from medimages4tests.dummy.dicom.base import (
    generate_dicom,
    default_dicom_dir,
    evolve_header,
)


def get_image(out_dir=None, **kwargs):
    if out_dir is None:
        out_dir = default_dicom_dir(__file__, kwargs)
    hdr = evolve_header(constant_hdr, **kwargs)
    return generate_dicom(out_dir, num_vols, hdr, collated_data, varying_hdr)


num_vols = 4020


constant_hdr = {
    "00080005": {"vr": "CS", "Value": ["ISO_IR 100"]},
    "00080008": {
        "vr": "CS",
        "Value": ["ORIGINAL", "PRIMARY", "DIFFUSION", "NONE", "ND", "NORM"],
    },
    "00080012": {"vr": "DA", "Value": ["20180525"]},
    "00080016": {"vr": "UI", "Value": ["1.2.840.10008.5.1.4.1.1.4"]},
    "00080020": {"vr": "DA", "Value": ["20180525"]},
    "00080021": {"vr": "DA", "Value": ["20180525"]},
    "00080022": {"vr": "DA", "Value": ["20180525"]},
    "00080023": {"vr": "DA", "Value": ["20180525"]},
    "00080030": {"vr": "TM", "Value": ["091331.137000"]},
    "00080031": {"vr": "TM", "Value": ["094527.609000"]},
    "00080050": {"vr": "SH"},
    "00080060": {"vr": "CS", "Value": ["MR"]},
    "00080070": {"vr": "LO", "Value": ["SIEMENS"]},
    "00080080": {"vr": "LO", "Value": ["An institute"]},
    "00080081": {"vr": "ST", "Value": ["An address"]},
    "00080090": {"vr": "PN", "Value": [{"Alphabetic": "XNAT"}]},
    "00081010": {"vr": "SH", "Value": ["AWP45193"]},
    "00081030": {"vr": "LO", "Value": ["Researcher^project"]},
    "0008103E": {
        "vr": "LO",
        "Value": ["R-L MRtrix 60 directions interleaved B0 ep2d_diff_p2"],
    },
    "00081040": {"vr": "LO", "Value": ["Department"]},
    "00081048": {"vr": "PN", "Value": [{"Alphabetic": "Some Phenotypes"}]},
    "00081050": {"vr": "PN"},
    "00081090": {"vr": "LO", "Value": ["Skyra"]},
    "00081140": {
        "vr": "SQ",
        "Value": [
            {
                "00081150": {"vr": "UI", "Value": ["1.2.840.10008.5.1.4.1.1.4"]},
                "00081155": {
                    "vr": "UI",
                    "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509141726605700537"],
                },
            },
            {
                "00081150": {"vr": "UI", "Value": ["1.2.840.10008.5.1.4.1.1.4"]},
                "00081155": {
                    "vr": "UI",
                    "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509142519936700545"],
                },
            },
            {
                "00081150": {"vr": "UI", "Value": ["1.2.840.10008.5.1.4.1.1.4"]},
                "00081155": {
                    "vr": "UI",
                    "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509142122884100541"],
                },
            },
        ],
    },
    "00100010": {"vr": "PN", "Value": [{"Alphabetic": "SUBJECTID^STUDYID"}]},
    "00100020": {"vr": "LO", "Value": ["SESSION_LABEL"]},
    "00100021": {"vr": "LO", "Value": ["2"]},
    "00100030": {"vr": "DA", "Value": ["19800824"]},
    "00100040": {"vr": "CS", "Value": ["M"]},
    "00101010": {"vr": "AS", "Value": ["037Y"]},
    "00101020": {"vr": "DS", "Value": [1.82]},
    "00101030": {"vr": "DS", "Value": [90.0]},
    "00102000": {"vr": "LO", "Value": ["None"]},
    "00102110": {"vr": "LO", "Value": ["None"]},
    "001021C0": {"vr": "US", "Value": [4]},
    "00104000": {"vr": "LT", "Value": ["Comments"]},
    "00180015": {"vr": "CS", "Value": ["BRAIN"]},
    "00180020": {"vr": "CS", "Value": ["EP"]},
    "00180021": {"vr": "CS", "Value": ["SK", "SP"]},
    "00180022": {"vr": "CS", "Value": ["PFP", "FS"]},
    "00180023": {"vr": "CS", "Value": ["2D"]},
    "00180025": {"vr": "CS", "Value": ["N"]},
    "00180050": {"vr": "DS", "Value": [2.5]},
    "00180080": {"vr": "DS", "Value": [8800.0]},
    "00180081": {"vr": "DS", "Value": [110.0]},
    "00180083": {"vr": "DS", "Value": [1.0]},
    "00180084": {"vr": "DS", "Value": [123.251961]},
    "00180085": {"vr": "SH", "Value": ["1H"]},
    "00180086": {"vr": "IS", "Value": [1]},
    "00180087": {"vr": "DS", "Value": [3.0]},
    "00180088": {"vr": "DS", "Value": [2.5]},
    "00180089": {"vr": "IS", "Value": [72]},
    "00180091": {"vr": "IS", "Value": [36]},
    "00180093": {"vr": "DS", "Value": [100.0]},
    "00180094": {"vr": "DS", "Value": [100.0]},
    "00180095": {"vr": "DS", "Value": [2365.0]},
    "00181000": {"vr": "LO", "Value": ["45193"]},
    "00181020": {"vr": "LO", "Value": ["syngo MR D13C"]},
    "00181030": {
        "vr": "LO",
        "Value": ["R-L MRtrix 60 directions interleaved B0 ep2d_diff_p2"],
    },
    "00181200": {"vr": "DA", "Value": ["20090304", "20090304"]},
    "00181201": {"vr": "TM", "Value": ["123723.000000", "123723.000000"]},
    "00181251": {"vr": "SH", "Value": ["Body"]},
    "00181310": {"vr": "US", "Value": [0, 96, 96, 0]},
    "00181312": {"vr": "CS", "Value": ["ROW"]},
    "00181314": {"vr": "DS", "Value": [90.0]},
    "00181315": {"vr": "CS", "Value": ["N"]},
    "00181316": {"vr": "DS", "Value": [0.29777722647054]},
    "00181318": {"vr": "DS", "Value": [0.0]},
    "00185100": {"vr": "CS", "Value": ["HFS"]},
    "00190010": {"vr": "LO", "Value": ["SIEMENS MR HEADER"]},
    "00191008": {"vr": "CS", "Value": ["IMAGE NUM 4"]},
    "00191009": {"vr": "LO", "Value": ["1.0"]},
    "0019100F": {"vr": "SH", "Value": ["Fast*"]},
    "00191011": {"vr": "SH", "Value": ["No"]},
    "00191012": {"vr": "SL", "Value": [0, 0, -1098]},
    "00191013": {"vr": "SL", "Value": [0, 0, -1098]},
    "00191014": {"vr": "IS", "Value": [0, 0, 0]},
    "00191017": {"vr": "DS", "Value": [1.0]},
    "00191018": {"vr": "IS", "Value": [2200]},
    "00191028": {"vr": "FD", "Value": [34.153]},
    "0020000D": {
        "vr": "UI",
        "Value": ["1.2.826.0.1.3680043.8.498.35939304416003656006618747446767853539"],
    },
    "0020000E": {
        "vr": "UI",
        "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509443854768758767.0.0.0"],
    },
    "00200010": {"vr": "SH", "Value": ["MRH060"]},
    "00200011": {"vr": "IS", "Value": [13]},
    "00200037": {
        "vr": "DS",
        "Value": [1.0, 0.0, 0.0, 0.0, 0.97667227753657, -0.2147353307947],
    },
    "00200052": {
        "vr": "UI",
        "Value": ["1.3.12.2.1107.5.2.19.45193.1.20180525091331822.0.0.0"],
    },
    "00201040": {"vr": "LO"},
    "00210010": {"vr": "LO", "Value": ["SIEMENS MR SDS 01"]},
    "00210011": {"vr": "LO", "Value": ["SIEMENS MR SDI 02"]},
    "00211001": {"vr": "IS", "Value": [90]},
    "00211004": {"vr": "DS", "Value": [1.0]},
    "00211005": {"vr": "IS", "Value": [0, 0, 0]},
    "00211006": {"vr": "LO", "Value": ["void"]},
    "00211007": {"vr": "LO", "Value": ["NUMARIS/4"]},
    "00211008": {"vr": "SH", "Value": ["Fast*"]},
    "00211009": {"vr": "LO", "Value": ["p2"]},
    "0021100A": {"vr": "DS", "Value": [1.0]},
    "0021100C": {"vr": "SH", "Value": ["+LPH"]},
    "0021100D": {"vr": "US", "Value": [0]},
    "0021100F": {"vr": "DS", "Value": [27.8939991, 23.26799965, 38.05500031]},
    "00211010": {"vr": "IS", "Value": [41330004]},
    "00211011": {"vr": "DS", "Value": [0.0]},
    "00211012": {"vr": "FD", "Value": [2.0]},
    "00211013": {"vr": "DS", "Value": [0.0]},
    "00211014": {"vr": "IS", "Value": [0]},
    "00211016": {"vr": "DS", "Value": [0.0]},
    "00211017": {"vr": "DS", "Value": [0.0]},
    "00211018": {"vr": "SH", "Value": ["Head"]},
    "0021101A": {"vr": "LO", "Value": ["HEA;HEP"]},
    "0021101B": {"vr": "DS", "Value": [1.0]},
    "0021101C": {"vr": "DS", "Value": [0.89755648, 22.62391663, 4.19425821]},
    "0021101D": {"vr": "IS", "Value": [2]},
    "00211022": {"vr": "SH", "Value": ["SIEMENS"]},
    "00211023": {"vr": "IS", "Value": [0]},
    "00211025": {"vr": "SL", "Value": [0, 0, -1098]},
    "00211026": {
        "vr": "IS",
        "Value": [
            40,
            67,
            67,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            524288,
            0,
            0,
            0,
            0,
            0,
            2,
            11505,
            0,
            0,
            0,
            0,
            0,
            0,
        ],
    },
    "00211027": {"vr": "US", "Value": [0]},
    "0021102A": {"vr": "IS", "Value": [255, 0, 0, 0, 0, 0, 0, 4865, 4866, 0, 0]},
    "0021102B": {"vr": "ST", "Value": ["1;HFS;90.00;37.75;2;0;2;-2057087971"]},
    "0021102C": {"vr": "DS", "Value": [1000000.0, 340.42637744, 340.42637744]},
    "0021102D": {"vr": "DS", "Value": [3.2, 1.35078298, 0.0]},
    "0021102E": {"vr": "IS", "Value": [2]},
    "0021102F": {"vr": "DS", "Value": [37.0, 37.0, 38.0]},
    "00211030": {"vr": "DS", "Value": [0.0]},
    "00211031": {"vr": "IS", "Value": [-1098]},
    "00211032": {"vr": "SS", "Value": [0]},
    "00211033": {"vr": "SH", "Value": ["GC99"]},
    "00211034": {"vr": "DS", "Value": [1.0]},
    "00211035": {"vr": "DS", "Value": [0.97907454]},
    "00211036": {"vr": "DS", "Value": [0.0]},
    "00211038": {"vr": "DS", "Value": [365.746003]},
    "0021103B": {"vr": "DS", "Value": [0.0]},
    "0021103D": {"vr": "CS", "Value": ["NONE"]},
    "00211044": {"vr": "DS", "Value": [7.07106781, 1.56484153]},
    "00211045": {"vr": "CS", "Value": ["NO"]},
    "00211046": {"vr": "DS", "Value": [2275.846875]},
    "00211047": {"vr": "CS", "Value": ["IEC"]},
    "00211048": {"vr": "CS"},
    "00211049": {"vr": "CS"},
    "00211050": {"vr": "US", "Value": [1]},
    "00211051": {"vr": "US", "Value": [36]},
    "00211053": {"vr": "CS", "Value": ["U"]},
    "0021111A": {"vr": "SH", "Value": ["predicted"]},
    "0021111C": {"vr": "IS", "Value": [1]},
    "00211124": {"vr": "IS", "Value": [0]},
    "00211133": {"vr": "IS", "Value": [48]},
    "00211135": {"vr": "IS", "Value": [0]},
    "00211141": {"vr": "SH", "Value": ["predicted"]},
    "00211142": {"vr": "IS", "Value": [2200]},
    "00211145": {"vr": "SL", "Value": [0, 0, -1098]},
    "00211148": {"vr": "IS", "Value": [32]},
    "00211149": {"vr": "IS", "Value": [48]},
    "0021114F": {"vr": "LO", "Value": ["HEA;HEP"]},
    "00211151": {"vr": "UL", "Value": [134217732]},
    "00211153": {"vr": "FD", "Value": [34.153]},
    "00211154": {"vr": "US", "Value": [0]},
    "00211156": {"vr": "LO", "Value": ["p2"]},
    "00211158": {"vr": "SH", "Value": ["96p*96s"]},
    "00211159": {"vr": "IS", "Value": [0, 0, 0]},
    "00211171": {"vr": "UT", "Value": ["XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"]},
    "00211175": {"vr": "CS", "Value": ["ORIGINAL", "PRIMARY", "DIFFUSION", "NONE"]},
    "00211176": {
        "vr": "LO",
        "Value": ["ChannelMixing:ND=true_CMM=1_CDM=1", "ACC1", "NormalizeAlgo:PreScan"],
    },
    "00250010": {"vr": "LO", "Value": ["SIEMENS MR EXTRACTED CSA HEADER"]},
    "00251001": {
        "vr": "SQ",
        "Value": [
            {
                "00250010": {"vr": "LO", "Value": ["SIEMENS MR EXTRACTED CSA HEADER"]},
                "00251002": {"vr": "LO", "Value": ["SIEMENS CSA HEADER"]},
                "00251003": {"vr": "AT", "Value": ["00290010"]},
            },
            {
                "00250010": {"vr": "LO", "Value": ["SIEMENS MR EXTRACTED CSA HEADER"]},
                "00251002": {"vr": "LO", "Value": ["SIEMENS CSA HEADER"]},
                "00251003": {"vr": "AT", "Value": ["00290020"]},
            },
        ],
    },
    "00280002": {"vr": "US", "Value": [1]},
    "00280004": {"vr": "CS", "Value": ["MONOCHROME2"]},
    "00280010": {"vr": "US", "Value": [96]},
    "00280011": {"vr": "US", "Value": [96]},
    "00280030": {"vr": "DS", "Value": [2.5, 2.5]},
    "00280100": {"vr": "US", "Value": [16]},
    "00280101": {"vr": "US", "Value": [12]},
    "00280102": {"vr": "US", "Value": [11]},
    "00280103": {"vr": "US", "Value": [0]},
    "00280106": {"vr": "US", "Value": [0]},
    "00281055": {"vr": "LO", "Value": ["Algo1"]},
    "00290010": {"vr": "LO", "Value": ["SIEMENS CSA HEADER"]},
    "00290011": {"vr": "LO", "Value": ["SIEMENS MEDCOM HEADER2"]},
    "00291008": {"vr": "CS", "Value": ["IMAGE NUM 4"]},
    "00291009": {"vr": "LO", "Value": ["20180525"]},
    "00291018": {"vr": "CS", "Value": ["MR"]},
    "00291019": {"vr": "LO", "Value": ["20180525"]},
    "00291160": {"vr": "LO", "Value": ["com"]},
    "00321032": {"vr": "PN", "Value": [{"Alphabetic": "Some Physician"}]},
    "00321060": {"vr": "LO", "Value": ["MR_EXAM"]},
    "00400244": {"vr": "DA", "Value": ["20180525"]},
    "00400245": {"vr": "TM", "Value": ["091331.375000"]},
    "00400253": {"vr": "SH", "Value": ["001"]},
    "00400254": {"vr": "LO", "Value": ["MR Scan"]},
    "00400275": {
        "vr": "SQ",
        "Value": [
            {
                "00400007": {"vr": "LO", "Value": ["MR Scan"]},
                "00400009": {"vr": "SH", "Value": ["001"]},
                "00401001": {"vr": "SH", "Value": ["MRH060"]},
            }
        ],
    },
    "00400280": {"vr": "ST"},
    "00510010": {"vr": "LO", "Value": ["SIEMENS MR HEADER"]},
    "00511008": {"vr": "CS", "Value": ["IMAGE NUM 4"]},
    "00511009": {"vr": "LO", "Value": ["1.0"]},
    "0051100A": {"vr": "LO", "Value": ["TA 00.02"]},
    "0051100B": {"vr": "LO", "Value": ["96p*96s"]},
    "0051100C": {"vr": "LO", "Value": ["FoV 240*240"]},
    "0051100E": {"vr": "LO", "Value": ["Tra>Cor(-12.4)"]},
    "0051100F": {"vr": "LO", "Value": ["HEA;HEP"]},
    "00511011": {"vr": "LO", "Value": ["p2"]},
    "00511012": {"vr": "SH", "Value": ["TP 0"]},
    "00511013": {"vr": "SH", "Value": ["+LPH"]},
    "00511015": {"vr": "SH", "Value": ["R"]},
    "00511016": {"vr": "LO", "Value": ["p2 DIFFUSION/NONE/ND/NORM"]},
    "00511017": {"vr": "SH", "Value": ["SL 2.5"]},
    "00511019": {"vr": "LO", "Value": ["A1/PFP/FS"]},
}


varying_hdr = {
    "00080013": {
        "0": {"vr": "TM", "Value": ["094827.811000"]},
        "1": {"vr": "TM", "Value": ["094947.660000"]},
        "2": {"vr": "TM", "Value": ["095127.776000"]},
        "3": {"vr": "TM", "Value": ["095147.804000"]},
        "4": {"vr": "TM", "Value": ["095107.672000"]},
        "5": {"vr": "TM", "Value": ["095047.889000"]},
        "6": {"vr": "TM", "Value": ["095307.863000"]},
        "7": {"vr": "TM", "Value": ["095327.829000"]},
        "8": {"vr": "TM", "Value": ["094847.667000"]},
        "9": {"vr": "TM", "Value": ["094707.827000"]},
        "10": {"vr": "TM", "Value": ["095307.825000"]},
        "11": {"vr": "TM", "Value": ["094847.852000"]},
        "12": {"vr": "TM", "Value": ["094847.774000"]},
        "13": {"vr": "TM", "Value": ["094527.681000"]},
        "14": {"vr": "TM", "Value": ["095007.805000"]},
        "15": {"vr": "TM", "Value": ["095207.670000"]},
        "16": {"vr": "TM", "Value": ["095247.920000"]},
        "17": {"vr": "TM", "Value": ["094607.854000"]},
        "18": {"vr": "TM", "Value": ["094807.810000"]},
        "19": {"vr": "TM", "Value": ["095207.729000"]},
        "20": {"vr": "TM", "Value": ["094727.655000"]},
        "21": {"vr": "TM", "Value": ["095207.916000"]},
        "22": {"vr": "TM", "Value": ["095227.930000"]},
        "23": {"vr": "TM", "Value": ["095407.705000"]},
        "24": {"vr": "TM", "Value": ["095227.666000"]},
        "25": {"vr": "TM", "Value": ["094807.770000"]},
        "26": {"vr": "TM", "Value": ["094947.815000"]},
        "27": {"vr": "TM", "Value": ["094727.896000"]},
        "28": {"vr": "TM", "Value": ["094747.949000"]},
        "29": {"vr": "TM", "Value": ["095147.882000"]},
        "30": {"vr": "TM", "Value": ["094947.846000"]},
        "31": {"vr": "TM", "Value": ["094827.939000"]},
        "32": {"vr": "TM", "Value": ["095027.864000"]},
        "33": {"vr": "TM", "Value": ["094747.821000"]},
        "34": {"vr": "TM", "Value": ["095456.546000"]},
        "35": {"vr": "TM", "Value": ["094527.618000"]},
        "36": {"vr": "TM", "Value": ["094647.883000"]},
        "37": {"vr": "TM", "Value": ["094807.723000"]},
        "38": {"vr": "TM", "Value": ["095107.925000"]},
        "39": {"vr": "TM", "Value": ["094927.742000"]},
        "40": {"vr": "TM", "Value": ["095327.790000"]},
        "41": {"vr": "TM", "Value": ["095427.944000"]},
        "42": {"vr": "TM", "Value": ["095447.685000"]},
        "43": {"vr": "TM", "Value": ["094807.812000"]},
        "44": {"vr": "TM", "Value": ["095307.634000"]},
        "45": {"vr": "TM", "Value": ["094627.764000"]},
        "46": {"vr": "TM", "Value": ["095307.845000"]},
        "47": {"vr": "TM", "Value": ["095427.881000"]},
        "48": {"vr": "TM", "Value": ["094927.616000"]},
        "49": {"vr": "TM", "Value": ["094547.697000"]},
        "50": {"vr": "TM", "Value": ["095247.637000"]},
        "51": {"vr": "TM", "Value": ["095247.775000"]},
        "52": {"vr": "TM", "Value": ["095307.608000"]},
        "53": {"vr": "TM", "Value": ["094827.763000"]},
        "54": {"vr": "TM", "Value": ["094647.710000"]},
        "55": {"vr": "TM", "Value": ["094907.641000"]},
        "56": {"vr": "TM", "Value": ["095047.915000"]},
        "57": {"vr": "TM", "Value": ["094907.946000"]},
        "58": {"vr": "TM", "Value": ["094847.651000"]},
        "59": {"vr": "TM", "Value": ["094747.612000"]},
        "60": {"vr": "TM", "Value": ["095147.849000"]},
        "61": {"vr": "TM", "Value": ["095327.697000"]},
        "62": {"vr": "TM", "Value": ["094827.760000"]},
        "63": {"vr": "TM", "Value": ["095447.788000"]},
        "64": {"vr": "TM", "Value": ["095047.838000"]},
        "65": {"vr": "TM", "Value": ["095447.811000"]},
        "66": {"vr": "TM", "Value": ["094827.784000"]},
        "67": {"vr": "TM", "Value": ["094847.900000"]},
        "68": {"vr": "TM", "Value": ["094707.680000"]},
        "69": {"vr": "TM", "Value": ["094727.761000"]},
        "70": {"vr": "TM", "Value": ["094647.606000"]},
        "71": {"vr": "TM", "Value": ["095107.642000"]},
        "72": {"vr": "TM", "Value": ["095047.907000"]},
        "73": {"vr": "TM", "Value": ["095207.918000"]},
        "74": {"vr": "TM", "Value": ["094607.931000"]},
        "75": {"vr": "TM", "Value": ["095427.619000"]},
        "76": {"vr": "TM", "Value": ["095207.859000"]},
        "77": {"vr": "TM", "Value": ["094947.870000"]},
        "78": {"vr": "TM", "Value": ["095147.892000"]},
        "79": {"vr": "TM", "Value": ["094747.806000"]},
        "80": {"vr": "TM", "Value": ["095456.515000"]},
        "81": {"vr": "TM", "Value": ["094607.923000"]},
        "82": {"vr": "TM", "Value": ["095127.678000"]},
        "83": {"vr": "TM", "Value": ["095027.862000"]},
        "84": {"vr": "TM", "Value": ["094527.933000"]},
        "85": {"vr": "TM", "Value": ["095207.639000"]},
        "86": {"vr": "TM", "Value": ["095247.855000"]},
        "87": {"vr": "TM", "Value": ["095207.900000"]},
        "88": {"vr": "TM", "Value": ["094907.934000"]},
        "89": {"vr": "TM", "Value": ["095347.923000"]},
        "90": {"vr": "TM", "Value": ["094527.655000"]},
        "91": {"vr": "TM", "Value": ["094707.634000"]},
        "92": {"vr": "TM", "Value": ["095227.817000"]},
        "93": {"vr": "TM", "Value": ["094627.962000"]},
        "94": {"vr": "TM", "Value": ["095347.853000"]},
        "95": {"vr": "TM", "Value": ["094727.929000"]},
        "96": {"vr": "TM", "Value": ["094747.759000"]},
        "97": {"vr": "TM", "Value": ["095447.901000"]},
        "98": {"vr": "TM", "Value": ["094527.851000"]},
        "99": {"vr": "TM", "Value": ["094527.865000"]},
        "100": {"vr": "TM", "Value": ["094627.756000"]},
        "101": {"vr": "TM", "Value": ["094907.693000"]},
        "102": {"vr": "TM", "Value": ["094627.812000"]},
        "103": {"vr": "TM", "Value": ["095027.739000"]},
        "104": {"vr": "TM", "Value": ["095307.751000"]},
        "105": {"vr": "TM", "Value": ["095347.802000"]},
        "106": {"vr": "TM", "Value": ["095227.671000"]},
        "107": {"vr": "TM", "Value": ["095347.666000"]},
        "108": {"vr": "TM", "Value": ["094727.721000"]},
        "109": {"vr": "TM", "Value": ["094727.748000"]},
        "110": {"vr": "TM", "Value": ["095447.773000"]},
        "111": {"vr": "TM", "Value": ["095307.809000"]},
        "112": {"vr": "TM", "Value": ["094827.854000"]},
        "113": {"vr": "TM", "Value": ["095447.693000"]},
        "114": {"vr": "TM", "Value": ["095007.882000"]},
        "115": {"vr": "TM", "Value": ["095227.830000"]},
        "116": {"vr": "TM", "Value": ["095327.630000"]},
        "117": {"vr": "TM", "Value": ["094707.922000"]},
        "118": {"vr": "TM", "Value": ["095147.632000"]},
        "119": {"vr": "TM", "Value": ["095447.945000"]},
        "120": {"vr": "TM", "Value": ["094607.654000"]},
        "121": {"vr": "TM", "Value": ["094547.687000"]},
        "122": {"vr": "TM", "Value": ["095247.863000"]},
        "123": {"vr": "TM", "Value": ["094527.820000"]},
        "124": {"vr": "TM", "Value": ["095227.747000"]},
        "125": {"vr": "TM", "Value": ["095007.946000"]},
        "126": {"vr": "TM", "Value": ["095447.634000"]},
        "127": {"vr": "TM", "Value": ["094927.804000"]},
        "128": {"vr": "TM", "Value": ["095147.731000"]},
        "129": {"vr": "TM", "Value": ["094827.636000"]},
        "130": {"vr": "TM", "Value": ["094627.694000"]},
        "131": {"vr": "TM", "Value": ["095147.898000"]},
        "132": {"vr": "TM", "Value": ["095347.794000"]},
        "133": {"vr": "TM", "Value": ["095427.899000"]},
        "134": {"vr": "TM", "Value": ["095347.820000"]},
        "135": {"vr": "TM", "Value": ["094747.900000"]},
        "136": {"vr": "TM", "Value": ["094947.853000"]},
        "137": {"vr": "TM", "Value": ["095047.882000"]},
        "138": {"vr": "TM", "Value": ["094627.741000"]},
        "139": {"vr": "TM", "Value": ["094807.836000"]},
        "140": {"vr": "TM", "Value": ["094847.793000"]},
        "141": {"vr": "TM", "Value": ["094547.822000"]},
        "142": {"vr": "TM", "Value": ["095027.800000"]},
        "143": {"vr": "TM", "Value": ["095247.875000"]},
        "144": {"vr": "TM", "Value": ["095027.910000"]},
        "145": {"vr": "TM", "Value": ["095307.656000"]},
        "146": {"vr": "TM", "Value": ["094607.861000"]},
        "147": {"vr": "TM", "Value": ["094727.891000"]},
        "148": {"vr": "TM", "Value": ["095307.868000"]},
        "149": {"vr": "TM", "Value": ["095247.843000"]},
        "150": {"vr": "TM", "Value": ["095007.753000"]},
        "151": {"vr": "TM", "Value": ["094727.789000"]},
        "152": {"vr": "TM", "Value": ["095447.793000"]},
        "153": {"vr": "TM", "Value": ["094747.704000"]},
        "154": {"vr": "TM", "Value": ["094527.796000"]},
        "155": {"vr": "TM", "Value": ["095207.780000"]},
        "156": {"vr": "TM", "Value": ["094807.611000"]},
        "157": {"vr": "TM", "Value": ["094907.832000"]},
        "158": {"vr": "TM", "Value": ["095047.607000"]},
        "159": {"vr": "TM", "Value": ["094607.776000"]},
        "160": {"vr": "TM", "Value": ["095456.529000"]},
        "161": {"vr": "TM", "Value": ["095307.771000"]},
        "162": {"vr": "TM", "Value": ["094747.770000"]},
        "163": {"vr": "TM", "Value": ["095247.822000"]},
        "164": {"vr": "TM", "Value": ["094707.830000"]},
        "165": {"vr": "TM", "Value": ["095247.608000"]},
        "166": {"vr": "TM", "Value": ["095107.637000"]},
        "167": {"vr": "TM", "Value": ["094927.611000"]},
        "168": {"vr": "TM", "Value": ["094647.702000"]},
        "169": {"vr": "TM", "Value": ["094807.950000"]},
        "170": {"vr": "TM", "Value": ["094607.710000"]},
        "171": {"vr": "TM", "Value": ["094807.795000"]},
        "172": {"vr": "TM", "Value": ["094547.869000"]},
        "173": {"vr": "TM", "Value": ["095427.949000"]},
        "174": {"vr": "TM", "Value": ["094727.703000"]},
        "175": {"vr": "TM", "Value": ["094827.802000"]},
        "176": {"vr": "TM", "Value": ["094527.982000"]},
        "177": {"vr": "TM", "Value": ["095307.704000"]},
        "178": {"vr": "TM", "Value": ["095427.633000"]},
        "179": {"vr": "TM", "Value": ["095247.930000"]},
        "180": {"vr": "TM", "Value": ["094707.892000"]},
        "181": {"vr": "TM", "Value": ["094827.839000"]},
        "182": {"vr": "TM", "Value": ["095247.642000"]},
        "183": {"vr": "TM", "Value": ["095127.734000"]},
        "184": {"vr": "TM", "Value": ["094547.717000"]},
        "185": {"vr": "TM", "Value": ["094807.651000"]},
        "186": {"vr": "TM", "Value": ["095227.811000"]},
        "187": {"vr": "TM", "Value": ["095227.837000"]},
        "188": {"vr": "TM", "Value": ["095427.910000"]},
        "189": {"vr": "TM", "Value": ["094907.819000"]},
        "190": {"vr": "TM", "Value": ["095027.844000"]},
        "191": {"vr": "TM", "Value": ["094527.772000"]},
        "192": {"vr": "TM", "Value": ["095207.908000"]},
        "193": {"vr": "TM", "Value": ["094627.684000"]},
        "194": {"vr": "TM", "Value": ["095427.708000"]},
        "195": {"vr": "TM", "Value": ["095047.633000"]},
        "196": {"vr": "TM", "Value": ["095127.611000"]},
        "197": {"vr": "TM", "Value": ["094907.864000"]},
        "198": {"vr": "TM", "Value": ["094527.663000"]},
        "199": {"vr": "TM", "Value": ["095127.696000"]},
        "200": {"vr": "TM", "Value": ["094547.679000"]},
        "201": {"vr": "TM", "Value": ["095147.885000"]},
        "202": {"vr": "TM", "Value": ["095227.694000"]},
        "203": {"vr": "TM", "Value": ["094807.645000"]},
        "204": {"vr": "TM", "Value": ["094927.727000"]},
        "205": {"vr": "TM", "Value": ["095227.901000"]},
        "206": {"vr": "TM", "Value": ["095247.758000"]},
        "207": {"vr": "TM", "Value": ["095047.863000"]},
        "208": {"vr": "TM", "Value": ["094547.847000"]},
        "209": {"vr": "TM", "Value": ["094627.837000"]},
        "210": {"vr": "TM", "Value": ["095007.885000"]},
        "211": {"vr": "TM", "Value": ["095047.736000"]},
        "212": {"vr": "TM", "Value": ["095347.925000"]},
        "213": {"vr": "TM", "Value": ["095347.946000"]},
        "214": {"vr": "TM", "Value": ["095227.607000"]},
        "215": {"vr": "TM", "Value": ["095107.721000"]},
        "216": {"vr": "TM", "Value": ["094727.675000"]},
        "217": {"vr": "TM", "Value": ["094707.845000"]},
        "218": {"vr": "TM", "Value": ["095427.727000"]},
        "219": {"vr": "TM", "Value": ["094947.663000"]},
        "220": {"vr": "TM", "Value": ["094847.680000"]},
        "221": {"vr": "TM", "Value": ["095027.682000"]},
        "222": {"vr": "TM", "Value": ["095027.870000"]},
        "223": {"vr": "TM", "Value": ["094547.850000"]},
        "224": {"vr": "TM", "Value": ["094607.636000"]},
        "225": {"vr": "TM", "Value": ["094607.705000"]},
        "226": {"vr": "TM", "Value": ["095127.630000"]},
        "227": {"vr": "TM", "Value": ["094707.621000"]},
        "228": {"vr": "TM", "Value": ["095047.825000"]},
        "229": {"vr": "TM", "Value": ["094827.633000"]},
        "230": {"vr": "TM", "Value": ["094727.650000"]},
        "231": {"vr": "TM", "Value": ["094707.820000"]},
        "232": {"vr": "TM", "Value": ["095227.944000"]},
        "233": {"vr": "TM", "Value": ["095247.772000"]},
        "234": {"vr": "TM", "Value": ["094807.958000"]},
        "235": {"vr": "TM", "Value": ["095247.753000"]},
        "236": {"vr": "TM", "Value": ["095407.676000"]},
        "237": {"vr": "TM", "Value": ["094547.845000"]},
        "238": {"vr": "TM", "Value": ["095027.662000"]},
        "239": {"vr": "TM", "Value": ["095247.933000"]},
        "240": {"vr": "TM", "Value": ["094907.801000"]},
        "241": {"vr": "TM", "Value": ["095027.659000"]},
        "242": {"vr": "TM", "Value": ["095127.867000"]},
        "243": {"vr": "TM", "Value": ["094827.894000"]},
        "244": {"vr": "TM", "Value": ["095427.827000"]},
        "245": {"vr": "TM", "Value": ["095327.888000"]},
        "246": {"vr": "TM", "Value": ["094527.678000"]},
        "247": {"vr": "TM", "Value": ["094627.810000"]},
        "248": {"vr": "TM", "Value": ["095047.782000"]},
        "249": {"vr": "TM", "Value": ["095047.953000"]},
        "250": {"vr": "TM", "Value": ["095147.710000"]},
        "251": {"vr": "TM", "Value": ["094807.763000"]},
        "252": {"vr": "TM", "Value": ["095027.788000"]},
        "253": {"vr": "TM", "Value": ["095027.890000"]},
        "254": {"vr": "TM", "Value": ["095107.781000"]},
        "255": {"vr": "TM", "Value": ["094847.943000"]},
        "256": {"vr": "TM", "Value": ["095327.772000"]},
        "257": {"vr": "TM", "Value": ["095407.888000"]},
        "258": {"vr": "TM", "Value": ["094907.768000"]},
        "259": {"vr": "TM", "Value": ["094907.705000"]},
        "260": {"vr": "TM", "Value": ["094647.849000"]},
        "261": {"vr": "TM", "Value": ["095327.621000"]},
        "262": {"vr": "TM", "Value": ["094807.745000"]},
        "263": {"vr": "TM", "Value": ["094627.729000"]},
        "264": {"vr": "TM", "Value": ["095347.644000"]},
        "265": {"vr": "TM", "Value": ["095427.876000"]},
        "266": {"vr": "TM", "Value": ["095447.727000"]},
        "267": {"vr": "TM", "Value": ["094847.714000"]},
        "268": {"vr": "TM", "Value": ["094627.947000"]},
        "269": {"vr": "TM", "Value": ["095207.795000"]},
        "270": {"vr": "TM", "Value": ["095456.551000"]},
        "271": {"vr": "TM", "Value": ["095227.868000"]},
        "272": {"vr": "TM", "Value": ["095427.683000"]},
        "273": {"vr": "TM", "Value": ["094947.888000"]},
        "274": {"vr": "TM", "Value": ["094627.974000"]},
        "275": {"vr": "TM", "Value": ["094707.637000"]},
        "276": {"vr": "TM", "Value": ["095227.923000"]},
        "277": {"vr": "TM", "Value": ["095407.768000"]},
        "278": {"vr": "TM", "Value": ["094847.664000"]},
        "279": {"vr": "TM", "Value": ["094807.827000"]},
        "280": {"vr": "TM", "Value": ["095107.891000"]},
        "281": {"vr": "TM", "Value": ["094907.748000"]},
        "282": {"vr": "TM", "Value": ["094547.804000"]},
        "283": {"vr": "TM", "Value": ["095007.618000"]},
        "284": {"vr": "TM", "Value": ["095427.695000"]},
        "285": {"vr": "TM", "Value": ["095227.892000"]},
        "286": {"vr": "TM", "Value": ["095027.877000"]},
        "287": {"vr": "TM", "Value": ["094627.709000"]},
        "288": {"vr": "TM", "Value": ["094727.751000"]},
        "289": {"vr": "TM", "Value": ["095447.796000"]},
        "290": {"vr": "TM", "Value": ["095456.412000"]},
        "291": {"vr": "TM", "Value": ["094907.855000"]},
        "292": {"vr": "TM", "Value": ["094947.917000"]},
        "293": {"vr": "TM", "Value": ["094727.865000"]},
        "294": {"vr": "TM", "Value": ["095427.842000"]},
        "295": {"vr": "TM", "Value": ["095147.649000"]},
        "296": {"vr": "TM", "Value": ["094747.772000"]},
        "297": {"vr": "TM", "Value": ["094527.953000"]},
        "298": {"vr": "TM", "Value": ["094547.634000"]},
        "299": {"vr": "TM", "Value": ["094527.902000"]},
        "300": {"vr": "TM", "Value": ["095427.884000"]},
        "301": {"vr": "TM", "Value": ["095456.473000"]},
        "302": {"vr": "TM", "Value": ["095127.632000"]},
        "303": {"vr": "TM", "Value": ["094927.938000"]},
        "304": {"vr": "TM", "Value": ["094947.723000"]},
        "305": {"vr": "TM", "Value": ["094707.889000"]},
        "306": {"vr": "TM", "Value": ["095407.870000"]},
        "307": {"vr": "TM", "Value": ["094947.612000"]},
        "308": {"vr": "TM", "Value": ["095407.620000"]},
        "309": {"vr": "TM", "Value": ["095047.961000"]},
        "310": {"vr": "TM", "Value": ["095027.948000"]},
        "311": {"vr": "TM", "Value": ["094647.925000"]},
        "312": {"vr": "TM", "Value": ["095147.672000"]},
        "313": {"vr": "TM", "Value": ["095456.490000"]},
        "314": {"vr": "TM", "Value": ["095447.664000"]},
        "315": {"vr": "TM", "Value": ["094727.784000"]},
        "316": {"vr": "TM", "Value": ["094647.935000"]},
        "317": {"vr": "TM", "Value": ["095407.718000"]},
        "318": {"vr": "TM", "Value": ["094847.706000"]},
        "319": {"vr": "TM", "Value": ["095047.615000"]},
        "320": {"vr": "TM", "Value": ["095127.770000"]},
        "321": {"vr": "TM", "Value": ["094727.738000"]},
        "322": {"vr": "TM", "Value": ["095407.943000"]},
        "323": {"vr": "TM", "Value": ["094947.784000"]},
        "324": {"vr": "TM", "Value": ["094927.909000"]},
        "325": {"vr": "TM", "Value": ["094727.662000"]},
        "326": {"vr": "TM", "Value": ["094607.730000"]},
        "327": {"vr": "TM", "Value": ["095127.708000"]},
        "328": {"vr": "TM", "Value": ["095327.637000"]},
        "329": {"vr": "TM", "Value": ["095127.727000"]},
        "330": {"vr": "TM", "Value": ["094547.812000"]},
        "331": {"vr": "TM", "Value": ["094947.903000"]},
        "332": {"vr": "TM", "Value": ["094727.624000"]},
        "333": {"vr": "TM", "Value": ["095247.701000"]},
        "334": {"vr": "TM", "Value": ["094927.666000"]},
        "335": {"vr": "TM", "Value": ["094807.931000"]},
        "336": {"vr": "TM", "Value": ["094727.870000"]},
        "337": {"vr": "TM", "Value": ["094907.882000"]},
        "338": {"vr": "TM", "Value": ["094547.796000"]},
        "339": {"vr": "TM", "Value": ["094847.771000"]},
        "340": {"vr": "TM", "Value": ["094647.612000"]},
        "341": {"vr": "TM", "Value": ["095447.672000"]},
        "342": {"vr": "TM", "Value": ["094807.875000"]},
        "343": {"vr": "TM", "Value": ["095347.743000"]},
        "344": {"vr": "TM", "Value": ["094847.811000"]},
        "345": {"vr": "TM", "Value": ["095207.856000"]},
        "346": {"vr": "TM", "Value": ["094627.831000"]},
        "347": {"vr": "TM", "Value": ["094707.807000"]},
        "348": {"vr": "TM", "Value": ["095007.667000"]},
        "349": {"vr": "TM", "Value": ["094527.675000"]},
        "350": {"vr": "TM", "Value": ["095147.813000"]},
        "351": {"vr": "TM", "Value": ["095407.842000"]},
        "352": {"vr": "TM", "Value": ["095007.694000"]},
        "353": {"vr": "TM", "Value": ["095007.646000"]},
        "354": {"vr": "TM", "Value": ["094927.886000"]},
        "355": {"vr": "TM", "Value": ["095327.827000"]},
        "356": {"vr": "TM", "Value": ["094747.895000"]},
        "357": {"vr": "TM", "Value": ["094547.674000"]},
        "358": {"vr": "TM", "Value": ["095227.925000"]},
        "359": {"vr": "TM", "Value": ["094707.945000"]},
        "360": {"vr": "TM", "Value": ["094547.714000"]},
        "361": {"vr": "TM", "Value": ["095007.848000"]},
        "362": {"vr": "TM", "Value": ["095227.699000"]},
        "363": {"vr": "TM", "Value": ["095007.924000"]},
        "364": {"vr": "TM", "Value": ["095327.824000"]},
        "365": {"vr": "TM", "Value": ["095007.939000"]},
        "366": {"vr": "TM", "Value": ["095427.892000"]},
        "367": {"vr": "TM", "Value": ["094707.805000"]},
        "368": {"vr": "TM", "Value": ["094647.951000"]},
        "369": {"vr": "TM", "Value": ["095307.899000"]},
        "370": {"vr": "TM", "Value": ["095227.856000"]},
        "371": {"vr": "TM", "Value": ["095227.691000"]},
        "372": {"vr": "TM", "Value": ["095207.813000"]},
        "373": {"vr": "TM", "Value": ["095107.916000"]},
        "374": {"vr": "TM", "Value": ["094927.916000"]},
        "375": {"vr": "TM", "Value": ["095107.807000"]},
        "376": {"vr": "TM", "Value": ["094947.886000"]},
        "377": {"vr": "TM", "Value": ["095327.644000"]},
        "378": {"vr": "TM", "Value": ["094927.758000"]},
        "379": {"vr": "TM", "Value": ["094747.748000"]},
        "380": {"vr": "TM", "Value": ["094907.898000"]},
        "381": {"vr": "TM", "Value": ["094727.881000"]},
        "382": {"vr": "TM", "Value": ["094847.908000"]},
        "383": {"vr": "TM", "Value": ["094527.726000"]},
        "384": {"vr": "TM", "Value": ["095007.827000"]},
        "385": {"vr": "TM", "Value": ["095347.843000"]},
        "386": {"vr": "TM", "Value": ["095347.861000"]},
        "387": {"vr": "TM", "Value": ["095107.833000"]},
        "388": {"vr": "TM", "Value": ["095407.825000"]},
        "389": {"vr": "TM", "Value": ["094907.924000"]},
        "390": {"vr": "TM", "Value": ["094707.755000"]},
        "391": {"vr": "TM", "Value": ["095347.943000"]},
        "392": {"vr": "TM", "Value": ["094807.897000"]},
        "393": {"vr": "TM", "Value": ["095127.673000"]},
        "394": {"vr": "TM", "Value": ["095107.660000"]},
        "395": {"vr": "TM", "Value": ["095007.751000"]},
        "396": {"vr": "TM", "Value": ["094827.914000"]},
        "397": {"vr": "TM", "Value": ["095007.631000"]},
        "398": {"vr": "TM", "Value": ["094607.737000"]},
        "399": {"vr": "TM", "Value": ["094707.654000"]},
        "400": {"vr": "TM", "Value": ["094907.913000"]},
        "401": {"vr": "TM", "Value": ["094647.881000"]},
        "402": {"vr": "TM", "Value": ["094807.684000"]},
        "403": {"vr": "TM", "Value": ["095047.805000"]},
        "404": {"vr": "TM", "Value": ["094607.681000"]},
        "405": {"vr": "TM", "Value": ["095227.742000"]},
        "406": {"vr": "TM", "Value": ["094727.779000"]},
        "407": {"vr": "TM", "Value": ["094807.760000"]},
        "408": {"vr": "TM", "Value": ["095027.693000"]},
        "409": {"vr": "TM", "Value": ["095107.649000"]},
        "410": {"vr": "TM", "Value": ["094747.709000"]},
        "411": {"vr": "TM", "Value": ["095347.682000"]},
        "412": {"vr": "TM", "Value": ["094547.640000"]},
        "413": {"vr": "TM", "Value": ["094707.794000"]},
        "414": {"vr": "TM", "Value": ["094607.763000"]},
        "415": {"vr": "TM", "Value": ["095307.789000"]},
        "416": {"vr": "TM", "Value": ["094947.810000"]},
        "417": {"vr": "TM", "Value": ["094607.895000"]},
        "418": {"vr": "TM", "Value": ["094527.742000"]},
        "419": {"vr": "TM", "Value": ["094607.771000"]},
        "420": {"vr": "TM", "Value": ["095447.763000"]},
        "421": {"vr": "TM", "Value": ["094627.817000"]},
        "422": {"vr": "TM", "Value": ["094747.840000"]},
        "423": {"vr": "TM", "Value": ["095327.894000"]},
        "424": {"vr": "TM", "Value": ["095147.767000"]},
        "425": {"vr": "TM", "Value": ["095427.750000"]},
        "426": {"vr": "TM", "Value": ["095207.711000"]},
        "427": {"vr": "TM", "Value": ["095127.924000"]},
        "428": {"vr": "TM", "Value": ["095407.830000"]},
        "429": {"vr": "TM", "Value": ["095207.765000"]},
        "430": {"vr": "TM", "Value": ["095047.679000"]},
        "431": {"vr": "TM", "Value": ["094647.878000"]},
        "432": {"vr": "TM", "Value": ["095427.758000"]},
        "433": {"vr": "TM", "Value": ["095127.883000"]},
        "434": {"vr": "TM", "Value": ["094707.863000"]},
        "435": {"vr": "TM", "Value": ["095447.734000"]},
        "436": {"vr": "TM", "Value": ["094527.790000"]},
        "437": {"vr": "TM", "Value": ["094827.768000"]},
        "438": {"vr": "TM", "Value": ["095107.713000"]},
        "439": {"vr": "TM", "Value": ["095307.791000"]},
        "440": {"vr": "TM", "Value": ["095407.753000"]},
        "441": {"vr": "TM", "Value": ["094627.825000"]},
        "442": {"vr": "TM", "Value": ["094647.785000"]},
        "443": {"vr": "TM", "Value": ["095347.697000"]},
        "444": {"vr": "TM", "Value": ["095147.662000"]},
        "445": {"vr": "TM", "Value": ["095147.763000"]},
        "446": {"vr": "TM", "Value": ["095247.894000"]},
        "447": {"vr": "TM", "Value": ["094527.883000"]},
        "448": {"vr": "TM", "Value": ["095327.802000"]},
        "449": {"vr": "TM", "Value": ["095047.731000"]},
        "450": {"vr": "TM", "Value": ["095407.689000"]},
        "451": {"vr": "TM", "Value": ["094707.948000"]},
        "452": {"vr": "TM", "Value": ["095247.626000"]},
        "453": {"vr": "TM", "Value": ["094547.824000"]},
        "454": {"vr": "TM", "Value": ["094807.948000"]},
        "455": {"vr": "TM", "Value": ["095107.684000"]},
        "456": {"vr": "TM", "Value": ["094807.829000"]},
        "457": {"vr": "TM", "Value": ["094827.730000"]},
        "458": {"vr": "TM", "Value": ["094927.639000"]},
        "459": {"vr": "TM", "Value": ["094807.805000"]},
        "460": {"vr": "TM", "Value": ["094847.703000"]},
        "461": {"vr": "TM", "Value": ["095107.682000"]},
        "462": {"vr": "TM", "Value": ["094927.898000"]},
        "463": {"vr": "TM", "Value": ["095107.882000"]},
        "464": {"vr": "TM", "Value": ["095307.873000"]},
        "465": {"vr": "TM", "Value": ["094747.943000"]},
        "466": {"vr": "TM", "Value": ["094707.760000"]},
        "467": {"vr": "TM", "Value": ["095027.723000"]},
        "468": {"vr": "TM", "Value": ["094547.814000"]},
        "469": {"vr": "TM", "Value": ["095456.425000"]},
        "470": {"vr": "TM", "Value": ["095047.841000"]},
        "471": {"vr": "TM", "Value": ["095047.690000"]},
        "472": {"vr": "TM", "Value": ["094707.853000"]},
        "473": {"vr": "TM", "Value": ["095347.958000"]},
        "474": {"vr": "TM", "Value": ["095347.702000"]},
        "475": {"vr": "TM", "Value": ["094527.711000"]},
        "476": {"vr": "TM", "Value": ["095347.858000"]},
        "477": {"vr": "TM", "Value": ["094727.942000"]},
        "478": {"vr": "TM", "Value": ["095427.673000"]},
        "479": {"vr": "TM", "Value": ["095307.730000"]},
        "480": {"vr": "TM", "Value": ["094947.829000"]},
        "481": {"vr": "TM", "Value": ["094527.887000"]},
        "482": {"vr": "TM", "Value": ["094707.932000"]},
        "483": {"vr": "TM", "Value": ["095327.735000"]},
        "484": {"vr": "TM", "Value": ["095127.620000"]},
        "485": {"vr": "TM", "Value": ["095227.722000"]},
        "486": {"vr": "TM", "Value": ["094827.735000"]},
        "487": {"vr": "TM", "Value": ["094847.842000"]},
        "488": {"vr": "TM", "Value": ["094907.634000"]},
        "489": {"vr": "TM", "Value": ["095307.618000"]},
        "490": {"vr": "TM", "Value": ["095047.638000"]},
        "491": {"vr": "TM", "Value": ["094947.930000"]},
        "492": {"vr": "TM", "Value": ["094727.923000"]},
        "493": {"vr": "TM", "Value": ["095307.781000"]},
        "494": {"vr": "TM", "Value": ["095327.930000"]},
        "495": {"vr": "TM", "Value": ["094827.774000"]},
        "496": {"vr": "TM", "Value": ["095007.723000"]},
        "497": {"vr": "TM", "Value": ["094527.769000"]},
        "498": {"vr": "TM", "Value": ["095427.809000"]},
        "499": {"vr": "TM", "Value": ["094607.703000"]},
        "500": {"vr": "TM", "Value": ["094627.689000"]},
        "501": {"vr": "TM", "Value": ["095456.541000"]},
        "502": {"vr": "TM", "Value": ["095027.834000"]},
        "503": {"vr": "TM", "Value": ["094907.750000"]},
        "504": {"vr": "TM", "Value": ["094847.690000"]},
        "505": {"vr": "TM", "Value": ["094607.757000"]},
        "506": {"vr": "TM", "Value": ["094727.728000"]},
        "507": {"vr": "TM", "Value": ["094707.629000"]},
        "508": {"vr": "TM", "Value": ["094747.837000"]},
        "509": {"vr": "TM", "Value": ["094947.675000"]},
        "510": {"vr": "TM", "Value": ["095347.951000"]},
        "511": {"vr": "TM", "Value": ["094927.948000"]},
        "512": {"vr": "TM", "Value": ["094807.710000"]},
        "513": {"vr": "TM", "Value": ["095227.737000"]},
        "514": {"vr": "TM", "Value": ["094647.990000"]},
        "515": {"vr": "TM", "Value": ["094827.887000"]},
        "516": {"vr": "TM", "Value": ["094527.799000"]},
        "517": {"vr": "TM", "Value": ["095347.812000"]},
        "518": {"vr": "TM", "Value": ["094907.654000"]},
        "519": {"vr": "TM", "Value": ["094707.935000"]},
        "520": {"vr": "TM", "Value": ["095147.847000"]},
        "521": {"vr": "TM", "Value": ["094547.642000"]},
        "522": {"vr": "TM", "Value": ["094947.768000"]},
        "523": {"vr": "TM", "Value": ["095447.848000"]},
        "524": {"vr": "TM", "Value": ["094707.858000"]},
        "525": {"vr": "TM", "Value": ["094947.813000"]},
        "526": {"vr": "TM", "Value": ["095427.835000"]},
        "527": {"vr": "TM", "Value": ["095407.774000"]},
        "528": {"vr": "TM", "Value": ["095407.713000"]},
        "529": {"vr": "TM", "Value": ["094547.627000"]},
        "530": {"vr": "TM", "Value": ["094727.888000"]},
        "531": {"vr": "TM", "Value": ["094847.621000"]},
        "532": {"vr": "TM", "Value": ["094527.994000"]},
        "533": {"vr": "TM", "Value": ["094747.644000"]},
        "534": {"vr": "TM", "Value": ["095027.777000"]},
        "535": {"vr": "TM", "Value": ["095227.773000"]},
        "536": {"vr": "TM", "Value": ["095207.664000"]},
        "537": {"vr": "TM", "Value": ["095027.651000"]},
        "538": {"vr": "TM", "Value": ["095107.716000"]},
        "539": {"vr": "TM", "Value": ["094527.633000"]},
        "540": {"vr": "TM", "Value": ["094827.610000"]},
        "541": {"vr": "TM", "Value": ["095407.945000"]},
        "542": {"vr": "TM", "Value": ["095007.909000"]},
        "543": {"vr": "TM", "Value": ["095447.947000"]},
        "544": {"vr": "TM", "Value": ["094647.943000"]},
        "545": {"vr": "TM", "Value": ["094947.614000"]},
        "546": {"vr": "TM", "Value": ["095407.807000"]},
        "547": {"vr": "TM", "Value": ["095407.763000"]},
        "548": {"vr": "TM", "Value": ["094847.617000"]},
        "549": {"vr": "TM", "Value": ["095127.784000"]},
        "550": {"vr": "TM", "Value": ["095047.951000"]},
        "551": {"vr": "TM", "Value": ["095307.804000"]},
        "552": {"vr": "TM", "Value": ["095107.726000"]},
        "553": {"vr": "TM", "Value": ["094647.977000"]},
        "554": {"vr": "TM", "Value": ["095007.914000"]},
        "555": {"vr": "TM", "Value": ["094527.657000"]},
        "556": {"vr": "TM", "Value": ["094747.630000"]},
        "557": {"vr": "TM", "Value": ["095427.933000"]},
        "558": {"vr": "TM", "Value": ["095107.814000"]},
        "559": {"vr": "TM", "Value": ["095247.899000"]},
        "560": {"vr": "TM", "Value": ["095107.772000"]},
        "561": {"vr": "TM", "Value": ["095347.907000"]},
        "562": {"vr": "TM", "Value": ["095207.823000"]},
        "563": {"vr": "TM", "Value": ["094807.743000"]},
        "564": {"vr": "TM", "Value": ["095107.779000"]},
        "565": {"vr": "TM", "Value": ["094907.869000"]},
        "566": {"vr": "TM", "Value": ["095127.816000"]},
        "567": {"vr": "TM", "Value": ["094847.614000"]},
        "568": {"vr": "TM", "Value": ["095207.656000"]},
        "569": {"vr": "TM", "Value": ["094927.740000"]},
        "570": {"vr": "TM", "Value": ["094827.686000"]},
        "571": {"vr": "TM", "Value": ["095327.628000"]},
        "572": {"vr": "TM", "Value": ["095347.931000"]},
        "573": {"vr": "TM", "Value": ["095427.654000"]},
        "574": {"vr": "TM", "Value": ["095407.679000"]},
        "575": {"vr": "TM", "Value": ["095127.634000"]},
        "576": {"vr": "TM", "Value": ["095127.824000"]},
        "577": {"vr": "TM", "Value": ["095347.700000"]},
        "578": {"vr": "TM", "Value": ["095027.690000"]},
        "579": {"vr": "TM", "Value": ["095307.712000"]},
        "580": {"vr": "TM", "Value": ["095307.779000"]},
        "581": {"vr": "TM", "Value": ["095147.918000"]},
        "582": {"vr": "TM", "Value": ["095027.620000"]},
        "583": {"vr": "TM", "Value": ["095127.809000"]},
        "584": {"vr": "TM", "Value": ["095227.776000"]},
        "585": {"vr": "TM", "Value": ["094527.709000"]},
        "586": {"vr": "TM", "Value": ["095347.730000"]},
        "587": {"vr": "TM", "Value": ["094647.920000"]},
        "588": {"vr": "TM", "Value": ["094727.875000"]},
        "589": {"vr": "TM", "Value": ["095327.837000"]},
        "590": {"vr": "TM", "Value": ["094907.710000"]},
        "591": {"vr": "TM", "Value": ["095047.764000"]},
        "592": {"vr": "TM", "Value": ["095347.792000"]},
        "593": {"vr": "TM", "Value": ["095247.656000"]},
        "594": {"vr": "TM", "Value": ["094527.827000"]},
        "595": {"vr": "TM", "Value": ["094527.960000"]},
        "596": {"vr": "TM", "Value": ["094947.928000"]},
        "597": {"vr": "TM", "Value": ["094907.785000"]},
        "598": {"vr": "TM", "Value": ["095347.608000"]},
        "599": {"vr": "TM", "Value": ["094747.804000"]},
        "600": {"vr": "TM", "Value": ["094847.612000"]},
        "601": {"vr": "TM", "Value": ["095147.872000"]},
        "602": {"vr": "TM", "Value": ["095007.720000"]},
        "603": {"vr": "TM", "Value": ["095407.901000"]},
        "604": {"vr": "TM", "Value": ["094627.622000"]},
        "605": {"vr": "TM", "Value": ["095427.768000"]},
        "606": {"vr": "TM", "Value": ["095227.946000"]},
        "607": {"vr": "TM", "Value": ["095127.898000"]},
        "608": {"vr": "TM", "Value": ["095407.748000"]},
        "609": {"vr": "TM", "Value": ["095227.681000"]},
        "610": {"vr": "TM", "Value": ["095427.928000"]},
        "611": {"vr": "TM", "Value": ["095007.875000"]},
        "612": {"vr": "TM", "Value": ["094547.632000"]},
        "613": {"vr": "TM", "Value": ["095307.649000"]},
        "614": {"vr": "TM", "Value": ["095007.758000"]},
        "615": {"vr": "TM", "Value": ["095207.677000"]},
        "616": {"vr": "TM", "Value": ["095207.831000"]},
        "617": {"vr": "TM", "Value": ["094607.908000"]},
        "618": {"vr": "TM", "Value": ["094707.843000"]},
        "619": {"vr": "TM", "Value": ["095027.872000"]},
        "620": {"vr": "TM", "Value": ["095027.824000"]},
        "621": {"vr": "TM", "Value": ["094647.724000"]},
        "622": {"vr": "TM", "Value": ["094527.871000"]},
        "623": {"vr": "TM", "Value": ["095407.730000"]},
        "624": {"vr": "TM", "Value": ["095456.441000"]},
        "625": {"vr": "TM", "Value": ["095307.832000"]},
        "626": {"vr": "TM", "Value": ["094727.810000"]},
        "627": {"vr": "TM", "Value": ["094707.742000"]},
        "628": {"vr": "TM", "Value": ["094527.950000"]},
        "629": {"vr": "TM", "Value": ["094907.936000"]},
        "630": {"vr": "TM", "Value": ["095227.846000"]},
        "631": {"vr": "TM", "Value": ["094807.797000"]},
        "632": {"vr": "TM", "Value": ["094607.893000"]},
        "633": {"vr": "TM", "Value": ["095027.852000"]},
        "634": {"vr": "TM", "Value": ["094807.895000"]},
        "635": {"vr": "TM", "Value": ["095247.663000"]},
        "636": {"vr": "TM", "Value": ["094707.687000"]},
        "637": {"vr": "TM", "Value": ["094707.876000"]},
        "638": {"vr": "TM", "Value": ["095207.689000"]},
        "639": {"vr": "TM", "Value": ["095447.688000"]},
        "640": {"vr": "TM", "Value": ["094627.936000"]},
        "641": {"vr": "TM", "Value": ["094627.657000"]},
        "642": {"vr": "TM", "Value": ["094807.768000"]},
        "643": {"vr": "TM", "Value": ["095227.794000"]},
        "644": {"vr": "TM", "Value": ["095307.938000"]},
        "645": {"vr": "TM", "Value": ["094927.832000"]},
        "646": {"vr": "TM", "Value": ["095327.661000"]},
        "647": {"vr": "TM", "Value": ["095107.821000"]},
        "648": {"vr": "TM", "Value": ["095427.678000"]},
        "649": {"vr": "TM", "Value": ["094927.699000"]},
        "650": {"vr": "TM", "Value": ["094627.858000"]},
        "651": {"vr": "TM", "Value": ["094747.775000"]},
        "652": {"vr": "TM", "Value": ["095307.892000"]},
        "653": {"vr": "TM", "Value": ["094747.615000"]},
        "654": {"vr": "TM", "Value": ["095147.695000"]},
        "655": {"vr": "TM", "Value": ["094827.727000"]},
        "656": {"vr": "TM", "Value": ["095127.842000"]},
        "657": {"vr": "TM", "Value": ["094547.794000"]},
        "658": {"vr": "TM", "Value": ["095207.866000"]},
        "659": {"vr": "TM", "Value": ["094647.700000"]},
        "660": {"vr": "TM", "Value": ["095027.908000"]},
        "661": {"vr": "TM", "Value": ["095307.884000"]},
        "662": {"vr": "TM", "Value": ["094647.864000"]},
        "663": {"vr": "TM", "Value": ["095456.556000"]},
        "664": {"vr": "TM", "Value": ["095207.703000"]},
        "665": {"vr": "TM", "Value": ["095207.691000"]},
        "666": {"vr": "TM", "Value": ["094947.896000"]},
        "667": {"vr": "TM", "Value": ["094627.879000"]},
        "668": {"vr": "TM", "Value": ["095007.834000"]},
        "669": {"vr": "TM", "Value": ["094527.958000"]},
        "670": {"vr": "TM", "Value": ["094627.749000"]},
        "671": {"vr": "TM", "Value": ["095107.861000"]},
        "672": {"vr": "TM", "Value": ["095407.812000"]},
        "673": {"vr": "TM", "Value": ["094607.745000"]},
        "674": {"vr": "TM", "Value": ["095327.618000"]},
        "675": {"vr": "TM", "Value": ["094847.948000"]},
        "676": {"vr": "TM", "Value": ["094847.672000"]},
        "677": {"vr": "TM", "Value": ["094907.845000"]},
        "678": {"vr": "TM", "Value": ["094647.712000"]},
        "679": {"vr": "TM", "Value": ["095007.824000"]},
        "680": {"vr": "TM", "Value": ["095147.655000"]},
        "681": {"vr": "TM", "Value": ["095447.711000"]},
        "682": {"vr": "TM", "Value": ["095247.750000"]},
        "683": {"vr": "TM", "Value": ["095447.647000"]},
        "684": {"vr": "TM", "Value": ["095227.707000"]},
        "685": {"vr": "TM", "Value": ["094607.828000"]},
        "686": {"vr": "TM", "Value": ["094907.879000"]},
        "687": {"vr": "TM", "Value": ["095147.794000"]},
        "688": {"vr": "TM", "Value": ["094947.756000"]},
        "689": {"vr": "TM", "Value": ["094527.880000"]},
        "690": {"vr": "TM", "Value": ["095007.788000"]},
        "691": {"vr": "TM", "Value": ["094547.726000"]},
        "692": {"vr": "TM", "Value": ["094547.859000"]},
        "693": {"vr": "TM", "Value": ["094547.942000"]},
        "694": {"vr": "TM", "Value": ["094947.642000"]},
        "695": {"vr": "TM", "Value": ["094607.799000"]},
        "696": {"vr": "TM", "Value": ["095227.904000"]},
        "697": {"vr": "TM", "Value": ["094927.632000"]},
        "698": {"vr": "TM", "Value": ["095107.803000"]},
        "699": {"vr": "TM", "Value": ["094847.626000"]},
        "700": {"vr": "TM", "Value": ["094607.727000"]},
        "701": {"vr": "TM", "Value": ["095227.915000"]},
        "702": {"vr": "TM", "Value": ["094547.739000"]},
        "703": {"vr": "TM", "Value": ["095307.671000"]},
        "704": {"vr": "TM", "Value": ["094807.788000"]},
        "705": {"vr": "TM", "Value": ["094827.641000"]},
        "706": {"vr": "TM", "Value": ["095127.618000"]},
        "707": {"vr": "TM", "Value": ["094707.649000"]},
        "708": {"vr": "TM", "Value": ["094847.719000"]},
        "709": {"vr": "TM", "Value": ["095247.815000"]},
        "710": {"vr": "TM", "Value": ["095307.830000"]},
        "711": {"vr": "TM", "Value": ["095227.615000"]},
        "712": {"vr": "TM", "Value": ["094527.848000"]},
        "713": {"vr": "TM", "Value": ["095047.887000"]},
        "714": {"vr": "TM", "Value": ["094827.879000"]},
        "715": {"vr": "TM", "Value": ["095147.751000"]},
        "716": {"vr": "TM", "Value": ["095207.874000"]},
        "717": {"vr": "TM", "Value": ["095307.931000"]},
        "718": {"vr": "TM", "Value": ["095407.666000"]},
        "719": {"vr": "TM", "Value": ["094947.900000"]},
        "720": {"vr": "TM", "Value": ["094607.946000"]},
        "721": {"vr": "TM", "Value": ["095107.786000"]},
        "722": {"vr": "TM", "Value": ["094647.735000"]},
        "723": {"vr": "TM", "Value": ["095447.642000"]},
        "724": {"vr": "TM", "Value": ["095247.708000"]},
        "725": {"vr": "TM", "Value": ["094547.661000"]},
        "726": {"vr": "TM", "Value": ["095407.929000"]},
        "727": {"vr": "TM", "Value": ["095407.623000"]},
        "728": {"vr": "TM", "Value": ["094527.990000"]},
        "729": {"vr": "TM", "Value": ["095407.940000"]},
        "730": {"vr": "TM", "Value": ["095027.622000"]},
        "731": {"vr": "TM", "Value": ["094907.782000"]},
        "732": {"vr": "TM", "Value": ["094647.962000"]},
        "733": {"vr": "TM", "Value": ["095427.916000"]},
        "734": {"vr": "TM", "Value": ["094547.936000"]},
        "735": {"vr": "TM", "Value": ["094907.728000"]},
        "736": {"vr": "TM", "Value": ["094727.855000"]},
        "737": {"vr": "TM", "Value": ["094627.712000"]},
        "738": {"vr": "TM", "Value": ["095307.745000"]},
        "739": {"vr": "TM", "Value": ["094527.779000"]},
        "740": {"vr": "TM", "Value": ["094647.875000"]},
        "741": {"vr": "TM", "Value": ["094607.683000"]},
        "742": {"vr": "TM", "Value": ["094707.825000"]},
        "743": {"vr": "TM", "Value": ["095327.914000"]},
        "744": {"vr": "TM", "Value": ["095107.757000"]},
        "745": {"vr": "TM", "Value": ["094707.714000"]},
        "746": {"vr": "TM", "Value": ["094707.787000"]},
        "747": {"vr": "TM", "Value": ["095047.858000"]},
        "748": {"vr": "TM", "Value": ["095147.667000"]},
        "749": {"vr": "TM", "Value": ["095207.696000"]},
        "750": {"vr": "TM", "Value": ["095447.819000"]},
        "751": {"vr": "TM", "Value": ["094807.824000"]},
        "752": {"vr": "TM", "Value": ["095247.729000"]},
        "753": {"vr": "TM", "Value": ["094627.672000"]},
        "754": {"vr": "TM", "Value": ["095207.759000"]},
        "755": {"vr": "TM", "Value": ["094947.820000"]},
        "756": {"vr": "TM", "Value": ["094827.829000"]},
        "757": {"vr": "TM", "Value": ["095456.493000"]},
        "758": {"vr": "TM", "Value": ["094747.951000"]},
        "759": {"vr": "TM", "Value": ["094547.891000"]},
        "760": {"vr": "TM", "Value": ["094727.906000"]},
        "761": {"vr": "TM", "Value": ["094747.927000"]},
        "762": {"vr": "TM", "Value": ["095447.623000"]},
        "763": {"vr": "TM", "Value": ["095147.670000"]},
        "764": {"vr": "TM", "Value": ["095007.651000"]},
        "765": {"vr": "TM", "Value": ["094727.630000"]},
        "766": {"vr": "TM", "Value": ["094727.716000"]},
        "767": {"vr": "TM", "Value": ["095327.842000"]},
        "768": {"vr": "TM", "Value": ["095047.787000"]},
        "769": {"vr": "TM", "Value": ["095227.858000"]},
        "770": {"vr": "TM", "Value": ["094827.799000"]},
        "771": {"vr": "TM", "Value": ["095456.510000"]},
        "772": {"vr": "TM", "Value": ["094907.758000"]},
        "773": {"vr": "TM", "Value": ["095407.927000"]},
        "774": {"vr": "TM", "Value": ["094747.869000"]},
        "775": {"vr": "TM", "Value": ["094727.652000"]},
        "776": {"vr": "TM", "Value": ["094847.882000"]},
        "777": {"vr": "TM", "Value": ["095007.839000"]},
        "778": {"vr": "TM", "Value": ["095447.724000"]},
        "779": {"vr": "TM", "Value": ["094547.832000"]},
        "780": {"vr": "TM", "Value": ["095047.921000"]},
        "781": {"vr": "TM", "Value": ["094907.698000"]},
        "782": {"vr": "TM", "Value": ["095427.628000"]},
        "783": {"vr": "TM", "Value": ["095207.892000"]},
        "784": {"vr": "TM", "Value": ["094527.910000"]},
        "785": {"vr": "TM", "Value": ["095207.654000"]},
        "786": {"vr": "TM", "Value": ["095047.871000"]},
        "787": {"vr": "TM", "Value": ["094707.763000"]},
        "788": {"vr": "TM", "Value": ["095327.716000"]},
        "789": {"vr": "TM", "Value": ["094827.670000"]},
        "790": {"vr": "TM", "Value": ["095407.802000"]},
        "791": {"vr": "TM", "Value": ["095327.755000"]},
        "792": {"vr": "TM", "Value": ["094607.626000"]},
        "793": {"vr": "TM", "Value": ["095207.698000"]},
        "794": {"vr": "TM", "Value": ["094827.659000"]},
        "795": {"vr": "TM", "Value": ["094907.858000"]},
        "796": {"vr": "TM", "Value": ["094747.892000"]},
        "797": {"vr": "TM", "Value": ["095107.840000"]},
        "798": {"vr": "TM", "Value": ["095207.785000"]},
        "799": {"vr": "TM", "Value": ["094547.779000"]},
        "800": {"vr": "TM", "Value": ["094627.960000"]},
        "801": {"vr": "TM", "Value": ["094527.781000"]},
        "802": {"vr": "TM", "Value": ["094627.704000"]},
        "803": {"vr": "TM", "Value": ["095247.770000"]},
        "804": {"vr": "TM", "Value": ["095247.691000"]},
        "805": {"vr": "TM", "Value": ["094807.834000"]},
        "806": {"vr": "TM", "Value": ["095107.864000"]},
        "807": {"vr": "TM", "Value": ["095227.824000"]},
        "808": {"vr": "TM", "Value": ["094807.661000"]},
        "809": {"vr": "TM", "Value": ["095027.826000"]},
        "810": {"vr": "TM", "Value": ["095007.899000"]},
        "811": {"vr": "TM", "Value": ["095207.861000"]},
        "812": {"vr": "TM", "Value": ["094927.628000"]},
        "813": {"vr": "TM", "Value": ["095047.628000"]},
        "814": {"vr": "TM", "Value": ["095107.810000"]},
        "815": {"vr": "TM", "Value": ["095447.611000"]},
        "816": {"vr": "TM", "Value": ["095327.782000"]},
        "817": {"vr": "TM", "Value": ["095447.765000"]},
        "818": {"vr": "TM", "Value": ["095047.676000"]},
        "819": {"vr": "TM", "Value": ["094927.931000"]},
        "820": {"vr": "TM", "Value": ["095327.689000"]},
        "821": {"vr": "TM", "Value": ["095327.652000"]},
        "822": {"vr": "TM", "Value": ["094847.743000"]},
        "823": {"vr": "TM", "Value": ["095127.741000"]},
        "824": {"vr": "TM", "Value": ["095247.912000"]},
        "825": {"vr": "TM", "Value": ["095127.637000"]},
        "826": {"vr": "TM", "Value": ["094807.955000"]},
        "827": {"vr": "TM", "Value": ["095456.462000"]},
        "828": {"vr": "TM", "Value": ["094947.690000"]},
        "829": {"vr": "TM", "Value": ["095147.753000"]},
        "830": {"vr": "TM", "Value": ["094607.885000"]},
        "831": {"vr": "TM", "Value": ["094827.722000"]},
        "832": {"vr": "TM", "Value": ["094747.787000"]},
        "833": {"vr": "TM", "Value": ["094647.663000"]},
        "834": {"vr": "TM", "Value": ["094627.702000"]},
        "835": {"vr": "TM", "Value": ["095447.842000"]},
        "836": {"vr": "TM", "Value": ["094827.823000"]},
        "837": {"vr": "TM", "Value": ["094627.724000"]},
        "838": {"vr": "TM", "Value": ["094547.895000"]},
        "839": {"vr": "TM", "Value": ["094727.746000"]},
        "840": {"vr": "TM", "Value": ["095307.946000"]},
        "841": {"vr": "TM", "Value": ["095147.866000"]},
        "842": {"vr": "TM", "Value": ["094607.698000"]},
        "843": {"vr": "TM", "Value": ["095007.748000"]},
        "844": {"vr": "TM", "Value": ["094807.616000"]},
        "845": {"vr": "TM", "Value": ["094547.766000"]},
        "846": {"vr": "TM", "Value": ["095007.858000"]},
        "847": {"vr": "TM", "Value": ["095207.770000"]},
        "848": {"vr": "TM", "Value": ["094947.877000"]},
        "849": {"vr": "TM", "Value": ["094627.751000"]},
        "850": {"vr": "TM", "Value": ["095147.719000"]},
        "851": {"vr": "TM", "Value": ["095047.625000"]},
        "852": {"vr": "TM", "Value": ["095027.946000"]},
        "853": {"vr": "TM", "Value": ["095227.739000"]},
        "854": {"vr": "TM", "Value": ["094747.734000"]},
        "855": {"vr": "TM", "Value": ["094727.841000"]},
        "856": {"vr": "TM", "Value": ["094927.801000"]},
        "857": {"vr": "TM", "Value": ["095107.921000"]},
        "858": {"vr": "TM", "Value": ["094807.643000"]},
        "859": {"vr": "TM", "Value": ["094607.874000"]},
        "860": {"vr": "TM", "Value": ["094847.701000"]},
        "861": {"vr": "TM", "Value": ["095456.414000"]},
        "862": {"vr": "TM", "Value": ["095347.881000"]},
        "863": {"vr": "TM", "Value": ["095127.865000"]},
        "864": {"vr": "TM", "Value": ["095447.804000"]},
        "865": {"vr": "TM", "Value": ["094907.658000"]},
        "866": {"vr": "TM", "Value": ["095207.931000"]},
        "867": {"vr": "TM", "Value": ["094707.632000"]},
        "868": {"vr": "TM", "Value": ["095147.743000"]},
        "869": {"vr": "TM", "Value": ["094707.753000"]},
        "870": {"vr": "TM", "Value": ["094827.909000"]},
        "871": {"vr": "TM", "Value": ["094927.842000"]},
        "872": {"vr": "TM", "Value": ["094547.659000"]},
        "873": {"vr": "TM", "Value": ["095347.735000"]},
        "874": {"vr": "TM", "Value": ["095207.624000"]},
        "875": {"vr": "TM", "Value": ["094527.758000"]},
        "876": {"vr": "TM", "Value": ["094707.835000"]},
        "877": {"vr": "TM", "Value": ["094607.911000"]},
        "878": {"vr": "TM", "Value": ["095347.815000"]},
        "879": {"vr": "TM", "Value": ["094547.734000"]},
        "880": {"vr": "TM", "Value": ["094607.794000"]},
        "881": {"vr": "TM", "Value": ["094727.610000"]},
        "882": {"vr": "TM", "Value": ["094607.866000"]},
        "883": {"vr": "TM", "Value": ["094707.856000"]},
        "884": {"vr": "TM", "Value": ["095327.904000"]},
        "885": {"vr": "TM", "Value": ["095456.544000"]},
        "886": {"vr": "TM", "Value": ["094727.786000"]},
        "887": {"vr": "TM", "Value": ["094947.910000"]},
        "888": {"vr": "TM", "Value": ["094707.750000"]},
        "889": {"vr": "TM", "Value": ["094607.666000"]},
        "890": {"vr": "TM", "Value": ["094747.954000"]},
        "891": {"vr": "TM", "Value": ["095007.776000"]},
        "892": {"vr": "TM", "Value": ["095427.649000"]},
        "893": {"vr": "TM", "Value": ["095047.813000"]},
        "894": {"vr": "TM", "Value": ["094747.819000"]},
        "895": {"vr": "TM", "Value": ["095007.634000"]},
        "896": {"vr": "TM", "Value": ["094647.727000"]},
        "897": {"vr": "TM", "Value": ["095007.641000"]},
        "898": {"vr": "TM", "Value": ["095027.867000"]},
        "899": {"vr": "TM", "Value": ["094907.628000"]},
        "900": {"vr": "TM", "Value": ["094927.893000"]},
        "901": {"vr": "TM", "Value": ["094607.941000"]},
        "902": {"vr": "TM", "Value": ["095027.941000"]},
        "903": {"vr": "TM", "Value": ["095447.928000"]},
        "904": {"vr": "TM", "Value": ["094627.677000"]},
        "905": {"vr": "TM", "Value": ["094727.919000"]},
        "906": {"vr": "TM", "Value": ["094627.645000"]},
        "907": {"vr": "TM", "Value": ["095207.772000"]},
        "908": {"vr": "TM", "Value": ["095007.656000"]},
        "909": {"vr": "TM", "Value": ["095447.742000"]},
        "910": {"vr": "TM", "Value": ["095107.859000"]},
        "911": {"vr": "TM", "Value": ["094907.780000"]},
        "912": {"vr": "TM", "Value": ["095427.830000"]},
        "913": {"vr": "TM", "Value": ["095127.608000"]},
        "914": {"vr": "TM", "Value": ["094727.857000"]},
        "915": {"vr": "TM", "Value": ["095047.792000"]},
        "916": {"vr": "TM", "Value": ["095427.921000"]},
        "917": {"vr": "TM", "Value": ["095147.864000"]},
        "918": {"vr": "TM", "Value": ["095307.676000"]},
        "919": {"vr": "TM", "Value": ["094527.700000"]},
        "920": {"vr": "TM", "Value": ["094647.816000"]},
        "921": {"vr": "TM", "Value": ["094807.753000"]},
        "922": {"vr": "TM", "Value": ["095307.663000"]},
        "923": {"vr": "TM", "Value": ["095227.932000"]},
        "924": {"vr": "TM", "Value": ["094527.622000"]},
        "925": {"vr": "TM", "Value": ["094547.893000"]},
        "926": {"vr": "TM", "Value": ["095456.427000"]},
        "927": {"vr": "TM", "Value": ["095207.747000"]},
        "928": {"vr": "TM", "Value": ["095347.626000"]},
        "929": {"vr": "TM", "Value": ["095047.620000"]},
        "930": {"vr": "TM", "Value": ["094947.778000"]},
        "931": {"vr": "TM", "Value": ["095007.768000"]},
        "932": {"vr": "TM", "Value": ["095456.476000"]},
        "933": {"vr": "TM", "Value": ["095127.644000"]},
        "934": {"vr": "TM", "Value": ["094547.753000"]},
        "935": {"vr": "TM", "Value": ["094927.840000"]},
        "936": {"vr": "TM", "Value": ["095147.825000"]},
        "937": {"vr": "TM", "Value": ["094927.819000"]},
        "938": {"vr": "TM", "Value": ["095456.404000"]},
        "939": {"vr": "TM", "Value": ["094907.691000"]},
        "940": {"vr": "TM", "Value": ["095307.820000"]},
        "941": {"vr": "TM", "Value": ["095307.773000"]},
        "942": {"vr": "TM", "Value": ["094707.953000"]},
        "943": {"vr": "TM", "Value": ["094927.822000"]},
        "944": {"vr": "TM", "Value": ["095127.772000"]},
        "945": {"vr": "TM", "Value": ["095407.862000"]},
        "946": {"vr": "TM", "Value": ["095127.658000"]},
        "947": {"vr": "TM", "Value": ["094907.929000"]},
        "948": {"vr": "TM", "Value": ["095147.823000"]},
        "949": {"vr": "TM", "Value": ["094827.709000"]},
        "950": {"vr": "TM", "Value": ["095247.928000"]},
        "951": {"vr": "TM", "Value": ["094907.919000"]},
        "952": {"vr": "TM", "Value": ["094727.677000"]},
        "953": {"vr": "TM", "Value": ["095027.842000"]},
        "954": {"vr": "TM", "Value": ["095227.630000"]},
        "955": {"vr": "TM", "Value": ["094607.830000"]},
        "956": {"vr": "TM", "Value": ["095147.840000"]},
        "957": {"vr": "TM", "Value": ["094907.861000"]},
        "958": {"vr": "TM", "Value": ["095247.891000"]},
        "959": {"vr": "TM", "Value": ["094827.688000"]},
        "960": {"vr": "TM", "Value": ["094927.768000"]},
        "961": {"vr": "TM", "Value": ["095007.831000"]},
        "962": {"vr": "TM", "Value": ["095307.840000"]},
        "963": {"vr": "TM", "Value": ["095207.798000"]},
        "964": {"vr": "TM", "Value": ["094647.862000"]},
        "965": {"vr": "TM", "Value": ["094747.816000"]},
        "966": {"vr": "TM", "Value": ["094927.702000"]},
        "967": {"vr": "TM", "Value": ["095407.735000"]},
        "968": {"vr": "TM", "Value": ["094707.938000"]},
        "969": {"vr": "TM", "Value": ["094727.642000"]},
        "970": {"vr": "TM", "Value": ["094527.977000"]},
        "971": {"vr": "TM", "Value": ["094727.768000"]},
        "972": {"vr": "TM", "Value": ["095407.867000"]},
        "973": {"vr": "TM", "Value": ["095327.876000"]},
        "974": {"vr": "TM", "Value": ["095047.693000"]},
        "975": {"vr": "TM", "Value": ["095127.919000"]},
        "976": {"vr": "TM", "Value": ["094807.614000"]},
        "977": {"vr": "TM", "Value": ["094947.773000"]},
        "978": {"vr": "TM", "Value": ["095456.507000"]},
        "979": {"vr": "TM", "Value": ["095147.895000"]},
        "980": {"vr": "TM", "Value": ["095207.686000"]},
        "981": {"vr": "TM", "Value": ["095347.766000"]},
        "982": {"vr": "TM", "Value": ["094907.842000"]},
        "983": {"vr": "TM", "Value": ["095147.837000"]},
        "984": {"vr": "TM", "Value": ["095307.641000"]},
        "985": {"vr": "TM", "Value": ["094947.770000"]},
        "986": {"vr": "TM", "Value": ["094847.725000"]},
        "987": {"vr": "TM", "Value": ["094527.987000"]},
        "988": {"vr": "TM", "Value": ["095347.618000"]},
        "989": {"vr": "TM", "Value": ["094927.704000"]},
        "990": {"vr": "TM", "Value": ["094947.801000"]},
        "991": {"vr": "TM", "Value": ["095407.852000"]},
        "992": {"vr": "TM", "Value": ["094827.631000"]},
        "993": {"vr": "TM", "Value": ["095427.807000"]},
        "994": {"vr": "TM", "Value": ["094647.751000"]},
        "995": {"vr": "TM", "Value": ["095307.827000"]},
        "996": {"vr": "TM", "Value": ["095456.410000"]},
        "997": {"vr": "TM", "Value": ["095227.709000"]},
        "998": {"vr": "TM", "Value": ["095307.613000"]},
        "999": {"vr": "TM", "Value": ["095427.951000"]},
        "1000": {"vr": "TM", "Value": ["095007.636000"]},
        "1001": {"vr": "TM", "Value": ["095447.616000"]},
        "1002": {"vr": "TM", "Value": ["094607.715000"]},
        "1003": {"vr": "TM", "Value": ["094747.657000"]},
        "1004": {"vr": "TM", "Value": ["095347.764000"]},
        "1005": {"vr": "TM", "Value": ["095207.614000"]},
        "1006": {"vr": "TM", "Value": ["095227.801000"]},
        "1007": {"vr": "TM", "Value": ["094727.673000"]},
        "1008": {"vr": "TM", "Value": ["094627.679000"]},
        "1009": {"vr": "TM", "Value": ["094727.794000"]},
        "1010": {"vr": "TM", "Value": ["095347.677000"]},
        "1011": {"vr": "TM", "Value": ["095447.866000"]},
        "1012": {"vr": "TM", "Value": ["095227.653000"]},
        "1013": {"vr": "TM", "Value": ["095227.806000"]},
        "1014": {"vr": "TM", "Value": ["095147.907000"]},
        "1015": {"vr": "TM", "Value": ["095456.522000"]},
        "1016": {"vr": "TM", "Value": ["094827.949000"]},
        "1017": {"vr": "TM", "Value": ["095447.659000"]},
        "1018": {"vr": "TM", "Value": ["094807.635000"]},
        "1019": {"vr": "TM", "Value": ["095347.894000"]},
        "1020": {"vr": "TM", "Value": ["095207.884000"]},
        "1021": {"vr": "TM", "Value": ["095427.797000"]},
        "1022": {"vr": "TM", "Value": ["094847.803000"]},
        "1023": {"vr": "TM", "Value": ["094907.909000"]},
        "1024": {"vr": "TM", "Value": ["095227.696000"]},
        "1025": {"vr": "TM", "Value": ["094547.751000"]},
        "1026": {"vr": "TM", "Value": ["094547.879000"]},
        "1027": {"vr": "TM", "Value": ["095207.905000"]},
        "1028": {"vr": "TM", "Value": ["095347.715000"]},
        "1029": {"vr": "TM", "Value": ["095047.923000"]},
        "1030": {"vr": "TM", "Value": ["094527.753000"]},
        "1031": {"vr": "TM", "Value": ["094647.698000"]},
        "1032": {"vr": "TM", "Value": ["094827.868000"]},
        "1033": {"vr": "TM", "Value": ["094947.624000"]},
        "1034": {"vr": "TM", "Value": ["094647.873000"]},
        "1035": {"vr": "TM", "Value": ["095407.674000"]},
        "1036": {"vr": "TM", "Value": ["094847.867000"]},
        "1037": {"vr": "TM", "Value": ["095107.736000"]},
        "1038": {"vr": "TM", "Value": ["094627.945000"]},
        "1039": {"vr": "TM", "Value": ["094847.607000"]},
        "1040": {"vr": "TM", "Value": ["094827.712000"]},
        "1041": {"vr": "TM", "Value": ["095207.879000"]},
        "1042": {"vr": "TM", "Value": ["094827.747000"]},
        "1043": {"vr": "TM", "Value": ["095027.751000"]},
        "1044": {"vr": "TM", "Value": ["094807.792000"]},
        "1045": {"vr": "TM", "Value": ["094607.708000"]},
        "1046": {"vr": "TM", "Value": ["095107.791000"]},
        "1047": {"vr": "TM", "Value": ["095407.903000"]},
        "1048": {"vr": "TM", "Value": ["095427.766000"]},
        "1049": {"vr": "TM", "Value": ["094547.756000"]},
        "1050": {"vr": "TM", "Value": ["095047.777000"]},
        "1051": {"vr": "TM", "Value": ["095007.616000"]},
        "1052": {"vr": "TM", "Value": ["094647.693000"]},
        "1053": {"vr": "TM", "Value": ["095107.796000"]},
        "1054": {"vr": "TM", "Value": ["094627.918000"]},
        "1055": {"vr": "TM", "Value": ["094847.662000"]},
        "1056": {"vr": "TM", "Value": ["095307.812000"]},
        "1057": {"vr": "TM", "Value": ["095427.690000"]},
        "1058": {"vr": "TM", "Value": ["095227.712000"]},
        "1059": {"vr": "TM", "Value": ["094907.762000"]},
        "1060": {"vr": "TM", "Value": ["094527.735000"]},
        "1061": {"vr": "TM", "Value": ["094547.862000"]},
        "1062": {"vr": "TM", "Value": ["094727.833000"]},
        "1063": {"vr": "TM", "Value": ["094847.716000"]},
        "1064": {"vr": "TM", "Value": ["094727.921000"]},
        "1065": {"vr": "TM", "Value": ["094847.610000"]},
        "1066": {"vr": "TM", "Value": ["094907.616000"]},
        "1067": {"vr": "TM", "Value": ["095207.841000"]},
        "1068": {"vr": "TM", "Value": ["095307.951000"]},
        "1069": {"vr": "TM", "Value": ["095047.963000"]},
        "1070": {"vr": "TM", "Value": ["094727.660000"]},
        "1071": {"vr": "TM", "Value": ["095307.761000"]},
        "1072": {"vr": "TM", "Value": ["095207.921000"]},
        "1073": {"vr": "TM", "Value": ["095456.478000"]},
        "1074": {"vr": "TM", "Value": ["095447.935000"]},
        "1075": {"vr": "TM", "Value": ["094647.759000"]},
        "1076": {"vr": "TM", "Value": ["095107.653000"]},
        "1077": {"vr": "TM", "Value": ["095227.939000"]},
        "1078": {"vr": "TM", "Value": ["094727.647000"]},
        "1079": {"vr": "TM", "Value": ["095307.856000"]},
        "1080": {"vr": "TM", "Value": ["094827.766000"]},
        "1081": {"vr": "TM", "Value": ["094647.960000"]},
        "1082": {"vr": "TM", "Value": ["095207.894000"]},
        "1083": {"vr": "TM", "Value": ["095207.936000"]},
        "1084": {"vr": "TM", "Value": ["094627.697000"]},
        "1085": {"vr": "TM", "Value": ["095307.799000"]},
        "1086": {"vr": "TM", "Value": ["095207.838000"]},
        "1087": {"vr": "TM", "Value": ["095207.872000"]},
        "1088": {"vr": "TM", "Value": ["095327.792000"]},
        "1089": {"vr": "TM", "Value": ["095207.661000"]},
        "1090": {"vr": "TM", "Value": ["095007.808000"]},
        "1091": {"vr": "TM", "Value": ["094847.624000"]},
        "1092": {"vr": "TM", "Value": ["095147.923000"]},
        "1093": {"vr": "TM", "Value": ["094627.773000"]},
        "1094": {"vr": "TM", "Value": ["095447.627000"]},
        "1095": {"vr": "TM", "Value": ["095227.734000"]},
        "1096": {"vr": "TM", "Value": ["095127.623000"]},
        "1097": {"vr": "TM", "Value": ["094827.947000"]},
        "1098": {"vr": "TM", "Value": ["095347.615000"]},
        "1099": {"vr": "TM", "Value": ["095127.903000"]},
        "1100": {"vr": "TM", "Value": ["094947.905000"]},
        "1101": {"vr": "TM", "Value": ["095127.829000"]},
        "1102": {"vr": "TM", "Value": ["095127.694000"]},
        "1103": {"vr": "TM", "Value": ["095307.886000"]},
        "1104": {"vr": "TM", "Value": ["094647.690000"]},
        "1105": {"vr": "TM", "Value": ["095147.741000"]},
        "1106": {"vr": "TM", "Value": ["094647.714000"]},
        "1107": {"vr": "TM", "Value": ["095007.669000"]},
        "1108": {"vr": "TM", "Value": ["094747.620000"]},
        "1109": {"vr": "TM", "Value": ["095427.871000"]},
        "1110": {"vr": "TM", "Value": ["095327.664000"]},
        "1111": {"vr": "TM", "Value": ["094807.778000"]},
        "1112": {"vr": "TM", "Value": ["094727.741000"]},
        "1113": {"vr": "TM", "Value": ["095207.667000"]},
        "1114": {"vr": "TM", "Value": ["094947.935000"]},
        "1115": {"vr": "TM", "Value": ["095427.693000"]},
        "1116": {"vr": "TM", "Value": ["094527.907000"]},
        "1117": {"vr": "TM", "Value": ["095247.687000"]},
        "1118": {"vr": "TM", "Value": ["094727.690000"]},
        "1119": {"vr": "TM", "Value": ["095427.671000"]},
        "1120": {"vr": "TM", "Value": ["095427.931000"]},
        "1121": {"vr": "TM", "Value": ["094947.808000"]},
        "1122": {"vr": "TM", "Value": ["094727.640000"]},
        "1123": {"vr": "TM", "Value": ["094627.632000"]},
        "1124": {"vr": "TM", "Value": ["094947.658000"]},
        "1125": {"vr": "TM", "Value": ["094927.651000"]},
        "1126": {"vr": "TM", "Value": ["095447.911000"]},
        "1127": {"vr": "TM", "Value": ["094647.833000"]},
        "1128": {"vr": "TM", "Value": ["095127.779000"]},
        "1129": {"vr": "TM", "Value": ["094847.819000"]},
        "1130": {"vr": "TM", "Value": ["095427.873000"]},
        "1131": {"vr": "TM", "Value": ["094707.678000"]},
        "1132": {"vr": "TM", "Value": ["094647.857000"]},
        "1133": {"vr": "TM", "Value": ["095107.706000"]},
        "1134": {"vr": "TM", "Value": ["095227.637000"]},
        "1135": {"vr": "TM", "Value": ["094927.719000"]},
        "1136": {"vr": "TM", "Value": ["094827.929000"]},
        "1137": {"vr": "TM", "Value": ["095307.627000"]},
        "1138": {"vr": "TM", "Value": ["094647.680000"]},
        "1139": {"vr": "TM", "Value": ["095027.632000"]},
        "1140": {"vr": "TM", "Value": ["094607.641000"]},
        "1141": {"vr": "TM", "Value": ["094907.725000"]},
        "1142": {"vr": "TM", "Value": ["094627.607000"]},
        "1143": {"vr": "TM", "Value": ["094647.675000"]},
        "1144": {"vr": "TM", "Value": ["094747.617000"]},
        "1145": {"vr": "TM", "Value": ["095007.743000"]},
        "1146": {"vr": "TM", "Value": ["094827.615000"]},
        "1147": {"vr": "TM", "Value": ["095456.502000"]},
        "1148": {"vr": "TM", "Value": ["094707.651000"]},
        "1149": {"vr": "TM", "Value": ["094527.666000"]},
        "1150": {"vr": "TM", "Value": ["095447.721000"]},
        "1151": {"vr": "TM", "Value": ["094927.858000"]},
        "1152": {"vr": "TM", "Value": ["095047.674000"]},
        "1153": {"vr": "TM", "Value": ["095007.733000"]},
        "1154": {"vr": "TM", "Value": ["095107.613000"]},
        "1155": {"vr": "TM", "Value": ["095047.723000"]},
        "1156": {"vr": "TM", "Value": ["094647.846000"]},
        "1157": {"vr": "TM", "Value": ["094547.657000"]},
        "1158": {"vr": "TM", "Value": ["095247.901000"]},
        "1159": {"vr": "TM", "Value": ["095007.674000"]},
        "1160": {"vr": "TM", "Value": ["095107.741000"]},
        "1161": {"vr": "TM", "Value": ["094707.727000"]},
        "1162": {"vr": "TM", "Value": ["095127.827000"]},
        "1163": {"vr": "TM", "Value": ["095127.744000"]},
        "1164": {"vr": "TM", "Value": ["094927.770000"]},
        "1165": {"vr": "TM", "Value": ["095327.765000"]},
        "1166": {"vr": "TM", "Value": ["094527.740000"]},
        "1167": {"vr": "TM", "Value": ["095227.849000"]},
        "1168": {"vr": "TM", "Value": ["094607.804000"]},
        "1169": {"vr": "TM", "Value": ["095307.794000"]},
        "1170": {"vr": "TM", "Value": ["095327.873000"]},
        "1171": {"vr": "TM", "Value": ["094627.881000"]},
        "1172": {"vr": "TM", "Value": ["095147.913000"]},
        "1173": {"vr": "TM", "Value": ["095407.924000"]},
        "1174": {"vr": "TM", "Value": ["095207.619000"]},
        "1175": {"vr": "TM", "Value": ["095247.746000"]},
        "1176": {"vr": "TM", "Value": ["095247.635000"]},
        "1177": {"vr": "TM", "Value": ["095347.684000"]},
        "1178": {"vr": "TM", "Value": ["094527.767000"]},
        "1179": {"vr": "TM", "Value": ["094747.654000"]},
        "1180": {"vr": "TM", "Value": ["094907.738000"]},
        "1181": {"vr": "TM", "Value": ["094847.787000"]},
        "1182": {"vr": "TM", "Value": ["094547.918000"]},
        "1183": {"vr": "TM", "Value": ["095027.847000"]},
        "1184": {"vr": "TM", "Value": ["095307.758000"]},
        "1185": {"vr": "TM", "Value": ["094907.806000"]},
        "1186": {"vr": "TM", "Value": ["094547.712000"]},
        "1187": {"vr": "TM", "Value": ["094947.796000"]},
        "1188": {"vr": "TM", "Value": ["095247.841000"]},
        "1189": {"vr": "TM", "Value": ["095327.694000"]},
        "1190": {"vr": "TM", "Value": ["095407.817000"]},
        "1191": {"vr": "TM", "Value": ["094527.729000"]},
        "1192": {"vr": "TM", "Value": ["094707.745000"]},
        "1193": {"vr": "TM", "Value": ["095007.861000"]},
        "1194": {"vr": "TM", "Value": ["095447.894000"]},
        "1195": {"vr": "TM", "Value": ["094927.735000"]},
        "1196": {"vr": "TM", "Value": ["094547.691000"]},
        "1197": {"vr": "TM", "Value": ["095427.666000"]},
        "1198": {"vr": "TM", "Value": ["094847.641000"]},
        "1199": {"vr": "TM", "Value": ["095207.869000"]},
        "1200": {"vr": "TM", "Value": ["095307.889000"]},
        "1201": {"vr": "TM", "Value": ["094527.689000"]},
        "1202": {"vr": "TM", "Value": ["094707.609000"]},
        "1203": {"vr": "TM", "Value": ["095447.737000"]},
        "1204": {"vr": "TM", "Value": ["095227.899000"]},
        "1205": {"vr": "TM", "Value": ["095047.941000"]},
        "1206": {"vr": "TM", "Value": ["095327.922000"]},
        "1207": {"vr": "TM", "Value": ["095127.748000"]},
        "1208": {"vr": "TM", "Value": ["094547.610000"]},
        "1209": {"vr": "TM", "Value": ["094547.920000"]},
        "1210": {"vr": "TM", "Value": ["095047.635000"]},
        "1211": {"vr": "TM", "Value": ["095447.675000"]},
        "1212": {"vr": "TM", "Value": ["094727.939000"]},
        "1213": {"vr": "TM", "Value": ["095027.700000"]},
        "1214": {"vr": "TM", "Value": ["095407.723000"]},
        "1215": {"vr": "TM", "Value": ["095047.810000"]},
        "1216": {"vr": "TM", "Value": ["095207.902000"]},
        "1217": {"vr": "TM", "Value": ["095227.871000"]},
        "1218": {"vr": "TM", "Value": ["094527.943000"]},
        "1219": {"vr": "TM", "Value": ["095327.699000"]},
        "1220": {"vr": "TM", "Value": ["095327.777000"]},
        "1221": {"vr": "TM", "Value": ["095427.724000"]},
        "1222": {"vr": "TM", "Value": ["094707.943000"]},
        "1223": {"vr": "TM", "Value": ["095407.656000"]},
        "1224": {"vr": "TM", "Value": ["094847.930000"]},
        "1225": {"vr": "TM", "Value": ["094547.731000"]},
        "1226": {"vr": "TM", "Value": ["094527.955000"]},
        "1227": {"vr": "TM", "Value": ["095427.773000"]},
        "1228": {"vr": "TM", "Value": ["095427.700000"]},
        "1229": {"vr": "TM", "Value": ["095207.611000"]},
        "1230": {"vr": "TM", "Value": ["095127.862000"]},
        "1231": {"vr": "TM", "Value": ["095347.776000"]},
        "1232": {"vr": "TM", "Value": ["095407.951000"]},
        "1233": {"vr": "TM", "Value": ["094747.731000"]},
        "1234": {"vr": "TM", "Value": ["094647.614000"]},
        "1235": {"vr": "TM", "Value": ["094827.740000"]},
        "1236": {"vr": "TM", "Value": ["094547.689000"]},
        "1237": {"vr": "TM", "Value": ["095447.814000"]},
        "1238": {"vr": "TM", "Value": ["094827.733000"]},
        "1239": {"vr": "TM", "Value": ["094707.692000"]},
        "1240": {"vr": "TM", "Value": ["094707.912000"]},
        "1241": {"vr": "TM", "Value": ["094527.857000"]},
        "1242": {"vr": "TM", "Value": ["095207.631000"]},
        "1243": {"vr": "TM", "Value": ["095247.763000"]},
        "1244": {"vr": "TM", "Value": ["095047.800000"]},
        "1245": {"vr": "TM", "Value": ["094907.619000"]},
        "1246": {"vr": "TM", "Value": ["095247.755000"]},
        "1247": {"vr": "TM", "Value": ["094747.662000"]},
        "1248": {"vr": "TM", "Value": ["095007.687000"]},
        "1249": {"vr": "TM", "Value": ["095347.779000"]},
        "1250": {"vr": "TM", "Value": ["094547.928000"]},
        "1251": {"vr": "TM", "Value": ["095127.934000"]},
        "1252": {"vr": "TM", "Value": ["095007.679000"]},
        "1253": {"vr": "TM", "Value": ["095327.909000"]},
        "1254": {"vr": "TM", "Value": ["094847.649000"]},
        "1255": {"vr": "TM", "Value": ["094847.887000"]},
        "1256": {"vr": "TM", "Value": ["095227.640000"]},
        "1257": {"vr": "TM", "Value": ["094527.916000"]},
        "1258": {"vr": "TM", "Value": ["094607.864000"]},
        "1259": {"vr": "TM", "Value": ["095307.611000"]},
        "1260": {"vr": "TM", "Value": ["095147.727000"]},
        "1261": {"vr": "TM", "Value": ["094647.732000"]},
        "1262": {"vr": "TM", "Value": ["094747.636000"]},
        "1263": {"vr": "TM", "Value": ["095147.910000"]},
        "1264": {"vr": "TM", "Value": ["094707.656000"]},
        "1265": {"vr": "TM", "Value": ["094727.665000"]},
        "1266": {"vr": "TM", "Value": ["094807.666000"]},
        "1267": {"vr": "TM", "Value": ["095047.759000"]},
        "1268": {"vr": "TM", "Value": ["095007.629000"]},
        "1269": {"vr": "TM", "Value": ["094607.812000"]},
        "1270": {"vr": "TM", "Value": ["094627.916000"]},
        "1271": {"vr": "TM", "Value": ["095456.495000"]},
        "1272": {"vr": "TM", "Value": ["094927.860000"]},
        "1273": {"vr": "TM", "Value": ["094727.723000"]},
        "1274": {"vr": "TM", "Value": ["095207.718000"]},
        "1275": {"vr": "TM", "Value": ["095307.639000"]},
        "1276": {"vr": "TM", "Value": ["095407.794000"]},
        "1277": {"vr": "TM", "Value": ["095427.743000"]},
        "1278": {"vr": "TM", "Value": ["094927.714000"]},
        "1279": {"vr": "TM", "Value": ["094907.730000"]},
        "1280": {"vr": "TM", "Value": ["094607.740000"]},
        "1281": {"vr": "TM", "Value": ["095207.793000"]},
        "1282": {"vr": "TM", "Value": ["094707.682000"]},
        "1283": {"vr": "TM", "Value": ["095207.749000"]},
        "1284": {"vr": "TM", "Value": ["095207.941000"]},
        "1285": {"vr": "TM", "Value": ["094907.837000"]},
        "1286": {"vr": "TM", "Value": ["094907.743000"]},
        "1287": {"vr": "TM", "Value": ["094907.916000"]},
        "1288": {"vr": "TM", "Value": ["094807.926000"]},
        "1289": {"vr": "TM", "Value": ["095247.682000"]},
        "1290": {"vr": "TM", "Value": ["094807.755000"]},
        "1291": {"vr": "TM", "Value": ["094527.692000"]},
        "1292": {"vr": "TM", "Value": ["094927.793000"]},
        "1293": {"vr": "TM", "Value": ["095027.608000"]},
        "1294": {"vr": "TM", "Value": ["095347.674000"]},
        "1295": {"vr": "TM", "Value": ["094927.923000"]},
        "1296": {"vr": "TM", "Value": ["094727.688000"]},
        "1297": {"vr": "TM", "Value": ["094707.917000"]},
        "1298": {"vr": "TM", "Value": ["094527.895000"]},
        "1299": {"vr": "TM", "Value": ["094627.868000"]},
        "1300": {"vr": "TM", "Value": ["095007.836000"]},
        "1301": {"vr": "TM", "Value": ["094947.834000"]},
        "1302": {"vr": "TM", "Value": ["094527.948000"]},
        "1303": {"vr": "TM", "Value": ["095407.664000"]},
        "1304": {"vr": "TM", "Value": ["094927.664000"]},
        "1305": {"vr": "TM", "Value": ["095007.703000"]},
        "1306": {"vr": "TM", "Value": ["094547.947000"]},
        "1307": {"vr": "TM", "Value": ["095307.897000"]},
        "1308": {"vr": "TM", "Value": ["094627.921000"]},
        "1309": {"vr": "TM", "Value": ["094647.922000"]},
        "1310": {"vr": "TM", "Value": ["094527.914000"]},
        "1311": {"vr": "TM", "Value": ["094947.848000"]},
        "1312": {"vr": "TM", "Value": ["095407.890000"]},
        "1313": {"vr": "TM", "Value": ["094947.617000"]},
        "1314": {"vr": "TM", "Value": ["094727.901000"]},
        "1315": {"vr": "TM", "Value": ["094527.928000"]},
        "1316": {"vr": "TM", "Value": ["095027.936000"]},
        "1317": {"vr": "TM", "Value": ["094907.644000"]},
        "1318": {"vr": "TM", "Value": ["094607.671000"]},
        "1319": {"vr": "TM", "Value": ["094647.620000"]},
        "1320": {"vr": "TM", "Value": ["095247.865000"]},
        "1321": {"vr": "TM", "Value": ["094947.855000"]},
        "1322": {"vr": "TM", "Value": ["094627.615000"]},
        "1323": {"vr": "TM", "Value": ["094747.890000"]},
        "1324": {"vr": "TM", "Value": ["094827.863000"]},
        "1325": {"vr": "TM", "Value": ["094547.652000"]},
        "1326": {"vr": "TM", "Value": ["094827.846000"]},
        "1327": {"vr": "TM", "Value": ["095407.837000"]},
        "1328": {"vr": "TM", "Value": ["094727.756000"]},
        "1329": {"vr": "TM", "Value": ["095147.905000"]},
        "1330": {"vr": "TM", "Value": ["095456.488000"]},
        "1331": {"vr": "TM", "Value": ["094927.669000"]},
        "1332": {"vr": "TM", "Value": ["095347.897000"]},
        "1333": {"vr": "TM", "Value": ["095327.794000"]},
        "1334": {"vr": "TM", "Value": ["095247.694000"]},
        "1335": {"vr": "TM", "Value": ["094747.938000"]},
        "1336": {"vr": "TM", "Value": ["095027.685000"]},
        "1337": {"vr": "TM", "Value": ["094727.828000"]},
        "1338": {"vr": "TM", "Value": ["094847.849000"]},
        "1339": {"vr": "TM", "Value": ["095227.781000"]},
        "1340": {"vr": "TM", "Value": ["094607.789000"]},
        "1341": {"vr": "TM", "Value": ["095427.647000"]},
        "1342": {"vr": "TM", "Value": ["094627.650000"]},
        "1343": {"vr": "TM", "Value": ["095247.832000"]},
        "1344": {"vr": "TM", "Value": ["094727.753000"]},
        "1345": {"vr": "TM", "Value": ["094727.792000"]},
        "1346": {"vr": "TM", "Value": ["094627.759000"]},
        "1347": {"vr": "TM", "Value": ["094527.747000"]},
        "1348": {"vr": "TM", "Value": ["095127.858000"]},
        "1349": {"vr": "TM", "Value": ["094627.761000"]},
        "1350": {"vr": "TM", "Value": ["095127.835000"]},
        "1351": {"vr": "TM", "Value": ["094607.618000"]},
        "1352": {"vr": "TM", "Value": ["095007.735000"]},
        "1353": {"vr": "TM", "Value": ["095247.806000"]},
        "1354": {"vr": "TM", "Value": ["095427.776000"]},
        "1355": {"vr": "TM", "Value": ["094827.717000"]},
        "1356": {"vr": "TM", "Value": ["094947.761000"]},
        "1357": {"vr": "TM", "Value": ["095027.926000"]},
        "1358": {"vr": "TM", "Value": ["094707.614000"]},
        "1359": {"vr": "TM", "Value": ["095407.700000"]},
        "1360": {"vr": "TM", "Value": ["095407.702000"]},
        "1361": {"vr": "TM", "Value": ["094607.856000"]},
        "1362": {"vr": "TM", "Value": ["094527.817000"]},
        "1363": {"vr": "TM", "Value": ["094707.866000"]},
        "1364": {"vr": "TM", "Value": ["094727.883000"]},
        "1365": {"vr": "TM", "Value": ["095047.713000"]},
        "1366": {"vr": "TM", "Value": ["094847.822000"]},
        "1367": {"vr": "TM", "Value": ["094607.695000"]},
        "1368": {"vr": "TM", "Value": ["094807.953000"]},
        "1369": {"vr": "TM", "Value": ["094847.685000"]},
        "1370": {"vr": "TM", "Value": ["094947.860000"]},
        "1371": {"vr": "TM", "Value": ["094627.861000"]},
        "1372": {"vr": "TM", "Value": ["094607.750000"]},
        "1373": {"vr": "TM", "Value": ["095227.617000"]},
        "1374": {"vr": "TM", "Value": ["095027.746000"]},
        "1375": {"vr": "TM", "Value": ["094827.936000"]},
        "1376": {"vr": "TM", "Value": ["094627.886000"]},
        "1377": {"vr": "TM", "Value": ["094647.678000"]},
        "1378": {"vr": "TM", "Value": ["095447.613000"]},
        "1379": {"vr": "TM", "Value": ["095447.768000"]},
        "1380": {"vr": "TM", "Value": ["095047.866000"]},
        "1381": {"vr": "TM", "Value": ["095327.726000"]},
        "1382": {"vr": "TM", "Value": ["095327.840000"]},
        "1383": {"vr": "TM", "Value": ["094727.926000"]},
        "1384": {"vr": "TM", "Value": ["094627.768000"]},
        "1385": {"vr": "TM", "Value": ["094847.940000"]},
        "1386": {"vr": "TM", "Value": ["095207.649000"]},
        "1387": {"vr": "TM", "Value": ["094847.892000"]},
        "1388": {"vr": "TM", "Value": ["095047.933000"]},
        "1389": {"vr": "TM", "Value": ["094627.665000"]},
        "1390": {"vr": "TM", "Value": ["094907.683000"]},
        "1391": {"vr": "TM", "Value": ["094527.810000"]},
        "1392": {"vr": "TM", "Value": ["095407.746000"]},
        "1393": {"vr": "TM", "Value": ["094847.920000"]},
        "1394": {"vr": "TM", "Value": ["095027.708000"]},
        "1395": {"vr": "TM", "Value": ["094927.921000"]},
        "1396": {"vr": "TM", "Value": ["095127.706000"]},
        "1397": {"vr": "TM", "Value": ["094947.680000"]},
        "1398": {"vr": "TM", "Value": ["094807.682000"]},
        "1399": {"vr": "TM", "Value": ["094827.808000"]},
        "1400": {"vr": "TM", "Value": ["095047.956000"]},
        "1401": {"vr": "TM", "Value": ["094747.778000"]},
        "1402": {"vr": "TM", "Value": ["095347.910000"]},
        "1403": {"vr": "TM", "Value": ["095007.725000"]},
        "1404": {"vr": "TM", "Value": ["094527.636000"]},
        "1405": {"vr": "TM", "Value": ["094547.667000"]},
        "1406": {"vr": "TM", "Value": ["094727.950000"]},
        "1407": {"vr": "TM", "Value": ["094707.884000"]},
        "1408": {"vr": "TM", "Value": ["094827.771000"]},
        "1409": {"vr": "TM", "Value": ["094727.627000"]},
        "1410": {"vr": "TM", "Value": ["095347.933000"]},
        "1411": {"vr": "TM", "Value": ["094647.657000"]},
        "1412": {"vr": "TM", "Value": ["095047.815000"]},
        "1413": {"vr": "TM", "Value": ["095327.775000"]},
        "1414": {"vr": "TM", "Value": ["095127.837000"]},
        "1415": {"vr": "TM", "Value": ["094547.791000"]},
        "1416": {"vr": "TM", "Value": ["094727.825000"]},
        "1417": {"vr": "TM", "Value": ["094647.933000"]},
        "1418": {"vr": "TM", "Value": ["095027.785000"]},
        "1419": {"vr": "TM", "Value": ["095347.827000"]},
        "1420": {"vr": "TM", "Value": ["095247.705000"]},
        "1421": {"vr": "TM", "Value": ["094727.868000"]},
        "1422": {"vr": "TM", "Value": ["095327.865000"]},
        "1423": {"vr": "TM", "Value": ["094947.747000"]},
        "1424": {"vr": "TM", "Value": ["095407.919000"]},
        "1425": {"vr": "TM", "Value": ["094907.663000"]},
        "1426": {"vr": "TM", "Value": ["095307.622000"]},
        "1427": {"vr": "TM", "Value": ["095227.714000"]},
        "1428": {"vr": "TM", "Value": ["094927.732000"]},
        "1429": {"vr": "TM", "Value": ["095347.641000"]},
        "1430": {"vr": "TM", "Value": ["095327.787000"]},
        "1431": {"vr": "TM", "Value": ["095427.926000"]},
        "1432": {"vr": "TM", "Value": ["094947.745000"]},
        "1433": {"vr": "TM", "Value": ["095247.640000"]},
        "1434": {"vr": "TM", "Value": ["095147.629000"]},
        "1435": {"vr": "TM", "Value": ["095047.772000"]},
        "1436": {"vr": "TM", "Value": ["095307.684000"]},
        "1437": {"vr": "TM", "Value": ["095127.895000"]},
        "1438": {"vr": "TM", "Value": ["094607.735000"]},
        "1439": {"vr": "TM", "Value": ["095027.705000"]},
        "1440": {"vr": "TM", "Value": ["095447.745000"]},
        "1441": {"vr": "TM", "Value": ["095047.610000"]},
        "1442": {"vr": "TM", "Value": ["094527.628000"]},
        "1443": {"vr": "TM", "Value": ["095447.690000"]},
        "1444": {"vr": "TM", "Value": ["095047.646000"]},
        "1445": {"vr": "TM", "Value": ["095407.720000"]},
        "1446": {"vr": "TM", "Value": ["095207.810000"]},
        "1447": {"vr": "TM", "Value": ["094747.842000"]},
        "1448": {"vr": "TM", "Value": ["094547.933000"]},
        "1449": {"vr": "TM", "Value": ["094647.931000"]},
        "1450": {"vr": "TM", "Value": ["094807.707000"]},
        "1451": {"vr": "TM", "Value": ["094947.687000"]},
        "1452": {"vr": "TM", "Value": ["094527.815000"]},
        "1453": {"vr": "TM", "Value": ["095207.836000"]},
        "1454": {"vr": "TM", "Value": ["095427.740000"]},
        "1455": {"vr": "TM", "Value": ["095456.500000"]},
        "1456": {"vr": "TM", "Value": ["095047.823000"]},
        "1457": {"vr": "TM", "Value": ["094707.792000"]},
        "1458": {"vr": "TM", "Value": ["095447.801000"]},
        "1459": {"vr": "TM", "Value": ["094627.637000"]},
        "1460": {"vr": "TM", "Value": ["095327.731000"]},
        "1461": {"vr": "TM", "Value": ["094707.644000"]},
        "1462": {"vr": "TM", "Value": ["094947.622000"]},
        "1463": {"vr": "TM", "Value": ["094927.891000"]},
        "1464": {"vr": "TM", "Value": ["095307.920000"]},
        "1465": {"vr": "TM", "Value": ["095107.824000"]},
        "1466": {"vr": "TM", "Value": ["094747.767000"]},
        "1467": {"vr": "TM", "Value": ["094727.685000"]},
        "1468": {"vr": "TM", "Value": ["095207.684000"]},
        "1469": {"vr": "TM", "Value": ["095407.766000"]},
        "1470": {"vr": "TM", "Value": ["095107.754000"]},
        "1471": {"vr": "TM", "Value": ["095327.819000"]},
        "1472": {"vr": "TM", "Value": ["094727.934000"]},
        "1473": {"vr": "TM", "Value": ["094747.649000"]},
        "1474": {"vr": "TM", "Value": ["095147.801000"]},
        "1475": {"vr": "TM", "Value": ["095327.896000"]},
        "1476": {"vr": "TM", "Value": ["094847.777000"]},
        "1477": {"vr": "TM", "Value": ["094547.888000"]},
        "1478": {"vr": "TM", "Value": ["094847.857000"]},
        "1479": {"vr": "TM", "Value": ["095127.758000"]},
        "1480": {"vr": "TM", "Value": ["095247.719000"]},
        "1481": {"vr": "TM", "Value": ["095307.850000"]},
        "1482": {"vr": "TM", "Value": ["095247.710000"]},
        "1483": {"vr": "TM", "Value": ["095227.906000"]},
        "1484": {"vr": "TM", "Value": ["095047.818000"]},
        "1485": {"vr": "TM", "Value": ["094907.824000"]},
        "1486": {"vr": "TM", "Value": ["094647.757000"]},
        "1487": {"vr": "TM", "Value": ["095447.625000"]},
        "1488": {"vr": "TM", "Value": ["095147.777000"]},
        "1489": {"vr": "TM", "Value": ["094927.618000"]},
        "1490": {"vr": "TM", "Value": ["095047.658000"]},
        "1491": {"vr": "TM", "Value": ["094807.905000"]},
        "1492": {"vr": "TM", "Value": ["095107.770000"]},
        "1493": {"vr": "TM", "Value": ["094707.607000"]},
        "1494": {"vr": "TM", "Value": ["095407.898000"]},
        "1495": {"vr": "TM", "Value": ["095207.621000"]},
        "1496": {"vr": "TM", "Value": ["095347.784000"]},
        "1497": {"vr": "TM", "Value": ["094707.914000"]},
        "1498": {"vr": "TM", "Value": ["094927.837000"]},
        "1499": {"vr": "TM", "Value": ["095347.789000"]},
        "1500": {"vr": "TM", "Value": ["095127.801000"]},
        "1501": {"vr": "TM", "Value": ["094747.695000"]},
        "1502": {"vr": "TM", "Value": ["095107.805000"]},
        "1503": {"vr": "TM", "Value": ["095327.899000"]},
        "1504": {"vr": "TM", "Value": ["095107.878000"]},
        "1505": {"vr": "TM", "Value": ["094807.712000"]},
        "1506": {"vr": "TM", "Value": ["094927.613000"]},
        "1507": {"vr": "TM", "Value": ["094807.668000"]},
        "1508": {"vr": "TM", "Value": ["094607.869000"]},
        "1509": {"vr": "TM", "Value": ["094707.702000"]},
        "1510": {"vr": "TM", "Value": ["095127.877000"]},
        "1511": {"vr": "TM", "Value": ["095327.817000"]},
        "1512": {"vr": "TM", "Value": ["095147.796000"]},
        "1513": {"vr": "TM", "Value": ["094547.874000"]},
        "1514": {"vr": "TM", "Value": ["094727.813000"]},
        "1515": {"vr": "TM", "Value": ["094527.649000"]},
        "1516": {"vr": "TM", "Value": ["094527.970000"]},
        "1517": {"vr": "TM", "Value": ["095327.767000"]},
        "1518": {"vr": "TM", "Value": ["095307.689000"]},
        "1519": {"vr": "TM", "Value": ["095027.829000"]},
        "1520": {"vr": "TM", "Value": ["094847.722000"]},
        "1521": {"vr": "TM", "Value": ["095327.656000"]},
        "1522": {"vr": "TM", "Value": ["094807.679000"]},
        "1523": {"vr": "TM", "Value": ["094847.748000"]},
        "1524": {"vr": "TM", "Value": ["094927.776000"]},
        "1525": {"vr": "TM", "Value": ["094627.822000"]},
        "1526": {"vr": "TM", "Value": ["094747.607000"]},
        "1527": {"vr": "TM", "Value": ["095247.904000"]},
        "1528": {"vr": "TM", "Value": ["094547.637000"]},
        "1529": {"vr": "TM", "Value": ["094907.871000"]},
        "1530": {"vr": "TM", "Value": ["095227.885000"]},
        "1531": {"vr": "TM", "Value": ["094947.670000"]},
        "1532": {"vr": "TM", "Value": ["095407.917000"]},
        "1533": {"vr": "TM", "Value": ["094747.715000"]},
        "1534": {"vr": "TM", "Value": ["094847.862000"]},
        "1535": {"vr": "TM", "Value": ["094727.830000"]},
        "1536": {"vr": "TM", "Value": ["095007.822000"]},
        "1537": {"vr": "TM", "Value": ["094607.613000"]},
        "1538": {"vr": "TM", "Value": ["094547.913000"]},
        "1539": {"vr": "TM", "Value": ["094647.799000"]},
        "1540": {"vr": "TM", "Value": ["095027.757000"]},
        "1541": {"vr": "TM", "Value": ["095047.757000"]},
        "1542": {"vr": "TM", "Value": ["094747.884000"]},
        "1543": {"vr": "TM", "Value": ["094847.835000"]},
        "1544": {"vr": "TM", "Value": ["095007.771000"]},
        "1545": {"vr": "TM", "Value": ["094947.694000"]},
        "1546": {"vr": "TM", "Value": ["095047.958000"]},
        "1547": {"vr": "TM", "Value": ["095047.653000"]},
        "1548": {"vr": "TM", "Value": ["095027.715000"]},
        "1549": {"vr": "TM", "Value": ["094907.853000"]},
        "1550": {"vr": "TM", "Value": ["094807.814000"]},
        "1551": {"vr": "TM", "Value": ["094827.667000"]},
        "1552": {"vr": "TM", "Value": ["094907.723000"]},
        "1553": {"vr": "TM", "Value": ["094647.972000"]},
        "1554": {"vr": "TM", "Value": ["095007.654000"]},
        "1555": {"vr": "TM", "Value": ["094527.724000"]},
        "1556": {"vr": "TM", "Value": ["095107.679000"]},
        "1557": {"vr": "TM", "Value": ["094947.872000"]},
        "1558": {"vr": "TM", "Value": ["094927.694000"]},
        "1559": {"vr": "TM", "Value": ["095147.755000"]},
        "1560": {"vr": "TM", "Value": ["095427.853000"]},
        "1561": {"vr": "TM", "Value": ["095027.654000"]},
        "1562": {"vr": "TM", "Value": ["095327.677000"]},
        "1563": {"vr": "TM", "Value": ["094727.944000"]},
        "1564": {"vr": "TM", "Value": ["094747.682000"]},
        "1565": {"vr": "TM", "Value": ["094627.754000"]},
        "1566": {"vr": "TM", "Value": ["095027.892000"]},
        "1567": {"vr": "TM", "Value": ["094807.902000"]},
        "1568": {"vr": "TM", "Value": ["095027.733000"]},
        "1569": {"vr": "TM", "Value": ["095327.941000"]},
        "1570": {"vr": "TM", "Value": ["095107.812000"]},
        "1571": {"vr": "TM", "Value": ["094547.744000"]},
        "1572": {"vr": "TM", "Value": ["094847.870000"]},
        "1573": {"vr": "TM", "Value": ["095047.868000"]},
        "1574": {"vr": "TM", "Value": ["095007.843000"]},
        "1575": {"vr": "TM", "Value": ["095107.789000"]},
        "1576": {"vr": "TM", "Value": ["094647.705000"]},
        "1577": {"vr": "TM", "Value": ["095127.739000"]},
        "1578": {"vr": "TM", "Value": ["095447.752000"]},
        "1579": {"vr": "TM", "Value": ["095447.770000"]},
        "1580": {"vr": "TM", "Value": ["095207.910000"]},
        "1581": {"vr": "TM", "Value": ["094927.896000"]},
        "1582": {"vr": "TM", "Value": ["095227.878000"]},
        "1583": {"vr": "TM", "Value": ["095107.618000"]},
        "1584": {"vr": "TM", "Value": ["094727.823000"]},
        "1585": {"vr": "TM", "Value": ["095347.748000"]},
        "1586": {"vr": "TM", "Value": ["095247.910000"]},
        "1587": {"vr": "TM", "Value": ["095107.625000"]},
        "1588": {"vr": "TM", "Value": ["095147.689000"]},
        "1589": {"vr": "TM", "Value": ["094707.851000"]},
        "1590": {"vr": "TM", "Value": ["094847.634000"]},
        "1591": {"vr": "TM", "Value": ["094727.916000"]},
        "1592": {"vr": "TM", "Value": ["095347.664000"]},
        "1593": {"vr": "TM", "Value": ["095047.774000"]},
        "1594": {"vr": "TM", "Value": ["095327.701000"]},
        "1595": {"vr": "TM", "Value": ["095427.802000"]},
        "1596": {"vr": "TM", "Value": ["094607.817000"]},
        "1597": {"vr": "TM", "Value": ["094927.812000"]},
        "1598": {"vr": "TM", "Value": ["095407.642000"]},
        "1599": {"vr": "TM", "Value": ["095227.655000"]},
        "1600": {"vr": "TM", "Value": ["095147.775000"]},
        "1601": {"vr": "TM", "Value": ["094527.764000"]},
        "1602": {"vr": "TM", "Value": ["095407.789000"]},
        "1603": {"vr": "TM", "Value": ["095456.455000"]},
        "1604": {"vr": "TM", "Value": ["094707.671000"]},
        "1605": {"vr": "TM", "Value": ["095107.850000"]},
        "1606": {"vr": "TM", "Value": ["095427.897000"]},
        "1607": {"vr": "TM", "Value": ["094847.756000"]},
        "1608": {"vr": "TM", "Value": ["095307.861000"]},
        "1609": {"vr": "TM", "Value": ["094947.609000"]},
        "1610": {"vr": "TM", "Value": ["095007.901000"]},
        "1611": {"vr": "TM", "Value": ["095247.736000"]},
        "1612": {"vr": "TM", "Value": ["094947.803000"]},
        "1613": {"vr": "TM", "Value": ["095247.794000"]},
        "1614": {"vr": "TM", "Value": ["094727.909000"]},
        "1615": {"vr": "TM", "Value": ["095307.681000"]},
        "1616": {"vr": "TM", "Value": ["094727.838000"]},
        "1617": {"vr": "TM", "Value": ["095007.710000"]},
        "1618": {"vr": "TM", "Value": ["094947.891000"]},
        "1619": {"vr": "TM", "Value": ["094547.702000"]},
        "1620": {"vr": "TM", "Value": ["094727.735000"]},
        "1621": {"vr": "TM", "Value": ["095007.639000"]},
        "1622": {"vr": "TM", "Value": ["095127.855000"]},
        "1623": {"vr": "TM", "Value": ["094947.782000"]},
        "1624": {"vr": "TM", "Value": ["095407.797000"]},
        "1625": {"vr": "TM", "Value": ["094827.875000"]},
        "1626": {"vr": "TM", "Value": ["095027.929000"]},
        "1627": {"vr": "TM", "Value": ["094847.695000"]},
        "1628": {"vr": "TM", "Value": ["095047.648000"]},
        "1629": {"vr": "TM", "Value": ["095247.696000"]},
        "1630": {"vr": "TM", "Value": ["095447.701000"]},
        "1631": {"vr": "TM", "Value": ["094707.712000"]},
        "1632": {"vr": "TM", "Value": ["095147.644000"]},
        "1633": {"vr": "TM", "Value": ["095047.630000"]},
        "1634": {"vr": "TM", "Value": ["094547.758000"]},
        "1635": {"vr": "TM", "Value": ["095227.724000"]},
        "1636": {"vr": "TM", "Value": ["094607.786000"]},
        "1637": {"vr": "TM", "Value": ["095207.679000"]},
        "1638": {"vr": "TM", "Value": ["094907.921000"]},
        "1639": {"vr": "TM", "Value": ["095327.855000"]},
        "1640": {"vr": "TM", "Value": ["094647.886000"]},
        "1641": {"vr": "TM", "Value": ["095447.940000"]},
        "1642": {"vr": "TM", "Value": ["094547.644000"]},
        "1643": {"vr": "TM", "Value": ["095456.481000"]},
        "1644": {"vr": "TM", "Value": ["095007.815000"]},
        "1645": {"vr": "TM", "Value": ["095407.710000"]},
        "1646": {"vr": "TM", "Value": ["095247.633000"]},
        "1647": {"vr": "TM", "Value": ["095347.656000"]},
        "1648": {"vr": "TM", "Value": ["094747.679000"]},
        "1649": {"vr": "TM", "Value": ["094827.952000"]},
        "1650": {"vr": "TM", "Value": ["095007.705000"]},
        "1651": {"vr": "TM", "Value": ["095247.860000"]},
        "1652": {"vr": "TM", "Value": ["094927.625000"]},
        "1653": {"vr": "TM", "Value": ["094947.754000"]},
        "1654": {"vr": "TM", "Value": ["094807.638000"]},
        "1655": {"vr": "TM", "Value": ["095147.869000"]},
        "1656": {"vr": "TM", "Value": ["094947.714000"]},
        "1657": {"vr": "TM", "Value": ["095147.715000"]},
        "1658": {"vr": "TM", "Value": ["095227.676000"]},
        "1659": {"vr": "TM", "Value": ["094907.745000"]},
        "1660": {"vr": "TM", "Value": ["095127.798000"]},
        "1661": {"vr": "TM", "Value": ["094527.837000"]},
        "1662": {"vr": "TM", "Value": ["095107.774000"]},
        "1663": {"vr": "TM", "Value": ["094827.704000"]},
        "1664": {"vr": "TM", "Value": ["095307.766000"]},
        "1665": {"vr": "TM", "Value": ["095227.778000"]},
        "1666": {"vr": "TM", "Value": ["094927.692000"]},
        "1667": {"vr": "TM", "Value": ["095227.927000"]},
        "1668": {"vr": "TM", "Value": ["094707.815000"]},
        "1669": {"vr": "TM", "Value": ["095247.661000"]},
        "1670": {"vr": "TM", "Value": ["094927.745000"]},
        "1671": {"vr": "TM", "Value": ["095147.707000"]},
        "1672": {"vr": "TM", "Value": ["094607.825000"]},
        "1673": {"vr": "TM", "Value": ["094827.725000"]},
        "1674": {"vr": "TM", "Value": ["095027.882000"]},
        "1675": {"vr": "TM", "Value": ["094747.701000"]},
        "1676": {"vr": "TM", "Value": ["094527.996000"]},
        "1677": {"vr": "TM", "Value": ["095427.703000"]},
        "1678": {"vr": "TM", "Value": ["094847.806000"]},
        "1679": {"vr": "TM", "Value": ["094907.892000"]},
        "1680": {"vr": "TM", "Value": ["095247.623000"]},
        "1681": {"vr": "TM", "Value": ["094647.746000"]},
        "1682": {"vr": "TM", "Value": ["095227.686000"]},
        "1683": {"vr": "TM", "Value": ["095127.906000"]},
        "1684": {"vr": "TM", "Value": ["095407.613000"]},
        "1685": {"vr": "TM", "Value": ["095307.699000"]},
        "1686": {"vr": "TM", "Value": ["094547.630000"]},
        "1687": {"vr": "TM", "Value": ["095207.767000"]},
        "1688": {"vr": "TM", "Value": ["094807.873000"]},
        "1689": {"vr": "TM", "Value": ["094827.858000"]},
        "1690": {"vr": "TM", "Value": ["095027.885000"]},
        "1691": {"vr": "TM", "Value": ["095327.714000"]},
        "1692": {"vr": "TM", "Value": ["094847.659000"]},
        "1693": {"vr": "TM", "Value": ["094907.631000"]},
        "1694": {"vr": "TM", "Value": ["095307.881000"]},
        "1695": {"vr": "TM", "Value": ["094727.733000"]},
        "1696": {"vr": "TM", "Value": ["094547.771000"]},
        "1697": {"vr": "TM", "Value": ["095047.751000"]},
        "1698": {"vr": "TM", "Value": ["095427.781000"]},
        "1699": {"vr": "TM", "Value": ["095047.895000"]},
        "1700": {"vr": "TM", "Value": ["094527.686000"]},
        "1701": {"vr": "TM", "Value": ["095307.815000"]},
        "1702": {"vr": "TM", "Value": ["094727.657000"]},
        "1703": {"vr": "TM", "Value": ["094547.857000"]},
        "1704": {"vr": "TM", "Value": ["095407.781000"]},
        "1705": {"vr": "TM", "Value": ["094547.768000"]},
        "1706": {"vr": "TM", "Value": ["094547.784000"]},
        "1707": {"vr": "TM", "Value": ["094847.639000"]},
        "1708": {"vr": "TM", "Value": ["095227.834000"]},
        "1709": {"vr": "TM", "Value": ["095027.749000"]},
        "1710": {"vr": "TM", "Value": ["094927.722000"]},
        "1711": {"vr": "TM", "Value": ["094547.699000"]},
        "1712": {"vr": "TM", "Value": ["095207.641000"]},
        "1713": {"vr": "TM", "Value": ["094747.781000"]},
        "1714": {"vr": "TM", "Value": ["095407.832000"]},
        "1715": {"vr": "TM", "Value": ["095247.853000"]},
        "1716": {"vr": "TM", "Value": ["094607.933000"]},
        "1717": {"vr": "TM", "Value": ["094647.918000"]},
        "1718": {"vr": "TM", "Value": ["094947.898000"]},
        "1719": {"vr": "TM", "Value": ["095427.710000"]},
        "1720": {"vr": "TM", "Value": ["095456.553000"]},
        "1721": {"vr": "TM", "Value": ["095407.872000"]},
        "1722": {"vr": "TM", "Value": ["094747.623000"]},
        "1723": {"vr": "TM", "Value": ["095427.786000"]},
        "1724": {"vr": "TM", "Value": ["095307.651000"]},
        "1725": {"vr": "TM", "Value": ["094747.856000"]},
        "1726": {"vr": "TM", "Value": ["095407.611000"]},
        "1727": {"vr": "TM", "Value": ["094927.786000"]},
        "1728": {"vr": "TM", "Value": ["094747.970000"]},
        "1729": {"vr": "TM", "Value": ["095007.756000"]},
        "1730": {"vr": "TM", "Value": ["094547.776000"]},
        "1731": {"vr": "TM", "Value": ["094847.798000"]},
        "1732": {"vr": "TM", "Value": ["094547.647000"]},
        "1733": {"vr": "TM", "Value": ["094527.834000"]},
        "1734": {"vr": "TM", "Value": ["095407.819000"]},
        "1735": {"vr": "TM", "Value": ["095307.902000"]},
        "1736": {"vr": "TM", "Value": ["094827.917000"]},
        "1737": {"vr": "TM", "Value": ["094707.887000"]},
        "1738": {"vr": "TM", "Value": ["095147.782000"]},
        "1739": {"vr": "TM", "Value": ["094847.877000"]},
        "1740": {"vr": "TM", "Value": ["095407.784000"]},
        "1741": {"vr": "TM", "Value": ["094807.702000"]},
        "1742": {"vr": "TM", "Value": ["094627.911000"]},
        "1743": {"vr": "TM", "Value": ["094747.832000"]},
        "1744": {"vr": "TM", "Value": ["095147.634000"]},
        "1745": {"vr": "TM", "Value": ["095107.868000"]},
        "1746": {"vr": "TM", "Value": ["095247.848000"]},
        "1747": {"vr": "TM", "Value": ["095107.611000"]},
        "1748": {"vr": "TM", "Value": ["095227.763000"]},
        "1749": {"vr": "TM", "Value": ["095307.858000"]},
        "1750": {"vr": "TM", "Value": ["095427.907000"]},
        "1751": {"vr": "TM", "Value": ["095447.740000"]},
        "1752": {"vr": "TM", "Value": ["094627.647000"]},
        "1753": {"vr": "TM", "Value": ["094747.745000"]},
        "1754": {"vr": "TM", "Value": ["094947.841000"]},
        "1755": {"vr": "TM", "Value": ["095147.620000"]},
        "1756": {"vr": "TM", "Value": ["094747.827000"]},
        "1757": {"vr": "TM", "Value": ["095127.840000"]},
        "1758": {"vr": "TM", "Value": ["094527.842000"]},
        "1759": {"vr": "TM", "Value": ["094547.620000"]},
        "1760": {"vr": "TM", "Value": ["095127.848000"]},
        "1761": {"vr": "TM", "Value": ["094547.931000"]},
        "1762": {"vr": "TM", "Value": ["094527.823000"]},
        "1763": {"vr": "TM", "Value": ["094607.836000"]},
        "1764": {"vr": "TM", "Value": ["094947.629000"]},
        "1765": {"vr": "TM", "Value": ["094647.907000"]},
        "1766": {"vr": "TM", "Value": ["094847.732000"]},
        "1767": {"vr": "TM", "Value": ["094907.626000"]},
        "1768": {"vr": "TM", "Value": ["094907.701000"]},
        "1769": {"vr": "TM", "Value": ["094527.807000"]},
        "1770": {"vr": "TM", "Value": ["095127.909000"]},
        "1771": {"vr": "TM", "Value": ["094947.749000"]},
        "1772": {"vr": "TM", "Value": ["094947.865000"]},
        "1773": {"vr": "TM", "Value": ["095407.738000"]},
        "1774": {"vr": "TM", "Value": ["094607.646000"]},
        "1775": {"vr": "TM", "Value": ["094647.948000"]},
        "1776": {"vr": "TM", "Value": ["095447.747000"]},
        "1777": {"vr": "TM", "Value": ["094747.762000"]},
        "1778": {"vr": "TM", "Value": ["094747.924000"]},
        "1779": {"vr": "TM", "Value": ["095247.881000"]},
        "1780": {"vr": "TM", "Value": ["094807.929000"]},
        "1781": {"vr": "TM", "Value": ["095307.644000"]},
        "1782": {"vr": "TM", "Value": ["094707.871000"]},
        "1783": {"vr": "TM", "Value": ["094747.785000"]},
        "1784": {"vr": "TM", "Value": ["095247.618000"]},
        "1785": {"vr": "TM", "Value": ["094847.890000"]},
        "1786": {"vr": "TM", "Value": ["095147.875000"]},
        "1787": {"vr": "TM", "Value": ["095447.891000"]},
        "1788": {"vr": "TM", "Value": ["094807.699000"]},
        "1789": {"vr": "TM", "Value": ["095247.673000"]},
        "1790": {"vr": "TM", "Value": ["094727.730000"]},
        "1791": {"vr": "TM", "Value": ["094647.633000"]},
        "1792": {"vr": "TM", "Value": ["095027.916000"]},
        "1793": {"vr": "TM", "Value": ["094947.677000"]},
        "1794": {"vr": "TM", "Value": ["094947.632000"]},
        "1795": {"vr": "TM", "Value": ["094747.651000"]},
        "1796": {"vr": "TM", "Value": ["094527.671000"]},
        "1797": {"vr": "TM", "Value": ["095047.846000"]},
        "1798": {"vr": "TM", "Value": ["094727.613000"]},
        "1799": {"vr": "TM", "Value": ["095107.831000"]},
        "1800": {"vr": "TM", "Value": ["095127.666000"]},
        "1801": {"vr": "TM", "Value": ["095347.636000"]},
        "1802": {"vr": "TM", "Value": ["094827.861000"]},
        "1803": {"vr": "TM", "Value": ["095427.755000"]},
        "1804": {"vr": "TM", "Value": ["095427.760000"]},
        "1805": {"vr": "TM", "Value": ["095456.531000"]},
        "1806": {"vr": "TM", "Value": ["094607.890000"]},
        "1807": {"vr": "TM", "Value": ["095427.640000"]},
        "1808": {"vr": "TM", "Value": ["095247.727000"]},
        "1809": {"vr": "TM", "Value": ["094747.764000"]},
        "1810": {"vr": "TM", "Value": ["095047.926000"]},
        "1811": {"vr": "TM", "Value": ["094947.794000"]},
        "1812": {"vr": "TM", "Value": ["094907.688000"]},
        "1813": {"vr": "TM", "Value": ["094847.837000"]},
        "1814": {"vr": "TM", "Value": ["095327.623000"]},
        "1815": {"vr": "TM", "Value": ["095427.946000"]},
        "1816": {"vr": "TM", "Value": ["095027.880000"]},
        "1817": {"vr": "TM", "Value": ["095047.938000"]},
        "1818": {"vr": "TM", "Value": ["095047.643000"]},
        "1819": {"vr": "TM", "Value": ["094927.845000"]},
        "1820": {"vr": "TM", "Value": ["094847.656000"]},
        "1821": {"vr": "TM", "Value": ["095147.717000"]},
        "1822": {"vr": "TM", "Value": ["095247.811000"]},
        "1823": {"vr": "TM", "Value": ["095147.697000"]},
        "1824": {"vr": "TM", "Value": ["094727.873000"]},
        "1825": {"vr": "TM", "Value": ["095107.622000"]},
        "1826": {"vr": "TM", "Value": ["094747.853000"]},
        "1827": {"vr": "TM", "Value": ["095327.779000"]},
        "1828": {"vr": "TM", "Value": ["094907.890000"]},
        "1829": {"vr": "TM", "Value": ["094627.625000"]},
        "1830": {"vr": "TM", "Value": ["094747.646000"]},
        "1831": {"vr": "TM", "Value": ["095047.918000"]},
        "1832": {"vr": "TM", "Value": ["094907.661000"]},
        "1833": {"vr": "TM", "Value": ["095027.923000"]},
        "1834": {"vr": "TM", "Value": ["094707.950000"]},
        "1835": {"vr": "TM", "Value": ["095027.790000"]},
        "1836": {"vr": "TM", "Value": ["095127.793000"]},
        "1837": {"vr": "TM", "Value": ["094847.619000"]},
        "1838": {"vr": "TM", "Value": ["095327.799000"]},
        "1839": {"vr": "TM", "Value": ["095227.822000"]},
        "1840": {"vr": "TM", "Value": ["094607.742000"]},
        "1841": {"vr": "TM", "Value": ["095107.691000"]},
        "1842": {"vr": "TM", "Value": ["094947.792000"]},
        "1843": {"vr": "TM", "Value": ["094707.904000"]},
        "1844": {"vr": "TM", "Value": ["095127.888000"]},
        "1845": {"vr": "TM", "Value": ["094827.842000"]},
        "1846": {"vr": "TM", "Value": ["094827.625000"]},
        "1847": {"vr": "TM", "Value": ["094807.878000"]},
        "1848": {"vr": "TM", "Value": ["095007.682000"]},
        "1849": {"vr": "TM", "Value": ["095247.724000"]},
        "1850": {"vr": "TM", "Value": ["095027.764000"]},
        "1851": {"vr": "TM", "Value": ["095247.741000"]},
        "1852": {"vr": "TM", "Value": ["095127.671000"]},
        "1853": {"vr": "TM", "Value": ["094527.885000"]},
        "1854": {"vr": "TM", "Value": ["094627.889000"]},
        "1855": {"vr": "TM", "Value": ["094947.913000"]},
        "1856": {"vr": "TM", "Value": ["094647.774000"]},
        "1857": {"vr": "TM", "Value": ["095427.845000"]},
        "1858": {"vr": "TM", "Value": ["094827.805000"]},
        "1859": {"vr": "TM", "Value": ["094647.777000"]},
        "1860": {"vr": "TM", "Value": ["095047.828000"]},
        "1861": {"vr": "TM", "Value": ["095107.708000"]},
        "1862": {"vr": "TM", "Value": ["094747.625000"]},
        "1863": {"vr": "TM", "Value": ["095327.858000"]},
        "1864": {"vr": "TM", "Value": ["094607.877000"]},
        "1865": {"vr": "TM", "Value": ["095007.766000"]},
        "1866": {"vr": "TM", "Value": ["095047.820000"]},
        "1867": {"vr": "TM", "Value": ["095107.928000"]},
        "1868": {"vr": "TM", "Value": ["095447.881000"]},
        "1869": {"vr": "TM", "Value": ["095207.788000"]},
        "1870": {"vr": "TM", "Value": ["094607.639000"]},
        "1871": {"vr": "TM", "Value": ["095227.678000"]},
        "1872": {"vr": "TM", "Value": ["095456.517000"]},
        "1873": {"vr": "TM", "Value": ["094527.702000"]},
        "1874": {"vr": "TM", "Value": ["094747.793000"]},
        "1875": {"vr": "TM", "Value": ["095427.837000"]},
        "1876": {"vr": "TM", "Value": ["094607.921000"]},
        "1877": {"vr": "TM", "Value": ["094627.800000"]},
        "1878": {"vr": "TM", "Value": ["095447.871000"]},
        "1879": {"vr": "TM", "Value": ["094827.745000"]},
        "1880": {"vr": "TM", "Value": ["094747.887000"]},
        "1881": {"vr": "TM", "Value": ["095247.734000"]},
        "1882": {"vr": "TM", "Value": ["094927.881000"]},
        "1883": {"vr": "TM", "Value": ["094547.852000"]},
        "1884": {"vr": "TM", "Value": ["094807.750000"]},
        "1885": {"vr": "TM", "Value": ["095427.680000"]},
        "1886": {"vr": "TM", "Value": ["095027.611000"]},
        "1887": {"vr": "TM", "Value": ["095307.620000"]},
        "1888": {"vr": "TM", "Value": ["095427.889000"]},
        "1889": {"vr": "TM", "Value": ["095327.684000"]},
        "1890": {"vr": "TM", "Value": ["095107.675000"]},
        "1891": {"vr": "TM", "Value": ["095047.613000"]},
        "1892": {"vr": "TM", "Value": ["095407.654000"]},
        "1893": {"vr": "TM", "Value": ["094547.867000"]},
        "1894": {"vr": "TM", "Value": ["095407.896000"]},
        "1895": {"vr": "TM", "Value": ["095407.658000"]},
        "1896": {"vr": "TM", "Value": ["095207.651000"]},
        "1897": {"vr": "TM", "Value": ["094807.656000"]},
        "1898": {"vr": "TM", "Value": ["095447.791000"]},
        "1899": {"vr": "TM", "Value": ["094547.837000"]},
        "1900": {"vr": "TM", "Value": ["094707.695000"]},
        "1901": {"vr": "TM", "Value": ["095407.850000"]},
        "1902": {"vr": "TM", "Value": ["094907.609000"]},
        "1903": {"vr": "TM", "Value": ["094747.882000"]},
        "1904": {"vr": "TM", "Value": ["094927.620000"]},
        "1905": {"vr": "TM", "Value": ["095247.649000"]},
        "1906": {"vr": "TM", "Value": ["094847.709000"]},
        "1907": {"vr": "TM", "Value": ["094907.611000"]},
        "1908": {"vr": "TM", "Value": ["094907.949000"]},
        "1909": {"vr": "TM", "Value": ["095327.770000"]},
        "1910": {"vr": "TM", "Value": ["094747.801000"]},
        "1911": {"vr": "TM", "Value": ["094607.848000"]},
        "1912": {"vr": "TM", "Value": ["094627.876000"]},
        "1913": {"vr": "TM", "Value": ["095247.846000"]},
        "1914": {"vr": "TM", "Value": ["095327.760000"]},
        "1915": {"vr": "TM", "Value": ["094527.761000"]},
        "1916": {"vr": "TM", "Value": ["095007.894000"]},
        "1917": {"vr": "TM", "Value": ["095247.611000"]},
        "1918": {"vr": "TM", "Value": ["095007.868000"]},
        "1919": {"vr": "TM", "Value": ["095447.879000"]},
        "1920": {"vr": "TM", "Value": ["094827.919000"]},
        "1921": {"vr": "TM", "Value": ["094847.955000"]},
        "1922": {"vr": "TM", "Value": ["094927.763000"]},
        "1923": {"vr": "TM", "Value": ["094927.671000"]},
        "1924": {"vr": "TM", "Value": ["094547.916000"]},
        "1925": {"vr": "TM", "Value": ["094807.819000"]},
        "1926": {"vr": "TM", "Value": ["095327.635000"]},
        "1927": {"vr": "TM", "Value": ["094927.778000"]},
        "1928": {"vr": "TM", "Value": ["094807.783000"]},
        "1929": {"vr": "TM", "Value": ["094947.836000"]},
        "1930": {"vr": "TM", "Value": ["095227.799000"]},
        "1931": {"vr": "TM", "Value": ["094907.926000"]},
        "1932": {"vr": "TM", "Value": ["095347.633000"]},
        "1933": {"vr": "TM", "Value": ["095147.830000"]},
        "1934": {"vr": "TM", "Value": ["094627.617000"]},
        "1935": {"vr": "TM", "Value": ["095347.756000"]},
        "1936": {"vr": "TM", "Value": ["094647.902000"]},
        "1937": {"vr": "TM", "Value": ["095227.768000"]},
        "1938": {"vr": "TM", "Value": ["095347.879000"]},
        "1939": {"vr": "TM", "Value": ["094947.682000"]},
        "1940": {"vr": "TM", "Value": ["094827.678000"]},
        "1941": {"vr": "TM", "Value": ["094847.677000"]},
        "1942": {"vr": "TM", "Value": ["095127.723000"]},
        "1943": {"vr": "TM", "Value": ["094627.803000"]},
        "1944": {"vr": "TM", "Value": ["095127.732000"]},
        "1945": {"vr": "TM", "Value": ["095207.616000"]},
        "1946": {"vr": "TM", "Value": ["094907.614000"]},
        "1947": {"vr": "TM", "Value": ["094907.708000"]},
        "1948": {"vr": "TM", "Value": ["095347.761000"]},
        "1949": {"vr": "TM", "Value": ["094707.647000"]},
        "1950": {"vr": "TM", "Value": ["095227.796000"]},
        "1951": {"vr": "TM", "Value": ["095107.608000"]},
        "1952": {"vr": "TM", "Value": ["095127.760000"]},
        "1953": {"vr": "TM", "Value": ["094947.799000"]},
        "1954": {"vr": "TM", "Value": ["094607.631000"]},
        "1955": {"vr": "TM", "Value": ["094727.696000"]},
        "1956": {"vr": "TM", "Value": ["095247.789000"]},
        "1957": {"vr": "TM", "Value": ["095027.780000"]},
        "1958": {"vr": "TM", "Value": ["095127.751000"]},
        "1959": {"vr": "TM", "Value": ["094947.701000"]},
        "1960": {"vr": "TM", "Value": ["094827.673000"]},
        "1961": {"vr": "TM", "Value": ["094527.652000"]},
        "1962": {"vr": "TM", "Value": ["095207.775000"]},
        "1963": {"vr": "TM", "Value": ["095127.875000"]},
        "1964": {"vr": "TM", "Value": ["095007.728000"]},
        "1965": {"vr": "TM", "Value": ["094907.696000"]},
        "1966": {"vr": "TM", "Value": ["095227.673000"]},
        "1967": {"vr": "TM", "Value": ["095456.485000"]},
        "1968": {"vr": "TM", "Value": ["095147.647000"]},
        "1969": {"vr": "TM", "Value": ["095447.709000"]},
        "1970": {"vr": "TM", "Value": ["094807.621000"]},
        "1971": {"vr": "TM", "Value": ["094847.911000"]},
        "1972": {"vr": "TM", "Value": ["095027.687000"]},
        "1973": {"vr": "TM", "Value": ["095456.420000"]},
        "1974": {"vr": "TM", "Value": ["094807.870000"]},
        "1975": {"vr": "TM", "Value": ["095307.786000"]},
        "1976": {"vr": "TM", "Value": ["094607.616000"]},
        "1977": {"vr": "TM", "Value": ["095027.695000"]},
        "1978": {"vr": "TM", "Value": ["094647.854000"]},
        "1979": {"vr": "TM", "Value": ["095227.645000"]},
        "1980": {"vr": "TM", "Value": ["094847.795000"]},
        "1981": {"vr": "TM", "Value": ["095107.793000"]},
        "1982": {"vr": "TM", "Value": ["095247.717000"]},
        "1983": {"vr": "TM", "Value": ["095027.641000"]},
        "1984": {"vr": "TM", "Value": ["094627.901000"]},
        "1985": {"vr": "TM", "Value": ["095027.634000"]},
        "1986": {"vr": "TM", "Value": ["095327.806000"]},
        "1987": {"vr": "TM", "Value": ["095427.954000"]},
        "1988": {"vr": "TM", "Value": ["094547.724000"]},
        "1989": {"vr": "TM", "Value": ["095027.657000"]},
        "1990": {"vr": "TM", "Value": ["095227.758000"]},
        "1991": {"vr": "TM", "Value": ["094927.835000"]},
        "1992": {"vr": "TM", "Value": ["094747.922000"]},
        "1993": {"vr": "TM", "Value": ["095007.887000"]},
        "1994": {"vr": "TM", "Value": ["095407.639000"]},
        "1995": {"vr": "TM", "Value": ["095427.645000"]},
        "1996": {"vr": "TM", "Value": ["095007.800000"]},
        "1997": {"vr": "TM", "Value": ["094607.718000"]},
        "1998": {"vr": "TM", "Value": ["095127.613000"]},
        "1999": {"vr": "TM", "Value": ["095147.627000"]},
        "2000": {"vr": "TM", "Value": ["095247.907000"]},
        "2001": {"vr": "TM", "Value": ["095456.471000"]},
        "2002": {"vr": "TM", "Value": ["095227.920000"]},
        "2003": {"vr": "TM", "Value": ["094547.736000"]},
        "2004": {"vr": "TM", "Value": ["095207.636000"]},
        "2005": {"vr": "TM", "Value": ["094647.787000"]},
        "2006": {"vr": "TM", "Value": ["094947.883000"]},
        "2007": {"vr": "TM", "Value": ["094607.882000"]},
        "2008": {"vr": "TM", "Value": ["094707.823000"]},
        "2009": {"vr": "TM", "Value": ["095447.845000"]},
        "2010": {"vr": "TM", "Value": ["094627.972000"]},
        "2011": {"vr": "TM", "Value": ["095347.918000"]},
        "2012": {"vr": "TM", "Value": ["094527.641000"]},
        "2013": {"vr": "TM", "Value": ["095307.843000"]},
        "2014": {"vr": "TM", "Value": ["094907.798000"]},
        "2015": {"vr": "TM", "Value": ["095247.748000"]},
        "2016": {"vr": "TM", "Value": ["095027.675000"]},
        "2017": {"vr": "TM", "Value": ["095007.778000"]},
        "2018": {"vr": "TM", "Value": ["095347.725000"]},
        "2019": {"vr": "TM", "Value": ["095007.713000"]},
        "2020": {"vr": "TM", "Value": ["095447.781000"]},
        "2021": {"vr": "TM", "Value": ["094847.737000"]},
        "2022": {"vr": "TM", "Value": ["095107.887000"]},
        "2023": {"vr": "TM", "Value": ["094827.755000"]},
        "2024": {"vr": "TM", "Value": ["095427.656000"]},
        "2025": {"vr": "TM", "Value": ["094707.675000"]},
        "2026": {"vr": "TM", "Value": ["095407.822000"]},
        "2027": {"vr": "TM", "Value": ["094807.765000"]},
        "2028": {"vr": "TM", "Value": ["095127.937000"]},
        "2029": {"vr": "TM", "Value": ["094707.666000"]},
        "2030": {"vr": "TM", "Value": ["095447.827000"]},
        "2031": {"vr": "TM", "Value": ["095027.806000"]},
        "2032": {"vr": "TM", "Value": ["094647.683000"]},
        "2033": {"vr": "TM", "Value": ["095447.620000"]},
        "2034": {"vr": "TM", "Value": ["095047.897000"]},
        "2035": {"vr": "TM", "Value": ["095027.618000"]},
        "2036": {"vr": "TM", "Value": ["094827.639000"]},
        "2037": {"vr": "TM", "Value": ["094747.756000"]},
        "2038": {"vr": "TM", "Value": ["095247.808000"]},
        "2039": {"vr": "TM", "Value": ["095007.740000"]},
        "2040": {"vr": "TM", "Value": ["094627.815000"]},
        "2041": {"vr": "TM", "Value": ["095127.646000"]},
        "2042": {"vr": "TM", "Value": ["094627.855000"]},
        "2043": {"vr": "TM", "Value": ["095307.740000"]},
        "2044": {"vr": "TM", "Value": ["094907.887000"]},
        "2045": {"vr": "TM", "Value": ["095107.752000"]},
        "2046": {"vr": "TM", "Value": ["094747.959000"]},
        "2047": {"vr": "TM", "Value": ["095447.732000"]},
        "2048": {"vr": "TM", "Value": ["094827.818000"]},
        "2049": {"vr": "TM", "Value": ["095027.677000"]},
        "2050": {"vr": "TM", "Value": ["094547.903000"]},
        "2051": {"vr": "TM", "Value": ["094927.654000"]},
        "2052": {"vr": "TM", "Value": ["094627.692000"]},
        "2053": {"vr": "TM", "Value": ["095227.663000"]},
        "2054": {"vr": "TM", "Value": ["094947.893000"]},
        "2055": {"vr": "TM", "Value": ["094847.832000"]},
        "2056": {"vr": "TM", "Value": ["095127.753000"]},
        "2057": {"vr": "TM", "Value": ["095427.676000"]},
        "2058": {"vr": "TM", "Value": ["095447.933000"]},
        "2059": {"vr": "TM", "Value": ["095347.869000"]},
        "2060": {"vr": "TM", "Value": ["094707.725000"]},
        "2061": {"vr": "TM", "Value": ["095047.803000"]},
        "2062": {"vr": "TM", "Value": ["094747.798000"]},
        "2063": {"vr": "TM", "Value": ["095107.677000"]},
        "2064": {"vr": "TM", "Value": ["095327.687000"]},
        "2065": {"vr": "TM", "Value": ["095407.922000"]},
        "2066": {"vr": "TM", "Value": ["095047.718000"]},
        "2067": {"vr": "TM", "Value": ["094847.923000"]},
        "2068": {"vr": "TM", "Value": ["094847.914000"]},
        "2069": {"vr": "TM", "Value": ["095407.628000"]},
        "2070": {"vr": "TM", "Value": ["095107.627000"]},
        "2071": {"vr": "TM", "Value": ["095227.913000"]},
        "2072": {"vr": "TM", "Value": ["095007.944000"]},
        "2073": {"vr": "TM", "Value": ["095127.845000"]},
        "2074": {"vr": "TM", "Value": ["094747.720000"]},
        "2075": {"vr": "TM", "Value": ["094827.877000"]},
        "2076": {"vr": "TM", "Value": ["095127.668000"]},
        "2077": {"vr": "TM", "Value": ["095307.943000"]},
        "2078": {"vr": "TM", "Value": ["094807.631000"]},
        "2079": {"vr": "TM", "Value": ["094827.944000"]},
        "2080": {"vr": "TM", "Value": ["094827.683000"]},
        "2081": {"vr": "TM", "Value": ["095407.697000"]},
        "2082": {"vr": "TM", "Value": ["094827.931000"]},
        "2083": {"vr": "TM", "Value": ["095007.803000"]},
        "2084": {"vr": "TM", "Value": ["095007.819000"]},
        "2085": {"vr": "TM", "Value": ["094727.903000"]},
        "2086": {"vr": "TM", "Value": ["095327.723000"]},
        "2087": {"vr": "TM", "Value": ["095427.638000"]},
        "2088": {"vr": "TM", "Value": ["095207.706000"]},
        "2089": {"vr": "TM", "Value": ["094807.626000"]},
        "2090": {"vr": "TM", "Value": ["095027.636000"]},
        "2091": {"vr": "TM", "Value": ["095047.905000"]},
        "2092": {"vr": "TM", "Value": ["095147.925000"]},
        "2093": {"vr": "TM", "Value": ["095447.863000"]},
        "2094": {"vr": "TM", "Value": ["095447.716000"]},
        "2095": {"vr": "TM", "Value": ["094907.720000"]},
        "2096": {"vr": "TM", "Value": ["094707.737000"]},
        "2097": {"vr": "TM", "Value": ["094707.803000"]},
        "2098": {"vr": "TM", "Value": ["094527.638000"]},
        "2099": {"vr": "TM", "Value": ["095307.691000"]},
        "2100": {"vr": "TM", "Value": ["095127.746000"]},
        "2101": {"vr": "TM", "Value": ["095307.637000"]},
        "2102": {"vr": "TM", "Value": ["094947.619000"]},
        "2103": {"vr": "TM", "Value": ["094527.830000"]},
        "2104": {"vr": "TM", "Value": ["095247.886000"]},
        "2105": {"vr": "TM", "Value": ["094607.624000"]},
        "2106": {"vr": "TM", "Value": ["094747.687000"]},
        "2107": {"vr": "TM", "Value": ["095107.847000"]},
        "2108": {"vr": "TM", "Value": ["094627.870000"]},
        "2109": {"vr": "TM", "Value": ["095327.668000"]},
        "2110": {"vr": "TM", "Value": ["095407.715000"]},
        "2111": {"vr": "TM", "Value": ["094707.730000"]},
        "2112": {"vr": "TM", "Value": ["094807.718000"]},
        "2113": {"vr": "TM", "Value": ["095027.859000"]},
        "2114": {"vr": "TM", "Value": ["095327.878000"]},
        "2115": {"vr": "TM", "Value": ["094547.923000"]},
        "2116": {"vr": "TM", "Value": ["095027.744000"]},
        "2117": {"vr": "TM", "Value": ["094827.665000"]},
        "2118": {"vr": "TM", "Value": ["094727.773000"]},
        "2119": {"vr": "TM", "Value": ["095047.856000"]},
        "2120": {"vr": "TM", "Value": ["095447.876000"]},
        "2121": {"vr": "TM", "Value": ["094647.790000"]},
        "2122": {"vr": "TM", "Value": ["094527.839000"]},
        "2123": {"vr": "TM", "Value": ["094647.722000"]},
        "2124": {"vr": "TM", "Value": ["094547.944000"]},
        "2125": {"vr": "TM", "Value": ["094827.649000"]},
        "2126": {"vr": "TM", "Value": ["094547.819000"]},
        "2127": {"vr": "TM", "Value": ["094927.729000"]},
        "2128": {"vr": "TM", "Value": ["095107.703000"]},
        "2129": {"vr": "TM", "Value": ["095407.758000"]},
        "2130": {"vr": "TM", "Value": ["094927.724000"]},
        "2131": {"vr": "TM", "Value": ["095427.729000"]},
        "2132": {"vr": "TM", "Value": ["095147.828000"]},
        "2133": {"vr": "TM", "Value": ["094627.612000"]},
        "2134": {"vr": "TM", "Value": ["094707.719000"]},
        "2135": {"vr": "TM", "Value": ["094727.898000"]},
        "2136": {"vr": "TM", "Value": ["094647.804000"]},
        "2137": {"vr": "TM", "Value": ["094847.646000"]},
        "2138": {"vr": "TM", "Value": ["094907.941000"]},
        "2139": {"vr": "TM", "Value": ["095027.644000"]},
        "2140": {"vr": "TM", "Value": ["095007.929000"]},
        "2141": {"vr": "TM", "Value": ["095127.656000"]},
        "2142": {"vr": "TM", "Value": ["094947.789000"]},
        "2143": {"vr": "TM", "Value": ["095447.775000"]},
        "2144": {"vr": "TM", "Value": ["095107.744000"]},
        "2145": {"vr": "TM", "Value": ["094747.905000"]},
        "2146": {"vr": "TM", "Value": ["095456.459000"]},
        "2147": {"vr": "TM", "Value": ["094647.647000"]},
        "2148": {"vr": "TM", "Value": ["094647.665000"]},
        "2149": {"vr": "TM", "Value": ["095427.661000"]},
        "2150": {"vr": "TM", "Value": ["095427.814000"]},
        "2151": {"vr": "TM", "Value": ["095027.811000"]},
        "2152": {"vr": "TM", "Value": ["094607.791000"]},
        "2153": {"vr": "TM", "Value": ["094727.952000"]},
        "2154": {"vr": "TM", "Value": ["095147.687000"]},
        "2155": {"vr": "TM", "Value": ["095107.668000"]},
        "2156": {"vr": "TM", "Value": ["095207.782000"]},
        "2157": {"vr": "TM", "Value": ["095007.649000"]},
        "2158": {"vr": "TM", "Value": ["095147.760000"]},
        "2159": {"vr": "TM", "Value": ["095007.718000"]},
        "2160": {"vr": "TM", "Value": ["095007.613000"]},
        "2161": {"vr": "TM", "Value": ["094707.955000"]},
        "2162": {"vr": "TM", "Value": ["094607.712000"]},
        "2163": {"vr": "TM", "Value": ["094947.699000"]},
        "2164": {"vr": "TM", "Value": ["095107.911000"]},
        "2165": {"vr": "TM", "Value": ["094827.844000"]},
        "2166": {"vr": "TM", "Value": ["094927.875000"]},
        "2167": {"vr": "TM", "Value": ["095127.765000"]},
        "2168": {"vr": "TM", "Value": ["095447.649000"]},
        "2169": {"vr": "TM", "Value": ["094747.957000"]},
        "2170": {"vr": "TM", "Value": ["095007.889000"]},
        "2171": {"vr": "TM", "Value": ["095427.817000"]},
        "2172": {"vr": "TM", "Value": ["094707.789000"]},
        "2173": {"vr": "TM", "Value": ["095247.827000"]},
        "2174": {"vr": "TM", "Value": ["095007.916000"]},
        "2175": {"vr": "TM", "Value": ["094807.841000"]},
        "2176": {"vr": "TM", "Value": ["095107.933000"]},
        "2177": {"vr": "TM", "Value": ["095447.921000"]},
        "2178": {"vr": "TM", "Value": ["094707.765000"]},
        "2179": {"vr": "TM", "Value": ["095127.698000"]},
        "2180": {"vr": "TM", "Value": ["094627.848000"]},
        "2181": {"vr": "TM", "Value": ["094747.670000"]},
        "2182": {"vr": "TM", "Value": ["095147.900000"]},
        "2183": {"vr": "TM", "Value": ["095347.649000"]},
        "2184": {"vr": "TM", "Value": ["095227.727000"]},
        "2185": {"vr": "TM", "Value": ["095007.692000"]},
        "2186": {"vr": "TM", "Value": ["095247.801000"]},
        "2187": {"vr": "TM", "Value": ["095456.407000"]},
        "2188": {"vr": "TM", "Value": ["095127.781000"]},
        "2189": {"vr": "TM", "Value": ["094807.674000"]},
        "2190": {"vr": "TM", "Value": ["094607.606000"]},
        "2191": {"vr": "TM", "Value": ["094647.814000"]},
        "2192": {"vr": "TM", "Value": ["094827.851000"]},
        "2193": {"vr": "TM", "Value": ["095307.694000"]},
        "2194": {"vr": "TM", "Value": ["094547.763000"]},
        "2195": {"vr": "TM", "Value": ["094907.850000"]},
        "2196": {"vr": "TM", "Value": ["095127.716000"]},
        "2197": {"vr": "TM", "Value": ["095007.662000"]},
        "2198": {"vr": "TM", "Value": ["095407.646000"]},
        "2199": {"vr": "TM", "Value": ["095247.820000"]},
        "2200": {"vr": "TM", "Value": ["094707.699000"]},
        "2201": {"vr": "TM", "Value": ["094807.720000"]},
        "2202": {"vr": "TM", "Value": ["095327.809000"]},
        "2203": {"vr": "TM", "Value": ["095207.851000"]},
        "2204": {"vr": "TM", "Value": ["095456.464000"]},
        "2205": {"vr": "TM", "Value": ["094607.833000"]},
        "2206": {"vr": "TM", "Value": ["095127.914000"]},
        "2207": {"vr": "TM", "Value": ["095107.765000"]},
        "2208": {"vr": "TM", "Value": ["095447.856000"]},
        "2209": {"vr": "TM", "Value": ["095307.797000"]},
        "2210": {"vr": "TM", "Value": ["094707.940000"]},
        "2211": {"vr": "TM", "Value": ["094547.854000"]},
        "2212": {"vr": "TM", "Value": ["095227.661000"]},
        "2213": {"vr": "TM", "Value": ["095227.622000"]},
        "2214": {"vr": "TM", "Value": ["094827.646000"]},
        "2215": {"vr": "TM", "Value": ["095327.632000"]},
        "2216": {"vr": "TM", "Value": ["095007.949000"]},
        "2217": {"vr": "TM", "Value": ["095207.724000"]},
        "2218": {"vr": "TM", "Value": ["094907.944000"]},
        "2219": {"vr": "TM", "Value": ["094727.718000"]},
        "2220": {"vr": "TM", "Value": ["094527.719000"]},
        "2221": {"vr": "TM", "Value": ["094647.811000"]},
        "2222": {"vr": "TM", "Value": ["095307.728000"]},
        "2223": {"vr": "TM", "Value": ["095047.843000"]},
        "2224": {"vr": "TM", "Value": ["094607.948000"]},
        "2225": {"vr": "TM", "Value": ["095107.646000"]},
        "2226": {"vr": "TM", "Value": ["094847.730000"]},
        "2227": {"vr": "TM", "Value": ["095407.855000"]},
        "2228": {"vr": "TM", "Value": ["094547.829000"]},
        "2229": {"vr": "TM", "Value": ["095427.687000"]},
        "2230": {"vr": "TM", "Value": ["095207.674000"]},
        "2231": {"vr": "TM", "Value": ["095247.666000"]},
        "2232": {"vr": "TM", "Value": ["095127.651000"]},
        "2233": {"vr": "TM", "Value": ["095447.923000"]},
        "2234": {"vr": "TM", "Value": ["095027.939000"]},
        "2235": {"vr": "TM", "Value": ["095207.864000"]},
        "2236": {"vr": "TM", "Value": ["095227.851000"]},
        "2237": {"vr": "TM", "Value": ["095107.908000"]},
        "2238": {"vr": "TM", "Value": ["095227.937000"]},
        "2239": {"vr": "TM", "Value": ["094707.642000"]},
        "2240": {"vr": "TM", "Value": ["094807.933000"]},
        "2241": {"vr": "TM", "Value": ["094647.905000"]},
        "2242": {"vr": "TM", "Value": ["095127.711000"]},
        "2243": {"vr": "TM", "Value": ["094627.635000"]},
        "2244": {"vr": "TM", "Value": ["094547.901000"]},
        "2245": {"vr": "TM", "Value": ["094927.814000"]},
        "2246": {"vr": "TM", "Value": ["094547.613000"]},
        "2247": {"vr": "TM", "Value": ["095107.866000"]},
        "2248": {"vr": "TM", "Value": ["094627.674000"]},
        "2249": {"vr": "TM", "Value": ["095347.631000"]},
        "2250": {"vr": "TM", "Value": ["095307.853000"]},
        "2251": {"vr": "TM", "Value": ["094707.897000"]},
        "2252": {"vr": "TM", "Value": ["094527.868000"]},
        "2253": {"vr": "TM", "Value": ["095347.646000"]},
        "2254": {"vr": "TM", "Value": ["095456.536000"]},
        "2255": {"vr": "TM", "Value": ["094827.753000"]},
        "2256": {"vr": "TM", "Value": ["095447.809000"]},
        "2257": {"vr": "TM", "Value": ["095207.818000"]},
        "2258": {"vr": "TM", "Value": ["094647.609000"]},
        "2259": {"vr": "TM", "Value": ["094647.967000"]},
        "2260": {"vr": "TM", "Value": ["095027.736000"]},
        "2261": {"vr": "TM", "Value": ["094747.962000"]},
        "2262": {"vr": "TM", "Value": ["095447.714000"]},
        "2263": {"vr": "TM", "Value": ["095327.743000"]},
        "2264": {"vr": "TM", "Value": ["095207.734000"]},
        "2265": {"vr": "TM", "Value": ["094947.780000"]},
        "2266": {"vr": "TM", "Value": ["095147.665000"]},
        "2267": {"vr": "TM", "Value": ["095427.763000"]},
        "2268": {"vr": "TM", "Value": ["095107.935000"]},
        "2269": {"vr": "TM", "Value": ["094627.957000"]},
        "2270": {"vr": "TM", "Value": ["095207.737000"]},
        "2271": {"vr": "TM", "Value": ["094827.719000"]},
        "2272": {"vr": "TM", "Value": ["095427.753000"]},
        "2273": {"vr": "TM", "Value": ["094907.808000"]},
        "2274": {"vr": "TM", "Value": ["095327.625000"]},
        "2275": {"vr": "TM", "Value": ["095047.669000"]},
        "2276": {"vr": "TM", "Value": ["095107.873000"]},
        "2277": {"vr": "TM", "Value": ["095027.798000"]},
        "2278": {"vr": "TM", "Value": ["095327.745000"]},
        "2279": {"vr": "TM", "Value": ["095447.667000"]},
        "2280": {"vr": "TM", "Value": ["094647.806000"]},
        "2281": {"vr": "TM", "Value": ["095227.861000"]},
        "2282": {"vr": "TM", "Value": ["094747.712000"]},
        "2283": {"vr": "TM", "Value": ["094747.908000"]},
        "2284": {"vr": "TM", "Value": ["095007.708000"]},
        "2285": {"vr": "TM", "Value": ["095307.720000"]},
        "2286": {"vr": "TM", "Value": ["095347.807000"]},
        "2287": {"vr": "TM", "Value": ["094527.694000"]},
        "2288": {"vr": "TM", "Value": ["095447.868000"]},
        "2289": {"vr": "TM", "Value": ["094547.649000"]},
        "2290": {"vr": "TM", "Value": ["094707.894000"]},
        "2291": {"vr": "TM", "Value": ["095147.816000"]},
        "2292": {"vr": "TM", "Value": ["095407.618000"]},
        "2293": {"vr": "TM", "Value": ["094727.766000"]},
        "2294": {"vr": "TM", "Value": ["095027.769000"]},
        "2295": {"vr": "TM", "Value": ["095007.846000"]},
        "2296": {"vr": "TM", "Value": ["095147.729000"]},
        "2297": {"vr": "TM", "Value": ["095407.684000"]},
        "2298": {"vr": "TM", "Value": ["095147.639000"]},
        "2299": {"vr": "TM", "Value": ["095427.923000"]},
        "2300": {"vr": "TM", "Value": ["095307.658000"]},
        "2301": {"vr": "TM", "Value": ["095127.850000"]},
        "2302": {"vr": "TM", "Value": ["094727.781000"]},
        "2303": {"vr": "TM", "Value": ["095147.915000"]},
        "2304": {"vr": "TM", "Value": ["095047.734000"]},
        "2305": {"vr": "TM", "Value": ["094527.854000"]},
        "2306": {"vr": "TM", "Value": ["094547.707000"]},
        "2307": {"vr": "TM", "Value": ["095227.620000"]},
        "2308": {"vr": "TM", "Value": ["095227.854000"]},
        "2309": {"vr": "TM", "Value": ["094927.926000"]},
        "2310": {"vr": "TM", "Value": ["094907.656000"]},
        "2311": {"vr": "TM", "Value": ["095207.889000"]},
        "2312": {"vr": "TM", "Value": ["095347.613000"]},
        "2313": {"vr": "TM", "Value": ["094527.630000"]},
        "2314": {"vr": "TM", "Value": ["094927.781000"]},
        "2315": {"vr": "TM", "Value": ["095447.884000"]},
        "2316": {"vr": "TM", "Value": ["094547.669000"]},
        "2317": {"vr": "TM", "Value": ["095227.827000"]},
        "2318": {"vr": "TM", "Value": ["095147.950000"]},
        "2319": {"vr": "TM", "Value": ["094747.903000"]},
        "2320": {"vr": "TM", "Value": ["094947.655000"]},
        "2321": {"vr": "TM", "Value": ["094807.733000"]},
        "2322": {"vr": "TM", "Value": ["094607.608000"]},
        "2323": {"vr": "TM", "Value": ["095347.825000"]},
        "2324": {"vr": "TM", "Value": ["095207.739000"]},
        "2325": {"vr": "TM", "Value": ["095427.863000"]},
        "2326": {"vr": "TM", "Value": ["094747.913000"]},
        "2327": {"vr": "TM", "Value": ["094927.941000"]},
        "2328": {"vr": "TM", "Value": ["094807.936000"]},
        "2329": {"vr": "TM", "Value": ["094927.630000"]},
        "2330": {"vr": "TM", "Value": ["095227.809000"]},
        "2331": {"vr": "TM", "Value": ["094727.693000"]},
        "2332": {"vr": "TM", "Value": ["095207.742000"]},
        "2333": {"vr": "TM", "Value": ["095127.730000"]},
        "2334": {"vr": "TM", "Value": ["095027.772000"]},
        "2335": {"vr": "TM", "Value": ["094847.785000"]},
        "2336": {"vr": "TM", "Value": ["094607.673000"]},
        "2337": {"vr": "TM", "Value": ["095147.700000"]},
        "2338": {"vr": "TM", "Value": ["094627.682000"]},
        "2339": {"vr": "TM", "Value": ["094807.738000"]},
        "2340": {"vr": "TM", "Value": ["095327.762000"]},
        "2341": {"vr": "TM", "Value": ["095047.943000"]},
        "2342": {"vr": "TM", "Value": ["095327.920000"]},
        "2343": {"vr": "TM", "Value": ["094907.772000"]},
        "2344": {"vr": "TM", "Value": ["094847.745000"]},
        "2345": {"vr": "TM", "Value": ["094927.659000"]},
        "2346": {"vr": "TM", "Value": ["095327.753000"]},
        "2347": {"vr": "TM", "Value": ["094707.817000"]},
        "2348": {"vr": "TM", "Value": ["095107.800000"]},
        "2349": {"vr": "TM", "Value": ["094727.893000"]},
        "2350": {"vr": "TM", "Value": ["094607.859000"]},
        "2351": {"vr": "TM", "Value": ["095207.626000"]},
        "2352": {"vr": "TM", "Value": ["094827.644000"]},
        "2353": {"vr": "TM", "Value": ["095347.876000"]},
        "2354": {"vr": "TM", "Value": ["094627.843000"]},
        "2355": {"vr": "TM", "Value": ["094527.922000"]},
        "2356": {"vr": "TM", "Value": ["094847.727000"]},
        "2357": {"vr": "TM", "Value": ["095447.630000"]},
        "2358": {"vr": "TM", "Value": ["094827.781000"]},
        "2359": {"vr": "TM", "Value": ["095327.733000"]},
        "2360": {"vr": "TM", "Value": ["094647.987000"]},
        "2361": {"vr": "TM", "Value": ["095447.829000"]},
        "2362": {"vr": "TM", "Value": ["095307.679000"]},
        "2363": {"vr": "TM", "Value": ["095447.698000"]},
        "2364": {"vr": "TM", "Value": ["095407.799000"]},
        "2365": {"vr": "TM", "Value": ["094607.778000"]},
        "2366": {"vr": "TM", "Value": ["094847.753000"]},
        "2367": {"vr": "TM", "Value": ["095047.910000"]},
        "2368": {"vr": "TM", "Value": ["095247.858000"]},
        "2369": {"vr": "TM", "Value": ["094527.673000"]},
        "2370": {"vr": "TM", "Value": ["094607.634000"]},
        "2371": {"vr": "TM", "Value": ["095107.615000"]},
        "2372": {"vr": "TM", "Value": ["094827.834000"]},
        "2373": {"vr": "TM", "Value": ["094627.828000"]},
        "2374": {"vr": "TM", "Value": ["094607.725000"]},
        "2375": {"vr": "TM", "Value": ["095007.626000"]},
        "2376": {"vr": "TM", "Value": ["094707.639000"]},
        "2377": {"vr": "TM", "Value": ["094547.817000"]},
        "2378": {"vr": "TM", "Value": ["095307.933000"]},
        "2379": {"vr": "TM", "Value": ["094627.736000"]},
        "2380": {"vr": "TM", "Value": ["095347.623000"]},
        "2381": {"vr": "TM", "Value": ["095147.835000"]},
        "2382": {"vr": "TM", "Value": ["095147.808000"]},
        "2383": {"vr": "TM", "Value": ["094907.911000"]},
        "2384": {"vr": "TM", "Value": ["094947.822000"]},
        "2385": {"vr": "TM", "Value": ["095007.865000"]},
        "2386": {"vr": "TM", "Value": ["095347.771000"]},
        "2387": {"vr": "TM", "Value": ["094747.723000"]},
        "2388": {"vr": "TM", "Value": ["095427.840000"]},
        "2389": {"vr": "TM", "Value": ["094607.720000"]},
        "2390": {"vr": "TM", "Value": ["095447.897000"]},
        "2391": {"vr": "TM", "Value": ["094747.930000"]},
        "2392": {"vr": "TM", "Value": ["094747.754000"]},
        "2393": {"vr": "TM", "Value": ["094547.883000"]},
        "2394": {"vr": "TM", "Value": ["095147.739000"]},
        "2395": {"vr": "TM", "Value": ["095347.848000"]},
        "2396": {"vr": "TM", "Value": ["094907.753000"]},
        "2397": {"vr": "TM", "Value": ["095347.759000"]},
        "2398": {"vr": "TM", "Value": ["095307.835000"]},
        "2399": {"vr": "TM", "Value": ["095407.835000"]},
        "2400": {"vr": "TM", "Value": ["095327.675000"]},
        "2401": {"vr": "TM", "Value": ["094847.865000"]},
        "2402": {"vr": "TM", "Value": ["095327.928000"]},
        "2403": {"vr": "TM", "Value": ["095227.752000"]},
        "2404": {"vr": "TM", "Value": ["095147.903000"]},
        "2405": {"vr": "TM", "Value": ["095207.803000"]},
        "2406": {"vr": "TM", "Value": ["094647.638000"]},
        "2407": {"vr": "TM", "Value": ["094807.907000"]},
        "2408": {"vr": "TM", "Value": ["094547.906000"]},
        "2409": {"vr": "TM", "Value": ["094847.953000"]},
        "2410": {"vr": "TM", "Value": ["095447.755000"]},
        "2411": {"vr": "TM", "Value": ["095127.720000"]},
        "2412": {"vr": "TM", "Value": ["095147.953000"]},
        "2413": {"vr": "TM", "Value": ["095307.653000"]},
        "2414": {"vr": "TM", "Value": ["095047.785000"]},
        "2415": {"vr": "TM", "Value": ["094627.619000"]},
        "2416": {"vr": "TM", "Value": ["094627.924000"]},
        "2417": {"vr": "TM", "Value": ["095456.524000"]},
        "2418": {"vr": "TM", "Value": ["095147.724000"]},
        "2419": {"vr": "TM", "Value": ["094807.715000"]},
        "2420": {"vr": "TM", "Value": ["095227.643000"]},
        "2421": {"vr": "TM", "Value": ["095207.777000"]},
        "2422": {"vr": "TM", "Value": ["095227.889000"]},
        "2423": {"vr": "TM", "Value": ["094547.694000"]},
        "2424": {"vr": "TM", "Value": ["094627.776000"]},
        "2425": {"vr": "TM", "Value": ["095127.625000"]},
        "2426": {"vr": "TM", "Value": ["094547.749000"]},
        "2427": {"vr": "TM", "Value": ["094747.866000"]},
        "2428": {"vr": "TM", "Value": ["095107.731000"]},
        "2429": {"vr": "TM", "Value": ["094927.906000"]},
        "2430": {"vr": "TM", "Value": ["094927.681000"]},
        "2431": {"vr": "TM", "Value": ["094547.786000"]},
        "2432": {"vr": "TM", "Value": ["094547.839000"]},
        "2433": {"vr": "TM", "Value": ["094827.882000"]},
        "2434": {"vr": "TM", "Value": ["094807.945000"]},
        "2435": {"vr": "TM", "Value": ["095407.875000"]},
        "2436": {"vr": "TM", "Value": ["094707.797000"]},
        "2437": {"vr": "TM", "Value": ["095147.677000"]},
        "2438": {"vr": "TM", "Value": ["094627.716000"]},
        "2439": {"vr": "TM", "Value": ["095127.860000"]},
        "2440": {"vr": "TM", "Value": ["095107.762000"]},
        "2441": {"vr": "TM", "Value": ["095347.741000"]},
        "2442": {"vr": "TM", "Value": ["095207.828000"]},
        "2443": {"vr": "TM", "Value": ["095247.839000"]},
        "2444": {"vr": "TM", "Value": ["095107.884000"]},
        "2445": {"vr": "TM", "Value": ["095207.805000"]},
        "2446": {"vr": "TM", "Value": ["094627.969000"]},
        "2447": {"vr": "TM", "Value": ["094927.946000"]},
        "2448": {"vr": "TM", "Value": ["095347.871000"]},
        "2449": {"vr": "TM", "Value": ["094547.842000"]},
        "2450": {"vr": "TM", "Value": ["095227.668000"]},
        "2451": {"vr": "TM", "Value": ["095027.918000"]},
        "2452": {"vr": "TM", "Value": ["094607.846000"]},
        "2453": {"vr": "TM", "Value": ["094927.809000"]},
        "2454": {"vr": "TM", "Value": ["095427.878000"]},
        "2455": {"vr": "TM", "Value": ["094747.845000"]},
        "2456": {"vr": "TM", "Value": ["095027.793000"]},
        "2457": {"vr": "TM", "Value": ["095027.698000"]},
        "2458": {"vr": "TM", "Value": ["095027.832000"]},
        "2459": {"vr": "TM", "Value": ["095427.936000"]},
        "2460": {"vr": "TM", "Value": ["094847.674000"]},
        "2461": {"vr": "TM", "Value": ["094807.735000"]},
        "2462": {"vr": "TM", "Value": ["095247.647000"]},
        "2463": {"vr": "TM", "Value": ["095407.761000"]},
        "2464": {"vr": "TM", "Value": ["095307.807000"]},
        "2465": {"vr": "TM", "Value": ["095147.880000"]},
        "2466": {"vr": "TM", "Value": ["094927.697000"]},
        "2467": {"vr": "TM", "Value": ["095027.913000"]},
        "2468": {"vr": "TM", "Value": ["095307.879000"]},
        "2469": {"vr": "TM", "Value": ["094947.858000"]},
        "2470": {"vr": "TM", "Value": ["094707.775000"]},
        "2471": {"vr": "TM", "Value": ["095147.615000"]},
        "2472": {"vr": "TM", "Value": ["094947.844000"]},
        "2473": {"vr": "TM", "Value": ["094807.962000"]},
        "2474": {"vr": "TM", "Value": ["094527.936000"]},
        "2475": {"vr": "TM", "Value": ["095147.642000"]},
        "2476": {"vr": "TM", "Value": ["095127.725000"]},
        "2477": {"vr": "TM", "Value": ["095447.618000"]},
        "2478": {"vr": "TM", "Value": ["094627.909000"]},
        "2479": {"vr": "TM", "Value": ["094647.940000"]},
        "2480": {"vr": "TM", "Value": ["095327.728000"]},
        "2481": {"vr": "TM", "Value": ["095347.751000"]},
        "2482": {"vr": "TM", "Value": ["094847.875000"]},
        "2483": {"vr": "TM", "Value": ["095327.935000"]},
        "2484": {"vr": "TM", "Value": ["094627.687000"]},
        "2485": {"vr": "TM", "Value": ["094827.620000"]},
        "2486": {"vr": "TM", "Value": ["094807.941000"]},
        "2487": {"vr": "TM", "Value": ["095327.659000"]},
        "2488": {"vr": "TM", "Value": ["095447.639000"]},
        "2489": {"vr": "TM", "Value": ["095427.794000"]},
        "2490": {"vr": "TM", "Value": ["095207.946000"]},
        "2491": {"vr": "TM", "Value": ["094627.933000"]},
        "2492": {"vr": "TM", "Value": ["095027.849000"]},
        "2493": {"vr": "TM", "Value": ["095107.835000"]},
        "2494": {"vr": "TM", "Value": ["095427.832000"]},
        "2495": {"vr": "TM", "Value": ["094827.737000"]},
        "2496": {"vr": "TM", "Value": ["094707.874000"]},
        "2497": {"vr": "TM", "Value": ["095327.925000"]},
        "2498": {"vr": "TM", "Value": ["095207.634000"]},
        "2499": {"vr": "TM", "Value": ["094847.903000"]},
        "2500": {"vr": "TM", "Value": ["095347.915000"]},
        "2501": {"vr": "TM", "Value": ["094947.737000"]},
        "2502": {"vr": "TM", "Value": ["094607.913000"]},
        "2503": {"vr": "TM", "Value": ["095327.639000"]},
        "2504": {"vr": "TM", "Value": ["094727.680000"]},
        "2505": {"vr": "TM", "Value": ["095147.930000"]},
        "2506": {"vr": "TM", "Value": ["094907.671000"]},
        "2507": {"vr": "TM", "Value": ["095147.607000"]},
        "2508": {"vr": "TM", "Value": ["095107.777000"]},
        "2509": {"vr": "TM", "Value": ["094727.947000"]},
        "2510": {"vr": "TM", "Value": ["095227.789000"]},
        "2511": {"vr": "TM", "Value": ["094907.777000"]},
        "2512": {"vr": "TM", "Value": ["095107.694000"]},
        "2513": {"vr": "TM", "Value": ["095427.722000"]},
        "2514": {"vr": "TM", "Value": ["094827.691000"]},
        "2515": {"vr": "TM", "Value": ["094607.802000"]},
        "2516": {"vr": "TM", "Value": ["094607.691000"]},
        "2517": {"vr": "TM", "Value": ["095347.941000"]},
        "2518": {"vr": "TM", "Value": ["094927.888000"]},
        "2519": {"vr": "TM", "Value": ["094847.808000"]},
        "2520": {"vr": "TM", "Value": ["095147.792000"]},
        "2521": {"vr": "TM", "Value": ["095327.642000"]},
        "2522": {"vr": "TM", "Value": ["095456.435000"]},
        "2523": {"vr": "TM", "Value": ["094627.642000"]},
        "2524": {"vr": "TM", "Value": ["095047.651000"]},
        "2525": {"vr": "TM", "Value": ["095456.505000"]},
        "2526": {"vr": "TM", "Value": ["094807.910000"]},
        "2527": {"vr": "TM", "Value": ["094807.888000"]},
        "2528": {"vr": "TM", "Value": ["095347.610000"]},
        "2529": {"vr": "TM", "Value": ["094847.758000"]},
        "2530": {"vr": "TM", "Value": ["095307.696000"]},
        "2531": {"vr": "TM", "Value": ["095247.658000"]},
        "2532": {"vr": "TM", "Value": ["095107.686000"]},
        "2533": {"vr": "TM", "Value": ["094547.926000"]},
        "2534": {"vr": "TM", "Value": ["095147.857000"]},
        "2535": {"vr": "TM", "Value": ["095107.845000"]},
        "2536": {"vr": "TM", "Value": ["094927.848000"]},
        "2537": {"vr": "TM", "Value": ["095007.911000"]},
        "2538": {"vr": "TM", "Value": ["095207.681000"]},
        "2539": {"vr": "TM", "Value": ["095456.417000"]},
        "2540": {"vr": "TM", "Value": ["095447.816000"]},
        "2541": {"vr": "TM", "Value": ["095027.808000"]},
        "2542": {"vr": "TM", "Value": ["094827.779000"]},
        "2543": {"vr": "TM", "Value": ["095247.675000"]},
        "2544": {"vr": "TM", "Value": ["094647.719000"]},
        "2545": {"vr": "TM", "Value": ["095107.739000"]},
        "2546": {"vr": "TM", "Value": ["095147.748000"]},
        "2547": {"vr": "TM", "Value": ["094707.810000"]},
        "2548": {"vr": "TM", "Value": ["094827.872000"]},
        "2549": {"vr": "TM", "Value": ["095027.803000"]},
        "2550": {"vr": "TM", "Value": ["095407.909000"]},
        "2551": {"vr": "TM", "Value": ["095247.935000"]},
        "2552": {"vr": "TM", "Value": ["095447.696000"]},
        "2553": {"vr": "TM", "Value": ["094607.951000"]},
        "2554": {"vr": "TM", "Value": ["094807.839000"]},
        "2555": {"vr": "TM", "Value": ["095127.703000"]},
        "2556": {"vr": "TM", "Value": ["095407.649000"]},
        "2557": {"vr": "TM", "Value": ["095327.758000"]},
        "2558": {"vr": "TM", "Value": ["095047.851000"]},
        "2559": {"vr": "TM", "Value": ["095327.886000"]},
        "2560": {"vr": "TM", "Value": ["095427.735000"]},
        "2561": {"vr": "TM", "Value": ["094927.760000"]},
        "2562": {"vr": "TM", "Value": ["095127.767000"]},
        "2563": {"vr": "TM", "Value": ["094847.885000"]},
        "2564": {"vr": "TM", "Value": ["094747.660000"]},
        "2565": {"vr": "TM", "Value": ["095347.738000"]},
        "2566": {"vr": "TM", "Value": ["095227.908000"]},
        "2567": {"vr": "TM", "Value": ["095147.702000"]},
        "2568": {"vr": "TM", "Value": ["095427.855000"]},
        "2569": {"vr": "TM", "Value": ["094647.764000"]},
        "2570": {"vr": "TM", "Value": ["095427.652000"]},
        "2571": {"vr": "TM", "Value": ["094707.627000"]},
        "2572": {"vr": "TM", "Value": ["095456.548000"]},
        "2573": {"vr": "TM", "Value": ["094547.898000"]},
        "2574": {"vr": "TM", "Value": ["095127.774000"]},
        "2575": {"vr": "TM", "Value": ["094627.707000"]},
        "2576": {"vr": "TM", "Value": ["095247.804000"]},
        "2577": {"vr": "TM", "Value": ["094807.938000"]},
        "2578": {"vr": "TM", "Value": ["094527.967000"]},
        "2579": {"vr": "TM", "Value": ["094527.786000"]},
        "2580": {"vr": "TM", "Value": ["095447.930000"]},
        "2581": {"vr": "TM", "Value": ["095027.669000"]},
        "2582": {"vr": "TM", "Value": ["095027.728000"]},
        "2583": {"vr": "TM", "Value": ["094927.661000"]},
        "2584": {"vr": "TM", "Value": ["094827.954000"]},
        "2585": {"vr": "TM", "Value": ["095327.797000"]},
        "2586": {"vr": "TM", "Value": ["095127.900000"]},
        "2587": {"vr": "TM", "Value": ["095227.875000"]},
        "2588": {"vr": "TM", "Value": ["094527.897000"]},
        "2589": {"vr": "TM", "Value": ["095447.918000"]},
        "2590": {"vr": "TM", "Value": ["095107.918000"]},
        "2591": {"vr": "TM", "Value": ["095407.906000"]},
        "2592": {"vr": "TM", "Value": ["094907.713000"]},
        "2593": {"vr": "TM", "Value": ["094927.855000"]},
        "2594": {"vr": "TM", "Value": ["094807.731000"]},
        "2595": {"vr": "TM", "Value": ["095347.956000"]},
        "2596": {"vr": "TM", "Value": ["094807.880000"]},
        "2597": {"vr": "TM", "Value": ["095427.913000"]},
        "2598": {"vr": "TM", "Value": ["094747.946000"]},
        "2599": {"vr": "TM", "Value": ["095107.875000"]},
        "2600": {"vr": "TM", "Value": ["095247.782000"]},
        "2601": {"vr": "TM", "Value": ["095327.860000"]},
        "2602": {"vr": "TM", "Value": ["094947.645000"]},
        "2603": {"vr": "TM", "Value": ["095247.792000"]},
        "2604": {"vr": "TM", "Value": ["095347.902000"]},
        "2605": {"vr": "TM", "Value": ["095207.808000"]},
        "2606": {"vr": "TM", "Value": ["095307.738000"]},
        "2607": {"vr": "TM", "Value": ["095207.821000"]},
        "2608": {"vr": "TM", "Value": ["095447.654000"]},
        "2609": {"vr": "TM", "Value": ["095147.734000"]},
        "2610": {"vr": "TM", "Value": ["094807.689000"]},
        "2611": {"vr": "TM", "Value": ["094827.884000"]},
        "2612": {"vr": "TM", "Value": ["094727.698000"]},
        "2613": {"vr": "TM", "Value": ["094627.669000"]},
        "2614": {"vr": "TM", "Value": ["095147.617000"]},
        "2615": {"vr": "TM", "Value": ["095347.864000"]},
        "2616": {"vr": "TM", "Value": ["094807.740000"]},
        "2617": {"vr": "TM", "Value": ["095207.951000"]},
        "2618": {"vr": "TM", "Value": ["095147.799000"]},
        "2619": {"vr": "TM", "Value": ["094927.674000"]},
        "2620": {"vr": "TM", "Value": ["094807.648000"]},
        "2621": {"vr": "TM", "Value": ["095027.905000"]},
        "2622": {"vr": "TM", "Value": ["095407.615000"]},
        "2623": {"vr": "TM", "Value": ["095327.832000"]},
        "2624": {"vr": "TM", "Value": ["095327.822000"]},
        "2625": {"vr": "TM", "Value": ["094847.839000"]},
        "2626": {"vr": "TM", "Value": ["095447.853000"]},
        "2627": {"vr": "TM", "Value": ["095327.649000"]},
        "2628": {"vr": "TM", "Value": ["095456.432000"]},
        "2629": {"vr": "TM", "Value": ["094707.668000"]},
        "2630": {"vr": "TM", "Value": ["094947.818000"]},
        "2631": {"vr": "TM", "Value": ["094947.647000"]},
        "2632": {"vr": "TM", "Value": ["094727.713000"]},
        "2633": {"vr": "TM", "Value": ["095007.738000"]},
        "2634": {"vr": "TM", "Value": ["094847.779000"]},
        "2635": {"vr": "TM", "Value": ["094547.746000"]},
        "2636": {"vr": "TM", "Value": ["095327.740000"]},
        "2637": {"vr": "TM", "Value": ["094947.775000"]},
        "2638": {"vr": "TM", "Value": ["094527.979000"]},
        "2639": {"vr": "TM", "Value": ["095147.758000"]},
        "2640": {"vr": "TM", "Value": ["094527.737000"]},
        "2641": {"vr": "TM", "Value": ["094627.952000"]},
        "2642": {"vr": "TM", "Value": ["094927.644000"]},
        "2643": {"vr": "TM", "Value": ["095447.886000"]},
        "2644": {"vr": "TM", "Value": ["095107.658000"]},
        "2645": {"vr": "TM", "Value": ["095327.616000"]},
        "2646": {"vr": "TM", "Value": ["095047.661000"]},
        "2647": {"vr": "TM", "Value": ["095227.648000"]},
        "2648": {"vr": "TM", "Value": ["095147.637000"]},
        "2649": {"vr": "TM", "Value": ["094707.927000"]},
        "2650": {"vr": "TM", "Value": ["094747.698000"]},
        "2651": {"vr": "TM", "Value": ["094827.836000"]},
        "2652": {"vr": "TM", "Value": ["094647.749000"]},
        "2653": {"vr": "TM", "Value": ["095427.668000"]},
        "2654": {"vr": "TM", "Value": ["095307.743000"]},
        "2655": {"vr": "TM", "Value": ["094547.834000"]},
        "2656": {"vr": "TM", "Value": ["094627.930000"]},
        "2657": {"vr": "TM", "Value": ["094747.863000"]},
        "2658": {"vr": "TM", "Value": ["095456.539000"]},
        "2659": {"vr": "TM", "Value": ["094847.879000"]},
        "2660": {"vr": "TM", "Value": ["095207.726000"]},
        "2661": {"vr": "TM", "Value": ["095347.695000"]},
        "2662": {"vr": "TM", "Value": ["095407.937000"]},
        "2663": {"vr": "TM", "Value": ["094607.754000"]},
        "2664": {"vr": "TM", "Value": ["094627.652000"]},
        "2665": {"vr": "TM", "Value": ["094627.766000"]},
        "2666": {"vr": "TM", "Value": ["095347.651000"]},
        "2667": {"vr": "TM", "Value": ["094747.972000"]},
        "2668": {"vr": "TM", "Value": ["094607.888000"]},
        "2669": {"vr": "TM", "Value": ["094647.670000"]},
        "2670": {"vr": "TM", "Value": ["094927.918000"]},
        "2671": {"vr": "TM", "Value": ["094847.801000"]},
        "2672": {"vr": "TM", "Value": ["095247.878000"]},
        "2673": {"vr": "TM", "Value": ["094707.773000"]},
        "2674": {"vr": "TM", "Value": ["094627.610000"]},
        "2675": {"vr": "TM", "Value": ["094627.927000"]},
        "2676": {"vr": "TM", "Value": ["094607.838000"]},
        "2677": {"vr": "TM", "Value": ["094947.637000"]},
        "2678": {"vr": "TM", "Value": ["095247.896000"]},
        "2679": {"vr": "TM", "Value": ["095007.892000"]},
        "2680": {"vr": "TM", "Value": ["094527.774000"]},
        "2681": {"vr": "TM", "Value": ["095207.938000"]},
        "2682": {"vr": "TM", "Value": ["095027.857000"]},
        "2683": {"vr": "TM", "Value": ["095227.839000"]},
        "2684": {"vr": "TM", "Value": ["094927.656000"]},
        "2685": {"vr": "TM", "Value": ["095147.692000"]},
        "2686": {"vr": "TM", "Value": ["094727.706000"]},
        "2687": {"vr": "TM", "Value": ["095107.630000"]},
        "2688": {"vr": "TM", "Value": ["095107.826000"]},
        "2689": {"vr": "TM", "Value": ["094847.750000"]},
        "2690": {"vr": "TM", "Value": ["094927.755000"]},
        "2691": {"vr": "TM", "Value": ["094647.673000"]},
        "2692": {"vr": "TM", "Value": ["094647.859000"]},
        "2693": {"vr": "TM", "Value": ["095107.838000"]},
        "2694": {"vr": "TM", "Value": ["095247.868000"]},
        "2695": {"vr": "TM", "Value": ["095227.717000"]},
        "2696": {"vr": "TM", "Value": ["094627.845000"]},
        "2697": {"vr": "TM", "Value": ["095427.616000"]},
        "2698": {"vr": "TM", "Value": ["095107.852000"]},
        "2699": {"vr": "TM", "Value": ["094727.836000"]},
        "2700": {"vr": "TM", "Value": ["094547.709000"]},
        "2701": {"vr": "TM", "Value": ["094907.788000"]},
        "2702": {"vr": "TM", "Value": ["094847.631000"]},
        "2703": {"vr": "TM", "Value": ["095427.886000"]},
        "2704": {"vr": "TM", "Value": ["094907.840000"]},
        "2705": {"vr": "TM", "Value": ["094607.688000"]},
        "2706": {"vr": "TM", "Value": ["094707.833000"]},
        "2707": {"vr": "TM", "Value": ["095407.814000"]},
        "2708": {"vr": "TM", "Value": ["095347.787000"]},
        "2709": {"vr": "TM", "Value": ["095327.647000"]},
        "2710": {"vr": "TM", "Value": ["095127.616000"]},
        "2711": {"vr": "TM", "Value": ["094607.905000"]},
        "2712": {"vr": "TM", "Value": ["094907.621000"]},
        "2713": {"vr": "TM", "Value": ["095427.905000"]},
        "2714": {"vr": "TM", "Value": ["095347.621000"]},
        "2715": {"vr": "TM", "Value": ["095107.634000"]},
        "2716": {"vr": "TM", "Value": ["095107.734000"]},
        "2717": {"vr": "TM", "Value": ["094847.829000"]},
        "2718": {"vr": "TM", "Value": ["094527.878000"]},
        "2719": {"vr": "TM", "Value": ["095047.746000"]},
        "2720": {"vr": "TM", "Value": ["094847.636000"]},
        "2721": {"vr": "TM", "Value": ["095407.932000"]},
        "2722": {"vr": "TM", "Value": ["094847.763000"]},
        "2723": {"vr": "TM", "Value": ["095447.821000"]},
        "2724": {"vr": "TM", "Value": ["095247.825000"]},
        "2725": {"vr": "TM", "Value": ["095247.613000"]},
        "2726": {"vr": "TM", "Value": ["095327.709000"]},
        "2727": {"vr": "TM", "Value": ["094927.676000"]},
        "2728": {"vr": "TM", "Value": ["094727.913000"]},
        "2729": {"vr": "TM", "Value": ["094927.853000"]},
        "2730": {"vr": "TM", "Value": ["095047.797000"]},
        "2731": {"vr": "TM", "Value": ["094907.666000"]},
        "2732": {"vr": "TM", "Value": ["095447.683000"]},
        "2733": {"vr": "TM", "Value": ["095407.827000"]},
        "2734": {"vr": "TM", "Value": ["094927.850000"]},
        "2735": {"vr": "TM", "Value": ["094647.644000"]},
        "2736": {"vr": "TM", "Value": ["095007.877000"]},
        "2737": {"vr": "TM", "Value": ["094927.712000"]},
        "2738": {"vr": "TM", "Value": ["094527.875000"]},
        "2739": {"vr": "TM", "Value": ["095047.767000"]},
        "2740": {"vr": "TM", "Value": ["094747.898000"]},
        "2741": {"vr": "TM", "Value": ["095456.457000"]},
        "2742": {"vr": "TM", "Value": ["095447.850000"]},
        "2743": {"vr": "TM", "Value": ["095407.840000"]},
        "2744": {"vr": "TM", "Value": ["095207.708000"]},
        "2745": {"vr": "TM", "Value": ["094547.615000"]},
        "2746": {"vr": "TM", "Value": ["095147.770000"]},
        "2747": {"vr": "TM", "Value": ["095247.923000"]},
        "2748": {"vr": "TM", "Value": ["095107.639000"]},
        "2749": {"vr": "TM", "Value": ["094847.782000"]},
        "2750": {"vr": "TM", "Value": ["094647.938000"]},
        "2751": {"vr": "TM", "Value": ["095247.621000"]},
        "2752": {"vr": "TM", "Value": ["094727.886000"]},
        "2753": {"vr": "TM", "Value": ["094527.900000"]},
        "2754": {"vr": "TM", "Value": ["095407.804000"]},
        "2755": {"vr": "TM", "Value": ["094727.937000"]},
        "2756": {"vr": "TM", "Value": ["095327.881000"]},
        "2757": {"vr": "TM", "Value": ["094827.892000"]},
        "2758": {"vr": "TM", "Value": ["094607.820000"]},
        "2759": {"vr": "TM", "Value": ["094647.782000"]},
        "2760": {"vr": "TM", "Value": ["095107.696000"]},
        "2761": {"vr": "TM", "Value": ["094927.689000"]},
        "2762": {"vr": "TM", "Value": ["095127.922000"]},
        "2763": {"vr": "TM", "Value": ["094707.840000"]},
        "2764": {"vr": "TM", "Value": ["094607.872000"]},
        "2765": {"vr": "TM", "Value": ["095007.781000"]},
        "2766": {"vr": "TM", "Value": ["094747.706000"]},
        "2767": {"vr": "TM", "Value": ["095027.615000"]},
        "2768": {"vr": "TM", "Value": ["095127.939000"]},
        "2769": {"vr": "TM", "Value": ["094627.884000"]},
        "2770": {"vr": "TM", "Value": ["095147.746000"]},
        "2771": {"vr": "TM", "Value": ["094547.774000"]},
        "2772": {"vr": "TM", "Value": ["094627.965000"]},
        "2773": {"vr": "TM", "Value": ["095347.712000"]},
        "2774": {"vr": "TM", "Value": ["094927.707000"]},
        "2775": {"vr": "TM", "Value": ["094527.801000"]},
        "2776": {"vr": "TM", "Value": ["094627.726000"]},
        "2777": {"vr": "TM", "Value": ["095147.811000"]},
        "2778": {"vr": "TM", "Value": ["095007.951000"]},
        "2779": {"vr": "TM", "Value": ["095247.698000"]},
        "2780": {"vr": "TM", "Value": ["095047.848000"]},
        "2781": {"vr": "TM", "Value": ["095456.448000"]},
        "2782": {"vr": "TM", "Value": ["094727.634000"]},
        "2783": {"vr": "TM", "Value": ["094627.863000"]},
        "2784": {"vr": "TM", "Value": ["094907.900000"]},
        "2785": {"vr": "TM", "Value": ["095007.941000"]},
        "2786": {"vr": "TM", "Value": ["094947.832000"]},
        "2787": {"vr": "TM", "Value": ["095427.732000"]},
        "2788": {"vr": "TM", "Value": ["095107.723000"]},
        "2789": {"vr": "TM", "Value": ["095127.932000"]},
        "2790": {"vr": "TM", "Value": ["094727.701000"]},
        "2791": {"vr": "TM", "Value": ["095207.844000"]},
        "2792": {"vr": "TM", "Value": ["095327.706000"]},
        "2793": {"vr": "TM", "Value": ["095247.739000"]},
        "2794": {"vr": "TM", "Value": ["094807.913000"]},
        "2795": {"vr": "TM", "Value": ["094747.690000"]},
        "2796": {"vr": "TM", "Value": ["095047.698000"]},
        "2797": {"vr": "TM", "Value": ["095147.842000"]},
        "2798": {"vr": "TM", "Value": ["095227.882000"]},
        "2799": {"vr": "TM", "Value": ["095347.628000"]},
        "2800": {"vr": "TM", "Value": ["095147.890000"]},
        "2801": {"vr": "TM", "Value": ["094907.668000"]},
        "2802": {"vr": "TM", "Value": ["095407.893000"]},
        "2803": {"vr": "TM", "Value": ["094947.697000"]},
        "2804": {"vr": "TM", "Value": ["095047.790000"]},
        "2805": {"vr": "TM", "Value": ["095127.821000"]},
        "2806": {"vr": "TM", "Value": ["094647.737000"]},
        "2807": {"vr": "TM", "Value": ["095427.748000"]},
        "2808": {"vr": "TM", "Value": ["095407.791000"]},
        "2809": {"vr": "TM", "Value": ["094907.903000"]},
        "2810": {"vr": "TM", "Value": ["095047.671000"]},
        "2811": {"vr": "TM", "Value": ["095447.950000"]},
        "2812": {"vr": "TM", "Value": ["094947.709000"]},
        "2813": {"vr": "TM", "Value": ["094747.871000"]},
        "2814": {"vr": "TM", "Value": ["094607.747000"]},
        "2815": {"vr": "TM", "Value": ["095047.769000"]},
        "2816": {"vr": "TM", "Value": ["094707.882000"]},
        "2817": {"vr": "TM", "Value": ["095127.642000"]},
        "2818": {"vr": "TM", "Value": ["094827.896000"]},
        "2819": {"vr": "TM", "Value": ["095407.741000"]},
        "2820": {"vr": "TM", "Value": ["094947.839000"]},
        "2821": {"vr": "TM", "Value": ["095407.786000"]},
        "2822": {"vr": "TM", "Value": ["095147.722000"]},
        "2823": {"vr": "TM", "Value": ["095347.928000"]},
        "2824": {"vr": "TM", "Value": ["095347.938000"]},
        "2825": {"vr": "TM", "Value": ["094827.826000"]},
        "2826": {"vr": "TM", "Value": ["094607.686000"]},
        "2827": {"vr": "TM", "Value": ["094727.878000"]},
        "2828": {"vr": "TM", "Value": ["095427.614000"]},
        "2829": {"vr": "TM", "Value": ["095307.707000"]},
        "2830": {"vr": "TM", "Value": ["095007.921000"]},
        "2831": {"vr": "TM", "Value": ["095327.945000"]},
        "2832": {"vr": "TM", "Value": ["095107.729000"]},
        "2833": {"vr": "TM", "Value": ["094947.733000"]},
        "2834": {"vr": "TM", "Value": ["095127.713000"]},
        "2835": {"vr": "TM", "Value": ["094907.765000"]},
        "2836": {"vr": "TM", "Value": ["095107.767000"]},
        "2837": {"vr": "TM", "Value": ["094707.800000"]},
        "2838": {"vr": "TM", "Value": ["094827.791000"]},
        "2839": {"vr": "TM", "Value": ["095047.640000"]},
        "2840": {"vr": "TM", "Value": ["094927.943000"]},
        "2841": {"vr": "TM", "Value": ["095247.780000"]},
        "2842": {"vr": "TM", "Value": ["095247.703000"]},
        "2843": {"vr": "TM", "Value": ["094947.652000"]},
        "2844": {"vr": "TM", "Value": ["094747.728000"]},
        "2845": {"vr": "TM", "Value": ["094827.694000"]},
        "2846": {"vr": "TM", "Value": ["094747.911000"]},
        "2847": {"vr": "TM", "Value": ["095327.907000"]},
        "2848": {"vr": "TM", "Value": ["095447.644000"]},
        "2849": {"vr": "TM", "Value": ["095307.926000"]},
        "2850": {"vr": "TM", "Value": ["095147.682000"]},
        "2851": {"vr": "TM", "Value": ["095247.616000"]},
        "2852": {"vr": "TM", "Value": ["095007.783000"]},
        "2853": {"vr": "TM", "Value": ["094727.818000"]},
        "2854": {"vr": "TM", "Value": ["094807.892000"]},
        "2855": {"vr": "TM", "Value": ["094527.625000"]},
        "2856": {"vr": "TM", "Value": ["094907.793000"]},
        "2857": {"vr": "TM", "Value": ["094807.943000"]},
        "2858": {"vr": "TM", "Value": ["094907.678000"]},
        "2859": {"vr": "TM", "Value": ["095227.745000"]},
        "2860": {"vr": "TM", "Value": ["095307.928000"]},
        "2861": {"vr": "TM", "Value": ["094807.633000"]},
        "2862": {"vr": "TM", "Value": ["094527.721000"]},
        "2863": {"vr": "TM", "Value": ["095007.672000"]},
        "2864": {"vr": "TM", "Value": ["094627.662000"]},
        "2865": {"vr": "TM", "Value": ["095247.712000"]},
        "2866": {"vr": "TM", "Value": ["094827.612000"]},
        "2867": {"vr": "TM", "Value": ["095207.826000"]},
        "2868": {"vr": "TM", "Value": ["095327.850000"]},
        "2869": {"vr": "TM", "Value": ["094807.915000"]},
        "2870": {"vr": "TM", "Value": ["094727.800000"]},
        "2871": {"vr": "TM", "Value": ["094547.607000"]},
        "2872": {"vr": "TM", "Value": ["095247.799000"]},
        "2873": {"vr": "TM", "Value": ["095207.716000"]},
        "2874": {"vr": "TM", "Value": ["094847.917000"]},
        "2875": {"vr": "TM", "Value": ["095407.687000"]},
        "2876": {"vr": "TM", "Value": ["094947.862000"]},
        "2877": {"vr": "TM", "Value": ["095047.900000"]},
        "2878": {"vr": "TM", "Value": ["095327.672000"]},
        "2879": {"vr": "TM", "Value": ["095047.946000"]},
        "2880": {"vr": "TM", "Value": ["095047.874000"]},
        "2881": {"vr": "TM", "Value": ["094947.763000"]},
        "2882": {"vr": "TM", "Value": ["094647.980000"]},
        "2883": {"vr": "TM", "Value": ["094607.938000"]},
        "2884": {"vr": "TM", "Value": ["094607.678000"]},
        "2885": {"vr": "TM", "Value": ["094847.824000"]},
        "2886": {"vr": "TM", "Value": ["095047.710000"]},
        "2887": {"vr": "TM", "Value": ["094907.906000"]},
        "2888": {"vr": "TM", "Value": ["094907.816000"]},
        "2889": {"vr": "TM", "Value": ["095447.670000"]},
        "2890": {"vr": "TM", "Value": ["094627.939000"]},
        "2891": {"vr": "TM", "Value": ["094707.899000"]},
        "2892": {"vr": "TM", "Value": ["095307.871000"]},
        "2893": {"vr": "TM", "Value": ["094827.628000"]},
        "2894": {"vr": "TM", "Value": ["095007.624000"]},
        "2895": {"vr": "TM", "Value": ["094547.806000"]},
        "2896": {"vr": "TM", "Value": ["095327.943000"]},
        "2897": {"vr": "TM", "Value": ["094947.673000"]},
        "2898": {"vr": "TM", "Value": ["095027.839000"]},
        "2899": {"vr": "TM", "Value": ["094747.751000"]},
        "2900": {"vr": "TM", "Value": ["095127.661000"]},
        "2901": {"vr": "TM", "Value": ["094627.655000"]},
        "2902": {"vr": "TM", "Value": ["095407.756000"]},
        "2903": {"vr": "TM", "Value": ["095127.796000"]},
        "2904": {"vr": "TM", "Value": ["095127.687000"]},
        "2905": {"vr": "TM", "Value": ["094747.941000"]},
        "2906": {"vr": "TM", "Value": ["094527.644000"]},
        "2907": {"vr": "TM", "Value": ["095456.422000"]},
        "2908": {"vr": "TM", "Value": ["094647.668000"]},
        "2909": {"vr": "TM", "Value": ["095427.737000"]},
        "2910": {"vr": "TM", "Value": ["094807.890000"]},
        "2911": {"vr": "TM", "Value": ["095407.743000"]},
        "2912": {"vr": "TM", "Value": ["094627.733000"]},
        "2913": {"vr": "TM", "Value": ["094927.791000"]},
        "2914": {"vr": "TM", "Value": ["094647.625000"]},
        "2915": {"vr": "TM", "Value": ["095027.951000"]},
        "2916": {"vr": "TM", "Value": ["095007.810000"]},
        "2917": {"vr": "TM", "Value": ["094807.883000"]},
        "2918": {"vr": "TM", "Value": ["094527.714000"]},
        "2919": {"vr": "TM", "Value": ["095456.519000"]},
        "2920": {"vr": "TM", "Value": ["095227.770000"]},
        "2921": {"vr": "TM", "Value": ["095147.625000"]},
        "2922": {"vr": "TM", "Value": ["095207.672000"]},
        "2923": {"vr": "TM", "Value": ["095007.829000"]},
        "2924": {"vr": "TM", "Value": ["095127.762000"]},
        "2925": {"vr": "TM", "Value": ["094607.732000"]},
        "2926": {"vr": "TM", "Value": ["094707.717000"]},
        "2927": {"vr": "TM", "Value": ["095307.822000"]},
        "2928": {"vr": "TM", "Value": ["094747.964000"]},
        "2929": {"vr": "TM", "Value": ["094527.919000"]},
        "2930": {"vr": "TM", "Value": ["094707.617000"]},
        "2931": {"vr": "TM", "Value": ["095447.899000"]},
        "2932": {"vr": "TM", "Value": ["095427.939000"]},
        "2933": {"vr": "TM", "Value": ["094647.627000"]},
        "2934": {"vr": "TM", "Value": ["095107.651000"]},
        "2935": {"vr": "TM", "Value": ["094707.685000"]},
        "2936": {"vr": "TM", "Value": ["095207.752000"]},
        "2937": {"vr": "TM", "Value": ["095307.866000"]},
        "2938": {"vr": "TM", "Value": ["095307.905000"]},
        "2939": {"vr": "TM", "Value": ["094847.827000"]},
        "2940": {"vr": "TM", "Value": ["094927.608000"]},
        "2941": {"vr": "TM", "Value": ["094727.860000"]},
        "2942": {"vr": "TM", "Value": ["095347.733000"]},
        "2943": {"vr": "TM", "Value": ["095207.659000"]},
        "2944": {"vr": "TM", "Value": ["095407.865000"]},
        "2945": {"vr": "TM", "Value": ["095447.926000"]},
        "2946": {"vr": "TM", "Value": ["094827.856000"]},
        "2947": {"vr": "TM", "Value": ["095307.912000"]},
        "2948": {"vr": "TM", "Value": ["094947.728000"]},
        "2949": {"vr": "TM", "Value": ["094527.705000"]},
        "2950": {"vr": "TM", "Value": ["094707.838000"]},
        "2951": {"vr": "TM", "Value": ["095107.817000"]},
        "2952": {"vr": "TM", "Value": ["095407.857000"]},
        "2953": {"vr": "TM", "Value": ["094907.813000"]},
        "2954": {"vr": "TM", "Value": ["095007.880000"]},
        "2955": {"vr": "TM", "Value": ["095147.854000"]},
        "2956": {"vr": "TM", "Value": ["095227.750000"]},
        "2957": {"vr": "TM", "Value": ["094627.899000"]},
        "2958": {"vr": "TM", "Value": ["094647.652000"]},
        "2959": {"vr": "TM", "Value": ["094747.829000"]},
        "2960": {"vr": "TM", "Value": ["094807.748000"]},
        "2961": {"vr": "TM", "Value": ["094747.935000"]},
        "2962": {"vr": "TM", "Value": ["094747.916000"]},
        "2963": {"vr": "TM", "Value": ["095347.654000"]},
        "2964": {"vr": "TM", "Value": ["094707.722000"]},
        "2965": {"vr": "TM", "Value": ["095327.863000"]},
        "2966": {"vr": "TM", "Value": ["094847.855000"]},
        "2967": {"vr": "TM", "Value": ["094607.841000"]},
        "2968": {"vr": "TM", "Value": ["094827.957000"]},
        "2969": {"vr": "TM", "Value": ["094707.879000"]},
        "2970": {"vr": "TM", "Value": ["095247.851000"]},
        "2971": {"vr": "TM", "Value": ["095447.861000"]},
        "2972": {"vr": "TM", "Value": ["095327.912000"]},
        "2973": {"vr": "TM", "Value": ["095047.728000"]},
        "2974": {"vr": "TM", "Value": ["094707.902000"]},
        "2975": {"vr": "TM", "Value": ["094547.886000"]},
        "2976": {"vr": "TM", "Value": ["094747.877000"]},
        "2977": {"vr": "TM", "Value": ["095107.699000"]},
        "2978": {"vr": "TM", "Value": ["094647.636000"]},
        "2979": {"vr": "TM", "Value": ["095307.625000"]},
        "2980": {"vr": "TM", "Value": ["095027.762000"]},
        "2981": {"vr": "TM", "Value": ["095227.814000"]},
        "2982": {"vr": "TM", "Value": ["095107.913000"]},
        "2983": {"vr": "TM", "Value": ["094627.744000"]},
        "2984": {"vr": "TM", "Value": ["095307.710000"]},
        "2985": {"vr": "TM", "Value": ["094847.629000"]},
        "2986": {"vr": "TM", "Value": ["094827.816000"]},
        "2987": {"vr": "TM", "Value": ["095127.682000"]},
        "2988": {"vr": "TM", "Value": ["095127.789000"]},
        "2989": {"vr": "TM", "Value": ["095247.670000"]},
        "2990": {"vr": "TM", "Value": ["094547.704000"]},
        "2991": {"vr": "TM", "Value": ["095207.629000"]},
        "2992": {"vr": "TM", "Value": ["095127.791000"]},
        "2993": {"vr": "TM", "Value": ["095027.795000"]},
        "2994": {"vr": "TM", "Value": ["095247.787000"]},
        "2995": {"vr": "TM", "Value": ["095347.774000"]},
        "2996": {"vr": "TM", "Value": ["094927.901000"]},
        "2997": {"vr": "TM", "Value": ["094807.697000"]},
        "2998": {"vr": "TM", "Value": ["095047.749000"]},
        "2999": {"vr": "TM", "Value": ["095027.814000"]},
        "3000": {"vr": "TM", "Value": ["095247.918000"]},
        "3001": {"vr": "TM", "Value": ["094627.731000"]},
        "3002": {"vr": "TM", "Value": ["095327.932000"]},
        "3003": {"vr": "TM", "Value": ["095127.737000"]},
        "3004": {"vr": "TM", "Value": ["095227.880000"]},
        "3005": {"vr": "TM", "Value": ["095456.430000"]},
        "3006": {"vr": "TM", "Value": ["095227.866000"]},
        "3007": {"vr": "TM", "Value": ["095307.753000"]},
        "3008": {"vr": "TM", "Value": ["094607.898000"]},
        "3009": {"vr": "TM", "Value": ["094707.740000"]},
        "3010": {"vr": "TM", "Value": ["095207.948000"]},
        "3011": {"vr": "TM", "Value": ["094847.814000"]},
        "3012": {"vr": "TM", "Value": ["094847.925000"]},
        "3013": {"vr": "TM", "Value": ["094727.763000"]},
        "3014": {"vr": "TM", "Value": ["095447.729000"]},
        "3015": {"vr": "TM", "Value": ["094907.954000"]},
        "3016": {"vr": "TM", "Value": ["094947.908000"]},
        "3017": {"vr": "TM", "Value": ["095047.807000"]},
        "3018": {"vr": "TM", "Value": ["095347.817000"]},
        "3019": {"vr": "TM", "Value": ["094527.744000"]},
        "3020": {"vr": "TM", "Value": ["094927.647000"]},
        "3021": {"vr": "TM", "Value": ["095047.623000"]},
        "3022": {"vr": "TM", "Value": ["094827.786000"]},
        "3023": {"vr": "TM", "Value": ["095127.755000"]},
        "3024": {"vr": "TM", "Value": ["095027.934000"]},
        "3025": {"vr": "TM", "Value": ["095307.629000"]},
        "3026": {"vr": "TM", "Value": ["094527.892000"]},
        "3027": {"vr": "TM", "Value": ["094727.670000"]},
        "3028": {"vr": "TM", "Value": ["094927.873000"]},
        "3029": {"vr": "TM", "Value": ["095147.845000"]},
        "3030": {"vr": "TM", "Value": ["095307.748000"]},
        "3031": {"vr": "TM", "Value": ["095307.923000"]},
        "3032": {"vr": "TM", "Value": ["095447.783000"]},
        "3033": {"vr": "TM", "Value": ["094647.754000"]},
        "3034": {"vr": "TM", "Value": ["094807.726000"]},
        "3035": {"vr": "TM", "Value": ["094907.673000"]},
        "3036": {"vr": "TM", "Value": ["095347.679000"]},
        "3037": {"vr": "TM", "Value": ["095047.948000"]},
        "3038": {"vr": "TM", "Value": ["094647.835000"]},
        "3039": {"vr": "TM", "Value": ["094647.827000"]},
        "3040": {"vr": "TM", "Value": ["094647.841000"]},
        "3041": {"vr": "TM", "Value": ["094747.879000"]},
        "3042": {"vr": "TM", "Value": ["095127.689000"]},
        "3043": {"vr": "TM", "Value": ["095247.715000"]},
        "3044": {"vr": "TM", "Value": ["095307.949000"]},
        "3045": {"vr": "TM", "Value": ["094627.840000"]},
        "3046": {"vr": "TM", "Value": ["094727.667000"]},
        "3047": {"vr": "TM", "Value": ["094947.706000"]},
        "3048": {"vr": "TM", "Value": ["094927.635000"]},
        "3049": {"vr": "TM", "Value": ["095407.948000"]},
        "3050": {"vr": "TM", "Value": ["095127.890000"]},
        "3051": {"vr": "TM", "Value": ["095027.819000"]},
        "3052": {"vr": "TM", "Value": ["094727.931000"]},
        "3053": {"vr": "TM", "Value": ["094647.912000"]},
        "3054": {"vr": "TM", "Value": ["095327.611000"]},
        "3055": {"vr": "TM", "Value": ["094607.629000"]},
        "3056": {"vr": "TM", "Value": ["095407.692000"]},
        "3057": {"vr": "TM", "Value": ["094607.815000"]},
        "3058": {"vr": "TM", "Value": ["094727.797000"]},
        "3059": {"vr": "TM", "Value": ["094727.802000"]},
        "3060": {"vr": "TM", "Value": ["095127.870000"]},
        "3061": {"vr": "TM", "Value": ["094827.758000"]},
        "3062": {"vr": "TM", "Value": ["095427.804000"]},
        "3063": {"vr": "TM", "Value": ["095407.608000"]},
        "3064": {"vr": "TM", "Value": ["094927.788000"]},
        "3065": {"vr": "TM", "Value": ["095127.639000"]},
        "3066": {"vr": "TM", "Value": ["095227.760000"]},
        "3067": {"vr": "TM", "Value": ["095027.710000"]},
        "3068": {"vr": "TM", "Value": ["095207.762000"]},
        "3069": {"vr": "TM", "Value": ["095027.897000"]},
        "3070": {"vr": "TM", "Value": ["095427.848000"]},
        "3071": {"vr": "TM", "Value": ["095027.672000"]},
        "3072": {"vr": "TM", "Value": ["095147.818000"]},
        "3073": {"vr": "TM", "Value": ["094747.684000"]},
        "3074": {"vr": "TM", "Value": ["094647.928000"]},
        "3075": {"vr": "TM", "Value": ["095447.706000"]},
        "3076": {"vr": "TM", "Value": ["094547.729000"]},
        "3077": {"vr": "TM", "Value": ["095147.765000"]},
        "3078": {"vr": "TM", "Value": ["095047.762000"]},
        "3079": {"vr": "TM", "Value": ["094927.679000"]},
        "3080": {"vr": "TM", "Value": ["094547.881000"]},
        "3081": {"vr": "TM", "Value": ["095327.938000"]},
        "3082": {"vr": "TM", "Value": ["095347.948000"]},
        "3083": {"vr": "TM", "Value": ["094847.898000"]},
        "3084": {"vr": "TM", "Value": ["095047.739000"]},
        "3085": {"vr": "TM", "Value": ["094847.895000"]},
        "3086": {"vr": "TM", "Value": ["095047.726000"]},
        "3087": {"vr": "TM", "Value": ["094547.781000"]},
        "3088": {"vr": "TM", "Value": ["095227.873000"]},
        "3089": {"vr": "TM", "Value": ["094527.668000"]},
        "3090": {"vr": "TM", "Value": ["095407.733000"]},
        "3091": {"vr": "TM", "Value": ["095107.901000"]},
        "3092": {"vr": "TM", "Value": ["094707.624000"]},
        "3093": {"vr": "TM", "Value": ["094807.607000"]},
        "3094": {"vr": "TM", "Value": ["095247.796000"]},
        "3095": {"vr": "TM", "Value": ["095247.743000"]},
        "3096": {"vr": "TM", "Value": ["095107.656000"]},
        "3097": {"vr": "TM", "Value": ["095007.931000"]},
        "3098": {"vr": "TM", "Value": ["094927.747000"]},
        "3099": {"vr": "TM", "Value": ["094827.821000"]},
        "3100": {"vr": "TM", "Value": ["094727.820000"]},
        "3101": {"vr": "TM", "Value": ["094827.618000"]},
        "3102": {"vr": "TM", "Value": ["095147.772000"]},
        "3103": {"vr": "TM", "Value": ["095147.613000"]},
        "3104": {"vr": "TM", "Value": ["095127.627000"]},
        "3105": {"vr": "TM", "Value": ["094907.895000"]},
        "3106": {"vr": "TM", "Value": ["094807.694000"]},
        "3107": {"vr": "TM", "Value": ["095407.728000"]},
        "3108": {"vr": "TM", "Value": ["095447.906000"]},
        "3109": {"vr": "TM", "Value": ["095427.868000"]},
        "3110": {"vr": "TM", "Value": ["094907.703000"]},
        "3111": {"vr": "TM", "Value": ["094827.623000"]},
        "3112": {"vr": "TM", "Value": ["094827.662000"]},
        "3113": {"vr": "TM", "Value": ["095227.863000"]},
        "3114": {"vr": "TM", "Value": ["094807.775000"]},
        "3115": {"vr": "TM", "Value": ["094527.845000"]},
        "3116": {"vr": "TM", "Value": ["094707.689000"]},
        "3117": {"vr": "TM", "Value": ["094907.686000"]},
        "3118": {"vr": "TM", "Value": ["094907.718000"]},
        "3119": {"vr": "TM", "Value": ["094647.888000"]},
        "3120": {"vr": "TM", "Value": ["095427.902000"]},
        "3121": {"vr": "TM", "Value": ["094847.946000"]},
        "3122": {"vr": "TM", "Value": ["094627.834000"]},
        "3123": {"vr": "TM", "Value": ["095307.848000"]},
        "3124": {"vr": "TM", "Value": ["094547.719000"]},
        "3125": {"vr": "TM", "Value": ["095247.784000"]},
        "3126": {"vr": "TM", "Value": ["095307.876000"]},
        "3127": {"vr": "TM", "Value": ["095207.790000"]},
        "3128": {"vr": "TM", "Value": ["095307.768000"]},
        "3129": {"vr": "TM", "Value": ["094607.796000"]},
        "3130": {"vr": "TM", "Value": ["094807.758000"]},
        "3131": {"vr": "TM", "Value": ["094847.644000"]},
        "3132": {"vr": "TM", "Value": ["094527.716000"]},
        "3133": {"vr": "TM", "Value": ["095207.943000"]},
        "3134": {"vr": "TM", "Value": ["095027.900000"]},
        "3135": {"vr": "TM", "Value": ["095347.797000"]},
        "3136": {"vr": "TM", "Value": ["094547.721000"]},
        "3137": {"vr": "TM", "Value": ["095407.914000"]},
        "3138": {"vr": "TM", "Value": ["094607.668000"]},
        "3139": {"vr": "TM", "Value": ["094547.672000"]},
        "3140": {"vr": "TM", "Value": ["095047.708000"]},
        "3141": {"vr": "TM", "Value": ["094807.802000"]},
        "3142": {"vr": "TM", "Value": ["095327.814000"]},
        "3143": {"vr": "TM", "Value": ["094627.914000"]},
        "3144": {"vr": "TM", "Value": ["094727.711000"]},
        "3145": {"vr": "TM", "Value": ["094527.945000"]},
        "3146": {"vr": "TM", "Value": ["095027.713000"]},
        "3147": {"vr": "TM", "Value": ["094727.771000"]},
        "3148": {"vr": "TM", "Value": ["094807.692000"]},
        "3149": {"vr": "TM", "Value": ["095147.948000"]},
        "3150": {"vr": "TM", "Value": ["095047.780000"]},
        "3151": {"vr": "TM", "Value": ["094707.747000"]},
        "3152": {"vr": "TM", "Value": ["095107.701000"]},
        "3153": {"vr": "TM", "Value": ["095307.686000"]},
        "3154": {"vr": "TM", "Value": ["094747.933000"]},
        "3155": {"vr": "TM", "Value": ["095427.822000"]},
        "3156": {"vr": "TM", "Value": ["094727.807000"]},
        "3157": {"vr": "TM", "Value": ["095247.873000"]},
        "3158": {"vr": "TM", "Value": ["095027.759000"]},
        "3159": {"vr": "TM", "Value": ["094807.658000"]},
        "3160": {"vr": "TM", "Value": ["094527.750000"]},
        "3161": {"vr": "TM", "Value": ["095007.761000"]},
        "3162": {"vr": "TM", "Value": ["094947.759000"]},
        "3163": {"vr": "TM", "Value": ["094607.916000"]},
        "3164": {"vr": "TM", "Value": ["094747.665000"]},
        "3165": {"vr": "TM", "Value": ["094527.646000"]},
        "3166": {"vr": "TM", "Value": ["094647.762000"]},
        "3167": {"vr": "TM", "Value": ["094647.617000"]},
        "3168": {"vr": "TM", "Value": ["095307.646000"]},
        "3169": {"vr": "TM", "Value": ["095007.773000"]},
        "3170": {"vr": "TM", "Value": ["095447.799000"]},
        "3171": {"vr": "TM", "Value": ["095027.782000"]},
        "3172": {"vr": "TM", "Value": ["095456.512000"]},
        "3173": {"vr": "TM", "Value": ["095327.883000"]},
        "3174": {"vr": "TM", "Value": ["094827.680000"]},
        "3175": {"vr": "TM", "Value": ["095007.746000"]},
        "3176": {"vr": "TM", "Value": ["095447.943000"]},
        "3177": {"vr": "TM", "Value": ["094927.709000"]},
        "3178": {"vr": "TM", "Value": ["095107.857000"]},
        "3179": {"vr": "TM", "Value": ["094907.822000"]},
        "3180": {"vr": "TM", "Value": ["095247.888000"]},
        "3181": {"vr": "TM", "Value": ["095307.733000"]},
        "3182": {"vr": "TM", "Value": ["095307.666000"]},
        "3183": {"vr": "TM", "Value": ["094807.676000"]},
        "3184": {"vr": "TM", "Value": ["094647.830000"]},
        "3185": {"vr": "TM", "Value": ["095307.756000"]},
        "3186": {"vr": "TM", "Value": ["095227.658000"]},
        "3187": {"vr": "TM", "Value": ["094927.737000"]},
        "3188": {"vr": "TM", "Value": ["094747.835000"]},
        "3189": {"vr": "TM", "Value": ["094747.850000"]},
        "3190": {"vr": "TM", "Value": ["095347.963000"]},
        "3191": {"vr": "TM", "Value": ["095307.918000"]},
        "3192": {"vr": "TM", "Value": ["095127.680000"]},
        "3193": {"vr": "TM", "Value": ["095007.841000"]},
        "3194": {"vr": "TM", "Value": ["094527.756000"]},
        "3195": {"vr": "TM", "Value": ["094927.868000"]},
        "3196": {"vr": "TM", "Value": ["094647.794000"]},
        "3197": {"vr": "TM", "Value": ["095247.883000"]},
        "3198": {"vr": "TM", "Value": ["095027.680000"]},
        "3199": {"vr": "TM", "Value": ["094907.770000"]},
        "3200": {"vr": "TM", "Value": ["094527.904000"]},
        "3201": {"vr": "TM", "Value": ["095247.836000"]},
        "3202": {"vr": "TM", "Value": ["095447.824000"]},
        "3203": {"vr": "TM", "Value": ["094947.806000"]},
        "3204": {"vr": "TM", "Value": ["094947.825000"]},
        "3205": {"vr": "TM", "Value": ["095447.760000"]},
        "3206": {"vr": "TM", "Value": ["094647.685000"]},
        "3207": {"vr": "TM", "Value": ["094907.755000"]},
        "3208": {"vr": "TM", "Value": ["094927.750000"]},
        "3209": {"vr": "TM", "Value": ["095227.783000"]},
        "3210": {"vr": "TM", "Value": ["094627.967000"]},
        "3211": {"vr": "TM", "Value": ["095047.912000"]},
        "3212": {"vr": "TM", "Value": ["095007.697000"]},
        "3213": {"vr": "TM", "Value": ["095307.894000"]},
        "3214": {"vr": "TM", "Value": ["095456.483000"]},
        "3215": {"vr": "TM", "Value": ["095407.695000"]},
        "3216": {"vr": "TM", "Value": ["095147.946000"]},
        "3217": {"vr": "TM", "Value": ["094627.891000"]},
        "3218": {"vr": "TM", "Value": ["094527.697000"]},
        "3219": {"vr": "TM", "Value": ["094747.824000"]},
        "3220": {"vr": "TM", "Value": ["095027.639000"]},
        "3221": {"vr": "TM", "Value": ["094727.615000"]},
        "3222": {"vr": "TM", "Value": ["095347.856000"]},
        "3223": {"vr": "TM", "Value": ["094907.676000"]},
        "3224": {"vr": "TM", "Value": ["094527.863000"]},
        "3225": {"vr": "TM", "Value": ["095147.674000"]},
        "3226": {"vr": "TM", "Value": ["095127.806000"]},
        "3227": {"vr": "TM", "Value": ["094747.814000"]},
        "3228": {"vr": "TM", "Value": ["095227.729000"]},
        "3229": {"vr": "TM", "Value": ["094627.807000"]},
        "3230": {"vr": "TM", "Value": ["094827.922000"]},
        "3231": {"vr": "TM", "Value": ["095207.700000"]},
        "3232": {"vr": "TM", "Value": ["094747.796000"]},
        "3233": {"vr": "TM", "Value": ["095427.858000"]},
        "3234": {"vr": "TM", "Value": ["094747.967000"]},
        "3235": {"vr": "TM", "Value": ["095147.622000"]},
        "3236": {"vr": "TM", "Value": ["094907.624000"]},
        "3237": {"vr": "TM", "Value": ["094927.933000"]},
        "3238": {"vr": "TM", "Value": ["095347.840000"]},
        "3239": {"vr": "TM", "Value": ["095307.735000"]},
        "3240": {"vr": "TM", "Value": ["095447.904000"]},
        "3241": {"vr": "TM", "Value": ["095227.842000"]},
        "3242": {"vr": "TM", "Value": ["094747.717000"]},
        "3243": {"vr": "TM", "Value": ["095007.904000"]},
        "3244": {"vr": "TM", "Value": ["094647.622000"]},
        "3245": {"vr": "TM", "Value": ["094527.873000"]},
        "3246": {"vr": "TM", "Value": ["095347.705000"]},
        "3247": {"vr": "TM", "Value": ["094927.753000"]},
        "3248": {"vr": "TM", "Value": ["095127.885000"]},
        "3249": {"vr": "TM", "Value": ["094847.935000"]},
        "3250": {"vr": "TM", "Value": ["095347.753000"]},
        "3251": {"vr": "TM", "Value": ["095107.632000"]},
        "3252": {"vr": "TM", "Value": ["095047.892000"]},
        "3253": {"vr": "TM", "Value": ["095307.817000"]},
        "3254": {"vr": "TM", "Value": ["095327.811000"]},
        "3255": {"vr": "TM", "Value": ["095447.938000"]},
        "3256": {"vr": "TM", "Value": ["095147.821000"]},
        "3257": {"vr": "TM", "Value": ["095307.668000"]},
        "3258": {"vr": "TM", "Value": ["095007.870000"]},
        "3259": {"vr": "TM", "Value": ["094607.781000"]},
        "3260": {"vr": "TM", "Value": ["095047.741000"]},
        "3261": {"vr": "TM", "Value": ["094927.637000"]},
        "3262": {"vr": "TM", "Value": ["094927.717000"]},
        "3263": {"vr": "TM", "Value": ["094827.789000"]},
        "3264": {"vr": "TM", "Value": ["095007.907000"]},
        "3265": {"vr": "TM", "Value": ["095347.830000"]},
        "3266": {"vr": "TM", "Value": ["095407.847000"]},
        "3267": {"vr": "TM", "Value": ["094927.765000"]},
        "3268": {"vr": "TM", "Value": ["094827.831000"]},
        "3269": {"vr": "TM", "Value": ["095227.804000"]},
        "3270": {"vr": "TM", "Value": ["095456.437000"]},
        "3271": {"vr": "TM", "Value": ["094747.919000"]},
        "3272": {"vr": "TM", "Value": ["095407.934000"]},
        "3273": {"vr": "TM", "Value": ["095447.680000"]},
        "3274": {"vr": "TM", "Value": ["095447.913000"]},
        "3275": {"vr": "TM", "Value": ["094727.863000"]},
        "3276": {"vr": "TM", "Value": ["094747.673000"]},
        "3277": {"vr": "TM", "Value": ["095047.754000"]},
        "3278": {"vr": "TM", "Value": ["095347.687000"]},
        "3279": {"vr": "TM", "Value": ["095347.707000"]},
        "3280": {"vr": "TM", "Value": ["094827.942000"]},
        "3281": {"vr": "TM", "Value": ["094747.809000"]},
        "3282": {"vr": "TM", "Value": ["094827.797000"]},
        "3283": {"vr": "TM", "Value": ["094647.717000"]},
        "3284": {"vr": "TM", "Value": ["095207.713000"]},
        "3285": {"vr": "TM", "Value": ["095047.884000"]},
        "3286": {"vr": "TM", "Value": ["095127.701000"]},
        "3287": {"vr": "TM", "Value": ["095327.845000"]},
        "3288": {"vr": "TM", "Value": ["094807.671000"]},
        "3289": {"vr": "TM", "Value": ["094647.729000"]},
        "3290": {"vr": "TM", "Value": ["094647.642000"]},
        "3291": {"vr": "TM", "Value": ["095107.644000"]},
        "3292": {"vr": "TM", "Value": ["095427.865000"]},
        "3293": {"vr": "TM", "Value": ["095007.621000"]},
        "3294": {"vr": "TM", "Value": ["095027.921000"]},
        "3295": {"vr": "TM", "Value": ["095127.654000"]},
        "3296": {"vr": "TM", "Value": ["094747.743000"]},
        "3297": {"vr": "TM", "Value": ["094747.676000"]},
        "3298": {"vr": "TM", "Value": ["094907.606000"]},
        "3299": {"vr": "TM", "Value": ["094627.865000"]},
        "3300": {"vr": "TM", "Value": ["094947.665000"]},
        "3301": {"vr": "TM", "Value": ["094947.875000"]},
        "3302": {"vr": "TM", "Value": ["095127.649000"]},
        "3303": {"vr": "TM", "Value": ["095447.874000"]},
        "3304": {"vr": "TM", "Value": ["094727.632000"]},
        "3305": {"vr": "TM", "Value": ["094927.904000"]},
        "3306": {"vr": "TM", "Value": ["095427.664000"]},
        "3307": {"vr": "TM", "Value": ["094607.809000"]},
        "3308": {"vr": "TM", "Value": ["094807.900000"]},
        "3309": {"vr": "TM", "Value": ["095207.933000"]},
        "3310": {"vr": "TM", "Value": ["094607.693000"]},
        "3311": {"vr": "TM", "Value": ["094847.740000"]},
        "3312": {"vr": "TM", "Value": ["095107.930000"]},
        "3313": {"vr": "TM", "Value": ["094527.804000"]},
        "3314": {"vr": "TM", "Value": ["094947.735000"]},
        "3315": {"vr": "TM", "Value": ["095007.926000"]},
        "3316": {"vr": "TM", "Value": ["094727.805000"]},
        "3317": {"vr": "TM", "Value": ["095407.625000"]},
        "3318": {"vr": "TM", "Value": ["095027.774000"]},
        "3319": {"vr": "TM", "Value": ["095307.838000"]},
        "3320": {"vr": "TM", "Value": ["095427.685000"]},
        "3321": {"vr": "TM", "Value": ["095227.918000"]},
        "3322": {"vr": "TM", "Value": ["095127.853000"]},
        "3323": {"vr": "TM", "Value": ["095047.695000"]},
        "3324": {"vr": "TM", "Value": ["095007.689000"]},
        "3325": {"vr": "TM", "Value": ["094727.708000"]},
        "3326": {"vr": "TM", "Value": ["094847.933000"]},
        "3327": {"vr": "TM", "Value": ["094947.650000"]},
        "3328": {"vr": "TM", "Value": ["095327.704000"]},
        "3329": {"vr": "TM", "Value": ["094807.780000"]},
        "3330": {"vr": "TM", "Value": ["094607.644000"]},
        "3331": {"vr": "TM", "Value": ["095447.837000"]},
        "3332": {"vr": "TM", "Value": ["095407.771000"]},
        "3333": {"vr": "TM", "Value": ["094807.868000"]},
        "3334": {"vr": "TM", "Value": ["095107.689000"]},
        "3335": {"vr": "TM", "Value": ["094947.851000"]},
        "3336": {"vr": "TM", "Value": ["094647.809000"]},
        "3337": {"vr": "TM", "Value": ["094527.776000"]},
        "3338": {"vr": "TM", "Value": ["094707.861000"]},
        "3339": {"vr": "TM", "Value": ["095107.843000"]},
        "3340": {"vr": "TM", "Value": ["094947.668000"]},
        "3341": {"vr": "TM", "Value": ["095127.927000"]},
        "3342": {"vr": "TM", "Value": ["095307.722000"]},
        "3343": {"vr": "TM", "Value": ["095007.853000"]},
        "3344": {"vr": "TM", "Value": ["094547.664000"]},
        "3345": {"vr": "TM", "Value": ["095107.899000"]},
        "3346": {"vr": "TM", "Value": ["095347.810000"]},
        "3347": {"vr": "TM", "Value": ["094827.901000"]},
        "3348": {"vr": "TM", "Value": ["094907.775000"]},
        "3349": {"vr": "TM", "Value": ["095427.789000"]},
        "3350": {"vr": "TM", "Value": ["094707.848000"]},
        "3351": {"vr": "TM", "Value": ["094627.820000"]},
        "3352": {"vr": "TM", "Value": ["094747.861000"]},
        "3353": {"vr": "TM", "Value": ["095327.868000"]},
        "3354": {"vr": "TM", "Value": ["094907.811000"]},
        "3355": {"vr": "TM", "Value": ["095007.700000"]},
        "3356": {"vr": "TM", "Value": ["095027.821000"]},
        "3357": {"vr": "TM", "Value": ["094547.799000"]},
        "3358": {"vr": "TM", "Value": ["094807.822000"]},
        "3359": {"vr": "TM", "Value": ["095407.669000"]},
        "3360": {"vr": "TM", "Value": ["095347.672000"]},
        "3361": {"vr": "TM", "Value": ["094907.636000"]},
        "3362": {"vr": "TM", "Value": ["094927.870000"]},
        "3363": {"vr": "TM", "Value": ["095347.769000"]},
        "3364": {"vr": "TM", "Value": ["095247.834000"]},
        "3365": {"vr": "TM", "Value": ["095456.497000"]},
        "3366": {"vr": "TM", "Value": ["095427.745000"]},
        "3367": {"vr": "TM", "Value": ["095347.833000"]},
        "3368": {"vr": "TM", "Value": ["094727.622000"]},
        "3369": {"vr": "TM", "Value": ["095247.654000"]},
        "3370": {"vr": "TM", "Value": ["095147.887000"]},
        "3371": {"vr": "TM", "Value": ["094927.796000"]},
        "3372": {"vr": "TM", "Value": ["095247.767000"]},
        "3373": {"vr": "TM", "Value": ["095207.928000"]},
        "3374": {"vr": "TM", "Value": ["095047.879000"]},
        "3375": {"vr": "TM", "Value": ["095227.911000"]},
        "3376": {"vr": "TM", "Value": ["094827.912000"]},
        "3377": {"vr": "TM", "Value": ["095247.925000"]},
        "3378": {"vr": "TM", "Value": ["094907.740000"]},
        "3379": {"vr": "TM", "Value": ["095027.613000"]},
        "3380": {"vr": "TM", "Value": ["094747.811000"]},
        "3381": {"vr": "TM", "Value": ["095227.684000"]},
        "3382": {"vr": "TM", "Value": ["095007.851000"]},
        "3383": {"vr": "TM", "Value": ["094607.936000"]},
        "3384": {"vr": "TM", "Value": ["095007.812000"]},
        "3385": {"vr": "TM", "Value": ["094807.921000"]},
        "3386": {"vr": "TM", "Value": ["095207.923000"]},
        "3387": {"vr": "TM", "Value": ["095447.834000"]},
        "3388": {"vr": "TM", "Value": ["094947.938000"]},
        "3389": {"vr": "TM", "Value": ["095327.682000"]},
        "3390": {"vr": "TM", "Value": ["095327.901000"]},
        "3391": {"vr": "TM", "Value": ["094827.714000"]},
        "3392": {"vr": "TM", "Value": ["094807.663000"]},
        "3393": {"vr": "TM", "Value": ["095007.763000"]},
        "3394": {"vr": "TM", "Value": ["094607.676000"]},
        "3395": {"vr": "TM", "Value": ["095207.926000"]},
        "3396": {"vr": "TM", "Value": ["094707.919000"]},
        "3397": {"vr": "TM", "Value": ["094807.924000"]},
        "3398": {"vr": "TM", "Value": ["094647.740000"]},
        "3399": {"vr": "TM", "Value": ["095227.832000"]},
        "3400": {"vr": "TM", "Value": ["095027.837000"]},
        "3401": {"vr": "TM", "Value": ["095007.611000"]},
        "3402": {"vr": "TM", "Value": ["095127.684000"]},
        "3403": {"vr": "TM", "Value": ["094907.649000"]},
        "3404": {"vr": "TM", "Value": ["094807.618000"]},
        "3405": {"vr": "TM", "Value": ["095007.863000"]},
        "3406": {"vr": "TM", "Value": ["095247.829000"]},
        "3407": {"vr": "TM", "Value": ["094727.619000"]},
        "3408": {"vr": "TM", "Value": ["094627.906000"]},
        "3409": {"vr": "TM", "Value": ["095207.754000"]},
        "3410": {"vr": "TM", "Value": ["095107.889000"]},
        "3411": {"vr": "TM", "Value": ["095227.704000"]},
        "3412": {"vr": "TM", "Value": ["095407.809000"]},
        "3413": {"vr": "TM", "Value": ["095427.719000"]},
        "3414": {"vr": "TM", "Value": ["095307.717000"]},
        "3415": {"vr": "TM", "Value": ["095327.853000"]},
        "3416": {"vr": "TM", "Value": ["094927.953000"]},
        "3417": {"vr": "TM", "Value": ["095127.819000"]},
        "3418": {"vr": "TM", "Value": ["094547.677000"]},
        "3419": {"vr": "TM", "Value": ["095347.720000"]},
        "3420": {"vr": "TM", "Value": ["094747.740000"]},
        "3421": {"vr": "TM", "Value": ["094647.660000"]},
        "3422": {"vr": "TM", "Value": ["095407.634000"]},
        "3423": {"vr": "TM", "Value": ["095427.705000"]},
        "3424": {"vr": "TM", "Value": ["095027.718000"]},
        "3425": {"vr": "TM", "Value": ["095007.684000"]},
        "3426": {"vr": "TM", "Value": ["095347.710000"]},
        "3427": {"vr": "TM", "Value": ["095127.675000"]},
        "3428": {"vr": "TM", "Value": ["094927.928000"]},
        "3429": {"vr": "TM", "Value": ["094947.719000"]},
        "3430": {"vr": "TM", "Value": ["095107.871000"]},
        "3431": {"vr": "TM", "Value": ["095327.719000"]},
        "3432": {"vr": "TM", "Value": ["094627.771000"]},
        "3433": {"vr": "TM", "Value": ["094627.721000"]},
        "3434": {"vr": "TM", "Value": ["095227.942000"]},
        "3435": {"vr": "TM", "Value": ["095207.744000"]},
        "3436": {"vr": "TM", "Value": ["095327.748000"]},
        "3437": {"vr": "TM", "Value": ["095347.799000"]},
        "3438": {"vr": "TM", "Value": ["094827.656000"]},
        "3439": {"vr": "TM", "Value": ["095147.657000"]},
        "3440": {"vr": "TM", "Value": ["095247.765000"]},
        "3441": {"vr": "TM", "Value": ["095307.941000"]},
        "3442": {"vr": "TM", "Value": ["095207.731000"]},
        "3443": {"vr": "TM", "Value": ["095347.822000"]},
        "3444": {"vr": "TM", "Value": ["095027.664000"]},
        "3445": {"vr": "TM", "Value": ["094547.625000"]},
        "3446": {"vr": "TM", "Value": ["094527.660000"]},
        "3447": {"vr": "TM", "Value": ["095427.621000"]},
        "3448": {"vr": "TM", "Value": ["094947.742000"]},
        "3449": {"vr": "TM", "Value": ["094907.790000"]},
        "3450": {"vr": "TM", "Value": ["095247.813000"]},
        "3451": {"vr": "TM", "Value": ["095027.931000"]},
        "3452": {"vr": "TM", "Value": ["094847.761000"]},
        "3453": {"vr": "TM", "Value": ["094907.931000"]},
        "3454": {"vr": "TM", "Value": ["094827.870000"]},
        "3455": {"vr": "TM", "Value": ["094627.851000"]},
        "3456": {"vr": "TM", "Value": ["094927.936000"]},
        "3457": {"vr": "TM", "Value": ["095247.668000"]},
        "3458": {"vr": "TM", "Value": ["095107.854000"]},
        "3459": {"vr": "TM", "Value": ["095407.779000"]},
        "3460": {"vr": "TM", "Value": ["095107.711000"]},
        "3461": {"vr": "TM", "Value": ["094647.631000"]},
        "3462": {"vr": "TM", "Value": ["094807.831000"]},
        "3463": {"vr": "TM", "Value": ["095127.814000"]},
        "3464": {"vr": "TM", "Value": ["095447.662000"]},
        "3465": {"vr": "TM", "Value": ["095127.880000"]},
        "3466": {"vr": "TM", "Value": ["094847.906000"]},
        "3467": {"vr": "TM", "Value": ["095347.692000"]},
        "3468": {"vr": "TM", "Value": ["094827.743000"]},
        "3469": {"vr": "TM", "Value": ["094727.776000"]},
        "3470": {"vr": "TM", "Value": ["095127.718000"]},
        "3471": {"vr": "TM", "Value": ["095107.828000"]},
        "3472": {"vr": "TM", "Value": ["095347.874000"]},
        "3473": {"vr": "TM", "Value": ["094607.823000"]},
        "3474": {"vr": "TM", "Value": ["094707.661000"]},
        "3475": {"vr": "TM", "Value": ["094927.863000"]},
        "3476": {"vr": "TM", "Value": ["094547.871000"]},
        "3477": {"vr": "TM", "Value": ["094527.860000"]},
        "3478": {"vr": "TM", "Value": ["095347.936000"]},
        "3479": {"vr": "TM", "Value": ["095107.749000"]},
        "3480": {"vr": "TM", "Value": ["094727.607000"]},
        "3481": {"vr": "TM", "Value": ["095456.451000"]},
        "3482": {"vr": "TM", "Value": ["095307.632000"]},
        "3483": {"vr": "TM", "Value": ["095347.905000"]},
        "3484": {"vr": "TM", "Value": ["095407.661000"]},
        "3485": {"vr": "TM", "Value": ["095127.803000"]},
        "3486": {"vr": "TM", "Value": ["095247.818000"]},
        "3487": {"vr": "TM", "Value": ["095447.889000"]},
        "3488": {"vr": "TM", "Value": ["094547.827000"]},
        "3489": {"vr": "TM", "Value": ["095227.819000"]},
        "3490": {"vr": "TM", "Value": ["094607.722000"]},
        "3491": {"vr": "TM", "Value": ["095347.661000"]},
        "3492": {"vr": "TM", "Value": ["094827.924000"]},
        "3493": {"vr": "TM", "Value": ["095427.771000"]},
        "3494": {"vr": "TM", "Value": ["095047.928000"]},
        "3495": {"vr": "TM", "Value": ["095227.894000"]},
        "3496": {"vr": "TM", "Value": ["094927.687000"]},
        "3497": {"vr": "TM", "Value": ["095127.786000"]},
        "3498": {"vr": "TM", "Value": ["095327.738000"]},
        "3499": {"vr": "TM", "Value": ["094907.877000"]},
        "3500": {"vr": "TM", "Value": ["095307.784000"]},
        "3501": {"vr": "TM", "Value": ["095007.919000"]},
        "3502": {"vr": "TM", "Value": ["095007.934000"]},
        "3503": {"vr": "TM", "Value": ["095327.711000"]},
        "3504": {"vr": "TM", "Value": ["094547.802000"]},
        "3505": {"vr": "TM", "Value": ["094807.773000"]},
        "3506": {"vr": "TM", "Value": ["094847.950000"]},
        "3507": {"vr": "TM", "Value": ["095047.795000"]},
        "3508": {"vr": "TM", "Value": ["095307.661000"]},
        "3509": {"vr": "TM", "Value": ["095207.644000"]},
        "3510": {"vr": "TM", "Value": ["095027.629000"]},
        "3511": {"vr": "TM", "Value": ["094527.683000"]},
        "3512": {"vr": "TM", "Value": ["094927.807000"]},
        "3513": {"vr": "TM", "Value": ["095107.670000"]},
        "3514": {"vr": "TM", "Value": ["095407.644000"]},
        "3515": {"vr": "TM", "Value": ["095027.726000"]},
        "3516": {"vr": "TM", "Value": ["094527.931000"]},
        "3517": {"vr": "TM", "Value": ["095427.631000"]},
        "3518": {"vr": "TM", "Value": ["094727.911000"]},
        "3519": {"vr": "TM", "Value": ["095027.767000"]},
        "3520": {"vr": "TM", "Value": ["095207.913000"]},
        "3521": {"vr": "TM", "Value": ["095456.469000"]},
        "3522": {"vr": "TM", "Value": ["094527.613000"]},
        "3523": {"vr": "TM", "Value": ["095447.757000"]},
        "3524": {"vr": "TM", "Value": ["095147.660000"]},
        "3525": {"vr": "TM", "Value": ["095007.659000"]},
        "3526": {"vr": "TM", "Value": ["094847.698000"]},
        "3527": {"vr": "TM", "Value": ["095427.713000"]},
        "3528": {"vr": "TM", "Value": ["094807.653000"]},
        "3529": {"vr": "TM", "Value": ["095456.445000"]},
        "3530": {"vr": "TM", "Value": ["094827.607000"]},
        "3531": {"vr": "TM", "Value": ["094647.688000"]},
        "3532": {"vr": "TM", "Value": ["094827.849000"]},
        "3533": {"vr": "TM", "Value": ["094827.813000"]},
        "3534": {"vr": "TM", "Value": ["095407.682000"]},
        "3535": {"vr": "TM", "Value": ["095227.632000"]},
        "3536": {"vr": "TM", "Value": ["094727.637000"]},
        "3537": {"vr": "TM", "Value": ["094627.630000"]},
        "3538": {"vr": "TM", "Value": ["095207.800000"]},
        "3539": {"vr": "TM", "Value": ["095456.527000"]},
        "3540": {"vr": "TM", "Value": ["095047.861000"]},
        "3541": {"vr": "TM", "Value": ["095207.833000"]},
        "3542": {"vr": "TM", "Value": ["094807.628000"]},
        "3543": {"vr": "TM", "Value": ["094907.885000"]},
        "3544": {"vr": "TM", "Value": ["094947.692000"]},
        "3545": {"vr": "TM", "Value": ["094847.872000"]},
        "3546": {"vr": "TM", "Value": ["095007.715000"]},
        "3547": {"vr": "TM", "Value": ["094847.682000"]},
        "3548": {"vr": "TM", "Value": ["095107.784000"]},
        "3549": {"vr": "TM", "Value": ["094627.627000"]},
        "3550": {"vr": "TM", "Value": ["095147.652000"]},
        "3551": {"vr": "TM", "Value": ["094627.667000"]},
        "3552": {"vr": "TM", "Value": ["095407.860000"]},
        "3553": {"vr": "TM", "Value": ["094947.726000"]},
        "3554": {"vr": "TM", "Value": ["094847.669000"]},
        "3555": {"vr": "TM", "Value": ["094947.627000"]},
        "3556": {"vr": "TM", "Value": ["094807.960000"]},
        "3557": {"vr": "TM", "Value": ["094747.668000"]},
        "3558": {"vr": "TM", "Value": ["094607.943000"]},
        "3559": {"vr": "TM", "Value": ["095047.703000"]},
        "3560": {"vr": "TM", "Value": ["094927.865000"]},
        "3561": {"vr": "TM", "Value": ["095247.684000"]},
        "3562": {"vr": "TM", "Value": ["094907.834000"]},
        "3563": {"vr": "TM", "Value": ["095227.701000"]},
        "3564": {"vr": "TM", "Value": ["094927.623000"]},
        "3565": {"vr": "TM", "Value": ["095327.654000"]},
        "3566": {"vr": "TM", "Value": ["095047.721000"]},
        "3567": {"vr": "TM", "Value": ["094607.918000"]},
        "3568": {"vr": "TM", "Value": ["094527.965000"]},
        "3569": {"vr": "TM", "Value": ["094707.930000"]},
        "3570": {"vr": "TM", "Value": ["094827.794000"]},
        "3571": {"vr": "TM", "Value": ["094607.656000"]},
        "3572": {"vr": "TM", "Value": ["095047.705000"]},
        "3573": {"vr": "TM", "Value": ["094547.864000"]},
        "3574": {"vr": "TM", "Value": ["094627.805000"]},
        "3575": {"vr": "TM", "Value": ["094707.663000"]},
        "3576": {"vr": "TM", "Value": ["095147.684000"]},
        "3577": {"vr": "TM", "Value": ["094947.711000"]},
        "3578": {"vr": "TM", "Value": ["094647.825000"]},
        "3579": {"vr": "TM", "Value": ["095007.677000"]},
        "3580": {"vr": "TM", "Value": ["095427.784000"]},
        "3581": {"vr": "TM", "Value": ["095307.802000"]},
        "3582": {"vr": "TM", "Value": ["095027.754000"]},
        "3583": {"vr": "TM", "Value": ["095447.839000"]},
        "3584": {"vr": "TM", "Value": ["094707.813000"]},
        "3585": {"vr": "TM", "Value": ["095047.700000"]},
        "3586": {"vr": "TM", "Value": ["095347.953000"]},
        "3587": {"vr": "TM", "Value": ["095347.835000"]},
        "3588": {"vr": "TM", "Value": ["094907.760000"]},
        "3589": {"vr": "TM", "Value": ["095327.721000"]},
        "3590": {"vr": "TM", "Value": ["094847.766000"]},
        "3591": {"vr": "TM", "Value": ["095307.673000"]},
        "3592": {"vr": "TM", "Value": ["094907.866000"]},
        "3593": {"vr": "TM", "Value": ["095307.907000"]},
        "3594": {"vr": "TM", "Value": ["095247.760000"]},
        "3595": {"vr": "TM", "Value": ["094727.815000"]},
        "3596": {"vr": "TM", "Value": ["094827.899000"]},
        "3597": {"vr": "TM", "Value": ["094747.628000"]},
        "3598": {"vr": "TM", "Value": ["094827.934000"]},
        "3599": {"vr": "TM", "Value": ["094547.761000"]},
        "3600": {"vr": "TM", "Value": ["095127.911000"]},
        "3601": {"vr": "TM", "Value": ["095227.934000"]},
        "3602": {"vr": "TM", "Value": ["094947.730000"]},
        "3603": {"vr": "TM", "Value": ["094827.675000"]},
        "3604": {"vr": "TM", "Value": ["094907.874000"]},
        "3605": {"vr": "TM", "Value": ["094927.827000"]},
        "3606": {"vr": "TM", "Value": ["095047.618000"]},
        "3607": {"vr": "TM", "Value": ["095447.652000"]},
        "3608": {"vr": "TM", "Value": ["094727.954000"]},
        "3609": {"vr": "TM", "Value": ["095407.651000"]},
        "3610": {"vr": "TM", "Value": ["095327.680000"]},
        "3611": {"vr": "TM", "Value": ["094607.773000"]},
        "3612": {"vr": "TM", "Value": ["095027.627000"]},
        "3613": {"vr": "TM", "Value": ["095247.689000"]},
        "3614": {"vr": "TM", "Value": ["095327.666000"]},
        "3615": {"vr": "TM", "Value": ["094627.746000"]},
        "3616": {"vr": "TM", "Value": ["094947.685000"]},
        "3617": {"vr": "TM", "Value": ["094707.707000"]},
        "3618": {"vr": "TM", "Value": ["094627.714000"]},
        "3619": {"vr": "TM", "Value": ["094527.972000"]},
        "3620": {"vr": "TM", "Value": ["094807.817000"]},
        "3621": {"vr": "TM", "Value": ["094847.688000"]},
        "3622": {"vr": "TM", "Value": ["094607.768000"]},
        "3623": {"vr": "TM", "Value": ["094647.870000"]},
        "3624": {"vr": "TM", "Value": ["095447.806000"]},
        "3625": {"vr": "TM", "Value": ["095447.703000"]},
        "3626": {"vr": "TM", "Value": ["094927.783000"]},
        "3627": {"vr": "TM", "Value": ["095347.804000"]},
        "3628": {"vr": "TM", "Value": ["095147.852000"]},
        "3629": {"vr": "TM", "Value": ["094547.950000"]},
        "3630": {"vr": "TM", "Value": ["095347.912000"]},
        "3631": {"vr": "TM", "Value": ["095407.880000"]},
        "3632": {"vr": "TM", "Value": ["094747.638000"]},
        "3633": {"vr": "TM", "Value": ["095227.650000"]},
        "3634": {"vr": "TM", "Value": ["095407.632000"]},
        "3635": {"vr": "TM", "Value": ["094927.649000"]},
        "3636": {"vr": "TM", "Value": ["095447.778000"]},
        "3637": {"vr": "TM", "Value": ["094547.910000"]},
        "3638": {"vr": "TM", "Value": ["094647.975000"]},
        "3639": {"vr": "TM", "Value": ["095427.941000"]},
        "3640": {"vr": "TM", "Value": ["095007.817000"]},
        "3641": {"vr": "TM", "Value": ["094847.816000"]},
        "3642": {"vr": "TM", "Value": ["095427.918000"]},
        "3643": {"vr": "TM", "Value": ["094947.739000"]},
        "3644": {"vr": "TM", "Value": ["095107.896000"]},
        "3645": {"vr": "TM", "Value": ["094627.896000"]},
        "3646": {"vr": "TM", "Value": ["094707.925000"]},
        "3647": {"vr": "TM", "Value": ["095247.731000"]},
        "3648": {"vr": "TM", "Value": ["095227.719000"]},
        "3649": {"vr": "TM", "Value": ["095027.667000"]},
        "3650": {"vr": "TM", "Value": ["094907.639000"]},
        "3651": {"vr": "TM", "Value": ["094807.785000"]},
        "3652": {"vr": "TM", "Value": ["095027.816000"]},
        "3653": {"vr": "TM", "Value": ["095327.784000"]},
        "3654": {"vr": "TM", "Value": ["095007.856000"]},
        "3655": {"vr": "TM", "Value": ["094707.709000"]},
        "3656": {"vr": "TM", "Value": ["095147.877000"]},
        "3657": {"vr": "TM", "Value": ["095407.877000"]},
        "3658": {"vr": "TM", "Value": ["094607.807000"]},
        "3659": {"vr": "TM", "Value": ["095407.911000"]},
        "3660": {"vr": "TM", "Value": ["094627.955000"]},
        "3661": {"vr": "TM", "Value": ["094747.610000"]},
        "3662": {"vr": "TM", "Value": ["095347.669000"]},
        "3663": {"vr": "TM", "Value": ["095347.723000"]},
        "3664": {"vr": "TM", "Value": ["094627.904000"]},
        "3665": {"vr": "TM", "Value": ["094727.957000"]},
        "3666": {"vr": "TM", "Value": ["095227.791000"]},
        "3667": {"vr": "TM", "Value": ["094927.825000"]},
        "3668": {"vr": "TM", "Value": ["094707.619000"]},
        "3669": {"vr": "TM", "Value": ["094807.728000"]},
        "3670": {"vr": "TM", "Value": ["094807.641000"]},
        "3671": {"vr": "TM", "Value": ["094947.787000"]},
        "3672": {"vr": "TM", "Value": ["094547.908000"]},
        "3673": {"vr": "TM", "Value": ["095456.534000"]},
        "3674": {"vr": "TM", "Value": ["094627.738000"]},
        "3675": {"vr": "TM", "Value": ["094907.681000"]},
        "3676": {"vr": "TM", "Value": ["095227.765000"]},
        "3677": {"vr": "TM", "Value": ["094607.928000"]},
        "3678": {"vr": "TM", "Value": ["095227.689000"]},
        "3679": {"vr": "TM", "Value": ["095227.755000"]},
        "3680": {"vr": "TM", "Value": ["095127.917000"]},
        "3681": {"vr": "TM", "Value": ["094707.697000"]},
        "3682": {"vr": "TM", "Value": ["094807.790000"]},
        "3683": {"vr": "TM", "Value": ["094947.827000"]},
        "3684": {"vr": "TM", "Value": ["094627.894000"]},
        "3685": {"vr": "TM", "Value": ["095207.849000"]},
        "3686": {"vr": "TM", "Value": ["094847.768000"]},
        "3687": {"vr": "TM", "Value": ["095147.779000"]},
        "3688": {"vr": "TM", "Value": ["095107.718000"]},
        "3689": {"vr": "TM", "Value": ["095247.630000"]},
        "3690": {"vr": "TM", "Value": ["094547.741000"]},
        "3691": {"vr": "TM", "Value": ["094847.735000"]},
        "3692": {"vr": "TM", "Value": ["094607.851000"]},
        "3693": {"vr": "TM", "Value": ["095047.666000"]},
        "3694": {"vr": "TM", "Value": ["095427.642000"]},
        "3695": {"vr": "TM", "Value": ["094627.640000"]},
        "3696": {"vr": "TM", "Value": ["095007.798000"]},
        "3697": {"vr": "TM", "Value": ["094907.829000"]},
        "3698": {"vr": "TM", "Value": ["094647.946000"]},
        "3699": {"vr": "TM", "Value": ["094807.918000"]},
        "3700": {"vr": "TM", "Value": ["095447.719000"]},
        "3701": {"vr": "TM", "Value": ["094647.695000"]},
        "3702": {"vr": "TM", "Value": ["094747.726000"]},
        "3703": {"vr": "TM", "Value": ["095427.860000"]},
        "3704": {"vr": "TM", "Value": ["095147.928000"]},
        "3705": {"vr": "TM", "Value": ["094607.843000"]},
        "3706": {"vr": "TM", "Value": ["095047.902000"]},
        "3707": {"vr": "TM", "Value": ["094707.868000"]},
        "3708": {"vr": "TM", "Value": ["095227.732000"]},
        "3709": {"vr": "TM", "Value": ["094827.699000"]},
        "3710": {"vr": "TM", "Value": ["095247.722000"]},
        "3711": {"vr": "TM", "Value": ["095327.835000"]},
        "3712": {"vr": "TM", "Value": ["094907.716000"]},
        "3713": {"vr": "TM", "Value": ["094527.941000"]},
        "3714": {"vr": "TM", "Value": ["095427.894000"]},
        "3715": {"vr": "TM", "Value": ["095047.833000"]},
        "3716": {"vr": "TM", "Value": ["095147.784000"]},
        "3717": {"vr": "TM", "Value": ["095427.609000"]},
        "3718": {"vr": "TM", "Value": ["095347.746000"]},
        "3719": {"vr": "TM", "Value": ["094607.765000"]},
        "3720": {"vr": "TM", "Value": ["095247.870000"]},
        "3721": {"vr": "TM", "Value": ["094947.880000"]},
        "3722": {"vr": "TM", "Value": ["094907.796000"]},
        "3723": {"vr": "TM", "Value": ["094827.907000"]},
        "3724": {"vr": "TM", "Value": ["094727.743000"]},
        "3725": {"vr": "TM", "Value": ["094647.769000"]},
        "3726": {"vr": "TM", "Value": ["095227.627000"]},
        "3727": {"vr": "TM", "Value": ["095047.876000"]},
        "3728": {"vr": "TM", "Value": ["095207.646000"]},
        "3729": {"vr": "TM", "Value": ["095327.692000"]},
        "3730": {"vr": "TM", "Value": ["094627.660000"]},
        "3731": {"vr": "TM", "Value": ["095127.691000"]},
        "3732": {"vr": "TM", "Value": ["094707.907000"]},
        "3733": {"vr": "TM", "Value": ["094547.684000"]},
        "3734": {"vr": "TM", "Value": ["095427.626000"]},
        "3735": {"vr": "TM", "Value": ["095327.804000"]},
        "3736": {"vr": "TM", "Value": ["095407.751000"]},
        "3737": {"vr": "TM", "Value": ["094847.928000"]},
        "3738": {"vr": "TM", "Value": ["095447.632000"]},
        "3739": {"vr": "TM", "Value": ["095047.830000"]},
        "3740": {"vr": "TM", "Value": ["094807.885000"]},
        "3741": {"vr": "TM", "Value": ["095127.811000"]},
        "3742": {"vr": "TM", "Value": ["095007.795000"]},
        "3743": {"vr": "TM", "Value": ["095247.644000"]},
        "3744": {"vr": "TM", "Value": ["094527.732000"]},
        "3745": {"vr": "TM", "Value": ["094547.618000"]},
        "3746": {"vr": "TM", "Value": ["094807.687000"]},
        "3747": {"vr": "TM", "Value": ["095407.776000"]},
        "3748": {"vr": "TM", "Value": ["095347.850000"]},
        "3749": {"vr": "TM", "Value": ["094827.750000"]},
        "3750": {"vr": "TM", "Value": ["094847.847000"]},
        "3751": {"vr": "TM", "Value": ["094807.807000"]},
        "3752": {"vr": "TM", "Value": ["094807.848000"]},
        "3753": {"vr": "TM", "Value": ["094947.640000"]},
        "3754": {"vr": "TM", "Value": ["095007.664000"]},
        "3755": {"vr": "TM", "Value": ["095027.703000"]},
        "3756": {"vr": "TM", "Value": ["095147.736000"]},
        "3757": {"vr": "TM", "Value": ["094627.950000"]},
        "3758": {"vr": "TM", "Value": ["095327.871000"]},
        "3759": {"vr": "TM", "Value": ["094927.883000"]},
        "3760": {"vr": "TM", "Value": ["094647.707000"]},
        "3761": {"vr": "TM", "Value": ["094927.684000"]},
        "3762": {"vr": "TM", "Value": ["094607.651000"]},
        "3763": {"vr": "TM", "Value": ["095147.833000"]},
        "3764": {"vr": "TM", "Value": ["095107.665000"]},
        "3765": {"vr": "TM", "Value": ["095447.858000"]},
        "3766": {"vr": "TM", "Value": ["094947.867000"]},
        "3767": {"vr": "TM", "Value": ["095127.832000"]},
        "3768": {"vr": "TM", "Value": ["095327.891000"]},
        "3769": {"vr": "TM", "Value": ["094647.899000"]},
        "3770": {"vr": "TM", "Value": ["094747.633000"]},
        "3771": {"vr": "TM", "Value": ["095447.608000"]},
        "3772": {"vr": "TM", "Value": ["095027.625000"]},
        "3773": {"vr": "TM", "Value": ["095327.613000"]},
        "3774": {"vr": "TM", "Value": ["094927.830000"]},
        "3775": {"vr": "TM", "Value": ["095107.894000"]},
        "3776": {"vr": "TM", "Value": ["094527.925000"]},
        "3777": {"vr": "TM", "Value": ["095027.646000"]},
        "3778": {"vr": "TM", "Value": ["094607.700000"]},
        "3779": {"vr": "TM", "Value": ["094847.654000"]},
        "3780": {"vr": "TM", "Value": ["094607.661000"]},
        "3781": {"vr": "TM", "Value": ["095347.728000"]},
        "3782": {"vr": "TM", "Value": ["094647.655000"]},
        "3783": {"vr": "TM", "Value": ["094647.838000"]},
        "3784": {"vr": "TM", "Value": ["095447.786000"]},
        "3785": {"vr": "TM", "Value": ["094647.910000"]},
        "3786": {"vr": "TM", "Value": ["095027.721000"]},
        "3787": {"vr": "TM", "Value": ["094527.890000"]},
        "3788": {"vr": "TM", "Value": ["094707.612000"]},
        "3789": {"vr": "TM", "Value": ["095307.776000"]},
        "3790": {"vr": "TM", "Value": ["094707.735000"]},
        "3791": {"vr": "TM", "Value": ["094627.853000"]},
        "3792": {"vr": "TM", "Value": ["094747.693000"]},
        "3793": {"vr": "TM", "Value": ["094947.716000"]},
        "3794": {"vr": "TM", "Value": ["094527.938000"]},
        "3795": {"vr": "TM", "Value": ["095147.789000"]},
        "3796": {"vr": "TM", "Value": ["095427.819000"]},
        "3797": {"vr": "TM", "Value": ["094747.858000"]},
        "3798": {"vr": "TM", "Value": ["095147.679000"]},
        "3799": {"vr": "TM", "Value": ["094747.737000"]},
        "3800": {"vr": "TM", "Value": ["095427.635000"]},
        "3801": {"vr": "TM", "Value": ["094947.721000"]},
        "3802": {"vr": "TM", "Value": ["095407.671000"]},
        "3803": {"vr": "TM", "Value": ["094647.772000"]},
        "3804": {"vr": "TM", "Value": ["095127.872000"]},
        "3805": {"vr": "TM", "Value": ["095147.787000"]},
        "3806": {"vr": "TM", "Value": ["095147.859000"]},
        "3807": {"vr": "TM", "Value": ["095307.702000"]},
        "3808": {"vr": "TM", "Value": ["095427.716000"]},
        "3809": {"vr": "TM", "Value": ["094707.768000"]},
        "3810": {"vr": "TM", "Value": ["095327.917000"]},
        "3811": {"vr": "TM", "Value": ["095227.897000"]},
        "3812": {"vr": "TM", "Value": ["095447.832000"]},
        "3813": {"vr": "TM", "Value": ["095227.610000"]},
        "3814": {"vr": "TM", "Value": ["094847.938000"]},
        "3815": {"vr": "TM", "Value": ["095107.906000"]},
        "3816": {"vr": "TM", "Value": ["095207.721000"]},
        "3817": {"vr": "TM", "Value": ["095207.608000"]},
        "3818": {"vr": "TM", "Value": ["094647.851000"]},
        "3819": {"vr": "TM", "Value": ["094827.776000"]},
        "3820": {"vr": "TM", "Value": ["095127.929000"]},
        "3821": {"vr": "TM", "Value": ["095047.931000"]},
        "3822": {"vr": "TM", "Value": ["095427.778000"]},
        "3823": {"vr": "TM", "Value": ["095207.882000"]},
        "3824": {"vr": "TM", "Value": ["095447.909000"]},
        "3825": {"vr": "TM", "Value": ["094827.865000"]},
        "3826": {"vr": "TM", "Value": ["094547.876000"]},
        "3827": {"vr": "TM", "Value": ["095027.887000"]},
        "3828": {"vr": "TM", "Value": ["094827.701000"]},
        "3829": {"vr": "TM", "Value": ["095307.910000"]},
        "3830": {"vr": "TM", "Value": ["094907.848000"]},
        "3831": {"vr": "TM", "Value": ["095107.663000"]},
        "3832": {"vr": "TM", "Value": ["095007.896000"]},
        "3833": {"vr": "TM", "Value": ["094947.704000"]},
        "3834": {"vr": "TM", "Value": ["094607.784000"]},
        "3835": {"vr": "TM", "Value": ["095407.708000"]},
        "3836": {"vr": "TM", "Value": ["095227.786000"]},
        "3837": {"vr": "TM", "Value": ["094727.847000"]},
        "3838": {"vr": "TM", "Value": ["094527.783000"]},
        "3839": {"vr": "TM", "Value": ["094527.793000"]},
        "3840": {"vr": "TM", "Value": ["095307.725000"]},
        "3841": {"vr": "TM", "Value": ["094707.784000"]},
        "3842": {"vr": "TM", "Value": ["094607.663000"]},
        "3843": {"vr": "TM", "Value": ["095107.819000"]},
        "3844": {"vr": "TM", "Value": ["094707.770000"]},
        "3845": {"vr": "TM", "Value": ["094827.889000"]},
        "3846": {"vr": "TM", "Value": ["095207.846000"]},
        "3847": {"vr": "TM", "Value": ["095127.893000"]},
        "3848": {"vr": "TM", "Value": ["095147.610000"]},
        "3849": {"vr": "TM", "Value": ["095427.659000"]},
        "3850": {"vr": "TM", "Value": ["095027.731000"]},
        "3851": {"vr": "TM", "Value": ["095207.815000"]},
        "3852": {"vr": "TM", "Value": ["094727.645000"]},
        "3853": {"vr": "TM", "Value": ["094607.649000"]},
        "3854": {"vr": "TM", "Value": ["094847.790000"]},
        "3855": {"vr": "TM", "Value": ["095456.466000"]},
        "3856": {"vr": "TM", "Value": ["094547.654000"]},
        "3857": {"vr": "TM", "Value": ["094707.909000"]},
        "3858": {"vr": "TM", "Value": ["094547.622000"]},
        "3859": {"vr": "TM", "Value": ["095027.943000"]},
        "3860": {"vr": "TM", "Value": ["094727.844000"]},
        "3861": {"vr": "TM", "Value": ["094947.925000"]},
        "3862": {"vr": "TM", "Value": ["094747.848000"]},
        "3863": {"vr": "TM", "Value": ["095327.670000"]},
        "3864": {"vr": "TM", "Value": ["094907.651000"]},
        "3865": {"vr": "TM", "Value": ["095107.903000"]},
        "3866": {"vr": "TM", "Value": ["094927.951000"]},
        "3867": {"vr": "TM", "Value": ["094607.926000"]},
        "3868": {"vr": "TM", "Value": ["094707.732000"]},
        "3869": {"vr": "TM", "Value": ["095247.680000"]},
        "3870": {"vr": "TM", "Value": ["095447.657000"]},
        "3871": {"vr": "TM", "Value": ["095347.659000"]},
        "3872": {"vr": "TM", "Value": ["094607.903000"]},
        "3873": {"vr": "TM", "Value": ["095307.715000"]},
        "3874": {"vr": "TM", "Value": ["095147.712000"]},
        "3875": {"vr": "TM", "Value": ["095407.845000"]},
        "3876": {"vr": "TM", "Value": ["094747.790000"]},
        "3877": {"vr": "TM", "Value": ["095407.725000"]},
        "3878": {"vr": "TM", "Value": ["095327.750000"]},
        "3879": {"vr": "TM", "Value": ["094727.852000"]},
        "3880": {"vr": "TM", "Value": ["095207.757000"]},
        "3881": {"vr": "TM", "Value": ["094907.733000"]},
        "3882": {"vr": "TM", "Value": ["095147.861000"]},
        "3883": {"vr": "TM", "Value": ["094927.878000"]},
        "3884": {"vr": "TM", "Value": ["095007.936000"]},
        "3885": {"vr": "TM", "Value": ["094647.982000"]},
        "3886": {"vr": "TM", "Value": ["095307.936000"]},
        "3887": {"vr": "TM", "Value": ["095027.854000"]},
        "3888": {"vr": "TM", "Value": ["094807.846000"]},
        "3889": {"vr": "TM", "Value": ["094547.789000"]},
        "3890": {"vr": "TM", "Value": ["094927.773000"]},
        "3891": {"vr": "TM", "Value": ["095107.923000"]},
        "3892": {"vr": "TM", "Value": ["095427.698000"]},
        "3893": {"vr": "TM", "Value": ["095147.943000"]},
        "3894": {"vr": "TM", "Value": ["094607.611000"]},
        "3895": {"vr": "TM", "Value": ["094747.641000"]},
        "3896": {"vr": "TM", "Value": ["095427.799000"]},
        "3897": {"vr": "TM", "Value": ["095347.781000"]},
        "3898": {"vr": "TM", "Value": ["095107.798000"]},
        "3899": {"vr": "TM", "Value": ["095207.854000"]},
        "3900": {"vr": "TM", "Value": ["094647.965000"]},
        "3901": {"vr": "TM", "Value": ["095307.615000"]},
        "3902": {"vr": "TM", "Value": ["095027.875000"]},
        "3903": {"vr": "TM", "Value": ["095227.887000"]},
        "3904": {"vr": "TM", "Value": ["094947.922000"]},
        "3905": {"vr": "TM", "Value": ["095447.677000"]},
        "3906": {"vr": "TM", "Value": ["095047.715000"]},
        "3907": {"vr": "TM", "Value": ["095347.866000"]},
        "3908": {"vr": "TM", "Value": ["094807.843000"]},
        "3909": {"vr": "TM", "Value": ["094647.801000"]},
        "3910": {"vr": "TM", "Value": ["094607.621000"]},
        "3911": {"vr": "TM", "Value": ["094847.859000"]},
        "3912": {"vr": "TM", "Value": ["095407.885000"]},
        "3913": {"vr": "TM", "Value": ["094927.817000"]},
        "3914": {"vr": "TM", "Value": ["095107.620000"]},
        "3915": {"vr": "TM", "Value": ["094527.963000"]},
        "3916": {"vr": "TM", "Value": ["094827.904000"]},
        "3917": {"vr": "TM", "Value": ["094607.901000"]},
        "3918": {"vr": "TM", "Value": ["095007.644000"]},
        "3919": {"vr": "TM", "Value": ["094927.642000"]},
        "3920": {"vr": "TM", "Value": ["094807.623000"]},
        "3921": {"vr": "TM", "Value": ["095327.848000"]},
        "3922": {"vr": "TM", "Value": ["095427.850000"]},
        "3923": {"vr": "TM", "Value": ["094647.649000"]},
        "3924": {"vr": "TM", "Value": ["094527.975000"]},
        "3925": {"vr": "TM", "Value": ["094807.705000"]},
        "3926": {"vr": "TM", "Value": ["095227.635000"]},
        "3927": {"vr": "TM", "Value": ["095227.844000"]},
        "3928": {"vr": "TM", "Value": ["095007.872000"]},
        "3929": {"vr": "TM", "Value": ["095307.915000"]},
        "3930": {"vr": "TM", "Value": ["095247.651000"]},
        "3931": {"vr": "TM", "Value": ["094947.915000"]},
        "3932": {"vr": "TM", "Value": ["095147.920000"]},
        "3933": {"vr": "TM", "Value": ["095347.920000"]},
        "3934": {"vr": "TM", "Value": ["095027.902000"]},
        "3935": {"vr": "TM", "Value": ["095347.899000"]},
        "3936": {"vr": "TM", "Value": ["095047.656000"]},
        "3937": {"vr": "TM", "Value": ["095147.806000"]},
        "3938": {"vr": "TM", "Value": ["095427.791000"]},
        "3939": {"vr": "TM", "Value": ["094647.894000"]},
        "3940": {"vr": "TM", "Value": ["094907.952000"]},
        "3941": {"vr": "TM", "Value": ["095347.638000"]},
        "3942": {"vr": "TM", "Value": ["095207.877000"]},
        "3943": {"vr": "TM", "Value": ["095427.612000"]},
        "3944": {"vr": "TM", "Value": ["095047.853000"]},
        "3945": {"vr": "TM", "Value": ["094827.927000"]},
        "3946": {"vr": "TM", "Value": ["095427.624000"]},
        "3947": {"vr": "TM", "Value": ["094647.897000"]},
        "3948": {"vr": "TM", "Value": ["094827.706000"]},
        "3949": {"vr": "TM", "Value": ["095347.961000"]},
        "3950": {"vr": "TM", "Value": ["095127.663000"]},
        "3951": {"vr": "TM", "Value": ["094907.646000"]},
        "3952": {"vr": "TM", "Value": ["095027.895000"]},
        "3953": {"vr": "TM", "Value": ["095047.664000"]},
        "3954": {"vr": "TM", "Value": ["094627.719000"]},
        "3955": {"vr": "TM", "Value": ["095447.916000"]},
        "3956": {"vr": "TM", "Value": ["095027.741000"]},
        "3957": {"vr": "TM", "Value": ["095007.730000"]},
        "3958": {"vr": "TM", "Value": ["094847.693000"]},
        "3959": {"vr": "TM", "Value": ["095347.845000"]},
        "3960": {"vr": "TM", "Value": ["095147.705000"]},
        "3961": {"vr": "TM", "Value": ["095207.897000"]},
        "3962": {"vr": "TM", "Value": ["095327.608000"]},
        "3963": {"vr": "TM", "Value": ["094727.758000"]},
        "3964": {"vr": "TM", "Value": ["095207.693000"]},
        "3965": {"vr": "TM", "Value": ["095447.750000"]},
        "3966": {"vr": "TM", "Value": ["094707.758000"]},
        "3967": {"vr": "TM", "Value": ["094907.803000"]},
        "3968": {"vr": "TM", "Value": ["094707.659000"]},
        "3969": {"vr": "TM", "Value": ["094607.659000"]},
        "3970": {"vr": "TM", "Value": ["094947.635000"]},
        "3971": {"vr": "TM", "Value": ["094607.879000"]},
        "3972": {"vr": "TM", "Value": ["095247.677000"]},
        "3973": {"vr": "TM", "Value": ["094907.735000"]},
        "3974": {"vr": "TM", "Value": ["094807.800000"]},
        "3975": {"vr": "TM", "Value": ["095247.915000"]},
        "3976": {"vr": "TM", "Value": ["094547.682000"]},
        "3977": {"vr": "TM", "Value": ["094627.942000"]},
        "3978": {"vr": "TM", "Value": ["095447.637000"]},
        "3979": {"vr": "TM", "Value": ["094927.799000"]},
        "3980": {"vr": "TM", "Value": ["094647.822000"]},
        "3981": {"vr": "TM", "Value": ["095227.625000"]},
        "3982": {"vr": "TM", "Value": ["094947.933000"]},
        "3983": {"vr": "TM", "Value": ["094547.809000"]},
        "3984": {"vr": "TM", "Value": ["094747.874000"]},
        "3985": {"vr": "TM", "Value": ["095047.936000"]},
        "3986": {"vr": "TM", "Value": ["095427.825000"]},
        "3987": {"vr": "TM", "Value": ["094907.939000"]},
        "3988": {"vr": "TM", "Value": ["095007.608000"]},
        "3989": {"vr": "TM", "Value": ["094847.845000"]},
        "3990": {"vr": "TM", "Value": ["095047.744000"]},
        "3991": {"vr": "TM", "Value": ["095047.835000"]},
        "3992": {"vr": "TM", "Value": ["095427.812000"]},
        "3993": {"vr": "TM", "Value": ["095347.690000"]},
        "3994": {"vr": "TM", "Value": ["094947.766000"]},
        "3995": {"vr": "TM", "Value": ["094707.704000"]},
        "3996": {"vr": "TM", "Value": ["094607.752000"]},
        "3997": {"vr": "TM", "Value": ["095347.838000"]},
        "3998": {"vr": "TM", "Value": ["094947.752000"]},
        "3999": {"vr": "TM", "Value": ["095227.613000"]},
        "4000": {"vr": "TM", "Value": ["095407.637000"]},
        "4001": {"vr": "TM", "Value": ["095207.887000"]},
        "4002": {"vr": "TM", "Value": ["095247.777000"]},
        "4003": {"vr": "TM", "Value": ["094847.711000"]},
        "4004": {"vr": "TM", "Value": ["095347.718000"]},
        "4005": {"vr": "TM", "Value": ["094727.849000"]},
        "4006": {"vr": "TM", "Value": ["094627.699000"]},
        "4007": {"vr": "TM", "Value": ["095107.759000"]},
        "4008": {"vr": "TM", "Value": ["094727.683000"]},
        "4009": {"vr": "TM", "Value": ["095007.786000"]},
        "4010": {"vr": "TM", "Value": ["095027.649000"]},
        "4011": {"vr": "TM", "Value": ["094647.985000"]},
        "4012": {"vr": "TM", "Value": ["095307.763000"]},
        "4013": {"vr": "TM", "Value": ["094647.796000"]},
        "4014": {"vr": "TM", "Value": ["094827.696000"]},
        "4015": {"vr": "TM", "Value": ["095407.883000"]},
        "4016": {"vr": "TM", "Value": ["095407.630000"]},
        "4017": {"vr": "TM", "Value": ["094947.920000"]},
        "4018": {"vr": "TM", "Value": ["095247.628000"]},
        "4019": {"vr": "TM", "Value": ["095107.747000"]},
    },
    "00080018": {
        "0": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481869288465334"],
        },
        "1": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493043786867779"],
        },
        "2": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951186426671444"],
        },
        "3": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513932806972169"],
        },
        "4": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505156166170544"],
        },
        "5": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504319990370259"],
        },
        "6": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530249890375004"],
        },
        "7": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532097791675634"],
        },
        "8": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483115074865754"],
        },
        "9": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470020140562654"],
        },
        "10": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530028133974929"],
        },
        "11": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484146026666109"],
        },
        "12": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483715618465959"],
        },
        "13": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451052518358914"],
        },
        "14": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495861388668739"],
        },
        "15": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515119790572574"],
        },
        "16": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524654876174464"],
        },
        "17": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460188420160669"],
        },
        "18": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475946517564674"],
        },
        "19": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515460085172694"],
        },
        "20": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471033735562999"],
        },
        "21": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520532910273059"],
        },
        "22": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522644106673779"],
        },
        "23": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535327104176739"],
        },
        "24": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952111313973249"],
        },
        "25": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475712540364594"],
        },
        "26": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949409391168104"],
        },
        "27": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472396862363464"],
        },
        "28": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474616955764224"],
        },
        "29": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951443431672329"],
        },
        "30": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494199915068169"],
        },
        "31": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482644806065594"],
        },
        "32": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502236234569549"],
        },
        "33": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473912629063984"],
        },
        "34": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545585417778869"],
        },
        "35": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450716039158799"],
        },
        "36": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464231292362044"],
        },
        "37": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475423973164499"],
        },
        "38": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510690448271064"],
        },
        "39": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491559618067269"],
        },
        "40": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531861541975554"],
        },
        "41": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542696971277884"],
        },
        "42": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543215081278064"],
        },
        "43": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475960897764679"],
        },
        "44": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524928427974554"],
        },
        "45": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461693509361179"],
        },
        "46": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530145615774969"],
        },
        "47": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542345434877764"],
        },
        "48": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490798443867014"],
        },
        "49": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453293294159679"],
        },
        "50": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522948929373879"],
        },
        "51": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523894374169"],
        },
        "52": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524757306374499"],
        },
        "53": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481619101465244"],
        },
        "54": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463340627261744"],
        },
        "55": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484952896666384"],
        },
        "56": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504476811570309"],
        },
        "57": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490698293466979"],
        },
        "58": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483027676765724"],
        },
        "59": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472794245063599"],
        },
        "60": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514210840472264"],
        },
        "61": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953135235175364"],
        },
        "62": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948163987165239"],
        },
        "63": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543810872978264"],
        },
        "64": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504035844970159"],
        },
        "65": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543944601278309"],
        },
        "66": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481735870665284"],
        },
        "67": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484434686966204"],
        },
        "68": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465185838662374"],
        },
        "69": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471634097463204"],
        },
        "70": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462765587461544"],
        },
        "71": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504974395870479"],
        },
        "72": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504419968070294"],
        },
        "73": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520557943373064"],
        },
        "74": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460627265060819"],
        },
        "75": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540819652477244"],
        },
        "76": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520221414672949"],
        },
        "77": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494345913668219"],
        },
        "78": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514451022772349"],
        },
        "79": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473835159163954"],
        },
        "80": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545395037078804"],
        },
        "81": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460593594060804"],
        },
        "82": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511189971571234"],
        },
        "83": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502231872669544"],
        },
        "84": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452398509359374"],
        },
        "85": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514944280072514"],
        },
        "86": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524286982874339"],
        },
        "87": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520455767373029"],
        },
        "88": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490635378866954"],
        },
        "89": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534516112876459"],
        },
        "90": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450895758658864"],
        },
        "91": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464935477462284"],
        },
        "92": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521966758373544"],
        },
        "93": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462677576061514"],
        },
        "94": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534179826276344"],
        },
        "95": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472587446663529"],
        },
        "96": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473574068263869"],
        },
        "97": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544456495178484"],
        },
        "98": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451934505359219"],
        },
        "99": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452018479659244"],
        },
        "100": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461649726561164"],
        },
        "101": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485271004466489"],
        },
        "102": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461856725361234"],
        },
        "103": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501529878069304"],
        },
        "104": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525593442274784"],
        },
        "105": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533886732176244"],
        },
        "106": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521130629373259"],
        },
        "107": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953319358075979"],
        },
        "108": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471414844263129"],
        },
        "109": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471561060663179"],
        },
        "110": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543722715278234"],
        },
        "111": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525930039474899"],
        },
        "112": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482133128865419"],
        },
        "113": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543269456678079"],
        },
        "114": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500329621268899"],
        },
        "115": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522040161873569"],
        },
        "116": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530893750875224"],
        },
        "117": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470563985062839"],
        },
        "118": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951296242671819"],
        },
        "119": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544720072078574"],
        },
        "120": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455053151960279"],
        },
        "121": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453234733459659"],
        },
        "122": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524341463974354"],
        },
        "123": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451798576459169"],
        },
        "124": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521569387173409"],
        },
        "125": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500722700969029"],
        },
        "126": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542930931877964"],
        },
        "127": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094919441667389"],
        },
        "128": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513483044772019"],
        },
        "129": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480929012165009"],
        },
        "130": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461283715061039"],
        },
        "131": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514490416772359"],
        },
        "132": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533842958976229"],
        },
        "133": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542448059277799"],
        },
        "134": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533989140376279"],
        },
        "135": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474349217764134"],
        },
        "136": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494243542968184"],
        },
        "137": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504286362770244"],
        },
        "138": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461561506161134"],
        },
        "139": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948017584764729"],
        },
        "140": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483819960365994"],
        },
        "141": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454027416459929"],
        },
        "142": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501870433569424"],
        },
        "143": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524414429174379"],
        },
        "144": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502511955669639"],
        },
        "145": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525060407474599"],
        },
        "146": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460242852460684"],
        },
        "147": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472367650363454"],
        },
        "148": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530266030475014"],
        },
        "149": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524223916674314"],
        },
        "150": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495591587068644"],
        },
        "151": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471795025963259"],
        },
        "152": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543840112478274"],
        },
        "153": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473291807563769"],
        },
        "154": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451681853159129"],
        },
        "155": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515765335372794"],
        },
        "156": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474788073364279"],
        },
        "157": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490062714766759"],
        },
        "158": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502760741969724"],
        },
        "159": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455757452060519"],
        },
        "160": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545483140878834"],
        },
        "161": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525721004674824"],
        },
        "162": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473645083663889"],
        },
        "163": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524082370374269"],
        },
        "164": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470024429662659"],
        },
        "165": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522773877573819"],
        },
        "166": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504945091670469"],
        },
        "167": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490781958567004"],
        },
        "168": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946337078761729"],
        },
        "169": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480680729764924"],
        },
        "170": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455391635960394"],
        },
        "171": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475858477964644"],
        },
        "172": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945436980760024"],
        },
        "173": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542712953677894"],
        },
        "174": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471299096763094"],
        },
        "175": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481838104565319"],
        },
        "176": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452693304259474"],
        },
        "177": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525327685874694"],
        },
        "178": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954097071077274"],
        },
        "179": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524723642274484"],
        },
        "180": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470388124762779"],
        },
        "181": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482034863365389"],
        },
        "182": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522978242873889"],
        },
        "183": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511540940271354"],
        },
        "184": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453412177259719"],
        },
        "185": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475022271164359"],
        },
        "186": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521937357173534"],
        },
        "187": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522073503373584"],
        },
        "188": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954256674977819"],
        },
        "189": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485993855766739"],
        },
        "190": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502129517969509"],
        },
        "191": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451550440559084"],
        },
        "192": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520499390473044"],
        },
        "193": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461225029361019"],
        },
        "194": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541362954177429"],
        },
        "195": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950296903069774"],
        },
        "196": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510767322271094"],
        },
        "197": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490228035466819"],
        },
        "198": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450950267858879"],
        },
        "199": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951136751471274"],
        },
        "200": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453191293359644"],
        },
        "201": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514417795972334"],
        },
        "202": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521262738373304"],
        },
        "203": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474982871564349"],
        },
        "204": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491471496167239"],
        },
        "205": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522479084773719"],
        },
        "206": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523684556974134"],
        },
        "207": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504183915270209"],
        },
        "208": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454173468259979"],
        },
        "209": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461988257461279"],
        },
        "210": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500354745768904"],
        },
        "211": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503450681269959"],
        },
        "212": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534520446976464"],
        },
        "213": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534649915776504"],
        },
        "214": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520762756373134"],
        },
        "215": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505459200870644"],
        },
        "216": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471151224963039"],
        },
        "217": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470124622962689"],
        },
        "218": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541465496377464"],
        },
        "219": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493068767067784"],
        },
        "220": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483178207665779"],
        },
        "221": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950125266069194"],
        },
        "222": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502275585169559"],
        },
        "223": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454177618459984"],
        },
        "224": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454950602560244"],
        },
        "225": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455352269160384"],
        },
        "226": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510897361271134"],
        },
        "227": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464851715462259"],
        },
        "228": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503949642570134"],
        },
        "229": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480914702965004"],
        },
        "230": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470994401362989"],
        },
        "231": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465976437462639"],
        },
        "232": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522744526073809"],
        },
        "233": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523785117174164"],
        },
        "234": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480724426664939"],
        },
        "235": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523668470374124"],
        },
        "236": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535176755476684"],
        },
        "237": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454145812559974"],
        },
        "238": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501088520069154"],
        },
        "239": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524738710774489"],
        },
        "240": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485891499866704"],
        },
        "241": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501063423669149"],
        },
        "242": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512333442371624"],
        },
        "243": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482371417065504"],
        },
        "244": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542036444177659"],
        },
        "245": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532434256675749"],
        },
        "246": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451027682958909"],
        },
        "247": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461831492261229"],
        },
        "248": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503713800270049"],
        },
        "249": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504685857470384"],
        },
        "250": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513346842771974"],
        },
        "251": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475657907964579"],
        },
        "252": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950187609969399"],
        },
        "253": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502395056169599"],
        },
        "254": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505810646770764"],
        },
        "255": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484669736866284"],
        },
        "256": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531759270075519"],
        },
        "257": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540395224377099"],
        },
        "258": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485711866466639"],
        },
        "259": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485343884666514"],
        },
        "260": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464044958261984"],
        },
        "261": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530834827875204"],
        },
        "262": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475555709064544"],
        },
        "263": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461488480161109"],
        },
        "264": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532977904375934"],
        },
        "265": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542315899777754"],
        },
        "266": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543449408678144"],
        },
        "267": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483379257865844"],
        },
        "268": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462588132161484"],
        },
        "269": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515853447472824"],
        },
        "270": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545614786078879"],
        },
        "271": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522273890073649"],
        },
        "272": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954124173077379"],
        },
        "273": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494448155368254"],
        },
        "274": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462740547561539"],
        },
        "275": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464949934662289"],
        },
        "276": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522610727073764"],
        },
        "277": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535694957376864"],
        },
        "278": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094831929165749"],
        },
        "279": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480048939864709"],
        },
        "280": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510485740870994"],
        },
        "281": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485594456866599"],
        },
        "282": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453911584559894"],
        },
        "283": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494814138868379"],
        },
        "284": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541290037677404"],
        },
        "285": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952249885673699"],
        },
        "286": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950236829969574"],
        },
        "287": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461361041761069"],
        },
        "288": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471565092263184"],
        },
        "289": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543854492978279"],
        },
        "290": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544810160878604"],
        },
        "291": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490194382066804"],
        },
        "292": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494623648368314"],
        },
        "293": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472221603763404"],
        },
        "294": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542126349277689"],
        },
        "295": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951308737471854"],
        },
        "296": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473646804463894"],
        },
        "297": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945254890259414"],
        },
        "298": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452927505259554"],
        },
        "299": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452237365959319"],
        },
        "300": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542360677877769"],
        },
        "301": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545146567278719"],
        },
        "302": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951091517471139"],
        },
        "303": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492659590467644"],
        },
        "304": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493436759467909"],
        },
        "305": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470360524862774"],
        },
        "306": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540290864377064"],
        },
        "307": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492775936867684"],
        },
        "308": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534840243876569"],
        },
        "309": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504740179770399"],
        },
        "310": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502731493469714"],
        },
        "311": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464438122862114"],
        },
        "312": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513140606571899"],
        },
        "313": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545248843078754"],
        },
        "314": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954318299978024"],
        },
        "315": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471765862463249"],
        },
        "316": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464483450262134"],
        },
        "317": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535410863676764"],
        },
        "318": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483335394665829"],
        },
        "319": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950284499769739"],
        },
        "320": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511762789771429"],
        },
        "321": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947152312663159"],
        },
        "322": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954072602477204"],
        },
        "323": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493816796668039"],
        },
        "324": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492512396467594"],
        },
        "325": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471064980663014"],
        },
        "326": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945559020360434"],
        },
        "327": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511369875671299"],
        },
        "328": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530937210675239"],
        },
        "329": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511497268571339"],
        },
        "330": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453968395859909"],
        },
        "331": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494536390568284"],
        },
        "332": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470856410662939"],
        },
        "333": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523344188474014"],
        },
        "334": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491118636967119"],
        },
        "335": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480562873164884"],
        },
        "336": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472237808563414"],
        },
        "337": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490328044866854"],
        },
        "338": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453880301959879"],
        },
        "339": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948371148865954"],
        },
        "340": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462794956961554"],
        },
        "341": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543151929578039"],
        },
        "342": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480226217664774"],
        },
        "343": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533548200576129"],
        },
        "344": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483912046466029"],
        },
        "345": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520196302172944"],
        },
        "346": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461958832761269"],
        },
        "347": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465890236762614"],
        },
        "348": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495093913468474"],
        },
        "349": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451023187858904"],
        },
        "350": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513980643372189"],
        },
        "351": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540129680177009"],
        },
        "352": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495255360768529"],
        },
        "353": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494977210068434"],
        },
        "354": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492370636167549"],
        },
        "355": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532072682775629"],
        },
        "356": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474333136364124"],
        },
        "357": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453161846059634"],
        },
        "358": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522625607973769"],
        },
        "359": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470695725962884"],
        },
        "360": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453397850259714"],
        },
        "361": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500124931968829"],
        },
        "362": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521291916373314"],
        },
        "363": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500588793468984"],
        },
        "364": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532068379575624"],
        },
        "365": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500665777369014"],
        },
        "366": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954244378977784"],
        },
        "367": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465888421162609"],
        },
        "368": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464584040462164"],
        },
        "369": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530454691075074"],
        },
        "370": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095222721773624"],
        },
        "371": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521237294773299"],
        },
        "372": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515955805272859"],
        },
        "373": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510631702571044"],
        },
        "374": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492527548067599"],
        },
        "375": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505962967270819"],
        },
        "376": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494433854968249"],
        },
        "377": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530968460775254"],
        },
        "378": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491636857667299"],
        },
        "379": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473526106563849"],
        },
        "380": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490428377666884"],
        },
        "381": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947239288263434"],
        },
        "382": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484478242866219"],
        },
        "383": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945131166858999"],
        },
        "384": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495993131168784"],
        },
        "385": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534120891576324"],
        },
        "386": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534223435076359"],
        },
        "387": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510134508170874"],
        },
        "388": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540027233776974"],
        },
        "389": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490564183366934"],
        },
        "390": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465639840762524"],
        },
        "391": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534624846476499"],
        },
        "392": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480362356964819"],
        },
        "393": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511160638671224"],
        },
        "394": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505093046170519"],
        },
        "395": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495577164668639"],
        },
        "396": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482498767865544"],
        },
        "397": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494889157368404"],
        },
        "398": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455552686060449"],
        },
        "399": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465052425962324"],
        },
        "400": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490518563766914"],
        },
        "401": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464216200562039"],
        },
        "402": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475212860264424"],
        },
        "403": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503845355870094"],
        },
        "404": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455216414660334"],
        },
        "405": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521540012173399"],
        },
        "406": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471736350763239"],
        },
        "407": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475653700764574"],
        },
        "408": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501264046169214"],
        },
        "409": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505020245970494"],
        },
        "410": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473310431963779"],
        },
        "411": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533197220976009"],
        },
        "412": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452956862759564"],
        },
        "413": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465819796662589"],
        },
        "414": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455684411460494"],
        },
        "415": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525823253574859"],
        },
        "416": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493980040468094"],
        },
        "417": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460422576160749"],
        },
        "418": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451388989559029"],
        },
        "419": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455718166160509"],
        },
        "420": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543651643478214"],
        },
        "421": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461885894661244"],
        },
        "422": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474015050264019"],
        },
        "423": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532463560675759"],
        },
        "424": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513712833972094"],
        },
        "425": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541597195377509"],
        },
        "426": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515360092972659"],
        },
        "427": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512644454271734"],
        },
        "428": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540056613676984"],
        },
        "429": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515678447572764"],
        },
        "430": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503170353469864"],
        },
        "431": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946421798462034"],
        },
        "432": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541640984877524"],
        },
        "433": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951248312271654"],
        },
        "434": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470226883462724"],
        },
        "435": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954353734178159"],
        },
        "436": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451652363159119"],
        },
        "437": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481635328365254"],
        },
        "438": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505415550270629"],
        },
        "439": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525827580774864"],
        },
        "440": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535617690476834"],
        },
        "441": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461929424761259"],
        },
        "442": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463733777361874"],
        },
        "443": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533284693976039"],
        },
        "444": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513081864771879"],
        },
        "445": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513683659372084"],
        },
        "446": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524518839174414"],
        },
        "447": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452120721959279"],
        },
        "448": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531934595075579"],
        },
        "449": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503410864069949"],
        },
        "450": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535249759676709"],
        },
        "451": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470710334262889"],
        },
        "452": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522875897373854"],
        },
        "453": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454041888959934"],
        },
        "454": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480665751564919"],
        },
        "455": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505239891170569"],
        },
        "456": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480063219564714"],
        },
        "457": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481428616065179"],
        },
        "458": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490957781167064"],
        },
        "459": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475917081264664"],
        },
        "460": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948339987465824"],
        },
        "461": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505224836670564"],
        },
        "462": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492441270367574"],
        },
        "463": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510426932370974"],
        },
        "464": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530297853575024"],
        },
        "465": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474585214064214"],
        },
        "466": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465656124962534"],
        },
        "467": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501439886469274"],
        },
        "468": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453983123459914"],
        },
        "469": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544883274278629"],
        },
        "470": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504050164870164"],
        },
        "471": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503174771269869"],
        },
        "472": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470158213962704"],
        },
        "473": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534723042176529"],
        },
        "474": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533314089076049"],
        },
        "475": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451213700358969"],
        },
        "476": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953429022476354"],
        },
        "477": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472660628663554"],
        },
        "478": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541156450877359"],
        },
        "479": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525486866274744"],
        },
        "480": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494084250768134"],
        },
        "481": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452150067259289"],
        },
        "482": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470622618462859"],
        },
        "483": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531539523575444"],
        },
        "484": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510838476471114"],
        },
        "485": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521423513273359"],
        },
        "486": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481458058065189"],
        },
        "487": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484098020766089"],
        },
        "488": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484919322466369"],
        },
        "489": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524826063274519"],
        },
        "490": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502936229569784"],
        },
        "491": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494686648868339"],
        },
        "492": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472558074263519"],
        },
        "493": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525779548874844"],
        },
        "494": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532668362275829"],
        },
        "495": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481667064065264"],
        },
        "496": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495416075768584"],
        },
        "497": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451535355959079"],
        },
        "498": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541934054277624"],
        },
        "499": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455348141260379"],
        },
        "500": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461254384761029"],
        },
        "501": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545556189878859"],
        },
        "502": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502070788969489"],
        },
        "503": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948569517066604"],
        },
        "504": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483247199065799"],
        },
        "505": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455670011660489"],
        },
        "506": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471433367863139"],
        },
        "507": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946496105862274"],
        },
        "508": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474011128664014"],
        },
        "509": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493144084067809"],
        },
        "510": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534679238876514"],
        },
        "511": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949277201267664"],
        },
        "512": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475358876264474"],
        },
        "513": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095215735473389"],
        },
        "514": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464749385662224"],
        },
        "515": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482337763365489"],
        },
        "516": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451696077859134"],
        },
        "517": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533945509976264"],
        },
        "518": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485036644466409"],
        },
        "519": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470626591962864"],
        },
        "520": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514185518372259"],
        },
        "521": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452971149559569"],
        },
        "522": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493714446768004"],
        },
        "523": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544149534678379"],
        },
        "524": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470197593262714"],
        },
        "525": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493984278268099"],
        },
        "526": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542080148877674"],
        },
        "527": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535734405076874"],
        },
        "528": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535381575076754"],
        },
        "529": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452873057359539"],
        },
        "530": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472353163263449"],
        },
        "531": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482839548465664"],
        },
        "532": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452737083259489"],
        },
        "533": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472969672763659"],
        },
        "534": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501738585569379"],
        },
        "535": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952175478273459"],
        },
        "536": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515090457772564"],
        },
        "537": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501029703869134"],
        },
        "538": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505429707870634"],
        },
        "539": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450788969258824"],
        },
        "540": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480782922464959"],
        },
        "541": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540717485877209"],
        },
        "542": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095005728268954"],
        },
        "543": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544724264578579"],
        },
        "544": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464540419362149"],
        },
        "545": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492791030667689"],
        },
        "546": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535924751376939"],
        },
        "547": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535663233676854"],
        },
        "548": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948287778465654"],
        },
        "549": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511840068671459"],
        },
        "550": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504681683070379"],
        },
        "551": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525911310874889"],
        },
        "552": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505488698570654"],
        },
        "553": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464686434062199"],
        },
        "554": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500530172968964"],
        },
        "555": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450920735658869"],
        },
        "556": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472896575163634"],
        },
        "557": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542638025477864"],
        },
        "558": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510017395470834"],
        },
        "559": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524548288574424"],
        },
        "560": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505751877370744"],
        },
        "561": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534418009776429"],
        },
        "562": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520014656572879"],
        },
        "563": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475551643764539"],
        },
        "564": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505795543170759"],
        },
        "565": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490257462066829"],
        },
        "566": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512040649371524"],
        },
        "567": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948285979965649"],
        },
        "568": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515046583172549"],
        },
        "569": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491534477067264"],
        },
        "570": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481167026765094"],
        },
        "571": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530868480775219"],
        },
        "572": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534559806676474"],
        },
        "573": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541038765177319"],
        },
        "574": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535191049176689"],
        },
        "575": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510926571971144"],
        },
        "576": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512074186971539"],
        },
        "577": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533299834076044"],
        },
        "578": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501249669269209"],
        },
        "579": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525384519074709"],
        },
        "580": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525764578174839"],
        },
        "581": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951467765372399"],
        },
        "582": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500829386569069"],
        },
        "583": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511997054771509"],
        },
        "584": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521730551373464"],
        },
        "585": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451198905058964"],
        },
        "586": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533475167576104"],
        },
        "587": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946448592962104"],
        },
        "588": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472269570663424"],
        },
        "589": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532141584275649"],
        },
        "590": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485373311666524"],
        },
        "591": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503611246970014"],
        },
        "592": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533817977376224"],
        },
        "593": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523066257473919"],
        },
        "594": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451827912659179"],
        },
        "595": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452561633459429"],
        },
        "596": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494682417068334"],
        },
        "597": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485814265666674"],
        },
        "598": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532770880175864"],
        },
        "599": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473810115063949"],
        },
        "600": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482791667165644"],
        },
        "601": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514344293272309"],
        },
        "602": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495391082468579"],
        },
        "603": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540468165177124"],
        },
        "604": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460859201760894"],
        },
        "605": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541699608777544"],
        },
        "606": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522746132573814"],
        },
        "607": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951258679371684"],
        },
        "608": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535588310976824"],
        },
        "609": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521189435073279"],
        },
        "610": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954268759777854"],
        },
        "611": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500296069468884"],
        },
        "612": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945292458859549"],
        },
        "613": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525016783874584"],
        },
        "614": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495620928168654"],
        },
        "615": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515155475972589"],
        },
        "616": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520060194172894"],
        },
        "617": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460493113760774"],
        },
        "618": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947018218162684"],
        },
        "619": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502290573069564"],
        },
        "620": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950201989769469"],
        },
        "621": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463439053861774"],
        },
        "622": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452034583159254"],
        },
        "623": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535486050776789"],
        },
        "624": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544960412278659"],
        },
        "625": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530061674874944"],
        },
        "626": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947193748463299"],
        },
        "627": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465556126762499"],
        },
        "628": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945253226159409"],
        },
        "629": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490650332166959"],
        },
        "630": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522142081273604"],
        },
        "631": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475873441764649"],
        },
        "632": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460418361160744"],
        },
        "633": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502173200269524"],
        },
        "634": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480358205264814"],
        },
        "635": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523110045373934"],
        },
        "636": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465244737662389"],
        },
        "637": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470289989562749"],
        },
        "638": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515226084372614"],
        },
        "639": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543240182878069"],
        },
        "640": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462529497561464"],
        },
        "641": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461063919360964"],
        },
        "642": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475687508964589"],
        },
        "643": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521834929173499"],
        },
        "644": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530663739075149"],
        },
        "645": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492071461967444"],
        },
        "646": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531086027275289"],
        },
        "647": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510060993970849"],
        },
        "648": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541185597277369"],
        },
        "649": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491298344767184"],
        },
        "650": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946214985461319"],
        },
        "651": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473674255563899"],
        },
        "652": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095304205475059"],
        },
        "653": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947288516763604"],
        },
        "654": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513272083071944"],
        },
        "655": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948141109265174"],
        },
        "656": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512174184271574"],
        },
        "657": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453866019759874"],
        },
        "658": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520265058172964"],
        },
        "659": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463292822861724"],
        },
        "660": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502497612269634"],
        },
        "661": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530366559375044"],
        },
        "662": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464143077862014"],
        },
        "663": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545633645878889"],
        },
        "664": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515326491372644"],
        },
        "665": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515253502472619"],
        },
        "666": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494481917968269"],
        },
        "667": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946227475161354"],
        },
        "668": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500047461868799"],
        },
        "669": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452536504959424"],
        },
        "670": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461595228461149"],
        },
        "671": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510297215670934"],
        },
        "672": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535954272776949"],
        },
        "673": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455586354960464"],
        },
        "674": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530820446375199"],
        },
        "675": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484687004766294"],
        },
        "676": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483144692165764"],
        },
        "677": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490125682666784"],
        },
        "678": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463365722861749"],
        },
        "679": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495988833468779"],
        },
        "680": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513038060871864"],
        },
        "681": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543371902178114"],
        },
        "682": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523653296674119"],
        },
        "683": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954306410077989"],
        },
        "684": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521335353073329"],
        },
        "685": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460052498160619"],
        },
        "686": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490326438566849"],
        },
        "687": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513874025572149"],
        },
        "688": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493641485367979"],
        },
        "689": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945216053559274"],
        },
        "690": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495798353868714"],
        },
        "691": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453470826459739"],
        },
        "692": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454248323960004"],
        },
        "693": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454716572560164"],
        },
        "694": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492941333067744"],
        },
        "695": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455889150860564"],
        },
        "696": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522493929973724"],
        },
        "697": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490913987667049"],
        },
        "698": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505944485170809"],
        },
        "699": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482878951865674"],
        },
        "700": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455483976460429"],
        },
        "701": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522567011073749"],
        },
        "702": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453543767359764"],
        },
        "703": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525148495874629"],
        },
        "704": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475814662564629"],
        },
        "705": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480958284165019"],
        },
        "706": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510824165371109"],
        },
        "707": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465022884362314"],
        },
        "708": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948348357865854"],
        },
        "709": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524048700574254"],
        },
        "710": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530057496474939"],
        },
        "711": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520796352773149"],
        },
        "712": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451930394159214"],
        },
        "713": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504315670170254"],
        },
        "714": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482294047665474"],
        },
        "715": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513610764472059"],
        },
        "716": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520298657172979"],
        },
        "717": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530630150775134"],
        },
        "718": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535118144276664"],
        },
        "719": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494521265968279"],
        },
        "720": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460725289660849"],
        },
        "721": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505826774570774"],
        },
        "722": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463499520761794"],
        },
        "723": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542974775977979"],
        },
        "724": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523377863174029"],
        },
        "725": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453088594259609"],
        },
        "726": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540629302977179"],
        },
        "727": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534854665176574"],
        },
        "728": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452722809959484"],
        },
        "729": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540688211577199"],
        },
        "730": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500854376169074"],
        },
        "731": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485789204366669"],
        },
        "732": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464613306462174"],
        },
        "733": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542536096677829"],
        },
        "734": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945472352960159"],
        },
        "735": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485475618266559"],
        },
        "736": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472162883263384"],
        },
        "737": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461386057261074"],
        },
        "738": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525561663174774"],
        },
        "739": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451593752259099"],
        },
        "740": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464176674562029"],
        },
        "741": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455220553060339"],
        },
        "742": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947005861162649"],
        },
        "743": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532580196175799"],
        },
        "744": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505663948470714"],
        },
        "745": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946545881962444"],
        },
        "746": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465786132162574"],
        },
        "747": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504154519170199"],
        },
        "748": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513111078371889"],
        },
        "749": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515282949172629"],
        },
        "750": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543988250078324"],
        },
        "751": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480023845664704"],
        },
        "752": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523519597574074"],
        },
        "753": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461151995960994"],
        },
        "754": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515648852672754"],
        },
        "755": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494038678468114"],
        },
        "756": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481984958665369"],
        },
        "757": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545263220678759"],
        },
        "758": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474642080664229"],
        },
        "759": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454438780060069"],
        },
        "760": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472455659263484"],
        },
        "761": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947458182564184"],
        },
        "762": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542847108577939"],
        },
        "763": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513112903571894"],
        },
        "764": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949506597268444"],
        },
        "765": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470885893862949"],
        },
        "766": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471385433263119"],
        },
        "767": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532170959675659"],
        },
        "768": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503743074470059"],
        },
        "769": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952225119473629"],
        },
        "770": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481823782965314"],
        },
        "771": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545365658578794"],
        },
        "772": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485653224466619"],
        },
        "773": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954061764877174"],
        },
        "774": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474186384464074"],
        },
        "775": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471019459562994"],
        },
        "776": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484332171466169"],
        },
        "777": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500076860468809"],
        },
        "778": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543445303178139"],
        },
        "779": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454075241659949"],
        },
        "780": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950456218170319"],
        },
        "781": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485289603466499"],
        },
        "782": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540867633477264"],
        },
        "783": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520398939973014"],
        },
        "784": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452268607759334"],
        },
        "785": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515021619872544"],
        },
        "786": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504217626970224"],
        },
        "787": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465683592562539"],
        },
        "788": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531422538475404"],
        },
        "789": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481090188365064"],
        },
        "790": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535895486576929"],
        },
        "791": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531656794875484"],
        },
        "792": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454881930160224"],
        },
        "793": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515297215972634"],
        },
        "794": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481031389665044"],
        },
        "795": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949029487266809"],
        },
        "796": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474318032264119"],
        },
        "797": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510178820470889"],
        },
        "798": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515794701972804"],
        },
        "799": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453778039059844"],
        },
        "800": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462663218961509"],
        },
        "801": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451597985159104"],
        },
        "802": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461331687761059"],
        },
        "803": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523770761374159"],
        },
        "804": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523285360873994"],
        },
        "805": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480092585364724"],
        },
        "806": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510324922270939"],
        },
        "807": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522010910973559"],
        },
        "808": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475081069664379"],
        },
        "809": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502027067069474"],
        },
        "810": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500429595068934"],
        },
        "811": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520235621772954"],
        },
        "812": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490884581767039"],
        },
        "813": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502877571769764"],
        },
        "814": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505988025870824"],
        },
        "815": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542784175777914"],
        },
        "816": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953187047275539"],
        },
        "817": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543679439978219"],
        },
        "818": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503145293769859"],
        },
        "819": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949264976167629"],
        },
        "820": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531261473875349"],
        },
        "821": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531025439475269"],
        },
        "822": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483540037565899"],
        },
        "823": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511585309571369"],
        },
        "824": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524621272774449"],
        },
        "825": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510930877471149"],
        },
        "826": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480696610064934"],
        },
        "827": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545060330478694"],
        },
        "828": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493231830467839"],
        },
        "829": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513614873472064"],
        },
        "830": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460374531760729"],
        },
        "831": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481384964865164"],
        },
        "832": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473732793563919"],
        },
        "833": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463072803661649"],
        },
        "834": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461327429761054"],
        },
        "835": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544120207978369"],
        },
        "836": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481955550365359"],
        },
        "837": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461459237361099"],
        },
        "838": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454468146360079"],
        },
        "839": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471533379563174"],
        },
        "840": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530718084775164"],
        },
        "841": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514314943272299"],
        },
        "842": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455318701260369"],
        },
        "843": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495562135568634"],
        },
        "844": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474817423064289"],
        },
        "845": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945374980959819"],
        },
        "846": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500193637568849"],
        },
        "847": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515694341172774"],
        },
        "848": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494389537268234"],
        },
        "849": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461620250261154"],
        },
        "850": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513420090271994"],
        },
        "851": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502863528969759"],
        },
        "852": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950276415569709"],
        },
        "853": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521525755373394"],
        },
        "854": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473442232263824"],
        },
        "855": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472090020163359"],
        },
        "856": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491896081967384"],
        },
        "857": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510661052871054"],
        },
        "858": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474978642664344"],
        },
        "859": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460315928360709"],
        },
        "860": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948335886165819"],
        },
        "861": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544824334778609"],
        },
        "862": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534340755776399"],
        },
        "863": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951238308471619"],
        },
        "864": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543887685978294"],
        },
        "865": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485055266466419"],
        },
        "866": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520631033773089"],
        },
        "867": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464920523562279"],
        },
        "868": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513566944272044"],
        },
        "869": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465624884162519"],
        },
        "870": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482469487365534"],
        },
        "871": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492130204067464"],
        },
        "872": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453073554859604"],
        },
        "873": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953354484276114"],
        },
        "874": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514856188172484"],
        },
        "875": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451466406259059"],
        },
        "876": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470053877962669"],
        },
        "877": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460520610260779"],
        },
        "878": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533949792476269"],
        },
        "879": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453514459059754"],
        },
        "880": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455859795160554"],
        },
        "881": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470783279262914"],
        },
        "882": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460258974560694"],
        },
        "883": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470183260962709"],
        },
        "884": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532511490475779"],
        },
        "885": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545560447278864"],
        },
        "886": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471767626863254"],
        },
        "887": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494580025868299"],
        },
        "888": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465610510162514"],
        },
        "889": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455118206460304"],
        },
        "890": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474656439364234"],
        },
        "891": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495725413568689"],
        },
        "892": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540999456077309"],
        },
        "893": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503879089970109"],
        },
        "894": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947398299563979"],
        },
        "895": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949494277468409"],
        },
        "896": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463442996561779"],
        },
        "897": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494947933668424"],
        },
        "898": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502261399469554"],
        },
        "899": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484890191366359"],
        },
        "900": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492425098867564"],
        },
        "901": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460696032160839"],
        },
        "902": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502677034469699"],
        },
        "903": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544618095778539"],
        },
        "904": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461181293961004"],
        },
        "905": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472528730763509"],
        },
        "906": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460991003460939"],
        },
        "907": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515721959372779"],
        },
        "908": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495022822268454"],
        },
        "909": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543547636178174"],
        },
        "910": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510295669670929"],
        },
        "911": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485784901566664"],
        },
        "912": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542040456177664"],
        },
        "913": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510765462171089"],
        },
        "914": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472167274663389"],
        },
        "915": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503772366470069"],
        },
        "916": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542565059477839"],
        },
        "917": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514287447772294"],
        },
        "918": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525177765674639"],
        },
        "919": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451155122058949"],
        },
        "920": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946399001861934"],
        },
        "921": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475610322864559"],
        },
        "922": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525091518974614"],
        },
        "923": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522669262973784"],
        },
        "924": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450730610458804"],
        },
        "925": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454453032860074"],
        },
        "926": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544897879578634"],
        },
        "927": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515575790472729"],
        },
        "928": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532875274575899"],
        },
        "929": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502834040369749"],
        },
        "930": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493773225468024"],
        },
        "931": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495679701068674"],
        },
        "932": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545160846578724"],
        },
        "933": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510985256871164"],
        },
        "934": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453631928459794"],
        },
        "935": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949215129867459"],
        },
        "936": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514051225272214"],
        },
        "937": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491998440667419"],
        },
        "938": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544755744878589"],
        },
        "939": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485256037966484"],
        },
        "940": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525998843574919"],
        },
        "941": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525725209374829"],
        },
        "942": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470728832962899"],
        },
        "943": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949202747767424"],
        },
        "944": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511777116771434"],
        },
        "945": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540247274777049"],
        },
        "946": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511072658671194"],
        },
        "947": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490595981466944"],
        },
        "948": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514049383872209"],
        },
        "949": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948131149565139"],
        },
        "950": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952479334674479"],
        },
        "951": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490547921266924"],
        },
        "952": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471165539663044"],
        },
        "953": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950214492069504"],
        },
        "954": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520894605173179"],
        },
        "955": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460056746760624"],
        },
        "956": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514152196172244"],
        },
        "957": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490223695766814"],
        },
        "958": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952454548174409"],
        },
        "959": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481194456365099"],
        },
        "960": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949175585867319"],
        },
        "961": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500032511768794"],
        },
        "962": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530116089474959"],
        },
        "963": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515857732972829"],
        },
        "964": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464128777262009"],
        },
        "965": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473880810763974"],
        },
        "966": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491325568967189"],
        },
        "967": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535515288576799"],
        },
        "968": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470651909962869"],
        },
        "969": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470958752162974"],
        },
        "970": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452663949859464"],
        },
        "971": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471667554963219"],
        },
        "972": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540265728277059"],
        },
        "973": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532361179075724"],
        },
        "974": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503199804769874"],
        },
        "975": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512628241271724"],
        },
        "976": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947483106664284"],
        },
        "977": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493743819968014"],
        },
        "978": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545351401378789"],
        },
        "979": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514476325272354"],
        },
        "980": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515224211472609"],
        },
        "981": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533679934776174"],
        },
        "982": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490121470166779"],
        },
        "983": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514137759572239"],
        },
        "984": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524972917874569"],
        },
        "985": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493729532668009"],
        },
        "986": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483437710065864"],
        },
        "987": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945277770559479"],
        },
        "988": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532829582675884"],
        },
        "989": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491339739967194"],
        },
        "990": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493919253368074"],
        },
        "991": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540188465177029"],
        },
        "992": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480899586064999"],
        },
        "993": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954198710677619"],
        },
        "994": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463572501261819"],
        },
        "995": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530030063874934"],
        },
        "996": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544795093778599"],
        },
        "997": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521337256573334"],
        },
        "998": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524786632274509"],
        },
        "999": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542740540377899"],
        },
        "1000": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494918601068414"],
        },
        "1001": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542813518477924"],
        },
        "1002": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455420944360404"],
        },
        "1003": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473042648163684"],
        },
        "1004": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533665489176169"],
        },
        "1005": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514787489972464"],
        },
        "1006": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521878628473514"],
        },
        "1007": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471136123563034"],
        },
        "1008": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461195597561009"],
        },
        "1009": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471824412763269"],
        },
        "1010": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533167974075999"],
        },
        "1011": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544252026778414"],
        },
        "1012": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521028596073224"],
        },
        "1013": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952197968873524"],
        },
        "1014": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514549006772379"],
        },
        "1015": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545428632778819"],
        },
        "1016": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948273612965614"],
        },
        "1017": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543079095378014"],
        },
        "1018": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474934970864329"],
        },
        "1019": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534355075376404"],
        },
        "1020": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520367378872999"],
        },
        "1021": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541860629277599"],
        },
        "1022": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483878419366014"],
        },
        "1023": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490489243666904"],
        },
        "1024": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521266813073309"],
        },
        "1025": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945366871059789"],
        },
        "1026": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454365800060044"],
        },
        "1027": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520485060873039"],
        },
        "1028": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533387026176074"],
        },
        "1029": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504520542370324"],
        },
        "1030": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451448020559049"],
        },
        "1031": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463277605361719"],
        },
        "1032": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482221062665449"],
        },
        "1033": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492838957767709"],
        },
        "1034": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464172495962024"],
        },
        "1035": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535161726376679"],
        },
        "1036": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484244222166139"],
        },
        "1037": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505547282470674"],
        },
        "1038": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462573037561479"],
        },
        "1039": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482762182765634"],
        },
        "1040": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481326246065144"],
        },
        "1041": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520328026672989"],
        },
        "1042": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481531094865214"],
        },
        "1043": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950162922369329"],
        },
        "1044": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475844090064639"],
        },
        "1045": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455377410060389"],
        },
        "1046": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505858554470784"],
        },
        "1047": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540483192377129"],
        },
        "1048": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541674530177539"],
        },
        "1049": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453646219459799"],
        },
        "1050": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503684277370039"],
        },
        "1051": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494786628468374"],
        },
        "1052": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463238263761709"],
        },
        "1053": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505899926470794"],
        },
        "1054": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462441864961434"],
        },
        "1055": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483075747165744"],
        },
        "1056": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525955183774904"],
        },
        "1057": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541260645177394"],
        },
        "1058": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521364843973339"],
        },
        "1059": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485682584766629"],
        },
        "1060": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451332856559014"],
        },
        "1061": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454263440560009"],
        },
        "1062": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472035487163344"],
        },
        "1063": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483393922265849"],
        },
        "1064": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472542996763514"],
        },
        "1065": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482776589465639"],
        },
        "1066": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484817247866334"],
        },
        "1067": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520118938672914"],
        },
        "1068": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530734325475174"],
        },
        "1069": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504754569670404"],
        },
        "1070": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471063137063009"],
        },
        "1071": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525662213574804"],
        },
        "1072": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520562303773069"],
        },
        "1073": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545175933678729"],
        },
        "1074": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544661163178554"],
        },
        "1075": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463616267261834"],
        },
        "1076": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505049508070504"],
        },
        "1077": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522715187973799"],
        },
        "1078": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470987972262984"],
        },
        "1079": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530195515374989"],
        },
        "1080": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481633563765249"],
        },
        "1081": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464599082462169"],
        },
        "1082": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520426324073019"],
        },
        "1083": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520660379273099"],
        },
        "1084": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461298052161044"],
        },
        "1085": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525882006474879"],
        },
        "1086": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520093886372909"],
        },
        "1087": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520294442672974"],
        },
        "1088": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531875772175559"],
        },
        "1089": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515075995472559"],
        },
        "1090": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495886464268744"],
        },
        "1091": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482864806765669"],
        },
        "1092": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514637245272409"],
        },
        "1093": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461754347361199"],
        },
        "1094": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542876550177949"],
        },
        "1095": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521496551673384"],
        },
        "1096": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510853565771119"],
        },
        "1097": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482689135765609"],
        },
        "1098": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532814723975879"],
        },
        "1099": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512540273471694"],
        },
        "1100": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494550655468289"],
        },
        "1101": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951213531771549"],
        },
        "1102": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511292453871269"],
        },
        "1103": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530381674875049"],
        },
        "1104": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463233852061704"],
        },
        "1105": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513551896872039"],
        },
        "1106": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463380102961754"],
        },
        "1107": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949518952868479"],
        },
        "1108": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472837898963614"],
        },
        "1109": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542276483477744"],
        },
        "1110": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095311375275294"],
        },
        "1111": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475755956364609"],
        },
        "1112": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471517456163164"],
        },
        "1113": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951515598272569"],
        },
        "1114": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494716029168349"],
        },
        "1115": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541274960777399"],
        },
        "1116": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452266688259329"],
        },
        "1117": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523246058773984"],
        },
        "1118": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471228482363069"],
        },
        "1119": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541141635477354"],
        },
        "1120": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542613017577859"],
        },
        "1121": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493965666768089"],
        },
        "1122": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470944483562969"],
        },
        "1123": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460917925960914"],
        },
        "1124": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493039773567774"],
        },
        "1125": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491030506967089"],
        },
        "1126": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544515392278504"],
        },
        "1127": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463982405161959"],
        },
        "1128": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511821570971449"],
        },
        "1129": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483966385766044"],
        },
        "1130": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954231545577749"],
        },
        "1131": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465184048562369"],
        },
        "1132": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464099450061999"],
        },
        "1133": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505358597270614"],
        },
        "1134": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520940615373194"],
        },
        "1135": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491427738867224"],
        },
        "1136": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482573631165574"],
        },
        "1137": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524884808774539"],
        },
        "1138": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463175147761684"],
        },
        "1139": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500899936169094"],
        },
        "1140": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454980239160254"],
        },
        "1141": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485460620066554"],
        },
        "1142": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460759018960864"],
        },
        "1143": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463145762661674"],
        },
        "1144": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472823593563609"],
        },
        "1145": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495522849968624"],
        },
        "1146": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480812280864969"],
        },
        "1147": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545321993478779"],
        },
        "1148": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465037922362319"],
        },
        "1149": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450964656858884"],
        },
        "1150": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543417488078134"],
        },
        "1151": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949227180467494"],
        },
        "1152": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503140966369854"],
        },
        "1153": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495474791868604"],
        },
        "1154": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504788270970419"],
        },
        "1155": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503377306569934"],
        },
        "1156": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464040696361979"],
        },
        "1157": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453059206559599"],
        },
        "1158": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524552507774429"],
        },
        "1159": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495138335268489"],
        },
        "1160": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505576576870684"],
        },
        "1161": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465479027162469"],
        },
        "1162": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512099317971544"],
        },
        "1163": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511599589571374"],
        },
        "1164": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491720592967324"],
        },
        "1165": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953174673475504"],
        },
        "1166": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451363988359024"],
        },
        "1167": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522157069073609"],
        },
        "1168": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455918572260574"],
        },
        "1169": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525852663274869"],
        },
        "1170": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532346122075719"],
        },
        "1171": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462222478661359"],
        },
        "1172": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514578377272389"],
        },
        "1173": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540599947077169"],
        },
        "1174": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514826835272474"],
        },
        "1175": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523614003174109"],
        },
        "1176": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522934663973874"],
        },
        "1177": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533211620976014"],
        },
        "1178": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451520844759074"],
        },
        "1179": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473028374563679"],
        },
        "1180": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485523568066579"],
        },
        "1181": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483778205965984"],
        },
        "1182": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454599863260124"],
        },
        "1183": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502143918169514"],
        },
        "1184": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525647923774799"],
        },
        "1185": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485930928766714"],
        },
        "1186": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453372732459709"],
        },
        "1187": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493879847268064"],
        },
        "1188": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952429740874309"],
        },
        "1189": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531290844575359"],
        },
        "1190": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535983468976959"],
        },
        "1191": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451316031959004"],
        },
        "1192": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465581267462504"],
        },
        "1193": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500195531068854"],
        },
        "1194": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544412686878469"],
        },
        "1195": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949152732567254"],
        },
        "1196": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453264064159669"],
        },
        "1197": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954111854577344"],
        },
        "1198": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482969025765704"],
        },
        "1199": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520279999872969"],
        },
        "1200": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530395957375054"],
        },
        "1201": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451096600158931"],
        },
        "1202": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464788810462234"],
        },
        "1203": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543518070678164"],
        },
        "1204": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522464595373714"],
        },
        "1205": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504622897070359"],
        },
        "1206": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532611459775814"],
        },
        "1207": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511628986871384"],
        },
        "1208": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452770723559504"],
        },
        "1209": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454614070460129"],
        },
        "1210": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502911190969779"],
        },
        "1211": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543167111578044"],
        },
        "1212": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472635410363549"],
        },
        "1213": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501297727369229"],
        },
        "1214": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535427069876774"],
        },
        "1215": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503874800470104"],
        },
        "1216": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520470120073034"],
        },
        "1217": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522275735573654"],
        },
        "1218": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452459315659394"],
        },
        "1219": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531320126275369"],
        },
        "1220": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531788724275529"],
        },
        "1221": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541440287177459"],
        },
        "1222": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470681337962879"],
        },
        "1223": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535059337376644"],
        },
        "1224": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484584984466259"],
        },
        "1225": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094535155959749"],
        },
        "1226": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452532488859419"],
        },
        "1227": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541729069677554"],
        },
        "1228": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954136191977414"],
        },
        "1229": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514783217972459"],
        },
        "1230": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951234041671614"],
        },
        "1231": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533740670276194"],
        },
        "1232": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540735910577219"],
        },
        "1233": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473437870563819"],
        },
        "1234": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946289330961559"],
        },
        "1235": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481487322265199"],
        },
        "1236": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453238936259664"],
        },
        "1237": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543958800778314"],
        },
        "1238": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481432875465184"],
        },
        "1239": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465274188362399"],
        },
        "1240": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470494726362819"],
        },
        "1241": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451963923359229"],
        },
        "1242": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514889821672499"],
        },
        "1243": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523716298174144"],
        },
        "1244": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503816039870084"],
        },
        "1245": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484821270366339"],
        },
        "1246": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523682698174129"],
        },
        "1247": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473072017463694"],
        },
        "1248": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495211401268514"],
        },
        "1249": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533754938776199"],
        },
        "1250": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454647799060144"],
        },
        "1251": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512715640371754"],
        },
        "1252": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495156952368499"],
        },
        "1253": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532540954775789"],
        },
        "1254": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483012681965719"],
        },
        "1255": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484350824366179"],
        },
        "1256": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520955376673199"],
        },
        "1257": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094523419359344"],
        },
        "1258": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460257109360689"],
        },
        "1259": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524782330874504"],
        },
        "1260": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513464375772009"],
        },
        "1261": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463474400161789"],
        },
        "1262": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472925993563644"],
        },
        "1263": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514553358772384"],
        },
        "1264": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465067603962329"],
        },
        "1265": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471092422263019"],
        },
        "1266": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475110541564389"],
        },
        "1267": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503581924170004"],
        },
        "1268": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494874784368399"],
        },
        "1269": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455954355760589"],
        },
        "1270": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462428030861429"],
        },
        "1271": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545278305678764"],
        },
        "1272": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492234674067499"],
        },
        "1273": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471429098463134"],
        },
        "1274": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515414504672674"],
        },
        "1275": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524957802774564"],
        },
        "1276": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535851810976914"],
        },
        "1277": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541540411777494"],
        },
        "1278": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491398546767214"],
        },
        "1279": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485490098366564"],
        },
        "1280": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455554565960454"],
        },
        "1281": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515828348772819"],
        },
        "1282": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465213231962379"],
        },
        "1283": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515590005972734"],
        },
        "1284": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520689729673109"],
        },
        "1285": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490092011166769"],
        },
        "1286": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485554936666589"],
        },
        "1287": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490532910566919"],
        },
        "1288": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480533496664874"],
        },
        "1289": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523214283173974"],
        },
        "1290": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475624792264564"],
        },
        "1291": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451098885558934"],
        },
        "1292": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491852457867369"],
        },
        "1293": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500766238469044"],
        },
        "1294": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533152973175994"],
        },
        "1295": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492571675867614"],
        },
        "1296": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471224190463064"],
        },
        "1297": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470524144862829"],
        },
        "1298": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452193746459304"],
        },
        "1299": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462163666361339"],
        },
        "1300": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500061822768804"],
        },
        "1301": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494116016368144"],
        },
        "1302": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452488758059404"],
        },
        "1303": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535092931676659"],
        },
        "1304": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949113488367114"],
        },
        "1305": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495288800168544"],
        },
        "1306": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454745902760174"],
        },
        "1307": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530429606875069"],
        },
        "1308": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462456837361439"],
        },
        "1309": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464413019862109"],
        },
        "1310": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452296073759339"],
        },
        "1311": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494214160368174"],
        },
        "1312": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540399501877104"],
        },
        "1313": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949285312167694"],
        },
        "1314": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472426267863474"],
        },
        "1315": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452369100959364"],
        },
        "1316": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502658509469689"],
        },
        "1317": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484978098966389"],
        },
        "1318": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455157540360314"],
        },
        "1319": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462838703761569"],
        },
        "1320": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524355723974359"],
        },
        "1321": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494247799068189"],
        },
        "1322": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460813454360879"],
        },
        "1323": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947433633464114"],
        },
        "1324": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482191798865439"],
        },
        "1325": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453029819459589"],
        },
        "1326": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482089333865404"],
        },
        "1327": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095401326376999"],
        },
        "1328": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947164768163194"],
        },
        "1329": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514521533172374"],
        },
        "1330": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545223891578749"],
        },
        "1331": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491132883767124"],
        },
        "1332": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534370142576409"],
        },
        "1333": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531890796575564"],
        },
        "1334": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095233543173999"],
        },
        "1335": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474568956564204"],
        },
        "1336": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501220424469199"],
        },
        "1337": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947203776863334"],
        },
        "1338": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484141734966104"],
        },
        "1339": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521759956473474"],
        },
        "1340": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455820475060544"],
        },
        "1341": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540995154977304"],
        },
        "1342": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461020387260949"],
        },
        "1343": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524150949874289"],
        },
        "1344": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471590359163189"],
        },
        "1345": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471799354663264"],
        },
        "1346": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461664312561169"],
        },
        "1347": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451418686759039"],
        },
        "1348": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512274685671604"],
        },
        "1349": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461665929061174"],
        },
        "1350": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512142953271559"],
        },
        "1351": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454848292860209"],
        },
        "1352": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495489210268609"],
        },
        "1353": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523989928774234"],
        },
        "1354": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541743452377559"],
        },
        "1355": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481355657665154"],
        },
        "1356": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493670787867989"],
        },
        "1357": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502599907969669"],
        },
        "1358": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464818076962244"],
        },
        "1359": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953538553276729"],
        },
        "1360": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535322898976734"],
        },
        "1361": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460213497960674"],
        },
        "1362": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451784230259164"],
        },
        "1363": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470242057362729"],
        },
        "1364": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472324232463439"],
        },
        "1365": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503318426869914"],
        },
        "1366": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483980683166049"],
        },
        "1367": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945534351360364"],
        },
        "1368": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480695017964929"],
        },
        "1369": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948327555765789"],
        },
        "1370": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494287166868199"],
        },
        "1371": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462120088061324"],
        },
        "1372": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455625671460474"],
        },
        "1373": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520821472773154"],
        },
        "1374": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501573451269319"],
        },
        "1375": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482630587165589"],
        },
        "1376": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462251849461369"],
        },
        "1377": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463160782761679"],
        },
        "1378": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542799165177919"],
        },
        "1379": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543683426378224"],
        },
        "1380": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504185855270214"],
        },
        "1381": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531470554675424"],
        },
        "1382": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532143325375654"],
        },
        "1383": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472572341563524"],
        },
        "1384": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461724995761189"],
        },
        "1385": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484653710266279"],
        },
        "1386": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514989807172534"],
        },
        "1387": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484380271666189"],
        },
        "1388": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504579308770344"],
        },
        "1389": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461097542560979"],
        },
        "1390": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485212429466469"],
        },
        "1391": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451754922659154"],
        },
        "1392": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535563238976819"],
        },
        "1393": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484537184666239"],
        },
        "1394": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501352363169244"],
        },
        "1395": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492557002667609"],
        },
        "1396": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511365796771294"],
        },
        "1397": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493173427867819"],
        },
        "1398": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475187641364419"],
        },
        "1399": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481867487165329"],
        },
        "1400": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504710966670389"],
        },
        "1401": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473678392963904"],
        },
        "1402": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534443159276434"],
        },
        "1403": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495420446868589"],
        },
        "1404": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450793401658829"],
        },
        "1405": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945317205759619"],
        },
        "1406": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947274225063569"],
        },
        "1407": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470344283262764"],
        },
        "1408": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481662993565259"],
        },
        "1409": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470860689762944"],
        },
        "1410": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534574772376479"],
        },
        "1411": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463043374861639"],
        },
        "1412": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950394061170114"],
        },
        "1413": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531773882275524"],
        },
        "1414": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512158041071564"],
        },
        "1415": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453840991359869"],
        },
        "1416": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947201921563329"],
        },
        "1417": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464481734862129"],
        },
        "1418": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501793102069394"],
        },
        "1419": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534020386876294"],
        },
        "1420": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523373550174024"],
        },
        "1421": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472236036963409"],
        },
        "1422": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953232798975704"],
        },
        "1423": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493582778367959"],
        },
        "1424": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540570532077159"],
        },
        "1425": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485084689966429"],
        },
        "1426": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524855514874529"],
        },
        "1427": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521369105573344"],
        },
        "1428": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094915822667249"],
        },
        "1429": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532963407275929"],
        },
        "1430": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531836446875549"],
        },
        "1431": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542594547377849"],
        },
        "1432": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493568462667954"],
        },
        "1433": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522963980273884"],
        },
        "1434": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512878735371814"],
        },
        "1435": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503644944570029"],
        },
        "1436": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525221427874654"],
        },
        "1437": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512494664971679"],
        },
        "1438": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455538380160444"],
        },
        "1439": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501337412369239"],
        },
        "1440": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543551623778179"],
        },
        "1441": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502775131969729"],
        },
        "1442": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450759975258814"],
        },
        "1443": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543254443578074"],
        },
        "1444": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502979998069799"],
        },
        "1445": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535425210776769"],
        },
        "1446": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515928343472854"],
        },
        "1447": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474040434464024"],
        },
        "1448": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454687117960154"],
        },
        "1449": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464467368562124"],
        },
        "1450": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475344579764469"],
        },
        "1451": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493216858067834"],
        },
        "1452": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451769165959159"],
        },
        "1453": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520089529772904"],
        },
        "1454": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541538972977491"],
        },
        "1455": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545294468678774"],
        },
        "1456": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503947827070129"],
        },
        "1457": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465815499462584"],
        },
        "1458": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543885818178289"],
        },
        "1459": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460947275860924"],
        },
        "1460": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953159941675434"],
        },
        "1461": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464983500062304"],
        },
        "1462": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492834619567704"],
        },
        "1463": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949249996067559"],
        },
        "1464": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530571323475114"],
        },
        "1465": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510062902370854"],
        },
        "1466": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473628506363884"],
        },
        "1467": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471199120763059"],
        },
        "1468": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951529919072604"],
        },
        "1469": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535690675276859"],
        },
        "1470": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505649692570709"],
        },
        "1471": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532039066975614"],
        },
        "1472": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947265996363539"],
        },
        "1473": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472998924063669"],
        },
        "1474": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513917622172164"],
        },
        "1475": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532477839075764"],
        },
        "1476": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483730613465964"],
        },
        "1477": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454413674660064"],
        },
        "1478": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484185442966119"],
        },
        "1479": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511689725771404"],
        },
        "1480": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523448429574054"],
        },
        "1481": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530164080774979"],
        },
        "1482": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952342922774034"],
        },
        "1483": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952258477973729"],
        },
        "1484": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503918428970119"],
        },
        "1485": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490023325866749"],
        },
        "1486": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946361994161829"],
        },
        "1487": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542872192077944"],
        },
        "1488": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513771595972114"],
        },
        "1489": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490826031767019"],
        },
        "1490": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503042959969824"],
        },
        "1491": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480416778464834"],
        },
        "1492": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505726825570739"],
        },
        "1493": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464774436362229"],
        },
        "1494": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540454022477119"],
        },
        "1495": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514841934472479"],
        },
        "1496": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533784312576209"],
        },
        "1497": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470519847562824"],
        },
        "1498": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094921959167454"],
        },
        "1499": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533813777776219"],
        },
        "1500": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511940052871494"],
        },
        "1501": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473247489263754"],
        },
        "1502": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505958765470814"],
        },
        "1503": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532492953175769"],
        },
        "1504": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510412654470969"],
        },
        "1505": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475373925564479"],
        },
        "1506": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490796484467009"],
        },
        "1507": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475124769464394"],
        },
        "1508": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460286527160699"],
        },
        "1509": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465322015762419"],
        },
        "1510": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512392157671644"],
        },
        "1511": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532024585975609"],
        },
        "1512": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513888374672154"],
        },
        "1513": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454336336160034"],
        },
        "1514": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471928899363304"],
        },
        "1515": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450864633058854"],
        },
        "1516": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452620363959449"],
        },
        "1517": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531729729075509"],
        },
        "1518": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525250828174664"],
        },
        "1519": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502041325269479"],
        },
        "1520": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483412322865859"],
        },
        "1521": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531054601775279"],
        },
        "1522": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475183471464414"],
        },
        "1523": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483569274965909"],
        },
        "1524": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491736849167334"],
        },
        "1525": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946191942161254"],
        },
        "1526": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472764893163589"],
        },
        "1527": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524577635374434"],
        },
        "1528": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452941754259559"],
        },
        "1529": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490282521766834"],
        },
        "1530": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522376222073684"],
        },
        "1531": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493114739167799"],
        },
        "1532": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540556238377154"],
        },
        "1533": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473339871063789"],
        },
        "1534": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484214772366129"],
        },
        "1535": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472031343763339"],
        },
        "1536": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495961366768774"],
        },
        "1537": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454818841860199"],
        },
        "1538": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454570443560114"],
        },
        "1539": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946386655661899"],
        },
        "1540": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501632304669339"],
        },
        "1541": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503567545969999"],
        },
        "1542": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474274259364104"],
        },
        "1543": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484053753366074"],
        },
        "1544": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495693939468679"],
        },
        "1545": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493261244267849"],
        },
        "1546": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504725211570394"],
        },
        "1547": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503011137769814"],
        },
        "1548": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501396161869259"],
        },
        "1549": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490180128066799"],
        },
        "1550": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475975734264684"],
        },
        "1551": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481064985565059"],
        },
        "1552": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485446276466549"],
        },
        "1553": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464646962262189"],
        },
        "1554": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495020974568449"],
        },
        "1555": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451286655558994"],
        },
        "1556": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505210687470559"],
        },
        "1557": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494350187868224"],
        },
        "1558": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491266569667174"],
        },
        "1559": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513640011672069"],
        },
        "1560": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542174375577709"],
        },
        "1561": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501034047369139"],
        },
        "1562": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531188517175324"],
        },
        "1563": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472674812663559"],
        },
        "1564": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473174396663729"],
        },
        "1565": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461634553861159"],
        },
        "1566": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950249542169604"],
        },
        "1567": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480391768464829"],
        },
        "1568": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095015416469294"],
        },
        "1569": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532727204375849"],
        },
        "1570": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505992295370829"],
        },
        "1571": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453573197759774"],
        },
        "1572": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484248457866144"],
        },
        "1573": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504213342370219"],
        },
        "1574": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500095510768819"],
        },
        "1575": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505854313670779"],
        },
        "1576": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946338896461734"],
        },
        "1577": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511570252071364"],
        },
        "1578": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954366242378194"],
        },
        "1579": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954378700478229"],
        },
        "1580": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520514362473049"],
        },
        "1581": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492439400867569"],
        },
        "1582": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522332624673669"],
        },
        "1583": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504817604270429"],
        },
        "1584": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471987647363324"],
        },
        "1585": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533577743576139"],
        },
        "1586": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952466979374444"],
        },
        "1587": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504872072470444"],
        },
        "1588": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513242643971934"],
        },
        "1589": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470153979962699"],
        },
        "1590": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482925379765689"],
        },
        "1591": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947253624663504"],
        },
        "1592": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533081853075974"],
        },
        "1593": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503670061770034"],
        },
        "1594": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531334493075374"],
        },
        "1595": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541890229377609"],
        },
        "1596": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455993874060599"],
        },
        "1597": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491954804767404"],
        },
        "1598": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534958792076614"],
        },
        "1599": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521032638773229"],
        },
        "1600": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513746546672109"],
        },
        "1601": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451495840059069"],
        },
        "1602": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535822557976904"],
        },
        "1603": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545029088478679"],
        },
        "1604": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465154662462359"],
        },
        "1605": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510226562470909"],
        },
        "1606": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542433621077794"],
        },
        "1607": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483613049965924"],
        },
        "1608": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530234859274999"],
        },
        "1609": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492761553967679"],
        },
        "1610": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500457079368939"],
        },
        "1611": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523565935174089"],
        },
        "1612": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493934264768079"],
        },
        "1613": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523916805574209"],
        },
        "1614": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472469925763489"],
        },
        "1615": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952527185774649"],
        },
        "1616": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472074999363354"],
        },
        "1617": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495343050468559"],
        },
        "1618": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494452474768259"],
        },
        "1619": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453324671759689"],
        },
        "1620": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471488209263154"],
        },
        "1621": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494922813068419"],
        },
        "1622": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512260293071599"],
        },
        "1623": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949382552968034"],
        },
        "1624": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535866043976919"],
        },
        "1625": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482264797765464"],
        },
        "1626": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502614277269674"],
        },
        "1627": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483276647365809"],
        },
        "1628": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502995106169804"],
        },
        "1629": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523314793274004"],
        },
        "1630": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543313180478094"],
        },
        "1631": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465390904962439"],
        },
        "1632": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512979213971844"],
        },
        "1633": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502892691869769"],
        },
        "1634": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453661369259804"],
        },
        "1635": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521437831273364"],
        },
        "1636": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455816120560539"],
        },
        "1637": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515180529872594"],
        },
        "1638": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490562244466929"],
        },
        "1639": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532243948675684"],
        },
        "1640": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464245471562049"],
        },
        "1641": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544690648278564"],
        },
        "1642": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452973017359574"],
        },
        "1643": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545190181578734"],
        },
        "1644": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495930127068759"],
        },
        "1645": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535356498676749"],
        },
        "1646": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952299552773869"],
        },
        "1647": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533051020575959"],
        },
        "1648": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473160162363724"],
        },
        "1649": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948277782865619"],
        },
        "1650": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495314110368549"],
        },
        "1651": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524316376674349"],
        },
        "1652": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490869711267034"],
        },
        "1653": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493613991467974"],
        },
        "1654": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474949369264334"],
        },
        "1655": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514319234772304"],
        },
        "1656": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493377971867889"],
        },
        "1657": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513378621971984"],
        },
        "1658": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521160079273269"],
        },
        "1659": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485580062666594"],
        },
        "1660": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511938285571489"],
        },
        "1661": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451871506959194"],
        },
        "1662": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505756159570749"],
        },
        "1663": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481282670965129"],
        },
        "1664": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525691560074814"],
        },
        "1665": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521734921573469"],
        },
        "1666": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491264728867169"],
        },
        "1667": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522640013273774"],
        },
        "1668": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465947096862629"],
        },
        "1669": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523095606673929"],
        },
        "1670": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491573854067274"],
        },
        "1671": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513344979471969"],
        },
        "1672": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460025022360614"],
        },
        "1673": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481399194265169"],
        },
        "1674": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502338600369584"],
        },
        "1675": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473276791263764"],
        },
        "1676": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452738899859494"],
        },
        "1677": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541333649077419"],
        },
        "1678": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483882647766019"],
        },
        "1679": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490399225966874"],
        },
        "1680": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522861538173849"],
        },
        "1681": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463543206761809"],
        },
        "1682": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521218709973289"],
        },
        "1683": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512544476571699"],
        },
        "1684": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534796106676554"],
        },
        "1685": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952539696374684"],
        },
        "1686": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452898143659544"],
        },
        "1687": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515692897172771"],
        },
        "1688": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480224372464769"],
        },
        "1689": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482162395265429"],
        },
        "1690": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502365709969589"],
        },
        "1691": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953147556575399"],
        },
        "1692": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483071428765739"],
        },
        "1693": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948494907966364"],
        },
        "1694": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530352353475039"],
        },
        "1695": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471462829463149"],
        },
        "1696": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453734376359829"],
        },
        "1697": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503538268069989"],
        },
        "1698": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541772840277569"],
        },
        "1699": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504349336870269"],
        },
        "1700": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451082005958924"],
        },
        "1701": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525959437774909"],
        },
        "1702": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471048887263004"],
        },
        "1703": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454233954259999"],
        },
        "1704": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535778707376889"],
        },
        "1705": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945379254159824"],
        },
        "1706": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945387314859854"],
        },
        "1707": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482943954865699"],
        },
        "1708": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522069453873579"],
        },
        "1709": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501588551969324"],
        },
        "1710": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491432093567229"],
        },
        "1711": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945337904659684"],
        },
        "1712": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514958509872519"],
        },
        "1713": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947373363263909"],
        },
        "1714": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540060935476989"],
        },
        "1715": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524282805074334"],
        },
        "1716": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460652465360824"],
        },
        "1717": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464383491062099"],
        },
        "1718": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949457012468274"],
        },
        "1719": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541377381577434"],
        },
        "1720": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545629105178884"],
        },
        "1721": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540295134177069"],
        },
        "1722": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472842160263619"],
        },
        "1723": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954182140277579"],
        },
        "1724": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525020937174589"],
        },
        "1725": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474113462064049"],
        },
        "1726": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534781687576549"],
        },
        "1727": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949187886367354"],
        },
        "1728": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474744525164264"],
        },
        "1729": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949566567768649"],
        },
        "1730": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453763660959839"],
        },
        "1731": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483848965066004"],
        },
        "1732": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094530446459579"],
        },
        "1733": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451857204459189"],
        },
        "1734": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535997928276964"],
        },
        "1735": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530469004175079"],
        },
        "1736": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948253079865549"],
        },
        "1737": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470358645362769"],
        },
        "1738": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095138946772124"],
        },
        "1739": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948432853466159"],
        },
        "1740": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535793090776894"],
        },
        "1741": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475315390164459"],
        },
        "1742": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462397881661419"],
        },
        "1743": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473981309364004"],
        },
        "1744": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512910472671824"],
        },
        "1745": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510354174770949"],
        },
        "1746": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524253464974324"],
        },
        "1747": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504783980870414"],
        },
        "1748": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521657537973439"],
        },
        "1749": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530220551974994"],
        },
        "1750": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542478989577814"],
        },
        "1751": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543533304778169"],
        },
        "1752": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460995217460944"],
        },
        "1753": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473511037963844"],
        },
        "1754": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494170507368159"],
        },
        "1755": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512833017671794"],
        },
        "1756": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473952045263994"],
        },
        "1757": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512172223171569"],
        },
        "1758": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094519921459204"],
        },
        "1759": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452839473159524"],
        },
        "1760": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951225928071584"],
        },
        "1761": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454672972960149"],
        },
        "1762": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094518359559174"],
        },
        "1763": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460095954960634"],
        },
        "1764": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492878340467719"],
        },
        "1765": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464347956162084"],
        },
        "1766": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483481443265879"],
        },
        "1767": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484875916966354"],
        },
        "1768": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485314749966504"],
        },
        "1769": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451729776459149"],
        },
        "1770": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512569653771704"],
        },
        "1771": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493597748867964"],
        },
        "1772": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494316630568209"],
        },
        "1773": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535529680876804"],
        },
        "1774": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945509590560264"],
        },
        "1775": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464569574062159"],
        },
        "1776": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543577034878184"],
        },
        "1777": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473599116663874"],
        },
        "1778": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474483203764179"],
        },
        "1779": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524445837274389"],
        },
        "1780": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480548487364879"],
        },
        "1781": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524987337574574"],
        },
        "1782": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470260580962739"],
        },
        "1783": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473717723363914"],
        },
        "1784": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522832262873839"],
        },
        "1785": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484375927066184"],
        },
        "1786": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514358562372314"],
        },
        "1787": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544387692078464"],
        },
        "1788": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475287793064454"],
        },
        "1789": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523168687473954"],
        },
        "1790": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471458526863144"],
        },
        "1791": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462911563261594"],
        },
        "1792": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502541393169649"],
        },
        "1793": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493145908467814"],
        },
        "1794": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492893385267724"],
        },
        "1795": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473013314563674"],
        },
        "1796": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450993998858894"],
        },
        "1797": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504079544670174"],
        },
        "1798": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470797570562919"],
        },
        "1799": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510120082670869"],
        },
        "1800": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511116935071209"],
        },
        "1801": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532933997575919"],
        },
        "1802": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482176642865434"],
        },
        "1803": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541626647077519"],
        },
        "1804": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541656000277529"],
        },
        "1805": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545497407078839"],
        },
        "1806": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460393137860739"],
        },
        "1807": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540951495677289"],
        },
        "1808": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952355233774069"],
        },
        "1809": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473613443463879"],
        },
        "1810": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504535435570329"],
        },
        "1811": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493875619468059"],
        },
        "1812": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485241571566479"],
        },
        "1813": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484068832966079"],
        },
        "1814": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530849864875209"],
        },
        "1815": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542711476377889"],
        },
        "1816": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502334392269579"],
        },
        "1817": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950468628870354"],
        },
        "1818": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502965668769794"],
        },
        "1819": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492134523567469"],
        },
        "1820": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483043946965734"],
        },
        "1821": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951345722571989"],
        },
        "1822": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524019357174244"],
        },
        "1823": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513276218571949"],
        },
        "1824": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472265421263419"],
        },
        "1825": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504856968170439"],
        },
        "1826": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474099101964044"],
        },
        "1827": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953182732275534"],
        },
        "1828": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490384901666869"],
        },
        "1829": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460863425260899"],
        },
        "1830": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472973939563664"],
        },
        "1831": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504491121470314"],
        },
        "1832": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485080339066424"],
        },
        "1833": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502574823469664"],
        },
        "1834": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470724550362894"],
        },
        "1835": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501822553669404"],
        },
        "1836": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951198867771479"],
        },
        "1837": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482835291065659"],
        },
        "1838": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953197089175574"],
        },
        "1839": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521996113173554"],
        },
        "1840": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455582013260459"],
        },
        "1841": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505284016770584"],
        },
        "1842": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493848088368054"],
        },
        "1843": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470461131662804"],
        },
        "1844": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512440112071664"],
        },
        "1845": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482059925365394"],
        },
        "1846": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480860178364989"],
        },
        "1847": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480253722164779"],
        },
        "1848": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495182072768504"],
        },
        "1849": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523480211374064"],
        },
        "1850": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501675625869354"],
        },
        "1851": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523584591274099"],
        },
        "1852": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511135609971219"],
        },
        "1853": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452135020659284"],
        },
        "1854": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462266287761374"],
        },
        "1855": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494584297568304"],
        },
        "1856": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463679154561859"],
        },
        "1857": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542140549377694"],
        },
        "1858": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481853111065324"],
        },
        "1859": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946374408061864"],
        },
        "1860": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503977129570139"],
        },
        "1861": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505386169470619"],
        },
        "1862": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472867225363624"],
        },
        "1863": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532259031175689"],
        },
        "1864": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460330138860714"],
        },
        "1865": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495654680168669"],
        },
        "1866": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503933415170124"],
        },
        "1867": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510694796871069"],
        },
        "1868": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544340001278444"],
        },
        "1869": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951589792472809"],
        },
        "1870": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454965712660249"],
        },
        "1871": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521174278973274"],
        },
        "1872": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545410132378809"],
        },
        "1873": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451169497958954"],
        },
        "1874": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473762092663929"],
        },
        "1875": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542095032577679"],
        },
        "1876": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460579326960799"],
        },
        "1877": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461783655061209"],
        },
        "1878": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544281469778424"],
        },
        "1879": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481516704665209"],
        },
        "1880": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474278583964109"],
        },
        "1881": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523548810774084"],
        },
        "1882": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492341291567539"],
        },
        "1883": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945424797159989"],
        },
        "1884": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475595469964554"],
        },
        "1885": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541199878277374"],
        },
        "1886": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500781277869049"],
        },
        "1887": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524841179074524"],
        },
        "1888": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542378977077779"],
        },
        "1889": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531232196375339"],
        },
        "1890": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505181276270549"],
        },
        "1891": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502776984569734"],
        },
        "1892": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535045151676639"],
        },
        "1893": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454281930260019"],
        },
        "1894": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540439331177114"],
        },
        "1895": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535074309376649"],
        },
        "1896": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515017355772539"],
        },
        "1897": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475051557064369"],
        },
        "1898": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543815113378269"],
        },
        "1899": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454114870659959"],
        },
        "1900": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465288477262404"],
        },
        "1901": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540163375677024"],
        },
        "1902": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484773501966319"],
        },
        "1903": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474249233764099"],
        },
        "1904": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490830185967024"],
        },
        "1905": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523011959073904"],
        },
        "1906": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483349801165834"],
        },
        "1907": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484787781466324"],
        },
        "1908": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490723408966984"],
        },
        "1909": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531744131675514"],
        },
        "1910": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947385831163944"],
        },
        "1911": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460159017660659"],
        },
        "1912": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462193066161349"],
        },
        "1913": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524239079374319"],
        },
        "1914": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531672923375494"],
        },
        "1915": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451491524759064"],
        },
        "1916": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500413495068924"],
        },
        "1917": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522777866373824"],
        },
        "1918": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500252289968869"],
        },
        "1919": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544325179778439"],
        },
        "1920": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482528104265554"],
        },
        "1921": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484743847266309"],
        },
        "1922": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491666247567309"],
        },
        "1923": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491147976667129"],
        },
        "1924": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454584804160119"],
        },
        "1925": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475992020364694"],
        },
        "1926": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530922880375234"],
        },
        "1927": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491764296867339"],
        },
        "1928": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475785388164619"],
        },
        "1929": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494141117168149"],
        },
        "1930": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521864356273509"],
        },
        "1931": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490591651566939"],
        },
        "1932": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532918876875914"],
        },
        "1933": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514083058572224"],
        },
        "1934": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460827699960884"],
        },
        "1935": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533621397876154"],
        },
        "1936": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464318413562074"],
        },
        "1937": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521686932673449"],
        },
        "1938": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534325710176394"],
        },
        "1939": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493177464467824"],
        },
        "1940": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481133639265079"],
        },
        "1941": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483173954865774"],
        },
        "1942": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511467841071329"],
        },
        "1943": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461797985361214"],
        },
        "1944": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511526583771349"],
        },
        "1945": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514812550472469"],
        },
        "1946": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948483012966329"],
        },
        "1947": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485358211066519"],
        },
        "1948": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533650476076164"],
        },
        "1949": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946508609162309"],
        },
        "1950": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521839278773504"],
        },
        "1951": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504769636670409"],
        },
        "1952": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951174042871409"],
        },
        "1953": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949394847368069"],
        },
        "1954": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454921257860234"],
        },
        "1955": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471267882563079"],
        },
        "1956": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523887380774199"],
        },
        "1957": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501763736569384"],
        },
        "1958": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511635310171389"],
        },
        "1959": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949334934567864"],
        },
        "1960": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481094370665069"],
        },
        "1961": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450891460358859"],
        },
        "1962": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515725975872784"],
        },
        "1963": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512377023371639"],
        },
        "1964": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495445496568594"],
        },
        "1965": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485285408066494"],
        },
        "1966": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521134922973264"],
        },
        "1967": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545219740978744"],
        },
        "1968": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512994362671849"],
        },
        "1969": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543346785278109"],
        },
        "1970": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474846733364299"],
        },
        "1971": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484482556466224"],
        },
        "1972": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501234704969204"],
        },
        "1973": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544853664278619"],
        },
        "1974": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948029951764764"],
        },
        "1975": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525795771174854"],
        },
        "1976": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454833911260204"],
        },
        "1977": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501268246069219"],
        },
        "1978": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464084317461994"],
        },
        "1979": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520984780973209"],
        },
        "1980": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483834727865999"],
        },
        "1981": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505885695570789"],
        },
        "1982": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523446604674049"],
        },
        "1983": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500971011069114"],
        },
        "1984": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462339160761399"],
        },
        "1985": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500927323169099"],
        },
        "1986": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531965879375589"],
        },
        "1987": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542744758177904"],
        },
        "1988": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453443357359734"],
        },
        "1989": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501059093669144"],
        },
        "1990": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521628143573429"],
        },
        "1991": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492086718467449"],
        },
        "1992": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474478821164174"],
        },
        "1993": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500359014968909"],
        },
        "1994": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534957036976609"],
        },
        "1995": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540970045577299"],
        },
        "1996": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495842756168729"],
        },
        "1997": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455435911060409"],
        },
        "1998": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510794838071099"],
        },
        "1999": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512876871671809"],
        },
        "2000": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524591810274439"],
        },
        "2001": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545131521478714"],
        },
        "2002": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522596337673759"],
        },
        "2003": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453529555159759"],
        },
        "2004": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514919259072509"],
        },
        "2005": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463748246861879"],
        },
        "2006": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494418822568244"],
        },
        "2007": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460359536460724"],
        },
        "2008": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465990765762644"],
        },
        "2009": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544122023378374"],
        },
        "2010": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462736411961534"],
        },
        "2011": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534486827676449"],
        },
        "2012": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450832923458839"],
        },
        "2013": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530130469874964"],
        },
        "2014": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485887280066699"],
        },
        "2015": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523639091474114"],
        },
        "2016": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501161599969179"],
        },
        "2017": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495727232368694"],
        },
        "2018": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533445838176094"],
        },
        "2019": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495357394368564"],
        },
        "2020": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543766979378249"],
        },
        "2021": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483510529065889"],
        },
        "2022": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510456344970984"],
        },
        "2023": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481564662065229"],
        },
        "2024": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541053797577324"],
        },
        "2025": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465169664962364"],
        },
        "2026": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540012778076969"],
        },
        "2027": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475683115764584"],
        },
        "2028": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512730660171759"],
        },
        "2029": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465115278962349"],
        },
        "2030": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544021790478339"],
        },
        "2031": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950199570269434"],
        },
        "2032": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463190227561689"],
        },
        "2033": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542842863677934"],
        },
        "2034": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504374379870274"],
        },
        "2035": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500825053469064"],
        },
        "2036": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480930902365014"],
        },
        "2037": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473569880463864"],
        },
        "2038": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952404956274239"],
        },
        "2039": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495518473968619"],
        },
        "2040": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461870722661239"],
        },
        "2041": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510999635171169"],
        },
        "2042": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462090781861314"],
        },
        "2043": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525545380774764"],
        },
        "2044": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490359819266864"],
        },
        "2045": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505624545670704"],
        },
        "2046": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474685663864244"],
        },
        "2047": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543488846578154"],
        },
        "2048": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481926244465349"],
        },
        "2049": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501165846469184"],
        },
        "2050": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454511836960094"],
        },
        "2051": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491032390167094"],
        },
        "2052": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461268706061034"],
        },
        "2053": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521087244873244"],
        },
        "2054": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494477554068264"],
        },
        "2055": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484039451366069"],
        },
        "2056": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511660401471394"],
        },
        "2057": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541170519777364"],
        },
        "2058": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544647158778549"],
        },
        "2059": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534254546876374"],
        },
        "2060": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465453817162464"],
        },
        "2061": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503831127270089"],
        },
        "2062": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473780758763939"],
        },
        "2063": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505195552070554"],
        },
        "2064": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531236434375344"],
        },
        "2065": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540585612577164"],
        },
        "2066": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503347885069924"],
        },
        "2067": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484551347166244"],
        },
        "2068": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948457626366229"],
        },
        "2069": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534883945276584"],
        },
        "2070": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504886391670449"],
        },
        "2071": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522541791973744"],
        },
        "2072": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500697535069024"],
        },
        "2073": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951221629771579"],
        },
        "2074": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473379276063799"],
        },
        "2075": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482269003965469"],
        },
        "2076": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511131341871214"],
        },
        "2077": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953073125375159"],
        },
        "2078": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947495538264319"],
        },
        "2079": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482674255165604"],
        },
        "2080": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481165111565089"],
        },
        "2081": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535293453376724"],
        },
        "2082": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948261113265579"],
        },
        "2083": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495857154368734"],
        },
        "2084": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495959495468769"],
        },
        "2085": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472440687163479"],
        },
        "2086": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531466232775419"],
        },
        "2087": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540936506577284"],
        },
        "2088": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515341572572649"],
        },
        "2089": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474876214264309"],
        },
        "2090": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500931673169104"],
        },
        "2091": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504418161970289"],
        },
        "2092": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514651386472414"],
        },
        "2093": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544237714878409"],
        },
        "2094": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954341546078124"],
        },
        "2095": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485421154466544"],
        },
        "2096": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465537545562489"],
        },
        "2097": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465874259362604"],
        },
        "2098": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450818648358834"],
        },
        "2099": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525255144874669"],
        },
        "2100": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951163889671379"],
        },
        "2101": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524943421874559"],
        },
        "2102": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949289545667699"],
        },
        "2103": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451832117559184"],
        },
        "2104": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524475263174399"],
        },
        "2105": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454877536560219"],
        },
        "2106": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947323795863739"],
        },
        "2107": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510222624370904"],
        },
        "2108": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462168052961344"],
        },
        "2109": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531129665875304"],
        },
        "2110": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535395858176759"],
        },
        "2111": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465493170462474"],
        },
        "2112": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947545440764489"],
        },
        "2113": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950226845369539"],
        },
        "2114": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532375494575729"],
        },
        "2115": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454615990560134"],
        },
        "2116": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501559133069314"],
        },
        "2117": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481060838165054"],
        },
        "2118": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471697039563229"],
        },
        "2119": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504140179270194"],
        },
        "2120": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544310811978434"],
        },
        "2121": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463763187861884"],
        },
        "2122": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451886553359199"],
        },
        "2123": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463424655161769"],
        },
        "2124": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454731544160169"],
        },
        "2125": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948102125665034"],
        },
        "2126": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454012663259924"],
        },
        "2127": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491486625567244"],
        },
        "2128": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505356713170609"],
        },
        "2129": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535647107276844"],
        },
        "2130": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491457147267234"],
        },
        "2131": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541469693277469"],
        },
        "2132": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514078719672219"],
        },
        "2133": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460798459960874"],
        },
        "2134": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465422012262454"],
        },
        "2135": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947241272563469"],
        },
        "2136": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463835987461909"],
        },
        "2137": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482998270565714"],
        },
        "2138": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490679737966969"],
        },
        "2139": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500986029769119"],
        },
        "2140": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500620274768994"],
        },
        "2141": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511058263171189"],
        },
        "2142": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493846242868049"],
        },
        "2143": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543737733278239"],
        },
        "2144": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505591005670689"],
        },
        "2145": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474380936464144"],
        },
        "2146": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545058453878689"],
        },
        "2147": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462974637161619"],
        },
        "2148": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463074609561654"],
        },
        "2149": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541069999177334"],
        },
        "2150": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541963454177634"],
        },
        "2151": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501939048569444"],
        },
        "2152": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455845563760549"],
        },
        "2153": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947275988763574"],
        },
        "2154": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513228450871929"],
        },
        "2155": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505124389470534"],
        },
        "2156": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515780517972799"],
        },
        "2157": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494991597868439"],
        },
        "2158": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513669438572079"],
        },
        "2159": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495386857768574"],
        },
        "2160": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494784751168369"],
        },
        "2161": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470754029362904"],
        },
        "2162": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945546512460399"],
        },
        "2163": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493279873167859"],
        },
        "2164": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951062354471034"],
        },
        "2165": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482074353065399"],
        },
        "2166": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492322641067529"],
        },
        "2167": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511733406571419"],
        },
        "2168": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543020709877994"],
        },
        "2169": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474671376764239"],
        },
        "2170": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500384117368914"],
        },
        "2171": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541977836277639"],
        },
        "2172": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465790382062579"],
        },
        "2173": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524121681974279"],
        },
        "2174": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500545194568969"],
        },
        "2175": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480126201564739"],
        },
        "2176": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510734032471079"],
        },
        "2177": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544574215978524"],
        },
        "2178": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465687915262544"],
        },
        "2179": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511321783071279"],
        },
        "2180": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462036101961299"],
        },
        "2181": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947315711863709"],
        },
        "2182": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951455326772364"],
        },
        "2183": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953307290675944"],
        },
        "2184": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521452827773369"],
        },
        "2185": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495240718568524"],
        },
        "2186": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523950477174224"],
        },
        "2187": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544780804578594"],
        },
        "2188": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511835718071454"],
        },
        "2189": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475153977464404"],
        },
        "2190": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454775352960184"],
        },
        "2191": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463894798761929"],
        },
        "2192": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948215534265414"],
        },
        "2193": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525280233774674"],
        },
        "2194": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453677456059814"],
        },
        "2195": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490165071766794"],
        },
        "2196": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511424301571314"],
        },
        "2197": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495054583268464"],
        },
        "2198": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534990587276624"],
        },
        "2199": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524078039074264"],
        },
        "2200": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465317744462414"],
        },
        "2201": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475419736064494"],
        },
        "2202": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531980278075594"],
        },
        "2203": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520164486772934"],
        },
        "2204": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545087862878699"],
        },
        "2205": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460081942460629"],
        },
        "2206": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512598857771714"],
        },
        "2207": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950578232870729"],
        },
        "2208": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544193490978394"],
        },
        "2209": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525866935474874"],
        },
        "2210": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470666329562874"],
        },
        "2211": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454218922859994"],
        },
        "2212": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521072433273239"],
        },
        "2213": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520851071773164"],
        },
        "2214": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480987644965029"],
        },
        "2215": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530897857575229"],
        },
        "2216": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500736897369034"],
        },
        "2217": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515444163672684"],
        },
        "2218": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490694033866974"],
        },
        "2219": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471399772063124"],
        },
        "2220": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451257405858984"],
        },
        "2221": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463879674961924"],
        },
        "2222": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525461677174739"],
        },
        "2223": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504065181970169"],
        },
        "2224": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460727275860854"],
        },
        "2225": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950505771070489"],
        },
        "2226": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483466981365874"],
        },
        "2227": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954022808277034"],
        },
        "2228": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454071184159944"],
        },
        "2229": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541235596177389"],
        },
        "2230": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515149158372584"],
        },
        "2231": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523114299373939"],
        },
        "2232": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511028959371179"],
        },
        "2233": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544588714078531"],
        },
        "2234": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502672731369694"],
        },
        "2235": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520250759072959"],
        },
        "2236": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522171536473614"],
        },
        "2237": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510588046571029"],
        },
        "2238": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095227796773794"],
        },
        "2239": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464979259462299"],
        },
        "2240": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480577991264889"],
        },
        "2241": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464333502462079"],
        },
        "2242": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511395019071304"],
        },
        "2243": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460932295560919"],
        },
        "2244": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454497449760089"],
        },
        "2245": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491969135967409"],
        },
        "2246": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452795764859509"],
        },
        "2247": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510328987070944"],
        },
        "2248": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461166278460999"],
        },
        "2249": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953294571875909"],
        },
        "2250": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530189181074984"],
        },
        "2251": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470417386462789"],
        },
        "2252": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452032746659249"],
        },
        "2253": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532981823475939"],
        },
        "2254": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545526771378849"],
        },
        "2255": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481560344665224"],
        },
        "2256": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543919436278304"],
        },
        "2257": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515985234972869"],
        },
        "2258": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462769928361549"],
        },
        "2259": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464642690862184"],
        },
        "2260": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950154456969299"],
        },
        "2261": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094747755164249"],
        },
        "2262": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543386334578119"],
        },
        "2263": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531572872175459"],
        },
        "2264": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515491867772704"],
        },
        "2265": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493777488968029"],
        },
        "2266": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513096759371884"],
        },
        "2267": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541670237277534"],
        },
        "2268": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510749085971084"],
        },
        "2269": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462638177861504"],
        },
        "2270": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515516923272709"],
        },
        "2271": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481369968865159"],
        },
        "2272": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541611583877514"],
        },
        "2273": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485945918966719"],
        },
        "2274": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530864169475214"],
        },
        "2275": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503111681469844"],
        },
        "2276": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510383291070959"],
        },
        "2277": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501866098269419"],
        },
        "2278": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531597949075464"],
        },
        "2279": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543112684578029"],
        },
        "2280": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463850410461914"],
        },
        "2281": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522230130273634"],
        },
        "2282": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473335436263784"],
        },
        "2283": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947446099864149"],
        },
        "2284": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495328495368554"],
        },
        "2285": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525428135774724"],
        },
        "2286": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533916139176254"],
        },
        "2287": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451125537958939"],
        },
        "2288": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544256059678419"],
        },
        "2289": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945304796459584"],
        },
        "2290": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470392337162784"],
        },
        "2291": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951405786272194"],
        },
        "2292": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534825489376564"],
        },
        "2293": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471663370863214"],
        },
        "2294": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950175278269364"],
        },
        "2295": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500120605768824"],
        },
        "2296": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513478752572014"],
        },
        "2297": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535220398576699"],
        },
        "2298": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512949853771834"],
        },
        "2299": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542579404977844"],
        },
        "2300": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525075478374604"],
        },
        "2301": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512231005371589"],
        },
        "2302": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471751396563244"],
        },
        "2303": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514592663672394"],
        },
        "2304": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503436081369954"],
        },
        "2305": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451959603459224"],
        },
        "2306": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453343352659699"],
        },
        "2307": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520836250473159"],
        },
        "2308": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522175730373619"],
        },
        "2309": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492575553667619"],
        },
        "2310": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485050889966414"],
        },
        "2311": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520397042473009"],
        },
        "2312": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095328396575874"],
        },
        "2313": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450764135958819"],
        },
        "2314": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491768630667344"],
        },
        "2315": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544354117778449"],
        },
        "2316": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453132398759624"],
        },
        "2317": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522025803673564"],
        },
        "2318": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514739423172444"],
        },
        "2319": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474376693464139"],
        },
        "2320": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493025369767769"],
        },
        "2321": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475492671164519"],
        },
        "2322": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454779559660189"],
        },
        "2323": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534018691676289"],
        },
        "2324": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515531203772714"],
        },
        "2325": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542242914577729"],
        },
        "2326": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474435388064159"],
        },
        "2327": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492673977767649"],
        },
        "2328": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480592340464894"],
        },
        "2329": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490898981167044"],
        },
        "2330": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521922952773529"],
        },
        "2331": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471253530463074"],
        },
        "2332": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515546192672719"],
        },
        "2333": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951151539671344"],
        },
        "2334": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501720063069369"],
        },
        "2335": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483774127965979"],
        },
        "2336": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455172706160319"],
        },
        "2337": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951331379271954"],
        },
        "2338": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461197498261014"],
        },
        "2339": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475522172664529"],
        },
        "2340": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095317424175499"],
        },
        "2341": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504637948970364"],
        },
        "2342": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953269557375809"],
        },
        "2343": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485741258566649"],
        },
        "2344": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483544234565904"],
        },
        "2345": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491064174267104"],
        },
        "2346": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531641703175479"],
        },
        "2347": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465962054762634"],
        },
        "2348": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505929294970804"],
        },
        "2349": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472371911863459"],
        },
        "2350": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460227801960679"],
        },
        "2351": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514871340772489"],
        },
        "2352": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480962589465024"],
        },
        "2353": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534311659176389"],
        },
        "2354": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462017639861289"],
        },
        "2355": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452339736259354"],
        },
        "2356": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483441693965869"],
        },
        "2357": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954291613777954"],
        },
        "2358": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481721366665279"],
        },
        "2359": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531525106775439"],
        },
        "2360": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464745013162219"],
        },
        "2361": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544046872978344"],
        },
        "2362": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525192106074644"],
        },
        "2363": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543298918778089"],
        },
        "2364": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535881234176924"],
        },
        "2365": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455772470360524"],
        },
        "2366": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483598681765919"],
        },
        "2367": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504447420270299"],
        },
        "2368": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524312188474344"],
        },
        "2369": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450998257958899"],
        },
        "2370": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454936261260239"],
        },
        "2371": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504813366270424"],
        },
        "2372": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948203425465379"],
        },
        "2373": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461933713661264"],
        },
        "2374": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455479703860424"],
        },
        "2375": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494859827268394"],
        },
        "2376": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464951735462294"],
        },
        "2377": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453998158259919"],
        },
        "2378": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530634390075139"],
        },
        "2379": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461532217361124"],
        },
        "2380": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532847658675894"],
        },
        "2381": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514122553172234"],
        },
        "2382": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513951309472179"],
        },
        "2383": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490493580466909"],
        },
        "2384": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494053031468119"],
        },
        "2385": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500227275668864"],
        },
        "2386": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953379174076184"],
        },
        "2387": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473394247463804"],
        },
        "2388": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954219628877684"],
        },
        "2389": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455450379160414"],
        },
        "2390": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544427069678474"],
        },
        "2391": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474514606664189"],
        },
        "2392": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473544681363859"],
        },
        "2393": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454381903460054"],
        },
        "2394": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513537617972034"],
        },
        "2395": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534150248276334"],
        },
        "2396": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485623787466609"],
        },
        "2397": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533636206376159"],
        },
        "2398": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530086707674949"],
        },
        "2399": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540085942076994"],
        },
        "2400": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531173359875319"],
        },
        "2401": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484216715266134"],
        },
        "2402": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532643253575824"],
        },
        "2403": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521598899673419"],
        },
        "2404": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514519579472369"],
        },
        "2405": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515897117472839"],
        },
        "2406": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462941123761604"],
        },
        "2407": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480431196664839"],
        },
        "2408": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454516013860099"],
        },
        "2409": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484718813666304"],
        },
        "2410": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543620730178199"],
        },
        "2411": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511453686171324"],
        },
        "2412": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514753766972449"],
        },
        "2413": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525046126674594"],
        },
        "2414": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503715562970054"],
        },
        "2415": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460844823660889"],
        },
        "2416": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462471371261444"],
        },
        "2417": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545453689078824"],
        },
        "2418": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513449475072004"],
        },
        "2419": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475388225464484"],
        },
        "2420": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520969813773204"],
        },
        "2421": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515751205672789"],
        },
        "2422": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952245609273694"],
        },
        "2423": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453278335759674"],
        },
        "2424": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461768758761204"],
        },
        "2425": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510867950271124"],
        },
        "2426": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945362647259784"],
        },
        "2427": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474172187864069"],
        },
        "2428": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505517991570664"],
        },
        "2429": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492498055067589"],
        },
        "2430": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491196002567149"],
        },
        "2431": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453811595259859"],
        },
        "2432": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454129791159964"],
        },
        "2433": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948238384365479"],
        },
        "2434": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480651193364914"],
        },
        "2435": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540320214377074"],
        },
        "2436": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465844810562594"],
        },
        "2437": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513169960271909"],
        },
        "2438": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461415414561084"],
        },
        "2439": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512289734371609"],
        },
        "2440": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505693157470724"],
        },
        "2441": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533533831376124"],
        },
        "2442": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520045817572889"],
        },
        "2443": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524184577174304"],
        },
        "2444": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510431208670979"],
        },
        "2445": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515912228972844"],
        },
        "2446": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462722033261529"],
        },
        "2447": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949273218167659"],
        },
        "2448": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534282278676379"],
        },
        "2449": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454144180259969"],
        },
        "2450": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952113162073254"],
        },
        "2451": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502543146769654"],
        },
        "2452": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460154747060654"],
        },
        "2453": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491939741167399"],
        },
        "2454": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542330937077759"],
        },
        "2455": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474044369264029"],
        },
        "2456": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501836936869409"],
        },
        "2457": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501293372269224"],
        },
        "2458": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502056461469484"],
        },
        "2459": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542642359277869"],
        },
        "2460": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483159700865769"],
        },
        "2461": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947557762064524"],
        },
        "2462": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952307741073899"],
        },
        "2463": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535661341276849"],
        },
        "2464": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525925729674894"],
        },
        "2465": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514388237872324"],
        },
        "2466": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491294057367179"],
        },
        "2467": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502526922169644"],
        },
        "2468": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530337220275034"],
        },
        "2469": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494272882768194"],
        },
        "2470": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465757179162564"],
        },
        "2471": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951283702971784"],
        },
        "2472": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494184829768164"],
        },
        "2473": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480753732964949"],
        },
        "2474": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945242846159379"],
        },
        "2475": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512964938871839"],
        },
        "2476": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511469715871334"],
        },
        "2477": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542828519077929"],
        },
        "2478": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462370363561414"],
        },
        "2479": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464515200862144"],
        },
        "2480": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531495612875429"],
        },
        "2481": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533581879076144"],
        },
        "2482": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484287800566154"],
        },
        "2483": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532697678775839"],
        },
        "2484": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461229309761024"],
        },
        "2485": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480830824964979"],
        },
        "2486": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480621871964904"],
        },
        "2487": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531068952875284"],
        },
        "2488": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542947097277974"],
        },
        "2489": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541845728977594"],
        },
        "2490": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520719082373119"],
        },
        "2491": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946254495361459"],
        },
        "2492": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502158881669519"],
        },
        "2493": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510149418270879"],
        },
        "2494": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542065716277669"],
        },
        "2495": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481472219565194"],
        },
        "2496": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470285683462744"],
        },
        "2497": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532639003175819"],
        },
        "2498": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514914986172504"],
        },
        "2499": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484448961566209"],
        },
        "2500": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534472468076444"],
        },
        "2501": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493514000267939"],
        },
        "2502": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460524857160784"],
        },
        "2503": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530952440275244"],
        },
        "2504": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471180459263049"],
        },
        "2505": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514680887972424"],
        },
        "2506": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485139115366444"],
        },
        "2507": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512760043171769"],
        },
        "2508": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505781228670754"],
        },
        "2509": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472689839663564"],
        },
        "2510": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952185638573489"],
        },
        "2511": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485759801766659"],
        },
        "2512": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505288049370589"],
        },
        "2513": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541436065877454"],
        },
        "2514": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481198739265104"],
        },
        "2515": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945594256460569"],
        },
        "2516": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455275076960354"],
        },
        "2517": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534620708676494"],
        },
        "2518": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492395613667554"],
        },
        "2519": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948397788866024"],
        },
        "2520": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513848884272144"],
        },
        "2521": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530966667575249"],
        },
        "2522": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544941821378649"],
        },
        "2523": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460963400060934"],
        },
        "2524": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950309275069809"],
        },
        "2525": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545326244478784"],
        },
        "2526": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480446147264844"],
        },
        "2527": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480314393664799"],
        },
        "2528": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532775021475869"],
        },
        "2529": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483627958965929"],
        },
        "2530": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525294587574679"],
        },
        "2531": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523080674673924"],
        },
        "2532": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505254448870574"],
        },
        "2533": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454643592160139"],
        },
        "2534": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514254139672279"],
        },
        "2535": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510197183970899"],
        },
        "2536": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492159578267474"],
        },
        "2537": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500515853468959"],
        },
        "2538": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515194860472599"],
        },
        "2539": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544826226578614"],
        },
        "2540": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543973917278319"],
        },
        "2541": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501924643569439"],
        },
        "2542": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948176238765274"],
        },
        "2543": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523183064473959"],
        },
        "2544": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946349404561764"],
        },
        "2545": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505561561370679"],
        },
        "2546": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513583116172054"],
        },
        "2547": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465917767762619"],
        },
        "2548": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482239635865459"],
        },
        "2549": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501895404169429"],
        },
        "2550": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954051786277139"],
        },
        "2551": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524753036274494"],
        },
        "2552": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543283761478084"],
        },
        "2553": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460754687060859"],
        },
        "2554": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480122017864734"],
        },
        "2555": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511351543471289"],
        },
        "2556": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535015658376629"],
        },
        "2557": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531671024875489"],
        },
        "2558": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950418959470184"],
        },
        "2559": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953249132375744"],
        },
        "2560": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954159528977479"],
        },
        "2561": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491661980767304"],
        },
        "2562": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511737709971424"],
        },
        "2563": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484346606566174"],
        },
        "2564": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473057743863689"],
        },
        "2565": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533518752376119"],
        },
        "2566": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952259965873734"],
        },
        "2567": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513315561071959"],
        },
        "2568": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542199338577714"],
        },
        "2569": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463645539661844"],
        },
        "2570": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541024449077314"],
        },
        "2571": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464881133762269"],
        },
        "2572": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545599718778874"],
        },
        "2573": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454482391960084"],
        },
        "2574": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511792114671439"],
        },
        "2575": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461356859861064"],
        },
        "2576": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523975629874229"],
        },
        "2577": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480596681064899"],
        },
        "2578": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945265415459444"],
        },
        "2579": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451637398759114"],
        },
        "2580": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544621993678544"],
        },
        "2581": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501132150069169"],
        },
        "2582": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501471345669284"],
        },
        "2583": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491089308267109"],
        },
        "2584": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482732885765624"],
        },
        "2585": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953195237375569"],
        },
        "2586": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512525979271689"],
        },
        "2587": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952237534373664"],
        },
        "2588": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452198060359309"],
        },
        "2589": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544559150078519"],
        },
        "2590": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510646671471049"],
        },
        "2591": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540497543677134"],
        },
        "2592": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485387514566529"],
        },
        "2593": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949225330867489"],
        },
        "2594": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475478473364514"],
        },
        "2595": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953478620576524"],
        },
        "2596": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480257971864784"],
        },
        "2597": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542510740977824"],
        },
        "2598": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474612643164219"],
        },
        "2599": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510397662370964"],
        },
        "2600": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523843820474184"],
        },
        "2601": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532273063975694"],
        },
        "2602": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492966349967749"],
        },
        "2603": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952392505074204"],
        },
        "2604": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534388715576419"],
        },
        "2605": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515926447372849"],
        },
        "2606": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525530423374759"],
        },
        "2607": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515999524272874"],
        },
        "2608": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543049694378004"],
        },
        "2609": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951358200872024"],
        },
        "2610": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475242235764434"],
        },
        "2611": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482323450165484"],
        },
        "2612": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471282947163084"],
        },
        "2613": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461126980860989"],
        },
        "2614": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951287947071789"],
        },
        "2615": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534238383376364"],
        },
        "2616": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475523959564534"],
        },
        "2617": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520748399073129"],
        },
        "2618": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951393319872159"],
        },
        "2619": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491162257067134"],
        },
        "2620": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947508037664354"],
        },
        "2621": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502472495669629"],
        },
        "2622": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534811036876559"],
        },
        "2623": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532112186975639"],
        },
        "2624": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532043317875619"],
        },
        "2625": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484083163366084"],
        },
        "2626": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544179033178389"],
        },
        "2627": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095310227875264"],
        },
        "2628": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544927029078644"],
        },
        "2629": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465140314962354"],
        },
        "2630": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494013605268109"],
        },
        "2631": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492981029667754"],
        },
        "2632": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471370216563114"],
        },
        "2633": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495491093768614"],
        },
        "2634": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483744928665969"],
        },
        "2635": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453577492859779"],
        },
        "2636": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531568585175454"],
        },
        "2637": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493748072668019"],
        },
        "2638": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452668373459469"],
        },
        "2639": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513654475972074"],
        },
        "2640": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451359721359019"],
        },
        "2641": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946266390661494"],
        },
        "2642": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490986836667074"],
        },
        "2643": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544355906478454"],
        },
        "2644": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505078794770514"],
        },
        "2645": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953085432075194"],
        },
        "2646": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503068013269829"],
        },
        "2647": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520999249673214"],
        },
        "2648": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512935599371829"],
        },
        "2649": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470593277862849"],
        },
        "2650": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473262539563759"],
        },
        "2651": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482029443865384"],
        },
        "2652": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463545028361814"],
        },
        "2653": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541127089777349"],
        },
        "2654": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525559784674769"],
        },
        "2655": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094541506559954"],
        },
        "2656": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094625493261454"],
        },
        "2657": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474146783564064"],
        },
        "2658": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545528640878854"],
        },
        "2659": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484317099966164"],
        },
        "2660": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515458214972689"],
        },
        "2661": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533270348376034"],
        },
        "2662": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540673150777194"],
        },
        "2663": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455655139760484"],
        },
        "2664": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461034532660954"],
        },
        "2665": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461697711561184"],
        },
        "2666": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533011238575949"],
        },
        "2667": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474748719964269"],
        },
        "2668": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460388936460734"],
        },
        "2669": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946316457861664"],
        },
        "2670": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492541972667604"],
        },
        "2671": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483864116666009"],
        },
        "2672": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524418773474384"],
        },
        "2673": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465742618162559"],
        },
        "2674": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460784072660869"],
        },
        "2675": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462486176261449"],
        },
        "2676": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460111003960639"],
        },
        "2677": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949299511967734"],
        },
        "2678": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524523110474419"],
        },
        "2679": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500398358168919"],
        },
        "2680": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451566850559091"],
        },
        "2681": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520664635073104"],
        },
        "2682": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950222707469534"],
        },
        "2683": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522098702973589"],
        },
        "2684": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491059870767099"],
        },
        "2685": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513246955071939"],
        },
        "2686": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471326592363099"],
        },
        "2687": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504888268170454"],
        },
        "2688": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510090528570859"],
        },
        "2689": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483583629565914"],
        },
        "2690": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491632635067294"],
        },
        "2691": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463131468261669"],
        },
        "2692": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464113676962004"],
        },
        "2693": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510163763470884"],
        },
        "2694": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524370861174364"],
        },
        "2695": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521394162373349"],
        },
        "2696": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462031816161294"],
        },
        "2697": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954084622177239"],
        },
        "2698": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510251932970914"],
        },
        "2699": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472060650763349"],
        },
        "2700": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453368386759704"],
        },
        "2701": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485828554766679"],
        },
        "2702": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948299253865684"],
        },
        "2703": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542375021977774"],
        },
        "2704": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490093854966774"],
        },
        "2705": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455249955260349"],
        },
        "2706": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470049513962664"],
        },
        "2707": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535968561476954"],
        },
        "2708": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533786169776214"],
        },
        "2709": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530996101375259"],
        },
        "2710": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510799108171104"],
        },
        "2711": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460491178060769"],
        },
        "2712": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484846546566344"],
        },
        "2713": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542477459177809"],
        },
        "2714": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532845873975889"],
        },
        "2715": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504920040670464"],
        },
        "2716": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505522168570669"],
        },
        "2717": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484014339466064"],
        },
        "2718": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452091545259269"],
        },
        "2719": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950358938769979"],
        },
        "2720": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482939685565694"],
        },
        "2721": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540633557177184"],
        },
        "2722": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483646508565939"],
        },
        "2723": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954403283578329"],
        },
        "2724": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952417361574274"],
        },
        "2725": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952283126273829"],
        },
        "2726": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531368197475389"],
        },
        "2727": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491166542067139"],
        },
        "2728": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472499293863499"],
        },
        "2729": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492188847867484"],
        },
        "2730": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950381689670079"],
        },
        "2731": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948519731366434"],
        },
        "2732": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543210863478059"],
        },
        "2733": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540031494976979"],
        },
        "2734": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492173879867479"],
        },
        "2735": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462970376761614"],
        },
        "2736": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500310999968889"],
        },
        "2737": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491384169767209"],
        },
        "2738": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452066358259264"],
        },
        "2739": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503615585670019"],
        },
        "2740": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474347317464129"],
        },
        "2741": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545044240278684"],
        },
        "2742": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544153861178384"],
        },
        "2743": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540115283777004"],
        },
        "2744": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515355787572654"],
        },
        "2745": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452810043659514"],
        },
        "2746": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513717138672099"],
        },
        "2747": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524679982674469"],
        },
        "2748": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504959366470474"],
        },
        "2749": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483746476165974"],
        },
        "2750": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464511034562139"],
        },
        "2751": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522846588773844"],
        },
        "2752": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472338215163444"],
        },
        "2753": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452223303759314"],
        },
        "2754": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535897378776934"],
        },
        "2755": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472631149663544"],
        },
        "2756": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532377327475734"],
        },
        "2757": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482367246165499"],
        },
        "2758": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946008881460604"],
        },
        "2759": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946378577461869"],
        },
        "2760": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505313350270594"],
        },
        "2761": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491250477667164"],
        },
        "2762": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512642524971729"],
        },
        "2763": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470093146662679"],
        },
        "2764": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460290775860704"],
        },
        "2765": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495754795468699"],
        },
        "2766": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947336177263774"],
        },
        "2767": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500799910669059"],
        },
        "2768": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512744957971764"],
        },
        "2769": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462236717961364"],
        },
        "2770": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513581222672049"],
        },
        "2771": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453748606459834"],
        },
        "2772": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462692563861519"],
        },
        "2773": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533372738676069"],
        },
        "2774": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491354730167199"],
        },
        "2775": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094517407359139"],
        },
        "2776": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461463495261104"],
        },
        "2777": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513976351472184"],
        },
        "2778": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500751955269039"],
        },
        "2779": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523329855174009"],
        },
        "2780": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504083828470179"],
        },
        "2781": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544989774778669"],
        },
        "2782": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470915230862959"],
        },
        "2783": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462134337761329"],
        },
        "2784": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490445633466889"],
        },
        "2785": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500693249669019"],
        },
        "2786": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494111775468139"],
        },
        "2787": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541494845077474"],
        },
        "2788": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505474354370649"],
        },
        "2789": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951271173471749"],
        },
        "2790": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471297236363089"],
        },
        "2791": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520133200372919"],
        },
        "2792": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531363811675384"],
        },
        "2793": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523580373074094"],
        },
        "2794": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480460508264849"],
        },
        "2795": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947328083963744"],
        },
        "2796": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503229050269884"],
        },
        "2797": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514167166772249"],
        },
        "2798": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522361913873679"],
        },
        "2799": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532879485075904"],
        },
        "2800": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514446968072344"],
        },
        "2801": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485124042466439"],
        },
        "2802": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540424710377109"],
        },
        "2803": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493275536167854"],
        },
        "2804": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503747327070064"],
        },
        "2805": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512069908071534"],
        },
        "2806": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463513822061799"],
        },
        "2807": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541572184277504"],
        },
        "2808": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535826829676909"],
        },
        "2809": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490459845166894"],
        },
        "2810": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503126726369849"],
        },
        "2811": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544749417678584"],
        },
        "2812": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493348651667879"],
        },
        "2813": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947421215964079"],
        },
        "2814": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455611416460469"],
        },
        "2815": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503640621670024"],
        },
        "2816": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470329337262759"],
        },
        "2817": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510970237771159"],
        },
        "2818": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482396478165509"],
        },
        "2819": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535544716976809"],
        },
        "2820": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494155392468154"],
        },
        "2821": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535797346476899"],
        },
        "2822": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513435144571999"],
        },
        "2823": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534545615476469"],
        },
        "2824": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953466332276489"],
        },
        "2825": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481969976165364"],
        },
        "2826": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455245735660344"],
        },
        "2827": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472294936463429"],
        },
        "2828": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540790362077234"],
        },
        "2829": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525355361274699"],
        },
        "2830": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500563754868979"],
        },
        "2831": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532745623375859"],
        },
        "2832": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505492794370659"],
        },
        "2833": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493495389867929"],
        },
        "2834": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511399256371309"],
        },
        "2835": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485696736066634"],
        },
        "2836": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505722497970734"],
        },
        "2837": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465859270462599"],
        },
        "2838": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481769323365299"],
        },
        "2839": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502940579769789"],
        },
        "2840": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492675553767654"],
        },
        "2841": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523818711374179"],
        },
        "2842": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523348443074019"],
        },
        "2843": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493010407867764"],
        },
        "2844": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473410430563814"],
        },
        "2845": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481223981065109"],
        },
        "2846": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474420390164154"],
        },
        "2847": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532536670775784"],
        },
        "2848": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542979034077984"],
        },
        "2849": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095306730375124"],
        },
        "2850": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513199250671919"],
        },
        "2851": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522817107973834"],
        },
        "2852": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495758967868704"],
        },
        "2853": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471958170863314"],
        },
        "2854": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480343708764809"],
        },
        "2855": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450745484858809"],
        },
        "2856": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485857962466689"],
        },
        "2857": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480626070864909"],
        },
        "2858": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485183159766459"],
        },
        "2859": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521555047373404"],
        },
        "2860": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530615710075129"],
        },
        "2861": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474919843064324"],
        },
        "2862": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451261731558989"],
        },
        "2863": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495123290268484"],
        },
        "2864": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461093339060974"],
        },
        "2865": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523417202374039"],
        },
        "2866": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480797412664964"],
        },
        "2867": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520029176172884"],
        },
        "2868": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532214531275674"],
        },
        "2869": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480462354564854"],
        },
        "2870": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471853689663279"],
        },
        "2871": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452766384359499"],
        },
        "2872": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523946131074219"],
        },
        "2873": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515389470672669"],
        },
        "2874": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484521946866234"],
        },
        "2875": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535224699076704"],
        },
        "2876": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949432302468204"],
        },
        "2877": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504388720070279"],
        },
        "2878": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531159121675314"],
        },
        "2879": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504652218070369"],
        },
        "2880": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504242716370229"],
        },
        "2881": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493685081267994"],
        },
        "2882": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946471471562204"],
        },
        "2883": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460681638360834"],
        },
        "2884": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945522023260329"],
        },
        "2885": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483982534166054"],
        },
        "2886": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950334206869909"],
        },
        "2887": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490464120466899"],
        },
        "2888": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485989590466734"],
        },
        "2889": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543137725778034"],
        },
        "2890": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462533723761469"],
        },
        "2891": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470431675162794"],
        },
        "2892": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530293514875019"],
        },
        "2893": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480885271064994"],
        },
        "2894": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494845503668389"],
        },
        "2895": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453939138559899"],
        },
        "2896": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532741655275854"],
        },
        "2897": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493129682967804"],
        },
        "2898": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095021151969499"],
        },
        "2899": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473540442163854"],
        },
        "2900": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511087606371199"],
        },
        "2901": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461049566460959"],
        },
        "2902": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535631911576839"],
        },
        "2903": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511923923371484"],
        },
        "2904": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511235655671254"],
        },
        "2905": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474583362564209"],
        },
        "2906": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450847716658844"],
        },
        "2907": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544857977178624"],
        },
        "2908": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946312165961659"],
        },
        "2909": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541524482877484"],
        },
        "2910": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480328807464804"],
        },
        "2911": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535559025676814"],
        },
        "2912": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461517918161119"],
        },
        "2913": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491837461467364"],
        },
        "2914": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462867983161579"],
        },
        "2915": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502745734769719"],
        },
        "2916": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495890810268749"],
        },
        "2917": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480285068764789"],
        },
        "2918": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451228001858974"],
        },
        "2919": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545424519878814"],
        },
        "2920": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952171252473454"],
        },
        "2921": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512862463271804"],
        },
        "2922": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515124081372579"],
        },
        "2923": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500018241268789"],
        },
        "2924": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951175902471414"],
        },
        "2925": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455523344560439"],
        },
        "2926": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465420142762449"],
        },
        "2927": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530013904774924"],
        },
        "2928": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474715142864254"],
        },
        "2929": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452325546559349"],
        },
        "2930": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464833113062249"],
        },
        "2931": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544442202678479"],
        },
        "2932": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542667442777874"],
        },
        "2933": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462872299361584"],
        },
        "2934": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505024396970499"],
        },
        "2935": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465217617662384"],
        },
        "2936": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515594353272739"],
        },
        "2937": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530264215575009"],
        },
        "2938": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530484049275084"],
        },
        "2939": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484010156966059"],
        },
        "2940": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490767032266999"],
        },
        "2941": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472192380963394"],
        },
        "2942": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533479483976109"],
        },
        "2943": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515061112072554"],
        },
        "2944": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540261482977054"],
        },
        "2945": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544590196278534"],
        },
        "2946": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482137267265424"],
        },
        "2947": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530527682575099"],
        },
        "2948": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493465979867919"],
        },
        "2949": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451184531358959"],
        },
        "2950": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470079000762674"],
        },
        "2951": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510031663170839"],
        },
        "2952": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540217857477039"],
        },
        "2953": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485975343966729"],
        },
        "2954": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500325304168894"],
        },
        "2955": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514240071672274"],
        },
        "2956": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521571300673414"],
        },
        "2957": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462324943061394"],
        },
        "2958": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946304047561629"],
        },
        "2959": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473967060763999"],
        },
        "2960": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475581111264549"],
        },
        "2961": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474553965364199"],
        },
        "2962": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474449869564164"],
        },
        "2963": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533036467975954"],
        },
        "2964": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465449539662459"],
        },
        "2965": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532277351275699"],
        },
        "2966": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484171123166114"],
        },
        "2967": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460125343860644"],
        },
        "2968": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482737149165629"],
        },
        "2969": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470314981262754"],
        },
        "2970": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524268505574329"],
        },
        "2971": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544222841078404"],
        },
        "2972": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532565925175794"],
        },
        "2973": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950346596969944"],
        },
        "2974": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470446771562799"],
        },
        "2975": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945449446660059"],
        },
        "2976": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474230567964089"],
        },
        "2977": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505327768170599"],
        },
        "2978": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462926660161599"],
        },
        "2979": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524857274174534"],
        },
        "2980": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501661592769349"],
        },
        "2981": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521941613973539"],
        },
        "2982": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510617307971039"],
        },
        "2983": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461565777061139"],
        },
        "2984": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525359464374704"],
        },
        "2985": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482894028265679"],
        },
        "2986": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948191078565344"],
        },
        "2987": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511219355671244"],
        },
        "2988": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511869458171469"],
        },
        "2989": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523143689973949"],
        },
        "2990": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453339107159694"],
        },
        "2991": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514885646172494"],
        },
        "2992": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511894414371474"],
        },
        "2993": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501838636769414"],
        },
        "2994": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523873212574194"],
        },
        "2995": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533715622076189"],
        },
        "2996": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492468887667579"],
        },
        "2997": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475285885464449"],
        },
        "2998": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503513192469984"],
        },
        "2999": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501954100469449"],
        },
        "3000": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524650659474459"],
        },
        "3001": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946152909261114"],
        },
        "3002": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532682698775834"],
        },
        "3003": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511555935071359"],
        },
        "3004": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522346829273674"],
        },
        "3005": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544912821878639"],
        },
        "3006": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522259518573644"],
        },
        "3007": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525618509274789"],
        },
        "3008": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460447565360754"],
        },
        "3009": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465551871562494"],
        },
        "3010": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520733473273124"],
        },
        "3011": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483936997366034"],
        },
        "3012": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484566416566249"],
        },
        "3013": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471649084863209"],
        },
        "3014": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543474583778149"],
        },
        "3015": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490752701766994"],
        },
        "3016": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494552509068294"],
        },
        "3017": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503849722670099"],
        },
        "3018": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533974920676274"],
        },
        "3019": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945143569759034"],
        },
        "3020": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949101240067079"],
        },
        "3021": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502848704069754"],
        },
        "3022": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481750846265289"],
        },
        "3023": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511674775471399"],
        },
        "3024": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502643563869684"],
        },
        "3025": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524889039974544"],
        },
        "3026": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452168618459299"],
        },
        "3027": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471122003163029"],
        },
        "3028": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949237583367524"],
        },
        "3029": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514181452772254"],
        },
        "3030": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525589266074779"],
        },
        "3031": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530586374375119"],
        },
        "3032": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543781495778254"],
        },
        "3033": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463576809861824"],
        },
        "3034": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475449095164504"],
        },
        "3035": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485153818466449"],
        },
        "3036": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533182255576004"],
        },
        "3037": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504654091270374"],
        },
        "3038": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463997250361964"],
        },
        "3039": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463942727161949"],
        },
        "3040": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464013198161974"],
        },
        "3041": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474244858364094"],
        },
        "3042": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511263110771259"],
        },
        "3043": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523432186174044"],
        },
        "3044": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530732480075169"],
        },
        "3045": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946202466661284"],
        },
        "3046": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471096746263024"],
        },
        "3047": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493334331467874"],
        },
        "3048": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490928362567054"],
        },
        "3049": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540731787377214"],
        },
        "3050": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512465116671669"],
        },
        "3051": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501972607369459"],
        },
        "3052": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947261722063534"],
        },
        "3053": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464379155262094"],
        },
        "3054": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530766113975184"],
        },
        "3055": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945496946560229"],
        },
        "3056": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535264114576714"],
        },
        "3057": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455979456160594"],
        },
        "3058": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471838636663274"],
        },
        "3059": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471869006363284"],
        },
        "3060": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512337701471629"],
        },
        "3061": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481589712465234"],
        },
        "3062": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954194711077614"],
        },
        "3063": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534756676876544"],
        },
        "3064": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491823170667359"],
        },
        "3065": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510955941771154"],
        },
        "3066": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521642469473434"],
        },
        "3067": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501366765969249"],
        },
        "3068": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515663463572759"],
        },
        "3069": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502438939769614"],
        },
        "3070": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542144915277699"],
        },
        "3071": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501134026269174"],
        },
        "3072": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514020078872199"],
        },
        "3073": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473176300163734"],
        },
        "3074": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464452403262119"],
        },
        "3075": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543342578278104"],
        },
        "3076": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453475103859744"],
        },
        "3077": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513698541572089"],
        },
        "3078": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503597002370009"],
        },
        "3079": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491191632467144"],
        },
        "3080": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454380053160049"],
        },
        "3081": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532711980175844"],
        },
        "3082": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534654300276509"],
        },
        "3083": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484419561966199"],
        },
        "3084": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503465486869964"],
        },
        "3085": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948445286166194"],
        },
        "3086": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503381527369939"],
        },
        "3087": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453793021259849"],
        },
        "3088": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952233318873659"],
        },
        "3089": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450979628258889"],
        },
        "3090": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095355242276794"],
        },
        "3091": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510531174571014"],
        },
        "3092": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464876835162264"],
        },
        "3093": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474773872764274"],
        },
        "3094": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523918687374214"],
        },
        "3095": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952369661274104"],
        },
        "3096": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505053756670509"],
        },
        "3097": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500634640068999"],
        },
        "3098": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491588884167279"],
        },
        "3099": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481940591865354"],
        },
        "3100": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471972489363319"],
        },
        "3101": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480826604264974"],
        },
        "3102": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513742272372104"],
        },
        "3103": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512778603871779"],
        },
        "3104": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510882867771129"],
        },
        "3105": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490414591966879"],
        },
        "3106": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475271695364444"],
        },
        "3107": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535458857476784"],
        },
        "3108": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544485974578494"],
        },
        "3109": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542272202577739"],
        },
        "3110": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485318865466509"],
        },
        "3111": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480855903764984"],
        },
        "3112": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481046379365049"],
        },
        "3113": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522244467673639"],
        },
        "3114": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475742037464604"],
        },
        "3115": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451915982459209"],
        },
        "3116": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465258952362394"],
        },
        "3117": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485226600266474"],
        },
        "3118": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485416939266539"],
        },
        "3119": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464247322562054"],
        },
        "3120": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542463019077804"],
        },
        "3121": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484685115266289"],
        },
        "3122": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461973165161274"],
        },
        "3123": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530160032674974"],
        },
        "3124": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453427189659724"],
        },
        "3125": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523848054674189"],
        },
        "3126": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530322917075029"],
        },
        "3127": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515824027772814"],
        },
        "3128": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525695791674819"],
        },
        "3129": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455874787460559"],
        },
        "3130": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475639314264569"],
        },
        "3131": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482973377865709"],
        },
        "3132": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451232301158979"],
        },
        "3133": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952074096473114"],
        },
        "3134": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502443087069619"],
        },
        "3135": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533857356876234"],
        },
        "3136": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453441533359729"],
        },
        "3137": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540531127477149"],
        },
        "3138": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455143217460309"],
        },
        "3139": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453136756659629"],
        },
        "3140": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503279063369904"],
        },
        "3141": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475892093264659"],
        },
        "3142": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953209588475604"],
        },
        "3143": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946242148161424"],
        },
        "3144": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471355958363109"],
        },
        "3145": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452473686759399"],
        },
        "3146": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501368295669254"],
        },
        "3147": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471692869063224"],
        },
        "3148": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475256567864439"],
        },
        "3149": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514724417472439"],
        },
        "3150": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503699292070044"],
        },
        "3151": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465585564662509"],
        },
        "3152": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505342688470604"],
        },
        "3153": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525225694374659"],
        },
        "3154": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474539687564194"],
        },
        "3155": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954207163377649"],
        },
        "3156": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471899532663294"],
        },
        "3157": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524386978074374"],
        },
        "3158": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501636313969344"],
        },
        "3159": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475053441364374"],
        },
        "3160": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451433074659044"],
        },
        "3161": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495625235168659"],
        },
        "3162": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493645744967984"],
        },
        "3163": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460550089360789"],
        },
        "3164": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473076295763699"],
        },
        "3165": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450862386658851"],
        },
        "3166": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463631324061839"],
        },
        "3167": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462824172561564"],
        },
        "3168": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524991578574579"],
        },
        "3169": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949578923368684"],
        },
        "3170": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543869425778284"],
        },
        "3171": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501768035569389"],
        },
        "3172": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545380721178799"],
        },
        "3173": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953244774675739"],
        },
        "3174": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481148597565084"],
        },
        "3175": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495547883868629"],
        },
        "3176": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954475723978569"],
        },
        "3177": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491369148867204"],
        },
        "3178": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510281255270924"],
        },
        "3179": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490018975666744"],
        },
        "3180": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524489527474404"],
        },
        "3181": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525491065574749"],
        },
        "3182": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525119051574619"],
        },
        "3183": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475169153064409"],
        },
        "3184": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463968020161954"],
        },
        "3185": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525632757574794"],
        },
        "3186": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521057971973234"],
        },
        "3187": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491530211067259"],
        },
        "3188": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473996531564009"],
        },
        "3189": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474084230464039"],
        },
        "3190": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534752310476539"],
        },
        "3191": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530557034675109"],
        },
        "3192": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951124317771239"],
        },
        "3193": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500091210868814"],
        },
        "3194": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451462213359054"],
        },
        "3195": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492278268967514"],
        },
        "3196": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463777259261889"],
        },
        "3197": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524460135074394"],
        },
        "3198": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501190923969189"],
        },
        "3199": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485726215466644"],
        },
        "3200": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452252383059324"],
        },
        "3201": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524180336074299"],
        },
        "3202": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544017589978334"],
        },
        "3203": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493949473968084"],
        },
        "3204": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494068084668124"],
        },
        "3205": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543649860678209"],
        },
        "3206": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946324590961694"],
        },
        "3207": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485625599266614"],
        },
        "3208": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949163241367284"],
        },
        "3209": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521774200873479"],
        },
        "3210": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946276982961524"],
        },
        "3211": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504451776070304"],
        },
        "3212": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495257047168534"],
        },
        "3213": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530425401975064"],
        },
        "3214": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545194515878739"],
        },
        "3215": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535279097876719"],
        },
        "3216": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514710146172434"],
        },
        "3217": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462270385561379"],
        },
        "3218": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451129934358944"],
        },
        "3219": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473937739563989"],
        },
        "3220": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500957016969109"],
        },
        "3221": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470812710262924"],
        },
        "3222": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534183917876349"],
        },
        "3223": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485155362366454"],
        },
        "3224": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945203409559239"],
        },
        "3225": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513144654771904"],
        },
        "3226": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511971844571504"],
        },
        "3227": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473878941963969"],
        },
        "3228": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521467130773374"],
        },
        "3229": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461827455461224"],
        },
        "3230": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482542464765559"],
        },
        "3231": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515312305872639"],
        },
        "3232": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473776576463934"],
        },
        "3233": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542213636177719"],
        },
        "3234": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474719353364259"],
        },
        "3235": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512847372971799"],
        },
        "3236": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484850639366349"],
        },
        "3237": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492630311367634"],
        },
        "3238": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953416619876319"],
        },
        "3239": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525516174574754"],
        },
        "3240": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544471651578489"],
        },
        "3241": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522112831073594"],
        },
        "3242": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473364843663794"],
        },
        "3243": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500461408668944"],
        },
        "3244": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462840470261574"],
        },
        "3245": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452062210659259"],
        },
        "3246": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533315910576054"],
        },
        "3247": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491618145767289"],
        },
        "3248": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512435875771659"],
        },
        "3249": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484614382066269"],
        },
        "3250": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953367248976149"],
        },
        "3251": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504915747270459"],
        },
        "3252": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504345084370264"],
        },
        "3253": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525984708274914"],
        },
        "3254": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531995195275599"],
        },
        "3255": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544676170378559"],
        },
        "3256": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514035098972204"],
        },
        "3257": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525123384174624"],
        },
        "3258": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500266605468874"],
        },
        "3259": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455786946460529"],
        },
        "3260": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503479547169969"],
        },
        "3261": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490932538867059"],
        },
        "3262": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949142745967219"],
        },
        "3263": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481765084565294"],
        },
        "3264": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500486445468949"],
        },
        "3265": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534048042076299"],
        },
        "3266": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540159176377019"],
        },
        "3267": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491691441467314"],
        },
        "3268": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481999216365374"],
        },
        "3269": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521893719973519"],
        },
        "3270": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544956224778654"],
        },
        "3271": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474464553664169"],
        },
        "3272": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540658880077189"],
        },
        "3273": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543183250478054"],
        },
        "3274": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544519712378509"],
        },
        "3275": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947226663063399"],
        },
        "3276": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473130749863714"],
        },
        "3277": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503552504969994"],
        },
        "3278": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533215874876019"],
        },
        "3279": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533343439276059"],
        },
        "3280": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482659824065599"],
        },
        "3281": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473849424663959"],
        },
        "3282": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481798727765309"],
        },
        "3283": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463395063261759"],
        },
        "3284": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515385121372664"],
        },
        "3285": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950431291570249"],
        },
        "3286": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511336456571284"],
        },
        "3287": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532175119775664"],
        },
        "3288": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475139779364399"],
        },
        "3289": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463468322361784"],
        },
        "3290": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462956052761609"],
        },
        "3291": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504989504170484"],
        },
        "3292": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542244764277734"],
        },
        "3293": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494818407268384"],
        },
        "3294": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502570548869659"],
        },
        "3295": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511033276071184"],
        },
        "3296": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473496766763839"],
        },
        "3297": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473145064763719"],
        },
        "3298": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484758362366314"],
        },
        "3299": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462136229661334"],
        },
        "3300": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493075230767789"],
        },
        "3301": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494375190068229"],
        },
        "3302": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951101451571174"],
        },
        "3303": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544285501578429"],
        },
        "3304": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470975762954"],
        },
        "3305": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492473078067584"],
        },
        "3306": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541097552477339"],
        },
        "3307": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455947943160584"],
        },
        "3308": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480387416664824"],
        },
        "3309": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520632880373094"],
        },
        "3310": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455289422260359"],
        },
        "3311": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483512410665894"],
        },
        "3312": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510719809171074"],
        },
        "3313": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451725464859144"],
        },
        "3314": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949359717467934"],
        },
        "3315": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500595212368989"],
        },
        "3316": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471885271963289"],
        },
        "3317": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534858839176579"],
        },
        "3318": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501734265969374"],
        },
        "3319": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953011029674954"],
        },
        "3320": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541229124577384"],
        },
        "3321": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522581396673754"],
        },
        "3322": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512245276171594"],
        },
        "3323": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503214006569879"],
        },
        "3324": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495225685668519"],
        },
        "3325": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471330906363104"],
        },
        "3326": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484610028466264"],
        },
        "3327": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492996171567759"],
        },
        "3328": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531338763175379"],
        },
        "3329": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475757880864614"],
        },
        "3330": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454984400060259"],
        },
        "3331": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544090527678359"],
        },
        "3332": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535720096876869"],
        },
        "3333": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480194936964759"],
        },
        "3334": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505258666770579"],
        },
        "3335": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494218361368179"],
        },
        "3336": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463865548461919"],
        },
        "3337": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451567910359094"],
        },
        "3338": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470212534462719"],
        },
        "3339": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510192931870894"],
        },
        "3340": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094931505267794"],
        },
        "3341": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512671995171739"],
        },
        "3342": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525443056374729"],
        },
        "3343": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500164332068839"],
        },
        "3344": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945313010759614"],
        },
        "3345": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510529448571009"],
        },
        "3346": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533920325476259"],
        },
        "3347": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482426108065519"],
        },
        "3348": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485755580066654"],
        },
        "3349": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954186411277584"],
        },
        "3350": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470126457562694"],
        },
        "3351": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461997061249"],
        },
        "3352": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474142814864059"],
        },
        "3353": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953236851175709"],
        },
        "3354": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485960236566724"],
        },
        "3355": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495284721168539"],
        },
        "3356": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501997776569464"],
        },
        "3357": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453895404959884"],
        },
        "3358": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480019557764699"],
        },
        "3359": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535122342776669"],
        },
        "3360": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533138662375989"],
        },
        "3361": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484921125466374"],
        },
        "3362": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492293311167519"],
        },
        "3363": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533684194676179"],
        },
        "3364": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524152805374294"],
        },
        "3365": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545292641978769"],
        },
        "3366": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541567869777499"],
        },
        "3367": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534052200376304"],
        },
        "3368": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470828913762934"],
        },
        "3369": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523051302773914"],
        },
        "3370": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514421695972339"],
        },
        "3371": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491866700567374"],
        },
        "3372": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523755726274154"],
        },
        "3373": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520616719273084"],
        },
        "3374": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504272084870239"],
        },
        "3375": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522537799273739"],
        },
        "3376": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482473660065539"],
        },
        "3377": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524694253674474"],
        },
        "3378": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485548570366584"],
        },
        "3379": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500795602669054"],
        },
        "3380": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473864506663964"],
        },
        "3381": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952123675773284"],
        },
        "3382": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500149954368834"],
        },
        "3383": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460656665360829"],
        },
        "3384": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495915822468754"],
        },
        "3385": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480494138564864"],
        },
        "3386": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520587344073074"],
        },
        "3387": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544076341078354"],
        },
        "3388": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494741010068354"],
        },
        "3389": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953124630175334"],
        },
        "3390": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953257216375774"],
        },
        "3391": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481330483065149"],
        },
        "3392": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475085326764384"],
        },
        "3393": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495650341868664"],
        },
        "3394": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455186902860324"],
        },
        "3395": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952061721173079"],
        },
        "3396": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470549334062834"],
        },
        "3397": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480519241464869"],
        },
        "3398": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463528906161804"],
        },
        "3399": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522041757273574"],
        },
        "3400": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502072706769494"],
        },
        "3401": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494770413768364"],
        },
        "3402": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511233746571249"],
        },
        "3403": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948507296666399"],
        },
        "3404": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474819297964294"],
        },
        "3405": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500222971468859"],
        },
        "3406": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524136659974284"],
        },
        "3407": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470827018962929"],
        },
        "3408": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462368639161409"],
        },
        "3409": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515619446672744"],
        },
        "3410": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510460591470989"],
        },
        "3411": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521321202173324"],
        },
        "3412": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535929118076944"],
        },
        "3413": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541421633477449"],
        },
        "3414": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525413872074719"],
        },
        "3415": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532229605175679"],
        },
        "3416": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492746547267674"],
        },
        "3417": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512055605371529"],
        },
        "3418": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453176087359639"],
        },
        "3419": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533416389476084"],
        },
        "3420": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473481813163834"],
        },
        "3421": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463058426061644"],
        },
        "3422": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534927537276599"],
        },
        "3423": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541337936877424"],
        },
        "3424": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501481069264"],
        },
        "3425": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495186339368509"],
        },
        "3426": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533347668576064"],
        },
        "3427": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511165029571229"],
        },
        "3428": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949261110067624"],
        },
        "3429": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949347348867899"],
        },
        "3430": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510368180870954"],
        },
        "3431": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531436906975409"],
        },
        "3432": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461739483061194"],
        },
        "3433": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461431669361094"],
        },
        "3434": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522730152973804"],
        },
        "3435": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515560641372724"],
        },
        "3436": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953162310675469"],
        },
        "3437": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533872304976239"],
        },
        "3438": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481017051065039"],
        },
        "3439": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513042300171869"],
        },
        "3440": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523741456974149"],
        },
        "3441": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530688766575154"],
        },
        "3442": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515487574672699"],
        },
        "3443": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953404432676284"],
        },
        "3444": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950112772469159"],
        },
        "3445": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452868680059534"],
        },
        "3446": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509450935290458874"],
        },
        "3447": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540834140777249"],
        },
        "3448": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493543399967949"],
        },
        "3449": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485843603866684"],
        },
        "3450": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524034451674249"],
        },
        "3451": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502629343269679"],
        },
        "3452": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483642483465934"],
        },
        "3453": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490621049866949"],
        },
        "3454": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482235477565454"],
        },
        "3455": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462061353361304"],
        },
        "3456": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492644681767639"],
        },
        "3457": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523139353373944"],
        },
        "3458": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510266323270919"],
        },
        "3459": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535763675076884"],
        },
        "3460": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505390407170624"],
        },
        "3461": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462897362561589"],
        },
        "3462": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480078154864719"],
        },
        "3463": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512026203571519"],
        },
        "3464": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543083287078019"],
        },
        "3465": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951246355271649"],
        },
        "3466": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484450789666214"],
        },
        "3467": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533245277176029"],
        },
        "3468": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948151576965204"],
        },
        "3469": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471722026363234"],
        },
        "3470": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511438658871319"],
        },
        "3471": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510094787670864"],
        },
        "3472": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534286251276384"],
        },
        "3473": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460023132960609"],
        },
        "3474": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465085879662339"],
        },
        "3475": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492238932467504"],
        },
        "3476": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454311290260029"],
        },
        "3477": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451989059659234"],
        },
        "3478": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534590025076484"],
        },
        "3479": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505620253670699"],
        },
        "3480": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470758278562909"],
        },
        "3481": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545014858878674"],
        },
        "3482": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524914104074549"],
        },
        "3483": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534413815976424"],
        },
        "3484": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535088765576654"],
        },
        "3485": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511967598471499"],
        },
        "3486": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524052945174259"],
        },
        "3487": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544383448378459"],
        },
        "3488": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454045855259939"],
        },
        "3489": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521971124473549"],
        },
        "3490": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455454601660419"],
        },
        "3491": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533080310975969"],
        },
        "3492": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482557476765564"],
        },
        "3493": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954173958577549"],
        },
        "3494": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504549823270334"],
        },
        "3495": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522435192473704"],
        },
        "3496": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491235323567159"],
        },
        "3497": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511865203871464"],
        },
        "3498": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531554601875449"],
        },
        "3499": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490311935066844"],
        },
        "3500": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525793976274849"],
        },
        "3501": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500559427368974"],
        },
        "3502": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500649599369004"],
        },
        "3503": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531393173675394"],
        },
        "3504": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945399749859889"],
        },
        "3505": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475727071264599"],
        },
        "3506": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484714563966299"],
        },
        "3507": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503786627470074"],
        },
        "3508": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525089685974609"],
        },
        "3509": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514973816172524"],
        },
        "3510": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500898080169089"],
        },
        "3511": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451067065358919"],
        },
        "3512": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491925479167394"],
        },
        "3513": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505151898570539"],
        },
        "3514": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534986346076619"],
        },
        "3515": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501454611869279"],
        },
        "3516": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452384229359369"],
        },
        "3517": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540892727577269"],
        },
        "3518": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472471847963494"],
        },
        "3519": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501690678869359"],
        },
        "3520": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520528618473054"],
        },
        "3521": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545117226978709"],
        },
        "3522": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945072198358794"],
        },
        "3523": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543635513678204"],
        },
        "3524": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513067371671874"],
        },
        "3525": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495050290968459"],
        },
        "3526": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483278191665814"],
        },
        "3527": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541392324077439"],
        },
        "3528": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475037327264364"],
        },
        "3529": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544985496678664"],
        },
        "3530": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480768088564954"],
        },
        "3531": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946328796061699"],
        },
        "3532": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948213807365409"],
        },
        "3533": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481896884165339"],
        },
        "3534": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535192894276694"],
        },
        "3535": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520898766373184"],
        },
        "3536": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470929291162964"],
        },
        "3537": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460892824660909"],
        },
        "3538": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515882819872834"],
        },
        "3539": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545458057378829"],
        },
        "3540": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504169739270204"],
        },
        "3541": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520064494072899"],
        },
        "3542": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474890471864314"],
        },
        "3543": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490355622866859"],
        },
        "3544": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493246166767844"],
        },
        "3545": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484273482866149"],
        },
        "3546": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495372447868569"],
        },
        "3547": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948323429465784"],
        },
        "3548": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505824904070769"],
        },
        "3549": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460888500960904"],
        },
        "3550": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513012937871859"],
        },
        "3551": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461122670560984"],
        },
        "3552": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540232164177044"],
        },
        "3553": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493450990867914"],
        },
        "3554": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483130114865759"],
        },
        "3555": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492864104067714"],
        },
        "3556": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480728373264944"],
        },
        "3557": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947311490463704"],
        },
        "3558": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460711067760844"],
        },
        "3559": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503247290669894"],
        },
        "3560": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492263969267509"],
        },
        "3561": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523241750073979"],
        },
        "3562": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490077739066764"],
        },
        "3563": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952136099173319"],
        },
        "3564": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490855522267029"],
        },
        "3565": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531039648575274"],
        },
        "3566": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503362972269929"],
        },
        "3567": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460564271360794"],
        },
        "3568": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452590994559439"],
        },
        "3569": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470594797162854"],
        },
        "3570": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481794497865304"],
        },
        "3571": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455068218360284"],
        },
        "3572": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503274903869899"],
        },
        "3573": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454277692460014"],
        },
        "3574": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946182059461219"],
        },
        "3575": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465111010262344"],
        },
        "3576": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513213390871924"],
        },
        "3577": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493363598467884"],
        },
        "3578": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463938375161944"],
        },
        "3579": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495152682268494"],
        },
        "3580": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541774628277574"],
        },
        "3581": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525896287474884"],
        },
        "3582": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950164462369334"],
        },
        "3583": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954415749278364"],
        },
        "3584": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465922044762624"],
        },
        "3585": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503245390969889"],
        },
        "3586": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534693884476519"],
        },
        "3587": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534077262876309"],
        },
        "3588": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485657401366624"],
        },
        "3589": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531438769075414"],
        },
        "3590": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483671821865944"],
        },
        "3591": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525162764774634"],
        },
        "3592": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490253217566824"],
        },
        "3593": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530498423575089"],
        },
        "3594": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523712130774139"],
        },
        "3595": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471933197363309"],
        },
        "3596": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482411179265514"],
        },
        "3597": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472871528463629"],
        },
        "3598": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948265445265584"],
        },
        "3599": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453675681159809"],
        },
        "3600": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512573861971709"],
        },
        "3601": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522675572973789"],
        },
        "3602": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493480306867924"],
        },
        "3603": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481119367465074"],
        },
        "3604": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490296845266839"],
        },
        "3605": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492042072167434"],
        },
        "3606": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950288832069744"],
        },
        "3607": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543035425077999"],
        },
        "3608": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472733417463579"],
        },
        "3609": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535030022176634"],
        },
        "3610": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953122861175329"],
        },
        "3611": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455743131660514"],
        },
        "3612": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500883736669084"],
        },
        "3613": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523271227273989"],
        },
        "3614": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953114624575299"],
        },
        "3615": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461590945461144"],
        },
        "3616": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949322530467829"],
        },
        "3617": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465351439662429"],
        },
        "3618": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094614525761079"],
        },
        "3619": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452634686559454"],
        },
        "3620": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475990230164689"],
        },
        "3621": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483233034465794"],
        },
        "3622": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455713826660504"],
        },
        "3623": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464147356762019"],
        },
        "3624": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543915197378299"],
        },
        "3625": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543317417678099"],
        },
        "3626": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491793642267349"],
        },
        "3627": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953391817276249"],
        },
        "3628": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514214976272269"],
        },
        "3629": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454750181060179"],
        },
        "3630": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534457405376439"],
        },
        "3631": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540349550277084"],
        },
        "3632": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472940292963649"],
        },
        "3633": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952103191673219"],
        },
        "3634": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534913245976594"],
        },
        "3635": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491016216767084"],
        },
        "3636": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543752043778244"],
        },
        "3637": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454545441860109"],
        },
        "3638": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464672034062194"],
        },
        "3639": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542681746477879"],
        },
        "3640": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495945166968764"],
        },
        "3641": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483951339366039"],
        },
        "3642": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542550461877834"],
        },
        "3643": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493539127967944"],
        },
        "3644": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510515021771004"],
        },
        "3645": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462299744461389"],
        },
        "3646": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470578752162844"],
        },
        "3647": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523534512674079"],
        },
        "3648": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952148368473354"],
        },
        "3649": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501117866469164"],
        },
        "3650": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484948565566379"],
        },
        "3651": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475789688964624"],
        },
        "3652": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501968287669454"],
        },
        "3653": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531832129975544"],
        },
        "3654": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500179370568844"],
        },
        "3655": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465376518662434"],
        },
        "3656": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514373738272319"],
        },
        "3657": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540334657077079"],
        },
        "3658": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455922850660579"],
        },
        "3659": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540526890577144"],
        },
        "3660": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462633912061499"],
        },
        "3661": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472779565763594"],
        },
        "3662": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533113535375984"],
        },
        "3663": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533431489976089"],
        },
        "3664": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462354264661404"],
        },
        "3665": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472737757363584"],
        },
        "3666": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952187491873494"],
        },
        "3667": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492027879867429"],
        },
        "3668": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464847468662254"],
        },
        "3669": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475453329864509"],
        },
        "3670": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474953453564339"],
        },
        "3671": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493831998168044"],
        },
        "3672": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454541209260104"],
        },
        "3673": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545512466378844"],
        },
        "3674": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461547316961129"],
        },
        "3675": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485187166366464"],
        },
        "3676": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521671839873444"],
        },
        "3677": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460622920360814"],
        },
        "3678": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521233055673294"],
        },
        "3679": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952163163573424"],
        },
        "3680": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512613157471719"],
        },
        "3681": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946533545962409"],
        },
        "3682": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475829019364634"],
        },
        "3683": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494082365868129"],
        },
        "3684": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462295616761384"],
        },
        "3685": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520162565472929"],
        },
        "3686": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483675846665949"],
        },
        "3687": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513785874472119"],
        },
        "3688": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505444848570639"],
        },
        "3689": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250952295295973864"],
        },
        "3690": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453558865459769"],
        },
        "3691": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483496273365884"],
        },
        "3692": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460184118560664"],
        },
        "3693": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503097304369839"],
        },
        "3694": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540965899577294"],
        },
        "3695": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460961640260929"],
        },
        "3696": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495827735368724"],
        },
        "3697": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490048466266754"],
        },
        "3698": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464554612762154"],
        },
        "3699": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480489915564859"],
        },
        "3700": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543416017278131"],
        },
        "3701": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463263431561714"],
        },
        "3702": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947348558763809"],
        },
        "3703": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542228539777724"],
        },
        "3704": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514655695572419"],
        },
        "3705": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460140543860649"],
        },
        "3706": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950443760370284"],
        },
        "3707": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470256365962734"],
        },
        "3708": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521471438373379"],
        },
        "3709": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481253161565119"],
        },
        "3710": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523476052374059"],
        },
        "3711": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532127158575644"],
        },
        "3712": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485389402466534"],
        },
        "3713": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452434299159389"],
        },
        "3714": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954248371177789"],
        },
        "3715": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950406475170149"],
        },
        "3716": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513815233072129"],
        },
        "3717": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540760995577224"],
        },
        "3718": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533550126276134"],
        },
        "3719": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455688718960499"],
        },
        "3720": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524385136274369"],
        },
        "3721": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949444610168239"],
        },
        "3722": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485859759066694"],
        },
        "3723": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482455121465529"],
        },
        "3724": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471532028763171"],
        },
        "3725": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463660662761849"],
        },
        "3726": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520867039273174"],
        },
        "3727": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504256955170234"],
        },
        "3728": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514988124472529"],
        },
        "3729": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531275756375354"],
        },
        "3730": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461078863360969"],
        },
        "3731": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509511267426371264"],
        },
        "3732": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470476089062809"],
        },
        "3733": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945327205559654"],
        },
        "3734": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540863351677259"],
        },
        "3735": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531938831475584"],
        },
        "3736": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535592639676829"],
        },
        "3737": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484580744666254"],
        },
        "3738": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542915857477959"],
        },
        "3739": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503981440970144"],
        },
        "3740": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480299349564794"],
        },
        "3741": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512011153871514"],
        },
        "3742": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495813511768719"],
        },
        "3743": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522980144073894"],
        },
        "3744": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451330614859011"],
        },
        "3745": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452825100559519"],
        },
        "3746": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475217171464429"],
        },
        "3747": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535749400376879"],
        },
        "3748": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534154585176339"],
        },
        "3749": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481535281165219"],
        },
        "3750": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484116686066099"],
        },
        "3751": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475921452264669"],
        },
        "3752": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480180637764754"],
        },
        "3753": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492937066567739"],
        },
        "3754": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495079632168469"],
        },
        "3755": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501322988969234"],
        },
        "3756": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513512497872029"],
        },
        "3757": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946264520961489"],
        },
        "3758": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532332035875714"],
        },
        "3759": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492366305667544"],
        },
        "3760": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463336556861739"],
        },
        "3761": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491221051767154"],
        },
        "3762": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455038859560274"],
        },
        "3763": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951418111172229"],
        },
        "3764": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505122535570529"],
        },
        "3765": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954428351178399"],
        },
        "3766": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494318391868214"],
        },
        "3767": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512128708971554"],
        },
        "3768": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532448436975754"],
        },
        "3769": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946434175062069"],
        },
        "3770": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472910825663639"],
        },
        "3771": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542769759677909"],
        },
        "3772": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500868619669079"],
        },
        "3773": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530791193975189"],
        },
        "3774": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492057281267439"],
        },
        "3775": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510499949570999"],
        },
        "3776": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452354804959359"],
        },
        "3777": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095010448269124"],
        },
        "3778": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455320536260374"],
        },
        "3779": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483042037265729"],
        },
        "3780": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455086407960294"],
        },
        "3781": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533450050676099"],
        },
        "3782": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463029088361634"],
        },
        "3783": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464011528161969"],
        },
        "3784": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543785800978259"],
        },
        "3785": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464364845562089"],
        },
        "3786": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501425403969269"],
        },
        "3787": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452164416759294"],
        },
        "3788": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946483863262239"],
        },
        "3789": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525750180674834"],
        },
        "3790": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465522640362484"],
        },
        "3791": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462065633761309"],
        },
        "3792": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473233102063749"],
        },
        "3793": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493379807667894"],
        },
        "3794": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452428026959384"],
        },
        "3795": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513844767172139"],
        },
        "3796": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541992772577644"],
        },
        "3797": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474115062364054"],
        },
        "3798": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513184396171914"],
        },
        "3799": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473467335063829"],
        },
        "3800": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540922057277279"],
        },
        "3801": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493411612367904"],
        },
        "3802": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535147427976674"],
        },
        "3803": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463675131761854"],
        },
        "3804": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512362816571634"],
        },
        "3805": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513817145972134"],
        },
        "3806": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514269133172284"],
        },
        "3807": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525326208774691"],
        },
        "3808": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954146716577444"],
        },
        "3809": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465712977762549"],
        },
        "3810": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532595299275804"],
        },
        "3811": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522439361673709"],
        },
        "3812": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544051233878349"],
        },
        "3813": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520767025573139"],
        },
        "3814": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484639354866274"],
        },
        "3815": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510562996171024"],
        },
        "3816": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515429115872679"],
        },
        "3817": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514755672772454"],
        },
        "3818": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464069968961989"],
        },
        "3819": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481692157365269"],
        },
        "3820": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512676222971744"],
        },
        "3821": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504554138770339"],
        },
        "3822": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541758473077564"],
        },
        "3823": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520353019572994"],
        },
        "3824": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544490180078499"],
        },
        "3825": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948226082665444"],
        },
        "3826": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454350656360039"],
        },
        "3827": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502380009369594"],
        },
        "3828": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481267625765124"],
        },
        "3829": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095305233875094"],
        },
        "3830": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490150812366789"],
        },
        "3831": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950518167370524"],
        },
        "3832": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500427690368929"],
        },
        "3833": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949339254167869"],
        },
        "3834": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455788715160534"],
        },
        "3835": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535352154976744"],
        },
        "3836": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509521789299273484"],
        },
        "3837": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472119319463369"],
        },
        "3838": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451623000859109"],
        },
        "3839": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509451666804059124"],
        },
        "3840": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525457442774734"],
        },
        "3841": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465772074662569"],
        },
        "3842": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455113945660299"],
        },
        "3843": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510046731470844"],
        },
        "3844": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465727437262554"],
        },
        "3845": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482339589465494"],
        },
        "3846": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520148311872924"],
        },
        "3847": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512479605771674"],
        },
        "3848": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509512774364071774"],
        },
        "3849": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541068170177329"],
        },
        "3850": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501486070569289"],
        },
        "3851": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515960124072864"],
        },
        "3852": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470962978662979"],
        },
        "3853": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455013802060269"],
        },
        "3854": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948385707965989"],
        },
        "3855": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509545092152178704"],
        },
        "3856": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453044141859594"],
        },
        "3857": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509470490392862814"],
        },
        "3858": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452854472759529"],
        },
        "3859": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950272132369704"],
        },
        "3860": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250947214312363364"],
        },
        "3861": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494668073968329"],
        },
        "3862": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474069844164034"],
        },
        "3863": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531134093775309"],
        },
        "3864": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485021635066404"],
        },
        "3865": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510558701971019"],
        },
        "3866": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492732216667669"],
        },
        "3867": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946068646060809"],
        },
        "3868": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250946558279662479"],
        },
        "3869": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523212371873969"],
        },
        "3870": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543064694978009"],
        },
        "3871": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533065898775964"],
        },
        "3872": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460476941760764"],
        },
        "3873": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525398828074714"],
        },
        "3874": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513374314271979"],
        },
        "3875": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540131464377014"],
        },
        "3876": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509473747197663924"],
        },
        "3877": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509535454612776779"],
        },
        "3878": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509531627291475474"],
        },
        "3879": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472137793263379"],
        },
        "3880": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515623716572749"],
        },
        "3881": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250948555092166569"],
        },
        "3882": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514285482172289"],
        },
        "3883": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509492336933967534"],
        },
        "3884": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500663967969009"],
        },
        "3885": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464715729562209"],
        },
        "3886": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530659427175144"],
        },
        "3887": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502188216269529"],
        },
        "3888": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480155570664749"],
        },
        "3889": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453836743059864"],
        },
        "3890": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491735100567329"],
        },
        "3891": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509510665346171059"],
        },
        "3892": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954134226077409"],
        },
        "3893": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514685076672429"],
        },
        "3894": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945484649260194"],
        },
        "3895": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472942147563654"],
        },
        "3896": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541875051377604"],
        },
        "3897": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533769903376204"],
        },
        "3898": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505914976070799"],
        },
        "3899": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520192022572939"],
        },
        "3900": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464617598362179"],
        },
        "3901": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524811739974514"],
        },
        "3902": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250950235013269569"],
        },
        "3903": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522391392273689"],
        },
        "3904": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494653069168324"],
        },
        "3905": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543181345778049"],
        },
        "3906": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503333447269919"],
        },
        "3907": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534252722476369"],
        },
        "3908": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509480151361964744"],
        },
        "3909": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463810899461904"],
        },
        "3910": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509454850127260214"],
        },
        "3911": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525094842448866124"],
        },
        "3912": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540367750477094"],
        },
        "3913": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491970984267414"],
        },
        "3914": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504842700570434"],
        },
        "3915": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452575927259434"],
        },
        "3916": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482440279765524"],
        },
        "3917": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460461903060759"],
        },
        "3918": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494952247768429"],
        },
        "3919": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490961789867069"],
        },
        "3920": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474851108964304"],
        },
        "3921": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.20180525095322156675669"],
        },
        "3922": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542170050577704"],
        },
        "3923": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462999717261624"],
        },
        "3924": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509452638953059459"],
        },
        "3925": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475319531864464"],
        },
        "3926": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520926148873189"],
        },
        "3927": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522127878373599"],
        },
        "3928": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509500281712668879"],
        },
        "3929": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530531964675104"],
        },
        "3930": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523036932173909"],
        },
        "3931": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949469330268309"],
        },
        "3932": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509514622096872404"],
        },
        "3933": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534488721476454"],
        },
        "3934": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502468257769624"],
        },
        "3935": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534384582076414"],
        },
        "3936": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503038649069819"],
        },
        "3937": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513947066372174"],
        },
        "3938": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541831405077589"],
        },
        "3939": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464274820162059"],
        },
        "3940": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490727697766989"],
        },
        "3941": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509532948235375924"],
        },
        "3942": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520323743572984"],
        },
        "3943": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540765325377229"],
        },
        "3944": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504115218670189"],
        },
        "3945": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509482571787465569"],
        },
        "3946": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540835888977254"],
        },
        "3947": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464279096662064"],
        },
        "3948": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481296968965134"],
        },
        "3949": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534724871776534"],
        },
        "3950": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250951112032471204"],
        },
        "3951": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484992363466394"],
        },
        "3952": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509502424560569609"],
        },
        "3953": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503082260969834"],
        },
        "3954": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461429780061089"],
        },
        "3955": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509544544722678514"],
        },
        "3956": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501533803869309"],
        },
        "3957": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495459754468599"],
        },
        "3958": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483262223365804"],
        },
        "3959": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534135988676329"],
        },
        "3960": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509513330595771964"],
        },
        "3961": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520430571873024"],
        },
        "3962": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509530761893975179"],
        },
        "3963": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471619747463199"],
        },
        "3964": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509515257794972624"],
        },
        "3965": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509543581000478189"],
        },
        "3966": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465654328062529"],
        },
        "3967": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485916650966709"],
        },
        "3968": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465081550062334"],
        },
        "3969": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455084622160289"],
        },
        "3970": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250949297805167729"],
        },
        "3971": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509460345131260719"],
        },
        "3972": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523198037873964"],
        },
        "3973": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509485519419966574"],
        },
        "3974": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509475887806364654"],
        },
        "3975": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509524623095674454"],
        },
        "3976": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250945325358059649"],
        },
        "3977": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509462558794261474"],
        },
        "3978": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509542945265877969"],
        },
        "3979": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509491871010467379"],
        },
        "3980": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463913304361939"],
        },
        "3981": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520865261573169"],
        },
        "3982": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494711703768344"],
        },
        "3983": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509453943417459904"],
        },
        "3984": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509474215652664084"],
        },
        "3985": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504583551270349"],
        },
        "3986": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250954208662077654"],
        },
        "3987": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509490664652866964"],
        },
        "3988": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494755367668359"],
        },
        "3989": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509484112431666094"],
        },
        "3990": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509503481417469974"],
        },
        "3991": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509504020762970154"],
        },
        "3992": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509541938083477629"],
        },
        "3993": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509533241119376024"],
        },
        "3994": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493796667999"],
        },
        "3995": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509465347237562424"],
        },
        "3996": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509455640633860479"],
        },
        "3997": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534091554576314"],
        },
        "3998": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509493612163667969"],
        },
        "3999": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520792118573144"],
        },
        "4000": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534942574776604"],
        },
        "4001": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509520382729773004"],
        },
        "4002": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509523814416274174"],
        },
        "4003": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509483364701465839"],
        },
        "4004": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.201805250953342063876079"],
        },
        "4005": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509472133751863374"],
        },
        "4006": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509461313045861049"],
        },
        "4007": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505678919170719"],
        },
        "4008": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509471194775363054"],
        },
        "4009": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509495784029968709"],
        },
        "4010": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509501015383269129"],
        },
        "4011": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509464717548462214"],
        },
        "4012": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509525677203274809"],
        },
        "4013": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509463779121361894"],
        },
        "4014": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509481238227265114"],
        },
        "4015": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509540365992177089"],
        },
        "4016": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509534888224576589"],
        },
        "4017": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509494638761168319"],
        },
        "4018": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509522880141173859"],
        },
        "4019": {
            "vr": "UI",
            "Value": ["1.3.12.2.1107.5.2.19.45193.2018052509505592789670694"],
        },
    },
    "00080032": {
        "0": {"vr": "TM", "Value": ["094817.767500"]},
        "1": {"vr": "TM", "Value": ["094929.485000"]},
        "2": {"vr": "TM", "Value": ["095117.007500"]},
        "3": {"vr": "TM", "Value": ["095138.265000"]},
        "4": {"vr": "TM", "Value": ["095050.607500"]},
        "5": {"vr": "TM", "Value": ["095042.247500"]},
        "6": {"vr": "TM", "Value": ["095301.437500"]},
        "7": {"vr": "TM", "Value": ["095319.915000"]},
        "8": {"vr": "TM", "Value": ["094830.100000"]},
        "9": {"vr": "TM", "Value": ["094659.152500"]},
        "10": {"vr": "TM", "Value": ["095259.222500"]},
        "11": {"vr": "TM", "Value": ["094840.510000"]},
        "12": {"vr": "TM", "Value": ["094836.100000"]},
        "13": {"vr": "TM", "Value": ["094509.455000"]},
        "14": {"vr": "TM", "Value": ["094957.660000"]},
        "15": {"vr": "TM", "Value": ["095150.137500"]},
        "16": {"vr": "TM", "Value": ["095245.592500"]},
        "17": {"vr": "TM", "Value": ["094600.937500"]},
        "18": {"vr": "TM", "Value": ["094758.412500"]},
        "19": {"vr": "TM", "Value": ["095153.670000"]},
        "20": {"vr": "TM", "Value": ["094709.290000"]},
        "21": {"vr": "TM", "Value": ["095204.372500"]},
        "22": {"vr": "TM", "Value": ["095225.485000"]},
        "23": {"vr": "TM", "Value": ["095352.315000"]},
        "24": {"vr": "TM", "Value": ["095209.955000"]},
        "25": {"vr": "TM", "Value": ["094756.070000"]},
        "26": {"vr": "TM", "Value": ["094939.037500"]},
        "27": {"vr": "TM", "Value": ["094722.920000"]},
        "28": {"vr": "TM", "Value": ["094745.222500"]},
        "29": {"vr": "TM", "Value": ["095142.967500"]},
        "30": {"vr": "TM", "Value": ["094940.940000"]},
        "31": {"vr": "TM", "Value": ["094825.397500"]},
        "32": {"vr": "TM", "Value": ["095021.407500"]},
        "33": {"vr": "TM", "Value": ["094738.177500"]},
        "34": {"vr": "TM", "Value": ["095454.792500"]},
        "35": {"vr": "TM", "Value": ["094506.090000"]},
        "36": {"vr": "TM", "Value": ["094641.260000"]},
        "37": {"vr": "TM", "Value": ["094753.290000"]},
        "38": {"vr": "TM", "Value": ["095105.845000"]},
        "39": {"vr": "TM", "Value": ["094914.540000"]},
        "40": {"vr": "TM", "Value": ["095317.552500"]},
        "41": {"vr": "TM", "Value": ["095425.905000"]},
        "42": {"vr": "TM", "Value": ["095431.192500"]},
        "43": {"vr": "TM", "Value": ["094758.557500"]},
        "44": {"vr": "TM", "Value": ["095248.227500"]},
        "45": {"vr": "TM", "Value": ["094615.885000"]},
        "46": {"vr": "TM", "Value": ["095300.392500"]},
        "47": {"vr": "TM", "Value": ["095422.392500"]},
        "48": {"vr": "TM", "Value": ["094907.055000"]},
        "49": {"vr": "TM", "Value": ["094531.885000"]},
        "50": {"vr": "TM", "Value": ["095228.432500"]},
        "51": {"vr": "TM", "Value": ["095236.940000"]},
        "52": {"vr": "TM", "Value": ["095246.617500"]},
        "53": {"vr": "TM", "Value": ["094815.135000"]},
        "54": {"vr": "TM", "Value": ["094632.460000"]},
        "55": {"vr": "TM", "Value": ["094848.577500"]},
        "56": {"vr": "TM", "Value": ["095043.710000"]},
        "57": {"vr": "TM", "Value": ["094906.032500"]},
        "58": {"vr": "TM", "Value": ["094829.222500"]},
        "59": {"vr": "TM", "Value": ["094726.890000"]},
        "60": {"vr": "TM", "Value": ["095141.045000"]},
        "61": {"vr": "TM", "Value": ["095311.992500"]},
        "62": {"vr": "TM", "Value": ["094814.987500"]},
        "63": {"vr": "TM", "Value": ["095437.045000"]},
        "64": {"vr": "TM", "Value": ["095039.300000"]},
        "65": {"vr": "TM", "Value": ["095438.382500"]},
        "66": {"vr": "TM", "Value": ["094816.305000"]},
        "67": {"vr": "TM", "Value": ["094843.290000"]},
        "68": {"vr": "TM", "Value": ["094650.937500"]},
        "69": {"vr": "TM", "Value": ["094715.290000"]},
        "70": {"vr": "TM", "Value": ["094626.607500"]},
        "71": {"vr": "TM", "Value": ["095048.685000"]},
        "72": {"vr": "TM", "Value": ["095043.270000"]},
        "73": {"vr": "TM", "Value": ["095204.520000"]},
        "74": {"vr": "TM", "Value": ["094605.327500"]},
        "75": {"vr": "TM", "Value": ["095407.135000"]},
        "76": {"vr": "TM", "Value": ["095201.155000"]},
        "77": {"vr": "TM", "Value": ["094942.402500"]},
        "78": {"vr": "TM", "Value": ["095143.555000"]},
        "79": {"vr": "TM", "Value": ["094737.300000"]},
        "80": {"vr": "TM", "Value": ["095452.890000"]},
        "81": {"vr": "TM", "Value": ["094604.890000"]},
        "82": {"vr": "TM", "Value": ["095110.842500"]},
        "83": {"vr": "TM", "Value": ["095021.260000"]},
        "84": {"vr": "TM", "Value": ["094522.937500"]},
        "85": {"vr": "TM", "Value": ["095148.382500"]},
        "86": {"vr": "TM", "Value": ["095241.915000"]},
        "87": {"vr": "TM", "Value": ["095203.495000"]},
        "88": {"vr": "TM", "Value": ["094905.300000"]},
        "89": {"vr": "TM", "Value": ["095344.100000"]},
        "90": {"vr": "TM", "Value": ["094507.992500"]},
        "91": {"vr": "TM", "Value": ["094648.305000"]},
        "92": {"vr": "TM", "Value": ["095218.607500"]},
        "93": {"vr": "TM", "Value": ["094625.730000"]},
        "94": {"vr": "TM", "Value": ["095340.735000"]},
        "95": {"vr": "TM", "Value": ["094724.822500"]},
        "96": {"vr": "TM", "Value": ["094734.792500"]},
        "97": {"vr": "TM", "Value": ["095443.505000"]},
        "98": {"vr": "TM", "Value": ["094518.402500"]},
        "99": {"vr": "TM", "Value": ["094519.132500"]},
        "100": {"vr": "TM", "Value": ["094615.445000"]},
        "101": {"vr": "TM", "Value": ["094851.650000"]},
        "102": {"vr": "TM", "Value": ["094617.515000"]},
        "103": {"vr": "TM", "Value": ["095014.237500"]},
        "104": {"vr": "TM", "Value": ["095254.977500"]},
        "105": {"vr": "TM", "Value": ["095337.807500"]},
        "106": {"vr": "TM", "Value": ["095210.247500"]},
        "107": {"vr": "TM", "Value": ["095330.032500"]},
        "108": {"vr": "TM", "Value": ["094713.095000"]},
        "109": {"vr": "TM", "Value": ["094714.557500"]},
        "110": {"vr": "TM", "Value": ["095436.167500"]},
        "111": {"vr": "TM", "Value": ["095258.345000"]},
        "112": {"vr": "TM", "Value": ["094820.275000"]},
        "113": {"vr": "TM", "Value": ["095431.632500"]},
        "114": {"vr": "TM", "Value": ["095002.342500"]},
        "115": {"vr": "TM", "Value": ["095219.340000"]},
        "116": {"vr": "TM", "Value": ["095307.875000"]},
        "117": {"vr": "TM", "Value": ["094704.587500"]},
        "118": {"vr": "TM", "Value": ["095128.002500"]},
        "119": {"vr": "TM", "Value": ["095446.140000"]},
        "120": {"vr": "TM", "Value": ["094549.485000"]},
        "121": {"vr": "TM", "Value": ["094531.300000"]},
        "122": {"vr": "TM", "Value": ["095242.352500"]},
        "123": {"vr": "TM", "Value": ["094516.937500"]},
        "124": {"vr": "TM", "Value": ["095214.637500"]},
        "125": {"vr": "TM", "Value": ["095006.167500"]},
        "126": {"vr": "TM", "Value": ["095428.245000"]},
        "127": {"vr": "TM", "Value": ["094918.050000"]},
        "128": {"vr": "TM", "Value": ["095133.875000"]},
        "129": {"vr": "TM", "Value": ["094808.235000"]},
        "130": {"vr": "TM", "Value": ["094611.787500"]},
        "131": {"vr": "TM", "Value": ["095143.847500"]},
        "132": {"vr": "TM", "Value": ["095337.367500"]},
        "133": {"vr": "TM", "Value": ["095423.417500"]},
        "134": {"vr": "TM", "Value": ["095338.832500"]},
        "135": {"vr": "TM", "Value": ["094742.567500"]},
        "136": {"vr": "TM", "Value": ["094941.377500"]},
        "137": {"vr": "TM", "Value": ["095041.807500"]},
        "138": {"vr": "TM", "Value": ["094614.567500"]},
        "139": {"vr": "TM", "Value": ["094800.022500"]},
        "140": {"vr": "TM", "Value": ["094837.145000"]},
        "141": {"vr": "TM", "Value": ["094539.220000"]},
        "142": {"vr": "TM", "Value": ["095017.747500"]},
        "143": {"vr": "TM", "Value": ["095243.085000"]},
        "144": {"vr": "TM", "Value": ["095024.060000"]},
        "145": {"vr": "TM", "Value": ["095249.545000"]},
        "146": {"vr": "TM", "Value": ["094601.377500"]},
        "147": {"vr": "TM", "Value": ["094722.627500"]},
        "148": {"vr": "TM", "Value": ["095301.730000"]},
        "149": {"vr": "TM", "Value": ["095241.182500"]},
        "150": {"vr": "TM", "Value": ["094954.860000"]},
        "151": {"vr": "TM", "Value": ["094716.900000"]},
        "152": {"vr": "TM", "Value": ["095437.340000"]},
        "153": {"vr": "TM", "Value": ["094731.865000"]},
        "154": {"vr": "TM", "Value": ["094515.767500"]},
        "155": {"vr": "TM", "Value": ["095156.597500"]},
        "156": {"vr": "TM", "Value": ["094746.832500"]},
        "157": {"vr": "TM", "Value": ["094859.572500"]},
        "158": {"vr": "TM", "Value": ["095026.547500"]},
        "159": {"vr": "TM", "Value": ["094556.527500"]},
        "160": {"vr": "TM", "Value": ["095453.767500"]},
        "161": {"vr": "TM", "Value": ["095256.150000"]},
        "162": {"vr": "TM", "Value": ["094735.377500"]},
        "163": {"vr": "TM", "Value": ["095239.865000"]},
        "164": {"vr": "TM", "Value": ["094659.300000"]},
        "165": {"vr": "TM", "Value": ["095226.675000"]},
        "166": {"vr": "TM", "Value": ["095048.392500"]},
        "167": {"vr": "TM", "Value": ["094906.762500"]},
        "168": {"vr": "TM", "Value": ["094632.022500"]},
        "169": {"vr": "TM", "Value": ["094805.747500"]},
        "170": {"vr": "TM", "Value": ["094552.870000"]},
        "171": {"vr": "TM", "Value": ["094757.535000"]},
        "172": {"vr": "TM", "Value": ["094542.022500"]},
        "173": {"vr": "TM", "Value": ["095426.197500"]},
        "174": {"vr": "TM", "Value": ["094712.070000"]},
        "175": {"vr": "TM", "Value": ["094817.330000"]},
        "176": {"vr": "TM", "Value": ["094525.885000"]},
        "177": {"vr": "TM", "Value": ["095252.345000"]},
        "178": {"vr": "TM", "Value": ["095408.012500"]},
        "179": {"vr": "TM", "Value": ["095246.177500"]},
        "180": {"vr": "TM", "Value": ["094702.832500"]},
        "181": {"vr": "TM", "Value": ["094819.377500"]},
        "182": {"vr": "TM", "Value": ["095228.725000"]},
        "183": {"vr": "TM", "Value": ["095114.352500"]},
        "184": {"vr": "TM", "Value": ["094533.075000"]},
        "185": {"vr": "TM", "Value": ["094749.172500"]},
        "186": {"vr": "TM", "Value": ["095218.315000"]},
        "187": {"vr": "TM", "Value": ["095219.777500"]},
        "188": {"vr": "TM", "Value": ["095424.002500"]},
        "189": {"vr": "TM", "Value": ["094858.987500"]},
        "190": {"vr": "TM", "Value": ["095020.235000"]},
        "191": {"vr": "TM", "Value": ["094514.430000"]},
        "192": {"vr": "TM", "Value": ["095203.935000"]},
        "193": {"vr": "TM", "Value": ["094611.202500"]},
        "194": {"vr": "TM", "Value": ["095412.567500"]},
        "195": {"vr": "TM", "Value": ["095028.012500"]},
        "196": {"vr": "TM", "Value": ["095106.745000"]},
        "197": {"vr": "TM", "Value": ["094901.330000"]},
        "198": {"vr": "TM", "Value": ["094508.432500"]},
        "199": {"vr": "TM", "Value": ["095112.012500"]},
        "200": {"vr": "TM", "Value": ["094530.860000"]},
        "201": {"vr": "TM", "Value": ["095143.115000"]},
        "202": {"vr": "TM", "Value": ["095211.562500"]},
        "203": {"vr": "TM", "Value": ["094748.880000"]},
        "204": {"vr": "TM", "Value": ["094913.660000"]},
        "205": {"vr": "TM", "Value": ["095223.730000"]},
        "206": {"vr": "TM", "Value": ["095235.915000"]},
        "207": {"vr": "TM", "Value": ["095040.782500"]},
        "208": {"vr": "TM", "Value": ["094540.685000"]},
        "209": {"vr": "TM", "Value": ["094618.832500"]},
        "210": {"vr": "TM", "Value": ["095002.490000"]},
        "211": {"vr": "TM", "Value": ["095033.447500"]},
        "212": {"vr": "TM", "Value": ["095344.245000"]},
        "213": {"vr": "TM", "Value": ["095345.437500"]},
        "214": {"vr": "TM", "Value": ["095206.567500"]},
        "215": {"vr": "TM", "Value": ["095053.535000"]},
        "216": {"vr": "TM", "Value": ["094710.460000"]},
        "217": {"vr": "TM", "Value": ["094700.177500"]},
        "218": {"vr": "TM", "Value": ["095413.592500"]},
        "219": {"vr": "TM", "Value": ["094929.630000"]},
        "220": {"vr": "TM", "Value": ["094830.832500"]},
        "221": {"vr": "TM", "Value": ["095010.997500"]},
        "222": {"vr": "TM", "Value": ["095021.700000"]},
        "223": {"vr": "TM", "Value": ["094540.830000"]},
        "224": {"vr": "TM", "Value": ["094548.460000"]},
        "225": {"vr": "TM", "Value": ["094552.577500"]},
        "226": {"vr": "TM", "Value": ["095107.915000"]},
        "227": {"vr": "TM", "Value": ["094647.572500"]},
        "228": {"vr": "TM", "Value": ["095038.567500"]},
        "229": {"vr": "TM", "Value": ["094808.090000"]},
        "230": {"vr": "TM", "Value": ["094708.977500"]},
        "231": {"vr": "TM", "Value": ["094658.715000"]},
        "232": {"vr": "TM", "Value": ["095226.382500"]},
        "233": {"vr": "TM", "Value": ["095236.792500"]},
        "234": {"vr": "TM", "Value": ["094806.187500"]},
        "235": {"vr": "TM", "Value": ["095235.622500"]},
        "236": {"vr": "TM", "Value": ["095350.705000"]},
        "237": {"vr": "TM", "Value": ["094540.537500"]},
        "238": {"vr": "TM", "Value": ["095009.827500"]},
        "239": {"vr": "TM", "Value": ["095246.325000"]},
        "240": {"vr": "TM", "Value": ["094857.962500"]},
        "241": {"vr": "TM", "Value": ["095009.680000"]},
        "242": {"vr": "TM", "Value": ["095122.275000"]},
        "243": {"vr": "TM", "Value": ["094822.762500"]},
        "244": {"vr": "TM", "Value": ["095419.300000"]},
        "245": {"vr": "TM", "Value": ["095323.280000"]},
        "246": {"vr": "TM", "Value": ["094509.310000"]},
        "247": {"vr": "TM", "Value": ["094617.367500"]},
        "248": {"vr": "TM", "Value": ["095036.080000"]},
        "249": {"vr": "TM", "Value": ["095045.905000"]},
        "250": {"vr": "TM", "Value": ["095132.537500"]},
        "251": {"vr": "TM", "Value": ["094755.632500"]},
        "252": {"vr": "TM", "Value": ["095017.017500"]},
        "253": {"vr": "TM", "Value": ["095022.890000"]},
        "254": {"vr": "TM", "Value": ["095057.045000"]},
        "255": {"vr": "TM", "Value": ["094845.630000"]},
        "256": {"vr": "TM", "Value": ["095316.530000"]},
        "257": {"vr": "TM", "Value": ["095402.890000"]},
        "258": {"vr": "TM", "Value": ["094856.060000"]},
        "259": {"vr": "TM", "Value": ["094852.382500"]},
        "260": {"vr": "TM", "Value": ["094639.505000"]},
        "261": {"vr": "TM", "Value": ["095307.290000"]},
        "262": {"vr": "TM", "Value": ["094754.607500"]},
        "263": {"vr": "TM", "Value": ["094613.835000"]},
        "264": {"vr": "TM", "Value": ["095328.715000"]},
        "265": {"vr": "TM", "Value": ["095422.100000"]},
        "266": {"vr": "TM", "Value": ["095433.535000"]},
        "267": {"vr": "TM", "Value": ["094832.735000"]},
        "268": {"vr": "TM", "Value": ["094624.830000"]},
        "269": {"vr": "TM", "Value": ["095157.475000"]},
        "270": {"vr": "TM", "Value": ["095455.085000"]},
        "271": {"vr": "TM", "Value": ["095221.680000"]},
        "272": {"vr": "TM", "Value": ["095411.085000"]},
        "273": {"vr": "TM", "Value": ["094943.427500"]},
        "274": {"vr": "TM", "Value": ["094626.460000"]},
        "275": {"vr": "TM", "Value": ["094648.450000"]},
        "276": {"vr": "TM", "Value": ["095225.045000"]},
        "277": {"vr": "TM", "Value": ["095355.992500"]},
        "278": {"vr": "TM", "Value": ["094829.952500"]},
        "279": {"vr": "TM", "Value": ["094759.435000"]},
        "280": {"vr": "TM", "Value": ["095103.797500"]},
        "281": {"vr": "TM", "Value": ["094854.890000"]},
        "282": {"vr": "TM", "Value": ["094538.197500"]},
        "283": {"vr": "TM", "Value": ["094947.085000"]},
        "284": {"vr": "TM", "Value": ["095411.837500"]},
        "285": {"vr": "TM", "Value": ["095223.142500"]},
        "286": {"vr": "TM", "Value": ["095022.137500"]},
        "287": {"vr": "TM", "Value": ["094612.665000"]},
        "288": {"vr": "TM", "Value": ["094714.705000"]},
        "289": {"vr": "TM", "Value": ["095437.485000"]},
        "290": {"vr": "TM", "Value": ["095447.037500"]},
        "291": {"vr": "TM", "Value": ["094900.890000"]},
        "292": {"vr": "TM", "Value": ["094945.182500"]},
        "293": {"vr": "TM", "Value": ["094721.162500"]},
        "294": {"vr": "TM", "Value": ["095420.177500"]},
        "295": {"vr": "TM", "Value": ["095129.027500"]},
        "296": {"vr": "TM", "Value": ["094735.545000"]},
        "297": {"vr": "TM", "Value": ["094524.130000"]},
        "298": {"vr": "TM", "Value": ["094528.227500"]},
        "299": {"vr": "TM", "Value": ["094521.327500"]},
        "300": {"vr": "TM", "Value": ["095422.540000"]},
        "301": {"vr": "TM", "Value": ["095450.402500"]},
        "302": {"vr": "TM", "Value": ["095108.060000"]},
        "303": {"vr": "TM", "Value": ["094925.535000"]},
        "304": {"vr": "TM", "Value": ["094933.310000"]},
        "305": {"vr": "TM", "Value": ["094702.685000"]},
        "306": {"vr": "TM", "Value": ["095401.845000"]},
        "307": {"vr": "TM", "Value": ["094926.705000"]},
        "308": {"vr": "TM", "Value": ["095347.340000"]},
        "309": {"vr": "TM", "Value": ["095046.342500"]},
        "310": {"vr": "TM", "Value": ["095026.255000"]},
        "311": {"vr": "TM", "Value": ["094643.330000"]},
        "312": {"vr": "TM", "Value": ["095130.342500"]},
        "313": {"vr": "TM", "Value": ["095451.427500"]},
        "314": {"vr": "TM", "Value": ["095430.022500"]},
        "315": {"vr": "TM", "Value": ["094716.607500"]},
        "316": {"vr": "TM", "Value": ["094643.915000"]},
        "317": {"vr": "TM", "Value": ["095353.045000"]},
        "318": {"vr": "TM", "Value": ["094832.295000"]},
        "319": {"vr": "TM", "Value": ["095026.987500"]},
        "320": {"vr": "TM", "Value": ["095116.567500"]},
        "321": {"vr": "TM", "Value": ["094713.972500"]},
        "322": {"vr": "TM", "Value": ["095405.962500"]},
        "323": {"vr": "TM", "Value": ["094937.115000"]},
        "324": {"vr": "TM", "Value": ["094924.070000"]},
        "325": {"vr": "TM", "Value": ["094709.730000"]},
        "326": {"vr": "TM", "Value": ["094554.040000"]},
        "327": {"vr": "TM", "Value": ["095112.742500"]},
        "328": {"vr": "TM", "Value": ["095308.315000"]},
        "329": {"vr": "TM", "Value": ["095113.915000"]},
        "330": {"vr": "TM", "Value": ["094538.635000"]},
        "331": {"vr": "TM", "Value": ["094944.305000"]},
        "332": {"vr": "TM", "Value": ["094707.515000"]},
        "333": {"vr": "TM", "Value": ["095232.382500"]},
        "334": {"vr": "TM", "Value": ["094910.130000"]},
        "335": {"vr": "TM", "Value": ["094804.577500"]},
        "336": {"vr": "TM", "Value": ["094721.455000"]},
        "337": {"vr": "TM", "Value": ["094902.352500"]},
        "338": {"vr": "TM", "Value": ["094537.757500"]},
        "339": {"vr": "TM", "Value": ["094835.952500"]},
        "340": {"vr": "TM", "Value": ["094626.900000"]},
        "341": {"vr": "TM", "Value": ["095430.462500"]},
        "342": {"vr": "TM", "Value": ["094801.337500"]},
        "343": {"vr": "TM", "Value": ["095334.422500"]},
        "344": {"vr": "TM", "Value": ["094838.167500"]},
        "345": {"vr": "TM", "Value": ["095201.007500"]},
        "346": {"vr": "TM", "Value": ["094618.537500"]},
        "347": {"vr": "TM", "Value": ["094657.982500"]},
        "348": {"vr": "TM", "Value": ["094949.885000"]},
        "349": {"vr": "TM", "Value": ["094509.162500"]},
        "350": {"vr": "TM", "Value": ["095138.850000"]},
        "351": {"vr": "TM", "Value": ["095400.237500"]},
        "352": {"vr": "TM", "Value": ["094951.495000"]},
        "353": {"vr": "TM", "Value": ["094948.715000"]},
        "354": {"vr": "TM", "Value": ["094922.752500"]},
        "355": {"vr": "TM", "Value": ["095319.767500"]},
        "356": {"vr": "TM", "Value": ["094742.275000"]},
        "357": {"vr": "TM", "Value": ["094530.567500"]},
        "358": {"vr": "TM", "Value": ["095225.192500"]},
        "359": {"vr": "TM", "Value": ["094705.905000"]},
        "360": {"vr": "TM", "Value": ["094532.930000"]},
        "361": {"vr": "TM", "Value": ["095000.295000"]},
        "362": {"vr": "TM", "Value": ["095211.855000"]},
        "363": {"vr": "TM", "Value": ["095004.830000"]},
        "364": {"vr": "TM", "Value": ["095319.622500"]},
        "365": {"vr": "TM", "Value": ["095005.730000"]},
        "366": {"vr": "TM", "Value": ["095422.977500"]},
        "367": {"vr": "TM", "Value": ["094657.835000"]},
        "368": {"vr": "TM", "Value": ["094644.792500"]},
        "369": {"vr": "TM", "Value": ["095303.485000"]},
        "370": {"vr": "TM", "Value": ["095220.950000"]},
        "371": {"vr": "TM", "Value": ["095211.417500"]},
        "372": {"vr": "TM", "Value": ["095158.500000"]},
        "373": {"vr": "TM", "Value": ["095105.260000"]},
        "374": {"vr": "TM", "Value": ["094924.217500"]},
        "375": {"vr": "TM", "Value": ["095058.675000"]},
        "376": {"vr": "TM", "Value": ["094943.280000"]},
        "377": {"vr": "TM", "Value": ["095308.752500"]},
        "378": {"vr": "TM", "Value": ["094915.417500"]},
        "379": {"vr": "TM", "Value": ["094734.207500"]},
        "380": {"vr": "TM", "Value": ["094903.230000"]},
        "381": {"vr": "TM", "Value": ["094722.040000"]},
        "382": {"vr": "TM", "Value": ["094843.730000"]},
        "383": {"vr": "TM", "Value": ["094511.942500"]},
        "384": {"vr": "TM", "Value": ["094958.977500"]},
        "385": {"vr": "TM", "Value": ["095340.150000"]},
        "386": {"vr": "TM", "Value": ["095341.172500"]},
        "387": {"vr": "TM", "Value": ["095100.285000"]},
        "388": {"vr": "TM", "Value": ["095359.212500"]},
        "389": {"vr": "TM", "Value": ["094904.715000"]},
        "390": {"vr": "TM", "Value": ["094655.347500"]},
        "391": {"vr": "TM", "Value": ["095345.290000"]},
        "392": {"vr": "TM", "Value": ["094802.675000"]},
        "393": {"vr": "TM", "Value": ["095110.547500"]},
        "394": {"vr": "TM", "Value": ["095049.875000"]},
        "395": {"vr": "TM", "Value": ["094954.715000"]},
        "396": {"vr": "TM", "Value": ["094823.935000"]},
        "397": {"vr": "TM", "Value": ["094947.837500"]},
        "398": {"vr": "TM", "Value": ["094554.480000"]},
        "399": {"vr": "TM", "Value": ["094649.475000"]},
        "400": {"vr": "TM", "Value": ["094904.130000"]},
        "401": {"vr": "TM", "Value": ["094641.115000"]},
        "402": {"vr": "TM", "Value": ["094751.075000"]},
        "403": {"vr": "TM", "Value": ["095037.397500"]},
        "404": {"vr": "TM", "Value": ["094551.115000"]},
        "405": {"vr": "TM", "Value": ["095214.342500"]},
        "406": {"vr": "TM", "Value": ["094716.315000"]},
        "407": {"vr": "TM", "Value": ["094755.485000"]},
        "408": {"vr": "TM", "Value": ["095011.582500"]},
        "409": {"vr": "TM", "Value": ["095049.145000"]},
        "410": {"vr": "TM", "Value": ["094732.157500"]},
        "411": {"vr": "TM", "Value": ["095330.910000"]},
        "412": {"vr": "TM", "Value": ["094528.520000"]},
        "413": {"vr": "TM", "Value": ["094657.250000"]},
        "414": {"vr": "TM", "Value": ["094555.797500"]},
        "415": {"vr": "TM", "Value": ["095257.172500"]},
        "416": {"vr": "TM", "Value": ["094938.745000"]},
        "417": {"vr": "TM", "Value": ["094603.280000"]},
        "418": {"vr": "TM", "Value": ["094512.820000"]},
        "419": {"vr": "TM", "Value": ["094556.235000"]},
        "420": {"vr": "TM", "Value": ["095435.582500"]},
        "421": {"vr": "TM", "Value": ["094617.807500"]},
        "422": {"vr": "TM", "Value": ["094739.202500"]},
        "423": {"vr": "TM", "Value": ["095323.572500"]},
        "424": {"vr": "TM", "Value": ["095136.070000"]},
        "425": {"vr": "TM", "Value": ["095414.910000"]},
        "426": {"vr": "TM", "Value": ["095152.647500"]},
        "427": {"vr": "TM", "Value": ["095125.515000"]},
        "428": {"vr": "TM", "Value": ["095359.505000"]},
        "429": {"vr": "TM", "Value": ["095155.720000"]},
        "430": {"vr": "TM", "Value": ["095030.645000"]},
        "431": {"vr": "TM", "Value": ["094640.967500"]},
        "432": {"vr": "TM", "Value": ["095415.350000"]},
        "433": {"vr": "TM", "Value": ["095123.152500"]},
        "434": {"vr": "TM", "Value": ["094701.222500"]},
        "435": {"vr": "TM", "Value": ["095433.972500"]},
        "436": {"vr": "TM", "Value": ["094515.475000"]},
        "437": {"vr": "TM", "Value": ["094815.427500"]},
        "438": {"vr": "TM", "Value": ["095053.095000"]},
        "439": {"vr": "TM", "Value": ["095257.320000"]},
        "440": {"vr": "TM", "Value": ["095355.115000"]},
        "441": {"vr": "TM", "Value": ["094618.245000"]},
        "442": {"vr": "TM", "Value": ["094636.285000"]},
        "443": {"vr": "TM", "Value": ["095331.787500"]},
        "444": {"vr": "TM", "Value": ["095129.757500"]},
        "445": {"vr": "TM", "Value": ["095135.777500"]},
        "446": {"vr": "TM", "Value": ["095244.130000"]},
        "447": {"vr": "TM", "Value": ["094520.157500"]},
        "448": {"vr": "TM", "Value": ["095318.285000"]},
        "449": {"vr": "TM", "Value": ["095033.152500"]},
        "450": {"vr": "TM", "Value": ["095351.437500"]},
        "451": {"vr": "TM", "Value": ["094706.050000"]},
        "452": {"vr": "TM", "Value": ["095227.700000"]},
        "453": {"vr": "TM", "Value": ["094539.367500"]},
        "454": {"vr": "TM", "Value": ["094805.602500"]},
        "455": {"vr": "TM", "Value": ["095051.340000"]},
        "456": {"vr": "TM", "Value": ["094759.582500"]},
        "457": {"vr": "TM", "Value": ["094813.232500"]},
        "458": {"vr": "TM", "Value": ["094908.520000"]},
        "459": {"vr": "TM", "Value": ["094758.120000"]},
        "460": {"vr": "TM", "Value": ["094832.147500"]},
        "461": {"vr": "TM", "Value": ["095051.192500"]},
        "462": {"vr": "TM", "Value": ["094923.485000"]},
        "463": {"vr": "TM", "Value": ["095103.212500"]},
        "464": {"vr": "TM", "Value": ["095302.022500"]},
        "465": {"vr": "TM", "Value": ["094744.930000"]},
        "466": {"vr": "TM", "Value": ["094655.640000"]},
        "467": {"vr": "TM", "Value": ["095013.337500"]},
        "468": {"vr": "TM", "Value": ["094538.782500"]},
        "469": {"vr": "TM", "Value": ["095447.767500"]},
        "470": {"vr": "TM", "Value": ["095039.445000"]},
        "471": {"vr": "TM", "Value": ["095030.792500"]},
        "472": {"vr": "TM", "Value": ["094700.637500"]},
        "473": {"vr": "TM", "Value": ["095346.167500"]},
        "474": {"vr": "TM", "Value": ["095332.080000"]},
        "475": {"vr": "TM", "Value": ["094511.065000"]},
        "476": {"vr": "TM", "Value": ["095341.027500"]},
        "477": {"vr": "TM", "Value": ["094725.552500"]},
        "478": {"vr": "TM", "Value": ["095410.500000"]},
        "479": {"vr": "TM", "Value": ["095253.807500"]},
        "480": {"vr": "TM", "Value": ["094939.915000"]},
        "481": {"vr": "TM", "Value": ["094520.450000"]},
        "482": {"vr": "TM", "Value": ["094705.172500"]},
        "483": {"vr": "TM", "Value": ["095314.335000"]},
        "484": {"vr": "TM", "Value": ["095107.330000"]},
        "485": {"vr": "TM", "Value": ["095213.172500"]},
        "486": {"vr": "TM", "Value": ["094813.525000"]},
        "487": {"vr": "TM", "Value": ["094839.925000"]},
        "488": {"vr": "TM", "Value": ["094848.140000"]},
        "489": {"vr": "TM", "Value": ["095247.202500"]},
        "490": {"vr": "TM", "Value": ["095028.305000"]},
        "491": {"vr": "TM", "Value": ["094945.915000"]},
        "492": {"vr": "TM", "Value": ["094724.527500"]},
        "493": {"vr": "TM", "Value": ["095256.735000"]},
        "494": {"vr": "TM", "Value": ["095325.622500"]},
        "495": {"vr": "TM", "Value": ["094815.720000"]},
        "496": {"vr": "TM", "Value": ["094953.105000"]},
        "497": {"vr": "TM", "Value": ["094514.285000"]},
        "498": {"vr": "TM", "Value": ["095418.275000"]},
        "499": {"vr": "TM", "Value": ["094552.432500"]},
        "500": {"vr": "TM", "Value": ["094611.495000"]},
        "501": {"vr": "TM", "Value": ["095454.500000"]},
        "502": {"vr": "TM", "Value": ["095019.650000"]},
        "503": {"vr": "TM", "Value": ["094855.037500"]},
        "504": {"vr": "TM", "Value": ["094831.417500"]},
        "505": {"vr": "TM", "Value": ["094555.650000"]},
        "506": {"vr": "TM", "Value": ["094713.387500"]},
        "507": {"vr": "TM", "Value": ["094648.012500"]},
        "508": {"vr": "TM", "Value": ["094739.055000"]},
        "509": {"vr": "TM", "Value": ["094930.382500"]},
        "510": {"vr": "TM", "Value": ["095345.730000"]},
        "511": {"vr": "TM", "Value": ["094926.120000"]},
        "512": {"vr": "TM", "Value": ["094752.537500"]},
        "513": {"vr": "TM", "Value": ["095214.050000"]},
        "514": {"vr": "TM", "Value": ["094646.547500"]},
        "515": {"vr": "TM", "Value": ["094822.325000"]},
        "516": {"vr": "TM", "Value": ["094515.915000"]},
        "517": {"vr": "TM", "Value": ["095338.392500"]},
        "518": {"vr": "TM", "Value": ["094849.310000"]},
        "519": {"vr": "TM", "Value": ["094705.320000"]},
        "520": {"vr": "TM", "Value": ["095140.900000"]},
        "521": {"vr": "TM", "Value": ["094528.665000"]},
        "522": {"vr": "TM", "Value": ["094936.090000"]},
        "523": {"vr": "TM", "Value": ["095440.432500"]},
        "524": {"vr": "TM", "Value": ["094700.930000"]},
        "525": {"vr": "TM", "Value": ["094938.890000"]},
        "526": {"vr": "TM", "Value": ["095419.740000"]},
        "527": {"vr": "TM", "Value": ["095356.285000"]},
        "528": {"vr": "TM", "Value": ["095352.752500"]},
        "529": {"vr": "TM", "Value": ["094527.787500"]},
        "530": {"vr": "TM", "Value": ["094722.480000"]},
        "531": {"vr": "TM", "Value": ["094827.445000"]},
        "532": {"vr": "TM", "Value": ["094526.325000"]},
        "533": {"vr": "TM", "Value": ["094728.645000"]},
        "534": {"vr": "TM", "Value": ["095016.432500"]},
        "535": {"vr": "TM", "Value": ["095216.100000"]},
        "536": {"vr": "TM", "Value": ["095149.845000"]},
        "537": {"vr": "TM", "Value": ["095009.242500"]},
        "538": {"vr": "TM", "Value": ["095053.242500"]},
        "539": {"vr": "TM", "Value": ["094506.822500"]},
        "540": {"vr": "TM", "Value": ["094806.772500"]},
        "541": {"vr": "TM", "Value": ["095406.110000"]},
        "542": {"vr": "TM", "Value": ["095003.952500"]},
        "543": {"vr": "TM", "Value": ["095446.285000"]},
        "544": {"vr": "TM", "Value": ["094644.352500"]},
        "545": {"vr": "TM", "Value": ["094926.850000"]},
        "546": {"vr": "TM", "Value": ["095358.187500"]},
        "547": {"vr": "TM", "Value": ["095355.700000"]},
        "548": {"vr": "TM", "Value": ["094827.152500"]},
        "549": {"vr": "TM", "Value": ["095117.447500"]},
        "550": {"vr": "TM", "Value": ["095045.757500"]},
        "551": {"vr": "TM", "Value": ["095258.050000"]},
        "552": {"vr": "TM", "Value": ["095053.827500"]},
        "553": {"vr": "TM", "Value": ["094645.817500"]},
        "554": {"vr": "TM", "Value": ["095004.245000"]},
        "555": {"vr": "TM", "Value": ["094508.137500"]},
        "556": {"vr": "TM", "Value": ["094727.915000"]},
        "557": {"vr": "TM", "Value": ["095425.320000"]},
        "558": {"vr": "TM", "Value": ["095059.115000"]},
        "559": {"vr": "TM", "Value": ["095244.422500"]},
        "560": {"vr": "TM", "Value": ["095056.460000"]},
        "561": {"vr": "TM", "Value": ["095343.222500"]},
        "562": {"vr": "TM", "Value": ["095159.085000"]},
        "563": {"vr": "TM", "Value": ["094754.460000"]},
        "564": {"vr": "TM", "Value": ["095056.900000"]},
        "565": {"vr": "TM", "Value": ["094901.622500"]},
        "566": {"vr": "TM", "Value": ["095119.347500"]},
        "567": {"vr": "TM", "Value": ["094827.007500"]},
        "568": {"vr": "TM", "Value": ["095149.407500"]},
        "569": {"vr": "TM", "Value": ["094914.392500"]},
        "570": {"vr": "TM", "Value": ["094810.745000"]},
        "571": {"vr": "TM", "Value": ["095307.730000"]},
        "572": {"vr": "TM", "Value": ["095344.540000"]},
        "573": {"vr": "TM", "Value": ["095409.330000"]},
        "574": {"vr": "TM", "Value": ["095350.850000"]},
        "575": {"vr": "TM", "Value": ["095108.207500"]},
        "576": {"vr": "TM", "Value": ["095119.787500"]},
        "577": {"vr": "TM", "Value": ["095331.935000"]},
        "578": {"vr": "TM", "Value": ["095011.435000"]},
        "579": {"vr": "TM", "Value": ["095252.782500"]},
        "580": {"vr": "TM", "Value": ["095256.587500"]},
        "581": {"vr": "TM", "Value": ["095145.017500"]},
        "582": {"vr": "TM", "Value": ["095007.340000"]},
        "583": {"vr": "TM", "Value": ["095118.910000"]},
        "584": {"vr": "TM", "Value": ["095216.245000"]},
        "585": {"vr": "TM", "Value": ["094510.920000"]},
        "586": {"vr": "TM", "Value": ["095333.690000"]},
        "587": {"vr": "TM", "Value": ["094643.037500"]},
        "588": {"vr": "TM", "Value": ["094721.747500"]},
        "589": {"vr": "TM", "Value": ["095320.355000"]},
        "590": {"vr": "TM", "Value": ["094852.675000"]},
        "591": {"vr": "TM", "Value": ["095035.055000"]},
        "592": {"vr": "TM", "Value": ["095337.222500"]},
        "593": {"vr": "TM", "Value": ["095229.602500"]},
        "594": {"vr": "TM", "Value": ["094517.232500"]},
        "595": {"vr": "TM", "Value": ["094524.567500"]},
        "596": {"vr": "TM", "Value": ["094945.767500"]},
        "597": {"vr": "TM", "Value": ["094857.085000"]},
        "598": {"vr": "TM", "Value": ["095326.645000"]},
        "599": {"vr": "TM", "Value": ["094737.152500"]},
        "600": {"vr": "TM", "Value": ["094826.860000"]},
        "601": {"vr": "TM", "Value": ["095142.382500"]},
        "602": {"vr": "TM", "Value": ["094952.957500"]},
        "603": {"vr": "TM", "Value": ["095403.622500"]},
        "604": {"vr": "TM", "Value": ["094607.545000"]},
        "605": {"vr": "TM", "Value": ["095415.935000"]},
        "606": {"vr": "TM", "Value": ["095226.530000"]},
        "607": {"vr": "TM", "Value": ["095124.032500"]},
        "608": {"vr": "TM", "Value": ["095354.822500"]},
        "609": {"vr": "TM", "Value": ["095210.832500"]},
        "610": {"vr": "TM", "Value": ["095425.027500"]},
        "611": {"vr": "TM", "Value": ["095001.905000"]},
        "612": {"vr": "TM", "Value": ["094528.080000"]},
        "613": {"vr": "TM", "Value": ["095249.105000"]},
        "614": {"vr": "TM", "Value": ["094955.152500"]},
        "615": {"vr": "TM", "Value": ["095150.577500"]},
        "616": {"vr": "TM", "Value": ["095159.545000"]},
        "617": {"vr": "TM", "Value": ["094604.012500"]},
        "618": {"vr": "TM", "Value": ["094700.030000"]},
        "619": {"vr": "TM", "Value": ["095021.845000"]},
        "620": {"vr": "TM", "Value": ["095019.065000"]},
        "621": {"vr": "TM", "Value": ["094633.337500"]},
        "622": {"vr": "TM", "Value": ["094519.427500"]},
        "623": {"vr": "TM", "Value": ["095353.777500"]},
        "624": {"vr": "TM", "Value": ["095448.647500"]},
        "625": {"vr": "TM", "Value": ["095259.660000"]},
        "626": {"vr": "TM", "Value": ["094718.090000"]},
        "627": {"vr": "TM", "Value": ["094654.617500"]},
        "628": {"vr": "TM", "Value": ["094523.982500"]},
        "629": {"vr": "TM", "Value": ["094905.447500"]},
        "630": {"vr": "TM", "Value": ["095220.362500"]},
        "631": {"vr": "TM", "Value": ["094757.680000"]},
        "632": {"vr": "TM", "Value": ["094603.132500"]},
        "633": {"vr": "TM", "Value": ["095020.675000"]},
        "634": {"vr": "TM", "Value": ["094802.530000"]},
        "635": {"vr": "TM", "Value": ["095230.042500"]},
        "636": {"vr": "TM", "Value": ["094651.377500"]},
        "637": {"vr": "TM", "Value": ["094701.952500"]},
        "638": {"vr": "TM", "Value": ["095151.330000"]},
        "639": {"vr": "TM", "Value": ["095431.340000"]},
        "640": {"vr": "TM", "Value": ["094624.245000"]},
        "641": {"vr": "TM", "Value": ["094609.592500"]},
        "642": {"vr": "TM", "Value": ["094755.925000"]},
        "643": {"vr": "TM", "Value": ["095217.290000"]},
        "644": {"vr": "TM", "Value": ["095305.680000"]},
        "645": {"vr": "TM", "Value": ["094919.660000"]},
        "646": {"vr": "TM", "Value": ["095309.777500"]},
        "647": {"vr": "TM", "Value": ["095059.552500"]},
        "648": {"vr": "TM", "Value": ["095410.792500"]},
        "649": {"vr": "TM", "Value": ["094912.030000"]},
        "650": {"vr": "TM", "Value": ["094620.002500"]},
        "651": {"vr": "TM", "Value": ["094735.690000"]},
        "652": {"vr": "TM", "Value": ["095303.047500"]},
        "653": {"vr": "TM", "Value": ["094727.037500"]},
        "654": {"vr": "TM", "Value": ["095131.660000"]},
        "655": {"vr": "TM", "Value": ["094813.085000"]},
        "656": {"vr": "TM", "Value": ["095120.812500"]},
        "657": {"vr": "TM", "Value": ["094537.612500"]},
        "658": {"vr": "TM", "Value": ["095201.592500"]},
        "659": {"vr": "TM", "Value": ["094631.875000"]},
        "660": {"vr": "TM", "Value": ["095023.915000"]},
        "661": {"vr": "TM", "Value": ["095302.607500"]},
        "662": {"vr": "TM", "Value": ["094640.382500"]},
        "663": {"vr": "TM", "Value": ["095455.377500"]},
        "664": {"vr": "TM", "Value": ["095152.207500"]},
        "665": {"vr": "TM", "Value": ["095151.475000"]},
        "666": {"vr": "TM", "Value": ["094943.865000"]},
        "667": {"vr": "TM", "Value": ["094621.027500"]},
        "668": {"vr": "TM", "Value": ["094959.417500"]},
        "669": {"vr": "TM", "Value": ["094524.422500"]},
        "670": {"vr": "TM", "Value": ["094615.007500"]},
        "671": {"vr": "TM", "Value": ["095102.042500"]},
        "672": {"vr": "TM", "Value": ["095358.480000"]},
        "673": {"vr": "TM", "Value": ["094554.920000"]},
        "674": {"vr": "TM", "Value": ["095307.145000"]},
        "675": {"vr": "TM", "Value": ["094845.945000"]},
        "676": {"vr": "TM", "Value": ["094830.392500"]},
        "677": {"vr": "TM", "Value": ["094900.305000"]},
        "678": {"vr": "TM", "Value": ["094632.607500"]},
        "679": {"vr": "TM", "Value": ["094958.832500"]},
        "680": {"vr": "TM", "Value": ["095129.320000"]},
        "681": {"vr": "TM", "Value": ["095432.657500"]},
        "682": {"vr": "TM", "Value": ["095235.475000"]},
        "683": {"vr": "TM", "Value": ["095428.977500"]},
        "684": {"vr": "TM", "Value": ["095212.295000"]},
        "685": {"vr": "TM", "Value": ["094559.475000"]},
        "686": {"vr": "TM", "Value": ["094902.207500"]},
        "687": {"vr": "TM", "Value": ["095137.680000"]},
        "688": {"vr": "TM", "Value": ["094935.357500"]},
        "689": {"vr": "TM", "Value": ["094520.012500"]},
        "690": {"vr": "TM", "Value": ["094956.930000"]},
        "691": {"vr": "TM", "Value": ["094533.660000"]},
        "692": {"vr": "TM", "Value": ["094541.437500"]},
        "693": {"vr": "TM", "Value": ["094546.120000"]},
        "694": {"vr": "TM", "Value": ["094928.460000"]},
        "695": {"vr": "TM", "Value": ["094557.845000"]},
        "696": {"vr": "TM", "Value": ["095223.875000"]},
        "697": {"vr": "TM", "Value": ["094908.080000"]},
        "698": {"vr": "TM", "Value": ["095058.382500"]},
        "699": {"vr": "TM", "Value": ["094827.737500"]},
        "700": {"vr": "TM", "Value": ["094553.895000"]},
        "701": {"vr": "TM", "Value": ["095224.607500"]},
        "702": {"vr": "TM", "Value": ["094534.392500"]},
        "703": {"vr": "TM", "Value": ["095250.422500"]},
        "704": {"vr": "TM", "Value": ["094757.095000"]},
        "705": {"vr": "TM", "Value": ["094808.530000"]},
        "706": {"vr": "TM", "Value": ["095107.182500"]},
        "707": {"vr": "TM", "Value": ["094649.182500"]},
        "708": {"vr": "TM", "Value": ["094833.027500"]},
        "709": {"vr": "TM", "Value": ["095239.427500"]},
        "710": {"vr": "TM", "Value": ["095259.515000"]},
        "711": {"vr": "TM", "Value": ["095207.007500"]},
        "712": {"vr": "TM", "Value": ["094518.255000"]},
        "713": {"vr": "TM", "Value": ["095042.100000"]},
        "714": {"vr": "TM", "Value": ["094821.885000"]},
        "715": {"vr": "TM", "Value": ["095135.047500"]},
        "716": {"vr": "TM", "Value": ["095202.032500"]},
        "717": {"vr": "TM", "Value": ["095305.242500"]},
        "718": {"vr": "TM", "Value": ["095350.120000"]},
        "719": {"vr": "TM", "Value": ["094944.157500"]},
        "720": {"vr": "TM", "Value": ["094606.207500"]},
        "721": {"vr": "TM", "Value": ["095057.337500"]},
        "722": {"vr": "TM", "Value": ["094633.945000"]},
        "723": {"vr": "TM", "Value": ["095428.685000"]},
        "724": {"vr": "TM", "Value": ["095232.822500"]},
        "725": {"vr": "TM", "Value": ["094529.835000"]},
        "726": {"vr": "TM", "Value": ["095405.232500"]},
        "727": {"vr": "TM", "Value": ["095347.485000"]},
        "728": {"vr": "TM", "Value": ["094526.177500"]},
        "729": {"vr": "TM", "Value": ["095405.817500"]},
        "730": {"vr": "TM", "Value": ["095007.485000"]},
        "731": {"vr": "TM", "Value": ["094856.940000"]},
        "732": {"vr": "TM", "Value": ["094645.085000"]},
        "733": {"vr": "TM", "Value": ["095424.295000"]},
        "734": {"vr": "TM", "Value": ["094545.972500"]},
        "735": {"vr": "TM", "Value": ["094853.700000"]},
        "736": {"vr": "TM", "Value": ["094720.577500"]},
        "737": {"vr": "TM", "Value": ["094612.812500"]},
        "738": {"vr": "TM", "Value": ["095254.685000"]},
        "739": {"vr": "TM", "Value": ["094514.890000"]},
        "740": {"vr": "TM", "Value": ["094640.822500"]},
        "741": {"vr": "TM", "Value": ["094551.260000"]},
        "742": {"vr": "TM", "Value": ["094659.007500"]},
        "743": {"vr": "TM", "Value": ["095324.745000"]},
        "744": {"vr": "TM", "Value": ["095055.582500"]},
        "745": {"vr": "TM", "Value": ["094653.007500"]},
        "746": {"vr": "TM", "Value": ["094656.812500"]},
        "747": {"vr": "TM", "Value": ["095040.490000"]},
        "748": {"vr": "TM", "Value": ["095130.050000"]},
        "749": {"vr": "TM", "Value": ["095151.767500"]},
        "750": {"vr": "TM", "Value": ["095438.822500"]},
        "751": {"vr": "TM", "Value": ["094759.290000"]},
        "752": {"vr": "TM", "Value": ["095234.137500"]},
        "753": {"vr": "TM", "Value": ["094610.470000"]},
        "754": {"vr": "TM", "Value": ["095155.427500"]},
        "755": {"vr": "TM", "Value": ["094939.330000"]},
        "756": {"vr": "TM", "Value": ["094818.792500"]},
        "757": {"vr": "TM", "Value": ["095451.572500"]},
        "758": {"vr": "TM", "Value": ["094745.367500"]},
        "759": {"vr": "TM", "Value": ["094543.337500"]},
        "760": {"vr": "TM", "Value": ["094723.505000"]},
        "761": {"vr": "TM", "Value": ["094744.030000"]},
        "762": {"vr": "TM", "Value": ["095427.515000"]},
        "763": {"vr": "TM", "Value": ["095130.197500"]},
        "764": {"vr": "TM", "Value": ["094949.007500"]},
        "765": {"vr": "TM", "Value": ["094707.807500"]},
        "766": {"vr": "TM", "Value": ["094712.802500"]},
        "767": {"vr": "TM", "Value": ["095320.647500"]},
        "768": {"vr": "TM", "Value": ["095036.372500"]},
        "769": {"vr": "TM", "Value": ["095221.095000"]},
        "770": {"vr": "TM", "Value": ["094817.182500"]},
        "771": {"vr": "TM", "Value": ["095452.597500"]},
        "772": {"vr": "TM", "Value": ["094855.475000"]},
        "773": {"vr": "TM", "Value": ["095405.085000"]},
        "774": {"vr": "TM", "Value": ["094740.812500"]},
        "775": {"vr": "TM", "Value": ["094709.145000"]},
        "776": {"vr": "TM", "Value": ["094842.265000"]},
        "777": {"vr": "TM", "Value": ["094959.710000"]},
        "778": {"vr": "TM", "Value": ["095433.387500"]},
        "779": {"vr": "TM", "Value": ["094539.807500"]},
        "780": {"vr": "TM", "Value": ["095044.002500"]},
        "781": {"vr": "TM", "Value": ["094851.942500"]},
        "782": {"vr": "TM", "Value": ["095407.720000"]},
        "783": {"vr": "TM", "Value": ["095203.055000"]},
        "784": {"vr": "TM", "Value": ["094521.767500"]},
        "785": {"vr": "TM", "Value": ["095149.260000"]},
        "786": {"vr": "TM", "Value": ["095041.222500"]},
        "787": {"vr": "TM", "Value": ["094655.787500"]},
        "788": {"vr": "TM", "Value": ["095313.162500"]},
        "789": {"vr": "TM", "Value": ["094809.845000"]},
        "790": {"vr": "TM", "Value": ["095357.895000"]},
        "791": {"vr": "TM", "Value": ["095315.505000"]},
        "792": {"vr": "TM", "Value": ["094547.875000"]},
        "793": {"vr": "TM", "Value": ["095151.915000"]},
        "794": {"vr": "TM", "Value": ["094809.260000"]},
        "795": {"vr": "TM", "Value": ["094901.035000"]},
        "796": {"vr": "TM", "Value": ["094742.127500"]},
        "797": {"vr": "TM", "Value": ["095100.725000"]},
        "798": {"vr": "TM", "Value": ["095156.890000"]},
        "799": {"vr": "TM", "Value": ["094536.732500"]},
        "800": {"vr": "TM", "Value": ["094625.582500"]},
        "801": {"vr": "TM", "Value": ["094515.037500"]},
        "802": {"vr": "TM", "Value": ["094612.372500"]},
        "803": {"vr": "TM", "Value": ["095236.647500"]},
        "804": {"vr": "TM", "Value": ["095231.797500"]},
        "805": {"vr": "TM", "Value": ["094759.875000"]},
        "806": {"vr": "TM", "Value": ["095102.187500"]},
        "807": {"vr": "TM", "Value": ["095219.047500"]},
        "808": {"vr": "TM", "Value": ["094749.757500"]},
        "809": {"vr": "TM", "Value": ["095019.212500"]},
        "810": {"vr": "TM", "Value": ["095003.367500"]},
        "811": {"vr": "TM", "Value": ["095201.300000"]},
        "812": {"vr": "TM", "Value": ["094907.787500"]},
        "813": {"vr": "TM", "Value": ["095027.720000"]},
        "814": {"vr": "TM", "Value": ["095058.822500"]},
        "815": {"vr": "TM", "Value": ["095426.782500"]},
        "816": {"vr": "TM", "Value": ["095317.115000"]},
        "817": {"vr": "TM", "Value": ["095435.730000"]},
        "818": {"vr": "TM", "Value": ["095030.500000"]},
        "819": {"vr": "TM", "Value": ["094925.095000"]},
        "820": {"vr": "TM", "Value": ["095311.555000"]},
        "821": {"vr": "TM", "Value": ["095309.192500"]},
        "822": {"vr": "TM", "Value": ["094834.342500"]},
        "823": {"vr": "TM", "Value": ["095114.792500"]},
        "824": {"vr": "TM", "Value": ["095245.155000"]},
        "825": {"vr": "TM", "Value": ["095108.352500"]},
        "826": {"vr": "TM", "Value": ["094806.040000"]},
        "827": {"vr": "TM", "Value": ["095449.670000"]},
        "828": {"vr": "TM", "Value": ["094931.260000"]},
        "829": {"vr": "TM", "Value": ["095135.192500"]},
        "830": {"vr": "TM", "Value": ["094602.695000"]},
        "831": {"vr": "TM", "Value": ["094812.792500"]},
        "832": {"vr": "TM", "Value": ["094736.275000"]},
        "833": {"vr": "TM", "Value": ["094629.680000"]},
        "834": {"vr": "TM", "Value": ["094612.227500"]},
        "835": {"vr": "TM", "Value": ["095440.140000"]},
        "836": {"vr": "TM", "Value": ["094818.500000"]},
        "837": {"vr": "TM", "Value": ["094613.542500"]},
        "838": {"vr": "TM", "Value": ["094543.632500"]},
        "839": {"vr": "TM", "Value": ["094714.412500"]},
        "840": {"vr": "TM", "Value": ["095306.120000"]},
        "841": {"vr": "TM", "Value": ["095142.090000"]},
        "842": {"vr": "TM", "Value": ["094552.137500"]},
        "843": {"vr": "TM", "Value": ["094954.567500"]},
        "844": {"vr": "TM", "Value": ["094747.125000"]},
        "845": {"vr": "TM", "Value": ["094536.002500"]},
        "846": {"vr": "TM", "Value": ["095000.880000"]},
        "847": {"vr": "TM", "Value": ["095156.012500"]},
        "848": {"vr": "TM", "Value": ["094942.842500"]},
        "849": {"vr": "TM", "Value": ["094615.152500"]},
        "850": {"vr": "TM", "Value": ["095133.145000"]},
        "851": {"vr": "TM", "Value": ["095027.572500"]},
        "852": {"vr": "TM", "Value": ["095026.110000"]},
        "853": {"vr": "TM", "Value": ["095214.197500"]},
        "854": {"vr": "TM", "Value": ["094733.475000"]},
        "855": {"vr": "TM", "Value": ["094719.845000"]},
        "856": {"vr": "TM", "Value": ["094917.905000"]},
        "857": {"vr": "TM", "Value": ["095105.552500"]},
        "858": {"vr": "TM", "Value": ["094748.735000"]},
        "859": {"vr": "TM", "Value": ["094602.110000"]},
        "860": {"vr": "TM", "Value": ["094832.002500"]},
        "861": {"vr": "TM", "Value": ["095447.182500"]},
        "862": {"vr": "TM", "Value": ["095342.345000"]},
        "863": {"vr": "TM", "Value": ["095122.130000"]},
        "864": {"vr": "TM", "Value": ["095437.945000"]},
        "865": {"vr": "TM", "Value": ["094849.602500"]},
        "866": {"vr": "TM", "Value": ["095205.250000"]},
        "867": {"vr": "TM", "Value": ["094648.157500"]},
        "868": {"vr": "TM", "Value": ["095134.607500"]},
        "869": {"vr": "TM", "Value": ["094655.202500"]},
        "870": {"vr": "TM", "Value": ["094823.640000"]},
        "871": {"vr": "TM", "Value": ["094920.245000"]},
        "872": {"vr": "TM", "Value": ["094529.690000"]},
        "873": {"vr": "TM", "Value": ["095333.982500"]},
        "874": {"vr": "TM", "Value": ["095147.505000"]},
        "875": {"vr": "TM", "Value": ["094513.700000"]},
        "876": {"vr": "TM", "Value": ["094659.592500"]},
        "877": {"vr": "TM", "Value": ["094604.157500"]},
        "878": {"vr": "TM", "Value": ["095338.540000"]},
        "879": {"vr": "TM", "Value": ["094534.100000"]},
        "880": {"vr": "TM", "Value": ["094557.552500"]},
        "881": {"vr": "TM", "Value": ["094706.782500"]},
        "882": {"vr": "TM", "Value": ["094601.670000"]},
        "883": {"vr": "TM", "Value": ["094700.782500"]},
        "884": {"vr": "TM", "Value": ["095324.157500"]},
        "885": {"vr": "TM", "Value": ["095454.645000"]},
        "886": {"vr": "TM", "Value": ["094716.752500"]},
        "887": {"vr": "TM", "Value": ["094944.742500"]},
        "888": {"vr": "TM", "Value": ["094655.055000"]},
        "889": {"vr": "TM", "Value": ["094550.237500"]},
        "890": {"vr": "TM", "Value": ["094745.515000"]},
        "891": {"vr": "TM", "Value": ["094956.177500"]},
        "892": {"vr": "TM", "Value": ["095409.037500"]},
        "893": {"vr": "TM", "Value": ["095037.837500"]},
        "894": {"vr": "TM", "Value": ["094738.032500"]},
        "895": {"vr": "TM", "Value": ["094947.982500"]},
        "896": {"vr": "TM", "Value": ["094633.485000"]},
        "897": {"vr": "TM", "Value": ["094948.422500"]},
        "898": {"vr": "TM", "Value": ["095021.552500"]},
        "899": {"vr": "TM", "Value": ["094847.845000"]},
        "900": {"vr": "TM", "Value": ["094923.192500"]},
        "901": {"vr": "TM", "Value": ["094605.915000"]},
        "902": {"vr": "TM", "Value": ["095025.817500"]},
        "903": {"vr": "TM", "Value": ["095445.115000"]},
        "904": {"vr": "TM", "Value": ["094610.762500"]},
        "905": {"vr": "TM", "Value": ["094724.235000"]},
        "906": {"vr": "TM", "Value": ["094608.860000"]},
        "907": {"vr": "TM", "Value": ["095156.157500"]},
        "908": {"vr": "TM", "Value": ["094949.300000"]},
        "909": {"vr": "TM", "Value": ["095434.412500"]},
        "910": {"vr": "TM", "Value": ["095101.895000"]},
        "911": {"vr": "TM", "Value": ["094856.792500"]},
        "912": {"vr": "TM", "Value": ["095419.445000"]},
        "913": {"vr": "TM", "Value": ["095106.577500"]},
        "914": {"vr": "TM", "Value": ["094720.725000"]},
        "915": {"vr": "TM", "Value": ["095036.665000"]},
        "916": {"vr": "TM", "Value": ["095424.587500"]},
        "917": {"vr": "TM", "Value": ["095141.945000"]},
        "918": {"vr": "TM", "Value": ["095250.715000"]},
        "919": {"vr": "TM", "Value": ["094510.480000"]},
        "920": {"vr": "TM", "Value": ["094638.040000"]},
        "921": {"vr": "TM", "Value": ["094755.045000"]},
        "922": {"vr": "TM", "Value": ["095249.982500"]},
        "923": {"vr": "TM", "Value": ["095225.632500"]},
        "924": {"vr": "TM", "Value": ["094506.237500"]},
        "925": {"vr": "TM", "Value": ["094543.485000"]},
        "926": {"vr": "TM", "Value": ["095447.915000"]},
        "927": {"vr": "TM", "Value": ["095154.695000"]},
        "928": {"vr": "TM", "Value": ["095327.690000"]},
        "929": {"vr": "TM", "Value": ["095027.280000"]},
        "930": {"vr": "TM", "Value": ["094936.675000"]},
        "931": {"vr": "TM", "Value": ["094955.737500"]},
        "932": {"vr": "TM", "Value": ["095450.550000"]},
        "933": {"vr": "TM", "Value": ["095108.792500"]},
        "934": {"vr": "TM", "Value": ["094535.270000"]},
        "935": {"vr": "TM", "Value": ["094920.100000"]},
        "936": {"vr": "TM", "Value": ["095139.582500"]},
        "937": {"vr": "TM", "Value": ["094918.930000"]},
        "938": {"vr": "TM", "Value": ["095446.577500"]},
        "939": {"vr": "TM", "Value": ["094851.505000"]},
        "940": {"vr": "TM", "Value": ["095258.930000"]},
        "941": {"vr": "TM", "Value": ["095256.295000"]},
        "942": {"vr": "TM", "Value": ["094706.342500"]},
        "943": {"vr": "TM", "Value": ["094919.075000"]},
        "944": {"vr": "TM", "Value": ["095116.715000"]},
        "945": {"vr": "TM", "Value": ["095401.407500"]},
        "946": {"vr": "TM", "Value": ["095109.670000"]},
        "947": {"vr": "TM", "Value": ["094905.007500"]},
        "948": {"vr": "TM", "Value": ["095139.437500"]},
        "949": {"vr": "TM", "Value": ["094812.060000"]},
        "950": {"vr": "TM", "Value": ["095246.032500"]},
        "951": {"vr": "TM", "Value": ["094904.422500"]},
        "952": {"vr": "TM", "Value": ["094710.607500"]},
        "953": {"vr": "TM", "Value": ["095020.090000"]},
        "954": {"vr": "TM", "Value": ["095207.885000"]},
        "955": {"vr": "TM", "Value": ["094559.622500"]},
        "956": {"vr": "TM", "Value": ["095140.460000"]},
        "957": {"vr": "TM", "Value": ["094901.182500"]},
        "958": {"vr": "TM", "Value": ["095243.982500"]},
        "959": {"vr": "TM", "Value": ["094810.890000"]},
        "960": {"vr": "TM", "Value": ["094916.002500"]},
        "961": {"vr": "TM", "Value": ["094959.270000"]},
        "962": {"vr": "TM", "Value": ["095300.100000"]},
        "963": {"vr": "TM", "Value": ["095157.622500"]},
        "964": {"vr": "TM", "Value": ["094640.235000"]},
        "965": {"vr": "TM", "Value": ["094737.885000"]},
        "966": {"vr": "TM", "Value": ["094912.177500"]},
        "967": {"vr": "TM", "Value": ["095354.090000"]},
        "968": {"vr": "TM", "Value": ["094705.465000"]},
        "969": {"vr": "TM", "Value": ["094708.537500"]},
        "970": {"vr": "TM", "Value": ["094525.592500"]},
        "971": {"vr": "TM", "Value": ["094715.727500"]},
        "972": {"vr": "TM", "Value": ["095401.700000"]},
        "973": {"vr": "TM", "Value": ["095322.550000"]},
        "974": {"vr": "TM", "Value": ["095030.937500"]},
        "975": {"vr": "TM", "Value": ["095125.222500"]},
        "976": {"vr": "TM", "Value": ["094746.977500"]},
        "977": {"vr": "TM", "Value": ["094936.382500"]},
        "978": {"vr": "TM", "Value": ["095452.450000"]},
        "979": {"vr": "TM", "Value": ["095143.700000"]},
        "980": {"vr": "TM", "Value": ["095151.182500"]},
        "981": {"vr": "TM", "Value": ["095335.740000"]},
        "982": {"vr": "TM", "Value": ["094900.157500"]},
        "983": {"vr": "TM", "Value": ["095140.315000"]},
        "984": {"vr": "TM", "Value": ["095248.665000"]},
        "985": {"vr": "TM", "Value": ["094936.235000"]},
        "986": {"vr": "TM", "Value": ["094833.320000"]},
        "987": {"vr": "TM", "Value": ["094526.032500"]},
        "988": {"vr": "TM", "Value": ["095327.232500"]},
        "989": {"vr": "TM", "Value": ["094912.345000"]},
        "990": {"vr": "TM", "Value": ["094938.137500"]},
        "991": {"vr": "TM", "Value": ["095400.822500"]},
        "992": {"vr": "TM", "Value": ["094807.942500"]},
        "993": {"vr": "TM", "Value": ["095418.130000"]},
        "994": {"vr": "TM", "Value": ["094634.675000"]},
        "995": {"vr": "TM", "Value": ["095259.367500"]},
        "996": {"vr": "TM", "Value": ["095446.890000"]},
        "997": {"vr": "TM", "Value": ["095212.442500"]},
        "998": {"vr": "TM", "Value": ["095246.910000"]},
        "999": {"vr": "TM", "Value": ["095426.345000"]},
        "1000": {"vr": "TM", "Value": ["094948.130000"]},
        "1001": {"vr": "TM", "Value": ["095427.075000"]},
        "1002": {"vr": "TM", "Value": ["094553.162500"]},
        "1003": {"vr": "TM", "Value": ["094729.377500"]},
        "1004": {"vr": "TM", "Value": ["095335.592500"]},
        "1005": {"vr": "TM", "Value": ["095146.920000"]},
        "1006": {"vr": "TM", "Value": ["095217.730000"]},
        "1007": {"vr": "TM", "Value": ["094710.315000"]},
        "1008": {"vr": "TM", "Value": ["094610.910000"]},
        "1009": {"vr": "TM", "Value": ["094717.192500"]},
        "1010": {"vr": "TM", "Value": ["095330.617500"]},
        "1011": {"vr": "TM", "Value": ["095441.457500"]},
        "1012": {"vr": "TM", "Value": ["095209.222500"]},
        "1013": {"vr": "TM", "Value": ["095218.022500"]},
        "1014": {"vr": "TM", "Value": ["095144.432500"]},
        "1015": {"vr": "TM", "Value": ["095453.330000"]},
        "1016": {"vr": "TM", "Value": ["094825.982500"]},
        "1017": {"vr": "TM", "Value": ["095429.730000"]},
        "1018": {"vr": "TM", "Value": ["094748.295000"]},
        "1019": {"vr": "TM", "Value": ["095342.490000"]},
        "1020": {"vr": "TM", "Value": ["095202.617500"]},
        "1021": {"vr": "TM", "Value": ["095417.545000"]},
        "1022": {"vr": "TM", "Value": ["094837.730000"]},
        "1023": {"vr": "TM", "Value": ["094903.837500"]},
        "1024": {"vr": "TM", "Value": ["095211.710000"]},
        "1025": {"vr": "TM", "Value": ["094535.125000"]},
        "1026": {"vr": "TM", "Value": ["094542.607500"]},
        "1027": {"vr": "TM", "Value": ["095203.787500"]},
        "1028": {"vr": "TM", "Value": ["095332.812500"]},
        "1029": {"vr": "TM", "Value": ["095044.147500"]},
        "1030": {"vr": "TM", "Value": ["094513.407500"]},
        "1031": {"vr": "TM", "Value": ["094631.727500"]},
        "1032": {"vr": "TM", "Value": ["094821.152500"]},
        "1033": {"vr": "TM", "Value": ["094927.435000"]},
        "1034": {"vr": "TM", "Value": ["094640.675000"]},
        "1035": {"vr": "TM", "Value": ["095350.557500"]},
        "1036": {"vr": "TM", "Value": ["094841.387500"]},
        "1037": {"vr": "TM", "Value": ["095054.412500"]},
        "1038": {"vr": "TM", "Value": ["094624.685000"]},
        "1039": {"vr": "TM", "Value": ["094826.567500"]},
        "1040": {"vr": "TM", "Value": ["094812.207500"]},
        "1041": {"vr": "TM", "Value": ["095202.325000"]},
        "1042": {"vr": "TM", "Value": ["094814.255000"]},
        "1043": {"vr": "TM", "Value": ["095014.967500"]},
        "1044": {"vr": "TM", "Value": ["094757.387500"]},
        "1045": {"vr": "TM", "Value": ["094552.725000"]},
        "1046": {"vr": "TM", "Value": ["095057.630000"]},
        "1047": {"vr": "TM", "Value": ["095403.767500"]},
        "1048": {"vr": "TM", "Value": ["095415.787500"]},
        "1049": {"vr": "TM", "Value": ["094535.417500"]},
        "1050": {"vr": "TM", "Value": ["095035.787500"]},
        "1051": {"vr": "TM", "Value": ["094946.937500"]},
        "1052": {"vr": "TM", "Value": ["094631.435000"]},
        "1053": {"vr": "TM", "Value": ["095057.945000"]},
        "1054": {"vr": "TM", "Value": ["094623.367500"]},
        "1055": {"vr": "TM", "Value": ["094829.807500"]},
        "1056": {"vr": "TM", "Value": ["095258.490000"]},
        "1057": {"vr": "TM", "Value": ["095411.545000"]},
        "1058": {"vr": "TM", "Value": ["095212.587500"]},
        "1059": {"vr": "TM", "Value": ["094855.767500"]},
        "1060": {"vr": "TM", "Value": ["094512.382500"]},
        "1061": {"vr": "TM", "Value": ["094541.582500"]},
        "1062": {"vr": "TM", "Value": ["094719.407500"]},
        "1063": {"vr": "TM", "Value": ["094832.880000"]},
        "1064": {"vr": "TM", "Value": ["094724.382500"]},
        "1065": {"vr": "TM", "Value": ["094826.715000"]},
        "1066": {"vr": "TM", "Value": ["094847.115000"]},
        "1067": {"vr": "TM", "Value": ["095200.130000"]},
        "1068": {"vr": "TM", "Value": ["095306.412500"]},
        "1069": {"vr": "TM", "Value": ["095046.490000"]},
        "1070": {"vr": "TM", "Value": ["094709.582500"]},
        "1071": {"vr": "TM", "Value": ["095255.562500"]},
        "1072": {"vr": "TM", "Value": ["095204.665000"]},
        "1073": {"vr": "TM", "Value": ["095450.695000"]},
        "1074": {"vr": "TM", "Value": ["095445.552500"]},
        "1075": {"vr": "TM", "Value": ["094635.115000"]},
        "1076": {"vr": "TM", "Value": ["095049.437500"]},
        "1077": {"vr": "TM", "Value": ["095226.090000"]},
        "1078": {"vr": "TM", "Value": ["094708.830000"]},
        "1079": {"vr": "TM", "Value": ["095300.977500"]},
        "1080": {"vr": "TM", "Value": ["094815.280000"]},
        "1081": {"vr": "TM", "Value": ["094644.940000"]},
        "1082": {"vr": "TM", "Value": ["095203.202500"]},
        "1083": {"vr": "TM", "Value": ["095205.542500"]},
        "1084": {"vr": "TM", "Value": ["094611.932500"]},
        "1085": {"vr": "TM", "Value": ["095257.757500"]},
        "1086": {"vr": "TM", "Value": ["095159.982500"]},
        "1087": {"vr": "TM", "Value": ["095201.885000"]},
        "1088": {"vr": "TM", "Value": ["095317.700000"]},
        "1089": {"vr": "TM", "Value": ["095149.700000"]},
        "1090": {"vr": "TM", "Value": ["094957.807500"]},
        "1091": {"vr": "TM", "Value": ["094827.592500"]},
        "1092": {"vr": "TM", "Value": ["095145.310000"]},
        "1093": {"vr": "TM", "Value": ["094616.490000"]},
        "1094": {"vr": "TM", "Value": ["095427.807500"]},
        "1095": {"vr": "TM", "Value": ["095213.905000"]},
        "1096": {"vr": "TM", "Value": ["095107.475000"]},
        "1097": {"vr": "TM", "Value": ["094825.835000"]},
        "1098": {"vr": "TM", "Value": ["095327.085000"]},
        "1099": {"vr": "TM", "Value": ["095124.345000"]},
        "1100": {"vr": "TM", "Value": ["094944.450000"]},
        "1101": {"vr": "TM", "Value": ["095120.080000"]},
        "1102": {"vr": "TM", "Value": ["095111.865000"]},
        "1103": {"vr": "TM", "Value": ["095302.755000"]},
        "1104": {"vr": "TM", "Value": ["094631.290000"]},
        "1105": {"vr": "TM", "Value": ["095134.460000"]},
        "1106": {"vr": "TM", "Value": ["094632.752500"]},
        "1107": {"vr": "TM", "Value": ["094950.032500"]},
        "1108": {"vr": "TM", "Value": ["094727.330000"]},
        "1109": {"vr": "TM", "Value": ["095421.807500"]},
        "1110": {"vr": "TM", "Value": ["095309.945000"]},
        "1111": {"vr": "TM", "Value": ["094756.510000"]},
        "1112": {"vr": "TM", "Value": ["094714.120000"]},
        "1113": {"vr": "TM", "Value": ["095149.992500"]},
        "1114": {"vr": "TM", "Value": ["094946.207500"]},
        "1115": {"vr": "TM", "Value": ["095411.690000"]},
        "1116": {"vr": "TM", "Value": ["094521.620000"]},
        "1117": {"vr": "TM", "Value": ["095231.505000"]},
        "1118": {"vr": "TM", "Value": ["094711.340000"]},
        "1119": {"vr": "TM", "Value": ["095410.352500"]},
        "1120": {"vr": "TM", "Value": ["095425.172500"]},
        "1121": {"vr": "TM", "Value": ["094938.577500"]},
        "1122": {"vr": "TM", "Value": ["094708.392500"]},
        "1123": {"vr": "TM", "Value": ["094608.130000"]},
        "1124": {"vr": "TM", "Value": ["094929.337500"]},
        "1125": {"vr": "TM", "Value": ["094909.250000"]},
        "1126": {"vr": "TM", "Value": ["095444.090000"]},
        "1127": {"vr": "TM", "Value": ["094638.772500"]},
        "1128": {"vr": "TM", "Value": ["095117.155000"]},
        "1129": {"vr": "TM", "Value": ["094838.607500"]},
        "1130": {"vr": "TM", "Value": ["095421.955000"]},
        "1131": {"vr": "TM", "Value": ["094650.792500"]},
        "1132": {"vr": "TM", "Value": ["094639.942500"]},
        "1133": {"vr": "TM", "Value": ["095052.655000"]},
        "1134": {"vr": "TM", "Value": ["095208.345000"]},
        "1135": {"vr": "TM", "Value": ["094913.222500"]},
        "1136": {"vr": "TM", "Value": ["094824.812500"]},
        "1137": {"vr": "TM", "Value": ["095247.787500"]},
        "1138": {"vr": "TM", "Value": ["094630.705000"]},
        "1139": {"vr": "TM", "Value": ["095008.070000"]},
        "1140": {"vr": "TM", "Value": ["094548.752500"]},
        "1141": {"vr": "TM", "Value": ["094853.552500"]},
        "1142": {"vr": "TM", "Value": ["094606.645000"]},
        "1143": {"vr": "TM", "Value": ["094630.412500"]},
        "1144": {"vr": "TM", "Value": ["094727.182500"]},
        "1145": {"vr": "TM", "Value": ["094954.275000"]},
        "1146": {"vr": "TM", "Value": ["094807.065000"]},
        "1147": {"vr": "TM", "Value": ["095452.157500"]},
        "1148": {"vr": "TM", "Value": ["094649.327500"]},
        "1149": {"vr": "TM", "Value": ["094508.577500"]},
        "1150": {"vr": "TM", "Value": ["095433.242500"]},
        "1151": {"vr": "TM", "Value": ["094921.145000"]},
        "1152": {"vr": "TM", "Value": ["095030.352500"]},
        "1153": {"vr": "TM", "Value": ["094953.690000"]},
        "1154": {"vr": "TM", "Value": ["095046.930000"]},
        "1155": {"vr": "TM", "Value": ["095032.715000"]},
        "1156": {"vr": "TM", "Value": ["094639.357500"]},
        "1157": {"vr": "TM", "Value": ["094529.542500"]},
        "1158": {"vr": "TM", "Value": ["095244.567500"]},
        "1159": {"vr": "TM", "Value": ["094950.325000"]},
        "1160": {"vr": "TM", "Value": ["095054.705000"]},
        "1161": {"vr": "TM", "Value": ["094653.740000"]},
        "1162": {"vr": "TM", "Value": ["095119.935000"]},
        "1163": {"vr": "TM", "Value": ["095114.937500"]},
        "1164": {"vr": "TM", "Value": ["094916.147500"]},
        "1165": {"vr": "TM", "Value": ["095316.090000"]},
        "1166": {"vr": "TM", "Value": ["094512.675000"]},
        "1167": {"vr": "TM", "Value": ["095220.510000"]},
        "1168": {"vr": "TM", "Value": ["094558.137500"]},
        "1169": {"vr": "TM", "Value": ["095257.465000"]},
        "1170": {"vr": "TM", "Value": ["095322.402500"]},
        "1171": {"vr": "TM", "Value": ["094621.172500"]},
        "1172": {"vr": "TM", "Value": ["095144.725000"]},
        "1173": {"vr": "TM", "Value": ["095404.940000"]},
        "1174": {"vr": "TM", "Value": ["095147.212500"]},
        "1175": {"vr": "TM", "Value": ["095235.182500"]},
        "1176": {"vr": "TM", "Value": ["095228.285000"]},
        "1177": {"vr": "TM", "Value": ["095331.055000"]},
        "1178": {"vr": "TM", "Value": ["094514.137500"]},
        "1179": {"vr": "TM", "Value": ["094729.232500"]},
        "1180": {"vr": "TM", "Value": ["094854.285000"]},
        "1181": {"vr": "TM", "Value": ["094836.830000"]},
        "1182": {"vr": "TM", "Value": ["094544.947500"]},
        "1183": {"vr": "TM", "Value": ["095020.382500"]},
        "1184": {"vr": "TM", "Value": ["095255.417500"]},
        "1185": {"vr": "TM", "Value": ["094858.255000"]},
        "1186": {"vr": "TM", "Value": ["094532.782500"]},
        "1187": {"vr": "TM", "Value": ["094937.845000"]},
        "1188": {"vr": "TM", "Value": ["095241.037500"]},
        "1189": {"vr": "TM", "Value": ["095311.847500"]},
        "1190": {"vr": "TM", "Value": ["095358.772500"]},
        "1191": {"vr": "TM", "Value": ["094512.090000"]},
        "1192": {"vr": "TM", "Value": ["094654.762500"]},
        "1193": {"vr": "TM", "Value": ["095001.027500"]},
        "1194": {"vr": "TM", "Value": ["095443.065000"]},
        "1195": {"vr": "TM", "Value": ["094914.100000"]},
        "1196": {"vr": "TM", "Value": ["094531.592500"]},
        "1197": {"vr": "TM", "Value": ["095410.060000"]},
        "1198": {"vr": "TM", "Value": ["094828.637500"]},
        "1199": {"vr": "TM", "Value": ["095201.740000"]},
        "1200": {"vr": "TM", "Value": ["095302.900000"]},
        "1201": {"vr": "TM", "Value": ["094509.895000"]},
        "1202": {"vr": "TM", "Value": ["094646.840000"]},
        "1203": {"vr": "TM", "Value": ["095434.120000"]},
        "1204": {"vr": "TM", "Value": ["095223.582500"]},
        "1205": {"vr": "TM", "Value": ["095045.172500"]},
        "1206": {"vr": "TM", "Value": ["095325.182500"]},
        "1207": {"vr": "TM", "Value": ["095115.232500"]},
        "1208": {"vr": "TM", "Value": ["094526.762500"]},
        "1209": {"vr": "TM", "Value": ["094545.095000"]},
        "1210": {"vr": "TM", "Value": ["095028.157500"]},
        "1211": {"vr": "TM", "Value": ["095430.607500"]},
        "1212": {"vr": "TM", "Value": ["094725.407500"]},
        "1213": {"vr": "TM", "Value": ["095012.022500"]},
        "1214": {"vr": "TM", "Value": ["095353.340000"]},
        "1215": {"vr": "TM", "Value": ["095037.690000"]},
        "1216": {"vr": "TM", "Value": ["095203.642500"]},
        "1217": {"vr": "TM", "Value": ["095221.827500"]},
        "1218": {"vr": "TM", "Value": ["094523.542500"]},
        "1219": {"vr": "TM", "Value": ["095312.140000"]},
        "1220": {"vr": "TM", "Value": ["095316.822500"]},
        "1221": {"vr": "TM", "Value": ["095413.447500"]},
        "1222": {"vr": "TM", "Value": ["094705.757500"]},
        "1223": {"vr": "TM", "Value": ["095349.535000"]},
        "1224": {"vr": "TM", "Value": ["094844.900000"]},
        "1225": {"vr": "TM", "Value": ["094533.952500"]},
        "1226": {"vr": "TM", "Value": ["094524.275000"]},
        "1227": {"vr": "TM", "Value": ["095416.227500"]},
        "1228": {"vr": "TM", "Value": ["095412.130000"]},
        "1229": {"vr": "TM", "Value": ["095146.772500"]},
        "1230": {"vr": "TM", "Value": ["095121.982500"]},
        "1231": {"vr": "TM", "Value": ["095336.345000"]},
        "1232": {"vr": "TM", "Value": ["095406.402500"]},
        "1233": {"vr": "TM", "Value": ["094733.327500"]},
        "1234": {"vr": "TM", "Value": ["094627.045000"]},
        "1235": {"vr": "TM", "Value": ["094813.817500"]},
        "1236": {"vr": "TM", "Value": ["094531.445000"]},
        "1237": {"vr": "TM", "Value": ["095438.530000"]},
        "1238": {"vr": "TM", "Value": ["094813.377500"]},
        "1239": {"vr": "TM", "Value": ["094651.690000"]},
        "1240": {"vr": "TM", "Value": ["094704.002500"]},
        "1241": {"vr": "TM", "Value": ["094518.695000"]},
        "1242": {"vr": "TM", "Value": ["095147.942500"]},
        "1243": {"vr": "TM", "Value": ["095236.207500"]},
        "1244": {"vr": "TM", "Value": ["095037.105000"]},
        "1245": {"vr": "TM", "Value": ["094847.260000"]},
        "1246": {"vr": "TM", "Value": ["095235.767500"]},
        "1247": {"vr": "TM", "Value": ["094729.670000"]},
        "1248": {"vr": "TM", "Value": ["094951.055000"]},
        "1249": {"vr": "TM", "Value": ["095336.490000"]},
        "1250": {"vr": "TM", "Value": ["094545.532500"]},
        "1251": {"vr": "TM", "Value": ["095126.100000"]},
        "1252": {"vr": "TM", "Value": ["094950.617500"]},
        "1253": {"vr": "TM", "Value": ["095324.450000"]},
        "1254": {"vr": "TM", "Value": ["094829.075000"]},
        "1255": {"vr": "TM", "Value": ["094842.557500"]},
        "1256": {"vr": "TM", "Value": ["095208.490000"]},
        "1257": {"vr": "TM", "Value": ["094522.060000"]},
        "1258": {"vr": "TM", "Value": ["094601.525000"]},
        "1259": {"vr": "TM", "Value": ["095246.762500"]},
        "1260": {"vr": "TM", "Value": ["095133.582500"]},
        "1261": {"vr": "TM", "Value": ["094633.777500"]},
        "1262": {"vr": "TM", "Value": ["094728.207500"]},
        "1263": {"vr": "TM", "Value": ["095144.577500"]},
        "1264": {"vr": "TM", "Value": ["094649.622500"]},
        "1265": {"vr": "TM", "Value": ["094709.875000"]},
        "1266": {"vr": "TM", "Value": ["094750.050000"]},
        "1267": {"vr": "TM", "Value": ["095034.762500"]},
        "1268": {"vr": "TM", "Value": ["094947.690000"]},
        "1269": {"vr": "TM", "Value": ["094558.577500"]},
        "1270": {"vr": "TM", "Value": ["094623.222500"]},
        "1271": {"vr": "TM", "Value": ["095451.720000"]},
        "1272": {"vr": "TM", "Value": ["094921.290000"]},
        "1273": {"vr": "TM", "Value": ["094713.240000"]},
        "1274": {"vr": "TM", "Value": ["095153.085000"]},
        "1275": {"vr": "TM", "Value": ["095248.520000"]},
        "1276": {"vr": "TM", "Value": ["095357.455000"]},
        "1277": {"vr": "TM", "Value": ["095414.470000"]},
        "1278": {"vr": "TM", "Value": ["094912.930000"]},
        "1279": {"vr": "TM", "Value": ["094853.845000"]},
        "1280": {"vr": "TM", "Value": ["094554.627500"]},
        "1281": {"vr": "TM", "Value": ["095157.330000"]},
        "1282": {"vr": "TM", "Value": ["094651.085000"]},
        "1283": {"vr": "TM", "Value": ["095154.842500"]},
        "1284": {"vr": "TM", "Value": ["095205.837500"]},
        "1285": {"vr": "TM", "Value": ["094859.865000"]},
        "1286": {"vr": "TM", "Value": ["094854.577500"]},
        "1287": {"vr": "TM", "Value": ["094904.275000"]},
        "1288": {"vr": "TM", "Value": ["094804.285000"]},
        "1289": {"vr": "TM", "Value": ["095231.212500"]},
        "1290": {"vr": "TM", "Value": ["094755.192500"]},
        "1291": {"vr": "TM", "Value": ["094510.040000"]},
        "1292": {"vr": "TM", "Value": ["094917.465000"]},
        "1293": {"vr": "TM", "Value": ["095006.607500"]},
        "1294": {"vr": "TM", "Value": ["095330.470000"]},
        "1295": {"vr": "TM", "Value": ["094924.655000"]},
        "1296": {"vr": "TM", "Value": ["094711.192500"]},
        "1297": {"vr": "TM", "Value": ["094704.295000"]},
        "1298": {"vr": "TM", "Value": ["094520.890000"]},
        "1299": {"vr": "TM", "Value": ["094620.587500"]},
        "1300": {"vr": "TM", "Value": ["094959.562500"]},
        "1301": {"vr": "TM", "Value": ["094940.207500"]},
        "1302": {"vr": "TM", "Value": ["094523.837500"]},
        "1303": {"vr": "TM", "Value": ["095349.972500"]},
        "1304": {"vr": "TM", "Value": ["094909.982500"]},
        "1305": {"vr": "TM", "Value": ["094951.935000"]},
        "1306": {"vr": "TM", "Value": ["094546.412500"]},
        "1307": {"vr": "TM", "Value": ["095303.340000"]},
        "1308": {"vr": "TM", "Value": ["094623.515000"]},
        "1309": {"vr": "TM", "Value": ["094643.182500"]},
        "1310": {"vr": "TM", "Value": ["094521.915000"]},
        "1311": {"vr": "TM", "Value": ["094941.085000"]},
        "1312": {"vr": "TM", "Value": ["095403.037500"]},
        "1313": {"vr": "TM", "Value": ["094926.997500"]},
        "1314": {"vr": "TM", "Value": ["094723.212500"]},
        "1315": {"vr": "TM", "Value": ["094522.645000"]},
        "1316": {"vr": "TM", "Value": ["095025.525000"]},
        "1317": {"vr": "TM", "Value": ["094848.725000"]},
        "1318": {"vr": "TM", "Value": ["094550.530000"]},
        "1319": {"vr": "TM", "Value": ["094627.337500"]},
        "1320": {"vr": "TM", "Value": ["095242.500000"]},
        "1321": {"vr": "TM", "Value": ["094941.525000"]},
        "1322": {"vr": "TM", "Value": ["094607.085000"]},
        "1323": {"vr": "TM", "Value": ["094741.982500"]},
        "1324": {"vr": "TM", "Value": ["094820.860000"]},
        "1325": {"vr": "TM", "Value": ["094529.250000"]},
        "1326": {"vr": "TM", "Value": ["094819.837500"]},
        "1327": {"vr": "TM", "Value": ["095359.945000"]},
        "1328": {"vr": "TM", "Value": ["094714.997500"]},
        "1329": {"vr": "TM", "Value": ["095144.285000"]},
        "1330": {"vr": "TM", "Value": ["095451.280000"]},
        "1331": {"vr": "TM", "Value": ["094910.275000"]},
        "1332": {"vr": "TM", "Value": ["095342.637500"]},
        "1333": {"vr": "TM", "Value": ["095317.845000"]},
        "1334": {"vr": "TM", "Value": ["095231.942500"]},
        "1335": {"vr": "TM", "Value": ["094744.637500"]},
        "1336": {"vr": "TM", "Value": ["095011.142500"]},
        "1337": {"vr": "TM", "Value": ["094719.115000"]},
        "1338": {"vr": "TM", "Value": ["094840.362500"]},
        "1339": {"vr": "TM", "Value": ["095216.537500"]},
        "1340": {"vr": "TM", "Value": ["094557.260000"]},
        "1341": {"vr": "TM", "Value": ["095408.890000"]},
        "1342": {"vr": "TM", "Value": ["094609.152500"]},
        "1343": {"vr": "TM", "Value": ["095240.450000"]},
        "1344": {"vr": "TM", "Value": ["094714.850000"]},
        "1345": {"vr": "TM", "Value": ["094717.045000"]},
        "1346": {"vr": "TM", "Value": ["094615.592500"]},
        "1347": {"vr": "TM", "Value": ["094513.115000"]},
        "1348": {"vr": "TM", "Value": ["095121.690000"]},
        "1349": {"vr": "TM", "Value": ["094615.737500"]},
        "1350": {"vr": "TM", "Value": ["095120.372500"]},
        "1351": {"vr": "TM", "Value": ["094547.435000"]},
        "1352": {"vr": "TM", "Value": ["094953.835000"]},
        "1353": {"vr": "TM", "Value": ["095238.842500"]},
        "1354": {"vr": "TM", "Value": ["095416.372500"]},
        "1355": {"vr": "TM", "Value": ["094812.500000"]},
        "1356": {"vr": "TM", "Value": ["094935.650000"]},
        "1357": {"vr": "TM", "Value": ["095024.940000"]},
        "1358": {"vr": "TM", "Value": ["094647.132500"]},
        "1359": {"vr": "TM", "Value": ["095352.022500"]},
        "1360": {"vr": "TM", "Value": ["095352.167500"]},
        "1361": {"vr": "TM", "Value": ["094601.085000"]},
        "1362": {"vr": "TM", "Value": ["094516.792500"]},
        "1363": {"vr": "TM", "Value": ["094701.367500"]},
        "1364": {"vr": "TM", "Value": ["094722.187500"]},
        "1365": {"vr": "TM", "Value": ["095032.130000"]},
        "1366": {"vr": "TM", "Value": ["094838.752500"]},
        "1367": {"vr": "TM", "Value": ["094551.992500"]},
        "1368": {"vr": "TM", "Value": ["094805.895000"]},
        "1369": {"vr": "TM", "Value": ["094831.125000"]},
        "1370": {"vr": "TM", "Value": ["094941.817500"]},
        "1371": {"vr": "TM", "Value": ["094620.147500"]},
        "1372": {"vr": "TM", "Value": ["094555.212500"]},
        "1373": {"vr": "TM", "Value": ["095207.152500"]},
        "1374": {"vr": "TM", "Value": ["095014.675000"]},
        "1375": {"vr": "TM", "Value": ["094825.250000"]},
        "1376": {"vr": "TM", "Value": ["094621.465000"]},
        "1377": {"vr": "TM", "Value": ["094630.557500"]},
        "1378": {"vr": "TM", "Value": ["095426.930000"]},
        "1379": {"vr": "TM", "Value": ["095435.875000"]},
        "1380": {"vr": "TM", "Value": ["095040.930000"]},
        "1381": {"vr": "TM", "Value": ["095313.750000"]},
        "1382": {"vr": "TM", "Value": ["095320.500000"]},
        "1383": {"vr": "TM", "Value": ["094724.675000"]},
        "1384": {"vr": "TM", "Value": ["094616.177500"]},
        "1385": {"vr": "TM", "Value": ["094845.485000"]},
        "1386": {"vr": "TM", "Value": ["095148.967500"]},
        "1387": {"vr": "TM", "Value": ["094842.850000"]},
        "1388": {"vr": "TM", "Value": ["095044.735000"]},
        "1389": {"vr": "TM", "Value": ["094610.032500"]},
        "1390": {"vr": "TM", "Value": ["094851.065000"]},
        "1391": {"vr": "TM", "Value": ["094516.500000"]},
        "1392": {"vr": "TM", "Value": ["095354.675000"]},
        "1393": {"vr": "TM", "Value": ["094844.315000"]},
        "1394": {"vr": "TM", "Value": ["095012.460000"]},
        "1395": {"vr": "TM", "Value": ["094924.510000"]},
        "1396": {"vr": "TM", "Value": ["095112.597500"]},
        "1397": {"vr": "TM", "Value": ["094930.675000"]},
        "1398": {"vr": "TM", "Value": ["094750.927500"]},
        "1399": {"vr": "TM", "Value": ["094817.622500"]},
        "1400": {"vr": "TM", "Value": ["095046.050000"]},
        "1401": {"vr": "TM", "Value": ["094735.837500"]},
        "1402": {"vr": "TM", "Value": ["095343.367500"]},
        "1403": {"vr": "TM", "Value": ["094953.250000"]},
        "1404": {"vr": "TM", "Value": ["094506.967500"]},
        "1405": {"vr": "TM", "Value": ["094530.127500"]},
        "1406": {"vr": "TM", "Value": ["094725.992500"]},
        "1407": {"vr": "TM", "Value": ["094702.392500"]},
        "1408": {"vr": "TM", "Value": ["094815.572500"]},
        "1409": {"vr": "TM", "Value": ["094707.660000"]},
        "1410": {"vr": "TM", "Value": ["095344.685000"]},
        "1411": {"vr": "TM", "Value": ["094629.387500"]},
        "1412": {"vr": "TM", "Value": ["095037.982500"]},
        "1413": {"vr": "TM", "Value": ["095316.675000"]},
        "1414": {"vr": "TM", "Value": ["095120.520000"]},
        "1415": {"vr": "TM", "Value": ["094537.465000"]},
        "1416": {"vr": "TM", "Value": ["094718.967500"]},
        "1417": {"vr": "TM", "Value": ["094643.767500"]},
        "1418": {"vr": "TM", "Value": ["095016.870000"]},
        "1419": {"vr": "TM", "Value": ["095339.270000"]},
        "1420": {"vr": "TM", "Value": ["095232.675000"]},
        "1421": {"vr": "TM", "Value": ["094721.310000"]},
        "1422": {"vr": "TM", "Value": ["095321.962500"]},
        "1423": {"vr": "TM", "Value": ["094934.772500"]},
        "1424": {"vr": "TM", "Value": ["095404.647500"]},
        "1425": {"vr": "TM", "Value": ["094849.895000"]},
        "1426": {"vr": "TM", "Value": ["095247.495000"]},
        "1427": {"vr": "TM", "Value": ["095212.735000"]},
        "1428": {"vr": "TM", "Value": ["094913.952500"]},
        "1429": {"vr": "TM", "Value": ["095328.567500"]},
        "1430": {"vr": "TM", "Value": ["095317.407500"]},
        "1431": {"vr": "TM", "Value": ["095424.880000"]},
        "1432": {"vr": "TM", "Value": ["094934.627500"]},
        "1433": {"vr": "TM", "Value": ["095228.577500"]},
        "1434": {"vr": "TM", "Value": ["095127.855000"]},
        "1435": {"vr": "TM", "Value": ["095035.495000"]},
        "1436": {"vr": "TM", "Value": ["095251.152500"]},
        "1437": {"vr": "TM", "Value": ["095123.885000"]},
        "1438": {"vr": "TM", "Value": ["094554.332500"]},
        "1439": {"vr": "TM", "Value": ["095012.315000"]},
        "1440": {"vr": "TM", "Value": ["095434.557500"]},
        "1441": {"vr": "TM", "Value": ["095026.695000"]},
        "1442": {"vr": "TM", "Value": ["094506.530000"]},
        "1443": {"vr": "TM", "Value": ["095431.485000"]},
        "1444": {"vr": "TM", "Value": ["095028.742500"]},
        "1445": {"vr": "TM", "Value": ["095353.192500"]},
        "1446": {"vr": "TM", "Value": ["095158.352500"]},
        "1447": {"vr": "TM", "Value": ["094739.347500"]},
        "1448": {"vr": "TM", "Value": ["094545.827500"]},
        "1449": {"vr": "TM", "Value": ["094643.622500"]},
        "1450": {"vr": "TM", "Value": ["094752.392500"]},
        "1451": {"vr": "TM", "Value": ["094931.115000"]},
        "1452": {"vr": "TM", "Value": ["094516.645000"]},
        "1453": {"vr": "TM", "Value": ["095159.837500"]},
        "1454": {"vr": "TM", "Value": ["095414.325000"]},
        "1455": {"vr": "TM", "Value": ["095452.012500"]},
        "1456": {"vr": "TM", "Value": ["095038.422500"]},
        "1457": {"vr": "TM", "Value": ["094657.105000"]},
        "1458": {"vr": "TM", "Value": ["095437.777500"]},
        "1459": {"vr": "TM", "Value": ["094608.422500"]},
        "1460": {"vr": "TM", "Value": ["095314.042500"]},
        "1461": {"vr": "TM", "Value": ["094648.890000"]},
        "1462": {"vr": "TM", "Value": ["094927.290000"]},
        "1463": {"vr": "TM", "Value": ["094923.047500"]},
        "1464": {"vr": "TM", "Value": ["095304.655000"]},
        "1465": {"vr": "TM", "Value": ["095059.700000"]},
        "1466": {"vr": "TM", "Value": ["094735.230000"]},
        "1467": {"vr": "TM", "Value": ["094711.045000"]},
        "1468": {"vr": "TM", "Value": ["095151.037500"]},
        "1469": {"vr": "TM", "Value": ["095355.847500"]},
        "1470": {"vr": "TM", "Value": ["095055.437500"]},
        "1471": {"vr": "TM", "Value": ["095319.330000"]},
        "1472": {"vr": "TM", "Value": ["094725.115000"]},
        "1473": {"vr": "TM", "Value": ["094728.940000"]},
        "1474": {"vr": "TM", "Value": ["095138.120000"]},
        "1475": {"vr": "TM", "Value": ["095323.720000"]},
        "1476": {"vr": "TM", "Value": ["094836.245000"]},
        "1477": {"vr": "TM", "Value": ["094543.192500"]},
        "1478": {"vr": "TM", "Value": ["094840.802500"]},
        "1479": {"vr": "TM", "Value": ["095115.837500"]},
        "1480": {"vr": "TM", "Value": ["095233.552500"]},
        "1481": {"vr": "TM", "Value": ["095300.685000"]},
        "1482": {"vr": "TM", "Value": ["095232.967500"]},
        "1483": {"vr": "TM", "Value": ["095224.022500"]},
        "1484": {"vr": "TM", "Value": ["095038.130000"]},
        "1485": {"vr": "TM", "Value": ["094859.280000"]},
        "1486": {"vr": "TM", "Value": ["094634.967500"]},
        "1487": {"vr": "TM", "Value": ["095427.660000"]},
        "1488": {"vr": "TM", "Value": ["095136.655000"]},
        "1489": {"vr": "TM", "Value": ["094907.202500"]},
        "1490": {"vr": "TM", "Value": ["095029.475000"]},
        "1491": {"vr": "TM", "Value": ["094803.115000"]},
        "1492": {"vr": "TM", "Value": ["095056.315000"]},
        "1493": {"vr": "TM", "Value": ["094646.695000"]},
        "1494": {"vr": "TM", "Value": ["095403.475000"]},
        "1495": {"vr": "TM", "Value": ["095147.357500"]},
        "1496": {"vr": "TM", "Value": ["095336.782500"]},
        "1497": {"vr": "TM", "Value": ["094704.147500"]},
        "1498": {"vr": "TM", "Value": ["094919.952500"]},
        "1499": {"vr": "TM", "Value": ["095337.075000"]},
        "1500": {"vr": "TM", "Value": ["095118.470000"]},
        "1501": {"vr": "TM", "Value": ["094731.427500"]},
        "1502": {"vr": "TM", "Value": ["095058.530000"]},
        "1503": {"vr": "TM", "Value": ["095323.865000"]},
        "1504": {"vr": "TM", "Value": ["095103.065000"]},
        "1505": {"vr": "TM", "Value": ["094752.685000"]},
        "1506": {"vr": "TM", "Value": ["094906.910000"]},
        "1507": {"vr": "TM", "Value": ["094750.197500"]},
        "1508": {"vr": "TM", "Value": ["094601.817500"]},
        "1509": {"vr": "TM", "Value": ["094652.275000"]},
        "1510": {"vr": "TM", "Value": ["095122.860000"]},
        "1511": {"vr": "TM", "Value": ["095319.182500"]},
        "1512": {"vr": "TM", "Value": ["095137.827500"]},
        "1513": {"vr": "TM", "Value": ["094542.315000"]},
        "1514": {"vr": "TM", "Value": ["094718.237500"]},
        "1515": {"vr": "TM", "Value": ["094507.700000"]},
        "1516": {"vr": "TM", "Value": ["094525.152500"]},
        "1517": {"vr": "TM", "Value": ["095316.237500"]},
        "1518": {"vr": "TM", "Value": ["095251.445000"]},
        "1519": {"vr": "TM", "Value": ["095019.357500"]},
        "1520": {"vr": "TM", "Value": ["094833.172500"]},
        "1521": {"vr": "TM", "Value": ["095309.485000"]},
        "1522": {"vr": "TM", "Value": ["094750.782500"]},
        "1523": {"vr": "TM", "Value": ["094834.635000"]},
        "1524": {"vr": "TM", "Value": ["094916.440000"]},
        "1525": {"vr": "TM", "Value": ["094618.100000"]},
        "1526": {"vr": "TM", "Value": ["094726.577500"]},
        "1527": {"vr": "TM", "Value": ["095244.715000"]},
        "1528": {"vr": "TM", "Value": ["094528.372500"]},
        "1529": {"vr": "TM", "Value": ["094901.767500"]},
        "1530": {"vr": "TM", "Value": ["095222.705000"]},
        "1531": {"vr": "TM", "Value": ["094930.090000"]},
        "1532": {"vr": "TM", "Value": ["095404.500000"]},
        "1533": {"vr": "TM", "Value": ["094732.450000"]},
        "1534": {"vr": "TM", "Value": ["094841.095000"]},
        "1535": {"vr": "TM", "Value": ["094719.260000"]},
        "1536": {"vr": "TM", "Value": ["094958.685000"]},
        "1537": {"vr": "TM", "Value": ["094547.142500"]},
        "1538": {"vr": "TM", "Value": ["094544.655000"]},
        "1539": {"vr": "TM", "Value": ["094637.017500"]},
        "1540": {"vr": "TM", "Value": ["095015.260000"]},
        "1541": {"vr": "TM", "Value": ["095034.617500"]},
        "1542": {"vr": "TM", "Value": ["094741.690000"]},
        "1543": {"vr": "TM", "Value": ["094839.485000"]},
        "1544": {"vr": "TM", "Value": ["094955.885000"]},
        "1545": {"vr": "TM", "Value": ["094931.552500"]},
        "1546": {"vr": "TM", "Value": ["095046.197500"]},
        "1547": {"vr": "TM", "Value": ["095029.182500"]},
        "1548": {"vr": "TM", "Value": ["095012.900000"]},
        "1549": {"vr": "TM", "Value": ["094900.742500"]},
        "1550": {"vr": "TM", "Value": ["094758.705000"]},
        "1551": {"vr": "TM", "Value": ["094809.700000"]},
        "1552": {"vr": "TM", "Value": ["094853.407500"]},
        "1553": {"vr": "TM", "Value": ["094645.525000"]},
        "1554": {"vr": "TM", "Value": ["094949.152500"]},
        "1555": {"vr": "TM", "Value": ["094511.797500"]},
        "1556": {"vr": "TM", "Value": ["095051.047500"]},
        "1557": {"vr": "TM", "Value": ["094942.547500"]},
        "1558": {"vr": "TM", "Value": ["094911.737500"]},
        "1559": {"vr": "TM", "Value": ["095135.340000"]},
        "1560": {"vr": "TM", "Value": ["095420.782500"]},
        "1561": {"vr": "TM", "Value": ["095009.387500"]},
        "1562": {"vr": "TM", "Value": ["095310.822500"]},
        "1563": {"vr": "TM", "Value": ["094725.700000"]},
        "1564": {"vr": "TM", "Value": ["094730.695000"]},
        "1565": {"vr": "TM", "Value": ["094615.300000"]},
        "1566": {"vr": "TM", "Value": ["095023.037500"]},
        "1567": {"vr": "TM", "Value": ["094802.967500"]},
        "1568": {"vr": "TM", "Value": ["095013.945000"]},
        "1569": {"vr": "TM", "Value": ["095326.207500"]},
        "1570": {"vr": "TM", "Value": ["095058.967500"]},
        "1571": {"vr": "TM", "Value": ["094534.685000"]},
        "1572": {"vr": "TM", "Value": ["094841.535000"]},
        "1573": {"vr": "TM", "Value": ["095041.075000"]},
        "1574": {"vr": "TM", "Value": ["095000.002500"]},
        "1575": {"vr": "TM", "Value": ["095057.485000"]},
        "1576": {"vr": "TM", "Value": ["094632.167500"]},
        "1577": {"vr": "TM", "Value": ["095114.645000"]},
        "1578": {"vr": "TM", "Value": ["095434.997500"]},
        "1579": {"vr": "TM", "Value": ["095436.022500"]},
        "1580": {"vr": "TM", "Value": ["095204.080000"]},
        "1581": {"vr": "TM", "Value": ["094923.340000"]},
        "1582": {"vr": "TM", "Value": ["095222.265000"]},
        "1583": {"vr": "TM", "Value": ["095047.222500"]},
        "1584": {"vr": "TM", "Value": ["094718.822500"]},
        "1585": {"vr": "TM", "Value": ["095334.715000"]},
        "1586": {"vr": "TM", "Value": ["095245.007500"]},
        "1587": {"vr": "TM", "Value": ["095047.660000"]},
        "1588": {"vr": "TM", "Value": ["095131.367500"]},
        "1589": {"vr": "TM", "Value": ["094700.490000"]},
        "1590": {"vr": "TM", "Value": ["094828.177500"]},
        "1591": {"vr": "TM", "Value": ["094724.090000"]},
        "1592": {"vr": "TM", "Value": ["095329.885000"]},
        "1593": {"vr": "TM", "Value": ["095035.642500"]},
        "1594": {"vr": "TM", "Value": ["095312.285000"]},
        "1595": {"vr": "TM", "Value": ["095417.837500"]},
        "1596": {"vr": "TM", "Value": ["094558.890000"]},
        "1597": {"vr": "TM", "Value": ["094918.490000"]},
        "1598": {"vr": "TM", "Value": ["095348.655000"]},
        "1599": {"vr": "TM", "Value": ["095209.367500"]},
        "1600": {"vr": "TM", "Value": ["095136.510000"]},
        "1601": {"vr": "TM", "Value": ["094513.992500"]},
        "1602": {"vr": "TM", "Value": ["095357.162500"]},
        "1603": {"vr": "TM", "Value": ["095449.232500"]},
        "1604": {"vr": "TM", "Value": ["094650.500000"]},
        "1605": {"vr": "TM", "Value": ["095101.310000"]},
        "1606": {"vr": "TM", "Value": ["095423.270000"]},
        "1607": {"vr": "TM", "Value": ["094835.075000"]},
        "1608": {"vr": "TM", "Value": ["095301.290000"]},
        "1609": {"vr": "TM", "Value": ["094926.557500"]},
        "1610": {"vr": "TM", "Value": ["095003.515000"]},
        "1611": {"vr": "TM", "Value": ["095234.577500"]},
        "1612": {"vr": "TM", "Value": ["094938.285000"]},
        "1613": {"vr": "TM", "Value": ["095238.110000"]},
        "1614": {"vr": "TM", "Value": ["094723.650000"]},
        "1615": {"vr": "TM", "Value": ["095251.007500"]},
        "1616": {"vr": "TM", "Value": ["094719.700000"]},
        "1617": {"vr": "TM", "Value": ["094952.372500"]},
        "1618": {"vr": "TM", "Value": ["094943.572500"]},
        "1619": {"vr": "TM", "Value": ["094532.177500"]},
        "1620": {"vr": "TM", "Value": ["094713.827500"]},
        "1621": {"vr": "TM", "Value": ["094948.275000"]},
        "1622": {"vr": "TM", "Value": ["095121.542500"]},
        "1623": {"vr": "TM", "Value": ["094936.967500"]},
        "1624": {"vr": "TM", "Value": ["095357.602500"]},
        "1625": {"vr": "TM", "Value": ["094821.592500"]},
        "1626": {"vr": "TM", "Value": ["095025.085000"]},
        "1627": {"vr": "TM", "Value": ["094831.710000"]},
        "1628": {"vr": "TM", "Value": ["095028.890000"]},
        "1629": {"vr": "TM", "Value": ["095232.090000"]},
        "1630": {"vr": "TM", "Value": ["095432.070000"]},
        "1631": {"vr": "TM", "Value": ["094652.860000"]},
        "1632": {"vr": "TM", "Value": ["095128.735000"]},
        "1633": {"vr": "TM", "Value": ["095027.865000"]},
        "1634": {"vr": "TM", "Value": ["094535.562500"]},
        "1635": {"vr": "TM", "Value": ["095213.320000"]},
        "1636": {"vr": "TM", "Value": ["094557.115000"]},
        "1637": {"vr": "TM", "Value": ["095150.745000"]},
        "1638": {"vr": "TM", "Value": ["094904.567500"]},
        "1639": {"vr": "TM", "Value": ["095321.377500"]},
        "1640": {"vr": "TM", "Value": ["094641.407500"]},
        "1641": {"vr": "TM", "Value": ["095445.845000"]},
        "1642": {"vr": "TM", "Value": ["094528.812500"]},
        "1643": {"vr": "TM", "Value": ["095450.842500"]},
        "1644": {"vr": "TM", "Value": ["094958.247500"]},
        "1645": {"vr": "TM", "Value": ["095352.607500"]},
        "1646": {"vr": "TM", "Value": ["095228.140000"]},
        "1647": {"vr": "TM", "Value": ["095329.447500"]},
        "1648": {"vr": "TM", "Value": ["094730.547500"]},
        "1649": {"vr": "TM", "Value": ["094826.130000"]},
        "1650": {"vr": "TM", "Value": ["094952.080000"]},
        "1651": {"vr": "TM", "Value": ["095242.207500"]},
        "1652": {"vr": "TM", "Value": ["094907.640000"]},
        "1653": {"vr": "TM", "Value": ["094935.212500"]},
        "1654": {"vr": "TM", "Value": ["094748.440000"]},
        "1655": {"vr": "TM", "Value": ["095142.237500"]},
        "1656": {"vr": "TM", "Value": ["094932.725000"]},
        "1657": {"vr": "TM", "Value": ["095132.832500"]},
        "1658": {"vr": "TM", "Value": ["095210.540000"]},
        "1659": {"vr": "TM", "Value": ["094854.745000"]},
        "1660": {"vr": "TM", "Value": ["095118.325000"]},
        "1661": {"vr": "TM", "Value": ["094517.670000"]},
        "1662": {"vr": "TM", "Value": ["095056.607500"]},
        "1663": {"vr": "TM", "Value": ["094811.767500"]},
        "1664": {"vr": "TM", "Value": ["095255.855000"]},
        "1665": {"vr": "TM", "Value": ["095216.392500"]},
        "1666": {"vr": "TM", "Value": ["094911.592500"]},
        "1667": {"vr": "TM", "Value": ["095225.337500"]},
        "1668": {"vr": "TM", "Value": ["094658.422500"]},
        "1669": {"vr": "TM", "Value": ["095229.895000"]},
        "1670": {"vr": "TM", "Value": ["094914.685000"]},
        "1671": {"vr": "TM", "Value": ["095132.392500"]},
        "1672": {"vr": "TM", "Value": ["094559.330000"]},
        "1673": {"vr": "TM", "Value": ["094812.940000"]},
        "1674": {"vr": "TM", "Value": ["095022.430000"]},
        "1675": {"vr": "TM", "Value": ["094731.720000"]},
        "1676": {"vr": "TM", "Value": ["094526.470000"]},
        "1677": {"vr": "TM", "Value": ["095412.275000"]},
        "1678": {"vr": "TM", "Value": ["094837.875000"]},
        "1679": {"vr": "TM", "Value": ["094902.937500"]},
        "1680": {"vr": "TM", "Value": ["095227.555000"]},
        "1681": {"vr": "TM", "Value": ["094634.382500"]},
        "1682": {"vr": "TM", "Value": ["095211.125000"]},
        "1683": {"vr": "TM", "Value": ["095124.490000"]},
        "1684": {"vr": "TM", "Value": ["095346.900000"]},
        "1685": {"vr": "TM", "Value": ["095252.032500"]},
        "1686": {"vr": "TM", "Value": ["094527.932500"]},
        "1687": {"vr": "TM", "Value": ["095155.865000"]},
        "1688": {"vr": "TM", "Value": ["094801.192500"]},
        "1689": {"vr": "TM", "Value": ["094820.567500"]},
        "1690": {"vr": "TM", "Value": ["095022.577500"]},
        "1691": {"vr": "TM", "Value": ["095313.017500"]},
        "1692": {"vr": "TM", "Value": ["094829.660000"]},
        "1693": {"vr": "TM", "Value": ["094847.992500"]},
        "1694": {"vr": "TM", "Value": ["095302.460000"]},
        "1695": {"vr": "TM", "Value": ["094713.680000"]},
        "1696": {"vr": "TM", "Value": ["094536.295000"]},
        "1697": {"vr": "TM", "Value": ["095034.325000"]},
        "1698": {"vr": "TM", "Value": ["095416.665000"]},
        "1699": {"vr": "TM", "Value": ["095042.540000"]},
        "1700": {"vr": "TM", "Value": ["094509.747500"]},
        "1701": {"vr": "TM", "Value": ["095258.637500"]},
        "1702": {"vr": "TM", "Value": ["094709.437500"]},
        "1703": {"vr": "TM", "Value": ["094541.290000"]},
        "1704": {"vr": "TM", "Value": ["095356.725000"]},
        "1705": {"vr": "TM", "Value": ["094536.147500"]},
        "1706": {"vr": "TM", "Value": ["094537.027500"]},
        "1707": {"vr": "TM", "Value": ["094828.490000"]},
        "1708": {"vr": "TM", "Value": ["095219.632500"]},
        "1709": {"vr": "TM", "Value": ["095014.822500"]},
        "1710": {"vr": "TM", "Value": ["094913.367500"]},
        "1711": {"vr": "TM", "Value": ["094532.030000"]},
        "1712": {"vr": "TM", "Value": ["095148.530000"]},
        "1713": {"vr": "TM", "Value": ["094735.982500"]},
        "1714": {"vr": "TM", "Value": ["095359.650000"]},
        "1715": {"vr": "TM", "Value": ["095241.767500"]},
        "1716": {"vr": "TM", "Value": ["094605.475000"]},
        "1717": {"vr": "TM", "Value": ["094642.890000"]},
        "1718": {"vr": "TM", "Value": ["094944.012500"]},
        "1719": {"vr": "TM", "Value": ["095412.715000"]},
        "1720": {"vr": "TM", "Value": ["095455.232500"]},
        "1721": {"vr": "TM", "Value": ["095401.992500"]},
        "1722": {"vr": "TM", "Value": ["094727.475000"]},
        "1723": {"vr": "TM", "Value": ["095416.957500"]},
        "1724": {"vr": "TM", "Value": ["095249.250000"]},
        "1725": {"vr": "TM", "Value": ["094740.080000"]},
        "1726": {"vr": "TM", "Value": ["095346.755000"]},
        "1727": {"vr": "TM", "Value": ["094917.027500"]},
        "1728": {"vr": "TM", "Value": ["094746.392500"]},
        "1729": {"vr": "TM", "Value": ["094955.007500"]},
        "1730": {"vr": "TM", "Value": ["094536.587500"]},
        "1731": {"vr": "TM", "Value": ["094837.437500"]},
        "1732": {"vr": "TM", "Value": ["094528.957500"]},
        "1733": {"vr": "TM", "Value": ["094517.525000"]},
        "1734": {"vr": "TM", "Value": ["095358.920000"]},
        "1735": {"vr": "TM", "Value": ["095303.632500"]},
        "1736": {"vr": "TM", "Value": ["094824.080000"]},
        "1737": {"vr": "TM", "Value": ["094702.540000"]},
        "1738": {"vr": "TM", "Value": ["095136.947500"]},
        "1739": {"vr": "TM", "Value": ["094841.972500"]},
        "1740": {"vr": "TM", "Value": ["095356.870000"]},
        "1741": {"vr": "TM", "Value": ["094752.100000"]},
        "1742": {"vr": "TM", "Value": ["094622.927500"]},
        "1743": {"vr": "TM", "Value": ["094738.762500"]},
        "1744": {"vr": "TM", "Value": ["095128.147500"]},
        "1745": {"vr": "TM", "Value": ["095102.480000"]},
        "1746": {"vr": "TM", "Value": ["095241.475000"]},
        "1747": {"vr": "TM", "Value": ["095046.782500"]},
        "1748": {"vr": "TM", "Value": ["095215.515000"]},
        "1749": {"vr": "TM", "Value": ["095301.145000"]},
        "1750": {"vr": "TM", "Value": ["095423.857500"]},
        "1751": {"vr": "TM", "Value": ["095434.265000"]},
        "1752": {"vr": "TM", "Value": ["094609.007500"]},
        "1753": {"vr": "TM", "Value": ["094734.060000"]},
        "1754": {"vr": "TM", "Value": ["094940.647500"]},
        "1755": {"vr": "TM", "Value": ["095127.270000"]},
        "1756": {"vr": "TM", "Value": ["094738.470000"]},
        "1757": {"vr": "TM", "Value": ["095120.665000"]},
        "1758": {"vr": "TM", "Value": ["094517.962500"]},
        "1759": {"vr": "TM", "Value": ["094527.347500"]},
        "1760": {"vr": "TM", "Value": ["095121.105000"]},
        "1761": {"vr": "TM", "Value": ["094545.680000"]},
        "1762": {"vr": "TM", "Value": ["094517.085000"]},
        "1763": {"vr": "TM", "Value": ["094559.915000"]},
        "1764": {"vr": "TM", "Value": ["094927.730000"]},
        "1765": {"vr": "TM", "Value": ["094642.430000"]},
        "1766": {"vr": "TM", "Value": ["094833.757500"]},
        "1767": {"vr": "TM", "Value": ["094847.700000"]},
        "1768": {"vr": "TM", "Value": ["094852.090000"]},
        "1769": {"vr": "TM", "Value": ["094516.352500"]},
        "1770": {"vr": "TM", "Value": ["095124.637500"]},
        "1771": {"vr": "TM", "Value": ["094934.920000"]},
        "1772": {"vr": "TM", "Value": ["094942.110000"]},
        "1773": {"vr": "TM", "Value": ["095354.237500"]},
        "1774": {"vr": "TM", "Value": ["094549.045000"]},
        "1775": {"vr": "TM", "Value": ["094644.645000"]},
        "1776": {"vr": "TM", "Value": ["095434.705000"]},
        "1777": {"vr": "TM", "Value": ["094734.937500"]},
        "1778": {"vr": "TM", "Value": ["094743.885000"]},
        "1779": {"vr": "TM", "Value": ["095243.377500"]},
        "1780": {"vr": "TM", "Value": ["094804.432500"]},
        "1781": {"vr": "TM", "Value": ["095248.812500"]},
        "1782": {"vr": "TM", "Value": ["094701.660000"]},
        "1783": {"vr": "TM", "Value": ["094736.130000"]},
        "1784": {"vr": "TM", "Value": ["095227.260000"]},
        "1785": {"vr": "TM", "Value": ["094842.705000"]},
        "1786": {"vr": "TM", "Value": ["095142.530000"]},
        "1787": {"vr": "TM", "Value": ["095442.920000"]},
        "1788": {"vr": "TM", "Value": ["094751.952500"]},
        "1789": {"vr": "TM", "Value": ["095230.627500"]},
        "1790": {"vr": "TM", "Value": ["094713.532500"]},
        "1791": {"vr": "TM", "Value": ["094628.070000"]},
        "1792": {"vr": "TM", "Value": ["095024.352500"]},
        "1793": {"vr": "TM", "Value": ["094930.530000"]},
        "1794": {"vr": "TM", "Value": ["094927.875000"]},
        "1795": {"vr": "TM", "Value": ["094729.085000"]},
        "1796": {"vr": "TM", "Value": ["094508.870000"]},
        "1797": {"vr": "TM", "Value": ["095039.737500"]},
        "1798": {"vr": "TM", "Value": ["094706.927500"]},
        "1799": {"vr": "TM", "Value": ["095100.140000"]},
        "1800": {"vr": "TM", "Value": ["095110.110000"]},
        "1801": {"vr": "TM", "Value": ["095328.275000"]},
        "1802": {"vr": "TM", "Value": ["094820.715000"]},
        "1803": {"vr": "TM", "Value": ["095415.202500"]},
        "1804": {"vr": "TM", "Value": ["095415.495000"]},
        "1805": {"vr": "TM", "Value": ["095453.915000"]},
        "1806": {"vr": "TM", "Value": ["094602.987500"]},
        "1807": {"vr": "TM", "Value": ["095408.450000"]},
        "1808": {"vr": "TM", "Value": ["095233.992500"]},
        "1809": {"vr": "TM", "Value": ["094735.085000"]},
        "1810": {"vr": "TM", "Value": ["095044.295000"]},
        "1811": {"vr": "TM", "Value": ["094937.700000"]},
        "1812": {"vr": "TM", "Value": ["094851.357500"]},
        "1813": {"vr": "TM", "Value": ["094839.632500"]},
        "1814": {"vr": "TM", "Value": ["095307.437500"]},
        "1815": {"vr": "TM", "Value": ["095426.050000"]},
        "1816": {"vr": "TM", "Value": ["095022.285000"]},
        "1817": {"vr": "TM", "Value": ["095045.027500"]},
        "1818": {"vr": "TM", "Value": ["095028.597500"]},
        "1819": {"vr": "TM", "Value": ["094920.392500"]},
        "1820": {"vr": "TM", "Value": ["094829.515000"]},
        "1821": {"vr": "TM", "Value": ["095132.977500"]},
        "1822": {"vr": "TM", "Value": ["095239.135000"]},
        "1823": {"vr": "TM", "Value": ["095131.807500"]},
        "1824": {"vr": "TM", "Value": ["094721.602500"]},
        "1825": {"vr": "TM", "Value": ["095047.515000"]},
        "1826": {"vr": "TM", "Value": ["094739.935000"]},
        "1827": {"vr": "TM", "Value": ["095316.967500"]},
        "1828": {"vr": "TM", "Value": ["094902.792500"]},
        "1829": {"vr": "TM", "Value": ["094607.690000"]},
        "1830": {"vr": "TM", "Value": ["094728.792500"]},
        "1831": {"vr": "TM", "Value": ["095043.855000"]},
        "1832": {"vr": "TM", "Value": ["094849.747500"]},
        "1833": {"vr": "TM", "Value": ["095024.792500"]},
        "1834": {"vr": "TM", "Value": ["094706.197500"]},
        "1835": {"vr": "TM", "Value": ["095017.162500"]},
        "1836": {"vr": "TM", "Value": ["095118.032500"]},
        "1837": {"vr": "TM", "Value": ["094827.300000"]},
        "1838": {"vr": "TM", "Value": ["095318.137500"]},
        "1839": {"vr": "TM", "Value": ["095218.900000"]},
        "1840": {"vr": "TM", "Value": ["094554.772500"]},
        "1841": {"vr": "TM", "Value": ["095051.777500"]},
        "1842": {"vr": "TM", "Value": ["094937.552500"]},
        "1843": {"vr": "TM", "Value": ["094703.562500"]},
        "1844": {"vr": "TM", "Value": ["095123.445000"]},
        "1845": {"vr": "TM", "Value": ["094819.545000"]},
        "1846": {"vr": "TM", "Value": ["094807.650000"]},
        "1847": {"vr": "TM", "Value": ["094801.485000"]},
        "1848": {"vr": "TM", "Value": ["094950.762500"]},
        "1849": {"vr": "TM", "Value": ["095233.845000"]},
        "1850": {"vr": "TM", "Value": ["095015.700000"]},
        "1851": {"vr": "TM", "Value": ["095234.890000"]},
        "1852": {"vr": "TM", "Value": ["095110.402500"]},
        "1853": {"vr": "TM", "Value": ["094520.305000"]},
        "1854": {"vr": "TM", "Value": ["094621.612500"]},
        "1855": {"vr": "TM", "Value": ["094944.890000"]},
        "1856": {"vr": "TM", "Value": ["094635.845000"]},
        "1857": {"vr": "TM", "Value": ["095420.345000"]},
        "1858": {"vr": "TM", "Value": ["094817.475000"]},
        "1859": {"vr": "TM", "Value": ["094635.992500"]},
        "1860": {"vr": "TM", "Value": ["095038.715000"]},
        "1861": {"vr": "TM", "Value": ["095052.802500"]},
        "1862": {"vr": "TM", "Value": ["094727.622500"]},
        "1863": {"vr": "TM", "Value": ["095321.525000"]},
        "1864": {"vr": "TM", "Value": ["094602.255000"]},
        "1865": {"vr": "TM", "Value": ["094955.592500"]},
        "1866": {"vr": "TM", "Value": ["095038.275000"]},
        "1867": {"vr": "TM", "Value": ["095105.992500"]},
        "1868": {"vr": "TM", "Value": ["095442.335000"]},
        "1869": {"vr": "TM", "Value": ["095157.037500"]},
        "1870": {"vr": "TM", "Value": ["094548.607500"]},
        "1871": {"vr": "TM", "Value": ["095210.685000"]},
        "1872": {"vr": "TM", "Value": ["095453.037500"]},
        "1873": {"vr": "TM", "Value": ["094510.627500"]},
        "1874": {"vr": "TM", "Value": ["094736.567500"]},
        "1875": {"vr": "TM", "Value": ["095419.885000"]},
        "1876": {"vr": "TM", "Value": ["094604.742500"]},
        "1877": {"vr": "TM", "Value": ["094616.782500"]},
        "1878": {"vr": "TM", "Value": ["095441.750000"]},
        "1879": {"vr": "TM", "Value": ["094814.110000"]},
        "1880": {"vr": "TM", "Value": ["094741.835000"]},
        "1881": {"vr": "TM", "Value": ["095234.432500"]},
        "1882": {"vr": "TM", "Value": ["094922.460000"]},
        "1883": {"vr": "TM", "Value": ["094540.977500"]},
        "1884": {"vr": "TM", "Value": ["094754.900000"]},
        "1885": {"vr": "TM", "Value": ["095410.940000"]},
        "1886": {"vr": "TM", "Value": ["095006.752500"]},
        "1887": {"vr": "TM", "Value": ["095247.350000"]},
        "1888": {"vr": "TM", "Value": ["095422.832500"]},
        "1889": {"vr": "TM", "Value": ["095311.260000"]},
        "1890": {"vr": "TM", "Value": ["095050.752500"]},
        "1891": {"vr": "TM", "Value": ["095026.842500"]},
        "1892": {"vr": "TM", "Value": ["095349.387500"]},
        "1893": {"vr": "TM", "Value": ["094541.875000"]},
        "1894": {"vr": "TM", "Value": ["095403.330000"]},
        "1895": {"vr": "TM", "Value": ["095349.680000"]},
        "1896": {"vr": "TM", "Value": ["095149.115000"]},
        "1897": {"vr": "TM", "Value": ["094749.465000"]},
        "1898": {"vr": "TM", "Value": ["095437.192500"]},
        "1899": {"vr": "TM", "Value": ["094540.100000"]},
        "1900": {"vr": "TM", "Value": ["094651.837500"]},
        "1901": {"vr": "TM", "Value": ["095400.675000"]},
        "1902": {"vr": "TM", "Value": ["094846.675000"]},
        "1903": {"vr": "TM", "Value": ["094741.542500"]},
        "1904": {"vr": "TM", "Value": ["094907.347500"]},
        "1905": {"vr": "TM", "Value": ["095229.162500"]},
        "1906": {"vr": "TM", "Value": ["094832.440000"]},
        "1907": {"vr": "TM", "Value": ["094846.822500"]},
        "1908": {"vr": "TM", "Value": ["094906.177500"]},
        "1909": {"vr": "TM", "Value": ["095316.382500"]},
        "1910": {"vr": "TM", "Value": ["094737.007500"]},
        "1911": {"vr": "TM", "Value": ["094600.645000"]},
        "1912": {"vr": "TM", "Value": ["094620.880000"]},
        "1913": {"vr": "TM", "Value": ["095241.330000"]},
        "1914": {"vr": "TM", "Value": ["095315.797500"]},
        "1915": {"vr": "TM", "Value": ["094513.845000"]},
        "1916": {"vr": "TM", "Value": ["095003.075000"]},
        "1917": {"vr": "TM", "Value": ["095226.822500"]},
        "1918": {"vr": "TM", "Value": ["095001.465000"]},
        "1919": {"vr": "TM", "Value": ["095442.187500"]},
        "1920": {"vr": "TM", "Value": ["094824.227500"]},
        "1921": {"vr": "TM", "Value": ["094846.382500"]},
        "1922": {"vr": "TM", "Value": ["094915.710000"]},
        "1923": {"vr": "TM", "Value": ["094910.422500"]},
        "1924": {"vr": "TM", "Value": ["094544.802500"]},
        "1925": {"vr": "TM", "Value": ["094758.997500"]},
        "1926": {"vr": "TM", "Value": ["095308.167500"]},
        "1927": {"vr": "TM", "Value": ["094916.587500"]},
        "1928": {"vr": "TM", "Value": ["094756.802500"]},
        "1929": {"vr": "TM", "Value": ["094940.352500"]},
        "1930": {"vr": "TM", "Value": ["095217.582500"]},
        "1931": {"vr": "TM", "Value": ["094904.860000"]},
        "1932": {"vr": "TM", "Value": ["095328.130000"]},
        "1933": {"vr": "TM", "Value": ["095139.875000"]},
        "1934": {"vr": "TM", "Value": ["094607.230000"]},
        "1935": {"vr": "TM", "Value": ["095335.152500"]},
        "1936": {"vr": "TM", "Value": ["094642.137500"]},
        "1937": {"vr": "TM", "Value": ["095215.807500"]},
        "1938": {"vr": "TM", "Value": ["095342.197500"]},
        "1939": {"vr": "TM", "Value": ["094930.822500"]},
        "1940": {"vr": "TM", "Value": ["094810.285000"]},
        "1941": {"vr": "TM", "Value": ["094830.685000"]},
        "1942": {"vr": "TM", "Value": ["095113.622500"]},
        "1943": {"vr": "TM", "Value": ["094616.930000"]},
        "1944": {"vr": "TM", "Value": ["095114.207500"]},
        "1945": {"vr": "TM", "Value": ["095147.065000"]},
        "1946": {"vr": "TM", "Value": ["094846.967500"]},
        "1947": {"vr": "TM", "Value": ["094852.530000"]},
        "1948": {"vr": "TM", "Value": ["095335.445000"]},
        "1949": {"vr": "TM", "Value": ["094649.035000"]},
        "1950": {"vr": "TM", "Value": ["095217.437500"]},
        "1951": {"vr": "TM", "Value": ["095046.637500"]},
        "1952": {"vr": "TM", "Value": ["095115.982500"]},
        "1953": {"vr": "TM", "Value": ["094937.992500"]},
        "1954": {"vr": "TM", "Value": ["094548.167500"]},
        "1955": {"vr": "TM", "Value": ["094711.632500"]},
        "1956": {"vr": "TM", "Value": ["095237.817500"]},
        "1957": {"vr": "TM", "Value": ["095016.577500"]},
        "1958": {"vr": "TM", "Value": ["095115.377500"]},
        "1959": {"vr": "TM", "Value": ["094931.992500"]},
        "1960": {"vr": "TM", "Value": ["094809.992500"]},
        "1961": {"vr": "TM", "Value": ["094507.845000"]},
        "1962": {"vr": "TM", "Value": ["095156.305000"]},
        "1963": {"vr": "TM", "Value": ["095122.715000"]},
        "1964": {"vr": "TM", "Value": ["094953.397500"]},
        "1965": {"vr": "TM", "Value": ["094851.797500"]},
        "1966": {"vr": "TM", "Value": ["095210.392500"]},
        "1967": {"vr": "TM", "Value": ["095451.135000"]},
        "1968": {"vr": "TM", "Value": ["095128.880000"]},
        "1969": {"vr": "TM", "Value": ["095432.510000"]},
        "1970": {"vr": "TM", "Value": ["094747.417500"]},
        "1971": {"vr": "TM", "Value": ["094843.875000"]},
        "1972": {"vr": "TM", "Value": ["095011.290000"]},
        "1973": {"vr": "TM", "Value": ["095447.475000"]},
        "1974": {"vr": "TM", "Value": ["094801.045000"]},
        "1975": {"vr": "TM", "Value": ["095257.027500"]},
        "1976": {"vr": "TM", "Value": ["094547.290000"]},
        "1977": {"vr": "TM", "Value": ["095011.730000"]},
        "1978": {"vr": "TM", "Value": ["094639.797500"]},
        "1979": {"vr": "TM", "Value": ["095208.782500"]},
        "1980": {"vr": "TM", "Value": ["094837.290000"]},
        "1981": {"vr": "TM", "Value": ["095057.777500"]},
        "1982": {"vr": "TM", "Value": ["095233.407500"]},
        "1983": {"vr": "TM", "Value": ["095008.655000"]},
        "1984": {"vr": "TM", "Value": ["094622.342500"]},
        "1985": {"vr": "TM", "Value": ["095008.217500"]},
        "1986": {"vr": "TM", "Value": ["095318.577500"]},
        "1987": {"vr": "TM", "Value": ["095426.490000"]},
        "1988": {"vr": "TM", "Value": ["094533.515000"]},
        "1989": {"vr": "TM", "Value": ["095009.535000"]},
        "1990": {"vr": "TM", "Value": ["095215.222500"]},
        "1991": {"vr": "TM", "Value": ["094919.807500"]},
        "1992": {"vr": "TM", "Value": ["094743.737500"]},
        "1993": {"vr": "TM", "Value": ["095002.635000"]},
        "1994": {"vr": "TM", "Value": ["095348.510000"]},
        "1995": {"vr": "TM", "Value": ["095408.745000"]},
        "1996": {"vr": "TM", "Value": ["094957.367500"]},
        "1997": {"vr": "TM", "Value": ["094553.310000"]},
        "1998": {"vr": "TM", "Value": ["095106.890000"]},
        "1999": {"vr": "TM", "Value": ["095127.710000"]},
        "2000": {"vr": "TM", "Value": ["095244.860000"]},
        "2001": {"vr": "TM", "Value": ["095450.257500"]},
        "2002": {"vr": "TM", "Value": ["095224.900000"]},
        "2003": {"vr": "TM", "Value": ["094534.245000"]},
        "2004": {"vr": "TM", "Value": ["095148.237500"]},
        "2005": {"vr": "TM", "Value": ["094636.432500"]},
        "2006": {"vr": "TM", "Value": ["094943.135000"]},
        "2007": {"vr": "TM", "Value": ["094602.547500"]},
        "2008": {"vr": "TM", "Value": ["094658.860000"]},
        "2009": {"vr": "TM", "Value": ["095440.285000"]},
        "2010": {"vr": "TM", "Value": ["094626.315000"]},
        "2011": {"vr": "TM", "Value": ["095343.807500"]},
        "2012": {"vr": "TM", "Value": ["094507.260000"]},
        "2013": {"vr": "TM", "Value": ["095300.245000"]},
        "2014": {"vr": "TM", "Value": ["094857.817500"]},
        "2015": {"vr": "TM", "Value": ["095235.330000"]},
        "2016": {"vr": "TM", "Value": ["095010.557500"]},
        "2017": {"vr": "TM", "Value": ["094956.345000"]},
        "2018": {"vr": "TM", "Value": ["095333.397500"]},
        "2019": {"vr": "TM", "Value": ["094952.520000"]},
        "2020": {"vr": "TM", "Value": ["095436.607500"]},
        "2021": {"vr": "TM", "Value": ["094834.050000"]},
        "2022": {"vr": "TM", "Value": ["095103.505000"]},
        "2023": {"vr": "TM", "Value": ["094814.695000"]},
        "2024": {"vr": "TM", "Value": ["095409.475000"]},
        "2025": {"vr": "TM", "Value": ["094650.645000"]},
        "2026": {"vr": "TM", "Value": ["095359.065000"]},
        "2027": {"vr": "TM", "Value": ["094755.777500"]},
        "2028": {"vr": "TM", "Value": ["095126.247500"]},
        "2029": {"vr": "TM", "Value": ["094650.207500"]},
        "2030": {"vr": "TM", "Value": ["095439.262500"]},
        "2031": {"vr": "TM", "Value": ["095018.042500"]},
        "2032": {"vr": "TM", "Value": ["094630.850000"]},
        "2033": {"vr": "TM", "Value": ["095427.367500"]},
        "2034": {"vr": "TM", "Value": ["095042.685000"]},
        "2035": {"vr": "TM", "Value": ["095007.192500"]},
        "2036": {"vr": "TM", "Value": ["094808.382500"]},
        "2037": {"vr": "TM", "Value": ["094734.645000"]},
        "2038": {"vr": "TM", "Value": ["095238.987500"]},
        "2039": {"vr": "TM", "Value": ["094954.130000"]},
        "2040": {"vr": "TM", "Value": ["094617.660000"]},
        "2041": {"vr": "TM", "Value": ["095108.940000"]},
        "2042": {"vr": "TM", "Value": ["094619.855000"]},
        "2043": {"vr": "TM", "Value": ["095254.392500"]},
        "2044": {"vr": "TM", "Value": ["094902.645000"]},
        "2045": {"vr": "TM", "Value": ["095055.290000"]},
        "2046": {"vr": "TM", "Value": ["094745.807500"]},
        "2047": {"vr": "TM", "Value": ["095433.827500"]},
        "2048": {"vr": "TM", "Value": ["094818.207500"]},
        "2049": {"vr": "TM", "Value": ["095010.705000"]},
        "2050": {"vr": "TM", "Value": ["094544.070000"]},
        "2051": {"vr": "TM", "Value": ["094909.397500"]},
        "2052": {"vr": "TM", "Value": ["094611.640000"]},
        "2053": {"vr": "TM", "Value": ["095209.807500"]},
        "2054": {"vr": "TM", "Value": ["094943.720000"]},
        "2055": {"vr": "TM", "Value": ["094839.340000"]},
        "2056": {"vr": "TM", "Value": ["095115.545000"]},
        "2057": {"vr": "TM", "Value": ["095410.645000"]},
        "2058": {"vr": "TM", "Value": ["095445.407500"]},
        "2059": {"vr": "TM", "Value": ["095341.612500"]},
        "2060": {"vr": "TM", "Value": ["094653.592500"]},
        "2061": {"vr": "TM", "Value": ["095037.250000"]},
        "2062": {"vr": "TM", "Value": ["094736.860000"]},
        "2063": {"vr": "TM", "Value": ["095050.900000"]},
        "2064": {"vr": "TM", "Value": ["095311.407500"]},
        "2065": {"vr": "TM", "Value": ["095404.792500"]},
        "2066": {"vr": "TM", "Value": ["095032.422500"]},
        "2067": {"vr": "TM", "Value": ["094844.460000"]},
        "2068": {"vr": "TM", "Value": ["094844.022500"]},
        "2069": {"vr": "TM", "Value": ["095347.777500"]},
        "2070": {"vr": "TM", "Value": ["095047.807500"]},
        "2071": {"vr": "TM", "Value": ["095224.460000"]},
        "2072": {"vr": "TM", "Value": ["095006.022500"]},
        "2073": {"vr": "TM", "Value": ["095120.957500"]},
        "2074": {"vr": "TM", "Value": ["094732.742500"]},
        "2075": {"vr": "TM", "Value": ["094821.740000"]},
        "2076": {"vr": "TM", "Value": ["095110.255000"]},
        "2077": {"vr": "TM", "Value": ["095305.972500"]},
        "2078": {"vr": "TM", "Value": ["094748.002500"]},
        "2079": {"vr": "TM", "Value": ["094825.690000"]},
        "2080": {"vr": "TM", "Value": ["094810.577500"]},
        "2081": {"vr": "TM", "Value": ["095351.875000"]},
        "2082": {"vr": "TM", "Value": ["094824.957500"]},
        "2083": {"vr": "TM", "Value": ["094957.515000"]},
        "2084": {"vr": "TM", "Value": ["094958.540000"]},
        "2085": {"vr": "TM", "Value": ["094723.357500"]},
        "2086": {"vr": "TM", "Value": ["095313.602500"]},
        "2087": {"vr": "TM", "Value": ["095408.305000"]},
        "2088": {"vr": "TM", "Value": ["095152.355000"]},
        "2089": {"vr": "TM", "Value": ["094747.710000"]},
        "2090": {"vr": "TM", "Value": ["095008.362500"]},
        "2091": {"vr": "TM", "Value": ["095043.125000"]},
        "2092": {"vr": "TM", "Value": ["095145.455000"]},
        "2093": {"vr": "TM", "Value": ["095441.310000"]},
        "2094": {"vr": "TM", "Value": ["095432.950000"]},
        "2095": {"vr": "TM", "Value": ["094853.260000"]},
        "2096": {"vr": "TM", "Value": ["094654.325000"]},
        "2097": {"vr": "TM", "Value": ["094657.690000"]},
        "2098": {"vr": "TM", "Value": ["094507.115000"]},
        "2099": {"vr": "TM", "Value": ["095251.592500"]},
        "2100": {"vr": "TM", "Value": ["095115.085000"]},
        "2101": {"vr": "TM", "Value": ["095248.372500"]},
        "2102": {"vr": "TM", "Value": ["094927.142500"]},
        "2103": {"vr": "TM", "Value": ["094517.377500"]},
        "2104": {"vr": "TM", "Value": ["095243.690000"]},
        "2105": {"vr": "TM", "Value": ["094547.727500"]},
        "2106": {"vr": "TM", "Value": ["094730.987500"]},
        "2107": {"vr": "TM", "Value": ["095101.162500"]},
        "2108": {"vr": "TM", "Value": ["094620.732500"]},
        "2109": {"vr": "TM", "Value": ["095310.237500"]},
        "2110": {"vr": "TM", "Value": ["095352.900000"]},
        "2111": {"vr": "TM", "Value": ["094653.885000"]},
        "2112": {"vr": "TM", "Value": ["094752.977500"]},
        "2113": {"vr": "TM", "Value": ["095021.115000"]},
        "2114": {"vr": "TM", "Value": ["095322.695000"]},
        "2115": {"vr": "TM", "Value": ["094545.240000"]},
        "2116": {"vr": "TM", "Value": ["095014.530000"]},
        "2117": {"vr": "TM", "Value": ["094809.552500"]},
        "2118": {"vr": "TM", "Value": ["094716.022500"]},
        "2119": {"vr": "TM", "Value": ["095040.345000"]},
        "2120": {"vr": "TM", "Value": ["095442.042500"]},
        "2121": {"vr": "TM", "Value": ["094636.577500"]},
        "2122": {"vr": "TM", "Value": ["094517.817500"]},
        "2123": {"vr": "TM", "Value": ["094633.192500"]},
        "2124": {"vr": "TM", "Value": ["094546.265000"]},
        "2125": {"vr": "TM", "Value": ["094808.967500"]},
        "2126": {"vr": "TM", "Value": ["094539.075000"]},
        "2127": {"vr": "TM", "Value": ["094913.807500"]},
        "2128": {"vr": "TM", "Value": ["095052.510000"]},
        "2129": {"vr": "TM", "Value": ["095355.407500"]},
        "2130": {"vr": "TM", "Value": ["094913.515000"]},
        "2131": {"vr": "TM", "Value": ["095413.740000"]},
        "2132": {"vr": "TM", "Value": ["095139.730000"]},
        "2133": {"vr": "TM", "Value": ["094606.937500"]},
        "2134": {"vr": "TM", "Value": ["094653.300000"]},
        "2135": {"vr": "TM", "Value": ["094723.065000"]},
        "2136": {"vr": "TM", "Value": ["094637.310000"]},
        "2137": {"vr": "TM", "Value": ["094828.930000"]},
        "2138": {"vr": "TM", "Value": ["094905.740000"]},
        "2139": {"vr": "TM", "Value": ["095008.802500"]},
        "2140": {"vr": "TM", "Value": ["095005.145000"]},
        "2141": {"vr": "TM", "Value": ["095109.525000"]},
        "2142": {"vr": "TM", "Value": ["094937.407500"]},
        "2143": {"vr": "TM", "Value": ["095436.315000"]},
        "2144": {"vr": "TM", "Value": ["095054.850000"]},
        "2145": {"vr": "TM", "Value": ["094742.860000"]},
        "2146": {"vr": "TM", "Value": ["095449.525000"]},
        "2147": {"vr": "TM", "Value": ["094628.802500"]},
        "2148": {"vr": "TM", "Value": ["094629.827500"]},
        "2149": {"vr": "TM", "Value": ["095409.767500"]},
        "2150": {"vr": "TM", "Value": ["095418.567500"]},
        "2151": {"vr": "TM", "Value": ["095018.335000"]},
        "2152": {"vr": "TM", "Value": ["094557.407500"]},
        "2153": {"vr": "TM", "Value": ["094726.137500"]},
        "2154": {"vr": "TM", "Value": ["095131.222500"]},
        "2155": {"vr": "TM", "Value": ["095050.315000"]},
        "2156": {"vr": "TM", "Value": ["095156.742500"]},
        "2157": {"vr": "TM", "Value": ["094948.860000"]},
        "2158": {"vr": "TM", "Value": ["095135.632500"]},
        "2159": {"vr": "TM", "Value": ["094952.812500"]},
        "2160": {"vr": "TM", "Value": ["094946.792500"]},
        "2161": {"vr": "TM", "Value": ["094706.490000"]},
        "2162": {"vr": "TM", "Value": ["094553.017500"]},
        "2163": {"vr": "TM", "Value": ["094931.847500"]},
        "2164": {"vr": "TM", "Value": ["095104.967500"]},
        "2165": {"vr": "TM", "Value": ["094819.690000"]},
        "2166": {"vr": "TM", "Value": ["094922.167500"]},
        "2167": {"vr": "TM", "Value": ["095116.275000"]},
        "2168": {"vr": "TM", "Value": ["095429.145000"]},
        "2169": {"vr": "TM", "Value": ["094745.660000"]},
        "2170": {"vr": "TM", "Value": ["095002.782500"]},
        "2171": {"vr": "TM", "Value": ["095418.715000"]},
        "2172": {"vr": "TM", "Value": ["094656.957500"]},
        "2173": {"vr": "TM", "Value": ["095240.157500"]},
        "2174": {"vr": "TM", "Value": ["095004.392500"]},
        "2175": {"vr": "TM", "Value": ["094800.315000"]},
        "2176": {"vr": "TM", "Value": ["095106.285000"]},
        "2177": {"vr": "TM", "Value": ["095444.675000"]},
        "2178": {"vr": "TM", "Value": ["094655.932500"]},
        "2179": {"vr": "TM", "Value": ["095112.157500"]},
        "2180": {"vr": "TM", "Value": ["094619.417500"]},
        "2181": {"vr": "TM", "Value": ["094730.110000"]},
        "2182": {"vr": "TM", "Value": ["095143.992500"]},
        "2183": {"vr": "TM", "Value": ["095329.007500"]},
        "2184": {"vr": "TM", "Value": ["095213.465000"]},
        "2185": {"vr": "TM", "Value": ["094951.347500"]},
        "2186": {"vr": "TM", "Value": ["095238.550000"]},
        "2187": {"vr": "TM", "Value": ["095446.745000"]},
        "2188": {"vr": "TM", "Value": ["095117.300000"]},
        "2189": {"vr": "TM", "Value": ["094750.490000"]},
        "2190": {"vr": "TM", "Value": ["094546.705000"]},
        "2191": {"vr": "TM", "Value": ["094637.895000"]},
        "2192": {"vr": "TM", "Value": ["094820.130000"]},
        "2193": {"vr": "TM", "Value": ["095251.737500"]},
        "2194": {"vr": "TM", "Value": ["094535.855000"]},
        "2195": {"vr": "TM", "Value": ["094900.597500"]},
        "2196": {"vr": "TM", "Value": ["095113.182500"]},
        "2197": {"vr": "TM", "Value": ["094949.592500"]},
        "2198": {"vr": "TM", "Value": ["095348.950000"]},
        "2199": {"vr": "TM", "Value": ["095239.720000"]},
        "2200": {"vr": "TM", "Value": ["094652.130000"]},
        "2201": {"vr": "TM", "Value": ["094753.145000"]},
        "2202": {"vr": "TM", "Value": ["095318.745000"]},
        "2203": {"vr": "TM", "Value": ["095200.715000"]},
        "2204": {"vr": "TM", "Value": ["095449.817500"]},
        "2205": {"vr": "TM", "Value": ["094559.767500"]},
        "2206": {"vr": "TM", "Value": ["095124.930000"]},
        "2207": {"vr": "TM", "Value": ["095056.022500"]},
        "2208": {"vr": "TM", "Value": ["095440.870000"]},
        "2209": {"vr": "TM", "Value": ["095257.612500"]},
        "2210": {"vr": "TM", "Value": ["094705.612500"]},
        "2211": {"vr": "TM", "Value": ["094541.142500"]},
        "2212": {"vr": "TM", "Value": ["095209.660000"]},
        "2213": {"vr": "TM", "Value": ["095207.445000"]},
        "2214": {"vr": "TM", "Value": ["094808.822500"]},
        "2215": {"vr": "TM", "Value": ["095308.022500"]},
        "2216": {"vr": "TM", "Value": ["095006.315000"]},
        "2217": {"vr": "TM", "Value": ["095153.377500"]},
        "2218": {"vr": "TM", "Value": ["094905.885000"]},
        "2219": {"vr": "TM", "Value": ["094712.947500"]},
        "2220": {"vr": "TM", "Value": ["094511.505000"]},
        "2221": {"vr": "TM", "Value": ["094637.747500"]},
        "2222": {"vr": "TM", "Value": ["095253.660000"]},
        "2223": {"vr": "TM", "Value": ["095039.592500"]},
        "2224": {"vr": "TM", "Value": ["094606.352500"]},
        "2225": {"vr": "TM", "Value": ["095048.977500"]},
        "2226": {"vr": "TM", "Value": ["094833.612500"]},
        "2227": {"vr": "TM", "Value": ["095400.967500"]},
        "2228": {"vr": "TM", "Value": ["094539.660000"]},
        "2229": {"vr": "TM", "Value": ["095411.377500"]},
        "2230": {"vr": "TM", "Value": ["095150.432500"]},
        "2231": {"vr": "TM", "Value": ["095230.187500"]},
        "2232": {"vr": "TM", "Value": ["095109.232500"]},
        "2233": {"vr": "TM", "Value": ["095444.822500"]},
        "2234": {"vr": "TM", "Value": ["095025.670000"]},
        "2235": {"vr": "TM", "Value": ["095201.447500"]},
        "2236": {"vr": "TM", "Value": ["095220.655000"]},
        "2237": {"vr": "TM", "Value": ["095104.822500"]},
        "2238": {"vr": "TM", "Value": ["095225.945000"]},
        "2239": {"vr": "TM", "Value": ["094648.742500"]},
        "2240": {"vr": "TM", "Value": ["094804.725000"]},
        "2241": {"vr": "TM", "Value": ["094642.285000"]},
        "2242": {"vr": "TM", "Value": ["095112.890000"]},
        "2243": {"vr": "TM", "Value": ["094608.275000"]},
        "2244": {"vr": "TM", "Value": ["094543.925000"]},
        "2245": {"vr": "TM", "Value": ["094918.635000"]},
        "2246": {"vr": "TM", "Value": ["094526.910000"]},
        "2247": {"vr": "TM", "Value": ["095102.335000"]},
        "2248": {"vr": "TM", "Value": ["094610.617500"]},
        "2249": {"vr": "TM", "Value": ["095327.982500"]},
        "2250": {"vr": "TM", "Value": ["095300.832500"]},
        "2251": {"vr": "TM", "Value": ["094703.125000"]},
        "2252": {"vr": "TM", "Value": ["094519.280000"]},
        "2253": {"vr": "TM", "Value": ["095328.860000"]},
        "2254": {"vr": "TM", "Value": ["095454.207500"]},
        "2255": {"vr": "TM", "Value": ["094814.547500"]},
        "2256": {"vr": "TM", "Value": ["095438.237500"]},
        "2257": {"vr": "TM", "Value": ["095158.792500"]},
        "2258": {"vr": "TM", "Value": ["094626.752500"]},
        "2259": {"vr": "TM", "Value": ["094645.377500"]},
        "2260": {"vr": "TM", "Value": ["095014.090000"]},
        "2261": {"vr": "TM", "Value": ["094745.952500"]},
        "2262": {"vr": "TM", "Value": ["095432.802500"]},
        "2263": {"vr": "TM", "Value": ["095314.772500"]},
        "2264": {"vr": "TM", "Value": ["095153.962500"]},
        "2265": {"vr": "TM", "Value": ["094936.822500"]},
        "2266": {"vr": "TM", "Value": ["095129.905000"]},
        "2267": {"vr": "TM", "Value": ["095415.642500"]},
        "2268": {"vr": "TM", "Value": ["095106.430000"]},
        "2269": {"vr": "TM", "Value": ["094625.437500"]},
        "2270": {"vr": "TM", "Value": ["095154.110000"]},
        "2271": {"vr": "TM", "Value": ["094812.645000"]},
        "2272": {"vr": "TM", "Value": ["095415.055000"]},
        "2273": {"vr": "TM", "Value": ["094858.402500"]},
        "2274": {"vr": "TM", "Value": ["095307.582500"]},
        "2275": {"vr": "TM", "Value": ["095030.060000"]},
        "2276": {"vr": "TM", "Value": ["095102.772500"]},
        "2277": {"vr": "TM", "Value": ["095017.602500"]},
        "2278": {"vr": "TM", "Value": ["095314.920000"]},
        "2279": {"vr": "TM", "Value": ["095430.167500"]},
        "2280": {"vr": "TM", "Value": ["094637.455000"]},
        "2281": {"vr": "TM", "Value": ["095221.242500"]},
        "2282": {"vr": "TM", "Value": ["094732.305000"]},
        "2283": {"vr": "TM", "Value": ["094743.007500"]},
        "2284": {"vr": "TM", "Value": ["094952.227500"]},
        "2285": {"vr": "TM", "Value": ["095253.222500"]},
        "2286": {"vr": "TM", "Value": ["095338.100000"]},
        "2287": {"vr": "TM", "Value": ["094510.187500"]},
        "2288": {"vr": "TM", "Value": ["095441.602500"]},
        "2289": {"vr": "TM", "Value": ["094529.105000"]},
        "2290": {"vr": "TM", "Value": ["094702.977500"]},
        "2291": {"vr": "TM", "Value": ["095138.997500"]},
        "2292": {"vr": "TM", "Value": ["095347.192500"]},
        "2293": {"vr": "TM", "Value": ["094715.582500"]},
        "2294": {"vr": "TM", "Value": ["095015.992500"]},
        "2295": {"vr": "TM", "Value": ["095000.147500"]},
        "2296": {"vr": "TM", "Value": ["095133.730000"]},
        "2297": {"vr": "TM", "Value": ["095351.145000"]},
        "2298": {"vr": "TM", "Value": ["095128.442500"]},
        "2299": {"vr": "TM", "Value": ["095424.735000"]},
        "2300": {"vr": "TM", "Value": ["095249.690000"]},
        "2301": {"vr": "TM", "Value": ["095121.250000"]},
        "2302": {"vr": "TM", "Value": ["094716.460000"]},
        "2303": {"vr": "TM", "Value": ["095144.870000"]},
        "2304": {"vr": "TM", "Value": ["095033.300000"]},
        "2305": {"vr": "TM", "Value": ["094518.547500"]},
        "2306": {"vr": "TM", "Value": ["094532.490000"]},
        "2307": {"vr": "TM", "Value": ["095207.300000"]},
        "2308": {"vr": "TM", "Value": ["095220.802500"]},
        "2309": {"vr": "TM", "Value": ["094924.802500"]},
        "2310": {"vr": "TM", "Value": ["094849.455000"]},
        "2311": {"vr": "TM", "Value": ["095202.910000"]},
        "2312": {"vr": "TM", "Value": ["095326.937500"]},
        "2313": {"vr": "TM", "Value": ["094506.675000"]},
        "2314": {"vr": "TM", "Value": ["094916.735000"]},
        "2315": {"vr": "TM", "Value": ["095442.480000"]},
        "2316": {"vr": "TM", "Value": ["094530.275000"]},
        "2317": {"vr": "TM", "Value": ["095219.192500"]},
        "2318": {"vr": "TM", "Value": ["095146.335000"]},
        "2319": {"vr": "TM", "Value": ["094742.715000"]},
        "2320": {"vr": "TM", "Value": ["094929.192500"]},
        "2321": {"vr": "TM", "Value": ["094753.875000"]},
        "2322": {"vr": "TM", "Value": ["094546.850000"]},
        "2323": {"vr": "TM", "Value": ["095339.125000"]},
        "2324": {"vr": "TM", "Value": ["095154.255000"]},
        "2325": {"vr": "TM", "Value": ["095421.367500"]},
        "2326": {"vr": "TM", "Value": ["094743.300000"]},
        "2327": {"vr": "TM", "Value": ["094925.680000"]},
        "2328": {"vr": "TM", "Value": ["094804.870000"]},
        "2329": {"vr": "TM", "Value": ["094907.935000"]},
        "2330": {"vr": "TM", "Value": ["095218.167500"]},
        "2331": {"vr": "TM", "Value": ["094711.485000"]},
        "2332": {"vr": "TM", "Value": ["095154.402500"]},
        "2333": {"vr": "TM", "Value": ["095114.060000"]},
        "2334": {"vr": "TM", "Value": ["095016.140000"]},
        "2335": {"vr": "TM", "Value": ["094836.685000"]},
        "2336": {"vr": "TM", "Value": ["094550.675000"]},
        "2337": {"vr": "TM", "Value": ["095131.952500"]},
        "2338": {"vr": "TM", "Value": ["094611.055000"]},
        "2339": {"vr": "TM", "Value": ["094754.167500"]},
        "2340": {"vr": "TM", "Value": ["095315.945000"]},
        "2341": {"vr": "TM", "Value": ["095045.320000"]},
        "2342": {"vr": "TM", "Value": ["095325.037500"]},
        "2343": {"vr": "TM", "Value": ["094856.352500"]},
        "2344": {"vr": "TM", "Value": ["094834.490000"]},
        "2345": {"vr": "TM", "Value": ["094909.690000"]},
        "2346": {"vr": "TM", "Value": ["095315.357500"]},
        "2347": {"vr": "TM", "Value": ["094658.567500"]},
        "2348": {"vr": "TM", "Value": ["095058.237500"]},
        "2349": {"vr": "TM", "Value": ["094722.772500"]},
        "2350": {"vr": "TM", "Value": ["094601.232500"]},
        "2351": {"vr": "TM", "Value": ["095147.650000"]},
        "2352": {"vr": "TM", "Value": ["094808.675000"]},
        "2353": {"vr": "TM", "Value": ["095342.050000"]},
        "2354": {"vr": "TM", "Value": ["094619.125000"]},
        "2355": {"vr": "TM", "Value": ["094522.352500"]},
        "2356": {"vr": "TM", "Value": ["094833.465000"]},
        "2357": {"vr": "TM", "Value": ["095427.952500"]},
        "2358": {"vr": "TM", "Value": ["094816.157500"]},
        "2359": {"vr": "TM", "Value": ["095314.187500"]},
        "2360": {"vr": "TM", "Value": ["094646.402500"]},
        "2361": {"vr": "TM", "Value": ["095439.407500"]},
        "2362": {"vr": "TM", "Value": ["095250.860000"]},
        "2363": {"vr": "TM", "Value": ["095431.925000"]},
        "2364": {"vr": "TM", "Value": ["095357.750000"]},
        "2365": {"vr": "TM", "Value": ["094556.675000"]},
        "2366": {"vr": "TM", "Value": ["094834.930000"]},
        "2367": {"vr": "TM", "Value": ["095043.417500"]},
        "2368": {"vr": "TM", "Value": ["095242.060000"]},
        "2369": {"vr": "TM", "Value": ["094509.017500"]},
        "2370": {"vr": "TM", "Value": ["094548.315000"]},
        "2371": {"vr": "TM", "Value": ["095047.075000"]},
        "2372": {"vr": "TM", "Value": ["094819.085000"]},
        "2373": {"vr": "TM", "Value": ["094618.392500"]},
        "2374": {"vr": "TM", "Value": ["094553.747500"]},
        "2375": {"vr": "TM", "Value": ["094947.545000"]},
        "2376": {"vr": "TM", "Value": ["094648.597500"]},
        "2377": {"vr": "TM", "Value": ["094538.927500"]},
        "2378": {"vr": "TM", "Value": ["095305.387500"]},
        "2379": {"vr": "TM", "Value": ["094614.275000"]},
        "2380": {"vr": "TM", "Value": ["095327.545000"]},
        "2381": {"vr": "TM", "Value": ["095140.167500"]},
        "2382": {"vr": "TM", "Value": ["095138.557500"]},
        "2383": {"vr": "TM", "Value": ["094903.982500"]},
        "2384": {"vr": "TM", "Value": ["094939.475000"]},
        "2385": {"vr": "TM", "Value": ["095001.320000"]},
        "2386": {"vr": "TM", "Value": ["095336.032500"]},
        "2387": {"vr": "TM", "Value": ["094732.890000"]},
        "2388": {"vr": "TM", "Value": ["095420.032500"]},
        "2389": {"vr": "TM", "Value": ["094553.455000"]},
        "2390": {"vr": "TM", "Value": ["095443.212500"]},
        "2391": {"vr": "TM", "Value": ["094744.177500"]},
        "2392": {"vr": "TM", "Value": ["094734.500000"]},
        "2393": {"vr": "TM", "Value": ["094542.900000"]},
        "2394": {"vr": "TM", "Value": ["095134.315000"]},
        "2395": {"vr": "TM", "Value": ["095340.442500"]},
        "2396": {"vr": "TM", "Value": ["094855.182500"]},
        "2397": {"vr": "TM", "Value": ["095335.300000"]},
        "2398": {"vr": "TM", "Value": ["095259.807500"]},
        "2399": {"vr": "TM", "Value": ["095359.797500"]},
        "2400": {"vr": "TM", "Value": ["095310.675000"]},
        "2401": {"vr": "TM", "Value": ["094841.240000"]},
        "2402": {"vr": "TM", "Value": ["095325.475000"]},
        "2403": {"vr": "TM", "Value": ["095214.930000"]},
        "2404": {"vr": "TM", "Value": ["095144.140000"]},
        "2405": {"vr": "TM", "Value": ["095157.915000"]},
        "2406": {"vr": "TM", "Value": ["094628.362500"]},
        "2407": {"vr": "TM", "Value": ["094803.260000"]},
        "2408": {"vr": "TM", "Value": ["094544.217500"]},
        "2409": {"vr": "TM", "Value": ["094846.237500"]},
        "2410": {"vr": "TM", "Value": ["095435.145000"]},
        "2411": {"vr": "TM", "Value": ["095113.475000"]},
        "2412": {"vr": "TM", "Value": ["095146.480000"]},
        "2413": {"vr": "TM", "Value": ["095249.397500"]},
        "2414": {"vr": "TM", "Value": ["095036.227500"]},
        "2415": {"vr": "TM", "Value": ["094607.377500"]},
        "2416": {"vr": "TM", "Value": ["094623.660000"]},
        "2417": {"vr": "TM", "Value": ["095453.475000"]},
        "2418": {"vr": "TM", "Value": ["095133.437500"]},
        "2419": {"vr": "TM", "Value": ["094752.830000"]},
        "2420": {"vr": "TM", "Value": ["095208.637500"]},
        "2421": {"vr": "TM", "Value": ["095156.450000"]},
        "2422": {"vr": "TM", "Value": ["095222.997500"]},
        "2423": {"vr": "TM", "Value": ["094531.737500"]},
        "2424": {"vr": "TM", "Value": ["094616.637500"]},
        "2425": {"vr": "TM", "Value": ["095107.622500"]},
        "2426": {"vr": "TM", "Value": ["094534.977500"]},
        "2427": {"vr": "TM", "Value": ["094740.665000"]},
        "2428": {"vr": "TM", "Value": ["095054.120000"]},
        "2429": {"vr": "TM", "Value": ["094923.925000"]},
        "2430": {"vr": "TM", "Value": ["094911.007500"]},
        "2431": {"vr": "TM", "Value": ["094537.172500"]},
        "2432": {"vr": "TM", "Value": ["094540.245000"]},
        "2433": {"vr": "TM", "Value": ["094822.032500"]},
        "2434": {"vr": "TM", "Value": ["094805.455000"]},
        "2435": {"vr": "TM", "Value": ["095402.140000"]},
        "2436": {"vr": "TM", "Value": ["094657.397500"]},
        "2437": {"vr": "TM", "Value": ["095130.637500"]},
        "2438": {"vr": "TM", "Value": ["094613.105000"]},
        "2439": {"vr": "TM", "Value": ["095121.837500"]},
        "2440": {"vr": "TM", "Value": ["095055.875000"]},
        "2441": {"vr": "TM", "Value": ["095334.275000"]},
        "2442": {"vr": "TM", "Value": ["095159.377500"]},
        "2443": {"vr": "TM", "Value": ["095240.890000"]},
        "2444": {"vr": "TM", "Value": ["095103.357500"]},
        "2445": {"vr": "TM", "Value": ["095158.060000"]},
        "2446": {"vr": "TM", "Value": ["094626.167500"]},
        "2447": {"vr": "TM", "Value": ["094925.972500"]},
        "2448": {"vr": "TM", "Value": ["095341.757500"]},
        "2449": {"vr": "TM", "Value": ["094540.392500"]},
        "2450": {"vr": "TM", "Value": ["095210.100000"]},
        "2451": {"vr": "TM", "Value": ["095024.500000"]},
        "2452": {"vr": "TM", "Value": ["094600.500000"]},
        "2453": {"vr": "TM", "Value": ["094918.342500"]},
        "2454": {"vr": "TM", "Value": ["095422.247500"]},
        "2455": {"vr": "TM", "Value": ["094739.495000"]},
        "2456": {"vr": "TM", "Value": ["095017.310000"]},
        "2457": {"vr": "TM", "Value": ["095011.875000"]},
        "2458": {"vr": "TM", "Value": ["095019.505000"]},
        "2459": {"vr": "TM", "Value": ["095425.465000"]},
        "2460": {"vr": "TM", "Value": ["094830.540000"]},
        "2461": {"vr": "TM", "Value": ["094754.022500"]},
        "2462": {"vr": "TM", "Value": ["095229.017500"]},
        "2463": {"vr": "TM", "Value": ["095355.555000"]},
        "2464": {"vr": "TM", "Value": ["095258.197500"]},
        "2465": {"vr": "TM", "Value": ["095142.822500"]},
        "2466": {"vr": "TM", "Value": ["094911.885000"]},
        "2467": {"vr": "TM", "Value": ["095024.207500"]},
        "2468": {"vr": "TM", "Value": ["095302.315000"]},
        "2469": {"vr": "TM", "Value": ["094941.670000"]},
        "2470": {"vr": "TM", "Value": ["094656.520000"]},
        "2471": {"vr": "TM", "Value": ["095126.977500"]},
        "2472": {"vr": "TM", "Value": ["094940.792500"]},
        "2473": {"vr": "TM", "Value": ["094806.480000"]},
        "2474": {"vr": "TM", "Value": ["094523.085000"]},
        "2475": {"vr": "TM", "Value": ["095128.587500"]},
        "2476": {"vr": "TM", "Value": ["095113.767500"]},
        "2477": {"vr": "TM", "Value": ["095427.222500"]},
        "2478": {"vr": "TM", "Value": ["094622.782500"]},
        "2479": {"vr": "TM", "Value": ["094644.207500"]},
        "2480": {"vr": "TM", "Value": ["095313.895000"]},
        "2481": {"vr": "TM", "Value": ["095334.860000"]},
        "2482": {"vr": "TM", "Value": ["094841.827500"]},
        "2483": {"vr": "TM", "Value": ["095325.915000"]},
        "2484": {"vr": "TM", "Value": ["094611.347500"]},
        "2485": {"vr": "TM", "Value": ["094807.357500"]},
        "2486": {"vr": "TM", "Value": ["094805.162500"]},
        "2487": {"vr": "TM", "Value": ["095309.632500"]},
        "2488": {"vr": "TM", "Value": ["095428.540000"]},
        "2489": {"vr": "TM", "Value": ["095417.397500"]},
        "2490": {"vr": "TM", "Value": ["095206.130000"]},
        "2491": {"vr": "TM", "Value": ["094624.100000"]},
        "2492": {"vr": "TM", "Value": ["095020.530000"]},
        "2493": {"vr": "TM", "Value": ["095100.432500"]},
        "2494": {"vr": "TM", "Value": ["095419.592500"]},
        "2495": {"vr": "TM", "Value": ["094813.670000"]},
        "2496": {"vr": "TM", "Value": ["094701.807500"]},
        "2497": {"vr": "TM", "Value": ["095325.330000"]},
        "2498": {"vr": "TM", "Value": ["095148.090000"]},
        "2499": {"vr": "TM", "Value": ["094843.435000"]},
        "2500": {"vr": "TM", "Value": ["095343.660000"]},
        "2501": {"vr": "TM", "Value": ["094934.187500"]},
        "2502": {"vr": "TM", "Value": ["094604.305000"]},
        "2503": {"vr": "TM", "Value": ["095308.460000"]},
        "2504": {"vr": "TM", "Value": ["094710.752500"]},
        "2505": {"vr": "TM", "Value": ["095145.747500"]},
        "2506": {"vr": "TM", "Value": ["094850.335000"]},
        "2507": {"vr": "TM", "Value": ["095126.540000"]},
        "2508": {"vr": "TM", "Value": ["095056.752500"]},
        "2509": {"vr": "TM", "Value": ["094725.845000"]},
        "2510": {"vr": "TM", "Value": ["095216.977500"]},
        "2511": {"vr": "TM", "Value": ["094856.647500"]},
        "2512": {"vr": "TM", "Value": ["095051.925000"]},
        "2513": {"vr": "TM", "Value": ["095413.300000"]},
        "2514": {"vr": "TM", "Value": ["094811.037500"]},
        "2515": {"vr": "TM", "Value": ["094557.992500"]},
        "2516": {"vr": "TM", "Value": ["094551.700000"]},
        "2517": {"vr": "TM", "Value": ["095345.145000"]},
        "2518": {"vr": "TM", "Value": ["094922.900000"]},
        "2519": {"vr": "TM", "Value": ["094838.022500"]},
        "2520": {"vr": "TM", "Value": ["095137.535000"]},
        "2521": {"vr": "TM", "Value": ["095308.607500"]},
        "2522": {"vr": "TM", "Value": ["095448.355000"]},
        "2523": {"vr": "TM", "Value": ["094608.715000"]},
        "2524": {"vr": "TM", "Value": ["095029.037500"]},
        "2525": {"vr": "TM", "Value": ["095452.305000"]},
        "2526": {"vr": "TM", "Value": ["094803.407500"]},
        "2527": {"vr": "TM", "Value": ["094802.090000"]},
        "2528": {"vr": "TM", "Value": ["095326.792500"]},
        "2529": {"vr": "TM", "Value": ["094835.222500"]},
        "2530": {"vr": "TM", "Value": ["095251.885000"]},
        "2531": {"vr": "TM", "Value": ["095229.750000"]},
        "2532": {"vr": "TM", "Value": ["095051.485000"]},
        "2533": {"vr": "TM", "Value": ["094545.387500"]},
        "2534": {"vr": "TM", "Value": ["095141.485000"]},
        "2535": {"vr": "TM", "Value": ["095101.017500"]},
        "2536": {"vr": "TM", "Value": ["094920.537500"]},
        "2537": {"vr": "TM", "Value": ["095004.100000"]},
        "2538": {"vr": "TM", "Value": ["095150.890000"]},
        "2539": {"vr": "TM", "Value": ["095447.330000"]},
        "2540": {"vr": "TM", "Value": ["095438.675000"]},
        "2541": {"vr": "TM", "Value": ["095018.187500"]},
        "2542": {"vr": "TM", "Value": ["094816.012500"]},
        "2543": {"vr": "TM", "Value": ["095230.772500"]},
        "2544": {"vr": "TM", "Value": ["094633.045000"]},
        "2545": {"vr": "TM", "Value": ["095054.557500"]},
        "2546": {"vr": "TM", "Value": ["095134.900000"]},
        "2547": {"vr": "TM", "Value": ["094658.127500"]},
        "2548": {"vr": "TM", "Value": ["094821.445000"]},
        "2549": {"vr": "TM", "Value": ["095017.895000"]},
        "2550": {"vr": "TM", "Value": ["095404.062500"]},
        "2551": {"vr": "TM", "Value": ["095246.470000"]},
        "2552": {"vr": "TM", "Value": ["095431.777500"]},
        "2553": {"vr": "TM", "Value": ["094606.500000"]},
        "2554": {"vr": "TM", "Value": ["094800.167500"]},
        "2555": {"vr": "TM", "Value": ["095112.450000"]},
        "2556": {"vr": "TM", "Value": ["095349.095000"]},
        "2557": {"vr": "TM", "Value": ["095315.650000"]},
        "2558": {"vr": "TM", "Value": ["095040.030000"]},
        "2559": {"vr": "TM", "Value": ["095323.135000"]},
        "2560": {"vr": "TM", "Value": ["095414.032500"]},
        "2561": {"vr": "TM", "Value": ["094915.562500"]},
        "2562": {"vr": "TM", "Value": ["095116.422500"]},
        "2563": {"vr": "TM", "Value": ["094842.412500"]},
        "2564": {"vr": "TM", "Value": ["094729.525000"]},
        "2565": {"vr": "TM", "Value": ["095334.130000"]},
        "2566": {"vr": "TM", "Value": ["095224.167500"]},
        "2567": {"vr": "TM", "Value": ["095132.100000"]},
        "2568": {"vr": "TM", "Value": ["095420.930000"]},
        "2569": {"vr": "TM", "Value": ["094635.407500"]},
        "2570": {"vr": "TM", "Value": ["095409.182500"]},
        "2571": {"vr": "TM", "Value": ["094647.865000"]},
        "2572": {"vr": "TM", "Value": ["095454.940000"]},
        "2573": {"vr": "TM", "Value": ["094543.777500"]},
        "2574": {"vr": "TM", "Value": ["095116.860000"]},
        "2575": {"vr": "TM", "Value": ["094612.520000"]},
        "2576": {"vr": "TM", "Value": ["095238.695000"]},
        "2577": {"vr": "TM", "Value": ["094805.017500"]},
        "2578": {"vr": "TM", "Value": ["094525.007500"]},
        "2579": {"vr": "TM", "Value": ["094515.330000"]},
        "2580": {"vr": "TM", "Value": ["095445.260000"]},
        "2581": {"vr": "TM", "Value": ["095010.265000"]},
        "2582": {"vr": "TM", "Value": ["095013.630000"]},
        "2583": {"vr": "TM", "Value": ["094909.835000"]},
        "2584": {"vr": "TM", "Value": ["094826.275000"]},
        "2585": {"vr": "TM", "Value": ["095317.992500"]},
        "2586": {"vr": "TM", "Value": ["095124.177500"]},
        "2587": {"vr": "TM", "Value": ["095222.120000"]},
        "2588": {"vr": "TM", "Value": ["094521.035000"]},
        "2589": {"vr": "TM", "Value": ["095444.530000"]},
        "2590": {"vr": "TM", "Value": ["095105.407500"]},
        "2591": {"vr": "TM", "Value": ["095403.915000"]},
        "2592": {"vr": "TM", "Value": ["094852.822500"]},
        "2593": {"vr": "TM", "Value": ["094920.977500"]},
        "2594": {"vr": "TM", "Value": ["094753.730000"]},
        "2595": {"vr": "TM", "Value": ["095346.022500"]},
        "2596": {"vr": "TM", "Value": ["094801.630000"]},
        "2597": {"vr": "TM", "Value": ["095424.150000"]},
        "2598": {"vr": "TM", "Value": ["094745.075000"]},
        "2599": {"vr": "TM", "Value": ["095102.920000"]},
        "2600": {"vr": "TM", "Value": ["095237.377500"]},
        "2601": {"vr": "TM", "Value": ["095321.670000"]},
        "2602": {"vr": "TM", "Value": ["094928.607500"]},
        "2603": {"vr": "TM", "Value": ["095237.962500"]},
        "2604": {"vr": "TM", "Value": ["095342.930000"]},
        "2605": {"vr": "TM", "Value": ["095158.207500"]},
        "2606": {"vr": "TM", "Value": ["095254.247500"]},
        "2607": {"vr": "TM", "Value": ["095158.937500"]},
        "2608": {"vr": "TM", "Value": ["095429.437500"]},
        "2609": {"vr": "TM", "Value": ["095134.022500"]},
        "2610": {"vr": "TM", "Value": ["094751.367500"]},
        "2611": {"vr": "TM", "Value": ["094822.177500"]},
        "2612": {"vr": "TM", "Value": ["094711.777500"]},
        "2613": {"vr": "TM", "Value": ["094610.325000"]},
        "2614": {"vr": "TM", "Value": ["095127.125000"]},
        "2615": {"vr": "TM", "Value": ["095341.320000"]},
        "2616": {"vr": "TM", "Value": ["094754.315000"]},
        "2617": {"vr": "TM", "Value": ["095206.422500"]},
        "2618": {"vr": "TM", "Value": ["095137.972500"]},
        "2619": {"vr": "TM", "Value": ["094910.567500"]},
        "2620": {"vr": "TM", "Value": ["094749.027500"]},
        "2621": {"vr": "TM", "Value": ["095023.767500"]},
        "2622": {"vr": "TM", "Value": ["095347.047500"]},
        "2623": {"vr": "TM", "Value": ["095320.060000"]},
        "2624": {"vr": "TM", "Value": ["095319.475000"]},
        "2625": {"vr": "TM", "Value": ["094839.777500"]},
        "2626": {"vr": "TM", "Value": ["095440.725000"]},
        "2627": {"vr": "TM", "Value": ["095309.045000"]},
        "2628": {"vr": "TM", "Value": ["095448.207500"]},
        "2629": {"vr": "TM", "Value": ["094650.352500"]},
        "2630": {"vr": "TM", "Value": ["094939.182500"]},
        "2631": {"vr": "TM", "Value": ["094928.752500"]},
        "2632": {"vr": "TM", "Value": ["094712.655000"]},
        "2633": {"vr": "TM", "Value": ["094953.982500"]},
        "2634": {"vr": "TM", "Value": ["094836.392500"]},
        "2635": {"vr": "TM", "Value": ["094534.832500"]},
        "2636": {"vr": "TM", "Value": ["095314.627500"]},
        "2637": {"vr": "TM", "Value": ["094936.530000"]},
        "2638": {"vr": "TM", "Value": ["094525.737500"]},
        "2639": {"vr": "TM", "Value": ["095135.485000"]},
        "2640": {"vr": "TM", "Value": ["094512.527500"]},
        "2641": {"vr": "TM", "Value": ["094625.145000"]},
        "2642": {"vr": "TM", "Value": ["094908.812500"]},
        "2643": {"vr": "TM", "Value": ["095442.627500"]},
        "2644": {"vr": "TM", "Value": ["095049.730000"]},
        "2645": {"vr": "TM", "Value": ["095306.997500"]},
        "2646": {"vr": "TM", "Value": ["095029.622500"]},
        "2647": {"vr": "TM", "Value": ["095208.930000"]},
        "2648": {"vr": "TM", "Value": ["095128.295000"]},
        "2649": {"vr": "TM", "Value": ["094704.880000"]},
        "2650": {"vr": "TM", "Value": ["094731.572500"]},
        "2651": {"vr": "TM", "Value": ["094819.230000"]},
        "2652": {"vr": "TM", "Value": ["094634.530000"]},
        "2653": {"vr": "TM", "Value": ["095410.207500"]},
        "2654": {"vr": "TM", "Value": ["095254.540000"]},
        "2655": {"vr": "TM", "Value": ["094539.952500"]},
        "2656": {"vr": "TM", "Value": ["094623.952500"]},
        "2657": {"vr": "TM", "Value": ["094740.520000"]},
        "2658": {"vr": "TM", "Value": ["095454.352500"]},
        "2659": {"vr": "TM", "Value": ["094842.120000"]},
        "2660": {"vr": "TM", "Value": ["095153.525000"]},
        "2661": {"vr": "TM", "Value": ["095331.642500"]},
        "2662": {"vr": "TM", "Value": ["095405.670000"]},
        "2663": {"vr": "TM", "Value": ["094555.505000"]},
        "2664": {"vr": "TM", "Value": ["094609.300000"]},
        "2665": {"vr": "TM", "Value": ["094616.030000"]},
        "2666": {"vr": "TM", "Value": ["095329.155000"]},
        "2667": {"vr": "TM", "Value": ["094746.540000"]},
        "2668": {"vr": "TM", "Value": ["094602.840000"]},
        "2669": {"vr": "TM", "Value": ["094630.120000"]},
        "2670": {"vr": "TM", "Value": ["094924.362500"]},
        "2671": {"vr": "TM", "Value": ["094837.582500"]},
        "2672": {"vr": "TM", "Value": ["095243.232500"]},
        "2673": {"vr": "TM", "Value": ["094656.372500"]},
        "2674": {"vr": "TM", "Value": ["094606.792500"]},
        "2675": {"vr": "TM", "Value": ["094623.807500"]},
        "2676": {"vr": "TM", "Value": ["094600.060000"]},
        "2677": {"vr": "TM", "Value": ["094928.167500"]},
        "2678": {"vr": "TM", "Value": ["095244.275000"]},
        "2679": {"vr": "TM", "Value": ["095002.930000"]},
        "2680": {"vr": "TM", "Value": ["094514.577500"]},
        "2681": {"vr": "TM", "Value": ["095205.690000"]},
        "2682": {"vr": "TM", "Value": ["095020.967500"]},
        "2683": {"vr": "TM", "Value": ["095219.925000"]},
        "2684": {"vr": "TM", "Value": ["094909.542500"]},
        "2685": {"vr": "TM", "Value": ["095131.515000"]},
        "2686": {"vr": "TM", "Value": ["094712.217500"]},
        "2687": {"vr": "TM", "Value": ["095047.952500"]},
        "2688": {"vr": "TM", "Value": ["095059.847500"]},
        "2689": {"vr": "TM", "Value": ["094834.782500"]},
        "2690": {"vr": "TM", "Value": ["094915.270000"]},
        "2691": {"vr": "TM", "Value": ["094630.265000"]},
        "2692": {"vr": "TM", "Value": ["094640.090000"]},
        "2693": {"vr": "TM", "Value": ["095100.577500"]},
        "2694": {"vr": "TM", "Value": ["095242.645000"]},
        "2695": {"vr": "TM", "Value": ["095212.880000"]},
        "2696": {"vr": "TM", "Value": ["094619.270000"]},
        "2697": {"vr": "TM", "Value": ["095406.987500"]},
        "2698": {"vr": "TM", "Value": ["095101.455000"]},
        "2699": {"vr": "TM", "Value": ["094719.552500"]},
        "2700": {"vr": "TM", "Value": ["094532.637500"]},
        "2701": {"vr": "TM", "Value": ["094857.232500"]},
        "2702": {"vr": "TM", "Value": ["094828.030000"]},
        "2703": {"vr": "TM", "Value": ["095422.685000"]},
        "2704": {"vr": "TM", "Value": ["094900.012500"]},
        "2705": {"vr": "TM", "Value": ["094551.552500"]},
        "2706": {"vr": "TM", "Value": ["094659.445000"]},
        "2707": {"vr": "TM", "Value": ["095358.627500"]},
        "2708": {"vr": "TM", "Value": ["095336.930000"]},
        "2709": {"vr": "TM", "Value": ["095308.900000"]},
        "2710": {"vr": "TM", "Value": ["095107.037500"]},
        "2711": {"vr": "TM", "Value": ["094603.865000"]},
        "2712": {"vr": "TM", "Value": ["094847.407500"]},
        "2713": {"vr": "TM", "Value": ["095423.710000"]},
        "2714": {"vr": "TM", "Value": ["095327.377500"]},
        "2715": {"vr": "TM", "Value": ["095048.245000"]},
        "2716": {"vr": "TM", "Value": ["095054.265000"]},
        "2717": {"vr": "TM", "Value": ["094839.192500"]},
        "2718": {"vr": "TM", "Value": ["094519.865000"]},
        "2719": {"vr": "TM", "Value": ["095034.032500"]},
        "2720": {"vr": "TM", "Value": ["094828.345000"]},
        "2721": {"vr": "TM", "Value": ["095405.377500"]},
        "2722": {"vr": "TM", "Value": ["094835.515000"]},
        "2723": {"vr": "TM", "Value": ["095438.967500"]},
        "2724": {"vr": "TM", "Value": ["095240.012500"]},
        "2725": {"vr": "TM", "Value": ["095226.967500"]},
        "2726": {"vr": "TM", "Value": ["095312.725000"]},
        "2727": {"vr": "TM", "Value": ["094910.715000"]},
        "2728": {"vr": "TM", "Value": ["094723.942500"]},
        "2729": {"vr": "TM", "Value": ["094920.830000"]},
        "2730": {"vr": "TM", "Value": ["095036.957500"]},
        "2731": {"vr": "TM", "Value": ["094850.040000"]},
        "2732": {"vr": "TM", "Value": ["095431.047500"]},
        "2733": {"vr": "TM", "Value": ["095359.357500"]},
        "2734": {"vr": "TM", "Value": ["094920.685000"]},
        "2735": {"vr": "TM", "Value": ["094628.655000"]},
        "2736": {"vr": "TM", "Value": ["095002.050000"]},
        "2737": {"vr": "TM", "Value": ["094912.782500"]},
        "2738": {"vr": "TM", "Value": ["094519.720000"]},
        "2739": {"vr": "TM", "Value": ["095035.202500"]},
        "2740": {"vr": "TM", "Value": ["094742.422500"]},
        "2741": {"vr": "TM", "Value": ["095449.377500"]},
        "2742": {"vr": "TM", "Value": ["095440.577500"]},
        "2743": {"vr": "TM", "Value": ["095400.090000"]},
        "2744": {"vr": "TM", "Value": ["095152.500000"]},
        "2745": {"vr": "TM", "Value": ["094527.055000"]},
        "2746": {"vr": "TM", "Value": ["095136.217500"]},
        "2747": {"vr": "TM", "Value": ["095245.740000"]},
        "2748": {"vr": "TM", "Value": ["095048.537500"]},
        "2749": {"vr": "TM", "Value": ["094836.537500"]},
        "2750": {"vr": "TM", "Value": ["094644.060000"]},
        "2751": {"vr": "TM", "Value": ["095227.407500"]},
        "2752": {"vr": "TM", "Value": ["094722.335000"]},
        "2753": {"vr": "TM", "Value": ["094521.182500"]},
        "2754": {"vr": "TM", "Value": ["095358.042500"]},
        "2755": {"vr": "TM", "Value": ["094725.260000"]},
        "2756": {"vr": "TM", "Value": ["095322.842500"]},
        "2757": {"vr": "TM", "Value": ["094822.617500"]},
        "2758": {"vr": "TM", "Value": ["094559.037500"]},
        "2759": {"vr": "TM", "Value": ["094636.140000"]},
        "2760": {"vr": "TM", "Value": ["095052.070000"]},
        "2761": {"vr": "TM", "Value": ["094911.445000"]},
        "2762": {"vr": "TM", "Value": ["095125.367500"]},
        "2763": {"vr": "TM", "Value": ["094659.885000"]},
        "2764": {"vr": "TM", "Value": ["094601.962500"]},
        "2765": {"vr": "TM", "Value": ["094956.490000"]},
        "2766": {"vr": "TM", "Value": ["094732.012500"]},
        "2767": {"vr": "TM", "Value": ["095007.047500"]},
        "2768": {"vr": "TM", "Value": ["095126.392500"]},
        "2769": {"vr": "TM", "Value": ["094621.320000"]},
        "2770": {"vr": "TM", "Value": ["095134.755000"]},
        "2771": {"vr": "TM", "Value": ["094536.440000"]},
        "2772": {"vr": "TM", "Value": ["094625.875000"]},
        "2773": {"vr": "TM", "Value": ["095332.665000"]},
        "2774": {"vr": "TM", "Value": ["094912.490000"]},
        "2775": {"vr": "TM", "Value": ["094516.060000"]},
        "2776": {"vr": "TM", "Value": ["094613.690000"]},
        "2777": {"vr": "TM", "Value": ["095138.705000"]},
        "2778": {"vr": "TM", "Value": ["095006.460000"]},
        "2779": {"vr": "TM", "Value": ["095232.237500"]},
        "2780": {"vr": "TM", "Value": ["095039.885000"]},
        "2781": {"vr": "TM", "Value": ["095448.940000"]},
        "2782": {"vr": "TM", "Value": ["094708.100000"]},
        "2783": {"vr": "TM", "Value": ["094620.295000"]},
        "2784": {"vr": "TM", "Value": ["094903.377500"]},
        "2785": {"vr": "TM", "Value": ["095005.875000"]},
        "2786": {"vr": "TM", "Value": ["094940.060000"]},
        "2787": {"vr": "TM", "Value": ["095413.885000"]},
        "2788": {"vr": "TM", "Value": ["095053.680000"]},
        "2789": {"vr": "TM", "Value": ["095125.955000"]},
        "2790": {"vr": "TM", "Value": ["094711.925000"]},
        "2791": {"vr": "TM", "Value": ["095200.275000"]},
        "2792": {"vr": "TM", "Value": ["095312.577500"]},
        "2793": {"vr": "TM", "Value": ["095234.745000"]},
        "2794": {"vr": "TM", "Value": ["094803.552500"]},
        "2795": {"vr": "TM", "Value": ["094731.135000"]},
        "2796": {"vr": "TM", "Value": ["095031.230000"]},
        "2797": {"vr": "TM", "Value": ["095140.607500"]},
        "2798": {"vr": "TM", "Value": ["095222.557500"]},
        "2799": {"vr": "TM", "Value": ["095327.837500"]},
        "2800": {"vr": "TM", "Value": ["095143.407500"]},
        "2801": {"vr": "TM", "Value": ["094850.187500"]},
        "2802": {"vr": "TM", "Value": ["095403.182500"]},
        "2803": {"vr": "TM", "Value": ["094931.700000"]},
        "2804": {"vr": "TM", "Value": ["095036.520000"]},
        "2805": {"vr": "TM", "Value": ["095119.642500"]},
        "2806": {"vr": "TM", "Value": ["094634.090000"]},
        "2807": {"vr": "TM", "Value": ["095414.762500"]},
        "2808": {"vr": "TM", "Value": ["095357.310000"]},
        "2809": {"vr": "TM", "Value": ["094903.545000"]},
        "2810": {"vr": "TM", "Value": ["095030.207500"]},
        "2811": {"vr": "TM", "Value": ["095446.432500"]},
        "2812": {"vr": "TM", "Value": ["094932.432500"]},
        "2813": {"vr": "TM", "Value": ["094740.957500"]},
        "2814": {"vr": "TM", "Value": ["094555.065000"]},
        "2815": {"vr": "TM", "Value": ["095035.347500"]},
        "2816": {"vr": "TM", "Value": ["094702.245000"]},
        "2817": {"vr": "TM", "Value": ["095108.647500"]},
        "2818": {"vr": "TM", "Value": ["094822.910000"]},
        "2819": {"vr": "TM", "Value": ["095354.382500"]},
        "2820": {"vr": "TM", "Value": ["094940.500000"]},
        "2821": {"vr": "TM", "Value": ["095357.017500"]},
        "2822": {"vr": "TM", "Value": ["095133.290000"]},
        "2823": {"vr": "TM", "Value": ["095344.392500"]},
        "2824": {"vr": "TM", "Value": ["095344.977500"]},
        "2825": {"vr": "TM", "Value": ["094818.645000"]},
        "2826": {"vr": "TM", "Value": ["094551.407500"]},
        "2827": {"vr": "TM", "Value": ["094721.895000"]},
        "2828": {"vr": "TM", "Value": ["095406.842500"]},
        "2829": {"vr": "TM", "Value": ["095252.490000"]},
        "2830": {"vr": "TM", "Value": ["095004.685000"]},
        "2831": {"vr": "TM", "Value": ["095326.500000"]},
        "2832": {"vr": "TM", "Value": ["095053.972500"]},
        "2833": {"vr": "TM", "Value": ["094933.895000"]},
        "2834": {"vr": "TM", "Value": ["095113.037500"]},
        "2835": {"vr": "TM", "Value": ["094855.915000"]},
        "2836": {"vr": "TM", "Value": ["095056.167500"]},
        "2837": {"vr": "TM", "Value": ["094657.542500"]},
        "2838": {"vr": "TM", "Value": ["094816.742500"]},
        "2839": {"vr": "TM", "Value": ["095028.450000"]},
        "2840": {"vr": "TM", "Value": ["094925.827500"]},
        "2841": {"vr": "TM", "Value": ["095237.232500"]},
        "2842": {"vr": "TM", "Value": ["095232.530000"]},
        "2843": {"vr": "TM", "Value": ["094929.045000"]},
        "2844": {"vr": "TM", "Value": ["094733.182500"]},
        "2845": {"vr": "TM", "Value": ["094811.182500"]},
        "2846": {"vr": "TM", "Value": ["094743.152500"]},
        "2847": {"vr": "TM", "Value": ["095324.305000"]},
        "2848": {"vr": "TM", "Value": ["095428.832500"]},
        "2849": {"vr": "TM", "Value": ["095304.950000"]},
        "2850": {"vr": "TM", "Value": ["095130.930000"]},
        "2851": {"vr": "TM", "Value": ["095227.115000"]},
        "2852": {"vr": "TM", "Value": ["094956.637500"]},
        "2853": {"vr": "TM", "Value": ["094718.530000"]},
        "2854": {"vr": "TM", "Value": ["094802.382500"]},
        "2855": {"vr": "TM", "Value": ["094506.382500"]},
        "2856": {"vr": "TM", "Value": ["094857.525000"]},
        "2857": {"vr": "TM", "Value": ["094805.310000"]},
        "2858": {"vr": "TM", "Value": ["094850.772500"]},
        "2859": {"vr": "TM", "Value": ["095214.490000"]},
        "2860": {"vr": "TM", "Value": ["095305.095000"]},
        "2861": {"vr": "TM", "Value": ["094748.147500"]},
        "2862": {"vr": "TM", "Value": ["094511.650000"]},
        "2863": {"vr": "TM", "Value": ["094950.177500"]},
        "2864": {"vr": "TM", "Value": ["094609.885000"]},
        "2865": {"vr": "TM", "Value": ["095233.115000"]},
        "2866": {"vr": "TM", "Value": ["094806.920000"]},
        "2867": {"vr": "TM", "Value": ["095159.232500"]},
        "2868": {"vr": "TM", "Value": ["095321.085000"]},
        "2869": {"vr": "TM", "Value": ["094803.700000"]},
        "2870": {"vr": "TM", "Value": ["094717.485000"]},
        "2871": {"vr": "TM", "Value": ["094526.617500"]},
        "2872": {"vr": "TM", "Value": ["095238.402500"]},
        "2873": {"vr": "TM", "Value": ["095152.940000"]},
        "2874": {"vr": "TM", "Value": ["094844.167500"]},
        "2875": {"vr": "TM", "Value": ["095351.290000"]},
        "2876": {"vr": "TM", "Value": ["094941.962500"]},
        "2877": {"vr": "TM", "Value": ["095042.832500"]},
        "2878": {"vr": "TM", "Value": ["095310.530000"]},
        "2879": {"vr": "TM", "Value": ["095045.465000"]},
        "2880": {"vr": "TM", "Value": ["095041.367500"]},
        "2881": {"vr": "TM", "Value": ["094935.797500"]},
        "2882": {"vr": "TM", "Value": ["094645.962500"]},
        "2883": {"vr": "TM", "Value": ["094605.767500"]},
        "2884": {"vr": "TM", "Value": ["094550.967500"]},
        "2885": {"vr": "TM", "Value": ["094838.900000"]},
        "2886": {"vr": "TM", "Value": ["095031.982500"]},
        "2887": {"vr": "TM", "Value": ["094903.690000"]},
        "2888": {"vr": "TM", "Value": ["094858.840000"]},
        "2889": {"vr": "TM", "Value": ["095430.315000"]},
        "2890": {"vr": "TM", "Value": ["094624.392500"]},
        "2891": {"vr": "TM", "Value": ["094703.270000"]},
        "2892": {"vr": "TM", "Value": ["095301.875000"]},
        "2893": {"vr": "TM", "Value": ["094807.797500"]},
        "2894": {"vr": "TM", "Value": ["094947.377500"]},
        "2895": {"vr": "TM", "Value": ["094538.342500"]},
        "2896": {"vr": "TM", "Value": ["095326.352500"]},
        "2897": {"vr": "TM", "Value": ["094930.237500"]},
        "2898": {"vr": "TM", "Value": ["095019.942500"]},
        "2899": {"vr": "TM", "Value": ["094734.352500"]},
        "2900": {"vr": "TM", "Value": ["095109.817500"]},
        "2901": {"vr": "TM", "Value": ["094609.445000"]},
        "2902": {"vr": "TM", "Value": ["095355.262500"]},
        "2903": {"vr": "TM", "Value": ["095118.177500"]},
        "2904": {"vr": "TM", "Value": ["095111.427500"]},
        "2905": {"vr": "TM", "Value": ["094744.782500"]},
        "2906": {"vr": "TM", "Value": ["094507.407500"]},
        "2907": {"vr": "TM", "Value": ["095447.622500"]},
        "2908": {"vr": "TM", "Value": ["094629.972500"]},
        "2909": {"vr": "TM", "Value": ["095414.177500"]},
        "2910": {"vr": "TM", "Value": ["094802.237500"]},
        "2911": {"vr": "TM", "Value": ["095354.530000"]},
        "2912": {"vr": "TM", "Value": ["094614.127500"]},
        "2913": {"vr": "TM", "Value": ["094917.320000"]},
        "2914": {"vr": "TM", "Value": ["094627.632500"]},
        "2915": {"vr": "TM", "Value": ["095026.402500"]},
        "2916": {"vr": "TM", "Value": ["094957.952500"]},
        "2917": {"vr": "TM", "Value": ["094801.777500"]},
        "2918": {"vr": "TM", "Value": ["094511.212500"]},
        "2919": {"vr": "TM", "Value": ["095453.182500"]},
        "2920": {"vr": "TM", "Value": ["095215.952500"]},
        "2921": {"vr": "TM", "Value": ["095127.562500"]},
        "2922": {"vr": "TM", "Value": ["095150.285000"]},
        "2923": {"vr": "TM", "Value": ["094959.125000"]},
        "2924": {"vr": "TM", "Value": ["095116.130000"]},
        "2925": {"vr": "TM", "Value": ["094554.187500"]},
        "2926": {"vr": "TM", "Value": ["094653.152500"]},
        "2927": {"vr": "TM", "Value": ["095259.075000"]},
        "2928": {"vr": "TM", "Value": ["094746.100000"]},
        "2929": {"vr": "TM", "Value": ["094522.207500"]},
        "2930": {"vr": "TM", "Value": ["094647.280000"]},
        "2931": {"vr": "TM", "Value": ["095443.357500"]},
        "2932": {"vr": "TM", "Value": ["095425.612500"]},
        "2933": {"vr": "TM", "Value": ["094627.777500"]},
        "2934": {"vr": "TM", "Value": ["095049.290000"]},
        "2935": {"vr": "TM", "Value": ["094651.230000"]},
        "2936": {"vr": "TM", "Value": ["095154.987500"]},
        "2937": {"vr": "TM", "Value": ["095301.582500"]},
        "2938": {"vr": "TM", "Value": ["095303.777500"]},
        "2939": {"vr": "TM", "Value": ["094839.045000"]},
        "2940": {"vr": "TM", "Value": ["094906.617500"]},
        "2941": {"vr": "TM", "Value": ["094720.870000"]},
        "2942": {"vr": "TM", "Value": ["095333.837500"]},
        "2943": {"vr": "TM", "Value": ["095149.552500"]},
        "2944": {"vr": "TM", "Value": ["095401.552500"]},
        "2945": {"vr": "TM", "Value": ["095444.967500"]},
        "2946": {"vr": "TM", "Value": ["094820.422500"]},
        "2947": {"vr": "TM", "Value": ["095304.217500"]},
        "2948": {"vr": "TM", "Value": ["094933.602500"]},
        "2949": {"vr": "TM", "Value": ["094510.772500"]},
        "2950": {"vr": "TM", "Value": ["094659.737500"]},
        "2951": {"vr": "TM", "Value": ["095059.260000"]},
        "2952": {"vr": "TM", "Value": ["095401.115000"]},
        "2953": {"vr": "TM", "Value": ["094858.695000"]},
        "2954": {"vr": "TM", "Value": ["095002.197500"]},
        "2955": {"vr": "TM", "Value": ["095141.337500"]},
        "2956": {"vr": "TM", "Value": ["095214.782500"]},
        "2957": {"vr": "TM", "Value": ["094622.197500"]},
        "2958": {"vr": "TM", "Value": ["094629.095000"]},
        "2959": {"vr": "TM", "Value": ["094738.617500"]},
        "2960": {"vr": "TM", "Value": ["094754.752500"]},
        "2961": {"vr": "TM", "Value": ["094744.490000"]},
        "2962": {"vr": "TM", "Value": ["094743.445000"]},
        "2963": {"vr": "TM", "Value": ["095329.300000"]},
        "2964": {"vr": "TM", "Value": ["094653.445000"]},
        "2965": {"vr": "TM", "Value": ["095321.817500"]},
        "2966": {"vr": "TM", "Value": ["094840.655000"]},
        "2967": {"vr": "TM", "Value": ["094600.207500"]},
        "2968": {"vr": "TM", "Value": ["094826.422500"]},
        "2969": {"vr": "TM", "Value": ["094702.100000"]},
        "2970": {"vr": "TM", "Value": ["095241.622500"]},
        "2971": {"vr": "TM", "Value": ["095441.162500"]},
        "2972": {"vr": "TM", "Value": ["095324.597500"]},
        "2973": {"vr": "TM", "Value": ["095033.007500"]},
        "2974": {"vr": "TM", "Value": ["094703.417500"]},
        "2975": {"vr": "TM", "Value": ["094543.045000"]},
        "2976": {"vr": "TM", "Value": ["094741.250000"]},
        "2977": {"vr": "TM", "Value": ["095052.217500"]},
        "2978": {"vr": "TM", "Value": ["094628.217500"]},
        "2979": {"vr": "TM", "Value": ["095247.642500"]},
        "2980": {"vr": "TM", "Value": ["095015.552500"]},
        "2981": {"vr": "TM", "Value": ["095218.460000"]},
        "2982": {"vr": "TM", "Value": ["095105.115000"]},
        "2983": {"vr": "TM", "Value": ["094614.715000"]},
        "2984": {"vr": "TM", "Value": ["095252.637500"]},
        "2985": {"vr": "TM", "Value": ["094827.885000"]},
        "2986": {"vr": "TM", "Value": ["094818.060000"]},
        "2987": {"vr": "TM", "Value": ["095111.135000"]},
        "2988": {"vr": "TM", "Value": ["095117.740000"]},
        "2989": {"vr": "TM", "Value": ["095230.480000"]},
        "2990": {"vr": "TM", "Value": ["094532.342500"]},
        "2991": {"vr": "TM", "Value": ["095147.797500"]},
        "2992": {"vr": "TM", "Value": ["095117.885000"]},
        "2993": {"vr": "TM", "Value": ["095017.455000"]},
        "2994": {"vr": "TM", "Value": ["095237.670000"]},
        "2995": {"vr": "TM", "Value": ["095336.177500"]},
        "2996": {"vr": "TM", "Value": ["094923.632500"]},
        "2997": {"vr": "TM", "Value": ["094751.807500"]},
        "2998": {"vr": "TM", "Value": ["095034.177500"]},
        "2999": {"vr": "TM", "Value": ["095018.480000"]},
        "3000": {"vr": "TM", "Value": ["095245.447500"]},
        "3001": {"vr": "TM", "Value": ["094613.982500"]},
        "3002": {"vr": "TM", "Value": ["095325.767500"]},
        "3003": {"vr": "TM", "Value": ["095114.500000"]},
        "3004": {"vr": "TM", "Value": ["095222.412500"]},
        "3005": {"vr": "TM", "Value": ["095448.062500"]},
        "3006": {"vr": "TM", "Value": ["095221.535000"]},
        "3007": {"vr": "TM", "Value": ["095255.125000"]},
        "3008": {"vr": "TM", "Value": ["094603.427500"]},
        "3009": {"vr": "TM", "Value": ["094654.470000"]},
        "3010": {"vr": "TM", "Value": ["095206.275000"]},
        "3011": {"vr": "TM", "Value": ["094838.315000"]},
        "3012": {"vr": "TM", "Value": ["094844.607500"]},
        "3013": {"vr": "TM", "Value": ["094715.435000"]},
        "3014": {"vr": "TM", "Value": ["095433.680000"]},
        "3015": {"vr": "TM", "Value": ["094906.470000"]},
        "3016": {"vr": "TM", "Value": ["094944.597500"]},
        "3017": {"vr": "TM", "Value": ["095037.542500"]},
        "3018": {"vr": "TM", "Value": ["095338.685000"]},
        "3019": {"vr": "TM", "Value": ["094512.967500"]},
        "3020": {"vr": "TM", "Value": ["094908.957500"]},
        "3021": {"vr": "TM", "Value": ["095027.427500"]},
        "3022": {"vr": "TM", "Value": ["094816.450000"]},
        "3023": {"vr": "TM", "Value": ["095115.690000"]},
        "3024": {"vr": "TM", "Value": ["095025.377500"]},
        "3025": {"vr": "TM", "Value": ["095247.935000"]},
        "3026": {"vr": "TM", "Value": ["094520.742500"]},
        "3027": {"vr": "TM", "Value": ["094710.167500"]},
        "3028": {"vr": "TM", "Value": ["094922.022500"]},
        "3029": {"vr": "TM", "Value": ["095140.752500"]},
        "3030": {"vr": "TM", "Value": ["095254.832500"]},
        "3031": {"vr": "TM", "Value": ["095304.802500"]},
        "3032": {"vr": "TM", "Value": ["095436.752500"]},
        "3033": {"vr": "TM", "Value": ["094634.822500"]},
        "3034": {"vr": "TM", "Value": ["094753.437500"]},
        "3035": {"vr": "TM", "Value": ["094850.480000"]},
        "3036": {"vr": "TM", "Value": ["095330.762500"]},
        "3037": {"vr": "TM", "Value": ["095045.612500"]},
        "3038": {"vr": "TM", "Value": ["094638.920000"]},
        "3039": {"vr": "TM", "Value": ["094638.480000"]},
        "3040": {"vr": "TM", "Value": ["094639.212500"]},
        "3041": {"vr": "TM", "Value": ["094741.397500"]},
        "3042": {"vr": "TM", "Value": ["095111.572500"]},
        "3043": {"vr": "TM", "Value": ["095233.260000"]},
        "3044": {"vr": "TM", "Value": ["095306.265000"]},
        "3045": {"vr": "TM", "Value": ["094618.977500"]},
        "3046": {"vr": "TM", "Value": ["094710.022500"]},
        "3047": {"vr": "TM", "Value": ["094932.285000"]},
        "3048": {"vr": "TM", "Value": ["094908.227500"]},
        "3049": {"vr": "TM", "Value": ["095406.255000"]},
        "3050": {"vr": "TM", "Value": ["095123.592500"]},
        "3051": {"vr": "TM", "Value": ["095018.772500"]},
        "3052": {"vr": "TM", "Value": ["094724.967500"]},
        "3053": {"vr": "TM", "Value": ["094642.745000"]},
        "3054": {"vr": "TM", "Value": ["095306.705000"]},
        "3055": {"vr": "TM", "Value": ["094548.022500"]},
        "3056": {"vr": "TM", "Value": ["095351.582500"]},
        "3057": {"vr": "TM", "Value": ["094558.745000"]},
        "3058": {"vr": "TM", "Value": ["094717.337500"]},
        "3059": {"vr": "TM", "Value": ["094717.630000"]},
        "3060": {"vr": "TM", "Value": ["095122.422500"]},
        "3061": {"vr": "TM", "Value": ["094814.840000"]},
        "3062": {"vr": "TM", "Value": ["095417.982500"]},
        "3063": {"vr": "TM", "Value": ["095346.607500"]},
        "3064": {"vr": "TM", "Value": ["094917.172500"]},
        "3065": {"vr": "TM", "Value": ["095108.500000"]},
        "3066": {"vr": "TM", "Value": ["095215.367500"]},
        "3067": {"vr": "TM", "Value": ["095012.607500"]},
        "3068": {"vr": "TM", "Value": ["095155.572500"]},
        "3069": {"vr": "TM", "Value": ["095023.330000"]},
        "3070": {"vr": "TM", "Value": ["095420.490000"]},
        "3071": {"vr": "TM", "Value": ["095010.412500"]},
        "3072": {"vr": "TM", "Value": ["095139.142500"]},
        "3073": {"vr": "TM", "Value": ["094730.840000"]},
        "3074": {"vr": "TM", "Value": ["094643.475000"]},
        "3075": {"vr": "TM", "Value": ["095432.362500"]},
        "3076": {"vr": "TM", "Value": ["094533.807500"]},
        "3077": {"vr": "TM", "Value": ["095135.925000"]},
        "3078": {"vr": "TM", "Value": ["095034.910000"]},
        "3079": {"vr": "TM", "Value": ["094910.860000"]},
        "3080": {"vr": "TM", "Value": ["094542.752500"]},
        "3081": {"vr": "TM", "Value": ["095326.060000"]},
        "3082": {"vr": "TM", "Value": ["095345.582500"]},
        "3083": {"vr": "TM", "Value": ["094843.142500"]},
        "3084": {"vr": "TM", "Value": ["095033.592500"]},
        "3085": {"vr": "TM", "Value": ["094842.997500"]},
        "3086": {"vr": "TM", "Value": ["095032.860000"]},
        "3087": {"vr": "TM", "Value": ["094536.880000"]},
        "3088": {"vr": "TM", "Value": ["095221.972500"]},
        "3089": {"vr": "TM", "Value": ["094508.725000"]},
        "3090": {"vr": "TM", "Value": ["095353.945000"]},
        "3091": {"vr": "TM", "Value": ["095104.382500"]},
        "3092": {"vr": "TM", "Value": ["094647.720000"]},
        "3093": {"vr": "TM", "Value": ["094746.685000"]},
        "3094": {"vr": "TM", "Value": ["095238.255000"]},
        "3095": {"vr": "TM", "Value": ["095235.037500"]},
        "3096": {"vr": "TM", "Value": ["095049.582500"]},
        "3097": {"vr": "TM", "Value": ["095005.290000"]},
        "3098": {"vr": "TM", "Value": ["094914.832500"]},
        "3099": {"vr": "TM", "Value": ["094818.352500"]},
        "3100": {"vr": "TM", "Value": ["094718.675000"]},
        "3101": {"vr": "TM", "Value": ["094807.212500"]},
        "3102": {"vr": "TM", "Value": ["095136.362500"]},
        "3103": {"vr": "TM", "Value": ["095126.832500"]},
        "3104": {"vr": "TM", "Value": ["095107.767500"]},
        "3105": {"vr": "TM", "Value": ["094903.085000"]},
        "3106": {"vr": "TM", "Value": ["094751.660000"]},
        "3107": {"vr": "TM", "Value": ["095353.632500"]},
        "3108": {"vr": "TM", "Value": ["095443.797500"]},
        "3109": {"vr": "TM", "Value": ["095421.662500"]},
        "3110": {"vr": "TM", "Value": ["094852.235000"]},
        "3111": {"vr": "TM", "Value": ["094807.505000"]},
        "3112": {"vr": "TM", "Value": ["094809.407500"]},
        "3113": {"vr": "TM", "Value": ["095221.387500"]},
        "3114": {"vr": "TM", "Value": ["094756.362500"]},
        "3115": {"vr": "TM", "Value": ["094518.110000"]},
        "3116": {"vr": "TM", "Value": ["094651.545000"]},
        "3117": {"vr": "TM", "Value": ["094851.212500"]},
        "3118": {"vr": "TM", "Value": ["094853.115000"]},
        "3119": {"vr": "TM", "Value": ["094641.552500"]},
        "3120": {"vr": "TM", "Value": ["095423.562500"]},
        "3121": {"vr": "TM", "Value": ["094845.777500"]},
        "3122": {"vr": "TM", "Value": ["094618.685000"]},
        "3123": {"vr": "TM", "Value": ["095300.537500"]},
        "3124": {"vr": "TM", "Value": ["094533.222500"]},
        "3125": {"vr": "TM", "Value": ["095237.525000"]},
        "3126": {"vr": "TM", "Value": ["095302.167500"]},
        "3127": {"vr": "TM", "Value": ["095157.182500"]},
        "3128": {"vr": "TM", "Value": ["095256.002500"]},
        "3129": {"vr": "TM", "Value": ["094557.700000"]},
        "3130": {"vr": "TM", "Value": ["094755.340000"]},
        "3131": {"vr": "TM", "Value": ["094828.782500"]},
        "3132": {"vr": "TM", "Value": ["094511.357500"]},
        "3133": {"vr": "TM", "Value": ["095205.982500"]},
        "3134": {"vr": "TM", "Value": ["095023.475000"]},
        "3135": {"vr": "TM", "Value": ["095337.515000"]},
        "3136": {"vr": "TM", "Value": ["094533.367500"]},
        "3137": {"vr": "TM", "Value": ["095404.355000"]},
        "3138": {"vr": "TM", "Value": ["094550.382500"]},
        "3139": {"vr": "TM", "Value": ["094530.420000"]},
        "3140": {"vr": "TM", "Value": ["095031.837500"]},
        "3141": {"vr": "TM", "Value": ["094757.972500"]},
        "3142": {"vr": "TM", "Value": ["095319.037500"]},
        "3143": {"vr": "TM", "Value": ["094623.075000"]},
        "3144": {"vr": "TM", "Value": ["094712.510000"]},
        "3145": {"vr": "TM", "Value": ["094523.690000"]},
        "3146": {"vr": "TM", "Value": ["095012.752500"]},
        "3147": {"vr": "TM", "Value": ["094715.875000"]},
        "3148": {"vr": "TM", "Value": ["094751.515000"]},
        "3149": {"vr": "TM", "Value": ["095146.187500"]},
        "3150": {"vr": "TM", "Value": ["095035.935000"]},
        "3151": {"vr": "TM", "Value": ["094654.910000"]},
        "3152": {"vr": "TM", "Value": ["095052.362500"]},
        "3153": {"vr": "TM", "Value": ["095251.300000"]},
        "3154": {"vr": "TM", "Value": ["094744.345000"]},
        "3155": {"vr": "TM", "Value": ["095419.007500"]},
        "3156": {"vr": "TM", "Value": ["094717.945000"]},
        "3157": {"vr": "TM", "Value": ["095242.937500"]},
        "3158": {"vr": "TM", "Value": ["095015.407500"]},
        "3159": {"vr": "TM", "Value": ["094749.612500"]},
        "3160": {"vr": "TM", "Value": ["094513.260000"]},
        "3161": {"vr": "TM", "Value": ["094955.300000"]},
        "3162": {"vr": "TM", "Value": ["094935.505000"]},
        "3163": {"vr": "TM", "Value": ["094604.450000"]},
        "3164": {"vr": "TM", "Value": ["094729.817500"]},
        "3165": {"vr": "TM", "Value": ["094507.552500"]},
        "3166": {"vr": "TM", "Value": ["094635.260000"]},
        "3167": {"vr": "TM", "Value": ["094627.192500"]},
        "3168": {"vr": "TM", "Value": ["095248.957500"]},
        "3169": {"vr": "TM", "Value": ["094956.030000"]},
        "3170": {"vr": "TM", "Value": ["095437.632500"]},
        "3171": {"vr": "TM", "Value": ["095016.725000"]},
        "3172": {"vr": "TM", "Value": ["095452.745000"]},
        "3173": {"vr": "TM", "Value": ["095322.987500"]},
        "3174": {"vr": "TM", "Value": ["094810.430000"]},
        "3175": {"vr": "TM", "Value": ["094954.422500"]},
        "3176": {"vr": "TM", "Value": ["095445.992500"]},
        "3177": {"vr": "TM", "Value": ["094912.637500"]},
        "3178": {"vr": "TM", "Value": ["095101.747500"]},
        "3179": {"vr": "TM", "Value": ["094859.135000"]},
        "3180": {"vr": "TM", "Value": ["095243.837500"]},
        "3181": {"vr": "TM", "Value": ["095253.955000"]},
        "3182": {"vr": "TM", "Value": ["095250.130000"]},
        "3183": {"vr": "TM", "Value": ["094750.635000"]},
        "3184": {"vr": "TM", "Value": ["094638.627500"]},
        "3185": {"vr": "TM", "Value": ["095255.270000"]},
        "3186": {"vr": "TM", "Value": ["095209.515000"]},
        "3187": {"vr": "TM", "Value": ["094914.247500"]},
        "3188": {"vr": "TM", "Value": ["094738.910000"]},
        "3189": {"vr": "TM", "Value": ["094739.787500"]},
        "3190": {"vr": "TM", "Value": ["095346.462500"]},
        "3191": {"vr": "TM", "Value": ["095304.510000"]},
        "3192": {"vr": "TM", "Value": ["095110.987500"]},
        "3193": {"vr": "TM", "Value": ["094959.855000"]},
        "3194": {"vr": "TM", "Value": ["094513.552500"]},
        "3195": {"vr": "TM", "Value": ["094921.730000"]},
        "3196": {"vr": "TM", "Value": ["094636.725000"]},
        "3197": {"vr": "TM", "Value": ["095243.545000"]},
        "3198": {"vr": "TM", "Value": ["095010.850000"]},
        "3199": {"vr": "TM", "Value": ["094856.207500"]},
        "3200": {"vr": "TM", "Value": ["094521.475000"]},
        "3201": {"vr": "TM", "Value": ["095240.742500"]},
        "3202": {"vr": "TM", "Value": ["095439.115000"]},
        "3203": {"vr": "TM", "Value": ["094938.430000"]},
        "3204": {"vr": "TM", "Value": ["094939.622500"]},
        "3205": {"vr": "TM", "Value": ["095435.437500"]},
        "3206": {"vr": "TM", "Value": ["094630.997500"]},
        "3207": {"vr": "TM", "Value": ["094855.330000"]},
        "3208": {"vr": "TM", "Value": ["094914.977500"]},
        "3209": {"vr": "TM", "Value": ["095216.685000"]},
        "3210": {"vr": "TM", "Value": ["094626.022500"]},
        "3211": {"vr": "TM", "Value": ["095043.562500"]},
        "3212": {"vr": "TM", "Value": ["094951.642500"]},
        "3213": {"vr": "TM", "Value": ["095303.192500"]},
        "3214": {"vr": "TM", "Value": ["095450.987500"]},
        "3215": {"vr": "TM", "Value": ["095351.730000"]},
        "3216": {"vr": "TM", "Value": ["095146.042500"]},
        "3217": {"vr": "TM", "Value": ["094621.757500"]},
        "3218": {"vr": "TM", "Value": ["094510.332500"]},
        "3219": {"vr": "TM", "Value": ["094738.325000"]},
        "3220": {"vr": "TM", "Value": ["095008.510000"]},
        "3221": {"vr": "TM", "Value": ["094707.075000"]},
        "3222": {"vr": "TM", "Value": ["095340.880000"]},
        "3223": {"vr": "TM", "Value": ["094850.627500"]},
        "3224": {"vr": "TM", "Value": ["094518.987500"]},
        "3225": {"vr": "TM", "Value": ["095130.490000"]},
        "3226": {"vr": "TM", "Value": ["095118.762500"]},
        "3227": {"vr": "TM", "Value": ["094737.740000"]},
        "3228": {"vr": "TM", "Value": ["095213.612500"]},
        "3229": {"vr": "TM", "Value": ["094617.222500"]},
        "3230": {"vr": "TM", "Value": ["094824.372500"]},
        "3231": {"vr": "TM", "Value": ["095152.060000"]},
        "3232": {"vr": "TM", "Value": ["094736.715000"]},
        "3233": {"vr": "TM", "Value": ["095421.075000"]},
        "3234": {"vr": "TM", "Value": ["094746.245000"]},
        "3235": {"vr": "TM", "Value": ["095127.417500"]},
        "3236": {"vr": "TM", "Value": ["094847.552500"]},
        "3237": {"vr": "TM", "Value": ["094925.240000"]},
        "3238": {"vr": "TM", "Value": ["095340.002500"]},
        "3239": {"vr": "TM", "Value": ["095254.100000"]},
        "3240": {"vr": "TM", "Value": ["095443.650000"]},
        "3241": {"vr": "TM", "Value": ["095220.070000"]},
        "3242": {"vr": "TM", "Value": ["094732.597500"]},
        "3243": {"vr": "TM", "Value": ["095003.660000"]},
        "3244": {"vr": "TM", "Value": ["094627.485000"]},
        "3245": {"vr": "TM", "Value": ["094519.572500"]},
        "3246": {"vr": "TM", "Value": ["095332.227500"]},
        "3247": {"vr": "TM", "Value": ["094915.125000"]},
        "3248": {"vr": "TM", "Value": ["095123.300000"]},
        "3249": {"vr": "TM", "Value": ["094845.192500"]},
        "3250": {"vr": "TM", "Value": ["095335.007500"]},
        "3251": {"vr": "TM", "Value": ["095048.100000"]},
        "3252": {"vr": "TM", "Value": ["095042.392500"]},
        "3253": {"vr": "TM", "Value": ["095258.782500"]},
        "3254": {"vr": "TM", "Value": ["095318.890000"]},
        "3255": {"vr": "TM", "Value": ["095445.700000"]},
        "3256": {"vr": "TM", "Value": ["095139.290000"]},
        "3257": {"vr": "TM", "Value": ["095250.275000"]},
        "3258": {"vr": "TM", "Value": ["095001.612500"]},
        "3259": {"vr": "TM", "Value": ["094556.822500"]},
        "3260": {"vr": "TM", "Value": ["095033.740000"]},
        "3261": {"vr": "TM", "Value": ["094908.372500"]},
        "3262": {"vr": "TM", "Value": ["094913.075000"]},
        "3263": {"vr": "TM", "Value": ["094816.597500"]},
        "3264": {"vr": "TM", "Value": ["095003.807500"]},
        "3265": {"vr": "TM", "Value": ["095339.417500"]},
        "3266": {"vr": "TM", "Value": ["095400.530000"]},
        "3267": {"vr": "TM", "Value": ["094915.855000"]},
        "3268": {"vr": "TM", "Value": ["094818.937500"]},
        "3269": {"vr": "TM", "Value": ["095217.875000"]},
        "3270": {"vr": "TM", "Value": ["095448.500000"]},
        "3271": {"vr": "TM", "Value": ["094743.592500"]},
        "3272": {"vr": "TM", "Value": ["095405.525000"]},
        "3273": {"vr": "TM", "Value": ["095430.900000"]},
        "3274": {"vr": "TM", "Value": ["095444.237500"]},
        "3275": {"vr": "TM", "Value": ["094721.017500"]},
        "3276": {"vr": "TM", "Value": ["094730.255000"]},
        "3277": {"vr": "TM", "Value": ["095034.470000"]},
        "3278": {"vr": "TM", "Value": ["095331.202500"]},
        "3279": {"vr": "TM", "Value": ["095332.372500"]},
        "3280": {"vr": "TM", "Value": ["094825.542500"]},
        "3281": {"vr": "TM", "Value": ["094737.445000"]},
        "3282": {"vr": "TM", "Value": ["094817.035000"]},
        "3283": {"vr": "TM", "Value": ["094632.900000"]},
        "3284": {"vr": "TM", "Value": ["095152.792500"]},
        "3285": {"vr": "TM", "Value": ["095041.952500"]},
        "3286": {"vr": "TM", "Value": ["095112.305000"]},
        "3287": {"vr": "TM", "Value": ["095320.792500"]},
        "3288": {"vr": "TM", "Value": ["094750.342500"]},
        "3289": {"vr": "TM", "Value": ["094633.630000"]},
        "3290": {"vr": "TM", "Value": ["094628.510000"]},
        "3291": {"vr": "TM", "Value": ["095048.830000"]},
        "3292": {"vr": "TM", "Value": ["095421.515000"]},
        "3293": {"vr": "TM", "Value": ["094947.230000"]},
        "3294": {"vr": "TM", "Value": ["095024.647500"]},
        "3295": {"vr": "TM", "Value": ["095109.377500"]},
        "3296": {"vr": "TM", "Value": ["094733.915000"]},
        "3297": {"vr": "TM", "Value": ["094730.402500"]},
        "3298": {"vr": "TM", "Value": ["094846.530000"]},
        "3299": {"vr": "TM", "Value": ["094620.440000"]},
        "3300": {"vr": "TM", "Value": ["094929.777500"]},
        "3301": {"vr": "TM", "Value": ["094942.695000"]},
        "3302": {"vr": "TM", "Value": ["095109.085000"]},
        "3303": {"vr": "TM", "Value": ["095441.895000"]},
        "3304": {"vr": "TM", "Value": ["094707.952500"]},
        "3305": {"vr": "TM", "Value": ["094923.777500"]},
        "3306": {"vr": "TM", "Value": ["095409.915000"]},
        "3307": {"vr": "TM", "Value": ["094558.430000"]},
        "3308": {"vr": "TM", "Value": ["094802.822500"]},
        "3309": {"vr": "TM", "Value": ["095205.397500"]},
        "3310": {"vr": "TM", "Value": ["094551.845000"]},
        "3311": {"vr": "TM", "Value": ["094834.197500"]},
        "3312": {"vr": "TM", "Value": ["095106.137500"]},
        "3313": {"vr": "TM", "Value": ["094516.207500"]},
        "3314": {"vr": "TM", "Value": ["094934.040000"]},
        "3315": {"vr": "TM", "Value": ["095004.977500"]},
        "3316": {"vr": "TM", "Value": ["094717.777500"]},
        "3317": {"vr": "TM", "Value": ["095347.632500"]},
        "3318": {"vr": "TM", "Value": ["095016.285000"]},
        "3319": {"vr": "TM", "Value": ["095259.952500"]},
        "3320": {"vr": "TM", "Value": ["095411.232500"]},
        "3321": {"vr": "TM", "Value": ["095224.752500"]},
        "3322": {"vr": "TM", "Value": ["095121.397500"]},
        "3323": {"vr": "TM", "Value": ["095031.085000"]},
        "3324": {"vr": "TM", "Value": ["094951.202500"]},
        "3325": {"vr": "TM", "Value": ["094712.362500"]},
        "3326": {"vr": "TM", "Value": ["094845.045000"]},
        "3327": {"vr": "TM", "Value": ["094928.900000"]},
        "3328": {"vr": "TM", "Value": ["095312.432500"]},
        "3329": {"vr": "TM", "Value": ["094756.655000"]},
        "3330": {"vr": "TM", "Value": ["094548.900000"]},
        "3331": {"vr": "TM", "Value": ["095439.847500"]},
        "3332": {"vr": "TM", "Value": ["095356.140000"]},
        "3333": {"vr": "TM", "Value": ["094800.900000"]},
        "3334": {"vr": "TM", "Value": ["095051.632500"]},
        "3335": {"vr": "TM", "Value": ["094941.232500"]},
        "3336": {"vr": "TM", "Value": ["094637.602500"]},
        "3337": {"vr": "TM", "Value": ["094514.742500"]},
        "3338": {"vr": "TM", "Value": ["094701.075000"]},
        "3339": {"vr": "TM", "Value": ["095100.870000"]},
        "3340": {"vr": "TM", "Value": ["094929.945000"]},
        "3341": {"vr": "TM", "Value": ["095125.660000"]},
        "3342": {"vr": "TM", "Value": ["095253.367500"]},
        "3343": {"vr": "TM", "Value": ["095000.587500"]},
        "3344": {"vr": "TM", "Value": ["094529.982500"]},
        "3345": {"vr": "TM", "Value": ["095104.237500"]},
        "3346": {"vr": "TM", "Value": ["095338.247500"]},
        "3347": {"vr": "TM", "Value": ["094823.202500"]},
        "3348": {"vr": "TM", "Value": ["094856.500000"]},
        "3349": {"vr": "TM", "Value": ["095417.105000"]},
        "3350": {"vr": "TM", "Value": ["094700.345000"]},
        "3351": {"vr": "TM", "Value": ["094617.952500"]},
        "3352": {"vr": "TM", "Value": ["094740.372500"]},
        "3353": {"vr": "TM", "Value": ["095322.110000"]},
        "3354": {"vr": "TM", "Value": ["094858.547500"]},
        "3355": {"vr": "TM", "Value": ["094951.787500"]},
        "3356": {"vr": "TM", "Value": ["095018.920000"]},
        "3357": {"vr": "TM", "Value": ["094537.905000"]},
        "3358": {"vr": "TM", "Value": ["094759.142500"]},
        "3359": {"vr": "TM", "Value": ["095350.265000"]},
        "3360": {"vr": "TM", "Value": ["095330.325000"]},
        "3361": {"vr": "TM", "Value": ["094848.285000"]},
        "3362": {"vr": "TM", "Value": ["094921.875000"]},
        "3363": {"vr": "TM", "Value": ["095335.885000"]},
        "3364": {"vr": "TM", "Value": ["095240.597500"]},
        "3365": {"vr": "TM", "Value": ["095451.865000"]},
        "3366": {"vr": "TM", "Value": ["095414.617500"]},
        "3367": {"vr": "TM", "Value": ["095339.562500"]},
        "3368": {"vr": "TM", "Value": ["094707.367500"]},
        "3369": {"vr": "TM", "Value": ["095229.455000"]},
        "3370": {"vr": "TM", "Value": ["095143.260000"]},
        "3371": {"vr": "TM", "Value": ["094917.612500"]},
        "3372": {"vr": "TM", "Value": ["095236.500000"]},
        "3373": {"vr": "TM", "Value": ["095205.105000"]},
        "3374": {"vr": "TM", "Value": ["095041.660000"]},
        "3375": {"vr": "TM", "Value": ["095224.315000"]},
        "3376": {"vr": "TM", "Value": ["094823.787500"]},
        "3377": {"vr": "TM", "Value": ["095245.885000"]},
        "3378": {"vr": "TM", "Value": ["094854.430000"]},
        "3379": {"vr": "TM", "Value": ["095006.900000"]},
        "3380": {"vr": "TM", "Value": ["094737.592500"]},
        "3381": {"vr": "TM", "Value": ["095210.977500"]},
        "3382": {"vr": "TM", "Value": ["095000.442500"]},
        "3383": {"vr": "TM", "Value": ["094605.622500"]},
        "3384": {"vr": "TM", "Value": ["094958.100000"]},
        "3385": {"vr": "TM", "Value": ["094803.992500"]},
        "3386": {"vr": "TM", "Value": ["095204.812500"]},
        "3387": {"vr": "TM", "Value": ["095439.700000"]},
        "3388": {"vr": "TM", "Value": ["094946.352500"]},
        "3389": {"vr": "TM", "Value": ["095311.115000"]},
        "3390": {"vr": "TM", "Value": ["095324.012500"]},
        "3391": {"vr": "TM", "Value": ["094812.352500"]},
        "3392": {"vr": "TM", "Value": ["094749.905000"]},
        "3393": {"vr": "TM", "Value": ["094955.445000"]},
        "3394": {"vr": "TM", "Value": ["094550.822500"]},
        "3395": {"vr": "TM", "Value": ["095204.957500"]},
        "3396": {"vr": "TM", "Value": ["094704.440000"]},
        "3397": {"vr": "TM", "Value": ["094804.140000"]},
        "3398": {"vr": "TM", "Value": ["094634.237500"]},
        "3399": {"vr": "TM", "Value": ["095219.485000"]},
        "3400": {"vr": "TM", "Value": ["095019.797500"]},
        "3401": {"vr": "TM", "Value": ["094946.645000"]},
        "3402": {"vr": "TM", "Value": ["095111.280000"]},
        "3403": {"vr": "TM", "Value": ["094849.017500"]},
        "3404": {"vr": "TM", "Value": ["094747.270000"]},
        "3405": {"vr": "TM", "Value": ["095001.172500"]},
        "3406": {"vr": "TM", "Value": ["095240.305000"]},
        "3407": {"vr": "TM", "Value": ["094707.222500"]},
        "3408": {"vr": "TM", "Value": ["094622.635000"]},
        "3409": {"vr": "TM", "Value": ["095155.135000"]},
        "3410": {"vr": "TM", "Value": ["095103.650000"]},
        "3411": {"vr": "TM", "Value": ["095212.150000"]},
        "3412": {"vr": "TM", "Value": ["095358.335000"]},
        "3413": {"vr": "TM", "Value": ["095413.155000"]},
        "3414": {"vr": "TM", "Value": ["095253.075000"]},
        "3415": {"vr": "TM", "Value": ["095321.232500"]},
        "3416": {"vr": "TM", "Value": ["094926.412500"]},
        "3417": {"vr": "TM", "Value": ["095119.495000"]},
        "3418": {"vr": "TM", "Value": ["094530.715000"]},
        "3419": {"vr": "TM", "Value": ["095333.105000"]},
        "3420": {"vr": "TM", "Value": ["094733.767500"]},
        "3421": {"vr": "TM", "Value": ["094629.532500"]},
        "3422": {"vr": "TM", "Value": ["095348.217500"]},
        "3423": {"vr": "TM", "Value": ["095412.422500"]},
        "3424": {"vr": "TM", "Value": ["095013.045000"]},
        "3425": {"vr": "TM", "Value": ["094950.910000"]},
        "3426": {"vr": "TM", "Value": ["095332.520000"]},
        "3427": {"vr": "TM", "Value": ["095110.695000"]},
        "3428": {"vr": "TM", "Value": ["094924.947500"]},
        "3429": {"vr": "TM", "Value": ["094933.017500"]},
        "3430": {"vr": "TM", "Value": ["095102.627500"]},
        "3431": {"vr": "TM", "Value": ["095313.310000"]},
        "3432": {"vr": "TM", "Value": ["094616.345000"]},
        "3433": {"vr": "TM", "Value": ["094613.397500"]},
        "3434": {"vr": "TM", "Value": ["095226.237500"]},
        "3435": {"vr": "TM", "Value": ["095154.547500"]},
        "3436": {"vr": "TM", "Value": ["095315.065000"]},
        "3437": {"vr": "TM", "Value": ["095337.662500"]},
        "3438": {"vr": "TM", "Value": ["094809.115000"]},
        "3439": {"vr": "TM", "Value": ["095129.465000"]},
        "3440": {"vr": "TM", "Value": ["095236.355000"]},
        "3441": {"vr": "TM", "Value": ["095305.827500"]},
        "3442": {"vr": "TM", "Value": ["095153.817500"]},
        "3443": {"vr": "TM", "Value": ["095338.977500"]},
        "3444": {"vr": "TM", "Value": ["095009.972500"]},
        "3445": {"vr": "TM", "Value": ["094527.640000"]},
        "3446": {"vr": "TM", "Value": ["094508.285000"]},
        "3447": {"vr": "TM", "Value": ["095407.280000"]},
        "3448": {"vr": "TM", "Value": ["094934.480000"]},
        "3449": {"vr": "TM", "Value": ["094857.377500"]},
        "3450": {"vr": "TM", "Value": ["095239.280000"]},
        "3451": {"vr": "TM", "Value": ["095025.232500"]},
        "3452": {"vr": "TM", "Value": ["094835.367500"]},
        "3453": {"vr": "TM", "Value": ["094905.152500"]},
        "3454": {"vr": "TM", "Value": ["094821.300000"]},
        "3455": {"vr": "TM", "Value": ["094619.562500"]},
        "3456": {"vr": "TM", "Value": ["094925.387500"]},
        "3457": {"vr": "TM", "Value": ["095230.335000"]},
        "3458": {"vr": "TM", "Value": ["095101.602500"]},
        "3459": {"vr": "TM", "Value": ["095356.577500"]},
        "3460": {"vr": "TM", "Value": ["095052.947500"]},
        "3461": {"vr": "TM", "Value": ["094627.925000"]},
        "3462": {"vr": "TM", "Value": ["094759.727500"]},
        "3463": {"vr": "TM", "Value": ["095119.202500"]},
        "3464": {"vr": "TM", "Value": ["095429.875000"]},
        "3465": {"vr": "TM", "Value": ["095123.007500"]},
        "3466": {"vr": "TM", "Value": ["094843.582500"]},
        "3467": {"vr": "TM", "Value": ["095331.495000"]},
        "3468": {"vr": "TM", "Value": ["094813.962500"]},
        "3469": {"vr": "TM", "Value": ["094716.167500"]},
        "3470": {"vr": "TM", "Value": ["095113.330000"]},
        "3471": {"vr": "TM", "Value": ["095059.992500"]},
        "3472": {"vr": "TM", "Value": ["095341.905000"]},
        "3473": {"vr": "TM", "Value": ["094559.182500"]},
        "3474": {"vr": "TM", "Value": ["094649.915000"]},
        "3475": {"vr": "TM", "Value": ["094921.437500"]},
        "3476": {"vr": "TM", "Value": ["094542.167500"]},
        "3477": {"vr": "TM", "Value": ["094518.840000"]},
        "3478": {"vr": "TM", "Value": ["095344.832500"]},
        "3479": {"vr": "TM", "Value": ["095055.142500"]},
        "3480": {"vr": "TM", "Value": ["094706.635000"]},
        "3481": {"vr": "TM", "Value": ["095449.085000"]},
        "3482": {"vr": "TM", "Value": ["095248.080000"]},
        "3483": {"vr": "TM", "Value": ["095343.075000"]},
        "3484": {"vr": "TM", "Value": ["095349.827500"]},
        "3485": {"vr": "TM", "Value": ["095118.617500"]},
        "3486": {"vr": "TM", "Value": ["095239.572500"]},
        "3487": {"vr": "TM", "Value": ["095442.772500"]},
        "3488": {"vr": "TM", "Value": ["094539.515000"]},
        "3489": {"vr": "TM", "Value": ["095218.755000"]},
        "3490": {"vr": "TM", "Value": ["094553.602500"]},
        "3491": {"vr": "TM", "Value": ["095329.740000"]},
        "3492": {"vr": "TM", "Value": ["094824.520000"]},
        "3493": {"vr": "TM", "Value": ["095416.080000"]},
        "3494": {"vr": "TM", "Value": ["095044.442500"]},
        "3495": {"vr": "TM", "Value": ["095223.290000"]},
        "3496": {"vr": "TM", "Value": ["094911.300000"]},
        "3497": {"vr": "TM", "Value": ["095117.592500"]},
        "3498": {"vr": "TM", "Value": ["095314.480000"]},
        "3499": {"vr": "TM", "Value": ["094902.060000"]},
        "3500": {"vr": "TM", "Value": ["095256.880000"]},
        "3501": {"vr": "TM", "Value": ["095004.537500"]},
        "3502": {"vr": "TM", "Value": ["095005.437500"]},
        "3503": {"vr": "TM", "Value": ["095312.870000"]},
        "3504": {"vr": "TM", "Value": ["094538.050000"]},
        "3505": {"vr": "TM", "Value": ["094756.217500"]},
        "3506": {"vr": "TM", "Value": ["094846.090000"]},
        "3507": {"vr": "TM", "Value": ["095036.812500"]},
        "3508": {"vr": "TM", "Value": ["095249.837500"]},
        "3509": {"vr": "TM", "Value": ["095148.675000"]},
        "3510": {"vr": "TM", "Value": ["095007.925000"]},
        "3511": {"vr": "TM", "Value": ["094509.602500"]},
        "3512": {"vr": "TM", "Value": ["094918.197500"]},
        "3513": {"vr": "TM", "Value": ["095050.460000"]},
        "3514": {"vr": "TM", "Value": ["095348.802500"]},
        "3515": {"vr": "TM", "Value": ["095013.485000"]},
        "3516": {"vr": "TM", "Value": ["094522.792500"]},
        "3517": {"vr": "TM", "Value": ["095407.865000"]},
        "3518": {"vr": "TM", "Value": ["094723.797500"]},
        "3519": {"vr": "TM", "Value": ["095015.847500"]},
        "3520": {"vr": "TM", "Value": ["095204.227500"]},
        "3521": {"vr": "TM", "Value": ["095450.110000"]},
        "3522": {"vr": "TM", "Value": ["094505.942500"]},
        "3523": {"vr": "TM", "Value": ["095435.290000"]},
        "3524": {"vr": "TM", "Value": ["095129.612500"]},
        "3525": {"vr": "TM", "Value": ["094949.447500"]},
        "3526": {"vr": "TM", "Value": ["094831.855000"]},
        "3527": {"vr": "TM", "Value": ["095412.862500"]},
        "3528": {"vr": "TM", "Value": ["094749.320000"]},
        "3529": {"vr": "TM", "Value": ["095448.792500"]},
        "3530": {"vr": "TM", "Value": ["094806.627500"]},
        "3531": {"vr": "TM", "Value": ["094631.142500"]},
        "3532": {"vr": "TM", "Value": ["094819.982500"]},
        "3533": {"vr": "TM", "Value": ["094817.915000"]},
        "3534": {"vr": "TM", "Value": ["095350.997500"]},
        "3535": {"vr": "TM", "Value": ["095208.032500"]},
        "3536": {"vr": "TM", "Value": ["094708.245000"]},
        "3537": {"vr": "TM", "Value": ["094607.982500"]},
        "3538": {"vr": "TM", "Value": ["095157.767500"]},
        "3539": {"vr": "TM", "Value": ["095453.622500"]},
        "3540": {"vr": "TM", "Value": ["095040.637500"]},
        "3541": {"vr": "TM", "Value": ["095159.690000"]},
        "3542": {"vr": "TM", "Value": ["094747.855000"]},
        "3543": {"vr": "TM", "Value": ["094902.500000"]},
        "3544": {"vr": "TM", "Value": ["094931.407500"]},
        "3545": {"vr": "TM", "Value": ["094841.680000"]},
        "3546": {"vr": "TM", "Value": ["094952.665000"]},
        "3547": {"vr": "TM", "Value": ["094830.977500"]},
        "3548": {"vr": "TM", "Value": ["095057.192500"]},
        "3549": {"vr": "TM", "Value": ["094607.837500"]},
        "3550": {"vr": "TM", "Value": ["095129.172500"]},
        "3551": {"vr": "TM", "Value": ["094610.177500"]},
        "3552": {"vr": "TM", "Value": ["095401.260000"]},
        "3553": {"vr": "TM", "Value": ["094933.455000"]},
        "3554": {"vr": "TM", "Value": ["094830.245000"]},
        "3555": {"vr": "TM", "Value": ["094927.582500"]},
        "3556": {"vr": "TM", "Value": ["094806.335000"]},
        "3557": {"vr": "TM", "Value": ["094729.962500"]},
        "3558": {"vr": "TM", "Value": ["094606.060000"]},
        "3559": {"vr": "TM", "Value": ["095031.545000"]},
        "3560": {"vr": "TM", "Value": ["094921.582500"]},
        "3561": {"vr": "TM", "Value": ["095231.357500"]},
        "3562": {"vr": "TM", "Value": ["094859.720000"]},
        "3563": {"vr": "TM", "Value": ["095212.002500"]},
        "3564": {"vr": "TM", "Value": ["094907.495000"]},
        "3565": {"vr": "TM", "Value": ["095309.337500"]},
        "3566": {"vr": "TM", "Value": ["095032.567500"]},
        "3567": {"vr": "TM", "Value": ["094604.597500"]},
        "3568": {"vr": "TM", "Value": ["094524.860000"]},
        "3569": {"vr": "TM", "Value": ["094705.027500"]},
        "3570": {"vr": "TM", "Value": ["094816.890000"]},
        "3571": {"vr": "TM", "Value": ["094549.630000"]},
        "3572": {"vr": "TM", "Value": ["095031.690000"]},
        "3573": {"vr": "TM", "Value": ["094541.730000"]},
        "3574": {"vr": "TM", "Value": ["094617.075000"]},
        "3575": {"vr": "TM", "Value": ["094650.060000"]},
        "3576": {"vr": "TM", "Value": ["095131.075000"]},
        "3577": {"vr": "TM", "Value": ["094932.577500"]},
        "3578": {"vr": "TM", "Value": ["094638.332500"]},
        "3579": {"vr": "TM", "Value": ["094950.470000"]},
        "3580": {"vr": "TM", "Value": ["095416.812500"]},
        "3581": {"vr": "TM", "Value": ["095257.905000"]},
        "3582": {"vr": "TM", "Value": ["095015.115000"]},
        "3583": {"vr": "TM", "Value": ["095439.992500"]},
        "3584": {"vr": "TM", "Value": ["094658.275000"]},
        "3585": {"vr": "TM", "Value": ["095031.377500"]},
        "3586": {"vr": "TM", "Value": ["095345.875000"]},
        "3587": {"vr": "TM", "Value": ["095339.710000"]},
        "3588": {"vr": "TM", "Value": ["094855.622500"]},
        "3589": {"vr": "TM", "Value": ["095313.455000"]},
        "3590": {"vr": "TM", "Value": ["094835.660000"]},
        "3591": {"vr": "TM", "Value": ["095250.567500"]},
        "3592": {"vr": "TM", "Value": ["094901.475000"]},
        "3593": {"vr": "TM", "Value": ["095303.925000"]},
        "3594": {"vr": "TM", "Value": ["095236.060000"]},
        "3595": {"vr": "TM", "Value": ["094718.382500"]},
        "3596": {"vr": "TM", "Value": ["094823.055000"]},
        "3597": {"vr": "TM", "Value": ["094727.767500"]},
        "3598": {"vr": "TM", "Value": ["094825.105000"]},
        "3599": {"vr": "TM", "Value": ["094535.710000"]},
        "3600": {"vr": "TM", "Value": ["095124.782500"]},
        "3601": {"vr": "TM", "Value": ["095225.777500"]},
        "3602": {"vr": "TM", "Value": ["094933.747500"]},
        "3603": {"vr": "TM", "Value": ["094810.137500"]},
        "3604": {"vr": "TM", "Value": ["094901.915000"]},
        "3605": {"vr": "TM", "Value": ["094919.367500"]},
        "3606": {"vr": "TM", "Value": ["095027.135000"]},
        "3607": {"vr": "TM", "Value": ["095429.290000"]},
        "3608": {"vr": "TM", "Value": ["094726.285000"]},
        "3609": {"vr": "TM", "Value": ["095349.242500"]},
        "3610": {"vr": "TM", "Value": ["095310.967500"]},
        "3611": {"vr": "TM", "Value": ["094556.382500"]},
        "3612": {"vr": "TM", "Value": ["095007.777500"]},
        "3613": {"vr": "TM", "Value": ["095231.650000"]},
        "3614": {"vr": "TM", "Value": ["095310.090000"]},
        "3615": {"vr": "TM", "Value": ["094614.860000"]},
        "3616": {"vr": "TM", "Value": ["094930.967500"]},
        "3617": {"vr": "TM", "Value": ["094652.567500"]},
        "3618": {"vr": "TM", "Value": ["094612.957500"]},
        "3619": {"vr": "TM", "Value": ["094525.300000"]},
        "3620": {"vr": "TM", "Value": ["094758.850000"]},
        "3621": {"vr": "TM", "Value": ["094831.270000"]},
        "3622": {"vr": "TM", "Value": ["094556.090000"]},
        "3623": {"vr": "TM", "Value": ["094640.527500"]},
        "3624": {"vr": "TM", "Value": ["095438.090000"]},
        "3625": {"vr": "TM", "Value": ["095432.217500"]},
        "3626": {"vr": "TM", "Value": ["094916.880000"]},
        "3627": {"vr": "TM", "Value": ["095337.955000"]},
        "3628": {"vr": "TM", "Value": ["095141.192500"]},
        "3629": {"vr": "TM", "Value": ["094546.557500"]},
        "3630": {"vr": "TM", "Value": ["095343.515000"]},
        "3631": {"vr": "TM", "Value": ["095402.432500"]},
        "3632": {"vr": "TM", "Value": ["094728.352500"]},
        "3633": {"vr": "TM", "Value": ["095209.075000"]},
        "3634": {"vr": "TM", "Value": ["095348.070000"]},
        "3635": {"vr": "TM", "Value": ["094909.105000"]},
        "3636": {"vr": "TM", "Value": ["095436.460000"]},
        "3637": {"vr": "TM", "Value": ["094544.510000"]},
        "3638": {"vr": "TM", "Value": ["094645.670000"]},
        "3639": {"vr": "TM", "Value": ["095425.757500"]},
        "3640": {"vr": "TM", "Value": ["094958.392500"]},
        "3641": {"vr": "TM", "Value": ["094838.460000"]},
        "3642": {"vr": "TM", "Value": ["095424.442500"]},
        "3643": {"vr": "TM", "Value": ["094934.335000"]},
        "3644": {"vr": "TM", "Value": ["095104.090000"]},
        "3645": {"vr": "TM", "Value": ["094622.050000"]},
        "3646": {"vr": "TM", "Value": ["094704.732500"]},
        "3647": {"vr": "TM", "Value": ["095234.285000"]},
        "3648": {"vr": "TM", "Value": ["095213.027500"]},
        "3649": {"vr": "TM", "Value": ["095010.120000"]},
        "3650": {"vr": "TM", "Value": ["094848.432500"]},
        "3651": {"vr": "TM", "Value": ["094756.947500"]},
        "3652": {"vr": "TM", "Value": ["095018.627500"]},
        "3653": {"vr": "TM", "Value": ["095317.260000"]},
        "3654": {"vr": "TM", "Value": ["095000.735000"]},
        "3655": {"vr": "TM", "Value": ["094652.715000"]},
        "3656": {"vr": "TM", "Value": ["095142.675000"]},
        "3657": {"vr": "TM", "Value": ["095402.285000"]},
        "3658": {"vr": "TM", "Value": ["094558.285000"]},
        "3659": {"vr": "TM", "Value": ["095404.207500"]},
        "3660": {"vr": "TM", "Value": ["094625.290000"]},
        "3661": {"vr": "TM", "Value": ["094726.745000"]},
        "3662": {"vr": "TM", "Value": ["095330.177500"]},
        "3663": {"vr": "TM", "Value": ["095333.250000"]},
        "3664": {"vr": "TM", "Value": ["094622.490000"]},
        "3665": {"vr": "TM", "Value": ["094726.430000"]},
        "3666": {"vr": "TM", "Value": ["095217.145000"]},
        "3667": {"vr": "TM", "Value": ["094919.222500"]},
        "3668": {"vr": "TM", "Value": ["094647.427500"]},
        "3669": {"vr": "TM", "Value": ["094753.582500"]},
        "3670": {"vr": "TM", "Value": ["094748.587500"]},
        "3671": {"vr": "TM", "Value": ["094937.260000"]},
        "3672": {"vr": "TM", "Value": ["094544.362500"]},
        "3673": {"vr": "TM", "Value": ["095454.060000"]},
        "3674": {"vr": "TM", "Value": ["094614.422500"]},
        "3675": {"vr": "TM", "Value": ["094850.920000"]},
        "3676": {"vr": "TM", "Value": ["095215.660000"]},
        "3677": {"vr": "TM", "Value": ["094605.182500"]},
        "3678": {"vr": "TM", "Value": ["095211.270000"]},
        "3679": {"vr": "TM", "Value": ["095215.075000"]},
        "3680": {"vr": "TM", "Value": ["095125.075000"]},
        "3681": {"vr": "TM", "Value": ["094651.982500"]},
        "3682": {"vr": "TM", "Value": ["094757.240000"]},
        "3683": {"vr": "TM", "Value": ["094939.767500"]},
        "3684": {"vr": "TM", "Value": ["094621.905000"]},
        "3685": {"vr": "TM", "Value": ["095200.567500"]},
        "3686": {"vr": "TM", "Value": ["094835.807500"]},
        "3687": {"vr": "TM", "Value": ["095136.802500"]},
        "3688": {"vr": "TM", "Value": ["095053.387500"]},
        "3689": {"vr": "TM", "Value": ["095227.992500"]},
        "3690": {"vr": "TM", "Value": ["094534.537500"]},
        "3691": {"vr": "TM", "Value": ["094833.905000"]},
        "3692": {"vr": "TM", "Value": ["094600.792500"]},
        "3693": {"vr": "TM", "Value": ["095029.915000"]},
        "3694": {"vr": "TM", "Value": ["095408.597500"]},
        "3695": {"vr": "TM", "Value": ["094608.567500"]},
        "3696": {"vr": "TM", "Value": ["094957.222500"]},
        "3697": {"vr": "TM", "Value": ["094859.427500"]},
        "3698": {"vr": "TM", "Value": ["094644.500000"]},
        "3699": {"vr": "TM", "Value": ["094803.845000"]},
        "3700": {"vr": "TM", "Value": ["095433.095000"]},
        "3701": {"vr": "TM", "Value": ["094631.582500"]},
        "3702": {"vr": "TM", "Value": ["094733.035000"]},
        "3703": {"vr": "TM", "Value": ["095421.222500"]},
        "3704": {"vr": "TM", "Value": ["095145.602500"]},
        "3705": {"vr": "TM", "Value": ["094600.352500"]},
        "3706": {"vr": "TM", "Value": ["095042.977500"]},
        "3707": {"vr": "TM", "Value": ["094701.515000"]},
        "3708": {"vr": "TM", "Value": ["095213.757500"]},
        "3709": {"vr": "TM", "Value": ["094811.475000"]},
        "3710": {"vr": "TM", "Value": ["095233.700000"]},
        "3711": {"vr": "TM", "Value": ["095320.207500"]},
        "3712": {"vr": "TM", "Value": ["094852.967500"]},
        "3713": {"vr": "TM", "Value": ["094523.377500"]},
        "3714": {"vr": "TM", "Value": ["095423.125000"]},
        "3715": {"vr": "TM", "Value": ["095039.007500"]},
        "3716": {"vr": "TM", "Value": ["095137.095000"]},
        "3717": {"vr": "TM", "Value": ["095406.550000"]},
        "3718": {"vr": "TM", "Value": ["095334.567500"]},
        "3719": {"vr": "TM", "Value": ["094555.942500"]},
        "3720": {"vr": "TM", "Value": ["095242.792500"]},
        "3721": {"vr": "TM", "Value": ["094942.987500"]},
        "3722": {"vr": "TM", "Value": ["094857.670000"]},
        "3723": {"vr": "TM", "Value": ["094823.495000"]},
        "3724": {"vr": "TM", "Value": ["094714.265000"]},
        "3725": {"vr": "TM", "Value": ["094635.552500"]},
        "3726": {"vr": "TM", "Value": ["095207.737500"]},
        "3727": {"vr": "TM", "Value": ["095041.515000"]},
        "3728": {"vr": "TM", "Value": ["095148.822500"]},
        "3729": {"vr": "TM", "Value": ["095311.700000"]},
        "3730": {"vr": "TM", "Value": ["094609.737500"]},
        "3731": {"vr": "TM", "Value": ["095111.720000"]},
        "3732": {"vr": "TM", "Value": ["094703.710000"]},
        "3733": {"vr": "TM", "Value": ["094531.152500"]},
        "3734": {"vr": "TM", "Value": ["095407.572500"]},
        "3735": {"vr": "TM", "Value": ["095318.432500"]},
        "3736": {"vr": "TM", "Value": ["095354.967500"]},
        "3737": {"vr": "TM", "Value": ["094844.752500"]},
        "3738": {"vr": "TM", "Value": ["095428.100000"]},
        "3739": {"vr": "TM", "Value": ["095038.860000"]},
        "3740": {"vr": "TM", "Value": ["094801.945000"]},
        "3741": {"vr": "TM", "Value": ["095119.055000"]},
        "3742": {"vr": "TM", "Value": ["094957.075000"]},
        "3743": {"vr": "TM", "Value": ["095228.870000"]},
        "3744": {"vr": "TM", "Value": ["094512.235000"]},
        "3745": {"vr": "TM", "Value": ["094527.202500"]},
        "3746": {"vr": "TM", "Value": ["094751.222500"]},
        "3747": {"vr": "TM", "Value": ["095356.432500"]},
        "3748": {"vr": "TM", "Value": ["095340.587500"]},
        "3749": {"vr": "TM", "Value": ["094814.402500"]},
        "3750": {"vr": "TM", "Value": ["094840.217500"]},
        "3751": {"vr": "TM", "Value": ["094758.265000"]},
        "3752": {"vr": "TM", "Value": ["094800.752500"]},
        "3753": {"vr": "TM", "Value": ["094928.315000"]},
        "3754": {"vr": "TM", "Value": ["094949.740000"]},
        "3755": {"vr": "TM", "Value": ["095012.167500"]},
        "3756": {"vr": "TM", "Value": ["095134.167500"]},
        "3757": {"vr": "TM", "Value": ["094624.977500"]},
        "3758": {"vr": "TM", "Value": ["095322.255000"]},
        "3759": {"vr": "TM", "Value": ["094922.607500"]},
        "3760": {"vr": "TM", "Value": ["094632.315000"]},
        "3761": {"vr": "TM", "Value": ["094911.152500"]},
        "3762": {"vr": "TM", "Value": ["094549.337500"]},
        "3763": {"vr": "TM", "Value": ["095140.022500"]},
        "3764": {"vr": "TM", "Value": ["095050.167500"]},
        "3765": {"vr": "TM", "Value": ["095441.017500"]},
        "3766": {"vr": "TM", "Value": ["094942.255000"]},
        "3767": {"vr": "TM", "Value": ["095120.227500"]},
        "3768": {"vr": "TM", "Value": ["095323.427500"]},
        "3769": {"vr": "TM", "Value": ["094641.992500"]},
        "3770": {"vr": "TM", "Value": ["094728.060000"]},
        "3771": {"vr": "TM", "Value": ["095426.637500"]},
        "3772": {"vr": "TM", "Value": ["095007.632500"]},
        "3773": {"vr": "TM", "Value": ["095306.850000"]},
        "3774": {"vr": "TM", "Value": ["094919.515000"]},
        "3775": {"vr": "TM", "Value": ["095103.942500"]},
        "3776": {"vr": "TM", "Value": ["094522.500000"]},
        "3777": {"vr": "TM", "Value": ["095008.947500"]},
        "3778": {"vr": "TM", "Value": ["094552.285000"]},
        "3779": {"vr": "TM", "Value": ["094829.367500"]},
        "3780": {"vr": "TM", "Value": ["094549.945000"]},
        "3781": {"vr": "TM", "Value": ["095333.545000"]},
        "3782": {"vr": "TM", "Value": ["094629.240000"]},
        "3783": {"vr": "TM", "Value": ["094639.065000"]},
        "3784": {"vr": "TM", "Value": ["095436.900000"]},
        "3785": {"vr": "TM", "Value": ["094642.577500"]},
        "3786": {"vr": "TM", "Value": ["095013.192500"]},
        "3787": {"vr": "TM", "Value": ["094520.597500"]},
        "3788": {"vr": "TM", "Value": ["094646.987500"]},
        "3789": {"vr": "TM", "Value": ["095256.442500"]},
        "3790": {"vr": "TM", "Value": ["094654.177500"]},
        "3791": {"vr": "TM", "Value": ["094619.710000"]},
        "3792": {"vr": "TM", "Value": ["094731.280000"]},
        "3793": {"vr": "TM", "Value": ["094932.870000"]},
        "3794": {"vr": "TM", "Value": ["094523.230000"]},
        "3795": {"vr": "TM", "Value": ["095137.387500"]},
        "3796": {"vr": "TM", "Value": ["095418.860000"]},
        "3797": {"vr": "TM", "Value": ["094740.227500"]},
        "3798": {"vr": "TM", "Value": ["095130.782500"]},
        "3799": {"vr": "TM", "Value": ["094733.622500"]},
        "3800": {"vr": "TM", "Value": ["095408.157500"]},
        "3801": {"vr": "TM", "Value": ["094933.162500"]},
        "3802": {"vr": "TM", "Value": ["095350.412500"]},
        "3803": {"vr": "TM", "Value": ["094635.700000"]},
        "3804": {"vr": "TM", "Value": ["095122.567500"]},
        "3805": {"vr": "TM", "Value": ["095137.242500"]},
        "3806": {"vr": "TM", "Value": ["095141.632500"]},
        "3807": {"vr": "TM", "Value": ["095252.177500"]},
        "3808": {"vr": "TM", "Value": ["095413.007500"]},
        "3809": {"vr": "TM", "Value": ["094656.080000"]},
        "3810": {"vr": "TM", "Value": ["095324.890000"]},
        "3811": {"vr": "TM", "Value": ["095223.437500"]},
        "3812": {"vr": "TM", "Value": ["095439.555000"]},
        "3813": {"vr": "TM", "Value": ["095206.715000"]},
        "3814": {"vr": "TM", "Value": ["094845.337500"]},
        "3815": {"vr": "TM", "Value": ["095104.675000"]},
        "3816": {"vr": "TM", "Value": ["095153.232500"]},
        "3817": {"vr": "TM", "Value": ["095146.627500"]},
        "3818": {"vr": "TM", "Value": ["094639.650000"]},
        "3819": {"vr": "TM", "Value": ["094815.865000"]},
        "3820": {"vr": "TM", "Value": ["095125.807500"]},
        "3821": {"vr": "TM", "Value": ["095044.587500"]},
        "3822": {"vr": "TM", "Value": ["095416.520000"]},
        "3823": {"vr": "TM", "Value": ["095202.470000"]},
        "3824": {"vr": "TM", "Value": ["095443.945000"]},
        "3825": {"vr": "TM", "Value": ["094821.007500"]},
        "3826": {"vr": "TM", "Value": ["094542.460000"]},
        "3827": {"vr": "TM", "Value": ["095022.745000"]},
        "3828": {"vr": "TM", "Value": ["094811.622500"]},
        "3829": {"vr": "TM", "Value": ["095304.070000"]},
        "3830": {"vr": "TM", "Value": ["094900.450000"]},
        "3831": {"vr": "TM", "Value": ["095050.022500"]},
        "3832": {"vr": "TM", "Value": ["095003.222500"]},
        "3833": {"vr": "TM", "Value": ["094932.140000"]},
        "3834": {"vr": "TM", "Value": ["094556.967500"]},
        "3835": {"vr": "TM", "Value": ["095352.460000"]},
        "3836": {"vr": "TM", "Value": ["095216.832500"]},
        "3837": {"vr": "TM", "Value": ["094720.140000"]},
        "3838": {"vr": "TM", "Value": ["094515.182500"]},
        "3839": {"vr": "TM", "Value": ["094515.622500"]},
        "3840": {"vr": "TM", "Value": ["095253.515000"]},
        "3841": {"vr": "TM", "Value": ["094656.665000"]},
        "3842": {"vr": "TM", "Value": ["094550.090000"]},
        "3843": {"vr": "TM", "Value": ["095059.407500"]},
        "3844": {"vr": "TM", "Value": ["094656.227500"]},
        "3845": {"vr": "TM", "Value": ["094822.470000"]},
        "3846": {"vr": "TM", "Value": ["095200.422500"]},
        "3847": {"vr": "TM", "Value": ["095123.737500"]},
        "3848": {"vr": "TM", "Value": ["095126.685000"]},
        "3849": {"vr": "TM", "Value": ["095409.622500"]},
        "3850": {"vr": "TM", "Value": ["095013.777500"]},
        "3851": {"vr": "TM", "Value": ["095158.645000"]},
        "3852": {"vr": "TM", "Value": ["094708.685000"]},
        "3853": {"vr": "TM", "Value": ["094549.192500"]},
        "3854": {"vr": "TM", "Value": ["094836.977500"]},
        "3855": {"vr": "TM", "Value": ["095449.962500"]},
        "3856": {"vr": "TM", "Value": ["094529.397500"]},
        "3857": {"vr": "TM", "Value": ["094703.855000"]},
        "3858": {"vr": "TM", "Value": ["094527.495000"]},
        "3859": {"vr": "TM", "Value": ["095025.962500"]},
        "3860": {"vr": "TM", "Value": ["094719.992500"]},
        "3861": {"vr": "TM", "Value": ["094945.622500"]},
        "3862": {"vr": "TM", "Value": ["094739.640000"]},
        "3863": {"vr": "TM", "Value": ["095310.382500"]},
        "3864": {"vr": "TM", "Value": ["094849.162500"]},
        "3865": {"vr": "TM", "Value": ["095104.530000"]},
        "3866": {"vr": "TM", "Value": ["094926.265000"]},
        "3867": {"vr": "TM", "Value": ["094605.035000"]},
        "3868": {"vr": "TM", "Value": ["094654.032500"]},
        "3869": {"vr": "TM", "Value": ["095231.065000"]},
        "3870": {"vr": "TM", "Value": ["095429.582500"]},
        "3871": {"vr": "TM", "Value": ["095329.592500"]},
        "3872": {"vr": "TM", "Value": ["094603.720000"]},
        "3873": {"vr": "TM", "Value": ["095252.930000"]},
        "3874": {"vr": "TM", "Value": ["095132.685000"]},
        "3875": {"vr": "TM", "Value": ["095400.382500"]},
        "3876": {"vr": "TM", "Value": ["094736.422500"]},
        "3877": {"vr": "TM", "Value": ["095353.485000"]},
        "3878": {"vr": "TM", "Value": ["095315.212500"]},
        "3879": {"vr": "TM", "Value": ["094720.432500"]},
        "3880": {"vr": "TM", "Value": ["095155.280000"]},
        "3881": {"vr": "TM", "Value": ["094853.992500"]},
        "3882": {"vr": "TM", "Value": ["095141.777500"]},
        "3883": {"vr": "TM", "Value": ["094922.315000"]},
        "3884": {"vr": "TM", "Value": ["095005.582500"]},
        "3885": {"vr": "TM", "Value": ["094646.110000"]},
        "3886": {"vr": "TM", "Value": ["095305.535000"]},
        "3887": {"vr": "TM", "Value": ["095020.822500"]},
        "3888": {"vr": "TM", "Value": ["094800.607500"]},
        "3889": {"vr": "TM", "Value": ["094537.320000"]},
        "3890": {"vr": "TM", "Value": ["094916.295000"]},
        "3891": {"vr": "TM", "Value": ["095105.700000"]},
        "3892": {"vr": "TM", "Value": ["095411.982500"]},
        "3893": {"vr": "TM", "Value": ["095145.895000"]},
        "3894": {"vr": "TM", "Value": ["094546.997500"]},
        "3895": {"vr": "TM", "Value": ["094728.500000"]},
        "3896": {"vr": "TM", "Value": ["095417.690000"]},
        "3897": {"vr": "TM", "Value": ["095336.637500"]},
        "3898": {"vr": "TM", "Value": ["095058.090000"]},
        "3899": {"vr": "TM", "Value": ["095200.860000"]},
        "3900": {"vr": "TM", "Value": ["094645.232500"]},
        "3901": {"vr": "TM", "Value": ["095247.055000"]},
        "3902": {"vr": "TM", "Value": ["095021.992500"]},
        "3903": {"vr": "TM", "Value": ["095222.850000"]},
        "3904": {"vr": "TM", "Value": ["094945.475000"]},
        "3905": {"vr": "TM", "Value": ["095430.755000"]},
        "3906": {"vr": "TM", "Value": ["095032.275000"]},
        "3907": {"vr": "TM", "Value": ["095341.465000"]},
        "3908": {"vr": "TM", "Value": ["094800.460000"]},
        "3909": {"vr": "TM", "Value": ["094637.162500"]},
        "3910": {"vr": "TM", "Value": ["094547.582500"]},
        "3911": {"vr": "TM", "Value": ["094840.947500"]},
        "3912": {"vr": "TM", "Value": ["095402.745000"]},
        "3913": {"vr": "TM", "Value": ["094918.782500"]},
        "3914": {"vr": "TM", "Value": ["095047.367500"]},
        "3915": {"vr": "TM", "Value": ["094524.715000"]},
        "3916": {"vr": "TM", "Value": ["094823.347500"]},
        "3917": {"vr": "TM", "Value": ["094603.572500"]},
        "3918": {"vr": "TM", "Value": ["094948.567500"]},
        "3919": {"vr": "TM", "Value": ["094908.665000"]},
        "3920": {"vr": "TM", "Value": ["094747.562500"]},
        "3921": {"vr": "TM", "Value": ["095320.940000"]},
        "3922": {"vr": "TM", "Value": ["095420.637500"]},
        "3923": {"vr": "TM", "Value": ["094628.947500"]},
        "3924": {"vr": "TM", "Value": ["094525.445000"]},
        "3925": {"vr": "TM", "Value": ["094752.245000"]},
        "3926": {"vr": "TM", "Value": ["095208.177500"]},
        "3927": {"vr": "TM", "Value": ["095220.217500"]},
        "3928": {"vr": "TM", "Value": ["095001.757500"]},
        "3929": {"vr": "TM", "Value": ["095304.362500"]},
        "3930": {"vr": "TM", "Value": ["095229.310000"]},
        "3931": {"vr": "TM", "Value": ["094945.035000"]},
        "3932": {"vr": "TM", "Value": ["095145.162500"]},
        "3933": {"vr": "TM", "Value": ["095343.952500"]},
        "3934": {"vr": "TM", "Value": ["095023.622500"]},
        "3935": {"vr": "TM", "Value": ["095342.782500"]},
        "3936": {"vr": "TM", "Value": ["095029.330000"]},
        "3937": {"vr": "TM", "Value": ["095138.412500"]},
        "3938": {"vr": "TM", "Value": ["095417.250000"]},
        "3939": {"vr": "TM", "Value": ["094641.700000"]},
        "3940": {"vr": "TM", "Value": ["094906.325000"]},
        "3941": {"vr": "TM", "Value": ["095328.422500"]},
        "3942": {"vr": "TM", "Value": ["095202.177500"]},
        "3943": {"vr": "TM", "Value": ["095406.695000"]},
        "3944": {"vr": "TM", "Value": ["095040.177500"]},
        "3945": {"vr": "TM", "Value": ["094824.665000"]},
        "3946": {"vr": "TM", "Value": ["095407.427500"]},
        "3947": {"vr": "TM", "Value": ["094641.845000"]},
        "3948": {"vr": "TM", "Value": ["094811.915000"]},
        "3949": {"vr": "TM", "Value": ["095346.315000"]},
        "3950": {"vr": "TM", "Value": ["095109.962500"]},
        "3951": {"vr": "TM", "Value": ["094848.870000"]},
        "3952": {"vr": "TM", "Value": ["095023.182500"]},
        "3953": {"vr": "TM", "Value": ["095029.767500"]},
        "3954": {"vr": "TM", "Value": ["094613.250000"]},
        "3955": {"vr": "TM", "Value": ["095444.382500"]},
        "3956": {"vr": "TM", "Value": ["095014.382500"]},
        "3957": {"vr": "TM", "Value": ["094953.542500"]},
        "3958": {"vr": "TM", "Value": ["094831.562500"]},
        "3959": {"vr": "TM", "Value": ["095340.295000"]},
        "3960": {"vr": "TM", "Value": ["095132.245000"]},
        "3961": {"vr": "TM", "Value": ["095203.350000"]},
        "3962": {"vr": "TM", "Value": ["095306.557500"]},
        "3963": {"vr": "TM", "Value": ["094715.142500"]},
        "3964": {"vr": "TM", "Value": ["095151.622500"]},
        "3965": {"vr": "TM", "Value": ["095434.850000"]},
        "3966": {"vr": "TM", "Value": ["094655.495000"]},
        "3967": {"vr": "TM", "Value": ["094858.110000"]},
        "3968": {"vr": "TM", "Value": ["094649.767500"]},
        "3969": {"vr": "TM", "Value": ["094549.777500"]},
        "3970": {"vr": "TM", "Value": ["094928.022500"]},
        "3971": {"vr": "TM", "Value": ["094602.402500"]},
        "3972": {"vr": "TM", "Value": ["095230.920000"]},
        "3973": {"vr": "TM", "Value": ["094854.137500"]},
        "3974": {"vr": "TM", "Value": ["094757.827500"]},
        "3975": {"vr": "TM", "Value": ["095245.300000"]},
        "3976": {"vr": "TM", "Value": ["094531.007500"]},
        "3977": {"vr": "TM", "Value": ["094624.537500"]},
        "3978": {"vr": "TM", "Value": ["095428.392500"]},
        "3979": {"vr": "TM", "Value": ["094917.757500"]},
        "3980": {"vr": "TM", "Value": ["094638.187500"]},
        "3981": {"vr": "TM", "Value": ["095207.592500"]},
        "3982": {"vr": "TM", "Value": ["094946.060000"]},
        "3983": {"vr": "TM", "Value": ["094538.490000"]},
        "3984": {"vr": "TM", "Value": ["094741.105000"]},
        "3985": {"vr": "TM", "Value": ["095044.880000"]},
        "3986": {"vr": "TM", "Value": ["095419.152500"]},
        "3987": {"vr": "TM", "Value": ["094905.592500"]},
        "3988": {"vr": "TM", "Value": ["094946.500000"]},
        "3989": {"vr": "TM", "Value": ["094840.070000"]},
        "3990": {"vr": "TM", "Value": ["095033.885000"]},
        "3991": {"vr": "TM", "Value": ["095039.152500"]},
        "3992": {"vr": "TM", "Value": ["095418.422500"]},
        "3993": {"vr": "TM", "Value": ["095331.350000"]},
        "3994": {"vr": "TM", "Value": ["094935.942500"]},
        "3995": {"vr": "TM", "Value": ["094652.422500"]},
        "3996": {"vr": "TM", "Value": ["094555.357500"]},
        "3997": {"vr": "TM", "Value": ["095339.855000"]},
        "3998": {"vr": "TM", "Value": ["094935.065000"]},
        "3999": {"vr": "TM", "Value": ["095206.860000"]},
        "4000": {"vr": "TM", "Value": ["095348.362500"]},
        "4001": {"vr": "TM", "Value": ["095202.762500"]},
        "4002": {"vr": "TM", "Value": ["095237.085000"]},
        "4003": {"vr": "TM", "Value": ["094832.587500"]},
        "4004": {"vr": "TM", "Value": ["095332.957500"]},
        "4005": {"vr": "TM", "Value": ["094720.285000"]},
        "4006": {"vr": "TM", "Value": ["094612.080000"]},
        "4007": {"vr": "TM", "Value": ["095055.730000"]},
        "4008": {"vr": "TM", "Value": ["094710.900000"]},
        "4009": {"vr": "TM", "Value": ["094956.782500"]},
        "4010": {"vr": "TM", "Value": ["095009.095000"]},
        "4011": {"vr": "TM", "Value": ["094646.255000"]},
        "4012": {"vr": "TM", "Value": ["095255.710000"]},
        "4013": {"vr": "TM", "Value": ["094636.870000"]},
        "4014": {"vr": "TM", "Value": ["094811.330000"]},
        "4015": {"vr": "TM", "Value": ["095402.577500"]},
        "4016": {"vr": "TM", "Value": ["095347.925000"]},
        "4017": {"vr": "TM", "Value": ["094945.330000"]},
        "4018": {"vr": "TM", "Value": ["095227.847500"]},
        "4019": {"vr": "TM", "Value": ["095054.997500"]},
    },
    "00080033": {
        "0": {"vr": "TM", "Value": ["094827.811000"]},
        "1": {"vr": "TM", "Value": ["094947.660000"]},
        "2": {"vr": "TM", "Value": ["095127.776000"]},
        "3": {"vr": "TM", "Value": ["095147.804000"]},
        "4": {"vr": "TM", "Value": ["095107.672000"]},
        "5": {"vr": "TM", "Value": ["095047.889000"]},
        "6": {"vr": "TM", "Value": ["095307.863000"]},
        "7": {"vr": "TM", "Value": ["095327.829000"]},
        "8": {"vr": "TM", "Value": ["094847.667000"]},
        "9": {"vr": "TM", "Value": ["094707.827000"]},
        "10": {"vr": "TM", "Value": ["095307.825000"]},
        "11": {"vr": "TM", "Value": ["094847.852000"]},
        "12": {"vr": "TM", "Value": ["094847.774000"]},
        "13": {"vr": "TM", "Value": ["094527.681000"]},
        "14": {"vr": "TM", "Value": ["095007.805000"]},
        "15": {"vr": "TM", "Value": ["095207.670000"]},
        "16": {"vr": "TM", "Value": ["095247.920000"]},
        "17": {"vr": "TM", "Value": ["094607.854000"]},
        "18": {"vr": "TM", "Value": ["094807.810000"]},
        "19": {"vr": "TM", "Value": ["095207.729000"]},
        "20": {"vr": "TM", "Value": ["094727.655000"]},
        "21": {"vr": "TM", "Value": ["095207.916000"]},
        "22": {"vr": "TM", "Value": ["095227.930000"]},
        "23": {"vr": "TM", "Value": ["095407.705000"]},
        "24": {"vr": "TM", "Value": ["095227.666000"]},
        "25": {"vr": "TM", "Value": ["094807.770000"]},
        "26": {"vr": "TM", "Value": ["094947.815000"]},
        "27": {"vr": "TM", "Value": ["094727.896000"]},
        "28": {"vr": "TM", "Value": ["094747.949000"]},
        "29": {"vr": "TM", "Value": ["095147.882000"]},
        "30": {"vr": "TM", "Value": ["094947.846000"]},
        "31": {"vr": "TM", "Value": ["094827.939000"]},
        "32": {"vr": "TM", "Value": ["095027.864000"]},
        "33": {"vr": "TM", "Value": ["094747.821000"]},
        "34": {"vr": "TM", "Value": ["095456.546000"]},
        "35": {"vr": "TM", "Value": ["094527.618000"]},
        "36": {"vr": "TM", "Value": ["094647.883000"]},
        "37": {"vr": "TM", "Value": ["094807.723000"]},
        "38": {"vr": "TM", "Value": ["095107.925000"]},
        "39": {"vr": "TM", "Value": ["094927.742000"]},
        "40": {"vr": "TM", "Value": ["095327.790000"]},
        "41": {"vr": "TM", "Value": ["095427.944000"]},
        "42": {"vr": "TM", "Value": ["095447.685000"]},
        "43": {"vr": "TM", "Value": ["094807.812000"]},
        "44": {"vr": "TM", "Value": ["095307.634000"]},
        "45": {"vr": "TM", "Value": ["094627.764000"]},
        "46": {"vr": "TM", "Value": ["095307.845000"]},
        "47": {"vr": "TM", "Value": ["095427.881000"]},
        "48": {"vr": "TM", "Value": ["094927.616000"]},
        "49": {"vr": "TM", "Value": ["094547.697000"]},
        "50": {"vr": "TM", "Value": ["095247.637000"]},
        "51": {"vr": "TM", "Value": ["095247.775000"]},
        "52": {"vr": "TM", "Value": ["095307.608000"]},
        "53": {"vr": "TM", "Value": ["094827.763000"]},
        "54": {"vr": "TM", "Value": ["094647.710000"]},
        "55": {"vr": "TM", "Value": ["094907.641000"]},
        "56": {"vr": "TM", "Value": ["095047.915000"]},
        "57": {"vr": "TM", "Value": ["094907.946000"]},
        "58": {"vr": "TM", "Value": ["094847.651000"]},
        "59": {"vr": "TM", "Value": ["094747.612000"]},
        "60": {"vr": "TM", "Value": ["095147.849000"]},
        "61": {"vr": "TM", "Value": ["095327.697000"]},
        "62": {"vr": "TM", "Value": ["094827.760000"]},
        "63": {"vr": "TM", "Value": ["095447.788000"]},
        "64": {"vr": "TM", "Value": ["095047.838000"]},
        "65": {"vr": "TM", "Value": ["095447.811000"]},
        "66": {"vr": "TM", "Value": ["094827.784000"]},
        "67": {"vr": "TM", "Value": ["094847.900000"]},
        "68": {"vr": "TM", "Value": ["094707.680000"]},
        "69": {"vr": "TM", "Value": ["094727.761000"]},
        "70": {"vr": "TM", "Value": ["094647.606000"]},
        "71": {"vr": "TM", "Value": ["095107.642000"]},
        "72": {"vr": "TM", "Value": ["095047.907000"]},
        "73": {"vr": "TM", "Value": ["095207.918000"]},
        "74": {"vr": "TM", "Value": ["094607.931000"]},
        "75": {"vr": "TM", "Value": ["095427.619000"]},
        "76": {"vr": "TM", "Value": ["095207.859000"]},
        "77": {"vr": "TM", "Value": ["094947.870000"]},
        "78": {"vr": "TM", "Value": ["095147.892000"]},
        "79": {"vr": "TM", "Value": ["094747.806000"]},
        "80": {"vr": "TM", "Value": ["095456.515000"]},
        "81": {"vr": "TM", "Value": ["094607.923000"]},
        "82": {"vr": "TM", "Value": ["095127.678000"]},
        "83": {"vr": "TM", "Value": ["095027.862000"]},
        "84": {"vr": "TM", "Value": ["094527.933000"]},
        "85": {"vr": "TM", "Value": ["095207.639000"]},
        "86": {"vr": "TM", "Value": ["095247.855000"]},
        "87": {"vr": "TM", "Value": ["095207.900000"]},
        "88": {"vr": "TM", "Value": ["094907.934000"]},
        "89": {"vr": "TM", "Value": ["095347.923000"]},
        "90": {"vr": "TM", "Value": ["094527.655000"]},
        "91": {"vr": "TM", "Value": ["094707.634000"]},
        "92": {"vr": "TM", "Value": ["095227.817000"]},
        "93": {"vr": "TM", "Value": ["094627.962000"]},
        "94": {"vr": "TM", "Value": ["095347.853000"]},
        "95": {"vr": "TM", "Value": ["094727.929000"]},
        "96": {"vr": "TM", "Value": ["094747.759000"]},
        "97": {"vr": "TM", "Value": ["095447.901000"]},
        "98": {"vr": "TM", "Value": ["094527.851000"]},
        "99": {"vr": "TM", "Value": ["094527.865000"]},
        "100": {"vr": "TM", "Value": ["094627.756000"]},
        "101": {"vr": "TM", "Value": ["094907.693000"]},
        "102": {"vr": "TM", "Value": ["094627.812000"]},
        "103": {"vr": "TM", "Value": ["095027.739000"]},
        "104": {"vr": "TM", "Value": ["095307.751000"]},
        "105": {"vr": "TM", "Value": ["095347.802000"]},
        "106": {"vr": "TM", "Value": ["095227.671000"]},
        "107": {"vr": "TM", "Value": ["095347.666000"]},
        "108": {"vr": "TM", "Value": ["094727.721000"]},
        "109": {"vr": "TM", "Value": ["094727.748000"]},
        "110": {"vr": "TM", "Value": ["095447.773000"]},
        "111": {"vr": "TM", "Value": ["095307.809000"]},
        "112": {"vr": "TM", "Value": ["094827.854000"]},
        "113": {"vr": "TM", "Value": ["095447.693000"]},
        "114": {"vr": "TM", "Value": ["095007.882000"]},
        "115": {"vr": "TM", "Value": ["095227.830000"]},
        "116": {"vr": "TM", "Value": ["095327.630000"]},
        "117": {"vr": "TM", "Value": ["094707.922000"]},
        "118": {"vr": "TM", "Value": ["095147.632000"]},
        "119": {"vr": "TM", "Value": ["095447.945000"]},
        "120": {"vr": "TM", "Value": ["094607.654000"]},
        "121": {"vr": "TM", "Value": ["094547.687000"]},
        "122": {"vr": "TM", "Value": ["095247.863000"]},
        "123": {"vr": "TM", "Value": ["094527.820000"]},
        "124": {"vr": "TM", "Value": ["095227.747000"]},
        "125": {"vr": "TM", "Value": ["095007.946000"]},
        "126": {"vr": "TM", "Value": ["095447.634000"]},
        "127": {"vr": "TM", "Value": ["094927.804000"]},
        "128": {"vr": "TM", "Value": ["095147.731000"]},
        "129": {"vr": "TM", "Value": ["094827.636000"]},
        "130": {"vr": "TM", "Value": ["094627.694000"]},
        "131": {"vr": "TM", "Value": ["095147.898000"]},
        "132": {"vr": "TM", "Value": ["095347.794000"]},
        "133": {"vr": "TM", "Value": ["095427.899000"]},
        "134": {"vr": "TM", "Value": ["095347.820000"]},
        "135": {"vr": "TM", "Value": ["094747.900000"]},
        "136": {"vr": "TM", "Value": ["094947.853000"]},
        "137": {"vr": "TM", "Value": ["095047.882000"]},
        "138": {"vr": "TM", "Value": ["094627.741000"]},
        "139": {"vr": "TM", "Value": ["094807.836000"]},
        "140": {"vr": "TM", "Value": ["094847.793000"]},
        "141": {"vr": "TM", "Value": ["094547.822000"]},
        "142": {"vr": "TM", "Value": ["095027.800000"]},
        "143": {"vr": "TM", "Value": ["095247.875000"]},
        "144": {"vr": "TM", "Value": ["095027.910000"]},
        "145": {"vr": "TM", "Value": ["095307.656000"]},
        "146": {"vr": "TM", "Value": ["094607.861000"]},
        "147": {"vr": "TM", "Value": ["094727.891000"]},
        "148": {"vr": "TM", "Value": ["095307.868000"]},
        "149": {"vr": "TM", "Value": ["095247.843000"]},
        "150": {"vr": "TM", "Value": ["095007.753000"]},
        "151": {"vr": "TM", "Value": ["094727.789000"]},
        "152": {"vr": "TM", "Value": ["095447.793000"]},
        "153": {"vr": "TM", "Value": ["094747.704000"]},
        "154": {"vr": "TM", "Value": ["094527.796000"]},
        "155": {"vr": "TM", "Value": ["095207.780000"]},
        "156": {"vr": "TM", "Value": ["094807.611000"]},
        "157": {"vr": "TM", "Value": ["094907.832000"]},
        "158": {"vr": "TM", "Value": ["095047.607000"]},
        "159": {"vr": "TM", "Value": ["094607.776000"]},
        "160": {"vr": "TM", "Value": ["095456.529000"]},
        "161": {"vr": "TM", "Value": ["095307.771000"]},
        "162": {"vr": "TM", "Value": ["094747.770000"]},
        "163": {"vr": "TM", "Value": ["095247.822000"]},
        "164": {"vr": "TM", "Value": ["094707.830000"]},
        "165": {"vr": "TM", "Value": ["095247.608000"]},
        "166": {"vr": "TM", "Value": ["095107.637000"]},
        "167": {"vr": "TM", "Value": ["094927.611000"]},
        "168": {"vr": "TM", "Value": ["094647.702000"]},
        "169": {"vr": "TM", "Value": ["094807.950000"]},
        "170": {"vr": "TM", "Value": ["094607.710000"]},
        "171": {"vr": "TM", "Value": ["094807.795000"]},
        "172": {"vr": "TM", "Value": ["094547.869000"]},
        "173": {"vr": "TM", "Value": ["095427.949000"]},
        "174": {"vr": "TM", "Value": ["094727.703000"]},
        "175": {"vr": "TM", "Value": ["094827.802000"]},
        "176": {"vr": "TM", "Value": ["094527.982000"]},
        "177": {"vr": "TM", "Value": ["095307.704000"]},
        "178": {"vr": "TM", "Value": ["095427.633000"]},
        "179": {"vr": "TM", "Value": ["095247.930000"]},
        "180": {"vr": "TM", "Value": ["094707.892000"]},
        "181": {"vr": "TM", "Value": ["094827.839000"]},
        "182": {"vr": "TM", "Value": ["095247.642000"]},
        "183": {"vr": "TM", "Value": ["095127.734000"]},
        "184": {"vr": "TM", "Value": ["094547.717000"]},
        "185": {"vr": "TM", "Value": ["094807.651000"]},
        "186": {"vr": "TM", "Value": ["095227.811000"]},
        "187": {"vr": "TM", "Value": ["095227.837000"]},
        "188": {"vr": "TM", "Value": ["095427.910000"]},
        "189": {"vr": "TM", "Value": ["094907.819000"]},
        "190": {"vr": "TM", "Value": ["095027.844000"]},
        "191": {"vr": "TM", "Value": ["094527.772000"]},
        "192": {"vr": "TM", "Value": ["095207.908000"]},
        "193": {"vr": "TM", "Value": ["094627.684000"]},
        "194": {"vr": "TM", "Value": ["095427.708000"]},
        "195": {"vr": "TM", "Value": ["095047.633000"]},
        "196": {"vr": "TM", "Value": ["095127.611000"]},
        "197": {"vr": "TM", "Value": ["094907.864000"]},
        "198": {"vr": "TM", "Value": ["094527.663000"]},
        "199": {"vr": "TM", "Value": ["095127.696000"]},
        "200": {"vr": "TM", "Value": ["094547.679000"]},
        "201": {"vr": "TM", "Value": ["095147.885000"]},
        "202": {"vr": "TM", "Value": ["095227.694000"]},
        "203": {"vr": "TM", "Value": ["094807.645000"]},
        "204": {"vr": "TM", "Value": ["094927.727000"]},
        "205": {"vr": "TM", "Value": ["095227.901000"]},
        "206": {"vr": "TM", "Value": ["095247.758000"]},
        "207": {"vr": "TM", "Value": ["095047.863000"]},
        "208": {"vr": "TM", "Value": ["094547.847000"]},
        "209": {"vr": "TM", "Value": ["094627.837000"]},
        "210": {"vr": "TM", "Value": ["095007.885000"]},
        "211": {"vr": "TM", "Value": ["095047.736000"]},
        "212": {"vr": "TM", "Value": ["095347.925000"]},
        "213": {"vr": "TM", "Value": ["095347.946000"]},
        "214": {"vr": "TM", "Value": ["095227.607000"]},
        "215": {"vr": "TM", "Value": ["095107.721000"]},
        "216": {"vr": "TM", "Value": ["094727.675000"]},
        "217": {"vr": "TM", "Value": ["094707.845000"]},
        "218": {"vr": "TM", "Value": ["095427.727000"]},
        "219": {"vr": "TM", "Value": ["094947.663000"]},
        "220": {"vr": "TM", "Value": ["094847.680000"]},
        "221": {"vr": "TM", "Value": ["095027.682000"]},
        "222": {"vr": "TM", "Value": ["095027.870000"]},
        "223": {"vr": "TM", "Value": ["094547.850000"]},
        "224": {"vr": "TM", "Value": ["094607.636000"]},
        "225": {"vr": "TM", "Value": ["094607.705000"]},
        "226": {"vr": "TM", "Value": ["095127.630000"]},
        "227": {"vr": "TM", "Value": ["094707.621000"]},
        "228": {"vr": "TM", "Value": ["095047.825000"]},
        "229": {"vr": "TM", "Value": ["094827.633000"]},
        "230": {"vr": "TM", "Value": ["094727.650000"]},
        "231": {"vr": "TM", "Value": ["094707.820000"]},
        "232": {"vr": "TM", "Value": ["095227.944000"]},
        "233": {"vr": "TM", "Value": ["095247.772000"]},
        "234": {"vr": "TM", "Value": ["094807.958000"]},
        "235": {"vr": "TM", "Value": ["095247.753000"]},
        "236": {"vr": "TM", "Value": ["095407.676000"]},
        "237": {"vr": "TM", "Value": ["094547.845000"]},
        "238": {"vr": "TM", "Value": ["095027.662000"]},
        "239": {"vr": "TM", "Value": ["095247.933000"]},
        "240": {"vr": "TM", "Value": ["094907.801000"]},
        "241": {"vr": "TM", "Value": ["095027.659000"]},
        "242": {"vr": "TM", "Value": ["095127.867000"]},
        "243": {"vr": "TM", "Value": ["094827.894000"]},
        "244": {"vr": "TM", "Value": ["095427.827000"]},
        "245": {"vr": "TM", "Value": ["095327.888000"]},
        "246": {"vr": "TM", "Value": ["094527.678000"]},
        "247": {"vr": "TM", "Value": ["094627.810000"]},
        "248": {"vr": "TM", "Value": ["095047.782000"]},
        "249": {"vr": "TM", "Value": ["095047.953000"]},
        "250": {"vr": "TM", "Value": ["095147.710000"]},
        "251": {"vr": "TM", "Value": ["094807.763000"]},
        "252": {"vr": "TM", "Value": ["095027.788000"]},
        "253": {"vr": "TM", "Value": ["095027.890000"]},
        "254": {"vr": "TM", "Value": ["095107.781000"]},
        "255": {"vr": "TM", "Value": ["094847.943000"]},
        "256": {"vr": "TM", "Value": ["095327.772000"]},
        "257": {"vr": "TM", "Value": ["095407.888000"]},
        "258": {"vr": "TM", "Value": ["094907.768000"]},
        "259": {"vr": "TM", "Value": ["094907.705000"]},
        "260": {"vr": "TM", "Value": ["094647.849000"]},
        "261": {"vr": "TM", "Value": ["095327.621000"]},
        "262": {"vr": "TM", "Value": ["094807.745000"]},
        "263": {"vr": "TM", "Value": ["094627.729000"]},
        "264": {"vr": "TM", "Value": ["095347.644000"]},
        "265": {"vr": "TM", "Value": ["095427.876000"]},
        "266": {"vr": "TM", "Value": ["095447.727000"]},
        "267": {"vr": "TM", "Value": ["094847.714000"]},
        "268": {"vr": "TM", "Value": ["094627.947000"]},
        "269": {"vr": "TM", "Value": ["095207.795000"]},
        "270": {"vr": "TM", "Value": ["095456.551000"]},
        "271": {"vr": "TM", "Value": ["095227.868000"]},
        "272": {"vr": "TM", "Value": ["095427.683000"]},
        "273": {"vr": "TM", "Value": ["094947.888000"]},
        "274": {"vr": "TM", "Value": ["094627.974000"]},
        "275": {"vr": "TM", "Value": ["094707.637000"]},
        "276": {"vr": "TM", "Value": ["095227.923000"]},
        "277": {"vr": "TM", "Value": ["095407.768000"]},
        "278": {"vr": "TM", "Value": ["094847.664000"]},
        "279": {"vr": "TM", "Value": ["094807.827000"]},
        "280": {"vr": "TM", "Value": ["095107.891000"]},
        "281": {"vr": "TM", "Value": ["094907.748000"]},
        "282": {"vr": "TM", "Value": ["094547.804000"]},
        "283": {"vr": "TM", "Value": ["095007.618000"]},
        "284": {"vr": "TM", "Value": ["095427.695000"]},
        "285": {"vr": "TM", "Value": ["095227.892000"]},
        "286": {"vr": "TM", "Value": ["095027.877000"]},
        "287": {"vr": "TM", "Value": ["094627.709000"]},
        "288": {"vr": "TM", "Value": ["094727.751000"]},
        "289": {"vr": "TM", "Value": ["095447.796000"]},
        "290": {"vr": "TM", "Value": ["095456.412000"]},
        "291": {"vr": "TM", "Value": ["094907.855000"]},
        "292": {"vr": "TM", "Value": ["094947.917000"]},
        "293": {"vr": "TM", "Value": ["094727.865000"]},
        "294": {"vr": "TM", "Value": ["095427.842000"]},
        "295": {"vr": "TM", "Value": ["095147.649000"]},
        "296": {"vr": "TM", "Value": ["094747.772000"]},
        "297": {"vr": "TM", "Value": ["094527.953000"]},
        "298": {"vr": "TM", "Value": ["094547.634000"]},
        "299": {"vr": "TM", "Value": ["094527.902000"]},
        "300": {"vr": "TM", "Value": ["095427.884000"]},
        "301": {"vr": "TM", "Value": ["095456.473000"]},
        "302": {"vr": "TM", "Value": ["095127.632000"]},
        "303": {"vr": "TM", "Value": ["094927.938000"]},
        "304": {"vr": "TM", "Value": ["094947.723000"]},
        "305": {"vr": "TM", "Value": ["094707.889000"]},
        "306": {"vr": "TM", "Value": ["095407.870000"]},
        "307": {"vr": "TM", "Value": ["094947.612000"]},
        "308": {"vr": "TM", "Value": ["095407.620000"]},
        "309": {"vr": "TM", "Value": ["095047.961000"]},
        "310": {"vr": "TM", "Value": ["095027.948000"]},
        "311": {"vr": "TM", "Value": ["094647.925000"]},
        "312": {"vr": "TM", "Value": ["095147.672000"]},
        "313": {"vr": "TM", "Value": ["095456.490000"]},
        "314": {"vr": "TM", "Value": ["095447.664000"]},
        "315": {"vr": "TM", "Value": ["094727.784000"]},
        "316": {"vr": "TM", "Value": ["094647.935000"]},
        "317": {"vr": "TM", "Value": ["095407.718000"]},
        "318": {"vr": "TM", "Value": ["094847.706000"]},
        "319": {"vr": "TM", "Value": ["095047.615000"]},
        "320": {"vr": "TM", "Value": ["095127.770000"]},
        "321": {"vr": "TM", "Value": ["094727.738000"]},
        "322": {"vr": "TM", "Value": ["095407.943000"]},
        "323": {"vr": "TM", "Value": ["094947.784000"]},
        "324": {"vr": "TM", "Value": ["094927.909000"]},
        "325": {"vr": "TM", "Value": ["094727.662000"]},
        "326": {"vr": "TM", "Value": ["094607.730000"]},
        "327": {"vr": "TM", "Value": ["095127.708000"]},
        "328": {"vr": "TM", "Value": ["095327.637000"]},
        "329": {"vr": "TM", "Value": ["095127.727000"]},
        "330": {"vr": "TM", "Value": ["094547.812000"]},
        "331": {"vr": "TM", "Value": ["094947.903000"]},
        "332": {"vr": "TM", "Value": ["094727.624000"]},
        "333": {"vr": "TM", "Value": ["095247.701000"]},
        "334": {"vr": "TM", "Value": ["094927.666000"]},
        "335": {"vr": "TM", "Value": ["094807.931000"]},
        "336": {"vr": "TM", "Value": ["094727.870000"]},
        "337": {"vr": "TM", "Value": ["094907.882000"]},
        "338": {"vr": "TM", "Value": ["094547.796000"]},
        "339": {"vr": "TM", "Value": ["094847.771000"]},
        "340": {"vr": "TM", "Value": ["094647.612000"]},
        "341": {"vr": "TM", "Value": ["095447.672000"]},
        "342": {"vr": "TM", "Value": ["094807.875000"]},
        "343": {"vr": "TM", "Value": ["095347.743000"]},
        "344": {"vr": "TM", "Value": ["094847.811000"]},
        "345": {"vr": "TM", "Value": ["095207.856000"]},
        "346": {"vr": "TM", "Value": ["094627.831000"]},
        "347": {"vr": "TM", "Value": ["094707.807000"]},
        "348": {"vr": "TM", "Value": ["095007.667000"]},
        "349": {"vr": "TM", "Value": ["094527.675000"]},
        "350": {"vr": "TM", "Value": ["095147.813000"]},
        "351": {"vr": "TM", "Value": ["095407.842000"]},
        "352": {"vr": "TM", "Value": ["095007.694000"]},
        "353": {"vr": "TM", "Value": ["095007.646000"]},
        "354": {"vr": "TM", "Value": ["094927.886000"]},
        "355": {"vr": "TM", "Value": ["095327.827000"]},
        "356": {"vr": "TM", "Value": ["094747.895000"]},
        "357": {"vr": "TM", "Value": ["094547.674000"]},
        "358": {"vr": "TM", "Value": ["095227.925000"]},
        "359": {"vr": "TM", "Value": ["094707.945000"]},
        "360": {"vr": "TM", "Value": ["094547.714000"]},
        "361": {"vr": "TM", "Value": ["095007.848000"]},
        "362": {"vr": "TM", "Value": ["095227.699000"]},
        "363": {"vr": "TM", "Value": ["095007.924000"]},
        "364": {"vr": "TM", "Value": ["095327.824000"]},
        "365": {"vr": "TM", "Value": ["095007.939000"]},
        "366": {"vr": "TM", "Value": ["095427.892000"]},
        "367": {"vr": "TM", "Value": ["094707.805000"]},
        "368": {"vr": "TM", "Value": ["094647.951000"]},
        "369": {"vr": "TM", "Value": ["095307.899000"]},
        "370": {"vr": "TM", "Value": ["095227.856000"]},
        "371": {"vr": "TM", "Value": ["095227.691000"]},
        "372": {"vr": "TM", "Value": ["095207.813000"]},
        "373": {"vr": "TM", "Value": ["095107.916000"]},
        "374": {"vr": "TM", "Value": ["094927.916000"]},
        "375": {"vr": "TM", "Value": ["095107.807000"]},
        "376": {"vr": "TM", "Value": ["094947.886000"]},
        "377": {"vr": "TM", "Value": ["095327.644000"]},
        "378": {"vr": "TM", "Value": ["094927.758000"]},
        "379": {"vr": "TM", "Value": ["094747.748000"]},
        "380": {"vr": "TM", "Value": ["094907.898000"]},
        "381": {"vr": "TM", "Value": ["094727.881000"]},
        "382": {"vr": "TM", "Value": ["094847.908000"]},
        "383": {"vr": "TM", "Value": ["094527.726000"]},
        "384": {"vr": "TM", "Value": ["095007.827000"]},
        "385": {"vr": "TM", "Value": ["095347.843000"]},
        "386": {"vr": "TM", "Value": ["095347.861000"]},
        "387": {"vr": "TM", "Value": ["095107.833000"]},
        "388": {"vr": "TM", "Value": ["095407.825000"]},
        "389": {"vr": "TM", "Value": ["094907.924000"]},
        "390": {"vr": "TM", "Value": ["094707.755000"]},
        "391": {"vr": "TM", "Value": ["095347.943000"]},
        "392": {"vr": "TM", "Value": ["094807.897000"]},
        "393": {"vr": "TM", "Value": ["095127.673000"]},
        "394": {"vr": "TM", "Value": ["095107.660000"]},
        "395": {"vr": "TM", "Value": ["095007.751000"]},
        "396": {"vr": "TM", "Value": ["094827.914000"]},
        "397": {"vr": "TM", "Value": ["095007.631000"]},
        "398": {"vr": "TM", "Value": ["094607.737000"]},
        "399": {"vr": "TM", "Value": ["094707.654000"]},
        "400": {"vr": "TM", "Value": ["094907.913000"]},
        "401": {"vr": "TM", "Value": ["094647.881000"]},
        "402": {"vr": "TM", "Value": ["094807.684000"]},
        "403": {"vr": "TM", "Value": ["095047.805000"]},
        "404": {"vr": "TM", "Value": ["094607.681000"]},
        "405": {"vr": "TM", "Value": ["095227.742000"]},
        "406": {"vr": "TM", "Value": ["094727.779000"]},
        "407": {"vr": "TM", "Value": ["094807.760000"]},
        "408": {"vr": "TM", "Value": ["095027.693000"]},
        "409": {"vr": "TM", "Value": ["095107.649000"]},
        "410": {"vr": "TM", "Value": ["094747.709000"]},
        "411": {"vr": "TM", "Value": ["095347.682000"]},
        "412": {"vr": "TM", "Value": ["094547.640000"]},
        "413": {"vr": "TM", "Value": ["094707.794000"]},
        "414": {"vr": "TM", "Value": ["094607.763000"]},
        "415": {"vr": "TM", "Value": ["095307.789000"]},
        "416": {"vr": "TM", "Value": ["094947.810000"]},
        "417": {"vr": "TM", "Value": ["094607.895000"]},
        "418": {"vr": "TM", "Value": ["094527.742000"]},
        "419": {"vr": "TM", "Value": ["094607.771000"]},
        "420": {"vr": "TM", "Value": ["095447.763000"]},
        "421": {"vr": "TM", "Value": ["094627.817000"]},
        "422": {"vr": "TM", "Value": ["094747.840000"]},
        "423": {"vr": "TM", "Value": ["095327.894000"]},
        "424": {"vr": "TM", "Value": ["095147.767000"]},
        "425": {"vr": "TM", "Value": ["095427.750000"]},
        "426": {"vr": "TM", "Value": ["095207.711000"]},
        "427": {"vr": "TM", "Value": ["095127.924000"]},
        "428": {"vr": "TM", "Value": ["095407.830000"]},
        "429": {"vr": "TM", "Value": ["095207.765000"]},
        "430": {"vr": "TM", "Value": ["095047.679000"]},
        "431": {"vr": "TM", "Value": ["094647.878000"]},
        "432": {"vr": "TM", "Value": ["095427.758000"]},
        "433": {"vr": "TM", "Value": ["095127.883000"]},
        "434": {"vr": "TM", "Value": ["094707.863000"]},
        "435": {"vr": "TM", "Value": ["095447.734000"]},
        "436": {"vr": "TM", "Value": ["094527.790000"]},
        "437": {"vr": "TM", "Value": ["094827.768000"]},
        "438": {"vr": "TM", "Value": ["095107.713000"]},
        "439": {"vr": "TM", "Value": ["095307.791000"]},
        "440": {"vr": "TM", "Value": ["095407.753000"]},
        "441": {"vr": "TM", "Value": ["094627.825000"]},
        "442": {"vr": "TM", "Value": ["094647.785000"]},
        "443": {"vr": "TM", "Value": ["095347.697000"]},
        "444": {"vr": "TM", "Value": ["095147.662000"]},
        "445": {"vr": "TM", "Value": ["095147.763000"]},
        "446": {"vr": "TM", "Value": ["095247.894000"]},
        "447": {"vr": "TM", "Value": ["094527.883000"]},
        "448": {"vr": "TM", "Value": ["095327.802000"]},
        "449": {"vr": "TM", "Value": ["095047.731000"]},
        "450": {"vr": "TM", "Value": ["095407.689000"]},
        "451": {"vr": "TM", "Value": ["094707.948000"]},
        "452": {"vr": "TM", "Value": ["095247.626000"]},
        "453": {"vr": "TM", "Value": ["094547.824000"]},
        "454": {"vr": "TM", "Value": ["094807.948000"]},
        "455": {"vr": "TM", "Value": ["095107.684000"]},
        "456": {"vr": "TM", "Value": ["094807.829000"]},
        "457": {"vr": "TM", "Value": ["094827.730000"]},
        "458": {"vr": "TM", "Value": ["094927.639000"]},
        "459": {"vr": "TM", "Value": ["094807.805000"]},
        "460": {"vr": "TM", "Value": ["094847.703000"]},
        "461": {"vr": "TM", "Value": ["095107.682000"]},
        "462": {"vr": "TM", "Value": ["094927.898000"]},
        "463": {"vr": "TM", "Value": ["095107.882000"]},
        "464": {"vr": "TM", "Value": ["095307.873000"]},
        "465": {"vr": "TM", "Value": ["094747.943000"]},
        "466": {"vr": "TM", "Value": ["094707.760000"]},
        "467": {"vr": "TM", "Value": ["095027.723000"]},
        "468": {"vr": "TM", "Value": ["094547.814000"]},
        "469": {"vr": "TM", "Value": ["095456.425000"]},
        "470": {"vr": "TM", "Value": ["095047.841000"]},
        "471": {"vr": "TM", "Value": ["095047.690000"]},
        "472": {"vr": "TM", "Value": ["094707.853000"]},
        "473": {"vr": "TM", "Value": ["095347.958000"]},
        "474": {"vr": "TM", "Value": ["095347.702000"]},
        "475": {"vr": "TM", "Value": ["094527.711000"]},
        "476": {"vr": "TM", "Value": ["095347.858000"]},
        "477": {"vr": "TM", "Value": ["094727.942000"]},
        "478": {"vr": "TM", "Value": ["095427.673000"]},
        "479": {"vr": "TM", "Value": ["095307.730000"]},
        "480": {"vr": "TM", "Value": ["094947.829000"]},
        "481": {"vr": "TM", "Value": ["094527.887000"]},
        "482": {"vr": "TM", "Value": ["094707.932000"]},
        "483": {"vr": "TM", "Value": ["095327.735000"]},
        "484": {"vr": "TM", "Value": ["095127.620000"]},
        "485": {"vr": "TM", "Value": ["095227.722000"]},
        "486": {"vr": "TM", "Value": ["094827.735000"]},
        "487": {"vr": "TM", "Value": ["094847.842000"]},
        "488": {"vr": "TM", "Value": ["094907.634000"]},
        "489": {"vr": "TM", "Value": ["095307.618000"]},
        "490": {"vr": "TM", "Value": ["095047.638000"]},
        "491": {"vr": "TM", "Value": ["094947.930000"]},
        "492": {"vr": "TM", "Value": ["094727.923000"]},
        "493": {"vr": "TM", "Value": ["095307.781000"]},
        "494": {"vr": "TM", "Value": ["095327.930000"]},
        "495": {"vr": "TM", "Value": ["094827.774000"]},
        "496": {"vr": "TM", "Value": ["095007.723000"]},
        "497": {"vr": "TM", "Value": ["094527.769000"]},
        "498": {"vr": "TM", "Value": ["095427.809000"]},
        "499": {"vr": "TM", "Value": ["094607.703000"]},
        "500": {"vr": "TM", "Value": ["094627.689000"]},
        "501": {"vr": "TM", "Value": ["095456.541000"]},
        "502": {"vr": "TM", "Value": ["095027.834000"]},
        "503": {"vr": "TM", "Value": ["094907.750000"]},
        "504": {"vr": "TM", "Value": ["094847.690000"]},
        "505": {"vr": "TM", "Value": ["094607.757000"]},
        "506": {"vr": "TM", "Value": ["094727.728000"]},
        "507": {"vr": "TM", "Value": ["094707.629000"]},
        "508": {"vr": "TM", "Value": ["094747.837000"]},
        "509": {"vr": "TM", "Value": ["094947.675000"]},
        "510": {"vr": "TM", "Value": ["095347.951000"]},
        "511": {"vr": "TM", "Value": ["094927.948000"]},
        "512": {"vr": "TM", "Value": ["094807.710000"]},
        "513": {"vr": "TM", "Value": ["095227.737000"]},
        "514": {"vr": "TM", "Value": ["094647.990000"]},
        "515": {"vr": "TM", "Value": ["094827.887000"]},
        "516": {"vr": "TM", "Value": ["094527.799000"]},
        "517": {"vr": "TM", "Value": ["095347.812000"]},
        "518": {"vr": "TM", "Value": ["094907.654000"]},
        "519": {"vr": "TM", "Value": ["094707.935000"]},
        "520": {"vr": "TM", "Value": ["095147.847000"]},
        "521": {"vr": "TM", "Value": ["094547.642000"]},
        "522": {"vr": "TM", "Value": ["094947.768000"]},
        "523": {"vr": "TM", "Value": ["095447.848000"]},
        "524": {"vr": "TM", "Value": ["094707.858000"]},
        "525": {"vr": "TM", "Value": ["094947.813000"]},
        "526": {"vr": "TM", "Value": ["095427.835000"]},
        "527": {"vr": "TM", "Value": ["095407.774000"]},
        "528": {"vr": "TM", "Value": ["095407.713000"]},
        "529": {"vr": "TM", "Value": ["094547.627000"]},
        "530": {"vr": "TM", "Value": ["094727.888000"]},
        "531": {"vr": "TM", "Value": ["094847.621000"]},
        "532": {"vr": "TM", "Value": ["094527.994000"]},
        "533": {"vr": "TM", "Value": ["094747.644000"]},
        "534": {"vr": "TM", "Value": ["095027.777000"]},
        "535": {"vr": "TM", "Value": ["095227.773000"]},
        "536": {"vr": "TM", "Value": ["095207.664000"]},
        "537": {"vr": "TM", "Value": ["095027.651000"]},
        "538": {"vr": "TM", "Value": ["095107.716000"]},
        "539": {"vr": "TM", "Value": ["094527.633000"]},
        "540": {"vr": "TM", "Value": ["094827.610000"]},
        "541": {"vr": "TM", "Value": ["095407.945000"]},
        "542": {"vr": "TM", "Value": ["095007.909000"]},
        "543": {"vr": "TM", "Value": ["095447.947000"]},
        "544": {"vr": "TM", "Value": ["094647.943000"]},
        "545": {"vr": "TM", "Value": ["094947.614000"]},
        "546": {"vr": "TM", "Value": ["095407.807000"]},
        "547": {"vr": "TM", "Value": ["095407.763000"]},
        "548": {"vr": "TM", "Value": ["094847.617000"]},
        "549": {"vr": "TM", "Value": ["095127.784000"]},
        "550": {"vr": "TM", "Value": ["095047.951000"]},
        "551": {"vr": "TM", "Value": ["095307.804000"]},
        "552": {"vr": "TM", "Value": ["095107.726000"]},
        "553": {"vr": "TM", "Value": ["094647.977000"]},
        "554": {"vr": "TM", "Value": ["095007.914000"]},
        "555": {"vr": "TM", "Value": ["094527.657000"]},
        "556": {"vr": "TM", "Value": ["094747.630000"]},
        "557": {"vr": "TM", "Value": ["095427.933000"]},
        "558": {"vr": "TM", "Value": ["095107.814000"]},
        "559": {"vr": "TM", "Value": ["095247.899000"]},
        "560": {"vr": "TM", "Value": ["095107.772000"]},
        "561": {"vr": "TM", "Value": ["095347.907000"]},
        "562": {"vr": "TM", "Value": ["095207.823000"]},
        "563": {"vr": "TM", "Value": ["094807.743000"]},
        "564": {"vr": "TM", "Value": ["095107.779000"]},
        "565": {"vr": "TM", "Value": ["094907.869000"]},
        "566": {"vr": "TM", "Value": ["095127.816000"]},
        "567": {"vr": "TM", "Value": ["094847.614000"]},
        "568": {"vr": "TM", "Value": ["095207.656000"]},
        "569": {"vr": "TM", "Value": ["094927.740000"]},
        "570": {"vr": "TM", "Value": ["094827.686000"]},
        "571": {"vr": "TM", "Value": ["095327.628000"]},
        "572": {"vr": "TM", "Value": ["095347.931000"]},
        "573": {"vr": "TM", "Value": ["095427.654000"]},
        "574": {"vr": "TM", "Value": ["095407.679000"]},
        "575": {"vr": "TM", "Value": ["095127.634000"]},
        "576": {"vr": "TM", "Value": ["095127.824000"]},
        "577": {"vr": "TM", "Value": ["095347.700000"]},
        "578": {"vr": "TM", "Value": ["095027.690000"]},
        "579": {"vr": "TM", "Value": ["095307.712000"]},
        "580": {"vr": "TM", "Value": ["095307.779000"]},
        "581": {"vr": "TM", "Value": ["095147.918000"]},
        "582": {"vr": "TM", "Value": ["095027.620000"]},
        "583": {"vr": "TM", "Value": ["095127.809000"]},
        "584": {"vr": "TM", "Value": ["095227.776000"]},
        "585": {"vr": "TM", "Value": ["094527.709000"]},
        "586": {"vr": "TM", "Value": ["095347.730000"]},
        "587": {"vr": "TM", "Value": ["094647.920000"]},
        "588": {"vr": "TM", "Value": ["094727.875000"]},
        "589": {"vr": "TM", "Value": ["095327.837000"]},
        "590": {"vr": "TM", "Value": ["094907.710000"]},
        "591": {"vr": "TM", "Value": ["095047.764000"]},
        "592": {"vr": "TM", "Value": ["095347.792000"]},
        "593": {"vr": "TM", "Value": ["095247.656000"]},
        "594": {"vr": "TM", "Value": ["094527.827000"]},
        "595": {"vr": "TM", "Value": ["094527.960000"]},
        "596": {"vr": "TM", "Value": ["094947.928000"]},
        "597": {"vr": "TM", "Value": ["094907.785000"]},
        "598": {"vr": "TM", "Value": ["095347.608000"]},
        "599": {"vr": "TM", "Value": ["094747.804000"]},
        "600": {"vr": "TM", "Value": ["094847.612000"]},
        "601": {"vr": "TM", "Value": ["095147.872000"]},
        "602": {"vr": "TM", "Value": ["095007.720000"]},
        "603": {"vr": "TM", "Value": ["095407.901000"]},
        "604": {"vr": "TM", "Value": ["094627.622000"]},
        "605": {"vr": "TM", "Value": ["095427.768000"]},
        "606": {"vr": "TM", "Value": ["095227.946000"]},
        "607": {"vr": "TM", "Value": ["095127.898000"]},
        "608": {"vr": "TM", "Value": ["095407.748000"]},
        "609": {"vr": "TM", "Value": ["095227.681000"]},
        "610": {"vr": "TM", "Value": ["095427.928000"]},
        "611": {"vr": "TM", "Value": ["095007.875000"]},
        "612": {"vr": "TM", "Value": ["094547.632000"]},
        "613": {"vr": "TM", "Value": ["095307.649000"]},
        "614": {"vr": "TM", "Value": ["095007.758000"]},
        "615": {"vr": "TM", "Value": ["095207.677000"]},
        "616": {"vr": "TM", "Value": ["095207.831000"]},
        "617": {"vr": "TM", "Value": ["094607.908000"]},
        "618": {"vr": "TM", "Value": ["094707.843000"]},
        "619": {"vr": "TM", "Value": ["095027.872000"]},
        "620": {"vr": "TM", "Value": ["095027.824000"]},
        "621": {"vr": "TM", "Value": ["094647.724000"]},
        "622": {"vr": "TM", "Value": ["094527.871000"]},
        "623": {"vr": "TM", "Value": ["095407.730000"]},
        "624": {"vr": "TM", "Value": ["095456.441000"]},
        "625": {"vr": "TM", "Value": ["095307.832000"]},
        "626": {"vr": "TM", "Value": ["094727.810000"]},
        "627": {"vr": "TM", "Value": ["094707.742000"]},
        "628": {"vr": "TM", "Value": ["094527.950000"]},
        "629": {"vr": "TM", "Value": ["094907.936000"]},
        "630": {"vr": "TM", "Value": ["095227.846000"]},
        "631": {"vr": "TM", "Value": ["094807.797000"]},
        "632": {"vr": "TM", "Value": ["094607.893000"]},
        "633": {"vr": "TM", "Value": ["095027.852000"]},
        "634": {"vr": "TM", "Value": ["094807.895000"]},
        "635": {"vr": "TM", "Value": ["095247.663000"]},
        "636": {"vr": "TM", "Value": ["094707.687000"]},
        "637": {"vr": "TM", "Value": ["094707.876000"]},
        "638": {"vr": "TM", "Value": ["095207.689000"]},
        "639": {"vr": "TM", "Value": ["095447.688000"]},
        "640": {"vr": "TM", "Value": ["094627.936000"]},
        "641": {"vr": "TM", "Value": ["094627.657000"]},
        "642": {"vr": "TM", "Value": ["094807.768000"]},
        "643": {"vr": "TM", "Value": ["095227.794000"]},
        "644": {"vr": "TM", "Value": ["095307.938000"]},
        "645": {"vr": "TM", "Value": ["094927.832000"]},
        "646": {"vr": "TM", "Value": ["095327.661000"]},
        "647": {"vr": "TM", "Value": ["095107.821000"]},
        "648": {"vr": "TM", "Value": ["095427.678000"]},
        "649": {"vr": "TM", "Value": ["094927.699000"]},
        "650": {"vr": "TM", "Value": ["094627.858000"]},
        "651": {"vr": "TM", "Value": ["094747.775000"]},
        "652": {"vr": "TM", "Value": ["095307.892000"]},
        "653": {"vr": "TM", "Value": ["094747.615000"]},
        "654": {"vr": "TM", "Value": ["095147.695000"]},
        "655": {"vr": "TM", "Value": ["094827.727000"]},
        "656": {"vr": "TM", "Value": ["095127.842000"]},
        "657": {"vr": "TM", "Value": ["094547.794000"]},
        "658": {"vr": "TM", "Value": ["095207.866000"]},
        "659": {"vr": "TM", "Value": ["094647.700000"]},
        "660": {"vr": "TM", "Value": ["095027.908000"]},
        "661": {"vr": "TM", "Value": ["095307.884000"]},
        "662": {"vr": "TM", "Value": ["094647.864000"]},
        "663": {"vr": "TM", "Value": ["095456.556000"]},
        "664": {"vr": "TM", "Value": ["095207.703000"]},
        "665": {"vr": "TM", "Value": ["095207.691000"]},
        "666": {"vr": "TM", "Value": ["094947.896000"]},
        "667": {"vr": "TM", "Value": ["094627.879000"]},
        "668": {"vr": "TM", "Value": ["095007.834000"]},
        "669": {"vr": "TM", "Value": ["094527.958000"]},
        "670": {"vr": "TM", "Value": ["094627.749000"]},
        "671": {"vr": "TM", "Value": ["095107.861000"]},
        "672": {"vr": "TM", "Value": ["095407.812000"]},
        "673": {"vr": "TM", "Value": ["094607.745000"]},
        "674": {"vr": "TM", "Value": ["095327.618000"]},
        "675": {"vr": "TM", "Value": ["094847.948000"]},
        "676": {"vr": "TM", "Value": ["094847.672000"]},
        "677": {"vr": "TM", "Value": ["094907.845000"]},
        "678": {"vr": "TM", "Value": ["094647.712000"]},
        "679": {"vr": "TM", "Value": ["095007.824000"]},
        "680": {"vr": "TM", "Value": ["095147.655000"]},
        "681": {"vr": "TM", "Value": ["095447.711000"]},
        "682": {"vr": "TM", "Value": ["095247.750000"]},
        "683": {"vr": "TM", "Value": ["095447.647000"]},
        "684": {"vr": "TM", "Value": ["095227.707000"]},
        "685": {"vr": "TM", "Value": ["094607.828000"]},
        "686": {"vr": "TM", "Value": ["094907.879000"]},
        "687": {"vr": "TM", "Value": ["095147.794000"]},
        "688": {"vr": "TM", "Value": ["094947.756000"]},
        "689": {"vr": "TM", "Value": ["094527.880000"]},
        "690": {"vr": "TM", "Value": ["095007.788000"]},
        "691": {"vr": "TM", "Value": ["094547.726000"]},
        "692": {"vr": "TM", "Value": ["094547.859000"]},
        "693": {"vr": "TM", "Value": ["094547.942000"]},
        "694": {"vr": "TM", "Value": ["094947.642000"]},
        "695": {"vr": "TM", "Value": ["094607.799000"]},
        "696": {"vr": "TM", "Value": ["095227.904000"]},
        "697": {"vr": "TM", "Value": ["094927.632000"]},
        "698": {"vr": "TM", "Value": ["095107.803000"]},
        "699": {"vr": "TM", "Value": ["094847.626000"]},
        "700": {"vr": "TM", "Value": ["094607.727000"]},
        "701": {"vr": "TM", "Value": ["095227.915000"]},
        "702": {"vr": "TM", "Value": ["094547.739000"]},
        "703": {"vr": "TM", "Value": ["095307.671000"]},
        "704": {"vr": "TM", "Value": ["094807.788000"]},
        "705": {"vr": "TM", "Value": ["094827.641000"]},
        "706": {"vr": "TM", "Value": ["095127.618000"]},
        "707": {"vr": "TM", "Value": ["094707.649000"]},
        "708": {"vr": "TM", "Value": ["094847.719000"]},
        "709": {"vr": "TM", "Value": ["095247.815000"]},
        "710": {"vr": "TM", "Value": ["095307.830000"]},
        "711": {"vr": "TM", "Value": ["095227.615000"]},
        "712": {"vr": "TM", "Value": ["094527.848000"]},
        "713": {"vr": "TM", "Value": ["095047.887000"]},
        "714": {"vr": "TM", "Value": ["094827.879000"]},
        "715": {"vr": "TM", "Value": ["095147.751000"]},
        "716": {"vr": "TM", "Value": ["095207.874000"]},
        "717": {"vr": "TM", "Value": ["095307.931000"]},
        "718": {"vr": "TM", "Value": ["095407.666000"]},
        "719": {"vr": "TM", "Value": ["094947.900000"]},
        "720": {"vr": "TM", "Value": ["094607.946000"]},
        "721": {"vr": "TM", "Value": ["095107.786000"]},
        "722": {"vr": "TM", "Value": ["094647.735000"]},
        "723": {"vr": "TM", "Value": ["095447.642000"]},
        "724": {"vr": "TM", "Value": ["095247.708000"]},
        "725": {"vr": "TM", "Value": ["094547.661000"]},
        "726": {"vr": "TM", "Value": ["095407.929000"]},
        "727": {"vr": "TM", "Value": ["095407.623000"]},
        "728": {"vr": "TM", "Value": ["094527.990000"]},
        "729": {"vr": "TM", "Value": ["095407.940000"]},
        "730": {"vr": "TM", "Value": ["095027.622000"]},
        "731": {"vr": "TM", "Value": ["094907.782000"]},
        "732": {"vr": "TM", "Value": ["094647.962000"]},
        "733": {"vr": "TM", "Value": ["095427.916000"]},
        "734": {"vr": "TM", "Value": ["094547.936000"]},
        "735": {"vr": "TM", "Value": ["094907.728000"]},
        "736": {"vr": "TM", "Value": ["094727.855000"]},
        "737": {"vr": "TM", "Value": ["094627.712000"]},
        "738": {"vr": "TM", "Value": ["095307.745000"]},
        "739": {"vr": "TM", "Value": ["094527.779000"]},
        "740": {"vr": "TM", "Value": ["094647.875000"]},
        "741": {"vr": "TM", "Value": ["094607.683000"]},
        "742": {"vr": "TM", "Value": ["094707.825000"]},
        "743": {"vr": "TM", "Value": ["095327.914000"]},
        "744": {"vr": "TM", "Value": ["095107.757000"]},
        "745": {"vr": "TM", "Value": ["094707.714000"]},
        "746": {"vr": "TM", "Value": ["094707.787000"]},
        "747": {"vr": "TM", "Value": ["095047.858000"]},
        "748": {"vr": "TM", "Value": ["095147.667000"]},
        "749": {"vr": "TM", "Value": ["095207.696000"]},
        "750": {"vr": "TM", "Value": ["095447.819000"]},
        "751": {"vr": "TM", "Value": ["094807.824000"]},
        "752": {"vr": "TM", "Value": ["095247.729000"]},
        "753": {"vr": "TM", "Value": ["094627.672000"]},
        "754": {"vr": "TM", "Value": ["095207.759000"]},
        "755": {"vr": "TM", "Value": ["094947.820000"]},
        "756": {"vr": "TM", "Value": ["094827.829000"]},
        "757": {"vr": "TM", "Value": ["095456.493000"]},
        "758": {"vr": "TM", "Value": ["094747.951000"]},
        "759": {"vr": "TM", "Value": ["094547.891000"]},
        "760": {"vr": "TM", "Value": ["094727.906000"]},
        "761": {"vr": "TM", "Value": ["094747.927000"]},
        "762": {"vr": "TM", "Value": ["095447.623000"]},
        "763": {"vr": "TM", "Value": ["095147.670000"]},
        "764": {"vr": "TM", "Value": ["095007.651000"]},
        "765": {"vr": "TM", "Value": ["094727.630000"]},
        "766": {"vr": "TM", "Value": ["094727.716000"]},
        "767": {"vr": "TM", "Value": ["095327.842000"]},
        "768": {"vr": "TM", "Value": ["095047.787000"]},
        "769": {"vr": "TM", "Value": ["095227.858000"]},
        "770": {"vr": "TM", "Value": ["094827.799000"]},
        "771": {"vr": "TM", "Value": ["095456.510000"]},
        "772": {"vr": "TM", "Value": ["094907.758000"]},
        "773": {"vr": "TM", "Value": ["095407.927000"]},
        "774": {"vr": "TM", "Value": ["094747.869000"]},
        "775": {"vr": "TM", "Value": ["094727.652000"]},
        "776": {"vr": "TM", "Value": ["094847.882000"]},
        "777": {"vr": "TM", "Value": ["095007.839000"]},
        "778": {"vr": "TM", "Value": ["095447.724000"]},
        "779": {"vr": "TM", "Value": ["094547.832000"]},
        "780": {"vr": "TM", "Value": ["095047.921000"]},
        "781": {"vr": "TM", "Value": ["094907.698000"]},
        "782": {"vr": "TM", "Value": ["095427.628000"]},
        "783": {"vr": "TM", "Value": ["095207.892000"]},
        "784": {"vr": "TM", "Value": ["094527.910000"]},
        "785": {"vr": "TM", "Value": ["095207.654000"]},
        "786": {"vr": "TM", "Value": ["095047.871000"]},
        "787": {"vr": "TM", "Value": ["094707.763000"]},
        "788": {"vr": "TM", "Value": ["095327.716000"]},
        "789": {"vr": "TM", "Value": ["094827.670000"]},
        "790": {"vr": "TM", "Value": ["095407.802000"]},
        "791": {"vr": "TM", "Value": ["095327.755000"]},
        "792": {"vr": "TM", "Value": ["094607.626000"]},
        "793": {"vr": "TM", "Value": ["095207.698000"]},
        "794": {"vr": "TM", "Value": ["094827.659000"]},
        "795": {"vr": "TM", "Value": ["094907.858000"]},
        "796": {"vr": "TM", "Value": ["094747.892000"]},
        "797": {"vr": "TM", "Value": ["095107.840000"]},
        "798": {"vr": "TM", "Value": ["095207.785000"]},
        "799": {"vr": "TM", "Value": ["094547.779000"]},
        "800": {"vr": "TM", "Value": ["094627.960000"]},
        "801": {"vr": "TM", "Value": ["094527.781000"]},
        "802": {"vr": "TM", "Value": ["094627.704000"]},
        "803": {"vr": "TM", "Value": ["095247.770000"]},
        "804": {"vr": "TM", "Value": ["095247.691000"]},
        "805": {"vr": "TM", "Value": ["094807.834000"]},
        "806": {"vr": "TM", "Value": ["095107.864000"]},
        "807": {"vr": "TM", "Value": ["095227.824000"]},
        "808": {"vr": "TM", "Value": ["094807.661000"]},
        "809": {"vr": "TM", "Value": ["095027.826000"]},
        "810": {"vr": "TM", "Value": ["095007.899000"]},
        "811": {"vr": "TM", "Value": ["095207.861000"]},
        "812": {"vr": "TM", "Value": ["094927.628000"]},
        "813": {"vr": "TM", "Value": ["095047.628000"]},
        "814": {"vr": "TM", "Value": ["095107.810000"]},
        "815": {"vr": "TM", "Value": ["095447.611000"]},
        "816": {"vr": "TM", "Value": ["095327.782000"]},
        "817": {"vr": "TM", "Value": ["095447.765000"]},
        "818": {"vr": "TM", "Value": ["095047.676000"]},
        "819": {"vr": "TM", "Value": ["094927.931000"]},
        "820": {"vr": "TM", "Value": ["095327.689000"]},
        "821": {"vr": "TM", "Value": ["095327.652000"]},
        "822": {"vr": "TM", "Value": ["094847.743000"]},
        "823": {"vr": "TM", "Value": ["095127.741000"]},
        "824": {"vr": "TM", "Value": ["095247.912000"]},
        "825": {"vr": "TM", "Value": ["095127.637000"]},
        "826": {"vr": "TM", "Value": ["094807.955000"]},
        "827": {"vr": "TM", "Value": ["095456.462000"]},
        "828": {"vr": "TM", "Value": ["094947.690000"]},
        "829": {"vr": "TM", "Value": ["095147.753000"]},
        "830": {"vr": "TM", "Value": ["094607.885000"]},
        "831": {"vr": "TM", "Value": ["094827.722000"]},
        "832": {"vr": "TM", "Value": ["094747.787000"]},
        "833": {"vr": "TM", "Value": ["094647.663000"]},
        "834": {"vr": "TM", "Value": ["094627.702000"]},
        "835": {"vr": "TM", "Value": ["095447.842000"]},
        "836": {"vr": "TM", "Value": ["094827.823000"]},
        "837": {"vr": "TM", "Value": ["094627.724000"]},
        "838": {"vr": "TM", "Value": ["094547.895000"]},
        "839": {"vr": "TM", "Value": ["094727.746000"]},
        "840": {"vr": "TM", "Value": ["095307.946000"]},
        "841": {"vr": "TM", "Value": ["095147.866000"]},
        "842": {"vr": "TM", "Value": ["094607.698000"]},
        "843": {"vr": "TM", "Value": ["095007.748000"]},
        "844": {"vr": "TM", "Value": ["094807.616000"]},
        "845": {"vr": "TM", "Value": ["094547.766000"]},
        "846": {"vr": "TM", "Value": ["095007.858000"]},
        "847": {"vr": "TM", "Value": ["095207.770000"]},
        "848": {"vr": "TM", "Value": ["094947.877000"]},
        "849": {"vr": "TM", "Value": ["094627.751000"]},
        "850": {"vr": "TM", "Value": ["095147.719000"]},
        "851": {"vr": "TM", "Value": ["095047.625000"]},
        "852": {"vr": "TM", "Value": ["095027.946000"]},
        "853": {"vr": "TM", "Value": ["095227.739000"]},
        "854": {"vr": "TM", "Value": ["094747.734000"]},
        "855": {"vr": "TM", "Value": ["094727.841000"]},
        "856": {"vr": "TM", "Value": ["094927.801000"]},
        "857": {"vr": "TM", "Value": ["095107.921000"]},
        "858": {"vr": "TM", "Value": ["094807.643000"]},
        "859": {"vr": "TM", "Value": ["094607.874000"]},
        "860": {"vr": "TM", "Value": ["094847.701000"]},
        "861": {"vr": "TM", "Value": ["095456.414000"]},
        "862": {"vr": "TM", "Value": ["095347.881000"]},
        "863": {"vr": "TM", "Value": ["095127.865000"]},
        "864": {"vr": "TM", "Value": ["095447.804000"]},
        "865": {"vr": "TM", "Value": ["094907.658000"]},
        "866": {"vr": "TM", "Value": ["095207.931000"]},
        "867": {"vr": "TM", "Value": ["094707.632000"]},
        "868": {"vr": "TM", "Value": ["095147.743000"]},
        "869": {"vr": "TM", "Value": ["094707.753000"]},
        "870": {"vr": "TM", "Value": ["094827.909000"]},
        "871": {"vr": "TM", "Value": ["094927.842000"]},
        "872": {"vr": "TM", "Value": ["094547.659000"]},
        "873": {"vr": "TM", "Value": ["095347.735000"]},
        "874": {"vr": "TM", "Value": ["095207.624000"]},
        "875": {"vr": "TM", "Value": ["094527.758000"]},
        "876": {"vr": "TM", "Value": ["094707.835000"]},
        "877": {"vr": "TM", "Value": ["094607.911000"]},
        "878": {"vr": "TM", "Value": ["095347.815000"]},
        "879": {"vr": "TM", "Value": ["094547.734000"]},
        "880": {"vr": "TM", "Value": ["094607.794000"]},
        "881": {"vr": "TM", "Value": ["094727.610000"]},
        "882": {"vr": "TM", "Value": ["094607.866000"]},
        "883": {"vr": "TM", "Value": ["094707.856000"]},
        "884": {"vr": "TM", "Value": ["095327.904000"]},
        "885": {"vr": "TM", "Value": ["095456.544000"]},
        "886": {"vr": "TM", "Value": ["094727.786000"]},
        "887": {"vr": "TM", "Value": ["094947.910000"]},
        "888": {"vr": "TM", "Value": ["094707.750000"]},
        "889": {"vr": "TM", "Value": ["094607.666000"]},
        "890": {"vr": "TM", "Value": ["094747.954000"]},
        "891": {"vr": "TM", "Value": ["095007.776000"]},
        "892": {"vr": "TM", "Value": ["095427.649000"]},
        "893": {"vr": "TM", "Value": ["095047.813000"]},
        "894": {"vr": "TM", "Value": ["094747.819000"]},
        "895": {"vr": "TM", "Value": ["095007.634000"]},
        "896": {"vr": "TM", "Value": ["094647.727000"]},
        "897": {"vr": "TM", "Value": ["095007.641000"]},
        "898": {"vr": "TM", "Value": ["095027.867000"]},
        "899": {"vr": "TM", "Value": ["094907.628000"]},
        "900": {"vr": "TM", "Value": ["094927.893000"]},
        "901": {"vr": "TM", "Value": ["094607.941000"]},
        "902": {"vr": "TM", "Value": ["095027.941000"]},
        "903": {"vr": "TM", "Value": ["095447.928000"]},
        "904": {"vr": "TM", "Value": ["094627.677000"]},
        "905": {"vr": "TM", "Value": ["094727.919000"]},
        "906": {"vr": "TM", "Value": ["094627.645000"]},
        "907": {"vr": "TM", "Value": ["095207.772000"]},
        "908": {"vr": "TM", "Value": ["095007.656000"]},
        "909": {"vr": "TM", "Value": ["095447.742000"]},
        "910": {"vr": "TM", "Value": ["095107.859000"]},
        "911": {"vr": "TM", "Value": ["094907.780000"]},
        "912": {"vr": "TM", "Value": ["095427.830000"]},
        "913": {"vr": "TM", "Value": ["095127.608000"]},
        "914": {"vr": "TM", "Value": ["094727.857000"]},
        "915": {"vr": "TM", "Value": ["095047.792000"]},
        "916": {"vr": "TM", "Value": ["095427.921000"]},
        "917": {"vr": "TM", "Value": ["095147.864000"]},
        "918": {"vr": "TM", "Value": ["095307.676000"]},
        "919": {"vr": "TM", "Value": ["094527.700000"]},
        "920": {"vr": "TM", "Value": ["094647.816000"]},
        "921": {"vr": "TM", "Value": ["094807.753000"]},
        "922": {"vr": "TM", "Value": ["095307.663000"]},
        "923": {"vr": "TM", "Value": ["095227.932000"]},
        "924": {"vr": "TM", "Value": ["094527.622000"]},
        "925": {"vr": "TM", "Value": ["094547.893000"]},
        "926": {"vr": "TM", "Value": ["095456.427000"]},
        "927": {"vr": "TM", "Value": ["095207.747000"]},
        "928": {"vr": "TM", "Value": ["095347.626000"]},
        "929": {"vr": "TM", "Value": ["095047.620000"]},
        "930": {"vr": "TM", "Value": ["094947.778000"]},
        "931": {"vr": "TM", "Value": ["095007.768000"]},
        "932": {"vr": "TM", "Value": ["095456.476000"]},
        "933": {"vr": "TM", "Value": ["095127.644000"]},
        "934": {"vr": "TM", "Value": ["094547.753000"]},
        "935": {"vr": "TM", "Value": ["094927.840000"]},
        "936": {"vr": "TM", "Value": ["095147.825000"]},
        "937": {"vr": "TM", "Value": ["094927.819000"]},
        "938": {"vr": "TM", "Value": ["095456.404000"]},
        "939": {"vr": "TM", "Value": ["094907.691000"]},
        "940": {"vr": "TM", "Value": ["095307.820000"]},
        "941": {"vr": "TM", "Value": ["095307.773000"]},
        "942": {"vr": "TM", "Value": ["094707.953000"]},
        "943": {"vr": "TM", "Value": ["094927.822000"]},
        "944": {"vr": "TM", "Value": ["095127.772000"]},
        "945": {"vr": "TM", "Value": ["095407.862000"]},
        "946": {"vr": "TM", "Value": ["095127.658000"]},
        "947": {"vr": "TM", "Value": ["094907.929000"]},
        "948": {"vr": "TM", "Value": ["095147.823000"]},
        "949": {"vr": "TM", "Value": ["094827.709000"]},
        "950": {"vr": "TM", "Value": ["095247.928000"]},
        "951": {"vr": "TM", "Value": ["094907.919000"]},
        "952": {"vr": "TM", "Value": ["094727.677000"]},
        "953": {"vr": "TM", "Value": ["095027.842000"]},
        "954": {"vr": "TM", "Value": ["095227.630000"]},
        "955": {"vr": "TM", "Value": ["094607.830000"]},
        "956": {"vr": "TM", "Value": ["095147.840000"]},
        "957": {"vr": "TM", "Value": ["094907.861000"]},
        "958": {"vr": "TM", "Value": ["095247.891000"]},
        "959": {"vr": "TM", "Value": ["094827.688000"]},
        "960": {"vr": "TM", "Value": ["094927.768000"]},
        "961": {"vr": "TM", "Value": ["095007.831000"]},
        "962": {"vr": "TM", "Value": ["095307.840000"]},
        "963": {"vr": "TM", "Value": ["095207.798000"]},
        "964": {"vr": "TM", "Value": ["094647.862000"]},
        "965": {"vr": "TM", "Value": ["094747.816000"]},
        "966": {"vr": "TM", "Value": ["094927.702000"]},
        "967": {"vr": "TM", "Value": ["095407.735000"]},
        "968": {"vr": "TM", "Value": ["094707.938000"]},
        "969": {"vr": "TM", "Value": ["094727.642000"]},
        "970": {"vr": "TM", "Value": ["094527.977000"]},
        "971": {"vr": "TM", "Value": ["094727.768000"]},
        "972": {"vr": "TM", "Value": ["095407.867000"]},
        "973": {"vr": "TM", "Value": ["095327.876000"]},
        "974": {"vr": "TM", "Value": ["095047.693000"]},
        "975": {"vr": "TM", "Value": ["095127.919000"]},
        "976": {"vr": "TM", "Value": ["094807.614000"]},
        "977": {"vr": "TM", "Value": ["094947.773000"]},
        "978": {"vr": "TM", "Value": ["095456.507000"]},
        "979": {"vr": "TM", "Value": ["095147.895000"]},
        "980": {"vr": "TM", "Value": ["095207.686000"]},
        "981": {"vr": "TM", "Value": ["095347.766000"]},
        "982": {"vr": "TM", "Value": ["094907.842000"]},
        "983": {"vr": "TM", "Value": ["095147.837000"]},
        "984": {"vr": "TM", "Value": ["095307.641000"]},
        "985": {"vr": "TM", "Value": ["094947.770000"]},
        "986": {"vr": "TM", "Value": ["094847.725000"]},
        "987": {"vr": "TM", "Value": ["094527.987000"]},
        "988": {"vr": "TM", "Value": ["095347.618000"]},
        "989": {"vr": "TM", "Value": ["094927.704000"]},
        "990": {"vr": "TM", "Value": ["094947.801000"]},
        "991": {"vr": "TM", "Value": ["095407.852000"]},
        "992": {"vr": "TM", "Value": ["094827.631000"]},
        "993": {"vr": "TM", "Value": ["095427.807000"]},
        "994": {"vr": "TM", "Value": ["094647.751000"]},
        "995": {"vr": "TM", "Value": ["095307.827000"]},
        "996": {"vr": "TM", "Value": ["095456.410000"]},
        "997": {"vr": "TM", "Value": ["095227.709000"]},
        "998": {"vr": "TM", "Value": ["095307.613000"]},
        "999": {"vr": "TM", "Value": ["095427.951000"]},
        "1000": {"vr": "TM", "Value": ["095007.636000"]},
        "1001": {"vr": "TM", "Value": ["095447.616000"]},
        "1002": {"vr": "TM", "Value": ["094607.715000"]},
        "1003": {"vr": "TM", "Value": ["094747.657000"]},
        "1004": {"vr": "TM", "Value": ["095347.764000"]},
        "1005": {"vr": "TM", "Value": ["095207.614000"]},
        "1006": {"vr": "TM", "Value": ["095227.801000"]},
        "1007": {"vr": "TM", "Value": ["094727.673000"]},
        "1008": {"vr": "TM", "Value": ["094627.679000"]},
        "1009": {"vr": "TM", "Value": ["094727.794000"]},
        "1010": {"vr": "TM", "Value": ["095347.677000"]},
        "1011": {"vr": "TM", "Value": ["095447.866000"]},
        "1012": {"vr": "TM", "Value": ["095227.653000"]},
        "1013": {"vr": "TM", "Value": ["095227.806000"]},
        "1014": {"vr": "TM", "Value": ["095147.907000"]},
        "1015": {"vr": "TM", "Value": ["095456.522000"]},
        "1016": {"vr": "TM", "Value": ["094827.949000"]},
        "1017": {"vr": "TM", "Value": ["095447.659000"]},
        "1018": {"vr": "TM", "Value": ["094807.635000"]},
        "1019": {"vr": "TM", "Value": ["095347.894000"]},
        "1020": {"vr": "TM", "Value": ["095207.884000"]},
        "1021": {"vr": "TM", "Value": ["095427.797000"]},
        "1022": {"vr": "TM", "Value": ["094847.803000"]},
        "1023": {"vr": "TM", "Value": ["094907.909000"]},
        "1024": {"vr": "TM", "Value": ["095227.696000"]},
        "1025": {"vr": "TM", "Value": ["094547.751000"]},
        "1026": {"vr": "TM", "Value": ["094547.879000"]},
        "1027": {"vr": "TM", "Value": ["095207.905000"]},
        "1028": {"vr": "TM", "Value": ["095347.715000"]},
        "1029": {"vr": "TM", "Value": ["095047.923000"]},
        "1030": {"vr": "TM", "Value": ["094527.753000"]},
        "1031": {"vr": "TM", "Value": ["094647.698000"]},
        "1032": {"vr": "TM", "Value": ["094827.868000"]},
        "1033": {"vr": "TM", "Value": ["094947.624000"]},
        "1034": {"vr": "TM", "Value": ["094647.873000"]},
        "1035": {"vr": "TM", "Value": ["095407.674000"]},
        "1036": {"vr": "TM", "Value": ["094847.867000"]},
        "1037": {"vr": "TM", "Value": ["095107.736000"]},
        "1038": {"vr": "TM", "Value": ["094627.945000"]},
        "1039": {"vr": "TM", "Value": ["094847.607000"]},
        "1040": {"vr": "TM", "Value": ["094827.712000"]},
        "1041": {"vr": "TM", "Value": ["095207.879000"]},
        "1042": {"vr": "TM", "Value": ["094827.747000"]},
        "1043": {"vr": "TM", "Value": ["095027.751000"]},
        "1044": {"vr": "TM", "Value": ["094807.792000"]},
        "1045": {"vr": "TM", "Value": ["094607.708000"]},
        "1046": {"vr": "TM", "Value": ["095107.791000"]},
        "1047": {"vr": "TM", "Value": ["095407.903000"]},
        "1048": {"vr": "TM", "Value": ["095427.766000"]},
        "1049": {"vr": "TM", "Value": ["094547.756000"]},
        "1050": {"vr": "TM", "Value": ["095047.777000"]},
        "1051": {"vr": "TM", "Value": ["095007.616000"]},
        "1052": {"vr": "TM", "Value": ["094647.693000"]},
        "1053": {"vr": "TM", "Value": ["095107.796000"]},
        "1054": {"vr": "TM", "Value": ["094627.918000"]},
        "1055": {"vr": "TM", "Value": ["094847.662000"]},
        "1056": {"vr": "TM", "Value": ["095307.812000"]},
        "1057": {"vr": "TM", "Value": ["095427.690000"]},
        "1058": {"vr": "TM", "Value": ["095227.712000"]},
        "1059": {"vr": "TM", "Value": ["094907.762000"]},
        "1060": {"vr": "TM", "Value": ["094527.735000"]},
        "1061": {"vr": "TM", "Value": ["094547.862000"]},
        "1062": {"vr": "TM", "Value": ["094727.833000"]},
        "1063": {"vr": "TM", "Value": ["094847.716000"]},
        "1064": {"vr": "TM", "Value": ["094727.921000"]},
        "1065": {"vr": "TM", "Value": ["094847.610000"]},
        "1066": {"vr": "TM", "Value": ["094907.616000"]},
        "1067": {"vr": "TM", "Value": ["095207.841000"]},
        "1068": {"vr": "TM", "Value": ["095307.951000"]},
        "1069": {"vr": "TM", "Value": ["095047.963000"]},
        "1070": {"vr": "TM", "Value": ["094727.660000"]},
        "1071": {"vr": "TM", "Value": ["095307.761000"]},
        "1072": {"vr": "TM", "Value": ["095207.921000"]},
        "1073": {"vr": "TM", "Value": ["095456.478000"]},
        "1074": {"vr": "TM", "Value": ["095447.935000"]},
        "1075": {"vr": "TM", "Value": ["094647.759000"]},
        "1076": {"vr": "TM", "Value": ["095107.653000"]},
        "1077": {"vr": "TM", "Value": ["095227.939000"]},
        "1078": {"vr": "TM", "Value": ["094727.647000"]},
        "1079": {"vr": "TM", "Value": ["095307.856000"]},
        "1080": {"vr": "TM", "Value": ["094827.766000"]},
        "1081": {"vr": "TM", "Value": ["094647.960000"]},
        "1082": {"vr": "TM", "Value": ["095207.894000"]},
        "1083": {"vr": "TM", "Value": ["095207.936000"]},
        "1084": {"vr": "TM", "Value": ["094627.697000"]},
        "1085": {"vr": "TM", "Value": ["095307.799000"]},
        "1086": {"vr": "TM", "Value": ["095207.838000"]},
        "1087": {"vr": "TM", "Value": ["095207.872000"]},
        "1088": {"vr": "TM", "Value": ["095327.792000"]},
        "1089": {"vr": "TM", "Value": ["095207.661000"]},
        "1090": {"vr": "TM", "Value": ["095007.808000"]},
        "1091": {"vr": "TM", "Value": ["094847.624000"]},
        "1092": {"vr": "TM", "Value": ["095147.923000"]},
        "1093": {"vr": "TM", "Value": ["094627.773000"]},
        "1094": {"vr": "TM", "Value": ["095447.627000"]},
        "1095": {"vr": "TM", "Value": ["095227.734000"]},
        "1096": {"vr": "TM", "Value": ["095127.623000"]},
        "1097": {"vr": "TM", "Value": ["094827.947000"]},
        "1098": {"vr": "TM", "Value": ["095347.615000"]},
        "1099": {"vr": "TM", "Value": ["095127.903000"]},
        "1100": {"vr": "TM", "Value": ["094947.905000"]},
        "1101": {"vr": "TM", "Value": ["095127.829000"]},
        "1102": {"vr": "TM", "Value": ["095127.694000"]},
        "1103": {"vr": "TM", "Value": ["095307.886000"]},
        "1104": {"vr": "TM", "Value": ["094647.690000"]},
        "1105": {"vr": "TM", "Value": ["095147.741000"]},
        "1106": {"vr": "TM", "Value": ["094647.714000"]},
        "1107": {"vr": "TM", "Value": ["095007.669000"]},
        "1108": {"vr": "TM", "Value": ["094747.620000"]},
        "1109": {"vr": "TM", "Value": ["095427.871000"]},
        "1110": {"vr": "TM", "Value": ["095327.664000"]},
        "1111": {"vr": "TM", "Value": ["094807.778000"]},
        "1112": {"vr": "TM", "Value": ["094727.741000"]},
        "1113": {"vr": "TM", "Value": ["095207.667000"]},
        "1114": {"vr": "TM", "Value": ["094947.935000"]},
        "1115": {"vr": "TM", "Value": ["095427.693000"]},
        "1116": {"vr": "TM", "Value": ["094527.907000"]},
        "1117": {"vr": "TM", "Value": ["095247.687000"]},
        "1118": {"vr": "TM", "Value": ["094727.690000"]},
        "1119": {"vr": "TM", "Value": ["095427.671000"]},
        "1120": {"vr": "TM", "Value": ["095427.931000"]},
        "1121": {"vr": "TM", "Value": ["094947.808000"]},
        "1122": {"vr": "TM", "Value": ["094727.640000"]},
        "1123": {"vr": "TM", "Value": ["094627.632000"]},
        "1124": {"vr": "TM", "Value": ["094947.658000"]},
        "1125": {"vr": "TM", "Value": ["094927.651000"]},
        "1126": {"vr": "TM", "Value": ["095447.911000"]},
        "1127": {"vr": "TM", "Value": ["094647.833000"]},
        "1128": {"vr": "TM", "Value": ["095127.779000"]},
        "1129": {"vr": "TM", "Value": ["094847.819000"]},
        "1130": {"vr": "TM", "Value": ["095427.873000"]},
        "1131": {"vr": "TM", "Value": ["094707.678000"]},
        "1132": {"vr": "TM", "Value": ["094647.857000"]},
        "1133": {"vr": "TM", "Value": ["095107.706000"]},
        "1134": {"vr": "TM", "Value": ["095227.637000"]},
        "1135": {"vr": "TM", "Value": ["094927.719000"]},
        "1136": {"vr": "TM", "Value": ["094827.929000"]},
        "1137": {"vr": "TM", "Value": ["095307.627000"]},
        "1138": {"vr": "TM", "Value": ["094647.680000"]},
        "1139": {"vr": "TM", "Value": ["095027.632000"]},
        "1140": {"vr": "TM", "Value": ["094607.641000"]},
        "1141": {"vr": "TM", "Value": ["094907.725000"]},
        "1142": {"vr": "TM", "Value": ["094627.607000"]},
        "1143": {"vr": "TM", "Value": ["094647.675000"]},
        "1144": {"vr": "TM", "Value": ["094747.617000"]},
        "1145": {"vr": "TM", "Value": ["095007.743000"]},
        "1146": {"vr": "TM", "Value": ["094827.615000"]},
        "1147": {"vr": "TM", "Value": ["095456.502000"]},
        "1148": {"vr": "TM", "Value": ["094707.651000"]},
        "1149": {"vr": "TM", "Value": ["094527.666000"]},
        "1150": {"vr": "TM", "Value": ["095447.721000"]},
        "1151": {"vr": "TM", "Value": ["094927.858000"]},
        "1152": {"vr": "TM", "Value": ["095047.674000"]},
        "1153": {"vr": "TM", "Value": ["095007.733000"]},
        "1154": {"vr": "TM", "Value": ["095107.613000"]},
        "1155": {"vr": "TM", "Value": ["095047.723000"]},
        "1156": {"vr": "TM", "Value": ["094647.846000"]},
        "1157": {"vr": "TM", "Value": ["094547.657000"]},
        "1158": {"vr": "TM", "Value": ["095247.901000"]},
        "1159": {"vr": "TM", "Value": ["095007.674000"]},
        "1160": {"vr": "TM", "Value": ["095107.741000"]},
        "1161": {"vr": "TM", "Value": ["094707.727000"]},
        "1162": {"vr": "TM", "Value": ["095127.827000"]},
        "1163": {"vr": "TM", "Value": ["095127.744000"]},
        "1164": {"vr": "TM", "Value": ["094927.770000"]},
        "1165": {"vr": "TM", "Value": ["095327.765000"]},
        "1166": {"vr": "TM", "Value": ["094527.740000"]},
        "1167": {"vr": "TM", "Value": ["095227.849000"]},
        "1168": {"vr": "TM", "Value": ["094607.804000"]},
        "1169": {"vr": "TM", "Value": ["095307.794000"]},
        "1170": {"vr": "TM", "Value": ["095327.873000"]},
        "1171": {"vr": "TM", "Value": ["094627.881000"]},
        "1172": {"vr": "TM", "Value": ["095147.913000"]},
        "1173": {"vr": "TM", "Value": ["095407.924000"]},
        "1174": {"vr": "TM", "Value": ["095207.619000"]},
        "1175": {"vr": "TM", "Value": ["095247.746000"]},
        "1176": {"vr": "TM", "Value": ["095247.635000"]},
        "1177": {"vr": "TM", "Value": ["095347.684000"]},
        "1178": {"vr": "TM", "Value": ["094527.767000"]},
        "1179": {"vr": "TM", "Value": ["094747.654000"]},
        "1180": {"vr": "TM", "Value": ["094907.738000"]},
        "1181": {"vr": "TM", "Value": ["094847.787000"]},
        "1182": {"vr": "TM", "Value": ["094547.918000"]},
        "1183": {"vr": "TM", "Value": ["095027.847000"]},
        "1184": {"vr": "TM", "Value": ["095307.758000"]},
        "1185": {"vr": "TM", "Value": ["094907.806000"]},
        "1186": {"vr": "TM", "Value": ["094547.712000"]},
        "1187": {"vr": "TM", "Value": ["094947.796000"]},
        "1188": {"vr": "TM", "Value": ["095247.841000"]},
        "1189": {"vr": "TM", "Value": ["095327.694000"]},
        "1190": {"vr": "TM", "Value": ["095407.817000"]},
        "1191": {"vr": "TM", "Value": ["094527.729000"]},
        "1192": {"vr": "TM", "Value": ["094707.745000"]},
        "1193": {"vr": "TM", "Value": ["095007.861000"]},
        "1194": {"vr": "TM", "Value": ["095447.894000"]},
        "1195": {"vr": "TM", "Value": ["094927.735000"]},
        "1196": {"vr": "TM", "Value": ["094547.691000"]},
        "1197": {"vr": "TM", "Value": ["095427.666000"]},
        "1198": {"vr": "TM", "Value": ["094847.641000"]},
        "1199": {"vr": "TM", "Value": ["095207.869000"]},
        "1200": {"vr": "TM", "Value": ["095307.889000"]},
        "1201": {"vr": "TM", "Value": ["094527.689000"]},
        "1202": {"vr": "TM", "Value": ["094707.609000"]},
        "1203": {"vr": "TM", "Value": ["095447.737000"]},
        "1204": {"vr": "TM", "Value": ["095227.899000"]},
        "1205": {"vr": "TM", "Value": ["095047.941000"]},
        "1206": {"vr": "TM", "Value": ["095327.922000"]},
        "1207": {"vr": "TM", "Value": ["095127.748000"]},
        "1208": {"vr": "TM", "Value": ["094547.610000"]},
        "1209": {"vr": "TM", "Value": ["094547.920000"]},
        "1210": {"vr": "TM", "Value": ["095047.635000"]},
        "1211": {"vr": "TM", "Value": ["095447.675000"]},
        "1212": {"vr": "TM", "Value": ["094727.939000"]},
        "1213": {"vr": "TM", "Value": ["095027.700000"]},
        "1214": {"vr": "TM", "Value": ["095407.723000"]},
        "1215": {"vr": "TM", "Value": ["095047.810000"]},
        "1216": {"vr": "TM", "Value": ["095207.902000"]},
        "1217": {"vr": "TM", "Value": ["095227.871000"]},
        "1218": {"vr": "TM", "Value": ["094527.943000"]},
        "1219": {"vr": "TM", "Value": ["095327.699000"]},
        "1220": {"vr": "TM", "Value": ["095327.777000"]},
        "1221": {"vr": "TM", "Value": ["095427.724000"]},
        "1222": {"vr": "TM", "Value": ["094707.943000"]},
        "1223": {"vr": "TM", "Value": ["095407.656000"]},
        "1224": {"vr": "TM", "Value": ["094847.930000"]},
        "1225": {"vr": "TM", "Value": ["094547.731000"]},
        "1226": {"vr": "TM", "Value": ["094527.955000"]},
        "1227": {"vr": "TM", "Value": ["095427.773000"]},
        "1228": {"vr": "TM", "Value": ["095427.700000"]},
        "1229": {"vr": "TM", "Value": ["095207.611000"]},
        "1230": {"vr": "TM", "Value": ["095127.862000"]},
        "1231": {"vr": "TM", "Value": ["095347.776000"]},
        "1232": {"vr": "TM", "Value": ["095407.951000"]},
        "1233": {"vr": "TM", "Value": ["094747.731000"]},
        "1234": {"vr": "TM", "Value": ["094647.614000"]},
        "1235": {"vr": "TM", "Value": ["094827.740000"]},
        "1236": {"vr": "TM", "Value": ["094547.689000"]},
        "1237": {"vr": "TM", "Value": ["095447.814000"]},
        "1238": {"vr": "TM", "Value": ["094827.733000"]},
        "1239": {"vr": "TM", "Value": ["094707.692000"]},
        "1240": {"vr": "TM", "Value": ["094707.912000"]},
        "1241": {"vr": "TM", "Value": ["094527.857000"]},
        "1242": {"vr": "TM", "Value": ["095207.631000"]},
        "1243": {"vr": "TM", "Value": ["095247.763000"]},
        "1244": {"vr": "TM", "Value": ["095047.800000"]},
        "1245": {"vr": "TM", "Value": ["094907.619000"]},
        "1246": {"vr": "TM", "Value": ["095247.755000"]},
        "1247": {"vr": "TM", "Value": ["094747.662000"]},
        "1248": {"vr": "TM", "Value": ["095007.687000"]},
        "1249": {"vr": "TM", "Value": ["095347.779000"]},
        "1250": {"vr": "TM", "Value": ["094547.928000"]},
        "1251": {"vr": "TM", "Value": ["095127.934000"]},
        "1252": {"vr": "TM", "Value": ["095007.679000"]},
        "1253": {"vr": "TM", "Value": ["095327.909000"]},
        "1254": {"vr": "TM", "Value": ["094847.649000"]},
        "1255": {"vr": "TM", "Value": ["094847.887000"]},
        "1256": {"vr": "TM", "Value": ["095227.640000"]},
        "1257": {"vr": "TM", "Value": ["094527.916000"]},
        "1258": {"vr": "TM", "Value": ["094607.864000"]},
        "1259": {"vr": "TM", "Value": ["095307.611000"]},
        "1260": {"vr": "TM", "Value": ["095147.727000"]},
        "1261": {"vr": "TM", "Value": ["094647.732000"]},
        "1262": {"vr": "TM", "Value": ["094747.636000"]},
        "1263": {"vr": "TM", "Value": ["095147.910000"]},
        "1264": {"vr": "TM", "Value": ["094707.656000"]},
        "1265": {"vr": "TM", "Value": ["094727.665000"]},
        "1266": {"vr": "TM", "Value": ["094807.666000"]},
        "1267": {"vr": "TM", "Value": ["095047.759000"]},
        "1268": {"vr": "TM", "Value": ["095007.629000"]},
        "1269": {"vr": "TM", "Value": ["094607.812000"]},
        "1270": {"vr": "TM", "Value": ["094627.916000"]},
        "1271": {"vr": "TM", "Value": ["095456.495000"]},
        "1272": {"vr": "TM", "Value": ["094927.860000"]},
        "1273": {"vr": "TM", "Value": ["094727.723000"]},
        "1274": {"vr": "TM", "Value": ["095207.718000"]},
        "1275": {"vr": "TM", "Value": ["095307.639000"]},
        "1276": {"vr": "TM", "Value": ["095407.794000"]},
        "1277": {"vr": "TM", "Value": ["095427.743000"]},
        "1278": {"vr": "TM", "Value": ["094927.714000"]},
        "1279": {"vr": "TM", "Value": ["094907.730000"]},
        "1280": {"vr": "TM", "Value": ["094607.740000"]},
        "1281": {"vr": "TM", "Value": ["095207.793000"]},
        "1282": {"vr": "TM", "Value": ["094707.682000"]},
        "1283": {"vr": "TM", "Value": ["095207.749000"]},
        "1284": {"vr": "TM", "Value": ["095207.941000"]},
        "1285": {"vr": "TM", "Value": ["094907.837000"]},
        "1286": {"vr": "TM", "Value": ["094907.743000"]},
        "1287": {"vr": "TM", "Value": ["094907.916000"]},
        "1288": {"vr": "TM", "Value": ["094807.926000"]},
        "1289": {"vr": "TM", "Value": ["095247.682000"]},
        "1290": {"vr": "TM", "Value": ["094807.755000"]},
        "1291": {"vr": "TM", "Value": ["094527.692000"]},
        "1292": {"vr": "TM", "Value": ["094927.793000"]},
        "1293": {"vr": "TM", "Value": ["095027.608000"]},
        "1294": {"vr": "TM", "Value": ["095347.674000"]},
        "1295": {"vr": "TM", "Value": ["094927.923000"]},
        "1296": {"vr": "TM", "Value": ["094727.688000"]},
        "1297": {"vr": "TM", "Value": ["094707.917000"]},
        "1298": {"vr": "TM", "Value": ["094527.895000"]},
        "1299": {"vr": "TM", "Value": ["094627.868000"]},
        "1300": {"vr": "TM", "Value": ["095007.836000"]},
        "1301": {"vr": "TM", "Value": ["094947.834000"]},
        "1302": {"vr": "TM", "Value": ["094527.948000"]},
        "1303": {"vr": "TM", "Value": ["095407.664000"]},
        "1304": {"vr": "TM", "Value": ["094927.664000"]},
        "1305": {"vr": "TM", "Value": ["095007.703000"]},
        "1306": {"vr": "TM", "Value": ["094547.947000"]},
        "1307": {"vr": "TM", "Value": ["095307.897000"]},
        "1308": {"vr": "TM", "Value": ["094627.921000"]},
        "1309": {"vr": "TM", "Value": ["094647.922000"]},
        "1310": {"vr": "TM", "Value": ["094527.914000"]},
        "1311": {"vr": "TM", "Value": ["094947.848000"]},
        "1312": {"vr": "TM", "Value": ["095407.890000"]},
        "1313": {"vr": "TM", "Value": ["094947.617000"]},
        "1314": {"vr": "TM", "Value": ["094727.901000"]},
        "1315": {"vr": "TM", "Value": ["094527.928000"]},
        "1316": {"vr": "TM", "Value": ["095027.936000"]},
        "1317": {"vr": "TM", "Value": ["094907.644000"]},
        "1318": {"vr": "TM", "Value": ["094607.671000"]},
        "1319": {"vr": "TM", "Value": ["094647.620000"]},
        "1320": {"vr": "TM", "Value": ["095247.865000"]},
        "1321": {"vr": "TM", "Value": ["094947.855000"]},
        "1322": {"vr": "TM", "Value": ["094627.615000"]},
        "1323": {"vr": "TM", "Value": ["094747.890000"]},
        "1324": {"vr": "TM", "Value": ["094827.863000"]},
        "1325": {"vr": "TM", "Value": ["094547.652000"]},
        "1326": {"vr": "TM", "Value": ["094827.846000"]},
        "1327": {"vr": "TM", "Value": ["095407.837000"]},
        "1328": {"vr": "TM", "Value": ["094727.756000"]},
        "1329": {"vr": "TM", "Value": ["095147.905000"]},
        "1330": {"vr": "TM", "Value": ["095456.488000"]},
        "1331": {"vr": "TM", "Value": ["094927.669000"]},
        "1332": {"vr": "TM", "Value": ["095347.897000"]},
        "1333": {"vr": "TM", "Value": ["095327.794000"]},
        "1334": {"vr": "TM", "Value": ["095247.694000"]},
        "1335": {"vr": "TM", "Value": ["094747.938000"]},
        "1336": {"vr": "TM", "Value": ["095027.685000"]},
        "1337": {"vr": "TM", "Value": ["094727.828000"]},
        "1338": {"vr": "TM", "Value": ["094847.849000"]},
        "1339": {"vr": "TM", "Value": ["095227.781000"]},
        "1340": {"vr": "TM", "Value": ["094607.789000"]},
        "1341": {"vr": "TM", "Value": ["095427.647000"]},
        "1342": {"vr": "TM", "Value": ["094627.650000"]},
        "1343": {"vr": "TM", "Value": ["095247.832000"]},
        "1344": {"vr": "TM", "Value": ["094727.753000"]},
        "1345": {"vr": "TM", "Value": ["094727.792000"]},
        "1346": {"vr": "TM", "Value": ["094627.759000"]},
        "1347": {"vr": "TM", "Value": ["094527.747000"]},
        "1348": {"vr": "TM", "Value": ["095127.858000"]},
        "1349": {"vr": "TM", "Value": ["094627.761000"]},
        "1350": {"vr": "TM", "Value": ["095127.835000"]},
        "1351": {"vr": "TM", "Value": ["094607.618000"]},
        "1352": {"vr": "TM", "Value": ["095007.735000"]},
        "1353": {"vr": "TM", "Value": ["095247.806000"]},
        "1354": {"vr": "TM", "Value": ["095427.776000"]},
        "1355": {"vr": "TM", "Value": ["094827.717000"]},
        "1356": {"vr": "TM", "Value": ["094947.761000"]},
        "1357": {"vr": "TM", "Value": ["095027.926000"]},
        "1358": {"vr": "TM", "Value": ["094707.614000"]},
        "1359": {"vr": "TM", "Value": ["095407.700000"]},
        "1360": {"vr": "TM", "Value": ["095407.702000"]},
        "1361": {"vr": "TM", "Value": ["094607.856000"]},
        "1362": {"vr": "TM", "Value": ["094527.817000"]},
        "1363": {"vr": "TM", "Value": ["094707.866000"]},
        "1364": {"vr": "TM", "Value": ["094727.883000"]},
        "1365": {"vr": "TM", "Value": ["095047.713000"]},
        "1366": {"vr": "TM", "Value": ["094847.822000"]},
        "1367": {"vr": "TM", "Value": ["094607.695000"]},
        "1368": {"vr": "TM", "Value": ["094807.953000"]},
        "1369": {"vr": "TM", "Value": ["094847.685000"]},
        "1370": {"vr": "TM", "Value": ["094947.860000"]},
        "1371": {"vr": "TM", "Value": ["094627.861000"]},
        "1372": {"vr": "TM", "Value": ["094607.750000"]},
        "1373": {"vr": "TM", "Value": ["095227.617000"]},
        "1374": {"vr": "TM", "Value": ["095027.746000"]},
        "1375": {"vr": "TM", "Value": ["094827.936000"]},
        "1376": {"vr": "TM", "Value": ["094627.886000"]},
        "1377": {"vr": "TM", "Value": ["094647.678000"]},
        "1378": {"vr": "TM", "Value": ["095447.613000"]},
        "1379": {"vr": "TM", "Value": ["095447.768000"]},
        "1380": {"vr": "TM", "Value": ["095047.866000"]},
        "1381": {"vr": "TM", "Value": ["095327.726000"]},
        "1382": {"vr": "TM", "Value": ["095327.840000"]},
        "1383": {"vr": "TM", "Value": ["094727.926000"]},
        "1384": {"vr": "TM", "Value": ["094627.768000"]},
        "1385": {"vr": "TM", "Value": ["094847.940000"]},
        "1386": {"vr": "TM", "Value": ["095207.649000"]},
        "1387": {"vr": "TM", "Value": ["094847.892000"]},
        "1388": {"vr": "TM", "Value": ["095047.933000"]},
        "1389": {"vr": "TM", "Value": ["094627.665000"]},
        "1390": {"vr": "TM", "Value": ["094907.683000"]},
        "1391": {"vr": "TM", "Value": ["094527.810000"]},
        "1392": {"vr": "TM", "Value": ["095407.746000"]},
        "1393": {"vr": "TM", "Value": ["094847.920000"]},
        "1394": {"vr": "TM", "Value": ["095027.708000"]},
        "1395": {"vr": "TM", "Value": ["094927.921000"]},
        "1396": {"vr": "TM", "Value": ["095127.706000"]},
        "1397": {"vr": "TM", "Value": ["094947.680000"]},
        "1398": {"vr": "TM", "Value": ["094807.682000"]},
        "1399": {"vr": "TM", "Value": ["094827.808000"]},
        "1400": {"vr": "TM", "Value": ["095047.956000"]},
        "1401": {"vr": "TM", "Value": ["094747.778000"]},
        "1402": {"vr": "TM", "Value": ["095347.910000"]},
        "1403": {"vr": "TM", "Value": ["095007.725000"]},
        "1404": {"vr": "TM", "Value": ["094527.636000"]},
        "1405": {"vr": "TM", "Value": ["094547.667000"]},
        "1406": {"vr": "TM", "Value": ["094727.950000"]},
        "1407": {"vr": "TM", "Value": ["094707.884000"]},
        "1408": {"vr": "TM", "Value": ["094827.771000"]},
        "1409": {"vr": "TM", "Value": ["094727.627000"]},
        "1410": {"vr": "TM", "Value": ["095347.933000"]},
        "1411": {"vr": "TM", "Value": ["094647.657000"]},
        "1412": {"vr": "TM", "Value": ["095047.815000"]},
        "1413": {"vr": "TM", "Value": ["095327.775000"]},
        "1414": {"vr": "TM", "Value": ["095127.837000"]},
        "1415": {"vr": "TM", "Value": ["094547.791000"]},
        "1416": {"vr": "TM", "Value": ["094727.825000"]},
        "1417": {"vr": "TM", "Value": ["094647.933000"]},
        "1418": {"vr": "TM", "Value": ["095027.785000"]},
        "1419": {"vr": "TM", "Value": ["095347.827000"]},
        "1420": {"vr": "TM", "Value": ["095247.705000"]},
        "1421": {"vr": "TM", "Value": ["094727.868000"]},
        "1422": {"vr": "TM", "Value": ["095327.865000"]},
        "1423": {"vr": "TM", "Value": ["094947.747000"]},
        "1424": {"vr": "TM", "Value": ["095407.919000"]},
        "1425": {"vr": "TM", "Value": ["094907.663000"]},
        "1426": {"vr": "TM", "Value": ["095307.622000"]},
        "1427": {"vr": "TM", "Value": ["095227.714000"]},
        "1428": {"vr": "TM", "Value": ["094927.732000"]},
        "1429": {"vr": "TM", "Value": ["095347.641000"]},
        "1430": {"vr": "TM", "Value": ["095327.787000"]},
        "1431": {"vr": "TM", "Value": ["095427.926000"]},
        "1432": {"vr": "TM", "Value": ["094947.745000"]},
        "1433": {"vr": "TM", "Value": ["095247.640000"]},
        "1434": {"vr": "TM", "Value": ["095147.629000"]},
        "1435": {"vr": "TM", "Value": ["095047.772000"]},
        "1436": {"vr": "TM", "Value": ["095307.684000"]},
        "1437": {"vr": "TM", "Value": ["095127.895000"]},
        "1438": {"vr": "TM", "Value": ["094607.735000"]},
        "1439": {"vr": "TM", "Value": ["095027.705000"]},
        "1440": {"vr": "TM", "Value": ["095447.745000"]},
        "1441": {"vr": "TM", "Value": ["095047.610000"]},
        "1442": {"vr": "TM", "Value": ["094527.628000"]},
        "1443": {"vr": "TM", "Value": ["095447.690000"]},
        "1444": {"vr": "TM", "Value": ["095047.646000"]},
        "1445": {"vr": "TM", "Value": ["095407.720000"]},
        "1446": {"vr": "TM", "Value": ["095207.810000"]},
        "1447": {"vr": "TM", "Value": ["094747.842000"]},
        "1448": {"vr": "TM", "Value": ["094547.933000"]},
        "1449": {"vr": "TM", "Value": ["094647.931000"]},
        "1450": {"vr": "TM", "Value": ["094807.707000"]},
        "1451": {"vr": "TM", "Value": ["094947.687000"]},
        "1452": {"vr": "TM", "Value": ["094527.815000"]},
        "1453": {"vr": "TM", "Value": ["095207.836000"]},
        "1454": {"vr": "TM", "Value": ["095427.740000"]},
        "1455": {"vr": "TM", "Value": ["095456.500000"]},
        "1456": {"vr": "TM", "Value": ["095047.823000"]},
        "1457": {"vr": "TM", "Value": ["094707.792000"]},
        "1458": {"vr": "TM", "Value": ["095447.801000"]},
        "1459": {"vr": "TM", "Value": ["094627.637000"]},
        "1460": {"vr": "TM", "Value": ["095327.731000"]},
        "1461": {"vr": "TM", "Value": ["094707.644000"]},
        "1462": {"vr": "TM", "Value": ["094947.622000"]},
        "1463": {"vr": "TM", "Value": ["094927.891000"]},
        "1464": {"vr": "TM", "Value": ["095307.920000"]},
        "1465": {"vr": "TM", "Value": ["095107.824000"]},
        "1466": {"vr": "TM", "Value": ["094747.767000"]},
        "1467": {"vr": "TM", "Value": ["094727.685000"]},
        "1468": {"vr": "TM", "Value": ["095207.684000"]},
        "1469": {"vr": "TM", "Value": ["095407.766000"]},
        "1470": {"vr": "TM", "Value": ["095107.754000"]},
        "1471": {"vr": "TM", "Value": ["095327.819000"]},
        "1472": {"vr": "TM", "Value": ["094727.934000"]},
        "1473": {"vr": "TM", "Value": ["094747.649000"]},
        "1474": {"vr": "TM", "Value": ["095147.801000"]},
        "1475": {"vr": "TM", "Value": ["095327.896000"]},
        "1476": {"vr": "TM", "Value": ["094847.777000"]},
        "1477": {"vr": "TM", "Value": ["094547.888000"]},
        "1478": {"vr": "TM", "Value": ["094847.857000"]},
        "1479": {"vr": "TM", "Value": ["095127.758000"]},
        "1480": {"vr": "TM", "Value": ["095247.719000"]},
        "1481": {"vr": "TM", "Value": ["095307.850000"]},
        "1482": {"vr": "TM", "Value": ["095247.710000"]},
        "1483": {"vr": "TM", "Value": ["095227.906000"]},
        "1484": {"vr": "TM", "Value": ["095047.818000"]},
        "1485": {"vr": "TM", "Value": ["094907.824000"]},
        "1486": {"vr": "TM", "Value": ["094647.757000"]},
        "1487": {"vr": "TM", "Value": ["095447.625000"]},
        "1488": {"vr": "TM", "Value": ["095147.777000"]},
        "1489": {"vr": "TM", "Value": ["094927.618000"]},
        "1490": {"vr": "TM", "Value": ["095047.658000"]},
        "1491": {"vr": "TM", "Value": ["094807.905000"]},
        "1492": {"vr": "TM", "Value": ["095107.770000"]},
        "1493": {"vr": "TM", "Value": ["094707.607000"]},
        "1494": {"vr": "TM", "Value": ["095407.898000"]},
        "1495": {"vr": "TM", "Value": ["095207.621000"]},
        "1496": {"vr": "TM", "Value": ["095347.784000"]},
        "1497": {"vr": "TM", "Value": ["094707.914000"]},
        "1498": {"vr": "TM", "Value": ["094927.837000"]},
        "1499": {"vr": "TM", "Value": ["095347.789000"]},
        "1500": {"vr": "TM", "Value": ["095127.801000"]},
        "1501": {"vr": "TM", "Value": ["094747.695000"]},
        "1502": {"vr": "TM", "Value": ["095107.805000"]},
        "1503": {"vr": "TM", "Value": ["095327.899000"]},
        "1504": {"vr": "TM", "Value": ["095107.878000"]},
        "1505": {"vr": "TM", "Value": ["094807.712000"]},
        "1506": {"vr": "TM", "Value": ["094927.613000"]},
        "1507": {"vr": "TM", "Value": ["094807.668000"]},
        "1508": {"vr": "TM", "Value": ["094607.869000"]},
        "1509": {"vr": "TM", "Value": ["094707.702000"]},
        "1510": {"vr": "TM", "Value": ["095127.877000"]},
        "1511": {"vr": "TM", "Value": ["095327.817000"]},
        "1512": {"vr": "TM", "Value": ["095147.796000"]},
        "1513": {"vr": "TM", "Value": ["094547.874000"]},
        "1514": {"vr": "TM", "Value": ["094727.813000"]},
        "1515": {"vr": "TM", "Value": ["094527.649000"]},
        "1516": {"vr": "TM", "Value": ["094527.970000"]},
        "1517": {"vr": "TM", "Value": ["095327.767000"]},
        "1518": {"vr": "TM", "Value": ["095307.689000"]},
        "1519": {"vr": "TM", "Value": ["095027.829000"]},
        "1520": {"vr": "TM", "Value": ["094847.722000"]},
        "1521": {"vr": "TM", "Value": ["095327.656000"]},
        "1522": {"vr": "TM", "Value": ["094807.679000"]},
        "1523": {"vr": "TM", "Value": ["094847.748000"]},
        "1524": {"vr": "TM", "Value": ["094927.776000"]},
        "1525": {"vr": "TM", "Value": ["094627.822000"]},
        "1526": {"vr": "TM", "Value": ["094747.607000"]},
        "1527": {"vr": "TM", "Value": ["095247.904000"]},
        "1528": {"vr": "TM", "Value": ["094547.637000"]},
        "1529": {"vr": "TM", "Value": ["094907.871000"]},
        "1530": {"vr": "TM", "Value": ["095227.885000"]},
        "1531": {"vr": "TM", "Value": ["094947.670000"]},
        "1532": {"vr": "TM", "Value": ["095407.917000"]},
        "1533": {"vr": "TM", "Value": ["094747.715000"]},
        "1534": {"vr": "TM", "Value": ["094847.862000"]},
        "1535": {"vr": "TM", "Value": ["094727.830000"]},
        "1536": {"vr": "TM", "Value": ["095007.822000"]},
        "1537": {"vr": "TM", "Value": ["094607.613000"]},
        "1538": {"vr": "TM", "Value": ["094547.913000"]},
        "1539": {"vr": "TM", "Value": ["094647.799000"]},
        "1540": {"vr": "TM", "Value": ["095027.757000"]},
        "1541": {"vr": "TM", "Value": ["095047.757000"]},
        "1542": {"vr": "TM", "Value": ["094747.884000"]},
        "1543": {"vr": "TM", "Value": ["094847.835000"]},
        "1544": {"vr": "TM", "Value": ["095007.771000"]},
        "1545": {"vr": "TM", "Value": ["094947.694000"]},
        "1546": {"vr": "TM", "Value": ["095047.958000"]},
        "1547": {"vr": "TM", "Value": ["095047.653000"]},
        "1548": {"vr": "TM", "Value": ["095027.715000"]},
        "1549": {"vr": "TM", "Value": ["094907.853000"]},
        "1550": {"vr": "TM", "Value": ["094807.814000"]},
        "1551": {"vr": "TM", "Value": ["094827.667000"]},
        "1552": {"vr": "TM", "Value": ["094907.723000"]},
        "1553": {"vr": "TM", "Value": ["094647.972000"]},
        "1554": {"vr": "TM", "Value": ["095007.654000"]},
        "1555": {"vr": "TM", "Value": ["094527.724000"]},
        "1556": {"vr": "TM", "Value": ["095107.679000"]},
        "1557": {"vr": "TM", "Value": ["094947.872000"]},
        "1558": {"vr": "TM", "Value": ["094927.694000"]},
        "1559": {"vr": "TM", "Value": ["095147.755000"]},
        "1560": {"vr": "TM", "Value": ["095427.853000"]},
        "1561": {"vr": "TM", "Value": ["095027.654000"]},
        "1562": {"vr": "TM", "Value": ["095327.677000"]},
        "1563": {"vr": "TM", "Value": ["094727.944000"]},
        "1564": {"vr": "TM", "Value": ["094747.682000"]},
        "1565": {"vr": "TM", "Value": ["094627.754000"]},
        "1566": {"vr": "TM", "Value": ["095027.892000"]},
        "1567": {"vr": "TM", "Value": ["094807.902000"]},
        "1568": {"vr": "TM", "Value": ["095027.733000"]},
        "1569": {"vr": "TM", "Value": ["095327.941000"]},
        "1570": {"vr": "TM", "Value": ["095107.812000"]},
        "1571": {"vr": "TM", "Value": ["094547.744000"]},
        "1572": {"vr": "TM", "Value": ["094847.870000"]},
        "1573": {"vr": "TM", "Value": ["095047.868000"]},
        "1574": {"vr": "TM", "Value": ["095007.843000"]},
        "1575": {"vr": "TM", "Value": ["095107.789000"]},
        "1576": {"vr": "TM", "Value": ["094647.705000"]},
        "1577": {"vr": "TM", "Value": ["095127.739000"]},
        "1578": {"vr": "TM", "Value": ["095447.752000"]},
        "1579": {"vr": "TM", "Value": ["095447.770000"]},
        "1580": {"vr": "TM", "Value": ["095207.910000"]},
        "1581": {"vr": "TM", "Value": ["094927.896000"]},
        "1582": {"vr": "TM", "Value": ["095227.878000"]},
        "1583": {"vr": "TM", "Value": ["095107.618000"]},
        "1584": {"vr": "TM", "Value": ["094727.823000"]},
        "1585": {"vr": "TM", "Value": ["095347.748000"]},
        "1586": {"vr": "TM", "Value": ["095247.910000"]},
        "1587": {"vr": "TM", "Value": ["095107.625000"]},
        "1588": {"vr": "TM", "Value": ["095147.689000"]},
        "1589": {"vr": "TM", "Value": ["094707.851000"]},
        "1590": {"vr": "TM", "Value": ["094847.634000"]},
        "1591": {"vr": "TM", "Value": ["094727.916000"]},
        "1592": {"vr": "TM", "Value": ["095347.664000"]},
        "1593": {"vr": "TM", "Value": ["095047.774000"]},
        "1594": {"vr": "TM", "Value": ["095327.701000"]},
        "1595": {"vr": "TM", "Value": ["095427.802000"]},
        "1596": {"vr": "TM", "Value": ["094607.817000"]},
        "1597": {"vr": "TM", "Value": ["094927.812000"]},
        "1598": {"vr": "TM", "Value": ["095407.642000"]},
        "1599": {"vr": "TM", "Value": ["095227.655000"]},
        "1600": {"vr": "TM", "Value": ["095147.775000"]},
        "1601": {"vr": "TM", "Value": ["094527.764000"]},
        "1602": {"vr": "TM", "Value": ["095407.789000"]},
        "1603": {"vr": "TM", "Value": ["095456.455000"]},
        "1604": {"vr": "TM", "Value": ["094707.671000"]},
        "1605": {"vr": "TM", "Value": ["095107.850000"]},
        "1606": {"vr": "TM", "Value": ["095427.897000"]},
        "1607": {"vr": "TM", "Value": ["094847.756000"]},
        "1608": {"vr": "TM", "Value": ["095307.861000"]},
        "1609": {"vr": "TM", "Value": ["094947.609000"]},
        "1610": {"vr": "TM", "Value": ["095007.901000"]},
        "1611": {"vr": "TM", "Value": ["095247.736000"]},
        "1612": {"vr": "TM", "Value": ["094947.803000"]},
        "1613": {"vr": "TM", "Value": ["095247.794000"]},
        "1614": {"vr": "TM", "Value": ["094727.909000"]},
        "1615": {"vr": "TM", "Value": ["095307.681000"]},
        "1616": {"vr": "TM", "Value": ["094727.838000"]},
        "1617": {"vr": "TM", "Value": ["095007.710000"]},
        "1618": {"vr": "TM", "Value": ["094947.891000"]},
        "1619": {"vr": "TM", "Value": ["094547.702000"]},
        "1620": {"vr": "TM", "Value": ["094727.735000"]},
        "1621": {"vr": "TM", "Value": ["095007.639000"]},
        "1622": {"vr": "TM", "Value": ["095127.855000"]},
        "1623": {"vr": "TM", "Value": ["094947.782000"]},
        "1624": {"vr": "TM", "Value": ["095407.797000"]},
        "1625": {"vr": "TM", "Value": ["094827.875000"]},
        "1626": {"vr": "TM", "Value": ["095027.929000"]},
        "1627": {"vr": "TM", "Value": ["094847.695000"]},
        "1628": {"vr": "TM", "Value": ["095047.648000"]},
        "1629": {"vr": "TM", "Value": ["095247.696000"]},
        "1630": {"vr": "TM", "Value": ["095447.701000"]},
        "1631": {"vr": "TM", "Value": ["094707.712000"]},
        "1632": {"vr": "TM", "Value": ["095147.644000"]},
        "1633": {"vr": "TM", "Value": ["095047.630000"]},
        "1634": {"vr": "TM", "Value": ["094547.758000"]},
        "1635": {"vr": "TM", "Value": ["095227.724000"]},
        "1636": {"vr": "TM", "Value": ["094607.786000"]},
        "1637": {"vr": "TM", "Value": ["095207.679000"]},
        "1638": {"vr": "TM", "Value": ["094907.921000"]},
        "1639": {"vr": "TM", "Value": ["095327.855000"]},
        "1640": {"vr": "TM", "Value": ["094647.886000"]},
        "1641": {"vr": "TM", "Value": ["095447.940000"]},
        "1642": {"vr": "TM", "Value": ["094547.644000"]},
        "1643": {"vr": "TM", "Value": ["095456.481000"]},
        "1644": {"vr": "TM", "Value": ["095007.815000"]},
        "1645": {"vr": "TM", "Value": ["095407.710000"]},
        "1646": {"vr": "TM", "Value": ["095247.633000"]},
        "1647": {"vr": "TM", "Value": ["095347.656000"]},
        "1648": {"vr": "TM", "Value": ["094747.679000"]},
        "1649": {"vr": "TM", "Value": ["094827.952000"]},
        "1650": {"vr": "TM", "Value": ["095007.705000"]},
        "1651": {"vr": "TM", "Value": ["095247.860000"]},
        "1652": {"vr": "TM", "Value": ["094927.625000"]},
        "1653": {"vr": "TM", "Value": ["094947.754000"]},
        "1654": {"vr": "TM", "Value": ["094807.638000"]},
        "1655": {"vr": "TM", "Value": ["095147.869000"]},
        "1656": {"vr": "TM", "Value": ["094947.714000"]},
        "1657": {"vr": "TM", "Value": ["095147.715000"]},
        "1658": {"vr": "TM", "Value": ["095227.676000"]},
        "1659": {"vr": "TM", "Value": ["094907.745000"]},
        "1660": {"vr": "TM", "Value": ["095127.798000"]},
        "1661": {"vr": "TM", "Value": ["094527.837000"]},
        "1662": {"vr": "TM", "Value": ["095107.774000"]},
        "1663": {"vr": "TM", "Value": ["094827.704000"]},
        "1664": {"vr": "TM", "Value": ["095307.766000"]},
        "1665": {"vr": "TM", "Value": ["095227.778000"]},
        "1666": {"vr": "TM", "Value": ["094927.692000"]},
        "1667": {"vr": "TM", "Value": ["095227.927000"]},
        "1668": {"vr": "TM", "Value": ["094707.815000"]},
        "1669": {"vr": "TM", "Value": ["095247.661000"]},
        "1670": {"vr": "TM", "Value": ["094927.745000"]},
        "1671": {"vr": "TM", "Value": ["095147.707000"]},
        "1672": {"vr": "TM", "Value": ["094607.825000"]},
        "1673": {"vr": "TM", "Value": ["094827.725000"]},
        "1674": {"vr": "TM", "Value": ["095027.882000"]},
        "1675": {"vr": "TM", "Value": ["094747.701000"]},
        "1676": {"vr": "TM", "Value": ["094527.996000"]},
        "1677": {"vr": "TM", "Value": ["095427.703000"]},
        "1678": {"vr": "TM", "Value": ["094847.806000"]},
        "1679": {"vr": "TM", "Value": ["094907.892000"]},
        "1680": {"vr": "TM", "Value": ["095247.623000"]},
        "1681": {"vr": "TM", "Value": ["094647.746000"]},
        "1682": {"vr": "TM", "Value": ["095227.686000"]},
        "1683": {"vr": "TM", "Value": ["095127.906000"]},
        "1684": {"vr": "TM", "Value": ["095407.613000"]},
        "1685": {"vr": "TM", "Value": ["095307.699000"]},
        "1686": {"vr": "TM", "Value": ["094547.630000"]},
        "1687": {"vr": "TM", "Value": ["095207.767000"]},
        "1688": {"vr": "TM", "Value": ["094807.873000"]},
        "1689": {"vr": "TM", "Value": ["094827.858000"]},
        "1690": {"vr": "TM", "Value": ["095027.885000"]},
        "1691": {"vr": "TM", "Value": ["095327.714000"]},
        "1692": {"vr": "TM", "Value": ["094847.659000"]},
        "1693": {"vr": "TM", "Value": ["094907.631000"]},
        "1694": {"vr": "TM", "Value": ["095307.881000"]},
        "1695": {"vr": "TM", "Value": ["094727.733000"]},
        "1696": {"vr": "TM", "Value": ["094547.771000"]},
        "1697": {"vr": "TM", "Value": ["095047.751000"]},
        "1698": {"vr": "TM", "Value": ["095427.781000"]},
        "1699": {"vr": "TM", "Value": ["095047.895000"]},
        "1700": {"vr": "TM", "Value": ["094527.686000"]},
        "1701": {"vr": "TM", "Value": ["095307.815000"]},
        "1702": {"vr": "TM", "Value": ["094727.657000"]},
        "1703": {"vr": "TM", "Value": ["094547.857000"]},
        "1704": {"vr": "TM", "Value": ["095407.781000"]},
        "1705": {"vr": "TM", "Value": ["094547.768000"]},
        "1706": {"vr": "TM", "Value": ["094547.784000"]},
        "1707": {"vr": "TM", "Value": ["094847.639000"]},
        "1708": {"vr": "TM", "Value": ["095227.834000"]},
        "1709": {"vr": "TM", "Value": ["095027.749000"]},
        "1710": {"vr": "TM", "Value": ["094927.722000"]},
        "1711": {"vr": "TM", "Value": ["094547.699000"]},
        "1712": {"vr": "TM", "Value": ["095207.641000"]},
        "1713": {"vr": "TM", "Value": ["094747.781000"]},
        "1714": {"vr": "TM", "Value": ["095407.832000"]},
        "1715": {"vr": "TM", "Value": ["095247.853000"]},
        "1716": {"vr": "TM", "Value": ["094607.933000"]},
        "1717": {"vr": "TM", "Value": ["094647.918000"]},
        "1718": {"vr": "TM", "Value": ["094947.898000"]},
        "1719": {"vr": "TM", "Value": ["095427.710000"]},
        "1720": {"vr": "TM", "Value": ["095456.553000"]},
        "1721": {"vr": "TM", "Value": ["095407.872000"]},
        "1722": {"vr": "TM", "Value": ["094747.623000"]},
        "1723": {"vr": "TM", "Value": ["095427.786000"]},
        "1724": {"vr": "TM", "Value": ["095307.651000"]},
        "1725": {"vr": "TM", "Value": ["094747.856000"]},
        "1726": {"vr": "TM", "Value": ["095407.611000"]},
        "1727": {"vr": "TM", "Value": ["094927.786000"]},
        "1728": {"vr": "TM", "Value": ["094747.970000"]},
        "1729": {"vr": "TM", "Value": ["095007.756000"]},
        "1730": {"vr": "TM", "Value": ["094547.776000"]},
        "1731": {"vr": "TM", "Value": ["094847.798000"]},
        "1732": {"vr": "TM", "Value": ["094547.647000"]},
        "1733": {"vr": "TM", "Value": ["094527.834000"]},
        "1734": {"vr": "TM", "Value": ["095407.819000"]},
        "1735": {"vr": "TM", "Value": ["095307.902000"]},
        "1736": {"vr": "TM", "Value": ["094827.917000"]},
        "1737": {"vr": "TM", "Value": ["094707.887000"]},
        "1738": {"vr": "TM", "Value": ["095147.782000"]},
        "1739": {"vr": "TM", "Value": ["094847.877000"]},
        "1740": {"vr": "TM", "Value": ["095407.784000"]},
        "1741": {"vr": "TM", "Value": ["094807.702000"]},
        "1742": {"vr": "TM", "Value": ["094627.911000"]},
        "1743": {"vr": "TM", "Value": ["094747.832000"]},
        "1744": {"vr": "TM", "Value": ["095147.634000"]},
        "1745": {"vr": "TM", "Value": ["095107.868000"]},
        "1746": {"vr": "TM", "Value": ["095247.848000"]},
        "1747": {"vr": "TM", "Value": ["095107.611000"]},
        "1748": {"vr": "TM", "Value": ["095227.763000"]},
        "1749": {"vr": "TM", "Value": ["095307.858000"]},
        "1750": {"vr": "TM", "Value": ["095427.907000"]},
        "1751": {"vr": "TM", "Value": ["095447.740000"]},
        "1752": {"vr": "TM", "Value": ["094627.647000"]},
        "1753": {"vr": "TM", "Value": ["094747.745000"]},
        "1754": {"vr": "TM", "Value": ["094947.841000"]},
        "1755": {"vr": "TM", "Value": ["095147.620000"]},
        "1756": {"vr": "TM", "Value": ["094747.827000"]},
        "1757": {"vr": "TM", "Value": ["095127.840000"]},
        "1758": {"vr": "TM", "Value": ["094527.842000"]},
        "1759": {"vr": "TM", "Value": ["094547.620000"]},
        "1760": {"vr": "TM", "Value": ["095127.848000"]},
        "1761": {"vr": "TM", "Value": ["094547.931000"]},
        "1762": {"vr": "TM", "Value": ["094527.823000"]},
        "1763": {"vr": "TM", "Value": ["094607.836000"]},
        "1764": {"vr": "TM", "Value": ["094947.629000"]},
        "1765": {"vr": "TM", "Value": ["094647.907000"]},
        "1766": {"vr": "TM", "Value": ["094847.732000"]},
        "1767": {"vr": "TM", "Value": ["094907.626000"]},
        "1768": {"vr": "TM", "Value": ["094907.701000"]},
        "1769": {"vr": "TM", "Value": ["094527.807000"]},
        "1770": {"vr": "TM", "Value": ["095127.909000"]},
        "1771": {"vr": "TM", "Value": ["094947.749000"]},
        "1772": {"vr": "TM", "Value": ["094947.865000"]},
        "1773": {"vr": "TM", "Value": ["095407.738000"]},
        "1774": {"vr": "TM", "Value": ["094607.646000"]},
        "1775": {"vr": "TM", "Value": ["094647.948000"]},
        "1776": {"vr": "TM", "Value": ["095447.747000"]},
        "1777": {"vr": "TM", "Value": ["094747.762000"]},
        "1778": {"vr": "TM", "Value": ["094747.924000"]},
        "1779": {"vr": "TM", "Value": ["095247.881000"]},
        "1780": {"vr": "TM", "Value": ["094807.929000"]},
        "1781": {"vr": "TM", "Value": ["095307.644000"]},
        "1782": {"vr": "TM", "Value": ["094707.871000"]},
        "1783": {"vr": "TM", "Value": ["094747.785000"]},
        "1784": {"vr": "TM", "Value": ["095247.618000"]},
        "1785": {"vr": "TM", "Value": ["094847.890000"]},
        "1786": {"vr": "TM", "Value": ["095147.875000"]},
        "1787": {"vr": "TM", "Value": ["095447.891000"]},
        "1788": {"vr": "TM", "Value": ["094807.699000"]},
        "1789": {"vr": "TM", "Value": ["095247.673000"]},
        "1790": {"vr": "TM", "Value": ["094727.730000"]},
        "1791": {"vr": "TM", "Value": ["094647.633000"]},
        "1792": {"vr": "TM", "Value": ["095027.916000"]},
        "1793": {"vr": "TM", "Value": ["094947.677000"]},
        "1794": {"vr": "TM", "Value": ["094947.632000"]},
        "1795": {"vr": "TM", "Value": ["094747.651000"]},
        "1796": {"vr": "TM", "Value": ["094527.671000"]},
        "1797": {"vr": "TM", "Value": ["095047.846000"]},
        "1798": {"vr": "TM", "Value": ["094727.613000"]},
        "1799": {"vr": "TM", "Value": ["095107.831000"]},
        "1800": {"vr": "TM", "Value": ["095127.666000"]},
        "1801": {"vr": "TM", "Value": ["095347.636000"]},
        "1802": {"vr": "TM", "Value": ["094827.861000"]},
        "1803": {"vr": "TM", "Value": ["095427.755000"]},
        "1804": {"vr": "TM", "Value": ["095427.760000"]},
        "1805": {"vr": "TM", "Value": ["095456.531000"]},
        "1806": {"vr": "TM", "Value": ["094607.890000"]},
        "1807": {"vr": "TM", "Value": ["095427.640000"]},
        "1808": {"vr": "TM", "Value": ["095247.727000"]},
        "1809": {"vr": "TM", "Value": ["094747.764000"]},
        "1810": {"vr": "TM", "Value": ["095047.926000"]},
        "1811": {"vr": "TM", "Value": ["094947.794000"]},
        "1812": {"vr": "TM", "Value": ["094907.688000"]},
        "1813": {"vr": "TM", "Value": ["094847.837000"]},
        "1814": {"vr": "TM", "Value": ["095327.623000"]},
        "1815": {"vr": "TM", "Value": ["095427.946000"]},
        "1816": {"vr": "TM", "Value": ["095027.880000"]},
        "1817": {"vr": "TM", "Value": ["095047.938000"]},
        "1818": {"vr": "TM", "Value": ["095047.643000"]},
        "1819": {"vr": "TM", "Value": ["094927.845000"]},
        "1820": {"vr": "TM", "Value": ["094847.656000"]},
        "1821": {"vr": "TM", "Value": ["095147.717000"]},
        "1822": {"vr": "TM", "Value": ["095247.811000"]},
        "1823": {"vr": "TM", "Value": ["095147.697000"]},
        "1824": {"vr": "TM", "Value": ["094727.873000"]},
        "1825": {"vr": "TM", "Value": ["095107.622000"]},
        "1826": {"vr": "TM", "Value": ["094747.853000"]},
        "1827": {"vr": "TM", "Value": ["095327.779000"]},
        "1828": {"vr": "TM", "Value": ["094907.890000"]},
        "1829": {"vr": "TM", "Value": ["094627.625000"]},
        "1830": {"vr": "TM", "Value": ["094747.646000"]},
        "1831": {"vr": "TM", "Value": ["095047.918000"]},
        "1832": {"vr": "TM", "Value": ["094907.661000"]},
        "1833": {"vr": "TM", "Value": ["095027.923000"]},
        "1834": {"vr": "TM", "Value": ["094707.950000"]},
        "1835": {"vr": "TM", "Value": ["095027.790000"]},
        "1836": {"vr": "TM", "Value": ["095127.793000"]},
        "1837": {"vr": "TM", "Value": ["094847.619000"]},
        "1838": {"vr": "TM", "Value": ["095327.799000"]},
        "1839": {"vr": "TM", "Value": ["095227.822000"]},
        "1840": {"vr": "TM", "Value": ["094607.742000"]},
        "1841": {"vr": "TM", "Value": ["095107.691000"]},
        "1842": {"vr": "TM", "Value": ["094947.792000"]},
        "1843": {"vr": "TM", "Value": ["094707.904000"]},
        "1844": {"vr": "TM", "Value": ["095127.888000"]},
        "1845": {"vr": "TM", "Value": ["094827.842000"]},
        "1846": {"vr": "TM", "Value": ["094827.625000"]},
        "1847": {"vr": "TM", "Value": ["094807.878000"]},
        "1848": {"vr": "TM", "Value": ["095007.682000"]},
        "1849": {"vr": "TM", "Value": ["095247.724000"]},
        "1850": {"vr": "TM", "Value": ["095027.764000"]},
        "1851": {"vr": "TM", "Value": ["095247.741000"]},
        "1852": {"vr": "TM", "Value": ["095127.671000"]},
        "1853": {"vr": "TM", "Value": ["094527.885000"]},
        "1854": {"vr": "TM", "Value": ["094627.889000"]},
        "1855": {"vr": "TM", "Value": ["094947.913000"]},
        "1856": {"vr": "TM", "Value": ["094647.774000"]},
        "1857": {"vr": "TM", "Value": ["095427.845000"]},
        "1858": {"vr": "TM", "Value": ["094827.805000"]},
        "1859": {"vr": "TM", "Value": ["094647.777000"]},
        "1860": {"vr": "TM", "Value": ["095047.828000"]},
        "1861": {"vr": "TM", "Value": ["095107.708000"]},
        "1862": {"vr": "TM", "Value": ["094747.625000"]},
        "1863": {"vr": "TM", "Value": ["095327.858000"]},
        "1864": {"vr": "TM", "Value": ["094607.877000"]},
        "1865": {"vr": "TM", "Value": ["095007.766000"]},
        "1866": {"vr": "TM", "Value": ["095047.820000"]},
        "1867": {"vr": "TM", "Value": ["095107.928000"]},
        "1868": {"vr": "TM", "Value": ["095447.881000"]},
        "1869": {"vr": "TM", "Value": ["095207.788000"]},
        "1870": {"vr": "TM", "Value": ["094607.639000"]},
        "1871": {"vr": "TM", "Value": ["095227.678000"]},
        "1872": {"vr": "TM", "Value": ["095456.517000"]},
        "1873": {"vr": "TM", "Value": ["094527.702000"]},
        "1874": {"vr": "TM", "Value": ["094747.793000"]},
        "1875": {"vr": "TM", "Value": ["095427.837000"]},
        "1876": {"vr": "TM", "Value": ["094607.921000"]},
        "1877": {"vr": "TM", "Value": ["094627.800000"]},
        "1878": {"vr": "TM", "Value": ["095447.871000"]},
        "1879": {"vr": "TM", "Value": ["094827.745000"]},
        "1880": {"vr": "TM", "Value": ["094747.887000"]},
        "1881": {"vr": "TM", "Value": ["095247.734000"]},
        "1882": {"vr": "TM", "Value": ["094927.881000"]},
        "1883": {"vr": "TM", "Value": ["094547.852000"]},
        "1884": {"vr": "TM", "Value": ["094807.750000"]},
        "1885": {"vr": "TM", "Value": ["095427.680000"]},
        "1886": {"vr": "TM", "Value": ["095027.611000"]},
        "1887": {"vr": "TM", "Value": ["095307.620000"]},
        "1888": {"vr": "TM", "Value": ["095427.889000"]},
        "1889": {"vr": "TM", "Value": ["095327.684000"]},
        "1890": {"vr": "TM", "Value": ["095107.675000"]},
        "1891": {"vr": "TM", "Value": ["095047.613000"]},
        "1892": {"vr": "TM", "Value": ["095407.654000"]},
        "1893": {"vr": "TM", "Value": ["094547.867000"]},
        "1894": {"vr": "TM", "Value": ["095407.896000"]},
        "1895": {"vr": "TM", "Value": ["095407.658000"]},
        "1896": {"vr": "TM", "Value": ["095207.651000"]},
        "1897": {"vr": "TM", "Value": ["094807.656000"]},
        "1898": {"vr": "TM", "Value": ["095447.791000"]},
        "1899": {"vr": "TM", "Value": ["094547.837000"]},
        "1900": {"vr": "TM", "Value": ["094707.695000"]},
        "1901": {"vr": "TM", "Value": ["095407.850000"]},
        "1902": {"vr": "TM", "Value": ["094907.609000"]},
        "1903": {"vr": "TM", "Value": ["094747.882000"]},
        "1904": {"vr": "TM", "Value": ["094927.620000"]},
        "1905": {"vr": "TM", "Value": ["095247.649000"]},
        "1906": {"vr": "TM", "Value": ["094847.709000"]},
        "1907": {"vr": "TM", "Value": ["094907.611000"]},
        "1908": {"vr": "TM", "Value": ["094907.949000"]},
        "1909": {"vr": "TM", "Value": ["095327.770000"]},
        "1910": {"vr": "TM", "Value": ["094747.801000"]},
        "1911": {"vr": "TM", "Value": ["094607.848000"]},
        "1912": {"vr": "TM", "Value": ["094627.876000"]},
        "1913": {"vr": "TM", "Value": ["095247.846000"]},
        "1914": {"vr": "TM", "Value": ["095327.760000"]},
        "1915": {"vr": "TM", "Value": ["094527.761000"]},
        "1916": {"vr": "TM", "Value": ["095007.894000"]},
        "1917": {"vr": "TM", "Value": ["095247.611000"]},
        "1918": {"vr": "TM", "Value": ["095007.868000"]},
        "1919": {"vr": "TM", "Value": ["095447.879000"]},
        "1920": {"vr": "TM", "Value": ["094827.919000"]},
        "1921": {"vr": "TM", "Value": ["094847.955000"]},
        "1922": {"vr": "TM", "Value": ["094927.763000"]},
        "1923": {"vr": "TM", "Value": ["094927.671000"]},
        "1924": {"vr": "TM", "Value": ["094547.916000"]},
        "1925": {"vr": "TM", "Value": ["094807.819000"]},
        "1926": {"vr": "TM", "Value": ["095327.635000"]},
        "1927": {"vr": "TM", "Value": ["094927.778000"]},
        "1928": {"vr": "TM", "Value": ["094807.783000"]},
        "1929": {"vr": "TM", "Value": ["094947.836000"]},
        "1930": {"vr": "TM", "Value": ["095227.799000"]},
        "1931": {"vr": "TM", "Value": ["094907.926000"]},
        "1932": {"vr": "TM", "Value": ["095347.633000"]},
        "1933": {"vr": "TM", "Value": ["095147.830000"]},
        "1934": {"vr": "TM", "Value": ["094627.617000"]},
        "1935": {"vr": "TM", "Value": ["095347.756000"]},
        "1936": {"vr": "TM", "Value": ["094647.902000"]},
        "1937": {"vr": "TM", "Value": ["095227.768000"]},
        "1938": {"vr": "TM", "Value": ["095347.879000"]},
        "1939": {"vr": "TM", "Value": ["094947.682000"]},
        "1940": {"vr": "TM", "Value": ["094827.678000"]},
        "1941": {"vr": "TM", "Value": ["094847.677000"]},
        "1942": {"vr": "TM", "Value": ["095127.723000"]},
        "1943": {"vr": "TM", "Value": ["094627.803000"]},
        "1944": {"vr": "TM", "Value": ["095127.732000"]},
        "1945": {"vr": "TM", "Value": ["095207.616000"]},
        "1946": {"vr": "TM", "Value": ["094907.614000"]},
        "1947": {"vr": "TM", "Value": ["094907.708000"]},
        "1948": {"vr": "TM", "Value": ["095347.761000"]},
        "1949": {"vr": "TM", "Value": ["094707.647000"]},
        "1950": {"vr": "TM", "Value": ["095227.796000"]},
        "1951": {"vr": "TM", "Value": ["095107.608000"]},
        "1952": {"vr": "TM", "Value": ["095127.760000"]},
        "1953": {"vr": "TM", "Value": ["094947.799000"]},
        "1954": {"vr": "TM", "Value": ["094607.631000"]},
        "1955": {"vr": "TM", "Value": ["094727.696000"]},
        "1956": {"vr": "TM", "Value": ["095247.789000"]},
        "1957": {"vr": "TM", "Value": ["095027.780000"]},
        "1958": {"vr": "TM", "Value": ["095127.751000"]},
        "1959": {"vr": "TM", "Value": ["094947.701000"]},
        "1960": {"vr": "TM", "Value": ["094827.673000"]},
        "1961": {"vr": "TM", "Value": ["094527.652000"]},
        "1962": {"vr": "TM", "Value": ["095207.775000"]},
        "1963": {"vr": "TM", "Value": ["095127.875000"]},
        "1964": {"vr": "TM", "Value": ["095007.728000"]},
        "1965": {"vr": "TM", "Value": ["094907.696000"]},
        "1966": {"vr": "TM", "Value": ["095227.673000"]},
        "1967": {"vr": "TM", "Value": ["095456.485000"]},
        "1968": {"vr": "TM", "Value": ["095147.647000"]},
        "1969": {"vr": "TM", "Value": ["095447.709000"]},
        "1970": {"vr": "TM", "Value": ["094807.621000"]},
        "1971": {"vr": "TM", "Value": ["094847.911000"]},
        "1972": {"vr": "TM", "Value": ["095027.687000"]},
        "1973": {"vr": "TM", "Value": ["095456.420000"]},
        "1974": {"vr": "TM", "Value": ["094807.870000"]},
        "1975": {"vr": "TM", "Value": ["095307.786000"]},
        "1976": {"vr": "TM", "Value": ["094607.616000"]},
        "1977": {"vr": "TM", "Value": ["095027.695000"]},
        "1978": {"vr": "TM", "Value": ["094647.854000"]},
        "1979": {"vr": "TM", "Value": ["095227.645000"]},
        "1980": {"vr": "TM", "Value": ["094847.795000"]},
        "1981": {"vr": "TM", "Value": ["095107.793000"]},
        "1982": {"vr": "TM", "Value": ["095247.717000"]},
        "1983": {"vr": "TM", "Value": ["095027.641000"]},
        "1984": {"vr": "TM", "Value": ["094627.901000"]},
        "1985": {"vr": "TM", "Value": ["095027.634000"]},
        "1986": {"vr": "TM", "Value": ["095327.806000"]},
        "1987": {"vr": "TM", "Value": ["095427.954000"]},
        "1988": {"vr": "TM", "Value": ["094547.724000"]},
        "1989": {"vr": "TM", "Value": ["095027.657000"]},
        "1990": {"vr": "TM", "Value": ["095227.758000"]},
        "1991": {"vr": "TM", "Value": ["094927.835000"]},
        "1992": {"vr": "TM", "Value": ["094747.922000"]},
        "1993": {"vr": "TM", "Value": ["095007.887000"]},
        "1994": {"vr": "TM", "Value": ["095407.639000"]},
        "1995": {"vr": "TM", "Value": ["095427.645000"]},
        "1996": {"vr": "TM", "Value": ["095007.800000"]},
        "1997": {"vr": "TM", "Value": ["094607.718000"]},
        "1998": {"vr": "TM", "Value": ["095127.613000"]},
        "1999": {"vr": "TM", "Value": ["095147.627000"]},
        "2000": {"vr": "TM", "Value": ["095247.907000"]},
        "2001": {"vr": "TM", "Value": ["095456.471000"]},
        "2002": {"vr": "TM", "Value": ["095227.920000"]},
        "2003": {"vr": "TM", "Value": ["094547.736000"]},
        "2004": {"vr": "TM", "Value": ["095207.636000"]},
        "2005": {"vr": "TM", "Value": ["094647.787000"]},
        "2006": {"vr": "TM", "Value": ["094947.883000"]},
        "2007": {"vr": "TM", "Value": ["094607.882000"]},
        "2008": {"vr": "TM", "Value": ["094707.823000"]},
        "2009": {"vr": "TM", "Value": ["095447.845000"]},
        "2010": {"vr": "TM", "Value": ["094627.972000"]},
        "2011": {"vr": "TM", "Value": ["095347.918000"]},
        "2012": {"vr": "TM", "Value": ["094527.641000"]},
        "2013": {"vr": "TM", "Value": ["095307.843000"]},
        "2014": {"vr": "TM", "Value": ["094907.798000"]},
        "2015": {"vr": "TM", "Value": ["095247.748000"]},
        "2016": {"vr": "TM", "Value": ["095027.675000"]},
        "2017": {"vr": "TM", "Value": ["095007.778000"]},
        "2018": {"vr": "TM", "Value": ["095347.725000"]},
        "2019": {"vr": "TM", "Value": ["095007.713000"]},
        "2020": {"vr": "TM", "Value": ["095447.781000"]},
        "2021": {"vr": "TM", "Value": ["094847.737000"]},
        "2022": {"vr": "TM", "Value": ["095107.887000"]},
        "2023": {"vr": "TM", "Value": ["094827.755000"]},
        "2024": {"vr": "TM", "Value": ["095427.656000"]},
        "2025": {"vr": "TM", "Value": ["094707.675000"]},
        "2026": {"vr": "TM", "Value": ["095407.822000"]},
        "2027": {"vr": "TM", "Value": ["094807.765000"]},
        "2028": {"vr": "TM", "Value": ["095127.937000"]},
        "2029": {"vr": "TM", "Value": ["094707.666000"]},
        "2030": {"vr": "TM", "Value": ["095447.827000"]},
        "2031": {"vr": "TM", "Value": ["095027.806000"]},
        "2032": {"vr": "TM", "Value": ["094647.683000"]},
        "2033": {"vr": "TM", "Value": ["095447.620000"]},
        "2034": {"vr": "TM", "Value": ["095047.897000"]},
        "2035": {"vr": "TM", "Value": ["095027.618000"]},
        "2036": {"vr": "TM", "Value": ["094827.639000"]},
        "2037": {"vr": "TM", "Value": ["094747.756000"]},
        "2038": {"vr": "TM", "Value": ["095247.808000"]},
        "2039": {"vr": "TM", "Value": ["095007.740000"]},
        "2040": {"vr": "TM", "Value": ["094627.815000"]},
        "2041": {"vr": "TM", "Value": ["095127.646000"]},
        "2042": {"vr": "TM", "Value": ["094627.855000"]},
        "2043": {"vr": "TM", "Value": ["095307.740000"]},
        "2044": {"vr": "TM", "Value": ["094907.887000"]},
        "2045": {"vr": "TM", "Value": ["095107.752000"]},
        "2046": {"vr": "TM", "Value": ["094747.959000"]},
        "2047": {"vr": "TM", "Value": ["095447.732000"]},
        "2048": {"vr": "TM", "Value": ["094827.818000"]},
        "2049": {"vr": "TM", "Value": ["095027.677000"]},
        "2050": {"vr": "TM", "Value": ["094547.903000"]},
        "2051": {"vr": "TM", "Value": ["094927.654000"]},
        "2052": {"vr": "TM", "Value": ["094627.692000"]},
        "2053": {"vr": "TM", "Value": ["095227.663000"]},
        "2054": {"vr": "TM", "Value": ["094947.893000"]},
        "2055": {"vr": "TM", "Value": ["094847.832000"]},
        "2056": {"vr": "TM", "Value": ["095127.753000"]},
        "2057": {"vr": "TM", "Value": ["095427.676000"]},
        "2058": {"vr": "TM", "Value": ["095447.933000"]},
        "2059": {"vr": "TM", "Value": ["095347.869000"]},
        "2060": {"vr": "TM", "Value": ["094707.725000"]},
        "2061": {"vr": "TM", "Value": ["095047.803000"]},
        "2062": {"vr": "TM", "Value": ["094747.798000"]},
        "2063": {"vr": "TM", "Value": ["095107.677000"]},
        "2064": {"vr": "TM", "Value": ["095327.687000"]},
        "2065": {"vr": "TM", "Value": ["095407.922000"]},
        "2066": {"vr": "TM", "Value": ["095047.718000"]},
        "2067": {"vr": "TM", "Value": ["094847.923000"]},
        "2068": {"vr": "TM", "Value": ["094847.914000"]},
        "2069": {"vr": "TM", "Value": ["095407.628000"]},
        "2070": {"vr": "TM", "Value": ["095107.627000"]},
        "2071": {"vr": "TM", "Value": ["095227.913000"]},
        "2072": {"vr": "TM", "Value": ["095007.944000"]},
        "2073": {"vr": "TM", "Value": ["095127.845000"]},
        "2074": {"vr": "TM", "Value": ["094747.720000"]},
        "2075": {"vr": "TM", "Value": ["094827.877000"]},
        "2076": {"vr": "TM", "Value": ["095127.668000"]},
        "2077": {"vr": "TM", "Value": ["095307.943000"]},
        "2078": {"vr": "TM", "Value": ["094807.631000"]},
        "2079": {"vr": "TM", "Value": ["094827.944000"]},
        "2080": {"vr": "TM", "Value": ["094827.683000"]},
        "2081": {"vr": "TM", "Value": ["095407.697000"]},
        "2082": {"vr": "TM", "Value": ["094827.931000"]},
        "2083": {"vr": "TM", "Value": ["095007.803000"]},
        "2084": {"vr": "TM", "Value": ["095007.819000"]},
        "2085": {"vr": "TM", "Value": ["094727.903000"]},
        "2086": {"vr": "TM", "Value": ["095327.723000"]},
        "2087": {"vr": "TM", "Value": ["095427.638000"]},
        "2088": {"vr": "TM", "Value": ["095207.706000"]},
        "2089": {"vr": "TM", "Value": ["094807.626000"]},
        "2090": {"vr": "TM", "Value": ["095027.636000"]},
        "2091": {"vr": "TM", "Value": ["095047.905000"]},
        "2092": {"vr": "TM", "Value": ["095147.925000"]},
        "2093": {"vr": "TM", "Value": ["095447.863000"]},
        "2094": {"vr": "TM", "Value": ["095447.716000"]},
        "2095": {"vr": "TM", "Value": ["094907.720000"]},
        "2096": {"vr": "TM", "Value": ["094707.737000"]},
        "2097": {"vr": "TM", "Value": ["094707.803000"]},
        "2098": {"vr": "TM", "Value": ["094527.638000"]},
        "2099": {"vr": "TM", "Value": ["095307.691000"]},
        "2100": {"vr": "TM", "Value": ["095127.746000"]},
        "2101": {"vr": "TM", "Value": ["095307.637000"]},
        "2102": {"vr": "TM", "Value": ["094947.619000"]},
        "2103": {"vr": "TM", "Value": ["094527.830000"]},
        "2104": {"vr": "TM", "Value": ["095247.886000"]},
        "2105": {"vr": "TM", "Value": ["094607.624000"]},
        "2106": {"vr": "TM", "Value": ["094747.687000"]},
        "2107": {"vr": "TM", "Value": ["095107.847000"]},
        "2108": {"vr": "TM", "Value": ["094627.870000"]},
        "2109": {"vr": "TM", "Value": ["095327.668000"]},
        "2110": {"vr": "TM", "Value": ["095407.715000"]},
        "2111": {"vr": "TM", "Value": ["094707.730000"]},
        "2112": {"vr": "TM", "Value": ["094807.718000"]},
        "2113": {"vr": "TM", "Value": ["095027.859000"]},
        "2114": {"vr": "TM", "Value": ["095327.878000"]},
        "2115": {"vr": "TM", "Value": ["094547.923000"]},
        "2116": {"vr": "TM", "Value": ["095027.744000"]},
        "2117": {"vr": "TM", "Value": ["094827.665000"]},
        "2118": {"vr": "TM", "Value": ["094727.773000"]},
        "2119": {"vr": "TM", "Value": ["095047.856000"]},
        "2120": {"vr": "TM", "Value": ["095447.876000"]},
        "2121": {"vr": "TM", "Value": ["094647.790000"]},
        "2122": {"vr": "TM", "Value": ["094527.839000"]},
        "2123": {"vr": "TM", "Value": ["094647.722000"]},
        "2124": {"vr": "TM", "Value": ["094547.944000"]},
        "2125": {"vr": "TM", "Value": ["094827.649000"]},
        "2126": {"vr": "TM", "Value": ["094547.819000"]},
        "2127": {"vr": "TM", "Value": ["094927.729000"]},
        "2128": {"vr": "TM", "Value": ["095107.703000"]},
        "2129": {"vr": "TM", "Value": ["095407.758000"]},
        "2130": {"vr": "TM", "Value": ["094927.724000"]},
        "2131": {"vr": "TM", "Value": ["095427.729000"]},
        "2132": {"vr": "TM", "Value": ["095147.828000"]},
        "2133": {"vr": "TM", "Value": ["094627.612000"]},
        "2134": {"vr": "TM", "Value": ["094707.719000"]},
        "2135": {"vr": "TM", "Value": ["094727.898000"]},
        "2136": {"vr": "TM", "Value": ["094647.804000"]},
        "2137": {"vr": "TM", "Value": ["094847.646000"]},
        "2138": {"vr": "TM", "Value": ["094907.941000"]},
        "2139": {"vr": "TM", "Value": ["095027.644000"]},
        "2140": {"vr": "TM", "Value": ["095007.929000"]},
        "2141": {"vr": "TM", "Value": ["095127.656000"]},
        "2142": {"vr": "TM", "Value": ["094947.789000"]},
        "2143": {"vr": "TM", "Value": ["095447.775000"]},
        "2144": {"vr": "TM", "Value": ["095107.744000"]},
        "2145": {"vr": "TM", "Value": ["094747.905000"]},
        "2146": {"vr": "TM", "Value": ["095456.459000"]},
        "2147": {"vr": "TM", "Value": ["094647.647000"]},
        "2148": {"vr": "TM", "Value": ["094647.665000"]},
        "2149": {"vr": "TM", "Value": ["095427.661000"]},
        "2150": {"vr": "TM", "Value": ["095427.814000"]},
        "2151": {"vr": "TM", "Value": ["095027.811000"]},
        "2152": {"vr": "TM", "Value": ["094607.791000"]},
        "2153": {"vr": "TM", "Value": ["094727.952000"]},
        "2154": {"vr": "TM", "Value": ["095147.687000"]},
        "2155": {"vr": "TM", "Value": ["095107.668000"]},
        "2156": {"vr": "TM", "Value": ["095207.782000"]},
        "2157": {"vr": "TM", "Value": ["095007.649000"]},
        "2158": {"vr": "TM", "Value": ["095147.760000"]},
        "2159": {"vr": "TM", "Value": ["095007.718000"]},
        "2160": {"vr": "TM", "Value": ["095007.613000"]},
        "2161": {"vr": "TM", "Value": ["094707.955000"]},
        "2162": {"vr": "TM", "Value": ["094607.712000"]},
        "2163": {"vr": "TM", "Value": ["094947.699000"]},
        "2164": {"vr": "TM", "Value": ["095107.911000"]},
        "2165": {"vr": "TM", "Value": ["094827.844000"]},
        "2166": {"vr": "TM", "Value": ["094927.875000"]},
        "2167": {"vr": "TM", "Value": ["095127.765000"]},
        "2168": {"vr": "TM", "Value": ["095447.649000"]},
        "2169": {"vr": "TM", "Value": ["094747.957000"]},
        "2170": {"vr": "TM", "Value": ["095007.889000"]},
        "2171": {"vr": "TM", "Value": ["095427.817000"]},
        "2172": {"vr": "TM", "Value": ["094707.789000"]},
        "2173": {"vr": "TM", "Value": ["095247.827000"]},
        "2174": {"vr": "TM", "Value": ["095007.916000"]},
        "2175": {"vr": "TM", "Value": ["094807.841000"]},
        "2176": {"vr": "TM", "Value": ["095107.933000"]},
        "2177": {"vr": "TM", "Value": ["095447.921000"]},
        "2178": {"vr": "TM", "Value": ["094707.765000"]},
        "2179": {"vr": "TM", "Value": ["095127.698000"]},
        "2180": {"vr": "TM", "Value": ["094627.848000"]},
        "2181": {"vr": "TM", "Value": ["094747.670000"]},
        "2182": {"vr": "TM", "Value": ["095147.900000"]},
        "2183": {"vr": "TM", "Value": ["095347.649000"]},
        "2184": {"vr": "TM", "Value": ["095227.727000"]},
        "2185": {"vr": "TM", "Value": ["095007.692000"]},
        "2186": {"vr": "TM", "Value": ["095247.801000"]},
        "2187": {"vr": "TM", "Value": ["095456.407000"]},
        "2188": {"vr": "TM", "Value": ["095127.781000"]},
        "2189": {"vr": "TM", "Value": ["094807.674000"]},
        "2190": {"vr": "TM", "Value": ["094607.606000"]},
        "2191": {"vr": "TM", "Value": ["094647.814000"]},
        "2192": {"vr": "TM", "Value": ["094827.851000"]},
        "2193": {"vr": "TM", "Value": ["095307.694000"]},
        "2194": {"vr": "TM", "Value": ["094547.763000"]},
        "2195": {"vr": "TM", "Value": ["094907.850000"]},
        "2196": {"vr": "TM", "Value": ["095127.716000"]},
        "2197": {"vr": "TM", "Value": ["095007.662000"]},
        "2198": {"vr": "TM", "Value": ["095407.646000"]},
        "2199": {"vr": "TM", "Value": ["095247.820000"]},
        "2200": {"vr": "TM", "Value": ["094707.699000"]},
        "2201": {"vr": "TM", "Value": ["094807.720000"]},
        "2202": {"vr": "TM", "Value": ["095327.809000"]},
        "2203": {"vr": "TM", "Value": ["095207.851000"]},
        "2204": {"vr": "TM", "Value": ["095456.464000"]},
        "2205": {"vr": "TM", "Value": ["094607.833000"]},
        "2206": {"vr": "TM", "Value": ["095127.914000"]},
        "2207": {"vr": "TM", "Value": ["095107.765000"]},
        "2208": {"vr": "TM", "Value": ["095447.856000"]},
        "2209": {"vr": "TM", "Value": ["095307.797000"]},
        "2210": {"vr": "TM", "Value": ["094707.940000"]},
        "2211": {"vr": "TM", "Value": ["094547.854000"]},
        "2212": {"vr": "TM", "Value": ["095227.661000"]},
        "2213": {"vr": "TM", "Value": ["095227.622000"]},
        "2214": {"vr": "TM", "Value": ["094827.646000"]},
        "2215": {"vr": "TM", "Value": ["095327.632000"]},
        "2216": {"vr": "TM", "Value": ["095007.949000"]},
        "2217": {"vr": "TM", "Value": ["095207.724000"]},
        "2218": {"vr": "TM", "Value": ["094907.944000"]},
        "2219": {"vr": "TM", "Value": ["094727.718000"]},
        "2220": {"vr": "TM", "Value": ["094527.719000"]},
        "2221": {"vr": "TM", "Value": ["094647.811000"]},
        "2222": {"vr": "TM", "Value": ["095307.728000"]},
        "2223": {"vr": "TM", "Value": ["095047.843000"]},
        "2224": {"vr": "TM", "Value": ["094607.948000"]},
        "2225": {"vr": "TM", "Value": ["095107.646000"]},
        "2226": {"vr": "TM", "Value": ["094847.730000"]},
        "2227": {"vr": "TM", "Value": ["095407.855000"]},
        "2228": {"vr": "TM", "Value": ["094547.829000"]},
        "2229": {"vr": "TM", "Value": ["095427.687000"]},
        "2230": {"vr": "TM", "Value": ["095207.674000"]},
        "2231": {"vr": "TM", "Value": ["095247.666000"]},
        "2232": {"vr": "TM", "Value": ["095127.651000"]},
        "2233": {"vr": "TM", "Value": ["095447.923000"]},
        "2234": {"vr": "TM", "Value": ["095027.939000"]},
        "2235": {"vr": "TM", "Value": ["095207.864000"]},
        "2236": {"vr": "TM", "Value": ["095227.851000"]},
        "2237": {"vr": "TM", "Value": ["095107.908000"]},
        "2238": {"vr": "TM", "Value": ["095227.937000"]},
        "2239": {"vr": "TM", "Value": ["094707.642000"]},
        "2240": {"vr": "TM", "Value": ["094807.933000"]},
        "2241": {"vr": "TM", "Value": ["094647.905000"]},
        "2242": {"vr": "TM", "Value": ["095127.711000"]},
        "2243": {"vr": "TM", "Value": ["094627.635000"]},
        "2244": {"vr": "TM", "Value": ["094547.901000"]},
        "2245": {"vr": "TM", "Value": ["094927.814000"]},
        "2246": {"vr": "TM", "Value": ["094547.613000"]},
        "2247": {"vr": "TM", "Value": ["095107.866000"]},
        "2248": {"vr": "TM", "Value": ["094627.674000"]},
        "2249": {"vr": "TM", "Value": ["095347.631000"]},
        "2250": {"vr": "TM", "Value": ["095307.853000"]},
        "2251": {"vr": "TM", "Value": ["094707.897000"]},
        "2252": {"vr": "TM", "Value": ["094527.868000"]},
        "2253": {"vr": "TM", "Value": ["095347.646000"]},
        "2254": {"vr": "TM", "Value": ["095456.536000"]},
        "2255": {"vr": "TM", "Value": ["094827.753000"]},
        "2256": {"vr": "TM", "Value": ["095447.809000"]},
        "2257": {"vr": "TM", "Value": ["095207.818000"]},
        "2258": {"vr": "TM", "Value": ["094647.609000"]},
        "2259": {"vr": "TM", "Value": ["094647.967000"]},
        "2260": {"vr": "TM", "Value": ["095027.736000"]},
        "2261": {"vr": "TM", "Value": ["094747.962000"]},
        "2262": {"vr": "TM", "Value": ["095447.714000"]},
        "2263": {"vr": "TM", "Value": ["095327.743000"]},
        "2264": {"vr": "TM", "Value": ["095207.734000"]},
        "2265": {"vr": "TM", "Value": ["094947.780000"]},
        "2266": {"vr": "TM", "Value": ["095147.665000"]},
        "2267": {"vr": "TM", "Value": ["095427.763000"]},
        "2268": {"vr": "TM", "Value": ["095107.935000"]},
        "2269": {"vr": "TM", "Value": ["094627.957000"]},
        "2270": {"vr": "TM", "Value": ["095207.737000"]},
        "2271": {"vr": "TM", "Value": ["094827.719000"]},
        "2272": {"vr": "TM", "Value": ["095427.753000"]},
        "2273": {"vr": "TM", "Value": ["094907.808000"]},
        "2274": {"vr": "TM", "Value": ["095327.625000"]},
        "2275": {"vr": "TM", "Value": ["095047.669000"]},
        "2276": {"vr": "TM", "Value": ["095107.873000"]},
        "2277": {"vr": "TM", "Value": ["095027.798000"]},
        "2278": {"vr": "TM", "Value": ["095327.745000"]},
        "2279": {"vr": "TM", "Value": ["095447.667000"]},
        "2280": {"vr": "TM", "Value": ["094647.806000"]},
        "2281": {"vr": "TM", "Value": ["095227.861000"]},
        "2282": {"vr": "TM", "Value": ["094747.712000"]},
        "2283": {"vr": "TM", "Value": ["094747.908000"]},
        "2284": {"vr": "TM", "Value": ["095007.708000"]},
        "2285": {"vr": "TM", "Value": ["095307.720000"]},
        "2286": {"vr": "TM", "Value": ["095347.807000"]},
        "2287": {"vr": "TM", "Value": ["094527.694000"]},
        "2288": {"vr": "TM", "Value": ["095447.868000"]},
        "2289": {"vr": "TM", "Value": ["094547.649000"]},
        "2290": {"vr": "TM", "Value": ["094707.894000"]},
        "2291": {"vr": "TM", "Value": ["095147.816000"]},
        "2292": {"vr": "TM", "Value": ["095407.618000"]},
        "2293": {"vr": "TM", "Value": ["094727.766000"]},
        "2294": {"vr": "TM", "Value": ["095027.769000"]},
        "2295": {"vr": "TM", "Value": ["095007.846000"]},
        "2296": {"vr": "TM", "Value": ["095147.729000"]},
        "2297": {"vr": "TM", "Value": ["095407.684000"]},
        "2298": {"vr": "TM", "Value": ["095147.639000"]},
        "2299": {"vr": "TM", "Value": ["095427.923000"]},
        "2300": {"vr": "TM", "Value": ["095307.658000"]},
        "2301": {"vr": "TM", "Value": ["095127.850000"]},
        "2302": {"vr": "TM", "Value": ["094727.781000"]},
        "2303": {"vr": "TM", "Value": ["095147.915000"]},
        "2304": {"vr": "TM", "Value": ["095047.734000"]},
        "2305": {"vr": "TM", "Value": ["094527.854000"]},
        "2306": {"vr": "TM", "Value": ["094547.707000"]},
        "2307": {"vr": "TM", "Value": ["095227.620000"]},
        "2308": {"vr": "TM", "Value": ["095227.854000"]},
        "2309": {"vr": "TM", "Value": ["094927.926000"]},
        "2310": {"vr": "TM", "Value": ["094907.656000"]},
        "2311": {"vr": "TM", "Value": ["095207.889000"]},
        "2312": {"vr": "TM", "Value": ["095347.613000"]},
        "2313": {"vr": "TM", "Value": ["094527.630000"]},
        "2314": {"vr": "TM", "Value": ["094927.781000"]},
        "2315": {"vr": "TM", "Value": ["095447.884000"]},
        "2316": {"vr": "TM", "Value": ["094547.669000"]},
        "2317": {"vr": "TM", "Value": ["095227.827000"]},
        "2318": {"vr": "TM", "Value": ["095147.950000"]},
        "2319": {"vr": "TM", "Value": ["094747.903000"]},
        "2320": {"vr": "TM", "Value": ["094947.655000"]},
        "2321": {"vr": "TM", "Value": ["094807.733000"]},
        "2322": {"vr": "TM", "Value": ["094607.608000"]},
        "2323": {"vr": "TM", "Value": ["095347.825000"]},
        "2324": {"vr": "TM", "Value": ["095207.739000"]},
        "2325": {"vr": "TM", "Value": ["095427.863000"]},
        "2326": {"vr": "TM", "Value": ["094747.913000"]},
        "2327": {"vr": "TM", "Value": ["094927.941000"]},
        "2328": {"vr": "TM", "Value": ["094807.936000"]},
        "2329": {"vr": "TM", "Value": ["094927.630000"]},
        "2330": {"vr": "TM", "Value": ["095227.809000"]},
        "2331": {"vr": "TM", "Value": ["094727.693000"]},
        "2332": {"vr": "TM", "Value": ["095207.742000"]},
        "2333": {"vr": "TM", "Value": ["095127.730000"]},
        "2334": {"vr": "TM", "Value": ["095027.772000"]},
        "2335": {"vr": "TM", "Value": ["094847.785000"]},
        "2336": {"vr": "TM", "Value": ["094607.673000"]},
        "2337": {"vr": "TM", "Value": ["095147.700000"]},
        "2338": {"vr": "TM", "Value": ["094627.682000"]},
        "2339": {"vr": "TM", "Value": ["094807.738000"]},
        "2340": {"vr": "TM", "Value": ["095327.762000"]},
        "2341": {"vr": "TM", "Value": ["095047.943000"]},
        "2342": {"vr": "TM", "Value": ["095327.920000"]},
        "2343": {"vr": "TM", "Value": ["094907.772000"]},
        "2344": {"vr": "TM", "Value": ["094847.745000"]},
        "2345": {"vr": "TM", "Value": ["094927.659000"]},
        "2346": {"vr": "TM", "Value": ["095327.753000"]},
        "2347": {"vr": "TM", "Value": ["094707.817000"]},
        "2348": {"vr": "TM", "Value": ["095107.800000"]},
        "2349": {"vr": "TM", "Value": ["094727.893000"]},
        "2350": {"vr": "TM", "Value": ["094607.859000"]},
        "2351": {"vr": "TM", "Value": ["095207.626000"]},
        "2352": {"vr": "TM", "Value": ["094827.644000"]},
        "2353": {"vr": "TM", "Value": ["095347.876000"]},
        "2354": {"vr": "TM", "Value": ["094627.843000"]},
        "2355": {"vr": "TM", "Value": ["094527.922000"]},
        "2356": {"vr": "TM", "Value": ["094847.727000"]},
        "2357": {"vr": "TM", "Value": ["095447.630000"]},
        "2358": {"vr": "TM", "Value": ["094827.781000"]},
        "2359": {"vr": "TM", "Value": ["095327.733000"]},
        "2360": {"vr": "TM", "Value": ["094647.987000"]},
        "2361": {"vr": "TM", "Value": ["095447.829000"]},
        "2362": {"vr": "TM", "Value": ["095307.679000"]},
        "2363": {"vr": "TM", "Value": ["095447.698000"]},
        "2364": {"vr": "TM", "Value": ["095407.799000"]},
        "2365": {"vr": "TM", "Value": ["094607.778000"]},
        "2366": {"vr": "TM", "Value": ["094847.753000"]},
        "2367": {"vr": "TM", "Value": ["095047.910000"]},
        "2368": {"vr": "TM", "Value": ["095247.858000"]},
        "2369": {"vr": "TM", "Value": ["094527.673000"]},
        "2370": {"vr": "TM", "Value": ["094607.634000"]},
        "2371": {"vr": "TM", "Value": ["095107.615000"]},
        "2372": {"vr": "TM", "Value": ["094827.834000"]},
        "2373": {"vr": "TM", "Value": ["094627.828000"]},
        "2374": {"vr": "TM", "Value": ["094607.725000"]},
        "2375": {"vr": "TM", "Value": ["095007.626000"]},
        "2376": {"vr": "TM", "Value": ["094707.639000"]},
        "2377": {"vr": "TM", "Value": ["094547.817000"]},
        "2378": {"vr": "TM", "Value": ["095307.933000"]},
        "2379": {"vr": "TM", "Value": ["094627.736000"]},
        "2380": {"vr": "TM", "Value": ["095347.623000"]},
        "2381": {"vr": "TM", "Value": ["095147.835000"]},
        "2382": {"vr": "TM", "Value": ["095147.808000"]},
        "2383": {"vr": "TM", "Value": ["094907.911000"]},
        "2384": {"vr": "TM", "Value": ["094947.822000"]},
        "2385": {"vr": "TM", "Value": ["095007.865000"]},
        "2386": {"vr": "TM", "Value": ["095347.771000"]},
        "2387": {"vr": "TM", "Value": ["094747.723000"]},
        "2388": {"vr": "TM", "Value": ["095427.840000"]},
        "2389": {"vr": "TM", "Value": ["094607.720000"]},
        "2390": {"vr": "TM", "Value": ["095447.897000"]},
        "2391": {"vr": "TM", "Value": ["094747.930000"]},
        "2392": {"vr": "TM", "Value": ["094747.754000"]},
        "2393": {"vr": "TM", "Value": ["094547.883000"]},
        "2394": {"vr": "TM", "Value": ["095147.739000"]},
        "2395": {"vr": "TM", "Value": ["095347.848000"]},
        "2396": {"vr": "TM", "Value": ["094907.753000"]},
        "2397": {"vr": "TM", "Value": ["095347.759000"]},
        "2398": {"vr": "TM", "Value": ["095307.835000"]},
        "2399": {"vr": "TM", "Value": ["095407.835000"]},
        "2400": {"vr": "TM", "Value": ["095327.675000"]},
        "2401": {"vr": "TM", "Value": ["094847.865000"]},
        "2402": {"vr": "TM", "Value": ["095327.928000"]},
        "2403": {"vr": "TM", "Value": ["095227.752000"]},
        "2404": {"vr": "TM", "Value": ["095147.903000"]},
        "2405": {"vr": "TM", "Value": ["095207.803000"]},
        "2406": {"vr": "TM", "Value": ["094647.638000"]},
        "2407": {"vr": "TM", "Value": ["094807.907000"]},
        "2408": {"vr": "TM", "Value": ["094547.906000"]},
        "2409": {"vr": "TM", "Value": ["094847.953000"]},
        "2410": {"vr": "TM", "Value": ["095447.755000"]},
        "2411": {"vr": "TM", "Value": ["095127.720000"]},
        "2412": {"vr": "TM", "Value": ["095147.953000"]},
        "2413": {"vr": "TM", "Value": ["095307.653000"]},
        "2414": {"vr": "TM", "Value": ["095047.785000"]},
        "2415": {"vr": "TM", "Value": ["094627.619000"]},
        "2416": {"vr": "TM", "Value": ["094627.924000"]},
        "2417": {"vr": "TM", "Value": ["095456.524000"]},
        "2418": {"vr": "TM", "Value": ["095147.724000"]},
        "2419": {"vr": "TM", "Value": ["094807.715000"]},
        "2420": {"vr": "TM", "Value": ["095227.643000"]},
        "2421": {"vr": "TM", "Value": ["095207.777000"]},
        "2422": {"vr": "TM", "Value": ["095227.889000"]},
        "2423": {"vr": "TM", "Value": ["094547.694000"]},
        "2424": {"vr": "TM", "Value": ["094627.776000"]},
        "2425": {"vr": "TM", "Value": ["095127.625000"]},
        "2426": {"vr": "TM", "Value": ["094547.749000"]},
        "2427": {"vr": "TM", "Value": ["094747.866000"]},
        "2428": {"vr": "TM", "Value": ["095107.731000"]},
        "2429": {"vr": "TM", "Value": ["094927.906000"]},
        "2430": {"vr": "TM", "Value": ["094927.681000"]},
        "2431": {"vr": "TM", "Value": ["094547.786000"]},
        "2432": {"vr": "TM", "Value": ["094547.839000"]},
        "2433": {"vr": "TM", "Value": ["094827.882000"]},
        "2434": {"vr": "TM", "Value": ["094807.945000"]},
        "2435": {"vr": "TM", "Value": ["095407.875000"]},
        "2436": {"vr": "TM", "Value": ["094707.797000"]},
        "2437": {"vr": "TM", "Value": ["095147.677000"]},
        "2438": {"vr": "TM", "Value": ["094627.716000"]},
        "2439": {"vr": "TM", "Value": ["095127.860000"]},
        "2440": {"vr": "TM", "Value": ["095107.762000"]},
        "2441": {"vr": "TM", "Value": ["095347.741000"]},
        "2442": {"vr": "TM", "Value": ["095207.828000"]},
        "2443": {"vr": "TM", "Value": ["095247.839000"]},
        "2444": {"vr": "TM", "Value": ["095107.884000"]},
        "2445": {"vr": "TM", "Value": ["095207.805000"]},
        "2446": {"vr": "TM", "Value": ["094627.969000"]},
        "2447": {"vr": "TM", "Value": ["094927.946000"]},
        "2448": {"vr": "TM", "Value": ["095347.871000"]},
        "2449": {"vr": "TM", "Value": ["094547.842000"]},
        "2450": {"vr": "TM", "Value": ["095227.668000"]},
        "2451": {"vr": "TM", "Value": ["095027.918000"]},
        "2452": {"vr": "TM", "Value": ["094607.846000"]},
        "2453": {"vr": "TM", "Value": ["094927.809000"]},
        "2454": {"vr": "TM", "Value": ["095427.878000"]},
        "2455": {"vr": "TM", "Value": ["094747.845000"]},
        "2456": {"vr": "TM", "Value": ["095027.793000"]},
        "2457": {"vr": "TM", "Value": ["095027.698000"]},
        "2458": {"vr": "TM", "Value": ["095027.832000"]},
        "2459": {"vr": "TM", "Value": ["095427.936000"]},
        "2460": {"vr": "TM", "Value": ["094847.674000"]},
        "2461": {"vr": "TM", "Value": ["094807.735000"]},
        "2462": {"vr": "TM", "Value": ["095247.647000"]},
        "2463": {"vr": "TM", "Value": ["095407.761000"]},
        "2464": {"vr": "TM", "Value": ["095307.807000"]},
        "2465": {"vr": "TM", "Value": ["095147.880000"]},
        "2466": {"vr": "TM", "Value": ["094927.697000"]},
        "2467": {"vr": "TM", "Value": ["095027.913000"]},
        "2468": {"vr": "TM", "Value": ["095307.879000"]},
        "2469": {"vr": "TM", "Value": ["094947.858000"]},
        "2470": {"vr": "TM", "Value": ["094707.775000"]},
        "2471": {"vr": "TM", "Value": ["095147.615000"]},
        "2472": {"vr": "TM", "Value": ["094947.844000"]},
        "2473": {"vr": "TM", "Value": ["094807.962000"]},
        "2474": {"vr": "TM", "Value": ["094527.936000"]},
        "2475": {"vr": "TM", "Value": ["095147.642000"]},
        "2476": {"vr": "TM", "Value": ["095127.725000"]},
        "2477": {"vr": "TM", "Value": ["095447.618000"]},
        "2478": {"vr": "TM", "Value": ["094627.909000"]},
        "2479": {"vr": "TM", "Value": ["094647.940000"]},
        "2480": {"vr": "TM", "Value": ["095327.728000"]},
        "2481": {"vr": "TM", "Value": ["095347.751000"]},
        "2482": {"vr": "TM", "Value": ["094847.875000"]},
        "2483": {"vr": "TM", "Value": ["095327.935000"]},
        "2484": {"vr": "TM", "Value": ["094627.687000"]},
        "2485": {"vr": "TM", "Value": ["094827.620000"]},
        "2486": {"vr": "TM", "Value": ["094807.941000"]},
        "2487": {"vr": "TM", "Value": ["095327.659000"]},
        "2488": {"vr": "TM", "Value": ["095447.639000"]},
        "2489": {"vr": "TM", "Value": ["095427.794000"]},
        "2490": {"vr": "TM", "Value": ["095207.946000"]},
        "2491": {"vr": "TM", "Value": ["094627.933000"]},
        "2492": {"vr": "TM", "Value": ["095027.849000"]},
        "2493": {"vr": "TM", "Value": ["095107.835000"]},
        "2494": {"vr": "TM", "Value": ["095427.832000"]},
        "2495": {"vr": "TM", "Value": ["094827.737000"]},
        "2496": {"vr": "TM", "Value": ["094707.874000"]},
        "2497": {"vr": "TM", "Value": ["095327.925000"]},
        "2498": {"vr": "TM", "Value": ["095207.634000"]},
        "2499": {"vr": "TM", "Value": ["094847.903000"]},
        "2500": {"vr": "TM", "Value": ["095347.915000"]},
        "2501": {"vr": "TM", "Value": ["094947.737000"]},
        "2502": {"vr": "TM", "Value": ["094607.913000"]},
        "2503": {"vr": "TM", "Value": ["095327.639000"]},
        "2504": {"vr": "TM", "Value": ["094727.680000"]},
        "2505": {"vr": "TM", "Value": ["095147.930000"]},
        "2506": {"vr": "TM", "Value": ["094907.671000"]},
        "2507": {"vr": "TM", "Value": ["095147.607000"]},
        "2508": {"vr": "TM", "Value": ["095107.777000"]},
        "2509": {"vr": "TM", "Value": ["094727.947000"]},
        "2510": {"vr": "TM", "Value": ["095227.789000"]},
        "2511": {"vr": "TM", "Value": ["094907.777000"]},
        "2512": {"vr": "TM", "Value": ["095107.694000"]},
        "2513": {"vr": "TM", "Value": ["095427.722000"]},
        "2514": {"vr": "TM", "Value": ["094827.691000"]},
        "2515": {"vr": "TM", "Value": ["094607.802000"]},
        "2516": {"vr": "TM", "Value": ["094607.691000"]},
        "2517": {"vr": "TM", "Value": ["095347.941000"]},
        "2518": {"vr": "TM", "Value": ["094927.888000"]},
        "2519": {"vr": "TM", "Value": ["094847.808000"]},
        "2520": {"vr": "TM", "Value": ["095147.792000"]},
        "2521": {"vr": "TM", "Value": ["095327.642000"]},
        "2522": {"vr": "TM", "Value": ["095456.435000"]},
        "2523": {"vr": "TM", "Value": ["094627.642000"]},
        "2524": {"vr": "TM", "Value": ["095047.651000"]},
        "2525": {"vr": "TM", "Value": ["095456.505000"]},
        "2526": {"vr": "TM", "Value": ["094807.910000"]},
        "2527": {"vr": "TM", "Value": ["094807.888000"]},
        "2528": {"vr": "TM", "Value": ["095347.610000"]},
        "2529": {"vr": "TM", "Value": ["094847.758000"]},
        "2530": {"vr": "TM", "Value": ["095307.696000"]},
        "2531": {"vr": "TM", "Value": ["095247.658000"]},
        "2532": {"vr": "TM", "Value": ["095107.686000"]},
        "2533": {"vr": "TM", "Value": ["094547.926000"]},
        "2534": {"vr": "TM", "Value": ["095147.857000"]},
        "2535": {"vr": "TM", "Value": ["095107.845000"]},
        "2536": {"vr": "TM", "Value": ["094927.848000"]},
        "2537": {"vr": "TM", "Value": ["095007.911000"]},
        "2538": {"vr": "TM", "Value": ["095207.681000"]},
        "2539": {"vr": "TM", "Value": ["095456.417000"]},
        "2540": {"vr": "TM", "Value": ["095447.816000"]},
        "2541": {"vr": "TM", "Value": ["095027.808000"]},
        "2542": {"vr": "TM", "Value": ["094827.779000"]},
        "2543": {"vr": "TM", "Value": ["095247.675000"]},
        "2544": {"vr": "TM", "Value": ["094647.719000"]},
        "2545": {"vr": "TM", "Value": ["095107.739000"]},
        "2546": {"vr": "TM", "Value": ["095147.748000"]},
        "2547": {"vr": "TM", "Value": ["094707.810000"]},
        "2548": {"vr": "TM", "Value": ["094827.872000"]},
        "2549": {"vr": "TM", "Value": ["095027.803000"]},
        "2550": {"vr": "TM", "Value": ["095407.909000"]},
        "2551": {"vr": "TM", "Value": ["095247.935000"]},
        "2552": {"vr": "TM", "Value": ["095447.696000"]},
        "2553": {"vr": "TM", "Value": ["094607.951000"]},
        "2554": {"vr": "TM", "Value": ["094807.839000"]},
        "2555": {"vr": "TM", "Value": ["095127.703000"]},
        "2556": {"vr": "TM", "Value": ["095407.649000"]},
        "2557": {"vr": "TM", "Value": ["095327.758000"]},
        "2558": {"vr": "TM", "Value": ["095047.851000"]},
        "2559": {"vr": "TM", "Value": ["095327.886000"]},
        "2560": {"vr": "TM", "Value": ["095427.735000"]},
        "2561": {"vr": "TM", "Value": ["094927.760000"]},
        "2562": {"vr": "TM", "Value": ["095127.767000"]},
        "2563": {"vr": "TM", "Value": ["094847.885000"]},
        "2564": {"vr": "TM", "Value": ["094747.660000"]},
        "2565": {"vr": "TM", "Value": ["095347.738000"]},
        "2566": {"vr": "TM", "Value": ["095227.908000"]},
        "2567": {"vr": "TM", "Value": ["095147.702000"]},
        "2568": {"vr": "TM", "Value": ["095427.855000"]},
        "2569": {"vr": "TM", "Value": ["094647.764000"]},
        "2570": {"vr": "TM", "Value": ["095427.652000"]},
        "2571": {"vr": "TM", "Value": ["094707.627000"]},
        "2572": {"vr": "TM", "Value": ["095456.548000"]},
        "2573": {"vr": "TM", "Value": ["094547.898000"]},
        "2574": {"vr": "TM", "Value": ["095127.774000"]},
        "2575": {"vr": "TM", "Value": ["094627.707000"]},
        "2576": {"vr": "TM", "Value": ["095247.804000"]},
        "2577": {"vr": "TM", "Value": ["094807.938000"]},
        "2578": {"vr": "TM", "Value": ["094527.967000"]},
        "2579": {"vr": "TM", "Value": ["094527.786000"]},
        "2580": {"vr": "TM", "Value": ["095447.930000"]},
        "2581": {"vr": "TM", "Value": ["095027.669000"]},
        "2582": {"vr": "TM", "Value": ["095027.728000"]},
        "2583": {"vr": "TM", "Value": ["094927.661000"]},
        "2584": {"vr": "TM", "Value": ["094827.954000"]},
        "2585": {"vr": "TM", "Value": ["095327.797000"]},
        "2586": {"vr": "TM", "Value": ["095127.900000"]},
        "2587": {"vr": "TM", "Value": ["095227.875000"]},
        "2588": {"vr": "TM", "Value": ["094527.897000"]},
        "2589": {"vr": "TM", "Value": ["095447.918000"]},
        "2590": {"vr": "TM", "Value": ["095107.918000"]},
        "2591": {"vr": "TM", "Value": ["095407.906000"]},
        "2592": {"vr": "TM", "Value": ["094907.713000"]},
        "2593": {"vr": "TM", "Value": ["094927.855000"]},
        "2594": {"vr": "TM", "Value": ["094807.731000"]},
        "2595": {"vr": "TM", "Value": ["095347.956000"]},
        "2596": {"vr": "TM", "Value": ["094807.880000"]},
        "2597": {"vr": "TM", "Value": ["095427.913000"]},
        "2598": {"vr": "TM", "Value": ["094747.946000"]},
        "2599": {"vr": "TM", "Value": ["095107.875000"]},
        "2600": {"vr": "TM", "Value": ["095247.782000"]},
        "2601": {"vr": "TM", "Value": ["095327.860000"]},
        "2602": {"vr": "TM", "Value": ["094947.645000"]},
        "2603": {"vr": "TM", "Value": ["095247.792000"]},
        "2604": {"vr": "TM", "Value": ["095347.902000"]},
        "2605": {"vr": "TM", "Value": ["095207.808000"]},
        "2606": {"vr": "TM", "Value": ["095307.738000"]},
        "2607": {"vr": "TM", "Value": ["095207.821000"]},
        "2608": {"vr": "TM", "Value": ["095447.654000"]},
        "2609": {"vr": "TM", "Value": ["095147.734000"]},
        "2610": {"vr": "TM", "Value": ["094807.689000"]},
        "2611": {"vr": "TM", "Value": ["094827.884000"]},
        "2612": {"vr": "TM", "Value": ["094727.698000"]},
        "2613": {"vr": "TM", "Value": ["094627.669000"]},
        "2614": {"vr": "TM", "Value": ["095147.617000"]},
        "2615": {"vr": "TM", "Value": ["095347.864000"]},
        "2616": {"vr": "TM", "Value": ["094807.740000"]},
        "2617": {"vr": "TM", "Value": ["095207.951000"]},
        "2618": {"vr": "TM", "Value": ["095147.799000"]},
        "2619": {"vr": "TM", "Value": ["094927.674000"]},
        "2620": {"vr": "TM", "Value": ["094807.648000"]},
        "2621": {"vr": "TM", "Value": ["095027.905000"]},
        "2622": {"vr": "TM", "Value": ["095407.615000"]},
        "2623": {"vr": "TM", "Value": ["095327.832000"]},
        "2624": {"vr": "TM", "Value": ["095327.822000"]},
        "2625": {"vr": "TM", "Value": ["094847.839000"]},
        "2626": {"vr": "TM", "Value": ["095447.853000"]},
        "2627": {"vr": "TM", "Value": ["095327.649000"]},
        "2628": {"vr": "TM", "Value": ["095456.432000"]},
        "2629": {"vr": "TM", "Value": ["094707.668000"]},
        "2630": {"vr": "TM", "Value": ["094947.818000"]},
        "2631": {"vr": "TM", "Value": ["094947.647000"]},
        "2632": {"vr": "TM", "Value": ["094727.713000"]},
        "2633": {"vr": "TM", "Value": ["095007.738000"]},
        "2634": {"vr": "TM", "Value": ["094847.779000"]},
        "2635": {"vr": "TM", "Value": ["094547.746000"]},
        "2636": {"vr": "TM", "Value": ["095327.740000"]},
        "2637": {"vr": "TM", "Value": ["094947.775000"]},
        "2638": {"vr": "TM", "Value": ["094527.979000"]},
        "2639": {"vr": "TM", "Value": ["095147.758000"]},
        "2640": {"vr": "TM", "Value": ["094527.737000"]},
        "2641": {"vr": "TM", "Value": ["094627.952000"]},
        "2642": {"vr": "TM", "Value": ["094927.644000"]},
        "2643": {"vr": "TM", "Value": ["095447.886000"]},
        "2644": {"vr": "TM", "Value": ["095107.658000"]},
        "2645": {"vr": "TM", "Value": ["095327.616000"]},
        "2646": {"vr": "TM", "Value": ["095047.661000"]},
        "2647": {"vr": "TM", "Value": ["095227.648000"]},
        "2648": {"vr": "TM", "Value": ["095147.637000"]},
        "2649": {"vr": "TM", "Value": ["094707.927000"]},
        "2650": {"vr": "TM", "Value": ["094747.698000"]},
        "2651": {"vr": "TM", "Value": ["094827.836000"]},
        "2652": {"vr": "TM", "Value": ["094647.749000"]},
        "2653": {"vr": "TM", "Value": ["095427.668000"]},
        "2654": {"vr": "TM", "Value": ["095307.743000"]},
        "2655": {"vr": "TM", "Value": ["094547.834000"]},
        "2656": {"vr": "TM", "Value": ["094627.930000"]},
        "2657": {"vr": "TM", "Value": ["094747.863000"]},
        "2658": {"vr": "TM", "Value": ["095456.539000"]},
        "2659": {"vr": "TM", "Value": ["094847.879000"]},
        "2660": {"vr": "TM", "Value": ["095207.726000"]},
        "2661": {"vr": "TM", "Value": ["095347.695000"]},
        "2662": {"vr": "TM", "Value": ["095407.937000"]},
        "2663": {"vr": "TM", "Value": ["094607.754000"]},
        "2664": {"vr": "TM", "Value": ["094627.652000"]},
        "2665": {"vr": "TM", "Value": ["094627.766000"]},
        "2666": {"vr": "TM", "Value": ["095347.651000"]},
        "2667": {"vr": "TM", "Value": ["094747.972000"]},
        "2668": {"vr": "TM", "Value": ["094607.888000"]},
        "2669": {"vr": "TM", "Value": ["094647.670000"]},
        "2670": {"vr": "TM", "Value": ["094927.918000"]},
        "2671": {"vr": "TM", "Value": ["094847.801000"]},
        "2672": {"vr": "TM", "Value": ["095247.878000"]},
        "2673": {"vr": "TM", "Value": ["094707.773000"]},
        "2674": {"vr": "TM", "Value": ["094627.610000"]},
        "2675": {"vr": "TM", "Value": ["094627.927000"]},
        "2676": {"vr": "TM", "Value": ["094607.838000"]},
        "2677": {"vr": "TM", "Value": ["094947.637000"]},
        "2678": {"vr": "TM", "Value": ["095247.896000"]},
        "2679": {"vr": "TM", "Value": ["095007.892000"]},
        "2680": {"vr": "TM", "Value": ["094527.774000"]},
        "2681": {"vr": "TM", "Value": ["095207.938000"]},
        "2682": {"vr": "TM", "Value": ["095027.857000"]},
        "2683": {"vr": "TM", "Value": ["095227.839000"]},
        "2684": {"vr": "TM", "Value": ["094927.656000"]},
        "2685": {"vr": "TM", "Value": ["095147.692000"]},
        "2686": {"vr": "TM", "Value": ["094727.706000"]},
        "2687": {"vr": "TM", "Value": ["095107.630000"]},
        "2688": {"vr": "TM", "Value": ["095107.826000"]},
        "2689": {"vr": "TM", "Value": ["094847.750000"]},
        "2690": {"vr": "TM", "Value": ["094927.755000"]},
        "2691": {"vr": "TM", "Value": ["094647.673000"]},
        "2692": {"vr": "TM", "Value": ["094647.859000"]},
        "2693": {"vr": "TM", "Value": ["095107.838000"]},
        "2694": {"vr": "TM", "Value": ["095247.868000"]},
        "2695": {"vr": "TM", "Value": ["095227.717000"]},
        "2696": {"vr": "TM", "Value": ["094627.845000"]},
        "2697": {"vr": "TM", "Value": ["095427.616000"]},
        "2698": {"vr": "TM", "Value": ["095107.852000"]},
        "2699": {"vr": "TM", "Value": ["094727.836000"]},
        "2700": {"vr": "TM", "Value": ["094547.709000"]},
        "2701": {"vr": "TM", "Value": ["094907.788000"]},
        "2702": {"vr": "TM", "Value": ["094847.631000"]},
        "2703": {"vr": "TM", "Value": ["095427.886000"]},
        "2704": {"vr": "TM", "Value": ["094907.840000"]},
        "2705": {"vr": "TM", "Value": ["094607.688000"]},
        "2706": {"vr": "TM", "Value": ["094707.833000"]},
        "2707": {"vr": "TM", "Value": ["095407.814000"]},
        "2708": {"vr": "TM", "Value": ["095347.787000"]},
        "2709": {"vr": "TM", "Value": ["095327.647000"]},
        "2710": {"vr": "TM", "Value": ["095127.616000"]},
        "2711": {"vr": "TM", "Value": ["094607.905000"]},
        "2712": {"vr": "TM", "Value": ["094907.621000"]},
        "2713": {"vr": "TM", "Value": ["095427.905000"]},
        "2714": {"vr": "TM", "Value": ["095347.621000"]},
        "2715": {"vr": "TM", "Value": ["095107.634000"]},
        "2716": {"vr": "TM", "Value": ["095107.734000"]},
        "2717": {"vr": "TM", "Value": ["094847.829000"]},
        "2718": {"vr": "TM", "Value": ["094527.878000"]},
        "2719": {"vr": "TM", "Value": ["095047.746000"]},
        "2720": {"vr": "TM", "Value": ["094847.636000"]},
        "2721": {"vr": "TM", "Value": ["095407.932000"]},
        "2722": {"vr": "TM", "Value": ["094847.763000"]},
        "2723": {"vr": "TM", "Value": ["095447.821000"]},
        "2724": {"vr": "TM", "Value": ["095247.825000"]},
        "2725": {"vr": "TM", "Value": ["095247.613000"]},
        "2726": {"vr": "TM", "Value": ["095327.709000"]},
        "2727": {"vr": "TM", "Value": ["094927.676000"]},
        "2728": {"vr": "TM", "Value": ["094727.913000"]},
        "2729": {"vr": "TM", "Value": ["094927.853000"]},
        "2730": {"vr": "TM", "Value": ["095047.797000"]},
        "2731": {"vr": "TM", "Value": ["094907.666000"]},
        "2732": {"vr": "TM", "Value": ["095447.683000"]},
        "2733": {"vr": "TM", "Value": ["095407.827000"]},
        "2734": {"vr": "TM", "Value": ["094927.850000"]},
        "2735": {"vr": "TM", "Value": ["094647.644000"]},
        "2736": {"vr": "TM", "Value": ["095007.877000"]},
        "2737": {"vr": "TM", "Value": ["094927.712000"]},
        "2738": {"vr": "TM", "Value": ["094527.875000"]},
        "2739": {"vr": "TM", "Value": ["095047.767000"]},
        "2740": {"vr": "TM", "Value": ["094747.898000"]},
        "2741": {"vr": "TM", "Value": ["095456.457000"]},
        "2742": {"vr": "TM", "Value": ["095447.850000"]},
        "2743": {"vr": "TM", "Value": ["095407.840000"]},
        "2744": {"vr": "TM", "Value": ["095207.708000"]},
        "2745": {"vr": "TM", "Value": ["094547.615000"]},
        "2746": {"vr": "TM", "Value": ["095147.770000"]},
        "2747": {"vr": "TM", "Value": ["095247.923000"]},
        "2748": {"vr": "TM", "Value": ["095107.639000"]},
        "2749": {"vr": "TM", "Value": ["094847.782000"]},
        "2750": {"vr": "TM", "Value": ["094647.938000"]},
        "2751": {"vr": "TM", "Value": ["095247.621000"]},
        "2752": {"vr": "TM", "Value": ["094727.886000"]},
        "2753": {"vr": "TM", "Value": ["094527.900000"]},
        "2754": {"vr": "TM", "Value": ["095407.804000"]},
        "2755": {"vr": "TM", "Value": ["094727.937000"]},
        "2756": {"vr": "TM", "Value": ["095327.881000"]},
        "2757": {"vr": "TM", "Value": ["094827.892000"]},
        "2758": {"vr": "TM", "Value": ["094607.820000"]},
        "2759": {"vr": "TM", "Value": ["094647.782000"]},
        "2760": {"vr": "TM", "Value": ["095107.696000"]},
        "2761": {"vr": "TM", "Value": ["094927.689000"]},
        "2762": {"vr": "TM", "Value": ["095127.922000"]},
        "2763": {"vr": "TM", "Value": ["094707.840000"]},
        "2764": {"vr": "TM", "Value": ["094607.872000"]},
        "2765": {"vr": "TM", "Value": ["095007.781000"]},
        "2766": {"vr": "TM", "Value": ["094747.706000"]},
        "2767": {"vr": "TM", "Value": ["095027.615000"]},
        "2768": {"vr": "TM", "Value": ["095127.939000"]},
        "2769": {"vr": "TM", "Value": ["094627.884000"]},
        "2770": {"vr": "TM", "Value": ["095147.746000"]},
        "2771": {"vr": "TM", "Value": ["094547.774000"]},
        "2772": {"vr": "TM", "Value": ["094627.965000"]},
        "2773": {"vr": "TM", "Value": ["095347.712000"]},
        "2774": {"vr": "TM", "Value": ["094927.707000"]},
        "2775": {"vr": "TM", "Value": ["094527.801000"]},
        "2776": {"vr": "TM", "Value": ["094627.726000"]},
        "2777": {"vr": "TM", "Value": ["095147.811000"]},
        "2778": {"vr": "TM", "Value": ["095007.951000"]},
        "2779": {"vr": "TM", "Value": ["095247.698000"]},
        "2780": {"vr": "TM", "Value": ["095047.848000"]},
        "2781": {"vr": "TM", "Value": ["095456.448000"]},
        "2782": {"vr": "TM", "Value": ["094727.634000"]},
        "2783": {"vr": "TM", "Value": ["094627.863000"]},
        "2784": {"vr": "TM", "Value": ["094907.900000"]},
        "2785": {"vr": "TM", "Value": ["095007.941000"]},
        "2786": {"vr": "TM", "Value": ["094947.832000"]},
        "2787": {"vr": "TM", "Value": ["095427.732000"]},
        "2788": {"vr": "TM", "Value": ["095107.723000"]},
        "2789": {"vr": "TM", "Value": ["095127.932000"]},
        "2790": {"vr": "TM", "Value": ["094727.701000"]},
        "2791": {"vr": "TM", "Value": ["095207.844000"]},
        "2792": {"vr": "TM", "Value": ["095327.706000"]},
        "2793": {"vr": "TM", "Value": ["095247.739000"]},
        "2794": {"vr": "TM", "Value": ["094807.913000"]},
        "2795": {"vr": "TM", "Value": ["094747.690000"]},
        "2796": {"vr": "TM", "Value": ["095047.698000"]},
        "2797": {"vr": "TM", "Value": ["095147.842000"]},
        "2798": {"vr": "TM", "Value": ["095227.882000"]},
        "2799": {"vr": "TM", "Value": ["095347.628000"]},
        "2800": {"vr": "TM", "Value": ["095147.890000"]},
        "2801": {"vr": "TM", "Value": ["094907.668000"]},
        "2802": {"vr": "TM", "Value": ["095407.893000"]},
        "2803": {"vr": "TM", "Value": ["094947.697000"]},
        "2804": {"vr": "TM", "Value": ["095047.790000"]},
        "2805": {"vr": "TM", "Value": ["095127.821000"]},
        "2806": {"vr": "TM", "Value": ["094647.737000"]},
        "2807": {"vr": "TM", "Value": ["095427.748000"]},
        "2808": {"vr": "TM", "Value": ["095407.791000"]},
        "2809": {"vr": "TM", "Value": ["094907.903000"]},
        "2810": {"vr": "TM", "Value": ["095047.671000"]},
        "2811": {"vr": "TM", "Value": ["095447.950000"]},
        "2812": {"vr": "TM", "Value": ["094947.709000"]},
        "2813": {"vr": "TM", "Value": ["094747.871000"]},
        "2814": {"vr": "TM", "Value": ["094607.747000"]},
        "2815": {"vr": "TM", "Value": ["095047.769000"]},
        "2816": {"vr": "TM", "Value": ["094707.882000"]},
        "2817": {"vr": "TM", "Value": ["095127.642000"]},
        "2818": {"vr": "TM", "Value": ["094827.896000"]},
        "2819": {"vr": "TM", "Value": ["095407.741000"]},
        "2820": {"vr": "TM", "Value": ["094947.839000"]},
        "2821": {"vr": "TM", "Value": ["095407.786000"]},
        "2822": {"vr": "TM", "Value": ["095147.722000"]},
        "2823": {"vr": "TM", "Value": ["095347.928000"]},
        "2824": {"vr": "TM", "Value": ["095347.938000"]},
        "2825": {"vr": "TM", "Value": ["094827.826000"]},
        "2826": {"vr": "TM", "Value": ["094607.686000"]},
        "2827": {"vr": "TM", "Value": ["094727.878000"]},
        "2828": {"vr": "TM", "Value": ["095427.614000"]},
        "2829": {"vr": "TM", "Value": ["095307.707000"]},
        "2830": {"vr": "TM", "Value": ["095007.921000"]},
        "2831": {"vr": "TM", "Value": ["095327.945000"]},
        "2832": {"vr": "TM", "Value": ["095107.729000"]},
        "2833": {"vr": "TM", "Value": ["094947.733000"]},
        "2834": {"vr": "TM", "Value": ["095127.713000"]},
        "2835": {"vr": "TM", "Value": ["094907.765000"]},
        "2836": {"vr": "TM", "Value": ["095107.767000"]},
        "2837": {"vr": "TM", "Value": ["094707.800000"]},
        "2838": {"vr": "TM", "Value": ["094827.791000"]},
        "2839": {"vr": "TM", "Value": ["095047.640000"]},
        "2840": {"vr": "TM", "Value": ["094927.943000"]},
        "2841": {"vr": "TM", "Value": ["095247.780000"]},
        "2842": {"vr": "TM", "Value": ["095247.703000"]},
        "2843": {"vr": "TM", "Value": ["094947.652000"]},
        "2844": {"vr": "TM", "Value": ["094747.728000"]},
        "2845": {"vr": "TM", "Value": ["094827.694000"]},
        "2846": {"vr": "TM", "Value": ["094747.911000"]},
        "2847": {"vr": "TM", "Value": ["095327.907000"]},
        "2848": {"vr": "TM", "Value": ["095447.644000"]},
        "2849": {"vr": "TM", "Value": ["095307.926000"]},
        "2850": {"vr": "TM", "Value": ["095147.682000"]},
        "2851": {"vr": "TM", "Value": ["095247.616000"]},
        "2852": {"vr": "TM", "Value": ["095007.783000"]},
        "2853": {"vr": "TM", "Value": ["094727.818000"]},
        "2854": {"vr": "TM", "Value": ["094807.892000"]},
        "2855": {"vr": "TM", "Value": ["094527.625000"]},
        "2856": {"vr": "TM", "Value": ["094907.793000"]},
        "2857": {"vr": "TM", "Value": ["094807.943000"]},
        "2858": {"vr": "TM", "Value": ["094907.678000"]},
        "2859": {"vr": "TM", "Value": ["095227.745000"]},
        "2860": {"vr": "TM", "Value": ["095307.928000"]},
        "2861": {"vr": "TM", "Value": ["094807.633000"]},
        "2862": {"vr": "TM", "Value": ["094527.721000"]},
        "2863": {"vr": "TM", "Value": ["095007.672000"]},
        "2864": {"vr": "TM", "Value": ["094627.662000"]},
        "2865": {"vr": "TM", "Value": ["095247.712000"]},
        "2866": {"vr": "TM", "Value": ["094827.612000"]},
        "2867": {"vr": "TM", "Value": ["095207.826000"]},
        "2868": {"vr": "TM", "Value": ["095327.850000"]},
        "2869": {"vr": "TM", "Value": ["094807.915000"]},
        "2870": {"vr": "TM", "Value": ["094727.800000"]},
        "2871": {"vr": "TM", "Value": ["094547.607000"]},
        "2872": {"vr": "TM", "Value": ["095247.799000"]},
        "2873": {"vr": "TM", "Value": ["095207.716000"]},
        "2874": {"vr": "TM", "Value": ["094847.917000"]},
        "2875": {"vr": "TM", "Value": ["095407.687000"]},
        "2876": {"vr": "TM", "Value": ["094947.862000"]},
        "2877": {"vr": "TM", "Value": ["095047.900000"]},
        "2878": {"vr": "TM", "Value": ["095327.672000"]},
        "2879": {"vr": "TM", "Value": ["095047.946000"]},
        "2880": {"vr": "TM", "Value": ["095047.874000"]},
        "2881": {"vr": "TM", "Value": ["094947.763000"]},
        "2882": {"vr": "TM", "Value": ["094647.980000"]},
        "2883": {"vr": "TM", "Value": ["094607.938000"]},
        "2884": {"vr": "TM", "Value": ["094607.678000"]},
        "2885": {"vr": "TM", "Value": ["094847.824000"]},
        "2886": {"vr": "TM", "Value": ["095047.710000"]},
        "2887": {"vr": "TM", "Value": ["094907.906000"]},
        "2888": {"vr": "TM", "Value": ["094907.816000"]},
        "2889": {"vr": "TM", "Value": ["095447.670000"]},
        "2890": {"vr": "TM", "Value": ["094627.939000"]},
        "2891": {"vr": "TM", "Value": ["094707.899000"]},
        "2892": {"vr": "TM", "Value": ["095307.871000"]},
        "2893": {"vr": "TM", "Value": ["094827.628000"]},
        "2894": {"vr": "TM", "Value": ["095007.624000"]},
        "2895": {"vr": "TM", "Value": ["094547.806000"]},
        "2896": {"vr": "TM", "Value": ["095327.943000"]},
        "2897": {"vr": "TM", "Value": ["094947.673000"]},
        "2898": {"vr": "TM", "Value": ["095027.839000"]},
        "2899": {"vr": "TM", "Value": ["094747.751000"]},
        "2900": {"vr": "TM", "Value": ["095127.661000"]},
        "2901": {"vr": "TM", "Value": ["094627.655000"]},
        "2902": {"vr": "TM", "Value": ["095407.756000"]},
        "2903": {"vr": "TM", "Value": ["095127.796000"]},
        "2904": {"vr": "TM", "Value": ["095127.687000"]},
        "2905": {"vr": "TM", "Value": ["094747.941000"]},
        "2906": {"vr": "TM", "Value": ["094527.644000"]},
        "2907": {"vr": "TM", "Value": ["095456.422000"]},
        "2908": {"vr": "TM", "Value": ["094647.668000"]},
        "2909": {"vr": "TM", "Value": ["095427.737000"]},
        "2910": {"vr": "TM", "Value": ["094807.890000"]},
        "2911": {"vr": "TM", "Value": ["095407.743000"]},
        "2912": {"vr": "TM", "Value": ["094627.733000"]},
        "2913": {"vr": "TM", "Value": ["094927.791000"]},
        "2914": {"vr": "TM", "Value": ["094647.625000"]},
        "2915": {"vr": "TM", "Value": ["095027.951000"]},
        "2916": {"vr": "TM", "Value": ["095007.810000"]},
        "2917": {"vr": "TM", "Value": ["094807.883000"]},
        "2918": {"vr": "TM", "Value": ["094527.714000"]},
        "2919": {"vr": "TM", "Value": ["095456.519000"]},
        "2920": {"vr": "TM", "Value": ["095227.770000"]},
        "2921": {"vr": "TM", "Value": ["095147.625000"]},
        "2922": {"vr": "TM", "Value": ["095207.672000"]},
        "2923": {"vr": "TM", "Value": ["095007.829000"]},
        "2924": {"vr": "TM", "Value": ["095127.762000"]},
        "2925": {"vr": "TM", "Value": ["094607.732000"]},
        "2926": {"vr": "TM", "Value": ["094707.717000"]},
        "2927": {"vr": "TM", "Value": ["095307.822000"]},
        "2928": {"vr": "TM", "Value": ["094747.964000"]},
        "2929": {"vr": "TM", "Value": ["094527.919000"]},
        "2930": {"vr": "TM", "Value": ["094707.617000"]},
        "2931": {"vr": "TM", "Value": ["095447.899000"]},
        "2932": {"vr": "TM", "Value": ["095427.939000"]},
        "2933": {"vr": "TM", "Value": ["094647.627000"]},
        "2934": {"vr": "TM", "Value": ["095107.651000"]},
        "2935": {"vr": "TM", "Value": ["094707.685000"]},
        "2936": {"vr": "TM", "Value": ["095207.752000"]},
        "2937": {"vr": "TM", "Value": ["095307.866000"]},
        "2938": {"vr": "TM", "Value": ["095307.905000"]},
        "2939": {"vr": "TM", "Value": ["094847.827000"]},
        "2940": {"vr": "TM", "Value": ["094927.608000"]},
        "2941": {"vr": "TM", "Value": ["094727.860000"]},
        "2942": {"vr": "TM", "Value": ["095347.733000"]},
        "2943": {"vr": "TM", "Value": ["095207.659000"]},
        "2944": {"vr": "TM", "Value": ["095407.865000"]},
        "2945": {"vr": "TM", "Value": ["095447.926000"]},
        "2946": {"vr": "TM", "Value": ["094827.856000"]},
        "2947": {"vr": "TM", "Value": ["095307.912000"]},
        "2948": {"vr": "TM", "Value": ["094947.728000"]},
        "2949": {"vr": "TM", "Value": ["094527.705000"]},
        "2950": {"vr": "TM", "Value": ["094707.838000"]},
        "2951": {"vr": "TM", "Value": ["095107.817000"]},
        "2952": {"vr": "TM", "Value": ["095407.857000"]},
        "2953": {"vr": "TM", "Value": ["094907.813000"]},
        "2954": {"vr": "TM", "Value": ["095007.880000"]},
        "2955": {"vr": "TM", "Value": ["095147.854000"]},
        "2956": {"vr": "TM", "Value": ["095227.750000"]},
        "2957": {"vr": "TM", "Value": ["094627.899000"]},
        "2958": {"vr": "TM", "Value": ["094647.652000"]},
        "2959": {"vr": "TM", "Value": ["094747.829000"]},
        "2960": {"vr": "TM", "Value": ["094807.748000"]},
        "2961": {"vr": "TM", "Value": ["094747.935000"]},
        "2962": {"vr": "TM", "Value": ["094747.916000"]},
        "2963": {"vr": "TM", "Value": ["095347.654000"]},
        "2964": {"vr": "TM", "Value": ["094707.722000"]},
        "2965": {"vr": "TM", "Value": ["095327.863000"]},
        "2966": {"vr": "TM", "Value": ["094847.855000"]},
        "2967": {"vr": "TM", "Value": ["094607.841000"]},
        "2968": {"vr": "TM", "Value": ["094827.957000"]},
        "2969": {"vr": "TM", "Value": ["094707.879000"]},
        "2970": {"vr": "TM", "Value": ["095247.851000"]},
        "2971": {"vr": "TM", "Value": ["095447.861000"]},
        "2972": {"vr": "TM", "Value": ["095327.912000"]},
        "2973": {"vr": "TM", "Value": ["095047.728000"]},
        "2974": {"vr": "TM", "Value": ["094707.902000"]},
        "2975": {"vr": "TM", "Value": ["094547.886000"]},
        "2976": {"vr": "TM", "Value": ["094747.877000"]},
        "2977": {"vr": "TM", "Value": ["095107.699000"]},
        "2978": {"vr": "TM", "Value": ["094647.636000"]},
        "2979": {"vr": "TM", "Value": ["095307.625000"]},
        "2980": {"vr": "TM", "Value": ["095027.762000"]},
        "2981": {"vr": "TM", "Value": ["095227.814000"]},
        "2982": {"vr": "TM", "Value": ["095107.913000"]},
        "2983": {"vr": "TM", "Value": ["094627.744000"]},
        "2984": {"vr": "TM", "Value": ["095307.710000"]},
        "2985": {"vr": "TM", "Value": ["094847.629000"]},
        "2986": {"vr": "TM", "Value": ["094827.816000"]},
        "2987": {"vr": "TM", "Value": ["095127.682000"]},
        "2988": {"vr": "TM", "Value": ["095127.789000"]},
        "2989": {"vr": "TM", "Value": ["095247.670000"]},
        "2990": {"vr": "TM", "Value": ["094547.704000"]},
        "2991": {"vr": "TM", "Value": ["095207.629000"]},
        "2992": {"vr": "TM", "Value": ["095127.791000"]},
        "2993": {"vr": "TM", "Value": ["095027.795000"]},
        "2994": {"vr": "TM", "Value": ["095247.787000"]},
        "2995": {"vr": "TM", "Value": ["095347.774000"]},
        "2996": {"vr": "TM", "Value": ["094927.901000"]},
        "2997": {"vr": "TM", "Value": ["094807.697000"]},
        "2998": {"vr": "TM", "Value": ["095047.749000"]},
        "2999": {"vr": "TM", "Value": ["095027.814000"]},
        "3000": {"vr": "TM", "Value": ["095247.918000"]},
        "3001": {"vr": "TM", "Value": ["094627.731000"]},
        "3002": {"vr": "TM", "Value": ["095327.932000"]},
        "3003": {"vr": "TM", "Value": ["095127.737000"]},
        "3004": {"vr": "TM", "Value": ["095227.880000"]},
        "3005": {"vr": "TM", "Value": ["095456.430000"]},
        "3006": {"vr": "TM", "Value": ["095227.866000"]},
        "3007": {"vr": "TM", "Value": ["095307.753000"]},
        "3008": {"vr": "TM", "Value": ["094607.898000"]},
        "3009": {"vr": "TM", "Value": ["094707.740000"]},
        "3010": {"vr": "TM", "Value": ["095207.948000"]},
        "3011": {"vr": "TM", "Value": ["094847.814000"]},
        "3012": {"vr": "TM", "Value": ["094847.925000"]},
        "3013": {"vr": "TM", "Value": ["094727.763000"]},
        "3014": {"vr": "TM", "Value": ["095447.729000"]},
        "3015": {"vr": "TM", "Value": ["094907.954000"]},
        "3016": {"vr": "TM", "Value": ["094947.908000"]},
        "3017": {"vr": "TM", "Value": ["095047.807000"]},
        "3018": {"vr": "TM", "Value": ["095347.817000"]},
        "3019": {"vr": "TM", "Value": ["094527.744000"]},
        "3020": {"vr": "TM", "Value": ["094927.647000"]},
        "3021": {"vr": "TM", "Value": ["095047.623000"]},
        "3022": {"vr": "TM", "Value": ["094827.786000"]},
        "3023": {"vr": "TM", "Value": ["095127.755000"]},
        "3024": {"vr": "TM", "Value": ["095027.934000"]},
        "3025": {"vr": "TM", "Value": ["095307.629000"]},
        "3026": {"vr": "TM", "Value": ["094527.892000"]},
        "3027": {"vr": "TM", "Value": ["094727.670000"]},
        "3028": {"vr": "TM", "Value": ["094927.873000"]},
        "3029": {"vr": "TM", "Value": ["095147.845000"]},
        "3030": {"vr": "TM", "Value": ["095307.748000"]},
        "3031": {"vr": "TM", "Value": ["095307.923000"]},
        "3032": {"vr": "TM", "Value": ["095447.783000"]},
        "3033": {"vr": "TM", "Value": ["094647.754000"]},
        "3034": {"vr": "TM", "Value": ["094807.726000"]},
        "3035": {"vr": "TM", "Value": ["094907.673000"]},
        "3036": {"vr": "TM", "Value": ["095347.679000"]},
        "3037": {"vr": "TM", "Value": ["095047.948000"]},
        "3038": {"vr": "TM", "Value": ["094647.835000"]},
        "3039": {"vr": "TM", "Value": ["094647.827000"]},
        "3040": {"vr": "TM", "Value": ["094647.841000"]},
        "3041": {"vr": "TM", "Value": ["094747.879000"]},
        "3042": {"vr": "TM", "Value": ["095127.689000"]},
        "3043": {"vr": "TM", "Value": ["095247.715000"]},
        "3044": {"vr": "TM", "Value": ["095307.949000"]},
        "3045": {"vr": "TM", "Value": ["094627.840000"]},
        "3046": {"vr": "TM", "Value": ["094727.667000"]},
        "3047": {"vr": "TM", "Value": ["094947.706000"]},
        "3048": {"vr": "TM", "Value": ["094927.635000"]},
        "3049": {"vr": "TM", "Value": ["095407.948000"]},
        "3050": {"vr": "TM", "Value": ["095127.890000"]},
        "3051": {"vr": "TM", "Value": ["095027.819000"]},
        "3052": {"vr": "TM", "Value": ["094727.931000"]},
        "3053": {"vr": "TM", "Value": ["094647.912000"]},
        "3054": {"vr": "TM", "Value": ["095327.611000"]},
        "3055": {"vr": "TM", "Value": ["094607.629000"]},
        "3056": {"vr": "TM", "Value": ["095407.692000"]},
        "3057": {"vr": "TM", "Value": ["094607.815000"]},
        "3058": {"vr": "TM", "Value": ["094727.797000"]},
        "3059": {"vr": "TM", "Value": ["094727.802000"]},
        "3060": {"vr": "TM", "Value": ["095127.870000"]},
        "3061": {"vr": "TM", "Value": ["094827.758000"]},
        "3062": {"vr": "TM", "Value": ["095427.804000"]},
        "3063": {"vr": "TM", "Value": ["095407.608000"]},
        "3064": {"vr": "TM", "Value": ["094927.788000"]},
        "3065": {"vr": "TM", "Value": ["095127.639000"]},
        "3066": {"vr": "TM", "Value": ["095227.760000"]},
        "3067": {"vr": "TM", "Value": ["095027.710000"]},
        "3068": {"vr": "TM", "Value": ["095207.762000"]},
        "3069": {"vr": "TM", "Value": ["095027.897000"]},
        "3070": {"vr": "TM", "Value": ["095427.848000"]},
        "3071": {"vr": "TM", "Value": ["095027.672000"]},
        "3072": {"vr": "TM", "Value": ["095147.818000"]},
        "3073": {"vr": "TM", "Value": ["094747.684000"]},
        "3074": {"vr": "TM", "Value": ["094647.928000"]},
        "3075": {"vr": "TM", "Value": ["095447.706000"]},
        "3076": {"vr": "TM", "Value": ["094547.729000"]},
        "3077": {"vr": "TM", "Value": ["095147.765000"]},
        "3078": {"vr": "TM", "Value": ["095047.762000"]},
        "3079": {"vr": "TM", "Value": ["094927.679000"]},
        "3080": {"vr": "TM", "Value": ["094547.881000"]},
        "3081": {"vr": "TM", "Value": ["095327.938000"]},
        "3082": {"vr": "TM", "Value": ["095347.948000"]},
        "3083": {"vr": "TM", "Value": ["094847.898000"]},
        "3084": {"vr": "TM", "Value": ["095047.739000"]},
        "3085": {"vr": "TM", "Value": ["094847.895000"]},
        "3086": {"vr": "TM", "Value": ["095047.726000"]},
        "3087": {"vr": "TM", "Value": ["094547.781000"]},
        "3088": {"vr": "TM", "Value": ["095227.873000"]},
        "3089": {"vr": "TM", "Value": ["094527.668000"]},
        "3090": {"vr": "TM", "Value": ["095407.733000"]},
        "3091": {"vr": "TM", "Value": ["095107.901000"]},
        "3092": {"vr": "TM", "Value": ["094707.624000"]},
        "3093": {"vr": "TM", "Value": ["094807.607000"]},
        "3094": {"vr": "TM", "Value": ["095247.796000"]},
        "3095": {"vr": "TM", "Value": ["095247.743000"]},
        "3096": {"vr": "TM", "Value": ["095107.656000"]},
        "3097": {"vr": "TM", "Value": ["095007.931000"]},
        "3098": {"vr": "TM", "Value": ["094927.747000"]},
        "3099": {"vr": "TM", "Value": ["094827.821000"]},
        "3100": {"vr": "TM", "Value": ["094727.820000"]},
        "3101": {"vr": "TM", "Value": ["094827.618000"]},
        "3102": {"vr": "TM", "Value": ["095147.772000"]},
        "3103": {"vr": "TM", "Value": ["095147.613000"]},
        "3104": {"vr": "TM", "Value": ["095127.627000"]},
        "3105": {"vr": "TM", "Value": ["094907.895000"]},
        "3106": {"vr": "TM", "Value": ["094807.694000"]},
        "3107": {"vr": "TM", "Value": ["095407.728000"]},
        "3108": {"vr": "TM", "Value": ["095447.906000"]},
        "3109": {"vr": "TM", "Value": ["095427.868000"]},
        "3110": {"vr": "TM", "Value": ["094907.703000"]},
        "3111": {"vr": "TM", "Value": ["094827.623000"]},
        "3112": {"vr": "TM", "Value": ["094827.662000"]},
        "3113": {"vr": "TM", "Value": ["095227.863000"]},
        "3114": {"vr": "TM", "Value": ["094807.775000"]},
        "3115": {"vr": "TM", "Value": ["094527.845000"]},
        "3116": {"vr": "TM", "Value": ["094707.689000"]},
        "3117": {"vr": "TM", "Value": ["094907.686000"]},
        "3118": {"vr": "TM", "Value": ["094907.718000"]},
        "3119": {"vr": "TM", "Value": ["094647.888000"]},
        "3120": {"vr": "TM", "Value": ["095427.902000"]},
        "3121": {"vr": "TM", "Value": ["094847.946000"]},
        "3122": {"vr": "TM", "Value": ["094627.834000"]},
        "3123": {"vr": "TM", "Value": ["095307.848000"]},
        "3124": {"vr": "TM", "Value": ["094547.719000"]},
        "3125": {"vr": "TM", "Value": ["095247.784000"]},
        "3126": {"vr": "TM", "Value": ["095307.876000"]},
        "3127": {"vr": "TM", "Value": ["095207.790000"]},
        "3128": {"vr": "TM", "Value": ["095307.768000"]},
        "3129": {"vr": "TM", "Value": ["094607.796000"]},
        "3130": {"vr": "TM", "Value": ["094807.758000"]},
        "3131": {"vr": "TM", "Value": ["094847.644000"]},
        "3132": {"vr": "TM", "Value": ["094527.716000"]},
        "3133": {"vr": "TM", "Value": ["095207.943000"]},
        "3134": {"vr": "TM", "Value": ["095027.900000"]},
        "3135": {"vr": "TM", "Value": ["095347.797000"]},
        "3136": {"vr": "TM", "Value": ["094547.721000"]},
        "3137": {"vr": "TM", "Value": ["095407.914000"]},
        "3138": {"vr": "TM", "Value": ["094607.668000"]},
        "3139": {"vr": "TM", "Value": ["094547.672000"]},
        "3140": {"vr": "TM", "Value": ["095047.708000"]},
        "3141": {"vr": "TM", "Value": ["094807.802000"]},
        "3142": {"vr": "TM", "Value": ["095327.814000"]},
        "3143": {"vr": "TM", "Value": ["094627.914000"]},
        "3144": {"vr": "TM", "Value": ["094727.711000"]},
        "3145": {"vr": "TM", "Value": ["094527.945000"]},
        "3146": {"vr": "TM", "Value": ["095027.713000"]},
        "3147": {"vr": "TM", "Value": ["094727.771000"]},
        "3148": {"vr": "TM", "Value": ["094807.692000"]},
        "3149": {"vr": "TM", "Value": ["095147.948000"]},
        "3150": {"vr": "TM", "Value": ["095047.780000"]},
        "3151": {"vr": "TM", "Value": ["094707.747000"]},
        "3152": {"vr": "TM", "Value": ["095107.701000"]},
        "3153": {"vr": "TM", "Value": ["095307.686000"]},
        "3154": {"vr": "TM", "Value": ["094747.933000"]},
        "3155": {"vr": "TM", "Value": ["095427.822000"]},
        "3156": {"vr": "TM", "Value": ["094727.807000"]},
        "3157": {"vr": "TM", "Value": ["095247.873000"]},
        "3158": {"vr": "TM", "Value": ["095027.759000"]},
        "3159": {"vr": "TM", "Value": ["094807.658000"]},
        "3160": {"vr": "TM", "Value": ["094527.750000"]},
        "3161": {"vr": "TM", "Value": ["095007.761000"]},
        "3162": {"vr": "TM", "Value": ["094947.759000"]},
        "3163": {"vr": "TM", "Value": ["094607.916000"]},
        "3164": {"vr": "TM", "Value": ["094747.665000"]},
        "3165": {"vr": "TM", "Value": ["094527.646000"]},
        "3166": {"vr": "TM", "Value": ["094647.762000"]},
        "3167": {"vr": "TM", "Value": ["094647.617000"]},
        "3168": {"vr": "TM", "Value": ["095307.646000"]},
        "3169": {"vr": "TM", "Value": ["095007.773000"]},
        "3170": {"vr": "TM", "Value": ["095447.799000"]},
        "3171": {"vr": "TM", "Value": ["095027.782000"]},
        "3172": {"vr": "TM", "Value": ["095456.512000"]},
        "3173": {"vr": "TM", "Value": ["095327.883000"]},
        "3174": {"vr": "TM", "Value": ["094827.680000"]},
        "3175": {"vr": "TM", "Value": ["095007.746000"]},
        "3176": {"vr": "TM", "Value": ["095447.943000"]},
        "3177": {"vr": "TM", "Value": ["094927.709000"]},
        "3178": {"vr": "TM", "Value": ["095107.857000"]},
        "3179": {"vr": "TM", "Value": ["094907.822000"]},
        "3180": {"vr": "TM", "Value": ["095247.888000"]},
        "3181": {"vr": "TM", "Value": ["095307.733000"]},
        "3182": {"vr": "TM", "Value": ["095307.666000"]},
        "3183": {"vr": "TM", "Value": ["094807.676000"]},
        "3184": {"vr": "TM", "Value": ["094647.830000"]},
        "3185": {"vr": "TM", "Value": ["095307.756000"]},
        "3186": {"vr": "TM", "Value": ["095227.658000"]},
        "3187": {"vr": "TM", "Value": ["094927.737000"]},
        "3188": {"vr": "TM", "Value": ["094747.835000"]},
        "3189": {"vr": "TM", "Value": ["094747.850000"]},
        "3190": {"vr": "TM", "Value": ["095347.963000"]},
        "3191": {"vr": "TM", "Value": ["095307.918000"]},
        "3192": {"vr": "TM", "Value": ["095127.680000"]},
        "3193": {"vr": "TM", "Value": ["095007.841000"]},
        "3194": {"vr": "TM", "Value": ["094527.756000"]},
        "3195": {"vr": "TM", "Value": ["094927.868000"]},
        "3196": {"vr": "TM", "Value": ["094647.794000"]},
        "3197": {"vr": "TM", "Value": ["095247.883000"]},
        "3198": {"vr": "TM", "Value": ["095027.680000"]},
        "3199": {"vr": "TM", "Value": ["094907.770000"]},
        "3200": {"vr": "TM", "Value": ["094527.904000"]},
        "3201": {"vr": "TM", "Value": ["095247.836000"]},
        "3202": {"vr": "TM", "Value": ["095447.824000"]},
        "3203": {"vr": "TM", "Value": ["094947.806000"]},
        "3204": {"vr": "TM", "Value": ["094947.825000"]},
        "3205": {"vr": "TM", "Value": ["095447.760000"]},
        "3206": {"vr": "TM", "Value": ["094647.685000"]},
        "3207": {"vr": "TM", "Value": ["094907.755000"]},
        "3208": {"vr": "TM", "Value": ["094927.750000"]},
        "3209": {"vr": "TM", "Value": ["095227.783000"]},
        "3210": {"vr": "TM", "Value": ["094627.967000"]},
        "3211": {"vr": "TM", "Value": ["095047.912000"]},
        "3212": {"vr": "TM", "Value": ["095007.697000"]},
        "3213": {"vr": "TM", "Value": ["095307.894000"]},
        "3214": {"vr": "TM", "Value": ["095456.483000"]},
        "3215": {"vr": "TM", "Value": ["095407.695000"]},
        "3216": {"vr": "TM", "Value": ["095147.946000"]},
        "3217": {"vr": "TM", "Value": ["094627.891000"]},
        "3218": {"vr": "TM", "Value": ["094527.697000"]},
        "3219": {"vr": "TM", "Value": ["094747.824000"]},
        "3220": {"vr": "TM", "Value": ["095027.639000"]},
        "3221": {"vr": "TM", "Value": ["094727.615000"]},
        "3222": {"vr": "TM", "Value": ["095347.856000"]},
        "3223": {"vr": "TM", "Value": ["094907.676000"]},
        "3224": {"vr": "TM", "Value": ["094527.863000"]},
        "3225": {"vr": "TM", "Value": ["095147.674000"]},
        "3226": {"vr": "TM", "Value": ["095127.806000"]},
        "3227": {"vr": "TM", "Value": ["094747.814000"]},
        "3228": {"vr": "TM", "Value": ["095227.729000"]},
        "3229": {"vr": "TM", "Value": ["094627.807000"]},
        "3230": {"vr": "TM", "Value": ["094827.922000"]},
        "3231": {"vr": "TM", "Value": ["095207.700000"]},
        "3232": {"vr": "TM", "Value": ["094747.796000"]},
        "3233": {"vr": "TM", "Value": ["095427.858000"]},
        "3234": {"vr": "TM", "Value": ["094747.967000"]},
        "3235": {"vr": "TM", "Value": ["095147.622000"]},
        "3236": {"vr": "TM", "Value": ["094907.624000"]},
        "3237": {"vr": "TM", "Value": ["094927.933000"]},
        "3238": {"vr": "TM", "Value": ["095347.840000"]},
        "3239": {"vr": "TM", "Value": ["095307.735000"]},
        "3240": {"vr": "TM", "Value": ["095447.904000"]},
        "3241": {"vr": "TM", "Value": ["095227.842000"]},
        "3242": {"vr": "TM", "Value": ["094747.717000"]},
        "3243": {"vr": "TM", "Value": ["095007.904000"]},
        "3244": {"vr": "TM", "Value": ["094647.622000"]},
        "3245": {"vr": "TM", "Value": ["094527.873000"]},
        "3246": {"vr": "TM", "Value": ["095347.705000"]},
        "3247": {"vr": "TM", "Value": ["094927.753000"]},
        "3248": {"vr": "TM", "Value": ["095127.885000"]},
        "3249": {"vr": "TM", "Value": ["094847.935000"]},
        "3250": {"vr": "TM", "Value": ["095347.753000"]},
        "3251": {"vr": "TM", "Value": ["095107.632000"]},
        "3252": {"vr": "TM", "Value": ["095047.892000"]},
        "3253": {"vr": "TM", "Value": ["095307.817000"]},
        "3254": {"vr": "TM", "Value": ["095327.811000"]},
        "3255": {"vr": "TM", "Value": ["095447.938000"]},
        "3256": {"vr": "TM", "Value": ["095147.821000"]},
        "3257": {"vr": "TM", "Value": ["095307.668000"]},
        "3258": {"vr": "TM", "Value": ["095007.870000"]},
        "3259": {"vr": "TM", "Value": ["094607.781000"]},
        "3260": {"vr": "TM", "Value": ["095047.741000"]},
        "3261": {"vr": "TM", "Value": ["094927.637000"]},
        "3262": {"vr": "TM", "Value": ["094927.717000"]},
        "3263": {"vr": "TM", "Value": ["094827.789000"]},
        "3264": {"vr": "TM", "Value": ["095007.907000"]},
        "3265": {"vr": "TM", "Value": ["095347.830000"]},
        "3266": {"vr": "TM", "Value": ["095407.847000"]},
        "3267": {"vr": "TM", "Value": ["094927.765000"]},
        "3268": {"vr": "TM", "Value": ["094827.831000"]},
        "3269": {"vr": "TM", "Value": ["095227.804000"]},
        "3270": {"vr": "TM", "Value": ["095456.437000"]},
        "3271": {"vr": "TM", "Value": ["094747.919000"]},
        "3272": {"vr": "TM", "Value": ["095407.934000"]},
        "3273": {"vr": "TM", "Value": ["095447.680000"]},
        "3274": {"vr": "TM", "Value": ["095447.913000"]},
        "3275": {"vr": "TM", "Value": ["094727.863000"]},
        "3276": {"vr": "TM", "Value": ["094747.673000"]},
        "3277": {"vr": "TM", "Value": ["095047.754000"]},
        "3278": {"vr": "TM", "Value": ["095347.687000"]},
        "3279": {"vr": "TM", "Value": ["095347.707000"]},
        "3280": {"vr": "TM", "Value": ["094827.942000"]},
        "3281": {"vr": "TM", "Value": ["094747.809000"]},
        "3282": {"vr": "TM", "Value": ["094827.797000"]},
        "3283": {"vr": "TM", "Value": ["094647.717000"]},
        "3284": {"vr": "TM", "Value": ["095207.713000"]},
        "3285": {"vr": "TM", "Value": ["095047.884000"]},
        "3286": {"vr": "TM", "Value": ["095127.701000"]},
        "3287": {"vr": "TM", "Value": ["095327.845000"]},
        "3288": {"vr": "TM", "Value": ["094807.671000"]},
        "3289": {"vr": "TM", "Value": ["094647.729000"]},
        "3290": {"vr": "TM", "Value": ["094647.642000"]},
        "3291": {"vr": "TM", "Value": ["095107.644000"]},
        "3292": {"vr": "TM", "Value": ["095427.865000"]},
        "3293": {"vr": "TM", "Value": ["095007.621000"]},
        "3294": {"vr": "TM", "Value": ["095027.921000"]},
        "3295": {"vr": "TM", "Value": ["095127.654000"]},
        "3296": {"vr": "TM", "Value": ["094747.743000"]},
        "3297": {"vr": "TM", "Value": ["094747.676000"]},
        "3298": {"vr": "TM", "Value": ["094907.606000"]},
        "3299": {"vr": "TM", "Value": ["094627.865000"]},
        "3300": {"vr": "TM", "Value": ["094947.665000"]},
        "3301": {"vr": "TM", "Value": ["094947.875000"]},
        "3302": {"vr": "TM", "Value": ["095127.649000"]},
        "3303": {"vr": "TM", "Value": ["095447.874000"]},
        "3304": {"vr": "TM", "Value": ["094727.632000"]},
        "3305": {"vr": "TM", "Value": ["094927.904000"]},
        "3306": {"vr": "TM", "Value": ["095427.664000"]},
        "3307": {"vr": "TM", "Value": ["094607.809000"]},
        "3308": {"vr": "TM", "Value": ["094807.900000"]},
        "3309": {"vr": "TM", "Value": ["095207.933000"]},
        "3310": {"vr": "TM", "Value": ["094607.693000"]},
        "3311": {"vr": "TM", "Value": ["094847.740000"]},
        "3312": {"vr": "TM", "Value": ["095107.930000"]},
        "3313": {"vr": "TM", "Value": ["094527.804000"]},
        "3314": {"vr": "TM", "Value": ["094947.735000"]},
        "3315": {"vr": "TM", "Value": ["095007.926000"]},
        "3316": {"vr": "TM", "Value": ["094727.805000"]},
        "3317": {"vr": "TM", "Value": ["095407.625000"]},
        "3318": {"vr": "TM", "Value": ["095027.774000"]},
        "3319": {"vr": "TM", "Value": ["095307.838000"]},
        "3320": {"vr": "TM", "Value": ["095427.685000"]},
        "3321": {"vr": "TM", "Value": ["095227.918000"]},
        "3322": {"vr": "TM", "Value": ["095127.853000"]},
        "3323": {"vr": "TM", "Value": ["095047.695000"]},
        "3324": {"vr": "TM", "Value": ["095007.689000"]},
        "3325": {"vr": "TM", "Value": ["094727.708000"]},
        "3326": {"vr": "TM", "Value": ["094847.933000"]},
        "3327": {"vr": "TM", "Value": ["094947.650000"]},
        "3328": {"vr": "TM", "Value": ["095327.704000"]},
        "3329": {"vr": "TM", "Value": ["094807.780000"]},
        "3330": {"vr": "TM", "Value": ["094607.644000"]},
        "3331": {"vr": "TM", "Value": ["095447.837000"]},
        "3332": {"vr": "TM", "Value": ["095407.771000"]},
        "3333": {"vr": "TM", "Value": ["094807.868000"]},
        "3334": {"vr": "TM", "Value": ["095107.689000"]},
        "3335": {"vr": "TM", "Value": ["094947.851000"]},
        "3336": {"vr": "TM", "Value": ["094647.809000"]},
        "3337": {"vr": "TM", "Value": ["094527.776000"]},
        "3338": {"vr": "TM", "Value": ["094707.861000"]},
        "3339": {"vr": "TM", "Value": ["095107.843000"]},
        "3340": {"vr": "TM", "Value": ["094947.668000"]},
        "3341": {"vr": "TM", "Value": ["095127.927000"]},
        "3342": {"vr": "TM", "Value": ["095307.722000"]},
        "3343": {"vr": "TM", "Value": ["095007.853000"]},
        "3344": {"vr": "TM", "Value": ["094547.664000"]},
        "3345": {"vr": "TM", "Value": ["095107.899000"]},
        "3346": {"vr": "TM", "Value": ["095347.810000"]},
        "3347": {"vr": "TM", "Value": ["094827.901000"]},
        "3348": {"vr": "TM", "Value": ["094907.775000"]},
        "3349": {"vr": "TM", "Value": ["095427.789000"]},
        "3350": {"vr": "TM", "Value": ["094707.848000"]},
        "3351": {"vr": "TM", "Value": ["094627.820000"]},
        "3352": {"vr": "TM", "Value": ["094747.861000"]},
        "3353": {"vr": "TM", "Value": ["095327.868000"]},
        "3354": {"vr": "TM", "Value": ["094907.811000"]},
        "3355": {"vr": "TM", "Value": ["095007.700000"]},
        "3356": {"vr": "TM", "Value": ["095027.821000"]},
        "3357": {"vr": "TM", "Value": ["094547.799000"]},
        "3358": {"vr": "TM", "Value": ["094807.822000"]},
        "3359": {"vr": "TM", "Value": ["095407.669000"]},
        "3360": {"vr": "TM", "Value": ["095347.672000"]},
        "3361": {"vr": "TM", "Value": ["094907.636000"]},
        "3362": {"vr": "TM", "Value": ["094927.870000"]},
        "3363": {"vr": "TM", "Value": ["095347.769000"]},
        "3364": {"vr": "TM", "Value": ["095247.834000"]},
        "3365": {"vr": "TM", "Value": ["095456.497000"]},
        "3366": {"vr": "TM", "Value": ["095427.745000"]},
        "3367": {"vr": "TM", "Value": ["095347.833000"]},
        "3368": {"vr": "TM", "Value": ["094727.622000"]},
        "3369": {"vr": "TM", "Value": ["095247.654000"]},
        "3370": {"vr": "TM", "Value": ["095147.887000"]},
        "3371": {"vr": "TM", "Value": ["094927.796000"]},
        "3372": {"vr": "TM", "Value": ["095247.767000"]},
        "3373": {"vr": "TM", "Value": ["095207.928000"]},
        "3374": {"vr": "TM", "Value": ["095047.879000"]},
        "3375": {"vr": "TM", "Value": ["095227.911000"]},
        "3376": {"vr": "TM", "Value": ["094827.912000"]},
        "3377": {"vr": "TM", "Value": ["095247.925000"]},
        "3378": {"vr": "TM", "Value": ["094907.740000"]},
        "3379": {"vr": "TM", "Value": ["095027.613000"]},
        "3380": {"vr": "TM", "Value": ["094747.811000"]},
        "3381": {"vr": "TM", "Value": ["095227.684000"]},
        "3382": {"vr": "TM", "Value": ["095007.851000"]},
        "3383": {"vr": "TM", "Value": ["094607.936000"]},
        "3384": {"vr": "TM", "Value": ["095007.812000"]},
        "3385": {"vr": "TM", "Value": ["094807.921000"]},
        "3386": {"vr": "TM", "Value": ["095207.923000"]},
        "3387": {"vr": "TM", "Value": ["095447.834000"]},
        "3388": {"vr": "TM", "Value": ["094947.938000"]},
        "3389": {"vr": "TM", "Value": ["095327.682000"]},
        "3390": {"vr": "TM", "Value": ["095327.901000"]},
        "3391": {"vr": "TM", "Value": ["094827.714000"]},
        "3392": {"vr": "TM", "Value": ["094807.663000"]},
        "3393": {"vr": "TM", "Value": ["095007.763000"]},
        "3394": {"vr": "TM", "Value": ["094607.676000"]},
        "3395": {"vr": "TM", "Value": ["095207.926000"]},
        "3396": {"vr": "TM", "Value": ["094707.919000"]},
        "3397": {"vr": "TM", "Value": ["094807.924000"]},
        "3398": {"vr": "TM", "Value": ["094647.740000"]},
        "3399": {"vr": "TM", "Value": ["095227.832000"]},
        "3400": {"vr": "TM", "Value": ["095027.837000"]},
        "3401": {"vr": "TM", "Value": ["095007.611000"]},
        "3402": {"vr": "TM", "Value": ["095127.684000"]},
        "3403": {"vr": "TM", "Value": ["094907.649000"]},
        "3404": {"vr": "TM", "Value": ["094807.618000"]},
        "3405": {"vr": "TM", "Value": ["095007.863000"]},
        "3406": {"vr": "TM", "Value": ["095247.829000"]},
        "3407": {"vr": "TM", "Value": ["094727.619000"]},
        "3408": {"vr": "TM", "Value": ["094627.906000"]},
        "3409": {"vr": "TM", "Value": ["095207.754000"]},
        "3410": {"vr": "TM", "Value": ["095107.889000"]},
        "3411": {"vr": "TM", "Value": ["095227.704000"]},
        "3412": {"vr": "TM", "Value": ["095407.809000"]},
        "3413": {"vr": "TM", "Value": ["095427.719000"]},
        "3414": {"vr": "TM", "Value": ["095307.717000"]},
        "3415": {"vr": "TM", "Value": ["095327.853000"]},
        "3416": {"vr": "TM", "Value": ["094927.953000"]},
        "3417": {"vr": "TM", "Value": ["095127.819000"]},
        "3418": {"vr": "TM", "Value": ["094547.677000"]},
        "3419": {"vr": "TM", "Value": ["095347.720000"]},
        "3420": {"vr": "TM", "Value": ["094747.740000"]},
        "3421": {"vr": "TM", "Value": ["094647.660000"]},
        "3422": {"vr": "TM", "Value": ["095407.634000"]},
        "3423": {"vr": "TM", "Value": ["095427.705000"]},
        "3424": {"vr": "TM", "Value": ["095027.718000"]},
        "3425": {"vr": "TM", "Value": ["095007.684000"]},
        "3426": {"vr": "TM", "Value": ["095347.710000"]},
        "3427": {"vr": "TM", "Value": ["095127.675000"]},
        "3428": {"vr": "TM", "Value": ["094927.928000"]},
        "3429": {"vr": "TM", "Value": ["094947.719000"]},
        "3430": {"vr": "TM", "Value": ["095107.871000"]},
        "3431": {"vr": "TM", "Value": ["095327.719000"]},
        "3432": {"vr": "TM", "Value": ["094627.771000"]},
        "3433": {"vr": "TM", "Value": ["094627.721000"]},
        "3434": {"vr": "TM", "Value": ["095227.942000"]},
        "3435": {"vr": "TM", "Value": ["095207.744000"]},
        "3436": {"vr": "TM", "Value": ["095327.748000"]},
        "3437": {"vr": "TM", "Value": ["095347.799000"]},
        "3438": {"vr": "TM", "Value": ["094827.656000"]},
        "3439": {"vr": "TM", "Value": ["095147.657000"]},
        "3440": {"vr": "TM", "Value": ["095247.765000"]},
        "3441": {"vr": "TM", "Value": ["095307.941000"]},
        "3442": {"vr": "TM", "Value": ["095207.731000"]},
        "3443": {"vr": "TM", "Value": ["095347.822000"]},
        "3444": {"vr": "TM", "Value": ["095027.664000"]},
        "3445": {"vr": "TM", "Value": ["094547.625000"]},
        "3446": {"vr": "TM", "Value": ["094527.660000"]},
        "3447": {"vr": "TM", "Value": ["095427.621000"]},
        "3448": {"vr": "TM", "Value": ["094947.742000"]},
        "3449": {"vr": "TM", "Value": ["094907.790000"]},
        "3450": {"vr": "TM", "Value": ["095247.813000"]},
        "3451": {"vr": "TM", "Value": ["095027.931000"]},
        "3452": {"vr": "TM", "Value": ["094847.761000"]},
        "3453": {"vr": "TM", "Value": ["094907.931000"]},
        "3454": {"vr": "TM", "Value": ["094827.870000"]},
        "3455": {"vr": "TM", "Value": ["094627.851000"]},
        "3456": {"vr": "TM", "Value": ["094927.936000"]},
        "3457": {"vr": "TM", "Value": ["095247.668000"]},
        "3458": {"vr": "TM", "Value": ["095107.854000"]},
        "3459": {"vr": "TM", "Value": ["095407.779000"]},
        "3460": {"vr": "TM", "Value": ["095107.711000"]},
        "3461": {"vr": "TM", "Value": ["094647.631000"]},
        "3462": {"vr": "TM", "Value": ["094807.831000"]},
        "3463": {"vr": "TM", "Value": ["095127.814000"]},
        "3464": {"vr": "TM", "Value": ["095447.662000"]},
        "3465": {"vr": "TM", "Value": ["095127.880000"]},
        "3466": {"vr": "TM", "Value": ["094847.906000"]},
        "3467": {"vr": "TM", "Value": ["095347.692000"]},
        "3468": {"vr": "TM", "Value": ["094827.743000"]},
        "3469": {"vr": "TM", "Value": ["094727.776000"]},
        "3470": {"vr": "TM", "Value": ["095127.718000"]},
        "3471": {"vr": "TM", "Value": ["095107.828000"]},
        "3472": {"vr": "TM", "Value": ["095347.874000"]},
        "3473": {"vr": "TM", "Value": ["094607.823000"]},
        "3474": {"vr": "TM", "Value": ["094707.661000"]},
        "3475": {"vr": "TM", "Value": ["094927.863000"]},
        "3476": {"vr": "TM", "Value": ["094547.871000"]},
        "3477": {"vr": "TM", "Value": ["094527.860000"]},
        "3478": {"vr": "TM", "Value": ["095347.936000"]},
        "3479": {"vr": "TM", "Value": ["095107.749000"]},
        "3480": {"vr": "TM", "Value": ["094727.607000"]},
        "3481": {"vr": "TM", "Value": ["095456.451000"]},
        "3482": {"vr": "TM", "Value": ["095307.632000"]},
        "3483": {"vr": "TM", "Value": ["095347.905000"]},
        "3484": {"vr": "TM", "Value": ["095407.661000"]},
        "3485": {"vr": "TM", "Value": ["095127.803000"]},
        "3486": {"vr": "TM", "Value": ["095247.818000"]},
        "3487": {"vr": "TM", "Value": ["095447.889000"]},
        "3488": {"vr": "TM", "Value": ["094547.827000"]},
        "3489": {"vr": "TM", "Value": ["095227.819000"]},
        "3490": {"vr": "TM", "Value": ["094607.722000"]},
        "3491": {"vr": "TM", "Value": ["095347.661000"]},
        "3492": {"vr": "TM", "Value": ["094827.924000"]},
        "3493": {"vr": "TM", "Value": ["095427.771000"]},
        "3494": {"vr": "TM", "Value": ["095047.928000"]},
        "3495": {"vr": "TM", "Value": ["095227.894000"]},
        "3496": {"vr": "TM", "Value": ["094927.687000"]},
        "3497": {"vr": "TM", "Value": ["095127.786000"]},
        "3498": {"vr": "TM", "Value": ["095327.738000"]},
        "3499": {"vr": "TM", "Value": ["094907.877000"]},
        "3500": {"vr": "TM", "Value": ["095307.784000"]},
        "3501": {"vr": "TM", "Value": ["095007.919000"]},
        "3502": {"vr": "TM", "Value": ["095007.934000"]},
        "3503": {"vr": "TM", "Value": ["095327.711000"]},
        "3504": {"vr": "TM", "Value": ["094547.802000"]},
        "3505": {"vr": "TM", "Value": ["094807.773000"]},
        "3506": {"vr": "TM", "Value": ["094847.950000"]},
        "3507": {"vr": "TM", "Value": ["095047.795000"]},
        "3508": {"vr": "TM", "Value": ["095307.661000"]},
        "3509": {"vr": "TM", "Value": ["095207.644000"]},
        "3510": {"vr": "TM", "Value": ["095027.629000"]},
        "3511": {"vr": "TM", "Value": ["094527.683000"]},
        "3512": {"vr": "TM", "Value": ["094927.807000"]},
        "3513": {"vr": "TM", "Value": ["095107.670000"]},
        "3514": {"vr": "TM", "Value": ["095407.644000"]},
        "3515": {"vr": "TM", "Value": ["095027.726000"]},
        "3516": {"vr": "TM", "Value": ["094527.931000"]},
        "3517": {"vr": "TM", "Value": ["095427.631000"]},
        "3518": {"vr": "TM", "Value": ["094727.911000"]},
        "3519": {"vr": "TM", "Value": ["095027.767000"]},
        "3520": {"vr": "TM", "Value": ["095207.913000"]},
        "3521": {"vr": "TM", "Value": ["095456.469000"]},
        "3522": {"vr": "TM", "Value": ["094527.613000"]},
        "3523": {"vr": "TM", "Value": ["095447.757000"]},
        "3524": {"vr": "TM", "Value": ["095147.660000"]},
        "3525": {"vr": "TM", "Value": ["095007.659000"]},
        "3526": {"vr": "TM", "Value": ["094847.698000"]},
        "3527": {"vr": "TM", "Value": ["095427.713000"]},
        "3528": {"vr": "TM", "Value": ["094807.653000"]},
        "3529": {"vr": "TM", "Value": ["095456.445000"]},
        "3530": {"vr": "TM", "Value": ["094827.607000"]},
        "3531": {"vr": "TM", "Value": ["094647.688000"]},
        "3532": {"vr": "TM", "Value": ["094827.849000"]},
        "3533": {"vr": "TM", "Value": ["094827.813000"]},
        "3534": {"vr": "TM", "Value": ["095407.682000"]},
        "3535": {"vr": "TM", "Value": ["095227.632000"]},
        "3536": {"vr": "TM", "Value": ["094727.637000"]},
        "3537": {"vr": "TM", "Value": ["094627.630000"]},
        "3538": {"vr": "TM", "Value": ["095207.800000"]},
        "3539": {"vr": "TM", "Value": ["095456.527000"]},
        "3540": {"vr": "TM", "Value": ["095047.861000"]},
        "3541": {"vr": "TM", "Value": ["095207.833000"]},
        "3542": {"vr": "TM", "Value": ["094807.628000"]},
        "3543": {"vr": "TM", "Value": ["094907.885000"]},
        "3544": {"vr": "TM", "Value": ["094947.692000"]},
        "3545": {"vr": "TM", "Value": ["094847.872000"]},
        "3546": {"vr": "TM", "Value": ["095007.715000"]},
        "3547": {"vr": "TM", "Value": ["094847.682000"]},
        "3548": {"vr": "TM", "Value": ["095107.784000"]},
        "3549": {"vr": "TM", "Value": ["094627.627000"]},
        "3550": {"vr": "TM", "Value": ["095147.652000"]},
        "3551": {"vr": "TM", "Value": ["094627.667000"]},
        "3552": {"vr": "TM", "Value": ["095407.860000"]},
        "3553": {"vr": "TM", "Value": ["094947.726000"]},
        "3554": {"vr": "TM", "Value": ["094847.669000"]},
        "3555": {"vr": "TM", "Value": ["094947.627000"]},
        "3556": {"vr": "TM", "Value": ["094807.960000"]},
        "3557": {"vr": "TM", "Value": ["094747.668000"]},
        "3558": {"vr": "TM", "Value": ["094607.943000"]},
        "3559": {"vr": "TM", "Value": ["095047.703000"]},
        "3560": {"vr": "TM", "Value": ["094927.865000"]},
        "3561": {"vr": "TM", "Value": ["095247.684000"]},
        "3562": {"vr": "TM", "Value": ["094907.834000"]},
        "3563": {"vr": "TM", "Value": ["095227.701000"]},
        "3564": {"vr": "TM", "Value": ["094927.623000"]},
        "3565": {"vr": "TM", "Value": ["095327.654000"]},
        "3566": {"vr": "TM", "Value": ["095047.721000"]},
        "3567": {"vr": "TM", "Value": ["094607.918000"]},
        "3568": {"vr": "TM", "Value": ["094527.965000"]},
        "3569": {"vr": "TM", "Value": ["094707.930000"]},
        "3570": {"vr": "TM", "Value": ["094827.794000"]},
        "3571": {"vr": "TM", "Value": ["094607.656000"]},
        "3572": {"vr": "TM", "Value": ["095047.705000"]},
        "3573": {"vr": "TM", "Value": ["094547.864000"]},
        "3574": {"vr": "TM", "Value": ["094627.805000"]},
        "3575": {"vr": "TM", "Value": ["094707.663000"]},
        "3576": {"vr": "TM", "Value": ["095147.684000"]},
        "3577": {"vr": "TM", "Value": ["094947.711000"]},
        "3578": {"vr": "TM", "Value": ["094647.825000"]},
        "3579": {"vr": "TM", "Value": ["095007.677000"]},
        "3580": {"vr": "TM", "Value": ["095427.784000"]},
        "3581": {"vr": "TM", "Value": ["095307.802000"]},
        "3582": {"vr": "TM", "Value": ["095027.754000"]},
        "3583": {"vr": "TM", "Value": ["095447.839000"]},
        "3584": {"vr": "TM", "Value": ["094707.813000"]},
        "3585": {"vr": "TM", "Value": ["095047.700000"]},
        "3586": {"vr": "TM", "Value": ["095347.953000"]},
        "3587": {"vr": "TM", "Value": ["095347.835000"]},
        "3588": {"vr": "TM", "Value": ["094907.760000"]},
        "3589": {"vr": "TM", "Value": ["095327.721000"]},
        "3590": {"vr": "TM", "Value": ["094847.766000"]},
        "3591": {"vr": "TM", "Value": ["095307.673000"]},
        "3592": {"vr": "TM", "Value": ["094907.866000"]},
        "3593": {"vr": "TM", "Value": ["095307.907000"]},
        "3594": {"vr": "TM", "Value": ["095247.760000"]},
        "3595": {"vr": "TM", "Value": ["094727.815000"]},
        "3596": {"vr": "TM", "Value": ["094827.899000"]},
        "3597": {"vr": "TM", "Value": ["094747.628000"]},
        "3598": {"vr": "TM", "Value": ["094827.934000"]},
        "3599": {"vr": "TM", "Value": ["094547.761000"]},
        "3600": {"vr": "TM", "Value": ["095127.911000"]},
        "3601": {"vr": "TM", "Value": ["095227.934000"]},
        "3602": {"vr": "TM", "Value": ["094947.730000"]},
        "3603": {"vr": "TM", "Value": ["094827.675000"]},
        "3604": {"vr": "TM", "Value": ["094907.874000"]},
        "3605": {"vr": "TM", "Value": ["094927.827000"]},
        "3606": {"vr": "TM", "Value": ["095047.618000"]},
        "3607": {"vr": "TM", "Value": ["095447.652000"]},
        "3608": {"vr": "TM", "Value": ["094727.954000"]},
        "3609": {"vr": "TM", "Value": ["095407.651000"]},
        "3610": {"vr": "TM", "Value": ["095327.680000"]},
        "3611": {"vr": "TM", "Value": ["094607.773000"]},
        "3612": {"vr": "TM", "Value": ["095027.627000"]},
        "3613": {"vr": "TM", "Value": ["095247.689000"]},
        "3614": {"vr": "TM", "Value": ["095327.666000"]},
        "3615": {"vr": "TM", "Value": ["094627.746000"]},
        "3616": {"vr": "TM", "Value": ["094947.685000"]},
        "3617": {"vr": "TM", "Value": ["094707.707000"]},
        "3618": {"vr": "TM", "Value": ["094627.714000"]},
        "3619": {"vr": "TM", "Value": ["094527.972000"]},
        "3620": {"vr": "TM", "Value": ["094807.817000"]},
        "3621": {"vr": "TM", "Value": ["094847.688000"]},
        "3622": {"vr": "TM", "Value": ["094607.768000"]},
        "3623": {"vr": "TM", "Value": ["094647.870000"]},
        "3624": {"vr": "TM", "Value": ["095447.806000"]},
        "3625": {"vr": "TM", "Value": ["095447.703000"]},
        "3626": {"vr": "TM", "Value": ["094927.783000"]},
        "3627": {"vr": "TM", "Value": ["095347.804000"]},
        "3628": {"vr": "TM", "Value": ["095147.852000"]},
        "3629": {"vr": "TM", "Value": ["094547.950000"]},
        "3630": {"vr": "TM", "Value": ["095347.912000"]},
        "3631": {"vr": "TM", "Value": ["095407.880000"]},
        "3632": {"vr": "TM", "Value": ["094747.638000"]},
        "3633": {"vr": "TM", "Value": ["095227.650000"]},
        "3634": {"vr": "TM", "Value": ["095407.632000"]},
        "3635": {"vr": "TM", "Value": ["094927.649000"]},
        "3636": {"vr": "TM", "Value": ["095447.778000"]},
        "3637": {"vr": "TM", "Value": ["094547.910000"]},
        "3638": {"vr": "TM", "Value": ["094647.975000"]},
        "3639": {"vr": "TM", "Value": ["095427.941000"]},
        "3640": {"vr": "TM", "Value": ["095007.817000"]},
        "3641": {"vr": "TM", "Value": ["094847.816000"]},
        "3642": {"vr": "TM", "Value": ["095427.918000"]},
        "3643": {"vr": "TM", "Value": ["094947.739000"]},
        "3644": {"vr": "TM", "Value": ["095107.896000"]},
        "3645": {"vr": "TM", "Value": ["094627.896000"]},
        "3646": {"vr": "TM", "Value": ["094707.925000"]},
        "3647": {"vr": "TM", "Value": ["095247.731000"]},
        "3648": {"vr": "TM", "Value": ["095227.719000"]},
        "3649": {"vr": "TM", "Value": ["095027.667000"]},
        "3650": {"vr": "TM", "Value": ["094907.639000"]},
        "3651": {"vr": "TM", "Value": ["094807.785000"]},
        "3652": {"vr": "TM", "Value": ["095027.816000"]},
        "3653": {"vr": "TM", "Value": ["095327.784000"]},
        "3654": {"vr": "TM", "Value": ["095007.856000"]},
        "3655": {"vr": "TM", "Value": ["094707.709000"]},
        "3656": {"vr": "TM", "Value": ["095147.877000"]},
        "3657": {"vr": "TM", "Value": ["095407.877000"]},
        "3658": {"vr": "TM", "Value": ["094607.807000"]},
        "3659": {"vr": "TM", "Value": ["095407.911000"]},
        "3660": {"vr": "TM", "Value": ["094627.955000"]},
        "3661": {"vr": "TM", "Value": ["094747.610000"]},
        "3662": {"vr": "TM", "Value": ["095347.669000"]},
        "3663": {"vr": "TM", "Value": ["095347.723000"]},
        "3664": {"vr": "TM", "Value": ["094627.904000"]},
        "3665": {"vr": "TM", "Value": ["094727.957000"]},
        "3666": {"vr": "TM", "Value": ["095227.791000"]},
        "3667": {"vr": "TM", "Value": ["094927.825000"]},
        "3668": {"vr": "TM", "Value": ["094707.619000"]},
        "3669": {"vr": "TM", "Value": ["094807.728000"]},
        "3670": {"vr": "TM", "Value": ["094807.641000"]},
        "3671": {"vr": "TM", "Value": ["094947.787000"]},
        "3672": {"vr": "TM", "Value": ["094547.908000"]},
        "3673": {"vr": "TM", "Value": ["095456.534000"]},
        "3674": {"vr": "TM", "Value": ["094627.738000"]},
        "3675": {"vr": "TM", "Value": ["094907.681000"]},
        "3676": {"vr": "TM", "Value": ["095227.765000"]},
        "3677": {"vr": "TM", "Value": ["094607.928000"]},
        "3678": {"vr": "TM", "Value": ["095227.689000"]},
        "3679": {"vr": "TM", "Value": ["095227.755000"]},
        "3680": {"vr": "TM", "Value": ["095127.917000"]},
        "3681": {"vr": "TM", "Value": ["094707.697000"]},
        "3682": {"vr": "TM", "Value": ["094807.790000"]},
        "3683": {"vr": "TM", "Value": ["094947.827000"]},
        "3684": {"vr": "TM", "Value": ["094627.894000"]},
        "3685": {"vr": "TM", "Value": ["095207.849000"]},
        "3686": {"vr": "TM", "Value": ["094847.768000"]},
        "3687": {"vr": "TM", "Value": ["095147.779000"]},
        "3688": {"vr": "TM", "Value": ["095107.718000"]},
        "3689": {"vr": "TM", "Value": ["095247.630000"]},
        "3690": {"vr": "TM", "Value": ["094547.741000"]},
        "3691": {"vr": "TM", "Value": ["094847.735000"]},
        "3692": {"vr": "TM", "Value": ["094607.851000"]},
        "3693": {"vr": "TM", "Value": ["095047.666000"]},
        "3694": {"vr": "TM", "Value": ["095427.642000"]},
        "3695": {"vr": "TM", "Value": ["094627.640000"]},
        "3696": {"vr": "TM", "Value": ["095007.798000"]},
        "3697": {"vr": "TM", "Value": ["094907.829000"]},
        "3698": {"vr": "TM", "Value": ["094647.946000"]},
        "3699": {"vr": "TM", "Value": ["094807.918000"]},
        "3700": {"vr": "TM", "Value": ["095447.719000"]},
        "3701": {"vr": "TM", "Value": ["094647.695000"]},
        "3702": {"vr": "TM", "Value": ["094747.726000"]},
        "3703": {"vr": "TM", "Value": ["095427.860000"]},
        "3704": {"vr": "TM", "Value": ["095147.928000"]},
        "3705": {"vr": "TM", "Value": ["094607.843000"]},
        "3706": {"vr": "TM", "Value": ["095047.902000"]},
        "3707": {"vr": "TM", "Value": ["094707.868000"]},
        "3708": {"vr": "TM", "Value": ["095227.732000"]},
        "3709": {"vr": "TM", "Value": ["094827.699000"]},
        "3710": {"vr": "TM", "Value": ["095247.722000"]},
        "3711": {"vr": "TM", "Value": ["095327.835000"]},
        "3712": {"vr": "TM", "Value": ["094907.716000"]},
        "3713": {"vr": "TM", "Value": ["094527.941000"]},
        "3714": {"vr": "TM", "Value": ["095427.894000"]},
        "3715": {"vr": "TM", "Value": ["095047.833000"]},
        "3716": {"vr": "TM", "Value": ["095147.784000"]},
        "3717": {"vr": "TM", "Value": ["095427.609000"]},
        "3718": {"vr": "TM", "Value": ["095347.746000"]},
        "3719": {"vr": "TM", "Value": ["094607.765000"]},
        "3720": {"vr": "TM", "Value": ["095247.870000"]},
        "3721": {"vr": "TM", "Value": ["094947.880000"]},
        "3722": {"vr": "TM", "Value": ["094907.796000"]},
        "3723": {"vr": "TM", "Value": ["094827.907000"]},
        "3724": {"vr": "TM", "Value": ["094727.743000"]},
        "3725": {"vr": "TM", "Value": ["094647.769000"]},
        "3726": {"vr": "TM", "Value": ["095227.627000"]},
        "3727": {"vr": "TM", "Value": ["095047.876000"]},
        "3728": {"vr": "TM", "Value": ["095207.646000"]},
        "3729": {"vr": "TM", "Value": ["095327.692000"]},
        "3730": {"vr": "TM", "Value": ["094627.660000"]},
        "3731": {"vr": "TM", "Value": ["095127.691000"]},
        "3732": {"vr": "TM", "Value": ["094707.907000"]},
        "3733": {"vr": "TM", "Value": ["094547.684000"]},
        "3734": {"vr": "TM", "Value": ["095427.626000"]},
        "3735": {"vr": "TM", "Value": ["095327.804000"]},
        "3736": {"vr": "TM", "Value": ["095407.751000"]},
        "3737": {"vr": "TM", "Value": ["094847.928000"]},
        "3738": {"vr": "TM", "Value": ["095447.632000"]},
        "3739": {"vr": "TM", "Value": ["095047.830000"]},
        "3740": {"vr": "TM", "Value": ["094807.885000"]},
        "3741": {"vr": "TM", "Value": ["095127.811000"]},
        "3742": {"vr": "TM", "Value": ["095007.795000"]},
        "3743": {"vr": "TM", "Value": ["095247.644000"]},
        "3744": {"vr": "TM", "Value": ["094527.732000"]},
        "3745": {"vr": "TM", "Value": ["094547.618000"]},
        "3746": {"vr": "TM", "Value": ["094807.687000"]},
        "3747": {"vr": "TM", "Value": ["095407.776000"]},
        "3748": {"vr": "TM", "Value": ["095347.850000"]},
        "3749": {"vr": "TM", "Value": ["094827.750000"]},
        "3750": {"vr": "TM", "Value": ["094847.847000"]},
        "3751": {"vr": "TM", "Value": ["094807.807000"]},
        "3752": {"vr": "TM", "Value": ["094807.848000"]},
        "3753": {"vr": "TM", "Value": ["094947.640000"]},
        "3754": {"vr": "TM", "Value": ["095007.664000"]},
        "3755": {"vr": "TM", "Value": ["095027.703000"]},
        "3756": {"vr": "TM", "Value": ["095147.736000"]},
        "3757": {"vr": "TM", "Value": ["094627.950000"]},
        "3758": {"vr": "TM", "Value": ["095327.871000"]},
        "3759": {"vr": "TM", "Value": ["094927.883000"]},
        "3760": {"vr": "TM", "Value": ["094647.707000"]},
        "3761": {"vr": "TM", "Value": ["094927.684000"]},
        "3762": {"vr": "TM", "Value": ["094607.651000"]},
        "3763": {"vr": "TM", "Value": ["095147.833000"]},
        "3764": {"vr": "TM", "Value": ["095107.665000"]},
        "3765": {"vr": "TM", "Value": ["095447.858000"]},
        "3766": {"vr": "TM", "Value": ["094947.867000"]},
        "3767": {"vr": "TM", "Value": ["095127.832000"]},
        "3768": {"vr": "TM", "Value": ["095327.891000"]},
        "3769": {"vr": "TM", "Value": ["094647.899000"]},
        "3770": {"vr": "TM", "Value": ["094747.633000"]},
        "3771": {"vr": "TM", "Value": ["095447.608000"]},
        "3772": {"vr": "TM", "Value": ["095027.625000"]},
        "3773": {"vr": "TM", "Value": ["095327.613000"]},
        "3774": {"vr": "TM", "Value": ["094927.830000"]},
        "3775": {"vr": "TM", "Value": ["095107.894000"]},
        "3776": {"vr": "TM", "Value": ["094527.925000"]},
        "3777": {"vr": "TM", "Value": ["095027.646000"]},
        "3778": {"vr": "TM", "Value": ["094607.700000"]},
        "3779": {"vr": "TM", "Value": ["094847.654000"]},
        "3780": {"vr": "TM", "Value": ["094607.661000"]},
        "3781": {"vr": "TM", "Value": ["095347.728000"]},
        "3782": {"vr": "TM", "Value": ["094647.655000"]},
        "3783": {"vr": "TM", "Value": ["094647.838000"]},
        "3784": {"vr": "TM", "Value": ["095447.786000"]},
        "3785": {"vr": "TM", "Value": ["094647.910000"]},
        "3786": {"vr": "TM", "Value": ["095027.721000"]},
        "3787": {"vr": "TM", "Value": ["094527.890000"]},
        "3788": {"vr": "TM", "Value": ["094707.612000"]},
        "3789": {"vr": "TM", "Value": ["095307.776000"]},
        "3790": {"vr": "TM", "Value": ["094707.735000"]},
        "3791": {"vr": "TM", "Value": ["094627.853000"]},
        "3792": {"vr": "TM", "Value": ["094747.693000"]},
        "3793": {"vr": "TM", "Value": ["094947.716000"]},
        "3794": {"vr": "TM", "Value": ["094527.938000"]},
        "3795": {"vr": "TM", "Value": ["095147.789000"]},
        "3796": {"vr": "TM", "Value": ["095427.819000"]},
        "3797": {"vr": "TM", "Value": ["094747.858000"]},
        "3798": {"vr": "TM", "Value": ["095147.679000"]},
        "3799": {"vr": "TM", "Value": ["094747.737000"]},
        "3800": {"vr": "TM", "Value": ["095427.635000"]},
        "3801": {"vr": "TM", "Value": ["094947.721000"]},
        "3802": {"vr": "TM", "Value": ["095407.671000"]},
        "3803": {"vr": "TM", "Value": ["094647.772000"]},
        "3804": {"vr": "TM", "Value": ["095127.872000"]},
        "3805": {"vr": "TM", "Value": ["095147.787000"]},
        "3806": {"vr": "TM", "Value": ["095147.859000"]},
        "3807": {"vr": "TM", "Value": ["095307.702000"]},
        "3808": {"vr": "TM", "Value": ["095427.716000"]},
        "3809": {"vr": "TM", "Value": ["094707.768000"]},
        "3810": {"vr": "TM", "Value": ["095327.917000"]},
        "3811": {"vr": "TM", "Value": ["095227.897000"]},
        "3812": {"vr": "TM", "Value": ["095447.832000"]},
        "3813": {"vr": "TM", "Value": ["095227.610000"]},
        "3814": {"vr": "TM", "Value": ["094847.938000"]},
        "3815": {"vr": "TM", "Value": ["095107.906000"]},
        "3816": {"vr": "TM", "Value": ["095207.721000"]},
        "3817": {"vr": "TM", "Value": ["095207.608000"]},
        "3818": {"vr": "TM", "Value": ["094647.851000"]},
        "3819": {"vr": "TM", "Value": ["094827.776000"]},
        "3820": {"vr": "TM", "Value": ["095127.929000"]},
        "3821": {"vr": "TM", "Value": ["095047.931000"]},
        "3822": {"vr": "TM", "Value": ["095427.778000"]},
        "3823": {"vr": "TM", "Value": ["095207.882000"]},
        "3824": {"vr": "TM", "Value": ["095447.909000"]},
        "3825": {"vr": "TM", "Value": ["094827.865000"]},
        "3826": {"vr": "TM", "Value": ["094547.876000"]},
        "3827": {"vr": "TM", "Value": ["095027.887000"]},
        "3828": {"vr": "TM", "Value": ["094827.701000"]},
        "3829": {"vr": "TM", "Value": ["095307.910000"]},
        "3830": {"vr": "TM", "Value": ["094907.848000"]},
        "3831": {"vr": "TM", "Value": ["095107.663000"]},
        "3832": {"vr": "TM", "Value": ["095007.896000"]},
        "3833": {"vr": "TM", "Value": ["094947.704000"]},
        "3834": {"vr": "TM", "Value": ["094607.784000"]},
        "3835": {"vr": "TM", "Value": ["095407.708000"]},
        "3836": {"vr": "TM", "Value": ["095227.786000"]},
        "3837": {"vr": "TM", "Value": ["094727.847000"]},
        "3838": {"vr": "TM", "Value": ["094527.783000"]},
        "3839": {"vr": "TM", "Value": ["094527.793000"]},
        "3840": {"vr": "TM", "Value": ["095307.725000"]},
        "3841": {"vr": "TM", "Value": ["094707.784000"]},
        "3842": {"vr": "TM", "Value": ["094607.663000"]},
        "3843": {"vr": "TM", "Value": ["095107.819000"]},
        "3844": {"vr": "TM", "Value": ["094707.770000"]},
        "3845": {"vr": "TM", "Value": ["094827.889000"]},
        "3846": {"vr": "TM", "Value": ["095207.846000"]},
        "3847": {"vr": "TM", "Value": ["095127.893000"]},
        "3848": {"vr": "TM", "Value": ["095147.610000"]},
        "3849": {"vr": "TM", "Value": ["095427.659000"]},
        "3850": {"vr": "TM", "Value": ["095027.731000"]},
        "3851": {"vr": "TM", "Value": ["095207.815000"]},
        "3852": {"vr": "TM", "Value": ["094727.645000"]},
        "3853": {"vr": "TM", "Value": ["094607.649000"]},
        "3854": {"vr": "TM", "Value": ["094847.790000"]},
        "3855": {"vr": "TM", "Value": ["095456.466000"]},
        "3856": {"vr": "TM", "Value": ["094547.654000"]},
        "3857": {"vr": "TM", "Value": ["094707.909000"]},
        "3858": {"vr": "TM", "Value": ["094547.622000"]},
        "3859": {"vr": "TM", "Value": ["095027.943000"]},
        "3860": {"vr": "TM", "Value": ["094727.844000"]},
        "3861": {"vr": "TM", "Value": ["094947.925000"]},
        "3862": {"vr": "TM", "Value": ["094747.848000"]},
        "3863": {"vr": "TM", "Value": ["095327.670000"]},
        "3864": {"vr": "TM", "Value": ["094907.651000"]},
        "3865": {"vr": "TM", "Value": ["095107.903000"]},
        "3866": {"vr": "TM", "Value": ["094927.951000"]},
        "3867": {"vr": "TM", "Value": ["094607.926000"]},
        "3868": {"vr": "TM", "Value": ["094707.732000"]},
        "3869": {"vr": "TM", "Value": ["095247.680000"]},
        "3870": {"vr": "TM", "Value": ["095447.657000"]},
        "3871": {"vr": "TM", "Value": ["095347.659000"]},
        "3872": {"vr": "TM", "Value": ["094607.903000"]},
        "3873": {"vr": "TM", "Value": ["095307.715000"]},
        "3874": {"vr": "TM", "Value": ["095147.712000"]},
        "3875": {"vr": "TM", "Value": ["095407.845000"]},
        "3876": {"vr": "TM", "Value": ["094747.790000"]},
        "3877": {"vr": "TM", "Value": ["095407.725000"]},
        "3878": {"vr": "TM", "Value": ["095327.750000"]},
        "3879": {"vr": "TM", "Value": ["094727.852000"]},
        "3880": {"vr": "TM", "Value": ["095207.757000"]},
        "3881": {"vr": "TM", "Value": ["094907.733000"]},
        "3882": {"vr": "TM", "Value": ["095147.861000"]},
        "3883": {"vr": "TM", "Value": ["094927.878000"]},
        "3884": {"vr": "TM", "Value": ["095007.936000"]},
        "3885": {"vr": "TM", "Value": ["094647.982000"]},
        "3886": {"vr": "TM", "Value": ["095307.936000"]},
        "3887": {"vr": "TM", "Value": ["095027.854000"]},
        "3888": {"vr": "TM", "Value": ["094807.846000"]},
        "3889": {"vr": "TM", "Value": ["094547.789000"]},
        "3890": {"vr": "TM", "Value": ["094927.773000"]},
        "3891": {"vr": "TM", "Value": ["095107.923000"]},
        "3892": {"vr": "TM", "Value": ["095427.698000"]},
        "3893": {"vr": "TM", "Value": ["095147.943000"]},
        "3894": {"vr": "TM", "Value": ["094607.611000"]},
        "3895": {"vr": "TM", "Value": ["094747.641000"]},
        "3896": {"vr": "TM", "Value": ["095427.799000"]},
        "3897": {"vr": "TM", "Value": ["095347.781000"]},
        "3898": {"vr": "TM", "Value": ["095107.798000"]},
        "3899": {"vr": "TM", "Value": ["095207.854000"]},
        "3900": {"vr": "TM", "Value": ["094647.965000"]},
        "3901": {"vr": "TM", "Value": ["095307.615000"]},
        "3902": {"vr": "TM", "Value": ["095027.875000"]},
        "3903": {"vr": "TM", "Value": ["095227.887000"]},
        "3904": {"vr": "TM", "Value": ["094947.922000"]},
        "3905": {"vr": "TM", "Value": ["095447.677000"]},
        "3906": {"vr": "TM", "Value": ["095047.715000"]},
        "3907": {"vr": "TM", "Value": ["095347.866000"]},
        "3908": {"vr": "TM", "Value": ["094807.843000"]},
        "3909": {"vr": "TM", "Value": ["094647.801000"]},
        "3910": {"vr": "TM", "Value": ["094607.621000"]},
        "3911": {"vr": "TM", "Value": ["094847.859000"]},
        "3912": {"vr": "TM", "Value": ["095407.885000"]},
        "3913": {"vr": "TM", "Value": ["094927.817000"]},
        "3914": {"vr": "TM", "Value": ["095107.620000"]},
        "3915": {"vr": "TM", "Value": ["094527.963000"]},
        "3916": {"vr": "TM", "Value": ["094827.904000"]},
        "3917": {"vr": "TM", "Value": ["094607.901000"]},
        "3918": {"vr": "TM", "Value": ["095007.644000"]},
        "3919": {"vr": "TM", "Value": ["094927.642000"]},
        "3920": {"vr": "TM", "Value": ["094807.623000"]},
        "3921": {"vr": "TM", "Value": ["095327.848000"]},
        "3922": {"vr": "TM", "Value": ["095427.850000"]},
        "3923": {"vr": "TM", "Value": ["094647.649000"]},
        "3924": {"vr": "TM", "Value": ["094527.975000"]},
        "3925": {"vr": "TM", "Value": ["094807.705000"]},
        "3926": {"vr": "TM", "Value": ["095227.635000"]},
        "3927": {"vr": "TM", "Value": ["095227.844000"]},
        "3928": {"vr": "TM", "Value": ["095007.872000"]},
        "3929": {"vr": "TM", "Value": ["095307.915000"]},
        "3930": {"vr": "TM", "Value": ["095247.651000"]},
        "3931": {"vr": "TM", "Value": ["094947.915000"]},
        "3932": {"vr": "TM", "Value": ["095147.920000"]},
        "3933": {"vr": "TM", "Value": ["095347.920000"]},
        "3934": {"vr": "TM", "Value": ["095027.902000"]},
        "3935": {"vr": "TM", "Value": ["095347.899000"]},
        "3936": {"vr": "TM", "Value": ["095047.656000"]},
        "3937": {"vr": "TM", "Value": ["095147.806000"]},
        "3938": {"vr": "TM", "Value": ["095427.791000"]},
        "3939": {"vr": "TM", "Value": ["094647.894000"]},
        "3940": {"vr": "TM", "Value": ["094907.952000"]},
        "3941": {"vr": "TM", "Value": ["095347.638000"]},
        "3942": {"vr": "TM", "Value": ["095207.877000"]},
        "3943": {"vr": "TM", "Value": ["095427.612000"]},
        "3944": {"vr": "TM", "Value": ["095047.853000"]},
        "3945": {"vr": "TM", "Value": ["094827.927000"]},
        "3946": {"vr": "TM", "Value": ["095427.624000"]},
        "3947": {"vr": "TM", "Value": ["094647.897000"]},
        "3948": {"vr": "TM", "Value": ["094827.706000"]},
        "3949": {"vr": "TM", "Value": ["095347.961000"]},
        "3950": {"vr": "TM", "Value": ["095127.663000"]},
        "3951": {"vr": "TM", "Value": ["094907.646000"]},
        "3952": {"vr": "TM", "Value": ["095027.895000"]},
        "3953": {"vr": "TM", "Value": ["095047.664000"]},
        "3954": {"vr": "TM", "Value": ["094627.719000"]},
        "3955": {"vr": "TM", "Value": ["095447.916000"]},
        "3956": {"vr": "TM", "Value": ["095027.741000"]},
        "3957": {"vr": "TM", "Value": ["095007.730000"]},
        "3958": {"vr": "TM", "Value": ["094847.693000"]},
        "3959": {"vr": "TM", "Value": ["095347.845000"]},
        "3960": {"vr": "TM", "Value": ["095147.705000"]},
        "3961": {"vr": "TM", "Value": ["095207.897000"]},
        "3962": {"vr": "TM", "Value": ["095327.608000"]},
        "3963": {"vr": "TM", "Value": ["094727.758000"]},
        "3964": {"vr": "TM", "Value": ["095207.693000"]},
        "3965": {"vr": "TM", "Value": ["095447.750000"]},
        "3966": {"vr": "TM", "Value": ["094707.758000"]},
        "3967": {"vr": "TM", "Value": ["094907.803000"]},
        "3968": {"vr": "TM", "Value": ["094707.659000"]},
        "3969": {"vr": "TM", "Value": ["094607.659000"]},
        "3970": {"vr": "TM", "Value": ["094947.635000"]},
        "3971": {"vr": "TM", "Value": ["094607.879000"]},
        "3972": {"vr": "TM", "Value": ["095247.677000"]},
        "3973": {"vr": "TM", "Value": ["094907.735000"]},
        "3974": {"vr": "TM", "Value": ["094807.800000"]},
        "3975": {"vr": "TM", "Value": ["095247.915000"]},
        "3976": {"vr": "TM", "Value": ["094547.682000"]},
        "3977": {"vr": "TM", "Value": ["094627.942000"]},
        "3978": {"vr": "TM", "Value": ["095447.637000"]},
        "3979": {"vr": "TM", "Value": ["094927.799000"]},
        "3980": {"vr": "TM", "Value": ["094647.822000"]},
        "3981": {"vr": "TM", "Value": ["095227.625000"]},
        "3982": {"vr": "TM", "Value": ["094947.933000"]},
        "3983": {"vr": "TM", "Value": ["094547.809000"]},
        "3984": {"vr": "TM", "Value": ["094747.874000"]},
        "3985": {"vr": "TM", "Value": ["095047.936000"]},
        "3986": {"vr": "TM", "Value": ["095427.825000"]},
        "3987": {"vr": "TM", "Value": ["094907.939000"]},
        "3988": {"vr": "TM", "Value": ["095007.608000"]},
        "3989": {"vr": "TM", "Value": ["094847.845000"]},
        "3990": {"vr": "TM", "Value": ["095047.744000"]},
        "3991": {"vr": "TM", "Value": ["095047.835000"]},
        "3992": {"vr": "TM", "Value": ["095427.812000"]},
        "3993": {"vr": "TM", "Value": ["095347.690000"]},
        "3994": {"vr": "TM", "Value": ["094947.766000"]},
        "3995": {"vr": "TM", "Value": ["094707.704000"]},
        "3996": {"vr": "TM", "Value": ["094607.752000"]},
        "3997": {"vr": "TM", "Value": ["095347.838000"]},
        "3998": {"vr": "TM", "Value": ["094947.752000"]},
        "3999": {"vr": "TM", "Value": ["095227.613000"]},
        "4000": {"vr": "TM", "Value": ["095407.637000"]},
        "4001": {"vr": "TM", "Value": ["095207.887000"]},
        "4002": {"vr": "TM", "Value": ["095247.777000"]},
        "4003": {"vr": "TM", "Value": ["094847.711000"]},
        "4004": {"vr": "TM", "Value": ["095347.718000"]},
        "4005": {"vr": "TM", "Value": ["094727.849000"]},
        "4006": {"vr": "TM", "Value": ["094627.699000"]},
        "4007": {"vr": "TM", "Value": ["095107.759000"]},
        "4008": {"vr": "TM", "Value": ["094727.683000"]},
        "4009": {"vr": "TM", "Value": ["095007.786000"]},
        "4010": {"vr": "TM", "Value": ["095027.649000"]},
        "4011": {"vr": "TM", "Value": ["094647.985000"]},
        "4012": {"vr": "TM", "Value": ["095307.763000"]},
        "4013": {"vr": "TM", "Value": ["094647.796000"]},
        "4014": {"vr": "TM", "Value": ["094827.696000"]},
        "4015": {"vr": "TM", "Value": ["095407.883000"]},
        "4016": {"vr": "TM", "Value": ["095407.630000"]},
        "4017": {"vr": "TM", "Value": ["094947.920000"]},
        "4018": {"vr": "TM", "Value": ["095247.628000"]},
        "4019": {"vr": "TM", "Value": ["095107.747000"]},
    },
    "00180024": {
        "0": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3": {"vr": "SH", "Value": ["*ep_b0"]},
        "4": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "5": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "6": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "7": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "8": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "9": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "10": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "11": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "12": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "13": {"vr": "SH", "Value": ["*ep_b0"]},
        "14": {"vr": "SH", "Value": ["*ep_b0"]},
        "15": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "16": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "17": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "18": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "19": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "20": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "21": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "22": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "23": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "24": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "25": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "26": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "27": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "28": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "29": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "30": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "31": {"vr": "SH", "Value": ["*ep_b0"]},
        "32": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "33": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "34": {"vr": "SH", "Value": ["*ep_b0"]},
        "35": {"vr": "SH", "Value": ["*ep_b0"]},
        "36": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "37": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "38": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "39": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "40": {"vr": "SH", "Value": ["*ep_b0"]},
        "41": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "42": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "43": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "44": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "45": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "46": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "47": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "48": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "49": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "50": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "51": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "52": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "53": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "54": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "55": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "56": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "57": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "58": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "59": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "60": {"vr": "SH", "Value": ["*ep_b0"]},
        "61": {"vr": "SH", "Value": ["*ep_b0"]},
        "62": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "63": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "64": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "65": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "66": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "67": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "68": {"vr": "SH", "Value": ["*ep_b0"]},
        "69": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "70": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "71": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "72": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "73": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "74": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "75": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "76": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "77": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "78": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "79": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "80": {"vr": "SH", "Value": ["*ep_b0"]},
        "81": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "82": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "83": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "84": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "85": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "86": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "87": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "88": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "89": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "90": {"vr": "SH", "Value": ["*ep_b0"]},
        "91": {"vr": "SH", "Value": ["*ep_b0"]},
        "92": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "93": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "94": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "95": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "96": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "97": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "98": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "99": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "100": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "101": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "102": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "103": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "104": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "105": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "106": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "107": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "108": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "109": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "110": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "111": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "112": {"vr": "SH", "Value": ["*ep_b0"]},
        "113": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "114": {"vr": "SH", "Value": ["*ep_b0"]},
        "115": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "116": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "117": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "118": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "119": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "120": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "121": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "122": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "123": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "124": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "125": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "126": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "127": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "128": {"vr": "SH", "Value": ["*ep_b0"]},
        "129": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "130": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "131": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "132": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "133": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "134": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "135": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "136": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "137": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "138": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "139": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "140": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "141": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "142": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "143": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "144": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "145": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "146": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "147": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "148": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "149": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "150": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "151": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "152": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "153": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "154": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "155": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "156": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "157": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "158": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "159": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "160": {"vr": "SH", "Value": ["*ep_b0"]},
        "161": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "162": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "163": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "164": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "165": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "166": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "167": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "168": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "169": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "170": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "171": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "172": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "173": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "174": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "175": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "176": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "177": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "178": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "179": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "180": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "181": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "182": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "183": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "184": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "185": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "186": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "187": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "188": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "189": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "190": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "191": {"vr": "SH", "Value": ["*ep_b0"]},
        "192": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "193": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "194": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "195": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "196": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "197": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "198": {"vr": "SH", "Value": ["*ep_b0"]},
        "199": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "200": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "201": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "202": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "203": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "204": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "205": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "206": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "207": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "208": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "209": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "210": {"vr": "SH", "Value": ["*ep_b0"]},
        "211": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "212": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "213": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "214": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "215": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "216": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "217": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "218": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "219": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "220": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "221": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "222": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "223": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "224": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "225": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "226": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "227": {"vr": "SH", "Value": ["*ep_b0"]},
        "228": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "229": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "230": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "231": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "232": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "233": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "234": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "235": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "236": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "237": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "238": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "239": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "240": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "241": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "242": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "243": {"vr": "SH", "Value": ["*ep_b0"]},
        "244": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "245": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "246": {"vr": "SH", "Value": ["*ep_b0"]},
        "247": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "248": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "249": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "250": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "251": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "252": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "253": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "254": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "255": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "256": {"vr": "SH", "Value": ["*ep_b0"]},
        "257": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "258": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "259": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "260": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "261": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "262": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "263": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "264": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "265": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "266": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "267": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "268": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "269": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "270": {"vr": "SH", "Value": ["*ep_b0"]},
        "271": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "272": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "273": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "274": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "275": {"vr": "SH", "Value": ["*ep_b0"]},
        "276": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "277": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "278": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "279": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "280": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "281": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "282": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "283": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "284": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "285": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "286": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "287": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "288": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "289": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "290": {"vr": "SH", "Value": ["*ep_b0"]},
        "291": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "292": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "293": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "294": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "295": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "296": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "297": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "298": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "299": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "300": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "301": {"vr": "SH", "Value": ["*ep_b0"]},
        "302": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "303": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "304": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "305": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "306": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "307": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "308": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "309": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "310": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "311": {"vr": "SH", "Value": ["*ep_b0"]},
        "312": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "313": {"vr": "SH", "Value": ["*ep_b0"]},
        "314": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "315": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "316": {"vr": "SH", "Value": ["*ep_b0"]},
        "317": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "318": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "319": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "320": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "321": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "322": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "323": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "324": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "325": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "326": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "327": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "328": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "329": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "330": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "331": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "332": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "333": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "334": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "335": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "336": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "337": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "338": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "339": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "340": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "341": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "342": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "343": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "344": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "345": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "346": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "347": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "348": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "349": {"vr": "SH", "Value": ["*ep_b0"]},
        "350": {"vr": "SH", "Value": ["*ep_b0"]},
        "351": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "352": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "353": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "354": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "355": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "356": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "357": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "358": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "359": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "360": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "361": {"vr": "SH", "Value": ["*ep_b0"]},
        "362": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "363": {"vr": "SH", "Value": ["*ep_b0"]},
        "364": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "365": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "366": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "367": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "368": {"vr": "SH", "Value": ["*ep_b0"]},
        "369": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "370": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "371": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "372": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "373": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "374": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "375": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "376": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "377": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "378": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "379": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "380": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "381": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "382": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "383": {"vr": "SH", "Value": ["*ep_b0"]},
        "384": {"vr": "SH", "Value": ["*ep_b0"]},
        "385": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "386": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "387": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "388": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "389": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "390": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "391": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "392": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "393": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "394": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "395": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "396": {"vr": "SH", "Value": ["*ep_b0"]},
        "397": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "398": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "399": {"vr": "SH", "Value": ["*ep_b0"]},
        "400": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "401": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "402": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "403": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "404": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "405": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "406": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "407": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "408": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "409": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "410": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "411": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "412": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "413": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "414": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "415": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "416": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "417": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "418": {"vr": "SH", "Value": ["*ep_b0"]},
        "419": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "420": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "421": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "422": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "423": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "424": {"vr": "SH", "Value": ["*ep_b0"]},
        "425": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "426": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "427": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "428": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "429": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "430": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "431": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "432": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "433": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "434": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "435": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "436": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "437": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "438": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "439": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "440": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "441": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "442": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "443": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "444": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "445": {"vr": "SH", "Value": ["*ep_b0"]},
        "446": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "447": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "448": {"vr": "SH", "Value": ["*ep_b0"]},
        "449": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "450": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "451": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "452": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "453": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "454": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "455": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "456": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "457": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "458": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "459": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "460": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "461": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "462": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "463": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "464": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "465": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "466": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "467": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "468": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "469": {"vr": "SH", "Value": ["*ep_b0"]},
        "470": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "471": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "472": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "473": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "474": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "475": {"vr": "SH", "Value": ["*ep_b0"]},
        "476": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "477": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "478": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "479": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "480": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "481": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "482": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "483": {"vr": "SH", "Value": ["*ep_b0"]},
        "484": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "485": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "486": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "487": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "488": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "489": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "490": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "491": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "492": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "493": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "494": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "495": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "496": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "497": {"vr": "SH", "Value": ["*ep_b0"]},
        "498": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "499": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "500": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "501": {"vr": "SH", "Value": ["*ep_b0"]},
        "502": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "503": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "504": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "505": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "506": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "507": {"vr": "SH", "Value": ["*ep_b0"]},
        "508": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "509": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "510": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "511": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "512": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "513": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "514": {"vr": "SH", "Value": ["*ep_b0"]},
        "515": {"vr": "SH", "Value": ["*ep_b0"]},
        "516": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "517": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "518": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "519": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "520": {"vr": "SH", "Value": ["*ep_b0"]},
        "521": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "522": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "523": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "524": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "525": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "526": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "527": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "528": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "529": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "530": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "531": {"vr": "SH", "Value": ["*ep_b0"]},
        "532": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "533": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "534": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "535": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "536": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "537": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "538": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "539": {"vr": "SH", "Value": ["*ep_b0"]},
        "540": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "541": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "542": {"vr": "SH", "Value": ["*ep_b0"]},
        "543": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "544": {"vr": "SH", "Value": ["*ep_b0"]},
        "545": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "546": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "547": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "548": {"vr": "SH", "Value": ["*ep_b0"]},
        "549": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "550": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "551": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "552": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "553": {"vr": "SH", "Value": ["*ep_b0"]},
        "554": {"vr": "SH", "Value": ["*ep_b0"]},
        "555": {"vr": "SH", "Value": ["*ep_b0"]},
        "556": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "557": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "558": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "559": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "560": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "561": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "562": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "563": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "564": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "565": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "566": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "567": {"vr": "SH", "Value": ["*ep_b0"]},
        "568": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "569": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "570": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "571": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "572": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "573": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "574": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "575": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "576": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "577": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "578": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "579": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "580": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "581": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "582": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "583": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "584": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "585": {"vr": "SH", "Value": ["*ep_b0"]},
        "586": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "587": {"vr": "SH", "Value": ["*ep_b0"]},
        "588": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "589": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "590": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "591": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "592": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "593": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "594": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "595": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "596": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "597": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "598": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "599": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "600": {"vr": "SH", "Value": ["*ep_b0"]},
        "601": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "602": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "603": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "604": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "605": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "606": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "607": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "608": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "609": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "610": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "611": {"vr": "SH", "Value": ["*ep_b0"]},
        "612": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "613": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "614": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "615": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "616": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "617": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "618": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "619": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "620": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "621": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "622": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "623": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "624": {"vr": "SH", "Value": ["*ep_b0"]},
        "625": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "626": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "627": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "628": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "629": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "630": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "631": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "632": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "633": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "634": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "635": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "636": {"vr": "SH", "Value": ["*ep_b0"]},
        "637": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "638": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "639": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "640": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "641": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "642": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "643": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "644": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "645": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "646": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "647": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "648": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "649": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "650": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "651": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "652": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "653": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "654": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "655": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "656": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "657": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "658": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "659": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "660": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "661": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "662": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "663": {"vr": "SH", "Value": ["*ep_b0"]},
        "664": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "665": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "666": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "667": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "668": {"vr": "SH", "Value": ["*ep_b0"]},
        "669": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "670": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "671": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "672": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "673": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "674": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "675": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "676": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "677": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "678": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "679": {"vr": "SH", "Value": ["*ep_b0"]},
        "680": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "681": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "682": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "683": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "684": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "685": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "686": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "687": {"vr": "SH", "Value": ["*ep_b0"]},
        "688": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "689": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "690": {"vr": "SH", "Value": ["*ep_b0"]},
        "691": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "692": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "693": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "694": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "695": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "696": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "697": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "698": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "699": {"vr": "SH", "Value": ["*ep_b0"]},
        "700": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "701": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "702": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "703": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "704": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "705": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "706": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "707": {"vr": "SH", "Value": ["*ep_b0"]},
        "708": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "709": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "710": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "711": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "712": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "713": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "714": {"vr": "SH", "Value": ["*ep_b0"]},
        "715": {"vr": "SH", "Value": ["*ep_b0"]},
        "716": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "717": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "718": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "719": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "720": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "721": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "722": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "723": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "724": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "725": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "726": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "727": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "728": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "729": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "730": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "731": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "732": {"vr": "SH", "Value": ["*ep_b0"]},
        "733": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "734": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "735": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "736": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "737": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "738": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "739": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "740": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "741": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "742": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "743": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "744": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "745": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "746": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "747": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "748": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "749": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "750": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "751": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "752": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "753": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "754": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "755": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "756": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "757": {"vr": "SH", "Value": ["*ep_b0"]},
        "758": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "759": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "760": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "761": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "762": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "763": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "764": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "765": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "766": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "767": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "768": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "769": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "770": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "771": {"vr": "SH", "Value": ["*ep_b0"]},
        "772": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "773": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "774": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "775": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "776": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "777": {"vr": "SH", "Value": ["*ep_b0"]},
        "778": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "779": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "780": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "781": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "782": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "783": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "784": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "785": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "786": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "787": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "788": {"vr": "SH", "Value": ["*ep_b0"]},
        "789": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "790": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "791": {"vr": "SH", "Value": ["*ep_b0"]},
        "792": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "793": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "794": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "795": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "796": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "797": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "798": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "799": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "800": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "801": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "802": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "803": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "804": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "805": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "806": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "807": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "808": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "809": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "810": {"vr": "SH", "Value": ["*ep_b0"]},
        "811": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "812": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "813": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "814": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "815": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "816": {"vr": "SH", "Value": ["*ep_b0"]},
        "817": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "818": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "819": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "820": {"vr": "SH", "Value": ["*ep_b0"]},
        "821": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "822": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "823": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "824": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "825": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "826": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "827": {"vr": "SH", "Value": ["*ep_b0"]},
        "828": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "829": {"vr": "SH", "Value": ["*ep_b0"]},
        "830": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "831": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "832": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "833": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "834": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "835": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "836": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "837": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "838": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "839": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "840": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "841": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "842": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "843": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "844": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "845": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "846": {"vr": "SH", "Value": ["*ep_b0"]},
        "847": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "848": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "849": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "850": {"vr": "SH", "Value": ["*ep_b0"]},
        "851": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "852": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "853": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "854": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "855": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "856": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "857": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "858": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "859": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "860": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "861": {"vr": "SH", "Value": ["*ep_b0"]},
        "862": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "863": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "864": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "865": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "866": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "867": {"vr": "SH", "Value": ["*ep_b0"]},
        "868": {"vr": "SH", "Value": ["*ep_b0"]},
        "869": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "870": {"vr": "SH", "Value": ["*ep_b0"]},
        "871": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "872": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "873": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "874": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "875": {"vr": "SH", "Value": ["*ep_b0"]},
        "876": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "877": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "878": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "879": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "880": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "881": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "882": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "883": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "884": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "885": {"vr": "SH", "Value": ["*ep_b0"]},
        "886": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "887": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "888": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "889": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "890": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "891": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "892": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "893": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "894": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "895": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "896": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "897": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "898": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "899": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "900": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "901": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "902": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "903": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "904": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "905": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "906": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "907": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "908": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "909": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "910": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "911": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "912": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "913": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "914": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "915": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "916": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "917": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "918": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "919": {"vr": "SH", "Value": ["*ep_b0"]},
        "920": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "921": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "922": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "923": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "924": {"vr": "SH", "Value": ["*ep_b0"]},
        "925": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "926": {"vr": "SH", "Value": ["*ep_b0"]},
        "927": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "928": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "929": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "930": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "931": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "932": {"vr": "SH", "Value": ["*ep_b0"]},
        "933": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "934": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "935": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "936": {"vr": "SH", "Value": ["*ep_b0"]},
        "937": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "938": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "939": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "940": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "941": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "942": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "943": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "944": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "945": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "946": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "947": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "948": {"vr": "SH", "Value": ["*ep_b0"]},
        "949": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "950": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "951": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "952": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "953": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "954": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "955": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "956": {"vr": "SH", "Value": ["*ep_b0"]},
        "957": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "958": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "959": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "960": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "961": {"vr": "SH", "Value": ["*ep_b0"]},
        "962": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "963": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "964": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "965": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "966": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "967": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "968": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "969": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "970": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "971": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "972": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "973": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "974": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "975": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "976": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "977": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "978": {"vr": "SH", "Value": ["*ep_b0"]},
        "979": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "980": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "981": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "982": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "983": {"vr": "SH", "Value": ["*ep_b0"]},
        "984": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "985": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "986": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "987": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "988": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "989": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "990": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "991": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "992": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "993": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "994": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "995": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "996": {"vr": "SH", "Value": ["*ep_b0"]},
        "997": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "998": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "999": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1000": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1001": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1002": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1003": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1004": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1005": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1006": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1007": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1008": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1009": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1010": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1011": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1012": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1013": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1014": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1015": {"vr": "SH", "Value": ["*ep_b0"]},
        "1016": {"vr": "SH", "Value": ["*ep_b0"]},
        "1017": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1018": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1019": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1020": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1021": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1022": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1023": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1024": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1025": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1026": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1027": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1028": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1029": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1030": {"vr": "SH", "Value": ["*ep_b0"]},
        "1031": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1032": {"vr": "SH", "Value": ["*ep_b0"]},
        "1033": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1034": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1035": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1036": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1037": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1038": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1039": {"vr": "SH", "Value": ["*ep_b0"]},
        "1040": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1041": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1042": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1043": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1044": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1045": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1046": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1047": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1048": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1049": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1050": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1051": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1052": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1053": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1054": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1055": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1056": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1057": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1058": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1059": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1060": {"vr": "SH", "Value": ["*ep_b0"]},
        "1061": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1062": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1063": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1064": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1065": {"vr": "SH", "Value": ["*ep_b0"]},
        "1066": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1067": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1068": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1069": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1070": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1071": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1072": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1073": {"vr": "SH", "Value": ["*ep_b0"]},
        "1074": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1075": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1076": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1077": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1078": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1079": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1080": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1081": {"vr": "SH", "Value": ["*ep_b0"]},
        "1082": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1083": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1084": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1085": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1086": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1087": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1088": {"vr": "SH", "Value": ["*ep_b0"]},
        "1089": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1090": {"vr": "SH", "Value": ["*ep_b0"]},
        "1091": {"vr": "SH", "Value": ["*ep_b0"]},
        "1092": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1093": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1094": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1095": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1096": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1097": {"vr": "SH", "Value": ["*ep_b0"]},
        "1098": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1099": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1100": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1101": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1102": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1103": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1104": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1105": {"vr": "SH", "Value": ["*ep_b0"]},
        "1106": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1107": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1108": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1109": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1110": {"vr": "SH", "Value": ["*ep_b0"]},
        "1111": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1112": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1113": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1114": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1115": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1116": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1117": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1118": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1119": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1120": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1121": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1122": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1123": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1124": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1125": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1126": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1127": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1128": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1129": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1130": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1131": {"vr": "SH", "Value": ["*ep_b0"]},
        "1132": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1133": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1134": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1135": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1136": {"vr": "SH", "Value": ["*ep_b0"]},
        "1137": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1138": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1139": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1140": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1141": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1142": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1143": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1144": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1145": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1146": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1147": {"vr": "SH", "Value": ["*ep_b0"]},
        "1148": {"vr": "SH", "Value": ["*ep_b0"]},
        "1149": {"vr": "SH", "Value": ["*ep_b0"]},
        "1150": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1151": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1152": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1153": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1154": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1155": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1156": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1157": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1158": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1159": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1160": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1161": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1162": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1163": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1164": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1165": {"vr": "SH", "Value": ["*ep_b0"]},
        "1166": {"vr": "SH", "Value": ["*ep_b0"]},
        "1167": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1168": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1169": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1170": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1171": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1172": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1173": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1174": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1175": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1176": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1177": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1178": {"vr": "SH", "Value": ["*ep_b0"]},
        "1179": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1180": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1181": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1182": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1183": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1184": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1185": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1186": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1187": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1188": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1189": {"vr": "SH", "Value": ["*ep_b0"]},
        "1190": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1191": {"vr": "SH", "Value": ["*ep_b0"]},
        "1192": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1193": {"vr": "SH", "Value": ["*ep_b0"]},
        "1194": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1195": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1196": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1197": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1198": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1199": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1200": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1201": {"vr": "SH", "Value": ["*ep_b0"]},
        "1202": {"vr": "SH", "Value": ["*ep_b0"]},
        "1203": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1204": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1205": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1206": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1207": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1208": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1209": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1210": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1211": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1212": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1213": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1214": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1215": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1216": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1217": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1218": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1219": {"vr": "SH", "Value": ["*ep_b0"]},
        "1220": {"vr": "SH", "Value": ["*ep_b0"]},
        "1221": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1222": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1223": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1224": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1225": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1226": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1227": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1228": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1229": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1230": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1231": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1232": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1233": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1234": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1235": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1236": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1237": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1238": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1239": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1240": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1241": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1242": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1243": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1244": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1245": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1246": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1247": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1248": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1249": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1250": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1251": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1252": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1253": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1254": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1255": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1256": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1257": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1258": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1259": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1260": {"vr": "SH", "Value": ["*ep_b0"]},
        "1261": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1262": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1263": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1264": {"vr": "SH", "Value": ["*ep_b0"]},
        "1265": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1266": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1267": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1268": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1269": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1270": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1271": {"vr": "SH", "Value": ["*ep_b0"]},
        "1272": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1273": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1274": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1275": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1276": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1277": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1278": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1279": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1280": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1281": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1282": {"vr": "SH", "Value": ["*ep_b0"]},
        "1283": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1284": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1285": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1286": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1287": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1288": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1289": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1290": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1291": {"vr": "SH", "Value": ["*ep_b0"]},
        "1292": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1293": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1294": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1295": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1296": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1297": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1298": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1299": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1300": {"vr": "SH", "Value": ["*ep_b0"]},
        "1301": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1302": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1303": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1304": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1305": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1306": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1307": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1308": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1309": {"vr": "SH", "Value": ["*ep_b0"]},
        "1310": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1311": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1312": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1313": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1314": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1315": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1316": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1317": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1318": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1319": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1320": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1321": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1322": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1323": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1324": {"vr": "SH", "Value": ["*ep_b0"]},
        "1325": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1326": {"vr": "SH", "Value": ["*ep_b0"]},
        "1327": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1328": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1329": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1330": {"vr": "SH", "Value": ["*ep_b0"]},
        "1331": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1332": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1333": {"vr": "SH", "Value": ["*ep_b0"]},
        "1334": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1335": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1336": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1337": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1338": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1339": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1340": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1341": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1342": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1343": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1344": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1345": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1346": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1347": {"vr": "SH", "Value": ["*ep_b0"]},
        "1348": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1349": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1350": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1351": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1352": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1353": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1354": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1355": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1356": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1357": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1358": {"vr": "SH", "Value": ["*ep_b0"]},
        "1359": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1360": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1361": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1362": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1363": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1364": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1365": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1366": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1367": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1368": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1369": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1370": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1371": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1372": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1373": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1374": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1375": {"vr": "SH", "Value": ["*ep_b0"]},
        "1376": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1377": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1378": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1379": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1380": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1381": {"vr": "SH", "Value": ["*ep_b0"]},
        "1382": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1383": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1384": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1385": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1386": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1387": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1388": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1389": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1390": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1391": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1392": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1393": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1394": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1395": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1396": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1397": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1398": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1399": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1400": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1401": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1402": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1403": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1404": {"vr": "SH", "Value": ["*ep_b0"]},
        "1405": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1406": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1407": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1408": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1409": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1410": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1411": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1412": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1413": {"vr": "SH", "Value": ["*ep_b0"]},
        "1414": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1415": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1416": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1417": {"vr": "SH", "Value": ["*ep_b0"]},
        "1418": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1419": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1420": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1421": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1422": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1423": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1424": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1425": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1426": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1427": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1428": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1429": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1430": {"vr": "SH", "Value": ["*ep_b0"]},
        "1431": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1432": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1433": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1434": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1435": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1436": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1437": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1438": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1439": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1440": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1441": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1442": {"vr": "SH", "Value": ["*ep_b0"]},
        "1443": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1444": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1445": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1446": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1447": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1448": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1449": {"vr": "SH", "Value": ["*ep_b0"]},
        "1450": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1451": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1452": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1453": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1454": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1455": {"vr": "SH", "Value": ["*ep_b0"]},
        "1456": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1457": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1458": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1459": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1460": {"vr": "SH", "Value": ["*ep_b0"]},
        "1461": {"vr": "SH", "Value": ["*ep_b0"]},
        "1462": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1463": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1464": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1465": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1466": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1467": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1468": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1469": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1470": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1471": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1472": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1473": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1474": {"vr": "SH", "Value": ["*ep_b0"]},
        "1475": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1476": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1477": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1478": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1479": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1480": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1481": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1482": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1483": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1484": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1485": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1486": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1487": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1488": {"vr": "SH", "Value": ["*ep_b0"]},
        "1489": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1490": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1491": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1492": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1493": {"vr": "SH", "Value": ["*ep_b0"]},
        "1494": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1495": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1496": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1497": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1498": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1499": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1500": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1501": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1502": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1503": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1504": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1505": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1506": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1507": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1508": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1509": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1510": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1511": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1512": {"vr": "SH", "Value": ["*ep_b0"]},
        "1513": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1514": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1515": {"vr": "SH", "Value": ["*ep_b0"]},
        "1516": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1517": {"vr": "SH", "Value": ["*ep_b0"]},
        "1518": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1519": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1520": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1521": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1522": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1523": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1524": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1525": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1526": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1527": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1528": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1529": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1530": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1531": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1532": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1533": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1534": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1535": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1536": {"vr": "SH", "Value": ["*ep_b0"]},
        "1537": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1538": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1539": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1540": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1541": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1542": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1543": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1544": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1545": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1546": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1547": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1548": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1549": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1550": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1551": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1552": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1553": {"vr": "SH", "Value": ["*ep_b0"]},
        "1554": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1555": {"vr": "SH", "Value": ["*ep_b0"]},
        "1556": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1557": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1558": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1559": {"vr": "SH", "Value": ["*ep_b0"]},
        "1560": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1561": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1562": {"vr": "SH", "Value": ["*ep_b0"]},
        "1563": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1564": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1565": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1566": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1567": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1568": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1569": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1570": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1571": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1572": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1573": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1574": {"vr": "SH", "Value": ["*ep_b0"]},
        "1575": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1576": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1577": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1578": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1579": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1580": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "1581": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1582": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1583": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1584": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1585": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1586": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1587": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1588": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1589": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1590": {"vr": "SH", "Value": ["*ep_b0"]},
        "1591": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1592": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1593": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1594": {"vr": "SH", "Value": ["*ep_b0"]},
        "1595": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1596": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1597": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1598": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1599": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1600": {"vr": "SH", "Value": ["*ep_b0"]},
        "1601": {"vr": "SH", "Value": ["*ep_b0"]},
        "1602": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1603": {"vr": "SH", "Value": ["*ep_b0"]},
        "1604": {"vr": "SH", "Value": ["*ep_b0"]},
        "1605": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1606": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1607": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1608": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1609": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1610": {"vr": "SH", "Value": ["*ep_b0"]},
        "1611": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1612": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1613": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1614": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1615": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1616": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1617": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1618": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1619": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1620": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1621": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1622": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1623": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1624": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1625": {"vr": "SH", "Value": ["*ep_b0"]},
        "1626": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1627": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1628": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1629": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1630": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1631": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1632": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1633": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1634": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1635": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1636": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1637": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1638": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1639": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1640": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1641": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1642": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1643": {"vr": "SH", "Value": ["*ep_b0"]},
        "1644": {"vr": "SH", "Value": ["*ep_b0"]},
        "1645": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1646": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1647": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1648": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1649": {"vr": "SH", "Value": ["*ep_b0"]},
        "1650": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1651": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1652": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1653": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1654": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1655": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1656": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1657": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1658": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1659": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1660": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1661": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1662": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1663": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1664": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1665": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1666": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1667": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1668": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1669": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1670": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1671": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1672": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1673": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1674": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1675": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1676": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1677": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1678": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1679": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1680": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1681": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1682": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1683": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1684": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1685": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1686": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1687": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1688": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1689": {"vr": "SH", "Value": ["*ep_b0"]},
        "1690": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1691": {"vr": "SH", "Value": ["*ep_b0"]},
        "1692": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1693": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1694": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1695": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1696": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1697": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1698": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1699": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1700": {"vr": "SH", "Value": ["*ep_b0"]},
        "1701": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1702": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1703": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1704": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1705": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1706": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1707": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1708": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1709": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1710": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1711": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1712": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1713": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1714": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1715": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1716": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1717": {"vr": "SH", "Value": ["*ep_b0"]},
        "1718": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1719": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1720": {"vr": "SH", "Value": ["*ep_b0"]},
        "1721": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1722": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1723": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1724": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1725": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1726": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1727": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1728": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1729": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1730": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1731": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1732": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1733": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1734": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1735": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1736": {"vr": "SH", "Value": ["*ep_b0"]},
        "1737": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1738": {"vr": "SH", "Value": ["*ep_b0"]},
        "1739": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1740": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1741": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1742": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1743": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1744": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1745": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1746": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1747": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1748": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1749": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1750": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1751": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1752": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1753": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1754": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1755": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1756": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1757": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1758": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1759": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "1760": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1761": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1762": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1763": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1764": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1765": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1766": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1767": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1768": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1769": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1770": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1771": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1772": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1773": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1774": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1775": {"vr": "SH", "Value": ["*ep_b0"]},
        "1776": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1777": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1778": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1779": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1780": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1781": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1782": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1783": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1784": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1785": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1786": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1787": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1788": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1789": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1790": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1791": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "1792": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1793": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1794": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1795": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1796": {"vr": "SH", "Value": ["*ep_b0"]},
        "1797": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1798": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1799": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1800": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1801": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1802": {"vr": "SH", "Value": ["*ep_b0"]},
        "1803": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1804": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1805": {"vr": "SH", "Value": ["*ep_b0"]},
        "1806": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1807": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1808": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1809": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1810": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1811": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1812": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1813": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1814": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1815": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1816": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1817": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1818": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1819": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1820": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1821": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1822": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1823": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1824": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "1825": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1826": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1827": {"vr": "SH", "Value": ["*ep_b0"]},
        "1828": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "1829": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "1830": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1831": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1832": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1833": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1834": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1835": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1836": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1837": {"vr": "SH", "Value": ["*ep_b0"]},
        "1838": {"vr": "SH", "Value": ["*ep_b0"]},
        "1839": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1840": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1841": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1842": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1843": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "1844": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1845": {"vr": "SH", "Value": ["*ep_b0"]},
        "1846": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1847": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1848": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1849": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1850": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1851": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1852": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1853": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "1854": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1855": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1856": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1857": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1858": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1859": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1860": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1861": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1862": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "1863": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "1864": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1865": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1866": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "1867": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "1868": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1869": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1870": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1871": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1872": {"vr": "SH", "Value": ["*ep_b0"]},
        "1873": {"vr": "SH", "Value": ["*ep_b0"]},
        "1874": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1875": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "1876": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1877": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1878": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1879": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "1880": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1881": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1882": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "1883": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1884": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1885": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1886": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1887": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "1888": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1889": {"vr": "SH", "Value": ["*ep_b0"]},
        "1890": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1891": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "1892": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1893": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1894": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1895": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1896": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1897": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1898": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1899": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1900": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "1901": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "1902": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1903": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1904": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1905": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1906": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1907": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1908": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1909": {"vr": "SH", "Value": ["*ep_b0"]},
        "1910": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1911": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1912": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1913": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1914": {"vr": "SH", "Value": ["*ep_b0"]},
        "1915": {"vr": "SH", "Value": ["*ep_b0"]},
        "1916": {"vr": "SH", "Value": ["*ep_b0"]},
        "1917": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1918": {"vr": "SH", "Value": ["*ep_b0"]},
        "1919": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "1920": {"vr": "SH", "Value": ["*ep_b0"]},
        "1921": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1922": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1923": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1924": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1925": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1926": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "1927": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1928": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1929": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "1930": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1931": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "1932": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1933": {"vr": "SH", "Value": ["*ep_b0"]},
        "1934": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "1935": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1936": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1937": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1938": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "1939": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1940": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1941": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "1942": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1943": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1944": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1945": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "1946": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1947": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1948": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "1949": {"vr": "SH", "Value": ["*ep_b0"]},
        "1950": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "1951": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "1952": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1953": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1954": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1955": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "1956": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "1957": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "1958": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1959": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "1960": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "1961": {"vr": "SH", "Value": ["*ep_b0"]},
        "1962": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "1963": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "1964": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "1965": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "1966": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1967": {"vr": "SH", "Value": ["*ep_b0"]},
        "1968": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "1969": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "1970": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "1971": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1972": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1973": {"vr": "SH", "Value": ["*ep_b0"]},
        "1974": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "1975": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "1976": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "1977": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1978": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "1979": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1980": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "1981": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "1982": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "1983": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1984": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "1985": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1986": {"vr": "SH", "Value": ["*ep_b0"]},
        "1987": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "1988": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "1989": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "1990": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "1991": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "1992": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "1993": {"vr": "SH", "Value": ["*ep_b0"]},
        "1994": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "1995": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "1996": {"vr": "SH", "Value": ["*ep_b0"]},
        "1997": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "1998": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "1999": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2000": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2001": {"vr": "SH", "Value": ["*ep_b0"]},
        "2002": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2003": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2004": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2005": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2006": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2007": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2008": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2009": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2010": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2011": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2012": {"vr": "SH", "Value": ["*ep_b0"]},
        "2013": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2014": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2015": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2016": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2017": {"vr": "SH", "Value": ["*ep_b0"]},
        "2018": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2019": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2020": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2021": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2022": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2023": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2024": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2025": {"vr": "SH", "Value": ["*ep_b0"]},
        "2026": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2027": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2028": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2029": {"vr": "SH", "Value": ["*ep_b0"]},
        "2030": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2031": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2032": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2033": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2034": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2035": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2036": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2037": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2038": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2039": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2040": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2041": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2042": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2043": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2044": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2045": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2046": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2047": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2048": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2049": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2050": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2051": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2052": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2053": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2054": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2055": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2056": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2057": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2058": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2059": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2060": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2061": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2062": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2063": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2064": {"vr": "SH", "Value": ["*ep_b0"]},
        "2065": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2066": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2067": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2068": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2069": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2070": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2071": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2072": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2073": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2074": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2075": {"vr": "SH", "Value": ["*ep_b0"]},
        "2076": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2077": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2078": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2079": {"vr": "SH", "Value": ["*ep_b0"]},
        "2080": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2081": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2082": {"vr": "SH", "Value": ["*ep_b0"]},
        "2083": {"vr": "SH", "Value": ["*ep_b0"]},
        "2084": {"vr": "SH", "Value": ["*ep_b0"]},
        "2085": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2086": {"vr": "SH", "Value": ["*ep_b0"]},
        "2087": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2088": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2089": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2090": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2091": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2092": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2093": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2094": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2095": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2096": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2097": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2098": {"vr": "SH", "Value": ["*ep_b0"]},
        "2099": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2100": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2101": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2102": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2103": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2104": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2105": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2106": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2107": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2108": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2109": {"vr": "SH", "Value": ["*ep_b0"]},
        "2110": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2111": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2112": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2113": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2114": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2115": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2116": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2117": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2118": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2119": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2120": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2121": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2122": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2123": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2124": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2125": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2126": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2127": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2128": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2129": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2130": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2131": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2132": {"vr": "SH", "Value": ["*ep_b0"]},
        "2133": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2134": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2135": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2136": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2137": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2138": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2139": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2140": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2141": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2142": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2143": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2144": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2145": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2146": {"vr": "SH", "Value": ["*ep_b0"]},
        "2147": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2148": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2149": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2150": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2151": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2152": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2153": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2154": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2155": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2156": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2157": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2158": {"vr": "SH", "Value": ["*ep_b0"]},
        "2159": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2160": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2161": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2162": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2163": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2164": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2165": {"vr": "SH", "Value": ["*ep_b0"]},
        "2166": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2167": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2168": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2169": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2170": {"vr": "SH", "Value": ["*ep_b0"]},
        "2171": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2172": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2173": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2174": {"vr": "SH", "Value": ["*ep_b0"]},
        "2175": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2176": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2177": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2178": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2179": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2180": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2181": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2182": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2183": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2184": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2185": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2186": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2187": {"vr": "SH", "Value": ["*ep_b0"]},
        "2188": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2189": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2190": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2191": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2192": {"vr": "SH", "Value": ["*ep_b0"]},
        "2193": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2194": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2195": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2196": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2197": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2198": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2199": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2200": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2201": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2202": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2203": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2204": {"vr": "SH", "Value": ["*ep_b0"]},
        "2205": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2206": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2207": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2208": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2209": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2210": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2211": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2212": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2213": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2214": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2215": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2216": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2217": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2218": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2219": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2220": {"vr": "SH", "Value": ["*ep_b0"]},
        "2221": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2222": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2223": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2224": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2225": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2226": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2227": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2228": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2229": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2230": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2231": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2232": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2233": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2234": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2235": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2236": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2237": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2238": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2239": {"vr": "SH", "Value": ["*ep_b0"]},
        "2240": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2241": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2242": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2243": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2244": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2245": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2246": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2247": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2248": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2249": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2250": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2251": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2252": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2253": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2254": {"vr": "SH", "Value": ["*ep_b0"]},
        "2255": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2256": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2257": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2258": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2259": {"vr": "SH", "Value": ["*ep_b0"]},
        "2260": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2261": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2262": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2263": {"vr": "SH", "Value": ["*ep_b0"]},
        "2264": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2265": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2266": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2267": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2268": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2269": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2270": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2271": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2272": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2273": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2274": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2275": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2276": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2277": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2278": {"vr": "SH", "Value": ["*ep_b0"]},
        "2279": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2280": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2281": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2282": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2283": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2284": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2285": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2286": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2287": {"vr": "SH", "Value": ["*ep_b0"]},
        "2288": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2289": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2290": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2291": {"vr": "SH", "Value": ["*ep_b0"]},
        "2292": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2293": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2294": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2295": {"vr": "SH", "Value": ["*ep_b0"]},
        "2296": {"vr": "SH", "Value": ["*ep_b0"]},
        "2297": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2298": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2299": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2300": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2301": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2302": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2303": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2304": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2305": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2306": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2307": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2308": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2309": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2310": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2311": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2312": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2313": {"vr": "SH", "Value": ["*ep_b0"]},
        "2314": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2315": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2316": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2317": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2318": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2319": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2320": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2321": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2322": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2323": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2324": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2325": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2326": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2327": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2328": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2329": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2330": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2331": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2332": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2333": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2334": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2335": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2336": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2337": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2338": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2339": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2340": {"vr": "SH", "Value": ["*ep_b0"]},
        "2341": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2342": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2343": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2344": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2345": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2346": {"vr": "SH", "Value": ["*ep_b0"]},
        "2347": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2348": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2349": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2350": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2351": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2352": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2353": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2354": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2355": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2356": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2357": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2358": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2359": {"vr": "SH", "Value": ["*ep_b0"]},
        "2360": {"vr": "SH", "Value": ["*ep_b0"]},
        "2361": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2362": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2363": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2364": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2365": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2366": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2367": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2368": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2369": {"vr": "SH", "Value": ["*ep_b0"]},
        "2370": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2371": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2372": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2373": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2374": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2375": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2376": {"vr": "SH", "Value": ["*ep_b0"]},
        "2377": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2378": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2379": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2380": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2381": {"vr": "SH", "Value": ["*ep_b0"]},
        "2382": {"vr": "SH", "Value": ["*ep_b0"]},
        "2383": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2384": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2385": {"vr": "SH", "Value": ["*ep_b0"]},
        "2386": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2387": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2388": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2389": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2390": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2391": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2392": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2393": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2394": {"vr": "SH", "Value": ["*ep_b0"]},
        "2395": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2396": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2397": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2398": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2399": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2400": {"vr": "SH", "Value": ["*ep_b0"]},
        "2401": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2402": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2403": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2404": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2405": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2406": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2407": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2408": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2409": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2410": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2411": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2412": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2413": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2414": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2415": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2416": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2417": {"vr": "SH", "Value": ["*ep_b0"]},
        "2418": {"vr": "SH", "Value": ["*ep_b0"]},
        "2419": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2420": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2421": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2422": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2423": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2424": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2425": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2426": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2427": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2428": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2429": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2430": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2431": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2432": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2433": {"vr": "SH", "Value": ["*ep_b0"]},
        "2434": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2435": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2436": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2437": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2438": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2439": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2440": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2441": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2442": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2443": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2444": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2445": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2446": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2447": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2448": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2449": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2450": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2451": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2452": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2453": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2454": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2455": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2456": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2457": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2458": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2459": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2460": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2461": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2462": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2463": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2464": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2465": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2466": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2467": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2468": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2469": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2470": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2471": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2472": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2473": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2474": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2475": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2476": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2477": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2478": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2479": {"vr": "SH", "Value": ["*ep_b0"]},
        "2480": {"vr": "SH", "Value": ["*ep_b0"]},
        "2481": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2482": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2483": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2484": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2485": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2486": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2487": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2488": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2489": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2490": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2491": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2492": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2493": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2494": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2495": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2496": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2497": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2498": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2499": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2500": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2501": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2502": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2503": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2504": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2505": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2506": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2507": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2508": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2509": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2510": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2511": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2512": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2513": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2514": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2515": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2516": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2517": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2518": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2519": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2520": {"vr": "SH", "Value": ["*ep_b0"]},
        "2521": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2522": {"vr": "SH", "Value": ["*ep_b0"]},
        "2523": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2524": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2525": {"vr": "SH", "Value": ["*ep_b0"]},
        "2526": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2527": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2528": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2529": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2530": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2531": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2532": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2533": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2534": {"vr": "SH", "Value": ["*ep_b0"]},
        "2535": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2536": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2537": {"vr": "SH", "Value": ["*ep_b0"]},
        "2538": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2539": {"vr": "SH", "Value": ["*ep_b0"]},
        "2540": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2541": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2542": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2543": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2544": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2545": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2546": {"vr": "SH", "Value": ["*ep_b0"]},
        "2547": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2548": {"vr": "SH", "Value": ["*ep_b0"]},
        "2549": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2550": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2551": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2552": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2553": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2554": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2555": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2556": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2557": {"vr": "SH", "Value": ["*ep_b0"]},
        "2558": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2559": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2560": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2561": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2562": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2563": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2564": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2565": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2566": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2567": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2568": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2569": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2570": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2571": {"vr": "SH", "Value": ["*ep_b0"]},
        "2572": {"vr": "SH", "Value": ["*ep_b0"]},
        "2573": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2574": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2575": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2576": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2577": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2578": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2579": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2580": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2581": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2582": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2583": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2584": {"vr": "SH", "Value": ["*ep_b0"]},
        "2585": {"vr": "SH", "Value": ["*ep_b0"]},
        "2586": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2587": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2588": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2589": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2590": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2591": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2592": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2593": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2594": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2595": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2596": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2597": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2598": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2599": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2600": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2601": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2602": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2603": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2604": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2605": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2606": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2607": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2608": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2609": {"vr": "SH", "Value": ["*ep_b0"]},
        "2610": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2611": {"vr": "SH", "Value": ["*ep_b0"]},
        "2612": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2613": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2614": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2615": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2616": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2617": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2618": {"vr": "SH", "Value": ["*ep_b0"]},
        "2619": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2620": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2621": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2622": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2623": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2624": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2625": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2626": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2627": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2628": {"vr": "SH", "Value": ["*ep_b0"]},
        "2629": {"vr": "SH", "Value": ["*ep_b0"]},
        "2630": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2631": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2632": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2633": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2634": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2635": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2636": {"vr": "SH", "Value": ["*ep_b0"]},
        "2637": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2638": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2639": {"vr": "SH", "Value": ["*ep_b0"]},
        "2640": {"vr": "SH", "Value": ["*ep_b0"]},
        "2641": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2642": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2643": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2644": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2645": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2646": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2647": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2648": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2649": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2650": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2651": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2652": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2653": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2654": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2655": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2656": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2657": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2658": {"vr": "SH", "Value": ["*ep_b0"]},
        "2659": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2660": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2661": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2662": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2663": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2664": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2665": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2666": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2667": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2668": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2669": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2670": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2671": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2672": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2673": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2674": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2675": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2676": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2677": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2678": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2679": {"vr": "SH", "Value": ["*ep_b0"]},
        "2680": {"vr": "SH", "Value": ["*ep_b0"]},
        "2681": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2682": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2683": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2684": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2685": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2686": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2687": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2688": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2689": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2690": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2691": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2692": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2693": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2694": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2695": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2696": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2697": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2698": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2699": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2700": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2701": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2702": {"vr": "SH", "Value": ["*ep_b0"]},
        "2703": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2704": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2705": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2706": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2707": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2708": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2709": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2710": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2711": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2712": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2713": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2714": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2715": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2716": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2717": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2718": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2719": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2720": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2721": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2722": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2723": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2724": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2725": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2726": {"vr": "SH", "Value": ["*ep_b0"]},
        "2727": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2728": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2729": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2730": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2731": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2732": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2733": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2734": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2735": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2736": {"vr": "SH", "Value": ["*ep_b0"]},
        "2737": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2738": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2739": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2740": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2741": {"vr": "SH", "Value": ["*ep_b0"]},
        "2742": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2743": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2744": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2745": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2746": {"vr": "SH", "Value": ["*ep_b0"]},
        "2747": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2748": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2749": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "2750": {"vr": "SH", "Value": ["*ep_b0"]},
        "2751": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2752": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2753": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2754": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2755": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2756": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2757": {"vr": "SH", "Value": ["*ep_b0"]},
        "2758": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2759": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2760": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2761": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2762": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2763": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2764": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2765": {"vr": "SH", "Value": ["*ep_b0"]},
        "2766": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2767": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2768": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2769": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2770": {"vr": "SH", "Value": ["*ep_b0"]},
        "2771": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2772": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2773": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2774": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2775": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2776": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2777": {"vr": "SH", "Value": ["*ep_b0"]},
        "2778": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2779": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2780": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2781": {"vr": "SH", "Value": ["*ep_b0"]},
        "2782": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2783": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2784": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2785": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "2786": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2787": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2788": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2789": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2790": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2791": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "2792": {"vr": "SH", "Value": ["*ep_b0"]},
        "2793": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2794": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2795": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2796": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2797": {"vr": "SH", "Value": ["*ep_b0"]},
        "2798": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2799": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2800": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2801": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2802": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2803": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2804": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2805": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2806": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "2807": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2808": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2809": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2810": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2811": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2812": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2813": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2814": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2815": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2816": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2817": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2818": {"vr": "SH", "Value": ["*ep_b0"]},
        "2819": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2820": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2821": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2822": {"vr": "SH", "Value": ["*ep_b0"]},
        "2823": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2824": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "2825": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2826": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2827": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2828": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "2829": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2830": {"vr": "SH", "Value": ["*ep_b0"]},
        "2831": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2832": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2833": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2834": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2835": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2836": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2837": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2838": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2839": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2840": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2841": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2842": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2843": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2844": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2845": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2846": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2847": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2848": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2849": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2850": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2851": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2852": {"vr": "SH", "Value": ["*ep_b0"]},
        "2853": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2854": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2855": {"vr": "SH", "Value": ["*ep_b0"]},
        "2856": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2857": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2858": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "2859": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2860": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2861": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2862": {"vr": "SH", "Value": ["*ep_b0"]},
        "2863": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "2864": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2865": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2866": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2867": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2868": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2869": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2870": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "2871": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "2872": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2873": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2874": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2875": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "2876": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2877": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2878": {"vr": "SH", "Value": ["*ep_b0"]},
        "2879": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2880": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "2881": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2882": {"vr": "SH", "Value": ["*ep_b0"]},
        "2883": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2884": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2885": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2886": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2887": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2888": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2889": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "2890": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2891": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2892": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2893": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2894": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "2895": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2896": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2897": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2898": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2899": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "2900": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2901": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2902": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2903": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2904": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2905": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2906": {"vr": "SH", "Value": ["*ep_b0"]},
        "2907": {"vr": "SH", "Value": ["*ep_b0"]},
        "2908": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2909": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "2910": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "2911": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2912": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2913": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "2914": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2915": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "2916": {"vr": "SH", "Value": ["*ep_b0"]},
        "2917": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2918": {"vr": "SH", "Value": ["*ep_b0"]},
        "2919": {"vr": "SH", "Value": ["*ep_b0"]},
        "2920": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2921": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "2922": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2923": {"vr": "SH", "Value": ["*ep_b0"]},
        "2924": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2925": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "2926": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2927": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2928": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2929": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "2930": {"vr": "SH", "Value": ["*ep_b0"]},
        "2931": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2932": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "2933": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2934": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2935": {"vr": "SH", "Value": ["*ep_b0"]},
        "2936": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "2937": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2938": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2939": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2940": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "2941": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "2942": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2943": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2944": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2945": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2946": {"vr": "SH", "Value": ["*ep_b0"]},
        "2947": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "2948": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "2949": {"vr": "SH", "Value": ["*ep_b0"]},
        "2950": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2951": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2952": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "2953": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "2954": {"vr": "SH", "Value": ["*ep_b0"]},
        "2955": {"vr": "SH", "Value": ["*ep_b0"]},
        "2956": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "2957": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "2958": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2959": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2960": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "2961": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2962": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2963": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2964": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "2965": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2966": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "2967": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "2968": {"vr": "SH", "Value": ["*ep_b0"]},
        "2969": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2970": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2971": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "2972": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "2973": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2974": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "2975": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "2976": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "2977": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "2978": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "2979": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "2980": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2981": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "2982": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "2983": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "2984": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "2985": {"vr": "SH", "Value": ["*ep_b0"]},
        "2986": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "2987": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "2988": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2989": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "2990": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "2991": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "2992": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "2993": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "2994": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "2995": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "2996": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "2997": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "2998": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "2999": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3000": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3001": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3002": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3003": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3004": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3005": {"vr": "SH", "Value": ["*ep_b0"]},
        "3006": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3007": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3008": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3009": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3010": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3011": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3012": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3013": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3014": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3015": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3016": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3017": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3018": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3019": {"vr": "SH", "Value": ["*ep_b0"]},
        "3020": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3021": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3022": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3023": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3024": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3025": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3026": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3027": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3028": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3029": {"vr": "SH", "Value": ["*ep_b0"]},
        "3030": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3031": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3032": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3033": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3034": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3035": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3036": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3037": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3038": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3039": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3040": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3041": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3042": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3043": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3044": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3045": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3046": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3047": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3048": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3049": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3050": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3051": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3052": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3053": {"vr": "SH", "Value": ["*ep_b0"]},
        "3054": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3055": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3056": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3057": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3058": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3059": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3060": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3061": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3062": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3063": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3064": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3065": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3066": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3067": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3068": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3069": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3070": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3071": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3072": {"vr": "SH", "Value": ["*ep_b0"]},
        "3073": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3074": {"vr": "SH", "Value": ["*ep_b0"]},
        "3075": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3076": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3077": {"vr": "SH", "Value": ["*ep_b0"]},
        "3078": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3079": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3080": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3081": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3082": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3083": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3084": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3085": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3086": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3087": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3088": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3089": {"vr": "SH", "Value": ["*ep_b0"]},
        "3090": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3091": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3092": {"vr": "SH", "Value": ["*ep_b0"]},
        "3093": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3094": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3095": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3096": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3097": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3098": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3099": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3100": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3101": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3102": {"vr": "SH", "Value": ["*ep_b0"]},
        "3103": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3104": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3105": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3106": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3107": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3108": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3109": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3110": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3111": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3112": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3113": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3114": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3115": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3116": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3117": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3118": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3119": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3120": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3121": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3122": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3123": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3124": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3125": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3126": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3127": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3128": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3129": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3130": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3131": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3132": {"vr": "SH", "Value": ["*ep_b0"]},
        "3133": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3134": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3135": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3136": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3137": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3138": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3139": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3140": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3141": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3142": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3143": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3144": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3145": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3146": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3147": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3148": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3149": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3150": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3151": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3152": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3153": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3154": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3155": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3156": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3157": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3158": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3159": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3160": {"vr": "SH", "Value": ["*ep_b0"]},
        "3161": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3162": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3163": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3164": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3165": {"vr": "SH", "Value": ["*ep_b0"]},
        "3166": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3167": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3168": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3169": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3170": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3171": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3172": {"vr": "SH", "Value": ["*ep_b0"]},
        "3173": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3174": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3175": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3176": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3177": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3178": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3179": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3180": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3181": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3182": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3183": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3184": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3185": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3186": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3187": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3188": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3189": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3190": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3191": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3192": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3193": {"vr": "SH", "Value": ["*ep_b0"]},
        "3194": {"vr": "SH", "Value": ["*ep_b0"]},
        "3195": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3196": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3197": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3198": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3199": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3200": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3201": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3202": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3203": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3204": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3205": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3206": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3207": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3208": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3209": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3210": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3211": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3212": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3213": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3214": {"vr": "SH", "Value": ["*ep_b0"]},
        "3215": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3216": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3217": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3218": {"vr": "SH", "Value": ["*ep_b0"]},
        "3219": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3220": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3221": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3222": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3223": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3224": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3225": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3226": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3227": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3228": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3229": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3230": {"vr": "SH", "Value": ["*ep_b0"]},
        "3231": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3232": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3233": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3234": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3235": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3236": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3237": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3238": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3239": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3240": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3241": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3242": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3243": {"vr": "SH", "Value": ["*ep_b0"]},
        "3244": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3245": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3246": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3247": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3248": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3249": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3250": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3251": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3252": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3253": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3254": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3255": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3256": {"vr": "SH", "Value": ["*ep_b0"]},
        "3257": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3258": {"vr": "SH", "Value": ["*ep_b0"]},
        "3259": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3260": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3261": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3262": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3263": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3264": {"vr": "SH", "Value": ["*ep_b0"]},
        "3265": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3266": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3267": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3268": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3269": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3270": {"vr": "SH", "Value": ["*ep_b0"]},
        "3271": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3272": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3273": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3274": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3275": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3276": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3277": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3278": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3279": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3280": {"vr": "SH", "Value": ["*ep_b0"]},
        "3281": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3282": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3283": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3284": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3285": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3286": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3287": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3288": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3289": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3290": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3291": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3292": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3293": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3294": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3295": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3296": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3297": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3298": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3299": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3300": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3301": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3302": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3303": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3304": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3305": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3306": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3307": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3308": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3309": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3310": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3311": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3312": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3313": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3314": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3315": {"vr": "SH", "Value": ["*ep_b0"]},
        "3316": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3317": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3318": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3319": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3320": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3321": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3322": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3323": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3324": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3325": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3326": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3327": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3328": {"vr": "SH", "Value": ["*ep_b0"]},
        "3329": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3330": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3331": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3332": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3333": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3334": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3335": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3336": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3337": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3338": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3339": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3340": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3341": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3342": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3343": {"vr": "SH", "Value": ["*ep_b0"]},
        "3344": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3345": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3346": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3347": {"vr": "SH", "Value": ["*ep_b0"]},
        "3348": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3349": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3350": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3351": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3352": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3353": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3354": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3355": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3356": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3357": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3358": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3359": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3360": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3361": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3362": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3363": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3364": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3365": {"vr": "SH", "Value": ["*ep_b0"]},
        "3366": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3367": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3368": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3369": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3370": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3371": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3372": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3373": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3374": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3375": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3376": {"vr": "SH", "Value": ["*ep_b0"]},
        "3377": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3378": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3379": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3380": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3381": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3382": {"vr": "SH", "Value": ["*ep_b0"]},
        "3383": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3384": {"vr": "SH", "Value": ["*ep_b0"]},
        "3385": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3386": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3387": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3388": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3389": {"vr": "SH", "Value": ["*ep_b0"]},
        "3390": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3391": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3392": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3393": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3394": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3395": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3396": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3397": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3398": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3399": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3400": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3401": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3402": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3403": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3404": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3405": {"vr": "SH", "Value": ["*ep_b0"]},
        "3406": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3407": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3408": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3409": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3410": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3411": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3412": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3413": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3414": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3415": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3416": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3417": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3418": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3419": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3420": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3421": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3422": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3423": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3424": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3425": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3426": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3427": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3428": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3429": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3430": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3431": {"vr": "SH", "Value": ["*ep_b0"]},
        "3432": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3433": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3434": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3435": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3436": {"vr": "SH", "Value": ["*ep_b0"]},
        "3437": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3438": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3439": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3440": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3441": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3442": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3443": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3444": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3445": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3446": {"vr": "SH", "Value": ["*ep_b0"]},
        "3447": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3448": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3449": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3450": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3451": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3452": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3453": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3454": {"vr": "SH", "Value": ["*ep_b0"]},
        "3455": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3456": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3457": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3458": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3459": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3460": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3461": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3462": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3463": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3464": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3465": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3466": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3467": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3468": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3469": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3470": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3471": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3472": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3473": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3474": {"vr": "SH", "Value": ["*ep_b0"]},
        "3475": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3476": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3477": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3478": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3479": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3480": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3481": {"vr": "SH", "Value": ["*ep_b0"]},
        "3482": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3483": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3484": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3485": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3486": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3487": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3488": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3489": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3490": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3491": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3492": {"vr": "SH", "Value": ["*ep_b0"]},
        "3493": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3494": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3495": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3496": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3497": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3498": {"vr": "SH", "Value": ["*ep_b0"]},
        "3499": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3500": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3501": {"vr": "SH", "Value": ["*ep_b0"]},
        "3502": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3503": {"vr": "SH", "Value": ["*ep_b0"]},
        "3504": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3505": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3506": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3507": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3508": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3509": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3510": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3511": {"vr": "SH", "Value": ["*ep_b0"]},
        "3512": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3513": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3514": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3515": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3516": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3517": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3518": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3519": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3520": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3521": {"vr": "SH", "Value": ["*ep_b0"]},
        "3522": {"vr": "SH", "Value": ["*ep_b0"]},
        "3523": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3524": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3525": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3526": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3527": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3528": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3529": {"vr": "SH", "Value": ["*ep_b0"]},
        "3530": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3531": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3532": {"vr": "SH", "Value": ["*ep_b0"]},
        "3533": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3534": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3535": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3536": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3537": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3538": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3539": {"vr": "SH", "Value": ["*ep_b0"]},
        "3540": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3541": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3542": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3543": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3544": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3545": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3546": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3547": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3548": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3549": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3550": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3551": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3552": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3553": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3554": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3555": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3556": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3557": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3558": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3559": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3560": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3561": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3562": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3563": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3564": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3565": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3566": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3567": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3568": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3569": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3570": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3571": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3572": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3573": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3574": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3575": {"vr": "SH", "Value": ["*ep_b0"]},
        "3576": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3577": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3578": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3579": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3580": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3581": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3582": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3583": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3584": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3585": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3586": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3587": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3588": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3589": {"vr": "SH", "Value": ["*ep_b0"]},
        "3590": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3591": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3592": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3593": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3594": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3595": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3596": {"vr": "SH", "Value": ["*ep_b0"]},
        "3597": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3598": {"vr": "SH", "Value": ["*ep_b0"]},
        "3599": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3600": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3601": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3602": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3603": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3604": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3605": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3606": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3607": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3608": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3609": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3610": {"vr": "SH", "Value": ["*ep_b0"]},
        "3611": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3612": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3613": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3614": {"vr": "SH", "Value": ["*ep_b0"]},
        "3615": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3616": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3617": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3618": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3619": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3620": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3621": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3622": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3623": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3624": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3625": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3626": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3627": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3628": {"vr": "SH", "Value": ["*ep_b0"]},
        "3629": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3630": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3631": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3632": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3633": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3634": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3635": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3636": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3637": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3638": {"vr": "SH", "Value": ["*ep_b0"]},
        "3639": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3640": {"vr": "SH", "Value": ["*ep_b0"]},
        "3641": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3642": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3643": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3644": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3645": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3646": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3647": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3648": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3649": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3650": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3651": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3652": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3653": {"vr": "SH", "Value": ["*ep_b0"]},
        "3654": {"vr": "SH", "Value": ["*ep_b0"]},
        "3655": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3656": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3657": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3658": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3659": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3660": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3661": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3662": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3663": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3664": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3665": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3666": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3667": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3668": {"vr": "SH", "Value": ["*ep_b0"]},
        "3669": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3670": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3671": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3672": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3673": {"vr": "SH", "Value": ["*ep_b0"]},
        "3674": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3675": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3676": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3677": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3678": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3679": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3680": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3681": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3682": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3683": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3684": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3685": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3686": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3687": {"vr": "SH", "Value": ["*ep_b0"]},
        "3688": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3689": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3690": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3691": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3692": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3693": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3694": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3695": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3696": {"vr": "SH", "Value": ["*ep_b0"]},
        "3697": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3698": {"vr": "SH", "Value": ["*ep_b0"]},
        "3699": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3700": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3701": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3702": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3703": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3704": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3705": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3706": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3707": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3708": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3709": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3710": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3711": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3712": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3713": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3714": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3715": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3716": {"vr": "SH", "Value": ["*ep_b0"]},
        "3717": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3718": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3719": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3720": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "3721": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3722": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3723": {"vr": "SH", "Value": ["*ep_b0"]},
        "3724": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3725": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3726": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3727": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3728": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3729": {"vr": "SH", "Value": ["*ep_b0"]},
        "3730": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3731": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3732": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3733": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3734": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3735": {"vr": "SH", "Value": ["*ep_b0"]},
        "3736": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3737": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3738": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3739": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3740": {"vr": "SH", "Value": ["*ep_b3000#21"]},
        "3741": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3742": {"vr": "SH", "Value": ["*ep_b0"]},
        "3743": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3744": {"vr": "SH", "Value": ["*ep_b0"]},
        "3745": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3746": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3747": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3748": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3749": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3750": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3751": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3752": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3753": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3754": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3755": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3756": {"vr": "SH", "Value": ["*ep_b0"]},
        "3757": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3758": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3759": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3760": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3761": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3762": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3763": {"vr": "SH", "Value": ["*ep_b0"]},
        "3764": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3765": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3766": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3767": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3768": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3769": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3770": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3771": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3772": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3773": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3774": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3775": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3776": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3777": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3778": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3779": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3780": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3781": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3782": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3783": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3784": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3785": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3786": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3787": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3788": {"vr": "SH", "Value": ["*ep_b0"]},
        "3789": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3790": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3791": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3792": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3793": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3794": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3795": {"vr": "SH", "Value": ["*ep_b0"]},
        "3796": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3797": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3798": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3799": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3800": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3801": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3802": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3803": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3804": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3805": {"vr": "SH", "Value": ["*ep_b0"]},
        "3806": {"vr": "SH", "Value": ["*ep_b0"]},
        "3807": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3808": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3809": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3810": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3811": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3812": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3813": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3814": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3815": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3816": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3817": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3818": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3819": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3820": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3821": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3822": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3823": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3824": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3825": {"vr": "SH", "Value": ["*ep_b0"]},
        "3826": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3827": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3828": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3829": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3830": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3831": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "3832": {"vr": "SH", "Value": ["*ep_b0"]},
        "3833": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3834": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3835": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3836": {"vr": "SH", "Value": ["*ep_b3000#49"]},
        "3837": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3838": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3839": {"vr": "SH", "Value": ["*ep_b3000#2"]},
        "3840": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3841": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3842": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3843": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3844": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3845": {"vr": "SH", "Value": ["*ep_b0"]},
        "3846": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3847": {"vr": "SH", "Value": ["*ep_b3000#43"]},
        "3848": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3849": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3850": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3851": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3852": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3853": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3854": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3855": {"vr": "SH", "Value": ["*ep_b0"]},
        "3856": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3857": {"vr": "SH", "Value": ["*ep_b3000#14"]},
        "3858": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3859": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3860": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3861": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3862": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3863": {"vr": "SH", "Value": ["*ep_b0"]},
        "3864": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3865": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3866": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3867": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3868": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3869": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3870": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3871": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3872": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3873": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "3874": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3875": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "3876": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3877": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3878": {"vr": "SH", "Value": ["*ep_b0"]},
        "3879": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "3880": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3881": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3882": {"vr": "SH", "Value": ["*ep_b0"]},
        "3883": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3884": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "3885": {"vr": "SH", "Value": ["*ep_b0"]},
        "3886": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3887": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3888": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3889": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3890": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3891": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3892": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3893": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3894": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3895": {"vr": "SH", "Value": ["*ep_b3000#17"]},
        "3896": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3897": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3898": {"vr": "SH", "Value": ["*ep_b3000#41"]},
        "3899": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3900": {"vr": "SH", "Value": ["*ep_b0"]},
        "3901": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3902": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3903": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3904": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3905": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3906": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3907": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3908": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3909": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3910": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3911": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3912": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3913": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3914": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3915": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3916": {"vr": "SH", "Value": ["*ep_b0"]},
        "3917": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3918": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3919": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3920": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3921": {"vr": "SH", "Value": ["*ep_b3000#57"]},
        "3922": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3923": {"vr": "SH", "Value": ["*ep_b3000#10"]},
        "3924": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3925": {"vr": "SH", "Value": ["*ep_b3000#19"]},
        "3926": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3927": {"vr": "SH", "Value": ["*ep_b3000#50"]},
        "3928": {"vr": "SH", "Value": ["*ep_b0"]},
        "3929": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3930": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3931": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3932": {"vr": "SH", "Value": ["*ep_b3000#46"]},
        "3933": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3934": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3935": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3936": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3937": {"vr": "SH", "Value": ["*ep_b0"]},
        "3938": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3939": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3940": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3941": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3942": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3943": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3944": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3945": {"vr": "SH", "Value": ["*ep_b0"]},
        "3946": {"vr": "SH", "Value": ["*ep_b3000#62"]},
        "3947": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3948": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "3949": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "3950": {"vr": "SH", "Value": ["*ep_b3000#42"]},
        "3951": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3952": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3953": {"vr": "SH", "Value": ["*ep_b3000#37"]},
        "3954": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "3955": {"vr": "SH", "Value": ["*ep_b3000#66"]},
        "3956": {"vr": "SH", "Value": ["*ep_b3000#36"]},
        "3957": {"vr": "SH", "Value": ["*ep_b3000#33"]},
        "3958": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "3959": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3960": {"vr": "SH", "Value": ["*ep_b3000#44"]},
        "3961": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3962": {"vr": "SH", "Value": ["*ep_b3000#55"]},
        "3963": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "3964": {"vr": "SH", "Value": ["*ep_b3000#47"]},
        "3965": {"vr": "SH", "Value": ["*ep_b3000#65"]},
        "3966": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3967": {"vr": "SH", "Value": ["*ep_b3000#27"]},
        "3968": {"vr": "SH", "Value": ["*ep_b0"]},
        "3969": {"vr": "SH", "Value": ["*ep_b3000#5"]},
        "3970": {"vr": "SH", "Value": ["*ep_b3000#30"]},
        "3971": {"vr": "SH", "Value": ["*ep_b3000#7"]},
        "3972": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "3973": {"vr": "SH", "Value": ["*ep_b3000#26"]},
        "3974": {"vr": "SH", "Value": ["*ep_b3000#20"]},
        "3975": {"vr": "SH", "Value": ["*ep_b3000#53"]},
        "3976": {"vr": "SH", "Value": ["*ep_b3000#3"]},
        "3977": {"vr": "SH", "Value": ["*ep_b3000#9"]},
        "3978": {"vr": "SH", "Value": ["*ep_b3000#64"]},
        "3979": {"vr": "SH", "Value": ["*ep_b3000#29"]},
        "3980": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "3981": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "3982": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3983": {"vr": "SH", "Value": ["*ep_b3000#4"]},
        "3984": {"vr": "SH", "Value": ["*ep_b3000#18"]},
        "3985": {"vr": "SH", "Value": ["*ep_b3000#39"]},
        "3986": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3987": {"vr": "SH", "Value": ["*ep_b3000#28"]},
        "3988": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "3989": {"vr": "SH", "Value": ["*ep_b3000#25"]},
        "3990": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3991": {"vr": "SH", "Value": ["*ep_b3000#38"]},
        "3992": {"vr": "SH", "Value": ["*ep_b3000#63"]},
        "3993": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "3994": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3995": {"vr": "SH", "Value": ["*ep_b3000#13"]},
        "3996": {"vr": "SH", "Value": ["*ep_b3000#6"]},
        "3997": {"vr": "SH", "Value": ["*ep_b3000#59"]},
        "3998": {"vr": "SH", "Value": ["*ep_b3000#31"]},
        "3999": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "4000": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "4001": {"vr": "SH", "Value": ["*ep_b3000#48"]},
        "4002": {"vr": "SH", "Value": ["*ep_b3000#52"]},
        "4003": {"vr": "SH", "Value": ["*ep_b3000#24"]},
        "4004": {"vr": "SH", "Value": ["*ep_b3000#58"]},
        "4005": {"vr": "SH", "Value": ["*ep_b3000#16"]},
        "4006": {"vr": "SH", "Value": ["*ep_b3000#8"]},
        "4007": {"vr": "SH", "Value": ["*ep_b3000#40"]},
        "4008": {"vr": "SH", "Value": ["*ep_b3000#15"]},
        "4009": {"vr": "SH", "Value": ["*ep_b0"]},
        "4010": {"vr": "SH", "Value": ["*ep_b3000#35"]},
        "4011": {"vr": "SH", "Value": ["*ep_b0"]},
        "4012": {"vr": "SH", "Value": ["*ep_b3000#54"]},
        "4013": {"vr": "SH", "Value": ["*ep_b3000#11"]},
        "4014": {"vr": "SH", "Value": ["*ep_b3000#22"]},
        "4015": {"vr": "SH", "Value": ["*ep_b3000#61"]},
        "4016": {"vr": "SH", "Value": ["*ep_b3000#60"]},
        "4017": {"vr": "SH", "Value": ["*ep_b3000#32"]},
        "4018": {"vr": "SH", "Value": ["*ep_b3000#51"]},
        "4019": {"vr": "SH", "Value": ["*ep_b3000#40"]},
    },
    "0019100B": {
        "0": {"vr": "DS", "Value": [22.5]},
        "1": {"vr": "DS", "Value": [20.0]},
        "2": {"vr": "DS", "Value": [22.5]},
        "3": {"vr": "DS", "Value": [22.5]},
        "4": {"vr": "DS", "Value": [20.0]},
        "5": {"vr": "DS", "Value": [20.0]},
        "6": {"vr": "DS", "Value": [20.0]},
        "7": {"vr": "DS", "Value": [22.5]},
        "8": {"vr": "DS", "Value": [20.0]},
        "9": {"vr": "DS", "Value": [22.5]},
        "10": {"vr": "DS", "Value": [20.0]},
        "11": {"vr": "DS", "Value": [20.0]},
        "12": {"vr": "DS", "Value": [20.0]},
        "13": {"vr": "DS", "Value": [22.5]},
        "14": {"vr": "DS", "Value": [22.5]},
        "15": {"vr": "DS", "Value": [22.5]},
        "16": {"vr": "DS", "Value": [22.5]},
        "17": {"vr": "DS", "Value": [22.5]},
        "18": {"vr": "DS", "Value": [20.0]},
        "19": {"vr": "DS", "Value": [22.5]},
        "20": {"vr": "DS", "Value": [22.5]},
        "21": {"vr": "DS", "Value": [22.5]},
        "22": {"vr": "DS", "Value": [22.5]},
        "23": {"vr": "DS", "Value": [20.0]},
        "24": {"vr": "DS", "Value": [20.0]},
        "25": {"vr": "DS", "Value": [22.5]},
        "26": {"vr": "DS", "Value": [20.0]},
        "27": {"vr": "DS", "Value": [20.0]},
        "28": {"vr": "DS", "Value": [20.0]},
        "29": {"vr": "DS", "Value": [22.5]},
        "30": {"vr": "DS", "Value": [20.0]},
        "31": {"vr": "DS", "Value": [20.0]},
        "32": {"vr": "DS", "Value": [20.0]},
        "33": {"vr": "DS", "Value": [22.5]},
        "34": {"vr": "DS", "Value": [22.5]},
        "35": {"vr": "DS", "Value": [22.5]},
        "36": {"vr": "DS", "Value": [22.5]},
        "37": {"vr": "DS", "Value": [22.5]},
        "38": {"vr": "DS", "Value": [22.5]},
        "39": {"vr": "DS", "Value": [20.0]},
        "40": {"vr": "DS", "Value": [22.5]},
        "41": {"vr": "DS", "Value": [20.0]},
        "42": {"vr": "DS", "Value": [22.5]},
        "43": {"vr": "DS", "Value": [22.5]},
        "44": {"vr": "DS", "Value": [20.0]},
        "45": {"vr": "DS", "Value": [20.0]},
        "46": {"vr": "DS", "Value": [20.0]},
        "47": {"vr": "DS", "Value": [22.5]},
        "48": {"vr": "DS", "Value": [22.5]},
        "49": {"vr": "DS", "Value": [20.0]},
        "50": {"vr": "DS", "Value": [20.0]},
        "51": {"vr": "DS", "Value": [20.0]},
        "52": {"vr": "DS", "Value": [20.0]},
        "53": {"vr": "DS", "Value": [20.0]},
        "54": {"vr": "DS", "Value": [22.5]},
        "55": {"vr": "DS", "Value": [22.5]},
        "56": {"vr": "DS", "Value": [20.0]},
        "57": {"vr": "DS", "Value": [20.0]},
        "58": {"vr": "DS", "Value": [20.0]},
        "59": {"vr": "DS", "Value": [22.5]},
        "60": {"vr": "DS", "Value": [22.5]},
        "61": {"vr": "DS", "Value": [22.5]},
        "62": {"vr": "DS", "Value": [22.5]},
        "63": {"vr": "DS", "Value": [22.5]},
        "64": {"vr": "DS", "Value": [20.0]},
        "65": {"vr": "DS", "Value": [22.5]},
        "66": {"vr": "DS", "Value": [20.0]},
        "67": {"vr": "DS", "Value": [20.0]},
        "68": {"vr": "DS", "Value": [22.5]},
        "69": {"vr": "DS", "Value": [20.0]},
        "70": {"vr": "DS", "Value": [20.0]},
        "71": {"vr": "DS", "Value": [20.0]},
        "72": {"vr": "DS", "Value": [22.5]},
        "73": {"vr": "DS", "Value": [20.0]},
        "74": {"vr": "DS", "Value": [22.5]},
        "75": {"vr": "DS", "Value": [20.0]},
        "76": {"vr": "DS", "Value": [20.0]},
        "77": {"vr": "DS", "Value": [20.0]},
        "78": {"vr": "DS", "Value": [20.0]},
        "79": {"vr": "DS", "Value": [20.0]},
        "80": {"vr": "DS", "Value": [22.5]},
        "81": {"vr": "DS", "Value": [20.0]},
        "82": {"vr": "DS", "Value": [20.0]},
        "83": {"vr": "DS", "Value": [22.5]},
        "84": {"vr": "DS", "Value": [22.5]},
        "85": {"vr": "DS", "Value": [22.5]},
        "86": {"vr": "DS", "Value": [20.0]},
        "87": {"vr": "DS", "Value": [22.5]},
        "88": {"vr": "DS", "Value": [22.5]},
        "89": {"vr": "DS", "Value": [20.0]},
        "90": {"vr": "DS", "Value": [20.0]},
        "91": {"vr": "DS", "Value": [20.0]},
        "92": {"vr": "DS", "Value": [22.5]},
        "93": {"vr": "DS", "Value": [20.0]},
        "94": {"vr": "DS", "Value": [20.0]},
        "95": {"vr": "DS", "Value": [20.0]},
        "96": {"vr": "DS", "Value": [20.0]},
        "97": {"vr": "DS", "Value": [20.0]},
        "98": {"vr": "DS", "Value": [20.0]},
        "99": {"vr": "DS", "Value": [22.5]},
        "100": {"vr": "DS", "Value": [22.5]},
        "101": {"vr": "DS", "Value": [22.5]},
        "102": {"vr": "DS", "Value": [20.0]},
        "103": {"vr": "DS", "Value": [20.0]},
        "104": {"vr": "DS", "Value": [22.5]},
        "105": {"vr": "DS", "Value": [22.5]},
        "106": {"vr": "DS", "Value": [20.0]},
        "107": {"vr": "DS", "Value": [20.0]},
        "108": {"vr": "DS", "Value": [20.0]},
        "109": {"vr": "DS", "Value": [22.5]},
        "110": {"vr": "DS", "Value": [22.5]},
        "111": {"vr": "DS", "Value": [20.0]},
        "112": {"vr": "DS", "Value": [22.5]},
        "113": {"vr": "DS", "Value": [20.0]},
        "114": {"vr": "DS", "Value": [22.5]},
        "115": {"vr": "DS", "Value": [20.0]},
        "116": {"vr": "DS", "Value": [22.5]},
        "117": {"vr": "DS", "Value": [22.5]},
        "118": {"vr": "DS", "Value": [20.0]},
        "119": {"vr": "DS", "Value": [20.0]},
        "120": {"vr": "DS", "Value": [20.0]},
        "121": {"vr": "DS", "Value": [20.0]},
        "122": {"vr": "DS", "Value": [22.5]},
        "123": {"vr": "DS", "Value": [22.5]},
        "124": {"vr": "DS", "Value": [20.0]},
        "125": {"vr": "DS", "Value": [22.5]},
        "126": {"vr": "DS", "Value": [22.5]},
        "127": {"vr": "DS", "Value": [22.5]},
        "128": {"vr": "DS", "Value": [22.5]},
        "129": {"vr": "DS", "Value": [22.5]},
        "130": {"vr": "DS", "Value": [20.0]},
        "131": {"vr": "DS", "Value": [20.0]},
        "132": {"vr": "DS", "Value": [22.5]},
        "133": {"vr": "DS", "Value": [20.0]},
        "134": {"vr": "DS", "Value": [20.0]},
        "135": {"vr": "DS", "Value": [22.5]},
        "136": {"vr": "DS", "Value": [22.5]},
        "137": {"vr": "DS", "Value": [20.0]},
        "138": {"vr": "DS", "Value": [22.5]},
        "139": {"vr": "DS", "Value": [20.0]},
        "140": {"vr": "DS", "Value": [20.0]},
        "141": {"vr": "DS", "Value": [22.5]},
        "142": {"vr": "DS", "Value": [22.5]},
        "143": {"vr": "DS", "Value": [22.5]},
        "144": {"vr": "DS", "Value": [22.5]},
        "145": {"vr": "DS", "Value": [20.0]},
        "146": {"vr": "DS", "Value": [22.5]},
        "147": {"vr": "DS", "Value": [20.0]},
        "148": {"vr": "DS", "Value": [20.0]},
        "149": {"vr": "DS", "Value": [22.5]},
        "150": {"vr": "DS", "Value": [22.5]},
        "151": {"vr": "DS", "Value": [20.0]},
        "152": {"vr": "DS", "Value": [20.0]},
        "153": {"vr": "DS", "Value": [22.5]},
        "154": {"vr": "DS", "Value": [22.5]},
        "155": {"vr": "DS", "Value": [20.0]},
        "156": {"vr": "DS", "Value": [20.0]},
        "157": {"vr": "DS", "Value": [22.5]},
        "158": {"vr": "DS", "Value": [22.5]},
        "159": {"vr": "DS", "Value": [22.5]},
        "160": {"vr": "DS", "Value": [22.5]},
        "161": {"vr": "DS", "Value": [20.0]},
        "162": {"vr": "DS", "Value": [20.0]},
        "163": {"vr": "DS", "Value": [22.5]},
        "164": {"vr": "DS", "Value": [20.0]},
        "165": {"vr": "DS", "Value": [22.5]},
        "166": {"vr": "DS", "Value": [20.0]},
        "167": {"vr": "DS", "Value": [22.5]},
        "168": {"vr": "DS", "Value": [20.0]},
        "169": {"vr": "DS", "Value": [22.5]},
        "170": {"vr": "DS", "Value": [22.5]},
        "171": {"vr": "DS", "Value": [20.0]},
        "172": {"vr": "DS", "Value": [20.0]},
        "173": {"vr": "DS", "Value": [22.5]},
        "174": {"vr": "DS", "Value": [22.5]},
        "175": {"vr": "DS", "Value": [20.0]},
        "176": {"vr": "DS", "Value": [22.5]},
        "177": {"vr": "DS", "Value": [20.0]},
        "178": {"vr": "DS", "Value": [20.0]},
        "179": {"vr": "DS", "Value": [22.5]},
        "180": {"vr": "DS", "Value": [20.0]},
        "181": {"vr": "DS", "Value": [20.0]},
        "182": {"vr": "DS", "Value": [20.0]},
        "183": {"vr": "DS", "Value": [22.5]},
        "184": {"vr": "DS", "Value": [22.5]},
        "185": {"vr": "DS", "Value": [22.5]},
        "186": {"vr": "DS", "Value": [20.0]},
        "187": {"vr": "DS", "Value": [22.5]},
        "188": {"vr": "DS", "Value": [22.5]},
        "189": {"vr": "DS", "Value": [22.5]},
        "190": {"vr": "DS", "Value": [22.5]},
        "191": {"vr": "DS", "Value": [22.5]},
        "192": {"vr": "DS", "Value": [20.0]},
        "193": {"vr": "DS", "Value": [20.0]},
        "194": {"vr": "DS", "Value": [22.5]},
        "195": {"vr": "DS", "Value": [20.0]},
        "196": {"vr": "DS", "Value": [20.0]},
        "197": {"vr": "DS", "Value": [20.0]},
        "198": {"vr": "DS", "Value": [20.0]},
        "199": {"vr": "DS", "Value": [20.0]},
        "200": {"vr": "DS", "Value": [22.5]},
        "201": {"vr": "DS", "Value": [20.0]},
        "202": {"vr": "DS", "Value": [22.5]},
        "203": {"vr": "DS", "Value": [22.5]},
        "204": {"vr": "DS", "Value": [22.5]},
        "205": {"vr": "DS", "Value": [20.0]},
        "206": {"vr": "DS", "Value": [20.0]},
        "207": {"vr": "DS", "Value": [22.5]},
        "208": {"vr": "DS", "Value": [20.0]},
        "209": {"vr": "DS", "Value": [20.0]},
        "210": {"vr": "DS", "Value": [20.0]},
        "211": {"vr": "DS", "Value": [20.0]},
        "212": {"vr": "DS", "Value": [22.5]},
        "213": {"vr": "DS", "Value": [20.0]},
        "214": {"vr": "DS", "Value": [22.5]},
        "215": {"vr": "DS", "Value": [20.0]},
        "216": {"vr": "DS", "Value": [22.5]},
        "217": {"vr": "DS", "Value": [20.0]},
        "218": {"vr": "DS", "Value": [22.5]},
        "219": {"vr": "DS", "Value": [22.5]},
        "220": {"vr": "DS", "Value": [20.0]},
        "221": {"vr": "DS", "Value": [20.0]},
        "222": {"vr": "DS", "Value": [20.0]},
        "223": {"vr": "DS", "Value": [22.5]},
        "224": {"vr": "DS", "Value": [22.5]},
        "225": {"vr": "DS", "Value": [22.5]},
        "226": {"vr": "DS", "Value": [20.0]},
        "227": {"vr": "DS", "Value": [22.5]},
        "228": {"vr": "DS", "Value": [22.5]},
        "229": {"vr": "DS", "Value": [20.0]},
        "230": {"vr": "DS", "Value": [20.0]},
        "231": {"vr": "DS", "Value": [20.0]},
        "232": {"vr": "DS", "Value": [22.5]},
        "233": {"vr": "DS", "Value": [22.5]},
        "234": {"vr": "DS", "Value": [22.5]},
        "235": {"vr": "DS", "Value": [20.0]},
        "236": {"vr": "DS", "Value": [20.0]},
        "237": {"vr": "DS", "Value": [22.5]},
        "238": {"vr": "DS", "Value": [20.0]},
        "239": {"vr": "DS", "Value": [20.0]},
        "240": {"vr": "DS", "Value": [22.5]},
        "241": {"vr": "DS", "Value": [22.5]},
        "242": {"vr": "DS", "Value": [22.5]},
        "243": {"vr": "DS", "Value": [22.5]},
        "244": {"vr": "DS", "Value": [20.0]},
        "245": {"vr": "DS", "Value": [22.5]},
        "246": {"vr": "DS", "Value": [20.0]},
        "247": {"vr": "DS", "Value": [22.5]},
        "248": {"vr": "DS", "Value": [22.5]},
        "249": {"vr": "DS", "Value": [20.0]},
        "250": {"vr": "DS", "Value": [22.5]},
        "251": {"vr": "DS", "Value": [20.0]},
        "252": {"vr": "DS", "Value": [20.0]},
        "253": {"vr": "DS", "Value": [22.5]},
        "254": {"vr": "DS", "Value": [22.5]},
        "255": {"vr": "DS", "Value": [22.5]},
        "256": {"vr": "DS", "Value": [20.0]},
        "257": {"vr": "DS", "Value": [22.5]},
        "258": {"vr": "DS", "Value": [22.5]},
        "259": {"vr": "DS", "Value": [22.5]},
        "260": {"vr": "DS", "Value": [20.0]},
        "261": {"vr": "DS", "Value": [22.5]},
        "262": {"vr": "DS", "Value": [20.0]},
        "263": {"vr": "DS", "Value": [22.5]},
        "264": {"vr": "DS", "Value": [22.5]},
        "265": {"vr": "DS", "Value": [22.5]},
        "266": {"vr": "DS", "Value": [20.0]},
        "267": {"vr": "DS", "Value": [20.0]},
        "268": {"vr": "DS", "Value": [22.5]},
        "269": {"vr": "DS", "Value": [22.5]},
        "270": {"vr": "DS", "Value": [22.5]},
        "271": {"vr": "DS", "Value": [22.5]},
        "272": {"vr": "DS", "Value": [22.5]},
        "273": {"vr": "DS", "Value": [20.0]},
        "274": {"vr": "DS", "Value": [22.5]},
        "275": {"vr": "DS", "Value": [22.5]},
        "276": {"vr": "DS", "Value": [22.5]},
        "277": {"vr": "DS", "Value": [22.5]},
        "278": {"vr": "DS", "Value": [22.5]},
        "279": {"vr": "DS", "Value": [22.5]},
        "280": {"vr": "DS", "Value": [20.0]},
        "281": {"vr": "DS", "Value": [22.5]},
        "282": {"vr": "DS", "Value": [20.0]},
        "283": {"vr": "DS", "Value": [20.0]},
        "284": {"vr": "DS", "Value": [20.0]},
        "285": {"vr": "DS", "Value": [22.5]},
        "286": {"vr": "DS", "Value": [22.5]},
        "287": {"vr": "DS", "Value": [22.5]},
        "288": {"vr": "DS", "Value": [20.0]},
        "289": {"vr": "DS", "Value": [22.5]},
        "290": {"vr": "DS", "Value": [20.0]},
        "291": {"vr": "DS", "Value": [20.0]},
        "292": {"vr": "DS", "Value": [22.5]},
        "293": {"vr": "DS", "Value": [22.5]},
        "294": {"vr": "DS", "Value": [22.5]},
        "295": {"vr": "DS", "Value": [20.0]},
        "296": {"vr": "DS", "Value": [20.0]},
        "297": {"vr": "DS", "Value": [20.0]},
        "298": {"vr": "DS", "Value": [20.0]},
        "299": {"vr": "DS", "Value": [22.5]},
        "300": {"vr": "DS", "Value": [20.0]},
        "301": {"vr": "DS", "Value": [22.5]},
        "302": {"vr": "DS", "Value": [22.5]},
        "303": {"vr": "DS", "Value": [20.0]},
        "304": {"vr": "DS", "Value": [20.0]},
        "305": {"vr": "DS", "Value": [22.5]},
        "306": {"vr": "DS", "Value": [22.5]},
        "307": {"vr": "DS", "Value": [20.0]},
        "308": {"vr": "DS", "Value": [20.0]},
        "309": {"vr": "DS", "Value": [22.5]},
        "310": {"vr": "DS", "Value": [22.5]},
        "311": {"vr": "DS", "Value": [20.0]},
        "312": {"vr": "DS", "Value": [22.5]},
        "313": {"vr": "DS", "Value": [20.0]},
        "314": {"vr": "DS", "Value": [20.0]},
        "315": {"vr": "DS", "Value": [20.0]},
        "316": {"vr": "DS", "Value": [20.0]},
        "317": {"vr": "DS", "Value": [22.5]},
        "318": {"vr": "DS", "Value": [20.0]},
        "319": {"vr": "DS", "Value": [22.5]},
        "320": {"vr": "DS", "Value": [22.5]},
        "321": {"vr": "DS", "Value": [22.5]},
        "322": {"vr": "DS", "Value": [22.5]},
        "323": {"vr": "DS", "Value": [20.0]},
        "324": {"vr": "DS", "Value": [22.5]},
        "325": {"vr": "DS", "Value": [20.0]},
        "326": {"vr": "DS", "Value": [22.5]},
        "327": {"vr": "DS", "Value": [22.5]},
        "328": {"vr": "DS", "Value": [20.0]},
        "329": {"vr": "DS", "Value": [20.0]},
        "330": {"vr": "DS", "Value": [22.5]},
        "331": {"vr": "DS", "Value": [20.0]},
        "332": {"vr": "DS", "Value": [20.0]},
        "333": {"vr": "DS", "Value": [22.5]},
        "334": {"vr": "DS", "Value": [20.0]},
        "335": {"vr": "DS", "Value": [22.5]},
        "336": {"vr": "DS", "Value": [22.5]},
        "337": {"vr": "DS", "Value": [22.5]},
        "338": {"vr": "DS", "Value": [22.5]},
        "339": {"vr": "DS", "Value": [22.5]},
        "340": {"vr": "DS", "Value": [20.0]},
        "341": {"vr": "DS", "Value": [20.0]},
        "342": {"vr": "DS", "Value": [22.5]},
        "343": {"vr": "DS", "Value": [20.0]},
        "344": {"vr": "DS", "Value": [22.5]},
        "345": {"vr": "DS", "Value": [22.5]},
        "346": {"vr": "DS", "Value": [22.5]},
        "347": {"vr": "DS", "Value": [20.0]},
        "348": {"vr": "DS", "Value": [22.5]},
        "349": {"vr": "DS", "Value": [22.5]},
        "350": {"vr": "DS", "Value": [22.5]},
        "351": {"vr": "DS", "Value": [20.0]},
        "352": {"vr": "DS", "Value": [22.5]},
        "353": {"vr": "DS", "Value": [20.0]},
        "354": {"vr": "DS", "Value": [22.5]},
        "355": {"vr": "DS", "Value": [22.5]},
        "356": {"vr": "DS", "Value": [22.5]},
        "357": {"vr": "DS", "Value": [22.5]},
        "358": {"vr": "DS", "Value": [20.0]},
        "359": {"vr": "DS", "Value": [20.0]},
        "360": {"vr": "DS", "Value": [20.0]},
        "361": {"vr": "DS", "Value": [22.5]},
        "362": {"vr": "DS", "Value": [22.5]},
        "363": {"vr": "DS", "Value": [22.5]},
        "364": {"vr": "DS", "Value": [20.0]},
        "365": {"vr": "DS", "Value": [20.0]},
        "366": {"vr": "DS", "Value": [22.5]},
        "367": {"vr": "DS", "Value": [22.5]},
        "368": {"vr": "DS", "Value": [22.5]},
        "369": {"vr": "DS", "Value": [22.5]},
        "370": {"vr": "DS", "Value": [20.0]},
        "371": {"vr": "DS", "Value": [20.0]},
        "372": {"vr": "DS", "Value": [20.0]},
        "373": {"vr": "DS", "Value": [22.5]},
        "374": {"vr": "DS", "Value": [20.0]},
        "375": {"vr": "DS", "Value": [22.5]},
        "376": {"vr": "DS", "Value": [22.5]},
        "377": {"vr": "DS", "Value": [22.5]},
        "378": {"vr": "DS", "Value": [20.0]},
        "379": {"vr": "DS", "Value": [20.0]},
        "380": {"vr": "DS", "Value": [22.5]},
        "381": {"vr": "DS", "Value": [22.5]},
        "382": {"vr": "DS", "Value": [20.0]},
        "383": {"vr": "DS", "Value": [22.5]},
        "384": {"vr": "DS", "Value": [22.5]},
        "385": {"vr": "DS", "Value": [20.0]},
        "386": {"vr": "DS", "Value": [22.5]},
        "387": {"vr": "DS", "Value": [22.5]},
        "388": {"vr": "DS", "Value": [20.0]},
        "389": {"vr": "DS", "Value": [20.0]},
        "390": {"vr": "DS", "Value": [22.5]},
        "391": {"vr": "DS", "Value": [22.5]},
        "392": {"vr": "DS", "Value": [22.5]},
        "393": {"vr": "DS", "Value": [22.5]},
        "394": {"vr": "DS", "Value": [22.5]},
        "395": {"vr": "DS", "Value": [20.0]},
        "396": {"vr": "DS", "Value": [20.0]},
        "397": {"vr": "DS", "Value": [20.0]},
        "398": {"vr": "DS", "Value": [22.5]},
        "399": {"vr": "DS", "Value": [22.5]},
        "400": {"vr": "DS", "Value": [20.0]},
        "401": {"vr": "DS", "Value": [20.0]},
        "402": {"vr": "DS", "Value": [22.5]},
        "403": {"vr": "DS", "Value": [20.0]},
        "404": {"vr": "DS", "Value": [20.0]},
        "405": {"vr": "DS", "Value": [22.5]},
        "406": {"vr": "DS", "Value": [20.0]},
        "407": {"vr": "DS", "Value": [22.5]},
        "408": {"vr": "DS", "Value": [22.5]},
        "409": {"vr": "DS", "Value": [20.0]},
        "410": {"vr": "DS", "Value": [22.5]},
        "411": {"vr": "DS", "Value": [20.0]},
        "412": {"vr": "DS", "Value": [20.0]},
        "413": {"vr": "DS", "Value": [22.5]},
        "414": {"vr": "DS", "Value": [20.0]},
        "415": {"vr": "DS", "Value": [22.5]},
        "416": {"vr": "DS", "Value": [20.0]},
        "417": {"vr": "DS", "Value": [22.5]},
        "418": {"vr": "DS", "Value": [22.5]},
        "419": {"vr": "DS", "Value": [22.5]},
        "420": {"vr": "DS", "Value": [22.5]},
        "421": {"vr": "DS", "Value": [20.0]},
        "422": {"vr": "DS", "Value": [20.0]},
        "423": {"vr": "DS", "Value": [22.5]},
        "424": {"vr": "DS", "Value": [22.5]},
        "425": {"vr": "DS", "Value": [22.5]},
        "426": {"vr": "DS", "Value": [20.0]},
        "427": {"vr": "DS", "Value": [20.0]},
        "428": {"vr": "DS", "Value": [20.0]},
        "429": {"vr": "DS", "Value": [20.0]},
        "430": {"vr": "DS", "Value": [22.5]},
        "431": {"vr": "DS", "Value": [22.5]},
        "432": {"vr": "DS", "Value": [20.0]},
        "433": {"vr": "DS", "Value": [22.5]},
        "434": {"vr": "DS", "Value": [20.0]},
        "435": {"vr": "DS", "Value": [22.5]},
        "436": {"vr": "DS", "Value": [22.5]},
        "437": {"vr": "DS", "Value": [20.0]},
        "438": {"vr": "DS", "Value": [22.5]},
        "439": {"vr": "DS", "Value": [20.0]},
        "440": {"vr": "DS", "Value": [22.5]},
        "441": {"vr": "DS", "Value": [22.5]},
        "442": {"vr": "DS", "Value": [22.5]},
        "443": {"vr": "DS", "Value": [22.5]},
        "444": {"vr": "DS", "Value": [22.5]},
        "445": {"vr": "DS", "Value": [22.5]},
        "446": {"vr": "DS", "Value": [20.0]},
        "447": {"vr": "DS", "Value": [22.5]},
        "448": {"vr": "DS", "Value": [22.5]},
        "449": {"vr": "DS", "Value": [22.5]},
        "450": {"vr": "DS", "Value": [20.0]},
        "451": {"vr": "DS", "Value": [22.5]},
        "452": {"vr": "DS", "Value": [22.5]},
        "453": {"vr": "DS", "Value": [22.5]},
        "454": {"vr": "DS", "Value": [20.0]},
        "455": {"vr": "DS", "Value": [20.0]},
        "456": {"vr": "DS", "Value": [22.5]},
        "457": {"vr": "DS", "Value": [20.0]},
        "458": {"vr": "DS", "Value": [20.0]},
        "459": {"vr": "DS", "Value": [20.0]},
        "460": {"vr": "DS", "Value": [22.5]},
        "461": {"vr": "DS", "Value": [22.5]},
        "462": {"vr": "DS", "Value": [22.5]},
        "463": {"vr": "DS", "Value": [20.0]},
        "464": {"vr": "DS", "Value": [20.0]},
        "465": {"vr": "DS", "Value": [20.0]},
        "466": {"vr": "DS", "Value": [22.5]},
        "467": {"vr": "DS", "Value": [22.5]},
        "468": {"vr": "DS", "Value": [20.0]},
        "469": {"vr": "DS", "Value": [22.5]},
        "470": {"vr": "DS", "Value": [22.5]},
        "471": {"vr": "DS", "Value": [20.0]},
        "472": {"vr": "DS", "Value": [20.0]},
        "473": {"vr": "DS", "Value": [22.5]},
        "474": {"vr": "DS", "Value": [22.5]},
        "475": {"vr": "DS", "Value": [22.5]},
        "476": {"vr": "DS", "Value": [20.0]},
        "477": {"vr": "DS", "Value": [22.5]},
        "478": {"vr": "DS", "Value": [20.0]},
        "479": {"vr": "DS", "Value": [22.5]},
        "480": {"vr": "DS", "Value": [20.0]},
        "481": {"vr": "DS", "Value": [22.5]},
        "482": {"vr": "DS", "Value": [22.5]},
        "483": {"vr": "DS", "Value": [20.0]},
        "484": {"vr": "DS", "Value": [20.0]},
        "485": {"vr": "DS", "Value": [22.5]},
        "486": {"vr": "DS", "Value": [20.0]},
        "487": {"vr": "DS", "Value": [20.0]},
        "488": {"vr": "DS", "Value": [20.0]},
        "489": {"vr": "DS", "Value": [22.5]},
        "490": {"vr": "DS", "Value": [20.0]},
        "491": {"vr": "DS", "Value": [20.0]},
        "492": {"vr": "DS", "Value": [22.5]},
        "493": {"vr": "DS", "Value": [20.0]},
        "494": {"vr": "DS", "Value": [20.0]},
        "495": {"vr": "DS", "Value": [20.0]},
        "496": {"vr": "DS", "Value": [20.0]},
        "497": {"vr": "DS", "Value": [20.0]},
        "498": {"vr": "DS", "Value": [22.5]},
        "499": {"vr": "DS", "Value": [20.0]},
        "500": {"vr": "DS", "Value": [20.0]},
        "501": {"vr": "DS", "Value": [20.0]},
        "502": {"vr": "DS", "Value": [22.5]},
        "503": {"vr": "DS", "Value": [20.0]},
        "504": {"vr": "DS", "Value": [20.0]},
        "505": {"vr": "DS", "Value": [22.5]},
        "506": {"vr": "DS", "Value": [22.5]},
        "507": {"vr": "DS", "Value": [20.0]},
        "508": {"vr": "DS", "Value": [22.5]},
        "509": {"vr": "DS", "Value": [22.5]},
        "510": {"vr": "DS", "Value": [20.0]},
        "511": {"vr": "DS", "Value": [20.0]},
        "512": {"vr": "DS", "Value": [22.5]},
        "513": {"vr": "DS", "Value": [22.5]},
        "514": {"vr": "DS", "Value": [22.5]},
        "515": {"vr": "DS", "Value": [20.0]},
        "516": {"vr": "DS", "Value": [20.0]},
        "517": {"vr": "DS", "Value": [22.5]},
        "518": {"vr": "DS", "Value": [20.0]},
        "519": {"vr": "DS", "Value": [20.0]},
        "520": {"vr": "DS", "Value": [20.0]},
        "521": {"vr": "DS", "Value": [22.5]},
        "522": {"vr": "DS", "Value": [20.0]},
        "523": {"vr": "DS", "Value": [20.0]},
        "524": {"vr": "DS", "Value": [20.0]},
        "525": {"vr": "DS", "Value": [22.5]},
        "526": {"vr": "DS", "Value": [20.0]},
        "527": {"vr": "DS", "Value": [22.5]},
        "528": {"vr": "DS", "Value": [22.5]},
        "529": {"vr": "DS", "Value": [20.0]},
        "530": {"vr": "DS", "Value": [22.5]},
        "531": {"vr": "DS", "Value": [22.5]},
        "532": {"vr": "DS", "Value": [20.0]},
        "533": {"vr": "DS", "Value": [22.5]},
        "534": {"vr": "DS", "Value": [20.0]},
        "535": {"vr": "DS", "Value": [20.0]},
        "536": {"vr": "DS", "Value": [22.5]},
        "537": {"vr": "DS", "Value": [20.0]},
        "538": {"vr": "DS", "Value": [20.0]},
        "539": {"vr": "DS", "Value": [20.0]},
        "540": {"vr": "DS", "Value": [22.5]},
        "541": {"vr": "DS", "Value": [22.5]},
        "542": {"vr": "DS", "Value": [22.5]},
        "543": {"vr": "DS", "Value": [22.5]},
        "544": {"vr": "DS", "Value": [22.5]},
        "545": {"vr": "DS", "Value": [22.5]},
        "546": {"vr": "DS", "Value": [22.5]},
        "547": {"vr": "DS", "Value": [22.5]},
        "548": {"vr": "DS", "Value": [22.5]},
        "549": {"vr": "DS", "Value": [20.0]},
        "550": {"vr": "DS", "Value": [22.5]},
        "551": {"vr": "DS", "Value": [22.5]},
        "552": {"vr": "DS", "Value": [20.0]},
        "553": {"vr": "DS", "Value": [20.0]},
        "554": {"vr": "DS", "Value": [22.5]},
        "555": {"vr": "DS", "Value": [22.5]},
        "556": {"vr": "DS", "Value": [20.0]},
        "557": {"vr": "DS", "Value": [20.0]},
        "558": {"vr": "DS", "Value": [20.0]},
        "559": {"vr": "DS", "Value": [20.0]},
        "560": {"vr": "DS", "Value": [22.5]},
        "561": {"vr": "DS", "Value": [20.0]},
        "562": {"vr": "DS", "Value": [22.5]},
        "563": {"vr": "DS", "Value": [22.5]},
        "564": {"vr": "DS", "Value": [20.0]},
        "565": {"vr": "DS", "Value": [20.0]},
        "566": {"vr": "DS", "Value": [22.5]},
        "567": {"vr": "DS", "Value": [20.0]},
        "568": {"vr": "DS", "Value": [20.0]},
        "569": {"vr": "DS", "Value": [22.5]},
        "570": {"vr": "DS", "Value": [20.0]},
        "571": {"vr": "DS", "Value": [20.0]},
        "572": {"vr": "DS", "Value": [20.0]},
        "573": {"vr": "DS", "Value": [20.0]},
        "574": {"vr": "DS", "Value": [22.5]},
        "575": {"vr": "DS", "Value": [22.5]},
        "576": {"vr": "DS", "Value": [22.5]},
        "577": {"vr": "DS", "Value": [20.0]},
        "578": {"vr": "DS", "Value": [22.5]},
        "579": {"vr": "DS", "Value": [22.5]},
        "580": {"vr": "DS", "Value": [22.5]},
        "581": {"vr": "DS", "Value": [20.0]},
        "582": {"vr": "DS", "Value": [20.0]},
        "583": {"vr": "DS", "Value": [20.0]},
        "584": {"vr": "DS", "Value": [22.5]},
        "585": {"vr": "DS", "Value": [20.0]},
        "586": {"vr": "DS", "Value": [22.5]},
        "587": {"vr": "DS", "Value": [20.0]},
        "588": {"vr": "DS", "Value": [22.5]},
        "589": {"vr": "DS", "Value": [20.0]},
        "590": {"vr": "DS", "Value": [22.5]},
        "591": {"vr": "DS", "Value": [22.5]},
        "592": {"vr": "DS", "Value": [20.0]},
        "593": {"vr": "DS", "Value": [22.5]},
        "594": {"vr": "DS", "Value": [20.0]},
        "595": {"vr": "DS", "Value": [22.5]},
        "596": {"vr": "DS", "Value": [22.5]},
        "597": {"vr": "DS", "Value": [22.5]},
        "598": {"vr": "DS", "Value": [22.5]},
        "599": {"vr": "DS", "Value": [22.5]},
        "600": {"vr": "DS", "Value": [22.5]},
        "601": {"vr": "DS", "Value": [22.5]},
        "602": {"vr": "DS", "Value": [22.5]},
        "603": {"vr": "DS", "Value": [20.0]},
        "604": {"vr": "DS", "Value": [20.0]},
        "605": {"vr": "DS", "Value": [20.0]},
        "606": {"vr": "DS", "Value": [20.0]},
        "607": {"vr": "DS", "Value": [20.0]},
        "608": {"vr": "DS", "Value": [20.0]},
        "609": {"vr": "DS", "Value": [20.0]},
        "610": {"vr": "DS", "Value": [20.0]},
        "611": {"vr": "DS", "Value": [20.0]},
        "612": {"vr": "DS", "Value": [22.5]},
        "613": {"vr": "DS", "Value": [20.0]},
        "614": {"vr": "DS", "Value": [22.5]},
        "615": {"vr": "DS", "Value": [22.5]},
        "616": {"vr": "DS", "Value": [20.0]},
        "617": {"vr": "DS", "Value": [20.0]},
        "618": {"vr": "DS", "Value": [22.5]},
        "619": {"vr": "DS", "Value": [22.5]},
        "620": {"vr": "DS", "Value": [22.5]},
        "621": {"vr": "DS", "Value": [22.5]},
        "622": {"vr": "DS", "Value": [20.0]},
        "623": {"vr": "DS", "Value": [22.5]},
        "624": {"vr": "DS", "Value": [20.0]},
        "625": {"vr": "DS", "Value": [22.5]},
        "626": {"vr": "DS", "Value": [22.5]},
        "627": {"vr": "DS", "Value": [20.0]},
        "628": {"vr": "DS", "Value": [22.5]},
        "629": {"vr": "DS", "Value": [20.0]},
        "630": {"vr": "DS", "Value": [22.5]},
        "631": {"vr": "DS", "Value": [22.5]},
        "632": {"vr": "DS", "Value": [22.5]},
        "633": {"vr": "DS", "Value": [22.5]},
        "634": {"vr": "DS", "Value": [20.0]},
        "635": {"vr": "DS", "Value": [20.0]},
        "636": {"vr": "DS", "Value": [20.0]},
        "637": {"vr": "DS", "Value": [22.5]},
        "638": {"vr": "DS", "Value": [20.0]},
        "639": {"vr": "DS", "Value": [20.0]},
        "640": {"vr": "DS", "Value": [22.5]},
        "641": {"vr": "DS", "Value": [20.0]},
        "642": {"vr": "DS", "Value": [20.0]},
        "643": {"vr": "DS", "Value": [22.5]},
        "644": {"vr": "DS", "Value": [22.5]},
        "645": {"vr": "DS", "Value": [22.5]},
        "646": {"vr": "DS", "Value": [22.5]},
        "647": {"vr": "DS", "Value": [22.5]},
        "648": {"vr": "DS", "Value": [22.5]},
        "649": {"vr": "DS", "Value": [22.5]},
        "650": {"vr": "DS", "Value": [20.0]},
        "651": {"vr": "DS", "Value": [22.5]},
        "652": {"vr": "DS", "Value": [20.0]},
        "653": {"vr": "DS", "Value": [20.0]},
        "654": {"vr": "DS", "Value": [22.5]},
        "655": {"vr": "DS", "Value": [22.5]},
        "656": {"vr": "DS", "Value": [20.0]},
        "657": {"vr": "DS", "Value": [20.0]},
        "658": {"vr": "DS", "Value": [22.5]},
        "659": {"vr": "DS", "Value": [22.5]},
        "660": {"vr": "DS", "Value": [20.0]},
        "661": {"vr": "DS", "Value": [22.5]},
        "662": {"vr": "DS", "Value": [20.0]},
        "663": {"vr": "DS", "Value": [22.5]},
        "664": {"vr": "DS", "Value": [22.5]},
        "665": {"vr": "DS", "Value": [22.5]},
        "666": {"vr": "DS", "Value": [22.5]},
        "667": {"vr": "DS", "Value": [20.0]},
        "668": {"vr": "DS", "Value": [20.0]},
        "669": {"vr": "DS", "Value": [20.0]},
        "670": {"vr": "DS", "Value": [20.0]},
        "671": {"vr": "DS", "Value": [20.0]},
        "672": {"vr": "DS", "Value": [22.5]},
        "673": {"vr": "DS", "Value": [20.0]},
        "674": {"vr": "DS", "Value": [20.0]},
        "675": {"vr": "DS", "Value": [20.0]},
        "676": {"vr": "DS", "Value": [22.5]},
        "677": {"vr": "DS", "Value": [20.0]},
        "678": {"vr": "DS", "Value": [20.0]},
        "679": {"vr": "DS", "Value": [20.0]},
        "680": {"vr": "DS", "Value": [20.0]},
        "681": {"vr": "DS", "Value": [20.0]},
        "682": {"vr": "DS", "Value": [22.5]},
        "683": {"vr": "DS", "Value": [22.5]},
        "684": {"vr": "DS", "Value": [22.5]},
        "685": {"vr": "DS", "Value": [22.5]},
        "686": {"vr": "DS", "Value": [20.0]},
        "687": {"vr": "DS", "Value": [22.5]},
        "688": {"vr": "DS", "Value": [22.5]},
        "689": {"vr": "DS", "Value": [20.0]},
        "690": {"vr": "DS", "Value": [20.0]},
        "691": {"vr": "DS", "Value": [22.5]},
        "692": {"vr": "DS", "Value": [20.0]},
        "693": {"vr": "DS", "Value": [20.0]},
        "694": {"vr": "DS", "Value": [22.5]},
        "695": {"vr": "DS", "Value": [22.5]},
        "696": {"vr": "DS", "Value": [22.5]},
        "697": {"vr": "DS", "Value": [22.5]},
        "698": {"vr": "DS", "Value": [22.5]},
        "699": {"vr": "DS", "Value": [22.5]},
        "700": {"vr": "DS", "Value": [20.0]},
        "701": {"vr": "DS", "Value": [20.0]},
        "702": {"vr": "DS", "Value": [20.0]},
        "703": {"vr": "DS", "Value": [20.0]},
        "704": {"vr": "DS", "Value": [20.0]},
        "705": {"vr": "DS", "Value": [20.0]},
        "706": {"vr": "DS", "Value": [22.5]},
        "707": {"vr": "DS", "Value": [20.0]},
        "708": {"vr": "DS", "Value": [20.0]},
        "709": {"vr": "DS", "Value": [20.0]},
        "710": {"vr": "DS", "Value": [20.0]},
        "711": {"vr": "DS", "Value": [20.0]},
        "712": {"vr": "DS", "Value": [22.5]},
        "713": {"vr": "DS", "Value": [22.5]},
        "714": {"vr": "DS", "Value": [22.5]},
        "715": {"vr": "DS", "Value": [20.0]},
        "716": {"vr": "DS", "Value": [20.0]},
        "717": {"vr": "DS", "Value": [20.0]},
        "718": {"vr": "DS", "Value": [20.0]},
        "719": {"vr": "DS", "Value": [22.5]},
        "720": {"vr": "DS", "Value": [20.0]},
        "721": {"vr": "DS", "Value": [22.5]},
        "722": {"vr": "DS", "Value": [20.0]},
        "723": {"vr": "DS", "Value": [22.5]},
        "724": {"vr": "DS", "Value": [20.0]},
        "725": {"vr": "DS", "Value": [22.5]},
        "726": {"vr": "DS", "Value": [20.0]},
        "727": {"vr": "DS", "Value": [22.5]},
        "728": {"vr": "DS", "Value": [22.5]},
        "729": {"vr": "DS", "Value": [20.0]},
        "730": {"vr": "DS", "Value": [22.5]},
        "731": {"vr": "DS", "Value": [20.0]},
        "732": {"vr": "DS", "Value": [22.5]},
        "733": {"vr": "DS", "Value": [22.5]},
        "734": {"vr": "DS", "Value": [22.5]},
        "735": {"vr": "DS", "Value": [20.0]},
        "736": {"vr": "DS", "Value": [22.5]},
        "737": {"vr": "DS", "Value": [20.0]},
        "738": {"vr": "DS", "Value": [22.5]},
        "739": {"vr": "DS", "Value": [22.5]},
        "740": {"vr": "DS", "Value": [20.0]},
        "741": {"vr": "DS", "Value": [22.5]},
        "742": {"vr": "DS", "Value": [20.0]},
        "743": {"vr": "DS", "Value": [20.0]},
        "744": {"vr": "DS", "Value": [22.5]},
        "745": {"vr": "DS", "Value": [20.0]},
        "746": {"vr": "DS", "Value": [20.0]},
        "747": {"vr": "DS", "Value": [22.5]},
        "748": {"vr": "DS", "Value": [22.5]},
        "749": {"vr": "DS", "Value": [22.5]},
        "750": {"vr": "DS", "Value": [20.0]},
        "751": {"vr": "DS", "Value": [20.0]},
        "752": {"vr": "DS", "Value": [22.5]},
        "753": {"vr": "DS", "Value": [22.5]},
        "754": {"vr": "DS", "Value": [20.0]},
        "755": {"vr": "DS", "Value": [20.0]},
        "756": {"vr": "DS", "Value": [20.0]},
        "757": {"vr": "DS", "Value": [22.5]},
        "758": {"vr": "DS", "Value": [22.5]},
        "759": {"vr": "DS", "Value": [22.5]},
        "760": {"vr": "DS", "Value": [20.0]},
        "761": {"vr": "DS", "Value": [22.5]},
        "762": {"vr": "DS", "Value": [20.0]},
        "763": {"vr": "DS", "Value": [20.0]},
        "764": {"vr": "DS", "Value": [20.0]},
        "765": {"vr": "DS", "Value": [20.0]},
        "766": {"vr": "DS", "Value": [20.0]},
        "767": {"vr": "DS", "Value": [20.0]},
        "768": {"vr": "DS", "Value": [22.5]},
        "769": {"vr": "DS", "Value": [22.5]},
        "770": {"vr": "DS", "Value": [22.5]},
        "771": {"vr": "DS", "Value": [22.5]},
        "772": {"vr": "DS", "Value": [22.5]},
        "773": {"vr": "DS", "Value": [22.5]},
        "774": {"vr": "DS", "Value": [20.0]},
        "775": {"vr": "DS", "Value": [20.0]},
        "776": {"vr": "DS", "Value": [22.5]},
        "777": {"vr": "DS", "Value": [20.0]},
        "778": {"vr": "DS", "Value": [22.5]},
        "779": {"vr": "DS", "Value": [20.0]},
        "780": {"vr": "DS", "Value": [20.0]},
        "781": {"vr": "DS", "Value": [22.5]},
        "782": {"vr": "DS", "Value": [20.0]},
        "783": {"vr": "DS", "Value": [22.5]},
        "784": {"vr": "DS", "Value": [22.5]},
        "785": {"vr": "DS", "Value": [22.5]},
        "786": {"vr": "DS", "Value": [20.0]},
        "787": {"vr": "DS", "Value": [20.0]},
        "788": {"vr": "DS", "Value": [22.5]},
        "789": {"vr": "DS", "Value": [22.5]},
        "790": {"vr": "DS", "Value": [22.5]},
        "791": {"vr": "DS", "Value": [20.0]},
        "792": {"vr": "DS", "Value": [22.5]},
        "793": {"vr": "DS", "Value": [20.0]},
        "794": {"vr": "DS", "Value": [22.5]},
        "795": {"vr": "DS", "Value": [22.5]},
        "796": {"vr": "DS", "Value": [22.5]},
        "797": {"vr": "DS", "Value": [20.0]},
        "798": {"vr": "DS", "Value": [22.5]},
        "799": {"vr": "DS", "Value": [22.5]},
        "800": {"vr": "DS", "Value": [22.5]},
        "801": {"vr": "DS", "Value": [20.0]},
        "802": {"vr": "DS", "Value": [22.5]},
        "803": {"vr": "DS", "Value": [20.0]},
        "804": {"vr": "DS", "Value": [22.5]},
        "805": {"vr": "DS", "Value": [22.5]},
        "806": {"vr": "DS", "Value": [22.5]},
        "807": {"vr": "DS", "Value": [20.0]},
        "808": {"vr": "DS", "Value": [22.5]},
        "809": {"vr": "DS", "Value": [20.0]},
        "810": {"vr": "DS", "Value": [22.5]},
        "811": {"vr": "DS", "Value": [22.5]},
        "812": {"vr": "DS", "Value": [22.5]},
        "813": {"vr": "DS", "Value": [20.0]},
        "814": {"vr": "DS", "Value": [20.0]},
        "815": {"vr": "DS", "Value": [22.5]},
        "816": {"vr": "DS", "Value": [20.0]},
        "817": {"vr": "DS", "Value": [20.0]},
        "818": {"vr": "DS", "Value": [20.0]},
        "819": {"vr": "DS", "Value": [22.5]},
        "820": {"vr": "DS", "Value": [20.0]},
        "821": {"vr": "DS", "Value": [20.0]},
        "822": {"vr": "DS", "Value": [22.5]},
        "823": {"vr": "DS", "Value": [20.0]},
        "824": {"vr": "DS", "Value": [20.0]},
        "825": {"vr": "DS", "Value": [22.5]},
        "826": {"vr": "DS", "Value": [22.5]},
        "827": {"vr": "DS", "Value": [22.5]},
        "828": {"vr": "DS", "Value": [22.5]},
        "829": {"vr": "DS", "Value": [22.5]},
        "830": {"vr": "DS", "Value": [20.0]},
        "831": {"vr": "DS", "Value": [22.5]},
        "832": {"vr": "DS", "Value": [22.5]},
        "833": {"vr": "DS", "Value": [22.5]},
        "834": {"vr": "DS", "Value": [20.0]},
        "835": {"vr": "DS", "Value": [20.0]},
        "836": {"vr": "DS", "Value": [20.0]},
        "837": {"vr": "DS", "Value": [22.5]},
        "838": {"vr": "DS", "Value": [20.0]},
        "839": {"vr": "DS", "Value": [20.0]},
        "840": {"vr": "DS", "Value": [20.0]},
        "841": {"vr": "DS", "Value": [22.5]},
        "842": {"vr": "DS", "Value": [22.5]},
        "843": {"vr": "DS", "Value": [22.5]},
        "844": {"vr": "DS", "Value": [20.0]},
        "845": {"vr": "DS", "Value": [20.0]},
        "846": {"vr": "DS", "Value": [22.5]},
        "847": {"vr": "DS", "Value": [20.0]},
        "848": {"vr": "DS", "Value": [20.0]},
        "849": {"vr": "DS", "Value": [22.5]},
        "850": {"vr": "DS", "Value": [20.0]},
        "851": {"vr": "DS", "Value": [22.5]},
        "852": {"vr": "DS", "Value": [20.0]},
        "853": {"vr": "DS", "Value": [20.0]},
        "854": {"vr": "DS", "Value": [22.5]},
        "855": {"vr": "DS", "Value": [22.5]},
        "856": {"vr": "DS", "Value": [20.0]},
        "857": {"vr": "DS", "Value": [22.5]},
        "858": {"vr": "DS", "Value": [20.0]},
        "859": {"vr": "DS", "Value": [20.0]},
        "860": {"vr": "DS", "Value": [20.0]},
        "861": {"vr": "DS", "Value": [22.5]},
        "862": {"vr": "DS", "Value": [20.0]},
        "863": {"vr": "DS", "Value": [20.0]},
        "864": {"vr": "DS", "Value": [20.0]},
        "865": {"vr": "DS", "Value": [20.0]},
        "866": {"vr": "DS", "Value": [22.5]},
        "867": {"vr": "DS", "Value": [22.5]},
        "868": {"vr": "DS", "Value": [22.5]},
        "869": {"vr": "DS", "Value": [20.0]},
        "870": {"vr": "DS", "Value": [22.5]},
        "871": {"vr": "DS", "Value": [22.5]},
        "872": {"vr": "DS", "Value": [20.0]},
        "873": {"vr": "DS", "Value": [22.5]},
        "874": {"vr": "DS", "Value": [20.0]},
        "875": {"vr": "DS", "Value": [20.0]},
        "876": {"vr": "DS", "Value": [20.0]},
        "877": {"vr": "DS", "Value": [22.5]},
        "878": {"vr": "DS", "Value": [20.0]},
        "879": {"vr": "DS", "Value": [20.0]},
        "880": {"vr": "DS", "Value": [22.5]},
        "881": {"vr": "DS", "Value": [20.0]},
        "882": {"vr": "DS", "Value": [22.5]},
        "883": {"vr": "DS", "Value": [22.5]},
        "884": {"vr": "DS", "Value": [22.5]},
        "885": {"vr": "DS", "Value": [22.5]},
        "886": {"vr": "DS", "Value": [22.5]},
        "887": {"vr": "DS", "Value": [22.5]},
        "888": {"vr": "DS", "Value": [22.5]},
        "889": {"vr": "DS", "Value": [20.0]},
        "890": {"vr": "DS", "Value": [20.0]},
        "891": {"vr": "DS", "Value": [22.5]},
        "892": {"vr": "DS", "Value": [20.0]},
        "893": {"vr": "DS", "Value": [20.0]},
        "894": {"vr": "DS", "Value": [20.0]},
        "895": {"vr": "DS", "Value": [22.5]},
        "896": {"vr": "DS", "Value": [20.0]},
        "897": {"vr": "DS", "Value": [20.0]},
        "898": {"vr": "DS", "Value": [22.5]},
        "899": {"vr": "DS", "Value": [22.5]},
        "900": {"vr": "DS", "Value": [22.5]},
        "901": {"vr": "DS", "Value": [20.0]},
        "902": {"vr": "DS", "Value": [20.0]},
        "903": {"vr": "DS", "Value": [20.0]},
        "904": {"vr": "DS", "Value": [22.5]},
        "905": {"vr": "DS", "Value": [22.5]},
        "906": {"vr": "DS", "Value": [22.5]},
        "907": {"vr": "DS", "Value": [22.5]},
        "908": {"vr": "DS", "Value": [22.5]},
        "909": {"vr": "DS", "Value": [20.0]},
        "910": {"vr": "DS", "Value": [22.5]},
        "911": {"vr": "DS", "Value": [22.5]},
        "912": {"vr": "DS", "Value": [22.5]},
        "913": {"vr": "DS", "Value": [22.5]},
        "914": {"vr": "DS", "Value": [20.0]},
        "915": {"vr": "DS", "Value": [22.5]},
        "916": {"vr": "DS", "Value": [22.5]},
        "917": {"vr": "DS", "Value": [20.0]},
        "918": {"vr": "DS", "Value": [20.0]},
        "919": {"vr": "DS", "Value": [22.5]},
        "920": {"vr": "DS", "Value": [22.5]},
        "921": {"vr": "DS", "Value": [22.5]},
        "922": {"vr": "DS", "Value": [22.5]},
        "923": {"vr": "DS", "Value": [20.0]},
        "924": {"vr": "DS", "Value": [20.0]},
        "925": {"vr": "DS", "Value": [22.5]},
        "926": {"vr": "DS", "Value": [22.5]},
        "927": {"vr": "DS", "Value": [22.5]},
        "928": {"vr": "DS", "Value": [22.5]},
        "929": {"vr": "DS", "Value": [22.5]},
        "930": {"vr": "DS", "Value": [22.5]},
        "931": {"vr": "DS", "Value": [22.5]},
        "932": {"vr": "DS", "Value": [20.0]},
        "933": {"vr": "DS", "Value": [22.5]},
        "934": {"vr": "DS", "Value": [22.5]},
        "935": {"vr": "DS", "Value": [20.0]},
        "936": {"vr": "DS", "Value": [22.5]},
        "937": {"vr": "DS", "Value": [20.0]},
        "938": {"vr": "DS", "Value": [22.5]},
        "939": {"vr": "DS", "Value": [20.0]},
        "940": {"vr": "DS", "Value": [20.0]},
        "941": {"vr": "DS", "Value": [22.5]},
        "942": {"vr": "DS", "Value": [22.5]},
        "943": {"vr": "DS", "Value": [22.5]},
        "944": {"vr": "DS", "Value": [20.0]},
        "945": {"vr": "DS", "Value": [20.0]},
        "946": {"vr": "DS", "Value": [22.5]},
        "947": {"vr": "DS", "Value": [20.0]},
        "948": {"vr": "DS", "Value": [20.0]},
        "949": {"vr": "DS", "Value": [22.5]},
        "950": {"vr": "DS", "Value": [20.0]},
        "951": {"vr": "DS", "Value": [20.0]},
        "952": {"vr": "DS", "Value": [20.0]},
        "953": {"vr": "DS", "Value": [22.5]},
        "954": {"vr": "DS", "Value": [22.5]},
        "955": {"vr": "DS", "Value": [20.0]},
        "956": {"vr": "DS", "Value": [22.5]},
        "957": {"vr": "DS", "Value": [22.5]},
        "958": {"vr": "DS", "Value": [22.5]},
        "959": {"vr": "DS", "Value": [22.5]},
        "960": {"vr": "DS", "Value": [20.0]},
        "961": {"vr": "DS", "Value": [22.5]},
        "962": {"vr": "DS", "Value": [20.0]},
        "963": {"vr": "DS", "Value": [20.0]},
        "964": {"vr": "DS", "Value": [22.5]},
        "965": {"vr": "DS", "Value": [22.5]},
        "966": {"vr": "DS", "Value": [22.5]},
        "967": {"vr": "DS", "Value": [22.5]},
        "968": {"vr": "DS", "Value": [22.5]},
        "969": {"vr": "DS", "Value": [22.5]},
        "970": {"vr": "DS", "Value": [20.0]},
        "971": {"vr": "DS", "Value": [22.5]},
        "972": {"vr": "DS", "Value": [20.0]},
        "973": {"vr": "DS", "Value": [20.0]},
        "974": {"vr": "DS", "Value": [22.5]},
        "975": {"vr": "DS", "Value": [20.0]},
        "976": {"vr": "DS", "Value": [22.5]},
        "977": {"vr": "DS", "Value": [22.5]},
        "978": {"vr": "DS", "Value": [22.5]},
        "979": {"vr": "DS", "Value": [22.5]},
        "980": {"vr": "DS", "Value": [22.5]},
        "981": {"vr": "DS", "Value": [20.0]},
        "982": {"vr": "DS", "Value": [22.5]},
        "983": {"vr": "DS", "Value": [20.0]},
        "984": {"vr": "DS", "Value": [22.5]},
        "985": {"vr": "DS", "Value": [22.5]},
        "986": {"vr": "DS", "Value": [20.0]},
        "987": {"vr": "DS", "Value": [20.0]},
        "988": {"vr": "DS", "Value": [20.0]},
        "989": {"vr": "DS", "Value": [20.0]},
        "990": {"vr": "DS", "Value": [22.5]},
        "991": {"vr": "DS", "Value": [20.0]},
        "992": {"vr": "DS", "Value": [22.5]},
        "993": {"vr": "DS", "Value": [20.0]},
        "994": {"vr": "DS", "Value": [22.5]},
        "995": {"vr": "DS", "Value": [22.5]},
        "996": {"vr": "DS", "Value": [22.5]},
        "997": {"vr": "DS", "Value": [20.0]},
        "998": {"vr": "DS", "Value": [20.0]},
        "999": {"vr": "DS", "Value": [20.0]},
        "1000": {"vr": "DS", "Value": [20.0]},
        "1001": {"vr": "DS", "Value": [22.5]},
        "1002": {"vr": "DS", "Value": [22.5]},
        "1003": {"vr": "DS", "Value": [22.5]},
        "1004": {"vr": "DS", "Value": [22.5]},
        "1005": {"vr": "DS", "Value": [20.0]},
        "1006": {"vr": "DS", "Value": [20.0]},
        "1007": {"vr": "DS", "Value": [20.0]},
        "1008": {"vr": "DS", "Value": [20.0]},
        "1009": {"vr": "DS", "Value": [20.0]},
        "1010": {"vr": "DS", "Value": [20.0]},
        "1011": {"vr": "DS", "Value": [20.0]},
        "1012": {"vr": "DS", "Value": [20.0]},
        "1013": {"vr": "DS", "Value": [20.0]},
        "1014": {"vr": "DS", "Value": [20.0]},
        "1015": {"vr": "DS", "Value": [20.0]},
        "1016": {"vr": "DS", "Value": [22.5]},
        "1017": {"vr": "DS", "Value": [20.0]},
        "1018": {"vr": "DS", "Value": [20.0]},
        "1019": {"vr": "DS", "Value": [22.5]},
        "1020": {"vr": "DS", "Value": [20.0]},
        "1021": {"vr": "DS", "Value": [20.0]},
        "1022": {"vr": "DS", "Value": [20.0]},
        "1023": {"vr": "DS", "Value": [20.0]},
        "1024": {"vr": "DS", "Value": [20.0]},
        "1025": {"vr": "DS", "Value": [20.0]},
        "1026": {"vr": "DS", "Value": [20.0]},
        "1027": {"vr": "DS", "Value": [22.5]},
        "1028": {"vr": "DS", "Value": [20.0]},
        "1029": {"vr": "DS", "Value": [22.5]},
        "1030": {"vr": "DS", "Value": [20.0]},
        "1031": {"vr": "DS", "Value": [22.5]},
        "1032": {"vr": "DS", "Value": [22.5]},
        "1033": {"vr": "DS", "Value": [22.5]},
        "1034": {"vr": "DS", "Value": [22.5]},
        "1035": {"vr": "DS", "Value": [22.5]},
        "1036": {"vr": "DS", "Value": [22.5]},
        "1037": {"vr": "DS", "Value": [20.0]},
        "1038": {"vr": "DS", "Value": [20.0]},
        "1039": {"vr": "DS", "Value": [22.5]},
        "1040": {"vr": "DS", "Value": [20.0]},
        "1041": {"vr": "DS", "Value": [20.0]},
        "1042": {"vr": "DS", "Value": [22.5]},
        "1043": {"vr": "DS", "Value": [22.5]},
        "1044": {"vr": "DS", "Value": [22.5]},
        "1045": {"vr": "DS", "Value": [20.0]},
        "1046": {"vr": "DS", "Value": [22.5]},
        "1047": {"vr": "DS", "Value": [22.5]},
        "1048": {"vr": "DS", "Value": [22.5]},
        "1049": {"vr": "DS", "Value": [20.0]},
        "1050": {"vr": "DS", "Value": [22.5]},
        "1051": {"vr": "DS", "Value": [22.5]},
        "1052": {"vr": "DS", "Value": [22.5]},
        "1053": {"vr": "DS", "Value": [20.0]},
        "1054": {"vr": "DS", "Value": [22.5]},
        "1055": {"vr": "DS", "Value": [20.0]},
        "1056": {"vr": "DS", "Value": [22.5]},
        "1057": {"vr": "DS", "Value": [20.0]},
        "1058": {"vr": "DS", "Value": [22.5]},
        "1059": {"vr": "DS", "Value": [22.5]},
        "1060": {"vr": "DS", "Value": [20.0]},
        "1061": {"vr": "DS", "Value": [22.5]},
        "1062": {"vr": "DS", "Value": [20.0]},
        "1063": {"vr": "DS", "Value": [22.5]},
        "1064": {"vr": "DS", "Value": [20.0]},
        "1065": {"vr": "DS", "Value": [20.0]},
        "1066": {"vr": "DS", "Value": [20.0]},
        "1067": {"vr": "DS", "Value": [20.0]},
        "1068": {"vr": "DS", "Value": [20.0]},
        "1069": {"vr": "DS", "Value": [22.5]},
        "1070": {"vr": "DS", "Value": [22.5]},
        "1071": {"vr": "DS", "Value": [22.5]},
        "1072": {"vr": "DS", "Value": [22.5]},
        "1073": {"vr": "DS", "Value": [22.5]},
        "1074": {"vr": "DS", "Value": [22.5]},
        "1075": {"vr": "DS", "Value": [20.0]},
        "1076": {"vr": "DS", "Value": [20.0]},
        "1077": {"vr": "DS", "Value": [22.5]},
        "1078": {"vr": "DS", "Value": [22.5]},
        "1079": {"vr": "DS", "Value": [22.5]},
        "1080": {"vr": "DS", "Value": [22.5]},
        "1081": {"vr": "DS", "Value": [20.0]},
        "1082": {"vr": "DS", "Value": [22.5]},
        "1083": {"vr": "DS", "Value": [22.5]},
        "1084": {"vr": "DS", "Value": [22.5]},
        "1085": {"vr": "DS", "Value": [22.5]},
        "1086": {"vr": "DS", "Value": [22.5]},
        "1087": {"vr": "DS", "Value": [22.5]},
        "1088": {"vr": "DS", "Value": [20.0]},
        "1089": {"vr": "DS", "Value": [20.0]},
        "1090": {"vr": "DS", "Value": [20.0]},
        "1091": {"vr": "DS", "Value": [20.0]},
        "1092": {"vr": "DS", "Value": [20.0]},
        "1093": {"vr": "DS", "Value": [22.5]},
        "1094": {"vr": "DS", "Value": [20.0]},
        "1095": {"vr": "DS", "Value": [20.0]},
        "1096": {"vr": "DS", "Value": [22.5]},
        "1097": {"vr": "DS", "Value": [22.5]},
        "1098": {"vr": "DS", "Value": [22.5]},
        "1099": {"vr": "DS", "Value": [20.0]},
        "1100": {"vr": "DS", "Value": [22.5]},
        "1101": {"vr": "DS", "Value": [22.5]},
        "1102": {"vr": "DS", "Value": [22.5]},
        "1103": {"vr": "DS", "Value": [20.0]},
        "1104": {"vr": "DS", "Value": [20.0]},
        "1105": {"vr": "DS", "Value": [22.5]},
        "1106": {"vr": "DS", "Value": [22.5]},
        "1107": {"vr": "DS", "Value": [20.0]},
        "1108": {"vr": "DS", "Value": [20.0]},
        "1109": {"vr": "DS", "Value": [22.5]},
        "1110": {"vr": "DS", "Value": [20.0]},
        "1111": {"vr": "DS", "Value": [20.0]},
        "1112": {"vr": "DS", "Value": [20.0]},
        "1113": {"vr": "DS", "Value": [20.0]},
        "1114": {"vr": "DS", "Value": [20.0]},
        "1115": {"vr": "DS", "Value": [22.5]},
        "1116": {"vr": "DS", "Value": [22.5]},
        "1117": {"vr": "DS", "Value": [20.0]},
        "1118": {"vr": "DS", "Value": [20.0]},
        "1119": {"vr": "DS", "Value": [22.5]},
        "1120": {"vr": "DS", "Value": [22.5]},
        "1121": {"vr": "DS", "Value": [22.5]},
        "1122": {"vr": "DS", "Value": [20.0]},
        "1123": {"vr": "DS", "Value": [20.0]},
        "1124": {"vr": "DS", "Value": [22.5]},
        "1125": {"vr": "DS", "Value": [22.5]},
        "1126": {"vr": "DS", "Value": [22.5]},
        "1127": {"vr": "DS", "Value": [22.5]},
        "1128": {"vr": "DS", "Value": [20.0]},
        "1129": {"vr": "DS", "Value": [20.0]},
        "1130": {"vr": "DS", "Value": [20.0]},
        "1131": {"vr": "DS", "Value": [20.0]},
        "1132": {"vr": "DS", "Value": [22.5]},
        "1133": {"vr": "DS", "Value": [22.5]},
        "1134": {"vr": "DS", "Value": [20.0]},
        "1135": {"vr": "DS", "Value": [20.0]},
        "1136": {"vr": "DS", "Value": [20.0]},
        "1137": {"vr": "DS", "Value": [22.5]},
        "1138": {"vr": "DS", "Value": [20.0]},
        "1139": {"vr": "DS", "Value": [22.5]},
        "1140": {"vr": "DS", "Value": [22.5]},
        "1141": {"vr": "DS", "Value": [22.5]},
        "1142": {"vr": "DS", "Value": [22.5]},
        "1143": {"vr": "DS", "Value": [20.0]},
        "1144": {"vr": "DS", "Value": [22.5]},
        "1145": {"vr": "DS", "Value": [22.5]},
        "1146": {"vr": "DS", "Value": [22.5]},
        "1147": {"vr": "DS", "Value": [22.5]},
        "1148": {"vr": "DS", "Value": [22.5]},
        "1149": {"vr": "DS", "Value": [22.5]},
        "1150": {"vr": "DS", "Value": [20.0]},
        "1151": {"vr": "DS", "Value": [20.0]},
        "1152": {"vr": "DS", "Value": [22.5]},
        "1153": {"vr": "DS", "Value": [20.0]},
        "1154": {"vr": "DS", "Value": [20.0]},
        "1155": {"vr": "DS", "Value": [20.0]},
        "1156": {"vr": "DS", "Value": [22.5]},
        "1157": {"vr": "DS", "Value": [22.5]},
        "1158": {"vr": "DS", "Value": [22.5]},
        "1159": {"vr": "DS", "Value": [20.0]},
        "1160": {"vr": "DS", "Value": [20.0]},
        "1161": {"vr": "DS", "Value": [20.0]},
        "1162": {"vr": "DS", "Value": [20.0]},
        "1163": {"vr": "DS", "Value": [22.5]},
        "1164": {"vr": "DS", "Value": [22.5]},
        "1165": {"vr": "DS", "Value": [22.5]},
        "1166": {"vr": "DS", "Value": [20.0]},
        "1167": {"vr": "DS", "Value": [20.0]},
        "1168": {"vr": "DS", "Value": [22.5]},
        "1169": {"vr": "DS", "Value": [22.5]},
        "1170": {"vr": "DS", "Value": [22.5]},
        "1171": {"vr": "DS", "Value": [22.5]},
        "1172": {"vr": "DS", "Value": [20.0]},
        "1173": {"vr": "DS", "Value": [20.0]},
        "1174": {"vr": "DS", "Value": [20.0]},
        "1175": {"vr": "DS", "Value": [22.5]},
        "1176": {"vr": "DS", "Value": [22.5]},
        "1177": {"vr": "DS", "Value": [22.5]},
        "1178": {"vr": "DS", "Value": [22.5]},
        "1179": {"vr": "DS", "Value": [20.0]},
        "1180": {"vr": "DS", "Value": [20.0]},
        "1181": {"vr": "DS", "Value": [22.5]},
        "1182": {"vr": "DS", "Value": [22.5]},
        "1183": {"vr": "DS", "Value": [22.5]},
        "1184": {"vr": "DS", "Value": [20.0]},
        "1185": {"vr": "DS", "Value": [22.5]},
        "1186": {"vr": "DS", "Value": [22.5]},
        "1187": {"vr": "DS", "Value": [22.5]},
        "1188": {"vr": "DS", "Value": [20.0]},
        "1189": {"vr": "DS", "Value": [20.0]},
        "1190": {"vr": "DS", "Value": [22.5]},
        "1191": {"vr": "DS", "Value": [20.0]},
        "1192": {"vr": "DS", "Value": [22.5]},
        "1193": {"vr": "DS", "Value": [20.0]},
        "1194": {"vr": "DS", "Value": [22.5]},
        "1195": {"vr": "DS", "Value": [22.5]},
        "1196": {"vr": "DS", "Value": [20.0]},
        "1197": {"vr": "DS", "Value": [22.5]},
        "1198": {"vr": "DS", "Value": [20.0]},
        "1199": {"vr": "DS", "Value": [20.0]},
        "1200": {"vr": "DS", "Value": [22.5]},
        "1201": {"vr": "DS", "Value": [20.0]},
        "1202": {"vr": "DS", "Value": [22.5]},
        "1203": {"vr": "DS", "Value": [20.0]},
        "1204": {"vr": "DS", "Value": [22.5]},
        "1205": {"vr": "DS", "Value": [22.5]},
        "1206": {"vr": "DS", "Value": [22.5]},
        "1207": {"vr": "DS", "Value": [20.0]},
        "1208": {"vr": "DS", "Value": [22.5]},
        "1209": {"vr": "DS", "Value": [20.0]},
        "1210": {"vr": "DS", "Value": [22.5]},
        "1211": {"vr": "DS", "Value": [22.5]},
        "1212": {"vr": "DS", "Value": [20.0]},
        "1213": {"vr": "DS", "Value": [20.0]},
        "1214": {"vr": "DS", "Value": [20.0]},
        "1215": {"vr": "DS", "Value": [22.5]},
        "1216": {"vr": "DS", "Value": [20.0]},
        "1217": {"vr": "DS", "Value": [20.0]},
        "1218": {"vr": "DS", "Value": [22.5]},
        "1219": {"vr": "DS", "Value": [20.0]},
        "1220": {"vr": "DS", "Value": [20.0]},
        "1221": {"vr": "DS", "Value": [20.0]},
        "1222": {"vr": "DS", "Value": [22.5]},
        "1223": {"vr": "DS", "Value": [20.0]},
        "1224": {"vr": "DS", "Value": [20.0]},
        "1225": {"vr": "DS", "Value": [22.5]},
        "1226": {"vr": "DS", "Value": [22.5]},
        "1227": {"vr": "DS", "Value": [20.0]},
        "1228": {"vr": "DS", "Value": [20.0]},
        "1229": {"vr": "DS", "Value": [22.5]},
        "1230": {"vr": "DS", "Value": [22.5]},
        "1231": {"vr": "DS", "Value": [20.0]},
        "1232": {"vr": "DS", "Value": [22.5]},
        "1233": {"vr": "DS", "Value": [22.5]},
        "1234": {"vr": "DS", "Value": [22.5]},
        "1235": {"vr": "DS", "Value": [20.0]},
        "1236": {"vr": "DS", "Value": [22.5]},
        "1237": {"vr": "DS", "Value": [20.0]},
        "1238": {"vr": "DS", "Value": [22.5]},
        "1239": {"vr": "DS", "Value": [22.5]},
        "1240": {"vr": "DS", "Value": [20.0]},
        "1241": {"vr": "DS", "Value": [20.0]},
        "1242": {"vr": "DS", "Value": [22.5]},
        "1243": {"vr": "DS", "Value": [22.5]},
        "1244": {"vr": "DS", "Value": [20.0]},
        "1245": {"vr": "DS", "Value": [22.5]},
        "1246": {"vr": "DS", "Value": [22.5]},
        "1247": {"vr": "DS", "Value": [22.5]},
        "1248": {"vr": "DS", "Value": [22.5]},
        "1249": {"vr": "DS", "Value": [22.5]},
        "1250": {"vr": "DS", "Value": [22.5]},
        "1251": {"vr": "DS", "Value": [22.5]},
        "1252": {"vr": "DS", "Value": [20.0]},
        "1253": {"vr": "DS", "Value": [22.5]},
        "1254": {"vr": "DS", "Value": [22.5]},
        "1255": {"vr": "DS", "Value": [22.5]},
        "1256": {"vr": "DS", "Value": [22.5]},
        "1257": {"vr": "DS", "Value": [22.5]},
        "1258": {"vr": "DS", "Value": [20.0]},
        "1259": {"vr": "DS", "Value": [22.5]},
        "1260": {"vr": "DS", "Value": [22.5]},
        "1261": {"vr": "DS", "Value": [20.0]},
        "1262": {"vr": "DS", "Value": [20.0]},
        "1263": {"vr": "DS", "Value": [22.5]},
        "1264": {"vr": "DS", "Value": [20.0]},
        "1265": {"vr": "DS", "Value": [22.5]},
        "1266": {"vr": "DS", "Value": [22.5]},
        "1267": {"vr": "DS", "Value": [22.5]},
        "1268": {"vr": "DS", "Value": [22.5]},
        "1269": {"vr": "DS", "Value": [20.0]},
        "1270": {"vr": "DS", "Value": [20.0]},
        "1271": {"vr": "DS", "Value": [20.0]},
        "1272": {"vr": "DS", "Value": [22.5]},
        "1273": {"vr": "DS", "Value": [22.5]},
        "1274": {"vr": "DS", "Value": [22.5]},
        "1275": {"vr": "DS", "Value": [20.0]},
        "1276": {"vr": "DS", "Value": [22.5]},
        "1277": {"vr": "DS", "Value": [22.5]},
        "1278": {"vr": "DS", "Value": [20.0]},
        "1279": {"vr": "DS", "Value": [22.5]},
        "1280": {"vr": "DS", "Value": [20.0]},
        "1281": {"vr": "DS", "Value": [20.0]},
        "1282": {"vr": "DS", "Value": [20.0]},
        "1283": {"vr": "DS", "Value": [20.0]},
        "1284": {"vr": "DS", "Value": [20.0]},
        "1285": {"vr": "DS", "Value": [22.5]},
        "1286": {"vr": "DS", "Value": [22.5]},
        "1287": {"vr": "DS", "Value": [22.5]},
        "1288": {"vr": "DS", "Value": [22.5]},
        "1289": {"vr": "DS", "Value": [20.0]},
        "1290": {"vr": "DS", "Value": [22.5]},
        "1291": {"vr": "DS", "Value": [22.5]},
        "1292": {"vr": "DS", "Value": [22.5]},
        "1293": {"vr": "DS", "Value": [20.0]},
        "1294": {"vr": "DS", "Value": [22.5]},
        "1295": {"vr": "DS", "Value": [22.5]},
        "1296": {"vr": "DS", "Value": [22.5]},
        "1297": {"vr": "DS", "Value": [20.0]},
        "1298": {"vr": "DS", "Value": [20.0]},
        "1299": {"vr": "DS", "Value": [20.0]},
        "1300": {"vr": "DS", "Value": [22.5]},
        "1301": {"vr": "DS", "Value": [20.0]},
        "1302": {"vr": "DS", "Value": [20.0]},
        "1303": {"vr": "DS", "Value": [22.5]},
        "1304": {"vr": "DS", "Value": [22.5]},
        "1305": {"vr": "DS", "Value": [20.0]},
        "1306": {"vr": "DS", "Value": [20.0]},
        "1307": {"vr": "DS", "Value": [20.0]},
        "1308": {"vr": "DS", "Value": [20.0]},
        "1309": {"vr": "DS", "Value": [22.5]},
        "1310": {"vr": "DS", "Value": [20.0]},
        "1311": {"vr": "DS", "Value": [22.5]},
        "1312": {"vr": "DS", "Value": [20.0]},
        "1313": {"vr": "DS", "Value": [20.0]},
        "1314": {"vr": "DS", "Value": [20.0]},
        "1315": {"vr": "DS", "Value": [22.5]},
        "1316": {"vr": "DS", "Value": [20.0]},
        "1317": {"vr": "DS", "Value": [20.0]},
        "1318": {"vr": "DS", "Value": [20.0]},
        "1319": {"vr": "DS", "Value": [22.5]},
        "1320": {"vr": "DS", "Value": [20.0]},
        "1321": {"vr": "DS", "Value": [20.0]},
        "1322": {"vr": "DS", "Value": [20.0]},
        "1323": {"vr": "DS", "Value": [20.0]},
        "1324": {"vr": "DS", "Value": [22.5]},
        "1325": {"vr": "DS", "Value": [22.5]},
        "1326": {"vr": "DS", "Value": [20.0]},
        "1327": {"vr": "DS", "Value": [20.0]},
        "1328": {"vr": "DS", "Value": [20.0]},
        "1329": {"vr": "DS", "Value": [22.5]},
        "1330": {"vr": "DS", "Value": [22.5]},
        "1331": {"vr": "DS", "Value": [22.5]},
        "1332": {"vr": "DS", "Value": [20.0]},
        "1333": {"vr": "DS", "Value": [22.5]},
        "1334": {"vr": "DS", "Value": [22.5]},
        "1335": {"vr": "DS", "Value": [20.0]},
        "1336": {"vr": "DS", "Value": [22.5]},
        "1337": {"vr": "DS", "Value": [20.0]},
        "1338": {"vr": "DS", "Value": [22.5]},
        "1339": {"vr": "DS", "Value": [22.5]},
        "1340": {"vr": "DS", "Value": [22.5]},
        "1341": {"vr": "DS", "Value": [22.5]},
        "1342": {"vr": "DS", "Value": [22.5]},
        "1343": {"vr": "DS", "Value": [22.5]},
        "1344": {"vr": "DS", "Value": [22.5]},
        "1345": {"vr": "DS", "Value": [22.5]},
        "1346": {"vr": "DS", "Value": [20.0]},
        "1347": {"vr": "DS", "Value": [20.0]},
        "1348": {"vr": "DS", "Value": [22.5]},
        "1349": {"vr": "DS", "Value": [22.5]},
        "1350": {"vr": "DS", "Value": [22.5]},
        "1351": {"vr": "DS", "Value": [22.5]},
        "1352": {"vr": "DS", "Value": [22.5]},
        "1353": {"vr": "DS", "Value": [20.0]},
        "1354": {"vr": "DS", "Value": [22.5]},
        "1355": {"vr": "DS", "Value": [20.0]},
        "1356": {"vr": "DS", "Value": [22.5]},
        "1357": {"vr": "DS", "Value": [20.0]},
        "1358": {"vr": "DS", "Value": [22.5]},
        "1359": {"vr": "DS", "Value": [20.0]},
        "1360": {"vr": "DS", "Value": [22.5]},
        "1361": {"vr": "DS", "Value": [22.5]},
        "1362": {"vr": "DS", "Value": [20.0]},
        "1363": {"vr": "DS", "Value": [22.5]},
        "1364": {"vr": "DS", "Value": [22.5]},
        "1365": {"vr": "DS", "Value": [20.0]},
        "1366": {"vr": "DS", "Value": [22.5]},
        "1367": {"vr": "DS", "Value": [20.0]},
        "1368": {"vr": "DS", "Value": [20.0]},
        "1369": {"vr": "DS", "Value": [20.0]},
        "1370": {"vr": "DS", "Value": [20.0]},
        "1371": {"vr": "DS", "Value": [22.5]},
        "1372": {"vr": "DS", "Value": [20.0]},
        "1373": {"vr": "DS", "Value": [22.5]},
        "1374": {"vr": "DS", "Value": [22.5]},
        "1375": {"vr": "DS", "Value": [22.5]},
        "1376": {"vr": "DS", "Value": [22.5]},
        "1377": {"vr": "DS", "Value": [22.5]},
        "1378": {"vr": "DS", "Value": [20.0]},
        "1379": {"vr": "DS", "Value": [22.5]},
        "1380": {"vr": "DS", "Value": [20.0]},
        "1381": {"vr": "DS", "Value": [20.0]},
        "1382": {"vr": "DS", "Value": [22.5]},
        "1383": {"vr": "DS", "Value": [22.5]},
        "1384": {"vr": "DS", "Value": [20.0]},
        "1385": {"vr": "DS", "Value": [20.0]},
        "1386": {"vr": "DS", "Value": [22.5]},
        "1387": {"vr": "DS", "Value": [22.5]},
        "1388": {"vr": "DS", "Value": [20.0]},
        "1389": {"vr": "DS", "Value": [20.0]},
        "1390": {"vr": "DS", "Value": [22.5]},
        "1391": {"vr": "DS", "Value": [20.0]},
        "1392": {"vr": "DS", "Value": [22.5]},
        "1393": {"vr": "DS", "Value": [20.0]},
        "1394": {"vr": "DS", "Value": [22.5]},
        "1395": {"vr": "DS", "Value": [20.0]},
        "1396": {"vr": "DS", "Value": [20.0]},
        "1397": {"vr": "DS", "Value": [22.5]},
        "1398": {"vr": "DS", "Value": [22.5]},
        "1399": {"vr": "DS", "Value": [20.0]},
        "1400": {"vr": "DS", "Value": [22.5]},
        "1401": {"vr": "DS", "Value": [20.0]},
        "1402": {"vr": "DS", "Value": [22.5]},
        "1403": {"vr": "DS", "Value": [22.5]},
        "1404": {"vr": "DS", "Value": [22.5]},
        "1405": {"vr": "DS", "Value": [22.5]},
        "1406": {"vr": "DS", "Value": [20.0]},
        "1407": {"vr": "DS", "Value": [22.5]},
        "1408": {"vr": "DS", "Value": [22.5]},
        "1409": {"vr": "DS", "Value": [22.5]},
        "1410": {"vr": "DS", "Value": [22.5]},
        "1411": {"vr": "DS", "Value": [20.0]},
        "1412": {"vr": "DS", "Value": [22.5]},
        "1413": {"vr": "DS", "Value": [22.5]},
        "1414": {"vr": "DS", "Value": [20.0]},
        "1415": {"vr": "DS", "Value": [22.5]},
        "1416": {"vr": "DS", "Value": [22.5]},
        "1417": {"vr": "DS", "Value": [22.5]},
        "1418": {"vr": "DS", "Value": [22.5]},
        "1419": {"vr": "DS", "Value": [22.5]},
        "1420": {"vr": "DS", "Value": [22.5]},
        "1421": {"vr": "DS", "Value": [20.0]},
        "1422": {"vr": "DS", "Value": [22.5]},
        "1423": {"vr": "DS", "Value": [22.5]},
        "1424": {"vr": "DS", "Value": [20.0]},
        "1425": {"vr": "DS", "Value": [20.0]},
        "1426": {"vr": "DS", "Value": [22.5]},
        "1427": {"vr": "DS", "Value": [20.0]},
        "1428": {"vr": "DS", "Value": [22.5]},
        "1429": {"vr": "DS", "Value": [22.5]},
        "1430": {"vr": "DS", "Value": [20.0]},
        "1431": {"vr": "DS", "Value": [22.5]},
        "1432": {"vr": "DS", "Value": [20.0]},
        "1433": {"vr": "DS", "Value": [22.5]},
        "1434": {"vr": "DS", "Value": [22.5]},
        "1435": {"vr": "DS", "Value": [22.5]},
        "1436": {"vr": "DS", "Value": [22.5]},
        "1437": {"vr": "DS", "Value": [22.5]},
        "1438": {"vr": "DS", "Value": [22.5]},
        "1439": {"vr": "DS", "Value": [20.0]},
        "1440": {"vr": "DS", "Value": [22.5]},
        "1441": {"vr": "DS", "Value": [22.5]},
        "1442": {"vr": "DS", "Value": [20.0]},
        "1443": {"vr": "DS", "Value": [22.5]},
        "1444": {"vr": "DS", "Value": [22.5]},
        "1445": {"vr": "DS", "Value": [22.5]},
        "1446": {"vr": "DS", "Value": [22.5]},
        "1447": {"vr": "DS", "Value": [22.5]},
        "1448": {"vr": "DS", "Value": [20.0]},
        "1449": {"vr": "DS", "Value": [20.0]},
        "1450": {"vr": "DS", "Value": [20.0]},
        "1451": {"vr": "DS", "Value": [20.0]},
        "1452": {"vr": "DS", "Value": [22.5]},
        "1453": {"vr": "DS", "Value": [20.0]},
        "1454": {"vr": "DS", "Value": [20.0]},
        "1455": {"vr": "DS", "Value": [20.0]},
        "1456": {"vr": "DS", "Value": [20.0]},
        "1457": {"vr": "DS", "Value": [20.0]},
        "1458": {"vr": "DS", "Value": [22.5]},
        "1459": {"vr": "DS", "Value": [20.0]},
        "1460": {"vr": "DS", "Value": [20.0]},
        "1461": {"vr": "DS", "Value": [20.0]},
        "1462": {"vr": "DS", "Value": [20.0]},
        "1463": {"vr": "DS", "Value": [20.0]},
        "1464": {"vr": "DS", "Value": [22.5]},
        "1465": {"vr": "DS", "Value": [22.5]},
        "1466": {"vr": "DS", "Value": [22.5]},
        "1467": {"vr": "DS", "Value": [22.5]},
        "1468": {"vr": "DS", "Value": [20.0]},
        "1469": {"vr": "DS", "Value": [20.0]},
        "1470": {"vr": "DS", "Value": [20.0]},
        "1471": {"vr": "DS", "Value": [20.0]},
        "1472": {"vr": "DS", "Value": [20.0]},
        "1473": {"vr": "DS", "Value": [20.0]},
        "1474": {"vr": "DS", "Value": [20.0]},
        "1475": {"vr": "DS", "Value": [20.0]},
        "1476": {"vr": "DS", "Value": [22.5]},
        "1477": {"vr": "DS", "Value": [20.0]},
        "1478": {"vr": "DS", "Value": [20.0]},
        "1479": {"vr": "DS", "Value": [20.0]},
        "1480": {"vr": "DS", "Value": [22.5]},
        "1481": {"vr": "DS", "Value": [22.5]},
        "1482": {"vr": "DS", "Value": [22.5]},
        "1483": {"vr": "DS", "Value": [20.0]},
        "1484": {"vr": "DS", "Value": [20.0]},
        "1485": {"vr": "DS", "Value": [22.5]},
        "1486": {"vr": "DS", "Value": [22.5]},
        "1487": {"vr": "DS", "Value": [22.5]},
        "1488": {"vr": "DS", "Value": [22.5]},
        "1489": {"vr": "DS", "Value": [20.0]},
        "1490": {"vr": "DS", "Value": [22.5]},
        "1491": {"vr": "DS", "Value": [20.0]},
        "1492": {"vr": "DS", "Value": [20.0]},
        "1493": {"vr": "DS", "Value": [20.0]},
        "1494": {"vr": "DS", "Value": [22.5]},
        "1495": {"vr": "DS", "Value": [22.5]},
        "1496": {"vr": "DS", "Value": [22.5]},
        "1497": {"vr": "DS", "Value": [22.5]},
        "1498": {"vr": "DS", "Value": [22.5]},
        "1499": {"vr": "DS", "Value": [22.5]},
        "1500": {"vr": "DS", "Value": [22.5]},
        "1501": {"vr": "DS", "Value": [20.0]},
        "1502": {"vr": "DS", "Value": [20.0]},
        "1503": {"vr": "DS", "Value": [22.5]},
        "1504": {"vr": "DS", "Value": [22.5]},
        "1505": {"vr": "DS", "Value": [20.0]},
        "1506": {"vr": "DS", "Value": [20.0]},
        "1507": {"vr": "DS", "Value": [20.0]},
        "1508": {"vr": "DS", "Value": [20.0]},
        "1509": {"vr": "DS", "Value": [22.5]},
        "1510": {"vr": "DS", "Value": [22.5]},
        "1511": {"vr": "DS", "Value": [22.5]},
        "1512": {"vr": "DS", "Value": [20.0]},
        "1513": {"vr": "DS", "Value": [20.0]},
        "1514": {"vr": "DS", "Value": [20.0]},
        "1515": {"vr": "DS", "Value": [20.0]},
        "1516": {"vr": "DS", "Value": [22.5]},
        "1517": {"vr": "DS", "Value": [20.0]},
        "1518": {"vr": "DS", "Value": [22.5]},
        "1519": {"vr": "DS", "Value": [22.5]},
        "1520": {"vr": "DS", "Value": [22.5]},
        "1521": {"vr": "DS", "Value": [22.5]},
        "1522": {"vr": "DS", "Value": [22.5]},
        "1523": {"vr": "DS", "Value": [22.5]},
        "1524": {"vr": "DS", "Value": [22.5]},
        "1525": {"vr": "DS", "Value": [20.0]},
        "1526": {"vr": "DS", "Value": [20.0]},
        "1527": {"vr": "DS", "Value": [20.0]},
        "1528": {"vr": "DS", "Value": [22.5]},
        "1529": {"vr": "DS", "Value": [22.5]},
        "1530": {"vr": "DS", "Value": [20.0]},
        "1531": {"vr": "DS", "Value": [22.5]},
        "1532": {"vr": "DS", "Value": [22.5]},
        "1533": {"vr": "DS", "Value": [22.5]},
        "1534": {"vr": "DS", "Value": [20.0]},
        "1535": {"vr": "DS", "Value": [22.5]},
        "1536": {"vr": "DS", "Value": [22.5]},
        "1537": {"vr": "DS", "Value": [22.5]},
        "1538": {"vr": "DS", "Value": [22.5]},
        "1539": {"vr": "DS", "Value": [20.0]},
        "1540": {"vr": "DS", "Value": [22.5]},
        "1541": {"vr": "DS", "Value": [20.0]},
        "1542": {"vr": "DS", "Value": [20.0]},
        "1543": {"vr": "DS", "Value": [22.5]},
        "1544": {"vr": "DS", "Value": [20.0]},
        "1545": {"vr": "DS", "Value": [22.5]},
        "1546": {"vr": "DS", "Value": [20.0]},
        "1547": {"vr": "DS", "Value": [22.5]},
        "1548": {"vr": "DS", "Value": [20.0]},
        "1549": {"vr": "DS", "Value": [22.5]},
        "1550": {"vr": "DS", "Value": [20.0]},
        "1551": {"vr": "DS", "Value": [20.0]},
        "1552": {"vr": "DS", "Value": [20.0]},
        "1553": {"vr": "DS", "Value": [20.0]},
        "1554": {"vr": "DS", "Value": [22.5]},
        "1555": {"vr": "DS", "Value": [20.0]},
        "1556": {"vr": "DS", "Value": [20.0]},
        "1557": {"vr": "DS", "Value": [22.5]},
        "1558": {"vr": "DS", "Value": [22.5]},
        "1559": {"vr": "DS", "Value": [20.0]},
        "1560": {"vr": "DS", "Value": [22.5]},
        "1561": {"vr": "DS", "Value": [22.5]},
        "1562": {"vr": "DS", "Value": [20.0]},
        "1563": {"vr": "DS", "Value": [20.0]},
        "1564": {"vr": "DS", "Value": [20.0]},
        "1565": {"vr": "DS", "Value": [20.0]},
        "1566": {"vr": "DS", "Value": [20.0]},
        "1567": {"vr": "DS", "Value": [22.5]},
        "1568": {"vr": "DS", "Value": [20.0]},
        "1569": {"vr": "DS", "Value": [20.0]},
        "1570": {"vr": "DS", "Value": [22.5]},
        "1571": {"vr": "DS", "Value": [22.5]},
        "1572": {"vr": "DS", "Value": [20.0]},
        "1573": {"vr": "DS", "Value": [22.5]},
        "1574": {"vr": "DS", "Value": [20.0]},
        "1575": {"vr": "DS", "Value": [22.5]},
        "1576": {"vr": "DS", "Value": [22.5]},
        "1577": {"vr": "DS", "Value": [22.5]},
        "1578": {"vr": "DS", "Value": [22.5]},
        "1579": {"vr": "DS", "Value": [20.0]},
        "1580": {"vr": "DS", "Value": [22.5]},
        "1581": {"vr": "DS", "Value": [20.0]},
        "1582": {"vr": "DS", "Value": [22.5]},
        "1583": {"vr": "DS", "Value": [20.0]},
        "1584": {"vr": "DS", "Value": [20.0]},
        "1585": {"vr": "DS", "Value": [20.0]},
        "1586": {"vr": "DS", "Value": [22.5]},
        "1587": {"vr": "DS", "Value": [22.5]},
        "1588": {"vr": "DS", "Value": [22.5]},
        "1589": {"vr": "DS", "Value": [22.5]},
        "1590": {"vr": "DS", "Value": [20.0]},
        "1591": {"vr": "DS", "Value": [20.0]},
        "1592": {"vr": "DS", "Value": [22.5]},
        "1593": {"vr": "DS", "Value": [20.0]},
        "1594": {"vr": "DS", "Value": [22.5]},
        "1595": {"vr": "DS", "Value": [20.0]},
        "1596": {"vr": "DS", "Value": [22.5]},
        "1597": {"vr": "DS", "Value": [20.0]},
        "1598": {"vr": "DS", "Value": [22.5]},
        "1599": {"vr": "DS", "Value": [22.5]},
        "1600": {"vr": "DS", "Value": [20.0]},
        "1601": {"vr": "DS", "Value": [20.0]},
        "1602": {"vr": "DS", "Value": [22.5]},
        "1603": {"vr": "DS", "Value": [20.0]},
        "1604": {"vr": "DS", "Value": [20.0]},
        "1605": {"vr": "DS", "Value": [20.0]},
        "1606": {"vr": "DS", "Value": [22.5]},
        "1607": {"vr": "DS", "Value": [22.5]},
        "1608": {"vr": "DS", "Value": [22.5]},
        "1609": {"vr": "DS", "Value": [22.5]},
        "1610": {"vr": "DS", "Value": [20.0]},
        "1611": {"vr": "DS", "Value": [22.5]},
        "1612": {"vr": "DS", "Value": [20.0]},
        "1613": {"vr": "DS", "Value": [20.0]},
        "1614": {"vr": "DS", "Value": [22.5]},
        "1615": {"vr": "DS", "Value": [20.0]},
        "1616": {"vr": "DS", "Value": [20.0]},
        "1617": {"vr": "DS", "Value": [22.5]},
        "1618": {"vr": "DS", "Value": [22.5]},
        "1619": {"vr": "DS", "Value": [20.0]},
        "1620": {"vr": "DS", "Value": [20.0]},
        "1621": {"vr": "DS", "Value": [22.5]},
        "1622": {"vr": "DS", "Value": [22.5]},
        "1623": {"vr": "DS", "Value": [22.5]},
        "1624": {"vr": "DS", "Value": [22.5]},
        "1625": {"vr": "DS", "Value": [22.5]},
        "1626": {"vr": "DS", "Value": [22.5]},
        "1627": {"vr": "DS", "Value": [20.0]},
        "1628": {"vr": "DS", "Value": [22.5]},
        "1629": {"vr": "DS", "Value": [22.5]},
        "1630": {"vr": "DS", "Value": [22.5]},
        "1631": {"vr": "DS", "Value": [22.5]},
        "1632": {"vr": "DS", "Value": [20.0]},
        "1633": {"vr": "DS", "Value": [22.5]},
        "1634": {"vr": "DS", "Value": [22.5]},
        "1635": {"vr": "DS", "Value": [20.0]},
        "1636": {"vr": "DS", "Value": [20.0]},
        "1637": {"vr": "DS", "Value": [20.0]},
        "1638": {"vr": "DS", "Value": [22.5]},
        "1639": {"vr": "DS", "Value": [22.5]},
        "1640": {"vr": "DS", "Value": [20.0]},
        "1641": {"vr": "DS", "Value": [22.5]},
        "1642": {"vr": "DS", "Value": [20.0]},
        "1643": {"vr": "DS", "Value": [20.0]},
        "1644": {"vr": "DS", "Value": [20.0]},
        "1645": {"vr": "DS", "Value": [20.0]},
        "1646": {"vr": "DS", "Value": [20.0]},
        "1647": {"vr": "DS", "Value": [20.0]},
        "1648": {"vr": "DS", "Value": [22.5]},
        "1649": {"vr": "DS", "Value": [20.0]},
        "1650": {"vr": "DS", "Value": [22.5]},
        "1651": {"vr": "DS", "Value": [20.0]},
        "1652": {"vr": "DS", "Value": [22.5]},
        "1653": {"vr": "DS", "Value": [20.0]},
        "1654": {"vr": "DS", "Value": [22.5]},
        "1655": {"vr": "DS", "Value": [20.0]},
        "1656": {"vr": "DS", "Value": [20.0]},
        "1657": {"vr": "DS", "Value": [20.0]},
        "1658": {"vr": "DS", "Value": [20.0]},
        "1659": {"vr": "DS", "Value": [20.0]},
        "1660": {"vr": "DS", "Value": [20.0]},
        "1661": {"vr": "DS", "Value": [22.5]},
        "1662": {"vr": "DS", "Value": [20.0]},
        "1663": {"vr": "DS", "Value": [22.5]},
        "1664": {"vr": "DS", "Value": [22.5]},
        "1665": {"vr": "DS", "Value": [20.0]},
        "1666": {"vr": "DS", "Value": [20.0]},
        "1667": {"vr": "DS", "Value": [22.5]},
        "1668": {"vr": "DS", "Value": [20.0]},
        "1669": {"vr": "DS", "Value": [22.5]},
        "1670": {"vr": "DS", "Value": [22.5]},
        "1671": {"vr": "DS", "Value": [20.0]},
        "1672": {"vr": "DS", "Value": [20.0]},
        "1673": {"vr": "DS", "Value": [20.0]},
        "1674": {"vr": "DS", "Value": [22.5]},
        "1675": {"vr": "DS", "Value": [20.0]},
        "1676": {"vr": "DS", "Value": [22.5]},
        "1677": {"vr": "DS", "Value": [22.5]},
        "1678": {"vr": "DS", "Value": [22.5]},
        "1679": {"vr": "DS", "Value": [22.5]},
        "1680": {"vr": "DS", "Value": [20.0]},
        "1681": {"vr": "DS", "Value": [22.5]},
        "1682": {"vr": "DS", "Value": [20.0]},
        "1683": {"vr": "DS", "Value": [22.5]},
        "1684": {"vr": "DS", "Value": [22.5]},
        "1685": {"vr": "DS", "Value": [20.0]},
        "1686": {"vr": "DS", "Value": [22.5]},
        "1687": {"vr": "DS", "Value": [22.5]},
        "1688": {"vr": "DS", "Value": [20.0]},
        "1689": {"vr": "DS", "Value": [22.5]},
        "1690": {"vr": "DS", "Value": [22.5]},
        "1691": {"vr": "DS", "Value": [20.0]},
        "1692": {"vr": "DS", "Value": [22.5]},
        "1693": {"vr": "DS", "Value": [22.5]},
        "1694": {"vr": "DS", "Value": [22.5]},
        "1695": {"vr": "DS", "Value": [22.5]},
        "1696": {"vr": "DS", "Value": [20.0]},
        "1697": {"vr": "DS", "Value": [20.0]},
        "1698": {"vr": "DS", "Value": [22.5]},
        "1699": {"vr": "DS", "Value": [20.0]},
        "1700": {"vr": "DS", "Value": [22.5]},
        "1701": {"vr": "DS", "Value": [20.0]},
        "1702": {"vr": "DS", "Value": [20.0]},
        "1703": {"vr": "DS", "Value": [22.5]},
        "1704": {"vr": "DS", "Value": [20.0]},
        "1705": {"vr": "DS", "Value": [22.5]},
        "1706": {"vr": "DS", "Value": [20.0]},
        "1707": {"vr": "DS", "Value": [22.5]},
        "1708": {"vr": "DS", "Value": [20.0]},
        "1709": {"vr": "DS", "Value": [20.0]},
        "1710": {"vr": "DS", "Value": [22.5]},
        "1711": {"vr": "DS", "Value": [22.5]},
        "1712": {"vr": "DS", "Value": [20.0]},
        "1713": {"vr": "DS", "Value": [22.5]},
        "1714": {"vr": "DS", "Value": [22.5]},
        "1715": {"vr": "DS", "Value": [22.5]},
        "1716": {"vr": "DS", "Value": [22.5]},
        "1717": {"vr": "DS", "Value": [22.5]},
        "1718": {"vr": "DS", "Value": [20.0]},
        "1719": {"vr": "DS", "Value": [22.5]},
        "1720": {"vr": "DS", "Value": [20.0]},
        "1721": {"vr": "DS", "Value": [22.5]},
        "1722": {"vr": "DS", "Value": [22.5]},
        "1723": {"vr": "DS", "Value": [22.5]},
        "1724": {"vr": "DS", "Value": [22.5]},
        "1725": {"vr": "DS", "Value": [22.5]},
        "1726": {"vr": "DS", "Value": [20.0]},
        "1727": {"vr": "DS", "Value": [20.0]},
        "1728": {"vr": "DS", "Value": [22.5]},
        "1729": {"vr": "DS", "Value": [20.0]},
        "1730": {"vr": "DS", "Value": [20.0]},
        "1731": {"vr": "DS", "Value": [20.0]},
        "1732": {"vr": "DS", "Value": [22.5]},
        "1733": {"vr": "DS", "Value": [20.0]},
        "1734": {"vr": "DS", "Value": [20.0]},
        "1735": {"vr": "DS", "Value": [20.0]},
        "1736": {"vr": "DS", "Value": [22.5]},
        "1737": {"vr": "DS", "Value": [20.0]},
        "1738": {"vr": "DS", "Value": [22.5]},
        "1739": {"vr": "DS", "Value": [22.5]},
        "1740": {"vr": "DS", "Value": [22.5]},
        "1741": {"vr": "DS", "Value": [20.0]},
        "1742": {"vr": "DS", "Value": [22.5]},
        "1743": {"vr": "DS", "Value": [22.5]},
        "1744": {"vr": "DS", "Value": [22.5]},
        "1745": {"vr": "DS", "Value": [22.5]},
        "1746": {"vr": "DS", "Value": [22.5]},
        "1747": {"vr": "DS", "Value": [22.5]},
        "1748": {"vr": "DS", "Value": [20.0]},
        "1749": {"vr": "DS", "Value": [20.0]},
        "1750": {"vr": "DS", "Value": [20.0]},
        "1751": {"vr": "DS", "Value": [22.5]},
        "1752": {"vr": "DS", "Value": [20.0]},
        "1753": {"vr": "DS", "Value": [22.5]},
        "1754": {"vr": "DS", "Value": [20.0]},
        "1755": {"vr": "DS", "Value": [22.5]},
        "1756": {"vr": "DS", "Value": [22.5]},
        "1757": {"vr": "DS", "Value": [22.5]},
        "1758": {"vr": "DS", "Value": [22.5]},
        "1759": {"vr": "DS", "Value": [22.5]},
        "1760": {"vr": "DS", "Value": [20.0]},
        "1761": {"vr": "DS", "Value": [22.5]},
        "1762": {"vr": "DS", "Value": [22.5]},
        "1763": {"vr": "DS", "Value": [20.0]},
        "1764": {"vr": "DS", "Value": [20.0]},
        "1765": {"vr": "DS", "Value": [22.5]},
        "1766": {"vr": "DS", "Value": [22.5]},
        "1767": {"vr": "DS", "Value": [22.5]},
        "1768": {"vr": "DS", "Value": [20.0]},
        "1769": {"vr": "DS", "Value": [22.5]},
        "1770": {"vr": "DS", "Value": [20.0]},
        "1771": {"vr": "DS", "Value": [20.0]},
        "1772": {"vr": "DS", "Value": [20.0]},
        "1773": {"vr": "DS", "Value": [20.0]},
        "1774": {"vr": "DS", "Value": [22.5]},
        "1775": {"vr": "DS", "Value": [22.5]},
        "1776": {"vr": "DS", "Value": [20.0]},
        "1777": {"vr": "DS", "Value": [22.5]},
        "1778": {"vr": "DS", "Value": [20.0]},
        "1779": {"vr": "DS", "Value": [22.5]},
        "1780": {"vr": "DS", "Value": [20.0]},
        "1781": {"vr": "DS", "Value": [20.0]},
        "1782": {"vr": "DS", "Value": [22.5]},
        "1783": {"vr": "DS", "Value": [20.0]},
        "1784": {"vr": "DS", "Value": [22.5]},
        "1785": {"vr": "DS", "Value": [20.0]},
        "1786": {"vr": "DS", "Value": [20.0]},
        "1787": {"vr": "DS", "Value": [20.0]},
        "1788": {"vr": "DS", "Value": [22.5]},
        "1789": {"vr": "DS", "Value": [20.0]},
        "1790": {"vr": "DS", "Value": [22.5]},
        "1791": {"vr": "DS", "Value": [22.5]},
        "1792": {"vr": "DS", "Value": [22.5]},
        "1793": {"vr": "DS", "Value": [20.0]},
        "1794": {"vr": "DS", "Value": [22.5]},
        "1795": {"vr": "DS", "Value": [22.5]},
        "1796": {"vr": "DS", "Value": [22.5]},
        "1797": {"vr": "DS", "Value": [22.5]},
        "1798": {"vr": "DS", "Value": [22.5]},
        "1799": {"vr": "DS", "Value": [20.0]},
        "1800": {"vr": "DS", "Value": [20.0]},
        "1801": {"vr": "DS", "Value": [22.5]},
        "1802": {"vr": "DS", "Value": [20.0]},
        "1803": {"vr": "DS", "Value": [22.5]},
        "1804": {"vr": "DS", "Value": [22.5]},
        "1805": {"vr": "DS", "Value": [20.0]},
        "1806": {"vr": "DS", "Value": [20.0]},
        "1807": {"vr": "DS", "Value": [22.5]},
        "1808": {"vr": "DS", "Value": [20.0]},
        "1809": {"vr": "DS", "Value": [20.0]},
        "1810": {"vr": "DS", "Value": [22.5]},
        "1811": {"vr": "DS", "Value": [20.0]},
        "1812": {"vr": "DS", "Value": [22.5]},
        "1813": {"vr": "DS", "Value": [20.0]},
        "1814": {"vr": "DS", "Value": [20.0]},
        "1815": {"vr": "DS", "Value": [22.5]},
        "1816": {"vr": "DS", "Value": [20.0]},
        "1817": {"vr": "DS", "Value": [20.0]},
        "1818": {"vr": "DS", "Value": [20.0]},
        "1819": {"vr": "DS", "Value": [20.0]},
        "1820": {"vr": "DS", "Value": [20.0]},
        "1821": {"vr": "DS", "Value": [22.5]},
        "1822": {"vr": "DS", "Value": [20.0]},
        "1823": {"vr": "DS", "Value": [20.0]},
        "1824": {"vr": "DS", "Value": [20.0]},
        "1825": {"vr": "DS", "Value": [20.0]},
        "1826": {"vr": "DS", "Value": [20.0]},
        "1827": {"vr": "DS", "Value": [22.5]},
        "1828": {"vr": "DS", "Value": [20.0]},
        "1829": {"vr": "DS", "Value": [22.5]},
        "1830": {"vr": "DS", "Value": [22.5]},
        "1831": {"vr": "DS", "Value": [22.5]},
        "1832": {"vr": "DS", "Value": [22.5]},
        "1833": {"vr": "DS", "Value": [22.5]},
        "1834": {"vr": "DS", "Value": [20.0]},
        "1835": {"vr": "DS", "Value": [22.5]},
        "1836": {"vr": "DS", "Value": [20.0]},
        "1837": {"vr": "DS", "Value": [20.0]},
        "1838": {"vr": "DS", "Value": [22.5]},
        "1839": {"vr": "DS", "Value": [22.5]},
        "1840": {"vr": "DS", "Value": [22.5]},
        "1841": {"vr": "DS", "Value": [22.5]},
        "1842": {"vr": "DS", "Value": [22.5]},
        "1843": {"vr": "DS", "Value": [22.5]},
        "1844": {"vr": "DS", "Value": [22.5]},
        "1845": {"vr": "DS", "Value": [20.0]},
        "1846": {"vr": "DS", "Value": [22.5]},
        "1847": {"vr": "DS", "Value": [20.0]},
        "1848": {"vr": "DS", "Value": [22.5]},
        "1849": {"vr": "DS", "Value": [22.5]},
        "1850": {"vr": "DS", "Value": [22.5]},
        "1851": {"vr": "DS", "Value": [22.5]},
        "1852": {"vr": "DS", "Value": [20.0]},
        "1853": {"vr": "DS", "Value": [20.0]},
        "1854": {"vr": "DS", "Value": [20.0]},
        "1855": {"vr": "DS", "Value": [20.0]},
        "1856": {"vr": "DS", "Value": [22.5]},
        "1857": {"vr": "DS", "Value": [20.0]},
        "1858": {"vr": "DS", "Value": [22.5]},
        "1859": {"vr": "DS", "Value": [22.5]},
        "1860": {"vr": "DS", "Value": [20.0]},
        "1861": {"vr": "DS", "Value": [20.0]},
        "1862": {"vr": "DS", "Value": [20.0]},
        "1863": {"vr": "DS", "Value": [20.0]},
        "1864": {"vr": "DS", "Value": [22.5]},
        "1865": {"vr": "DS", "Value": [20.0]},
        "1866": {"vr": "DS", "Value": [22.5]},
        "1867": {"vr": "DS", "Value": [20.0]},
        "1868": {"vr": "DS", "Value": [20.0]},
        "1869": {"vr": "DS", "Value": [20.0]},
        "1870": {"vr": "DS", "Value": [20.0]},
        "1871": {"vr": "DS", "Value": [22.5]},
        "1872": {"vr": "DS", "Value": [20.0]},
        "1873": {"vr": "DS", "Value": [20.0]},
        "1874": {"vr": "DS", "Value": [22.5]},
        "1875": {"vr": "DS", "Value": [22.5]},
        "1876": {"vr": "DS", "Value": [22.5]},
        "1877": {"vr": "DS", "Value": [22.5]},
        "1878": {"vr": "DS", "Value": [20.0]},
        "1879": {"vr": "DS", "Value": [20.0]},
        "1880": {"vr": "DS", "Value": [22.5]},
        "1881": {"vr": "DS", "Value": [20.0]},
        "1882": {"vr": "DS", "Value": [22.5]},
        "1883": {"vr": "DS", "Value": [20.0]},
        "1884": {"vr": "DS", "Value": [20.0]},
        "1885": {"vr": "DS", "Value": [20.0]},
        "1886": {"vr": "DS", "Value": [22.5]},
        "1887": {"vr": "DS", "Value": [20.0]},
        "1888": {"vr": "DS", "Value": [20.0]},
        "1889": {"vr": "DS", "Value": [22.5]},
        "1890": {"vr": "DS", "Value": [22.5]},
        "1891": {"vr": "DS", "Value": [20.0]},
        "1892": {"vr": "DS", "Value": [22.5]},
        "1893": {"vr": "DS", "Value": [22.5]},
        "1894": {"vr": "DS", "Value": [20.0]},
        "1895": {"vr": "DS", "Value": [22.5]},
        "1896": {"vr": "DS", "Value": [20.0]},
        "1897": {"vr": "DS", "Value": [22.5]},
        "1898": {"vr": "DS", "Value": [22.5]},
        "1899": {"vr": "DS", "Value": [20.0]},
        "1900": {"vr": "DS", "Value": [20.0]},
        "1901": {"vr": "DS", "Value": [22.5]},
        "1902": {"vr": "DS", "Value": [22.5]},
        "1903": {"vr": "DS", "Value": [22.5]},
        "1904": {"vr": "DS", "Value": [22.5]},
        "1905": {"vr": "DS", "Value": [22.5]},
        "1906": {"vr": "DS", "Value": [22.5]},
        "1907": {"vr": "DS", "Value": [20.0]},
        "1908": {"vr": "DS", "Value": [22.5]},
        "1909": {"vr": "DS", "Value": [22.5]},
        "1910": {"vr": "DS", "Value": [20.0]},
        "1911": {"vr": "DS", "Value": [22.5]},
        "1912": {"vr": "DS", "Value": [22.5]},
        "1913": {"vr": "DS", "Value": [20.0]},
        "1914": {"vr": "DS", "Value": [22.5]},
        "1915": {"vr": "DS", "Value": [22.5]},
        "1916": {"vr": "DS", "Value": [22.5]},
        "1917": {"vr": "DS", "Value": [20.0]},
        "1918": {"vr": "DS", "Value": [22.5]},
        "1919": {"vr": "DS", "Value": [22.5]},
        "1920": {"vr": "DS", "Value": [20.0]},
        "1921": {"vr": "DS", "Value": [22.5]},
        "1922": {"vr": "DS", "Value": [20.0]},
        "1923": {"vr": "DS", "Value": [20.0]},
        "1924": {"vr": "DS", "Value": [20.0]},
        "1925": {"vr": "DS", "Value": [20.0]},
        "1926": {"vr": "DS", "Value": [22.5]},
        "1927": {"vr": "DS", "Value": [22.5]},
        "1928": {"vr": "DS", "Value": [20.0]},
        "1929": {"vr": "DS", "Value": [22.5]},
        "1930": {"vr": "DS", "Value": [22.5]},
        "1931": {"vr": "DS", "Value": [22.5]},
        "1932": {"vr": "DS", "Value": [20.0]},
        "1933": {"vr": "DS", "Value": [22.5]},
        "1934": {"vr": "DS", "Value": [22.5]},
        "1935": {"vr": "DS", "Value": [22.5]},
        "1936": {"vr": "DS", "Value": [22.5]},
        "1937": {"vr": "DS", "Value": [20.0]},
        "1938": {"vr": "DS", "Value": [22.5]},
        "1939": {"vr": "DS", "Value": [20.0]},
        "1940": {"vr": "DS", "Value": [20.0]},
        "1941": {"vr": "DS", "Value": [22.5]},
        "1942": {"vr": "DS", "Value": [20.0]},
        "1943": {"vr": "DS", "Value": [20.0]},
        "1944": {"vr": "DS", "Value": [20.0]},
        "1945": {"vr": "DS", "Value": [22.5]},
        "1946": {"vr": "DS", "Value": [22.5]},
        "1947": {"vr": "DS", "Value": [20.0]},
        "1948": {"vr": "DS", "Value": [22.5]},
        "1949": {"vr": "DS", "Value": [22.5]},
        "1950": {"vr": "DS", "Value": [20.0]},
        "1951": {"vr": "DS", "Value": [20.0]},
        "1952": {"vr": "DS", "Value": [22.5]},
        "1953": {"vr": "DS", "Value": [20.0]},
        "1954": {"vr": "DS", "Value": [22.5]},
        "1955": {"vr": "DS", "Value": [20.0]},
        "1956": {"vr": "DS", "Value": [20.0]},
        "1957": {"vr": "DS", "Value": [22.5]},
        "1958": {"vr": "DS", "Value": [22.5]},
        "1959": {"vr": "DS", "Value": [22.5]},
        "1960": {"vr": "DS", "Value": [20.0]},
        "1961": {"vr": "DS", "Value": [22.5]},
        "1962": {"vr": "DS", "Value": [20.0]},
        "1963": {"vr": "DS", "Value": [20.0]},
        "1964": {"vr": "DS", "Value": [20.0]},
        "1965": {"vr": "DS", "Value": [20.0]},
        "1966": {"vr": "DS", "Value": [22.5]},
        "1967": {"vr": "DS", "Value": [20.0]},
        "1968": {"vr": "DS", "Value": [22.5]},
        "1969": {"vr": "DS", "Value": [22.5]},
        "1970": {"vr": "DS", "Value": [20.0]},
        "1971": {"vr": "DS", "Value": [22.5]},
        "1972": {"vr": "DS", "Value": [22.5]},
        "1973": {"vr": "DS", "Value": [22.5]},
        "1974": {"vr": "DS", "Value": [22.5]},
        "1975": {"vr": "DS", "Value": [20.0]},
        "1976": {"vr": "DS", "Value": [20.0]},
        "1977": {"vr": "DS", "Value": [20.0]},
        "1978": {"vr": "DS", "Value": [20.0]},
        "1979": {"vr": "DS", "Value": [22.5]},
        "1980": {"vr": "DS", "Value": [22.5]},
        "1981": {"vr": "DS", "Value": [22.5]},
        "1982": {"vr": "DS", "Value": [20.0]},
        "1983": {"vr": "DS", "Value": [22.5]},
        "1984": {"vr": "DS", "Value": [22.5]},
        "1985": {"vr": "DS", "Value": [20.0]},
        "1986": {"vr": "DS", "Value": [22.5]},
        "1987": {"vr": "DS", "Value": [22.5]},
        "1988": {"vr": "DS", "Value": [20.0]},
        "1989": {"vr": "DS", "Value": [20.0]},
        "1990": {"vr": "DS", "Value": [20.0]},
        "1991": {"vr": "DS", "Value": [20.0]},
        "1992": {"vr": "DS", "Value": [22.5]},
        "1993": {"vr": "DS", "Value": [22.5]},
        "1994": {"vr": "DS", "Value": [20.0]},
        "1995": {"vr": "DS", "Value": [20.0]},
        "1996": {"vr": "DS", "Value": [22.5]},
        "1997": {"vr": "DS", "Value": [20.0]},
        "1998": {"vr": "DS", "Value": [22.5]},
        "1999": {"vr": "DS", "Value": [20.0]},
        "2000": {"vr": "DS", "Value": [22.5]},
        "2001": {"vr": "DS", "Value": [20.0]},
        "2002": {"vr": "DS", "Value": [20.0]},
        "2003": {"vr": "DS", "Value": [22.5]},
        "2004": {"vr": "DS", "Value": [20.0]},
        "2005": {"vr": "DS", "Value": [20.0]},
        "2006": {"vr": "DS", "Value": [20.0]},
        "2007": {"vr": "DS", "Value": [22.5]},
        "2008": {"vr": "DS", "Value": [22.5]},
        "2009": {"vr": "DS", "Value": [22.5]},
        "2010": {"vr": "DS", "Value": [20.0]},
        "2011": {"vr": "DS", "Value": [20.0]},
        "2012": {"vr": "DS", "Value": [22.5]},
        "2013": {"vr": "DS", "Value": [22.5]},
        "2014": {"vr": "DS", "Value": [20.0]},
        "2015": {"vr": "DS", "Value": [20.0]},
        "2016": {"vr": "DS", "Value": [22.5]},
        "2017": {"vr": "DS", "Value": [20.0]},
        "2018": {"vr": "DS", "Value": [22.5]},
        "2019": {"vr": "DS", "Value": [20.0]},
        "2020": {"vr": "DS", "Value": [20.0]},
        "2021": {"vr": "DS", "Value": [22.5]},
        "2022": {"vr": "DS", "Value": [20.0]},
        "2023": {"vr": "DS", "Value": [20.0]},
        "2024": {"vr": "DS", "Value": [22.5]},
        "2025": {"vr": "DS", "Value": [22.5]},
        "2026": {"vr": "DS", "Value": [22.5]},
        "2027": {"vr": "DS", "Value": [22.5]},
        "2028": {"vr": "DS", "Value": [20.0]},
        "2029": {"vr": "DS", "Value": [20.0]},
        "2030": {"vr": "DS", "Value": [20.0]},
        "2031": {"vr": "DS", "Value": [20.0]},
        "2032": {"vr": "DS", "Value": [22.5]},
        "2033": {"vr": "DS", "Value": [22.5]},
        "2034": {"vr": "DS", "Value": [22.5]},
        "2035": {"vr": "DS", "Value": [22.5]},
        "2036": {"vr": "DS", "Value": [22.5]},
        "2037": {"vr": "DS", "Value": [22.5]},
        "2038": {"vr": "DS", "Value": [22.5]},
        "2039": {"vr": "DS", "Value": [20.0]},
        "2040": {"vr": "DS", "Value": [22.5]},
        "2041": {"vr": "DS", "Value": [20.0]},
        "2042": {"vr": "DS", "Value": [22.5]},
        "2043": {"vr": "DS", "Value": [22.5]},
        "2044": {"vr": "DS", "Value": [22.5]},
        "2045": {"vr": "DS", "Value": [22.5]},
        "2046": {"vr": "DS", "Value": [20.0]},
        "2047": {"vr": "DS", "Value": [20.0]},
        "2048": {"vr": "DS", "Value": [20.0]},
        "2049": {"vr": "DS", "Value": [20.0]},
        "2050": {"vr": "DS", "Value": [22.5]},
        "2051": {"vr": "DS", "Value": [20.0]},
        "2052": {"vr": "DS", "Value": [22.5]},
        "2053": {"vr": "DS", "Value": [22.5]},
        "2054": {"vr": "DS", "Value": [20.0]},
        "2055": {"vr": "DS", "Value": [20.0]},
        "2056": {"vr": "DS", "Value": [20.0]},
        "2057": {"vr": "DS", "Value": [22.5]},
        "2058": {"vr": "DS", "Value": [20.0]},
        "2059": {"vr": "DS", "Value": [20.0]},
        "2060": {"vr": "DS", "Value": [22.5]},
        "2061": {"vr": "DS", "Value": [22.5]},
        "2062": {"vr": "DS", "Value": [22.5]},
        "2063": {"vr": "DS", "Value": [22.5]},
        "2064": {"vr": "DS", "Value": [22.5]},
        "2065": {"vr": "DS", "Value": [22.5]},
        "2066": {"vr": "DS", "Value": [20.0]},
        "2067": {"vr": "DS", "Value": [22.5]},
        "2068": {"vr": "DS", "Value": [20.0]},
        "2069": {"vr": "DS", "Value": [22.5]},
        "2070": {"vr": "DS", "Value": [20.0]},
        "2071": {"vr": "DS", "Value": [22.5]},
        "2072": {"vr": "DS", "Value": [20.0]},
        "2073": {"vr": "DS", "Value": [22.5]},
        "2074": {"vr": "DS", "Value": [22.5]},
        "2075": {"vr": "DS", "Value": [20.0]},
        "2076": {"vr": "DS", "Value": [22.5]},
        "2077": {"vr": "DS", "Value": [22.5]},
        "2078": {"vr": "DS", "Value": [20.0]},
        "2079": {"vr": "DS", "Value": [20.0]},
        "2080": {"vr": "DS", "Value": [20.0]},
        "2081": {"vr": "DS", "Value": [22.5]},
        "2082": {"vr": "DS", "Value": [22.5]},
        "2083": {"vr": "DS", "Value": [20.0]},
        "2084": {"vr": "DS", "Value": [20.0]},
        "2085": {"vr": "DS", "Value": [22.5]},
        "2086": {"vr": "DS", "Value": [22.5]},
        "2087": {"vr": "DS", "Value": [20.0]},
        "2088": {"vr": "DS", "Value": [20.0]},
        "2089": {"vr": "DS", "Value": [20.0]},
        "2090": {"vr": "DS", "Value": [22.5]},
        "2091": {"vr": "DS", "Value": [20.0]},
        "2092": {"vr": "DS", "Value": [22.5]},
        "2093": {"vr": "DS", "Value": [22.5]},
        "2094": {"vr": "DS", "Value": [20.0]},
        "2095": {"vr": "DS", "Value": [22.5]},
        "2096": {"vr": "DS", "Value": [20.0]},
        "2097": {"vr": "DS", "Value": [20.0]},
        "2098": {"vr": "DS", "Value": [20.0]},
        "2099": {"vr": "DS", "Value": [20.0]},
        "2100": {"vr": "DS", "Value": [22.5]},
        "2101": {"vr": "DS", "Value": [22.5]},
        "2102": {"vr": "DS", "Value": [22.5]},
        "2103": {"vr": "DS", "Value": [22.5]},
        "2104": {"vr": "DS", "Value": [22.5]},
        "2105": {"vr": "DS", "Value": [22.5]},
        "2106": {"vr": "DS", "Value": [22.5]},
        "2107": {"vr": "DS", "Value": [22.5]},
        "2108": {"vr": "DS", "Value": [22.5]},
        "2109": {"vr": "DS", "Value": [20.0]},
        "2110": {"vr": "DS", "Value": [20.0]},
        "2111": {"vr": "DS", "Value": [22.5]},
        "2112": {"vr": "DS", "Value": [20.0]},
        "2113": {"vr": "DS", "Value": [20.0]},
        "2114": {"vr": "DS", "Value": [22.5]},
        "2115": {"vr": "DS", "Value": [22.5]},
        "2116": {"vr": "DS", "Value": [20.0]},
        "2117": {"vr": "DS", "Value": [22.5]},
        "2118": {"vr": "DS", "Value": [20.0]},
        "2119": {"vr": "DS", "Value": [20.0]},
        "2120": {"vr": "DS", "Value": [20.0]},
        "2121": {"vr": "DS", "Value": [22.5]},
        "2122": {"vr": "DS", "Value": [20.0]},
        "2123": {"vr": "DS", "Value": [20.0]},
        "2124": {"vr": "DS", "Value": [22.5]},
        "2125": {"vr": "DS", "Value": [22.5]},
        "2126": {"vr": "DS", "Value": [22.5]},
        "2127": {"vr": "DS", "Value": [20.0]},
        "2128": {"vr": "DS", "Value": [20.0]},
        "2129": {"vr": "DS", "Value": [22.5]},
        "2130": {"vr": "DS", "Value": [20.0]},
        "2131": {"vr": "DS", "Value": [20.0]},
        "2132": {"vr": "DS", "Value": [20.0]},
        "2133": {"vr": "DS", "Value": [22.5]},
        "2134": {"vr": "DS", "Value": [20.0]},
        "2135": {"vr": "DS", "Value": [22.5]},
        "2136": {"vr": "DS", "Value": [20.0]},
        "2137": {"vr": "DS", "Value": [20.0]},
        "2138": {"vr": "DS", "Value": [20.0]},
        "2139": {"vr": "DS", "Value": [20.0]},
        "2140": {"vr": "DS", "Value": [20.0]},
        "2141": {"vr": "DS", "Value": [20.0]},
        "2142": {"vr": "DS", "Value": [20.0]},
        "2143": {"vr": "DS", "Value": [20.0]},
        "2144": {"vr": "DS", "Value": [22.5]},
        "2145": {"vr": "DS", "Value": [22.5]},
        "2146": {"vr": "DS", "Value": [20.0]},
        "2147": {"vr": "DS", "Value": [20.0]},
        "2148": {"vr": "DS", "Value": [20.0]},
        "2149": {"vr": "DS", "Value": [22.5]},
        "2150": {"vr": "DS", "Value": [22.5]},
        "2151": {"vr": "DS", "Value": [20.0]},
        "2152": {"vr": "DS", "Value": [20.0]},
        "2153": {"vr": "DS", "Value": [22.5]},
        "2154": {"vr": "DS", "Value": [20.0]},
        "2155": {"vr": "DS", "Value": [20.0]},
        "2156": {"vr": "DS", "Value": [22.5]},
        "2157": {"vr": "DS", "Value": [22.5]},
        "2158": {"vr": "DS", "Value": [20.0]},
        "2159": {"vr": "DS", "Value": [20.0]},
        "2160": {"vr": "DS", "Value": [20.0]},
        "2161": {"vr": "DS", "Value": [20.0]},
        "2162": {"vr": "DS", "Value": [20.0]},
        "2163": {"vr": "DS", "Value": [20.0]},
        "2164": {"vr": "DS", "Value": [22.5]},
        "2165": {"vr": "DS", "Value": [22.5]},
        "2166": {"vr": "DS", "Value": [22.5]},
        "2167": {"vr": "DS", "Value": [22.5]},
        "2168": {"vr": "DS", "Value": [20.0]},
        "2169": {"vr": "DS", "Value": [22.5]},
        "2170": {"vr": "DS", "Value": [22.5]},
        "2171": {"vr": "DS", "Value": [20.0]},
        "2172": {"vr": "DS", "Value": [22.5]},
        "2173": {"vr": "DS", "Value": [22.5]},
        "2174": {"vr": "DS", "Value": [20.0]},
        "2175": {"vr": "DS", "Value": [20.0]},
        "2176": {"vr": "DS", "Value": [22.5]},
        "2177": {"vr": "DS", "Value": [22.5]},
        "2178": {"vr": "DS", "Value": [22.5]},
        "2179": {"vr": "DS", "Value": [22.5]},
        "2180": {"vr": "DS", "Value": [20.0]},
        "2181": {"vr": "DS", "Value": [20.0]},
        "2182": {"vr": "DS", "Value": [22.5]},
        "2183": {"vr": "DS", "Value": [22.5]},
        "2184": {"vr": "DS", "Value": [22.5]},
        "2185": {"vr": "DS", "Value": [22.5]},
        "2186": {"vr": "DS", "Value": [20.0]},
        "2187": {"vr": "DS", "Value": [20.0]},
        "2188": {"vr": "DS", "Value": [22.5]},
        "2189": {"vr": "DS", "Value": [20.0]},
        "2190": {"vr": "DS", "Value": [20.0]},
        "2191": {"vr": "DS", "Value": [20.0]},
        "2192": {"vr": "DS", "Value": [20.0]},
        "2193": {"vr": "DS", "Value": [22.5]},
        "2194": {"vr": "DS", "Value": [22.5]},
        "2195": {"vr": "DS", "Value": [20.0]},
        "2196": {"vr": "DS", "Value": [22.5]},
        "2197": {"vr": "DS", "Value": [22.5]},
        "2198": {"vr": "DS", "Value": [20.0]},
        "2199": {"vr": "DS", "Value": [20.0]},
        "2200": {"vr": "DS", "Value": [20.0]},
        "2201": {"vr": "DS", "Value": [20.0]},
        "2202": {"vr": "DS", "Value": [20.0]},
        "2203": {"vr": "DS", "Value": [20.0]},
        "2204": {"vr": "DS", "Value": [20.0]},
        "2205": {"vr": "DS", "Value": [22.5]},
        "2206": {"vr": "DS", "Value": [20.0]},
        "2207": {"vr": "DS", "Value": [20.0]},
        "2208": {"vr": "DS", "Value": [22.5]},
        "2209": {"vr": "DS", "Value": [20.0]},
        "2210": {"vr": "DS", "Value": [20.0]},
        "2211": {"vr": "DS", "Value": [22.5]},
        "2212": {"vr": "DS", "Value": [22.5]},
        "2213": {"vr": "DS", "Value": [22.5]},
        "2214": {"vr": "DS", "Value": [20.0]},
        "2215": {"vr": "DS", "Value": [20.0]},
        "2216": {"vr": "DS", "Value": [20.0]},
        "2217": {"vr": "DS", "Value": [22.5]},
        "2218": {"vr": "DS", "Value": [22.5]},
        "2219": {"vr": "DS", "Value": [22.5]},
        "2220": {"vr": "DS", "Value": [20.0]},
        "2221": {"vr": "DS", "Value": [22.5]},
        "2222": {"vr": "DS", "Value": [22.5]},
        "2223": {"vr": "DS", "Value": [20.0]},
        "2224": {"vr": "DS", "Value": [22.5]},
        "2225": {"vr": "DS", "Value": [22.5]},
        "2226": {"vr": "DS", "Value": [20.0]},
        "2227": {"vr": "DS", "Value": [22.5]},
        "2228": {"vr": "DS", "Value": [22.5]},
        "2229": {"vr": "DS", "Value": [22.5]},
        "2230": {"vr": "DS", "Value": [20.0]},
        "2231": {"vr": "DS", "Value": [22.5]},
        "2232": {"vr": "DS", "Value": [20.0]},
        "2233": {"vr": "DS", "Value": [20.0]},
        "2234": {"vr": "DS", "Value": [22.5]},
        "2235": {"vr": "DS", "Value": [20.0]},
        "2236": {"vr": "DS", "Value": [22.5]},
        "2237": {"vr": "DS", "Value": [20.0]},
        "2238": {"vr": "DS", "Value": [20.0]},
        "2239": {"vr": "DS", "Value": [22.5]},
        "2240": {"vr": "DS", "Value": [20.0]},
        "2241": {"vr": "DS", "Value": [20.0]},
        "2242": {"vr": "DS", "Value": [22.5]},
        "2243": {"vr": "DS", "Value": [22.5]},
        "2244": {"vr": "DS", "Value": [20.0]},
        "2245": {"vr": "DS", "Value": [22.5]},
        "2246": {"vr": "DS", "Value": [20.0]},
        "2247": {"vr": "DS", "Value": [20.0]},
        "2248": {"vr": "DS", "Value": [20.0]},
        "2249": {"vr": "DS", "Value": [22.5]},
        "2250": {"vr": "DS", "Value": [20.0]},
        "2251": {"vr": "DS", "Value": [20.0]},
        "2252": {"vr": "DS", "Value": [22.5]},
        "2253": {"vr": "DS", "Value": [22.5]},
        "2254": {"vr": "DS", "Value": [20.0]},
        "2255": {"vr": "DS", "Value": [22.5]},
        "2256": {"vr": "DS", "Value": [20.0]},
        "2257": {"vr": "DS", "Value": [20.0]},
        "2258": {"vr": "DS", "Value": [22.5]},
        "2259": {"vr": "DS", "Value": [22.5]},
        "2260": {"vr": "DS", "Value": [22.5]},
        "2261": {"vr": "DS", "Value": [22.5]},
        "2262": {"vr": "DS", "Value": [22.5]},
        "2263": {"vr": "DS", "Value": [22.5]},
        "2264": {"vr": "DS", "Value": [22.5]},
        "2265": {"vr": "DS", "Value": [20.0]},
        "2266": {"vr": "DS", "Value": [20.0]},
        "2267": {"vr": "DS", "Value": [20.0]},
        "2268": {"vr": "DS", "Value": [22.5]},
        "2269": {"vr": "DS", "Value": [20.0]},
        "2270": {"vr": "DS", "Value": [20.0]},
        "2271": {"vr": "DS", "Value": [22.5]},
        "2272": {"vr": "DS", "Value": [22.5]},
        "2273": {"vr": "DS", "Value": [20.0]},
        "2274": {"vr": "DS", "Value": [22.5]},
        "2275": {"vr": "DS", "Value": [22.5]},
        "2276": {"vr": "DS", "Value": [22.5]},
        "2277": {"vr": "DS", "Value": [20.0]},
        "2278": {"vr": "DS", "Value": [20.0]},
        "2279": {"vr": "DS", "Value": [22.5]},
        "2280": {"vr": "DS", "Value": [22.5]},
        "2281": {"vr": "DS", "Value": [20.0]},
        "2282": {"vr": "DS", "Value": [20.0]},
        "2283": {"vr": "DS", "Value": [20.0]},
        "2284": {"vr": "DS", "Value": [20.0]},
        "2285": {"vr": "DS", "Value": [20.0]},
        "2286": {"vr": "DS", "Value": [22.5]},
        "2287": {"vr": "DS", "Value": [20.0]},
        "2288": {"vr": "DS", "Value": [22.5]},
        "2289": {"vr": "DS", "Value": [20.0]},
        "2290": {"vr": "DS", "Value": [22.5]},
        "2291": {"vr": "DS", "Value": [20.0]},
        "2292": {"vr": "DS", "Value": [22.5]},
        "2293": {"vr": "DS", "Value": [20.0]},
        "2294": {"vr": "DS", "Value": [22.5]},
        "2295": {"vr": "DS", "Value": [22.5]},
        "2296": {"vr": "DS", "Value": [20.0]},
        "2297": {"vr": "DS", "Value": [20.0]},
        "2298": {"vr": "DS", "Value": [20.0]},
        "2299": {"vr": "DS", "Value": [20.0]},
        "2300": {"vr": "DS", "Value": [22.5]},
        "2301": {"vr": "DS", "Value": [22.5]},
        "2302": {"vr": "DS", "Value": [22.5]},
        "2303": {"vr": "DS", "Value": [22.5]},
        "2304": {"vr": "DS", "Value": [22.5]},
        "2305": {"vr": "DS", "Value": [22.5]},
        "2306": {"vr": "DS", "Value": [22.5]},
        "2307": {"vr": "DS", "Value": [20.0]},
        "2308": {"vr": "DS", "Value": [22.5]},
        "2309": {"vr": "DS", "Value": [20.0]},
        "2310": {"vr": "DS", "Value": [22.5]},
        "2311": {"vr": "DS", "Value": [20.0]},
        "2312": {"vr": "DS", "Value": [22.5]},
        "2313": {"vr": "DS", "Value": [22.5]},
        "2314": {"vr": "DS", "Value": [20.0]},
        "2315": {"vr": "DS", "Value": [22.5]},
        "2316": {"vr": "DS", "Value": [22.5]},
        "2317": {"vr": "DS", "Value": [22.5]},
        "2318": {"vr": "DS", "Value": [20.0]},
        "2319": {"vr": "DS", "Value": [20.0]},
        "2320": {"vr": "DS", "Value": [20.0]},
        "2321": {"vr": "DS", "Value": [22.5]},
        "2322": {"vr": "DS", "Value": [22.5]},
        "2323": {"vr": "DS", "Value": [20.0]},
        "2324": {"vr": "DS", "Value": [22.5]},
        "2325": {"vr": "DS", "Value": [22.5]},
        "2326": {"vr": "DS", "Value": [20.0]},
        "2327": {"vr": "DS", "Value": [22.5]},
        "2328": {"vr": "DS", "Value": [22.5]},
        "2329": {"vr": "DS", "Value": [20.0]},
        "2330": {"vr": "DS", "Value": [22.5]},
        "2331": {"vr": "DS", "Value": [22.5]},
        "2332": {"vr": "DS", "Value": [22.5]},
        "2333": {"vr": "DS", "Value": [22.5]},
        "2334": {"vr": "DS", "Value": [20.0]},
        "2335": {"vr": "DS", "Value": [20.0]},
        "2336": {"vr": "DS", "Value": [22.5]},
        "2337": {"vr": "DS", "Value": [22.5]},
        "2338": {"vr": "DS", "Value": [22.5]},
        "2339": {"vr": "DS", "Value": [22.5]},
        "2340": {"vr": "DS", "Value": [20.0]},
        "2341": {"vr": "DS", "Value": [20.0]},
        "2342": {"vr": "DS", "Value": [20.0]},
        "2343": {"vr": "DS", "Value": [22.5]},
        "2344": {"vr": "DS", "Value": [20.0]},
        "2345": {"vr": "DS", "Value": [20.0]},
        "2346": {"vr": "DS", "Value": [22.5]},
        "2347": {"vr": "DS", "Value": [22.5]},
        "2348": {"vr": "DS", "Value": [20.0]},
        "2349": {"vr": "DS", "Value": [22.5]},
        "2350": {"vr": "DS", "Value": [20.0]},
        "2351": {"vr": "DS", "Value": [22.5]},
        "2352": {"vr": "DS", "Value": [22.5]},
        "2353": {"vr": "DS", "Value": [22.5]},
        "2354": {"vr": "DS", "Value": [20.0]},
        "2355": {"vr": "DS", "Value": [22.5]},
        "2356": {"vr": "DS", "Value": [22.5]},
        "2357": {"vr": "DS", "Value": [22.5]},
        "2358": {"vr": "DS", "Value": [22.5]},
        "2359": {"vr": "DS", "Value": [22.5]},
        "2360": {"vr": "DS", "Value": [20.0]},
        "2361": {"vr": "DS", "Value": [22.5]},
        "2362": {"vr": "DS", "Value": [22.5]},
        "2363": {"vr": "DS", "Value": [20.0]},
        "2364": {"vr": "DS", "Value": [20.0]},
        "2365": {"vr": "DS", "Value": [22.5]},
        "2366": {"vr": "DS", "Value": [20.0]},
        "2367": {"vr": "DS", "Value": [20.0]},
        "2368": {"vr": "DS", "Value": [22.5]},
        "2369": {"vr": "DS", "Value": [20.0]},
        "2370": {"vr": "DS", "Value": [20.0]},
        "2371": {"vr": "DS", "Value": [22.5]},
        "2372": {"vr": "DS", "Value": [20.0]},
        "2373": {"vr": "DS", "Value": [22.5]},
        "2374": {"vr": "DS", "Value": [22.5]},
        "2375": {"vr": "DS", "Value": [20.0]},
        "2376": {"vr": "DS", "Value": [20.0]},
        "2377": {"vr": "DS", "Value": [22.5]},
        "2378": {"vr": "DS", "Value": [22.5]},
        "2379": {"vr": "DS", "Value": [22.5]},
        "2380": {"vr": "DS", "Value": [20.0]},
        "2381": {"vr": "DS", "Value": [22.5]},
        "2382": {"vr": "DS", "Value": [22.5]},
        "2383": {"vr": "DS", "Value": [22.5]},
        "2384": {"vr": "DS", "Value": [22.5]},
        "2385": {"vr": "DS", "Value": [20.0]},
        "2386": {"vr": "DS", "Value": [20.0]},
        "2387": {"vr": "DS", "Value": [20.0]},
        "2388": {"vr": "DS", "Value": [20.0]},
        "2389": {"vr": "DS", "Value": [22.5]},
        "2390": {"vr": "DS", "Value": [20.0]},
        "2391": {"vr": "DS", "Value": [20.0]},
        "2392": {"vr": "DS", "Value": [20.0]},
        "2393": {"vr": "DS", "Value": [20.0]},
        "2394": {"vr": "DS", "Value": [20.0]},
        "2395": {"vr": "DS", "Value": [20.0]},
        "2396": {"vr": "DS", "Value": [22.5]},
        "2397": {"vr": "DS", "Value": [20.0]},
        "2398": {"vr": "DS", "Value": [20.0]},
        "2399": {"vr": "DS", "Value": [22.5]},
        "2400": {"vr": "DS", "Value": [22.5]},
        "2401": {"vr": "DS", "Value": [22.5]},
        "2402": {"vr": "DS", "Value": [22.5]},
        "2403": {"vr": "DS", "Value": [20.0]},
        "2404": {"vr": "DS", "Value": [20.0]},
        "2405": {"vr": "DS", "Value": [20.0]},
        "2406": {"vr": "DS", "Value": [22.5]},
        "2407": {"vr": "DS", "Value": [22.5]},
        "2408": {"vr": "DS", "Value": [20.0]},
        "2409": {"vr": "DS", "Value": [20.0]},
        "2410": {"vr": "DS", "Value": [20.0]},
        "2411": {"vr": "DS", "Value": [22.5]},
        "2412": {"vr": "DS", "Value": [22.5]},
        "2413": {"vr": "DS", "Value": [22.5]},
        "2414": {"vr": "DS", "Value": [20.0]},
        "2415": {"vr": "DS", "Value": [20.0]},
        "2416": {"vr": "DS", "Value": [22.5]},
        "2417": {"vr": "DS", "Value": [22.5]},
        "2418": {"vr": "DS", "Value": [20.0]},
        "2419": {"vr": "DS", "Value": [22.5]},
        "2420": {"vr": "DS", "Value": [20.0]},
        "2421": {"vr": "DS", "Value": [22.5]},
        "2422": {"vr": "DS", "Value": [20.0]},
        "2423": {"vr": "DS", "Value": [22.5]},
        "2424": {"vr": "DS", "Value": [20.0]},
        "2425": {"vr": "DS", "Value": [20.0]},
        "2426": {"vr": "DS", "Value": [22.5]},
        "2427": {"vr": "DS", "Value": [22.5]},
        "2428": {"vr": "DS", "Value": [20.0]},
        "2429": {"vr": "DS", "Value": [20.0]},
        "2430": {"vr": "DS", "Value": [20.0]},
        "2431": {"vr": "DS", "Value": [22.5]},
        "2432": {"vr": "DS", "Value": [22.5]},
        "2433": {"vr": "DS", "Value": [20.0]},
        "2434": {"vr": "DS", "Value": [22.5]},
        "2435": {"vr": "DS", "Value": [20.0]},
        "2436": {"vr": "DS", "Value": [20.0]},
        "2437": {"vr": "DS", "Value": [20.0]},
        "2438": {"vr": "DS", "Value": [20.0]},
        "2439": {"vr": "DS", "Value": [20.0]},
        "2440": {"vr": "DS", "Value": [22.5]},
        "2441": {"vr": "DS", "Value": [22.5]},
        "2442": {"vr": "DS", "Value": [22.5]},
        "2443": {"vr": "DS", "Value": [22.5]},
        "2444": {"vr": "DS", "Value": [22.5]},
        "2445": {"vr": "DS", "Value": [22.5]},
        "2446": {"vr": "DS", "Value": [22.5]},
        "2447": {"vr": "DS", "Value": [22.5]},
        "2448": {"vr": "DS", "Value": [22.5]},
        "2449": {"vr": "DS", "Value": [20.0]},
        "2450": {"vr": "DS", "Value": [22.5]},
        "2451": {"vr": "DS", "Value": [22.5]},
        "2452": {"vr": "DS", "Value": [20.0]},
        "2453": {"vr": "DS", "Value": [22.5]},
        "2454": {"vr": "DS", "Value": [20.0]},
        "2455": {"vr": "DS", "Value": [20.0]},
        "2456": {"vr": "DS", "Value": [20.0]},
        "2457": {"vr": "DS", "Value": [22.5]},
        "2458": {"vr": "DS", "Value": [20.0]},
        "2459": {"vr": "DS", "Value": [22.5]},
        "2460": {"vr": "DS", "Value": [20.0]},
        "2461": {"vr": "DS", "Value": [20.0]},
        "2462": {"vr": "DS", "Value": [20.0]},
        "2463": {"vr": "DS", "Value": [20.0]},
        "2464": {"vr": "DS", "Value": [22.5]},
        "2465": {"vr": "DS", "Value": [20.0]},
        "2466": {"vr": "DS", "Value": [20.0]},
        "2467": {"vr": "DS", "Value": [20.0]},
        "2468": {"vr": "DS", "Value": [20.0]},
        "2469": {"vr": "DS", "Value": [22.5]},
        "2470": {"vr": "DS", "Value": [20.0]},
        "2471": {"vr": "DS", "Value": [22.5]},
        "2472": {"vr": "DS", "Value": [22.5]},
        "2473": {"vr": "DS", "Value": [22.5]},
        "2474": {"vr": "DS", "Value": [20.0]},
        "2475": {"vr": "DS", "Value": [22.5]},
        "2476": {"vr": "DS", "Value": [22.5]},
        "2477": {"vr": "DS", "Value": [20.0]},
        "2478": {"vr": "DS", "Value": [20.0]},
        "2479": {"vr": "DS", "Value": [20.0]},
        "2480": {"vr": "DS", "Value": [22.5]},
        "2481": {"vr": "DS", "Value": [22.5]},
        "2482": {"vr": "DS", "Value": [20.0]},
        "2483": {"vr": "DS", "Value": [20.0]},
        "2484": {"vr": "DS", "Value": [22.5]},
        "2485": {"vr": "DS", "Value": [22.5]},
        "2486": {"vr": "DS", "Value": [22.5]},
        "2487": {"vr": "DS", "Value": [20.0]},
        "2488": {"vr": "DS", "Value": [20.0]},
        "2489": {"vr": "DS", "Value": [22.5]},
        "2490": {"vr": "DS", "Value": [20.0]},
        "2491": {"vr": "DS", "Value": [20.0]},
        "2492": {"vr": "DS", "Value": [20.0]},
        "2493": {"vr": "DS", "Value": [20.0]},
        "2494": {"vr": "DS", "Value": [22.5]},
        "2495": {"vr": "DS", "Value": [22.5]},
        "2496": {"vr": "DS", "Value": [20.0]},
        "2497": {"vr": "DS", "Value": [20.0]},
        "2498": {"vr": "DS", "Value": [22.5]},
        "2499": {"vr": "DS", "Value": [22.5]},
        "2500": {"vr": "DS", "Value": [22.5]},
        "2501": {"vr": "DS", "Value": [22.5]},
        "2502": {"vr": "DS", "Value": [20.0]},
        "2503": {"vr": "DS", "Value": [22.5]},
        "2504": {"vr": "DS", "Value": [22.5]},
        "2505": {"vr": "DS", "Value": [22.5]},
        "2506": {"vr": "DS", "Value": [20.0]},
        "2507": {"vr": "DS", "Value": [20.0]},
        "2508": {"vr": "DS", "Value": [22.5]},
        "2509": {"vr": "DS", "Value": [22.5]},
        "2510": {"vr": "DS", "Value": [22.5]},
        "2511": {"vr": "DS", "Value": [20.0]},
        "2512": {"vr": "DS", "Value": [20.0]},
        "2513": {"vr": "DS", "Value": [22.5]},
        "2514": {"vr": "DS", "Value": [20.0]},
        "2515": {"vr": "DS", "Value": [20.0]},
        "2516": {"vr": "DS", "Value": [20.0]},
        "2517": {"vr": "DS", "Value": [20.0]},
        "2518": {"vr": "DS", "Value": [22.5]},
        "2519": {"vr": "DS", "Value": [20.0]},
        "2520": {"vr": "DS", "Value": [20.0]},
        "2521": {"vr": "DS", "Value": [20.0]},
        "2522": {"vr": "DS", "Value": [20.0]},
        "2523": {"vr": "DS", "Value": [20.0]},
        "2524": {"vr": "DS", "Value": [20.0]},
        "2525": {"vr": "DS", "Value": [22.5]},
        "2526": {"vr": "DS", "Value": [20.0]},
        "2527": {"vr": "DS", "Value": [22.5]},
        "2528": {"vr": "DS", "Value": [22.5]},
        "2529": {"vr": "DS", "Value": [20.0]},
        "2530": {"vr": "DS", "Value": [22.5]},
        "2531": {"vr": "DS", "Value": [20.0]},
        "2532": {"vr": "DS", "Value": [22.5]},
        "2533": {"vr": "DS", "Value": [20.0]},
        "2534": {"vr": "DS", "Value": [22.5]},
        "2535": {"vr": "DS", "Value": [20.0]},
        "2536": {"vr": "DS", "Value": [22.5]},
        "2537": {"vr": "DS", "Value": [20.0]},
        "2538": {"vr": "DS", "Value": [22.5]},
        "2539": {"vr": "DS", "Value": [20.0]},
        "2540": {"vr": "DS", "Value": [22.5]},
        "2541": {"vr": "DS", "Value": [22.5]},
        "2542": {"vr": "DS", "Value": [20.0]},
        "2543": {"vr": "DS", "Value": [22.5]},
        "2544": {"vr": "DS", "Value": [22.5]},
        "2545": {"vr": "DS", "Value": [22.5]},
        "2546": {"vr": "DS", "Value": [22.5]},
        "2547": {"vr": "DS", "Value": [22.5]},
        "2548": {"vr": "DS", "Value": [22.5]},
        "2549": {"vr": "DS", "Value": [22.5]},
        "2550": {"vr": "DS", "Value": [20.0]},
        "2551": {"vr": "DS", "Value": [22.5]},
        "2552": {"vr": "DS", "Value": [22.5]},
        "2553": {"vr": "DS", "Value": [20.0]},
        "2554": {"vr": "DS", "Value": [22.5]},
        "2555": {"vr": "DS", "Value": [22.5]},
        "2556": {"vr": "DS", "Value": [22.5]},
        "2557": {"vr": "DS", "Value": [22.5]},
        "2558": {"vr": "DS", "Value": [22.5]},
        "2559": {"vr": "DS", "Value": [20.0]},
        "2560": {"vr": "DS", "Value": [20.0]},
        "2561": {"vr": "DS", "Value": [22.5]},
        "2562": {"vr": "DS", "Value": [20.0]},
        "2563": {"vr": "DS", "Value": [20.0]},
        "2564": {"vr": "DS", "Value": [20.0]},
        "2565": {"vr": "DS", "Value": [20.0]},
        "2566": {"vr": "DS", "Value": [22.5]},
        "2567": {"vr": "DS", "Value": [20.0]},
        "2568": {"vr": "DS", "Value": [20.0]},
        "2569": {"vr": "DS", "Value": [20.0]},
        "2570": {"vr": "DS", "Value": [22.5]},
        "2571": {"vr": "DS", "Value": [22.5]},
        "2572": {"vr": "DS", "Value": [20.0]},
        "2573": {"vr": "DS", "Value": [22.5]},
        "2574": {"vr": "DS", "Value": [22.5]},
        "2575": {"vr": "DS", "Value": [20.0]},
        "2576": {"vr": "DS", "Value": [22.5]},
        "2577": {"vr": "DS", "Value": [20.0]},
        "2578": {"vr": "DS", "Value": [20.0]},
        "2579": {"vr": "DS", "Value": [20.0]},
        "2580": {"vr": "DS", "Value": [22.5]},
        "2581": {"vr": "DS", "Value": [22.5]},
        "2582": {"vr": "DS", "Value": [22.5]},
        "2583": {"vr": "DS", "Value": [22.5]},
        "2584": {"vr": "DS", "Value": [22.5]},
        "2585": {"vr": "DS", "Value": [22.5]},
        "2586": {"vr": "DS", "Value": [22.5]},
        "2587": {"vr": "DS", "Value": [20.0]},
        "2588": {"vr": "DS", "Value": [22.5]},
        "2589": {"vr": "DS", "Value": [20.0]},
        "2590": {"vr": "DS", "Value": [20.0]},
        "2591": {"vr": "DS", "Value": [22.5]},
        "2592": {"vr": "DS", "Value": [20.0]},
        "2593": {"vr": "DS", "Value": [22.5]},
        "2594": {"vr": "DS", "Value": [20.0]},
        "2595": {"vr": "DS", "Value": [20.0]},
        "2596": {"vr": "DS", "Value": [22.5]},
        "2597": {"vr": "DS", "Value": [20.0]},
        "2598": {"vr": "DS", "Value": [22.5]},
        "2599": {"vr": "DS", "Value": [20.0]},
        "2600": {"vr": "DS", "Value": [22.5]},
        "2601": {"vr": "DS", "Value": [22.5]},
        "2602": {"vr": "DS", "Value": [20.0]},
        "2603": {"vr": "DS", "Value": [22.5]},
        "2604": {"vr": "DS", "Value": [20.0]},
        "2605": {"vr": "DS", "Value": [20.0]},
        "2606": {"vr": "DS", "Value": [20.0]},
        "2607": {"vr": "DS", "Value": [22.5]},
        "2608": {"vr": "DS", "Value": [20.0]},
        "2609": {"vr": "DS", "Value": [20.0]},
        "2610": {"vr": "DS", "Value": [22.5]},
        "2611": {"vr": "DS", "Value": [22.5]},
        "2612": {"vr": "DS", "Value": [22.5]},
        "2613": {"vr": "DS", "Value": [20.0]},
        "2614": {"vr": "DS", "Value": [20.0]},
        "2615": {"vr": "DS", "Value": [20.0]},
        "2616": {"vr": "DS", "Value": [20.0]},
        "2617": {"vr": "DS", "Value": [20.0]},
        "2618": {"vr": "DS", "Value": [22.5]},
        "2619": {"vr": "DS", "Value": [22.5]},
        "2620": {"vr": "DS", "Value": [20.0]},
        "2621": {"vr": "DS", "Value": [22.5]},
        "2622": {"vr": "DS", "Value": [20.0]},
        "2623": {"vr": "DS", "Value": [22.5]},
        "2624": {"vr": "DS", "Value": [22.5]},
        "2625": {"vr": "DS", "Value": [22.5]},
        "2626": {"vr": "DS", "Value": [20.0]},
        "2627": {"vr": "DS", "Value": [22.5]},
        "2628": {"vr": "DS", "Value": [22.5]},
        "2629": {"vr": "DS", "Value": [22.5]},
        "2630": {"vr": "DS", "Value": [22.5]},
        "2631": {"vr": "DS", "Value": [22.5]},
        "2632": {"vr": "DS", "Value": [22.5]},
        "2633": {"vr": "DS", "Value": [22.5]},
        "2634": {"vr": "DS", "Value": [20.0]},
        "2635": {"vr": "DS", "Value": [20.0]},
        "2636": {"vr": "DS", "Value": [20.0]},
        "2637": {"vr": "DS", "Value": [20.0]},
        "2638": {"vr": "DS", "Value": [22.5]},
        "2639": {"vr": "DS", "Value": [22.5]},
        "2640": {"vr": "DS", "Value": [22.5]},
        "2641": {"vr": "DS", "Value": [20.0]},
        "2642": {"vr": "DS", "Value": [20.0]},
        "2643": {"vr": "DS", "Value": [20.0]},
        "2644": {"vr": "DS", "Value": [20.0]},
        "2645": {"vr": "DS", "Value": [22.5]},
        "2646": {"vr": "DS", "Value": [20.0]},
        "2647": {"vr": "DS", "Value": [20.0]},
        "2648": {"vr": "DS", "Value": [22.5]},
        "2649": {"vr": "DS", "Value": [22.5]},
        "2650": {"vr": "DS", "Value": [22.5]},
        "2651": {"vr": "DS", "Value": [22.5]},
        "2652": {"vr": "DS", "Value": [20.0]},
        "2653": {"vr": "DS", "Value": [20.0]},
        "2654": {"vr": "DS", "Value": [20.0]},
        "2655": {"vr": "DS", "Value": [22.5]},
        "2656": {"vr": "DS", "Value": [22.5]},
        "2657": {"vr": "DS", "Value": [20.0]},
        "2658": {"vr": "DS", "Value": [22.5]},
        "2659": {"vr": "DS", "Value": [20.0]},
        "2660": {"vr": "DS", "Value": [20.0]},
        "2661": {"vr": "DS", "Value": [20.0]},
        "2662": {"vr": "DS", "Value": [22.5]},
        "2663": {"vr": "DS", "Value": [20.0]},
        "2664": {"vr": "DS", "Value": [20.0]},
        "2665": {"vr": "DS", "Value": [22.5]},
        "2666": {"vr": "DS", "Value": [20.0]},
        "2667": {"vr": "DS", "Value": [20.0]},
        "2668": {"vr": "DS", "Value": [22.5]},
        "2669": {"vr": "DS", "Value": [20.0]},
        "2670": {"vr": "DS", "Value": [22.5]},
        "2671": {"vr": "DS", "Value": [22.5]},
        "2672": {"vr": "DS", "Value": [20.0]},
        "2673": {"vr": "DS", "Value": [22.5]},
        "2674": {"vr": "DS", "Value": [20.0]},
        "2675": {"vr": "DS", "Value": [20.0]},
        "2676": {"vr": "DS", "Value": [22.5]},
        "2677": {"vr": "DS", "Value": [22.5]},
        "2678": {"vr": "DS", "Value": [22.5]},
        "2679": {"vr": "DS", "Value": [20.0]},
        "2680": {"vr": "DS", "Value": [20.0]},
        "2681": {"vr": "DS", "Value": [22.5]},
        "2682": {"vr": "DS", "Value": [22.5]},
        "2683": {"vr": "DS", "Value": [20.0]},
        "2684": {"vr": "DS", "Value": [22.5]},
        "2685": {"vr": "DS", "Value": [20.0]},
        "2686": {"vr": "DS", "Value": [20.0]},
        "2687": {"vr": "DS", "Value": [22.5]},
        "2688": {"vr": "DS", "Value": [20.0]},
        "2689": {"vr": "DS", "Value": [22.5]},
        "2690": {"vr": "DS", "Value": [22.5]},
        "2691": {"vr": "DS", "Value": [22.5]},
        "2692": {"vr": "DS", "Value": [20.0]},
        "2693": {"vr": "DS", "Value": [22.5]},
        "2694": {"vr": "DS", "Value": [22.5]},
        "2695": {"vr": "DS", "Value": [22.5]},
        "2696": {"vr": "DS", "Value": [22.5]},
        "2697": {"vr": "DS", "Value": [22.5]},
        "2698": {"vr": "DS", "Value": [22.5]},
        "2699": {"vr": "DS", "Value": [22.5]},
        "2700": {"vr": "DS", "Value": [20.0]},
        "2701": {"vr": "DS", "Value": [20.0]},
        "2702": {"vr": "DS", "Value": [22.5]},
        "2703": {"vr": "DS", "Value": [22.5]},
        "2704": {"vr": "DS", "Value": [20.0]},
        "2705": {"vr": "DS", "Value": [22.5]},
        "2706": {"vr": "DS", "Value": [22.5]},
        "2707": {"vr": "DS", "Value": [20.0]},
        "2708": {"vr": "DS", "Value": [20.0]},
        "2709": {"vr": "DS", "Value": [20.0]},
        "2710": {"vr": "DS", "Value": [20.0]},
        "2711": {"vr": "DS", "Value": [22.5]},
        "2712": {"vr": "DS", "Value": [20.0]},
        "2713": {"vr": "DS", "Value": [22.5]},
        "2714": {"vr": "DS", "Value": [22.5]},
        "2715": {"vr": "DS", "Value": [22.5]},
        "2716": {"vr": "DS", "Value": [22.5]},
        "2717": {"vr": "DS", "Value": [22.5]},
        "2718": {"vr": "DS", "Value": [22.5]},
        "2719": {"vr": "DS", "Value": [20.0]},
        "2720": {"vr": "DS", "Value": [20.0]},
        "2721": {"vr": "DS", "Value": [22.5]},
        "2722": {"vr": "DS", "Value": [20.0]},
        "2723": {"vr": "DS", "Value": [22.5]},
        "2724": {"vr": "DS", "Value": [20.0]},
        "2725": {"vr": "DS", "Value": [22.5]},
        "2726": {"vr": "DS", "Value": [20.0]},
        "2727": {"vr": "DS", "Value": [20.0]},
        "2728": {"vr": "DS", "Value": [22.5]},
        "2729": {"vr": "DS", "Value": [22.5]},
        "2730": {"vr": "DS", "Value": [22.5]},
        "2731": {"vr": "DS", "Value": [22.5]},
        "2732": {"vr": "DS", "Value": [20.0]},
        "2733": {"vr": "DS", "Value": [22.5]},
        "2734": {"vr": "DS", "Value": [20.0]},
        "2735": {"vr": "DS", "Value": [22.5]},
        "2736": {"vr": "DS", "Value": [22.5]},
        "2737": {"vr": "DS", "Value": [22.5]},
        "2738": {"vr": "DS", "Value": [20.0]},
        "2739": {"vr": "DS", "Value": [20.0]},
        "2740": {"vr": "DS", "Value": [20.0]},
        "2741": {"vr": "DS", "Value": [22.5]},
        "2742": {"vr": "DS", "Value": [22.5]},
        "2743": {"vr": "DS", "Value": [22.5]},
        "2744": {"vr": "DS", "Value": [22.5]},
        "2745": {"vr": "DS", "Value": [22.5]},
        "2746": {"vr": "DS", "Value": [20.0]},
        "2747": {"vr": "DS", "Value": [20.0]},
        "2748": {"vr": "DS", "Value": [22.5]},
        "2749": {"vr": "DS", "Value": [22.5]},
        "2750": {"vr": "DS", "Value": [22.5]},
        "2751": {"vr": "DS", "Value": [22.5]},
        "2752": {"vr": "DS", "Value": [20.0]},
        "2753": {"vr": "DS", "Value": [20.0]},
        "2754": {"vr": "DS", "Value": [20.0]},
        "2755": {"vr": "DS", "Value": [22.5]},
        "2756": {"vr": "DS", "Value": [20.0]},
        "2757": {"vr": "DS", "Value": [20.0]},
        "2758": {"vr": "DS", "Value": [20.0]},
        "2759": {"vr": "DS", "Value": [20.0]},
        "2760": {"vr": "DS", "Value": [22.5]},
        "2761": {"vr": "DS", "Value": [22.5]},
        "2762": {"vr": "DS", "Value": [22.5]},
        "2763": {"vr": "DS", "Value": [20.0]},
        "2764": {"vr": "DS", "Value": [22.5]},
        "2765": {"vr": "DS", "Value": [22.5]},
        "2766": {"vr": "DS", "Value": [20.0]},
        "2767": {"vr": "DS", "Value": [20.0]},
        "2768": {"vr": "DS", "Value": [22.5]},
        "2769": {"vr": "DS", "Value": [20.0]},
        "2770": {"vr": "DS", "Value": [20.0]},
        "2771": {"vr": "DS", "Value": [22.5]},
        "2772": {"vr": "DS", "Value": [22.5]},
        "2773": {"vr": "DS", "Value": [22.5]},
        "2774": {"vr": "DS", "Value": [22.5]},
        "2775": {"vr": "DS", "Value": [22.5]},
        "2776": {"vr": "DS", "Value": [20.0]},
        "2777": {"vr": "DS", "Value": [20.0]},
        "2778": {"vr": "DS", "Value": [22.5]},
        "2779": {"vr": "DS", "Value": [20.0]},
        "2780": {"vr": "DS", "Value": [20.0]},
        "2781": {"vr": "DS", "Value": [20.0]},
        "2782": {"vr": "DS", "Value": [20.0]},
        "2783": {"vr": "DS", "Value": [20.0]},
        "2784": {"vr": "DS", "Value": [22.5]},
        "2785": {"vr": "DS", "Value": [22.5]},
        "2786": {"vr": "DS", "Value": [22.5]},
        "2787": {"vr": "DS", "Value": [22.5]},
        "2788": {"vr": "DS", "Value": [22.5]},
        "2789": {"vr": "DS", "Value": [20.0]},
        "2790": {"vr": "DS", "Value": [20.0]},
        "2791": {"vr": "DS", "Value": [22.5]},
        "2792": {"vr": "DS", "Value": [22.5]},
        "2793": {"vr": "DS", "Value": [20.0]},
        "2794": {"vr": "DS", "Value": [22.5]},
        "2795": {"vr": "DS", "Value": [20.0]},
        "2796": {"vr": "DS", "Value": [22.5]},
        "2797": {"vr": "DS", "Value": [20.0]},
        "2798": {"vr": "DS", "Value": [22.5]},
        "2799": {"vr": "DS", "Value": [20.0]},
        "2800": {"vr": "DS", "Value": [22.5]},
        "2801": {"vr": "DS", "Value": [22.5]},
        "2802": {"vr": "DS", "Value": [22.5]},
        "2803": {"vr": "DS", "Value": [22.5]},
        "2804": {"vr": "DS", "Value": [20.0]},
        "2805": {"vr": "DS", "Value": [20.0]},
        "2806": {"vr": "DS", "Value": [22.5]},
        "2807": {"vr": "DS", "Value": [22.5]},
        "2808": {"vr": "DS", "Value": [20.0]},
        "2809": {"vr": "DS", "Value": [20.0]},
        "2810": {"vr": "DS", "Value": [20.0]},
        "2811": {"vr": "DS", "Value": [20.0]},
        "2812": {"vr": "DS", "Value": [20.0]},
        "2813": {"vr": "DS", "Value": [22.5]},
        "2814": {"vr": "DS", "Value": [22.5]},
        "2815": {"vr": "DS", "Value": [22.5]},
        "2816": {"vr": "DS", "Value": [22.5]},
        "2817": {"vr": "DS", "Value": [20.0]},
        "2818": {"vr": "DS", "Value": [20.0]},
        "2819": {"vr": "DS", "Value": [22.5]},
        "2820": {"vr": "DS", "Value": [22.5]},
        "2821": {"vr": "DS", "Value": [20.0]},
        "2822": {"vr": "DS", "Value": [22.5]},
        "2823": {"vr": "DS", "Value": [22.5]},
        "2824": {"vr": "DS", "Value": [22.5]},
        "2825": {"vr": "DS", "Value": [22.5]},
        "2826": {"vr": "DS", "Value": [20.0]},
        "2827": {"vr": "DS", "Value": [20.0]},
        "2828": {"vr": "DS", "Value": [20.0]},
        "2829": {"vr": "DS", "Value": [22.5]},
        "2830": {"vr": "DS", "Value": [20.0]},
        "2831": {"vr": "DS", "Value": [20.0]},
        "2832": {"vr": "DS", "Value": [22.5]},
        "2833": {"vr": "DS", "Value": [22.5]},
        "2834": {"vr": "DS", "Value": [20.0]},
        "2835": {"vr": "DS", "Value": [20.0]},
        "2836": {"vr": "DS", "Value": [22.5]},
        "2837": {"vr": "DS", "Value": [22.5]},
        "2838": {"vr": "DS", "Value": [22.5]},
        "2839": {"vr": "DS", "Value": [22.5]},
        "2840": {"vr": "DS", "Value": [20.0]},
        "2841": {"vr": "DS", "Value": [20.0]},
        "2842": {"vr": "DS", "Value": [20.0]},
        "2843": {"vr": "DS", "Value": [22.5]},
        "2844": {"vr": "DS", "Value": [20.0]},
        "2845": {"vr": "DS", "Value": [22.5]},
        "2846": {"vr": "DS", "Value": [22.5]},
        "2847": {"vr": "DS", "Value": [20.0]},
        "2848": {"vr": "DS", "Value": [20.0]},
        "2849": {"vr": "DS", "Value": [20.0]},
        "2850": {"vr": "DS", "Value": [20.0]},
        "2851": {"vr": "DS", "Value": [20.0]},
        "2852": {"vr": "DS", "Value": [20.0]},
        "2853": {"vr": "DS", "Value": [20.0]},
        "2854": {"vr": "DS", "Value": [22.5]},
        "2855": {"vr": "DS", "Value": [22.5]},
        "2856": {"vr": "DS", "Value": [20.0]},
        "2857": {"vr": "DS", "Value": [20.0]},
        "2858": {"vr": "DS", "Value": [22.5]},
        "2859": {"vr": "DS", "Value": [22.5]},
        "2860": {"vr": "DS", "Value": [22.5]},
        "2861": {"vr": "DS", "Value": [22.5]},
        "2862": {"vr": "DS", "Value": [22.5]},
        "2863": {"vr": "DS", "Value": [22.5]},
        "2864": {"vr": "DS", "Value": [22.5]},
        "2865": {"vr": "DS", "Value": [20.0]},
        "2866": {"vr": "DS", "Value": [20.0]},
        "2867": {"vr": "DS", "Value": [20.0]},
        "2868": {"vr": "DS", "Value": [22.5]},
        "2869": {"vr": "DS", "Value": [20.0]},
        "2870": {"vr": "DS", "Value": [20.0]},
        "2871": {"vr": "DS", "Value": [20.0]},
        "2872": {"vr": "DS", "Value": [22.5]},
        "2873": {"vr": "DS", "Value": [20.0]},
        "2874": {"vr": "DS", "Value": [22.5]},
        "2875": {"vr": "DS", "Value": [22.5]},
        "2876": {"vr": "DS", "Value": [22.5]},
        "2877": {"vr": "DS", "Value": [20.0]},
        "2878": {"vr": "DS", "Value": [20.0]},
        "2879": {"vr": "DS", "Value": [22.5]},
        "2880": {"vr": "DS", "Value": [22.5]},
        "2881": {"vr": "DS", "Value": [20.0]},
        "2882": {"vr": "DS", "Value": [22.5]},
        "2883": {"vr": "DS", "Value": [22.5]},
        "2884": {"vr": "DS", "Value": [22.5]},
        "2885": {"vr": "DS", "Value": [22.5]},
        "2886": {"vr": "DS", "Value": [22.5]},
        "2887": {"vr": "DS", "Value": [22.5]},
        "2888": {"vr": "DS", "Value": [22.5]},
        "2889": {"vr": "DS", "Value": [22.5]},
        "2890": {"vr": "DS", "Value": [20.0]},
        "2891": {"vr": "DS", "Value": [22.5]},
        "2892": {"vr": "DS", "Value": [22.5]},
        "2893": {"vr": "DS", "Value": [20.0]},
        "2894": {"vr": "DS", "Value": [22.5]},
        "2895": {"vr": "DS", "Value": [22.5]},
        "2896": {"vr": "DS", "Value": [22.5]},
        "2897": {"vr": "DS", "Value": [20.0]},
        "2898": {"vr": "DS", "Value": [22.5]},
        "2899": {"vr": "DS", "Value": [22.5]},
        "2900": {"vr": "DS", "Value": [20.0]},
        "2901": {"vr": "DS", "Value": [22.5]},
        "2902": {"vr": "DS", "Value": [20.0]},
        "2903": {"vr": "DS", "Value": [22.5]},
        "2904": {"vr": "DS", "Value": [20.0]},
        "2905": {"vr": "DS", "Value": [22.5]},
        "2906": {"vr": "DS", "Value": [20.0]},
        "2907": {"vr": "DS", "Value": [20.0]},
        "2908": {"vr": "DS", "Value": [22.5]},
        "2909": {"vr": "DS", "Value": [22.5]},
        "2910": {"vr": "DS", "Value": [20.0]},
        "2911": {"vr": "DS", "Value": [20.0]},
        "2912": {"vr": "DS", "Value": [22.5]},
        "2913": {"vr": "DS", "Value": [20.0]},
        "2914": {"vr": "DS", "Value": [20.0]},
        "2915": {"vr": "DS", "Value": [20.0]},
        "2916": {"vr": "DS", "Value": [22.5]},
        "2917": {"vr": "DS", "Value": [20.0]},
        "2918": {"vr": "DS", "Value": [20.0]},
        "2919": {"vr": "DS", "Value": [22.5]},
        "2920": {"vr": "DS", "Value": [22.5]},
        "2921": {"vr": "DS", "Value": [22.5]},
        "2922": {"vr": "DS", "Value": [22.5]},
        "2923": {"vr": "DS", "Value": [20.0]},
        "2924": {"vr": "DS", "Value": [20.0]},
        "2925": {"vr": "DS", "Value": [20.0]},
        "2926": {"vr": "DS", "Value": [22.5]},
        "2927": {"vr": "DS", "Value": [22.5]},
        "2928": {"vr": "DS", "Value": [20.0]},
        "2929": {"vr": "DS", "Value": [20.0]},
        "2930": {"vr": "DS", "Value": [22.5]},
        "2931": {"vr": "DS", "Value": [22.5]},
        "2932": {"vr": "DS", "Value": [20.0]},
        "2933": {"vr": "DS", "Value": [22.5]},
        "2934": {"vr": "DS", "Value": [22.5]},
        "2935": {"vr": "DS", "Value": [22.5]},
        "2936": {"vr": "DS", "Value": [22.5]},
        "2937": {"vr": "DS", "Value": [22.5]},
        "2938": {"vr": "DS", "Value": [22.5]},
        "2939": {"vr": "DS", "Value": [22.5]},
        "2940": {"vr": "DS", "Value": [20.0]},
        "2941": {"vr": "DS", "Value": [22.5]},
        "2942": {"vr": "DS", "Value": [20.0]},
        "2943": {"vr": "DS", "Value": [22.5]},
        "2944": {"vr": "DS", "Value": [22.5]},
        "2945": {"vr": "DS", "Value": [22.5]},
        "2946": {"vr": "DS", "Value": [20.0]},
        "2947": {"vr": "DS", "Value": [20.0]},
        "2948": {"vr": "DS", "Value": [20.0]},
        "2949": {"vr": "DS", "Value": [22.5]},
        "2950": {"vr": "DS", "Value": [22.5]},
        "2951": {"vr": "DS", "Value": [22.5]},
        "2952": {"vr": "DS", "Value": [20.0]},
        "2953": {"vr": "DS", "Value": [20.0]},
        "2954": {"vr": "DS", "Value": [20.0]},
        "2955": {"vr": "DS", "Value": [22.5]},
        "2956": {"vr": "DS", "Value": [22.5]},
        "2957": {"vr": "DS", "Value": [20.0]},
        "2958": {"vr": "DS", "Value": [20.0]},
        "2959": {"vr": "DS", "Value": [20.0]},
        "2960": {"vr": "DS", "Value": [22.5]},
        "2961": {"vr": "DS", "Value": [22.5]},
        "2962": {"vr": "DS", "Value": [22.5]},
        "2963": {"vr": "DS", "Value": [22.5]},
        "2964": {"vr": "DS", "Value": [22.5]},
        "2965": {"vr": "DS", "Value": [20.0]},
        "2966": {"vr": "DS", "Value": [22.5]},
        "2967": {"vr": "DS", "Value": [20.0]},
        "2968": {"vr": "DS", "Value": [20.0]},
        "2969": {"vr": "DS", "Value": [20.0]},
        "2970": {"vr": "DS", "Value": [20.0]},
        "2971": {"vr": "DS", "Value": [22.5]},
        "2972": {"vr": "DS", "Value": [22.5]},
        "2973": {"vr": "DS", "Value": [20.0]},
        "2974": {"vr": "DS", "Value": [20.0]},
        "2975": {"vr": "DS", "Value": [22.5]},
        "2976": {"vr": "DS", "Value": [22.5]},
        "2977": {"vr": "DS", "Value": [20.0]},
        "2978": {"vr": "DS", "Value": [20.0]},
        "2979": {"vr": "DS", "Value": [20.0]},
        "2980": {"vr": "DS", "Value": [22.5]},
        "2981": {"vr": "DS", "Value": [22.5]},
        "2982": {"vr": "DS", "Value": [20.0]},
        "2983": {"vr": "DS", "Value": [20.0]},
        "2984": {"vr": "DS", "Value": [20.0]},
        "2985": {"vr": "DS", "Value": [20.0]},
        "2986": {"vr": "DS", "Value": [22.5]},
        "2987": {"vr": "DS", "Value": [20.0]},
        "2988": {"vr": "DS", "Value": [20.0]},
        "2989": {"vr": "DS", "Value": [22.5]},
        "2990": {"vr": "DS", "Value": [22.5]},
        "2991": {"vr": "DS", "Value": [20.0]},
        "2992": {"vr": "DS", "Value": [22.5]},
        "2993": {"vr": "DS", "Value": [22.5]},
        "2994": {"vr": "DS", "Value": [22.5]},
        "2995": {"vr": "DS", "Value": [22.5]},
        "2996": {"vr": "DS", "Value": [20.0]},
        "2997": {"vr": "DS", "Value": [20.0]},
        "2998": {"vr": "DS", "Value": [22.5]},
        "2999": {"vr": "DS", "Value": [22.5]},
        "3000": {"vr": "DS", "Value": [20.0]},
        "3001": {"vr": "DS", "Value": [20.0]},
        "3002": {"vr": "DS", "Value": [22.5]},
        "3003": {"vr": "DS", "Value": [20.0]},
        "3004": {"vr": "DS", "Value": [20.0]},
        "3005": {"vr": "DS", "Value": [20.0]},
        "3006": {"vr": "DS", "Value": [20.0]},
        "3007": {"vr": "DS", "Value": [20.0]},
        "3008": {"vr": "DS", "Value": [20.0]},
        "3009": {"vr": "DS", "Value": [22.5]},
        "3010": {"vr": "DS", "Value": [22.5]},
        "3011": {"vr": "DS", "Value": [20.0]},
        "3012": {"vr": "DS", "Value": [20.0]},
        "3013": {"vr": "DS", "Value": [22.5]},
        "3014": {"vr": "DS", "Value": [22.5]},
        "3015": {"vr": "DS", "Value": [22.5]},
        "3016": {"vr": "DS", "Value": [20.0]},
        "3017": {"vr": "DS", "Value": [22.5]},
        "3018": {"vr": "DS", "Value": [22.5]},
        "3019": {"vr": "DS", "Value": [22.5]},
        "3020": {"vr": "DS", "Value": [22.5]},
        "3021": {"vr": "DS", "Value": [20.0]},
        "3022": {"vr": "DS", "Value": [22.5]},
        "3023": {"vr": "DS", "Value": [22.5]},
        "3024": {"vr": "DS", "Value": [22.5]},
        "3025": {"vr": "DS", "Value": [20.0]},
        "3026": {"vr": "DS", "Value": [22.5]},
        "3027": {"vr": "DS", "Value": [22.5]},
        "3028": {"vr": "DS", "Value": [20.0]},
        "3029": {"vr": "DS", "Value": [22.5]},
        "3030": {"vr": "DS", "Value": [20.0]},
        "3031": {"vr": "DS", "Value": [22.5]},
        "3032": {"vr": "DS", "Value": [22.5]},
        "3033": {"vr": "DS", "Value": [20.0]},
        "3034": {"vr": "DS", "Value": [20.0]},
        "3035": {"vr": "DS", "Value": [22.5]},
        "3036": {"vr": "DS", "Value": [22.5]},
        "3037": {"vr": "DS", "Value": [20.0]},
        "3038": {"vr": "DS", "Value": [20.0]},
        "3039": {"vr": "DS", "Value": [22.5]},
        "3040": {"vr": "DS", "Value": [20.0]},
        "3041": {"vr": "DS", "Value": [20.0]},
        "3042": {"vr": "DS", "Value": [22.5]},
        "3043": {"vr": "DS", "Value": [22.5]},
        "3044": {"vr": "DS", "Value": [22.5]},
        "3045": {"vr": "DS", "Value": [22.5]},
        "3046": {"vr": "DS", "Value": [20.0]},
        "3047": {"vr": "DS", "Value": [22.5]},
        "3048": {"vr": "DS", "Value": [20.0]},
        "3049": {"vr": "DS", "Value": [22.5]},
        "3050": {"vr": "DS", "Value": [20.0]},
        "3051": {"vr": "DS", "Value": [22.5]},
        "3052": {"vr": "DS", "Value": [22.5]},
        "3053": {"vr": "DS", "Value": [20.0]},
        "3054": {"vr": "DS", "Value": [20.0]},
        "3055": {"vr": "DS", "Value": [20.0]},
        "3056": {"vr": "DS", "Value": [22.5]},
        "3057": {"vr": "DS", "Value": [20.0]},
        "3058": {"vr": "DS", "Value": [22.5]},
        "3059": {"vr": "DS", "Value": [22.5]},
        "3060": {"vr": "DS", "Value": [20.0]},
        "3061": {"vr": "DS", "Value": [22.5]},
        "3062": {"vr": "DS", "Value": [22.5]},
        "3063": {"vr": "DS", "Value": [22.5]},
        "3064": {"vr": "DS", "Value": [22.5]},
        "3065": {"vr": "DS", "Value": [22.5]},
        "3066": {"vr": "DS", "Value": [22.5]},
        "3067": {"vr": "DS", "Value": [20.0]},
        "3068": {"vr": "DS", "Value": [22.5]},
        "3069": {"vr": "DS", "Value": [20.0]},
        "3070": {"vr": "DS", "Value": [22.5]},
        "3071": {"vr": "DS", "Value": [20.0]},
        "3072": {"vr": "DS", "Value": [22.5]},
        "3073": {"vr": "DS", "Value": [22.5]},
        "3074": {"vr": "DS", "Value": [22.5]},
        "3075": {"vr": "DS", "Value": [22.5]},
        "3076": {"vr": "DS", "Value": [20.0]},
        "3077": {"vr": "DS", "Value": [20.0]},
        "3078": {"vr": "DS", "Value": [20.0]},
        "3079": {"vr": "DS", "Value": [22.5]},
        "3080": {"vr": "DS", "Value": [22.5]},
        "3081": {"vr": "DS", "Value": [22.5]},
        "3082": {"vr": "DS", "Value": [22.5]},
        "3083": {"vr": "DS", "Value": [22.5]},
        "3084": {"vr": "DS", "Value": [22.5]},
        "3085": {"vr": "DS", "Value": [20.0]},
        "3086": {"vr": "DS", "Value": [22.5]},
        "3087": {"vr": "DS", "Value": [22.5]},
        "3088": {"vr": "DS", "Value": [22.5]},
        "3089": {"vr": "DS", "Value": [20.0]},
        "3090": {"vr": "DS", "Value": [20.0]},
        "3091": {"vr": "DS", "Value": [22.5]},
        "3092": {"vr": "DS", "Value": [20.0]},
        "3093": {"vr": "DS", "Value": [22.5]},
        "3094": {"vr": "DS", "Value": [22.5]},
        "3095": {"vr": "DS", "Value": [20.0]},
        "3096": {"vr": "DS", "Value": [22.5]},
        "3097": {"vr": "DS", "Value": [22.5]},
        "3098": {"vr": "DS", "Value": [20.0]},
        "3099": {"vr": "DS", "Value": [22.5]},
        "3100": {"vr": "DS", "Value": [22.5]},
        "3101": {"vr": "DS", "Value": [20.0]},
        "3102": {"vr": "DS", "Value": [22.5]},
        "3103": {"vr": "DS", "Value": [20.0]},
        "3104": {"vr": "DS", "Value": [22.5]},
        "3105": {"vr": "DS", "Value": [20.0]},
        "3106": {"vr": "DS", "Value": [22.5]},
        "3107": {"vr": "DS", "Value": [20.0]},
        "3108": {"vr": "DS", "Value": [22.5]},
        "3109": {"vr": "DS", "Value": [20.0]},
        "3110": {"vr": "DS", "Value": [22.5]},
        "3111": {"vr": "DS", "Value": [20.0]},
        "3112": {"vr": "DS", "Value": [20.0]},
        "3113": {"vr": "DS", "Value": [22.5]},
        "3114": {"vr": "DS", "Value": [22.5]},
        "3115": {"vr": "DS", "Value": [20.0]},
        "3116": {"vr": "DS", "Value": [20.0]},
        "3117": {"vr": "DS", "Value": [20.0]},
        "3118": {"vr": "DS", "Value": [20.0]},
        "3119": {"vr": "DS", "Value": [22.5]},
        "3120": {"vr": "DS", "Value": [22.5]},
        "3121": {"vr": "DS", "Value": [22.5]},
        "3122": {"vr": "DS", "Value": [22.5]},
        "3123": {"vr": "DS", "Value": [22.5]},
        "3124": {"vr": "DS", "Value": [20.0]},
        "3125": {"vr": "DS", "Value": [20.0]},
        "3126": {"vr": "DS", "Value": [22.5]},
        "3127": {"vr": "DS", "Value": [22.5]},
        "3128": {"vr": "DS", "Value": [22.5]},
        "3129": {"vr": "DS", "Value": [20.0]},
        "3130": {"vr": "DS", "Value": [20.0]},
        "3131": {"vr": "DS", "Value": [22.5]},
        "3132": {"vr": "DS", "Value": [22.5]},
        "3133": {"vr": "DS", "Value": [22.5]},
        "3134": {"vr": "DS", "Value": [22.5]},
        "3135": {"vr": "DS", "Value": [22.5]},
        "3136": {"vr": "DS", "Value": [22.5]},
        "3137": {"vr": "DS", "Value": [20.0]},
        "3138": {"vr": "DS", "Value": [22.5]},
        "3139": {"vr": "DS", "Value": [22.5]},
        "3140": {"vr": "DS", "Value": [20.0]},
        "3141": {"vr": "DS", "Value": [22.5]},
        "3142": {"vr": "DS", "Value": [20.0]},
        "3143": {"vr": "DS", "Value": [22.5]},
        "3144": {"vr": "DS", "Value": [20.0]},
        "3145": {"vr": "DS", "Value": [22.5]},
        "3146": {"vr": "DS", "Value": [22.5]},
        "3147": {"vr": "DS", "Value": [22.5]},
        "3148": {"vr": "DS", "Value": [20.0]},
        "3149": {"vr": "DS", "Value": [22.5]},
        "3150": {"vr": "DS", "Value": [20.0]},
        "3151": {"vr": "DS", "Value": [20.0]},
        "3152": {"vr": "DS", "Value": [22.5]},
        "3153": {"vr": "DS", "Value": [20.0]},
        "3154": {"vr": "DS", "Value": [20.0]},
        "3155": {"vr": "DS", "Value": [20.0]},
        "3156": {"vr": "DS", "Value": [20.0]},
        "3157": {"vr": "DS", "Value": [22.5]},
        "3158": {"vr": "DS", "Value": [20.0]},
        "3159": {"vr": "DS", "Value": [20.0]},
        "3160": {"vr": "DS", "Value": [22.5]},
        "3161": {"vr": "DS", "Value": [20.0]},
        "3162": {"vr": "DS", "Value": [20.0]},
        "3163": {"vr": "DS", "Value": [22.5]},
        "3164": {"vr": "DS", "Value": [20.0]},
        "3165": {"vr": "DS", "Value": [22.5]},
        "3166": {"vr": "DS", "Value": [22.5]},
        "3167": {"vr": "DS", "Value": [22.5]},
        "3168": {"vr": "DS", "Value": [22.5]},
        "3169": {"vr": "DS", "Value": [22.5]},
        "3170": {"vr": "DS", "Value": [20.0]},
        "3171": {"vr": "DS", "Value": [20.0]},
        "3172": {"vr": "DS", "Value": [20.0]},
        "3173": {"vr": "DS", "Value": [22.5]},
        "3174": {"vr": "DS", "Value": [22.5]},
        "3175": {"vr": "DS", "Value": [20.0]},
        "3176": {"vr": "DS", "Value": [22.5]},
        "3177": {"vr": "DS", "Value": [20.0]},
        "3178": {"vr": "DS", "Value": [22.5]},
        "3179": {"vr": "DS", "Value": [20.0]},
        "3180": {"vr": "DS", "Value": [20.0]},
        "3181": {"vr": "DS", "Value": [20.0]},
        "3182": {"vr": "DS", "Value": [20.0]},
        "3183": {"vr": "DS", "Value": [22.5]},
        "3184": {"vr": "DS", "Value": [20.0]},
        "3185": {"vr": "DS", "Value": [22.5]},
        "3186": {"vr": "DS", "Value": [20.0]},
        "3187": {"vr": "DS", "Value": [20.0]},
        "3188": {"vr": "DS", "Value": [20.0]},
        "3189": {"vr": "DS", "Value": [22.5]},
        "3190": {"vr": "DS", "Value": [20.0]},
        "3191": {"vr": "DS", "Value": [20.0]},
        "3192": {"vr": "DS", "Value": [22.5]},
        "3193": {"vr": "DS", "Value": [22.5]},
        "3194": {"vr": "DS", "Value": [22.5]},
        "3195": {"vr": "DS", "Value": [20.0]},
        "3196": {"vr": "DS", "Value": [20.0]},
        "3197": {"vr": "DS", "Value": [20.0]},
        "3198": {"vr": "DS", "Value": [22.5]},
        "3199": {"vr": "DS", "Value": [20.0]},
        "3200": {"vr": "DS", "Value": [20.0]},
        "3201": {"vr": "DS", "Value": [22.5]},
        "3202": {"vr": "DS", "Value": [22.5]},
        "3203": {"vr": "DS", "Value": [22.5]},
        "3204": {"vr": "DS", "Value": [20.0]},
        "3205": {"vr": "DS", "Value": [20.0]},
        "3206": {"vr": "DS", "Value": [20.0]},
        "3207": {"vr": "DS", "Value": [20.0]},
        "3208": {"vr": "DS", "Value": [22.5]},
        "3209": {"vr": "DS", "Value": [22.5]},
        "3210": {"vr": "DS", "Value": [20.0]},
        "3211": {"vr": "DS", "Value": [22.5]},
        "3212": {"vr": "DS", "Value": [20.0]},
        "3213": {"vr": "DS", "Value": [22.5]},
        "3214": {"vr": "DS", "Value": [22.5]},
        "3215": {"vr": "DS", "Value": [20.0]},
        "3216": {"vr": "DS", "Value": [20.0]},
        "3217": {"vr": "DS", "Value": [22.5]},
        "3218": {"vr": "DS", "Value": [22.5]},
        "3219": {"vr": "DS", "Value": [20.0]},
        "3220": {"vr": "DS", "Value": [20.0]},
        "3221": {"vr": "DS", "Value": [22.5]},
        "3222": {"vr": "DS", "Value": [22.5]},
        "3223": {"vr": "DS", "Value": [20.0]},
        "3224": {"vr": "DS", "Value": [20.0]},
        "3225": {"vr": "DS", "Value": [22.5]},
        "3226": {"vr": "DS", "Value": [22.5]},
        "3227": {"vr": "DS", "Value": [20.0]},
        "3228": {"vr": "DS", "Value": [20.0]},
        "3229": {"vr": "DS", "Value": [20.0]},
        "3230": {"vr": "DS", "Value": [22.5]},
        "3231": {"vr": "DS", "Value": [22.5]},
        "3232": {"vr": "DS", "Value": [20.0]},
        "3233": {"vr": "DS", "Value": [22.5]},
        "3234": {"vr": "DS", "Value": [22.5]},
        "3235": {"vr": "DS", "Value": [20.0]},
        "3236": {"vr": "DS", "Value": [22.5]},
        "3237": {"vr": "DS", "Value": [22.5]},
        "3238": {"vr": "DS", "Value": [22.5]},
        "3239": {"vr": "DS", "Value": [22.5]},
        "3240": {"vr": "DS", "Value": [22.5]},
        "3241": {"vr": "DS", "Value": [22.5]},
        "3242": {"vr": "DS", "Value": [20.0]},
        "3243": {"vr": "DS", "Value": [22.5]},
        "3244": {"vr": "DS", "Value": [22.5]},
        "3245": {"vr": "DS", "Value": [22.5]},
        "3246": {"vr": "DS", "Value": [20.0]},
        "3247": {"vr": "DS", "Value": [20.0]},
        "3248": {"vr": "DS", "Value": [20.0]},
        "3249": {"vr": "DS", "Value": [20.0]},
        "3250": {"vr": "DS", "Value": [20.0]},
        "3251": {"vr": "DS", "Value": [20.0]},
        "3252": {"vr": "DS", "Value": [22.5]},
        "3253": {"vr": "DS", "Value": [22.5]},
        "3254": {"vr": "DS", "Value": [22.5]},
        "3255": {"vr": "DS", "Value": [20.0]},
        "3256": {"vr": "DS", "Value": [22.5]},
        "3257": {"vr": "DS", "Value": [22.5]},
        "3258": {"vr": "DS", "Value": [20.0]},
        "3259": {"vr": "DS", "Value": [20.0]},
        "3260": {"vr": "DS", "Value": [20.0]},
        "3261": {"vr": "DS", "Value": [22.5]},
        "3262": {"vr": "DS", "Value": [22.5]},
        "3263": {"vr": "DS", "Value": [20.0]},
        "3264": {"vr": "DS", "Value": [20.0]},
        "3265": {"vr": "DS", "Value": [20.0]},
        "3266": {"vr": "DS", "Value": [20.0]},
        "3267": {"vr": "DS", "Value": [22.5]},
        "3268": {"vr": "DS", "Value": [22.5]},
        "3269": {"vr": "DS", "Value": [22.5]},
        "3270": {"vr": "DS", "Value": [22.5]},
        "3271": {"vr": "DS", "Value": [20.0]},
        "3272": {"vr": "DS", "Value": [20.0]},
        "3273": {"vr": "DS", "Value": [22.5]},
        "3274": {"vr": "DS", "Value": [20.0]},
        "3275": {"vr": "DS", "Value": [20.0]},
        "3276": {"vr": "DS", "Value": [22.5]},
        "3277": {"vr": "DS", "Value": [22.5]},
        "3278": {"vr": "DS", "Value": [22.5]},
        "3279": {"vr": "DS", "Value": [22.5]},
        "3280": {"vr": "DS", "Value": [22.5]},
        "3281": {"vr": "DS", "Value": [22.5]},
        "3282": {"vr": "DS", "Value": [22.5]},
        "3283": {"vr": "DS", "Value": [20.0]},
        "3284": {"vr": "DS", "Value": [22.5]},
        "3285": {"vr": "DS", "Value": [22.5]},
        "3286": {"vr": "DS", "Value": [20.0]},
        "3287": {"vr": "DS", "Value": [22.5]},
        "3288": {"vr": "DS", "Value": [22.5]},
        "3289": {"vr": "DS", "Value": [22.5]},
        "3290": {"vr": "DS", "Value": [20.0]},
        "3291": {"vr": "DS", "Value": [22.5]},
        "3292": {"vr": "DS", "Value": [22.5]},
        "3293": {"vr": "DS", "Value": [22.5]},
        "3294": {"vr": "DS", "Value": [20.0]},
        "3295": {"vr": "DS", "Value": [22.5]},
        "3296": {"vr": "DS", "Value": [20.0]},
        "3297": {"vr": "DS", "Value": [20.0]},
        "3298": {"vr": "DS", "Value": [20.0]},
        "3299": {"vr": "DS", "Value": [22.5]},
        "3300": {"vr": "DS", "Value": [22.5]},
        "3301": {"vr": "DS", "Value": [22.5]},
        "3302": {"vr": "DS", "Value": [22.5]},
        "3303": {"vr": "DS", "Value": [22.5]},
        "3304": {"vr": "DS", "Value": [22.5]},
        "3305": {"vr": "DS", "Value": [22.5]},
        "3306": {"vr": "DS", "Value": [20.0]},
        "3307": {"vr": "DS", "Value": [22.5]},
        "3308": {"vr": "DS", "Value": [20.0]},
        "3309": {"vr": "DS", "Value": [20.0]},
        "3310": {"vr": "DS", "Value": [22.5]},
        "3311": {"vr": "DS", "Value": [20.0]},
        "3312": {"vr": "DS", "Value": [22.5]},
        "3313": {"vr": "DS", "Value": [20.0]},
        "3314": {"vr": "DS", "Value": [22.5]},
        "3315": {"vr": "DS", "Value": [22.5]},
        "3316": {"vr": "DS", "Value": [20.0]},
        "3317": {"vr": "DS", "Value": [20.0]},
        "3318": {"vr": "DS", "Value": [22.5]},
        "3319": {"vr": "DS", "Value": [22.5]},
        "3320": {"vr": "DS", "Value": [20.0]},
        "3321": {"vr": "DS", "Value": [22.5]},
        "3322": {"vr": "DS", "Value": [20.0]},
        "3323": {"vr": "DS", "Value": [20.0]},
        "3324": {"vr": "DS", "Value": [20.0]},
        "3325": {"vr": "DS", "Value": [22.5]},
        "3326": {"vr": "DS", "Value": [22.5]},
        "3327": {"vr": "DS", "Value": [20.0]},
        "3328": {"vr": "DS", "Value": [20.0]},
        "3329": {"vr": "DS", "Value": [22.5]},
        "3330": {"vr": "DS", "Value": [20.0]},
        "3331": {"vr": "DS", "Value": [20.0]},
        "3332": {"vr": "DS", "Value": [20.0]},
        "3333": {"vr": "DS", "Value": [20.0]},
        "3334": {"vr": "DS", "Value": [20.0]},
        "3335": {"vr": "DS", "Value": [20.0]},
        "3336": {"vr": "DS", "Value": [20.0]},
        "3337": {"vr": "DS", "Value": [22.5]},
        "3338": {"vr": "DS", "Value": [22.5]},
        "3339": {"vr": "DS", "Value": [22.5]},
        "3340": {"vr": "DS", "Value": [20.0]},
        "3341": {"vr": "DS", "Value": [22.5]},
        "3342": {"vr": "DS", "Value": [22.5]},
        "3343": {"vr": "DS", "Value": [22.5]},
        "3344": {"vr": "DS", "Value": [20.0]},
        "3345": {"vr": "DS", "Value": [20.0]},
        "3346": {"vr": "DS", "Value": [20.0]},
        "3347": {"vr": "DS", "Value": [20.0]},
        "3348": {"vr": "DS", "Value": [22.5]},
        "3349": {"vr": "DS", "Value": [20.0]},
        "3350": {"vr": "DS", "Value": [20.0]},
        "3351": {"vr": "DS", "Value": [22.5]},
        "3352": {"vr": "DS", "Value": [22.5]},
        "3353": {"vr": "DS", "Value": [20.0]},
        "3354": {"vr": "DS", "Value": [22.5]},
        "3355": {"vr": "DS", "Value": [22.5]},
        "3356": {"vr": "DS", "Value": [20.0]},
        "3357": {"vr": "DS", "Value": [20.0]},
        "3358": {"vr": "DS", "Value": [22.5]},
        "3359": {"vr": "DS", "Value": [22.5]},
        "3360": {"vr": "DS", "Value": [20.0]},
        "3361": {"vr": "DS", "Value": [22.5]},
        "3362": {"vr": "DS", "Value": [22.5]},
        "3363": {"vr": "DS", "Value": [22.5]},
        "3364": {"vr": "DS", "Value": [22.5]},
        "3365": {"vr": "DS", "Value": [22.5]},
        "3366": {"vr": "DS", "Value": [20.0]},
        "3367": {"vr": "DS", "Value": [22.5]},
        "3368": {"vr": "DS", "Value": [22.5]},
        "3369": {"vr": "DS", "Value": [22.5]},
        "3370": {"vr": "DS", "Value": [22.5]},
        "3371": {"vr": "DS", "Value": [20.0]},
        "3372": {"vr": "DS", "Value": [22.5]},
        "3373": {"vr": "DS", "Value": [20.0]},
        "3374": {"vr": "DS", "Value": [22.5]},
        "3375": {"vr": "DS", "Value": [20.0]},
        "3376": {"vr": "DS", "Value": [22.5]},
        "3377": {"vr": "DS", "Value": [22.5]},
        "3378": {"vr": "DS", "Value": [22.5]},
        "3379": {"vr": "DS", "Value": [22.5]},
        "3380": {"vr": "DS", "Value": [22.5]},
        "3381": {"vr": "DS", "Value": [22.5]},
        "3382": {"vr": "DS", "Value": [20.0]},
        "3383": {"vr": "DS", "Value": [20.0]},
        "3384": {"vr": "DS", "Value": [22.5]},
        "3385": {"vr": "DS", "Value": [22.5]},
        "3386": {"vr": "DS", "Value": [20.0]},
        "3387": {"vr": "DS", "Value": [22.5]},
        "3388": {"vr": "DS", "Value": [22.5]},
        "3389": {"vr": "DS", "Value": [20.0]},
        "3390": {"vr": "DS", "Value": [20.0]},
        "3391": {"vr": "DS", "Value": [22.5]},
        "3392": {"vr": "DS", "Value": [20.0]},
        "3393": {"vr": "DS", "Value": [22.5]},
        "3394": {"vr": "DS", "Value": [20.0]},
        "3395": {"vr": "DS", "Value": [22.5]},
        "3396": {"vr": "DS", "Value": [22.5]},
        "3397": {"vr": "DS", "Value": [20.0]},
        "3398": {"vr": "DS", "Value": [20.0]},
        "3399": {"vr": "DS", "Value": [22.5]},
        "3400": {"vr": "DS", "Value": [20.0]},
        "3401": {"vr": "DS", "Value": [22.5]},
        "3402": {"vr": "DS", "Value": [22.5]},
        "3403": {"vr": "DS", "Value": [20.0]},
        "3404": {"vr": "DS", "Value": [22.5]},
        "3405": {"vr": "DS", "Value": [22.5]},
        "3406": {"vr": "DS", "Value": [20.0]},
        "3407": {"vr": "DS", "Value": [20.0]},
        "3408": {"vr": "DS", "Value": [22.5]},
        "3409": {"vr": "DS", "Value": [20.0]},
        "3410": {"vr": "DS", "Value": [22.5]},
        "3411": {"vr": "DS", "Value": [20.0]},
        "3412": {"vr": "DS", "Value": [20.0]},
        "3413": {"vr": "DS", "Value": [20.0]},
        "3414": {"vr": "DS", "Value": [22.5]},
        "3415": {"vr": "DS", "Value": [20.0]},
        "3416": {"vr": "DS", "Value": [20.0]},
        "3417": {"vr": "DS", "Value": [22.5]},
        "3418": {"vr": "DS", "Value": [20.0]},
        "3419": {"vr": "DS", "Value": [20.0]},
        "3420": {"vr": "DS", "Value": [22.5]},
        "3421": {"vr": "DS", "Value": [22.5]},
        "3422": {"vr": "DS", "Value": [20.0]},
        "3423": {"vr": "DS", "Value": [20.0]},
        "3424": {"vr": "DS", "Value": [22.5]},
        "3425": {"vr": "DS", "Value": [20.0]},
        "3426": {"vr": "DS", "Value": [20.0]},
        "3427": {"vr": "DS", "Value": [22.5]},
        "3428": {"vr": "DS", "Value": [22.5]},
        "3429": {"vr": "DS", "Value": [20.0]},
        "3430": {"vr": "DS", "Value": [20.0]},
        "3431": {"vr": "DS", "Value": [20.0]},
        "3432": {"vr": "DS", "Value": [20.0]},
        "3433": {"vr": "DS", "Value": [20.0]},
        "3434": {"vr": "DS", "Value": [20.0]},
        "3435": {"vr": "DS", "Value": [22.5]},
        "3436": {"vr": "DS", "Value": [22.5]},
        "3437": {"vr": "DS", "Value": [20.0]},
        "3438": {"vr": "DS", "Value": [20.0]},
        "3439": {"vr": "DS", "Value": [22.5]},
        "3440": {"vr": "DS", "Value": [20.0]},
        "3441": {"vr": "DS", "Value": [20.0]},
        "3442": {"vr": "DS", "Value": [20.0]},
        "3443": {"vr": "DS", "Value": [22.5]},
        "3444": {"vr": "DS", "Value": [22.5]},
        "3445": {"vr": "DS", "Value": [22.5]},
        "3446": {"vr": "DS", "Value": [22.5]},
        "3447": {"vr": "DS", "Value": [22.5]},
        "3448": {"vr": "DS", "Value": [22.5]},
        "3449": {"vr": "DS", "Value": [22.5]},
        "3450": {"vr": "DS", "Value": [22.5]},
        "3451": {"vr": "DS", "Value": [20.0]},
        "3452": {"vr": "DS", "Value": [22.5]},
        "3453": {"vr": "DS", "Value": [22.5]},
        "3454": {"vr": "DS", "Value": [20.0]},
        "3455": {"vr": "DS", "Value": [22.5]},
        "3456": {"vr": "DS", "Value": [22.5]},
        "3457": {"vr": "DS", "Value": [20.0]},
        "3458": {"vr": "DS", "Value": [20.0]},
        "3459": {"vr": "DS", "Value": [22.5]},
        "3460": {"vr": "DS", "Value": [22.5]},
        "3461": {"vr": "DS", "Value": [20.0]},
        "3462": {"vr": "DS", "Value": [22.5]},
        "3463": {"vr": "DS", "Value": [20.0]},
        "3464": {"vr": "DS", "Value": [22.5]},
        "3465": {"vr": "DS", "Value": [20.0]},
        "3466": {"vr": "DS", "Value": [22.5]},
        "3467": {"vr": "DS", "Value": [22.5]},
        "3468": {"vr": "DS", "Value": [22.5]},
        "3469": {"vr": "DS", "Value": [22.5]},
        "3470": {"vr": "DS", "Value": [20.0]},
        "3471": {"vr": "DS", "Value": [22.5]},
        "3472": {"vr": "DS", "Value": [20.0]},
        "3473": {"vr": "DS", "Value": [22.5]},
        "3474": {"vr": "DS", "Value": [20.0]},
        "3475": {"vr": "DS", "Value": [20.0]},
        "3476": {"vr": "DS", "Value": [22.5]},
        "3477": {"vr": "DS", "Value": [22.5]},
        "3478": {"vr": "DS", "Value": [20.0]},
        "3479": {"vr": "DS", "Value": [22.5]},
        "3480": {"vr": "DS", "Value": [22.5]},
        "3481": {"vr": "DS", "Value": [22.5]},
        "3482": {"vr": "DS", "Value": [22.5]},
        "3483": {"vr": "DS", "Value": [22.5]},
        "3484": {"vr": "DS", "Value": [20.0]},
        "3485": {"vr": "DS", "Value": [20.0]},
        "3486": {"vr": "DS", "Value": [22.5]},
        "3487": {"vr": "DS", "Value": [22.5]},
        "3488": {"vr": "DS", "Value": [20.0]},
        "3489": {"vr": "DS", "Value": [20.0]},
        "3490": {"vr": "DS", "Value": [20.0]},
        "3491": {"vr": "DS", "Value": [20.0]},
        "3492": {"vr": "DS", "Value": [20.0]},
        "3493": {"vr": "DS", "Value": [22.5]},
        "3494": {"vr": "DS", "Value": [20.0]},
        "3495": {"vr": "DS", "Value": [22.5]},
        "3496": {"vr": "DS", "Value": [20.0]},
        "3497": {"vr": "DS", "Value": [22.5]},
        "3498": {"vr": "DS", "Value": [22.5]},
        "3499": {"vr": "DS", "Value": [22.5]},
        "3500": {"vr": "DS", "Value": [22.5]},
        "3501": {"vr": "DS", "Value": [22.5]},
        "3502": {"vr": "DS", "Value": [20.0]},
        "3503": {"vr": "DS", "Value": [22.5]},
        "3504": {"vr": "DS", "Value": [22.5]},
        "3505": {"vr": "DS", "Value": [20.0]},
        "3506": {"vr": "DS", "Value": [22.5]},
        "3507": {"vr": "DS", "Value": [20.0]},
        "3508": {"vr": "DS", "Value": [20.0]},
        "3509": {"vr": "DS", "Value": [22.5]},
        "3510": {"vr": "DS", "Value": [20.0]},
        "3511": {"vr": "DS", "Value": [20.0]},
        "3512": {"vr": "DS", "Value": [20.0]},
        "3513": {"vr": "DS", "Value": [22.5]},
        "3514": {"vr": "DS", "Value": [22.5]},
        "3515": {"vr": "DS", "Value": [20.0]},
        "3516": {"vr": "DS", "Value": [20.0]},
        "3517": {"vr": "DS", "Value": [22.5]},
        "3518": {"vr": "DS", "Value": [20.0]},
        "3519": {"vr": "DS", "Value": [20.0]},
        "3520": {"vr": "DS", "Value": [20.0]},
        "3521": {"vr": "DS", "Value": [22.5]},
        "3522": {"vr": "DS", "Value": [22.5]},
        "3523": {"vr": "DS", "Value": [22.5]},
        "3524": {"vr": "DS", "Value": [20.0]},
        "3525": {"vr": "DS", "Value": [20.0]},
        "3526": {"vr": "DS", "Value": [22.5]},
        "3527": {"vr": "DS", "Value": [20.0]},
        "3528": {"vr": "DS", "Value": [20.0]},
        "3529": {"vr": "DS", "Value": [22.5]},
        "3530": {"vr": "DS", "Value": [20.0]},
        "3531": {"vr": "DS", "Value": [22.5]},
        "3532": {"vr": "DS", "Value": [22.5]},
        "3533": {"vr": "DS", "Value": [20.0]},
        "3534": {"vr": "DS", "Value": [22.5]},
        "3535": {"vr": "DS", "Value": [20.0]},
        "3536": {"vr": "DS", "Value": [22.5]},
        "3537": {"vr": "DS", "Value": [22.5]},
        "3538": {"vr": "DS", "Value": [22.5]},
        "3539": {"vr": "DS", "Value": [20.0]},
        "3540": {"vr": "DS", "Value": [20.0]},
        "3541": {"vr": "DS", "Value": [22.5]},
        "3542": {"vr": "DS", "Value": [22.5]},
        "3543": {"vr": "DS", "Value": [20.0]},
        "3544": {"vr": "DS", "Value": [20.0]},
        "3545": {"vr": "DS", "Value": [22.5]},
        "3546": {"vr": "DS", "Value": [22.5]},
        "3547": {"vr": "DS", "Value": [22.5]},
        "3548": {"vr": "DS", "Value": [20.0]},
        "3549": {"vr": "DS", "Value": [20.0]},
        "3550": {"vr": "DS", "Value": [22.5]},
        "3551": {"vr": "DS", "Value": [22.5]},
        "3552": {"vr": "DS", "Value": [22.5]},
        "3553": {"vr": "DS", "Value": [22.5]},
        "3554": {"vr": "DS", "Value": [22.5]},
        "3555": {"vr": "DS", "Value": [22.5]},
        "3556": {"vr": "DS", "Value": [20.0]},
        "3557": {"vr": "DS", "Value": [22.5]},
        "3558": {"vr": "DS", "Value": [22.5]},
        "3559": {"vr": "DS", "Value": [20.0]},
        "3560": {"vr": "DS", "Value": [22.5]},
        "3561": {"vr": "DS", "Value": [22.5]},
        "3562": {"vr": "DS", "Value": [20.0]},
        "3563": {"vr": "DS", "Value": [22.5]},
        "3564": {"vr": "DS", "Value": [20.0]},
        "3565": {"vr": "DS", "Value": [22.5]},
        "3566": {"vr": "DS", "Value": [22.5]},
        "3567": {"vr": "DS", "Value": [20.0]},
        "3568": {"vr": "DS", "Value": [22.5]},
        "3569": {"vr": "DS", "Value": [20.0]},
        "3570": {"vr": "DS", "Value": [20.0]},
        "3571": {"vr": "DS", "Value": [22.5]},
        "3572": {"vr": "DS", "Value": [22.5]},
        "3573": {"vr": "DS", "Value": [20.0]},
        "3574": {"vr": "DS", "Value": [22.5]},
        "3575": {"vr": "DS", "Value": [22.5]},
        "3576": {"vr": "DS", "Value": [22.5]},
        "3577": {"vr": "DS", "Value": [22.5]},
        "3578": {"vr": "DS", "Value": [22.5]},
        "3579": {"vr": "DS", "Value": [22.5]},
        "3580": {"vr": "DS", "Value": [20.0]},
        "3581": {"vr": "DS", "Value": [20.0]},
        "3582": {"vr": "DS", "Value": [20.0]},
        "3583": {"vr": "DS", "Value": [22.5]},
        "3584": {"vr": "DS", "Value": [22.5]},
        "3585": {"vr": "DS", "Value": [22.5]},
        "3586": {"vr": "DS", "Value": [22.5]},
        "3587": {"vr": "DS", "Value": [20.0]},
        "3588": {"vr": "DS", "Value": [20.0]},
        "3589": {"vr": "DS", "Value": [22.5]},
        "3590": {"vr": "DS", "Value": [22.5]},
        "3591": {"vr": "DS", "Value": [22.5]},
        "3592": {"vr": "DS", "Value": [22.5]},
        "3593": {"vr": "DS", "Value": [20.0]},
        "3594": {"vr": "DS", "Value": [22.5]},
        "3595": {"vr": "DS", "Value": [22.5]},
        "3596": {"vr": "DS", "Value": [22.5]},
        "3597": {"vr": "DS", "Value": [22.5]},
        "3598": {"vr": "DS", "Value": [20.0]},
        "3599": {"vr": "DS", "Value": [20.0]},
        "3600": {"vr": "DS", "Value": [22.5]},
        "3601": {"vr": "DS", "Value": [22.5]},
        "3602": {"vr": "DS", "Value": [22.5]},
        "3603": {"vr": "DS", "Value": [22.5]},
        "3604": {"vr": "DS", "Value": [20.0]},
        "3605": {"vr": "DS", "Value": [22.5]},
        "3606": {"vr": "DS", "Value": [20.0]},
        "3607": {"vr": "DS", "Value": [22.5]},
        "3608": {"vr": "DS", "Value": [20.0]},
        "3609": {"vr": "DS", "Value": [20.0]},
        "3610": {"vr": "DS", "Value": [22.5]},
        "3611": {"vr": "DS", "Value": [20.0]},
        "3612": {"vr": "DS", "Value": [22.5]},
        "3613": {"vr": "DS", "Value": [22.5]},
        "3614": {"vr": "DS", "Value": [22.5]},
        "3615": {"vr": "DS", "Value": [22.5]},
        "3616": {"vr": "DS", "Value": [22.5]},
        "3617": {"vr": "DS", "Value": [22.5]},
        "3618": {"vr": "DS", "Value": [22.5]},
        "3619": {"vr": "DS", "Value": [20.0]},
        "3620": {"vr": "DS", "Value": [22.5]},
        "3621": {"vr": "DS", "Value": [22.5]},
        "3622": {"vr": "DS", "Value": [20.0]},
        "3623": {"vr": "DS", "Value": [22.5]},
        "3624": {"vr": "DS", "Value": [22.5]},
        "3625": {"vr": "DS", "Value": [20.0]},
        "3626": {"vr": "DS", "Value": [22.5]},
        "3627": {"vr": "DS", "Value": [20.0]},
        "3628": {"vr": "DS", "Value": [20.0]},
        "3629": {"vr": "DS", "Value": [22.5]},
        "3630": {"vr": "DS", "Value": [20.0]},
        "3631": {"vr": "DS", "Value": [20.0]},
        "3632": {"vr": "DS", "Value": [22.5]},
        "3633": {"vr": "DS", "Value": [22.5]},
        "3634": {"vr": "DS", "Value": [22.5]},
        "3635": {"vr": "DS", "Value": [20.0]},
        "3636": {"vr": "DS", "Value": [22.5]},
        "3637": {"vr": "DS", "Value": [20.0]},
        "3638": {"vr": "DS", "Value": [22.5]},
        "3639": {"vr": "DS", "Value": [22.5]},
        "3640": {"vr": "DS", "Value": [22.5]},
        "3641": {"vr": "DS", "Value": [22.5]},
        "3642": {"vr": "DS", "Value": [20.0]},
        "3643": {"vr": "DS", "Value": [20.0]},
        "3644": {"vr": "DS", "Value": [22.5]},
        "3645": {"vr": "DS", "Value": [22.5]},
        "3646": {"vr": "DS", "Value": [22.5]},
        "3647": {"vr": "DS", "Value": [22.5]},
        "3648": {"vr": "DS", "Value": [20.0]},
        "3649": {"vr": "DS", "Value": [20.0]},
        "3650": {"vr": "DS", "Value": [20.0]},
        "3651": {"vr": "DS", "Value": [22.5]},
        "3652": {"vr": "DS", "Value": [20.0]},
        "3653": {"vr": "DS", "Value": [22.5]},
        "3654": {"vr": "DS", "Value": [20.0]},
        "3655": {"vr": "DS", "Value": [20.0]},
        "3656": {"vr": "DS", "Value": [22.5]},
        "3657": {"vr": "DS", "Value": [22.5]},
        "3658": {"vr": "DS", "Value": [20.0]},
        "3659": {"vr": "DS", "Value": [22.5]},
        "3660": {"vr": "DS", "Value": [22.5]},
        "3661": {"vr": "DS", "Value": [20.0]},
        "3662": {"vr": "DS", "Value": [22.5]},
        "3663": {"vr": "DS", "Value": [22.5]},
        "3664": {"vr": "DS", "Value": [20.0]},
        "3665": {"vr": "DS", "Value": [22.5]},
        "3666": {"vr": "DS", "Value": [20.0]},
        "3667": {"vr": "DS", "Value": [20.0]},
        "3668": {"vr": "DS", "Value": [20.0]},
        "3669": {"vr": "DS", "Value": [22.5]},
        "3670": {"vr": "DS", "Value": [22.5]},
        "3671": {"vr": "DS", "Value": [22.5]},
        "3672": {"vr": "DS", "Value": [22.5]},
        "3673": {"vr": "DS", "Value": [22.5]},
        "3674": {"vr": "DS", "Value": [20.0]},
        "3675": {"vr": "DS", "Value": [20.0]},
        "3676": {"vr": "DS", "Value": [22.5]},
        "3677": {"vr": "DS", "Value": [20.0]},
        "3678": {"vr": "DS", "Value": [22.5]},
        "3679": {"vr": "DS", "Value": [22.5]},
        "3680": {"vr": "DS", "Value": [22.5]},
        "3681": {"vr": "DS", "Value": [22.5]},
        "3682": {"vr": "DS", "Value": [22.5]},
        "3683": {"vr": "DS", "Value": [22.5]},
        "3684": {"vr": "DS", "Value": [20.0]},
        "3685": {"vr": "DS", "Value": [22.5]},
        "3686": {"vr": "DS", "Value": [20.0]},
        "3687": {"vr": "DS", "Value": [20.0]},
        "3688": {"vr": "DS", "Value": [22.5]},
        "3689": {"vr": "DS", "Value": [22.5]},
        "3690": {"vr": "DS", "Value": [22.5]},
        "3691": {"vr": "DS", "Value": [20.0]},
        "3692": {"vr": "DS", "Value": [20.0]},
        "3693": {"vr": "DS", "Value": [20.0]},
        "3694": {"vr": "DS", "Value": [22.5]},
        "3695": {"vr": "DS", "Value": [22.5]},
        "3696": {"vr": "DS", "Value": [20.0]},
        "3697": {"vr": "DS", "Value": [20.0]},
        "3698": {"vr": "DS", "Value": [20.0]},
        "3699": {"vr": "DS", "Value": [22.5]},
        "3700": {"vr": "DS", "Value": [22.5]},
        "3701": {"vr": "DS", "Value": [20.0]},
        "3702": {"vr": "DS", "Value": [22.5]},
        "3703": {"vr": "DS", "Value": [20.0]},
        "3704": {"vr": "DS", "Value": [22.5]},
        "3705": {"vr": "DS", "Value": [22.5]},
        "3706": {"vr": "DS", "Value": [22.5]},
        "3707": {"vr": "DS", "Value": [20.0]},
        "3708": {"vr": "DS", "Value": [22.5]},
        "3709": {"vr": "DS", "Value": [22.5]},
        "3710": {"vr": "DS", "Value": [20.0]},
        "3711": {"vr": "DS", "Value": [22.5]},
        "3712": {"vr": "DS", "Value": [22.5]},
        "3713": {"vr": "DS", "Value": [20.0]},
        "3714": {"vr": "DS", "Value": [20.0]},
        "3715": {"vr": "DS", "Value": [20.0]},
        "3716": {"vr": "DS", "Value": [22.5]},
        "3717": {"vr": "DS", "Value": [20.0]},
        "3718": {"vr": "DS", "Value": [22.5]},
        "3719": {"vr": "DS", "Value": [22.5]},
        "3720": {"vr": "DS", "Value": [20.0]},
        "3721": {"vr": "DS", "Value": [22.5]},
        "3722": {"vr": "DS", "Value": [22.5]},
        "3723": {"vr": "DS", "Value": [20.0]},
        "3724": {"vr": "DS", "Value": [22.5]},
        "3725": {"vr": "DS", "Value": [22.5]},
        "3726": {"vr": "DS", "Value": [22.5]},
        "3727": {"vr": "DS", "Value": [20.0]},
        "3728": {"vr": "DS", "Value": [20.0]},
        "3729": {"vr": "DS", "Value": [22.5]},
        "3730": {"vr": "DS", "Value": [22.5]},
        "3731": {"vr": "DS", "Value": [20.0]},
        "3732": {"vr": "DS", "Value": [20.0]},
        "3733": {"vr": "DS", "Value": [22.5]},
        "3734": {"vr": "DS", "Value": [22.5]},
        "3735": {"vr": "DS", "Value": [20.0]},
        "3736": {"vr": "DS", "Value": [22.5]},
        "3737": {"vr": "DS", "Value": [22.5]},
        "3738": {"vr": "DS", "Value": [20.0]},
        "3739": {"vr": "DS", "Value": [22.5]},
        "3740": {"vr": "DS", "Value": [20.0]},
        "3741": {"vr": "DS", "Value": [22.5]},
        "3742": {"vr": "DS", "Value": [22.5]},
        "3743": {"vr": "DS", "Value": [22.5]},
        "3744": {"vr": "DS", "Value": [22.5]},
        "3745": {"vr": "DS", "Value": [20.0]},
        "3746": {"vr": "DS", "Value": [20.0]},
        "3747": {"vr": "DS", "Value": [20.0]},
        "3748": {"vr": "DS", "Value": [22.5]},
        "3749": {"vr": "DS", "Value": [20.0]},
        "3750": {"vr": "DS", "Value": [20.0]},
        "3751": {"vr": "DS", "Value": [22.5]},
        "3752": {"vr": "DS", "Value": [22.5]},
        "3753": {"vr": "DS", "Value": [20.0]},
        "3754": {"vr": "DS", "Value": [20.0]},
        "3755": {"vr": "DS", "Value": [22.5]},
        "3756": {"vr": "DS", "Value": [22.5]},
        "3757": {"vr": "DS", "Value": [20.0]},
        "3758": {"vr": "DS", "Value": [22.5]},
        "3759": {"vr": "DS", "Value": [20.0]},
        "3760": {"vr": "DS", "Value": [20.0]},
        "3761": {"vr": "DS", "Value": [22.5]},
        "3762": {"vr": "DS", "Value": [22.5]},
        "3763": {"vr": "DS", "Value": [20.0]},
        "3764": {"vr": "DS", "Value": [22.5]},
        "3765": {"vr": "DS", "Value": [20.0]},
        "3766": {"vr": "DS", "Value": [22.5]},
        "3767": {"vr": "DS", "Value": [20.0]},
        "3768": {"vr": "DS", "Value": [20.0]},
        "3769": {"vr": "DS", "Value": [20.0]},
        "3770": {"vr": "DS", "Value": [22.5]},
        "3771": {"vr": "DS", "Value": [20.0]},
        "3772": {"vr": "DS", "Value": [20.0]},
        "3773": {"vr": "DS", "Value": [22.5]},
        "3774": {"vr": "DS", "Value": [20.0]},
        "3775": {"vr": "DS", "Value": [22.5]},
        "3776": {"vr": "DS", "Value": [20.0]},
        "3777": {"vr": "DS", "Value": [22.5]},
        "3778": {"vr": "DS", "Value": [22.5]},
        "3779": {"vr": "DS", "Value": [22.5]},
        "3780": {"vr": "DS", "Value": [20.0]},
        "3781": {"vr": "DS", "Value": [20.0]},
        "3782": {"vr": "DS", "Value": [22.5]},
        "3783": {"vr": "DS", "Value": [22.5]},
        "3784": {"vr": "DS", "Value": [20.0]},
        "3785": {"vr": "DS", "Value": [20.0]},
        "3786": {"vr": "DS", "Value": [20.0]},
        "3787": {"vr": "DS", "Value": [20.0]},
        "3788": {"vr": "DS", "Value": [20.0]},
        "3789": {"vr": "DS", "Value": [20.0]},
        "3790": {"vr": "DS", "Value": [22.5]},
        "3791": {"vr": "DS", "Value": [20.0]},
        "3792": {"vr": "DS", "Value": [22.5]},
        "3793": {"vr": "DS", "Value": [22.5]},
        "3794": {"vr": "DS", "Value": [22.5]},
        "3795": {"vr": "DS", "Value": [22.5]},
        "3796": {"vr": "DS", "Value": [22.5]},
        "3797": {"vr": "DS", "Value": [20.0]},
        "3798": {"vr": "DS", "Value": [22.5]},
        "3799": {"vr": "DS", "Value": [20.0]},
        "3800": {"vr": "DS", "Value": [22.5]},
        "3801": {"vr": "DS", "Value": [22.5]},
        "3802": {"vr": "DS", "Value": [20.0]},
        "3803": {"vr": "DS", "Value": [20.0]},
        "3804": {"vr": "DS", "Value": [22.5]},
        "3805": {"vr": "DS", "Value": [20.0]},
        "3806": {"vr": "DS", "Value": [20.0]},
        "3807": {"vr": "DS", "Value": [22.5]},
        "3808": {"vr": "DS", "Value": [22.5]},
        "3809": {"vr": "DS", "Value": [22.5]},
        "3810": {"vr": "DS", "Value": [22.5]},
        "3811": {"vr": "DS", "Value": [20.0]},
        "3812": {"vr": "DS", "Value": [20.0]},
        "3813": {"vr": "DS", "Value": [20.0]},
        "3814": {"vr": "DS", "Value": [22.5]},
        "3815": {"vr": "DS", "Value": [22.5]},
        "3816": {"vr": "DS", "Value": [20.0]},
        "3817": {"vr": "DS", "Value": [20.0]},
        "3818": {"vr": "DS", "Value": [22.5]},
        "3819": {"vr": "DS", "Value": [22.5]},
        "3820": {"vr": "DS", "Value": [22.5]},
        "3821": {"vr": "DS", "Value": [22.5]},
        "3822": {"vr": "DS", "Value": [20.0]},
        "3823": {"vr": "DS", "Value": [22.5]},
        "3824": {"vr": "DS", "Value": [20.0]},
        "3825": {"vr": "DS", "Value": [20.0]},
        "3826": {"vr": "DS", "Value": [22.5]},
        "3827": {"vr": "DS", "Value": [20.0]},
        "3828": {"vr": "DS", "Value": [20.0]},
        "3829": {"vr": "DS", "Value": [22.5]},
        "3830": {"vr": "DS", "Value": [22.5]},
        "3831": {"vr": "DS", "Value": [20.0]},
        "3832": {"vr": "DS", "Value": [20.0]},
        "3833": {"vr": "DS", "Value": [20.0]},
        "3834": {"vr": "DS", "Value": [22.5]},
        "3835": {"vr": "DS", "Value": [22.5]},
        "3836": {"vr": "DS", "Value": [20.0]},
        "3837": {"vr": "DS", "Value": [20.0]},
        "3838": {"vr": "DS", "Value": [22.5]},
        "3839": {"vr": "DS", "Value": [20.0]},
        "3840": {"vr": "DS", "Value": [20.0]},
        "3841": {"vr": "DS", "Value": [22.5]},
        "3842": {"vr": "DS", "Value": [22.5]},
        "3843": {"vr": "DS", "Value": [22.5]},
        "3844": {"vr": "DS", "Value": [20.0]},
        "3845": {"vr": "DS", "Value": [22.5]},
        "3846": {"vr": "DS", "Value": [20.0]},
        "3847": {"vr": "DS", "Value": [22.5]},
        "3848": {"vr": "DS", "Value": [22.5]},
        "3849": {"vr": "DS", "Value": [20.0]},
        "3850": {"vr": "DS", "Value": [22.5]},
        "3851": {"vr": "DS", "Value": [22.5]},
        "3852": {"vr": "DS", "Value": [20.0]},
        "3853": {"vr": "DS", "Value": [20.0]},
        "3854": {"vr": "DS", "Value": [22.5]},
        "3855": {"vr": "DS", "Value": [22.5]},
        "3856": {"vr": "DS", "Value": [20.0]},
        "3857": {"vr": "DS", "Value": [22.5]},
        "3858": {"vr": "DS", "Value": [20.0]},
        "3859": {"vr": "DS", "Value": [22.5]},
        "3860": {"vr": "DS", "Value": [22.5]},
        "3861": {"vr": "DS", "Value": [20.0]},
        "3862": {"vr": "DS", "Value": [22.5]},
        "3863": {"vr": "DS", "Value": [22.5]},
        "3864": {"vr": "DS", "Value": [22.5]},
        "3865": {"vr": "DS", "Value": [20.0]},
        "3866": {"vr": "DS", "Value": [22.5]},
        "3867": {"vr": "DS", "Value": [22.5]},
        "3868": {"vr": "DS", "Value": [20.0]},
        "3869": {"vr": "DS", "Value": [22.5]},
        "3870": {"vr": "DS", "Value": [22.5]},
        "3871": {"vr": "DS", "Value": [22.5]},
        "3872": {"vr": "DS", "Value": [20.0]},
        "3873": {"vr": "DS", "Value": [20.0]},
        "3874": {"vr": "DS", "Value": [22.5]},
        "3875": {"vr": "DS", "Value": [22.5]},
        "3876": {"vr": "DS", "Value": [20.0]},
        "3877": {"vr": "DS", "Value": [22.5]},
        "3878": {"vr": "DS", "Value": [20.0]},
        "3879": {"vr": "DS", "Value": [20.0]},
        "3880": {"vr": "DS", "Value": [22.5]},
        "3881": {"vr": "DS", "Value": [20.0]},
        "3882": {"vr": "DS", "Value": [22.5]},
        "3883": {"vr": "DS", "Value": [20.0]},
        "3884": {"vr": "DS", "Value": [22.5]},
        "3885": {"vr": "DS", "Value": [20.0]},
        "3886": {"vr": "DS", "Value": [20.0]},
        "3887": {"vr": "DS", "Value": [20.0]},
        "3888": {"vr": "DS", "Value": [20.0]},
        "3889": {"vr": "DS", "Value": [20.0]},
        "3890": {"vr": "DS", "Value": [20.0]},
        "3891": {"vr": "DS", "Value": [20.0]},
        "3892": {"vr": "DS", "Value": [22.5]},
        "3893": {"vr": "DS", "Value": [22.5]},
        "3894": {"vr": "DS", "Value": [20.0]},
        "3895": {"vr": "DS", "Value": [20.0]},
        "3896": {"vr": "DS", "Value": [22.5]},
        "3897": {"vr": "DS", "Value": [20.0]},
        "3898": {"vr": "DS", "Value": [22.5]},
        "3899": {"vr": "DS", "Value": [22.5]},
        "3900": {"vr": "DS", "Value": [20.0]},
        "3901": {"vr": "DS", "Value": [22.5]},
        "3902": {"vr": "DS", "Value": [20.0]},
        "3903": {"vr": "DS", "Value": [22.5]},
        "3904": {"vr": "DS", "Value": [22.5]},
        "3905": {"vr": "DS", "Value": [20.0]},
        "3906": {"vr": "DS", "Value": [22.5]},
        "3907": {"vr": "DS", "Value": [22.5]},
        "3908": {"vr": "DS", "Value": [22.5]},
        "3909": {"vr": "DS", "Value": [22.5]},
        "3910": {"vr": "DS", "Value": [20.0]},
        "3911": {"vr": "DS", "Value": [22.5]},
        "3912": {"vr": "DS", "Value": [20.0]},
        "3913": {"vr": "DS", "Value": [22.5]},
        "3914": {"vr": "DS", "Value": [22.5]},
        "3915": {"vr": "DS", "Value": [20.0]},
        "3916": {"vr": "DS", "Value": [22.5]},
        "3917": {"vr": "DS", "Value": [22.5]},
        "3918": {"vr": "DS", "Value": [22.5]},
        "3919": {"vr": "DS", "Value": [22.5]},
        "3920": {"vr": "DS", "Value": [22.5]},
        "3921": {"vr": "DS", "Value": [20.0]},
        "3922": {"vr": "DS", "Value": [20.0]},
        "3923": {"vr": "DS", "Value": [22.5]},
        "3924": {"vr": "DS", "Value": [22.5]},
        "3925": {"vr": "DS", "Value": [22.5]},
        "3926": {"vr": "DS", "Value": [22.5]},
        "3927": {"vr": "DS", "Value": [20.0]},
        "3928": {"vr": "DS", "Value": [22.5]},
        "3929": {"vr": "DS", "Value": [22.5]},
        "3930": {"vr": "DS", "Value": [20.0]},
        "3931": {"vr": "DS", "Value": [22.5]},
        "3932": {"vr": "DS", "Value": [22.5]},
        "3933": {"vr": "DS", "Value": [22.5]},
        "3934": {"vr": "DS", "Value": [20.0]},
        "3935": {"vr": "DS", "Value": [22.5]},
        "3936": {"vr": "DS", "Value": [20.0]},
        "3937": {"vr": "DS", "Value": [20.0]},
        "3938": {"vr": "DS", "Value": [22.5]},
        "3939": {"vr": "DS", "Value": [20.0]},
        "3940": {"vr": "DS", "Value": [20.0]},
        "3941": {"vr": "DS", "Value": [20.0]},
        "3942": {"vr": "DS", "Value": [22.5]},
        "3943": {"vr": "DS", "Value": [22.5]},
        "3944": {"vr": "DS", "Value": [22.5]},
        "3945": {"vr": "DS", "Value": [22.5]},
        "3946": {"vr": "DS", "Value": [20.0]},
        "3947": {"vr": "DS", "Value": [22.5]},
        "3948": {"vr": "DS", "Value": [20.0]},
        "3949": {"vr": "DS", "Value": [22.5]},
        "3950": {"vr": "DS", "Value": [22.5]},
        "3951": {"vr": "DS", "Value": [22.5]},
        "3952": {"vr": "DS", "Value": [22.5]},
        "3953": {"vr": "DS", "Value": [22.5]},
        "3954": {"vr": "DS", "Value": [22.5]},
        "3955": {"vr": "DS", "Value": [22.5]},
        "3956": {"vr": "DS", "Value": [22.5]},
        "3957": {"vr": "DS", "Value": [22.5]},
        "3958": {"vr": "DS", "Value": [22.5]},
        "3959": {"vr": "DS", "Value": [22.5]},
        "3960": {"vr": "DS", "Value": [22.5]},
        "3961": {"vr": "DS", "Value": [20.0]},
        "3962": {"vr": "DS", "Value": [22.5]},
        "3963": {"vr": "DS", "Value": [22.5]},
        "3964": {"vr": "DS", "Value": [20.0]},
        "3965": {"vr": "DS", "Value": [22.5]},
        "3966": {"vr": "DS", "Value": [20.0]},
        "3967": {"vr": "DS", "Value": [20.0]},
        "3968": {"vr": "DS", "Value": [22.5]},
        "3969": {"vr": "DS", "Value": [20.0]},
        "3970": {"vr": "DS", "Value": [20.0]},
        "3971": {"vr": "DS", "Value": [20.0]},
        "3972": {"vr": "DS", "Value": [20.0]},
        "3973": {"vr": "DS", "Value": [22.5]},
        "3974": {"vr": "DS", "Value": [20.0]},
        "3975": {"vr": "DS", "Value": [22.5]},
        "3976": {"vr": "DS", "Value": [20.0]},
        "3977": {"vr": "DS", "Value": [22.5]},
        "3978": {"vr": "DS", "Value": [22.5]},
        "3979": {"vr": "DS", "Value": [22.5]},
        "3980": {"vr": "DS", "Value": [20.0]},
        "3981": {"vr": "DS", "Value": [20.0]},
        "3982": {"vr": "DS", "Value": [22.5]},
        "3983": {"vr": "DS", "Value": [20.0]},
        "3984": {"vr": "DS", "Value": [20.0]},
        "3985": {"vr": "DS", "Value": [22.5]},
        "3986": {"vr": "DS", "Value": [22.5]},
        "3987": {"vr": "DS", "Value": [22.5]},
        "3988": {"vr": "DS", "Value": [20.0]},
        "3989": {"vr": "DS", "Value": [22.5]},
        "3990": {"vr": "DS", "Value": [22.5]},
        "3991": {"vr": "DS", "Value": [22.5]},
        "3992": {"vr": "DS", "Value": [20.0]},
        "3993": {"vr": "DS", "Value": [20.0]},
        "3994": {"vr": "DS", "Value": [22.5]},
        "3995": {"vr": "DS", "Value": [20.0]},
        "3996": {"vr": "DS", "Value": [22.5]},
        "3997": {"vr": "DS", "Value": [22.5]},
        "3998": {"vr": "DS", "Value": [22.5]},
        "3999": {"vr": "DS", "Value": [22.5]},
        "4000": {"vr": "DS", "Value": [22.5]},
        "4001": {"vr": "DS", "Value": [22.5]},
        "4002": {"vr": "DS", "Value": [22.5]},
        "4003": {"vr": "DS", "Value": [22.5]},
        "4004": {"vr": "DS", "Value": [22.5]},
        "4005": {"vr": "DS", "Value": [22.5]},
        "4006": {"vr": "DS", "Value": [22.5]},
        "4007": {"vr": "DS", "Value": [20.0]},
        "4008": {"vr": "DS", "Value": [20.0]},
        "4009": {"vr": "DS", "Value": [22.5]},
        "4010": {"vr": "DS", "Value": [22.5]},
        "4011": {"vr": "DS", "Value": [22.5]},
        "4012": {"vr": "DS", "Value": [20.0]},
        "4013": {"vr": "DS", "Value": [22.5]},
        "4014": {"vr": "DS", "Value": [20.0]},
        "4015": {"vr": "DS", "Value": [22.5]},
        "4016": {"vr": "DS", "Value": [20.0]},
        "4017": {"vr": "DS", "Value": [20.0]},
        "4018": {"vr": "DS", "Value": [20.0]},
        "4019": {"vr": "DS", "Value": [20.0]},
    },
    "0019100C": {
        "0": {"vr": "IS", "Value": [3000]},
        "1": {"vr": "IS", "Value": [3000]},
        "2": {"vr": "IS", "Value": [3000]},
        "3": {"vr": "IS", "Value": [0]},
        "4": {"vr": "IS", "Value": [3000]},
        "5": {"vr": "IS", "Value": [3000]},
        "6": {"vr": "IS", "Value": [3000]},
        "7": {"vr": "IS", "Value": [3000]},
        "8": {"vr": "IS", "Value": [3000]},
        "9": {"vr": "IS", "Value": [3000]},
        "10": {"vr": "IS", "Value": [3000]},
        "11": {"vr": "IS", "Value": [3000]},
        "12": {"vr": "IS", "Value": [3000]},
        "13": {"vr": "IS", "Value": [0]},
        "14": {"vr": "IS", "Value": [0]},
        "15": {"vr": "IS", "Value": [3000]},
        "16": {"vr": "IS", "Value": [3000]},
        "17": {"vr": "IS", "Value": [3000]},
        "18": {"vr": "IS", "Value": [3000]},
        "19": {"vr": "IS", "Value": [3000]},
        "20": {"vr": "IS", "Value": [3000]},
        "21": {"vr": "IS", "Value": [3000]},
        "22": {"vr": "IS", "Value": [3000]},
        "23": {"vr": "IS", "Value": [3000]},
        "24": {"vr": "IS", "Value": [3000]},
        "25": {"vr": "IS", "Value": [3000]},
        "26": {"vr": "IS", "Value": [3000]},
        "27": {"vr": "IS", "Value": [3000]},
        "28": {"vr": "IS", "Value": [3000]},
        "29": {"vr": "IS", "Value": [3000]},
        "30": {"vr": "IS", "Value": [3000]},
        "31": {"vr": "IS", "Value": [0]},
        "32": {"vr": "IS", "Value": [3000]},
        "33": {"vr": "IS", "Value": [3000]},
        "34": {"vr": "IS", "Value": [0]},
        "35": {"vr": "IS", "Value": [0]},
        "36": {"vr": "IS", "Value": [3000]},
        "37": {"vr": "IS", "Value": [3000]},
        "38": {"vr": "IS", "Value": [3000]},
        "39": {"vr": "IS", "Value": [3000]},
        "40": {"vr": "IS", "Value": [0]},
        "41": {"vr": "IS", "Value": [3000]},
        "42": {"vr": "IS", "Value": [3000]},
        "43": {"vr": "IS", "Value": [3000]},
        "44": {"vr": "IS", "Value": [3000]},
        "45": {"vr": "IS", "Value": [3000]},
        "46": {"vr": "IS", "Value": [3000]},
        "47": {"vr": "IS", "Value": [3000]},
        "48": {"vr": "IS", "Value": [3000]},
        "49": {"vr": "IS", "Value": [3000]},
        "50": {"vr": "IS", "Value": [3000]},
        "51": {"vr": "IS", "Value": [3000]},
        "52": {"vr": "IS", "Value": [3000]},
        "53": {"vr": "IS", "Value": [3000]},
        "54": {"vr": "IS", "Value": [3000]},
        "55": {"vr": "IS", "Value": [3000]},
        "56": {"vr": "IS", "Value": [3000]},
        "57": {"vr": "IS", "Value": [3000]},
        "58": {"vr": "IS", "Value": [3000]},
        "59": {"vr": "IS", "Value": [3000]},
        "60": {"vr": "IS", "Value": [0]},
        "61": {"vr": "IS", "Value": [0]},
        "62": {"vr": "IS", "Value": [3000]},
        "63": {"vr": "IS", "Value": [3000]},
        "64": {"vr": "IS", "Value": [3000]},
        "65": {"vr": "IS", "Value": [3000]},
        "66": {"vr": "IS", "Value": [3000]},
        "67": {"vr": "IS", "Value": [3000]},
        "68": {"vr": "IS", "Value": [0]},
        "69": {"vr": "IS", "Value": [3000]},
        "70": {"vr": "IS", "Value": [3000]},
        "71": {"vr": "IS", "Value": [3000]},
        "72": {"vr": "IS", "Value": [3000]},
        "73": {"vr": "IS", "Value": [3000]},
        "74": {"vr": "IS", "Value": [3000]},
        "75": {"vr": "IS", "Value": [3000]},
        "76": {"vr": "IS", "Value": [3000]},
        "77": {"vr": "IS", "Value": [3000]},
        "78": {"vr": "IS", "Value": [3000]},
        "79": {"vr": "IS", "Value": [3000]},
        "80": {"vr": "IS", "Value": [0]},
        "81": {"vr": "IS", "Value": [3000]},
        "82": {"vr": "IS", "Value": [3000]},
        "83": {"vr": "IS", "Value": [3000]},
        "84": {"vr": "IS", "Value": [3000]},
        "85": {"vr": "IS", "Value": [3000]},
        "86": {"vr": "IS", "Value": [3000]},
        "87": {"vr": "IS", "Value": [3000]},
        "88": {"vr": "IS", "Value": [3000]},
        "89": {"vr": "IS", "Value": [3000]},
        "90": {"vr": "IS", "Value": [0]},
        "91": {"vr": "IS", "Value": [0]},
        "92": {"vr": "IS", "Value": [3000]},
        "93": {"vr": "IS", "Value": [3000]},
        "94": {"vr": "IS", "Value": [3000]},
        "95": {"vr": "IS", "Value": [3000]},
        "96": {"vr": "IS", "Value": [3000]},
        "97": {"vr": "IS", "Value": [3000]},
        "98": {"vr": "IS", "Value": [3000]},
        "99": {"vr": "IS", "Value": [3000]},
        "100": {"vr": "IS", "Value": [3000]},
        "101": {"vr": "IS", "Value": [3000]},
        "102": {"vr": "IS", "Value": [3000]},
        "103": {"vr": "IS", "Value": [3000]},
        "104": {"vr": "IS", "Value": [3000]},
        "105": {"vr": "IS", "Value": [3000]},
        "106": {"vr": "IS", "Value": [3000]},
        "107": {"vr": "IS", "Value": [3000]},
        "108": {"vr": "IS", "Value": [3000]},
        "109": {"vr": "IS", "Value": [3000]},
        "110": {"vr": "IS", "Value": [3000]},
        "111": {"vr": "IS", "Value": [3000]},
        "112": {"vr": "IS", "Value": [0]},
        "113": {"vr": "IS", "Value": [3000]},
        "114": {"vr": "IS", "Value": [0]},
        "115": {"vr": "IS", "Value": [3000]},
        "116": {"vr": "IS", "Value": [3000]},
        "117": {"vr": "IS", "Value": [3000]},
        "118": {"vr": "IS", "Value": [3000]},
        "119": {"vr": "IS", "Value": [3000]},
        "120": {"vr": "IS", "Value": [3000]},
        "121": {"vr": "IS", "Value": [3000]},
        "122": {"vr": "IS", "Value": [3000]},
        "123": {"vr": "IS", "Value": [3000]},
        "124": {"vr": "IS", "Value": [3000]},
        "125": {"vr": "IS", "Value": [3000]},
        "126": {"vr": "IS", "Value": [3000]},
        "127": {"vr": "IS", "Value": [3000]},
        "128": {"vr": "IS", "Value": [0]},
        "129": {"vr": "IS", "Value": [3000]},
        "130": {"vr": "IS", "Value": [3000]},
        "131": {"vr": "IS", "Value": [3000]},
        "132": {"vr": "IS", "Value": [3000]},
        "133": {"vr": "IS", "Value": [3000]},
        "134": {"vr": "IS", "Value": [3000]},
        "135": {"vr": "IS", "Value": [3000]},
        "136": {"vr": "IS", "Value": [3000]},
        "137": {"vr": "IS", "Value": [3000]},
        "138": {"vr": "IS", "Value": [3000]},
        "139": {"vr": "IS", "Value": [3000]},
        "140": {"vr": "IS", "Value": [3000]},
        "141": {"vr": "IS", "Value": [3000]},
        "142": {"vr": "IS", "Value": [3000]},
        "143": {"vr": "IS", "Value": [3000]},
        "144": {"vr": "IS", "Value": [3000]},
        "145": {"vr": "IS", "Value": [3000]},
        "146": {"vr": "IS", "Value": [3000]},
        "147": {"vr": "IS", "Value": [3000]},
        "148": {"vr": "IS", "Value": [3000]},
        "149": {"vr": "IS", "Value": [3000]},
        "150": {"vr": "IS", "Value": [3000]},
        "151": {"vr": "IS", "Value": [3000]},
        "152": {"vr": "IS", "Value": [3000]},
        "153": {"vr": "IS", "Value": [3000]},
        "154": {"vr": "IS", "Value": [3000]},
        "155": {"vr": "IS", "Value": [3000]},
        "156": {"vr": "IS", "Value": [3000]},
        "157": {"vr": "IS", "Value": [3000]},
        "158": {"vr": "IS", "Value": [3000]},
        "159": {"vr": "IS", "Value": [3000]},
        "160": {"vr": "IS", "Value": [0]},
        "161": {"vr": "IS", "Value": [3000]},
        "162": {"vr": "IS", "Value": [3000]},
        "163": {"vr": "IS", "Value": [3000]},
        "164": {"vr": "IS", "Value": [3000]},
        "165": {"vr": "IS", "Value": [3000]},
        "166": {"vr": "IS", "Value": [3000]},
        "167": {"vr": "IS", "Value": [3000]},
        "168": {"vr": "IS", "Value": [3000]},
        "169": {"vr": "IS", "Value": [3000]},
        "170": {"vr": "IS", "Value": [3000]},
        "171": {"vr": "IS", "Value": [3000]},
        "172": {"vr": "IS", "Value": [3000]},
        "173": {"vr": "IS", "Value": [3000]},
        "174": {"vr": "IS", "Value": [3000]},
        "175": {"vr": "IS", "Value": [3000]},
        "176": {"vr": "IS", "Value": [3000]},
        "177": {"vr": "IS", "Value": [3000]},
        "178": {"vr": "IS", "Value": [3000]},
        "179": {"vr": "IS", "Value": [3000]},
        "180": {"vr": "IS", "Value": [3000]},
        "181": {"vr": "IS", "Value": [3000]},
        "182": {"vr": "IS", "Value": [3000]},
        "183": {"vr": "IS", "Value": [3000]},
        "184": {"vr": "IS", "Value": [3000]},
        "185": {"vr": "IS", "Value": [3000]},
        "186": {"vr": "IS", "Value": [3000]},
        "187": {"vr": "IS", "Value": [3000]},
        "188": {"vr": "IS", "Value": [3000]},
        "189": {"vr": "IS", "Value": [3000]},
        "190": {"vr": "IS", "Value": [3000]},
        "191": {"vr": "IS", "Value": [0]},
        "192": {"vr": "IS", "Value": [3000]},
        "193": {"vr": "IS", "Value": [3000]},
        "194": {"vr": "IS", "Value": [3000]},
        "195": {"vr": "IS", "Value": [3000]},
        "196": {"vr": "IS", "Value": [3000]},
        "197": {"vr": "IS", "Value": [3000]},
        "198": {"vr": "IS", "Value": [0]},
        "199": {"vr": "IS", "Value": [3000]},
        "200": {"vr": "IS", "Value": [3000]},
        "201": {"vr": "IS", "Value": [3000]},
        "202": {"vr": "IS", "Value": [3000]},
        "203": {"vr": "IS", "Value": [3000]},
        "204": {"vr": "IS", "Value": [3000]},
        "205": {"vr": "IS", "Value": [3000]},
        "206": {"vr": "IS", "Value": [3000]},
        "207": {"vr": "IS", "Value": [3000]},
        "208": {"vr": "IS", "Value": [3000]},
        "209": {"vr": "IS", "Value": [3000]},
        "210": {"vr": "IS", "Value": [0]},
        "211": {"vr": "IS", "Value": [3000]},
        "212": {"vr": "IS", "Value": [3000]},
        "213": {"vr": "IS", "Value": [3000]},
        "214": {"vr": "IS", "Value": [3000]},
        "215": {"vr": "IS", "Value": [3000]},
        "216": {"vr": "IS", "Value": [3000]},
        "217": {"vr": "IS", "Value": [3000]},
        "218": {"vr": "IS", "Value": [3000]},
        "219": {"vr": "IS", "Value": [3000]},
        "220": {"vr": "IS", "Value": [3000]},
        "221": {"vr": "IS", "Value": [3000]},
        "222": {"vr": "IS", "Value": [3000]},
        "223": {"vr": "IS", "Value": [3000]},
        "224": {"vr": "IS", "Value": [3000]},
        "225": {"vr": "IS", "Value": [3000]},
        "226": {"vr": "IS", "Value": [3000]},
        "227": {"vr": "IS", "Value": [0]},
        "228": {"vr": "IS", "Value": [3000]},
        "229": {"vr": "IS", "Value": [3000]},
        "230": {"vr": "IS", "Value": [3000]},
        "231": {"vr": "IS", "Value": [3000]},
        "232": {"vr": "IS", "Value": [3000]},
        "233": {"vr": "IS", "Value": [3000]},
        "234": {"vr": "IS", "Value": [3000]},
        "235": {"vr": "IS", "Value": [3000]},
        "236": {"vr": "IS", "Value": [3000]},
        "237": {"vr": "IS", "Value": [3000]},
        "238": {"vr": "IS", "Value": [3000]},
        "239": {"vr": "IS", "Value": [3000]},
        "240": {"vr": "IS", "Value": [3000]},
        "241": {"vr": "IS", "Value": [3000]},
        "242": {"vr": "IS", "Value": [3000]},
        "243": {"vr": "IS", "Value": [0]},
        "244": {"vr": "IS", "Value": [3000]},
        "245": {"vr": "IS", "Value": [3000]},
        "246": {"vr": "IS", "Value": [0]},
        "247": {"vr": "IS", "Value": [3000]},
        "248": {"vr": "IS", "Value": [3000]},
        "249": {"vr": "IS", "Value": [3000]},
        "250": {"vr": "IS", "Value": [3000]},
        "251": {"vr": "IS", "Value": [3000]},
        "252": {"vr": "IS", "Value": [3000]},
        "253": {"vr": "IS", "Value": [3000]},
        "254": {"vr": "IS", "Value": [3000]},
        "255": {"vr": "IS", "Value": [3000]},
        "256": {"vr": "IS", "Value": [0]},
        "257": {"vr": "IS", "Value": [3000]},
        "258": {"vr": "IS", "Value": [3000]},
        "259": {"vr": "IS", "Value": [3000]},
        "260": {"vr": "IS", "Value": [3000]},
        "261": {"vr": "IS", "Value": [3000]},
        "262": {"vr": "IS", "Value": [3000]},
        "263": {"vr": "IS", "Value": [3000]},
        "264": {"vr": "IS", "Value": [3000]},
        "265": {"vr": "IS", "Value": [3000]},
        "266": {"vr": "IS", "Value": [3000]},
        "267": {"vr": "IS", "Value": [3000]},
        "268": {"vr": "IS", "Value": [3000]},
        "269": {"vr": "IS", "Value": [3000]},
        "270": {"vr": "IS", "Value": [0]},
        "271": {"vr": "IS", "Value": [3000]},
        "272": {"vr": "IS", "Value": [3000]},
        "273": {"vr": "IS", "Value": [3000]},
        "274": {"vr": "IS", "Value": [3000]},
        "275": {"vr": "IS", "Value": [0]},
        "276": {"vr": "IS", "Value": [3000]},
        "277": {"vr": "IS", "Value": [3000]},
        "278": {"vr": "IS", "Value": [3000]},
        "279": {"vr": "IS", "Value": [3000]},
        "280": {"vr": "IS", "Value": [3000]},
        "281": {"vr": "IS", "Value": [3000]},
        "282": {"vr": "IS", "Value": [3000]},
        "283": {"vr": "IS", "Value": [3000]},
        "284": {"vr": "IS", "Value": [3000]},
        "285": {"vr": "IS", "Value": [3000]},
        "286": {"vr": "IS", "Value": [3000]},
        "287": {"vr": "IS", "Value": [3000]},
        "288": {"vr": "IS", "Value": [3000]},
        "289": {"vr": "IS", "Value": [3000]},
        "290": {"vr": "IS", "Value": [0]},
        "291": {"vr": "IS", "Value": [3000]},
        "292": {"vr": "IS", "Value": [3000]},
        "293": {"vr": "IS", "Value": [3000]},
        "294": {"vr": "IS", "Value": [3000]},
        "295": {"vr": "IS", "Value": [3000]},
        "296": {"vr": "IS", "Value": [3000]},
        "297": {"vr": "IS", "Value": [3000]},
        "298": {"vr": "IS", "Value": [3000]},
        "299": {"vr": "IS", "Value": [3000]},
        "300": {"vr": "IS", "Value": [3000]},
        "301": {"vr": "IS", "Value": [0]},
        "302": {"vr": "IS", "Value": [3000]},
        "303": {"vr": "IS", "Value": [3000]},
        "304": {"vr": "IS", "Value": [3000]},
        "305": {"vr": "IS", "Value": [3000]},
        "306": {"vr": "IS", "Value": [3000]},
        "307": {"vr": "IS", "Value": [3000]},
        "308": {"vr": "IS", "Value": [3000]},
        "309": {"vr": "IS", "Value": [3000]},
        "310": {"vr": "IS", "Value": [3000]},
        "311": {"vr": "IS", "Value": [0]},
        "312": {"vr": "IS", "Value": [3000]},
        "313": {"vr": "IS", "Value": [0]},
        "314": {"vr": "IS", "Value": [3000]},
        "315": {"vr": "IS", "Value": [3000]},
        "316": {"vr": "IS", "Value": [0]},
        "317": {"vr": "IS", "Value": [3000]},
        "318": {"vr": "IS", "Value": [3000]},
        "319": {"vr": "IS", "Value": [3000]},
        "320": {"vr": "IS", "Value": [3000]},
        "321": {"vr": "IS", "Value": [3000]},
        "322": {"vr": "IS", "Value": [3000]},
        "323": {"vr": "IS", "Value": [3000]},
        "324": {"vr": "IS", "Value": [3000]},
        "325": {"vr": "IS", "Value": [3000]},
        "326": {"vr": "IS", "Value": [3000]},
        "327": {"vr": "IS", "Value": [3000]},
        "328": {"vr": "IS", "Value": [3000]},
        "329": {"vr": "IS", "Value": [3000]},
        "330": {"vr": "IS", "Value": [3000]},
        "331": {"vr": "IS", "Value": [3000]},
        "332": {"vr": "IS", "Value": [3000]},
        "333": {"vr": "IS", "Value": [3000]},
        "334": {"vr": "IS", "Value": [3000]},
        "335": {"vr": "IS", "Value": [3000]},
        "336": {"vr": "IS", "Value": [3000]},
        "337": {"vr": "IS", "Value": [3000]},
        "338": {"vr": "IS", "Value": [3000]},
        "339": {"vr": "IS", "Value": [3000]},
        "340": {"vr": "IS", "Value": [3000]},
        "341": {"vr": "IS", "Value": [3000]},
        "342": {"vr": "IS", "Value": [3000]},
        "343": {"vr": "IS", "Value": [3000]},
        "344": {"vr": "IS", "Value": [3000]},
        "345": {"vr": "IS", "Value": [3000]},
        "346": {"vr": "IS", "Value": [3000]},
        "347": {"vr": "IS", "Value": [3000]},
        "348": {"vr": "IS", "Value": [3000]},
        "349": {"vr": "IS", "Value": [0]},
        "350": {"vr": "IS", "Value": [0]},
        "351": {"vr": "IS", "Value": [3000]},
        "352": {"vr": "IS", "Value": [3000]},
        "353": {"vr": "IS", "Value": [3000]},
        "354": {"vr": "IS", "Value": [3000]},
        "355": {"vr": "IS", "Value": [3000]},
        "356": {"vr": "IS", "Value": [3000]},
        "357": {"vr": "IS", "Value": [3000]},
        "358": {"vr": "IS", "Value": [3000]},
        "359": {"vr": "IS", "Value": [3000]},
        "360": {"vr": "IS", "Value": [3000]},
        "361": {"vr": "IS", "Value": [0]},
        "362": {"vr": "IS", "Value": [3000]},
        "363": {"vr": "IS", "Value": [0]},
        "364": {"vr": "IS", "Value": [3000]},
        "365": {"vr": "IS", "Value": [3000]},
        "366": {"vr": "IS", "Value": [3000]},
        "367": {"vr": "IS", "Value": [3000]},
        "368": {"vr": "IS", "Value": [0]},
        "369": {"vr": "IS", "Value": [3000]},
        "370": {"vr": "IS", "Value": [3000]},
        "371": {"vr": "IS", "Value": [3000]},
        "372": {"vr": "IS", "Value": [3000]},
        "373": {"vr": "IS", "Value": [3000]},
        "374": {"vr": "IS", "Value": [3000]},
        "375": {"vr": "IS", "Value": [3000]},
        "376": {"vr": "IS", "Value": [3000]},
        "377": {"vr": "IS", "Value": [3000]},
        "378": {"vr": "IS", "Value": [3000]},
        "379": {"vr": "IS", "Value": [3000]},
        "380": {"vr": "IS", "Value": [3000]},
        "381": {"vr": "IS", "Value": [3000]},
        "382": {"vr": "IS", "Value": [3000]},
        "383": {"vr": "IS", "Value": [0]},
        "384": {"vr": "IS", "Value": [0]},
        "385": {"vr": "IS", "Value": [3000]},
        "386": {"vr": "IS", "Value": [3000]},
        "387": {"vr": "IS", "Value": [3000]},
        "388": {"vr": "IS", "Value": [3000]},
        "389": {"vr": "IS", "Value": [3000]},
        "390": {"vr": "IS", "Value": [3000]},
        "391": {"vr": "IS", "Value": [3000]},
        "392": {"vr": "IS", "Value": [3000]},
        "393": {"vr": "IS", "Value": [3000]},
        "394": {"vr": "IS", "Value": [3000]},
        "395": {"vr": "IS", "Value": [3000]},
        "396": {"vr": "IS", "Value": [0]},
        "397": {"vr": "IS", "Value": [3000]},
        "398": {"vr": "IS", "Value": [3000]},
        "399": {"vr": "IS", "Value": [0]},
        "400": {"vr": "IS", "Value": [3000]},
        "401": {"vr": "IS", "Value": [3000]},
        "402": {"vr": "IS", "Value": [3000]},
        "403": {"vr": "IS", "Value": [3000]},
        "404": {"vr": "IS", "Value": [3000]},
        "405": {"vr": "IS", "Value": [3000]},
        "406": {"vr": "IS", "Value": [3000]},
        "407": {"vr": "IS", "Value": [3000]},
        "408": {"vr": "IS", "Value": [3000]},
        "409": {"vr": "IS", "Value": [3000]},
        "410": {"vr": "IS", "Value": [3000]},
        "411": {"vr": "IS", "Value": [3000]},
        "412": {"vr": "IS", "Value": [3000]},
        "413": {"vr": "IS", "Value": [3000]},
        "414": {"vr": "IS", "Value": [3000]},
        "415": {"vr": "IS", "Value": [3000]},
        "416": {"vr": "IS", "Value": [3000]},
        "417": {"vr": "IS", "Value": [3000]},
        "418": {"vr": "IS", "Value": [0]},
        "419": {"vr": "IS", "Value": [3000]},
        "420": {"vr": "IS", "Value": [3000]},
        "421": {"vr": "IS", "Value": [3000]},
        "422": {"vr": "IS", "Value": [3000]},
        "423": {"vr": "IS", "Value": [3000]},
        "424": {"vr": "IS", "Value": [0]},
        "425": {"vr": "IS", "Value": [3000]},
        "426": {"vr": "IS", "Value": [3000]},
        "427": {"vr": "IS", "Value": [3000]},
        "428": {"vr": "IS", "Value": [3000]},
        "429": {"vr": "IS", "Value": [3000]},
        "430": {"vr": "IS", "Value": [3000]},
        "431": {"vr": "IS", "Value": [3000]},
        "432": {"vr": "IS", "Value": [3000]},
        "433": {"vr": "IS", "Value": [3000]},
        "434": {"vr": "IS", "Value": [3000]},
        "435": {"vr": "IS", "Value": [3000]},
        "436": {"vr": "IS", "Value": [3000]},
        "437": {"vr": "IS", "Value": [3000]},
        "438": {"vr": "IS", "Value": [3000]},
        "439": {"vr": "IS", "Value": [3000]},
        "440": {"vr": "IS", "Value": [3000]},
        "441": {"vr": "IS", "Value": [3000]},
        "442": {"vr": "IS", "Value": [3000]},
        "443": {"vr": "IS", "Value": [3000]},
        "444": {"vr": "IS", "Value": [3000]},
        "445": {"vr": "IS", "Value": [0]},
        "446": {"vr": "IS", "Value": [3000]},
        "447": {"vr": "IS", "Value": [3000]},
        "448": {"vr": "IS", "Value": [0]},
        "449": {"vr": "IS", "Value": [3000]},
        "450": {"vr": "IS", "Value": [3000]},
        "451": {"vr": "IS", "Value": [3000]},
        "452": {"vr": "IS", "Value": [3000]},
        "453": {"vr": "IS", "Value": [3000]},
        "454": {"vr": "IS", "Value": [3000]},
        "455": {"vr": "IS", "Value": [3000]},
        "456": {"vr": "IS", "Value": [3000]},
        "457": {"vr": "IS", "Value": [3000]},
        "458": {"vr": "IS", "Value": [3000]},
        "459": {"vr": "IS", "Value": [3000]},
        "460": {"vr": "IS", "Value": [3000]},
        "461": {"vr": "IS", "Value": [3000]},
        "462": {"vr": "IS", "Value": [3000]},
        "463": {"vr": "IS", "Value": [3000]},
        "464": {"vr": "IS", "Value": [3000]},
        "465": {"vr": "IS", "Value": [3000]},
        "466": {"vr": "IS", "Value": [3000]},
        "467": {"vr": "IS", "Value": [3000]},
        "468": {"vr": "IS", "Value": [3000]},
        "469": {"vr": "IS", "Value": [0]},
        "470": {"vr": "IS", "Value": [3000]},
        "471": {"vr": "IS", "Value": [3000]},
        "472": {"vr": "IS", "Value": [3000]},
        "473": {"vr": "IS", "Value": [3000]},
        "474": {"vr": "IS", "Value": [3000]},
        "475": {"vr": "IS", "Value": [0]},
        "476": {"vr": "IS", "Value": [3000]},
        "477": {"vr": "IS", "Value": [3000]},
        "478": {"vr": "IS", "Value": [3000]},
        "479": {"vr": "IS", "Value": [3000]},
        "480": {"vr": "IS", "Value": [3000]},
        "481": {"vr": "IS", "Value": [3000]},
        "482": {"vr": "IS", "Value": [3000]},
        "483": {"vr": "IS", "Value": [0]},
        "484": {"vr": "IS", "Value": [3000]},
        "485": {"vr": "IS", "Value": [3000]},
        "486": {"vr": "IS", "Value": [3000]},
        "487": {"vr": "IS", "Value": [3000]},
        "488": {"vr": "IS", "Value": [3000]},
        "489": {"vr": "IS", "Value": [3000]},
        "490": {"vr": "IS", "Value": [3000]},
        "491": {"vr": "IS", "Value": [3000]},
        "492": {"vr": "IS", "Value": [3000]},
        "493": {"vr": "IS", "Value": [3000]},
        "494": {"vr": "IS", "Value": [3000]},
        "495": {"vr": "IS", "Value": [3000]},
        "496": {"vr": "IS", "Value": [3000]},
        "497": {"vr": "IS", "Value": [0]},
        "498": {"vr": "IS", "Value": [3000]},
        "499": {"vr": "IS", "Value": [3000]},
        "500": {"vr": "IS", "Value": [3000]},
        "501": {"vr": "IS", "Value": [0]},
        "502": {"vr": "IS", "Value": [3000]},
        "503": {"vr": "IS", "Value": [3000]},
        "504": {"vr": "IS", "Value": [3000]},
        "505": {"vr": "IS", "Value": [3000]},
        "506": {"vr": "IS", "Value": [3000]},
        "507": {"vr": "IS", "Value": [0]},
        "508": {"vr": "IS", "Value": [3000]},
        "509": {"vr": "IS", "Value": [3000]},
        "510": {"vr": "IS", "Value": [3000]},
        "511": {"vr": "IS", "Value": [3000]},
        "512": {"vr": "IS", "Value": [3000]},
        "513": {"vr": "IS", "Value": [3000]},
        "514": {"vr": "IS", "Value": [0]},
        "515": {"vr": "IS", "Value": [0]},
        "516": {"vr": "IS", "Value": [3000]},
        "517": {"vr": "IS", "Value": [3000]},
        "518": {"vr": "IS", "Value": [3000]},
        "519": {"vr": "IS", "Value": [3000]},
        "520": {"vr": "IS", "Value": [0]},
        "521": {"vr": "IS", "Value": [3000]},
        "522": {"vr": "IS", "Value": [3000]},
        "523": {"vr": "IS", "Value": [3000]},
        "524": {"vr": "IS", "Value": [3000]},
        "525": {"vr": "IS", "Value": [3000]},
        "526": {"vr": "IS", "Value": [3000]},
        "527": {"vr": "IS", "Value": [3000]},
        "528": {"vr": "IS", "Value": [3000]},
        "529": {"vr": "IS", "Value": [3000]},
        "530": {"vr": "IS", "Value": [3000]},
        "531": {"vr": "IS", "Value": [0]},
        "532": {"vr": "IS", "Value": [3000]},
        "533": {"vr": "IS", "Value": [3000]},
        "534": {"vr": "IS", "Value": [3000]},
        "535": {"vr": "IS", "Value": [3000]},
        "536": {"vr": "IS", "Value": [3000]},
        "537": {"vr": "IS", "Value": [3000]},
        "538": {"vr": "IS", "Value": [3000]},
        "539": {"vr": "IS", "Value": [0]},
        "540": {"vr": "IS", "Value": [3000]},
        "541": {"vr": "IS", "Value": [3000]},
        "542": {"vr": "IS", "Value": [0]},
        "543": {"vr": "IS", "Value": [3000]},
        "544": {"vr": "IS", "Value": [0]},
        "545": {"vr": "IS", "Value": [3000]},
        "546": {"vr": "IS", "Value": [3000]},
        "547": {"vr": "IS", "Value": [3000]},
        "548": {"vr": "IS", "Value": [0]},
        "549": {"vr": "IS", "Value": [3000]},
        "550": {"vr": "IS", "Value": [3000]},
        "551": {"vr": "IS", "Value": [3000]},
        "552": {"vr": "IS", "Value": [3000]},
        "553": {"vr": "IS", "Value": [0]},
        "554": {"vr": "IS", "Value": [0]},
        "555": {"vr": "IS", "Value": [0]},
        "556": {"vr": "IS", "Value": [3000]},
        "557": {"vr": "IS", "Value": [3000]},
        "558": {"vr": "IS", "Value": [3000]},
        "559": {"vr": "IS", "Value": [3000]},
        "560": {"vr": "IS", "Value": [3000]},
        "561": {"vr": "IS", "Value": [3000]},
        "562": {"vr": "IS", "Value": [3000]},
        "563": {"vr": "IS", "Value": [3000]},
        "564": {"vr": "IS", "Value": [3000]},
        "565": {"vr": "IS", "Value": [3000]},
        "566": {"vr": "IS", "Value": [3000]},
        "567": {"vr": "IS", "Value": [0]},
        "568": {"vr": "IS", "Value": [3000]},
        "569": {"vr": "IS", "Value": [3000]},
        "570": {"vr": "IS", "Value": [3000]},
        "571": {"vr": "IS", "Value": [3000]},
        "572": {"vr": "IS", "Value": [3000]},
        "573": {"vr": "IS", "Value": [3000]},
        "574": {"vr": "IS", "Value": [3000]},
        "575": {"vr": "IS", "Value": [3000]},
        "576": {"vr": "IS", "Value": [3000]},
        "577": {"vr": "IS", "Value": [3000]},
        "578": {"vr": "IS", "Value": [3000]},
        "579": {"vr": "IS", "Value": [3000]},
        "580": {"vr": "IS", "Value": [3000]},
        "581": {"vr": "IS", "Value": [3000]},
        "582": {"vr": "IS", "Value": [3000]},
        "583": {"vr": "IS", "Value": [3000]},
        "584": {"vr": "IS", "Value": [3000]},
        "585": {"vr": "IS", "Value": [0]},
        "586": {"vr": "IS", "Value": [3000]},
        "587": {"vr": "IS", "Value": [0]},
        "588": {"vr": "IS", "Value": [3000]},
        "589": {"vr": "IS", "Value": [3000]},
        "590": {"vr": "IS", "Value": [3000]},
        "591": {"vr": "IS", "Value": [3000]},
        "592": {"vr": "IS", "Value": [3000]},
        "593": {"vr": "IS", "Value": [3000]},
        "594": {"vr": "IS", "Value": [3000]},
        "595": {"vr": "IS", "Value": [3000]},
        "596": {"vr": "IS", "Value": [3000]},
        "597": {"vr": "IS", "Value": [3000]},
        "598": {"vr": "IS", "Value": [3000]},
        "599": {"vr": "IS", "Value": [3000]},
        "600": {"vr": "IS", "Value": [0]},
        "601": {"vr": "IS", "Value": [3000]},
        "602": {"vr": "IS", "Value": [3000]},
        "603": {"vr": "IS", "Value": [3000]},
        "604": {"vr": "IS", "Value": [3000]},
        "605": {"vr": "IS", "Value": [3000]},
        "606": {"vr": "IS", "Value": [3000]},
        "607": {"vr": "IS", "Value": [3000]},
        "608": {"vr": "IS", "Value": [3000]},
        "609": {"vr": "IS", "Value": [3000]},
        "610": {"vr": "IS", "Value": [3000]},
        "611": {"vr": "IS", "Value": [0]},
        "612": {"vr": "IS", "Value": [3000]},
        "613": {"vr": "IS", "Value": [3000]},
        "614": {"vr": "IS", "Value": [3000]},
        "615": {"vr": "IS", "Value": [3000]},
        "616": {"vr": "IS", "Value": [3000]},
        "617": {"vr": "IS", "Value": [3000]},
        "618": {"vr": "IS", "Value": [3000]},
        "619": {"vr": "IS", "Value": [3000]},
        "620": {"vr": "IS", "Value": [3000]},
        "621": {"vr": "IS", "Value": [3000]},
        "622": {"vr": "IS", "Value": [3000]},
        "623": {"vr": "IS", "Value": [3000]},
        "624": {"vr": "IS", "Value": [0]},
        "625": {"vr": "IS", "Value": [3000]},
        "626": {"vr": "IS", "Value": [3000]},
        "627": {"vr": "IS", "Value": [3000]},
        "628": {"vr": "IS", "Value": [3000]},
        "629": {"vr": "IS", "Value": [3000]},
        "630": {"vr": "IS", "Value": [3000]},
        "631": {"vr": "IS", "Value": [3000]},
        "632": {"vr": "IS", "Value": [3000]},
        "633": {"vr": "IS", "Value": [3000]},
        "634": {"vr": "IS", "Value": [3000]},
        "635": {"vr": "IS", "Value": [3000]},
        "636": {"vr": "IS", "Value": [0]},
        "637": {"vr": "IS", "Value": [3000]},
        "638": {"vr": "IS", "Value": [3000]},
        "639": {"vr": "IS", "Value": [3000]},
        "640": {"vr": "IS", "Value": [3000]},
        "641": {"vr": "IS", "Value": [3000]},
        "642": {"vr": "IS", "Value": [3000]},
        "643": {"vr": "IS", "Value": [3000]},
        "644": {"vr": "IS", "Value": [3000]},
        "645": {"vr": "IS", "Value": [3000]},
        "646": {"vr": "IS", "Value": [3000]},
        "647": {"vr": "IS", "Value": [3000]},
        "648": {"vr": "IS", "Value": [3000]},
        "649": {"vr": "IS", "Value": [3000]},
        "650": {"vr": "IS", "Value": [3000]},
        "651": {"vr": "IS", "Value": [3000]},
        "652": {"vr": "IS", "Value": [3000]},
        "653": {"vr": "IS", "Value": [3000]},
        "654": {"vr": "IS", "Value": [3000]},
        "655": {"vr": "IS", "Value": [3000]},
        "656": {"vr": "IS", "Value": [3000]},
        "657": {"vr": "IS", "Value": [3000]},
        "658": {"vr": "IS", "Value": [3000]},
        "659": {"vr": "IS", "Value": [3000]},
        "660": {"vr": "IS", "Value": [3000]},
        "661": {"vr": "IS", "Value": [3000]},
        "662": {"vr": "IS", "Value": [3000]},
        "663": {"vr": "IS", "Value": [0]},
        "664": {"vr": "IS", "Value": [3000]},
        "665": {"vr": "IS", "Value": [3000]},
        "666": {"vr": "IS", "Value": [3000]},
        "667": {"vr": "IS", "Value": [3000]},
        "668": {"vr": "IS", "Value": [0]},
        "669": {"vr": "IS", "Value": [3000]},
        "670": {"vr": "IS", "Value": [3000]},
        "671": {"vr": "IS", "Value": [3000]},
        "672": {"vr": "IS", "Value": [3000]},
        "673": {"vr": "IS", "Value": [3000]},
        "674": {"vr": "IS", "Value": [3000]},
        "675": {"vr": "IS", "Value": [3000]},
        "676": {"vr": "IS", "Value": [3000]},
        "677": {"vr": "IS", "Value": [3000]},
        "678": {"vr": "IS", "Value": [3000]},
        "679": {"vr": "IS", "Value": [0]},
        "680": {"vr": "IS", "Value": [3000]},
        "681": {"vr": "IS", "Value": [3000]},
        "682": {"vr": "IS", "Value": [3000]},
        "683": {"vr": "IS", "Value": [3000]},
        "684": {"vr": "IS", "Value": [3000]},
        "685": {"vr": "IS", "Value": [3000]},
        "686": {"vr": "IS", "Value": [3000]},
        "687": {"vr": "IS", "Value": [0]},
        "688": {"vr": "IS", "Value": [3000]},
        "689": {"vr": "IS", "Value": [3000]},
        "690": {"vr": "IS", "Value": [0]},
        "691": {"vr": "IS", "Value": [3000]},
        "692": {"vr": "IS", "Value": [3000]},
        "693": {"vr": "IS", "Value": [3000]},
        "694": {"vr": "IS", "Value": [3000]},
        "695": {"vr": "IS", "Value": [3000]},
        "696": {"vr": "IS", "Value": [3000]},
        "697": {"vr": "IS", "Value": [3000]},
        "698": {"vr": "IS", "Value": [3000]},
        "699": {"vr": "IS", "Value": [0]},
        "700": {"vr": "IS", "Value": [3000]},
        "701": {"vr": "IS", "Value": [3000]},
        "702": {"vr": "IS", "Value": [3000]},
        "703": {"vr": "IS", "Value": [3000]},
        "704": {"vr": "IS", "Value": [3000]},
        "705": {"vr": "IS", "Value": [3000]},
        "706": {"vr": "IS", "Value": [3000]},
        "707": {"vr": "IS", "Value": [0]},
        "708": {"vr": "IS", "Value": [3000]},
        "709": {"vr": "IS", "Value": [3000]},
        "710": {"vr": "IS", "Value": [3000]},
        "711": {"vr": "IS", "Value": [3000]},
        "712": {"vr": "IS", "Value": [3000]},
        "713": {"vr": "IS", "Value": [3000]},
        "714": {"vr": "IS", "Value": [0]},
        "715": {"vr": "IS", "Value": [0]},
        "716": {"vr": "IS", "Value": [3000]},
        "717": {"vr": "IS", "Value": [3000]},
        "718": {"vr": "IS", "Value": [3000]},
        "719": {"vr": "IS", "Value": [3000]},
        "720": {"vr": "IS", "Value": [3000]},
        "721": {"vr": "IS", "Value": [3000]},
        "722": {"vr": "IS", "Value": [3000]},
        "723": {"vr": "IS", "Value": [3000]},
        "724": {"vr": "IS", "Value": [3000]},
        "725": {"vr": "IS", "Value": [3000]},
        "726": {"vr": "IS", "Value": [3000]},
        "727": {"vr": "IS", "Value": [3000]},
        "728": {"vr": "IS", "Value": [3000]},
        "729": {"vr": "IS", "Value": [3000]},
        "730": {"vr": "IS", "Value": [3000]},
        "731": {"vr": "IS", "Value": [3000]},
        "732": {"vr": "IS", "Value": [0]},
        "733": {"vr": "IS", "Value": [3000]},
        "734": {"vr": "IS", "Value": [3000]},
        "735": {"vr": "IS", "Value": [3000]},
        "736": {"vr": "IS", "Value": [3000]},
        "737": {"vr": "IS", "Value": [3000]},
        "738": {"vr": "IS", "Value": [3000]},
        "739": {"vr": "IS", "Value": [3000]},
        "740": {"vr": "IS", "Value": [3000]},
        "741": {"vr": "IS", "Value": [3000]},
        "742": {"vr": "IS", "Value": [3000]},
        "743": {"vr": "IS", "Value": [3000]},
        "744": {"vr": "IS", "Value": [3000]},
        "745": {"vr": "IS", "Value": [3000]},
        "746": {"vr": "IS", "Value": [3000]},
        "747": {"vr": "IS", "Value": [3000]},
        "748": {"vr": "IS", "Value": [3000]},
        "749": {"vr": "IS", "Value": [3000]},
        "750": {"vr": "IS", "Value": [3000]},
        "751": {"vr": "IS", "Value": [3000]},
        "752": {"vr": "IS", "Value": [3000]},
        "753": {"vr": "IS", "Value": [3000]},
        "754": {"vr": "IS", "Value": [3000]},
        "755": {"vr": "IS", "Value": [3000]},
        "756": {"vr": "IS", "Value": [3000]},
        "757": {"vr": "IS", "Value": [0]},
        "758": {"vr": "IS", "Value": [3000]},
        "759": {"vr": "IS", "Value": [3000]},
        "760": {"vr": "IS", "Value": [3000]},
        "761": {"vr": "IS", "Value": [3000]},
        "762": {"vr": "IS", "Value": [3000]},
        "763": {"vr": "IS", "Value": [3000]},
        "764": {"vr": "IS", "Value": [3000]},
        "765": {"vr": "IS", "Value": [3000]},
        "766": {"vr": "IS", "Value": [3000]},
        "767": {"vr": "IS", "Value": [3000]},
        "768": {"vr": "IS", "Value": [3000]},
        "769": {"vr": "IS", "Value": [3000]},
        "770": {"vr": "IS", "Value": [3000]},
        "771": {"vr": "IS", "Value": [0]},
        "772": {"vr": "IS", "Value": [3000]},
        "773": {"vr": "IS", "Value": [3000]},
        "774": {"vr": "IS", "Value": [3000]},
        "775": {"vr": "IS", "Value": [3000]},
        "776": {"vr": "IS", "Value": [3000]},
        "777": {"vr": "IS", "Value": [0]},
        "778": {"vr": "IS", "Value": [3000]},
        "779": {"vr": "IS", "Value": [3000]},
        "780": {"vr": "IS", "Value": [3000]},
        "781": {"vr": "IS", "Value": [3000]},
        "782": {"vr": "IS", "Value": [3000]},
        "783": {"vr": "IS", "Value": [3000]},
        "784": {"vr": "IS", "Value": [3000]},
        "785": {"vr": "IS", "Value": [3000]},
        "786": {"vr": "IS", "Value": [3000]},
        "787": {"vr": "IS", "Value": [3000]},
        "788": {"vr": "IS", "Value": [0]},
        "789": {"vr": "IS", "Value": [3000]},
        "790": {"vr": "IS", "Value": [3000]},
        "791": {"vr": "IS", "Value": [0]},
        "792": {"vr": "IS", "Value": [3000]},
        "793": {"vr": "IS", "Value": [3000]},
        "794": {"vr": "IS", "Value": [3000]},
        "795": {"vr": "IS", "Value": [3000]},
        "796": {"vr": "IS", "Value": [3000]},
        "797": {"vr": "IS", "Value": [3000]},
        "798": {"vr": "IS", "Value": [3000]},
        "799": {"vr": "IS", "Value": [3000]},
        "800": {"vr": "IS", "Value": [3000]},
        "801": {"vr": "IS", "Value": [3000]},
        "802": {"vr": "IS", "Value": [3000]},
        "803": {"vr": "IS", "Value": [3000]},
        "804": {"vr": "IS", "Value": [3000]},
        "805": {"vr": "IS", "Value": [3000]},
        "806": {"vr": "IS", "Value": [3000]},
        "807": {"vr": "IS", "Value": [3000]},
        "808": {"vr": "IS", "Value": [3000]},
        "809": {"vr": "IS", "Value": [3000]},
        "810": {"vr": "IS", "Value": [0]},
        "811": {"vr": "IS", "Value": [3000]},
        "812": {"vr": "IS", "Value": [3000]},
        "813": {"vr": "IS", "Value": [3000]},
        "814": {"vr": "IS", "Value": [3000]},
        "815": {"vr": "IS", "Value": [3000]},
        "816": {"vr": "IS", "Value": [0]},
        "817": {"vr": "IS", "Value": [3000]},
        "818": {"vr": "IS", "Value": [3000]},
        "819": {"vr": "IS", "Value": [3000]},
        "820": {"vr": "IS", "Value": [0]},
        "821": {"vr": "IS", "Value": [3000]},
        "822": {"vr": "IS", "Value": [3000]},
        "823": {"vr": "IS", "Value": [3000]},
        "824": {"vr": "IS", "Value": [3000]},
        "825": {"vr": "IS", "Value": [3000]},
        "826": {"vr": "IS", "Value": [3000]},
        "827": {"vr": "IS", "Value": [0]},
        "828": {"vr": "IS", "Value": [3000]},
        "829": {"vr": "IS", "Value": [0]},
        "830": {"vr": "IS", "Value": [3000]},
        "831": {"vr": "IS", "Value": [3000]},
        "832": {"vr": "IS", "Value": [3000]},
        "833": {"vr": "IS", "Value": [3000]},
        "834": {"vr": "IS", "Value": [3000]},
        "835": {"vr": "IS", "Value": [3000]},
        "836": {"vr": "IS", "Value": [3000]},
        "837": {"vr": "IS", "Value": [3000]},
        "838": {"vr": "IS", "Value": [3000]},
        "839": {"vr": "IS", "Value": [3000]},
        "840": {"vr": "IS", "Value": [3000]},
        "841": {"vr": "IS", "Value": [3000]},
        "842": {"vr": "IS", "Value": [3000]},
        "843": {"vr": "IS", "Value": [3000]},
        "844": {"vr": "IS", "Value": [3000]},
        "845": {"vr": "IS", "Value": [3000]},
        "846": {"vr": "IS", "Value": [0]},
        "847": {"vr": "IS", "Value": [3000]},
        "848": {"vr": "IS", "Value": [3000]},
        "849": {"vr": "IS", "Value": [3000]},
        "850": {"vr": "IS", "Value": [0]},
        "851": {"vr": "IS", "Value": [3000]},
        "852": {"vr": "IS", "Value": [3000]},
        "853": {"vr": "IS", "Value": [3000]},
        "854": {"vr": "IS", "Value": [3000]},
        "855": {"vr": "IS", "Value": [3000]},
        "856": {"vr": "IS", "Value": [3000]},
        "857": {"vr": "IS", "Value": [3000]},
        "858": {"vr": "IS", "Value": [3000]},
        "859": {"vr": "IS", "Value": [3000]},
        "860": {"vr": "IS", "Value": [3000]},
        "861": {"vr": "IS", "Value": [0]},
        "862": {"vr": "IS", "Value": [3000]},
        "863": {"vr": "IS", "Value": [3000]},
        "864": {"vr": "IS", "Value": [3000]},
        "865": {"vr": "IS", "Value": [3000]},
        "866": {"vr": "IS", "Value": [3000]},
        "867": {"vr": "IS", "Value": [0]},
        "868": {"vr": "IS", "Value": [0]},
        "869": {"vr": "IS", "Value": [3000]},
        "870": {"vr": "IS", "Value": [0]},
        "871": {"vr": "IS", "Value": [3000]},
        "872": {"vr": "IS", "Value": [3000]},
        "873": {"vr": "IS", "Value": [3000]},
        "874": {"vr": "IS", "Value": [3000]},
        "875": {"vr": "IS", "Value": [0]},
        "876": {"vr": "IS", "Value": [3000]},
        "877": {"vr": "IS", "Value": [3000]},
        "878": {"vr": "IS", "Value": [3000]},
        "879": {"vr": "IS", "Value": [3000]},
        "880": {"vr": "IS", "Value": [3000]},
        "881": {"vr": "IS", "Value": [3000]},
        "882": {"vr": "IS", "Value": [3000]},
        "883": {"vr": "IS", "Value": [3000]},
        "884": {"vr": "IS", "Value": [3000]},
        "885": {"vr": "IS", "Value": [0]},
        "886": {"vr": "IS", "Value": [3000]},
        "887": {"vr": "IS", "Value": [3000]},
        "888": {"vr": "IS", "Value": [3000]},
        "889": {"vr": "IS", "Value": [3000]},
        "890": {"vr": "IS", "Value": [3000]},
        "891": {"vr": "IS", "Value": [3000]},
        "892": {"vr": "IS", "Value": [3000]},
        "893": {"vr": "IS", "Value": [3000]},
        "894": {"vr": "IS", "Value": [3000]},
        "895": {"vr": "IS", "Value": [3000]},
        "896": {"vr": "IS", "Value": [3000]},
        "897": {"vr": "IS", "Value": [3000]},
        "898": {"vr": "IS", "Value": [3000]},
        "899": {"vr": "IS", "Value": [3000]},
        "900": {"vr": "IS", "Value": [3000]},
        "901": {"vr": "IS", "Value": [3000]},
        "902": {"vr": "IS", "Value": [3000]},
        "903": {"vr": "IS", "Value": [3000]},
        "904": {"vr": "IS", "Value": [3000]},
        "905": {"vr": "IS", "Value": [3000]},
        "906": {"vr": "IS", "Value": [3000]},
        "907": {"vr": "IS", "Value": [3000]},
        "908": {"vr": "IS", "Value": [3000]},
        "909": {"vr": "IS", "Value": [3000]},
        "910": {"vr": "IS", "Value": [3000]},
        "911": {"vr": "IS", "Value": [3000]},
        "912": {"vr": "IS", "Value": [3000]},
        "913": {"vr": "IS", "Value": [3000]},
        "914": {"vr": "IS", "Value": [3000]},
        "915": {"vr": "IS", "Value": [3000]},
        "916": {"vr": "IS", "Value": [3000]},
        "917": {"vr": "IS", "Value": [3000]},
        "918": {"vr": "IS", "Value": [3000]},
        "919": {"vr": "IS", "Value": [0]},
        "920": {"vr": "IS", "Value": [3000]},
        "921": {"vr": "IS", "Value": [3000]},
        "922": {"vr": "IS", "Value": [3000]},
        "923": {"vr": "IS", "Value": [3000]},
        "924": {"vr": "IS", "Value": [0]},
        "925": {"vr": "IS", "Value": [3000]},
        "926": {"vr": "IS", "Value": [0]},
        "927": {"vr": "IS", "Value": [3000]},
        "928": {"vr": "IS", "Value": [3000]},
        "929": {"vr": "IS", "Value": [3000]},
        "930": {"vr": "IS", "Value": [3000]},
        "931": {"vr": "IS", "Value": [3000]},
        "932": {"vr": "IS", "Value": [0]},
        "933": {"vr": "IS", "Value": [3000]},
        "934": {"vr": "IS", "Value": [3000]},
        "935": {"vr": "IS", "Value": [3000]},
        "936": {"vr": "IS", "Value": [0]},
        "937": {"vr": "IS", "Value": [3000]},
        "938": {"vr": "IS", "Value": [3000]},
        "939": {"vr": "IS", "Value": [3000]},
        "940": {"vr": "IS", "Value": [3000]},
        "941": {"vr": "IS", "Value": [3000]},
        "942": {"vr": "IS", "Value": [3000]},
        "943": {"vr": "IS", "Value": [3000]},
        "944": {"vr": "IS", "Value": [3000]},
        "945": {"vr": "IS", "Value": [3000]},
        "946": {"vr": "IS", "Value": [3000]},
        "947": {"vr": "IS", "Value": [3000]},
        "948": {"vr": "IS", "Value": [0]},
        "949": {"vr": "IS", "Value": [3000]},
        "950": {"vr": "IS", "Value": [3000]},
        "951": {"vr": "IS", "Value": [3000]},
        "952": {"vr": "IS", "Value": [3000]},
        "953": {"vr": "IS", "Value": [3000]},
        "954": {"vr": "IS", "Value": [3000]},
        "955": {"vr": "IS", "Value": [3000]},
        "956": {"vr": "IS", "Value": [0]},
        "957": {"vr": "IS", "Value": [3000]},
        "958": {"vr": "IS", "Value": [3000]},
        "959": {"vr": "IS", "Value": [3000]},
        "960": {"vr": "IS", "Value": [3000]},
        "961": {"vr": "IS", "Value": [0]},
        "962": {"vr": "IS", "Value": [3000]},
        "963": {"vr": "IS", "Value": [3000]},
        "964": {"vr": "IS", "Value": [3000]},
        "965": {"vr": "IS", "Value": [3000]},
        "966": {"vr": "IS", "Value": [3000]},
        "967": {"vr": "IS", "Value": [3000]},
        "968": {"vr": "IS", "Value": [3000]},
        "969": {"vr": "IS", "Value": [3000]},
        "970": {"vr": "IS", "Value": [3000]},
        "971": {"vr": "IS", "Value": [3000]},
        "972": {"vr": "IS", "Value": [3000]},
        "973": {"vr": "IS", "Value": [3000]},
        "974": {"vr": "IS", "Value": [3000]},
        "975": {"vr": "IS", "Value": [3000]},
        "976": {"vr": "IS", "Value": [3000]},
        "977": {"vr": "IS", "Value": [3000]},
        "978": {"vr": "IS", "Value": [0]},
        "979": {"vr": "IS", "Value": [3000]},
        "980": {"vr": "IS", "Value": [3000]},
        "981": {"vr": "IS", "Value": [3000]},
        "982": {"vr": "IS", "Value": [3000]},
        "983": {"vr": "IS", "Value": [0]},
        "984": {"vr": "IS", "Value": [3000]},
        "985": {"vr": "IS", "Value": [3000]},
        "986": {"vr": "IS", "Value": [3000]},
        "987": {"vr": "IS", "Value": [3000]},
        "988": {"vr": "IS", "Value": [3000]},
        "989": {"vr": "IS", "Value": [3000]},
        "990": {"vr": "IS", "Value": [3000]},
        "991": {"vr": "IS", "Value": [3000]},
        "992": {"vr": "IS", "Value": [3000]},
        "993": {"vr": "IS", "Value": [3000]},
        "994": {"vr": "IS", "Value": [3000]},
        "995": {"vr": "IS", "Value": [3000]},
        "996": {"vr": "IS", "Value": [0]},
        "997": {"vr": "IS", "Value": [3000]},
        "998": {"vr": "IS", "Value": [3000]},
        "999": {"vr": "IS", "Value": [3000]},
        "1000": {"vr": "IS", "Value": [3000]},
        "1001": {"vr": "IS", "Value": [3000]},
        "1002": {"vr": "IS", "Value": [3000]},
        "1003": {"vr": "IS", "Value": [3000]},
        "1004": {"vr": "IS", "Value": [3000]},
        "1005": {"vr": "IS", "Value": [3000]},
        "1006": {"vr": "IS", "Value": [3000]},
        "1007": {"vr": "IS", "Value": [3000]},
        "1008": {"vr": "IS", "Value": [3000]},
        "1009": {"vr": "IS", "Value": [3000]},
        "1010": {"vr": "IS", "Value": [3000]},
        "1011": {"vr": "IS", "Value": [3000]},
        "1012": {"vr": "IS", "Value": [3000]},
        "1013": {"vr": "IS", "Value": [3000]},
        "1014": {"vr": "IS", "Value": [3000]},
        "1015": {"vr": "IS", "Value": [0]},
        "1016": {"vr": "IS", "Value": [0]},
        "1017": {"vr": "IS", "Value": [3000]},
        "1018": {"vr": "IS", "Value": [3000]},
        "1019": {"vr": "IS", "Value": [3000]},
        "1020": {"vr": "IS", "Value": [3000]},
        "1021": {"vr": "IS", "Value": [3000]},
        "1022": {"vr": "IS", "Value": [3000]},
        "1023": {"vr": "IS", "Value": [3000]},
        "1024": {"vr": "IS", "Value": [3000]},
        "1025": {"vr": "IS", "Value": [3000]},
        "1026": {"vr": "IS", "Value": [3000]},
        "1027": {"vr": "IS", "Value": [3000]},
        "1028": {"vr": "IS", "Value": [3000]},
        "1029": {"vr": "IS", "Value": [3000]},
        "1030": {"vr": "IS", "Value": [0]},
        "1031": {"vr": "IS", "Value": [3000]},
        "1032": {"vr": "IS", "Value": [0]},
        "1033": {"vr": "IS", "Value": [3000]},
        "1034": {"vr": "IS", "Value": [3000]},
        "1035": {"vr": "IS", "Value": [3000]},
        "1036": {"vr": "IS", "Value": [3000]},
        "1037": {"vr": "IS", "Value": [3000]},
        "1038": {"vr": "IS", "Value": [3000]},
        "1039": {"vr": "IS", "Value": [0]},
        "1040": {"vr": "IS", "Value": [3000]},
        "1041": {"vr": "IS", "Value": [3000]},
        "1042": {"vr": "IS", "Value": [3000]},
        "1043": {"vr": "IS", "Value": [3000]},
        "1044": {"vr": "IS", "Value": [3000]},
        "1045": {"vr": "IS", "Value": [3000]},
        "1046": {"vr": "IS", "Value": [3000]},
        "1047": {"vr": "IS", "Value": [3000]},
        "1048": {"vr": "IS", "Value": [3000]},
        "1049": {"vr": "IS", "Value": [3000]},
        "1050": {"vr": "IS", "Value": [3000]},
        "1051": {"vr": "IS", "Value": [3000]},
        "1052": {"vr": "IS", "Value": [3000]},
        "1053": {"vr": "IS", "Value": [3000]},
        "1054": {"vr": "IS", "Value": [3000]},
        "1055": {"vr": "IS", "Value": [3000]},
        "1056": {"vr": "IS", "Value": [3000]},
        "1057": {"vr": "IS", "Value": [3000]},
        "1058": {"vr": "IS", "Value": [3000]},
        "1059": {"vr": "IS", "Value": [3000]},
        "1060": {"vr": "IS", "Value": [0]},
        "1061": {"vr": "IS", "Value": [3000]},
        "1062": {"vr": "IS", "Value": [3000]},
        "1063": {"vr": "IS", "Value": [3000]},
        "1064": {"vr": "IS", "Value": [3000]},
        "1065": {"vr": "IS", "Value": [0]},
        "1066": {"vr": "IS", "Value": [3000]},
        "1067": {"vr": "IS", "Value": [3000]},
        "1068": {"vr": "IS", "Value": [3000]},
        "1069": {"vr": "IS", "Value": [3000]},
        "1070": {"vr": "IS", "Value": [3000]},
        "1071": {"vr": "IS", "Value": [3000]},
        "1072": {"vr": "IS", "Value": [3000]},
        "1073": {"vr": "IS", "Value": [0]},
        "1074": {"vr": "IS", "Value": [3000]},
        "1075": {"vr": "IS", "Value": [3000]},
        "1076": {"vr": "IS", "Value": [3000]},
        "1077": {"vr": "IS", "Value": [3000]},
        "1078": {"vr": "IS", "Value": [3000]},
        "1079": {"vr": "IS", "Value": [3000]},
        "1080": {"vr": "IS", "Value": [3000]},
        "1081": {"vr": "IS", "Value": [0]},
        "1082": {"vr": "IS", "Value": [3000]},
        "1083": {"vr": "IS", "Value": [3000]},
        "1084": {"vr": "IS", "Value": [3000]},
        "1085": {"vr": "IS", "Value": [3000]},
        "1086": {"vr": "IS", "Value": [3000]},
        "1087": {"vr": "IS", "Value": [3000]},
        "1088": {"vr": "IS", "Value": [0]},
        "1089": {"vr": "IS", "Value": [3000]},
        "1090": {"vr": "IS", "Value": [0]},
        "1091": {"vr": "IS", "Value": [0]},
        "1092": {"vr": "IS", "Value": [3000]},
        "1093": {"vr": "IS", "Value": [3000]},
        "1094": {"vr": "IS", "Value": [3000]},
        "1095": {"vr": "IS", "Value": [3000]},
        "1096": {"vr": "IS", "Value": [3000]},
        "1097": {"vr": "IS", "Value": [0]},
        "1098": {"vr": "IS", "Value": [3000]},
        "1099": {"vr": "IS", "Value": [3000]},
        "1100": {"vr": "IS", "Value": [3000]},
        "1101": {"vr": "IS", "Value": [3000]},
        "1102": {"vr": "IS", "Value": [3000]},
        "1103": {"vr": "IS", "Value": [3000]},
        "1104": {"vr": "IS", "Value": [3000]},
        "1105": {"vr": "IS", "Value": [0]},
        "1106": {"vr": "IS", "Value": [3000]},
        "1107": {"vr": "IS", "Value": [3000]},
        "1108": {"vr": "IS", "Value": [3000]},
        "1109": {"vr": "IS", "Value": [3000]},
        "1110": {"vr": "IS", "Value": [0]},
        "1111": {"vr": "IS", "Value": [3000]},
        "1112": {"vr": "IS", "Value": [3000]},
        "1113": {"vr": "IS", "Value": [3000]},
        "1114": {"vr": "IS", "Value": [3000]},
        "1115": {"vr": "IS", "Value": [3000]},
        "1116": {"vr": "IS", "Value": [3000]},
        "1117": {"vr": "IS", "Value": [3000]},
        "1118": {"vr": "IS", "Value": [3000]},
        "1119": {"vr": "IS", "Value": [3000]},
        "1120": {"vr": "IS", "Value": [3000]},
        "1121": {"vr": "IS", "Value": [3000]},
        "1122": {"vr": "IS", "Value": [3000]},
        "1123": {"vr": "IS", "Value": [3000]},
        "1124": {"vr": "IS", "Value": [3000]},
        "1125": {"vr": "IS", "Value": [3000]},
        "1126": {"vr": "IS", "Value": [3000]},
        "1127": {"vr": "IS", "Value": [3000]},
        "1128": {"vr": "IS", "Value": [3000]},
        "1129": {"vr": "IS", "Value": [3000]},
        "1130": {"vr": "IS", "Value": [3000]},
        "1131": {"vr": "IS", "Value": [0]},
        "1132": {"vr": "IS", "Value": [3000]},
        "1133": {"vr": "IS", "Value": [3000]},
        "1134": {"vr": "IS", "Value": [3000]},
        "1135": {"vr": "IS", "Value": [3000]},
        "1136": {"vr": "IS", "Value": [0]},
        "1137": {"vr": "IS", "Value": [3000]},
        "1138": {"vr": "IS", "Value": [3000]},
        "1139": {"vr": "IS", "Value": [3000]},
        "1140": {"vr": "IS", "Value": [3000]},
        "1141": {"vr": "IS", "Value": [3000]},
        "1142": {"vr": "IS", "Value": [3000]},
        "1143": {"vr": "IS", "Value": [3000]},
        "1144": {"vr": "IS", "Value": [3000]},
        "1145": {"vr": "IS", "Value": [3000]},
        "1146": {"vr": "IS", "Value": [3000]},
        "1147": {"vr": "IS", "Value": [0]},
        "1148": {"vr": "IS", "Value": [0]},
        "1149": {"vr": "IS", "Value": [0]},
        "1150": {"vr": "IS", "Value": [3000]},
        "1151": {"vr": "IS", "Value": [3000]},
        "1152": {"vr": "IS", "Value": [3000]},
        "1153": {"vr": "IS", "Value": [3000]},
        "1154": {"vr": "IS", "Value": [3000]},
        "1155": {"vr": "IS", "Value": [3000]},
        "1156": {"vr": "IS", "Value": [3000]},
        "1157": {"vr": "IS", "Value": [3000]},
        "1158": {"vr": "IS", "Value": [3000]},
        "1159": {"vr": "IS", "Value": [3000]},
        "1160": {"vr": "IS", "Value": [3000]},
        "1161": {"vr": "IS", "Value": [3000]},
        "1162": {"vr": "IS", "Value": [3000]},
        "1163": {"vr": "IS", "Value": [3000]},
        "1164": {"vr": "IS", "Value": [3000]},
        "1165": {"vr": "IS", "Value": [0]},
        "1166": {"vr": "IS", "Value": [0]},
        "1167": {"vr": "IS", "Value": [3000]},
        "1168": {"vr": "IS", "Value": [3000]},
        "1169": {"vr": "IS", "Value": [3000]},
        "1170": {"vr": "IS", "Value": [3000]},
        "1171": {"vr": "IS", "Value": [3000]},
        "1172": {"vr": "IS", "Value": [3000]},
        "1173": {"vr": "IS", "Value": [3000]},
        "1174": {"vr": "IS", "Value": [3000]},
        "1175": {"vr": "IS", "Value": [3000]},
        "1176": {"vr": "IS", "Value": [3000]},
        "1177": {"vr": "IS", "Value": [3000]},
        "1178": {"vr": "IS", "Value": [0]},
        "1179": {"vr": "IS", "Value": [3000]},
        "1180": {"vr": "IS", "Value": [3000]},
        "1181": {"vr": "IS", "Value": [3000]},
        "1182": {"vr": "IS", "Value": [3000]},
        "1183": {"vr": "IS", "Value": [3000]},
        "1184": {"vr": "IS", "Value": [3000]},
        "1185": {"vr": "IS", "Value": [3000]},
        "1186": {"vr": "IS", "Value": [3000]},
        "1187": {"vr": "IS", "Value": [3000]},
        "1188": {"vr": "IS", "Value": [3000]},
        "1189": {"vr": "IS", "Value": [0]},
        "1190": {"vr": "IS", "Value": [3000]},
        "1191": {"vr": "IS", "Value": [0]},
        "1192": {"vr": "IS", "Value": [3000]},
        "1193": {"vr": "IS", "Value": [0]},
        "1194": {"vr": "IS", "Value": [3000]},
        "1195": {"vr": "IS", "Value": [3000]},
        "1196": {"vr": "IS", "Value": [3000]},
        "1197": {"vr": "IS", "Value": [3000]},
        "1198": {"vr": "IS", "Value": [3000]},
        "1199": {"vr": "IS", "Value": [3000]},
        "1200": {"vr": "IS", "Value": [3000]},
        "1201": {"vr": "IS", "Value": [0]},
        "1202": {"vr": "IS", "Value": [0]},
        "1203": {"vr": "IS", "Value": [3000]},
        "1204": {"vr": "IS", "Value": [3000]},
        "1205": {"vr": "IS", "Value": [3000]},
        "1206": {"vr": "IS", "Value": [3000]},
        "1207": {"vr": "IS", "Value": [3000]},
        "1208": {"vr": "IS", "Value": [3000]},
        "1209": {"vr": "IS", "Value": [3000]},
        "1210": {"vr": "IS", "Value": [3000]},
        "1211": {"vr": "IS", "Value": [3000]},
        "1212": {"vr": "IS", "Value": [3000]},
        "1213": {"vr": "IS", "Value": [3000]},
        "1214": {"vr": "IS", "Value": [3000]},
        "1215": {"vr": "IS", "Value": [3000]},
        "1216": {"vr": "IS", "Value": [3000]},
        "1217": {"vr": "IS", "Value": [3000]},
        "1218": {"vr": "IS", "Value": [3000]},
        "1219": {"vr": "IS", "Value": [0]},
        "1220": {"vr": "IS", "Value": [0]},
        "1221": {"vr": "IS", "Value": [3000]},
        "1222": {"vr": "IS", "Value": [3000]},
        "1223": {"vr": "IS", "Value": [3000]},
        "1224": {"vr": "IS", "Value": [3000]},
        "1225": {"vr": "IS", "Value": [3000]},
        "1226": {"vr": "IS", "Value": [3000]},
        "1227": {"vr": "IS", "Value": [3000]},
        "1228": {"vr": "IS", "Value": [3000]},
        "1229": {"vr": "IS", "Value": [3000]},
        "1230": {"vr": "IS", "Value": [3000]},
        "1231": {"vr": "IS", "Value": [3000]},
        "1232": {"vr": "IS", "Value": [3000]},
        "1233": {"vr": "IS", "Value": [3000]},
        "1234": {"vr": "IS", "Value": [3000]},
        "1235": {"vr": "IS", "Value": [3000]},
        "1236": {"vr": "IS", "Value": [3000]},
        "1237": {"vr": "IS", "Value": [3000]},
        "1238": {"vr": "IS", "Value": [3000]},
        "1239": {"vr": "IS", "Value": [3000]},
        "1240": {"vr": "IS", "Value": [3000]},
        "1241": {"vr": "IS", "Value": [3000]},
        "1242": {"vr": "IS", "Value": [3000]},
        "1243": {"vr": "IS", "Value": [3000]},
        "1244": {"vr": "IS", "Value": [3000]},
        "1245": {"vr": "IS", "Value": [3000]},
        "1246": {"vr": "IS", "Value": [3000]},
        "1247": {"vr": "IS", "Value": [3000]},
        "1248": {"vr": "IS", "Value": [3000]},
        "1249": {"vr": "IS", "Value": [3000]},
        "1250": {"vr": "IS", "Value": [3000]},
        "1251": {"vr": "IS", "Value": [3000]},
        "1252": {"vr": "IS", "Value": [3000]},
        "1253": {"vr": "IS", "Value": [3000]},
        "1254": {"vr": "IS", "Value": [3000]},
        "1255": {"vr": "IS", "Value": [3000]},
        "1256": {"vr": "IS", "Value": [3000]},
        "1257": {"vr": "IS", "Value": [3000]},
        "1258": {"vr": "IS", "Value": [3000]},
        "1259": {"vr": "IS", "Value": [3000]},
        "1260": {"vr": "IS", "Value": [0]},
        "1261": {"vr": "IS", "Value": [3000]},
        "1262": {"vr": "IS", "Value": [3000]},
        "1263": {"vr": "IS", "Value": [3000]},
        "1264": {"vr": "IS", "Value": [0]},
        "1265": {"vr": "IS", "Value": [3000]},
        "1266": {"vr": "IS", "Value": [3000]},
        "1267": {"vr": "IS", "Value": [3000]},
        "1268": {"vr": "IS", "Value": [3000]},
        "1269": {"vr": "IS", "Value": [3000]},
        "1270": {"vr": "IS", "Value": [3000]},
        "1271": {"vr": "IS", "Value": [0]},
        "1272": {"vr": "IS", "Value": [3000]},
        "1273": {"vr": "IS", "Value": [3000]},
        "1274": {"vr": "IS", "Value": [3000]},
        "1275": {"vr": "IS", "Value": [3000]},
        "1276": {"vr": "IS", "Value": [3000]},
        "1277": {"vr": "IS", "Value": [3000]},
        "1278": {"vr": "IS", "Value": [3000]},
        "1279": {"vr": "IS", "Value": [3000]},
        "1280": {"vr": "IS", "Value": [3000]},
        "1281": {"vr": "IS", "Value": [3000]},
        "1282": {"vr": "IS", "Value": [0]},
        "1283": {"vr": "IS", "Value": [3000]},
        "1284": {"vr": "IS", "Value": [3000]},
        "1285": {"vr": "IS", "Value": [3000]},
        "1286": {"vr": "IS", "Value": [3000]},
        "1287": {"vr": "IS", "Value": [3000]},
        "1288": {"vr": "IS", "Value": [3000]},
        "1289": {"vr": "IS", "Value": [3000]},
        "1290": {"vr": "IS", "Value": [3000]},
        "1291": {"vr": "IS", "Value": [0]},
        "1292": {"vr": "IS", "Value": [3000]},
        "1293": {"vr": "IS", "Value": [3000]},
        "1294": {"vr": "IS", "Value": [3000]},
        "1295": {"vr": "IS", "Value": [3000]},
        "1296": {"vr": "IS", "Value": [3000]},
        "1297": {"vr": "IS", "Value": [3000]},
        "1298": {"vr": "IS", "Value": [3000]},
        "1299": {"vr": "IS", "Value": [3000]},
        "1300": {"vr": "IS", "Value": [0]},
        "1301": {"vr": "IS", "Value": [3000]},
        "1302": {"vr": "IS", "Value": [3000]},
        "1303": {"vr": "IS", "Value": [3000]},
        "1304": {"vr": "IS", "Value": [3000]},
        "1305": {"vr": "IS", "Value": [3000]},
        "1306": {"vr": "IS", "Value": [3000]},
        "1307": {"vr": "IS", "Value": [3000]},
        "1308": {"vr": "IS", "Value": [3000]},
        "1309": {"vr": "IS", "Value": [0]},
        "1310": {"vr": "IS", "Value": [3000]},
        "1311": {"vr": "IS", "Value": [3000]},
        "1312": {"vr": "IS", "Value": [3000]},
        "1313": {"vr": "IS", "Value": [3000]},
        "1314": {"vr": "IS", "Value": [3000]},
        "1315": {"vr": "IS", "Value": [3000]},
        "1316": {"vr": "IS", "Value": [3000]},
        "1317": {"vr": "IS", "Value": [3000]},
        "1318": {"vr": "IS", "Value": [3000]},
        "1319": {"vr": "IS", "Value": [3000]},
        "1320": {"vr": "IS", "Value": [3000]},
        "1321": {"vr": "IS", "Value": [3000]},
        "1322": {"vr": "IS", "Value": [3000]},
        "1323": {"vr": "IS", "Value": [3000]},
        "1324": {"vr": "IS", "Value": [0]},
        "1325": {"vr": "IS", "Value": [3000]},
        "1326": {"vr": "IS", "Value": [0]},
        "1327": {"vr": "IS", "Value": [3000]},
        "1328": {"vr": "IS", "Value": [3000]},
        "1329": {"vr": "IS", "Value": [3000]},
        "1330": {"vr": "IS", "Value": [0]},
        "1331": {"vr": "IS", "Value": [3000]},
        "1332": {"vr": "IS", "Value": [3000]},
        "1333": {"vr": "IS", "Value": [0]},
        "1334": {"vr": "IS", "Value": [3000]},
        "1335": {"vr": "IS", "Value": [3000]},
        "1336": {"vr": "IS", "Value": [3000]},
        "1337": {"vr": "IS", "Value": [3000]},
        "1338": {"vr": "IS", "Value": [3000]},
        "1339": {"vr": "IS", "Value": [3000]},
        "1340": {"vr": "IS", "Value": [3000]},
        "1341": {"vr": "IS", "Value": [3000]},
        "1342": {"vr": "IS", "Value": [3000]},
        "1343": {"vr": "IS", "Value": [3000]},
        "1344": {"vr": "IS", "Value": [3000]},
        "1345": {"vr": "IS", "Value": [3000]},
        "1346": {"vr": "IS", "Value": [3000]},
        "1347": {"vr": "IS", "Value": [0]},
        "1348": {"vr": "IS", "Value": [3000]},
        "1349": {"vr": "IS", "Value": [3000]},
        "1350": {"vr": "IS", "Value": [3000]},
        "1351": {"vr": "IS", "Value": [3000]},
        "1352": {"vr": "IS", "Value": [3000]},
        "1353": {"vr": "IS", "Value": [3000]},
        "1354": {"vr": "IS", "Value": [3000]},
        "1355": {"vr": "IS", "Value": [3000]},
        "1356": {"vr": "IS", "Value": [3000]},
        "1357": {"vr": "IS", "Value": [3000]},
        "1358": {"vr": "IS", "Value": [0]},
        "1359": {"vr": "IS", "Value": [3000]},
        "1360": {"vr": "IS", "Value": [3000]},
        "1361": {"vr": "IS", "Value": [3000]},
        "1362": {"vr": "IS", "Value": [3000]},
        "1363": {"vr": "IS", "Value": [3000]},
        "1364": {"vr": "IS", "Value": [3000]},
        "1365": {"vr": "IS", "Value": [3000]},
        "1366": {"vr": "IS", "Value": [3000]},
        "1367": {"vr": "IS", "Value": [3000]},
        "1368": {"vr": "IS", "Value": [3000]},
        "1369": {"vr": "IS", "Value": [3000]},
        "1370": {"vr": "IS", "Value": [3000]},
        "1371": {"vr": "IS", "Value": [3000]},
        "1372": {"vr": "IS", "Value": [3000]},
        "1373": {"vr": "IS", "Value": [3000]},
        "1374": {"vr": "IS", "Value": [3000]},
        "1375": {"vr": "IS", "Value": [0]},
        "1376": {"vr": "IS", "Value": [3000]},
        "1377": {"vr": "IS", "Value": [3000]},
        "1378": {"vr": "IS", "Value": [3000]},
        "1379": {"vr": "IS", "Value": [3000]},
        "1380": {"vr": "IS", "Value": [3000]},
        "1381": {"vr": "IS", "Value": [0]},
        "1382": {"vr": "IS", "Value": [3000]},
        "1383": {"vr": "IS", "Value": [3000]},
        "1384": {"vr": "IS", "Value": [3000]},
        "1385": {"vr": "IS", "Value": [3000]},
        "1386": {"vr": "IS", "Value": [3000]},
        "1387": {"vr": "IS", "Value": [3000]},
        "1388": {"vr": "IS", "Value": [3000]},
        "1389": {"vr": "IS", "Value": [3000]},
        "1390": {"vr": "IS", "Value": [3000]},
        "1391": {"vr": "IS", "Value": [3000]},
        "1392": {"vr": "IS", "Value": [3000]},
        "1393": {"vr": "IS", "Value": [3000]},
        "1394": {"vr": "IS", "Value": [3000]},
        "1395": {"vr": "IS", "Value": [3000]},
        "1396": {"vr": "IS", "Value": [3000]},
        "1397": {"vr": "IS", "Value": [3000]},
        "1398": {"vr": "IS", "Value": [3000]},
        "1399": {"vr": "IS", "Value": [3000]},
        "1400": {"vr": "IS", "Value": [3000]},
        "1401": {"vr": "IS", "Value": [3000]},
        "1402": {"vr": "IS", "Value": [3000]},
        "1403": {"vr": "IS", "Value": [3000]},
        "1404": {"vr": "IS", "Value": [0]},
        "1405": {"vr": "IS", "Value": [3000]},
        "1406": {"vr": "IS", "Value": [3000]},
        "1407": {"vr": "IS", "Value": [3000]},
        "1408": {"vr": "IS", "Value": [3000]},
        "1409": {"vr": "IS", "Value": [3000]},
        "1410": {"vr": "IS", "Value": [3000]},
        "1411": {"vr": "IS", "Value": [3000]},
        "1412": {"vr": "IS", "Value": [3000]},
        "1413": {"vr": "IS", "Value": [0]},
        "1414": {"vr": "IS", "Value": [3000]},
        "1415": {"vr": "IS", "Value": [3000]},
        "1416": {"vr": "IS", "Value": [3000]},
        "1417": {"vr": "IS", "Value": [0]},
        "1418": {"vr": "IS", "Value": [3000]},
        "1419": {"vr": "IS", "Value": [3000]},
        "1420": {"vr": "IS", "Value": [3000]},
        "1421": {"vr": "IS", "Value": [3000]},
        "1422": {"vr": "IS", "Value": [3000]},
        "1423": {"vr": "IS", "Value": [3000]},
        "1424": {"vr": "IS", "Value": [3000]},
        "1425": {"vr": "IS", "Value": [3000]},
        "1426": {"vr": "IS", "Value": [3000]},
        "1427": {"vr": "IS", "Value": [3000]},
        "1428": {"vr": "IS", "Value": [3000]},
        "1429": {"vr": "IS", "Value": [3000]},
        "1430": {"vr": "IS", "Value": [0]},
        "1431": {"vr": "IS", "Value": [3000]},
        "1432": {"vr": "IS", "Value": [3000]},
        "1433": {"vr": "IS", "Value": [3000]},
        "1434": {"vr": "IS", "Value": [3000]},
        "1435": {"vr": "IS", "Value": [3000]},
        "1436": {"vr": "IS", "Value": [3000]},
        "1437": {"vr": "IS", "Value": [3000]},
        "1438": {"vr": "IS", "Value": [3000]},
        "1439": {"vr": "IS", "Value": [3000]},
        "1440": {"vr": "IS", "Value": [3000]},
        "1441": {"vr": "IS", "Value": [3000]},
        "1442": {"vr": "IS", "Value": [0]},
        "1443": {"vr": "IS", "Value": [3000]},
        "1444": {"vr": "IS", "Value": [3000]},
        "1445": {"vr": "IS", "Value": [3000]},
        "1446": {"vr": "IS", "Value": [3000]},
        "1447": {"vr": "IS", "Value": [3000]},
        "1448": {"vr": "IS", "Value": [3000]},
        "1449": {"vr": "IS", "Value": [0]},
        "1450": {"vr": "IS", "Value": [3000]},
        "1451": {"vr": "IS", "Value": [3000]},
        "1452": {"vr": "IS", "Value": [3000]},
        "1453": {"vr": "IS", "Value": [3000]},
        "1454": {"vr": "IS", "Value": [3000]},
        "1455": {"vr": "IS", "Value": [0]},
        "1456": {"vr": "IS", "Value": [3000]},
        "1457": {"vr": "IS", "Value": [3000]},
        "1458": {"vr": "IS", "Value": [3000]},
        "1459": {"vr": "IS", "Value": [3000]},
        "1460": {"vr": "IS", "Value": [0]},
        "1461": {"vr": "IS", "Value": [0]},
        "1462": {"vr": "IS", "Value": [3000]},
        "1463": {"vr": "IS", "Value": [3000]},
        "1464": {"vr": "IS", "Value": [3000]},
        "1465": {"vr": "IS", "Value": [3000]},
        "1466": {"vr": "IS", "Value": [3000]},
        "1467": {"vr": "IS", "Value": [3000]},
        "1468": {"vr": "IS", "Value": [3000]},
        "1469": {"vr": "IS", "Value": [3000]},
        "1470": {"vr": "IS", "Value": [3000]},
        "1471": {"vr": "IS", "Value": [3000]},
        "1472": {"vr": "IS", "Value": [3000]},
        "1473": {"vr": "IS", "Value": [3000]},
        "1474": {"vr": "IS", "Value": [0]},
        "1475": {"vr": "IS", "Value": [3000]},
        "1476": {"vr": "IS", "Value": [3000]},
        "1477": {"vr": "IS", "Value": [3000]},
        "1478": {"vr": "IS", "Value": [3000]},
        "1479": {"vr": "IS", "Value": [3000]},
        "1480": {"vr": "IS", "Value": [3000]},
        "1481": {"vr": "IS", "Value": [3000]},
        "1482": {"vr": "IS", "Value": [3000]},
        "1483": {"vr": "IS", "Value": [3000]},
        "1484": {"vr": "IS", "Value": [3000]},
        "1485": {"vr": "IS", "Value": [3000]},
        "1486": {"vr": "IS", "Value": [3000]},
        "1487": {"vr": "IS", "Value": [3000]},
        "1488": {"vr": "IS", "Value": [0]},
        "1489": {"vr": "IS", "Value": [3000]},
        "1490": {"vr": "IS", "Value": [3000]},
        "1491": {"vr": "IS", "Value": [3000]},
        "1492": {"vr": "IS", "Value": [3000]},
        "1493": {"vr": "IS", "Value": [0]},
        "1494": {"vr": "IS", "Value": [3000]},
        "1495": {"vr": "IS", "Value": [3000]},
        "1496": {"vr": "IS", "Value": [3000]},
        "1497": {"vr": "IS", "Value": [3000]},
        "1498": {"vr": "IS", "Value": [3000]},
        "1499": {"vr": "IS", "Value": [3000]},
        "1500": {"vr": "IS", "Value": [3000]},
        "1501": {"vr": "IS", "Value": [3000]},
        "1502": {"vr": "IS", "Value": [3000]},
        "1503": {"vr": "IS", "Value": [3000]},
        "1504": {"vr": "IS", "Value": [3000]},
        "1505": {"vr": "IS", "Value": [3000]},
        "1506": {"vr": "IS", "Value": [3000]},
        "1507": {"vr": "IS", "Value": [3000]},
        "1508": {"vr": "IS", "Value": [3000]},
        "1509": {"vr": "IS", "Value": [3000]},
        "1510": {"vr": "IS", "Value": [3000]},
        "1511": {"vr": "IS", "Value": [3000]},
        "1512": {"vr": "IS", "Value": [0]},
        "1513": {"vr": "IS", "Value": [3000]},
        "1514": {"vr": "IS", "Value": [3000]},
        "1515": {"vr": "IS", "Value": [0]},
        "1516": {"vr": "IS", "Value": [3000]},
        "1517": {"vr": "IS", "Value": [0]},
        "1518": {"vr": "IS", "Value": [3000]},
        "1519": {"vr": "IS", "Value": [3000]},
        "1520": {"vr": "IS", "Value": [3000]},
        "1521": {"vr": "IS", "Value": [3000]},
        "1522": {"vr": "IS", "Value": [3000]},
        "1523": {"vr": "IS", "Value": [3000]},
        "1524": {"vr": "IS", "Value": [3000]},
        "1525": {"vr": "IS", "Value": [3000]},
        "1526": {"vr": "IS", "Value": [3000]},
        "1527": {"vr": "IS", "Value": [3000]},
        "1528": {"vr": "IS", "Value": [3000]},
        "1529": {"vr": "IS", "Value": [3000]},
        "1530": {"vr": "IS", "Value": [3000]},
        "1531": {"vr": "IS", "Value": [3000]},
        "1532": {"vr": "IS", "Value": [3000]},
        "1533": {"vr": "IS", "Value": [3000]},
        "1534": {"vr": "IS", "Value": [3000]},
        "1535": {"vr": "IS", "Value": [3000]},
        "1536": {"vr": "IS", "Value": [0]},
        "1537": {"vr": "IS", "Value": [3000]},
        "1538": {"vr": "IS", "Value": [3000]},
        "1539": {"vr": "IS", "Value": [3000]},
        "1540": {"vr": "IS", "Value": [3000]},
        "1541": {"vr": "IS", "Value": [3000]},
        "1542": {"vr": "IS", "Value": [3000]},
        "1543": {"vr": "IS", "Value": [3000]},
        "1544": {"vr": "IS", "Value": [3000]},
        "1545": {"vr": "IS", "Value": [3000]},
        "1546": {"vr": "IS", "Value": [3000]},
        "1547": {"vr": "IS", "Value": [3000]},
        "1548": {"vr": "IS", "Value": [3000]},
        "1549": {"vr": "IS", "Value": [3000]},
        "1550": {"vr": "IS", "Value": [3000]},
        "1551": {"vr": "IS", "Value": [3000]},
        "1552": {"vr": "IS", "Value": [3000]},
        "1553": {"vr": "IS", "Value": [0]},
        "1554": {"vr": "IS", "Value": [3000]},
        "1555": {"vr": "IS", "Value": [0]},
        "1556": {"vr": "IS", "Value": [3000]},
        "1557": {"vr": "IS", "Value": [3000]},
        "1558": {"vr": "IS", "Value": [3000]},
        "1559": {"vr": "IS", "Value": [0]},
        "1560": {"vr": "IS", "Value": [3000]},
        "1561": {"vr": "IS", "Value": [3000]},
        "1562": {"vr": "IS", "Value": [0]},
        "1563": {"vr": "IS", "Value": [3000]},
        "1564": {"vr": "IS", "Value": [3000]},
        "1565": {"vr": "IS", "Value": [3000]},
        "1566": {"vr": "IS", "Value": [3000]},
        "1567": {"vr": "IS", "Value": [3000]},
        "1568": {"vr": "IS", "Value": [3000]},
        "1569": {"vr": "IS", "Value": [3000]},
        "1570": {"vr": "IS", "Value": [3000]},
        "1571": {"vr": "IS", "Value": [3000]},
        "1572": {"vr": "IS", "Value": [3000]},
        "1573": {"vr": "IS", "Value": [3000]},
        "1574": {"vr": "IS", "Value": [0]},
        "1575": {"vr": "IS", "Value": [3000]},
        "1576": {"vr": "IS", "Value": [3000]},
        "1577": {"vr": "IS", "Value": [3000]},
        "1578": {"vr": "IS", "Value": [3000]},
        "1579": {"vr": "IS", "Value": [3000]},
        "1580": {"vr": "IS", "Value": [3000]},
        "1581": {"vr": "IS", "Value": [3000]},
        "1582": {"vr": "IS", "Value": [3000]},
        "1583": {"vr": "IS", "Value": [3000]},
        "1584": {"vr": "IS", "Value": [3000]},
        "1585": {"vr": "IS", "Value": [3000]},
        "1586": {"vr": "IS", "Value": [3000]},
        "1587": {"vr": "IS", "Value": [3000]},
        "1588": {"vr": "IS", "Value": [3000]},
        "1589": {"vr": "IS", "Value": [3000]},
        "1590": {"vr": "IS", "Value": [0]},
        "1591": {"vr": "IS", "Value": [3000]},
        "1592": {"vr": "IS", "Value": [3000]},
        "1593": {"vr": "IS", "Value": [3000]},
        "1594": {"vr": "IS", "Value": [0]},
        "1595": {"vr": "IS", "Value": [3000]},
        "1596": {"vr": "IS", "Value": [3000]},
        "1597": {"vr": "IS", "Value": [3000]},
        "1598": {"vr": "IS", "Value": [3000]},
        "1599": {"vr": "IS", "Value": [3000]},
        "1600": {"vr": "IS", "Value": [0]},
        "1601": {"vr": "IS", "Value": [0]},
        "1602": {"vr": "IS", "Value": [3000]},
        "1603": {"vr": "IS", "Value": [0]},
        "1604": {"vr": "IS", "Value": [0]},
        "1605": {"vr": "IS", "Value": [3000]},
        "1606": {"vr": "IS", "Value": [3000]},
        "1607": {"vr": "IS", "Value": [3000]},
        "1608": {"vr": "IS", "Value": [3000]},
        "1609": {"vr": "IS", "Value": [3000]},
        "1610": {"vr": "IS", "Value": [0]},
        "1611": {"vr": "IS", "Value": [3000]},
        "1612": {"vr": "IS", "Value": [3000]},
        "1613": {"vr": "IS", "Value": [3000]},
        "1614": {"vr": "IS", "Value": [3000]},
        "1615": {"vr": "IS", "Value": [3000]},
        "1616": {"vr": "IS", "Value": [3000]},
        "1617": {"vr": "IS", "Value": [3000]},
        "1618": {"vr": "IS", "Value": [3000]},
        "1619": {"vr": "IS", "Value": [3000]},
        "1620": {"vr": "IS", "Value": [3000]},
        "1621": {"vr": "IS", "Value": [3000]},
        "1622": {"vr": "IS", "Value": [3000]},
        "1623": {"vr": "IS", "Value": [3000]},
        "1624": {"vr": "IS", "Value": [3000]},
        "1625": {"vr": "IS", "Value": [0]},
        "1626": {"vr": "IS", "Value": [3000]},
        "1627": {"vr": "IS", "Value": [3000]},
        "1628": {"vr": "IS", "Value": [3000]},
        "1629": {"vr": "IS", "Value": [3000]},
        "1630": {"vr": "IS", "Value": [3000]},
        "1631": {"vr": "IS", "Value": [3000]},
        "1632": {"vr": "IS", "Value": [3000]},
        "1633": {"vr": "IS", "Value": [3000]},
        "1634": {"vr": "IS", "Value": [3000]},
        "1635": {"vr": "IS", "Value": [3000]},
        "1636": {"vr": "IS", "Value": [3000]},
        "1637": {"vr": "IS", "Value": [3000]},
        "1638": {"vr": "IS", "Value": [3000]},
        "1639": {"vr": "IS", "Value": [3000]},
        "1640": {"vr": "IS", "Value": [3000]},
        "1641": {"vr": "IS", "Value": [3000]},
        "1642": {"vr": "IS", "Value": [3000]},
        "1643": {"vr": "IS", "Value": [0]},
        "1644": {"vr": "IS", "Value": [0]},
        "1645": {"vr": "IS", "Value": [3000]},
        "1646": {"vr": "IS", "Value": [3000]},
        "1647": {"vr": "IS", "Value": [3000]},
        "1648": {"vr": "IS", "Value": [3000]},
        "1649": {"vr": "IS", "Value": [0]},
        "1650": {"vr": "IS", "Value": [3000]},
        "1651": {"vr": "IS", "Value": [3000]},
        "1652": {"vr": "IS", "Value": [3000]},
        "1653": {"vr": "IS", "Value": [3000]},
        "1654": {"vr": "IS", "Value": [3000]},
        "1655": {"vr": "IS", "Value": [3000]},
        "1656": {"vr": "IS", "Value": [3000]},
        "1657": {"vr": "IS", "Value": [3000]},
        "1658": {"vr": "IS", "Value": [3000]},
        "1659": {"vr": "IS", "Value": [3000]},
        "1660": {"vr": "IS", "Value": [3000]},
        "1661": {"vr": "IS", "Value": [3000]},
        "1662": {"vr": "IS", "Value": [3000]},
        "1663": {"vr": "IS", "Value": [3000]},
        "1664": {"vr": "IS", "Value": [3000]},
        "1665": {"vr": "IS", "Value": [3000]},
        "1666": {"vr": "IS", "Value": [3000]},
        "1667": {"vr": "IS", "Value": [3000]},
        "1668": {"vr": "IS", "Value": [3000]},
        "1669": {"vr": "IS", "Value": [3000]},
        "1670": {"vr": "IS", "Value": [3000]},
        "1671": {"vr": "IS", "Value": [3000]},
        "1672": {"vr": "IS", "Value": [3000]},
        "1673": {"vr": "IS", "Value": [3000]},
        "1674": {"vr": "IS", "Value": [3000]},
        "1675": {"vr": "IS", "Value": [3000]},
        "1676": {"vr": "IS", "Value": [3000]},
        "1677": {"vr": "IS", "Value": [3000]},
        "1678": {"vr": "IS", "Value": [3000]},
        "1679": {"vr": "IS", "Value": [3000]},
        "1680": {"vr": "IS", "Value": [3000]},
        "1681": {"vr": "IS", "Value": [3000]},
        "1682": {"vr": "IS", "Value": [3000]},
        "1683": {"vr": "IS", "Value": [3000]},
        "1684": {"vr": "IS", "Value": [3000]},
        "1685": {"vr": "IS", "Value": [3000]},
        "1686": {"vr": "IS", "Value": [3000]},
        "1687": {"vr": "IS", "Value": [3000]},
        "1688": {"vr": "IS", "Value": [3000]},
        "1689": {"vr": "IS", "Value": [0]},
        "1690": {"vr": "IS", "Value": [3000]},
        "1691": {"vr": "IS", "Value": [0]},
        "1692": {"vr": "IS", "Value": [3000]},
        "1693": {"vr": "IS", "Value": [3000]},
        "1694": {"vr": "IS", "Value": [3000]},
        "1695": {"vr": "IS", "Value": [3000]},
        "1696": {"vr": "IS", "Value": [3000]},
        "1697": {"vr": "IS", "Value": [3000]},
        "1698": {"vr": "IS", "Value": [3000]},
        "1699": {"vr": "IS", "Value": [3000]},
        "1700": {"vr": "IS", "Value": [0]},
        "1701": {"vr": "IS", "Value": [3000]},
        "1702": {"vr": "IS", "Value": [3000]},
        "1703": {"vr": "IS", "Value": [3000]},
        "1704": {"vr": "IS", "Value": [3000]},
        "1705": {"vr": "IS", "Value": [3000]},
        "1706": {"vr": "IS", "Value": [3000]},
        "1707": {"vr": "IS", "Value": [3000]},
        "1708": {"vr": "IS", "Value": [3000]},
        "1709": {"vr": "IS", "Value": [3000]},
        "1710": {"vr": "IS", "Value": [3000]},
        "1711": {"vr": "IS", "Value": [3000]},
        "1712": {"vr": "IS", "Value": [3000]},
        "1713": {"vr": "IS", "Value": [3000]},
        "1714": {"vr": "IS", "Value": [3000]},
        "1715": {"vr": "IS", "Value": [3000]},
        "1716": {"vr": "IS", "Value": [3000]},
        "1717": {"vr": "IS", "Value": [0]},
        "1718": {"vr": "IS", "Value": [3000]},
        "1719": {"vr": "IS", "Value": [3000]},
        "1720": {"vr": "IS", "Value": [0]},
        "1721": {"vr": "IS", "Value": [3000]},
        "1722": {"vr": "IS", "Value": [3000]},
        "1723": {"vr": "IS", "Value": [3000]},
        "1724": {"vr": "IS", "Value": [3000]},
        "1725": {"vr": "IS", "Value": [3000]},
        "1726": {"vr": "IS", "Value": [3000]},
        "1727": {"vr": "IS", "Value": [3000]},
        "1728": {"vr": "IS", "Value": [3000]},
        "1729": {"vr": "IS", "Value": [3000]},
        "1730": {"vr": "IS", "Value": [3000]},
        "1731": {"vr": "IS", "Value": [3000]},
        "1732": {"vr": "IS", "Value": [3000]},
        "1733": {"vr": "IS", "Value": [3000]},
        "1734": {"vr": "IS", "Value": [3000]},
        "1735": {"vr": "IS", "Value": [3000]},
        "1736": {"vr": "IS", "Value": [0]},
        "1737": {"vr": "IS", "Value": [3000]},
        "1738": {"vr": "IS", "Value": [0]},
        "1739": {"vr": "IS", "Value": [3000]},
        "1740": {"vr": "IS", "Value": [3000]},
        "1741": {"vr": "IS", "Value": [3000]},
        "1742": {"vr": "IS", "Value": [3000]},
        "1743": {"vr": "IS", "Value": [3000]},
        "1744": {"vr": "IS", "Value": [3000]},
        "1745": {"vr": "IS", "Value": [3000]},
        "1746": {"vr": "IS", "Value": [3000]},
        "1747": {"vr": "IS", "Value": [3000]},
        "1748": {"vr": "IS", "Value": [3000]},
        "1749": {"vr": "IS", "Value": [3000]},
        "1750": {"vr": "IS", "Value": [3000]},
        "1751": {"vr": "IS", "Value": [3000]},
        "1752": {"vr": "IS", "Value": [3000]},
        "1753": {"vr": "IS", "Value": [3000]},
        "1754": {"vr": "IS", "Value": [3000]},
        "1755": {"vr": "IS", "Value": [3000]},
        "1756": {"vr": "IS", "Value": [3000]},
        "1757": {"vr": "IS", "Value": [3000]},
        "1758": {"vr": "IS", "Value": [3000]},
        "1759": {"vr": "IS", "Value": [3000]},
        "1760": {"vr": "IS", "Value": [3000]},
        "1761": {"vr": "IS", "Value": [3000]},
        "1762": {"vr": "IS", "Value": [3000]},
        "1763": {"vr": "IS", "Value": [3000]},
        "1764": {"vr": "IS", "Value": [3000]},
        "1765": {"vr": "IS", "Value": [3000]},
        "1766": {"vr": "IS", "Value": [3000]},
        "1767": {"vr": "IS", "Value": [3000]},
        "1768": {"vr": "IS", "Value": [3000]},
        "1769": {"vr": "IS", "Value": [3000]},
        "1770": {"vr": "IS", "Value": [3000]},
        "1771": {"vr": "IS", "Value": [3000]},
        "1772": {"vr": "IS", "Value": [3000]},
        "1773": {"vr": "IS", "Value": [3000]},
        "1774": {"vr": "IS", "Value": [3000]},
        "1775": {"vr": "IS", "Value": [0]},
        "1776": {"vr": "IS", "Value": [3000]},
        "1777": {"vr": "IS", "Value": [3000]},
        "1778": {"vr": "IS", "Value": [3000]},
        "1779": {"vr": "IS", "Value": [3000]},
        "1780": {"vr": "IS", "Value": [3000]},
        "1781": {"vr": "IS", "Value": [3000]},
        "1782": {"vr": "IS", "Value": [3000]},
        "1783": {"vr": "IS", "Value": [3000]},
        "1784": {"vr": "IS", "Value": [3000]},
        "1785": {"vr": "IS", "Value": [3000]},
        "1786": {"vr": "IS", "Value": [3000]},
        "1787": {"vr": "IS", "Value": [3000]},
        "1788": {"vr": "IS", "Value": [3000]},
        "1789": {"vr": "IS", "Value": [3000]},
        "1790": {"vr": "IS", "Value": [3000]},
        "1791": {"vr": "IS", "Value": [3000]},
        "1792": {"vr": "IS", "Value": [3000]},
        "1793": {"vr": "IS", "Value": [3000]},
        "1794": {"vr": "IS", "Value": [3000]},
        "1795": {"vr": "IS", "Value": [3000]},
        "1796": {"vr": "IS", "Value": [0]},
        "1797": {"vr": "IS", "Value": [3000]},
        "1798": {"vr": "IS", "Value": [3000]},
        "1799": {"vr": "IS", "Value": [3000]},
        "1800": {"vr": "IS", "Value": [3000]},
        "1801": {"vr": "IS", "Value": [3000]},
        "1802": {"vr": "IS", "Value": [0]},
        "1803": {"vr": "IS", "Value": [3000]},
        "1804": {"vr": "IS", "Value": [3000]},
        "1805": {"vr": "IS", "Value": [0]},
        "1806": {"vr": "IS", "Value": [3000]},
        "1807": {"vr": "IS", "Value": [3000]},
        "1808": {"vr": "IS", "Value": [3000]},
        "1809": {"vr": "IS", "Value": [3000]},
        "1810": {"vr": "IS", "Value": [3000]},
        "1811": {"vr": "IS", "Value": [3000]},
        "1812": {"vr": "IS", "Value": [3000]},
        "1813": {"vr": "IS", "Value": [3000]},
        "1814": {"vr": "IS", "Value": [3000]},
        "1815": {"vr": "IS", "Value": [3000]},
        "1816": {"vr": "IS", "Value": [3000]},
        "1817": {"vr": "IS", "Value": [3000]},
        "1818": {"vr": "IS", "Value": [3000]},
        "1819": {"vr": "IS", "Value": [3000]},
        "1820": {"vr": "IS", "Value": [3000]},
        "1821": {"vr": "IS", "Value": [3000]},
        "1822": {"vr": "IS", "Value": [3000]},
        "1823": {"vr": "IS", "Value": [3000]},
        "1824": {"vr": "IS", "Value": [3000]},
        "1825": {"vr": "IS", "Value": [3000]},
        "1826": {"vr": "IS", "Value": [3000]},
        "1827": {"vr": "IS", "Value": [0]},
        "1828": {"vr": "IS", "Value": [3000]},
        "1829": {"vr": "IS", "Value": [3000]},
        "1830": {"vr": "IS", "Value": [3000]},
        "1831": {"vr": "IS", "Value": [3000]},
        "1832": {"vr": "IS", "Value": [3000]},
        "1833": {"vr": "IS", "Value": [3000]},
        "1834": {"vr": "IS", "Value": [3000]},
        "1835": {"vr": "IS", "Value": [3000]},
        "1836": {"vr": "IS", "Value": [3000]},
        "1837": {"vr": "IS", "Value": [0]},
        "1838": {"vr": "IS", "Value": [0]},
        "1839": {"vr": "IS", "Value": [3000]},
        "1840": {"vr": "IS", "Value": [3000]},
        "1841": {"vr": "IS", "Value": [3000]},
        "1842": {"vr": "IS", "Value": [3000]},
        "1843": {"vr": "IS", "Value": [3000]},
        "1844": {"vr": "IS", "Value": [3000]},
        "1845": {"vr": "IS", "Value": [0]},
        "1846": {"vr": "IS", "Value": [3000]},
        "1847": {"vr": "IS", "Value": [3000]},
        "1848": {"vr": "IS", "Value": [3000]},
        "1849": {"vr": "IS", "Value": [3000]},
        "1850": {"vr": "IS", "Value": [3000]},
        "1851": {"vr": "IS", "Value": [3000]},
        "1852": {"vr": "IS", "Value": [3000]},
        "1853": {"vr": "IS", "Value": [3000]},
        "1854": {"vr": "IS", "Value": [3000]},
        "1855": {"vr": "IS", "Value": [3000]},
        "1856": {"vr": "IS", "Value": [3000]},
        "1857": {"vr": "IS", "Value": [3000]},
        "1858": {"vr": "IS", "Value": [3000]},
        "1859": {"vr": "IS", "Value": [3000]},
        "1860": {"vr": "IS", "Value": [3000]},
        "1861": {"vr": "IS", "Value": [3000]},
        "1862": {"vr": "IS", "Value": [3000]},
        "1863": {"vr": "IS", "Value": [3000]},
        "1864": {"vr": "IS", "Value": [3000]},
        "1865": {"vr": "IS", "Value": [3000]},
        "1866": {"vr": "IS", "Value": [3000]},
        "1867": {"vr": "IS", "Value": [3000]},
        "1868": {"vr": "IS", "Value": [3000]},
        "1869": {"vr": "IS", "Value": [3000]},
        "1870": {"vr": "IS", "Value": [3000]},
        "1871": {"vr": "IS", "Value": [3000]},
        "1872": {"vr": "IS", "Value": [0]},
        "1873": {"vr": "IS", "Value": [0]},
        "1874": {"vr": "IS", "Value": [3000]},
        "1875": {"vr": "IS", "Value": [3000]},
        "1876": {"vr": "IS", "Value": [3000]},
        "1877": {"vr": "IS", "Value": [3000]},
        "1878": {"vr": "IS", "Value": [3000]},
        "1879": {"vr": "IS", "Value": [3000]},
        "1880": {"vr": "IS", "Value": [3000]},
        "1881": {"vr": "IS", "Value": [3000]},
        "1882": {"vr": "IS", "Value": [3000]},
        "1883": {"vr": "IS", "Value": [3000]},
        "1884": {"vr": "IS", "Value": [3000]},
        "1885": {"vr": "IS", "Value": [3000]},
        "1886": {"vr": "IS", "Value": [3000]},
        "1887": {"vr": "IS", "Value": [3000]},
        "1888": {"vr": "IS", "Value": [3000]},
        "1889": {"vr": "IS", "Value": [0]},
        "1890": {"vr": "IS", "Value": [3000]},
        "1891": {"vr": "IS", "Value": [3000]},
        "1892": {"vr": "IS", "Value": [3000]},
        "1893": {"vr": "IS", "Value": [3000]},
        "1894": {"vr": "IS", "Value": [3000]},
        "1895": {"vr": "IS", "Value": [3000]},
        "1896": {"vr": "IS", "Value": [3000]},
        "1897": {"vr": "IS", "Value": [3000]},
        "1898": {"vr": "IS", "Value": [3000]},
        "1899": {"vr": "IS", "Value": [3000]},
        "1900": {"vr": "IS", "Value": [3000]},
        "1901": {"vr": "IS", "Value": [3000]},
        "1902": {"vr": "IS", "Value": [3000]},
        "1903": {"vr": "IS", "Value": [3000]},
        "1904": {"vr": "IS", "Value": [3000]},
        "1905": {"vr": "IS", "Value": [3000]},
        "1906": {"vr": "IS", "Value": [3000]},
        "1907": {"vr": "IS", "Value": [3000]},
        "1908": {"vr": "IS", "Value": [3000]},
        "1909": {"vr": "IS", "Value": [0]},
        "1910": {"vr": "IS", "Value": [3000]},
        "1911": {"vr": "IS", "Value": [3000]},
        "1912": {"vr": "IS", "Value": [3000]},
        "1913": {"vr": "IS", "Value": [3000]},
        "1914": {"vr": "IS", "Value": [0]},
        "1915": {"vr": "IS", "Value": [0]},
        "1916": {"vr": "IS", "Value": [0]},
        "1917": {"vr": "IS", "Value": [3000]},
        "1918": {"vr": "IS", "Value": [0]},
        "1919": {"vr": "IS", "Value": [3000]},
        "1920": {"vr": "IS", "Value": [0]},
        "1921": {"vr": "IS", "Value": [3000]},
        "1922": {"vr": "IS", "Value": [3000]},
        "1923": {"vr": "IS", "Value": [3000]},
        "1924": {"vr": "IS", "Value": [3000]},
        "1925": {"vr": "IS", "Value": [3000]},
        "1926": {"vr": "IS", "Value": [3000]},
        "1927": {"vr": "IS", "Value": [3000]},
        "1928": {"vr": "IS", "Value": [3000]},
        "1929": {"vr": "IS", "Value": [3000]},
        "1930": {"vr": "IS", "Value": [3000]},
        "1931": {"vr": "IS", "Value": [3000]},
        "1932": {"vr": "IS", "Value": [3000]},
        "1933": {"vr": "IS", "Value": [0]},
        "1934": {"vr": "IS", "Value": [3000]},
        "1935": {"vr": "IS", "Value": [3000]},
        "1936": {"vr": "IS", "Value": [3000]},
        "1937": {"vr": "IS", "Value": [3000]},
        "1938": {"vr": "IS", "Value": [3000]},
        "1939": {"vr": "IS", "Value": [3000]},
        "1940": {"vr": "IS", "Value": [3000]},
        "1941": {"vr": "IS", "Value": [3000]},
        "1942": {"vr": "IS", "Value": [3000]},
        "1943": {"vr": "IS", "Value": [3000]},
        "1944": {"vr": "IS", "Value": [3000]},
        "1945": {"vr": "IS", "Value": [3000]},
        "1946": {"vr": "IS", "Value": [3000]},
        "1947": {"vr": "IS", "Value": [3000]},
        "1948": {"vr": "IS", "Value": [3000]},
        "1949": {"vr": "IS", "Value": [0]},
        "1950": {"vr": "IS", "Value": [3000]},
        "1951": {"vr": "IS", "Value": [3000]},
        "1952": {"vr": "IS", "Value": [3000]},
        "1953": {"vr": "IS", "Value": [3000]},
        "1954": {"vr": "IS", "Value": [3000]},
        "1955": {"vr": "IS", "Value": [3000]},
        "1956": {"vr": "IS", "Value": [3000]},
        "1957": {"vr": "IS", "Value": [3000]},
        "1958": {"vr": "IS", "Value": [3000]},
        "1959": {"vr": "IS", "Value": [3000]},
        "1960": {"vr": "IS", "Value": [3000]},
        "1961": {"vr": "IS", "Value": [0]},
        "1962": {"vr": "IS", "Value": [3000]},
        "1963": {"vr": "IS", "Value": [3000]},
        "1964": {"vr": "IS", "Value": [3000]},
        "1965": {"vr": "IS", "Value": [3000]},
        "1966": {"vr": "IS", "Value": [3000]},
        "1967": {"vr": "IS", "Value": [0]},
        "1968": {"vr": "IS", "Value": [3000]},
        "1969": {"vr": "IS", "Value": [3000]},
        "1970": {"vr": "IS", "Value": [3000]},
        "1971": {"vr": "IS", "Value": [3000]},
        "1972": {"vr": "IS", "Value": [3000]},
        "1973": {"vr": "IS", "Value": [0]},
        "1974": {"vr": "IS", "Value": [3000]},
        "1975": {"vr": "IS", "Value": [3000]},
        "1976": {"vr": "IS", "Value": [3000]},
        "1977": {"vr": "IS", "Value": [3000]},
        "1978": {"vr": "IS", "Value": [3000]},
        "1979": {"vr": "IS", "Value": [3000]},
        "1980": {"vr": "IS", "Value": [3000]},
        "1981": {"vr": "IS", "Value": [3000]},
        "1982": {"vr": "IS", "Value": [3000]},
        "1983": {"vr": "IS", "Value": [3000]},
        "1984": {"vr": "IS", "Value": [3000]},
        "1985": {"vr": "IS", "Value": [3000]},
        "1986": {"vr": "IS", "Value": [0]},
        "1987": {"vr": "IS", "Value": [3000]},
        "1988": {"vr": "IS", "Value": [3000]},
        "1989": {"vr": "IS", "Value": [3000]},
        "1990": {"vr": "IS", "Value": [3000]},
        "1991": {"vr": "IS", "Value": [3000]},
        "1992": {"vr": "IS", "Value": [3000]},
        "1993": {"vr": "IS", "Value": [0]},
        "1994": {"vr": "IS", "Value": [3000]},
        "1995": {"vr": "IS", "Value": [3000]},
        "1996": {"vr": "IS", "Value": [0]},
        "1997": {"vr": "IS", "Value": [3000]},
        "1998": {"vr": "IS", "Value": [3000]},
        "1999": {"vr": "IS", "Value": [3000]},
        "2000": {"vr": "IS", "Value": [3000]},
        "2001": {"vr": "IS", "Value": [0]},
        "2002": {"vr": "IS", "Value": [3000]},
        "2003": {"vr": "IS", "Value": [3000]},
        "2004": {"vr": "IS", "Value": [3000]},
        "2005": {"vr": "IS", "Value": [3000]},
        "2006": {"vr": "IS", "Value": [3000]},
        "2007": {"vr": "IS", "Value": [3000]},
        "2008": {"vr": "IS", "Value": [3000]},
        "2009": {"vr": "IS", "Value": [3000]},
        "2010": {"vr": "IS", "Value": [3000]},
        "2011": {"vr": "IS", "Value": [3000]},
        "2012": {"vr": "IS", "Value": [0]},
        "2013": {"vr": "IS", "Value": [3000]},
        "2014": {"vr": "IS", "Value": [3000]},
        "2015": {"vr": "IS", "Value": [3000]},
        "2016": {"vr": "IS", "Value": [3000]},
        "2017": {"vr": "IS", "Value": [0]},
        "2018": {"vr": "IS", "Value": [3000]},
        "2019": {"vr": "IS", "Value": [3000]},
        "2020": {"vr": "IS", "Value": [3000]},
        "2021": {"vr": "IS", "Value": [3000]},
        "2022": {"vr": "IS", "Value": [3000]},
        "2023": {"vr": "IS", "Value": [3000]},
        "2024": {"vr": "IS", "Value": [3000]},
        "2025": {"vr": "IS", "Value": [0]},
        "2026": {"vr": "IS", "Value": [3000]},
        "2027": {"vr": "IS", "Value": [3000]},
        "2028": {"vr": "IS", "Value": [3000]},
        "2029": {"vr": "IS", "Value": [0]},
        "2030": {"vr": "IS", "Value": [3000]},
        "2031": {"vr": "IS", "Value": [3000]},
        "2032": {"vr": "IS", "Value": [3000]},
        "2033": {"vr": "IS", "Value": [3000]},
        "2034": {"vr": "IS", "Value": [3000]},
        "2035": {"vr": "IS", "Value": [3000]},
        "2036": {"vr": "IS", "Value": [3000]},
        "2037": {"vr": "IS", "Value": [3000]},
        "2038": {"vr": "IS", "Value": [3000]},
        "2039": {"vr": "IS", "Value": [3000]},
        "2040": {"vr": "IS", "Value": [3000]},
        "2041": {"vr": "IS", "Value": [3000]},
        "2042": {"vr": "IS", "Value": [3000]},
        "2043": {"vr": "IS", "Value": [3000]},
        "2044": {"vr": "IS", "Value": [3000]},
        "2045": {"vr": "IS", "Value": [3000]},
        "2046": {"vr": "IS", "Value": [3000]},
        "2047": {"vr": "IS", "Value": [3000]},
        "2048": {"vr": "IS", "Value": [3000]},
        "2049": {"vr": "IS", "Value": [3000]},
        "2050": {"vr": "IS", "Value": [3000]},
        "2051": {"vr": "IS", "Value": [3000]},
        "2052": {"vr": "IS", "Value": [3000]},
        "2053": {"vr": "IS", "Value": [3000]},
        "2054": {"vr": "IS", "Value": [3000]},
        "2055": {"vr": "IS", "Value": [3000]},
        "2056": {"vr": "IS", "Value": [3000]},
        "2057": {"vr": "IS", "Value": [3000]},
        "2058": {"vr": "IS", "Value": [3000]},
        "2059": {"vr": "IS", "Value": [3000]},
        "2060": {"vr": "IS", "Value": [3000]},
        "2061": {"vr": "IS", "Value": [3000]},
        "2062": {"vr": "IS", "Value": [3000]},
        "2063": {"vr": "IS", "Value": [3000]},
        "2064": {"vr": "IS", "Value": [0]},
        "2065": {"vr": "IS", "Value": [3000]},
        "2066": {"vr": "IS", "Value": [3000]},
        "2067": {"vr": "IS", "Value": [3000]},
        "2068": {"vr": "IS", "Value": [3000]},
        "2069": {"vr": "IS", "Value": [3000]},
        "2070": {"vr": "IS", "Value": [3000]},
        "2071": {"vr": "IS", "Value": [3000]},
        "2072": {"vr": "IS", "Value": [3000]},
        "2073": {"vr": "IS", "Value": [3000]},
        "2074": {"vr": "IS", "Value": [3000]},
        "2075": {"vr": "IS", "Value": [0]},
        "2076": {"vr": "IS", "Value": [3000]},
        "2077": {"vr": "IS", "Value": [3000]},
        "2078": {"vr": "IS", "Value": [3000]},
        "2079": {"vr": "IS", "Value": [0]},
        "2080": {"vr": "IS", "Value": [3000]},
        "2081": {"vr": "IS", "Value": [3000]},
        "2082": {"vr": "IS", "Value": [0]},
        "2083": {"vr": "IS", "Value": [0]},
        "2084": {"vr": "IS", "Value": [0]},
        "2085": {"vr": "IS", "Value": [3000]},
        "2086": {"vr": "IS", "Value": [0]},
        "2087": {"vr": "IS", "Value": [3000]},
        "2088": {"vr": "IS", "Value": [3000]},
        "2089": {"vr": "IS", "Value": [3000]},
        "2090": {"vr": "IS", "Value": [3000]},
        "2091": {"vr": "IS", "Value": [3000]},
        "2092": {"vr": "IS", "Value": [3000]},
        "2093": {"vr": "IS", "Value": [3000]},
        "2094": {"vr": "IS", "Value": [3000]},
        "2095": {"vr": "IS", "Value": [3000]},
        "2096": {"vr": "IS", "Value": [3000]},
        "2097": {"vr": "IS", "Value": [3000]},
        "2098": {"vr": "IS", "Value": [0]},
        "2099": {"vr": "IS", "Value": [3000]},
        "2100": {"vr": "IS", "Value": [3000]},
        "2101": {"vr": "IS", "Value": [3000]},
        "2102": {"vr": "IS", "Value": [3000]},
        "2103": {"vr": "IS", "Value": [3000]},
        "2104": {"vr": "IS", "Value": [3000]},
        "2105": {"vr": "IS", "Value": [3000]},
        "2106": {"vr": "IS", "Value": [3000]},
        "2107": {"vr": "IS", "Value": [3000]},
        "2108": {"vr": "IS", "Value": [3000]},
        "2109": {"vr": "IS", "Value": [0]},
        "2110": {"vr": "IS", "Value": [3000]},
        "2111": {"vr": "IS", "Value": [3000]},
        "2112": {"vr": "IS", "Value": [3000]},
        "2113": {"vr": "IS", "Value": [3000]},
        "2114": {"vr": "IS", "Value": [3000]},
        "2115": {"vr": "IS", "Value": [3000]},
        "2116": {"vr": "IS", "Value": [3000]},
        "2117": {"vr": "IS", "Value": [3000]},
        "2118": {"vr": "IS", "Value": [3000]},
        "2119": {"vr": "IS", "Value": [3000]},
        "2120": {"vr": "IS", "Value": [3000]},
        "2121": {"vr": "IS", "Value": [3000]},
        "2122": {"vr": "IS", "Value": [3000]},
        "2123": {"vr": "IS", "Value": [3000]},
        "2124": {"vr": "IS", "Value": [3000]},
        "2125": {"vr": "IS", "Value": [3000]},
        "2126": {"vr": "IS", "Value": [3000]},
        "2127": {"vr": "IS", "Value": [3000]},
        "2128": {"vr": "IS", "Value": [3000]},
        "2129": {"vr": "IS", "Value": [3000]},
        "2130": {"vr": "IS", "Value": [3000]},
        "2131": {"vr": "IS", "Value": [3000]},
        "2132": {"vr": "IS", "Value": [0]},
        "2133": {"vr": "IS", "Value": [3000]},
        "2134": {"vr": "IS", "Value": [3000]},
        "2135": {"vr": "IS", "Value": [3000]},
        "2136": {"vr": "IS", "Value": [3000]},
        "2137": {"vr": "IS", "Value": [3000]},
        "2138": {"vr": "IS", "Value": [3000]},
        "2139": {"vr": "IS", "Value": [3000]},
        "2140": {"vr": "IS", "Value": [3000]},
        "2141": {"vr": "IS", "Value": [3000]},
        "2142": {"vr": "IS", "Value": [3000]},
        "2143": {"vr": "IS", "Value": [3000]},
        "2144": {"vr": "IS", "Value": [3000]},
        "2145": {"vr": "IS", "Value": [3000]},
        "2146": {"vr": "IS", "Value": [0]},
        "2147": {"vr": "IS", "Value": [3000]},
        "2148": {"vr": "IS", "Value": [3000]},
        "2149": {"vr": "IS", "Value": [3000]},
        "2150": {"vr": "IS", "Value": [3000]},
        "2151": {"vr": "IS", "Value": [3000]},
        "2152": {"vr": "IS", "Value": [3000]},
        "2153": {"vr": "IS", "Value": [3000]},
        "2154": {"vr": "IS", "Value": [3000]},
        "2155": {"vr": "IS", "Value": [3000]},
        "2156": {"vr": "IS", "Value": [3000]},
        "2157": {"vr": "IS", "Value": [3000]},
        "2158": {"vr": "IS", "Value": [0]},
        "2159": {"vr": "IS", "Value": [3000]},
        "2160": {"vr": "IS", "Value": [3000]},
        "2161": {"vr": "IS", "Value": [3000]},
        "2162": {"vr": "IS", "Value": [3000]},
        "2163": {"vr": "IS", "Value": [3000]},
        "2164": {"vr": "IS", "Value": [3000]},
        "2165": {"vr": "IS", "Value": [0]},
        "2166": {"vr": "IS", "Value": [3000]},
        "2167": {"vr": "IS", "Value": [3000]},
        "2168": {"vr": "IS", "Value": [3000]},
        "2169": {"vr": "IS", "Value": [3000]},
        "2170": {"vr": "IS", "Value": [0]},
        "2171": {"vr": "IS", "Value": [3000]},
        "2172": {"vr": "IS", "Value": [3000]},
        "2173": {"vr": "IS", "Value": [3000]},
        "2174": {"vr": "IS", "Value": [0]},
        "2175": {"vr": "IS", "Value": [3000]},
        "2176": {"vr": "IS", "Value": [3000]},
        "2177": {"vr": "IS", "Value": [3000]},
        "2178": {"vr": "IS", "Value": [3000]},
        "2179": {"vr": "IS", "Value": [3000]},
        "2180": {"vr": "IS", "Value": [3000]},
        "2181": {"vr": "IS", "Value": [3000]},
        "2182": {"vr": "IS", "Value": [3000]},
        "2183": {"vr": "IS", "Value": [3000]},
        "2184": {"vr": "IS", "Value": [3000]},
        "2185": {"vr": "IS", "Value": [3000]},
        "2186": {"vr": "IS", "Value": [3000]},
        "2187": {"vr": "IS", "Value": [0]},
        "2188": {"vr": "IS", "Value": [3000]},
        "2189": {"vr": "IS", "Value": [3000]},
        "2190": {"vr": "IS", "Value": [3000]},
        "2191": {"vr": "IS", "Value": [3000]},
        "2192": {"vr": "IS", "Value": [0]},
        "2193": {"vr": "IS", "Value": [3000]},
        "2194": {"vr": "IS", "Value": [3000]},
        "2195": {"vr": "IS", "Value": [3000]},
        "2196": {"vr": "IS", "Value": [3000]},
        "2197": {"vr": "IS", "Value": [3000]},
        "2198": {"vr": "IS", "Value": [3000]},
        "2199": {"vr": "IS", "Value": [3000]},
        "2200": {"vr": "IS", "Value": [3000]},
        "2201": {"vr": "IS", "Value": [3000]},
        "2202": {"vr": "IS", "Value": [3000]},
        "2203": {"vr": "IS", "Value": [3000]},
        "2204": {"vr": "IS", "Value": [0]},
        "2205": {"vr": "IS", "Value": [3000]},
        "2206": {"vr": "IS", "Value": [3000]},
        "2207": {"vr": "IS", "Value": [3000]},
        "2208": {"vr": "IS", "Value": [3000]},
        "2209": {"vr": "IS", "Value": [3000]},
        "2210": {"vr": "IS", "Value": [3000]},
        "2211": {"vr": "IS", "Value": [3000]},
        "2212": {"vr": "IS", "Value": [3000]},
        "2213": {"vr": "IS", "Value": [3000]},
        "2214": {"vr": "IS", "Value": [3000]},
        "2215": {"vr": "IS", "Value": [3000]},
        "2216": {"vr": "IS", "Value": [3000]},
        "2217": {"vr": "IS", "Value": [3000]},
        "2218": {"vr": "IS", "Value": [3000]},
        "2219": {"vr": "IS", "Value": [3000]},
        "2220": {"vr": "IS", "Value": [0]},
        "2221": {"vr": "IS", "Value": [3000]},
        "2222": {"vr": "IS", "Value": [3000]},
        "2223": {"vr": "IS", "Value": [3000]},
        "2224": {"vr": "IS", "Value": [3000]},
        "2225": {"vr": "IS", "Value": [3000]},
        "2226": {"vr": "IS", "Value": [3000]},
        "2227": {"vr": "IS", "Value": [3000]},
        "2228": {"vr": "IS", "Value": [3000]},
        "2229": {"vr": "IS", "Value": [3000]},
        "2230": {"vr": "IS", "Value": [3000]},
        "2231": {"vr": "IS", "Value": [3000]},
        "2232": {"vr": "IS", "Value": [3000]},
        "2233": {"vr": "IS", "Value": [3000]},
        "2234": {"vr": "IS", "Value": [3000]},
        "2235": {"vr": "IS", "Value": [3000]},
        "2236": {"vr": "IS", "Value": [3000]},
        "2237": {"vr": "IS", "Value": [3000]},
        "2238": {"vr": "IS", "Value": [3000]},
        "2239": {"vr": "IS", "Value": [0]},
        "2240": {"vr": "IS", "Value": [3000]},
        "2241": {"vr": "IS", "Value": [3000]},
        "2242": {"vr": "IS", "Value": [3000]},
        "2243": {"vr": "IS", "Value": [3000]},
        "2244": {"vr": "IS", "Value": [3000]},
        "2245": {"vr": "IS", "Value": [3000]},
        "2246": {"vr": "IS", "Value": [3000]},
        "2247": {"vr": "IS", "Value": [3000]},
        "2248": {"vr": "IS", "Value": [3000]},
        "2249": {"vr": "IS", "Value": [3000]},
        "2250": {"vr": "IS", "Value": [3000]},
        "2251": {"vr": "IS", "Value": [3000]},
        "2252": {"vr": "IS", "Value": [3000]},
        "2253": {"vr": "IS", "Value": [3000]},
        "2254": {"vr": "IS", "Value": [0]},
        "2255": {"vr": "IS", "Value": [3000]},
        "2256": {"vr": "IS", "Value": [3000]},
        "2257": {"vr": "IS", "Value": [3000]},
        "2258": {"vr": "IS", "Value": [3000]},
        "2259": {"vr": "IS", "Value": [0]},
        "2260": {"vr": "IS", "Value": [3000]},
        "2261": {"vr": "IS", "Value": [3000]},
        "2262": {"vr": "IS", "Value": [3000]},
        "2263": {"vr": "IS", "Value": [0]},
        "2264": {"vr": "IS", "Value": [3000]},
        "2265": {"vr": "IS", "Value": [3000]},
        "2266": {"vr": "IS", "Value": [3000]},
        "2267": {"vr": "IS", "Value": [3000]},
        "2268": {"vr": "IS", "Value": [3000]},
        "2269": {"vr": "IS", "Value": [3000]},
        "2270": {"vr": "IS", "Value": [3000]},
        "2271": {"vr": "IS", "Value": [3000]},
        "2272": {"vr": "IS", "Value": [3000]},
        "2273": {"vr": "IS", "Value": [3000]},
        "2274": {"vr": "IS", "Value": [3000]},
        "2275": {"vr": "IS", "Value": [3000]},
        "2276": {"vr": "IS", "Value": [3000]},
        "2277": {"vr": "IS", "Value": [3000]},
        "2278": {"vr": "IS", "Value": [0]},
        "2279": {"vr": "IS", "Value": [3000]},
        "2280": {"vr": "IS", "Value": [3000]},
        "2281": {"vr": "IS", "Value": [3000]},
        "2282": {"vr": "IS", "Value": [3000]},
        "2283": {"vr": "IS", "Value": [3000]},
        "2284": {"vr": "IS", "Value": [3000]},
        "2285": {"vr": "IS", "Value": [3000]},
        "2286": {"vr": "IS", "Value": [3000]},
        "2287": {"vr": "IS", "Value": [0]},
        "2288": {"vr": "IS", "Value": [3000]},
        "2289": {"vr": "IS", "Value": [3000]},
        "2290": {"vr": "IS", "Value": [3000]},
        "2291": {"vr": "IS", "Value": [0]},
        "2292": {"vr": "IS", "Value": [3000]},
        "2293": {"vr": "IS", "Value": [3000]},
        "2294": {"vr": "IS", "Value": [3000]},
        "2295": {"vr": "IS", "Value": [0]},
        "2296": {"vr": "IS", "Value": [0]},
        "2297": {"vr": "IS", "Value": [3000]},
        "2298": {"vr": "IS", "Value": [3000]},
        "2299": {"vr": "IS", "Value": [3000]},
        "2300": {"vr": "IS", "Value": [3000]},
        "2301": {"vr": "IS", "Value": [3000]},
        "2302": {"vr": "IS", "Value": [3000]},
        "2303": {"vr": "IS", "Value": [3000]},
        "2304": {"vr": "IS", "Value": [3000]},
        "2305": {"vr": "IS", "Value": [3000]},
        "2306": {"vr": "IS", "Value": [3000]},
        "2307": {"vr": "IS", "Value": [3000]},
        "2308": {"vr": "IS", "Value": [3000]},
        "2309": {"vr": "IS", "Value": [3000]},
        "2310": {"vr": "IS", "Value": [3000]},
        "2311": {"vr": "IS", "Value": [3000]},
        "2312": {"vr": "IS", "Value": [3000]},
        "2313": {"vr": "IS", "Value": [0]},
        "2314": {"vr": "IS", "Value": [3000]},
        "2315": {"vr": "IS", "Value": [3000]},
        "2316": {"vr": "IS", "Value": [3000]},
        "2317": {"vr": "IS", "Value": [3000]},
        "2318": {"vr": "IS", "Value": [3000]},
        "2319": {"vr": "IS", "Value": [3000]},
        "2320": {"vr": "IS", "Value": [3000]},
        "2321": {"vr": "IS", "Value": [3000]},
        "2322": {"vr": "IS", "Value": [3000]},
        "2323": {"vr": "IS", "Value": [3000]},
        "2324": {"vr": "IS", "Value": [3000]},
        "2325": {"vr": "IS", "Value": [3000]},
        "2326": {"vr": "IS", "Value": [3000]},
        "2327": {"vr": "IS", "Value": [3000]},
        "2328": {"vr": "IS", "Value": [3000]},
        "2329": {"vr": "IS", "Value": [3000]},
        "2330": {"vr": "IS", "Value": [3000]},
        "2331": {"vr": "IS", "Value": [3000]},
        "2332": {"vr": "IS", "Value": [3000]},
        "2333": {"vr": "IS", "Value": [3000]},
        "2334": {"vr": "IS", "Value": [3000]},
        "2335": {"vr": "IS", "Value": [3000]},
        "2336": {"vr": "IS", "Value": [3000]},
        "2337": {"vr": "IS", "Value": [3000]},
        "2338": {"vr": "IS", "Value": [3000]},
        "2339": {"vr": "IS", "Value": [3000]},
        "2340": {"vr": "IS", "Value": [0]},
        "2341": {"vr": "IS", "Value": [3000]},
        "2342": {"vr": "IS", "Value": [3000]},
        "2343": {"vr": "IS", "Value": [3000]},
        "2344": {"vr": "IS", "Value": [3000]},
        "2345": {"vr": "IS", "Value": [3000]},
        "2346": {"vr": "IS", "Value": [0]},
        "2347": {"vr": "IS", "Value": [3000]},
        "2348": {"vr": "IS", "Value": [3000]},
        "2349": {"vr": "IS", "Value": [3000]},
        "2350": {"vr": "IS", "Value": [3000]},
        "2351": {"vr": "IS", "Value": [3000]},
        "2352": {"vr": "IS", "Value": [3000]},
        "2353": {"vr": "IS", "Value": [3000]},
        "2354": {"vr": "IS", "Value": [3000]},
        "2355": {"vr": "IS", "Value": [3000]},
        "2356": {"vr": "IS", "Value": [3000]},
        "2357": {"vr": "IS", "Value": [3000]},
        "2358": {"vr": "IS", "Value": [3000]},
        "2359": {"vr": "IS", "Value": [0]},
        "2360": {"vr": "IS", "Value": [0]},
        "2361": {"vr": "IS", "Value": [3000]},
        "2362": {"vr": "IS", "Value": [3000]},
        "2363": {"vr": "IS", "Value": [3000]},
        "2364": {"vr": "IS", "Value": [3000]},
        "2365": {"vr": "IS", "Value": [3000]},
        "2366": {"vr": "IS", "Value": [3000]},
        "2367": {"vr": "IS", "Value": [3000]},
        "2368": {"vr": "IS", "Value": [3000]},
        "2369": {"vr": "IS", "Value": [0]},
        "2370": {"vr": "IS", "Value": [3000]},
        "2371": {"vr": "IS", "Value": [3000]},
        "2372": {"vr": "IS", "Value": [3000]},
        "2373": {"vr": "IS", "Value": [3000]},
        "2374": {"vr": "IS", "Value": [3000]},
        "2375": {"vr": "IS", "Value": [3000]},
        "2376": {"vr": "IS", "Value": [0]},
        "2377": {"vr": "IS", "Value": [3000]},
        "2378": {"vr": "IS", "Value": [3000]},
        "2379": {"vr": "IS", "Value": [3000]},
        "2380": {"vr": "IS", "Value": [3000]},
        "2381": {"vr": "IS", "Value": [0]},
        "2382": {"vr": "IS", "Value": [0]},
        "2383": {"vr": "IS", "Value": [3000]},
        "2384": {"vr": "IS", "Value": [3000]},
        "2385": {"vr": "IS", "Value": [0]},
        "2386": {"vr": "IS", "Value": [3000]},
        "2387": {"vr": "IS", "Value": [3000]},
        "2388": {"vr": "IS", "Value": [3000]},
        "2389": {"vr": "IS", "Value": [3000]},
        "2390": {"vr": "IS", "Value": [3000]},
        "2391": {"vr": "IS", "Value": [3000]},
        "2392": {"vr": "IS", "Value": [3000]},
        "2393": {"vr": "IS", "Value": [3000]},
        "2394": {"vr": "IS", "Value": [0]},
        "2395": {"vr": "IS", "Value": [3000]},
        "2396": {"vr": "IS", "Value": [3000]},
        "2397": {"vr": "IS", "Value": [3000]},
        "2398": {"vr": "IS", "Value": [3000]},
        "2399": {"vr": "IS", "Value": [3000]},
        "2400": {"vr": "IS", "Value": [0]},
        "2401": {"vr": "IS", "Value": [3000]},
        "2402": {"vr": "IS", "Value": [3000]},
        "2403": {"vr": "IS", "Value": [3000]},
        "2404": {"vr": "IS", "Value": [3000]},
        "2405": {"vr": "IS", "Value": [3000]},
        "2406": {"vr": "IS", "Value": [3000]},
        "2407": {"vr": "IS", "Value": [3000]},
        "2408": {"vr": "IS", "Value": [3000]},
        "2409": {"vr": "IS", "Value": [3000]},
        "2410": {"vr": "IS", "Value": [3000]},
        "2411": {"vr": "IS", "Value": [3000]},
        "2412": {"vr": "IS", "Value": [3000]},
        "2413": {"vr": "IS", "Value": [3000]},
        "2414": {"vr": "IS", "Value": [3000]},
        "2415": {"vr": "IS", "Value": [3000]},
        "2416": {"vr": "IS", "Value": [3000]},
        "2417": {"vr": "IS", "Value": [0]},
        "2418": {"vr": "IS", "Value": [0]},
        "2419": {"vr": "IS", "Value": [3000]},
        "2420": {"vr": "IS", "Value": [3000]},
        "2421": {"vr": "IS", "Value": [3000]},
        "2422": {"vr": "IS", "Value": [3000]},
        "2423": {"vr": "IS", "Value": [3000]},
        "2424": {"vr": "IS", "Value": [3000]},
        "2425": {"vr": "IS", "Value": [3000]},
        "2426": {"vr": "IS", "Value": [3000]},
        "2427": {"vr": "IS", "Value": [3000]},
        "2428": {"vr": "IS", "Value": [3000]},
        "2429": {"vr": "IS", "Value": [3000]},
        "2430": {"vr": "IS", "Value": [3000]},
        "2431": {"vr": "IS", "Value": [3000]},
        "2432": {"vr": "IS", "Value": [3000]},
        "2433": {"vr": "IS", "Value": [0]},
        "2434": {"vr": "IS", "Value": [3000]},
        "2435": {"vr": "IS", "Value": [3000]},
        "2436": {"vr": "IS", "Value": [3000]},
        "2437": {"vr": "IS", "Value": [3000]},
        "2438": {"vr": "IS", "Value": [3000]},
        "2439": {"vr": "IS", "Value": [3000]},
        "2440": {"vr": "IS", "Value": [3000]},
        "2441": {"vr": "IS", "Value": [3000]},
        "2442": {"vr": "IS", "Value": [3000]},
        "2443": {"vr": "IS", "Value": [3000]},
        "2444": {"vr": "IS", "Value": [3000]},
        "2445": {"vr": "IS", "Value": [3000]},
        "2446": {"vr": "IS", "Value": [3000]},
        "2447": {"vr": "IS", "Value": [3000]},
        "2448": {"vr": "IS", "Value": [3000]},
        "2449": {"vr": "IS", "Value": [3000]},
        "2450": {"vr": "IS", "Value": [3000]},
        "2451": {"vr": "IS", "Value": [3000]},
        "2452": {"vr": "IS", "Value": [3000]},
        "2453": {"vr": "IS", "Value": [3000]},
        "2454": {"vr": "IS", "Value": [3000]},
        "2455": {"vr": "IS", "Value": [3000]},
        "2456": {"vr": "IS", "Value": [3000]},
        "2457": {"vr": "IS", "Value": [3000]},
        "2458": {"vr": "IS", "Value": [3000]},
        "2459": {"vr": "IS", "Value": [3000]},
        "2460": {"vr": "IS", "Value": [3000]},
        "2461": {"vr": "IS", "Value": [3000]},
        "2462": {"vr": "IS", "Value": [3000]},
        "2463": {"vr": "IS", "Value": [3000]},
        "2464": {"vr": "IS", "Value": [3000]},
        "2465": {"vr": "IS", "Value": [3000]},
        "2466": {"vr": "IS", "Value": [3000]},
        "2467": {"vr": "IS", "Value": [3000]},
        "2468": {"vr": "IS", "Value": [3000]},
        "2469": {"vr": "IS", "Value": [3000]},
        "2470": {"vr": "IS", "Value": [3000]},
        "2471": {"vr": "IS", "Value": [3000]},
        "2472": {"vr": "IS", "Value": [3000]},
        "2473": {"vr": "IS", "Value": [3000]},
        "2474": {"vr": "IS", "Value": [3000]},
        "2475": {"vr": "IS", "Value": [3000]},
        "2476": {"vr": "IS", "Value": [3000]},
        "2477": {"vr": "IS", "Value": [3000]},
        "2478": {"vr": "IS", "Value": [3000]},
        "2479": {"vr": "IS", "Value": [0]},
        "2480": {"vr": "IS", "Value": [0]},
        "2481": {"vr": "IS", "Value": [3000]},
        "2482": {"vr": "IS", "Value": [3000]},
        "2483": {"vr": "IS", "Value": [3000]},
        "2484": {"vr": "IS", "Value": [3000]},
        "2485": {"vr": "IS", "Value": [3000]},
        "2486": {"vr": "IS", "Value": [3000]},
        "2487": {"vr": "IS", "Value": [3000]},
        "2488": {"vr": "IS", "Value": [3000]},
        "2489": {"vr": "IS", "Value": [3000]},
        "2490": {"vr": "IS", "Value": [3000]},
        "2491": {"vr": "IS", "Value": [3000]},
        "2492": {"vr": "IS", "Value": [3000]},
        "2493": {"vr": "IS", "Value": [3000]},
        "2494": {"vr": "IS", "Value": [3000]},
        "2495": {"vr": "IS", "Value": [3000]},
        "2496": {"vr": "IS", "Value": [3000]},
        "2497": {"vr": "IS", "Value": [3000]},
        "2498": {"vr": "IS", "Value": [3000]},
        "2499": {"vr": "IS", "Value": [3000]},
        "2500": {"vr": "IS", "Value": [3000]},
        "2501": {"vr": "IS", "Value": [3000]},
        "2502": {"vr": "IS", "Value": [3000]},
        "2503": {"vr": "IS", "Value": [3000]},
        "2504": {"vr": "IS", "Value": [3000]},
        "2505": {"vr": "IS", "Value": [3000]},
        "2506": {"vr": "IS", "Value": [3000]},
        "2507": {"vr": "IS", "Value": [3000]},
        "2508": {"vr": "IS", "Value": [3000]},
        "2509": {"vr": "IS", "Value": [3000]},
        "2510": {"vr": "IS", "Value": [3000]},
        "2511": {"vr": "IS", "Value": [3000]},
        "2512": {"vr": "IS", "Value": [3000]},
        "2513": {"vr": "IS", "Value": [3000]},
        "2514": {"vr": "IS", "Value": [3000]},
        "2515": {"vr": "IS", "Value": [3000]},
        "2516": {"vr": "IS", "Value": [3000]},
        "2517": {"vr": "IS", "Value": [3000]},
        "2518": {"vr": "IS", "Value": [3000]},
        "2519": {"vr": "IS", "Value": [3000]},
        "2520": {"vr": "IS", "Value": [0]},
        "2521": {"vr": "IS", "Value": [3000]},
        "2522": {"vr": "IS", "Value": [0]},
        "2523": {"vr": "IS", "Value": [3000]},
        "2524": {"vr": "IS", "Value": [3000]},
        "2525": {"vr": "IS", "Value": [0]},
        "2526": {"vr": "IS", "Value": [3000]},
        "2527": {"vr": "IS", "Value": [3000]},
        "2528": {"vr": "IS", "Value": [3000]},
        "2529": {"vr": "IS", "Value": [3000]},
        "2530": {"vr": "IS", "Value": [3000]},
        "2531": {"vr": "IS", "Value": [3000]},
        "2532": {"vr": "IS", "Value": [3000]},
        "2533": {"vr": "IS", "Value": [3000]},
        "2534": {"vr": "IS", "Value": [0]},
        "2535": {"vr": "IS", "Value": [3000]},
        "2536": {"vr": "IS", "Value": [3000]},
        "2537": {"vr": "IS", "Value": [0]},
        "2538": {"vr": "IS", "Value": [3000]},
        "2539": {"vr": "IS", "Value": [0]},
        "2540": {"vr": "IS", "Value": [3000]},
        "2541": {"vr": "IS", "Value": [3000]},
        "2542": {"vr": "IS", "Value": [3000]},
        "2543": {"vr": "IS", "Value": [3000]},
        "2544": {"vr": "IS", "Value": [3000]},
        "2545": {"vr": "IS", "Value": [3000]},
        "2546": {"vr": "IS", "Value": [0]},
        "2547": {"vr": "IS", "Value": [3000]},
        "2548": {"vr": "IS", "Value": [0]},
        "2549": {"vr": "IS", "Value": [3000]},
        "2550": {"vr": "IS", "Value": [3000]},
        "2551": {"vr": "IS", "Value": [3000]},
        "2552": {"vr": "IS", "Value": [3000]},
        "2553": {"vr": "IS", "Value": [3000]},
        "2554": {"vr": "IS", "Value": [3000]},
        "2555": {"vr": "IS", "Value": [3000]},
        "2556": {"vr": "IS", "Value": [3000]},
        "2557": {"vr": "IS", "Value": [0]},
        "2558": {"vr": "IS", "Value": [3000]},
        "2559": {"vr": "IS", "Value": [3000]},
        "2560": {"vr": "IS", "Value": [3000]},
        "2561": {"vr": "IS", "Value": [3000]},
        "2562": {"vr": "IS", "Value": [3000]},
        "2563": {"vr": "IS", "Value": [3000]},
        "2564": {"vr": "IS", "Value": [3000]},
        "2565": {"vr": "IS", "Value": [3000]},
        "2566": {"vr": "IS", "Value": [3000]},
        "2567": {"vr": "IS", "Value": [3000]},
        "2568": {"vr": "IS", "Value": [3000]},
        "2569": {"vr": "IS", "Value": [3000]},
        "2570": {"vr": "IS", "Value": [3000]},
        "2571": {"vr": "IS", "Value": [0]},
        "2572": {"vr": "IS", "Value": [0]},
        "2573": {"vr": "IS", "Value": [3000]},
        "2574": {"vr": "IS", "Value": [3000]},
        "2575": {"vr": "IS", "Value": [3000]},
        "2576": {"vr": "IS", "Value": [3000]},
        "2577": {"vr": "IS", "Value": [3000]},
        "2578": {"vr": "IS", "Value": [3000]},
        "2579": {"vr": "IS", "Value": [3000]},
        "2580": {"vr": "IS", "Value": [3000]},
        "2581": {"vr": "IS", "Value": [3000]},
        "2582": {"vr": "IS", "Value": [3000]},
        "2583": {"vr": "IS", "Value": [3000]},
        "2584": {"vr": "IS", "Value": [0]},
        "2585": {"vr": "IS", "Value": [0]},
        "2586": {"vr": "IS", "Value": [3000]},
        "2587": {"vr": "IS", "Value": [3000]},
        "2588": {"vr": "IS", "Value": [3000]},
        "2589": {"vr": "IS", "Value": [3000]},
        "2590": {"vr": "IS", "Value": [3000]},
        "2591": {"vr": "IS", "Value": [3000]},
        "2592": {"vr": "IS", "Value": [3000]},
        "2593": {"vr": "IS", "Value": [3000]},
        "2594": {"vr": "IS", "Value": [3000]},
        "2595": {"vr": "IS", "Value": [3000]},
        "2596": {"vr": "IS", "Value": [3000]},
        "2597": {"vr": "IS", "Value": [3000]},
        "2598": {"vr": "IS", "Value": [3000]},
        "2599": {"vr": "IS", "Value": [3000]},
        "2600": {"vr": "IS", "Value": [3000]},
        "2601": {"vr": "IS", "Value": [3000]},
        "2602": {"vr": "IS", "Value": [3000]},
        "2603": {"vr": "IS", "Value": [3000]},
        "2604": {"vr": "IS", "Value": [3000]},
        "2605": {"vr": "IS", "Value": [3000]},
        "2606": {"vr": "IS", "Value": [3000]},
        "2607": {"vr": "IS", "Value": [3000]},
        "2608": {"vr": "IS", "Value": [3000]},
        "2609": {"vr": "IS", "Value": [0]},
        "2610": {"vr": "IS", "Value": [3000]},
        "2611": {"vr": "IS", "Value": [0]},
        "2612": {"vr": "IS", "Value": [3000]},
        "2613": {"vr": "IS", "Value": [3000]},
        "2614": {"vr": "IS", "Value": [3000]},
        "2615": {"vr": "IS", "Value": [3000]},
        "2616": {"vr": "IS", "Value": [3000]},
        "2617": {"vr": "IS", "Value": [3000]},
        "2618": {"vr": "IS", "Value": [0]},
        "2619": {"vr": "IS", "Value": [3000]},
        "2620": {"vr": "IS", "Value": [3000]},
        "2621": {"vr": "IS", "Value": [3000]},
        "2622": {"vr": "IS", "Value": [3000]},
        "2623": {"vr": "IS", "Value": [3000]},
        "2624": {"vr": "IS", "Value": [3000]},
        "2625": {"vr": "IS", "Value": [3000]},
        "2626": {"vr": "IS", "Value": [3000]},
        "2627": {"vr": "IS", "Value": [3000]},
        "2628": {"vr": "IS", "Value": [0]},
        "2629": {"vr": "IS", "Value": [0]},
        "2630": {"vr": "IS", "Value": [3000]},
        "2631": {"vr": "IS", "Value": [3000]},
        "2632": {"vr": "IS", "Value": [3000]},
        "2633": {"vr": "IS", "Value": [3000]},
        "2634": {"vr": "IS", "Value": [3000]},
        "2635": {"vr": "IS", "Value": [3000]},
        "2636": {"vr": "IS", "Value": [0]},
        "2637": {"vr": "IS", "Value": [3000]},
        "2638": {"vr": "IS", "Value": [3000]},
        "2639": {"vr": "IS", "Value": [0]},
        "2640": {"vr": "IS", "Value": [0]},
        "2641": {"vr": "IS", "Value": [3000]},
        "2642": {"vr": "IS", "Value": [3000]},
        "2643": {"vr": "IS", "Value": [3000]},
        "2644": {"vr": "IS", "Value": [3000]},
        "2645": {"vr": "IS", "Value": [3000]},
        "2646": {"vr": "IS", "Value": [3000]},
        "2647": {"vr": "IS", "Value": [3000]},
        "2648": {"vr": "IS", "Value": [3000]},
        "2649": {"vr": "IS", "Value": [3000]},
        "2650": {"vr": "IS", "Value": [3000]},
        "2651": {"vr": "IS", "Value": [3000]},
        "2652": {"vr": "IS", "Value": [3000]},
        "2653": {"vr": "IS", "Value": [3000]},
        "2654": {"vr": "IS", "Value": [3000]},
        "2655": {"vr": "IS", "Value": [3000]},
        "2656": {"vr": "IS", "Value": [3000]},
        "2657": {"vr": "IS", "Value": [3000]},
        "2658": {"vr": "IS", "Value": [0]},
        "2659": {"vr": "IS", "Value": [3000]},
        "2660": {"vr": "IS", "Value": [3000]},
        "2661": {"vr": "IS", "Value": [3000]},
        "2662": {"vr": "IS", "Value": [3000]},
        "2663": {"vr": "IS", "Value": [3000]},
        "2664": {"vr": "IS", "Value": [3000]},
        "2665": {"vr": "IS", "Value": [3000]},
        "2666": {"vr": "IS", "Value": [3000]},
        "2667": {"vr": "IS", "Value": [3000]},
        "2668": {"vr": "IS", "Value": [3000]},
        "2669": {"vr": "IS", "Value": [3000]},
        "2670": {"vr": "IS", "Value": [3000]},
        "2671": {"vr": "IS", "Value": [3000]},
        "2672": {"vr": "IS", "Value": [3000]},
        "2673": {"vr": "IS", "Value": [3000]},
        "2674": {"vr": "IS", "Value": [3000]},
        "2675": {"vr": "IS", "Value": [3000]},
        "2676": {"vr": "IS", "Value": [3000]},
        "2677": {"vr": "IS", "Value": [3000]},
        "2678": {"vr": "IS", "Value": [3000]},
        "2679": {"vr": "IS", "Value": [0]},
        "2680": {"vr": "IS", "Value": [0]},
        "2681": {"vr": "IS", "Value": [3000]},
        "2682": {"vr": "IS", "Value": [3000]},
        "2683": {"vr": "IS", "Value": [3000]},
        "2684": {"vr": "IS", "Value": [3000]},
        "2685": {"vr": "IS", "Value": [3000]},
        "2686": {"vr": "IS", "Value": [3000]},
        "2687": {"vr": "IS", "Value": [3000]},
        "2688": {"vr": "IS", "Value": [3000]},
        "2689": {"vr": "IS", "Value": [3000]},
        "2690": {"vr": "IS", "Value": [3000]},
        "2691": {"vr": "IS", "Value": [3000]},
        "2692": {"vr": "IS", "Value": [3000]},
        "2693": {"vr": "IS", "Value": [3000]},
        "2694": {"vr": "IS", "Value": [3000]},
        "2695": {"vr": "IS", "Value": [3000]},
        "2696": {"vr": "IS", "Value": [3000]},
        "2697": {"vr": "IS", "Value": [3000]},
        "2698": {"vr": "IS", "Value": [3000]},
        "2699": {"vr": "IS", "Value": [3000]},
        "2700": {"vr": "IS", "Value": [3000]},
        "2701": {"vr": "IS", "Value": [3000]},
        "2702": {"vr": "IS", "Value": [0]},
        "2703": {"vr": "IS", "Value": [3000]},
        "2704": {"vr": "IS", "Value": [3000]},
        "2705": {"vr": "IS", "Value": [3000]},
        "2706": {"vr": "IS", "Value": [3000]},
        "2707": {"vr": "IS", "Value": [3000]},
        "2708": {"vr": "IS", "Value": [3000]},
        "2709": {"vr": "IS", "Value": [3000]},
        "2710": {"vr": "IS", "Value": [3000]},
        "2711": {"vr": "IS", "Value": [3000]},
        "2712": {"vr": "IS", "Value": [3000]},
        "2713": {"vr": "IS", "Value": [3000]},
        "2714": {"vr": "IS", "Value": [3000]},
        "2715": {"vr": "IS", "Value": [3000]},
        "2716": {"vr": "IS", "Value": [3000]},
        "2717": {"vr": "IS", "Value": [3000]},
        "2718": {"vr": "IS", "Value": [3000]},
        "2719": {"vr": "IS", "Value": [3000]},
        "2720": {"vr": "IS", "Value": [3000]},
        "2721": {"vr": "IS", "Value": [3000]},
        "2722": {"vr": "IS", "Value": [3000]},
        "2723": {"vr": "IS", "Value": [3000]},
        "2724": {"vr": "IS", "Value": [3000]},
        "2725": {"vr": "IS", "Value": [3000]},
        "2726": {"vr": "IS", "Value": [0]},
        "2727": {"vr": "IS", "Value": [3000]},
        "2728": {"vr": "IS", "Value": [3000]},
        "2729": {"vr": "IS", "Value": [3000]},
        "2730": {"vr": "IS", "Value": [3000]},
        "2731": {"vr": "IS", "Value": [3000]},
        "2732": {"vr": "IS", "Value": [3000]},
        "2733": {"vr": "IS", "Value": [3000]},
        "2734": {"vr": "IS", "Value": [3000]},
        "2735": {"vr": "IS", "Value": [3000]},
        "2736": {"vr": "IS", "Value": [0]},
        "2737": {"vr": "IS", "Value": [3000]},
        "2738": {"vr": "IS", "Value": [3000]},
        "2739": {"vr": "IS", "Value": [3000]},
        "2740": {"vr": "IS", "Value": [3000]},
        "2741": {"vr": "IS", "Value": [0]},
        "2742": {"vr": "IS", "Value": [3000]},
        "2743": {"vr": "IS", "Value": [3000]},
        "2744": {"vr": "IS", "Value": [3000]},
        "2745": {"vr": "IS", "Value": [3000]},
        "2746": {"vr": "IS", "Value": [0]},
        "2747": {"vr": "IS", "Value": [3000]},
        "2748": {"vr": "IS", "Value": [3000]},
        "2749": {"vr": "IS", "Value": [3000]},
        "2750": {"vr": "IS", "Value": [0]},
        "2751": {"vr": "IS", "Value": [3000]},
        "2752": {"vr": "IS", "Value": [3000]},
        "2753": {"vr": "IS", "Value": [3000]},
        "2754": {"vr": "IS", "Value": [3000]},
        "2755": {"vr": "IS", "Value": [3000]},
        "2756": {"vr": "IS", "Value": [3000]},
        "2757": {"vr": "IS", "Value": [0]},
        "2758": {"vr": "IS", "Value": [3000]},
        "2759": {"vr": "IS", "Value": [3000]},
        "2760": {"vr": "IS", "Value": [3000]},
        "2761": {"vr": "IS", "Value": [3000]},
        "2762": {"vr": "IS", "Value": [3000]},
        "2763": {"vr": "IS", "Value": [3000]},
        "2764": {"vr": "IS", "Value": [3000]},
        "2765": {"vr": "IS", "Value": [0]},
        "2766": {"vr": "IS", "Value": [3000]},
        "2767": {"vr": "IS", "Value": [3000]},
        "2768": {"vr": "IS", "Value": [3000]},
        "2769": {"vr": "IS", "Value": [3000]},
        "2770": {"vr": "IS", "Value": [0]},
        "2771": {"vr": "IS", "Value": [3000]},
        "2772": {"vr": "IS", "Value": [3000]},
        "2773": {"vr": "IS", "Value": [3000]},
        "2774": {"vr": "IS", "Value": [3000]},
        "2775": {"vr": "IS", "Value": [3000]},
        "2776": {"vr": "IS", "Value": [3000]},
        "2777": {"vr": "IS", "Value": [0]},
        "2778": {"vr": "IS", "Value": [3000]},
        "2779": {"vr": "IS", "Value": [3000]},
        "2780": {"vr": "IS", "Value": [3000]},
        "2781": {"vr": "IS", "Value": [0]},
        "2782": {"vr": "IS", "Value": [3000]},
        "2783": {"vr": "IS", "Value": [3000]},
        "2784": {"vr": "IS", "Value": [3000]},
        "2785": {"vr": "IS", "Value": [3000]},
        "2786": {"vr": "IS", "Value": [3000]},
        "2787": {"vr": "IS", "Value": [3000]},
        "2788": {"vr": "IS", "Value": [3000]},
        "2789": {"vr": "IS", "Value": [3000]},
        "2790": {"vr": "IS", "Value": [3000]},
        "2791": {"vr": "IS", "Value": [3000]},
        "2792": {"vr": "IS", "Value": [0]},
        "2793": {"vr": "IS", "Value": [3000]},
        "2794": {"vr": "IS", "Value": [3000]},
        "2795": {"vr": "IS", "Value": [3000]},
        "2796": {"vr": "IS", "Value": [3000]},
        "2797": {"vr": "IS", "Value": [0]},
        "2798": {"vr": "IS", "Value": [3000]},
        "2799": {"vr": "IS", "Value": [3000]},
        "2800": {"vr": "IS", "Value": [3000]},
        "2801": {"vr": "IS", "Value": [3000]},
        "2802": {"vr": "IS", "Value": [3000]},
        "2803": {"vr": "IS", "Value": [3000]},
        "2804": {"vr": "IS", "Value": [3000]},
        "2805": {"vr": "IS", "Value": [3000]},
        "2806": {"vr": "IS", "Value": [3000]},
        "2807": {"vr": "IS", "Value": [3000]},
        "2808": {"vr": "IS", "Value": [3000]},
        "2809": {"vr": "IS", "Value": [3000]},
        "2810": {"vr": "IS", "Value": [3000]},
        "2811": {"vr": "IS", "Value": [3000]},
        "2812": {"vr": "IS", "Value": [3000]},
        "2813": {"vr": "IS", "Value": [3000]},
        "2814": {"vr": "IS", "Value": [3000]},
        "2815": {"vr": "IS", "Value": [3000]},
        "2816": {"vr": "IS", "Value": [3000]},
        "2817": {"vr": "IS", "Value": [3000]},
        "2818": {"vr": "IS", "Value": [0]},
        "2819": {"vr": "IS", "Value": [3000]},
        "2820": {"vr": "IS", "Value": [3000]},
        "2821": {"vr": "IS", "Value": [3000]},
        "2822": {"vr": "IS", "Value": [0]},
        "2823": {"vr": "IS", "Value": [3000]},
        "2824": {"vr": "IS", "Value": [3000]},
        "2825": {"vr": "IS", "Value": [3000]},
        "2826": {"vr": "IS", "Value": [3000]},
        "2827": {"vr": "IS", "Value": [3000]},
        "2828": {"vr": "IS", "Value": [3000]},
        "2829": {"vr": "IS", "Value": [3000]},
        "2830": {"vr": "IS", "Value": [0]},
        "2831": {"vr": "IS", "Value": [3000]},
        "2832": {"vr": "IS", "Value": [3000]},
        "2833": {"vr": "IS", "Value": [3000]},
        "2834": {"vr": "IS", "Value": [3000]},
        "2835": {"vr": "IS", "Value": [3000]},
        "2836": {"vr": "IS", "Value": [3000]},
        "2837": {"vr": "IS", "Value": [3000]},
        "2838": {"vr": "IS", "Value": [3000]},
        "2839": {"vr": "IS", "Value": [3000]},
        "2840": {"vr": "IS", "Value": [3000]},
        "2841": {"vr": "IS", "Value": [3000]},
        "2842": {"vr": "IS", "Value": [3000]},
        "2843": {"vr": "IS", "Value": [3000]},
        "2844": {"vr": "IS", "Value": [3000]},
        "2845": {"vr": "IS", "Value": [3000]},
        "2846": {"vr": "IS", "Value": [3000]},
        "2847": {"vr": "IS", "Value": [3000]},
        "2848": {"vr": "IS", "Value": [3000]},
        "2849": {"vr": "IS", "Value": [3000]},
        "2850": {"vr": "IS", "Value": [3000]},
        "2851": {"vr": "IS", "Value": [3000]},
        "2852": {"vr": "IS", "Value": [0]},
        "2853": {"vr": "IS", "Value": [3000]},
        "2854": {"vr": "IS", "Value": [3000]},
        "2855": {"vr": "IS", "Value": [0]},
        "2856": {"vr": "IS", "Value": [3000]},
        "2857": {"vr": "IS", "Value": [3000]},
        "2858": {"vr": "IS", "Value": [3000]},
        "2859": {"vr": "IS", "Value": [3000]},
        "2860": {"vr": "IS", "Value": [3000]},
        "2861": {"vr": "IS", "Value": [3000]},
        "2862": {"vr": "IS", "Value": [0]},
        "2863": {"vr": "IS", "Value": [3000]},
        "2864": {"vr": "IS", "Value": [3000]},
        "2865": {"vr": "IS", "Value": [3000]},
        "2866": {"vr": "IS", "Value": [3000]},
        "2867": {"vr": "IS", "Value": [3000]},
        "2868": {"vr": "IS", "Value": [3000]},
        "2869": {"vr": "IS", "Value": [3000]},
        "2870": {"vr": "IS", "Value": [3000]},
        "2871": {"vr": "IS", "Value": [3000]},
        "2872": {"vr": "IS", "Value": [3000]},
        "2873": {"vr": "IS", "Value": [3000]},
        "2874": {"vr": "IS", "Value": [3000]},
        "2875": {"vr": "IS", "Value": [3000]},
        "2876": {"vr": "IS", "Value": [3000]},
        "2877": {"vr": "IS", "Value": [3000]},
        "2878": {"vr": "IS", "Value": [0]},
        "2879": {"vr": "IS", "Value": [3000]},
        "2880": {"vr": "IS", "Value": [3000]},
        "2881": {"vr": "IS", "Value": [3000]},
        "2882": {"vr": "IS", "Value": [0]},
        "2883": {"vr": "IS", "Value": [3000]},
        "2884": {"vr": "IS", "Value": [3000]},
        "2885": {"vr": "IS", "Value": [3000]},
        "2886": {"vr": "IS", "Value": [3000]},
        "2887": {"vr": "IS", "Value": [3000]},
        "2888": {"vr": "IS", "Value": [3000]},
        "2889": {"vr": "IS", "Value": [3000]},
        "2890": {"vr": "IS", "Value": [3000]},
        "2891": {"vr": "IS", "Value": [3000]},
        "2892": {"vr": "IS", "Value": [3000]},
        "2893": {"vr": "IS", "Value": [3000]},
        "2894": {"vr": "IS", "Value": [3000]},
        "2895": {"vr": "IS", "Value": [3000]},
        "2896": {"vr": "IS", "Value": [3000]},
        "2897": {"vr": "IS", "Value": [3000]},
        "2898": {"vr": "IS", "Value": [3000]},
        "2899": {"vr": "IS", "Value": [3000]},
        "2900": {"vr": "IS", "Value": [3000]},
        "2901": {"vr": "IS", "Value": [3000]},
        "2902": {"vr": "IS", "Value": [3000]},
        "2903": {"vr": "IS", "Value": [3000]},
        "2904": {"vr": "IS", "Value": [3000]},
        "2905": {"vr": "IS", "Value": [3000]},
        "2906": {"vr": "IS", "Value": [0]},
        "2907": {"vr": "IS", "Value": [0]},
        "2908": {"vr": "IS", "Value": [3000]},
        "2909": {"vr": "IS", "Value": [3000]},
        "2910": {"vr": "IS", "Value": [3000]},
        "2911": {"vr": "IS", "Value": [3000]},
        "2912": {"vr": "IS", "Value": [3000]},
        "2913": {"vr": "IS", "Value": [3000]},
        "2914": {"vr": "IS", "Value": [3000]},
        "2915": {"vr": "IS", "Value": [3000]},
        "2916": {"vr": "IS", "Value": [0]},
        "2917": {"vr": "IS", "Value": [3000]},
        "2918": {"vr": "IS", "Value": [0]},
        "2919": {"vr": "IS", "Value": [0]},
        "2920": {"vr": "IS", "Value": [3000]},
        "2921": {"vr": "IS", "Value": [3000]},
        "2922": {"vr": "IS", "Value": [3000]},
        "2923": {"vr": "IS", "Value": [0]},
        "2924": {"vr": "IS", "Value": [3000]},
        "2925": {"vr": "IS", "Value": [3000]},
        "2926": {"vr": "IS", "Value": [3000]},
        "2927": {"vr": "IS", "Value": [3000]},
        "2928": {"vr": "IS", "Value": [3000]},
        "2929": {"vr": "IS", "Value": [3000]},
        "2930": {"vr": "IS", "Value": [0]},
        "2931": {"vr": "IS", "Value": [3000]},
        "2932": {"vr": "IS", "Value": [3000]},
        "2933": {"vr": "IS", "Value": [3000]},
        "2934": {"vr": "IS", "Value": [3000]},
        "2935": {"vr": "IS", "Value": [0]},
        "2936": {"vr": "IS", "Value": [3000]},
        "2937": {"vr": "IS", "Value": [3000]},
        "2938": {"vr": "IS", "Value": [3000]},
        "2939": {"vr": "IS", "Value": [3000]},
        "2940": {"vr": "IS", "Value": [3000]},
        "2941": {"vr": "IS", "Value": [3000]},
        "2942": {"vr": "IS", "Value": [3000]},
        "2943": {"vr": "IS", "Value": [3000]},
        "2944": {"vr": "IS", "Value": [3000]},
        "2945": {"vr": "IS", "Value": [3000]},
        "2946": {"vr": "IS", "Value": [0]},
        "2947": {"vr": "IS", "Value": [3000]},
        "2948": {"vr": "IS", "Value": [3000]},
        "2949": {"vr": "IS", "Value": [0]},
        "2950": {"vr": "IS", "Value": [3000]},
        "2951": {"vr": "IS", "Value": [3000]},
        "2952": {"vr": "IS", "Value": [3000]},
        "2953": {"vr": "IS", "Value": [3000]},
        "2954": {"vr": "IS", "Value": [0]},
        "2955": {"vr": "IS", "Value": [0]},
        "2956": {"vr": "IS", "Value": [3000]},
        "2957": {"vr": "IS", "Value": [3000]},
        "2958": {"vr": "IS", "Value": [3000]},
        "2959": {"vr": "IS", "Value": [3000]},
        "2960": {"vr": "IS", "Value": [3000]},
        "2961": {"vr": "IS", "Value": [3000]},
        "2962": {"vr": "IS", "Value": [3000]},
        "2963": {"vr": "IS", "Value": [3000]},
        "2964": {"vr": "IS", "Value": [3000]},
        "2965": {"vr": "IS", "Value": [3000]},
        "2966": {"vr": "IS", "Value": [3000]},
        "2967": {"vr": "IS", "Value": [3000]},
        "2968": {"vr": "IS", "Value": [0]},
        "2969": {"vr": "IS", "Value": [3000]},
        "2970": {"vr": "IS", "Value": [3000]},
        "2971": {"vr": "IS", "Value": [3000]},
        "2972": {"vr": "IS", "Value": [3000]},
        "2973": {"vr": "IS", "Value": [3000]},
        "2974": {"vr": "IS", "Value": [3000]},
        "2975": {"vr": "IS", "Value": [3000]},
        "2976": {"vr": "IS", "Value": [3000]},
        "2977": {"vr": "IS", "Value": [3000]},
        "2978": {"vr": "IS", "Value": [3000]},
        "2979": {"vr": "IS", "Value": [3000]},
        "2980": {"vr": "IS", "Value": [3000]},
        "2981": {"vr": "IS", "Value": [3000]},
        "2982": {"vr": "IS", "Value": [3000]},
        "2983": {"vr": "IS", "Value": [3000]},
        "2984": {"vr": "IS", "Value": [3000]},
        "2985": {"vr": "IS", "Value": [0]},
        "2986": {"vr": "IS", "Value": [3000]},
        "2987": {"vr": "IS", "Value": [3000]},
        "2988": {"vr": "IS", "Value": [3000]},
        "2989": {"vr": "IS", "Value": [3000]},
        "2990": {"vr": "IS", "Value": [3000]},
        "2991": {"vr": "IS", "Value": [3000]},
        "2992": {"vr": "IS", "Value": [3000]},
        "2993": {"vr": "IS", "Value": [3000]},
        "2994": {"vr": "IS", "Value": [3000]},
        "2995": {"vr": "IS", "Value": [3000]},
        "2996": {"vr": "IS", "Value": [3000]},
        "2997": {"vr": "IS", "Value": [3000]},
        "2998": {"vr": "IS", "Value": [3000]},
        "2999": {"vr": "IS", "Value": [3000]},
        "3000": {"vr": "IS", "Value": [3000]},
        "3001": {"vr": "IS", "Value": [3000]},
        "3002": {"vr": "IS", "Value": [3000]},
        "3003": {"vr": "IS", "Value": [3000]},
        "3004": {"vr": "IS", "Value": [3000]},
        "3005": {"vr": "IS", "Value": [0]},
        "3006": {"vr": "IS", "Value": [3000]},
        "3007": {"vr": "IS", "Value": [3000]},
        "3008": {"vr": "IS", "Value": [3000]},
        "3009": {"vr": "IS", "Value": [3000]},
        "3010": {"vr": "IS", "Value": [3000]},
        "3011": {"vr": "IS", "Value": [3000]},
        "3012": {"vr": "IS", "Value": [3000]},
        "3013": {"vr": "IS", "Value": [3000]},
        "3014": {"vr": "IS", "Value": [3000]},
        "3015": {"vr": "IS", "Value": [3000]},
        "3016": {"vr": "IS", "Value": [3000]},
        "3017": {"vr": "IS", "Value": [3000]},
        "3018": {"vr": "IS", "Value": [3000]},
        "3019": {"vr": "IS", "Value": [0]},
        "3020": {"vr": "IS", "Value": [3000]},
        "3021": {"vr": "IS", "Value": [3000]},
        "3022": {"vr": "IS", "Value": [3000]},
        "3023": {"vr": "IS", "Value": [3000]},
        "3024": {"vr": "IS", "Value": [3000]},
        "3025": {"vr": "IS", "Value": [3000]},
        "3026": {"vr": "IS", "Value": [3000]},
        "3027": {"vr": "IS", "Value": [3000]},
        "3028": {"vr": "IS", "Value": [3000]},
        "3029": {"vr": "IS", "Value": [0]},
        "3030": {"vr": "IS", "Value": [3000]},
        "3031": {"vr": "IS", "Value": [3000]},
        "3032": {"vr": "IS", "Value": [3000]},
        "3033": {"vr": "IS", "Value": [3000]},
        "3034": {"vr": "IS", "Value": [3000]},
        "3035": {"vr": "IS", "Value": [3000]},
        "3036": {"vr": "IS", "Value": [3000]},
        "3037": {"vr": "IS", "Value": [3000]},
        "3038": {"vr": "IS", "Value": [3000]},
        "3039": {"vr": "IS", "Value": [3000]},
        "3040": {"vr": "IS", "Value": [3000]},
        "3041": {"vr": "IS", "Value": [3000]},
        "3042": {"vr": "IS", "Value": [3000]},
        "3043": {"vr": "IS", "Value": [3000]},
        "3044": {"vr": "IS", "Value": [3000]},
        "3045": {"vr": "IS", "Value": [3000]},
        "3046": {"vr": "IS", "Value": [3000]},
        "3047": {"vr": "IS", "Value": [3000]},
        "3048": {"vr": "IS", "Value": [3000]},
        "3049": {"vr": "IS", "Value": [3000]},
        "3050": {"vr": "IS", "Value": [3000]},
        "3051": {"vr": "IS", "Value": [3000]},
        "3052": {"vr": "IS", "Value": [3000]},
        "3053": {"vr": "IS", "Value": [0]},
        "3054": {"vr": "IS", "Value": [3000]},
        "3055": {"vr": "IS", "Value": [3000]},
        "3056": {"vr": "IS", "Value": [3000]},
        "3057": {"vr": "IS", "Value": [3000]},
        "3058": {"vr": "IS", "Value": [3000]},
        "3059": {"vr": "IS", "Value": [3000]},
        "3060": {"vr": "IS", "Value": [3000]},
        "3061": {"vr": "IS", "Value": [3000]},
        "3062": {"vr": "IS", "Value": [3000]},
        "3063": {"vr": "IS", "Value": [3000]},
        "3064": {"vr": "IS", "Value": [3000]},
        "3065": {"vr": "IS", "Value": [3000]},
        "3066": {"vr": "IS", "Value": [3000]},
        "3067": {"vr": "IS", "Value": [3000]},
        "3068": {"vr": "IS", "Value": [3000]},
        "3069": {"vr": "IS", "Value": [3000]},
        "3070": {"vr": "IS", "Value": [3000]},
        "3071": {"vr": "IS", "Value": [3000]},
        "3072": {"vr": "IS", "Value": [0]},
        "3073": {"vr": "IS", "Value": [3000]},
        "3074": {"vr": "IS", "Value": [0]},
        "3075": {"vr": "IS", "Value": [3000]},
        "3076": {"vr": "IS", "Value": [3000]},
        "3077": {"vr": "IS", "Value": [0]},
        "3078": {"vr": "IS", "Value": [3000]},
        "3079": {"vr": "IS", "Value": [3000]},
        "3080": {"vr": "IS", "Value": [3000]},
        "3081": {"vr": "IS", "Value": [3000]},
        "3082": {"vr": "IS", "Value": [3000]},
        "3083": {"vr": "IS", "Value": [3000]},
        "3084": {"vr": "IS", "Value": [3000]},
        "3085": {"vr": "IS", "Value": [3000]},
        "3086": {"vr": "IS", "Value": [3000]},
        "3087": {"vr": "IS", "Value": [3000]},
        "3088": {"vr": "IS", "Value": [3000]},
        "3089": {"vr": "IS", "Value": [0]},
        "3090": {"vr": "IS", "Value": [3000]},
        "3091": {"vr": "IS", "Value": [3000]},
        "3092": {"vr": "IS", "Value": [0]},
        "3093": {"vr": "IS", "Value": [3000]},
        "3094": {"vr": "IS", "Value": [3000]},
        "3095": {"vr": "IS", "Value": [3000]},
        "3096": {"vr": "IS", "Value": [3000]},
        "3097": {"vr": "IS", "Value": [3000]},
        "3098": {"vr": "IS", "Value": [3000]},
        "3099": {"vr": "IS", "Value": [3000]},
        "3100": {"vr": "IS", "Value": [3000]},
        "3101": {"vr": "IS", "Value": [3000]},
        "3102": {"vr": "IS", "Value": [0]},
        "3103": {"vr": "IS", "Value": [3000]},
        "3104": {"vr": "IS", "Value": [3000]},
        "3105": {"vr": "IS", "Value": [3000]},
        "3106": {"vr": "IS", "Value": [3000]},
        "3107": {"vr": "IS", "Value": [3000]},
        "3108": {"vr": "IS", "Value": [3000]},
        "3109": {"vr": "IS", "Value": [3000]},
        "3110": {"vr": "IS", "Value": [3000]},
        "3111": {"vr": "IS", "Value": [3000]},
        "3112": {"vr": "IS", "Value": [3000]},
        "3113": {"vr": "IS", "Value": [3000]},
        "3114": {"vr": "IS", "Value": [3000]},
        "3115": {"vr": "IS", "Value": [3000]},
        "3116": {"vr": "IS", "Value": [3000]},
        "3117": {"vr": "IS", "Value": [3000]},
        "3118": {"vr": "IS", "Value": [3000]},
        "3119": {"vr": "IS", "Value": [3000]},
        "3120": {"vr": "IS", "Value": [3000]},
        "3121": {"vr": "IS", "Value": [3000]},
        "3122": {"vr": "IS", "Value": [3000]},
        "3123": {"vr": "IS", "Value": [3000]},
        "3124": {"vr": "IS", "Value": [3000]},
        "3125": {"vr": "IS", "Value": [3000]},
        "3126": {"vr": "IS", "Value": [3000]},
        "3127": {"vr": "IS", "Value": [3000]},
        "3128": {"vr": "IS", "Value": [3000]},
        "3129": {"vr": "IS", "Value": [3000]},
        "3130": {"vr": "IS", "Value": [3000]},
        "3131": {"vr": "IS", "Value": [3000]},
        "3132": {"vr": "IS", "Value": [0]},
        "3133": {"vr": "IS", "Value": [3000]},
        "3134": {"vr": "IS", "Value": [3000]},
        "3135": {"vr": "IS", "Value": [3000]},
        "3136": {"vr": "IS", "Value": [3000]},
        "3137": {"vr": "IS", "Value": [3000]},
        "3138": {"vr": "IS", "Value": [3000]},
        "3139": {"vr": "IS", "Value": [3000]},
        "3140": {"vr": "IS", "Value": [3000]},
        "3141": {"vr": "IS", "Value": [3000]},
        "3142": {"vr": "IS", "Value": [3000]},
        "3143": {"vr": "IS", "Value": [3000]},
        "3144": {"vr": "IS", "Value": [3000]},
        "3145": {"vr": "IS", "Value": [3000]},
        "3146": {"vr": "IS", "Value": [3000]},
        "3147": {"vr": "IS", "Value": [3000]},
        "3148": {"vr": "IS", "Value": [3000]},
        "3149": {"vr": "IS", "Value": [3000]},
        "3150": {"vr": "IS", "Value": [3000]},
        "3151": {"vr": "IS", "Value": [3000]},
        "3152": {"vr": "IS", "Value": [3000]},
        "3153": {"vr": "IS", "Value": [3000]},
        "3154": {"vr": "IS", "Value": [3000]},
        "3155": {"vr": "IS", "Value": [3000]},
        "3156": {"vr": "IS", "Value": [3000]},
        "3157": {"vr": "IS", "Value": [3000]},
        "3158": {"vr": "IS", "Value": [3000]},
        "3159": {"vr": "IS", "Value": [3000]},
        "3160": {"vr": "IS", "Value": [0]},
        "3161": {"vr": "IS", "Value": [3000]},
        "3162": {"vr": "IS", "Value": [3000]},
        "3163": {"vr": "IS", "Value": [3000]},
        "3164": {"vr": "IS", "Value": [3000]},
        "3165": {"vr": "IS", "Value": [0]},
        "3166": {"vr": "IS", "Value": [3000]},
        "3167": {"vr": "IS", "Value": [3000]},
        "3168": {"vr": "IS", "Value": [3000]},
        "3169": {"vr": "IS", "Value": [3000]},
        "3170": {"vr": "IS", "Value": [3000]},
        "3171": {"vr": "IS", "Value": [3000]},
        "3172": {"vr": "IS", "Value": [0]},
        "3173": {"vr": "IS", "Value": [3000]},
        "3174": {"vr": "IS", "Value": [3000]},
        "3175": {"vr": "IS", "Value": [3000]},
        "3176": {"vr": "IS", "Value": [3000]},
        "3177": {"vr": "IS", "Value": [3000]},
        "3178": {"vr": "IS", "Value": [3000]},
        "3179": {"vr": "IS", "Value": [3000]},
        "3180": {"vr": "IS", "Value": [3000]},
        "3181": {"vr": "IS", "Value": [3000]},
        "3182": {"vr": "IS", "Value": [3000]},
        "3183": {"vr": "IS", "Value": [3000]},
        "3184": {"vr": "IS", "Value": [3000]},
        "3185": {"vr": "IS", "Value": [3000]},
        "3186": {"vr": "IS", "Value": [3000]},
        "3187": {"vr": "IS", "Value": [3000]},
        "3188": {"vr": "IS", "Value": [3000]},
        "3189": {"vr": "IS", "Value": [3000]},
        "3190": {"vr": "IS", "Value": [3000]},
        "3191": {"vr": "IS", "Value": [3000]},
        "3192": {"vr": "IS", "Value": [3000]},
        "3193": {"vr": "IS", "Value": [0]},
        "3194": {"vr": "IS", "Value": [0]},
        "3195": {"vr": "IS", "Value": [3000]},
        "3196": {"vr": "IS", "Value": [3000]},
        "3197": {"vr": "IS", "Value": [3000]},
        "3198": {"vr": "IS", "Value": [3000]},
        "3199": {"vr": "IS", "Value": [3000]},
        "3200": {"vr": "IS", "Value": [3000]},
        "3201": {"vr": "IS", "Value": [3000]},
        "3202": {"vr": "IS", "Value": [3000]},
        "3203": {"vr": "IS", "Value": [3000]},
        "3204": {"vr": "IS", "Value": [3000]},
        "3205": {"vr": "IS", "Value": [3000]},
        "3206": {"vr": "IS", "Value": [3000]},
        "3207": {"vr": "IS", "Value": [3000]},
        "3208": {"vr": "IS", "Value": [3000]},
        "3209": {"vr": "IS", "Value": [3000]},
        "3210": {"vr": "IS", "Value": [3000]},
        "3211": {"vr": "IS", "Value": [3000]},
        "3212": {"vr": "IS", "Value": [3000]},
        "3213": {"vr": "IS", "Value": [3000]},
        "3214": {"vr": "IS", "Value": [0]},
        "3215": {"vr": "IS", "Value": [3000]},
        "3216": {"vr": "IS", "Value": [3000]},
        "3217": {"vr": "IS", "Value": [3000]},
        "3218": {"vr": "IS", "Value": [0]},
        "3219": {"vr": "IS", "Value": [3000]},
        "3220": {"vr": "IS", "Value": [3000]},
        "3221": {"vr": "IS", "Value": [3000]},
        "3222": {"vr": "IS", "Value": [3000]},
        "3223": {"vr": "IS", "Value": [3000]},
        "3224": {"vr": "IS", "Value": [3000]},
        "3225": {"vr": "IS", "Value": [3000]},
        "3226": {"vr": "IS", "Value": [3000]},
        "3227": {"vr": "IS", "Value": [3000]},
        "3228": {"vr": "IS", "Value": [3000]},
        "3229": {"vr": "IS", "Value": [3000]},
        "3230": {"vr": "IS", "Value": [0]},
        "3231": {"vr": "IS", "Value": [3000]},
        "3232": {"vr": "IS", "Value": [3000]},
        "3233": {"vr": "IS", "Value": [3000]},
        "3234": {"vr": "IS", "Value": [3000]},
        "3235": {"vr": "IS", "Value": [3000]},
        "3236": {"vr": "IS", "Value": [3000]},
        "3237": {"vr": "IS", "Value": [3000]},
        "3238": {"vr": "IS", "Value": [3000]},
        "3239": {"vr": "IS", "Value": [3000]},
        "3240": {"vr": "IS", "Value": [3000]},
        "3241": {"vr": "IS", "Value": [3000]},
        "3242": {"vr": "IS", "Value": [3000]},
        "3243": {"vr": "IS", "Value": [0]},
        "3244": {"vr": "IS", "Value": [3000]},
        "3245": {"vr": "IS", "Value": [3000]},
        "3246": {"vr": "IS", "Value": [3000]},
        "3247": {"vr": "IS", "Value": [3000]},
        "3248": {"vr": "IS", "Value": [3000]},
        "3249": {"vr": "IS", "Value": [3000]},
        "3250": {"vr": "IS", "Value": [3000]},
        "3251": {"vr": "IS", "Value": [3000]},
        "3252": {"vr": "IS", "Value": [3000]},
        "3253": {"vr": "IS", "Value": [3000]},
        "3254": {"vr": "IS", "Value": [3000]},
        "3255": {"vr": "IS", "Value": [3000]},
        "3256": {"vr": "IS", "Value": [0]},
        "3257": {"vr": "IS", "Value": [3000]},
        "3258": {"vr": "IS", "Value": [0]},
        "3259": {"vr": "IS", "Value": [3000]},
        "3260": {"vr": "IS", "Value": [3000]},
        "3261": {"vr": "IS", "Value": [3000]},
        "3262": {"vr": "IS", "Value": [3000]},
        "3263": {"vr": "IS", "Value": [3000]},
        "3264": {"vr": "IS", "Value": [0]},
        "3265": {"vr": "IS", "Value": [3000]},
        "3266": {"vr": "IS", "Value": [3000]},
        "3267": {"vr": "IS", "Value": [3000]},
        "3268": {"vr": "IS", "Value": [3000]},
        "3269": {"vr": "IS", "Value": [3000]},
        "3270": {"vr": "IS", "Value": [0]},
        "3271": {"vr": "IS", "Value": [3000]},
        "3272": {"vr": "IS", "Value": [3000]},
        "3273": {"vr": "IS", "Value": [3000]},
        "3274": {"vr": "IS", "Value": [3000]},
        "3275": {"vr": "IS", "Value": [3000]},
        "3276": {"vr": "IS", "Value": [3000]},
        "3277": {"vr": "IS", "Value": [3000]},
        "3278": {"vr": "IS", "Value": [3000]},
        "3279": {"vr": "IS", "Value": [3000]},
        "3280": {"vr": "IS", "Value": [0]},
        "3281": {"vr": "IS", "Value": [3000]},
        "3282": {"vr": "IS", "Value": [3000]},
        "3283": {"vr": "IS", "Value": [3000]},
        "3284": {"vr": "IS", "Value": [3000]},
        "3285": {"vr": "IS", "Value": [3000]},
        "3286": {"vr": "IS", "Value": [3000]},
        "3287": {"vr": "IS", "Value": [3000]},
        "3288": {"vr": "IS", "Value": [3000]},
        "3289": {"vr": "IS", "Value": [3000]},
        "3290": {"vr": "IS", "Value": [3000]},
        "3291": {"vr": "IS", "Value": [3000]},
        "3292": {"vr": "IS", "Value": [3000]},
        "3293": {"vr": "IS", "Value": [3000]},
        "3294": {"vr": "IS", "Value": [3000]},
        "3295": {"vr": "IS", "Value": [3000]},
        "3296": {"vr": "IS", "Value": [3000]},
        "3297": {"vr": "IS", "Value": [3000]},
        "3298": {"vr": "IS", "Value": [3000]},
        "3299": {"vr": "IS", "Value": [3000]},
        "3300": {"vr": "IS", "Value": [3000]},
        "3301": {"vr": "IS", "Value": [3000]},
        "3302": {"vr": "IS", "Value": [3000]},
        "3303": {"vr": "IS", "Value": [3000]},
        "3304": {"vr": "IS", "Value": [3000]},
        "3305": {"vr": "IS", "Value": [3000]},
        "3306": {"vr": "IS", "Value": [3000]},
        "3307": {"vr": "IS", "Value": [3000]},
        "3308": {"vr": "IS", "Value": [3000]},
        "3309": {"vr": "IS", "Value": [3000]},
        "3310": {"vr": "IS", "Value": [3000]},
        "3311": {"vr": "IS", "Value": [3000]},
        "3312": {"vr": "IS", "Value": [3000]},
        "3313": {"vr": "IS", "Value": [3000]},
        "3314": {"vr": "IS", "Value": [3000]},
        "3315": {"vr": "IS", "Value": [0]},
        "3316": {"vr": "IS", "Value": [3000]},
        "3317": {"vr": "IS", "Value": [3000]},
        "3318": {"vr": "IS", "Value": [3000]},
        "3319": {"vr": "IS", "Value": [3000]},
        "3320": {"vr": "IS", "Value": [3000]},
        "3321": {"vr": "IS", "Value": [3000]},
        "3322": {"vr": "IS", "Value": [3000]},
        "3323": {"vr": "IS", "Value": [3000]},
        "3324": {"vr": "IS", "Value": [3000]},
        "3325": {"vr": "IS", "Value": [3000]},
        "3326": {"vr": "IS", "Value": [3000]},
        "3327": {"vr": "IS", "Value": [3000]},
        "3328": {"vr": "IS", "Value": [0]},
        "3329": {"vr": "IS", "Value": [3000]},
        "3330": {"vr": "IS", "Value": [3000]},
        "3331": {"vr": "IS", "Value": [3000]},
        "3332": {"vr": "IS", "Value": [3000]},
        "3333": {"vr": "IS", "Value": [3000]},
        "3334": {"vr": "IS", "Value": [3000]},
        "3335": {"vr": "IS", "Value": [3000]},
        "3336": {"vr": "IS", "Value": [3000]},
        "3337": {"vr": "IS", "Value": [3000]},
        "3338": {"vr": "IS", "Value": [3000]},
        "3339": {"vr": "IS", "Value": [3000]},
        "3340": {"vr": "IS", "Value": [3000]},
        "3341": {"vr": "IS", "Value": [3000]},
        "3342": {"vr": "IS", "Value": [3000]},
        "3343": {"vr": "IS", "Value": [0]},
        "3344": {"vr": "IS", "Value": [3000]},
        "3345": {"vr": "IS", "Value": [3000]},
        "3346": {"vr": "IS", "Value": [3000]},
        "3347": {"vr": "IS", "Value": [0]},
        "3348": {"vr": "IS", "Value": [3000]},
        "3349": {"vr": "IS", "Value": [3000]},
        "3350": {"vr": "IS", "Value": [3000]},
        "3351": {"vr": "IS", "Value": [3000]},
        "3352": {"vr": "IS", "Value": [3000]},
        "3353": {"vr": "IS", "Value": [3000]},
        "3354": {"vr": "IS", "Value": [3000]},
        "3355": {"vr": "IS", "Value": [3000]},
        "3356": {"vr": "IS", "Value": [3000]},
        "3357": {"vr": "IS", "Value": [3000]},
        "3358": {"vr": "IS", "Value": [3000]},
        "3359": {"vr": "IS", "Value": [3000]},
        "3360": {"vr": "IS", "Value": [3000]},
        "3361": {"vr": "IS", "Value": [3000]},
        "3362": {"vr": "IS", "Value": [3000]},
        "3363": {"vr": "IS", "Value": [3000]},
        "3364": {"vr": "IS", "Value": [3000]},
        "3365": {"vr": "IS", "Value": [0]},
        "3366": {"vr": "IS", "Value": [3000]},
        "3367": {"vr": "IS", "Value": [3000]},
        "3368": {"vr": "IS", "Value": [3000]},
        "3369": {"vr": "IS", "Value": [3000]},
        "3370": {"vr": "IS", "Value": [3000]},
        "3371": {"vr": "IS", "Value": [3000]},
        "3372": {"vr": "IS", "Value": [3000]},
        "3373": {"vr": "IS", "Value": [3000]},
        "3374": {"vr": "IS", "Value": [3000]},
        "3375": {"vr": "IS", "Value": [3000]},
        "3376": {"vr": "IS", "Value": [0]},
        "3377": {"vr": "IS", "Value": [3000]},
        "3378": {"vr": "IS", "Value": [3000]},
        "3379": {"vr": "IS", "Value": [3000]},
        "3380": {"vr": "IS", "Value": [3000]},
        "3381": {"vr": "IS", "Value": [3000]},
        "3382": {"vr": "IS", "Value": [0]},
        "3383": {"vr": "IS", "Value": [3000]},
        "3384": {"vr": "IS", "Value": [0]},
        "3385": {"vr": "IS", "Value": [3000]},
        "3386": {"vr": "IS", "Value": [3000]},
        "3387": {"vr": "IS", "Value": [3000]},
        "3388": {"vr": "IS", "Value": [3000]},
        "3389": {"vr": "IS", "Value": [0]},
        "3390": {"vr": "IS", "Value": [3000]},
        "3391": {"vr": "IS", "Value": [3000]},
        "3392": {"vr": "IS", "Value": [3000]},
        "3393": {"vr": "IS", "Value": [3000]},
        "3394": {"vr": "IS", "Value": [3000]},
        "3395": {"vr": "IS", "Value": [3000]},
        "3396": {"vr": "IS", "Value": [3000]},
        "3397": {"vr": "IS", "Value": [3000]},
        "3398": {"vr": "IS", "Value": [3000]},
        "3399": {"vr": "IS", "Value": [3000]},
        "3400": {"vr": "IS", "Value": [3000]},
        "3401": {"vr": "IS", "Value": [3000]},
        "3402": {"vr": "IS", "Value": [3000]},
        "3403": {"vr": "IS", "Value": [3000]},
        "3404": {"vr": "IS", "Value": [3000]},
        "3405": {"vr": "IS", "Value": [0]},
        "3406": {"vr": "IS", "Value": [3000]},
        "3407": {"vr": "IS", "Value": [3000]},
        "3408": {"vr": "IS", "Value": [3000]},
        "3409": {"vr": "IS", "Value": [3000]},
        "3410": {"vr": "IS", "Value": [3000]},
        "3411": {"vr": "IS", "Value": [3000]},
        "3412": {"vr": "IS", "Value": [3000]},
        "3413": {"vr": "IS", "Value": [3000]},
        "3414": {"vr": "IS", "Value": [3000]},
        "3415": {"vr": "IS", "Value": [3000]},
        "3416": {"vr": "IS", "Value": [3000]},
        "3417": {"vr": "IS", "Value": [3000]},
        "3418": {"vr": "IS", "Value": [3000]},
        "3419": {"vr": "IS", "Value": [3000]},
        "3420": {"vr": "IS", "Value": [3000]},
        "3421": {"vr": "IS", "Value": [3000]},
        "3422": {"vr": "IS", "Value": [3000]},
        "3423": {"vr": "IS", "Value": [3000]},
        "3424": {"vr": "IS", "Value": [3000]},
        "3425": {"vr": "IS", "Value": [3000]},
        "3426": {"vr": "IS", "Value": [3000]},
        "3427": {"vr": "IS", "Value": [3000]},
        "3428": {"vr": "IS", "Value": [3000]},
        "3429": {"vr": "IS", "Value": [3000]},
        "3430": {"vr": "IS", "Value": [3000]},
        "3431": {"vr": "IS", "Value": [0]},
        "3432": {"vr": "IS", "Value": [3000]},
        "3433": {"vr": "IS", "Value": [3000]},
        "3434": {"vr": "IS", "Value": [3000]},
        "3435": {"vr": "IS", "Value": [3000]},
        "3436": {"vr": "IS", "Value": [0]},
        "3437": {"vr": "IS", "Value": [3000]},
        "3438": {"vr": "IS", "Value": [3000]},
        "3439": {"vr": "IS", "Value": [3000]},
        "3440": {"vr": "IS", "Value": [3000]},
        "3441": {"vr": "IS", "Value": [3000]},
        "3442": {"vr": "IS", "Value": [3000]},
        "3443": {"vr": "IS", "Value": [3000]},
        "3444": {"vr": "IS", "Value": [3000]},
        "3445": {"vr": "IS", "Value": [3000]},
        "3446": {"vr": "IS", "Value": [0]},
        "3447": {"vr": "IS", "Value": [3000]},
        "3448": {"vr": "IS", "Value": [3000]},
        "3449": {"vr": "IS", "Value": [3000]},
        "3450": {"vr": "IS", "Value": [3000]},
        "3451": {"vr": "IS", "Value": [3000]},
        "3452": {"vr": "IS", "Value": [3000]},
        "3453": {"vr": "IS", "Value": [3000]},
        "3454": {"vr": "IS", "Value": [0]},
        "3455": {"vr": "IS", "Value": [3000]},
        "3456": {"vr": "IS", "Value": [3000]},
        "3457": {"vr": "IS", "Value": [3000]},
        "3458": {"vr": "IS", "Value": [3000]},
        "3459": {"vr": "IS", "Value": [3000]},
        "3460": {"vr": "IS", "Value": [3000]},
        "3461": {"vr": "IS", "Value": [3000]},
        "3462": {"vr": "IS", "Value": [3000]},
        "3463": {"vr": "IS", "Value": [3000]},
        "3464": {"vr": "IS", "Value": [3000]},
        "3465": {"vr": "IS", "Value": [3000]},
        "3466": {"vr": "IS", "Value": [3000]},
        "3467": {"vr": "IS", "Value": [3000]},
        "3468": {"vr": "IS", "Value": [3000]},
        "3469": {"vr": "IS", "Value": [3000]},
        "3470": {"vr": "IS", "Value": [3000]},
        "3471": {"vr": "IS", "Value": [3000]},
        "3472": {"vr": "IS", "Value": [3000]},
        "3473": {"vr": "IS", "Value": [3000]},
        "3474": {"vr": "IS", "Value": [0]},
        "3475": {"vr": "IS", "Value": [3000]},
        "3476": {"vr": "IS", "Value": [3000]},
        "3477": {"vr": "IS", "Value": [3000]},
        "3478": {"vr": "IS", "Value": [3000]},
        "3479": {"vr": "IS", "Value": [3000]},
        "3480": {"vr": "IS", "Value": [3000]},
        "3481": {"vr": "IS", "Value": [0]},
        "3482": {"vr": "IS", "Value": [3000]},
        "3483": {"vr": "IS", "Value": [3000]},
        "3484": {"vr": "IS", "Value": [3000]},
        "3485": {"vr": "IS", "Value": [3000]},
        "3486": {"vr": "IS", "Value": [3000]},
        "3487": {"vr": "IS", "Value": [3000]},
        "3488": {"vr": "IS", "Value": [3000]},
        "3489": {"vr": "IS", "Value": [3000]},
        "3490": {"vr": "IS", "Value": [3000]},
        "3491": {"vr": "IS", "Value": [3000]},
        "3492": {"vr": "IS", "Value": [0]},
        "3493": {"vr": "IS", "Value": [3000]},
        "3494": {"vr": "IS", "Value": [3000]},
        "3495": {"vr": "IS", "Value": [3000]},
        "3496": {"vr": "IS", "Value": [3000]},
        "3497": {"vr": "IS", "Value": [3000]},
        "3498": {"vr": "IS", "Value": [0]},
        "3499": {"vr": "IS", "Value": [3000]},
        "3500": {"vr": "IS", "Value": [3000]},
        "3501": {"vr": "IS", "Value": [0]},
        "3502": {"vr": "IS", "Value": [3000]},
        "3503": {"vr": "IS", "Value": [0]},
        "3504": {"vr": "IS", "Value": [3000]},
        "3505": {"vr": "IS", "Value": [3000]},
        "3506": {"vr": "IS", "Value": [3000]},
        "3507": {"vr": "IS", "Value": [3000]},
        "3508": {"vr": "IS", "Value": [3000]},
        "3509": {"vr": "IS", "Value": [3000]},
        "3510": {"vr": "IS", "Value": [3000]},
        "3511": {"vr": "IS", "Value": [0]},
        "3512": {"vr": "IS", "Value": [3000]},
        "3513": {"vr": "IS", "Value": [3000]},
        "3514": {"vr": "IS", "Value": [3000]},
        "3515": {"vr": "IS", "Value": [3000]},
        "3516": {"vr": "IS", "Value": [3000]},
        "3517": {"vr": "IS", "Value": [3000]},
        "3518": {"vr": "IS", "Value": [3000]},
        "3519": {"vr": "IS", "Value": [3000]},
        "3520": {"vr": "IS", "Value": [3000]},
        "3521": {"vr": "IS", "Value": [0]},
        "3522": {"vr": "IS", "Value": [0]},
        "3523": {"vr": "IS", "Value": [3000]},
        "3524": {"vr": "IS", "Value": [3000]},
        "3525": {"vr": "IS", "Value": [3000]},
        "3526": {"vr": "IS", "Value": [3000]},
        "3527": {"vr": "IS", "Value": [3000]},
        "3528": {"vr": "IS", "Value": [3000]},
        "3529": {"vr": "IS", "Value": [0]},
        "3530": {"vr": "IS", "Value": [3000]},
        "3531": {"vr": "IS", "Value": [3000]},
        "3532": {"vr": "IS", "Value": [0]},
        "3533": {"vr": "IS", "Value": [3000]},
        "3534": {"vr": "IS", "Value": [3000]},
        "3535": {"vr": "IS", "Value": [3000]},
        "3536": {"vr": "IS", "Value": [3000]},
        "3537": {"vr": "IS", "Value": [3000]},
        "3538": {"vr": "IS", "Value": [3000]},
        "3539": {"vr": "IS", "Value": [0]},
        "3540": {"vr": "IS", "Value": [3000]},
        "3541": {"vr": "IS", "Value": [3000]},
        "3542": {"vr": "IS", "Value": [3000]},
        "3543": {"vr": "IS", "Value": [3000]},
        "3544": {"vr": "IS", "Value": [3000]},
        "3545": {"vr": "IS", "Value": [3000]},
        "3546": {"vr": "IS", "Value": [3000]},
        "3547": {"vr": "IS", "Value": [3000]},
        "3548": {"vr": "IS", "Value": [3000]},
        "3549": {"vr": "IS", "Value": [3000]},
        "3550": {"vr": "IS", "Value": [3000]},
        "3551": {"vr": "IS", "Value": [3000]},
        "3552": {"vr": "IS", "Value": [3000]},
        "3553": {"vr": "IS", "Value": [3000]},
        "3554": {"vr": "IS", "Value": [3000]},
        "3555": {"vr": "IS", "Value": [3000]},
        "3556": {"vr": "IS", "Value": [3000]},
        "3557": {"vr": "IS", "Value": [3000]},
        "3558": {"vr": "IS", "Value": [3000]},
        "3559": {"vr": "IS", "Value": [3000]},
        "3560": {"vr": "IS", "Value": [3000]},
        "3561": {"vr": "IS", "Value": [3000]},
        "3562": {"vr": "IS", "Value": [3000]},
        "3563": {"vr": "IS", "Value": [3000]},
        "3564": {"vr": "IS", "Value": [3000]},
        "3565": {"vr": "IS", "Value": [3000]},
        "3566": {"vr": "IS", "Value": [3000]},
        "3567": {"vr": "IS", "Value": [3000]},
        "3568": {"vr": "IS", "Value": [3000]},
        "3569": {"vr": "IS", "Value": [3000]},
        "3570": {"vr": "IS", "Value": [3000]},
        "3571": {"vr": "IS", "Value": [3000]},
        "3572": {"vr": "IS", "Value": [3000]},
        "3573": {"vr": "IS", "Value": [3000]},
        "3574": {"vr": "IS", "Value": [3000]},
        "3575": {"vr": "IS", "Value": [0]},
        "3576": {"vr": "IS", "Value": [3000]},
        "3577": {"vr": "IS", "Value": [3000]},
        "3578": {"vr": "IS", "Value": [3000]},
        "3579": {"vr": "IS", "Value": [3000]},
        "3580": {"vr": "IS", "Value": [3000]},
        "3581": {"vr": "IS", "Value": [3000]},
        "3582": {"vr": "IS", "Value": [3000]},
        "3583": {"vr": "IS", "Value": [3000]},
        "3584": {"vr": "IS", "Value": [3000]},
        "3585": {"vr": "IS", "Value": [3000]},
        "3586": {"vr": "IS", "Value": [3000]},
        "3587": {"vr": "IS", "Value": [3000]},
        "3588": {"vr": "IS", "Value": [3000]},
        "3589": {"vr": "IS", "Value": [0]},
        "3590": {"vr": "IS", "Value": [3000]},
        "3591": {"vr": "IS", "Value": [3000]},
        "3592": {"vr": "IS", "Value": [3000]},
        "3593": {"vr": "IS", "Value": [3000]},
        "3594": {"vr": "IS", "Value": [3000]},
        "3595": {"vr": "IS", "Value": [3000]},
        "3596": {"vr": "IS", "Value": [0]},
        "3597": {"vr": "IS", "Value": [3000]},
        "3598": {"vr": "IS", "Value": [0]},
        "3599": {"vr": "IS", "Value": [3000]},
        "3600": {"vr": "IS", "Value": [3000]},
        "3601": {"vr": "IS", "Value": [3000]},
        "3602": {"vr": "IS", "Value": [3000]},
        "3603": {"vr": "IS", "Value": [3000]},
        "3604": {"vr": "IS", "Value": [3000]},
        "3605": {"vr": "IS", "Value": [3000]},
        "3606": {"vr": "IS", "Value": [3000]},
        "3607": {"vr": "IS", "Value": [3000]},
        "3608": {"vr": "IS", "Value": [3000]},
        "3609": {"vr": "IS", "Value": [3000]},
        "3610": {"vr": "IS", "Value": [0]},
        "3611": {"vr": "IS", "Value": [3000]},
        "3612": {"vr": "IS", "Value": [3000]},
        "3613": {"vr": "IS", "Value": [3000]},
        "3614": {"vr": "IS", "Value": [0]},
        "3615": {"vr": "IS", "Value": [3000]},
        "3616": {"vr": "IS", "Value": [3000]},
        "3617": {"vr": "IS", "Value": [3000]},
        "3618": {"vr": "IS", "Value": [3000]},
        "3619": {"vr": "IS", "Value": [3000]},
        "3620": {"vr": "IS", "Value": [3000]},
        "3621": {"vr": "IS", "Value": [3000]},
        "3622": {"vr": "IS", "Value": [3000]},
        "3623": {"vr": "IS", "Value": [3000]},
        "3624": {"vr": "IS", "Value": [3000]},
        "3625": {"vr": "IS", "Value": [3000]},
        "3626": {"vr": "IS", "Value": [3000]},
        "3627": {"vr": "IS", "Value": [3000]},
        "3628": {"vr": "IS", "Value": [0]},
        "3629": {"vr": "IS", "Value": [3000]},
        "3630": {"vr": "IS", "Value": [3000]},
        "3631": {"vr": "IS", "Value": [3000]},
        "3632": {"vr": "IS", "Value": [3000]},
        "3633": {"vr": "IS", "Value": [3000]},
        "3634": {"vr": "IS", "Value": [3000]},
        "3635": {"vr": "IS", "Value": [3000]},
        "3636": {"vr": "IS", "Value": [3000]},
        "3637": {"vr": "IS", "Value": [3000]},
        "3638": {"vr": "IS", "Value": [0]},
        "3639": {"vr": "IS", "Value": [3000]},
        "3640": {"vr": "IS", "Value": [0]},
        "3641": {"vr": "IS", "Value": [3000]},
        "3642": {"vr": "IS", "Value": [3000]},
        "3643": {"vr": "IS", "Value": [3000]},
        "3644": {"vr": "IS", "Value": [3000]},
        "3645": {"vr": "IS", "Value": [3000]},
        "3646": {"vr": "IS", "Value": [3000]},
        "3647": {"vr": "IS", "Value": [3000]},
        "3648": {"vr": "IS", "Value": [3000]},
        "3649": {"vr": "IS", "Value": [3000]},
        "3650": {"vr": "IS", "Value": [3000]},
        "3651": {"vr": "IS", "Value": [3000]},
        "3652": {"vr": "IS", "Value": [3000]},
        "3653": {"vr": "IS", "Value": [0]},
        "3654": {"vr": "IS", "Value": [0]},
        "3655": {"vr": "IS", "Value": [3000]},
        "3656": {"vr": "IS", "Value": [3000]},
        "3657": {"vr": "IS", "Value": [3000]},
        "3658": {"vr": "IS", "Value": [3000]},
        "3659": {"vr": "IS", "Value": [3000]},
        "3660": {"vr": "IS", "Value": [3000]},
        "3661": {"vr": "IS", "Value": [3000]},
        "3662": {"vr": "IS", "Value": [3000]},
        "3663": {"vr": "IS", "Value": [3000]},
        "3664": {"vr": "IS", "Value": [3000]},
        "3665": {"vr": "IS", "Value": [3000]},
        "3666": {"vr": "IS", "Value": [3000]},
        "3667": {"vr": "IS", "Value": [3000]},
        "3668": {"vr": "IS", "Value": [0]},
        "3669": {"vr": "IS", "Value": [3000]},
        "3670": {"vr": "IS", "Value": [3000]},
        "3671": {"vr": "IS", "Value": [3000]},
        "3672": {"vr": "IS", "Value": [3000]},
        "3673": {"vr": "IS", "Value": [0]},
        "3674": {"vr": "IS", "Value": [3000]},
        "3675": {"vr": "IS", "Value": [3000]},
        "3676": {"vr": "IS", "Value": [3000]},
        "3677": {"vr": "IS", "Value": [3000]},
        "3678": {"vr": "IS", "Value": [3000]},
        "3679": {"vr": "IS", "Value": [3000]},
        "3680": {"vr": "IS", "Value": [3000]},
        "3681": {"vr": "IS", "Value": [3000]},
        "3682": {"vr": "IS", "Value": [3000]},
        "3683": {"vr": "IS", "Value": [3000]},
        "3684": {"vr": "IS", "Value": [3000]},
        "3685": {"vr": "IS", "Value": [3000]},
        "3686": {"vr": "IS", "Value": [3000]},
        "3687": {"vr": "IS", "Value": [0]},
        "3688": {"vr": "IS", "Value": [3000]},
        "3689": {"vr": "IS", "Value": [3000]},
        "3690": {"vr": "IS", "Value": [3000]},
        "3691": {"vr": "IS", "Value": [3000]},
        "3692": {"vr": "IS", "Value": [3000]},
        "3693": {"vr": "IS", "Value": [3000]},
        "3694": {"vr": "IS", "Value": [3000]},
        "3695": {"vr": "IS", "Value": [3000]},
        "3696": {"vr": "IS", "Value": [0]},
        "3697": {"vr": "IS", "Value": [3000]},
        "3698": {"vr": "IS", "Value": [0]},
        "3699": {"vr": "IS", "Value": [3000]},
        "3700": {"vr": "IS", "Value": [3000]},
        "3701": {"vr": "IS", "Value": [3000]},
        "3702": {"vr": "IS", "Value": [3000]},
        "3703": {"vr": "IS", "Value": [3000]},
        "3704": {"vr": "IS", "Value": [3000]},
        "3705": {"vr": "IS", "Value": [3000]},
        "3706": {"vr": "IS", "Value": [3000]},
        "3707": {"vr": "IS", "Value": [3000]},
        "3708": {"vr": "IS", "Value": [3000]},
        "3709": {"vr": "IS", "Value": [3000]},
        "3710": {"vr": "IS", "Value": [3000]},
        "3711": {"vr": "IS", "Value": [3000]},
        "3712": {"vr": "IS", "Value": [3000]},
        "3713": {"vr": "IS", "Value": [3000]},
        "3714": {"vr": "IS", "Value": [3000]},
        "3715": {"vr": "IS", "Value": [3000]},
        "3716": {"vr": "IS", "Value": [0]},
        "3717": {"vr": "IS", "Value": [3000]},
        "3718": {"vr": "IS", "Value": [3000]},
        "3719": {"vr": "IS", "Value": [3000]},
        "3720": {"vr": "IS", "Value": [3000]},
        "3721": {"vr": "IS", "Value": [3000]},
        "3722": {"vr": "IS", "Value": [3000]},
        "3723": {"vr": "IS", "Value": [0]},
        "3724": {"vr": "IS", "Value": [3000]},
        "3725": {"vr": "IS", "Value": [3000]},
        "3726": {"vr": "IS", "Value": [3000]},
        "3727": {"vr": "IS", "Value": [3000]},
        "3728": {"vr": "IS", "Value": [3000]},
        "3729": {"vr": "IS", "Value": [0]},
        "3730": {"vr": "IS", "Value": [3000]},
        "3731": {"vr": "IS", "Value": [3000]},
        "3732": {"vr": "IS", "Value": [3000]},
        "3733": {"vr": "IS", "Value": [3000]},
        "3734": {"vr": "IS", "Value": [3000]},
        "3735": {"vr": "IS", "Value": [0]},
        "3736": {"vr": "IS", "Value": [3000]},
        "3737": {"vr": "IS", "Value": [3000]},
        "3738": {"vr": "IS", "Value": [3000]},
        "3739": {"vr": "IS", "Value": [3000]},
        "3740": {"vr": "IS", "Value": [3000]},
        "3741": {"vr": "IS", "Value": [3000]},
        "3742": {"vr": "IS", "Value": [0]},
        "3743": {"vr": "IS", "Value": [3000]},
        "3744": {"vr": "IS", "Value": [0]},
        "3745": {"vr": "IS", "Value": [3000]},
        "3746": {"vr": "IS", "Value": [3000]},
        "3747": {"vr": "IS", "Value": [3000]},
        "3748": {"vr": "IS", "Value": [3000]},
        "3749": {"vr": "IS", "Value": [3000]},
        "3750": {"vr": "IS", "Value": [3000]},
        "3751": {"vr": "IS", "Value": [3000]},
        "3752": {"vr": "IS", "Value": [3000]},
        "3753": {"vr": "IS", "Value": [3000]},
        "3754": {"vr": "IS", "Value": [3000]},
        "3755": {"vr": "IS", "Value": [3000]},
        "3756": {"vr": "IS", "Value": [0]},
        "3757": {"vr": "IS", "Value": [3000]},
        "3758": {"vr": "IS", "Value": [3000]},
        "3759": {"vr": "IS", "Value": [3000]},
        "3760": {"vr": "IS", "Value": [3000]},
        "3761": {"vr": "IS", "Value": [3000]},
        "3762": {"vr": "IS", "Value": [3000]},
        "3763": {"vr": "IS", "Value": [0]},
        "3764": {"vr": "IS", "Value": [3000]},
        "3765": {"vr": "IS", "Value": [3000]},
        "3766": {"vr": "IS", "Value": [3000]},
        "3767": {"vr": "IS", "Value": [3000]},
        "3768": {"vr": "IS", "Value": [3000]},
        "3769": {"vr": "IS", "Value": [3000]},
        "3770": {"vr": "IS", "Value": [3000]},
        "3771": {"vr": "IS", "Value": [3000]},
        "3772": {"vr": "IS", "Value": [3000]},
        "3773": {"vr": "IS", "Value": [3000]},
        "3774": {"vr": "IS", "Value": [3000]},
        "3775": {"vr": "IS", "Value": [3000]},
        "3776": {"vr": "IS", "Value": [3000]},
        "3777": {"vr": "IS", "Value": [3000]},
        "3778": {"vr": "IS", "Value": [3000]},
        "3779": {"vr": "IS", "Value": [3000]},
        "3780": {"vr": "IS", "Value": [3000]},
        "3781": {"vr": "IS", "Value": [3000]},
        "3782": {"vr": "IS", "Value": [3000]},
        "3783": {"vr": "IS", "Value": [3000]},
        "3784": {"vr": "IS", "Value": [3000]},
        "3785": {"vr": "IS", "Value": [3000]},
        "3786": {"vr": "IS", "Value": [3000]},
        "3787": {"vr": "IS", "Value": [3000]},
        "3788": {"vr": "IS", "Value": [0]},
        "3789": {"vr": "IS", "Value": [3000]},
        "3790": {"vr": "IS", "Value": [3000]},
        "3791": {"vr": "IS", "Value": [3000]},
        "3792": {"vr": "IS", "Value": [3000]},
        "3793": {"vr": "IS", "Value": [3000]},
        "3794": {"vr": "IS", "Value": [3000]},
        "3795": {"vr": "IS", "Value": [0]},
        "3796": {"vr": "IS", "Value": [3000]},
        "3797": {"vr": "IS", "Value": [3000]},
        "3798": {"vr": "IS", "Value": [3000]},
        "3799": {"vr": "IS", "Value": [3000]},
        "3800": {"vr": "IS", "Value": [3000]},
        "3801": {"vr": "IS", "Value": [3000]},
        "3802": {"vr": "IS", "Value": [3000]},
        "3803": {"vr": "IS", "Value": [3000]},
        "3804": {"vr": "IS", "Value": [3000]},
        "3805": {"vr": "IS", "Value": [0]},
        "3806": {"vr": "IS", "Value": [0]},
        "3807": {"vr": "IS", "Value": [3000]},
        "3808": {"vr": "IS", "Value": [3000]},
        "3809": {"vr": "IS", "Value": [3000]},
        "3810": {"vr": "IS", "Value": [3000]},
        "3811": {"vr": "IS", "Value": [3000]},
        "3812": {"vr": "IS", "Value": [3000]},
        "3813": {"vr": "IS", "Value": [3000]},
        "3814": {"vr": "IS", "Value": [3000]},
        "3815": {"vr": "IS", "Value": [3000]},
        "3816": {"vr": "IS", "Value": [3000]},
        "3817": {"vr": "IS", "Value": [3000]},
        "3818": {"vr": "IS", "Value": [3000]},
        "3819": {"vr": "IS", "Value": [3000]},
        "3820": {"vr": "IS", "Value": [3000]},
        "3821": {"vr": "IS", "Value": [3000]},
        "3822": {"vr": "IS", "Value": [3000]},
        "3823": {"vr": "IS", "Value": [3000]},
        "3824": {"vr": "IS", "Value": [3000]},
        "3825": {"vr": "IS", "Value": [0]},
        "3826": {"vr": "IS", "Value": [3000]},
        "3827": {"vr": "IS", "Value": [3000]},
        "3828": {"vr": "IS", "Value": [3000]},
        "3829": {"vr": "IS", "Value": [3000]},
        "3830": {"vr": "IS", "Value": [3000]},
        "3831": {"vr": "IS", "Value": [3000]},
        "3832": {"vr": "IS", "Value": [0]},
        "3833": {"vr": "IS", "Value": [3000]},
        "3834": {"vr": "IS", "Value": [3000]},
        "3835": {"vr": "IS", "Value": [3000]},
        "3836": {"vr": "IS", "Value": [3000]},
        "3837": {"vr": "IS", "Value": [3000]},
        "3838": {"vr": "IS", "Value": [3000]},
        "3839": {"vr": "IS", "Value": [3000]},
        "3840": {"vr": "IS", "Value": [3000]},
        "3841": {"vr": "IS", "Value": [3000]},
        "3842": {"vr": "IS", "Value": [3000]},
        "3843": {"vr": "IS", "Value": [3000]},
        "3844": {"vr": "IS", "Value": [3000]},
        "3845": {"vr": "IS", "Value": [0]},
        "3846": {"vr": "IS", "Value": [3000]},
        "3847": {"vr": "IS", "Value": [3000]},
        "3848": {"vr": "IS", "Value": [3000]},
        "3849": {"vr": "IS", "Value": [3000]},
        "3850": {"vr": "IS", "Value": [3000]},
        "3851": {"vr": "IS", "Value": [3000]},
        "3852": {"vr": "IS", "Value": [3000]},
        "3853": {"vr": "IS", "Value": [3000]},
        "3854": {"vr": "IS", "Value": [3000]},
        "3855": {"vr": "IS", "Value": [0]},
        "3856": {"vr": "IS", "Value": [3000]},
        "3857": {"vr": "IS", "Value": [3000]},
        "3858": {"vr": "IS", "Value": [3000]},
        "3859": {"vr": "IS", "Value": [3000]},
        "3860": {"vr": "IS", "Value": [3000]},
        "3861": {"vr": "IS", "Value": [3000]},
        "3862": {"vr": "IS", "Value": [3000]},
        "3863": {"vr": "IS", "Value": [0]},
        "3864": {"vr": "IS", "Value": [3000]},
        "3865": {"vr": "IS", "Value": [3000]},
        "3866": {"vr": "IS", "Value": [3000]},
        "3867": {"vr": "IS", "Value": [3000]},
        "3868": {"vr": "IS", "Value": [3000]},
        "3869": {"vr": "IS", "Value": [3000]},
        "3870": {"vr": "IS", "Value": [3000]},
        "3871": {"vr": "IS", "Value": [3000]},
        "3872": {"vr": "IS", "Value": [3000]},
        "3873": {"vr": "IS", "Value": [3000]},
        "3874": {"vr": "IS", "Value": [3000]},
        "3875": {"vr": "IS", "Value": [3000]},
        "3876": {"vr": "IS", "Value": [3000]},
        "3877": {"vr": "IS", "Value": [3000]},
        "3878": {"vr": "IS", "Value": [0]},
        "3879": {"vr": "IS", "Value": [3000]},
        "3880": {"vr": "IS", "Value": [3000]},
        "3881": {"vr": "IS", "Value": [3000]},
        "3882": {"vr": "IS", "Value": [0]},
        "3883": {"vr": "IS", "Value": [3000]},
        "3884": {"vr": "IS", "Value": [3000]},
        "3885": {"vr": "IS", "Value": [0]},
        "3886": {"vr": "IS", "Value": [3000]},
        "3887": {"vr": "IS", "Value": [3000]},
        "3888": {"vr": "IS", "Value": [3000]},
        "3889": {"vr": "IS", "Value": [3000]},
        "3890": {"vr": "IS", "Value": [3000]},
        "3891": {"vr": "IS", "Value": [3000]},
        "3892": {"vr": "IS", "Value": [3000]},
        "3893": {"vr": "IS", "Value": [3000]},
        "3894": {"vr": "IS", "Value": [3000]},
        "3895": {"vr": "IS", "Value": [3000]},
        "3896": {"vr": "IS", "Value": [3000]},
        "3897": {"vr": "IS", "Value": [3000]},
        "3898": {"vr": "IS", "Value": [3000]},
        "3899": {"vr": "IS", "Value": [3000]},
        "3900": {"vr": "IS", "Value": [0]},
        "3901": {"vr": "IS", "Value": [3000]},
        "3902": {"vr": "IS", "Value": [3000]},
        "3903": {"vr": "IS", "Value": [3000]},
        "3904": {"vr": "IS", "Value": [3000]},
        "3905": {"vr": "IS", "Value": [3000]},
        "3906": {"vr": "IS", "Value": [3000]},
        "3907": {"vr": "IS", "Value": [3000]},
        "3908": {"vr": "IS", "Value": [3000]},
        "3909": {"vr": "IS", "Value": [3000]},
        "3910": {"vr": "IS", "Value": [3000]},
        "3911": {"vr": "IS", "Value": [3000]},
        "3912": {"vr": "IS", "Value": [3000]},
        "3913": {"vr": "IS", "Value": [3000]},
        "3914": {"vr": "IS", "Value": [3000]},
        "3915": {"vr": "IS", "Value": [3000]},
        "3916": {"vr": "IS", "Value": [0]},
        "3917": {"vr": "IS", "Value": [3000]},
        "3918": {"vr": "IS", "Value": [3000]},
        "3919": {"vr": "IS", "Value": [3000]},
        "3920": {"vr": "IS", "Value": [3000]},
        "3921": {"vr": "IS", "Value": [3000]},
        "3922": {"vr": "IS", "Value": [3000]},
        "3923": {"vr": "IS", "Value": [3000]},
        "3924": {"vr": "IS", "Value": [3000]},
        "3925": {"vr": "IS", "Value": [3000]},
        "3926": {"vr": "IS", "Value": [3000]},
        "3927": {"vr": "IS", "Value": [3000]},
        "3928": {"vr": "IS", "Value": [0]},
        "3929": {"vr": "IS", "Value": [3000]},
        "3930": {"vr": "IS", "Value": [3000]},
        "3931": {"vr": "IS", "Value": [3000]},
        "3932": {"vr": "IS", "Value": [3000]},
        "3933": {"vr": "IS", "Value": [3000]},
        "3934": {"vr": "IS", "Value": [3000]},
        "3935": {"vr": "IS", "Value": [3000]},
        "3936": {"vr": "IS", "Value": [3000]},
        "3937": {"vr": "IS", "Value": [0]},
        "3938": {"vr": "IS", "Value": [3000]},
        "3939": {"vr": "IS", "Value": [3000]},
        "3940": {"vr": "IS", "Value": [3000]},
        "3941": {"vr": "IS", "Value": [3000]},
        "3942": {"vr": "IS", "Value": [3000]},
        "3943": {"vr": "IS", "Value": [3000]},
        "3944": {"vr": "IS", "Value": [3000]},
        "3945": {"vr": "IS", "Value": [0]},
        "3946": {"vr": "IS", "Value": [3000]},
        "3947": {"vr": "IS", "Value": [3000]},
        "3948": {"vr": "IS", "Value": [3000]},
        "3949": {"vr": "IS", "Value": [3000]},
        "3950": {"vr": "IS", "Value": [3000]},
        "3951": {"vr": "IS", "Value": [3000]},
        "3952": {"vr": "IS", "Value": [3000]},
        "3953": {"vr": "IS", "Value": [3000]},
        "3954": {"vr": "IS", "Value": [3000]},
        "3955": {"vr": "IS", "Value": [3000]},
        "3956": {"vr": "IS", "Value": [3000]},
        "3957": {"vr": "IS", "Value": [3000]},
        "3958": {"vr": "IS", "Value": [3000]},
        "3959": {"vr": "IS", "Value": [3000]},
        "3960": {"vr": "IS", "Value": [3000]},
        "3961": {"vr": "IS", "Value": [3000]},
        "3962": {"vr": "IS", "Value": [3000]},
        "3963": {"vr": "IS", "Value": [3000]},
        "3964": {"vr": "IS", "Value": [3000]},
        "3965": {"vr": "IS", "Value": [3000]},
        "3966": {"vr": "IS", "Value": [3000]},
        "3967": {"vr": "IS", "Value": [3000]},
        "3968": {"vr": "IS", "Value": [0]},
        "3969": {"vr": "IS", "Value": [3000]},
        "3970": {"vr": "IS", "Value": [3000]},
        "3971": {"vr": "IS", "Value": [3000]},
        "3972": {"vr": "IS", "Value": [3000]},
        "3973": {"vr": "IS", "Value": [3000]},
        "3974": {"vr": "IS", "Value": [3000]},
        "3975": {"vr": "IS", "Value": [3000]},
        "3976": {"vr": "IS", "Value": [3000]},
        "3977": {"vr": "IS", "Value": [3000]},
        "3978": {"vr": "IS", "Value": [3000]},
        "3979": {"vr": "IS", "Value": [3000]},
        "3980": {"vr": "IS", "Value": [3000]},
        "3981": {"vr": "IS", "Value": [3000]},
        "3982": {"vr": "IS", "Value": [3000]},
        "3983": {"vr": "IS", "Value": [3000]},
        "3984": {"vr": "IS", "Value": [3000]},
        "3985": {"vr": "IS", "Value": [3000]},
        "3986": {"vr": "IS", "Value": [3000]},
        "3987": {"vr": "IS", "Value": [3000]},
        "3988": {"vr": "IS", "Value": [3000]},
        "3989": {"vr": "IS", "Value": [3000]},
        "3990": {"vr": "IS", "Value": [3000]},
        "3991": {"vr": "IS", "Value": [3000]},
        "3992": {"vr": "IS", "Value": [3000]},
        "3993": {"vr": "IS", "Value": [3000]},
        "3994": {"vr": "IS", "Value": [3000]},
        "3995": {"vr": "IS", "Value": [3000]},
        "3996": {"vr": "IS", "Value": [3000]},
        "3997": {"vr": "IS", "Value": [3000]},
        "3998": {"vr": "IS", "Value": [3000]},
        "3999": {"vr": "IS", "Value": [3000]},
        "4000": {"vr": "IS", "Value": [3000]},
        "4001": {"vr": "IS", "Value": [3000]},
        "4002": {"vr": "IS", "Value": [3000]},
        "4003": {"vr": "IS", "Value": [3000]},
        "4004": {"vr": "IS", "Value": [3000]},
        "4005": {"vr": "IS", "Value": [3000]},
        "4006": {"vr": "IS", "Value": [3000]},
        "4007": {"vr": "IS", "Value": [3000]},
        "4008": {"vr": "IS", "Value": [3000]},
        "4009": {"vr": "IS", "Value": [0]},
        "4010": {"vr": "IS", "Value": [3000]},
        "4011": {"vr": "IS", "Value": [0]},
        "4012": {"vr": "IS", "Value": [3000]},
        "4013": {"vr": "IS", "Value": [3000]},
        "4014": {"vr": "IS", "Value": [3000]},
        "4015": {"vr": "IS", "Value": [3000]},
        "4016": {"vr": "IS", "Value": [3000]},
        "4017": {"vr": "IS", "Value": [3000]},
        "4018": {"vr": "IS", "Value": [3000]},
        "4019": {"vr": "IS", "Value": [3000]},
    },
    "0019100D": {
        "0": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3": {"vr": "CS", "Value": ["NONE"]},
        "4": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "5": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "6": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "7": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "8": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "9": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "10": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "11": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "12": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "13": {"vr": "CS", "Value": ["NONE"]},
        "14": {"vr": "CS", "Value": ["NONE"]},
        "15": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "16": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "17": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "18": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "19": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "20": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "21": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "22": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "23": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "24": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "25": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "26": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "27": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "28": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "29": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "30": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "31": {"vr": "CS", "Value": ["NONE"]},
        "32": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "33": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "34": {"vr": "CS", "Value": ["NONE"]},
        "35": {"vr": "CS", "Value": ["NONE"]},
        "36": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "37": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "38": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "39": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "40": {"vr": "CS", "Value": ["NONE"]},
        "41": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "42": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "43": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "44": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "45": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "46": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "47": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "48": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "49": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "50": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "51": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "52": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "53": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "54": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "55": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "56": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "57": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "58": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "59": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "60": {"vr": "CS", "Value": ["NONE"]},
        "61": {"vr": "CS", "Value": ["NONE"]},
        "62": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "63": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "64": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "65": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "66": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "67": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "68": {"vr": "CS", "Value": ["NONE"]},
        "69": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "70": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "71": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "72": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "73": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "74": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "75": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "76": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "77": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "78": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "79": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "80": {"vr": "CS", "Value": ["NONE"]},
        "81": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "82": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "83": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "84": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "85": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "86": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "87": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "88": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "89": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "90": {"vr": "CS", "Value": ["NONE"]},
        "91": {"vr": "CS", "Value": ["NONE"]},
        "92": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "93": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "94": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "95": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "96": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "97": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "98": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "99": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "112": {"vr": "CS", "Value": ["NONE"]},
        "113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "114": {"vr": "CS", "Value": ["NONE"]},
        "115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "128": {"vr": "CS", "Value": ["NONE"]},
        "129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "132": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "160": {"vr": "CS", "Value": ["NONE"]},
        "161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "165": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "191": {"vr": "CS", "Value": ["NONE"]},
        "192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "193": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "198": {"vr": "CS", "Value": ["NONE"]},
        "199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "210": {"vr": "CS", "Value": ["NONE"]},
        "211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "220": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "227": {"vr": "CS", "Value": ["NONE"]},
        "228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "243": {"vr": "CS", "Value": ["NONE"]},
        "244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "246": {"vr": "CS", "Value": ["NONE"]},
        "247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "256": {"vr": "CS", "Value": ["NONE"]},
        "257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "264": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "270": {"vr": "CS", "Value": ["NONE"]},
        "271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "275": {"vr": "CS", "Value": ["NONE"]},
        "276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "290": {"vr": "CS", "Value": ["NONE"]},
        "291": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "301": {"vr": "CS", "Value": ["NONE"]},
        "302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "311": {"vr": "CS", "Value": ["NONE"]},
        "312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "313": {"vr": "CS", "Value": ["NONE"]},
        "314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "316": {"vr": "CS", "Value": ["NONE"]},
        "317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "347": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "349": {"vr": "CS", "Value": ["NONE"]},
        "350": {"vr": "CS", "Value": ["NONE"]},
        "351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "361": {"vr": "CS", "Value": ["NONE"]},
        "362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "363": {"vr": "CS", "Value": ["NONE"]},
        "364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "368": {"vr": "CS", "Value": ["NONE"]},
        "369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "376": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "381": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "382": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "383": {"vr": "CS", "Value": ["NONE"]},
        "384": {"vr": "CS", "Value": ["NONE"]},
        "385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "396": {"vr": "CS", "Value": ["NONE"]},
        "397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "399": {"vr": "CS", "Value": ["NONE"]},
        "400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "417": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "418": {"vr": "CS", "Value": ["NONE"]},
        "419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "424": {"vr": "CS", "Value": ["NONE"]},
        "425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "445": {"vr": "CS", "Value": ["NONE"]},
        "446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "448": {"vr": "CS", "Value": ["NONE"]},
        "449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "469": {"vr": "CS", "Value": ["NONE"]},
        "470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "474": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "475": {"vr": "CS", "Value": ["NONE"]},
        "476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "483": {"vr": "CS", "Value": ["NONE"]},
        "484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "497": {"vr": "CS", "Value": ["NONE"]},
        "498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "501": {"vr": "CS", "Value": ["NONE"]},
        "502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "507": {"vr": "CS", "Value": ["NONE"]},
        "508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "514": {"vr": "CS", "Value": ["NONE"]},
        "515": {"vr": "CS", "Value": ["NONE"]},
        "516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "520": {"vr": "CS", "Value": ["NONE"]},
        "521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "522": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "531": {"vr": "CS", "Value": ["NONE"]},
        "532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "539": {"vr": "CS", "Value": ["NONE"]},
        "540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "542": {"vr": "CS", "Value": ["NONE"]},
        "543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "544": {"vr": "CS", "Value": ["NONE"]},
        "545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "548": {"vr": "CS", "Value": ["NONE"]},
        "549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "553": {"vr": "CS", "Value": ["NONE"]},
        "554": {"vr": "CS", "Value": ["NONE"]},
        "555": {"vr": "CS", "Value": ["NONE"]},
        "556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "567": {"vr": "CS", "Value": ["NONE"]},
        "568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "585": {"vr": "CS", "Value": ["NONE"]},
        "586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "587": {"vr": "CS", "Value": ["NONE"]},
        "588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "600": {"vr": "CS", "Value": ["NONE"]},
        "601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "610": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "611": {"vr": "CS", "Value": ["NONE"]},
        "612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "624": {"vr": "CS", "Value": ["NONE"]},
        "625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "628": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "636": {"vr": "CS", "Value": ["NONE"]},
        "637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "640": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "663": {"vr": "CS", "Value": ["NONE"]},
        "664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "668": {"vr": "CS", "Value": ["NONE"]},
        "669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "679": {"vr": "CS", "Value": ["NONE"]},
        "680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "687": {"vr": "CS", "Value": ["NONE"]},
        "688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "690": {"vr": "CS", "Value": ["NONE"]},
        "691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "699": {"vr": "CS", "Value": ["NONE"]},
        "700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "707": {"vr": "CS", "Value": ["NONE"]},
        "708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "714": {"vr": "CS", "Value": ["NONE"]},
        "715": {"vr": "CS", "Value": ["NONE"]},
        "716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "732": {"vr": "CS", "Value": ["NONE"]},
        "733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "736": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "757": {"vr": "CS", "Value": ["NONE"]},
        "758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "771": {"vr": "CS", "Value": ["NONE"]},
        "772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "777": {"vr": "CS", "Value": ["NONE"]},
        "778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "788": {"vr": "CS", "Value": ["NONE"]},
        "789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "791": {"vr": "CS", "Value": ["NONE"]},
        "792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "805": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "810": {"vr": "CS", "Value": ["NONE"]},
        "811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "816": {"vr": "CS", "Value": ["NONE"]},
        "817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "820": {"vr": "CS", "Value": ["NONE"]},
        "821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "827": {"vr": "CS", "Value": ["NONE"]},
        "828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "829": {"vr": "CS", "Value": ["NONE"]},
        "830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "845": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "846": {"vr": "CS", "Value": ["NONE"]},
        "847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "850": {"vr": "CS", "Value": ["NONE"]},
        "851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "855": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "861": {"vr": "CS", "Value": ["NONE"]},
        "862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "867": {"vr": "CS", "Value": ["NONE"]},
        "868": {"vr": "CS", "Value": ["NONE"]},
        "869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "870": {"vr": "CS", "Value": ["NONE"]},
        "871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "875": {"vr": "CS", "Value": ["NONE"]},
        "876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "878": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "882": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "885": {"vr": "CS", "Value": ["NONE"]},
        "886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "916": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "918": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "919": {"vr": "CS", "Value": ["NONE"]},
        "920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "924": {"vr": "CS", "Value": ["NONE"]},
        "925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "926": {"vr": "CS", "Value": ["NONE"]},
        "927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "932": {"vr": "CS", "Value": ["NONE"]},
        "933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "936": {"vr": "CS", "Value": ["NONE"]},
        "937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "948": {"vr": "CS", "Value": ["NONE"]},
        "949": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "956": {"vr": "CS", "Value": ["NONE"]},
        "957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "961": {"vr": "CS", "Value": ["NONE"]},
        "962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "968": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "978": {"vr": "CS", "Value": ["NONE"]},
        "979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "983": {"vr": "CS", "Value": ["NONE"]},
        "984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "996": {"vr": "CS", "Value": ["NONE"]},
        "997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1015": {"vr": "CS", "Value": ["NONE"]},
        "1016": {"vr": "CS", "Value": ["NONE"]},
        "1017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1025": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1029": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1030": {"vr": "CS", "Value": ["NONE"]},
        "1031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1032": {"vr": "CS", "Value": ["NONE"]},
        "1033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1039": {"vr": "CS", "Value": ["NONE"]},
        "1040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1053": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1060": {"vr": "CS", "Value": ["NONE"]},
        "1061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1064": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1065": {"vr": "CS", "Value": ["NONE"]},
        "1066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1072": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1073": {"vr": "CS", "Value": ["NONE"]},
        "1074": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1075": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1077": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1079": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1081": {"vr": "CS", "Value": ["NONE"]},
        "1082": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1083": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1084": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1086": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1088": {"vr": "CS", "Value": ["NONE"]},
        "1089": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1090": {"vr": "CS", "Value": ["NONE"]},
        "1091": {"vr": "CS", "Value": ["NONE"]},
        "1092": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1097": {"vr": "CS", "Value": ["NONE"]},
        "1098": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1105": {"vr": "CS", "Value": ["NONE"]},
        "1106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1110": {"vr": "CS", "Value": ["NONE"]},
        "1111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1131": {"vr": "CS", "Value": ["NONE"]},
        "1132": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1136": {"vr": "CS", "Value": ["NONE"]},
        "1137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1147": {"vr": "CS", "Value": ["NONE"]},
        "1148": {"vr": "CS", "Value": ["NONE"]},
        "1149": {"vr": "CS", "Value": ["NONE"]},
        "1150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1160": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1165": {"vr": "CS", "Value": ["NONE"]},
        "1166": {"vr": "CS", "Value": ["NONE"]},
        "1167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1178": {"vr": "CS", "Value": ["NONE"]},
        "1179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1189": {"vr": "CS", "Value": ["NONE"]},
        "1190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1191": {"vr": "CS", "Value": ["NONE"]},
        "1192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1193": {"vr": "CS", "Value": ["NONE"]},
        "1194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1201": {"vr": "CS", "Value": ["NONE"]},
        "1202": {"vr": "CS", "Value": ["NONE"]},
        "1203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1219": {"vr": "CS", "Value": ["NONE"]},
        "1220": {"vr": "CS", "Value": ["NONE"]},
        "1221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1243": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1256": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1260": {"vr": "CS", "Value": ["NONE"]},
        "1261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1264": {"vr": "CS", "Value": ["NONE"]},
        "1265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1270": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1271": {"vr": "CS", "Value": ["NONE"]},
        "1272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1282": {"vr": "CS", "Value": ["NONE"]},
        "1283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1291": {"vr": "CS", "Value": ["NONE"]},
        "1292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1300": {"vr": "CS", "Value": ["NONE"]},
        "1301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1309": {"vr": "CS", "Value": ["NONE"]},
        "1310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1313": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1324": {"vr": "CS", "Value": ["NONE"]},
        "1325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1326": {"vr": "CS", "Value": ["NONE"]},
        "1327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1330": {"vr": "CS", "Value": ["NONE"]},
        "1331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1333": {"vr": "CS", "Value": ["NONE"]},
        "1334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1347": {"vr": "CS", "Value": ["NONE"]},
        "1348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1358": {"vr": "CS", "Value": ["NONE"]},
        "1359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1375": {"vr": "CS", "Value": ["NONE"]},
        "1376": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1381": {"vr": "CS", "Value": ["NONE"]},
        "1382": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1384": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1404": {"vr": "CS", "Value": ["NONE"]},
        "1405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1413": {"vr": "CS", "Value": ["NONE"]},
        "1414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1417": {"vr": "CS", "Value": ["NONE"]},
        "1418": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1430": {"vr": "CS", "Value": ["NONE"]},
        "1431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1442": {"vr": "CS", "Value": ["NONE"]},
        "1443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1449": {"vr": "CS", "Value": ["NONE"]},
        "1450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1455": {"vr": "CS", "Value": ["NONE"]},
        "1456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1460": {"vr": "CS", "Value": ["NONE"]},
        "1461": {"vr": "CS", "Value": ["NONE"]},
        "1462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1474": {"vr": "CS", "Value": ["NONE"]},
        "1475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1488": {"vr": "CS", "Value": ["NONE"]},
        "1489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1493": {"vr": "CS", "Value": ["NONE"]},
        "1494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1501": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1512": {"vr": "CS", "Value": ["NONE"]},
        "1513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1515": {"vr": "CS", "Value": ["NONE"]},
        "1516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1517": {"vr": "CS", "Value": ["NONE"]},
        "1518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1520": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1522": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1536": {"vr": "CS", "Value": ["NONE"]},
        "1537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1539": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1548": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1553": {"vr": "CS", "Value": ["NONE"]},
        "1554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1555": {"vr": "CS", "Value": ["NONE"]},
        "1556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1559": {"vr": "CS", "Value": ["NONE"]},
        "1560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1562": {"vr": "CS", "Value": ["NONE"]},
        "1563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1574": {"vr": "CS", "Value": ["NONE"]},
        "1575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1585": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1590": {"vr": "CS", "Value": ["NONE"]},
        "1591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1594": {"vr": "CS", "Value": ["NONE"]},
        "1595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1600": {"vr": "CS", "Value": ["NONE"]},
        "1601": {"vr": "CS", "Value": ["NONE"]},
        "1602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1603": {"vr": "CS", "Value": ["NONE"]},
        "1604": {"vr": "CS", "Value": ["NONE"]},
        "1605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1610": {"vr": "CS", "Value": ["NONE"]},
        "1611": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1625": {"vr": "CS", "Value": ["NONE"]},
        "1626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1628": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1636": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1640": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1643": {"vr": "CS", "Value": ["NONE"]},
        "1644": {"vr": "CS", "Value": ["NONE"]},
        "1645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1649": {"vr": "CS", "Value": ["NONE"]},
        "1650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1668": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1679": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1687": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1689": {"vr": "CS", "Value": ["NONE"]},
        "1690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1691": {"vr": "CS", "Value": ["NONE"]},
        "1692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1700": {"vr": "CS", "Value": ["NONE"]},
        "1701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1717": {"vr": "CS", "Value": ["NONE"]},
        "1718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1720": {"vr": "CS", "Value": ["NONE"]},
        "1721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1736": {"vr": "CS", "Value": ["NONE"]},
        "1737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1738": {"vr": "CS", "Value": ["NONE"]},
        "1739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1757": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1775": {"vr": "CS", "Value": ["NONE"]},
        "1776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1777": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1788": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1796": {"vr": "CS", "Value": ["NONE"]},
        "1797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1802": {"vr": "CS", "Value": ["NONE"]},
        "1803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1805": {"vr": "CS", "Value": ["NONE"]},
        "1806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1827": {"vr": "CS", "Value": ["NONE"]},
        "1828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1837": {"vr": "CS", "Value": ["NONE"]},
        "1838": {"vr": "CS", "Value": ["NONE"]},
        "1839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1845": {"vr": "CS", "Value": ["NONE"]},
        "1846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1855": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1872": {"vr": "CS", "Value": ["NONE"]},
        "1873": {"vr": "CS", "Value": ["NONE"]},
        "1874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1878": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1882": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1885": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1889": {"vr": "CS", "Value": ["NONE"]},
        "1890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1909": {"vr": "CS", "Value": ["NONE"]},
        "1910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1914": {"vr": "CS", "Value": ["NONE"]},
        "1915": {"vr": "CS", "Value": ["NONE"]},
        "1916": {"vr": "CS", "Value": ["NONE"]},
        "1917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1918": {"vr": "CS", "Value": ["NONE"]},
        "1919": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1920": {"vr": "CS", "Value": ["NONE"]},
        "1921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1933": {"vr": "CS", "Value": ["NONE"]},
        "1934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1949": {"vr": "CS", "Value": ["NONE"]},
        "1950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1961": {"vr": "CS", "Value": ["NONE"]},
        "1962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1967": {"vr": "CS", "Value": ["NONE"]},
        "1968": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1973": {"vr": "CS", "Value": ["NONE"]},
        "1974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1986": {"vr": "CS", "Value": ["NONE"]},
        "1987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1993": {"vr": "CS", "Value": ["NONE"]},
        "1994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1996": {"vr": "CS", "Value": ["NONE"]},
        "1997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2001": {"vr": "CS", "Value": ["NONE"]},
        "2002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2012": {"vr": "CS", "Value": ["NONE"]},
        "2013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2017": {"vr": "CS", "Value": ["NONE"]},
        "2018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2025": {"vr": "CS", "Value": ["NONE"]},
        "2026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2029": {"vr": "CS", "Value": ["NONE"]},
        "2030": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2032": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2039": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2053": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2060": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2064": {"vr": "CS", "Value": ["NONE"]},
        "2065": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2072": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2073": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2074": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2075": {"vr": "CS", "Value": ["NONE"]},
        "2076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2077": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2079": {"vr": "CS", "Value": ["NONE"]},
        "2080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2081": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2082": {"vr": "CS", "Value": ["NONE"]},
        "2083": {"vr": "CS", "Value": ["NONE"]},
        "2084": {"vr": "CS", "Value": ["NONE"]},
        "2085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2086": {"vr": "CS", "Value": ["NONE"]},
        "2087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2088": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2089": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2090": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2091": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2092": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2097": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2098": {"vr": "CS", "Value": ["NONE"]},
        "2099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2109": {"vr": "CS", "Value": ["NONE"]},
        "2110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2132": {"vr": "CS", "Value": ["NONE"]},
        "2133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2146": {"vr": "CS", "Value": ["NONE"]},
        "2147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2158": {"vr": "CS", "Value": ["NONE"]},
        "2159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2160": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2165": {"vr": "CS", "Value": ["NONE"]},
        "2166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2170": {"vr": "CS", "Value": ["NONE"]},
        "2171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2174": {"vr": "CS", "Value": ["NONE"]},
        "2175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2187": {"vr": "CS", "Value": ["NONE"]},
        "2188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2191": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2192": {"vr": "CS", "Value": ["NONE"]},
        "2193": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2204": {"vr": "CS", "Value": ["NONE"]},
        "2205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2220": {"vr": "CS", "Value": ["NONE"]},
        "2221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2239": {"vr": "CS", "Value": ["NONE"]},
        "2240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2243": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2254": {"vr": "CS", "Value": ["NONE"]},
        "2255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2256": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2259": {"vr": "CS", "Value": ["NONE"]},
        "2260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2263": {"vr": "CS", "Value": ["NONE"]},
        "2264": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2270": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2278": {"vr": "CS", "Value": ["NONE"]},
        "2279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2287": {"vr": "CS", "Value": ["NONE"]},
        "2288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2291": {"vr": "CS", "Value": ["NONE"]},
        "2292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2295": {"vr": "CS", "Value": ["NONE"]},
        "2296": {"vr": "CS", "Value": ["NONE"]},
        "2297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2313": {"vr": "CS", "Value": ["NONE"]},
        "2314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2340": {"vr": "CS", "Value": ["NONE"]},
        "2341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2346": {"vr": "CS", "Value": ["NONE"]},
        "2347": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2359": {"vr": "CS", "Value": ["NONE"]},
        "2360": {"vr": "CS", "Value": ["NONE"]},
        "2361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2369": {"vr": "CS", "Value": ["NONE"]},
        "2370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2376": {"vr": "CS", "Value": ["NONE"]},
        "2377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2381": {"vr": "CS", "Value": ["NONE"]},
        "2382": {"vr": "CS", "Value": ["NONE"]},
        "2383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2384": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2385": {"vr": "CS", "Value": ["NONE"]},
        "2386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2394": {"vr": "CS", "Value": ["NONE"]},
        "2395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2400": {"vr": "CS", "Value": ["NONE"]},
        "2401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2417": {"vr": "CS", "Value": ["NONE"]},
        "2418": {"vr": "CS", "Value": ["NONE"]},
        "2419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2433": {"vr": "CS", "Value": ["NONE"]},
        "2434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2474": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2479": {"vr": "CS", "Value": ["NONE"]},
        "2480": {"vr": "CS", "Value": ["NONE"]},
        "2481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2501": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2515": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2520": {"vr": "CS", "Value": ["NONE"]},
        "2521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2522": {"vr": "CS", "Value": ["NONE"]},
        "2523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2525": {"vr": "CS", "Value": ["NONE"]},
        "2526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2534": {"vr": "CS", "Value": ["NONE"]},
        "2535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2537": {"vr": "CS", "Value": ["NONE"]},
        "2538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2539": {"vr": "CS", "Value": ["NONE"]},
        "2540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2546": {"vr": "CS", "Value": ["NONE"]},
        "2547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2548": {"vr": "CS", "Value": ["NONE"]},
        "2549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2553": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2555": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2557": {"vr": "CS", "Value": ["NONE"]},
        "2558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2571": {"vr": "CS", "Value": ["NONE"]},
        "2572": {"vr": "CS", "Value": ["NONE"]},
        "2573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2584": {"vr": "CS", "Value": ["NONE"]},
        "2585": {"vr": "CS", "Value": ["NONE"]},
        "2586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2600": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2609": {"vr": "CS", "Value": ["NONE"]},
        "2610": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2611": {"vr": "CS", "Value": ["NONE"]},
        "2612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2618": {"vr": "CS", "Value": ["NONE"]},
        "2619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2628": {"vr": "CS", "Value": ["NONE"]},
        "2629": {"vr": "CS", "Value": ["NONE"]},
        "2630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2636": {"vr": "CS", "Value": ["NONE"]},
        "2637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2639": {"vr": "CS", "Value": ["NONE"]},
        "2640": {"vr": "CS", "Value": ["NONE"]},
        "2641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2658": {"vr": "CS", "Value": ["NONE"]},
        "2659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2668": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2679": {"vr": "CS", "Value": ["NONE"]},
        "2680": {"vr": "CS", "Value": ["NONE"]},
        "2681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2687": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2702": {"vr": "CS", "Value": ["NONE"]},
        "2703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2726": {"vr": "CS", "Value": ["NONE"]},
        "2727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2736": {"vr": "CS", "Value": ["NONE"]},
        "2737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2741": {"vr": "CS", "Value": ["NONE"]},
        "2742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2746": {"vr": "CS", "Value": ["NONE"]},
        "2747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2750": {"vr": "CS", "Value": ["NONE"]},
        "2751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2757": {"vr": "CS", "Value": ["NONE"]},
        "2758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2765": {"vr": "CS", "Value": ["NONE"]},
        "2766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2770": {"vr": "CS", "Value": ["NONE"]},
        "2771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2777": {"vr": "CS", "Value": ["NONE"]},
        "2778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2781": {"vr": "CS", "Value": ["NONE"]},
        "2782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2788": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2792": {"vr": "CS", "Value": ["NONE"]},
        "2793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2797": {"vr": "CS", "Value": ["NONE"]},
        "2798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2805": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2818": {"vr": "CS", "Value": ["NONE"]},
        "2819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2822": {"vr": "CS", "Value": ["NONE"]},
        "2823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2827": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2830": {"vr": "CS", "Value": ["NONE"]},
        "2831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2845": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2852": {"vr": "CS", "Value": ["NONE"]},
        "2853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2855": {"vr": "CS", "Value": ["NONE"]},
        "2856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2862": {"vr": "CS", "Value": ["NONE"]},
        "2863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2878": {"vr": "CS", "Value": ["NONE"]},
        "2879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2882": {"vr": "CS", "Value": ["NONE"]},
        "2883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2885": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2906": {"vr": "CS", "Value": ["NONE"]},
        "2907": {"vr": "CS", "Value": ["NONE"]},
        "2908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2916": {"vr": "CS", "Value": ["NONE"]},
        "2917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2918": {"vr": "CS", "Value": ["NONE"]},
        "2919": {"vr": "CS", "Value": ["NONE"]},
        "2920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2923": {"vr": "CS", "Value": ["NONE"]},
        "2924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2930": {"vr": "CS", "Value": ["NONE"]},
        "2931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2935": {"vr": "CS", "Value": ["NONE"]},
        "2936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2946": {"vr": "CS", "Value": ["NONE"]},
        "2947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2949": {"vr": "CS", "Value": ["NONE"]},
        "2950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2954": {"vr": "CS", "Value": ["NONE"]},
        "2955": {"vr": "CS", "Value": ["NONE"]},
        "2956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2961": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2968": {"vr": "CS", "Value": ["NONE"]},
        "2969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2985": {"vr": "CS", "Value": ["NONE"]},
        "2986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2996": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3005": {"vr": "CS", "Value": ["NONE"]},
        "3006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3019": {"vr": "CS", "Value": ["NONE"]},
        "3020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3025": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3029": {"vr": "CS", "Value": ["NONE"]},
        "3030": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3032": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3039": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3053": {"vr": "CS", "Value": ["NONE"]},
        "3054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3060": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3064": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3065": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3072": {"vr": "CS", "Value": ["NONE"]},
        "3073": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3074": {"vr": "CS", "Value": ["NONE"]},
        "3075": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3077": {"vr": "CS", "Value": ["NONE"]},
        "3078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3079": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3081": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3082": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3083": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3084": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3086": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3088": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3089": {"vr": "CS", "Value": ["NONE"]},
        "3090": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3091": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3092": {"vr": "CS", "Value": ["NONE"]},
        "3093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3097": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3098": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3102": {"vr": "CS", "Value": ["NONE"]},
        "3103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3132": {"vr": "CS", "Value": ["NONE"]},
        "3133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3160": {"vr": "CS", "Value": ["NONE"]},
        "3161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3165": {"vr": "CS", "Value": ["NONE"]},
        "3166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3172": {"vr": "CS", "Value": ["NONE"]},
        "3173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3191": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3193": {"vr": "CS", "Value": ["NONE"]},
        "3194": {"vr": "CS", "Value": ["NONE"]},
        "3195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3214": {"vr": "CS", "Value": ["NONE"]},
        "3215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3218": {"vr": "CS", "Value": ["NONE"]},
        "3219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3220": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3230": {"vr": "CS", "Value": ["NONE"]},
        "3231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3243": {"vr": "CS", "Value": ["NONE"]},
        "3244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3256": {"vr": "CS", "Value": ["NONE"]},
        "3257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3258": {"vr": "CS", "Value": ["NONE"]},
        "3259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3264": {"vr": "CS", "Value": ["NONE"]},
        "3265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3270": {"vr": "CS", "Value": ["NONE"]},
        "3271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3280": {"vr": "CS", "Value": ["NONE"]},
        "3281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3291": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3313": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3315": {"vr": "CS", "Value": ["NONE"]},
        "3316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3328": {"vr": "CS", "Value": ["NONE"]},
        "3329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3343": {"vr": "CS", "Value": ["NONE"]},
        "3344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3347": {"vr": "CS", "Value": ["NONE"]},
        "3348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3365": {"vr": "CS", "Value": ["NONE"]},
        "3366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3376": {"vr": "CS", "Value": ["NONE"]},
        "3377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3381": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3382": {"vr": "CS", "Value": ["NONE"]},
        "3383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3384": {"vr": "CS", "Value": ["NONE"]},
        "3385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3389": {"vr": "CS", "Value": ["NONE"]},
        "3390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3405": {"vr": "CS", "Value": ["NONE"]},
        "3406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3417": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3418": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3431": {"vr": "CS", "Value": ["NONE"]},
        "3432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3436": {"vr": "CS", "Value": ["NONE"]},
        "3437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3446": {"vr": "CS", "Value": ["NONE"]},
        "3447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3454": {"vr": "CS", "Value": ["NONE"]},
        "3455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3474": {"vr": "CS", "Value": ["NONE"]},
        "3475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3481": {"vr": "CS", "Value": ["NONE"]},
        "3482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3492": {"vr": "CS", "Value": ["NONE"]},
        "3493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3498": {"vr": "CS", "Value": ["NONE"]},
        "3499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3501": {"vr": "CS", "Value": ["NONE"]},
        "3502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3503": {"vr": "CS", "Value": ["NONE"]},
        "3504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3511": {"vr": "CS", "Value": ["NONE"]},
        "3512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3515": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3520": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3521": {"vr": "CS", "Value": ["NONE"]},
        "3522": {"vr": "CS", "Value": ["NONE"]},
        "3523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3529": {"vr": "CS", "Value": ["NONE"]},
        "3530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3532": {"vr": "CS", "Value": ["NONE"]},
        "3533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3539": {"vr": "CS", "Value": ["NONE"]},
        "3540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3548": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3553": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3555": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3575": {"vr": "CS", "Value": ["NONE"]},
        "3576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3585": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3589": {"vr": "CS", "Value": ["NONE"]},
        "3590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3596": {"vr": "CS", "Value": ["NONE"]},
        "3597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3598": {"vr": "CS", "Value": ["NONE"]},
        "3599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3600": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3610": {"vr": "CS", "Value": ["NONE"]},
        "3611": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3614": {"vr": "CS", "Value": ["NONE"]},
        "3615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3628": {"vr": "CS", "Value": ["NONE"]},
        "3629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3636": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3638": {"vr": "CS", "Value": ["NONE"]},
        "3639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3640": {"vr": "CS", "Value": ["NONE"]},
        "3641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3653": {"vr": "CS", "Value": ["NONE"]},
        "3654": {"vr": "CS", "Value": ["NONE"]},
        "3655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3668": {"vr": "CS", "Value": ["NONE"]},
        "3669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3673": {"vr": "CS", "Value": ["NONE"]},
        "3674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3679": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3687": {"vr": "CS", "Value": ["NONE"]},
        "3688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3696": {"vr": "CS", "Value": ["NONE"]},
        "3697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3698": {"vr": "CS", "Value": ["NONE"]},
        "3699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3716": {"vr": "CS", "Value": ["NONE"]},
        "3717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3723": {"vr": "CS", "Value": ["NONE"]},
        "3724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3729": {"vr": "CS", "Value": ["NONE"]},
        "3730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3735": {"vr": "CS", "Value": ["NONE"]},
        "3736": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3742": {"vr": "CS", "Value": ["NONE"]},
        "3743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3744": {"vr": "CS", "Value": ["NONE"]},
        "3745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3756": {"vr": "CS", "Value": ["NONE"]},
        "3757": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3763": {"vr": "CS", "Value": ["NONE"]},
        "3764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3777": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3788": {"vr": "CS", "Value": ["NONE"]},
        "3789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3795": {"vr": "CS", "Value": ["NONE"]},
        "3796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3805": {"vr": "CS", "Value": ["NONE"]},
        "3806": {"vr": "CS", "Value": ["NONE"]},
        "3807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3825": {"vr": "CS", "Value": ["NONE"]},
        "3826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3827": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3832": {"vr": "CS", "Value": ["NONE"]},
        "3833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3845": {"vr": "CS", "Value": ["NONE"]},
        "3846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3855": {"vr": "CS", "Value": ["NONE"]},
        "3856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3863": {"vr": "CS", "Value": ["NONE"]},
        "3864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3878": {"vr": "CS", "Value": ["NONE"]},
        "3879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3882": {"vr": "CS", "Value": ["NONE"]},
        "3883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3885": {"vr": "CS", "Value": ["NONE"]},
        "3886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3900": {"vr": "CS", "Value": ["NONE"]},
        "3901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3916": {"vr": "CS", "Value": ["NONE"]},
        "3917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3918": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3919": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3928": {"vr": "CS", "Value": ["NONE"]},
        "3929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3937": {"vr": "CS", "Value": ["NONE"]},
        "3938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3945": {"vr": "CS", "Value": ["NONE"]},
        "3946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3949": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3961": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3968": {"vr": "CS", "Value": ["NONE"]},
        "3969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3996": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4009": {"vr": "CS", "Value": ["NONE"]},
        "4010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4011": {"vr": "CS", "Value": ["NONE"]},
        "4012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
    },
    "0019100E": {
        "0": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "4": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "5": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "6": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "7": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "8": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "9": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "10": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "11": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "12": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "15": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "16": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "17": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "18": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "19": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "20": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "21": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "22": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "23": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "24": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "25": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "26": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "27": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "28": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "29": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "30": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "32": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "33": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "36": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "37": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "38": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "39": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "41": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "42": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "43": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "44": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "45": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "46": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "47": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "48": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "49": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "50": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "51": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "52": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "53": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "54": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "55": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "56": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "57": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "58": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "59": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "62": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "63": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "64": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "65": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "66": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "67": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "69": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "70": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "71": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "72": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "73": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "74": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "75": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "76": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "77": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "78": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "79": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "81": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "82": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "83": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "84": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "85": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "86": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "87": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "88": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "89": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "92": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "93": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "94": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "95": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "96": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "97": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "98": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "99": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "100": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "101": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "102": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "103": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "104": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "105": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "106": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "107": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "108": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "109": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "110": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "111": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "113": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "115": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "116": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "117": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "118": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "119": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "120": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "121": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "122": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "123": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "124": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "125": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "126": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "127": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "129": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "130": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "131": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "132": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "133": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "134": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "135": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "136": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "137": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "138": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "139": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "140": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "141": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "142": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "143": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "144": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "145": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "146": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "147": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "148": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "149": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "150": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "151": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "152": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "153": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "154": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "155": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "156": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "157": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "158": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "159": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "161": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "162": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "163": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "164": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "165": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "166": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "167": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "168": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "169": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "170": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "171": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "172": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "173": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "174": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "175": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "176": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "177": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "178": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "179": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "180": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "181": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "182": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "183": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "184": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "185": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "186": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "187": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "188": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "189": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "190": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "192": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "193": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "194": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "195": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "196": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "197": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "199": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "200": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "201": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "202": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "203": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "204": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "205": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "206": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "207": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "208": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "209": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "211": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "212": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "213": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "214": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "215": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "216": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "217": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "218": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "219": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "220": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "221": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "222": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "223": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "224": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "225": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "226": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "228": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "229": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "230": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "231": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "232": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "233": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "234": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "235": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "236": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "237": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "238": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "239": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "240": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "241": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "242": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "244": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "245": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "247": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "248": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "249": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "250": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "251": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "252": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "253": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "254": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "255": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "257": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "258": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "259": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "260": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "261": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "262": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "263": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "264": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "265": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "266": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "267": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "268": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "269": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "271": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "272": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "273": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "274": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "276": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "277": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "278": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "279": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "280": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "281": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "282": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "283": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "284": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "285": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "286": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "287": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "288": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "289": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "291": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "292": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "293": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "294": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "295": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "296": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "297": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "298": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "299": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "300": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "302": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "303": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "304": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "305": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "306": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "307": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "308": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "309": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "310": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "312": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "314": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "315": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "317": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "318": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "319": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "320": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "321": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "322": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "323": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "324": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "325": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "326": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "327": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "328": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "329": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "330": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "331": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "332": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "333": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "334": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "335": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "336": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "337": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "338": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "339": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "340": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "341": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "342": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "343": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "344": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "345": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "346": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "347": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "348": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "351": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "352": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "353": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "354": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "355": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "356": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "357": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "358": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "359": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "360": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "362": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "364": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "365": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "366": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "367": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "369": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "370": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "371": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "372": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "373": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "374": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "375": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "376": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "377": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "378": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "379": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "380": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "381": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "382": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "385": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "386": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "387": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "388": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "389": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "390": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "391": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "392": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "393": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "394": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "395": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "397": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "398": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "400": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "401": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "402": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "403": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "404": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "405": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "406": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "407": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "408": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "409": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "410": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "411": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "412": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "413": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "414": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "415": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "416": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "417": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "419": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "420": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "421": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "422": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "423": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "425": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "426": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "427": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "428": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "429": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "430": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "431": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "432": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "433": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "434": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "435": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "436": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "437": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "438": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "439": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "440": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "441": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "442": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "443": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "444": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "446": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "447": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "449": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "450": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "451": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "452": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "453": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "454": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "455": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "456": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "457": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "458": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "459": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "460": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "461": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "462": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "463": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "464": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "465": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "466": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "467": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "468": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "470": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "471": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "472": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "473": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "474": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "476": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "477": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "478": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "479": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "480": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "481": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "482": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "484": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "485": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "486": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "487": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "488": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "489": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "490": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "491": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "492": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "493": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "494": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "495": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "496": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "498": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "499": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "500": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "502": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "503": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "504": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "505": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "506": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "508": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "509": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "510": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "511": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "512": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "513": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "516": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "517": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "518": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "519": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "521": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "522": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "523": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "524": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "525": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "526": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "527": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "528": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "529": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "530": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "532": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "533": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "534": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "535": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "536": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "537": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "538": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "540": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "541": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "543": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "545": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "546": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "547": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "549": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "550": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "551": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "552": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "556": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "557": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "558": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "559": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "560": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "561": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "562": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "563": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "564": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "565": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "566": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "568": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "569": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "570": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "571": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "572": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "573": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "574": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "575": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "576": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "577": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "578": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "579": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "580": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "581": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "582": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "583": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "584": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "586": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "588": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "589": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "590": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "591": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "592": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "593": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "594": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "595": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "596": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "597": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "598": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "599": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "601": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "602": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "603": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "604": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "605": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "606": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "607": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "608": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "609": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "610": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "612": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "613": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "614": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "615": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "616": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "617": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "618": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "619": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "620": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "621": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "622": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "623": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "625": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "626": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "627": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "628": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "629": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "630": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "631": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "632": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "633": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "634": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "635": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "637": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "638": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "639": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "640": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "641": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "642": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "643": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "644": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "645": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "646": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "647": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "648": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "649": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "650": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "651": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "652": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "653": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "654": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "655": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "656": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "657": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "658": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "659": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "660": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "661": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "662": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "664": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "665": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "666": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "667": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "669": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "670": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "671": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "672": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "673": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "674": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "675": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "676": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "677": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "678": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "680": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "681": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "682": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "683": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "684": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "685": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "686": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "688": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "689": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "691": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "692": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "693": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "694": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "695": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "696": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "697": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "698": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "700": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "701": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "702": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "703": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "704": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "705": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "706": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "708": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "709": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "710": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "711": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "712": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "713": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "716": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "717": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "718": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "719": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "720": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "721": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "722": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "723": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "724": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "725": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "726": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "727": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "728": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "729": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "730": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "731": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "733": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "734": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "735": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "736": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "737": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "738": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "739": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "740": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "741": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "742": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "743": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "744": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "745": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "746": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "747": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "748": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "749": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "750": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "751": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "752": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "753": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "754": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "755": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "756": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "758": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "759": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "760": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "761": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "762": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "763": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "764": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "765": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "766": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "767": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "768": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "769": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "770": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "772": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "773": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "774": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "775": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "776": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "778": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "779": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "780": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "781": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "782": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "783": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "784": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "785": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "786": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "787": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "789": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "790": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "792": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "793": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "794": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "795": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "796": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "797": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "798": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "799": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "800": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "801": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "802": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "803": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "804": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "805": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "806": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "807": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "808": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "809": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "811": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "812": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "813": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "814": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "815": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "817": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "818": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "819": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "821": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "822": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "823": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "824": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "825": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "826": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "828": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "830": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "831": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "832": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "833": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "834": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "835": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "836": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "837": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "838": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "839": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "840": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "841": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "842": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "843": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "844": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "845": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "847": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "848": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "849": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "851": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "852": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "853": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "854": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "855": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "856": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "857": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "858": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "859": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "860": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "862": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "863": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "864": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "865": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "866": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "869": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "871": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "872": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "873": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "874": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "876": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "877": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "878": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "879": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "880": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "881": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "882": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "883": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "884": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "886": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "887": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "888": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "889": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "890": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "891": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "892": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "893": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "894": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "895": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "896": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "897": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "898": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "899": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "900": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "901": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "902": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "903": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "904": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "905": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "906": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "907": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "908": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "909": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "910": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "911": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "912": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "913": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "914": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "915": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "916": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "917": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "918": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "920": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "921": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "922": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "923": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "925": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "927": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "928": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "929": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "930": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "931": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "933": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "934": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "935": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "937": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "938": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "939": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "940": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "941": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "942": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "943": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "944": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "945": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "946": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "947": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "949": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "950": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "951": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "952": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "953": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "954": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "955": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "957": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "958": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "959": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "960": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "962": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "963": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "964": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "965": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "966": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "967": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "968": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "969": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "970": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "971": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "972": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "973": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "974": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "975": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "976": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "977": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "979": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "980": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "981": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "982": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "984": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "985": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "986": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "987": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "988": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "989": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "990": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "991": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "992": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "993": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "994": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "995": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "997": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "998": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "999": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1000": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1001": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1002": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1003": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1004": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1005": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1006": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1007": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1008": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1009": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1010": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1011": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1012": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1013": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1014": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1017": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1018": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1019": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1020": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1021": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1022": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1023": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1024": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1025": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1026": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1027": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1028": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1029": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1031": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1033": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1034": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1035": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1036": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1037": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1038": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1040": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1041": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1042": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1043": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1044": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1045": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1046": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1047": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1048": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1049": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1050": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1051": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1052": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1053": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1054": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1055": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1056": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1057": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1058": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1059": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1061": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1062": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1063": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1064": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1066": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1067": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1068": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1069": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1070": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1071": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1072": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1074": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1075": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1076": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1077": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1078": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1079": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1080": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1082": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1083": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1084": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1085": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1086": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1087": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1089": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1092": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1093": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1094": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1095": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1096": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1098": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1099": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1100": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1101": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1102": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1103": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1104": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1106": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1107": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1108": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1109": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1111": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1112": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1113": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1114": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1115": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1116": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1117": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1118": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1119": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1120": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1121": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1122": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1123": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1124": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1125": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1126": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1127": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1128": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1129": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1130": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1132": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1133": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1134": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1135": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1137": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1138": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1139": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1140": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1141": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1142": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1143": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1144": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1145": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1146": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1150": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1151": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1152": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1153": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1154": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1155": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1156": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1157": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1158": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1159": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1160": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1161": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1162": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1163": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1164": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1167": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1168": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1169": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1170": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1171": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1172": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1173": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1174": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1175": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1176": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1177": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1179": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1180": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1181": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1182": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1183": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1184": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1185": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1186": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1187": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1188": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1190": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1192": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1194": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1195": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1196": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1197": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1198": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1199": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1200": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1203": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1204": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1205": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1206": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1207": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1208": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1209": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1210": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1211": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1212": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1213": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1214": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1215": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1216": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1217": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1218": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1221": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1222": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1223": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1224": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1225": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1226": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1227": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1228": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1229": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1230": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1231": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1232": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1233": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1234": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1235": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1236": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1237": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1238": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1239": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1240": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1241": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1242": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1243": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1244": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1245": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1246": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1247": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1248": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1249": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1250": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1251": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1252": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1253": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1254": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1255": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1256": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1257": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1258": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1259": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1261": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1262": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1263": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1265": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1266": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1267": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1268": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1269": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1270": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1272": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1273": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1274": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1275": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1276": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1277": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1278": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1279": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1280": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1281": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1283": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1284": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1285": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1286": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1287": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1288": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1289": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1290": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1292": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1293": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1294": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1295": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1296": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1297": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1298": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1299": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1301": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1302": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1303": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1304": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1305": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1306": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1307": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1308": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1310": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1311": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1312": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1313": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1314": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1315": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1316": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1317": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1318": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1319": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1320": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1321": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1322": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1323": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1325": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1327": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1328": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1329": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1331": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1332": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1334": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1335": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1336": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1337": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1338": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1339": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1340": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1341": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1342": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1343": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1344": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1345": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1346": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1348": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1349": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1350": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1351": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1352": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1353": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1354": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1355": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1356": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1357": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1359": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1360": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1361": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1362": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1363": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1364": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1365": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1366": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1367": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1368": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1369": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1370": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1371": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1372": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1373": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1374": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1376": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1377": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1378": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1379": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1380": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1382": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1383": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1384": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1385": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1386": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1387": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1388": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1389": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1390": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1391": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1392": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1393": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1394": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1395": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1396": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1397": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1398": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1399": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1400": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1401": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1402": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1403": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1405": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1406": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1407": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1408": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1409": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1410": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1411": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1412": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1414": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1415": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1416": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1418": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1419": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1420": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1421": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1422": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1423": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1424": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1425": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1426": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1427": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1428": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1429": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1431": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1432": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1433": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1434": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1435": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1436": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1437": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1438": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1439": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1440": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1441": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1443": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1444": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1445": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1446": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1447": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1448": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1450": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1451": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1452": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1453": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1454": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1456": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1457": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1458": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1459": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1462": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1463": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1464": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1465": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1466": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1467": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1468": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1469": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1470": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1471": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1472": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1473": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1475": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1476": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1477": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1478": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1479": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1480": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1481": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1482": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1483": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1484": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1485": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1486": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1487": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1489": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1490": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1491": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1492": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1494": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1495": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1496": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1497": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1498": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1499": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1500": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1501": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1502": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1503": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1504": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1505": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1506": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1507": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1508": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1509": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1510": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1511": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1513": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1514": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1516": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1518": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1519": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1520": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1521": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1522": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1523": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1524": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1525": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1526": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1527": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1528": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1529": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1530": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1531": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1532": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1533": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1534": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1535": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1537": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1538": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1539": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1540": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1541": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1542": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1543": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1544": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1545": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1546": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1547": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1548": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1549": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1550": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1551": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1552": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1554": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1556": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1557": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1558": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1560": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1561": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1563": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1564": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1565": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1566": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1567": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1568": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1569": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1570": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1571": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1572": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1573": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1575": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1576": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1577": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1578": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1579": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1580": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1581": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1582": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1583": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1584": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1585": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1586": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1587": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1588": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1589": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1591": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1592": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1593": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1595": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1596": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1597": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1598": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1599": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1602": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1605": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1606": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1607": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1608": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1609": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1611": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1612": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1613": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1614": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1615": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1616": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1617": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1618": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1619": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1620": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1621": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1622": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1623": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1624": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1626": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1627": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1628": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1629": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1630": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1631": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1632": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1633": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1634": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1635": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1636": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1637": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1638": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1639": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1640": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1641": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1642": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1645": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1646": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1647": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1648": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1650": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1651": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1652": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1653": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1654": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1655": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1656": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1657": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1658": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1659": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1660": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1661": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1662": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1663": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1664": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1665": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1666": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1667": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1668": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1669": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1670": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1671": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1672": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1673": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1674": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1675": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1676": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1677": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1678": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1679": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1680": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1681": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1682": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1683": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1684": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1685": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1686": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1687": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1688": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1690": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1692": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1693": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1694": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1695": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1696": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1697": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1698": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1699": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1701": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1702": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1703": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1704": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1705": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1706": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1707": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1708": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1709": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1710": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1711": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1712": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1713": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1714": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1715": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1716": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1718": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1719": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1721": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1722": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1723": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1724": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1725": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1726": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1727": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1728": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1729": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1730": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1731": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1732": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1733": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1734": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1735": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1737": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1739": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1740": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1741": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1742": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1743": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1744": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1745": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1746": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1747": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1748": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1749": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1750": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1751": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1752": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1753": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1754": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1755": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1756": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1757": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1758": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1759": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1760": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1761": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1762": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1763": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1764": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1765": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1766": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1767": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1768": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1769": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1770": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1771": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1772": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1773": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1774": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1776": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1777": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1778": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1779": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1780": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1781": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1782": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1783": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1784": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1785": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1786": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1787": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1788": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1789": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1790": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1791": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1792": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1793": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1794": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1795": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1797": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1798": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1799": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1800": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1801": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1803": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1804": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1806": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1807": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1808": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1809": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1810": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1811": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1812": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1813": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1814": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1815": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1816": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1817": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1818": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1819": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1820": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1821": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1822": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1823": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1824": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1825": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1826": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1828": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1829": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1830": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1831": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1832": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1833": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1834": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1835": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1836": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1839": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1840": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1841": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1842": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1843": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1844": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1846": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1847": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1848": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1849": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1850": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1851": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1852": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1853": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1854": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1855": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1856": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1857": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1858": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1859": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1860": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1861": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1862": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1863": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1864": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1865": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1866": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1867": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1868": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1869": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1870": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1871": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1874": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1875": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1876": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1877": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1878": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1879": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1880": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1881": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1882": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1883": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1884": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1885": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1886": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1887": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1888": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1890": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1891": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1892": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1893": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1894": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1895": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1896": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1897": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1898": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1899": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1900": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1901": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1902": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1903": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1904": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1905": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1906": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1907": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1908": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1910": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1911": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1912": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1913": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1917": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1919": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1921": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1922": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1923": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1924": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1925": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1926": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1927": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1928": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1929": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1930": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1931": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1932": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1934": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1935": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1936": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1937": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1938": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1939": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1940": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1941": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1942": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1943": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1944": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1945": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1946": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1947": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1948": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1950": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1951": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1952": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1953": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1954": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1955": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1956": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1957": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1958": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1959": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1960": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1962": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1963": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1964": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1965": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1966": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1968": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1969": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1970": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1971": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1972": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1974": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1975": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1976": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1977": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1978": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1979": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1980": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1981": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1982": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1983": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1984": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1985": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1987": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1988": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1989": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1990": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1991": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1992": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1994": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1995": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1997": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1998": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1999": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2000": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2002": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2003": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2004": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2005": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2006": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2007": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2008": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2009": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2010": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2011": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2013": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2014": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2015": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2016": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2018": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2019": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2020": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2021": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2022": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2023": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2024": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2026": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2027": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2028": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2030": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2031": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2032": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2033": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2034": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2035": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2036": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2037": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2038": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2039": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2040": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2041": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2042": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2043": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2044": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2045": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2046": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2047": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2048": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2049": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2050": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2051": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2052": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2053": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2054": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2055": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2056": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2057": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2058": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2059": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2060": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2061": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2062": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2063": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2065": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2066": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2067": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2068": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2069": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2070": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2071": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2072": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2073": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2074": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2076": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2077": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2078": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2080": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2081": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2085": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2087": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2088": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2089": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2090": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2091": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2092": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2093": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2094": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2095": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2096": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2097": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2099": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2100": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2101": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2102": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2103": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2104": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2105": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2106": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2107": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2108": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2110": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2111": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2112": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2113": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2114": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2115": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2116": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2117": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2118": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2119": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2120": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2121": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2122": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2123": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2124": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2125": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2126": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2127": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2128": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2129": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2130": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2131": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2133": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2134": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2135": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2136": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2137": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2138": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2139": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2140": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2141": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2142": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2143": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2144": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2145": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2147": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2148": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2149": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2150": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2151": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2152": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2153": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2154": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2155": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2156": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2157": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2159": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2160": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2161": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2162": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2163": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2164": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2166": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2167": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2168": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2169": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2171": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2172": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2173": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2175": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2176": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2177": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2178": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2179": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2180": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2181": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2182": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2183": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2184": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2185": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2186": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2188": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2189": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2190": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2191": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2193": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2194": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2195": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2196": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2197": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2198": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2199": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2200": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2201": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2202": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2203": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2205": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2206": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2207": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2208": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2209": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2210": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2211": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2212": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2213": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2214": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2215": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2216": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2217": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2218": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2219": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2221": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2222": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2223": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2224": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2225": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2226": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2227": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2228": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2229": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2230": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2231": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2232": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2233": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2234": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2235": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2236": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2237": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2238": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2240": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2241": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2242": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2243": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2244": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2245": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2246": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2247": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2248": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2249": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2250": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2251": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2252": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2253": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2255": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2256": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2257": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2258": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2260": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2261": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2262": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2264": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2265": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2266": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2267": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2268": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2269": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2270": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2271": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2272": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2273": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2274": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2275": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2276": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2277": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2279": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2280": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2281": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2282": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2283": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2284": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2285": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2286": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2288": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2289": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2290": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2292": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2293": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2294": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2297": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2298": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2299": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2300": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2301": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2302": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2303": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2304": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2305": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2306": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2307": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2308": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2309": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2310": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2311": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2312": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2314": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2315": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2316": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2317": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2318": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2319": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2320": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2321": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2322": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2323": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2324": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2325": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2326": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2327": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2328": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2329": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2330": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2331": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2332": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2333": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2334": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2335": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2336": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2337": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2338": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2339": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2341": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2342": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2343": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2344": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2345": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2347": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2348": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2349": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2350": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2351": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2352": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2353": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2354": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2355": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2356": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2357": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2358": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2361": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2362": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2363": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2364": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2365": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2366": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2367": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2368": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2370": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2371": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2372": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2373": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2374": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2375": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2377": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2378": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2379": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2380": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2383": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2384": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2386": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2387": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2388": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2389": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2390": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2391": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2392": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2393": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2395": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2396": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2397": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2398": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2399": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2401": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2402": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2403": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2404": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2405": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2406": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2407": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2408": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2409": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2410": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2411": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2412": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2413": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2414": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2415": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2416": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2419": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2420": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2421": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2422": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2423": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2424": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2425": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2426": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2427": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2428": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2429": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2430": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2431": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2432": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2434": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2435": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2436": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2437": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2438": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2439": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2440": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2441": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2442": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2443": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2444": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2445": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2446": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2447": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2448": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2449": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2450": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2451": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2452": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2453": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2454": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2455": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2456": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2457": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2458": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2459": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2460": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2461": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2462": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2463": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2464": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2465": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2466": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2467": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2468": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2469": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2470": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2471": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2472": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2473": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2474": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2475": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2476": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2477": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2478": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2481": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2482": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2483": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2484": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2485": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2486": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2487": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2488": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2489": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2490": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2491": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2492": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2493": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2494": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2495": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2496": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2497": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2498": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2499": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2500": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2501": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2502": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2503": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2504": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2505": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2506": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2507": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2508": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2509": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2510": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2511": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2512": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2513": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2514": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2515": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2516": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2517": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2518": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2519": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2521": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2523": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2524": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2526": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2527": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2528": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2529": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2530": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2531": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2532": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2533": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2535": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2536": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2538": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2540": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2541": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2542": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2543": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2544": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2545": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2547": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2549": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2550": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2551": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2552": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2553": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2554": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2555": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2556": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2558": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2559": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2560": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2561": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2562": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2563": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2564": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2565": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2566": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2567": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2568": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2569": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2570": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2573": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2574": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2575": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2576": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2577": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2578": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2579": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2580": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2581": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2582": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2583": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2586": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2587": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2588": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2589": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2590": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2591": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2592": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2593": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2594": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2595": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2596": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2597": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2598": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2599": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2600": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2601": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2602": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2603": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2604": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2605": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2606": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2607": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2608": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2610": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2612": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2613": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2614": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2615": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2616": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2617": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2619": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2620": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2621": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2622": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2623": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2624": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2625": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2626": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2627": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2630": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2631": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2632": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2633": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2634": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2635": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2637": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2638": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2641": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2642": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2643": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2644": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2645": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2646": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2647": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2648": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2649": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2650": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2651": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2652": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2653": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2654": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2655": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2656": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2657": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2659": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2660": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2661": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2662": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2663": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2664": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2665": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2666": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2667": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2668": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2669": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2670": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2671": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2672": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2673": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2674": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2675": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2676": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2677": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2678": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2681": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2682": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2683": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2684": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2685": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2686": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2687": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2688": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2689": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2690": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2691": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2692": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2693": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2694": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2695": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2696": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2697": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2698": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2699": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2700": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2701": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2703": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2704": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2705": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2706": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2707": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2708": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2709": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2710": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2711": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2712": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2713": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2714": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2715": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2716": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2717": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2718": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2719": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2720": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2721": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2722": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2723": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2724": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2725": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2727": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2728": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2729": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2730": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2731": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2732": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2733": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2734": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2735": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2737": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2738": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2739": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2740": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2742": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2743": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2744": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2745": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2747": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2748": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2749": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2751": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2752": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2753": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2754": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2755": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2756": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2758": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2759": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2760": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2761": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2762": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2763": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2764": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2766": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2767": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2768": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2769": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2771": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2772": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2773": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2774": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2775": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2776": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2778": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2779": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2780": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2782": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2783": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2784": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2785": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2786": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2787": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2788": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2789": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2790": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2791": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2793": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2794": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2795": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2796": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2798": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2799": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2800": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2801": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2802": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2803": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2804": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2805": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2806": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2807": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2808": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2809": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2810": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2811": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2812": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2813": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2814": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2815": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2816": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2817": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2819": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2820": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2821": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2823": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2824": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2825": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2826": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2827": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2828": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2829": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2831": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2832": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2833": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2834": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2835": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2836": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2837": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2838": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2839": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2840": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2841": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2842": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2843": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2844": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2845": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2846": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2847": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2848": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2849": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2850": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2851": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2853": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2854": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2856": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2857": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2858": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2859": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2860": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2861": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2863": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2864": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2865": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2866": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2867": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2868": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2869": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2870": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2871": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2872": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2873": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2874": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2875": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2876": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2877": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2879": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2880": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2881": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2883": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2884": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2885": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2886": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2887": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2888": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2889": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2890": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2891": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2892": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2893": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2894": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2895": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2896": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2897": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2898": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2899": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2900": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2901": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2902": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2903": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2904": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2905": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2908": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2909": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2910": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2911": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2912": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2913": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2914": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2915": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2917": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2920": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2921": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2922": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2924": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2925": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2926": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2927": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2928": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2929": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2931": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2932": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2933": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2934": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2936": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2937": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2938": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2939": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2940": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2941": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2942": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2943": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2944": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2945": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2947": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2948": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2950": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2951": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2952": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2953": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2956": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2957": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2958": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2959": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2960": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2961": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2962": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2963": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2964": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2965": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2966": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2967": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2969": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2970": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2971": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2972": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2973": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2974": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2975": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2976": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2977": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2978": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2979": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2980": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2981": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2982": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2983": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2984": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2986": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2987": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2988": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2989": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2990": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2991": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2992": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2993": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2994": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2995": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2996": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2997": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2998": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2999": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3000": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3001": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3002": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3003": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3004": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3006": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3007": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3008": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3009": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3010": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3011": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3012": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3013": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3014": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3015": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3016": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3017": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3018": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3020": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3021": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3022": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3023": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3024": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3025": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3026": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3027": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3028": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3030": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3031": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3032": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3033": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3034": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3035": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3036": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3037": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3038": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3039": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3040": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3041": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3042": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3043": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3044": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3045": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3046": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3047": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3048": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3049": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3050": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3051": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3052": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3054": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3055": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3056": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3057": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3058": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3059": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3060": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3061": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3062": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3063": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3064": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3065": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3066": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3067": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3068": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3069": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3070": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3071": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3073": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3075": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3076": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3078": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3079": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3080": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3081": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3082": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3083": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3084": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3085": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3086": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3087": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3088": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3090": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3091": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3093": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3094": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3095": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3096": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3097": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3098": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3099": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3100": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3101": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3103": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3104": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3105": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3106": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3107": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3108": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3109": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3110": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3111": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3112": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3113": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3114": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3115": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3116": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3117": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3118": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3119": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3120": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3121": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3122": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3123": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3124": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3125": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3126": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3127": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3128": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3129": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3130": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3131": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3133": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3134": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3135": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3136": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3137": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3138": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3139": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3140": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3141": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3142": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3143": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3144": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3145": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3146": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3147": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3148": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3149": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3150": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3151": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3152": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3153": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3154": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3155": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3156": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3157": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3158": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3159": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3161": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3162": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3163": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3164": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3166": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3167": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3168": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3169": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3170": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3171": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3173": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3174": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3175": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3176": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3177": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3178": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3179": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3180": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3181": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3182": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3183": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3184": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3185": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3186": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3187": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3188": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3189": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3190": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3191": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3192": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3195": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3196": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3197": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3198": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3199": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3200": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3201": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3202": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3203": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3204": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3205": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3206": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3207": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3208": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3209": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3210": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3211": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3212": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3213": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3215": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3216": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3217": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3219": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3220": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3221": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3222": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3223": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3224": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3225": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3226": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3227": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3228": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3229": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3231": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3232": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3233": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3234": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3235": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3236": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3237": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3238": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3239": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3240": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3241": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3242": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3244": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3245": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3246": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3247": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3248": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3249": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3250": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3251": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3252": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3253": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3254": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3255": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3257": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3259": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3260": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3261": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3262": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3263": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3265": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3266": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3267": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3268": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3269": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3271": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3272": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3273": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3274": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3275": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3276": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3277": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3278": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3279": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3281": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3282": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3283": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3284": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3285": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3286": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3287": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3288": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3289": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3290": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3291": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3292": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3293": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3294": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3295": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3296": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3297": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3298": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3299": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3300": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3301": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3302": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3303": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3304": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3305": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3306": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3307": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3308": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3309": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3310": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3311": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3312": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3313": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3314": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3316": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3317": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3318": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3319": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3320": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3321": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3322": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3323": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3324": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3325": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3326": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3327": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3329": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3330": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3331": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3332": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3333": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3334": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3335": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3336": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3337": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3338": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3339": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3340": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3341": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3342": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3344": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3345": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3346": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3348": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3349": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3350": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3351": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3352": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3353": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3354": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3355": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3356": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3357": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3358": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3359": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3360": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3361": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3362": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3363": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3364": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3366": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3367": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3368": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3369": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3370": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3371": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3372": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3373": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3374": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3375": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3377": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3378": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3379": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3380": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3381": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3383": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3385": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3386": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3387": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3388": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3390": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3391": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3392": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3393": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3394": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3395": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3396": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3397": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3398": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3399": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3400": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3401": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3402": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3403": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3404": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3406": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3407": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3408": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3409": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3410": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3411": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3412": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3413": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3414": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3415": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3416": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3417": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3418": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3419": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3420": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3421": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3422": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3423": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3424": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3425": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3426": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3427": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3428": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3429": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3430": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3432": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3433": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3434": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3435": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3437": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3438": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3439": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3440": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3441": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3442": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3443": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3444": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3445": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3447": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3448": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3449": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3450": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3451": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3452": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3453": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3455": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3456": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3457": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3458": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3459": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3460": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3461": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3462": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3463": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3464": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3465": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3466": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3467": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3468": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3469": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3470": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3471": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3472": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3473": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3475": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3476": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3477": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3478": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3479": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3480": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3482": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3483": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3484": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3485": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3486": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3487": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3488": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3489": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3490": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3491": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3493": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3494": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3495": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3496": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3497": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3499": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3500": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3502": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3504": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3505": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3506": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3507": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3508": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3509": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3510": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3512": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3513": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3514": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3515": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3516": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3517": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3518": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3519": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3520": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3523": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3524": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3525": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3526": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3527": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3528": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3530": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3531": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3533": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3534": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3535": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3536": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3537": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3538": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3540": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3541": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3542": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3543": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3544": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3545": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3546": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3547": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3548": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3549": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3550": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3551": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3552": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3553": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3554": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3555": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3556": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3557": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3558": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3559": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3560": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3561": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3562": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3563": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3564": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3565": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3566": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3567": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3568": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3569": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3570": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3571": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3572": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3573": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3574": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3576": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3577": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3578": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3579": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3580": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3581": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3582": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3583": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3584": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3585": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3586": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3587": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3588": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3590": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3591": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3592": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3593": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3594": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3595": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3597": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3599": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3600": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3601": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3602": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3603": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3604": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3605": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3606": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3607": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3608": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3609": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3611": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3612": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3613": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3615": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3616": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3617": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3618": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3619": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3620": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3621": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3622": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3623": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3624": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3625": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3626": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3627": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3629": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3630": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3631": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3632": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3633": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3634": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3635": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3636": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3637": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3639": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3641": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3642": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3643": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3644": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3645": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3646": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3647": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3648": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3649": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3650": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3651": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3652": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3655": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3656": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3657": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3658": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3659": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3660": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3661": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3662": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3663": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3664": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3665": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3666": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3667": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3669": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3670": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3671": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3672": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3674": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3675": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3676": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3677": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3678": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3679": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3680": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3681": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3682": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3683": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3684": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3685": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3686": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3688": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3689": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3690": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3691": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3692": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3693": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3694": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3695": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3697": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3699": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3700": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3701": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3702": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3703": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3704": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3705": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3706": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3707": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3708": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3709": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3710": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3711": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3712": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3713": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3714": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3715": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3717": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3718": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3719": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3720": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3721": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3722": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3724": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3725": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3726": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3727": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3728": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3730": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3731": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3732": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3733": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3734": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3736": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3737": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3738": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3739": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3740": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3741": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3743": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3745": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3746": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3747": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3748": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3749": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3750": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3751": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3752": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3753": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3754": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3755": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3757": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3758": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3759": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3760": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3761": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3762": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3764": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3765": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3766": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3767": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3768": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3769": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3770": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3771": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3772": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3773": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3774": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3775": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3776": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3777": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3778": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3779": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3780": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3781": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3782": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3783": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3784": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3785": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3786": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3787": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3789": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3790": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3791": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3792": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3793": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3794": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3796": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3797": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3798": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3799": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3800": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3801": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3802": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3803": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3804": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3807": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3808": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3809": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3810": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3811": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3812": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3813": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3814": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3815": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3816": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3817": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3818": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3819": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3820": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3821": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3822": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3823": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3824": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3826": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3827": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3828": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3829": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3830": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3831": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3833": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3834": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3835": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3836": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3837": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3838": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3839": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3840": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3841": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3842": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3843": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3844": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3846": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3847": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3848": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3849": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3850": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3851": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3852": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3853": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3854": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3856": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3857": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3858": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3859": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3860": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3861": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3862": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3864": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3865": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3866": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3867": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3868": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3869": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3870": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3871": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3872": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3873": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3874": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3875": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3876": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3877": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3879": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3880": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3881": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3883": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3884": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3886": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3887": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3888": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3889": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3890": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3891": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3892": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3893": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3894": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3895": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3896": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3897": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3898": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3899": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3901": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3902": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3903": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3904": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3905": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3906": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3907": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3908": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3909": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3910": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3911": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3912": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3913": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3914": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3915": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3917": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3918": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3919": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3920": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3921": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3922": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3923": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3924": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3925": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3926": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3927": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3929": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3930": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3931": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3932": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3933": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3934": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3935": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3936": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3938": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3939": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3940": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3941": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3942": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3943": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3944": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3946": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3947": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3948": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3949": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3950": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3951": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3952": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3953": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3954": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3955": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3956": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3957": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3958": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3959": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3960": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3961": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3962": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3963": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3964": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3965": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3966": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3967": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3969": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3970": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3971": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3972": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3973": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3974": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3975": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3976": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3977": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3978": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3979": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3980": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3981": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3982": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3983": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3984": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3985": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3986": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3987": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3988": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3989": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3990": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3991": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3992": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3993": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3994": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3995": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3996": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3997": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3998": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3999": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "4000": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "4001": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "4002": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "4003": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "4004": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "4005": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "4006": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "4007": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "4008": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "4010": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "4012": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "4013": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "4014": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "4015": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "4016": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "4017": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "4018": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "4019": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
    },
    "00191015": {
        "0": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "4": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "5": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "6": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "7": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "8": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "9": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "10": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "11": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "12": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "13": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "14": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "15": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "16": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "17": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "18": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "19": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "20": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "21": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "22": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "23": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "24": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "25": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "26": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "27": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "28": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "29": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "30": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "31": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "32": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "33": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "34": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "35": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "36": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "37": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "38": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "39": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "40": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "41": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "42": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "43": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "44": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "45": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "46": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "47": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "48": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "49": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "50": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "51": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "52": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "53": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "54": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "55": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "56": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "57": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "58": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "59": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "60": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "61": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "62": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "63": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "64": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "65": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "66": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "67": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "68": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "69": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "70": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "71": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "72": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "73": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "74": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "75": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "76": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "77": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "78": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "79": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "80": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "81": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "82": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "83": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "84": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "85": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "86": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "87": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "88": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "89": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "90": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "91": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "92": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "93": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "94": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "95": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "96": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "97": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "98": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "99": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "100": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "101": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "102": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "103": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "104": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "105": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "106": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "107": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "108": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "109": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "110": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "111": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "112": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "113": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "114": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "115": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "116": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "117": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "118": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "119": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "120": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "121": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "122": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "123": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "124": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "125": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "126": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "127": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "128": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "129": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "130": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "131": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "132": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "133": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "134": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "135": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "136": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "137": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "138": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "139": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "140": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "141": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "142": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "143": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "144": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "145": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "146": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "147": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "148": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "149": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "150": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "151": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "152": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "153": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "154": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "155": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "156": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "157": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "158": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "159": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "160": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "161": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "162": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "163": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "164": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "165": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "166": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "167": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "168": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "169": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "170": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "171": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "172": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "173": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "174": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "175": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "176": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "177": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "178": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "179": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "180": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "181": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "182": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "183": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "184": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "185": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "186": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "187": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "188": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "189": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "190": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "191": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "192": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "193": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "194": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "195": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "196": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "197": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "198": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "199": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "200": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "201": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "202": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "203": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "204": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "205": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "206": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "207": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "208": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "209": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "210": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "211": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "212": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "213": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "214": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "215": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "216": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "217": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "218": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "219": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "220": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "221": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "222": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "223": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "224": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "225": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "226": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "227": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "228": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "229": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "230": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "231": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "232": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "233": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "234": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "235": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "236": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "237": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "238": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "239": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "240": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "241": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "242": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "243": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "244": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "245": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "246": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "247": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "248": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "249": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "250": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "251": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "252": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "253": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "254": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "255": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "256": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "257": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "258": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "259": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "260": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "261": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "262": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "263": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "264": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "265": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "266": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "267": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "268": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "269": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "270": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "271": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "272": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "273": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "274": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "275": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "276": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "277": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "278": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "279": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "280": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "281": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "282": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "283": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "284": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "285": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "286": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "287": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "288": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "289": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "290": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "291": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "292": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "293": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "294": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "295": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "296": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "297": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "298": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "299": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "300": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "301": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "302": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "303": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "304": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "305": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "306": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "307": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "308": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "309": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "310": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "311": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "312": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "313": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "314": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "315": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "316": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "317": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "318": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "319": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "320": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "321": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "322": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "323": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "324": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "325": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "326": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "327": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "328": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "329": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "330": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "331": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "332": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "333": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "334": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "335": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "336": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "337": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "338": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "339": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "340": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "341": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "342": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "343": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "344": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "345": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "346": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "347": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "348": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "349": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "350": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "351": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "352": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "353": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "354": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "355": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "356": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "357": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "358": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "359": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "360": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "361": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "362": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "363": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "364": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "365": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "366": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "367": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "368": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "369": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "370": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "371": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "372": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "373": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "374": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "375": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "376": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "377": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "378": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "379": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "380": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "381": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "382": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "383": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "384": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "385": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "386": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "387": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "388": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "389": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "390": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "391": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "392": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "393": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "394": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "395": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "396": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "397": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "398": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "399": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "400": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "401": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "402": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "403": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "404": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "405": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "406": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "407": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "408": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "409": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "410": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "411": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "412": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "413": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "414": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "415": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "416": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "417": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "418": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "419": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "420": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "421": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "422": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "423": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "424": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "425": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "426": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "427": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "428": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "429": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "430": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "431": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "432": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "433": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "434": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "435": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "436": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "437": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "438": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "439": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "440": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "441": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "442": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "443": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "444": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "445": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "446": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "447": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "448": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "449": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "450": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "451": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "452": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "453": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "454": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "455": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "456": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "457": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "458": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "459": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "460": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "461": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "462": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "463": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "464": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "465": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "466": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "467": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "468": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "469": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "470": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "471": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "472": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "473": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "474": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "475": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "476": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "477": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "478": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "479": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "480": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "481": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "482": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "483": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "484": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "485": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "486": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "487": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "488": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "489": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "490": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "491": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "492": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "493": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "494": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "495": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "496": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "497": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "498": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "499": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "500": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "501": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "502": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "503": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "504": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "505": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "506": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "507": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "508": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "509": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "510": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "511": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "512": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "513": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "514": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "515": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "516": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "517": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "518": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "519": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "520": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "521": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "522": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "523": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "524": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "525": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "526": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "527": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "528": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "529": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "530": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "531": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "532": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "533": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "534": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "535": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "536": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "537": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "538": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "539": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "540": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "541": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "542": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "543": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "544": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "545": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "546": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "547": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "548": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "549": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "550": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "551": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "552": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "553": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "554": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "555": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "556": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "557": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "558": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "559": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "560": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "561": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "562": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "563": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "564": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "565": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "566": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "567": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "568": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "569": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "570": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "571": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "572": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "573": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "574": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "575": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "576": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "577": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "578": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "579": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "580": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "581": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "582": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "583": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "584": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "585": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "586": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "587": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "588": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "589": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "590": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "591": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "592": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "593": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "594": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "595": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "596": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "597": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "598": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "599": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "600": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "601": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "602": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "603": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "604": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "605": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "606": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "607": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "608": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "609": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "610": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "611": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "612": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "613": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "614": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "615": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "616": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "617": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "618": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "619": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "620": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "621": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "622": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "623": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "624": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "625": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "626": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "627": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "628": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "629": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "630": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "631": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "632": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "633": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "634": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "635": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "636": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "637": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "638": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "639": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "640": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "641": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "642": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "643": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "644": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "645": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "646": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "647": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "648": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "649": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "650": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "651": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "652": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "653": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "654": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "655": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "656": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "657": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "658": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "659": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "660": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "661": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "662": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "663": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "664": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "665": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "666": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "667": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "668": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "669": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "670": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "671": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "672": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "673": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "674": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "675": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "676": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "677": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "678": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "679": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "680": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "681": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "682": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "683": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "684": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "685": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "686": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "687": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "688": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "689": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "690": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "691": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "692": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "693": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "694": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "695": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "696": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "697": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "698": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "699": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "700": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "701": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "702": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "703": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "704": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "705": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "706": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "707": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "708": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "709": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "710": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "711": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "712": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "713": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "714": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "715": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "716": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "717": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "718": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "719": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "720": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "721": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "722": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "723": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "724": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "725": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "726": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "727": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "728": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "729": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "730": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "731": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "732": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "733": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "734": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "735": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "736": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "737": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "738": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "739": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "740": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "741": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "742": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "743": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "744": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "745": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "746": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "747": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "748": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "749": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "750": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "751": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "752": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "753": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "754": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "755": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "756": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "757": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "758": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "759": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "760": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "761": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "762": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "763": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "764": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "765": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "766": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "767": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "768": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "769": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "770": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "771": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "772": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "773": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "774": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "775": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "776": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "777": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "778": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "779": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "780": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "781": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "782": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "783": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "784": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "785": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "786": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "787": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "788": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "789": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "790": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "791": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "792": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "793": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "794": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "795": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "796": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "797": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "798": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "799": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "800": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "801": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "802": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "803": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "804": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "805": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "806": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "807": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "808": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "809": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "810": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "811": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "812": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "813": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "814": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "815": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "816": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "817": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "818": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "819": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "820": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "821": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "822": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "823": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "824": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "825": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "826": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "827": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "828": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "829": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "830": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "831": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "832": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "833": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "834": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "835": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "836": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "837": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "838": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "839": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "840": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "841": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "842": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "843": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "844": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "845": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "846": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "847": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "848": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "849": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "850": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "851": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "852": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "853": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "854": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "855": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "856": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "857": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "858": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "859": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "860": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "861": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "862": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "863": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "864": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "865": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "866": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "867": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "868": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "869": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "870": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "871": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "872": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "873": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "874": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "875": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "876": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "877": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "878": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "879": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "880": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "881": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "882": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "883": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "884": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "885": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "886": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "887": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "888": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "889": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "890": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "891": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "892": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "893": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "894": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "895": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "896": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "897": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "898": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "899": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "900": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "901": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "902": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "903": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "904": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "905": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "906": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "907": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "908": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "909": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "910": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "911": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "912": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "913": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "914": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "915": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "916": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "917": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "918": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "919": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "920": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "921": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "922": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "923": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "924": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "925": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "926": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "927": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "928": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "929": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "930": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "931": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "932": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "933": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "934": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "935": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "936": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "937": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "938": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "939": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "940": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "941": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "942": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "943": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "944": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "945": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "946": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "947": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "948": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "949": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "950": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "951": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "952": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "953": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "954": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "955": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "956": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "957": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "958": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "959": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "960": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "961": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "962": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "963": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "964": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "965": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "966": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "967": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "968": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "969": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "970": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "971": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "972": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "973": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "974": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "975": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "976": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "977": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "978": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "979": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "980": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "981": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "982": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "983": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "984": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "985": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "986": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "987": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "988": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "989": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "990": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "991": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "992": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "993": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "994": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "995": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "996": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "997": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "998": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "999": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1000": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1001": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1002": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1003": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1004": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1005": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1006": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1007": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1008": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1009": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1010": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1011": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1012": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1013": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1014": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1015": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1016": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1017": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1018": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1019": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1020": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1021": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1022": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1023": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1024": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1025": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1026": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1027": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1028": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1029": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1030": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1031": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1032": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1033": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1034": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1035": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1036": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1037": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1038": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1039": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1040": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1041": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1042": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1043": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1044": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1045": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1046": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1047": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1048": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1049": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1050": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1051": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1052": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1053": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1054": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1055": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1056": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1057": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1058": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1059": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1060": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1061": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1062": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1063": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1064": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1065": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1066": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1067": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1068": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1069": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1070": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1071": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1072": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1073": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1074": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1075": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1076": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1077": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1078": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1079": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1080": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1081": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1082": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1083": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1084": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1085": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1086": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1087": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1088": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1089": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1090": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1091": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1092": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1093": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1094": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1095": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1096": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1097": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1098": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1099": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1100": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1101": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1102": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1103": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1104": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1105": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1106": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1107": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1108": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1109": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1110": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1111": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1112": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1113": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1114": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1115": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1116": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1117": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1118": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1119": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1120": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1121": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1122": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1123": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1124": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1125": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1126": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1127": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1128": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1129": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1130": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1131": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1132": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1133": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1134": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1135": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1136": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1137": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1138": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1139": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1140": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1141": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1142": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1143": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1144": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1145": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1146": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1147": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1148": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1149": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1150": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1151": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1152": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1153": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1154": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1155": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1156": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1157": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1158": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1159": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1160": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1161": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1162": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1163": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1164": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1165": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1166": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1167": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1168": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1169": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1170": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1171": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1172": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1173": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1174": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1175": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1176": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1177": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1178": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1179": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1180": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1181": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1182": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1183": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1184": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1185": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1186": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1187": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1188": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1189": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1190": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1191": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1192": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1193": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1194": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1195": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1196": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1197": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1198": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1199": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1200": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1201": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1202": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1203": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1204": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1205": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1206": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1207": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1208": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1209": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1210": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1211": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1212": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1213": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1214": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1215": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1216": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1217": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1218": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1219": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1220": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1221": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1222": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1223": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1224": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1225": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1226": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1227": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1228": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1229": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1230": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1231": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1232": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1233": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1234": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1235": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1236": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1237": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1238": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1239": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1240": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1241": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1242": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1243": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1244": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1245": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1246": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1247": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1248": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1249": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1250": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1251": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1252": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1253": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1254": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1255": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1256": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1257": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1258": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1259": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1260": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1261": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1262": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1263": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1264": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1265": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1266": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1267": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1268": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1269": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1270": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1271": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1272": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1273": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1274": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1275": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1276": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1277": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1278": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1279": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1280": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1281": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1282": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1283": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1284": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1285": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1286": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1287": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1288": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1289": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1290": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1291": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1292": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1293": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1294": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1295": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1296": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1297": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1298": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1299": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1300": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1301": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1302": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1303": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1304": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1305": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1306": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1307": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1308": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1309": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1310": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1311": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1312": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1313": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1314": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1315": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1316": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1317": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1318": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1319": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1320": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1321": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1322": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1323": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1324": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1325": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1326": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1327": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1328": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1329": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1330": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1331": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1332": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1333": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1334": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1335": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1336": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1337": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1338": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1339": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1340": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1341": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1342": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1343": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1344": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1345": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1346": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1347": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1348": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1349": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1350": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1351": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1352": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1353": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1354": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1355": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1356": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1357": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1358": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1359": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1360": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1361": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1362": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1363": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1364": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1365": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1366": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1367": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1368": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1369": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1370": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1371": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1372": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1373": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1374": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1375": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1376": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1377": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1378": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1379": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1380": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1381": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1382": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1383": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1384": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1385": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1386": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1387": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1388": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1389": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1390": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1391": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1392": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1393": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1394": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1395": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1396": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1397": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1398": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1399": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1400": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1401": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1402": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1403": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1404": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1405": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1406": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1407": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1408": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1409": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1410": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1411": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1412": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1413": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1414": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1415": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1416": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1417": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1418": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1419": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1420": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1421": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1422": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1423": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1424": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1425": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1426": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1427": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1428": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1429": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1430": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1431": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1432": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1433": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1434": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1435": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1436": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1437": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1438": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1439": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1440": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1441": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1442": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1443": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1444": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1445": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1446": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1447": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1448": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1449": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1450": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1451": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1452": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1453": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1454": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1455": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1456": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1457": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1458": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1459": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1460": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1461": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1462": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1463": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1464": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1465": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1466": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1467": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1468": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1469": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1470": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1471": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1472": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1473": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1474": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1475": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1476": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1477": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1478": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1479": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1480": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1481": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1482": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1483": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1484": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1485": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1486": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1487": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1488": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1489": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1490": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1491": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1492": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1493": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1494": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1495": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1496": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1497": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1498": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1499": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1500": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1501": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1502": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1503": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1504": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1505": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1506": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1507": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1508": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1509": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1510": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1511": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1512": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1513": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1514": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1515": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1516": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1517": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1518": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1519": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1520": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1521": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1522": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1523": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1524": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1525": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1526": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1527": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1528": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1529": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1530": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1531": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1532": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1533": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1534": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1535": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1536": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1537": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1538": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1539": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1540": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1541": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1542": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1543": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1544": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1545": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1546": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1547": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1548": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1549": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1550": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1551": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1552": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1553": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1554": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1555": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1556": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1557": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1558": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1559": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1560": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1561": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1562": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1563": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1564": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1565": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1566": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1567": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1568": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1569": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1570": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1571": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1572": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1573": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1574": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1575": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1576": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1577": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1578": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1579": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1580": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1581": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1582": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1583": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1584": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1585": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1586": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1587": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1588": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1589": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1590": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1591": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1592": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1593": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1594": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1595": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1596": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1597": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1598": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1599": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1600": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1601": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1602": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1603": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1604": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1605": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1606": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1607": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1608": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1609": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1610": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1611": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1612": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1613": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1614": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1615": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1616": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1617": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1618": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1619": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1620": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1621": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1622": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1623": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1624": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1625": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1626": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1627": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1628": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1629": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1630": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1631": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1632": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1633": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1634": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1635": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1636": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1637": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1638": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1639": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1640": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1641": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1642": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1643": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1644": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1645": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1646": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1647": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1648": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1649": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1650": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1651": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1652": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1653": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1654": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1655": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1656": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1657": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1658": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1659": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1660": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1661": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1662": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1663": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1664": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1665": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1666": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1667": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1668": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1669": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1670": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1671": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1672": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1673": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1674": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1675": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1676": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1677": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1678": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1679": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1680": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1681": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1682": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1683": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1684": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1685": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1686": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1687": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1688": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1689": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1690": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1691": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1692": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1693": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1694": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1695": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1696": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1697": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1698": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1699": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1700": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1701": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1702": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1703": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1704": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1705": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1706": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1707": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1708": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1709": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1710": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1711": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1712": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1713": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1714": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1715": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1716": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1717": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1718": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1719": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1720": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1721": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1722": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1723": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1724": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1725": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1726": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1727": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1728": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1729": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1730": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1731": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1732": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1733": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1734": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1735": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1736": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1737": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1738": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1739": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1740": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1741": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1742": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1743": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1744": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1745": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1746": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1747": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1748": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1749": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1750": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1751": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1752": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1753": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1754": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1755": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1756": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1757": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1758": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1759": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1760": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1761": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1762": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1763": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1764": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1765": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1766": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1767": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1768": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1769": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1770": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1771": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1772": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1773": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1774": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1775": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1776": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1777": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1778": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1779": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1780": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1781": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1782": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1783": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1784": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1785": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1786": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1787": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1788": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1789": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1790": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1791": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1792": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1793": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1794": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1795": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1796": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1797": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1798": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1799": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1800": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1801": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1802": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1803": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1804": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1805": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1806": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1807": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1808": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1809": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1810": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1811": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1812": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1813": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1814": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1815": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1816": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1817": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1818": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1819": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1820": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1821": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1822": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1823": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1824": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1825": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1826": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1827": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1828": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1829": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1830": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1831": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1832": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1833": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1834": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1835": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1836": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1837": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1838": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1839": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1840": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1841": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1842": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1843": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1844": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1845": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1846": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1847": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1848": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1849": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1850": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1851": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1852": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1853": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1854": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1855": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1856": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1857": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1858": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1859": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1860": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1861": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1862": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1863": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1864": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1865": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1866": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1867": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1868": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1869": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1870": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1871": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1872": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1873": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1874": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1875": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1876": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1877": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1878": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1879": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1880": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1881": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1882": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1883": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1884": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1885": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1886": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1887": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1888": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1889": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1890": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1891": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1892": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1893": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1894": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1895": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1896": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1897": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1898": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1899": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1900": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1901": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1902": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1903": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1904": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1905": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1906": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1907": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1908": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1909": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1910": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1911": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1912": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1913": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1914": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1915": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1916": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1917": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1918": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1919": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1920": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1921": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1922": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1923": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1924": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1925": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1926": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1927": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1928": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1929": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1930": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1931": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1932": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1933": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1934": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1935": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1936": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1937": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1938": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1939": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1940": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1941": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1942": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1943": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1944": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1945": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1946": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1947": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1948": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1949": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1950": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1951": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1952": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1953": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1954": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1955": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1956": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1957": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1958": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1959": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1960": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1961": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1962": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1963": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1964": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1965": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1966": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1967": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1968": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1969": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1970": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1971": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1972": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1973": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1974": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1975": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1976": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1977": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1978": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1979": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1980": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1981": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1982": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1983": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1984": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1985": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1986": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1987": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1988": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1989": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1990": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1991": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1992": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1993": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1994": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1995": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1996": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1997": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1998": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1999": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2000": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2001": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2002": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2003": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2004": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2005": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2006": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2007": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2008": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2009": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2010": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2011": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2012": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2013": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2014": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2015": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2016": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2017": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2018": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2019": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2020": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2021": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2022": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2023": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2024": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2025": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2026": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2027": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2028": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2029": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2030": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2031": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2032": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2033": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2034": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2035": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2036": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2037": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2038": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2039": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2040": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2041": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2042": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2043": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2044": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2045": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2046": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2047": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2048": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2049": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2050": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2051": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2052": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2053": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2054": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2055": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2056": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2057": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2058": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2059": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2060": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2061": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2062": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2063": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2064": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2065": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2066": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2067": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2068": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2069": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2070": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2071": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2072": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2073": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2074": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2075": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2076": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2077": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2078": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2079": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2080": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2081": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2082": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2083": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2084": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2085": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2086": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2087": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2088": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2089": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2090": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2091": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2092": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2093": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2094": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2095": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2096": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2097": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2098": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2099": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2100": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2101": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2102": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2103": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2104": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2105": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2106": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2107": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2108": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2109": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2110": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2111": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2112": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2113": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2114": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2115": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2116": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2117": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2118": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2119": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2120": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2121": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2122": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2123": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2124": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2125": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2126": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2127": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2128": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2129": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2130": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2131": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2132": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2133": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2134": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2135": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2136": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2137": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2138": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2139": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2140": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2141": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2142": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2143": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2144": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2145": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2146": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2147": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2148": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2149": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2150": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2151": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2152": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2153": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2154": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2155": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2156": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2157": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2158": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2159": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2160": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2161": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2162": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2163": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2164": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2165": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2166": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2167": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2168": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2169": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2170": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2171": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2172": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2173": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2174": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2175": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2176": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2177": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2178": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2179": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2180": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2181": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2182": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2183": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2184": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2185": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2186": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2187": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2188": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2189": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2190": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2191": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2192": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2193": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2194": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2195": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2196": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2197": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2198": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2199": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2200": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2201": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2202": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2203": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2204": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2205": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2206": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2207": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2208": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2209": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2210": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2211": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2212": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2213": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2214": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2215": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2216": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2217": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2218": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2219": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2220": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2221": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2222": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2223": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2224": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2225": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2226": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2227": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2228": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2229": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2230": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2231": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2232": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2233": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2234": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2235": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2236": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2237": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2238": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2239": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2240": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2241": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2242": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2243": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2244": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2245": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2246": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2247": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2248": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2249": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2250": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2251": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2252": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2253": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2254": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2255": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2256": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2257": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2258": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2259": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2260": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2261": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2262": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2263": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2264": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2265": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2266": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2267": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2268": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2269": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2270": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2271": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2272": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2273": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2274": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2275": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2276": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2277": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2278": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2279": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2280": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2281": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2282": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2283": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2284": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2285": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2286": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2287": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2288": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2289": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2290": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2291": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2292": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2293": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2294": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2295": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2296": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2297": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2298": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2299": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2300": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2301": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2302": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2303": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2304": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2305": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2306": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2307": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2308": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2309": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2310": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2311": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2312": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2313": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2314": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2315": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2316": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2317": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2318": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2319": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2320": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2321": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2322": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2323": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2324": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2325": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2326": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2327": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2328": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2329": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2330": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2331": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2332": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2333": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2334": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2335": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2336": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2337": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2338": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2339": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2340": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2341": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2342": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2343": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2344": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2345": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2346": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2347": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2348": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2349": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2350": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2351": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2352": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2353": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2354": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2355": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2356": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2357": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2358": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2359": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2360": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2361": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2362": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2363": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2364": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2365": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2366": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2367": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2368": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2369": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2370": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2371": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2372": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2373": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2374": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2375": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2376": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2377": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2378": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2379": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2380": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2381": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2382": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2383": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2384": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2385": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2386": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2387": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2388": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2389": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2390": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2391": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2392": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2393": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2394": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2395": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2396": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2397": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2398": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2399": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2400": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2401": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2402": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2403": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2404": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2405": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2406": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2407": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2408": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2409": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2410": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2411": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2412": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2413": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2414": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2415": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2416": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2417": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2418": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2419": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2420": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2421": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2422": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2423": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2424": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2425": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2426": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2427": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2428": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2429": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2430": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2431": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2432": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2433": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2434": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2435": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2436": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2437": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2438": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2439": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2440": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2441": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2442": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2443": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2444": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2445": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2446": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2447": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2448": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2449": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2450": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2451": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2452": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2453": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2454": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2455": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2456": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2457": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2458": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2459": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2460": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2461": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2462": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2463": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2464": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2465": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2466": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2467": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2468": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2469": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2470": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2471": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2472": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2473": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2474": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2475": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2476": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2477": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2478": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2479": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2480": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2481": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2482": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2483": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2484": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2485": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2486": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2487": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2488": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2489": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2490": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2491": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2492": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2493": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2494": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2495": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2496": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2497": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2498": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2499": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2500": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2501": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2502": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2503": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2504": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2505": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2506": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2507": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2508": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2509": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2510": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2511": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2512": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2513": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2514": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2515": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2516": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2517": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2518": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2519": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2520": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2521": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2522": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2523": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2524": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2525": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2526": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2527": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2528": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2529": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2530": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2531": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2532": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2533": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2534": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2535": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2536": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2537": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2538": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2539": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2540": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2541": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2542": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2543": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2544": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2545": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2546": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2547": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2548": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2549": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2550": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2551": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2552": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2553": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2554": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2555": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2556": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2557": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2558": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2559": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2560": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2561": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2562": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2563": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2564": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2565": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2566": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2567": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2568": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2569": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2570": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2571": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2572": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2573": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2574": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2575": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2576": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2577": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2578": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2579": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2580": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2581": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2582": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2583": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2584": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2585": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2586": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2587": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2588": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2589": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2590": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2591": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2592": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2593": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2594": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2595": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2596": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2597": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2598": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2599": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2600": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2601": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2602": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2603": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2604": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2605": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2606": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2607": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2608": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2609": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2610": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2611": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2612": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2613": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2614": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2615": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2616": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2617": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2618": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2619": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2620": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2621": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2622": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2623": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2624": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2625": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2626": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2627": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2628": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2629": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2630": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2631": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2632": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2633": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2634": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2635": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2636": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2637": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2638": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2639": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2640": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2641": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2642": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2643": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2644": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2645": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2646": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2647": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2648": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2649": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2650": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2651": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2652": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2653": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2654": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2655": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2656": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2657": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2658": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2659": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2660": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2661": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2662": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2663": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2664": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2665": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2666": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2667": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2668": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2669": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2670": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2671": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2672": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2673": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2674": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2675": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2676": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2677": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2678": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2679": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2680": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2681": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2682": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2683": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2684": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2685": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2686": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2687": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2688": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2689": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2690": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2691": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2692": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2693": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2694": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2695": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2696": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2697": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2698": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2699": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2700": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2701": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2702": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2703": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2704": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2705": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2706": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2707": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2708": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2709": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2710": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2711": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2712": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2713": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2714": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2715": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2716": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2717": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2718": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2719": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2720": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2721": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2722": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2723": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2724": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2725": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2726": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2727": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2728": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2729": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2730": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2731": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2732": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2733": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2734": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2735": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2736": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2737": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2738": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2739": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2740": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2741": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2742": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2743": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2744": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2745": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2746": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2747": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2748": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2749": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2750": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2751": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2752": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2753": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2754": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2755": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2756": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2757": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2758": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2759": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2760": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2761": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2762": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2763": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2764": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2765": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2766": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2767": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2768": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2769": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2770": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2771": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2772": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2773": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2774": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2775": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2776": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2777": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2778": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2779": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2780": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2781": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2782": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2783": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2784": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2785": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2786": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2787": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2788": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2789": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2790": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2791": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2792": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2793": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2794": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2795": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2796": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2797": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2798": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2799": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2800": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2801": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2802": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2803": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2804": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2805": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2806": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2807": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2808": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2809": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2810": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2811": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2812": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2813": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2814": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2815": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2816": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2817": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2818": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2819": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2820": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2821": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2822": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2823": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2824": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2825": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2826": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2827": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2828": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2829": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2830": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2831": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2832": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2833": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2834": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2835": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2836": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2837": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2838": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2839": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2840": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2841": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2842": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2843": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2844": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2845": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2846": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2847": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2848": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2849": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2850": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2851": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2852": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2853": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2854": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2855": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2856": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2857": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2858": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2859": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2860": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2861": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2862": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2863": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2864": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2865": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2866": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2867": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2868": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2869": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2870": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2871": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2872": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2873": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2874": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2875": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2876": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2877": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2878": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2879": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2880": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2881": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2882": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2883": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2884": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2885": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2886": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2887": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2888": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2889": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2890": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2891": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2892": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2893": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2894": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2895": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2896": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2897": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2898": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2899": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2900": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2901": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2902": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2903": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2904": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2905": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2906": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2907": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2908": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2909": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2910": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2911": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2912": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2913": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2914": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2915": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2916": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2917": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2918": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2919": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2920": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2921": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2922": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2923": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2924": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2925": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2926": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2927": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2928": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2929": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2930": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2931": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2932": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2933": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2934": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2935": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2936": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2937": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2938": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2939": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2940": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2941": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2942": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2943": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2944": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2945": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2946": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2947": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2948": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2949": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2950": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2951": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2952": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2953": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2954": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2955": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2956": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2957": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2958": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2959": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2960": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2961": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2962": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2963": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2964": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2965": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2966": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2967": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2968": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2969": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2970": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2971": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2972": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2973": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2974": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2975": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2976": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2977": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2978": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2979": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2980": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2981": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2982": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2983": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2984": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2985": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2986": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2987": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2988": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2989": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2990": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2991": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2992": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2993": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2994": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2995": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2996": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2997": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2998": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2999": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3000": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3001": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3002": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3003": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3004": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3005": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3006": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3007": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3008": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3009": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3010": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3011": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3012": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3013": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3014": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3015": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3016": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3017": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3018": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3019": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3020": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3021": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3022": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3023": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3024": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3025": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3026": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3027": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3028": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3029": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3030": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3031": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3032": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3033": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3034": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3035": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3036": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3037": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3038": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3039": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3040": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3041": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3042": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3043": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3044": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3045": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3046": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3047": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3048": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3049": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3050": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3051": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3052": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3053": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3054": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3055": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3056": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3057": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3058": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3059": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3060": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3061": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3062": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3063": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3064": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3065": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3066": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3067": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3068": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3069": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3070": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3071": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3072": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3073": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3074": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3075": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3076": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3077": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3078": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3079": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3080": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3081": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3082": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3083": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3084": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3085": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3086": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3087": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3088": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3089": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3090": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3091": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3092": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3093": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3094": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3095": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3096": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3097": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3098": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3099": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3100": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3101": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3102": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3103": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3104": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3105": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3106": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3107": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3108": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3109": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3110": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3111": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3112": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3113": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3114": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3115": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3116": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3117": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3118": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3119": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3120": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3121": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3122": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3123": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3124": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3125": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3126": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3127": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3128": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3129": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3130": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3131": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3132": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3133": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3134": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3135": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3136": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3137": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3138": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3139": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3140": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3141": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3142": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3143": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3144": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3145": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3146": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3147": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3148": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3149": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3150": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3151": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3152": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3153": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3154": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3155": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3156": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3157": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3158": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3159": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3160": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3161": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3162": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3163": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3164": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3165": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3166": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3167": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3168": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3169": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3170": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3171": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3172": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3173": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3174": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3175": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3176": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3177": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3178": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3179": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3180": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3181": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3182": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3183": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3184": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3185": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3186": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3187": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3188": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3189": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3190": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3191": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3192": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3193": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3194": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3195": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3196": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3197": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3198": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3199": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3200": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3201": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3202": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3203": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3204": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3205": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3206": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3207": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3208": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3209": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3210": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3211": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3212": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3213": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3214": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3215": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3216": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3217": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3218": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3219": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3220": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3221": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3222": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3223": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3224": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3225": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3226": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3227": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3228": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3229": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3230": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3231": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3232": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3233": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3234": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3235": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3236": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3237": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3238": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3239": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3240": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3241": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3242": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3243": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3244": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3245": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3246": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3247": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3248": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3249": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3250": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3251": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3252": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3253": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3254": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3255": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3256": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3257": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3258": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3259": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3260": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3261": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3262": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3263": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3264": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3265": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3266": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3267": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3268": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3269": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3270": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3271": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3272": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3273": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3274": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3275": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3276": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3277": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3278": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3279": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3280": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3281": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3282": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3283": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3284": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3285": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3286": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3287": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3288": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3289": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3290": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3291": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3292": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3293": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3294": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3295": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3296": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3297": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3298": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3299": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3300": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3301": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3302": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3303": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3304": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3305": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3306": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3307": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3308": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3309": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3310": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3311": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3312": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3313": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3314": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3315": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3316": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3317": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3318": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3319": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3320": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3321": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3322": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3323": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3324": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3325": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3326": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3327": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3328": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3329": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3330": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3331": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3332": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3333": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3334": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3335": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3336": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3337": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3338": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3339": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3340": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3341": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3342": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3343": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3344": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3345": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3346": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3347": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3348": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3349": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3350": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3351": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3352": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3353": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3354": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3355": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3356": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3357": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3358": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3359": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3360": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3361": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3362": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3363": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3364": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3365": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3366": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3367": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3368": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3369": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3370": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3371": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3372": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3373": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3374": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3375": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3376": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3377": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3378": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3379": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3380": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3381": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3382": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3383": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3384": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3385": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3386": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3387": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3388": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3389": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3390": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3391": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3392": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3393": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3394": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3395": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3396": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3397": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3398": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3399": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3400": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3401": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3402": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3403": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3404": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3405": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3406": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3407": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3408": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3409": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3410": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3411": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3412": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3413": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3414": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3415": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3416": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3417": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3418": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3419": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3420": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3421": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3422": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3423": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3424": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3425": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3426": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3427": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3428": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3429": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3430": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3431": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3432": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3433": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3434": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3435": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3436": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3437": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3438": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3439": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3440": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3441": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3442": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3443": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3444": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3445": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3446": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3447": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3448": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3449": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3450": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3451": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3452": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3453": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3454": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3455": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3456": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3457": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3458": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3459": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3460": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3461": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3462": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3463": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3464": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3465": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3466": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3467": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3468": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3469": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3470": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3471": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3472": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3473": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3474": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3475": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3476": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3477": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3478": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3479": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3480": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3481": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3482": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3483": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3484": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3485": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3486": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3487": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3488": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3489": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3490": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3491": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3492": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3493": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3494": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3495": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3496": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3497": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3498": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3499": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3500": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3501": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3502": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3503": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3504": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3505": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3506": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3507": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3508": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3509": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3510": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3511": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3512": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3513": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3514": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3515": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3516": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3517": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3518": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3519": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3520": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3521": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3522": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3523": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3524": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3525": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3526": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3527": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3528": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3529": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3530": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3531": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3532": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3533": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3534": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3535": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3536": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3537": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3538": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3539": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3540": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3541": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3542": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3543": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3544": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3545": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3546": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3547": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3548": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3549": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3550": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3551": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3552": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3553": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3554": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3555": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3556": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3557": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3558": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3559": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3560": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3561": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3562": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3563": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3564": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3565": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3566": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3567": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3568": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3569": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3570": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3571": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3572": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3573": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3574": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3575": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3576": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3577": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3578": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3579": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3580": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3581": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3582": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3583": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3584": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3585": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3586": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3587": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3588": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3589": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3590": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3591": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3592": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3593": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3594": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3595": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3596": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3597": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3598": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3599": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3600": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3601": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3602": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3603": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3604": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3605": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3606": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3607": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3608": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3609": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3610": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3611": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3612": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3613": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3614": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3615": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3616": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3617": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3618": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3619": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3620": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3621": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3622": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3623": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3624": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3625": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3626": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3627": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3628": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3629": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3630": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3631": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3632": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3633": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3634": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3635": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3636": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3637": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3638": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3639": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3640": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3641": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3642": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3643": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3644": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3645": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3646": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3647": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3648": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3649": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3650": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3651": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3652": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3653": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3654": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3655": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3656": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3657": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3658": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3659": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3660": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3661": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3662": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3663": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3664": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3665": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3666": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3667": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3668": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3669": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3670": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3671": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3672": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3673": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3674": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3675": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3676": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3677": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3678": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3679": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3680": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3681": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3682": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3683": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3684": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3685": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3686": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3687": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3688": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3689": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3690": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3691": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3692": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3693": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3694": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3695": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3696": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3697": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3698": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3699": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3700": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3701": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3702": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3703": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3704": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3705": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3706": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3707": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3708": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3709": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3710": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3711": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3712": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3713": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3714": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3715": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3716": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3717": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3718": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3719": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3720": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3721": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3722": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3723": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3724": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3725": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3726": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3727": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3728": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3729": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3730": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3731": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3732": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3733": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3734": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3735": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3736": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3737": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3738": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3739": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3740": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3741": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3742": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3743": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3744": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3745": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3746": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3747": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3748": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3749": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3750": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3751": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3752": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3753": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3754": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3755": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3756": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3757": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3758": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3759": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3760": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3761": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3762": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3763": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3764": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3765": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3766": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3767": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3768": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3769": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3770": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3771": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3772": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3773": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3774": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3775": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3776": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3777": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3778": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3779": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3780": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3781": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3782": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3783": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3784": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3785": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3786": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3787": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3788": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3789": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3790": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3791": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3792": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3793": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3794": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3795": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3796": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3797": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3798": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3799": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3800": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3801": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3802": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3803": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3804": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3805": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3806": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3807": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3808": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3809": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3810": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3811": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3812": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3813": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3814": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3815": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3816": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3817": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3818": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3819": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3820": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3821": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3822": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3823": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3824": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3825": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3826": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3827": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3828": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3829": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3830": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3831": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3832": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3833": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3834": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3835": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3836": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3837": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3838": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3839": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3840": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3841": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3842": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3843": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3844": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3845": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3846": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3847": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3848": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3849": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3850": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3851": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3852": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3853": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3854": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3855": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3856": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3857": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3858": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3859": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3860": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3861": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3862": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3863": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3864": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3865": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3866": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3867": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3868": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3869": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3870": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3871": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3872": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3873": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3874": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3875": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3876": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3877": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3878": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3879": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3880": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3881": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3882": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3883": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3884": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3885": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3886": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3887": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3888": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3889": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3890": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3891": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3892": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3893": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3894": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3895": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3896": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3897": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3898": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3899": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3900": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3901": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3902": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3903": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3904": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3905": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3906": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3907": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3908": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3909": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3910": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3911": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3912": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3913": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3914": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3915": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3916": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3917": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3918": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3919": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3920": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3921": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3922": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3923": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3924": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3925": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3926": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3927": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3928": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3929": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3930": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3931": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3932": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3933": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3934": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3935": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3936": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3937": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3938": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3939": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3940": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3941": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3942": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3943": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3944": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3945": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3946": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3947": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3948": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3949": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3950": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3951": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3952": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3953": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3954": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3955": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3956": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3957": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3958": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3959": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3960": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3961": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3962": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3963": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3964": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3965": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3966": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3967": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3968": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3969": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3970": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3971": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3972": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3973": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3974": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3975": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3976": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3977": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3978": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3979": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3980": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3981": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3982": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3983": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3984": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3985": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3986": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3987": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3988": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3989": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3990": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3991": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3992": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3993": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3994": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3995": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3996": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3997": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3998": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3999": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "4000": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "4001": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "4002": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "4003": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "4004": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "4005": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "4006": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "4007": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "4008": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "4009": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "4010": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "4011": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "4012": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "4013": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "4014": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "4015": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "4016": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "4017": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "4018": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "4019": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
    },
    "00191016": {
        "0": {"vr": "DS", "Value": [200.625]},
        "1": {"vr": "DS", "Value": [272.3425]},
        "2": {"vr": "DS", "Value": [379.865]},
        "3": {"vr": "DS", "Value": [401.1225]},
        "4": {"vr": "DS", "Value": [353.465]},
        "5": {"vr": "DS", "Value": [345.1025]},
        "6": {"vr": "DS", "Value": [484.295]},
        "7": {"vr": "DS", "Value": [502.7725]},
        "8": {"vr": "DS", "Value": [212.9575]},
        "9": {"vr": "DS", "Value": [122.01]},
        "10": {"vr": "DS", "Value": [482.0775]},
        "11": {"vr": "DS", "Value": [223.3675]},
        "12": {"vr": "DS", "Value": [218.9575]},
        "13": {"vr": "DS", "Value": [3.5125]},
        "14": {"vr": "DS", "Value": [300.5175]},
        "15": {"vr": "DS", "Value": [412.995]},
        "16": {"vr": "DS", "Value": [468.45]},
        "17": {"vr": "DS", "Value": [63.795]},
        "18": {"vr": "DS", "Value": [181.2675]},
        "19": {"vr": "DS", "Value": [416.5275]},
        "20": {"vr": "DS", "Value": [132.1475]},
        "21": {"vr": "DS", "Value": [427.23]},
        "22": {"vr": "DS", "Value": [448.3425]},
        "23": {"vr": "DS", "Value": [535.1725]},
        "24": {"vr": "DS", "Value": [432.81]},
        "25": {"vr": "DS", "Value": [178.9275]},
        "26": {"vr": "DS", "Value": [281.8925]},
        "27": {"vr": "DS", "Value": [145.775]},
        "28": {"vr": "DS", "Value": [168.08]},
        "29": {"vr": "DS", "Value": [405.825]},
        "30": {"vr": "DS", "Value": [283.795]},
        "31": {"vr": "DS", "Value": [208.255]},
        "32": {"vr": "DS", "Value": [324.265]},
        "33": {"vr": "DS", "Value": [161.035]},
        "34": {"vr": "DS", "Value": [597.65]},
        "35": {"vr": "DS", "Value": [0.1475]},
        "36": {"vr": "DS", "Value": [104.1175]},
        "37": {"vr": "DS", "Value": [176.1475]},
        "38": {"vr": "DS", "Value": [368.7025]},
        "39": {"vr": "DS", "Value": [257.395]},
        "40": {"vr": "DS", "Value": [500.41]},
        "41": {"vr": "DS", "Value": [568.7625]},
        "42": {"vr": "DS", "Value": [574.05]},
        "43": {"vr": "DS", "Value": [181.415]},
        "44": {"vr": "DS", "Value": [471.0825]},
        "45": {"vr": "DS", "Value": [78.7425]},
        "46": {"vr": "DS", "Value": [483.25]},
        "47": {"vr": "DS", "Value": [565.25]},
        "48": {"vr": "DS", "Value": [249.9125]},
        "49": {"vr": "DS", "Value": [34.7425]},
        "50": {"vr": "DS", "Value": [451.29]},
        "51": {"vr": "DS", "Value": [459.795]},
        "52": {"vr": "DS", "Value": [469.475]},
        "53": {"vr": "DS", "Value": [197.99]},
        "54": {"vr": "DS", "Value": [95.3175]},
        "55": {"vr": "DS", "Value": [231.435]},
        "56": {"vr": "DS", "Value": [346.5675]},
        "57": {"vr": "DS", "Value": [248.8875]},
        "58": {"vr": "DS", "Value": [212.08]},
        "59": {"vr": "DS", "Value": [149.7475]},
        "60": {"vr": "DS", "Value": [403.9025]},
        "61": {"vr": "DS", "Value": [494.85]},
        "62": {"vr": "DS", "Value": [197.845]},
        "63": {"vr": "DS", "Value": [579.9025]},
        "64": {"vr": "DS", "Value": [342.1575]},
        "65": {"vr": "DS", "Value": [581.24]},
        "66": {"vr": "DS", "Value": [199.1625]},
        "67": {"vr": "DS", "Value": [226.1475]},
        "68": {"vr": "DS", "Value": [113.795]},
        "69": {"vr": "DS", "Value": [138.1475]},
        "70": {"vr": "DS", "Value": [89.465]},
        "71": {"vr": "DS", "Value": [351.5425]},
        "72": {"vr": "DS", "Value": [346.1275]},
        "73": {"vr": "DS", "Value": [427.3775]},
        "74": {"vr": "DS", "Value": [68.185]},
        "75": {"vr": "DS", "Value": [549.99]},
        "76": {"vr": "DS", "Value": [424.01]},
        "77": {"vr": "DS", "Value": [285.26]},
        "78": {"vr": "DS", "Value": [406.41]},
        "79": {"vr": "DS", "Value": [160.1575]},
        "80": {"vr": "DS", "Value": [595.7475]},
        "81": {"vr": "DS", "Value": [67.7475]},
        "82": {"vr": "DS", "Value": [373.6975]},
        "83": {"vr": "DS", "Value": [324.1175]},
        "84": {"vr": "DS", "Value": [25.795]},
        "85": {"vr": "DS", "Value": [411.24]},
        "86": {"vr": "DS", "Value": [464.7725]},
        "87": {"vr": "DS", "Value": [426.3525]},
        "88": {"vr": "DS", "Value": [248.1575]},
        "89": {"vr": "DS", "Value": [526.9575]},
        "90": {"vr": "DS", "Value": [2.05]},
        "91": {"vr": "DS", "Value": [111.1625]},
        "92": {"vr": "DS", "Value": [441.465]},
        "93": {"vr": "DS", "Value": [88.585]},
        "94": {"vr": "DS", "Value": [523.59]},
        "95": {"vr": "DS", "Value": [147.6775]},
        "96": {"vr": "DS", "Value": [157.65]},
        "97": {"vr": "DS", "Value": [586.3625]},
        "98": {"vr": "DS", "Value": [21.26]},
        "99": {"vr": "DS", "Value": [21.99]},
        "100": {"vr": "DS", "Value": [78.3025]},
        "101": {"vr": "DS", "Value": [234.5075]},
        "102": {"vr": "DS", "Value": [80.3725]},
        "103": {"vr": "DS", "Value": [317.0925]},
        "104": {"vr": "DS", "Value": [477.835]},
        "105": {"vr": "DS", "Value": [520.665]},
        "106": {"vr": "DS", "Value": [433.1025]},
        "107": {"vr": "DS", "Value": [512.89]},
        "108": {"vr": "DS", "Value": [135.9525]},
        "109": {"vr": "DS", "Value": [137.415]},
        "110": {"vr": "DS", "Value": [579.025]},
        "111": {"vr": "DS", "Value": [481.2]},
        "112": {"vr": "DS", "Value": [203.1325]},
        "113": {"vr": "DS", "Value": [574.49]},
        "114": {"vr": "DS", "Value": [305.2]},
        "115": {"vr": "DS", "Value": [442.195]},
        "116": {"vr": "DS", "Value": [490.7325]},
        "117": {"vr": "DS", "Value": [127.445]},
        "118": {"vr": "DS", "Value": [390.86]},
        "119": {"vr": "DS", "Value": [588.995]},
        "120": {"vr": "DS", "Value": [52.3425]},
        "121": {"vr": "DS", "Value": [34.155]},
        "122": {"vr": "DS", "Value": [465.21]},
        "123": {"vr": "DS", "Value": [19.795]},
        "124": {"vr": "DS", "Value": [437.4925]},
        "125": {"vr": "DS", "Value": [309.025]},
        "126": {"vr": "DS", "Value": [571.1025]},
        "127": {"vr": "DS", "Value": [260.9075]},
        "128": {"vr": "DS", "Value": [396.7325]},
        "129": {"vr": "DS", "Value": [191.0925]},
        "130": {"vr": "DS", "Value": [74.645]},
        "131": {"vr": "DS", "Value": [406.7025]},
        "132": {"vr": "DS", "Value": [520.225]},
        "133": {"vr": "DS", "Value": [566.275]},
        "134": {"vr": "DS", "Value": [521.69]},
        "135": {"vr": "DS", "Value": [165.425]},
        "136": {"vr": "DS", "Value": [284.235]},
        "137": {"vr": "DS", "Value": [344.665]},
        "138": {"vr": "DS", "Value": [77.425]},
        "139": {"vr": "DS", "Value": [182.8775]},
        "140": {"vr": "DS", "Value": [220.0]},
        "141": {"vr": "DS", "Value": [42.0775]},
        "142": {"vr": "DS", "Value": [320.605]},
        "143": {"vr": "DS", "Value": [465.9425]},
        "144": {"vr": "DS", "Value": [326.9175]},
        "145": {"vr": "DS", "Value": [472.4]},
        "146": {"vr": "DS", "Value": [64.235]},
        "147": {"vr": "DS", "Value": [145.4825]},
        "148": {"vr": "DS", "Value": [484.5875]},
        "149": {"vr": "DS", "Value": [464.04]},
        "150": {"vr": "DS", "Value": [297.7175]},
        "151": {"vr": "DS", "Value": [139.7575]},
        "152": {"vr": "DS", "Value": [580.195]},
        "153": {"vr": "DS", "Value": [154.7225]},
        "154": {"vr": "DS", "Value": [18.625]},
        "155": {"vr": "DS", "Value": [419.455]},
        "156": {"vr": "DS", "Value": [169.6875]},
        "157": {"vr": "DS", "Value": [242.43]},
        "158": {"vr": "DS", "Value": [329.405]},
        "159": {"vr": "DS", "Value": [59.385]},
        "160": {"vr": "DS", "Value": [596.625]},
        "161": {"vr": "DS", "Value": [479.005]},
        "162": {"vr": "DS", "Value": [158.235]},
        "163": {"vr": "DS", "Value": [462.7225]},
        "164": {"vr": "DS", "Value": [122.1575]},
        "165": {"vr": "DS", "Value": [449.5325]},
        "166": {"vr": "DS", "Value": [351.25]},
        "167": {"vr": "DS", "Value": [249.62]},
        "168": {"vr": "DS", "Value": [94.8775]},
        "169": {"vr": "DS", "Value": [188.605]},
        "170": {"vr": "DS", "Value": [55.7275]},
        "171": {"vr": "DS", "Value": [180.39]},
        "172": {"vr": "DS", "Value": [44.8775]},
        "173": {"vr": "DS", "Value": [569.055]},
        "174": {"vr": "DS", "Value": [134.9275]},
        "175": {"vr": "DS", "Value": [200.185]},
        "176": {"vr": "DS", "Value": [28.7425]},
        "177": {"vr": "DS", "Value": [475.2]},
        "178": {"vr": "DS", "Value": [550.87]},
        "179": {"vr": "DS", "Value": [469.035]},
        "180": {"vr": "DS", "Value": [125.6875]},
        "181": {"vr": "DS", "Value": [202.235]},
        "182": {"vr": "DS", "Value": [451.5825]},
        "183": {"vr": "DS", "Value": [377.21]},
        "184": {"vr": "DS", "Value": [35.9325]},
        "185": {"vr": "DS", "Value": [172.03]},
        "186": {"vr": "DS", "Value": [441.1725]},
        "187": {"vr": "DS", "Value": [442.635]},
        "188": {"vr": "DS", "Value": [566.86]},
        "189": {"vr": "DS", "Value": [241.845]},
        "190": {"vr": "DS", "Value": [323.0925]},
        "191": {"vr": "DS", "Value": [8.4875]},
        "192": {"vr": "DS", "Value": [426.79]},
        "193": {"vr": "DS", "Value": [74.06]},
        "194": {"vr": "DS", "Value": [555.425]},
        "195": {"vr": "DS", "Value": [330.87]},
        "196": {"vr": "DS", "Value": [369.6]},
        "197": {"vr": "DS", "Value": [244.185]},
        "198": {"vr": "DS", "Value": [2.4875]},
        "199": {"vr": "DS", "Value": [374.87]},
        "200": {"vr": "DS", "Value": [33.7175]},
        "201": {"vr": "DS", "Value": [405.9725]},
        "202": {"vr": "DS", "Value": [434.42]},
        "203": {"vr": "DS", "Value": [171.7375]},
        "204": {"vr": "DS", "Value": [256.5175]},
        "205": {"vr": "DS", "Value": [446.585]},
        "206": {"vr": "DS", "Value": [458.7725]},
        "207": {"vr": "DS", "Value": [343.64]},
        "208": {"vr": "DS", "Value": [43.5425]},
        "209": {"vr": "DS", "Value": [81.6875]},
        "210": {"vr": "DS", "Value": [305.3475]},
        "211": {"vr": "DS", "Value": [336.3025]},
        "212": {"vr": "DS", "Value": [527.1025]},
        "213": {"vr": "DS", "Value": [528.295]},
        "214": {"vr": "DS", "Value": [429.425]},
        "215": {"vr": "DS", "Value": [356.39]},
        "216": {"vr": "DS", "Value": [133.3175]},
        "217": {"vr": "DS", "Value": [123.035]},
        "218": {"vr": "DS", "Value": [556.45]},
        "219": {"vr": "DS", "Value": [272.4875]},
        "220": {"vr": "DS", "Value": [213.6875]},
        "221": {"vr": "DS", "Value": [313.855]},
        "222": {"vr": "DS", "Value": [324.5575]},
        "223": {"vr": "DS", "Value": [43.6875]},
        "224": {"vr": "DS", "Value": [51.3175]},
        "225": {"vr": "DS", "Value": [55.435]},
        "226": {"vr": "DS", "Value": [370.7725]},
        "227": {"vr": "DS", "Value": [110.43]},
        "228": {"vr": "DS", "Value": [341.425]},
        "229": {"vr": "DS", "Value": [190.9475]},
        "230": {"vr": "DS", "Value": [131.835]},
        "231": {"vr": "DS", "Value": [121.57]},
        "232": {"vr": "DS", "Value": [449.24]},
        "233": {"vr": "DS", "Value": [459.65]},
        "234": {"vr": "DS", "Value": [189.045]},
        "235": {"vr": "DS", "Value": [458.48]},
        "236": {"vr": "DS", "Value": [533.5625]},
        "237": {"vr": "DS", "Value": [43.395]},
        "238": {"vr": "DS", "Value": [312.6825]},
        "239": {"vr": "DS", "Value": [469.1825]},
        "240": {"vr": "DS", "Value": [240.82]},
        "241": {"vr": "DS", "Value": [312.5375]},
        "242": {"vr": "DS", "Value": [385.1325]},
        "243": {"vr": "DS", "Value": [205.62]},
        "244": {"vr": "DS", "Value": [562.1575]},
        "245": {"vr": "DS", "Value": [506.1375]},
        "246": {"vr": "DS", "Value": [3.365]},
        "247": {"vr": "DS", "Value": [80.225]},
        "248": {"vr": "DS", "Value": [338.9375]},
        "249": {"vr": "DS", "Value": [348.7625]},
        "250": {"vr": "DS", "Value": [395.395]},
        "251": {"vr": "DS", "Value": [178.4875]},
        "252": {"vr": "DS", "Value": [319.875]},
        "253": {"vr": "DS", "Value": [325.7475]},
        "254": {"vr": "DS", "Value": [359.9025]},
        "255": {"vr": "DS", "Value": [228.4875]},
        "256": {"vr": "DS", "Value": [499.385]},
        "257": {"vr": "DS", "Value": [545.7475]},
        "258": {"vr": "DS", "Value": [238.9175]},
        "259": {"vr": "DS", "Value": [235.24]},
        "260": {"vr": "DS", "Value": [102.3625]},
        "261": {"vr": "DS", "Value": [490.1475]},
        "262": {"vr": "DS", "Value": [177.465]},
        "263": {"vr": "DS", "Value": [76.6925]},
        "264": {"vr": "DS", "Value": [511.5725]},
        "265": {"vr": "DS", "Value": [564.9575]},
        "266": {"vr": "DS", "Value": [576.39]},
        "267": {"vr": "DS", "Value": [215.59]},
        "268": {"vr": "DS", "Value": [87.6875]},
        "269": {"vr": "DS", "Value": [420.3325]},
        "270": {"vr": "DS", "Value": [597.9425]},
        "271": {"vr": "DS", "Value": [444.5375]},
        "272": {"vr": "DS", "Value": [553.9425]},
        "273": {"vr": "DS", "Value": [286.2825]},
        "274": {"vr": "DS", "Value": [89.3175]},
        "275": {"vr": "DS", "Value": [111.3075]},
        "276": {"vr": "DS", "Value": [447.9025]},
        "277": {"vr": "DS", "Value": [538.85]},
        "278": {"vr": "DS", "Value": [212.81]},
        "279": {"vr": "DS", "Value": [182.2925]},
        "280": {"vr": "DS", "Value": [366.655]},
        "281": {"vr": "DS", "Value": [237.7475]},
        "282": {"vr": "DS", "Value": [41.055]},
        "283": {"vr": "DS", "Value": [289.9425]},
        "284": {"vr": "DS", "Value": [554.695]},
        "285": {"vr": "DS", "Value": [446.0]},
        "286": {"vr": "DS", "Value": [324.995]},
        "287": {"vr": "DS", "Value": [75.5225]},
        "288": {"vr": "DS", "Value": [137.5625]},
        "289": {"vr": "DS", "Value": [580.3425]},
        "290": {"vr": "DS", "Value": [589.895]},
        "291": {"vr": "DS", "Value": [243.7475]},
        "292": {"vr": "DS", "Value": [288.04]},
        "293": {"vr": "DS", "Value": [144.02]},
        "294": {"vr": "DS", "Value": [563.035]},
        "295": {"vr": "DS", "Value": [391.8825]},
        "296": {"vr": "DS", "Value": [158.4]},
        "297": {"vr": "DS", "Value": [26.985]},
        "298": {"vr": "DS", "Value": [31.0825]},
        "299": {"vr": "DS", "Value": [24.185]},
        "300": {"vr": "DS", "Value": [565.395]},
        "301": {"vr": "DS", "Value": [593.26]},
        "302": {"vr": "DS", "Value": [370.9175]},
        "303": {"vr": "DS", "Value": [268.39]},
        "304": {"vr": "DS", "Value": [276.1675]},
        "305": {"vr": "DS", "Value": [125.5425]},
        "306": {"vr": "DS", "Value": [544.7025]},
        "307": {"vr": "DS", "Value": [269.5625]},
        "308": {"vr": "DS", "Value": [530.195]},
        "309": {"vr": "DS", "Value": [349.2]},
        "310": {"vr": "DS", "Value": [329.1125]},
        "311": {"vr": "DS", "Value": [106.185]},
        "312": {"vr": "DS", "Value": [393.2]},
        "313": {"vr": "DS", "Value": [594.285]},
        "314": {"vr": "DS", "Value": [572.88]},
        "315": {"vr": "DS", "Value": [139.4625]},
        "316": {"vr": "DS", "Value": [106.7725]},
        "317": {"vr": "DS", "Value": [535.9025]},
        "318": {"vr": "DS", "Value": [215.1525]},
        "319": {"vr": "DS", "Value": [329.845]},
        "320": {"vr": "DS", "Value": [379.425]},
        "321": {"vr": "DS", "Value": [136.83]},
        "322": {"vr": "DS", "Value": [548.82]},
        "323": {"vr": "DS", "Value": [279.97]},
        "324": {"vr": "DS", "Value": [266.9275]},
        "325": {"vr": "DS", "Value": [132.585]},
        "326": {"vr": "DS", "Value": [56.8975]},
        "327": {"vr": "DS", "Value": [375.6]},
        "328": {"vr": "DS", "Value": [491.1725]},
        "329": {"vr": "DS", "Value": [376.77]},
        "330": {"vr": "DS", "Value": [41.4925]},
        "331": {"vr": "DS", "Value": [287.1625]},
        "332": {"vr": "DS", "Value": [130.37]},
        "333": {"vr": "DS", "Value": [455.24]},
        "334": {"vr": "DS", "Value": [252.985]},
        "335": {"vr": "DS", "Value": [187.435]},
        "336": {"vr": "DS", "Value": [144.3125]},
        "337": {"vr": "DS", "Value": [245.21]},
        "338": {"vr": "DS", "Value": [40.615]},
        "339": {"vr": "DS", "Value": [218.81]},
        "340": {"vr": "DS", "Value": [89.7575]},
        "341": {"vr": "DS", "Value": [573.3175]},
        "342": {"vr": "DS", "Value": [184.195]},
        "343": {"vr": "DS", "Value": [517.2775]},
        "344": {"vr": "DS", "Value": [221.025]},
        "345": {"vr": "DS", "Value": [423.865]},
        "346": {"vr": "DS", "Value": [81.395]},
        "347": {"vr": "DS", "Value": [120.84]},
        "348": {"vr": "DS", "Value": [292.7425]},
        "349": {"vr": "DS", "Value": [3.22]},
        "350": {"vr": "DS", "Value": [401.7075]},
        "351": {"vr": "DS", "Value": [543.0925]},
        "352": {"vr": "DS", "Value": [294.3525]},
        "353": {"vr": "DS", "Value": [291.5725]},
        "354": {"vr": "DS", "Value": [265.61]},
        "355": {"vr": "DS", "Value": [502.625]},
        "356": {"vr": "DS", "Value": [165.1325]},
        "357": {"vr": "DS", "Value": [33.425]},
        "358": {"vr": "DS", "Value": [448.05]},
        "359": {"vr": "DS", "Value": [128.7625]},
        "360": {"vr": "DS", "Value": [35.785]},
        "361": {"vr": "DS", "Value": [303.1525]},
        "362": {"vr": "DS", "Value": [434.7125]},
        "363": {"vr": "DS", "Value": [307.6875]},
        "364": {"vr": "DS", "Value": [502.48]},
        "365": {"vr": "DS", "Value": [308.5875]},
        "366": {"vr": "DS", "Value": [565.835]},
        "367": {"vr": "DS", "Value": [120.6925]},
        "368": {"vr": "DS", "Value": [107.65]},
        "369": {"vr": "DS", "Value": [486.3425]},
        "370": {"vr": "DS", "Value": [443.805]},
        "371": {"vr": "DS", "Value": [434.275]},
        "372": {"vr": "DS", "Value": [421.3575]},
        "373": {"vr": "DS", "Value": [368.1175]},
        "374": {"vr": "DS", "Value": [267.075]},
        "375": {"vr": "DS", "Value": [361.5325]},
        "376": {"vr": "DS", "Value": [286.1375]},
        "377": {"vr": "DS", "Value": [491.61]},
        "378": {"vr": "DS", "Value": [258.275]},
        "379": {"vr": "DS", "Value": [157.0625]},
        "380": {"vr": "DS", "Value": [246.0875]},
        "381": {"vr": "DS", "Value": [144.8975]},
        "382": {"vr": "DS", "Value": [226.585]},
        "383": {"vr": "DS", "Value": [6.0]},
        "384": {"vr": "DS", "Value": [301.835]},
        "385": {"vr": "DS", "Value": [523.005]},
        "386": {"vr": "DS", "Value": [524.03]},
        "387": {"vr": "DS", "Value": [363.1425]},
        "388": {"vr": "DS", "Value": [542.07]},
        "389": {"vr": "DS", "Value": [247.5725]},
        "390": {"vr": "DS", "Value": [118.205]},
        "391": {"vr": "DS", "Value": [528.1475]},
        "392": {"vr": "DS", "Value": [185.5325]},
        "393": {"vr": "DS", "Value": [373.405]},
        "394": {"vr": "DS", "Value": [352.7325]},
        "395": {"vr": "DS", "Value": [297.57]},
        "396": {"vr": "DS", "Value": [206.79]},
        "397": {"vr": "DS", "Value": [290.6925]},
        "398": {"vr": "DS", "Value": [57.3375]},
        "399": {"vr": "DS", "Value": [112.3325]},
        "400": {"vr": "DS", "Value": [246.9875]},
        "401": {"vr": "DS", "Value": [103.97]},
        "402": {"vr": "DS", "Value": [173.9325]},
        "403": {"vr": "DS", "Value": [340.255]},
        "404": {"vr": "DS", "Value": [53.9725]},
        "405": {"vr": "DS", "Value": [437.2]},
        "406": {"vr": "DS", "Value": [139.17]},
        "407": {"vr": "DS", "Value": [178.3425]},
        "408": {"vr": "DS", "Value": [314.44]},
        "409": {"vr": "DS", "Value": [352.0]},
        "410": {"vr": "DS", "Value": [155.015]},
        "411": {"vr": "DS", "Value": [513.7675]},
        "412": {"vr": "DS", "Value": [31.375]},
        "413": {"vr": "DS", "Value": [120.1075]},
        "414": {"vr": "DS", "Value": [58.655]},
        "415": {"vr": "DS", "Value": [480.03]},
        "416": {"vr": "DS", "Value": [281.6]},
        "417": {"vr": "DS", "Value": [66.1375]},
        "418": {"vr": "DS", "Value": [6.8775]},
        "419": {"vr": "DS", "Value": [59.0925]},
        "420": {"vr": "DS", "Value": [578.44]},
        "421": {"vr": "DS", "Value": [80.665]},
        "422": {"vr": "DS", "Value": [162.06]},
        "423": {"vr": "DS", "Value": [506.43]},
        "424": {"vr": "DS", "Value": [398.9275]},
        "425": {"vr": "DS", "Value": [557.7675]},
        "426": {"vr": "DS", "Value": [415.5025]},
        "427": {"vr": "DS", "Value": [388.3725]},
        "428": {"vr": "DS", "Value": [542.3625]},
        "429": {"vr": "DS", "Value": [418.5775]},
        "430": {"vr": "DS", "Value": [333.5025]},
        "431": {"vr": "DS", "Value": [103.825]},
        "432": {"vr": "DS", "Value": [558.205]},
        "433": {"vr": "DS", "Value": [386.01]},
        "434": {"vr": "DS", "Value": [124.08]},
        "435": {"vr": "DS", "Value": [576.83]},
        "436": {"vr": "DS", "Value": [18.3325]},
        "437": {"vr": "DS", "Value": [198.2825]},
        "438": {"vr": "DS", "Value": [355.9525]},
        "439": {"vr": "DS", "Value": [480.1775]},
        "440": {"vr": "DS", "Value": [537.9725]},
        "441": {"vr": "DS", "Value": [81.1025]},
        "442": {"vr": "DS", "Value": [99.1425]},
        "443": {"vr": "DS", "Value": [514.645]},
        "444": {"vr": "DS", "Value": [392.615]},
        "445": {"vr": "DS", "Value": [398.635]},
        "446": {"vr": "DS", "Value": [466.9875]},
        "447": {"vr": "DS", "Value": [23.015]},
        "448": {"vr": "DS", "Value": [501.1425]},
        "449": {"vr": "DS", "Value": [336.01]},
        "450": {"vr": "DS", "Value": [534.2925]},
        "451": {"vr": "DS", "Value": [128.9075]},
        "452": {"vr": "DS", "Value": [450.5575]},
        "453": {"vr": "DS", "Value": [42.225]},
        "454": {"vr": "DS", "Value": [188.46]},
        "455": {"vr": "DS", "Value": [354.195]},
        "456": {"vr": "DS", "Value": [182.44]},
        "457": {"vr": "DS", "Value": [196.0875]},
        "458": {"vr": "DS", "Value": [251.375]},
        "459": {"vr": "DS", "Value": [180.975]},
        "460": {"vr": "DS", "Value": [215.005]},
        "461": {"vr": "DS", "Value": [354.05]},
        "462": {"vr": "DS", "Value": [266.3425]},
        "463": {"vr": "DS", "Value": [366.07]},
        "464": {"vr": "DS", "Value": [484.88]},
        "465": {"vr": "DS", "Value": [167.785]},
        "466": {"vr": "DS", "Value": [118.4975]},
        "467": {"vr": "DS", "Value": [316.195]},
        "468": {"vr": "DS", "Value": [41.64]},
        "469": {"vr": "DS", "Value": [590.625]},
        "470": {"vr": "DS", "Value": [342.3025]},
        "471": {"vr": "DS", "Value": [333.65]},
        "472": {"vr": "DS", "Value": [123.4925]},
        "473": {"vr": "DS", "Value": [529.025]},
        "474": {"vr": "DS", "Value": [514.9375]},
        "475": {"vr": "DS", "Value": [5.1225]},
        "476": {"vr": "DS", "Value": [523.885]},
        "477": {"vr": "DS", "Value": [148.41]},
        "478": {"vr": "DS", "Value": [553.3575]},
        "479": {"vr": "DS", "Value": [476.665]},
        "480": {"vr": "DS", "Value": [282.7725]},
        "481": {"vr": "DS", "Value": [23.3075]},
        "482": {"vr": "DS", "Value": [128.03]},
        "483": {"vr": "DS", "Value": [497.19]},
        "484": {"vr": "DS", "Value": [370.1875]},
        "485": {"vr": "DS", "Value": [436.03]},
        "486": {"vr": "DS", "Value": [196.38]},
        "487": {"vr": "DS", "Value": [222.78]},
        "488": {"vr": "DS", "Value": [230.995]},
        "489": {"vr": "DS", "Value": [470.06]},
        "490": {"vr": "DS", "Value": [331.1625]},
        "491": {"vr": "DS", "Value": [288.77]},
        "492": {"vr": "DS", "Value": [147.385]},
        "493": {"vr": "DS", "Value": [479.59]},
        "494": {"vr": "DS", "Value": [508.4775]},
        "495": {"vr": "DS", "Value": [198.575]},
        "496": {"vr": "DS", "Value": [295.9625]},
        "497": {"vr": "DS", "Value": [8.3425]},
        "498": {"vr": "DS", "Value": [561.1325]},
        "499": {"vr": "DS", "Value": [55.2875]},
        "500": {"vr": "DS", "Value": [74.3525]},
        "501": {"vr": "DS", "Value": [597.3575]},
        "502": {"vr": "DS", "Value": [322.5075]},
        "503": {"vr": "DS", "Value": [237.8925]},
        "504": {"vr": "DS", "Value": [214.275]},
        "505": {"vr": "DS", "Value": [58.5075]},
        "506": {"vr": "DS", "Value": [136.245]},
        "507": {"vr": "DS", "Value": [110.8675]},
        "508": {"vr": "DS", "Value": [161.9125]},
        "509": {"vr": "DS", "Value": [273.24]},
        "510": {"vr": "DS", "Value": [528.5875]},
        "511": {"vr": "DS", "Value": [268.975]},
        "512": {"vr": "DS", "Value": [175.395]},
        "513": {"vr": "DS", "Value": [436.9075]},
        "514": {"vr": "DS", "Value": [109.405]},
        "515": {"vr": "DS", "Value": [205.18]},
        "516": {"vr": "DS", "Value": [18.7725]},
        "517": {"vr": "DS", "Value": [521.25]},
        "518": {"vr": "DS", "Value": [232.1675]},
        "519": {"vr": "DS", "Value": [128.175]},
        "520": {"vr": "DS", "Value": [403.7575]},
        "521": {"vr": "DS", "Value": [31.5225]},
        "522": {"vr": "DS", "Value": [278.9475]},
        "523": {"vr": "DS", "Value": [583.29]},
        "524": {"vr": "DS", "Value": [123.785]},
        "525": {"vr": "DS", "Value": [281.7475]},
        "526": {"vr": "DS", "Value": [562.595]},
        "527": {"vr": "DS", "Value": [539.1425]},
        "528": {"vr": "DS", "Value": [535.61]},
        "529": {"vr": "DS", "Value": [30.645]},
        "530": {"vr": "DS", "Value": [145.3375]},
        "531": {"vr": "DS", "Value": [210.3025]},
        "532": {"vr": "DS", "Value": [29.18]},
        "533": {"vr": "DS", "Value": [151.5025]},
        "534": {"vr": "DS", "Value": [319.2875]},
        "535": {"vr": "DS", "Value": [438.9575]},
        "536": {"vr": "DS", "Value": [412.7025]},
        "537": {"vr": "DS", "Value": [312.0975]},
        "538": {"vr": "DS", "Value": [356.0975]},
        "539": {"vr": "DS", "Value": [0.8775]},
        "540": {"vr": "DS", "Value": [189.63]},
        "541": {"vr": "DS", "Value": [548.9675]},
        "542": {"vr": "DS", "Value": [306.81]},
        "543": {"vr": "DS", "Value": [589.1425]},
        "544": {"vr": "DS", "Value": [107.21]},
        "545": {"vr": "DS", "Value": [269.7075]},
        "546": {"vr": "DS", "Value": [541.045]},
        "547": {"vr": "DS", "Value": [538.5575]},
        "548": {"vr": "DS", "Value": [210.01]},
        "549": {"vr": "DS", "Value": [380.3025]},
        "550": {"vr": "DS", "Value": [348.615]},
        "551": {"vr": "DS", "Value": [480.9075]},
        "552": {"vr": "DS", "Value": [356.6825]},
        "553": {"vr": "DS", "Value": [108.6725]},
        "554": {"vr": "DS", "Value": [307.1025]},
        "555": {"vr": "DS", "Value": [2.195]},
        "556": {"vr": "DS", "Value": [150.7725]},
        "557": {"vr": "DS", "Value": [568.1775]},
        "558": {"vr": "DS", "Value": [361.9725]},
        "559": {"vr": "DS", "Value": [467.28]},
        "560": {"vr": "DS", "Value": [359.3175]},
        "561": {"vr": "DS", "Value": [526.08]},
        "562": {"vr": "DS", "Value": [421.9425]},
        "563": {"vr": "DS", "Value": [177.3175]},
        "564": {"vr": "DS", "Value": [359.7575]},
        "565": {"vr": "DS", "Value": [244.4775]},
        "566": {"vr": "DS", "Value": [382.205]},
        "567": {"vr": "DS", "Value": [209.8625]},
        "568": {"vr": "DS", "Value": [412.265]},
        "569": {"vr": "DS", "Value": [257.25]},
        "570": {"vr": "DS", "Value": [193.6]},
        "571": {"vr": "DS", "Value": [490.585]},
        "572": {"vr": "DS", "Value": [527.395]},
        "573": {"vr": "DS", "Value": [552.185]},
        "574": {"vr": "DS", "Value": [533.7075]},
        "575": {"vr": "DS", "Value": [371.065]},
        "576": {"vr": "DS", "Value": [382.645]},
        "577": {"vr": "DS", "Value": [514.79]},
        "578": {"vr": "DS", "Value": [314.2925]},
        "579": {"vr": "DS", "Value": [475.64]},
        "580": {"vr": "DS", "Value": [479.445]},
        "581": {"vr": "DS", "Value": [407.875]},
        "582": {"vr": "DS", "Value": [310.195]},
        "583": {"vr": "DS", "Value": [381.7675]},
        "584": {"vr": "DS", "Value": [439.1025]},
        "585": {"vr": "DS", "Value": [4.975]},
        "586": {"vr": "DS", "Value": [516.5475]},
        "587": {"vr": "DS", "Value": [105.8925]},
        "588": {"vr": "DS", "Value": [144.605]},
        "589": {"vr": "DS", "Value": [503.21]},
        "590": {"vr": "DS", "Value": [235.5325]},
        "591": {"vr": "DS", "Value": [337.9125]},
        "592": {"vr": "DS", "Value": [520.08]},
        "593": {"vr": "DS", "Value": [452.46]},
        "594": {"vr": "DS", "Value": [20.0875]},
        "595": {"vr": "DS", "Value": [27.425]},
        "596": {"vr": "DS", "Value": [288.625]},
        "597": {"vr": "DS", "Value": [239.9425]},
        "598": {"vr": "DS", "Value": [509.5025]},
        "599": {"vr": "DS", "Value": [160.01]},
        "600": {"vr": "DS", "Value": [209.7175]},
        "601": {"vr": "DS", "Value": [405.24]},
        "602": {"vr": "DS", "Value": [295.815]},
        "603": {"vr": "DS", "Value": [546.48]},
        "604": {"vr": "DS", "Value": [70.4]},
        "605": {"vr": "DS", "Value": [558.79]},
        "606": {"vr": "DS", "Value": [449.3875]},
        "607": {"vr": "DS", "Value": [386.8875]},
        "608": {"vr": "DS", "Value": [537.68]},
        "609": {"vr": "DS", "Value": [433.69]},
        "610": {"vr": "DS", "Value": [567.885]},
        "611": {"vr": "DS", "Value": [304.7625]},
        "612": {"vr": "DS", "Value": [30.9375]},
        "613": {"vr": "DS", "Value": [471.9625]},
        "614": {"vr": "DS", "Value": [298.01]},
        "615": {"vr": "DS", "Value": [413.435]},
        "616": {"vr": "DS", "Value": [422.4]},
        "617": {"vr": "DS", "Value": [66.8675]},
        "618": {"vr": "DS", "Value": [122.8875]},
        "619": {"vr": "DS", "Value": [324.7025]},
        "620": {"vr": "DS", "Value": [321.9225]},
        "621": {"vr": "DS", "Value": [96.195]},
        "622": {"vr": "DS", "Value": [22.2825]},
        "623": {"vr": "DS", "Value": [536.635]},
        "624": {"vr": "DS", "Value": [591.5025]},
        "625": {"vr": "DS", "Value": [482.5175]},
        "626": {"vr": "DS", "Value": [140.9475]},
        "627": {"vr": "DS", "Value": [117.4725]},
        "628": {"vr": "DS", "Value": [26.84]},
        "629": {"vr": "DS", "Value": [248.3025]},
        "630": {"vr": "DS", "Value": [443.22]},
        "631": {"vr": "DS", "Value": [180.5375]},
        "632": {"vr": "DS", "Value": [65.99]},
        "633": {"vr": "DS", "Value": [323.5325]},
        "634": {"vr": "DS", "Value": [185.385]},
        "635": {"vr": "DS", "Value": [452.8975]},
        "636": {"vr": "DS", "Value": [114.235]},
        "637": {"vr": "DS", "Value": [124.81]},
        "638": {"vr": "DS", "Value": [414.1875]},
        "639": {"vr": "DS", "Value": [574.1975]},
        "640": {"vr": "DS", "Value": [87.1025]},
        "641": {"vr": "DS", "Value": [72.45]},
        "642": {"vr": "DS", "Value": [178.78]},
        "643": {"vr": "DS", "Value": [440.1475]},
        "644": {"vr": "DS", "Value": [488.5375]},
        "645": {"vr": "DS", "Value": [262.5175]},
        "646": {"vr": "DS", "Value": [492.635]},
        "647": {"vr": "DS", "Value": [362.41]},
        "648": {"vr": "DS", "Value": [553.65]},
        "649": {"vr": "DS", "Value": [254.8875]},
        "650": {"vr": "DS", "Value": [82.86]},
        "651": {"vr": "DS", "Value": [158.5475]},
        "652": {"vr": "DS", "Value": [485.9025]},
        "653": {"vr": "DS", "Value": [149.8925]},
        "654": {"vr": "DS", "Value": [394.5175]},
        "655": {"vr": "DS", "Value": [195.9425]},
        "656": {"vr": "DS", "Value": [383.67]},
        "657": {"vr": "DS", "Value": [40.4675]},
        "658": {"vr": "DS", "Value": [424.45]},
        "659": {"vr": "DS", "Value": [94.7325]},
        "660": {"vr": "DS", "Value": [326.7725]},
        "661": {"vr": "DS", "Value": [485.465]},
        "662": {"vr": "DS", "Value": [103.24]},
        "663": {"vr": "DS", "Value": [598.235]},
        "664": {"vr": "DS", "Value": [415.065]},
        "665": {"vr": "DS", "Value": [414.3325]},
        "666": {"vr": "DS", "Value": [286.7225]},
        "667": {"vr": "DS", "Value": [83.8825]},
        "668": {"vr": "DS", "Value": [302.275]},
        "669": {"vr": "DS", "Value": [27.2775]},
        "670": {"vr": "DS", "Value": [77.8625]},
        "671": {"vr": "DS", "Value": [364.8975]},
        "672": {"vr": "DS", "Value": [541.3375]},
        "673": {"vr": "DS", "Value": [57.775]},
        "674": {"vr": "DS", "Value": [490.0]},
        "675": {"vr": "DS", "Value": [228.8]},
        "676": {"vr": "DS", "Value": [213.25]},
        "677": {"vr": "DS", "Value": [243.1625]},
        "678": {"vr": "DS", "Value": [95.4625]},
        "679": {"vr": "DS", "Value": [301.6875]},
        "680": {"vr": "DS", "Value": [392.1775]},
        "681": {"vr": "DS", "Value": [575.5125]},
        "682": {"vr": "DS", "Value": [458.3325]},
        "683": {"vr": "DS", "Value": [571.835]},
        "684": {"vr": "DS", "Value": [435.1525]},
        "685": {"vr": "DS", "Value": [62.3325]},
        "686": {"vr": "DS", "Value": [245.065]},
        "687": {"vr": "DS", "Value": [400.5375]},
        "688": {"vr": "DS", "Value": [278.215]},
        "689": {"vr": "DS", "Value": [22.8675]},
        "690": {"vr": "DS", "Value": [299.7875]},
        "691": {"vr": "DS", "Value": [36.5175]},
        "692": {"vr": "DS", "Value": [44.2925]},
        "693": {"vr": "DS", "Value": [48.975]},
        "694": {"vr": "DS", "Value": [271.3175]},
        "695": {"vr": "DS", "Value": [60.7025]},
        "696": {"vr": "DS", "Value": [446.7325]},
        "697": {"vr": "DS", "Value": [250.9375]},
        "698": {"vr": "DS", "Value": [361.24]},
        "699": {"vr": "DS", "Value": [210.595]},
        "700": {"vr": "DS", "Value": [56.7525]},
        "701": {"vr": "DS", "Value": [447.465]},
        "702": {"vr": "DS", "Value": [37.25]},
        "703": {"vr": "DS", "Value": [473.2775]},
        "704": {"vr": "DS", "Value": [179.9525]},
        "705": {"vr": "DS", "Value": [191.385]},
        "706": {"vr": "DS", "Value": [370.04]},
        "707": {"vr": "DS", "Value": [112.04]},
        "708": {"vr": "DS", "Value": [215.8825]},
        "709": {"vr": "DS", "Value": [462.2825]},
        "710": {"vr": "DS", "Value": [482.3725]},
        "711": {"vr": "DS", "Value": [429.865]},
        "712": {"vr": "DS", "Value": [21.1125]},
        "713": {"vr": "DS", "Value": [344.9575]},
        "714": {"vr": "DS", "Value": [204.7425]},
        "715": {"vr": "DS", "Value": [397.9025]},
        "716": {"vr": "DS", "Value": [424.8875]},
        "717": {"vr": "DS", "Value": [488.0975]},
        "718": {"vr": "DS", "Value": [532.9775]},
        "719": {"vr": "DS", "Value": [287.015]},
        "720": {"vr": "DS", "Value": [69.0625]},
        "721": {"vr": "DS", "Value": [360.195]},
        "722": {"vr": "DS", "Value": [96.8]},
        "723": {"vr": "DS", "Value": [571.5425]},
        "724": {"vr": "DS", "Value": [455.6775]},
        "725": {"vr": "DS", "Value": [32.6925]},
        "726": {"vr": "DS", "Value": [548.09]},
        "727": {"vr": "DS", "Value": [530.3425]},
        "728": {"vr": "DS", "Value": [29.035]},
        "729": {"vr": "DS", "Value": [548.675]},
        "730": {"vr": "DS", "Value": [310.3425]},
        "731": {"vr": "DS", "Value": [239.795]},
        "732": {"vr": "DS", "Value": [107.9425]},
        "733": {"vr": "DS", "Value": [567.1525]},
        "734": {"vr": "DS", "Value": [48.83]},
        "735": {"vr": "DS", "Value": [236.5575]},
        "736": {"vr": "DS", "Value": [143.435]},
        "737": {"vr": "DS", "Value": [75.6675]},
        "738": {"vr": "DS", "Value": [477.5425]},
        "739": {"vr": "DS", "Value": [17.7475]},
        "740": {"vr": "DS", "Value": [103.6775]},
        "741": {"vr": "DS", "Value": [54.1175]},
        "742": {"vr": "DS", "Value": [121.8625]},
        "743": {"vr": "DS", "Value": [507.6]},
        "744": {"vr": "DS", "Value": [358.44]},
        "745": {"vr": "DS", "Value": [115.865]},
        "746": {"vr": "DS", "Value": [119.6675]},
        "747": {"vr": "DS", "Value": [343.3475]},
        "748": {"vr": "DS", "Value": [392.9075]},
        "749": {"vr": "DS", "Value": [414.625]},
        "750": {"vr": "DS", "Value": [581.68]},
        "751": {"vr": "DS", "Value": [182.1475]},
        "752": {"vr": "DS", "Value": [456.995]},
        "753": {"vr": "DS", "Value": [73.3275]},
        "754": {"vr": "DS", "Value": [418.2825]},
        "755": {"vr": "DS", "Value": [282.1875]},
        "756": {"vr": "DS", "Value": [201.65]},
        "757": {"vr": "DS", "Value": [594.43]},
        "758": {"vr": "DS", "Value": [168.225]},
        "759": {"vr": "DS", "Value": [46.195]},
        "760": {"vr": "DS", "Value": [146.3625]},
        "761": {"vr": "DS", "Value": [166.8875]},
        "762": {"vr": "DS", "Value": [570.3725]},
        "763": {"vr": "DS", "Value": [393.055]},
        "764": {"vr": "DS", "Value": [291.865]},
        "765": {"vr": "DS", "Value": [130.6625]},
        "766": {"vr": "DS", "Value": [135.66]},
        "767": {"vr": "DS", "Value": [503.5025]},
        "768": {"vr": "DS", "Value": [339.23]},
        "769": {"vr": "DS", "Value": [443.9525]},
        "770": {"vr": "DS", "Value": [200.04]},
        "771": {"vr": "DS", "Value": [595.455]},
        "772": {"vr": "DS", "Value": [238.3325]},
        "773": {"vr": "DS", "Value": [547.9425]},
        "774": {"vr": "DS", "Value": [163.6675]},
        "775": {"vr": "DS", "Value": [132.0]},
        "776": {"vr": "DS", "Value": [225.1225]},
        "777": {"vr": "DS", "Value": [302.5675]},
        "778": {"vr": "DS", "Value": [576.245]},
        "779": {"vr": "DS", "Value": [42.6625]},
        "780": {"vr": "DS", "Value": [346.86]},
        "781": {"vr": "DS", "Value": [234.8]},
        "782": {"vr": "DS", "Value": [550.5775]},
        "783": {"vr": "DS", "Value": [425.9125]},
        "784": {"vr": "DS", "Value": [24.625]},
        "785": {"vr": "DS", "Value": [412.1175]},
        "786": {"vr": "DS", "Value": [344.08]},
        "787": {"vr": "DS", "Value": [118.645]},
        "788": {"vr": "DS", "Value": [496.02]},
        "789": {"vr": "DS", "Value": [192.7025]},
        "790": {"vr": "DS", "Value": [540.7525]},
        "791": {"vr": "DS", "Value": [498.3625]},
        "792": {"vr": "DS", "Value": [50.7325]},
        "793": {"vr": "DS", "Value": [414.7725]},
        "794": {"vr": "DS", "Value": [192.1175]},
        "795": {"vr": "DS", "Value": [243.8925]},
        "796": {"vr": "DS", "Value": [164.985]},
        "797": {"vr": "DS", "Value": [363.5825]},
        "798": {"vr": "DS", "Value": [419.7475]},
        "799": {"vr": "DS", "Value": [39.59]},
        "800": {"vr": "DS", "Value": [88.44]},
        "801": {"vr": "DS", "Value": [17.8925]},
        "802": {"vr": "DS", "Value": [75.23]},
        "803": {"vr": "DS", "Value": [459.5025]},
        "804": {"vr": "DS", "Value": [454.655]},
        "805": {"vr": "DS", "Value": [182.7325]},
        "806": {"vr": "DS", "Value": [365.045]},
        "807": {"vr": "DS", "Value": [441.9025]},
        "808": {"vr": "DS", "Value": [172.615]},
        "809": {"vr": "DS", "Value": [322.07]},
        "810": {"vr": "DS", "Value": [306.225]},
        "811": {"vr": "DS", "Value": [424.1575]},
        "812": {"vr": "DS", "Value": [250.645]},
        "813": {"vr": "DS", "Value": [330.575]},
        "814": {"vr": "DS", "Value": [361.68]},
        "815": {"vr": "DS", "Value": [569.64]},
        "816": {"vr": "DS", "Value": [499.9725]},
        "817": {"vr": "DS", "Value": [578.585]},
        "818": {"vr": "DS", "Value": [333.3575]},
        "819": {"vr": "DS", "Value": [267.9525]},
        "820": {"vr": "DS", "Value": [494.41]},
        "821": {"vr": "DS", "Value": [492.05]},
        "822": {"vr": "DS", "Value": [217.2]},
        "823": {"vr": "DS", "Value": [377.65]},
        "824": {"vr": "DS", "Value": [468.01]},
        "825": {"vr": "DS", "Value": [371.21]},
        "826": {"vr": "DS", "Value": [188.8975]},
        "827": {"vr": "DS", "Value": [592.5275]},
        "828": {"vr": "DS", "Value": [274.1175]},
        "829": {"vr": "DS", "Value": [398.05]},
        "830": {"vr": "DS", "Value": [65.5525]},
        "831": {"vr": "DS", "Value": [195.65]},
        "832": {"vr": "DS", "Value": [159.1325]},
        "833": {"vr": "DS", "Value": [92.5375]},
        "834": {"vr": "DS", "Value": [75.0825]},
        "835": {"vr": "DS", "Value": [582.9975]},
        "836": {"vr": "DS", "Value": [201.3575]},
        "837": {"vr": "DS", "Value": [76.4]},
        "838": {"vr": "DS", "Value": [46.4875]},
        "839": {"vr": "DS", "Value": [137.2675]},
        "840": {"vr": "DS", "Value": [488.9775]},
        "841": {"vr": "DS", "Value": [404.9475]},
        "842": {"vr": "DS", "Value": [54.995]},
        "843": {"vr": "DS", "Value": [297.425]},
        "844": {"vr": "DS", "Value": [169.98]},
        "845": {"vr": "DS", "Value": [38.86]},
        "846": {"vr": "DS", "Value": [303.7375]},
        "847": {"vr": "DS", "Value": [418.87]},
        "848": {"vr": "DS", "Value": [285.6975]},
        "849": {"vr": "DS", "Value": [78.01]},
        "850": {"vr": "DS", "Value": [396.0]},
        "851": {"vr": "DS", "Value": [330.43]},
        "852": {"vr": "DS", "Value": [328.9675]},
        "853": {"vr": "DS", "Value": [437.055]},
        "854": {"vr": "DS", "Value": [156.3325]},
        "855": {"vr": "DS", "Value": [142.7025]},
        "856": {"vr": "DS", "Value": [260.7625]},
        "857": {"vr": "DS", "Value": [368.41]},
        "858": {"vr": "DS", "Value": [171.59]},
        "859": {"vr": "DS", "Value": [64.9675]},
        "860": {"vr": "DS", "Value": [214.86]},
        "861": {"vr": "DS", "Value": [590.04]},
        "862": {"vr": "DS", "Value": [525.2]},
        "863": {"vr": "DS", "Value": [384.985]},
        "864": {"vr": "DS", "Value": [580.8025]},
        "865": {"vr": "DS", "Value": [232.46]},
        "866": {"vr": "DS", "Value": [428.1075]},
        "867": {"vr": "DS", "Value": [111.015]},
        "868": {"vr": "DS", "Value": [397.465]},
        "869": {"vr": "DS", "Value": [118.06]},
        "870": {"vr": "DS", "Value": [206.4975]},
        "871": {"vr": "DS", "Value": [263.1025]},
        "872": {"vr": "DS", "Value": [32.5475]},
        "873": {"vr": "DS", "Value": [516.84]},
        "874": {"vr": "DS", "Value": [410.3625]},
        "875": {"vr": "DS", "Value": [7.755]},
        "876": {"vr": "DS", "Value": [122.45]},
        "877": {"vr": "DS", "Value": [67.015]},
        "878": {"vr": "DS", "Value": [521.395]},
        "879": {"vr": "DS", "Value": [36.9575]},
        "880": {"vr": "DS", "Value": [60.41]},
        "881": {"vr": "DS", "Value": [129.64]},
        "882": {"vr": "DS", "Value": [64.5275]},
        "883": {"vr": "DS", "Value": [123.64]},
        "884": {"vr": "DS", "Value": [507.015]},
        "885": {"vr": "DS", "Value": [597.5025]},
        "886": {"vr": "DS", "Value": [139.61]},
        "887": {"vr": "DS", "Value": [287.6]},
        "888": {"vr": "DS", "Value": [117.9125]},
        "889": {"vr": "DS", "Value": [53.0925]},
        "890": {"vr": "DS", "Value": [168.3725]},
        "891": {"vr": "DS", "Value": [299.035]},
        "892": {"vr": "DS", "Value": [551.8925]},
        "893": {"vr": "DS", "Value": [340.6925]},
        "894": {"vr": "DS", "Value": [160.8875]},
        "895": {"vr": "DS", "Value": [290.84]},
        "896": {"vr": "DS", "Value": [96.3425]},
        "897": {"vr": "DS", "Value": [291.28]},
        "898": {"vr": "DS", "Value": [324.41]},
        "899": {"vr": "DS", "Value": [230.7025]},
        "900": {"vr": "DS", "Value": [266.05]},
        "901": {"vr": "DS", "Value": [68.77]},
        "902": {"vr": "DS", "Value": [328.675]},
        "903": {"vr": "DS", "Value": [587.9725]},
        "904": {"vr": "DS", "Value": [73.62]},
        "905": {"vr": "DS", "Value": [147.0925]},
        "906": {"vr": "DS", "Value": [71.7175]},
        "907": {"vr": "DS", "Value": [419.015]},
        "908": {"vr": "DS", "Value": [292.1575]},
        "909": {"vr": "DS", "Value": [577.27]},
        "910": {"vr": "DS", "Value": [364.7525]},
        "911": {"vr": "DS", "Value": [239.65]},
        "912": {"vr": "DS", "Value": [562.3025]},
        "913": {"vr": "DS", "Value": [369.435]},
        "914": {"vr": "DS", "Value": [143.58]},
        "915": {"vr": "DS", "Value": [339.5225]},
        "916": {"vr": "DS", "Value": [567.445]},
        "917": {"vr": "DS", "Value": [404.8]},
        "918": {"vr": "DS", "Value": [473.5725]},
        "919": {"vr": "DS", "Value": [4.5375]},
        "920": {"vr": "DS", "Value": [100.8975]},
        "921": {"vr": "DS", "Value": [177.9025]},
        "922": {"vr": "DS", "Value": [472.84]},
        "923": {"vr": "DS", "Value": [448.4875]},
        "924": {"vr": "DS", "Value": [0.2925]},
        "925": {"vr": "DS", "Value": [46.3425]},
        "926": {"vr": "DS", "Value": [590.7725]},
        "927": {"vr": "DS", "Value": [417.5525]},
        "928": {"vr": "DS", "Value": [510.5475]},
        "929": {"vr": "DS", "Value": [330.1375]},
        "930": {"vr": "DS", "Value": [279.5325]},
        "931": {"vr": "DS", "Value": [298.595]},
        "932": {"vr": "DS", "Value": [593.405]},
        "933": {"vr": "DS", "Value": [371.65]},
        "934": {"vr": "DS", "Value": [38.1275]},
        "935": {"vr": "DS", "Value": [262.9575]},
        "936": {"vr": "DS", "Value": [402.44]},
        "937": {"vr": "DS", "Value": [261.785]},
        "938": {"vr": "DS", "Value": [589.435]},
        "939": {"vr": "DS", "Value": [234.3625]},
        "940": {"vr": "DS", "Value": [481.785]},
        "941": {"vr": "DS", "Value": [479.1525]},
        "942": {"vr": "DS", "Value": [129.2]},
        "943": {"vr": "DS", "Value": [261.9325]},
        "944": {"vr": "DS", "Value": [379.5725]},
        "945": {"vr": "DS", "Value": [544.265]},
        "946": {"vr": "DS", "Value": [372.5275]},
        "947": {"vr": "DS", "Value": [247.865]},
        "948": {"vr": "DS", "Value": [402.2925]},
        "949": {"vr": "DS", "Value": [194.9175]},
        "950": {"vr": "DS", "Value": [468.89]},
        "951": {"vr": "DS", "Value": [247.28]},
        "952": {"vr": "DS", "Value": [133.465]},
        "953": {"vr": "DS", "Value": [322.9475]},
        "954": {"vr": "DS", "Value": [430.7425]},
        "955": {"vr": "DS", "Value": [62.4775]},
        "956": {"vr": "DS", "Value": [403.3175]},
        "957": {"vr": "DS", "Value": [244.04]},
        "958": {"vr": "DS", "Value": [466.84]},
        "959": {"vr": "DS", "Value": [193.7475]},
        "960": {"vr": "DS", "Value": [258.86]},
        "961": {"vr": "DS", "Value": [302.1275]},
        "962": {"vr": "DS", "Value": [482.9575]},
        "963": {"vr": "DS", "Value": [420.4775]},
        "964": {"vr": "DS", "Value": [103.0925]},
        "965": {"vr": "DS", "Value": [160.7425]},
        "966": {"vr": "DS", "Value": [255.035]},
        "967": {"vr": "DS", "Value": [536.9475]},
        "968": {"vr": "DS", "Value": [128.3225]},
        "969": {"vr": "DS", "Value": [131.395]},
        "970": {"vr": "DS", "Value": [28.45]},
        "971": {"vr": "DS", "Value": [138.585]},
        "972": {"vr": "DS", "Value": [544.5575]},
        "973": {"vr": "DS", "Value": [505.405]},
        "974": {"vr": "DS", "Value": [333.795]},
        "975": {"vr": "DS", "Value": [388.08]},
        "976": {"vr": "DS", "Value": [169.835]},
        "977": {"vr": "DS", "Value": [279.24]},
        "978": {"vr": "DS", "Value": [595.3075]},
        "979": {"vr": "DS", "Value": [406.5575]},
        "980": {"vr": "DS", "Value": [414.04]},
        "981": {"vr": "DS", "Value": [518.595]},
        "982": {"vr": "DS", "Value": [243.015]},
        "983": {"vr": "DS", "Value": [403.1725]},
        "984": {"vr": "DS", "Value": [471.5225]},
        "985": {"vr": "DS", "Value": [279.0925]},
        "986": {"vr": "DS", "Value": [216.175]},
        "987": {"vr": "DS", "Value": [28.8875]},
        "988": {"vr": "DS", "Value": [510.0875]},
        "989": {"vr": "DS", "Value": [255.2]},
        "990": {"vr": "DS", "Value": [280.995]},
        "991": {"vr": "DS", "Value": [543.68]},
        "992": {"vr": "DS", "Value": [190.8]},
        "993": {"vr": "DS", "Value": [560.985]},
        "994": {"vr": "DS", "Value": [97.5325]},
        "995": {"vr": "DS", "Value": [482.225]},
        "996": {"vr": "DS", "Value": [589.7475]},
        "997": {"vr": "DS", "Value": [435.2975]},
        "998": {"vr": "DS", "Value": [469.7675]},
        "999": {"vr": "DS", "Value": [569.2]},
        "1000": {"vr": "DS", "Value": [290.9875]},
        "1001": {"vr": "DS", "Value": [569.9325]},
        "1002": {"vr": "DS", "Value": [56.02]},
        "1003": {"vr": "DS", "Value": [152.235]},
        "1004": {"vr": "DS", "Value": [518.45]},
        "1005": {"vr": "DS", "Value": [409.7775]},
        "1006": {"vr": "DS", "Value": [440.5875]},
        "1007": {"vr": "DS", "Value": [133.1725]},
        "1008": {"vr": "DS", "Value": [73.7675]},
        "1009": {"vr": "DS", "Value": [140.05]},
        "1010": {"vr": "DS", "Value": [513.475]},
        "1011": {"vr": "DS", "Value": [584.3125]},
        "1012": {"vr": "DS", "Value": [432.08]},
        "1013": {"vr": "DS", "Value": [440.88]},
        "1014": {"vr": "DS", "Value": [407.2875]},
        "1015": {"vr": "DS", "Value": [596.185]},
        "1016": {"vr": "DS", "Value": [208.84]},
        "1017": {"vr": "DS", "Value": [572.5875]},
        "1018": {"vr": "DS", "Value": [171.1525]},
        "1019": {"vr": "DS", "Value": [525.3475]},
        "1020": {"vr": "DS", "Value": [425.475]},
        "1021": {"vr": "DS", "Value": [560.4]},
        "1022": {"vr": "DS", "Value": [220.585]},
        "1023": {"vr": "DS", "Value": [246.6925]},
        "1024": {"vr": "DS", "Value": [434.5675]},
        "1025": {"vr": "DS", "Value": [37.98]},
        "1026": {"vr": "DS", "Value": [45.465]},
        "1027": {"vr": "DS", "Value": [426.645]},
        "1028": {"vr": "DS", "Value": [515.67]},
        "1029": {"vr": "DS", "Value": [347.005]},
        "1030": {"vr": "DS", "Value": [7.4625]},
        "1031": {"vr": "DS", "Value": [94.585]},
        "1032": {"vr": "DS", "Value": [204.01]},
        "1033": {"vr": "DS", "Value": [270.2925]},
        "1034": {"vr": "DS", "Value": [103.5325]},
        "1035": {"vr": "DS", "Value": [533.415]},
        "1036": {"vr": "DS", "Value": [224.245]},
        "1037": {"vr": "DS", "Value": [357.27]},
        "1038": {"vr": "DS", "Value": [87.5425]},
        "1039": {"vr": "DS", "Value": [209.425]},
        "1040": {"vr": "DS", "Value": [195.065]},
        "1041": {"vr": "DS", "Value": [425.1825]},
        "1042": {"vr": "DS", "Value": [197.1125]},
        "1043": {"vr": "DS", "Value": [317.825]},
        "1044": {"vr": "DS", "Value": [180.245]},
        "1045": {"vr": "DS", "Value": [55.58]},
        "1046": {"vr": "DS", "Value": [360.4875]},
        "1047": {"vr": "DS", "Value": [546.625]},
        "1048": {"vr": "DS", "Value": [558.645]},
        "1049": {"vr": "DS", "Value": [38.2725]},
        "1050": {"vr": "DS", "Value": [338.645]},
        "1051": {"vr": "DS", "Value": [289.795]},
        "1052": {"vr": "DS", "Value": [94.2925]},
        "1053": {"vr": "DS", "Value": [360.8]},
        "1054": {"vr": "DS", "Value": [86.225]},
        "1055": {"vr": "DS", "Value": [212.665]},
        "1056": {"vr": "DS", "Value": [481.3475]},
        "1057": {"vr": "DS", "Value": [554.4025]},
        "1058": {"vr": "DS", "Value": [435.445]},
        "1059": {"vr": "DS", "Value": [238.625]},
        "1060": {"vr": "DS", "Value": [6.44]},
        "1061": {"vr": "DS", "Value": [44.44]},
        "1062": {"vr": "DS", "Value": [142.265]},
        "1063": {"vr": "DS", "Value": [215.7375]},
        "1064": {"vr": "DS", "Value": [147.24]},
        "1065": {"vr": "DS", "Value": [209.57]},
        "1066": {"vr": "DS", "Value": [229.9725]},
        "1067": {"vr": "DS", "Value": [422.9875]},
        "1068": {"vr": "DS", "Value": [489.27]},
        "1069": {"vr": "DS", "Value": [349.3475]},
        "1070": {"vr": "DS", "Value": [132.44]},
        "1071": {"vr": "DS", "Value": [478.42]},
        "1072": {"vr": "DS", "Value": [427.5225]},
        "1073": {"vr": "DS", "Value": [593.5525]},
        "1074": {"vr": "DS", "Value": [588.41]},
        "1075": {"vr": "DS", "Value": [97.9725]},
        "1076": {"vr": "DS", "Value": [352.2925]},
        "1077": {"vr": "DS", "Value": [448.9475]},
        "1078": {"vr": "DS", "Value": [131.6875]},
        "1079": {"vr": "DS", "Value": [483.835]},
        "1080": {"vr": "DS", "Value": [198.1375]},
        "1081": {"vr": "DS", "Value": [107.795]},
        "1082": {"vr": "DS", "Value": [426.06]},
        "1083": {"vr": "DS", "Value": [428.4]},
        "1084": {"vr": "DS", "Value": [74.79]},
        "1085": {"vr": "DS", "Value": [480.615]},
        "1086": {"vr": "DS", "Value": [422.84]},
        "1087": {"vr": "DS", "Value": [424.7425]},
        "1088": {"vr": "DS", "Value": [500.5575]},
        "1089": {"vr": "DS", "Value": [412.5575]},
        "1090": {"vr": "DS", "Value": [300.665]},
        "1091": {"vr": "DS", "Value": [210.45]},
        "1092": {"vr": "DS", "Value": [408.1675]},
        "1093": {"vr": "DS", "Value": [79.3475]},
        "1094": {"vr": "DS", "Value": [570.665]},
        "1095": {"vr": "DS", "Value": [436.7625]},
        "1096": {"vr": "DS", "Value": [370.3325]},
        "1097": {"vr": "DS", "Value": [208.6925]},
        "1098": {"vr": "DS", "Value": [509.9425]},
        "1099": {"vr": "DS", "Value": [387.2]},
        "1100": {"vr": "DS", "Value": [287.3075]},
        "1101": {"vr": "DS", "Value": [382.9375]},
        "1102": {"vr": "DS", "Value": [374.7225]},
        "1103": {"vr": "DS", "Value": [485.61]},
        "1104": {"vr": "DS", "Value": [94.1475]},
        "1105": {"vr": "DS", "Value": [397.3175]},
        "1106": {"vr": "DS", "Value": [95.61]},
        "1107": {"vr": "DS", "Value": [292.8875]},
        "1108": {"vr": "DS", "Value": [150.185]},
        "1109": {"vr": "DS", "Value": [564.665]},
        "1110": {"vr": "DS", "Value": [492.8]},
        "1111": {"vr": "DS", "Value": [179.3675]},
        "1112": {"vr": "DS", "Value": [136.975]},
        "1113": {"vr": "DS", "Value": [412.85]},
        "1114": {"vr": "DS", "Value": [289.065]},
        "1115": {"vr": "DS", "Value": [554.5475]},
        "1116": {"vr": "DS", "Value": [24.4775]},
        "1117": {"vr": "DS", "Value": [454.3625]},
        "1118": {"vr": "DS", "Value": [134.195]},
        "1119": {"vr": "DS", "Value": [553.21]},
        "1120": {"vr": "DS", "Value": [568.03]},
        "1121": {"vr": "DS", "Value": [281.435]},
        "1122": {"vr": "DS", "Value": [131.25]},
        "1123": {"vr": "DS", "Value": [70.985]},
        "1124": {"vr": "DS", "Value": [272.195]},
        "1125": {"vr": "DS", "Value": [252.1075]},
        "1126": {"vr": "DS", "Value": [586.9475]},
        "1127": {"vr": "DS", "Value": [101.63]},
        "1128": {"vr": "DS", "Value": [380.01]},
        "1129": {"vr": "DS", "Value": [221.465]},
        "1130": {"vr": "DS", "Value": [564.81]},
        "1131": {"vr": "DS", "Value": [113.65]},
        "1132": {"vr": "DS", "Value": [102.8]},
        "1133": {"vr": "DS", "Value": [355.5125]},
        "1134": {"vr": "DS", "Value": [431.2]},
        "1135": {"vr": "DS", "Value": [256.08]},
        "1136": {"vr": "DS", "Value": [207.67]},
        "1137": {"vr": "DS", "Value": [470.645]},
        "1138": {"vr": "DS", "Value": [93.5625]},
        "1139": {"vr": "DS", "Value": [310.9275]},
        "1140": {"vr": "DS", "Value": [51.61]},
        "1141": {"vr": "DS", "Value": [236.41]},
        "1142": {"vr": "DS", "Value": [69.5025]},
        "1143": {"vr": "DS", "Value": [93.2675]},
        "1144": {"vr": "DS", "Value": [150.04]},
        "1145": {"vr": "DS", "Value": [297.1325]},
        "1146": {"vr": "DS", "Value": [189.9225]},
        "1147": {"vr": "DS", "Value": [595.015]},
        "1148": {"vr": "DS", "Value": [112.185]},
        "1149": {"vr": "DS", "Value": [2.635]},
        "1150": {"vr": "DS", "Value": [576.0975]},
        "1151": {"vr": "DS", "Value": [264.0]},
        "1152": {"vr": "DS", "Value": [333.21]},
        "1153": {"vr": "DS", "Value": [296.5475]},
        "1154": {"vr": "DS", "Value": [349.785]},
        "1155": {"vr": "DS", "Value": [335.5725]},
        "1156": {"vr": "DS", "Value": [102.215]},
        "1157": {"vr": "DS", "Value": [32.4]},
        "1158": {"vr": "DS", "Value": [467.425]},
        "1159": {"vr": "DS", "Value": [293.1825]},
        "1160": {"vr": "DS", "Value": [357.5625]},
        "1161": {"vr": "DS", "Value": [116.595]},
        "1162": {"vr": "DS", "Value": [382.79]},
        "1163": {"vr": "DS", "Value": [377.795]},
        "1164": {"vr": "DS", "Value": [259.005]},
        "1165": {"vr": "DS", "Value": [498.9475]},
        "1166": {"vr": "DS", "Value": [6.7325]},
        "1167": {"vr": "DS", "Value": [443.3675]},
        "1168": {"vr": "DS", "Value": [60.995]},
        "1169": {"vr": "DS", "Value": [480.3225]},
        "1170": {"vr": "DS", "Value": [505.26]},
        "1171": {"vr": "DS", "Value": [84.03]},
        "1172": {"vr": "DS", "Value": [407.5825]},
        "1173": {"vr": "DS", "Value": [547.795]},
        "1174": {"vr": "DS", "Value": [410.07]},
        "1175": {"vr": "DS", "Value": [458.04]},
        "1176": {"vr": "DS", "Value": [451.1425]},
        "1177": {"vr": "DS", "Value": [513.9125]},
        "1178": {"vr": "DS", "Value": [8.195]},
        "1179": {"vr": "DS", "Value": [152.0875]},
        "1180": {"vr": "DS", "Value": [237.1425]},
        "1181": {"vr": "DS", "Value": [219.6875]},
        "1182": {"vr": "DS", "Value": [47.805]},
        "1183": {"vr": "DS", "Value": [323.24]},
        "1184": {"vr": "DS", "Value": [478.275]},
        "1185": {"vr": "DS", "Value": [241.1125]},
        "1186": {"vr": "DS", "Value": [35.64]},
        "1187": {"vr": "DS", "Value": [280.7025]},
        "1188": {"vr": "DS", "Value": [463.8925]},
        "1189": {"vr": "DS", "Value": [494.7025]},
        "1190": {"vr": "DS", "Value": [541.63]},
        "1191": {"vr": "DS", "Value": [6.1475]},
        "1192": {"vr": "DS", "Value": [117.62]},
        "1193": {"vr": "DS", "Value": [303.8825]},
        "1194": {"vr": "DS", "Value": [585.9225]},
        "1195": {"vr": "DS", "Value": [256.9575]},
        "1196": {"vr": "DS", "Value": [34.45]},
        "1197": {"vr": "DS", "Value": [552.9175]},
        "1198": {"vr": "DS", "Value": [211.4925]},
        "1199": {"vr": "DS", "Value": [424.595]},
        "1200": {"vr": "DS", "Value": [485.7575]},
        "1201": {"vr": "DS", "Value": [3.9525]},
        "1202": {"vr": "DS", "Value": [109.6975]},
        "1203": {"vr": "DS", "Value": [576.9775]},
        "1204": {"vr": "DS", "Value": [446.44]},
        "1205": {"vr": "DS", "Value": [348.03]},
        "1206": {"vr": "DS", "Value": [508.04]},
        "1207": {"vr": "DS", "Value": [378.0875]},
        "1208": {"vr": "DS", "Value": [29.62]},
        "1209": {"vr": "DS", "Value": [47.9525]},
        "1210": {"vr": "DS", "Value": [331.015]},
        "1211": {"vr": "DS", "Value": [573.465]},
        "1212": {"vr": "DS", "Value": [148.2625]},
        "1213": {"vr": "DS", "Value": [314.8775]},
        "1214": {"vr": "DS", "Value": [536.195]},
        "1215": {"vr": "DS", "Value": [340.5475]},
        "1216": {"vr": "DS", "Value": [426.4975]},
        "1217": {"vr": "DS", "Value": [444.6825]},
        "1218": {"vr": "DS", "Value": [26.4]},
        "1219": {"vr": "DS", "Value": [494.995]},
        "1220": {"vr": "DS", "Value": [499.6775]},
        "1221": {"vr": "DS", "Value": [556.3025]},
        "1222": {"vr": "DS", "Value": [128.615]},
        "1223": {"vr": "DS", "Value": [532.39]},
        "1224": {"vr": "DS", "Value": [227.7575]},
        "1225": {"vr": "DS", "Value": [36.81]},
        "1226": {"vr": "DS", "Value": [27.1325]},
        "1227": {"vr": "DS", "Value": [559.085]},
        "1228": {"vr": "DS", "Value": [554.9875]},
        "1229": {"vr": "DS", "Value": [409.63]},
        "1230": {"vr": "DS", "Value": [384.84]},
        "1231": {"vr": "DS", "Value": [519.2]},
        "1232": {"vr": "DS", "Value": [549.26]},
        "1233": {"vr": "DS", "Value": [156.185]},
        "1234": {"vr": "DS", "Value": [89.9025]},
        "1235": {"vr": "DS", "Value": [196.675]},
        "1236": {"vr": "DS", "Value": [34.3025]},
        "1237": {"vr": "DS", "Value": [581.3875]},
        "1238": {"vr": "DS", "Value": [196.235]},
        "1239": {"vr": "DS", "Value": [114.5475]},
        "1240": {"vr": "DS", "Value": [126.86]},
        "1241": {"vr": "DS", "Value": [21.5525]},
        "1242": {"vr": "DS", "Value": [410.8]},
        "1243": {"vr": "DS", "Value": [459.065]},
        "1244": {"vr": "DS", "Value": [339.9625]},
        "1245": {"vr": "DS", "Value": [230.1175]},
        "1246": {"vr": "DS", "Value": [458.625]},
        "1247": {"vr": "DS", "Value": [152.5275]},
        "1248": {"vr": "DS", "Value": [293.9125]},
        "1249": {"vr": "DS", "Value": [519.3475]},
        "1250": {"vr": "DS", "Value": [48.39]},
        "1251": {"vr": "DS", "Value": [388.9575]},
        "1252": {"vr": "DS", "Value": [293.475]},
        "1253": {"vr": "DS", "Value": [507.3075]},
        "1254": {"vr": "DS", "Value": [211.9325]},
        "1255": {"vr": "DS", "Value": [225.415]},
        "1256": {"vr": "DS", "Value": [431.3475]},
        "1257": {"vr": "DS", "Value": [24.9175]},
        "1258": {"vr": "DS", "Value": [64.38]},
        "1259": {"vr": "DS", "Value": [469.62]},
        "1260": {"vr": "DS", "Value": [396.44]},
        "1261": {"vr": "DS", "Value": [96.635]},
        "1262": {"vr": "DS", "Value": [151.065]},
        "1263": {"vr": "DS", "Value": [407.435]},
        "1264": {"vr": "DS", "Value": [112.4775]},
        "1265": {"vr": "DS", "Value": [132.7325]},
        "1266": {"vr": "DS", "Value": [172.9075]},
        "1267": {"vr": "DS", "Value": [337.62]},
        "1268": {"vr": "DS", "Value": [290.5475]},
        "1269": {"vr": "DS", "Value": [61.435]},
        "1270": {"vr": "DS", "Value": [86.0775]},
        "1271": {"vr": "DS", "Value": [594.5775]},
        "1272": {"vr": "DS", "Value": [264.1475]},
        "1273": {"vr": "DS", "Value": [136.0975]},
        "1274": {"vr": "DS", "Value": [415.9425]},
        "1275": {"vr": "DS", "Value": [471.3775]},
        "1276": {"vr": "DS", "Value": [540.3125]},
        "1277": {"vr": "DS", "Value": [557.3275]},
        "1278": {"vr": "DS", "Value": [255.7875]},
        "1279": {"vr": "DS", "Value": [236.7025]},
        "1280": {"vr": "DS", "Value": [57.4825]},
        "1281": {"vr": "DS", "Value": [420.185]},
        "1282": {"vr": "DS", "Value": [113.9425]},
        "1283": {"vr": "DS", "Value": [417.6975]},
        "1284": {"vr": "DS", "Value": [428.6925]},
        "1285": {"vr": "DS", "Value": [242.7225]},
        "1286": {"vr": "DS", "Value": [237.435]},
        "1287": {"vr": "DS", "Value": [247.1325]},
        "1288": {"vr": "DS", "Value": [187.1425]},
        "1289": {"vr": "DS", "Value": [454.07]},
        "1290": {"vr": "DS", "Value": [178.05]},
        "1291": {"vr": "DS", "Value": [4.0975]},
        "1292": {"vr": "DS", "Value": [260.3225]},
        "1293": {"vr": "DS", "Value": [309.465]},
        "1294": {"vr": "DS", "Value": [513.3275]},
        "1295": {"vr": "DS", "Value": [267.5125]},
        "1296": {"vr": "DS", "Value": [134.05]},
        "1297": {"vr": "DS", "Value": [127.1525]},
        "1298": {"vr": "DS", "Value": [23.7475]},
        "1299": {"vr": "DS", "Value": [83.445]},
        "1300": {"vr": "DS", "Value": [302.42]},
        "1301": {"vr": "DS", "Value": [283.065]},
        "1302": {"vr": "DS", "Value": [26.6925]},
        "1303": {"vr": "DS", "Value": [532.83]},
        "1304": {"vr": "DS", "Value": [252.84]},
        "1305": {"vr": "DS", "Value": [294.79]},
        "1306": {"vr": "DS", "Value": [49.2675]},
        "1307": {"vr": "DS", "Value": [486.195]},
        "1308": {"vr": "DS", "Value": [86.37]},
        "1309": {"vr": "DS", "Value": [106.04]},
        "1310": {"vr": "DS", "Value": [24.77]},
        "1311": {"vr": "DS", "Value": [283.9425]},
        "1312": {"vr": "DS", "Value": [545.895]},
        "1313": {"vr": "DS", "Value": [269.855]},
        "1314": {"vr": "DS", "Value": [146.0675]},
        "1315": {"vr": "DS", "Value": [25.5025]},
        "1316": {"vr": "DS", "Value": [328.3825]},
        "1317": {"vr": "DS", "Value": [231.58]},
        "1318": {"vr": "DS", "Value": [53.385]},
        "1319": {"vr": "DS", "Value": [90.195]},
        "1320": {"vr": "DS", "Value": [465.3575]},
        "1321": {"vr": "DS", "Value": [284.38]},
        "1322": {"vr": "DS", "Value": [69.9425]},
        "1323": {"vr": "DS", "Value": [164.84]},
        "1324": {"vr": "DS", "Value": [203.7175]},
        "1325": {"vr": "DS", "Value": [32.1075]},
        "1326": {"vr": "DS", "Value": [202.6925]},
        "1327": {"vr": "DS", "Value": [542.8]},
        "1328": {"vr": "DS", "Value": [137.855]},
        "1329": {"vr": "DS", "Value": [407.1425]},
        "1330": {"vr": "DS", "Value": [594.1375]},
        "1331": {"vr": "DS", "Value": [253.1325]},
        "1332": {"vr": "DS", "Value": [525.4925]},
        "1333": {"vr": "DS", "Value": [500.7025]},
        "1334": {"vr": "DS", "Value": [454.8]},
        "1335": {"vr": "DS", "Value": [167.4925]},
        "1336": {"vr": "DS", "Value": [314.0]},
        "1337": {"vr": "DS", "Value": [141.9725]},
        "1338": {"vr": "DS", "Value": [223.22]},
        "1339": {"vr": "DS", "Value": [439.395]},
        "1340": {"vr": "DS", "Value": [60.1175]},
        "1341": {"vr": "DS", "Value": [551.7475]},
        "1342": {"vr": "DS", "Value": [72.01]},
        "1343": {"vr": "DS", "Value": [463.3075]},
        "1344": {"vr": "DS", "Value": [137.7075]},
        "1345": {"vr": "DS", "Value": [139.9025]},
        "1346": {"vr": "DS", "Value": [78.45]},
        "1347": {"vr": "DS", "Value": [7.17]},
        "1348": {"vr": "DS", "Value": [384.5475]},
        "1349": {"vr": "DS", "Value": [78.595]},
        "1350": {"vr": "DS", "Value": [383.23]},
        "1351": {"vr": "DS", "Value": [50.2925]},
        "1352": {"vr": "DS", "Value": [296.6925]},
        "1353": {"vr": "DS", "Value": [461.6975]},
        "1354": {"vr": "DS", "Value": [559.23]},
        "1355": {"vr": "DS", "Value": [195.3575]},
        "1356": {"vr": "DS", "Value": [278.5075]},
        "1357": {"vr": "DS", "Value": [327.795]},
        "1358": {"vr": "DS", "Value": [109.99]},
        "1359": {"vr": "DS", "Value": [534.88]},
        "1360": {"vr": "DS", "Value": [535.025]},
        "1361": {"vr": "DS", "Value": [63.9425]},
        "1362": {"vr": "DS", "Value": [19.65]},
        "1363": {"vr": "DS", "Value": [124.225]},
        "1364": {"vr": "DS", "Value": [145.045]},
        "1365": {"vr": "DS", "Value": [334.9875]},
        "1366": {"vr": "DS", "Value": [221.61]},
        "1367": {"vr": "DS", "Value": [54.85]},
        "1368": {"vr": "DS", "Value": [188.7525]},
        "1369": {"vr": "DS", "Value": [213.98]},
        "1370": {"vr": "DS", "Value": [284.675]},
        "1371": {"vr": "DS", "Value": [83.005]},
        "1372": {"vr": "DS", "Value": [58.0675]},
        "1373": {"vr": "DS", "Value": [430.01]},
        "1374": {"vr": "DS", "Value": [317.5325]},
        "1375": {"vr": "DS", "Value": [208.1075]},
        "1376": {"vr": "DS", "Value": [84.3225]},
        "1377": {"vr": "DS", "Value": [93.415]},
        "1378": {"vr": "DS", "Value": [569.785]},
        "1379": {"vr": "DS", "Value": [578.7325]},
        "1380": {"vr": "DS", "Value": [343.7875]},
        "1381": {"vr": "DS", "Value": [496.605]},
        "1382": {"vr": "DS", "Value": [503.3575]},
        "1383": {"vr": "DS", "Value": [147.5325]},
        "1384": {"vr": "DS", "Value": [79.035]},
        "1385": {"vr": "DS", "Value": [228.3425]},
        "1386": {"vr": "DS", "Value": [411.825]},
        "1387": {"vr": "DS", "Value": [225.7075]},
        "1388": {"vr": "DS", "Value": [347.59]},
        "1389": {"vr": "DS", "Value": [72.8875]},
        "1390": {"vr": "DS", "Value": [233.9225]},
        "1391": {"vr": "DS", "Value": [19.3575]},
        "1392": {"vr": "DS", "Value": [537.5325]},
        "1393": {"vr": "DS", "Value": [227.17]},
        "1394": {"vr": "DS", "Value": [315.3175]},
        "1395": {"vr": "DS", "Value": [267.3675]},
        "1396": {"vr": "DS", "Value": [375.455]},
        "1397": {"vr": "DS", "Value": [273.5325]},
        "1398": {"vr": "DS", "Value": [173.785]},
        "1399": {"vr": "DS", "Value": [200.4775]},
        "1400": {"vr": "DS", "Value": [348.9075]},
        "1401": {"vr": "DS", "Value": [158.6925]},
        "1402": {"vr": "DS", "Value": [526.225]},
        "1403": {"vr": "DS", "Value": [296.1075]},
        "1404": {"vr": "DS", "Value": [1.025]},
        "1405": {"vr": "DS", "Value": [32.985]},
        "1406": {"vr": "DS", "Value": [148.85]},
        "1407": {"vr": "DS", "Value": [125.25]},
        "1408": {"vr": "DS", "Value": [198.43]},
        "1409": {"vr": "DS", "Value": [130.5175]},
        "1410": {"vr": "DS", "Value": [527.5425]},
        "1411": {"vr": "DS", "Value": [92.245]},
        "1412": {"vr": "DS", "Value": [340.84]},
        "1413": {"vr": "DS", "Value": [499.5325]},
        "1414": {"vr": "DS", "Value": [383.3775]},
        "1415": {"vr": "DS", "Value": [40.3225]},
        "1416": {"vr": "DS", "Value": [141.825]},
        "1417": {"vr": "DS", "Value": [106.625]},
        "1418": {"vr": "DS", "Value": [319.7275]},
        "1419": {"vr": "DS", "Value": [522.1275]},
        "1420": {"vr": "DS", "Value": [455.5325]},
        "1421": {"vr": "DS", "Value": [144.1675]},
        "1422": {"vr": "DS", "Value": [504.82]},
        "1423": {"vr": "DS", "Value": [277.63]},
        "1424": {"vr": "DS", "Value": [547.5025]},
        "1425": {"vr": "DS", "Value": [232.7525]},
        "1426": {"vr": "DS", "Value": [470.3525]},
        "1427": {"vr": "DS", "Value": [435.59]},
        "1428": {"vr": "DS", "Value": [256.81]},
        "1429": {"vr": "DS", "Value": [511.425]},
        "1430": {"vr": "DS", "Value": [500.265]},
        "1431": {"vr": "DS", "Value": [567.7375]},
        "1432": {"vr": "DS", "Value": [277.4825]},
        "1433": {"vr": "DS", "Value": [451.435]},
        "1434": {"vr": "DS", "Value": [390.7125]},
        "1435": {"vr": "DS", "Value": [338.3525]},
        "1436": {"vr": "DS", "Value": [474.01]},
        "1437": {"vr": "DS", "Value": [386.7425]},
        "1438": {"vr": "DS", "Value": [57.19]},
        "1439": {"vr": "DS", "Value": [315.17]},
        "1440": {"vr": "DS", "Value": [577.415]},
        "1441": {"vr": "DS", "Value": [329.5525]},
        "1442": {"vr": "DS", "Value": [0.585]},
        "1443": {"vr": "DS", "Value": [574.3425]},
        "1444": {"vr": "DS", "Value": [331.6]},
        "1445": {"vr": "DS", "Value": [536.05]},
        "1446": {"vr": "DS", "Value": [421.21]},
        "1447": {"vr": "DS", "Value": [162.205]},
        "1448": {"vr": "DS", "Value": [48.6825]},
        "1449": {"vr": "DS", "Value": [106.48]},
        "1450": {"vr": "DS", "Value": [175.25]},
        "1451": {"vr": "DS", "Value": [273.9725]},
        "1452": {"vr": "DS", "Value": [19.5025]},
        "1453": {"vr": "DS", "Value": [422.695]},
        "1454": {"vr": "DS", "Value": [557.1825]},
        "1455": {"vr": "DS", "Value": [594.87]},
        "1456": {"vr": "DS", "Value": [341.2775]},
        "1457": {"vr": "DS", "Value": [119.9625]},
        "1458": {"vr": "DS", "Value": [580.635]},
        "1459": {"vr": "DS", "Value": [71.2775]},
        "1460": {"vr": "DS", "Value": [496.8975]},
        "1461": {"vr": "DS", "Value": [111.7475]},
        "1462": {"vr": "DS", "Value": [270.1475]},
        "1463": {"vr": "DS", "Value": [265.9025]},
        "1464": {"vr": "DS", "Value": [487.5125]},
        "1465": {"vr": "DS", "Value": [362.5575]},
        "1466": {"vr": "DS", "Value": [158.0875]},
        "1467": {"vr": "DS", "Value": [133.9025]},
        "1468": {"vr": "DS", "Value": [413.895]},
        "1469": {"vr": "DS", "Value": [538.7025]},
        "1470": {"vr": "DS", "Value": [358.2925]},
        "1471": {"vr": "DS", "Value": [502.1875]},
        "1472": {"vr": "DS", "Value": [147.97]},
        "1473": {"vr": "DS", "Value": [151.795]},
        "1474": {"vr": "DS", "Value": [400.9775]},
        "1475": {"vr": "DS", "Value": [506.5775]},
        "1476": {"vr": "DS", "Value": [219.1025]},
        "1477": {"vr": "DS", "Value": [46.05]},
        "1478": {"vr": "DS", "Value": [223.66]},
        "1479": {"vr": "DS", "Value": [378.6925]},
        "1480": {"vr": "DS", "Value": [456.41]},
        "1481": {"vr": "DS", "Value": [483.5425]},
        "1482": {"vr": "DS", "Value": [455.825]},
        "1483": {"vr": "DS", "Value": [446.8775]},
        "1484": {"vr": "DS", "Value": [340.985]},
        "1485": {"vr": "DS", "Value": [242.1375]},
        "1486": {"vr": "DS", "Value": [97.825]},
        "1487": {"vr": "DS", "Value": [570.5175]},
        "1488": {"vr": "DS", "Value": [399.5125]},
        "1489": {"vr": "DS", "Value": [250.06]},
        "1490": {"vr": "DS", "Value": [332.3325]},
        "1491": {"vr": "DS", "Value": [185.9725]},
        "1492": {"vr": "DS", "Value": [359.17]},
        "1493": {"vr": "DS", "Value": [109.5525]},
        "1494": {"vr": "DS", "Value": [546.3325]},
        "1495": {"vr": "DS", "Value": [410.215]},
        "1496": {"vr": "DS", "Value": [519.64]},
        "1497": {"vr": "DS", "Value": [127.005]},
        "1498": {"vr": "DS", "Value": [262.81]},
        "1499": {"vr": "DS", "Value": [519.9325]},
        "1500": {"vr": "DS", "Value": [381.3275]},
        "1501": {"vr": "DS", "Value": [154.2825]},
        "1502": {"vr": "DS", "Value": [361.3875]},
        "1503": {"vr": "DS", "Value": [506.7225]},
        "1504": {"vr": "DS", "Value": [365.9225]},
        "1505": {"vr": "DS", "Value": [175.5425]},
        "1506": {"vr": "DS", "Value": [249.7675]},
        "1507": {"vr": "DS", "Value": [173.055]},
        "1508": {"vr": "DS", "Value": [64.6725]},
        "1509": {"vr": "DS", "Value": [115.1325]},
        "1510": {"vr": "DS", "Value": [385.7175]},
        "1511": {"vr": "DS", "Value": [502.04]},
        "1512": {"vr": "DS", "Value": [400.6825]},
        "1513": {"vr": "DS", "Value": [45.1725]},
        "1514": {"vr": "DS", "Value": [141.0925]},
        "1515": {"vr": "DS", "Value": [1.7575]},
        "1516": {"vr": "DS", "Value": [28.01]},
        "1517": {"vr": "DS", "Value": [499.0925]},
        "1518": {"vr": "DS", "Value": [474.3025]},
        "1519": {"vr": "DS", "Value": [322.215]},
        "1520": {"vr": "DS", "Value": [216.03]},
        "1521": {"vr": "DS", "Value": [492.3425]},
        "1522": {"vr": "DS", "Value": [173.64]},
        "1523": {"vr": "DS", "Value": [217.4925]},
        "1524": {"vr": "DS", "Value": [259.2975]},
        "1525": {"vr": "DS", "Value": [80.9575]},
        "1526": {"vr": "DS", "Value": [149.435]},
        "1527": {"vr": "DS", "Value": [467.5725]},
        "1528": {"vr": "DS", "Value": [31.23]},
        "1529": {"vr": "DS", "Value": [244.625]},
        "1530": {"vr": "DS", "Value": [445.5625]},
        "1531": {"vr": "DS", "Value": [272.9475]},
        "1532": {"vr": "DS", "Value": [547.3575]},
        "1533": {"vr": "DS", "Value": [155.3075]},
        "1534": {"vr": "DS", "Value": [223.9525]},
        "1535": {"vr": "DS", "Value": [142.1175]},
        "1536": {"vr": "DS", "Value": [301.5425]},
        "1537": {"vr": "DS", "Value": [50.0]},
        "1538": {"vr": "DS", "Value": [47.5125]},
        "1539": {"vr": "DS", "Value": [99.8725]},
        "1540": {"vr": "DS", "Value": [318.1175]},
        "1541": {"vr": "DS", "Value": [337.475]},
        "1542": {"vr": "DS", "Value": [164.5475]},
        "1543": {"vr": "DS", "Value": [222.3425]},
        "1544": {"vr": "DS", "Value": [298.7425]},
        "1545": {"vr": "DS", "Value": [274.41]},
        "1546": {"vr": "DS", "Value": [349.055]},
        "1547": {"vr": "DS", "Value": [332.04]},
        "1548": {"vr": "DS", "Value": [315.7575]},
        "1549": {"vr": "DS", "Value": [243.6]},
        "1550": {"vr": "DS", "Value": [181.5625]},
        "1551": {"vr": "DS", "Value": [192.5575]},
        "1552": {"vr": "DS", "Value": [236.2625]},
        "1553": {"vr": "DS", "Value": [108.38]},
        "1554": {"vr": "DS", "Value": [292.01]},
        "1555": {"vr": "DS", "Value": [5.855]},
        "1556": {"vr": "DS", "Value": [353.9025]},
        "1557": {"vr": "DS", "Value": [285.405]},
        "1558": {"vr": "DS", "Value": [254.595]},
        "1559": {"vr": "DS", "Value": [398.195]},
        "1560": {"vr": "DS", "Value": [563.64]},
        "1561": {"vr": "DS", "Value": [312.245]},
        "1562": {"vr": "DS", "Value": [493.68]},
        "1563": {"vr": "DS", "Value": [148.5575]},
        "1564": {"vr": "DS", "Value": [153.5525]},
        "1565": {"vr": "DS", "Value": [78.155]},
        "1566": {"vr": "DS", "Value": [325.8925]},
        "1567": {"vr": "DS", "Value": [185.825]},
        "1568": {"vr": "DS", "Value": [316.8]},
        "1569": {"vr": "DS", "Value": [509.065]},
        "1570": {"vr": "DS", "Value": [361.825]},
        "1571": {"vr": "DS", "Value": [37.5425]},
        "1572": {"vr": "DS", "Value": [224.39]},
        "1573": {"vr": "DS", "Value": [343.9325]},
        "1574": {"vr": "DS", "Value": [302.86]},
        "1575": {"vr": "DS", "Value": [360.3425]},
        "1576": {"vr": "DS", "Value": [95.025]},
        "1577": {"vr": "DS", "Value": [377.5025]},
        "1578": {"vr": "DS", "Value": [577.855]},
        "1579": {"vr": "DS", "Value": [578.88]},
        "1580": {"vr": "DS", "Value": [426.9375]},
        "1581": {"vr": "DS", "Value": [266.195]},
        "1582": {"vr": "DS", "Value": [445.1225]},
        "1583": {"vr": "DS", "Value": [350.0775]},
        "1584": {"vr": "DS", "Value": [141.68]},
        "1585": {"vr": "DS", "Value": [517.5725]},
        "1586": {"vr": "DS", "Value": [467.865]},
        "1587": {"vr": "DS", "Value": [350.5175]},
        "1588": {"vr": "DS", "Value": [394.225]},
        "1589": {"vr": "DS", "Value": [123.3475]},
        "1590": {"vr": "DS", "Value": [211.035]},
        "1591": {"vr": "DS", "Value": [146.9475]},
        "1592": {"vr": "DS", "Value": [512.7425]},
        "1593": {"vr": "DS", "Value": [338.4975]},
        "1594": {"vr": "DS", "Value": [495.1425]},
        "1595": {"vr": "DS", "Value": [560.6925]},
        "1596": {"vr": "DS", "Value": [61.7475]},
        "1597": {"vr": "DS", "Value": [261.3475]},
        "1598": {"vr": "DS", "Value": [531.5125]},
        "1599": {"vr": "DS", "Value": [432.225]},
        "1600": {"vr": "DS", "Value": [399.3675]},
        "1601": {"vr": "DS", "Value": [8.05]},
        "1602": {"vr": "DS", "Value": [540.02]},
        "1603": {"vr": "DS", "Value": [592.09]},
        "1604": {"vr": "DS", "Value": [113.3575]},
        "1605": {"vr": "DS", "Value": [364.1675]},
        "1606": {"vr": "DS", "Value": [566.1275]},
        "1607": {"vr": "DS", "Value": [217.9325]},
        "1608": {"vr": "DS", "Value": [484.1475]},
        "1609": {"vr": "DS", "Value": [269.415]},
        "1610": {"vr": "DS", "Value": [306.37]},
        "1611": {"vr": "DS", "Value": [457.435]},
        "1612": {"vr": "DS", "Value": [281.1425]},
        "1613": {"vr": "DS", "Value": [460.9675]},
        "1614": {"vr": "DS", "Value": [146.5075]},
        "1615": {"vr": "DS", "Value": [473.865]},
        "1616": {"vr": "DS", "Value": [142.5575]},
        "1617": {"vr": "DS", "Value": [295.23]},
        "1618": {"vr": "DS", "Value": [286.43]},
        "1619": {"vr": "DS", "Value": [35.035]},
        "1620": {"vr": "DS", "Value": [136.6825]},
        "1621": {"vr": "DS", "Value": [291.1325]},
        "1622": {"vr": "DS", "Value": [384.4]},
        "1623": {"vr": "DS", "Value": [279.825]},
        "1624": {"vr": "DS", "Value": [540.46]},
        "1625": {"vr": "DS", "Value": [204.45]},
        "1626": {"vr": "DS", "Value": [327.9425]},
        "1627": {"vr": "DS", "Value": [214.5675]},
        "1628": {"vr": "DS", "Value": [331.7475]},
        "1629": {"vr": "DS", "Value": [454.9475]},
        "1630": {"vr": "DS", "Value": [574.9275]},
        "1631": {"vr": "DS", "Value": [115.7175]},
        "1632": {"vr": "DS", "Value": [391.59]},
        "1633": {"vr": "DS", "Value": [330.7225]},
        "1634": {"vr": "DS", "Value": [38.42]},
        "1635": {"vr": "DS", "Value": [436.1775]},
        "1636": {"vr": "DS", "Value": [59.97]},
        "1637": {"vr": "DS", "Value": [413.6]},
        "1638": {"vr": "DS", "Value": [247.425]},
        "1639": {"vr": "DS", "Value": [504.235]},
        "1640": {"vr": "DS", "Value": [104.2625]},
        "1641": {"vr": "DS", "Value": [588.7025]},
        "1642": {"vr": "DS", "Value": [31.6675]},
        "1643": {"vr": "DS", "Value": [593.6975]},
        "1644": {"vr": "DS", "Value": [301.1025]},
        "1645": {"vr": "DS", "Value": [535.465]},
        "1646": {"vr": "DS", "Value": [450.995]},
        "1647": {"vr": "DS", "Value": [512.3025]},
        "1648": {"vr": "DS", "Value": [153.405]},
        "1649": {"vr": "DS", "Value": [208.985]},
        "1650": {"vr": "DS", "Value": [294.9375]},
        "1651": {"vr": "DS", "Value": [465.065]},
        "1652": {"vr": "DS", "Value": [250.4975]},
        "1653": {"vr": "DS", "Value": [278.07]},
        "1654": {"vr": "DS", "Value": [171.2975]},
        "1655": {"vr": "DS", "Value": [405.095]},
        "1656": {"vr": "DS", "Value": [275.58]},
        "1657": {"vr": "DS", "Value": [395.6875]},
        "1658": {"vr": "DS", "Value": [433.395]},
        "1659": {"vr": "DS", "Value": [237.6]},
        "1660": {"vr": "DS", "Value": [381.1825]},
        "1661": {"vr": "DS", "Value": [20.5275]},
        "1662": {"vr": "DS", "Value": [359.465]},
        "1663": {"vr": "DS", "Value": [194.625]},
        "1664": {"vr": "DS", "Value": [478.7125]},
        "1665": {"vr": "DS", "Value": [439.25]},
        "1666": {"vr": "DS", "Value": [254.45]},
        "1667": {"vr": "DS", "Value": [448.195]},
        "1668": {"vr": "DS", "Value": [121.2775]},
        "1669": {"vr": "DS", "Value": [452.7525]},
        "1670": {"vr": "DS", "Value": [257.5425]},
        "1671": {"vr": "DS", "Value": [395.25]},
        "1672": {"vr": "DS", "Value": [62.185]},
        "1673": {"vr": "DS", "Value": [195.795]},
        "1674": {"vr": "DS", "Value": [325.2875]},
        "1675": {"vr": "DS", "Value": [154.575]},
        "1676": {"vr": "DS", "Value": [29.3275]},
        "1677": {"vr": "DS", "Value": [555.1325]},
        "1678": {"vr": "DS", "Value": [220.7325]},
        "1679": {"vr": "DS", "Value": [245.795]},
        "1680": {"vr": "DS", "Value": [450.41]},
        "1681": {"vr": "DS", "Value": [97.24]},
        "1682": {"vr": "DS", "Value": [433.9825]},
        "1683": {"vr": "DS", "Value": [387.3475]},
        "1684": {"vr": "DS", "Value": [529.7575]},
        "1685": {"vr": "DS", "Value": [474.8875]},
        "1686": {"vr": "DS", "Value": [30.79]},
        "1687": {"vr": "DS", "Value": [418.7225]},
        "1688": {"vr": "DS", "Value": [184.05]},
        "1689": {"vr": "DS", "Value": [203.425]},
        "1690": {"vr": "DS", "Value": [325.435]},
        "1691": {"vr": "DS", "Value": [495.875]},
        "1692": {"vr": "DS", "Value": [212.5175]},
        "1693": {"vr": "DS", "Value": [230.85]},
        "1694": {"vr": "DS", "Value": [485.3175]},
        "1695": {"vr": "DS", "Value": [136.5375]},
        "1696": {"vr": "DS", "Value": [39.1525]},
        "1697": {"vr": "DS", "Value": [337.1825]},
        "1698": {"vr": "DS", "Value": [559.5225]},
        "1699": {"vr": "DS", "Value": [345.395]},
        "1700": {"vr": "DS", "Value": [3.805]},
        "1701": {"vr": "DS", "Value": [481.4925]},
        "1702": {"vr": "DS", "Value": [132.2925]},
        "1703": {"vr": "DS", "Value": [44.1475]},
        "1704": {"vr": "DS", "Value": [539.5825]},
        "1705": {"vr": "DS", "Value": [39.005]},
        "1706": {"vr": "DS", "Value": [39.8825]},
        "1707": {"vr": "DS", "Value": [211.3475]},
        "1708": {"vr": "DS", "Value": [442.49]},
        "1709": {"vr": "DS", "Value": [317.68]},
        "1710": {"vr": "DS", "Value": [256.225]},
        "1711": {"vr": "DS", "Value": [34.8875]},
        "1712": {"vr": "DS", "Value": [411.385]},
        "1713": {"vr": "DS", "Value": [158.84]},
        "1714": {"vr": "DS", "Value": [542.5075]},
        "1715": {"vr": "DS", "Value": [464.625]},
        "1716": {"vr": "DS", "Value": [68.3325]},
        "1717": {"vr": "DS", "Value": [105.7475]},
        "1718": {"vr": "DS", "Value": [286.87]},
        "1719": {"vr": "DS", "Value": [555.5725]},
        "1720": {"vr": "DS", "Value": [598.0875]},
        "1721": {"vr": "DS", "Value": [544.85]},
        "1722": {"vr": "DS", "Value": [150.3325]},
        "1723": {"vr": "DS", "Value": [559.815]},
        "1724": {"vr": "DS", "Value": [472.1075]},
        "1725": {"vr": "DS", "Value": [162.9375]},
        "1726": {"vr": "DS", "Value": [529.61]},
        "1727": {"vr": "DS", "Value": [259.8825]},
        "1728": {"vr": "DS", "Value": [169.25]},
        "1729": {"vr": "DS", "Value": [297.865]},
        "1730": {"vr": "DS", "Value": [39.445]},
        "1731": {"vr": "DS", "Value": [220.2925]},
        "1732": {"vr": "DS", "Value": [31.815]},
        "1733": {"vr": "DS", "Value": [20.38]},
        "1734": {"vr": "DS", "Value": [541.7775]},
        "1735": {"vr": "DS", "Value": [486.49]},
        "1736": {"vr": "DS", "Value": [206.9375]},
        "1737": {"vr": "DS", "Value": [125.395]},
        "1738": {"vr": "DS", "Value": [399.805]},
        "1739": {"vr": "DS", "Value": [224.83]},
        "1740": {"vr": "DS", "Value": [539.7275]},
        "1741": {"vr": "DS", "Value": [174.9575]},
        "1742": {"vr": "DS", "Value": [85.785]},
        "1743": {"vr": "DS", "Value": [161.62]},
        "1744": {"vr": "DS", "Value": [391.005]},
        "1745": {"vr": "DS", "Value": [365.3375]},
        "1746": {"vr": "DS", "Value": [464.3325]},
        "1747": {"vr": "DS", "Value": [349.64]},
        "1748": {"vr": "DS", "Value": [438.3725]},
        "1749": {"vr": "DS", "Value": [484.0]},
        "1750": {"vr": "DS", "Value": [566.7125]},
        "1751": {"vr": "DS", "Value": [577.1225]},
        "1752": {"vr": "DS", "Value": [71.865]},
        "1753": {"vr": "DS", "Value": [156.9175]},
        "1754": {"vr": "DS", "Value": [283.5025]},
        "1755": {"vr": "DS", "Value": [390.1275]},
        "1756": {"vr": "DS", "Value": [161.3275]},
        "1757": {"vr": "DS", "Value": [383.5225]},
        "1758": {"vr": "DS", "Value": [20.82]},
        "1759": {"vr": "DS", "Value": [30.205]},
        "1760": {"vr": "DS", "Value": [383.9625]},
        "1761": {"vr": "DS", "Value": [48.5375]},
        "1762": {"vr": "DS", "Value": [19.9425]},
        "1763": {"vr": "DS", "Value": [62.7725]},
        "1764": {"vr": "DS", "Value": [270.585]},
        "1765": {"vr": "DS", "Value": [105.2875]},
        "1766": {"vr": "DS", "Value": [216.615]},
        "1767": {"vr": "DS", "Value": [230.5575]},
        "1768": {"vr": "DS", "Value": [234.9475]},
        "1769": {"vr": "DS", "Value": [19.21]},
        "1770": {"vr": "DS", "Value": [387.495]},
        "1771": {"vr": "DS", "Value": [277.775]},
        "1772": {"vr": "DS", "Value": [284.9675]},
        "1773": {"vr": "DS", "Value": [537.095]},
        "1774": {"vr": "DS", "Value": [51.9025]},
        "1775": {"vr": "DS", "Value": [107.5025]},
        "1776": {"vr": "DS", "Value": [577.5625]},
        "1777": {"vr": "DS", "Value": [157.795]},
        "1778": {"vr": "DS", "Value": [166.7425]},
        "1779": {"vr": "DS", "Value": [466.235]},
        "1780": {"vr": "DS", "Value": [187.2875]},
        "1781": {"vr": "DS", "Value": [471.67]},
        "1782": {"vr": "DS", "Value": [124.5175]},
        "1783": {"vr": "DS", "Value": [158.985]},
        "1784": {"vr": "DS", "Value": [450.1175]},
        "1785": {"vr": "DS", "Value": [225.5625]},
        "1786": {"vr": "DS", "Value": [405.3875]},
        "1787": {"vr": "DS", "Value": [585.7775]},
        "1788": {"vr": "DS", "Value": [174.81]},
        "1789": {"vr": "DS", "Value": [453.4825]},
        "1790": {"vr": "DS", "Value": [136.39]},
        "1791": {"vr": "DS", "Value": [90.9275]},
        "1792": {"vr": "DS", "Value": [327.21]},
        "1793": {"vr": "DS", "Value": [273.3875]},
        "1794": {"vr": "DS", "Value": [270.7325]},
        "1795": {"vr": "DS", "Value": [151.9425]},
        "1796": {"vr": "DS", "Value": [2.9275]},
        "1797": {"vr": "DS", "Value": [342.595]},
        "1798": {"vr": "DS", "Value": [129.785]},
        "1799": {"vr": "DS", "Value": [362.995]},
        "1800": {"vr": "DS", "Value": [372.9675]},
        "1801": {"vr": "DS", "Value": [511.1325]},
        "1802": {"vr": "DS", "Value": [203.5725]},
        "1803": {"vr": "DS", "Value": [558.06]},
        "1804": {"vr": "DS", "Value": [558.3525]},
        "1805": {"vr": "DS", "Value": [596.7725]},
        "1806": {"vr": "DS", "Value": [65.845]},
        "1807": {"vr": "DS", "Value": [551.3075]},
        "1808": {"vr": "DS", "Value": [456.85]},
        "1809": {"vr": "DS", "Value": [157.9425]},
        "1810": {"vr": "DS", "Value": [347.1525]},
        "1811": {"vr": "DS", "Value": [280.5575]},
        "1812": {"vr": "DS", "Value": [234.215]},
        "1813": {"vr": "DS", "Value": [222.4875]},
        "1814": {"vr": "DS", "Value": [490.2925]},
        "1815": {"vr": "DS", "Value": [568.9075]},
        "1816": {"vr": "DS", "Value": [325.1425]},
        "1817": {"vr": "DS", "Value": [347.8825]},
        "1818": {"vr": "DS", "Value": [331.455]},
        "1819": {"vr": "DS", "Value": [263.25]},
        "1820": {"vr": "DS", "Value": [212.3725]},
        "1821": {"vr": "DS", "Value": [395.835]},
        "1822": {"vr": "DS", "Value": [461.99]},
        "1823": {"vr": "DS", "Value": [394.665]},
        "1824": {"vr": "DS", "Value": [144.46]},
        "1825": {"vr": "DS", "Value": [350.37]},
        "1826": {"vr": "DS", "Value": [162.79]},
        "1827": {"vr": "DS", "Value": [499.825]},
        "1828": {"vr": "DS", "Value": [245.65]},
        "1829": {"vr": "DS", "Value": [70.5475]},
        "1830": {"vr": "DS", "Value": [151.65]},
        "1831": {"vr": "DS", "Value": [346.7125]},
        "1832": {"vr": "DS", "Value": [232.605]},
        "1833": {"vr": "DS", "Value": [327.65]},
        "1834": {"vr": "DS", "Value": [129.055]},
        "1835": {"vr": "DS", "Value": [320.02]},
        "1836": {"vr": "DS", "Value": [380.8875]},
        "1837": {"vr": "DS", "Value": [210.1575]},
        "1838": {"vr": "DS", "Value": [500.995]},
        "1839": {"vr": "DS", "Value": [441.7575]},
        "1840": {"vr": "DS", "Value": [57.63]},
        "1841": {"vr": "DS", "Value": [354.635]},
        "1842": {"vr": "DS", "Value": [280.41]},
        "1843": {"vr": "DS", "Value": [126.42]},
        "1844": {"vr": "DS", "Value": [386.3025]},
        "1845": {"vr": "DS", "Value": [202.4]},
        "1846": {"vr": "DS", "Value": [190.5075]},
        "1847": {"vr": "DS", "Value": [184.3425]},
        "1848": {"vr": "DS", "Value": [293.62]},
        "1849": {"vr": "DS", "Value": [456.7025]},
        "1850": {"vr": "DS", "Value": [318.5575]},
        "1851": {"vr": "DS", "Value": [457.7475]},
        "1852": {"vr": "DS", "Value": [373.26]},
        "1853": {"vr": "DS", "Value": [23.16]},
        "1854": {"vr": "DS", "Value": [84.4675]},
        "1855": {"vr": "DS", "Value": [287.7475]},
        "1856": {"vr": "DS", "Value": [98.7025]},
        "1857": {"vr": "DS", "Value": [563.2025]},
        "1858": {"vr": "DS", "Value": [200.3325]},
        "1859": {"vr": "DS", "Value": [98.85]},
        "1860": {"vr": "DS", "Value": [341.57]},
        "1861": {"vr": "DS", "Value": [355.66]},
        "1862": {"vr": "DS", "Value": [150.48]},
        "1863": {"vr": "DS", "Value": [504.3825]},
        "1864": {"vr": "DS", "Value": [65.1125]},
        "1865": {"vr": "DS", "Value": [298.45]},
        "1866": {"vr": "DS", "Value": [341.1325]},
        "1867": {"vr": "DS", "Value": [368.85]},
        "1868": {"vr": "DS", "Value": [585.19]},
        "1869": {"vr": "DS", "Value": [419.8925]},
        "1870": {"vr": "DS", "Value": [51.4625]},
        "1871": {"vr": "DS", "Value": [433.5425]},
        "1872": {"vr": "DS", "Value": [595.8925]},
        "1873": {"vr": "DS", "Value": [4.6825]},
        "1874": {"vr": "DS", "Value": [159.425]},
        "1875": {"vr": "DS", "Value": [562.7425]},
        "1876": {"vr": "DS", "Value": [67.6]},
        "1877": {"vr": "DS", "Value": [79.64]},
        "1878": {"vr": "DS", "Value": [584.605]},
        "1879": {"vr": "DS", "Value": [196.9675]},
        "1880": {"vr": "DS", "Value": [164.6925]},
        "1881": {"vr": "DS", "Value": [457.2875]},
        "1882": {"vr": "DS", "Value": [265.3175]},
        "1883": {"vr": "DS", "Value": [43.835]},
        "1884": {"vr": "DS", "Value": [177.7575]},
        "1885": {"vr": "DS", "Value": [553.795]},
        "1886": {"vr": "DS", "Value": [309.61]},
        "1887": {"vr": "DS", "Value": [470.205]},
        "1888": {"vr": "DS", "Value": [565.69]},
        "1889": {"vr": "DS", "Value": [494.1175]},
        "1890": {"vr": "DS", "Value": [353.61]},
        "1891": {"vr": "DS", "Value": [329.6975]},
        "1892": {"vr": "DS", "Value": [532.245]},
        "1893": {"vr": "DS", "Value": [44.7325]},
        "1894": {"vr": "DS", "Value": [546.1875]},
        "1895": {"vr": "DS", "Value": [532.5375]},
        "1896": {"vr": "DS", "Value": [411.9725]},
        "1897": {"vr": "DS", "Value": [172.3225]},
        "1898": {"vr": "DS", "Value": [580.05]},
        "1899": {"vr": "DS", "Value": [42.955]},
        "1900": {"vr": "DS", "Value": [114.6925]},
        "1901": {"vr": "DS", "Value": [543.5325]},
        "1902": {"vr": "DS", "Value": [229.5325]},
        "1903": {"vr": "DS", "Value": [164.4]},
        "1904": {"vr": "DS", "Value": [250.205]},
        "1905": {"vr": "DS", "Value": [452.02]},
        "1906": {"vr": "DS", "Value": [215.2975]},
        "1907": {"vr": "DS", "Value": [229.68]},
        "1908": {"vr": "DS", "Value": [249.035]},
        "1909": {"vr": "DS", "Value": [499.24]},
        "1910": {"vr": "DS", "Value": [159.865]},
        "1911": {"vr": "DS", "Value": [63.5025]},
        "1912": {"vr": "DS", "Value": [83.7375]},
        "1913": {"vr": "DS", "Value": [464.185]},
        "1914": {"vr": "DS", "Value": [498.655]},
        "1915": {"vr": "DS", "Value": [7.9025]},
        "1916": {"vr": "DS", "Value": [305.9325]},
        "1917": {"vr": "DS", "Value": [449.68]},
        "1918": {"vr": "DS", "Value": [304.3225]},
        "1919": {"vr": "DS", "Value": [585.045]},
        "1920": {"vr": "DS", "Value": [207.0825]},
        "1921": {"vr": "DS", "Value": [229.24]},
        "1922": {"vr": "DS", "Value": [258.5675]},
        "1923": {"vr": "DS", "Value": [253.2775]},
        "1924": {"vr": "DS", "Value": [47.66]},
        "1925": {"vr": "DS", "Value": [181.855]},
        "1926": {"vr": "DS", "Value": [491.025]},
        "1927": {"vr": "DS", "Value": [259.445]},
        "1928": {"vr": "DS", "Value": [179.66]},
        "1929": {"vr": "DS", "Value": [283.21]},
        "1930": {"vr": "DS", "Value": [440.44]},
        "1931": {"vr": "DS", "Value": [247.7175]},
        "1932": {"vr": "DS", "Value": [510.9875]},
        "1933": {"vr": "DS", "Value": [402.7325]},
        "1934": {"vr": "DS", "Value": [70.0875]},
        "1935": {"vr": "DS", "Value": [518.01]},
        "1936": {"vr": "DS", "Value": [104.995]},
        "1937": {"vr": "DS", "Value": [438.665]},
        "1938": {"vr": "DS", "Value": [525.055]},
        "1939": {"vr": "DS", "Value": [273.68]},
        "1940": {"vr": "DS", "Value": [193.1425]},
        "1941": {"vr": "DS", "Value": [213.5425]},
        "1942": {"vr": "DS", "Value": [376.4775]},
        "1943": {"vr": "DS", "Value": [79.785]},
        "1944": {"vr": "DS", "Value": [377.065]},
        "1945": {"vr": "DS", "Value": [409.9225]},
        "1946": {"vr": "DS", "Value": [229.825]},
        "1947": {"vr": "DS", "Value": [235.385]},
        "1948": {"vr": "DS", "Value": [518.3025]},
        "1949": {"vr": "DS", "Value": [111.8925]},
        "1950": {"vr": "DS", "Value": [440.295]},
        "1951": {"vr": "DS", "Value": [349.4925]},
        "1952": {"vr": "DS", "Value": [378.84]},
        "1953": {"vr": "DS", "Value": [280.85]},
        "1954": {"vr": "DS", "Value": [51.025]},
        "1955": {"vr": "DS", "Value": [134.4875]},
        "1956": {"vr": "DS", "Value": [460.675]},
        "1957": {"vr": "DS", "Value": [319.435]},
        "1958": {"vr": "DS", "Value": [378.235]},
        "1959": {"vr": "DS", "Value": [274.85]},
        "1960": {"vr": "DS", "Value": [192.85]},
        "1961": {"vr": "DS", "Value": [1.9025]},
        "1962": {"vr": "DS", "Value": [419.1625]},
        "1963": {"vr": "DS", "Value": [385.5725]},
        "1964": {"vr": "DS", "Value": [296.255]},
        "1965": {"vr": "DS", "Value": [234.655]},
        "1966": {"vr": "DS", "Value": [433.25]},
        "1967": {"vr": "DS", "Value": [593.99]},
        "1968": {"vr": "DS", "Value": [391.7375]},
        "1969": {"vr": "DS", "Value": [575.3675]},
        "1970": {"vr": "DS", "Value": [170.275]},
        "1971": {"vr": "DS", "Value": [226.7325]},
        "1972": {"vr": "DS", "Value": [314.1475]},
        "1973": {"vr": "DS", "Value": [590.3325]},
        "1974": {"vr": "DS", "Value": [183.9025]},
        "1975": {"vr": "DS", "Value": [479.885]},
        "1976": {"vr": "DS", "Value": [50.1475]},
        "1977": {"vr": "DS", "Value": [314.585]},
        "1978": {"vr": "DS", "Value": [102.655]},
        "1979": {"vr": "DS", "Value": [431.64]},
        "1980": {"vr": "DS", "Value": [220.1475]},
        "1981": {"vr": "DS", "Value": [360.635]},
        "1982": {"vr": "DS", "Value": [456.265]},
        "1983": {"vr": "DS", "Value": [311.5125]},
        "1984": {"vr": "DS", "Value": [85.2]},
        "1985": {"vr": "DS", "Value": [311.075]},
        "1986": {"vr": "DS", "Value": [501.435]},
        "1987": {"vr": "DS", "Value": [569.3475]},
        "1988": {"vr": "DS", "Value": [36.3725]},
        "1989": {"vr": "DS", "Value": [312.39]},
        "1990": {"vr": "DS", "Value": [438.0775]},
        "1991": {"vr": "DS", "Value": [262.665]},
        "1992": {"vr": "DS", "Value": [166.595]},
        "1993": {"vr": "DS", "Value": [305.4925]},
        "1994": {"vr": "DS", "Value": [531.3675]},
        "1995": {"vr": "DS", "Value": [551.6]},
        "1996": {"vr": "DS", "Value": [300.225]},
        "1997": {"vr": "DS", "Value": [56.1675]},
        "1998": {"vr": "DS", "Value": [369.7475]},
        "1999": {"vr": "DS", "Value": [390.5675]},
        "2000": {"vr": "DS", "Value": [467.7175]},
        "2001": {"vr": "DS", "Value": [593.1125]},
        "2002": {"vr": "DS", "Value": [447.7575]},
        "2003": {"vr": "DS", "Value": [37.1025]},
        "2004": {"vr": "DS", "Value": [411.0925]},
        "2005": {"vr": "DS", "Value": [99.2875]},
        "2006": {"vr": "DS", "Value": [285.99]},
        "2007": {"vr": "DS", "Value": [65.405]},
        "2008": {"vr": "DS", "Value": [121.7175]},
        "2009": {"vr": "DS", "Value": [583.1425]},
        "2010": {"vr": "DS", "Value": [89.1725]},
        "2011": {"vr": "DS", "Value": [526.665]},
        "2012": {"vr": "DS", "Value": [1.3175]},
        "2013": {"vr": "DS", "Value": [483.1025]},
        "2014": {"vr": "DS", "Value": [240.675]},
        "2015": {"vr": "DS", "Value": [458.1875]},
        "2016": {"vr": "DS", "Value": [313.415]},
        "2017": {"vr": "DS", "Value": [299.2]},
        "2018": {"vr": "DS", "Value": [516.255]},
        "2019": {"vr": "DS", "Value": [295.375]},
        "2020": {"vr": "DS", "Value": [579.465]},
        "2021": {"vr": "DS", "Value": [216.9075]},
        "2022": {"vr": "DS", "Value": [366.3625]},
        "2023": {"vr": "DS", "Value": [197.5525]},
        "2024": {"vr": "DS", "Value": [552.3325]},
        "2025": {"vr": "DS", "Value": [113.5025]},
        "2026": {"vr": "DS", "Value": [541.9225]},
        "2027": {"vr": "DS", "Value": [178.635]},
        "2028": {"vr": "DS", "Value": [389.1025]},
        "2029": {"vr": "DS", "Value": [113.0625]},
        "2030": {"vr": "DS", "Value": [582.1175]},
        "2031": {"vr": "DS", "Value": [320.8975]},
        "2032": {"vr": "DS", "Value": [93.7075]},
        "2033": {"vr": "DS", "Value": [570.225]},
        "2034": {"vr": "DS", "Value": [345.5425]},
        "2035": {"vr": "DS", "Value": [310.05]},
        "2036": {"vr": "DS", "Value": [191.24]},
        "2037": {"vr": "DS", "Value": [157.5025]},
        "2038": {"vr": "DS", "Value": [461.845]},
        "2039": {"vr": "DS", "Value": [296.985]},
        "2040": {"vr": "DS", "Value": [80.5175]},
        "2041": {"vr": "DS", "Value": [371.795]},
        "2042": {"vr": "DS", "Value": [82.7125]},
        "2043": {"vr": "DS", "Value": [477.25]},
        "2044": {"vr": "DS", "Value": [245.5025]},
        "2045": {"vr": "DS", "Value": [358.1475]},
        "2046": {"vr": "DS", "Value": [168.665]},
        "2047": {"vr": "DS", "Value": [576.685]},
        "2048": {"vr": "DS", "Value": [201.0625]},
        "2049": {"vr": "DS", "Value": [313.5625]},
        "2050": {"vr": "DS", "Value": [46.9275]},
        "2051": {"vr": "DS", "Value": [252.255]},
        "2052": {"vr": "DS", "Value": [74.4975]},
        "2053": {"vr": "DS", "Value": [432.665]},
        "2054": {"vr": "DS", "Value": [286.575]},
        "2055": {"vr": "DS", "Value": [222.195]},
        "2056": {"vr": "DS", "Value": [378.4]},
        "2057": {"vr": "DS", "Value": [553.5025]},
        "2058": {"vr": "DS", "Value": [588.265]},
        "2059": {"vr": "DS", "Value": [524.47]},
        "2060": {"vr": "DS", "Value": [116.45]},
        "2061": {"vr": "DS", "Value": [340.1075]},
        "2062": {"vr": "DS", "Value": [159.7175]},
        "2063": {"vr": "DS", "Value": [353.7575]},
        "2064": {"vr": "DS", "Value": [494.265]},
        "2065": {"vr": "DS", "Value": [547.65]},
        "2066": {"vr": "DS", "Value": [335.28]},
        "2067": {"vr": "DS", "Value": [227.3175]},
        "2068": {"vr": "DS", "Value": [226.8775]},
        "2069": {"vr": "DS", "Value": [530.635]},
        "2070": {"vr": "DS", "Value": [350.665]},
        "2071": {"vr": "DS", "Value": [447.3175]},
        "2072": {"vr": "DS", "Value": [308.88]},
        "2073": {"vr": "DS", "Value": [383.815]},
        "2074": {"vr": "DS", "Value": [155.6]},
        "2075": {"vr": "DS", "Value": [204.595]},
        "2076": {"vr": "DS", "Value": [373.1125]},
        "2077": {"vr": "DS", "Value": [488.83]},
        "2078": {"vr": "DS", "Value": [170.86]},
        "2079": {"vr": "DS", "Value": [208.5475]},
        "2080": {"vr": "DS", "Value": [193.435]},
        "2081": {"vr": "DS", "Value": [534.7325]},
        "2082": {"vr": "DS", "Value": [207.815]},
        "2083": {"vr": "DS", "Value": [300.3725]},
        "2084": {"vr": "DS", "Value": [301.395]},
        "2085": {"vr": "DS", "Value": [146.215]},
        "2086": {"vr": "DS", "Value": [496.46]},
        "2087": {"vr": "DS", "Value": [551.1625]},
        "2088": {"vr": "DS", "Value": [415.21]},
        "2089": {"vr": "DS", "Value": [170.5675]},
        "2090": {"vr": "DS", "Value": [311.22]},
        "2091": {"vr": "DS", "Value": [345.9825]},
        "2092": {"vr": "DS", "Value": [408.3125]},
        "2093": {"vr": "DS", "Value": [584.1675]},
        "2094": {"vr": "DS", "Value": [575.805]},
        "2095": {"vr": "DS", "Value": [236.1175]},
        "2096": {"vr": "DS", "Value": [117.18]},
        "2097": {"vr": "DS", "Value": [120.5475]},
        "2098": {"vr": "DS", "Value": [1.1725]},
        "2099": {"vr": "DS", "Value": [474.45]},
        "2100": {"vr": "DS", "Value": [377.9425]},
        "2101": {"vr": "DS", "Value": [471.23]},
        "2102": {"vr": "DS", "Value": [270.0]},
        "2103": {"vr": "DS", "Value": [20.235]},
        "2104": {"vr": "DS", "Value": [466.5475]},
        "2105": {"vr": "DS", "Value": [50.585]},
        "2106": {"vr": "DS", "Value": [153.845]},
        "2107": {"vr": "DS", "Value": [364.02]},
        "2108": {"vr": "DS", "Value": [83.59]},
        "2109": {"vr": "DS", "Value": [493.095]},
        "2110": {"vr": "DS", "Value": [535.7575]},
        "2111": {"vr": "DS", "Value": [116.7425]},
        "2112": {"vr": "DS", "Value": [175.835]},
        "2113": {"vr": "DS", "Value": [323.97]},
        "2114": {"vr": "DS", "Value": [505.5525]},
        "2115": {"vr": "DS", "Value": [48.0975]},
        "2116": {"vr": "DS", "Value": [317.3875]},
        "2117": {"vr": "DS", "Value": [192.41]},
        "2118": {"vr": "DS", "Value": [138.8775]},
        "2119": {"vr": "DS", "Value": [343.2]},
        "2120": {"vr": "DS", "Value": [584.8975]},
        "2121": {"vr": "DS", "Value": [99.435]},
        "2122": {"vr": "DS", "Value": [20.6725]},
        "2123": {"vr": "DS", "Value": [96.05]},
        "2124": {"vr": "DS", "Value": [49.1225]},
        "2125": {"vr": "DS", "Value": [191.825]},
        "2126": {"vr": "DS", "Value": [41.9325]},
        "2127": {"vr": "DS", "Value": [256.665]},
        "2128": {"vr": "DS", "Value": [355.3675]},
        "2129": {"vr": "DS", "Value": [538.265]},
        "2130": {"vr": "DS", "Value": [256.3725]},
        "2131": {"vr": "DS", "Value": [556.595]},
        "2132": {"vr": "DS", "Value": [402.585]},
        "2133": {"vr": "DS", "Value": [69.795]},
        "2134": {"vr": "DS", "Value": [116.1575]},
        "2135": {"vr": "DS", "Value": [145.9225]},
        "2136": {"vr": "DS", "Value": [100.1675]},
        "2137": {"vr": "DS", "Value": [211.785]},
        "2138": {"vr": "DS", "Value": [248.595]},
        "2139": {"vr": "DS", "Value": [311.66]},
        "2140": {"vr": "DS", "Value": [308.0]},
        "2141": {"vr": "DS", "Value": [372.3825]},
        "2142": {"vr": "DS", "Value": [280.265]},
        "2143": {"vr": "DS", "Value": [579.1725]},
        "2144": {"vr": "DS", "Value": [357.7075]},
        "2145": {"vr": "DS", "Value": [165.7175]},
        "2146": {"vr": "DS", "Value": [592.3825]},
        "2147": {"vr": "DS", "Value": [91.66]},
        "2148": {"vr": "DS", "Value": [92.6825]},
        "2149": {"vr": "DS", "Value": [552.625]},
        "2150": {"vr": "DS", "Value": [561.425]},
        "2151": {"vr": "DS", "Value": [321.19]},
        "2152": {"vr": "DS", "Value": [60.2625]},
        "2153": {"vr": "DS", "Value": [148.995]},
        "2154": {"vr": "DS", "Value": [394.0775]},
        "2155": {"vr": "DS", "Value": [353.1725]},
        "2156": {"vr": "DS", "Value": [419.6]},
        "2157": {"vr": "DS", "Value": [291.7175]},
        "2158": {"vr": "DS", "Value": [398.4875]},
        "2159": {"vr": "DS", "Value": [295.67]},
        "2160": {"vr": "DS", "Value": [289.65]},
        "2161": {"vr": "DS", "Value": [129.3475]},
        "2162": {"vr": "DS", "Value": [55.8725]},
        "2163": {"vr": "DS", "Value": [274.7025]},
        "2164": {"vr": "DS", "Value": [367.825]},
        "2165": {"vr": "DS", "Value": [202.5475]},
        "2166": {"vr": "DS", "Value": [265.025]},
        "2167": {"vr": "DS", "Value": [379.1325]},
        "2168": {"vr": "DS", "Value": [572.0025]},
        "2169": {"vr": "DS", "Value": [168.5175]},
        "2170": {"vr": "DS", "Value": [305.64]},
        "2171": {"vr": "DS", "Value": [561.5725]},
        "2172": {"vr": "DS", "Value": [119.815]},
        "2173": {"vr": "DS", "Value": [463.015]},
        "2174": {"vr": "DS", "Value": [307.25]},
        "2175": {"vr": "DS", "Value": [183.17]},
        "2176": {"vr": "DS", "Value": [369.1425]},
        "2177": {"vr": "DS", "Value": [587.5325]},
        "2178": {"vr": "DS", "Value": [118.79]},
        "2179": {"vr": "DS", "Value": [375.015]},
        "2180": {"vr": "DS", "Value": [82.2725]},
        "2181": {"vr": "DS", "Value": [152.9675]},
        "2182": {"vr": "DS", "Value": [406.85]},
        "2183": {"vr": "DS", "Value": [511.865]},
        "2184": {"vr": "DS", "Value": [436.3225]},
        "2185": {"vr": "DS", "Value": [294.205]},
        "2186": {"vr": "DS", "Value": [461.405]},
        "2187": {"vr": "DS", "Value": [589.6025]},
        "2188": {"vr": "DS", "Value": [380.1575]},
        "2189": {"vr": "DS", "Value": [173.3475]},
        "2190": {"vr": "DS", "Value": [49.56]},
        "2191": {"vr": "DS", "Value": [100.7525]},
        "2192": {"vr": "DS", "Value": [202.985]},
        "2193": {"vr": "DS", "Value": [474.595]},
        "2194": {"vr": "DS", "Value": [38.7125]},
        "2195": {"vr": "DS", "Value": [243.455]},
        "2196": {"vr": "DS", "Value": [376.04]},
        "2197": {"vr": "DS", "Value": [292.45]},
        "2198": {"vr": "DS", "Value": [531.805]},
        "2199": {"vr": "DS", "Value": [462.5775]},
        "2200": {"vr": "DS", "Value": [114.985]},
        "2201": {"vr": "DS", "Value": [176.0]},
        "2202": {"vr": "DS", "Value": [501.6]},
        "2203": {"vr": "DS", "Value": [423.5725]},
        "2204": {"vr": "DS", "Value": [592.675]},
        "2205": {"vr": "DS", "Value": [62.625]},
        "2206": {"vr": "DS", "Value": [387.7875]},
        "2207": {"vr": "DS", "Value": [358.8775]},
        "2208": {"vr": "DS", "Value": [583.7275]},
        "2209": {"vr": "DS", "Value": [480.47]},
        "2210": {"vr": "DS", "Value": [128.4675]},
        "2211": {"vr": "DS", "Value": [44.0]},
        "2212": {"vr": "DS", "Value": [432.5175]},
        "2213": {"vr": "DS", "Value": [430.3025]},
        "2214": {"vr": "DS", "Value": [191.6775]},
        "2215": {"vr": "DS", "Value": [490.8775]},
        "2216": {"vr": "DS", "Value": [309.1725]},
        "2217": {"vr": "DS", "Value": [416.235]},
        "2218": {"vr": "DS", "Value": [248.7425]},
        "2219": {"vr": "DS", "Value": [135.805]},
        "2220": {"vr": "DS", "Value": [5.56]},
        "2221": {"vr": "DS", "Value": [100.605]},
        "2222": {"vr": "DS", "Value": [476.5175]},
        "2223": {"vr": "DS", "Value": [342.45]},
        "2224": {"vr": "DS", "Value": [69.21]},
        "2225": {"vr": "DS", "Value": [351.835]},
        "2226": {"vr": "DS", "Value": [216.47]},
        "2227": {"vr": "DS", "Value": [543.825]},
        "2228": {"vr": "DS", "Value": [42.5175]},
        "2229": {"vr": "DS", "Value": [554.235]},
        "2230": {"vr": "DS", "Value": [413.2875]},
        "2231": {"vr": "DS", "Value": [453.045]},
        "2232": {"vr": "DS", "Value": [372.0875]},
        "2233": {"vr": "DS", "Value": [587.68]},
        "2234": {"vr": "DS", "Value": [328.5275]},
        "2235": {"vr": "DS", "Value": [424.3025]},
        "2236": {"vr": "DS", "Value": [443.5125]},
        "2237": {"vr": "DS", "Value": [367.6775]},
        "2238": {"vr": "DS", "Value": [448.8]},
        "2239": {"vr": "DS", "Value": [111.6]},
        "2240": {"vr": "DS", "Value": [187.58]},
        "2241": {"vr": "DS", "Value": [105.1425]},
        "2242": {"vr": "DS", "Value": [375.7475]},
        "2243": {"vr": "DS", "Value": [71.1325]},
        "2244": {"vr": "DS", "Value": [46.78]},
        "2245": {"vr": "DS", "Value": [261.4925]},
        "2246": {"vr": "DS", "Value": [29.7675]},
        "2247": {"vr": "DS", "Value": [365.19]},
        "2248": {"vr": "DS", "Value": [73.4725]},
        "2249": {"vr": "DS", "Value": [510.84]},
        "2250": {"vr": "DS", "Value": [483.6875]},
        "2251": {"vr": "DS", "Value": [125.98]},
        "2252": {"vr": "DS", "Value": [22.1375]},
        "2253": {"vr": "DS", "Value": [511.7175]},
        "2254": {"vr": "DS", "Value": [597.065]},
        "2255": {"vr": "DS", "Value": [197.405]},
        "2256": {"vr": "DS", "Value": [581.095]},
        "2257": {"vr": "DS", "Value": [421.65]},
        "2258": {"vr": "DS", "Value": [89.61]},
        "2259": {"vr": "DS", "Value": [108.235]},
        "2260": {"vr": "DS", "Value": [316.9475]},
        "2261": {"vr": "DS", "Value": [168.81]},
        "2262": {"vr": "DS", "Value": [575.66]},
        "2263": {"vr": "DS", "Value": [497.63]},
        "2264": {"vr": "DS", "Value": [416.82]},
        "2265": {"vr": "DS", "Value": [279.6775]},
        "2266": {"vr": "DS", "Value": [392.7625]},
        "2267": {"vr": "DS", "Value": [558.4975]},
        "2268": {"vr": "DS", "Value": [369.2875]},
        "2269": {"vr": "DS", "Value": [88.2925]},
        "2270": {"vr": "DS", "Value": [416.9675]},
        "2271": {"vr": "DS", "Value": [195.5025]},
        "2272": {"vr": "DS", "Value": [557.9125]},
        "2273": {"vr": "DS", "Value": [241.26]},
        "2274": {"vr": "DS", "Value": [490.44]},
        "2275": {"vr": "DS", "Value": [332.9175]},
        "2276": {"vr": "DS", "Value": [365.63]},
        "2277": {"vr": "DS", "Value": [320.46]},
        "2278": {"vr": "DS", "Value": [497.7775]},
        "2279": {"vr": "DS", "Value": [573.025]},
        "2280": {"vr": "DS", "Value": [100.3125]},
        "2281": {"vr": "DS", "Value": [444.0975]},
        "2282": {"vr": "DS", "Value": [155.1625]},
        "2283": {"vr": "DS", "Value": [165.8625]},
        "2284": {"vr": "DS", "Value": [295.0825]},
        "2285": {"vr": "DS", "Value": [476.08]},
        "2286": {"vr": "DS", "Value": [520.9575]},
        "2287": {"vr": "DS", "Value": [4.245]},
        "2288": {"vr": "DS", "Value": [584.46]},
        "2289": {"vr": "DS", "Value": [31.96]},
        "2290": {"vr": "DS", "Value": [125.835]},
        "2291": {"vr": "DS", "Value": [401.855]},
        "2292": {"vr": "DS", "Value": [530.05]},
        "2293": {"vr": "DS", "Value": [138.44]},
        "2294": {"vr": "DS", "Value": [318.85]},
        "2295": {"vr": "DS", "Value": [303.005]},
        "2296": {"vr": "DS", "Value": [396.5875]},
        "2297": {"vr": "DS", "Value": [534.0]},
        "2298": {"vr": "DS", "Value": [391.2975]},
        "2299": {"vr": "DS", "Value": [567.59]},
        "2300": {"vr": "DS", "Value": [472.5475]},
        "2301": {"vr": "DS", "Value": [384.1075]},
        "2302": {"vr": "DS", "Value": [139.3175]},
        "2303": {"vr": "DS", "Value": [407.7275]},
        "2304": {"vr": "DS", "Value": [336.1575]},
        "2305": {"vr": "DS", "Value": [21.405]},
        "2306": {"vr": "DS", "Value": [35.3475]},
        "2307": {"vr": "DS", "Value": [430.1575]},
        "2308": {"vr": "DS", "Value": [443.66]},
        "2309": {"vr": "DS", "Value": [267.66]},
        "2310": {"vr": "DS", "Value": [232.3125]},
        "2311": {"vr": "DS", "Value": [425.7675]},
        "2312": {"vr": "DS", "Value": [509.795]},
        "2313": {"vr": "DS", "Value": [0.7325]},
        "2314": {"vr": "DS", "Value": [259.59]},
        "2315": {"vr": "DS", "Value": [585.3375]},
        "2316": {"vr": "DS", "Value": [33.1325]},
        "2317": {"vr": "DS", "Value": [442.05]},
        "2318": {"vr": "DS", "Value": [409.19]},
        "2319": {"vr": "DS", "Value": [165.57]},
        "2320": {"vr": "DS", "Value": [272.05]},
        "2321": {"vr": "DS", "Value": [176.7325]},
        "2322": {"vr": "DS", "Value": [49.7075]},
        "2323": {"vr": "DS", "Value": [521.9825]},
        "2324": {"vr": "DS", "Value": [417.1125]},
        "2325": {"vr": "DS", "Value": [564.225]},
        "2326": {"vr": "DS", "Value": [166.1575]},
        "2327": {"vr": "DS", "Value": [268.5375]},
        "2328": {"vr": "DS", "Value": [187.7275]},
        "2329": {"vr": "DS", "Value": [250.79]},
        "2330": {"vr": "DS", "Value": [441.025]},
        "2331": {"vr": "DS", "Value": [134.3425]},
        "2332": {"vr": "DS", "Value": [417.26]},
        "2333": {"vr": "DS", "Value": [376.9175]},
        "2334": {"vr": "DS", "Value": [318.995]},
        "2335": {"vr": "DS", "Value": [219.5425]},
        "2336": {"vr": "DS", "Value": [53.5325]},
        "2337": {"vr": "DS", "Value": [394.81]},
        "2338": {"vr": "DS", "Value": [73.9125]},
        "2339": {"vr": "DS", "Value": [177.025]},
        "2340": {"vr": "DS", "Value": [498.8]},
        "2341": {"vr": "DS", "Value": [348.1775]},
        "2342": {"vr": "DS", "Value": [507.8925]},
        "2343": {"vr": "DS", "Value": [239.21]},
        "2344": {"vr": "DS", "Value": [217.3475]},
        "2345": {"vr": "DS", "Value": [252.5475]},
        "2346": {"vr": "DS", "Value": [498.215]},
        "2347": {"vr": "DS", "Value": [121.425]},
        "2348": {"vr": "DS", "Value": [361.0925]},
        "2349": {"vr": "DS", "Value": [145.63]},
        "2350": {"vr": "DS", "Value": [64.0875]},
        "2351": {"vr": "DS", "Value": [410.5075]},
        "2352": {"vr": "DS", "Value": [191.5325]},
        "2353": {"vr": "DS", "Value": [524.9075]},
        "2354": {"vr": "DS", "Value": [81.98]},
        "2355": {"vr": "DS", "Value": [25.21]},
        "2356": {"vr": "DS", "Value": [216.3225]},
        "2357": {"vr": "DS", "Value": [570.81]},
        "2358": {"vr": "DS", "Value": [199.015]},
        "2359": {"vr": "DS", "Value": [497.045]},
        "2360": {"vr": "DS", "Value": [109.26]},
        "2361": {"vr": "DS", "Value": [582.265]},
        "2362": {"vr": "DS", "Value": [473.7175]},
        "2363": {"vr": "DS", "Value": [574.7825]},
        "2364": {"vr": "DS", "Value": [540.605]},
        "2365": {"vr": "DS", "Value": [59.5325]},
        "2366": {"vr": "DS", "Value": [217.785]},
        "2367": {"vr": "DS", "Value": [346.275]},
        "2368": {"vr": "DS", "Value": [464.9175]},
        "2369": {"vr": "DS", "Value": [3.0725]},
        "2370": {"vr": "DS", "Value": [51.17]},
        "2371": {"vr": "DS", "Value": [349.9325]},
        "2372": {"vr": "DS", "Value": [201.9425]},
        "2373": {"vr": "DS", "Value": [81.25]},
        "2374": {"vr": "DS", "Value": [56.605]},
        "2375": {"vr": "DS", "Value": [290.4]},
        "2376": {"vr": "DS", "Value": [111.455]},
        "2377": {"vr": "DS", "Value": [41.785]},
        "2378": {"vr": "DS", "Value": [488.245]},
        "2379": {"vr": "DS", "Value": [77.1325]},
        "2380": {"vr": "DS", "Value": [510.4]},
        "2381": {"vr": "DS", "Value": [403.025]},
        "2382": {"vr": "DS", "Value": [401.415]},
        "2383": {"vr": "DS", "Value": [246.84]},
        "2384": {"vr": "DS", "Value": [282.3325]},
        "2385": {"vr": "DS", "Value": [304.175]},
        "2386": {"vr": "DS", "Value": [518.8875]},
        "2387": {"vr": "DS", "Value": [155.7475]},
        "2388": {"vr": "DS", "Value": [562.8875]},
        "2389": {"vr": "DS", "Value": [56.3125]},
        "2390": {"vr": "DS", "Value": [586.07]},
        "2391": {"vr": "DS", "Value": [167.035]},
        "2392": {"vr": "DS", "Value": [157.3575]},
        "2393": {"vr": "DS", "Value": [45.7575]},
        "2394": {"vr": "DS", "Value": [397.1725]},
        "2395": {"vr": "DS", "Value": [523.2975]},
        "2396": {"vr": "DS", "Value": [238.04]},
        "2397": {"vr": "DS", "Value": [518.1575]},
        "2398": {"vr": "DS", "Value": [482.665]},
        "2399": {"vr": "DS", "Value": [542.655]},
        "2400": {"vr": "DS", "Value": [493.5325]},
        "2401": {"vr": "DS", "Value": [224.0975]},
        "2402": {"vr": "DS", "Value": [508.3325]},
        "2403": {"vr": "DS", "Value": [437.785]},
        "2404": {"vr": "DS", "Value": [406.995]},
        "2405": {"vr": "DS", "Value": [420.7725]},
        "2406": {"vr": "DS", "Value": [91.22]},
        "2407": {"vr": "DS", "Value": [186.1175]},
        "2408": {"vr": "DS", "Value": [47.0725]},
        "2409": {"vr": "DS", "Value": [229.0925]},
        "2410": {"vr": "DS", "Value": [578.0]},
        "2411": {"vr": "DS", "Value": [376.3325]},
        "2412": {"vr": "DS", "Value": [409.3375]},
        "2413": {"vr": "DS", "Value": [472.255]},
        "2414": {"vr": "DS", "Value": [339.0825]},
        "2415": {"vr": "DS", "Value": [70.235]},
        "2416": {"vr": "DS", "Value": [86.5175]},
        "2417": {"vr": "DS", "Value": [596.3325]},
        "2418": {"vr": "DS", "Value": [396.295]},
        "2419": {"vr": "DS", "Value": [175.6875]},
        "2420": {"vr": "DS", "Value": [431.495]},
        "2421": {"vr": "DS", "Value": [419.3075]},
        "2422": {"vr": "DS", "Value": [445.855]},
        "2423": {"vr": "DS", "Value": [34.595]},
        "2424": {"vr": "DS", "Value": [79.4925]},
        "2425": {"vr": "DS", "Value": [370.48]},
        "2426": {"vr": "DS", "Value": [37.835]},
        "2427": {"vr": "DS", "Value": [163.5225]},
        "2428": {"vr": "DS", "Value": [356.9775]},
        "2429": {"vr": "DS", "Value": [266.78]},
        "2430": {"vr": "DS", "Value": [253.865]},
        "2431": {"vr": "DS", "Value": [40.03]},
        "2432": {"vr": "DS", "Value": [43.1025]},
        "2433": {"vr": "DS", "Value": [204.8875]},
        "2434": {"vr": "DS", "Value": [188.3125]},
        "2435": {"vr": "DS", "Value": [544.995]},
        "2436": {"vr": "DS", "Value": [120.255]},
        "2437": {"vr": "DS", "Value": [393.4925]},
        "2438": {"vr": "DS", "Value": [75.9625]},
        "2439": {"vr": "DS", "Value": [384.6925]},
        "2440": {"vr": "DS", "Value": [358.7325]},
        "2441": {"vr": "DS", "Value": [517.1325]},
        "2442": {"vr": "DS", "Value": [422.235]},
        "2443": {"vr": "DS", "Value": [463.7475]},
        "2444": {"vr": "DS", "Value": [366.215]},
        "2445": {"vr": "DS", "Value": [420.9175]},
        "2446": {"vr": "DS", "Value": [89.025]},
        "2447": {"vr": "DS", "Value": [268.83]},
        "2448": {"vr": "DS", "Value": [524.615]},
        "2449": {"vr": "DS", "Value": [43.25]},
        "2450": {"vr": "DS", "Value": [432.9575]},
        "2451": {"vr": "DS", "Value": [327.3575]},
        "2452": {"vr": "DS", "Value": [63.3575]},
        "2453": {"vr": "DS", "Value": [261.2]},
        "2454": {"vr": "DS", "Value": [565.1025]},
        "2455": {"vr": "DS", "Value": [162.3525]},
        "2456": {"vr": "DS", "Value": [320.1675]},
        "2457": {"vr": "DS", "Value": [314.7325]},
        "2458": {"vr": "DS", "Value": [322.3625]},
        "2459": {"vr": "DS", "Value": [568.3225]},
        "2460": {"vr": "DS", "Value": [213.395]},
        "2461": {"vr": "DS", "Value": [176.88]},
        "2462": {"vr": "DS", "Value": [451.875]},
        "2463": {"vr": "DS", "Value": [538.41]},
        "2464": {"vr": "DS", "Value": [481.055]},
        "2465": {"vr": "DS", "Value": [405.68]},
        "2466": {"vr": "DS", "Value": [254.7425]},
        "2467": {"vr": "DS", "Value": [327.065]},
        "2468": {"vr": "DS", "Value": [485.1725]},
        "2469": {"vr": "DS", "Value": [284.5275]},
        "2470": {"vr": "DS", "Value": [119.375]},
        "2471": {"vr": "DS", "Value": [389.835]},
        "2472": {"vr": "DS", "Value": [283.65]},
        "2473": {"vr": "DS", "Value": [189.3375]},
        "2474": {"vr": "DS", "Value": [25.9425]},
        "2475": {"vr": "DS", "Value": [391.445]},
        "2476": {"vr": "DS", "Value": [376.625]},
        "2477": {"vr": "DS", "Value": [570.08]},
        "2478": {"vr": "DS", "Value": [85.64]},
        "2479": {"vr": "DS", "Value": [107.065]},
        "2480": {"vr": "DS", "Value": [496.7525]},
        "2481": {"vr": "DS", "Value": [517.7175]},
        "2482": {"vr": "DS", "Value": [224.6825]},
        "2483": {"vr": "DS", "Value": [508.7725]},
        "2484": {"vr": "DS", "Value": [74.205]},
        "2485": {"vr": "DS", "Value": [190.215]},
        "2486": {"vr": "DS", "Value": [188.02]},
        "2487": {"vr": "DS", "Value": [492.4875]},
        "2488": {"vr": "DS", "Value": [571.395]},
        "2489": {"vr": "DS", "Value": [560.255]},
        "2490": {"vr": "DS", "Value": [428.985]},
        "2491": {"vr": "DS", "Value": [86.955]},
        "2492": {"vr": "DS", "Value": [323.385]},
        "2493": {"vr": "DS", "Value": [363.2875]},
        "2494": {"vr": "DS", "Value": [562.45]},
        "2495": {"vr": "DS", "Value": [196.5275]},
        "2496": {"vr": "DS", "Value": [124.665]},
        "2497": {"vr": "DS", "Value": [508.185]},
        "2498": {"vr": "DS", "Value": [410.9475]},
        "2499": {"vr": "DS", "Value": [226.2925]},
        "2500": {"vr": "DS", "Value": [526.5175]},
        "2501": {"vr": "DS", "Value": [277.045]},
        "2502": {"vr": "DS", "Value": [67.1625]},
        "2503": {"vr": "DS", "Value": [491.3175]},
        "2504": {"vr": "DS", "Value": [133.61]},
        "2505": {"vr": "DS", "Value": [408.605]},
        "2506": {"vr": "DS", "Value": [233.19]},
        "2507": {"vr": "DS", "Value": [389.395]},
        "2508": {"vr": "DS", "Value": [359.61]},
        "2509": {"vr": "DS", "Value": [148.7025]},
        "2510": {"vr": "DS", "Value": [439.835]},
        "2511": {"vr": "DS", "Value": [239.5025]},
        "2512": {"vr": "DS", "Value": [354.7825]},
        "2513": {"vr": "DS", "Value": [556.1575]},
        "2514": {"vr": "DS", "Value": [193.8925]},
        "2515": {"vr": "DS", "Value": [60.85]},
        "2516": {"vr": "DS", "Value": [54.5575]},
        "2517": {"vr": "DS", "Value": [528.0025]},
        "2518": {"vr": "DS", "Value": [265.7575]},
        "2519": {"vr": "DS", "Value": [220.88]},
        "2520": {"vr": "DS", "Value": [400.39]},
        "2521": {"vr": "DS", "Value": [491.465]},
        "2522": {"vr": "DS", "Value": [591.21]},
        "2523": {"vr": "DS", "Value": [71.5725]},
        "2524": {"vr": "DS", "Value": [331.8925]},
        "2525": {"vr": "DS", "Value": [595.1625]},
        "2526": {"vr": "DS", "Value": [186.265]},
        "2527": {"vr": "DS", "Value": [184.9475]},
        "2528": {"vr": "DS", "Value": [509.65]},
        "2529": {"vr": "DS", "Value": [218.0775]},
        "2530": {"vr": "DS", "Value": [474.7425]},
        "2531": {"vr": "DS", "Value": [452.605]},
        "2532": {"vr": "DS", "Value": [354.3425]},
        "2533": {"vr": "DS", "Value": [48.245]},
        "2534": {"vr": "DS", "Value": [404.3425]},
        "2535": {"vr": "DS", "Value": [363.875]},
        "2536": {"vr": "DS", "Value": [263.395]},
        "2537": {"vr": "DS", "Value": [306.9575]},
        "2538": {"vr": "DS", "Value": [413.7475]},
        "2539": {"vr": "DS", "Value": [590.1875]},
        "2540": {"vr": "DS", "Value": [581.5325]},
        "2541": {"vr": "DS", "Value": [321.045]},
        "2542": {"vr": "DS", "Value": [198.87]},
        "2543": {"vr": "DS", "Value": [453.63]},
        "2544": {"vr": "DS", "Value": [95.9025]},
        "2545": {"vr": "DS", "Value": [357.415]},
        "2546": {"vr": "DS", "Value": [397.7575]},
        "2547": {"vr": "DS", "Value": [120.985]},
        "2548": {"vr": "DS", "Value": [204.3025]},
        "2549": {"vr": "DS", "Value": [320.7525]},
        "2550": {"vr": "DS", "Value": [546.9175]},
        "2551": {"vr": "DS", "Value": [469.3275]},
        "2552": {"vr": "DS", "Value": [574.635]},
        "2553": {"vr": "DS", "Value": [69.355]},
        "2554": {"vr": "DS", "Value": [183.025]},
        "2555": {"vr": "DS", "Value": [375.3075]},
        "2556": {"vr": "DS", "Value": [531.9525]},
        "2557": {"vr": "DS", "Value": [498.5075]},
        "2558": {"vr": "DS", "Value": [342.8875]},
        "2559": {"vr": "DS", "Value": [505.99]},
        "2560": {"vr": "DS", "Value": [556.89]},
        "2561": {"vr": "DS", "Value": [258.42]},
        "2562": {"vr": "DS", "Value": [379.28]},
        "2563": {"vr": "DS", "Value": [225.27]},
        "2564": {"vr": "DS", "Value": [152.38]},
        "2565": {"vr": "DS", "Value": [516.985]},
        "2566": {"vr": "DS", "Value": [447.025]},
        "2567": {"vr": "DS", "Value": [394.9575]},
        "2568": {"vr": "DS", "Value": [563.7875]},
        "2569": {"vr": "DS", "Value": [98.265]},
        "2570": {"vr": "DS", "Value": [552.04]},
        "2571": {"vr": "DS", "Value": [110.7225]},
        "2572": {"vr": "DS", "Value": [597.795]},
        "2573": {"vr": "DS", "Value": [46.635]},
        "2574": {"vr": "DS", "Value": [379.7175]},
        "2575": {"vr": "DS", "Value": [75.375]},
        "2576": {"vr": "DS", "Value": [461.5525]},
        "2577": {"vr": "DS", "Value": [187.875]},
        "2578": {"vr": "DS", "Value": [27.865]},
        "2579": {"vr": "DS", "Value": [18.185]},
        "2580": {"vr": "DS", "Value": [588.1175]},
        "2581": {"vr": "DS", "Value": [313.1225]},
        "2582": {"vr": "DS", "Value": [316.4875]},
        "2583": {"vr": "DS", "Value": [252.6925]},
        "2584": {"vr": "DS", "Value": [209.1325]},
        "2585": {"vr": "DS", "Value": [500.85]},
        "2586": {"vr": "DS", "Value": [387.035]},
        "2587": {"vr": "DS", "Value": [444.9775]},
        "2588": {"vr": "DS", "Value": [23.8925]},
        "2589": {"vr": "DS", "Value": [587.385]},
        "2590": {"vr": "DS", "Value": [368.265]},
        "2591": {"vr": "DS", "Value": [546.7725]},
        "2592": {"vr": "DS", "Value": [235.6775]},
        "2593": {"vr": "DS", "Value": [263.835]},
        "2594": {"vr": "DS", "Value": [176.585]},
        "2595": {"vr": "DS", "Value": [528.88]},
        "2596": {"vr": "DS", "Value": [184.4875]},
        "2597": {"vr": "DS", "Value": [567.005]},
        "2598": {"vr": "DS", "Value": [167.9325]},
        "2599": {"vr": "DS", "Value": [365.7775]},
        "2600": {"vr": "DS", "Value": [460.235]},
        "2601": {"vr": "DS", "Value": [504.5275]},
        "2602": {"vr": "DS", "Value": [271.465]},
        "2603": {"vr": "DS", "Value": [460.82]},
        "2604": {"vr": "DS", "Value": [525.785]},
        "2605": {"vr": "DS", "Value": [421.065]},
        "2606": {"vr": "DS", "Value": [477.1025]},
        "2607": {"vr": "DS", "Value": [421.795]},
        "2608": {"vr": "DS", "Value": [572.295]},
        "2609": {"vr": "DS", "Value": [396.88]},
        "2610": {"vr": "DS", "Value": [174.225]},
        "2611": {"vr": "DS", "Value": [205.035]},
        "2612": {"vr": "DS", "Value": [134.635]},
        "2613": {"vr": "DS", "Value": [73.18]},
        "2614": {"vr": "DS", "Value": [389.9825]},
        "2615": {"vr": "DS", "Value": [524.1775]},
        "2616": {"vr": "DS", "Value": [177.1725]},
        "2617": {"vr": "DS", "Value": [429.2775]},
        "2618": {"vr": "DS", "Value": [400.83]},
        "2619": {"vr": "DS", "Value": [253.425]},
        "2620": {"vr": "DS", "Value": [171.8825]},
        "2621": {"vr": "DS", "Value": [326.625]},
        "2622": {"vr": "DS", "Value": [529.9025]},
        "2623": {"vr": "DS", "Value": [502.9175]},
        "2624": {"vr": "DS", "Value": [502.3325]},
        "2625": {"vr": "DS", "Value": [222.635]},
        "2626": {"vr": "DS", "Value": [583.5825]},
        "2627": {"vr": "DS", "Value": [491.9025]},
        "2628": {"vr": "DS", "Value": [591.065]},
        "2629": {"vr": "DS", "Value": [113.21]},
        "2630": {"vr": "DS", "Value": [282.04]},
        "2631": {"vr": "DS", "Value": [271.61]},
        "2632": {"vr": "DS", "Value": [135.5125]},
        "2633": {"vr": "DS", "Value": [296.84]},
        "2634": {"vr": "DS", "Value": [219.25]},
        "2635": {"vr": "DS", "Value": [37.6875]},
        "2636": {"vr": "DS", "Value": [497.485]},
        "2637": {"vr": "DS", "Value": [279.385]},
        "2638": {"vr": "DS", "Value": [28.595]},
        "2639": {"vr": "DS", "Value": [398.3425]},
        "2640": {"vr": "DS", "Value": [6.585]},
        "2641": {"vr": "DS", "Value": [88.0]},
        "2642": {"vr": "DS", "Value": [251.67]},
        "2643": {"vr": "DS", "Value": [585.485]},
        "2644": {"vr": "DS", "Value": [352.5875]},
        "2645": {"vr": "DS", "Value": [489.855]},
        "2646": {"vr": "DS", "Value": [332.4775]},
        "2647": {"vr": "DS", "Value": [431.7875]},
        "2648": {"vr": "DS", "Value": [391.1525]},
        "2649": {"vr": "DS", "Value": [127.7375]},
        "2650": {"vr": "DS", "Value": [154.43]},
        "2651": {"vr": "DS", "Value": [202.0875]},
        "2652": {"vr": "DS", "Value": [97.385]},
        "2653": {"vr": "DS", "Value": [553.065]},
        "2654": {"vr": "DS", "Value": [477.395]},
        "2655": {"vr": "DS", "Value": [42.81]},
        "2656": {"vr": "DS", "Value": [86.81]},
        "2657": {"vr": "DS", "Value": [163.375]},
        "2658": {"vr": "DS", "Value": [597.21]},
        "2659": {"vr": "DS", "Value": [224.975]},
        "2660": {"vr": "DS", "Value": [416.3825]},
        "2661": {"vr": "DS", "Value": [514.4975]},
        "2662": {"vr": "DS", "Value": [548.5275]},
        "2663": {"vr": "DS", "Value": [58.3625]},
        "2664": {"vr": "DS", "Value": [72.1575]},
        "2665": {"vr": "DS", "Value": [78.8875]},
        "2666": {"vr": "DS", "Value": [512.01]},
        "2667": {"vr": "DS", "Value": [169.395]},
        "2668": {"vr": "DS", "Value": [65.6975]},
        "2669": {"vr": "DS", "Value": [92.975]},
        "2670": {"vr": "DS", "Value": [267.22]},
        "2671": {"vr": "DS", "Value": [220.44]},
        "2672": {"vr": "DS", "Value": [466.0875]},
        "2673": {"vr": "DS", "Value": [119.23]},
        "2674": {"vr": "DS", "Value": [69.65]},
        "2675": {"vr": "DS", "Value": [86.6625]},
        "2676": {"vr": "DS", "Value": [62.9175]},
        "2677": {"vr": "DS", "Value": [271.025]},
        "2678": {"vr": "DS", "Value": [467.1325]},
        "2679": {"vr": "DS", "Value": [305.785]},
        "2680": {"vr": "DS", "Value": [8.635]},
        "2681": {"vr": "DS", "Value": [428.5475]},
        "2682": {"vr": "DS", "Value": [323.825]},
        "2683": {"vr": "DS", "Value": [442.7825]},
        "2684": {"vr": "DS", "Value": [252.4]},
        "2685": {"vr": "DS", "Value": [394.3725]},
        "2686": {"vr": "DS", "Value": [135.0725]},
        "2687": {"vr": "DS", "Value": [350.81]},
        "2688": {"vr": "DS", "Value": [362.7025]},
        "2689": {"vr": "DS", "Value": [217.64]},
        "2690": {"vr": "DS", "Value": [258.1275]},
        "2691": {"vr": "DS", "Value": [93.1225]},
        "2692": {"vr": "DS", "Value": [102.9475]},
        "2693": {"vr": "DS", "Value": [363.435]},
        "2694": {"vr": "DS", "Value": [465.5025]},
        "2695": {"vr": "DS", "Value": [435.7375]},
        "2696": {"vr": "DS", "Value": [82.1275]},
        "2697": {"vr": "DS", "Value": [549.845]},
        "2698": {"vr": "DS", "Value": [364.3125]},
        "2699": {"vr": "DS", "Value": [142.41]},
        "2700": {"vr": "DS", "Value": [35.4925]},
        "2701": {"vr": "DS", "Value": [240.0875]},
        "2702": {"vr": "DS", "Value": [210.8875]},
        "2703": {"vr": "DS", "Value": [565.5425]},
        "2704": {"vr": "DS", "Value": [242.87]},
        "2705": {"vr": "DS", "Value": [54.41]},
        "2706": {"vr": "DS", "Value": [122.3025]},
        "2707": {"vr": "DS", "Value": [541.485]},
        "2708": {"vr": "DS", "Value": [519.7875]},
        "2709": {"vr": "DS", "Value": [491.7575]},
        "2710": {"vr": "DS", "Value": [369.8925]},
        "2711": {"vr": "DS", "Value": [66.7225]},
        "2712": {"vr": "DS", "Value": [230.265]},
        "2713": {"vr": "DS", "Value": [566.5675]},
        "2714": {"vr": "DS", "Value": [510.235]},
        "2715": {"vr": "DS", "Value": [351.1025]},
        "2716": {"vr": "DS", "Value": [357.1225]},
        "2717": {"vr": "DS", "Value": [222.05]},
        "2718": {"vr": "DS", "Value": [22.7225]},
        "2719": {"vr": "DS", "Value": [336.8875]},
        "2720": {"vr": "DS", "Value": [211.2]},
        "2721": {"vr": "DS", "Value": [548.235]},
        "2722": {"vr": "DS", "Value": [218.37]},
        "2723": {"vr": "DS", "Value": [581.825]},
        "2724": {"vr": "DS", "Value": [462.87]},
        "2725": {"vr": "DS", "Value": [449.825]},
        "2726": {"vr": "DS", "Value": [495.5825]},
        "2727": {"vr": "DS", "Value": [253.57]},
        "2728": {"vr": "DS", "Value": [146.8]},
        "2729": {"vr": "DS", "Value": [263.6875]},
        "2730": {"vr": "DS", "Value": [339.815]},
        "2731": {"vr": "DS", "Value": [232.8975]},
        "2732": {"vr": "DS", "Value": [573.9025]},
        "2733": {"vr": "DS", "Value": [542.215]},
        "2734": {"vr": "DS", "Value": [263.5425]},
        "2735": {"vr": "DS", "Value": [91.5125]},
        "2736": {"vr": "DS", "Value": [304.9075]},
        "2737": {"vr": "DS", "Value": [255.64]},
        "2738": {"vr": "DS", "Value": [22.575]},
        "2739": {"vr": "DS", "Value": [338.06]},
        "2740": {"vr": "DS", "Value": [165.2775]},
        "2741": {"vr": "DS", "Value": [592.235]},
        "2742": {"vr": "DS", "Value": [583.435]},
        "2743": {"vr": "DS", "Value": [542.9475]},
        "2744": {"vr": "DS", "Value": [415.3575]},
        "2745": {"vr": "DS", "Value": [29.9125]},
        "2746": {"vr": "DS", "Value": [399.075]},
        "2747": {"vr": "DS", "Value": [468.595]},
        "2748": {"vr": "DS", "Value": [351.395]},
        "2749": {"vr": "DS", "Value": [219.395]},
        "2750": {"vr": "DS", "Value": [106.9175]},
        "2751": {"vr": "DS", "Value": [450.265]},
        "2752": {"vr": "DS", "Value": [145.19]},
        "2753": {"vr": "DS", "Value": [24.04]},
        "2754": {"vr": "DS", "Value": [540.8975]},
        "2755": {"vr": "DS", "Value": [148.1175]},
        "2756": {"vr": "DS", "Value": [505.6975]},
        "2757": {"vr": "DS", "Value": [205.475]},
        "2758": {"vr": "DS", "Value": [61.8925]},
        "2759": {"vr": "DS", "Value": [98.995]},
        "2760": {"vr": "DS", "Value": [354.9275]},
        "2761": {"vr": "DS", "Value": [254.3025]},
        "2762": {"vr": "DS", "Value": [388.225]},
        "2763": {"vr": "DS", "Value": [122.7425]},
        "2764": {"vr": "DS", "Value": [64.82]},
        "2765": {"vr": "DS", "Value": [299.3475]},
        "2766": {"vr": "DS", "Value": [154.8675]},
        "2767": {"vr": "DS", "Value": [309.9025]},
        "2768": {"vr": "DS", "Value": [389.25]},
        "2769": {"vr": "DS", "Value": [84.175]},
        "2770": {"vr": "DS", "Value": [397.61]},
        "2771": {"vr": "DS", "Value": [39.2975]},
        "2772": {"vr": "DS", "Value": [88.7325]},
        "2773": {"vr": "DS", "Value": [515.5225]},
        "2774": {"vr": "DS", "Value": [255.3475]},
        "2775": {"vr": "DS", "Value": [18.9175]},
        "2776": {"vr": "DS", "Value": [76.5475]},
        "2777": {"vr": "DS", "Value": [401.5625]},
        "2778": {"vr": "DS", "Value": [309.3175]},
        "2779": {"vr": "DS", "Value": [455.0925]},
        "2780": {"vr": "DS", "Value": [342.7425]},
        "2781": {"vr": "DS", "Value": [591.7975]},
        "2782": {"vr": "DS", "Value": [130.9575]},
        "2783": {"vr": "DS", "Value": [83.1525]},
        "2784": {"vr": "DS", "Value": [246.235]},
        "2785": {"vr": "DS", "Value": [308.7325]},
        "2786": {"vr": "DS", "Value": [282.9175]},
        "2787": {"vr": "DS", "Value": [556.7425]},
        "2788": {"vr": "DS", "Value": [356.5375]},
        "2789": {"vr": "DS", "Value": [388.81]},
        "2790": {"vr": "DS", "Value": [134.78]},
        "2791": {"vr": "DS", "Value": [423.1325]},
        "2792": {"vr": "DS", "Value": [495.435]},
        "2793": {"vr": "DS", "Value": [457.6]},
        "2794": {"vr": "DS", "Value": [186.41]},
        "2795": {"vr": "DS", "Value": [153.99]},
        "2796": {"vr": "DS", "Value": [334.0875]},
        "2797": {"vr": "DS", "Value": [403.465]},
        "2798": {"vr": "DS", "Value": [445.415]},
        "2799": {"vr": "DS", "Value": [510.695]},
        "2800": {"vr": "DS", "Value": [406.265]},
        "2801": {"vr": "DS", "Value": [233.045]},
        "2802": {"vr": "DS", "Value": [546.04]},
        "2803": {"vr": "DS", "Value": [274.5575]},
        "2804": {"vr": "DS", "Value": [339.3775]},
        "2805": {"vr": "DS", "Value": [382.4975]},
        "2806": {"vr": "DS", "Value": [96.9475]},
        "2807": {"vr": "DS", "Value": [557.62]},
        "2808": {"vr": "DS", "Value": [540.1675]},
        "2809": {"vr": "DS", "Value": [246.4]},
        "2810": {"vr": "DS", "Value": [333.065]},
        "2811": {"vr": "DS", "Value": [589.2875]},
        "2812": {"vr": "DS", "Value": [275.2875]},
        "2813": {"vr": "DS", "Value": [163.815]},
        "2814": {"vr": "DS", "Value": [57.9225]},
        "2815": {"vr": "DS", "Value": [338.205]},
        "2816": {"vr": "DS", "Value": [125.1025]},
        "2817": {"vr": "DS", "Value": [371.5025]},
        "2818": {"vr": "DS", "Value": [205.7675]},
        "2819": {"vr": "DS", "Value": [537.24]},
        "2820": {"vr": "DS", "Value": [283.3575]},
        "2821": {"vr": "DS", "Value": [539.875]},
        "2822": {"vr": "DS", "Value": [396.1475]},
        "2823": {"vr": "DS", "Value": [527.25]},
        "2824": {"vr": "DS", "Value": [527.835]},
        "2825": {"vr": "DS", "Value": [201.5025]},
        "2826": {"vr": "DS", "Value": [54.265]},
        "2827": {"vr": "DS", "Value": [144.7525]},
        "2828": {"vr": "DS", "Value": [549.6975]},
        "2829": {"vr": "DS", "Value": [475.3475]},
        "2830": {"vr": "DS", "Value": [307.5425]},
        "2831": {"vr": "DS", "Value": [509.3575]},
        "2832": {"vr": "DS", "Value": [356.83]},
        "2833": {"vr": "DS", "Value": [276.7525]},
        "2834": {"vr": "DS", "Value": [375.8925]},
        "2835": {"vr": "DS", "Value": [238.7725]},
        "2836": {"vr": "DS", "Value": [359.025]},
        "2837": {"vr": "DS", "Value": [120.4]},
        "2838": {"vr": "DS", "Value": [199.6]},
        "2839": {"vr": "DS", "Value": [331.3075]},
        "2840": {"vr": "DS", "Value": [268.6825]},
        "2841": {"vr": "DS", "Value": [460.09]},
        "2842": {"vr": "DS", "Value": [455.385]},
        "2843": {"vr": "DS", "Value": [271.9025]},
        "2844": {"vr": "DS", "Value": [156.04]},
        "2845": {"vr": "DS", "Value": [194.04]},
        "2846": {"vr": "DS", "Value": [166.01]},
        "2847": {"vr": "DS", "Value": [507.1625]},
        "2848": {"vr": "DS", "Value": [571.6875]},
        "2849": {"vr": "DS", "Value": [487.805]},
        "2850": {"vr": "DS", "Value": [393.785]},
        "2851": {"vr": "DS", "Value": [449.9725]},
        "2852": {"vr": "DS", "Value": [299.4925]},
        "2853": {"vr": "DS", "Value": [141.385]},
        "2854": {"vr": "DS", "Value": [185.24]},
        "2855": {"vr": "DS", "Value": [0.44]},
        "2856": {"vr": "DS", "Value": [240.38]},
        "2857": {"vr": "DS", "Value": [188.1675]},
        "2858": {"vr": "DS", "Value": [233.63]},
        "2859": {"vr": "DS", "Value": [437.3475]},
        "2860": {"vr": "DS", "Value": [487.9525]},
        "2861": {"vr": "DS", "Value": [171.005]},
        "2862": {"vr": "DS", "Value": [5.7075]},
        "2863": {"vr": "DS", "Value": [293.035]},
        "2864": {"vr": "DS", "Value": [72.7425]},
        "2865": {"vr": "DS", "Value": [455.9725]},
        "2866": {"vr": "DS", "Value": [189.775]},
        "2867": {"vr": "DS", "Value": [422.0875]},
        "2868": {"vr": "DS", "Value": [503.9425]},
        "2869": {"vr": "DS", "Value": [186.5575]},
        "2870": {"vr": "DS", "Value": [140.3425]},
        "2871": {"vr": "DS", "Value": [29.4725]},
        "2872": {"vr": "DS", "Value": [461.26]},
        "2873": {"vr": "DS", "Value": [415.795]},
        "2874": {"vr": "DS", "Value": [227.025]},
        "2875": {"vr": "DS", "Value": [534.1475]},
        "2876": {"vr": "DS", "Value": [284.82]},
        "2877": {"vr": "DS", "Value": [345.6875]},
        "2878": {"vr": "DS", "Value": [493.3875]},
        "2879": {"vr": "DS", "Value": [348.3225]},
        "2880": {"vr": "DS", "Value": [344.225]},
        "2881": {"vr": "DS", "Value": [278.655]},
        "2882": {"vr": "DS", "Value": [108.82]},
        "2883": {"vr": "DS", "Value": [68.625]},
        "2884": {"vr": "DS", "Value": [53.825]},
        "2885": {"vr": "DS", "Value": [221.7575]},
        "2886": {"vr": "DS", "Value": [334.84]},
        "2887": {"vr": "DS", "Value": [246.5475]},
        "2888": {"vr": "DS", "Value": [241.6975]},
        "2889": {"vr": "DS", "Value": [573.1725]},
        "2890": {"vr": "DS", "Value": [87.25]},
        "2891": {"vr": "DS", "Value": [126.1275]},
        "2892": {"vr": "DS", "Value": [484.7325]},
        "2893": {"vr": "DS", "Value": [190.655]},
        "2894": {"vr": "DS", "Value": [290.235]},
        "2895": {"vr": "DS", "Value": [41.2]},
        "2896": {"vr": "DS", "Value": [509.21]},
        "2897": {"vr": "DS", "Value": [273.0925]},
        "2898": {"vr": "DS", "Value": [322.8]},
        "2899": {"vr": "DS", "Value": [157.21]},
        "2900": {"vr": "DS", "Value": [372.675]},
        "2901": {"vr": "DS", "Value": [72.3025]},
        "2902": {"vr": "DS", "Value": [538.1175]},
        "2903": {"vr": "DS", "Value": [381.035]},
        "2904": {"vr": "DS", "Value": [374.2825]},
        "2905": {"vr": "DS", "Value": [167.64]},
        "2906": {"vr": "DS", "Value": [1.465]},
        "2907": {"vr": "DS", "Value": [590.48]},
        "2908": {"vr": "DS", "Value": [92.83]},
        "2909": {"vr": "DS", "Value": [557.035]},
        "2910": {"vr": "DS", "Value": [185.0925]},
        "2911": {"vr": "DS", "Value": [537.3875]},
        "2912": {"vr": "DS", "Value": [76.985]},
        "2913": {"vr": "DS", "Value": [260.175]},
        "2914": {"vr": "DS", "Value": [90.4875]},
        "2915": {"vr": "DS", "Value": [329.26]},
        "2916": {"vr": "DS", "Value": [300.81]},
        "2917": {"vr": "DS", "Value": [184.635]},
        "2918": {"vr": "DS", "Value": [5.2675]},
        "2919": {"vr": "DS", "Value": [596.04]},
        "2920": {"vr": "DS", "Value": [438.81]},
        "2921": {"vr": "DS", "Value": [390.42]},
        "2922": {"vr": "DS", "Value": [413.1425]},
        "2923": {"vr": "DS", "Value": [301.9825]},
        "2924": {"vr": "DS", "Value": [378.9875]},
        "2925": {"vr": "DS", "Value": [57.045]},
        "2926": {"vr": "DS", "Value": [116.01]},
        "2927": {"vr": "DS", "Value": [481.9325]},
        "2928": {"vr": "DS", "Value": [168.9575]},
        "2929": {"vr": "DS", "Value": [25.0625]},
        "2930": {"vr": "DS", "Value": [110.1375]},
        "2931": {"vr": "DS", "Value": [586.215]},
        "2932": {"vr": "DS", "Value": [568.47]},
        "2933": {"vr": "DS", "Value": [90.635]},
        "2934": {"vr": "DS", "Value": [352.1475]},
        "2935": {"vr": "DS", "Value": [114.0875]},
        "2936": {"vr": "DS", "Value": [417.845]},
        "2937": {"vr": "DS", "Value": [484.44]},
        "2938": {"vr": "DS", "Value": [486.635]},
        "2939": {"vr": "DS", "Value": [221.9025]},
        "2940": {"vr": "DS", "Value": [249.475]},
        "2941": {"vr": "DS", "Value": [143.7275]},
        "2942": {"vr": "DS", "Value": [516.6925]},
        "2943": {"vr": "DS", "Value": [412.41]},
        "2944": {"vr": "DS", "Value": [544.41]},
        "2945": {"vr": "DS", "Value": [587.825]},
        "2946": {"vr": "DS", "Value": [203.28]},
        "2947": {"vr": "DS", "Value": [487.075]},
        "2948": {"vr": "DS", "Value": [276.46]},
        "2949": {"vr": "DS", "Value": [4.83]},
        "2950": {"vr": "DS", "Value": [122.595]},
        "2951": {"vr": "DS", "Value": [362.1175]},
        "2952": {"vr": "DS", "Value": [543.9725]},
        "2953": {"vr": "DS", "Value": [241.5525]},
        "2954": {"vr": "DS", "Value": [305.055]},
        "2955": {"vr": "DS", "Value": [404.195]},
        "2956": {"vr": "DS", "Value": [437.64]},
        "2957": {"vr": "DS", "Value": [85.055]},
        "2958": {"vr": "DS", "Value": [91.9525]},
        "2959": {"vr": "DS", "Value": [161.475]},
        "2960": {"vr": "DS", "Value": [177.61]},
        "2961": {"vr": "DS", "Value": [167.3475]},
        "2962": {"vr": "DS", "Value": [166.3025]},
        "2963": {"vr": "DS", "Value": [512.1575]},
        "2964": {"vr": "DS", "Value": [116.3025]},
        "2965": {"vr": "DS", "Value": [504.675]},
        "2966": {"vr": "DS", "Value": [223.5125]},
        "2967": {"vr": "DS", "Value": [63.065]},
        "2968": {"vr": "DS", "Value": [209.2775]},
        "2969": {"vr": "DS", "Value": [124.9575]},
        "2970": {"vr": "DS", "Value": [464.4775]},
        "2971": {"vr": "DS", "Value": [584.02]},
        "2972": {"vr": "DS", "Value": [507.455]},
        "2973": {"vr": "DS", "Value": [335.865]},
        "2974": {"vr": "DS", "Value": [126.2725]},
        "2975": {"vr": "DS", "Value": [45.9025]},
        "2976": {"vr": "DS", "Value": [164.1075]},
        "2977": {"vr": "DS", "Value": [355.075]},
        "2978": {"vr": "DS", "Value": [91.0725]},
        "2979": {"vr": "DS", "Value": [470.4975]},
        "2980": {"vr": "DS", "Value": [318.41]},
        "2981": {"vr": "DS", "Value": [441.3175]},
        "2982": {"vr": "DS", "Value": [367.97]},
        "2983": {"vr": "DS", "Value": [77.57]},
        "2984": {"vr": "DS", "Value": [475.495]},
        "2985": {"vr": "DS", "Value": [210.7425]},
        "2986": {"vr": "DS", "Value": [200.9175]},
        "2987": {"vr": "DS", "Value": [373.99]},
        "2988": {"vr": "DS", "Value": [380.595]},
        "2989": {"vr": "DS", "Value": [453.3375]},
        "2990": {"vr": "DS", "Value": [35.2]},
        "2991": {"vr": "DS", "Value": [410.655]},
        "2992": {"vr": "DS", "Value": [380.7425]},
        "2993": {"vr": "DS", "Value": [320.3125]},
        "2994": {"vr": "DS", "Value": [460.5275]},
        "2995": {"vr": "DS", "Value": [519.035]},
        "2996": {"vr": "DS", "Value": [266.4875]},
        "2997": {"vr": "DS", "Value": [174.6625]},
        "2998": {"vr": "DS", "Value": [337.035]},
        "2999": {"vr": "DS", "Value": [321.3375]},
        "3000": {"vr": "DS", "Value": [468.3025]},
        "3001": {"vr": "DS", "Value": [76.84]},
        "3002": {"vr": "DS", "Value": [508.625]},
        "3003": {"vr": "DS", "Value": [377.3575]},
        "3004": {"vr": "DS", "Value": [445.27]},
        "3005": {"vr": "DS", "Value": [590.9175]},
        "3006": {"vr": "DS", "Value": [444.39]},
        "3007": {"vr": "DS", "Value": [477.9825]},
        "3008": {"vr": "DS", "Value": [66.2825]},
        "3009": {"vr": "DS", "Value": [117.3275]},
        "3010": {"vr": "DS", "Value": [429.1325]},
        "3011": {"vr": "DS", "Value": [221.1725]},
        "3012": {"vr": "DS", "Value": [227.4625]},
        "3013": {"vr": "DS", "Value": [138.2925]},
        "3014": {"vr": "DS", "Value": [576.5375]},
        "3015": {"vr": "DS", "Value": [249.3275]},
        "3016": {"vr": "DS", "Value": [287.455]},
        "3017": {"vr": "DS", "Value": [340.4]},
        "3018": {"vr": "DS", "Value": [521.5425]},
        "3019": {"vr": "DS", "Value": [7.025]},
        "3020": {"vr": "DS", "Value": [251.815]},
        "3021": {"vr": "DS", "Value": [330.2825]},
        "3022": {"vr": "DS", "Value": [199.3075]},
        "3023": {"vr": "DS", "Value": [378.5475]},
        "3024": {"vr": "DS", "Value": [328.235]},
        "3025": {"vr": "DS", "Value": [470.79]},
        "3026": {"vr": "DS", "Value": [23.6]},
        "3027": {"vr": "DS", "Value": [133.025]},
        "3028": {"vr": "DS", "Value": [264.88]},
        "3029": {"vr": "DS", "Value": [403.61]},
        "3030": {"vr": "DS", "Value": [477.69]},
        "3031": {"vr": "DS", "Value": [487.66]},
        "3032": {"vr": "DS", "Value": [579.61]},
        "3033": {"vr": "DS", "Value": [97.6775]},
        "3034": {"vr": "DS", "Value": [176.2925]},
        "3035": {"vr": "DS", "Value": [233.3375]},
        "3036": {"vr": "DS", "Value": [513.62]},
        "3037": {"vr": "DS", "Value": [348.47]},
        "3038": {"vr": "DS", "Value": [101.775]},
        "3039": {"vr": "DS", "Value": [101.3375]},
        "3040": {"vr": "DS", "Value": [102.0675]},
        "3041": {"vr": "DS", "Value": [164.255]},
        "3042": {"vr": "DS", "Value": [374.43]},
        "3043": {"vr": "DS", "Value": [456.1175]},
        "3044": {"vr": "DS", "Value": [489.1225]},
        "3045": {"vr": "DS", "Value": [81.835]},
        "3046": {"vr": "DS", "Value": [132.88]},
        "3047": {"vr": "DS", "Value": [275.1425]},
        "3048": {"vr": "DS", "Value": [251.0825]},
        "3049": {"vr": "DS", "Value": [549.1125]},
        "3050": {"vr": "DS", "Value": [386.45]},
        "3051": {"vr": "DS", "Value": [321.63]},
        "3052": {"vr": "DS", "Value": [147.825]},
        "3053": {"vr": "DS", "Value": [105.6]},
        "3054": {"vr": "DS", "Value": [489.5625]},
        "3055": {"vr": "DS", "Value": [50.8775]},
        "3056": {"vr": "DS", "Value": [534.44]},
        "3057": {"vr": "DS", "Value": [61.6]},
        "3058": {"vr": "DS", "Value": [140.195]},
        "3059": {"vr": "DS", "Value": [140.4875]},
        "3060": {"vr": "DS", "Value": [385.2775]},
        "3061": {"vr": "DS", "Value": [197.6975]},
        "3062": {"vr": "DS", "Value": [560.84]},
        "3063": {"vr": "DS", "Value": [529.465]},
        "3064": {"vr": "DS", "Value": [260.03]},
        "3065": {"vr": "DS", "Value": [371.3575]},
        "3066": {"vr": "DS", "Value": [438.225]},
        "3067": {"vr": "DS", "Value": [315.465]},
        "3068": {"vr": "DS", "Value": [418.43]},
        "3069": {"vr": "DS", "Value": [326.1875]},
        "3070": {"vr": "DS", "Value": [563.3475]},
        "3071": {"vr": "DS", "Value": [313.27]},
        "3072": {"vr": "DS", "Value": [402.0]},
        "3073": {"vr": "DS", "Value": [153.6975]},
        "3074": {"vr": "DS", "Value": [106.3325]},
        "3075": {"vr": "DS", "Value": [575.22]},
        "3076": {"vr": "DS", "Value": [36.665]},
        "3077": {"vr": "DS", "Value": [398.7825]},
        "3078": {"vr": "DS", "Value": [337.7675]},
        "3079": {"vr": "DS", "Value": [253.7175]},
        "3080": {"vr": "DS", "Value": [45.61]},
        "3081": {"vr": "DS", "Value": [508.9175]},
        "3082": {"vr": "DS", "Value": [528.44]},
        "3083": {"vr": "DS", "Value": [226.0]},
        "3084": {"vr": "DS", "Value": [336.45]},
        "3085": {"vr": "DS", "Value": [225.855]},
        "3086": {"vr": "DS", "Value": [335.7175]},
        "3087": {"vr": "DS", "Value": [39.7375]},
        "3088": {"vr": "DS", "Value": [444.83]},
        "3089": {"vr": "DS", "Value": [2.78]},
        "3090": {"vr": "DS", "Value": [536.8025]},
        "3091": {"vr": "DS", "Value": [367.24]},
        "3092": {"vr": "DS", "Value": [110.575]},
        "3093": {"vr": "DS", "Value": [169.5425]},
        "3094": {"vr": "DS", "Value": [461.1125]},
        "3095": {"vr": "DS", "Value": [457.895]},
        "3096": {"vr": "DS", "Value": [352.44]},
        "3097": {"vr": "DS", "Value": [308.1475]},
        "3098": {"vr": "DS", "Value": [257.6875]},
        "3099": {"vr": "DS", "Value": [201.21]},
        "3100": {"vr": "DS", "Value": [141.5325]},
        "3101": {"vr": "DS", "Value": [190.0675]},
        "3102": {"vr": "DS", "Value": [399.22]},
        "3103": {"vr": "DS", "Value": [389.6875]},
        "3104": {"vr": "DS", "Value": [370.625]},
        "3105": {"vr": "DS", "Value": [245.9425]},
        "3106": {"vr": "DS", "Value": [174.5175]},
        "3107": {"vr": "DS", "Value": [536.4875]},
        "3108": {"vr": "DS", "Value": [586.655]},
        "3109": {"vr": "DS", "Value": [564.5175]},
        "3110": {"vr": "DS", "Value": [235.0925]},
        "3111": {"vr": "DS", "Value": [190.3625]},
        "3112": {"vr": "DS", "Value": [192.2625]},
        "3113": {"vr": "DS", "Value": [444.245]},
        "3114": {"vr": "DS", "Value": [179.22]},
        "3115": {"vr": "DS", "Value": [20.9675]},
        "3116": {"vr": "DS", "Value": [114.4]},
        "3117": {"vr": "DS", "Value": [234.07]},
        "3118": {"vr": "DS", "Value": [235.97]},
        "3119": {"vr": "DS", "Value": [104.41]},
        "3120": {"vr": "DS", "Value": [566.42]},
        "3121": {"vr": "DS", "Value": [228.635]},
        "3122": {"vr": "DS", "Value": [81.5425]},
        "3123": {"vr": "DS", "Value": [483.395]},
        "3124": {"vr": "DS", "Value": [36.0775]},
        "3125": {"vr": "DS", "Value": [460.3825]},
        "3126": {"vr": "DS", "Value": [485.025]},
        "3127": {"vr": "DS", "Value": [420.04]},
        "3128": {"vr": "DS", "Value": [478.86]},
        "3129": {"vr": "DS", "Value": [60.555]},
        "3130": {"vr": "DS", "Value": [178.195]},
        "3131": {"vr": "DS", "Value": [211.64]},
        "3132": {"vr": "DS", "Value": [5.415]},
        "3133": {"vr": "DS", "Value": [428.84]},
        "3134": {"vr": "DS", "Value": [326.3325]},
        "3135": {"vr": "DS", "Value": [520.3725]},
        "3136": {"vr": "DS", "Value": [36.225]},
        "3137": {"vr": "DS", "Value": [547.21]},
        "3138": {"vr": "DS", "Value": [53.24]},
        "3139": {"vr": "DS", "Value": [33.2775]},
        "3140": {"vr": "DS", "Value": [334.6925]},
        "3141": {"vr": "DS", "Value": [180.83]},
        "3142": {"vr": "DS", "Value": [501.895]},
        "3143": {"vr": "DS", "Value": [85.9325]},
        "3144": {"vr": "DS", "Value": [135.3675]},
        "3145": {"vr": "DS", "Value": [26.5475]},
        "3146": {"vr": "DS", "Value": [315.61]},
        "3147": {"vr": "DS", "Value": [138.7325]},
        "3148": {"vr": "DS", "Value": [174.37]},
        "3149": {"vr": "DS", "Value": [409.045]},
        "3150": {"vr": "DS", "Value": [338.79]},
        "3151": {"vr": "DS", "Value": [117.7675]},
        "3152": {"vr": "DS", "Value": [355.22]},
        "3153": {"vr": "DS", "Value": [474.1575]},
        "3154": {"vr": "DS", "Value": [167.2]},
        "3155": {"vr": "DS", "Value": [561.865]},
        "3156": {"vr": "DS", "Value": [140.8]},
        "3157": {"vr": "DS", "Value": [465.795]},
        "3158": {"vr": "DS", "Value": [318.265]},
        "3159": {"vr": "DS", "Value": [172.4675]},
        "3160": {"vr": "DS", "Value": [7.3175]},
        "3161": {"vr": "DS", "Value": [298.1575]},
        "3162": {"vr": "DS", "Value": [278.3625]},
        "3163": {"vr": "DS", "Value": [67.3075]},
        "3164": {"vr": "DS", "Value": [152.675]},
        "3165": {"vr": "DS", "Value": [1.61]},
        "3166": {"vr": "DS", "Value": [98.1175]},
        "3167": {"vr": "DS", "Value": [90.05]},
        "3168": {"vr": "DS", "Value": [471.815]},
        "3169": {"vr": "DS", "Value": [298.8875]},
        "3170": {"vr": "DS", "Value": [580.4875]},
        "3171": {"vr": "DS", "Value": [319.5825]},
        "3172": {"vr": "DS", "Value": [595.6]},
        "3173": {"vr": "DS", "Value": [505.845]},
        "3174": {"vr": "DS", "Value": [193.2875]},
        "3175": {"vr": "DS", "Value": [297.2775]},
        "3176": {"vr": "DS", "Value": [588.85]},
        "3177": {"vr": "DS", "Value": [255.4925]},
        "3178": {"vr": "DS", "Value": [364.605]},
        "3179": {"vr": "DS", "Value": [241.99]},
        "3180": {"vr": "DS", "Value": [466.695]},
        "3181": {"vr": "DS", "Value": [476.81]},
        "3182": {"vr": "DS", "Value": [472.985]},
        "3183": {"vr": "DS", "Value": [173.4925]},
        "3184": {"vr": "DS", "Value": [101.4825]},
        "3185": {"vr": "DS", "Value": [478.1275]},
        "3186": {"vr": "DS", "Value": [432.3725]},
        "3187": {"vr": "DS", "Value": [257.1025]},
        "3188": {"vr": "DS", "Value": [161.7675]},
        "3189": {"vr": "DS", "Value": [162.645]},
        "3190": {"vr": "DS", "Value": [529.3175]},
        "3191": {"vr": "DS", "Value": [487.3675]},
        "3192": {"vr": "DS", "Value": [373.845]},
        "3193": {"vr": "DS", "Value": [302.7125]},
        "3194": {"vr": "DS", "Value": [7.61]},
        "3195": {"vr": "DS", "Value": [264.5875]},
        "3196": {"vr": "DS", "Value": [99.58]},
        "3197": {"vr": "DS", "Value": [466.4]},
        "3198": {"vr": "DS", "Value": [313.7075]},
        "3199": {"vr": "DS", "Value": [239.065]},
        "3200": {"vr": "DS", "Value": [24.3325]},
        "3201": {"vr": "DS", "Value": [463.6]},
        "3202": {"vr": "DS", "Value": [581.9725]},
        "3203": {"vr": "DS", "Value": [281.2875]},
        "3204": {"vr": "DS", "Value": [282.48]},
        "3205": {"vr": "DS", "Value": [578.2925]},
        "3206": {"vr": "DS", "Value": [93.855]},
        "3207": {"vr": "DS", "Value": [238.185]},
        "3208": {"vr": "DS", "Value": [257.835]},
        "3209": {"vr": "DS", "Value": [439.5425]},
        "3210": {"vr": "DS", "Value": [88.8775]},
        "3211": {"vr": "DS", "Value": [346.42]},
        "3212": {"vr": "DS", "Value": [294.4975]},
        "3213": {"vr": "DS", "Value": [486.05]},
        "3214": {"vr": "DS", "Value": [593.845]},
        "3215": {"vr": "DS", "Value": [534.585]},
        "3216": {"vr": "DS", "Value": [408.8975]},
        "3217": {"vr": "DS", "Value": [84.615]},
        "3218": {"vr": "DS", "Value": [4.39]},
        "3219": {"vr": "DS", "Value": [161.18]},
        "3220": {"vr": "DS", "Value": [311.3675]},
        "3221": {"vr": "DS", "Value": [129.9325]},
        "3222": {"vr": "DS", "Value": [523.7375]},
        "3223": {"vr": "DS", "Value": [233.4825]},
        "3224": {"vr": "DS", "Value": [21.845]},
        "3225": {"vr": "DS", "Value": [393.3475]},
        "3226": {"vr": "DS", "Value": [381.62]},
        "3227": {"vr": "DS", "Value": [160.595]},
        "3228": {"vr": "DS", "Value": [436.47]},
        "3229": {"vr": "DS", "Value": [80.0775]},
        "3230": {"vr": "DS", "Value": [207.23]},
        "3231": {"vr": "DS", "Value": [414.9175]},
        "3232": {"vr": "DS", "Value": [159.5725]},
        "3233": {"vr": "DS", "Value": [563.9325]},
        "3234": {"vr": "DS", "Value": [169.1025]},
        "3235": {"vr": "DS", "Value": [390.275]},
        "3236": {"vr": "DS", "Value": [230.41]},
        "3237": {"vr": "DS", "Value": [268.0975]},
        "3238": {"vr": "DS", "Value": [522.86]},
        "3239": {"vr": "DS", "Value": [476.9575]},
        "3240": {"vr": "DS", "Value": [586.5075]},
        "3241": {"vr": "DS", "Value": [442.9275]},
        "3242": {"vr": "DS", "Value": [155.455]},
        "3243": {"vr": "DS", "Value": [306.5175]},
        "3244": {"vr": "DS", "Value": [90.3425]},
        "3245": {"vr": "DS", "Value": [22.43]},
        "3246": {"vr": "DS", "Value": [515.085]},
        "3247": {"vr": "DS", "Value": [257.98]},
        "3248": {"vr": "DS", "Value": [386.1575]},
        "3249": {"vr": "DS", "Value": [228.05]},
        "3250": {"vr": "DS", "Value": [517.865]},
        "3251": {"vr": "DS", "Value": [350.9575]},
        "3252": {"vr": "DS", "Value": [345.25]},
        "3253": {"vr": "DS", "Value": [481.64]},
        "3254": {"vr": "DS", "Value": [501.7475]},
        "3255": {"vr": "DS", "Value": [588.5575]},
        "3256": {"vr": "DS", "Value": [402.1475]},
        "3257": {"vr": "DS", "Value": [473.1325]},
        "3258": {"vr": "DS", "Value": [304.47]},
        "3259": {"vr": "DS", "Value": [59.6775]},
        "3260": {"vr": "DS", "Value": [336.595]},
        "3261": {"vr": "DS", "Value": [251.23]},
        "3262": {"vr": "DS", "Value": [255.9325]},
        "3263": {"vr": "DS", "Value": [199.455]},
        "3264": {"vr": "DS", "Value": [306.665]},
        "3265": {"vr": "DS", "Value": [522.275]},
        "3266": {"vr": "DS", "Value": [543.385]},
        "3267": {"vr": "DS", "Value": [258.7125]},
        "3268": {"vr": "DS", "Value": [201.795]},
        "3269": {"vr": "DS", "Value": [440.7325]},
        "3270": {"vr": "DS", "Value": [591.3575]},
        "3271": {"vr": "DS", "Value": [166.45]},
        "3272": {"vr": "DS", "Value": [548.3825]},
        "3273": {"vr": "DS", "Value": [573.7575]},
        "3274": {"vr": "DS", "Value": [587.0925]},
        "3275": {"vr": "DS", "Value": [143.8725]},
        "3276": {"vr": "DS", "Value": [153.1125]},
        "3277": {"vr": "DS", "Value": [337.3275]},
        "3278": {"vr": "DS", "Value": [514.06]},
        "3279": {"vr": "DS", "Value": [515.23]},
        "3280": {"vr": "DS", "Value": [208.4]},
        "3281": {"vr": "DS", "Value": [160.3025]},
        "3282": {"vr": "DS", "Value": [199.8925]},
        "3283": {"vr": "DS", "Value": [95.755]},
        "3284": {"vr": "DS", "Value": [415.65]},
        "3285": {"vr": "DS", "Value": [344.81]},
        "3286": {"vr": "DS", "Value": [375.1625]},
        "3287": {"vr": "DS", "Value": [503.65]},
        "3288": {"vr": "DS", "Value": [173.2]},
        "3289": {"vr": "DS", "Value": [96.4875]},
        "3290": {"vr": "DS", "Value": [91.3675]},
        "3291": {"vr": "DS", "Value": [351.6875]},
        "3292": {"vr": "DS", "Value": [564.3725]},
        "3293": {"vr": "DS", "Value": [290.0875]},
        "3294": {"vr": "DS", "Value": [327.5025]},
        "3295": {"vr": "DS", "Value": [372.235]},
        "3296": {"vr": "DS", "Value": [156.77]},
        "3297": {"vr": "DS", "Value": [153.26]},
        "3298": {"vr": "DS", "Value": [229.385]},
        "3299": {"vr": "DS", "Value": [83.2975]},
        "3300": {"vr": "DS", "Value": [272.635]},
        "3301": {"vr": "DS", "Value": [285.5525]},
        "3302": {"vr": "DS", "Value": [371.9425]},
        "3303": {"vr": "DS", "Value": [584.7525]},
        "3304": {"vr": "DS", "Value": [130.81]},
        "3305": {"vr": "DS", "Value": [266.635]},
        "3306": {"vr": "DS", "Value": [552.7725]},
        "3307": {"vr": "DS", "Value": [61.2875]},
        "3308": {"vr": "DS", "Value": [185.68]},
        "3309": {"vr": "DS", "Value": [428.255]},
        "3310": {"vr": "DS", "Value": [54.7025]},
        "3311": {"vr": "DS", "Value": [217.055]},
        "3312": {"vr": "DS", "Value": [368.995]},
        "3313": {"vr": "DS", "Value": [19.065]},
        "3314": {"vr": "DS", "Value": [276.8975]},
        "3315": {"vr": "DS", "Value": [307.835]},
        "3316": {"vr": "DS", "Value": [140.635]},
        "3317": {"vr": "DS", "Value": [530.49]},
        "3318": {"vr": "DS", "Value": [319.1425]},
        "3319": {"vr": "DS", "Value": [482.81]},
        "3320": {"vr": "DS", "Value": [554.0875]},
        "3321": {"vr": "DS", "Value": [447.61]},
        "3322": {"vr": "DS", "Value": [384.255]},
        "3323": {"vr": "DS", "Value": [333.9425]},
        "3324": {"vr": "DS", "Value": [294.06]},
        "3325": {"vr": "DS", "Value": [135.22]},
        "3326": {"vr": "DS", "Value": [227.9025]},
        "3327": {"vr": "DS", "Value": [271.7575]},
        "3328": {"vr": "DS", "Value": [495.29]},
        "3329": {"vr": "DS", "Value": [179.5125]},
        "3330": {"vr": "DS", "Value": [51.755]},
        "3331": {"vr": "DS", "Value": [582.7025]},
        "3332": {"vr": "DS", "Value": [538.995]},
        "3333": {"vr": "DS", "Value": [183.7575]},
        "3334": {"vr": "DS", "Value": [354.4875]},
        "3335": {"vr": "DS", "Value": [284.0875]},
        "3336": {"vr": "DS", "Value": [100.46]},
        "3337": {"vr": "DS", "Value": [17.6]},
        "3338": {"vr": "DS", "Value": [123.9325]},
        "3339": {"vr": "DS", "Value": [363.7275]},
        "3340": {"vr": "DS", "Value": [272.8]},
        "3341": {"vr": "DS", "Value": [388.5175]},
        "3342": {"vr": "DS", "Value": [476.225]},
        "3343": {"vr": "DS", "Value": [303.445]},
        "3344": {"vr": "DS", "Value": [32.84]},
        "3345": {"vr": "DS", "Value": [367.0925]},
        "3346": {"vr": "DS", "Value": [521.1025]},
        "3347": {"vr": "DS", "Value": [206.06]},
        "3348": {"vr": "DS", "Value": [239.3575]},
        "3349": {"vr": "DS", "Value": [559.9625]},
        "3350": {"vr": "DS", "Value": [123.2]},
        "3351": {"vr": "DS", "Value": [80.81]},
        "3352": {"vr": "DS", "Value": [163.23]},
        "3353": {"vr": "DS", "Value": [504.9675]},
        "3354": {"vr": "DS", "Value": [241.405]},
        "3355": {"vr": "DS", "Value": [294.645]},
        "3356": {"vr": "DS", "Value": [321.775]},
        "3357": {"vr": "DS", "Value": [40.76]},
        "3358": {"vr": "DS", "Value": [182.0]},
        "3359": {"vr": "DS", "Value": [533.1225]},
        "3360": {"vr": "DS", "Value": [513.1825]},
        "3361": {"vr": "DS", "Value": [231.1425]},
        "3362": {"vr": "DS", "Value": [264.7325]},
        "3363": {"vr": "DS", "Value": [518.7425]},
        "3364": {"vr": "DS", "Value": [463.455]},
        "3365": {"vr": "DS", "Value": [594.7225]},
        "3366": {"vr": "DS", "Value": [557.475]},
        "3367": {"vr": "DS", "Value": [522.42]},
        "3368": {"vr": "DS", "Value": [130.225]},
        "3369": {"vr": "DS", "Value": [452.3125]},
        "3370": {"vr": "DS", "Value": [406.1175]},
        "3371": {"vr": "DS", "Value": [260.47]},
        "3372": {"vr": "DS", "Value": [459.3575]},
        "3373": {"vr": "DS", "Value": [427.9625]},
        "3374": {"vr": "DS", "Value": [344.5175]},
        "3375": {"vr": "DS", "Value": [447.1725]},
        "3376": {"vr": "DS", "Value": [206.645]},
        "3377": {"vr": "DS", "Value": [468.7425]},
        "3378": {"vr": "DS", "Value": [237.2875]},
        "3379": {"vr": "DS", "Value": [309.7575]},
        "3380": {"vr": "DS", "Value": [160.45]},
        "3381": {"vr": "DS", "Value": [433.835]},
        "3382": {"vr": "DS", "Value": [303.2975]},
        "3383": {"vr": "DS", "Value": [68.4775]},
        "3384": {"vr": "DS", "Value": [300.9575]},
        "3385": {"vr": "DS", "Value": [186.85]},
        "3386": {"vr": "DS", "Value": [427.67]},
        "3387": {"vr": "DS", "Value": [582.5575]},
        "3388": {"vr": "DS", "Value": [289.21]},
        "3389": {"vr": "DS", "Value": [493.9725]},
        "3390": {"vr": "DS", "Value": [506.87]},
        "3391": {"vr": "DS", "Value": [195.21]},
        "3392": {"vr": "DS", "Value": [172.7625]},
        "3393": {"vr": "DS", "Value": [298.3025]},
        "3394": {"vr": "DS", "Value": [53.6775]},
        "3395": {"vr": "DS", "Value": [427.815]},
        "3396": {"vr": "DS", "Value": [127.2975]},
        "3397": {"vr": "DS", "Value": [186.995]},
        "3398": {"vr": "DS", "Value": [97.0925]},
        "3399": {"vr": "DS", "Value": [442.3425]},
        "3400": {"vr": "DS", "Value": [322.655]},
        "3401": {"vr": "DS", "Value": [289.5025]},
        "3402": {"vr": "DS", "Value": [374.1375]},
        "3403": {"vr": "DS", "Value": [231.875]},
        "3404": {"vr": "DS", "Value": [170.1275]},
        "3405": {"vr": "DS", "Value": [304.03]},
        "3406": {"vr": "DS", "Value": [463.1625]},
        "3407": {"vr": "DS", "Value": [130.0775]},
        "3408": {"vr": "DS", "Value": [85.4925]},
        "3409": {"vr": "DS", "Value": [417.99]},
        "3410": {"vr": "DS", "Value": [366.5075]},
        "3411": {"vr": "DS", "Value": [435.005]},
        "3412": {"vr": "DS", "Value": [541.19]},
        "3413": {"vr": "DS", "Value": [556.01]},
        "3414": {"vr": "DS", "Value": [475.9325]},
        "3415": {"vr": "DS", "Value": [504.09]},
        "3416": {"vr": "DS", "Value": [269.27]},
        "3417": {"vr": "DS", "Value": [382.3525]},
        "3418": {"vr": "DS", "Value": [33.57]},
        "3419": {"vr": "DS", "Value": [515.9625]},
        "3420": {"vr": "DS", "Value": [156.625]},
        "3421": {"vr": "DS", "Value": [92.39]},
        "3422": {"vr": "DS", "Value": [531.075]},
        "3423": {"vr": "DS", "Value": [555.28]},
        "3424": {"vr": "DS", "Value": [315.9025]},
        "3425": {"vr": "DS", "Value": [293.7675]},
        "3426": {"vr": "DS", "Value": [515.3775]},
        "3427": {"vr": "DS", "Value": [373.5525]},
        "3428": {"vr": "DS", "Value": [267.805]},
        "3429": {"vr": "DS", "Value": [275.875]},
        "3430": {"vr": "DS", "Value": [365.4825]},
        "3431": {"vr": "DS", "Value": [496.1675]},
        "3432": {"vr": "DS", "Value": [79.2]},
        "3433": {"vr": "DS", "Value": [76.255]},
        "3434": {"vr": "DS", "Value": [449.095]},
        "3435": {"vr": "DS", "Value": [417.405]},
        "3436": {"vr": "DS", "Value": [497.9225]},
        "3437": {"vr": "DS", "Value": [520.5175]},
        "3438": {"vr": "DS", "Value": [191.97]},
        "3439": {"vr": "DS", "Value": [392.3225]},
        "3440": {"vr": "DS", "Value": [459.21]},
        "3441": {"vr": "DS", "Value": [488.685]},
        "3442": {"vr": "DS", "Value": [416.675]},
        "3443": {"vr": "DS", "Value": [521.835]},
        "3444": {"vr": "DS", "Value": [312.83]},
        "3445": {"vr": "DS", "Value": [30.4975]},
        "3446": {"vr": "DS", "Value": [2.3425]},
        "3447": {"vr": "DS", "Value": [550.1375]},
        "3448": {"vr": "DS", "Value": [277.3375]},
        "3449": {"vr": "DS", "Value": [240.235]},
        "3450": {"vr": "DS", "Value": [462.1375]},
        "3451": {"vr": "DS", "Value": [328.0875]},
        "3452": {"vr": "DS", "Value": [218.225]},
        "3453": {"vr": "DS", "Value": [248.01]},
        "3454": {"vr": "DS", "Value": [204.1575]},
        "3455": {"vr": "DS", "Value": [82.42]},
        "3456": {"vr": "DS", "Value": [268.245]},
        "3457": {"vr": "DS", "Value": [453.19]},
        "3458": {"vr": "DS", "Value": [364.46]},
        "3459": {"vr": "DS", "Value": [539.435]},
        "3460": {"vr": "DS", "Value": [355.805]},
        "3461": {"vr": "DS", "Value": [90.78]},
        "3462": {"vr": "DS", "Value": [182.585]},
        "3463": {"vr": "DS", "Value": [382.06]},
        "3464": {"vr": "DS", "Value": [572.7325]},
        "3465": {"vr": "DS", "Value": [385.865]},
        "3466": {"vr": "DS", "Value": [226.44]},
        "3467": {"vr": "DS", "Value": [514.3525]},
        "3468": {"vr": "DS", "Value": [196.82]},
        "3469": {"vr": "DS", "Value": [139.025]},
        "3470": {"vr": "DS", "Value": [376.185]},
        "3471": {"vr": "DS", "Value": [362.85]},
        "3472": {"vr": "DS", "Value": [524.7625]},
        "3473": {"vr": "DS", "Value": [62.04]},
        "3474": {"vr": "DS", "Value": [112.77]},
        "3475": {"vr": "DS", "Value": [264.2925]},
        "3476": {"vr": "DS", "Value": [45.025]},
        "3477": {"vr": "DS", "Value": [21.6975]},
        "3478": {"vr": "DS", "Value": [527.6875]},
        "3479": {"vr": "DS", "Value": [358.0]},
        "3480": {"vr": "DS", "Value": [129.4925]},
        "3481": {"vr": "DS", "Value": [591.9425]},
        "3482": {"vr": "DS", "Value": [470.9375]},
        "3483": {"vr": "DS", "Value": [525.9325]},
        "3484": {"vr": "DS", "Value": [532.685]},
        "3485": {"vr": "DS", "Value": [381.475]},
        "3486": {"vr": "DS", "Value": [462.43]},
        "3487": {"vr": "DS", "Value": [585.63]},
        "3488": {"vr": "DS", "Value": [42.37]},
        "3489": {"vr": "DS", "Value": [441.61]},
        "3490": {"vr": "DS", "Value": [56.46]},
        "3491": {"vr": "DS", "Value": [512.595]},
        "3492": {"vr": "DS", "Value": [207.375]},
        "3493": {"vr": "DS", "Value": [558.9375]},
        "3494": {"vr": "DS", "Value": [347.2975]},
        "3495": {"vr": "DS", "Value": [446.1475]},
        "3496": {"vr": "DS", "Value": [254.1575]},
        "3497": {"vr": "DS", "Value": [380.45]},
        "3498": {"vr": "DS", "Value": [497.3375]},
        "3499": {"vr": "DS", "Value": [244.9175]},
        "3500": {"vr": "DS", "Value": [479.7375]},
        "3501": {"vr": "DS", "Value": [307.395]},
        "3502": {"vr": "DS", "Value": [308.2925]},
        "3503": {"vr": "DS", "Value": [495.7275]},
        "3504": {"vr": "DS", "Value": [40.9075]},
        "3505": {"vr": "DS", "Value": [179.075]},
        "3506": {"vr": "DS", "Value": [228.9475]},
        "3507": {"vr": "DS", "Value": [339.67]},
        "3508": {"vr": "DS", "Value": [472.6925]},
        "3509": {"vr": "DS", "Value": [411.5325]},
        "3510": {"vr": "DS", "Value": [310.7825]},
        "3511": {"vr": "DS", "Value": [3.66]},
        "3512": {"vr": "DS", "Value": [261.055]},
        "3513": {"vr": "DS", "Value": [353.3175]},
        "3514": {"vr": "DS", "Value": [531.66]},
        "3515": {"vr": "DS", "Value": [316.3425]},
        "3516": {"vr": "DS", "Value": [25.65]},
        "3517": {"vr": "DS", "Value": [550.7225]},
        "3518": {"vr": "DS", "Value": [146.655]},
        "3519": {"vr": "DS", "Value": [318.7025]},
        "3520": {"vr": "DS", "Value": [427.0825]},
        "3521": {"vr": "DS", "Value": [592.9675]},
        "3522": {"vr": "DS", "Value": [0.0]},
        "3523": {"vr": "DS", "Value": [578.1475]},
        "3524": {"vr": "DS", "Value": [392.47]},
        "3525": {"vr": "DS", "Value": [292.3025]},
        "3526": {"vr": "DS", "Value": [214.7125]},
        "3527": {"vr": "DS", "Value": [555.7175]},
        "3528": {"vr": "DS", "Value": [172.175]},
        "3529": {"vr": "DS", "Value": [591.65]},
        "3530": {"vr": "DS", "Value": [189.4825]},
        "3531": {"vr": "DS", "Value": [94.0]},
        "3532": {"vr": "DS", "Value": [202.84]},
        "3533": {"vr": "DS", "Value": [200.77]},
        "3534": {"vr": "DS", "Value": [533.855]},
        "3535": {"vr": "DS", "Value": [430.8875]},
        "3536": {"vr": "DS", "Value": [131.1025]},
        "3537": {"vr": "DS", "Value": [70.84]},
        "3538": {"vr": "DS", "Value": [420.625]},
        "3539": {"vr": "DS", "Value": [596.48]},
        "3540": {"vr": "DS", "Value": [343.4925]},
        "3541": {"vr": "DS", "Value": [422.5475]},
        "3542": {"vr": "DS", "Value": [170.7125]},
        "3543": {"vr": "DS", "Value": [245.3575]},
        "3544": {"vr": "DS", "Value": [274.265]},
        "3545": {"vr": "DS", "Value": [224.5375]},
        "3546": {"vr": "DS", "Value": [295.5225]},
        "3547": {"vr": "DS", "Value": [213.835]},
        "3548": {"vr": "DS", "Value": [360.05]},
        "3549": {"vr": "DS", "Value": [70.6925]},
        "3550": {"vr": "DS", "Value": [392.03]},
        "3551": {"vr": "DS", "Value": [73.035]},
        "3552": {"vr": "DS", "Value": [544.1175]},
        "3553": {"vr": "DS", "Value": [276.3125]},
        "3554": {"vr": "DS", "Value": [213.1025]},
        "3555": {"vr": "DS", "Value": [270.44]},
        "3556": {"vr": "DS", "Value": [189.19]},
        "3557": {"vr": "DS", "Value": [152.82]},
        "3558": {"vr": "DS", "Value": [68.9175]},
        "3559": {"vr": "DS", "Value": [334.4]},
        "3560": {"vr": "DS", "Value": [264.44]},
        "3561": {"vr": "DS", "Value": [454.215]},
        "3562": {"vr": "DS", "Value": [242.575]},
        "3563": {"vr": "DS", "Value": [434.86]},
        "3564": {"vr": "DS", "Value": [250.3525]},
        "3565": {"vr": "DS", "Value": [492.195]},
        "3566": {"vr": "DS", "Value": [335.425]},
        "3567": {"vr": "DS", "Value": [67.455]},
        "3568": {"vr": "DS", "Value": [27.7175]},
        "3569": {"vr": "DS", "Value": [127.8825]},
        "3570": {"vr": "DS", "Value": [199.7475]},
        "3571": {"vr": "DS", "Value": [52.4875]},
        "3572": {"vr": "DS", "Value": [334.5475]},
        "3573": {"vr": "DS", "Value": [44.585]},
        "3574": {"vr": "DS", "Value": [79.9325]},
        "3575": {"vr": "DS", "Value": [112.9175]},
        "3576": {"vr": "DS", "Value": [393.9325]},
        "3577": {"vr": "DS", "Value": [275.435]},
        "3578": {"vr": "DS", "Value": [101.19]},
        "3579": {"vr": "DS", "Value": [293.3275]},
        "3580": {"vr": "DS", "Value": [559.67]},
        "3581": {"vr": "DS", "Value": [480.7625]},
        "3582": {"vr": "DS", "Value": [317.9725]},
        "3583": {"vr": "DS", "Value": [582.85]},
        "3584": {"vr": "DS", "Value": [121.1325]},
        "3585": {"vr": "DS", "Value": [334.235]},
        "3586": {"vr": "DS", "Value": [528.7325]},
        "3587": {"vr": "DS", "Value": [522.5675]},
        "3588": {"vr": "DS", "Value": [238.48]},
        "3589": {"vr": "DS", "Value": [496.3125]},
        "3590": {"vr": "DS", "Value": [218.5175]},
        "3591": {"vr": "DS", "Value": [473.425]},
        "3592": {"vr": "DS", "Value": [244.3325]},
        "3593": {"vr": "DS", "Value": [486.7825]},
        "3594": {"vr": "DS", "Value": [458.9175]},
        "3595": {"vr": "DS", "Value": [141.24]},
        "3596": {"vr": "DS", "Value": [205.9125]},
        "3597": {"vr": "DS", "Value": [150.625]},
        "3598": {"vr": "DS", "Value": [207.9625]},
        "3599": {"vr": "DS", "Value": [38.5675]},
        "3600": {"vr": "DS", "Value": [387.64]},
        "3601": {"vr": "DS", "Value": [448.635]},
        "3602": {"vr": "DS", "Value": [276.605]},
        "3603": {"vr": "DS", "Value": [192.995]},
        "3604": {"vr": "DS", "Value": [244.77]},
        "3605": {"vr": "DS", "Value": [262.225]},
        "3606": {"vr": "DS", "Value": [329.99]},
        "3607": {"vr": "DS", "Value": [572.1475]},
        "3608": {"vr": "DS", "Value": [149.1425]},
        "3609": {"vr": "DS", "Value": [532.0975]},
        "3610": {"vr": "DS", "Value": [493.825]},
        "3611": {"vr": "DS", "Value": [59.24]},
        "3612": {"vr": "DS", "Value": [310.635]},
        "3613": {"vr": "DS", "Value": [454.5075]},
        "3614": {"vr": "DS", "Value": [492.9475]},
        "3615": {"vr": "DS", "Value": [77.7175]},
        "3616": {"vr": "DS", "Value": [273.825]},
        "3617": {"vr": "DS", "Value": [115.425]},
        "3618": {"vr": "DS", "Value": [75.815]},
        "3619": {"vr": "DS", "Value": [28.1575]},
        "3620": {"vr": "DS", "Value": [181.7075]},
        "3621": {"vr": "DS", "Value": [214.1275]},
        "3622": {"vr": "DS", "Value": [58.9475]},
        "3623": {"vr": "DS", "Value": [103.385]},
        "3624": {"vr": "DS", "Value": [580.9475]},
        "3625": {"vr": "DS", "Value": [575.075]},
        "3626": {"vr": "DS", "Value": [259.7375]},
        "3627": {"vr": "DS", "Value": [520.81]},
        "3628": {"vr": "DS", "Value": [404.05]},
        "3629": {"vr": "DS", "Value": [49.415]},
        "3630": {"vr": "DS", "Value": [526.3725]},
        "3631": {"vr": "DS", "Value": [545.2875]},
        "3632": {"vr": "DS", "Value": [151.21]},
        "3633": {"vr": "DS", "Value": [431.9325]},
        "3634": {"vr": "DS", "Value": [530.9275]},
        "3635": {"vr": "DS", "Value": [251.9625]},
        "3636": {"vr": "DS", "Value": [579.3175]},
        "3637": {"vr": "DS", "Value": [47.3675]},
        "3638": {"vr": "DS", "Value": [108.5275]},
        "3639": {"vr": "DS", "Value": [568.615]},
        "3640": {"vr": "DS", "Value": [301.25]},
        "3641": {"vr": "DS", "Value": [221.3175]},
        "3642": {"vr": "DS", "Value": [567.2975]},
        "3643": {"vr": "DS", "Value": [277.19]},
        "3644": {"vr": "DS", "Value": [366.9475]},
        "3645": {"vr": "DS", "Value": [84.9075]},
        "3646": {"vr": "DS", "Value": [127.59]},
        "3647": {"vr": "DS", "Value": [457.1425]},
        "3648": {"vr": "DS", "Value": [435.8825]},
        "3649": {"vr": "DS", "Value": [312.975]},
        "3650": {"vr": "DS", "Value": [231.2875]},
        "3651": {"vr": "DS", "Value": [179.805]},
        "3652": {"vr": "DS", "Value": [321.4825]},
        "3653": {"vr": "DS", "Value": [500.1175]},
        "3654": {"vr": "DS", "Value": [303.59]},
        "3655": {"vr": "DS", "Value": [115.5725]},
        "3656": {"vr": "DS", "Value": [405.5325]},
        "3657": {"vr": "DS", "Value": [545.1425]},
        "3658": {"vr": "DS", "Value": [61.1425]},
        "3659": {"vr": "DS", "Value": [547.065]},
        "3660": {"vr": "DS", "Value": [88.1475]},
        "3661": {"vr": "DS", "Value": [149.6]},
        "3662": {"vr": "DS", "Value": [513.035]},
        "3663": {"vr": "DS", "Value": [516.1075]},
        "3664": {"vr": "DS", "Value": [85.3475]},
        "3665": {"vr": "DS", "Value": [149.2875]},
        "3666": {"vr": "DS", "Value": [440.0]},
        "3667": {"vr": "DS", "Value": [262.0775]},
        "3668": {"vr": "DS", "Value": [110.2825]},
        "3669": {"vr": "DS", "Value": [176.44]},
        "3670": {"vr": "DS", "Value": [171.445]},
        "3671": {"vr": "DS", "Value": [280.1175]},
        "3672": {"vr": "DS", "Value": [47.22]},
        "3673": {"vr": "DS", "Value": [596.9175]},
        "3674": {"vr": "DS", "Value": [77.2775]},
        "3675": {"vr": "DS", "Value": [233.775]},
        "3676": {"vr": "DS", "Value": [438.5175]},
        "3677": {"vr": "DS", "Value": [68.04]},
        "3678": {"vr": "DS", "Value": [434.1275]},
        "3679": {"vr": "DS", "Value": [437.9325]},
        "3680": {"vr": "DS", "Value": [387.9325]},
        "3681": {"vr": "DS", "Value": [114.84]},
        "3682": {"vr": "DS", "Value": [180.0975]},
        "3683": {"vr": "DS", "Value": [282.625]},
        "3684": {"vr": "DS", "Value": [84.7625]},
        "3685": {"vr": "DS", "Value": [423.425]},
        "3686": {"vr": "DS", "Value": [218.6625]},
        "3687": {"vr": "DS", "Value": [399.66]},
        "3688": {"vr": "DS", "Value": [356.245]},
        "3689": {"vr": "DS", "Value": [450.85]},
        "3690": {"vr": "DS", "Value": [37.395]},
        "3691": {"vr": "DS", "Value": [216.7625]},
        "3692": {"vr": "DS", "Value": [63.65]},
        "3693": {"vr": "DS", "Value": [332.77]},
        "3694": {"vr": "DS", "Value": [551.455]},
        "3695": {"vr": "DS", "Value": [71.425]},
        "3696": {"vr": "DS", "Value": [300.08]},
        "3697": {"vr": "DS", "Value": [242.2825]},
        "3698": {"vr": "DS", "Value": [107.3575]},
        "3699": {"vr": "DS", "Value": [186.7025]},
        "3700": {"vr": "DS", "Value": [575.9525]},
        "3701": {"vr": "DS", "Value": [94.44]},
        "3702": {"vr": "DS", "Value": [155.8925]},
        "3703": {"vr": "DS", "Value": [564.08]},
        "3704": {"vr": "DS", "Value": [408.46]},
        "3705": {"vr": "DS", "Value": [63.21]},
        "3706": {"vr": "DS", "Value": [345.835]},
        "3707": {"vr": "DS", "Value": [124.3725]},
        "3708": {"vr": "DS", "Value": [436.615]},
        "3709": {"vr": "DS", "Value": [194.3325]},
        "3710": {"vr": "DS", "Value": [456.5575]},
        "3711": {"vr": "DS", "Value": [503.065]},
        "3712": {"vr": "DS", "Value": [235.825]},
        "3713": {"vr": "DS", "Value": [26.235]},
        "3714": {"vr": "DS", "Value": [565.9825]},
        "3715": {"vr": "DS", "Value": [341.865]},
        "3716": {"vr": "DS", "Value": [399.9525]},
        "3717": {"vr": "DS", "Value": [549.405]},
        "3718": {"vr": "DS", "Value": [517.425]},
        "3719": {"vr": "DS", "Value": [58.8]},
        "3720": {"vr": "DS", "Value": [465.65]},
        "3721": {"vr": "DS", "Value": [285.845]},
        "3722": {"vr": "DS", "Value": [240.5275]},
        "3723": {"vr": "DS", "Value": [206.3525]},
        "3724": {"vr": "DS", "Value": [137.1225]},
        "3725": {"vr": "DS", "Value": [98.41]},
        "3726": {"vr": "DS", "Value": [430.595]},
        "3727": {"vr": "DS", "Value": [344.3725]},
        "3728": {"vr": "DS", "Value": [411.6775]},
        "3729": {"vr": "DS", "Value": [494.5575]},
        "3730": {"vr": "DS", "Value": [72.595]},
        "3731": {"vr": "DS", "Value": [374.5775]},
        "3732": {"vr": "DS", "Value": [126.5675]},
        "3733": {"vr": "DS", "Value": [34.01]},
        "3734": {"vr": "DS", "Value": [550.43]},
        "3735": {"vr": "DS", "Value": [501.2875]},
        "3736": {"vr": "DS", "Value": [537.825]},
        "3737": {"vr": "DS", "Value": [227.61]},
        "3738": {"vr": "DS", "Value": [570.9575]},
        "3739": {"vr": "DS", "Value": [341.7175]},
        "3740": {"vr": "DS", "Value": [184.8]},
        "3741": {"vr": "DS", "Value": [381.9125]},
        "3742": {"vr": "DS", "Value": [299.9325]},
        "3743": {"vr": "DS", "Value": [451.7275]},
        "3744": {"vr": "DS", "Value": [6.2925]},
        "3745": {"vr": "DS", "Value": [30.06]},
        "3746": {"vr": "DS", "Value": [174.0775]},
        "3747": {"vr": "DS", "Value": [539.29]},
        "3748": {"vr": "DS", "Value": [523.445]},
        "3749": {"vr": "DS", "Value": [197.26]},
        "3750": {"vr": "DS", "Value": [223.075]},
        "3751": {"vr": "DS", "Value": [181.1225]},
        "3752": {"vr": "DS", "Value": [183.61]},
        "3753": {"vr": "DS", "Value": [271.17]},
        "3754": {"vr": "DS", "Value": [292.595]},
        "3755": {"vr": "DS", "Value": [315.025]},
        "3756": {"vr": "DS", "Value": [397.025]},
        "3757": {"vr": "DS", "Value": [87.835]},
        "3758": {"vr": "DS", "Value": [505.1125]},
        "3759": {"vr": "DS", "Value": [265.465]},
        "3760": {"vr": "DS", "Value": [95.17]},
        "3761": {"vr": "DS", "Value": [254.01]},
        "3762": {"vr": "DS", "Value": [52.195]},
        "3763": {"vr": "DS", "Value": [402.8775]},
        "3764": {"vr": "DS", "Value": [353.025]},
        "3765": {"vr": "DS", "Value": [583.875]},
        "3766": {"vr": "DS", "Value": [285.1125]},
        "3767": {"vr": "DS", "Value": [383.0825]},
        "3768": {"vr": "DS", "Value": [506.285]},
        "3769": {"vr": "DS", "Value": [104.85]},
        "3770": {"vr": "DS", "Value": [150.9175]},
        "3771": {"vr": "DS", "Value": [569.4925]},
        "3772": {"vr": "DS", "Value": [310.4875]},
        "3773": {"vr": "DS", "Value": [489.7075]},
        "3774": {"vr": "DS", "Value": [262.37]},
        "3775": {"vr": "DS", "Value": [366.8]},
        "3776": {"vr": "DS", "Value": [25.355]},
        "3777": {"vr": "DS", "Value": [311.805]},
        "3778": {"vr": "DS", "Value": [55.1425]},
        "3779": {"vr": "DS", "Value": [212.225]},
        "3780": {"vr": "DS", "Value": [52.8]},
        "3781": {"vr": "DS", "Value": [516.4]},
        "3782": {"vr": "DS", "Value": [92.0975]},
        "3783": {"vr": "DS", "Value": [101.9225]},
        "3784": {"vr": "DS", "Value": [579.7575]},
        "3785": {"vr": "DS", "Value": [105.435]},
        "3786": {"vr": "DS", "Value": [316.05]},
        "3787": {"vr": "DS", "Value": [23.455]},
        "3788": {"vr": "DS", "Value": [109.845]},
        "3789": {"vr": "DS", "Value": [479.2975]},
        "3790": {"vr": "DS", "Value": [117.035]},
        "3791": {"vr": "DS", "Value": [82.5675]},
        "3792": {"vr": "DS", "Value": [154.1375]},
        "3793": {"vr": "DS", "Value": [275.7275]},
        "3794": {"vr": "DS", "Value": [26.0875]},
        "3795": {"vr": "DS", "Value": [400.245]},
        "3796": {"vr": "DS", "Value": [561.7175]},
        "3797": {"vr": "DS", "Value": [163.0825]},
        "3798": {"vr": "DS", "Value": [393.64]},
        "3799": {"vr": "DS", "Value": [156.4775]},
        "3800": {"vr": "DS", "Value": [551.015]},
        "3801": {"vr": "DS", "Value": [276.02]},
        "3802": {"vr": "DS", "Value": [533.27]},
        "3803": {"vr": "DS", "Value": [98.5575]},
        "3804": {"vr": "DS", "Value": [385.425]},
        "3805": {"vr": "DS", "Value": [400.0975]},
        "3806": {"vr": "DS", "Value": [404.4875]},
        "3807": {"vr": "DS", "Value": [475.035]},
        "3808": {"vr": "DS", "Value": [555.865]},
        "3809": {"vr": "DS", "Value": [118.9375]},
        "3810": {"vr": "DS", "Value": [507.7475]},
        "3811": {"vr": "DS", "Value": [446.2925]},
        "3812": {"vr": "DS", "Value": [582.41]},
        "3813": {"vr": "DS", "Value": [429.5725]},
        "3814": {"vr": "DS", "Value": [228.195]},
        "3815": {"vr": "DS", "Value": [367.5325]},
        "3816": {"vr": "DS", "Value": [416.0875]},
        "3817": {"vr": "DS", "Value": [409.4825]},
        "3818": {"vr": "DS", "Value": [102.5075]},
        "3819": {"vr": "DS", "Value": [198.7225]},
        "3820": {"vr": "DS", "Value": [388.665]},
        "3821": {"vr": "DS", "Value": [347.445]},
        "3822": {"vr": "DS", "Value": [559.3775]},
        "3823": {"vr": "DS", "Value": [425.3275]},
        "3824": {"vr": "DS", "Value": [586.8]},
        "3825": {"vr": "DS", "Value": [203.865]},
        "3826": {"vr": "DS", "Value": [45.3175]},
        "3827": {"vr": "DS", "Value": [325.6]},
        "3828": {"vr": "DS", "Value": [194.48]},
        "3829": {"vr": "DS", "Value": [486.9275]},
        "3830": {"vr": "DS", "Value": [243.3075]},
        "3831": {"vr": "DS", "Value": [352.88]},
        "3832": {"vr": "DS", "Value": [306.0775]},
        "3833": {"vr": "DS", "Value": [274.995]},
        "3834": {"vr": "DS", "Value": [59.825]},
        "3835": {"vr": "DS", "Value": [535.3175]},
        "3836": {"vr": "DS", "Value": [439.6875]},
        "3837": {"vr": "DS", "Value": [142.995]},
        "3838": {"vr": "DS", "Value": [18.04]},
        "3839": {"vr": "DS", "Value": [18.4775]},
        "3840": {"vr": "DS", "Value": [476.3725]},
        "3841": {"vr": "DS", "Value": [119.5225]},
        "3842": {"vr": "DS", "Value": [52.9475]},
        "3843": {"vr": "DS", "Value": [362.265]},
        "3844": {"vr": "DS", "Value": [119.0825]},
        "3845": {"vr": "DS", "Value": [205.3275]},
        "3846": {"vr": "DS", "Value": [423.28]},
        "3847": {"vr": "DS", "Value": [386.595]},
        "3848": {"vr": "DS", "Value": [389.5425]},
        "3849": {"vr": "DS", "Value": [552.48]},
        "3850": {"vr": "DS", "Value": [316.635]},
        "3851": {"vr": "DS", "Value": [421.5025]},
        "3852": {"vr": "DS", "Value": [131.5425]},
        "3853": {"vr": "DS", "Value": [52.05]},
        "3854": {"vr": "DS", "Value": [219.835]},
        "3855": {"vr": "DS", "Value": [592.82]},
        "3856": {"vr": "DS", "Value": [32.255]},
        "3857": {"vr": "DS", "Value": [126.7125]},
        "3858": {"vr": "DS", "Value": [30.3525]},
        "3859": {"vr": "DS", "Value": [328.82]},
        "3860": {"vr": "DS", "Value": [142.85]},
        "3861": {"vr": "DS", "Value": [288.4775]},
        "3862": {"vr": "DS", "Value": [162.4975]},
        "3863": {"vr": "DS", "Value": [493.24]},
        "3864": {"vr": "DS", "Value": [232.02]},
        "3865": {"vr": "DS", "Value": [367.385]},
        "3866": {"vr": "DS", "Value": [269.1225]},
        "3867": {"vr": "DS", "Value": [67.8925]},
        "3868": {"vr": "DS", "Value": [116.8875]},
        "3869": {"vr": "DS", "Value": [453.9225]},
        "3870": {"vr": "DS", "Value": [572.44]},
        "3871": {"vr": "DS", "Value": [512.45]},
        "3872": {"vr": "DS", "Value": [66.575]},
        "3873": {"vr": "DS", "Value": [475.7875]},
        "3874": {"vr": "DS", "Value": [395.5425]},
        "3875": {"vr": "DS", "Value": [543.24]},
        "3876": {"vr": "DS", "Value": [159.28]},
        "3877": {"vr": "DS", "Value": [536.3425]},
        "3878": {"vr": "DS", "Value": [498.07]},
        "3879": {"vr": "DS", "Value": [143.2875]},
        "3880": {"vr": "DS", "Value": [418.1375]},
        "3881": {"vr": "DS", "Value": [236.85]},
        "3882": {"vr": "DS", "Value": [404.635]},
        "3883": {"vr": "DS", "Value": [265.1725]},
        "3884": {"vr": "DS", "Value": [308.44]},
        "3885": {"vr": "DS", "Value": [108.9675]},
        "3886": {"vr": "DS", "Value": [488.39]},
        "3887": {"vr": "DS", "Value": [323.6775]},
        "3888": {"vr": "DS", "Value": [183.4625]},
        "3889": {"vr": "DS", "Value": [40.175]},
        "3890": {"vr": "DS", "Value": [259.1525]},
        "3891": {"vr": "DS", "Value": [368.5575]},
        "3892": {"vr": "DS", "Value": [554.84]},
        "3893": {"vr": "DS", "Value": [408.7525]},
        "3894": {"vr": "DS", "Value": [49.855]},
        "3895": {"vr": "DS", "Value": [151.3575]},
        "3896": {"vr": "DS", "Value": [560.5475]},
        "3897": {"vr": "DS", "Value": [519.495]},
        "3898": {"vr": "DS", "Value": [360.9475]},
        "3899": {"vr": "DS", "Value": [423.7175]},
        "3900": {"vr": "DS", "Value": [108.0875]},
        "3901": {"vr": "DS", "Value": [469.9125]},
        "3902": {"vr": "DS", "Value": [324.85]},
        "3903": {"vr": "DS", "Value": [445.7075]},
        "3904": {"vr": "DS", "Value": [288.3325]},
        "3905": {"vr": "DS", "Value": [573.61]},
        "3906": {"vr": "DS", "Value": [335.1325]},
        "3907": {"vr": "DS", "Value": [524.3225]},
        "3908": {"vr": "DS", "Value": [183.3175]},
        "3909": {"vr": "DS", "Value": [100.02]},
        "3910": {"vr": "DS", "Value": [50.44]},
        "3911": {"vr": "DS", "Value": [223.805]},
        "3912": {"vr": "DS", "Value": [545.6025]},
        "3913": {"vr": "DS", "Value": [261.64]},
        "3914": {"vr": "DS", "Value": [350.225]},
        "3915": {"vr": "DS", "Value": [27.5725]},
        "3916": {"vr": "DS", "Value": [206.205]},
        "3917": {"vr": "DS", "Value": [66.43]},
        "3918": {"vr": "DS", "Value": [291.425]},
        "3919": {"vr": "DS", "Value": [251.5225]},
        "3920": {"vr": "DS", "Value": [170.42]},
        "3921": {"vr": "DS", "Value": [503.795]},
        "3922": {"vr": "DS", "Value": [563.495]},
        "3923": {"vr": "DS", "Value": [91.805]},
        "3924": {"vr": "DS", "Value": [28.3025]},
        "3925": {"vr": "DS", "Value": [175.1025]},
        "3926": {"vr": "DS", "Value": [431.035]},
        "3927": {"vr": "DS", "Value": [443.075]},
        "3928": {"vr": "DS", "Value": [304.615]},
        "3929": {"vr": "DS", "Value": [487.22]},
        "3930": {"vr": "DS", "Value": [452.1675]},
        "3931": {"vr": "DS", "Value": [287.8925]},
        "3932": {"vr": "DS", "Value": [408.02]},
        "3933": {"vr": "DS", "Value": [526.81]},
        "3934": {"vr": "DS", "Value": [326.48]},
        "3935": {"vr": "DS", "Value": [525.64]},
        "3936": {"vr": "DS", "Value": [332.185]},
        "3937": {"vr": "DS", "Value": [401.27]},
        "3938": {"vr": "DS", "Value": [560.1075]},
        "3939": {"vr": "DS", "Value": [104.5575]},
        "3940": {"vr": "DS", "Value": [249.18]},
        "3941": {"vr": "DS", "Value": [511.28]},
        "3942": {"vr": "DS", "Value": [425.035]},
        "3943": {"vr": "DS", "Value": [549.5525]},
        "3944": {"vr": "DS", "Value": [343.035]},
        "3945": {"vr": "DS", "Value": [207.5225]},
        "3946": {"vr": "DS", "Value": [550.285]},
        "3947": {"vr": "DS", "Value": [104.7025]},
        "3948": {"vr": "DS", "Value": [194.7725]},
        "3949": {"vr": "DS", "Value": [529.1725]},
        "3950": {"vr": "DS", "Value": [372.82]},
        "3951": {"vr": "DS", "Value": [231.7275]},
        "3952": {"vr": "DS", "Value": [326.04]},
        "3953": {"vr": "DS", "Value": [332.625]},
        "3954": {"vr": "DS", "Value": [76.1075]},
        "3955": {"vr": "DS", "Value": [587.24]},
        "3956": {"vr": "DS", "Value": [317.24]},
        "3957": {"vr": "DS", "Value": [296.4]},
        "3958": {"vr": "DS", "Value": [214.42]},
        "3959": {"vr": "DS", "Value": [523.1525]},
        "3960": {"vr": "DS", "Value": [395.1025]},
        "3961": {"vr": "DS", "Value": [426.205]},
        "3962": {"vr": "DS", "Value": [489.415]},
        "3963": {"vr": "DS", "Value": [138.0]},
        "3964": {"vr": "DS", "Value": [414.48]},
        "3965": {"vr": "DS", "Value": [577.7075]},
        "3966": {"vr": "DS", "Value": [118.3525]},
        "3967": {"vr": "DS", "Value": [240.9675]},
        "3968": {"vr": "DS", "Value": [112.625]},
        "3969": {"vr": "DS", "Value": [52.635]},
        "3970": {"vr": "DS", "Value": [270.8775]},
        "3971": {"vr": "DS", "Value": [65.26]},
        "3972": {"vr": "DS", "Value": [453.7775]},
        "3973": {"vr": "DS", "Value": [236.995]},
        "3974": {"vr": "DS", "Value": [180.6825]},
        "3975": {"vr": "DS", "Value": [468.1575]},
        "3976": {"vr": "DS", "Value": [33.8625]},
        "3977": {"vr": "DS", "Value": [87.395]},
        "3978": {"vr": "DS", "Value": [571.25]},
        "3979": {"vr": "DS", "Value": [260.615]},
        "3980": {"vr": "DS", "Value": [101.045]},
        "3981": {"vr": "DS", "Value": [430.45]},
        "3982": {"vr": "DS", "Value": [288.9175]},
        "3983": {"vr": "DS", "Value": [41.3475]},
        "3984": {"vr": "DS", "Value": [163.9625]},
        "3985": {"vr": "DS", "Value": [347.7375]},
        "3986": {"vr": "DS", "Value": [562.01]},
        "3987": {"vr": "DS", "Value": [248.45]},
        "3988": {"vr": "DS", "Value": [289.3575]},
        "3989": {"vr": "DS", "Value": [222.9275]},
        "3990": {"vr": "DS", "Value": [336.7425]},
        "3991": {"vr": "DS", "Value": [342.01]},
        "3992": {"vr": "DS", "Value": [561.28]},
        "3993": {"vr": "DS", "Value": [514.205]},
        "3994": {"vr": "DS", "Value": [278.8]},
        "3995": {"vr": "DS", "Value": [115.28]},
        "3996": {"vr": "DS", "Value": [58.215]},
        "3997": {"vr": "DS", "Value": [522.7125]},
        "3998": {"vr": "DS", "Value": [277.9225]},
        "3999": {"vr": "DS", "Value": [429.7175]},
        "4000": {"vr": "DS", "Value": [531.22]},
        "4001": {"vr": "DS", "Value": [425.62]},
        "4002": {"vr": "DS", "Value": [459.9425]},
        "4003": {"vr": "DS", "Value": [215.445]},
        "4004": {"vr": "DS", "Value": [515.815]},
        "4005": {"vr": "DS", "Value": [143.1425]},
        "4006": {"vr": "DS", "Value": [74.9375]},
        "4007": {"vr": "DS", "Value": [358.585]},
        "4008": {"vr": "DS", "Value": [133.7575]},
        "4009": {"vr": "DS", "Value": [299.64]},
        "4010": {"vr": "DS", "Value": [311.9525]},
        "4011": {"vr": "DS", "Value": [109.1125]},
        "4012": {"vr": "DS", "Value": [478.5675]},
        "4013": {"vr": "DS", "Value": [99.7275]},
        "4014": {"vr": "DS", "Value": [194.185]},
        "4015": {"vr": "DS", "Value": [545.435]},
        "4016": {"vr": "DS", "Value": [530.7825]},
        "4017": {"vr": "DS", "Value": [288.185]},
        "4018": {"vr": "DS", "Value": [450.7025]},
        "4019": {"vr": "DS", "Value": [357.855]},
    },
    "00191027": {
        "0": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "4": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "5": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "6": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "7": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "8": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "9": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "10": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "11": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "12": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "15": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "16": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "17": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "18": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "19": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "20": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "21": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "22": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "23": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "24": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "25": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "26": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "27": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "28": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "29": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "30": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "32": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "33": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "36": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "37": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "38": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "39": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "41": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "42": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "43": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "44": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "45": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "46": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "47": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "48": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "49": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "50": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "51": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "52": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "53": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "54": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "55": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "56": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "57": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "58": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "59": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "62": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "63": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "64": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "65": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "66": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "67": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "69": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "70": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "71": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "72": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "73": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "74": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "75": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "76": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "77": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "78": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "79": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "81": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "82": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "83": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "84": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "85": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "86": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "87": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "88": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "89": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "92": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "93": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "94": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "95": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "96": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "97": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "98": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "99": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "100": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "101": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "102": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "103": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "104": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "105": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "106": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "107": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "108": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "109": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "110": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "111": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "113": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "115": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "116": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "117": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "118": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "119": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "120": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "121": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "122": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "123": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "124": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "125": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "126": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "127": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "129": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "130": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "131": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "132": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "133": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "134": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "135": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "136": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "137": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "138": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "139": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "140": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "141": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "142": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "143": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "144": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "145": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "146": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "147": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "148": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "149": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "150": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "151": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "152": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "153": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "154": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "155": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "156": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "157": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "158": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "159": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "161": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "162": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "163": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "164": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "165": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "166": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "167": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "168": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "169": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "170": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "171": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "172": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "173": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "174": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "175": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "176": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "177": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "178": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "179": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "180": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "181": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "182": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "183": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "184": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "185": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "186": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "187": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "188": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "189": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "190": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "192": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "193": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "194": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "195": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "196": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "197": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "199": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "200": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "201": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "202": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "203": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "204": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "205": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "206": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "207": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "208": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "209": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "211": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "212": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "213": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "214": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "215": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "216": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "217": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "218": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "219": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "220": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "221": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "222": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "223": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "224": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "225": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "226": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "228": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "229": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "230": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "231": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "232": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "233": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "234": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "235": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "236": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "237": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "238": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "239": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "240": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "241": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "242": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "244": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "245": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "247": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "248": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "249": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "250": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "251": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "252": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "253": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "254": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "255": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "257": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "258": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "259": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "260": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "261": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "262": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "263": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "264": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "265": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "266": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "267": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "268": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "269": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "271": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "272": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "273": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "274": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "276": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "277": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "278": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "279": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "280": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "281": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "282": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "283": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "284": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "285": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "286": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "287": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "288": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "289": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "291": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "292": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "293": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "294": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "295": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "296": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "297": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "298": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "299": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "300": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "302": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "303": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "304": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "305": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "306": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "307": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "308": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "309": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "310": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "312": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "314": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "315": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "317": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "318": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "319": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "320": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "321": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "322": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "323": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "324": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "325": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "326": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "327": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "328": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "329": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "330": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "331": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "332": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "333": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "334": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "335": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "336": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "337": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "338": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "339": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "340": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "341": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "342": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "343": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "344": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "345": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "346": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "347": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "348": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "351": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "352": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "353": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "354": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "355": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "356": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "357": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "358": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "359": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "360": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "362": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "364": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "365": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "366": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "367": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "369": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "370": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "371": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "372": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "373": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "374": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "375": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "376": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "377": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "378": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "379": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "380": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "381": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "382": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "385": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "386": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "387": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "388": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "389": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "390": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "391": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "392": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "393": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "394": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "395": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "397": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "398": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "400": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "401": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "402": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "403": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "404": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "405": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "406": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "407": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "408": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "409": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "410": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "411": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "412": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "413": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "414": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "415": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "416": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "417": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "419": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "420": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "421": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "422": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "423": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "425": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "426": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "427": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "428": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "429": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "430": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "431": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "432": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "433": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "434": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "435": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "436": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "437": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "438": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "439": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "440": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "441": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "442": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "443": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "444": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "446": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "447": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "449": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "450": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "451": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "452": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "453": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "454": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "455": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "456": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "457": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "458": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "459": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "460": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "461": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "462": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "463": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "464": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "465": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "466": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "467": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "468": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "470": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "471": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "472": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "473": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "474": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "476": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "477": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "478": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "479": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "480": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "481": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "482": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "484": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "485": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "486": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "487": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "488": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "489": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "490": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "491": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "492": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "493": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "494": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "495": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "496": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "498": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "499": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "500": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "502": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "503": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "504": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "505": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "506": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "508": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "509": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "510": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "511": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "512": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "513": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "516": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "517": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "518": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "519": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "521": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "522": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "523": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "524": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "525": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "526": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "527": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "528": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "529": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "530": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "532": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "533": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "534": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "535": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "536": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "537": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "538": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "540": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "541": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "543": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "545": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "546": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "547": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "549": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "550": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "551": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "552": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "556": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "557": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "558": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "559": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "560": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "561": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "562": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "563": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "564": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "565": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "566": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "568": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "569": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "570": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "571": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "572": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "573": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "574": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "575": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "576": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "577": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "578": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "579": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "580": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "581": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "582": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "583": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "584": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "586": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "588": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "589": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "590": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "591": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "592": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "593": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "594": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "595": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "596": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "597": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "598": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "599": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "601": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "602": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "603": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "604": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "605": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "606": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "607": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "608": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "609": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "610": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "612": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "613": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "614": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "615": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "616": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "617": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "618": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "619": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "620": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "621": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "622": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "623": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "625": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "626": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "627": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "628": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "629": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "630": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "631": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "632": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "633": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "634": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "635": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "637": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "638": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "639": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "640": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "641": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "642": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "643": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "644": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "645": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "646": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "647": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "648": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "649": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "650": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "651": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "652": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "653": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "654": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "655": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "656": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "657": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "658": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "659": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "660": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "661": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "662": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "664": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "665": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "666": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "667": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "669": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "670": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "671": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "672": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "673": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "674": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "675": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "676": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "677": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "678": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "680": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "681": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "682": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "683": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "684": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "685": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "686": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "688": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "689": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "691": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "692": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "693": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "694": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "695": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "696": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "697": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "698": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "700": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "701": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "702": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "703": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "704": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "705": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "706": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "708": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "709": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "710": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "711": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "712": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "713": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "716": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "717": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "718": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "719": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "720": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "721": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "722": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "723": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "724": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "725": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "726": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "727": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "728": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "729": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "730": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "731": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "733": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "734": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "735": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "736": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "737": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "738": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "739": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "740": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "741": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "742": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "743": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "744": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "745": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "746": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "747": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "748": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "749": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "750": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "751": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "752": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "753": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "754": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "755": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "756": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "758": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "759": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "760": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "761": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "762": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "763": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "764": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "765": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "766": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "767": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "768": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "769": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "770": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "772": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "773": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "774": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "775": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "776": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "778": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "779": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "780": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "781": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "782": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "783": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "784": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "785": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "786": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "787": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "789": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "790": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "792": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "793": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "794": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "795": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "796": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "797": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "798": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "799": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "800": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "801": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "802": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "803": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "804": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "805": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "806": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "807": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "808": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "809": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "811": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "812": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "813": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "814": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "815": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "817": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "818": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "819": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "821": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "822": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "823": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "824": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "825": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "826": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "828": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "830": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "831": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "832": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "833": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "834": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "835": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "836": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "837": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "838": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "839": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "840": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "841": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "842": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "843": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "844": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "845": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "847": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "848": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "849": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "851": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "852": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "853": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "854": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "855": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "856": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "857": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "858": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "859": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "860": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "862": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "863": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "864": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "865": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "866": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "869": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "871": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "872": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "873": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "874": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "876": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "877": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "878": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "879": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "880": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "881": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "882": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "883": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "884": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "886": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "887": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "888": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "889": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "890": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "891": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "892": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "893": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "894": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "895": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "896": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "897": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "898": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "899": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "900": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "901": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "902": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "903": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "904": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "905": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "906": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "907": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "908": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "909": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "910": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "911": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "912": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "913": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "914": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "915": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "916": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "917": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "918": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "920": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "921": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "922": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "923": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "925": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "927": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "928": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "929": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "930": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "931": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "933": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "934": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "935": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "937": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "938": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "939": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "940": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "941": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "942": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "943": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "944": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "945": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "946": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "947": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "949": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "950": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "951": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "952": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "953": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "954": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "955": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "957": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "958": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "959": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "960": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "962": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "963": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "964": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "965": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "966": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "967": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "968": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "969": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "970": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "971": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "972": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "973": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "974": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "975": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "976": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "977": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "979": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "980": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "981": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "982": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "984": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "985": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "986": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "987": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "988": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "989": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "990": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "991": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "992": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "993": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "994": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "995": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "997": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "998": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "999": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1000": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1001": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1002": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1003": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1004": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1005": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1006": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1007": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1008": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1009": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1010": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1011": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1012": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1013": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1014": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1017": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1018": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1019": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1020": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1021": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1022": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1023": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1024": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1025": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1026": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1027": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1028": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1029": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1031": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1033": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1034": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1035": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1036": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1037": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1038": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1040": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1041": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1042": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1043": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1044": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1045": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1046": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1047": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1048": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1049": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1050": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1051": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1052": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1053": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1054": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1055": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1056": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1057": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1058": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1059": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1061": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1062": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1063": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1064": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1066": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1067": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1068": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1069": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1070": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1071": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1072": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1074": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1075": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1076": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1077": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1078": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1079": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1080": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1082": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1083": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1084": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1085": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1086": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1087": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1089": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1092": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1093": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1094": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1095": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1096": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1098": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1099": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1100": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1101": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1102": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1103": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1104": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1106": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1107": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1108": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1109": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1111": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1112": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1113": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1114": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1115": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1116": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1117": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1118": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1119": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1120": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1121": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1122": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1123": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1124": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1125": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1126": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1127": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1128": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1129": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1130": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1132": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1133": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1134": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1135": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1137": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1138": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1139": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1140": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1141": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1142": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1143": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1144": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1145": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1146": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1150": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1151": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1152": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1153": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1154": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1155": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1156": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1157": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1158": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1159": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1160": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1161": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1162": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1163": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1164": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1167": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1168": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1169": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1170": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1171": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1172": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1173": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1174": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1175": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1176": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1177": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1179": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1180": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1181": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1182": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1183": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1184": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1185": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1186": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1187": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1188": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1190": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1192": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1194": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1195": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1196": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1197": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1198": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1199": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1200": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1203": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1204": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1205": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1206": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1207": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1208": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1209": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1210": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1211": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1212": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1213": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1214": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1215": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1216": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1217": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1218": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1221": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1222": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1223": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1224": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1225": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1226": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1227": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1228": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1229": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1230": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1231": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1232": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1233": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1234": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1235": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1236": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1237": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1238": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1239": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1240": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1241": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1242": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1243": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1244": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1245": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1246": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1247": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1248": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1249": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1250": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1251": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1252": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1253": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1254": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1255": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1256": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1257": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1258": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1259": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1261": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1262": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1263": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1265": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1266": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1267": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1268": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1269": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1270": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1272": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1273": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1274": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1275": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1276": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1277": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1278": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1279": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1280": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1281": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1283": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1284": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1285": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1286": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1287": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1288": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1289": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1290": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1292": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1293": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1294": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1295": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1296": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1297": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1298": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1299": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1301": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1302": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1303": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1304": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1305": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1306": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1307": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1308": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1310": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1311": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1312": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1313": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1314": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1315": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1316": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1317": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1318": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1319": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1320": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1321": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1322": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1323": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1325": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1327": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1328": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1329": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1331": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1332": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1334": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1335": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1336": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1337": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1338": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1339": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1340": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1341": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1342": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1343": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1344": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1345": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1346": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1348": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1349": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1350": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1351": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1352": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1353": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1354": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1355": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1356": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1357": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1359": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1360": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1361": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1362": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1363": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1364": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1365": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1366": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1367": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1368": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1369": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1370": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1371": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1372": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1373": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1374": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1376": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1377": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1378": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1379": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1380": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1382": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1383": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1384": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1385": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1386": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1387": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1388": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1389": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1390": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1391": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1392": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1393": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1394": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1395": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1396": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1397": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1398": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1399": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1400": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1401": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1402": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1403": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1405": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1406": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1407": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1408": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1409": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1410": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1411": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1412": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1414": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1415": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1416": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1418": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1419": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1420": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1421": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1422": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1423": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1424": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1425": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1426": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1427": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1428": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1429": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1431": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1432": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1433": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1434": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1435": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1436": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1437": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1438": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1439": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1440": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1441": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1443": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1444": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1445": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1446": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1447": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1448": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1450": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1451": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1452": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1453": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1454": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1456": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1457": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1458": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1459": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1462": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1463": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1464": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1465": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1466": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1467": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1468": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1469": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1470": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1471": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1472": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1473": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1475": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1476": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1477": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1478": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1479": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1480": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1481": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1482": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1483": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1484": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1485": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1486": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1487": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1489": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1490": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1491": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1492": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1494": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1495": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1496": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1497": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1498": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1499": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1500": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1501": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1502": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1503": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1504": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1505": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1506": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1507": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1508": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1509": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1510": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1511": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1513": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1514": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1516": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1518": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1519": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1520": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1521": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1522": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1523": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1524": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1525": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1526": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1527": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1528": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1529": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1530": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1531": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1532": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1533": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1534": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1535": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1537": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1538": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1539": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1540": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1541": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1542": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1543": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1544": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1545": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1546": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1547": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1548": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1549": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1550": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1551": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1552": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1554": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1556": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1557": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1558": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1560": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1561": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1563": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1564": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1565": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1566": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1567": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1568": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1569": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1570": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1571": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1572": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1573": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1575": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1576": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1577": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1578": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1579": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1580": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1581": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1582": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1583": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1584": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1585": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1586": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1587": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1588": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1589": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1591": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1592": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1593": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1595": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1596": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1597": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1598": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1599": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1602": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1605": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1606": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1607": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1608": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1609": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1611": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1612": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1613": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1614": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1615": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1616": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1617": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1618": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1619": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1620": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1621": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1622": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1623": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1624": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1626": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1627": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1628": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1629": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1630": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1631": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1632": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1633": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1634": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1635": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1636": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1637": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1638": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1639": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1640": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1641": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1642": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1645": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1646": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1647": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1648": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1650": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1651": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1652": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1653": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1654": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1655": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1656": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1657": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1658": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1659": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1660": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1661": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1662": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1663": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1664": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1665": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1666": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1667": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1668": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1669": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1670": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1671": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1672": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1673": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1674": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1675": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1676": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1677": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1678": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1679": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1680": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1681": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1682": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1683": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1684": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1685": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1686": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1687": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1688": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1690": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1692": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1693": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1694": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1695": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1696": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1697": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1698": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1699": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1701": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1702": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1703": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1704": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1705": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1706": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1707": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1708": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1709": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1710": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1711": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1712": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1713": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1714": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1715": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1716": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1718": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1719": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1721": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1722": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1723": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1724": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1725": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1726": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1727": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1728": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1729": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1730": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1731": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1732": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1733": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1734": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1735": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1737": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1739": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1740": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1741": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1742": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1743": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1744": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1745": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1746": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1747": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1748": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1749": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1750": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1751": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1752": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1753": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1754": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1755": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1756": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1757": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1758": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1759": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1760": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1761": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1762": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1763": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1764": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1765": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1766": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1767": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1768": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1769": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1770": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1771": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1772": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1773": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1774": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1776": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1777": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1778": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1779": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1780": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1781": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1782": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1783": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1784": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1785": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1786": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1787": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1788": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1789": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1790": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1791": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1792": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1793": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1794": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1795": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1797": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1798": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1799": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1800": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1801": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1803": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1804": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1806": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1807": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1808": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1809": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1810": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1811": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1812": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1813": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1814": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1815": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1816": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1817": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1818": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1819": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1820": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1821": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1822": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1823": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1824": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1825": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1826": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1828": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1829": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1830": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1831": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1832": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1833": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1834": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1835": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1836": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1839": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1840": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1841": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1842": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1843": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1844": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1846": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1847": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1848": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1849": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1850": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1851": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1852": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1853": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1854": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1855": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1856": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1857": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1858": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1859": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1860": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1861": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1862": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1863": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1864": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1865": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1866": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1867": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1868": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1869": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1870": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1871": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1874": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1875": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1876": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1877": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1878": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1879": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1880": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1881": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1882": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1883": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1884": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1885": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1886": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1887": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1888": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1890": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1891": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1892": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1893": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1894": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1895": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1896": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1897": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1898": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1899": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1900": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1901": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1902": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1903": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1904": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1905": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1906": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1907": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1908": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1910": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1911": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1912": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1913": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1917": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1919": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1921": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1922": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1923": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1924": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1925": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1926": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1927": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1928": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1929": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1930": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1931": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1932": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1934": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1935": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1936": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1937": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1938": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1939": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1940": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1941": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1942": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1943": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1944": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1945": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1946": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1947": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1948": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1950": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1951": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1952": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1953": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1954": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1955": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1956": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1957": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1958": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1959": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1960": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1962": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1963": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1964": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1965": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1966": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1968": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1969": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1970": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1971": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1972": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1974": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1975": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1976": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1977": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1978": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1979": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1980": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1981": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1982": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1983": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1984": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1985": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1987": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1988": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1989": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1990": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1991": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1992": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1994": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1995": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1997": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1998": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1999": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2000": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2002": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2003": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2004": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2005": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2006": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2007": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2008": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2009": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2010": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2011": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2013": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2014": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2015": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2016": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2018": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2019": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2020": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2021": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2022": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2023": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2024": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2026": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2027": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2028": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2030": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2031": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2032": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2033": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2034": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2035": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2036": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2037": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2038": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2039": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2040": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2041": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2042": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2043": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2044": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2045": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2046": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2047": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2048": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2049": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2050": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2051": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2052": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2053": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2054": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2055": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2056": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2057": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2058": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2059": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2060": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2061": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2062": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2063": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2065": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2066": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2067": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2068": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2069": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2070": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2071": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2072": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2073": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2074": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2076": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2077": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2078": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2080": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2081": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2085": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2087": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2088": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2089": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2090": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2091": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2092": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2093": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2094": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2095": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2096": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2097": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2099": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2100": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2101": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2102": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2103": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2104": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2105": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2106": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2107": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2108": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2110": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2111": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2112": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2113": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2114": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2115": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2116": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2117": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2118": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2119": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2120": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2121": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2122": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2123": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2124": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2125": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2126": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2127": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2128": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2129": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2130": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2131": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2133": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2134": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2135": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2136": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2137": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2138": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2139": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2140": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2141": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2142": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2143": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2144": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2145": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2147": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2148": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2149": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2150": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2151": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2152": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2153": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2154": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2155": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2156": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2157": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2159": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2160": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2161": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2162": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2163": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2164": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2166": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2167": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2168": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2169": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2171": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2172": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2173": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2175": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2176": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2177": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2178": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2179": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2180": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2181": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2182": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2183": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2184": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2185": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2186": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2188": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2189": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2190": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2191": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2193": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2194": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2195": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2196": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2197": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2198": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2199": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2200": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2201": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2202": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2203": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2205": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2206": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2207": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2208": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2209": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2210": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2211": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2212": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2213": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2214": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2215": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2216": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2217": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2218": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2219": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2221": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2222": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2223": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2224": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2225": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2226": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2227": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2228": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2229": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2230": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2231": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2232": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2233": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2234": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2235": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2236": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2237": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2238": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2240": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2241": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2242": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2243": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2244": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2245": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2246": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2247": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2248": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2249": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2250": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2251": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2252": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2253": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2255": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2256": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2257": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2258": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2260": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2261": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2262": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2264": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2265": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2266": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2267": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2268": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2269": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2270": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2271": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2272": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2273": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2274": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2275": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2276": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2277": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2279": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2280": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2281": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2282": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2283": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2284": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2285": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2286": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2288": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2289": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2290": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2292": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2293": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2294": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2297": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2298": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2299": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2300": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2301": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2302": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2303": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2304": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2305": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2306": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2307": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2308": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2309": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2310": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2311": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2312": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2314": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2315": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2316": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2317": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2318": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2319": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2320": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2321": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2322": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2323": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2324": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2325": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2326": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2327": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2328": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2329": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2330": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2331": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2332": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2333": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2334": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2335": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2336": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2337": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2338": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2339": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2341": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2342": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2343": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2344": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2345": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2347": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2348": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2349": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2350": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2351": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2352": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2353": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2354": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2355": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2356": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2357": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2358": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2361": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2362": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2363": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2364": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2365": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2366": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2367": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2368": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2370": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2371": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2372": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2373": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2374": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2375": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2377": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2378": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2379": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2380": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2383": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2384": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2386": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2387": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2388": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2389": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2390": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2391": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2392": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2393": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2395": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2396": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2397": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2398": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2399": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2401": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2402": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2403": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2404": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2405": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2406": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2407": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2408": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2409": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2410": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2411": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2412": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2413": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2414": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2415": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2416": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2419": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2420": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2421": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2422": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2423": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2424": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2425": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2426": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2427": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2428": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2429": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2430": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2431": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2432": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2434": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2435": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2436": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2437": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2438": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2439": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2440": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2441": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2442": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2443": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2444": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2445": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2446": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2447": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2448": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2449": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2450": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2451": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2452": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2453": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2454": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2455": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2456": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2457": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2458": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2459": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2460": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2461": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2462": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2463": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2464": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2465": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2466": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2467": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2468": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2469": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2470": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2471": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2472": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2473": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2474": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2475": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2476": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2477": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2478": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2481": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2482": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2483": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2484": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2485": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2486": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2487": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2488": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2489": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2490": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2491": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2492": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2493": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2494": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2495": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2496": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2497": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2498": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2499": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2500": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2501": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2502": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2503": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2504": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2505": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2506": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2507": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2508": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2509": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2510": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2511": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2512": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2513": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2514": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2515": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2516": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2517": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2518": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2519": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2521": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2523": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2524": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2526": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2527": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2528": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2529": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2530": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2531": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2532": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2533": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2535": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2536": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2538": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2540": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2541": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2542": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2543": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2544": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2545": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2547": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2549": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2550": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2551": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2552": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2553": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2554": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2555": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2556": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2558": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2559": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2560": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2561": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2562": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2563": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2564": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2565": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2566": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2567": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2568": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2569": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2570": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2573": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2574": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2575": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2576": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2577": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2578": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2579": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2580": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2581": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2582": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2583": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2586": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2587": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2588": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2589": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2590": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2591": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2592": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2593": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2594": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2595": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2596": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2597": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2598": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2599": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2600": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2601": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2602": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2603": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2604": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2605": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2606": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2607": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2608": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2610": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2612": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2613": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2614": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2615": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2616": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2617": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2619": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2620": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2621": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2622": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2623": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2624": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2625": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2626": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2627": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2630": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2631": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2632": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2633": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2634": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2635": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2637": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2638": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2641": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2642": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2643": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2644": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2645": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2646": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2647": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2648": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2649": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2650": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2651": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2652": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2653": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2654": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2655": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2656": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2657": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2659": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2660": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2661": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2662": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2663": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2664": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2665": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2666": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2667": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2668": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2669": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2670": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2671": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2672": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2673": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2674": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2675": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2676": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2677": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2678": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2681": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2682": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2683": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2684": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2685": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2686": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2687": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2688": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2689": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2690": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2691": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2692": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2693": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2694": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2695": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2696": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2697": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2698": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2699": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2700": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2701": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2703": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2704": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2705": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2706": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2707": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2708": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2709": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2710": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2711": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2712": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2713": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2714": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2715": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2716": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2717": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2718": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2719": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2720": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2721": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2722": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2723": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2724": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2725": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2727": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2728": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2729": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2730": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2731": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2732": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2733": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2734": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2735": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2737": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2738": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2739": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2740": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2742": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2743": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2744": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2745": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2747": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2748": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2749": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2751": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2752": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2753": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2754": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2755": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2756": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2758": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2759": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2760": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2761": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2762": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2763": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2764": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2766": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2767": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2768": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2769": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2771": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2772": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2773": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2774": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2775": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2776": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2778": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2779": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2780": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2782": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2783": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2784": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2785": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2786": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2787": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2788": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2789": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2790": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2791": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2793": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2794": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2795": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2796": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2798": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2799": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2800": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2801": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2802": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2803": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2804": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2805": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2806": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2807": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2808": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2809": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2810": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2811": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2812": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2813": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2814": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2815": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2816": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2817": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2819": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2820": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2821": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2823": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2824": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2825": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2826": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2827": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2828": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2829": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2831": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2832": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2833": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2834": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2835": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2836": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2837": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2838": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2839": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2840": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2841": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2842": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2843": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2844": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2845": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2846": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2847": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2848": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2849": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2850": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2851": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2853": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2854": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2856": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2857": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2858": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2859": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2860": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2861": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2863": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2864": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2865": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2866": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2867": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2868": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2869": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2870": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2871": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2872": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2873": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2874": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2875": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2876": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2877": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2879": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2880": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2881": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2883": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2884": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2885": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2886": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2887": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2888": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2889": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2890": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2891": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2892": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2893": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2894": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2895": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2896": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2897": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2898": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2899": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2900": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2901": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2902": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2903": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2904": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2905": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2908": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2909": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2910": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2911": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2912": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2913": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2914": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2915": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2917": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2920": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2921": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2922": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2924": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2925": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2926": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2927": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2928": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2929": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2931": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2932": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2933": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2934": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2936": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2937": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2938": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2939": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2940": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2941": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2942": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2943": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2944": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2945": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2947": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2948": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2950": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2951": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2952": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2953": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2956": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2957": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2958": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2959": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2960": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2961": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2962": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2963": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2964": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2965": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2966": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2967": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2969": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2970": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2971": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2972": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2973": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2974": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2975": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2976": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2977": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2978": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2979": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2980": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2981": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2982": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2983": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2984": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2986": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2987": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2988": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2989": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2990": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2991": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2992": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2993": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2994": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2995": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2996": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2997": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2998": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2999": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3000": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3001": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3002": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3003": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3004": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3006": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3007": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3008": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3009": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3010": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3011": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3012": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3013": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3014": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3015": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3016": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3017": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3018": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3020": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3021": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3022": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3023": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3024": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3025": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3026": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3027": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3028": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3030": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3031": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3032": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3033": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3034": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3035": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3036": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3037": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3038": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3039": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3040": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3041": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3042": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3043": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3044": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3045": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3046": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3047": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3048": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3049": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3050": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3051": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3052": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3054": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3055": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3056": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3057": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3058": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3059": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3060": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3061": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3062": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3063": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3064": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3065": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3066": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3067": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3068": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3069": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3070": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3071": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3073": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3075": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3076": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3078": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3079": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3080": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3081": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3082": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3083": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3084": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3085": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3086": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3087": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3088": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3090": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3091": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3093": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3094": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3095": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3096": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3097": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3098": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3099": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3100": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3101": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3103": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3104": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3105": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3106": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3107": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3108": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3109": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3110": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3111": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3112": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3113": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3114": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3115": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3116": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3117": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3118": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3119": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3120": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3121": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3122": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3123": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3124": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3125": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3126": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3127": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3128": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3129": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3130": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3131": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3133": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3134": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3135": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3136": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3137": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3138": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3139": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3140": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3141": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3142": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3143": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3144": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3145": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3146": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3147": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3148": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3149": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3150": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3151": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3152": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3153": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3154": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3155": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3156": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3157": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3158": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3159": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3161": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3162": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3163": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3164": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3166": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3167": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3168": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3169": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3170": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3171": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3173": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3174": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3175": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3176": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3177": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3178": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3179": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3180": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3181": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3182": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3183": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3184": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3185": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3186": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3187": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3188": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3189": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3190": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3191": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3192": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3195": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3196": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3197": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3198": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3199": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3200": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3201": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3202": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3203": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3204": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3205": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3206": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3207": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3208": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3209": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3210": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3211": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3212": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3213": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3215": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3216": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3217": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3219": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3220": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3221": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3222": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3223": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3224": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3225": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3226": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3227": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3228": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3229": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3231": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3232": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3233": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3234": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3235": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3236": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3237": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3238": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3239": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3240": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3241": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3242": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3244": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3245": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3246": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3247": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3248": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3249": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3250": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3251": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3252": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3253": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3254": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3255": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3257": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3259": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3260": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3261": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3262": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3263": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3265": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3266": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3267": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3268": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3269": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3271": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3272": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3273": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3274": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3275": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3276": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3277": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3278": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3279": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3281": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3282": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3283": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3284": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3285": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3286": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3287": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3288": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3289": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3290": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3291": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3292": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3293": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3294": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3295": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3296": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3297": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3298": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3299": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3300": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3301": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3302": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3303": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3304": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3305": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3306": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3307": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3308": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3309": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3310": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3311": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3312": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3313": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3314": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3316": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3317": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3318": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3319": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3320": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3321": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3322": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3323": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3324": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3325": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3326": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3327": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3329": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3330": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3331": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3332": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3333": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3334": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3335": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3336": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3337": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3338": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3339": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3340": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3341": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3342": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3344": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3345": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3346": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3348": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3349": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3350": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3351": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3352": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3353": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3354": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3355": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3356": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3357": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3358": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3359": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3360": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3361": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3362": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3363": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3364": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3366": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3367": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3368": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3369": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3370": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3371": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3372": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3373": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3374": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3375": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3377": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3378": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3379": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3380": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3381": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3383": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3385": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3386": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3387": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3388": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3390": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3391": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3392": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3393": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3394": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3395": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3396": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3397": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3398": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3399": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3400": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3401": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3402": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3403": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3404": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3406": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3407": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3408": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3409": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3410": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3411": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3412": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3413": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3414": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3415": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3416": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3417": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3418": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3419": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3420": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3421": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3422": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3423": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3424": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3425": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3426": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3427": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3428": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3429": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3430": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3432": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3433": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3434": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3435": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3437": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3438": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3439": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3440": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3441": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3442": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3443": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3444": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3445": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3447": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3448": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3449": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3450": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3451": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3452": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3453": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3455": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3456": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3457": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3458": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3459": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3460": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3461": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3462": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3463": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3464": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3465": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3466": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3467": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3468": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3469": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3470": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3471": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3472": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3473": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3475": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3476": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3477": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3478": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3479": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3480": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3482": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3483": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3484": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3485": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3486": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3487": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3488": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3489": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3490": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3491": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3493": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3494": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3495": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3496": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3497": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3499": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3500": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3502": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3504": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3505": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3506": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3507": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3508": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3509": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3510": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3512": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3513": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3514": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3515": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3516": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3517": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3518": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3519": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3520": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3523": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3524": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3525": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3526": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3527": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3528": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3530": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3531": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3533": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3534": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3535": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3536": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3537": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3538": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3540": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3541": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3542": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3543": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3544": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3545": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3546": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3547": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3548": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3549": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3550": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3551": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3552": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3553": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3554": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3555": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3556": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3557": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3558": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3559": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3560": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3561": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3562": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3563": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3564": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3565": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3566": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3567": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3568": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3569": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3570": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3571": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3572": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3573": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3574": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3576": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3577": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3578": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3579": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3580": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3581": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3582": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3583": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3584": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3585": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3586": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3587": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3588": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3590": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3591": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3592": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3593": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3594": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3595": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3597": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3599": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3600": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3601": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3602": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3603": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3604": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3605": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3606": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3607": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3608": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3609": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3611": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3612": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3613": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3615": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3616": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3617": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3618": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3619": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3620": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3621": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3622": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3623": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3624": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3625": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3626": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3627": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3629": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3630": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3631": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3632": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3633": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3634": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3635": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3636": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3637": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3639": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3641": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3642": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3643": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3644": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3645": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3646": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3647": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3648": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3649": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3650": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3651": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3652": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3655": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3656": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3657": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3658": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3659": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3660": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3661": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3662": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3663": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3664": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3665": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3666": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3667": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3669": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3670": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3671": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3672": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3674": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3675": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3676": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3677": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3678": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3679": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3680": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3681": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3682": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3683": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3684": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3685": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3686": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3688": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3689": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3690": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3691": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3692": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3693": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3694": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3695": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3697": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3699": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3700": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3701": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3702": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3703": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3704": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3705": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3706": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3707": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3708": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3709": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3710": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3711": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3712": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3713": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3714": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3715": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3717": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3718": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3719": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3720": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3721": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3722": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3724": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3725": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3726": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3727": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3728": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3730": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3731": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3732": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3733": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3734": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3736": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3737": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3738": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3739": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3740": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3741": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3743": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3745": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3746": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3747": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3748": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3749": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3750": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3751": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3752": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3753": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3754": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3755": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3757": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3758": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3759": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3760": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3761": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3762": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3764": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3765": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3766": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3767": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3768": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3769": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3770": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3771": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3772": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3773": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3774": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3775": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3776": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3777": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3778": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3779": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3780": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3781": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3782": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3783": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3784": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3785": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3786": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3787": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3789": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3790": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3791": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3792": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3793": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3794": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3796": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3797": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3798": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3799": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3800": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3801": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3802": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3803": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3804": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3807": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3808": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3809": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3810": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3811": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3812": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3813": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3814": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3815": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3816": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3817": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3818": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3819": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3820": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3821": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3822": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3823": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3824": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3826": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3827": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3828": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3829": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3830": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3831": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3833": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3834": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3835": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3836": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3837": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3838": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3839": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3840": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3841": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3842": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3843": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3844": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3846": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3847": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3848": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3849": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3850": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3851": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3852": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3853": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3854": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3856": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3857": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3858": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3859": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3860": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3861": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3862": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3864": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3865": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3866": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3867": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3868": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3869": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3870": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3871": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3872": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3873": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3874": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3875": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3876": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3877": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3879": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3880": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3881": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3883": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3884": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3886": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3887": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3888": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3889": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3890": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3891": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3892": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3893": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3894": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3895": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3896": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3897": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3898": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3899": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3901": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3902": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3903": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3904": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3905": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3906": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3907": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3908": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3909": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3910": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3911": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3912": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3913": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3914": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3915": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3917": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3918": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3919": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3920": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3921": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3922": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3923": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3924": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3925": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3926": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3927": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3929": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3930": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3931": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3932": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3933": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3934": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3935": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3936": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3938": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3939": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3940": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3941": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3942": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3943": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3944": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3946": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3947": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3948": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3949": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3950": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3951": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3952": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3953": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3954": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3955": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3956": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3957": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3958": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3959": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3960": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3961": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3962": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3963": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3964": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3965": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3966": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3967": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3969": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3970": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3971": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3972": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3973": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3974": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3975": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3976": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3977": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3978": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3979": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3980": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3981": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3982": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3983": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3984": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3985": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3986": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3987": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3988": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3989": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3990": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3991": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3992": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3993": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3994": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3995": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3996": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3997": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3998": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3999": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "4000": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "4001": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "4002": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "4003": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "4004": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "4005": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "4006": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "4007": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "4008": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "4010": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "4012": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "4013": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "4014": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "4015": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "4016": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "4017": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "4018": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "4019": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
    },
    "00200012": {
        "0": {"vr": "IS", "Value": [22]},
        "1": {"vr": "IS", "Value": [30]},
        "2": {"vr": "IS", "Value": [43]},
        "3": {"vr": "IS", "Value": [45]},
        "4": {"vr": "IS", "Value": [40]},
        "5": {"vr": "IS", "Value": [39]},
        "6": {"vr": "IS", "Value": [55]},
        "7": {"vr": "IS", "Value": [57]},
        "8": {"vr": "IS", "Value": [24]},
        "9": {"vr": "IS", "Value": [13]},
        "10": {"vr": "IS", "Value": [54]},
        "11": {"vr": "IS", "Value": [25]},
        "12": {"vr": "IS", "Value": [24]},
        "13": {"vr": "IS", "Value": [1]},
        "14": {"vr": "IS", "Value": [34]},
        "15": {"vr": "IS", "Value": [46]},
        "16": {"vr": "IS", "Value": [53]},
        "17": {"vr": "IS", "Value": [7]},
        "18": {"vr": "IS", "Value": [20]},
        "19": {"vr": "IS", "Value": [47]},
        "20": {"vr": "IS", "Value": [15]},
        "21": {"vr": "IS", "Value": [48]},
        "22": {"vr": "IS", "Value": [50]},
        "23": {"vr": "IS", "Value": [60]},
        "24": {"vr": "IS", "Value": [49]},
        "25": {"vr": "IS", "Value": [20]},
        "26": {"vr": "IS", "Value": [32]},
        "27": {"vr": "IS", "Value": [16]},
        "28": {"vr": "IS", "Value": [19]},
        "29": {"vr": "IS", "Value": [46]},
        "30": {"vr": "IS", "Value": [32]},
        "31": {"vr": "IS", "Value": [23]},
        "32": {"vr": "IS", "Value": [36]},
        "33": {"vr": "IS", "Value": [18]},
        "34": {"vr": "IS", "Value": [67]},
        "35": {"vr": "IS", "Value": [1]},
        "36": {"vr": "IS", "Value": [11]},
        "37": {"vr": "IS", "Value": [20]},
        "38": {"vr": "IS", "Value": [41]},
        "39": {"vr": "IS", "Value": [29]},
        "40": {"vr": "IS", "Value": [56]},
        "41": {"vr": "IS", "Value": [64]},
        "42": {"vr": "IS", "Value": [65]},
        "43": {"vr": "IS", "Value": [20]},
        "44": {"vr": "IS", "Value": [53]},
        "45": {"vr": "IS", "Value": [8]},
        "46": {"vr": "IS", "Value": [54]},
        "47": {"vr": "IS", "Value": [64]},
        "48": {"vr": "IS", "Value": [28]},
        "49": {"vr": "IS", "Value": [3]},
        "50": {"vr": "IS", "Value": [51]},
        "51": {"vr": "IS", "Value": [52]},
        "52": {"vr": "IS", "Value": [53]},
        "53": {"vr": "IS", "Value": [22]},
        "54": {"vr": "IS", "Value": [10]},
        "55": {"vr": "IS", "Value": [26]},
        "56": {"vr": "IS", "Value": [39]},
        "57": {"vr": "IS", "Value": [28]},
        "58": {"vr": "IS", "Value": [24]},
        "59": {"vr": "IS", "Value": [17]},
        "60": {"vr": "IS", "Value": [45]},
        "61": {"vr": "IS", "Value": [56]},
        "62": {"vr": "IS", "Value": [22]},
        "63": {"vr": "IS", "Value": [65]},
        "64": {"vr": "IS", "Value": [38]},
        "65": {"vr": "IS", "Value": [66]},
        "66": {"vr": "IS", "Value": [22]},
        "67": {"vr": "IS", "Value": [25]},
        "68": {"vr": "IS", "Value": [12]},
        "69": {"vr": "IS", "Value": [15]},
        "70": {"vr": "IS", "Value": [10]},
        "71": {"vr": "IS", "Value": [39]},
        "72": {"vr": "IS", "Value": [39]},
        "73": {"vr": "IS", "Value": [48]},
        "74": {"vr": "IS", "Value": [7]},
        "75": {"vr": "IS", "Value": [62]},
        "76": {"vr": "IS", "Value": [48]},
        "77": {"vr": "IS", "Value": [32]},
        "78": {"vr": "IS", "Value": [46]},
        "79": {"vr": "IS", "Value": [18]},
        "80": {"vr": "IS", "Value": [67]},
        "81": {"vr": "IS", "Value": [7]},
        "82": {"vr": "IS", "Value": [42]},
        "83": {"vr": "IS", "Value": [36]},
        "84": {"vr": "IS", "Value": [2]},
        "85": {"vr": "IS", "Value": [46]},
        "86": {"vr": "IS", "Value": [52]},
        "87": {"vr": "IS", "Value": [48]},
        "88": {"vr": "IS", "Value": [28]},
        "89": {"vr": "IS", "Value": [59]},
        "90": {"vr": "IS", "Value": [1]},
        "91": {"vr": "IS", "Value": [12]},
        "92": {"vr": "IS", "Value": [50]},
        "93": {"vr": "IS", "Value": [10]},
        "94": {"vr": "IS", "Value": [59]},
        "95": {"vr": "IS", "Value": [16]},
        "96": {"vr": "IS", "Value": [17]},
        "97": {"vr": "IS", "Value": [66]},
        "98": {"vr": "IS", "Value": [2]},
        "99": {"vr": "IS", "Value": [2]},
        "100": {"vr": "IS", "Value": [8]},
        "101": {"vr": "IS", "Value": [26]},
        "102": {"vr": "IS", "Value": [9]},
        "103": {"vr": "IS", "Value": [36]},
        "104": {"vr": "IS", "Value": [54]},
        "105": {"vr": "IS", "Value": [59]},
        "106": {"vr": "IS", "Value": [49]},
        "107": {"vr": "IS", "Value": [58]},
        "108": {"vr": "IS", "Value": [15]},
        "109": {"vr": "IS", "Value": [15]},
        "110": {"vr": "IS", "Value": [65]},
        "111": {"vr": "IS", "Value": [54]},
        "112": {"vr": "IS", "Value": [23]},
        "113": {"vr": "IS", "Value": [65]},
        "114": {"vr": "IS", "Value": [34]},
        "115": {"vr": "IS", "Value": [50]},
        "116": {"vr": "IS", "Value": [55]},
        "117": {"vr": "IS", "Value": [14]},
        "118": {"vr": "IS", "Value": [44]},
        "119": {"vr": "IS", "Value": [66]},
        "120": {"vr": "IS", "Value": [5]},
        "121": {"vr": "IS", "Value": [3]},
        "122": {"vr": "IS", "Value": [52]},
        "123": {"vr": "IS", "Value": [2]},
        "124": {"vr": "IS", "Value": [49]},
        "125": {"vr": "IS", "Value": [35]},
        "126": {"vr": "IS", "Value": [64]},
        "127": {"vr": "IS", "Value": [29]},
        "128": {"vr": "IS", "Value": [45]},
        "129": {"vr": "IS", "Value": [21]},
        "130": {"vr": "IS", "Value": [8]},
        "131": {"vr": "IS", "Value": [46]},
        "132": {"vr": "IS", "Value": [59]},
        "133": {"vr": "IS", "Value": [64]},
        "134": {"vr": "IS", "Value": [59]},
        "135": {"vr": "IS", "Value": [18]},
        "136": {"vr": "IS", "Value": [32]},
        "137": {"vr": "IS", "Value": [39]},
        "138": {"vr": "IS", "Value": [8]},
        "139": {"vr": "IS", "Value": [20]},
        "140": {"vr": "IS", "Value": [25]},
        "141": {"vr": "IS", "Value": [4]},
        "142": {"vr": "IS", "Value": [36]},
        "143": {"vr": "IS", "Value": [52]},
        "144": {"vr": "IS", "Value": [37]},
        "145": {"vr": "IS", "Value": [53]},
        "146": {"vr": "IS", "Value": [7]},
        "147": {"vr": "IS", "Value": [16]},
        "148": {"vr": "IS", "Value": [55]},
        "149": {"vr": "IS", "Value": [52]},
        "150": {"vr": "IS", "Value": [33]},
        "151": {"vr": "IS", "Value": [15]},
        "152": {"vr": "IS", "Value": [65]},
        "153": {"vr": "IS", "Value": [17]},
        "154": {"vr": "IS", "Value": [2]},
        "155": {"vr": "IS", "Value": [47]},
        "156": {"vr": "IS", "Value": [19]},
        "157": {"vr": "IS", "Value": [27]},
        "158": {"vr": "IS", "Value": [37]},
        "159": {"vr": "IS", "Value": [6]},
        "160": {"vr": "IS", "Value": [67]},
        "161": {"vr": "IS", "Value": [54]},
        "162": {"vr": "IS", "Value": [17]},
        "163": {"vr": "IS", "Value": [52]},
        "164": {"vr": "IS", "Value": [13]},
        "165": {"vr": "IS", "Value": [51]},
        "166": {"vr": "IS", "Value": [39]},
        "167": {"vr": "IS", "Value": [28]},
        "168": {"vr": "IS", "Value": [10]},
        "169": {"vr": "IS", "Value": [21]},
        "170": {"vr": "IS", "Value": [6]},
        "171": {"vr": "IS", "Value": [20]},
        "172": {"vr": "IS", "Value": [5]},
        "173": {"vr": "IS", "Value": [64]},
        "174": {"vr": "IS", "Value": [15]},
        "175": {"vr": "IS", "Value": [22]},
        "176": {"vr": "IS", "Value": [3]},
        "177": {"vr": "IS", "Value": [54]},
        "178": {"vr": "IS", "Value": [62]},
        "179": {"vr": "IS", "Value": [53]},
        "180": {"vr": "IS", "Value": [14]},
        "181": {"vr": "IS", "Value": [22]},
        "182": {"vr": "IS", "Value": [51]},
        "183": {"vr": "IS", "Value": [42]},
        "184": {"vr": "IS", "Value": [4]},
        "185": {"vr": "IS", "Value": [19]},
        "186": {"vr": "IS", "Value": [50]},
        "187": {"vr": "IS", "Value": [50]},
        "188": {"vr": "IS", "Value": [64]},
        "189": {"vr": "IS", "Value": [27]},
        "190": {"vr": "IS", "Value": [36]},
        "191": {"vr": "IS", "Value": [1]},
        "192": {"vr": "IS", "Value": [48]},
        "193": {"vr": "IS", "Value": [8]},
        "194": {"vr": "IS", "Value": [63]},
        "195": {"vr": "IS", "Value": [37]},
        "196": {"vr": "IS", "Value": [42]},
        "197": {"vr": "IS", "Value": [27]},
        "198": {"vr": "IS", "Value": [1]},
        "199": {"vr": "IS", "Value": [42]},
        "200": {"vr": "IS", "Value": [3]},
        "201": {"vr": "IS", "Value": [46]},
        "202": {"vr": "IS", "Value": [49]},
        "203": {"vr": "IS", "Value": [19]},
        "204": {"vr": "IS", "Value": [29]},
        "205": {"vr": "IS", "Value": [50]},
        "206": {"vr": "IS", "Value": [52]},
        "207": {"vr": "IS", "Value": [39]},
        "208": {"vr": "IS", "Value": [4]},
        "209": {"vr": "IS", "Value": [9]},
        "210": {"vr": "IS", "Value": [34]},
        "211": {"vr": "IS", "Value": [38]},
        "212": {"vr": "IS", "Value": [59]},
        "213": {"vr": "IS", "Value": [60]},
        "214": {"vr": "IS", "Value": [48]},
        "215": {"vr": "IS", "Value": [40]},
        "216": {"vr": "IS", "Value": [15]},
        "217": {"vr": "IS", "Value": [13]},
        "218": {"vr": "IS", "Value": [63]},
        "219": {"vr": "IS", "Value": [30]},
        "220": {"vr": "IS", "Value": [24]},
        "221": {"vr": "IS", "Value": [35]},
        "222": {"vr": "IS", "Value": [36]},
        "223": {"vr": "IS", "Value": [4]},
        "224": {"vr": "IS", "Value": [5]},
        "225": {"vr": "IS", "Value": [6]},
        "226": {"vr": "IS", "Value": [42]},
        "227": {"vr": "IS", "Value": [12]},
        "228": {"vr": "IS", "Value": [38]},
        "229": {"vr": "IS", "Value": [21]},
        "230": {"vr": "IS", "Value": [14]},
        "231": {"vr": "IS", "Value": [13]},
        "232": {"vr": "IS", "Value": [51]},
        "233": {"vr": "IS", "Value": [52]},
        "234": {"vr": "IS", "Value": [21]},
        "235": {"vr": "IS", "Value": [52]},
        "236": {"vr": "IS", "Value": [60]},
        "237": {"vr": "IS", "Value": [4]},
        "238": {"vr": "IS", "Value": [35]},
        "239": {"vr": "IS", "Value": [53]},
        "240": {"vr": "IS", "Value": [27]},
        "241": {"vr": "IS", "Value": [35]},
        "242": {"vr": "IS", "Value": [43]},
        "243": {"vr": "IS", "Value": [23]},
        "244": {"vr": "IS", "Value": [63]},
        "245": {"vr": "IS", "Value": [57]},
        "246": {"vr": "IS", "Value": [1]},
        "247": {"vr": "IS", "Value": [9]},
        "248": {"vr": "IS", "Value": [38]},
        "249": {"vr": "IS", "Value": [39]},
        "250": {"vr": "IS", "Value": [44]},
        "251": {"vr": "IS", "Value": [20]},
        "252": {"vr": "IS", "Value": [36]},
        "253": {"vr": "IS", "Value": [37]},
        "254": {"vr": "IS", "Value": [40]},
        "255": {"vr": "IS", "Value": [25]},
        "256": {"vr": "IS", "Value": [56]},
        "257": {"vr": "IS", "Value": [62]},
        "258": {"vr": "IS", "Value": [27]},
        "259": {"vr": "IS", "Value": [26]},
        "260": {"vr": "IS", "Value": [11]},
        "261": {"vr": "IS", "Value": [55]},
        "262": {"vr": "IS", "Value": [20]},
        "263": {"vr": "IS", "Value": [8]},
        "264": {"vr": "IS", "Value": [58]},
        "265": {"vr": "IS", "Value": [64]},
        "266": {"vr": "IS", "Value": [65]},
        "267": {"vr": "IS", "Value": [24]},
        "268": {"vr": "IS", "Value": [9]},
        "269": {"vr": "IS", "Value": [47]},
        "270": {"vr": "IS", "Value": [67]},
        "271": {"vr": "IS", "Value": [50]},
        "272": {"vr": "IS", "Value": [62]},
        "273": {"vr": "IS", "Value": [32]},
        "274": {"vr": "IS", "Value": [10]},
        "275": {"vr": "IS", "Value": [12]},
        "276": {"vr": "IS", "Value": [50]},
        "277": {"vr": "IS", "Value": [61]},
        "278": {"vr": "IS", "Value": [24]},
        "279": {"vr": "IS", "Value": [20]},
        "280": {"vr": "IS", "Value": [41]},
        "281": {"vr": "IS", "Value": [27]},
        "282": {"vr": "IS", "Value": [4]},
        "283": {"vr": "IS", "Value": [32]},
        "284": {"vr": "IS", "Value": [63]},
        "285": {"vr": "IS", "Value": [50]},
        "286": {"vr": "IS", "Value": [36]},
        "287": {"vr": "IS", "Value": [8]},
        "288": {"vr": "IS", "Value": [15]},
        "289": {"vr": "IS", "Value": [65]},
        "290": {"vr": "IS", "Value": [67]},
        "291": {"vr": "IS", "Value": [27]},
        "292": {"vr": "IS", "Value": [32]},
        "293": {"vr": "IS", "Value": [16]},
        "294": {"vr": "IS", "Value": [63]},
        "295": {"vr": "IS", "Value": [44]},
        "296": {"vr": "IS", "Value": [18]},
        "297": {"vr": "IS", "Value": [3]},
        "298": {"vr": "IS", "Value": [3]},
        "299": {"vr": "IS", "Value": [2]},
        "300": {"vr": "IS", "Value": [64]},
        "301": {"vr": "IS", "Value": [67]},
        "302": {"vr": "IS", "Value": [42]},
        "303": {"vr": "IS", "Value": [30]},
        "304": {"vr": "IS", "Value": [31]},
        "305": {"vr": "IS", "Value": [14]},
        "306": {"vr": "IS", "Value": [61]},
        "307": {"vr": "IS", "Value": [30]},
        "308": {"vr": "IS", "Value": [60]},
        "309": {"vr": "IS", "Value": [39]},
        "310": {"vr": "IS", "Value": [37]},
        "311": {"vr": "IS", "Value": [12]},
        "312": {"vr": "IS", "Value": [44]},
        "313": {"vr": "IS", "Value": [67]},
        "314": {"vr": "IS", "Value": [65]},
        "315": {"vr": "IS", "Value": [15]},
        "316": {"vr": "IS", "Value": [12]},
        "317": {"vr": "IS", "Value": [60]},
        "318": {"vr": "IS", "Value": [24]},
        "319": {"vr": "IS", "Value": [37]},
        "320": {"vr": "IS", "Value": [43]},
        "321": {"vr": "IS", "Value": [15]},
        "322": {"vr": "IS", "Value": [62]},
        "323": {"vr": "IS", "Value": [31]},
        "324": {"vr": "IS", "Value": [30]},
        "325": {"vr": "IS", "Value": [15]},
        "326": {"vr": "IS", "Value": [6]},
        "327": {"vr": "IS", "Value": [42]},
        "328": {"vr": "IS", "Value": [55]},
        "329": {"vr": "IS", "Value": [42]},
        "330": {"vr": "IS", "Value": [4]},
        "331": {"vr": "IS", "Value": [32]},
        "332": {"vr": "IS", "Value": [14]},
        "333": {"vr": "IS", "Value": [51]},
        "334": {"vr": "IS", "Value": [28]},
        "335": {"vr": "IS", "Value": [21]},
        "336": {"vr": "IS", "Value": [16]},
        "337": {"vr": "IS", "Value": [27]},
        "338": {"vr": "IS", "Value": [4]},
        "339": {"vr": "IS", "Value": [24]},
        "340": {"vr": "IS", "Value": [10]},
        "341": {"vr": "IS", "Value": [65]},
        "342": {"vr": "IS", "Value": [20]},
        "343": {"vr": "IS", "Value": [58]},
        "344": {"vr": "IS", "Value": [25]},
        "345": {"vr": "IS", "Value": [48]},
        "346": {"vr": "IS", "Value": [9]},
        "347": {"vr": "IS", "Value": [13]},
        "348": {"vr": "IS", "Value": [33]},
        "349": {"vr": "IS", "Value": [1]},
        "350": {"vr": "IS", "Value": [45]},
        "351": {"vr": "IS", "Value": [61]},
        "352": {"vr": "IS", "Value": [33]},
        "353": {"vr": "IS", "Value": [33]},
        "354": {"vr": "IS", "Value": [30]},
        "355": {"vr": "IS", "Value": [57]},
        "356": {"vr": "IS", "Value": [18]},
        "357": {"vr": "IS", "Value": [3]},
        "358": {"vr": "IS", "Value": [50]},
        "359": {"vr": "IS", "Value": [14]},
        "360": {"vr": "IS", "Value": [4]},
        "361": {"vr": "IS", "Value": [34]},
        "362": {"vr": "IS", "Value": [49]},
        "363": {"vr": "IS", "Value": [34]},
        "364": {"vr": "IS", "Value": [57]},
        "365": {"vr": "IS", "Value": [35]},
        "366": {"vr": "IS", "Value": [64]},
        "367": {"vr": "IS", "Value": [13]},
        "368": {"vr": "IS", "Value": [12]},
        "369": {"vr": "IS", "Value": [55]},
        "370": {"vr": "IS", "Value": [50]},
        "371": {"vr": "IS", "Value": [49]},
        "372": {"vr": "IS", "Value": [47]},
        "373": {"vr": "IS", "Value": [41]},
        "374": {"vr": "IS", "Value": [30]},
        "375": {"vr": "IS", "Value": [41]},
        "376": {"vr": "IS", "Value": [32]},
        "377": {"vr": "IS", "Value": [55]},
        "378": {"vr": "IS", "Value": [29]},
        "379": {"vr": "IS", "Value": [17]},
        "380": {"vr": "IS", "Value": [27]},
        "381": {"vr": "IS", "Value": [16]},
        "382": {"vr": "IS", "Value": [25]},
        "383": {"vr": "IS", "Value": [1]},
        "384": {"vr": "IS", "Value": [34]},
        "385": {"vr": "IS", "Value": [59]},
        "386": {"vr": "IS", "Value": [59]},
        "387": {"vr": "IS", "Value": [41]},
        "388": {"vr": "IS", "Value": [61]},
        "389": {"vr": "IS", "Value": [28]},
        "390": {"vr": "IS", "Value": [13]},
        "391": {"vr": "IS", "Value": [60]},
        "392": {"vr": "IS", "Value": [21]},
        "393": {"vr": "IS", "Value": [42]},
        "394": {"vr": "IS", "Value": [40]},
        "395": {"vr": "IS", "Value": [33]},
        "396": {"vr": "IS", "Value": [23]},
        "397": {"vr": "IS", "Value": [33]},
        "398": {"vr": "IS", "Value": [6]},
        "399": {"vr": "IS", "Value": [12]},
        "400": {"vr": "IS", "Value": [28]},
        "401": {"vr": "IS", "Value": [11]},
        "402": {"vr": "IS", "Value": [19]},
        "403": {"vr": "IS", "Value": [38]},
        "404": {"vr": "IS", "Value": [6]},
        "405": {"vr": "IS", "Value": [49]},
        "406": {"vr": "IS", "Value": [15]},
        "407": {"vr": "IS", "Value": [20]},
        "408": {"vr": "IS", "Value": [35]},
        "409": {"vr": "IS", "Value": [40]},
        "410": {"vr": "IS", "Value": [17]},
        "411": {"vr": "IS", "Value": [58]},
        "412": {"vr": "IS", "Value": [3]},
        "413": {"vr": "IS", "Value": [13]},
        "414": {"vr": "IS", "Value": [6]},
        "415": {"vr": "IS", "Value": [54]},
        "416": {"vr": "IS", "Value": [32]},
        "417": {"vr": "IS", "Value": [7]},
        "418": {"vr": "IS", "Value": [1]},
        "419": {"vr": "IS", "Value": [6]},
        "420": {"vr": "IS", "Value": [65]},
        "421": {"vr": "IS", "Value": [9]},
        "422": {"vr": "IS", "Value": [18]},
        "423": {"vr": "IS", "Value": [57]},
        "424": {"vr": "IS", "Value": [45]},
        "425": {"vr": "IS", "Value": [63]},
        "426": {"vr": "IS", "Value": [47]},
        "427": {"vr": "IS", "Value": [44]},
        "428": {"vr": "IS", "Value": [61]},
        "429": {"vr": "IS", "Value": [47]},
        "430": {"vr": "IS", "Value": [37]},
        "431": {"vr": "IS", "Value": [11]},
        "432": {"vr": "IS", "Value": [63]},
        "433": {"vr": "IS", "Value": [43]},
        "434": {"vr": "IS", "Value": [14]},
        "435": {"vr": "IS", "Value": [65]},
        "436": {"vr": "IS", "Value": [2]},
        "437": {"vr": "IS", "Value": [22]},
        "438": {"vr": "IS", "Value": [40]},
        "439": {"vr": "IS", "Value": [54]},
        "440": {"vr": "IS", "Value": [61]},
        "441": {"vr": "IS", "Value": [9]},
        "442": {"vr": "IS", "Value": [11]},
        "443": {"vr": "IS", "Value": [58]},
        "444": {"vr": "IS", "Value": [44]},
        "445": {"vr": "IS", "Value": [45]},
        "446": {"vr": "IS", "Value": [53]},
        "447": {"vr": "IS", "Value": [2]},
        "448": {"vr": "IS", "Value": [56]},
        "449": {"vr": "IS", "Value": [38]},
        "450": {"vr": "IS", "Value": [60]},
        "451": {"vr": "IS", "Value": [14]},
        "452": {"vr": "IS", "Value": [51]},
        "453": {"vr": "IS", "Value": [4]},
        "454": {"vr": "IS", "Value": [21]},
        "455": {"vr": "IS", "Value": [40]},
        "456": {"vr": "IS", "Value": [20]},
        "457": {"vr": "IS", "Value": [22]},
        "458": {"vr": "IS", "Value": [28]},
        "459": {"vr": "IS", "Value": [20]},
        "460": {"vr": "IS", "Value": [24]},
        "461": {"vr": "IS", "Value": [40]},
        "462": {"vr": "IS", "Value": [30]},
        "463": {"vr": "IS", "Value": [41]},
        "464": {"vr": "IS", "Value": [55]},
        "465": {"vr": "IS", "Value": [19]},
        "466": {"vr": "IS", "Value": [13]},
        "467": {"vr": "IS", "Value": [35]},
        "468": {"vr": "IS", "Value": [4]},
        "469": {"vr": "IS", "Value": [67]},
        "470": {"vr": "IS", "Value": [38]},
        "471": {"vr": "IS", "Value": [37]},
        "472": {"vr": "IS", "Value": [14]},
        "473": {"vr": "IS", "Value": [60]},
        "474": {"vr": "IS", "Value": [58]},
        "475": {"vr": "IS", "Value": [1]},
        "476": {"vr": "IS", "Value": [59]},
        "477": {"vr": "IS", "Value": [16]},
        "478": {"vr": "IS", "Value": [62]},
        "479": {"vr": "IS", "Value": [54]},
        "480": {"vr": "IS", "Value": [32]},
        "481": {"vr": "IS", "Value": [2]},
        "482": {"vr": "IS", "Value": [14]},
        "483": {"vr": "IS", "Value": [56]},
        "484": {"vr": "IS", "Value": [42]},
        "485": {"vr": "IS", "Value": [49]},
        "486": {"vr": "IS", "Value": [22]},
        "487": {"vr": "IS", "Value": [25]},
        "488": {"vr": "IS", "Value": [26]},
        "489": {"vr": "IS", "Value": [53]},
        "490": {"vr": "IS", "Value": [37]},
        "491": {"vr": "IS", "Value": [32]},
        "492": {"vr": "IS", "Value": [16]},
        "493": {"vr": "IS", "Value": [54]},
        "494": {"vr": "IS", "Value": [57]},
        "495": {"vr": "IS", "Value": [22]},
        "496": {"vr": "IS", "Value": [33]},
        "497": {"vr": "IS", "Value": [1]},
        "498": {"vr": "IS", "Value": [63]},
        "499": {"vr": "IS", "Value": [6]},
        "500": {"vr": "IS", "Value": [8]},
        "501": {"vr": "IS", "Value": [67]},
        "502": {"vr": "IS", "Value": [36]},
        "503": {"vr": "IS", "Value": [27]},
        "504": {"vr": "IS", "Value": [24]},
        "505": {"vr": "IS", "Value": [6]},
        "506": {"vr": "IS", "Value": [15]},
        "507": {"vr": "IS", "Value": [12]},
        "508": {"vr": "IS", "Value": [18]},
        "509": {"vr": "IS", "Value": [31]},
        "510": {"vr": "IS", "Value": [60]},
        "511": {"vr": "IS", "Value": [30]},
        "512": {"vr": "IS", "Value": [19]},
        "513": {"vr": "IS", "Value": [49]},
        "514": {"vr": "IS", "Value": [12]},
        "515": {"vr": "IS", "Value": [23]},
        "516": {"vr": "IS", "Value": [2]},
        "517": {"vr": "IS", "Value": [59]},
        "518": {"vr": "IS", "Value": [26]},
        "519": {"vr": "IS", "Value": [14]},
        "520": {"vr": "IS", "Value": [45]},
        "521": {"vr": "IS", "Value": [3]},
        "522": {"vr": "IS", "Value": [31]},
        "523": {"vr": "IS", "Value": [66]},
        "524": {"vr": "IS", "Value": [14]},
        "525": {"vr": "IS", "Value": [32]},
        "526": {"vr": "IS", "Value": [63]},
        "527": {"vr": "IS", "Value": [61]},
        "528": {"vr": "IS", "Value": [60]},
        "529": {"vr": "IS", "Value": [3]},
        "530": {"vr": "IS", "Value": [16]},
        "531": {"vr": "IS", "Value": [23]},
        "532": {"vr": "IS", "Value": [3]},
        "533": {"vr": "IS", "Value": [17]},
        "534": {"vr": "IS", "Value": [36]},
        "535": {"vr": "IS", "Value": [49]},
        "536": {"vr": "IS", "Value": [46]},
        "537": {"vr": "IS", "Value": [35]},
        "538": {"vr": "IS", "Value": [40]},
        "539": {"vr": "IS", "Value": [1]},
        "540": {"vr": "IS", "Value": [21]},
        "541": {"vr": "IS", "Value": [62]},
        "542": {"vr": "IS", "Value": [34]},
        "543": {"vr": "IS", "Value": [66]},
        "544": {"vr": "IS", "Value": [12]},
        "545": {"vr": "IS", "Value": [30]},
        "546": {"vr": "IS", "Value": [61]},
        "547": {"vr": "IS", "Value": [61]},
        "548": {"vr": "IS", "Value": [23]},
        "549": {"vr": "IS", "Value": [43]},
        "550": {"vr": "IS", "Value": [39]},
        "551": {"vr": "IS", "Value": [54]},
        "552": {"vr": "IS", "Value": [40]},
        "553": {"vr": "IS", "Value": [12]},
        "554": {"vr": "IS", "Value": [34]},
        "555": {"vr": "IS", "Value": [1]},
        "556": {"vr": "IS", "Value": [17]},
        "557": {"vr": "IS", "Value": [64]},
        "558": {"vr": "IS", "Value": [41]},
        "559": {"vr": "IS", "Value": [53]},
        "560": {"vr": "IS", "Value": [40]},
        "561": {"vr": "IS", "Value": [59]},
        "562": {"vr": "IS", "Value": [47]},
        "563": {"vr": "IS", "Value": [20]},
        "564": {"vr": "IS", "Value": [40]},
        "565": {"vr": "IS", "Value": [27]},
        "566": {"vr": "IS", "Value": [43]},
        "567": {"vr": "IS", "Value": [23]},
        "568": {"vr": "IS", "Value": [46]},
        "569": {"vr": "IS", "Value": [29]},
        "570": {"vr": "IS", "Value": [22]},
        "571": {"vr": "IS", "Value": [55]},
        "572": {"vr": "IS", "Value": [59]},
        "573": {"vr": "IS", "Value": [62]},
        "574": {"vr": "IS", "Value": [60]},
        "575": {"vr": "IS", "Value": [42]},
        "576": {"vr": "IS", "Value": [43]},
        "577": {"vr": "IS", "Value": [58]},
        "578": {"vr": "IS", "Value": [35]},
        "579": {"vr": "IS", "Value": [54]},
        "580": {"vr": "IS", "Value": [54]},
        "581": {"vr": "IS", "Value": [46]},
        "582": {"vr": "IS", "Value": [35]},
        "583": {"vr": "IS", "Value": [43]},
        "584": {"vr": "IS", "Value": [49]},
        "585": {"vr": "IS", "Value": [1]},
        "586": {"vr": "IS", "Value": [58]},
        "587": {"vr": "IS", "Value": [12]},
        "588": {"vr": "IS", "Value": [16]},
        "589": {"vr": "IS", "Value": [57]},
        "590": {"vr": "IS", "Value": [26]},
        "591": {"vr": "IS", "Value": [38]},
        "592": {"vr": "IS", "Value": [59]},
        "593": {"vr": "IS", "Value": [51]},
        "594": {"vr": "IS", "Value": [2]},
        "595": {"vr": "IS", "Value": [3]},
        "596": {"vr": "IS", "Value": [32]},
        "597": {"vr": "IS", "Value": [27]},
        "598": {"vr": "IS", "Value": [57]},
        "599": {"vr": "IS", "Value": [18]},
        "600": {"vr": "IS", "Value": [23]},
        "601": {"vr": "IS", "Value": [46]},
        "602": {"vr": "IS", "Value": [33]},
        "603": {"vr": "IS", "Value": [62]},
        "604": {"vr": "IS", "Value": [8]},
        "605": {"vr": "IS", "Value": [63]},
        "606": {"vr": "IS", "Value": [51]},
        "607": {"vr": "IS", "Value": [43]},
        "608": {"vr": "IS", "Value": [61]},
        "609": {"vr": "IS", "Value": [49]},
        "610": {"vr": "IS", "Value": [64]},
        "611": {"vr": "IS", "Value": [34]},
        "612": {"vr": "IS", "Value": [3]},
        "613": {"vr": "IS", "Value": [53]},
        "614": {"vr": "IS", "Value": [33]},
        "615": {"vr": "IS", "Value": [46]},
        "616": {"vr": "IS", "Value": [48]},
        "617": {"vr": "IS", "Value": [7]},
        "618": {"vr": "IS", "Value": [13]},
        "619": {"vr": "IS", "Value": [36]},
        "620": {"vr": "IS", "Value": [36]},
        "621": {"vr": "IS", "Value": [10]},
        "622": {"vr": "IS", "Value": [2]},
        "623": {"vr": "IS", "Value": [60]},
        "624": {"vr": "IS", "Value": [67]},
        "625": {"vr": "IS", "Value": [54]},
        "626": {"vr": "IS", "Value": [16]},
        "627": {"vr": "IS", "Value": [13]},
        "628": {"vr": "IS", "Value": [3]},
        "629": {"vr": "IS", "Value": [28]},
        "630": {"vr": "IS", "Value": [50]},
        "631": {"vr": "IS", "Value": [20]},
        "632": {"vr": "IS", "Value": [7]},
        "633": {"vr": "IS", "Value": [36]},
        "634": {"vr": "IS", "Value": [21]},
        "635": {"vr": "IS", "Value": [51]},
        "636": {"vr": "IS", "Value": [12]},
        "637": {"vr": "IS", "Value": [14]},
        "638": {"vr": "IS", "Value": [47]},
        "639": {"vr": "IS", "Value": [65]},
        "640": {"vr": "IS", "Value": [9]},
        "641": {"vr": "IS", "Value": [8]},
        "642": {"vr": "IS", "Value": [20]},
        "643": {"vr": "IS", "Value": [50]},
        "644": {"vr": "IS", "Value": [55]},
        "645": {"vr": "IS", "Value": [29]},
        "646": {"vr": "IS", "Value": [55]},
        "647": {"vr": "IS", "Value": [41]},
        "648": {"vr": "IS", "Value": [62]},
        "649": {"vr": "IS", "Value": [28]},
        "650": {"vr": "IS", "Value": [9]},
        "651": {"vr": "IS", "Value": [18]},
        "652": {"vr": "IS", "Value": [55]},
        "653": {"vr": "IS", "Value": [17]},
        "654": {"vr": "IS", "Value": [44]},
        "655": {"vr": "IS", "Value": [22]},
        "656": {"vr": "IS", "Value": [43]},
        "657": {"vr": "IS", "Value": [4]},
        "658": {"vr": "IS", "Value": [48]},
        "659": {"vr": "IS", "Value": [10]},
        "660": {"vr": "IS", "Value": [37]},
        "661": {"vr": "IS", "Value": [55]},
        "662": {"vr": "IS", "Value": [11]},
        "663": {"vr": "IS", "Value": [67]},
        "664": {"vr": "IS", "Value": [47]},
        "665": {"vr": "IS", "Value": [47]},
        "666": {"vr": "IS", "Value": [32]},
        "667": {"vr": "IS", "Value": [9]},
        "668": {"vr": "IS", "Value": [34]},
        "669": {"vr": "IS", "Value": [3]},
        "670": {"vr": "IS", "Value": [8]},
        "671": {"vr": "IS", "Value": [41]},
        "672": {"vr": "IS", "Value": [61]},
        "673": {"vr": "IS", "Value": [6]},
        "674": {"vr": "IS", "Value": [55]},
        "675": {"vr": "IS", "Value": [26]},
        "676": {"vr": "IS", "Value": [24]},
        "677": {"vr": "IS", "Value": [27]},
        "678": {"vr": "IS", "Value": [10]},
        "679": {"vr": "IS", "Value": [34]},
        "680": {"vr": "IS", "Value": [44]},
        "681": {"vr": "IS", "Value": [65]},
        "682": {"vr": "IS", "Value": [52]},
        "683": {"vr": "IS", "Value": [64]},
        "684": {"vr": "IS", "Value": [49]},
        "685": {"vr": "IS", "Value": [7]},
        "686": {"vr": "IS", "Value": [27]},
        "687": {"vr": "IS", "Value": [45]},
        "688": {"vr": "IS", "Value": [31]},
        "689": {"vr": "IS", "Value": [2]},
        "690": {"vr": "IS", "Value": [34]},
        "691": {"vr": "IS", "Value": [4]},
        "692": {"vr": "IS", "Value": [5]},
        "693": {"vr": "IS", "Value": [5]},
        "694": {"vr": "IS", "Value": [30]},
        "695": {"vr": "IS", "Value": [6]},
        "696": {"vr": "IS", "Value": [50]},
        "697": {"vr": "IS", "Value": [28]},
        "698": {"vr": "IS", "Value": [41]},
        "699": {"vr": "IS", "Value": [23]},
        "700": {"vr": "IS", "Value": [6]},
        "701": {"vr": "IS", "Value": [50]},
        "702": {"vr": "IS", "Value": [4]},
        "703": {"vr": "IS", "Value": [53]},
        "704": {"vr": "IS", "Value": [20]},
        "705": {"vr": "IS", "Value": [21]},
        "706": {"vr": "IS", "Value": [42]},
        "707": {"vr": "IS", "Value": [12]},
        "708": {"vr": "IS", "Value": [24]},
        "709": {"vr": "IS", "Value": [52]},
        "710": {"vr": "IS", "Value": [54]},
        "711": {"vr": "IS", "Value": [48]},
        "712": {"vr": "IS", "Value": [2]},
        "713": {"vr": "IS", "Value": [39]},
        "714": {"vr": "IS", "Value": [23]},
        "715": {"vr": "IS", "Value": [45]},
        "716": {"vr": "IS", "Value": [48]},
        "717": {"vr": "IS", "Value": [55]},
        "718": {"vr": "IS", "Value": [60]},
        "719": {"vr": "IS", "Value": [32]},
        "720": {"vr": "IS", "Value": [7]},
        "721": {"vr": "IS", "Value": [40]},
        "722": {"vr": "IS", "Value": [11]},
        "723": {"vr": "IS", "Value": [64]},
        "724": {"vr": "IS", "Value": [51]},
        "725": {"vr": "IS", "Value": [3]},
        "726": {"vr": "IS", "Value": [62]},
        "727": {"vr": "IS", "Value": [60]},
        "728": {"vr": "IS", "Value": [3]},
        "729": {"vr": "IS", "Value": [62]},
        "730": {"vr": "IS", "Value": [35]},
        "731": {"vr": "IS", "Value": [27]},
        "732": {"vr": "IS", "Value": [12]},
        "733": {"vr": "IS", "Value": [64]},
        "734": {"vr": "IS", "Value": [5]},
        "735": {"vr": "IS", "Value": [26]},
        "736": {"vr": "IS", "Value": [16]},
        "737": {"vr": "IS", "Value": [8]},
        "738": {"vr": "IS", "Value": [54]},
        "739": {"vr": "IS", "Value": [2]},
        "740": {"vr": "IS", "Value": [11]},
        "741": {"vr": "IS", "Value": [6]},
        "742": {"vr": "IS", "Value": [13]},
        "743": {"vr": "IS", "Value": [57]},
        "744": {"vr": "IS", "Value": [40]},
        "745": {"vr": "IS", "Value": [13]},
        "746": {"vr": "IS", "Value": [13]},
        "747": {"vr": "IS", "Value": [39]},
        "748": {"vr": "IS", "Value": [44]},
        "749": {"vr": "IS", "Value": [47]},
        "750": {"vr": "IS", "Value": [66]},
        "751": {"vr": "IS", "Value": [20]},
        "752": {"vr": "IS", "Value": [51]},
        "753": {"vr": "IS", "Value": [8]},
        "754": {"vr": "IS", "Value": [47]},
        "755": {"vr": "IS", "Value": [32]},
        "756": {"vr": "IS", "Value": [22]},
        "757": {"vr": "IS", "Value": [67]},
        "758": {"vr": "IS", "Value": [19]},
        "759": {"vr": "IS", "Value": [5]},
        "760": {"vr": "IS", "Value": [16]},
        "761": {"vr": "IS", "Value": [18]},
        "762": {"vr": "IS", "Value": [64]},
        "763": {"vr": "IS", "Value": [44]},
        "764": {"vr": "IS", "Value": [33]},
        "765": {"vr": "IS", "Value": [14]},
        "766": {"vr": "IS", "Value": [15]},
        "767": {"vr": "IS", "Value": [57]},
        "768": {"vr": "IS", "Value": [38]},
        "769": {"vr": "IS", "Value": [50]},
        "770": {"vr": "IS", "Value": [22]},
        "771": {"vr": "IS", "Value": [67]},
        "772": {"vr": "IS", "Value": [27]},
        "773": {"vr": "IS", "Value": [62]},
        "774": {"vr": "IS", "Value": [18]},
        "775": {"vr": "IS", "Value": [15]},
        "776": {"vr": "IS", "Value": [25]},
        "777": {"vr": "IS", "Value": [34]},
        "778": {"vr": "IS", "Value": [65]},
        "779": {"vr": "IS", "Value": [4]},
        "780": {"vr": "IS", "Value": [39]},
        "781": {"vr": "IS", "Value": [26]},
        "782": {"vr": "IS", "Value": [62]},
        "783": {"vr": "IS", "Value": [48]},
        "784": {"vr": "IS", "Value": [2]},
        "785": {"vr": "IS", "Value": [46]},
        "786": {"vr": "IS", "Value": [39]},
        "787": {"vr": "IS", "Value": [13]},
        "788": {"vr": "IS", "Value": [56]},
        "789": {"vr": "IS", "Value": [21]},
        "790": {"vr": "IS", "Value": [61]},
        "791": {"vr": "IS", "Value": [56]},
        "792": {"vr": "IS", "Value": [5]},
        "793": {"vr": "IS", "Value": [47]},
        "794": {"vr": "IS", "Value": [21]},
        "795": {"vr": "IS", "Value": [27]},
        "796": {"vr": "IS", "Value": [18]},
        "797": {"vr": "IS", "Value": [41]},
        "798": {"vr": "IS", "Value": [47]},
        "799": {"vr": "IS", "Value": [4]},
        "800": {"vr": "IS", "Value": [10]},
        "801": {"vr": "IS", "Value": [2]},
        "802": {"vr": "IS", "Value": [8]},
        "803": {"vr": "IS", "Value": [52]},
        "804": {"vr": "IS", "Value": [51]},
        "805": {"vr": "IS", "Value": [20]},
        "806": {"vr": "IS", "Value": [41]},
        "807": {"vr": "IS", "Value": [50]},
        "808": {"vr": "IS", "Value": [19]},
        "809": {"vr": "IS", "Value": [36]},
        "810": {"vr": "IS", "Value": [34]},
        "811": {"vr": "IS", "Value": [48]},
        "812": {"vr": "IS", "Value": [28]},
        "813": {"vr": "IS", "Value": [37]},
        "814": {"vr": "IS", "Value": [41]},
        "815": {"vr": "IS", "Value": [64]},
        "816": {"vr": "IS", "Value": [56]},
        "817": {"vr": "IS", "Value": [65]},
        "818": {"vr": "IS", "Value": [37]},
        "819": {"vr": "IS", "Value": [30]},
        "820": {"vr": "IS", "Value": [56]},
        "821": {"vr": "IS", "Value": [55]},
        "822": {"vr": "IS", "Value": [24]},
        "823": {"vr": "IS", "Value": [42]},
        "824": {"vr": "IS", "Value": [53]},
        "825": {"vr": "IS", "Value": [42]},
        "826": {"vr": "IS", "Value": [21]},
        "827": {"vr": "IS", "Value": [67]},
        "828": {"vr": "IS", "Value": [31]},
        "829": {"vr": "IS", "Value": [45]},
        "830": {"vr": "IS", "Value": [7]},
        "831": {"vr": "IS", "Value": [22]},
        "832": {"vr": "IS", "Value": [18]},
        "833": {"vr": "IS", "Value": [10]},
        "834": {"vr": "IS", "Value": [8]},
        "835": {"vr": "IS", "Value": [66]},
        "836": {"vr": "IS", "Value": [22]},
        "837": {"vr": "IS", "Value": [8]},
        "838": {"vr": "IS", "Value": [5]},
        "839": {"vr": "IS", "Value": [15]},
        "840": {"vr": "IS", "Value": [55]},
        "841": {"vr": "IS", "Value": [46]},
        "842": {"vr": "IS", "Value": [6]},
        "843": {"vr": "IS", "Value": [33]},
        "844": {"vr": "IS", "Value": [19]},
        "845": {"vr": "IS", "Value": [4]},
        "846": {"vr": "IS", "Value": [34]},
        "847": {"vr": "IS", "Value": [47]},
        "848": {"vr": "IS", "Value": [32]},
        "849": {"vr": "IS", "Value": [8]},
        "850": {"vr": "IS", "Value": [45]},
        "851": {"vr": "IS", "Value": [37]},
        "852": {"vr": "IS", "Value": [37]},
        "853": {"vr": "IS", "Value": [49]},
        "854": {"vr": "IS", "Value": [17]},
        "855": {"vr": "IS", "Value": [16]},
        "856": {"vr": "IS", "Value": [29]},
        "857": {"vr": "IS", "Value": [41]},
        "858": {"vr": "IS", "Value": [19]},
        "859": {"vr": "IS", "Value": [7]},
        "860": {"vr": "IS", "Value": [24]},
        "861": {"vr": "IS", "Value": [67]},
        "862": {"vr": "IS", "Value": [59]},
        "863": {"vr": "IS", "Value": [43]},
        "864": {"vr": "IS", "Value": [66]},
        "865": {"vr": "IS", "Value": [26]},
        "866": {"vr": "IS", "Value": [48]},
        "867": {"vr": "IS", "Value": [12]},
        "868": {"vr": "IS", "Value": [45]},
        "869": {"vr": "IS", "Value": [13]},
        "870": {"vr": "IS", "Value": [23]},
        "871": {"vr": "IS", "Value": [29]},
        "872": {"vr": "IS", "Value": [3]},
        "873": {"vr": "IS", "Value": [58]},
        "874": {"vr": "IS", "Value": [46]},
        "875": {"vr": "IS", "Value": [1]},
        "876": {"vr": "IS", "Value": [13]},
        "877": {"vr": "IS", "Value": [7]},
        "878": {"vr": "IS", "Value": [59]},
        "879": {"vr": "IS", "Value": [4]},
        "880": {"vr": "IS", "Value": [6]},
        "881": {"vr": "IS", "Value": [14]},
        "882": {"vr": "IS", "Value": [7]},
        "883": {"vr": "IS", "Value": [14]},
        "884": {"vr": "IS", "Value": [57]},
        "885": {"vr": "IS", "Value": [67]},
        "886": {"vr": "IS", "Value": [15]},
        "887": {"vr": "IS", "Value": [32]},
        "888": {"vr": "IS", "Value": [13]},
        "889": {"vr": "IS", "Value": [6]},
        "890": {"vr": "IS", "Value": [19]},
        "891": {"vr": "IS", "Value": [33]},
        "892": {"vr": "IS", "Value": [62]},
        "893": {"vr": "IS", "Value": [38]},
        "894": {"vr": "IS", "Value": [18]},
        "895": {"vr": "IS", "Value": [33]},
        "896": {"vr": "IS", "Value": [10]},
        "897": {"vr": "IS", "Value": [33]},
        "898": {"vr": "IS", "Value": [36]},
        "899": {"vr": "IS", "Value": [26]},
        "900": {"vr": "IS", "Value": [30]},
        "901": {"vr": "IS", "Value": [7]},
        "902": {"vr": "IS", "Value": [37]},
        "903": {"vr": "IS", "Value": [66]},
        "904": {"vr": "IS", "Value": [8]},
        "905": {"vr": "IS", "Value": [16]},
        "906": {"vr": "IS", "Value": [8]},
        "907": {"vr": "IS", "Value": [47]},
        "908": {"vr": "IS", "Value": [33]},
        "909": {"vr": "IS", "Value": [65]},
        "910": {"vr": "IS", "Value": [41]},
        "911": {"vr": "IS", "Value": [27]},
        "912": {"vr": "IS", "Value": [63]},
        "913": {"vr": "IS", "Value": [41]},
        "914": {"vr": "IS", "Value": [16]},
        "915": {"vr": "IS", "Value": [38]},
        "916": {"vr": "IS", "Value": [64]},
        "917": {"vr": "IS", "Value": [46]},
        "918": {"vr": "IS", "Value": [53]},
        "919": {"vr": "IS", "Value": [1]},
        "920": {"vr": "IS", "Value": [11]},
        "921": {"vr": "IS", "Value": [20]},
        "922": {"vr": "IS", "Value": [53]},
        "923": {"vr": "IS", "Value": [50]},
        "924": {"vr": "IS", "Value": [1]},
        "925": {"vr": "IS", "Value": [5]},
        "926": {"vr": "IS", "Value": [67]},
        "927": {"vr": "IS", "Value": [47]},
        "928": {"vr": "IS", "Value": [58]},
        "929": {"vr": "IS", "Value": [37]},
        "930": {"vr": "IS", "Value": [31]},
        "931": {"vr": "IS", "Value": [33]},
        "932": {"vr": "IS", "Value": [67]},
        "933": {"vr": "IS", "Value": [42]},
        "934": {"vr": "IS", "Value": [4]},
        "935": {"vr": "IS", "Value": [29]},
        "936": {"vr": "IS", "Value": [45]},
        "937": {"vr": "IS", "Value": [29]},
        "938": {"vr": "IS", "Value": [66]},
        "939": {"vr": "IS", "Value": [26]},
        "940": {"vr": "IS", "Value": [54]},
        "941": {"vr": "IS", "Value": [54]},
        "942": {"vr": "IS", "Value": [14]},
        "943": {"vr": "IS", "Value": [29]},
        "944": {"vr": "IS", "Value": [43]},
        "945": {"vr": "IS", "Value": [61]},
        "946": {"vr": "IS", "Value": [42]},
        "947": {"vr": "IS", "Value": [28]},
        "948": {"vr": "IS", "Value": [45]},
        "949": {"vr": "IS", "Value": [22]},
        "950": {"vr": "IS", "Value": [53]},
        "951": {"vr": "IS", "Value": [28]},
        "952": {"vr": "IS", "Value": [15]},
        "953": {"vr": "IS", "Value": [36]},
        "954": {"vr": "IS", "Value": [48]},
        "955": {"vr": "IS", "Value": [7]},
        "956": {"vr": "IS", "Value": [45]},
        "957": {"vr": "IS", "Value": [27]},
        "958": {"vr": "IS", "Value": [53]},
        "959": {"vr": "IS", "Value": [22]},
        "960": {"vr": "IS", "Value": [29]},
        "961": {"vr": "IS", "Value": [34]},
        "962": {"vr": "IS", "Value": [54]},
        "963": {"vr": "IS", "Value": [47]},
        "964": {"vr": "IS", "Value": [11]},
        "965": {"vr": "IS", "Value": [18]},
        "966": {"vr": "IS", "Value": [28]},
        "967": {"vr": "IS", "Value": [61]},
        "968": {"vr": "IS", "Value": [14]},
        "969": {"vr": "IS", "Value": [14]},
        "970": {"vr": "IS", "Value": [3]},
        "971": {"vr": "IS", "Value": [15]},
        "972": {"vr": "IS", "Value": [61]},
        "973": {"vr": "IS", "Value": [57]},
        "974": {"vr": "IS", "Value": [37]},
        "975": {"vr": "IS", "Value": [44]},
        "976": {"vr": "IS", "Value": [19]},
        "977": {"vr": "IS", "Value": [31]},
        "978": {"vr": "IS", "Value": [67]},
        "979": {"vr": "IS", "Value": [46]},
        "980": {"vr": "IS", "Value": [47]},
        "981": {"vr": "IS", "Value": [58]},
        "982": {"vr": "IS", "Value": [27]},
        "983": {"vr": "IS", "Value": [45]},
        "984": {"vr": "IS", "Value": [53]},
        "985": {"vr": "IS", "Value": [31]},
        "986": {"vr": "IS", "Value": [24]},
        "987": {"vr": "IS", "Value": [3]},
        "988": {"vr": "IS", "Value": [57]},
        "989": {"vr": "IS", "Value": [29]},
        "990": {"vr": "IS", "Value": [31]},
        "991": {"vr": "IS", "Value": [61]},
        "992": {"vr": "IS", "Value": [21]},
        "993": {"vr": "IS", "Value": [63]},
        "994": {"vr": "IS", "Value": [11]},
        "995": {"vr": "IS", "Value": [54]},
        "996": {"vr": "IS", "Value": [67]},
        "997": {"vr": "IS", "Value": [49]},
        "998": {"vr": "IS", "Value": [53]},
        "999": {"vr": "IS", "Value": [64]},
        "1000": {"vr": "IS", "Value": [33]},
        "1001": {"vr": "IS", "Value": [64]},
        "1002": {"vr": "IS", "Value": [6]},
        "1003": {"vr": "IS", "Value": [17]},
        "1004": {"vr": "IS", "Value": [58]},
        "1005": {"vr": "IS", "Value": [46]},
        "1006": {"vr": "IS", "Value": [50]},
        "1007": {"vr": "IS", "Value": [15]},
        "1008": {"vr": "IS", "Value": [8]},
        "1009": {"vr": "IS", "Value": [15]},
        "1010": {"vr": "IS", "Value": [58]},
        "1011": {"vr": "IS", "Value": [66]},
        "1012": {"vr": "IS", "Value": [49]},
        "1013": {"vr": "IS", "Value": [50]},
        "1014": {"vr": "IS", "Value": [46]},
        "1015": {"vr": "IS", "Value": [67]},
        "1016": {"vr": "IS", "Value": [23]},
        "1017": {"vr": "IS", "Value": [65]},
        "1018": {"vr": "IS", "Value": [19]},
        "1019": {"vr": "IS", "Value": [59]},
        "1020": {"vr": "IS", "Value": [48]},
        "1021": {"vr": "IS", "Value": [63]},
        "1022": {"vr": "IS", "Value": [25]},
        "1023": {"vr": "IS", "Value": [28]},
        "1024": {"vr": "IS", "Value": [49]},
        "1025": {"vr": "IS", "Value": [4]},
        "1026": {"vr": "IS", "Value": [5]},
        "1027": {"vr": "IS", "Value": [48]},
        "1028": {"vr": "IS", "Value": [58]},
        "1029": {"vr": "IS", "Value": [39]},
        "1030": {"vr": "IS", "Value": [1]},
        "1031": {"vr": "IS", "Value": [10]},
        "1032": {"vr": "IS", "Value": [23]},
        "1033": {"vr": "IS", "Value": [30]},
        "1034": {"vr": "IS", "Value": [11]},
        "1035": {"vr": "IS", "Value": [60]},
        "1036": {"vr": "IS", "Value": [25]},
        "1037": {"vr": "IS", "Value": [40]},
        "1038": {"vr": "IS", "Value": [9]},
        "1039": {"vr": "IS", "Value": [23]},
        "1040": {"vr": "IS", "Value": [22]},
        "1041": {"vr": "IS", "Value": [48]},
        "1042": {"vr": "IS", "Value": [22]},
        "1043": {"vr": "IS", "Value": [36]},
        "1044": {"vr": "IS", "Value": [20]},
        "1045": {"vr": "IS", "Value": [6]},
        "1046": {"vr": "IS", "Value": [40]},
        "1047": {"vr": "IS", "Value": [62]},
        "1048": {"vr": "IS", "Value": [63]},
        "1049": {"vr": "IS", "Value": [4]},
        "1050": {"vr": "IS", "Value": [38]},
        "1051": {"vr": "IS", "Value": [32]},
        "1052": {"vr": "IS", "Value": [10]},
        "1053": {"vr": "IS", "Value": [41]},
        "1054": {"vr": "IS", "Value": [9]},
        "1055": {"vr": "IS", "Value": [24]},
        "1056": {"vr": "IS", "Value": [54]},
        "1057": {"vr": "IS", "Value": [63]},
        "1058": {"vr": "IS", "Value": [49]},
        "1059": {"vr": "IS", "Value": [27]},
        "1060": {"vr": "IS", "Value": [1]},
        "1061": {"vr": "IS", "Value": [5]},
        "1062": {"vr": "IS", "Value": [16]},
        "1063": {"vr": "IS", "Value": [24]},
        "1064": {"vr": "IS", "Value": [16]},
        "1065": {"vr": "IS", "Value": [23]},
        "1066": {"vr": "IS", "Value": [26]},
        "1067": {"vr": "IS", "Value": [48]},
        "1068": {"vr": "IS", "Value": [55]},
        "1069": {"vr": "IS", "Value": [39]},
        "1070": {"vr": "IS", "Value": [15]},
        "1071": {"vr": "IS", "Value": [54]},
        "1072": {"vr": "IS", "Value": [48]},
        "1073": {"vr": "IS", "Value": [67]},
        "1074": {"vr": "IS", "Value": [66]},
        "1075": {"vr": "IS", "Value": [11]},
        "1076": {"vr": "IS", "Value": [40]},
        "1077": {"vr": "IS", "Value": [51]},
        "1078": {"vr": "IS", "Value": [14]},
        "1079": {"vr": "IS", "Value": [54]},
        "1080": {"vr": "IS", "Value": [22]},
        "1081": {"vr": "IS", "Value": [12]},
        "1082": {"vr": "IS", "Value": [48]},
        "1083": {"vr": "IS", "Value": [48]},
        "1084": {"vr": "IS", "Value": [8]},
        "1085": {"vr": "IS", "Value": [54]},
        "1086": {"vr": "IS", "Value": [48]},
        "1087": {"vr": "IS", "Value": [48]},
        "1088": {"vr": "IS", "Value": [56]},
        "1089": {"vr": "IS", "Value": [46]},
        "1090": {"vr": "IS", "Value": [34]},
        "1091": {"vr": "IS", "Value": [23]},
        "1092": {"vr": "IS", "Value": [46]},
        "1093": {"vr": "IS", "Value": [9]},
        "1094": {"vr": "IS", "Value": [64]},
        "1095": {"vr": "IS", "Value": [49]},
        "1096": {"vr": "IS", "Value": [42]},
        "1097": {"vr": "IS", "Value": [23]},
        "1098": {"vr": "IS", "Value": [57]},
        "1099": {"vr": "IS", "Value": [44]},
        "1100": {"vr": "IS", "Value": [32]},
        "1101": {"vr": "IS", "Value": [43]},
        "1102": {"vr": "IS", "Value": [42]},
        "1103": {"vr": "IS", "Value": [55]},
        "1104": {"vr": "IS", "Value": [10]},
        "1105": {"vr": "IS", "Value": [45]},
        "1106": {"vr": "IS", "Value": [10]},
        "1107": {"vr": "IS", "Value": [33]},
        "1108": {"vr": "IS", "Value": [17]},
        "1109": {"vr": "IS", "Value": [64]},
        "1110": {"vr": "IS", "Value": [56]},
        "1111": {"vr": "IS", "Value": [20]},
        "1112": {"vr": "IS", "Value": [15]},
        "1113": {"vr": "IS", "Value": [46]},
        "1114": {"vr": "IS", "Value": [32]},
        "1115": {"vr": "IS", "Value": [63]},
        "1116": {"vr": "IS", "Value": [2]},
        "1117": {"vr": "IS", "Value": [51]},
        "1118": {"vr": "IS", "Value": [15]},
        "1119": {"vr": "IS", "Value": [62]},
        "1120": {"vr": "IS", "Value": [64]},
        "1121": {"vr": "IS", "Value": [31]},
        "1122": {"vr": "IS", "Value": [14]},
        "1123": {"vr": "IS", "Value": [8]},
        "1124": {"vr": "IS", "Value": [30]},
        "1125": {"vr": "IS", "Value": [28]},
        "1126": {"vr": "IS", "Value": [66]},
        "1127": {"vr": "IS", "Value": [11]},
        "1128": {"vr": "IS", "Value": [43]},
        "1129": {"vr": "IS", "Value": [25]},
        "1130": {"vr": "IS", "Value": [64]},
        "1131": {"vr": "IS", "Value": [12]},
        "1132": {"vr": "IS", "Value": [11]},
        "1133": {"vr": "IS", "Value": [40]},
        "1134": {"vr": "IS", "Value": [49]},
        "1135": {"vr": "IS", "Value": [29]},
        "1136": {"vr": "IS", "Value": [23]},
        "1137": {"vr": "IS", "Value": [53]},
        "1138": {"vr": "IS", "Value": [10]},
        "1139": {"vr": "IS", "Value": [35]},
        "1140": {"vr": "IS", "Value": [5]},
        "1141": {"vr": "IS", "Value": [26]},
        "1142": {"vr": "IS", "Value": [7]},
        "1143": {"vr": "IS", "Value": [10]},
        "1144": {"vr": "IS", "Value": [17]},
        "1145": {"vr": "IS", "Value": [33]},
        "1146": {"vr": "IS", "Value": [21]},
        "1147": {"vr": "IS", "Value": [67]},
        "1148": {"vr": "IS", "Value": [12]},
        "1149": {"vr": "IS", "Value": [1]},
        "1150": {"vr": "IS", "Value": [65]},
        "1151": {"vr": "IS", "Value": [30]},
        "1152": {"vr": "IS", "Value": [37]},
        "1153": {"vr": "IS", "Value": [33]},
        "1154": {"vr": "IS", "Value": [39]},
        "1155": {"vr": "IS", "Value": [38]},
        "1156": {"vr": "IS", "Value": [11]},
        "1157": {"vr": "IS", "Value": [3]},
        "1158": {"vr": "IS", "Value": [53]},
        "1159": {"vr": "IS", "Value": [33]},
        "1160": {"vr": "IS", "Value": [40]},
        "1161": {"vr": "IS", "Value": [13]},
        "1162": {"vr": "IS", "Value": [43]},
        "1163": {"vr": "IS", "Value": [42]},
        "1164": {"vr": "IS", "Value": [29]},
        "1165": {"vr": "IS", "Value": [56]},
        "1166": {"vr": "IS", "Value": [1]},
        "1167": {"vr": "IS", "Value": [50]},
        "1168": {"vr": "IS", "Value": [6]},
        "1169": {"vr": "IS", "Value": [54]},
        "1170": {"vr": "IS", "Value": [57]},
        "1171": {"vr": "IS", "Value": [9]},
        "1172": {"vr": "IS", "Value": [46]},
        "1173": {"vr": "IS", "Value": [62]},
        "1174": {"vr": "IS", "Value": [46]},
        "1175": {"vr": "IS", "Value": [52]},
        "1176": {"vr": "IS", "Value": [51]},
        "1177": {"vr": "IS", "Value": [58]},
        "1178": {"vr": "IS", "Value": [1]},
        "1179": {"vr": "IS", "Value": [17]},
        "1180": {"vr": "IS", "Value": [26]},
        "1181": {"vr": "IS", "Value": [24]},
        "1182": {"vr": "IS", "Value": [5]},
        "1183": {"vr": "IS", "Value": [36]},
        "1184": {"vr": "IS", "Value": [54]},
        "1185": {"vr": "IS", "Value": [27]},
        "1186": {"vr": "IS", "Value": [4]},
        "1187": {"vr": "IS", "Value": [31]},
        "1188": {"vr": "IS", "Value": [52]},
        "1189": {"vr": "IS", "Value": [56]},
        "1190": {"vr": "IS", "Value": [61]},
        "1191": {"vr": "IS", "Value": [1]},
        "1192": {"vr": "IS", "Value": [13]},
        "1193": {"vr": "IS", "Value": [34]},
        "1194": {"vr": "IS", "Value": [66]},
        "1195": {"vr": "IS", "Value": [29]},
        "1196": {"vr": "IS", "Value": [3]},
        "1197": {"vr": "IS", "Value": [62]},
        "1198": {"vr": "IS", "Value": [24]},
        "1199": {"vr": "IS", "Value": [48]},
        "1200": {"vr": "IS", "Value": [55]},
        "1201": {"vr": "IS", "Value": [1]},
        "1202": {"vr": "IS", "Value": [12]},
        "1203": {"vr": "IS", "Value": [65]},
        "1204": {"vr": "IS", "Value": [50]},
        "1205": {"vr": "IS", "Value": [39]},
        "1206": {"vr": "IS", "Value": [57]},
        "1207": {"vr": "IS", "Value": [42]},
        "1208": {"vr": "IS", "Value": [3]},
        "1209": {"vr": "IS", "Value": [5]},
        "1210": {"vr": "IS", "Value": [37]},
        "1211": {"vr": "IS", "Value": [65]},
        "1212": {"vr": "IS", "Value": [16]},
        "1213": {"vr": "IS", "Value": [35]},
        "1214": {"vr": "IS", "Value": [60]},
        "1215": {"vr": "IS", "Value": [38]},
        "1216": {"vr": "IS", "Value": [48]},
        "1217": {"vr": "IS", "Value": [50]},
        "1218": {"vr": "IS", "Value": [3]},
        "1219": {"vr": "IS", "Value": [56]},
        "1220": {"vr": "IS", "Value": [56]},
        "1221": {"vr": "IS", "Value": [63]},
        "1222": {"vr": "IS", "Value": [14]},
        "1223": {"vr": "IS", "Value": [60]},
        "1224": {"vr": "IS", "Value": [25]},
        "1225": {"vr": "IS", "Value": [4]},
        "1226": {"vr": "IS", "Value": [3]},
        "1227": {"vr": "IS", "Value": [63]},
        "1228": {"vr": "IS", "Value": [63]},
        "1229": {"vr": "IS", "Value": [46]},
        "1230": {"vr": "IS", "Value": [43]},
        "1231": {"vr": "IS", "Value": [59]},
        "1232": {"vr": "IS", "Value": [62]},
        "1233": {"vr": "IS", "Value": [17]},
        "1234": {"vr": "IS", "Value": [10]},
        "1235": {"vr": "IS", "Value": [22]},
        "1236": {"vr": "IS", "Value": [3]},
        "1237": {"vr": "IS", "Value": [66]},
        "1238": {"vr": "IS", "Value": [22]},
        "1239": {"vr": "IS", "Value": [13]},
        "1240": {"vr": "IS", "Value": [14]},
        "1241": {"vr": "IS", "Value": [2]},
        "1242": {"vr": "IS", "Value": [46]},
        "1243": {"vr": "IS", "Value": [52]},
        "1244": {"vr": "IS", "Value": [38]},
        "1245": {"vr": "IS", "Value": [26]},
        "1246": {"vr": "IS", "Value": [52]},
        "1247": {"vr": "IS", "Value": [17]},
        "1248": {"vr": "IS", "Value": [33]},
        "1249": {"vr": "IS", "Value": [59]},
        "1250": {"vr": "IS", "Value": [5]},
        "1251": {"vr": "IS", "Value": [44]},
        "1252": {"vr": "IS", "Value": [33]},
        "1253": {"vr": "IS", "Value": [57]},
        "1254": {"vr": "IS", "Value": [24]},
        "1255": {"vr": "IS", "Value": [25]},
        "1256": {"vr": "IS", "Value": [49]},
        "1257": {"vr": "IS", "Value": [2]},
        "1258": {"vr": "IS", "Value": [7]},
        "1259": {"vr": "IS", "Value": [53]},
        "1260": {"vr": "IS", "Value": [45]},
        "1261": {"vr": "IS", "Value": [10]},
        "1262": {"vr": "IS", "Value": [17]},
        "1263": {"vr": "IS", "Value": [46]},
        "1264": {"vr": "IS", "Value": [12]},
        "1265": {"vr": "IS", "Value": [15]},
        "1266": {"vr": "IS", "Value": [19]},
        "1267": {"vr": "IS", "Value": [38]},
        "1268": {"vr": "IS", "Value": [33]},
        "1269": {"vr": "IS", "Value": [6]},
        "1270": {"vr": "IS", "Value": [9]},
        "1271": {"vr": "IS", "Value": [67]},
        "1272": {"vr": "IS", "Value": [30]},
        "1273": {"vr": "IS", "Value": [15]},
        "1274": {"vr": "IS", "Value": [47]},
        "1275": {"vr": "IS", "Value": [53]},
        "1276": {"vr": "IS", "Value": [61]},
        "1277": {"vr": "IS", "Value": [63]},
        "1278": {"vr": "IS", "Value": [29]},
        "1279": {"vr": "IS", "Value": [26]},
        "1280": {"vr": "IS", "Value": [6]},
        "1281": {"vr": "IS", "Value": [47]},
        "1282": {"vr": "IS", "Value": [12]},
        "1283": {"vr": "IS", "Value": [47]},
        "1284": {"vr": "IS", "Value": [48]},
        "1285": {"vr": "IS", "Value": [27]},
        "1286": {"vr": "IS", "Value": [26]},
        "1287": {"vr": "IS", "Value": [28]},
        "1288": {"vr": "IS", "Value": [21]},
        "1289": {"vr": "IS", "Value": [51]},
        "1290": {"vr": "IS", "Value": [20]},
        "1291": {"vr": "IS", "Value": [1]},
        "1292": {"vr": "IS", "Value": [29]},
        "1293": {"vr": "IS", "Value": [35]},
        "1294": {"vr": "IS", "Value": [58]},
        "1295": {"vr": "IS", "Value": [30]},
        "1296": {"vr": "IS", "Value": [15]},
        "1297": {"vr": "IS", "Value": [14]},
        "1298": {"vr": "IS", "Value": [2]},
        "1299": {"vr": "IS", "Value": [9]},
        "1300": {"vr": "IS", "Value": [34]},
        "1301": {"vr": "IS", "Value": [32]},
        "1302": {"vr": "IS", "Value": [3]},
        "1303": {"vr": "IS", "Value": [60]},
        "1304": {"vr": "IS", "Value": [28]},
        "1305": {"vr": "IS", "Value": [33]},
        "1306": {"vr": "IS", "Value": [5]},
        "1307": {"vr": "IS", "Value": [55]},
        "1308": {"vr": "IS", "Value": [9]},
        "1309": {"vr": "IS", "Value": [12]},
        "1310": {"vr": "IS", "Value": [2]},
        "1311": {"vr": "IS", "Value": [32]},
        "1312": {"vr": "IS", "Value": [62]},
        "1313": {"vr": "IS", "Value": [30]},
        "1314": {"vr": "IS", "Value": [16]},
        "1315": {"vr": "IS", "Value": [2]},
        "1316": {"vr": "IS", "Value": [37]},
        "1317": {"vr": "IS", "Value": [26]},
        "1318": {"vr": "IS", "Value": [6]},
        "1319": {"vr": "IS", "Value": [10]},
        "1320": {"vr": "IS", "Value": [52]},
        "1321": {"vr": "IS", "Value": [32]},
        "1322": {"vr": "IS", "Value": [7]},
        "1323": {"vr": "IS", "Value": [18]},
        "1324": {"vr": "IS", "Value": [23]},
        "1325": {"vr": "IS", "Value": [3]},
        "1326": {"vr": "IS", "Value": [23]},
        "1327": {"vr": "IS", "Value": [61]},
        "1328": {"vr": "IS", "Value": [15]},
        "1329": {"vr": "IS", "Value": [46]},
        "1330": {"vr": "IS", "Value": [67]},
        "1331": {"vr": "IS", "Value": [28]},
        "1332": {"vr": "IS", "Value": [59]},
        "1333": {"vr": "IS", "Value": [56]},
        "1334": {"vr": "IS", "Value": [51]},
        "1335": {"vr": "IS", "Value": [19]},
        "1336": {"vr": "IS", "Value": [35]},
        "1337": {"vr": "IS", "Value": [16]},
        "1338": {"vr": "IS", "Value": [25]},
        "1339": {"vr": "IS", "Value": [49]},
        "1340": {"vr": "IS", "Value": [6]},
        "1341": {"vr": "IS", "Value": [62]},
        "1342": {"vr": "IS", "Value": [8]},
        "1343": {"vr": "IS", "Value": [52]},
        "1344": {"vr": "IS", "Value": [15]},
        "1345": {"vr": "IS", "Value": [15]},
        "1346": {"vr": "IS", "Value": [8]},
        "1347": {"vr": "IS", "Value": [1]},
        "1348": {"vr": "IS", "Value": [43]},
        "1349": {"vr": "IS", "Value": [8]},
        "1350": {"vr": "IS", "Value": [43]},
        "1351": {"vr": "IS", "Value": [5]},
        "1352": {"vr": "IS", "Value": [33]},
        "1353": {"vr": "IS", "Value": [52]},
        "1354": {"vr": "IS", "Value": [63]},
        "1355": {"vr": "IS", "Value": [22]},
        "1356": {"vr": "IS", "Value": [31]},
        "1357": {"vr": "IS", "Value": [37]},
        "1358": {"vr": "IS", "Value": [12]},
        "1359": {"vr": "IS", "Value": [60]},
        "1360": {"vr": "IS", "Value": [60]},
        "1361": {"vr": "IS", "Value": [7]},
        "1362": {"vr": "IS", "Value": [2]},
        "1363": {"vr": "IS", "Value": [14]},
        "1364": {"vr": "IS", "Value": [16]},
        "1365": {"vr": "IS", "Value": [38]},
        "1366": {"vr": "IS", "Value": [25]},
        "1367": {"vr": "IS", "Value": [6]},
        "1368": {"vr": "IS", "Value": [21]},
        "1369": {"vr": "IS", "Value": [24]},
        "1370": {"vr": "IS", "Value": [32]},
        "1371": {"vr": "IS", "Value": [9]},
        "1372": {"vr": "IS", "Value": [6]},
        "1373": {"vr": "IS", "Value": [48]},
        "1374": {"vr": "IS", "Value": [36]},
        "1375": {"vr": "IS", "Value": [23]},
        "1376": {"vr": "IS", "Value": [9]},
        "1377": {"vr": "IS", "Value": [10]},
        "1378": {"vr": "IS", "Value": [64]},
        "1379": {"vr": "IS", "Value": [65]},
        "1380": {"vr": "IS", "Value": [39]},
        "1381": {"vr": "IS", "Value": [56]},
        "1382": {"vr": "IS", "Value": [57]},
        "1383": {"vr": "IS", "Value": [16]},
        "1384": {"vr": "IS", "Value": [8]},
        "1385": {"vr": "IS", "Value": [25]},
        "1386": {"vr": "IS", "Value": [46]},
        "1387": {"vr": "IS", "Value": [25]},
        "1388": {"vr": "IS", "Value": [39]},
        "1389": {"vr": "IS", "Value": [8]},
        "1390": {"vr": "IS", "Value": [26]},
        "1391": {"vr": "IS", "Value": [2]},
        "1392": {"vr": "IS", "Value": [61]},
        "1393": {"vr": "IS", "Value": [25]},
        "1394": {"vr": "IS", "Value": [35]},
        "1395": {"vr": "IS", "Value": [30]},
        "1396": {"vr": "IS", "Value": [42]},
        "1397": {"vr": "IS", "Value": [31]},
        "1398": {"vr": "IS", "Value": [19]},
        "1399": {"vr": "IS", "Value": [22]},
        "1400": {"vr": "IS", "Value": [39]},
        "1401": {"vr": "IS", "Value": [18]},
        "1402": {"vr": "IS", "Value": [59]},
        "1403": {"vr": "IS", "Value": [33]},
        "1404": {"vr": "IS", "Value": [1]},
        "1405": {"vr": "IS", "Value": [3]},
        "1406": {"vr": "IS", "Value": [16]},
        "1407": {"vr": "IS", "Value": [14]},
        "1408": {"vr": "IS", "Value": [22]},
        "1409": {"vr": "IS", "Value": [14]},
        "1410": {"vr": "IS", "Value": [59]},
        "1411": {"vr": "IS", "Value": [10]},
        "1412": {"vr": "IS", "Value": [38]},
        "1413": {"vr": "IS", "Value": [56]},
        "1414": {"vr": "IS", "Value": [43]},
        "1415": {"vr": "IS", "Value": [4]},
        "1416": {"vr": "IS", "Value": [16]},
        "1417": {"vr": "IS", "Value": [12]},
        "1418": {"vr": "IS", "Value": [36]},
        "1419": {"vr": "IS", "Value": [59]},
        "1420": {"vr": "IS", "Value": [51]},
        "1421": {"vr": "IS", "Value": [16]},
        "1422": {"vr": "IS", "Value": [57]},
        "1423": {"vr": "IS", "Value": [31]},
        "1424": {"vr": "IS", "Value": [62]},
        "1425": {"vr": "IS", "Value": [26]},
        "1426": {"vr": "IS", "Value": [53]},
        "1427": {"vr": "IS", "Value": [49]},
        "1428": {"vr": "IS", "Value": [29]},
        "1429": {"vr": "IS", "Value": [58]},
        "1430": {"vr": "IS", "Value": [56]},
        "1431": {"vr": "IS", "Value": [64]},
        "1432": {"vr": "IS", "Value": [31]},
        "1433": {"vr": "IS", "Value": [51]},
        "1434": {"vr": "IS", "Value": [44]},
        "1435": {"vr": "IS", "Value": [38]},
        "1436": {"vr": "IS", "Value": [53]},
        "1437": {"vr": "IS", "Value": [43]},
        "1438": {"vr": "IS", "Value": [6]},
        "1439": {"vr": "IS", "Value": [35]},
        "1440": {"vr": "IS", "Value": [65]},
        "1441": {"vr": "IS", "Value": [37]},
        "1442": {"vr": "IS", "Value": [1]},
        "1443": {"vr": "IS", "Value": [65]},
        "1444": {"vr": "IS", "Value": [37]},
        "1445": {"vr": "IS", "Value": [60]},
        "1446": {"vr": "IS", "Value": [47]},
        "1447": {"vr": "IS", "Value": [18]},
        "1448": {"vr": "IS", "Value": [5]},
        "1449": {"vr": "IS", "Value": [12]},
        "1450": {"vr": "IS", "Value": [19]},
        "1451": {"vr": "IS", "Value": [31]},
        "1452": {"vr": "IS", "Value": [2]},
        "1453": {"vr": "IS", "Value": [48]},
        "1454": {"vr": "IS", "Value": [63]},
        "1455": {"vr": "IS", "Value": [67]},
        "1456": {"vr": "IS", "Value": [38]},
        "1457": {"vr": "IS", "Value": [13]},
        "1458": {"vr": "IS", "Value": [65]},
        "1459": {"vr": "IS", "Value": [8]},
        "1460": {"vr": "IS", "Value": [56]},
        "1461": {"vr": "IS", "Value": [12]},
        "1462": {"vr": "IS", "Value": [30]},
        "1463": {"vr": "IS", "Value": [30]},
        "1464": {"vr": "IS", "Value": [55]},
        "1465": {"vr": "IS", "Value": [41]},
        "1466": {"vr": "IS", "Value": [17]},
        "1467": {"vr": "IS", "Value": [15]},
        "1468": {"vr": "IS", "Value": [47]},
        "1469": {"vr": "IS", "Value": [61]},
        "1470": {"vr": "IS", "Value": [40]},
        "1471": {"vr": "IS", "Value": [57]},
        "1472": {"vr": "IS", "Value": [16]},
        "1473": {"vr": "IS", "Value": [17]},
        "1474": {"vr": "IS", "Value": [45]},
        "1475": {"vr": "IS", "Value": [57]},
        "1476": {"vr": "IS", "Value": [24]},
        "1477": {"vr": "IS", "Value": [5]},
        "1478": {"vr": "IS", "Value": [25]},
        "1479": {"vr": "IS", "Value": [43]},
        "1480": {"vr": "IS", "Value": [51]},
        "1481": {"vr": "IS", "Value": [54]},
        "1482": {"vr": "IS", "Value": [51]},
        "1483": {"vr": "IS", "Value": [50]},
        "1484": {"vr": "IS", "Value": [38]},
        "1485": {"vr": "IS", "Value": [27]},
        "1486": {"vr": "IS", "Value": [11]},
        "1487": {"vr": "IS", "Value": [64]},
        "1488": {"vr": "IS", "Value": [45]},
        "1489": {"vr": "IS", "Value": [28]},
        "1490": {"vr": "IS", "Value": [37]},
        "1491": {"vr": "IS", "Value": [21]},
        "1492": {"vr": "IS", "Value": [40]},
        "1493": {"vr": "IS", "Value": [12]},
        "1494": {"vr": "IS", "Value": [62]},
        "1495": {"vr": "IS", "Value": [46]},
        "1496": {"vr": "IS", "Value": [59]},
        "1497": {"vr": "IS", "Value": [14]},
        "1498": {"vr": "IS", "Value": [29]},
        "1499": {"vr": "IS", "Value": [59]},
        "1500": {"vr": "IS", "Value": [43]},
        "1501": {"vr": "IS", "Value": [17]},
        "1502": {"vr": "IS", "Value": [41]},
        "1503": {"vr": "IS", "Value": [57]},
        "1504": {"vr": "IS", "Value": [41]},
        "1505": {"vr": "IS", "Value": [19]},
        "1506": {"vr": "IS", "Value": [28]},
        "1507": {"vr": "IS", "Value": [19]},
        "1508": {"vr": "IS", "Value": [7]},
        "1509": {"vr": "IS", "Value": [13]},
        "1510": {"vr": "IS", "Value": [43]},
        "1511": {"vr": "IS", "Value": [57]},
        "1512": {"vr": "IS", "Value": [45]},
        "1513": {"vr": "IS", "Value": [5]},
        "1514": {"vr": "IS", "Value": [16]},
        "1515": {"vr": "IS", "Value": [1]},
        "1516": {"vr": "IS", "Value": [3]},
        "1517": {"vr": "IS", "Value": [56]},
        "1518": {"vr": "IS", "Value": [53]},
        "1519": {"vr": "IS", "Value": [36]},
        "1520": {"vr": "IS", "Value": [24]},
        "1521": {"vr": "IS", "Value": [55]},
        "1522": {"vr": "IS", "Value": [19]},
        "1523": {"vr": "IS", "Value": [24]},
        "1524": {"vr": "IS", "Value": [29]},
        "1525": {"vr": "IS", "Value": [9]},
        "1526": {"vr": "IS", "Value": [16]},
        "1527": {"vr": "IS", "Value": [53]},
        "1528": {"vr": "IS", "Value": [3]},
        "1529": {"vr": "IS", "Value": [27]},
        "1530": {"vr": "IS", "Value": [50]},
        "1531": {"vr": "IS", "Value": [31]},
        "1532": {"vr": "IS", "Value": [62]},
        "1533": {"vr": "IS", "Value": [17]},
        "1534": {"vr": "IS", "Value": [25]},
        "1535": {"vr": "IS", "Value": [16]},
        "1536": {"vr": "IS", "Value": [34]},
        "1537": {"vr": "IS", "Value": [5]},
        "1538": {"vr": "IS", "Value": [5]},
        "1539": {"vr": "IS", "Value": [11]},
        "1540": {"vr": "IS", "Value": [36]},
        "1541": {"vr": "IS", "Value": [38]},
        "1542": {"vr": "IS", "Value": [18]},
        "1543": {"vr": "IS", "Value": [25]},
        "1544": {"vr": "IS", "Value": [33]},
        "1545": {"vr": "IS", "Value": [31]},
        "1546": {"vr": "IS", "Value": [39]},
        "1547": {"vr": "IS", "Value": [37]},
        "1548": {"vr": "IS", "Value": [35]},
        "1549": {"vr": "IS", "Value": [27]},
        "1550": {"vr": "IS", "Value": [20]},
        "1551": {"vr": "IS", "Value": [21]},
        "1552": {"vr": "IS", "Value": [26]},
        "1553": {"vr": "IS", "Value": [12]},
        "1554": {"vr": "IS", "Value": [33]},
        "1555": {"vr": "IS", "Value": [1]},
        "1556": {"vr": "IS", "Value": [40]},
        "1557": {"vr": "IS", "Value": [32]},
        "1558": {"vr": "IS", "Value": [28]},
        "1559": {"vr": "IS", "Value": [45]},
        "1560": {"vr": "IS", "Value": [64]},
        "1561": {"vr": "IS", "Value": [35]},
        "1562": {"vr": "IS", "Value": [56]},
        "1563": {"vr": "IS", "Value": [16]},
        "1564": {"vr": "IS", "Value": [17]},
        "1565": {"vr": "IS", "Value": [8]},
        "1566": {"vr": "IS", "Value": [37]},
        "1567": {"vr": "IS", "Value": [21]},
        "1568": {"vr": "IS", "Value": [36]},
        "1569": {"vr": "IS", "Value": [57]},
        "1570": {"vr": "IS", "Value": [41]},
        "1571": {"vr": "IS", "Value": [4]},
        "1572": {"vr": "IS", "Value": [25]},
        "1573": {"vr": "IS", "Value": [39]},
        "1574": {"vr": "IS", "Value": [34]},
        "1575": {"vr": "IS", "Value": [40]},
        "1576": {"vr": "IS", "Value": [10]},
        "1577": {"vr": "IS", "Value": [42]},
        "1578": {"vr": "IS", "Value": [65]},
        "1579": {"vr": "IS", "Value": [65]},
        "1580": {"vr": "IS", "Value": [48]},
        "1581": {"vr": "IS", "Value": [30]},
        "1582": {"vr": "IS", "Value": [50]},
        "1583": {"vr": "IS", "Value": [39]},
        "1584": {"vr": "IS", "Value": [16]},
        "1585": {"vr": "IS", "Value": [58]},
        "1586": {"vr": "IS", "Value": [53]},
        "1587": {"vr": "IS", "Value": [39]},
        "1588": {"vr": "IS", "Value": [44]},
        "1589": {"vr": "IS", "Value": [14]},
        "1590": {"vr": "IS", "Value": [23]},
        "1591": {"vr": "IS", "Value": [16]},
        "1592": {"vr": "IS", "Value": [58]},
        "1593": {"vr": "IS", "Value": [38]},
        "1594": {"vr": "IS", "Value": [56]},
        "1595": {"vr": "IS", "Value": [63]},
        "1596": {"vr": "IS", "Value": [7]},
        "1597": {"vr": "IS", "Value": [29]},
        "1598": {"vr": "IS", "Value": [60]},
        "1599": {"vr": "IS", "Value": [49]},
        "1600": {"vr": "IS", "Value": [45]},
        "1601": {"vr": "IS", "Value": [1]},
        "1602": {"vr": "IS", "Value": [61]},
        "1603": {"vr": "IS", "Value": [67]},
        "1604": {"vr": "IS", "Value": [12]},
        "1605": {"vr": "IS", "Value": [41]},
        "1606": {"vr": "IS", "Value": [64]},
        "1607": {"vr": "IS", "Value": [24]},
        "1608": {"vr": "IS", "Value": [55]},
        "1609": {"vr": "IS", "Value": [30]},
        "1610": {"vr": "IS", "Value": [34]},
        "1611": {"vr": "IS", "Value": [51]},
        "1612": {"vr": "IS", "Value": [31]},
        "1613": {"vr": "IS", "Value": [52]},
        "1614": {"vr": "IS", "Value": [16]},
        "1615": {"vr": "IS", "Value": [53]},
        "1616": {"vr": "IS", "Value": [16]},
        "1617": {"vr": "IS", "Value": [33]},
        "1618": {"vr": "IS", "Value": [32]},
        "1619": {"vr": "IS", "Value": [3]},
        "1620": {"vr": "IS", "Value": [15]},
        "1621": {"vr": "IS", "Value": [33]},
        "1622": {"vr": "IS", "Value": [43]},
        "1623": {"vr": "IS", "Value": [31]},
        "1624": {"vr": "IS", "Value": [61]},
        "1625": {"vr": "IS", "Value": [23]},
        "1626": {"vr": "IS", "Value": [37]},
        "1627": {"vr": "IS", "Value": [24]},
        "1628": {"vr": "IS", "Value": [37]},
        "1629": {"vr": "IS", "Value": [51]},
        "1630": {"vr": "IS", "Value": [65]},
        "1631": {"vr": "IS", "Value": [13]},
        "1632": {"vr": "IS", "Value": [44]},
        "1633": {"vr": "IS", "Value": [37]},
        "1634": {"vr": "IS", "Value": [4]},
        "1635": {"vr": "IS", "Value": [49]},
        "1636": {"vr": "IS", "Value": [6]},
        "1637": {"vr": "IS", "Value": [47]},
        "1638": {"vr": "IS", "Value": [28]},
        "1639": {"vr": "IS", "Value": [57]},
        "1640": {"vr": "IS", "Value": [11]},
        "1641": {"vr": "IS", "Value": [66]},
        "1642": {"vr": "IS", "Value": [3]},
        "1643": {"vr": "IS", "Value": [67]},
        "1644": {"vr": "IS", "Value": [34]},
        "1645": {"vr": "IS", "Value": [60]},
        "1646": {"vr": "IS", "Value": [51]},
        "1647": {"vr": "IS", "Value": [58]},
        "1648": {"vr": "IS", "Value": [17]},
        "1649": {"vr": "IS", "Value": [23]},
        "1650": {"vr": "IS", "Value": [33]},
        "1651": {"vr": "IS", "Value": [52]},
        "1652": {"vr": "IS", "Value": [28]},
        "1653": {"vr": "IS", "Value": [31]},
        "1654": {"vr": "IS", "Value": [19]},
        "1655": {"vr": "IS", "Value": [46]},
        "1656": {"vr": "IS", "Value": [31]},
        "1657": {"vr": "IS", "Value": [44]},
        "1658": {"vr": "IS", "Value": [49]},
        "1659": {"vr": "IS", "Value": [27]},
        "1660": {"vr": "IS", "Value": [43]},
        "1661": {"vr": "IS", "Value": [2]},
        "1662": {"vr": "IS", "Value": [40]},
        "1663": {"vr": "IS", "Value": [22]},
        "1664": {"vr": "IS", "Value": [54]},
        "1665": {"vr": "IS", "Value": [49]},
        "1666": {"vr": "IS", "Value": [28]},
        "1667": {"vr": "IS", "Value": [50]},
        "1668": {"vr": "IS", "Value": [13]},
        "1669": {"vr": "IS", "Value": [51]},
        "1670": {"vr": "IS", "Value": [29]},
        "1671": {"vr": "IS", "Value": [44]},
        "1672": {"vr": "IS", "Value": [7]},
        "1673": {"vr": "IS", "Value": [22]},
        "1674": {"vr": "IS", "Value": [36]},
        "1675": {"vr": "IS", "Value": [17]},
        "1676": {"vr": "IS", "Value": [3]},
        "1677": {"vr": "IS", "Value": [63]},
        "1678": {"vr": "IS", "Value": [25]},
        "1679": {"vr": "IS", "Value": [27]},
        "1680": {"vr": "IS", "Value": [51]},
        "1681": {"vr": "IS", "Value": [11]},
        "1682": {"vr": "IS", "Value": [49]},
        "1683": {"vr": "IS", "Value": [44]},
        "1684": {"vr": "IS", "Value": [60]},
        "1685": {"vr": "IS", "Value": [53]},
        "1686": {"vr": "IS", "Value": [3]},
        "1687": {"vr": "IS", "Value": [47]},
        "1688": {"vr": "IS", "Value": [20]},
        "1689": {"vr": "IS", "Value": [23]},
        "1690": {"vr": "IS", "Value": [36]},
        "1691": {"vr": "IS", "Value": [56]},
        "1692": {"vr": "IS", "Value": [24]},
        "1693": {"vr": "IS", "Value": [26]},
        "1694": {"vr": "IS", "Value": [55]},
        "1695": {"vr": "IS", "Value": [15]},
        "1696": {"vr": "IS", "Value": [4]},
        "1697": {"vr": "IS", "Value": [38]},
        "1698": {"vr": "IS", "Value": [63]},
        "1699": {"vr": "IS", "Value": [39]},
        "1700": {"vr": "IS", "Value": [1]},
        "1701": {"vr": "IS", "Value": [54]},
        "1702": {"vr": "IS", "Value": [15]},
        "1703": {"vr": "IS", "Value": [5]},
        "1704": {"vr": "IS", "Value": [61]},
        "1705": {"vr": "IS", "Value": [4]},
        "1706": {"vr": "IS", "Value": [4]},
        "1707": {"vr": "IS", "Value": [24]},
        "1708": {"vr": "IS", "Value": [50]},
        "1709": {"vr": "IS", "Value": [36]},
        "1710": {"vr": "IS", "Value": [29]},
        "1711": {"vr": "IS", "Value": [3]},
        "1712": {"vr": "IS", "Value": [46]},
        "1713": {"vr": "IS", "Value": [18]},
        "1714": {"vr": "IS", "Value": [61]},
        "1715": {"vr": "IS", "Value": [52]},
        "1716": {"vr": "IS", "Value": [7]},
        "1717": {"vr": "IS", "Value": [12]},
        "1718": {"vr": "IS", "Value": [32]},
        "1719": {"vr": "IS", "Value": [63]},
        "1720": {"vr": "IS", "Value": [67]},
        "1721": {"vr": "IS", "Value": [61]},
        "1722": {"vr": "IS", "Value": [17]},
        "1723": {"vr": "IS", "Value": [63]},
        "1724": {"vr": "IS", "Value": [53]},
        "1725": {"vr": "IS", "Value": [18]},
        "1726": {"vr": "IS", "Value": [60]},
        "1727": {"vr": "IS", "Value": [29]},
        "1728": {"vr": "IS", "Value": [19]},
        "1729": {"vr": "IS", "Value": [33]},
        "1730": {"vr": "IS", "Value": [4]},
        "1731": {"vr": "IS", "Value": [25]},
        "1732": {"vr": "IS", "Value": [3]},
        "1733": {"vr": "IS", "Value": [2]},
        "1734": {"vr": "IS", "Value": [61]},
        "1735": {"vr": "IS", "Value": [55]},
        "1736": {"vr": "IS", "Value": [23]},
        "1737": {"vr": "IS", "Value": [14]},
        "1738": {"vr": "IS", "Value": [45]},
        "1739": {"vr": "IS", "Value": [25]},
        "1740": {"vr": "IS", "Value": [61]},
        "1741": {"vr": "IS", "Value": [19]},
        "1742": {"vr": "IS", "Value": [9]},
        "1743": {"vr": "IS", "Value": [18]},
        "1744": {"vr": "IS", "Value": [44]},
        "1745": {"vr": "IS", "Value": [41]},
        "1746": {"vr": "IS", "Value": [52]},
        "1747": {"vr": "IS", "Value": [39]},
        "1748": {"vr": "IS", "Value": [49]},
        "1749": {"vr": "IS", "Value": [55]},
        "1750": {"vr": "IS", "Value": [64]},
        "1751": {"vr": "IS", "Value": [65]},
        "1752": {"vr": "IS", "Value": [8]},
        "1753": {"vr": "IS", "Value": [17]},
        "1754": {"vr": "IS", "Value": [32]},
        "1755": {"vr": "IS", "Value": [44]},
        "1756": {"vr": "IS", "Value": [18]},
        "1757": {"vr": "IS", "Value": [43]},
        "1758": {"vr": "IS", "Value": [2]},
        "1759": {"vr": "IS", "Value": [3]},
        "1760": {"vr": "IS", "Value": [43]},
        "1761": {"vr": "IS", "Value": [5]},
        "1762": {"vr": "IS", "Value": [2]},
        "1763": {"vr": "IS", "Value": [7]},
        "1764": {"vr": "IS", "Value": [30]},
        "1765": {"vr": "IS", "Value": [11]},
        "1766": {"vr": "IS", "Value": [24]},
        "1767": {"vr": "IS", "Value": [26]},
        "1768": {"vr": "IS", "Value": [26]},
        "1769": {"vr": "IS", "Value": [2]},
        "1770": {"vr": "IS", "Value": [44]},
        "1771": {"vr": "IS", "Value": [31]},
        "1772": {"vr": "IS", "Value": [32]},
        "1773": {"vr": "IS", "Value": [61]},
        "1774": {"vr": "IS", "Value": [5]},
        "1775": {"vr": "IS", "Value": [12]},
        "1776": {"vr": "IS", "Value": [65]},
        "1777": {"vr": "IS", "Value": [17]},
        "1778": {"vr": "IS", "Value": [18]},
        "1779": {"vr": "IS", "Value": [52]},
        "1780": {"vr": "IS", "Value": [21]},
        "1781": {"vr": "IS", "Value": [53]},
        "1782": {"vr": "IS", "Value": [14]},
        "1783": {"vr": "IS", "Value": [18]},
        "1784": {"vr": "IS", "Value": [51]},
        "1785": {"vr": "IS", "Value": [25]},
        "1786": {"vr": "IS", "Value": [46]},
        "1787": {"vr": "IS", "Value": [66]},
        "1788": {"vr": "IS", "Value": [19]},
        "1789": {"vr": "IS", "Value": [51]},
        "1790": {"vr": "IS", "Value": [15]},
        "1791": {"vr": "IS", "Value": [10]},
        "1792": {"vr": "IS", "Value": [37]},
        "1793": {"vr": "IS", "Value": [31]},
        "1794": {"vr": "IS", "Value": [30]},
        "1795": {"vr": "IS", "Value": [17]},
        "1796": {"vr": "IS", "Value": [1]},
        "1797": {"vr": "IS", "Value": [38]},
        "1798": {"vr": "IS", "Value": [14]},
        "1799": {"vr": "IS", "Value": [41]},
        "1800": {"vr": "IS", "Value": [42]},
        "1801": {"vr": "IS", "Value": [58]},
        "1802": {"vr": "IS", "Value": [23]},
        "1803": {"vr": "IS", "Value": [63]},
        "1804": {"vr": "IS", "Value": [63]},
        "1805": {"vr": "IS", "Value": [67]},
        "1806": {"vr": "IS", "Value": [7]},
        "1807": {"vr": "IS", "Value": [62]},
        "1808": {"vr": "IS", "Value": [51]},
        "1809": {"vr": "IS", "Value": [17]},
        "1810": {"vr": "IS", "Value": [39]},
        "1811": {"vr": "IS", "Value": [31]},
        "1812": {"vr": "IS", "Value": [26]},
        "1813": {"vr": "IS", "Value": [25]},
        "1814": {"vr": "IS", "Value": [55]},
        "1815": {"vr": "IS", "Value": [64]},
        "1816": {"vr": "IS", "Value": [36]},
        "1817": {"vr": "IS", "Value": [39]},
        "1818": {"vr": "IS", "Value": [37]},
        "1819": {"vr": "IS", "Value": [29]},
        "1820": {"vr": "IS", "Value": [24]},
        "1821": {"vr": "IS", "Value": [44]},
        "1822": {"vr": "IS", "Value": [52]},
        "1823": {"vr": "IS", "Value": [44]},
        "1824": {"vr": "IS", "Value": [16]},
        "1825": {"vr": "IS", "Value": [39]},
        "1826": {"vr": "IS", "Value": [18]},
        "1827": {"vr": "IS", "Value": [56]},
        "1828": {"vr": "IS", "Value": [27]},
        "1829": {"vr": "IS", "Value": [8]},
        "1830": {"vr": "IS", "Value": [17]},
        "1831": {"vr": "IS", "Value": [39]},
        "1832": {"vr": "IS", "Value": [26]},
        "1833": {"vr": "IS", "Value": [37]},
        "1834": {"vr": "IS", "Value": [14]},
        "1835": {"vr": "IS", "Value": [36]},
        "1836": {"vr": "IS", "Value": [43]},
        "1837": {"vr": "IS", "Value": [23]},
        "1838": {"vr": "IS", "Value": [56]},
        "1839": {"vr": "IS", "Value": [50]},
        "1840": {"vr": "IS", "Value": [6]},
        "1841": {"vr": "IS", "Value": [40]},
        "1842": {"vr": "IS", "Value": [31]},
        "1843": {"vr": "IS", "Value": [14]},
        "1844": {"vr": "IS", "Value": [43]},
        "1845": {"vr": "IS", "Value": [23]},
        "1846": {"vr": "IS", "Value": [21]},
        "1847": {"vr": "IS", "Value": [20]},
        "1848": {"vr": "IS", "Value": [33]},
        "1849": {"vr": "IS", "Value": [51]},
        "1850": {"vr": "IS", "Value": [36]},
        "1851": {"vr": "IS", "Value": [52]},
        "1852": {"vr": "IS", "Value": [42]},
        "1853": {"vr": "IS", "Value": [2]},
        "1854": {"vr": "IS", "Value": [9]},
        "1855": {"vr": "IS", "Value": [32]},
        "1856": {"vr": "IS", "Value": [11]},
        "1857": {"vr": "IS", "Value": [64]},
        "1858": {"vr": "IS", "Value": [22]},
        "1859": {"vr": "IS", "Value": [11]},
        "1860": {"vr": "IS", "Value": [38]},
        "1861": {"vr": "IS", "Value": [40]},
        "1862": {"vr": "IS", "Value": [17]},
        "1863": {"vr": "IS", "Value": [57]},
        "1864": {"vr": "IS", "Value": [7]},
        "1865": {"vr": "IS", "Value": [33]},
        "1866": {"vr": "IS", "Value": [38]},
        "1867": {"vr": "IS", "Value": [41]},
        "1868": {"vr": "IS", "Value": [66]},
        "1869": {"vr": "IS", "Value": [47]},
        "1870": {"vr": "IS", "Value": [5]},
        "1871": {"vr": "IS", "Value": [49]},
        "1872": {"vr": "IS", "Value": [67]},
        "1873": {"vr": "IS", "Value": [1]},
        "1874": {"vr": "IS", "Value": [18]},
        "1875": {"vr": "IS", "Value": [63]},
        "1876": {"vr": "IS", "Value": [7]},
        "1877": {"vr": "IS", "Value": [9]},
        "1878": {"vr": "IS", "Value": [66]},
        "1879": {"vr": "IS", "Value": [22]},
        "1880": {"vr": "IS", "Value": [18]},
        "1881": {"vr": "IS", "Value": [51]},
        "1882": {"vr": "IS", "Value": [30]},
        "1883": {"vr": "IS", "Value": [4]},
        "1884": {"vr": "IS", "Value": [20]},
        "1885": {"vr": "IS", "Value": [62]},
        "1886": {"vr": "IS", "Value": [35]},
        "1887": {"vr": "IS", "Value": [53]},
        "1888": {"vr": "IS", "Value": [64]},
        "1889": {"vr": "IS", "Value": [56]},
        "1890": {"vr": "IS", "Value": [40]},
        "1891": {"vr": "IS", "Value": [37]},
        "1892": {"vr": "IS", "Value": [60]},
        "1893": {"vr": "IS", "Value": [5]},
        "1894": {"vr": "IS", "Value": [62]},
        "1895": {"vr": "IS", "Value": [60]},
        "1896": {"vr": "IS", "Value": [46]},
        "1897": {"vr": "IS", "Value": [19]},
        "1898": {"vr": "IS", "Value": [65]},
        "1899": {"vr": "IS", "Value": [4]},
        "1900": {"vr": "IS", "Value": [13]},
        "1901": {"vr": "IS", "Value": [61]},
        "1902": {"vr": "IS", "Value": [26]},
        "1903": {"vr": "IS", "Value": [18]},
        "1904": {"vr": "IS", "Value": [28]},
        "1905": {"vr": "IS", "Value": [51]},
        "1906": {"vr": "IS", "Value": [24]},
        "1907": {"vr": "IS", "Value": [26]},
        "1908": {"vr": "IS", "Value": [28]},
        "1909": {"vr": "IS", "Value": [56]},
        "1910": {"vr": "IS", "Value": [18]},
        "1911": {"vr": "IS", "Value": [7]},
        "1912": {"vr": "IS", "Value": [9]},
        "1913": {"vr": "IS", "Value": [52]},
        "1914": {"vr": "IS", "Value": [56]},
        "1915": {"vr": "IS", "Value": [1]},
        "1916": {"vr": "IS", "Value": [34]},
        "1917": {"vr": "IS", "Value": [51]},
        "1918": {"vr": "IS", "Value": [34]},
        "1919": {"vr": "IS", "Value": [66]},
        "1920": {"vr": "IS", "Value": [23]},
        "1921": {"vr": "IS", "Value": [26]},
        "1922": {"vr": "IS", "Value": [29]},
        "1923": {"vr": "IS", "Value": [28]},
        "1924": {"vr": "IS", "Value": [5]},
        "1925": {"vr": "IS", "Value": [20]},
        "1926": {"vr": "IS", "Value": [55]},
        "1927": {"vr": "IS", "Value": [29]},
        "1928": {"vr": "IS", "Value": [20]},
        "1929": {"vr": "IS", "Value": [32]},
        "1930": {"vr": "IS", "Value": [50]},
        "1931": {"vr": "IS", "Value": [28]},
        "1932": {"vr": "IS", "Value": [58]},
        "1933": {"vr": "IS", "Value": [45]},
        "1934": {"vr": "IS", "Value": [7]},
        "1935": {"vr": "IS", "Value": [58]},
        "1936": {"vr": "IS", "Value": [11]},
        "1937": {"vr": "IS", "Value": [49]},
        "1938": {"vr": "IS", "Value": [59]},
        "1939": {"vr": "IS", "Value": [31]},
        "1940": {"vr": "IS", "Value": [21]},
        "1941": {"vr": "IS", "Value": [24]},
        "1942": {"vr": "IS", "Value": [42]},
        "1943": {"vr": "IS", "Value": [9]},
        "1944": {"vr": "IS", "Value": [42]},
        "1945": {"vr": "IS", "Value": [46]},
        "1946": {"vr": "IS", "Value": [26]},
        "1947": {"vr": "IS", "Value": [26]},
        "1948": {"vr": "IS", "Value": [58]},
        "1949": {"vr": "IS", "Value": [12]},
        "1950": {"vr": "IS", "Value": [50]},
        "1951": {"vr": "IS", "Value": [39]},
        "1952": {"vr": "IS", "Value": [43]},
        "1953": {"vr": "IS", "Value": [31]},
        "1954": {"vr": "IS", "Value": [5]},
        "1955": {"vr": "IS", "Value": [15]},
        "1956": {"vr": "IS", "Value": [52]},
        "1957": {"vr": "IS", "Value": [36]},
        "1958": {"vr": "IS", "Value": [42]},
        "1959": {"vr": "IS", "Value": [31]},
        "1960": {"vr": "IS", "Value": [21]},
        "1961": {"vr": "IS", "Value": [1]},
        "1962": {"vr": "IS", "Value": [47]},
        "1963": {"vr": "IS", "Value": [43]},
        "1964": {"vr": "IS", "Value": [33]},
        "1965": {"vr": "IS", "Value": [26]},
        "1966": {"vr": "IS", "Value": [49]},
        "1967": {"vr": "IS", "Value": [67]},
        "1968": {"vr": "IS", "Value": [44]},
        "1969": {"vr": "IS", "Value": [65]},
        "1970": {"vr": "IS", "Value": [19]},
        "1971": {"vr": "IS", "Value": [25]},
        "1972": {"vr": "IS", "Value": [35]},
        "1973": {"vr": "IS", "Value": [67]},
        "1974": {"vr": "IS", "Value": [20]},
        "1975": {"vr": "IS", "Value": [54]},
        "1976": {"vr": "IS", "Value": [5]},
        "1977": {"vr": "IS", "Value": [35]},
        "1978": {"vr": "IS", "Value": [11]},
        "1979": {"vr": "IS", "Value": [49]},
        "1980": {"vr": "IS", "Value": [25]},
        "1981": {"vr": "IS", "Value": [40]},
        "1982": {"vr": "IS", "Value": [51]},
        "1983": {"vr": "IS", "Value": [35]},
        "1984": {"vr": "IS", "Value": [9]},
        "1985": {"vr": "IS", "Value": [35]},
        "1986": {"vr": "IS", "Value": [56]},
        "1987": {"vr": "IS", "Value": [64]},
        "1988": {"vr": "IS", "Value": [4]},
        "1989": {"vr": "IS", "Value": [35]},
        "1990": {"vr": "IS", "Value": [49]},
        "1991": {"vr": "IS", "Value": [29]},
        "1992": {"vr": "IS", "Value": [18]},
        "1993": {"vr": "IS", "Value": [34]},
        "1994": {"vr": "IS", "Value": [60]},
        "1995": {"vr": "IS", "Value": [62]},
        "1996": {"vr": "IS", "Value": [34]},
        "1997": {"vr": "IS", "Value": [6]},
        "1998": {"vr": "IS", "Value": [42]},
        "1999": {"vr": "IS", "Value": [44]},
        "2000": {"vr": "IS", "Value": [53]},
        "2001": {"vr": "IS", "Value": [67]},
        "2002": {"vr": "IS", "Value": [50]},
        "2003": {"vr": "IS", "Value": [4]},
        "2004": {"vr": "IS", "Value": [46]},
        "2005": {"vr": "IS", "Value": [11]},
        "2006": {"vr": "IS", "Value": [32]},
        "2007": {"vr": "IS", "Value": [7]},
        "2008": {"vr": "IS", "Value": [13]},
        "2009": {"vr": "IS", "Value": [66]},
        "2010": {"vr": "IS", "Value": [10]},
        "2011": {"vr": "IS", "Value": [59]},
        "2012": {"vr": "IS", "Value": [1]},
        "2013": {"vr": "IS", "Value": [54]},
        "2014": {"vr": "IS", "Value": [27]},
        "2015": {"vr": "IS", "Value": [52]},
        "2016": {"vr": "IS", "Value": [35]},
        "2017": {"vr": "IS", "Value": [34]},
        "2018": {"vr": "IS", "Value": [58]},
        "2019": {"vr": "IS", "Value": [33]},
        "2020": {"vr": "IS", "Value": [65]},
        "2021": {"vr": "IS", "Value": [24]},
        "2022": {"vr": "IS", "Value": [41]},
        "2023": {"vr": "IS", "Value": [22]},
        "2024": {"vr": "IS", "Value": [62]},
        "2025": {"vr": "IS", "Value": [12]},
        "2026": {"vr": "IS", "Value": [61]},
        "2027": {"vr": "IS", "Value": [20]},
        "2028": {"vr": "IS", "Value": [44]},
        "2029": {"vr": "IS", "Value": [12]},
        "2030": {"vr": "IS", "Value": [66]},
        "2031": {"vr": "IS", "Value": [36]},
        "2032": {"vr": "IS", "Value": [10]},
        "2033": {"vr": "IS", "Value": [64]},
        "2034": {"vr": "IS", "Value": [39]},
        "2035": {"vr": "IS", "Value": [35]},
        "2036": {"vr": "IS", "Value": [21]},
        "2037": {"vr": "IS", "Value": [17]},
        "2038": {"vr": "IS", "Value": [52]},
        "2039": {"vr": "IS", "Value": [33]},
        "2040": {"vr": "IS", "Value": [9]},
        "2041": {"vr": "IS", "Value": [42]},
        "2042": {"vr": "IS", "Value": [9]},
        "2043": {"vr": "IS", "Value": [54]},
        "2044": {"vr": "IS", "Value": [27]},
        "2045": {"vr": "IS", "Value": [40]},
        "2046": {"vr": "IS", "Value": [19]},
        "2047": {"vr": "IS", "Value": [65]},
        "2048": {"vr": "IS", "Value": [22]},
        "2049": {"vr": "IS", "Value": [35]},
        "2050": {"vr": "IS", "Value": [5]},
        "2051": {"vr": "IS", "Value": [28]},
        "2052": {"vr": "IS", "Value": [8]},
        "2053": {"vr": "IS", "Value": [49]},
        "2054": {"vr": "IS", "Value": [32]},
        "2055": {"vr": "IS", "Value": [25]},
        "2056": {"vr": "IS", "Value": [43]},
        "2057": {"vr": "IS", "Value": [62]},
        "2058": {"vr": "IS", "Value": [66]},
        "2059": {"vr": "IS", "Value": [59]},
        "2060": {"vr": "IS", "Value": [13]},
        "2061": {"vr": "IS", "Value": [38]},
        "2062": {"vr": "IS", "Value": [18]},
        "2063": {"vr": "IS", "Value": [40]},
        "2064": {"vr": "IS", "Value": [56]},
        "2065": {"vr": "IS", "Value": [62]},
        "2066": {"vr": "IS", "Value": [38]},
        "2067": {"vr": "IS", "Value": [25]},
        "2068": {"vr": "IS", "Value": [25]},
        "2069": {"vr": "IS", "Value": [60]},
        "2070": {"vr": "IS", "Value": [39]},
        "2071": {"vr": "IS", "Value": [50]},
        "2072": {"vr": "IS", "Value": [35]},
        "2073": {"vr": "IS", "Value": [43]},
        "2074": {"vr": "IS", "Value": [17]},
        "2075": {"vr": "IS", "Value": [23]},
        "2076": {"vr": "IS", "Value": [42]},
        "2077": {"vr": "IS", "Value": [55]},
        "2078": {"vr": "IS", "Value": [19]},
        "2079": {"vr": "IS", "Value": [23]},
        "2080": {"vr": "IS", "Value": [21]},
        "2081": {"vr": "IS", "Value": [60]},
        "2082": {"vr": "IS", "Value": [23]},
        "2083": {"vr": "IS", "Value": [34]},
        "2084": {"vr": "IS", "Value": [34]},
        "2085": {"vr": "IS", "Value": [16]},
        "2086": {"vr": "IS", "Value": [56]},
        "2087": {"vr": "IS", "Value": [62]},
        "2088": {"vr": "IS", "Value": [47]},
        "2089": {"vr": "IS", "Value": [19]},
        "2090": {"vr": "IS", "Value": [35]},
        "2091": {"vr": "IS", "Value": [39]},
        "2092": {"vr": "IS", "Value": [46]},
        "2093": {"vr": "IS", "Value": [66]},
        "2094": {"vr": "IS", "Value": [65]},
        "2095": {"vr": "IS", "Value": [26]},
        "2096": {"vr": "IS", "Value": [13]},
        "2097": {"vr": "IS", "Value": [13]},
        "2098": {"vr": "IS", "Value": [1]},
        "2099": {"vr": "IS", "Value": [53]},
        "2100": {"vr": "IS", "Value": [42]},
        "2101": {"vr": "IS", "Value": [53]},
        "2102": {"vr": "IS", "Value": [30]},
        "2103": {"vr": "IS", "Value": [2]},
        "2104": {"vr": "IS", "Value": [53]},
        "2105": {"vr": "IS", "Value": [5]},
        "2106": {"vr": "IS", "Value": [17]},
        "2107": {"vr": "IS", "Value": [41]},
        "2108": {"vr": "IS", "Value": [9]},
        "2109": {"vr": "IS", "Value": [56]},
        "2110": {"vr": "IS", "Value": [60]},
        "2111": {"vr": "IS", "Value": [13]},
        "2112": {"vr": "IS", "Value": [19]},
        "2113": {"vr": "IS", "Value": [36]},
        "2114": {"vr": "IS", "Value": [57]},
        "2115": {"vr": "IS", "Value": [5]},
        "2116": {"vr": "IS", "Value": [36]},
        "2117": {"vr": "IS", "Value": [21]},
        "2118": {"vr": "IS", "Value": [15]},
        "2119": {"vr": "IS", "Value": [39]},
        "2120": {"vr": "IS", "Value": [66]},
        "2121": {"vr": "IS", "Value": [11]},
        "2122": {"vr": "IS", "Value": [2]},
        "2123": {"vr": "IS", "Value": [10]},
        "2124": {"vr": "IS", "Value": [5]},
        "2125": {"vr": "IS", "Value": [21]},
        "2126": {"vr": "IS", "Value": [4]},
        "2127": {"vr": "IS", "Value": [29]},
        "2128": {"vr": "IS", "Value": [40]},
        "2129": {"vr": "IS", "Value": [61]},
        "2130": {"vr": "IS", "Value": [29]},
        "2131": {"vr": "IS", "Value": [63]},
        "2132": {"vr": "IS", "Value": [45]},
        "2133": {"vr": "IS", "Value": [7]},
        "2134": {"vr": "IS", "Value": [13]},
        "2135": {"vr": "IS", "Value": [16]},
        "2136": {"vr": "IS", "Value": [11]},
        "2137": {"vr": "IS", "Value": [24]},
        "2138": {"vr": "IS", "Value": [28]},
        "2139": {"vr": "IS", "Value": [35]},
        "2140": {"vr": "IS", "Value": [35]},
        "2141": {"vr": "IS", "Value": [42]},
        "2142": {"vr": "IS", "Value": [31]},
        "2143": {"vr": "IS", "Value": [65]},
        "2144": {"vr": "IS", "Value": [40]},
        "2145": {"vr": "IS", "Value": [18]},
        "2146": {"vr": "IS", "Value": [67]},
        "2147": {"vr": "IS", "Value": [10]},
        "2148": {"vr": "IS", "Value": [10]},
        "2149": {"vr": "IS", "Value": [62]},
        "2150": {"vr": "IS", "Value": [63]},
        "2151": {"vr": "IS", "Value": [36]},
        "2152": {"vr": "IS", "Value": [6]},
        "2153": {"vr": "IS", "Value": [16]},
        "2154": {"vr": "IS", "Value": [44]},
        "2155": {"vr": "IS", "Value": [40]},
        "2156": {"vr": "IS", "Value": [47]},
        "2157": {"vr": "IS", "Value": [33]},
        "2158": {"vr": "IS", "Value": [45]},
        "2159": {"vr": "IS", "Value": [33]},
        "2160": {"vr": "IS", "Value": [32]},
        "2161": {"vr": "IS", "Value": [14]},
        "2162": {"vr": "IS", "Value": [6]},
        "2163": {"vr": "IS", "Value": [31]},
        "2164": {"vr": "IS", "Value": [41]},
        "2165": {"vr": "IS", "Value": [23]},
        "2166": {"vr": "IS", "Value": [30]},
        "2167": {"vr": "IS", "Value": [43]},
        "2168": {"vr": "IS", "Value": [65]},
        "2169": {"vr": "IS", "Value": [19]},
        "2170": {"vr": "IS", "Value": [34]},
        "2171": {"vr": "IS", "Value": [63]},
        "2172": {"vr": "IS", "Value": [13]},
        "2173": {"vr": "IS", "Value": [52]},
        "2174": {"vr": "IS", "Value": [34]},
        "2175": {"vr": "IS", "Value": [20]},
        "2176": {"vr": "IS", "Value": [41]},
        "2177": {"vr": "IS", "Value": [66]},
        "2178": {"vr": "IS", "Value": [13]},
        "2179": {"vr": "IS", "Value": [42]},
        "2180": {"vr": "IS", "Value": [9]},
        "2181": {"vr": "IS", "Value": [17]},
        "2182": {"vr": "IS", "Value": [46]},
        "2183": {"vr": "IS", "Value": [58]},
        "2184": {"vr": "IS", "Value": [49]},
        "2185": {"vr": "IS", "Value": [33]},
        "2186": {"vr": "IS", "Value": [52]},
        "2187": {"vr": "IS", "Value": [67]},
        "2188": {"vr": "IS", "Value": [43]},
        "2189": {"vr": "IS", "Value": [19]},
        "2190": {"vr": "IS", "Value": [5]},
        "2191": {"vr": "IS", "Value": [11]},
        "2192": {"vr": "IS", "Value": [23]},
        "2193": {"vr": "IS", "Value": [53]},
        "2194": {"vr": "IS", "Value": [4]},
        "2195": {"vr": "IS", "Value": [27]},
        "2196": {"vr": "IS", "Value": [42]},
        "2197": {"vr": "IS", "Value": [33]},
        "2198": {"vr": "IS", "Value": [60]},
        "2199": {"vr": "IS", "Value": [52]},
        "2200": {"vr": "IS", "Value": [13]},
        "2201": {"vr": "IS", "Value": [20]},
        "2202": {"vr": "IS", "Value": [57]},
        "2203": {"vr": "IS", "Value": [48]},
        "2204": {"vr": "IS", "Value": [67]},
        "2205": {"vr": "IS", "Value": [7]},
        "2206": {"vr": "IS", "Value": [44]},
        "2207": {"vr": "IS", "Value": [40]},
        "2208": {"vr": "IS", "Value": [66]},
        "2209": {"vr": "IS", "Value": [54]},
        "2210": {"vr": "IS", "Value": [14]},
        "2211": {"vr": "IS", "Value": [5]},
        "2212": {"vr": "IS", "Value": [49]},
        "2213": {"vr": "IS", "Value": [48]},
        "2214": {"vr": "IS", "Value": [21]},
        "2215": {"vr": "IS", "Value": [55]},
        "2216": {"vr": "IS", "Value": [35]},
        "2217": {"vr": "IS", "Value": [47]},
        "2218": {"vr": "IS", "Value": [28]},
        "2219": {"vr": "IS", "Value": [15]},
        "2220": {"vr": "IS", "Value": [1]},
        "2221": {"vr": "IS", "Value": [11]},
        "2222": {"vr": "IS", "Value": [54]},
        "2223": {"vr": "IS", "Value": [38]},
        "2224": {"vr": "IS", "Value": [7]},
        "2225": {"vr": "IS", "Value": [39]},
        "2226": {"vr": "IS", "Value": [24]},
        "2227": {"vr": "IS", "Value": [61]},
        "2228": {"vr": "IS", "Value": [4]},
        "2229": {"vr": "IS", "Value": [62]},
        "2230": {"vr": "IS", "Value": [46]},
        "2231": {"vr": "IS", "Value": [51]},
        "2232": {"vr": "IS", "Value": [42]},
        "2233": {"vr": "IS", "Value": [66]},
        "2234": {"vr": "IS", "Value": [37]},
        "2235": {"vr": "IS", "Value": [48]},
        "2236": {"vr": "IS", "Value": [50]},
        "2237": {"vr": "IS", "Value": [41]},
        "2238": {"vr": "IS", "Value": [51]},
        "2239": {"vr": "IS", "Value": [12]},
        "2240": {"vr": "IS", "Value": [21]},
        "2241": {"vr": "IS", "Value": [11]},
        "2242": {"vr": "IS", "Value": [42]},
        "2243": {"vr": "IS", "Value": [8]},
        "2244": {"vr": "IS", "Value": [5]},
        "2245": {"vr": "IS", "Value": [29]},
        "2246": {"vr": "IS", "Value": [3]},
        "2247": {"vr": "IS", "Value": [41]},
        "2248": {"vr": "IS", "Value": [8]},
        "2249": {"vr": "IS", "Value": [58]},
        "2250": {"vr": "IS", "Value": [54]},
        "2251": {"vr": "IS", "Value": [14]},
        "2252": {"vr": "IS", "Value": [2]},
        "2253": {"vr": "IS", "Value": [58]},
        "2254": {"vr": "IS", "Value": [67]},
        "2255": {"vr": "IS", "Value": [22]},
        "2256": {"vr": "IS", "Value": [66]},
        "2257": {"vr": "IS", "Value": [47]},
        "2258": {"vr": "IS", "Value": [10]},
        "2259": {"vr": "IS", "Value": [12]},
        "2260": {"vr": "IS", "Value": [36]},
        "2261": {"vr": "IS", "Value": [19]},
        "2262": {"vr": "IS", "Value": [65]},
        "2263": {"vr": "IS", "Value": [56]},
        "2264": {"vr": "IS", "Value": [47]},
        "2265": {"vr": "IS", "Value": [31]},
        "2266": {"vr": "IS", "Value": [44]},
        "2267": {"vr": "IS", "Value": [63]},
        "2268": {"vr": "IS", "Value": [41]},
        "2269": {"vr": "IS", "Value": [10]},
        "2270": {"vr": "IS", "Value": [47]},
        "2271": {"vr": "IS", "Value": [22]},
        "2272": {"vr": "IS", "Value": [63]},
        "2273": {"vr": "IS", "Value": [27]},
        "2274": {"vr": "IS", "Value": [55]},
        "2275": {"vr": "IS", "Value": [37]},
        "2276": {"vr": "IS", "Value": [41]},
        "2277": {"vr": "IS", "Value": [36]},
        "2278": {"vr": "IS", "Value": [56]},
        "2279": {"vr": "IS", "Value": [65]},
        "2280": {"vr": "IS", "Value": [11]},
        "2281": {"vr": "IS", "Value": [50]},
        "2282": {"vr": "IS", "Value": [17]},
        "2283": {"vr": "IS", "Value": [18]},
        "2284": {"vr": "IS", "Value": [33]},
        "2285": {"vr": "IS", "Value": [54]},
        "2286": {"vr": "IS", "Value": [59]},
        "2287": {"vr": "IS", "Value": [1]},
        "2288": {"vr": "IS", "Value": [66]},
        "2289": {"vr": "IS", "Value": [3]},
        "2290": {"vr": "IS", "Value": [14]},
        "2291": {"vr": "IS", "Value": [45]},
        "2292": {"vr": "IS", "Value": [60]},
        "2293": {"vr": "IS", "Value": [15]},
        "2294": {"vr": "IS", "Value": [36]},
        "2295": {"vr": "IS", "Value": [34]},
        "2296": {"vr": "IS", "Value": [45]},
        "2297": {"vr": "IS", "Value": [60]},
        "2298": {"vr": "IS", "Value": [44]},
        "2299": {"vr": "IS", "Value": [64]},
        "2300": {"vr": "IS", "Value": [53]},
        "2301": {"vr": "IS", "Value": [43]},
        "2302": {"vr": "IS", "Value": [15]},
        "2303": {"vr": "IS", "Value": [46]},
        "2304": {"vr": "IS", "Value": [38]},
        "2305": {"vr": "IS", "Value": [2]},
        "2306": {"vr": "IS", "Value": [4]},
        "2307": {"vr": "IS", "Value": [48]},
        "2308": {"vr": "IS", "Value": [50]},
        "2309": {"vr": "IS", "Value": [30]},
        "2310": {"vr": "IS", "Value": [26]},
        "2311": {"vr": "IS", "Value": [48]},
        "2312": {"vr": "IS", "Value": [57]},
        "2313": {"vr": "IS", "Value": [1]},
        "2314": {"vr": "IS", "Value": [29]},
        "2315": {"vr": "IS", "Value": [66]},
        "2316": {"vr": "IS", "Value": [3]},
        "2317": {"vr": "IS", "Value": [50]},
        "2318": {"vr": "IS", "Value": [46]},
        "2319": {"vr": "IS", "Value": [18]},
        "2320": {"vr": "IS", "Value": [30]},
        "2321": {"vr": "IS", "Value": [20]},
        "2322": {"vr": "IS", "Value": [5]},
        "2323": {"vr": "IS", "Value": [59]},
        "2324": {"vr": "IS", "Value": [47]},
        "2325": {"vr": "IS", "Value": [64]},
        "2326": {"vr": "IS", "Value": [18]},
        "2327": {"vr": "IS", "Value": [30]},
        "2328": {"vr": "IS", "Value": [21]},
        "2329": {"vr": "IS", "Value": [28]},
        "2330": {"vr": "IS", "Value": [50]},
        "2331": {"vr": "IS", "Value": [15]},
        "2332": {"vr": "IS", "Value": [47]},
        "2333": {"vr": "IS", "Value": [42]},
        "2334": {"vr": "IS", "Value": [36]},
        "2335": {"vr": "IS", "Value": [24]},
        "2336": {"vr": "IS", "Value": [6]},
        "2337": {"vr": "IS", "Value": [44]},
        "2338": {"vr": "IS", "Value": [8]},
        "2339": {"vr": "IS", "Value": [20]},
        "2340": {"vr": "IS", "Value": [56]},
        "2341": {"vr": "IS", "Value": [39]},
        "2342": {"vr": "IS", "Value": [57]},
        "2343": {"vr": "IS", "Value": [27]},
        "2344": {"vr": "IS", "Value": [24]},
        "2345": {"vr": "IS", "Value": [28]},
        "2346": {"vr": "IS", "Value": [56]},
        "2347": {"vr": "IS", "Value": [13]},
        "2348": {"vr": "IS", "Value": [41]},
        "2349": {"vr": "IS", "Value": [16]},
        "2350": {"vr": "IS", "Value": [7]},
        "2351": {"vr": "IS", "Value": [46]},
        "2352": {"vr": "IS", "Value": [21]},
        "2353": {"vr": "IS", "Value": [59]},
        "2354": {"vr": "IS", "Value": [9]},
        "2355": {"vr": "IS", "Value": [2]},
        "2356": {"vr": "IS", "Value": [24]},
        "2357": {"vr": "IS", "Value": [64]},
        "2358": {"vr": "IS", "Value": [22]},
        "2359": {"vr": "IS", "Value": [56]},
        "2360": {"vr": "IS", "Value": [12]},
        "2361": {"vr": "IS", "Value": [66]},
        "2362": {"vr": "IS", "Value": [53]},
        "2363": {"vr": "IS", "Value": [65]},
        "2364": {"vr": "IS", "Value": [61]},
        "2365": {"vr": "IS", "Value": [6]},
        "2366": {"vr": "IS", "Value": [24]},
        "2367": {"vr": "IS", "Value": [39]},
        "2368": {"vr": "IS", "Value": [52]},
        "2369": {"vr": "IS", "Value": [1]},
        "2370": {"vr": "IS", "Value": [5]},
        "2371": {"vr": "IS", "Value": [39]},
        "2372": {"vr": "IS", "Value": [22]},
        "2373": {"vr": "IS", "Value": [9]},
        "2374": {"vr": "IS", "Value": [6]},
        "2375": {"vr": "IS", "Value": [33]},
        "2376": {"vr": "IS", "Value": [12]},
        "2377": {"vr": "IS", "Value": [4]},
        "2378": {"vr": "IS", "Value": [55]},
        "2379": {"vr": "IS", "Value": [8]},
        "2380": {"vr": "IS", "Value": [58]},
        "2381": {"vr": "IS", "Value": [45]},
        "2382": {"vr": "IS", "Value": [45]},
        "2383": {"vr": "IS", "Value": [28]},
        "2384": {"vr": "IS", "Value": [32]},
        "2385": {"vr": "IS", "Value": [34]},
        "2386": {"vr": "IS", "Value": [58]},
        "2387": {"vr": "IS", "Value": [17]},
        "2388": {"vr": "IS", "Value": [63]},
        "2389": {"vr": "IS", "Value": [6]},
        "2390": {"vr": "IS", "Value": [66]},
        "2391": {"vr": "IS", "Value": [18]},
        "2392": {"vr": "IS", "Value": [17]},
        "2393": {"vr": "IS", "Value": [5]},
        "2394": {"vr": "IS", "Value": [45]},
        "2395": {"vr": "IS", "Value": [59]},
        "2396": {"vr": "IS", "Value": [27]},
        "2397": {"vr": "IS", "Value": [58]},
        "2398": {"vr": "IS", "Value": [54]},
        "2399": {"vr": "IS", "Value": [61]},
        "2400": {"vr": "IS", "Value": [56]},
        "2401": {"vr": "IS", "Value": [25]},
        "2402": {"vr": "IS", "Value": [57]},
        "2403": {"vr": "IS", "Value": [49]},
        "2404": {"vr": "IS", "Value": [46]},
        "2405": {"vr": "IS", "Value": [47]},
        "2406": {"vr": "IS", "Value": [10]},
        "2407": {"vr": "IS", "Value": [21]},
        "2408": {"vr": "IS", "Value": [5]},
        "2409": {"vr": "IS", "Value": [26]},
        "2410": {"vr": "IS", "Value": [65]},
        "2411": {"vr": "IS", "Value": [42]},
        "2412": {"vr": "IS", "Value": [46]},
        "2413": {"vr": "IS", "Value": [53]},
        "2414": {"vr": "IS", "Value": [38]},
        "2415": {"vr": "IS", "Value": [7]},
        "2416": {"vr": "IS", "Value": [9]},
        "2417": {"vr": "IS", "Value": [67]},
        "2418": {"vr": "IS", "Value": [45]},
        "2419": {"vr": "IS", "Value": [19]},
        "2420": {"vr": "IS", "Value": [49]},
        "2421": {"vr": "IS", "Value": [47]},
        "2422": {"vr": "IS", "Value": [50]},
        "2423": {"vr": "IS", "Value": [3]},
        "2424": {"vr": "IS", "Value": [9]},
        "2425": {"vr": "IS", "Value": [42]},
        "2426": {"vr": "IS", "Value": [4]},
        "2427": {"vr": "IS", "Value": [18]},
        "2428": {"vr": "IS", "Value": [40]},
        "2429": {"vr": "IS", "Value": [30]},
        "2430": {"vr": "IS", "Value": [28]},
        "2431": {"vr": "IS", "Value": [4]},
        "2432": {"vr": "IS", "Value": [4]},
        "2433": {"vr": "IS", "Value": [23]},
        "2434": {"vr": "IS", "Value": [21]},
        "2435": {"vr": "IS", "Value": [61]},
        "2436": {"vr": "IS", "Value": [13]},
        "2437": {"vr": "IS", "Value": [44]},
        "2438": {"vr": "IS", "Value": [8]},
        "2439": {"vr": "IS", "Value": [43]},
        "2440": {"vr": "IS", "Value": [40]},
        "2441": {"vr": "IS", "Value": [58]},
        "2442": {"vr": "IS", "Value": [47]},
        "2443": {"vr": "IS", "Value": [52]},
        "2444": {"vr": "IS", "Value": [41]},
        "2445": {"vr": "IS", "Value": [47]},
        "2446": {"vr": "IS", "Value": [10]},
        "2447": {"vr": "IS", "Value": [30]},
        "2448": {"vr": "IS", "Value": [59]},
        "2449": {"vr": "IS", "Value": [4]},
        "2450": {"vr": "IS", "Value": [49]},
        "2451": {"vr": "IS", "Value": [37]},
        "2452": {"vr": "IS", "Value": [7]},
        "2453": {"vr": "IS", "Value": [29]},
        "2454": {"vr": "IS", "Value": [64]},
        "2455": {"vr": "IS", "Value": [18]},
        "2456": {"vr": "IS", "Value": [36]},
        "2457": {"vr": "IS", "Value": [35]},
        "2458": {"vr": "IS", "Value": [36]},
        "2459": {"vr": "IS", "Value": [64]},
        "2460": {"vr": "IS", "Value": [24]},
        "2461": {"vr": "IS", "Value": [20]},
        "2462": {"vr": "IS", "Value": [51]},
        "2463": {"vr": "IS", "Value": [61]},
        "2464": {"vr": "IS", "Value": [54]},
        "2465": {"vr": "IS", "Value": [46]},
        "2466": {"vr": "IS", "Value": [28]},
        "2467": {"vr": "IS", "Value": [37]},
        "2468": {"vr": "IS", "Value": [55]},
        "2469": {"vr": "IS", "Value": [32]},
        "2470": {"vr": "IS", "Value": [13]},
        "2471": {"vr": "IS", "Value": [44]},
        "2472": {"vr": "IS", "Value": [32]},
        "2473": {"vr": "IS", "Value": [21]},
        "2474": {"vr": "IS", "Value": [2]},
        "2475": {"vr": "IS", "Value": [44]},
        "2476": {"vr": "IS", "Value": [42]},
        "2477": {"vr": "IS", "Value": [64]},
        "2478": {"vr": "IS", "Value": [9]},
        "2479": {"vr": "IS", "Value": [12]},
        "2480": {"vr": "IS", "Value": [56]},
        "2481": {"vr": "IS", "Value": [58]},
        "2482": {"vr": "IS", "Value": [25]},
        "2483": {"vr": "IS", "Value": [57]},
        "2484": {"vr": "IS", "Value": [8]},
        "2485": {"vr": "IS", "Value": [21]},
        "2486": {"vr": "IS", "Value": [21]},
        "2487": {"vr": "IS", "Value": [55]},
        "2488": {"vr": "IS", "Value": [64]},
        "2489": {"vr": "IS", "Value": [63]},
        "2490": {"vr": "IS", "Value": [48]},
        "2491": {"vr": "IS", "Value": [9]},
        "2492": {"vr": "IS", "Value": [36]},
        "2493": {"vr": "IS", "Value": [41]},
        "2494": {"vr": "IS", "Value": [63]},
        "2495": {"vr": "IS", "Value": [22]},
        "2496": {"vr": "IS", "Value": [14]},
        "2497": {"vr": "IS", "Value": [57]},
        "2498": {"vr": "IS", "Value": [46]},
        "2499": {"vr": "IS", "Value": [25]},
        "2500": {"vr": "IS", "Value": [59]},
        "2501": {"vr": "IS", "Value": [31]},
        "2502": {"vr": "IS", "Value": [7]},
        "2503": {"vr": "IS", "Value": [55]},
        "2504": {"vr": "IS", "Value": [15]},
        "2505": {"vr": "IS", "Value": [46]},
        "2506": {"vr": "IS", "Value": [26]},
        "2507": {"vr": "IS", "Value": [44]},
        "2508": {"vr": "IS", "Value": [40]},
        "2509": {"vr": "IS", "Value": [16]},
        "2510": {"vr": "IS", "Value": [49]},
        "2511": {"vr": "IS", "Value": [27]},
        "2512": {"vr": "IS", "Value": [40]},
        "2513": {"vr": "IS", "Value": [63]},
        "2514": {"vr": "IS", "Value": [22]},
        "2515": {"vr": "IS", "Value": [6]},
        "2516": {"vr": "IS", "Value": [6]},
        "2517": {"vr": "IS", "Value": [60]},
        "2518": {"vr": "IS", "Value": [30]},
        "2519": {"vr": "IS", "Value": [25]},
        "2520": {"vr": "IS", "Value": [45]},
        "2521": {"vr": "IS", "Value": [55]},
        "2522": {"vr": "IS", "Value": [67]},
        "2523": {"vr": "IS", "Value": [8]},
        "2524": {"vr": "IS", "Value": [37]},
        "2525": {"vr": "IS", "Value": [67]},
        "2526": {"vr": "IS", "Value": [21]},
        "2527": {"vr": "IS", "Value": [21]},
        "2528": {"vr": "IS", "Value": [57]},
        "2529": {"vr": "IS", "Value": [24]},
        "2530": {"vr": "IS", "Value": [53]},
        "2531": {"vr": "IS", "Value": [51]},
        "2532": {"vr": "IS", "Value": [40]},
        "2533": {"vr": "IS", "Value": [5]},
        "2534": {"vr": "IS", "Value": [45]},
        "2535": {"vr": "IS", "Value": [41]},
        "2536": {"vr": "IS", "Value": [29]},
        "2537": {"vr": "IS", "Value": [34]},
        "2538": {"vr": "IS", "Value": [47]},
        "2539": {"vr": "IS", "Value": [67]},
        "2540": {"vr": "IS", "Value": [66]},
        "2541": {"vr": "IS", "Value": [36]},
        "2542": {"vr": "IS", "Value": [22]},
        "2543": {"vr": "IS", "Value": [51]},
        "2544": {"vr": "IS", "Value": [10]},
        "2545": {"vr": "IS", "Value": [40]},
        "2546": {"vr": "IS", "Value": [45]},
        "2547": {"vr": "IS", "Value": [13]},
        "2548": {"vr": "IS", "Value": [23]},
        "2549": {"vr": "IS", "Value": [36]},
        "2550": {"vr": "IS", "Value": [62]},
        "2551": {"vr": "IS", "Value": [53]},
        "2552": {"vr": "IS", "Value": [65]},
        "2553": {"vr": "IS", "Value": [7]},
        "2554": {"vr": "IS", "Value": [20]},
        "2555": {"vr": "IS", "Value": [42]},
        "2556": {"vr": "IS", "Value": [60]},
        "2557": {"vr": "IS", "Value": [56]},
        "2558": {"vr": "IS", "Value": [38]},
        "2559": {"vr": "IS", "Value": [57]},
        "2560": {"vr": "IS", "Value": [63]},
        "2561": {"vr": "IS", "Value": [29]},
        "2562": {"vr": "IS", "Value": [43]},
        "2563": {"vr": "IS", "Value": [25]},
        "2564": {"vr": "IS", "Value": [17]},
        "2565": {"vr": "IS", "Value": [58]},
        "2566": {"vr": "IS", "Value": [50]},
        "2567": {"vr": "IS", "Value": [44]},
        "2568": {"vr": "IS", "Value": [64]},
        "2569": {"vr": "IS", "Value": [11]},
        "2570": {"vr": "IS", "Value": [62]},
        "2571": {"vr": "IS", "Value": [12]},
        "2572": {"vr": "IS", "Value": [67]},
        "2573": {"vr": "IS", "Value": [5]},
        "2574": {"vr": "IS", "Value": [43]},
        "2575": {"vr": "IS", "Value": [8]},
        "2576": {"vr": "IS", "Value": [52]},
        "2577": {"vr": "IS", "Value": [21]},
        "2578": {"vr": "IS", "Value": [3]},
        "2579": {"vr": "IS", "Value": [2]},
        "2580": {"vr": "IS", "Value": [66]},
        "2581": {"vr": "IS", "Value": [35]},
        "2582": {"vr": "IS", "Value": [35]},
        "2583": {"vr": "IS", "Value": [28]},
        "2584": {"vr": "IS", "Value": [23]},
        "2585": {"vr": "IS", "Value": [56]},
        "2586": {"vr": "IS", "Value": [43]},
        "2587": {"vr": "IS", "Value": [50]},
        "2588": {"vr": "IS", "Value": [2]},
        "2589": {"vr": "IS", "Value": [66]},
        "2590": {"vr": "IS", "Value": [41]},
        "2591": {"vr": "IS", "Value": [62]},
        "2592": {"vr": "IS", "Value": [26]},
        "2593": {"vr": "IS", "Value": [29]},
        "2594": {"vr": "IS", "Value": [20]},
        "2595": {"vr": "IS", "Value": [60]},
        "2596": {"vr": "IS", "Value": [20]},
        "2597": {"vr": "IS", "Value": [64]},
        "2598": {"vr": "IS", "Value": [19]},
        "2599": {"vr": "IS", "Value": [41]},
        "2600": {"vr": "IS", "Value": [52]},
        "2601": {"vr": "IS", "Value": [57]},
        "2602": {"vr": "IS", "Value": [30]},
        "2603": {"vr": "IS", "Value": [52]},
        "2604": {"vr": "IS", "Value": [59]},
        "2605": {"vr": "IS", "Value": [47]},
        "2606": {"vr": "IS", "Value": [54]},
        "2607": {"vr": "IS", "Value": [47]},
        "2608": {"vr": "IS", "Value": [65]},
        "2609": {"vr": "IS", "Value": [45]},
        "2610": {"vr": "IS", "Value": [19]},
        "2611": {"vr": "IS", "Value": [23]},
        "2612": {"vr": "IS", "Value": [15]},
        "2613": {"vr": "IS", "Value": [8]},
        "2614": {"vr": "IS", "Value": [44]},
        "2615": {"vr": "IS", "Value": [59]},
        "2616": {"vr": "IS", "Value": [20]},
        "2617": {"vr": "IS", "Value": [48]},
        "2618": {"vr": "IS", "Value": [45]},
        "2619": {"vr": "IS", "Value": [28]},
        "2620": {"vr": "IS", "Value": [19]},
        "2621": {"vr": "IS", "Value": [37]},
        "2622": {"vr": "IS", "Value": [60]},
        "2623": {"vr": "IS", "Value": [57]},
        "2624": {"vr": "IS", "Value": [57]},
        "2625": {"vr": "IS", "Value": [25]},
        "2626": {"vr": "IS", "Value": [66]},
        "2627": {"vr": "IS", "Value": [55]},
        "2628": {"vr": "IS", "Value": [67]},
        "2629": {"vr": "IS", "Value": [12]},
        "2630": {"vr": "IS", "Value": [32]},
        "2631": {"vr": "IS", "Value": [30]},
        "2632": {"vr": "IS", "Value": [15]},
        "2633": {"vr": "IS", "Value": [33]},
        "2634": {"vr": "IS", "Value": [24]},
        "2635": {"vr": "IS", "Value": [4]},
        "2636": {"vr": "IS", "Value": [56]},
        "2637": {"vr": "IS", "Value": [31]},
        "2638": {"vr": "IS", "Value": [3]},
        "2639": {"vr": "IS", "Value": [45]},
        "2640": {"vr": "IS", "Value": [1]},
        "2641": {"vr": "IS", "Value": [10]},
        "2642": {"vr": "IS", "Value": [28]},
        "2643": {"vr": "IS", "Value": [66]},
        "2644": {"vr": "IS", "Value": [40]},
        "2645": {"vr": "IS", "Value": [55]},
        "2646": {"vr": "IS", "Value": [37]},
        "2647": {"vr": "IS", "Value": [49]},
        "2648": {"vr": "IS", "Value": [44]},
        "2649": {"vr": "IS", "Value": [14]},
        "2650": {"vr": "IS", "Value": [17]},
        "2651": {"vr": "IS", "Value": [22]},
        "2652": {"vr": "IS", "Value": [11]},
        "2653": {"vr": "IS", "Value": [62]},
        "2654": {"vr": "IS", "Value": [54]},
        "2655": {"vr": "IS", "Value": [4]},
        "2656": {"vr": "IS", "Value": [9]},
        "2657": {"vr": "IS", "Value": [18]},
        "2658": {"vr": "IS", "Value": [67]},
        "2659": {"vr": "IS", "Value": [25]},
        "2660": {"vr": "IS", "Value": [47]},
        "2661": {"vr": "IS", "Value": [58]},
        "2662": {"vr": "IS", "Value": [62]},
        "2663": {"vr": "IS", "Value": [6]},
        "2664": {"vr": "IS", "Value": [8]},
        "2665": {"vr": "IS", "Value": [8]},
        "2666": {"vr": "IS", "Value": [58]},
        "2667": {"vr": "IS", "Value": [19]},
        "2668": {"vr": "IS", "Value": [7]},
        "2669": {"vr": "IS", "Value": [10]},
        "2670": {"vr": "IS", "Value": [30]},
        "2671": {"vr": "IS", "Value": [25]},
        "2672": {"vr": "IS", "Value": [52]},
        "2673": {"vr": "IS", "Value": [13]},
        "2674": {"vr": "IS", "Value": [7]},
        "2675": {"vr": "IS", "Value": [9]},
        "2676": {"vr": "IS", "Value": [7]},
        "2677": {"vr": "IS", "Value": [30]},
        "2678": {"vr": "IS", "Value": [53]},
        "2679": {"vr": "IS", "Value": [34]},
        "2680": {"vr": "IS", "Value": [1]},
        "2681": {"vr": "IS", "Value": [48]},
        "2682": {"vr": "IS", "Value": [36]},
        "2683": {"vr": "IS", "Value": [50]},
        "2684": {"vr": "IS", "Value": [28]},
        "2685": {"vr": "IS", "Value": [44]},
        "2686": {"vr": "IS", "Value": [15]},
        "2687": {"vr": "IS", "Value": [39]},
        "2688": {"vr": "IS", "Value": [41]},
        "2689": {"vr": "IS", "Value": [24]},
        "2690": {"vr": "IS", "Value": [29]},
        "2691": {"vr": "IS", "Value": [10]},
        "2692": {"vr": "IS", "Value": [11]},
        "2693": {"vr": "IS", "Value": [41]},
        "2694": {"vr": "IS", "Value": [52]},
        "2695": {"vr": "IS", "Value": [49]},
        "2696": {"vr": "IS", "Value": [9]},
        "2697": {"vr": "IS", "Value": [62]},
        "2698": {"vr": "IS", "Value": [41]},
        "2699": {"vr": "IS", "Value": [16]},
        "2700": {"vr": "IS", "Value": [4]},
        "2701": {"vr": "IS", "Value": [27]},
        "2702": {"vr": "IS", "Value": [23]},
        "2703": {"vr": "IS", "Value": [64]},
        "2704": {"vr": "IS", "Value": [27]},
        "2705": {"vr": "IS", "Value": [6]},
        "2706": {"vr": "IS", "Value": [13]},
        "2707": {"vr": "IS", "Value": [61]},
        "2708": {"vr": "IS", "Value": [59]},
        "2709": {"vr": "IS", "Value": [55]},
        "2710": {"vr": "IS", "Value": [42]},
        "2711": {"vr": "IS", "Value": [7]},
        "2712": {"vr": "IS", "Value": [26]},
        "2713": {"vr": "IS", "Value": [64]},
        "2714": {"vr": "IS", "Value": [57]},
        "2715": {"vr": "IS", "Value": [39]},
        "2716": {"vr": "IS", "Value": [40]},
        "2717": {"vr": "IS", "Value": [25]},
        "2718": {"vr": "IS", "Value": [2]},
        "2719": {"vr": "IS", "Value": [38]},
        "2720": {"vr": "IS", "Value": [24]},
        "2721": {"vr": "IS", "Value": [62]},
        "2722": {"vr": "IS", "Value": [24]},
        "2723": {"vr": "IS", "Value": [66]},
        "2724": {"vr": "IS", "Value": [52]},
        "2725": {"vr": "IS", "Value": [51]},
        "2726": {"vr": "IS", "Value": [56]},
        "2727": {"vr": "IS", "Value": [28]},
        "2728": {"vr": "IS", "Value": [16]},
        "2729": {"vr": "IS", "Value": [29]},
        "2730": {"vr": "IS", "Value": [38]},
        "2731": {"vr": "IS", "Value": [26]},
        "2732": {"vr": "IS", "Value": [65]},
        "2733": {"vr": "IS", "Value": [61]},
        "2734": {"vr": "IS", "Value": [29]},
        "2735": {"vr": "IS", "Value": [10]},
        "2736": {"vr": "IS", "Value": [34]},
        "2737": {"vr": "IS", "Value": [29]},
        "2738": {"vr": "IS", "Value": [2]},
        "2739": {"vr": "IS", "Value": [38]},
        "2740": {"vr": "IS", "Value": [18]},
        "2741": {"vr": "IS", "Value": [67]},
        "2742": {"vr": "IS", "Value": [66]},
        "2743": {"vr": "IS", "Value": [61]},
        "2744": {"vr": "IS", "Value": [47]},
        "2745": {"vr": "IS", "Value": [3]},
        "2746": {"vr": "IS", "Value": [45]},
        "2747": {"vr": "IS", "Value": [53]},
        "2748": {"vr": "IS", "Value": [39]},
        "2749": {"vr": "IS", "Value": [24]},
        "2750": {"vr": "IS", "Value": [12]},
        "2751": {"vr": "IS", "Value": [51]},
        "2752": {"vr": "IS", "Value": [16]},
        "2753": {"vr": "IS", "Value": [2]},
        "2754": {"vr": "IS", "Value": [61]},
        "2755": {"vr": "IS", "Value": [16]},
        "2756": {"vr": "IS", "Value": [57]},
        "2757": {"vr": "IS", "Value": [23]},
        "2758": {"vr": "IS", "Value": [7]},
        "2759": {"vr": "IS", "Value": [11]},
        "2760": {"vr": "IS", "Value": [40]},
        "2761": {"vr": "IS", "Value": [28]},
        "2762": {"vr": "IS", "Value": [44]},
        "2763": {"vr": "IS", "Value": [13]},
        "2764": {"vr": "IS", "Value": [7]},
        "2765": {"vr": "IS", "Value": [34]},
        "2766": {"vr": "IS", "Value": [17]},
        "2767": {"vr": "IS", "Value": [35]},
        "2768": {"vr": "IS", "Value": [44]},
        "2769": {"vr": "IS", "Value": [9]},
        "2770": {"vr": "IS", "Value": [45]},
        "2771": {"vr": "IS", "Value": [4]},
        "2772": {"vr": "IS", "Value": [10]},
        "2773": {"vr": "IS", "Value": [58]},
        "2774": {"vr": "IS", "Value": [29]},
        "2775": {"vr": "IS", "Value": [2]},
        "2776": {"vr": "IS", "Value": [8]},
        "2777": {"vr": "IS", "Value": [45]},
        "2778": {"vr": "IS", "Value": [35]},
        "2779": {"vr": "IS", "Value": [51]},
        "2780": {"vr": "IS", "Value": [38]},
        "2781": {"vr": "IS", "Value": [67]},
        "2782": {"vr": "IS", "Value": [14]},
        "2783": {"vr": "IS", "Value": [9]},
        "2784": {"vr": "IS", "Value": [27]},
        "2785": {"vr": "IS", "Value": [35]},
        "2786": {"vr": "IS", "Value": [32]},
        "2787": {"vr": "IS", "Value": [63]},
        "2788": {"vr": "IS", "Value": [40]},
        "2789": {"vr": "IS", "Value": [44]},
        "2790": {"vr": "IS", "Value": [15]},
        "2791": {"vr": "IS", "Value": [48]},
        "2792": {"vr": "IS", "Value": [56]},
        "2793": {"vr": "IS", "Value": [52]},
        "2794": {"vr": "IS", "Value": [21]},
        "2795": {"vr": "IS", "Value": [17]},
        "2796": {"vr": "IS", "Value": [37]},
        "2797": {"vr": "IS", "Value": [45]},
        "2798": {"vr": "IS", "Value": [50]},
        "2799": {"vr": "IS", "Value": [58]},
        "2800": {"vr": "IS", "Value": [46]},
        "2801": {"vr": "IS", "Value": [26]},
        "2802": {"vr": "IS", "Value": [62]},
        "2803": {"vr": "IS", "Value": [31]},
        "2804": {"vr": "IS", "Value": [38]},
        "2805": {"vr": "IS", "Value": [43]},
        "2806": {"vr": "IS", "Value": [11]},
        "2807": {"vr": "IS", "Value": [63]},
        "2808": {"vr": "IS", "Value": [61]},
        "2809": {"vr": "IS", "Value": [28]},
        "2810": {"vr": "IS", "Value": [37]},
        "2811": {"vr": "IS", "Value": [66]},
        "2812": {"vr": "IS", "Value": [31]},
        "2813": {"vr": "IS", "Value": [18]},
        "2814": {"vr": "IS", "Value": [6]},
        "2815": {"vr": "IS", "Value": [38]},
        "2816": {"vr": "IS", "Value": [14]},
        "2817": {"vr": "IS", "Value": [42]},
        "2818": {"vr": "IS", "Value": [23]},
        "2819": {"vr": "IS", "Value": [61]},
        "2820": {"vr": "IS", "Value": [32]},
        "2821": {"vr": "IS", "Value": [61]},
        "2822": {"vr": "IS", "Value": [45]},
        "2823": {"vr": "IS", "Value": [59]},
        "2824": {"vr": "IS", "Value": [59]},
        "2825": {"vr": "IS", "Value": [22]},
        "2826": {"vr": "IS", "Value": [6]},
        "2827": {"vr": "IS", "Value": [16]},
        "2828": {"vr": "IS", "Value": [62]},
        "2829": {"vr": "IS", "Value": [54]},
        "2830": {"vr": "IS", "Value": [34]},
        "2831": {"vr": "IS", "Value": [57]},
        "2832": {"vr": "IS", "Value": [40]},
        "2833": {"vr": "IS", "Value": [31]},
        "2834": {"vr": "IS", "Value": [42]},
        "2835": {"vr": "IS", "Value": [27]},
        "2836": {"vr": "IS", "Value": [40]},
        "2837": {"vr": "IS", "Value": [13]},
        "2838": {"vr": "IS", "Value": [22]},
        "2839": {"vr": "IS", "Value": [37]},
        "2840": {"vr": "IS", "Value": [30]},
        "2841": {"vr": "IS", "Value": [52]},
        "2842": {"vr": "IS", "Value": [51]},
        "2843": {"vr": "IS", "Value": [30]},
        "2844": {"vr": "IS", "Value": [17]},
        "2845": {"vr": "IS", "Value": [22]},
        "2846": {"vr": "IS", "Value": [18]},
        "2847": {"vr": "IS", "Value": [57]},
        "2848": {"vr": "IS", "Value": [64]},
        "2849": {"vr": "IS", "Value": [55]},
        "2850": {"vr": "IS", "Value": [44]},
        "2851": {"vr": "IS", "Value": [51]},
        "2852": {"vr": "IS", "Value": [34]},
        "2853": {"vr": "IS", "Value": [16]},
        "2854": {"vr": "IS", "Value": [21]},
        "2855": {"vr": "IS", "Value": [1]},
        "2856": {"vr": "IS", "Value": [27]},
        "2857": {"vr": "IS", "Value": [21]},
        "2858": {"vr": "IS", "Value": [26]},
        "2859": {"vr": "IS", "Value": [49]},
        "2860": {"vr": "IS", "Value": [55]},
        "2861": {"vr": "IS", "Value": [19]},
        "2862": {"vr": "IS", "Value": [1]},
        "2863": {"vr": "IS", "Value": [33]},
        "2864": {"vr": "IS", "Value": [8]},
        "2865": {"vr": "IS", "Value": [51]},
        "2866": {"vr": "IS", "Value": [21]},
        "2867": {"vr": "IS", "Value": [47]},
        "2868": {"vr": "IS", "Value": [57]},
        "2869": {"vr": "IS", "Value": [21]},
        "2870": {"vr": "IS", "Value": [15]},
        "2871": {"vr": "IS", "Value": [3]},
        "2872": {"vr": "IS", "Value": [52]},
        "2873": {"vr": "IS", "Value": [47]},
        "2874": {"vr": "IS", "Value": [25]},
        "2875": {"vr": "IS", "Value": [60]},
        "2876": {"vr": "IS", "Value": [32]},
        "2877": {"vr": "IS", "Value": [39]},
        "2878": {"vr": "IS", "Value": [56]},
        "2879": {"vr": "IS", "Value": [39]},
        "2880": {"vr": "IS", "Value": [39]},
        "2881": {"vr": "IS", "Value": [31]},
        "2882": {"vr": "IS", "Value": [12]},
        "2883": {"vr": "IS", "Value": [7]},
        "2884": {"vr": "IS", "Value": [6]},
        "2885": {"vr": "IS", "Value": [25]},
        "2886": {"vr": "IS", "Value": [38]},
        "2887": {"vr": "IS", "Value": [28]},
        "2888": {"vr": "IS", "Value": [27]},
        "2889": {"vr": "IS", "Value": [65]},
        "2890": {"vr": "IS", "Value": [9]},
        "2891": {"vr": "IS", "Value": [14]},
        "2892": {"vr": "IS", "Value": [55]},
        "2893": {"vr": "IS", "Value": [21]},
        "2894": {"vr": "IS", "Value": [32]},
        "2895": {"vr": "IS", "Value": [4]},
        "2896": {"vr": "IS", "Value": [57]},
        "2897": {"vr": "IS", "Value": [31]},
        "2898": {"vr": "IS", "Value": [36]},
        "2899": {"vr": "IS", "Value": [17]},
        "2900": {"vr": "IS", "Value": [42]},
        "2901": {"vr": "IS", "Value": [8]},
        "2902": {"vr": "IS", "Value": [61]},
        "2903": {"vr": "IS", "Value": [43]},
        "2904": {"vr": "IS", "Value": [42]},
        "2905": {"vr": "IS", "Value": [19]},
        "2906": {"vr": "IS", "Value": [1]},
        "2907": {"vr": "IS", "Value": [67]},
        "2908": {"vr": "IS", "Value": [10]},
        "2909": {"vr": "IS", "Value": [63]},
        "2910": {"vr": "IS", "Value": [21]},
        "2911": {"vr": "IS", "Value": [61]},
        "2912": {"vr": "IS", "Value": [8]},
        "2913": {"vr": "IS", "Value": [29]},
        "2914": {"vr": "IS", "Value": [10]},
        "2915": {"vr": "IS", "Value": [37]},
        "2916": {"vr": "IS", "Value": [34]},
        "2917": {"vr": "IS", "Value": [20]},
        "2918": {"vr": "IS", "Value": [1]},
        "2919": {"vr": "IS", "Value": [67]},
        "2920": {"vr": "IS", "Value": [49]},
        "2921": {"vr": "IS", "Value": [44]},
        "2922": {"vr": "IS", "Value": [46]},
        "2923": {"vr": "IS", "Value": [34]},
        "2924": {"vr": "IS", "Value": [43]},
        "2925": {"vr": "IS", "Value": [6]},
        "2926": {"vr": "IS", "Value": [13]},
        "2927": {"vr": "IS", "Value": [54]},
        "2928": {"vr": "IS", "Value": [19]},
        "2929": {"vr": "IS", "Value": [2]},
        "2930": {"vr": "IS", "Value": [12]},
        "2931": {"vr": "IS", "Value": [66]},
        "2932": {"vr": "IS", "Value": [64]},
        "2933": {"vr": "IS", "Value": [10]},
        "2934": {"vr": "IS", "Value": [40]},
        "2935": {"vr": "IS", "Value": [12]},
        "2936": {"vr": "IS", "Value": [47]},
        "2937": {"vr": "IS", "Value": [55]},
        "2938": {"vr": "IS", "Value": [55]},
        "2939": {"vr": "IS", "Value": [25]},
        "2940": {"vr": "IS", "Value": [28]},
        "2941": {"vr": "IS", "Value": [16]},
        "2942": {"vr": "IS", "Value": [58]},
        "2943": {"vr": "IS", "Value": [46]},
        "2944": {"vr": "IS", "Value": [61]},
        "2945": {"vr": "IS", "Value": [66]},
        "2946": {"vr": "IS", "Value": [23]},
        "2947": {"vr": "IS", "Value": [55]},
        "2948": {"vr": "IS", "Value": [31]},
        "2949": {"vr": "IS", "Value": [1]},
        "2950": {"vr": "IS", "Value": [13]},
        "2951": {"vr": "IS", "Value": [41]},
        "2952": {"vr": "IS", "Value": [61]},
        "2953": {"vr": "IS", "Value": [27]},
        "2954": {"vr": "IS", "Value": [34]},
        "2955": {"vr": "IS", "Value": [45]},
        "2956": {"vr": "IS", "Value": [49]},
        "2957": {"vr": "IS", "Value": [9]},
        "2958": {"vr": "IS", "Value": [10]},
        "2959": {"vr": "IS", "Value": [18]},
        "2960": {"vr": "IS", "Value": [20]},
        "2961": {"vr": "IS", "Value": [19]},
        "2962": {"vr": "IS", "Value": [18]},
        "2963": {"vr": "IS", "Value": [58]},
        "2964": {"vr": "IS", "Value": [13]},
        "2965": {"vr": "IS", "Value": [57]},
        "2966": {"vr": "IS", "Value": [25]},
        "2967": {"vr": "IS", "Value": [7]},
        "2968": {"vr": "IS", "Value": [23]},
        "2969": {"vr": "IS", "Value": [14]},
        "2970": {"vr": "IS", "Value": [52]},
        "2971": {"vr": "IS", "Value": [66]},
        "2972": {"vr": "IS", "Value": [57]},
        "2973": {"vr": "IS", "Value": [38]},
        "2974": {"vr": "IS", "Value": [14]},
        "2975": {"vr": "IS", "Value": [5]},
        "2976": {"vr": "IS", "Value": [18]},
        "2977": {"vr": "IS", "Value": [40]},
        "2978": {"vr": "IS", "Value": [10]},
        "2979": {"vr": "IS", "Value": [53]},
        "2980": {"vr": "IS", "Value": [36]},
        "2981": {"vr": "IS", "Value": [50]},
        "2982": {"vr": "IS", "Value": [41]},
        "2983": {"vr": "IS", "Value": [8]},
        "2984": {"vr": "IS", "Value": [54]},
        "2985": {"vr": "IS", "Value": [23]},
        "2986": {"vr": "IS", "Value": [22]},
        "2987": {"vr": "IS", "Value": [42]},
        "2988": {"vr": "IS", "Value": [43]},
        "2989": {"vr": "IS", "Value": [51]},
        "2990": {"vr": "IS", "Value": [4]},
        "2991": {"vr": "IS", "Value": [46]},
        "2992": {"vr": "IS", "Value": [43]},
        "2993": {"vr": "IS", "Value": [36]},
        "2994": {"vr": "IS", "Value": [52]},
        "2995": {"vr": "IS", "Value": [58]},
        "2996": {"vr": "IS", "Value": [30]},
        "2997": {"vr": "IS", "Value": [19]},
        "2998": {"vr": "IS", "Value": [38]},
        "2999": {"vr": "IS", "Value": [36]},
        "3000": {"vr": "IS", "Value": [53]},
        "3001": {"vr": "IS", "Value": [8]},
        "3002": {"vr": "IS", "Value": [57]},
        "3003": {"vr": "IS", "Value": [42]},
        "3004": {"vr": "IS", "Value": [50]},
        "3005": {"vr": "IS", "Value": [67]},
        "3006": {"vr": "IS", "Value": [50]},
        "3007": {"vr": "IS", "Value": [54]},
        "3008": {"vr": "IS", "Value": [7]},
        "3009": {"vr": "IS", "Value": [13]},
        "3010": {"vr": "IS", "Value": [48]},
        "3011": {"vr": "IS", "Value": [25]},
        "3012": {"vr": "IS", "Value": [25]},
        "3013": {"vr": "IS", "Value": [15]},
        "3014": {"vr": "IS", "Value": [65]},
        "3015": {"vr": "IS", "Value": [28]},
        "3016": {"vr": "IS", "Value": [32]},
        "3017": {"vr": "IS", "Value": [38]},
        "3018": {"vr": "IS", "Value": [59]},
        "3019": {"vr": "IS", "Value": [1]},
        "3020": {"vr": "IS", "Value": [28]},
        "3021": {"vr": "IS", "Value": [37]},
        "3022": {"vr": "IS", "Value": [22]},
        "3023": {"vr": "IS", "Value": [43]},
        "3024": {"vr": "IS", "Value": [37]},
        "3025": {"vr": "IS", "Value": [53]},
        "3026": {"vr": "IS", "Value": [2]},
        "3027": {"vr": "IS", "Value": [15]},
        "3028": {"vr": "IS", "Value": [30]},
        "3029": {"vr": "IS", "Value": [45]},
        "3030": {"vr": "IS", "Value": [54]},
        "3031": {"vr": "IS", "Value": [55]},
        "3032": {"vr": "IS", "Value": [65]},
        "3033": {"vr": "IS", "Value": [11]},
        "3034": {"vr": "IS", "Value": [20]},
        "3035": {"vr": "IS", "Value": [26]},
        "3036": {"vr": "IS", "Value": [58]},
        "3037": {"vr": "IS", "Value": [39]},
        "3038": {"vr": "IS", "Value": [11]},
        "3039": {"vr": "IS", "Value": [11]},
        "3040": {"vr": "IS", "Value": [11]},
        "3041": {"vr": "IS", "Value": [18]},
        "3042": {"vr": "IS", "Value": [42]},
        "3043": {"vr": "IS", "Value": [51]},
        "3044": {"vr": "IS", "Value": [55]},
        "3045": {"vr": "IS", "Value": [9]},
        "3046": {"vr": "IS", "Value": [15]},
        "3047": {"vr": "IS", "Value": [31]},
        "3048": {"vr": "IS", "Value": [28]},
        "3049": {"vr": "IS", "Value": [62]},
        "3050": {"vr": "IS", "Value": [43]},
        "3051": {"vr": "IS", "Value": [36]},
        "3052": {"vr": "IS", "Value": [16]},
        "3053": {"vr": "IS", "Value": [12]},
        "3054": {"vr": "IS", "Value": [55]},
        "3055": {"vr": "IS", "Value": [5]},
        "3056": {"vr": "IS", "Value": [60]},
        "3057": {"vr": "IS", "Value": [7]},
        "3058": {"vr": "IS", "Value": [15]},
        "3059": {"vr": "IS", "Value": [15]},
        "3060": {"vr": "IS", "Value": [43]},
        "3061": {"vr": "IS", "Value": [22]},
        "3062": {"vr": "IS", "Value": [63]},
        "3063": {"vr": "IS", "Value": [60]},
        "3064": {"vr": "IS", "Value": [29]},
        "3065": {"vr": "IS", "Value": [42]},
        "3066": {"vr": "IS", "Value": [49]},
        "3067": {"vr": "IS", "Value": [35]},
        "3068": {"vr": "IS", "Value": [47]},
        "3069": {"vr": "IS", "Value": [37]},
        "3070": {"vr": "IS", "Value": [64]},
        "3071": {"vr": "IS", "Value": [35]},
        "3072": {"vr": "IS", "Value": [45]},
        "3073": {"vr": "IS", "Value": [17]},
        "3074": {"vr": "IS", "Value": [12]},
        "3075": {"vr": "IS", "Value": [65]},
        "3076": {"vr": "IS", "Value": [4]},
        "3077": {"vr": "IS", "Value": [45]},
        "3078": {"vr": "IS", "Value": [38]},
        "3079": {"vr": "IS", "Value": [28]},
        "3080": {"vr": "IS", "Value": [5]},
        "3081": {"vr": "IS", "Value": [57]},
        "3082": {"vr": "IS", "Value": [60]},
        "3083": {"vr": "IS", "Value": [25]},
        "3084": {"vr": "IS", "Value": [38]},
        "3085": {"vr": "IS", "Value": [25]},
        "3086": {"vr": "IS", "Value": [38]},
        "3087": {"vr": "IS", "Value": [4]},
        "3088": {"vr": "IS", "Value": [50]},
        "3089": {"vr": "IS", "Value": [1]},
        "3090": {"vr": "IS", "Value": [61]},
        "3091": {"vr": "IS", "Value": [41]},
        "3092": {"vr": "IS", "Value": [12]},
        "3093": {"vr": "IS", "Value": [19]},
        "3094": {"vr": "IS", "Value": [52]},
        "3095": {"vr": "IS", "Value": [52]},
        "3096": {"vr": "IS", "Value": [40]},
        "3097": {"vr": "IS", "Value": [35]},
        "3098": {"vr": "IS", "Value": [29]},
        "3099": {"vr": "IS", "Value": [22]},
        "3100": {"vr": "IS", "Value": [16]},
        "3101": {"vr": "IS", "Value": [21]},
        "3102": {"vr": "IS", "Value": [45]},
        "3103": {"vr": "IS", "Value": [44]},
        "3104": {"vr": "IS", "Value": [42]},
        "3105": {"vr": "IS", "Value": [27]},
        "3106": {"vr": "IS", "Value": [19]},
        "3107": {"vr": "IS", "Value": [60]},
        "3108": {"vr": "IS", "Value": [66]},
        "3109": {"vr": "IS", "Value": [64]},
        "3110": {"vr": "IS", "Value": [26]},
        "3111": {"vr": "IS", "Value": [21]},
        "3112": {"vr": "IS", "Value": [21]},
        "3113": {"vr": "IS", "Value": [50]},
        "3114": {"vr": "IS", "Value": [20]},
        "3115": {"vr": "IS", "Value": [2]},
        "3116": {"vr": "IS", "Value": [13]},
        "3117": {"vr": "IS", "Value": [26]},
        "3118": {"vr": "IS", "Value": [26]},
        "3119": {"vr": "IS", "Value": [11]},
        "3120": {"vr": "IS", "Value": [64]},
        "3121": {"vr": "IS", "Value": [25]},
        "3122": {"vr": "IS", "Value": [9]},
        "3123": {"vr": "IS", "Value": [54]},
        "3124": {"vr": "IS", "Value": [4]},
        "3125": {"vr": "IS", "Value": [52]},
        "3126": {"vr": "IS", "Value": [55]},
        "3127": {"vr": "IS", "Value": [47]},
        "3128": {"vr": "IS", "Value": [54]},
        "3129": {"vr": "IS", "Value": [6]},
        "3130": {"vr": "IS", "Value": [20]},
        "3131": {"vr": "IS", "Value": [24]},
        "3132": {"vr": "IS", "Value": [1]},
        "3133": {"vr": "IS", "Value": [48]},
        "3134": {"vr": "IS", "Value": [37]},
        "3135": {"vr": "IS", "Value": [59]},
        "3136": {"vr": "IS", "Value": [4]},
        "3137": {"vr": "IS", "Value": [62]},
        "3138": {"vr": "IS", "Value": [6]},
        "3139": {"vr": "IS", "Value": [3]},
        "3140": {"vr": "IS", "Value": [38]},
        "3141": {"vr": "IS", "Value": [20]},
        "3142": {"vr": "IS", "Value": [57]},
        "3143": {"vr": "IS", "Value": [9]},
        "3144": {"vr": "IS", "Value": [15]},
        "3145": {"vr": "IS", "Value": [3]},
        "3146": {"vr": "IS", "Value": [35]},
        "3147": {"vr": "IS", "Value": [15]},
        "3148": {"vr": "IS", "Value": [19]},
        "3149": {"vr": "IS", "Value": [46]},
        "3150": {"vr": "IS", "Value": [38]},
        "3151": {"vr": "IS", "Value": [13]},
        "3152": {"vr": "IS", "Value": [40]},
        "3153": {"vr": "IS", "Value": [53]},
        "3154": {"vr": "IS", "Value": [19]},
        "3155": {"vr": "IS", "Value": [63]},
        "3156": {"vr": "IS", "Value": [16]},
        "3157": {"vr": "IS", "Value": [52]},
        "3158": {"vr": "IS", "Value": [36]},
        "3159": {"vr": "IS", "Value": [19]},
        "3160": {"vr": "IS", "Value": [1]},
        "3161": {"vr": "IS", "Value": [33]},
        "3162": {"vr": "IS", "Value": [31]},
        "3163": {"vr": "IS", "Value": [7]},
        "3164": {"vr": "IS", "Value": [17]},
        "3165": {"vr": "IS", "Value": [1]},
        "3166": {"vr": "IS", "Value": [11]},
        "3167": {"vr": "IS", "Value": [10]},
        "3168": {"vr": "IS", "Value": [53]},
        "3169": {"vr": "IS", "Value": [33]},
        "3170": {"vr": "IS", "Value": [65]},
        "3171": {"vr": "IS", "Value": [36]},
        "3172": {"vr": "IS", "Value": [67]},
        "3173": {"vr": "IS", "Value": [57]},
        "3174": {"vr": "IS", "Value": [21]},
        "3175": {"vr": "IS", "Value": [33]},
        "3176": {"vr": "IS", "Value": [66]},
        "3177": {"vr": "IS", "Value": [29]},
        "3178": {"vr": "IS", "Value": [41]},
        "3179": {"vr": "IS", "Value": [27]},
        "3180": {"vr": "IS", "Value": [53]},
        "3181": {"vr": "IS", "Value": [54]},
        "3182": {"vr": "IS", "Value": [53]},
        "3183": {"vr": "IS", "Value": [19]},
        "3184": {"vr": "IS", "Value": [11]},
        "3185": {"vr": "IS", "Value": [54]},
        "3186": {"vr": "IS", "Value": [49]},
        "3187": {"vr": "IS", "Value": [29]},
        "3188": {"vr": "IS", "Value": [18]},
        "3189": {"vr": "IS", "Value": [18]},
        "3190": {"vr": "IS", "Value": [60]},
        "3191": {"vr": "IS", "Value": [55]},
        "3192": {"vr": "IS", "Value": [42]},
        "3193": {"vr": "IS", "Value": [34]},
        "3194": {"vr": "IS", "Value": [1]},
        "3195": {"vr": "IS", "Value": [30]},
        "3196": {"vr": "IS", "Value": [11]},
        "3197": {"vr": "IS", "Value": [53]},
        "3198": {"vr": "IS", "Value": [35]},
        "3199": {"vr": "IS", "Value": [27]},
        "3200": {"vr": "IS", "Value": [2]},
        "3201": {"vr": "IS", "Value": [52]},
        "3202": {"vr": "IS", "Value": [66]},
        "3203": {"vr": "IS", "Value": [31]},
        "3204": {"vr": "IS", "Value": [32]},
        "3205": {"vr": "IS", "Value": [65]},
        "3206": {"vr": "IS", "Value": [10]},
        "3207": {"vr": "IS", "Value": [27]},
        "3208": {"vr": "IS", "Value": [29]},
        "3209": {"vr": "IS", "Value": [49]},
        "3210": {"vr": "IS", "Value": [10]},
        "3211": {"vr": "IS", "Value": [39]},
        "3212": {"vr": "IS", "Value": [33]},
        "3213": {"vr": "IS", "Value": [55]},
        "3214": {"vr": "IS", "Value": [67]},
        "3215": {"vr": "IS", "Value": [60]},
        "3216": {"vr": "IS", "Value": [46]},
        "3217": {"vr": "IS", "Value": [9]},
        "3218": {"vr": "IS", "Value": [1]},
        "3219": {"vr": "IS", "Value": [18]},
        "3220": {"vr": "IS", "Value": [35]},
        "3221": {"vr": "IS", "Value": [14]},
        "3222": {"vr": "IS", "Value": [59]},
        "3223": {"vr": "IS", "Value": [26]},
        "3224": {"vr": "IS", "Value": [2]},
        "3225": {"vr": "IS", "Value": [44]},
        "3226": {"vr": "IS", "Value": [43]},
        "3227": {"vr": "IS", "Value": [18]},
        "3228": {"vr": "IS", "Value": [49]},
        "3229": {"vr": "IS", "Value": [9]},
        "3230": {"vr": "IS", "Value": [23]},
        "3231": {"vr": "IS", "Value": [47]},
        "3232": {"vr": "IS", "Value": [18]},
        "3233": {"vr": "IS", "Value": [64]},
        "3234": {"vr": "IS", "Value": [19]},
        "3235": {"vr": "IS", "Value": [44]},
        "3236": {"vr": "IS", "Value": [26]},
        "3237": {"vr": "IS", "Value": [30]},
        "3238": {"vr": "IS", "Value": [59]},
        "3239": {"vr": "IS", "Value": [54]},
        "3240": {"vr": "IS", "Value": [66]},
        "3241": {"vr": "IS", "Value": [50]},
        "3242": {"vr": "IS", "Value": [17]},
        "3243": {"vr": "IS", "Value": [34]},
        "3244": {"vr": "IS", "Value": [10]},
        "3245": {"vr": "IS", "Value": [2]},
        "3246": {"vr": "IS", "Value": [58]},
        "3247": {"vr": "IS", "Value": [29]},
        "3248": {"vr": "IS", "Value": [43]},
        "3249": {"vr": "IS", "Value": [25]},
        "3250": {"vr": "IS", "Value": [58]},
        "3251": {"vr": "IS", "Value": [39]},
        "3252": {"vr": "IS", "Value": [39]},
        "3253": {"vr": "IS", "Value": [54]},
        "3254": {"vr": "IS", "Value": [57]},
        "3255": {"vr": "IS", "Value": [66]},
        "3256": {"vr": "IS", "Value": [45]},
        "3257": {"vr": "IS", "Value": [53]},
        "3258": {"vr": "IS", "Value": [34]},
        "3259": {"vr": "IS", "Value": [6]},
        "3260": {"vr": "IS", "Value": [38]},
        "3261": {"vr": "IS", "Value": [28]},
        "3262": {"vr": "IS", "Value": [29]},
        "3263": {"vr": "IS", "Value": [22]},
        "3264": {"vr": "IS", "Value": [34]},
        "3265": {"vr": "IS", "Value": [59]},
        "3266": {"vr": "IS", "Value": [61]},
        "3267": {"vr": "IS", "Value": [29]},
        "3268": {"vr": "IS", "Value": [22]},
        "3269": {"vr": "IS", "Value": [50]},
        "3270": {"vr": "IS", "Value": [67]},
        "3271": {"vr": "IS", "Value": [18]},
        "3272": {"vr": "IS", "Value": [62]},
        "3273": {"vr": "IS", "Value": [65]},
        "3274": {"vr": "IS", "Value": [66]},
        "3275": {"vr": "IS", "Value": [16]},
        "3276": {"vr": "IS", "Value": [17]},
        "3277": {"vr": "IS", "Value": [38]},
        "3278": {"vr": "IS", "Value": [58]},
        "3279": {"vr": "IS", "Value": [58]},
        "3280": {"vr": "IS", "Value": [23]},
        "3281": {"vr": "IS", "Value": [18]},
        "3282": {"vr": "IS", "Value": [22]},
        "3283": {"vr": "IS", "Value": [10]},
        "3284": {"vr": "IS", "Value": [47]},
        "3285": {"vr": "IS", "Value": [39]},
        "3286": {"vr": "IS", "Value": [42]},
        "3287": {"vr": "IS", "Value": [57]},
        "3288": {"vr": "IS", "Value": [19]},
        "3289": {"vr": "IS", "Value": [10]},
        "3290": {"vr": "IS", "Value": [10]},
        "3291": {"vr": "IS", "Value": [39]},
        "3292": {"vr": "IS", "Value": [64]},
        "3293": {"vr": "IS", "Value": [32]},
        "3294": {"vr": "IS", "Value": [37]},
        "3295": {"vr": "IS", "Value": [42]},
        "3296": {"vr": "IS", "Value": [17]},
        "3297": {"vr": "IS", "Value": [17]},
        "3298": {"vr": "IS", "Value": [26]},
        "3299": {"vr": "IS", "Value": [9]},
        "3300": {"vr": "IS", "Value": [30]},
        "3301": {"vr": "IS", "Value": [32]},
        "3302": {"vr": "IS", "Value": [42]},
        "3303": {"vr": "IS", "Value": [66]},
        "3304": {"vr": "IS", "Value": [14]},
        "3305": {"vr": "IS", "Value": [30]},
        "3306": {"vr": "IS", "Value": [62]},
        "3307": {"vr": "IS", "Value": [6]},
        "3308": {"vr": "IS", "Value": [21]},
        "3309": {"vr": "IS", "Value": [48]},
        "3310": {"vr": "IS", "Value": [6]},
        "3311": {"vr": "IS", "Value": [24]},
        "3312": {"vr": "IS", "Value": [41]},
        "3313": {"vr": "IS", "Value": [2]},
        "3314": {"vr": "IS", "Value": [31]},
        "3315": {"vr": "IS", "Value": [34]},
        "3316": {"vr": "IS", "Value": [15]},
        "3317": {"vr": "IS", "Value": [60]},
        "3318": {"vr": "IS", "Value": [36]},
        "3319": {"vr": "IS", "Value": [54]},
        "3320": {"vr": "IS", "Value": [62]},
        "3321": {"vr": "IS", "Value": [50]},
        "3322": {"vr": "IS", "Value": [43]},
        "3323": {"vr": "IS", "Value": [37]},
        "3324": {"vr": "IS", "Value": [33]},
        "3325": {"vr": "IS", "Value": [15]},
        "3326": {"vr": "IS", "Value": [25]},
        "3327": {"vr": "IS", "Value": [30]},
        "3328": {"vr": "IS", "Value": [56]},
        "3329": {"vr": "IS", "Value": [20]},
        "3330": {"vr": "IS", "Value": [5]},
        "3331": {"vr": "IS", "Value": [66]},
        "3332": {"vr": "IS", "Value": [61]},
        "3333": {"vr": "IS", "Value": [20]},
        "3334": {"vr": "IS", "Value": [40]},
        "3335": {"vr": "IS", "Value": [32]},
        "3336": {"vr": "IS", "Value": [11]},
        "3337": {"vr": "IS", "Value": [2]},
        "3338": {"vr": "IS", "Value": [14]},
        "3339": {"vr": "IS", "Value": [41]},
        "3340": {"vr": "IS", "Value": [31]},
        "3341": {"vr": "IS", "Value": [44]},
        "3342": {"vr": "IS", "Value": [54]},
        "3343": {"vr": "IS", "Value": [34]},
        "3344": {"vr": "IS", "Value": [3]},
        "3345": {"vr": "IS", "Value": [41]},
        "3346": {"vr": "IS", "Value": [59]},
        "3347": {"vr": "IS", "Value": [23]},
        "3348": {"vr": "IS", "Value": [27]},
        "3349": {"vr": "IS", "Value": [63]},
        "3350": {"vr": "IS", "Value": [14]},
        "3351": {"vr": "IS", "Value": [9]},
        "3352": {"vr": "IS", "Value": [18]},
        "3353": {"vr": "IS", "Value": [57]},
        "3354": {"vr": "IS", "Value": [27]},
        "3355": {"vr": "IS", "Value": [33]},
        "3356": {"vr": "IS", "Value": [36]},
        "3357": {"vr": "IS", "Value": [4]},
        "3358": {"vr": "IS", "Value": [20]},
        "3359": {"vr": "IS", "Value": [60]},
        "3360": {"vr": "IS", "Value": [58]},
        "3361": {"vr": "IS", "Value": [26]},
        "3362": {"vr": "IS", "Value": [30]},
        "3363": {"vr": "IS", "Value": [58]},
        "3364": {"vr": "IS", "Value": [52]},
        "3365": {"vr": "IS", "Value": [67]},
        "3366": {"vr": "IS", "Value": [63]},
        "3367": {"vr": "IS", "Value": [59]},
        "3368": {"vr": "IS", "Value": [14]},
        "3369": {"vr": "IS", "Value": [51]},
        "3370": {"vr": "IS", "Value": [46]},
        "3371": {"vr": "IS", "Value": [29]},
        "3372": {"vr": "IS", "Value": [52]},
        "3373": {"vr": "IS", "Value": [48]},
        "3374": {"vr": "IS", "Value": [39]},
        "3375": {"vr": "IS", "Value": [50]},
        "3376": {"vr": "IS", "Value": [23]},
        "3377": {"vr": "IS", "Value": [53]},
        "3378": {"vr": "IS", "Value": [26]},
        "3379": {"vr": "IS", "Value": [35]},
        "3380": {"vr": "IS", "Value": [18]},
        "3381": {"vr": "IS", "Value": [49]},
        "3382": {"vr": "IS", "Value": [34]},
        "3383": {"vr": "IS", "Value": [7]},
        "3384": {"vr": "IS", "Value": [34]},
        "3385": {"vr": "IS", "Value": [21]},
        "3386": {"vr": "IS", "Value": [48]},
        "3387": {"vr": "IS", "Value": [66]},
        "3388": {"vr": "IS", "Value": [32]},
        "3389": {"vr": "IS", "Value": [56]},
        "3390": {"vr": "IS", "Value": [57]},
        "3391": {"vr": "IS", "Value": [22]},
        "3392": {"vr": "IS", "Value": [19]},
        "3393": {"vr": "IS", "Value": [33]},
        "3394": {"vr": "IS", "Value": [6]},
        "3395": {"vr": "IS", "Value": [48]},
        "3396": {"vr": "IS", "Value": [14]},
        "3397": {"vr": "IS", "Value": [21]},
        "3398": {"vr": "IS", "Value": [11]},
        "3399": {"vr": "IS", "Value": [50]},
        "3400": {"vr": "IS", "Value": [36]},
        "3401": {"vr": "IS", "Value": [32]},
        "3402": {"vr": "IS", "Value": [42]},
        "3403": {"vr": "IS", "Value": [26]},
        "3404": {"vr": "IS", "Value": [19]},
        "3405": {"vr": "IS", "Value": [34]},
        "3406": {"vr": "IS", "Value": [52]},
        "3407": {"vr": "IS", "Value": [14]},
        "3408": {"vr": "IS", "Value": [9]},
        "3409": {"vr": "IS", "Value": [47]},
        "3410": {"vr": "IS", "Value": [41]},
        "3411": {"vr": "IS", "Value": [49]},
        "3412": {"vr": "IS", "Value": [61]},
        "3413": {"vr": "IS", "Value": [63]},
        "3414": {"vr": "IS", "Value": [54]},
        "3415": {"vr": "IS", "Value": [57]},
        "3416": {"vr": "IS", "Value": [30]},
        "3417": {"vr": "IS", "Value": [43]},
        "3418": {"vr": "IS", "Value": [3]},
        "3419": {"vr": "IS", "Value": [58]},
        "3420": {"vr": "IS", "Value": [17]},
        "3421": {"vr": "IS", "Value": [10]},
        "3422": {"vr": "IS", "Value": [60]},
        "3423": {"vr": "IS", "Value": [63]},
        "3424": {"vr": "IS", "Value": [35]},
        "3425": {"vr": "IS", "Value": [33]},
        "3426": {"vr": "IS", "Value": [58]},
        "3427": {"vr": "IS", "Value": [42]},
        "3428": {"vr": "IS", "Value": [30]},
        "3429": {"vr": "IS", "Value": [31]},
        "3430": {"vr": "IS", "Value": [41]},
        "3431": {"vr": "IS", "Value": [56]},
        "3432": {"vr": "IS", "Value": [9]},
        "3433": {"vr": "IS", "Value": [8]},
        "3434": {"vr": "IS", "Value": [51]},
        "3435": {"vr": "IS", "Value": [47]},
        "3436": {"vr": "IS", "Value": [56]},
        "3437": {"vr": "IS", "Value": [59]},
        "3438": {"vr": "IS", "Value": [21]},
        "3439": {"vr": "IS", "Value": [44]},
        "3440": {"vr": "IS", "Value": [52]},
        "3441": {"vr": "IS", "Value": [55]},
        "3442": {"vr": "IS", "Value": [47]},
        "3443": {"vr": "IS", "Value": [59]},
        "3444": {"vr": "IS", "Value": [35]},
        "3445": {"vr": "IS", "Value": [3]},
        "3446": {"vr": "IS", "Value": [1]},
        "3447": {"vr": "IS", "Value": [62]},
        "3448": {"vr": "IS", "Value": [31]},
        "3449": {"vr": "IS", "Value": [27]},
        "3450": {"vr": "IS", "Value": [52]},
        "3451": {"vr": "IS", "Value": [37]},
        "3452": {"vr": "IS", "Value": [24]},
        "3453": {"vr": "IS", "Value": [28]},
        "3454": {"vr": "IS", "Value": [23]},
        "3455": {"vr": "IS", "Value": [9]},
        "3456": {"vr": "IS", "Value": [30]},
        "3457": {"vr": "IS", "Value": [51]},
        "3458": {"vr": "IS", "Value": [41]},
        "3459": {"vr": "IS", "Value": [61]},
        "3460": {"vr": "IS", "Value": [40]},
        "3461": {"vr": "IS", "Value": [10]},
        "3462": {"vr": "IS", "Value": [20]},
        "3463": {"vr": "IS", "Value": [43]},
        "3464": {"vr": "IS", "Value": [65]},
        "3465": {"vr": "IS", "Value": [43]},
        "3466": {"vr": "IS", "Value": [25]},
        "3467": {"vr": "IS", "Value": [58]},
        "3468": {"vr": "IS", "Value": [22]},
        "3469": {"vr": "IS", "Value": [15]},
        "3470": {"vr": "IS", "Value": [42]},
        "3471": {"vr": "IS", "Value": [41]},
        "3472": {"vr": "IS", "Value": [59]},
        "3473": {"vr": "IS", "Value": [7]},
        "3474": {"vr": "IS", "Value": [12]},
        "3475": {"vr": "IS", "Value": [30]},
        "3476": {"vr": "IS", "Value": [5]},
        "3477": {"vr": "IS", "Value": [2]},
        "3478": {"vr": "IS", "Value": [59]},
        "3479": {"vr": "IS", "Value": [40]},
        "3480": {"vr": "IS", "Value": [14]},
        "3481": {"vr": "IS", "Value": [67]},
        "3482": {"vr": "IS", "Value": [53]},
        "3483": {"vr": "IS", "Value": [59]},
        "3484": {"vr": "IS", "Value": [60]},
        "3485": {"vr": "IS", "Value": [43]},
        "3486": {"vr": "IS", "Value": [52]},
        "3487": {"vr": "IS", "Value": [66]},
        "3488": {"vr": "IS", "Value": [4]},
        "3489": {"vr": "IS", "Value": [50]},
        "3490": {"vr": "IS", "Value": [6]},
        "3491": {"vr": "IS", "Value": [58]},
        "3492": {"vr": "IS", "Value": [23]},
        "3493": {"vr": "IS", "Value": [63]},
        "3494": {"vr": "IS", "Value": [39]},
        "3495": {"vr": "IS", "Value": [50]},
        "3496": {"vr": "IS", "Value": [28]},
        "3497": {"vr": "IS", "Value": [43]},
        "3498": {"vr": "IS", "Value": [56]},
        "3499": {"vr": "IS", "Value": [27]},
        "3500": {"vr": "IS", "Value": [54]},
        "3501": {"vr": "IS", "Value": [34]},
        "3502": {"vr": "IS", "Value": [35]},
        "3503": {"vr": "IS", "Value": [56]},
        "3504": {"vr": "IS", "Value": [4]},
        "3505": {"vr": "IS", "Value": [20]},
        "3506": {"vr": "IS", "Value": [26]},
        "3507": {"vr": "IS", "Value": [38]},
        "3508": {"vr": "IS", "Value": [53]},
        "3509": {"vr": "IS", "Value": [46]},
        "3510": {"vr": "IS", "Value": [35]},
        "3511": {"vr": "IS", "Value": [1]},
        "3512": {"vr": "IS", "Value": [29]},
        "3513": {"vr": "IS", "Value": [40]},
        "3514": {"vr": "IS", "Value": [60]},
        "3515": {"vr": "IS", "Value": [35]},
        "3516": {"vr": "IS", "Value": [2]},
        "3517": {"vr": "IS", "Value": [62]},
        "3518": {"vr": "IS", "Value": [16]},
        "3519": {"vr": "IS", "Value": [36]},
        "3520": {"vr": "IS", "Value": [48]},
        "3521": {"vr": "IS", "Value": [67]},
        "3522": {"vr": "IS", "Value": [1]},
        "3523": {"vr": "IS", "Value": [65]},
        "3524": {"vr": "IS", "Value": [44]},
        "3525": {"vr": "IS", "Value": [33]},
        "3526": {"vr": "IS", "Value": [24]},
        "3527": {"vr": "IS", "Value": [63]},
        "3528": {"vr": "IS", "Value": [19]},
        "3529": {"vr": "IS", "Value": [67]},
        "3530": {"vr": "IS", "Value": [21]},
        "3531": {"vr": "IS", "Value": [10]},
        "3532": {"vr": "IS", "Value": [23]},
        "3533": {"vr": "IS", "Value": [22]},
        "3534": {"vr": "IS", "Value": [60]},
        "3535": {"vr": "IS", "Value": [48]},
        "3536": {"vr": "IS", "Value": [14]},
        "3537": {"vr": "IS", "Value": [8]},
        "3538": {"vr": "IS", "Value": [47]},
        "3539": {"vr": "IS", "Value": [67]},
        "3540": {"vr": "IS", "Value": [39]},
        "3541": {"vr": "IS", "Value": [48]},
        "3542": {"vr": "IS", "Value": [19]},
        "3543": {"vr": "IS", "Value": [27]},
        "3544": {"vr": "IS", "Value": [31]},
        "3545": {"vr": "IS", "Value": [25]},
        "3546": {"vr": "IS", "Value": [33]},
        "3547": {"vr": "IS", "Value": [24]},
        "3548": {"vr": "IS", "Value": [40]},
        "3549": {"vr": "IS", "Value": [8]},
        "3550": {"vr": "IS", "Value": [44]},
        "3551": {"vr": "IS", "Value": [8]},
        "3552": {"vr": "IS", "Value": [61]},
        "3553": {"vr": "IS", "Value": [31]},
        "3554": {"vr": "IS", "Value": [24]},
        "3555": {"vr": "IS", "Value": [30]},
        "3556": {"vr": "IS", "Value": [21]},
        "3557": {"vr": "IS", "Value": [17]},
        "3558": {"vr": "IS", "Value": [7]},
        "3559": {"vr": "IS", "Value": [38]},
        "3560": {"vr": "IS", "Value": [30]},
        "3561": {"vr": "IS", "Value": [51]},
        "3562": {"vr": "IS", "Value": [27]},
        "3563": {"vr": "IS", "Value": [49]},
        "3564": {"vr": "IS", "Value": [28]},
        "3565": {"vr": "IS", "Value": [55]},
        "3566": {"vr": "IS", "Value": [38]},
        "3567": {"vr": "IS", "Value": [7]},
        "3568": {"vr": "IS", "Value": [3]},
        "3569": {"vr": "IS", "Value": [14]},
        "3570": {"vr": "IS", "Value": [22]},
        "3571": {"vr": "IS", "Value": [5]},
        "3572": {"vr": "IS", "Value": [38]},
        "3573": {"vr": "IS", "Value": [5]},
        "3574": {"vr": "IS", "Value": [9]},
        "3575": {"vr": "IS", "Value": [12]},
        "3576": {"vr": "IS", "Value": [44]},
        "3577": {"vr": "IS", "Value": [31]},
        "3578": {"vr": "IS", "Value": [11]},
        "3579": {"vr": "IS", "Value": [33]},
        "3580": {"vr": "IS", "Value": [63]},
        "3581": {"vr": "IS", "Value": [54]},
        "3582": {"vr": "IS", "Value": [36]},
        "3583": {"vr": "IS", "Value": [66]},
        "3584": {"vr": "IS", "Value": [13]},
        "3585": {"vr": "IS", "Value": [37]},
        "3586": {"vr": "IS", "Value": [60]},
        "3587": {"vr": "IS", "Value": [59]},
        "3588": {"vr": "IS", "Value": [27]},
        "3589": {"vr": "IS", "Value": [56]},
        "3590": {"vr": "IS", "Value": [24]},
        "3591": {"vr": "IS", "Value": [53]},
        "3592": {"vr": "IS", "Value": [27]},
        "3593": {"vr": "IS", "Value": [55]},
        "3594": {"vr": "IS", "Value": [52]},
        "3595": {"vr": "IS", "Value": [16]},
        "3596": {"vr": "IS", "Value": [23]},
        "3597": {"vr": "IS", "Value": [17]},
        "3598": {"vr": "IS", "Value": [23]},
        "3599": {"vr": "IS", "Value": [4]},
        "3600": {"vr": "IS", "Value": [44]},
        "3601": {"vr": "IS", "Value": [50]},
        "3602": {"vr": "IS", "Value": [31]},
        "3603": {"vr": "IS", "Value": [21]},
        "3604": {"vr": "IS", "Value": [27]},
        "3605": {"vr": "IS", "Value": [29]},
        "3606": {"vr": "IS", "Value": [37]},
        "3607": {"vr": "IS", "Value": [65]},
        "3608": {"vr": "IS", "Value": [16]},
        "3609": {"vr": "IS", "Value": [60]},
        "3610": {"vr": "IS", "Value": [56]},
        "3611": {"vr": "IS", "Value": [6]},
        "3612": {"vr": "IS", "Value": [35]},
        "3613": {"vr": "IS", "Value": [51]},
        "3614": {"vr": "IS", "Value": [56]},
        "3615": {"vr": "IS", "Value": [8]},
        "3616": {"vr": "IS", "Value": [31]},
        "3617": {"vr": "IS", "Value": [13]},
        "3618": {"vr": "IS", "Value": [8]},
        "3619": {"vr": "IS", "Value": [3]},
        "3620": {"vr": "IS", "Value": [20]},
        "3621": {"vr": "IS", "Value": [24]},
        "3622": {"vr": "IS", "Value": [6]},
        "3623": {"vr": "IS", "Value": [11]},
        "3624": {"vr": "IS", "Value": [66]},
        "3625": {"vr": "IS", "Value": [65]},
        "3626": {"vr": "IS", "Value": [29]},
        "3627": {"vr": "IS", "Value": [59]},
        "3628": {"vr": "IS", "Value": [45]},
        "3629": {"vr": "IS", "Value": [5]},
        "3630": {"vr": "IS", "Value": [59]},
        "3631": {"vr": "IS", "Value": [61]},
        "3632": {"vr": "IS", "Value": [17]},
        "3633": {"vr": "IS", "Value": [49]},
        "3634": {"vr": "IS", "Value": [60]},
        "3635": {"vr": "IS", "Value": [28]},
        "3636": {"vr": "IS", "Value": [65]},
        "3637": {"vr": "IS", "Value": [5]},
        "3638": {"vr": "IS", "Value": [12]},
        "3639": {"vr": "IS", "Value": [64]},
        "3640": {"vr": "IS", "Value": [34]},
        "3641": {"vr": "IS", "Value": [25]},
        "3642": {"vr": "IS", "Value": [64]},
        "3643": {"vr": "IS", "Value": [31]},
        "3644": {"vr": "IS", "Value": [41]},
        "3645": {"vr": "IS", "Value": [9]},
        "3646": {"vr": "IS", "Value": [14]},
        "3647": {"vr": "IS", "Value": [51]},
        "3648": {"vr": "IS", "Value": [49]},
        "3649": {"vr": "IS", "Value": [35]},
        "3650": {"vr": "IS", "Value": [26]},
        "3651": {"vr": "IS", "Value": [20]},
        "3652": {"vr": "IS", "Value": [36]},
        "3653": {"vr": "IS", "Value": [56]},
        "3654": {"vr": "IS", "Value": [34]},
        "3655": {"vr": "IS", "Value": [13]},
        "3656": {"vr": "IS", "Value": [46]},
        "3657": {"vr": "IS", "Value": [61]},
        "3658": {"vr": "IS", "Value": [6]},
        "3659": {"vr": "IS", "Value": [62]},
        "3660": {"vr": "IS", "Value": [10]},
        "3661": {"vr": "IS", "Value": [17]},
        "3662": {"vr": "IS", "Value": [58]},
        "3663": {"vr": "IS", "Value": [58]},
        "3664": {"vr": "IS", "Value": [9]},
        "3665": {"vr": "IS", "Value": [16]},
        "3666": {"vr": "IS", "Value": [50]},
        "3667": {"vr": "IS", "Value": [29]},
        "3668": {"vr": "IS", "Value": [12]},
        "3669": {"vr": "IS", "Value": [20]},
        "3670": {"vr": "IS", "Value": [19]},
        "3671": {"vr": "IS", "Value": [31]},
        "3672": {"vr": "IS", "Value": [5]},
        "3673": {"vr": "IS", "Value": [67]},
        "3674": {"vr": "IS", "Value": [8]},
        "3675": {"vr": "IS", "Value": [26]},
        "3676": {"vr": "IS", "Value": [49]},
        "3677": {"vr": "IS", "Value": [7]},
        "3678": {"vr": "IS", "Value": [49]},
        "3679": {"vr": "IS", "Value": [49]},
        "3680": {"vr": "IS", "Value": [44]},
        "3681": {"vr": "IS", "Value": [13]},
        "3682": {"vr": "IS", "Value": [20]},
        "3683": {"vr": "IS", "Value": [32]},
        "3684": {"vr": "IS", "Value": [9]},
        "3685": {"vr": "IS", "Value": [48]},
        "3686": {"vr": "IS", "Value": [24]},
        "3687": {"vr": "IS", "Value": [45]},
        "3688": {"vr": "IS", "Value": [40]},
        "3689": {"vr": "IS", "Value": [51]},
        "3690": {"vr": "IS", "Value": [4]},
        "3691": {"vr": "IS", "Value": [24]},
        "3692": {"vr": "IS", "Value": [7]},
        "3693": {"vr": "IS", "Value": [37]},
        "3694": {"vr": "IS", "Value": [62]},
        "3695": {"vr": "IS", "Value": [8]},
        "3696": {"vr": "IS", "Value": [34]},
        "3697": {"vr": "IS", "Value": [27]},
        "3698": {"vr": "IS", "Value": [12]},
        "3699": {"vr": "IS", "Value": [21]},
        "3700": {"vr": "IS", "Value": [65]},
        "3701": {"vr": "IS", "Value": [10]},
        "3702": {"vr": "IS", "Value": [17]},
        "3703": {"vr": "IS", "Value": [64]},
        "3704": {"vr": "IS", "Value": [46]},
        "3705": {"vr": "IS", "Value": [7]},
        "3706": {"vr": "IS", "Value": [39]},
        "3707": {"vr": "IS", "Value": [14]},
        "3708": {"vr": "IS", "Value": [49]},
        "3709": {"vr": "IS", "Value": [22]},
        "3710": {"vr": "IS", "Value": [51]},
        "3711": {"vr": "IS", "Value": [57]},
        "3712": {"vr": "IS", "Value": [26]},
        "3713": {"vr": "IS", "Value": [2]},
        "3714": {"vr": "IS", "Value": [64]},
        "3715": {"vr": "IS", "Value": [38]},
        "3716": {"vr": "IS", "Value": [45]},
        "3717": {"vr": "IS", "Value": [62]},
        "3718": {"vr": "IS", "Value": [58]},
        "3719": {"vr": "IS", "Value": [6]},
        "3720": {"vr": "IS", "Value": [52]},
        "3721": {"vr": "IS", "Value": [32]},
        "3722": {"vr": "IS", "Value": [27]},
        "3723": {"vr": "IS", "Value": [23]},
        "3724": {"vr": "IS", "Value": [15]},
        "3725": {"vr": "IS", "Value": [11]},
        "3726": {"vr": "IS", "Value": [48]},
        "3727": {"vr": "IS", "Value": [39]},
        "3728": {"vr": "IS", "Value": [46]},
        "3729": {"vr": "IS", "Value": [56]},
        "3730": {"vr": "IS", "Value": [8]},
        "3731": {"vr": "IS", "Value": [42]},
        "3732": {"vr": "IS", "Value": [14]},
        "3733": {"vr": "IS", "Value": [3]},
        "3734": {"vr": "IS", "Value": [62]},
        "3735": {"vr": "IS", "Value": [56]},
        "3736": {"vr": "IS", "Value": [61]},
        "3737": {"vr": "IS", "Value": [25]},
        "3738": {"vr": "IS", "Value": [64]},
        "3739": {"vr": "IS", "Value": [38]},
        "3740": {"vr": "IS", "Value": [21]},
        "3741": {"vr": "IS", "Value": [43]},
        "3742": {"vr": "IS", "Value": [34]},
        "3743": {"vr": "IS", "Value": [51]},
        "3744": {"vr": "IS", "Value": [1]},
        "3745": {"vr": "IS", "Value": [3]},
        "3746": {"vr": "IS", "Value": [19]},
        "3747": {"vr": "IS", "Value": [61]},
        "3748": {"vr": "IS", "Value": [59]},
        "3749": {"vr": "IS", "Value": [22]},
        "3750": {"vr": "IS", "Value": [25]},
        "3751": {"vr": "IS", "Value": [20]},
        "3752": {"vr": "IS", "Value": [20]},
        "3753": {"vr": "IS", "Value": [30]},
        "3754": {"vr": "IS", "Value": [33]},
        "3755": {"vr": "IS", "Value": [35]},
        "3756": {"vr": "IS", "Value": [45]},
        "3757": {"vr": "IS", "Value": [9]},
        "3758": {"vr": "IS", "Value": [57]},
        "3759": {"vr": "IS", "Value": [30]},
        "3760": {"vr": "IS", "Value": [10]},
        "3761": {"vr": "IS", "Value": [28]},
        "3762": {"vr": "IS", "Value": [5]},
        "3763": {"vr": "IS", "Value": [45]},
        "3764": {"vr": "IS", "Value": [40]},
        "3765": {"vr": "IS", "Value": [66]},
        "3766": {"vr": "IS", "Value": [32]},
        "3767": {"vr": "IS", "Value": [43]},
        "3768": {"vr": "IS", "Value": [57]},
        "3769": {"vr": "IS", "Value": [11]},
        "3770": {"vr": "IS", "Value": [17]},
        "3771": {"vr": "IS", "Value": [64]},
        "3772": {"vr": "IS", "Value": [35]},
        "3773": {"vr": "IS", "Value": [55]},
        "3774": {"vr": "IS", "Value": [29]},
        "3775": {"vr": "IS", "Value": [41]},
        "3776": {"vr": "IS", "Value": [2]},
        "3777": {"vr": "IS", "Value": [35]},
        "3778": {"vr": "IS", "Value": [6]},
        "3779": {"vr": "IS", "Value": [24]},
        "3780": {"vr": "IS", "Value": [6]},
        "3781": {"vr": "IS", "Value": [58]},
        "3782": {"vr": "IS", "Value": [10]},
        "3783": {"vr": "IS", "Value": [11]},
        "3784": {"vr": "IS", "Value": [65]},
        "3785": {"vr": "IS", "Value": [11]},
        "3786": {"vr": "IS", "Value": [35]},
        "3787": {"vr": "IS", "Value": [2]},
        "3788": {"vr": "IS", "Value": [12]},
        "3789": {"vr": "IS", "Value": [54]},
        "3790": {"vr": "IS", "Value": [13]},
        "3791": {"vr": "IS", "Value": [9]},
        "3792": {"vr": "IS", "Value": [17]},
        "3793": {"vr": "IS", "Value": [31]},
        "3794": {"vr": "IS", "Value": [2]},
        "3795": {"vr": "IS", "Value": [45]},
        "3796": {"vr": "IS", "Value": [63]},
        "3797": {"vr": "IS", "Value": [18]},
        "3798": {"vr": "IS", "Value": [44]},
        "3799": {"vr": "IS", "Value": [17]},
        "3800": {"vr": "IS", "Value": [62]},
        "3801": {"vr": "IS", "Value": [31]},
        "3802": {"vr": "IS", "Value": [60]},
        "3803": {"vr": "IS", "Value": [11]},
        "3804": {"vr": "IS", "Value": [43]},
        "3805": {"vr": "IS", "Value": [45]},
        "3806": {"vr": "IS", "Value": [45]},
        "3807": {"vr": "IS", "Value": [53]},
        "3808": {"vr": "IS", "Value": [63]},
        "3809": {"vr": "IS", "Value": [13]},
        "3810": {"vr": "IS", "Value": [57]},
        "3811": {"vr": "IS", "Value": [50]},
        "3812": {"vr": "IS", "Value": [66]},
        "3813": {"vr": "IS", "Value": [48]},
        "3814": {"vr": "IS", "Value": [25]},
        "3815": {"vr": "IS", "Value": [41]},
        "3816": {"vr": "IS", "Value": [47]},
        "3817": {"vr": "IS", "Value": [46]},
        "3818": {"vr": "IS", "Value": [11]},
        "3819": {"vr": "IS", "Value": [22]},
        "3820": {"vr": "IS", "Value": [44]},
        "3821": {"vr": "IS", "Value": [39]},
        "3822": {"vr": "IS", "Value": [63]},
        "3823": {"vr": "IS", "Value": [48]},
        "3824": {"vr": "IS", "Value": [66]},
        "3825": {"vr": "IS", "Value": [23]},
        "3826": {"vr": "IS", "Value": [5]},
        "3827": {"vr": "IS", "Value": [37]},
        "3828": {"vr": "IS", "Value": [22]},
        "3829": {"vr": "IS", "Value": [55]},
        "3830": {"vr": "IS", "Value": [27]},
        "3831": {"vr": "IS", "Value": [40]},
        "3832": {"vr": "IS", "Value": [34]},
        "3833": {"vr": "IS", "Value": [31]},
        "3834": {"vr": "IS", "Value": [6]},
        "3835": {"vr": "IS", "Value": [60]},
        "3836": {"vr": "IS", "Value": [49]},
        "3837": {"vr": "IS", "Value": [16]},
        "3838": {"vr": "IS", "Value": [2]},
        "3839": {"vr": "IS", "Value": [2]},
        "3840": {"vr": "IS", "Value": [54]},
        "3841": {"vr": "IS", "Value": [13]},
        "3842": {"vr": "IS", "Value": [6]},
        "3843": {"vr": "IS", "Value": [41]},
        "3844": {"vr": "IS", "Value": [13]},
        "3845": {"vr": "IS", "Value": [23]},
        "3846": {"vr": "IS", "Value": [48]},
        "3847": {"vr": "IS", "Value": [43]},
        "3848": {"vr": "IS", "Value": [44]},
        "3849": {"vr": "IS", "Value": [62]},
        "3850": {"vr": "IS", "Value": [35]},
        "3851": {"vr": "IS", "Value": [47]},
        "3852": {"vr": "IS", "Value": [14]},
        "3853": {"vr": "IS", "Value": [5]},
        "3854": {"vr": "IS", "Value": [24]},
        "3855": {"vr": "IS", "Value": [67]},
        "3856": {"vr": "IS", "Value": [3]},
        "3857": {"vr": "IS", "Value": [14]},
        "3858": {"vr": "IS", "Value": [3]},
        "3859": {"vr": "IS", "Value": [37]},
        "3860": {"vr": "IS", "Value": [16]},
        "3861": {"vr": "IS", "Value": [32]},
        "3862": {"vr": "IS", "Value": [18]},
        "3863": {"vr": "IS", "Value": [56]},
        "3864": {"vr": "IS", "Value": [26]},
        "3865": {"vr": "IS", "Value": [41]},
        "3866": {"vr": "IS", "Value": [30]},
        "3867": {"vr": "IS", "Value": [7]},
        "3868": {"vr": "IS", "Value": [13]},
        "3869": {"vr": "IS", "Value": [51]},
        "3870": {"vr": "IS", "Value": [65]},
        "3871": {"vr": "IS", "Value": [58]},
        "3872": {"vr": "IS", "Value": [7]},
        "3873": {"vr": "IS", "Value": [54]},
        "3874": {"vr": "IS", "Value": [44]},
        "3875": {"vr": "IS", "Value": [61]},
        "3876": {"vr": "IS", "Value": [18]},
        "3877": {"vr": "IS", "Value": [60]},
        "3878": {"vr": "IS", "Value": [56]},
        "3879": {"vr": "IS", "Value": [16]},
        "3880": {"vr": "IS", "Value": [47]},
        "3881": {"vr": "IS", "Value": [26]},
        "3882": {"vr": "IS", "Value": [45]},
        "3883": {"vr": "IS", "Value": [30]},
        "3884": {"vr": "IS", "Value": [35]},
        "3885": {"vr": "IS", "Value": [12]},
        "3886": {"vr": "IS", "Value": [55]},
        "3887": {"vr": "IS", "Value": [36]},
        "3888": {"vr": "IS", "Value": [20]},
        "3889": {"vr": "IS", "Value": [4]},
        "3890": {"vr": "IS", "Value": [29]},
        "3891": {"vr": "IS", "Value": [41]},
        "3892": {"vr": "IS", "Value": [63]},
        "3893": {"vr": "IS", "Value": [46]},
        "3894": {"vr": "IS", "Value": [5]},
        "3895": {"vr": "IS", "Value": [17]},
        "3896": {"vr": "IS", "Value": [63]},
        "3897": {"vr": "IS", "Value": [59]},
        "3898": {"vr": "IS", "Value": [41]},
        "3899": {"vr": "IS", "Value": [48]},
        "3900": {"vr": "IS", "Value": [12]},
        "3901": {"vr": "IS", "Value": [53]},
        "3902": {"vr": "IS", "Value": [36]},
        "3903": {"vr": "IS", "Value": [50]},
        "3904": {"vr": "IS", "Value": [32]},
        "3905": {"vr": "IS", "Value": [65]},
        "3906": {"vr": "IS", "Value": [38]},
        "3907": {"vr": "IS", "Value": [59]},
        "3908": {"vr": "IS", "Value": [20]},
        "3909": {"vr": "IS", "Value": [11]},
        "3910": {"vr": "IS", "Value": [5]},
        "3911": {"vr": "IS", "Value": [25]},
        "3912": {"vr": "IS", "Value": [62]},
        "3913": {"vr": "IS", "Value": [29]},
        "3914": {"vr": "IS", "Value": [39]},
        "3915": {"vr": "IS", "Value": [3]},
        "3916": {"vr": "IS", "Value": [23]},
        "3917": {"vr": "IS", "Value": [7]},
        "3918": {"vr": "IS", "Value": [33]},
        "3919": {"vr": "IS", "Value": [28]},
        "3920": {"vr": "IS", "Value": [19]},
        "3921": {"vr": "IS", "Value": [57]},
        "3922": {"vr": "IS", "Value": [64]},
        "3923": {"vr": "IS", "Value": [10]},
        "3924": {"vr": "IS", "Value": [3]},
        "3925": {"vr": "IS", "Value": [19]},
        "3926": {"vr": "IS", "Value": [48]},
        "3927": {"vr": "IS", "Value": [50]},
        "3928": {"vr": "IS", "Value": [34]},
        "3929": {"vr": "IS", "Value": [55]},
        "3930": {"vr": "IS", "Value": [51]},
        "3931": {"vr": "IS", "Value": [32]},
        "3932": {"vr": "IS", "Value": [46]},
        "3933": {"vr": "IS", "Value": [59]},
        "3934": {"vr": "IS", "Value": [37]},
        "3935": {"vr": "IS", "Value": [59]},
        "3936": {"vr": "IS", "Value": [37]},
        "3937": {"vr": "IS", "Value": [45]},
        "3938": {"vr": "IS", "Value": [63]},
        "3939": {"vr": "IS", "Value": [11]},
        "3940": {"vr": "IS", "Value": [28]},
        "3941": {"vr": "IS", "Value": [58]},
        "3942": {"vr": "IS", "Value": [48]},
        "3943": {"vr": "IS", "Value": [62]},
        "3944": {"vr": "IS", "Value": [38]},
        "3945": {"vr": "IS", "Value": [23]},
        "3946": {"vr": "IS", "Value": [62]},
        "3947": {"vr": "IS", "Value": [11]},
        "3948": {"vr": "IS", "Value": [22]},
        "3949": {"vr": "IS", "Value": [60]},
        "3950": {"vr": "IS", "Value": [42]},
        "3951": {"vr": "IS", "Value": [26]},
        "3952": {"vr": "IS", "Value": [37]},
        "3953": {"vr": "IS", "Value": [37]},
        "3954": {"vr": "IS", "Value": [8]},
        "3955": {"vr": "IS", "Value": [66]},
        "3956": {"vr": "IS", "Value": [36]},
        "3957": {"vr": "IS", "Value": [33]},
        "3958": {"vr": "IS", "Value": [24]},
        "3959": {"vr": "IS", "Value": [59]},
        "3960": {"vr": "IS", "Value": [44]},
        "3961": {"vr": "IS", "Value": [48]},
        "3962": {"vr": "IS", "Value": [55]},
        "3963": {"vr": "IS", "Value": [15]},
        "3964": {"vr": "IS", "Value": [47]},
        "3965": {"vr": "IS", "Value": [65]},
        "3966": {"vr": "IS", "Value": [13]},
        "3967": {"vr": "IS", "Value": [27]},
        "3968": {"vr": "IS", "Value": [12]},
        "3969": {"vr": "IS", "Value": [5]},
        "3970": {"vr": "IS", "Value": [30]},
        "3971": {"vr": "IS", "Value": [7]},
        "3972": {"vr": "IS", "Value": [51]},
        "3973": {"vr": "IS", "Value": [26]},
        "3974": {"vr": "IS", "Value": [20]},
        "3975": {"vr": "IS", "Value": [53]},
        "3976": {"vr": "IS", "Value": [3]},
        "3977": {"vr": "IS", "Value": [9]},
        "3978": {"vr": "IS", "Value": [64]},
        "3979": {"vr": "IS", "Value": [29]},
        "3980": {"vr": "IS", "Value": [11]},
        "3981": {"vr": "IS", "Value": [48]},
        "3982": {"vr": "IS", "Value": [32]},
        "3983": {"vr": "IS", "Value": [4]},
        "3984": {"vr": "IS", "Value": [18]},
        "3985": {"vr": "IS", "Value": [39]},
        "3986": {"vr": "IS", "Value": [63]},
        "3987": {"vr": "IS", "Value": [28]},
        "3988": {"vr": "IS", "Value": [32]},
        "3989": {"vr": "IS", "Value": [25]},
        "3990": {"vr": "IS", "Value": [38]},
        "3991": {"vr": "IS", "Value": [38]},
        "3992": {"vr": "IS", "Value": [63]},
        "3993": {"vr": "IS", "Value": [58]},
        "3994": {"vr": "IS", "Value": [31]},
        "3995": {"vr": "IS", "Value": [13]},
        "3996": {"vr": "IS", "Value": [6]},
        "3997": {"vr": "IS", "Value": [59]},
        "3998": {"vr": "IS", "Value": [31]},
        "3999": {"vr": "IS", "Value": [48]},
        "4000": {"vr": "IS", "Value": [60]},
        "4001": {"vr": "IS", "Value": [48]},
        "4002": {"vr": "IS", "Value": [52]},
        "4003": {"vr": "IS", "Value": [24]},
        "4004": {"vr": "IS", "Value": [58]},
        "4005": {"vr": "IS", "Value": [16]},
        "4006": {"vr": "IS", "Value": [8]},
        "4007": {"vr": "IS", "Value": [40]},
        "4008": {"vr": "IS", "Value": [15]},
        "4009": {"vr": "IS", "Value": [34]},
        "4010": {"vr": "IS", "Value": [35]},
        "4011": {"vr": "IS", "Value": [12]},
        "4012": {"vr": "IS", "Value": [54]},
        "4013": {"vr": "IS", "Value": [11]},
        "4014": {"vr": "IS", "Value": [22]},
        "4015": {"vr": "IS", "Value": [61]},
        "4016": {"vr": "IS", "Value": [60]},
        "4017": {"vr": "IS", "Value": [32]},
        "4018": {"vr": "IS", "Value": [51]},
        "4019": {"vr": "IS", "Value": [40]},
    },
    "00200013": {
        "0": {"vr": "IS", "Value": [1297]},
        "1": {"vr": "IS", "Value": [1795]},
        "2": {"vr": "IS", "Value": [2542]},
        "3": {"vr": "IS", "Value": [2651]},
        "4": {"vr": "IS", "Value": [2362]},
        "5": {"vr": "IS", "Value": [2308]},
        "6": {"vr": "IS", "Value": [3246]},
        "7": {"vr": "IS", "Value": [3378]},
        "8": {"vr": "IS", "Value": [1406]},
        "9": {"vr": "IS", "Value": [765]},
        "10": {"vr": "IS", "Value": [3215]},
        "11": {"vr": "IS", "Value": [1488]},
        "12": {"vr": "IS", "Value": [1427]},
        "13": {"vr": "IS", "Value": [50]},
        "14": {"vr": "IS", "Value": [2000]},
        "15": {"vr": "IS", "Value": [2753]},
        "16": {"vr": "IS", "Value": [3150]},
        "17": {"vr": "IS", "Value": [392]},
        "18": {"vr": "IS", "Value": [1153]},
        "19": {"vr": "IS", "Value": [2802]},
        "20": {"vr": "IS", "Value": [844]},
        "21": {"vr": "IS", "Value": [2827]},
        "22": {"vr": "IS", "Value": [2995]},
        "23": {"vr": "IS", "Value": [3579]},
        "24": {"vr": "IS", "Value": [2904]},
        "25": {"vr": "IS", "Value": [1182]},
        "26": {"vr": "IS", "Value": [1866]},
        "27": {"vr": "IS", "Value": [909]},
        "28": {"vr": "IS", "Value": [1094]},
        "29": {"vr": "IS", "Value": [2716]},
        "30": {"vr": "IS", "Value": [1892]},
        "31": {"vr": "IS", "Value": [1341]},
        "32": {"vr": "IS", "Value": [2143]},
        "33": {"vr": "IS", "Value": [1058]},
        "34": {"vr": "IS", "Value": [4011]},
        "35": {"vr": "IS", "Value": [4]},
        "36": {"vr": "IS", "Value": [641]},
        "37": {"vr": "IS", "Value": [1144]},
        "38": {"vr": "IS", "Value": [2449]},
        "39": {"vr": "IS", "Value": [1712]},
        "40": {"vr": "IS", "Value": [3345]},
        "41": {"vr": "IS", "Value": [3797]},
        "42": {"vr": "IS", "Value": [3870]},
        "43": {"vr": "IS", "Value": [1155]},
        "44": {"vr": "IS", "Value": [3125]},
        "45": {"vr": "IS", "Value": [475]},
        "46": {"vr": "IS", "Value": [3231]},
        "47": {"vr": "IS", "Value": [3810]},
        "48": {"vr": "IS", "Value": [1670]},
        "49": {"vr": "IS", "Value": [175]},
        "50": {"vr": "IS", "Value": [3036]},
        "51": {"vr": "IS", "Value": [3092]},
        "52": {"vr": "IS", "Value": [3164]},
        "53": {"vr": "IS", "Value": [1261]},
        "54": {"vr": "IS", "Value": [581]},
        "55": {"vr": "IS", "Value": [1538]},
        "56": {"vr": "IS", "Value": [2328]},
        "57": {"vr": "IS", "Value": [1656]},
        "58": {"vr": "IS", "Value": [1394]},
        "59": {"vr": "IS", "Value": [964]},
        "60": {"vr": "IS", "Value": [2689]},
        "61": {"vr": "IS", "Value": [3330]},
        "62": {"vr": "IS", "Value": [1320]},
        "63": {"vr": "IS", "Value": [3889]},
        "64": {"vr": "IS", "Value": [2267]},
        "65": {"vr": "IS", "Value": [3908]},
        "66": {"vr": "IS", "Value": [1277]},
        "67": {"vr": "IS", "Value": [1465]},
        "68": {"vr": "IS", "Value": [713]},
        "69": {"vr": "IS", "Value": [865]},
        "70": {"vr": "IS", "Value": [562]},
        "71": {"vr": "IS", "Value": [2335]},
        "72": {"vr": "IS", "Value": [2322]},
        "73": {"vr": "IS", "Value": [2829]},
        "74": {"vr": "IS", "Value": [391]},
        "75": {"vr": "IS", "Value": [3661]},
        "76": {"vr": "IS", "Value": [2844]},
        "77": {"vr": "IS", "Value": [1912]},
        "78": {"vr": "IS", "Value": [2724]},
        "79": {"vr": "IS", "Value": [1046]},
        "80": {"vr": "IS", "Value": [3985]},
        "81": {"vr": "IS", "Value": [385]},
        "82": {"vr": "IS", "Value": [2518]},
        "83": {"vr": "IS", "Value": [2141]},
        "84": {"vr": "IS", "Value": [113]},
        "85": {"vr": "IS", "Value": [2729]},
        "86": {"vr": "IS", "Value": [3099]},
        "87": {"vr": "IS", "Value": [2876]},
        "88": {"vr": "IS", "Value": [1646]},
        "89": {"vr": "IS", "Value": [3527]},
        "90": {"vr": "IS", "Value": [30]},
        "91": {"vr": "IS", "Value": [677]},
        "92": {"vr": "IS", "Value": [2962]},
        "93": {"vr": "IS", "Value": [550]},
        "94": {"vr": "IS", "Value": [3481]},
        "95": {"vr": "IS", "Value": [935]},
        "96": {"vr": "IS", "Value": [1011]},
        "97": {"vr": "IS", "Value": [3917]},
        "98": {"vr": "IS", "Value": [112]},
        "99": {"vr": "IS", "Value": [61]},
        "100": {"vr": "IS", "Value": [469]},
        "101": {"vr": "IS", "Value": [1519]},
        "102": {"vr": "IS", "Value": [498]},
        "103": {"vr": "IS", "Value": [2106]},
        "104": {"vr": "IS", "Value": [3218]},
        "105": {"vr": "IS", "Value": [3502]},
        "106": {"vr": "IS", "Value": [2908]},
        "107": {"vr": "IS", "Value": [3456]},
        "108": {"vr": "IS", "Value": [896]},
        "109": {"vr": "IS", "Value": [855]},
        "110": {"vr": "IS", "Value": [3877]},
        "111": {"vr": "IS", "Value": [3203]},
        "112": {"vr": "IS", "Value": [1332]},
        "113": {"vr": "IS", "Value": [3876]},
        "114": {"vr": "IS", "Value": [2003]},
        "115": {"vr": "IS", "Value": [2972]},
        "116": {"vr": "IS", "Value": [3273]},
        "117": {"vr": "IS", "Value": [840]},
        "118": {"vr": "IS", "Value": [2632]},
        "119": {"vr": "IS", "Value": [3953]},
        "120": {"vr": "IS", "Value": [295]},
        "121": {"vr": "IS", "Value": [167]},
        "122": {"vr": "IS", "Value": [3105]},
        "123": {"vr": "IS", "Value": [92]},
        "124": {"vr": "IS", "Value": [2907]},
        "125": {"vr": "IS", "Value": [2056]},
        "126": {"vr": "IS", "Value": [3829]},
        "127": {"vr": "IS", "Value": [1699]},
        "128": {"vr": "IS", "Value": [2652]},
        "129": {"vr": "IS", "Value": [1227]},
        "130": {"vr": "IS", "Value": [480]},
        "131": {"vr": "IS", "Value": [2728]},
        "132": {"vr": "IS", "Value": [3496]},
        "133": {"vr": "IS", "Value": [3824]},
        "134": {"vr": "IS", "Value": [3516]},
        "135": {"vr": "IS", "Value": [1057]},
        "136": {"vr": "IS", "Value": [1898]},
        "137": {"vr": "IS", "Value": [2302]},
        "138": {"vr": "IS", "Value": [457]},
        "139": {"vr": "IS", "Value": [1175]},
        "140": {"vr": "IS", "Value": [1442]},
        "141": {"vr": "IS", "Value": [215]},
        "142": {"vr": "IS", "Value": [2154]},
        "143": {"vr": "IS", "Value": [3115]},
        "144": {"vr": "IS", "Value": [2180]},
        "145": {"vr": "IS", "Value": [3143]},
        "146": {"vr": "IS", "Value": [398]},
        "147": {"vr": "IS", "Value": [905]},
        "148": {"vr": "IS", "Value": [3250]},
        "149": {"vr": "IS", "Value": [3089]},
        "150": {"vr": "IS", "Value": [1961]},
        "151": {"vr": "IS", "Value": [887]},
        "152": {"vr": "IS", "Value": [3893]},
        "153": {"vr": "IS", "Value": [971]},
        "154": {"vr": "IS", "Value": [76]},
        "155": {"vr": "IS", "Value": [2781]},
        "156": {"vr": "IS", "Value": [1116]},
        "157": {"vr": "IS", "Value": [1567]},
        "158": {"vr": "IS", "Value": [2214]},
        "159": {"vr": "IS", "Value": [331]},
        "160": {"vr": "IS", "Value": [3997]},
        "161": {"vr": "IS", "Value": [3234]},
        "162": {"vr": "IS", "Value": [1019]},
        "163": {"vr": "IS", "Value": [3071]},
        "164": {"vr": "IS", "Value": [767]},
        "165": {"vr": "IS", "Value": [3012]},
        "166": {"vr": "IS", "Value": [2331]},
        "167": {"vr": "IS", "Value": [1666]},
        "168": {"vr": "IS", "Value": [575]},
        "169": {"vr": "IS", "Value": [1254]},
        "170": {"vr": "IS", "Value": [342]},
        "171": {"vr": "IS", "Value": [1141]},
        "172": {"vr": "IS", "Value": [254]},
        "173": {"vr": "IS", "Value": [3801]},
        "174": {"vr": "IS", "Value": [882]},
        "175": {"vr": "IS", "Value": [1291]},
        "176": {"vr": "IS", "Value": [154]},
        "177": {"vr": "IS", "Value": [3182]},
        "178": {"vr": "IS", "Value": [3673]},
        "179": {"vr": "IS", "Value": [3158]},
        "180": {"vr": "IS", "Value": [816]},
        "181": {"vr": "IS", "Value": [1319]},
        "182": {"vr": "IS", "Value": [3040]},
        "183": {"vr": "IS", "Value": [2505]},
        "184": {"vr": "IS", "Value": [192]},
        "185": {"vr": "IS", "Value": [1087]},
        "186": {"vr": "IS", "Value": [2958]},
        "187": {"vr": "IS", "Value": [2978]},
        "188": {"vr": "IS", "Value": [3832]},
        "189": {"vr": "IS", "Value": [1620]},
        "190": {"vr": "IS", "Value": [2127]},
        "191": {"vr": "IS", "Value": [57]},
        "192": {"vr": "IS", "Value": [2821]},
        "193": {"vr": "IS", "Value": [472]},
        "194": {"vr": "IS", "Value": [3736]},
        "195": {"vr": "IS", "Value": [2173]},
        "196": {"vr": "IS", "Value": [2462]},
        "197": {"vr": "IS", "Value": [1591]},
        "198": {"vr": "IS", "Value": [36]},
        "199": {"vr": "IS", "Value": [2473]},
        "200": {"vr": "IS", "Value": [161]},
        "201": {"vr": "IS", "Value": [2718]},
        "202": {"vr": "IS", "Value": [2926]},
        "203": {"vr": "IS", "Value": [1083]},
        "204": {"vr": "IS", "Value": [1700]},
        "205": {"vr": "IS", "Value": [2971]},
        "206": {"vr": "IS", "Value": [3078]},
        "207": {"vr": "IS", "Value": [2288]},
        "208": {"vr": "IS", "Value": [235]},
        "209": {"vr": "IS", "Value": [516]},
        "210": {"vr": "IS", "Value": [2005]},
        "211": {"vr": "IS", "Value": [2248]},
        "212": {"vr": "IS", "Value": [3529]},
        "213": {"vr": "IS", "Value": [3546]},
        "214": {"vr": "IS", "Value": [2857]},
        "215": {"vr": "IS", "Value": [2341]},
        "216": {"vr": "IS", "Value": [860]},
        "217": {"vr": "IS", "Value": [779]},
        "218": {"vr": "IS", "Value": [3750]},
        "219": {"vr": "IS", "Value": [1797]},
        "220": {"vr": "IS", "Value": [1416]},
        "221": {"vr": "IS", "Value": [2061]},
        "222": {"vr": "IS", "Value": [2147]},
        "223": {"vr": "IS", "Value": [237]},
        "224": {"vr": "IS", "Value": [281]},
        "225": {"vr": "IS", "Value": [338]},
        "226": {"vr": "IS", "Value": [2478]},
        "227": {"vr": "IS", "Value": [667]},
        "228": {"vr": "IS", "Value": [2257]},
        "229": {"vr": "IS", "Value": [1225]},
        "230": {"vr": "IS", "Value": [839]},
        "231": {"vr": "IS", "Value": [759]},
        "232": {"vr": "IS", "Value": [3008]},
        "233": {"vr": "IS", "Value": [3090]},
        "234": {"vr": "IS", "Value": [1260]},
        "235": {"vr": "IS", "Value": [3074]},
        "236": {"vr": "IS", "Value": [3557]},
        "237": {"vr": "IS", "Value": [233]},
        "238": {"vr": "IS", "Value": [2045]},
        "239": {"vr": "IS", "Value": [3160]},
        "240": {"vr": "IS", "Value": [1606]},
        "241": {"vr": "IS", "Value": [2043]},
        "242": {"vr": "IS", "Value": [2553]},
        "243": {"vr": "IS", "Value": [1366]},
        "244": {"vr": "IS", "Value": [3767]},
        "245": {"vr": "IS", "Value": [3363]},
        "246": {"vr": "IS", "Value": [48]},
        "247": {"vr": "IS", "Value": [496]},
        "248": {"vr": "IS", "Value": [2223]},
        "249": {"vr": "IS", "Value": [2297]},
        "250": {"vr": "IS", "Value": [2633]},
        "251": {"vr": "IS", "Value": [1176]},
        "252": {"vr": "IS", "Value": [2144]},
        "253": {"vr": "IS", "Value": [2164]},
        "254": {"vr": "IS", "Value": [2389]},
        "255": {"vr": "IS", "Value": [1497]},
        "256": {"vr": "IS", "Value": [3331]},
        "257": {"vr": "IS", "Value": [3664]},
        "258": {"vr": "IS", "Value": [1580]},
        "259": {"vr": "IS", "Value": [1529]},
        "260": {"vr": "IS", "Value": [617]},
        "261": {"vr": "IS", "Value": [3265]},
        "262": {"vr": "IS", "Value": [1162]},
        "263": {"vr": "IS", "Value": [447]},
        "264": {"vr": "IS", "Value": [3438]},
        "265": {"vr": "IS", "Value": [3806]},
        "266": {"vr": "IS", "Value": [3841]},
        "267": {"vr": "IS", "Value": [1381]},
        "268": {"vr": "IS", "Value": [537]},
        "269": {"vr": "IS", "Value": [2793]},
        "270": {"vr": "IS", "Value": [4015]},
        "271": {"vr": "IS", "Value": [2943]},
        "272": {"vr": "IS", "Value": [3715]},
        "273": {"vr": "IS", "Value": [1865]},
        "274": {"vr": "IS", "Value": [560]},
        "275": {"vr": "IS", "Value": [679]},
        "276": {"vr": "IS", "Value": [2989]},
        "277": {"vr": "IS", "Value": [3630]},
        "278": {"vr": "IS", "Value": [1404]},
        "279": {"vr": "IS", "Value": [1167]},
        "280": {"vr": "IS", "Value": [2421]},
        "281": {"vr": "IS", "Value": [1564]},
        "282": {"vr": "IS", "Value": [201]},
        "283": {"vr": "IS", "Value": [1915]},
        "284": {"vr": "IS", "Value": [3726]},
        "285": {"vr": "IS", "Value": [2963]},
        "286": {"vr": "IS", "Value": [2153]},
        "287": {"vr": "IS", "Value": [431]},
        "288": {"vr": "IS", "Value": [857]},
        "289": {"vr": "IS", "Value": [3895]},
        "290": {"vr": "IS", "Value": [3966]},
        "291": {"vr": "IS", "Value": [1585]},
        "292": {"vr": "IS", "Value": [1889]},
        "293": {"vr": "IS", "Value": [946]},
        "294": {"vr": "IS", "Value": [3779]},
        "295": {"vr": "IS", "Value": [2585]},
        "296": {"vr": "IS", "Value": [1022]},
        "297": {"vr": "IS", "Value": [130]},
        "298": {"vr": "IS", "Value": [125]},
        "299": {"vr": "IS", "Value": [91]},
        "300": {"vr": "IS", "Value": [3812]},
        "301": {"vr": "IS", "Value": [4012]},
        "302": {"vr": "IS", "Value": [2480]},
        "303": {"vr": "IS", "Value": [1741]},
        "304": {"vr": "IS", "Value": [1848]},
        "305": {"vr": "IS", "Value": [814]},
        "306": {"vr": "IS", "Value": [3649]},
        "307": {"vr": "IS", "Value": [1757]},
        "308": {"vr": "IS", "Value": [3572]},
        "309": {"vr": "IS", "Value": [2303]},
        "310": {"vr": "IS", "Value": [2210]},
        "311": {"vr": "IS", "Value": [670]},
        "312": {"vr": "IS", "Value": [2603]},
        "313": {"vr": "IS", "Value": [3965]},
        "314": {"vr": "IS", "Value": [3854]},
        "315": {"vr": "IS", "Value": [883]},
        "316": {"vr": "IS", "Value": [678]},
        "317": {"vr": "IS", "Value": [3589]},
        "318": {"vr": "IS", "Value": [1436]},
        "319": {"vr": "IS", "Value": [2220]},
        "320": {"vr": "IS", "Value": [2536]},
        "321": {"vr": "IS", "Value": [847]},
        "322": {"vr": "IS", "Value": [3706]},
        "323": {"vr": "IS", "Value": [1839]},
        "324": {"vr": "IS", "Value": [1782]},
        "325": {"vr": "IS", "Value": [850]},
        "326": {"vr": "IS", "Value": [358]},
        "327": {"vr": "IS", "Value": [2483]},
        "328": {"vr": "IS", "Value": [3279]},
        "329": {"vr": "IS", "Value": [2499]},
        "330": {"vr": "IS", "Value": [207]},
        "331": {"vr": "IS", "Value": [1877]},
        "332": {"vr": "IS", "Value": [819]},
        "333": {"vr": "IS", "Value": [3029]},
        "334": {"vr": "IS", "Value": [1651]},
        "335": {"vr": "IS", "Value": [1238]},
        "336": {"vr": "IS", "Value": [950]},
        "337": {"vr": "IS", "Value": [1605]},
        "338": {"vr": "IS", "Value": [195]},
        "339": {"vr": "IS", "Value": [1425]},
        "340": {"vr": "IS", "Value": [566]},
        "341": {"vr": "IS", "Value": [3860]},
        "342": {"vr": "IS", "Value": [1193]},
        "343": {"vr": "IS", "Value": [3455]},
        "344": {"vr": "IS", "Value": [1456]},
        "345": {"vr": "IS", "Value": [2842]},
        "346": {"vr": "IS", "Value": [512]},
        "347": {"vr": "IS", "Value": [749]},
        "348": {"vr": "IS", "Value": [1954]},
        "349": {"vr": "IS", "Value": [46]},
        "350": {"vr": "IS", "Value": [2659]},
        "351": {"vr": "IS", "Value": [3627]},
        "352": {"vr": "IS", "Value": [1976]},
        "353": {"vr": "IS", "Value": [1938]},
        "354": {"vr": "IS", "Value": [1764]},
        "355": {"vr": "IS", "Value": [3376]},
        "356": {"vr": "IS", "Value": [1053]},
        "357": {"vr": "IS", "Value": [157]},
        "358": {"vr": "IS", "Value": [2991]},
        "359": {"vr": "IS", "Value": [797]},
        "360": {"vr": "IS", "Value": [190]},
        "361": {"vr": "IS", "Value": [2036]},
        "362": {"vr": "IS", "Value": [2930]},
        "363": {"vr": "IS", "Value": [2037]},
        "364": {"vr": "IS", "Value": [3374]},
        "365": {"vr": "IS", "Value": [2050]},
        "366": {"vr": "IS", "Value": [3818]},
        "367": {"vr": "IS", "Value": [747]},
        "368": {"vr": "IS", "Value": [690]},
        "369": {"vr": "IS", "Value": [3274]},
        "370": {"vr": "IS", "Value": [2994]},
        "371": {"vr": "IS", "Value": [2924]},
        "372": {"vr": "IS", "Value": [2807]},
        "373": {"vr": "IS", "Value": [2441]},
        "374": {"vr": "IS", "Value": [1784]},
        "375": {"vr": "IS", "Value": [2412]},
        "376": {"vr": "IS", "Value": [1863]},
        "377": {"vr": "IS", "Value": [3285]},
        "378": {"vr": "IS", "Value": [1724]},
        "379": {"vr": "IS", "Value": [1003]},
        "380": {"vr": "IS", "Value": [1617]},
        "381": {"vr": "IS", "Value": [958]},
        "382": {"vr": "IS", "Value": [1471]},
        "383": {"vr": "IS", "Value": [23]},
        "384": {"vr": "IS", "Value": [2018]},
        "385": {"vr": "IS", "Value": [3534]},
        "386": {"vr": "IS", "Value": [3487]},
        "387": {"vr": "IS", "Value": [2434]},
        "388": {"vr": "IS", "Value": [3613]},
        "389": {"vr": "IS", "Value": [1638]},
        "390": {"vr": "IS", "Value": [774]},
        "391": {"vr": "IS", "Value": [3544]},
        "392": {"vr": "IS", "Value": [1212]},
        "393": {"vr": "IS", "Value": [2514]},
        "394": {"vr": "IS", "Value": [2352]},
        "395": {"vr": "IS", "Value": [1959]},
        "396": {"vr": "IS", "Value": [1321]},
        "397": {"vr": "IS", "Value": [1926]},
        "398": {"vr": "IS", "Value": [303]},
        "399": {"vr": "IS", "Value": [693]},
        "400": {"vr": "IS", "Value": [1630]},
        "401": {"vr": "IS", "Value": [639]},
        "402": {"vr": "IS", "Value": [1113]},
        "403": {"vr": "IS", "Value": [2241]},
        "404": {"vr": "IS", "Value": [318]},
        "405": {"vr": "IS", "Value": [2903]},
        "406": {"vr": "IS", "Value": [879]},
        "407": {"vr": "IS", "Value": [1174]},
        "408": {"vr": "IS", "Value": [2069]},
        "409": {"vr": "IS", "Value": [2342]},
        "410": {"vr": "IS", "Value": [975]},
        "411": {"vr": "IS", "Value": [3468]},
        "412": {"vr": "IS", "Value": [129]},
        "413": {"vr": "IS", "Value": [739]},
        "414": {"vr": "IS", "Value": [321]},
        "415": {"vr": "IS", "Value": [3187]},
        "416": {"vr": "IS", "Value": [1862]},
        "417": {"vr": "IS", "Value": [363]},
        "418": {"vr": "IS", "Value": [35]},
        "419": {"vr": "IS", "Value": [327]},
        "420": {"vr": "IS", "Value": [3869]},
        "421": {"vr": "IS", "Value": [502]},
        "422": {"vr": "IS", "Value": [1072]},
        "423": {"vr": "IS", "Value": [3367]},
        "424": {"vr": "IS", "Value": [2682]},
        "425": {"vr": "IS", "Value": [3768]},
        "426": {"vr": "IS", "Value": [2788]},
        "427": {"vr": "IS", "Value": [2598]},
        "428": {"vr": "IS", "Value": [3617]},
        "429": {"vr": "IS", "Value": [2769]},
        "430": {"vr": "IS", "Value": [2209]},
        "431": {"vr": "IS", "Value": [637]},
        "432": {"vr": "IS", "Value": [3774]},
        "433": {"vr": "IS", "Value": [2565]},
        "434": {"vr": "IS", "Value": [794]},
        "435": {"vr": "IS", "Value": [3847]},
        "436": {"vr": "IS", "Value": [72]},
        "437": {"vr": "IS", "Value": [1265]},
        "438": {"vr": "IS", "Value": [2396]},
        "439": {"vr": "IS", "Value": [3189]},
        "440": {"vr": "IS", "Value": [3618]},
        "441": {"vr": "IS", "Value": [508]},
        "442": {"vr": "IS", "Value": [634]},
        "443": {"vr": "IS", "Value": [3480]},
        "444": {"vr": "IS", "Value": [2595]},
        "445": {"vr": "IS", "Value": [2678]},
        "446": {"vr": "IS", "Value": [3130]},
        "447": {"vr": "IS", "Value": [75]},
        "448": {"vr": "IS", "Value": [3355]},
        "449": {"vr": "IS", "Value": [2244]},
        "450": {"vr": "IS", "Value": [3567]},
        "451": {"vr": "IS", "Value": [799]},
        "452": {"vr": "IS", "Value": [3026]},
        "453": {"vr": "IS", "Value": [217]},
        "454": {"vr": "IS", "Value": [1252]},
        "455": {"vr": "IS", "Value": [2372]},
        "456": {"vr": "IS", "Value": [1169]},
        "457": {"vr": "IS", "Value": [1296]},
        "458": {"vr": "IS", "Value": [1629]},
        "459": {"vr": "IS", "Value": [1149]},
        "460": {"vr": "IS", "Value": [1434]},
        "461": {"vr": "IS", "Value": [2370]},
        "462": {"vr": "IS", "Value": [1774]},
        "463": {"vr": "IS", "Value": [2413]},
        "464": {"vr": "IS", "Value": [3254]},
        "465": {"vr": "IS", "Value": [1090]},
        "466": {"vr": "IS", "Value": [778]},
        "467": {"vr": "IS", "Value": [2093]},
        "468": {"vr": "IS", "Value": [209]},
        "469": {"vr": "IS", "Value": [3976]},
        "470": {"vr": "IS", "Value": [2269]},
        "471": {"vr": "IS", "Value": [2211]},
        "472": {"vr": "IS", "Value": [786]},
        "473": {"vr": "IS", "Value": [3556]},
        "474": {"vr": "IS", "Value": [3423]},
        "475": {"vr": "IS", "Value": [11]},
        "476": {"vr": "IS", "Value": [3485]},
        "477": {"vr": "IS", "Value": [945]},
        "478": {"vr": "IS", "Value": [3707]},
        "479": {"vr": "IS", "Value": [3202]},
        "480": {"vr": "IS", "Value": [1878]},
        "481": {"vr": "IS", "Value": [79]},
        "482": {"vr": "IS", "Value": [787]},
        "483": {"vr": "IS", "Value": [3301]},
        "484": {"vr": "IS", "Value": [2470]},
        "485": {"vr": "IS", "Value": [2887]},
        "486": {"vr": "IS", "Value": [1300]},
        "487": {"vr": "IS", "Value": [1480]},
        "488": {"vr": "IS", "Value": [1532]},
        "489": {"vr": "IS", "Value": [3172]},
        "490": {"vr": "IS", "Value": [2177]},
        "491": {"vr": "IS", "Value": [1899]},
        "492": {"vr": "IS", "Value": [931]},
        "493": {"vr": "IS", "Value": [3181]},
        "494": {"vr": "IS", "Value": [3395]},
        "495": {"vr": "IS", "Value": [1269]},
        "496": {"vr": "IS", "Value": [1937]},
        "497": {"vr": "IS", "Value": [55]},
        "498": {"vr": "IS", "Value": [3753]},
        "499": {"vr": "IS", "Value": [336]},
        "500": {"vr": "IS", "Value": [476]},
        "501": {"vr": "IS", "Value": [4007]},
        "502": {"vr": "IS", "Value": [2119]},
        "503": {"vr": "IS", "Value": [1566]},
        "504": {"vr": "IS", "Value": [1424]},
        "505": {"vr": "IS", "Value": [319]},
        "506": {"vr": "IS", "Value": [900]},
        "507": {"vr": "IS", "Value": [673]},
        "508": {"vr": "IS", "Value": [1070]},
        "509": {"vr": "IS", "Value": [1808]},
        "510": {"vr": "IS", "Value": [3550]},
        "511": {"vr": "IS", "Value": [1749]},
        "512": {"vr": "IS", "Value": [1133]},
        "513": {"vr": "IS", "Value": [2899]},
        "514": {"vr": "IS", "Value": [714]},
        "515": {"vr": "IS", "Value": [1360]},
        "516": {"vr": "IS", "Value": [78]},
        "517": {"vr": "IS", "Value": [3510]},
        "518": {"vr": "IS", "Value": [1548]},
        "519": {"vr": "IS", "Value": [789]},
        "520": {"vr": "IS", "Value": [2687]},
        "521": {"vr": "IS", "Value": [131]},
        "522": {"vr": "IS", "Value": [1825]},
        "523": {"vr": "IS", "Value": [3936]},
        "524": {"vr": "IS", "Value": [790]},
        "525": {"vr": "IS", "Value": [1864]},
        "526": {"vr": "IS", "Value": [3773]},
        "527": {"vr": "IS", "Value": [3634]},
        "528": {"vr": "IS", "Value": [3585]},
        "529": {"vr": "IS", "Value": [180]},
        "530": {"vr": "IS", "Value": [903]},
        "531": {"vr": "IS", "Value": [1369]},
        "532": {"vr": "IS", "Value": [160]},
        "533": {"vr": "IS", "Value": [988]},
        "534": {"vr": "IS", "Value": [2136]},
        "535": {"vr": "IS", "Value": [2927]},
        "536": {"vr": "IS", "Value": [2749]},
        "537": {"vr": "IS", "Value": [2098]},
        "538": {"vr": "IS", "Value": [2398]},
        "539": {"vr": "IS", "Value": [14]},
        "540": {"vr": "IS", "Value": [1207]},
        "541": {"vr": "IS", "Value": [3708]},
        "542": {"vr": "IS", "Value": [2025]},
        "543": {"vr": "IS", "Value": [3955]},
        "544": {"vr": "IS", "Value": [684]},
        "545": {"vr": "IS", "Value": [1759]},
        "546": {"vr": "IS", "Value": [3660]},
        "547": {"vr": "IS", "Value": [3626]},
        "548": {"vr": "IS", "Value": [1365]},
        "549": {"vr": "IS", "Value": [2548]},
        "550": {"vr": "IS", "Value": [2295]},
        "551": {"vr": "IS", "Value": [3199]},
        "552": {"vr": "IS", "Value": [2345]},
        "553": {"vr": "IS", "Value": [704]},
        "554": {"vr": "IS", "Value": [2029]},
        "555": {"vr": "IS", "Value": [32]},
        "556": {"vr": "IS", "Value": [978]},
        "557": {"vr": "IS", "Value": [3789]},
        "558": {"vr": "IS", "Value": [2418]},
        "559": {"vr": "IS", "Value": [3134]},
        "560": {"vr": "IS", "Value": [2381]},
        "561": {"vr": "IS", "Value": [3515]},
        "562": {"vr": "IS", "Value": [2815]},
        "563": {"vr": "IS", "Value": [1160]},
        "564": {"vr": "IS", "Value": [2387]},
        "565": {"vr": "IS", "Value": [1595]},
        "566": {"vr": "IS", "Value": [2574]},
        "567": {"vr": "IS", "Value": [1363]},
        "568": {"vr": "IS", "Value": [2743]},
        "569": {"vr": "IS", "Value": [1710]},
        "570": {"vr": "IS", "Value": [1262]},
        "571": {"vr": "IS", "Value": [3271]},
        "572": {"vr": "IS", "Value": [3533]},
        "573": {"vr": "IS", "Value": [3691]},
        "574": {"vr": "IS", "Value": [3559]},
        "575": {"vr": "IS", "Value": [2482]},
        "576": {"vr": "IS", "Value": [2580]},
        "577": {"vr": "IS", "Value": [3421]},
        "578": {"vr": "IS", "Value": [2067]},
        "579": {"vr": "IS", "Value": [3188]},
        "580": {"vr": "IS", "Value": [3240]},
        "581": {"vr": "IS", "Value": [2744]},
        "582": {"vr": "IS", "Value": [2072]},
        "583": {"vr": "IS", "Value": [2568]},
        "584": {"vr": "IS", "Value": [2929]},
        "585": {"vr": "IS", "Value": [9]},
        "586": {"vr": "IS", "Value": [3445]},
        "587": {"vr": "IS", "Value": [666]},
        "588": {"vr": "IS", "Value": [954]},
        "589": {"vr": "IS", "Value": [3384]},
        "590": {"vr": "IS", "Value": [1533]},
        "591": {"vr": "IS", "Value": [2270]},
        "592": {"vr": "IS", "Value": [3494]},
        "593": {"vr": "IS", "Value": [3052]},
        "594": {"vr": "IS", "Value": [96]},
        "595": {"vr": "IS", "Value": [136]},
        "596": {"vr": "IS", "Value": [1897]},
        "597": {"vr": "IS", "Value": [1594]},
        "598": {"vr": "IS", "Value": [3409]},
        "599": {"vr": "IS", "Value": [1044]},
        "600": {"vr": "IS", "Value": [1361]},
        "601": {"vr": "IS", "Value": [2708]},
        "602": {"vr": "IS", "Value": [1935]},
        "603": {"vr": "IS", "Value": [3674]},
        "604": {"vr": "IS", "Value": [422]},
        "605": {"vr": "IS", "Value": [3721]},
        "606": {"vr": "IS", "Value": [3010]},
        "607": {"vr": "IS", "Value": [2577]},
        "608": {"vr": "IS", "Value": [3614]},
        "609": {"vr": "IS", "Value": [2916]},
        "610": {"vr": "IS", "Value": [3785]},
        "611": {"vr": "IS", "Value": [1997]},
        "612": {"vr": "IS", "Value": [123]},
        "613": {"vr": "IS", "Value": [3137]},
        "614": {"vr": "IS", "Value": [1965]},
        "615": {"vr": "IS", "Value": [2759]},
        "616": {"vr": "IS", "Value": [2822]},
        "617": {"vr": "IS", "Value": [373]},
        "618": {"vr": "IS", "Value": [777]},
        "619": {"vr": "IS", "Value": [2149]},
        "620": {"vr": "IS", "Value": [2111]},
        "621": {"vr": "IS", "Value": [593]},
        "622": {"vr": "IS", "Value": [65]},
        "623": {"vr": "IS", "Value": [3599]},
        "624": {"vr": "IS", "Value": [3988]},
        "625": {"vr": "IS", "Value": [3221]},
        "626": {"vr": "IS", "Value": [904]},
        "627": {"vr": "IS", "Value": [764]},
        "628": {"vr": "IS", "Value": [128]},
        "629": {"vr": "IS", "Value": [1648]},
        "630": {"vr": "IS", "Value": [2986]},
        "631": {"vr": "IS", "Value": [1143]},
        "632": {"vr": "IS", "Value": [361]},
        "633": {"vr": "IS", "Value": [2133]},
        "634": {"vr": "IS", "Value": [1210]},
        "635": {"vr": "IS", "Value": [3058]},
        "636": {"vr": "IS", "Value": [719]},
        "637": {"vr": "IS", "Value": [804]},
        "638": {"vr": "IS", "Value": [2770]},
        "639": {"vr": "IS", "Value": [3872]},
        "640": {"vr": "IS", "Value": [529]},
        "641": {"vr": "IS", "Value": [450]},
        "642": {"vr": "IS", "Value": [1180]},
        "643": {"vr": "IS", "Value": [2944]},
        "644": {"vr": "IS", "Value": [3243]},
        "645": {"vr": "IS", "Value": [1721]},
        "646": {"vr": "IS", "Value": [3299]},
        "647": {"vr": "IS", "Value": [2424]},
        "648": {"vr": "IS", "Value": [3711]},
        "649": {"vr": "IS", "Value": [1677]},
        "650": {"vr": "IS", "Value": [532]},
        "651": {"vr": "IS", "Value": [1024]},
        "652": {"vr": "IS", "Value": [3268]},
        "653": {"vr": "IS", "Value": [966]},
        "654": {"vr": "IS", "Value": [2621]},
        "655": {"vr": "IS", "Value": [1294]},
        "656": {"vr": "IS", "Value": [2533]},
        "657": {"vr": "IS", "Value": [193]},
        "658": {"vr": "IS", "Value": [2850]},
        "659": {"vr": "IS", "Value": [573]},
        "660": {"vr": "IS", "Value": [2178]},
        "661": {"vr": "IS", "Value": [3262]},
        "662": {"vr": "IS", "Value": [629]},
        "663": {"vr": "IS", "Value": [4019]},
        "664": {"vr": "IS", "Value": [2782]},
        "665": {"vr": "IS", "Value": [2772]},
        "666": {"vr": "IS", "Value": [1871]},
        "667": {"vr": "IS", "Value": [485]},
        "668": {"vr": "IS", "Value": [2024]},
        "669": {"vr": "IS", "Value": [134]},
        "670": {"vr": "IS", "Value": [463]},
        "671": {"vr": "IS", "Value": [2458]},
        "672": {"vr": "IS", "Value": [3603]},
        "673": {"vr": "IS", "Value": [309]},
        "674": {"vr": "IS", "Value": [3263]},
        "675": {"vr": "IS", "Value": [1502]},
        "676": {"vr": "IS", "Value": [1410]},
        "677": {"vr": "IS", "Value": [1577]},
        "678": {"vr": "IS", "Value": [583]},
        "679": {"vr": "IS", "Value": [2016]},
        "680": {"vr": "IS", "Value": [2589]},
        "681": {"vr": "IS", "Value": [3890]},
        "682": {"vr": "IS", "Value": [3072]},
        "683": {"vr": "IS", "Value": [3839]},
        "684": {"vr": "IS", "Value": [2936]},
        "685": {"vr": "IS", "Value": [372]},
        "686": {"vr": "IS", "Value": [1603]},
        "687": {"vr": "IS", "Value": [2643]},
        "688": {"vr": "IS", "Value": [1815]},
        "689": {"vr": "IS", "Value": [73]},
        "690": {"vr": "IS", "Value": [1990]},
        "691": {"vr": "IS", "Value": [200]},
        "692": {"vr": "IS", "Value": [246]},
        "693": {"vr": "IS", "Value": [249]},
        "694": {"vr": "IS", "Value": [1781]},
        "695": {"vr": "IS", "Value": [349]},
        "696": {"vr": "IS", "Value": [2973]},
        "697": {"vr": "IS", "Value": [1623]},
        "698": {"vr": "IS", "Value": [2408]},
        "699": {"vr": "IS", "Value": [1373]},
        "700": {"vr": "IS", "Value": [356]},
        "701": {"vr": "IS", "Value": [2983]},
        "702": {"vr": "IS", "Value": [210]},
        "703": {"vr": "IS", "Value": [3155]},
        "704": {"vr": "IS", "Value": [1196]},
        "705": {"vr": "IS", "Value": [1231]},
        "706": {"vr": "IS", "Value": [2468]},
        "707": {"vr": "IS", "Value": [689]},
        "708": {"vr": "IS", "Value": [1385]},
        "709": {"vr": "IS", "Value": [3065]},
        "710": {"vr": "IS", "Value": [3219]},
        "711": {"vr": "IS", "Value": [2863]},
        "712": {"vr": "IS", "Value": [110]},
        "713": {"vr": "IS", "Value": [2306]},
        "714": {"vr": "IS", "Value": [1354]},
        "715": {"vr": "IS", "Value": [2668]},
        "716": {"vr": "IS", "Value": [2856]},
        "717": {"vr": "IS", "Value": [3298]},
        "718": {"vr": "IS", "Value": [3549]},
        "719": {"vr": "IS", "Value": [1875]},
        "720": {"vr": "IS", "Value": [403]},
        "721": {"vr": "IS", "Value": [2393]},
        "722": {"vr": "IS", "Value": [602]},
        "723": {"vr": "IS", "Value": [3835]},
        "724": {"vr": "IS", "Value": [3035]},
        "725": {"vr": "IS", "Value": [147]},
        "726": {"vr": "IS", "Value": [3696]},
        "727": {"vr": "IS", "Value": [3574]},
        "728": {"vr": "IS", "Value": [158]},
        "729": {"vr": "IS", "Value": [3704]},
        "730": {"vr": "IS", "Value": [2074]},
        "731": {"vr": "IS", "Value": [1592]},
        "732": {"vr": "IS", "Value": [694]},
        "733": {"vr": "IS", "Value": [3836]},
        "734": {"vr": "IS", "Value": [247]},
        "735": {"vr": "IS", "Value": [1547]},
        "736": {"vr": "IS", "Value": [938]},
        "737": {"vr": "IS", "Value": [433]},
        "738": {"vr": "IS", "Value": [3214]},
        "739": {"vr": "IS", "Value": [64]},
        "740": {"vr": "IS", "Value": [635]},
        "741": {"vr": "IS", "Value": [320]},
        "742": {"vr": "IS", "Value": [763]},
        "743": {"vr": "IS", "Value": [3383]},
        "744": {"vr": "IS", "Value": [2369]},
        "745": {"vr": "IS", "Value": [742]},
        "746": {"vr": "IS", "Value": [733]},
        "747": {"vr": "IS", "Value": [2284]},
        "748": {"vr": "IS", "Value": [2599]},
        "749": {"vr": "IS", "Value": [2776]},
        "750": {"vr": "IS", "Value": [3914]},
        "751": {"vr": "IS", "Value": [1165]},
        "752": {"vr": "IS", "Value": [3053]},
        "753": {"vr": "IS", "Value": [462]},
        "754": {"vr": "IS", "Value": [2765]},
        "755": {"vr": "IS", "Value": [1870]},
        "756": {"vr": "IS", "Value": [1311]},
        "757": {"vr": "IS", "Value": [3967]},
        "758": {"vr": "IS", "Value": [1096]},
        "759": {"vr": "IS", "Value": [272]},
        "760": {"vr": "IS", "Value": [917]},
        "761": {"vr": "IS", "Value": [1077]},
        "762": {"vr": "IS", "Value": [3819]},
        "763": {"vr": "IS", "Value": [2601]},
        "764": {"vr": "IS", "Value": [1942]},
        "765": {"vr": "IS", "Value": [823]},
        "766": {"vr": "IS", "Value": [892]},
        "767": {"vr": "IS", "Value": [3388]},
        "768": {"vr": "IS", "Value": [2227]},
        "769": {"vr": "IS", "Value": [2996]},
        "770": {"vr": "IS", "Value": [1289]},
        "771": {"vr": "IS", "Value": [3981]},
        "772": {"vr": "IS", "Value": [1572]},
        "773": {"vr": "IS", "Value": [3694]},
        "774": {"vr": "IS", "Value": [1033]},
        "775": {"vr": "IS", "Value": [842]},
        "776": {"vr": "IS", "Value": [1451]},
        "777": {"vr": "IS", "Value": [2028]},
        "778": {"vr": "IS", "Value": [3900]},
        "779": {"vr": "IS", "Value": [223]},
        "780": {"vr": "IS", "Value": [2332]},
        "781": {"vr": "IS", "Value": [1523]},
        "782": {"vr": "IS", "Value": [3669]},
        "783": {"vr": "IS", "Value": [2870]},
        "784": {"vr": "IS", "Value": [97]},
        "785": {"vr": "IS", "Value": [2741]},
        "786": {"vr": "IS", "Value": [2294]},
        "787": {"vr": "IS", "Value": [780]},
        "788": {"vr": "IS", "Value": [3346]},
        "789": {"vr": "IS", "Value": [1249]},
        "790": {"vr": "IS", "Value": [3656]},
        "791": {"vr": "IS", "Value": [3317]},
        "792": {"vr": "IS", "Value": [273]},
        "793": {"vr": "IS", "Value": [2778]},
        "794": {"vr": "IS", "Value": [1241]},
        "795": {"vr": "IS", "Value": [1587]},
        "796": {"vr": "IS", "Value": [1051]},
        "797": {"vr": "IS", "Value": [2440]},
        "798": {"vr": "IS", "Value": [2785]},
        "799": {"vr": "IS", "Value": [181]},
        "800": {"vr": "IS", "Value": [548]},
        "801": {"vr": "IS", "Value": [66]},
        "802": {"vr": "IS", "Value": [427]},
        "803": {"vr": "IS", "Value": [3088]},
        "804": {"vr": "IS", "Value": [3021]},
        "805": {"vr": "IS", "Value": [1173]},
        "806": {"vr": "IS", "Value": [2460]},
        "807": {"vr": "IS", "Value": [2968]},
        "808": {"vr": "IS", "Value": [1095]},
        "809": {"vr": "IS", "Value": [2113]},
        "810": {"vr": "IS", "Value": [2017]},
        "811": {"vr": "IS", "Value": [2846]},
        "812": {"vr": "IS", "Value": [1680]},
        "813": {"vr": "IS", "Value": [2169]},
        "814": {"vr": "IS", "Value": [2414]},
        "815": {"vr": "IS", "Value": [3809]},
        "816": {"vr": "IS", "Value": [3339]},
        "817": {"vr": "IS", "Value": [3871]},
        "818": {"vr": "IS", "Value": [2207]},
        "819": {"vr": "IS", "Value": [1796]},
        "820": {"vr": "IS", "Value": [3324]},
        "821": {"vr": "IS", "Value": [3291]},
        "822": {"vr": "IS", "Value": [1403]},
        "823": {"vr": "IS", "Value": [2511]},
        "824": {"vr": "IS", "Value": [3144]},
        "825": {"vr": "IS", "Value": [2484]},
        "826": {"vr": "IS", "Value": [1258]},
        "827": {"vr": "IS", "Value": [4002]},
        "828": {"vr": "IS", "Value": [1820]},
        "829": {"vr": "IS", "Value": [2670]},
        "830": {"vr": "IS", "Value": [416]},
        "831": {"vr": "IS", "Value": [1290]},
        "832": {"vr": "IS", "Value": [1032]},
        "833": {"vr": "IS", "Value": [543]},
        "834": {"vr": "IS", "Value": [425]},
        "835": {"vr": "IS", "Value": [3932]},
        "836": {"vr": "IS", "Value": [1307]},
        "837": {"vr": "IS", "Value": [443]},
        "838": {"vr": "IS", "Value": [276]},
        "839": {"vr": "IS", "Value": [853]},
        "840": {"vr": "IS", "Value": [3249]},
        "841": {"vr": "IS", "Value": [2704]},
        "842": {"vr": "IS", "Value": [332]},
        "843": {"vr": "IS", "Value": [1957]},
        "844": {"vr": "IS", "Value": [1120]},
        "845": {"vr": "IS", "Value": [232]},
        "846": {"vr": "IS", "Value": [1983]},
        "847": {"vr": "IS", "Value": [2773]},
        "848": {"vr": "IS", "Value": [1918]},
        "849": {"vr": "IS", "Value": [465]},
        "850": {"vr": "IS", "Value": [2642]},
        "851": {"vr": "IS", "Value": [2167]},
        "852": {"vr": "IS", "Value": [2208]},
        "853": {"vr": "IS", "Value": [2901]},
        "854": {"vr": "IS", "Value": [993]},
        "855": {"vr": "IS", "Value": [928]},
        "856": {"vr": "IS", "Value": [1697]},
        "857": {"vr": "IS", "Value": [2445]},
        "858": {"vr": "IS", "Value": [1081]},
        "859": {"vr": "IS", "Value": [408]},
        "860": {"vr": "IS", "Value": [1432]},
        "861": {"vr": "IS", "Value": [3968]},
        "862": {"vr": "IS", "Value": [3503]},
        "863": {"vr": "IS", "Value": [2551]},
        "864": {"vr": "IS", "Value": [3902]},
        "865": {"vr": "IS", "Value": [1552]},
        "866": {"vr": "IS", "Value": [2839]},
        "867": {"vr": "IS", "Value": [675]},
        "868": {"vr": "IS", "Value": [2662]},
        "869": {"vr": "IS", "Value": [772]},
        "870": {"vr": "IS", "Value": [1378]},
        "871": {"vr": "IS", "Value": [1729]},
        "872": {"vr": "IS", "Value": [145]},
        "873": {"vr": "IS", "Value": [3449]},
        "874": {"vr": "IS", "Value": [2717]},
        "875": {"vr": "IS", "Value": [47]},
        "876": {"vr": "IS", "Value": [771]},
        "877": {"vr": "IS", "Value": [375]},
        "878": {"vr": "IS", "Value": [3512]},
        "879": {"vr": "IS", "Value": [206]},
        "880": {"vr": "IS", "Value": [345]},
        "881": {"vr": "IS", "Value": [809]},
        "882": {"vr": "IS", "Value": [402]},
        "883": {"vr": "IS", "Value": [788]},
        "884": {"vr": "IS", "Value": [3375]},
        "885": {"vr": "IS", "Value": [4009]},
        "886": {"vr": "IS", "Value": [885]},
        "887": {"vr": "IS", "Value": [1883]},
        "888": {"vr": "IS", "Value": [770]},
        "889": {"vr": "IS", "Value": [306]},
        "890": {"vr": "IS", "Value": [1098]},
        "891": {"vr": "IS", "Value": [1979]},
        "892": {"vr": "IS", "Value": [3687]},
        "893": {"vr": "IS", "Value": [2247]},
        "894": {"vr": "IS", "Value": [1056]},
        "895": {"vr": "IS", "Value": [1928]},
        "896": {"vr": "IS", "Value": [595]},
        "897": {"vr": "IS", "Value": [1934]},
        "898": {"vr": "IS", "Value": [2145]},
        "899": {"vr": "IS", "Value": [1528]},
        "900": {"vr": "IS", "Value": [1770]},
        "901": {"vr": "IS", "Value": [399]},
        "902": {"vr": "IS", "Value": [2204]},
        "903": {"vr": "IS", "Value": [3939]},
        "904": {"vr": "IS", "Value": [466]},
        "905": {"vr": "IS", "Value": [927]},
        "906": {"vr": "IS", "Value": [440]},
        "907": {"vr": "IS", "Value": [2775]},
        "908": {"vr": "IS", "Value": [1946]},
        "909": {"vr": "IS", "Value": [3853]},
        "910": {"vr": "IS", "Value": [2456]},
        "911": {"vr": "IS", "Value": [1590]},
        "912": {"vr": "IS", "Value": [3769]},
        "913": {"vr": "IS", "Value": [2459]},
        "914": {"vr": "IS", "Value": [940]},
        "915": {"vr": "IS", "Value": [2231]},
        "916": {"vr": "IS", "Value": [3840]},
        "917": {"vr": "IS", "Value": [2702]},
        "918": {"vr": "IS", "Value": [3159]},
        "919": {"vr": "IS", "Value": [3]},
        "920": {"vr": "IS", "Value": [658]},
        "921": {"vr": "IS", "Value": [1168]},
        "922": {"vr": "IS", "Value": [3149]},
        "923": {"vr": "IS", "Value": [2997]},
        "924": {"vr": "IS", "Value": [6]},
        "925": {"vr": "IS", "Value": [274]},
        "926": {"vr": "IS", "Value": [3978]},
        "927": {"vr": "IS", "Value": [2816]},
        "928": {"vr": "IS", "Value": [3424]},
        "929": {"vr": "IS", "Value": [2163]},
        "930": {"vr": "IS", "Value": [1833]},
        "931": {"vr": "IS", "Value": [1973]},
        "932": {"vr": "IS", "Value": [4014]},
        "933": {"vr": "IS", "Value": [2490]},
        "934": {"vr": "IS", "Value": [222]},
        "935": {"vr": "IS", "Value": [1727]},
        "936": {"vr": "IS", "Value": [2669]},
        "937": {"vr": "IS", "Value": [1711]},
        "938": {"vr": "IS", "Value": [3959]},
        "939": {"vr": "IS", "Value": [1517]},
        "940": {"vr": "IS", "Value": [3211]},
        "941": {"vr": "IS", "Value": [3236]},
        "942": {"vr": "IS", "Value": [803]},
        "943": {"vr": "IS", "Value": [1713]},
        "944": {"vr": "IS", "Value": [2538]},
        "945": {"vr": "IS", "Value": [3643]},
        "946": {"vr": "IS", "Value": [2502]},
        "947": {"vr": "IS", "Value": [1642]},
        "948": {"vr": "IS", "Value": [2667]},
        "949": {"vr": "IS", "Value": [1280]},
        "950": {"vr": "IS", "Value": [3156]},
        "951": {"vr": "IS", "Value": [1634]},
        "952": {"vr": "IS", "Value": [862]},
        "953": {"vr": "IS", "Value": [2125]},
        "954": {"vr": "IS", "Value": [2875]},
        "955": {"vr": "IS", "Value": [374]},
        "956": {"vr": "IS", "Value": [2681]},
        "957": {"vr": "IS", "Value": [1589]},
        "958": {"vr": "IS", "Value": [3128]},
        "959": {"vr": "IS", "Value": [1264]},
        "960": {"vr": "IS", "Value": [1732]},
        "961": {"vr": "IS", "Value": [2022]},
        "962": {"vr": "IS", "Value": [3227]},
        "963": {"vr": "IS", "Value": [2795]},
        "964": {"vr": "IS", "Value": [627]},
        "965": {"vr": "IS", "Value": [1054]},
        "966": {"vr": "IS", "Value": [1679]},
        "967": {"vr": "IS", "Value": [3604]},
        "968": {"vr": "IS", "Value": [791]},
        "969": {"vr": "IS", "Value": [833]},
        "970": {"vr": "IS", "Value": [150]},
        "971": {"vr": "IS", "Value": [871]},
        "972": {"vr": "IS", "Value": [3647]},
        "973": {"vr": "IS", "Value": [3414]},
        "974": {"vr": "IS", "Value": [2213]},
        "975": {"vr": "IS", "Value": [2594]},
        "976": {"vr": "IS", "Value": [1118]},
        "977": {"vr": "IS", "Value": [1829]},
        "978": {"vr": "IS", "Value": [3979]},
        "979": {"vr": "IS", "Value": [2726]},
        "980": {"vr": "IS", "Value": [2768]},
        "981": {"vr": "IS", "Value": [3473]},
        "982": {"vr": "IS", "Value": [1575]},
        "983": {"vr": "IS", "Value": [2679]},
        "984": {"vr": "IS", "Value": [3131]},
        "985": {"vr": "IS", "Value": [1827]},
        "986": {"vr": "IS", "Value": [1389]},
        "987": {"vr": "IS", "Value": [156]},
        "988": {"vr": "IS", "Value": [3417]},
        "989": {"vr": "IS", "Value": [1682]},
        "990": {"vr": "IS", "Value": [1853]},
        "991": {"vr": "IS", "Value": [3635]},
        "992": {"vr": "IS", "Value": [1223]},
        "993": {"vr": "IS", "Value": [3751]},
        "994": {"vr": "IS", "Value": [612]},
        "995": {"vr": "IS", "Value": [3217]},
        "996": {"vr": "IS", "Value": [3964]},
        "997": {"vr": "IS", "Value": [2938]},
        "998": {"vr": "IS", "Value": [3168]},
        "999": {"vr": "IS", "Value": [3803]},
        "1000": {"vr": "IS", "Value": [1930]},
        "1001": {"vr": "IS", "Value": [3813]},
        "1002": {"vr": "IS", "Value": [346]},
        "1003": {"vr": "IS", "Value": [998]},
        "1004": {"vr": "IS", "Value": [3471]},
        "1005": {"vr": "IS", "Value": [2709]},
        "1006": {"vr": "IS", "Value": [2950]},
        "1007": {"vr": "IS", "Value": [858]},
        "1008": {"vr": "IS", "Value": [468]},
        "1009": {"vr": "IS", "Value": [891]},
        "1010": {"vr": "IS", "Value": [3464]},
        "1011": {"vr": "IS", "Value": [3950]},
        "1012": {"vr": "IS", "Value": [2894]},
        "1013": {"vr": "IS", "Value": [2954]},
        "1014": {"vr": "IS", "Value": [2736]},
        "1015": {"vr": "IS", "Value": [3991]},
        "1016": {"vr": "IS", "Value": [1349]},
        "1017": {"vr": "IS", "Value": [3850]},
        "1018": {"vr": "IS", "Value": [1136]},
        "1019": {"vr": "IS", "Value": [3505]},
        "1020": {"vr": "IS", "Value": [2864]},
        "1021": {"vr": "IS", "Value": [3743]},
        "1022": {"vr": "IS", "Value": [1450]},
        "1023": {"vr": "IS", "Value": [1626]},
        "1024": {"vr": "IS", "Value": [2928]},
        "1025": {"vr": "IS", "Value": [220]},
        "1026": {"vr": "IS", "Value": [262]},
        "1027": {"vr": "IS", "Value": [2880]},
        "1028": {"vr": "IS", "Value": [3433]},
        "1029": {"vr": "IS", "Value": [2334]},
        "1030": {"vr": "IS", "Value": [43]},
        "1031": {"vr": "IS", "Value": [571]},
        "1032": {"vr": "IS", "Value": [1344]},
        "1033": {"vr": "IS", "Value": [1767]},
        "1034": {"vr": "IS", "Value": [633]},
        "1035": {"vr": "IS", "Value": [3555]},
        "1036": {"vr": "IS", "Value": [1500]},
        "1037": {"vr": "IS", "Value": [2353]},
        "1038": {"vr": "IS", "Value": [535]},
        "1039": {"vr": "IS", "Value": [1357]},
        "1040": {"vr": "IS", "Value": [1282]},
        "1041": {"vr": "IS", "Value": [2860]},
        "1042": {"vr": "IS", "Value": [1310]},
        "1043": {"vr": "IS", "Value": [2116]},
        "1044": {"vr": "IS", "Value": [1200]},
        "1045": {"vr": "IS", "Value": [340]},
        "1046": {"vr": "IS", "Value": [2397]},
        "1047": {"vr": "IS", "Value": [3676]},
        "1048": {"vr": "IS", "Value": [3780]},
        "1049": {"vr": "IS", "Value": [224]},
        "1050": {"vr": "IS", "Value": [2280]},
        "1051": {"vr": "IS", "Value": [1913]},
        "1052": {"vr": "IS", "Value": [567]},
        "1053": {"vr": "IS", "Value": [2402]},
        "1054": {"vr": "IS", "Value": [517]},
        "1055": {"vr": "IS", "Value": [1402]},
        "1056": {"vr": "IS", "Value": [3205]},
        "1057": {"vr": "IS", "Value": [3722]},
        "1058": {"vr": "IS", "Value": [2940]},
        "1059": {"vr": "IS", "Value": [1576]},
        "1060": {"vr": "IS", "Value": [29]},
        "1061": {"vr": "IS", "Value": [248]},
        "1062": {"vr": "IS", "Value": [922]},
        "1063": {"vr": "IS", "Value": [1383]},
        "1064": {"vr": "IS", "Value": [929]},
        "1065": {"vr": "IS", "Value": [1359]},
        "1066": {"vr": "IS", "Value": [1518]},
        "1067": {"vr": "IS", "Value": [2830]},
        "1068": {"vr": "IS", "Value": [3253]},
        "1069": {"vr": "IS", "Value": [2305]},
        "1070": {"vr": "IS", "Value": [848]},
        "1071": {"vr": "IS", "Value": [3226]},
        "1072": {"vr": "IS", "Value": [2831]},
        "1073": {"vr": "IS", "Value": [4016]},
        "1074": {"vr": "IS", "Value": [3945]},
        "1075": {"vr": "IS", "Value": [618]},
        "1076": {"vr": "IS", "Value": [2346]},
        "1077": {"vr": "IS", "Value": [3004]},
        "1078": {"vr": "IS", "Value": [837]},
        "1079": {"vr": "IS", "Value": [3239]},
        "1080": {"vr": "IS", "Value": [1263]},
        "1081": {"vr": "IS", "Value": [692]},
        "1082": {"vr": "IS", "Value": [2872]},
        "1083": {"vr": "IS", "Value": [2843]},
        "1084": {"vr": "IS", "Value": [421]},
        "1085": {"vr": "IS", "Value": [3195]},
        "1086": {"vr": "IS", "Value": [2828]},
        "1087": {"vr": "IS", "Value": [2854]},
        "1088": {"vr": "IS", "Value": [3347]},
        "1089": {"vr": "IS", "Value": [2747]},
        "1090": {"vr": "IS", "Value": [2002]},
        "1091": {"vr": "IS", "Value": [1371]},
        "1092": {"vr": "IS", "Value": [2748]},
        "1093": {"vr": "IS", "Value": [484]},
        "1094": {"vr": "IS", "Value": [3823]},
        "1095": {"vr": "IS", "Value": [2897]},
        "1096": {"vr": "IS", "Value": [2472]},
        "1097": {"vr": "IS", "Value": [1347]},
        "1098": {"vr": "IS", "Value": [3415]},
        "1099": {"vr": "IS", "Value": [2582]},
        "1100": {"vr": "IS", "Value": [1879]},
        "1101": {"vr": "IS", "Value": [2523]},
        "1102": {"vr": "IS", "Value": [2471]},
        "1103": {"vr": "IS", "Value": [3264]},
        "1104": {"vr": "IS", "Value": [565]},
        "1105": {"vr": "IS", "Value": [2660]},
        "1106": {"vr": "IS", "Value": [585]},
        "1107": {"vr": "IS", "Value": [1956]},
        "1108": {"vr": "IS", "Value": [970]},
        "1109": {"vr": "IS", "Value": [3802]},
        "1110": {"vr": "IS", "Value": [3302]},
        "1111": {"vr": "IS", "Value": [1188]},
        "1112": {"vr": "IS", "Value": [849]},
        "1113": {"vr": "IS", "Value": [2751]},
        "1114": {"vr": "IS", "Value": [1903]},
        "1115": {"vr": "IS", "Value": [3724]},
        "1116": {"vr": "IS", "Value": [95]},
        "1117": {"vr": "IS", "Value": [3017]},
        "1118": {"vr": "IS", "Value": [872]},
        "1119": {"vr": "IS", "Value": [3705]},
        "1120": {"vr": "IS", "Value": [3787]},
        "1121": {"vr": "IS", "Value": [1859]},
        "1122": {"vr": "IS", "Value": [831]},
        "1123": {"vr": "IS", "Value": [430]},
        "1124": {"vr": "IS", "Value": [1793]},
        "1125": {"vr": "IS", "Value": [1639]},
        "1126": {"vr": "IS", "Value": [3925]},
        "1127": {"vr": "IS", "Value": [607]},
        "1128": {"vr": "IS", "Value": [2544]},
        "1129": {"vr": "IS", "Value": [1462]},
        "1130": {"vr": "IS", "Value": [3804]},
        "1131": {"vr": "IS", "Value": [711]},
        "1132": {"vr": "IS", "Value": [623]},
        "1133": {"vr": "IS", "Value": [2390]},
        "1134": {"vr": "IS", "Value": [2882]},
        "1135": {"vr": "IS", "Value": [1694]},
        "1136": {"vr": "IS", "Value": [1333]},
        "1137": {"vr": "IS", "Value": [3180]},
        "1138": {"vr": "IS", "Value": [557]},
        "1139": {"vr": "IS", "Value": [2082]},
        "1140": {"vr": "IS", "Value": [285]},
        "1141": {"vr": "IS", "Value": [1545]},
        "1142": {"vr": "IS", "Value": [409]},
        "1143": {"vr": "IS", "Value": [553]},
        "1144": {"vr": "IS", "Value": [968]},
        "1145": {"vr": "IS", "Value": [1953]},
        "1146": {"vr": "IS", "Value": [1211]},
        "1147": {"vr": "IS", "Value": [3975]},
        "1148": {"vr": "IS", "Value": [691]},
        "1149": {"vr": "IS", "Value": [38]},
        "1150": {"vr": "IS", "Value": [3898]},
        "1151": {"vr": "IS", "Value": [1742]},
        "1152": {"vr": "IS", "Value": [2205]},
        "1153": {"vr": "IS", "Value": [1945]},
        "1154": {"vr": "IS", "Value": [2311]},
        "1155": {"vr": "IS", "Value": [2238]},
        "1156": {"vr": "IS", "Value": [615]},
        "1157": {"vr": "IS", "Value": [143]},
        "1158": {"vr": "IS", "Value": [3136]},
        "1159": {"vr": "IS", "Value": [1960]},
        "1160": {"vr": "IS", "Value": [2357]},
        "1161": {"vr": "IS", "Value": [752]},
        "1162": {"vr": "IS", "Value": [2521]},
        "1163": {"vr": "IS", "Value": [2513]},
        "1164": {"vr": "IS", "Value": [1734]},
        "1165": {"vr": "IS", "Value": [3325]},
        "1166": {"vr": "IS", "Value": [33]},
        "1167": {"vr": "IS", "Value": [2988]},
        "1168": {"vr": "IS", "Value": [353]},
        "1169": {"vr": "IS", "Value": [3191]},
        "1170": {"vr": "IS", "Value": [3412]},
        "1171": {"vr": "IS", "Value": [487]},
        "1172": {"vr": "IS", "Value": [2740]},
        "1173": {"vr": "IS", "Value": [3692]},
        "1174": {"vr": "IS", "Value": [2713]},
        "1175": {"vr": "IS", "Value": [3068]},
        "1176": {"vr": "IS", "Value": [3034]},
        "1177": {"vr": "IS", "Value": [3470]},
        "1178": {"vr": "IS", "Value": [53]},
        "1179": {"vr": "IS", "Value": [996]},
        "1180": {"vr": "IS", "Value": [1555]},
        "1181": {"vr": "IS", "Value": [1437]},
        "1182": {"vr": "IS", "Value": [294]},
        "1183": {"vr": "IS", "Value": [2129]},
        "1184": {"vr": "IS", "Value": [3224]},
        "1185": {"vr": "IS", "Value": [1610]},
        "1186": {"vr": "IS", "Value": [188]},
        "1187": {"vr": "IS", "Value": [1849]},
        "1188": {"vr": "IS", "Value": [3087]},
        "1189": {"vr": "IS", "Value": [3328]},
        "1190": {"vr": "IS", "Value": [3607]},
        "1191": {"vr": "IS", "Value": [25]},
        "1192": {"vr": "IS", "Value": [766]},
        "1193": {"vr": "IS", "Value": [1985]},
        "1194": {"vr": "IS", "Value": [3911]},
        "1195": {"vr": "IS", "Value": [1706]},
        "1196": {"vr": "IS", "Value": [171]},
        "1197": {"vr": "IS", "Value": [3701]},
        "1198": {"vr": "IS", "Value": [1386]},
        "1199": {"vr": "IS", "Value": [2852]},
        "1200": {"vr": "IS", "Value": [3266]},
        "1201": {"vr": "IS", "Value": [56]},
        "1202": {"vr": "IS", "Value": [718]},
        "1203": {"vr": "IS", "Value": [3849]},
        "1204": {"vr": "IS", "Value": [2969]},
        "1205": {"vr": "IS", "Value": [2287]},
        "1206": {"vr": "IS", "Value": [3389]},
        "1207": {"vr": "IS", "Value": [2517]},
        "1208": {"vr": "IS", "Value": [166]},
        "1209": {"vr": "IS", "Value": [296]},
        "1210": {"vr": "IS", "Value": [2175]},
        "1211": {"vr": "IS", "Value": [3862]},
        "1212": {"vr": "IS", "Value": [943]},
        "1213": {"vr": "IS", "Value": [2075]},
        "1214": {"vr": "IS", "Value": [3593]},
        "1215": {"vr": "IS", "Value": [2245]},
        "1216": {"vr": "IS", "Value": [2878]},
        "1217": {"vr": "IS", "Value": [2945]},
        "1218": {"vr": "IS", "Value": [122]},
        "1219": {"vr": "IS", "Value": [3332]},
        "1220": {"vr": "IS", "Value": [3335]},
        "1221": {"vr": "IS", "Value": [3748]},
        "1222": {"vr": "IS", "Value": [795]},
        "1223": {"vr": "IS", "Value": [3541]},
        "1224": {"vr": "IS", "Value": [1487]},
        "1225": {"vr": "IS", "Value": [204]},
        "1226": {"vr": "IS", "Value": [132]},
        "1227": {"vr": "IS", "Value": [3725]},
        "1228": {"vr": "IS", "Value": [3730]},
        "1229": {"vr": "IS", "Value": [2707]},
        "1230": {"vr": "IS", "Value": [2549]},
        "1231": {"vr": "IS", "Value": [3482]},
        "1232": {"vr": "IS", "Value": [3712]},
        "1233": {"vr": "IS", "Value": [991]},
        "1234": {"vr": "IS", "Value": [568]},
        "1235": {"vr": "IS", "Value": [1304]},
        "1236": {"vr": "IS", "Value": [169]},
        "1237": {"vr": "IS", "Value": [3910]},
        "1238": {"vr": "IS", "Value": [1298]},
        "1239": {"vr": "IS", "Value": [724]},
        "1240": {"vr": "IS", "Value": [832]},
        "1241": {"vr": "IS", "Value": [116]},
        "1242": {"vr": "IS", "Value": [2723]},
        "1243": {"vr": "IS", "Value": [3082]},
        "1244": {"vr": "IS", "Value": [2237]},
        "1245": {"vr": "IS", "Value": [1520]},
        "1246": {"vr": "IS", "Value": [3076]},
        "1247": {"vr": "IS", "Value": [1002]},
        "1248": {"vr": "IS", "Value": [1970]},
        "1249": {"vr": "IS", "Value": [3484]},
        "1250": {"vr": "IS", "Value": [241]},
        "1251": {"vr": "IS", "Value": [2606]},
        "1252": {"vr": "IS", "Value": [1964]},
        "1253": {"vr": "IS", "Value": [3379]},
        "1254": {"vr": "IS", "Value": [1392]},
        "1255": {"vr": "IS", "Value": [1455]},
        "1256": {"vr": "IS", "Value": [2884]},
        "1257": {"vr": "IS", "Value": [101]},
        "1258": {"vr": "IS", "Value": [400]},
        "1259": {"vr": "IS", "Value": [3166]},
        "1260": {"vr": "IS", "Value": [2648]},
        "1261": {"vr": "IS", "Value": [599]},
        "1262": {"vr": "IS", "Value": [982]},
        "1263": {"vr": "IS", "Value": [2738]},
        "1264": {"vr": "IS", "Value": [695]},
        "1265": {"vr": "IS", "Value": [852]},
        "1266": {"vr": "IS", "Value": [1099]},
        "1267": {"vr": "IS", "Value": [2266]},
        "1268": {"vr": "IS", "Value": [1924]},
        "1269": {"vr": "IS", "Value": [359]},
        "1270": {"vr": "IS", "Value": [515]},
        "1271": {"vr": "IS", "Value": [3969]},
        "1272": {"vr": "IS", "Value": [1744]},
        "1273": {"vr": "IS", "Value": [898]},
        "1274": {"vr": "IS", "Value": [2794]},
        "1275": {"vr": "IS", "Value": [3129]},
        "1276": {"vr": "IS", "Value": [3650]},
        "1277": {"vr": "IS", "Value": [3762]},
        "1278": {"vr": "IS", "Value": [1690]},
        "1279": {"vr": "IS", "Value": [1549]},
        "1280": {"vr": "IS", "Value": [305]},
        "1281": {"vr": "IS", "Value": [2791]},
        "1282": {"vr": "IS", "Value": [715]},
        "1283": {"vr": "IS", "Value": [2818]},
        "1284": {"vr": "IS", "Value": [2847]},
        "1285": {"vr": "IS", "Value": [1571]},
        "1286": {"vr": "IS", "Value": [1559]},
        "1287": {"vr": "IS", "Value": [1632]},
        "1288": {"vr": "IS", "Value": [1234]},
        "1289": {"vr": "IS", "Value": [3013]},
        "1290": {"vr": "IS", "Value": [1170]},
        "1291": {"vr": "IS", "Value": [58]},
        "1292": {"vr": "IS", "Value": [1691]},
        "1293": {"vr": "IS", "Value": [2062]},
        "1294": {"vr": "IS", "Value": [3462]},
        "1295": {"vr": "IS", "Value": [1790]},
        "1296": {"vr": "IS", "Value": [870]},
        "1297": {"vr": "IS", "Value": [836]},
        "1298": {"vr": "IS", "Value": [85]},
        "1299": {"vr": "IS", "Value": [540]},
        "1300": {"vr": "IS", "Value": [2026]},
        "1301": {"vr": "IS", "Value": [1882]},
        "1302": {"vr": "IS", "Value": [126]},
        "1303": {"vr": "IS", "Value": [3547]},
        "1304": {"vr": "IS", "Value": [1649]},
        "1305": {"vr": "IS", "Value": [1921]},
        "1306": {"vr": "IS", "Value": [253]},
        "1307": {"vr": "IS", "Value": [3272]},
        "1308": {"vr": "IS", "Value": [519]},
        "1309": {"vr": "IS", "Value": [668]},
        "1310": {"vr": "IS", "Value": [99]},
        "1311": {"vr": "IS", "Value": [1894]},
        "1312": {"vr": "IS", "Value": [3666]},
        "1313": {"vr": "IS", "Value": [1761]},
        "1314": {"vr": "IS", "Value": [913]},
        "1315": {"vr": "IS", "Value": [109]},
        "1316": {"vr": "IS", "Value": [2200]},
        "1317": {"vr": "IS", "Value": [1540]},
        "1318": {"vr": "IS", "Value": [310]},
        "1319": {"vr": "IS", "Value": [572]},
        "1320": {"vr": "IS", "Value": [3107]},
        "1321": {"vr": "IS", "Value": [1900]},
        "1322": {"vr": "IS", "Value": [415]},
        "1323": {"vr": "IS", "Value": [1049]},
        "1324": {"vr": "IS", "Value": [1340]},
        "1325": {"vr": "IS", "Value": [139]},
        "1326": {"vr": "IS", "Value": [1326]},
        "1327": {"vr": "IS", "Value": [3623]},
        "1328": {"vr": "IS", "Value": [861]},
        "1329": {"vr": "IS", "Value": [2734]},
        "1330": {"vr": "IS", "Value": [3963]},
        "1331": {"vr": "IS", "Value": [1653]},
        "1332": {"vr": "IS", "Value": [3507]},
        "1333": {"vr": "IS", "Value": [3349]},
        "1334": {"vr": "IS", "Value": [3023]},
        "1335": {"vr": "IS", "Value": [1086]},
        "1336": {"vr": "IS", "Value": [2063]},
        "1337": {"vr": "IS", "Value": [918]},
        "1338": {"vr": "IS", "Value": [1486]},
        "1339": {"vr": "IS", "Value": [2933]},
        "1340": {"vr": "IS", "Value": [341]},
        "1341": {"vr": "IS", "Value": [3685]},
        "1342": {"vr": "IS", "Value": [444]},
        "1343": {"vr": "IS", "Value": [3079]},
        "1344": {"vr": "IS", "Value": [859]},
        "1345": {"vr": "IS", "Value": [889]},
        "1346": {"vr": "IS", "Value": [471]},
        "1347": {"vr": "IS", "Value": [39]},
        "1348": {"vr": "IS", "Value": [2545]},
        "1349": {"vr": "IS", "Value": [473]},
        "1350": {"vr": "IS", "Value": [2527]},
        "1351": {"vr": "IS", "Value": [267]},
        "1352": {"vr": "IS", "Value": [1947]},
        "1353": {"vr": "IS", "Value": [3118]},
        "1354": {"vr": "IS", "Value": [3727]},
        "1355": {"vr": "IS", "Value": [1286]},
        "1356": {"vr": "IS", "Value": [1819]},
        "1357": {"vr": "IS", "Value": [2192]},
        "1358": {"vr": "IS", "Value": [661]},
        "1359": {"vr": "IS", "Value": [3575]},
        "1360": {"vr": "IS", "Value": [3577]},
        "1361": {"vr": "IS", "Value": [394]},
        "1362": {"vr": "IS", "Value": [90]},
        "1363": {"vr": "IS", "Value": [796]},
        "1364": {"vr": "IS", "Value": [960]},
        "1365": {"vr": "IS", "Value": [2230]},
        "1366": {"vr": "IS", "Value": [1464]},
        "1367": {"vr": "IS", "Value": [330]},
        "1368": {"vr": "IS", "Value": [1256]},
        "1369": {"vr": "IS", "Value": [1420]},
        "1370": {"vr": "IS", "Value": [1904]},
        "1371": {"vr": "IS", "Value": [534]},
        "1372": {"vr": "IS", "Value": [313]},
        "1373": {"vr": "IS", "Value": [2865]},
        "1374": {"vr": "IS", "Value": [2112]},
        "1375": {"vr": "IS", "Value": [1339]},
        "1376": {"vr": "IS", "Value": [491]},
        "1377": {"vr": "IS", "Value": [555]},
        "1378": {"vr": "IS", "Value": [3811]},
        "1379": {"vr": "IS", "Value": [3873]},
        "1380": {"vr": "IS", "Value": [2290]},
        "1381": {"vr": "IS", "Value": [3354]},
        "1382": {"vr": "IS", "Value": [3386]},
        "1383": {"vr": "IS", "Value": [933]},
        "1384": {"vr": "IS", "Value": [479]},
        "1385": {"vr": "IS", "Value": [1495]},
        "1386": {"vr": "IS", "Value": [2737]},
        "1387": {"vr": "IS", "Value": [1459]},
        "1388": {"vr": "IS", "Value": [2281]},
        "1389": {"vr": "IS", "Value": [456]},
        "1390": {"vr": "IS", "Value": [1511]},
        "1391": {"vr": "IS", "Value": [86]},
        "1392": {"vr": "IS", "Value": [3612]},
        "1393": {"vr": "IS", "Value": [1479]},
        "1394": {"vr": "IS", "Value": [2081]},
        "1395": {"vr": "IS", "Value": [1788]},
        "1396": {"vr": "IS", "Value": [2481]},
        "1397": {"vr": "IS", "Value": [1812]},
        "1398": {"vr": "IS", "Value": [1111]},
        "1399": {"vr": "IS", "Value": [1295]},
        "1400": {"vr": "IS", "Value": [2299]},
        "1401": {"vr": "IS", "Value": [1026]},
        "1402": {"vr": "IS", "Value": [3517]},
        "1403": {"vr": "IS", "Value": [1939]},
        "1404": {"vr": "IS", "Value": [16]},
        "1405": {"vr": "IS", "Value": [151]},
        "1406": {"vr": "IS", "Value": [951]},
        "1407": {"vr": "IS", "Value": [810]},
        "1408": {"vr": "IS", "Value": [1267]},
        "1409": {"vr": "IS", "Value": [821]},
        "1410": {"vr": "IS", "Value": [3535]},
        "1411": {"vr": "IS", "Value": [600]},
        "1412": {"vr": "IS", "Value": [2249]},
        "1413": {"vr": "IS", "Value": [3333]},
        "1414": {"vr": "IS", "Value": [2529]},
        "1415": {"vr": "IS", "Value": [191]},
        "1416": {"vr": "IS", "Value": [916]},
        "1417": {"vr": "IS", "Value": [676]},
        "1418": {"vr": "IS", "Value": [2142]},
        "1419": {"vr": "IS", "Value": [3522]},
        "1420": {"vr": "IS", "Value": [3033]},
        "1421": {"vr": "IS", "Value": [948]},
        "1422": {"vr": "IS", "Value": [3406]},
        "1423": {"vr": "IS", "Value": [1807]},
        "1424": {"vr": "IS", "Value": [3688]},
        "1425": {"vr": "IS", "Value": [1556]},
        "1426": {"vr": "IS", "Value": [3176]},
        "1427": {"vr": "IS", "Value": [2881]},
        "1428": {"vr": "IS", "Value": [1704]},
        "1429": {"vr": "IS", "Value": [3436]},
        "1430": {"vr": "IS", "Value": [3343]},
        "1431": {"vr": "IS", "Value": [3783]},
        "1432": {"vr": "IS", "Value": [1805]},
        "1433": {"vr": "IS", "Value": [3038]},
        "1434": {"vr": "IS", "Value": [2630]},
        "1435": {"vr": "IS", "Value": [2276]},
        "1436": {"vr": "IS", "Value": [3165]},
        "1437": {"vr": "IS", "Value": [2575]},
        "1438": {"vr": "IS", "Value": [301]},
        "1439": {"vr": "IS", "Value": [2079]},
        "1440": {"vr": "IS", "Value": [3855]},
        "1441": {"vr": "IS", "Value": [2216]},
        "1442": {"vr": "IS", "Value": [10]},
        "1443": {"vr": "IS", "Value": [3874]},
        "1444": {"vr": "IS", "Value": [2183]},
        "1445": {"vr": "IS", "Value": [3591]},
        "1446": {"vr": "IS", "Value": [2805]},
        "1447": {"vr": "IS", "Value": [1074]},
        "1448": {"vr": "IS", "Value": [245]},
        "1449": {"vr": "IS", "Value": [674]},
        "1450": {"vr": "IS", "Value": [1131]},
        "1451": {"vr": "IS", "Value": [1818]},
        "1452": {"vr": "IS", "Value": [88]},
        "1453": {"vr": "IS", "Value": [2826]},
        "1454": {"vr": "IS", "Value": [3760]},
        "1455": {"vr": "IS", "Value": [3973]},
        "1456": {"vr": "IS", "Value": [2255]},
        "1457": {"vr": "IS", "Value": [737]},
        "1458": {"vr": "IS", "Value": [3899]},
        "1459": {"vr": "IS", "Value": [434]},
        "1460": {"vr": "IS", "Value": [3358]},
        "1461": {"vr": "IS", "Value": [685]},
        "1462": {"vr": "IS", "Value": [1765]},
        "1463": {"vr": "IS", "Value": [1768]},
        "1464": {"vr": "IS", "Value": [3290]},
        "1465": {"vr": "IS", "Value": [2426]},
        "1466": {"vr": "IS", "Value": [1017]},
        "1467": {"vr": "IS", "Value": [868]},
        "1468": {"vr": "IS", "Value": [2766]},
        "1469": {"vr": "IS", "Value": [3628]},
        "1470": {"vr": "IS", "Value": [2367]},
        "1471": {"vr": "IS", "Value": [3370]},
        "1472": {"vr": "IS", "Value": [939]},
        "1473": {"vr": "IS", "Value": [992]},
        "1474": {"vr": "IS", "Value": [2649]},
        "1475": {"vr": "IS", "Value": [3369]},
        "1476": {"vr": "IS", "Value": [1429]},
        "1477": {"vr": "IS", "Value": [270]},
        "1478": {"vr": "IS", "Value": [1492]},
        "1479": {"vr": "IS", "Value": [2526]},
        "1480": {"vr": "IS", "Value": [3045]},
        "1481": {"vr": "IS", "Value": [3235]},
        "1482": {"vr": "IS", "Value": [3037]},
        "1483": {"vr": "IS", "Value": [2975]},
        "1484": {"vr": "IS", "Value": [2251]},
        "1485": {"vr": "IS", "Value": [1563]},
        "1486": {"vr": "IS", "Value": [616]},
        "1487": {"vr": "IS", "Value": [3821]},
        "1488": {"vr": "IS", "Value": [2690]},
        "1489": {"vr": "IS", "Value": [1672]},
        "1490": {"vr": "IS", "Value": [2193]},
        "1491": {"vr": "IS", "Value": [1218]},
        "1492": {"vr": "IS", "Value": [2379]},
        "1493": {"vr": "IS", "Value": [716]},
        "1494": {"vr": "IS", "Value": [3672]},
        "1495": {"vr": "IS", "Value": [2715]},
        "1496": {"vr": "IS", "Value": [3488]},
        "1497": {"vr": "IS", "Value": [834]},
        "1498": {"vr": "IS", "Value": [1725]},
        "1499": {"vr": "IS", "Value": [3492]},
        "1500": {"vr": "IS", "Value": [2562]},
        "1501": {"vr": "IS", "Value": [965]},
        "1502": {"vr": "IS", "Value": [2410]},
        "1503": {"vr": "IS", "Value": [3371]},
        "1504": {"vr": "IS", "Value": [2411]},
        "1505": {"vr": "IS", "Value": [1135]},
        "1506": {"vr": "IS", "Value": [1668]},
        "1507": {"vr": "IS", "Value": [1101]},
        "1508": {"vr": "IS", "Value": [404]},
        "1509": {"vr": "IS", "Value": [732]},
        "1510": {"vr": "IS", "Value": [2561]},
        "1511": {"vr": "IS", "Value": [3368]},
        "1512": {"vr": "IS", "Value": [2645]},
        "1513": {"vr": "IS", "Value": [258]},
        "1514": {"vr": "IS", "Value": [906]},
        "1515": {"vr": "IS", "Value": [26]},
        "1516": {"vr": "IS", "Value": [144]},
        "1517": {"vr": "IS", "Value": [3327]},
        "1518": {"vr": "IS", "Value": [3169]},
        "1519": {"vr": "IS", "Value": [2115]},
        "1520": {"vr": "IS", "Value": [1387]},
        "1521": {"vr": "IS", "Value": [3295]},
        "1522": {"vr": "IS", "Value": [1109]},
        "1523": {"vr": "IS", "Value": [1407]},
        "1524": {"vr": "IS", "Value": [1738]},
        "1525": {"vr": "IS", "Value": [506]},
        "1526": {"vr": "IS", "Value": [959]},
        "1527": {"vr": "IS", "Value": [3138]},
        "1528": {"vr": "IS", "Value": [127]},
        "1529": {"vr": "IS", "Value": [1597]},
        "1530": {"vr": "IS", "Value": [2957]},
        "1531": {"vr": "IS", "Value": [1804]},
        "1532": {"vr": "IS", "Value": [3686]},
        "1533": {"vr": "IS", "Value": [979]},
        "1534": {"vr": "IS", "Value": [1496]},
        "1535": {"vr": "IS", "Value": [920]},
        "1536": {"vr": "IS", "Value": [2014]},
        "1537": {"vr": "IS", "Value": [263]},
        "1538": {"vr": "IS", "Value": [290]},
        "1539": {"vr": "IS", "Value": [644]},
        "1540": {"vr": "IS", "Value": [2120]},
        "1541": {"vr": "IS", "Value": [2264]},
        "1542": {"vr": "IS", "Value": [1045]},
        "1543": {"vr": "IS", "Value": [1474]},
        "1544": {"vr": "IS", "Value": [1975]},
        "1545": {"vr": "IS", "Value": [1824]},
        "1546": {"vr": "IS", "Value": [2301]},
        "1547": {"vr": "IS", "Value": [2189]},
        "1548": {"vr": "IS", "Value": [2087]},
        "1549": {"vr": "IS", "Value": [1583]},
        "1550": {"vr": "IS", "Value": [1157]},
        "1551": {"vr": "IS", "Value": [1247]},
        "1552": {"vr": "IS", "Value": [1543]},
        "1553": {"vr": "IS", "Value": [700]},
        "1554": {"vr": "IS", "Value": [1944]},
        "1555": {"vr": "IS", "Value": [21]},
        "1556": {"vr": "IS", "Value": [2368]},
        "1557": {"vr": "IS", "Value": [1914]},
        "1558": {"vr": "IS", "Value": [1673]},
        "1559": {"vr": "IS", "Value": [2672]},
        "1560": {"vr": "IS", "Value": [3788]},
        "1561": {"vr": "IS", "Value": [2100]},
        "1562": {"vr": "IS", "Value": [3314]},
        "1563": {"vr": "IS", "Value": [947]},
        "1564": {"vr": "IS", "Value": [1016]},
        "1565": {"vr": "IS", "Value": [467]},
        "1566": {"vr": "IS", "Value": [2166]},
        "1567": {"vr": "IS", "Value": [1216]},
        "1568": {"vr": "IS", "Value": [2102]},
        "1569": {"vr": "IS", "Value": [3403]},
        "1570": {"vr": "IS", "Value": [2416]},
        "1571": {"vr": "IS", "Value": [214]},
        "1572": {"vr": "IS", "Value": [1441]},
        "1573": {"vr": "IS", "Value": [2292]},
        "1574": {"vr": "IS", "Value": [2032]},
        "1575": {"vr": "IS", "Value": [2395]},
        "1576": {"vr": "IS", "Value": [577]},
        "1577": {"vr": "IS", "Value": [2509]},
        "1578": {"vr": "IS", "Value": [3861]},
        "1579": {"vr": "IS", "Value": [3875]},
        "1580": {"vr": "IS", "Value": [2823]},
        "1581": {"vr": "IS", "Value": [1772]},
        "1582": {"vr": "IS", "Value": [2951]},
        "1583": {"vr": "IS", "Value": [2315]},
        "1584": {"vr": "IS", "Value": [914]},
        "1585": {"vr": "IS", "Value": [3459]},
        "1586": {"vr": "IS", "Value": [3142]},
        "1587": {"vr": "IS", "Value": [2321]},
        "1588": {"vr": "IS", "Value": [2617]},
        "1589": {"vr": "IS", "Value": [784]},
        "1590": {"vr": "IS", "Value": [1379]},
        "1591": {"vr": "IS", "Value": [925]},
        "1592": {"vr": "IS", "Value": [3454]},
        "1593": {"vr": "IS", "Value": [2278]},
        "1594": {"vr": "IS", "Value": [3334]},
        "1595": {"vr": "IS", "Value": [3747]},
        "1596": {"vr": "IS", "Value": [364]},
        "1597": {"vr": "IS", "Value": [1705]},
        "1598": {"vr": "IS", "Value": [3590]},
        "1599": {"vr": "IS", "Value": [2896]},
        "1600": {"vr": "IS", "Value": [2688]},
        "1601": {"vr": "IS", "Value": [51]},
        "1602": {"vr": "IS", "Value": [3646]},
        "1603": {"vr": "IS", "Value": [3996]},
        "1604": {"vr": "IS", "Value": [707]},
        "1605": {"vr": "IS", "Value": [2448]},
        "1606": {"vr": "IS", "Value": [3822]},
        "1607": {"vr": "IS", "Value": [1413]},
        "1608": {"vr": "IS", "Value": [3244]},
        "1609": {"vr": "IS", "Value": [1755]},
        "1610": {"vr": "IS", "Value": [2019]},
        "1611": {"vr": "IS", "Value": [3059]},
        "1612": {"vr": "IS", "Value": [1855]},
        "1613": {"vr": "IS", "Value": [3108]},
        "1614": {"vr": "IS", "Value": [919]},
        "1615": {"vr": "IS", "Value": [3163]},
        "1616": {"vr": "IS", "Value": [926]},
        "1617": {"vr": "IS", "Value": [1927]},
        "1618": {"vr": "IS", "Value": [1867]},
        "1619": {"vr": "IS", "Value": [179]},
        "1620": {"vr": "IS", "Value": [845]},
        "1621": {"vr": "IS", "Value": [1932]},
        "1622": {"vr": "IS", "Value": [2543]},
        "1623": {"vr": "IS", "Value": [1837]},
        "1624": {"vr": "IS", "Value": [3652]},
        "1625": {"vr": "IS", "Value": [1350]},
        "1626": {"vr": "IS", "Value": [2194]},
        "1627": {"vr": "IS", "Value": [1428]},
        "1628": {"vr": "IS", "Value": [2185]},
        "1629": {"vr": "IS", "Value": [3025]},
        "1630": {"vr": "IS", "Value": [3882]},
        "1631": {"vr": "IS", "Value": [740]},
        "1632": {"vr": "IS", "Value": [2581]},
        "1633": {"vr": "IS", "Value": [2171]},
        "1634": {"vr": "IS", "Value": [226]},
        "1635": {"vr": "IS", "Value": [2889]},
        "1636": {"vr": "IS", "Value": [339]},
        "1637": {"vr": "IS", "Value": [2762]},
        "1638": {"vr": "IS", "Value": [1636]},
        "1639": {"vr": "IS", "Value": [3398]},
        "1640": {"vr": "IS", "Value": [643]},
        "1641": {"vr": "IS", "Value": [3949]},
        "1642": {"vr": "IS", "Value": [133]},
        "1643": {"vr": "IS", "Value": [4018]},
        "1644": {"vr": "IS", "Value": [2008]},
        "1645": {"vr": "IS", "Value": [3583]},
        "1646": {"vr": "IS", "Value": [3032]},
        "1647": {"vr": "IS", "Value": [3448]},
        "1648": {"vr": "IS", "Value": [1014]},
        "1649": {"vr": "IS", "Value": [1351]},
        "1650": {"vr": "IS", "Value": [1923]},
        "1651": {"vr": "IS", "Value": [3103]},
        "1652": {"vr": "IS", "Value": [1678]},
        "1653": {"vr": "IS", "Value": [1813]},
        "1654": {"vr": "IS", "Value": [1138]},
        "1655": {"vr": "IS", "Value": [2706]},
        "1656": {"vr": "IS", "Value": [1840]},
        "1657": {"vr": "IS", "Value": [2637]},
        "1658": {"vr": "IS", "Value": [2912]},
        "1659": {"vr": "IS", "Value": [1562]},
        "1660": {"vr": "IS", "Value": [2560]},
        "1661": {"vr": "IS", "Value": [102]},
        "1662": {"vr": "IS", "Value": [2383]},
        "1663": {"vr": "IS", "Value": [1276]},
        "1664": {"vr": "IS", "Value": [3230]},
        "1665": {"vr": "IS", "Value": [2931]},
        "1666": {"vr": "IS", "Value": [1671]},
        "1667": {"vr": "IS", "Value": [2993]},
        "1668": {"vr": "IS", "Value": [755]},
        "1669": {"vr": "IS", "Value": [3056]},
        "1670": {"vr": "IS", "Value": [1714]},
        "1671": {"vr": "IS", "Value": [2631]},
        "1672": {"vr": "IS", "Value": [370]},
        "1673": {"vr": "IS", "Value": [1292]},
        "1674": {"vr": "IS", "Value": [2157]},
        "1675": {"vr": "IS", "Value": [969]},
        "1676": {"vr": "IS", "Value": [162]},
        "1677": {"vr": "IS", "Value": [3732]},
        "1678": {"vr": "IS", "Value": [1452]},
        "1679": {"vr": "IS", "Value": [1613]},
        "1680": {"vr": "IS", "Value": [3024]},
        "1681": {"vr": "IS", "Value": [608]},
        "1682": {"vr": "IS", "Value": [2920]},
        "1683": {"vr": "IS", "Value": [2584]},
        "1684": {"vr": "IS", "Value": [3566]},
        "1685": {"vr": "IS", "Value": [3177]},
        "1686": {"vr": "IS", "Value": [121]},
        "1687": {"vr": "IS", "Value": [2771]},
        "1688": {"vr": "IS", "Value": [1191]},
        "1689": {"vr": "IS", "Value": [1336]},
        "1690": {"vr": "IS", "Value": [2159]},
        "1691": {"vr": "IS", "Value": [3344]},
        "1692": {"vr": "IS", "Value": [1400]},
        "1693": {"vr": "IS", "Value": [1530]},
        "1694": {"vr": "IS", "Value": [3260]},
        "1695": {"vr": "IS", "Value": [843]},
        "1696": {"vr": "IS", "Value": [236]},
        "1697": {"vr": "IS", "Value": [2260]},
        "1698": {"vr": "IS", "Value": [3731]},
        "1699": {"vr": "IS", "Value": [2312]},
        "1700": {"vr": "IS", "Value": [54]},
        "1701": {"vr": "IS", "Value": [3207]},
        "1702": {"vr": "IS", "Value": [846]},
        "1703": {"vr": "IS", "Value": [244]},
        "1704": {"vr": "IS", "Value": [3640]},
        "1705": {"vr": "IS", "Value": [234]},
        "1706": {"vr": "IS", "Value": [185]},
        "1707": {"vr": "IS", "Value": [1384]},
        "1708": {"vr": "IS", "Value": [2976]},
        "1709": {"vr": "IS", "Value": [2114]},
        "1710": {"vr": "IS", "Value": [1696]},
        "1711": {"vr": "IS", "Value": [177]},
        "1712": {"vr": "IS", "Value": [2731]},
        "1713": {"vr": "IS", "Value": [1028]},
        "1714": {"vr": "IS", "Value": [3619]},
        "1715": {"vr": "IS", "Value": [3097]},
        "1716": {"vr": "IS", "Value": [393]},
        "1717": {"vr": "IS", "Value": [664]},
        "1718": {"vr": "IS", "Value": [1873]},
        "1719": {"vr": "IS", "Value": [3738]},
        "1720": {"vr": "IS", "Value": [4017]},
        "1721": {"vr": "IS", "Value": [3651]},
        "1722": {"vr": "IS", "Value": [972]},
        "1723": {"vr": "IS", "Value": [3735]},
        "1724": {"vr": "IS", "Value": [3139]},
        "1725": {"vr": "IS", "Value": [1023]},
        "1726": {"vr": "IS", "Value": [3564]},
        "1727": {"vr": "IS", "Value": [1685]},
        "1728": {"vr": "IS", "Value": [1110]},
        "1729": {"vr": "IS", "Value": [1963]},
        "1730": {"vr": "IS", "Value": [240]},
        "1731": {"vr": "IS", "Value": [1446]},
        "1732": {"vr": "IS", "Value": [135]},
        "1733": {"vr": "IS", "Value": [100]},
        "1734": {"vr": "IS", "Value": [3609]},
        "1735": {"vr": "IS", "Value": [3276]},
        "1736": {"vr": "IS", "Value": [1323]},
        "1737": {"vr": "IS", "Value": [812]},
        "1738": {"vr": "IS", "Value": [2694]},
        "1739": {"vr": "IS", "Value": [1447]},
        "1740": {"vr": "IS", "Value": [3642]},
        "1741": {"vr": "IS", "Value": [1127]},
        "1742": {"vr": "IS", "Value": [511]},
        "1743": {"vr": "IS", "Value": [1066]},
        "1744": {"vr": "IS", "Value": [2634]},
        "1745": {"vr": "IS", "Value": [2403]},
        "1746": {"vr": "IS", "Value": [3093]},
        "1747": {"vr": "IS", "Value": [2309]},
        "1748": {"vr": "IS", "Value": [2919]},
        "1749": {"vr": "IS", "Value": [3242]},
        "1750": {"vr": "IS", "Value": [3830]},
        "1751": {"vr": "IS", "Value": [3851]},
        "1752": {"vr": "IS", "Value": [442]},
        "1753": {"vr": "IS", "Value": [1001]},
        "1754": {"vr": "IS", "Value": [1888]},
        "1755": {"vr": "IS", "Value": [2622]},
        "1756": {"vr": "IS", "Value": [1062]},
        "1757": {"vr": "IS", "Value": [2531]},
        "1758": {"vr": "IS", "Value": [106]},
        "1759": {"vr": "IS", "Value": [174]},
        "1760": {"vr": "IS", "Value": [2537]},
        "1761": {"vr": "IS", "Value": [243]},
        "1762": {"vr": "IS", "Value": [94]},
        "1763": {"vr": "IS", "Value": [378]},
        "1764": {"vr": "IS", "Value": [1771]},
        "1765": {"vr": "IS", "Value": [657]},
        "1766": {"vr": "IS", "Value": [1395]},
        "1767": {"vr": "IS", "Value": [1526]},
        "1768": {"vr": "IS", "Value": [1525]},
        "1769": {"vr": "IS", "Value": [84]},
        "1770": {"vr": "IS", "Value": [2586]},
        "1771": {"vr": "IS", "Value": [1809]},
        "1772": {"vr": "IS", "Value": [1908]},
        "1773": {"vr": "IS", "Value": [3606]},
        "1774": {"vr": "IS", "Value": [289]},
        "1775": {"vr": "IS", "Value": [688]},
        "1776": {"vr": "IS", "Value": [3857]},
        "1777": {"vr": "IS", "Value": [1013]},
        "1778": {"vr": "IS", "Value": [1075]},
        "1779": {"vr": "IS", "Value": [3119]},
        "1780": {"vr": "IS", "Value": [1236]},
        "1781": {"vr": "IS", "Value": [3133]},
        "1782": {"vr": "IS", "Value": [800]},
        "1783": {"vr": "IS", "Value": [1030]},
        "1784": {"vr": "IS", "Value": [3020]},
        "1785": {"vr": "IS", "Value": [1457]},
        "1786": {"vr": "IS", "Value": [2710]},
        "1787": {"vr": "IS", "Value": [3909]},
        "1788": {"vr": "IS", "Value": [1125]},
        "1789": {"vr": "IS", "Value": [3005]},
        "1790": {"vr": "IS", "Value": [841]},
        "1791": {"vr": "IS", "Value": [582]},
        "1792": {"vr": "IS", "Value": [2184]},
        "1793": {"vr": "IS", "Value": [1810]},
        "1794": {"vr": "IS", "Value": [1773]},
        "1795": {"vr": "IS", "Value": [994]},
        "1796": {"vr": "IS", "Value": [42]},
        "1797": {"vr": "IS", "Value": [2273]},
        "1798": {"vr": "IS", "Value": [811]},
        "1799": {"vr": "IS", "Value": [2432]},
        "1800": {"vr": "IS", "Value": [2508]},
        "1801": {"vr": "IS", "Value": [3432]},
        "1802": {"vr": "IS", "Value": [1338]},
        "1803": {"vr": "IS", "Value": [3772]},
        "1804": {"vr": "IS", "Value": [3776]},
        "1805": {"vr": "IS", "Value": [3999]},
        "1806": {"vr": "IS", "Value": [420]},
        "1807": {"vr": "IS", "Value": [3679]},
        "1808": {"vr": "IS", "Value": [3051]},
        "1809": {"vr": "IS", "Value": [1015]},
        "1810": {"vr": "IS", "Value": [2336]},
        "1811": {"vr": "IS", "Value": [1847]},
        "1812": {"vr": "IS", "Value": [1515]},
        "1813": {"vr": "IS", "Value": [1476]},
        "1814": {"vr": "IS", "Value": [3267]},
        "1815": {"vr": "IS", "Value": [3799]},
        "1816": {"vr": "IS", "Value": [2155]},
        "1817": {"vr": "IS", "Value": [2285]},
        "1818": {"vr": "IS", "Value": [2181]},
        "1819": {"vr": "IS", "Value": [1731]},
        "1820": {"vr": "IS", "Value": [1398]},
        "1821": {"vr": "IS", "Value": [2639]},
        "1822": {"vr": "IS", "Value": [3061]},
        "1823": {"vr": "IS", "Value": [2623]},
        "1824": {"vr": "IS", "Value": [952]},
        "1825": {"vr": "IS", "Value": [2319]},
        "1826": {"vr": "IS", "Value": [1021]},
        "1827": {"vr": "IS", "Value": [3337]},
        "1828": {"vr": "IS", "Value": [1611]},
        "1829": {"vr": "IS", "Value": [424]},
        "1830": {"vr": "IS", "Value": [990]},
        "1831": {"vr": "IS", "Value": [2330]},
        "1832": {"vr": "IS", "Value": [1554]},
        "1833": {"vr": "IS", "Value": [2190]},
        "1834": {"vr": "IS", "Value": [801]},
        "1835": {"vr": "IS", "Value": [2146]},
        "1836": {"vr": "IS", "Value": [2556]},
        "1837": {"vr": "IS", "Value": [1367]},
        "1838": {"vr": "IS", "Value": [3353]},
        "1839": {"vr": "IS", "Value": [2966]},
        "1840": {"vr": "IS", "Value": [307]},
        "1841": {"vr": "IS", "Value": [2378]},
        "1842": {"vr": "IS", "Value": [1845]},
        "1843": {"vr": "IS", "Value": [826]},
        "1844": {"vr": "IS", "Value": [2569]},
        "1845": {"vr": "IS", "Value": [1322]},
        "1846": {"vr": "IS", "Value": [1219]},
        "1847": {"vr": "IS", "Value": [1195]},
        "1848": {"vr": "IS", "Value": [1966]},
        "1849": {"vr": "IS", "Value": [3049]},
        "1850": {"vr": "IS", "Value": [2126]},
        "1851": {"vr": "IS", "Value": [3064]},
        "1852": {"vr": "IS", "Value": [2512]},
        "1853": {"vr": "IS", "Value": [77]},
        "1854": {"vr": "IS", "Value": [493]},
        "1855": {"vr": "IS", "Value": [1885]},
        "1856": {"vr": "IS", "Value": [628]},
        "1857": {"vr": "IS", "Value": [3782]},
        "1858": {"vr": "IS", "Value": [1293]},
        "1859": {"vr": "IS", "Value": [630]},
        "1860": {"vr": "IS", "Value": [2259]},
        "1861": {"vr": "IS", "Value": [2392]},
        "1862": {"vr": "IS", "Value": [974]},
        "1863": {"vr": "IS", "Value": [3400]},
        "1864": {"vr": "IS", "Value": [410]},
        "1865": {"vr": "IS", "Value": [1971]},
        "1866": {"vr": "IS", "Value": [2253]},
        "1867": {"vr": "IS", "Value": [2451]},
        "1868": {"vr": "IS", "Value": [3901]},
        "1869": {"vr": "IS", "Value": [2787]},
        "1870": {"vr": "IS", "Value": [283]},
        "1871": {"vr": "IS", "Value": [2914]},
        "1872": {"vr": "IS", "Value": [3987]},
        "1873": {"vr": "IS", "Value": [5]},
        "1874": {"vr": "IS", "Value": [1036]},
        "1875": {"vr": "IS", "Value": [3775]},
        "1876": {"vr": "IS", "Value": [383]},
        "1877": {"vr": "IS", "Value": [488]},
        "1878": {"vr": "IS", "Value": [3954]},
        "1879": {"vr": "IS", "Value": [1308]},
        "1880": {"vr": "IS", "Value": [1047]},
        "1881": {"vr": "IS", "Value": [3057]},
        "1882": {"vr": "IS", "Value": [1760]},
        "1883": {"vr": "IS", "Value": [239]},
        "1884": {"vr": "IS", "Value": [1166]},
        "1885": {"vr": "IS", "Value": [3713]},
        "1886": {"vr": "IS", "Value": [2064]},
        "1887": {"vr": "IS", "Value": [3174]},
        "1888": {"vr": "IS", "Value": [3816]},
        "1889": {"vr": "IS", "Value": [3320]},
        "1890": {"vr": "IS", "Value": [2364]},
        "1891": {"vr": "IS", "Value": [2218]},
        "1892": {"vr": "IS", "Value": [3600]},
        "1893": {"vr": "IS", "Value": [252]},
        "1894": {"vr": "IS", "Value": [3670]},
        "1895": {"vr": "IS", "Value": [3543]},
        "1896": {"vr": "IS", "Value": [2739]},
        "1897": {"vr": "IS", "Value": [1091]},
        "1898": {"vr": "IS", "Value": [3891]},
        "1899": {"vr": "IS", "Value": [227]},
        "1900": {"vr": "IS", "Value": [726]},
        "1901": {"vr": "IS", "Value": [3633]},
        "1902": {"vr": "IS", "Value": [1512]},
        "1903": {"vr": "IS", "Value": [1043]},
        "1904": {"vr": "IS", "Value": [1674]},
        "1905": {"vr": "IS", "Value": [3046]},
        "1906": {"vr": "IS", "Value": [1438]},
        "1907": {"vr": "IS", "Value": [1514]},
        "1908": {"vr": "IS", "Value": [1658]},
        "1909": {"vr": "IS", "Value": [3329]},
        "1910": {"vr": "IS", "Value": [1042]},
        "1911": {"vr": "IS", "Value": [388]},
        "1912": {"vr": "IS", "Value": [483]},
        "1913": {"vr": "IS", "Value": [3091]},
        "1914": {"vr": "IS", "Value": [3321]},
        "1915": {"vr": "IS", "Value": [49]},
        "1916": {"vr": "IS", "Value": [2013]},
        "1917": {"vr": "IS", "Value": [3014]},
        "1918": {"vr": "IS", "Value": [1991]},
        "1919": {"vr": "IS", "Value": [3960]},
        "1920": {"vr": "IS", "Value": [1325]},
        "1921": {"vr": "IS", "Value": [1508]},
        "1922": {"vr": "IS", "Value": [1728]},
        "1923": {"vr": "IS", "Value": [1655]},
        "1924": {"vr": "IS", "Value": [292]},
        "1925": {"vr": "IS", "Value": [1161]},
        "1926": {"vr": "IS", "Value": [3277]},
        "1927": {"vr": "IS", "Value": [1740]},
        "1928": {"vr": "IS", "Value": [1192]},
        "1929": {"vr": "IS", "Value": [1884]},
        "1930": {"vr": "IS", "Value": [2948]},
        "1931": {"vr": "IS", "Value": [1640]},
        "1932": {"vr": "IS", "Value": [3430]},
        "1933": {"vr": "IS", "Value": [2673]},
        "1934": {"vr": "IS", "Value": [417]},
        "1935": {"vr": "IS", "Value": [3465]},
        "1936": {"vr": "IS", "Value": [653]},
        "1937": {"vr": "IS", "Value": [2923]},
        "1938": {"vr": "IS", "Value": [3501]},
        "1939": {"vr": "IS", "Value": [1814]},
        "1940": {"vr": "IS", "Value": [1255]},
        "1941": {"vr": "IS", "Value": [1414]},
        "1942": {"vr": "IS", "Value": [2495]},
        "1943": {"vr": "IS", "Value": [490]},
        "1944": {"vr": "IS", "Value": [2503]},
        "1945": {"vr": "IS", "Value": [2711]},
        "1946": {"vr": "IS", "Value": [1516]},
        "1947": {"vr": "IS", "Value": [1531]},
        "1948": {"vr": "IS", "Value": [3469]},
        "1949": {"vr": "IS", "Value": [687]},
        "1950": {"vr": "IS", "Value": [2946]},
        "1951": {"vr": "IS", "Value": [2307]},
        "1952": {"vr": "IS", "Value": [2528]},
        "1953": {"vr": "IS", "Value": [1851]},
        "1954": {"vr": "IS", "Value": [277]},
        "1955": {"vr": "IS", "Value": [876]},
        "1956": {"vr": "IS", "Value": [3104]},
        "1957": {"vr": "IS", "Value": [2138]},
        "1958": {"vr": "IS", "Value": [2519]},
        "1959": {"vr": "IS", "Value": [1830]},
        "1960": {"vr": "IS", "Value": [1251]},
        "1961": {"vr": "IS", "Value": [28]},
        "1962": {"vr": "IS", "Value": [2777]},
        "1963": {"vr": "IS", "Value": [2559]},
        "1964": {"vr": "IS", "Value": [1941]},
        "1965": {"vr": "IS", "Value": [1521]},
        "1966": {"vr": "IS", "Value": [2910]},
        "1967": {"vr": "IS", "Value": [3961]},
        "1968": {"vr": "IS", "Value": [2583]},
        "1969": {"vr": "IS", "Value": [3888]},
        "1970": {"vr": "IS", "Value": [1124]},
        "1971": {"vr": "IS", "Value": [1473]},
        "1972": {"vr": "IS", "Value": [2065]},
        "1973": {"vr": "IS", "Value": [3972]},
        "1974": {"vr": "IS", "Value": [1189]},
        "1975": {"vr": "IS", "Value": [3185]},
        "1976": {"vr": "IS", "Value": [265]},
        "1977": {"vr": "IS", "Value": [2071]},
        "1978": {"vr": "IS", "Value": [621]},
        "1979": {"vr": "IS", "Value": [2888]},
        "1980": {"vr": "IS", "Value": [1444]},
        "1981": {"vr": "IS", "Value": [2399]},
        "1982": {"vr": "IS", "Value": [3043]},
        "1983": {"vr": "IS", "Value": [2090]},
        "1984": {"vr": "IS", "Value": [503]},
        "1985": {"vr": "IS", "Value": [2084]},
        "1986": {"vr": "IS", "Value": [3359]},
        "1987": {"vr": "IS", "Value": [3805]},
        "1988": {"vr": "IS", "Value": [198]},
        "1989": {"vr": "IS", "Value": [2041]},
        "1990": {"vr": "IS", "Value": [2915]},
        "1991": {"vr": "IS", "Value": [1723]},
        "1992": {"vr": "IS", "Value": [1073]},
        "1993": {"vr": "IS", "Value": [2007]},
        "1994": {"vr": "IS", "Value": [3588]},
        "1995": {"vr": "IS", "Value": [3683]},
        "1996": {"vr": "IS", "Value": [1996]},
        "1997": {"vr": "IS", "Value": [348]},
        "1998": {"vr": "IS", "Value": [2464]},
        "1999": {"vr": "IS", "Value": [2628]},
        "2000": {"vr": "IS", "Value": [3140]},
        "2001": {"vr": "IS", "Value": [4010]},
        "2002": {"vr": "IS", "Value": [2987]},
        "2003": {"vr": "IS", "Value": [208]},
        "2004": {"vr": "IS", "Value": [2727]},
        "2005": {"vr": "IS", "Value": [636]},
        "2006": {"vr": "IS", "Value": [1861]},
        "2007": {"vr": "IS", "Value": [414]},
        "2008": {"vr": "IS", "Value": [761]},
        "2009": {"vr": "IS", "Value": [3934]},
        "2010": {"vr": "IS", "Value": [558]},
        "2011": {"vr": "IS", "Value": [3523]},
        "2012": {"vr": "IS", "Value": [20]},
        "2013": {"vr": "IS", "Value": [3229]},
        "2014": {"vr": "IS", "Value": [1604]},
        "2015": {"vr": "IS", "Value": [3070]},
        "2016": {"vr": "IS", "Value": [2055]},
        "2017": {"vr": "IS", "Value": [1982]},
        "2018": {"vr": "IS", "Value": [3441]},
        "2019": {"vr": "IS", "Value": [1929]},
        "2020": {"vr": "IS", "Value": [3883]},
        "2021": {"vr": "IS", "Value": [1399]},
        "2022": {"vr": "IS", "Value": [2417]},
        "2023": {"vr": "IS", "Value": [1316]},
        "2024": {"vr": "IS", "Value": [3693]},
        "2025": {"vr": "IS", "Value": [709]},
        "2026": {"vr": "IS", "Value": [3611]},
        "2027": {"vr": "IS", "Value": [1178]},
        "2028": {"vr": "IS", "Value": [2608]},
        "2029": {"vr": "IS", "Value": [703]},
        "2030": {"vr": "IS", "Value": [3920]},
        "2031": {"vr": "IS", "Value": [2158]},
        "2032": {"vr": "IS", "Value": [559]},
        "2033": {"vr": "IS", "Value": [3817]},
        "2034": {"vr": "IS", "Value": [2314]},
        "2035": {"vr": "IS", "Value": [2070]},
        "2036": {"vr": "IS", "Value": [1229]},
        "2037": {"vr": "IS", "Value": [1009]},
        "2038": {"vr": "IS", "Value": [3120]},
        "2039": {"vr": "IS", "Value": [1951]},
        "2040": {"vr": "IS", "Value": [500]},
        "2041": {"vr": "IS", "Value": [2492]},
        "2042": {"vr": "IS", "Value": [530]},
        "2043": {"vr": "IS", "Value": [3210]},
        "2044": {"vr": "IS", "Value": [1609]},
        "2045": {"vr": "IS", "Value": [2365]},
        "2046": {"vr": "IS", "Value": [1102]},
        "2047": {"vr": "IS", "Value": [3845]},
        "2048": {"vr": "IS", "Value": [1303]},
        "2049": {"vr": "IS", "Value": [2057]},
        "2050": {"vr": "IS", "Value": [282]},
        "2051": {"vr": "IS", "Value": [1641]},
        "2052": {"vr": "IS", "Value": [478]},
        "2053": {"vr": "IS", "Value": [2902]},
        "2054": {"vr": "IS", "Value": [1869]},
        "2055": {"vr": "IS", "Value": [1472]},
        "2056": {"vr": "IS", "Value": [2522]},
        "2057": {"vr": "IS", "Value": [3709]},
        "2058": {"vr": "IS", "Value": [3943]},
        "2059": {"vr": "IS", "Value": [3493]},
        "2060": {"vr": "IS", "Value": [750]},
        "2061": {"vr": "IS", "Value": [2239]},
        "2062": {"vr": "IS", "Value": [1040]},
        "2063": {"vr": "IS", "Value": [2366]},
        "2064": {"vr": "IS", "Value": [3322]},
        "2065": {"vr": "IS", "Value": [3690]},
        "2066": {"vr": "IS", "Value": [2234]},
        "2067": {"vr": "IS", "Value": [1481]},
        "2068": {"vr": "IS", "Value": [1475]},
        "2069": {"vr": "IS", "Value": [3578]},
        "2070": {"vr": "IS", "Value": [2323]},
        "2071": {"vr": "IS", "Value": [2981]},
        "2072": {"vr": "IS", "Value": [2054]},
        "2073": {"vr": "IS", "Value": [2535]},
        "2074": {"vr": "IS", "Value": [983]},
        "2075": {"vr": "IS", "Value": [1352]},
        "2076": {"vr": "IS", "Value": [2510]},
        "2077": {"vr": "IS", "Value": [3247]},
        "2078": {"vr": "IS", "Value": [1132]},
        "2079": {"vr": "IS", "Value": [1345]},
        "2080": {"vr": "IS", "Value": [1259]},
        "2081": {"vr": "IS", "Value": [3573]},
        "2082": {"vr": "IS", "Value": [1335]},
        "2083": {"vr": "IS", "Value": [1998]},
        "2084": {"vr": "IS", "Value": [2012]},
        "2085": {"vr": "IS", "Value": [915]},
        "2086": {"vr": "IS", "Value": [3352]},
        "2087": {"vr": "IS", "Value": [3677]},
        "2088": {"vr": "IS", "Value": [2784]},
        "2089": {"vr": "IS", "Value": [1128]},
        "2090": {"vr": "IS", "Value": [2086]},
        "2091": {"vr": "IS", "Value": [2320]},
        "2092": {"vr": "IS", "Value": [2750]},
        "2093": {"vr": "IS", "Value": [3948]},
        "2094": {"vr": "IS", "Value": [3894]},
        "2095": {"vr": "IS", "Value": [1541]},
        "2096": {"vr": "IS", "Value": [760]},
        "2097": {"vr": "IS", "Value": [745]},
        "2098": {"vr": "IS", "Value": [18]},
        "2099": {"vr": "IS", "Value": [3171]},
        "2100": {"vr": "IS", "Value": [2515]},
        "2101": {"vr": "IS", "Value": [3127]},
        "2102": {"vr": "IS", "Value": [1763]},
        "2103": {"vr": "IS", "Value": [98]},
        "2104": {"vr": "IS", "Value": [3124]},
        "2105": {"vr": "IS", "Value": [271]},
        "2106": {"vr": "IS", "Value": [1020]},
        "2107": {"vr": "IS", "Value": [2446]},
        "2108": {"vr": "IS", "Value": [481]},
        "2109": {"vr": "IS", "Value": [3306]},
        "2110": {"vr": "IS", "Value": [3587]},
        "2111": {"vr": "IS", "Value": [754]},
        "2112": {"vr": "IS", "Value": [1139]},
        "2113": {"vr": "IS", "Value": [2139]},
        "2114": {"vr": "IS", "Value": [3416]},
        "2115": {"vr": "IS", "Value": [298]},
        "2116": {"vr": "IS", "Value": [2110]},
        "2117": {"vr": "IS", "Value": [1245]},
        "2118": {"vr": "IS", "Value": [875]},
        "2119": {"vr": "IS", "Value": [2282]},
        "2120": {"vr": "IS", "Value": [3958]},
        "2121": {"vr": "IS", "Value": [638]},
        "2122": {"vr": "IS", "Value": [104]},
        "2123": {"vr": "IS", "Value": [591]},
        "2124": {"vr": "IS", "Value": [251]},
        "2125": {"vr": "IS", "Value": [1237]},
        "2126": {"vr": "IS", "Value": [213]},
        "2127": {"vr": "IS", "Value": [1702]},
        "2128": {"vr": "IS", "Value": [2388]},
        "2129": {"vr": "IS", "Value": [3622]},
        "2130": {"vr": "IS", "Value": [1698]},
        "2131": {"vr": "IS", "Value": [3752]},
        "2132": {"vr": "IS", "Value": [2671]},
        "2133": {"vr": "IS", "Value": [413]},
        "2134": {"vr": "IS", "Value": [746]},
        "2135": {"vr": "IS", "Value": [911]},
        "2136": {"vr": "IS", "Value": [648]},
        "2137": {"vr": "IS", "Value": [1390]},
        "2138": {"vr": "IS", "Value": [1652]},
        "2139": {"vr": "IS", "Value": [2092]},
        "2140": {"vr": "IS", "Value": [2042]},
        "2141": {"vr": "IS", "Value": [2500]},
        "2142": {"vr": "IS", "Value": [1843]},
        "2143": {"vr": "IS", "Value": [3879]},
        "2144": {"vr": "IS", "Value": [2359]},
        "2145": {"vr": "IS", "Value": [1061]},
        "2146": {"vr": "IS", "Value": [4000]},
        "2147": {"vr": "IS", "Value": [592]},
        "2148": {"vr": "IS", "Value": [545]},
        "2149": {"vr": "IS", "Value": [3697]},
        "2150": {"vr": "IS", "Value": [3757]},
        "2151": {"vr": "IS", "Value": [2101]},
        "2152": {"vr": "IS", "Value": [343]},
        "2153": {"vr": "IS", "Value": [953]},
        "2154": {"vr": "IS", "Value": [2615]},
        "2155": {"vr": "IS", "Value": [2358]},
        "2156": {"vr": "IS", "Value": [2783]},
        "2157": {"vr": "IS", "Value": [1940]},
        "2158": {"vr": "IS", "Value": [2676]},
        "2159": {"vr": "IS", "Value": [1933]},
        "2160": {"vr": "IS", "Value": [1911]},
        "2161": {"vr": "IS", "Value": [805]},
        "2162": {"vr": "IS", "Value": [344]},
        "2163": {"vr": "IS", "Value": [1828]},
        "2164": {"vr": "IS", "Value": [2437]},
        "2165": {"vr": "IS", "Value": [1324]},
        "2166": {"vr": "IS", "Value": [1756]},
        "2167": {"vr": "IS", "Value": [2532]},
        "2168": {"vr": "IS", "Value": [3842]},
        "2169": {"vr": "IS", "Value": [1100]},
        "2170": {"vr": "IS", "Value": [2009]},
        "2171": {"vr": "IS", "Value": [3759]},
        "2172": {"vr": "IS", "Value": [735]},
        "2173": {"vr": "IS", "Value": [3075]},
        "2174": {"vr": "IS", "Value": [2031]},
        "2175": {"vr": "IS", "Value": [1179]},
        "2176": {"vr": "IS", "Value": [2455]},
        "2177": {"vr": "IS", "Value": [3933]},
        "2178": {"vr": "IS", "Value": [721]},
        "2179": {"vr": "IS", "Value": [2475]},
        "2180": {"vr": "IS", "Value": [524]},
        "2181": {"vr": "IS", "Value": [1008]},
        "2182": {"vr": "IS", "Value": [2730]},
        "2183": {"vr": "IS", "Value": [3442]},
        "2184": {"vr": "IS", "Value": [2891]},
        "2185": {"vr": "IS", "Value": [1974]},
        "2186": {"vr": "IS", "Value": [3114]},
        "2187": {"vr": "IS", "Value": [3962]},
        "2188": {"vr": "IS", "Value": [2546]},
        "2189": {"vr": "IS", "Value": [1105]},
        "2190": {"vr": "IS", "Value": [257]},
        "2191": {"vr": "IS", "Value": [656]},
        "2192": {"vr": "IS", "Value": [1330]},
        "2193": {"vr": "IS", "Value": [3173]},
        "2194": {"vr": "IS", "Value": [230]},
        "2195": {"vr": "IS", "Value": [1581]},
        "2196": {"vr": "IS", "Value": [2489]},
        "2197": {"vr": "IS", "Value": [1950]},
        "2198": {"vr": "IS", "Value": [3594]},
        "2199": {"vr": "IS", "Value": [3069]},
        "2200": {"vr": "IS", "Value": [730]},
        "2201": {"vr": "IS", "Value": [1142]},
        "2202": {"vr": "IS", "Value": [3362]},
        "2203": {"vr": "IS", "Value": [2838]},
        "2204": {"vr": "IS", "Value": [4004]},
        "2205": {"vr": "IS", "Value": [376]},
        "2206": {"vr": "IS", "Value": [2590]},
        "2207": {"vr": "IS", "Value": [2375]},
        "2208": {"vr": "IS", "Value": [3942]},
        "2209": {"vr": "IS", "Value": [3193]},
        "2210": {"vr": "IS", "Value": [793]},
        "2211": {"vr": "IS", "Value": [242]},
        "2212": {"vr": "IS", "Value": [2900]},
        "2213": {"vr": "IS", "Value": [2869]},
        "2214": {"vr": "IS", "Value": [1235]},
        "2215": {"vr": "IS", "Value": [3275]},
        "2216": {"vr": "IS", "Value": [2058]},
        "2217": {"vr": "IS", "Value": [2798]},
        "2218": {"vr": "IS", "Value": [1654]},
        "2219": {"vr": "IS", "Value": [894]},
        "2220": {"vr": "IS", "Value": [17]},
        "2221": {"vr": "IS", "Value": [654]},
        "2222": {"vr": "IS", "Value": [3200]},
        "2223": {"vr": "IS", "Value": [2271]},
        "2224": {"vr": "IS", "Value": [405]},
        "2225": {"vr": "IS", "Value": [2339]},
        "2226": {"vr": "IS", "Value": [1393]},
        "2227": {"vr": "IS", "Value": [3637]},
        "2228": {"vr": "IS", "Value": [221]},
        "2229": {"vr": "IS", "Value": [3719]},
        "2230": {"vr": "IS", "Value": [2757]},
        "2231": {"vr": "IS", "Value": [3060]},
        "2232": {"vr": "IS", "Value": [2496]},
        "2233": {"vr": "IS", "Value": [3935]},
        "2234": {"vr": "IS", "Value": [2202]},
        "2235": {"vr": "IS", "Value": [2848]},
        "2236": {"vr": "IS", "Value": [2990]},
        "2237": {"vr": "IS", "Value": [2435]},
        "2238": {"vr": "IS", "Value": [3002]},
        "2239": {"vr": "IS", "Value": [683]},
        "2240": {"vr": "IS", "Value": [1240]},
        "2241": {"vr": "IS", "Value": [655]},
        "2242": {"vr": "IS", "Value": [2485]},
        "2243": {"vr": "IS", "Value": [432]},
        "2244": {"vr": "IS", "Value": [280]},
        "2245": {"vr": "IS", "Value": [1707]},
        "2246": {"vr": "IS", "Value": [168]},
        "2247": {"vr": "IS", "Value": [2401]},
        "2248": {"vr": "IS", "Value": [464]},
        "2249": {"vr": "IS", "Value": [3428]},
        "2250": {"vr": "IS", "Value": [3237]},
        "2251": {"vr": "IS", "Value": [820]},
        "2252": {"vr": "IS", "Value": [63]},
        "2253": {"vr": "IS", "Value": [3440]},
        "2254": {"vr": "IS", "Value": [4003]},
        "2255": {"vr": "IS", "Value": [1314]},
        "2256": {"vr": "IS", "Value": [3906]},
        "2257": {"vr": "IS", "Value": [2811]},
        "2258": {"vr": "IS", "Value": [564]},
        "2259": {"vr": "IS", "Value": [698]},
        "2260": {"vr": "IS", "Value": [2104]},
        "2261": {"vr": "IS", "Value": [1104]},
        "2262": {"vr": "IS", "Value": [3892]},
        "2263": {"vr": "IS", "Value": [3307]},
        "2264": {"vr": "IS", "Value": [2806]},
        "2265": {"vr": "IS", "Value": [1835]},
        "2266": {"vr": "IS", "Value": [2597]},
        "2267": {"vr": "IS", "Value": [3778]},
        "2268": {"vr": "IS", "Value": [2457]},
        "2269": {"vr": "IS", "Value": [546]},
        "2270": {"vr": "IS", "Value": [2808]},
        "2271": {"vr": "IS", "Value": [1288]},
        "2272": {"vr": "IS", "Value": [3770]},
        "2273": {"vr": "IS", "Value": [1612]},
        "2274": {"vr": "IS", "Value": [3269]},
        "2275": {"vr": "IS", "Value": [2201]},
        "2276": {"vr": "IS", "Value": [2407]},
        "2277": {"vr": "IS", "Value": [2152]},
        "2278": {"vr": "IS", "Value": [3309]},
        "2279": {"vr": "IS", "Value": [3856]},
        "2280": {"vr": "IS", "Value": [650]},
        "2281": {"vr": "IS", "Value": [2998]},
        "2282": {"vr": "IS", "Value": [977]},
        "2283": {"vr": "IS", "Value": [1063]},
        "2284": {"vr": "IS", "Value": [1925]},
        "2285": {"vr": "IS", "Value": [3194]},
        "2286": {"vr": "IS", "Value": [3506]},
        "2287": {"vr": "IS", "Value": [60]},
        "2288": {"vr": "IS", "Value": [3952]},
        "2289": {"vr": "IS", "Value": [137]},
        "2290": {"vr": "IS", "Value": [818]},
        "2291": {"vr": "IS", "Value": [2661]},
        "2292": {"vr": "IS", "Value": [3570]},
        "2293": {"vr": "IS", "Value": [869]},
        "2294": {"vr": "IS", "Value": [2130]},
        "2295": {"vr": "IS", "Value": [2034]},
        "2296": {"vr": "IS", "Value": [2650]},
        "2297": {"vr": "IS", "Value": [3563]},
        "2298": {"vr": "IS", "Value": [2638]},
        "2299": {"vr": "IS", "Value": [3781]},
        "2300": {"vr": "IS", "Value": [3145]},
        "2301": {"vr": "IS", "Value": [2539]},
        "2302": {"vr": "IS", "Value": [881]},
        "2303": {"vr": "IS", "Value": [2742]},
        "2304": {"vr": "IS", "Value": [2246]},
        "2305": {"vr": "IS", "Value": [114]},
        "2306": {"vr": "IS", "Value": [184]},
        "2307": {"vr": "IS", "Value": [2867]},
        "2308": {"vr": "IS", "Value": [2992]},
        "2309": {"vr": "IS", "Value": [1792]},
        "2310": {"vr": "IS", "Value": [1550]},
        "2311": {"vr": "IS", "Value": [2868]},
        "2312": {"vr": "IS", "Value": [3413]},
        "2313": {"vr": "IS", "Value": [12]},
        "2314": {"vr": "IS", "Value": [1681]},
        "2315": {"vr": "IS", "Value": [3903]},
        "2316": {"vr": "IS", "Value": [153]},
        "2317": {"vr": "IS", "Value": [2970]},
        "2318": {"vr": "IS", "Value": [2701]},
        "2319": {"vr": "IS", "Value": [1059]},
        "2320": {"vr": "IS", "Value": [1791]},
        "2321": {"vr": "IS", "Value": [1152]},
        "2322": {"vr": "IS", "Value": [259]},
        "2323": {"vr": "IS", "Value": [3520]},
        "2324": {"vr": "IS", "Value": [2810]},
        "2325": {"vr": "IS", "Value": [3796]},
        "2326": {"vr": "IS", "Value": [1067]},
        "2327": {"vr": "IS", "Value": [1743]},
        "2328": {"vr": "IS", "Value": [1242]},
        "2329": {"vr": "IS", "Value": [1621]},
        "2330": {"vr": "IS", "Value": [2956]},
        "2331": {"vr": "IS", "Value": [874]},
        "2332": {"vr": "IS", "Value": [2812]},
        "2333": {"vr": "IS", "Value": [2501]},
        "2334": {"vr": "IS", "Value": [2132]},
        "2335": {"vr": "IS", "Value": [1435]},
        "2336": {"vr": "IS", "Value": [312]},
        "2337": {"vr": "IS", "Value": [2625]},
        "2338": {"vr": "IS", "Value": [470]},
        "2339": {"vr": "IS", "Value": [1156]},
        "2340": {"vr": "IS", "Value": [3323]},
        "2341": {"vr": "IS", "Value": [2289]},
        "2342": {"vr": "IS", "Value": [3387]},
        "2343": {"vr": "IS", "Value": [1584]},
        "2344": {"vr": "IS", "Value": [1405]},
        "2345": {"vr": "IS", "Value": [1645]},
        "2346": {"vr": "IS", "Value": [3315]},
        "2347": {"vr": "IS", "Value": [757]},
        "2348": {"vr": "IS", "Value": [2406]},
        "2349": {"vr": "IS", "Value": [907]},
        "2350": {"vr": "IS", "Value": [396]},
        "2351": {"vr": "IS", "Value": [2719]},
        "2352": {"vr": "IS", "Value": [1233]},
        "2353": {"vr": "IS", "Value": [3499]},
        "2354": {"vr": "IS", "Value": [520]},
        "2355": {"vr": "IS", "Value": [105]},
        "2356": {"vr": "IS", "Value": [1391]},
        "2357": {"vr": "IS", "Value": [3825]},
        "2358": {"vr": "IS", "Value": [1275]},
        "2359": {"vr": "IS", "Value": [3360]},
        "2360": {"vr": "IS", "Value": [712]},
        "2361": {"vr": "IS", "Value": [3922]},
        "2362": {"vr": "IS", "Value": [3161]},
        "2363": {"vr": "IS", "Value": [3880]},
        "2364": {"vr": "IS", "Value": [3654]},
        "2365": {"vr": "IS", "Value": [333]},
        "2366": {"vr": "IS", "Value": [1411]},
        "2367": {"vr": "IS", "Value": [2324]},
        "2368": {"vr": "IS", "Value": [3101]},
        "2369": {"vr": "IS", "Value": [44]},
        "2370": {"vr": "IS", "Value": [279]},
        "2371": {"vr": "IS", "Value": [2313]},
        "2372": {"vr": "IS", "Value": [1315]},
        "2373": {"vr": "IS", "Value": [510]},
        "2374": {"vr": "IS", "Value": [354]},
        "2375": {"vr": "IS", "Value": [1922]},
        "2376": {"vr": "IS", "Value": [681]},
        "2377": {"vr": "IS", "Value": [211]},
        "2378": {"vr": "IS", "Value": [3300]},
        "2379": {"vr": "IS", "Value": [453]},
        "2380": {"vr": "IS", "Value": [3422]},
        "2381": {"vr": "IS", "Value": [2677]},
        "2382": {"vr": "IS", "Value": [2655]},
        "2383": {"vr": "IS", "Value": [1628]},
        "2384": {"vr": "IS", "Value": [1872]},
        "2385": {"vr": "IS", "Value": [1989]},
        "2386": {"vr": "IS", "Value": [3477]},
        "2387": {"vr": "IS", "Value": [985]},
        "2388": {"vr": "IS", "Value": [3777]},
        "2389": {"vr": "IS", "Value": [350]},
        "2390": {"vr": "IS", "Value": [3913]},
        "2391": {"vr": "IS", "Value": [1079]},
        "2392": {"vr": "IS", "Value": [1007]},
        "2393": {"vr": "IS", "Value": [266]},
        "2394": {"vr": "IS", "Value": [2658]},
        "2395": {"vr": "IS", "Value": [3538]},
        "2396": {"vr": "IS", "Value": [1568]},
        "2397": {"vr": "IS", "Value": [3467]},
        "2398": {"vr": "IS", "Value": [3223]},
        "2399": {"vr": "IS", "Value": [3621]},
        "2400": {"vr": "IS", "Value": [3312]},
        "2401": {"vr": "IS", "Value": [1498]},
        "2402": {"vr": "IS", "Value": [3393]},
        "2403": {"vr": "IS", "Value": [2911]},
        "2404": {"vr": "IS", "Value": [2732]},
        "2405": {"vr": "IS", "Value": [2799]},
        "2406": {"vr": "IS", "Value": [586]},
        "2407": {"vr": "IS", "Value": [1220]},
        "2408": {"vr": "IS", "Value": [284]},
        "2409": {"vr": "IS", "Value": [1506]},
        "2410": {"vr": "IS", "Value": [3863]},
        "2411": {"vr": "IS", "Value": [2493]},
        "2412": {"vr": "IS", "Value": [2703]},
        "2413": {"vr": "IS", "Value": [3141]},
        "2414": {"vr": "IS", "Value": [2225]},
        "2415": {"vr": "IS", "Value": [419]},
        "2416": {"vr": "IS", "Value": [521]},
        "2417": {"vr": "IS", "Value": [3993]},
        "2418": {"vr": "IS", "Value": [2646]},
        "2419": {"vr": "IS", "Value": [1137]},
        "2420": {"vr": "IS", "Value": [2886]},
        "2421": {"vr": "IS", "Value": [2779]},
        "2422": {"vr": "IS", "Value": [2961]},
        "2423": {"vr": "IS", "Value": [173]},
        "2424": {"vr": "IS", "Value": [486]},
        "2425": {"vr": "IS", "Value": [2474]},
        "2426": {"vr": "IS", "Value": [218]},
        "2427": {"vr": "IS", "Value": [1031]},
        "2428": {"vr": "IS", "Value": [2349]},
        "2429": {"vr": "IS", "Value": [1780]},
        "2430": {"vr": "IS", "Value": [1663]},
        "2431": {"vr": "IS", "Value": [187]},
        "2432": {"vr": "IS", "Value": [229]},
        "2433": {"vr": "IS", "Value": [1356]},
        "2434": {"vr": "IS", "Value": [1250]},
        "2435": {"vr": "IS", "Value": [3653]},
        "2436": {"vr": "IS", "Value": [741]},
        "2437": {"vr": "IS", "Value": [2607]},
        "2438": {"vr": "IS", "Value": [437]},
        "2439": {"vr": "IS", "Value": [2547]},
        "2440": {"vr": "IS", "Value": [2373]},
        "2441": {"vr": "IS", "Value": [3453]},
        "2442": {"vr": "IS", "Value": [2819]},
        "2443": {"vr": "IS", "Value": [3085]},
        "2444": {"vr": "IS", "Value": [2415]},
        "2445": {"vr": "IS", "Value": [2801]},
        "2446": {"vr": "IS", "Value": [556]},
        "2447": {"vr": "IS", "Value": [1747]},
        "2448": {"vr": "IS", "Value": [3495]},
        "2449": {"vr": "IS", "Value": [231]},
        "2450": {"vr": "IS", "Value": [2906]},
        "2451": {"vr": "IS", "Value": [2186]},
        "2452": {"vr": "IS", "Value": [386]},
        "2453": {"vr": "IS", "Value": [1703]},
        "2454": {"vr": "IS", "Value": [3808]},
        "2455": {"vr": "IS", "Value": [1076]},
        "2456": {"vr": "IS", "Value": [2148]},
        "2457": {"vr": "IS", "Value": [2073]},
        "2458": {"vr": "IS", "Value": [2117]},
        "2459": {"vr": "IS", "Value": [3791]},
        "2460": {"vr": "IS", "Value": [1412]},
        "2461": {"vr": "IS", "Value": [1154]},
        "2462": {"vr": "IS", "Value": [3044]},
        "2463": {"vr": "IS", "Value": [3624]},
        "2464": {"vr": "IS", "Value": [3201]},
        "2465": {"vr": "IS", "Value": [2714]},
        "2466": {"vr": "IS", "Value": [1675]},
        "2467": {"vr": "IS", "Value": [2182]},
        "2468": {"vr": "IS", "Value": [3258]},
        "2469": {"vr": "IS", "Value": [1902]},
        "2470": {"vr": "IS", "Value": [729]},
        "2471": {"vr": "IS", "Value": [2618]},
        "2472": {"vr": "IS", "Value": [1890]},
        "2473": {"vr": "IS", "Value": [1203]},
        "2474": {"vr": "IS", "Value": [115]},
        "2475": {"vr": "IS", "Value": [2640]},
        "2476": {"vr": "IS", "Value": [2497]},
        "2477": {"vr": "IS", "Value": [3815]},
        "2478": {"vr": "IS", "Value": [509]},
        "2479": {"vr": "IS", "Value": [682]},
        "2480": {"vr": "IS", "Value": [3356]},
        "2481": {"vr": "IS", "Value": [3461]},
        "2482": {"vr": "IS", "Value": [1445]},
        "2483": {"vr": "IS", "Value": [3399]},
        "2484": {"vr": "IS", "Value": [474]},
        "2485": {"vr": "IS", "Value": [1215]},
        "2486": {"vr": "IS", "Value": [1246]},
        "2487": {"vr": "IS", "Value": [3297]},
        "2488": {"vr": "IS", "Value": [3833]},
        "2489": {"vr": "IS", "Value": [3741]},
        "2490": {"vr": "IS", "Value": [2851]},
        "2491": {"vr": "IS", "Value": [527]},
        "2492": {"vr": "IS", "Value": [2131]},
        "2493": {"vr": "IS", "Value": [2436]},
        "2494": {"vr": "IS", "Value": [3771]},
        "2495": {"vr": "IS", "Value": [1302]},
        "2496": {"vr": "IS", "Value": [802]},
        "2497": {"vr": "IS", "Value": [3391]},
        "2498": {"vr": "IS", "Value": [2725]},
        "2499": {"vr": "IS", "Value": [1467]},
        "2500": {"vr": "IS", "Value": [3521]},
        "2501": {"vr": "IS", "Value": [1860]},
        "2502": {"vr": "IS", "Value": [377]},
        "2503": {"vr": "IS", "Value": [3281]},
        "2504": {"vr": "IS", "Value": [864]},
        "2505": {"vr": "IS", "Value": [2754]},
        "2506": {"vr": "IS", "Value": [1501]},
        "2507": {"vr": "IS", "Value": [2612]},
        "2508": {"vr": "IS", "Value": [2385]},
        "2509": {"vr": "IS", "Value": [949]},
        "2510": {"vr": "IS", "Value": [2939]},
        "2511": {"vr": "IS", "Value": [1588]},
        "2512": {"vr": "IS", "Value": [2380]},
        "2513": {"vr": "IS", "Value": [3746]},
        "2514": {"vr": "IS", "Value": [1266]},
        "2515": {"vr": "IS", "Value": [351]},
        "2516": {"vr": "IS", "Value": [326]},
        "2517": {"vr": "IS", "Value": [3542]},
        "2518": {"vr": "IS", "Value": [1766]},
        "2519": {"vr": "IS", "Value": [1454]},
        "2520": {"vr": "IS", "Value": [2641]},
        "2521": {"vr": "IS", "Value": [3283]},
        "2522": {"vr": "IS", "Value": [3984]},
        "2523": {"vr": "IS", "Value": [438]},
        "2524": {"vr": "IS", "Value": [2187]},
        "2525": {"vr": "IS", "Value": [3977]},
        "2526": {"vr": "IS", "Value": [1222]},
        "2527": {"vr": "IS", "Value": [1204]},
        "2528": {"vr": "IS", "Value": [3411]},
        "2529": {"vr": "IS", "Value": [1415]},
        "2530": {"vr": "IS", "Value": [3175]},
        "2531": {"vr": "IS", "Value": [3054]},
        "2532": {"vr": "IS", "Value": [2374]},
        "2533": {"vr": "IS", "Value": [300]},
        "2534": {"vr": "IS", "Value": [2695]},
        "2535": {"vr": "IS", "Value": [2444]},
        "2536": {"vr": "IS", "Value": [1733]},
        "2537": {"vr": "IS", "Value": [2027]},
        "2538": {"vr": "IS", "Value": [2764]},
        "2539": {"vr": "IS", "Value": [3970]},
        "2540": {"vr": "IS", "Value": [3912]},
        "2541": {"vr": "IS", "Value": [2160]},
        "2542": {"vr": "IS", "Value": [1273]},
        "2543": {"vr": "IS", "Value": [3007]},
        "2544": {"vr": "IS", "Value": [589]},
        "2545": {"vr": "IS", "Value": [2355]},
        "2546": {"vr": "IS", "Value": [2666]},
        "2547": {"vr": "IS", "Value": [751]},
        "2548": {"vr": "IS", "Value": [1348]},
        "2549": {"vr": "IS", "Value": [2156]},
        "2550": {"vr": "IS", "Value": [3680]},
        "2551": {"vr": "IS", "Value": [3162]},
        "2552": {"vr": "IS", "Value": [3878]},
        "2553": {"vr": "IS", "Value": [407]},
        "2554": {"vr": "IS", "Value": [1177]},
        "2555": {"vr": "IS", "Value": [2479]},
        "2556": {"vr": "IS", "Value": [3596]},
        "2557": {"vr": "IS", "Value": [3319]},
        "2558": {"vr": "IS", "Value": [2277]},
        "2559": {"vr": "IS", "Value": [3361]},
        "2560": {"vr": "IS", "Value": [3756]},
        "2561": {"vr": "IS", "Value": [1726]},
        "2562": {"vr": "IS", "Value": [2534]},
        "2563": {"vr": "IS", "Value": [1453]},
        "2564": {"vr": "IS", "Value": [1000]},
        "2565": {"vr": "IS", "Value": [3451]},
        "2566": {"vr": "IS", "Value": [2977]},
        "2567": {"vr": "IS", "Value": [2627]},
        "2568": {"vr": "IS", "Value": [3790]},
        "2569": {"vr": "IS", "Value": [622]},
        "2570": {"vr": "IS", "Value": [3689]},
        "2571": {"vr": "IS", "Value": [671]},
        "2572": {"vr": "IS", "Value": [4013]},
        "2573": {"vr": "IS", "Value": [278]},
        "2574": {"vr": "IS", "Value": [2540]},
        "2575": {"vr": "IS", "Value": [429]},
        "2576": {"vr": "IS", "Value": [3116]},
        "2577": {"vr": "IS", "Value": [1244]},
        "2578": {"vr": "IS", "Value": [142]},
        "2579": {"vr": "IS", "Value": [70]},
        "2580": {"vr": "IS", "Value": [3941]},
        "2581": {"vr": "IS", "Value": [2051]},
        "2582": {"vr": "IS", "Value": [2097]},
        "2583": {"vr": "IS", "Value": [1647]},
        "2584": {"vr": "IS", "Value": [1353]},
        "2585": {"vr": "IS", "Value": [3351]},
        "2586": {"vr": "IS", "Value": [2579]},
        "2587": {"vr": "IS", "Value": [2949]},
        "2588": {"vr": "IS", "Value": [87]},
        "2589": {"vr": "IS", "Value": [3931]},
        "2590": {"vr": "IS", "Value": [2443]},
        "2591": {"vr": "IS", "Value": [3678]},
        "2592": {"vr": "IS", "Value": [1535]},
        "2593": {"vr": "IS", "Value": [1739]},
        "2594": {"vr": "IS", "Value": [1150]},
        "2595": {"vr": "IS", "Value": [3554]},
        "2596": {"vr": "IS", "Value": [1197]},
        "2597": {"vr": "IS", "Value": [3834]},
        "2598": {"vr": "IS", "Value": [1092]},
        "2599": {"vr": "IS", "Value": [2409]},
        "2600": {"vr": "IS", "Value": [3098]},
        "2601": {"vr": "IS", "Value": [3402]},
        "2602": {"vr": "IS", "Value": [1783]},
        "2603": {"vr": "IS", "Value": [3106]},
        "2604": {"vr": "IS", "Value": [3511]},
        "2605": {"vr": "IS", "Value": [2803]},
        "2606": {"vr": "IS", "Value": [3208]},
        "2607": {"vr": "IS", "Value": [2813]},
        "2608": {"vr": "IS", "Value": [3846]},
        "2609": {"vr": "IS", "Value": [2654]},
        "2610": {"vr": "IS", "Value": [1117]},
        "2611": {"vr": "IS", "Value": [1358]},
        "2612": {"vr": "IS", "Value": [878]},
        "2613": {"vr": "IS", "Value": [460]},
        "2614": {"vr": "IS", "Value": [2620]},
        "2615": {"vr": "IS", "Value": [3489]},
        "2616": {"vr": "IS", "Value": [1158]},
        "2617": {"vr": "IS", "Value": [2855]},
        "2618": {"vr": "IS", "Value": [2647]},
        "2619": {"vr": "IS", "Value": [1657]},
        "2620": {"vr": "IS", "Value": [1085]},
        "2621": {"vr": "IS", "Value": [2176]},
        "2622": {"vr": "IS", "Value": [3568]},
        "2623": {"vr": "IS", "Value": [3380]},
        "2624": {"vr": "IS", "Value": [3372]},
        "2625": {"vr": "IS", "Value": [1478]},
        "2626": {"vr": "IS", "Value": [3940]},
        "2627": {"vr": "IS", "Value": [3289]},
        "2628": {"vr": "IS", "Value": [3982]},
        "2629": {"vr": "IS", "Value": [705]},
        "2630": {"vr": "IS", "Value": [1868]},
        "2631": {"vr": "IS", "Value": [1785]},
        "2632": {"vr": "IS", "Value": [890]},
        "2633": {"vr": "IS", "Value": [1949]},
        "2634": {"vr": "IS", "Value": [1431]},
        "2635": {"vr": "IS", "Value": [216]},
        "2636": {"vr": "IS", "Value": [3305]},
        "2637": {"vr": "IS", "Value": [1831]},
        "2638": {"vr": "IS", "Value": [152]},
        "2639": {"vr": "IS", "Value": [2674]},
        "2640": {"vr": "IS", "Value": [31]},
        "2641": {"vr": "IS", "Value": [542]},
        "2642": {"vr": "IS", "Value": [1633]},
        "2643": {"vr": "IS", "Value": [3905]},
        "2644": {"vr": "IS", "Value": [2350]},
        "2645": {"vr": "IS", "Value": [3261]},
        "2646": {"vr": "IS", "Value": [2195]},
        "2647": {"vr": "IS", "Value": [2890]},
        "2648": {"vr": "IS", "Value": [2636]},
        "2649": {"vr": "IS", "Value": [783]},
        "2650": {"vr": "IS", "Value": [967]},
        "2651": {"vr": "IS", "Value": [1317]},
        "2652": {"vr": "IS", "Value": [610]},
        "2653": {"vr": "IS", "Value": [3703]},
        "2654": {"vr": "IS", "Value": [3212]},
        "2655": {"vr": "IS", "Value": [225]},
        "2656": {"vr": "IS", "Value": [525]},
        "2657": {"vr": "IS", "Value": [1029]},
        "2658": {"vr": "IS", "Value": [4005]},
        "2659": {"vr": "IS", "Value": [1449]},
        "2660": {"vr": "IS", "Value": [2800]},
        "2661": {"vr": "IS", "Value": [3478]},
        "2662": {"vr": "IS", "Value": [3702]},
        "2663": {"vr": "IS", "Value": [317]},
        "2664": {"vr": "IS", "Value": [446]},
        "2665": {"vr": "IS", "Value": [477]},
        "2666": {"vr": "IS", "Value": [3444]},
        "2667": {"vr": "IS", "Value": [1112]},
        "2668": {"vr": "IS", "Value": [418]},
        "2669": {"vr": "IS", "Value": [549]},
        "2670": {"vr": "IS", "Value": [1786]},
        "2671": {"vr": "IS", "Value": [1448]},
        "2672": {"vr": "IS", "Value": [3117]},
        "2673": {"vr": "IS", "Value": [727]},
        "2674": {"vr": "IS", "Value": [411]},
        "2675": {"vr": "IS", "Value": [523]},
        "2676": {"vr": "IS", "Value": [380]},
        "2677": {"vr": "IS", "Value": [1777]},
        "2678": {"vr": "IS", "Value": [3132]},
        "2679": {"vr": "IS", "Value": [2011]},
        "2680": {"vr": "IS", "Value": [59]},
        "2681": {"vr": "IS", "Value": [2845]},
        "2682": {"vr": "IS", "Value": [2137]},
        "2683": {"vr": "IS", "Value": [2980]},
        "2684": {"vr": "IS", "Value": [1643]},
        "2685": {"vr": "IS", "Value": [2619]},
        "2686": {"vr": "IS", "Value": [884]},
        "2687": {"vr": "IS", "Value": [2325]},
        "2688": {"vr": "IS", "Value": [2428]},
        "2689": {"vr": "IS", "Value": [1409]},
        "2690": {"vr": "IS", "Value": [1722]},
        "2691": {"vr": "IS", "Value": [551]},
        "2692": {"vr": "IS", "Value": [625]},
        "2693": {"vr": "IS", "Value": [2438]},
        "2694": {"vr": "IS", "Value": [3109]},
        "2695": {"vr": "IS", "Value": [2883]},
        "2696": {"vr": "IS", "Value": [522]},
        "2697": {"vr": "IS", "Value": [3720]},
        "2698": {"vr": "IS", "Value": [2450]},
        "2699": {"vr": "IS", "Value": [924]},
        "2700": {"vr": "IS", "Value": [186]},
        "2701": {"vr": "IS", "Value": [1596]},
        "2702": {"vr": "IS", "Value": [1377]},
        "2703": {"vr": "IS", "Value": [3814]},
        "2704": {"vr": "IS", "Value": [1573]},
        "2705": {"vr": "IS", "Value": [324]},
        "2706": {"vr": "IS", "Value": [769]},
        "2707": {"vr": "IS", "Value": [3605]},
        "2708": {"vr": "IS", "Value": [3490]},
        "2709": {"vr": "IS", "Value": [3287]},
        "2710": {"vr": "IS", "Value": [2466]},
        "2711": {"vr": "IS", "Value": [371]},
        "2712": {"vr": "IS", "Value": [1522]},
        "2713": {"vr": "IS", "Value": [3828]},
        "2714": {"vr": "IS", "Value": [3419]},
        "2715": {"vr": "IS", "Value": [2329]},
        "2716": {"vr": "IS", "Value": [2351]},
        "2717": {"vr": "IS", "Value": [1470]},
        "2718": {"vr": "IS", "Value": [71]},
        "2719": {"vr": "IS", "Value": [2256]},
        "2720": {"vr": "IS", "Value": [1382]},
        "2721": {"vr": "IS", "Value": [3698]},
        "2722": {"vr": "IS", "Value": [1419]},
        "2723": {"vr": "IS", "Value": [3916]},
        "2724": {"vr": "IS", "Value": [3073]},
        "2725": {"vr": "IS", "Value": [3016]},
        "2726": {"vr": "IS", "Value": [3340]},
        "2727": {"vr": "IS", "Value": [1659]},
        "2728": {"vr": "IS", "Value": [923]},
        "2729": {"vr": "IS", "Value": [1737]},
        "2730": {"vr": "IS", "Value": [2235]},
        "2731": {"vr": "IS", "Value": [1558]},
        "2732": {"vr": "IS", "Value": [3868]},
        "2733": {"vr": "IS", "Value": [3615]},
        "2734": {"vr": "IS", "Value": [1735]},
        "2735": {"vr": "IS", "Value": [590]},
        "2736": {"vr": "IS", "Value": [1999]},
        "2737": {"vr": "IS", "Value": [1688]},
        "2738": {"vr": "IS", "Value": [69]},
        "2739": {"vr": "IS", "Value": [2272]},
        "2740": {"vr": "IS", "Value": [1055]},
        "2741": {"vr": "IS", "Value": [3998]},
        "2742": {"vr": "IS", "Value": [3938]},
        "2743": {"vr": "IS", "Value": [3625]},
        "2744": {"vr": "IS", "Value": [2786]},
        "2745": {"vr": "IS", "Value": [170]},
        "2746": {"vr": "IS", "Value": [2684]},
        "2747": {"vr": "IS", "Value": [3152]},
        "2748": {"vr": "IS", "Value": [2333]},
        "2749": {"vr": "IS", "Value": [1433]},
        "2750": {"vr": "IS", "Value": [680]},
        "2751": {"vr": "IS", "Value": [3022]},
        "2752": {"vr": "IS", "Value": [901]},
        "2753": {"vr": "IS", "Value": [89]},
        "2754": {"vr": "IS", "Value": [3658]},
        "2755": {"vr": "IS", "Value": [941]},
        "2756": {"vr": "IS", "Value": [3418]},
        "2757": {"vr": "IS", "Value": [1364]},
        "2758": {"vr": "IS", "Value": [366]},
        "2759": {"vr": "IS", "Value": [632]},
        "2760": {"vr": "IS", "Value": [2382]},
        "2761": {"vr": "IS", "Value": [1669]},
        "2762": {"vr": "IS", "Value": [2596]},
        "2763": {"vr": "IS", "Value": [775]},
        "2764": {"vr": "IS", "Value": [406]},
        "2765": {"vr": "IS", "Value": [1984]},
        "2766": {"vr": "IS", "Value": [973]},
        "2767": {"vr": "IS", "Value": [2068]},
        "2768": {"vr": "IS", "Value": [2610]},
        "2769": {"vr": "IS", "Value": [489]},
        "2770": {"vr": "IS", "Value": [2664]},
        "2771": {"vr": "IS", "Value": [238]},
        "2772": {"vr": "IS", "Value": [552]},
        "2773": {"vr": "IS", "Value": [3431]},
        "2774": {"vr": "IS", "Value": [1684]},
        "2775": {"vr": "IS", "Value": [80]},
        "2776": {"vr": "IS", "Value": [445]},
        "2777": {"vr": "IS", "Value": [2657]},
        "2778": {"vr": "IS", "Value": [2060]},
        "2779": {"vr": "IS", "Value": [3027]},
        "2780": {"vr": "IS", "Value": [2275]},
        "2781": {"vr": "IS", "Value": [3992]},
        "2782": {"vr": "IS", "Value": [827]},
        "2783": {"vr": "IS", "Value": [536]},
        "2784": {"vr": "IS", "Value": [1619]},
        "2785": {"vr": "IS", "Value": [2052]},
        "2786": {"vr": "IS", "Value": [1880]},
        "2787": {"vr": "IS", "Value": [3754]},
        "2788": {"vr": "IS", "Value": [2343]},
        "2789": {"vr": "IS", "Value": [2604]},
        "2790": {"vr": "IS", "Value": [880]},
        "2791": {"vr": "IS", "Value": [2832]},
        "2792": {"vr": "IS", "Value": [3338]},
        "2793": {"vr": "IS", "Value": [3062]},
        "2794": {"vr": "IS", "Value": [1224]},
        "2795": {"vr": "IS", "Value": [961]},
        "2796": {"vr": "IS", "Value": [2217]},
        "2797": {"vr": "IS", "Value": [2683]},
        "2798": {"vr": "IS", "Value": [2955]},
        "2799": {"vr": "IS", "Value": [3426]},
        "2800": {"vr": "IS", "Value": [2722]},
        "2801": {"vr": "IS", "Value": [1560]},
        "2802": {"vr": "IS", "Value": [3668]},
        "2803": {"vr": "IS", "Value": [1826]},
        "2804": {"vr": "IS", "Value": [2229]},
        "2805": {"vr": "IS", "Value": [2578]},
        "2806": {"vr": "IS", "Value": [604]},
        "2807": {"vr": "IS", "Value": [3766]},
        "2808": {"vr": "IS", "Value": [3648]},
        "2809": {"vr": "IS", "Value": [1622]},
        "2810": {"vr": "IS", "Value": [2203]},
        "2811": {"vr": "IS", "Value": [3957]},
        "2812": {"vr": "IS", "Value": [1836]},
        "2813": {"vr": "IS", "Value": [1035]},
        "2814": {"vr": "IS", "Value": [311]},
        "2815": {"vr": "IS", "Value": [2274]},
        "2816": {"vr": "IS", "Value": [808]},
        "2817": {"vr": "IS", "Value": [2488]},
        "2818": {"vr": "IS", "Value": [1368]},
        "2819": {"vr": "IS", "Value": [3608]},
        "2820": {"vr": "IS", "Value": [1886]},
        "2821": {"vr": "IS", "Value": [3644]},
        "2822": {"vr": "IS", "Value": [2644]},
        "2823": {"vr": "IS", "Value": [3531]},
        "2824": {"vr": "IS", "Value": [3539]},
        "2825": {"vr": "IS", "Value": [1309]},
        "2826": {"vr": "IS", "Value": [322]},
        "2827": {"vr": "IS", "Value": [956]},
        "2828": {"vr": "IS", "Value": [3718]},
        "2829": {"vr": "IS", "Value": [3184]},
        "2830": {"vr": "IS", "Value": [2035]},
        "2831": {"vr": "IS", "Value": [3407]},
        "2832": {"vr": "IS", "Value": [2347]},
        "2833": {"vr": "IS", "Value": [1856]},
        "2834": {"vr": "IS", "Value": [2487]},
        "2835": {"vr": "IS", "Value": [1578]},
        "2836": {"vr": "IS", "Value": [2377]},
        "2837": {"vr": "IS", "Value": [743]},
        "2838": {"vr": "IS", "Value": [1283]},
        "2839": {"vr": "IS", "Value": [2179]},
        "2840": {"vr": "IS", "Value": [1745]},
        "2841": {"vr": "IS", "Value": [3096]},
        "2842": {"vr": "IS", "Value": [3031]},
        "2843": {"vr": "IS", "Value": [1789]},
        "2844": {"vr": "IS", "Value": [989]},
        "2845": {"vr": "IS", "Value": [1268]},
        "2846": {"vr": "IS", "Value": [1065]},
        "2847": {"vr": "IS", "Value": [3377]},
        "2848": {"vr": "IS", "Value": [3837]},
        "2849": {"vr": "IS", "Value": [3294]},
        "2850": {"vr": "IS", "Value": [2611]},
        "2851": {"vr": "IS", "Value": [3018]},
        "2852": {"vr": "IS", "Value": [1986]},
        "2853": {"vr": "IS", "Value": [910]},
        "2854": {"vr": "IS", "Value": [1208]},
        "2855": {"vr": "IS", "Value": [8]},
        "2856": {"vr": "IS", "Value": [1600]},
        "2857": {"vr": "IS", "Value": [1248]},
        "2858": {"vr": "IS", "Value": [1507]},
        "2859": {"vr": "IS", "Value": [2905]},
        "2860": {"vr": "IS", "Value": [3296]},
        "2861": {"vr": "IS", "Value": [1134]},
        "2862": {"vr": "IS", "Value": [19]},
        "2863": {"vr": "IS", "Value": [1958]},
        "2864": {"vr": "IS", "Value": [454]},
        "2865": {"vr": "IS", "Value": [3039]},
        "2866": {"vr": "IS", "Value": [1209]},
        "2867": {"vr": "IS", "Value": [2817]},
        "2868": {"vr": "IS", "Value": [3394]},
        "2869": {"vr": "IS", "Value": [1226]},
        "2870": {"vr": "IS", "Value": [895]},
        "2871": {"vr": "IS", "Value": [164]},
        "2872": {"vr": "IS", "Value": [3112]},
        "2873": {"vr": "IS", "Value": [2792]},
        "2874": {"vr": "IS", "Value": [1477]},
        "2875": {"vr": "IS", "Value": [3565]},
        "2876": {"vr": "IS", "Value": [1906]},
        "2877": {"vr": "IS", "Value": [2316]},
        "2878": {"vr": "IS", "Value": [3310]},
        "2879": {"vr": "IS", "Value": [2291]},
        "2880": {"vr": "IS", "Value": [2296]},
        "2881": {"vr": "IS", "Value": [1821]},
        "2882": {"vr": "IS", "Value": [706]},
        "2883": {"vr": "IS", "Value": [397]},
        "2884": {"vr": "IS", "Value": [316]},
        "2885": {"vr": "IS", "Value": [1466]},
        "2886": {"vr": "IS", "Value": [2228]},
        "2887": {"vr": "IS", "Value": [1624]},
        "2888": {"vr": "IS", "Value": [1618]},
        "2889": {"vr": "IS", "Value": [3858]},
        "2890": {"vr": "IS", "Value": [531]},
        "2891": {"vr": "IS", "Value": [822]},
        "2892": {"vr": "IS", "Value": [3252]},
        "2893": {"vr": "IS", "Value": [1221]},
        "2894": {"vr": "IS", "Value": [1919]},
        "2895": {"vr": "IS", "Value": [203]},
        "2896": {"vr": "IS", "Value": [3405]},
        "2897": {"vr": "IS", "Value": [1806]},
        "2898": {"vr": "IS", "Value": [2123]},
        "2899": {"vr": "IS", "Value": [1005]},
        "2900": {"vr": "IS", "Value": [2504]},
        "2901": {"vr": "IS", "Value": [448]},
        "2902": {"vr": "IS", "Value": [3620]},
        "2903": {"vr": "IS", "Value": [2558]},
        "2904": {"vr": "IS", "Value": [2465]},
        "2905": {"vr": "IS", "Value": [1088]},
        "2906": {"vr": "IS", "Value": [22]},
        "2907": {"vr": "IS", "Value": [3974]},
        "2908": {"vr": "IS", "Value": [547]},
        "2909": {"vr": "IS", "Value": [3758]},
        "2910": {"vr": "IS", "Value": [1206]},
        "2911": {"vr": "IS", "Value": [3610]},
        "2912": {"vr": "IS", "Value": [451]},
        "2913": {"vr": "IS", "Value": [1689]},
        "2914": {"vr": "IS", "Value": [576]},
        "2915": {"vr": "IS", "Value": [2212]},
        "2916": {"vr": "IS", "Value": [2004]},
        "2917": {"vr": "IS", "Value": [1199]},
        "2918": {"vr": "IS", "Value": [13]},
        "2919": {"vr": "IS", "Value": [3989]},
        "2920": {"vr": "IS", "Value": [2925]},
        "2921": {"vr": "IS", "Value": [2626]},
        "2922": {"vr": "IS", "Value": [2755]},
        "2923": {"vr": "IS", "Value": [2020]},
        "2924": {"vr": "IS", "Value": [2530]},
        "2925": {"vr": "IS", "Value": [360]},
        "2926": {"vr": "IS", "Value": [744]},
        "2927": {"vr": "IS", "Value": [3213]},
        "2928": {"vr": "IS", "Value": [1106]},
        "2929": {"vr": "IS", "Value": [103]},
        "2930": {"vr": "IS", "Value": [663]},
        "2931": {"vr": "IS", "Value": [3915]},
        "2932": {"vr": "IS", "Value": [3793]},
        "2933": {"vr": "IS", "Value": [578]},
        "2934": {"vr": "IS", "Value": [2344]},
        "2935": {"vr": "IS", "Value": [717]},
        "2936": {"vr": "IS", "Value": [2820]},
        "2937": {"vr": "IS", "Value": [3248]},
        "2938": {"vr": "IS", "Value": [3278]},
        "2939": {"vr": "IS", "Value": [1468]},
        "2940": {"vr": "IS", "Value": [1664]},
        "2941": {"vr": "IS", "Value": [942]},
        "2942": {"vr": "IS", "Value": [3447]},
        "2943": {"vr": "IS", "Value": [2745]},
        "2944": {"vr": "IS", "Value": [3645]},
        "2945": {"vr": "IS", "Value": [3937]},
        "2946": {"vr": "IS", "Value": [1334]},
        "2947": {"vr": "IS", "Value": [3284]},
        "2948": {"vr": "IS", "Value": [1852]},
        "2949": {"vr": "IS", "Value": [7]},
        "2950": {"vr": "IS", "Value": [773]},
        "2951": {"vr": "IS", "Value": [2420]},
        "2952": {"vr": "IS", "Value": [3639]},
        "2953": {"vr": "IS", "Value": [1616]},
        "2954": {"vr": "IS", "Value": [2001]},
        "2955": {"vr": "IS", "Value": [2693]},
        "2956": {"vr": "IS", "Value": [2909]},
        "2957": {"vr": "IS", "Value": [501]},
        "2958": {"vr": "IS", "Value": [596]},
        "2959": {"vr": "IS", "Value": [1064]},
        "2960": {"vr": "IS", "Value": [1164]},
        "2961": {"vr": "IS", "Value": [1084]},
        "2962": {"vr": "IS", "Value": [1069]},
        "2963": {"vr": "IS", "Value": [3446]},
        "2964": {"vr": "IS", "Value": [748]},
        "2965": {"vr": "IS", "Value": [3404]},
        "2966": {"vr": "IS", "Value": [1490]},
        "2967": {"vr": "IS", "Value": [382]},
        "2968": {"vr": "IS", "Value": [1355]},
        "2969": {"vr": "IS", "Value": [806]},
        "2970": {"vr": "IS", "Value": [3095]},
        "2971": {"vr": "IS", "Value": [3946]},
        "2972": {"vr": "IS", "Value": [3381]},
        "2973": {"vr": "IS", "Value": [2242]},
        "2974": {"vr": "IS", "Value": [824]},
        "2975": {"vr": "IS", "Value": [268]},
        "2976": {"vr": "IS", "Value": [1039]},
        "2977": {"vr": "IS", "Value": [2384]},
        "2978": {"vr": "IS", "Value": [584]},
        "2979": {"vr": "IS", "Value": [3178]},
        "2980": {"vr": "IS", "Value": [2124]},
        "2981": {"vr": "IS", "Value": [2960]},
        "2982": {"vr": "IS", "Value": [2439]},
        "2983": {"vr": "IS", "Value": [459]},
        "2984": {"vr": "IS", "Value": [3186]},
        "2985": {"vr": "IS", "Value": [1375]},
        "2986": {"vr": "IS", "Value": [1301]},
        "2987": {"vr": "IS", "Value": [2461]},
        "2988": {"vr": "IS", "Value": [2552]},
        "2989": {"vr": "IS", "Value": [3003]},
        "2990": {"vr": "IS", "Value": [182]},
        "2991": {"vr": "IS", "Value": [2721]},
        "2992": {"vr": "IS", "Value": [2554]},
        "2993": {"vr": "IS", "Value": [2150]},
        "2994": {"vr": "IS", "Value": [3102]},
        "2995": {"vr": "IS", "Value": [3479]},
        "2996": {"vr": "IS", "Value": [1776]},
        "2997": {"vr": "IS", "Value": [1123]},
        "2998": {"vr": "IS", "Value": [2258]},
        "2999": {"vr": "IS", "Value": [2103]},
        "3000": {"vr": "IS", "Value": [3148]},
        "3001": {"vr": "IS", "Value": [449]},
        "3002": {"vr": "IS", "Value": [3397]},
        "3003": {"vr": "IS", "Value": [2507]},
        "3004": {"vr": "IS", "Value": [2953]},
        "3005": {"vr": "IS", "Value": [3980]},
        "3006": {"vr": "IS", "Value": [2941]},
        "3007": {"vr": "IS", "Value": [3220]},
        "3008": {"vr": "IS", "Value": [365]},
        "3009": {"vr": "IS", "Value": [762]},
        "3010": {"vr": "IS", "Value": [2853]},
        "3011": {"vr": "IS", "Value": [1458]},
        "3012": {"vr": "IS", "Value": [1483]},
        "3013": {"vr": "IS", "Value": [867]},
        "3014": {"vr": "IS", "Value": [3843]},
        "3015": {"vr": "IS", "Value": [1662]},
        "3016": {"vr": "IS", "Value": [1881]},
        "3017": {"vr": "IS", "Value": [2243]},
        "3018": {"vr": "IS", "Value": [3514]},
        "3019": {"vr": "IS", "Value": [37]},
        "3020": {"vr": "IS", "Value": [1635]},
        "3021": {"vr": "IS", "Value": [2165]},
        "3022": {"vr": "IS", "Value": [1279]},
        "3023": {"vr": "IS", "Value": [2524]},
        "3024": {"vr": "IS", "Value": [2198]},
        "3025": {"vr": "IS", "Value": [3121]},
        "3026": {"vr": "IS", "Value": [83]},
        "3027": {"vr": "IS", "Value": [856]},
        "3028": {"vr": "IS", "Value": [1754]},
        "3029": {"vr": "IS", "Value": [2685]},
        "3030": {"vr": "IS", "Value": [3216]},
        "3031": {"vr": "IS", "Value": [3292]},
        "3032": {"vr": "IS", "Value": [3885]},
        "3033": {"vr": "IS", "Value": [614]},
        "3034": {"vr": "IS", "Value": [1146]},
        "3035": {"vr": "IS", "Value": [1503]},
        "3036": {"vr": "IS", "Value": [3466]},
        "3037": {"vr": "IS", "Value": [2293]},
        "3038": {"vr": "IS", "Value": [609]},
        "3039": {"vr": "IS", "Value": [603]},
        "3040": {"vr": "IS", "Value": [613]},
        "3041": {"vr": "IS", "Value": [1041]},
        "3042": {"vr": "IS", "Value": [2467]},
        "3043": {"vr": "IS", "Value": [3041]},
        "3044": {"vr": "IS", "Value": [3251]},
        "3045": {"vr": "IS", "Value": [518]},
        "3046": {"vr": "IS", "Value": [854]},
        "3047": {"vr": "IS", "Value": [1834]},
        "3048": {"vr": "IS", "Value": [1625]},
        "3049": {"vr": "IS", "Value": [3710]},
        "3050": {"vr": "IS", "Value": [2571]},
        "3051": {"vr": "IS", "Value": [2107]},
        "3052": {"vr": "IS", "Value": [937]},
        "3053": {"vr": "IS", "Value": [662]},
        "3054": {"vr": "IS", "Value": [3257]},
        "3055": {"vr": "IS", "Value": [275]},
        "3056": {"vr": "IS", "Value": [3569]},
        "3057": {"vr": "IS", "Value": [362]},
        "3058": {"vr": "IS", "Value": [893]},
        "3059": {"vr": "IS", "Value": [897]},
        "3060": {"vr": "IS", "Value": [2555]},
        "3061": {"vr": "IS", "Value": [1318]},
        "3062": {"vr": "IS", "Value": [3749]},
        "3063": {"vr": "IS", "Value": [3562]},
        "3064": {"vr": "IS", "Value": [1687]},
        "3065": {"vr": "IS", "Value": [2486]},
        "3066": {"vr": "IS", "Value": [2917]},
        "3067": {"vr": "IS", "Value": [2083]},
        "3068": {"vr": "IS", "Value": [2767]},
        "3069": {"vr": "IS", "Value": [2170]},
        "3070": {"vr": "IS", "Value": [3784]},
        "3071": {"vr": "IS", "Value": [2053]},
        "3072": {"vr": "IS", "Value": [2663]},
        "3073": {"vr": "IS", "Value": [1018]},
        "3074": {"vr": "IS", "Value": [672]},
        "3075": {"vr": "IS", "Value": [3886]},
        "3076": {"vr": "IS", "Value": [202]},
        "3077": {"vr": "IS", "Value": [2680]},
        "3078": {"vr": "IS", "Value": [2268]},
        "3079": {"vr": "IS", "Value": [1661]},
        "3080": {"vr": "IS", "Value": [264]},
        "3081": {"vr": "IS", "Value": [3401]},
        "3082": {"vr": "IS", "Value": [3548]},
        "3083": {"vr": "IS", "Value": [1463]},
        "3084": {"vr": "IS", "Value": [2250]},
        "3085": {"vr": "IS", "Value": [1461]},
        "3086": {"vr": "IS", "Value": [2240]},
        "3087": {"vr": "IS", "Value": [183]},
        "3088": {"vr": "IS", "Value": [2947]},
        "3089": {"vr": "IS", "Value": [40]},
        "3090": {"vr": "IS", "Value": [3602]},
        "3091": {"vr": "IS", "Value": [2429]},
        "3092": {"vr": "IS", "Value": [669]},
        "3093": {"vr": "IS", "Value": [1114]},
        "3094": {"vr": "IS", "Value": [3110]},
        "3095": {"vr": "IS", "Value": [3066]},
        "3096": {"vr": "IS", "Value": [2348]},
        "3097": {"vr": "IS", "Value": [2044]},
        "3098": {"vr": "IS", "Value": [1716]},
        "3099": {"vr": "IS", "Value": [1305]},
        "3100": {"vr": "IS", "Value": [912]},
        "3101": {"vr": "IS", "Value": [1213]},
        "3102": {"vr": "IS", "Value": [2686]},
        "3103": {"vr": "IS", "Value": [2616]},
        "3104": {"vr": "IS", "Value": [2476]},
        "3105": {"vr": "IS", "Value": [1615]},
        "3106": {"vr": "IS", "Value": [1121]},
        "3107": {"vr": "IS", "Value": [3597]},
        "3108": {"vr": "IS", "Value": [3921]},
        "3109": {"vr": "IS", "Value": [3800]},
        "3110": {"vr": "IS", "Value": [1527]},
        "3111": {"vr": "IS", "Value": [1217]},
        "3112": {"vr": "IS", "Value": [1243]},
        "3113": {"vr": "IS", "Value": [3000]},
        "3114": {"vr": "IS", "Value": [1186]},
        "3115": {"vr": "IS", "Value": [108]},
        "3116": {"vr": "IS", "Value": [722]},
        "3117": {"vr": "IS", "Value": [1513]},
        "3118": {"vr": "IS", "Value": [1539]},
        "3119": {"vr": "IS", "Value": [645]},
        "3120": {"vr": "IS", "Value": [3826]},
        "3121": {"vr": "IS", "Value": [1499]},
        "3122": {"vr": "IS", "Value": [514]},
        "3123": {"vr": "IS", "Value": [3233]},
        "3124": {"vr": "IS", "Value": [194]},
        "3125": {"vr": "IS", "Value": [3100]},
        "3126": {"vr": "IS", "Value": [3256]},
        "3127": {"vr": "IS", "Value": [2789]},
        "3128": {"vr": "IS", "Value": [3232]},
        "3129": {"vr": "IS", "Value": [347]},
        "3130": {"vr": "IS", "Value": [1172]},
        "3131": {"vr": "IS", "Value": [1388]},
        "3132": {"vr": "IS", "Value": [15]},
        "3133": {"vr": "IS", "Value": [2849]},
        "3134": {"vr": "IS", "Value": [2172]},
        "3135": {"vr": "IS", "Value": [3498]},
        "3136": {"vr": "IS", "Value": [196]},
        "3137": {"vr": "IS", "Value": [3684]},
        "3138": {"vr": "IS", "Value": [308]},
        "3139": {"vr": "IS", "Value": [155]},
        "3140": {"vr": "IS", "Value": [2226]},
        "3141": {"vr": "IS", "Value": [1147]},
        "3142": {"vr": "IS", "Value": [3366]},
        "3143": {"vr": "IS", "Value": [513]},
        "3144": {"vr": "IS", "Value": [888]},
        "3145": {"vr": "IS", "Value": [124]},
        "3146": {"vr": "IS", "Value": [2085]},
        "3147": {"vr": "IS", "Value": [873]},
        "3148": {"vr": "IS", "Value": [1119]},
        "3149": {"vr": "IS", "Value": [2760]},
        "3150": {"vr": "IS", "Value": [2221]},
        "3151": {"vr": "IS", "Value": [768]},
        "3152": {"vr": "IS", "Value": [2386]},
        "3153": {"vr": "IS", "Value": [3167]},
        "3154": {"vr": "IS", "Value": [1082]},
        "3155": {"vr": "IS", "Value": [3763]},
        "3156": {"vr": "IS", "Value": [902]},
        "3157": {"vr": "IS", "Value": [3113]},
        "3158": {"vr": "IS", "Value": [2122]},
        "3159": {"vr": "IS", "Value": [1093]},
        "3160": {"vr": "IS", "Value": [41]},
        "3161": {"vr": "IS", "Value": [1967]},
        "3162": {"vr": "IS", "Value": [1817]},
        "3163": {"vr": "IS", "Value": [379]},
        "3164": {"vr": "IS", "Value": [1004]},
        "3165": {"vr": "IS", "Value": [24]},
        "3166": {"vr": "IS", "Value": [620]},
        "3167": {"vr": "IS", "Value": [570]},
        "3168": {"vr": "IS", "Value": [3135]},
        "3169": {"vr": "IS", "Value": [1977]},
        "3170": {"vr": "IS", "Value": [3897]},
        "3171": {"vr": "IS", "Value": [2140]},
        "3172": {"vr": "IS", "Value": [3983]},
        "3173": {"vr": "IS", "Value": [3420]},
        "3174": {"vr": "IS", "Value": [1257]},
        "3175": {"vr": "IS", "Value": [1955]},
        "3176": {"vr": "IS", "Value": [3951]},
        "3177": {"vr": "IS", "Value": [1686]},
        "3178": {"vr": "IS", "Value": [2454]},
        "3179": {"vr": "IS", "Value": [1561]},
        "3180": {"vr": "IS", "Value": [3126]},
        "3181": {"vr": "IS", "Value": [3204]},
        "3182": {"vr": "IS", "Value": [3151]},
        "3183": {"vr": "IS", "Value": [1107]},
        "3184": {"vr": "IS", "Value": [605]},
        "3185": {"vr": "IS", "Value": [3222]},
        "3186": {"vr": "IS", "Value": [2898]},
        "3187": {"vr": "IS", "Value": [1708]},
        "3188": {"vr": "IS", "Value": [1068]},
        "3189": {"vr": "IS", "Value": [1080]},
        "3190": {"vr": "IS", "Value": [3560]},
        "3191": {"vr": "IS", "Value": [3288]},
        "3192": {"vr": "IS", "Value": [2520]},
        "3193": {"vr": "IS", "Value": [2030]},
        "3194": {"vr": "IS", "Value": [45]},
        "3195": {"vr": "IS", "Value": [1750]},
        "3196": {"vr": "IS", "Value": [640]},
        "3197": {"vr": "IS", "Value": [3122]},
        "3198": {"vr": "IS", "Value": [2059]},
        "3199": {"vr": "IS", "Value": [1582]},
        "3200": {"vr": "IS", "Value": [93]},
        "3201": {"vr": "IS", "Value": [3083]},
        "3202": {"vr": "IS", "Value": [3918]},
        "3203": {"vr": "IS", "Value": [1857]},
        "3204": {"vr": "IS", "Value": [1874]},
        "3205": {"vr": "IS", "Value": [3867]},
        "3206": {"vr": "IS", "Value": [561]},
        "3207": {"vr": "IS", "Value": [1570]},
        "3208": {"vr": "IS", "Value": [1718]},
        "3209": {"vr": "IS", "Value": [2935]},
        "3210": {"vr": "IS", "Value": [554]},
        "3211": {"vr": "IS", "Value": [2326]},
        "3212": {"vr": "IS", "Value": [1978]},
        "3213": {"vr": "IS", "Value": [3270]},
        "3214": {"vr": "IS", "Value": [4020]},
        "3215": {"vr": "IS", "Value": [3571]},
        "3216": {"vr": "IS", "Value": [2758]},
        "3217": {"vr": "IS", "Value": [495]},
        "3218": {"vr": "IS", "Value": [1]},
        "3219": {"vr": "IS", "Value": [1060]},
        "3220": {"vr": "IS", "Value": [2088]},
        "3221": {"vr": "IS", "Value": [813]},
        "3222": {"vr": "IS", "Value": [3483]},
        "3223": {"vr": "IS", "Value": [1505]},
        "3224": {"vr": "IS", "Value": [120]},
        "3225": {"vr": "IS", "Value": [2605]},
        "3226": {"vr": "IS", "Value": [2566]},
        "3227": {"vr": "IS", "Value": [1052]},
        "3228": {"vr": "IS", "Value": [2893]},
        "3229": {"vr": "IS", "Value": [494]},
        "3230": {"vr": "IS", "Value": [1327]},
        "3231": {"vr": "IS", "Value": [2780]},
        "3232": {"vr": "IS", "Value": [1038]},
        "3233": {"vr": "IS", "Value": [3792]},
        "3234": {"vr": "IS", "Value": [1108]},
        "3235": {"vr": "IS", "Value": [2624]},
        "3236": {"vr": "IS", "Value": [1524]},
        "3237": {"vr": "IS", "Value": [1798]},
        "3238": {"vr": "IS", "Value": [3532]},
        "3239": {"vr": "IS", "Value": [3206]},
        "3240": {"vr": "IS", "Value": [3919]},
        "3241": {"vr": "IS", "Value": [2982]},
        "3242": {"vr": "IS", "Value": [981]},
        "3243": {"vr": "IS", "Value": [2021]},
        "3244": {"vr": "IS", "Value": [574]},
        "3245": {"vr": "IS", "Value": [67]},
        "3246": {"vr": "IS", "Value": [3425]},
        "3247": {"vr": "IS", "Value": [1720]},
        "3248": {"vr": "IS", "Value": [2567]},
        "3249": {"vr": "IS", "Value": [1491]},
        "3250": {"vr": "IS", "Value": [3463]},
        "3251": {"vr": "IS", "Value": [2327]},
        "3252": {"vr": "IS", "Value": [2310]},
        "3253": {"vr": "IS", "Value": [3209]},
        "3254": {"vr": "IS", "Value": [3364]},
        "3255": {"vr": "IS", "Value": [3947]},
        "3256": {"vr": "IS", "Value": [2665]},
        "3257": {"vr": "IS", "Value": [3153]},
        "3258": {"vr": "IS", "Value": [1993]},
        "3259": {"vr": "IS", "Value": [335]},
        "3260": {"vr": "IS", "Value": [2252]},
        "3261": {"vr": "IS", "Value": [1627]},
        "3262": {"vr": "IS", "Value": [1692]},
        "3263": {"vr": "IS", "Value": [1281]},
        "3264": {"vr": "IS", "Value": [2023]},
        "3265": {"vr": "IS", "Value": [3524]},
        "3266": {"vr": "IS", "Value": [3631]},
        "3267": {"vr": "IS", "Value": [1730]},
        "3268": {"vr": "IS", "Value": [1313]},
        "3269": {"vr": "IS", "Value": [2952]},
        "3270": {"vr": "IS", "Value": [3986]},
        "3271": {"vr": "IS", "Value": [1071]},
        "3272": {"vr": "IS", "Value": [3700]},
        "3273": {"vr": "IS", "Value": [3866]},
        "3274": {"vr": "IS", "Value": [3927]},
        "3275": {"vr": "IS", "Value": [944]},
        "3276": {"vr": "IS", "Value": [1010]},
        "3277": {"vr": "IS", "Value": [2262]},
        "3278": {"vr": "IS", "Value": [3472]},
        "3279": {"vr": "IS", "Value": [3427]},
        "3280": {"vr": "IS", "Value": [1343]},
        "3281": {"vr": "IS", "Value": [1048]},
        "3282": {"vr": "IS", "Value": [1287]},
        "3283": {"vr": "IS", "Value": [587]},
        "3284": {"vr": "IS", "Value": [2790]},
        "3285": {"vr": "IS", "Value": [2304]},
        "3286": {"vr": "IS", "Value": [2477]},
        "3287": {"vr": "IS", "Value": [3390]},
        "3288": {"vr": "IS", "Value": [1103]},
        "3289": {"vr": "IS", "Value": [597]},
        "3290": {"vr": "IS", "Value": [588]},
        "3291": {"vr": "IS", "Value": [2337]},
        "3292": {"vr": "IS", "Value": [3798]},
        "3293": {"vr": "IS", "Value": [1917]},
        "3294": {"vr": "IS", "Value": [2188]},
        "3295": {"vr": "IS", "Value": [2498]},
        "3296": {"vr": "IS", "Value": [999]},
        "3297": {"vr": "IS", "Value": [1012]},
        "3298": {"vr": "IS", "Value": [1510]},
        "3299": {"vr": "IS", "Value": [538]},
        "3300": {"vr": "IS", "Value": [1799]},
        "3301": {"vr": "IS", "Value": [1916]},
        "3302": {"vr": "IS", "Value": [2494]},
        "3303": {"vr": "IS", "Value": [3956]},
        "3304": {"vr": "IS", "Value": [825]},
        "3305": {"vr": "IS", "Value": [1778]},
        "3306": {"vr": "IS", "Value": [3699]},
        "3307": {"vr": "IS", "Value": [357]},
        "3308": {"vr": "IS", "Value": [1214]},
        "3309": {"vr": "IS", "Value": [2841]},
        "3310": {"vr": "IS", "Value": [328]},
        "3311": {"vr": "IS", "Value": [1401]},
        "3312": {"vr": "IS", "Value": [2453]},
        "3313": {"vr": "IS", "Value": [82]},
        "3314": {"vr": "IS", "Value": [1858]},
        "3315": {"vr": "IS", "Value": [2039]},
        "3316": {"vr": "IS", "Value": [899]},
        "3317": {"vr": "IS", "Value": [3576]},
        "3318": {"vr": "IS", "Value": [2134]},
        "3319": {"vr": "IS", "Value": [3225]},
        "3320": {"vr": "IS", "Value": [3717]},
        "3321": {"vr": "IS", "Value": [2985]},
        "3322": {"vr": "IS", "Value": [2541]},
        "3323": {"vr": "IS", "Value": [2215]},
        "3324": {"vr": "IS", "Value": [1972]},
        "3325": {"vr": "IS", "Value": [886]},
        "3326": {"vr": "IS", "Value": [1489]},
        "3327": {"vr": "IS", "Value": [1787]},
        "3328": {"vr": "IS", "Value": [3336]},
        "3329": {"vr": "IS", "Value": [1190]},
        "3330": {"vr": "IS", "Value": [287]},
        "3331": {"vr": "IS", "Value": [3928]},
        "3332": {"vr": "IS", "Value": [3632]},
        "3333": {"vr": "IS", "Value": [1187]},
        "3334": {"vr": "IS", "Value": [2376]},
        "3335": {"vr": "IS", "Value": [1896]},
        "3336": {"vr": "IS", "Value": [652]},
        "3337": {"vr": "IS", "Value": [62]},
        "3338": {"vr": "IS", "Value": [792]},
        "3339": {"vr": "IS", "Value": [2442]},
        "3340": {"vr": "IS", "Value": [1802]},
        "3341": {"vr": "IS", "Value": [2600]},
        "3342": {"vr": "IS", "Value": [3196]},
        "3343": {"vr": "IS", "Value": [2040]},
        "3344": {"vr": "IS", "Value": [149]},
        "3345": {"vr": "IS", "Value": [2427]},
        "3346": {"vr": "IS", "Value": [3508]},
        "3347": {"vr": "IS", "Value": [1372]},
        "3348": {"vr": "IS", "Value": [1586]},
        "3349": {"vr": "IS", "Value": [3737]},
        "3350": {"vr": "IS", "Value": [782]},
        "3351": {"vr": "IS", "Value": [504]},
        "3352": {"vr": "IS", "Value": [1027]},
        "3353": {"vr": "IS", "Value": [3408]},
        "3354": {"vr": "IS", "Value": [1614]},
        "3355": {"vr": "IS", "Value": [1980]},
        "3356": {"vr": "IS", "Value": [2109]},
        "3357": {"vr": "IS", "Value": [197]},
        "3358": {"vr": "IS", "Value": [1163]},
        "3359": {"vr": "IS", "Value": [3551]},
        "3360": {"vr": "IS", "Value": [3460]},
        "3361": {"vr": "IS", "Value": [1534]},
        "3362": {"vr": "IS", "Value": [1752]},
        "3363": {"vr": "IS", "Value": [3475]},
        "3364": {"vr": "IS", "Value": [3081]},
        "3365": {"vr": "IS", "Value": [3971]},
        "3366": {"vr": "IS", "Value": [3764]},
        "3367": {"vr": "IS", "Value": [3526]},
        "3368": {"vr": "IS", "Value": [817]},
        "3369": {"vr": "IS", "Value": [3050]},
        "3370": {"vr": "IS", "Value": [2720]},
        "3371": {"vr": "IS", "Value": [1693]},
        "3372": {"vr": "IS", "Value": [3086]},
        "3373": {"vr": "IS", "Value": [2837]},
        "3374": {"vr": "IS", "Value": [2300]},
        "3375": {"vr": "IS", "Value": [2979]},
        "3376": {"vr": "IS", "Value": [1380]},
        "3377": {"vr": "IS", "Value": [3154]},
        "3378": {"vr": "IS", "Value": [1557]},
        "3379": {"vr": "IS", "Value": [2066]},
        "3380": {"vr": "IS", "Value": [1050]},
        "3381": {"vr": "IS", "Value": [2918]},
        "3382": {"vr": "IS", "Value": [2038]},
        "3383": {"vr": "IS", "Value": [395]},
        "3384": {"vr": "IS", "Value": [2006]},
        "3385": {"vr": "IS", "Value": [1230]},
        "3386": {"vr": "IS", "Value": [2833]},
        "3387": {"vr": "IS", "Value": [3926]},
        "3388": {"vr": "IS", "Value": [1905]},
        "3389": {"vr": "IS", "Value": [3318]},
        "3390": {"vr": "IS", "Value": [3373]},
        "3391": {"vr": "IS", "Value": [1284]},
        "3392": {"vr": "IS", "Value": [1097]},
        "3393": {"vr": "IS", "Value": [1969]},
        "3394": {"vr": "IS", "Value": [314]},
        "3395": {"vr": "IS", "Value": [2835]},
        "3396": {"vr": "IS", "Value": [838]},
        "3397": {"vr": "IS", "Value": [1232]},
        "3398": {"vr": "IS", "Value": [606]},
        "3399": {"vr": "IS", "Value": [2974]},
        "3400": {"vr": "IS", "Value": [2121]},
        "3401": {"vr": "IS", "Value": [1909]},
        "3402": {"vr": "IS", "Value": [2463]},
        "3403": {"vr": "IS", "Value": [1544]},
        "3404": {"vr": "IS", "Value": [1122]},
        "3405": {"vr": "IS", "Value": [1987]},
        "3406": {"vr": "IS", "Value": [3077]},
        "3407": {"vr": "IS", "Value": [815]},
        "3408": {"vr": "IS", "Value": [507]},
        "3409": {"vr": "IS", "Value": [2761]},
        "3410": {"vr": "IS", "Value": [2419]},
        "3411": {"vr": "IS", "Value": [2934]},
        "3412": {"vr": "IS", "Value": [3601]},
        "3413": {"vr": "IS", "Value": [3744]},
        "3414": {"vr": "IS", "Value": [3192]},
        "3415": {"vr": "IS", "Value": [3396]},
        "3416": {"vr": "IS", "Value": [1753]},
        "3417": {"vr": "IS", "Value": [2576]},
        "3418": {"vr": "IS", "Value": [159]},
        "3419": {"vr": "IS", "Value": [3437]},
        "3420": {"vr": "IS", "Value": [997]},
        "3421": {"vr": "IS", "Value": [541]},
        "3422": {"vr": "IS", "Value": [3584]},
        "3423": {"vr": "IS", "Value": [3734]},
        "3424": {"vr": "IS", "Value": [2089]},
        "3425": {"vr": "IS", "Value": [1968]},
        "3426": {"vr": "IS", "Value": [3429]},
        "3427": {"vr": "IS", "Value": [2516]},
        "3428": {"vr": "IS", "Value": [1794]},
        "3429": {"vr": "IS", "Value": [1844]},
        "3430": {"vr": "IS", "Value": [2405]},
        "3431": {"vr": "IS", "Value": [3348]},
        "3432": {"vr": "IS", "Value": [482]},
        "3433": {"vr": "IS", "Value": [441]},
        "3434": {"vr": "IS", "Value": [3006]},
        "3435": {"vr": "IS", "Value": [2814]},
        "3436": {"vr": "IS", "Value": [3311]},
        "3437": {"vr": "IS", "Value": [3500]},
        "3438": {"vr": "IS", "Value": [1239]},
        "3439": {"vr": "IS", "Value": [2591]},
        "3440": {"vr": "IS", "Value": [3084]},
        "3441": {"vr": "IS", "Value": [3245]},
        "3442": {"vr": "IS", "Value": [2804]},
        "3443": {"vr": "IS", "Value": [3518]},
        "3444": {"vr": "IS", "Value": [2047]},
        "3445": {"vr": "IS", "Value": [178]},
        "3446": {"vr": "IS", "Value": [34]},
        "3447": {"vr": "IS", "Value": [3663]},
        "3448": {"vr": "IS", "Value": [1803]},
        "3449": {"vr": "IS", "Value": [1598]},
        "3450": {"vr": "IS", "Value": [3063]},
        "3451": {"vr": "IS", "Value": [2196]},
        "3452": {"vr": "IS", "Value": [1417]},
        "3453": {"vr": "IS", "Value": [1644]},
        "3454": {"vr": "IS", "Value": [1346]},
        "3455": {"vr": "IS", "Value": [526]},
        "3456": {"vr": "IS", "Value": [1800]},
        "3457": {"vr": "IS", "Value": [3001]},
        "3458": {"vr": "IS", "Value": [2452]},
        "3459": {"vr": "IS", "Value": [3638]},
        "3460": {"vr": "IS", "Value": [2394]},
        "3461": {"vr": "IS", "Value": [580]},
        "3462": {"vr": "IS", "Value": [1171]},
        "3463": {"vr": "IS", "Value": [2572]},
        "3464": {"vr": "IS", "Value": [3852]},
        "3465": {"vr": "IS", "Value": [2563]},
        "3466": {"vr": "IS", "Value": [1469]},
        "3467": {"vr": "IS", "Value": [3476]},
        "3468": {"vr": "IS", "Value": [1306]},
        "3469": {"vr": "IS", "Value": [877]},
        "3470": {"vr": "IS", "Value": [2491]},
        "3471": {"vr": "IS", "Value": [2430]},
        "3472": {"vr": "IS", "Value": [3497]},
        "3473": {"vr": "IS", "Value": [368]},
        "3474": {"vr": "IS", "Value": [699]},
        "3475": {"vr": "IS", "Value": [1746]},
        "3476": {"vr": "IS", "Value": [256]},
        "3477": {"vr": "IS", "Value": [118]},
        "3478": {"vr": "IS", "Value": [3537]},
        "3479": {"vr": "IS", "Value": [2363]},
        "3480": {"vr": "IS", "Value": [807]},
        "3481": {"vr": "IS", "Value": [3994]},
        "3482": {"vr": "IS", "Value": [3123]},
        "3483": {"vr": "IS", "Value": [3513]},
        "3484": {"vr": "IS", "Value": [3545]},
        "3485": {"vr": "IS", "Value": [2564]},
        "3486": {"vr": "IS", "Value": [3067]},
        "3487": {"vr": "IS", "Value": [3907]},
        "3488": {"vr": "IS", "Value": [219]},
        "3489": {"vr": "IS", "Value": [2964]},
        "3490": {"vr": "IS", "Value": [352]},
        "3491": {"vr": "IS", "Value": [3452]},
        "3492": {"vr": "IS", "Value": [1329]},
        "3493": {"vr": "IS", "Value": [3723]},
        "3494": {"vr": "IS", "Value": [2338]},
        "3495": {"vr": "IS", "Value": [2965]},
        "3496": {"vr": "IS", "Value": [1667]},
        "3497": {"vr": "IS", "Value": [2550]},
        "3498": {"vr": "IS", "Value": [3303]},
        "3499": {"vr": "IS", "Value": [1601]},
        "3500": {"vr": "IS", "Value": [3183]},
        "3501": {"vr": "IS", "Value": [2033]},
        "3502": {"vr": "IS", "Value": [2046]},
        "3503": {"vr": "IS", "Value": [3342]},
        "3504": {"vr": "IS", "Value": [199]},
        "3505": {"vr": "IS", "Value": [1184]},
        "3506": {"vr": "IS", "Value": [1504]},
        "3507": {"vr": "IS", "Value": [2233]},
        "3508": {"vr": "IS", "Value": [3147]},
        "3509": {"vr": "IS", "Value": [2733]},
        "3510": {"vr": "IS", "Value": [2080]},
        "3511": {"vr": "IS", "Value": [52]},
        "3512": {"vr": "IS", "Value": [1701]},
        "3513": {"vr": "IS", "Value": [2360]},
        "3514": {"vr": "IS", "Value": [3592]},
        "3515": {"vr": "IS", "Value": [2095]},
        "3516": {"vr": "IS", "Value": [111]},
        "3517": {"vr": "IS", "Value": [3671]},
        "3518": {"vr": "IS", "Value": [921]},
        "3519": {"vr": "IS", "Value": [2128]},
        "3520": {"vr": "IS", "Value": [2825]},
        "3521": {"vr": "IS", "Value": [4008]},
        "3522": {"vr": "IS", "Value": [2]},
        "3523": {"vr": "IS", "Value": [3865]},
        "3524": {"vr": "IS", "Value": [2593]},
        "3525": {"vr": "IS", "Value": [1948]},
        "3526": {"vr": "IS", "Value": [1430]},
        "3527": {"vr": "IS", "Value": [3740]},
        "3528": {"vr": "IS", "Value": [1089]},
        "3529": {"vr": "IS", "Value": [3990]},
        "3530": {"vr": "IS", "Value": [1205]},
        "3531": {"vr": "IS", "Value": [563]},
        "3532": {"vr": "IS", "Value": [1328]},
        "3533": {"vr": "IS", "Value": [1299]},
        "3534": {"vr": "IS", "Value": [3561]},
        "3535": {"vr": "IS", "Value": [2877]},
        "3536": {"vr": "IS", "Value": [829]},
        "3537": {"vr": "IS", "Value": [428]},
        "3538": {"vr": "IS", "Value": [2797]},
        "3539": {"vr": "IS", "Value": [3995]},
        "3540": {"vr": "IS", "Value": [2286]},
        "3541": {"vr": "IS", "Value": [2824]},
        "3542": {"vr": "IS", "Value": [1130]},
        "3543": {"vr": "IS", "Value": [1607]},
        "3544": {"vr": "IS", "Value": [1822]},
        "3545": {"vr": "IS", "Value": [1443]},
        "3546": {"vr": "IS", "Value": [1931]},
        "3547": {"vr": "IS", "Value": [1418]},
        "3548": {"vr": "IS", "Value": [2391]},
        "3549": {"vr": "IS", "Value": [426]},
        "3550": {"vr": "IS", "Value": [2587]},
        "3551": {"vr": "IS", "Value": [458]},
        "3552": {"vr": "IS", "Value": [3641]},
        "3553": {"vr": "IS", "Value": [1850]},
        "3554": {"vr": "IS", "Value": [1408]},
        "3555": {"vr": "IS", "Value": [1769]},
        "3556": {"vr": "IS", "Value": [1201]},
        "3557": {"vr": "IS", "Value": [1006]},
        "3558": {"vr": "IS", "Value": [401]},
        "3559": {"vr": "IS", "Value": [2222]},
        "3560": {"vr": "IS", "Value": [1748]},
        "3561": {"vr": "IS", "Value": [3015]},
        "3562": {"vr": "IS", "Value": [1569]},
        "3563": {"vr": "IS", "Value": [2932]},
        "3564": {"vr": "IS", "Value": [1676]},
        "3565": {"vr": "IS", "Value": [3293]},
        "3566": {"vr": "IS", "Value": [2236]},
        "3567": {"vr": "IS", "Value": [381]},
        "3568": {"vr": "IS", "Value": [140]},
        "3569": {"vr": "IS", "Value": [785]},
        "3570": {"vr": "IS", "Value": [1285]},
        "3571": {"vr": "IS", "Value": [297]},
        "3572": {"vr": "IS", "Value": [2224]},
        "3573": {"vr": "IS", "Value": [250]},
        "3574": {"vr": "IS", "Value": [492]},
        "3575": {"vr": "IS", "Value": [701]},
        "3576": {"vr": "IS", "Value": [2613]},
        "3577": {"vr": "IS", "Value": [1838]},
        "3578": {"vr": "IS", "Value": [601]},
        "3579": {"vr": "IS", "Value": [1962]},
        "3580": {"vr": "IS", "Value": [3733]},
        "3581": {"vr": "IS", "Value": [3197]},
        "3582": {"vr": "IS", "Value": [2118]},
        "3583": {"vr": "IS", "Value": [3930]},
        "3584": {"vr": "IS", "Value": [753]},
        "3585": {"vr": "IS", "Value": [2219]},
        "3586": {"vr": "IS", "Value": [3552]},
        "3587": {"vr": "IS", "Value": [3528]},
        "3588": {"vr": "IS", "Value": [1574]},
        "3589": {"vr": "IS", "Value": [3350]},
        "3590": {"vr": "IS", "Value": [1421]},
        "3591": {"vr": "IS", "Value": [3157]},
        "3592": {"vr": "IS", "Value": [1593]},
        "3593": {"vr": "IS", "Value": [3280]},
        "3594": {"vr": "IS", "Value": [3080]},
        "3595": {"vr": "IS", "Value": [908]},
        "3596": {"vr": "IS", "Value": [1370]},
        "3597": {"vr": "IS", "Value": [976]},
        "3598": {"vr": "IS", "Value": [1337]},
        "3599": {"vr": "IS", "Value": [228]},
        "3600": {"vr": "IS", "Value": [2588]},
        "3601": {"vr": "IS", "Value": [2999]},
        "3602": {"vr": "IS", "Value": [1854]},
        "3603": {"vr": "IS", "Value": [1253]},
        "3604": {"vr": "IS", "Value": [1599]},
        "3605": {"vr": "IS", "Value": [1717]},
        "3606": {"vr": "IS", "Value": [2161]},
        "3607": {"vr": "IS", "Value": [3844]},
        "3608": {"vr": "IS", "Value": [955]},
        "3609": {"vr": "IS", "Value": [3598]},
        "3610": {"vr": "IS", "Value": [3316]},
        "3611": {"vr": "IS", "Value": [329]},
        "3612": {"vr": "IS", "Value": [2078]},
        "3613": {"vr": "IS", "Value": [3019]},
        "3614": {"vr": "IS", "Value": [3304]},
        "3615": {"vr": "IS", "Value": [461]},
        "3616": {"vr": "IS", "Value": [1816]},
        "3617": {"vr": "IS", "Value": [736]},
        "3618": {"vr": "IS", "Value": [435]},
        "3619": {"vr": "IS", "Value": [146]},
        "3620": {"vr": "IS", "Value": [1159]},
        "3621": {"vr": "IS", "Value": [1422]},
        "3622": {"vr": "IS", "Value": [325]},
        "3623": {"vr": "IS", "Value": [631]},
        "3624": {"vr": "IS", "Value": [3904]},
        "3625": {"vr": "IS", "Value": [3884]},
        "3626": {"vr": "IS", "Value": [1683]},
        "3627": {"vr": "IS", "Value": [3504]},
        "3628": {"vr": "IS", "Value": [2691]},
        "3629": {"vr": "IS", "Value": [255]},
        "3630": {"vr": "IS", "Value": [3519]},
        "3631": {"vr": "IS", "Value": [3657]},
        "3632": {"vr": "IS", "Value": [984]},
        "3633": {"vr": "IS", "Value": [2892]},
        "3634": {"vr": "IS", "Value": [3582]},
        "3635": {"vr": "IS", "Value": [1637]},
        "3636": {"vr": "IS", "Value": [3881]},
        "3637": {"vr": "IS", "Value": [288]},
        "3638": {"vr": "IS", "Value": [702]},
        "3639": {"vr": "IS", "Value": [3795]},
        "3640": {"vr": "IS", "Value": [2010]},
        "3641": {"vr": "IS", "Value": [1460]},
        "3642": {"vr": "IS", "Value": [3838]},
        "3643": {"vr": "IS", "Value": [1801]},
        "3644": {"vr": "IS", "Value": [2425]},
        "3645": {"vr": "IS", "Value": [499]},
        "3646": {"vr": "IS", "Value": [781]},
        "3647": {"vr": "IS", "Value": [3055]},
        "3648": {"vr": "IS", "Value": [2885]},
        "3649": {"vr": "IS", "Value": [2049]},
        "3650": {"vr": "IS", "Value": [1536]},
        "3651": {"vr": "IS", "Value": [1194]},
        "3652": {"vr": "IS", "Value": [2105]},
        "3653": {"vr": "IS", "Value": [3341]},
        "3654": {"vr": "IS", "Value": [1981]},
        "3655": {"vr": "IS", "Value": [738]},
        "3656": {"vr": "IS", "Value": [2712]},
        "3657": {"vr": "IS", "Value": [3655]},
        "3658": {"vr": "IS", "Value": [355]},
        "3659": {"vr": "IS", "Value": [3682]},
        "3660": {"vr": "IS", "Value": [544]},
        "3661": {"vr": "IS", "Value": [962]},
        "3662": {"vr": "IS", "Value": [3458]},
        "3663": {"vr": "IS", "Value": [3439]},
        "3664": {"vr": "IS", "Value": [505]},
        "3665": {"vr": "IS", "Value": [957]},
        "3666": {"vr": "IS", "Value": [2942]},
        "3667": {"vr": "IS", "Value": [1715]},
        "3668": {"vr": "IS", "Value": [665]},
        "3669": {"vr": "IS", "Value": [1148]},
        "3670": {"vr": "IS", "Value": [1140]},
        "3671": {"vr": "IS", "Value": [1841]},
        "3672": {"vr": "IS", "Value": [286]},
        "3673": {"vr": "IS", "Value": [4001]},
        "3674": {"vr": "IS", "Value": [455]},
        "3675": {"vr": "IS", "Value": [1509]},
        "3676": {"vr": "IS", "Value": [2921]},
        "3677": {"vr": "IS", "Value": [389]},
        "3678": {"vr": "IS", "Value": [2922]},
        "3679": {"vr": "IS", "Value": [2913]},
        "3680": {"vr": "IS", "Value": [2592]},
        "3681": {"vr": "IS", "Value": [728]},
        "3682": {"vr": "IS", "Value": [1198]},
        "3683": {"vr": "IS", "Value": [1876]},
        "3684": {"vr": "IS", "Value": [497]},
        "3685": {"vr": "IS", "Value": [2836]},
        "3686": {"vr": "IS", "Value": [1423]},
        "3687": {"vr": "IS", "Value": [2692]},
        "3688": {"vr": "IS", "Value": [2400]},
        "3689": {"vr": "IS", "Value": [3030]},
        "3690": {"vr": "IS", "Value": [212]},
        "3691": {"vr": "IS", "Value": [1397]},
        "3692": {"vr": "IS", "Value": [390]},
        "3693": {"vr": "IS", "Value": [2199]},
        "3694": {"vr": "IS", "Value": [3681]},
        "3695": {"vr": "IS", "Value": [436]},
        "3696": {"vr": "IS", "Value": [1994]},
        "3697": {"vr": "IS", "Value": [1565]},
        "3698": {"vr": "IS", "Value": [686]},
        "3699": {"vr": "IS", "Value": [1228]},
        "3700": {"vr": "IS", "Value": [3896]},
        "3701": {"vr": "IS", "Value": [569]},
        "3702": {"vr": "IS", "Value": [987]},
        "3703": {"vr": "IS", "Value": [3794]},
        "3704": {"vr": "IS", "Value": [2752]},
        "3705": {"vr": "IS", "Value": [384]},
        "3706": {"vr": "IS", "Value": [2318]},
        "3707": {"vr": "IS", "Value": [798]},
        "3708": {"vr": "IS", "Value": [2895]},
        "3709": {"vr": "IS", "Value": [1272]},
        "3710": {"vr": "IS", "Value": [3047]},
        "3711": {"vr": "IS", "Value": [3382]},
        "3712": {"vr": "IS", "Value": [1537]},
        "3713": {"vr": "IS", "Value": [119]},
        "3714": {"vr": "IS", "Value": [3820]},
        "3715": {"vr": "IS", "Value": [2263]},
        "3716": {"vr": "IS", "Value": [2696]},
        "3717": {"vr": "IS", "Value": [3714]},
        "3718": {"vr": "IS", "Value": [3457]},
        "3719": {"vr": "IS", "Value": [323]},
        "3720": {"vr": "IS", "Value": [3111]},
        "3721": {"vr": "IS", "Value": [1920]},
        "3722": {"vr": "IS", "Value": [1602]},
        "3723": {"vr": "IS", "Value": [1376]},
        "3724": {"vr": "IS", "Value": [851]},
        "3725": {"vr": "IS", "Value": [624]},
        "3726": {"vr": "IS", "Value": [2873]},
        "3727": {"vr": "IS", "Value": [2298]},
        "3728": {"vr": "IS", "Value": [2735]},
        "3729": {"vr": "IS", "Value": [3326]},
        "3730": {"vr": "IS", "Value": [452]},
        "3731": {"vr": "IS", "Value": [2469]},
        "3732": {"vr": "IS", "Value": [828]},
        "3733": {"vr": "IS", "Value": [165]},
        "3734": {"vr": "IS", "Value": [3667]},
        "3735": {"vr": "IS", "Value": [3357]},
        "3736": {"vr": "IS", "Value": [3616]},
        "3737": {"vr": "IS", "Value": [1485]},
        "3738": {"vr": "IS", "Value": [3827]},
        "3739": {"vr": "IS", "Value": [2261]},
        "3740": {"vr": "IS", "Value": [1202]},
        "3741": {"vr": "IS", "Value": [2570]},
        "3742": {"vr": "IS", "Value": [1992]},
        "3743": {"vr": "IS", "Value": [3042]},
        "3744": {"vr": "IS", "Value": [27]},
        "3745": {"vr": "IS", "Value": [172]},
        "3746": {"vr": "IS", "Value": [1115]},
        "3747": {"vr": "IS", "Value": [3636]},
        "3748": {"vr": "IS", "Value": [3540]},
        "3749": {"vr": "IS", "Value": [1312]},
        "3750": {"vr": "IS", "Value": [1484]},
        "3751": {"vr": "IS", "Value": [1151]},
        "3752": {"vr": "IS", "Value": [1185]},
        "3753": {"vr": "IS", "Value": [1779]},
        "3754": {"vr": "IS", "Value": [1952]},
        "3755": {"vr": "IS", "Value": [2077]},
        "3756": {"vr": "IS", "Value": [2656]},
        "3757": {"vr": "IS", "Value": [539]},
        "3758": {"vr": "IS", "Value": [3410]},
        "3759": {"vr": "IS", "Value": [1762]},
        "3760": {"vr": "IS", "Value": [579]},
        "3761": {"vr": "IS", "Value": [1665]},
        "3762": {"vr": "IS", "Value": [293]},
        "3763": {"vr": "IS", "Value": [2675]},
        "3764": {"vr": "IS", "Value": [2356]},
        "3765": {"vr": "IS", "Value": [3944]},
        "3766": {"vr": "IS", "Value": [1910]},
        "3767": {"vr": "IS", "Value": [2525]},
        "3768": {"vr": "IS", "Value": [3365]},
        "3769": {"vr": "IS", "Value": [651]},
        "3770": {"vr": "IS", "Value": [980]},
        "3771": {"vr": "IS", "Value": [3807]},
        "3772": {"vr": "IS", "Value": [2076]},
        "3773": {"vr": "IS", "Value": [3259]},
        "3774": {"vr": "IS", "Value": [1719]},
        "3775": {"vr": "IS", "Value": [2423]},
        "3776": {"vr": "IS", "Value": [107]},
        "3777": {"vr": "IS", "Value": [2094]},
        "3778": {"vr": "IS", "Value": [334]},
        "3779": {"vr": "IS", "Value": [1396]},
        "3780": {"vr": "IS", "Value": [302]},
        "3781": {"vr": "IS", "Value": [3443]},
        "3782": {"vr": "IS", "Value": [598]},
        "3783": {"vr": "IS", "Value": [611]},
        "3784": {"vr": "IS", "Value": [3887]},
        "3785": {"vr": "IS", "Value": [659]},
        "3786": {"vr": "IS", "Value": [2091]},
        "3787": {"vr": "IS", "Value": [81]},
        "3788": {"vr": "IS", "Value": [720]},
        "3789": {"vr": "IS", "Value": [3238]},
        "3790": {"vr": "IS", "Value": [758]},
        "3791": {"vr": "IS", "Value": [528]},
        "3792": {"vr": "IS", "Value": [963]},
        "3793": {"vr": "IS", "Value": [1842]},
        "3794": {"vr": "IS", "Value": [117]},
        "3795": {"vr": "IS", "Value": [2700]},
        "3796": {"vr": "IS", "Value": [3761]},
        "3797": {"vr": "IS", "Value": [1025]},
        "3798": {"vr": "IS", "Value": [2609]},
        "3799": {"vr": "IS", "Value": [995]},
        "3800": {"vr": "IS", "Value": [3675]},
        "3801": {"vr": "IS", "Value": [1846]},
        "3802": {"vr": "IS", "Value": [3553]},
        "3803": {"vr": "IS", "Value": [626]},
        "3804": {"vr": "IS", "Value": [2557]},
        "3805": {"vr": "IS", "Value": [2698]},
        "3806": {"vr": "IS", "Value": [2697]},
        "3807": {"vr": "IS", "Value": [3179]},
        "3808": {"vr": "IS", "Value": [3742]},
        "3809": {"vr": "IS", "Value": [723]},
        "3810": {"vr": "IS", "Value": [3385]},
        "3811": {"vr": "IS", "Value": [2967]},
        "3812": {"vr": "IS", "Value": [3924]},
        "3813": {"vr": "IS", "Value": [2859]},
        "3814": {"vr": "IS", "Value": [1493]},
        "3815": {"vr": "IS", "Value": [2433]},
        "3816": {"vr": "IS", "Value": [2796]},
        "3817": {"vr": "IS", "Value": [2705]},
        "3818": {"vr": "IS", "Value": [619]},
        "3819": {"vr": "IS", "Value": [1271]},
        "3820": {"vr": "IS", "Value": [2602]},
        "3821": {"vr": "IS", "Value": [2340]},
        "3822": {"vr": "IS", "Value": [3729]},
        "3823": {"vr": "IS", "Value": [2862]},
        "3824": {"vr": "IS", "Value": [3923]},
        "3825": {"vr": "IS", "Value": [1342]},
        "3826": {"vr": "IS", "Value": [260]},
        "3827": {"vr": "IS", "Value": [2162]},
        "3828": {"vr": "IS", "Value": [1274]},
        "3829": {"vr": "IS", "Value": [3282]},
        "3830": {"vr": "IS", "Value": [1579]},
        "3831": {"vr": "IS", "Value": [2354]},
        "3832": {"vr": "IS", "Value": [2015]},
        "3833": {"vr": "IS", "Value": [1832]},
        "3834": {"vr": "IS", "Value": [337]},
        "3835": {"vr": "IS", "Value": [3581]},
        "3836": {"vr": "IS", "Value": [2937]},
        "3837": {"vr": "IS", "Value": [932]},
        "3838": {"vr": "IS", "Value": [68]},
        "3839": {"vr": "IS", "Value": [74]},
        "3840": {"vr": "IS", "Value": [3198]},
        "3841": {"vr": "IS", "Value": [731]},
        "3842": {"vr": "IS", "Value": [304]},
        "3843": {"vr": "IS", "Value": [2422]},
        "3844": {"vr": "IS", "Value": [725]},
        "3845": {"vr": "IS", "Value": [1362]},
        "3846": {"vr": "IS", "Value": [2834]},
        "3847": {"vr": "IS", "Value": [2573]},
        "3848": {"vr": "IS", "Value": [2614]},
        "3849": {"vr": "IS", "Value": [3695]},
        "3850": {"vr": "IS", "Value": [2099]},
        "3851": {"vr": "IS", "Value": [2809]},
        "3852": {"vr": "IS", "Value": [835]},
        "3853": {"vr": "IS", "Value": [291]},
        "3854": {"vr": "IS", "Value": [1439]},
        "3855": {"vr": "IS", "Value": [4006]},
        "3856": {"vr": "IS", "Value": [141]},
        "3857": {"vr": "IS", "Value": [830]},
        "3858": {"vr": "IS", "Value": [176]},
        "3859": {"vr": "IS", "Value": [2206]},
        "3860": {"vr": "IS", "Value": [930]},
        "3861": {"vr": "IS", "Value": [1895]},
        "3862": {"vr": "IS", "Value": [1078]},
        "3863": {"vr": "IS", "Value": [3308]},
        "3864": {"vr": "IS", "Value": [1546]},
        "3865": {"vr": "IS", "Value": [2431]},
        "3866": {"vr": "IS", "Value": [1751]},
        "3867": {"vr": "IS", "Value": [387]},
        "3868": {"vr": "IS", "Value": [756]},
        "3869": {"vr": "IS", "Value": [3011]},
        "3870": {"vr": "IS", "Value": [3848]},
        "3871": {"vr": "IS", "Value": [3450]},
        "3872": {"vr": "IS", "Value": [369]},
        "3873": {"vr": "IS", "Value": [3190]},
        "3874": {"vr": "IS", "Value": [2635]},
        "3875": {"vr": "IS", "Value": [3629]},
        "3876": {"vr": "IS", "Value": [1034]},
        "3877": {"vr": "IS", "Value": [3595]},
        "3878": {"vr": "IS", "Value": [3313]},
        "3879": {"vr": "IS", "Value": [936]},
        "3880": {"vr": "IS", "Value": [2763]},
        "3881": {"vr": "IS", "Value": [1551]},
        "3882": {"vr": "IS", "Value": [2699]},
        "3883": {"vr": "IS", "Value": [1758]},
        "3884": {"vr": "IS", "Value": [2048]},
        "3885": {"vr": "IS", "Value": [708]},
        "3886": {"vr": "IS", "Value": [3241]},
        "3887": {"vr": "IS", "Value": [2135]},
        "3888": {"vr": "IS", "Value": [1183]},
        "3889": {"vr": "IS", "Value": [189]},
        "3890": {"vr": "IS", "Value": [1736]},
        "3891": {"vr": "IS", "Value": [2447]},
        "3892": {"vr": "IS", "Value": [3728]},
        "3893": {"vr": "IS", "Value": [2756]},
        "3894": {"vr": "IS", "Value": [261]},
        "3895": {"vr": "IS", "Value": [986]},
        "3896": {"vr": "IS", "Value": [3745]},
        "3897": {"vr": "IS", "Value": [3486]},
        "3898": {"vr": "IS", "Value": [2404]},
        "3899": {"vr": "IS", "Value": [2840]},
        "3900": {"vr": "IS", "Value": [696]},
        "3901": {"vr": "IS", "Value": [3170]},
        "3902": {"vr": "IS", "Value": [2151]},
        "3903": {"vr": "IS", "Value": [2959]},
        "3904": {"vr": "IS", "Value": [1893]},
        "3905": {"vr": "IS", "Value": [3864]},
        "3906": {"vr": "IS", "Value": [2232]},
        "3907": {"vr": "IS", "Value": [3491]},
        "3908": {"vr": "IS", "Value": [1181]},
        "3909": {"vr": "IS", "Value": [646]},
        "3910": {"vr": "IS", "Value": [269]},
        "3911": {"vr": "IS", "Value": [1494]},
        "3912": {"vr": "IS", "Value": [3662]},
        "3913": {"vr": "IS", "Value": [1709]},
        "3914": {"vr": "IS", "Value": [2317]},
        "3915": {"vr": "IS", "Value": [138]},
        "3916": {"vr": "IS", "Value": [1374]},
        "3917": {"vr": "IS", "Value": [367]},
        "3918": {"vr": "IS", "Value": [1936]},
        "3919": {"vr": "IS", "Value": [1631]},
        "3920": {"vr": "IS", "Value": [1126]},
        "3921": {"vr": "IS", "Value": [3392]},
        "3922": {"vr": "IS", "Value": [3786]},
        "3923": {"vr": "IS", "Value": [594]},
        "3924": {"vr": "IS", "Value": [148]},
        "3925": {"vr": "IS", "Value": [1129]},
        "3926": {"vr": "IS", "Value": [2879]},
        "3927": {"vr": "IS", "Value": [2984]},
        "3928": {"vr": "IS", "Value": [1995]},
        "3929": {"vr": "IS", "Value": [3286]},
        "3930": {"vr": "IS", "Value": [3048]},
        "3931": {"vr": "IS", "Value": [1887]},
        "3932": {"vr": "IS", "Value": [2746]},
        "3933": {"vr": "IS", "Value": [3525]},
        "3934": {"vr": "IS", "Value": [2174]},
        "3935": {"vr": "IS", "Value": [3509]},
        "3936": {"vr": "IS", "Value": [2191]},
        "3937": {"vr": "IS", "Value": [2653]},
        "3938": {"vr": "IS", "Value": [3739]},
        "3939": {"vr": "IS", "Value": [647]},
        "3940": {"vr": "IS", "Value": [1660]},
        "3941": {"vr": "IS", "Value": [3434]},
        "3942": {"vr": "IS", "Value": [2858]},
        "3943": {"vr": "IS", "Value": [3716]},
        "3944": {"vr": "IS", "Value": [2279]},
        "3945": {"vr": "IS", "Value": [1331]},
        "3946": {"vr": "IS", "Value": [3665]},
        "3947": {"vr": "IS", "Value": [649]},
        "3948": {"vr": "IS", "Value": [1278]},
        "3949": {"vr": "IS", "Value": [3558]},
        "3950": {"vr": "IS", "Value": [2506]},
        "3951": {"vr": "IS", "Value": [1542]},
        "3952": {"vr": "IS", "Value": [2168]},
        "3953": {"vr": "IS", "Value": [2197]},
        "3954": {"vr": "IS", "Value": [439]},
        "3955": {"vr": "IS", "Value": [3929]},
        "3956": {"vr": "IS", "Value": [2108]},
        "3957": {"vr": "IS", "Value": [1943]},
        "3958": {"vr": "IS", "Value": [1426]},
        "3959": {"vr": "IS", "Value": [3536]},
        "3960": {"vr": "IS", "Value": [2629]},
        "3961": {"vr": "IS", "Value": [2874]},
        "3962": {"vr": "IS", "Value": [3255]},
        "3963": {"vr": "IS", "Value": [863]},
        "3964": {"vr": "IS", "Value": [2774]},
        "3965": {"vr": "IS", "Value": [3859]},
        "3966": {"vr": "IS", "Value": [776]},
        "3967": {"vr": "IS", "Value": [1608]},
        "3968": {"vr": "IS", "Value": [697]},
        "3969": {"vr": "IS", "Value": [299]},
        "3970": {"vr": "IS", "Value": [1775]},
        "3971": {"vr": "IS", "Value": [412]},
        "3972": {"vr": "IS", "Value": [3009]},
        "3973": {"vr": "IS", "Value": [1553]},
        "3974": {"vr": "IS", "Value": [1145]},
        "3975": {"vr": "IS", "Value": [3146]},
        "3976": {"vr": "IS", "Value": [163]},
        "3977": {"vr": "IS", "Value": [533]},
        "3978": {"vr": "IS", "Value": [3831]},
        "3979": {"vr": "IS", "Value": [1695]},
        "3980": {"vr": "IS", "Value": [660]},
        "3981": {"vr": "IS", "Value": [2871]},
        "3982": {"vr": "IS", "Value": [1901]},
        "3983": {"vr": "IS", "Value": [205]},
        "3984": {"vr": "IS", "Value": [1037]},
        "3985": {"vr": "IS", "Value": [2283]},
        "3986": {"vr": "IS", "Value": [3765]},
        "3987": {"vr": "IS", "Value": [1650]},
        "3988": {"vr": "IS", "Value": [1907]},
        "3989": {"vr": "IS", "Value": [1482]},
        "3990": {"vr": "IS", "Value": [2254]},
        "3991": {"vr": "IS", "Value": [2265]},
        "3992": {"vr": "IS", "Value": [3755]},
        "3993": {"vr": "IS", "Value": [3474]},
        "3994": {"vr": "IS", "Value": [1823]},
        "3995": {"vr": "IS", "Value": [734]},
        "3996": {"vr": "IS", "Value": [315]},
        "3997": {"vr": "IS", "Value": [3530]},
        "3998": {"vr": "IS", "Value": [1811]},
        "3999": {"vr": "IS", "Value": [2861]},
        "4000": {"vr": "IS", "Value": [3586]},
        "4001": {"vr": "IS", "Value": [2866]},
        "4002": {"vr": "IS", "Value": [3094]},
        "4003": {"vr": "IS", "Value": [1440]},
        "4004": {"vr": "IS", "Value": [3435]},
        "4005": {"vr": "IS", "Value": [934]},
        "4006": {"vr": "IS", "Value": [423]},
        "4007": {"vr": "IS", "Value": [2371]},
        "4008": {"vr": "IS", "Value": [866]},
        "4009": {"vr": "IS", "Value": [1988]},
        "4010": {"vr": "IS", "Value": [2096]},
        "4011": {"vr": "IS", "Value": [710]},
        "4012": {"vr": "IS", "Value": [3228]},
        "4013": {"vr": "IS", "Value": [642]},
        "4014": {"vr": "IS", "Value": [1270]},
        "4015": {"vr": "IS", "Value": [3659]},
        "4016": {"vr": "IS", "Value": [3580]},
        "4017": {"vr": "IS", "Value": [1891]},
        "4018": {"vr": "IS", "Value": [3028]},
        "4019": {"vr": "IS", "Value": [2361]},
    },
    "00200032": {
        "0": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "4": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "5": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "6": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "7": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "8": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "9": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "10": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "11": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "12": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "13": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "14": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "15": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "16": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "17": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "18": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "19": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "20": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "21": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "22": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "23": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "24": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "25": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "26": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "27": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "28": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "29": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "30": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "31": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "32": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "33": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "34": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "35": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "36": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "37": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "38": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "39": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "40": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "41": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "42": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "43": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "44": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "45": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "46": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "47": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "48": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "49": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "50": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "51": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "52": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "53": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "54": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "55": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "56": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "57": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "58": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "59": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "60": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "61": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "62": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "63": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "64": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "65": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "66": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "67": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "68": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "69": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "70": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "71": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "72": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "73": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "74": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "75": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "76": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "77": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "78": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "79": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "80": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "81": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "82": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "83": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "84": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "85": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "86": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "87": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "88": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "89": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "90": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "91": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "92": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "93": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "94": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "95": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "96": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "97": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "98": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "99": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "100": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "101": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "102": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "103": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "104": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "105": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "106": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "107": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "108": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "109": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "110": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "111": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "112": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "113": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "114": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "115": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "116": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "117": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "118": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "119": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "120": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "121": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "122": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "123": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "124": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "125": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "126": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "127": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "128": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "129": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "130": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "131": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "132": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "133": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "134": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "135": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "136": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "137": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "138": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "139": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "140": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "141": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "142": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "143": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "144": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "145": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "146": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "147": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "148": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "149": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "150": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "151": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "152": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "153": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "154": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "155": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "156": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "157": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "158": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "159": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "160": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "161": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "162": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "163": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "164": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "165": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "166": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "167": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "168": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "169": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "170": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "171": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "172": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "173": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "174": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "175": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "176": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "177": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "178": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "179": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "180": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "181": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "182": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "183": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "184": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "185": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "186": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "187": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "188": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "189": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "190": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "191": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "192": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "193": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "194": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "195": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "196": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "197": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "198": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "199": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "200": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "201": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "202": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "203": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "204": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "205": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "206": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "207": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "208": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "209": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "210": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "211": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "212": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "213": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "214": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "215": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "216": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "217": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "218": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "219": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "220": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "221": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "222": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "223": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "224": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "225": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "226": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "227": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "228": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "229": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "230": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "231": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "232": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "233": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "234": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "235": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "236": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "237": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "238": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "239": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "240": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "241": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "242": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "243": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "244": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "245": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "246": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "247": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "248": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "249": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "250": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "251": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "252": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "253": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "254": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "255": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "256": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "257": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "258": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "259": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "260": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "261": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "262": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "263": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "264": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "265": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "266": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "267": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "268": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "269": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "270": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "271": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "272": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "273": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "274": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "275": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "276": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "277": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "278": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "279": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "280": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "281": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "282": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "283": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "284": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "285": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "286": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "287": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "288": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "289": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "290": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "291": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "292": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "293": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "294": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "295": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "296": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "297": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "298": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "299": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "300": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "301": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "302": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "303": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "304": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "305": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "306": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "307": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "308": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "309": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "310": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "311": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "312": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "313": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "314": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "315": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "316": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "317": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "318": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "319": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "320": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "321": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "322": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "323": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "324": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "325": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "326": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "327": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "328": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "329": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "330": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "331": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "332": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "333": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "334": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "335": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "336": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "337": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "338": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "339": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "340": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "341": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "342": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "343": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "344": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "345": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "346": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "347": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "348": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "349": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "350": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "351": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "352": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "353": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "354": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "355": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "356": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "357": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "358": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "359": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "360": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "361": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "362": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "363": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "364": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "365": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "366": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "367": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "368": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "369": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "370": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "371": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "372": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "373": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "374": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "375": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "376": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "377": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "378": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "379": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "380": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "381": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "382": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "383": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "384": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "385": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "386": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "387": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "388": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "389": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "390": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "391": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "392": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "393": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "394": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "395": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "396": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "397": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "398": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "399": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "400": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "401": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "402": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "403": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "404": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "405": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "406": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "407": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "408": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "409": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "410": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "411": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "412": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "413": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "414": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "415": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "416": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "417": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "418": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "419": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "420": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "421": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "422": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "423": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "424": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "425": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "426": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "427": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "428": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "429": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "430": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "431": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "432": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "433": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "434": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "435": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "436": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "437": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "438": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "439": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "440": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "441": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "442": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "443": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "444": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "445": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "446": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "447": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "448": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "449": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "450": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "451": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "452": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "453": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "454": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "455": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "456": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "457": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "458": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "459": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "460": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "461": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "462": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "463": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "464": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "465": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "466": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "467": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "468": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "469": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "470": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "471": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "472": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "473": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "474": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "475": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "476": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "477": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "478": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "479": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "480": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "481": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "482": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "483": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "484": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "485": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "486": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "487": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "488": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "489": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "490": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "491": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "492": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "493": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "494": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "495": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "496": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "497": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "498": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "499": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "500": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "501": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "502": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "503": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "504": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "505": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "506": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "507": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "508": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "509": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "510": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "511": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "512": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "513": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "514": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "515": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "516": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "517": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "518": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "519": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "520": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "521": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "522": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "523": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "524": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "525": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "526": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "527": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "528": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "529": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "530": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "531": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "532": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "533": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "534": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "535": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "536": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "537": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "538": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "539": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "540": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "541": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "542": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "543": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "544": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "545": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "546": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "547": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "548": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "549": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "550": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "551": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "552": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "553": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "554": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "555": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "556": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "557": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "558": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "559": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "560": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "561": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "562": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "563": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "564": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "565": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "566": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "567": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "568": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "569": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "570": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "571": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "572": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "573": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "574": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "575": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "576": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "577": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "578": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "579": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "580": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "581": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "582": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "583": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "584": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "585": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "586": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "587": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "588": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "589": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "590": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "591": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "592": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "593": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "594": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "595": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "596": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "597": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "598": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "599": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "600": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "601": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "602": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "603": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "604": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "605": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "606": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "607": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "608": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "609": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "610": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "611": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "612": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "613": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "614": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "615": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "616": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "617": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "618": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "619": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "620": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "621": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "622": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "623": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "624": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "625": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "626": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "627": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "628": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "629": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "630": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "631": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "632": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "633": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "634": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "635": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "636": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "637": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "638": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "639": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "640": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "641": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "642": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "643": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "644": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "645": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "646": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "647": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "648": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "649": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "650": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "651": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "652": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "653": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "654": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "655": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "656": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "657": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "658": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "659": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "660": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "661": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "662": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "663": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "664": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "665": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "666": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "667": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "668": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "669": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "670": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "671": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "672": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "673": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "674": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "675": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "676": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "677": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "678": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "679": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "680": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "681": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "682": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "683": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "684": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "685": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "686": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "687": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "688": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "689": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "690": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "691": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "692": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "693": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "694": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "695": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "696": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "697": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "698": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "699": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "700": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "701": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "702": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "703": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "704": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "705": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "706": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "707": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "708": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "709": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "710": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "711": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "712": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "713": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "714": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "715": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "716": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "717": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "718": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "719": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "720": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "721": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "722": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "723": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "724": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "725": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "726": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "727": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "728": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "729": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "730": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "731": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "732": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "733": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "734": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "735": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "736": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "737": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "738": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "739": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "740": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "741": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "742": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "743": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "744": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "745": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "746": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "747": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "748": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "749": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "750": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "751": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "752": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "753": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "754": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "755": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "756": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "757": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "758": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "759": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "760": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "761": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "762": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "763": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "764": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "765": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "766": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "767": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "768": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "769": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "770": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "771": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "772": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "773": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "774": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "775": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "776": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "777": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "778": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "779": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "780": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "781": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "782": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "783": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "784": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "785": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "786": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "787": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "788": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "789": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "790": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "791": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "792": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "793": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "794": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "795": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "796": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "797": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "798": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "799": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "800": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "801": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "802": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "803": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "804": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "805": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "806": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "807": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "808": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "809": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "810": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "811": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "812": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "813": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "814": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "815": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "816": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "817": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "818": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "819": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "820": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "821": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "822": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "823": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "824": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "825": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "826": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "827": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "828": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "829": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "830": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "831": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "832": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "833": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "834": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "835": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "836": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "837": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "838": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "839": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "840": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "841": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "842": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "843": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "844": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "845": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "846": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "847": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "848": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "849": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "850": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "851": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "852": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "853": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "854": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "855": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "856": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "857": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "858": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "859": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "860": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "861": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "862": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "863": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "864": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "865": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "866": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "867": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "868": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "869": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "870": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "871": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "872": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "873": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "874": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "875": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "876": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "877": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "878": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "879": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "880": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "881": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "882": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "883": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "884": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "885": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "886": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "887": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "888": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "889": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "890": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "891": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "892": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "893": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "894": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "895": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "896": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "897": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "898": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "899": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "900": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "901": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "902": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "903": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "904": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "905": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "906": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "907": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "908": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "909": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "910": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "911": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "912": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "913": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "914": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "915": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "916": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "917": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "918": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "919": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "920": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "921": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "922": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "923": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "924": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "925": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "926": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "927": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "928": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "929": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "930": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "931": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "932": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "933": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "934": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "935": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "936": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "937": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "938": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "939": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "940": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "941": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "942": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "943": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "944": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "945": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "946": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "947": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "948": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "949": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "950": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "951": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "952": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "953": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "954": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "955": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "956": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "957": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "958": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "959": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "960": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "961": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "962": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "963": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "964": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "965": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "966": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "967": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "968": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "969": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "970": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "971": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "972": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "973": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "974": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "975": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "976": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "977": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "978": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "979": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "980": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "981": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "982": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "983": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "984": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "985": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "986": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "987": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "988": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "989": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "990": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "991": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "992": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "993": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "994": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "995": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "996": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "997": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "998": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "999": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1000": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1001": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1002": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1003": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1004": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1005": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1006": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1007": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1008": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1009": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1010": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1011": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1012": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1013": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1014": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1015": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1016": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1017": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1018": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1019": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1020": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1021": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1022": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1023": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1024": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1025": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1026": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1027": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1028": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1029": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1030": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1031": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1032": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1033": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1034": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1035": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1036": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1037": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1038": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1039": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1040": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1041": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1042": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1043": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1044": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1045": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1046": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1047": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1048": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1049": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1050": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1051": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1052": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1053": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1054": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1055": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1056": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1057": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1058": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1059": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1060": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1061": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1062": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1063": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1064": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1065": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1066": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1067": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1068": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1069": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1070": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1071": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1072": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1073": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1074": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1075": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1076": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1077": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1078": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1079": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1080": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1081": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1082": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1083": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1084": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1085": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1086": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1087": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1088": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1089": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1090": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1091": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1092": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1093": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1094": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1095": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1096": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1097": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1098": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1099": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1100": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1101": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1102": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1103": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1104": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1105": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1106": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1107": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1108": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1109": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1110": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1111": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1112": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1113": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1114": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1115": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1116": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1117": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1118": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1119": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1120": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1121": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1122": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1123": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1124": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1125": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1126": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1127": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1128": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1129": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1130": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1131": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1132": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1133": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1134": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1135": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1136": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1137": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1138": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1139": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1140": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1141": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1142": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1143": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1144": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1145": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1146": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1147": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1148": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1149": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1150": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1151": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1152": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1153": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1154": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1155": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1156": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1157": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1158": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1159": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1160": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1161": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1162": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1163": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1164": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1165": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1166": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1167": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1168": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1169": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1170": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1171": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1172": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1173": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1174": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1175": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1176": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1177": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1178": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1179": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1180": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1181": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1182": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1183": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1184": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1185": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1186": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1187": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1188": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1189": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1190": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1191": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1192": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1193": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1194": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1195": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1196": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1197": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1198": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1199": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1200": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1201": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1202": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1203": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1204": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1205": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1206": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1207": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1208": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1209": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1210": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1211": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1212": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1213": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1214": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1215": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1216": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1217": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1218": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1219": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1220": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1221": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1222": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1223": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1224": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1225": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1226": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1227": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1228": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1229": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1230": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1231": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1232": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1233": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1234": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1235": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1236": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1237": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1238": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1239": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1240": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1241": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1242": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1243": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1244": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1245": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1246": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1247": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1248": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1249": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1250": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1251": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1252": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1253": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1254": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1255": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1256": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1257": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1258": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1259": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1260": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1261": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1262": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1263": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1264": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1265": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1266": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1267": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1268": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1269": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1270": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1271": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1272": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1273": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1274": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1275": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1276": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1277": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1278": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1279": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1280": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1281": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1282": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1283": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1284": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1285": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1286": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1287": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1288": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1289": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1290": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1291": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1292": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1293": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1294": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1295": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1296": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1297": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1298": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1299": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1300": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1301": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1302": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1303": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1304": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1305": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1306": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1307": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1308": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1309": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1310": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1311": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1312": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1313": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1314": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1315": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1316": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1317": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1318": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1319": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1320": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1321": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1322": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1323": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1324": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1325": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1326": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1327": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1328": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1329": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1330": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1331": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1332": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1333": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1334": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1335": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1336": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1337": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1338": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1339": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1340": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1341": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1342": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1343": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1344": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1345": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1346": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1347": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1348": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1349": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1350": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1351": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1352": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1353": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1354": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1355": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1356": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1357": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1358": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1359": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1360": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1361": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1362": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1363": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1364": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1365": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1366": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1367": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1368": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1369": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1370": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1371": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1372": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1373": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1374": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1375": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1376": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1377": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1378": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1379": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1380": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1381": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1382": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1383": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1384": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1385": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1386": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1387": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1388": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1389": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1390": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1391": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1392": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1393": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1394": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1395": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1396": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1397": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1398": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1399": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1400": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1401": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1402": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1403": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1404": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1405": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1406": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1407": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1408": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1409": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1410": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1411": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1412": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1413": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1414": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1415": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1416": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1417": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1418": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1419": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1420": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1421": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1422": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1423": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1424": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1425": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1426": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1427": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1428": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1429": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1430": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1431": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1432": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1433": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1434": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1435": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1436": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1437": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1438": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1439": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1440": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1441": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1442": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1443": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1444": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1445": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1446": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1447": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1448": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1449": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1450": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1451": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1452": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1453": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1454": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1455": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1456": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1457": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1458": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1459": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1460": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1461": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1462": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1463": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1464": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1465": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1466": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1467": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1468": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1469": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1470": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1471": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1472": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1473": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1474": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1475": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1476": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1477": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1478": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1479": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1480": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1481": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1482": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1483": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1484": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1485": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1486": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1487": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1488": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1489": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1490": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1491": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1492": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1493": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1494": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1495": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1496": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1497": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1498": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1499": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1500": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1501": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1502": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1503": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1504": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1505": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1506": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1507": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1508": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1509": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1510": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1511": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1512": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1513": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1514": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1515": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1516": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1517": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1518": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1519": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1520": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1521": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1522": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1523": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1524": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1525": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1526": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1527": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1528": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1529": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1530": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1531": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1532": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1533": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1534": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1535": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1536": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1537": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1538": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1539": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1540": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1541": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1542": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1543": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1544": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1545": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1546": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1547": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1548": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1549": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1550": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1551": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1552": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1553": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1554": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1555": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1556": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1557": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1558": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1559": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1560": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1561": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1562": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1563": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1564": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1565": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1566": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1567": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1568": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1569": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1570": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1571": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1572": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1573": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1574": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1575": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1576": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1577": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1578": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1579": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1580": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1581": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1582": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1583": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1584": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1585": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1586": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1587": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1588": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1589": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1590": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1591": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1592": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1593": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1594": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1595": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1596": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1597": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1598": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1599": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1600": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1601": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1602": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1603": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1604": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1605": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1606": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1607": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1608": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1609": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1610": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1611": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1612": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1613": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1614": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1615": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1616": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1617": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1618": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1619": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1620": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1621": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1622": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1623": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1624": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1625": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1626": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1627": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1628": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1629": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1630": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1631": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1632": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1633": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1634": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1635": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1636": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1637": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1638": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1639": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1640": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1641": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1642": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1643": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1644": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1645": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1646": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1647": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1648": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1649": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1650": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1651": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1652": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1653": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1654": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1655": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1656": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1657": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1658": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1659": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1660": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1661": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1662": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1663": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1664": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1665": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1666": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1667": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1668": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1669": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1670": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1671": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1672": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1673": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1674": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1675": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1676": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1677": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1678": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1679": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1680": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1681": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1682": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1683": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1684": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1685": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1686": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1687": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1688": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1689": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1690": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1691": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1692": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1693": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1694": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1695": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1696": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1697": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1698": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1699": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1700": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1701": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1702": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1703": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1704": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1705": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1706": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1707": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1708": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1709": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1710": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1711": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1712": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1713": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1714": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1715": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1716": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1717": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1718": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1719": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1720": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1721": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1722": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1723": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1724": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1725": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1726": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1727": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1728": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1729": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1730": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1731": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1732": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1733": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1734": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1735": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1736": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1737": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1738": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1739": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1740": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1741": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1742": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1743": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1744": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1745": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1746": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1747": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1748": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1749": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1750": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1751": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1752": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1753": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "1754": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1755": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1756": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1757": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1758": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1759": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1760": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1761": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1762": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1763": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1764": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1765": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1766": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1767": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1768": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1769": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1770": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1771": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1772": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1773": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1774": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1775": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1776": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1777": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1778": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1779": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1780": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1781": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1782": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1783": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1784": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1785": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1786": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1787": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "1788": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1789": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1790": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1791": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1792": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1793": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1794": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1795": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1796": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "1797": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1798": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1799": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "1800": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1801": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1802": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1803": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1804": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1805": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1806": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1807": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1808": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1809": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1810": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "1811": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1812": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "1813": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1814": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1815": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1816": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1817": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1818": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1819": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1820": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1821": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1822": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1823": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1824": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1825": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1826": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1827": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1828": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1829": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1830": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1831": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1832": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1833": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1834": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1835": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1836": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1837": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1838": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1839": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1840": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "1841": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1842": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1843": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1844": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1845": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1846": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "1847": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1848": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1849": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1850": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1851": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1852": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1853": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1854": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "1855": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1856": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1857": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "1858": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1859": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1860": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1861": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1862": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1863": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "1864": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1865": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1866": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1867": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1868": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1869": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1870": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1871": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1872": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1873": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1874": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1875": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1876": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1877": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1878": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1879": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1880": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1881": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1882": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1883": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1884": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "1885": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1886": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1887": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1888": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1889": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1890": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1891": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1892": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1893": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1894": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1895": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1896": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1897": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1898": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1899": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "1900": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1901": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1902": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1903": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1904": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "1905": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "1906": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "1907": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1908": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1909": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "1910": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "1911": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1912": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1913": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1914": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1915": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1916": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1917": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1918": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1919": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1920": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1921": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1922": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1923": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1924": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1925": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1926": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1927": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "1928": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "1929": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "1930": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1931": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "1932": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1933": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1934": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "1935": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "1936": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1937": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1938": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1939": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "1940": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "1941": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "1942": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1943": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "1944": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1945": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "1946": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1947": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1948": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1949": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1950": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "1951": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1952": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1953": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1954": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "1955": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "1956": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1957": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "1958": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1959": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1960": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "1961": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "1962": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "1963": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "1964": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1965": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1966": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "1967": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1968": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "1969": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1970": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1971": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "1972": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1973": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "1974": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "1975": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "1976": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1977": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "1978": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "1979": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "1980": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1981": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1982": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1983": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "1984": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1985": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "1986": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "1987": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "1988": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "1989": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "1990": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "1991": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "1992": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "1993": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "1994": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1995": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "1996": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "1997": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "1998": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "1999": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2000": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2001": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2002": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2003": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2004": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2005": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2006": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2007": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2008": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2009": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2010": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2011": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2012": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2013": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2014": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2015": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2016": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2017": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2018": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2019": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2020": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2021": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2022": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2023": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2024": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2025": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2026": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2027": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2028": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2029": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2030": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2031": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2032": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2033": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2034": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2035": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2036": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2037": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2038": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2039": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2040": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2041": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2042": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2043": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2044": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2045": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2046": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2047": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2048": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2049": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2050": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2051": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2052": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2053": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2054": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2055": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2056": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2057": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2058": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2059": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2060": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2061": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2062": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2063": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2064": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2065": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2066": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2067": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2068": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2069": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2070": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2071": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2072": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2073": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2074": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2075": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2076": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2077": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2078": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2079": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2080": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2081": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2082": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2083": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2084": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2085": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2086": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2087": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2088": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2089": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2090": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2091": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2092": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2093": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2094": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2095": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2096": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2097": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2098": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2099": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2100": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2101": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2102": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2103": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2104": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2105": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2106": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2107": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2108": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2109": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2110": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2111": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2112": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2113": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2114": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2115": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2116": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2117": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2118": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2119": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2120": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2121": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2122": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2123": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2124": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2125": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2126": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2127": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2128": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2129": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2130": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2131": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2132": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2133": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2134": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2135": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2136": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2137": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2138": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2139": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2140": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2141": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2142": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2143": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2144": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2145": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2146": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2147": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2148": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2149": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2150": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2151": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2152": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2153": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2154": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2155": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2156": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2157": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2158": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2159": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2160": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2161": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2162": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2163": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2164": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2165": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2166": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2167": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2168": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2169": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2170": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2171": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2172": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2173": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2174": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2175": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2176": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2177": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2178": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2179": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2180": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2181": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2182": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2183": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2184": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2185": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2186": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2187": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2188": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2189": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2190": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2191": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2192": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2193": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2194": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2195": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2196": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2197": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2198": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2199": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2200": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2201": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2202": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2203": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2204": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2205": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2206": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2207": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2208": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2209": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2210": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2211": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2212": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2213": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2214": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2215": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2216": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2217": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2218": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2219": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2220": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2221": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2222": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2223": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2224": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2225": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2226": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2227": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2228": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2229": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2230": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2231": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2232": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2233": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2234": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2235": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2236": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2237": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2238": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2239": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2240": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2241": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2242": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2243": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2244": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2245": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2246": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2247": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2248": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2249": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2250": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2251": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2252": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2253": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2254": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2255": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2256": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2257": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2258": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2259": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2260": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2261": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2262": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2263": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2264": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2265": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2266": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2267": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2268": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2269": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2270": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2271": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2272": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2273": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2274": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2275": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2276": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2277": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2278": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2279": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2280": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2281": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2282": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2283": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2284": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2285": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2286": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2287": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2288": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2289": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2290": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2291": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2292": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2293": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2294": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2295": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2296": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2297": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2298": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2299": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2300": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2301": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2302": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2303": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2304": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2305": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2306": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2307": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2308": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2309": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2310": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2311": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2312": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2313": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2314": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2315": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2316": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2317": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2318": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2319": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2320": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2321": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2322": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2323": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2324": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2325": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2326": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2327": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2328": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2329": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2330": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2331": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2332": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2333": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2334": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2335": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2336": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2337": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2338": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2339": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2340": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2341": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2342": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2343": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2344": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2345": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2346": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2347": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2348": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2349": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2350": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2351": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2352": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2353": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2354": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2355": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2356": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2357": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2358": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2359": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2360": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2361": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2362": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2363": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2364": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2365": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2366": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2367": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2368": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2369": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2370": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2371": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2372": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2373": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2374": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2375": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2376": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2377": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2378": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2379": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2380": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2381": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2382": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2383": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2384": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2385": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2386": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2387": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2388": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2389": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2390": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2391": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2392": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2393": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2394": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2395": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2396": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2397": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2398": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2399": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2400": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2401": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2402": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2403": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2404": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2405": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2406": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2407": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2408": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2409": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2410": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2411": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2412": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2413": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2414": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2415": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2416": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2417": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2418": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2419": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2420": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2421": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2422": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2423": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2424": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2425": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2426": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2427": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2428": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2429": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2430": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2431": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2432": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2433": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2434": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2435": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2436": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2437": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2438": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2439": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2440": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2441": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2442": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2443": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2444": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2445": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2446": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2447": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2448": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2449": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2450": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2451": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2452": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2453": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2454": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2455": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2456": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2457": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2458": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2459": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2460": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2461": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2462": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2463": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2464": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2465": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2466": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2467": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2468": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2469": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2470": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2471": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2472": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2473": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2474": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2475": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2476": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2477": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2478": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2479": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2480": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2481": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2482": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2483": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2484": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2485": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2486": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2487": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2488": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2489": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2490": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2491": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2492": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2493": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2494": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2495": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2496": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2497": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2498": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2499": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2500": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2501": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2502": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2503": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2504": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2505": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2506": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2507": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2508": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2509": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2510": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2511": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2512": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2513": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2514": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2515": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2516": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2517": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2518": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2519": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2520": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2521": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2522": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2523": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2524": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2525": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2526": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2527": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2528": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2529": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2530": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2531": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2532": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2533": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2534": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2535": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2536": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2537": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2538": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2539": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2540": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2541": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2542": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2543": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2544": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2545": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2546": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2547": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2548": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2549": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2550": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2551": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2552": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2553": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2554": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2555": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2556": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2557": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2558": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2559": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2560": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2561": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2562": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2563": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2564": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2565": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2566": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2567": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2568": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2569": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2570": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2571": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2572": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2573": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2574": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2575": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2576": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2577": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2578": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2579": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2580": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2581": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2582": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2583": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2584": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2585": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2586": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2587": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2588": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2589": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2590": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2591": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2592": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2593": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2594": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2595": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2596": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2597": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2598": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2599": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2600": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2601": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2602": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2603": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2604": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2605": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2606": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2607": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2608": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2609": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2610": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2611": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2612": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2613": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2614": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2615": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2616": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2617": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2618": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2619": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2620": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2621": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2622": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2623": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2624": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2625": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2626": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2627": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2628": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2629": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2630": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2631": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2632": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2633": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2634": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2635": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2636": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2637": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2638": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2639": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2640": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2641": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2642": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2643": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2644": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2645": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2646": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2647": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2648": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2649": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2650": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2651": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2652": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2653": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2654": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2655": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2656": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2657": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2658": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2659": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2660": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2661": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2662": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2663": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2664": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2665": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2666": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2667": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2668": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2669": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2670": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2671": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2672": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2673": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2674": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2675": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2676": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2677": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2678": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2679": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2680": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2681": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2682": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2683": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2684": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2685": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2686": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2687": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2688": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2689": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2690": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2691": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2692": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2693": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2694": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2695": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2696": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2697": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2698": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2699": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2700": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2701": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2702": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2703": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2704": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2705": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2706": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2707": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2708": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2709": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2710": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2711": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2712": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2713": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2714": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2715": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2716": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2717": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2718": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2719": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2720": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2721": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2722": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2723": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2724": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2725": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2726": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2727": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2728": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2729": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2730": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2731": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2732": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2733": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2734": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2735": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2736": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2737": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2738": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2739": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2740": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2741": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2742": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2743": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2744": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2745": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2746": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2747": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2748": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2749": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2750": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2751": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2752": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2753": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2754": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2755": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2756": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2757": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2758": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2759": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2760": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2761": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2762": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2763": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2764": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2765": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2766": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2767": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2768": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "2769": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2770": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2771": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2772": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2773": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2774": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2775": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2776": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2777": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2778": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2779": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2780": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2781": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2782": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2783": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2784": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2785": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2786": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2787": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2788": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2789": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2790": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2791": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2792": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2793": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2794": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2795": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2796": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2797": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2798": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2799": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2800": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2801": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2802": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2803": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2804": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2805": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2806": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2807": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2808": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2809": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2810": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2811": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2812": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2813": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2814": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2815": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2816": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2817": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2818": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2819": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2820": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2821": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2822": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2823": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2824": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2825": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2826": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2827": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2828": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2829": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2830": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2831": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "2832": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2833": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2834": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2835": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2836": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2837": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2838": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2839": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2840": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2841": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2842": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2843": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2844": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2845": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2846": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2847": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "2848": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2849": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2850": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2851": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2852": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2853": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2854": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2855": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2856": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2857": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "2858": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2859": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2860": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2861": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "2862": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2863": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2864": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2865": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2866": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2867": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2868": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2869": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2870": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2871": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2872": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2873": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2874": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2875": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "2876": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2877": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2878": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2879": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "2880": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2881": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2882": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2883": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2884": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "2885": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2886": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2887": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2888": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2889": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "2890": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "2891": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2892": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "2893": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2894": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2895": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2896": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2897": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2898": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "2899": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2900": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2901": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2902": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2903": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2904": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "2905": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2906": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2907": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2908": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2909": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2910": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2911": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2912": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "2913": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "2914": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2915": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2916": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2917": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2918": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2919": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2920": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2921": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2922": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2923": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "2924": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "2925": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2926": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2927": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "2928": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2929": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2930": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2931": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "2932": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "2933": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2934": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2935": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "2936": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "2937": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "2938": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2939": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2940": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2941": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2942": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "2943": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2944": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "2945": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "2946": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "2947": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2948": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "2949": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "2950": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2951": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2952": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2953": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2954": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2955": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "2956": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "2957": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2958": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "2959": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2960": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2961": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "2962": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "2963": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2964": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2965": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2966": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2967": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2968": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2969": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "2970": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "2971": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "2972": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2973": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "2974": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2975": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "2976": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "2977": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2978": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "2979": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "2980": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "2981": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "2982": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2983": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "2984": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "2985": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "2986": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "2987": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "2988": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "2989": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "2990": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "2991": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "2992": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "2993": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "2994": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "2995": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "2996": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "2997": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "2998": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "2999": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3000": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3001": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3002": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3003": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3004": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3005": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3006": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3007": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3008": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3009": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3010": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3011": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3012": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3013": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3014": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3015": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3016": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3017": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3018": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3019": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3020": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3021": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3022": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3023": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3024": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3025": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3026": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3027": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3028": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3029": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3030": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3031": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3032": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3033": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3034": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3035": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3036": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3037": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3038": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3039": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3040": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3041": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3042": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3043": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3044": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3045": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3046": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3047": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3048": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3049": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3050": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3051": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3052": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3053": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3054": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3055": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3056": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3057": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3058": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3059": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3060": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3061": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3062": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3063": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3064": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3065": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3066": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3067": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3068": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3069": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3070": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3071": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3072": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3073": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3074": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3075": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3076": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3077": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3078": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3079": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3080": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3081": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3082": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3083": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3084": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3085": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3086": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3087": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3088": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3089": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3090": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3091": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3092": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3093": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3094": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3095": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3096": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3097": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3098": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3099": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3100": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3101": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3102": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3103": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3104": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3105": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3106": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3107": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3108": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3109": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3110": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3111": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3112": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3113": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3114": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3115": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3116": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3117": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3118": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3119": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3120": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3121": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3122": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3123": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3124": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3125": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3126": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3127": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3128": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3129": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3130": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3131": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3132": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3133": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3134": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3135": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3136": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3137": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3138": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3139": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3140": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3141": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3142": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3143": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3144": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3145": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3146": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3147": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3148": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3149": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3150": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3151": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3152": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3153": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3154": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3155": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3156": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3157": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3158": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3159": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3160": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3161": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3162": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3163": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3164": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3165": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3166": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3167": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3168": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3169": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3170": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3171": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3172": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3173": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3174": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3175": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3176": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3177": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3178": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3179": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3180": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3181": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3182": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3183": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3184": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3185": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3186": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3187": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3188": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3189": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3190": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3191": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3192": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3193": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3194": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3195": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3196": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3197": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3198": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3199": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3200": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3201": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3202": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3203": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3204": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3205": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3206": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3207": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3208": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3209": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3210": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3211": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3212": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3213": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3214": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3215": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3216": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3217": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3218": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3219": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3220": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3221": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3222": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3223": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3224": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3225": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3226": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3227": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3228": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3229": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3230": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3231": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3232": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3233": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3234": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3235": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3236": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3237": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3238": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3239": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3240": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3241": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3242": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3243": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3244": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3245": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3246": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3247": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3248": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3249": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3250": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3251": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3252": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3253": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3254": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3255": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3256": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3257": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3258": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3259": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3260": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3261": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3262": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3263": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3264": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3265": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3266": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3267": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3268": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3269": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3270": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3271": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3272": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3273": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3274": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3275": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3276": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3277": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3278": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3279": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3280": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3281": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3282": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3283": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3284": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3285": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3286": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3287": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3288": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3289": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3290": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3291": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3292": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3293": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3294": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3295": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3296": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3297": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3298": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3299": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3300": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3301": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3302": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3303": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3304": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3305": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3306": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3307": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3308": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3309": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3310": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3311": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3312": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3313": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3314": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3315": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3316": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3317": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3318": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3319": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3320": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3321": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3322": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3323": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3324": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3325": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3326": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3327": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3328": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3329": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3330": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3331": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3332": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3333": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3334": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3335": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3336": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3337": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3338": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3339": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3340": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3341": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3342": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3343": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3344": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3345": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3346": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3347": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3348": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3349": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3350": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3351": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3352": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3353": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3354": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3355": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3356": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3357": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3358": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3359": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3360": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3361": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3362": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3363": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3364": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3365": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3366": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3367": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3368": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3369": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3370": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3371": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3372": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3373": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3374": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3375": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3376": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3377": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3378": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3379": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3380": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3381": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3382": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3383": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3384": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3385": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3386": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3387": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3388": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3389": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3390": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3391": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3392": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3393": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3394": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3395": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3396": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3397": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3398": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3399": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3400": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3401": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3402": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3403": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3404": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3405": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3406": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3407": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3408": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3409": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3410": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3411": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3412": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3413": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3414": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3415": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3416": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3417": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3418": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3419": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3420": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3421": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3422": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3423": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3424": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3425": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3426": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3427": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3428": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3429": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3430": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3431": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3432": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3433": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3434": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3435": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3436": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3437": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3438": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3439": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3440": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3441": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3442": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3443": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3444": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3445": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3446": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3447": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3448": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3449": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3450": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3451": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3452": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3453": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3454": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3455": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3456": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3457": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3458": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3459": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3460": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3461": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3462": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3463": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3464": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3465": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3466": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3467": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3468": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3469": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3470": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3471": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3472": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3473": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3474": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3475": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3476": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3477": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3478": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3479": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3480": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3481": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3482": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3483": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3484": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3485": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3486": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3487": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3488": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3489": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3490": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3491": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3492": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3493": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3494": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3495": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3496": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3497": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3498": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3499": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3500": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3501": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3502": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3503": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3504": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3505": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3506": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3507": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3508": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3509": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3510": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3511": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3512": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3513": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3514": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3515": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3516": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3517": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3518": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3519": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3520": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3521": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3522": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3523": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3524": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3525": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3526": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3527": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3528": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3529": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3530": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3531": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3532": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3533": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3534": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3535": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3536": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3537": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3538": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3539": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3540": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3541": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3542": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3543": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3544": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3545": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3546": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3547": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3548": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3549": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3550": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3551": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3552": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3553": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3554": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3555": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3556": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3557": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3558": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3559": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3560": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3561": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3562": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3563": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3564": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3565": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3566": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3567": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3568": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3569": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3570": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3571": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3572": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3573": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3574": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3575": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3576": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3577": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3578": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3579": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3580": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3581": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3582": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3583": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3584": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3585": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3586": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3587": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3588": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3589": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3590": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3591": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3592": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3593": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3594": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3595": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3596": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3597": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3598": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3599": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3600": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3601": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3602": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3603": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3604": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3605": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3606": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3607": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3608": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3609": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3610": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3611": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3612": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3613": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3614": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3615": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3616": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3617": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3618": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3619": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3620": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3621": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3622": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3623": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3624": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3625": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3626": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3627": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3628": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3629": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3630": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3631": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3632": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3633": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3634": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3635": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3636": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3637": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3638": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3639": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3640": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3641": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3642": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3643": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3644": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3645": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3646": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3647": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3648": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3649": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3650": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3651": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3652": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3653": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3654": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3655": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3656": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3657": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3658": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3659": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3660": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3661": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3662": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3663": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3664": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3665": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3666": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3667": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3668": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3669": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3670": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3671": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3672": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3673": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3674": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3675": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3676": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3677": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3678": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3679": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3680": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3681": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3682": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3683": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3684": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3685": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3686": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3687": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3688": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3689": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3690": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3691": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3692": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3693": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3694": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3695": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3696": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3697": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3698": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3699": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3700": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3701": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3702": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3703": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3704": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3705": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3706": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3707": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3708": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3709": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3710": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3711": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3712": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3713": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3714": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3715": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3716": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3717": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3718": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3719": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3720": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3721": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3722": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3723": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3724": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3725": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3726": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3727": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3728": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3729": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3730": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3731": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3732": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3733": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3734": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3735": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3736": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3737": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3738": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3739": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3740": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3741": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3742": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3743": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3744": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3745": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3746": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3747": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3748": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3749": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3750": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3751": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3752": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3753": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3754": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3755": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3756": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3757": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3758": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3759": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3760": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3761": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3762": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3763": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3764": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3765": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3766": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3767": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3768": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3769": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3770": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3771": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3772": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3773": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3774": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3775": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3776": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3777": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3778": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3779": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3780": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3781": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3782": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3783": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3784": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3785": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3786": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3787": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3788": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3789": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3790": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3791": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3792": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3793": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3794": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3795": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3796": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3797": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3798": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3799": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3800": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3801": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3802": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3803": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3804": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3805": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3806": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3807": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3808": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3809": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3810": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3811": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3812": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3813": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.205752573798, 43.451404291925],
        },
        "3814": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3815": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3816": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3817": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3818": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3819": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3820": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3821": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3822": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3823": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3824": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3825": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3826": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3827": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3828": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3829": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3830": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3831": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3832": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3833": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3834": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3835": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3836": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.542664728949, 87.401654917536],
        },
        "3837": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3838": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3839": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3840": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3841": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3842": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3843": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.33200474818, 1.9428326671694],
        },
        "3844": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3845": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3846": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3847": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3848": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3849": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3850": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3851": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3852": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3853": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3854": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3855": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3856": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3857": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3858": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3859": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3860": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3861": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3862": {
            "vr": "DS",
            "Value": [-117.42307591438, -84.005826197455, 89.843335825739],
        },
        "3863": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3864": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3865": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3866": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3867": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3868": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3869": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3870": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3871": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3872": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3873": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "3874": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3875": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3876": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3877": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.616339884589, 82.518293101129],
        },
        "3878": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3879": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3880": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3881": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3882": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3883": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3884": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3885": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3886": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.60560961802, -49.33246068305],
        },
        "3887": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3888": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3889": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3890": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3891": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3892": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3893": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3894": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
        "3895": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3896": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3897": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3898": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.99509450037, -42.007417958441],
        },
        "3899": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.40568181116, -2.9405291492369],
        },
        "3900": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.81626816828, 36.126361567316],
        },
        "3901": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3902": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3903": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3904": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.426783762762, 28.801319557962],
        },
        "3905": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.25832863886, 6.826192576227],
        },
        "3906": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.70038815577, -22.473974507513],
        },
        "3907": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3908": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3909": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3910": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3911": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3912": {
            "vr": "DS",
            "Value": [-117.42307591438, -114.06877132494, -46.890779774847],
        },
        "3913": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3914": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3915": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3916": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3917": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.38457985956, -34.682379048529],
        },
        "3918": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.55303498347, -12.707250874701],
        },
        "3919": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3920": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3921": {
            "vr": "DS",
            "Value": [-117.42307591438, -97.963622294257, 26.359638768968],
        },
        "3922": {
            "vr": "DS",
            "Value": [-117.42307591438, -111.92141791422, -37.124059956732],
        },
        "3923": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3924": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "3925": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3926": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3927": {
            "vr": "DS",
            "Value": [-117.42307591438, -91.521561823676, 55.659806925592],
        },
        "3928": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3929": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3930": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3931": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.64781304438, 14.151235300836],
        },
        "3932": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3933": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3934": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3935": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3936": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "3937": {
            "vr": "DS",
            "Value": [-117.42307591438, -108.16354962427, -20.03229359931],
        },
        "3938": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3939": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3940": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "3941": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3942": {
            "vr": "DS",
            "Value": [-117.42307591438, -94.742591105292, 41.009723383722],
        },
        "3943": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3944": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3945": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3946": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3947": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3948": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3949": {
            "vr": "DS",
            "Value": [-117.42307591438, -105.47935792048, -7.8238890582945],
        },
        "3950": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3951": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3952": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3953": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3954": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3955": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.57413598139, 19.034596640405],
        },
        "3956": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "3957": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3958": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "3959": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3960": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.837371073553, 67.868211466608],
        },
        "3961": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3962": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3963": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3964": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3965": {
            "vr": "DS",
            "Value": [-117.42307591438, -104.94251938898, -5.38221005744],
        },
        "3966": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "3967": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "3968": {
            "vr": "DS",
            "Value": [-117.42307591438, -95.279429636786, 38.568042475519],
        },
        "3969": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "3970": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3971": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.226855479071, 75.193254191217],
        },
        "3972": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.31090279658, -29.799017232123],
        },
        "3973": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3974": {
            "vr": "DS",
            "Value": [-117.42307591438, -112.45825644572, -39.565737050238],
        },
        "3975": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "3976": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.05840035517, 53.218126017389],
        },
        "3977": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.690016947577, 77.63493509942],
        },
        "3978": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3979": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3980": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "3981": {
            "vr": "DS",
            "Value": [-117.42307591438, -87.763694010565, 72.751573283014],
        },
        "3982": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "3983": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.72149010737, 9.2678734844301],
        },
        "3984": {
            "vr": "DS",
            "Value": [-117.42307591438, -106.01619645197, -10.265569966498],
        },
        "3985": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "3986": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3987": {
            "vr": "DS",
            "Value": [-117.42307591438, -99.037297449896, 21.476277548609],
        },
        "3988": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.911046229193, 62.984849650202],
        },
        "3989": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "3990": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "3991": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.984723292181, 58.101487833795],
        },
        "3992": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.353106699774, 33.684680659113],
        },
        "3993": {
            "vr": "DS",
            "Value": [-117.42307591438, -86.153178416083, 80.076612192926],
        },
        "3994": {
            "vr": "DS",
            "Value": [-117.42307591438, -102.79516621668, 4.3845116680239],
        },
        "3995": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.62671109278, -17.590612691107],
        },
        "3996": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "3997": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "3998": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.23722621042, -24.915655415716],
        },
        "3999": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.132077418158, 48.334764200983],
        },
        "4000": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "4001": {
            "vr": "DS",
            "Value": [-117.42307591438, -90.447884760687, 60.543168741998],
        },
        "4002": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "4003": {
            "vr": "DS",
            "Value": [-117.42307591438, -82.932149134467, 94.726697642145],
        },
        "4004": {
            "vr": "DS",
            "Value": [-117.42307591438, -107.08987351496, -15.148931782904],
        },
        "4005": {
            "vr": "DS",
            "Value": [-117.42307591438, -96.889945231268, 31.243000227747],
        },
        "4006": {
            "vr": "DS",
            "Value": [-117.42307591438, -113.53193303187, -44.449098866644],
        },
        "4007": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "4008": {
            "vr": "DS",
            "Value": [-117.42307591438, -101.18465157587, 11.709554392633],
        },
        "4009": {
            "vr": "DS",
            "Value": [-117.42307591438, -110.84774132807, -32.240698140326],
        },
        "4010": {
            "vr": "DS",
            "Value": [-117.42307591438, -85.079503260443, 84.959974009332],
        },
        "4011": {
            "vr": "DS",
            "Value": [-117.42307591438, -88.300532542059, 70.309892374811],
        },
        "4012": {
            "vr": "DS",
            "Value": [-117.42307591438, -89.374207697699, 65.426530558405],
        },
        "4013": {
            "vr": "DS",
            "Value": [-117.42307591438, -92.595238886664, 50.776445109186],
        },
        "4014": {
            "vr": "DS",
            "Value": [-117.42307591438, -109.77406474192, -27.35733632392],
        },
        "4015": {
            "vr": "DS",
            "Value": [-117.42307591438, -83.468987665961, 92.285016733942],
        },
        "4016": {
            "vr": "DS",
            "Value": [-117.42307591438, -93.668915949652, 45.893085200128],
        },
        "4017": {
            "vr": "DS",
            "Value": [-117.42307591438, -98.500460825751, 23.917958099184],
        },
        "4018": {
            "vr": "DS",
            "Value": [-117.42307591438, -100.11097451288, 16.592916209039],
        },
        "4019": {
            "vr": "DS",
            "Value": [-117.42307591438, -103.86884327967, -0.4988482410338],
        },
    },
    "00201041": {
        "0": {"vr": "DS", "Value": [17.208478043704]},
        "1": {"vr": "DS", "Value": [62.208476194959]},
        "2": {"vr": "DS", "Value": [-20.291521415365]},
        "3": {"vr": "DS", "Value": [-47.791521826579]},
        "4": {"vr": "DS", "Value": [-20.291521415365]},
        "5": {"vr": "DS", "Value": [-5.291521963351]},
        "6": {"vr": "DS", "Value": [-60.291522888171]},
        "7": {"vr": "DS", "Value": [-30.291520360827]},
        "8": {"vr": "DS", "Value": [-10.291522469903]},
        "9": {"vr": "DS", "Value": [37.208477797483]},
        "10": {"vr": "DS", "Value": [12.208477537152]},
        "11": {"vr": "DS", "Value": [44.708478557311]},
        "12": {"vr": "DS", "Value": [42.208478304035]},
        "13": {"vr": "DS", "Value": [49.708478654288]},
        "14": {"vr": "DS", "Value": [-25.291521921917]},
        "15": {"vr": "DS", "Value": [57.208479414116]},
        "16": {"vr": "DS", "Value": [-0.2915219225125]},
        "17": {"vr": "DS", "Value": [4.7084775923224]},
        "18": {"vr": "DS", "Value": [-42.79152142242]},
        "19": {"vr": "DS", "Value": [29.708477037655]},
        "20": {"vr": "DS", "Value": [-65.291519566621]},
        "21": {"vr": "DS", "Value": [-57.791522737289]},
        "22": {"vr": "DS", "Value": [62.208476194959]},
        "23": {"vr": "DS", "Value": [22.208478550256]},
        "24": {"vr": "DS", "Value": [-15.291522976455]},
        "25": {"vr": "DS", "Value": [29.708477037655]},
        "26": {"vr": "DS", "Value": [-60.291522888171]},
        "27": {"vr": "DS", "Value": [-52.791522230737]},
        "28": {"vr": "DS", "Value": [-40.291521169144]},
        "29": {"vr": "DS", "Value": [-35.29152086738]},
        "30": {"vr": "DS", "Value": [4.7084775923224]},
        "31": {"vr": "DS", "Value": [-22.791521668641]},
        "32": {"vr": "DS", "Value": [32.208477290931]},
        "33": {"vr": "DS", "Value": [19.70847829698]},
        "34": {"vr": "DS", "Value": [52.208478907564]},
        "35": {"vr": "DS", "Value": [-65.291519566621]},
        "36": {"vr": "DS", "Value": [27.208476784379]},
        "37": {"vr": "DS", "Value": [-65.291519566621]},
        "38": {"vr": "DS", "Value": [47.208478401012]},
        "39": {"vr": "DS", "Value": [4.7084775923224]},
        "40": {"vr": "DS", "Value": [37.208477797483]},
        "41": {"vr": "DS", "Value": [-32.791520614104]},
        "42": {"vr": "DS", "Value": [-0.2915219225125]},
        "43": {"vr": "DS", "Value": [-37.791521120656]},
        "44": {"vr": "DS", "Value": [-62.791519415738]},
        "45": {"vr": "DS", "Value": [62.208476194959]},
        "46": {"vr": "DS", "Value": [52.208478907564]},
        "47": {"vr": "DS", "Value": [-0.2915219225125]},
        "48": {"vr": "DS", "Value": [49.708478654288]},
        "49": {"vr": "DS", "Value": [62.208476194959]},
        "50": {"vr": "DS", "Value": [14.708477790428]},
        "51": {"vr": "DS", "Value": [4.7084775923224]},
        "52": {"vr": "DS", "Value": [34.708477544207]},
        "53": {"vr": "DS", "Value": [-72.791520224055]},
        "54": {"vr": "DS", "Value": [27.208476784379]},
        "55": {"vr": "DS", "Value": [19.70847829698]},
        "56": {"vr": "DS", "Value": [44.708478557311]},
        "57": {"vr": "DS", "Value": [14.708477790428]},
        "58": {"vr": "DS", "Value": [-40.291521169144]},
        "59": {"vr": "DS", "Value": [-65.291519566621]},
        "60": {"vr": "DS", "Value": [47.208478401012]},
        "61": {"vr": "DS", "Value": [-0.2915219225125]},
        "62": {"vr": "DS", "Value": [74.708477051764]},
        "63": {"vr": "DS", "Value": [47.208478401012]},
        "64": {"vr": "DS", "Value": [42.208478304035]},
        "65": {"vr": "DS", "Value": [-55.291522484013]},
        "66": {"vr": "DS", "Value": [-32.791520614104]},
        "67": {"vr": "DS", "Value": [-12.791522723179]},
        "68": {"vr": "DS", "Value": [57.208479414116]},
        "69": {"vr": "DS", "Value": [-12.791522723179]},
        "70": {"vr": "DS", "Value": [-20.291521415365]},
        "71": {"vr": "DS", "Value": [62.208476194959]},
        "72": {"vr": "DS", "Value": [29.708477037655]},
        "73": {"vr": "DS", "Value": [-52.791522230737]},
        "74": {"vr": "DS", "Value": [2.2084775719032]},
        "75": {"vr": "DS", "Value": [-72.791520224055]},
        "76": {"vr": "DS", "Value": [-15.291522976455]},
        "77": {"vr": "DS", "Value": [54.70847916084]},
        "78": {"vr": "DS", "Value": [-15.291522976455]},
        "79": {"vr": "DS", "Value": [-10.291522469903]},
        "80": {"vr": "DS", "Value": [-12.791522723179]},
        "81": {"vr": "DS", "Value": [-12.791522723179]},
        "82": {"vr": "DS", "Value": [69.708476545212]},
        "83": {"vr": "DS", "Value": [27.208476784379]},
        "84": {"vr": "DS", "Value": [57.208479414116]},
        "85": {"vr": "DS", "Value": [-2.7915221757886]},
        "86": {"vr": "DS", "Value": [22.208478550256]},
        "87": {"vr": "DS", "Value": [64.70847603866]},
        "88": {"vr": "DS", "Value": [-10.291522469903]},
        "89": {"vr": "DS", "Value": [42.208478304035]},
        "90": {"vr": "DS", "Value": [-0.2915219225125]},
        "91": {"vr": "DS", "Value": [-32.791520614104]},
        "92": {"vr": "DS", "Value": [-20.291521415365]},
        "93": {"vr": "DS", "Value": [-50.291522079855]},
        "94": {"vr": "DS", "Value": [-72.791520224055]},
        "95": {"vr": "DS", "Value": [12.208477537152]},
        "96": {"vr": "DS", "Value": [52.208478907564]},
        "97": {"vr": "DS", "Value": [-32.791520614104]},
        "98": {"vr": "DS", "Value": [54.70847916084]},
        "99": {"vr": "DS", "Value": [-72.791520224055]},
        "100": {"vr": "DS", "Value": [47.208478401012]},
        "101": {"vr": "DS", "Value": [-27.791521970406]},
        "102": {"vr": "DS", "Value": [-30.291520360827]},
        "103": {"vr": "DS", "Value": [-60.291522888171]},
        "104": {"vr": "DS", "Value": [19.70847829698]},
        "105": {"vr": "DS", "Value": [-20.291521415365]},
        "106": {"vr": "DS", "Value": [-5.291521963351]},
        "107": {"vr": "DS", "Value": [14.708477790428]},
        "108": {"vr": "DS", "Value": [64.70847603866]},
        "109": {"vr": "DS", "Value": [-37.791521120656]},
        "110": {"vr": "DS", "Value": [17.208478043704]},
        "111": {"vr": "DS", "Value": [-17.791523024944]},
        "112": {"vr": "DS", "Value": [-45.291521675696]},
        "113": {"vr": "DS", "Value": [14.708477790428]},
        "114": {"vr": "DS", "Value": [-17.791523024944]},
        "115": {"vr": "DS", "Value": [4.7084775923224]},
        "116": {"vr": "DS", "Value": [7.2084777291701]},
        "117": {"vr": "DS", "Value": [74.708477051764]},
        "118": {"vr": "DS", "Value": [54.70847916084]},
        "119": {"vr": "DS", "Value": [57.208479414116]},
        "120": {"vr": "DS", "Value": [62.208476194959]},
        "121": {"vr": "DS", "Value": [42.208478304035]},
        "122": {"vr": "DS", "Value": [37.208477797483]},
        "123": {"vr": "DS", "Value": [4.7084775923224]},
        "124": {"vr": "DS", "Value": [-7.7915222166271]},
        "125": {"vr": "DS", "Value": [-35.29152086738]},
        "126": {"vr": "DS", "Value": [47.208478401012]},
        "127": {"vr": "DS", "Value": [-27.791521970406]},
        "128": {"vr": "DS", "Value": [-45.291521675696]},
        "129": {"vr": "DS", "Value": [-7.7915222166271]},
        "130": {"vr": "DS", "Value": [74.708477051764]},
        "131": {"vr": "DS", "Value": [-5.291521963351]},
        "132": {"vr": "DS", "Value": [-35.29152086738]},
        "133": {"vr": "DS", "Value": [34.708477544207]},
        "134": {"vr": "DS", "Value": [14.708477790428]},
        "135": {"vr": "DS", "Value": [17.208478043704]},
        "136": {"vr": "DS", "Value": [19.70847829698]},
        "137": {"vr": "DS", "Value": [-20.291521415365]},
        "138": {"vr": "DS", "Value": [17.208478043704]},
        "139": {"vr": "DS", "Value": [12.208477537152]},
        "140": {"vr": "DS", "Value": [-70.291520021976]},
        "141": {"vr": "DS", "Value": [12.208477537152]},
        "142": {"vr": "DS", "Value": [59.708475941683]},
        "143": {"vr": "DS", "Value": [62.208476194959]},
        "144": {"vr": "DS", "Value": [-25.291521921917]},
        "145": {"vr": "DS", "Value": [-17.791523024944]},
        "146": {"vr": "DS", "Value": [19.70847829698]},
        "147": {"vr": "DS", "Value": [-62.791519415738]},
        "148": {"vr": "DS", "Value": [-50.291522079855]},
        "149": {"vr": "DS", "Value": [-2.7915221757886]},
        "150": {"vr": "DS", "Value": [27.208476784379]},
        "151": {"vr": "DS", "Value": [42.208478304035]},
        "152": {"vr": "DS", "Value": [57.208479414116]},
        "153": {"vr": "DS", "Value": [-47.791521826579]},
        "154": {"vr": "DS", "Value": [-35.29152086738]},
        "155": {"vr": "DS", "Value": [-22.791521668641]},
        "156": {"vr": "DS", "Value": [14.708477790428]},
        "157": {"vr": "DS", "Value": [-57.791522737289]},
        "158": {"vr": "DS", "Value": [59.708475941683]},
        "159": {"vr": "DS", "Value": [2.2084775719032]},
        "160": {"vr": "DS", "Value": [17.208478043704]},
        "161": {"vr": "DS", "Value": [59.708475941683]},
        "162": {"vr": "DS", "Value": [72.208476798488]},
        "163": {"vr": "DS", "Value": [-47.791521826579]},
        "164": {"vr": "DS", "Value": [42.208478304035]},
        "165": {"vr": "DS", "Value": [-45.291521675696]},
        "166": {"vr": "DS", "Value": [52.208478907564]},
        "167": {"vr": "DS", "Value": [39.708478050759]},
        "168": {"vr": "DS", "Value": [12.208477537152]},
        "169": {"vr": "DS", "Value": [59.708475941683]},
        "170": {"vr": "DS", "Value": [29.708477037655]},
        "171": {"vr": "DS", "Value": [-72.791520224055]},
        "172": {"vr": "DS", "Value": [-40.291521169144]},
        "173": {"vr": "DS", "Value": [-22.791521668641]},
        "174": {"vr": "DS", "Value": [29.708477037655]},
        "175": {"vr": "DS", "Value": [2.2084775719032]},
        "176": {"vr": "DS", "Value": [9.7084777495894]},
        "177": {"vr": "DS", "Value": [-70.291520021976]},
        "178": {"vr": "DS", "Value": [-42.79152142242]},
        "179": {"vr": "DS", "Value": [19.70847829698]},
        "180": {"vr": "DS", "Value": [14.708477790428]},
        "181": {"vr": "DS", "Value": [72.208476798488]},
        "182": {"vr": "DS", "Value": [24.708478393957]},
        "183": {"vr": "DS", "Value": [37.208477797483]},
        "184": {"vr": "DS", "Value": [-45.291521675696]},
        "185": {"vr": "DS", "Value": [-57.791522737289]},
        "186": {"vr": "DS", "Value": [-30.291520360827]},
        "187": {"vr": "DS", "Value": [19.70847829698]},
        "188": {"vr": "DS", "Value": [54.70847916084]},
        "189": {"vr": "DS", "Value": [74.708477051764]},
        "190": {"vr": "DS", "Value": [-7.7915222166271]},
        "191": {"vr": "DS", "Value": [67.208476291936]},
        "192": {"vr": "DS", "Value": [-72.791520224055]},
        "193": {"vr": "DS", "Value": [54.70847916084]},
        "194": {"vr": "DS", "Value": [-35.29152086738]},
        "195": {"vr": "DS", "Value": [-42.79152142242]},
        "196": {"vr": "DS", "Value": [-70.291520021976]},
        "197": {"vr": "DS", "Value": [2.2084775719032]},
        "198": {"vr": "DS", "Value": [14.708477790428]},
        "199": {"vr": "DS", "Value": [-42.79152142242]},
        "200": {"vr": "DS", "Value": [27.208476784379]},
        "201": {"vr": "DS", "Value": [-30.291520360827]},
        "202": {"vr": "DS", "Value": [39.708478050759]},
        "203": {"vr": "DS", "Value": [-67.791519819897]},
        "204": {"vr": "DS", "Value": [-25.291521921917]},
        "205": {"vr": "DS", "Value": [2.2084775719032]},
        "206": {"vr": "DS", "Value": [-30.291520360827]},
        "207": {"vr": "DS", "Value": [-55.291522484013]},
        "208": {"vr": "DS", "Value": [62.208476194959]},
        "209": {"vr": "DS", "Value": [14.708477790428]},
        "210": {"vr": "DS", "Value": [-12.791522723179]},
        "211": {"vr": "DS", "Value": [-5.291521963351]},
        "212": {"vr": "DS", "Value": [47.208478401012]},
        "213": {"vr": "DS", "Value": [-60.291522888171]},
        "214": {"vr": "DS", "Value": [17.208478043704]},
        "215": {"vr": "DS", "Value": [-72.791520224055]},
        "216": {"vr": "DS", "Value": [-25.291521921917]},
        "217": {"vr": "DS", "Value": [72.208476798488]},
        "218": {"vr": "DS", "Value": [-0.2915219225125]},
        "219": {"vr": "DS", "Value": [67.208476291936]},
        "220": {"vr": "DS", "Value": [14.708477790428]},
        "221": {"vr": "DS", "Value": [-22.791521668641]},
        "222": {"vr": "DS", "Value": [42.208478304035]},
        "223": {"vr": "DS", "Value": [67.208476291936]},
        "224": {"vr": "DS", "Value": [27.208476784379]},
        "225": {"vr": "DS", "Value": [19.70847829698]},
        "226": {"vr": "DS", "Value": [-30.291520360827]},
        "227": {"vr": "DS", "Value": [-57.791522737289]},
        "228": {"vr": "DS", "Value": [17.208478043704]},
        "229": {"vr": "DS", "Value": [-12.791522723179]},
        "230": {"vr": "DS", "Value": [72.208476798488]},
        "231": {"vr": "DS", "Value": [22.208478550256]},
        "232": {"vr": "DS", "Value": [-55.291522484013]},
        "233": {"vr": "DS", "Value": [-0.2915219225125]},
        "234": {"vr": "DS", "Value": [74.708477051764]},
        "235": {"vr": "DS", "Value": [-40.291521169144]},
        "236": {"vr": "DS", "Value": [-32.791520614104]},
        "237": {"vr": "DS", "Value": [57.208479414116]},
        "238": {"vr": "DS", "Value": [-62.791519415738]},
        "239": {"vr": "DS", "Value": [24.708478393957]},
        "240": {"vr": "DS", "Value": [39.708478050759]},
        "241": {"vr": "DS", "Value": [-67.791519819897]},
        "242": {"vr": "DS", "Value": [7.2084777291701]},
        "243": {"vr": "DS", "Value": [39.708478050759]},
        "244": {"vr": "DS", "Value": [42.208478304035]},
        "245": {"vr": "DS", "Value": [-67.791519819897]},
        "246": {"vr": "DS", "Value": [44.708478557311]},
        "247": {"vr": "DS", "Value": [-35.29152086738]},
        "248": {"vr": "DS", "Value": [-67.791519819897]},
        "249": {"vr": "DS", "Value": [-32.791520614104]},
        "250": {"vr": "DS", "Value": [57.208479414116]},
        "251": {"vr": "DS", "Value": [14.708477790428]},
        "252": {"vr": "DS", "Value": [34.708477544207]},
        "253": {"vr": "DS", "Value": [-65.291519566621]},
        "254": {"vr": "DS", "Value": [47.208478401012]},
        "255": {"vr": "DS", "Value": [67.208476291936]},
        "256": {"vr": "DS", "Value": [2.2084775719032]},
        "257": {"vr": "DS", "Value": [-65.291519566621]},
        "258": {"vr": "DS", "Value": [-25.291521921917]},
        "259": {"vr": "DS", "Value": [-2.7915221757886]},
        "260": {"vr": "DS", "Value": [-32.791520614104]},
        "261": {"vr": "DS", "Value": [-12.791522723179]},
        "262": {"vr": "DS", "Value": [-20.291521415365]},
        "263": {"vr": "DS", "Value": [-7.7915222166271]},
        "264": {"vr": "DS", "Value": [-30.291520360827]},
        "265": {"vr": "DS", "Value": [-10.291522469903]},
        "266": {"vr": "DS", "Value": [-72.791520224055]},
        "267": {"vr": "DS", "Value": [-72.791520224055]},
        "268": {"vr": "DS", "Value": [67.208476291936]},
        "269": {"vr": "DS", "Value": [7.2084777291701]},
        "270": {"vr": "DS", "Value": [62.208476194959]},
        "271": {"vr": "DS", "Value": [-67.791519819897]},
        "272": {"vr": "DS", "Value": [62.208476194959]},
        "273": {"vr": "DS", "Value": [-62.791519415738]},
        "274": {"vr": "DS", "Value": [-25.291521921917]},
        "275": {"vr": "DS", "Value": [-27.791521970406]},
        "276": {"vr": "DS", "Value": [47.208478401012]},
        "277": {"vr": "DS", "Value": [-0.2915219225125]},
        "278": {"vr": "DS", "Value": [-15.291522976455]},
        "279": {"vr": "DS", "Value": [-7.7915222166271]},
        "280": {"vr": "DS", "Value": [-22.791521668641]},
        "281": {"vr": "DS", "Value": [-65.291519566621]},
        "282": {"vr": "DS", "Value": [-22.791521668641]},
        "283": {"vr": "DS", "Value": [62.208476194959]},
        "284": {"vr": "DS", "Value": [-60.291522888171]},
        "285": {"vr": "DS", "Value": [-17.791523024944]},
        "286": {"vr": "DS", "Value": [57.208479414116]},
        "287": {"vr": "DS", "Value": [-47.791521826579]},
        "288": {"vr": "DS", "Value": [-32.791520614104]},
        "289": {"vr": "DS", "Value": [62.208476194959]},
        "290": {"vr": "DS", "Value": [-60.291522888171]},
        "291": {"vr": "DS", "Value": [-12.791522723179]},
        "292": {"vr": "DS", "Value": [-2.7915221757886]},
        "293": {"vr": "DS", "Value": [39.708478050759]},
        "294": {"vr": "DS", "Value": [72.208476798488]},
        "295": {"vr": "DS", "Value": [-62.791519415738]},
        "296": {"vr": "DS", "Value": [-70.291520021976]},
        "297": {"vr": "DS", "Value": [-50.291522079855]},
        "298": {"vr": "DS", "Value": [-62.791519415738]},
        "299": {"vr": "DS", "Value": [2.2084775719032]},
        "300": {"vr": "DS", "Value": [4.7084775923224]},
        "301": {"vr": "DS", "Value": [54.70847916084]},
        "302": {"vr": "DS", "Value": [-25.291521921917]},
        "303": {"vr": "DS", "Value": [-72.791520224055]},
        "304": {"vr": "DS", "Value": [44.708478557311]},
        "305": {"vr": "DS", "Value": [9.7084777495894]},
        "306": {"vr": "DS", "Value": [47.208478401012]},
        "307": {"vr": "DS", "Value": [-32.791520614104]},
        "308": {"vr": "DS", "Value": [4.7084775923224]},
        "309": {"vr": "DS", "Value": [-17.791523024944]},
        "310": {"vr": "DS", "Value": [49.708478654288]},
        "311": {"vr": "DS", "Value": [-50.291522079855]},
        "312": {"vr": "DS", "Value": [-17.791523024944]},
        "313": {"vr": "DS", "Value": [-62.791519415738]},
        "314": {"vr": "DS", "Value": [-40.291521169144]},
        "315": {"vr": "DS", "Value": [32.208477290931]},
        "316": {"vr": "DS", "Value": [-30.291520360827]},
        "317": {"vr": "DS", "Value": [47.208478401012]},
        "318": {"vr": "DS", "Value": [64.70847603866]},
        "319": {"vr": "DS", "Value": [74.708477051764]},
        "320": {"vr": "DS", "Value": [-35.29152086738]},
        "321": {"vr": "DS", "Value": [-57.791522737289]},
        "322": {"vr": "DS", "Value": [39.708478050759]},
        "323": {"vr": "DS", "Value": [22.208478550256]},
        "324": {"vr": "DS", "Value": [29.708477037655]},
        "325": {"vr": "DS", "Value": [-50.291522079855]},
        "326": {"vr": "DS", "Value": [69.708476545212]},
        "327": {"vr": "DS", "Value": [-17.791523024944]},
        "328": {"vr": "DS", "Value": [22.208478550256]},
        "329": {"vr": "DS", "Value": [22.208478550256]},
        "330": {"vr": "DS", "Value": [-7.7915222166271]},
        "331": {"vr": "DS", "Value": [-32.791520614104]},
        "332": {"vr": "DS", "Value": [22.208478550256]},
        "333": {"vr": "DS", "Value": [-2.7915221757886]},
        "334": {"vr": "DS", "Value": [2.2084775719032]},
        "335": {"vr": "DS", "Value": [19.70847829698]},
        "336": {"vr": "DS", "Value": [49.708478654288]},
        "337": {"vr": "DS", "Value": [37.208477797483]},
        "338": {"vr": "DS", "Value": [-37.791521120656]},
        "339": {"vr": "DS", "Value": [37.208477797483]},
        "340": {"vr": "DS", "Value": [-10.291522469903]},
        "341": {"vr": "DS", "Value": [-25.291521921917]},
        "342": {"vr": "DS", "Value": [57.208479414116]},
        "343": {"vr": "DS", "Value": [12.208477537152]},
        "344": {"vr": "DS", "Value": [-35.29152086738]},
        "345": {"vr": "DS", "Value": [-20.291521415365]},
        "346": {"vr": "DS", "Value": [4.7084775923224]},
        "347": {"vr": "DS", "Value": [-2.7915221757886]},
        "348": {"vr": "DS", "Value": [9.7084777495894]},
        "349": {"vr": "DS", "Value": [39.708478050759]},
        "350": {"vr": "DS", "Value": [-27.791521970406]},
        "351": {"vr": "DS", "Value": [-7.7915222166271]},
        "352": {"vr": "DS", "Value": [64.70847603866]},
        "353": {"vr": "DS", "Value": [-30.291520360827]},
        "354": {"vr": "DS", "Value": [-15.291522976455]},
        "355": {"vr": "DS", "Value": [-35.29152086738]},
        "356": {"vr": "DS", "Value": [7.2084777291701]},
        "357": {"vr": "DS", "Value": [17.208478043704]},
        "358": {"vr": "DS", "Value": [52.208478907564]},
        "359": {"vr": "DS", "Value": [-32.791520614104]},
        "360": {"vr": "DS", "Value": [-50.291522079855]},
        "361": {"vr": "DS", "Value": [64.70847603866]},
        "362": {"vr": "DS", "Value": [49.708478654288]},
        "363": {"vr": "DS", "Value": [67.208476291936]},
        "364": {"vr": "DS", "Value": [-40.291521169144]},
        "365": {"vr": "DS", "Value": [-50.291522079855]},
        "366": {"vr": "DS", "Value": [19.70847829698]},
        "367": {"vr": "DS", "Value": [-7.7915222166271]},
        "368": {"vr": "DS", "Value": [-0.2915219225125]},
        "369": {"vr": "DS", "Value": [9.7084777495894]},
        "370": {"vr": "DS", "Value": [59.708475941683]},
        "371": {"vr": "DS", "Value": [34.708477544207]},
        "372": {"vr": "DS", "Value": [42.208478304035]},
        "373": {"vr": "DS", "Value": [27.208476784379]},
        "374": {"vr": "DS", "Value": [34.708477544207]},
        "375": {"vr": "DS", "Value": [-45.291521675696]},
        "376": {"vr": "DS", "Value": [-67.791519819897]},
        "377": {"vr": "DS", "Value": [37.208477797483]},
        "378": {"vr": "DS", "Value": [34.708477544207]},
        "379": {"vr": "DS", "Value": [32.208477290931]},
        "380": {"vr": "DS", "Value": [67.208476291936]},
        "381": {"vr": "DS", "Value": [69.708476545212]},
        "382": {"vr": "DS", "Value": [2.2084775719032]},
        "383": {"vr": "DS", "Value": [-17.791523024944]},
        "384": {"vr": "DS", "Value": [19.70847829698]},
        "385": {"vr": "DS", "Value": [59.708475941683]},
        "386": {"vr": "DS", "Value": [-57.791522737289]},
        "387": {"vr": "DS", "Value": [9.7084777495894]},
        "388": {"vr": "DS", "Value": [-42.79152142242]},
        "389": {"vr": "DS", "Value": [-30.291520360827]},
        "390": {"vr": "DS", "Value": [59.708475941683]},
        "391": {"vr": "DS", "Value": [-65.291519566621]},
        "392": {"vr": "DS", "Value": [-45.291521675696]},
        "393": {"vr": "DS", "Value": [59.708475941683]},
        "394": {"vr": "DS", "Value": [-45.291521675696]},
        "395": {"vr": "DS", "Value": [22.208478550256]},
        "396": {"vr": "DS", "Value": [-72.791520224055]},
        "397": {"vr": "DS", "Value": [-60.291522888171]},
        "398": {"vr": "DS", "Value": [-67.791519819897]},
        "399": {"vr": "DS", "Value": [7.2084777291701]},
        "400": {"vr": "DS", "Value": [-50.291522079855]},
        "401": {"vr": "DS", "Value": [22.208478550256]},
        "402": {"vr": "DS", "Value": [7.2084777291701]},
        "403": {"vr": "DS", "Value": [-22.791521668641]},
        "404": {"vr": "DS", "Value": [-30.291520360827]},
        "405": {"vr": "DS", "Value": [-17.791523024944]},
        "406": {"vr": "DS", "Value": [22.208478550256]},
        "407": {"vr": "DS", "Value": [9.7084777495894]},
        "408": {"vr": "DS", "Value": [-2.7915221757886]},
        "409": {"vr": "DS", "Value": [-70.291520021976]},
        "410": {"vr": "DS", "Value": [-37.791521120656]},
        "411": {"vr": "DS", "Value": [44.708478557311]},
        "412": {"vr": "DS", "Value": [-52.791522230737]},
        "413": {"vr": "DS", "Value": [-27.791521970406]},
        "414": {"vr": "DS", "Value": [-22.791521668641]},
        "415": {"vr": "DS", "Value": [-57.791522737289]},
        "416": {"vr": "DS", "Value": [-70.291520021976]},
        "417": {"vr": "DS", "Value": [-67.791519819897]},
        "418": {"vr": "DS", "Value": [12.208477537152]},
        "419": {"vr": "DS", "Value": [-7.7915222166271]},
        "420": {"vr": "DS", "Value": [-2.7915221757886]},
        "421": {"vr": "DS", "Value": [-20.291521415365]},
        "422": {"vr": "DS", "Value": [54.70847916084]},
        "423": {"vr": "DS", "Value": [-57.791522737289]},
        "424": {"vr": "DS", "Value": [29.708477037655]},
        "425": {"vr": "DS", "Value": [44.708478557311]},
        "426": {"vr": "DS", "Value": [-5.291521963351]},
        "427": {"vr": "DS", "Value": [-30.291520360827]},
        "428": {"vr": "DS", "Value": [-32.791520614104]},
        "429": {"vr": "DS", "Value": [-52.791522230737]},
        "430": {"vr": "DS", "Value": [47.208478401012]},
        "431": {"vr": "DS", "Value": [17.208478043704]},
        "432": {"vr": "DS", "Value": [59.708475941683]},
        "433": {"vr": "DS", "Value": [37.208477797483]},
        "434": {"vr": "DS", "Value": [-40.291521169144]},
        "435": {"vr": "DS", "Value": [-57.791522737289]},
        "436": {"vr": "DS", "Value": [-45.291521675696]},
        "437": {"vr": "DS", "Value": [-62.791519415738]},
        "438": {"vr": "DS", "Value": [64.70847603866]},
        "439": {"vr": "DS", "Value": [-52.791522230737]},
        "440": {"vr": "DS", "Value": [-30.291520360827]},
        "441": {"vr": "DS", "Value": [-5.291521963351]},
        "442": {"vr": "DS", "Value": [9.7084777495894]},
        "443": {"vr": "DS", "Value": [74.708477051764]},
        "444": {"vr": "DS", "Value": [-37.791521120656]},
        "445": {"vr": "DS", "Value": [19.70847829698]},
        "446": {"vr": "DS", "Value": [-50.291522079855]},
        "447": {"vr": "DS", "Value": [-37.791521120656]},
        "448": {"vr": "DS", "Value": [62.208476194959]},
        "449": {"vr": "DS", "Value": [-15.291522976455]},
        "450": {"vr": "DS", "Value": [-7.7915222166271]},
        "451": {"vr": "DS", "Value": [-27.791521970406]},
        "452": {"vr": "DS", "Value": [-10.291522469903]},
        "453": {"vr": "DS", "Value": [17.208478043704]},
        "454": {"vr": "DS", "Value": [54.70847916084]},
        "455": {"vr": "DS", "Value": [4.7084775923224]},
        "456": {"vr": "DS", "Value": [-2.7915221757886]},
        "457": {"vr": "DS", "Value": [14.708477790428]},
        "458": {"vr": "DS", "Value": [-52.791522230737]},
        "459": {"vr": "DS", "Value": [-52.791522230737]},
        "460": {"vr": "DS", "Value": [59.708475941683]},
        "461": {"vr": "DS", "Value": [-0.2915219225125]},
        "462": {"vr": "DS", "Value": [9.7084777495894]},
        "463": {"vr": "DS", "Value": [-42.79152142242]},
        "464": {"vr": "DS", "Value": [-40.291521169144]},
        "465": {"vr": "DS", "Value": [-50.291522079855]},
        "466": {"vr": "DS", "Value": [69.708476545212]},
        "467": {"vr": "DS", "Value": [57.208479414116]},
        "468": {"vr": "DS", "Value": [-2.7915221757886]},
        "469": {"vr": "DS", "Value": [-35.29152086738]},
        "470": {"vr": "DS", "Value": [47.208478401012]},
        "471": {"vr": "DS", "Value": [52.208478907564]},
        "472": {"vr": "DS", "Value": [-60.291522888171]},
        "473": {"vr": "DS", "Value": [-35.29152086738]},
        "474": {"vr": "DS", "Value": [-67.791519819897]},
        "475": {"vr": "DS", "Value": [-47.791521826579]},
        "476": {"vr": "DS", "Value": [-62.791519415738]},
        "477": {"vr": "DS", "Value": [37.208477797483]},
        "478": {"vr": "DS", "Value": [42.208478304035]},
        "479": {"vr": "DS", "Value": [-20.291521415365]},
        "480": {"vr": "DS", "Value": [-30.291520360827]},
        "481": {"vr": "DS", "Value": [-27.791521970406]},
        "482": {"vr": "DS", "Value": [-57.791522737289]},
        "483": {"vr": "DS", "Value": [-72.791520224055]},
        "484": {"vr": "DS", "Value": [-50.291522079855]},
        "485": {"vr": "DS", "Value": [-57.791522737289]},
        "486": {"vr": "DS", "Value": [24.708478393957]},
        "487": {"vr": "DS", "Value": [24.708478393957]},
        "488": {"vr": "DS", "Value": [4.7084775923224]},
        "489": {"vr": "DS", "Value": [54.70847916084]},
        "490": {"vr": "DS", "Value": [-32.791520614104]},
        "491": {"vr": "DS", "Value": [22.208478550256]},
        "492": {"vr": "DS", "Value": [2.2084775719032]},
        "493": {"vr": "DS", "Value": [-72.791520224055]},
        "494": {"vr": "DS", "Value": [12.208477537152]},
        "495": {"vr": "DS", "Value": [-52.791522230737]},
        "496": {"vr": "DS", "Value": [-32.791520614104]},
        "497": {"vr": "DS", "Value": [62.208476194959]},
        "498": {"vr": "DS", "Value": [7.2084777291701]},
        "499": {"vr": "DS", "Value": [14.708477790428]},
        "500": {"vr": "DS", "Value": [64.70847603866]},
        "501": {"vr": "DS", "Value": [42.208478304035]},
        "502": {"vr": "DS", "Value": [-27.791521970406]},
        "503": {"vr": "DS", "Value": [-60.291522888171]},
        "504": {"vr": "DS", "Value": [34.708477544207]},
        "505": {"vr": "DS", "Value": [-27.791521970406]},
        "506": {"vr": "DS", "Value": [74.708477051764]},
        "507": {"vr": "DS", "Value": [-42.79152142242]},
        "508": {"vr": "DS", "Value": [49.708478654288]},
        "509": {"vr": "DS", "Value": [-55.291522484013]},
        "510": {"vr": "DS", "Value": [-50.291522079855]},
        "511": {"vr": "DS", "Value": [-52.791522230737]},
        "512": {"vr": "DS", "Value": [57.208479414116]},
        "513": {"vr": "DS", "Value": [-27.791521970406]},
        "514": {"vr": "DS", "Value": [59.708475941683]},
        "515": {"vr": "DS", "Value": [24.708478393957]},
        "516": {"vr": "DS", "Value": [-30.291520360827]},
        "517": {"vr": "DS", "Value": [-0.2915219225125]},
        "518": {"vr": "DS", "Value": [44.708478557311]},
        "519": {"vr": "DS", "Value": [-52.791522230737]},
        "520": {"vr": "DS", "Value": [42.208478304035]},
        "521": {"vr": "DS", "Value": [-47.791521826579]},
        "522": {"vr": "DS", "Value": [-12.791522723179]},
        "523": {"vr": "DS", "Value": [14.708477790428]},
        "524": {"vr": "DS", "Value": [-50.291522079855]},
        "525": {"vr": "DS", "Value": [-65.291519566621]},
        "526": {"vr": "DS", "Value": [57.208479414116]},
        "527": {"vr": "DS", "Value": [9.7084777495894]},
        "528": {"vr": "DS", "Value": [37.208477797483]},
        "529": {"vr": "DS", "Value": [74.708477051764]},
        "530": {"vr": "DS", "Value": [-67.791519819897]},
        "531": {"vr": "DS", "Value": [47.208478401012]},
        "532": {"vr": "DS", "Value": [24.708478393957]},
        "533": {"vr": "DS", "Value": [-5.291521963351]},
        "534": {"vr": "DS", "Value": [14.708477790428]},
        "535": {"vr": "DS", "Value": [42.208478304035]},
        "536": {"vr": "DS", "Value": [47.208478401012]},
        "537": {"vr": "DS", "Value": [69.708476545212]},
        "538": {"vr": "DS", "Value": [69.708476545212]},
        "539": {"vr": "DS", "Value": [-40.291521169144]},
        "540": {"vr": "DS", "Value": [-57.791522737289]},
        "541": {"vr": "DS", "Value": [44.708478557311]},
        "542": {"vr": "DS", "Value": [37.208477797483]},
        "543": {"vr": "DS", "Value": [62.208476194959]},
        "544": {"vr": "DS", "Value": [-15.291522976455]},
        "545": {"vr": "DS", "Value": [-27.791521970406]},
        "546": {"vr": "DS", "Value": [74.708477051764]},
        "547": {"vr": "DS", "Value": [-10.291522469903]},
        "548": {"vr": "DS", "Value": [37.208477797483]},
        "549": {"vr": "DS", "Value": [-5.291521963351]},
        "550": {"vr": "DS", "Value": [-37.791521120656]},
        "551": {"vr": "DS", "Value": [-27.791521970406]},
        "552": {"vr": "DS", "Value": [-62.791519415738]},
        "553": {"vr": "DS", "Value": [34.708477544207]},
        "554": {"vr": "DS", "Value": [47.208478401012]},
        "555": {"vr": "DS", "Value": [4.7084775923224]},
        "556": {"vr": "DS", "Value": [-30.291520360827]},
        "557": {"vr": "DS", "Value": [-52.791522230737]},
        "558": {"vr": "DS", "Value": [-30.291520360827]},
        "559": {"vr": "DS", "Value": [-40.291521169144]},
        "560": {"vr": "DS", "Value": [27.208476784379]},
        "561": {"vr": "DS", "Value": [12.208477537152]},
        "562": {"vr": "DS", "Value": [62.208476194959]},
        "563": {"vr": "DS", "Value": [-25.291521921917]},
        "564": {"vr": "DS", "Value": [42.208478304035]},
        "565": {"vr": "DS", "Value": [12.208477537152]},
        "566": {"vr": "DS", "Value": [59.708475941683]},
        "567": {"vr": "DS", "Value": [32.208477290931]},
        "568": {"vr": "DS", "Value": [32.208477290931]},
        "569": {"vr": "DS", "Value": [-0.2915219225125]},
        "570": {"vr": "DS", "Value": [-70.291520021976]},
        "571": {"vr": "DS", "Value": [2.2084775719032]},
        "572": {"vr": "DS", "Value": [57.208479414116]},
        "573": {"vr": "DS", "Value": [2.2084775719032]},
        "574": {"vr": "DS", "Value": [-27.791521970406]},
        "575": {"vr": "DS", "Value": [-20.291521415365]},
        "576": {"vr": "DS", "Value": [74.708477051764]},
        "577": {"vr": "DS", "Value": [-72.791520224055]},
        "578": {"vr": "DS", "Value": [-7.7915222166271]},
        "579": {"vr": "DS", "Value": [-55.291522484013]},
        "580": {"vr": "DS", "Value": [74.708477051764]},
        "581": {"vr": "DS", "Value": [34.708477544207]},
        "582": {"vr": "DS", "Value": [4.7084775923224]},
        "583": {"vr": "DS", "Value": [44.708478557311]},
        "584": {"vr": "DS", "Value": [47.208478401012]},
        "585": {"vr": "DS", "Value": [-52.791522230737]},
        "586": {"vr": "DS", "Value": [-12.791522723179]},
        "587": {"vr": "DS", "Value": [-60.291522888171]},
        "588": {"vr": "DS", "Value": [59.708475941683]},
        "589": {"vr": "DS", "Value": [-15.291522976455]},
        "590": {"vr": "DS", "Value": [7.2084777291701]},
        "591": {"vr": "DS", "Value": [49.708478654288]},
        "592": {"vr": "DS", "Value": [-40.291521169144]},
        "593": {"vr": "DS", "Value": [54.70847916084]},
        "594": {"vr": "DS", "Value": [14.708477790428]},
        "595": {"vr": "DS", "Value": [-35.29152086738]},
        "596": {"vr": "DS", "Value": [17.208478043704]},
        "597": {"vr": "DS", "Value": [9.7084777495894]},
        "598": {"vr": "DS", "Value": [47.208478401012]},
        "599": {"vr": "DS", "Value": [-15.291522976455]},
        "600": {"vr": "DS", "Value": [27.208476784379]},
        "601": {"vr": "DS", "Value": [-55.291522484013]},
        "602": {"vr": "DS", "Value": [-37.791521120656]},
        "603": {"vr": "DS", "Value": [-40.291521169144]},
        "604": {"vr": "DS", "Value": [-70.291520021976]},
        "605": {"vr": "DS", "Value": [-72.791520224055]},
        "606": {"vr": "DS", "Value": [-50.291522079855]},
        "607": {"vr": "DS", "Value": [67.208476291936]},
        "608": {"vr": "DS", "Value": [-40.291521169144]},
        "609": {"vr": "DS", "Value": [14.708477790428]},
        "610": {"vr": "DS", "Value": [-62.791519415738]},
        "611": {"vr": "DS", "Value": [-32.791520614104]},
        "612": {"vr": "DS", "Value": [-67.791519819897]},
        "613": {"vr": "DS", "Value": [-32.791520614104]},
        "614": {"vr": "DS", "Value": [37.208477797483]},
        "615": {"vr": "DS", "Value": [72.208476798488]},
        "616": {"vr": "DS", "Value": [-70.291520021976]},
        "617": {"vr": "DS", "Value": [-42.79152142242]},
        "618": {"vr": "DS", "Value": [67.208476291936]},
        "619": {"vr": "DS", "Value": [47.208478401012]},
        "620": {"vr": "DS", "Value": [-47.791521826579]},
        "621": {"vr": "DS", "Value": [57.208479414116]},
        "622": {"vr": "DS", "Value": [-62.791519415738]},
        "623": {"vr": "DS", "Value": [72.208476798488]},
        "624": {"vr": "DS", "Value": [-5.291521963351]},
        "625": {"vr": "DS", "Value": [27.208476784379]},
        "626": {"vr": "DS", "Value": [-65.291519566621]},
        "627": {"vr": "DS", "Value": [34.708477544207]},
        "628": {"vr": "DS", "Value": [-55.291522484013]},
        "629": {"vr": "DS", "Value": [-5.291521963351]},
        "630": {"vr": "DS", "Value": [39.708478050759]},
        "631": {"vr": "DS", "Value": [-67.791519819897]},
        "632": {"vr": "DS", "Value": [-72.791520224055]},
        "633": {"vr": "DS", "Value": [7.2084777291701]},
        "634": {"vr": "DS", "Value": [-50.291522079855]},
        "635": {"vr": "DS", "Value": [69.708476545212]},
        "636": {"vr": "DS", "Value": [72.208476798488]},
        "637": {"vr": "DS", "Value": [-15.291522976455]},
        "638": {"vr": "DS", "Value": [-50.291522079855]},
        "639": {"vr": "DS", "Value": [4.7084775923224]},
        "640": {"vr": "DS", "Value": [47.208478401012]},
        "641": {"vr": "DS", "Value": [-0.2915219225125]},
        "642": {"vr": "DS", "Value": [24.708478393957]},
        "643": {"vr": "DS", "Value": [-65.291519566621]},
        "644": {"vr": "DS", "Value": [-67.791519819897]},
        "645": {"vr": "DS", "Value": [27.208476784379]},
        "646": {"vr": "DS", "Value": [72.208476798488]},
        "647": {"vr": "DS", "Value": [-15.291522976455]},
        "648": {"vr": "DS", "Value": [52.208478907564]},
        "649": {"vr": "DS", "Value": [67.208476291936]},
        "650": {"vr": "DS", "Value": [54.70847916084]},
        "651": {"vr": "DS", "Value": [-65.291519566621]},
        "652": {"vr": "DS", "Value": [-5.291521963351]},
        "653": {"vr": "DS", "Value": [-60.291522888171]},
        "654": {"vr": "DS", "Value": [27.208476784379]},
        "655": {"vr": "DS", "Value": [9.7084777495894]},
        "656": {"vr": "DS", "Value": [-42.79152142242]},
        "657": {"vr": "DS", "Value": [-42.79152142242]},
        "658": {"vr": "DS", "Value": [-0.2915219225125]},
        "659": {"vr": "DS", "Value": [7.2084777291701]},
        "660": {"vr": "DS", "Value": [-30.291520360827]},
        "661": {"vr": "DS", "Value": [-20.291521415365]},
        "662": {"vr": "DS", "Value": [-2.7915221757886]},
        "663": {"vr": "DS", "Value": [72.208476798488]},
        "664": {"vr": "DS", "Value": [-20.291521415365]},
        "665": {"vr": "DS", "Value": [-45.291521675696]},
        "666": {"vr": "DS", "Value": [-47.791521826579]},
        "667": {"vr": "DS", "Value": [-62.791519415738]},
        "668": {"vr": "DS", "Value": [34.708477544207]},
        "669": {"vr": "DS", "Value": [-40.291521169144]},
        "670": {"vr": "DS", "Value": [32.208477290931]},
        "671": {"vr": "DS", "Value": [69.708476545212]},
        "672": {"vr": "DS", "Value": [-67.791519819897]},
        "673": {"vr": "DS", "Value": [-52.791522230737]},
        "674": {"vr": "DS", "Value": [-17.791523024944]},
        "675": {"vr": "DS", "Value": [-70.291520021976]},
        "676": {"vr": "DS", "Value": [-0.2915219225125]},
        "677": {"vr": "DS", "Value": [-32.791520614104]},
        "678": {"vr": "DS", "Value": [32.208477290931]},
        "679": {"vr": "DS", "Value": [14.708477790428]},
        "680": {"vr": "DS", "Value": [-52.791522230737]},
        "681": {"vr": "DS", "Value": [49.708478654288]},
        "682": {"vr": "DS", "Value": [-45.291521675696]},
        "683": {"vr": "DS", "Value": [72.208476798488]},
        "684": {"vr": "DS", "Value": [64.70847603866]},
        "685": {"vr": "DS", "Value": [-45.291521675696]},
        "686": {"vr": "DS", "Value": [32.208477290931]},
        "687": {"vr": "DS", "Value": [-67.791519819897]},
        "688": {"vr": "DS", "Value": [-37.791521120656]},
        "689": {"vr": "DS", "Value": [-42.79152142242]},
        "690": {"vr": "DS", "Value": [-50.291522079855]},
        "691": {"vr": "DS", "Value": [-25.291521921917]},
        "692": {"vr": "DS", "Value": [-60.291522888171]},
        "693": {"vr": "DS", "Value": [-52.791522230737]},
        "694": {"vr": "DS", "Value": [27.208476784379]},
        "695": {"vr": "DS", "Value": [47.208478401012]},
        "696": {"vr": "DS", "Value": [7.2084777291701]},
        "697": {"vr": "DS", "Value": [-67.791519819897]},
        "698": {"vr": "DS", "Value": [-55.291522484013]},
        "699": {"vr": "DS", "Value": [57.208479414116]},
        "700": {"vr": "DS", "Value": [64.70847603866]},
        "701": {"vr": "DS", "Value": [32.208477290931]},
        "702": {"vr": "DS", "Value": [-0.2915219225125]},
        "703": {"vr": "DS", "Value": [12.208477537152]},
        "704": {"vr": "DS", "Value": [64.70847603866]},
        "705": {"vr": "DS", "Value": [2.2084775719032]},
        "706": {"vr": "DS", "Value": [-55.291522484013]},
        "707": {"vr": "DS", "Value": [-2.7915221757886]},
        "708": {"vr": "DS", "Value": [-62.791519415738]},
        "709": {"vr": "DS", "Value": [-62.791519415738]},
        "710": {"vr": "DS", "Value": [22.208478550256]},
        "711": {"vr": "DS", "Value": [32.208477290931]},
        "712": {"vr": "DS", "Value": [49.708478654288]},
        "713": {"vr": "DS", "Value": [-10.291522469903]},
        "714": {"vr": "DS", "Value": [9.7084777495894]},
        "715": {"vr": "DS", "Value": [-5.291521963351]},
        "716": {"vr": "DS", "Value": [14.708477790428]},
        "717": {"vr": "DS", "Value": [69.708476545212]},
        "718": {"vr": "DS", "Value": [-52.791522230737]},
        "719": {"vr": "DS", "Value": [-37.791521120656]},
        "720": {"vr": "DS", "Value": [32.208477290931]},
        "721": {"vr": "DS", "Value": [57.208479414116]},
        "722": {"vr": "DS", "Value": [-70.291520021976]},
        "723": {"vr": "DS", "Value": [62.208476194959]},
        "724": {"vr": "DS", "Value": [12.208477537152]},
        "725": {"vr": "DS", "Value": [-7.7915222166271]},
        "726": {"vr": "DS", "Value": [14.708477790428]},
        "727": {"vr": "DS", "Value": [9.7084777495894]},
        "728": {"vr": "DS", "Value": [19.70847829698]},
        "729": {"vr": "DS", "Value": [34.708477544207]},
        "730": {"vr": "DS", "Value": [9.7084777495894]},
        "731": {"vr": "DS", "Value": [4.7084775923224]},
        "732": {"vr": "DS", "Value": [9.7084777495894]},
        "733": {"vr": "DS", "Value": [64.70847603866]},
        "734": {"vr": "DS", "Value": [-57.791522737289]},
        "735": {"vr": "DS", "Value": [42.208478304035]},
        "736": {"vr": "DS", "Value": [19.70847829698]},
        "737": {"vr": "DS", "Value": [-42.79152142242]},
        "738": {"vr": "DS", "Value": [9.7084777495894]},
        "739": {"vr": "DS", "Value": [-65.291519566621]},
        "740": {"vr": "DS", "Value": [12.208477537152]},
        "741": {"vr": "DS", "Value": [-25.291521921917]},
        "742": {"vr": "DS", "Value": [32.208477290931]},
        "743": {"vr": "DS", "Value": [-17.791523024944]},
        "744": {"vr": "DS", "Value": [-2.7915221757886]},
        "745": {"vr": "DS", "Value": [-20.291521415365]},
        "746": {"vr": "DS", "Value": [-42.79152142242]},
        "747": {"vr": "DS", "Value": [-65.291519566621]},
        "748": {"vr": "DS", "Value": [-27.791521970406]},
        "749": {"vr": "DS", "Value": [-35.29152086738]},
        "750": {"vr": "DS", "Value": [-40.291521169144]},
        "751": {"vr": "DS", "Value": [-12.791522723179]},
        "752": {"vr": "DS", "Value": [57.208479414116]},
        "753": {"vr": "DS", "Value": [29.708477037655]},
        "754": {"vr": "DS", "Value": [-62.791519415738]},
        "755": {"vr": "DS", "Value": [-50.291522079855]},
        "756": {"vr": "DS", "Value": [52.208478907564]},
        "757": {"vr": "DS", "Value": [-57.791522737289]},
        "758": {"vr": "DS", "Value": [-35.29152086738]},
        "759": {"vr": "DS", "Value": [4.7084775923224]},
        "760": {"vr": "DS", "Value": [-32.791520614104]},
        "761": {"vr": "DS", "Value": [67.208476291936]},
        "762": {"vr": "DS", "Value": [22.208478550256]},
        "763": {"vr": "DS", "Value": [-22.791521668641]},
        "764": {"vr": "DS", "Value": [-20.291521415365]},
        "765": {"vr": "DS", "Value": [32.208477290931]},
        "766": {"vr": "DS", "Value": [54.70847916084]},
        "767": {"vr": "DS", "Value": [-5.291521963351]},
        "768": {"vr": "DS", "Value": [-57.791522737289]},
        "769": {"vr": "DS", "Value": [64.70847603866]},
        "770": {"vr": "DS", "Value": [-2.7915221757886]},
        "771": {"vr": "DS", "Value": [-22.791521668641]},
        "772": {"vr": "DS", "Value": [-45.291521675696]},
        "773": {"vr": "DS", "Value": [9.7084777495894]},
        "774": {"vr": "DS", "Value": [-42.79152142242]},
        "775": {"vr": "DS", "Value": [-70.291520021976]},
        "776": {"vr": "DS", "Value": [-47.791521826579]},
        "777": {"vr": "DS", "Value": [44.708478557311]},
        "778": {"vr": "DS", "Value": [74.708477051764]},
        "779": {"vr": "DS", "Value": [32.208477290931]},
        "780": {"vr": "DS", "Value": [54.70847916084]},
        "781": {"vr": "DS", "Value": [-17.791523024944]},
        "782": {"vr": "DS", "Value": [-52.791522230737]},
        "783": {"vr": "DS", "Value": [49.708478654288]},
        "784": {"vr": "DS", "Value": [17.208478043704]},
        "785": {"vr": "DS", "Value": [27.208476784379]},
        "786": {"vr": "DS", "Value": [-40.291521169144]},
        "787": {"vr": "DS", "Value": [74.708477051764]},
        "788": {"vr": "DS", "Value": [39.708478050759]},
        "789": {"vr": "DS", "Value": [47.208478401012]},
        "790": {"vr": "DS", "Value": [64.70847603866]},
        "791": {"vr": "DS", "Value": [-32.791520614104]},
        "792": {"vr": "DS", "Value": [7.2084777291701]},
        "793": {"vr": "DS", "Value": [-30.291520360827]},
        "794": {"vr": "DS", "Value": [27.208476784379]},
        "795": {"vr": "DS", "Value": [-7.7915222166271]},
        "796": {"vr": "DS", "Value": [2.2084775719032]},
        "797": {"vr": "DS", "Value": [24.708478393957]},
        "798": {"vr": "DS", "Value": [-12.791522723179]},
        "799": {"vr": "DS", "Value": [-72.791520224055]},
        "800": {"vr": "DS", "Value": [-55.291522484013]},
        "801": {"vr": "DS", "Value": [-60.291522888171]},
        "802": {"vr": "DS", "Value": [-57.791522737289]},
        "803": {"vr": "DS", "Value": [-5.291521963351]},
        "804": {"vr": "DS", "Value": [-22.791521668641]},
        "805": {"vr": "DS", "Value": [7.2084777291701]},
        "806": {"vr": "DS", "Value": [74.708477051764]},
        "807": {"vr": "DS", "Value": [-5.291521963351]},
        "808": {"vr": "DS", "Value": [-37.791521120656]},
        "809": {"vr": "DS", "Value": [-42.79152142242]},
        "810": {"vr": "DS", "Value": [17.208478043704]},
        "811": {"vr": "DS", "Value": [-10.291522469903]},
        "812": {"vr": "DS", "Value": [74.708477051764]},
        "813": {"vr": "DS", "Value": [-52.791522230737]},
        "814": {"vr": "DS", "Value": [-40.291521169144]},
        "815": {"vr": "DS", "Value": [-2.7915221757886]},
        "816": {"vr": "DS", "Value": [22.208478550256]},
        "817": {"vr": "DS", "Value": [2.2084775719032]},
        "818": {"vr": "DS", "Value": [42.208478304035]},
        "819": {"vr": "DS", "Value": [64.70847603866]},
        "820": {"vr": "DS", "Value": [-15.291522976455]},
        "821": {"vr": "DS", "Value": [52.208478907564]},
        "822": {"vr": "DS", "Value": [-17.791523024944]},
        "823": {"vr": "DS", "Value": [52.208478907564]},
        "824": {"vr": "DS", "Value": [-15.291522976455]},
        "825": {"vr": "DS", "Value": [-15.291522976455]},
        "826": {"vr": "DS", "Value": [69.708476545212]},
        "827": {"vr": "DS", "Value": [29.708477037655]},
        "828": {"vr": "DS", "Value": [-25.291521921917]},
        "829": {"vr": "DS", "Value": [-0.2915219225125]},
        "830": {"vr": "DS", "Value": [64.70847603866]},
        "831": {"vr": "DS", "Value": [-0.2915219225125]},
        "832": {"vr": "DS", "Value": [-45.291521675696]},
        "833": {"vr": "DS", "Value": [-67.791519819897]},
        "834": {"vr": "DS", "Value": [-62.791519415738]},
        "835": {"vr": "DS", "Value": [4.7084775923224]},
        "836": {"vr": "DS", "Value": [42.208478304035]},
        "837": {"vr": "DS", "Value": [-17.791523024944]},
        "838": {"vr": "DS", "Value": [14.708477790428]},
        "839": {"vr": "DS", "Value": [-42.79152142242]},
        "840": {"vr": "DS", "Value": [-52.791522230737]},
        "841": {"vr": "DS", "Value": [-65.291519566621]},
        "842": {"vr": "DS", "Value": [4.7084775923224]},
        "843": {"vr": "DS", "Value": [17.208478043704]},
        "844": {"vr": "DS", "Value": [24.708478393957]},
        "845": {"vr": "DS", "Value": [54.70847916084]},
        "846": {"vr": "DS", "Value": [-67.791519819897]},
        "847": {"vr": "DS", "Value": [-42.79152142242]},
        "848": {"vr": "DS", "Value": [69.708476545212]},
        "849": {"vr": "DS", "Value": [37.208477797483]},
        "850": {"vr": "DS", "Value": [-70.291520021976]},
        "851": {"vr": "DS", "Value": [-57.791522737289]},
        "852": {"vr": "DS", "Value": [44.708478557311]},
        "853": {"vr": "DS", "Value": [-22.791521668641]},
        "854": {"vr": "DS", "Value": [7.2084777291701]},
        "855": {"vr": "DS", "Value": [-5.291521963351]},
        "856": {"vr": "DS", "Value": [-32.791520614104]},
        "857": {"vr": "DS", "Value": [37.208477797483]},
        "858": {"vr": "DS", "Value": [-72.791520224055]},
        "859": {"vr": "DS", "Value": [44.708478557311]},
        "860": {"vr": "DS", "Value": [54.70847916084]},
        "861": {"vr": "DS", "Value": [-55.291522484013]},
        "862": {"vr": "DS", "Value": [-17.791523024944]},
        "863": {"vr": "DS", "Value": [2.2084775719032]},
        "864": {"vr": "DS", "Value": [-70.291520021976]},
        "865": {"vr": "DS", "Value": [54.70847916084]},
        "866": {"vr": "DS", "Value": [-27.791521970406]},
        "867": {"vr": "DS", "Value": [-37.791521120656]},
        "868": {"vr": "DS", "Value": [-20.291521415365]},
        "869": {"vr": "DS", "Value": [54.70847916084]},
        "870": {"vr": "DS", "Value": [69.708476545212]},
        "871": {"vr": "DS", "Value": [47.208478401012]},
        "872": {"vr": "DS", "Value": [-12.791522723179]},
        "873": {"vr": "DS", "Value": [-2.7915221757886]},
        "874": {"vr": "DS", "Value": [-32.791520614104]},
        "875": {"vr": "DS", "Value": [42.208478304035]},
        "876": {"vr": "DS", "Value": [52.208478907564]},
        "877": {"vr": "DS", "Value": [-37.791521120656]},
        "878": {"vr": "DS", "Value": [4.7084775923224]},
        "879": {"vr": "DS", "Value": [-10.291522469903]},
        "880": {"vr": "DS", "Value": [37.208477797483]},
        "881": {"vr": "DS", "Value": [-2.7915221757886]},
        "882": {"vr": "DS", "Value": [29.708477037655]},
        "883": {"vr": "DS", "Value": [-55.291522484013]},
        "884": {"vr": "DS", "Value": [-37.791521120656]},
        "885": {"vr": "DS", "Value": [47.208478401012]},
        "886": {"vr": "DS", "Value": [37.208477797483]},
        "887": {"vr": "DS", "Value": [-17.791523024944]},
        "888": {"vr": "DS", "Value": [49.708478654288]},
        "889": {"vr": "DS", "Value": [-60.291522888171]},
        "890": {"vr": "DS", "Value": [-30.291520360827]},
        "891": {"vr": "DS", "Value": [72.208476798488]},
        "892": {"vr": "DS", "Value": [-7.7915222166271]},
        "893": {"vr": "DS", "Value": [-7.7915222166271]},
        "894": {"vr": "DS", "Value": [14.708477790428]},
        "895": {"vr": "DS", "Value": [-55.291522484013]},
        "896": {"vr": "DS", "Value": [62.208476194959]},
        "897": {"vr": "DS", "Value": [-40.291521169144]},
        "898": {"vr": "DS", "Value": [37.208477797483]},
        "899": {"vr": "DS", "Value": [-5.291521963351]},
        "900": {"vr": "DS", "Value": [-0.2915219225125]},
        "901": {"vr": "DS", "Value": [22.208478550256]},
        "902": {"vr": "DS", "Value": [34.708477544207]},
        "903": {"vr": "DS", "Value": [22.208478550256]},
        "904": {"vr": "DS", "Value": [39.708478050759]},
        "905": {"vr": "DS", "Value": [-7.7915222166271]},
        "906": {"vr": "DS", "Value": [-25.291521921917]},
        "907": {"vr": "DS", "Value": [-37.791521120656]},
        "908": {"vr": "DS", "Value": [-10.291522469903]},
        "909": {"vr": "DS", "Value": [-42.79152142242]},
        "910": {"vr": "DS", "Value": [64.70847603866]},
        "911": {"vr": "DS", "Value": [-0.2915219225125]},
        "912": {"vr": "DS", "Value": [47.208478401012]},
        "913": {"vr": "DS", "Value": [72.208476798488]},
        "914": {"vr": "DS", "Value": [24.708478393957]},
        "915": {"vr": "DS", "Value": [-47.791521826579]},
        "916": {"vr": "DS", "Value": [74.708477051764]},
        "917": {"vr": "DS", "Value": [-70.291520021976]},
        "918": {"vr": "DS", "Value": [22.208478550256]},
        "919": {"vr": "DS", "Value": [-67.791519819897]},
        "920": {"vr": "DS", "Value": [69.708476545212]},
        "921": {"vr": "DS", "Value": [-5.291521963351]},
        "922": {"vr": "DS", "Value": [-2.7915221757886]},
        "923": {"vr": "DS", "Value": [67.208476291936]},
        "924": {"vr": "DS", "Value": [-60.291522888171]},
        "925": {"vr": "DS", "Value": [9.7084777495894]},
        "926": {"vr": "DS", "Value": [-30.291520360827]},
        "927": {"vr": "DS", "Value": [64.70847603866]},
        "928": {"vr": "DS", "Value": [-65.291519566621]},
        "929": {"vr": "DS", "Value": [-67.791519819897]},
        "930": {"vr": "DS", "Value": [7.2084777291701]},
        "931": {"vr": "DS", "Value": [57.208479414116]},
        "932": {"vr": "DS", "Value": [59.708475941683]},
        "933": {"vr": "DS", "Value": [-0.2915219225125]},
        "934": {"vr": "DS", "Value": [29.708477037655]},
        "935": {"vr": "DS", "Value": [42.208478304035]},
        "936": {"vr": "DS", "Value": [-2.7915221757886]},
        "937": {"vr": "DS", "Value": [2.2084775719032]},
        "938": {"vr": "DS", "Value": [72.208476798488]},
        "939": {"vr": "DS", "Value": [-32.791520614104]},
        "940": {"vr": "DS", "Value": [2.2084775719032]},
        "941": {"vr": "DS", "Value": [64.70847603866]},
        "942": {"vr": "DS", "Value": [-17.791523024944]},
        "943": {"vr": "DS", "Value": [7.2084777291701]},
        "944": {"vr": "DS", "Value": [-30.291520360827]},
        "945": {"vr": "DS", "Value": [32.208477290931]},
        "946": {"vr": "DS", "Value": [29.708477037655]},
        "947": {"vr": "DS", "Value": [-20.291521415365]},
        "948": {"vr": "DS", "Value": [-7.7915222166271]},
        "949": {"vr": "DS", "Value": [-25.291521921917]},
        "950": {"vr": "DS", "Value": [14.708477790428]},
        "951": {"vr": "DS", "Value": [-40.291521169144]},
        "952": {"vr": "DS", "Value": [-20.291521415365]},
        "953": {"vr": "DS", "Value": [-12.791522723179]},
        "954": {"vr": "DS", "Value": [62.208476194959]},
        "955": {"vr": "DS", "Value": [-40.291521169144]},
        "956": {"vr": "DS", "Value": [27.208476784379]},
        "957": {"vr": "DS", "Value": [-2.7915221757886]},
        "958": {"vr": "DS", "Value": [-55.291522484013]},
        "959": {"vr": "DS", "Value": [-65.291519566621]},
        "960": {"vr": "DS", "Value": [54.70847916084]},
        "961": {"vr": "DS", "Value": [29.708477037655]},
        "962": {"vr": "DS", "Value": [42.208478304035]},
        "963": {"vr": "DS", "Value": [12.208477537152]},
        "964": {"vr": "DS", "Value": [-7.7915222166271]},
        "965": {"vr": "DS", "Value": [9.7084777495894]},
        "966": {"vr": "DS", "Value": [72.208476798488]},
        "967": {"vr": "DS", "Value": [-65.291519566621]},
        "968": {"vr": "DS", "Value": [-47.791521826579]},
        "969": {"vr": "DS", "Value": [57.208479414116]},
        "970": {"vr": "DS", "Value": [-0.2915219225125]},
        "971": {"vr": "DS", "Value": [2.2084775719032]},
        "972": {"vr": "DS", "Value": [42.208478304035]},
        "973": {"vr": "DS", "Value": [59.708475941683]},
        "974": {"vr": "DS", "Value": [57.208479414116]},
        "975": {"vr": "DS", "Value": [-40.291521169144]},
        "976": {"vr": "DS", "Value": [19.70847829698]},
        "977": {"vr": "DS", "Value": [-2.7915221757886]},
        "978": {"vr": "DS", "Value": [-27.791521970406]},
        "979": {"vr": "DS", "Value": [-10.291522469903]},
        "980": {"vr": "DS", "Value": [-55.291522484013]},
        "981": {"vr": "DS", "Value": [57.208479414116]},
        "982": {"vr": "DS", "Value": [-37.791521120656]},
        "983": {"vr": "DS", "Value": [22.208478550256]},
        "984": {"vr": "DS", "Value": [-47.791521826579]},
        "985": {"vr": "DS", "Value": [-7.7915222166271]},
        "986": {"vr": "DS", "Value": [-52.791522230737]},
        "987": {"vr": "DS", "Value": [14.708477790428]},
        "988": {"vr": "DS", "Value": [67.208476291936]},
        "989": {"vr": "DS", "Value": [-70.291520021976]},
        "990": {"vr": "DS", "Value": [57.208479414116]},
        "991": {"vr": "DS", "Value": [12.208477537152]},
        "992": {"vr": "DS", "Value": [-17.791523024944]},
        "993": {"vr": "DS", "Value": [2.2084775719032]},
        "994": {"vr": "DS", "Value": [-45.291521675696]},
        "995": {"vr": "DS", "Value": [17.208478043704]},
        "996": {"vr": "DS", "Value": [-65.291519566621]},
        "997": {"vr": "DS", "Value": [69.708476545212]},
        "998": {"vr": "DS", "Value": [44.708478557311]},
        "999": {"vr": "DS", "Value": [-17.791523024944]},
        "1000": {"vr": "DS", "Value": [-50.291522079855]},
        "1001": {"vr": "DS", "Value": [7.2084777291701]},
        "1002": {"vr": "DS", "Value": [39.708478050759]},
        "1003": {"vr": "DS", "Value": [19.70847829698]},
        "1004": {"vr": "DS", "Value": [52.208478907564]},
        "1005": {"vr": "DS", "Value": [-52.791522230737]},
        "1006": {"vr": "DS", "Value": [-50.291522079855]},
        "1007": {"vr": "DS", "Value": [-30.291520360827]},
        "1008": {"vr": "DS", "Value": [44.708478557311]},
        "1009": {"vr": "DS", "Value": [52.208478907564]},
        "1010": {"vr": "DS", "Value": [34.708477544207]},
        "1011": {"vr": "DS", "Value": [49.708478654288]},
        "1012": {"vr": "DS", "Value": [-40.291521169144]},
        "1013": {"vr": "DS", "Value": [-40.291521169144]},
        "1014": {"vr": "DS", "Value": [14.708477790428]},
        "1015": {"vr": "DS", "Value": [2.2084775719032]},
        "1016": {"vr": "DS", "Value": [-2.7915221757886]},
        "1017": {"vr": "DS", "Value": [-50.291522079855]},
        "1018": {"vr": "DS", "Value": [64.70847603866]},
        "1019": {"vr": "DS", "Value": [-12.791522723179]},
        "1020": {"vr": "DS", "Value": [34.708477544207]},
        "1021": {"vr": "DS", "Value": [-17.791523024944]},
        "1022": {"vr": "DS", "Value": [-50.291522079855]},
        "1023": {"vr": "DS", "Value": [-60.291522888171]},
        "1024": {"vr": "DS", "Value": [44.708478557311]},
        "1025": {"vr": "DS", "Value": [24.708478393957]},
        "1026": {"vr": "DS", "Value": [-20.291521415365]},
        "1027": {"vr": "DS", "Value": [74.708477051764]},
        "1028": {"vr": "DS", "Value": [-42.79152142242]},
        "1029": {"vr": "DS", "Value": [59.708475941683]},
        "1030": {"vr": "DS", "Value": [32.208477290931]},
        "1031": {"vr": "DS", "Value": [2.2084775719032]},
        "1032": {"vr": "DS", "Value": [-15.291522976455]},
        "1033": {"vr": "DS", "Value": [-7.7915222166271]},
        "1034": {"vr": "DS", "Value": [7.2084777291701]},
        "1035": {"vr": "DS", "Value": [-37.791521120656]},
        "1036": {"vr": "DS", "Value": [74.708477051764]},
        "1037": {"vr": "DS", "Value": [-42.79152142242]},
        "1038": {"vr": "DS", "Value": [62.208476194959]},
        "1039": {"vr": "DS", "Value": [17.208478043704]},
        "1040": {"vr": "DS", "Value": [-20.291521415365]},
        "1041": {"vr": "DS", "Value": [24.708478393957]},
        "1042": {"vr": "DS", "Value": [49.708478654288]},
        "1043": {"vr": "DS", "Value": [-35.29152086738]},
        "1044": {"vr": "DS", "Value": [74.708477051764]},
        "1045": {"vr": "DS", "Value": [24.708478393957]},
        "1046": {"vr": "DS", "Value": [67.208476291936]},
        "1047": {"vr": "DS", "Value": [-35.29152086738]},
        "1048": {"vr": "DS", "Value": [74.708477051764]},
        "1049": {"vr": "DS", "Value": [34.708477544207]},
        "1050": {"vr": "DS", "Value": [74.708477051764]},
        "1051": {"vr": "DS", "Value": [57.208479414116]},
        "1052": {"vr": "DS", "Value": [-7.7915222166271]},
        "1053": {"vr": "DS", "Value": [-70.291520021976]},
        "1054": {"vr": "DS", "Value": [17.208478043704]},
        "1055": {"vr": "DS", "Value": [-20.291521415365]},
        "1056": {"vr": "DS", "Value": [-12.791522723179]},
        "1057": {"vr": "DS", "Value": [-70.291520021976]},
        "1058": {"vr": "DS", "Value": [74.708477051764]},
        "1059": {"vr": "DS", "Value": [-35.29152086738]},
        "1060": {"vr": "DS", "Value": [-2.7915221757886]},
        "1061": {"vr": "DS", "Value": [-55.291522484013]},
        "1062": {"vr": "DS", "Value": [-20.291521415365]},
        "1063": {"vr": "DS", "Value": [-67.791519819897]},
        "1064": {"vr": "DS", "Value": [-2.7915221757886]},
        "1065": {"vr": "DS", "Value": [22.208478550256]},
        "1066": {"vr": "DS", "Value": [-30.291520360827]},
        "1067": {"vr": "DS", "Value": [-50.291522079855]},
        "1068": {"vr": "DS", "Value": [-42.79152142242]},
        "1069": {"vr": "DS", "Value": [-12.791522723179]},
        "1070": {"vr": "DS", "Value": [-55.291522484013]},
        "1071": {"vr": "DS", "Value": [39.708478050759]},
        "1072": {"vr": "DS", "Value": [-47.791521826579]},
        "1073": {"vr": "DS", "Value": [64.70847603866]},
        "1074": {"vr": "DS", "Value": [37.208477797483]},
        "1075": {"vr": "DS", "Value": [-30.291520360827]},
        "1076": {"vr": "DS", "Value": [-60.291522888171]},
        "1077": {"vr": "DS", "Value": [-65.291519566621]},
        "1078": {"vr": "DS", "Value": [67.208476291936]},
        "1079": {"vr": "DS", "Value": [72.208476798488]},
        "1080": {"vr": "DS", "Value": [-67.791519819897]},
        "1081": {"vr": "DS", "Value": [4.7084775923224]},
        "1082": {"vr": "DS", "Value": [54.70847916084]},
        "1083": {"vr": "DS", "Value": [-17.791523024944]},
        "1084": {"vr": "DS", "Value": [-72.791520224055]},
        "1085": {"vr": "DS", "Value": [-37.791521120656]},
        "1086": {"vr": "DS", "Value": [-55.291522484013]},
        "1087": {"vr": "DS", "Value": [9.7084777495894]},
        "1088": {"vr": "DS", "Value": [42.208478304035]},
        "1089": {"vr": "DS", "Value": [42.208478304035]},
        "1090": {"vr": "DS", "Value": [-20.291521415365]},
        "1091": {"vr": "DS", "Value": [52.208478907564]},
        "1092": {"vr": "DS", "Value": [44.708478557311]},
        "1093": {"vr": "DS", "Value": [-65.291519566621]},
        "1094": {"vr": "DS", "Value": [32.208477290931]},
        "1095": {"vr": "DS", "Value": [-32.791520614104]},
        "1096": {"vr": "DS", "Value": [-45.291521675696]},
        "1097": {"vr": "DS", "Value": [-7.7915222166271]},
        "1098": {"vr": "DS", "Value": [62.208476194959]},
        "1099": {"vr": "DS", "Value": [-70.291520021976]},
        "1100": {"vr": "DS", "Value": [-27.791521970406]},
        "1101": {"vr": "DS", "Value": [-67.791519819897]},
        "1102": {"vr": "DS", "Value": [-47.791521826579]},
        "1103": {"vr": "DS", "Value": [-15.291522976455]},
        "1104": {"vr": "DS", "Value": [-12.791522723179]},
        "1105": {"vr": "DS", "Value": [-25.291521921917]},
        "1106": {"vr": "DS", "Value": [37.208477797483]},
        "1107": {"vr": "DS", "Value": [14.708477790428]},
        "1108": {"vr": "DS", "Value": [-50.291522079855]},
        "1109": {"vr": "DS", "Value": [-20.291521415365]},
        "1110": {"vr": "DS", "Value": [-70.291520021976]},
        "1111": {"vr": "DS", "Value": [44.708478557311]},
        "1112": {"vr": "DS", "Value": [-52.791522230737]},
        "1113": {"vr": "DS", "Value": [52.208478907564]},
        "1114": {"vr": "DS", "Value": [32.208477290931]},
        "1115": {"vr": "DS", "Value": [-65.291519566621]},
        "1116": {"vr": "DS", "Value": [12.208477537152]},
        "1117": {"vr": "DS", "Value": [-32.791520614104]},
        "1118": {"vr": "DS", "Value": [4.7084775923224]},
        "1119": {"vr": "DS", "Value": [37.208477797483]},
        "1120": {"vr": "DS", "Value": [-57.791522737289]},
        "1121": {"vr": "DS", "Value": [72.208476798488]},
        "1122": {"vr": "DS", "Value": [52.208478907564]},
        "1123": {"vr": "DS", "Value": [-50.291522079855]},
        "1124": {"vr": "DS", "Value": [57.208479414116]},
        "1125": {"vr": "DS", "Value": [-27.791521970406]},
        "1126": {"vr": "DS", "Value": [-12.791522723179]},
        "1127": {"vr": "DS", "Value": [-57.791522737289]},
        "1128": {"vr": "DS", "Value": [-15.291522976455]},
        "1129": {"vr": "DS", "Value": [-20.291521415365]},
        "1130": {"vr": "DS", "Value": [-15.291522976455]},
        "1131": {"vr": "DS", "Value": [52.208478907564]},
        "1132": {"vr": "DS", "Value": [-17.791523024944]},
        "1133": {"vr": "DS", "Value": [49.708478654288]},
        "1134": {"vr": "DS", "Value": [-70.291520021976]},
        "1135": {"vr": "DS", "Value": [-40.291521169144]},
        "1136": {"vr": "DS", "Value": [-42.79152142242]},
        "1137": {"vr": "DS", "Value": [74.708477051764]},
        "1138": {"vr": "DS", "Value": [-32.791520614104]},
        "1139": {"vr": "DS", "Value": [29.708477037655]},
        "1140": {"vr": "DS", "Value": [37.208477797483]},
        "1141": {"vr": "DS", "Value": [37.208477797483]},
        "1142": {"vr": "DS", "Value": [47.208478401012]},
        "1143": {"vr": "DS", "Value": [-42.79152142242]},
        "1144": {"vr": "DS", "Value": [-55.291522484013]},
        "1145": {"vr": "DS", "Value": [7.2084777291701]},
        "1146": {"vr": "DS", "Value": [-47.791521826579]},
        "1147": {"vr": "DS", "Value": [-37.791521120656]},
        "1148": {"vr": "DS", "Value": [2.2084775719032]},
        "1149": {"vr": "DS", "Value": [19.70847829698]},
        "1150": {"vr": "DS", "Value": [69.708476545212]},
        "1151": {"vr": "DS", "Value": [-70.291520021976]},
        "1152": {"vr": "DS", "Value": [37.208477797483]},
        "1153": {"vr": "DS", "Value": [-12.791522723179]},
        "1154": {"vr": "DS", "Value": [2.2084775719032]},
        "1155": {"vr": "DS", "Value": [-30.291520360827]},
        "1156": {"vr": "DS", "Value": [-37.791521120656]},
        "1157": {"vr": "DS", "Value": [-17.791523024944]},
        "1158": {"vr": "DS", "Value": [-35.29152086738]},
        "1159": {"vr": "DS", "Value": [24.708478393957]},
        "1160": {"vr": "DS", "Value": [-32.791520614104]},
        "1161": {"vr": "DS", "Value": [4.7084775923224]},
        "1162": {"vr": "DS", "Value": [-72.791520224055]},
        "1163": {"vr": "DS", "Value": [57.208479414116]},
        "1164": {"vr": "DS", "Value": [59.708475941683]},
        "1165": {"vr": "DS", "Value": [-12.791522723179]},
        "1166": {"vr": "DS", "Value": [7.2084777291701]},
        "1167": {"vr": "DS", "Value": [44.708478557311]},
        "1168": {"vr": "DS", "Value": [57.208479414116]},
        "1169": {"vr": "DS", "Value": [-47.791521826579]},
        "1170": {"vr": "DS", "Value": [54.70847916084]},
        "1171": {"vr": "DS", "Value": [-57.791522737289]},
        "1172": {"vr": "DS", "Value": [24.708478393957]},
        "1173": {"vr": "DS", "Value": [4.7084775923224]},
        "1174": {"vr": "DS", "Value": [-42.79152142242]},
        "1175": {"vr": "DS", "Value": [-55.291522484013]},
        "1176": {"vr": "DS", "Value": [9.7084777495894]},
        "1177": {"vr": "DS", "Value": [49.708478654288]},
        "1178": {"vr": "DS", "Value": [57.208479414116]},
        "1179": {"vr": "DS", "Value": [14.708477790428]},
        "1180": {"vr": "DS", "Value": [62.208476194959]},
        "1181": {"vr": "DS", "Value": [67.208476291936]},
        "1182": {"vr": "DS", "Value": [59.708475941683]},
        "1183": {"vr": "DS", "Value": [-2.7915221757886]},
        "1184": {"vr": "DS", "Value": [34.708477544207]},
        "1185": {"vr": "DS", "Value": [49.708478654288]},
        "1186": {"vr": "DS", "Value": [-55.291522484013]},
        "1187": {"vr": "DS", "Value": [47.208478401012]},
        "1188": {"vr": "DS", "Value": [-7.7915222166271]},
        "1189": {"vr": "DS", "Value": [-5.291521963351]},
        "1190": {"vr": "DS", "Value": [-57.791522737289]},
        "1191": {"vr": "DS", "Value": [-12.791522723179]},
        "1192": {"vr": "DS", "Value": [39.708478050759]},
        "1193": {"vr": "DS", "Value": [-62.791519415738]},
        "1194": {"vr": "DS", "Value": [-47.791521826579]},
        "1195": {"vr": "DS", "Value": [-10.291522469903]},
        "1196": {"vr": "DS", "Value": [52.208478907564]},
        "1197": {"vr": "DS", "Value": [27.208476784379]},
        "1198": {"vr": "DS", "Value": [-60.291522888171]},
        "1199": {"vr": "DS", "Value": [4.7084775923224]},
        "1200": {"vr": "DS", "Value": [-10.291522469903]},
        "1201": {"vr": "DS", "Value": [64.70847603866]},
        "1202": {"vr": "DS", "Value": [69.708476545212]},
        "1203": {"vr": "DS", "Value": [-52.791522230737]},
        "1204": {"vr": "DS", "Value": [-2.7915221757886]},
        "1205": {"vr": "DS", "Value": [-57.791522737289]},
        "1206": {"vr": "DS", "Value": [-2.7915221757886]},
        "1207": {"vr": "DS", "Value": [67.208476291936]},
        "1208": {"vr": "DS", "Value": [39.708478050759]},
        "1209": {"vr": "DS", "Value": [64.70847603866]},
        "1210": {"vr": "DS", "Value": [-37.791521120656]},
        "1211": {"vr": "DS", "Value": [-20.291521415365]},
        "1212": {"vr": "DS", "Value": [32.208477290931]},
        "1213": {"vr": "DS", "Value": [12.208477537152]},
        "1214": {"vr": "DS", "Value": [57.208479414116]},
        "1215": {"vr": "DS", "Value": [-12.791522723179]},
        "1216": {"vr": "DS", "Value": [69.708476545212]},
        "1217": {"vr": "DS", "Value": [-62.791519415738]},
        "1218": {"vr": "DS", "Value": [-70.291520021976]},
        "1219": {"vr": "DS", "Value": [4.7084775923224]},
        "1220": {"vr": "DS", "Value": [12.208477537152]},
        "1221": {"vr": "DS", "Value": [-5.291521963351]},
        "1222": {"vr": "DS", "Value": [-37.791521120656]},
        "1223": {"vr": "DS", "Value": [-72.791520224055]},
        "1224": {"vr": "DS", "Value": [42.208478304035]},
        "1225": {"vr": "DS", "Value": [-15.291522976455]},
        "1226": {"vr": "DS", "Value": [-45.291521675696]},
        "1227": {"vr": "DS", "Value": [-62.791519415738]},
        "1228": {"vr": "DS", "Value": [-50.291522079855]},
        "1229": {"vr": "DS", "Value": [-57.791522737289]},
        "1230": {"vr": "DS", "Value": [-2.7915221757886]},
        "1231": {"vr": "DS", "Value": [-70.291520021976]},
        "1232": {"vr": "DS", "Value": [54.70847916084]},
        "1233": {"vr": "DS", "Value": [2.2084775719032]},
        "1234": {"vr": "DS", "Value": [-5.291521963351]},
        "1235": {"vr": "DS", "Value": [34.708477544207]},
        "1236": {"vr": "DS", "Value": [47.208478401012]},
        "1237": {"vr": "DS", "Value": [-50.291522079855]},
        "1238": {"vr": "DS", "Value": [19.70847829698]},
        "1239": {"vr": "DS", "Value": [-65.291519566621]},
        "1240": {"vr": "DS", "Value": [54.70847916084]},
        "1241": {"vr": "DS", "Value": [64.70847603866]},
        "1242": {"vr": "DS", "Value": [-17.791523024944]},
        "1243": {"vr": "DS", "Value": [-20.291521415365]},
        "1244": {"vr": "DS", "Value": [-32.791520614104]},
        "1245": {"vr": "DS", "Value": [-25.291521921917]},
        "1246": {"vr": "DS", "Value": [-35.29152086738]},
        "1247": {"vr": "DS", "Value": [29.708477037655]},
        "1248": {"vr": "DS", "Value": [49.708478654288]},
        "1249": {"vr": "DS", "Value": [-65.291519566621]},
        "1250": {"vr": "DS", "Value": [-72.791520224055]},
        "1251": {"vr": "DS", "Value": [-10.291522469903]},
        "1252": {"vr": "DS", "Value": [34.708477544207]},
        "1253": {"vr": "DS", "Value": [-27.791521970406]},
        "1254": {"vr": "DS", "Value": [-45.291521675696]},
        "1255": {"vr": "DS", "Value": [-37.791521120656]},
        "1256": {"vr": "DS", "Value": [-65.291519566621]},
        "1257": {"vr": "DS", "Value": [27.208476784379]},
        "1258": {"vr": "DS", "Value": [24.708478393957]},
        "1259": {"vr": "DS", "Value": [39.708478050759]},
        "1260": {"vr": "DS", "Value": [-55.291522484013]},
        "1261": {"vr": "DS", "Value": [72.208476798488]},
        "1262": {"vr": "DS", "Value": [-20.291521415365]},
        "1263": {"vr": "DS", "Value": [19.70847829698]},
        "1264": {"vr": "DS", "Value": [12.208477537152]},
        "1265": {"vr": "DS", "Value": [-45.291521675696]},
        "1266": {"vr": "DS", "Value": [-27.791521970406]},
        "1267": {"vr": "DS", "Value": [39.708478050759]},
        "1268": {"vr": "DS", "Value": [-65.291519566621]},
        "1269": {"vr": "DS", "Value": [72.208476798488]},
        "1270": {"vr": "DS", "Value": [12.208477537152]},
        "1271": {"vr": "DS", "Value": [-52.791522230737]},
        "1272": {"vr": "DS", "Value": [-65.291519566621]},
        "1273": {"vr": "DS", "Value": [69.708476545212]},
        "1274": {"vr": "DS", "Value": [9.7084777495894]},
        "1275": {"vr": "DS", "Value": [-52.791522230737]},
        "1276": {"vr": "DS", "Value": [49.708478654288]},
        "1277": {"vr": "DS", "Value": [29.708477037655]},
        "1278": {"vr": "DS", "Value": [-50.291522079855]},
        "1279": {"vr": "DS", "Value": [47.208478401012]},
        "1280": {"vr": "DS", "Value": [-62.791519415738]},
        "1281": {"vr": "DS", "Value": [2.2084775719032]},
        "1282": {"vr": "DS", "Value": [62.208476194959]},
        "1283": {"vr": "DS", "Value": [69.708476545212]},
        "1284": {"vr": "DS", "Value": [-7.7915222166271]},
        "1285": {"vr": "DS", "Value": [-47.791521826579]},
        "1286": {"vr": "DS", "Value": [72.208476798488]},
        "1287": {"vr": "DS", "Value": [-45.291521675696]},
        "1288": {"vr": "DS", "Value": [9.7084777495894]},
        "1289": {"vr": "DS", "Value": [-42.79152142242]},
        "1290": {"vr": "DS", "Value": [-0.2915219225125]},
        "1291": {"vr": "DS", "Value": [69.708476545212]},
        "1292": {"vr": "DS", "Value": [-47.791521826579]},
        "1293": {"vr": "DS", "Value": [-20.291521415365]},
        "1294": {"vr": "DS", "Value": [29.708477037655]},
        "1295": {"vr": "DS", "Value": [49.708478654288]},
        "1296": {"vr": "DS", "Value": [-0.2915219225125]},
        "1297": {"vr": "DS", "Value": [64.70847603866]},
        "1298": {"vr": "DS", "Value": [-12.791522723179]},
        "1299": {"vr": "DS", "Value": [74.708477051764]},
        "1300": {"vr": "DS", "Value": [39.708478050759]},
        "1301": {"vr": "DS", "Value": [-20.291521415365]},
        "1302": {"vr": "DS", "Value": [-60.291522888171]},
        "1303": {"vr": "DS", "Value": [-57.791522737289]},
        "1304": {"vr": "DS", "Value": [-2.7915221757886]},
        "1305": {"vr": "DS", "Value": [-72.791520224055]},
        "1306": {"vr": "DS", "Value": [-42.79152142242]},
        "1307": {"vr": "DS", "Value": [4.7084775923224]},
        "1308": {"vr": "DS", "Value": [22.208478550256]},
        "1309": {"vr": "DS", "Value": [-55.291522484013]},
        "1310": {"vr": "DS", "Value": [22.208478550256]},
        "1311": {"vr": "DS", "Value": [9.7084777495894]},
        "1312": {"vr": "DS", "Value": [-60.291522888171]},
        "1313": {"vr": "DS", "Value": [-22.791521668641]},
        "1314": {"vr": "DS", "Value": [-42.79152142242]},
        "1315": {"vr": "DS", "Value": [47.208478401012]},
        "1316": {"vr": "DS", "Value": [24.708478393957]},
        "1317": {"vr": "DS", "Value": [24.708478393957]},
        "1318": {"vr": "DS", "Value": [-50.291522079855]},
        "1319": {"vr": "DS", "Value": [4.7084775923224]},
        "1320": {"vr": "DS", "Value": [42.208478304035]},
        "1321": {"vr": "DS", "Value": [24.708478393957]},
        "1322": {"vr": "DS", "Value": [62.208476194959]},
        "1323": {"vr": "DS", "Value": [-2.7915221757886]},
        "1324": {"vr": "DS", "Value": [-25.291521921917]},
        "1325": {"vr": "DS", "Value": [-27.791521970406]},
        "1326": {"vr": "DS", "Value": [-60.291522888171]},
        "1327": {"vr": "DS", "Value": [-17.791523024944]},
        "1328": {"vr": "DS", "Value": [-22.791521668641]},
        "1329": {"vr": "DS", "Value": [9.7084777495894]},
        "1330": {"vr": "DS", "Value": [-67.791519819897]},
        "1331": {"vr": "DS", "Value": [7.2084777291701]},
        "1332": {"vr": "DS", "Value": [-7.7915222166271]},
        "1333": {"vr": "DS", "Value": [47.208478401012]},
        "1334": {"vr": "DS", "Value": [-17.791523024944]},
        "1335": {"vr": "DS", "Value": [-60.291522888171]},
        "1336": {"vr": "DS", "Value": [-17.791523024944]},
        "1337": {"vr": "DS", "Value": [-30.291520360827]},
        "1338": {"vr": "DS", "Value": [39.708478050759]},
        "1339": {"vr": "DS", "Value": [57.208479414116]},
        "1340": {"vr": "DS", "Value": [27.208476784379]},
        "1341": {"vr": "DS", "Value": [-12.791522723179]},
        "1342": {"vr": "DS", "Value": [-15.291522976455]},
        "1343": {"vr": "DS", "Value": [-27.791521970406]},
        "1344": {"vr": "DS", "Value": [-27.791521970406]},
        "1345": {"vr": "DS", "Value": [47.208478401012]},
        "1346": {"vr": "DS", "Value": [52.208478907564]},
        "1347": {"vr": "DS", "Value": [22.208478550256]},
        "1348": {"vr": "DS", "Value": [-12.791522723179]},
        "1349": {"vr": "DS", "Value": [57.208479414116]},
        "1350": {"vr": "DS", "Value": [-57.791522737289]},
        "1351": {"vr": "DS", "Value": [-7.7915222166271]},
        "1352": {"vr": "DS", "Value": [-7.7915222166271]},
        "1353": {"vr": "DS", "Value": [69.708476545212]},
        "1354": {"vr": "DS", "Value": [-57.791522737289]},
        "1355": {"vr": "DS", "Value": [-10.291522469903]},
        "1356": {"vr": "DS", "Value": [-27.791521970406]},
        "1357": {"vr": "DS", "Value": [4.7084775923224]},
        "1358": {"vr": "DS", "Value": [-72.791520224055]},
        "1359": {"vr": "DS", "Value": [12.208477537152]},
        "1360": {"vr": "DS", "Value": [17.208478043704]},
        "1361": {"vr": "DS", "Value": [9.7084777495894]},
        "1362": {"vr": "DS", "Value": [-0.2915219225125]},
        "1363": {"vr": "DS", "Value": [-35.29152086738]},
        "1364": {"vr": "DS", "Value": [74.708477051764]},
        "1365": {"vr": "DS", "Value": [-50.291522079855]},
        "1366": {"vr": "DS", "Value": [-15.291522976455]},
        "1367": {"vr": "DS", "Value": [-0.2915219225125]},
        "1368": {"vr": "DS", "Value": [64.70847603866]},
        "1369": {"vr": "DS", "Value": [24.708478393957]},
        "1370": {"vr": "DS", "Value": [34.708477544207]},
        "1371": {"vr": "DS", "Value": [59.708475941683]},
        "1372": {"vr": "DS", "Value": [-42.79152142242]},
        "1373": {"vr": "DS", "Value": [37.208477797483]},
        "1374": {"vr": "DS", "Value": [-45.291521675696]},
        "1375": {"vr": "DS", "Value": [-27.791521970406]},
        "1376": {"vr": "DS", "Value": [-47.791521826579]},
        "1377": {"vr": "DS", "Value": [-37.791521120656]},
        "1378": {"vr": "DS", "Value": [2.2084775719032]},
        "1379": {"vr": "DS", "Value": [7.2084777291701]},
        "1380": {"vr": "DS", "Value": [-50.291522079855]},
        "1381": {"vr": "DS", "Value": [59.708475941683]},
        "1382": {"vr": "DS", "Value": [-10.291522469903]},
        "1383": {"vr": "DS", "Value": [7.2084777291701]},
        "1384": {"vr": "DS", "Value": [72.208476798488]},
        "1385": {"vr": "DS", "Value": [62.208476194959]},
        "1386": {"vr": "DS", "Value": [17.208478043704]},
        "1387": {"vr": "DS", "Value": [-27.791521970406]},
        "1388": {"vr": "DS", "Value": [-72.791520224055]},
        "1389": {"vr": "DS", "Value": [14.708477790428]},
        "1390": {"vr": "DS", "Value": [-47.791521826579]},
        "1391": {"vr": "DS", "Value": [-10.291522469903]},
        "1392": {"vr": "DS", "Value": [-45.291521675696]},
        "1393": {"vr": "DS", "Value": [22.208478550256]},
        "1394": {"vr": "DS", "Value": [27.208476784379]},
        "1395": {"vr": "DS", "Value": [44.708478557311]},
        "1396": {"vr": "DS", "Value": [-22.791521668641]},
        "1397": {"vr": "DS", "Value": [-45.291521675696]},
        "1398": {"vr": "DS", "Value": [2.2084775719032]},
        "1399": {"vr": "DS", "Value": [12.208477537152]},
        "1400": {"vr": "DS", "Value": [-27.791521970406]},
        "1401": {"vr": "DS", "Value": [-60.291522888171]},
        "1402": {"vr": "DS", "Value": [17.208478043704]},
        "1403": {"vr": "DS", "Value": [-27.791521970406]},
        "1404": {"vr": "DS", "Value": [-35.29152086738]},
        "1405": {"vr": "DS", "Value": [2.2084775719032]},
        "1406": {"vr": "DS", "Value": [52.208478907564]},
        "1407": {"vr": "DS", "Value": [-0.2915219225125]},
        "1408": {"vr": "DS", "Value": [-57.791522737289]},
        "1409": {"vr": "DS", "Value": [27.208476784379]},
        "1410": {"vr": "DS", "Value": [62.208476194959]},
        "1411": {"vr": "DS", "Value": [74.708477051764]},
        "1412": {"vr": "DS", "Value": [-2.7915221757886]},
        "1413": {"vr": "DS", "Value": [7.2084777291701]},
        "1414": {"vr": "DS", "Value": [-52.791522230737]},
        "1415": {"vr": "DS", "Value": [-47.791521826579]},
        "1416": {"vr": "DS", "Value": [-35.29152086738]},
        "1417": {"vr": "DS", "Value": [-35.29152086738]},
        "1418": {"vr": "DS", "Value": [29.708477037655]},
        "1419": {"vr": "DS", "Value": [29.708477037655]},
        "1420": {"vr": "DS", "Value": [7.2084777291701]},
        "1421": {"vr": "DS", "Value": [44.708478557311]},
        "1422": {"vr": "DS", "Value": [39.708478050759]},
        "1423": {"vr": "DS", "Value": [-57.791522737289]},
        "1424": {"vr": "DS", "Value": [-5.291521963351]},
        "1425": {"vr": "DS", "Value": [64.70847603866]},
        "1426": {"vr": "DS", "Value": [64.70847603866]},
        "1427": {"vr": "DS", "Value": [-72.791520224055]},
        "1428": {"vr": "DS", "Value": [-15.291522976455]},
        "1429": {"vr": "DS", "Value": [-35.29152086738]},
        "1430": {"vr": "DS", "Value": [32.208477290931]},
        "1431": {"vr": "DS", "Value": [-67.791519819897]},
        "1432": {"vr": "DS", "Value": [-62.791519415738]},
        "1433": {"vr": "DS", "Value": [19.70847829698]},
        "1434": {"vr": "DS", "Value": [49.708478654288]},
        "1435": {"vr": "DS", "Value": [64.70847603866]},
        "1436": {"vr": "DS", "Value": [37.208477797483]},
        "1437": {"vr": "DS", "Value": [62.208476194959]},
        "1438": {"vr": "DS", "Value": [-72.791520224055]},
        "1439": {"vr": "DS", "Value": [22.208478550256]},
        "1440": {"vr": "DS", "Value": [-37.791521120656]},
        "1441": {"vr": "DS", "Value": [64.70847603866]},
        "1442": {"vr": "DS", "Value": [-50.291522079855]},
        "1443": {"vr": "DS", "Value": [9.7084777495894]},
        "1444": {"vr": "DS", "Value": [-17.791523024944]},
        "1445": {"vr": "DS", "Value": [52.208478907564]},
        "1446": {"vr": "DS", "Value": [37.208477797483]},
        "1447": {"vr": "DS", "Value": [59.708475941683]},
        "1448": {"vr": "DS", "Value": [-62.791519415738]},
        "1449": {"vr": "DS", "Value": [-40.291521169144]},
        "1450": {"vr": "DS", "Value": [52.208478907564]},
        "1451": {"vr": "DS", "Value": [-30.291520360827]},
        "1452": {"vr": "DS", "Value": [-5.291521963351]},
        "1453": {"vr": "DS", "Value": [-60.291522888171]},
        "1454": {"vr": "DS", "Value": [24.708478393957]},
        "1455": {"vr": "DS", "Value": [-42.79152142242]},
        "1456": {"vr": "DS", "Value": [12.208477537152]},
        "1457": {"vr": "DS", "Value": [-32.791520614104]},
        "1458": {"vr": "DS", "Value": [72.208476798488]},
        "1459": {"vr": "DS", "Value": [-40.291521169144]},
        "1460": {"vr": "DS", "Value": [69.708476545212]},
        "1461": {"vr": "DS", "Value": [-12.791522723179]},
        "1462": {"vr": "DS", "Value": [-12.791522723179]},
        "1463": {"vr": "DS", "Value": [-5.291521963351]},
        "1464": {"vr": "DS", "Value": [49.708478654288]},
        "1465": {"vr": "DS", "Value": [-10.291522469903]},
        "1466": {"vr": "DS", "Value": [67.208476291936]},
        "1467": {"vr": "DS", "Value": [-5.291521963351]},
        "1468": {"vr": "DS", "Value": [-60.291522888171]},
        "1469": {"vr": "DS", "Value": [-5.291521963351]},
        "1470": {"vr": "DS", "Value": [-7.7915222166271]},
        "1471": {"vr": "DS", "Value": [-50.291522079855]},
        "1472": {"vr": "DS", "Value": [22.208478550256]},
        "1473": {"vr": "DS", "Value": [4.7084775923224]},
        "1474": {"vr": "DS", "Value": [-52.791522230737]},
        "1475": {"vr": "DS", "Value": [-52.791522230737]},
        "1476": {"vr": "DS", "Value": [47.208478401012]},
        "1477": {"vr": "DS", "Value": [-0.2915219225125]},
        "1478": {"vr": "DS", "Value": [54.70847916084]},
        "1479": {"vr": "DS", "Value": [-60.291522888171]},
        "1480": {"vr": "DS", "Value": [37.208477797483]},
        "1481": {"vr": "DS", "Value": [62.208476194959]},
        "1482": {"vr": "DS", "Value": [17.208478043704]},
        "1483": {"vr": "DS", "Value": [12.208477537152]},
        "1484": {"vr": "DS", "Value": [2.2084775719032]},
        "1485": {"vr": "DS", "Value": [-67.791519819897]},
        "1486": {"vr": "DS", "Value": [-35.29152086738]},
        "1487": {"vr": "DS", "Value": [27.208476784379]},
        "1488": {"vr": "DS", "Value": [49.708478654288]},
        "1489": {"vr": "DS", "Value": [54.70847916084]},
        "1490": {"vr": "DS", "Value": [7.2084777291701]},
        "1491": {"vr": "DS", "Value": [-30.291520360827]},
        "1492": {"vr": "DS", "Value": [22.208478550256]},
        "1493": {"vr": "DS", "Value": [64.70847603866]},
        "1494": {"vr": "DS", "Value": [-45.291521675696]},
        "1495": {"vr": "DS", "Value": [-37.791521120656]},
        "1496": {"vr": "DS", "Value": [-55.291522484013]},
        "1497": {"vr": "DS", "Value": [59.708475941683]},
        "1498": {"vr": "DS", "Value": [37.208477797483]},
        "1499": {"vr": "DS", "Value": [-45.291521675696]},
        "1500": {"vr": "DS", "Value": [29.708477037655]},
        "1501": {"vr": "DS", "Value": [-62.791519415738]},
        "1502": {"vr": "DS", "Value": [-50.291522079855]},
        "1503": {"vr": "DS", "Value": [-47.791521826579]},
        "1504": {"vr": "DS", "Value": [-47.791521826579]},
        "1505": {"vr": "DS", "Value": [62.208476194959]},
        "1506": {"vr": "DS", "Value": [44.708478557311]},
        "1507": {"vr": "DS", "Value": [-22.791521668641]},
        "1508": {"vr": "DS", "Value": [34.708477544207]},
        "1509": {"vr": "DS", "Value": [-45.291521675696]},
        "1510": {"vr": "DS", "Value": [27.208476784379]},
        "1511": {"vr": "DS", "Value": [-55.291522484013]},
        "1512": {"vr": "DS", "Value": [-62.791519415738]},
        "1513": {"vr": "DS", "Value": [-30.291520360827]},
        "1514": {"vr": "DS", "Value": [-60.291522888171]},
        "1515": {"vr": "DS", "Value": [-10.291522469903]},
        "1516": {"vr": "DS", "Value": [-15.291522976455]},
        "1517": {"vr": "DS", "Value": [-7.7915222166271]},
        "1518": {"vr": "DS", "Value": [47.208478401012]},
        "1519": {"vr": "DS", "Value": [-37.791521120656]},
        "1520": {"vr": "DS", "Value": [-57.791522737289]},
        "1521": {"vr": "DS", "Value": [62.208476194959]},
        "1522": {"vr": "DS", "Value": [-2.7915221757886]},
        "1523": {"vr": "DS", "Value": [-7.7915222166271]},
        "1524": {"vr": "DS", "Value": [69.708476545212]},
        "1525": {"vr": "DS", "Value": [-10.291522469903]},
        "1526": {"vr": "DS", "Value": [72.208476798488]},
        "1527": {"vr": "DS", "Value": [-30.291520360827]},
        "1528": {"vr": "DS", "Value": [-57.791522737289]},
        "1529": {"vr": "DS", "Value": [17.208478043704]},
        "1530": {"vr": "DS", "Value": [-32.791520614104]},
        "1531": {"vr": "DS", "Value": [-65.291519566621]},
        "1532": {"vr": "DS", "Value": [-10.291522469903]},
        "1533": {"vr": "DS", "Value": [-27.791521970406]},
        "1534": {"vr": "DS", "Value": [64.70847603866]},
        "1535": {"vr": "DS", "Value": [-25.291521921917]},
        "1536": {"vr": "DS", "Value": [9.7084777495894]},
        "1537": {"vr": "DS", "Value": [-17.791523024944]},
        "1538": {"vr": "DS", "Value": [49.708478654288]},
        "1539": {"vr": "DS", "Value": [34.708477544207]},
        "1540": {"vr": "DS", "Value": [-25.291521921917]},
        "1541": {"vr": "DS", "Value": [34.708477544207]},
        "1542": {"vr": "DS", "Value": [-12.791522723179]},
        "1543": {"vr": "DS", "Value": [9.7084777495894]},
        "1544": {"vr": "DS", "Value": [62.208476194959]},
        "1545": {"vr": "DS", "Value": [-15.291522976455]},
        "1546": {"vr": "DS", "Value": [-22.791521668641]},
        "1547": {"vr": "DS", "Value": [-2.7915221757886]},
        "1548": {"vr": "DS", "Value": [42.208478304035]},
        "1549": {"vr": "DS", "Value": [-17.791523024944]},
        "1550": {"vr": "DS", "Value": [-32.791520614104]},
        "1551": {"vr": "DS", "Value": [42.208478304035]},
        "1552": {"vr": "DS", "Value": [32.208477290931]},
        "1553": {"vr": "DS", "Value": [24.708478393957]},
        "1554": {"vr": "DS", "Value": [-15.291522976455]},
        "1555": {"vr": "DS", "Value": [-22.791521668641]},
        "1556": {"vr": "DS", "Value": [-5.291521963351]},
        "1557": {"vr": "DS", "Value": [59.708475941683]},
        "1558": {"vr": "DS", "Value": [57.208479414116]},
        "1559": {"vr": "DS", "Value": [4.7084775923224]},
        "1560": {"vr": "DS", "Value": [-55.291522484013]},
        "1561": {"vr": "DS", "Value": [74.708477051764]},
        "1562": {"vr": "DS", "Value": [-40.291521169144]},
        "1563": {"vr": "DS", "Value": [42.208478304035]},
        "1564": {"vr": "DS", "Value": [64.70847603866]},
        "1565": {"vr": "DS", "Value": [42.208478304035]},
        "1566": {"vr": "DS", "Value": [-60.291522888171]},
        "1567": {"vr": "DS", "Value": [-35.29152086738]},
        "1568": {"vr": "DS", "Value": [-70.291520021976]},
        "1569": {"vr": "DS", "Value": [32.208477290931]},
        "1570": {"vr": "DS", "Value": [-35.29152086738]},
        "1571": {"vr": "DS", "Value": [9.7084777495894]},
        "1572": {"vr": "DS", "Value": [-72.791520224055]},
        "1573": {"vr": "DS", "Value": [-45.291521675696]},
        "1574": {"vr": "DS", "Value": [54.70847916084]},
        "1575": {"vr": "DS", "Value": [62.208476194959]},
        "1576": {"vr": "DS", "Value": [17.208478043704]},
        "1577": {"vr": "DS", "Value": [47.208478401012]},
        "1578": {"vr": "DS", "Value": [-22.791521668641]},
        "1579": {"vr": "DS", "Value": [12.208477537152]},
        "1580": {"vr": "DS", "Value": [-67.791519819897]},
        "1581": {"vr": "DS", "Value": [4.7084775923224]},
        "1582": {"vr": "DS", "Value": [-47.791521826579]},
        "1583": {"vr": "DS", "Value": [12.208477537152]},
        "1584": {"vr": "DS", "Value": [-40.291521169144]},
        "1585": {"vr": "DS", "Value": [22.208478550256]},
        "1586": {"vr": "DS", "Value": [-20.291521415365]},
        "1587": {"vr": "DS", "Value": [27.208476784379]},
        "1588": {"vr": "DS", "Value": [17.208478043704]},
        "1589": {"vr": "DS", "Value": [-65.291519566621]},
        "1590": {"vr": "DS", "Value": [72.208476798488]},
        "1591": {"vr": "DS", "Value": [-12.791522723179]},
        "1592": {"vr": "DS", "Value": [9.7084777495894]},
        "1593": {"vr": "DS", "Value": [69.708476545212]},
        "1594": {"vr": "DS", "Value": [9.7084777495894]},
        "1595": {"vr": "DS", "Value": [-7.7915222166271]},
        "1596": {"vr": "DS", "Value": [-65.291519566621]},
        "1597": {"vr": "DS", "Value": [-12.791522723179]},
        "1598": {"vr": "DS", "Value": [49.708478654288]},
        "1599": {"vr": "DS", "Value": [-35.29152086738]},
        "1600": {"vr": "DS", "Value": [44.708478557311]},
        "1601": {"vr": "DS", "Value": [52.208478907564]},
        "1602": {"vr": "DS", "Value": [39.708478050759]},
        "1603": {"vr": "DS", "Value": [14.708477790428]},
        "1604": {"vr": "DS", "Value": [42.208478304035]},
        "1605": {"vr": "DS", "Value": [44.708478557311]},
        "1606": {"vr": "DS", "Value": [29.708477037655]},
        "1607": {"vr": "DS", "Value": [7.2084777291701]},
        "1608": {"vr": "DS", "Value": [-65.291519566621]},
        "1609": {"vr": "DS", "Value": [-37.791521120656]},
        "1610": {"vr": "DS", "Value": [22.208478550256]},
        "1611": {"vr": "DS", "Value": [72.208476798488]},
        "1612": {"vr": "DS", "Value": [62.208476194959]},
        "1613": {"vr": "DS", "Value": [44.708478557311]},
        "1614": {"vr": "DS", "Value": [-27.791521970406]},
        "1615": {"vr": "DS", "Value": [32.208477290931]},
        "1616": {"vr": "DS", "Value": [-10.291522469903]},
        "1617": {"vr": "DS", "Value": [-57.791522737289]},
        "1618": {"vr": "DS", "Value": [-57.791522737289]},
        "1619": {"vr": "DS", "Value": [72.208476798488]},
        "1620": {"vr": "DS", "Value": [-62.791519415738]},
        "1621": {"vr": "DS", "Value": [-45.291521675696]},
        "1622": {"vr": "DS", "Value": [-17.791523024944]},
        "1623": {"vr": "DS", "Value": [17.208478043704]},
        "1624": {"vr": "DS", "Value": [54.70847916084]},
        "1625": {"vr": "DS", "Value": [-0.2915219225125]},
        "1626": {"vr": "DS", "Value": [9.7084777495894]},
        "1627": {"vr": "DS", "Value": [44.708478557311]},
        "1628": {"vr": "DS", "Value": [-12.791522723179]},
        "1629": {"vr": "DS", "Value": [-12.791522723179]},
        "1630": {"vr": "DS", "Value": [29.708477037655]},
        "1631": {"vr": "DS", "Value": [-25.291521921917]},
        "1632": {"vr": "DS", "Value": [-72.791520224055]},
        "1633": {"vr": "DS", "Value": [-47.791521826579]},
        "1634": {"vr": "DS", "Value": [39.708478050759]},
        "1635": {"vr": "DS", "Value": [-52.791522230737]},
        "1636": {"vr": "DS", "Value": [22.208478550256]},
        "1637": {"vr": "DS", "Value": [-70.291520021976]},
        "1638": {"vr": "DS", "Value": [-35.29152086738]},
        "1639": {"vr": "DS", "Value": [19.70847829698]},
        "1640": {"vr": "DS", "Value": [32.208477290931]},
        "1641": {"vr": "DS", "Value": [47.208478401012]},
        "1642": {"vr": "DS", "Value": [-42.79152142242]},
        "1643": {"vr": "DS", "Value": [69.708476545212]},
        "1644": {"vr": "DS", "Value": [-5.291521963351]},
        "1645": {"vr": "DS", "Value": [32.208477290931]},
        "1646": {"vr": "DS", "Value": [4.7084775923224]},
        "1647": {"vr": "DS", "Value": [-5.291521963351]},
        "1648": {"vr": "DS", "Value": [59.708475941683]},
        "1649": {"vr": "DS", "Value": [2.2084775719032]},
        "1650": {"vr": "DS", "Value": [-67.791519819897]},
        "1651": {"vr": "DS", "Value": [32.208477290931]},
        "1652": {"vr": "DS", "Value": [69.708476545212]},
        "1653": {"vr": "DS", "Value": [-42.79152142242]},
        "1654": {"vr": "DS", "Value": [69.708476545212]},
        "1655": {"vr": "DS", "Value": [-60.291522888171]},
        "1656": {"vr": "DS", "Value": [24.708478393957]},
        "1657": {"vr": "DS", "Value": [67.208476291936]},
        "1658": {"vr": "DS", "Value": [4.7084775923224]},
        "1659": {"vr": "DS", "Value": [-70.291520021976]},
        "1660": {"vr": "DS", "Value": [24.708478393957]},
        "1661": {"vr": "DS", "Value": [29.708477037655]},
        "1662": {"vr": "DS", "Value": [32.208477290931]},
        "1663": {"vr": "DS", "Value": [-35.29152086738]},
        "1664": {"vr": "DS", "Value": [49.708478654288]},
        "1665": {"vr": "DS", "Value": [52.208478907564]},
        "1666": {"vr": "DS", "Value": [52.208478907564]},
        "1667": {"vr": "DS", "Value": [57.208479414116]},
        "1668": {"vr": "DS", "Value": [12.208477537152]},
        "1669": {"vr": "DS", "Value": [64.70847603866]},
        "1670": {"vr": "DS", "Value": [9.7084777495894]},
        "1671": {"vr": "DS", "Value": [52.208478907564]},
        "1672": {"vr": "DS", "Value": [-50.291522079855]},
        "1673": {"vr": "DS", "Value": [4.7084775923224]},
        "1674": {"vr": "DS", "Value": [67.208476291936]},
        "1675": {"vr": "DS", "Value": [-52.791522230737]},
        "1676": {"vr": "DS", "Value": [29.708477037655]},
        "1677": {"vr": "DS", "Value": [-45.291521675696]},
        "1678": {"vr": "DS", "Value": [-45.291521675696]},
        "1679": {"vr": "DS", "Value": [57.208479414116]},
        "1680": {"vr": "DS", "Value": [-15.291522976455]},
        "1681": {"vr": "DS", "Value": [-55.291522484013]},
        "1682": {"vr": "DS", "Value": [24.708478393957]},
        "1683": {"vr": "DS", "Value": [-65.291519566621]},
        "1684": {"vr": "DS", "Value": [-10.291522469903]},
        "1685": {"vr": "DS", "Value": [67.208476291936]},
        "1686": {"vr": "DS", "Value": [-72.791520224055]},
        "1687": {"vr": "DS", "Value": [-47.791521826579]},
        "1688": {"vr": "DS", "Value": [52.208478907564]},
        "1689": {"vr": "DS", "Value": [-35.29152086738]},
        "1690": {"vr": "DS", "Value": [72.208476798488]},
        "1691": {"vr": "DS", "Value": [34.708477544207]},
        "1692": {"vr": "DS", "Value": [-25.291521921917]},
        "1693": {"vr": "DS", "Value": [-0.2915219225125]},
        "1694": {"vr": "DS", "Value": [-25.291521921917]},
        "1695": {"vr": "DS", "Value": [-67.791519819897]},
        "1696": {"vr": "DS", "Value": [64.70847603866]},
        "1697": {"vr": "DS", "Value": [24.708478393957]},
        "1698": {"vr": "DS", "Value": [-47.791521826579]},
        "1699": {"vr": "DS", "Value": [4.7084775923224]},
        "1700": {"vr": "DS", "Value": [59.708475941683]},
        "1701": {"vr": "DS", "Value": [-7.7915222166271]},
        "1702": {"vr": "DS", "Value": [-60.291522888171]},
        "1703": {"vr": "DS", "Value": [-65.291519566621]},
        "1704": {"vr": "DS", "Value": [24.708478393957]},
        "1705": {"vr": "DS", "Value": [59.708475941683]},
        "1706": {"vr": "DS", "Value": [-62.791519415738]},
        "1707": {"vr": "DS", "Value": [-65.291519566621]},
        "1708": {"vr": "DS", "Value": [14.708477790428]},
        "1709": {"vr": "DS", "Value": [-40.291521169144]},
        "1710": {"vr": "DS", "Value": [-35.29152086738]},
        "1711": {"vr": "DS", "Value": [67.208476291936]},
        "1712": {"vr": "DS", "Value": [2.2084775719032]},
        "1713": {"vr": "DS", "Value": [-55.291522484013]},
        "1714": {"vr": "DS", "Value": [-27.791521970406]},
        "1715": {"vr": "DS", "Value": [17.208478043704]},
        "1716": {"vr": "DS", "Value": [7.2084777291701]},
        "1717": {"vr": "DS", "Value": [-65.291519566621]},
        "1718": {"vr": "DS", "Value": [-42.79152142242]},
        "1719": {"vr": "DS", "Value": [-30.291520360827]},
        "1720": {"vr": "DS", "Value": [67.208476291936]},
        "1721": {"vr": "DS", "Value": [52.208478907564]},
        "1722": {"vr": "DS", "Value": [-45.291521675696]},
        "1723": {"vr": "DS", "Value": [-37.791521120656]},
        "1724": {"vr": "DS", "Value": [-27.791521970406]},
        "1725": {"vr": "DS", "Value": [-67.791519819897]},
        "1726": {"vr": "DS", "Value": [-15.291522976455]},
        "1727": {"vr": "DS", "Value": [-62.791519415738]},
        "1728": {"vr": "DS", "Value": [-0.2915219225125]},
        "1729": {"vr": "DS", "Value": [32.208477290931]},
        "1730": {"vr": "DS", "Value": [74.708477051764]},
        "1731": {"vr": "DS", "Value": [-60.291522888171]},
        "1732": {"vr": "DS", "Value": [-37.791521120656]},
        "1733": {"vr": "DS", "Value": [24.708478393957]},
        "1734": {"vr": "DS", "Value": [-52.791522230737]},
        "1735": {"vr": "DS", "Value": [14.708477790428]},
        "1736": {"vr": "DS", "Value": [-67.791519819897]},
        "1737": {"vr": "DS", "Value": [4.7084775923224]},
        "1738": {"vr": "DS", "Value": [59.708475941683]},
        "1739": {"vr": "DS", "Value": [-57.791522737289]},
        "1740": {"vr": "DS", "Value": [29.708477037655]},
        "1741": {"vr": "DS", "Value": [42.208478304035]},
        "1742": {"vr": "DS", "Value": [2.2084775719032]},
        "1743": {"vr": "DS", "Value": [39.708478050759]},
        "1744": {"vr": "DS", "Value": [59.708475941683]},
        "1745": {"vr": "DS", "Value": [-67.791519819897]},
        "1746": {"vr": "DS", "Value": [7.2084777291701]},
        "1747": {"vr": "DS", "Value": [-2.7915221757886]},
        "1748": {"vr": "DS", "Value": [22.208478550256]},
        "1749": {"vr": "DS", "Value": [-70.291520021976]},
        "1750": {"vr": "DS", "Value": [49.708478654288]},
        "1751": {"vr": "DS", "Value": [-47.791521826579]},
        "1752": {"vr": "DS", "Value": [-20.291521415365]},
        "1753": {"vr": "DS", "Value": [27.208476784379]},
        "1754": {"vr": "DS", "Value": [-5.291521963351]},
        "1755": {"vr": "DS", "Value": [29.708477037655]},
        "1756": {"vr": "DS", "Value": [29.708477037655]},
        "1757": {"vr": "DS", "Value": [-47.791521826579]},
        "1758": {"vr": "DS", "Value": [39.708478050759]},
        "1759": {"vr": "DS", "Value": [59.708475941683]},
        "1760": {"vr": "DS", "Value": [-32.791520614104]},
        "1761": {"vr": "DS", "Value": [-67.791519819897]},
        "1762": {"vr": "DS", "Value": [9.7084777495894]},
        "1763": {"vr": "DS", "Value": [-30.291520360827]},
        "1764": {"vr": "DS", "Value": [2.2084775719032]},
        "1765": {"vr": "DS", "Value": [67.208476291936]},
        "1766": {"vr": "DS", "Value": [-37.791521120656]},
        "1767": {"vr": "DS", "Value": [-10.291522469903]},
        "1768": {"vr": "DS", "Value": [-12.791522723179]},
        "1769": {"vr": "DS", "Value": [-15.291522976455]},
        "1770": {"vr": "DS", "Value": [-60.291522888171]},
        "1771": {"vr": "DS", "Value": [-52.791522230737]},
        "1772": {"vr": "DS", "Value": [44.708478557311]},
        "1773": {"vr": "DS", "Value": [-60.291522888171]},
        "1774": {"vr": "DS", "Value": [47.208478401012]},
        "1775": {"vr": "DS", "Value": [-5.291521963351]},
        "1776": {"vr": "DS", "Value": [-32.791520614104]},
        "1777": {"vr": "DS", "Value": [57.208479414116]},
        "1778": {"vr": "DS", "Value": [62.208476194959]},
        "1779": {"vr": "DS", "Value": [72.208476798488]},
        "1780": {"vr": "DS", "Value": [14.708477790428]},
        "1781": {"vr": "DS", "Value": [-42.79152142242]},
        "1782": {"vr": "DS", "Value": [-25.291521921917]},
        "1783": {"vr": "DS", "Value": [-50.291522079855]},
        "1784": {"vr": "DS", "Value": [-25.291521921917]},
        "1785": {"vr": "DS", "Value": [-32.791520614104]},
        "1786": {"vr": "DS", "Value": [-50.291522079855]},
        "1787": {"vr": "DS", "Value": [-52.791522230737]},
        "1788": {"vr": "DS", "Value": [37.208477797483]},
        "1789": {"vr": "DS", "Value": [-62.791519415738]},
        "1790": {"vr": "DS", "Value": [-72.791520224055]},
        "1791": {"vr": "DS", "Value": [29.708477037655]},
        "1792": {"vr": "DS", "Value": [-15.291522976455]},
        "1793": {"vr": "DS", "Value": [-50.291522079855]},
        "1794": {"vr": "DS", "Value": [7.2084777291701]},
        "1795": {"vr": "DS", "Value": [9.7084777495894]},
        "1796": {"vr": "DS", "Value": [29.708477037655]},
        "1797": {"vr": "DS", "Value": [57.208479414116]},
        "1798": {"vr": "DS", "Value": [2.2084775719032]},
        "1799": {"vr": "DS", "Value": [4.7084775923224]},
        "1800": {"vr": "DS", "Value": [44.708478557311]},
        "1801": {"vr": "DS", "Value": [-45.291521675696]},
        "1802": {"vr": "DS", "Value": [-30.291520360827]},
        "1803": {"vr": "DS", "Value": [54.70847916084]},
        "1804": {"vr": "DS", "Value": [64.70847603866]},
        "1805": {"vr": "DS", "Value": [22.208478550256]},
        "1806": {"vr": "DS", "Value": [74.708477051764]},
        "1807": {"vr": "DS", "Value": [-27.791521970406]},
        "1808": {"vr": "DS", "Value": [52.208478907564]},
        "1809": {"vr": "DS", "Value": [62.208476194959]},
        "1810": {"vr": "DS", "Value": [64.70847603866]},
        "1811": {"vr": "DS", "Value": [42.208478304035]},
        "1812": {"vr": "DS", "Value": [-37.791521120656]},
        "1813": {"vr": "DS", "Value": [14.708477790428]},
        "1814": {"vr": "DS", "Value": [-7.7915222166271]},
        "1815": {"vr": "DS", "Value": [-27.791521970406]},
        "1816": {"vr": "DS", "Value": [62.208476194959]},
        "1817": {"vr": "DS", "Value": [-62.791519415738]},
        "1818": {"vr": "DS", "Value": [-22.791521668641]},
        "1819": {"vr": "DS", "Value": [52.208478907564]},
        "1820": {"vr": "DS", "Value": [-30.291520360827]},
        "1821": {"vr": "DS", "Value": [72.208476798488]},
        "1822": {"vr": "DS", "Value": [-72.791520224055]},
        "1823": {"vr": "DS", "Value": [32.208477290931]},
        "1824": {"vr": "DS", "Value": [54.70847916084]},
        "1825": {"vr": "DS", "Value": [22.208478550256]},
        "1826": {"vr": "DS", "Value": [-72.791520224055]},
        "1827": {"vr": "DS", "Value": [17.208478043704]},
        "1828": {"vr": "DS", "Value": [52.208478907564]},
        "1829": {"vr": "DS", "Value": [-65.291519566621]},
        "1830": {"vr": "DS", "Value": [-0.2915219225125]},
        "1831": {"vr": "DS", "Value": [49.708478654288]},
        "1832": {"vr": "DS", "Value": [59.708475941683]},
        "1833": {"vr": "DS", "Value": [-0.2915219225125]},
        "1834": {"vr": "DS", "Value": [-22.791521668641]},
        "1835": {"vr": "DS", "Value": [39.708478050759]},
        "1836": {"vr": "DS", "Value": [14.708477790428]},
        "1837": {"vr": "DS", "Value": [42.208478304035]},
        "1838": {"vr": "DS", "Value": [57.208479414116]},
        "1839": {"vr": "DS", "Value": [-10.291522469903]},
        "1840": {"vr": "DS", "Value": [-57.791522737289]},
        "1841": {"vr": "DS", "Value": [19.70847829698]},
        "1842": {"vr": "DS", "Value": [37.208477797483]},
        "1843": {"vr": "DS", "Value": [39.708478050759]},
        "1844": {"vr": "DS", "Value": [47.208478401012]},
        "1845": {"vr": "DS", "Value": [-70.291520021976]},
        "1846": {"vr": "DS", "Value": [-27.791521970406]},
        "1847": {"vr": "DS", "Value": [62.208476194959]},
        "1848": {"vr": "DS", "Value": [39.708478050759]},
        "1849": {"vr": "DS", "Value": [47.208478401012]},
        "1850": {"vr": "DS", "Value": [-10.291522469903]},
        "1851": {"vr": "DS", "Value": [-65.291519566621]},
        "1852": {"vr": "DS", "Value": [54.70847916084]},
        "1853": {"vr": "DS", "Value": [-32.791520614104]},
        "1854": {"vr": "DS", "Value": [-42.79152142242]},
        "1855": {"vr": "DS", "Value": [-12.791522723179]},
        "1856": {"vr": "DS", "Value": [-5.291521963351]},
        "1857": {"vr": "DS", "Value": [-70.291520021976]},
        "1858": {"vr": "DS", "Value": [7.2084777291701]},
        "1859": {"vr": "DS", "Value": [-0.2915219225125]},
        "1860": {"vr": "DS", "Value": [22.208478550256]},
        "1861": {"vr": "DS", "Value": [54.70847916084]},
        "1862": {"vr": "DS", "Value": [-40.291521169144]},
        "1863": {"vr": "DS", "Value": [24.708478393957]},
        "1864": {"vr": "DS", "Value": [49.708478654288]},
        "1865": {"vr": "DS", "Value": [52.208478907564]},
        "1866": {"vr": "DS", "Value": [7.2084777291701]},
        "1867": {"vr": "DS", "Value": [52.208478907564]},
        "1868": {"vr": "DS", "Value": [-72.791520224055]},
        "1869": {"vr": "DS", "Value": [-7.7915222166271]},
        "1870": {"vr": "DS", "Value": [32.208477290931]},
        "1871": {"vr": "DS", "Value": [9.7084777495894]},
        "1872": {"vr": "DS", "Value": [-7.7915222166271]},
        "1873": {"vr": "DS", "Value": [-62.791519415738]},
        "1874": {"vr": "DS", "Value": [-35.29152086738]},
        "1875": {"vr": "DS", "Value": [62.208476194959]},
        "1876": {"vr": "DS", "Value": [-17.791523024944]},
        "1877": {"vr": "DS", "Value": [-55.291522484013]},
        "1878": {"vr": "DS", "Value": [59.708475941683]},
        "1879": {"vr": "DS", "Value": [44.708478557311]},
        "1880": {"vr": "DS", "Value": [-7.7915222166271]},
        "1881": {"vr": "DS", "Value": [67.208476291936]},
        "1882": {"vr": "DS", "Value": [-25.291521921917]},
        "1883": {"vr": "DS", "Value": [72.208476798488]},
        "1884": {"vr": "DS", "Value": [-10.291522469903]},
        "1885": {"vr": "DS", "Value": [57.208479414116]},
        "1886": {"vr": "DS", "Value": [-15.291522976455]},
        "1887": {"vr": "DS", "Value": [59.708475941683]},
        "1888": {"vr": "DS", "Value": [14.708477790428]},
        "1889": {"vr": "DS", "Value": [-25.291521921917]},
        "1890": {"vr": "DS", "Value": [-15.291522976455]},
        "1891": {"vr": "DS", "Value": [69.708476545212]},
        "1892": {"vr": "DS", "Value": [74.708477051764]},
        "1893": {"vr": "DS", "Value": [-45.291521675696]},
        "1894": {"vr": "DS", "Value": [-50.291522079855]},
        "1895": {"vr": "DS", "Value": [-67.791519819897]},
        "1896": {"vr": "DS", "Value": [22.208478550256]},
        "1897": {"vr": "DS", "Value": [-47.791521826579]},
        "1898": {"vr": "DS", "Value": [52.208478907564]},
        "1899": {"vr": "DS", "Value": [42.208478304035]},
        "1900": {"vr": "DS", "Value": [-60.291522888171]},
        "1901": {"vr": "DS", "Value": [7.2084777291701]},
        "1902": {"vr": "DS", "Value": [-45.291521675696]},
        "1903": {"vr": "DS", "Value": [-17.791523024944]},
        "1904": {"vr": "DS", "Value": [59.708475941683]},
        "1905": {"vr": "DS", "Value": [39.708478050759]},
        "1906": {"vr": "DS", "Value": [69.708476545212]},
        "1907": {"vr": "DS", "Value": [-40.291521169144]},
        "1908": {"vr": "DS", "Value": [19.70847829698]},
        "1909": {"vr": "DS", "Value": [-2.7915221757886]},
        "1910": {"vr": "DS", "Value": [-20.291521415365]},
        "1911": {"vr": "DS", "Value": [-5.291521963351]},
        "1912": {"vr": "DS", "Value": [-67.791519819897]},
        "1913": {"vr": "DS", "Value": [2.2084775719032]},
        "1914": {"vr": "DS", "Value": [-22.791521668641]},
        "1915": {"vr": "DS", "Value": [47.208478401012]},
        "1916": {"vr": "DS", "Value": [7.2084777291701]},
        "1917": {"vr": "DS", "Value": [-40.291521169144]},
        "1918": {"vr": "DS", "Value": [-47.791521826579]},
        "1919": {"vr": "DS", "Value": [74.708477051764]},
        "1920": {"vr": "DS", "Value": [-62.791519415738]},
        "1921": {"vr": "DS", "Value": [-55.291522484013]},
        "1922": {"vr": "DS", "Value": [44.708478557311]},
        "1923": {"vr": "DS", "Value": [12.208477537152]},
        "1924": {"vr": "DS", "Value": [54.70847916084]},
        "1925": {"vr": "DS", "Value": [-22.791521668641]},
        "1926": {"vr": "DS", "Value": [17.208478043704]},
        "1927": {"vr": "DS", "Value": [74.708477051764]},
        "1928": {"vr": "DS", "Value": [54.70847916084]},
        "1929": {"vr": "DS", "Value": [-15.291522976455]},
        "1930": {"vr": "DS", "Value": [-55.291522484013]},
        "1931": {"vr": "DS", "Value": [-25.291521921917]},
        "1932": {"vr": "DS", "Value": [-50.291522079855]},
        "1933": {"vr": "DS", "Value": [7.2084777291701]},
        "1934": {"vr": "DS", "Value": [67.208476291936]},
        "1935": {"vr": "DS", "Value": [37.208477797483]},
        "1936": {"vr": "DS", "Value": [57.208479414116]},
        "1937": {"vr": "DS", "Value": [32.208477290931]},
        "1938": {"vr": "DS", "Value": [-22.791521668641]},
        "1939": {"vr": "DS", "Value": [-40.291521169144]},
        "1940": {"vr": "DS", "Value": [62.208476194959]},
        "1941": {"vr": "DS", "Value": [9.7084777495894]},
        "1942": {"vr": "DS", "Value": [12.208477537152]},
        "1943": {"vr": "DS", "Value": [-50.291522079855]},
        "1944": {"vr": "DS", "Value": [32.208477290931]},
        "1945": {"vr": "DS", "Value": [-47.791521826579]},
        "1946": {"vr": "DS", "Value": [-35.29152086738]},
        "1947": {"vr": "DS", "Value": [2.2084775719032]},
        "1948": {"vr": "DS", "Value": [47.208478401012]},
        "1949": {"vr": "DS", "Value": [-7.7915222166271]},
        "1950": {"vr": "DS", "Value": [-60.291522888171]},
        "1951": {"vr": "DS", "Value": [-7.7915222166271]},
        "1952": {"vr": "DS", "Value": [-55.291522484013]},
        "1953": {"vr": "DS", "Value": [52.208478907564]},
        "1954": {"vr": "DS", "Value": [17.208478043704]},
        "1955": {"vr": "DS", "Value": [14.708477790428]},
        "1956": {"vr": "DS", "Value": [34.708477544207]},
        "1957": {"vr": "DS", "Value": [19.70847829698]},
        "1958": {"vr": "DS", "Value": [72.208476798488]},
        "1959": {"vr": "DS", "Value": [-0.2915219225125]},
        "1960": {"vr": "DS", "Value": [52.208478907564]},
        "1961": {"vr": "DS", "Value": [-5.291521963351]},
        "1962": {"vr": "DS", "Value": [-32.791520614104]},
        "1963": {"vr": "DS", "Value": [22.208478550256]},
        "1964": {"vr": "DS", "Value": [-22.791521668641]},
        "1965": {"vr": "DS", "Value": [-22.791521668641]},
        "1966": {"vr": "DS", "Value": [-0.2915219225125]},
        "1967": {"vr": "DS", "Value": [-72.791520224055]},
        "1968": {"vr": "DS", "Value": [-67.791519819897]},
        "1969": {"vr": "DS", "Value": [44.708478557311]},
        "1970": {"vr": "DS", "Value": [34.708477544207]},
        "1971": {"vr": "DS", "Value": [7.2084777291701]},
        "1972": {"vr": "DS", "Value": [-12.791522723179]},
        "1973": {"vr": "DS", "Value": [-45.291521675696]},
        "1974": {"vr": "DS", "Value": [47.208478401012]},
        "1975": {"vr": "DS", "Value": [-62.791519415738]},
        "1976": {"vr": "DS", "Value": [-12.791522723179]},
        "1977": {"vr": "DS", "Value": [2.2084775719032]},
        "1978": {"vr": "DS", "Value": [-22.791521668641]},
        "1979": {"vr": "DS", "Value": [-55.291522484013]},
        "1980": {"vr": "DS", "Value": [-65.291519566621]},
        "1981": {"vr": "DS", "Value": [72.208476798488]},
        "1982": {"vr": "DS", "Value": [32.208477290931]},
        "1983": {"vr": "DS", "Value": [49.708478654288]},
        "1984": {"vr": "DS", "Value": [-17.791523024944]},
        "1985": {"vr": "DS", "Value": [34.708477544207]},
        "1986": {"vr": "DS", "Value": [72.208476798488]},
        "1987": {"vr": "DS", "Value": [-12.791522723179]},
        "1988": {"vr": "DS", "Value": [-30.291520360827]},
        "1989": {"vr": "DS", "Value": [-72.791520224055]},
        "1990": {"vr": "DS", "Value": [12.208477537152]},
        "1991": {"vr": "DS", "Value": [32.208477290931]},
        "1992": {"vr": "DS", "Value": [57.208479414116]},
        "1993": {"vr": "DS", "Value": [-7.7915222166271]},
        "1994": {"vr": "DS", "Value": [44.708478557311]},
        "1995": {"vr": "DS", "Value": [-17.791523024944]},
        "1996": {"vr": "DS", "Value": [-35.29152086738]},
        "1997": {"vr": "DS", "Value": [44.708478557311]},
        "1998": {"vr": "DS", "Value": [-65.291519566621]},
        "1999": {"vr": "DS", "Value": [44.708478557311]},
        "2000": {"vr": "DS", "Value": [-25.291521921917]},
        "2001": {"vr": "DS", "Value": [49.708478654288]},
        "2002": {"vr": "DS", "Value": [42.208478304035]},
        "2003": {"vr": "DS", "Value": [-5.291521963351]},
        "2004": {"vr": "DS", "Value": [-7.7915222166271]},
        "2005": {"vr": "DS", "Value": [14.708477790428]},
        "2006": {"vr": "DS", "Value": [-72.791520224055]},
        "2007": {"vr": "DS", "Value": [59.708475941683]},
        "2008": {"vr": "DS", "Value": [27.208476784379]},
        "2009": {"vr": "DS", "Value": [9.7084777495894]},
        "2010": {"vr": "DS", "Value": [-30.291520360827]},
        "2011": {"vr": "DS", "Value": [32.208477290931]},
        "2012": {"vr": "DS", "Value": [-25.291521921917]},
        "2013": {"vr": "DS", "Value": [47.208478401012]},
        "2014": {"vr": "DS", "Value": [34.708477544207]},
        "2015": {"vr": "DS", "Value": [-50.291522079855]},
        "2016": {"vr": "DS", "Value": [-37.791521120656]},
        "2017": {"vr": "DS", "Value": [-70.291520021976]},
        "2018": {"vr": "DS", "Value": [-22.791521668641]},
        "2019": {"vr": "DS", "Value": [-52.791522230737]},
        "2020": {"vr": "DS", "Value": [32.208477290931]},
        "2021": {"vr": "DS", "Value": [-27.791521970406]},
        "2022": {"vr": "DS", "Value": [-32.791520614104]},
        "2023": {"vr": "DS", "Value": [64.70847603866]},
        "2024": {"vr": "DS", "Value": [7.2084777291701]},
        "2025": {"vr": "DS", "Value": [47.208478401012]},
        "2026": {"vr": "DS", "Value": [-47.791521826579]},
        "2027": {"vr": "DS", "Value": [19.70847829698]},
        "2028": {"vr": "DS", "Value": [-5.291521963351]},
        "2029": {"vr": "DS", "Value": [32.208477290931]},
        "2030": {"vr": "DS", "Value": [-25.291521921917]},
        "2031": {"vr": "DS", "Value": [69.708476545212]},
        "2032": {"vr": "DS", "Value": [-27.791521970406]},
        "2033": {"vr": "DS", "Value": [17.208478043704]},
        "2034": {"vr": "DS", "Value": [9.7084777495894]},
        "2035": {"vr": "DS", "Value": [-0.2915219225125]},
        "2036": {"vr": "DS", "Value": [-2.7915221757886]},
        "2037": {"vr": "DS", "Value": [47.208478401012]},
        "2038": {"vr": "DS", "Value": [74.708477051764]},
        "2039": {"vr": "DS", "Value": [2.2084775719032]},
        "2040": {"vr": "DS", "Value": [-25.291521921917]},
        "2041": {"vr": "DS", "Value": [4.7084775923224]},
        "2042": {"vr": "DS", "Value": [49.708478654288]},
        "2043": {"vr": "DS", "Value": [-0.2915219225125]},
        "2044": {"vr": "DS", "Value": [47.208478401012]},
        "2045": {"vr": "DS", "Value": [-12.791522723179]},
        "2046": {"vr": "DS", "Value": [-20.291521415365]},
        "2047": {"vr": "DS", "Value": [-62.791519415738]},
        "2048": {"vr": "DS", "Value": [32.208477290931]},
        "2049": {"vr": "DS", "Value": [-32.791520614104]},
        "2050": {"vr": "DS", "Value": [29.708477037655]},
        "2051": {"vr": "DS", "Value": [-22.791521668641]},
        "2052": {"vr": "DS", "Value": [69.708476545212]},
        "2053": {"vr": "DS", "Value": [-20.291521415365]},
        "2054": {"vr": "DS", "Value": [-52.791522230737]},
        "2055": {"vr": "DS", "Value": [4.7084775923224]},
        "2056": {"vr": "DS", "Value": [-70.291520021976]},
        "2057": {"vr": "DS", "Value": [47.208478401012]},
        "2058": {"vr": "DS", "Value": [32.208477290931]},
        "2059": {"vr": "DS", "Value": [-42.79152142242]},
        "2060": {"vr": "DS", "Value": [-0.2915219225125]},
        "2061": {"vr": "DS", "Value": [-27.791521970406]},
        "2062": {"vr": "DS", "Value": [-25.291521921917]},
        "2063": {"vr": "DS", "Value": [-10.291522469903]},
        "2064": {"vr": "DS", "Value": [-20.291521415365]},
        "2065": {"vr": "DS", "Value": [-0.2915219225125]},
        "2066": {"vr": "DS", "Value": [-40.291521169144]},
        "2067": {"vr": "DS", "Value": [27.208476784379]},
        "2068": {"vr": "DS", "Value": [12.208477537152]},
        "2069": {"vr": "DS", "Value": [19.70847829698]},
        "2070": {"vr": "DS", "Value": [32.208477290931]},
        "2071": {"vr": "DS", "Value": [27.208476784379]},
        "2072": {"vr": "DS", "Value": [-40.291521169144]},
        "2073": {"vr": "DS", "Value": [-37.791521120656]},
        "2074": {"vr": "DS", "Value": [-17.791523024944]},
        "2075": {"vr": "DS", "Value": [4.7084775923224]},
        "2076": {"vr": "DS", "Value": [49.708478654288]},
        "2077": {"vr": "DS", "Value": [-57.791522737289]},
        "2078": {"vr": "DS", "Value": [54.70847916084]},
        "2079": {"vr": "DS", "Value": [-12.791522723179]},
        "2080": {"vr": "DS", "Value": [72.208476798488]},
        "2081": {"vr": "DS", "Value": [7.2084777291701]},
        "2082": {"vr": "DS", "Value": [-37.791521120656]},
        "2083": {"vr": "DS", "Value": [-30.291520360827]},
        "2084": {"vr": "DS", "Value": [4.7084775923224]},
        "2085": {"vr": "DS", "Value": [-37.791521120656]},
        "2086": {"vr": "DS", "Value": [54.70847916084]},
        "2087": {"vr": "DS", "Value": [-32.791520614104]},
        "2088": {"vr": "DS", "Value": [-15.291522976455]},
        "2089": {"vr": "DS", "Value": [44.708478557311]},
        "2090": {"vr": "DS", "Value": [39.708478050759]},
        "2091": {"vr": "DS", "Value": [24.708478393957]},
        "2092": {"vr": "DS", "Value": [49.708478654288]},
        "2093": {"vr": "DS", "Value": [44.708478557311]},
        "2094": {"vr": "DS", "Value": [59.708475941683]},
        "2095": {"vr": "DS", "Value": [27.208476784379]},
        "2096": {"vr": "DS", "Value": [24.708478393957]},
        "2097": {"vr": "DS", "Value": [-12.791522723179]},
        "2098": {"vr": "DS", "Value": [-30.291520360827]},
        "2099": {"vr": "DS", "Value": [52.208478907564]},
        "2100": {"vr": "DS", "Value": [62.208476194959]},
        "2101": {"vr": "DS", "Value": [-57.791522737289]},
        "2102": {"vr": "DS", "Value": [-17.791523024944]},
        "2103": {"vr": "DS", "Value": [19.70847829698]},
        "2104": {"vr": "DS", "Value": [-65.291519566621]},
        "2105": {"vr": "DS", "Value": [2.2084775719032]},
        "2106": {"vr": "DS", "Value": [74.708477051764]},
        "2107": {"vr": "DS", "Value": [39.708478050759]},
        "2108": {"vr": "DS", "Value": [-72.791520224055]},
        "2109": {"vr": "DS", "Value": [-60.291522888171]},
        "2110": {"vr": "DS", "Value": [42.208478304035]},
        "2111": {"vr": "DS", "Value": [9.7084777495894]},
        "2112": {"vr": "DS", "Value": [72.208476798488]},
        "2113": {"vr": "DS", "Value": [22.208478550256]},
        "2114": {"vr": "DS", "Value": [64.70847603866]},
        "2115": {"vr": "DS", "Value": [69.708476545212]},
        "2116": {"vr": "DS", "Value": [-50.291522079855]},
        "2117": {"vr": "DS", "Value": [37.208477797483]},
        "2118": {"vr": "DS", "Value": [12.208477537152]},
        "2119": {"vr": "DS", "Value": [-70.291520021976]},
        "2120": {"vr": "DS", "Value": [69.708476545212]},
        "2121": {"vr": "DS", "Value": [19.70847829698]},
        "2122": {"vr": "DS", "Value": [34.708477544207]},
        "2123": {"vr": "DS", "Value": [52.208478907564]},
        "2124": {"vr": "DS", "Value": [-47.791521826579]},
        "2125": {"vr": "DS", "Value": [17.208478043704]},
        "2126": {"vr": "DS", "Value": [7.2084777291701]},
        "2127": {"vr": "DS", "Value": [-20.291521415365]},
        "2128": {"vr": "DS", "Value": [44.708478557311]},
        "2129": {"vr": "DS", "Value": [-20.291521415365]},
        "2130": {"vr": "DS", "Value": [-30.291520360827]},
        "2131": {"vr": "DS", "Value": [4.7084775923224]},
        "2132": {"vr": "DS", "Value": [2.2084775719032]},
        "2133": {"vr": "DS", "Value": [57.208479414116]},
        "2134": {"vr": "DS", "Value": [-10.291522469903]},
        "2135": {"vr": "DS", "Value": [-47.791521826579]},
        "2136": {"vr": "DS", "Value": [44.708478557311]},
        "2137": {"vr": "DS", "Value": [-50.291522079855]},
        "2138": {"vr": "DS", "Value": [4.7084775923224]},
        "2139": {"vr": "DS", "Value": [54.70847916084]},
        "2140": {"vr": "DS", "Value": [-70.291520021976]},
        "2141": {"vr": "DS", "Value": [24.708478393957]},
        "2142": {"vr": "DS", "Value": [32.208477290931]},
        "2143": {"vr": "DS", "Value": [22.208478550256]},
        "2144": {"vr": "DS", "Value": [-27.791521970406]},
        "2145": {"vr": "DS", "Value": [27.208476784379]},
        "2146": {"vr": "DS", "Value": [24.708478393957]},
        "2147": {"vr": "DS", "Value": [54.70847916084]},
        "2148": {"vr": "DS", "Value": [-62.791519415738]},
        "2149": {"vr": "DS", "Value": [17.208478043704]},
        "2150": {"vr": "DS", "Value": [17.208478043704]},
        "2151": {"vr": "DS", "Value": [-72.791520224055]},
        "2152": {"vr": "DS", "Value": [32.208477290931]},
        "2153": {"vr": "DS", "Value": [57.208479414116]},
        "2154": {"vr": "DS", "Value": [12.208477537152]},
        "2155": {"vr": "DS", "Value": [-30.291520360827]},
        "2156": {"vr": "DS", "Value": [-17.791523024944]},
        "2157": {"vr": "DS", "Value": [-25.291521921917]},
        "2158": {"vr": "DS", "Value": [14.708477790428]},
        "2159": {"vr": "DS", "Value": [-42.79152142242]},
        "2160": {"vr": "DS", "Value": [52.208478907564]},
        "2161": {"vr": "DS", "Value": [-12.791522723179]},
        "2162": {"vr": "DS", "Value": [34.708477544207]},
        "2163": {"vr": "DS", "Value": [-5.291521963351]},
        "2164": {"vr": "DS", "Value": [17.208478043704]},
        "2165": {"vr": "DS", "Value": [-65.291519566621]},
        "2166": {"vr": "DS", "Value": [-35.29152086738]},
        "2167": {"vr": "DS", "Value": [-45.291521675696]},
        "2168": {"vr": "DS", "Value": [-70.291520021976]},
        "2169": {"vr": "DS", "Value": [-25.291521921917]},
        "2170": {"vr": "DS", "Value": [-2.7915221757886]},
        "2171": {"vr": "DS", "Value": [22.208478550256]},
        "2172": {"vr": "DS", "Value": [-37.791521120656]},
        "2173": {"vr": "DS", "Value": [-37.791521120656]},
        "2174": {"vr": "DS", "Value": [52.208478907564]},
        "2175": {"vr": "DS", "Value": [22.208478550256]},
        "2176": {"vr": "DS", "Value": [62.208476194959]},
        "2177": {"vr": "DS", "Value": [7.2084777291701]},
        "2178": {"vr": "DS", "Value": [-72.791520224055]},
        "2179": {"vr": "DS", "Value": [-37.791521120656]},
        "2180": {"vr": "DS", "Value": [34.708477544207]},
        "2181": {"vr": "DS", "Value": [44.708478557311]},
        "2182": {"vr": "DS", "Value": [-0.2915219225125]},
        "2183": {"vr": "DS", "Value": [-20.291521415365]},
        "2184": {"vr": "DS", "Value": [-47.791521826579]},
        "2185": {"vr": "DS", "Value": [59.708475941683]},
        "2186": {"vr": "DS", "Value": [59.708475941683]},
        "2187": {"vr": "DS", "Value": [-70.291520021976]},
        "2188": {"vr": "DS", "Value": [-10.291522469903]},
        "2189": {"vr": "DS", "Value": [-12.791522723179]},
        "2190": {"vr": "DS", "Value": [-32.791520614104]},
        "2191": {"vr": "DS", "Value": [64.70847603866]},
        "2192": {"vr": "DS", "Value": [-50.291522079855]},
        "2193": {"vr": "DS", "Value": [57.208479414116]},
        "2194": {"vr": "DS", "Value": [49.708478654288]},
        "2195": {"vr": "DS", "Value": [-22.791521668641]},
        "2196": {"vr": "DS", "Value": [-2.7915221757886]},
        "2197": {"vr": "DS", "Value": [-0.2915219225125]},
        "2198": {"vr": "DS", "Value": [59.708475941683]},
        "2199": {"vr": "DS", "Value": [-52.791522230737]},
        "2200": {"vr": "DS", "Value": [-50.291522079855]},
        "2201": {"vr": "DS", "Value": [-70.291520021976]},
        "2202": {"vr": "DS", "Value": [-70.291520021976]},
        "2203": {"vr": "DS", "Value": [-30.291520360827]},
        "2204": {"vr": "DS", "Value": [34.708477544207]},
        "2205": {"vr": "DS", "Value": [-35.29152086738]},
        "2206": {"vr": "DS", "Value": [-50.291522079855]},
        "2207": {"vr": "DS", "Value": [12.208477537152]},
        "2208": {"vr": "DS", "Value": [29.708477037655]},
        "2209": {"vr": "DS", "Value": [-42.79152142242]},
        "2210": {"vr": "DS", "Value": [-42.79152142242]},
        "2211": {"vr": "DS", "Value": [-70.291520021976]},
        "2212": {"vr": "DS", "Value": [-25.291521921917]},
        "2213": {"vr": "DS", "Value": [47.208478401012]},
        "2214": {"vr": "DS", "Value": [12.208477537152]},
        "2215": {"vr": "DS", "Value": [12.208477537152]},
        "2216": {"vr": "DS", "Value": [-30.291520360827]},
        "2217": {"vr": "DS", "Value": [19.70847829698]},
        "2218": {"vr": "DS", "Value": [9.7084777495894]},
        "2219": {"vr": "DS", "Value": [59.708475941683]},
        "2220": {"vr": "DS", "Value": [-32.791520614104]},
        "2221": {"vr": "DS", "Value": [59.708475941683]},
        "2222": {"vr": "DS", "Value": [-25.291521921917]},
        "2223": {"vr": "DS", "Value": [52.208478907564]},
        "2224": {"vr": "DS", "Value": [37.208477797483]},
        "2225": {"vr": "DS", "Value": [72.208476798488]},
        "2226": {"vr": "DS", "Value": [-42.79152142242]},
        "2227": {"vr": "DS", "Value": [17.208478043704]},
        "2228": {"vr": "DS", "Value": [27.208476784379]},
        "2229": {"vr": "DS", "Value": [72.208476798488]},
        "2230": {"vr": "DS", "Value": [67.208476291936]},
        "2231": {"vr": "DS", "Value": [74.708477051764]},
        "2232": {"vr": "DS", "Value": [14.708477790428]},
        "2233": {"vr": "DS", "Value": [12.208477537152]},
        "2234": {"vr": "DS", "Value": [29.708477037655]},
        "2235": {"vr": "DS", "Value": [-5.291521963351]},
        "2236": {"vr": "DS", "Value": [49.708478654288]},
        "2237": {"vr": "DS", "Value": [12.208477537152]},
        "2238": {"vr": "DS", "Value": [-70.291520021976]},
        "2239": {"vr": "DS", "Value": [-17.791523024944]},
        "2240": {"vr": "DS", "Value": [24.708478393957]},
        "2241": {"vr": "DS", "Value": [62.208476194959]},
        "2242": {"vr": "DS", "Value": [-12.791522723179]},
        "2243": {"vr": "DS", "Value": [-45.291521675696]},
        "2244": {"vr": "DS", "Value": [24.708478393957]},
        "2245": {"vr": "DS", "Value": [-7.7915222166271]},
        "2246": {"vr": "DS", "Value": [44.708478557311]},
        "2247": {"vr": "DS", "Value": [-72.791520224055]},
        "2248": {"vr": "DS", "Value": [34.708477544207]},
        "2249": {"vr": "DS", "Value": [-55.291522484013]},
        "2250": {"vr": "DS", "Value": [67.208476291936]},
        "2251": {"vr": "DS", "Value": [24.708478393957]},
        "2252": {"vr": "DS", "Value": [-67.791519819897]},
        "2253": {"vr": "DS", "Value": [-25.291521921917]},
        "2254": {"vr": "DS", "Value": [32.208477290931]},
        "2255": {"vr": "DS", "Value": [59.708475941683]},
        "2256": {"vr": "DS", "Value": [-60.291522888171]},
        "2257": {"vr": "DS", "Value": [52.208478907564]},
        "2258": {"vr": "DS", "Value": [-15.291522976455]},
        "2259": {"vr": "DS", "Value": [19.70847829698]},
        "2260": {"vr": "DS", "Value": [-65.291519566621]},
        "2261": {"vr": "DS", "Value": [-15.291522976455]},
        "2262": {"vr": "DS", "Value": [54.70847916084]},
        "2263": {"vr": "DS", "Value": [-57.791522737289]},
        "2264": {"vr": "DS", "Value": [39.708478050759]},
        "2265": {"vr": "DS", "Value": [12.208477537152]},
        "2266": {"vr": "DS", "Value": [-32.791520614104]},
        "2267": {"vr": "DS", "Value": [69.708476545212]},
        "2268": {"vr": "DS", "Value": [67.208476291936]},
        "2269": {"vr": "DS", "Value": [-60.291522888171]},
        "2270": {"vr": "DS", "Value": [44.708478557311]},
        "2271": {"vr": "DS", "Value": [-5.291521963351]},
        "2272": {"vr": "DS", "Value": [49.708478654288]},
        "2273": {"vr": "DS", "Value": [54.70847916084]},
        "2274": {"vr": "DS", "Value": [-2.7915221757886]},
        "2275": {"vr": "DS", "Value": [27.208476784379]},
        "2276": {"vr": "DS", "Value": [-57.791522737289]},
        "2277": {"vr": "DS", "Value": [54.70847916084]},
        "2278": {"vr": "DS", "Value": [-52.791522230737]},
        "2279": {"vr": "DS", "Value": [-35.29152086738]},
        "2280": {"vr": "DS", "Value": [49.708478654288]},
        "2281": {"vr": "DS", "Value": [69.708476545212]},
        "2282": {"vr": "DS", "Value": [-32.791520614104]},
        "2283": {"vr": "DS", "Value": [32.208477290931]},
        "2284": {"vr": "DS", "Value": [-62.791519415738]},
        "2285": {"vr": "DS", "Value": [-40.291521169144]},
        "2286": {"vr": "DS", "Value": [-10.291522469903]},
        "2287": {"vr": "DS", "Value": [74.708477051764]},
        "2288": {"vr": "DS", "Value": [54.70847916084]},
        "2289": {"vr": "DS", "Value": [-32.791520614104]},
        "2290": {"vr": "DS", "Value": [19.70847829698]},
        "2291": {"vr": "DS", "Value": [-22.791521668641]},
        "2292": {"vr": "DS", "Value": [-0.2915219225125]},
        "2293": {"vr": "DS", "Value": [-2.7915221757886]},
        "2294": {"vr": "DS", "Value": [-0.2915219225125]},
        "2295": {"vr": "DS", "Value": [59.708475941683]},
        "2296": {"vr": "DS", "Value": [-50.291522079855]},
        "2297": {"vr": "DS", "Value": [-17.791523024944]},
        "2298": {"vr": "DS", "Value": [69.708476545212]},
        "2299": {"vr": "DS", "Value": [-72.791520224055]},
        "2300": {"vr": "DS", "Value": [-12.791522723179]},
        "2301": {"vr": "DS", "Value": [-27.791521970406]},
        "2302": {"vr": "DS", "Value": [27.208476784379]},
        "2303": {"vr": "DS", "Value": [29.708477037655]},
        "2304": {"vr": "DS", "Value": [-10.291522469903]},
        "2305": {"vr": "DS", "Value": [59.708475941683]},
        "2306": {"vr": "DS", "Value": [-65.291519566621]},
        "2307": {"vr": "DS", "Value": [42.208478304035]},
        "2308": {"vr": "DS", "Value": [54.70847916084]},
        "2309": {"vr": "DS", "Value": [54.70847916084]},
        "2310": {"vr": "DS", "Value": [49.708478654288]},
        "2311": {"vr": "DS", "Value": [44.708478557311]},
        "2312": {"vr": "DS", "Value": [57.208479414116]},
        "2313": {"vr": "DS", "Value": [-45.291521675696]},
        "2314": {"vr": "DS", "Value": [-72.791520224055]},
        "2315": {"vr": "DS", "Value": [-67.791519819897]},
        "2316": {"vr": "DS", "Value": [7.2084777291701]},
        "2317": {"vr": "DS", "Value": [-0.2915219225125]},
        "2318": {"vr": "DS", "Value": [-72.791520224055]},
        "2319": {"vr": "DS", "Value": [22.208478550256]},
        "2320": {"vr": "DS", "Value": [52.208478907564]},
        "2321": {"vr": "DS", "Value": [-45.291521675696]},
        "2322": {"vr": "DS", "Value": [-27.791521970406]},
        "2323": {"vr": "DS", "Value": [24.708478393957]},
        "2324": {"vr": "DS", "Value": [49.708478654288]},
        "2325": {"vr": "DS", "Value": [-35.29152086738]},
        "2326": {"vr": "DS", "Value": [42.208478304035]},
        "2327": {"vr": "DS", "Value": [-67.791519819897]},
        "2328": {"vr": "DS", "Value": [29.708477037655]},
        "2329": {"vr": "DS", "Value": [-72.791520224055]},
        "2330": {"vr": "DS", "Value": [-35.29152086738]},
        "2331": {"vr": "DS", "Value": [9.7084777495894]},
        "2332": {"vr": "DS", "Value": [54.70847916084]},
        "2333": {"vr": "DS", "Value": [27.208476784379]},
        "2334": {"vr": "DS", "Value": [4.7084775923224]},
        "2335": {"vr": "DS", "Value": [62.208476194959]},
        "2336": {"vr": "DS", "Value": [-45.291521675696]},
        "2337": {"vr": "DS", "Value": [37.208477797483]},
        "2338": {"vr": "DS", "Value": [49.708478654288]},
        "2339": {"vr": "DS", "Value": [-35.29152086738]},
        "2340": {"vr": "DS", "Value": [-17.791523024944]},
        "2341": {"vr": "DS", "Value": [-52.791522230737]},
        "2342": {"vr": "DS", "Value": [-7.7915222166271]},
        "2343": {"vr": "DS", "Value": [-15.291522976455]},
        "2344": {"vr": "DS", "Value": [-12.791522723179]},
        "2345": {"vr": "DS", "Value": [-12.791522723179]},
        "2346": {"vr": "DS", "Value": [-37.791521120656]},
        "2347": {"vr": "DS", "Value": [17.208478043704]},
        "2348": {"vr": "DS", "Value": [-60.291522888171]},
        "2349": {"vr": "DS", "Value": [-57.791522737289]},
        "2350": {"vr": "DS", "Value": [14.708477790428]},
        "2351": {"vr": "DS", "Value": [-27.791521970406]},
        "2352": {"vr": "DS", "Value": [7.2084777291701]},
        "2353": {"vr": "DS", "Value": [-27.791521970406]},
        "2354": {"vr": "DS", "Value": [24.708478393957]},
        "2355": {"vr": "DS", "Value": [37.208477797483]},
        "2356": {"vr": "DS", "Value": [-47.791521826579]},
        "2357": {"vr": "DS", "Value": [37.208477797483]},
        "2358": {"vr": "DS", "Value": [-37.791521120656]},
        "2359": {"vr": "DS", "Value": [74.708477051764]},
        "2360": {"vr": "DS", "Value": [54.70847916084]},
        "2361": {"vr": "DS", "Value": [-20.291521415365]},
        "2362": {"vr": "DS", "Value": [27.208476784379]},
        "2363": {"vr": "DS", "Value": [24.708478393957]},
        "2364": {"vr": "DS", "Value": [59.708475941683]},
        "2365": {"vr": "DS", "Value": [7.2084777291701]},
        "2366": {"vr": "DS", "Value": [2.2084775719032]},
        "2367": {"vr": "DS", "Value": [34.708477544207]},
        "2368": {"vr": "DS", "Value": [27.208476784379]},
        "2369": {"vr": "DS", "Value": [34.708477544207]},
        "2370": {"vr": "DS", "Value": [22.208478550256]},
        "2371": {"vr": "DS", "Value": [7.2084777291701]},
        "2372": {"vr": "DS", "Value": [62.208476194959]},
        "2373": {"vr": "DS", "Value": [-0.2915219225125]},
        "2374": {"vr": "DS", "Value": [59.708475941683]},
        "2375": {"vr": "DS", "Value": [-70.291520021976]},
        "2376": {"vr": "DS", "Value": [-22.791521668641]},
        "2377": {"vr": "DS", "Value": [2.2084775719032]},
        "2378": {"vr": "DS", "Value": [74.708477051764]},
        "2379": {"vr": "DS", "Value": [7.2084777291701]},
        "2380": {"vr": "DS", "Value": [-70.291520021976]},
        "2381": {"vr": "DS", "Value": [17.208478043704]},
        "2382": {"vr": "DS", "Value": [-37.791521120656]},
        "2383": {"vr": "DS", "Value": [-55.291522484013]},
        "2384": {"vr": "DS", "Value": [-45.291521675696]},
        "2385": {"vr": "DS", "Value": [-52.791522230737]},
        "2386": {"vr": "DS", "Value": [67.208476291936]},
        "2387": {"vr": "DS", "Value": [-12.791522723179]},
        "2388": {"vr": "DS", "Value": [67.208476291936]},
        "2389": {"vr": "DS", "Value": [49.708478654288]},
        "2390": {"vr": "DS", "Value": [-42.79152142242]},
        "2391": {"vr": "DS", "Value": [72.208476798488]},
        "2392": {"vr": "DS", "Value": [42.208478304035]},
        "2393": {"vr": "DS", "Value": [-10.291522469903]},
        "2394": {"vr": "DS", "Value": [-30.291520360827]},
        "2395": {"vr": "DS", "Value": [69.708476545212]},
        "2396": {"vr": "DS", "Value": [-55.291522484013]},
        "2397": {"vr": "DS", "Value": [42.208478304035]},
        "2398": {"vr": "DS", "Value": [32.208477290931]},
        "2399": {"vr": "DS", "Value": [-22.791521668641]},
        "2400": {"vr": "DS", "Value": [-45.291521675696]},
        "2401": {"vr": "DS", "Value": [69.708476545212]},
        "2402": {"vr": "DS", "Value": [7.2084777291701]},
        "2403": {"vr": "DS", "Value": [2.2084775719032]},
        "2404": {"vr": "DS", "Value": [4.7084775923224]},
        "2405": {"vr": "DS", "Value": [22.208478550256]},
        "2406": {"vr": "DS", "Value": [39.708478050759]},
        "2407": {"vr": "DS", "Value": [-25.291521921917]},
        "2408": {"vr": "DS", "Value": [34.708477544207]},
        "2409": {"vr": "DS", "Value": [-60.291522888171]},
        "2410": {"vr": "DS", "Value": [-17.791523024944]},
        "2411": {"vr": "DS", "Value": [7.2084777291701]},
        "2412": {"vr": "DS", "Value": [-67.791519819897]},
        "2413": {"vr": "DS", "Value": [-22.791521668641]},
        "2414": {"vr": "DS", "Value": [-62.791519415738]},
        "2415": {"vr": "DS", "Value": [72.208476798488]},
        "2416": {"vr": "DS", "Value": [27.208476784379]},
        "2417": {"vr": "DS", "Value": [7.2084777291701]},
        "2418": {"vr": "DS", "Value": [-60.291522888171]},
        "2419": {"vr": "DS", "Value": [67.208476291936]},
        "2420": {"vr": "DS", "Value": [-60.291522888171]},
        "2421": {"vr": "DS", "Value": [-27.791521970406]},
        "2422": {"vr": "DS", "Value": [-22.791521668641]},
        "2423": {"vr": "DS", "Value": [57.208479414116]},
        "2424": {"vr": "DS", "Value": [-60.291522888171]},
        "2425": {"vr": "DS", "Value": [-40.291521169144]},
        "2426": {"vr": "DS", "Value": [19.70847829698]},
        "2427": {"vr": "DS", "Value": [-47.791521826579]},
        "2428": {"vr": "DS", "Value": [-52.791522230737]},
        "2429": {"vr": "DS", "Value": [24.708478393957]},
        "2430": {"vr": "DS", "Value": [32.208477290931]},
        "2431": {"vr": "DS", "Value": [-57.791522737289]},
        "2432": {"vr": "DS", "Value": [47.208478401012]},
        "2433": {"vr": "DS", "Value": [14.708477790428]},
        "2434": {"vr": "DS", "Value": [49.708478654288]},
        "2435": {"vr": "DS", "Value": [57.208479414116]},
        "2436": {"vr": "DS", "Value": [-22.791521668641]},
        "2437": {"vr": "DS", "Value": [-7.7915222166271]},
        "2438": {"vr": "DS", "Value": [-32.791520614104]},
        "2439": {"vr": "DS", "Value": [-7.7915222166271]},
        "2440": {"vr": "DS", "Value": [7.2084777291701]},
        "2441": {"vr": "DS", "Value": [7.2084777291701]},
        "2442": {"vr": "DS", "Value": [72.208476798488]},
        "2443": {"vr": "DS", "Value": [-12.791522723179]},
        "2444": {"vr": "DS", "Value": [-37.791521120656]},
        "2445": {"vr": "DS", "Value": [27.208476784379]},
        "2446": {"vr": "DS", "Value": [-35.29152086738]},
        "2447": {"vr": "DS", "Value": [-57.791522737289]},
        "2448": {"vr": "DS", "Value": [-37.791521120656]},
        "2449": {"vr": "DS", "Value": [52.208478907564]},
        "2450": {"vr": "DS", "Value": [-10.291522469903]},
        "2451": {"vr": "DS", "Value": [-10.291522469903]},
        "2452": {"vr": "DS", "Value": [-10.291522469903]},
        "2453": {"vr": "DS", "Value": [-17.791523024944]},
        "2454": {"vr": "DS", "Value": [-5.291521963351]},
        "2455": {"vr": "DS", "Value": [64.70847603866]},
        "2456": {"vr": "DS", "Value": [44.708478557311]},
        "2457": {"vr": "DS", "Value": [7.2084777291701]},
        "2458": {"vr": "DS", "Value": [-32.791520614104]},
        "2459": {"vr": "DS", "Value": [-47.791521826579]},
        "2460": {"vr": "DS", "Value": [4.7084775923224]},
        "2461": {"vr": "DS", "Value": [-40.291521169144]},
        "2462": {"vr": "DS", "Value": [34.708477544207]},
        "2463": {"vr": "DS", "Value": [-15.291522976455]},
        "2464": {"vr": "DS", "Value": [-22.791521668641]},
        "2465": {"vr": "DS", "Value": [-40.291521169144]},
        "2466": {"vr": "DS", "Value": [62.208476194959]},
        "2467": {"vr": "DS", "Value": [-20.291521415365]},
        "2468": {"vr": "DS", "Value": [-30.291520360827]},
        "2469": {"vr": "DS", "Value": [29.708477037655]},
        "2470": {"vr": "DS", "Value": [-52.791522230737]},
        "2471": {"vr": "DS", "Value": [19.70847829698]},
        "2472": {"vr": "DS", "Value": [-0.2915219225125]},
        "2473": {"vr": "DS", "Value": [-67.791519819897]},
        "2474": {"vr": "DS", "Value": [62.208476194959]},
        "2475": {"vr": "DS", "Value": [74.708477051764]},
        "2476": {"vr": "DS", "Value": [17.208478043704]},
        "2477": {"vr": "DS", "Value": [12.208477537152]},
        "2478": {"vr": "DS", "Value": [-2.7915221757886]},
        "2479": {"vr": "DS", "Value": [-20.291521415365]},
        "2480": {"vr": "DS", "Value": [64.70847603866]},
        "2481": {"vr": "DS", "Value": [27.208476784379]},
        "2482": {"vr": "DS", "Value": [-62.791519415738]},
        "2483": {"vr": "DS", "Value": [22.208478550256]},
        "2484": {"vr": "DS", "Value": [59.708475941683]},
        "2485": {"vr": "DS", "Value": [-37.791521120656]},
        "2486": {"vr": "DS", "Value": [39.708478050759]},
        "2487": {"vr": "DS", "Value": [67.208476291936]},
        "2488": {"vr": "DS", "Value": [57.208479414116]},
        "2489": {"vr": "DS", "Value": [-22.791521668641]},
        "2490": {"vr": "DS", "Value": [2.2084775719032]},
        "2491": {"vr": "DS", "Value": [42.208478304035]},
        "2492": {"vr": "DS", "Value": [2.2084775719032]},
        "2493": {"vr": "DS", "Value": [14.708477790428]},
        "2494": {"vr": "DS", "Value": [52.208478907564]},
        "2495": {"vr": "DS", "Value": [29.708477037655]},
        "2496": {"vr": "DS", "Value": [-20.291521415365]},
        "2497": {"vr": "DS", "Value": [2.2084775719032]},
        "2498": {"vr": "DS", "Value": [-12.791522723179]},
        "2499": {"vr": "DS", "Value": [-7.7915222166271]},
        "2500": {"vr": "DS", "Value": [27.208476784379]},
        "2501": {"vr": "DS", "Value": [74.708477051764]},
        "2502": {"vr": "DS", "Value": [-32.791520614104]},
        "2503": {"vr": "DS", "Value": [27.208476784379]},
        "2504": {"vr": "DS", "Value": [-15.291522976455]},
        "2505": {"vr": "DS", "Value": [59.708475941683]},
        "2506": {"vr": "DS", "Value": [-72.791520224055]},
        "2507": {"vr": "DS", "Value": [4.7084775923224]},
        "2508": {"vr": "DS", "Value": [37.208477797483]},
        "2509": {"vr": "DS", "Value": [47.208478401012]},
        "2510": {"vr": "DS", "Value": [72.208476798488]},
        "2511": {"vr": "DS", "Value": [-5.291521963351]},
        "2512": {"vr": "DS", "Value": [24.708478393957]},
        "2513": {"vr": "DS", "Value": [-10.291522469903]},
        "2514": {"vr": "DS", "Value": [-60.291522888171]},
        "2515": {"vr": "DS", "Value": [52.208478907564]},
        "2516": {"vr": "DS", "Value": [-10.291522469903]},
        "2517": {"vr": "DS", "Value": [-70.291520021976]},
        "2518": {"vr": "DS", "Value": [-10.291522469903]},
        "2519": {"vr": "DS", "Value": [-40.291521169144]},
        "2520": {"vr": "DS", "Value": [-72.791520224055]},
        "2521": {"vr": "DS", "Value": [32.208477290931]},
        "2522": {"vr": "DS", "Value": [-15.291522976455]},
        "2523": {"vr": "DS", "Value": [-30.291520360827]},
        "2524": {"vr": "DS", "Value": [-7.7915222166271]},
        "2525": {"vr": "DS", "Value": [-32.791520614104]},
        "2526": {"vr": "DS", "Value": [-20.291521415365]},
        "2527": {"vr": "DS", "Value": [-65.291519566621]},
        "2528": {"vr": "DS", "Value": [52.208478907564]},
        "2529": {"vr": "DS", "Value": [12.208477537152]},
        "2530": {"vr": "DS", "Value": [62.208476194959]},
        "2531": {"vr": "DS", "Value": [59.708475941683]},
        "2532": {"vr": "DS", "Value": [9.7084777495894]},
        "2533": {"vr": "DS", "Value": [74.708477051764]},
        "2534": {"vr": "DS", "Value": [62.208476194959]},
        "2535": {"vr": "DS", "Value": [34.708477544207]},
        "2536": {"vr": "DS", "Value": [57.208479414116]},
        "2537": {"vr": "DS", "Value": [42.208478304035]},
        "2538": {"vr": "DS", "Value": [-65.291519566621]},
        "2539": {"vr": "DS", "Value": [-50.291522079855]},
        "2540": {"vr": "DS", "Value": [-45.291521675696]},
        "2541": {"vr": "DS", "Value": [74.708477051764]},
        "2542": {"vr": "DS", "Value": [-42.79152142242]},
        "2543": {"vr": "DS", "Value": [-57.791522737289]},
        "2544": {"vr": "DS", "Value": [47.208478401012]},
        "2545": {"vr": "DS", "Value": [-37.791521120656]},
        "2546": {"vr": "DS", "Value": [-10.291522469903]},
        "2547": {"vr": "DS", "Value": [2.2084775719032]},
        "2548": {"vr": "DS", "Value": [-5.291521963351]},
        "2549": {"vr": "DS", "Value": [64.70847603866]},
        "2550": {"vr": "DS", "Value": [-25.291521921917]},
        "2551": {"vr": "DS", "Value": [29.708477037655]},
        "2552": {"vr": "DS", "Value": [19.70847829698]},
        "2553": {"vr": "DS", "Value": [42.208478304035]},
        "2554": {"vr": "DS", "Value": [17.208478043704]},
        "2555": {"vr": "DS", "Value": [-27.791521970406]},
        "2556": {"vr": "DS", "Value": [64.70847603866]},
        "2557": {"vr": "DS", "Value": [-27.791521970406]},
        "2558": {"vr": "DS", "Value": [67.208476291936]},
        "2559": {"vr": "DS", "Value": [-72.791520224055]},
        "2560": {"vr": "DS", "Value": [14.708477790428]},
        "2561": {"vr": "DS", "Value": [39.708478050759]},
        "2562": {"vr": "DS", "Value": [-40.291521169144]},
        "2563": {"vr": "DS", "Value": [-42.79152142242]},
        "2564": {"vr": "DS", "Value": [24.708478393957]},
        "2565": {"vr": "DS", "Value": [2.2084775719032]},
        "2566": {"vr": "DS", "Value": [17.208478043704]},
        "2567": {"vr": "DS", "Value": [42.208478304035]},
        "2568": {"vr": "DS", "Value": [-50.291522079855]},
        "2569": {"vr": "DS", "Value": [-20.291521415365]},
        "2570": {"vr": "DS", "Value": [-2.7915221757886]},
        "2571": {"vr": "DS", "Value": [-47.791521826579]},
        "2572": {"vr": "DS", "Value": [57.208479414116]},
        "2573": {"vr": "DS", "Value": [19.70847829698]},
        "2574": {"vr": "DS", "Value": [-25.291521921917]},
        "2575": {"vr": "DS", "Value": [-52.791522230737]},
        "2576": {"vr": "DS", "Value": [64.70847603866]},
        "2577": {"vr": "DS", "Value": [34.708477544207]},
        "2578": {"vr": "DS", "Value": [-20.291521415365]},
        "2579": {"vr": "DS", "Value": [-50.291522079855]},
        "2580": {"vr": "DS", "Value": [27.208476784379]},
        "2581": {"vr": "DS", "Value": [-47.791521826579]},
        "2582": {"vr": "DS", "Value": [67.208476291936]},
        "2583": {"vr": "DS", "Value": [-7.7915222166271]},
        "2584": {"vr": "DS", "Value": [7.2084777291701]},
        "2585": {"vr": "DS", "Value": [52.208478907564]},
        "2586": {"vr": "DS", "Value": [72.208476798488]},
        "2587": {"vr": "DS", "Value": [-52.791522230737]},
        "2588": {"vr": "DS", "Value": [-7.7915222166271]},
        "2589": {"vr": "DS", "Value": [2.2084775719032]},
        "2590": {"vr": "DS", "Value": [32.208477290931]},
        "2591": {"vr": "DS", "Value": [-30.291520360827]},
        "2592": {"vr": "DS", "Value": [12.208477537152]},
        "2593": {"vr": "DS", "Value": [72.208476798488]},
        "2594": {"vr": "DS", "Value": [-50.291522079855]},
        "2595": {"vr": "DS", "Value": [-40.291521169144]},
        "2596": {"vr": "DS", "Value": [67.208476291936]},
        "2597": {"vr": "DS", "Value": [59.708475941683]},
        "2598": {"vr": "DS", "Value": [-45.291521675696]},
        "2599": {"vr": "DS", "Value": [-52.791522230737]},
        "2600": {"vr": "DS", "Value": [19.70847829698]},
        "2601": {"vr": "DS", "Value": [29.708477037655]},
        "2602": {"vr": "DS", "Value": [32.208477290931]},
        "2603": {"vr": "DS", "Value": [39.708478050759]},
        "2604": {"vr": "DS", "Value": [2.2084775719032]},
        "2605": {"vr": "DS", "Value": [32.208477290931]},
        "2606": {"vr": "DS", "Value": [-5.291521963351]},
        "2607": {"vr": "DS", "Value": [57.208479414116]},
        "2608": {"vr": "DS", "Value": [-60.291522888171]},
        "2609": {"vr": "DS", "Value": [-40.291521169144]},
        "2610": {"vr": "DS", "Value": [17.208478043704]},
        "2611": {"vr": "DS", "Value": [19.70847829698]},
        "2612": {"vr": "DS", "Value": [19.70847829698]},
        "2613": {"vr": "DS", "Value": [24.708478393957]},
        "2614": {"vr": "DS", "Value": [24.708478393957]},
        "2615": {"vr": "DS", "Value": [-52.791522230737]},
        "2616": {"vr": "DS", "Value": [-30.291520360827]},
        "2617": {"vr": "DS", "Value": [12.208477537152]},
        "2618": {"vr": "DS", "Value": [-57.791522737289]},
        "2619": {"vr": "DS", "Value": [17.208478043704]},
        "2620": {"vr": "DS", "Value": [-62.791519415738]},
        "2621": {"vr": "DS", "Value": [-35.29152086738]},
        "2622": {"vr": "DS", "Value": [-5.291521963351]},
        "2623": {"vr": "DS", "Value": [-25.291521921917]},
        "2624": {"vr": "DS", "Value": [-45.291521675696]},
        "2625": {"vr": "DS", "Value": [19.70847829698]},
        "2626": {"vr": "DS", "Value": [24.708478393957]},
        "2627": {"vr": "DS", "Value": [47.208478401012]},
        "2628": {"vr": "DS", "Value": [-20.291521415365]},
        "2629": {"vr": "DS", "Value": [37.208477797483]},
        "2630": {"vr": "DS", "Value": [-55.291522484013]},
        "2631": {"vr": "DS", "Value": [37.208477797483]},
        "2632": {"vr": "DS", "Value": [49.708478654288]},
        "2633": {"vr": "DS", "Value": [-2.7915221757886]},
        "2634": {"vr": "DS", "Value": [52.208478907564]},
        "2635": {"vr": "DS", "Value": [14.708477790428]},
        "2636": {"vr": "DS", "Value": [-62.791519415738]},
        "2637": {"vr": "DS", "Value": [2.2084775719032]},
        "2638": {"vr": "DS", "Value": [4.7084775923224]},
        "2639": {"vr": "DS", "Value": [9.7084777495894]},
        "2640": {"vr": "DS", "Value": [2.2084775719032]},
        "2641": {"vr": "DS", "Value": [-70.291520021976]},
        "2642": {"vr": "DS", "Value": [-42.79152142242]},
        "2643": {"vr": "DS", "Value": [-62.791519415738]},
        "2644": {"vr": "DS", "Value": [-50.291522079855]},
        "2645": {"vr": "DS", "Value": [-22.791521668641]},
        "2646": {"vr": "DS", "Value": [12.208477537152]},
        "2647": {"vr": "DS", "Value": [-50.291522079855]},
        "2648": {"vr": "DS", "Value": [64.70847603866]},
        "2649": {"vr": "DS", "Value": [-67.791519819897]},
        "2650": {"vr": "DS", "Value": [-57.791522737289]},
        "2651": {"vr": "DS", "Value": [67.208476291936]},
        "2652": {"vr": "DS", "Value": [-50.291522079855]},
        "2653": {"vr": "DS", "Value": [32.208477290931]},
        "2654": {"vr": "DS", "Value": [4.7084775923224]},
        "2655": {"vr": "DS", "Value": [37.208477797483]},
        "2656": {"vr": "DS", "Value": [37.208477797483]},
        "2657": {"vr": "DS", "Value": [-52.791522230737]},
        "2658": {"vr": "DS", "Value": [37.208477797483]},
        "2659": {"vr": "DS", "Value": [-52.791522230737]},
        "2660": {"vr": "DS", "Value": [24.708478393957]},
        "2661": {"vr": "DS", "Value": [69.708476545212]},
        "2662": {"vr": "DS", "Value": [29.708477037655]},
        "2663": {"vr": "DS", "Value": [-32.791520614104]},
        "2664": {"vr": "DS", "Value": [-10.291522469903]},
        "2665": {"vr": "DS", "Value": [67.208476291936]},
        "2666": {"vr": "DS", "Value": [-15.291522976455]},
        "2667": {"vr": "DS", "Value": [4.7084775923224]},
        "2668": {"vr": "DS", "Value": [69.708476545212]},
        "2669": {"vr": "DS", "Value": [-52.791522230737]},
        "2670": {"vr": "DS", "Value": [39.708478050759]},
        "2671": {"vr": "DS", "Value": [-55.291522484013]},
        "2672": {"vr": "DS", "Value": [67.208476291936]},
        "2673": {"vr": "DS", "Value": [-57.791522737289]},
        "2674": {"vr": "DS", "Value": [52.208478907564]},
        "2675": {"vr": "DS", "Value": [32.208477290931]},
        "2676": {"vr": "DS", "Value": [-25.291521921917]},
        "2677": {"vr": "DS", "Value": [17.208478043704]},
        "2678": {"vr": "DS", "Value": [-45.291521675696]},
        "2679": {"vr": "DS", "Value": [2.2084775719032]},
        "2680": {"vr": "DS", "Value": [72.208476798488]},
        "2681": {"vr": "DS", "Value": [-12.791522723179]},
        "2682": {"vr": "DS", "Value": [17.208478043704]},
        "2683": {"vr": "DS", "Value": [24.708478393957]},
        "2684": {"vr": "DS", "Value": [-17.791523024944]},
        "2685": {"vr": "DS", "Value": [22.208478550256]},
        "2686": {"vr": "DS", "Value": [34.708477544207]},
        "2687": {"vr": "DS", "Value": [37.208477797483]},
        "2688": {"vr": "DS", "Value": [-5.291521963351]},
        "2689": {"vr": "DS", "Value": [-2.7915221757886]},
        "2690": {"vr": "DS", "Value": [29.708477037655]},
        "2691": {"vr": "DS", "Value": [-47.791521826579]},
        "2692": {"vr": "DS", "Value": [-12.791522723179]},
        "2693": {"vr": "DS", "Value": [19.70847829698]},
        "2694": {"vr": "DS", "Value": [47.208478401012]},
        "2695": {"vr": "DS", "Value": [-67.791519819897]},
        "2696": {"vr": "DS", "Value": [29.708477037655]},
        "2697": {"vr": "DS", "Value": [74.708477051764]},
        "2698": {"vr": "DS", "Value": [49.708478654288]},
        "2699": {"vr": "DS", "Value": [-15.291522976455]},
        "2700": {"vr": "DS", "Value": [-60.291522888171]},
        "2701": {"vr": "DS", "Value": [14.708477790428]},
        "2702": {"vr": "DS", "Value": [67.208476291936]},
        "2703": {"vr": "DS", "Value": [9.7084777495894]},
        "2704": {"vr": "DS", "Value": [-42.79152142242]},
        "2705": {"vr": "DS", "Value": [-15.291522976455]},
        "2706": {"vr": "DS", "Value": [47.208478401012]},
        "2707": {"vr": "DS", "Value": [-62.791519415738]},
        "2708": {"vr": "DS", "Value": [-50.291522079855]},
        "2709": {"vr": "DS", "Value": [42.208478304035]},
        "2710": {"vr": "DS", "Value": [-60.291522888171]},
        "2711": {"vr": "DS", "Value": [-47.791521826579]},
        "2712": {"vr": "DS", "Value": [-20.291521415365]},
        "2713": {"vr": "DS", "Value": [44.708478557311]},
        "2714": {"vr": "DS", "Value": [72.208476798488]},
        "2715": {"vr": "DS", "Value": [47.208478401012]},
        "2716": {"vr": "DS", "Value": [-47.791521826579]},
        "2717": {"vr": "DS", "Value": [-0.2915219225125]},
        "2718": {"vr": "DS", "Value": [-47.791521826579]},
        "2719": {"vr": "DS", "Value": [14.708477790428]},
        "2720": {"vr": "DS", "Value": [-70.291520021976]},
        "2721": {"vr": "DS", "Value": [19.70847829698]},
        "2722": {"vr": "DS", "Value": [22.208478550256]},
        "2723": {"vr": "DS", "Value": [-35.29152086738]},
        "2724": {"vr": "DS", "Value": [-42.79152142242]},
        "2725": {"vr": "DS", "Value": [-35.29152086738]},
        "2726": {"vr": "DS", "Value": [24.708478393957]},
        "2727": {"vr": "DS", "Value": [22.208478550256]},
        "2728": {"vr": "DS", "Value": [-17.791523024944]},
        "2729": {"vr": "DS", "Value": [67.208476291936]},
        "2730": {"vr": "DS", "Value": [-37.791521120656]},
        "2731": {"vr": "DS", "Value": [69.708476545212]},
        "2732": {"vr": "DS", "Value": [-5.291521963351]},
        "2733": {"vr": "DS", "Value": [-37.791521120656]},
        "2734": {"vr": "DS", "Value": [62.208476194959]},
        "2735": {"vr": "DS", "Value": [49.708478654288]},
        "2736": {"vr": "DS", "Value": [-27.791521970406]},
        "2737": {"vr": "DS", "Value": [-55.291522484013]},
        "2738": {"vr": "DS", "Value": [-52.791522230737]},
        "2739": {"vr": "DS", "Value": [54.70847916084]},
        "2740": {"vr": "DS", "Value": [12.208477537152]},
        "2741": {"vr": "DS", "Value": [19.70847829698]},
        "2742": {"vr": "DS", "Value": [19.70847829698]},
        "2743": {"vr": "DS", "Value": [-12.791522723179]},
        "2744": {"vr": "DS", "Value": [-10.291522469903]},
        "2745": {"vr": "DS", "Value": [49.708478654288]},
        "2746": {"vr": "DS", "Value": [34.708477544207]},
        "2747": {"vr": "DS", "Value": [4.7084775923224]},
        "2748": {"vr": "DS", "Value": [57.208479414116]},
        "2749": {"vr": "DS", "Value": [57.208479414116]},
        "2750": {"vr": "DS", "Value": [-25.291521921917]},
        "2751": {"vr": "DS", "Value": [-20.291521415365]},
        "2752": {"vr": "DS", "Value": [-72.791520224055]},
        "2753": {"vr": "DS", "Value": [-2.7915221757886]},
        "2754": {"vr": "DS", "Value": [69.708476545212]},
        "2755": {"vr": "DS", "Value": [27.208476784379]},
        "2756": {"vr": "DS", "Value": [69.708476545212]},
        "2757": {"vr": "DS", "Value": [34.708477544207]},
        "2758": {"vr": "DS", "Value": [-60.291522888171]},
        "2759": {"vr": "DS", "Value": [4.7084775923224]},
        "2760": {"vr": "DS", "Value": [29.708477037655]},
        "2761": {"vr": "DS", "Value": [47.208478401012]},
        "2762": {"vr": "DS", "Value": [-35.29152086738]},
        "2763": {"vr": "DS", "Value": [62.208476194959]},
        "2764": {"vr": "DS", "Value": [39.708478050759]},
        "2765": {"vr": "DS", "Value": [-65.291519566621]},
        "2766": {"vr": "DS", "Value": [-42.79152142242]},
        "2767": {"vr": "DS", "Value": [-5.291521963351]},
        "2768": {"vr": "DS", "Value": [-0.2915219225125]},
        "2769": {"vr": "DS", "Value": [-52.791522230737]},
        "2770": {"vr": "DS", "Value": [-15.291522976455]},
        "2771": {"vr": "DS", "Value": [69.708476545212]},
        "2772": {"vr": "DS", "Value": [-45.291521675696]},
        "2773": {"vr": "DS", "Value": [-47.791521826579]},
        "2774": {"vr": "DS", "Value": [-65.291519566621]},
        "2775": {"vr": "DS", "Value": [-25.291521921917]},
        "2776": {"vr": "DS", "Value": [-12.791522723179]},
        "2777": {"vr": "DS", "Value": [-32.791520614104]},
        "2778": {"vr": "DS", "Value": [-25.291521921917]},
        "2779": {"vr": "DS", "Value": [-7.7915222166271]},
        "2780": {"vr": "DS", "Value": [62.208476194959]},
        "2781": {"vr": "DS", "Value": [4.7084775923224]},
        "2782": {"vr": "DS", "Value": [42.208478304035]},
        "2783": {"vr": "DS", "Value": [64.70847603866]},
        "2784": {"vr": "DS", "Value": [72.208476798488]},
        "2785": {"vr": "DS", "Value": [-45.291521675696]},
        "2786": {"vr": "DS", "Value": [-25.291521921917]},
        "2787": {"vr": "DS", "Value": [9.7084777495894]},
        "2788": {"vr": "DS", "Value": [-67.791519819897]},
        "2789": {"vr": "DS", "Value": [-15.291522976455]},
        "2790": {"vr": "DS", "Value": [24.708478393957]},
        "2791": {"vr": "DS", "Value": [-45.291521675696]},
        "2792": {"vr": "DS", "Value": [19.70847829698]},
        "2793": {"vr": "DS", "Value": [-70.291520021976]},
        "2794": {"vr": "DS", "Value": [-15.291522976455]},
        "2795": {"vr": "DS", "Value": [-72.791520224055]},
        "2796": {"vr": "DS", "Value": [67.208476291936]},
        "2797": {"vr": "DS", "Value": [32.208477290931]},
        "2798": {"vr": "DS", "Value": [-37.791521120656]},
        "2799": {"vr": "DS", "Value": [-60.291522888171]},
        "2800": {"vr": "DS", "Value": [-20.291521415365]},
        "2801": {"vr": "DS", "Value": [74.708477051764]},
        "2802": {"vr": "DS", "Value": [-55.291522484013]},
        "2803": {"vr": "DS", "Value": [-10.291522469903]},
        "2804": {"vr": "DS", "Value": [-52.791522230737]},
        "2805": {"vr": "DS", "Value": [69.708476545212]},
        "2806": {"vr": "DS", "Value": [-65.291519566621]},
        "2807": {"vr": "DS", "Value": [39.708478050759]},
        "2808": {"vr": "DS", "Value": [44.708478557311]},
        "2809": {"vr": "DS", "Value": [-70.291520021976]},
        "2810": {"vr": "DS", "Value": [32.208477290931]},
        "2811": {"vr": "DS", "Value": [67.208476291936]},
        "2812": {"vr": "DS", "Value": [14.708477790428]},
        "2813": {"vr": "DS", "Value": [-37.791521120656]},
        "2814": {"vr": "DS", "Value": [-47.791521826579]},
        "2815": {"vr": "DS", "Value": [59.708475941683]},
        "2816": {"vr": "DS", "Value": [-5.291521963351]},
        "2817": {"vr": "DS", "Value": [-5.291521963351]},
        "2818": {"vr": "DS", "Value": [44.708478557311]},
        "2819": {"vr": "DS", "Value": [-55.291522484013]},
        "2820": {"vr": "DS", "Value": [-10.291522469903]},
        "2821": {"vr": "DS", "Value": [34.708477544207]},
        "2822": {"vr": "DS", "Value": [-65.291519566621]},
        "2823": {"vr": "DS", "Value": [52.208478907564]},
        "2824": {"vr": "DS", "Value": [72.208476798488]},
        "2825": {"vr": "DS", "Value": [47.208478401012]},
        "2826": {"vr": "DS", "Value": [-20.291521415365]},
        "2827": {"vr": "DS", "Value": [64.70847603866]},
        "2828": {"vr": "DS", "Value": [69.708476545212]},
        "2829": {"vr": "DS", "Value": [-65.291519566621]},
        "2830": {"vr": "DS", "Value": [62.208476194959]},
        "2831": {"vr": "DS", "Value": [42.208478304035]},
        "2832": {"vr": "DS", "Value": [-57.791522737289]},
        "2833": {"vr": "DS", "Value": [64.70847603866]},
        "2834": {"vr": "DS", "Value": [-7.7915222166271]},
        "2835": {"vr": "DS", "Value": [-30.291520360827]},
        "2836": {"vr": "DS", "Value": [17.208478043704]},
        "2837": {"vr": "DS", "Value": [-17.791523024944]},
        "2838": {"vr": "DS", "Value": [-17.791523024944]},
        "2839": {"vr": "DS", "Value": [-27.791521970406]},
        "2840": {"vr": "DS", "Value": [-62.791519415738]},
        "2841": {"vr": "DS", "Value": [14.708477790428]},
        "2842": {"vr": "DS", "Value": [2.2084775719032]},
        "2843": {"vr": "DS", "Value": [47.208478401012]},
        "2844": {"vr": "DS", "Value": [-2.7915221757886]},
        "2845": {"vr": "DS", "Value": [-55.291522484013]},
        "2846": {"vr": "DS", "Value": [37.208477797483]},
        "2847": {"vr": "DS", "Value": [-32.791520614104]},
        "2848": {"vr": "DS", "Value": [67.208476291936]},
        "2849": {"vr": "DS", "Value": [59.708475941683]},
        "2850": {"vr": "DS", "Value": [2.2084775719032]},
        "2851": {"vr": "DS", "Value": [-30.291520360827]},
        "2852": {"vr": "DS", "Value": [-60.291522888171]},
        "2853": {"vr": "DS", "Value": [-50.291522079855]},
        "2854": {"vr": "DS", "Value": [-55.291522484013]},
        "2855": {"vr": "DS", "Value": [-55.291522484013]},
        "2856": {"vr": "DS", "Value": [24.708478393957]},
        "2857": {"vr": "DS", "Value": [44.708478557311]},
        "2858": {"vr": "DS", "Value": [-57.791522737289]},
        "2859": {"vr": "DS", "Value": [-12.791522723179]},
        "2860": {"vr": "DS", "Value": [64.70847603866]},
        "2861": {"vr": "DS", "Value": [59.708475941683]},
        "2862": {"vr": "DS", "Value": [-27.791521970406]},
        "2863": {"vr": "DS", "Value": [19.70847829698]},
        "2864": {"vr": "DS", "Value": [9.7084777495894]},
        "2865": {"vr": "DS", "Value": [22.208478550256]},
        "2866": {"vr": "DS", "Value": [-52.791522230737]},
        "2867": {"vr": "DS", "Value": [67.208476291936]},
        "2868": {"vr": "DS", "Value": [9.7084777495894]},
        "2869": {"vr": "DS", "Value": [-10.291522469903]},
        "2870": {"vr": "DS", "Value": [62.208476194959]},
        "2871": {"vr": "DS", "Value": [34.708477544207]},
        "2872": {"vr": "DS", "Value": [54.70847916084]},
        "2873": {"vr": "DS", "Value": [4.7084775923224]},
        "2874": {"vr": "DS", "Value": [17.208478043704]},
        "2875": {"vr": "DS", "Value": [-12.791522723179]},
        "2876": {"vr": "DS", "Value": [39.708478050759]},
        "2877": {"vr": "DS", "Value": [14.708477790428]},
        "2878": {"vr": "DS", "Value": [-50.291522079855]},
        "2879": {"vr": "DS", "Value": [-47.791521826579]},
        "2880": {"vr": "DS", "Value": [-35.29152086738]},
        "2881": {"vr": "DS", "Value": [-22.791521668641]},
        "2882": {"vr": "DS", "Value": [39.708478050759]},
        "2883": {"vr": "DS", "Value": [17.208478043704]},
        "2884": {"vr": "DS", "Value": [-35.29152086738]},
        "2885": {"vr": "DS", "Value": [-10.291522469903]},
        "2886": {"vr": "DS", "Value": [-55.291522484013]},
        "2887": {"vr": "DS", "Value": [-65.291519566621]},
        "2888": {"vr": "DS", "Value": [69.708476545212]},
        "2889": {"vr": "DS", "Value": [-30.291520360827]},
        "2890": {"vr": "DS", "Value": [52.208478907564]},
        "2891": {"vr": "DS", "Value": [29.708477037655]},
        "2892": {"vr": "DS", "Value": [-45.291521675696]},
        "2893": {"vr": "DS", "Value": [-22.791521668641]},
        "2894": {"vr": "DS", "Value": [72.208476798488]},
        "2895": {"vr": "DS", "Value": [-17.791523024944]},
        "2896": {"vr": "DS", "Value": [37.208477797483]},
        "2897": {"vr": "DS", "Value": [-60.291522888171]},
        "2898": {"vr": "DS", "Value": [-17.791523024944]},
        "2899": {"vr": "DS", "Value": [37.208477797483]},
        "2900": {"vr": "DS", "Value": [34.708477544207]},
        "2901": {"vr": "DS", "Value": [-5.291521963351]},
        "2902": {"vr": "DS", "Value": [-25.291521921917]},
        "2903": {"vr": "DS", "Value": [19.70847829698]},
        "2904": {"vr": "DS", "Value": [-62.791519415738]},
        "2905": {"vr": "DS", "Value": [-55.291522484013]},
        "2906": {"vr": "DS", "Value": [-20.291521415365]},
        "2907": {"vr": "DS", "Value": [-40.291521169144]},
        "2908": {"vr": "DS", "Value": [-57.791522737289]},
        "2909": {"vr": "DS", "Value": [19.70847829698]},
        "2910": {"vr": "DS", "Value": [-60.291522888171]},
        "2911": {"vr": "DS", "Value": [-50.291522079855]},
        "2912": {"vr": "DS", "Value": [2.2084775719032]},
        "2913": {"vr": "DS", "Value": [-52.791522230737]},
        "2914": {"vr": "DS", "Value": [14.708477790428]},
        "2915": {"vr": "DS", "Value": [54.70847916084]},
        "2916": {"vr": "DS", "Value": [-15.291522976455]},
        "2917": {"vr": "DS", "Value": [72.208476798488]},
        "2918": {"vr": "DS", "Value": [-42.79152142242]},
        "2919": {"vr": "DS", "Value": [-2.7915221757886]},
        "2920": {"vr": "DS", "Value": [37.208477797483]},
        "2921": {"vr": "DS", "Value": [39.708478050759]},
        "2922": {"vr": "DS", "Value": [62.208476194959]},
        "2923": {"vr": "DS", "Value": [24.708478393957]},
        "2924": {"vr": "DS", "Value": [-50.291522079855]},
        "2925": {"vr": "DS", "Value": [74.708477051764]},
        "2926": {"vr": "DS", "Value": [-15.291522976455]},
        "2927": {"vr": "DS", "Value": [7.2084777291701]},
        "2928": {"vr": "DS", "Value": [-10.291522469903]},
        "2929": {"vr": "DS", "Value": [32.208477290931]},
        "2930": {"vr": "DS", "Value": [-67.791519819897]},
        "2931": {"vr": "DS", "Value": [-37.791521120656]},
        "2932": {"vr": "DS", "Value": [-42.79152142242]},
        "2933": {"vr": "DS", "Value": [19.70847829698]},
        "2934": {"vr": "DS", "Value": [-65.291519566621]},
        "2935": {"vr": "DS", "Value": [67.208476291936]},
        "2936": {"vr": "DS", "Value": [74.708477051764]},
        "2937": {"vr": "DS", "Value": [-55.291522484013]},
        "2938": {"vr": "DS", "Value": [19.70847829698]},
        "2939": {"vr": "DS", "Value": [-5.291521963351]},
        "2940": {"vr": "DS", "Value": [34.708477544207]},
        "2941": {"vr": "DS", "Value": [29.708477037655]},
        "2942": {"vr": "DS", "Value": [-7.7915222166271]},
        "2943": {"vr": "DS", "Value": [37.208477797483]},
        "2944": {"vr": "DS", "Value": [37.208477797483]},
        "2945": {"vr": "DS", "Value": [17.208478043704]},
        "2946": {"vr": "DS", "Value": [-40.291521169144]},
        "2947": {"vr": "DS", "Value": [34.708477544207]},
        "2948": {"vr": "DS", "Value": [54.70847916084]},
        "2949": {"vr": "DS", "Value": [-57.791522737289]},
        "2950": {"vr": "DS", "Value": [57.208479414116]},
        "2951": {"vr": "DS", "Value": [-25.291521921917]},
        "2952": {"vr": "DS", "Value": [22.208478550256]},
        "2953": {"vr": "DS", "Value": [64.70847603866]},
        "2954": {"vr": "DS", "Value": [-22.791521668641]},
        "2955": {"vr": "DS", "Value": [57.208479414116]},
        "2956": {"vr": "DS", "Value": [-2.7915221757886]},
        "2957": {"vr": "DS", "Value": [-22.791521668641]},
        "2958": {"vr": "DS", "Value": [64.70847603866]},
        "2959": {"vr": "DS", "Value": [34.708477544207]},
        "2960": {"vr": "DS", "Value": [-15.291522976455]},
        "2961": {"vr": "DS", "Value": [-65.291519566621]},
        "2962": {"vr": "DS", "Value": [47.208478401012]},
        "2963": {"vr": "DS", "Value": [-10.291522469903]},
        "2964": {"vr": "DS", "Value": [-5.291521963351]},
        "2965": {"vr": "DS", "Value": [34.708477544207]},
        "2966": {"vr": "DS", "Value": [49.708478654288]},
        "2967": {"vr": "DS", "Value": [-20.291521415365]},
        "2968": {"vr": "DS", "Value": [12.208477537152]},
        "2969": {"vr": "DS", "Value": [-10.291522469903]},
        "2970": {"vr": "DS", "Value": [12.208477537152]},
        "2971": {"vr": "DS", "Value": [39.708478050759]},
        "2972": {"vr": "DS", "Value": [-22.791521668641]},
        "2973": {"vr": "DS", "Value": [-20.291521415365]},
        "2974": {"vr": "DS", "Value": [34.708477544207]},
        "2975": {"vr": "DS", "Value": [-5.291521963351]},
        "2976": {"vr": "DS", "Value": [-27.791521970406]},
        "2977": {"vr": "DS", "Value": [34.708477544207]},
        "2978": {"vr": "DS", "Value": [34.708477544207]},
        "2979": {"vr": "DS", "Value": [69.708476545212]},
        "2980": {"vr": "DS", "Value": [-15.291522976455]},
        "2981": {"vr": "DS", "Value": [-25.291521921917]},
        "2982": {"vr": "DS", "Value": [22.208478550256]},
        "2983": {"vr": "DS", "Value": [22.208478550256]},
        "2984": {"vr": "DS", "Value": [-60.291522888171]},
        "2985": {"vr": "DS", "Value": [62.208476194959]},
        "2986": {"vr": "DS", "Value": [27.208476784379]},
        "2987": {"vr": "DS", "Value": [-72.791520224055]},
        "2988": {"vr": "DS", "Value": [4.7084775923224]},
        "2989": {"vr": "DS", "Value": [-67.791519819897]},
        "2990": {"vr": "DS", "Value": [-70.291520021976]},
        "2991": {"vr": "DS", "Value": [-22.791521668641]},
        "2992": {"vr": "DS", "Value": [9.7084777495894]},
        "2993": {"vr": "DS", "Value": [49.708478654288]},
        "2994": {"vr": "DS", "Value": [29.708477037655]},
        "2995": {"vr": "DS", "Value": [72.208476798488]},
        "2996": {"vr": "DS", "Value": [14.708477790428]},
        "2997": {"vr": "DS", "Value": [32.208477290931]},
        "2998": {"vr": "DS", "Value": [19.70847829698]},
        "2999": {"vr": "DS", "Value": [-67.791519819897]},
        "3000": {"vr": "DS", "Value": [-5.291521963351]},
        "3001": {"vr": "DS", "Value": [-2.7915221757886]},
        "3002": {"vr": "DS", "Value": [17.208478043704]},
        "3003": {"vr": "DS", "Value": [42.208478304035]},
        "3004": {"vr": "DS", "Value": [-42.79152142242]},
        "3005": {"vr": "DS", "Value": [-25.291521921917]},
        "3006": {"vr": "DS", "Value": [-72.791520224055]},
        "3007": {"vr": "DS", "Value": [24.708478393957]},
        "3008": {"vr": "DS", "Value": [-62.791519415738]},
        "3009": {"vr": "DS", "Value": [29.708477037655]},
        "3010": {"vr": "DS", "Value": [7.2084777291701]},
        "3011": {"vr": "DS", "Value": [-30.291520360827]},
        "3012": {"vr": "DS", "Value": [32.208477290931]},
        "3013": {"vr": "DS", "Value": [-7.7915222166271]},
        "3014": {"vr": "DS", "Value": [-67.791519819897]},
        "3015": {"vr": "DS", "Value": [29.708477037655]},
        "3016": {"vr": "DS", "Value": [-22.791521668641]},
        "3017": {"vr": "DS", "Value": [-17.791523024944]},
        "3018": {"vr": "DS", "Value": [9.7084777495894]},
        "3019": {"vr": "DS", "Value": [17.208478043704]},
        "3020": {"vr": "DS", "Value": [-37.791521120656]},
        "3021": {"vr": "DS", "Value": [-62.791519415738]},
        "3022": {"vr": "DS", "Value": [-27.791521970406]},
        "3023": {"vr": "DS", "Value": [-65.291519566621]},
        "3024": {"vr": "DS", "Value": [19.70847829698]},
        "3025": {"vr": "DS", "Value": [-72.791520224055]},
        "3026": {"vr": "DS", "Value": [-17.791523024944]},
        "3027": {"vr": "DS", "Value": [-35.29152086738]},
        "3028": {"vr": "DS", "Value": [-40.291521169144]},
        "3029": {"vr": "DS", "Value": [37.208477797483]},
        "3030": {"vr": "DS", "Value": [14.708477790428]},
        "3031": {"vr": "DS", "Value": [54.70847916084]},
        "3032": {"vr": "DS", "Value": [37.208477797483]},
        "3033": {"vr": "DS", "Value": [-40.291521169144]},
        "3034": {"vr": "DS", "Value": [-60.291522888171]},
        "3035": {"vr": "DS", "Value": [-67.791519819897]},
        "3036": {"vr": "DS", "Value": [39.708478050759]},
        "3037": {"vr": "DS", "Value": [-42.79152142242]},
        "3038": {"vr": "DS", "Value": [-52.791522230737]},
        "3039": {"vr": "DS", "Value": [-67.791519819897]},
        "3040": {"vr": "DS", "Value": [-42.79152142242]},
        "3041": {"vr": "DS", "Value": [-22.791521668641]},
        "3042": {"vr": "DS", "Value": [-57.791522737289]},
        "3043": {"vr": "DS", "Value": [27.208476784379]},
        "3044": {"vr": "DS", "Value": [-47.791521826579]},
        "3045": {"vr": "DS", "Value": [19.70847829698]},
        "3046": {"vr": "DS", "Value": [-40.291521169144]},
        "3047": {"vr": "DS", "Value": [9.7084777495894]},
        "3048": {"vr": "DS", "Value": [-62.791519415738]},
        "3049": {"vr": "DS", "Value": [49.708478654288]},
        "3050": {"vr": "DS", "Value": [52.208478907564]},
        "3051": {"vr": "DS", "Value": [-57.791522737289]},
        "3052": {"vr": "DS", "Value": [17.208478043704]},
        "3053": {"vr": "DS", "Value": [-70.291520021976]},
        "3054": {"vr": "DS", "Value": [-32.791520614104]},
        "3055": {"vr": "DS", "Value": [12.208477537152]},
        "3056": {"vr": "DS", "Value": [-2.7915221757886]},
        "3057": {"vr": "DS", "Value": [-70.291520021976]},
        "3058": {"vr": "DS", "Value": [57.208479414116]},
        "3059": {"vr": "DS", "Value": [67.208476291936]},
        "3060": {"vr": "DS", "Value": [12.208477537152]},
        "3061": {"vr": "DS", "Value": [69.708476545212]},
        "3062": {"vr": "DS", "Value": [-2.7915221757886]},
        "3063": {"vr": "DS", "Value": [-20.291521415365]},
        "3064": {"vr": "DS", "Value": [-57.791522737289]},
        "3065": {"vr": "DS", "Value": [-10.291522469903]},
        "3066": {"vr": "DS", "Value": [17.208478043704]},
        "3067": {"vr": "DS", "Value": [32.208477290931]},
        "3068": {"vr": "DS", "Value": [-57.791522737289]},
        "3069": {"vr": "DS", "Value": [-50.291522079855]},
        "3070": {"vr": "DS", "Value": [-65.291519566621]},
        "3071": {"vr": "DS", "Value": [-42.79152142242]},
        "3072": {"vr": "DS", "Value": [-17.791523024944]},
        "3073": {"vr": "DS", "Value": [69.708476545212]},
        "3074": {"vr": "DS", "Value": [-45.291521675696]},
        "3075": {"vr": "DS", "Value": [39.708478050759]},
        "3076": {"vr": "DS", "Value": [-20.291521415365]},
        "3077": {"vr": "DS", "Value": [24.708478393957]},
        "3078": {"vr": "DS", "Value": [44.708478557311]},
        "3079": {"vr": "DS", "Value": [27.208476784379]},
        "3080": {"vr": "DS", "Value": [-15.291522976455]},
        "3081": {"vr": "DS", "Value": [27.208476784379]},
        "3082": {"vr": "DS", "Value": [-55.291522484013]},
        "3083": {"vr": "DS", "Value": [-17.791523024944]},
        "3084": {"vr": "DS", "Value": [-0.2915219225125]},
        "3085": {"vr": "DS", "Value": [-22.791521668641]},
        "3086": {"vr": "DS", "Value": [-25.291521921917]},
        "3087": {"vr": "DS", "Value": [-67.791519819897]},
        "3088": {"vr": "DS", "Value": [-57.791522737289]},
        "3089": {"vr": "DS", "Value": [24.708478393957]},
        "3090": {"vr": "DS", "Value": [-70.291520021976]},
        "3091": {"vr": "DS", "Value": [-2.7915221757886]},
        "3092": {"vr": "DS", "Value": [-52.791522230737]},
        "3093": {"vr": "DS", "Value": [9.7084777495894]},
        "3094": {"vr": "DS", "Value": [49.708478654288]},
        "3095": {"vr": "DS", "Value": [-60.291522888171]},
        "3096": {"vr": "DS", "Value": [-55.291522484013]},
        "3097": {"vr": "DS", "Value": [-65.291519566621]},
        "3098": {"vr": "DS", "Value": [14.708477790428]},
        "3099": {"vr": "DS", "Value": [37.208477797483]},
        "3100": {"vr": "DS", "Value": [-45.291521675696]},
        "3101": {"vr": "DS", "Value": [-42.79152142242]},
        "3102": {"vr": "DS", "Value": [39.708478050759]},
        "3103": {"vr": "DS", "Value": [14.708477790428]},
        "3104": {"vr": "DS", "Value": [-35.29152086738]},
        "3105": {"vr": "DS", "Value": [62.208476194959]},
        "3106": {"vr": "DS", "Value": [27.208476784379]},
        "3107": {"vr": "DS", "Value": [67.208476291936]},
        "3108": {"vr": "DS", "Value": [-22.791521668641]},
        "3109": {"vr": "DS", "Value": [-25.291521921917]},
        "3110": {"vr": "DS", "Value": [-7.7915222166271]},
        "3111": {"vr": "DS", "Value": [-32.791520614104]},
        "3112": {"vr": "DS", "Value": [32.208477290931]},
        "3113": {"vr": "DS", "Value": [74.708477051764]},
        "3114": {"vr": "DS", "Value": [39.708478050759]},
        "3115": {"vr": "DS", "Value": [44.708478557311]},
        "3116": {"vr": "DS", "Value": [-70.291520021976]},
        "3117": {"vr": "DS", "Value": [-42.79152142242]},
        "3118": {"vr": "DS", "Value": [22.208478550256]},
        "3119": {"vr": "DS", "Value": [37.208477797483]},
        "3120": {"vr": "DS", "Value": [39.708478050759]},
        "3121": {"vr": "DS", "Value": [72.208476798488]},
        "3122": {"vr": "DS", "Value": [9.7084777495894]},
        "3123": {"vr": "DS", "Value": [57.208479414116]},
        "3124": {"vr": "DS", "Value": [-40.291521169144]},
        "3125": {"vr": "DS", "Value": [24.708478393957]},
        "3126": {"vr": "DS", "Value": [-35.29152086738]},
        "3127": {"vr": "DS", "Value": [-2.7915221757886]},
        "3128": {"vr": "DS", "Value": [54.70847916084]},
        "3129": {"vr": "DS", "Value": [42.208478304035]},
        "3130": {"vr": "DS", "Value": [4.7084775923224]},
        "3131": {"vr": "DS", "Value": [-55.291522484013]},
        "3132": {"vr": "DS", "Value": [-37.791521120656]},
        "3133": {"vr": "DS", "Value": [-2.7915221757886]},
        "3134": {"vr": "DS", "Value": [-45.291521675696]},
        "3135": {"vr": "DS", "Value": [-30.291520360827]},
        "3136": {"vr": "DS", "Value": [-35.29152086738]},
        "3137": {"vr": "DS", "Value": [-15.291522976455]},
        "3138": {"vr": "DS", "Value": [-55.291522484013]},
        "3139": {"vr": "DS", "Value": [12.208477537152]},
        "3140": {"vr": "DS", "Value": [-60.291522888171]},
        "3141": {"vr": "DS", "Value": [-57.791522737289]},
        "3142": {"vr": "DS", "Value": [-60.291522888171]},
        "3143": {"vr": "DS", "Value": [7.2084777291701]},
        "3144": {"vr": "DS", "Value": [44.708478557311]},
        "3145": {"vr": "DS", "Value": [-65.291519566621]},
        "3146": {"vr": "DS", "Value": [37.208477797483]},
        "3147": {"vr": "DS", "Value": [7.2084777291701]},
        "3148": {"vr": "DS", "Value": [22.208478550256]},
        "3149": {"vr": "DS", "Value": [74.708477051764]},
        "3150": {"vr": "DS", "Value": [-72.791520224055]},
        "3151": {"vr": "DS", "Value": [44.708478557311]},
        "3152": {"vr": "DS", "Value": [39.708478050759]},
        "3153": {"vr": "DS", "Value": [42.208478304035]},
        "3154": {"vr": "DS", "Value": [-70.291520021976]},
        "3155": {"vr": "DS", "Value": [32.208477290931]},
        "3156": {"vr": "DS", "Value": [-70.291520021976]},
        "3157": {"vr": "DS", "Value": [57.208479414116]},
        "3158": {"vr": "DS", "Value": [-20.291521415365]},
        "3159": {"vr": "DS", "Value": [-42.79152142242]},
        "3160": {"vr": "DS", "Value": [27.208476784379]},
        "3161": {"vr": "DS", "Value": [42.208478304035]},
        "3162": {"vr": "DS", "Value": [-32.791520614104]},
        "3163": {"vr": "DS", "Value": [-27.791521970406]},
        "3164": {"vr": "DS", "Value": [34.708477544207]},
        "3165": {"vr": "DS", "Value": [-15.291522976455]},
        "3166": {"vr": "DS", "Value": [-25.291521921917]},
        "3167": {"vr": "DS", "Value": [-0.2915219225125]},
        "3168": {"vr": "DS", "Value": [-37.791521120656]},
        "3169": {"vr": "DS", "Value": [67.208476291936]},
        "3170": {"vr": "DS", "Value": [67.208476291936]},
        "3171": {"vr": "DS", "Value": [24.708478393957]},
        "3172": {"vr": "DS", "Value": [-17.791523024944]},
        "3173": {"vr": "DS", "Value": [74.708477051764]},
        "3174": {"vr": "DS", "Value": [67.208476291936]},
        "3175": {"vr": "DS", "Value": [12.208477537152]},
        "3176": {"vr": "DS", "Value": [52.208478907564]},
        "3177": {"vr": "DS", "Value": [-60.291522888171]},
        "3178": {"vr": "DS", "Value": [59.708475941683]},
        "3179": {"vr": "DS", "Value": [-72.791520224055]},
        "3180": {"vr": "DS", "Value": [-60.291522888171]},
        "3181": {"vr": "DS", "Value": [-15.291522976455]},
        "3182": {"vr": "DS", "Value": [2.2084775719032]},
        "3183": {"vr": "DS", "Value": [-7.7915222166271]},
        "3184": {"vr": "DS", "Value": [-62.791519415738]},
        "3185": {"vr": "DS", "Value": [29.708477037655]},
        "3186": {"vr": "DS", "Value": [-30.291520360827]},
        "3187": {"vr": "DS", "Value": [-5.291521963351]},
        "3188": {"vr": "DS", "Value": [44.708478557311]},
        "3189": {"vr": "DS", "Value": [74.708477051764]},
        "3190": {"vr": "DS", "Value": [-25.291521921917]},
        "3191": {"vr": "DS", "Value": [44.708478557311]},
        "3192": {"vr": "DS", "Value": [74.708477051764]},
        "3193": {"vr": "DS", "Value": [49.708478654288]},
        "3194": {"vr": "DS", "Value": [37.208477797483]},
        "3195": {"vr": "DS", "Value": [-50.291522079855]},
        "3196": {"vr": "DS", "Value": [24.708478393957]},
        "3197": {"vr": "DS", "Value": [-70.291520021976]},
        "3198": {"vr": "DS", "Value": [-27.791521970406]},
        "3199": {"vr": "DS", "Value": [-20.291521415365]},
        "3200": {"vr": "DS", "Value": [7.2084777291701]},
        "3201": {"vr": "DS", "Value": [-17.791523024944]},
        "3202": {"vr": "DS", "Value": [-30.291520360827]},
        "3203": {"vr": "DS", "Value": [67.208476291936]},
        "3204": {"vr": "DS", "Value": [-40.291521169144]},
        "3205": {"vr": "DS", "Value": [-7.7915222166271]},
        "3206": {"vr": "DS", "Value": [-22.791521668641]},
        "3207": {"vr": "DS", "Value": [-50.291522079855]},
        "3208": {"vr": "DS", "Value": [19.70847829698]},
        "3209": {"vr": "DS", "Value": [62.208476194959]},
        "3210": {"vr": "DS", "Value": [-40.291521169144]},
        "3211": {"vr": "DS", "Value": [39.708478050759]},
        "3212": {"vr": "DS", "Value": [69.708476545212]},
        "3213": {"vr": "DS", "Value": [-0.2915219225125]},
        "3214": {"vr": "DS", "Value": [74.708477051764]},
        "3215": {"vr": "DS", "Value": [2.2084775719032]},
        "3216": {"vr": "DS", "Value": [69.708476545212]},
        "3217": {"vr": "DS", "Value": [-37.791521120656]},
        "3218": {"vr": "DS", "Value": [-72.791520224055]},
        "3219": {"vr": "DS", "Value": [24.708478393957]},
        "3220": {"vr": "DS", "Value": [44.708478557311]},
        "3221": {"vr": "DS", "Value": [7.2084777291701]},
        "3222": {"vr": "DS", "Value": [-67.791519819897]},
        "3223": {"vr": "DS", "Value": [-62.791519415738]},
        "3224": {"vr": "DS", "Value": [74.708477051764]},
        "3225": {"vr": "DS", "Value": [-12.791522723179]},
        "3226": {"vr": "DS", "Value": [39.708478050759]},
        "3227": {"vr": "DS", "Value": [4.7084775923224]},
        "3228": {"vr": "DS", "Value": [-42.79152142242]},
        "3229": {"vr": "DS", "Value": [-40.291521169144]},
        "3230": {"vr": "DS", "Value": [-57.791522737289]},
        "3231": {"vr": "DS", "Value": [-25.291521921917]},
        "3232": {"vr": "DS", "Value": [-30.291520360827]},
        "3233": {"vr": "DS", "Value": [-45.291521675696]},
        "3234": {"vr": "DS", "Value": [-5.291521963351]},
        "3235": {"vr": "DS", "Value": [34.708477544207]},
        "3236": {"vr": "DS", "Value": [-15.291522976455]},
        "3237": {"vr": "DS", "Value": [69.708476545212]},
        "3238": {"vr": "DS", "Value": [54.70847916084]},
        "3239": {"vr": "DS", "Value": [-10.291522469903]},
        "3240": {"vr": "DS", "Value": [-27.791521970406]},
        "3241": {"vr": "DS", "Value": [29.708477037655]},
        "3242": {"vr": "DS", "Value": [-22.791521668641]},
        "3243": {"vr": "DS", "Value": [27.208476784379]},
        "3244": {"vr": "DS", "Value": [9.7084777495894]},
        "3245": {"vr": "DS", "Value": [-57.791522737289]},
        "3246": {"vr": "DS", "Value": [-62.791519415738]},
        "3247": {"vr": "DS", "Value": [24.708478393957]},
        "3248": {"vr": "DS", "Value": [42.208478304035]},
        "3249": {"vr": "DS", "Value": [52.208478907564]},
        "3250": {"vr": "DS", "Value": [32.208477290931]},
        "3251": {"vr": "DS", "Value": [42.208478304035]},
        "3252": {"vr": "DS", "Value": [-0.2915219225125]},
        "3253": {"vr": "DS", "Value": [-2.7915221757886]},
        "3254": {"vr": "DS", "Value": [-65.291519566621]},
        "3255": {"vr": "DS", "Value": [42.208478304035]},
        "3256": {"vr": "DS", "Value": [-12.791522723179]},
        "3257": {"vr": "DS", "Value": [7.2084777291701]},
        "3258": {"vr": "DS", "Value": [-42.79152142242]},
        "3259": {"vr": "DS", "Value": [12.208477537152]},
        "3260": {"vr": "DS", "Value": [4.7084775923224]},
        "3261": {"vr": "DS", "Value": [-57.791522737289]},
        "3262": {"vr": "DS", "Value": [-45.291521675696]},
        "3263": {"vr": "DS", "Value": [-22.791521668641]},
        "3264": {"vr": "DS", "Value": [32.208477290931]},
        "3265": {"vr": "DS", "Value": [34.708477544207]},
        "3266": {"vr": "DS", "Value": [2.2084775719032]},
        "3267": {"vr": "DS", "Value": [49.708478654288]},
        "3268": {"vr": "DS", "Value": [57.208479414116]},
        "3269": {"vr": "DS", "Value": [-45.291521675696]},
        "3270": {"vr": "DS", "Value": [-10.291522469903]},
        "3271": {"vr": "DS", "Value": [52.208478907564]},
        "3272": {"vr": "DS", "Value": [24.708478393957]},
        "3273": {"vr": "DS", "Value": [-10.291522469903]},
        "3274": {"vr": "DS", "Value": [-7.7915222166271]},
        "3275": {"vr": "DS", "Value": [34.708477544207]},
        "3276": {"vr": "DS", "Value": [49.708478654288]},
        "3277": {"vr": "DS", "Value": [29.708477037655]},
        "3278": {"vr": "DS", "Value": [54.70847916084]},
        "3279": {"vr": "DS", "Value": [-57.791522737289]},
        "3280": {"vr": "DS", "Value": [-17.791523024944]},
        "3281": {"vr": "DS", "Value": [-5.291521963351]},
        "3282": {"vr": "DS", "Value": [-7.7915222166271]},
        "3283": {"vr": "DS", "Value": [42.208478304035]},
        "3284": {"vr": "DS", "Value": [-0.2915219225125]},
        "3285": {"vr": "DS", "Value": [-15.291522976455]},
        "3286": {"vr": "DS", "Value": [-32.791520614104]},
        "3287": {"vr": "DS", "Value": [-0.2915219225125]},
        "3288": {"vr": "DS", "Value": [-17.791523024944]},
        "3289": {"vr": "DS", "Value": [67.208476291936]},
        "3290": {"vr": "DS", "Value": [44.708478557311]},
        "3291": {"vr": "DS", "Value": [67.208476291936]},
        "3292": {"vr": "DS", "Value": [-30.291520360827]},
        "3293": {"vr": "DS", "Value": [67.208476291936]},
        "3294": {"vr": "DS", "Value": [-5.291521963351]},
        "3295": {"vr": "DS", "Value": [19.70847829698]},
        "3296": {"vr": "DS", "Value": [22.208478550256]},
        "3297": {"vr": "DS", "Value": [54.70847916084]},
        "3298": {"vr": "DS", "Value": [-50.291522079855]},
        "3299": {"vr": "DS", "Value": [69.708476545212]},
        "3300": {"vr": "DS", "Value": [72.208476798488]},
        "3301": {"vr": "DS", "Value": [64.70847603866]},
        "3302": {"vr": "DS", "Value": [9.7084777495894]},
        "3303": {"vr": "DS", "Value": [64.70847603866]},
        "3304": {"vr": "DS", "Value": [37.208477797483]},
        "3305": {"vr": "DS", "Value": [19.70847829698]},
        "3306": {"vr": "DS", "Value": [22.208478550256]},
        "3307": {"vr": "DS", "Value": [67.208476291936]},
        "3308": {"vr": "DS", "Value": [-40.291521169144]},
        "3309": {"vr": "DS", "Value": [-22.791521668641]},
        "3310": {"vr": "DS", "Value": [-5.291521963351]},
        "3311": {"vr": "DS", "Value": [-22.791521668641]},
        "3312": {"vr": "DS", "Value": [57.208479414116]},
        "3313": {"vr": "DS", "Value": [-20.291521415365]},
        "3314": {"vr": "DS", "Value": [69.708476545212]},
        "3315": {"vr": "DS", "Value": [72.208476798488]},
        "3316": {"vr": "DS", "Value": [72.208476798488]},
        "3317": {"vr": "DS", "Value": [14.708477790428]},
        "3318": {"vr": "DS", "Value": [9.7084777495894]},
        "3319": {"vr": "DS", "Value": [37.208477797483]},
        "3320": {"vr": "DS", "Value": [67.208476291936]},
        "3321": {"vr": "DS", "Value": [37.208477797483]},
        "3322": {"vr": "DS", "Value": [-22.791521668641]},
        "3323": {"vr": "DS", "Value": [62.208476194959]},
        "3324": {"vr": "DS", "Value": [54.70847916084]},
        "3325": {"vr": "DS", "Value": [39.708478050759]},
        "3326": {"vr": "DS", "Value": [47.208478401012]},
        "3327": {"vr": "DS", "Value": [42.208478304035]},
        "3328": {"vr": "DS", "Value": [14.708477790428]},
        "3329": {"vr": "DS", "Value": [49.708478654288]},
        "3330": {"vr": "DS", "Value": [42.208478304035]},
        "3331": {"vr": "DS", "Value": [-5.291521963351]},
        "3332": {"vr": "DS", "Value": [4.7084775923224]},
        "3333": {"vr": "DS", "Value": [42.208478304035]},
        "3334": {"vr": "DS", "Value": [14.708477790428]},
        "3335": {"vr": "DS", "Value": [14.708477790428]},
        "3336": {"vr": "DS", "Value": [54.70847916084]},
        "3337": {"vr": "DS", "Value": [-70.291520021976]},
        "3338": {"vr": "DS", "Value": [-45.291521675696]},
        "3339": {"vr": "DS", "Value": [29.708477037655]},
        "3340": {"vr": "DS", "Value": [-70.291520021976]},
        "3341": {"vr": "DS", "Value": [-25.291521921917]},
        "3342": {"vr": "DS", "Value": [-35.29152086738]},
        "3343": {"vr": "DS", "Value": [74.708477051764]},
        "3344": {"vr": "DS", "Value": [-2.7915221757886]},
        "3345": {"vr": "DS", "Value": [-7.7915222166271]},
        "3346": {"vr": "DS", "Value": [-5.291521963351]},
        "3347": {"vr": "DS", "Value": [54.70847916084]},
        "3348": {"vr": "DS", "Value": [-10.291522469903]},
        "3349": {"vr": "DS", "Value": [-32.791520614104]},
        "3350": {"vr": "DS", "Value": [-70.291520021976]},
        "3351": {"vr": "DS", "Value": [-15.291522976455]},
        "3352": {"vr": "DS", "Value": [-57.791522737289]},
        "3353": {"vr": "DS", "Value": [44.708478557311]},
        "3354": {"vr": "DS", "Value": [59.708475941683]},
        "3355": {"vr": "DS", "Value": [74.708477051764]},
        "3356": {"vr": "DS", "Value": [-52.791522230737]},
        "3357": {"vr": "DS", "Value": [-32.791520614104]},
        "3358": {"vr": "DS", "Value": [-17.791523024944]},
        "3359": {"vr": "DS", "Value": [-47.791521826579]},
        "3360": {"vr": "DS", "Value": [24.708478393957]},
        "3361": {"vr": "DS", "Value": [9.7084777495894]},
        "3362": {"vr": "DS", "Value": [-45.291521675696]},
        "3363": {"vr": "DS", "Value": [62.208476194959]},
        "3364": {"vr": "DS", "Value": [-22.791521668641]},
        "3365": {"vr": "DS", "Value": [-47.791521826579]},
        "3366": {"vr": "DS", "Value": [34.708477544207]},
        "3367": {"vr": "DS", "Value": [39.708478050759]},
        "3368": {"vr": "DS", "Value": [17.208478043704]},
        "3369": {"vr": "DS", "Value": [49.708478654288]},
        "3370": {"vr": "DS", "Value": [-25.291521921917]},
        "3371": {"vr": "DS", "Value": [-42.79152142242]},
        "3372": {"vr": "DS", "Value": [-10.291522469903]},
        "3373": {"vr": "DS", "Value": [-32.791520614104]},
        "3374": {"vr": "DS", "Value": [-25.291521921917]},
        "3375": {"vr": "DS", "Value": [22.208478550256]},
        "3376": {"vr": "DS", "Value": [74.708477051764]},
        "3377": {"vr": "DS", "Value": [9.7084777495894]},
        "3378": {"vr": "DS", "Value": [67.208476291936]},
        "3379": {"vr": "DS", "Value": [-10.291522469903]},
        "3380": {"vr": "DS", "Value": [-0.2915219225125]},
        "3381": {"vr": "DS", "Value": [19.70847829698]},
        "3382": {"vr": "DS", "Value": [69.708476545212]},
        "3383": {"vr": "DS", "Value": [12.208477537152]},
        "3384": {"vr": "DS", "Value": [-10.291522469903]},
        "3385": {"vr": "DS", "Value": [-0.2915219225125]},
        "3386": {"vr": "DS", "Value": [-42.79152142242]},
        "3387": {"vr": "DS", "Value": [-10.291522469903]},
        "3388": {"vr": "DS", "Value": [37.208477797483]},
        "3389": {"vr": "DS", "Value": [-30.291520360827]},
        "3390": {"vr": "DS", "Value": [-42.79152142242]},
        "3391": {"vr": "DS", "Value": [-15.291522976455]},
        "3392": {"vr": "DS", "Value": [-32.791520614104]},
        "3393": {"vr": "DS", "Value": [47.208478401012]},
        "3394": {"vr": "DS", "Value": [-40.291521169144]},
        "3395": {"vr": "DS", "Value": [-37.791521120656]},
        "3396": {"vr": "DS", "Value": [69.708476545212]},
        "3397": {"vr": "DS", "Value": [4.7084775923224]},
        "3398": {"vr": "DS", "Value": [-60.291522888171]},
        "3399": {"vr": "DS", "Value": [9.7084777495894]},
        "3400": {"vr": "DS", "Value": [-22.791521668641]},
        "3401": {"vr": "DS", "Value": [47.208478401012]},
        "3402": {"vr": "DS", "Value": [-67.791519819897]},
        "3403": {"vr": "DS", "Value": [34.708477544207]},
        "3404": {"vr": "DS", "Value": [29.708477037655]},
        "3405": {"vr": "DS", "Value": [-57.791522737289]},
        "3406": {"vr": "DS", "Value": [-32.791520614104]},
        "3407": {"vr": "DS", "Value": [12.208477537152]},
        "3408": {"vr": "DS", "Value": [-7.7915222166271]},
        "3409": {"vr": "DS", "Value": [-72.791520224055]},
        "3410": {"vr": "DS", "Value": [-27.791521970406]},
        "3411": {"vr": "DS", "Value": [59.708475941683]},
        "3412": {"vr": "DS", "Value": [-72.791520224055]},
        "3413": {"vr": "DS", "Value": [-15.291522976455]},
        "3414": {"vr": "DS", "Value": [-45.291521675696]},
        "3415": {"vr": "DS", "Value": [14.708477790428]},
        "3416": {"vr": "DS", "Value": [-42.79152142242]},
        "3417": {"vr": "DS", "Value": [64.70847603866]},
        "3418": {"vr": "DS", "Value": [22.208478550256]},
        "3419": {"vr": "DS", "Value": [-32.791520614104]},
        "3420": {"vr": "DS", "Value": [17.208478043704]},
        "3421": {"vr": "DS", "Value": [-72.791520224055]},
        "3422": {"vr": "DS", "Value": [34.708477544207]},
        "3423": {"vr": "DS", "Value": [-40.291521169144]},
        "3424": {"vr": "DS", "Value": [47.208478401012]},
        "3425": {"vr": "DS", "Value": [44.708478557311]},
        "3426": {"vr": "DS", "Value": [-52.791522230737]},
        "3427": {"vr": "DS", "Value": [64.70847603866]},
        "3428": {"vr": "DS", "Value": [59.708475941683]},
        "3429": {"vr": "DS", "Value": [34.708477544207]},
        "3430": {"vr": "DS", "Value": [-62.791519415738]},
        "3431": {"vr": "DS", "Value": [44.708478557311]},
        "3432": {"vr": "DS", "Value": [-70.291520021976]},
        "3433": {"vr": "DS", "Value": [-22.791521668641]},
        "3434": {"vr": "DS", "Value": [-60.291522888171]},
        "3435": {"vr": "DS", "Value": [59.708475941683]},
        "3436": {"vr": "DS", "Value": [-47.791521826579]},
        "3437": {"vr": "DS", "Value": [-25.291521921917]},
        "3438": {"vr": "DS", "Value": [22.208478550256]},
        "3439": {"vr": "DS", "Value": [-47.791521826579]},
        "3440": {"vr": "DS", "Value": [-15.291522976455]},
        "3441": {"vr": "DS", "Value": [-62.791519415738]},
        "3442": {"vr": "DS", "Value": [34.708477544207]},
        "3443": {"vr": "DS", "Value": [19.70847829698]},
        "3444": {"vr": "DS", "Value": [-57.791522737289]},
        "3445": {"vr": "DS", "Value": [69.708476545212]},
        "3446": {"vr": "DS", "Value": [9.7084777495894]},
        "3447": {"vr": "DS", "Value": [-67.791519819897]},
        "3448": {"vr": "DS", "Value": [-67.791519819897]},
        "3449": {"vr": "DS", "Value": [19.70847829698]},
        "3450": {"vr": "DS", "Value": [-67.791519819897]},
        "3451": {"vr": "DS", "Value": [14.708477790428]},
        "3452": {"vr": "DS", "Value": [17.208478043704]},
        "3453": {"vr": "DS", "Value": [-15.291522976455]},
        "3454": {"vr": "DS", "Value": [-10.291522469903]},
        "3455": {"vr": "DS", "Value": [39.708478050759]},
        "3456": {"vr": "DS", "Value": [74.708477051764]},
        "3457": {"vr": "DS", "Value": [-72.791520224055]},
        "3458": {"vr": "DS", "Value": [54.70847916084]},
        "3459": {"vr": "DS", "Value": [19.70847829698]},
        "3460": {"vr": "DS", "Value": [59.708475941683]},
        "3461": {"vr": "DS", "Value": [24.708478393957]},
        "3462": {"vr": "DS", "Value": [2.2084775719032]},
        "3463": {"vr": "DS", "Value": [54.70847916084]},
        "3464": {"vr": "DS", "Value": [-45.291521675696]},
        "3465": {"vr": "DS", "Value": [32.208477290931]},
        "3466": {"vr": "DS", "Value": [-2.7915221757886]},
        "3467": {"vr": "DS", "Value": [64.70847603866]},
        "3468": {"vr": "DS", "Value": [39.708478050759]},
        "3469": {"vr": "DS", "Value": [17.208478043704]},
        "3470": {"vr": "DS", "Value": [2.2084775719032]},
        "3471": {"vr": "DS", "Value": [-0.2915219225125]},
        "3472": {"vr": "DS", "Value": [-32.791520614104]},
        "3473": {"vr": "DS", "Value": [-55.291522484013]},
        "3474": {"vr": "DS", "Value": [22.208478550256]},
        "3475": {"vr": "DS", "Value": [-60.291522888171]},
        "3476": {"vr": "DS", "Value": [-35.29152086738]},
        "3477": {"vr": "DS", "Value": [69.708476545212]},
        "3478": {"vr": "DS", "Value": [67.208476291936]},
        "3479": {"vr": "DS", "Value": [-17.791523024944]},
        "3480": {"vr": "DS", "Value": [-7.7915222166271]},
        "3481": {"vr": "DS", "Value": [9.7084777495894]},
        "3482": {"vr": "DS", "Value": [-67.791519819897]},
        "3483": {"vr": "DS", "Value": [7.2084777291701]},
        "3484": {"vr": "DS", "Value": [-62.791519415738]},
        "3485": {"vr": "DS", "Value": [34.708477544207]},
        "3486": {"vr": "DS", "Value": [-57.791522737289]},
        "3487": {"vr": "DS", "Value": [-57.791522737289]},
        "3488": {"vr": "DS", "Value": [22.208478550256]},
        "3489": {"vr": "DS", "Value": [-15.291522976455]},
        "3490": {"vr": "DS", "Value": [54.70847916084]},
        "3491": {"vr": "DS", "Value": [4.7084775923224]},
        "3492": {"vr": "DS", "Value": [-52.791522230737]},
        "3493": {"vr": "DS", "Value": [-67.791519819897]},
        "3494": {"vr": "DS", "Value": [69.708476545212]},
        "3495": {"vr": "DS", "Value": [-12.791522723179]},
        "3496": {"vr": "DS", "Value": [42.208478304035]},
        "3497": {"vr": "DS", "Value": [-0.2915219225125]},
        "3498": {"vr": "DS", "Value": [-67.791519819897]},
        "3499": {"vr": "DS", "Value": [27.208476784379]},
        "3500": {"vr": "DS", "Value": [-67.791519819897]},
        "3501": {"vr": "DS", "Value": [57.208479414116]},
        "3502": {"vr": "DS", "Value": [-60.291522888171]},
        "3503": {"vr": "DS", "Value": [29.708477037655]},
        "3504": {"vr": "DS", "Value": [-27.791521970406]},
        "3505": {"vr": "DS", "Value": [34.708477544207]},
        "3506": {"vr": "DS", "Value": [-65.291519566621]},
        "3507": {"vr": "DS", "Value": [-42.79152142242]},
        "3508": {"vr": "DS", "Value": [-7.7915222166271]},
        "3509": {"vr": "DS", "Value": [7.2084777291701]},
        "3510": {"vr": "DS", "Value": [24.708478393957]},
        "3511": {"vr": "DS", "Value": [54.70847916084]},
        "3512": {"vr": "DS", "Value": [-22.791521668641]},
        "3513": {"vr": "DS", "Value": [-25.291521921917]},
        "3514": {"vr": "DS", "Value": [54.70847916084]},
        "3515": {"vr": "DS", "Value": [62.208476194959]},
        "3516": {"vr": "DS", "Value": [52.208478907564]},
        "3517": {"vr": "DS", "Value": [-47.791521826579]},
        "3518": {"vr": "DS", "Value": [-22.791521668641]},
        "3519": {"vr": "DS", "Value": [-5.291521963351]},
        "3520": {"vr": "DS", "Value": [-62.791519415738]},
        "3521": {"vr": "DS", "Value": [44.708478557311]},
        "3522": {"vr": "DS", "Value": [-70.291520021976]},
        "3523": {"vr": "DS", "Value": [-12.791522723179]},
        "3524": {"vr": "DS", "Value": [-42.79152142242]},
        "3525": {"vr": "DS", "Value": [-5.291521963351]},
        "3526": {"vr": "DS", "Value": [49.708478654288]},
        "3527": {"vr": "DS", "Value": [-25.291521921917]},
        "3528": {"vr": "DS", "Value": [-52.791522230737]},
        "3529": {"vr": "DS", "Value": [-0.2915219225125]},
        "3530": {"vr": "DS", "Value": [-62.791519415738]},
        "3531": {"vr": "DS", "Value": [-17.791523024944]},
        "3532": {"vr": "DS", "Value": [-55.291522484013]},
        "3533": {"vr": "DS", "Value": [22.208478550256]},
        "3534": {"vr": "DS", "Value": [-22.791521668641]},
        "3535": {"vr": "DS", "Value": [67.208476291936]},
        "3536": {"vr": "DS", "Value": [47.208478401012]},
        "3537": {"vr": "DS", "Value": [-55.291522484013]},
        "3538": {"vr": "DS", "Value": [17.208478043704]},
        "3539": {"vr": "DS", "Value": [12.208477537152]},
        "3540": {"vr": "DS", "Value": [-60.291522888171]},
        "3541": {"vr": "DS", "Value": [-65.291519566621]},
        "3542": {"vr": "DS", "Value": [49.708478654288]},
        "3543": {"vr": "DS", "Value": [42.208478304035]},
        "3544": {"vr": "DS", "Value": [-20.291521415365]},
        "3545": {"vr": "DS", "Value": [-67.791519819897]},
        "3546": {"vr": "DS", "Value": [-47.791521826579]},
        "3547": {"vr": "DS", "Value": [19.70847829698]},
        "3548": {"vr": "DS", "Value": [52.208478907564]},
        "3549": {"vr": "DS", "Value": [-60.291522888171]},
        "3550": {"vr": "DS", "Value": [-57.791522737289]},
        "3551": {"vr": "DS", "Value": [19.70847829698]},
        "3552": {"vr": "DS", "Value": [27.208476784379]},
        "3553": {"vr": "DS", "Value": [49.708478654288]},
        "3554": {"vr": "DS", "Value": [-5.291521963351]},
        "3555": {"vr": "DS", "Value": [-2.7915221757886]},
        "3556": {"vr": "DS", "Value": [-72.791520224055]},
        "3557": {"vr": "DS", "Value": [39.708478050759]},
        "3558": {"vr": "DS", "Value": [27.208476784379]},
        "3559": {"vr": "DS", "Value": [-70.291520021976]},
        "3560": {"vr": "DS", "Value": [-55.291522484013]},
        "3561": {"vr": "DS", "Value": [-37.791521120656]},
        "3562": {"vr": "DS", "Value": [-52.791522230737]},
        "3563": {"vr": "DS", "Value": [54.70847916084]},
        "3564": {"vr": "DS", "Value": [64.70847603866]},
        "3565": {"vr": "DS", "Value": [57.208479414116]},
        "3566": {"vr": "DS", "Value": [-35.29152086738]},
        "3567": {"vr": "DS", "Value": [-22.791521668641]},
        "3568": {"vr": "DS", "Value": [-25.291521921917]},
        "3569": {"vr": "DS", "Value": [-62.791519415738]},
        "3570": {"vr": "DS", "Value": [-12.791522723179]},
        "3571": {"vr": "DS", "Value": [67.208476291936]},
        "3572": {"vr": "DS", "Value": [-65.291519566621]},
        "3573": {"vr": "DS", "Value": [-50.291522079855]},
        "3574": {"vr": "DS", "Value": [-45.291521675696]},
        "3575": {"vr": "DS", "Value": [27.208476784379]},
        "3576": {"vr": "DS", "Value": [7.2084777291701]},
        "3577": {"vr": "DS", "Value": [19.70847829698]},
        "3578": {"vr": "DS", "Value": [-72.791520224055]},
        "3579": {"vr": "DS", "Value": [29.708477037655]},
        "3580": {"vr": "DS", "Value": [-42.79152142242]},
        "3581": {"vr": "DS", "Value": [-32.791520614104]},
        "3582": {"vr": "DS", "Value": [-30.291520360827]},
        "3583": {"vr": "DS", "Value": [-0.2915219225125]},
        "3584": {"vr": "DS", "Value": [7.2084777291701]},
        "3585": {"vr": "DS", "Value": [72.208476798488]},
        "3586": {"vr": "DS", "Value": [-45.291521675696]},
        "3587": {"vr": "DS", "Value": [44.708478557311]},
        "3588": {"vr": "DS", "Value": [-40.291521169144]},
        "3589": {"vr": "DS", "Value": [49.708478654288]},
        "3590": {"vr": "DS", "Value": [27.208476784379]},
        "3591": {"vr": "DS", "Value": [17.208478043704]},
        "3592": {"vr": "DS", "Value": [7.2084777291701]},
        "3593": {"vr": "DS", "Value": [24.708478393957]},
        "3594": {"vr": "DS", "Value": [-25.291521921917]},
        "3595": {"vr": "DS", "Value": [-55.291522484013]},
        "3596": {"vr": "DS", "Value": [49.708478654288]},
        "3597": {"vr": "DS", "Value": [-35.29152086738]},
        "3598": {"vr": "DS", "Value": [-32.791520614104]},
        "3599": {"vr": "DS", "Value": [44.708478557311]},
        "3600": {"vr": "DS", "Value": [-55.291522484013]},
        "3601": {"vr": "DS", "Value": [72.208476798488]},
        "3602": {"vr": "DS", "Value": [59.708475941683]},
        "3603": {"vr": "DS", "Value": [57.208479414116]},
        "3604": {"vr": "DS", "Value": [22.208478550256]},
        "3605": {"vr": "DS", "Value": [17.208478043704]},
        "3606": {"vr": "DS", "Value": [-72.791520224055]},
        "3607": {"vr": "DS", "Value": [-65.291519566621]},
        "3608": {"vr": "DS", "Value": [62.208476194959]},
        "3609": {"vr": "DS", "Value": [69.708476545212]},
        "3610": {"vr": "DS", "Value": [-35.29152086738]},
        "3611": {"vr": "DS", "Value": [-2.7915221757886]},
        "3612": {"vr": "DS", "Value": [19.70847829698]},
        "3613": {"vr": "DS", "Value": [-27.791521970406]},
        "3614": {"vr": "DS", "Value": [-65.291519566621]},
        "3615": {"vr": "DS", "Value": [27.208476784379]},
        "3616": {"vr": "DS", "Value": [-35.29152086738]},
        "3617": {"vr": "DS", "Value": [-35.29152086738]},
        "3618": {"vr": "DS", "Value": [-37.791521120656]},
        "3619": {"vr": "DS", "Value": [-10.291522469903]},
        "3620": {"vr": "DS", "Value": [-27.791521970406]},
        "3621": {"vr": "DS", "Value": [29.708477037655]},
        "3622": {"vr": "DS", "Value": [-12.791522723179]},
        "3623": {"vr": "DS", "Value": [2.2084775719032]},
        "3624": {"vr": "DS", "Value": [-65.291519566621]},
        "3625": {"vr": "DS", "Value": [34.708477544207]},
        "3626": {"vr": "DS", "Value": [-67.791519819897]},
        "3627": {"vr": "DS", "Value": [-15.291522976455]},
        "3628": {"vr": "DS", "Value": [52.208478907564]},
        "3629": {"vr": "DS", "Value": [-37.791521120656]},
        "3630": {"vr": "DS", "Value": [22.208478550256]},
        "3631": {"vr": "DS", "Value": [67.208476291936]},
        "3632": {"vr": "DS", "Value": [-15.291522976455]},
        "3633": {"vr": "DS", "Value": [-45.291521675696]},
        "3634": {"vr": "DS", "Value": [29.708477037655]},
        "3635": {"vr": "DS", "Value": [-32.791520614104]},
        "3636": {"vr": "DS", "Value": [27.208476784379]},
        "3637": {"vr": "DS", "Value": [44.708478557311]},
        "3638": {"vr": "DS", "Value": [29.708477037655]},
        "3639": {"vr": "DS", "Value": [-37.791521120656]},
        "3640": {"vr": "DS", "Value": [-0.2915219225125]},
        "3641": {"vr": "DS", "Value": [-25.291521921917]},
        "3642": {"vr": "DS", "Value": [69.708476545212]},
        "3643": {"vr": "DS", "Value": [-72.791520224055]},
        "3644": {"vr": "DS", "Value": [-12.791522723179]},
        "3645": {"vr": "DS", "Value": [-27.791521970406]},
        "3646": {"vr": "DS", "Value": [-72.791520224055]},
        "3647": {"vr": "DS", "Value": [62.208476194959]},
        "3648": {"vr": "DS", "Value": [-62.791519415738]},
        "3649": {"vr": "DS", "Value": [-52.791522230737]},
        "3650": {"vr": "DS", "Value": [14.708477790428]},
        "3651": {"vr": "DS", "Value": [59.708475941683]},
        "3652": {"vr": "DS", "Value": [-62.791519415738]},
        "3653": {"vr": "DS", "Value": [27.208476784379]},
        "3654": {"vr": "DS", "Value": [-72.791520224055]},
        "3655": {"vr": "DS", "Value": [-30.291520360827]},
        "3656": {"vr": "DS", "Value": [-45.291521675696]},
        "3657": {"vr": "DS", "Value": [62.208476194959]},
        "3658": {"vr": "DS", "Value": [62.208476194959]},
        "3659": {"vr": "DS", "Value": [-20.291521415365]},
        "3660": {"vr": "DS", "Value": [-65.291519566621]},
        "3661": {"vr": "DS", "Value": [-70.291520021976]},
        "3662": {"vr": "DS", "Value": [19.70847829698]},
        "3663": {"vr": "DS", "Value": [-27.791521970406]},
        "3664": {"vr": "DS", "Value": [-12.791522723179]},
        "3665": {"vr": "DS", "Value": [67.208476291936]},
        "3666": {"vr": "DS", "Value": [-70.291520021976]},
        "3667": {"vr": "DS", "Value": [12.208477537152]},
        "3668": {"vr": "DS", "Value": [-62.791519415738]},
        "3669": {"vr": "DS", "Value": [-55.291522484013]},
        "3670": {"vr": "DS", "Value": [74.708477051764]},
        "3671": {"vr": "DS", "Value": [27.208476784379]},
        "3672": {"vr": "DS", "Value": [39.708478050759]},
        "3673": {"vr": "DS", "Value": [27.208476784379]},
        "3674": {"vr": "DS", "Value": [12.208477537152]},
        "3675": {"vr": "DS", "Value": [-52.791522230737]},
        "3676": {"vr": "DS", "Value": [27.208476784379]},
        "3677": {"vr": "DS", "Value": [-2.7915221757886]},
        "3678": {"vr": "DS", "Value": [29.708477037655]},
        "3679": {"vr": "DS", "Value": [7.2084777291701]},
        "3680": {"vr": "DS", "Value": [-45.291521675696]},
        "3681": {"vr": "DS", "Value": [-55.291522484013]},
        "3682": {"vr": "DS", "Value": [69.708476545212]},
        "3683": {"vr": "DS", "Value": [-35.29152086738]},
        "3684": {"vr": "DS", "Value": [-32.791520614104]},
        "3685": {"vr": "DS", "Value": [-35.29152086738]},
        "3686": {"vr": "DS", "Value": [32.208477290931]},
        "3687": {"vr": "DS", "Value": [54.70847916084]},
        "3688": {"vr": "DS", "Value": [74.708477051764]},
        "3689": {"vr": "DS", "Value": [-0.2915219225125]},
        "3690": {"vr": "DS", "Value": [4.7084775923224]},
        "3691": {"vr": "DS", "Value": [-32.791520614104]},
        "3692": {"vr": "DS", "Value": [-0.2915219225125]},
        "3693": {"vr": "DS", "Value": [22.208478550256]},
        "3694": {"vr": "DS", "Value": [-22.791521668641]},
        "3695": {"vr": "DS", "Value": [-35.29152086738]},
        "3696": {"vr": "DS", "Value": [-40.291521169144]},
        "3697": {"vr": "DS", "Value": [-62.791519415738]},
        "3698": {"vr": "DS", "Value": [-10.291522469903]},
        "3699": {"vr": "DS", "Value": [-5.291521963351]},
        "3700": {"vr": "DS", "Value": [64.70847603866]},
        "3701": {"vr": "DS", "Value": [-2.7915221757886]},
        "3702": {"vr": "DS", "Value": [-7.7915222166271]},
        "3703": {"vr": "DS", "Value": [-40.291521169144]},
        "3704": {"vr": "DS", "Value": [54.70847916084]},
        "3705": {"vr": "DS", "Value": [-15.291522976455]},
        "3706": {"vr": "DS", "Value": [19.70847829698]},
        "3707": {"vr": "DS", "Value": [-30.291520360827]},
        "3708": {"vr": "DS", "Value": [-37.791521120656]},
        "3709": {"vr": "DS", "Value": [-45.291521675696]},
        "3710": {"vr": "DS", "Value": [42.208478304035]},
        "3711": {"vr": "DS", "Value": [-20.291521415365]},
        "3712": {"vr": "DS", "Value": [17.208478043704]},
        "3713": {"vr": "DS", "Value": [72.208476798488]},
        "3714": {"vr": "DS", "Value": [24.708478393957]},
        "3715": {"vr": "DS", "Value": [32.208477290931]},
        "3716": {"vr": "DS", "Value": [64.70847603866]},
        "3717": {"vr": "DS", "Value": [59.708475941683]},
        "3718": {"vr": "DS", "Value": [17.208478043704]},
        "3719": {"vr": "DS", "Value": [-17.791523024944]},
        "3720": {"vr": "DS", "Value": [52.208478907564]},
        "3721": {"vr": "DS", "Value": [74.708477051764]},
        "3722": {"vr": "DS", "Value": [29.708477037655]},
        "3723": {"vr": "DS", "Value": [64.70847603866]},
        "3724": {"vr": "DS", "Value": [-47.791521826579]},
        "3725": {"vr": "DS", "Value": [-15.291522976455]},
        "3726": {"vr": "DS", "Value": [57.208479414116]},
        "3727": {"vr": "DS", "Value": [-30.291520360827]},
        "3728": {"vr": "DS", "Value": [12.208477537152]},
        "3729": {"vr": "DS", "Value": [-10.291522469903]},
        "3730": {"vr": "DS", "Value": [4.7084775923224]},
        "3731": {"vr": "DS", "Value": [-52.791522230737]},
        "3732": {"vr": "DS", "Value": [44.708478557311]},
        "3733": {"vr": "DS", "Value": [37.208477797483]},
        "3734": {"vr": "DS", "Value": [-57.791522737289]},
        "3735": {"vr": "DS", "Value": [67.208476291936]},
        "3736": {"vr": "DS", "Value": [-35.29152086738]},
        "3737": {"vr": "DS", "Value": [37.208477797483]},
        "3738": {"vr": "DS", "Value": [42.208478304035]},
        "3739": {"vr": "DS", "Value": [27.208476784379]},
        "3740": {"vr": "DS", "Value": [-70.291520021976]},
        "3741": {"vr": "DS", "Value": [49.708478654288]},
        "3742": {"vr": "DS", "Value": [-45.291521675696]},
        "3743": {"vr": "DS", "Value": [29.708477037655]},
        "3744": {"vr": "DS", "Value": [-7.7915222166271]},
        "3745": {"vr": "DS", "Value": [54.70847916084]},
        "3746": {"vr": "DS", "Value": [12.208477537152]},
        "3747": {"vr": "DS", "Value": [14.708477790428]},
        "3748": {"vr": "DS", "Value": [74.708477051764]},
        "3749": {"vr": "DS", "Value": [54.70847916084]},
        "3750": {"vr": "DS", "Value": [34.708477544207]},
        "3751": {"vr": "DS", "Value": [-47.791521826579]},
        "3752": {"vr": "DS", "Value": [37.208477797483]},
        "3753": {"vr": "DS", "Value": [22.208478550256]},
        "3754": {"vr": "DS", "Value": [4.7084775923224]},
        "3755": {"vr": "DS", "Value": [17.208478043704]},
        "3756": {"vr": "DS", "Value": [-35.29152086738]},
        "3757": {"vr": "DS", "Value": [72.208476798488]},
        "3758": {"vr": "DS", "Value": [49.708478654288]},
        "3759": {"vr": "DS", "Value": [-20.291521415365]},
        "3760": {"vr": "DS", "Value": [22.208478550256]},
        "3761": {"vr": "DS", "Value": [37.208477797483]},
        "3762": {"vr": "DS", "Value": [57.208479414116]},
        "3763": {"vr": "DS", "Value": [12.208477537152]},
        "3764": {"vr": "DS", "Value": [-35.29152086738]},
        "3765": {"vr": "DS", "Value": [34.708477544207]},
        "3766": {"vr": "DS", "Value": [49.708478654288]},
        "3767": {"vr": "DS", "Value": [-62.791519415738]},
        "3768": {"vr": "DS", "Value": [-62.791519415738]},
        "3769": {"vr": "DS", "Value": [52.208478907564]},
        "3770": {"vr": "DS", "Value": [-25.291521921917]},
        "3771": {"vr": "DS", "Value": [-7.7915222166271]},
        "3772": {"vr": "DS", "Value": [14.708477790428]},
        "3773": {"vr": "DS", "Value": [-27.791521970406]},
        "3774": {"vr": "DS", "Value": [22.208478550256]},
        "3775": {"vr": "DS", "Value": [-17.791523024944]},
        "3776": {"vr": "DS", "Value": [42.208478304035]},
        "3777": {"vr": "DS", "Value": [59.708475941683]},
        "3778": {"vr": "DS", "Value": [9.7084777495894]},
        "3779": {"vr": "DS", "Value": [-35.29152086738]},
        "3780": {"vr": "DS", "Value": [-70.291520021976]},
        "3781": {"vr": "DS", "Value": [-17.791523024944]},
        "3782": {"vr": "DS", "Value": [69.708476545212]},
        "3783": {"vr": "DS", "Value": [-47.791521826579]},
        "3784": {"vr": "DS", "Value": [42.208478304035]},
        "3785": {"vr": "DS", "Value": [72.208476798488]},
        "3786": {"vr": "DS", "Value": [52.208478907564]},
        "3787": {"vr": "DS", "Value": [-22.791521668641]},
        "3788": {"vr": "DS", "Value": [74.708477051764]},
        "3789": {"vr": "DS", "Value": [69.708476545212]},
        "3790": {"vr": "DS", "Value": [19.70847829698]},
        "3791": {"vr": "DS", "Value": [44.708478557311]},
        "3792": {"vr": "DS", "Value": [-67.791519819897]},
        "3793": {"vr": "DS", "Value": [29.708477037655]},
        "3794": {"vr": "DS", "Value": [67.208476291936]},
        "3795": {"vr": "DS", "Value": [74.708477051764]},
        "3796": {"vr": "DS", "Value": [27.208476784379]},
        "3797": {"vr": "DS", "Value": [-62.791519415738]},
        "3798": {"vr": "DS", "Value": [-2.7915221757886]},
        "3799": {"vr": "DS", "Value": [12.208477537152]},
        "3800": {"vr": "DS", "Value": [-37.791521120656]},
        "3801": {"vr": "DS", "Value": [39.708478050759]},
        "3802": {"vr": "DS", "Value": [-42.79152142242]},
        "3803": {"vr": "DS", "Value": [-10.291522469903]},
        "3804": {"vr": "DS", "Value": [17.208478043704]},
        "3805": {"vr": "DS", "Value": [69.708476545212]},
        "3806": {"vr": "DS", "Value": [67.208476291936]},
        "3807": {"vr": "DS", "Value": [72.208476798488]},
        "3808": {"vr": "DS", "Value": [-20.291521415365]},
        "3809": {"vr": "DS", "Value": [-67.791519819897]},
        "3810": {"vr": "DS", "Value": [-12.791522723179]},
        "3811": {"vr": "DS", "Value": [-7.7915222166271]},
        "3812": {"vr": "DS", "Value": [-15.291522976455]},
        "3813": {"vr": "DS", "Value": [22.208478550256]},
        "3814": {"vr": "DS", "Value": [57.208479414116]},
        "3815": {"vr": "DS", "Value": [7.2084777291701]},
        "3816": {"vr": "DS", "Value": [14.708477790428]},
        "3817": {"vr": "DS", "Value": [-62.791519415738]},
        "3818": {"vr": "DS", "Value": [-27.791521970406]},
        "3819": {"vr": "DS", "Value": [-47.791521826579]},
        "3820": {"vr": "DS", "Value": [-20.291521415365]},
        "3821": {"vr": "DS", "Value": [74.708477051764]},
        "3822": {"vr": "DS", "Value": [-52.791522230737]},
        "3823": {"vr": "DS", "Value": [29.708477037655]},
        "3824": {"vr": "DS", "Value": [-17.791523024944]},
        "3825": {"vr": "DS", "Value": [-20.291521415365]},
        "3826": {"vr": "DS", "Value": [-25.291521921917]},
        "3827": {"vr": "DS", "Value": [-70.291520021976]},
        "3828": {"vr": "DS", "Value": [-40.291521169144]},
        "3829": {"vr": "DS", "Value": [29.708477037655]},
        "3830": {"vr": "DS", "Value": [-27.791521970406]},
        "3831": {"vr": "DS", "Value": [-40.291521169144]},
        "3832": {"vr": "DS", "Value": [12.208477537152]},
        "3833": {"vr": "DS", "Value": [4.7084775923224]},
        "3834": {"vr": "DS", "Value": [17.208478043704]},
        "3835": {"vr": "DS", "Value": [27.208476784379]},
        "3836": {"vr": "DS", "Value": [67.208476291936]},
        "3837": {"vr": "DS", "Value": [4.7084775923224]},
        "3838": {"vr": "DS", "Value": [-55.291522484013]},
        "3839": {"vr": "DS", "Value": [-40.291521169144]},
        "3840": {"vr": "DS", "Value": [-30.291520360827]},
        "3841": {"vr": "DS", "Value": [-47.791521826579]},
        "3842": {"vr": "DS", "Value": [-65.291519566621]},
        "3843": {"vr": "DS", "Value": [-20.291521415365]},
        "3844": {"vr": "DS", "Value": [-62.791519415738]},
        "3845": {"vr": "DS", "Value": [29.708477037655]},
        "3846": {"vr": "DS", "Value": [-40.291521169144]},
        "3847": {"vr": "DS", "Value": [57.208479414116]},
        "3848": {"vr": "DS", "Value": [9.7084777495894]},
        "3849": {"vr": "DS", "Value": [12.208477537152]},
        "3850": {"vr": "DS", "Value": [72.208476798488]},
        "3851": {"vr": "DS", "Value": [47.208478401012]},
        "3852": {"vr": "DS", "Value": [62.208476194959]},
        "3853": {"vr": "DS", "Value": [52.208478907564]},
        "3854": {"vr": "DS", "Value": [72.208476798488]},
        "3855": {"vr": "DS", "Value": [39.708478050759]},
        "3856": {"vr": "DS", "Value": [-22.791521668641]},
        "3857": {"vr": "DS", "Value": [49.708478654288]},
        "3858": {"vr": "DS", "Value": [64.70847603866]},
        "3859": {"vr": "DS", "Value": [39.708478050759]},
        "3860": {"vr": "DS", "Value": [-0.2915219225125]},
        "3861": {"vr": "DS", "Value": [12.208477537152]},
        "3862": {"vr": "DS", "Value": [69.708476545212]},
        "3863": {"vr": "DS", "Value": [-55.291522484013]},
        "3864": {"vr": "DS", "Value": [39.708478050759]},
        "3865": {"vr": "DS", "Value": [2.2084775719032]},
        "3866": {"vr": "DS", "Value": [-47.791521826579]},
        "3867": {"vr": "DS", "Value": [-7.7915222166271]},
        "3868": {"vr": "DS", "Value": [14.708477790428]},
        "3869": {"vr": "DS", "Value": [-47.791521826579]},
        "3870": {"vr": "DS", "Value": [-55.291522484013]},
        "3871": {"vr": "DS", "Value": [-0.2915219225125]},
        "3872": {"vr": "DS", "Value": [-52.791522230737]},
        "3873": {"vr": "DS", "Value": [-50.291522079855]},
        "3874": {"vr": "DS", "Value": [62.208476194959]},
        "3875": {"vr": "DS", "Value": [-2.7915221757886]},
        "3876": {"vr": "DS", "Value": [-40.291521169144]},
        "3877": {"vr": "DS", "Value": [62.208476194959]},
        "3878": {"vr": "DS", "Value": [-42.79152142242]},
        "3879": {"vr": "DS", "Value": [14.708477790428]},
        "3880": {"vr": "DS", "Value": [-67.791519819897]},
        "3881": {"vr": "DS", "Value": [52.208478907564]},
        "3882": {"vr": "DS", "Value": [72.208476798488]},
        "3883": {"vr": "DS", "Value": [-30.291520360827]},
        "3884": {"vr": "DS", "Value": [-55.291522484013]},
        "3885": {"vr": "DS", "Value": [44.708478557311]},
        "3886": {"vr": "DS", "Value": [-72.791520224055]},
        "3887": {"vr": "DS", "Value": [12.208477537152]},
        "3888": {"vr": "DS", "Value": [32.208477290931]},
        "3889": {"vr": "DS", "Value": [-52.791522230737]},
        "3890": {"vr": "DS", "Value": [64.70847603866]},
        "3891": {"vr": "DS", "Value": [42.208478304035]},
        "3892": {"vr": "DS", "Value": [-55.291522484013]},
        "3893": {"vr": "DS", "Value": [64.70847603866]},
        "3894": {"vr": "DS", "Value": [-22.791521668641]},
        "3895": {"vr": "DS", "Value": [-10.291522469903]},
        "3896": {"vr": "DS", "Value": [-12.791522723179]},
        "3897": {"vr": "DS", "Value": [-60.291522888171]},
        "3898": {"vr": "DS", "Value": [-65.291519566621]},
        "3899": {"vr": "DS", "Value": [-25.291521921917]},
        "3900": {"vr": "DS", "Value": [14.708477790428]},
        "3901": {"vr": "DS", "Value": [49.708478654288]},
        "3902": {"vr": "DS", "Value": [52.208478907564]},
        "3903": {"vr": "DS", "Value": [-27.791521970406]},
        "3904": {"vr": "DS", "Value": [7.2084777291701]},
        "3905": {"vr": "DS", "Value": [-15.291522976455]},
        "3906": {"vr": "DS", "Value": [-45.291521675696]},
        "3907": {"vr": "DS", "Value": [-47.791521826579]},
        "3908": {"vr": "DS", "Value": [27.208476784379]},
        "3909": {"vr": "DS", "Value": [39.708478050759]},
        "3910": {"vr": "DS", "Value": [-2.7915221757886]},
        "3911": {"vr": "DS", "Value": [59.708475941683]},
        "3912": {"vr": "DS", "Value": [-70.291520021976]},
        "3913": {"vr": "DS", "Value": [-2.7915221757886]},
        "3914": {"vr": "DS", "Value": [17.208478043704]},
        "3915": {"vr": "DS", "Value": [-30.291520360827]},
        "3916": {"vr": "DS", "Value": [59.708475941683]},
        "3917": {"vr": "DS", "Value": [-57.791522737289]},
        "3918": {"vr": "DS", "Value": [-35.29152086738]},
        "3919": {"vr": "DS", "Value": [-47.791521826579]},
        "3920": {"vr": "DS", "Value": [39.708478050759]},
        "3921": {"vr": "DS", "Value": [4.7084775923224]},
        "3922": {"vr": "DS", "Value": [-60.291522888171]},
        "3923": {"vr": "DS", "Value": [59.708475941683]},
        "3924": {"vr": "DS", "Value": [-5.291521963351]},
        "3925": {"vr": "DS", "Value": [47.208478401012]},
        "3926": {"vr": "DS", "Value": [72.208476798488]},
        "3927": {"vr": "DS", "Value": [34.708477544207]},
        "3928": {"vr": "DS", "Value": [-37.791521120656]},
        "3929": {"vr": "DS", "Value": [39.708478050759]},
        "3930": {"vr": "DS", "Value": [44.708478557311]},
        "3931": {"vr": "DS", "Value": [-7.7915222166271]},
        "3932": {"vr": "DS", "Value": [39.708478050759]},
        "3933": {"vr": "DS", "Value": [37.208477797483]},
        "3934": {"vr": "DS", "Value": [-40.291521169144]},
        "3935": {"vr": "DS", "Value": [-2.7915221757886]},
        "3936": {"vr": "DS", "Value": [2.2084775719032]},
        "3937": {"vr": "DS", "Value": [-42.79152142242]},
        "3938": {"vr": "DS", "Value": [-27.791521970406]},
        "3939": {"vr": "DS", "Value": [42.208478304035]},
        "3940": {"vr": "DS", "Value": [24.708478393957]},
        "3941": {"vr": "DS", "Value": [-40.291521169144]},
        "3942": {"vr": "DS", "Value": [19.70847829698]},
        "3943": {"vr": "DS", "Value": [64.70847603866]},
        "3944": {"vr": "DS", "Value": [72.208476798488]},
        "3945": {"vr": "DS", "Value": [-47.791521826579]},
        "3946": {"vr": "DS", "Value": [-62.791519415738]},
        "3947": {"vr": "DS", "Value": [47.208478401012]},
        "3948": {"vr": "DS", "Value": [-30.291520360827]},
        "3949": {"vr": "DS", "Value": [-30.291520360827]},
        "3950": {"vr": "DS", "Value": [39.708478050759]},
        "3951": {"vr": "DS", "Value": [29.708477037655]},
        "3952": {"vr": "DS", "Value": [-55.291522484013]},
        "3953": {"vr": "DS", "Value": [17.208478043704]},
        "3954": {"vr": "DS", "Value": [-27.791521970406]},
        "3955": {"vr": "DS", "Value": [-2.7915221757886]},
        "3956": {"vr": "DS", "Value": [-55.291522484013]},
        "3957": {"vr": "DS", "Value": [-17.791523024944]},
        "3958": {"vr": "DS", "Value": [39.708478050759]},
        "3959": {"vr": "DS", "Value": [64.70847603866]},
        "3960": {"vr": "DS", "Value": [47.208478401012]},
        "3961": {"vr": "DS", "Value": [59.708475941683]},
        "3962": {"vr": "DS", "Value": [-37.791521120656]},
        "3963": {"vr": "DS", "Value": [-17.791523024944]},
        "3964": {"vr": "DS", "Value": [-40.291521169144]},
        "3965": {"vr": "DS", "Value": [-27.791521970406]},
        "3966": {"vr": "DS", "Value": [64.70847603866]},
        "3967": {"vr": "DS", "Value": [44.708478557311]},
        "3968": {"vr": "DS", "Value": [17.208478043704]},
        "3969": {"vr": "DS", "Value": [72.208476798488]},
        "3970": {"vr": "DS", "Value": [12.208477537152]},
        "3971": {"vr": "DS", "Value": [54.70847916084]},
        "3972": {"vr": "DS", "Value": [-52.791522230737]},
        "3973": {"vr": "DS", "Value": [57.208479414116]},
        "3974": {"vr": "DS", "Value": [-62.791519415738]},
        "3975": {"vr": "DS", "Value": [-10.291522469903]},
        "3976": {"vr": "DS", "Value": [32.208477290931]},
        "3977": {"vr": "DS", "Value": [57.208479414116]},
        "3978": {"vr": "DS", "Value": [52.208478907564]},
        "3979": {"vr": "DS", "Value": [-37.791521120656]},
        "3980": {"vr": "DS", "Value": [74.708477051764]},
        "3981": {"vr": "DS", "Value": [52.208478907564]},
        "3982": {"vr": "DS", "Value": [27.208476784379]},
        "3983": {"vr": "DS", "Value": [-12.791522723179]},
        "3984": {"vr": "DS", "Value": [-32.791520614104]},
        "3985": {"vr": "DS", "Value": [-67.791519819897]},
        "3986": {"vr": "DS", "Value": [37.208477797483]},
        "3987": {"vr": "DS", "Value": [-0.2915219225125]},
        "3988": {"vr": "DS", "Value": [42.208478304035]},
        "3989": {"vr": "DS", "Value": [29.708477037655]},
        "3990": {"vr": "DS", "Value": [9.7084777495894]},
        "3991": {"vr": "DS", "Value": [37.208477797483]},
        "3992": {"vr": "DS", "Value": [12.208477537152]},
        "3993": {"vr": "DS", "Value": [59.708475941683]},
        "3994": {"vr": "DS", "Value": [-17.791523024944]},
        "3995": {"vr": "DS", "Value": [-40.291521169144]},
        "3996": {"vr": "DS", "Value": [-37.791521120656]},
        "3997": {"vr": "DS", "Value": [49.708478654288]},
        "3998": {"vr": "DS", "Value": [-47.791521826579]},
        "3999": {"vr": "DS", "Value": [27.208476784379]},
        "4000": {"vr": "DS", "Value": [39.708478050759]},
        "4001": {"vr": "DS", "Value": [39.708478050759]},
        "4002": {"vr": "DS", "Value": [9.7084777495894]},
        "4003": {"vr": "DS", "Value": [74.708477051764]},
        "4004": {"vr": "DS", "Value": [-37.791521120656]},
        "4005": {"vr": "DS", "Value": [9.7084777495894]},
        "4006": {"vr": "DS", "Value": [-67.791519819897]},
        "4007": {"vr": "DS", "Value": [2.2084775719032]},
        "4008": {"vr": "DS", "Value": [-10.291522469903]},
        "4009": {"vr": "DS", "Value": [-55.291522484013]},
        "4010": {"vr": "DS", "Value": [64.70847603866]},
        "4011": {"vr": "DS", "Value": [49.708478654288]},
        "4012": {"vr": "DS", "Value": [44.708478557311]},
        "4013": {"vr": "DS", "Value": [29.708477037655]},
        "4014": {"vr": "DS", "Value": [-50.291522079855]},
        "4015": {"vr": "DS", "Value": [72.208476798488]},
        "4016": {"vr": "DS", "Value": [24.708478393957]},
        "4017": {"vr": "DS", "Value": [2.2084775719032]},
        "4018": {"vr": "DS", "Value": [-5.291521963351]},
        "4019": {"vr": "DS", "Value": [-22.791521668641]},
    },
    "00211103": {
        "0": {"vr": "DS", "Value": [22.5]},
        "1": {"vr": "DS", "Value": [20.0]},
        "2": {"vr": "DS", "Value": [22.5]},
        "3": {"vr": "DS", "Value": [22.5]},
        "4": {"vr": "DS", "Value": [20.0]},
        "5": {"vr": "DS", "Value": [20.0]},
        "6": {"vr": "DS", "Value": [20.0]},
        "7": {"vr": "DS", "Value": [22.5]},
        "8": {"vr": "DS", "Value": [20.0]},
        "9": {"vr": "DS", "Value": [22.5]},
        "10": {"vr": "DS", "Value": [20.0]},
        "11": {"vr": "DS", "Value": [20.0]},
        "12": {"vr": "DS", "Value": [20.0]},
        "13": {"vr": "DS", "Value": [22.5]},
        "14": {"vr": "DS", "Value": [22.5]},
        "15": {"vr": "DS", "Value": [22.5]},
        "16": {"vr": "DS", "Value": [22.5]},
        "17": {"vr": "DS", "Value": [22.5]},
        "18": {"vr": "DS", "Value": [20.0]},
        "19": {"vr": "DS", "Value": [22.5]},
        "20": {"vr": "DS", "Value": [22.5]},
        "21": {"vr": "DS", "Value": [22.5]},
        "22": {"vr": "DS", "Value": [22.5]},
        "23": {"vr": "DS", "Value": [20.0]},
        "24": {"vr": "DS", "Value": [20.0]},
        "25": {"vr": "DS", "Value": [22.5]},
        "26": {"vr": "DS", "Value": [20.0]},
        "27": {"vr": "DS", "Value": [20.0]},
        "28": {"vr": "DS", "Value": [20.0]},
        "29": {"vr": "DS", "Value": [22.5]},
        "30": {"vr": "DS", "Value": [20.0]},
        "31": {"vr": "DS", "Value": [20.0]},
        "32": {"vr": "DS", "Value": [20.0]},
        "33": {"vr": "DS", "Value": [22.5]},
        "34": {"vr": "DS", "Value": [22.5]},
        "35": {"vr": "DS", "Value": [22.5]},
        "36": {"vr": "DS", "Value": [22.5]},
        "37": {"vr": "DS", "Value": [22.5]},
        "38": {"vr": "DS", "Value": [22.5]},
        "39": {"vr": "DS", "Value": [20.0]},
        "40": {"vr": "DS", "Value": [22.5]},
        "41": {"vr": "DS", "Value": [20.0]},
        "42": {"vr": "DS", "Value": [22.5]},
        "43": {"vr": "DS", "Value": [22.5]},
        "44": {"vr": "DS", "Value": [20.0]},
        "45": {"vr": "DS", "Value": [20.0]},
        "46": {"vr": "DS", "Value": [20.0]},
        "47": {"vr": "DS", "Value": [22.5]},
        "48": {"vr": "DS", "Value": [22.5]},
        "49": {"vr": "DS", "Value": [20.0]},
        "50": {"vr": "DS", "Value": [20.0]},
        "51": {"vr": "DS", "Value": [20.0]},
        "52": {"vr": "DS", "Value": [20.0]},
        "53": {"vr": "DS", "Value": [20.0]},
        "54": {"vr": "DS", "Value": [22.5]},
        "55": {"vr": "DS", "Value": [22.5]},
        "56": {"vr": "DS", "Value": [20.0]},
        "57": {"vr": "DS", "Value": [20.0]},
        "58": {"vr": "DS", "Value": [20.0]},
        "59": {"vr": "DS", "Value": [22.5]},
        "60": {"vr": "DS", "Value": [22.5]},
        "61": {"vr": "DS", "Value": [22.5]},
        "62": {"vr": "DS", "Value": [22.5]},
        "63": {"vr": "DS", "Value": [22.5]},
        "64": {"vr": "DS", "Value": [20.0]},
        "65": {"vr": "DS", "Value": [22.5]},
        "66": {"vr": "DS", "Value": [20.0]},
        "67": {"vr": "DS", "Value": [20.0]},
        "68": {"vr": "DS", "Value": [22.5]},
        "69": {"vr": "DS", "Value": [20.0]},
        "70": {"vr": "DS", "Value": [20.0]},
        "71": {"vr": "DS", "Value": [20.0]},
        "72": {"vr": "DS", "Value": [22.5]},
        "73": {"vr": "DS", "Value": [20.0]},
        "74": {"vr": "DS", "Value": [22.5]},
        "75": {"vr": "DS", "Value": [20.0]},
        "76": {"vr": "DS", "Value": [20.0]},
        "77": {"vr": "DS", "Value": [20.0]},
        "78": {"vr": "DS", "Value": [20.0]},
        "79": {"vr": "DS", "Value": [20.0]},
        "80": {"vr": "DS", "Value": [22.5]},
        "81": {"vr": "DS", "Value": [20.0]},
        "82": {"vr": "DS", "Value": [20.0]},
        "83": {"vr": "DS", "Value": [22.5]},
        "84": {"vr": "DS", "Value": [22.5]},
        "85": {"vr": "DS", "Value": [22.5]},
        "86": {"vr": "DS", "Value": [20.0]},
        "87": {"vr": "DS", "Value": [22.5]},
        "88": {"vr": "DS", "Value": [22.5]},
        "89": {"vr": "DS", "Value": [20.0]},
        "90": {"vr": "DS", "Value": [20.0]},
        "91": {"vr": "DS", "Value": [20.0]},
        "92": {"vr": "DS", "Value": [22.5]},
        "93": {"vr": "DS", "Value": [20.0]},
        "94": {"vr": "DS", "Value": [20.0]},
        "95": {"vr": "DS", "Value": [20.0]},
        "96": {"vr": "DS", "Value": [20.0]},
        "97": {"vr": "DS", "Value": [20.0]},
        "98": {"vr": "DS", "Value": [20.0]},
        "99": {"vr": "DS", "Value": [22.5]},
        "100": {"vr": "DS", "Value": [22.5]},
        "101": {"vr": "DS", "Value": [22.5]},
        "102": {"vr": "DS", "Value": [20.0]},
        "103": {"vr": "DS", "Value": [20.0]},
        "104": {"vr": "DS", "Value": [22.5]},
        "105": {"vr": "DS", "Value": [22.5]},
        "106": {"vr": "DS", "Value": [20.0]},
        "107": {"vr": "DS", "Value": [20.0]},
        "108": {"vr": "DS", "Value": [20.0]},
        "109": {"vr": "DS", "Value": [22.5]},
        "110": {"vr": "DS", "Value": [22.5]},
        "111": {"vr": "DS", "Value": [20.0]},
        "112": {"vr": "DS", "Value": [22.5]},
        "113": {"vr": "DS", "Value": [20.0]},
        "114": {"vr": "DS", "Value": [22.5]},
        "115": {"vr": "DS", "Value": [20.0]},
        "116": {"vr": "DS", "Value": [22.5]},
        "117": {"vr": "DS", "Value": [22.5]},
        "118": {"vr": "DS", "Value": [20.0]},
        "119": {"vr": "DS", "Value": [20.0]},
        "120": {"vr": "DS", "Value": [20.0]},
        "121": {"vr": "DS", "Value": [20.0]},
        "122": {"vr": "DS", "Value": [22.5]},
        "123": {"vr": "DS", "Value": [22.5]},
        "124": {"vr": "DS", "Value": [20.0]},
        "125": {"vr": "DS", "Value": [22.5]},
        "126": {"vr": "DS", "Value": [22.5]},
        "127": {"vr": "DS", "Value": [22.5]},
        "128": {"vr": "DS", "Value": [22.5]},
        "129": {"vr": "DS", "Value": [22.5]},
        "130": {"vr": "DS", "Value": [20.0]},
        "131": {"vr": "DS", "Value": [20.0]},
        "132": {"vr": "DS", "Value": [22.5]},
        "133": {"vr": "DS", "Value": [20.0]},
        "134": {"vr": "DS", "Value": [20.0]},
        "135": {"vr": "DS", "Value": [22.5]},
        "136": {"vr": "DS", "Value": [22.5]},
        "137": {"vr": "DS", "Value": [20.0]},
        "138": {"vr": "DS", "Value": [22.5]},
        "139": {"vr": "DS", "Value": [20.0]},
        "140": {"vr": "DS", "Value": [20.0]},
        "141": {"vr": "DS", "Value": [22.5]},
        "142": {"vr": "DS", "Value": [22.5]},
        "143": {"vr": "DS", "Value": [22.5]},
        "144": {"vr": "DS", "Value": [22.5]},
        "145": {"vr": "DS", "Value": [20.0]},
        "146": {"vr": "DS", "Value": [22.5]},
        "147": {"vr": "DS", "Value": [20.0]},
        "148": {"vr": "DS", "Value": [20.0]},
        "149": {"vr": "DS", "Value": [22.5]},
        "150": {"vr": "DS", "Value": [22.5]},
        "151": {"vr": "DS", "Value": [20.0]},
        "152": {"vr": "DS", "Value": [20.0]},
        "153": {"vr": "DS", "Value": [22.5]},
        "154": {"vr": "DS", "Value": [22.5]},
        "155": {"vr": "DS", "Value": [20.0]},
        "156": {"vr": "DS", "Value": [20.0]},
        "157": {"vr": "DS", "Value": [22.5]},
        "158": {"vr": "DS", "Value": [22.5]},
        "159": {"vr": "DS", "Value": [22.5]},
        "160": {"vr": "DS", "Value": [22.5]},
        "161": {"vr": "DS", "Value": [20.0]},
        "162": {"vr": "DS", "Value": [20.0]},
        "163": {"vr": "DS", "Value": [22.5]},
        "164": {"vr": "DS", "Value": [20.0]},
        "165": {"vr": "DS", "Value": [22.5]},
        "166": {"vr": "DS", "Value": [20.0]},
        "167": {"vr": "DS", "Value": [22.5]},
        "168": {"vr": "DS", "Value": [20.0]},
        "169": {"vr": "DS", "Value": [22.5]},
        "170": {"vr": "DS", "Value": [22.5]},
        "171": {"vr": "DS", "Value": [20.0]},
        "172": {"vr": "DS", "Value": [20.0]},
        "173": {"vr": "DS", "Value": [22.5]},
        "174": {"vr": "DS", "Value": [22.5]},
        "175": {"vr": "DS", "Value": [20.0]},
        "176": {"vr": "DS", "Value": [22.5]},
        "177": {"vr": "DS", "Value": [20.0]},
        "178": {"vr": "DS", "Value": [20.0]},
        "179": {"vr": "DS", "Value": [22.5]},
        "180": {"vr": "DS", "Value": [20.0]},
        "181": {"vr": "DS", "Value": [20.0]},
        "182": {"vr": "DS", "Value": [20.0]},
        "183": {"vr": "DS", "Value": [22.5]},
        "184": {"vr": "DS", "Value": [22.5]},
        "185": {"vr": "DS", "Value": [22.5]},
        "186": {"vr": "DS", "Value": [20.0]},
        "187": {"vr": "DS", "Value": [22.5]},
        "188": {"vr": "DS", "Value": [22.5]},
        "189": {"vr": "DS", "Value": [22.5]},
        "190": {"vr": "DS", "Value": [22.5]},
        "191": {"vr": "DS", "Value": [22.5]},
        "192": {"vr": "DS", "Value": [20.0]},
        "193": {"vr": "DS", "Value": [20.0]},
        "194": {"vr": "DS", "Value": [22.5]},
        "195": {"vr": "DS", "Value": [20.0]},
        "196": {"vr": "DS", "Value": [20.0]},
        "197": {"vr": "DS", "Value": [20.0]},
        "198": {"vr": "DS", "Value": [20.0]},
        "199": {"vr": "DS", "Value": [20.0]},
        "200": {"vr": "DS", "Value": [22.5]},
        "201": {"vr": "DS", "Value": [20.0]},
        "202": {"vr": "DS", "Value": [22.5]},
        "203": {"vr": "DS", "Value": [22.5]},
        "204": {"vr": "DS", "Value": [22.5]},
        "205": {"vr": "DS", "Value": [20.0]},
        "206": {"vr": "DS", "Value": [20.0]},
        "207": {"vr": "DS", "Value": [22.5]},
        "208": {"vr": "DS", "Value": [20.0]},
        "209": {"vr": "DS", "Value": [20.0]},
        "210": {"vr": "DS", "Value": [20.0]},
        "211": {"vr": "DS", "Value": [20.0]},
        "212": {"vr": "DS", "Value": [22.5]},
        "213": {"vr": "DS", "Value": [20.0]},
        "214": {"vr": "DS", "Value": [22.5]},
        "215": {"vr": "DS", "Value": [20.0]},
        "216": {"vr": "DS", "Value": [22.5]},
        "217": {"vr": "DS", "Value": [20.0]},
        "218": {"vr": "DS", "Value": [22.5]},
        "219": {"vr": "DS", "Value": [22.5]},
        "220": {"vr": "DS", "Value": [20.0]},
        "221": {"vr": "DS", "Value": [20.0]},
        "222": {"vr": "DS", "Value": [20.0]},
        "223": {"vr": "DS", "Value": [22.5]},
        "224": {"vr": "DS", "Value": [22.5]},
        "225": {"vr": "DS", "Value": [22.5]},
        "226": {"vr": "DS", "Value": [20.0]},
        "227": {"vr": "DS", "Value": [22.5]},
        "228": {"vr": "DS", "Value": [22.5]},
        "229": {"vr": "DS", "Value": [20.0]},
        "230": {"vr": "DS", "Value": [20.0]},
        "231": {"vr": "DS", "Value": [20.0]},
        "232": {"vr": "DS", "Value": [22.5]},
        "233": {"vr": "DS", "Value": [22.5]},
        "234": {"vr": "DS", "Value": [22.5]},
        "235": {"vr": "DS", "Value": [20.0]},
        "236": {"vr": "DS", "Value": [20.0]},
        "237": {"vr": "DS", "Value": [22.5]},
        "238": {"vr": "DS", "Value": [20.0]},
        "239": {"vr": "DS", "Value": [20.0]},
        "240": {"vr": "DS", "Value": [22.5]},
        "241": {"vr": "DS", "Value": [22.5]},
        "242": {"vr": "DS", "Value": [22.5]},
        "243": {"vr": "DS", "Value": [22.5]},
        "244": {"vr": "DS", "Value": [20.0]},
        "245": {"vr": "DS", "Value": [22.5]},
        "246": {"vr": "DS", "Value": [20.0]},
        "247": {"vr": "DS", "Value": [22.5]},
        "248": {"vr": "DS", "Value": [22.5]},
        "249": {"vr": "DS", "Value": [20.0]},
        "250": {"vr": "DS", "Value": [22.5]},
        "251": {"vr": "DS", "Value": [20.0]},
        "252": {"vr": "DS", "Value": [20.0]},
        "253": {"vr": "DS", "Value": [22.5]},
        "254": {"vr": "DS", "Value": [22.5]},
        "255": {"vr": "DS", "Value": [22.5]},
        "256": {"vr": "DS", "Value": [20.0]},
        "257": {"vr": "DS", "Value": [22.5]},
        "258": {"vr": "DS", "Value": [22.5]},
        "259": {"vr": "DS", "Value": [22.5]},
        "260": {"vr": "DS", "Value": [20.0]},
        "261": {"vr": "DS", "Value": [22.5]},
        "262": {"vr": "DS", "Value": [20.0]},
        "263": {"vr": "DS", "Value": [22.5]},
        "264": {"vr": "DS", "Value": [22.5]},
        "265": {"vr": "DS", "Value": [22.5]},
        "266": {"vr": "DS", "Value": [20.0]},
        "267": {"vr": "DS", "Value": [20.0]},
        "268": {"vr": "DS", "Value": [22.5]},
        "269": {"vr": "DS", "Value": [22.5]},
        "270": {"vr": "DS", "Value": [22.5]},
        "271": {"vr": "DS", "Value": [22.5]},
        "272": {"vr": "DS", "Value": [22.5]},
        "273": {"vr": "DS", "Value": [20.0]},
        "274": {"vr": "DS", "Value": [22.5]},
        "275": {"vr": "DS", "Value": [22.5]},
        "276": {"vr": "DS", "Value": [22.5]},
        "277": {"vr": "DS", "Value": [22.5]},
        "278": {"vr": "DS", "Value": [22.5]},
        "279": {"vr": "DS", "Value": [22.5]},
        "280": {"vr": "DS", "Value": [20.0]},
        "281": {"vr": "DS", "Value": [22.5]},
        "282": {"vr": "DS", "Value": [20.0]},
        "283": {"vr": "DS", "Value": [20.0]},
        "284": {"vr": "DS", "Value": [20.0]},
        "285": {"vr": "DS", "Value": [22.5]},
        "286": {"vr": "DS", "Value": [22.5]},
        "287": {"vr": "DS", "Value": [22.5]},
        "288": {"vr": "DS", "Value": [20.0]},
        "289": {"vr": "DS", "Value": [22.5]},
        "290": {"vr": "DS", "Value": [20.0]},
        "291": {"vr": "DS", "Value": [20.0]},
        "292": {"vr": "DS", "Value": [22.5]},
        "293": {"vr": "DS", "Value": [22.5]},
        "294": {"vr": "DS", "Value": [22.5]},
        "295": {"vr": "DS", "Value": [20.0]},
        "296": {"vr": "DS", "Value": [20.0]},
        "297": {"vr": "DS", "Value": [20.0]},
        "298": {"vr": "DS", "Value": [20.0]},
        "299": {"vr": "DS", "Value": [22.5]},
        "300": {"vr": "DS", "Value": [20.0]},
        "301": {"vr": "DS", "Value": [22.5]},
        "302": {"vr": "DS", "Value": [22.5]},
        "303": {"vr": "DS", "Value": [20.0]},
        "304": {"vr": "DS", "Value": [20.0]},
        "305": {"vr": "DS", "Value": [22.5]},
        "306": {"vr": "DS", "Value": [22.5]},
        "307": {"vr": "DS", "Value": [20.0]},
        "308": {"vr": "DS", "Value": [20.0]},
        "309": {"vr": "DS", "Value": [22.5]},
        "310": {"vr": "DS", "Value": [22.5]},
        "311": {"vr": "DS", "Value": [20.0]},
        "312": {"vr": "DS", "Value": [22.5]},
        "313": {"vr": "DS", "Value": [20.0]},
        "314": {"vr": "DS", "Value": [20.0]},
        "315": {"vr": "DS", "Value": [20.0]},
        "316": {"vr": "DS", "Value": [20.0]},
        "317": {"vr": "DS", "Value": [22.5]},
        "318": {"vr": "DS", "Value": [20.0]},
        "319": {"vr": "DS", "Value": [22.5]},
        "320": {"vr": "DS", "Value": [22.5]},
        "321": {"vr": "DS", "Value": [22.5]},
        "322": {"vr": "DS", "Value": [22.5]},
        "323": {"vr": "DS", "Value": [20.0]},
        "324": {"vr": "DS", "Value": [22.5]},
        "325": {"vr": "DS", "Value": [20.0]},
        "326": {"vr": "DS", "Value": [22.5]},
        "327": {"vr": "DS", "Value": [22.5]},
        "328": {"vr": "DS", "Value": [20.0]},
        "329": {"vr": "DS", "Value": [20.0]},
        "330": {"vr": "DS", "Value": [22.5]},
        "331": {"vr": "DS", "Value": [20.0]},
        "332": {"vr": "DS", "Value": [20.0]},
        "333": {"vr": "DS", "Value": [22.5]},
        "334": {"vr": "DS", "Value": [20.0]},
        "335": {"vr": "DS", "Value": [22.5]},
        "336": {"vr": "DS", "Value": [22.5]},
        "337": {"vr": "DS", "Value": [22.5]},
        "338": {"vr": "DS", "Value": [22.5]},
        "339": {"vr": "DS", "Value": [22.5]},
        "340": {"vr": "DS", "Value": [20.0]},
        "341": {"vr": "DS", "Value": [20.0]},
        "342": {"vr": "DS", "Value": [22.5]},
        "343": {"vr": "DS", "Value": [20.0]},
        "344": {"vr": "DS", "Value": [22.5]},
        "345": {"vr": "DS", "Value": [22.5]},
        "346": {"vr": "DS", "Value": [22.5]},
        "347": {"vr": "DS", "Value": [20.0]},
        "348": {"vr": "DS", "Value": [22.5]},
        "349": {"vr": "DS", "Value": [22.5]},
        "350": {"vr": "DS", "Value": [22.5]},
        "351": {"vr": "DS", "Value": [20.0]},
        "352": {"vr": "DS", "Value": [22.5]},
        "353": {"vr": "DS", "Value": [20.0]},
        "354": {"vr": "DS", "Value": [22.5]},
        "355": {"vr": "DS", "Value": [22.5]},
        "356": {"vr": "DS", "Value": [22.5]},
        "357": {"vr": "DS", "Value": [22.5]},
        "358": {"vr": "DS", "Value": [20.0]},
        "359": {"vr": "DS", "Value": [20.0]},
        "360": {"vr": "DS", "Value": [20.0]},
        "361": {"vr": "DS", "Value": [22.5]},
        "362": {"vr": "DS", "Value": [22.5]},
        "363": {"vr": "DS", "Value": [22.5]},
        "364": {"vr": "DS", "Value": [20.0]},
        "365": {"vr": "DS", "Value": [20.0]},
        "366": {"vr": "DS", "Value": [22.5]},
        "367": {"vr": "DS", "Value": [22.5]},
        "368": {"vr": "DS", "Value": [22.5]},
        "369": {"vr": "DS", "Value": [22.5]},
        "370": {"vr": "DS", "Value": [20.0]},
        "371": {"vr": "DS", "Value": [20.0]},
        "372": {"vr": "DS", "Value": [20.0]},
        "373": {"vr": "DS", "Value": [22.5]},
        "374": {"vr": "DS", "Value": [20.0]},
        "375": {"vr": "DS", "Value": [22.5]},
        "376": {"vr": "DS", "Value": [22.5]},
        "377": {"vr": "DS", "Value": [22.5]},
        "378": {"vr": "DS", "Value": [20.0]},
        "379": {"vr": "DS", "Value": [20.0]},
        "380": {"vr": "DS", "Value": [22.5]},
        "381": {"vr": "DS", "Value": [22.5]},
        "382": {"vr": "DS", "Value": [20.0]},
        "383": {"vr": "DS", "Value": [22.5]},
        "384": {"vr": "DS", "Value": [22.5]},
        "385": {"vr": "DS", "Value": [20.0]},
        "386": {"vr": "DS", "Value": [22.5]},
        "387": {"vr": "DS", "Value": [22.5]},
        "388": {"vr": "DS", "Value": [20.0]},
        "389": {"vr": "DS", "Value": [20.0]},
        "390": {"vr": "DS", "Value": [22.5]},
        "391": {"vr": "DS", "Value": [22.5]},
        "392": {"vr": "DS", "Value": [22.5]},
        "393": {"vr": "DS", "Value": [22.5]},
        "394": {"vr": "DS", "Value": [22.5]},
        "395": {"vr": "DS", "Value": [20.0]},
        "396": {"vr": "DS", "Value": [20.0]},
        "397": {"vr": "DS", "Value": [20.0]},
        "398": {"vr": "DS", "Value": [22.5]},
        "399": {"vr": "DS", "Value": [22.5]},
        "400": {"vr": "DS", "Value": [20.0]},
        "401": {"vr": "DS", "Value": [20.0]},
        "402": {"vr": "DS", "Value": [22.5]},
        "403": {"vr": "DS", "Value": [20.0]},
        "404": {"vr": "DS", "Value": [20.0]},
        "405": {"vr": "DS", "Value": [22.5]},
        "406": {"vr": "DS", "Value": [20.0]},
        "407": {"vr": "DS", "Value": [22.5]},
        "408": {"vr": "DS", "Value": [22.5]},
        "409": {"vr": "DS", "Value": [20.0]},
        "410": {"vr": "DS", "Value": [22.5]},
        "411": {"vr": "DS", "Value": [20.0]},
        "412": {"vr": "DS", "Value": [20.0]},
        "413": {"vr": "DS", "Value": [22.5]},
        "414": {"vr": "DS", "Value": [20.0]},
        "415": {"vr": "DS", "Value": [22.5]},
        "416": {"vr": "DS", "Value": [20.0]},
        "417": {"vr": "DS", "Value": [22.5]},
        "418": {"vr": "DS", "Value": [22.5]},
        "419": {"vr": "DS", "Value": [22.5]},
        "420": {"vr": "DS", "Value": [22.5]},
        "421": {"vr": "DS", "Value": [20.0]},
        "422": {"vr": "DS", "Value": [20.0]},
        "423": {"vr": "DS", "Value": [22.5]},
        "424": {"vr": "DS", "Value": [22.5]},
        "425": {"vr": "DS", "Value": [22.5]},
        "426": {"vr": "DS", "Value": [20.0]},
        "427": {"vr": "DS", "Value": [20.0]},
        "428": {"vr": "DS", "Value": [20.0]},
        "429": {"vr": "DS", "Value": [20.0]},
        "430": {"vr": "DS", "Value": [22.5]},
        "431": {"vr": "DS", "Value": [22.5]},
        "432": {"vr": "DS", "Value": [20.0]},
        "433": {"vr": "DS", "Value": [22.5]},
        "434": {"vr": "DS", "Value": [20.0]},
        "435": {"vr": "DS", "Value": [22.5]},
        "436": {"vr": "DS", "Value": [22.5]},
        "437": {"vr": "DS", "Value": [20.0]},
        "438": {"vr": "DS", "Value": [22.5]},
        "439": {"vr": "DS", "Value": [20.0]},
        "440": {"vr": "DS", "Value": [22.5]},
        "441": {"vr": "DS", "Value": [22.5]},
        "442": {"vr": "DS", "Value": [22.5]},
        "443": {"vr": "DS", "Value": [22.5]},
        "444": {"vr": "DS", "Value": [22.5]},
        "445": {"vr": "DS", "Value": [22.5]},
        "446": {"vr": "DS", "Value": [20.0]},
        "447": {"vr": "DS", "Value": [22.5]},
        "448": {"vr": "DS", "Value": [22.5]},
        "449": {"vr": "DS", "Value": [22.5]},
        "450": {"vr": "DS", "Value": [20.0]},
        "451": {"vr": "DS", "Value": [22.5]},
        "452": {"vr": "DS", "Value": [22.5]},
        "453": {"vr": "DS", "Value": [22.5]},
        "454": {"vr": "DS", "Value": [20.0]},
        "455": {"vr": "DS", "Value": [20.0]},
        "456": {"vr": "DS", "Value": [22.5]},
        "457": {"vr": "DS", "Value": [20.0]},
        "458": {"vr": "DS", "Value": [20.0]},
        "459": {"vr": "DS", "Value": [20.0]},
        "460": {"vr": "DS", "Value": [22.5]},
        "461": {"vr": "DS", "Value": [22.5]},
        "462": {"vr": "DS", "Value": [22.5]},
        "463": {"vr": "DS", "Value": [20.0]},
        "464": {"vr": "DS", "Value": [20.0]},
        "465": {"vr": "DS", "Value": [20.0]},
        "466": {"vr": "DS", "Value": [22.5]},
        "467": {"vr": "DS", "Value": [22.5]},
        "468": {"vr": "DS", "Value": [20.0]},
        "469": {"vr": "DS", "Value": [22.5]},
        "470": {"vr": "DS", "Value": [22.5]},
        "471": {"vr": "DS", "Value": [20.0]},
        "472": {"vr": "DS", "Value": [20.0]},
        "473": {"vr": "DS", "Value": [22.5]},
        "474": {"vr": "DS", "Value": [22.5]},
        "475": {"vr": "DS", "Value": [22.5]},
        "476": {"vr": "DS", "Value": [20.0]},
        "477": {"vr": "DS", "Value": [22.5]},
        "478": {"vr": "DS", "Value": [20.0]},
        "479": {"vr": "DS", "Value": [22.5]},
        "480": {"vr": "DS", "Value": [20.0]},
        "481": {"vr": "DS", "Value": [22.5]},
        "482": {"vr": "DS", "Value": [22.5]},
        "483": {"vr": "DS", "Value": [20.0]},
        "484": {"vr": "DS", "Value": [20.0]},
        "485": {"vr": "DS", "Value": [22.5]},
        "486": {"vr": "DS", "Value": [20.0]},
        "487": {"vr": "DS", "Value": [20.0]},
        "488": {"vr": "DS", "Value": [20.0]},
        "489": {"vr": "DS", "Value": [22.5]},
        "490": {"vr": "DS", "Value": [20.0]},
        "491": {"vr": "DS", "Value": [20.0]},
        "492": {"vr": "DS", "Value": [22.5]},
        "493": {"vr": "DS", "Value": [20.0]},
        "494": {"vr": "DS", "Value": [20.0]},
        "495": {"vr": "DS", "Value": [20.0]},
        "496": {"vr": "DS", "Value": [20.0]},
        "497": {"vr": "DS", "Value": [20.0]},
        "498": {"vr": "DS", "Value": [22.5]},
        "499": {"vr": "DS", "Value": [20.0]},
        "500": {"vr": "DS", "Value": [20.0]},
        "501": {"vr": "DS", "Value": [20.0]},
        "502": {"vr": "DS", "Value": [22.5]},
        "503": {"vr": "DS", "Value": [20.0]},
        "504": {"vr": "DS", "Value": [20.0]},
        "505": {"vr": "DS", "Value": [22.5]},
        "506": {"vr": "DS", "Value": [22.5]},
        "507": {"vr": "DS", "Value": [20.0]},
        "508": {"vr": "DS", "Value": [22.5]},
        "509": {"vr": "DS", "Value": [22.5]},
        "510": {"vr": "DS", "Value": [20.0]},
        "511": {"vr": "DS", "Value": [20.0]},
        "512": {"vr": "DS", "Value": [22.5]},
        "513": {"vr": "DS", "Value": [22.5]},
        "514": {"vr": "DS", "Value": [22.5]},
        "515": {"vr": "DS", "Value": [20.0]},
        "516": {"vr": "DS", "Value": [20.0]},
        "517": {"vr": "DS", "Value": [22.5]},
        "518": {"vr": "DS", "Value": [20.0]},
        "519": {"vr": "DS", "Value": [20.0]},
        "520": {"vr": "DS", "Value": [20.0]},
        "521": {"vr": "DS", "Value": [22.5]},
        "522": {"vr": "DS", "Value": [20.0]},
        "523": {"vr": "DS", "Value": [20.0]},
        "524": {"vr": "DS", "Value": [20.0]},
        "525": {"vr": "DS", "Value": [22.5]},
        "526": {"vr": "DS", "Value": [20.0]},
        "527": {"vr": "DS", "Value": [22.5]},
        "528": {"vr": "DS", "Value": [22.5]},
        "529": {"vr": "DS", "Value": [20.0]},
        "530": {"vr": "DS", "Value": [22.5]},
        "531": {"vr": "DS", "Value": [22.5]},
        "532": {"vr": "DS", "Value": [20.0]},
        "533": {"vr": "DS", "Value": [22.5]},
        "534": {"vr": "DS", "Value": [20.0]},
        "535": {"vr": "DS", "Value": [20.0]},
        "536": {"vr": "DS", "Value": [22.5]},
        "537": {"vr": "DS", "Value": [20.0]},
        "538": {"vr": "DS", "Value": [20.0]},
        "539": {"vr": "DS", "Value": [20.0]},
        "540": {"vr": "DS", "Value": [22.5]},
        "541": {"vr": "DS", "Value": [22.5]},
        "542": {"vr": "DS", "Value": [22.5]},
        "543": {"vr": "DS", "Value": [22.5]},
        "544": {"vr": "DS", "Value": [22.5]},
        "545": {"vr": "DS", "Value": [22.5]},
        "546": {"vr": "DS", "Value": [22.5]},
        "547": {"vr": "DS", "Value": [22.5]},
        "548": {"vr": "DS", "Value": [22.5]},
        "549": {"vr": "DS", "Value": [20.0]},
        "550": {"vr": "DS", "Value": [22.5]},
        "551": {"vr": "DS", "Value": [22.5]},
        "552": {"vr": "DS", "Value": [20.0]},
        "553": {"vr": "DS", "Value": [20.0]},
        "554": {"vr": "DS", "Value": [22.5]},
        "555": {"vr": "DS", "Value": [22.5]},
        "556": {"vr": "DS", "Value": [20.0]},
        "557": {"vr": "DS", "Value": [20.0]},
        "558": {"vr": "DS", "Value": [20.0]},
        "559": {"vr": "DS", "Value": [20.0]},
        "560": {"vr": "DS", "Value": [22.5]},
        "561": {"vr": "DS", "Value": [20.0]},
        "562": {"vr": "DS", "Value": [22.5]},
        "563": {"vr": "DS", "Value": [22.5]},
        "564": {"vr": "DS", "Value": [20.0]},
        "565": {"vr": "DS", "Value": [20.0]},
        "566": {"vr": "DS", "Value": [22.5]},
        "567": {"vr": "DS", "Value": [20.0]},
        "568": {"vr": "DS", "Value": [20.0]},
        "569": {"vr": "DS", "Value": [22.5]},
        "570": {"vr": "DS", "Value": [20.0]},
        "571": {"vr": "DS", "Value": [20.0]},
        "572": {"vr": "DS", "Value": [20.0]},
        "573": {"vr": "DS", "Value": [20.0]},
        "574": {"vr": "DS", "Value": [22.5]},
        "575": {"vr": "DS", "Value": [22.5]},
        "576": {"vr": "DS", "Value": [22.5]},
        "577": {"vr": "DS", "Value": [20.0]},
        "578": {"vr": "DS", "Value": [22.5]},
        "579": {"vr": "DS", "Value": [22.5]},
        "580": {"vr": "DS", "Value": [22.5]},
        "581": {"vr": "DS", "Value": [20.0]},
        "582": {"vr": "DS", "Value": [20.0]},
        "583": {"vr": "DS", "Value": [20.0]},
        "584": {"vr": "DS", "Value": [22.5]},
        "585": {"vr": "DS", "Value": [20.0]},
        "586": {"vr": "DS", "Value": [22.5]},
        "587": {"vr": "DS", "Value": [20.0]},
        "588": {"vr": "DS", "Value": [22.5]},
        "589": {"vr": "DS", "Value": [20.0]},
        "590": {"vr": "DS", "Value": [22.5]},
        "591": {"vr": "DS", "Value": [22.5]},
        "592": {"vr": "DS", "Value": [20.0]},
        "593": {"vr": "DS", "Value": [22.5]},
        "594": {"vr": "DS", "Value": [20.0]},
        "595": {"vr": "DS", "Value": [22.5]},
        "596": {"vr": "DS", "Value": [22.5]},
        "597": {"vr": "DS", "Value": [22.5]},
        "598": {"vr": "DS", "Value": [22.5]},
        "599": {"vr": "DS", "Value": [22.5]},
        "600": {"vr": "DS", "Value": [22.5]},
        "601": {"vr": "DS", "Value": [22.5]},
        "602": {"vr": "DS", "Value": [22.5]},
        "603": {"vr": "DS", "Value": [20.0]},
        "604": {"vr": "DS", "Value": [20.0]},
        "605": {"vr": "DS", "Value": [20.0]},
        "606": {"vr": "DS", "Value": [20.0]},
        "607": {"vr": "DS", "Value": [20.0]},
        "608": {"vr": "DS", "Value": [20.0]},
        "609": {"vr": "DS", "Value": [20.0]},
        "610": {"vr": "DS", "Value": [20.0]},
        "611": {"vr": "DS", "Value": [20.0]},
        "612": {"vr": "DS", "Value": [22.5]},
        "613": {"vr": "DS", "Value": [20.0]},
        "614": {"vr": "DS", "Value": [22.5]},
        "615": {"vr": "DS", "Value": [22.5]},
        "616": {"vr": "DS", "Value": [20.0]},
        "617": {"vr": "DS", "Value": [20.0]},
        "618": {"vr": "DS", "Value": [22.5]},
        "619": {"vr": "DS", "Value": [22.5]},
        "620": {"vr": "DS", "Value": [22.5]},
        "621": {"vr": "DS", "Value": [22.5]},
        "622": {"vr": "DS", "Value": [20.0]},
        "623": {"vr": "DS", "Value": [22.5]},
        "624": {"vr": "DS", "Value": [20.0]},
        "625": {"vr": "DS", "Value": [22.5]},
        "626": {"vr": "DS", "Value": [22.5]},
        "627": {"vr": "DS", "Value": [20.0]},
        "628": {"vr": "DS", "Value": [22.5]},
        "629": {"vr": "DS", "Value": [20.0]},
        "630": {"vr": "DS", "Value": [22.5]},
        "631": {"vr": "DS", "Value": [22.5]},
        "632": {"vr": "DS", "Value": [22.5]},
        "633": {"vr": "DS", "Value": [22.5]},
        "634": {"vr": "DS", "Value": [20.0]},
        "635": {"vr": "DS", "Value": [20.0]},
        "636": {"vr": "DS", "Value": [20.0]},
        "637": {"vr": "DS", "Value": [22.5]},
        "638": {"vr": "DS", "Value": [20.0]},
        "639": {"vr": "DS", "Value": [20.0]},
        "640": {"vr": "DS", "Value": [22.5]},
        "641": {"vr": "DS", "Value": [20.0]},
        "642": {"vr": "DS", "Value": [20.0]},
        "643": {"vr": "DS", "Value": [22.5]},
        "644": {"vr": "DS", "Value": [22.5]},
        "645": {"vr": "DS", "Value": [22.5]},
        "646": {"vr": "DS", "Value": [22.5]},
        "647": {"vr": "DS", "Value": [22.5]},
        "648": {"vr": "DS", "Value": [22.5]},
        "649": {"vr": "DS", "Value": [22.5]},
        "650": {"vr": "DS", "Value": [20.0]},
        "651": {"vr": "DS", "Value": [22.5]},
        "652": {"vr": "DS", "Value": [20.0]},
        "653": {"vr": "DS", "Value": [20.0]},
        "654": {"vr": "DS", "Value": [22.5]},
        "655": {"vr": "DS", "Value": [22.5]},
        "656": {"vr": "DS", "Value": [20.0]},
        "657": {"vr": "DS", "Value": [20.0]},
        "658": {"vr": "DS", "Value": [22.5]},
        "659": {"vr": "DS", "Value": [22.5]},
        "660": {"vr": "DS", "Value": [20.0]},
        "661": {"vr": "DS", "Value": [22.5]},
        "662": {"vr": "DS", "Value": [20.0]},
        "663": {"vr": "DS", "Value": [22.5]},
        "664": {"vr": "DS", "Value": [22.5]},
        "665": {"vr": "DS", "Value": [22.5]},
        "666": {"vr": "DS", "Value": [22.5]},
        "667": {"vr": "DS", "Value": [20.0]},
        "668": {"vr": "DS", "Value": [20.0]},
        "669": {"vr": "DS", "Value": [20.0]},
        "670": {"vr": "DS", "Value": [20.0]},
        "671": {"vr": "DS", "Value": [20.0]},
        "672": {"vr": "DS", "Value": [22.5]},
        "673": {"vr": "DS", "Value": [20.0]},
        "674": {"vr": "DS", "Value": [20.0]},
        "675": {"vr": "DS", "Value": [20.0]},
        "676": {"vr": "DS", "Value": [22.5]},
        "677": {"vr": "DS", "Value": [20.0]},
        "678": {"vr": "DS", "Value": [20.0]},
        "679": {"vr": "DS", "Value": [20.0]},
        "680": {"vr": "DS", "Value": [20.0]},
        "681": {"vr": "DS", "Value": [20.0]},
        "682": {"vr": "DS", "Value": [22.5]},
        "683": {"vr": "DS", "Value": [22.5]},
        "684": {"vr": "DS", "Value": [22.5]},
        "685": {"vr": "DS", "Value": [22.5]},
        "686": {"vr": "DS", "Value": [20.0]},
        "687": {"vr": "DS", "Value": [22.5]},
        "688": {"vr": "DS", "Value": [22.5]},
        "689": {"vr": "DS", "Value": [20.0]},
        "690": {"vr": "DS", "Value": [20.0]},
        "691": {"vr": "DS", "Value": [22.5]},
        "692": {"vr": "DS", "Value": [20.0]},
        "693": {"vr": "DS", "Value": [20.0]},
        "694": {"vr": "DS", "Value": [22.5]},
        "695": {"vr": "DS", "Value": [22.5]},
        "696": {"vr": "DS", "Value": [22.5]},
        "697": {"vr": "DS", "Value": [22.5]},
        "698": {"vr": "DS", "Value": [22.5]},
        "699": {"vr": "DS", "Value": [22.5]},
        "700": {"vr": "DS", "Value": [20.0]},
        "701": {"vr": "DS", "Value": [20.0]},
        "702": {"vr": "DS", "Value": [20.0]},
        "703": {"vr": "DS", "Value": [20.0]},
        "704": {"vr": "DS", "Value": [20.0]},
        "705": {"vr": "DS", "Value": [20.0]},
        "706": {"vr": "DS", "Value": [22.5]},
        "707": {"vr": "DS", "Value": [20.0]},
        "708": {"vr": "DS", "Value": [20.0]},
        "709": {"vr": "DS", "Value": [20.0]},
        "710": {"vr": "DS", "Value": [20.0]},
        "711": {"vr": "DS", "Value": [20.0]},
        "712": {"vr": "DS", "Value": [22.5]},
        "713": {"vr": "DS", "Value": [22.5]},
        "714": {"vr": "DS", "Value": [22.5]},
        "715": {"vr": "DS", "Value": [20.0]},
        "716": {"vr": "DS", "Value": [20.0]},
        "717": {"vr": "DS", "Value": [20.0]},
        "718": {"vr": "DS", "Value": [20.0]},
        "719": {"vr": "DS", "Value": [22.5]},
        "720": {"vr": "DS", "Value": [20.0]},
        "721": {"vr": "DS", "Value": [22.5]},
        "722": {"vr": "DS", "Value": [20.0]},
        "723": {"vr": "DS", "Value": [22.5]},
        "724": {"vr": "DS", "Value": [20.0]},
        "725": {"vr": "DS", "Value": [22.5]},
        "726": {"vr": "DS", "Value": [20.0]},
        "727": {"vr": "DS", "Value": [22.5]},
        "728": {"vr": "DS", "Value": [22.5]},
        "729": {"vr": "DS", "Value": [20.0]},
        "730": {"vr": "DS", "Value": [22.5]},
        "731": {"vr": "DS", "Value": [20.0]},
        "732": {"vr": "DS", "Value": [22.5]},
        "733": {"vr": "DS", "Value": [22.5]},
        "734": {"vr": "DS", "Value": [22.5]},
        "735": {"vr": "DS", "Value": [20.0]},
        "736": {"vr": "DS", "Value": [22.5]},
        "737": {"vr": "DS", "Value": [20.0]},
        "738": {"vr": "DS", "Value": [22.5]},
        "739": {"vr": "DS", "Value": [22.5]},
        "740": {"vr": "DS", "Value": [20.0]},
        "741": {"vr": "DS", "Value": [22.5]},
        "742": {"vr": "DS", "Value": [20.0]},
        "743": {"vr": "DS", "Value": [20.0]},
        "744": {"vr": "DS", "Value": [22.5]},
        "745": {"vr": "DS", "Value": [20.0]},
        "746": {"vr": "DS", "Value": [20.0]},
        "747": {"vr": "DS", "Value": [22.5]},
        "748": {"vr": "DS", "Value": [22.5]},
        "749": {"vr": "DS", "Value": [22.5]},
        "750": {"vr": "DS", "Value": [20.0]},
        "751": {"vr": "DS", "Value": [20.0]},
        "752": {"vr": "DS", "Value": [22.5]},
        "753": {"vr": "DS", "Value": [22.5]},
        "754": {"vr": "DS", "Value": [20.0]},
        "755": {"vr": "DS", "Value": [20.0]},
        "756": {"vr": "DS", "Value": [20.0]},
        "757": {"vr": "DS", "Value": [22.5]},
        "758": {"vr": "DS", "Value": [22.5]},
        "759": {"vr": "DS", "Value": [22.5]},
        "760": {"vr": "DS", "Value": [20.0]},
        "761": {"vr": "DS", "Value": [22.5]},
        "762": {"vr": "DS", "Value": [20.0]},
        "763": {"vr": "DS", "Value": [20.0]},
        "764": {"vr": "DS", "Value": [20.0]},
        "765": {"vr": "DS", "Value": [20.0]},
        "766": {"vr": "DS", "Value": [20.0]},
        "767": {"vr": "DS", "Value": [20.0]},
        "768": {"vr": "DS", "Value": [22.5]},
        "769": {"vr": "DS", "Value": [22.5]},
        "770": {"vr": "DS", "Value": [22.5]},
        "771": {"vr": "DS", "Value": [22.5]},
        "772": {"vr": "DS", "Value": [22.5]},
        "773": {"vr": "DS", "Value": [22.5]},
        "774": {"vr": "DS", "Value": [20.0]},
        "775": {"vr": "DS", "Value": [20.0]},
        "776": {"vr": "DS", "Value": [22.5]},
        "777": {"vr": "DS", "Value": [20.0]},
        "778": {"vr": "DS", "Value": [22.5]},
        "779": {"vr": "DS", "Value": [20.0]},
        "780": {"vr": "DS", "Value": [20.0]},
        "781": {"vr": "DS", "Value": [22.5]},
        "782": {"vr": "DS", "Value": [20.0]},
        "783": {"vr": "DS", "Value": [22.5]},
        "784": {"vr": "DS", "Value": [22.5]},
        "785": {"vr": "DS", "Value": [22.5]},
        "786": {"vr": "DS", "Value": [20.0]},
        "787": {"vr": "DS", "Value": [20.0]},
        "788": {"vr": "DS", "Value": [22.5]},
        "789": {"vr": "DS", "Value": [22.5]},
        "790": {"vr": "DS", "Value": [22.5]},
        "791": {"vr": "DS", "Value": [20.0]},
        "792": {"vr": "DS", "Value": [22.5]},
        "793": {"vr": "DS", "Value": [20.0]},
        "794": {"vr": "DS", "Value": [22.5]},
        "795": {"vr": "DS", "Value": [22.5]},
        "796": {"vr": "DS", "Value": [22.5]},
        "797": {"vr": "DS", "Value": [20.0]},
        "798": {"vr": "DS", "Value": [22.5]},
        "799": {"vr": "DS", "Value": [22.5]},
        "800": {"vr": "DS", "Value": [22.5]},
        "801": {"vr": "DS", "Value": [20.0]},
        "802": {"vr": "DS", "Value": [22.5]},
        "803": {"vr": "DS", "Value": [20.0]},
        "804": {"vr": "DS", "Value": [22.5]},
        "805": {"vr": "DS", "Value": [22.5]},
        "806": {"vr": "DS", "Value": [22.5]},
        "807": {"vr": "DS", "Value": [20.0]},
        "808": {"vr": "DS", "Value": [22.5]},
        "809": {"vr": "DS", "Value": [20.0]},
        "810": {"vr": "DS", "Value": [22.5]},
        "811": {"vr": "DS", "Value": [22.5]},
        "812": {"vr": "DS", "Value": [22.5]},
        "813": {"vr": "DS", "Value": [20.0]},
        "814": {"vr": "DS", "Value": [20.0]},
        "815": {"vr": "DS", "Value": [22.5]},
        "816": {"vr": "DS", "Value": [20.0]},
        "817": {"vr": "DS", "Value": [20.0]},
        "818": {"vr": "DS", "Value": [20.0]},
        "819": {"vr": "DS", "Value": [22.5]},
        "820": {"vr": "DS", "Value": [20.0]},
        "821": {"vr": "DS", "Value": [20.0]},
        "822": {"vr": "DS", "Value": [22.5]},
        "823": {"vr": "DS", "Value": [20.0]},
        "824": {"vr": "DS", "Value": [20.0]},
        "825": {"vr": "DS", "Value": [22.5]},
        "826": {"vr": "DS", "Value": [22.5]},
        "827": {"vr": "DS", "Value": [22.5]},
        "828": {"vr": "DS", "Value": [22.5]},
        "829": {"vr": "DS", "Value": [22.5]},
        "830": {"vr": "DS", "Value": [20.0]},
        "831": {"vr": "DS", "Value": [22.5]},
        "832": {"vr": "DS", "Value": [22.5]},
        "833": {"vr": "DS", "Value": [22.5]},
        "834": {"vr": "DS", "Value": [20.0]},
        "835": {"vr": "DS", "Value": [20.0]},
        "836": {"vr": "DS", "Value": [20.0]},
        "837": {"vr": "DS", "Value": [22.5]},
        "838": {"vr": "DS", "Value": [20.0]},
        "839": {"vr": "DS", "Value": [20.0]},
        "840": {"vr": "DS", "Value": [20.0]},
        "841": {"vr": "DS", "Value": [22.5]},
        "842": {"vr": "DS", "Value": [22.5]},
        "843": {"vr": "DS", "Value": [22.5]},
        "844": {"vr": "DS", "Value": [20.0]},
        "845": {"vr": "DS", "Value": [20.0]},
        "846": {"vr": "DS", "Value": [22.5]},
        "847": {"vr": "DS", "Value": [20.0]},
        "848": {"vr": "DS", "Value": [20.0]},
        "849": {"vr": "DS", "Value": [22.5]},
        "850": {"vr": "DS", "Value": [20.0]},
        "851": {"vr": "DS", "Value": [22.5]},
        "852": {"vr": "DS", "Value": [20.0]},
        "853": {"vr": "DS", "Value": [20.0]},
        "854": {"vr": "DS", "Value": [22.5]},
        "855": {"vr": "DS", "Value": [22.5]},
        "856": {"vr": "DS", "Value": [20.0]},
        "857": {"vr": "DS", "Value": [22.5]},
        "858": {"vr": "DS", "Value": [20.0]},
        "859": {"vr": "DS", "Value": [20.0]},
        "860": {"vr": "DS", "Value": [20.0]},
        "861": {"vr": "DS", "Value": [22.5]},
        "862": {"vr": "DS", "Value": [20.0]},
        "863": {"vr": "DS", "Value": [20.0]},
        "864": {"vr": "DS", "Value": [20.0]},
        "865": {"vr": "DS", "Value": [20.0]},
        "866": {"vr": "DS", "Value": [22.5]},
        "867": {"vr": "DS", "Value": [22.5]},
        "868": {"vr": "DS", "Value": [22.5]},
        "869": {"vr": "DS", "Value": [20.0]},
        "870": {"vr": "DS", "Value": [22.5]},
        "871": {"vr": "DS", "Value": [22.5]},
        "872": {"vr": "DS", "Value": [20.0]},
        "873": {"vr": "DS", "Value": [22.5]},
        "874": {"vr": "DS", "Value": [20.0]},
        "875": {"vr": "DS", "Value": [20.0]},
        "876": {"vr": "DS", "Value": [20.0]},
        "877": {"vr": "DS", "Value": [22.5]},
        "878": {"vr": "DS", "Value": [20.0]},
        "879": {"vr": "DS", "Value": [20.0]},
        "880": {"vr": "DS", "Value": [22.5]},
        "881": {"vr": "DS", "Value": [20.0]},
        "882": {"vr": "DS", "Value": [22.5]},
        "883": {"vr": "DS", "Value": [22.5]},
        "884": {"vr": "DS", "Value": [22.5]},
        "885": {"vr": "DS", "Value": [22.5]},
        "886": {"vr": "DS", "Value": [22.5]},
        "887": {"vr": "DS", "Value": [22.5]},
        "888": {"vr": "DS", "Value": [22.5]},
        "889": {"vr": "DS", "Value": [20.0]},
        "890": {"vr": "DS", "Value": [20.0]},
        "891": {"vr": "DS", "Value": [22.5]},
        "892": {"vr": "DS", "Value": [20.0]},
        "893": {"vr": "DS", "Value": [20.0]},
        "894": {"vr": "DS", "Value": [20.0]},
        "895": {"vr": "DS", "Value": [22.5]},
        "896": {"vr": "DS", "Value": [20.0]},
        "897": {"vr": "DS", "Value": [20.0]},
        "898": {"vr": "DS", "Value": [22.5]},
        "899": {"vr": "DS", "Value": [22.5]},
        "900": {"vr": "DS", "Value": [22.5]},
        "901": {"vr": "DS", "Value": [20.0]},
        "902": {"vr": "DS", "Value": [20.0]},
        "903": {"vr": "DS", "Value": [20.0]},
        "904": {"vr": "DS", "Value": [22.5]},
        "905": {"vr": "DS", "Value": [22.5]},
        "906": {"vr": "DS", "Value": [22.5]},
        "907": {"vr": "DS", "Value": [22.5]},
        "908": {"vr": "DS", "Value": [22.5]},
        "909": {"vr": "DS", "Value": [20.0]},
        "910": {"vr": "DS", "Value": [22.5]},
        "911": {"vr": "DS", "Value": [22.5]},
        "912": {"vr": "DS", "Value": [22.5]},
        "913": {"vr": "DS", "Value": [22.5]},
        "914": {"vr": "DS", "Value": [20.0]},
        "915": {"vr": "DS", "Value": [22.5]},
        "916": {"vr": "DS", "Value": [22.5]},
        "917": {"vr": "DS", "Value": [20.0]},
        "918": {"vr": "DS", "Value": [20.0]},
        "919": {"vr": "DS", "Value": [22.5]},
        "920": {"vr": "DS", "Value": [22.5]},
        "921": {"vr": "DS", "Value": [22.5]},
        "922": {"vr": "DS", "Value": [22.5]},
        "923": {"vr": "DS", "Value": [20.0]},
        "924": {"vr": "DS", "Value": [20.0]},
        "925": {"vr": "DS", "Value": [22.5]},
        "926": {"vr": "DS", "Value": [22.5]},
        "927": {"vr": "DS", "Value": [22.5]},
        "928": {"vr": "DS", "Value": [22.5]},
        "929": {"vr": "DS", "Value": [22.5]},
        "930": {"vr": "DS", "Value": [22.5]},
        "931": {"vr": "DS", "Value": [22.5]},
        "932": {"vr": "DS", "Value": [20.0]},
        "933": {"vr": "DS", "Value": [22.5]},
        "934": {"vr": "DS", "Value": [22.5]},
        "935": {"vr": "DS", "Value": [20.0]},
        "936": {"vr": "DS", "Value": [22.5]},
        "937": {"vr": "DS", "Value": [20.0]},
        "938": {"vr": "DS", "Value": [22.5]},
        "939": {"vr": "DS", "Value": [20.0]},
        "940": {"vr": "DS", "Value": [20.0]},
        "941": {"vr": "DS", "Value": [22.5]},
        "942": {"vr": "DS", "Value": [22.5]},
        "943": {"vr": "DS", "Value": [22.5]},
        "944": {"vr": "DS", "Value": [20.0]},
        "945": {"vr": "DS", "Value": [20.0]},
        "946": {"vr": "DS", "Value": [22.5]},
        "947": {"vr": "DS", "Value": [20.0]},
        "948": {"vr": "DS", "Value": [20.0]},
        "949": {"vr": "DS", "Value": [22.5]},
        "950": {"vr": "DS", "Value": [20.0]},
        "951": {"vr": "DS", "Value": [20.0]},
        "952": {"vr": "DS", "Value": [20.0]},
        "953": {"vr": "DS", "Value": [22.5]},
        "954": {"vr": "DS", "Value": [22.5]},
        "955": {"vr": "DS", "Value": [20.0]},
        "956": {"vr": "DS", "Value": [22.5]},
        "957": {"vr": "DS", "Value": [22.5]},
        "958": {"vr": "DS", "Value": [22.5]},
        "959": {"vr": "DS", "Value": [22.5]},
        "960": {"vr": "DS", "Value": [20.0]},
        "961": {"vr": "DS", "Value": [22.5]},
        "962": {"vr": "DS", "Value": [20.0]},
        "963": {"vr": "DS", "Value": [20.0]},
        "964": {"vr": "DS", "Value": [22.5]},
        "965": {"vr": "DS", "Value": [22.5]},
        "966": {"vr": "DS", "Value": [22.5]},
        "967": {"vr": "DS", "Value": [22.5]},
        "968": {"vr": "DS", "Value": [22.5]},
        "969": {"vr": "DS", "Value": [22.5]},
        "970": {"vr": "DS", "Value": [20.0]},
        "971": {"vr": "DS", "Value": [22.5]},
        "972": {"vr": "DS", "Value": [20.0]},
        "973": {"vr": "DS", "Value": [20.0]},
        "974": {"vr": "DS", "Value": [22.5]},
        "975": {"vr": "DS", "Value": [20.0]},
        "976": {"vr": "DS", "Value": [22.5]},
        "977": {"vr": "DS", "Value": [22.5]},
        "978": {"vr": "DS", "Value": [22.5]},
        "979": {"vr": "DS", "Value": [22.5]},
        "980": {"vr": "DS", "Value": [22.5]},
        "981": {"vr": "DS", "Value": [20.0]},
        "982": {"vr": "DS", "Value": [22.5]},
        "983": {"vr": "DS", "Value": [20.0]},
        "984": {"vr": "DS", "Value": [22.5]},
        "985": {"vr": "DS", "Value": [22.5]},
        "986": {"vr": "DS", "Value": [20.0]},
        "987": {"vr": "DS", "Value": [20.0]},
        "988": {"vr": "DS", "Value": [20.0]},
        "989": {"vr": "DS", "Value": [20.0]},
        "990": {"vr": "DS", "Value": [22.5]},
        "991": {"vr": "DS", "Value": [20.0]},
        "992": {"vr": "DS", "Value": [22.5]},
        "993": {"vr": "DS", "Value": [20.0]},
        "994": {"vr": "DS", "Value": [22.5]},
        "995": {"vr": "DS", "Value": [22.5]},
        "996": {"vr": "DS", "Value": [22.5]},
        "997": {"vr": "DS", "Value": [20.0]},
        "998": {"vr": "DS", "Value": [20.0]},
        "999": {"vr": "DS", "Value": [20.0]},
        "1000": {"vr": "DS", "Value": [20.0]},
        "1001": {"vr": "DS", "Value": [22.5]},
        "1002": {"vr": "DS", "Value": [22.5]},
        "1003": {"vr": "DS", "Value": [22.5]},
        "1004": {"vr": "DS", "Value": [22.5]},
        "1005": {"vr": "DS", "Value": [20.0]},
        "1006": {"vr": "DS", "Value": [20.0]},
        "1007": {"vr": "DS", "Value": [20.0]},
        "1008": {"vr": "DS", "Value": [20.0]},
        "1009": {"vr": "DS", "Value": [20.0]},
        "1010": {"vr": "DS", "Value": [20.0]},
        "1011": {"vr": "DS", "Value": [20.0]},
        "1012": {"vr": "DS", "Value": [20.0]},
        "1013": {"vr": "DS", "Value": [20.0]},
        "1014": {"vr": "DS", "Value": [20.0]},
        "1015": {"vr": "DS", "Value": [20.0]},
        "1016": {"vr": "DS", "Value": [22.5]},
        "1017": {"vr": "DS", "Value": [20.0]},
        "1018": {"vr": "DS", "Value": [20.0]},
        "1019": {"vr": "DS", "Value": [22.5]},
        "1020": {"vr": "DS", "Value": [20.0]},
        "1021": {"vr": "DS", "Value": [20.0]},
        "1022": {"vr": "DS", "Value": [20.0]},
        "1023": {"vr": "DS", "Value": [20.0]},
        "1024": {"vr": "DS", "Value": [20.0]},
        "1025": {"vr": "DS", "Value": [20.0]},
        "1026": {"vr": "DS", "Value": [20.0]},
        "1027": {"vr": "DS", "Value": [22.5]},
        "1028": {"vr": "DS", "Value": [20.0]},
        "1029": {"vr": "DS", "Value": [22.5]},
        "1030": {"vr": "DS", "Value": [20.0]},
        "1031": {"vr": "DS", "Value": [22.5]},
        "1032": {"vr": "DS", "Value": [22.5]},
        "1033": {"vr": "DS", "Value": [22.5]},
        "1034": {"vr": "DS", "Value": [22.5]},
        "1035": {"vr": "DS", "Value": [22.5]},
        "1036": {"vr": "DS", "Value": [22.5]},
        "1037": {"vr": "DS", "Value": [20.0]},
        "1038": {"vr": "DS", "Value": [20.0]},
        "1039": {"vr": "DS", "Value": [22.5]},
        "1040": {"vr": "DS", "Value": [20.0]},
        "1041": {"vr": "DS", "Value": [20.0]},
        "1042": {"vr": "DS", "Value": [22.5]},
        "1043": {"vr": "DS", "Value": [22.5]},
        "1044": {"vr": "DS", "Value": [22.5]},
        "1045": {"vr": "DS", "Value": [20.0]},
        "1046": {"vr": "DS", "Value": [22.5]},
        "1047": {"vr": "DS", "Value": [22.5]},
        "1048": {"vr": "DS", "Value": [22.5]},
        "1049": {"vr": "DS", "Value": [20.0]},
        "1050": {"vr": "DS", "Value": [22.5]},
        "1051": {"vr": "DS", "Value": [22.5]},
        "1052": {"vr": "DS", "Value": [22.5]},
        "1053": {"vr": "DS", "Value": [20.0]},
        "1054": {"vr": "DS", "Value": [22.5]},
        "1055": {"vr": "DS", "Value": [20.0]},
        "1056": {"vr": "DS", "Value": [22.5]},
        "1057": {"vr": "DS", "Value": [20.0]},
        "1058": {"vr": "DS", "Value": [22.5]},
        "1059": {"vr": "DS", "Value": [22.5]},
        "1060": {"vr": "DS", "Value": [20.0]},
        "1061": {"vr": "DS", "Value": [22.5]},
        "1062": {"vr": "DS", "Value": [20.0]},
        "1063": {"vr": "DS", "Value": [22.5]},
        "1064": {"vr": "DS", "Value": [20.0]},
        "1065": {"vr": "DS", "Value": [20.0]},
        "1066": {"vr": "DS", "Value": [20.0]},
        "1067": {"vr": "DS", "Value": [20.0]},
        "1068": {"vr": "DS", "Value": [20.0]},
        "1069": {"vr": "DS", "Value": [22.5]},
        "1070": {"vr": "DS", "Value": [22.5]},
        "1071": {"vr": "DS", "Value": [22.5]},
        "1072": {"vr": "DS", "Value": [22.5]},
        "1073": {"vr": "DS", "Value": [22.5]},
        "1074": {"vr": "DS", "Value": [22.5]},
        "1075": {"vr": "DS", "Value": [20.0]},
        "1076": {"vr": "DS", "Value": [20.0]},
        "1077": {"vr": "DS", "Value": [22.5]},
        "1078": {"vr": "DS", "Value": [22.5]},
        "1079": {"vr": "DS", "Value": [22.5]},
        "1080": {"vr": "DS", "Value": [22.5]},
        "1081": {"vr": "DS", "Value": [20.0]},
        "1082": {"vr": "DS", "Value": [22.5]},
        "1083": {"vr": "DS", "Value": [22.5]},
        "1084": {"vr": "DS", "Value": [22.5]},
        "1085": {"vr": "DS", "Value": [22.5]},
        "1086": {"vr": "DS", "Value": [22.5]},
        "1087": {"vr": "DS", "Value": [22.5]},
        "1088": {"vr": "DS", "Value": [20.0]},
        "1089": {"vr": "DS", "Value": [20.0]},
        "1090": {"vr": "DS", "Value": [20.0]},
        "1091": {"vr": "DS", "Value": [20.0]},
        "1092": {"vr": "DS", "Value": [20.0]},
        "1093": {"vr": "DS", "Value": [22.5]},
        "1094": {"vr": "DS", "Value": [20.0]},
        "1095": {"vr": "DS", "Value": [20.0]},
        "1096": {"vr": "DS", "Value": [22.5]},
        "1097": {"vr": "DS", "Value": [22.5]},
        "1098": {"vr": "DS", "Value": [22.5]},
        "1099": {"vr": "DS", "Value": [20.0]},
        "1100": {"vr": "DS", "Value": [22.5]},
        "1101": {"vr": "DS", "Value": [22.5]},
        "1102": {"vr": "DS", "Value": [22.5]},
        "1103": {"vr": "DS", "Value": [20.0]},
        "1104": {"vr": "DS", "Value": [20.0]},
        "1105": {"vr": "DS", "Value": [22.5]},
        "1106": {"vr": "DS", "Value": [22.5]},
        "1107": {"vr": "DS", "Value": [20.0]},
        "1108": {"vr": "DS", "Value": [20.0]},
        "1109": {"vr": "DS", "Value": [22.5]},
        "1110": {"vr": "DS", "Value": [20.0]},
        "1111": {"vr": "DS", "Value": [20.0]},
        "1112": {"vr": "DS", "Value": [20.0]},
        "1113": {"vr": "DS", "Value": [20.0]},
        "1114": {"vr": "DS", "Value": [20.0]},
        "1115": {"vr": "DS", "Value": [22.5]},
        "1116": {"vr": "DS", "Value": [22.5]},
        "1117": {"vr": "DS", "Value": [20.0]},
        "1118": {"vr": "DS", "Value": [20.0]},
        "1119": {"vr": "DS", "Value": [22.5]},
        "1120": {"vr": "DS", "Value": [22.5]},
        "1121": {"vr": "DS", "Value": [22.5]},
        "1122": {"vr": "DS", "Value": [20.0]},
        "1123": {"vr": "DS", "Value": [20.0]},
        "1124": {"vr": "DS", "Value": [22.5]},
        "1125": {"vr": "DS", "Value": [22.5]},
        "1126": {"vr": "DS", "Value": [22.5]},
        "1127": {"vr": "DS", "Value": [22.5]},
        "1128": {"vr": "DS", "Value": [20.0]},
        "1129": {"vr": "DS", "Value": [20.0]},
        "1130": {"vr": "DS", "Value": [20.0]},
        "1131": {"vr": "DS", "Value": [20.0]},
        "1132": {"vr": "DS", "Value": [22.5]},
        "1133": {"vr": "DS", "Value": [22.5]},
        "1134": {"vr": "DS", "Value": [20.0]},
        "1135": {"vr": "DS", "Value": [20.0]},
        "1136": {"vr": "DS", "Value": [20.0]},
        "1137": {"vr": "DS", "Value": [22.5]},
        "1138": {"vr": "DS", "Value": [20.0]},
        "1139": {"vr": "DS", "Value": [22.5]},
        "1140": {"vr": "DS", "Value": [22.5]},
        "1141": {"vr": "DS", "Value": [22.5]},
        "1142": {"vr": "DS", "Value": [22.5]},
        "1143": {"vr": "DS", "Value": [20.0]},
        "1144": {"vr": "DS", "Value": [22.5]},
        "1145": {"vr": "DS", "Value": [22.5]},
        "1146": {"vr": "DS", "Value": [22.5]},
        "1147": {"vr": "DS", "Value": [22.5]},
        "1148": {"vr": "DS", "Value": [22.5]},
        "1149": {"vr": "DS", "Value": [22.5]},
        "1150": {"vr": "DS", "Value": [20.0]},
        "1151": {"vr": "DS", "Value": [20.0]},
        "1152": {"vr": "DS", "Value": [22.5]},
        "1153": {"vr": "DS", "Value": [20.0]},
        "1154": {"vr": "DS", "Value": [20.0]},
        "1155": {"vr": "DS", "Value": [20.0]},
        "1156": {"vr": "DS", "Value": [22.5]},
        "1157": {"vr": "DS", "Value": [22.5]},
        "1158": {"vr": "DS", "Value": [22.5]},
        "1159": {"vr": "DS", "Value": [20.0]},
        "1160": {"vr": "DS", "Value": [20.0]},
        "1161": {"vr": "DS", "Value": [20.0]},
        "1162": {"vr": "DS", "Value": [20.0]},
        "1163": {"vr": "DS", "Value": [22.5]},
        "1164": {"vr": "DS", "Value": [22.5]},
        "1165": {"vr": "DS", "Value": [22.5]},
        "1166": {"vr": "DS", "Value": [20.0]},
        "1167": {"vr": "DS", "Value": [20.0]},
        "1168": {"vr": "DS", "Value": [22.5]},
        "1169": {"vr": "DS", "Value": [22.5]},
        "1170": {"vr": "DS", "Value": [22.5]},
        "1171": {"vr": "DS", "Value": [22.5]},
        "1172": {"vr": "DS", "Value": [20.0]},
        "1173": {"vr": "DS", "Value": [20.0]},
        "1174": {"vr": "DS", "Value": [20.0]},
        "1175": {"vr": "DS", "Value": [22.5]},
        "1176": {"vr": "DS", "Value": [22.5]},
        "1177": {"vr": "DS", "Value": [22.5]},
        "1178": {"vr": "DS", "Value": [22.5]},
        "1179": {"vr": "DS", "Value": [20.0]},
        "1180": {"vr": "DS", "Value": [20.0]},
        "1181": {"vr": "DS", "Value": [22.5]},
        "1182": {"vr": "DS", "Value": [22.5]},
        "1183": {"vr": "DS", "Value": [22.5]},
        "1184": {"vr": "DS", "Value": [20.0]},
        "1185": {"vr": "DS", "Value": [22.5]},
        "1186": {"vr": "DS", "Value": [22.5]},
        "1187": {"vr": "DS", "Value": [22.5]},
        "1188": {"vr": "DS", "Value": [20.0]},
        "1189": {"vr": "DS", "Value": [20.0]},
        "1190": {"vr": "DS", "Value": [22.5]},
        "1191": {"vr": "DS", "Value": [20.0]},
        "1192": {"vr": "DS", "Value": [22.5]},
        "1193": {"vr": "DS", "Value": [20.0]},
        "1194": {"vr": "DS", "Value": [22.5]},
        "1195": {"vr": "DS", "Value": [22.5]},
        "1196": {"vr": "DS", "Value": [20.0]},
        "1197": {"vr": "DS", "Value": [22.5]},
        "1198": {"vr": "DS", "Value": [20.0]},
        "1199": {"vr": "DS", "Value": [20.0]},
        "1200": {"vr": "DS", "Value": [22.5]},
        "1201": {"vr": "DS", "Value": [20.0]},
        "1202": {"vr": "DS", "Value": [22.5]},
        "1203": {"vr": "DS", "Value": [20.0]},
        "1204": {"vr": "DS", "Value": [22.5]},
        "1205": {"vr": "DS", "Value": [22.5]},
        "1206": {"vr": "DS", "Value": [22.5]},
        "1207": {"vr": "DS", "Value": [20.0]},
        "1208": {"vr": "DS", "Value": [22.5]},
        "1209": {"vr": "DS", "Value": [20.0]},
        "1210": {"vr": "DS", "Value": [22.5]},
        "1211": {"vr": "DS", "Value": [22.5]},
        "1212": {"vr": "DS", "Value": [20.0]},
        "1213": {"vr": "DS", "Value": [20.0]},
        "1214": {"vr": "DS", "Value": [20.0]},
        "1215": {"vr": "DS", "Value": [22.5]},
        "1216": {"vr": "DS", "Value": [20.0]},
        "1217": {"vr": "DS", "Value": [20.0]},
        "1218": {"vr": "DS", "Value": [22.5]},
        "1219": {"vr": "DS", "Value": [20.0]},
        "1220": {"vr": "DS", "Value": [20.0]},
        "1221": {"vr": "DS", "Value": [20.0]},
        "1222": {"vr": "DS", "Value": [22.5]},
        "1223": {"vr": "DS", "Value": [20.0]},
        "1224": {"vr": "DS", "Value": [20.0]},
        "1225": {"vr": "DS", "Value": [22.5]},
        "1226": {"vr": "DS", "Value": [22.5]},
        "1227": {"vr": "DS", "Value": [20.0]},
        "1228": {"vr": "DS", "Value": [20.0]},
        "1229": {"vr": "DS", "Value": [22.5]},
        "1230": {"vr": "DS", "Value": [22.5]},
        "1231": {"vr": "DS", "Value": [20.0]},
        "1232": {"vr": "DS", "Value": [22.5]},
        "1233": {"vr": "DS", "Value": [22.5]},
        "1234": {"vr": "DS", "Value": [22.5]},
        "1235": {"vr": "DS", "Value": [20.0]},
        "1236": {"vr": "DS", "Value": [22.5]},
        "1237": {"vr": "DS", "Value": [20.0]},
        "1238": {"vr": "DS", "Value": [22.5]},
        "1239": {"vr": "DS", "Value": [22.5]},
        "1240": {"vr": "DS", "Value": [20.0]},
        "1241": {"vr": "DS", "Value": [20.0]},
        "1242": {"vr": "DS", "Value": [22.5]},
        "1243": {"vr": "DS", "Value": [22.5]},
        "1244": {"vr": "DS", "Value": [20.0]},
        "1245": {"vr": "DS", "Value": [22.5]},
        "1246": {"vr": "DS", "Value": [22.5]},
        "1247": {"vr": "DS", "Value": [22.5]},
        "1248": {"vr": "DS", "Value": [22.5]},
        "1249": {"vr": "DS", "Value": [22.5]},
        "1250": {"vr": "DS", "Value": [22.5]},
        "1251": {"vr": "DS", "Value": [22.5]},
        "1252": {"vr": "DS", "Value": [20.0]},
        "1253": {"vr": "DS", "Value": [22.5]},
        "1254": {"vr": "DS", "Value": [22.5]},
        "1255": {"vr": "DS", "Value": [22.5]},
        "1256": {"vr": "DS", "Value": [22.5]},
        "1257": {"vr": "DS", "Value": [22.5]},
        "1258": {"vr": "DS", "Value": [20.0]},
        "1259": {"vr": "DS", "Value": [22.5]},
        "1260": {"vr": "DS", "Value": [22.5]},
        "1261": {"vr": "DS", "Value": [20.0]},
        "1262": {"vr": "DS", "Value": [20.0]},
        "1263": {"vr": "DS", "Value": [22.5]},
        "1264": {"vr": "DS", "Value": [20.0]},
        "1265": {"vr": "DS", "Value": [22.5]},
        "1266": {"vr": "DS", "Value": [22.5]},
        "1267": {"vr": "DS", "Value": [22.5]},
        "1268": {"vr": "DS", "Value": [22.5]},
        "1269": {"vr": "DS", "Value": [20.0]},
        "1270": {"vr": "DS", "Value": [20.0]},
        "1271": {"vr": "DS", "Value": [20.0]},
        "1272": {"vr": "DS", "Value": [22.5]},
        "1273": {"vr": "DS", "Value": [22.5]},
        "1274": {"vr": "DS", "Value": [22.5]},
        "1275": {"vr": "DS", "Value": [20.0]},
        "1276": {"vr": "DS", "Value": [22.5]},
        "1277": {"vr": "DS", "Value": [22.5]},
        "1278": {"vr": "DS", "Value": [20.0]},
        "1279": {"vr": "DS", "Value": [22.5]},
        "1280": {"vr": "DS", "Value": [20.0]},
        "1281": {"vr": "DS", "Value": [20.0]},
        "1282": {"vr": "DS", "Value": [20.0]},
        "1283": {"vr": "DS", "Value": [20.0]},
        "1284": {"vr": "DS", "Value": [20.0]},
        "1285": {"vr": "DS", "Value": [22.5]},
        "1286": {"vr": "DS", "Value": [22.5]},
        "1287": {"vr": "DS", "Value": [22.5]},
        "1288": {"vr": "DS", "Value": [22.5]},
        "1289": {"vr": "DS", "Value": [20.0]},
        "1290": {"vr": "DS", "Value": [22.5]},
        "1291": {"vr": "DS", "Value": [22.5]},
        "1292": {"vr": "DS", "Value": [22.5]},
        "1293": {"vr": "DS", "Value": [20.0]},
        "1294": {"vr": "DS", "Value": [22.5]},
        "1295": {"vr": "DS", "Value": [22.5]},
        "1296": {"vr": "DS", "Value": [22.5]},
        "1297": {"vr": "DS", "Value": [20.0]},
        "1298": {"vr": "DS", "Value": [20.0]},
        "1299": {"vr": "DS", "Value": [20.0]},
        "1300": {"vr": "DS", "Value": [22.5]},
        "1301": {"vr": "DS", "Value": [20.0]},
        "1302": {"vr": "DS", "Value": [20.0]},
        "1303": {"vr": "DS", "Value": [22.5]},
        "1304": {"vr": "DS", "Value": [22.5]},
        "1305": {"vr": "DS", "Value": [20.0]},
        "1306": {"vr": "DS", "Value": [20.0]},
        "1307": {"vr": "DS", "Value": [20.0]},
        "1308": {"vr": "DS", "Value": [20.0]},
        "1309": {"vr": "DS", "Value": [22.5]},
        "1310": {"vr": "DS", "Value": [20.0]},
        "1311": {"vr": "DS", "Value": [22.5]},
        "1312": {"vr": "DS", "Value": [20.0]},
        "1313": {"vr": "DS", "Value": [20.0]},
        "1314": {"vr": "DS", "Value": [20.0]},
        "1315": {"vr": "DS", "Value": [22.5]},
        "1316": {"vr": "DS", "Value": [20.0]},
        "1317": {"vr": "DS", "Value": [20.0]},
        "1318": {"vr": "DS", "Value": [20.0]},
        "1319": {"vr": "DS", "Value": [22.5]},
        "1320": {"vr": "DS", "Value": [20.0]},
        "1321": {"vr": "DS", "Value": [20.0]},
        "1322": {"vr": "DS", "Value": [20.0]},
        "1323": {"vr": "DS", "Value": [20.0]},
        "1324": {"vr": "DS", "Value": [22.5]},
        "1325": {"vr": "DS", "Value": [22.5]},
        "1326": {"vr": "DS", "Value": [20.0]},
        "1327": {"vr": "DS", "Value": [20.0]},
        "1328": {"vr": "DS", "Value": [20.0]},
        "1329": {"vr": "DS", "Value": [22.5]},
        "1330": {"vr": "DS", "Value": [22.5]},
        "1331": {"vr": "DS", "Value": [22.5]},
        "1332": {"vr": "DS", "Value": [20.0]},
        "1333": {"vr": "DS", "Value": [22.5]},
        "1334": {"vr": "DS", "Value": [22.5]},
        "1335": {"vr": "DS", "Value": [20.0]},
        "1336": {"vr": "DS", "Value": [22.5]},
        "1337": {"vr": "DS", "Value": [20.0]},
        "1338": {"vr": "DS", "Value": [22.5]},
        "1339": {"vr": "DS", "Value": [22.5]},
        "1340": {"vr": "DS", "Value": [22.5]},
        "1341": {"vr": "DS", "Value": [22.5]},
        "1342": {"vr": "DS", "Value": [22.5]},
        "1343": {"vr": "DS", "Value": [22.5]},
        "1344": {"vr": "DS", "Value": [22.5]},
        "1345": {"vr": "DS", "Value": [22.5]},
        "1346": {"vr": "DS", "Value": [20.0]},
        "1347": {"vr": "DS", "Value": [20.0]},
        "1348": {"vr": "DS", "Value": [22.5]},
        "1349": {"vr": "DS", "Value": [22.5]},
        "1350": {"vr": "DS", "Value": [22.5]},
        "1351": {"vr": "DS", "Value": [22.5]},
        "1352": {"vr": "DS", "Value": [22.5]},
        "1353": {"vr": "DS", "Value": [20.0]},
        "1354": {"vr": "DS", "Value": [22.5]},
        "1355": {"vr": "DS", "Value": [20.0]},
        "1356": {"vr": "DS", "Value": [22.5]},
        "1357": {"vr": "DS", "Value": [20.0]},
        "1358": {"vr": "DS", "Value": [22.5]},
        "1359": {"vr": "DS", "Value": [20.0]},
        "1360": {"vr": "DS", "Value": [22.5]},
        "1361": {"vr": "DS", "Value": [22.5]},
        "1362": {"vr": "DS", "Value": [20.0]},
        "1363": {"vr": "DS", "Value": [22.5]},
        "1364": {"vr": "DS", "Value": [22.5]},
        "1365": {"vr": "DS", "Value": [20.0]},
        "1366": {"vr": "DS", "Value": [22.5]},
        "1367": {"vr": "DS", "Value": [20.0]},
        "1368": {"vr": "DS", "Value": [20.0]},
        "1369": {"vr": "DS", "Value": [20.0]},
        "1370": {"vr": "DS", "Value": [20.0]},
        "1371": {"vr": "DS", "Value": [22.5]},
        "1372": {"vr": "DS", "Value": [20.0]},
        "1373": {"vr": "DS", "Value": [22.5]},
        "1374": {"vr": "DS", "Value": [22.5]},
        "1375": {"vr": "DS", "Value": [22.5]},
        "1376": {"vr": "DS", "Value": [22.5]},
        "1377": {"vr": "DS", "Value": [22.5]},
        "1378": {"vr": "DS", "Value": [20.0]},
        "1379": {"vr": "DS", "Value": [22.5]},
        "1380": {"vr": "DS", "Value": [20.0]},
        "1381": {"vr": "DS", "Value": [20.0]},
        "1382": {"vr": "DS", "Value": [22.5]},
        "1383": {"vr": "DS", "Value": [22.5]},
        "1384": {"vr": "DS", "Value": [20.0]},
        "1385": {"vr": "DS", "Value": [20.0]},
        "1386": {"vr": "DS", "Value": [22.5]},
        "1387": {"vr": "DS", "Value": [22.5]},
        "1388": {"vr": "DS", "Value": [20.0]},
        "1389": {"vr": "DS", "Value": [20.0]},
        "1390": {"vr": "DS", "Value": [22.5]},
        "1391": {"vr": "DS", "Value": [20.0]},
        "1392": {"vr": "DS", "Value": [22.5]},
        "1393": {"vr": "DS", "Value": [20.0]},
        "1394": {"vr": "DS", "Value": [22.5]},
        "1395": {"vr": "DS", "Value": [20.0]},
        "1396": {"vr": "DS", "Value": [20.0]},
        "1397": {"vr": "DS", "Value": [22.5]},
        "1398": {"vr": "DS", "Value": [22.5]},
        "1399": {"vr": "DS", "Value": [20.0]},
        "1400": {"vr": "DS", "Value": [22.5]},
        "1401": {"vr": "DS", "Value": [20.0]},
        "1402": {"vr": "DS", "Value": [22.5]},
        "1403": {"vr": "DS", "Value": [22.5]},
        "1404": {"vr": "DS", "Value": [22.5]},
        "1405": {"vr": "DS", "Value": [22.5]},
        "1406": {"vr": "DS", "Value": [20.0]},
        "1407": {"vr": "DS", "Value": [22.5]},
        "1408": {"vr": "DS", "Value": [22.5]},
        "1409": {"vr": "DS", "Value": [22.5]},
        "1410": {"vr": "DS", "Value": [22.5]},
        "1411": {"vr": "DS", "Value": [20.0]},
        "1412": {"vr": "DS", "Value": [22.5]},
        "1413": {"vr": "DS", "Value": [22.5]},
        "1414": {"vr": "DS", "Value": [20.0]},
        "1415": {"vr": "DS", "Value": [22.5]},
        "1416": {"vr": "DS", "Value": [22.5]},
        "1417": {"vr": "DS", "Value": [22.5]},
        "1418": {"vr": "DS", "Value": [22.5]},
        "1419": {"vr": "DS", "Value": [22.5]},
        "1420": {"vr": "DS", "Value": [22.5]},
        "1421": {"vr": "DS", "Value": [20.0]},
        "1422": {"vr": "DS", "Value": [22.5]},
        "1423": {"vr": "DS", "Value": [22.5]},
        "1424": {"vr": "DS", "Value": [20.0]},
        "1425": {"vr": "DS", "Value": [20.0]},
        "1426": {"vr": "DS", "Value": [22.5]},
        "1427": {"vr": "DS", "Value": [20.0]},
        "1428": {"vr": "DS", "Value": [22.5]},
        "1429": {"vr": "DS", "Value": [22.5]},
        "1430": {"vr": "DS", "Value": [20.0]},
        "1431": {"vr": "DS", "Value": [22.5]},
        "1432": {"vr": "DS", "Value": [20.0]},
        "1433": {"vr": "DS", "Value": [22.5]},
        "1434": {"vr": "DS", "Value": [22.5]},
        "1435": {"vr": "DS", "Value": [22.5]},
        "1436": {"vr": "DS", "Value": [22.5]},
        "1437": {"vr": "DS", "Value": [22.5]},
        "1438": {"vr": "DS", "Value": [22.5]},
        "1439": {"vr": "DS", "Value": [20.0]},
        "1440": {"vr": "DS", "Value": [22.5]},
        "1441": {"vr": "DS", "Value": [22.5]},
        "1442": {"vr": "DS", "Value": [20.0]},
        "1443": {"vr": "DS", "Value": [22.5]},
        "1444": {"vr": "DS", "Value": [22.5]},
        "1445": {"vr": "DS", "Value": [22.5]},
        "1446": {"vr": "DS", "Value": [22.5]},
        "1447": {"vr": "DS", "Value": [22.5]},
        "1448": {"vr": "DS", "Value": [20.0]},
        "1449": {"vr": "DS", "Value": [20.0]},
        "1450": {"vr": "DS", "Value": [20.0]},
        "1451": {"vr": "DS", "Value": [20.0]},
        "1452": {"vr": "DS", "Value": [22.5]},
        "1453": {"vr": "DS", "Value": [20.0]},
        "1454": {"vr": "DS", "Value": [20.0]},
        "1455": {"vr": "DS", "Value": [20.0]},
        "1456": {"vr": "DS", "Value": [20.0]},
        "1457": {"vr": "DS", "Value": [20.0]},
        "1458": {"vr": "DS", "Value": [22.5]},
        "1459": {"vr": "DS", "Value": [20.0]},
        "1460": {"vr": "DS", "Value": [20.0]},
        "1461": {"vr": "DS", "Value": [20.0]},
        "1462": {"vr": "DS", "Value": [20.0]},
        "1463": {"vr": "DS", "Value": [20.0]},
        "1464": {"vr": "DS", "Value": [22.5]},
        "1465": {"vr": "DS", "Value": [22.5]},
        "1466": {"vr": "DS", "Value": [22.5]},
        "1467": {"vr": "DS", "Value": [22.5]},
        "1468": {"vr": "DS", "Value": [20.0]},
        "1469": {"vr": "DS", "Value": [20.0]},
        "1470": {"vr": "DS", "Value": [20.0]},
        "1471": {"vr": "DS", "Value": [20.0]},
        "1472": {"vr": "DS", "Value": [20.0]},
        "1473": {"vr": "DS", "Value": [20.0]},
        "1474": {"vr": "DS", "Value": [20.0]},
        "1475": {"vr": "DS", "Value": [20.0]},
        "1476": {"vr": "DS", "Value": [22.5]},
        "1477": {"vr": "DS", "Value": [20.0]},
        "1478": {"vr": "DS", "Value": [20.0]},
        "1479": {"vr": "DS", "Value": [20.0]},
        "1480": {"vr": "DS", "Value": [22.5]},
        "1481": {"vr": "DS", "Value": [22.5]},
        "1482": {"vr": "DS", "Value": [22.5]},
        "1483": {"vr": "DS", "Value": [20.0]},
        "1484": {"vr": "DS", "Value": [20.0]},
        "1485": {"vr": "DS", "Value": [22.5]},
        "1486": {"vr": "DS", "Value": [22.5]},
        "1487": {"vr": "DS", "Value": [22.5]},
        "1488": {"vr": "DS", "Value": [22.5]},
        "1489": {"vr": "DS", "Value": [20.0]},
        "1490": {"vr": "DS", "Value": [22.5]},
        "1491": {"vr": "DS", "Value": [20.0]},
        "1492": {"vr": "DS", "Value": [20.0]},
        "1493": {"vr": "DS", "Value": [20.0]},
        "1494": {"vr": "DS", "Value": [22.5]},
        "1495": {"vr": "DS", "Value": [22.5]},
        "1496": {"vr": "DS", "Value": [22.5]},
        "1497": {"vr": "DS", "Value": [22.5]},
        "1498": {"vr": "DS", "Value": [22.5]},
        "1499": {"vr": "DS", "Value": [22.5]},
        "1500": {"vr": "DS", "Value": [22.5]},
        "1501": {"vr": "DS", "Value": [20.0]},
        "1502": {"vr": "DS", "Value": [20.0]},
        "1503": {"vr": "DS", "Value": [22.5]},
        "1504": {"vr": "DS", "Value": [22.5]},
        "1505": {"vr": "DS", "Value": [20.0]},
        "1506": {"vr": "DS", "Value": [20.0]},
        "1507": {"vr": "DS", "Value": [20.0]},
        "1508": {"vr": "DS", "Value": [20.0]},
        "1509": {"vr": "DS", "Value": [22.5]},
        "1510": {"vr": "DS", "Value": [22.5]},
        "1511": {"vr": "DS", "Value": [22.5]},
        "1512": {"vr": "DS", "Value": [20.0]},
        "1513": {"vr": "DS", "Value": [20.0]},
        "1514": {"vr": "DS", "Value": [20.0]},
        "1515": {"vr": "DS", "Value": [20.0]},
        "1516": {"vr": "DS", "Value": [22.5]},
        "1517": {"vr": "DS", "Value": [20.0]},
        "1518": {"vr": "DS", "Value": [22.5]},
        "1519": {"vr": "DS", "Value": [22.5]},
        "1520": {"vr": "DS", "Value": [22.5]},
        "1521": {"vr": "DS", "Value": [22.5]},
        "1522": {"vr": "DS", "Value": [22.5]},
        "1523": {"vr": "DS", "Value": [22.5]},
        "1524": {"vr": "DS", "Value": [22.5]},
        "1525": {"vr": "DS", "Value": [20.0]},
        "1526": {"vr": "DS", "Value": [20.0]},
        "1527": {"vr": "DS", "Value": [20.0]},
        "1528": {"vr": "DS", "Value": [22.5]},
        "1529": {"vr": "DS", "Value": [22.5]},
        "1530": {"vr": "DS", "Value": [20.0]},
        "1531": {"vr": "DS", "Value": [22.5]},
        "1532": {"vr": "DS", "Value": [22.5]},
        "1533": {"vr": "DS", "Value": [22.5]},
        "1534": {"vr": "DS", "Value": [20.0]},
        "1535": {"vr": "DS", "Value": [22.5]},
        "1536": {"vr": "DS", "Value": [22.5]},
        "1537": {"vr": "DS", "Value": [22.5]},
        "1538": {"vr": "DS", "Value": [22.5]},
        "1539": {"vr": "DS", "Value": [20.0]},
        "1540": {"vr": "DS", "Value": [22.5]},
        "1541": {"vr": "DS", "Value": [20.0]},
        "1542": {"vr": "DS", "Value": [20.0]},
        "1543": {"vr": "DS", "Value": [22.5]},
        "1544": {"vr": "DS", "Value": [20.0]},
        "1545": {"vr": "DS", "Value": [22.5]},
        "1546": {"vr": "DS", "Value": [20.0]},
        "1547": {"vr": "DS", "Value": [22.5]},
        "1548": {"vr": "DS", "Value": [20.0]},
        "1549": {"vr": "DS", "Value": [22.5]},
        "1550": {"vr": "DS", "Value": [20.0]},
        "1551": {"vr": "DS", "Value": [20.0]},
        "1552": {"vr": "DS", "Value": [20.0]},
        "1553": {"vr": "DS", "Value": [20.0]},
        "1554": {"vr": "DS", "Value": [22.5]},
        "1555": {"vr": "DS", "Value": [20.0]},
        "1556": {"vr": "DS", "Value": [20.0]},
        "1557": {"vr": "DS", "Value": [22.5]},
        "1558": {"vr": "DS", "Value": [22.5]},
        "1559": {"vr": "DS", "Value": [20.0]},
        "1560": {"vr": "DS", "Value": [22.5]},
        "1561": {"vr": "DS", "Value": [22.5]},
        "1562": {"vr": "DS", "Value": [20.0]},
        "1563": {"vr": "DS", "Value": [20.0]},
        "1564": {"vr": "DS", "Value": [20.0]},
        "1565": {"vr": "DS", "Value": [20.0]},
        "1566": {"vr": "DS", "Value": [20.0]},
        "1567": {"vr": "DS", "Value": [22.5]},
        "1568": {"vr": "DS", "Value": [20.0]},
        "1569": {"vr": "DS", "Value": [20.0]},
        "1570": {"vr": "DS", "Value": [22.5]},
        "1571": {"vr": "DS", "Value": [22.5]},
        "1572": {"vr": "DS", "Value": [20.0]},
        "1573": {"vr": "DS", "Value": [22.5]},
        "1574": {"vr": "DS", "Value": [20.0]},
        "1575": {"vr": "DS", "Value": [22.5]},
        "1576": {"vr": "DS", "Value": [22.5]},
        "1577": {"vr": "DS", "Value": [22.5]},
        "1578": {"vr": "DS", "Value": [22.5]},
        "1579": {"vr": "DS", "Value": [20.0]},
        "1580": {"vr": "DS", "Value": [22.5]},
        "1581": {"vr": "DS", "Value": [20.0]},
        "1582": {"vr": "DS", "Value": [22.5]},
        "1583": {"vr": "DS", "Value": [20.0]},
        "1584": {"vr": "DS", "Value": [20.0]},
        "1585": {"vr": "DS", "Value": [20.0]},
        "1586": {"vr": "DS", "Value": [22.5]},
        "1587": {"vr": "DS", "Value": [22.5]},
        "1588": {"vr": "DS", "Value": [22.5]},
        "1589": {"vr": "DS", "Value": [22.5]},
        "1590": {"vr": "DS", "Value": [20.0]},
        "1591": {"vr": "DS", "Value": [20.0]},
        "1592": {"vr": "DS", "Value": [22.5]},
        "1593": {"vr": "DS", "Value": [20.0]},
        "1594": {"vr": "DS", "Value": [22.5]},
        "1595": {"vr": "DS", "Value": [20.0]},
        "1596": {"vr": "DS", "Value": [22.5]},
        "1597": {"vr": "DS", "Value": [20.0]},
        "1598": {"vr": "DS", "Value": [22.5]},
        "1599": {"vr": "DS", "Value": [22.5]},
        "1600": {"vr": "DS", "Value": [20.0]},
        "1601": {"vr": "DS", "Value": [20.0]},
        "1602": {"vr": "DS", "Value": [22.5]},
        "1603": {"vr": "DS", "Value": [20.0]},
        "1604": {"vr": "DS", "Value": [20.0]},
        "1605": {"vr": "DS", "Value": [20.0]},
        "1606": {"vr": "DS", "Value": [22.5]},
        "1607": {"vr": "DS", "Value": [22.5]},
        "1608": {"vr": "DS", "Value": [22.5]},
        "1609": {"vr": "DS", "Value": [22.5]},
        "1610": {"vr": "DS", "Value": [20.0]},
        "1611": {"vr": "DS", "Value": [22.5]},
        "1612": {"vr": "DS", "Value": [20.0]},
        "1613": {"vr": "DS", "Value": [20.0]},
        "1614": {"vr": "DS", "Value": [22.5]},
        "1615": {"vr": "DS", "Value": [20.0]},
        "1616": {"vr": "DS", "Value": [20.0]},
        "1617": {"vr": "DS", "Value": [22.5]},
        "1618": {"vr": "DS", "Value": [22.5]},
        "1619": {"vr": "DS", "Value": [20.0]},
        "1620": {"vr": "DS", "Value": [20.0]},
        "1621": {"vr": "DS", "Value": [22.5]},
        "1622": {"vr": "DS", "Value": [22.5]},
        "1623": {"vr": "DS", "Value": [22.5]},
        "1624": {"vr": "DS", "Value": [22.5]},
        "1625": {"vr": "DS", "Value": [22.5]},
        "1626": {"vr": "DS", "Value": [22.5]},
        "1627": {"vr": "DS", "Value": [20.0]},
        "1628": {"vr": "DS", "Value": [22.5]},
        "1629": {"vr": "DS", "Value": [22.5]},
        "1630": {"vr": "DS", "Value": [22.5]},
        "1631": {"vr": "DS", "Value": [22.5]},
        "1632": {"vr": "DS", "Value": [20.0]},
        "1633": {"vr": "DS", "Value": [22.5]},
        "1634": {"vr": "DS", "Value": [22.5]},
        "1635": {"vr": "DS", "Value": [20.0]},
        "1636": {"vr": "DS", "Value": [20.0]},
        "1637": {"vr": "DS", "Value": [20.0]},
        "1638": {"vr": "DS", "Value": [22.5]},
        "1639": {"vr": "DS", "Value": [22.5]},
        "1640": {"vr": "DS", "Value": [20.0]},
        "1641": {"vr": "DS", "Value": [22.5]},
        "1642": {"vr": "DS", "Value": [20.0]},
        "1643": {"vr": "DS", "Value": [20.0]},
        "1644": {"vr": "DS", "Value": [20.0]},
        "1645": {"vr": "DS", "Value": [20.0]},
        "1646": {"vr": "DS", "Value": [20.0]},
        "1647": {"vr": "DS", "Value": [20.0]},
        "1648": {"vr": "DS", "Value": [22.5]},
        "1649": {"vr": "DS", "Value": [20.0]},
        "1650": {"vr": "DS", "Value": [22.5]},
        "1651": {"vr": "DS", "Value": [20.0]},
        "1652": {"vr": "DS", "Value": [22.5]},
        "1653": {"vr": "DS", "Value": [20.0]},
        "1654": {"vr": "DS", "Value": [22.5]},
        "1655": {"vr": "DS", "Value": [20.0]},
        "1656": {"vr": "DS", "Value": [20.0]},
        "1657": {"vr": "DS", "Value": [20.0]},
        "1658": {"vr": "DS", "Value": [20.0]},
        "1659": {"vr": "DS", "Value": [20.0]},
        "1660": {"vr": "DS", "Value": [20.0]},
        "1661": {"vr": "DS", "Value": [22.5]},
        "1662": {"vr": "DS", "Value": [20.0]},
        "1663": {"vr": "DS", "Value": [22.5]},
        "1664": {"vr": "DS", "Value": [22.5]},
        "1665": {"vr": "DS", "Value": [20.0]},
        "1666": {"vr": "DS", "Value": [20.0]},
        "1667": {"vr": "DS", "Value": [22.5]},
        "1668": {"vr": "DS", "Value": [20.0]},
        "1669": {"vr": "DS", "Value": [22.5]},
        "1670": {"vr": "DS", "Value": [22.5]},
        "1671": {"vr": "DS", "Value": [20.0]},
        "1672": {"vr": "DS", "Value": [20.0]},
        "1673": {"vr": "DS", "Value": [20.0]},
        "1674": {"vr": "DS", "Value": [22.5]},
        "1675": {"vr": "DS", "Value": [20.0]},
        "1676": {"vr": "DS", "Value": [22.5]},
        "1677": {"vr": "DS", "Value": [22.5]},
        "1678": {"vr": "DS", "Value": [22.5]},
        "1679": {"vr": "DS", "Value": [22.5]},
        "1680": {"vr": "DS", "Value": [20.0]},
        "1681": {"vr": "DS", "Value": [22.5]},
        "1682": {"vr": "DS", "Value": [20.0]},
        "1683": {"vr": "DS", "Value": [22.5]},
        "1684": {"vr": "DS", "Value": [22.5]},
        "1685": {"vr": "DS", "Value": [20.0]},
        "1686": {"vr": "DS", "Value": [22.5]},
        "1687": {"vr": "DS", "Value": [22.5]},
        "1688": {"vr": "DS", "Value": [20.0]},
        "1689": {"vr": "DS", "Value": [22.5]},
        "1690": {"vr": "DS", "Value": [22.5]},
        "1691": {"vr": "DS", "Value": [20.0]},
        "1692": {"vr": "DS", "Value": [22.5]},
        "1693": {"vr": "DS", "Value": [22.5]},
        "1694": {"vr": "DS", "Value": [22.5]},
        "1695": {"vr": "DS", "Value": [22.5]},
        "1696": {"vr": "DS", "Value": [20.0]},
        "1697": {"vr": "DS", "Value": [20.0]},
        "1698": {"vr": "DS", "Value": [22.5]},
        "1699": {"vr": "DS", "Value": [20.0]},
        "1700": {"vr": "DS", "Value": [22.5]},
        "1701": {"vr": "DS", "Value": [20.0]},
        "1702": {"vr": "DS", "Value": [20.0]},
        "1703": {"vr": "DS", "Value": [22.5]},
        "1704": {"vr": "DS", "Value": [20.0]},
        "1705": {"vr": "DS", "Value": [22.5]},
        "1706": {"vr": "DS", "Value": [20.0]},
        "1707": {"vr": "DS", "Value": [22.5]},
        "1708": {"vr": "DS", "Value": [20.0]},
        "1709": {"vr": "DS", "Value": [20.0]},
        "1710": {"vr": "DS", "Value": [22.5]},
        "1711": {"vr": "DS", "Value": [22.5]},
        "1712": {"vr": "DS", "Value": [20.0]},
        "1713": {"vr": "DS", "Value": [22.5]},
        "1714": {"vr": "DS", "Value": [22.5]},
        "1715": {"vr": "DS", "Value": [22.5]},
        "1716": {"vr": "DS", "Value": [22.5]},
        "1717": {"vr": "DS", "Value": [22.5]},
        "1718": {"vr": "DS", "Value": [20.0]},
        "1719": {"vr": "DS", "Value": [22.5]},
        "1720": {"vr": "DS", "Value": [20.0]},
        "1721": {"vr": "DS", "Value": [22.5]},
        "1722": {"vr": "DS", "Value": [22.5]},
        "1723": {"vr": "DS", "Value": [22.5]},
        "1724": {"vr": "DS", "Value": [22.5]},
        "1725": {"vr": "DS", "Value": [22.5]},
        "1726": {"vr": "DS", "Value": [20.0]},
        "1727": {"vr": "DS", "Value": [20.0]},
        "1728": {"vr": "DS", "Value": [22.5]},
        "1729": {"vr": "DS", "Value": [20.0]},
        "1730": {"vr": "DS", "Value": [20.0]},
        "1731": {"vr": "DS", "Value": [20.0]},
        "1732": {"vr": "DS", "Value": [22.5]},
        "1733": {"vr": "DS", "Value": [20.0]},
        "1734": {"vr": "DS", "Value": [20.0]},
        "1735": {"vr": "DS", "Value": [20.0]},
        "1736": {"vr": "DS", "Value": [22.5]},
        "1737": {"vr": "DS", "Value": [20.0]},
        "1738": {"vr": "DS", "Value": [22.5]},
        "1739": {"vr": "DS", "Value": [22.5]},
        "1740": {"vr": "DS", "Value": [22.5]},
        "1741": {"vr": "DS", "Value": [20.0]},
        "1742": {"vr": "DS", "Value": [22.5]},
        "1743": {"vr": "DS", "Value": [22.5]},
        "1744": {"vr": "DS", "Value": [22.5]},
        "1745": {"vr": "DS", "Value": [22.5]},
        "1746": {"vr": "DS", "Value": [22.5]},
        "1747": {"vr": "DS", "Value": [22.5]},
        "1748": {"vr": "DS", "Value": [20.0]},
        "1749": {"vr": "DS", "Value": [20.0]},
        "1750": {"vr": "DS", "Value": [20.0]},
        "1751": {"vr": "DS", "Value": [22.5]},
        "1752": {"vr": "DS", "Value": [20.0]},
        "1753": {"vr": "DS", "Value": [22.5]},
        "1754": {"vr": "DS", "Value": [20.0]},
        "1755": {"vr": "DS", "Value": [22.5]},
        "1756": {"vr": "DS", "Value": [22.5]},
        "1757": {"vr": "DS", "Value": [22.5]},
        "1758": {"vr": "DS", "Value": [22.5]},
        "1759": {"vr": "DS", "Value": [22.5]},
        "1760": {"vr": "DS", "Value": [20.0]},
        "1761": {"vr": "DS", "Value": [22.5]},
        "1762": {"vr": "DS", "Value": [22.5]},
        "1763": {"vr": "DS", "Value": [20.0]},
        "1764": {"vr": "DS", "Value": [20.0]},
        "1765": {"vr": "DS", "Value": [22.5]},
        "1766": {"vr": "DS", "Value": [22.5]},
        "1767": {"vr": "DS", "Value": [22.5]},
        "1768": {"vr": "DS", "Value": [20.0]},
        "1769": {"vr": "DS", "Value": [22.5]},
        "1770": {"vr": "DS", "Value": [20.0]},
        "1771": {"vr": "DS", "Value": [20.0]},
        "1772": {"vr": "DS", "Value": [20.0]},
        "1773": {"vr": "DS", "Value": [20.0]},
        "1774": {"vr": "DS", "Value": [22.5]},
        "1775": {"vr": "DS", "Value": [22.5]},
        "1776": {"vr": "DS", "Value": [20.0]},
        "1777": {"vr": "DS", "Value": [22.5]},
        "1778": {"vr": "DS", "Value": [20.0]},
        "1779": {"vr": "DS", "Value": [22.5]},
        "1780": {"vr": "DS", "Value": [20.0]},
        "1781": {"vr": "DS", "Value": [20.0]},
        "1782": {"vr": "DS", "Value": [22.5]},
        "1783": {"vr": "DS", "Value": [20.0]},
        "1784": {"vr": "DS", "Value": [22.5]},
        "1785": {"vr": "DS", "Value": [20.0]},
        "1786": {"vr": "DS", "Value": [20.0]},
        "1787": {"vr": "DS", "Value": [20.0]},
        "1788": {"vr": "DS", "Value": [22.5]},
        "1789": {"vr": "DS", "Value": [20.0]},
        "1790": {"vr": "DS", "Value": [22.5]},
        "1791": {"vr": "DS", "Value": [22.5]},
        "1792": {"vr": "DS", "Value": [22.5]},
        "1793": {"vr": "DS", "Value": [20.0]},
        "1794": {"vr": "DS", "Value": [22.5]},
        "1795": {"vr": "DS", "Value": [22.5]},
        "1796": {"vr": "DS", "Value": [22.5]},
        "1797": {"vr": "DS", "Value": [22.5]},
        "1798": {"vr": "DS", "Value": [22.5]},
        "1799": {"vr": "DS", "Value": [20.0]},
        "1800": {"vr": "DS", "Value": [20.0]},
        "1801": {"vr": "DS", "Value": [22.5]},
        "1802": {"vr": "DS", "Value": [20.0]},
        "1803": {"vr": "DS", "Value": [22.5]},
        "1804": {"vr": "DS", "Value": [22.5]},
        "1805": {"vr": "DS", "Value": [20.0]},
        "1806": {"vr": "DS", "Value": [20.0]},
        "1807": {"vr": "DS", "Value": [22.5]},
        "1808": {"vr": "DS", "Value": [20.0]},
        "1809": {"vr": "DS", "Value": [20.0]},
        "1810": {"vr": "DS", "Value": [22.5]},
        "1811": {"vr": "DS", "Value": [20.0]},
        "1812": {"vr": "DS", "Value": [22.5]},
        "1813": {"vr": "DS", "Value": [20.0]},
        "1814": {"vr": "DS", "Value": [20.0]},
        "1815": {"vr": "DS", "Value": [22.5]},
        "1816": {"vr": "DS", "Value": [20.0]},
        "1817": {"vr": "DS", "Value": [20.0]},
        "1818": {"vr": "DS", "Value": [20.0]},
        "1819": {"vr": "DS", "Value": [20.0]},
        "1820": {"vr": "DS", "Value": [20.0]},
        "1821": {"vr": "DS", "Value": [22.5]},
        "1822": {"vr": "DS", "Value": [20.0]},
        "1823": {"vr": "DS", "Value": [20.0]},
        "1824": {"vr": "DS", "Value": [20.0]},
        "1825": {"vr": "DS", "Value": [20.0]},
        "1826": {"vr": "DS", "Value": [20.0]},
        "1827": {"vr": "DS", "Value": [22.5]},
        "1828": {"vr": "DS", "Value": [20.0]},
        "1829": {"vr": "DS", "Value": [22.5]},
        "1830": {"vr": "DS", "Value": [22.5]},
        "1831": {"vr": "DS", "Value": [22.5]},
        "1832": {"vr": "DS", "Value": [22.5]},
        "1833": {"vr": "DS", "Value": [22.5]},
        "1834": {"vr": "DS", "Value": [20.0]},
        "1835": {"vr": "DS", "Value": [22.5]},
        "1836": {"vr": "DS", "Value": [20.0]},
        "1837": {"vr": "DS", "Value": [20.0]},
        "1838": {"vr": "DS", "Value": [22.5]},
        "1839": {"vr": "DS", "Value": [22.5]},
        "1840": {"vr": "DS", "Value": [22.5]},
        "1841": {"vr": "DS", "Value": [22.5]},
        "1842": {"vr": "DS", "Value": [22.5]},
        "1843": {"vr": "DS", "Value": [22.5]},
        "1844": {"vr": "DS", "Value": [22.5]},
        "1845": {"vr": "DS", "Value": [20.0]},
        "1846": {"vr": "DS", "Value": [22.5]},
        "1847": {"vr": "DS", "Value": [20.0]},
        "1848": {"vr": "DS", "Value": [22.5]},
        "1849": {"vr": "DS", "Value": [22.5]},
        "1850": {"vr": "DS", "Value": [22.5]},
        "1851": {"vr": "DS", "Value": [22.5]},
        "1852": {"vr": "DS", "Value": [20.0]},
        "1853": {"vr": "DS", "Value": [20.0]},
        "1854": {"vr": "DS", "Value": [20.0]},
        "1855": {"vr": "DS", "Value": [20.0]},
        "1856": {"vr": "DS", "Value": [22.5]},
        "1857": {"vr": "DS", "Value": [20.0]},
        "1858": {"vr": "DS", "Value": [22.5]},
        "1859": {"vr": "DS", "Value": [22.5]},
        "1860": {"vr": "DS", "Value": [20.0]},
        "1861": {"vr": "DS", "Value": [20.0]},
        "1862": {"vr": "DS", "Value": [20.0]},
        "1863": {"vr": "DS", "Value": [20.0]},
        "1864": {"vr": "DS", "Value": [22.5]},
        "1865": {"vr": "DS", "Value": [20.0]},
        "1866": {"vr": "DS", "Value": [22.5]},
        "1867": {"vr": "DS", "Value": [20.0]},
        "1868": {"vr": "DS", "Value": [20.0]},
        "1869": {"vr": "DS", "Value": [20.0]},
        "1870": {"vr": "DS", "Value": [20.0]},
        "1871": {"vr": "DS", "Value": [22.5]},
        "1872": {"vr": "DS", "Value": [20.0]},
        "1873": {"vr": "DS", "Value": [20.0]},
        "1874": {"vr": "DS", "Value": [22.5]},
        "1875": {"vr": "DS", "Value": [22.5]},
        "1876": {"vr": "DS", "Value": [22.5]},
        "1877": {"vr": "DS", "Value": [22.5]},
        "1878": {"vr": "DS", "Value": [20.0]},
        "1879": {"vr": "DS", "Value": [20.0]},
        "1880": {"vr": "DS", "Value": [22.5]},
        "1881": {"vr": "DS", "Value": [20.0]},
        "1882": {"vr": "DS", "Value": [22.5]},
        "1883": {"vr": "DS", "Value": [20.0]},
        "1884": {"vr": "DS", "Value": [20.0]},
        "1885": {"vr": "DS", "Value": [20.0]},
        "1886": {"vr": "DS", "Value": [22.5]},
        "1887": {"vr": "DS", "Value": [20.0]},
        "1888": {"vr": "DS", "Value": [20.0]},
        "1889": {"vr": "DS", "Value": [22.5]},
        "1890": {"vr": "DS", "Value": [22.5]},
        "1891": {"vr": "DS", "Value": [20.0]},
        "1892": {"vr": "DS", "Value": [22.5]},
        "1893": {"vr": "DS", "Value": [22.5]},
        "1894": {"vr": "DS", "Value": [20.0]},
        "1895": {"vr": "DS", "Value": [22.5]},
        "1896": {"vr": "DS", "Value": [20.0]},
        "1897": {"vr": "DS", "Value": [22.5]},
        "1898": {"vr": "DS", "Value": [22.5]},
        "1899": {"vr": "DS", "Value": [20.0]},
        "1900": {"vr": "DS", "Value": [20.0]},
        "1901": {"vr": "DS", "Value": [22.5]},
        "1902": {"vr": "DS", "Value": [22.5]},
        "1903": {"vr": "DS", "Value": [22.5]},
        "1904": {"vr": "DS", "Value": [22.5]},
        "1905": {"vr": "DS", "Value": [22.5]},
        "1906": {"vr": "DS", "Value": [22.5]},
        "1907": {"vr": "DS", "Value": [20.0]},
        "1908": {"vr": "DS", "Value": [22.5]},
        "1909": {"vr": "DS", "Value": [22.5]},
        "1910": {"vr": "DS", "Value": [20.0]},
        "1911": {"vr": "DS", "Value": [22.5]},
        "1912": {"vr": "DS", "Value": [22.5]},
        "1913": {"vr": "DS", "Value": [20.0]},
        "1914": {"vr": "DS", "Value": [22.5]},
        "1915": {"vr": "DS", "Value": [22.5]},
        "1916": {"vr": "DS", "Value": [22.5]},
        "1917": {"vr": "DS", "Value": [20.0]},
        "1918": {"vr": "DS", "Value": [22.5]},
        "1919": {"vr": "DS", "Value": [22.5]},
        "1920": {"vr": "DS", "Value": [20.0]},
        "1921": {"vr": "DS", "Value": [22.5]},
        "1922": {"vr": "DS", "Value": [20.0]},
        "1923": {"vr": "DS", "Value": [20.0]},
        "1924": {"vr": "DS", "Value": [20.0]},
        "1925": {"vr": "DS", "Value": [20.0]},
        "1926": {"vr": "DS", "Value": [22.5]},
        "1927": {"vr": "DS", "Value": [22.5]},
        "1928": {"vr": "DS", "Value": [20.0]},
        "1929": {"vr": "DS", "Value": [22.5]},
        "1930": {"vr": "DS", "Value": [22.5]},
        "1931": {"vr": "DS", "Value": [22.5]},
        "1932": {"vr": "DS", "Value": [20.0]},
        "1933": {"vr": "DS", "Value": [22.5]},
        "1934": {"vr": "DS", "Value": [22.5]},
        "1935": {"vr": "DS", "Value": [22.5]},
        "1936": {"vr": "DS", "Value": [22.5]},
        "1937": {"vr": "DS", "Value": [20.0]},
        "1938": {"vr": "DS", "Value": [22.5]},
        "1939": {"vr": "DS", "Value": [20.0]},
        "1940": {"vr": "DS", "Value": [20.0]},
        "1941": {"vr": "DS", "Value": [22.5]},
        "1942": {"vr": "DS", "Value": [20.0]},
        "1943": {"vr": "DS", "Value": [20.0]},
        "1944": {"vr": "DS", "Value": [20.0]},
        "1945": {"vr": "DS", "Value": [22.5]},
        "1946": {"vr": "DS", "Value": [22.5]},
        "1947": {"vr": "DS", "Value": [20.0]},
        "1948": {"vr": "DS", "Value": [22.5]},
        "1949": {"vr": "DS", "Value": [22.5]},
        "1950": {"vr": "DS", "Value": [20.0]},
        "1951": {"vr": "DS", "Value": [20.0]},
        "1952": {"vr": "DS", "Value": [22.5]},
        "1953": {"vr": "DS", "Value": [20.0]},
        "1954": {"vr": "DS", "Value": [22.5]},
        "1955": {"vr": "DS", "Value": [20.0]},
        "1956": {"vr": "DS", "Value": [20.0]},
        "1957": {"vr": "DS", "Value": [22.5]},
        "1958": {"vr": "DS", "Value": [22.5]},
        "1959": {"vr": "DS", "Value": [22.5]},
        "1960": {"vr": "DS", "Value": [20.0]},
        "1961": {"vr": "DS", "Value": [22.5]},
        "1962": {"vr": "DS", "Value": [20.0]},
        "1963": {"vr": "DS", "Value": [20.0]},
        "1964": {"vr": "DS", "Value": [20.0]},
        "1965": {"vr": "DS", "Value": [20.0]},
        "1966": {"vr": "DS", "Value": [22.5]},
        "1967": {"vr": "DS", "Value": [20.0]},
        "1968": {"vr": "DS", "Value": [22.5]},
        "1969": {"vr": "DS", "Value": [22.5]},
        "1970": {"vr": "DS", "Value": [20.0]},
        "1971": {"vr": "DS", "Value": [22.5]},
        "1972": {"vr": "DS", "Value": [22.5]},
        "1973": {"vr": "DS", "Value": [22.5]},
        "1974": {"vr": "DS", "Value": [22.5]},
        "1975": {"vr": "DS", "Value": [20.0]},
        "1976": {"vr": "DS", "Value": [20.0]},
        "1977": {"vr": "DS", "Value": [20.0]},
        "1978": {"vr": "DS", "Value": [20.0]},
        "1979": {"vr": "DS", "Value": [22.5]},
        "1980": {"vr": "DS", "Value": [22.5]},
        "1981": {"vr": "DS", "Value": [22.5]},
        "1982": {"vr": "DS", "Value": [20.0]},
        "1983": {"vr": "DS", "Value": [22.5]},
        "1984": {"vr": "DS", "Value": [22.5]},
        "1985": {"vr": "DS", "Value": [20.0]},
        "1986": {"vr": "DS", "Value": [22.5]},
        "1987": {"vr": "DS", "Value": [22.5]},
        "1988": {"vr": "DS", "Value": [20.0]},
        "1989": {"vr": "DS", "Value": [20.0]},
        "1990": {"vr": "DS", "Value": [20.0]},
        "1991": {"vr": "DS", "Value": [20.0]},
        "1992": {"vr": "DS", "Value": [22.5]},
        "1993": {"vr": "DS", "Value": [22.5]},
        "1994": {"vr": "DS", "Value": [20.0]},
        "1995": {"vr": "DS", "Value": [20.0]},
        "1996": {"vr": "DS", "Value": [22.5]},
        "1997": {"vr": "DS", "Value": [20.0]},
        "1998": {"vr": "DS", "Value": [22.5]},
        "1999": {"vr": "DS", "Value": [20.0]},
        "2000": {"vr": "DS", "Value": [22.5]},
        "2001": {"vr": "DS", "Value": [20.0]},
        "2002": {"vr": "DS", "Value": [20.0]},
        "2003": {"vr": "DS", "Value": [22.5]},
        "2004": {"vr": "DS", "Value": [20.0]},
        "2005": {"vr": "DS", "Value": [20.0]},
        "2006": {"vr": "DS", "Value": [20.0]},
        "2007": {"vr": "DS", "Value": [22.5]},
        "2008": {"vr": "DS", "Value": [22.5]},
        "2009": {"vr": "DS", "Value": [22.5]},
        "2010": {"vr": "DS", "Value": [20.0]},
        "2011": {"vr": "DS", "Value": [20.0]},
        "2012": {"vr": "DS", "Value": [22.5]},
        "2013": {"vr": "DS", "Value": [22.5]},
        "2014": {"vr": "DS", "Value": [20.0]},
        "2015": {"vr": "DS", "Value": [20.0]},
        "2016": {"vr": "DS", "Value": [22.5]},
        "2017": {"vr": "DS", "Value": [20.0]},
        "2018": {"vr": "DS", "Value": [22.5]},
        "2019": {"vr": "DS", "Value": [20.0]},
        "2020": {"vr": "DS", "Value": [20.0]},
        "2021": {"vr": "DS", "Value": [22.5]},
        "2022": {"vr": "DS", "Value": [20.0]},
        "2023": {"vr": "DS", "Value": [20.0]},
        "2024": {"vr": "DS", "Value": [22.5]},
        "2025": {"vr": "DS", "Value": [22.5]},
        "2026": {"vr": "DS", "Value": [22.5]},
        "2027": {"vr": "DS", "Value": [22.5]},
        "2028": {"vr": "DS", "Value": [20.0]},
        "2029": {"vr": "DS", "Value": [20.0]},
        "2030": {"vr": "DS", "Value": [20.0]},
        "2031": {"vr": "DS", "Value": [20.0]},
        "2032": {"vr": "DS", "Value": [22.5]},
        "2033": {"vr": "DS", "Value": [22.5]},
        "2034": {"vr": "DS", "Value": [22.5]},
        "2035": {"vr": "DS", "Value": [22.5]},
        "2036": {"vr": "DS", "Value": [22.5]},
        "2037": {"vr": "DS", "Value": [22.5]},
        "2038": {"vr": "DS", "Value": [22.5]},
        "2039": {"vr": "DS", "Value": [20.0]},
        "2040": {"vr": "DS", "Value": [22.5]},
        "2041": {"vr": "DS", "Value": [20.0]},
        "2042": {"vr": "DS", "Value": [22.5]},
        "2043": {"vr": "DS", "Value": [22.5]},
        "2044": {"vr": "DS", "Value": [22.5]},
        "2045": {"vr": "DS", "Value": [22.5]},
        "2046": {"vr": "DS", "Value": [20.0]},
        "2047": {"vr": "DS", "Value": [20.0]},
        "2048": {"vr": "DS", "Value": [20.0]},
        "2049": {"vr": "DS", "Value": [20.0]},
        "2050": {"vr": "DS", "Value": [22.5]},
        "2051": {"vr": "DS", "Value": [20.0]},
        "2052": {"vr": "DS", "Value": [22.5]},
        "2053": {"vr": "DS", "Value": [22.5]},
        "2054": {"vr": "DS", "Value": [20.0]},
        "2055": {"vr": "DS", "Value": [20.0]},
        "2056": {"vr": "DS", "Value": [20.0]},
        "2057": {"vr": "DS", "Value": [22.5]},
        "2058": {"vr": "DS", "Value": [20.0]},
        "2059": {"vr": "DS", "Value": [20.0]},
        "2060": {"vr": "DS", "Value": [22.5]},
        "2061": {"vr": "DS", "Value": [22.5]},
        "2062": {"vr": "DS", "Value": [22.5]},
        "2063": {"vr": "DS", "Value": [22.5]},
        "2064": {"vr": "DS", "Value": [22.5]},
        "2065": {"vr": "DS", "Value": [22.5]},
        "2066": {"vr": "DS", "Value": [20.0]},
        "2067": {"vr": "DS", "Value": [22.5]},
        "2068": {"vr": "DS", "Value": [20.0]},
        "2069": {"vr": "DS", "Value": [22.5]},
        "2070": {"vr": "DS", "Value": [20.0]},
        "2071": {"vr": "DS", "Value": [22.5]},
        "2072": {"vr": "DS", "Value": [20.0]},
        "2073": {"vr": "DS", "Value": [22.5]},
        "2074": {"vr": "DS", "Value": [22.5]},
        "2075": {"vr": "DS", "Value": [20.0]},
        "2076": {"vr": "DS", "Value": [22.5]},
        "2077": {"vr": "DS", "Value": [22.5]},
        "2078": {"vr": "DS", "Value": [20.0]},
        "2079": {"vr": "DS", "Value": [20.0]},
        "2080": {"vr": "DS", "Value": [20.0]},
        "2081": {"vr": "DS", "Value": [22.5]},
        "2082": {"vr": "DS", "Value": [22.5]},
        "2083": {"vr": "DS", "Value": [20.0]},
        "2084": {"vr": "DS", "Value": [20.0]},
        "2085": {"vr": "DS", "Value": [22.5]},
        "2086": {"vr": "DS", "Value": [22.5]},
        "2087": {"vr": "DS", "Value": [20.0]},
        "2088": {"vr": "DS", "Value": [20.0]},
        "2089": {"vr": "DS", "Value": [20.0]},
        "2090": {"vr": "DS", "Value": [22.5]},
        "2091": {"vr": "DS", "Value": [20.0]},
        "2092": {"vr": "DS", "Value": [22.5]},
        "2093": {"vr": "DS", "Value": [22.5]},
        "2094": {"vr": "DS", "Value": [20.0]},
        "2095": {"vr": "DS", "Value": [22.5]},
        "2096": {"vr": "DS", "Value": [20.0]},
        "2097": {"vr": "DS", "Value": [20.0]},
        "2098": {"vr": "DS", "Value": [20.0]},
        "2099": {"vr": "DS", "Value": [20.0]},
        "2100": {"vr": "DS", "Value": [22.5]},
        "2101": {"vr": "DS", "Value": [22.5]},
        "2102": {"vr": "DS", "Value": [22.5]},
        "2103": {"vr": "DS", "Value": [22.5]},
        "2104": {"vr": "DS", "Value": [22.5]},
        "2105": {"vr": "DS", "Value": [22.5]},
        "2106": {"vr": "DS", "Value": [22.5]},
        "2107": {"vr": "DS", "Value": [22.5]},
        "2108": {"vr": "DS", "Value": [22.5]},
        "2109": {"vr": "DS", "Value": [20.0]},
        "2110": {"vr": "DS", "Value": [20.0]},
        "2111": {"vr": "DS", "Value": [22.5]},
        "2112": {"vr": "DS", "Value": [20.0]},
        "2113": {"vr": "DS", "Value": [20.0]},
        "2114": {"vr": "DS", "Value": [22.5]},
        "2115": {"vr": "DS", "Value": [22.5]},
        "2116": {"vr": "DS", "Value": [20.0]},
        "2117": {"vr": "DS", "Value": [22.5]},
        "2118": {"vr": "DS", "Value": [20.0]},
        "2119": {"vr": "DS", "Value": [20.0]},
        "2120": {"vr": "DS", "Value": [20.0]},
        "2121": {"vr": "DS", "Value": [22.5]},
        "2122": {"vr": "DS", "Value": [20.0]},
        "2123": {"vr": "DS", "Value": [20.0]},
        "2124": {"vr": "DS", "Value": [22.5]},
        "2125": {"vr": "DS", "Value": [22.5]},
        "2126": {"vr": "DS", "Value": [22.5]},
        "2127": {"vr": "DS", "Value": [20.0]},
        "2128": {"vr": "DS", "Value": [20.0]},
        "2129": {"vr": "DS", "Value": [22.5]},
        "2130": {"vr": "DS", "Value": [20.0]},
        "2131": {"vr": "DS", "Value": [20.0]},
        "2132": {"vr": "DS", "Value": [20.0]},
        "2133": {"vr": "DS", "Value": [22.5]},
        "2134": {"vr": "DS", "Value": [20.0]},
        "2135": {"vr": "DS", "Value": [22.5]},
        "2136": {"vr": "DS", "Value": [20.0]},
        "2137": {"vr": "DS", "Value": [20.0]},
        "2138": {"vr": "DS", "Value": [20.0]},
        "2139": {"vr": "DS", "Value": [20.0]},
        "2140": {"vr": "DS", "Value": [20.0]},
        "2141": {"vr": "DS", "Value": [20.0]},
        "2142": {"vr": "DS", "Value": [20.0]},
        "2143": {"vr": "DS", "Value": [20.0]},
        "2144": {"vr": "DS", "Value": [22.5]},
        "2145": {"vr": "DS", "Value": [22.5]},
        "2146": {"vr": "DS", "Value": [20.0]},
        "2147": {"vr": "DS", "Value": [20.0]},
        "2148": {"vr": "DS", "Value": [20.0]},
        "2149": {"vr": "DS", "Value": [22.5]},
        "2150": {"vr": "DS", "Value": [22.5]},
        "2151": {"vr": "DS", "Value": [20.0]},
        "2152": {"vr": "DS", "Value": [20.0]},
        "2153": {"vr": "DS", "Value": [22.5]},
        "2154": {"vr": "DS", "Value": [20.0]},
        "2155": {"vr": "DS", "Value": [20.0]},
        "2156": {"vr": "DS", "Value": [22.5]},
        "2157": {"vr": "DS", "Value": [22.5]},
        "2158": {"vr": "DS", "Value": [20.0]},
        "2159": {"vr": "DS", "Value": [20.0]},
        "2160": {"vr": "DS", "Value": [20.0]},
        "2161": {"vr": "DS", "Value": [20.0]},
        "2162": {"vr": "DS", "Value": [20.0]},
        "2163": {"vr": "DS", "Value": [20.0]},
        "2164": {"vr": "DS", "Value": [22.5]},
        "2165": {"vr": "DS", "Value": [22.5]},
        "2166": {"vr": "DS", "Value": [22.5]},
        "2167": {"vr": "DS", "Value": [22.5]},
        "2168": {"vr": "DS", "Value": [20.0]},
        "2169": {"vr": "DS", "Value": [22.5]},
        "2170": {"vr": "DS", "Value": [22.5]},
        "2171": {"vr": "DS", "Value": [20.0]},
        "2172": {"vr": "DS", "Value": [22.5]},
        "2173": {"vr": "DS", "Value": [22.5]},
        "2174": {"vr": "DS", "Value": [20.0]},
        "2175": {"vr": "DS", "Value": [20.0]},
        "2176": {"vr": "DS", "Value": [22.5]},
        "2177": {"vr": "DS", "Value": [22.5]},
        "2178": {"vr": "DS", "Value": [22.5]},
        "2179": {"vr": "DS", "Value": [22.5]},
        "2180": {"vr": "DS", "Value": [20.0]},
        "2181": {"vr": "DS", "Value": [20.0]},
        "2182": {"vr": "DS", "Value": [22.5]},
        "2183": {"vr": "DS", "Value": [22.5]},
        "2184": {"vr": "DS", "Value": [22.5]},
        "2185": {"vr": "DS", "Value": [22.5]},
        "2186": {"vr": "DS", "Value": [20.0]},
        "2187": {"vr": "DS", "Value": [20.0]},
        "2188": {"vr": "DS", "Value": [22.5]},
        "2189": {"vr": "DS", "Value": [20.0]},
        "2190": {"vr": "DS", "Value": [20.0]},
        "2191": {"vr": "DS", "Value": [20.0]},
        "2192": {"vr": "DS", "Value": [20.0]},
        "2193": {"vr": "DS", "Value": [22.5]},
        "2194": {"vr": "DS", "Value": [22.5]},
        "2195": {"vr": "DS", "Value": [20.0]},
        "2196": {"vr": "DS", "Value": [22.5]},
        "2197": {"vr": "DS", "Value": [22.5]},
        "2198": {"vr": "DS", "Value": [20.0]},
        "2199": {"vr": "DS", "Value": [20.0]},
        "2200": {"vr": "DS", "Value": [20.0]},
        "2201": {"vr": "DS", "Value": [20.0]},
        "2202": {"vr": "DS", "Value": [20.0]},
        "2203": {"vr": "DS", "Value": [20.0]},
        "2204": {"vr": "DS", "Value": [20.0]},
        "2205": {"vr": "DS", "Value": [22.5]},
        "2206": {"vr": "DS", "Value": [20.0]},
        "2207": {"vr": "DS", "Value": [20.0]},
        "2208": {"vr": "DS", "Value": [22.5]},
        "2209": {"vr": "DS", "Value": [20.0]},
        "2210": {"vr": "DS", "Value": [20.0]},
        "2211": {"vr": "DS", "Value": [22.5]},
        "2212": {"vr": "DS", "Value": [22.5]},
        "2213": {"vr": "DS", "Value": [22.5]},
        "2214": {"vr": "DS", "Value": [20.0]},
        "2215": {"vr": "DS", "Value": [20.0]},
        "2216": {"vr": "DS", "Value": [20.0]},
        "2217": {"vr": "DS", "Value": [22.5]},
        "2218": {"vr": "DS", "Value": [22.5]},
        "2219": {"vr": "DS", "Value": [22.5]},
        "2220": {"vr": "DS", "Value": [20.0]},
        "2221": {"vr": "DS", "Value": [22.5]},
        "2222": {"vr": "DS", "Value": [22.5]},
        "2223": {"vr": "DS", "Value": [20.0]},
        "2224": {"vr": "DS", "Value": [22.5]},
        "2225": {"vr": "DS", "Value": [22.5]},
        "2226": {"vr": "DS", "Value": [20.0]},
        "2227": {"vr": "DS", "Value": [22.5]},
        "2228": {"vr": "DS", "Value": [22.5]},
        "2229": {"vr": "DS", "Value": [22.5]},
        "2230": {"vr": "DS", "Value": [20.0]},
        "2231": {"vr": "DS", "Value": [22.5]},
        "2232": {"vr": "DS", "Value": [20.0]},
        "2233": {"vr": "DS", "Value": [20.0]},
        "2234": {"vr": "DS", "Value": [22.5]},
        "2235": {"vr": "DS", "Value": [20.0]},
        "2236": {"vr": "DS", "Value": [22.5]},
        "2237": {"vr": "DS", "Value": [20.0]},
        "2238": {"vr": "DS", "Value": [20.0]},
        "2239": {"vr": "DS", "Value": [22.5]},
        "2240": {"vr": "DS", "Value": [20.0]},
        "2241": {"vr": "DS", "Value": [20.0]},
        "2242": {"vr": "DS", "Value": [22.5]},
        "2243": {"vr": "DS", "Value": [22.5]},
        "2244": {"vr": "DS", "Value": [20.0]},
        "2245": {"vr": "DS", "Value": [22.5]},
        "2246": {"vr": "DS", "Value": [20.0]},
        "2247": {"vr": "DS", "Value": [20.0]},
        "2248": {"vr": "DS", "Value": [20.0]},
        "2249": {"vr": "DS", "Value": [22.5]},
        "2250": {"vr": "DS", "Value": [20.0]},
        "2251": {"vr": "DS", "Value": [20.0]},
        "2252": {"vr": "DS", "Value": [22.5]},
        "2253": {"vr": "DS", "Value": [22.5]},
        "2254": {"vr": "DS", "Value": [20.0]},
        "2255": {"vr": "DS", "Value": [22.5]},
        "2256": {"vr": "DS", "Value": [20.0]},
        "2257": {"vr": "DS", "Value": [20.0]},
        "2258": {"vr": "DS", "Value": [22.5]},
        "2259": {"vr": "DS", "Value": [22.5]},
        "2260": {"vr": "DS", "Value": [22.5]},
        "2261": {"vr": "DS", "Value": [22.5]},
        "2262": {"vr": "DS", "Value": [22.5]},
        "2263": {"vr": "DS", "Value": [22.5]},
        "2264": {"vr": "DS", "Value": [22.5]},
        "2265": {"vr": "DS", "Value": [20.0]},
        "2266": {"vr": "DS", "Value": [20.0]},
        "2267": {"vr": "DS", "Value": [20.0]},
        "2268": {"vr": "DS", "Value": [22.5]},
        "2269": {"vr": "DS", "Value": [20.0]},
        "2270": {"vr": "DS", "Value": [20.0]},
        "2271": {"vr": "DS", "Value": [22.5]},
        "2272": {"vr": "DS", "Value": [22.5]},
        "2273": {"vr": "DS", "Value": [20.0]},
        "2274": {"vr": "DS", "Value": [22.5]},
        "2275": {"vr": "DS", "Value": [22.5]},
        "2276": {"vr": "DS", "Value": [22.5]},
        "2277": {"vr": "DS", "Value": [20.0]},
        "2278": {"vr": "DS", "Value": [20.0]},
        "2279": {"vr": "DS", "Value": [22.5]},
        "2280": {"vr": "DS", "Value": [22.5]},
        "2281": {"vr": "DS", "Value": [20.0]},
        "2282": {"vr": "DS", "Value": [20.0]},
        "2283": {"vr": "DS", "Value": [20.0]},
        "2284": {"vr": "DS", "Value": [20.0]},
        "2285": {"vr": "DS", "Value": [20.0]},
        "2286": {"vr": "DS", "Value": [22.5]},
        "2287": {"vr": "DS", "Value": [20.0]},
        "2288": {"vr": "DS", "Value": [22.5]},
        "2289": {"vr": "DS", "Value": [20.0]},
        "2290": {"vr": "DS", "Value": [22.5]},
        "2291": {"vr": "DS", "Value": [20.0]},
        "2292": {"vr": "DS", "Value": [22.5]},
        "2293": {"vr": "DS", "Value": [20.0]},
        "2294": {"vr": "DS", "Value": [22.5]},
        "2295": {"vr": "DS", "Value": [22.5]},
        "2296": {"vr": "DS", "Value": [20.0]},
        "2297": {"vr": "DS", "Value": [20.0]},
        "2298": {"vr": "DS", "Value": [20.0]},
        "2299": {"vr": "DS", "Value": [20.0]},
        "2300": {"vr": "DS", "Value": [22.5]},
        "2301": {"vr": "DS", "Value": [22.5]},
        "2302": {"vr": "DS", "Value": [22.5]},
        "2303": {"vr": "DS", "Value": [22.5]},
        "2304": {"vr": "DS", "Value": [22.5]},
        "2305": {"vr": "DS", "Value": [22.5]},
        "2306": {"vr": "DS", "Value": [22.5]},
        "2307": {"vr": "DS", "Value": [20.0]},
        "2308": {"vr": "DS", "Value": [22.5]},
        "2309": {"vr": "DS", "Value": [20.0]},
        "2310": {"vr": "DS", "Value": [22.5]},
        "2311": {"vr": "DS", "Value": [20.0]},
        "2312": {"vr": "DS", "Value": [22.5]},
        "2313": {"vr": "DS", "Value": [22.5]},
        "2314": {"vr": "DS", "Value": [20.0]},
        "2315": {"vr": "DS", "Value": [22.5]},
        "2316": {"vr": "DS", "Value": [22.5]},
        "2317": {"vr": "DS", "Value": [22.5]},
        "2318": {"vr": "DS", "Value": [20.0]},
        "2319": {"vr": "DS", "Value": [20.0]},
        "2320": {"vr": "DS", "Value": [20.0]},
        "2321": {"vr": "DS", "Value": [22.5]},
        "2322": {"vr": "DS", "Value": [22.5]},
        "2323": {"vr": "DS", "Value": [20.0]},
        "2324": {"vr": "DS", "Value": [22.5]},
        "2325": {"vr": "DS", "Value": [22.5]},
        "2326": {"vr": "DS", "Value": [20.0]},
        "2327": {"vr": "DS", "Value": [22.5]},
        "2328": {"vr": "DS", "Value": [22.5]},
        "2329": {"vr": "DS", "Value": [20.0]},
        "2330": {"vr": "DS", "Value": [22.5]},
        "2331": {"vr": "DS", "Value": [22.5]},
        "2332": {"vr": "DS", "Value": [22.5]},
        "2333": {"vr": "DS", "Value": [22.5]},
        "2334": {"vr": "DS", "Value": [20.0]},
        "2335": {"vr": "DS", "Value": [20.0]},
        "2336": {"vr": "DS", "Value": [22.5]},
        "2337": {"vr": "DS", "Value": [22.5]},
        "2338": {"vr": "DS", "Value": [22.5]},
        "2339": {"vr": "DS", "Value": [22.5]},
        "2340": {"vr": "DS", "Value": [20.0]},
        "2341": {"vr": "DS", "Value": [20.0]},
        "2342": {"vr": "DS", "Value": [20.0]},
        "2343": {"vr": "DS", "Value": [22.5]},
        "2344": {"vr": "DS", "Value": [20.0]},
        "2345": {"vr": "DS", "Value": [20.0]},
        "2346": {"vr": "DS", "Value": [22.5]},
        "2347": {"vr": "DS", "Value": [22.5]},
        "2348": {"vr": "DS", "Value": [20.0]},
        "2349": {"vr": "DS", "Value": [22.5]},
        "2350": {"vr": "DS", "Value": [20.0]},
        "2351": {"vr": "DS", "Value": [22.5]},
        "2352": {"vr": "DS", "Value": [22.5]},
        "2353": {"vr": "DS", "Value": [22.5]},
        "2354": {"vr": "DS", "Value": [20.0]},
        "2355": {"vr": "DS", "Value": [22.5]},
        "2356": {"vr": "DS", "Value": [22.5]},
        "2357": {"vr": "DS", "Value": [22.5]},
        "2358": {"vr": "DS", "Value": [22.5]},
        "2359": {"vr": "DS", "Value": [22.5]},
        "2360": {"vr": "DS", "Value": [20.0]},
        "2361": {"vr": "DS", "Value": [22.5]},
        "2362": {"vr": "DS", "Value": [22.5]},
        "2363": {"vr": "DS", "Value": [20.0]},
        "2364": {"vr": "DS", "Value": [20.0]},
        "2365": {"vr": "DS", "Value": [22.5]},
        "2366": {"vr": "DS", "Value": [20.0]},
        "2367": {"vr": "DS", "Value": [20.0]},
        "2368": {"vr": "DS", "Value": [22.5]},
        "2369": {"vr": "DS", "Value": [20.0]},
        "2370": {"vr": "DS", "Value": [20.0]},
        "2371": {"vr": "DS", "Value": [22.5]},
        "2372": {"vr": "DS", "Value": [20.0]},
        "2373": {"vr": "DS", "Value": [22.5]},
        "2374": {"vr": "DS", "Value": [22.5]},
        "2375": {"vr": "DS", "Value": [20.0]},
        "2376": {"vr": "DS", "Value": [20.0]},
        "2377": {"vr": "DS", "Value": [22.5]},
        "2378": {"vr": "DS", "Value": [22.5]},
        "2379": {"vr": "DS", "Value": [22.5]},
        "2380": {"vr": "DS", "Value": [20.0]},
        "2381": {"vr": "DS", "Value": [22.5]},
        "2382": {"vr": "DS", "Value": [22.5]},
        "2383": {"vr": "DS", "Value": [22.5]},
        "2384": {"vr": "DS", "Value": [22.5]},
        "2385": {"vr": "DS", "Value": [20.0]},
        "2386": {"vr": "DS", "Value": [20.0]},
        "2387": {"vr": "DS", "Value": [20.0]},
        "2388": {"vr": "DS", "Value": [20.0]},
        "2389": {"vr": "DS", "Value": [22.5]},
        "2390": {"vr": "DS", "Value": [20.0]},
        "2391": {"vr": "DS", "Value": [20.0]},
        "2392": {"vr": "DS", "Value": [20.0]},
        "2393": {"vr": "DS", "Value": [20.0]},
        "2394": {"vr": "DS", "Value": [20.0]},
        "2395": {"vr": "DS", "Value": [20.0]},
        "2396": {"vr": "DS", "Value": [22.5]},
        "2397": {"vr": "DS", "Value": [20.0]},
        "2398": {"vr": "DS", "Value": [20.0]},
        "2399": {"vr": "DS", "Value": [22.5]},
        "2400": {"vr": "DS", "Value": [22.5]},
        "2401": {"vr": "DS", "Value": [22.5]},
        "2402": {"vr": "DS", "Value": [22.5]},
        "2403": {"vr": "DS", "Value": [20.0]},
        "2404": {"vr": "DS", "Value": [20.0]},
        "2405": {"vr": "DS", "Value": [20.0]},
        "2406": {"vr": "DS", "Value": [22.5]},
        "2407": {"vr": "DS", "Value": [22.5]},
        "2408": {"vr": "DS", "Value": [20.0]},
        "2409": {"vr": "DS", "Value": [20.0]},
        "2410": {"vr": "DS", "Value": [20.0]},
        "2411": {"vr": "DS", "Value": [22.5]},
        "2412": {"vr": "DS", "Value": [22.5]},
        "2413": {"vr": "DS", "Value": [22.5]},
        "2414": {"vr": "DS", "Value": [20.0]},
        "2415": {"vr": "DS", "Value": [20.0]},
        "2416": {"vr": "DS", "Value": [22.5]},
        "2417": {"vr": "DS", "Value": [22.5]},
        "2418": {"vr": "DS", "Value": [20.0]},
        "2419": {"vr": "DS", "Value": [22.5]},
        "2420": {"vr": "DS", "Value": [20.0]},
        "2421": {"vr": "DS", "Value": [22.5]},
        "2422": {"vr": "DS", "Value": [20.0]},
        "2423": {"vr": "DS", "Value": [22.5]},
        "2424": {"vr": "DS", "Value": [20.0]},
        "2425": {"vr": "DS", "Value": [20.0]},
        "2426": {"vr": "DS", "Value": [22.5]},
        "2427": {"vr": "DS", "Value": [22.5]},
        "2428": {"vr": "DS", "Value": [20.0]},
        "2429": {"vr": "DS", "Value": [20.0]},
        "2430": {"vr": "DS", "Value": [20.0]},
        "2431": {"vr": "DS", "Value": [22.5]},
        "2432": {"vr": "DS", "Value": [22.5]},
        "2433": {"vr": "DS", "Value": [20.0]},
        "2434": {"vr": "DS", "Value": [22.5]},
        "2435": {"vr": "DS", "Value": [20.0]},
        "2436": {"vr": "DS", "Value": [20.0]},
        "2437": {"vr": "DS", "Value": [20.0]},
        "2438": {"vr": "DS", "Value": [20.0]},
        "2439": {"vr": "DS", "Value": [20.0]},
        "2440": {"vr": "DS", "Value": [22.5]},
        "2441": {"vr": "DS", "Value": [22.5]},
        "2442": {"vr": "DS", "Value": [22.5]},
        "2443": {"vr": "DS", "Value": [22.5]},
        "2444": {"vr": "DS", "Value": [22.5]},
        "2445": {"vr": "DS", "Value": [22.5]},
        "2446": {"vr": "DS", "Value": [22.5]},
        "2447": {"vr": "DS", "Value": [22.5]},
        "2448": {"vr": "DS", "Value": [22.5]},
        "2449": {"vr": "DS", "Value": [20.0]},
        "2450": {"vr": "DS", "Value": [22.5]},
        "2451": {"vr": "DS", "Value": [22.5]},
        "2452": {"vr": "DS", "Value": [20.0]},
        "2453": {"vr": "DS", "Value": [22.5]},
        "2454": {"vr": "DS", "Value": [20.0]},
        "2455": {"vr": "DS", "Value": [20.0]},
        "2456": {"vr": "DS", "Value": [20.0]},
        "2457": {"vr": "DS", "Value": [22.5]},
        "2458": {"vr": "DS", "Value": [20.0]},
        "2459": {"vr": "DS", "Value": [22.5]},
        "2460": {"vr": "DS", "Value": [20.0]},
        "2461": {"vr": "DS", "Value": [20.0]},
        "2462": {"vr": "DS", "Value": [20.0]},
        "2463": {"vr": "DS", "Value": [20.0]},
        "2464": {"vr": "DS", "Value": [22.5]},
        "2465": {"vr": "DS", "Value": [20.0]},
        "2466": {"vr": "DS", "Value": [20.0]},
        "2467": {"vr": "DS", "Value": [20.0]},
        "2468": {"vr": "DS", "Value": [20.0]},
        "2469": {"vr": "DS", "Value": [22.5]},
        "2470": {"vr": "DS", "Value": [20.0]},
        "2471": {"vr": "DS", "Value": [22.5]},
        "2472": {"vr": "DS", "Value": [22.5]},
        "2473": {"vr": "DS", "Value": [22.5]},
        "2474": {"vr": "DS", "Value": [20.0]},
        "2475": {"vr": "DS", "Value": [22.5]},
        "2476": {"vr": "DS", "Value": [22.5]},
        "2477": {"vr": "DS", "Value": [20.0]},
        "2478": {"vr": "DS", "Value": [20.0]},
        "2479": {"vr": "DS", "Value": [20.0]},
        "2480": {"vr": "DS", "Value": [22.5]},
        "2481": {"vr": "DS", "Value": [22.5]},
        "2482": {"vr": "DS", "Value": [20.0]},
        "2483": {"vr": "DS", "Value": [20.0]},
        "2484": {"vr": "DS", "Value": [22.5]},
        "2485": {"vr": "DS", "Value": [22.5]},
        "2486": {"vr": "DS", "Value": [22.5]},
        "2487": {"vr": "DS", "Value": [20.0]},
        "2488": {"vr": "DS", "Value": [20.0]},
        "2489": {"vr": "DS", "Value": [22.5]},
        "2490": {"vr": "DS", "Value": [20.0]},
        "2491": {"vr": "DS", "Value": [20.0]},
        "2492": {"vr": "DS", "Value": [20.0]},
        "2493": {"vr": "DS", "Value": [20.0]},
        "2494": {"vr": "DS", "Value": [22.5]},
        "2495": {"vr": "DS", "Value": [22.5]},
        "2496": {"vr": "DS", "Value": [20.0]},
        "2497": {"vr": "DS", "Value": [20.0]},
        "2498": {"vr": "DS", "Value": [22.5]},
        "2499": {"vr": "DS", "Value": [22.5]},
        "2500": {"vr": "DS", "Value": [22.5]},
        "2501": {"vr": "DS", "Value": [22.5]},
        "2502": {"vr": "DS", "Value": [20.0]},
        "2503": {"vr": "DS", "Value": [22.5]},
        "2504": {"vr": "DS", "Value": [22.5]},
        "2505": {"vr": "DS", "Value": [22.5]},
        "2506": {"vr": "DS", "Value": [20.0]},
        "2507": {"vr": "DS", "Value": [20.0]},
        "2508": {"vr": "DS", "Value": [22.5]},
        "2509": {"vr": "DS", "Value": [22.5]},
        "2510": {"vr": "DS", "Value": [22.5]},
        "2511": {"vr": "DS", "Value": [20.0]},
        "2512": {"vr": "DS", "Value": [20.0]},
        "2513": {"vr": "DS", "Value": [22.5]},
        "2514": {"vr": "DS", "Value": [20.0]},
        "2515": {"vr": "DS", "Value": [20.0]},
        "2516": {"vr": "DS", "Value": [20.0]},
        "2517": {"vr": "DS", "Value": [20.0]},
        "2518": {"vr": "DS", "Value": [22.5]},
        "2519": {"vr": "DS", "Value": [20.0]},
        "2520": {"vr": "DS", "Value": [20.0]},
        "2521": {"vr": "DS", "Value": [20.0]},
        "2522": {"vr": "DS", "Value": [20.0]},
        "2523": {"vr": "DS", "Value": [20.0]},
        "2524": {"vr": "DS", "Value": [20.0]},
        "2525": {"vr": "DS", "Value": [22.5]},
        "2526": {"vr": "DS", "Value": [20.0]},
        "2527": {"vr": "DS", "Value": [22.5]},
        "2528": {"vr": "DS", "Value": [22.5]},
        "2529": {"vr": "DS", "Value": [20.0]},
        "2530": {"vr": "DS", "Value": [22.5]},
        "2531": {"vr": "DS", "Value": [20.0]},
        "2532": {"vr": "DS", "Value": [22.5]},
        "2533": {"vr": "DS", "Value": [20.0]},
        "2534": {"vr": "DS", "Value": [22.5]},
        "2535": {"vr": "DS", "Value": [20.0]},
        "2536": {"vr": "DS", "Value": [22.5]},
        "2537": {"vr": "DS", "Value": [20.0]},
        "2538": {"vr": "DS", "Value": [22.5]},
        "2539": {"vr": "DS", "Value": [20.0]},
        "2540": {"vr": "DS", "Value": [22.5]},
        "2541": {"vr": "DS", "Value": [22.5]},
        "2542": {"vr": "DS", "Value": [20.0]},
        "2543": {"vr": "DS", "Value": [22.5]},
        "2544": {"vr": "DS", "Value": [22.5]},
        "2545": {"vr": "DS", "Value": [22.5]},
        "2546": {"vr": "DS", "Value": [22.5]},
        "2547": {"vr": "DS", "Value": [22.5]},
        "2548": {"vr": "DS", "Value": [22.5]},
        "2549": {"vr": "DS", "Value": [22.5]},
        "2550": {"vr": "DS", "Value": [20.0]},
        "2551": {"vr": "DS", "Value": [22.5]},
        "2552": {"vr": "DS", "Value": [22.5]},
        "2553": {"vr": "DS", "Value": [20.0]},
        "2554": {"vr": "DS", "Value": [22.5]},
        "2555": {"vr": "DS", "Value": [22.5]},
        "2556": {"vr": "DS", "Value": [22.5]},
        "2557": {"vr": "DS", "Value": [22.5]},
        "2558": {"vr": "DS", "Value": [22.5]},
        "2559": {"vr": "DS", "Value": [20.0]},
        "2560": {"vr": "DS", "Value": [20.0]},
        "2561": {"vr": "DS", "Value": [22.5]},
        "2562": {"vr": "DS", "Value": [20.0]},
        "2563": {"vr": "DS", "Value": [20.0]},
        "2564": {"vr": "DS", "Value": [20.0]},
        "2565": {"vr": "DS", "Value": [20.0]},
        "2566": {"vr": "DS", "Value": [22.5]},
        "2567": {"vr": "DS", "Value": [20.0]},
        "2568": {"vr": "DS", "Value": [20.0]},
        "2569": {"vr": "DS", "Value": [20.0]},
        "2570": {"vr": "DS", "Value": [22.5]},
        "2571": {"vr": "DS", "Value": [22.5]},
        "2572": {"vr": "DS", "Value": [20.0]},
        "2573": {"vr": "DS", "Value": [22.5]},
        "2574": {"vr": "DS", "Value": [22.5]},
        "2575": {"vr": "DS", "Value": [20.0]},
        "2576": {"vr": "DS", "Value": [22.5]},
        "2577": {"vr": "DS", "Value": [20.0]},
        "2578": {"vr": "DS", "Value": [20.0]},
        "2579": {"vr": "DS", "Value": [20.0]},
        "2580": {"vr": "DS", "Value": [22.5]},
        "2581": {"vr": "DS", "Value": [22.5]},
        "2582": {"vr": "DS", "Value": [22.5]},
        "2583": {"vr": "DS", "Value": [22.5]},
        "2584": {"vr": "DS", "Value": [22.5]},
        "2585": {"vr": "DS", "Value": [22.5]},
        "2586": {"vr": "DS", "Value": [22.5]},
        "2587": {"vr": "DS", "Value": [20.0]},
        "2588": {"vr": "DS", "Value": [22.5]},
        "2589": {"vr": "DS", "Value": [20.0]},
        "2590": {"vr": "DS", "Value": [20.0]},
        "2591": {"vr": "DS", "Value": [22.5]},
        "2592": {"vr": "DS", "Value": [20.0]},
        "2593": {"vr": "DS", "Value": [22.5]},
        "2594": {"vr": "DS", "Value": [20.0]},
        "2595": {"vr": "DS", "Value": [20.0]},
        "2596": {"vr": "DS", "Value": [22.5]},
        "2597": {"vr": "DS", "Value": [20.0]},
        "2598": {"vr": "DS", "Value": [22.5]},
        "2599": {"vr": "DS", "Value": [20.0]},
        "2600": {"vr": "DS", "Value": [22.5]},
        "2601": {"vr": "DS", "Value": [22.5]},
        "2602": {"vr": "DS", "Value": [20.0]},
        "2603": {"vr": "DS", "Value": [22.5]},
        "2604": {"vr": "DS", "Value": [20.0]},
        "2605": {"vr": "DS", "Value": [20.0]},
        "2606": {"vr": "DS", "Value": [20.0]},
        "2607": {"vr": "DS", "Value": [22.5]},
        "2608": {"vr": "DS", "Value": [20.0]},
        "2609": {"vr": "DS", "Value": [20.0]},
        "2610": {"vr": "DS", "Value": [22.5]},
        "2611": {"vr": "DS", "Value": [22.5]},
        "2612": {"vr": "DS", "Value": [22.5]},
        "2613": {"vr": "DS", "Value": [20.0]},
        "2614": {"vr": "DS", "Value": [20.0]},
        "2615": {"vr": "DS", "Value": [20.0]},
        "2616": {"vr": "DS", "Value": [20.0]},
        "2617": {"vr": "DS", "Value": [20.0]},
        "2618": {"vr": "DS", "Value": [22.5]},
        "2619": {"vr": "DS", "Value": [22.5]},
        "2620": {"vr": "DS", "Value": [20.0]},
        "2621": {"vr": "DS", "Value": [22.5]},
        "2622": {"vr": "DS", "Value": [20.0]},
        "2623": {"vr": "DS", "Value": [22.5]},
        "2624": {"vr": "DS", "Value": [22.5]},
        "2625": {"vr": "DS", "Value": [22.5]},
        "2626": {"vr": "DS", "Value": [20.0]},
        "2627": {"vr": "DS", "Value": [22.5]},
        "2628": {"vr": "DS", "Value": [22.5]},
        "2629": {"vr": "DS", "Value": [22.5]},
        "2630": {"vr": "DS", "Value": [22.5]},
        "2631": {"vr": "DS", "Value": [22.5]},
        "2632": {"vr": "DS", "Value": [22.5]},
        "2633": {"vr": "DS", "Value": [22.5]},
        "2634": {"vr": "DS", "Value": [20.0]},
        "2635": {"vr": "DS", "Value": [20.0]},
        "2636": {"vr": "DS", "Value": [20.0]},
        "2637": {"vr": "DS", "Value": [20.0]},
        "2638": {"vr": "DS", "Value": [22.5]},
        "2639": {"vr": "DS", "Value": [22.5]},
        "2640": {"vr": "DS", "Value": [22.5]},
        "2641": {"vr": "DS", "Value": [20.0]},
        "2642": {"vr": "DS", "Value": [20.0]},
        "2643": {"vr": "DS", "Value": [20.0]},
        "2644": {"vr": "DS", "Value": [20.0]},
        "2645": {"vr": "DS", "Value": [22.5]},
        "2646": {"vr": "DS", "Value": [20.0]},
        "2647": {"vr": "DS", "Value": [20.0]},
        "2648": {"vr": "DS", "Value": [22.5]},
        "2649": {"vr": "DS", "Value": [22.5]},
        "2650": {"vr": "DS", "Value": [22.5]},
        "2651": {"vr": "DS", "Value": [22.5]},
        "2652": {"vr": "DS", "Value": [20.0]},
        "2653": {"vr": "DS", "Value": [20.0]},
        "2654": {"vr": "DS", "Value": [20.0]},
        "2655": {"vr": "DS", "Value": [22.5]},
        "2656": {"vr": "DS", "Value": [22.5]},
        "2657": {"vr": "DS", "Value": [20.0]},
        "2658": {"vr": "DS", "Value": [22.5]},
        "2659": {"vr": "DS", "Value": [20.0]},
        "2660": {"vr": "DS", "Value": [20.0]},
        "2661": {"vr": "DS", "Value": [20.0]},
        "2662": {"vr": "DS", "Value": [22.5]},
        "2663": {"vr": "DS", "Value": [20.0]},
        "2664": {"vr": "DS", "Value": [20.0]},
        "2665": {"vr": "DS", "Value": [22.5]},
        "2666": {"vr": "DS", "Value": [20.0]},
        "2667": {"vr": "DS", "Value": [20.0]},
        "2668": {"vr": "DS", "Value": [22.5]},
        "2669": {"vr": "DS", "Value": [20.0]},
        "2670": {"vr": "DS", "Value": [22.5]},
        "2671": {"vr": "DS", "Value": [22.5]},
        "2672": {"vr": "DS", "Value": [20.0]},
        "2673": {"vr": "DS", "Value": [22.5]},
        "2674": {"vr": "DS", "Value": [20.0]},
        "2675": {"vr": "DS", "Value": [20.0]},
        "2676": {"vr": "DS", "Value": [22.5]},
        "2677": {"vr": "DS", "Value": [22.5]},
        "2678": {"vr": "DS", "Value": [22.5]},
        "2679": {"vr": "DS", "Value": [20.0]},
        "2680": {"vr": "DS", "Value": [20.0]},
        "2681": {"vr": "DS", "Value": [22.5]},
        "2682": {"vr": "DS", "Value": [22.5]},
        "2683": {"vr": "DS", "Value": [20.0]},
        "2684": {"vr": "DS", "Value": [22.5]},
        "2685": {"vr": "DS", "Value": [20.0]},
        "2686": {"vr": "DS", "Value": [20.0]},
        "2687": {"vr": "DS", "Value": [22.5]},
        "2688": {"vr": "DS", "Value": [20.0]},
        "2689": {"vr": "DS", "Value": [22.5]},
        "2690": {"vr": "DS", "Value": [22.5]},
        "2691": {"vr": "DS", "Value": [22.5]},
        "2692": {"vr": "DS", "Value": [20.0]},
        "2693": {"vr": "DS", "Value": [22.5]},
        "2694": {"vr": "DS", "Value": [22.5]},
        "2695": {"vr": "DS", "Value": [22.5]},
        "2696": {"vr": "DS", "Value": [22.5]},
        "2697": {"vr": "DS", "Value": [22.5]},
        "2698": {"vr": "DS", "Value": [22.5]},
        "2699": {"vr": "DS", "Value": [22.5]},
        "2700": {"vr": "DS", "Value": [20.0]},
        "2701": {"vr": "DS", "Value": [20.0]},
        "2702": {"vr": "DS", "Value": [22.5]},
        "2703": {"vr": "DS", "Value": [22.5]},
        "2704": {"vr": "DS", "Value": [20.0]},
        "2705": {"vr": "DS", "Value": [22.5]},
        "2706": {"vr": "DS", "Value": [22.5]},
        "2707": {"vr": "DS", "Value": [20.0]},
        "2708": {"vr": "DS", "Value": [20.0]},
        "2709": {"vr": "DS", "Value": [20.0]},
        "2710": {"vr": "DS", "Value": [20.0]},
        "2711": {"vr": "DS", "Value": [22.5]},
        "2712": {"vr": "DS", "Value": [20.0]},
        "2713": {"vr": "DS", "Value": [22.5]},
        "2714": {"vr": "DS", "Value": [22.5]},
        "2715": {"vr": "DS", "Value": [22.5]},
        "2716": {"vr": "DS", "Value": [22.5]},
        "2717": {"vr": "DS", "Value": [22.5]},
        "2718": {"vr": "DS", "Value": [22.5]},
        "2719": {"vr": "DS", "Value": [20.0]},
        "2720": {"vr": "DS", "Value": [20.0]},
        "2721": {"vr": "DS", "Value": [22.5]},
        "2722": {"vr": "DS", "Value": [20.0]},
        "2723": {"vr": "DS", "Value": [22.5]},
        "2724": {"vr": "DS", "Value": [20.0]},
        "2725": {"vr": "DS", "Value": [22.5]},
        "2726": {"vr": "DS", "Value": [20.0]},
        "2727": {"vr": "DS", "Value": [20.0]},
        "2728": {"vr": "DS", "Value": [22.5]},
        "2729": {"vr": "DS", "Value": [22.5]},
        "2730": {"vr": "DS", "Value": [22.5]},
        "2731": {"vr": "DS", "Value": [22.5]},
        "2732": {"vr": "DS", "Value": [20.0]},
        "2733": {"vr": "DS", "Value": [22.5]},
        "2734": {"vr": "DS", "Value": [20.0]},
        "2735": {"vr": "DS", "Value": [22.5]},
        "2736": {"vr": "DS", "Value": [22.5]},
        "2737": {"vr": "DS", "Value": [22.5]},
        "2738": {"vr": "DS", "Value": [20.0]},
        "2739": {"vr": "DS", "Value": [20.0]},
        "2740": {"vr": "DS", "Value": [20.0]},
        "2741": {"vr": "DS", "Value": [22.5]},
        "2742": {"vr": "DS", "Value": [22.5]},
        "2743": {"vr": "DS", "Value": [22.5]},
        "2744": {"vr": "DS", "Value": [22.5]},
        "2745": {"vr": "DS", "Value": [22.5]},
        "2746": {"vr": "DS", "Value": [20.0]},
        "2747": {"vr": "DS", "Value": [20.0]},
        "2748": {"vr": "DS", "Value": [22.5]},
        "2749": {"vr": "DS", "Value": [22.5]},
        "2750": {"vr": "DS", "Value": [22.5]},
        "2751": {"vr": "DS", "Value": [22.5]},
        "2752": {"vr": "DS", "Value": [20.0]},
        "2753": {"vr": "DS", "Value": [20.0]},
        "2754": {"vr": "DS", "Value": [20.0]},
        "2755": {"vr": "DS", "Value": [22.5]},
        "2756": {"vr": "DS", "Value": [20.0]},
        "2757": {"vr": "DS", "Value": [20.0]},
        "2758": {"vr": "DS", "Value": [20.0]},
        "2759": {"vr": "DS", "Value": [20.0]},
        "2760": {"vr": "DS", "Value": [22.5]},
        "2761": {"vr": "DS", "Value": [22.5]},
        "2762": {"vr": "DS", "Value": [22.5]},
        "2763": {"vr": "DS", "Value": [20.0]},
        "2764": {"vr": "DS", "Value": [22.5]},
        "2765": {"vr": "DS", "Value": [22.5]},
        "2766": {"vr": "DS", "Value": [20.0]},
        "2767": {"vr": "DS", "Value": [20.0]},
        "2768": {"vr": "DS", "Value": [22.5]},
        "2769": {"vr": "DS", "Value": [20.0]},
        "2770": {"vr": "DS", "Value": [20.0]},
        "2771": {"vr": "DS", "Value": [22.5]},
        "2772": {"vr": "DS", "Value": [22.5]},
        "2773": {"vr": "DS", "Value": [22.5]},
        "2774": {"vr": "DS", "Value": [22.5]},
        "2775": {"vr": "DS", "Value": [22.5]},
        "2776": {"vr": "DS", "Value": [20.0]},
        "2777": {"vr": "DS", "Value": [20.0]},
        "2778": {"vr": "DS", "Value": [22.5]},
        "2779": {"vr": "DS", "Value": [20.0]},
        "2780": {"vr": "DS", "Value": [20.0]},
        "2781": {"vr": "DS", "Value": [20.0]},
        "2782": {"vr": "DS", "Value": [20.0]},
        "2783": {"vr": "DS", "Value": [20.0]},
        "2784": {"vr": "DS", "Value": [22.5]},
        "2785": {"vr": "DS", "Value": [22.5]},
        "2786": {"vr": "DS", "Value": [22.5]},
        "2787": {"vr": "DS", "Value": [22.5]},
        "2788": {"vr": "DS", "Value": [22.5]},
        "2789": {"vr": "DS", "Value": [20.0]},
        "2790": {"vr": "DS", "Value": [20.0]},
        "2791": {"vr": "DS", "Value": [22.5]},
        "2792": {"vr": "DS", "Value": [22.5]},
        "2793": {"vr": "DS", "Value": [20.0]},
        "2794": {"vr": "DS", "Value": [22.5]},
        "2795": {"vr": "DS", "Value": [20.0]},
        "2796": {"vr": "DS", "Value": [22.5]},
        "2797": {"vr": "DS", "Value": [20.0]},
        "2798": {"vr": "DS", "Value": [22.5]},
        "2799": {"vr": "DS", "Value": [20.0]},
        "2800": {"vr": "DS", "Value": [22.5]},
        "2801": {"vr": "DS", "Value": [22.5]},
        "2802": {"vr": "DS", "Value": [22.5]},
        "2803": {"vr": "DS", "Value": [22.5]},
        "2804": {"vr": "DS", "Value": [20.0]},
        "2805": {"vr": "DS", "Value": [20.0]},
        "2806": {"vr": "DS", "Value": [22.5]},
        "2807": {"vr": "DS", "Value": [22.5]},
        "2808": {"vr": "DS", "Value": [20.0]},
        "2809": {"vr": "DS", "Value": [20.0]},
        "2810": {"vr": "DS", "Value": [20.0]},
        "2811": {"vr": "DS", "Value": [20.0]},
        "2812": {"vr": "DS", "Value": [20.0]},
        "2813": {"vr": "DS", "Value": [22.5]},
        "2814": {"vr": "DS", "Value": [22.5]},
        "2815": {"vr": "DS", "Value": [22.5]},
        "2816": {"vr": "DS", "Value": [22.5]},
        "2817": {"vr": "DS", "Value": [20.0]},
        "2818": {"vr": "DS", "Value": [20.0]},
        "2819": {"vr": "DS", "Value": [22.5]},
        "2820": {"vr": "DS", "Value": [22.5]},
        "2821": {"vr": "DS", "Value": [20.0]},
        "2822": {"vr": "DS", "Value": [22.5]},
        "2823": {"vr": "DS", "Value": [22.5]},
        "2824": {"vr": "DS", "Value": [22.5]},
        "2825": {"vr": "DS", "Value": [22.5]},
        "2826": {"vr": "DS", "Value": [20.0]},
        "2827": {"vr": "DS", "Value": [20.0]},
        "2828": {"vr": "DS", "Value": [20.0]},
        "2829": {"vr": "DS", "Value": [22.5]},
        "2830": {"vr": "DS", "Value": [20.0]},
        "2831": {"vr": "DS", "Value": [20.0]},
        "2832": {"vr": "DS", "Value": [22.5]},
        "2833": {"vr": "DS", "Value": [22.5]},
        "2834": {"vr": "DS", "Value": [20.0]},
        "2835": {"vr": "DS", "Value": [20.0]},
        "2836": {"vr": "DS", "Value": [22.5]},
        "2837": {"vr": "DS", "Value": [22.5]},
        "2838": {"vr": "DS", "Value": [22.5]},
        "2839": {"vr": "DS", "Value": [22.5]},
        "2840": {"vr": "DS", "Value": [20.0]},
        "2841": {"vr": "DS", "Value": [20.0]},
        "2842": {"vr": "DS", "Value": [20.0]},
        "2843": {"vr": "DS", "Value": [22.5]},
        "2844": {"vr": "DS", "Value": [20.0]},
        "2845": {"vr": "DS", "Value": [22.5]},
        "2846": {"vr": "DS", "Value": [22.5]},
        "2847": {"vr": "DS", "Value": [20.0]},
        "2848": {"vr": "DS", "Value": [20.0]},
        "2849": {"vr": "DS", "Value": [20.0]},
        "2850": {"vr": "DS", "Value": [20.0]},
        "2851": {"vr": "DS", "Value": [20.0]},
        "2852": {"vr": "DS", "Value": [20.0]},
        "2853": {"vr": "DS", "Value": [20.0]},
        "2854": {"vr": "DS", "Value": [22.5]},
        "2855": {"vr": "DS", "Value": [22.5]},
        "2856": {"vr": "DS", "Value": [20.0]},
        "2857": {"vr": "DS", "Value": [20.0]},
        "2858": {"vr": "DS", "Value": [22.5]},
        "2859": {"vr": "DS", "Value": [22.5]},
        "2860": {"vr": "DS", "Value": [22.5]},
        "2861": {"vr": "DS", "Value": [22.5]},
        "2862": {"vr": "DS", "Value": [22.5]},
        "2863": {"vr": "DS", "Value": [22.5]},
        "2864": {"vr": "DS", "Value": [22.5]},
        "2865": {"vr": "DS", "Value": [20.0]},
        "2866": {"vr": "DS", "Value": [20.0]},
        "2867": {"vr": "DS", "Value": [20.0]},
        "2868": {"vr": "DS", "Value": [22.5]},
        "2869": {"vr": "DS", "Value": [20.0]},
        "2870": {"vr": "DS", "Value": [20.0]},
        "2871": {"vr": "DS", "Value": [20.0]},
        "2872": {"vr": "DS", "Value": [22.5]},
        "2873": {"vr": "DS", "Value": [20.0]},
        "2874": {"vr": "DS", "Value": [22.5]},
        "2875": {"vr": "DS", "Value": [22.5]},
        "2876": {"vr": "DS", "Value": [22.5]},
        "2877": {"vr": "DS", "Value": [20.0]},
        "2878": {"vr": "DS", "Value": [20.0]},
        "2879": {"vr": "DS", "Value": [22.5]},
        "2880": {"vr": "DS", "Value": [22.5]},
        "2881": {"vr": "DS", "Value": [20.0]},
        "2882": {"vr": "DS", "Value": [22.5]},
        "2883": {"vr": "DS", "Value": [22.5]},
        "2884": {"vr": "DS", "Value": [22.5]},
        "2885": {"vr": "DS", "Value": [22.5]},
        "2886": {"vr": "DS", "Value": [22.5]},
        "2887": {"vr": "DS", "Value": [22.5]},
        "2888": {"vr": "DS", "Value": [22.5]},
        "2889": {"vr": "DS", "Value": [22.5]},
        "2890": {"vr": "DS", "Value": [20.0]},
        "2891": {"vr": "DS", "Value": [22.5]},
        "2892": {"vr": "DS", "Value": [22.5]},
        "2893": {"vr": "DS", "Value": [20.0]},
        "2894": {"vr": "DS", "Value": [22.5]},
        "2895": {"vr": "DS", "Value": [22.5]},
        "2896": {"vr": "DS", "Value": [22.5]},
        "2897": {"vr": "DS", "Value": [20.0]},
        "2898": {"vr": "DS", "Value": [22.5]},
        "2899": {"vr": "DS", "Value": [22.5]},
        "2900": {"vr": "DS", "Value": [20.0]},
        "2901": {"vr": "DS", "Value": [22.5]},
        "2902": {"vr": "DS", "Value": [20.0]},
        "2903": {"vr": "DS", "Value": [22.5]},
        "2904": {"vr": "DS", "Value": [20.0]},
        "2905": {"vr": "DS", "Value": [22.5]},
        "2906": {"vr": "DS", "Value": [20.0]},
        "2907": {"vr": "DS", "Value": [20.0]},
        "2908": {"vr": "DS", "Value": [22.5]},
        "2909": {"vr": "DS", "Value": [22.5]},
        "2910": {"vr": "DS", "Value": [20.0]},
        "2911": {"vr": "DS", "Value": [20.0]},
        "2912": {"vr": "DS", "Value": [22.5]},
        "2913": {"vr": "DS", "Value": [20.0]},
        "2914": {"vr": "DS", "Value": [20.0]},
        "2915": {"vr": "DS", "Value": [20.0]},
        "2916": {"vr": "DS", "Value": [22.5]},
        "2917": {"vr": "DS", "Value": [20.0]},
        "2918": {"vr": "DS", "Value": [20.0]},
        "2919": {"vr": "DS", "Value": [22.5]},
        "2920": {"vr": "DS", "Value": [22.5]},
        "2921": {"vr": "DS", "Value": [22.5]},
        "2922": {"vr": "DS", "Value": [22.5]},
        "2923": {"vr": "DS", "Value": [20.0]},
        "2924": {"vr": "DS", "Value": [20.0]},
        "2925": {"vr": "DS", "Value": [20.0]},
        "2926": {"vr": "DS", "Value": [22.5]},
        "2927": {"vr": "DS", "Value": [22.5]},
        "2928": {"vr": "DS", "Value": [20.0]},
        "2929": {"vr": "DS", "Value": [20.0]},
        "2930": {"vr": "DS", "Value": [22.5]},
        "2931": {"vr": "DS", "Value": [22.5]},
        "2932": {"vr": "DS", "Value": [20.0]},
        "2933": {"vr": "DS", "Value": [22.5]},
        "2934": {"vr": "DS", "Value": [22.5]},
        "2935": {"vr": "DS", "Value": [22.5]},
        "2936": {"vr": "DS", "Value": [22.5]},
        "2937": {"vr": "DS", "Value": [22.5]},
        "2938": {"vr": "DS", "Value": [22.5]},
        "2939": {"vr": "DS", "Value": [22.5]},
        "2940": {"vr": "DS", "Value": [20.0]},
        "2941": {"vr": "DS", "Value": [22.5]},
        "2942": {"vr": "DS", "Value": [20.0]},
        "2943": {"vr": "DS", "Value": [22.5]},
        "2944": {"vr": "DS", "Value": [22.5]},
        "2945": {"vr": "DS", "Value": [22.5]},
        "2946": {"vr": "DS", "Value": [20.0]},
        "2947": {"vr": "DS", "Value": [20.0]},
        "2948": {"vr": "DS", "Value": [20.0]},
        "2949": {"vr": "DS", "Value": [22.5]},
        "2950": {"vr": "DS", "Value": [22.5]},
        "2951": {"vr": "DS", "Value": [22.5]},
        "2952": {"vr": "DS", "Value": [20.0]},
        "2953": {"vr": "DS", "Value": [20.0]},
        "2954": {"vr": "DS", "Value": [20.0]},
        "2955": {"vr": "DS", "Value": [22.5]},
        "2956": {"vr": "DS", "Value": [22.5]},
        "2957": {"vr": "DS", "Value": [20.0]},
        "2958": {"vr": "DS", "Value": [20.0]},
        "2959": {"vr": "DS", "Value": [20.0]},
        "2960": {"vr": "DS", "Value": [22.5]},
        "2961": {"vr": "DS", "Value": [22.5]},
        "2962": {"vr": "DS", "Value": [22.5]},
        "2963": {"vr": "DS", "Value": [22.5]},
        "2964": {"vr": "DS", "Value": [22.5]},
        "2965": {"vr": "DS", "Value": [20.0]},
        "2966": {"vr": "DS", "Value": [22.5]},
        "2967": {"vr": "DS", "Value": [20.0]},
        "2968": {"vr": "DS", "Value": [20.0]},
        "2969": {"vr": "DS", "Value": [20.0]},
        "2970": {"vr": "DS", "Value": [20.0]},
        "2971": {"vr": "DS", "Value": [22.5]},
        "2972": {"vr": "DS", "Value": [22.5]},
        "2973": {"vr": "DS", "Value": [20.0]},
        "2974": {"vr": "DS", "Value": [20.0]},
        "2975": {"vr": "DS", "Value": [22.5]},
        "2976": {"vr": "DS", "Value": [22.5]},
        "2977": {"vr": "DS", "Value": [20.0]},
        "2978": {"vr": "DS", "Value": [20.0]},
        "2979": {"vr": "DS", "Value": [20.0]},
        "2980": {"vr": "DS", "Value": [22.5]},
        "2981": {"vr": "DS", "Value": [22.5]},
        "2982": {"vr": "DS", "Value": [20.0]},
        "2983": {"vr": "DS", "Value": [20.0]},
        "2984": {"vr": "DS", "Value": [20.0]},
        "2985": {"vr": "DS", "Value": [20.0]},
        "2986": {"vr": "DS", "Value": [22.5]},
        "2987": {"vr": "DS", "Value": [20.0]},
        "2988": {"vr": "DS", "Value": [20.0]},
        "2989": {"vr": "DS", "Value": [22.5]},
        "2990": {"vr": "DS", "Value": [22.5]},
        "2991": {"vr": "DS", "Value": [20.0]},
        "2992": {"vr": "DS", "Value": [22.5]},
        "2993": {"vr": "DS", "Value": [22.5]},
        "2994": {"vr": "DS", "Value": [22.5]},
        "2995": {"vr": "DS", "Value": [22.5]},
        "2996": {"vr": "DS", "Value": [20.0]},
        "2997": {"vr": "DS", "Value": [20.0]},
        "2998": {"vr": "DS", "Value": [22.5]},
        "2999": {"vr": "DS", "Value": [22.5]},
        "3000": {"vr": "DS", "Value": [20.0]},
        "3001": {"vr": "DS", "Value": [20.0]},
        "3002": {"vr": "DS", "Value": [22.5]},
        "3003": {"vr": "DS", "Value": [20.0]},
        "3004": {"vr": "DS", "Value": [20.0]},
        "3005": {"vr": "DS", "Value": [20.0]},
        "3006": {"vr": "DS", "Value": [20.0]},
        "3007": {"vr": "DS", "Value": [20.0]},
        "3008": {"vr": "DS", "Value": [20.0]},
        "3009": {"vr": "DS", "Value": [22.5]},
        "3010": {"vr": "DS", "Value": [22.5]},
        "3011": {"vr": "DS", "Value": [20.0]},
        "3012": {"vr": "DS", "Value": [20.0]},
        "3013": {"vr": "DS", "Value": [22.5]},
        "3014": {"vr": "DS", "Value": [22.5]},
        "3015": {"vr": "DS", "Value": [22.5]},
        "3016": {"vr": "DS", "Value": [20.0]},
        "3017": {"vr": "DS", "Value": [22.5]},
        "3018": {"vr": "DS", "Value": [22.5]},
        "3019": {"vr": "DS", "Value": [22.5]},
        "3020": {"vr": "DS", "Value": [22.5]},
        "3021": {"vr": "DS", "Value": [20.0]},
        "3022": {"vr": "DS", "Value": [22.5]},
        "3023": {"vr": "DS", "Value": [22.5]},
        "3024": {"vr": "DS", "Value": [22.5]},
        "3025": {"vr": "DS", "Value": [20.0]},
        "3026": {"vr": "DS", "Value": [22.5]},
        "3027": {"vr": "DS", "Value": [22.5]},
        "3028": {"vr": "DS", "Value": [20.0]},
        "3029": {"vr": "DS", "Value": [22.5]},
        "3030": {"vr": "DS", "Value": [20.0]},
        "3031": {"vr": "DS", "Value": [22.5]},
        "3032": {"vr": "DS", "Value": [22.5]},
        "3033": {"vr": "DS", "Value": [20.0]},
        "3034": {"vr": "DS", "Value": [20.0]},
        "3035": {"vr": "DS", "Value": [22.5]},
        "3036": {"vr": "DS", "Value": [22.5]},
        "3037": {"vr": "DS", "Value": [20.0]},
        "3038": {"vr": "DS", "Value": [20.0]},
        "3039": {"vr": "DS", "Value": [22.5]},
        "3040": {"vr": "DS", "Value": [20.0]},
        "3041": {"vr": "DS", "Value": [20.0]},
        "3042": {"vr": "DS", "Value": [22.5]},
        "3043": {"vr": "DS", "Value": [22.5]},
        "3044": {"vr": "DS", "Value": [22.5]},
        "3045": {"vr": "DS", "Value": [22.5]},
        "3046": {"vr": "DS", "Value": [20.0]},
        "3047": {"vr": "DS", "Value": [22.5]},
        "3048": {"vr": "DS", "Value": [20.0]},
        "3049": {"vr": "DS", "Value": [22.5]},
        "3050": {"vr": "DS", "Value": [20.0]},
        "3051": {"vr": "DS", "Value": [22.5]},
        "3052": {"vr": "DS", "Value": [22.5]},
        "3053": {"vr": "DS", "Value": [20.0]},
        "3054": {"vr": "DS", "Value": [20.0]},
        "3055": {"vr": "DS", "Value": [20.0]},
        "3056": {"vr": "DS", "Value": [22.5]},
        "3057": {"vr": "DS", "Value": [20.0]},
        "3058": {"vr": "DS", "Value": [22.5]},
        "3059": {"vr": "DS", "Value": [22.5]},
        "3060": {"vr": "DS", "Value": [20.0]},
        "3061": {"vr": "DS", "Value": [22.5]},
        "3062": {"vr": "DS", "Value": [22.5]},
        "3063": {"vr": "DS", "Value": [22.5]},
        "3064": {"vr": "DS", "Value": [22.5]},
        "3065": {"vr": "DS", "Value": [22.5]},
        "3066": {"vr": "DS", "Value": [22.5]},
        "3067": {"vr": "DS", "Value": [20.0]},
        "3068": {"vr": "DS", "Value": [22.5]},
        "3069": {"vr": "DS", "Value": [20.0]},
        "3070": {"vr": "DS", "Value": [22.5]},
        "3071": {"vr": "DS", "Value": [20.0]},
        "3072": {"vr": "DS", "Value": [22.5]},
        "3073": {"vr": "DS", "Value": [22.5]},
        "3074": {"vr": "DS", "Value": [22.5]},
        "3075": {"vr": "DS", "Value": [22.5]},
        "3076": {"vr": "DS", "Value": [20.0]},
        "3077": {"vr": "DS", "Value": [20.0]},
        "3078": {"vr": "DS", "Value": [20.0]},
        "3079": {"vr": "DS", "Value": [22.5]},
        "3080": {"vr": "DS", "Value": [22.5]},
        "3081": {"vr": "DS", "Value": [22.5]},
        "3082": {"vr": "DS", "Value": [22.5]},
        "3083": {"vr": "DS", "Value": [22.5]},
        "3084": {"vr": "DS", "Value": [22.5]},
        "3085": {"vr": "DS", "Value": [20.0]},
        "3086": {"vr": "DS", "Value": [22.5]},
        "3087": {"vr": "DS", "Value": [22.5]},
        "3088": {"vr": "DS", "Value": [22.5]},
        "3089": {"vr": "DS", "Value": [20.0]},
        "3090": {"vr": "DS", "Value": [20.0]},
        "3091": {"vr": "DS", "Value": [22.5]},
        "3092": {"vr": "DS", "Value": [20.0]},
        "3093": {"vr": "DS", "Value": [22.5]},
        "3094": {"vr": "DS", "Value": [22.5]},
        "3095": {"vr": "DS", "Value": [20.0]},
        "3096": {"vr": "DS", "Value": [22.5]},
        "3097": {"vr": "DS", "Value": [22.5]},
        "3098": {"vr": "DS", "Value": [20.0]},
        "3099": {"vr": "DS", "Value": [22.5]},
        "3100": {"vr": "DS", "Value": [22.5]},
        "3101": {"vr": "DS", "Value": [20.0]},
        "3102": {"vr": "DS", "Value": [22.5]},
        "3103": {"vr": "DS", "Value": [20.0]},
        "3104": {"vr": "DS", "Value": [22.5]},
        "3105": {"vr": "DS", "Value": [20.0]},
        "3106": {"vr": "DS", "Value": [22.5]},
        "3107": {"vr": "DS", "Value": [20.0]},
        "3108": {"vr": "DS", "Value": [22.5]},
        "3109": {"vr": "DS", "Value": [20.0]},
        "3110": {"vr": "DS", "Value": [22.5]},
        "3111": {"vr": "DS", "Value": [20.0]},
        "3112": {"vr": "DS", "Value": [20.0]},
        "3113": {"vr": "DS", "Value": [22.5]},
        "3114": {"vr": "DS", "Value": [22.5]},
        "3115": {"vr": "DS", "Value": [20.0]},
        "3116": {"vr": "DS", "Value": [20.0]},
        "3117": {"vr": "DS", "Value": [20.0]},
        "3118": {"vr": "DS", "Value": [20.0]},
        "3119": {"vr": "DS", "Value": [22.5]},
        "3120": {"vr": "DS", "Value": [22.5]},
        "3121": {"vr": "DS", "Value": [22.5]},
        "3122": {"vr": "DS", "Value": [22.5]},
        "3123": {"vr": "DS", "Value": [22.5]},
        "3124": {"vr": "DS", "Value": [20.0]},
        "3125": {"vr": "DS", "Value": [20.0]},
        "3126": {"vr": "DS", "Value": [22.5]},
        "3127": {"vr": "DS", "Value": [22.5]},
        "3128": {"vr": "DS", "Value": [22.5]},
        "3129": {"vr": "DS", "Value": [20.0]},
        "3130": {"vr": "DS", "Value": [20.0]},
        "3131": {"vr": "DS", "Value": [22.5]},
        "3132": {"vr": "DS", "Value": [22.5]},
        "3133": {"vr": "DS", "Value": [22.5]},
        "3134": {"vr": "DS", "Value": [22.5]},
        "3135": {"vr": "DS", "Value": [22.5]},
        "3136": {"vr": "DS", "Value": [22.5]},
        "3137": {"vr": "DS", "Value": [20.0]},
        "3138": {"vr": "DS", "Value": [22.5]},
        "3139": {"vr": "DS", "Value": [22.5]},
        "3140": {"vr": "DS", "Value": [20.0]},
        "3141": {"vr": "DS", "Value": [22.5]},
        "3142": {"vr": "DS", "Value": [20.0]},
        "3143": {"vr": "DS", "Value": [22.5]},
        "3144": {"vr": "DS", "Value": [20.0]},
        "3145": {"vr": "DS", "Value": [22.5]},
        "3146": {"vr": "DS", "Value": [22.5]},
        "3147": {"vr": "DS", "Value": [22.5]},
        "3148": {"vr": "DS", "Value": [20.0]},
        "3149": {"vr": "DS", "Value": [22.5]},
        "3150": {"vr": "DS", "Value": [20.0]},
        "3151": {"vr": "DS", "Value": [20.0]},
        "3152": {"vr": "DS", "Value": [22.5]},
        "3153": {"vr": "DS", "Value": [20.0]},
        "3154": {"vr": "DS", "Value": [20.0]},
        "3155": {"vr": "DS", "Value": [20.0]},
        "3156": {"vr": "DS", "Value": [20.0]},
        "3157": {"vr": "DS", "Value": [22.5]},
        "3158": {"vr": "DS", "Value": [20.0]},
        "3159": {"vr": "DS", "Value": [20.0]},
        "3160": {"vr": "DS", "Value": [22.5]},
        "3161": {"vr": "DS", "Value": [20.0]},
        "3162": {"vr": "DS", "Value": [20.0]},
        "3163": {"vr": "DS", "Value": [22.5]},
        "3164": {"vr": "DS", "Value": [20.0]},
        "3165": {"vr": "DS", "Value": [22.5]},
        "3166": {"vr": "DS", "Value": [22.5]},
        "3167": {"vr": "DS", "Value": [22.5]},
        "3168": {"vr": "DS", "Value": [22.5]},
        "3169": {"vr": "DS", "Value": [22.5]},
        "3170": {"vr": "DS", "Value": [20.0]},
        "3171": {"vr": "DS", "Value": [20.0]},
        "3172": {"vr": "DS", "Value": [20.0]},
        "3173": {"vr": "DS", "Value": [22.5]},
        "3174": {"vr": "DS", "Value": [22.5]},
        "3175": {"vr": "DS", "Value": [20.0]},
        "3176": {"vr": "DS", "Value": [22.5]},
        "3177": {"vr": "DS", "Value": [20.0]},
        "3178": {"vr": "DS", "Value": [22.5]},
        "3179": {"vr": "DS", "Value": [20.0]},
        "3180": {"vr": "DS", "Value": [20.0]},
        "3181": {"vr": "DS", "Value": [20.0]},
        "3182": {"vr": "DS", "Value": [20.0]},
        "3183": {"vr": "DS", "Value": [22.5]},
        "3184": {"vr": "DS", "Value": [20.0]},
        "3185": {"vr": "DS", "Value": [22.5]},
        "3186": {"vr": "DS", "Value": [20.0]},
        "3187": {"vr": "DS", "Value": [20.0]},
        "3188": {"vr": "DS", "Value": [20.0]},
        "3189": {"vr": "DS", "Value": [22.5]},
        "3190": {"vr": "DS", "Value": [20.0]},
        "3191": {"vr": "DS", "Value": [20.0]},
        "3192": {"vr": "DS", "Value": [22.5]},
        "3193": {"vr": "DS", "Value": [22.5]},
        "3194": {"vr": "DS", "Value": [22.5]},
        "3195": {"vr": "DS", "Value": [20.0]},
        "3196": {"vr": "DS", "Value": [20.0]},
        "3197": {"vr": "DS", "Value": [20.0]},
        "3198": {"vr": "DS", "Value": [22.5]},
        "3199": {"vr": "DS", "Value": [20.0]},
        "3200": {"vr": "DS", "Value": [20.0]},
        "3201": {"vr": "DS", "Value": [22.5]},
        "3202": {"vr": "DS", "Value": [22.5]},
        "3203": {"vr": "DS", "Value": [22.5]},
        "3204": {"vr": "DS", "Value": [20.0]},
        "3205": {"vr": "DS", "Value": [20.0]},
        "3206": {"vr": "DS", "Value": [20.0]},
        "3207": {"vr": "DS", "Value": [20.0]},
        "3208": {"vr": "DS", "Value": [22.5]},
        "3209": {"vr": "DS", "Value": [22.5]},
        "3210": {"vr": "DS", "Value": [20.0]},
        "3211": {"vr": "DS", "Value": [22.5]},
        "3212": {"vr": "DS", "Value": [20.0]},
        "3213": {"vr": "DS", "Value": [22.5]},
        "3214": {"vr": "DS", "Value": [22.5]},
        "3215": {"vr": "DS", "Value": [20.0]},
        "3216": {"vr": "DS", "Value": [20.0]},
        "3217": {"vr": "DS", "Value": [22.5]},
        "3218": {"vr": "DS", "Value": [22.5]},
        "3219": {"vr": "DS", "Value": [20.0]},
        "3220": {"vr": "DS", "Value": [20.0]},
        "3221": {"vr": "DS", "Value": [22.5]},
        "3222": {"vr": "DS", "Value": [22.5]},
        "3223": {"vr": "DS", "Value": [20.0]},
        "3224": {"vr": "DS", "Value": [20.0]},
        "3225": {"vr": "DS", "Value": [22.5]},
        "3226": {"vr": "DS", "Value": [22.5]},
        "3227": {"vr": "DS", "Value": [20.0]},
        "3228": {"vr": "DS", "Value": [20.0]},
        "3229": {"vr": "DS", "Value": [20.0]},
        "3230": {"vr": "DS", "Value": [22.5]},
        "3231": {"vr": "DS", "Value": [22.5]},
        "3232": {"vr": "DS", "Value": [20.0]},
        "3233": {"vr": "DS", "Value": [22.5]},
        "3234": {"vr": "DS", "Value": [22.5]},
        "3235": {"vr": "DS", "Value": [20.0]},
        "3236": {"vr": "DS", "Value": [22.5]},
        "3237": {"vr": "DS", "Value": [22.5]},
        "3238": {"vr": "DS", "Value": [22.5]},
        "3239": {"vr": "DS", "Value": [22.5]},
        "3240": {"vr": "DS", "Value": [22.5]},
        "3241": {"vr": "DS", "Value": [22.5]},
        "3242": {"vr": "DS", "Value": [20.0]},
        "3243": {"vr": "DS", "Value": [22.5]},
        "3244": {"vr": "DS", "Value": [22.5]},
        "3245": {"vr": "DS", "Value": [22.5]},
        "3246": {"vr": "DS", "Value": [20.0]},
        "3247": {"vr": "DS", "Value": [20.0]},
        "3248": {"vr": "DS", "Value": [20.0]},
        "3249": {"vr": "DS", "Value": [20.0]},
        "3250": {"vr": "DS", "Value": [20.0]},
        "3251": {"vr": "DS", "Value": [20.0]},
        "3252": {"vr": "DS", "Value": [22.5]},
        "3253": {"vr": "DS", "Value": [22.5]},
        "3254": {"vr": "DS", "Value": [22.5]},
        "3255": {"vr": "DS", "Value": [20.0]},
        "3256": {"vr": "DS", "Value": [22.5]},
        "3257": {"vr": "DS", "Value": [22.5]},
        "3258": {"vr": "DS", "Value": [20.0]},
        "3259": {"vr": "DS", "Value": [20.0]},
        "3260": {"vr": "DS", "Value": [20.0]},
        "3261": {"vr": "DS", "Value": [22.5]},
        "3262": {"vr": "DS", "Value": [22.5]},
        "3263": {"vr": "DS", "Value": [20.0]},
        "3264": {"vr": "DS", "Value": [20.0]},
        "3265": {"vr": "DS", "Value": [20.0]},
        "3266": {"vr": "DS", "Value": [20.0]},
        "3267": {"vr": "DS", "Value": [22.5]},
        "3268": {"vr": "DS", "Value": [22.5]},
        "3269": {"vr": "DS", "Value": [22.5]},
        "3270": {"vr": "DS", "Value": [22.5]},
        "3271": {"vr": "DS", "Value": [20.0]},
        "3272": {"vr": "DS", "Value": [20.0]},
        "3273": {"vr": "DS", "Value": [22.5]},
        "3274": {"vr": "DS", "Value": [20.0]},
        "3275": {"vr": "DS", "Value": [20.0]},
        "3276": {"vr": "DS", "Value": [22.5]},
        "3277": {"vr": "DS", "Value": [22.5]},
        "3278": {"vr": "DS", "Value": [22.5]},
        "3279": {"vr": "DS", "Value": [22.5]},
        "3280": {"vr": "DS", "Value": [22.5]},
        "3281": {"vr": "DS", "Value": [22.5]},
        "3282": {"vr": "DS", "Value": [22.5]},
        "3283": {"vr": "DS", "Value": [20.0]},
        "3284": {"vr": "DS", "Value": [22.5]},
        "3285": {"vr": "DS", "Value": [22.5]},
        "3286": {"vr": "DS", "Value": [20.0]},
        "3287": {"vr": "DS", "Value": [22.5]},
        "3288": {"vr": "DS", "Value": [22.5]},
        "3289": {"vr": "DS", "Value": [22.5]},
        "3290": {"vr": "DS", "Value": [20.0]},
        "3291": {"vr": "DS", "Value": [22.5]},
        "3292": {"vr": "DS", "Value": [22.5]},
        "3293": {"vr": "DS", "Value": [22.5]},
        "3294": {"vr": "DS", "Value": [20.0]},
        "3295": {"vr": "DS", "Value": [22.5]},
        "3296": {"vr": "DS", "Value": [20.0]},
        "3297": {"vr": "DS", "Value": [20.0]},
        "3298": {"vr": "DS", "Value": [20.0]},
        "3299": {"vr": "DS", "Value": [22.5]},
        "3300": {"vr": "DS", "Value": [22.5]},
        "3301": {"vr": "DS", "Value": [22.5]},
        "3302": {"vr": "DS", "Value": [22.5]},
        "3303": {"vr": "DS", "Value": [22.5]},
        "3304": {"vr": "DS", "Value": [22.5]},
        "3305": {"vr": "DS", "Value": [22.5]},
        "3306": {"vr": "DS", "Value": [20.0]},
        "3307": {"vr": "DS", "Value": [22.5]},
        "3308": {"vr": "DS", "Value": [20.0]},
        "3309": {"vr": "DS", "Value": [20.0]},
        "3310": {"vr": "DS", "Value": [22.5]},
        "3311": {"vr": "DS", "Value": [20.0]},
        "3312": {"vr": "DS", "Value": [22.5]},
        "3313": {"vr": "DS", "Value": [20.0]},
        "3314": {"vr": "DS", "Value": [22.5]},
        "3315": {"vr": "DS", "Value": [22.5]},
        "3316": {"vr": "DS", "Value": [20.0]},
        "3317": {"vr": "DS", "Value": [20.0]},
        "3318": {"vr": "DS", "Value": [22.5]},
        "3319": {"vr": "DS", "Value": [22.5]},
        "3320": {"vr": "DS", "Value": [20.0]},
        "3321": {"vr": "DS", "Value": [22.5]},
        "3322": {"vr": "DS", "Value": [20.0]},
        "3323": {"vr": "DS", "Value": [20.0]},
        "3324": {"vr": "DS", "Value": [20.0]},
        "3325": {"vr": "DS", "Value": [22.5]},
        "3326": {"vr": "DS", "Value": [22.5]},
        "3327": {"vr": "DS", "Value": [20.0]},
        "3328": {"vr": "DS", "Value": [20.0]},
        "3329": {"vr": "DS", "Value": [22.5]},
        "3330": {"vr": "DS", "Value": [20.0]},
        "3331": {"vr": "DS", "Value": [20.0]},
        "3332": {"vr": "DS", "Value": [20.0]},
        "3333": {"vr": "DS", "Value": [20.0]},
        "3334": {"vr": "DS", "Value": [20.0]},
        "3335": {"vr": "DS", "Value": [20.0]},
        "3336": {"vr": "DS", "Value": [20.0]},
        "3337": {"vr": "DS", "Value": [22.5]},
        "3338": {"vr": "DS", "Value": [22.5]},
        "3339": {"vr": "DS", "Value": [22.5]},
        "3340": {"vr": "DS", "Value": [20.0]},
        "3341": {"vr": "DS", "Value": [22.5]},
        "3342": {"vr": "DS", "Value": [22.5]},
        "3343": {"vr": "DS", "Value": [22.5]},
        "3344": {"vr": "DS", "Value": [20.0]},
        "3345": {"vr": "DS", "Value": [20.0]},
        "3346": {"vr": "DS", "Value": [20.0]},
        "3347": {"vr": "DS", "Value": [20.0]},
        "3348": {"vr": "DS", "Value": [22.5]},
        "3349": {"vr": "DS", "Value": [20.0]},
        "3350": {"vr": "DS", "Value": [20.0]},
        "3351": {"vr": "DS", "Value": [22.5]},
        "3352": {"vr": "DS", "Value": [22.5]},
        "3353": {"vr": "DS", "Value": [20.0]},
        "3354": {"vr": "DS", "Value": [22.5]},
        "3355": {"vr": "DS", "Value": [22.5]},
        "3356": {"vr": "DS", "Value": [20.0]},
        "3357": {"vr": "DS", "Value": [20.0]},
        "3358": {"vr": "DS", "Value": [22.5]},
        "3359": {"vr": "DS", "Value": [22.5]},
        "3360": {"vr": "DS", "Value": [20.0]},
        "3361": {"vr": "DS", "Value": [22.5]},
        "3362": {"vr": "DS", "Value": [22.5]},
        "3363": {"vr": "DS", "Value": [22.5]},
        "3364": {"vr": "DS", "Value": [22.5]},
        "3365": {"vr": "DS", "Value": [22.5]},
        "3366": {"vr": "DS", "Value": [20.0]},
        "3367": {"vr": "DS", "Value": [22.5]},
        "3368": {"vr": "DS", "Value": [22.5]},
        "3369": {"vr": "DS", "Value": [22.5]},
        "3370": {"vr": "DS", "Value": [22.5]},
        "3371": {"vr": "DS", "Value": [20.0]},
        "3372": {"vr": "DS", "Value": [22.5]},
        "3373": {"vr": "DS", "Value": [20.0]},
        "3374": {"vr": "DS", "Value": [22.5]},
        "3375": {"vr": "DS", "Value": [20.0]},
        "3376": {"vr": "DS", "Value": [22.5]},
        "3377": {"vr": "DS", "Value": [22.5]},
        "3378": {"vr": "DS", "Value": [22.5]},
        "3379": {"vr": "DS", "Value": [22.5]},
        "3380": {"vr": "DS", "Value": [22.5]},
        "3381": {"vr": "DS", "Value": [22.5]},
        "3382": {"vr": "DS", "Value": [20.0]},
        "3383": {"vr": "DS", "Value": [20.0]},
        "3384": {"vr": "DS", "Value": [22.5]},
        "3385": {"vr": "DS", "Value": [22.5]},
        "3386": {"vr": "DS", "Value": [20.0]},
        "3387": {"vr": "DS", "Value": [22.5]},
        "3388": {"vr": "DS", "Value": [22.5]},
        "3389": {"vr": "DS", "Value": [20.0]},
        "3390": {"vr": "DS", "Value": [20.0]},
        "3391": {"vr": "DS", "Value": [22.5]},
        "3392": {"vr": "DS", "Value": [20.0]},
        "3393": {"vr": "DS", "Value": [22.5]},
        "3394": {"vr": "DS", "Value": [20.0]},
        "3395": {"vr": "DS", "Value": [22.5]},
        "3396": {"vr": "DS", "Value": [22.5]},
        "3397": {"vr": "DS", "Value": [20.0]},
        "3398": {"vr": "DS", "Value": [20.0]},
        "3399": {"vr": "DS", "Value": [22.5]},
        "3400": {"vr": "DS", "Value": [20.0]},
        "3401": {"vr": "DS", "Value": [22.5]},
        "3402": {"vr": "DS", "Value": [22.5]},
        "3403": {"vr": "DS", "Value": [20.0]},
        "3404": {"vr": "DS", "Value": [22.5]},
        "3405": {"vr": "DS", "Value": [22.5]},
        "3406": {"vr": "DS", "Value": [20.0]},
        "3407": {"vr": "DS", "Value": [20.0]},
        "3408": {"vr": "DS", "Value": [22.5]},
        "3409": {"vr": "DS", "Value": [20.0]},
        "3410": {"vr": "DS", "Value": [22.5]},
        "3411": {"vr": "DS", "Value": [20.0]},
        "3412": {"vr": "DS", "Value": [20.0]},
        "3413": {"vr": "DS", "Value": [20.0]},
        "3414": {"vr": "DS", "Value": [22.5]},
        "3415": {"vr": "DS", "Value": [20.0]},
        "3416": {"vr": "DS", "Value": [20.0]},
        "3417": {"vr": "DS", "Value": [22.5]},
        "3418": {"vr": "DS", "Value": [20.0]},
        "3419": {"vr": "DS", "Value": [20.0]},
        "3420": {"vr": "DS", "Value": [22.5]},
        "3421": {"vr": "DS", "Value": [22.5]},
        "3422": {"vr": "DS", "Value": [20.0]},
        "3423": {"vr": "DS", "Value": [20.0]},
        "3424": {"vr": "DS", "Value": [22.5]},
        "3425": {"vr": "DS", "Value": [20.0]},
        "3426": {"vr": "DS", "Value": [20.0]},
        "3427": {"vr": "DS", "Value": [22.5]},
        "3428": {"vr": "DS", "Value": [22.5]},
        "3429": {"vr": "DS", "Value": [20.0]},
        "3430": {"vr": "DS", "Value": [20.0]},
        "3431": {"vr": "DS", "Value": [20.0]},
        "3432": {"vr": "DS", "Value": [20.0]},
        "3433": {"vr": "DS", "Value": [20.0]},
        "3434": {"vr": "DS", "Value": [20.0]},
        "3435": {"vr": "DS", "Value": [22.5]},
        "3436": {"vr": "DS", "Value": [22.5]},
        "3437": {"vr": "DS", "Value": [20.0]},
        "3438": {"vr": "DS", "Value": [20.0]},
        "3439": {"vr": "DS", "Value": [22.5]},
        "3440": {"vr": "DS", "Value": [20.0]},
        "3441": {"vr": "DS", "Value": [20.0]},
        "3442": {"vr": "DS", "Value": [20.0]},
        "3443": {"vr": "DS", "Value": [22.5]},
        "3444": {"vr": "DS", "Value": [22.5]},
        "3445": {"vr": "DS", "Value": [22.5]},
        "3446": {"vr": "DS", "Value": [22.5]},
        "3447": {"vr": "DS", "Value": [22.5]},
        "3448": {"vr": "DS", "Value": [22.5]},
        "3449": {"vr": "DS", "Value": [22.5]},
        "3450": {"vr": "DS", "Value": [22.5]},
        "3451": {"vr": "DS", "Value": [20.0]},
        "3452": {"vr": "DS", "Value": [22.5]},
        "3453": {"vr": "DS", "Value": [22.5]},
        "3454": {"vr": "DS", "Value": [20.0]},
        "3455": {"vr": "DS", "Value": [22.5]},
        "3456": {"vr": "DS", "Value": [22.5]},
        "3457": {"vr": "DS", "Value": [20.0]},
        "3458": {"vr": "DS", "Value": [20.0]},
        "3459": {"vr": "DS", "Value": [22.5]},
        "3460": {"vr": "DS", "Value": [22.5]},
        "3461": {"vr": "DS", "Value": [20.0]},
        "3462": {"vr": "DS", "Value": [22.5]},
        "3463": {"vr": "DS", "Value": [20.0]},
        "3464": {"vr": "DS", "Value": [22.5]},
        "3465": {"vr": "DS", "Value": [20.0]},
        "3466": {"vr": "DS", "Value": [22.5]},
        "3467": {"vr": "DS", "Value": [22.5]},
        "3468": {"vr": "DS", "Value": [22.5]},
        "3469": {"vr": "DS", "Value": [22.5]},
        "3470": {"vr": "DS", "Value": [20.0]},
        "3471": {"vr": "DS", "Value": [22.5]},
        "3472": {"vr": "DS", "Value": [20.0]},
        "3473": {"vr": "DS", "Value": [22.5]},
        "3474": {"vr": "DS", "Value": [20.0]},
        "3475": {"vr": "DS", "Value": [20.0]},
        "3476": {"vr": "DS", "Value": [22.5]},
        "3477": {"vr": "DS", "Value": [22.5]},
        "3478": {"vr": "DS", "Value": [20.0]},
        "3479": {"vr": "DS", "Value": [22.5]},
        "3480": {"vr": "DS", "Value": [22.5]},
        "3481": {"vr": "DS", "Value": [22.5]},
        "3482": {"vr": "DS", "Value": [22.5]},
        "3483": {"vr": "DS", "Value": [22.5]},
        "3484": {"vr": "DS", "Value": [20.0]},
        "3485": {"vr": "DS", "Value": [20.0]},
        "3486": {"vr": "DS", "Value": [22.5]},
        "3487": {"vr": "DS", "Value": [22.5]},
        "3488": {"vr": "DS", "Value": [20.0]},
        "3489": {"vr": "DS", "Value": [20.0]},
        "3490": {"vr": "DS", "Value": [20.0]},
        "3491": {"vr": "DS", "Value": [20.0]},
        "3492": {"vr": "DS", "Value": [20.0]},
        "3493": {"vr": "DS", "Value": [22.5]},
        "3494": {"vr": "DS", "Value": [20.0]},
        "3495": {"vr": "DS", "Value": [22.5]},
        "3496": {"vr": "DS", "Value": [20.0]},
        "3497": {"vr": "DS", "Value": [22.5]},
        "3498": {"vr": "DS", "Value": [22.5]},
        "3499": {"vr": "DS", "Value": [22.5]},
        "3500": {"vr": "DS", "Value": [22.5]},
        "3501": {"vr": "DS", "Value": [22.5]},
        "3502": {"vr": "DS", "Value": [20.0]},
        "3503": {"vr": "DS", "Value": [22.5]},
        "3504": {"vr": "DS", "Value": [22.5]},
        "3505": {"vr": "DS", "Value": [20.0]},
        "3506": {"vr": "DS", "Value": [22.5]},
        "3507": {"vr": "DS", "Value": [20.0]},
        "3508": {"vr": "DS", "Value": [20.0]},
        "3509": {"vr": "DS", "Value": [22.5]},
        "3510": {"vr": "DS", "Value": [20.0]},
        "3511": {"vr": "DS", "Value": [20.0]},
        "3512": {"vr": "DS", "Value": [20.0]},
        "3513": {"vr": "DS", "Value": [22.5]},
        "3514": {"vr": "DS", "Value": [22.5]},
        "3515": {"vr": "DS", "Value": [20.0]},
        "3516": {"vr": "DS", "Value": [20.0]},
        "3517": {"vr": "DS", "Value": [22.5]},
        "3518": {"vr": "DS", "Value": [20.0]},
        "3519": {"vr": "DS", "Value": [20.0]},
        "3520": {"vr": "DS", "Value": [20.0]},
        "3521": {"vr": "DS", "Value": [22.5]},
        "3522": {"vr": "DS", "Value": [22.5]},
        "3523": {"vr": "DS", "Value": [22.5]},
        "3524": {"vr": "DS", "Value": [20.0]},
        "3525": {"vr": "DS", "Value": [20.0]},
        "3526": {"vr": "DS", "Value": [22.5]},
        "3527": {"vr": "DS", "Value": [20.0]},
        "3528": {"vr": "DS", "Value": [20.0]},
        "3529": {"vr": "DS", "Value": [22.5]},
        "3530": {"vr": "DS", "Value": [20.0]},
        "3531": {"vr": "DS", "Value": [22.5]},
        "3532": {"vr": "DS", "Value": [22.5]},
        "3533": {"vr": "DS", "Value": [20.0]},
        "3534": {"vr": "DS", "Value": [22.5]},
        "3535": {"vr": "DS", "Value": [20.0]},
        "3536": {"vr": "DS", "Value": [22.5]},
        "3537": {"vr": "DS", "Value": [22.5]},
        "3538": {"vr": "DS", "Value": [22.5]},
        "3539": {"vr": "DS", "Value": [20.0]},
        "3540": {"vr": "DS", "Value": [20.0]},
        "3541": {"vr": "DS", "Value": [22.5]},
        "3542": {"vr": "DS", "Value": [22.5]},
        "3543": {"vr": "DS", "Value": [20.0]},
        "3544": {"vr": "DS", "Value": [20.0]},
        "3545": {"vr": "DS", "Value": [22.5]},
        "3546": {"vr": "DS", "Value": [22.5]},
        "3547": {"vr": "DS", "Value": [22.5]},
        "3548": {"vr": "DS", "Value": [20.0]},
        "3549": {"vr": "DS", "Value": [20.0]},
        "3550": {"vr": "DS", "Value": [22.5]},
        "3551": {"vr": "DS", "Value": [22.5]},
        "3552": {"vr": "DS", "Value": [22.5]},
        "3553": {"vr": "DS", "Value": [22.5]},
        "3554": {"vr": "DS", "Value": [22.5]},
        "3555": {"vr": "DS", "Value": [22.5]},
        "3556": {"vr": "DS", "Value": [20.0]},
        "3557": {"vr": "DS", "Value": [22.5]},
        "3558": {"vr": "DS", "Value": [22.5]},
        "3559": {"vr": "DS", "Value": [20.0]},
        "3560": {"vr": "DS", "Value": [22.5]},
        "3561": {"vr": "DS", "Value": [22.5]},
        "3562": {"vr": "DS", "Value": [20.0]},
        "3563": {"vr": "DS", "Value": [22.5]},
        "3564": {"vr": "DS", "Value": [20.0]},
        "3565": {"vr": "DS", "Value": [22.5]},
        "3566": {"vr": "DS", "Value": [22.5]},
        "3567": {"vr": "DS", "Value": [20.0]},
        "3568": {"vr": "DS", "Value": [22.5]},
        "3569": {"vr": "DS", "Value": [20.0]},
        "3570": {"vr": "DS", "Value": [20.0]},
        "3571": {"vr": "DS", "Value": [22.5]},
        "3572": {"vr": "DS", "Value": [22.5]},
        "3573": {"vr": "DS", "Value": [20.0]},
        "3574": {"vr": "DS", "Value": [22.5]},
        "3575": {"vr": "DS", "Value": [22.5]},
        "3576": {"vr": "DS", "Value": [22.5]},
        "3577": {"vr": "DS", "Value": [22.5]},
        "3578": {"vr": "DS", "Value": [22.5]},
        "3579": {"vr": "DS", "Value": [22.5]},
        "3580": {"vr": "DS", "Value": [20.0]},
        "3581": {"vr": "DS", "Value": [20.0]},
        "3582": {"vr": "DS", "Value": [20.0]},
        "3583": {"vr": "DS", "Value": [22.5]},
        "3584": {"vr": "DS", "Value": [22.5]},
        "3585": {"vr": "DS", "Value": [22.5]},
        "3586": {"vr": "DS", "Value": [22.5]},
        "3587": {"vr": "DS", "Value": [20.0]},
        "3588": {"vr": "DS", "Value": [20.0]},
        "3589": {"vr": "DS", "Value": [22.5]},
        "3590": {"vr": "DS", "Value": [22.5]},
        "3591": {"vr": "DS", "Value": [22.5]},
        "3592": {"vr": "DS", "Value": [22.5]},
        "3593": {"vr": "DS", "Value": [20.0]},
        "3594": {"vr": "DS", "Value": [22.5]},
        "3595": {"vr": "DS", "Value": [22.5]},
        "3596": {"vr": "DS", "Value": [22.5]},
        "3597": {"vr": "DS", "Value": [22.5]},
        "3598": {"vr": "DS", "Value": [20.0]},
        "3599": {"vr": "DS", "Value": [20.0]},
        "3600": {"vr": "DS", "Value": [22.5]},
        "3601": {"vr": "DS", "Value": [22.5]},
        "3602": {"vr": "DS", "Value": [22.5]},
        "3603": {"vr": "DS", "Value": [22.5]},
        "3604": {"vr": "DS", "Value": [20.0]},
        "3605": {"vr": "DS", "Value": [22.5]},
        "3606": {"vr": "DS", "Value": [20.0]},
        "3607": {"vr": "DS", "Value": [22.5]},
        "3608": {"vr": "DS", "Value": [20.0]},
        "3609": {"vr": "DS", "Value": [20.0]},
        "3610": {"vr": "DS", "Value": [22.5]},
        "3611": {"vr": "DS", "Value": [20.0]},
        "3612": {"vr": "DS", "Value": [22.5]},
        "3613": {"vr": "DS", "Value": [22.5]},
        "3614": {"vr": "DS", "Value": [22.5]},
        "3615": {"vr": "DS", "Value": [22.5]},
        "3616": {"vr": "DS", "Value": [22.5]},
        "3617": {"vr": "DS", "Value": [22.5]},
        "3618": {"vr": "DS", "Value": [22.5]},
        "3619": {"vr": "DS", "Value": [20.0]},
        "3620": {"vr": "DS", "Value": [22.5]},
        "3621": {"vr": "DS", "Value": [22.5]},
        "3622": {"vr": "DS", "Value": [20.0]},
        "3623": {"vr": "DS", "Value": [22.5]},
        "3624": {"vr": "DS", "Value": [22.5]},
        "3625": {"vr": "DS", "Value": [20.0]},
        "3626": {"vr": "DS", "Value": [22.5]},
        "3627": {"vr": "DS", "Value": [20.0]},
        "3628": {"vr": "DS", "Value": [20.0]},
        "3629": {"vr": "DS", "Value": [22.5]},
        "3630": {"vr": "DS", "Value": [20.0]},
        "3631": {"vr": "DS", "Value": [20.0]},
        "3632": {"vr": "DS", "Value": [22.5]},
        "3633": {"vr": "DS", "Value": [22.5]},
        "3634": {"vr": "DS", "Value": [22.5]},
        "3635": {"vr": "DS", "Value": [20.0]},
        "3636": {"vr": "DS", "Value": [22.5]},
        "3637": {"vr": "DS", "Value": [20.0]},
        "3638": {"vr": "DS", "Value": [22.5]},
        "3639": {"vr": "DS", "Value": [22.5]},
        "3640": {"vr": "DS", "Value": [22.5]},
        "3641": {"vr": "DS", "Value": [22.5]},
        "3642": {"vr": "DS", "Value": [20.0]},
        "3643": {"vr": "DS", "Value": [20.0]},
        "3644": {"vr": "DS", "Value": [22.5]},
        "3645": {"vr": "DS", "Value": [22.5]},
        "3646": {"vr": "DS", "Value": [22.5]},
        "3647": {"vr": "DS", "Value": [22.5]},
        "3648": {"vr": "DS", "Value": [20.0]},
        "3649": {"vr": "DS", "Value": [20.0]},
        "3650": {"vr": "DS", "Value": [20.0]},
        "3651": {"vr": "DS", "Value": [22.5]},
        "3652": {"vr": "DS", "Value": [20.0]},
        "3653": {"vr": "DS", "Value": [22.5]},
        "3654": {"vr": "DS", "Value": [20.0]},
        "3655": {"vr": "DS", "Value": [20.0]},
        "3656": {"vr": "DS", "Value": [22.5]},
        "3657": {"vr": "DS", "Value": [22.5]},
        "3658": {"vr": "DS", "Value": [20.0]},
        "3659": {"vr": "DS", "Value": [22.5]},
        "3660": {"vr": "DS", "Value": [22.5]},
        "3661": {"vr": "DS", "Value": [20.0]},
        "3662": {"vr": "DS", "Value": [22.5]},
        "3663": {"vr": "DS", "Value": [22.5]},
        "3664": {"vr": "DS", "Value": [20.0]},
        "3665": {"vr": "DS", "Value": [22.5]},
        "3666": {"vr": "DS", "Value": [20.0]},
        "3667": {"vr": "DS", "Value": [20.0]},
        "3668": {"vr": "DS", "Value": [20.0]},
        "3669": {"vr": "DS", "Value": [22.5]},
        "3670": {"vr": "DS", "Value": [22.5]},
        "3671": {"vr": "DS", "Value": [22.5]},
        "3672": {"vr": "DS", "Value": [22.5]},
        "3673": {"vr": "DS", "Value": [22.5]},
        "3674": {"vr": "DS", "Value": [20.0]},
        "3675": {"vr": "DS", "Value": [20.0]},
        "3676": {"vr": "DS", "Value": [22.5]},
        "3677": {"vr": "DS", "Value": [20.0]},
        "3678": {"vr": "DS", "Value": [22.5]},
        "3679": {"vr": "DS", "Value": [22.5]},
        "3680": {"vr": "DS", "Value": [22.5]},
        "3681": {"vr": "DS", "Value": [22.5]},
        "3682": {"vr": "DS", "Value": [22.5]},
        "3683": {"vr": "DS", "Value": [22.5]},
        "3684": {"vr": "DS", "Value": [20.0]},
        "3685": {"vr": "DS", "Value": [22.5]},
        "3686": {"vr": "DS", "Value": [20.0]},
        "3687": {"vr": "DS", "Value": [20.0]},
        "3688": {"vr": "DS", "Value": [22.5]},
        "3689": {"vr": "DS", "Value": [22.5]},
        "3690": {"vr": "DS", "Value": [22.5]},
        "3691": {"vr": "DS", "Value": [20.0]},
        "3692": {"vr": "DS", "Value": [20.0]},
        "3693": {"vr": "DS", "Value": [20.0]},
        "3694": {"vr": "DS", "Value": [22.5]},
        "3695": {"vr": "DS", "Value": [22.5]},
        "3696": {"vr": "DS", "Value": [20.0]},
        "3697": {"vr": "DS", "Value": [20.0]},
        "3698": {"vr": "DS", "Value": [20.0]},
        "3699": {"vr": "DS", "Value": [22.5]},
        "3700": {"vr": "DS", "Value": [22.5]},
        "3701": {"vr": "DS", "Value": [20.0]},
        "3702": {"vr": "DS", "Value": [22.5]},
        "3703": {"vr": "DS", "Value": [20.0]},
        "3704": {"vr": "DS", "Value": [22.5]},
        "3705": {"vr": "DS", "Value": [22.5]},
        "3706": {"vr": "DS", "Value": [22.5]},
        "3707": {"vr": "DS", "Value": [20.0]},
        "3708": {"vr": "DS", "Value": [22.5]},
        "3709": {"vr": "DS", "Value": [22.5]},
        "3710": {"vr": "DS", "Value": [20.0]},
        "3711": {"vr": "DS", "Value": [22.5]},
        "3712": {"vr": "DS", "Value": [22.5]},
        "3713": {"vr": "DS", "Value": [20.0]},
        "3714": {"vr": "DS", "Value": [20.0]},
        "3715": {"vr": "DS", "Value": [20.0]},
        "3716": {"vr": "DS", "Value": [22.5]},
        "3717": {"vr": "DS", "Value": [20.0]},
        "3718": {"vr": "DS", "Value": [22.5]},
        "3719": {"vr": "DS", "Value": [22.5]},
        "3720": {"vr": "DS", "Value": [20.0]},
        "3721": {"vr": "DS", "Value": [22.5]},
        "3722": {"vr": "DS", "Value": [22.5]},
        "3723": {"vr": "DS", "Value": [20.0]},
        "3724": {"vr": "DS", "Value": [22.5]},
        "3725": {"vr": "DS", "Value": [22.5]},
        "3726": {"vr": "DS", "Value": [22.5]},
        "3727": {"vr": "DS", "Value": [20.0]},
        "3728": {"vr": "DS", "Value": [20.0]},
        "3729": {"vr": "DS", "Value": [22.5]},
        "3730": {"vr": "DS", "Value": [22.5]},
        "3731": {"vr": "DS", "Value": [20.0]},
        "3732": {"vr": "DS", "Value": [20.0]},
        "3733": {"vr": "DS", "Value": [22.5]},
        "3734": {"vr": "DS", "Value": [22.5]},
        "3735": {"vr": "DS", "Value": [20.0]},
        "3736": {"vr": "DS", "Value": [22.5]},
        "3737": {"vr": "DS", "Value": [22.5]},
        "3738": {"vr": "DS", "Value": [20.0]},
        "3739": {"vr": "DS", "Value": [22.5]},
        "3740": {"vr": "DS", "Value": [20.0]},
        "3741": {"vr": "DS", "Value": [22.5]},
        "3742": {"vr": "DS", "Value": [22.5]},
        "3743": {"vr": "DS", "Value": [22.5]},
        "3744": {"vr": "DS", "Value": [22.5]},
        "3745": {"vr": "DS", "Value": [20.0]},
        "3746": {"vr": "DS", "Value": [20.0]},
        "3747": {"vr": "DS", "Value": [20.0]},
        "3748": {"vr": "DS", "Value": [22.5]},
        "3749": {"vr": "DS", "Value": [20.0]},
        "3750": {"vr": "DS", "Value": [20.0]},
        "3751": {"vr": "DS", "Value": [22.5]},
        "3752": {"vr": "DS", "Value": [22.5]},
        "3753": {"vr": "DS", "Value": [20.0]},
        "3754": {"vr": "DS", "Value": [20.0]},
        "3755": {"vr": "DS", "Value": [22.5]},
        "3756": {"vr": "DS", "Value": [22.5]},
        "3757": {"vr": "DS", "Value": [20.0]},
        "3758": {"vr": "DS", "Value": [22.5]},
        "3759": {"vr": "DS", "Value": [20.0]},
        "3760": {"vr": "DS", "Value": [20.0]},
        "3761": {"vr": "DS", "Value": [22.5]},
        "3762": {"vr": "DS", "Value": [22.5]},
        "3763": {"vr": "DS", "Value": [20.0]},
        "3764": {"vr": "DS", "Value": [22.5]},
        "3765": {"vr": "DS", "Value": [20.0]},
        "3766": {"vr": "DS", "Value": [22.5]},
        "3767": {"vr": "DS", "Value": [20.0]},
        "3768": {"vr": "DS", "Value": [20.0]},
        "3769": {"vr": "DS", "Value": [20.0]},
        "3770": {"vr": "DS", "Value": [22.5]},
        "3771": {"vr": "DS", "Value": [20.0]},
        "3772": {"vr": "DS", "Value": [20.0]},
        "3773": {"vr": "DS", "Value": [22.5]},
        "3774": {"vr": "DS", "Value": [20.0]},
        "3775": {"vr": "DS", "Value": [22.5]},
        "3776": {"vr": "DS", "Value": [20.0]},
        "3777": {"vr": "DS", "Value": [22.5]},
        "3778": {"vr": "DS", "Value": [22.5]},
        "3779": {"vr": "DS", "Value": [22.5]},
        "3780": {"vr": "DS", "Value": [20.0]},
        "3781": {"vr": "DS", "Value": [20.0]},
        "3782": {"vr": "DS", "Value": [22.5]},
        "3783": {"vr": "DS", "Value": [22.5]},
        "3784": {"vr": "DS", "Value": [20.0]},
        "3785": {"vr": "DS", "Value": [20.0]},
        "3786": {"vr": "DS", "Value": [20.0]},
        "3787": {"vr": "DS", "Value": [20.0]},
        "3788": {"vr": "DS", "Value": [20.0]},
        "3789": {"vr": "DS", "Value": [20.0]},
        "3790": {"vr": "DS", "Value": [22.5]},
        "3791": {"vr": "DS", "Value": [20.0]},
        "3792": {"vr": "DS", "Value": [22.5]},
        "3793": {"vr": "DS", "Value": [22.5]},
        "3794": {"vr": "DS", "Value": [22.5]},
        "3795": {"vr": "DS", "Value": [22.5]},
        "3796": {"vr": "DS", "Value": [22.5]},
        "3797": {"vr": "DS", "Value": [20.0]},
        "3798": {"vr": "DS", "Value": [22.5]},
        "3799": {"vr": "DS", "Value": [20.0]},
        "3800": {"vr": "DS", "Value": [22.5]},
        "3801": {"vr": "DS", "Value": [22.5]},
        "3802": {"vr": "DS", "Value": [20.0]},
        "3803": {"vr": "DS", "Value": [20.0]},
        "3804": {"vr": "DS", "Value": [22.5]},
        "3805": {"vr": "DS", "Value": [20.0]},
        "3806": {"vr": "DS", "Value": [20.0]},
        "3807": {"vr": "DS", "Value": [22.5]},
        "3808": {"vr": "DS", "Value": [22.5]},
        "3809": {"vr": "DS", "Value": [22.5]},
        "3810": {"vr": "DS", "Value": [22.5]},
        "3811": {"vr": "DS", "Value": [20.0]},
        "3812": {"vr": "DS", "Value": [20.0]},
        "3813": {"vr": "DS", "Value": [20.0]},
        "3814": {"vr": "DS", "Value": [22.5]},
        "3815": {"vr": "DS", "Value": [22.5]},
        "3816": {"vr": "DS", "Value": [20.0]},
        "3817": {"vr": "DS", "Value": [20.0]},
        "3818": {"vr": "DS", "Value": [22.5]},
        "3819": {"vr": "DS", "Value": [22.5]},
        "3820": {"vr": "DS", "Value": [22.5]},
        "3821": {"vr": "DS", "Value": [22.5]},
        "3822": {"vr": "DS", "Value": [20.0]},
        "3823": {"vr": "DS", "Value": [22.5]},
        "3824": {"vr": "DS", "Value": [20.0]},
        "3825": {"vr": "DS", "Value": [20.0]},
        "3826": {"vr": "DS", "Value": [22.5]},
        "3827": {"vr": "DS", "Value": [20.0]},
        "3828": {"vr": "DS", "Value": [20.0]},
        "3829": {"vr": "DS", "Value": [22.5]},
        "3830": {"vr": "DS", "Value": [22.5]},
        "3831": {"vr": "DS", "Value": [20.0]},
        "3832": {"vr": "DS", "Value": [20.0]},
        "3833": {"vr": "DS", "Value": [20.0]},
        "3834": {"vr": "DS", "Value": [22.5]},
        "3835": {"vr": "DS", "Value": [22.5]},
        "3836": {"vr": "DS", "Value": [20.0]},
        "3837": {"vr": "DS", "Value": [20.0]},
        "3838": {"vr": "DS", "Value": [22.5]},
        "3839": {"vr": "DS", "Value": [20.0]},
        "3840": {"vr": "DS", "Value": [20.0]},
        "3841": {"vr": "DS", "Value": [22.5]},
        "3842": {"vr": "DS", "Value": [22.5]},
        "3843": {"vr": "DS", "Value": [22.5]},
        "3844": {"vr": "DS", "Value": [20.0]},
        "3845": {"vr": "DS", "Value": [22.5]},
        "3846": {"vr": "DS", "Value": [20.0]},
        "3847": {"vr": "DS", "Value": [22.5]},
        "3848": {"vr": "DS", "Value": [22.5]},
        "3849": {"vr": "DS", "Value": [20.0]},
        "3850": {"vr": "DS", "Value": [22.5]},
        "3851": {"vr": "DS", "Value": [22.5]},
        "3852": {"vr": "DS", "Value": [20.0]},
        "3853": {"vr": "DS", "Value": [20.0]},
        "3854": {"vr": "DS", "Value": [22.5]},
        "3855": {"vr": "DS", "Value": [22.5]},
        "3856": {"vr": "DS", "Value": [20.0]},
        "3857": {"vr": "DS", "Value": [22.5]},
        "3858": {"vr": "DS", "Value": [20.0]},
        "3859": {"vr": "DS", "Value": [22.5]},
        "3860": {"vr": "DS", "Value": [22.5]},
        "3861": {"vr": "DS", "Value": [20.0]},
        "3862": {"vr": "DS", "Value": [22.5]},
        "3863": {"vr": "DS", "Value": [22.5]},
        "3864": {"vr": "DS", "Value": [22.5]},
        "3865": {"vr": "DS", "Value": [20.0]},
        "3866": {"vr": "DS", "Value": [22.5]},
        "3867": {"vr": "DS", "Value": [22.5]},
        "3868": {"vr": "DS", "Value": [20.0]},
        "3869": {"vr": "DS", "Value": [22.5]},
        "3870": {"vr": "DS", "Value": [22.5]},
        "3871": {"vr": "DS", "Value": [22.5]},
        "3872": {"vr": "DS", "Value": [20.0]},
        "3873": {"vr": "DS", "Value": [20.0]},
        "3874": {"vr": "DS", "Value": [22.5]},
        "3875": {"vr": "DS", "Value": [22.5]},
        "3876": {"vr": "DS", "Value": [20.0]},
        "3877": {"vr": "DS", "Value": [22.5]},
        "3878": {"vr": "DS", "Value": [20.0]},
        "3879": {"vr": "DS", "Value": [20.0]},
        "3880": {"vr": "DS", "Value": [22.5]},
        "3881": {"vr": "DS", "Value": [20.0]},
        "3882": {"vr": "DS", "Value": [22.5]},
        "3883": {"vr": "DS", "Value": [20.0]},
        "3884": {"vr": "DS", "Value": [22.5]},
        "3885": {"vr": "DS", "Value": [20.0]},
        "3886": {"vr": "DS", "Value": [20.0]},
        "3887": {"vr": "DS", "Value": [20.0]},
        "3888": {"vr": "DS", "Value": [20.0]},
        "3889": {"vr": "DS", "Value": [20.0]},
        "3890": {"vr": "DS", "Value": [20.0]},
        "3891": {"vr": "DS", "Value": [20.0]},
        "3892": {"vr": "DS", "Value": [22.5]},
        "3893": {"vr": "DS", "Value": [22.5]},
        "3894": {"vr": "DS", "Value": [20.0]},
        "3895": {"vr": "DS", "Value": [20.0]},
        "3896": {"vr": "DS", "Value": [22.5]},
        "3897": {"vr": "DS", "Value": [20.0]},
        "3898": {"vr": "DS", "Value": [22.5]},
        "3899": {"vr": "DS", "Value": [22.5]},
        "3900": {"vr": "DS", "Value": [20.0]},
        "3901": {"vr": "DS", "Value": [22.5]},
        "3902": {"vr": "DS", "Value": [20.0]},
        "3903": {"vr": "DS", "Value": [22.5]},
        "3904": {"vr": "DS", "Value": [22.5]},
        "3905": {"vr": "DS", "Value": [20.0]},
        "3906": {"vr": "DS", "Value": [22.5]},
        "3907": {"vr": "DS", "Value": [22.5]},
        "3908": {"vr": "DS", "Value": [22.5]},
        "3909": {"vr": "DS", "Value": [22.5]},
        "3910": {"vr": "DS", "Value": [20.0]},
        "3911": {"vr": "DS", "Value": [22.5]},
        "3912": {"vr": "DS", "Value": [20.0]},
        "3913": {"vr": "DS", "Value": [22.5]},
        "3914": {"vr": "DS", "Value": [22.5]},
        "3915": {"vr": "DS", "Value": [20.0]},
        "3916": {"vr": "DS", "Value": [22.5]},
        "3917": {"vr": "DS", "Value": [22.5]},
        "3918": {"vr": "DS", "Value": [22.5]},
        "3919": {"vr": "DS", "Value": [22.5]},
        "3920": {"vr": "DS", "Value": [22.5]},
        "3921": {"vr": "DS", "Value": [20.0]},
        "3922": {"vr": "DS", "Value": [20.0]},
        "3923": {"vr": "DS", "Value": [22.5]},
        "3924": {"vr": "DS", "Value": [22.5]},
        "3925": {"vr": "DS", "Value": [22.5]},
        "3926": {"vr": "DS", "Value": [22.5]},
        "3927": {"vr": "DS", "Value": [20.0]},
        "3928": {"vr": "DS", "Value": [22.5]},
        "3929": {"vr": "DS", "Value": [22.5]},
        "3930": {"vr": "DS", "Value": [20.0]},
        "3931": {"vr": "DS", "Value": [22.5]},
        "3932": {"vr": "DS", "Value": [22.5]},
        "3933": {"vr": "DS", "Value": [22.5]},
        "3934": {"vr": "DS", "Value": [20.0]},
        "3935": {"vr": "DS", "Value": [22.5]},
        "3936": {"vr": "DS", "Value": [20.0]},
        "3937": {"vr": "DS", "Value": [20.0]},
        "3938": {"vr": "DS", "Value": [22.5]},
        "3939": {"vr": "DS", "Value": [20.0]},
        "3940": {"vr": "DS", "Value": [20.0]},
        "3941": {"vr": "DS", "Value": [20.0]},
        "3942": {"vr": "DS", "Value": [22.5]},
        "3943": {"vr": "DS", "Value": [22.5]},
        "3944": {"vr": "DS", "Value": [22.5]},
        "3945": {"vr": "DS", "Value": [22.5]},
        "3946": {"vr": "DS", "Value": [20.0]},
        "3947": {"vr": "DS", "Value": [22.5]},
        "3948": {"vr": "DS", "Value": [20.0]},
        "3949": {"vr": "DS", "Value": [22.5]},
        "3950": {"vr": "DS", "Value": [22.5]},
        "3951": {"vr": "DS", "Value": [22.5]},
        "3952": {"vr": "DS", "Value": [22.5]},
        "3953": {"vr": "DS", "Value": [22.5]},
        "3954": {"vr": "DS", "Value": [22.5]},
        "3955": {"vr": "DS", "Value": [22.5]},
        "3956": {"vr": "DS", "Value": [22.5]},
        "3957": {"vr": "DS", "Value": [22.5]},
        "3958": {"vr": "DS", "Value": [22.5]},
        "3959": {"vr": "DS", "Value": [22.5]},
        "3960": {"vr": "DS", "Value": [22.5]},
        "3961": {"vr": "DS", "Value": [20.0]},
        "3962": {"vr": "DS", "Value": [22.5]},
        "3963": {"vr": "DS", "Value": [22.5]},
        "3964": {"vr": "DS", "Value": [20.0]},
        "3965": {"vr": "DS", "Value": [22.5]},
        "3966": {"vr": "DS", "Value": [20.0]},
        "3967": {"vr": "DS", "Value": [20.0]},
        "3968": {"vr": "DS", "Value": [22.5]},
        "3969": {"vr": "DS", "Value": [20.0]},
        "3970": {"vr": "DS", "Value": [20.0]},
        "3971": {"vr": "DS", "Value": [20.0]},
        "3972": {"vr": "DS", "Value": [20.0]},
        "3973": {"vr": "DS", "Value": [22.5]},
        "3974": {"vr": "DS", "Value": [20.0]},
        "3975": {"vr": "DS", "Value": [22.5]},
        "3976": {"vr": "DS", "Value": [20.0]},
        "3977": {"vr": "DS", "Value": [22.5]},
        "3978": {"vr": "DS", "Value": [22.5]},
        "3979": {"vr": "DS", "Value": [22.5]},
        "3980": {"vr": "DS", "Value": [20.0]},
        "3981": {"vr": "DS", "Value": [20.0]},
        "3982": {"vr": "DS", "Value": [22.5]},
        "3983": {"vr": "DS", "Value": [20.0]},
        "3984": {"vr": "DS", "Value": [20.0]},
        "3985": {"vr": "DS", "Value": [22.5]},
        "3986": {"vr": "DS", "Value": [22.5]},
        "3987": {"vr": "DS", "Value": [22.5]},
        "3988": {"vr": "DS", "Value": [20.0]},
        "3989": {"vr": "DS", "Value": [22.5]},
        "3990": {"vr": "DS", "Value": [22.5]},
        "3991": {"vr": "DS", "Value": [22.5]},
        "3992": {"vr": "DS", "Value": [20.0]},
        "3993": {"vr": "DS", "Value": [20.0]},
        "3994": {"vr": "DS", "Value": [22.5]},
        "3995": {"vr": "DS", "Value": [20.0]},
        "3996": {"vr": "DS", "Value": [22.5]},
        "3997": {"vr": "DS", "Value": [22.5]},
        "3998": {"vr": "DS", "Value": [22.5]},
        "3999": {"vr": "DS", "Value": [22.5]},
        "4000": {"vr": "DS", "Value": [22.5]},
        "4001": {"vr": "DS", "Value": [22.5]},
        "4002": {"vr": "DS", "Value": [22.5]},
        "4003": {"vr": "DS", "Value": [22.5]},
        "4004": {"vr": "DS", "Value": [22.5]},
        "4005": {"vr": "DS", "Value": [22.5]},
        "4006": {"vr": "DS", "Value": [22.5]},
        "4007": {"vr": "DS", "Value": [20.0]},
        "4008": {"vr": "DS", "Value": [20.0]},
        "4009": {"vr": "DS", "Value": [22.5]},
        "4010": {"vr": "DS", "Value": [22.5]},
        "4011": {"vr": "DS", "Value": [22.5]},
        "4012": {"vr": "DS", "Value": [20.0]},
        "4013": {"vr": "DS", "Value": [22.5]},
        "4014": {"vr": "DS", "Value": [20.0]},
        "4015": {"vr": "DS", "Value": [22.5]},
        "4016": {"vr": "DS", "Value": [20.0]},
        "4017": {"vr": "DS", "Value": [20.0]},
        "4018": {"vr": "DS", "Value": [20.0]},
        "4019": {"vr": "DS", "Value": [20.0]},
    },
    "00211104": {
        "0": {"vr": "DS", "Value": [200.625]},
        "1": {"vr": "DS", "Value": [272.3425]},
        "2": {"vr": "DS", "Value": [379.865]},
        "3": {"vr": "DS", "Value": [401.1225]},
        "4": {"vr": "DS", "Value": [353.465]},
        "5": {"vr": "DS", "Value": [345.1025]},
        "6": {"vr": "DS", "Value": [484.295]},
        "7": {"vr": "DS", "Value": [502.7725]},
        "8": {"vr": "DS", "Value": [212.9575]},
        "9": {"vr": "DS", "Value": [122.01]},
        "10": {"vr": "DS", "Value": [482.0775]},
        "11": {"vr": "DS", "Value": [223.3675]},
        "12": {"vr": "DS", "Value": [218.9575]},
        "13": {"vr": "DS", "Value": [3.5125]},
        "14": {"vr": "DS", "Value": [300.5175]},
        "15": {"vr": "DS", "Value": [412.995]},
        "16": {"vr": "DS", "Value": [468.45]},
        "17": {"vr": "DS", "Value": [63.795]},
        "18": {"vr": "DS", "Value": [181.2675]},
        "19": {"vr": "DS", "Value": [416.5275]},
        "20": {"vr": "DS", "Value": [132.1475]},
        "21": {"vr": "DS", "Value": [427.23]},
        "22": {"vr": "DS", "Value": [448.3425]},
        "23": {"vr": "DS", "Value": [535.1725]},
        "24": {"vr": "DS", "Value": [432.81]},
        "25": {"vr": "DS", "Value": [178.9275]},
        "26": {"vr": "DS", "Value": [281.8925]},
        "27": {"vr": "DS", "Value": [145.775]},
        "28": {"vr": "DS", "Value": [168.08]},
        "29": {"vr": "DS", "Value": [405.825]},
        "30": {"vr": "DS", "Value": [283.795]},
        "31": {"vr": "DS", "Value": [208.255]},
        "32": {"vr": "DS", "Value": [324.265]},
        "33": {"vr": "DS", "Value": [161.035]},
        "34": {"vr": "DS", "Value": [597.65]},
        "35": {"vr": "DS", "Value": [0.1475]},
        "36": {"vr": "DS", "Value": [104.1175]},
        "37": {"vr": "DS", "Value": [176.1475]},
        "38": {"vr": "DS", "Value": [368.7025]},
        "39": {"vr": "DS", "Value": [257.395]},
        "40": {"vr": "DS", "Value": [500.41]},
        "41": {"vr": "DS", "Value": [568.7625]},
        "42": {"vr": "DS", "Value": [574.05]},
        "43": {"vr": "DS", "Value": [181.415]},
        "44": {"vr": "DS", "Value": [471.0825]},
        "45": {"vr": "DS", "Value": [78.7425]},
        "46": {"vr": "DS", "Value": [483.25]},
        "47": {"vr": "DS", "Value": [565.25]},
        "48": {"vr": "DS", "Value": [249.9125]},
        "49": {"vr": "DS", "Value": [34.7425]},
        "50": {"vr": "DS", "Value": [451.29]},
        "51": {"vr": "DS", "Value": [459.795]},
        "52": {"vr": "DS", "Value": [469.475]},
        "53": {"vr": "DS", "Value": [197.99]},
        "54": {"vr": "DS", "Value": [95.3175]},
        "55": {"vr": "DS", "Value": [231.435]},
        "56": {"vr": "DS", "Value": [346.5675]},
        "57": {"vr": "DS", "Value": [248.8875]},
        "58": {"vr": "DS", "Value": [212.08]},
        "59": {"vr": "DS", "Value": [149.7475]},
        "60": {"vr": "DS", "Value": [403.9025]},
        "61": {"vr": "DS", "Value": [494.85]},
        "62": {"vr": "DS", "Value": [197.845]},
        "63": {"vr": "DS", "Value": [579.9025]},
        "64": {"vr": "DS", "Value": [342.1575]},
        "65": {"vr": "DS", "Value": [581.24]},
        "66": {"vr": "DS", "Value": [199.1625]},
        "67": {"vr": "DS", "Value": [226.1475]},
        "68": {"vr": "DS", "Value": [113.795]},
        "69": {"vr": "DS", "Value": [138.1475]},
        "70": {"vr": "DS", "Value": [89.465]},
        "71": {"vr": "DS", "Value": [351.5425]},
        "72": {"vr": "DS", "Value": [346.1275]},
        "73": {"vr": "DS", "Value": [427.3775]},
        "74": {"vr": "DS", "Value": [68.185]},
        "75": {"vr": "DS", "Value": [549.99]},
        "76": {"vr": "DS", "Value": [424.01]},
        "77": {"vr": "DS", "Value": [285.26]},
        "78": {"vr": "DS", "Value": [406.41]},
        "79": {"vr": "DS", "Value": [160.1575]},
        "80": {"vr": "DS", "Value": [595.7475]},
        "81": {"vr": "DS", "Value": [67.7475]},
        "82": {"vr": "DS", "Value": [373.6975]},
        "83": {"vr": "DS", "Value": [324.1175]},
        "84": {"vr": "DS", "Value": [25.795]},
        "85": {"vr": "DS", "Value": [411.24]},
        "86": {"vr": "DS", "Value": [464.7725]},
        "87": {"vr": "DS", "Value": [426.3525]},
        "88": {"vr": "DS", "Value": [248.1575]},
        "89": {"vr": "DS", "Value": [526.9575]},
        "90": {"vr": "DS", "Value": [2.05]},
        "91": {"vr": "DS", "Value": [111.1625]},
        "92": {"vr": "DS", "Value": [441.465]},
        "93": {"vr": "DS", "Value": [88.585]},
        "94": {"vr": "DS", "Value": [523.59]},
        "95": {"vr": "DS", "Value": [147.6775]},
        "96": {"vr": "DS", "Value": [157.65]},
        "97": {"vr": "DS", "Value": [586.3625]},
        "98": {"vr": "DS", "Value": [21.26]},
        "99": {"vr": "DS", "Value": [21.99]},
        "100": {"vr": "DS", "Value": [78.3025]},
        "101": {"vr": "DS", "Value": [234.5075]},
        "102": {"vr": "DS", "Value": [80.3725]},
        "103": {"vr": "DS", "Value": [317.0925]},
        "104": {"vr": "DS", "Value": [477.835]},
        "105": {"vr": "DS", "Value": [520.665]},
        "106": {"vr": "DS", "Value": [433.1025]},
        "107": {"vr": "DS", "Value": [512.89]},
        "108": {"vr": "DS", "Value": [135.9525]},
        "109": {"vr": "DS", "Value": [137.415]},
        "110": {"vr": "DS", "Value": [579.025]},
        "111": {"vr": "DS", "Value": [481.2]},
        "112": {"vr": "DS", "Value": [203.1325]},
        "113": {"vr": "DS", "Value": [574.49]},
        "114": {"vr": "DS", "Value": [305.2]},
        "115": {"vr": "DS", "Value": [442.195]},
        "116": {"vr": "DS", "Value": [490.7325]},
        "117": {"vr": "DS", "Value": [127.445]},
        "118": {"vr": "DS", "Value": [390.86]},
        "119": {"vr": "DS", "Value": [588.995]},
        "120": {"vr": "DS", "Value": [52.3425]},
        "121": {"vr": "DS", "Value": [34.155]},
        "122": {"vr": "DS", "Value": [465.21]},
        "123": {"vr": "DS", "Value": [19.795]},
        "124": {"vr": "DS", "Value": [437.4925]},
        "125": {"vr": "DS", "Value": [309.025]},
        "126": {"vr": "DS", "Value": [571.1025]},
        "127": {"vr": "DS", "Value": [260.9075]},
        "128": {"vr": "DS", "Value": [396.7325]},
        "129": {"vr": "DS", "Value": [191.0925]},
        "130": {"vr": "DS", "Value": [74.645]},
        "131": {"vr": "DS", "Value": [406.7025]},
        "132": {"vr": "DS", "Value": [520.225]},
        "133": {"vr": "DS", "Value": [566.275]},
        "134": {"vr": "DS", "Value": [521.69]},
        "135": {"vr": "DS", "Value": [165.425]},
        "136": {"vr": "DS", "Value": [284.235]},
        "137": {"vr": "DS", "Value": [344.665]},
        "138": {"vr": "DS", "Value": [77.425]},
        "139": {"vr": "DS", "Value": [182.8775]},
        "140": {"vr": "DS", "Value": [220.0]},
        "141": {"vr": "DS", "Value": [42.0775]},
        "142": {"vr": "DS", "Value": [320.605]},
        "143": {"vr": "DS", "Value": [465.9425]},
        "144": {"vr": "DS", "Value": [326.9175]},
        "145": {"vr": "DS", "Value": [472.4]},
        "146": {"vr": "DS", "Value": [64.235]},
        "147": {"vr": "DS", "Value": [145.4825]},
        "148": {"vr": "DS", "Value": [484.5875]},
        "149": {"vr": "DS", "Value": [464.04]},
        "150": {"vr": "DS", "Value": [297.7175]},
        "151": {"vr": "DS", "Value": [139.7575]},
        "152": {"vr": "DS", "Value": [580.195]},
        "153": {"vr": "DS", "Value": [154.7225]},
        "154": {"vr": "DS", "Value": [18.625]},
        "155": {"vr": "DS", "Value": [419.455]},
        "156": {"vr": "DS", "Value": [169.6875]},
        "157": {"vr": "DS", "Value": [242.43]},
        "158": {"vr": "DS", "Value": [329.405]},
        "159": {"vr": "DS", "Value": [59.385]},
        "160": {"vr": "DS", "Value": [596.625]},
        "161": {"vr": "DS", "Value": [479.005]},
        "162": {"vr": "DS", "Value": [158.235]},
        "163": {"vr": "DS", "Value": [462.7225]},
        "164": {"vr": "DS", "Value": [122.1575]},
        "165": {"vr": "DS", "Value": [449.5325]},
        "166": {"vr": "DS", "Value": [351.25]},
        "167": {"vr": "DS", "Value": [249.62]},
        "168": {"vr": "DS", "Value": [94.8775]},
        "169": {"vr": "DS", "Value": [188.605]},
        "170": {"vr": "DS", "Value": [55.7275]},
        "171": {"vr": "DS", "Value": [180.39]},
        "172": {"vr": "DS", "Value": [44.8775]},
        "173": {"vr": "DS", "Value": [569.055]},
        "174": {"vr": "DS", "Value": [134.9275]},
        "175": {"vr": "DS", "Value": [200.185]},
        "176": {"vr": "DS", "Value": [28.7425]},
        "177": {"vr": "DS", "Value": [475.2]},
        "178": {"vr": "DS", "Value": [550.87]},
        "179": {"vr": "DS", "Value": [469.035]},
        "180": {"vr": "DS", "Value": [125.6875]},
        "181": {"vr": "DS", "Value": [202.235]},
        "182": {"vr": "DS", "Value": [451.5825]},
        "183": {"vr": "DS", "Value": [377.21]},
        "184": {"vr": "DS", "Value": [35.9325]},
        "185": {"vr": "DS", "Value": [172.03]},
        "186": {"vr": "DS", "Value": [441.1725]},
        "187": {"vr": "DS", "Value": [442.635]},
        "188": {"vr": "DS", "Value": [566.86]},
        "189": {"vr": "DS", "Value": [241.845]},
        "190": {"vr": "DS", "Value": [323.0925]},
        "191": {"vr": "DS", "Value": [8.4875]},
        "192": {"vr": "DS", "Value": [426.79]},
        "193": {"vr": "DS", "Value": [74.06]},
        "194": {"vr": "DS", "Value": [555.425]},
        "195": {"vr": "DS", "Value": [330.87]},
        "196": {"vr": "DS", "Value": [369.6]},
        "197": {"vr": "DS", "Value": [244.185]},
        "198": {"vr": "DS", "Value": [2.4875]},
        "199": {"vr": "DS", "Value": [374.87]},
        "200": {"vr": "DS", "Value": [33.7175]},
        "201": {"vr": "DS", "Value": [405.9725]},
        "202": {"vr": "DS", "Value": [434.42]},
        "203": {"vr": "DS", "Value": [171.7375]},
        "204": {"vr": "DS", "Value": [256.5175]},
        "205": {"vr": "DS", "Value": [446.585]},
        "206": {"vr": "DS", "Value": [458.7725]},
        "207": {"vr": "DS", "Value": [343.64]},
        "208": {"vr": "DS", "Value": [43.5425]},
        "209": {"vr": "DS", "Value": [81.6875]},
        "210": {"vr": "DS", "Value": [305.3475]},
        "211": {"vr": "DS", "Value": [336.3025]},
        "212": {"vr": "DS", "Value": [527.1025]},
        "213": {"vr": "DS", "Value": [528.295]},
        "214": {"vr": "DS", "Value": [429.425]},
        "215": {"vr": "DS", "Value": [356.39]},
        "216": {"vr": "DS", "Value": [133.3175]},
        "217": {"vr": "DS", "Value": [123.035]},
        "218": {"vr": "DS", "Value": [556.45]},
        "219": {"vr": "DS", "Value": [272.4875]},
        "220": {"vr": "DS", "Value": [213.6875]},
        "221": {"vr": "DS", "Value": [313.855]},
        "222": {"vr": "DS", "Value": [324.5575]},
        "223": {"vr": "DS", "Value": [43.6875]},
        "224": {"vr": "DS", "Value": [51.3175]},
        "225": {"vr": "DS", "Value": [55.435]},
        "226": {"vr": "DS", "Value": [370.7725]},
        "227": {"vr": "DS", "Value": [110.43]},
        "228": {"vr": "DS", "Value": [341.425]},
        "229": {"vr": "DS", "Value": [190.9475]},
        "230": {"vr": "DS", "Value": [131.835]},
        "231": {"vr": "DS", "Value": [121.57]},
        "232": {"vr": "DS", "Value": [449.24]},
        "233": {"vr": "DS", "Value": [459.65]},
        "234": {"vr": "DS", "Value": [189.045]},
        "235": {"vr": "DS", "Value": [458.48]},
        "236": {"vr": "DS", "Value": [533.5625]},
        "237": {"vr": "DS", "Value": [43.395]},
        "238": {"vr": "DS", "Value": [312.6825]},
        "239": {"vr": "DS", "Value": [469.1825]},
        "240": {"vr": "DS", "Value": [240.82]},
        "241": {"vr": "DS", "Value": [312.5375]},
        "242": {"vr": "DS", "Value": [385.1325]},
        "243": {"vr": "DS", "Value": [205.62]},
        "244": {"vr": "DS", "Value": [562.1575]},
        "245": {"vr": "DS", "Value": [506.1375]},
        "246": {"vr": "DS", "Value": [3.365]},
        "247": {"vr": "DS", "Value": [80.225]},
        "248": {"vr": "DS", "Value": [338.9375]},
        "249": {"vr": "DS", "Value": [348.7625]},
        "250": {"vr": "DS", "Value": [395.395]},
        "251": {"vr": "DS", "Value": [178.4875]},
        "252": {"vr": "DS", "Value": [319.875]},
        "253": {"vr": "DS", "Value": [325.7475]},
        "254": {"vr": "DS", "Value": [359.9025]},
        "255": {"vr": "DS", "Value": [228.4875]},
        "256": {"vr": "DS", "Value": [499.385]},
        "257": {"vr": "DS", "Value": [545.7475]},
        "258": {"vr": "DS", "Value": [238.9175]},
        "259": {"vr": "DS", "Value": [235.24]},
        "260": {"vr": "DS", "Value": [102.3625]},
        "261": {"vr": "DS", "Value": [490.1475]},
        "262": {"vr": "DS", "Value": [177.465]},
        "263": {"vr": "DS", "Value": [76.6925]},
        "264": {"vr": "DS", "Value": [511.5725]},
        "265": {"vr": "DS", "Value": [564.9575]},
        "266": {"vr": "DS", "Value": [576.39]},
        "267": {"vr": "DS", "Value": [215.59]},
        "268": {"vr": "DS", "Value": [87.6875]},
        "269": {"vr": "DS", "Value": [420.3325]},
        "270": {"vr": "DS", "Value": [597.9425]},
        "271": {"vr": "DS", "Value": [444.5375]},
        "272": {"vr": "DS", "Value": [553.9425]},
        "273": {"vr": "DS", "Value": [286.2825]},
        "274": {"vr": "DS", "Value": [89.3175]},
        "275": {"vr": "DS", "Value": [111.3075]},
        "276": {"vr": "DS", "Value": [447.9025]},
        "277": {"vr": "DS", "Value": [538.85]},
        "278": {"vr": "DS", "Value": [212.81]},
        "279": {"vr": "DS", "Value": [182.2925]},
        "280": {"vr": "DS", "Value": [366.655]},
        "281": {"vr": "DS", "Value": [237.7475]},
        "282": {"vr": "DS", "Value": [41.055]},
        "283": {"vr": "DS", "Value": [289.9425]},
        "284": {"vr": "DS", "Value": [554.695]},
        "285": {"vr": "DS", "Value": [446.0]},
        "286": {"vr": "DS", "Value": [324.995]},
        "287": {"vr": "DS", "Value": [75.5225]},
        "288": {"vr": "DS", "Value": [137.5625]},
        "289": {"vr": "DS", "Value": [580.3425]},
        "290": {"vr": "DS", "Value": [589.895]},
        "291": {"vr": "DS", "Value": [243.7475]},
        "292": {"vr": "DS", "Value": [288.04]},
        "293": {"vr": "DS", "Value": [144.02]},
        "294": {"vr": "DS", "Value": [563.035]},
        "295": {"vr": "DS", "Value": [391.8825]},
        "296": {"vr": "DS", "Value": [158.4]},
        "297": {"vr": "DS", "Value": [26.985]},
        "298": {"vr": "DS", "Value": [31.0825]},
        "299": {"vr": "DS", "Value": [24.185]},
        "300": {"vr": "DS", "Value": [565.395]},
        "301": {"vr": "DS", "Value": [593.26]},
        "302": {"vr": "DS", "Value": [370.9175]},
        "303": {"vr": "DS", "Value": [268.39]},
        "304": {"vr": "DS", "Value": [276.1675]},
        "305": {"vr": "DS", "Value": [125.5425]},
        "306": {"vr": "DS", "Value": [544.7025]},
        "307": {"vr": "DS", "Value": [269.5625]},
        "308": {"vr": "DS", "Value": [530.195]},
        "309": {"vr": "DS", "Value": [349.2]},
        "310": {"vr": "DS", "Value": [329.1125]},
        "311": {"vr": "DS", "Value": [106.185]},
        "312": {"vr": "DS", "Value": [393.2]},
        "313": {"vr": "DS", "Value": [594.285]},
        "314": {"vr": "DS", "Value": [572.88]},
        "315": {"vr": "DS", "Value": [139.4625]},
        "316": {"vr": "DS", "Value": [106.7725]},
        "317": {"vr": "DS", "Value": [535.9025]},
        "318": {"vr": "DS", "Value": [215.1525]},
        "319": {"vr": "DS", "Value": [329.845]},
        "320": {"vr": "DS", "Value": [379.425]},
        "321": {"vr": "DS", "Value": [136.83]},
        "322": {"vr": "DS", "Value": [548.82]},
        "323": {"vr": "DS", "Value": [279.97]},
        "324": {"vr": "DS", "Value": [266.9275]},
        "325": {"vr": "DS", "Value": [132.585]},
        "326": {"vr": "DS", "Value": [56.8975]},
        "327": {"vr": "DS", "Value": [375.6]},
        "328": {"vr": "DS", "Value": [491.1725]},
        "329": {"vr": "DS", "Value": [376.77]},
        "330": {"vr": "DS", "Value": [41.4925]},
        "331": {"vr": "DS", "Value": [287.1625]},
        "332": {"vr": "DS", "Value": [130.37]},
        "333": {"vr": "DS", "Value": [455.24]},
        "334": {"vr": "DS", "Value": [252.985]},
        "335": {"vr": "DS", "Value": [187.435]},
        "336": {"vr": "DS", "Value": [144.3125]},
        "337": {"vr": "DS", "Value": [245.21]},
        "338": {"vr": "DS", "Value": [40.615]},
        "339": {"vr": "DS", "Value": [218.81]},
        "340": {"vr": "DS", "Value": [89.7575]},
        "341": {"vr": "DS", "Value": [573.3175]},
        "342": {"vr": "DS", "Value": [184.195]},
        "343": {"vr": "DS", "Value": [517.2775]},
        "344": {"vr": "DS", "Value": [221.025]},
        "345": {"vr": "DS", "Value": [423.865]},
        "346": {"vr": "DS", "Value": [81.395]},
        "347": {"vr": "DS", "Value": [120.84]},
        "348": {"vr": "DS", "Value": [292.7425]},
        "349": {"vr": "DS", "Value": [3.22]},
        "350": {"vr": "DS", "Value": [401.7075]},
        "351": {"vr": "DS", "Value": [543.0925]},
        "352": {"vr": "DS", "Value": [294.3525]},
        "353": {"vr": "DS", "Value": [291.5725]},
        "354": {"vr": "DS", "Value": [265.61]},
        "355": {"vr": "DS", "Value": [502.625]},
        "356": {"vr": "DS", "Value": [165.1325]},
        "357": {"vr": "DS", "Value": [33.425]},
        "358": {"vr": "DS", "Value": [448.05]},
        "359": {"vr": "DS", "Value": [128.7625]},
        "360": {"vr": "DS", "Value": [35.785]},
        "361": {"vr": "DS", "Value": [303.1525]},
        "362": {"vr": "DS", "Value": [434.7125]},
        "363": {"vr": "DS", "Value": [307.6875]},
        "364": {"vr": "DS", "Value": [502.48]},
        "365": {"vr": "DS", "Value": [308.5875]},
        "366": {"vr": "DS", "Value": [565.835]},
        "367": {"vr": "DS", "Value": [120.6925]},
        "368": {"vr": "DS", "Value": [107.65]},
        "369": {"vr": "DS", "Value": [486.3425]},
        "370": {"vr": "DS", "Value": [443.805]},
        "371": {"vr": "DS", "Value": [434.275]},
        "372": {"vr": "DS", "Value": [421.3575]},
        "373": {"vr": "DS", "Value": [368.1175]},
        "374": {"vr": "DS", "Value": [267.075]},
        "375": {"vr": "DS", "Value": [361.5325]},
        "376": {"vr": "DS", "Value": [286.1375]},
        "377": {"vr": "DS", "Value": [491.61]},
        "378": {"vr": "DS", "Value": [258.275]},
        "379": {"vr": "DS", "Value": [157.0625]},
        "380": {"vr": "DS", "Value": [246.0875]},
        "381": {"vr": "DS", "Value": [144.8975]},
        "382": {"vr": "DS", "Value": [226.585]},
        "383": {"vr": "DS", "Value": [6.0]},
        "384": {"vr": "DS", "Value": [301.835]},
        "385": {"vr": "DS", "Value": [523.005]},
        "386": {"vr": "DS", "Value": [524.03]},
        "387": {"vr": "DS", "Value": [363.1425]},
        "388": {"vr": "DS", "Value": [542.07]},
        "389": {"vr": "DS", "Value": [247.5725]},
        "390": {"vr": "DS", "Value": [118.205]},
        "391": {"vr": "DS", "Value": [528.1475]},
        "392": {"vr": "DS", "Value": [185.5325]},
        "393": {"vr": "DS", "Value": [373.405]},
        "394": {"vr": "DS", "Value": [352.7325]},
        "395": {"vr": "DS", "Value": [297.57]},
        "396": {"vr": "DS", "Value": [206.79]},
        "397": {"vr": "DS", "Value": [290.6925]},
        "398": {"vr": "DS", "Value": [57.3375]},
        "399": {"vr": "DS", "Value": [112.3325]},
        "400": {"vr": "DS", "Value": [246.9875]},
        "401": {"vr": "DS", "Value": [103.97]},
        "402": {"vr": "DS", "Value": [173.9325]},
        "403": {"vr": "DS", "Value": [340.255]},
        "404": {"vr": "DS", "Value": [53.9725]},
        "405": {"vr": "DS", "Value": [437.2]},
        "406": {"vr": "DS", "Value": [139.17]},
        "407": {"vr": "DS", "Value": [178.3425]},
        "408": {"vr": "DS", "Value": [314.44]},
        "409": {"vr": "DS", "Value": [352.0]},
        "410": {"vr": "DS", "Value": [155.015]},
        "411": {"vr": "DS", "Value": [513.7675]},
        "412": {"vr": "DS", "Value": [31.375]},
        "413": {"vr": "DS", "Value": [120.1075]},
        "414": {"vr": "DS", "Value": [58.655]},
        "415": {"vr": "DS", "Value": [480.03]},
        "416": {"vr": "DS", "Value": [281.6]},
        "417": {"vr": "DS", "Value": [66.1375]},
        "418": {"vr": "DS", "Value": [6.8775]},
        "419": {"vr": "DS", "Value": [59.0925]},
        "420": {"vr": "DS", "Value": [578.44]},
        "421": {"vr": "DS", "Value": [80.665]},
        "422": {"vr": "DS", "Value": [162.06]},
        "423": {"vr": "DS", "Value": [506.43]},
        "424": {"vr": "DS", "Value": [398.9275]},
        "425": {"vr": "DS", "Value": [557.7675]},
        "426": {"vr": "DS", "Value": [415.5025]},
        "427": {"vr": "DS", "Value": [388.3725]},
        "428": {"vr": "DS", "Value": [542.3625]},
        "429": {"vr": "DS", "Value": [418.5775]},
        "430": {"vr": "DS", "Value": [333.5025]},
        "431": {"vr": "DS", "Value": [103.825]},
        "432": {"vr": "DS", "Value": [558.205]},
        "433": {"vr": "DS", "Value": [386.01]},
        "434": {"vr": "DS", "Value": [124.08]},
        "435": {"vr": "DS", "Value": [576.83]},
        "436": {"vr": "DS", "Value": [18.3325]},
        "437": {"vr": "DS", "Value": [198.2825]},
        "438": {"vr": "DS", "Value": [355.9525]},
        "439": {"vr": "DS", "Value": [480.1775]},
        "440": {"vr": "DS", "Value": [537.9725]},
        "441": {"vr": "DS", "Value": [81.1025]},
        "442": {"vr": "DS", "Value": [99.1425]},
        "443": {"vr": "DS", "Value": [514.645]},
        "444": {"vr": "DS", "Value": [392.615]},
        "445": {"vr": "DS", "Value": [398.635]},
        "446": {"vr": "DS", "Value": [466.9875]},
        "447": {"vr": "DS", "Value": [23.015]},
        "448": {"vr": "DS", "Value": [501.1425]},
        "449": {"vr": "DS", "Value": [336.01]},
        "450": {"vr": "DS", "Value": [534.2925]},
        "451": {"vr": "DS", "Value": [128.9075]},
        "452": {"vr": "DS", "Value": [450.5575]},
        "453": {"vr": "DS", "Value": [42.225]},
        "454": {"vr": "DS", "Value": [188.46]},
        "455": {"vr": "DS", "Value": [354.195]},
        "456": {"vr": "DS", "Value": [182.44]},
        "457": {"vr": "DS", "Value": [196.0875]},
        "458": {"vr": "DS", "Value": [251.375]},
        "459": {"vr": "DS", "Value": [180.975]},
        "460": {"vr": "DS", "Value": [215.005]},
        "461": {"vr": "DS", "Value": [354.05]},
        "462": {"vr": "DS", "Value": [266.3425]},
        "463": {"vr": "DS", "Value": [366.07]},
        "464": {"vr": "DS", "Value": [484.88]},
        "465": {"vr": "DS", "Value": [167.785]},
        "466": {"vr": "DS", "Value": [118.4975]},
        "467": {"vr": "DS", "Value": [316.195]},
        "468": {"vr": "DS", "Value": [41.64]},
        "469": {"vr": "DS", "Value": [590.625]},
        "470": {"vr": "DS", "Value": [342.3025]},
        "471": {"vr": "DS", "Value": [333.65]},
        "472": {"vr": "DS", "Value": [123.4925]},
        "473": {"vr": "DS", "Value": [529.025]},
        "474": {"vr": "DS", "Value": [514.9375]},
        "475": {"vr": "DS", "Value": [5.1225]},
        "476": {"vr": "DS", "Value": [523.885]},
        "477": {"vr": "DS", "Value": [148.41]},
        "478": {"vr": "DS", "Value": [553.3575]},
        "479": {"vr": "DS", "Value": [476.665]},
        "480": {"vr": "DS", "Value": [282.7725]},
        "481": {"vr": "DS", "Value": [23.3075]},
        "482": {"vr": "DS", "Value": [128.03]},
        "483": {"vr": "DS", "Value": [497.19]},
        "484": {"vr": "DS", "Value": [370.1875]},
        "485": {"vr": "DS", "Value": [436.03]},
        "486": {"vr": "DS", "Value": [196.38]},
        "487": {"vr": "DS", "Value": [222.78]},
        "488": {"vr": "DS", "Value": [230.995]},
        "489": {"vr": "DS", "Value": [470.06]},
        "490": {"vr": "DS", "Value": [331.1625]},
        "491": {"vr": "DS", "Value": [288.77]},
        "492": {"vr": "DS", "Value": [147.385]},
        "493": {"vr": "DS", "Value": [479.59]},
        "494": {"vr": "DS", "Value": [508.4775]},
        "495": {"vr": "DS", "Value": [198.575]},
        "496": {"vr": "DS", "Value": [295.9625]},
        "497": {"vr": "DS", "Value": [8.3425]},
        "498": {"vr": "DS", "Value": [561.1325]},
        "499": {"vr": "DS", "Value": [55.2875]},
        "500": {"vr": "DS", "Value": [74.3525]},
        "501": {"vr": "DS", "Value": [597.3575]},
        "502": {"vr": "DS", "Value": [322.5075]},
        "503": {"vr": "DS", "Value": [237.8925]},
        "504": {"vr": "DS", "Value": [214.275]},
        "505": {"vr": "DS", "Value": [58.5075]},
        "506": {"vr": "DS", "Value": [136.245]},
        "507": {"vr": "DS", "Value": [110.8675]},
        "508": {"vr": "DS", "Value": [161.9125]},
        "509": {"vr": "DS", "Value": [273.24]},
        "510": {"vr": "DS", "Value": [528.5875]},
        "511": {"vr": "DS", "Value": [268.975]},
        "512": {"vr": "DS", "Value": [175.395]},
        "513": {"vr": "DS", "Value": [436.9075]},
        "514": {"vr": "DS", "Value": [109.405]},
        "515": {"vr": "DS", "Value": [205.18]},
        "516": {"vr": "DS", "Value": [18.7725]},
        "517": {"vr": "DS", "Value": [521.25]},
        "518": {"vr": "DS", "Value": [232.1675]},
        "519": {"vr": "DS", "Value": [128.175]},
        "520": {"vr": "DS", "Value": [403.7575]},
        "521": {"vr": "DS", "Value": [31.5225]},
        "522": {"vr": "DS", "Value": [278.9475]},
        "523": {"vr": "DS", "Value": [583.29]},
        "524": {"vr": "DS", "Value": [123.785]},
        "525": {"vr": "DS", "Value": [281.7475]},
        "526": {"vr": "DS", "Value": [562.595]},
        "527": {"vr": "DS", "Value": [539.1425]},
        "528": {"vr": "DS", "Value": [535.61]},
        "529": {"vr": "DS", "Value": [30.645]},
        "530": {"vr": "DS", "Value": [145.3375]},
        "531": {"vr": "DS", "Value": [210.3025]},
        "532": {"vr": "DS", "Value": [29.18]},
        "533": {"vr": "DS", "Value": [151.5025]},
        "534": {"vr": "DS", "Value": [319.2875]},
        "535": {"vr": "DS", "Value": [438.9575]},
        "536": {"vr": "DS", "Value": [412.7025]},
        "537": {"vr": "DS", "Value": [312.0975]},
        "538": {"vr": "DS", "Value": [356.0975]},
        "539": {"vr": "DS", "Value": [0.8775]},
        "540": {"vr": "DS", "Value": [189.63]},
        "541": {"vr": "DS", "Value": [548.9675]},
        "542": {"vr": "DS", "Value": [306.81]},
        "543": {"vr": "DS", "Value": [589.1425]},
        "544": {"vr": "DS", "Value": [107.21]},
        "545": {"vr": "DS", "Value": [269.7075]},
        "546": {"vr": "DS", "Value": [541.045]},
        "547": {"vr": "DS", "Value": [538.5575]},
        "548": {"vr": "DS", "Value": [210.01]},
        "549": {"vr": "DS", "Value": [380.3025]},
        "550": {"vr": "DS", "Value": [348.615]},
        "551": {"vr": "DS", "Value": [480.9075]},
        "552": {"vr": "DS", "Value": [356.6825]},
        "553": {"vr": "DS", "Value": [108.6725]},
        "554": {"vr": "DS", "Value": [307.1025]},
        "555": {"vr": "DS", "Value": [2.195]},
        "556": {"vr": "DS", "Value": [150.7725]},
        "557": {"vr": "DS", "Value": [568.1775]},
        "558": {"vr": "DS", "Value": [361.9725]},
        "559": {"vr": "DS", "Value": [467.28]},
        "560": {"vr": "DS", "Value": [359.3175]},
        "561": {"vr": "DS", "Value": [526.08]},
        "562": {"vr": "DS", "Value": [421.9425]},
        "563": {"vr": "DS", "Value": [177.3175]},
        "564": {"vr": "DS", "Value": [359.7575]},
        "565": {"vr": "DS", "Value": [244.4775]},
        "566": {"vr": "DS", "Value": [382.205]},
        "567": {"vr": "DS", "Value": [209.8625]},
        "568": {"vr": "DS", "Value": [412.265]},
        "569": {"vr": "DS", "Value": [257.25]},
        "570": {"vr": "DS", "Value": [193.6]},
        "571": {"vr": "DS", "Value": [490.585]},
        "572": {"vr": "DS", "Value": [527.395]},
        "573": {"vr": "DS", "Value": [552.185]},
        "574": {"vr": "DS", "Value": [533.7075]},
        "575": {"vr": "DS", "Value": [371.065]},
        "576": {"vr": "DS", "Value": [382.645]},
        "577": {"vr": "DS", "Value": [514.79]},
        "578": {"vr": "DS", "Value": [314.2925]},
        "579": {"vr": "DS", "Value": [475.64]},
        "580": {"vr": "DS", "Value": [479.445]},
        "581": {"vr": "DS", "Value": [407.875]},
        "582": {"vr": "DS", "Value": [310.195]},
        "583": {"vr": "DS", "Value": [381.7675]},
        "584": {"vr": "DS", "Value": [439.1025]},
        "585": {"vr": "DS", "Value": [4.975]},
        "586": {"vr": "DS", "Value": [516.5475]},
        "587": {"vr": "DS", "Value": [105.8925]},
        "588": {"vr": "DS", "Value": [144.605]},
        "589": {"vr": "DS", "Value": [503.21]},
        "590": {"vr": "DS", "Value": [235.5325]},
        "591": {"vr": "DS", "Value": [337.9125]},
        "592": {"vr": "DS", "Value": [520.08]},
        "593": {"vr": "DS", "Value": [452.46]},
        "594": {"vr": "DS", "Value": [20.0875]},
        "595": {"vr": "DS", "Value": [27.425]},
        "596": {"vr": "DS", "Value": [288.625]},
        "597": {"vr": "DS", "Value": [239.9425]},
        "598": {"vr": "DS", "Value": [509.5025]},
        "599": {"vr": "DS", "Value": [160.01]},
        "600": {"vr": "DS", "Value": [209.7175]},
        "601": {"vr": "DS", "Value": [405.24]},
        "602": {"vr": "DS", "Value": [295.815]},
        "603": {"vr": "DS", "Value": [546.48]},
        "604": {"vr": "DS", "Value": [70.4]},
        "605": {"vr": "DS", "Value": [558.79]},
        "606": {"vr": "DS", "Value": [449.3875]},
        "607": {"vr": "DS", "Value": [386.8875]},
        "608": {"vr": "DS", "Value": [537.68]},
        "609": {"vr": "DS", "Value": [433.69]},
        "610": {"vr": "DS", "Value": [567.885]},
        "611": {"vr": "DS", "Value": [304.7625]},
        "612": {"vr": "DS", "Value": [30.9375]},
        "613": {"vr": "DS", "Value": [471.9625]},
        "614": {"vr": "DS", "Value": [298.01]},
        "615": {"vr": "DS", "Value": [413.435]},
        "616": {"vr": "DS", "Value": [422.4]},
        "617": {"vr": "DS", "Value": [66.8675]},
        "618": {"vr": "DS", "Value": [122.8875]},
        "619": {"vr": "DS", "Value": [324.7025]},
        "620": {"vr": "DS", "Value": [321.9225]},
        "621": {"vr": "DS", "Value": [96.195]},
        "622": {"vr": "DS", "Value": [22.2825]},
        "623": {"vr": "DS", "Value": [536.635]},
        "624": {"vr": "DS", "Value": [591.5025]},
        "625": {"vr": "DS", "Value": [482.5175]},
        "626": {"vr": "DS", "Value": [140.9475]},
        "627": {"vr": "DS", "Value": [117.4725]},
        "628": {"vr": "DS", "Value": [26.84]},
        "629": {"vr": "DS", "Value": [248.3025]},
        "630": {"vr": "DS", "Value": [443.22]},
        "631": {"vr": "DS", "Value": [180.5375]},
        "632": {"vr": "DS", "Value": [65.99]},
        "633": {"vr": "DS", "Value": [323.5325]},
        "634": {"vr": "DS", "Value": [185.385]},
        "635": {"vr": "DS", "Value": [452.8975]},
        "636": {"vr": "DS", "Value": [114.235]},
        "637": {"vr": "DS", "Value": [124.81]},
        "638": {"vr": "DS", "Value": [414.1875]},
        "639": {"vr": "DS", "Value": [574.1975]},
        "640": {"vr": "DS", "Value": [87.1025]},
        "641": {"vr": "DS", "Value": [72.45]},
        "642": {"vr": "DS", "Value": [178.78]},
        "643": {"vr": "DS", "Value": [440.1475]},
        "644": {"vr": "DS", "Value": [488.5375]},
        "645": {"vr": "DS", "Value": [262.5175]},
        "646": {"vr": "DS", "Value": [492.635]},
        "647": {"vr": "DS", "Value": [362.41]},
        "648": {"vr": "DS", "Value": [553.65]},
        "649": {"vr": "DS", "Value": [254.8875]},
        "650": {"vr": "DS", "Value": [82.86]},
        "651": {"vr": "DS", "Value": [158.5475]},
        "652": {"vr": "DS", "Value": [485.9025]},
        "653": {"vr": "DS", "Value": [149.8925]},
        "654": {"vr": "DS", "Value": [394.5175]},
        "655": {"vr": "DS", "Value": [195.9425]},
        "656": {"vr": "DS", "Value": [383.67]},
        "657": {"vr": "DS", "Value": [40.4675]},
        "658": {"vr": "DS", "Value": [424.45]},
        "659": {"vr": "DS", "Value": [94.7325]},
        "660": {"vr": "DS", "Value": [326.7725]},
        "661": {"vr": "DS", "Value": [485.465]},
        "662": {"vr": "DS", "Value": [103.24]},
        "663": {"vr": "DS", "Value": [598.235]},
        "664": {"vr": "DS", "Value": [415.065]},
        "665": {"vr": "DS", "Value": [414.3325]},
        "666": {"vr": "DS", "Value": [286.7225]},
        "667": {"vr": "DS", "Value": [83.8825]},
        "668": {"vr": "DS", "Value": [302.275]},
        "669": {"vr": "DS", "Value": [27.2775]},
        "670": {"vr": "DS", "Value": [77.8625]},
        "671": {"vr": "DS", "Value": [364.8975]},
        "672": {"vr": "DS", "Value": [541.3375]},
        "673": {"vr": "DS", "Value": [57.775]},
        "674": {"vr": "DS", "Value": [490.0]},
        "675": {"vr": "DS", "Value": [228.8]},
        "676": {"vr": "DS", "Value": [213.25]},
        "677": {"vr": "DS", "Value": [243.1625]},
        "678": {"vr": "DS", "Value": [95.4625]},
        "679": {"vr": "DS", "Value": [301.6875]},
        "680": {"vr": "DS", "Value": [392.1775]},
        "681": {"vr": "DS", "Value": [575.5125]},
        "682": {"vr": "DS", "Value": [458.3325]},
        "683": {"vr": "DS", "Value": [571.835]},
        "684": {"vr": "DS", "Value": [435.1525]},
        "685": {"vr": "DS", "Value": [62.3325]},
        "686": {"vr": "DS", "Value": [245.065]},
        "687": {"vr": "DS", "Value": [400.5375]},
        "688": {"vr": "DS", "Value": [278.215]},
        "689": {"vr": "DS", "Value": [22.8675]},
        "690": {"vr": "DS", "Value": [299.7875]},
        "691": {"vr": "DS", "Value": [36.5175]},
        "692": {"vr": "DS", "Value": [44.2925]},
        "693": {"vr": "DS", "Value": [48.975]},
        "694": {"vr": "DS", "Value": [271.3175]},
        "695": {"vr": "DS", "Value": [60.7025]},
        "696": {"vr": "DS", "Value": [446.7325]},
        "697": {"vr": "DS", "Value": [250.9375]},
        "698": {"vr": "DS", "Value": [361.24]},
        "699": {"vr": "DS", "Value": [210.595]},
        "700": {"vr": "DS", "Value": [56.7525]},
        "701": {"vr": "DS", "Value": [447.465]},
        "702": {"vr": "DS", "Value": [37.25]},
        "703": {"vr": "DS", "Value": [473.2775]},
        "704": {"vr": "DS", "Value": [179.9525]},
        "705": {"vr": "DS", "Value": [191.385]},
        "706": {"vr": "DS", "Value": [370.04]},
        "707": {"vr": "DS", "Value": [112.04]},
        "708": {"vr": "DS", "Value": [215.8825]},
        "709": {"vr": "DS", "Value": [462.2825]},
        "710": {"vr": "DS", "Value": [482.3725]},
        "711": {"vr": "DS", "Value": [429.865]},
        "712": {"vr": "DS", "Value": [21.1125]},
        "713": {"vr": "DS", "Value": [344.9575]},
        "714": {"vr": "DS", "Value": [204.7425]},
        "715": {"vr": "DS", "Value": [397.9025]},
        "716": {"vr": "DS", "Value": [424.8875]},
        "717": {"vr": "DS", "Value": [488.0975]},
        "718": {"vr": "DS", "Value": [532.9775]},
        "719": {"vr": "DS", "Value": [287.015]},
        "720": {"vr": "DS", "Value": [69.0625]},
        "721": {"vr": "DS", "Value": [360.195]},
        "722": {"vr": "DS", "Value": [96.8]},
        "723": {"vr": "DS", "Value": [571.5425]},
        "724": {"vr": "DS", "Value": [455.6775]},
        "725": {"vr": "DS", "Value": [32.6925]},
        "726": {"vr": "DS", "Value": [548.09]},
        "727": {"vr": "DS", "Value": [530.3425]},
        "728": {"vr": "DS", "Value": [29.035]},
        "729": {"vr": "DS", "Value": [548.675]},
        "730": {"vr": "DS", "Value": [310.3425]},
        "731": {"vr": "DS", "Value": [239.795]},
        "732": {"vr": "DS", "Value": [107.9425]},
        "733": {"vr": "DS", "Value": [567.1525]},
        "734": {"vr": "DS", "Value": [48.83]},
        "735": {"vr": "DS", "Value": [236.5575]},
        "736": {"vr": "DS", "Value": [143.435]},
        "737": {"vr": "DS", "Value": [75.6675]},
        "738": {"vr": "DS", "Value": [477.5425]},
        "739": {"vr": "DS", "Value": [17.7475]},
        "740": {"vr": "DS", "Value": [103.6775]},
        "741": {"vr": "DS", "Value": [54.1175]},
        "742": {"vr": "DS", "Value": [121.8625]},
        "743": {"vr": "DS", "Value": [507.6]},
        "744": {"vr": "DS", "Value": [358.44]},
        "745": {"vr": "DS", "Value": [115.865]},
        "746": {"vr": "DS", "Value": [119.6675]},
        "747": {"vr": "DS", "Value": [343.3475]},
        "748": {"vr": "DS", "Value": [392.9075]},
        "749": {"vr": "DS", "Value": [414.625]},
        "750": {"vr": "DS", "Value": [581.68]},
        "751": {"vr": "DS", "Value": [182.1475]},
        "752": {"vr": "DS", "Value": [456.995]},
        "753": {"vr": "DS", "Value": [73.3275]},
        "754": {"vr": "DS", "Value": [418.2825]},
        "755": {"vr": "DS", "Value": [282.1875]},
        "756": {"vr": "DS", "Value": [201.65]},
        "757": {"vr": "DS", "Value": [594.43]},
        "758": {"vr": "DS", "Value": [168.225]},
        "759": {"vr": "DS", "Value": [46.195]},
        "760": {"vr": "DS", "Value": [146.3625]},
        "761": {"vr": "DS", "Value": [166.8875]},
        "762": {"vr": "DS", "Value": [570.3725]},
        "763": {"vr": "DS", "Value": [393.055]},
        "764": {"vr": "DS", "Value": [291.865]},
        "765": {"vr": "DS", "Value": [130.6625]},
        "766": {"vr": "DS", "Value": [135.66]},
        "767": {"vr": "DS", "Value": [503.5025]},
        "768": {"vr": "DS", "Value": [339.23]},
        "769": {"vr": "DS", "Value": [443.9525]},
        "770": {"vr": "DS", "Value": [200.04]},
        "771": {"vr": "DS", "Value": [595.455]},
        "772": {"vr": "DS", "Value": [238.3325]},
        "773": {"vr": "DS", "Value": [547.9425]},
        "774": {"vr": "DS", "Value": [163.6675]},
        "775": {"vr": "DS", "Value": [132.0]},
        "776": {"vr": "DS", "Value": [225.1225]},
        "777": {"vr": "DS", "Value": [302.5675]},
        "778": {"vr": "DS", "Value": [576.245]},
        "779": {"vr": "DS", "Value": [42.6625]},
        "780": {"vr": "DS", "Value": [346.86]},
        "781": {"vr": "DS", "Value": [234.8]},
        "782": {"vr": "DS", "Value": [550.5775]},
        "783": {"vr": "DS", "Value": [425.9125]},
        "784": {"vr": "DS", "Value": [24.625]},
        "785": {"vr": "DS", "Value": [412.1175]},
        "786": {"vr": "DS", "Value": [344.08]},
        "787": {"vr": "DS", "Value": [118.645]},
        "788": {"vr": "DS", "Value": [496.02]},
        "789": {"vr": "DS", "Value": [192.7025]},
        "790": {"vr": "DS", "Value": [540.7525]},
        "791": {"vr": "DS", "Value": [498.3625]},
        "792": {"vr": "DS", "Value": [50.7325]},
        "793": {"vr": "DS", "Value": [414.7725]},
        "794": {"vr": "DS", "Value": [192.1175]},
        "795": {"vr": "DS", "Value": [243.8925]},
        "796": {"vr": "DS", "Value": [164.985]},
        "797": {"vr": "DS", "Value": [363.5825]},
        "798": {"vr": "DS", "Value": [419.7475]},
        "799": {"vr": "DS", "Value": [39.59]},
        "800": {"vr": "DS", "Value": [88.44]},
        "801": {"vr": "DS", "Value": [17.8925]},
        "802": {"vr": "DS", "Value": [75.23]},
        "803": {"vr": "DS", "Value": [459.5025]},
        "804": {"vr": "DS", "Value": [454.655]},
        "805": {"vr": "DS", "Value": [182.7325]},
        "806": {"vr": "DS", "Value": [365.045]},
        "807": {"vr": "DS", "Value": [441.9025]},
        "808": {"vr": "DS", "Value": [172.615]},
        "809": {"vr": "DS", "Value": [322.07]},
        "810": {"vr": "DS", "Value": [306.225]},
        "811": {"vr": "DS", "Value": [424.1575]},
        "812": {"vr": "DS", "Value": [250.645]},
        "813": {"vr": "DS", "Value": [330.575]},
        "814": {"vr": "DS", "Value": [361.68]},
        "815": {"vr": "DS", "Value": [569.64]},
        "816": {"vr": "DS", "Value": [499.9725]},
        "817": {"vr": "DS", "Value": [578.585]},
        "818": {"vr": "DS", "Value": [333.3575]},
        "819": {"vr": "DS", "Value": [267.9525]},
        "820": {"vr": "DS", "Value": [494.41]},
        "821": {"vr": "DS", "Value": [492.05]},
        "822": {"vr": "DS", "Value": [217.2]},
        "823": {"vr": "DS", "Value": [377.65]},
        "824": {"vr": "DS", "Value": [468.01]},
        "825": {"vr": "DS", "Value": [371.21]},
        "826": {"vr": "DS", "Value": [188.8975]},
        "827": {"vr": "DS", "Value": [592.5275]},
        "828": {"vr": "DS", "Value": [274.1175]},
        "829": {"vr": "DS", "Value": [398.05]},
        "830": {"vr": "DS", "Value": [65.5525]},
        "831": {"vr": "DS", "Value": [195.65]},
        "832": {"vr": "DS", "Value": [159.1325]},
        "833": {"vr": "DS", "Value": [92.5375]},
        "834": {"vr": "DS", "Value": [75.0825]},
        "835": {"vr": "DS", "Value": [582.9975]},
        "836": {"vr": "DS", "Value": [201.3575]},
        "837": {"vr": "DS", "Value": [76.4]},
        "838": {"vr": "DS", "Value": [46.4875]},
        "839": {"vr": "DS", "Value": [137.2675]},
        "840": {"vr": "DS", "Value": [488.9775]},
        "841": {"vr": "DS", "Value": [404.9475]},
        "842": {"vr": "DS", "Value": [54.995]},
        "843": {"vr": "DS", "Value": [297.425]},
        "844": {"vr": "DS", "Value": [169.98]},
        "845": {"vr": "DS", "Value": [38.86]},
        "846": {"vr": "DS", "Value": [303.7375]},
        "847": {"vr": "DS", "Value": [418.87]},
        "848": {"vr": "DS", "Value": [285.6975]},
        "849": {"vr": "DS", "Value": [78.01]},
        "850": {"vr": "DS", "Value": [396.0]},
        "851": {"vr": "DS", "Value": [330.43]},
        "852": {"vr": "DS", "Value": [328.9675]},
        "853": {"vr": "DS", "Value": [437.055]},
        "854": {"vr": "DS", "Value": [156.3325]},
        "855": {"vr": "DS", "Value": [142.7025]},
        "856": {"vr": "DS", "Value": [260.7625]},
        "857": {"vr": "DS", "Value": [368.41]},
        "858": {"vr": "DS", "Value": [171.59]},
        "859": {"vr": "DS", "Value": [64.9675]},
        "860": {"vr": "DS", "Value": [214.86]},
        "861": {"vr": "DS", "Value": [590.04]},
        "862": {"vr": "DS", "Value": [525.2]},
        "863": {"vr": "DS", "Value": [384.985]},
        "864": {"vr": "DS", "Value": [580.8025]},
        "865": {"vr": "DS", "Value": [232.46]},
        "866": {"vr": "DS", "Value": [428.1075]},
        "867": {"vr": "DS", "Value": [111.015]},
        "868": {"vr": "DS", "Value": [397.465]},
        "869": {"vr": "DS", "Value": [118.06]},
        "870": {"vr": "DS", "Value": [206.4975]},
        "871": {"vr": "DS", "Value": [263.1025]},
        "872": {"vr": "DS", "Value": [32.5475]},
        "873": {"vr": "DS", "Value": [516.84]},
        "874": {"vr": "DS", "Value": [410.3625]},
        "875": {"vr": "DS", "Value": [7.755]},
        "876": {"vr": "DS", "Value": [122.45]},
        "877": {"vr": "DS", "Value": [67.015]},
        "878": {"vr": "DS", "Value": [521.395]},
        "879": {"vr": "DS", "Value": [36.9575]},
        "880": {"vr": "DS", "Value": [60.41]},
        "881": {"vr": "DS", "Value": [129.64]},
        "882": {"vr": "DS", "Value": [64.5275]},
        "883": {"vr": "DS", "Value": [123.64]},
        "884": {"vr": "DS", "Value": [507.015]},
        "885": {"vr": "DS", "Value": [597.5025]},
        "886": {"vr": "DS", "Value": [139.61]},
        "887": {"vr": "DS", "Value": [287.6]},
        "888": {"vr": "DS", "Value": [117.9125]},
        "889": {"vr": "DS", "Value": [53.0925]},
        "890": {"vr": "DS", "Value": [168.3725]},
        "891": {"vr": "DS", "Value": [299.035]},
        "892": {"vr": "DS", "Value": [551.8925]},
        "893": {"vr": "DS", "Value": [340.6925]},
        "894": {"vr": "DS", "Value": [160.8875]},
        "895": {"vr": "DS", "Value": [290.84]},
        "896": {"vr": "DS", "Value": [96.3425]},
        "897": {"vr": "DS", "Value": [291.28]},
        "898": {"vr": "DS", "Value": [324.41]},
        "899": {"vr": "DS", "Value": [230.7025]},
        "900": {"vr": "DS", "Value": [266.05]},
        "901": {"vr": "DS", "Value": [68.77]},
        "902": {"vr": "DS", "Value": [328.675]},
        "903": {"vr": "DS", "Value": [587.9725]},
        "904": {"vr": "DS", "Value": [73.62]},
        "905": {"vr": "DS", "Value": [147.0925]},
        "906": {"vr": "DS", "Value": [71.7175]},
        "907": {"vr": "DS", "Value": [419.015]},
        "908": {"vr": "DS", "Value": [292.1575]},
        "909": {"vr": "DS", "Value": [577.27]},
        "910": {"vr": "DS", "Value": [364.7525]},
        "911": {"vr": "DS", "Value": [239.65]},
        "912": {"vr": "DS", "Value": [562.3025]},
        "913": {"vr": "DS", "Value": [369.435]},
        "914": {"vr": "DS", "Value": [143.58]},
        "915": {"vr": "DS", "Value": [339.5225]},
        "916": {"vr": "DS", "Value": [567.445]},
        "917": {"vr": "DS", "Value": [404.8]},
        "918": {"vr": "DS", "Value": [473.5725]},
        "919": {"vr": "DS", "Value": [4.5375]},
        "920": {"vr": "DS", "Value": [100.8975]},
        "921": {"vr": "DS", "Value": [177.9025]},
        "922": {"vr": "DS", "Value": [472.84]},
        "923": {"vr": "DS", "Value": [448.4875]},
        "924": {"vr": "DS", "Value": [0.2925]},
        "925": {"vr": "DS", "Value": [46.3425]},
        "926": {"vr": "DS", "Value": [590.7725]},
        "927": {"vr": "DS", "Value": [417.5525]},
        "928": {"vr": "DS", "Value": [510.5475]},
        "929": {"vr": "DS", "Value": [330.1375]},
        "930": {"vr": "DS", "Value": [279.5325]},
        "931": {"vr": "DS", "Value": [298.595]},
        "932": {"vr": "DS", "Value": [593.405]},
        "933": {"vr": "DS", "Value": [371.65]},
        "934": {"vr": "DS", "Value": [38.1275]},
        "935": {"vr": "DS", "Value": [262.9575]},
        "936": {"vr": "DS", "Value": [402.44]},
        "937": {"vr": "DS", "Value": [261.785]},
        "938": {"vr": "DS", "Value": [589.435]},
        "939": {"vr": "DS", "Value": [234.3625]},
        "940": {"vr": "DS", "Value": [481.785]},
        "941": {"vr": "DS", "Value": [479.1525]},
        "942": {"vr": "DS", "Value": [129.2]},
        "943": {"vr": "DS", "Value": [261.9325]},
        "944": {"vr": "DS", "Value": [379.5725]},
        "945": {"vr": "DS", "Value": [544.265]},
        "946": {"vr": "DS", "Value": [372.5275]},
        "947": {"vr": "DS", "Value": [247.865]},
        "948": {"vr": "DS", "Value": [402.2925]},
        "949": {"vr": "DS", "Value": [194.9175]},
        "950": {"vr": "DS", "Value": [468.89]},
        "951": {"vr": "DS", "Value": [247.28]},
        "952": {"vr": "DS", "Value": [133.465]},
        "953": {"vr": "DS", "Value": [322.9475]},
        "954": {"vr": "DS", "Value": [430.7425]},
        "955": {"vr": "DS", "Value": [62.4775]},
        "956": {"vr": "DS", "Value": [403.3175]},
        "957": {"vr": "DS", "Value": [244.04]},
        "958": {"vr": "DS", "Value": [466.84]},
        "959": {"vr": "DS", "Value": [193.7475]},
        "960": {"vr": "DS", "Value": [258.86]},
        "961": {"vr": "DS", "Value": [302.1275]},
        "962": {"vr": "DS", "Value": [482.9575]},
        "963": {"vr": "DS", "Value": [420.4775]},
        "964": {"vr": "DS", "Value": [103.0925]},
        "965": {"vr": "DS", "Value": [160.7425]},
        "966": {"vr": "DS", "Value": [255.035]},
        "967": {"vr": "DS", "Value": [536.9475]},
        "968": {"vr": "DS", "Value": [128.3225]},
        "969": {"vr": "DS", "Value": [131.395]},
        "970": {"vr": "DS", "Value": [28.45]},
        "971": {"vr": "DS", "Value": [138.585]},
        "972": {"vr": "DS", "Value": [544.5575]},
        "973": {"vr": "DS", "Value": [505.405]},
        "974": {"vr": "DS", "Value": [333.795]},
        "975": {"vr": "DS", "Value": [388.08]},
        "976": {"vr": "DS", "Value": [169.835]},
        "977": {"vr": "DS", "Value": [279.24]},
        "978": {"vr": "DS", "Value": [595.3075]},
        "979": {"vr": "DS", "Value": [406.5575]},
        "980": {"vr": "DS", "Value": [414.04]},
        "981": {"vr": "DS", "Value": [518.595]},
        "982": {"vr": "DS", "Value": [243.015]},
        "983": {"vr": "DS", "Value": [403.1725]},
        "984": {"vr": "DS", "Value": [471.5225]},
        "985": {"vr": "DS", "Value": [279.0925]},
        "986": {"vr": "DS", "Value": [216.175]},
        "987": {"vr": "DS", "Value": [28.8875]},
        "988": {"vr": "DS", "Value": [510.0875]},
        "989": {"vr": "DS", "Value": [255.2]},
        "990": {"vr": "DS", "Value": [280.995]},
        "991": {"vr": "DS", "Value": [543.68]},
        "992": {"vr": "DS", "Value": [190.8]},
        "993": {"vr": "DS", "Value": [560.985]},
        "994": {"vr": "DS", "Value": [97.5325]},
        "995": {"vr": "DS", "Value": [482.225]},
        "996": {"vr": "DS", "Value": [589.7475]},
        "997": {"vr": "DS", "Value": [435.2975]},
        "998": {"vr": "DS", "Value": [469.7675]},
        "999": {"vr": "DS", "Value": [569.2]},
        "1000": {"vr": "DS", "Value": [290.9875]},
        "1001": {"vr": "DS", "Value": [569.9325]},
        "1002": {"vr": "DS", "Value": [56.02]},
        "1003": {"vr": "DS", "Value": [152.235]},
        "1004": {"vr": "DS", "Value": [518.45]},
        "1005": {"vr": "DS", "Value": [409.7775]},
        "1006": {"vr": "DS", "Value": [440.5875]},
        "1007": {"vr": "DS", "Value": [133.1725]},
        "1008": {"vr": "DS", "Value": [73.7675]},
        "1009": {"vr": "DS", "Value": [140.05]},
        "1010": {"vr": "DS", "Value": [513.475]},
        "1011": {"vr": "DS", "Value": [584.3125]},
        "1012": {"vr": "DS", "Value": [432.08]},
        "1013": {"vr": "DS", "Value": [440.88]},
        "1014": {"vr": "DS", "Value": [407.2875]},
        "1015": {"vr": "DS", "Value": [596.185]},
        "1016": {"vr": "DS", "Value": [208.84]},
        "1017": {"vr": "DS", "Value": [572.5875]},
        "1018": {"vr": "DS", "Value": [171.1525]},
        "1019": {"vr": "DS", "Value": [525.3475]},
        "1020": {"vr": "DS", "Value": [425.475]},
        "1021": {"vr": "DS", "Value": [560.4]},
        "1022": {"vr": "DS", "Value": [220.585]},
        "1023": {"vr": "DS", "Value": [246.6925]},
        "1024": {"vr": "DS", "Value": [434.5675]},
        "1025": {"vr": "DS", "Value": [37.98]},
        "1026": {"vr": "DS", "Value": [45.465]},
        "1027": {"vr": "DS", "Value": [426.645]},
        "1028": {"vr": "DS", "Value": [515.67]},
        "1029": {"vr": "DS", "Value": [347.005]},
        "1030": {"vr": "DS", "Value": [7.4625]},
        "1031": {"vr": "DS", "Value": [94.585]},
        "1032": {"vr": "DS", "Value": [204.01]},
        "1033": {"vr": "DS", "Value": [270.2925]},
        "1034": {"vr": "DS", "Value": [103.5325]},
        "1035": {"vr": "DS", "Value": [533.415]},
        "1036": {"vr": "DS", "Value": [224.245]},
        "1037": {"vr": "DS", "Value": [357.27]},
        "1038": {"vr": "DS", "Value": [87.5425]},
        "1039": {"vr": "DS", "Value": [209.425]},
        "1040": {"vr": "DS", "Value": [195.065]},
        "1041": {"vr": "DS", "Value": [425.1825]},
        "1042": {"vr": "DS", "Value": [197.1125]},
        "1043": {"vr": "DS", "Value": [317.825]},
        "1044": {"vr": "DS", "Value": [180.245]},
        "1045": {"vr": "DS", "Value": [55.58]},
        "1046": {"vr": "DS", "Value": [360.4875]},
        "1047": {"vr": "DS", "Value": [546.625]},
        "1048": {"vr": "DS", "Value": [558.645]},
        "1049": {"vr": "DS", "Value": [38.2725]},
        "1050": {"vr": "DS", "Value": [338.645]},
        "1051": {"vr": "DS", "Value": [289.795]},
        "1052": {"vr": "DS", "Value": [94.2925]},
        "1053": {"vr": "DS", "Value": [360.8]},
        "1054": {"vr": "DS", "Value": [86.225]},
        "1055": {"vr": "DS", "Value": [212.665]},
        "1056": {"vr": "DS", "Value": [481.3475]},
        "1057": {"vr": "DS", "Value": [554.4025]},
        "1058": {"vr": "DS", "Value": [435.445]},
        "1059": {"vr": "DS", "Value": [238.625]},
        "1060": {"vr": "DS", "Value": [6.44]},
        "1061": {"vr": "DS", "Value": [44.44]},
        "1062": {"vr": "DS", "Value": [142.265]},
        "1063": {"vr": "DS", "Value": [215.7375]},
        "1064": {"vr": "DS", "Value": [147.24]},
        "1065": {"vr": "DS", "Value": [209.57]},
        "1066": {"vr": "DS", "Value": [229.9725]},
        "1067": {"vr": "DS", "Value": [422.9875]},
        "1068": {"vr": "DS", "Value": [489.27]},
        "1069": {"vr": "DS", "Value": [349.3475]},
        "1070": {"vr": "DS", "Value": [132.44]},
        "1071": {"vr": "DS", "Value": [478.42]},
        "1072": {"vr": "DS", "Value": [427.5225]},
        "1073": {"vr": "DS", "Value": [593.5525]},
        "1074": {"vr": "DS", "Value": [588.41]},
        "1075": {"vr": "DS", "Value": [97.9725]},
        "1076": {"vr": "DS", "Value": [352.2925]},
        "1077": {"vr": "DS", "Value": [448.9475]},
        "1078": {"vr": "DS", "Value": [131.6875]},
        "1079": {"vr": "DS", "Value": [483.835]},
        "1080": {"vr": "DS", "Value": [198.1375]},
        "1081": {"vr": "DS", "Value": [107.795]},
        "1082": {"vr": "DS", "Value": [426.06]},
        "1083": {"vr": "DS", "Value": [428.4]},
        "1084": {"vr": "DS", "Value": [74.79]},
        "1085": {"vr": "DS", "Value": [480.615]},
        "1086": {"vr": "DS", "Value": [422.84]},
        "1087": {"vr": "DS", "Value": [424.7425]},
        "1088": {"vr": "DS", "Value": [500.5575]},
        "1089": {"vr": "DS", "Value": [412.5575]},
        "1090": {"vr": "DS", "Value": [300.665]},
        "1091": {"vr": "DS", "Value": [210.45]},
        "1092": {"vr": "DS", "Value": [408.1675]},
        "1093": {"vr": "DS", "Value": [79.3475]},
        "1094": {"vr": "DS", "Value": [570.665]},
        "1095": {"vr": "DS", "Value": [436.7625]},
        "1096": {"vr": "DS", "Value": [370.3325]},
        "1097": {"vr": "DS", "Value": [208.6925]},
        "1098": {"vr": "DS", "Value": [509.9425]},
        "1099": {"vr": "DS", "Value": [387.2]},
        "1100": {"vr": "DS", "Value": [287.3075]},
        "1101": {"vr": "DS", "Value": [382.9375]},
        "1102": {"vr": "DS", "Value": [374.7225]},
        "1103": {"vr": "DS", "Value": [485.61]},
        "1104": {"vr": "DS", "Value": [94.1475]},
        "1105": {"vr": "DS", "Value": [397.3175]},
        "1106": {"vr": "DS", "Value": [95.61]},
        "1107": {"vr": "DS", "Value": [292.8875]},
        "1108": {"vr": "DS", "Value": [150.185]},
        "1109": {"vr": "DS", "Value": [564.665]},
        "1110": {"vr": "DS", "Value": [492.8]},
        "1111": {"vr": "DS", "Value": [179.3675]},
        "1112": {"vr": "DS", "Value": [136.975]},
        "1113": {"vr": "DS", "Value": [412.85]},
        "1114": {"vr": "DS", "Value": [289.065]},
        "1115": {"vr": "DS", "Value": [554.5475]},
        "1116": {"vr": "DS", "Value": [24.4775]},
        "1117": {"vr": "DS", "Value": [454.3625]},
        "1118": {"vr": "DS", "Value": [134.195]},
        "1119": {"vr": "DS", "Value": [553.21]},
        "1120": {"vr": "DS", "Value": [568.03]},
        "1121": {"vr": "DS", "Value": [281.435]},
        "1122": {"vr": "DS", "Value": [131.25]},
        "1123": {"vr": "DS", "Value": [70.985]},
        "1124": {"vr": "DS", "Value": [272.195]},
        "1125": {"vr": "DS", "Value": [252.1075]},
        "1126": {"vr": "DS", "Value": [586.9475]},
        "1127": {"vr": "DS", "Value": [101.63]},
        "1128": {"vr": "DS", "Value": [380.01]},
        "1129": {"vr": "DS", "Value": [221.465]},
        "1130": {"vr": "DS", "Value": [564.81]},
        "1131": {"vr": "DS", "Value": [113.65]},
        "1132": {"vr": "DS", "Value": [102.8]},
        "1133": {"vr": "DS", "Value": [355.5125]},
        "1134": {"vr": "DS", "Value": [431.2]},
        "1135": {"vr": "DS", "Value": [256.08]},
        "1136": {"vr": "DS", "Value": [207.67]},
        "1137": {"vr": "DS", "Value": [470.645]},
        "1138": {"vr": "DS", "Value": [93.5625]},
        "1139": {"vr": "DS", "Value": [310.9275]},
        "1140": {"vr": "DS", "Value": [51.61]},
        "1141": {"vr": "DS", "Value": [236.41]},
        "1142": {"vr": "DS", "Value": [69.5025]},
        "1143": {"vr": "DS", "Value": [93.2675]},
        "1144": {"vr": "DS", "Value": [150.04]},
        "1145": {"vr": "DS", "Value": [297.1325]},
        "1146": {"vr": "DS", "Value": [189.9225]},
        "1147": {"vr": "DS", "Value": [595.015]},
        "1148": {"vr": "DS", "Value": [112.185]},
        "1149": {"vr": "DS", "Value": [2.635]},
        "1150": {"vr": "DS", "Value": [576.0975]},
        "1151": {"vr": "DS", "Value": [264.0]},
        "1152": {"vr": "DS", "Value": [333.21]},
        "1153": {"vr": "DS", "Value": [296.5475]},
        "1154": {"vr": "DS", "Value": [349.785]},
        "1155": {"vr": "DS", "Value": [335.5725]},
        "1156": {"vr": "DS", "Value": [102.215]},
        "1157": {"vr": "DS", "Value": [32.4]},
        "1158": {"vr": "DS", "Value": [467.425]},
        "1159": {"vr": "DS", "Value": [293.1825]},
        "1160": {"vr": "DS", "Value": [357.5625]},
        "1161": {"vr": "DS", "Value": [116.595]},
        "1162": {"vr": "DS", "Value": [382.79]},
        "1163": {"vr": "DS", "Value": [377.795]},
        "1164": {"vr": "DS", "Value": [259.005]},
        "1165": {"vr": "DS", "Value": [498.9475]},
        "1166": {"vr": "DS", "Value": [6.7325]},
        "1167": {"vr": "DS", "Value": [443.3675]},
        "1168": {"vr": "DS", "Value": [60.995]},
        "1169": {"vr": "DS", "Value": [480.3225]},
        "1170": {"vr": "DS", "Value": [505.26]},
        "1171": {"vr": "DS", "Value": [84.03]},
        "1172": {"vr": "DS", "Value": [407.5825]},
        "1173": {"vr": "DS", "Value": [547.795]},
        "1174": {"vr": "DS", "Value": [410.07]},
        "1175": {"vr": "DS", "Value": [458.04]},
        "1176": {"vr": "DS", "Value": [451.1425]},
        "1177": {"vr": "DS", "Value": [513.9125]},
        "1178": {"vr": "DS", "Value": [8.195]},
        "1179": {"vr": "DS", "Value": [152.0875]},
        "1180": {"vr": "DS", "Value": [237.1425]},
        "1181": {"vr": "DS", "Value": [219.6875]},
        "1182": {"vr": "DS", "Value": [47.805]},
        "1183": {"vr": "DS", "Value": [323.24]},
        "1184": {"vr": "DS", "Value": [478.275]},
        "1185": {"vr": "DS", "Value": [241.1125]},
        "1186": {"vr": "DS", "Value": [35.64]},
        "1187": {"vr": "DS", "Value": [280.7025]},
        "1188": {"vr": "DS", "Value": [463.8925]},
        "1189": {"vr": "DS", "Value": [494.7025]},
        "1190": {"vr": "DS", "Value": [541.63]},
        "1191": {"vr": "DS", "Value": [6.1475]},
        "1192": {"vr": "DS", "Value": [117.62]},
        "1193": {"vr": "DS", "Value": [303.8825]},
        "1194": {"vr": "DS", "Value": [585.9225]},
        "1195": {"vr": "DS", "Value": [256.9575]},
        "1196": {"vr": "DS", "Value": [34.45]},
        "1197": {"vr": "DS", "Value": [552.9175]},
        "1198": {"vr": "DS", "Value": [211.4925]},
        "1199": {"vr": "DS", "Value": [424.595]},
        "1200": {"vr": "DS", "Value": [485.7575]},
        "1201": {"vr": "DS", "Value": [3.9525]},
        "1202": {"vr": "DS", "Value": [109.6975]},
        "1203": {"vr": "DS", "Value": [576.9775]},
        "1204": {"vr": "DS", "Value": [446.44]},
        "1205": {"vr": "DS", "Value": [348.03]},
        "1206": {"vr": "DS", "Value": [508.04]},
        "1207": {"vr": "DS", "Value": [378.0875]},
        "1208": {"vr": "DS", "Value": [29.62]},
        "1209": {"vr": "DS", "Value": [47.9525]},
        "1210": {"vr": "DS", "Value": [331.015]},
        "1211": {"vr": "DS", "Value": [573.465]},
        "1212": {"vr": "DS", "Value": [148.2625]},
        "1213": {"vr": "DS", "Value": [314.8775]},
        "1214": {"vr": "DS", "Value": [536.195]},
        "1215": {"vr": "DS", "Value": [340.5475]},
        "1216": {"vr": "DS", "Value": [426.4975]},
        "1217": {"vr": "DS", "Value": [444.6825]},
        "1218": {"vr": "DS", "Value": [26.4]},
        "1219": {"vr": "DS", "Value": [494.995]},
        "1220": {"vr": "DS", "Value": [499.6775]},
        "1221": {"vr": "DS", "Value": [556.3025]},
        "1222": {"vr": "DS", "Value": [128.615]},
        "1223": {"vr": "DS", "Value": [532.39]},
        "1224": {"vr": "DS", "Value": [227.7575]},
        "1225": {"vr": "DS", "Value": [36.81]},
        "1226": {"vr": "DS", "Value": [27.1325]},
        "1227": {"vr": "DS", "Value": [559.085]},
        "1228": {"vr": "DS", "Value": [554.9875]},
        "1229": {"vr": "DS", "Value": [409.63]},
        "1230": {"vr": "DS", "Value": [384.84]},
        "1231": {"vr": "DS", "Value": [519.2]},
        "1232": {"vr": "DS", "Value": [549.26]},
        "1233": {"vr": "DS", "Value": [156.185]},
        "1234": {"vr": "DS", "Value": [89.9025]},
        "1235": {"vr": "DS", "Value": [196.675]},
        "1236": {"vr": "DS", "Value": [34.3025]},
        "1237": {"vr": "DS", "Value": [581.3875]},
        "1238": {"vr": "DS", "Value": [196.235]},
        "1239": {"vr": "DS", "Value": [114.5475]},
        "1240": {"vr": "DS", "Value": [126.86]},
        "1241": {"vr": "DS", "Value": [21.5525]},
        "1242": {"vr": "DS", "Value": [410.8]},
        "1243": {"vr": "DS", "Value": [459.065]},
        "1244": {"vr": "DS", "Value": [339.9625]},
        "1245": {"vr": "DS", "Value": [230.1175]},
        "1246": {"vr": "DS", "Value": [458.625]},
        "1247": {"vr": "DS", "Value": [152.5275]},
        "1248": {"vr": "DS", "Value": [293.9125]},
        "1249": {"vr": "DS", "Value": [519.3475]},
        "1250": {"vr": "DS", "Value": [48.39]},
        "1251": {"vr": "DS", "Value": [388.9575]},
        "1252": {"vr": "DS", "Value": [293.475]},
        "1253": {"vr": "DS", "Value": [507.3075]},
        "1254": {"vr": "DS", "Value": [211.9325]},
        "1255": {"vr": "DS", "Value": [225.415]},
        "1256": {"vr": "DS", "Value": [431.3475]},
        "1257": {"vr": "DS", "Value": [24.9175]},
        "1258": {"vr": "DS", "Value": [64.38]},
        "1259": {"vr": "DS", "Value": [469.62]},
        "1260": {"vr": "DS", "Value": [396.44]},
        "1261": {"vr": "DS", "Value": [96.635]},
        "1262": {"vr": "DS", "Value": [151.065]},
        "1263": {"vr": "DS", "Value": [407.435]},
        "1264": {"vr": "DS", "Value": [112.4775]},
        "1265": {"vr": "DS", "Value": [132.7325]},
        "1266": {"vr": "DS", "Value": [172.9075]},
        "1267": {"vr": "DS", "Value": [337.62]},
        "1268": {"vr": "DS", "Value": [290.5475]},
        "1269": {"vr": "DS", "Value": [61.435]},
        "1270": {"vr": "DS", "Value": [86.0775]},
        "1271": {"vr": "DS", "Value": [594.5775]},
        "1272": {"vr": "DS", "Value": [264.1475]},
        "1273": {"vr": "DS", "Value": [136.0975]},
        "1274": {"vr": "DS", "Value": [415.9425]},
        "1275": {"vr": "DS", "Value": [471.3775]},
        "1276": {"vr": "DS", "Value": [540.3125]},
        "1277": {"vr": "DS", "Value": [557.3275]},
        "1278": {"vr": "DS", "Value": [255.7875]},
        "1279": {"vr": "DS", "Value": [236.7025]},
        "1280": {"vr": "DS", "Value": [57.4825]},
        "1281": {"vr": "DS", "Value": [420.185]},
        "1282": {"vr": "DS", "Value": [113.9425]},
        "1283": {"vr": "DS", "Value": [417.6975]},
        "1284": {"vr": "DS", "Value": [428.6925]},
        "1285": {"vr": "DS", "Value": [242.7225]},
        "1286": {"vr": "DS", "Value": [237.435]},
        "1287": {"vr": "DS", "Value": [247.1325]},
        "1288": {"vr": "DS", "Value": [187.1425]},
        "1289": {"vr": "DS", "Value": [454.07]},
        "1290": {"vr": "DS", "Value": [178.05]},
        "1291": {"vr": "DS", "Value": [4.0975]},
        "1292": {"vr": "DS", "Value": [260.3225]},
        "1293": {"vr": "DS", "Value": [309.465]},
        "1294": {"vr": "DS", "Value": [513.3275]},
        "1295": {"vr": "DS", "Value": [267.5125]},
        "1296": {"vr": "DS", "Value": [134.05]},
        "1297": {"vr": "DS", "Value": [127.1525]},
        "1298": {"vr": "DS", "Value": [23.7475]},
        "1299": {"vr": "DS", "Value": [83.445]},
        "1300": {"vr": "DS", "Value": [302.42]},
        "1301": {"vr": "DS", "Value": [283.065]},
        "1302": {"vr": "DS", "Value": [26.6925]},
        "1303": {"vr": "DS", "Value": [532.83]},
        "1304": {"vr": "DS", "Value": [252.84]},
        "1305": {"vr": "DS", "Value": [294.79]},
        "1306": {"vr": "DS", "Value": [49.2675]},
        "1307": {"vr": "DS", "Value": [486.195]},
        "1308": {"vr": "DS", "Value": [86.37]},
        "1309": {"vr": "DS", "Value": [106.04]},
        "1310": {"vr": "DS", "Value": [24.77]},
        "1311": {"vr": "DS", "Value": [283.9425]},
        "1312": {"vr": "DS", "Value": [545.895]},
        "1313": {"vr": "DS", "Value": [269.855]},
        "1314": {"vr": "DS", "Value": [146.0675]},
        "1315": {"vr": "DS", "Value": [25.5025]},
        "1316": {"vr": "DS", "Value": [328.3825]},
        "1317": {"vr": "DS", "Value": [231.58]},
        "1318": {"vr": "DS", "Value": [53.385]},
        "1319": {"vr": "DS", "Value": [90.195]},
        "1320": {"vr": "DS", "Value": [465.3575]},
        "1321": {"vr": "DS", "Value": [284.38]},
        "1322": {"vr": "DS", "Value": [69.9425]},
        "1323": {"vr": "DS", "Value": [164.84]},
        "1324": {"vr": "DS", "Value": [203.7175]},
        "1325": {"vr": "DS", "Value": [32.1075]},
        "1326": {"vr": "DS", "Value": [202.6925]},
        "1327": {"vr": "DS", "Value": [542.8]},
        "1328": {"vr": "DS", "Value": [137.855]},
        "1329": {"vr": "DS", "Value": [407.1425]},
        "1330": {"vr": "DS", "Value": [594.1375]},
        "1331": {"vr": "DS", "Value": [253.1325]},
        "1332": {"vr": "DS", "Value": [525.4925]},
        "1333": {"vr": "DS", "Value": [500.7025]},
        "1334": {"vr": "DS", "Value": [454.8]},
        "1335": {"vr": "DS", "Value": [167.4925]},
        "1336": {"vr": "DS", "Value": [314.0]},
        "1337": {"vr": "DS", "Value": [141.9725]},
        "1338": {"vr": "DS", "Value": [223.22]},
        "1339": {"vr": "DS", "Value": [439.395]},
        "1340": {"vr": "DS", "Value": [60.1175]},
        "1341": {"vr": "DS", "Value": [551.7475]},
        "1342": {"vr": "DS", "Value": [72.01]},
        "1343": {"vr": "DS", "Value": [463.3075]},
        "1344": {"vr": "DS", "Value": [137.7075]},
        "1345": {"vr": "DS", "Value": [139.9025]},
        "1346": {"vr": "DS", "Value": [78.45]},
        "1347": {"vr": "DS", "Value": [7.17]},
        "1348": {"vr": "DS", "Value": [384.5475]},
        "1349": {"vr": "DS", "Value": [78.595]},
        "1350": {"vr": "DS", "Value": [383.23]},
        "1351": {"vr": "DS", "Value": [50.2925]},
        "1352": {"vr": "DS", "Value": [296.6925]},
        "1353": {"vr": "DS", "Value": [461.6975]},
        "1354": {"vr": "DS", "Value": [559.23]},
        "1355": {"vr": "DS", "Value": [195.3575]},
        "1356": {"vr": "DS", "Value": [278.5075]},
        "1357": {"vr": "DS", "Value": [327.795]},
        "1358": {"vr": "DS", "Value": [109.99]},
        "1359": {"vr": "DS", "Value": [534.88]},
        "1360": {"vr": "DS", "Value": [535.025]},
        "1361": {"vr": "DS", "Value": [63.9425]},
        "1362": {"vr": "DS", "Value": [19.65]},
        "1363": {"vr": "DS", "Value": [124.225]},
        "1364": {"vr": "DS", "Value": [145.045]},
        "1365": {"vr": "DS", "Value": [334.9875]},
        "1366": {"vr": "DS", "Value": [221.61]},
        "1367": {"vr": "DS", "Value": [54.85]},
        "1368": {"vr": "DS", "Value": [188.7525]},
        "1369": {"vr": "DS", "Value": [213.98]},
        "1370": {"vr": "DS", "Value": [284.675]},
        "1371": {"vr": "DS", "Value": [83.005]},
        "1372": {"vr": "DS", "Value": [58.0675]},
        "1373": {"vr": "DS", "Value": [430.01]},
        "1374": {"vr": "DS", "Value": [317.5325]},
        "1375": {"vr": "DS", "Value": [208.1075]},
        "1376": {"vr": "DS", "Value": [84.3225]},
        "1377": {"vr": "DS", "Value": [93.415]},
        "1378": {"vr": "DS", "Value": [569.785]},
        "1379": {"vr": "DS", "Value": [578.7325]},
        "1380": {"vr": "DS", "Value": [343.7875]},
        "1381": {"vr": "DS", "Value": [496.605]},
        "1382": {"vr": "DS", "Value": [503.3575]},
        "1383": {"vr": "DS", "Value": [147.5325]},
        "1384": {"vr": "DS", "Value": [79.035]},
        "1385": {"vr": "DS", "Value": [228.3425]},
        "1386": {"vr": "DS", "Value": [411.825]},
        "1387": {"vr": "DS", "Value": [225.7075]},
        "1388": {"vr": "DS", "Value": [347.59]},
        "1389": {"vr": "DS", "Value": [72.8875]},
        "1390": {"vr": "DS", "Value": [233.9225]},
        "1391": {"vr": "DS", "Value": [19.3575]},
        "1392": {"vr": "DS", "Value": [537.5325]},
        "1393": {"vr": "DS", "Value": [227.17]},
        "1394": {"vr": "DS", "Value": [315.3175]},
        "1395": {"vr": "DS", "Value": [267.3675]},
        "1396": {"vr": "DS", "Value": [375.455]},
        "1397": {"vr": "DS", "Value": [273.5325]},
        "1398": {"vr": "DS", "Value": [173.785]},
        "1399": {"vr": "DS", "Value": [200.4775]},
        "1400": {"vr": "DS", "Value": [348.9075]},
        "1401": {"vr": "DS", "Value": [158.6925]},
        "1402": {"vr": "DS", "Value": [526.225]},
        "1403": {"vr": "DS", "Value": [296.1075]},
        "1404": {"vr": "DS", "Value": [1.025]},
        "1405": {"vr": "DS", "Value": [32.985]},
        "1406": {"vr": "DS", "Value": [148.85]},
        "1407": {"vr": "DS", "Value": [125.25]},
        "1408": {"vr": "DS", "Value": [198.43]},
        "1409": {"vr": "DS", "Value": [130.5175]},
        "1410": {"vr": "DS", "Value": [527.5425]},
        "1411": {"vr": "DS", "Value": [92.245]},
        "1412": {"vr": "DS", "Value": [340.84]},
        "1413": {"vr": "DS", "Value": [499.5325]},
        "1414": {"vr": "DS", "Value": [383.3775]},
        "1415": {"vr": "DS", "Value": [40.3225]},
        "1416": {"vr": "DS", "Value": [141.825]},
        "1417": {"vr": "DS", "Value": [106.625]},
        "1418": {"vr": "DS", "Value": [319.7275]},
        "1419": {"vr": "DS", "Value": [522.1275]},
        "1420": {"vr": "DS", "Value": [455.5325]},
        "1421": {"vr": "DS", "Value": [144.1675]},
        "1422": {"vr": "DS", "Value": [504.82]},
        "1423": {"vr": "DS", "Value": [277.63]},
        "1424": {"vr": "DS", "Value": [547.5025]},
        "1425": {"vr": "DS", "Value": [232.7525]},
        "1426": {"vr": "DS", "Value": [470.3525]},
        "1427": {"vr": "DS", "Value": [435.59]},
        "1428": {"vr": "DS", "Value": [256.81]},
        "1429": {"vr": "DS", "Value": [511.425]},
        "1430": {"vr": "DS", "Value": [500.265]},
        "1431": {"vr": "DS", "Value": [567.7375]},
        "1432": {"vr": "DS", "Value": [277.4825]},
        "1433": {"vr": "DS", "Value": [451.435]},
        "1434": {"vr": "DS", "Value": [390.7125]},
        "1435": {"vr": "DS", "Value": [338.3525]},
        "1436": {"vr": "DS", "Value": [474.01]},
        "1437": {"vr": "DS", "Value": [386.7425]},
        "1438": {"vr": "DS", "Value": [57.19]},
        "1439": {"vr": "DS", "Value": [315.17]},
        "1440": {"vr": "DS", "Value": [577.415]},
        "1441": {"vr": "DS", "Value": [329.5525]},
        "1442": {"vr": "DS", "Value": [0.585]},
        "1443": {"vr": "DS", "Value": [574.3425]},
        "1444": {"vr": "DS", "Value": [331.6]},
        "1445": {"vr": "DS", "Value": [536.05]},
        "1446": {"vr": "DS", "Value": [421.21]},
        "1447": {"vr": "DS", "Value": [162.205]},
        "1448": {"vr": "DS", "Value": [48.6825]},
        "1449": {"vr": "DS", "Value": [106.48]},
        "1450": {"vr": "DS", "Value": [175.25]},
        "1451": {"vr": "DS", "Value": [273.9725]},
        "1452": {"vr": "DS", "Value": [19.5025]},
        "1453": {"vr": "DS", "Value": [422.695]},
        "1454": {"vr": "DS", "Value": [557.1825]},
        "1455": {"vr": "DS", "Value": [594.87]},
        "1456": {"vr": "DS", "Value": [341.2775]},
        "1457": {"vr": "DS", "Value": [119.9625]},
        "1458": {"vr": "DS", "Value": [580.635]},
        "1459": {"vr": "DS", "Value": [71.2775]},
        "1460": {"vr": "DS", "Value": [496.8975]},
        "1461": {"vr": "DS", "Value": [111.7475]},
        "1462": {"vr": "DS", "Value": [270.1475]},
        "1463": {"vr": "DS", "Value": [265.9025]},
        "1464": {"vr": "DS", "Value": [487.5125]},
        "1465": {"vr": "DS", "Value": [362.5575]},
        "1466": {"vr": "DS", "Value": [158.0875]},
        "1467": {"vr": "DS", "Value": [133.9025]},
        "1468": {"vr": "DS", "Value": [413.895]},
        "1469": {"vr": "DS", "Value": [538.7025]},
        "1470": {"vr": "DS", "Value": [358.2925]},
        "1471": {"vr": "DS", "Value": [502.1875]},
        "1472": {"vr": "DS", "Value": [147.97]},
        "1473": {"vr": "DS", "Value": [151.795]},
        "1474": {"vr": "DS", "Value": [400.9775]},
        "1475": {"vr": "DS", "Value": [506.5775]},
        "1476": {"vr": "DS", "Value": [219.1025]},
        "1477": {"vr": "DS", "Value": [46.05]},
        "1478": {"vr": "DS", "Value": [223.66]},
        "1479": {"vr": "DS", "Value": [378.6925]},
        "1480": {"vr": "DS", "Value": [456.41]},
        "1481": {"vr": "DS", "Value": [483.5425]},
        "1482": {"vr": "DS", "Value": [455.825]},
        "1483": {"vr": "DS", "Value": [446.8775]},
        "1484": {"vr": "DS", "Value": [340.985]},
        "1485": {"vr": "DS", "Value": [242.1375]},
        "1486": {"vr": "DS", "Value": [97.825]},
        "1487": {"vr": "DS", "Value": [570.5175]},
        "1488": {"vr": "DS", "Value": [399.5125]},
        "1489": {"vr": "DS", "Value": [250.06]},
        "1490": {"vr": "DS", "Value": [332.3325]},
        "1491": {"vr": "DS", "Value": [185.9725]},
        "1492": {"vr": "DS", "Value": [359.17]},
        "1493": {"vr": "DS", "Value": [109.5525]},
        "1494": {"vr": "DS", "Value": [546.3325]},
        "1495": {"vr": "DS", "Value": [410.215]},
        "1496": {"vr": "DS", "Value": [519.64]},
        "1497": {"vr": "DS", "Value": [127.005]},
        "1498": {"vr": "DS", "Value": [262.81]},
        "1499": {"vr": "DS", "Value": [519.9325]},
        "1500": {"vr": "DS", "Value": [381.3275]},
        "1501": {"vr": "DS", "Value": [154.2825]},
        "1502": {"vr": "DS", "Value": [361.3875]},
        "1503": {"vr": "DS", "Value": [506.7225]},
        "1504": {"vr": "DS", "Value": [365.9225]},
        "1505": {"vr": "DS", "Value": [175.5425]},
        "1506": {"vr": "DS", "Value": [249.7675]},
        "1507": {"vr": "DS", "Value": [173.055]},
        "1508": {"vr": "DS", "Value": [64.6725]},
        "1509": {"vr": "DS", "Value": [115.1325]},
        "1510": {"vr": "DS", "Value": [385.7175]},
        "1511": {"vr": "DS", "Value": [502.04]},
        "1512": {"vr": "DS", "Value": [400.6825]},
        "1513": {"vr": "DS", "Value": [45.1725]},
        "1514": {"vr": "DS", "Value": [141.0925]},
        "1515": {"vr": "DS", "Value": [1.7575]},
        "1516": {"vr": "DS", "Value": [28.01]},
        "1517": {"vr": "DS", "Value": [499.0925]},
        "1518": {"vr": "DS", "Value": [474.3025]},
        "1519": {"vr": "DS", "Value": [322.215]},
        "1520": {"vr": "DS", "Value": [216.03]},
        "1521": {"vr": "DS", "Value": [492.3425]},
        "1522": {"vr": "DS", "Value": [173.64]},
        "1523": {"vr": "DS", "Value": [217.4925]},
        "1524": {"vr": "DS", "Value": [259.2975]},
        "1525": {"vr": "DS", "Value": [80.9575]},
        "1526": {"vr": "DS", "Value": [149.435]},
        "1527": {"vr": "DS", "Value": [467.5725]},
        "1528": {"vr": "DS", "Value": [31.23]},
        "1529": {"vr": "DS", "Value": [244.625]},
        "1530": {"vr": "DS", "Value": [445.5625]},
        "1531": {"vr": "DS", "Value": [272.9475]},
        "1532": {"vr": "DS", "Value": [547.3575]},
        "1533": {"vr": "DS", "Value": [155.3075]},
        "1534": {"vr": "DS", "Value": [223.9525]},
        "1535": {"vr": "DS", "Value": [142.1175]},
        "1536": {"vr": "DS", "Value": [301.5425]},
        "1537": {"vr": "DS", "Value": [50.0]},
        "1538": {"vr": "DS", "Value": [47.5125]},
        "1539": {"vr": "DS", "Value": [99.8725]},
        "1540": {"vr": "DS", "Value": [318.1175]},
        "1541": {"vr": "DS", "Value": [337.475]},
        "1542": {"vr": "DS", "Value": [164.5475]},
        "1543": {"vr": "DS", "Value": [222.3425]},
        "1544": {"vr": "DS", "Value": [298.7425]},
        "1545": {"vr": "DS", "Value": [274.41]},
        "1546": {"vr": "DS", "Value": [349.055]},
        "1547": {"vr": "DS", "Value": [332.04]},
        "1548": {"vr": "DS", "Value": [315.7575]},
        "1549": {"vr": "DS", "Value": [243.6]},
        "1550": {"vr": "DS", "Value": [181.5625]},
        "1551": {"vr": "DS", "Value": [192.5575]},
        "1552": {"vr": "DS", "Value": [236.2625]},
        "1553": {"vr": "DS", "Value": [108.38]},
        "1554": {"vr": "DS", "Value": [292.01]},
        "1555": {"vr": "DS", "Value": [5.855]},
        "1556": {"vr": "DS", "Value": [353.9025]},
        "1557": {"vr": "DS", "Value": [285.405]},
        "1558": {"vr": "DS", "Value": [254.595]},
        "1559": {"vr": "DS", "Value": [398.195]},
        "1560": {"vr": "DS", "Value": [563.64]},
        "1561": {"vr": "DS", "Value": [312.245]},
        "1562": {"vr": "DS", "Value": [493.68]},
        "1563": {"vr": "DS", "Value": [148.5575]},
        "1564": {"vr": "DS", "Value": [153.5525]},
        "1565": {"vr": "DS", "Value": [78.155]},
        "1566": {"vr": "DS", "Value": [325.8925]},
        "1567": {"vr": "DS", "Value": [185.825]},
        "1568": {"vr": "DS", "Value": [316.8]},
        "1569": {"vr": "DS", "Value": [509.065]},
        "1570": {"vr": "DS", "Value": [361.825]},
        "1571": {"vr": "DS", "Value": [37.5425]},
        "1572": {"vr": "DS", "Value": [224.39]},
        "1573": {"vr": "DS", "Value": [343.9325]},
        "1574": {"vr": "DS", "Value": [302.86]},
        "1575": {"vr": "DS", "Value": [360.3425]},
        "1576": {"vr": "DS", "Value": [95.025]},
        "1577": {"vr": "DS", "Value": [377.5025]},
        "1578": {"vr": "DS", "Value": [577.855]},
        "1579": {"vr": "DS", "Value": [578.88]},
        "1580": {"vr": "DS", "Value": [426.9375]},
        "1581": {"vr": "DS", "Value": [266.195]},
        "1582": {"vr": "DS", "Value": [445.1225]},
        "1583": {"vr": "DS", "Value": [350.0775]},
        "1584": {"vr": "DS", "Value": [141.68]},
        "1585": {"vr": "DS", "Value": [517.5725]},
        "1586": {"vr": "DS", "Value": [467.865]},
        "1587": {"vr": "DS", "Value": [350.5175]},
        "1588": {"vr": "DS", "Value": [394.225]},
        "1589": {"vr": "DS", "Value": [123.3475]},
        "1590": {"vr": "DS", "Value": [211.035]},
        "1591": {"vr": "DS", "Value": [146.9475]},
        "1592": {"vr": "DS", "Value": [512.7425]},
        "1593": {"vr": "DS", "Value": [338.4975]},
        "1594": {"vr": "DS", "Value": [495.1425]},
        "1595": {"vr": "DS", "Value": [560.6925]},
        "1596": {"vr": "DS", "Value": [61.7475]},
        "1597": {"vr": "DS", "Value": [261.3475]},
        "1598": {"vr": "DS", "Value": [531.5125]},
        "1599": {"vr": "DS", "Value": [432.225]},
        "1600": {"vr": "DS", "Value": [399.3675]},
        "1601": {"vr": "DS", "Value": [8.05]},
        "1602": {"vr": "DS", "Value": [540.02]},
        "1603": {"vr": "DS", "Value": [592.09]},
        "1604": {"vr": "DS", "Value": [113.3575]},
        "1605": {"vr": "DS", "Value": [364.1675]},
        "1606": {"vr": "DS", "Value": [566.1275]},
        "1607": {"vr": "DS", "Value": [217.9325]},
        "1608": {"vr": "DS", "Value": [484.1475]},
        "1609": {"vr": "DS", "Value": [269.415]},
        "1610": {"vr": "DS", "Value": [306.37]},
        "1611": {"vr": "DS", "Value": [457.435]},
        "1612": {"vr": "DS", "Value": [281.1425]},
        "1613": {"vr": "DS", "Value": [460.9675]},
        "1614": {"vr": "DS", "Value": [146.5075]},
        "1615": {"vr": "DS", "Value": [473.865]},
        "1616": {"vr": "DS", "Value": [142.5575]},
        "1617": {"vr": "DS", "Value": [295.23]},
        "1618": {"vr": "DS", "Value": [286.43]},
        "1619": {"vr": "DS", "Value": [35.035]},
        "1620": {"vr": "DS", "Value": [136.6825]},
        "1621": {"vr": "DS", "Value": [291.1325]},
        "1622": {"vr": "DS", "Value": [384.4]},
        "1623": {"vr": "DS", "Value": [279.825]},
        "1624": {"vr": "DS", "Value": [540.46]},
        "1625": {"vr": "DS", "Value": [204.45]},
        "1626": {"vr": "DS", "Value": [327.9425]},
        "1627": {"vr": "DS", "Value": [214.5675]},
        "1628": {"vr": "DS", "Value": [331.7475]},
        "1629": {"vr": "DS", "Value": [454.9475]},
        "1630": {"vr": "DS", "Value": [574.9275]},
        "1631": {"vr": "DS", "Value": [115.7175]},
        "1632": {"vr": "DS", "Value": [391.59]},
        "1633": {"vr": "DS", "Value": [330.7225]},
        "1634": {"vr": "DS", "Value": [38.42]},
        "1635": {"vr": "DS", "Value": [436.1775]},
        "1636": {"vr": "DS", "Value": [59.97]},
        "1637": {"vr": "DS", "Value": [413.6]},
        "1638": {"vr": "DS", "Value": [247.425]},
        "1639": {"vr": "DS", "Value": [504.235]},
        "1640": {"vr": "DS", "Value": [104.2625]},
        "1641": {"vr": "DS", "Value": [588.7025]},
        "1642": {"vr": "DS", "Value": [31.6675]},
        "1643": {"vr": "DS", "Value": [593.6975]},
        "1644": {"vr": "DS", "Value": [301.1025]},
        "1645": {"vr": "DS", "Value": [535.465]},
        "1646": {"vr": "DS", "Value": [450.995]},
        "1647": {"vr": "DS", "Value": [512.3025]},
        "1648": {"vr": "DS", "Value": [153.405]},
        "1649": {"vr": "DS", "Value": [208.985]},
        "1650": {"vr": "DS", "Value": [294.9375]},
        "1651": {"vr": "DS", "Value": [465.065]},
        "1652": {"vr": "DS", "Value": [250.4975]},
        "1653": {"vr": "DS", "Value": [278.07]},
        "1654": {"vr": "DS", "Value": [171.2975]},
        "1655": {"vr": "DS", "Value": [405.095]},
        "1656": {"vr": "DS", "Value": [275.58]},
        "1657": {"vr": "DS", "Value": [395.6875]},
        "1658": {"vr": "DS", "Value": [433.395]},
        "1659": {"vr": "DS", "Value": [237.6]},
        "1660": {"vr": "DS", "Value": [381.1825]},
        "1661": {"vr": "DS", "Value": [20.5275]},
        "1662": {"vr": "DS", "Value": [359.465]},
        "1663": {"vr": "DS", "Value": [194.625]},
        "1664": {"vr": "DS", "Value": [478.7125]},
        "1665": {"vr": "DS", "Value": [439.25]},
        "1666": {"vr": "DS", "Value": [254.45]},
        "1667": {"vr": "DS", "Value": [448.195]},
        "1668": {"vr": "DS", "Value": [121.2775]},
        "1669": {"vr": "DS", "Value": [452.7525]},
        "1670": {"vr": "DS", "Value": [257.5425]},
        "1671": {"vr": "DS", "Value": [395.25]},
        "1672": {"vr": "DS", "Value": [62.185]},
        "1673": {"vr": "DS", "Value": [195.795]},
        "1674": {"vr": "DS", "Value": [325.2875]},
        "1675": {"vr": "DS", "Value": [154.575]},
        "1676": {"vr": "DS", "Value": [29.3275]},
        "1677": {"vr": "DS", "Value": [555.1325]},
        "1678": {"vr": "DS", "Value": [220.7325]},
        "1679": {"vr": "DS", "Value": [245.795]},
        "1680": {"vr": "DS", "Value": [450.41]},
        "1681": {"vr": "DS", "Value": [97.24]},
        "1682": {"vr": "DS", "Value": [433.9825]},
        "1683": {"vr": "DS", "Value": [387.3475]},
        "1684": {"vr": "DS", "Value": [529.7575]},
        "1685": {"vr": "DS", "Value": [474.8875]},
        "1686": {"vr": "DS", "Value": [30.79]},
        "1687": {"vr": "DS", "Value": [418.7225]},
        "1688": {"vr": "DS", "Value": [184.05]},
        "1689": {"vr": "DS", "Value": [203.425]},
        "1690": {"vr": "DS", "Value": [325.435]},
        "1691": {"vr": "DS", "Value": [495.875]},
        "1692": {"vr": "DS", "Value": [212.5175]},
        "1693": {"vr": "DS", "Value": [230.85]},
        "1694": {"vr": "DS", "Value": [485.3175]},
        "1695": {"vr": "DS", "Value": [136.5375]},
        "1696": {"vr": "DS", "Value": [39.1525]},
        "1697": {"vr": "DS", "Value": [337.1825]},
        "1698": {"vr": "DS", "Value": [559.5225]},
        "1699": {"vr": "DS", "Value": [345.395]},
        "1700": {"vr": "DS", "Value": [3.805]},
        "1701": {"vr": "DS", "Value": [481.4925]},
        "1702": {"vr": "DS", "Value": [132.2925]},
        "1703": {"vr": "DS", "Value": [44.1475]},
        "1704": {"vr": "DS", "Value": [539.5825]},
        "1705": {"vr": "DS", "Value": [39.005]},
        "1706": {"vr": "DS", "Value": [39.8825]},
        "1707": {"vr": "DS", "Value": [211.3475]},
        "1708": {"vr": "DS", "Value": [442.49]},
        "1709": {"vr": "DS", "Value": [317.68]},
        "1710": {"vr": "DS", "Value": [256.225]},
        "1711": {"vr": "DS", "Value": [34.8875]},
        "1712": {"vr": "DS", "Value": [411.385]},
        "1713": {"vr": "DS", "Value": [158.84]},
        "1714": {"vr": "DS", "Value": [542.5075]},
        "1715": {"vr": "DS", "Value": [464.625]},
        "1716": {"vr": "DS", "Value": [68.3325]},
        "1717": {"vr": "DS", "Value": [105.7475]},
        "1718": {"vr": "DS", "Value": [286.87]},
        "1719": {"vr": "DS", "Value": [555.5725]},
        "1720": {"vr": "DS", "Value": [598.0875]},
        "1721": {"vr": "DS", "Value": [544.85]},
        "1722": {"vr": "DS", "Value": [150.3325]},
        "1723": {"vr": "DS", "Value": [559.815]},
        "1724": {"vr": "DS", "Value": [472.1075]},
        "1725": {"vr": "DS", "Value": [162.9375]},
        "1726": {"vr": "DS", "Value": [529.61]},
        "1727": {"vr": "DS", "Value": [259.8825]},
        "1728": {"vr": "DS", "Value": [169.25]},
        "1729": {"vr": "DS", "Value": [297.865]},
        "1730": {"vr": "DS", "Value": [39.445]},
        "1731": {"vr": "DS", "Value": [220.2925]},
        "1732": {"vr": "DS", "Value": [31.815]},
        "1733": {"vr": "DS", "Value": [20.38]},
        "1734": {"vr": "DS", "Value": [541.7775]},
        "1735": {"vr": "DS", "Value": [486.49]},
        "1736": {"vr": "DS", "Value": [206.9375]},
        "1737": {"vr": "DS", "Value": [125.395]},
        "1738": {"vr": "DS", "Value": [399.805]},
        "1739": {"vr": "DS", "Value": [224.83]},
        "1740": {"vr": "DS", "Value": [539.7275]},
        "1741": {"vr": "DS", "Value": [174.9575]},
        "1742": {"vr": "DS", "Value": [85.785]},
        "1743": {"vr": "DS", "Value": [161.62]},
        "1744": {"vr": "DS", "Value": [391.005]},
        "1745": {"vr": "DS", "Value": [365.3375]},
        "1746": {"vr": "DS", "Value": [464.3325]},
        "1747": {"vr": "DS", "Value": [349.64]},
        "1748": {"vr": "DS", "Value": [438.3725]},
        "1749": {"vr": "DS", "Value": [484.0]},
        "1750": {"vr": "DS", "Value": [566.7125]},
        "1751": {"vr": "DS", "Value": [577.1225]},
        "1752": {"vr": "DS", "Value": [71.865]},
        "1753": {"vr": "DS", "Value": [156.9175]},
        "1754": {"vr": "DS", "Value": [283.5025]},
        "1755": {"vr": "DS", "Value": [390.1275]},
        "1756": {"vr": "DS", "Value": [161.3275]},
        "1757": {"vr": "DS", "Value": [383.5225]},
        "1758": {"vr": "DS", "Value": [20.82]},
        "1759": {"vr": "DS", "Value": [30.205]},
        "1760": {"vr": "DS", "Value": [383.9625]},
        "1761": {"vr": "DS", "Value": [48.5375]},
        "1762": {"vr": "DS", "Value": [19.9425]},
        "1763": {"vr": "DS", "Value": [62.7725]},
        "1764": {"vr": "DS", "Value": [270.585]},
        "1765": {"vr": "DS", "Value": [105.2875]},
        "1766": {"vr": "DS", "Value": [216.615]},
        "1767": {"vr": "DS", "Value": [230.5575]},
        "1768": {"vr": "DS", "Value": [234.9475]},
        "1769": {"vr": "DS", "Value": [19.21]},
        "1770": {"vr": "DS", "Value": [387.495]},
        "1771": {"vr": "DS", "Value": [277.775]},
        "1772": {"vr": "DS", "Value": [284.9675]},
        "1773": {"vr": "DS", "Value": [537.095]},
        "1774": {"vr": "DS", "Value": [51.9025]},
        "1775": {"vr": "DS", "Value": [107.5025]},
        "1776": {"vr": "DS", "Value": [577.5625]},
        "1777": {"vr": "DS", "Value": [157.795]},
        "1778": {"vr": "DS", "Value": [166.7425]},
        "1779": {"vr": "DS", "Value": [466.235]},
        "1780": {"vr": "DS", "Value": [187.2875]},
        "1781": {"vr": "DS", "Value": [471.67]},
        "1782": {"vr": "DS", "Value": [124.5175]},
        "1783": {"vr": "DS", "Value": [158.985]},
        "1784": {"vr": "DS", "Value": [450.1175]},
        "1785": {"vr": "DS", "Value": [225.5625]},
        "1786": {"vr": "DS", "Value": [405.3875]},
        "1787": {"vr": "DS", "Value": [585.7775]},
        "1788": {"vr": "DS", "Value": [174.81]},
        "1789": {"vr": "DS", "Value": [453.4825]},
        "1790": {"vr": "DS", "Value": [136.39]},
        "1791": {"vr": "DS", "Value": [90.9275]},
        "1792": {"vr": "DS", "Value": [327.21]},
        "1793": {"vr": "DS", "Value": [273.3875]},
        "1794": {"vr": "DS", "Value": [270.7325]},
        "1795": {"vr": "DS", "Value": [151.9425]},
        "1796": {"vr": "DS", "Value": [2.9275]},
        "1797": {"vr": "DS", "Value": [342.595]},
        "1798": {"vr": "DS", "Value": [129.785]},
        "1799": {"vr": "DS", "Value": [362.995]},
        "1800": {"vr": "DS", "Value": [372.9675]},
        "1801": {"vr": "DS", "Value": [511.1325]},
        "1802": {"vr": "DS", "Value": [203.5725]},
        "1803": {"vr": "DS", "Value": [558.06]},
        "1804": {"vr": "DS", "Value": [558.3525]},
        "1805": {"vr": "DS", "Value": [596.7725]},
        "1806": {"vr": "DS", "Value": [65.845]},
        "1807": {"vr": "DS", "Value": [551.3075]},
        "1808": {"vr": "DS", "Value": [456.85]},
        "1809": {"vr": "DS", "Value": [157.9425]},
        "1810": {"vr": "DS", "Value": [347.1525]},
        "1811": {"vr": "DS", "Value": [280.5575]},
        "1812": {"vr": "DS", "Value": [234.215]},
        "1813": {"vr": "DS", "Value": [222.4875]},
        "1814": {"vr": "DS", "Value": [490.2925]},
        "1815": {"vr": "DS", "Value": [568.9075]},
        "1816": {"vr": "DS", "Value": [325.1425]},
        "1817": {"vr": "DS", "Value": [347.8825]},
        "1818": {"vr": "DS", "Value": [331.455]},
        "1819": {"vr": "DS", "Value": [263.25]},
        "1820": {"vr": "DS", "Value": [212.3725]},
        "1821": {"vr": "DS", "Value": [395.835]},
        "1822": {"vr": "DS", "Value": [461.99]},
        "1823": {"vr": "DS", "Value": [394.665]},
        "1824": {"vr": "DS", "Value": [144.46]},
        "1825": {"vr": "DS", "Value": [350.37]},
        "1826": {"vr": "DS", "Value": [162.79]},
        "1827": {"vr": "DS", "Value": [499.825]},
        "1828": {"vr": "DS", "Value": [245.65]},
        "1829": {"vr": "DS", "Value": [70.5475]},
        "1830": {"vr": "DS", "Value": [151.65]},
        "1831": {"vr": "DS", "Value": [346.7125]},
        "1832": {"vr": "DS", "Value": [232.605]},
        "1833": {"vr": "DS", "Value": [327.65]},
        "1834": {"vr": "DS", "Value": [129.055]},
        "1835": {"vr": "DS", "Value": [320.02]},
        "1836": {"vr": "DS", "Value": [380.8875]},
        "1837": {"vr": "DS", "Value": [210.1575]},
        "1838": {"vr": "DS", "Value": [500.995]},
        "1839": {"vr": "DS", "Value": [441.7575]},
        "1840": {"vr": "DS", "Value": [57.63]},
        "1841": {"vr": "DS", "Value": [354.635]},
        "1842": {"vr": "DS", "Value": [280.41]},
        "1843": {"vr": "DS", "Value": [126.42]},
        "1844": {"vr": "DS", "Value": [386.3025]},
        "1845": {"vr": "DS", "Value": [202.4]},
        "1846": {"vr": "DS", "Value": [190.5075]},
        "1847": {"vr": "DS", "Value": [184.3425]},
        "1848": {"vr": "DS", "Value": [293.62]},
        "1849": {"vr": "DS", "Value": [456.7025]},
        "1850": {"vr": "DS", "Value": [318.5575]},
        "1851": {"vr": "DS", "Value": [457.7475]},
        "1852": {"vr": "DS", "Value": [373.26]},
        "1853": {"vr": "DS", "Value": [23.16]},
        "1854": {"vr": "DS", "Value": [84.4675]},
        "1855": {"vr": "DS", "Value": [287.7475]},
        "1856": {"vr": "DS", "Value": [98.7025]},
        "1857": {"vr": "DS", "Value": [563.2025]},
        "1858": {"vr": "DS", "Value": [200.3325]},
        "1859": {"vr": "DS", "Value": [98.85]},
        "1860": {"vr": "DS", "Value": [341.57]},
        "1861": {"vr": "DS", "Value": [355.66]},
        "1862": {"vr": "DS", "Value": [150.48]},
        "1863": {"vr": "DS", "Value": [504.3825]},
        "1864": {"vr": "DS", "Value": [65.1125]},
        "1865": {"vr": "DS", "Value": [298.45]},
        "1866": {"vr": "DS", "Value": [341.1325]},
        "1867": {"vr": "DS", "Value": [368.85]},
        "1868": {"vr": "DS", "Value": [585.19]},
        "1869": {"vr": "DS", "Value": [419.8925]},
        "1870": {"vr": "DS", "Value": [51.4625]},
        "1871": {"vr": "DS", "Value": [433.5425]},
        "1872": {"vr": "DS", "Value": [595.8925]},
        "1873": {"vr": "DS", "Value": [4.6825]},
        "1874": {"vr": "DS", "Value": [159.425]},
        "1875": {"vr": "DS", "Value": [562.7425]},
        "1876": {"vr": "DS", "Value": [67.6]},
        "1877": {"vr": "DS", "Value": [79.64]},
        "1878": {"vr": "DS", "Value": [584.605]},
        "1879": {"vr": "DS", "Value": [196.9675]},
        "1880": {"vr": "DS", "Value": [164.6925]},
        "1881": {"vr": "DS", "Value": [457.2875]},
        "1882": {"vr": "DS", "Value": [265.3175]},
        "1883": {"vr": "DS", "Value": [43.835]},
        "1884": {"vr": "DS", "Value": [177.7575]},
        "1885": {"vr": "DS", "Value": [553.795]},
        "1886": {"vr": "DS", "Value": [309.61]},
        "1887": {"vr": "DS", "Value": [470.205]},
        "1888": {"vr": "DS", "Value": [565.69]},
        "1889": {"vr": "DS", "Value": [494.1175]},
        "1890": {"vr": "DS", "Value": [353.61]},
        "1891": {"vr": "DS", "Value": [329.6975]},
        "1892": {"vr": "DS", "Value": [532.245]},
        "1893": {"vr": "DS", "Value": [44.7325]},
        "1894": {"vr": "DS", "Value": [546.1875]},
        "1895": {"vr": "DS", "Value": [532.5375]},
        "1896": {"vr": "DS", "Value": [411.9725]},
        "1897": {"vr": "DS", "Value": [172.3225]},
        "1898": {"vr": "DS", "Value": [580.05]},
        "1899": {"vr": "DS", "Value": [42.955]},
        "1900": {"vr": "DS", "Value": [114.6925]},
        "1901": {"vr": "DS", "Value": [543.5325]},
        "1902": {"vr": "DS", "Value": [229.5325]},
        "1903": {"vr": "DS", "Value": [164.4]},
        "1904": {"vr": "DS", "Value": [250.205]},
        "1905": {"vr": "DS", "Value": [452.02]},
        "1906": {"vr": "DS", "Value": [215.2975]},
        "1907": {"vr": "DS", "Value": [229.68]},
        "1908": {"vr": "DS", "Value": [249.035]},
        "1909": {"vr": "DS", "Value": [499.24]},
        "1910": {"vr": "DS", "Value": [159.865]},
        "1911": {"vr": "DS", "Value": [63.5025]},
        "1912": {"vr": "DS", "Value": [83.7375]},
        "1913": {"vr": "DS", "Value": [464.185]},
        "1914": {"vr": "DS", "Value": [498.655]},
        "1915": {"vr": "DS", "Value": [7.9025]},
        "1916": {"vr": "DS", "Value": [305.9325]},
        "1917": {"vr": "DS", "Value": [449.68]},
        "1918": {"vr": "DS", "Value": [304.3225]},
        "1919": {"vr": "DS", "Value": [585.045]},
        "1920": {"vr": "DS", "Value": [207.0825]},
        "1921": {"vr": "DS", "Value": [229.24]},
        "1922": {"vr": "DS", "Value": [258.5675]},
        "1923": {"vr": "DS", "Value": [253.2775]},
        "1924": {"vr": "DS", "Value": [47.66]},
        "1925": {"vr": "DS", "Value": [181.855]},
        "1926": {"vr": "DS", "Value": [491.025]},
        "1927": {"vr": "DS", "Value": [259.445]},
        "1928": {"vr": "DS", "Value": [179.66]},
        "1929": {"vr": "DS", "Value": [283.21]},
        "1930": {"vr": "DS", "Value": [440.44]},
        "1931": {"vr": "DS", "Value": [247.7175]},
        "1932": {"vr": "DS", "Value": [510.9875]},
        "1933": {"vr": "DS", "Value": [402.7325]},
        "1934": {"vr": "DS", "Value": [70.0875]},
        "1935": {"vr": "DS", "Value": [518.01]},
        "1936": {"vr": "DS", "Value": [104.995]},
        "1937": {"vr": "DS", "Value": [438.665]},
        "1938": {"vr": "DS", "Value": [525.055]},
        "1939": {"vr": "DS", "Value": [273.68]},
        "1940": {"vr": "DS", "Value": [193.1425]},
        "1941": {"vr": "DS", "Value": [213.5425]},
        "1942": {"vr": "DS", "Value": [376.4775]},
        "1943": {"vr": "DS", "Value": [79.785]},
        "1944": {"vr": "DS", "Value": [377.065]},
        "1945": {"vr": "DS", "Value": [409.9225]},
        "1946": {"vr": "DS", "Value": [229.825]},
        "1947": {"vr": "DS", "Value": [235.385]},
        "1948": {"vr": "DS", "Value": [518.3025]},
        "1949": {"vr": "DS", "Value": [111.8925]},
        "1950": {"vr": "DS", "Value": [440.295]},
        "1951": {"vr": "DS", "Value": [349.4925]},
        "1952": {"vr": "DS", "Value": [378.84]},
        "1953": {"vr": "DS", "Value": [280.85]},
        "1954": {"vr": "DS", "Value": [51.025]},
        "1955": {"vr": "DS", "Value": [134.4875]},
        "1956": {"vr": "DS", "Value": [460.675]},
        "1957": {"vr": "DS", "Value": [319.435]},
        "1958": {"vr": "DS", "Value": [378.235]},
        "1959": {"vr": "DS", "Value": [274.85]},
        "1960": {"vr": "DS", "Value": [192.85]},
        "1961": {"vr": "DS", "Value": [1.9025]},
        "1962": {"vr": "DS", "Value": [419.1625]},
        "1963": {"vr": "DS", "Value": [385.5725]},
        "1964": {"vr": "DS", "Value": [296.255]},
        "1965": {"vr": "DS", "Value": [234.655]},
        "1966": {"vr": "DS", "Value": [433.25]},
        "1967": {"vr": "DS", "Value": [593.99]},
        "1968": {"vr": "DS", "Value": [391.7375]},
        "1969": {"vr": "DS", "Value": [575.3675]},
        "1970": {"vr": "DS", "Value": [170.275]},
        "1971": {"vr": "DS", "Value": [226.7325]},
        "1972": {"vr": "DS", "Value": [314.1475]},
        "1973": {"vr": "DS", "Value": [590.3325]},
        "1974": {"vr": "DS", "Value": [183.9025]},
        "1975": {"vr": "DS", "Value": [479.885]},
        "1976": {"vr": "DS", "Value": [50.1475]},
        "1977": {"vr": "DS", "Value": [314.585]},
        "1978": {"vr": "DS", "Value": [102.655]},
        "1979": {"vr": "DS", "Value": [431.64]},
        "1980": {"vr": "DS", "Value": [220.1475]},
        "1981": {"vr": "DS", "Value": [360.635]},
        "1982": {"vr": "DS", "Value": [456.265]},
        "1983": {"vr": "DS", "Value": [311.5125]},
        "1984": {"vr": "DS", "Value": [85.2]},
        "1985": {"vr": "DS", "Value": [311.075]},
        "1986": {"vr": "DS", "Value": [501.435]},
        "1987": {"vr": "DS", "Value": [569.3475]},
        "1988": {"vr": "DS", "Value": [36.3725]},
        "1989": {"vr": "DS", "Value": [312.39]},
        "1990": {"vr": "DS", "Value": [438.0775]},
        "1991": {"vr": "DS", "Value": [262.665]},
        "1992": {"vr": "DS", "Value": [166.595]},
        "1993": {"vr": "DS", "Value": [305.4925]},
        "1994": {"vr": "DS", "Value": [531.3675]},
        "1995": {"vr": "DS", "Value": [551.6]},
        "1996": {"vr": "DS", "Value": [300.225]},
        "1997": {"vr": "DS", "Value": [56.1675]},
        "1998": {"vr": "DS", "Value": [369.7475]},
        "1999": {"vr": "DS", "Value": [390.5675]},
        "2000": {"vr": "DS", "Value": [467.7175]},
        "2001": {"vr": "DS", "Value": [593.1125]},
        "2002": {"vr": "DS", "Value": [447.7575]},
        "2003": {"vr": "DS", "Value": [37.1025]},
        "2004": {"vr": "DS", "Value": [411.0925]},
        "2005": {"vr": "DS", "Value": [99.2875]},
        "2006": {"vr": "DS", "Value": [285.99]},
        "2007": {"vr": "DS", "Value": [65.405]},
        "2008": {"vr": "DS", "Value": [121.7175]},
        "2009": {"vr": "DS", "Value": [583.1425]},
        "2010": {"vr": "DS", "Value": [89.1725]},
        "2011": {"vr": "DS", "Value": [526.665]},
        "2012": {"vr": "DS", "Value": [1.3175]},
        "2013": {"vr": "DS", "Value": [483.1025]},
        "2014": {"vr": "DS", "Value": [240.675]},
        "2015": {"vr": "DS", "Value": [458.1875]},
        "2016": {"vr": "DS", "Value": [313.415]},
        "2017": {"vr": "DS", "Value": [299.2]},
        "2018": {"vr": "DS", "Value": [516.255]},
        "2019": {"vr": "DS", "Value": [295.375]},
        "2020": {"vr": "DS", "Value": [579.465]},
        "2021": {"vr": "DS", "Value": [216.9075]},
        "2022": {"vr": "DS", "Value": [366.3625]},
        "2023": {"vr": "DS", "Value": [197.5525]},
        "2024": {"vr": "DS", "Value": [552.3325]},
        "2025": {"vr": "DS", "Value": [113.5025]},
        "2026": {"vr": "DS", "Value": [541.9225]},
        "2027": {"vr": "DS", "Value": [178.635]},
        "2028": {"vr": "DS", "Value": [389.1025]},
        "2029": {"vr": "DS", "Value": [113.0625]},
        "2030": {"vr": "DS", "Value": [582.1175]},
        "2031": {"vr": "DS", "Value": [320.8975]},
        "2032": {"vr": "DS", "Value": [93.7075]},
        "2033": {"vr": "DS", "Value": [570.225]},
        "2034": {"vr": "DS", "Value": [345.5425]},
        "2035": {"vr": "DS", "Value": [310.05]},
        "2036": {"vr": "DS", "Value": [191.24]},
        "2037": {"vr": "DS", "Value": [157.5025]},
        "2038": {"vr": "DS", "Value": [461.845]},
        "2039": {"vr": "DS", "Value": [296.985]},
        "2040": {"vr": "DS", "Value": [80.5175]},
        "2041": {"vr": "DS", "Value": [371.795]},
        "2042": {"vr": "DS", "Value": [82.7125]},
        "2043": {"vr": "DS", "Value": [477.25]},
        "2044": {"vr": "DS", "Value": [245.5025]},
        "2045": {"vr": "DS", "Value": [358.1475]},
        "2046": {"vr": "DS", "Value": [168.665]},
        "2047": {"vr": "DS", "Value": [576.685]},
        "2048": {"vr": "DS", "Value": [201.0625]},
        "2049": {"vr": "DS", "Value": [313.5625]},
        "2050": {"vr": "DS", "Value": [46.9275]},
        "2051": {"vr": "DS", "Value": [252.255]},
        "2052": {"vr": "DS", "Value": [74.4975]},
        "2053": {"vr": "DS", "Value": [432.665]},
        "2054": {"vr": "DS", "Value": [286.575]},
        "2055": {"vr": "DS", "Value": [222.195]},
        "2056": {"vr": "DS", "Value": [378.4]},
        "2057": {"vr": "DS", "Value": [553.5025]},
        "2058": {"vr": "DS", "Value": [588.265]},
        "2059": {"vr": "DS", "Value": [524.47]},
        "2060": {"vr": "DS", "Value": [116.45]},
        "2061": {"vr": "DS", "Value": [340.1075]},
        "2062": {"vr": "DS", "Value": [159.7175]},
        "2063": {"vr": "DS", "Value": [353.7575]},
        "2064": {"vr": "DS", "Value": [494.265]},
        "2065": {"vr": "DS", "Value": [547.65]},
        "2066": {"vr": "DS", "Value": [335.28]},
        "2067": {"vr": "DS", "Value": [227.3175]},
        "2068": {"vr": "DS", "Value": [226.8775]},
        "2069": {"vr": "DS", "Value": [530.635]},
        "2070": {"vr": "DS", "Value": [350.665]},
        "2071": {"vr": "DS", "Value": [447.3175]},
        "2072": {"vr": "DS", "Value": [308.88]},
        "2073": {"vr": "DS", "Value": [383.815]},
        "2074": {"vr": "DS", "Value": [155.6]},
        "2075": {"vr": "DS", "Value": [204.595]},
        "2076": {"vr": "DS", "Value": [373.1125]},
        "2077": {"vr": "DS", "Value": [488.83]},
        "2078": {"vr": "DS", "Value": [170.86]},
        "2079": {"vr": "DS", "Value": [208.5475]},
        "2080": {"vr": "DS", "Value": [193.435]},
        "2081": {"vr": "DS", "Value": [534.7325]},
        "2082": {"vr": "DS", "Value": [207.815]},
        "2083": {"vr": "DS", "Value": [300.3725]},
        "2084": {"vr": "DS", "Value": [301.395]},
        "2085": {"vr": "DS", "Value": [146.215]},
        "2086": {"vr": "DS", "Value": [496.46]},
        "2087": {"vr": "DS", "Value": [551.1625]},
        "2088": {"vr": "DS", "Value": [415.21]},
        "2089": {"vr": "DS", "Value": [170.5675]},
        "2090": {"vr": "DS", "Value": [311.22]},
        "2091": {"vr": "DS", "Value": [345.9825]},
        "2092": {"vr": "DS", "Value": [408.3125]},
        "2093": {"vr": "DS", "Value": [584.1675]},
        "2094": {"vr": "DS", "Value": [575.805]},
        "2095": {"vr": "DS", "Value": [236.1175]},
        "2096": {"vr": "DS", "Value": [117.18]},
        "2097": {"vr": "DS", "Value": [120.5475]},
        "2098": {"vr": "DS", "Value": [1.1725]},
        "2099": {"vr": "DS", "Value": [474.45]},
        "2100": {"vr": "DS", "Value": [377.9425]},
        "2101": {"vr": "DS", "Value": [471.23]},
        "2102": {"vr": "DS", "Value": [270.0]},
        "2103": {"vr": "DS", "Value": [20.235]},
        "2104": {"vr": "DS", "Value": [466.5475]},
        "2105": {"vr": "DS", "Value": [50.585]},
        "2106": {"vr": "DS", "Value": [153.845]},
        "2107": {"vr": "DS", "Value": [364.02]},
        "2108": {"vr": "DS", "Value": [83.59]},
        "2109": {"vr": "DS", "Value": [493.095]},
        "2110": {"vr": "DS", "Value": [535.7575]},
        "2111": {"vr": "DS", "Value": [116.7425]},
        "2112": {"vr": "DS", "Value": [175.835]},
        "2113": {"vr": "DS", "Value": [323.97]},
        "2114": {"vr": "DS", "Value": [505.5525]},
        "2115": {"vr": "DS", "Value": [48.0975]},
        "2116": {"vr": "DS", "Value": [317.3875]},
        "2117": {"vr": "DS", "Value": [192.41]},
        "2118": {"vr": "DS", "Value": [138.8775]},
        "2119": {"vr": "DS", "Value": [343.2]},
        "2120": {"vr": "DS", "Value": [584.8975]},
        "2121": {"vr": "DS", "Value": [99.435]},
        "2122": {"vr": "DS", "Value": [20.6725]},
        "2123": {"vr": "DS", "Value": [96.05]},
        "2124": {"vr": "DS", "Value": [49.1225]},
        "2125": {"vr": "DS", "Value": [191.825]},
        "2126": {"vr": "DS", "Value": [41.9325]},
        "2127": {"vr": "DS", "Value": [256.665]},
        "2128": {"vr": "DS", "Value": [355.3675]},
        "2129": {"vr": "DS", "Value": [538.265]},
        "2130": {"vr": "DS", "Value": [256.3725]},
        "2131": {"vr": "DS", "Value": [556.595]},
        "2132": {"vr": "DS", "Value": [402.585]},
        "2133": {"vr": "DS", "Value": [69.795]},
        "2134": {"vr": "DS", "Value": [116.1575]},
        "2135": {"vr": "DS", "Value": [145.9225]},
        "2136": {"vr": "DS", "Value": [100.1675]},
        "2137": {"vr": "DS", "Value": [211.785]},
        "2138": {"vr": "DS", "Value": [248.595]},
        "2139": {"vr": "DS", "Value": [311.66]},
        "2140": {"vr": "DS", "Value": [308.0]},
        "2141": {"vr": "DS", "Value": [372.3825]},
        "2142": {"vr": "DS", "Value": [280.265]},
        "2143": {"vr": "DS", "Value": [579.1725]},
        "2144": {"vr": "DS", "Value": [357.7075]},
        "2145": {"vr": "DS", "Value": [165.7175]},
        "2146": {"vr": "DS", "Value": [592.3825]},
        "2147": {"vr": "DS", "Value": [91.66]},
        "2148": {"vr": "DS", "Value": [92.6825]},
        "2149": {"vr": "DS", "Value": [552.625]},
        "2150": {"vr": "DS", "Value": [561.425]},
        "2151": {"vr": "DS", "Value": [321.19]},
        "2152": {"vr": "DS", "Value": [60.2625]},
        "2153": {"vr": "DS", "Value": [148.995]},
        "2154": {"vr": "DS", "Value": [394.0775]},
        "2155": {"vr": "DS", "Value": [353.1725]},
        "2156": {"vr": "DS", "Value": [419.6]},
        "2157": {"vr": "DS", "Value": [291.7175]},
        "2158": {"vr": "DS", "Value": [398.4875]},
        "2159": {"vr": "DS", "Value": [295.67]},
        "2160": {"vr": "DS", "Value": [289.65]},
        "2161": {"vr": "DS", "Value": [129.3475]},
        "2162": {"vr": "DS", "Value": [55.8725]},
        "2163": {"vr": "DS", "Value": [274.7025]},
        "2164": {"vr": "DS", "Value": [367.825]},
        "2165": {"vr": "DS", "Value": [202.5475]},
        "2166": {"vr": "DS", "Value": [265.025]},
        "2167": {"vr": "DS", "Value": [379.1325]},
        "2168": {"vr": "DS", "Value": [572.0025]},
        "2169": {"vr": "DS", "Value": [168.5175]},
        "2170": {"vr": "DS", "Value": [305.64]},
        "2171": {"vr": "DS", "Value": [561.5725]},
        "2172": {"vr": "DS", "Value": [119.815]},
        "2173": {"vr": "DS", "Value": [463.015]},
        "2174": {"vr": "DS", "Value": [307.25]},
        "2175": {"vr": "DS", "Value": [183.17]},
        "2176": {"vr": "DS", "Value": [369.1425]},
        "2177": {"vr": "DS", "Value": [587.5325]},
        "2178": {"vr": "DS", "Value": [118.79]},
        "2179": {"vr": "DS", "Value": [375.015]},
        "2180": {"vr": "DS", "Value": [82.2725]},
        "2181": {"vr": "DS", "Value": [152.9675]},
        "2182": {"vr": "DS", "Value": [406.85]},
        "2183": {"vr": "DS", "Value": [511.865]},
        "2184": {"vr": "DS", "Value": [436.3225]},
        "2185": {"vr": "DS", "Value": [294.205]},
        "2186": {"vr": "DS", "Value": [461.405]},
        "2187": {"vr": "DS", "Value": [589.6025]},
        "2188": {"vr": "DS", "Value": [380.1575]},
        "2189": {"vr": "DS", "Value": [173.3475]},
        "2190": {"vr": "DS", "Value": [49.56]},
        "2191": {"vr": "DS", "Value": [100.7525]},
        "2192": {"vr": "DS", "Value": [202.985]},
        "2193": {"vr": "DS", "Value": [474.595]},
        "2194": {"vr": "DS", "Value": [38.7125]},
        "2195": {"vr": "DS", "Value": [243.455]},
        "2196": {"vr": "DS", "Value": [376.04]},
        "2197": {"vr": "DS", "Value": [292.45]},
        "2198": {"vr": "DS", "Value": [531.805]},
        "2199": {"vr": "DS", "Value": [462.5775]},
        "2200": {"vr": "DS", "Value": [114.985]},
        "2201": {"vr": "DS", "Value": [176.0]},
        "2202": {"vr": "DS", "Value": [501.6]},
        "2203": {"vr": "DS", "Value": [423.5725]},
        "2204": {"vr": "DS", "Value": [592.675]},
        "2205": {"vr": "DS", "Value": [62.625]},
        "2206": {"vr": "DS", "Value": [387.7875]},
        "2207": {"vr": "DS", "Value": [358.8775]},
        "2208": {"vr": "DS", "Value": [583.7275]},
        "2209": {"vr": "DS", "Value": [480.47]},
        "2210": {"vr": "DS", "Value": [128.4675]},
        "2211": {"vr": "DS", "Value": [44.0]},
        "2212": {"vr": "DS", "Value": [432.5175]},
        "2213": {"vr": "DS", "Value": [430.3025]},
        "2214": {"vr": "DS", "Value": [191.6775]},
        "2215": {"vr": "DS", "Value": [490.8775]},
        "2216": {"vr": "DS", "Value": [309.1725]},
        "2217": {"vr": "DS", "Value": [416.235]},
        "2218": {"vr": "DS", "Value": [248.7425]},
        "2219": {"vr": "DS", "Value": [135.805]},
        "2220": {"vr": "DS", "Value": [5.56]},
        "2221": {"vr": "DS", "Value": [100.605]},
        "2222": {"vr": "DS", "Value": [476.5175]},
        "2223": {"vr": "DS", "Value": [342.45]},
        "2224": {"vr": "DS", "Value": [69.21]},
        "2225": {"vr": "DS", "Value": [351.835]},
        "2226": {"vr": "DS", "Value": [216.47]},
        "2227": {"vr": "DS", "Value": [543.825]},
        "2228": {"vr": "DS", "Value": [42.5175]},
        "2229": {"vr": "DS", "Value": [554.235]},
        "2230": {"vr": "DS", "Value": [413.2875]},
        "2231": {"vr": "DS", "Value": [453.045]},
        "2232": {"vr": "DS", "Value": [372.0875]},
        "2233": {"vr": "DS", "Value": [587.68]},
        "2234": {"vr": "DS", "Value": [328.5275]},
        "2235": {"vr": "DS", "Value": [424.3025]},
        "2236": {"vr": "DS", "Value": [443.5125]},
        "2237": {"vr": "DS", "Value": [367.6775]},
        "2238": {"vr": "DS", "Value": [448.8]},
        "2239": {"vr": "DS", "Value": [111.6]},
        "2240": {"vr": "DS", "Value": [187.58]},
        "2241": {"vr": "DS", "Value": [105.1425]},
        "2242": {"vr": "DS", "Value": [375.7475]},
        "2243": {"vr": "DS", "Value": [71.1325]},
        "2244": {"vr": "DS", "Value": [46.78]},
        "2245": {"vr": "DS", "Value": [261.4925]},
        "2246": {"vr": "DS", "Value": [29.7675]},
        "2247": {"vr": "DS", "Value": [365.19]},
        "2248": {"vr": "DS", "Value": [73.4725]},
        "2249": {"vr": "DS", "Value": [510.84]},
        "2250": {"vr": "DS", "Value": [483.6875]},
        "2251": {"vr": "DS", "Value": [125.98]},
        "2252": {"vr": "DS", "Value": [22.1375]},
        "2253": {"vr": "DS", "Value": [511.7175]},
        "2254": {"vr": "DS", "Value": [597.065]},
        "2255": {"vr": "DS", "Value": [197.405]},
        "2256": {"vr": "DS", "Value": [581.095]},
        "2257": {"vr": "DS", "Value": [421.65]},
        "2258": {"vr": "DS", "Value": [89.61]},
        "2259": {"vr": "DS", "Value": [108.235]},
        "2260": {"vr": "DS", "Value": [316.9475]},
        "2261": {"vr": "DS", "Value": [168.81]},
        "2262": {"vr": "DS", "Value": [575.66]},
        "2263": {"vr": "DS", "Value": [497.63]},
        "2264": {"vr": "DS", "Value": [416.82]},
        "2265": {"vr": "DS", "Value": [279.6775]},
        "2266": {"vr": "DS", "Value": [392.7625]},
        "2267": {"vr": "DS", "Value": [558.4975]},
        "2268": {"vr": "DS", "Value": [369.2875]},
        "2269": {"vr": "DS", "Value": [88.2925]},
        "2270": {"vr": "DS", "Value": [416.9675]},
        "2271": {"vr": "DS", "Value": [195.5025]},
        "2272": {"vr": "DS", "Value": [557.9125]},
        "2273": {"vr": "DS", "Value": [241.26]},
        "2274": {"vr": "DS", "Value": [490.44]},
        "2275": {"vr": "DS", "Value": [332.9175]},
        "2276": {"vr": "DS", "Value": [365.63]},
        "2277": {"vr": "DS", "Value": [320.46]},
        "2278": {"vr": "DS", "Value": [497.7775]},
        "2279": {"vr": "DS", "Value": [573.025]},
        "2280": {"vr": "DS", "Value": [100.3125]},
        "2281": {"vr": "DS", "Value": [444.0975]},
        "2282": {"vr": "DS", "Value": [155.1625]},
        "2283": {"vr": "DS", "Value": [165.8625]},
        "2284": {"vr": "DS", "Value": [295.0825]},
        "2285": {"vr": "DS", "Value": [476.08]},
        "2286": {"vr": "DS", "Value": [520.9575]},
        "2287": {"vr": "DS", "Value": [4.245]},
        "2288": {"vr": "DS", "Value": [584.46]},
        "2289": {"vr": "DS", "Value": [31.96]},
        "2290": {"vr": "DS", "Value": [125.835]},
        "2291": {"vr": "DS", "Value": [401.855]},
        "2292": {"vr": "DS", "Value": [530.05]},
        "2293": {"vr": "DS", "Value": [138.44]},
        "2294": {"vr": "DS", "Value": [318.85]},
        "2295": {"vr": "DS", "Value": [303.005]},
        "2296": {"vr": "DS", "Value": [396.5875]},
        "2297": {"vr": "DS", "Value": [534.0]},
        "2298": {"vr": "DS", "Value": [391.2975]},
        "2299": {"vr": "DS", "Value": [567.59]},
        "2300": {"vr": "DS", "Value": [472.5475]},
        "2301": {"vr": "DS", "Value": [384.1075]},
        "2302": {"vr": "DS", "Value": [139.3175]},
        "2303": {"vr": "DS", "Value": [407.7275]},
        "2304": {"vr": "DS", "Value": [336.1575]},
        "2305": {"vr": "DS", "Value": [21.405]},
        "2306": {"vr": "DS", "Value": [35.3475]},
        "2307": {"vr": "DS", "Value": [430.1575]},
        "2308": {"vr": "DS", "Value": [443.66]},
        "2309": {"vr": "DS", "Value": [267.66]},
        "2310": {"vr": "DS", "Value": [232.3125]},
        "2311": {"vr": "DS", "Value": [425.7675]},
        "2312": {"vr": "DS", "Value": [509.795]},
        "2313": {"vr": "DS", "Value": [0.7325]},
        "2314": {"vr": "DS", "Value": [259.59]},
        "2315": {"vr": "DS", "Value": [585.3375]},
        "2316": {"vr": "DS", "Value": [33.1325]},
        "2317": {"vr": "DS", "Value": [442.05]},
        "2318": {"vr": "DS", "Value": [409.19]},
        "2319": {"vr": "DS", "Value": [165.57]},
        "2320": {"vr": "DS", "Value": [272.05]},
        "2321": {"vr": "DS", "Value": [176.7325]},
        "2322": {"vr": "DS", "Value": [49.7075]},
        "2323": {"vr": "DS", "Value": [521.9825]},
        "2324": {"vr": "DS", "Value": [417.1125]},
        "2325": {"vr": "DS", "Value": [564.225]},
        "2326": {"vr": "DS", "Value": [166.1575]},
        "2327": {"vr": "DS", "Value": [268.5375]},
        "2328": {"vr": "DS", "Value": [187.7275]},
        "2329": {"vr": "DS", "Value": [250.79]},
        "2330": {"vr": "DS", "Value": [441.025]},
        "2331": {"vr": "DS", "Value": [134.3425]},
        "2332": {"vr": "DS", "Value": [417.26]},
        "2333": {"vr": "DS", "Value": [376.9175]},
        "2334": {"vr": "DS", "Value": [318.995]},
        "2335": {"vr": "DS", "Value": [219.5425]},
        "2336": {"vr": "DS", "Value": [53.5325]},
        "2337": {"vr": "DS", "Value": [394.81]},
        "2338": {"vr": "DS", "Value": [73.9125]},
        "2339": {"vr": "DS", "Value": [177.025]},
        "2340": {"vr": "DS", "Value": [498.8]},
        "2341": {"vr": "DS", "Value": [348.1775]},
        "2342": {"vr": "DS", "Value": [507.8925]},
        "2343": {"vr": "DS", "Value": [239.21]},
        "2344": {"vr": "DS", "Value": [217.3475]},
        "2345": {"vr": "DS", "Value": [252.5475]},
        "2346": {"vr": "DS", "Value": [498.215]},
        "2347": {"vr": "DS", "Value": [121.425]},
        "2348": {"vr": "DS", "Value": [361.0925]},
        "2349": {"vr": "DS", "Value": [145.63]},
        "2350": {"vr": "DS", "Value": [64.0875]},
        "2351": {"vr": "DS", "Value": [410.5075]},
        "2352": {"vr": "DS", "Value": [191.5325]},
        "2353": {"vr": "DS", "Value": [524.9075]},
        "2354": {"vr": "DS", "Value": [81.98]},
        "2355": {"vr": "DS", "Value": [25.21]},
        "2356": {"vr": "DS", "Value": [216.3225]},
        "2357": {"vr": "DS", "Value": [570.81]},
        "2358": {"vr": "DS", "Value": [199.015]},
        "2359": {"vr": "DS", "Value": [497.045]},
        "2360": {"vr": "DS", "Value": [109.26]},
        "2361": {"vr": "DS", "Value": [582.265]},
        "2362": {"vr": "DS", "Value": [473.7175]},
        "2363": {"vr": "DS", "Value": [574.7825]},
        "2364": {"vr": "DS", "Value": [540.605]},
        "2365": {"vr": "DS", "Value": [59.5325]},
        "2366": {"vr": "DS", "Value": [217.785]},
        "2367": {"vr": "DS", "Value": [346.275]},
        "2368": {"vr": "DS", "Value": [464.9175]},
        "2369": {"vr": "DS", "Value": [3.0725]},
        "2370": {"vr": "DS", "Value": [51.17]},
        "2371": {"vr": "DS", "Value": [349.9325]},
        "2372": {"vr": "DS", "Value": [201.9425]},
        "2373": {"vr": "DS", "Value": [81.25]},
        "2374": {"vr": "DS", "Value": [56.605]},
        "2375": {"vr": "DS", "Value": [290.4]},
        "2376": {"vr": "DS", "Value": [111.455]},
        "2377": {"vr": "DS", "Value": [41.785]},
        "2378": {"vr": "DS", "Value": [488.245]},
        "2379": {"vr": "DS", "Value": [77.1325]},
        "2380": {"vr": "DS", "Value": [510.4]},
        "2381": {"vr": "DS", "Value": [403.025]},
        "2382": {"vr": "DS", "Value": [401.415]},
        "2383": {"vr": "DS", "Value": [246.84]},
        "2384": {"vr": "DS", "Value": [282.3325]},
        "2385": {"vr": "DS", "Value": [304.175]},
        "2386": {"vr": "DS", "Value": [518.8875]},
        "2387": {"vr": "DS", "Value": [155.7475]},
        "2388": {"vr": "DS", "Value": [562.8875]},
        "2389": {"vr": "DS", "Value": [56.3125]},
        "2390": {"vr": "DS", "Value": [586.07]},
        "2391": {"vr": "DS", "Value": [167.035]},
        "2392": {"vr": "DS", "Value": [157.3575]},
        "2393": {"vr": "DS", "Value": [45.7575]},
        "2394": {"vr": "DS", "Value": [397.1725]},
        "2395": {"vr": "DS", "Value": [523.2975]},
        "2396": {"vr": "DS", "Value": [238.04]},
        "2397": {"vr": "DS", "Value": [518.1575]},
        "2398": {"vr": "DS", "Value": [482.665]},
        "2399": {"vr": "DS", "Value": [542.655]},
        "2400": {"vr": "DS", "Value": [493.5325]},
        "2401": {"vr": "DS", "Value": [224.0975]},
        "2402": {"vr": "DS", "Value": [508.3325]},
        "2403": {"vr": "DS", "Value": [437.785]},
        "2404": {"vr": "DS", "Value": [406.995]},
        "2405": {"vr": "DS", "Value": [420.7725]},
        "2406": {"vr": "DS", "Value": [91.22]},
        "2407": {"vr": "DS", "Value": [186.1175]},
        "2408": {"vr": "DS", "Value": [47.0725]},
        "2409": {"vr": "DS", "Value": [229.0925]},
        "2410": {"vr": "DS", "Value": [578.0]},
        "2411": {"vr": "DS", "Value": [376.3325]},
        "2412": {"vr": "DS", "Value": [409.3375]},
        "2413": {"vr": "DS", "Value": [472.255]},
        "2414": {"vr": "DS", "Value": [339.0825]},
        "2415": {"vr": "DS", "Value": [70.235]},
        "2416": {"vr": "DS", "Value": [86.5175]},
        "2417": {"vr": "DS", "Value": [596.3325]},
        "2418": {"vr": "DS", "Value": [396.295]},
        "2419": {"vr": "DS", "Value": [175.6875]},
        "2420": {"vr": "DS", "Value": [431.495]},
        "2421": {"vr": "DS", "Value": [419.3075]},
        "2422": {"vr": "DS", "Value": [445.855]},
        "2423": {"vr": "DS", "Value": [34.595]},
        "2424": {"vr": "DS", "Value": [79.4925]},
        "2425": {"vr": "DS", "Value": [370.48]},
        "2426": {"vr": "DS", "Value": [37.835]},
        "2427": {"vr": "DS", "Value": [163.5225]},
        "2428": {"vr": "DS", "Value": [356.9775]},
        "2429": {"vr": "DS", "Value": [266.78]},
        "2430": {"vr": "DS", "Value": [253.865]},
        "2431": {"vr": "DS", "Value": [40.03]},
        "2432": {"vr": "DS", "Value": [43.1025]},
        "2433": {"vr": "DS", "Value": [204.8875]},
        "2434": {"vr": "DS", "Value": [188.3125]},
        "2435": {"vr": "DS", "Value": [544.995]},
        "2436": {"vr": "DS", "Value": [120.255]},
        "2437": {"vr": "DS", "Value": [393.4925]},
        "2438": {"vr": "DS", "Value": [75.9625]},
        "2439": {"vr": "DS", "Value": [384.6925]},
        "2440": {"vr": "DS", "Value": [358.7325]},
        "2441": {"vr": "DS", "Value": [517.1325]},
        "2442": {"vr": "DS", "Value": [422.235]},
        "2443": {"vr": "DS", "Value": [463.7475]},
        "2444": {"vr": "DS", "Value": [366.215]},
        "2445": {"vr": "DS", "Value": [420.9175]},
        "2446": {"vr": "DS", "Value": [89.025]},
        "2447": {"vr": "DS", "Value": [268.83]},
        "2448": {"vr": "DS", "Value": [524.615]},
        "2449": {"vr": "DS", "Value": [43.25]},
        "2450": {"vr": "DS", "Value": [432.9575]},
        "2451": {"vr": "DS", "Value": [327.3575]},
        "2452": {"vr": "DS", "Value": [63.3575]},
        "2453": {"vr": "DS", "Value": [261.2]},
        "2454": {"vr": "DS", "Value": [565.1025]},
        "2455": {"vr": "DS", "Value": [162.3525]},
        "2456": {"vr": "DS", "Value": [320.1675]},
        "2457": {"vr": "DS", "Value": [314.7325]},
        "2458": {"vr": "DS", "Value": [322.3625]},
        "2459": {"vr": "DS", "Value": [568.3225]},
        "2460": {"vr": "DS", "Value": [213.395]},
        "2461": {"vr": "DS", "Value": [176.88]},
        "2462": {"vr": "DS", "Value": [451.875]},
        "2463": {"vr": "DS", "Value": [538.41]},
        "2464": {"vr": "DS", "Value": [481.055]},
        "2465": {"vr": "DS", "Value": [405.68]},
        "2466": {"vr": "DS", "Value": [254.7425]},
        "2467": {"vr": "DS", "Value": [327.065]},
        "2468": {"vr": "DS", "Value": [485.1725]},
        "2469": {"vr": "DS", "Value": [284.5275]},
        "2470": {"vr": "DS", "Value": [119.375]},
        "2471": {"vr": "DS", "Value": [389.835]},
        "2472": {"vr": "DS", "Value": [283.65]},
        "2473": {"vr": "DS", "Value": [189.3375]},
        "2474": {"vr": "DS", "Value": [25.9425]},
        "2475": {"vr": "DS", "Value": [391.445]},
        "2476": {"vr": "DS", "Value": [376.625]},
        "2477": {"vr": "DS", "Value": [570.08]},
        "2478": {"vr": "DS", "Value": [85.64]},
        "2479": {"vr": "DS", "Value": [107.065]},
        "2480": {"vr": "DS", "Value": [496.7525]},
        "2481": {"vr": "DS", "Value": [517.7175]},
        "2482": {"vr": "DS", "Value": [224.6825]},
        "2483": {"vr": "DS", "Value": [508.7725]},
        "2484": {"vr": "DS", "Value": [74.205]},
        "2485": {"vr": "DS", "Value": [190.215]},
        "2486": {"vr": "DS", "Value": [188.02]},
        "2487": {"vr": "DS", "Value": [492.4875]},
        "2488": {"vr": "DS", "Value": [571.395]},
        "2489": {"vr": "DS", "Value": [560.255]},
        "2490": {"vr": "DS", "Value": [428.985]},
        "2491": {"vr": "DS", "Value": [86.955]},
        "2492": {"vr": "DS", "Value": [323.385]},
        "2493": {"vr": "DS", "Value": [363.2875]},
        "2494": {"vr": "DS", "Value": [562.45]},
        "2495": {"vr": "DS", "Value": [196.5275]},
        "2496": {"vr": "DS", "Value": [124.665]},
        "2497": {"vr": "DS", "Value": [508.185]},
        "2498": {"vr": "DS", "Value": [410.9475]},
        "2499": {"vr": "DS", "Value": [226.2925]},
        "2500": {"vr": "DS", "Value": [526.5175]},
        "2501": {"vr": "DS", "Value": [277.045]},
        "2502": {"vr": "DS", "Value": [67.1625]},
        "2503": {"vr": "DS", "Value": [491.3175]},
        "2504": {"vr": "DS", "Value": [133.61]},
        "2505": {"vr": "DS", "Value": [408.605]},
        "2506": {"vr": "DS", "Value": [233.19]},
        "2507": {"vr": "DS", "Value": [389.395]},
        "2508": {"vr": "DS", "Value": [359.61]},
        "2509": {"vr": "DS", "Value": [148.7025]},
        "2510": {"vr": "DS", "Value": [439.835]},
        "2511": {"vr": "DS", "Value": [239.5025]},
        "2512": {"vr": "DS", "Value": [354.7825]},
        "2513": {"vr": "DS", "Value": [556.1575]},
        "2514": {"vr": "DS", "Value": [193.8925]},
        "2515": {"vr": "DS", "Value": [60.85]},
        "2516": {"vr": "DS", "Value": [54.5575]},
        "2517": {"vr": "DS", "Value": [528.0025]},
        "2518": {"vr": "DS", "Value": [265.7575]},
        "2519": {"vr": "DS", "Value": [220.88]},
        "2520": {"vr": "DS", "Value": [400.39]},
        "2521": {"vr": "DS", "Value": [491.465]},
        "2522": {"vr": "DS", "Value": [591.21]},
        "2523": {"vr": "DS", "Value": [71.5725]},
        "2524": {"vr": "DS", "Value": [331.8925]},
        "2525": {"vr": "DS", "Value": [595.1625]},
        "2526": {"vr": "DS", "Value": [186.265]},
        "2527": {"vr": "DS", "Value": [184.9475]},
        "2528": {"vr": "DS", "Value": [509.65]},
        "2529": {"vr": "DS", "Value": [218.0775]},
        "2530": {"vr": "DS", "Value": [474.7425]},
        "2531": {"vr": "DS", "Value": [452.605]},
        "2532": {"vr": "DS", "Value": [354.3425]},
        "2533": {"vr": "DS", "Value": [48.245]},
        "2534": {"vr": "DS", "Value": [404.3425]},
        "2535": {"vr": "DS", "Value": [363.875]},
        "2536": {"vr": "DS", "Value": [263.395]},
        "2537": {"vr": "DS", "Value": [306.9575]},
        "2538": {"vr": "DS", "Value": [413.7475]},
        "2539": {"vr": "DS", "Value": [590.1875]},
        "2540": {"vr": "DS", "Value": [581.5325]},
        "2541": {"vr": "DS", "Value": [321.045]},
        "2542": {"vr": "DS", "Value": [198.87]},
        "2543": {"vr": "DS", "Value": [453.63]},
        "2544": {"vr": "DS", "Value": [95.9025]},
        "2545": {"vr": "DS", "Value": [357.415]},
        "2546": {"vr": "DS", "Value": [397.7575]},
        "2547": {"vr": "DS", "Value": [120.985]},
        "2548": {"vr": "DS", "Value": [204.3025]},
        "2549": {"vr": "DS", "Value": [320.7525]},
        "2550": {"vr": "DS", "Value": [546.9175]},
        "2551": {"vr": "DS", "Value": [469.3275]},
        "2552": {"vr": "DS", "Value": [574.635]},
        "2553": {"vr": "DS", "Value": [69.355]},
        "2554": {"vr": "DS", "Value": [183.025]},
        "2555": {"vr": "DS", "Value": [375.3075]},
        "2556": {"vr": "DS", "Value": [531.9525]},
        "2557": {"vr": "DS", "Value": [498.5075]},
        "2558": {"vr": "DS", "Value": [342.8875]},
        "2559": {"vr": "DS", "Value": [505.99]},
        "2560": {"vr": "DS", "Value": [556.89]},
        "2561": {"vr": "DS", "Value": [258.42]},
        "2562": {"vr": "DS", "Value": [379.28]},
        "2563": {"vr": "DS", "Value": [225.27]},
        "2564": {"vr": "DS", "Value": [152.38]},
        "2565": {"vr": "DS", "Value": [516.985]},
        "2566": {"vr": "DS", "Value": [447.025]},
        "2567": {"vr": "DS", "Value": [394.9575]},
        "2568": {"vr": "DS", "Value": [563.7875]},
        "2569": {"vr": "DS", "Value": [98.265]},
        "2570": {"vr": "DS", "Value": [552.04]},
        "2571": {"vr": "DS", "Value": [110.7225]},
        "2572": {"vr": "DS", "Value": [597.795]},
        "2573": {"vr": "DS", "Value": [46.635]},
        "2574": {"vr": "DS", "Value": [379.7175]},
        "2575": {"vr": "DS", "Value": [75.375]},
        "2576": {"vr": "DS", "Value": [461.5525]},
        "2577": {"vr": "DS", "Value": [187.875]},
        "2578": {"vr": "DS", "Value": [27.865]},
        "2579": {"vr": "DS", "Value": [18.185]},
        "2580": {"vr": "DS", "Value": [588.1175]},
        "2581": {"vr": "DS", "Value": [313.1225]},
        "2582": {"vr": "DS", "Value": [316.4875]},
        "2583": {"vr": "DS", "Value": [252.6925]},
        "2584": {"vr": "DS", "Value": [209.1325]},
        "2585": {"vr": "DS", "Value": [500.85]},
        "2586": {"vr": "DS", "Value": [387.035]},
        "2587": {"vr": "DS", "Value": [444.9775]},
        "2588": {"vr": "DS", "Value": [23.8925]},
        "2589": {"vr": "DS", "Value": [587.385]},
        "2590": {"vr": "DS", "Value": [368.265]},
        "2591": {"vr": "DS", "Value": [546.7725]},
        "2592": {"vr": "DS", "Value": [235.6775]},
        "2593": {"vr": "DS", "Value": [263.835]},
        "2594": {"vr": "DS", "Value": [176.585]},
        "2595": {"vr": "DS", "Value": [528.88]},
        "2596": {"vr": "DS", "Value": [184.4875]},
        "2597": {"vr": "DS", "Value": [567.005]},
        "2598": {"vr": "DS", "Value": [167.9325]},
        "2599": {"vr": "DS", "Value": [365.7775]},
        "2600": {"vr": "DS", "Value": [460.235]},
        "2601": {"vr": "DS", "Value": [504.5275]},
        "2602": {"vr": "DS", "Value": [271.465]},
        "2603": {"vr": "DS", "Value": [460.82]},
        "2604": {"vr": "DS", "Value": [525.785]},
        "2605": {"vr": "DS", "Value": [421.065]},
        "2606": {"vr": "DS", "Value": [477.1025]},
        "2607": {"vr": "DS", "Value": [421.795]},
        "2608": {"vr": "DS", "Value": [572.295]},
        "2609": {"vr": "DS", "Value": [396.88]},
        "2610": {"vr": "DS", "Value": [174.225]},
        "2611": {"vr": "DS", "Value": [205.035]},
        "2612": {"vr": "DS", "Value": [134.635]},
        "2613": {"vr": "DS", "Value": [73.18]},
        "2614": {"vr": "DS", "Value": [389.9825]},
        "2615": {"vr": "DS", "Value": [524.1775]},
        "2616": {"vr": "DS", "Value": [177.1725]},
        "2617": {"vr": "DS", "Value": [429.2775]},
        "2618": {"vr": "DS", "Value": [400.83]},
        "2619": {"vr": "DS", "Value": [253.425]},
        "2620": {"vr": "DS", "Value": [171.8825]},
        "2621": {"vr": "DS", "Value": [326.625]},
        "2622": {"vr": "DS", "Value": [529.9025]},
        "2623": {"vr": "DS", "Value": [502.9175]},
        "2624": {"vr": "DS", "Value": [502.3325]},
        "2625": {"vr": "DS", "Value": [222.635]},
        "2626": {"vr": "DS", "Value": [583.5825]},
        "2627": {"vr": "DS", "Value": [491.9025]},
        "2628": {"vr": "DS", "Value": [591.065]},
        "2629": {"vr": "DS", "Value": [113.21]},
        "2630": {"vr": "DS", "Value": [282.04]},
        "2631": {"vr": "DS", "Value": [271.61]},
        "2632": {"vr": "DS", "Value": [135.5125]},
        "2633": {"vr": "DS", "Value": [296.84]},
        "2634": {"vr": "DS", "Value": [219.25]},
        "2635": {"vr": "DS", "Value": [37.6875]},
        "2636": {"vr": "DS", "Value": [497.485]},
        "2637": {"vr": "DS", "Value": [279.385]},
        "2638": {"vr": "DS", "Value": [28.595]},
        "2639": {"vr": "DS", "Value": [398.3425]},
        "2640": {"vr": "DS", "Value": [6.585]},
        "2641": {"vr": "DS", "Value": [88.0]},
        "2642": {"vr": "DS", "Value": [251.67]},
        "2643": {"vr": "DS", "Value": [585.485]},
        "2644": {"vr": "DS", "Value": [352.5875]},
        "2645": {"vr": "DS", "Value": [489.855]},
        "2646": {"vr": "DS", "Value": [332.4775]},
        "2647": {"vr": "DS", "Value": [431.7875]},
        "2648": {"vr": "DS", "Value": [391.1525]},
        "2649": {"vr": "DS", "Value": [127.7375]},
        "2650": {"vr": "DS", "Value": [154.43]},
        "2651": {"vr": "DS", "Value": [202.0875]},
        "2652": {"vr": "DS", "Value": [97.385]},
        "2653": {"vr": "DS", "Value": [553.065]},
        "2654": {"vr": "DS", "Value": [477.395]},
        "2655": {"vr": "DS", "Value": [42.81]},
        "2656": {"vr": "DS", "Value": [86.81]},
        "2657": {"vr": "DS", "Value": [163.375]},
        "2658": {"vr": "DS", "Value": [597.21]},
        "2659": {"vr": "DS", "Value": [224.975]},
        "2660": {"vr": "DS", "Value": [416.3825]},
        "2661": {"vr": "DS", "Value": [514.4975]},
        "2662": {"vr": "DS", "Value": [548.5275]},
        "2663": {"vr": "DS", "Value": [58.3625]},
        "2664": {"vr": "DS", "Value": [72.1575]},
        "2665": {"vr": "DS", "Value": [78.8875]},
        "2666": {"vr": "DS", "Value": [512.01]},
        "2667": {"vr": "DS", "Value": [169.395]},
        "2668": {"vr": "DS", "Value": [65.6975]},
        "2669": {"vr": "DS", "Value": [92.975]},
        "2670": {"vr": "DS", "Value": [267.22]},
        "2671": {"vr": "DS", "Value": [220.44]},
        "2672": {"vr": "DS", "Value": [466.0875]},
        "2673": {"vr": "DS", "Value": [119.23]},
        "2674": {"vr": "DS", "Value": [69.65]},
        "2675": {"vr": "DS", "Value": [86.6625]},
        "2676": {"vr": "DS", "Value": [62.9175]},
        "2677": {"vr": "DS", "Value": [271.025]},
        "2678": {"vr": "DS", "Value": [467.1325]},
        "2679": {"vr": "DS", "Value": [305.785]},
        "2680": {"vr": "DS", "Value": [8.635]},
        "2681": {"vr": "DS", "Value": [428.5475]},
        "2682": {"vr": "DS", "Value": [323.825]},
        "2683": {"vr": "DS", "Value": [442.7825]},
        "2684": {"vr": "DS", "Value": [252.4]},
        "2685": {"vr": "DS", "Value": [394.3725]},
        "2686": {"vr": "DS", "Value": [135.0725]},
        "2687": {"vr": "DS", "Value": [350.81]},
        "2688": {"vr": "DS", "Value": [362.7025]},
        "2689": {"vr": "DS", "Value": [217.64]},
        "2690": {"vr": "DS", "Value": [258.1275]},
        "2691": {"vr": "DS", "Value": [93.1225]},
        "2692": {"vr": "DS", "Value": [102.9475]},
        "2693": {"vr": "DS", "Value": [363.435]},
        "2694": {"vr": "DS", "Value": [465.5025]},
        "2695": {"vr": "DS", "Value": [435.7375]},
        "2696": {"vr": "DS", "Value": [82.1275]},
        "2697": {"vr": "DS", "Value": [549.845]},
        "2698": {"vr": "DS", "Value": [364.3125]},
        "2699": {"vr": "DS", "Value": [142.41]},
        "2700": {"vr": "DS", "Value": [35.4925]},
        "2701": {"vr": "DS", "Value": [240.0875]},
        "2702": {"vr": "DS", "Value": [210.8875]},
        "2703": {"vr": "DS", "Value": [565.5425]},
        "2704": {"vr": "DS", "Value": [242.87]},
        "2705": {"vr": "DS", "Value": [54.41]},
        "2706": {"vr": "DS", "Value": [122.3025]},
        "2707": {"vr": "DS", "Value": [541.485]},
        "2708": {"vr": "DS", "Value": [519.7875]},
        "2709": {"vr": "DS", "Value": [491.7575]},
        "2710": {"vr": "DS", "Value": [369.8925]},
        "2711": {"vr": "DS", "Value": [66.7225]},
        "2712": {"vr": "DS", "Value": [230.265]},
        "2713": {"vr": "DS", "Value": [566.5675]},
        "2714": {"vr": "DS", "Value": [510.235]},
        "2715": {"vr": "DS", "Value": [351.1025]},
        "2716": {"vr": "DS", "Value": [357.1225]},
        "2717": {"vr": "DS", "Value": [222.05]},
        "2718": {"vr": "DS", "Value": [22.7225]},
        "2719": {"vr": "DS", "Value": [336.8875]},
        "2720": {"vr": "DS", "Value": [211.2]},
        "2721": {"vr": "DS", "Value": [548.235]},
        "2722": {"vr": "DS", "Value": [218.37]},
        "2723": {"vr": "DS", "Value": [581.825]},
        "2724": {"vr": "DS", "Value": [462.87]},
        "2725": {"vr": "DS", "Value": [449.825]},
        "2726": {"vr": "DS", "Value": [495.5825]},
        "2727": {"vr": "DS", "Value": [253.57]},
        "2728": {"vr": "DS", "Value": [146.8]},
        "2729": {"vr": "DS", "Value": [263.6875]},
        "2730": {"vr": "DS", "Value": [339.815]},
        "2731": {"vr": "DS", "Value": [232.8975]},
        "2732": {"vr": "DS", "Value": [573.9025]},
        "2733": {"vr": "DS", "Value": [542.215]},
        "2734": {"vr": "DS", "Value": [263.5425]},
        "2735": {"vr": "DS", "Value": [91.5125]},
        "2736": {"vr": "DS", "Value": [304.9075]},
        "2737": {"vr": "DS", "Value": [255.64]},
        "2738": {"vr": "DS", "Value": [22.575]},
        "2739": {"vr": "DS", "Value": [338.06]},
        "2740": {"vr": "DS", "Value": [165.2775]},
        "2741": {"vr": "DS", "Value": [592.235]},
        "2742": {"vr": "DS", "Value": [583.435]},
        "2743": {"vr": "DS", "Value": [542.9475]},
        "2744": {"vr": "DS", "Value": [415.3575]},
        "2745": {"vr": "DS", "Value": [29.9125]},
        "2746": {"vr": "DS", "Value": [399.075]},
        "2747": {"vr": "DS", "Value": [468.595]},
        "2748": {"vr": "DS", "Value": [351.395]},
        "2749": {"vr": "DS", "Value": [219.395]},
        "2750": {"vr": "DS", "Value": [106.9175]},
        "2751": {"vr": "DS", "Value": [450.265]},
        "2752": {"vr": "DS", "Value": [145.19]},
        "2753": {"vr": "DS", "Value": [24.04]},
        "2754": {"vr": "DS", "Value": [540.8975]},
        "2755": {"vr": "DS", "Value": [148.1175]},
        "2756": {"vr": "DS", "Value": [505.6975]},
        "2757": {"vr": "DS", "Value": [205.475]},
        "2758": {"vr": "DS", "Value": [61.8925]},
        "2759": {"vr": "DS", "Value": [98.995]},
        "2760": {"vr": "DS", "Value": [354.9275]},
        "2761": {"vr": "DS", "Value": [254.3025]},
        "2762": {"vr": "DS", "Value": [388.225]},
        "2763": {"vr": "DS", "Value": [122.7425]},
        "2764": {"vr": "DS", "Value": [64.82]},
        "2765": {"vr": "DS", "Value": [299.3475]},
        "2766": {"vr": "DS", "Value": [154.8675]},
        "2767": {"vr": "DS", "Value": [309.9025]},
        "2768": {"vr": "DS", "Value": [389.25]},
        "2769": {"vr": "DS", "Value": [84.175]},
        "2770": {"vr": "DS", "Value": [397.61]},
        "2771": {"vr": "DS", "Value": [39.2975]},
        "2772": {"vr": "DS", "Value": [88.7325]},
        "2773": {"vr": "DS", "Value": [515.5225]},
        "2774": {"vr": "DS", "Value": [255.3475]},
        "2775": {"vr": "DS", "Value": [18.9175]},
        "2776": {"vr": "DS", "Value": [76.5475]},
        "2777": {"vr": "DS", "Value": [401.5625]},
        "2778": {"vr": "DS", "Value": [309.3175]},
        "2779": {"vr": "DS", "Value": [455.0925]},
        "2780": {"vr": "DS", "Value": [342.7425]},
        "2781": {"vr": "DS", "Value": [591.7975]},
        "2782": {"vr": "DS", "Value": [130.9575]},
        "2783": {"vr": "DS", "Value": [83.1525]},
        "2784": {"vr": "DS", "Value": [246.235]},
        "2785": {"vr": "DS", "Value": [308.7325]},
        "2786": {"vr": "DS", "Value": [282.9175]},
        "2787": {"vr": "DS", "Value": [556.7425]},
        "2788": {"vr": "DS", "Value": [356.5375]},
        "2789": {"vr": "DS", "Value": [388.81]},
        "2790": {"vr": "DS", "Value": [134.78]},
        "2791": {"vr": "DS", "Value": [423.1325]},
        "2792": {"vr": "DS", "Value": [495.435]},
        "2793": {"vr": "DS", "Value": [457.6]},
        "2794": {"vr": "DS", "Value": [186.41]},
        "2795": {"vr": "DS", "Value": [153.99]},
        "2796": {"vr": "DS", "Value": [334.0875]},
        "2797": {"vr": "DS", "Value": [403.465]},
        "2798": {"vr": "DS", "Value": [445.415]},
        "2799": {"vr": "DS", "Value": [510.695]},
        "2800": {"vr": "DS", "Value": [406.265]},
        "2801": {"vr": "DS", "Value": [233.045]},
        "2802": {"vr": "DS", "Value": [546.04]},
        "2803": {"vr": "DS", "Value": [274.5575]},
        "2804": {"vr": "DS", "Value": [339.3775]},
        "2805": {"vr": "DS", "Value": [382.4975]},
        "2806": {"vr": "DS", "Value": [96.9475]},
        "2807": {"vr": "DS", "Value": [557.62]},
        "2808": {"vr": "DS", "Value": [540.1675]},
        "2809": {"vr": "DS", "Value": [246.4]},
        "2810": {"vr": "DS", "Value": [333.065]},
        "2811": {"vr": "DS", "Value": [589.2875]},
        "2812": {"vr": "DS", "Value": [275.2875]},
        "2813": {"vr": "DS", "Value": [163.815]},
        "2814": {"vr": "DS", "Value": [57.9225]},
        "2815": {"vr": "DS", "Value": [338.205]},
        "2816": {"vr": "DS", "Value": [125.1025]},
        "2817": {"vr": "DS", "Value": [371.5025]},
        "2818": {"vr": "DS", "Value": [205.7675]},
        "2819": {"vr": "DS", "Value": [537.24]},
        "2820": {"vr": "DS", "Value": [283.3575]},
        "2821": {"vr": "DS", "Value": [539.875]},
        "2822": {"vr": "DS", "Value": [396.1475]},
        "2823": {"vr": "DS", "Value": [527.25]},
        "2824": {"vr": "DS", "Value": [527.835]},
        "2825": {"vr": "DS", "Value": [201.5025]},
        "2826": {"vr": "DS", "Value": [54.265]},
        "2827": {"vr": "DS", "Value": [144.7525]},
        "2828": {"vr": "DS", "Value": [549.6975]},
        "2829": {"vr": "DS", "Value": [475.3475]},
        "2830": {"vr": "DS", "Value": [307.5425]},
        "2831": {"vr": "DS", "Value": [509.3575]},
        "2832": {"vr": "DS", "Value": [356.83]},
        "2833": {"vr": "DS", "Value": [276.7525]},
        "2834": {"vr": "DS", "Value": [375.8925]},
        "2835": {"vr": "DS", "Value": [238.7725]},
        "2836": {"vr": "DS", "Value": [359.025]},
        "2837": {"vr": "DS", "Value": [120.4]},
        "2838": {"vr": "DS", "Value": [199.6]},
        "2839": {"vr": "DS", "Value": [331.3075]},
        "2840": {"vr": "DS", "Value": [268.6825]},
        "2841": {"vr": "DS", "Value": [460.09]},
        "2842": {"vr": "DS", "Value": [455.385]},
        "2843": {"vr": "DS", "Value": [271.9025]},
        "2844": {"vr": "DS", "Value": [156.04]},
        "2845": {"vr": "DS", "Value": [194.04]},
        "2846": {"vr": "DS", "Value": [166.01]},
        "2847": {"vr": "DS", "Value": [507.1625]},
        "2848": {"vr": "DS", "Value": [571.6875]},
        "2849": {"vr": "DS", "Value": [487.805]},
        "2850": {"vr": "DS", "Value": [393.785]},
        "2851": {"vr": "DS", "Value": [449.9725]},
        "2852": {"vr": "DS", "Value": [299.4925]},
        "2853": {"vr": "DS", "Value": [141.385]},
        "2854": {"vr": "DS", "Value": [185.24]},
        "2855": {"vr": "DS", "Value": [0.44]},
        "2856": {"vr": "DS", "Value": [240.38]},
        "2857": {"vr": "DS", "Value": [188.1675]},
        "2858": {"vr": "DS", "Value": [233.63]},
        "2859": {"vr": "DS", "Value": [437.3475]},
        "2860": {"vr": "DS", "Value": [487.9525]},
        "2861": {"vr": "DS", "Value": [171.005]},
        "2862": {"vr": "DS", "Value": [5.7075]},
        "2863": {"vr": "DS", "Value": [293.035]},
        "2864": {"vr": "DS", "Value": [72.7425]},
        "2865": {"vr": "DS", "Value": [455.9725]},
        "2866": {"vr": "DS", "Value": [189.775]},
        "2867": {"vr": "DS", "Value": [422.0875]},
        "2868": {"vr": "DS", "Value": [503.9425]},
        "2869": {"vr": "DS", "Value": [186.5575]},
        "2870": {"vr": "DS", "Value": [140.3425]},
        "2871": {"vr": "DS", "Value": [29.4725]},
        "2872": {"vr": "DS", "Value": [461.26]},
        "2873": {"vr": "DS", "Value": [415.795]},
        "2874": {"vr": "DS", "Value": [227.025]},
        "2875": {"vr": "DS", "Value": [534.1475]},
        "2876": {"vr": "DS", "Value": [284.82]},
        "2877": {"vr": "DS", "Value": [345.6875]},
        "2878": {"vr": "DS", "Value": [493.3875]},
        "2879": {"vr": "DS", "Value": [348.3225]},
        "2880": {"vr": "DS", "Value": [344.225]},
        "2881": {"vr": "DS", "Value": [278.655]},
        "2882": {"vr": "DS", "Value": [108.82]},
        "2883": {"vr": "DS", "Value": [68.625]},
        "2884": {"vr": "DS", "Value": [53.825]},
        "2885": {"vr": "DS", "Value": [221.7575]},
        "2886": {"vr": "DS", "Value": [334.84]},
        "2887": {"vr": "DS", "Value": [246.5475]},
        "2888": {"vr": "DS", "Value": [241.6975]},
        "2889": {"vr": "DS", "Value": [573.1725]},
        "2890": {"vr": "DS", "Value": [87.25]},
        "2891": {"vr": "DS", "Value": [126.1275]},
        "2892": {"vr": "DS", "Value": [484.7325]},
        "2893": {"vr": "DS", "Value": [190.655]},
        "2894": {"vr": "DS", "Value": [290.235]},
        "2895": {"vr": "DS", "Value": [41.2]},
        "2896": {"vr": "DS", "Value": [509.21]},
        "2897": {"vr": "DS", "Value": [273.0925]},
        "2898": {"vr": "DS", "Value": [322.8]},
        "2899": {"vr": "DS", "Value": [157.21]},
        "2900": {"vr": "DS", "Value": [372.675]},
        "2901": {"vr": "DS", "Value": [72.3025]},
        "2902": {"vr": "DS", "Value": [538.1175]},
        "2903": {"vr": "DS", "Value": [381.035]},
        "2904": {"vr": "DS", "Value": [374.2825]},
        "2905": {"vr": "DS", "Value": [167.64]},
        "2906": {"vr": "DS", "Value": [1.465]},
        "2907": {"vr": "DS", "Value": [590.48]},
        "2908": {"vr": "DS", "Value": [92.83]},
        "2909": {"vr": "DS", "Value": [557.035]},
        "2910": {"vr": "DS", "Value": [185.0925]},
        "2911": {"vr": "DS", "Value": [537.3875]},
        "2912": {"vr": "DS", "Value": [76.985]},
        "2913": {"vr": "DS", "Value": [260.175]},
        "2914": {"vr": "DS", "Value": [90.4875]},
        "2915": {"vr": "DS", "Value": [329.26]},
        "2916": {"vr": "DS", "Value": [300.81]},
        "2917": {"vr": "DS", "Value": [184.635]},
        "2918": {"vr": "DS", "Value": [5.2675]},
        "2919": {"vr": "DS", "Value": [596.04]},
        "2920": {"vr": "DS", "Value": [438.81]},
        "2921": {"vr": "DS", "Value": [390.42]},
        "2922": {"vr": "DS", "Value": [413.1425]},
        "2923": {"vr": "DS", "Value": [301.9825]},
        "2924": {"vr": "DS", "Value": [378.9875]},
        "2925": {"vr": "DS", "Value": [57.045]},
        "2926": {"vr": "DS", "Value": [116.01]},
        "2927": {"vr": "DS", "Value": [481.9325]},
        "2928": {"vr": "DS", "Value": [168.9575]},
        "2929": {"vr": "DS", "Value": [25.0625]},
        "2930": {"vr": "DS", "Value": [110.1375]},
        "2931": {"vr": "DS", "Value": [586.215]},
        "2932": {"vr": "DS", "Value": [568.47]},
        "2933": {"vr": "DS", "Value": [90.635]},
        "2934": {"vr": "DS", "Value": [352.1475]},
        "2935": {"vr": "DS", "Value": [114.0875]},
        "2936": {"vr": "DS", "Value": [417.845]},
        "2937": {"vr": "DS", "Value": [484.44]},
        "2938": {"vr": "DS", "Value": [486.635]},
        "2939": {"vr": "DS", "Value": [221.9025]},
        "2940": {"vr": "DS", "Value": [249.475]},
        "2941": {"vr": "DS", "Value": [143.7275]},
        "2942": {"vr": "DS", "Value": [516.6925]},
        "2943": {"vr": "DS", "Value": [412.41]},
        "2944": {"vr": "DS", "Value": [544.41]},
        "2945": {"vr": "DS", "Value": [587.825]},
        "2946": {"vr": "DS", "Value": [203.28]},
        "2947": {"vr": "DS", "Value": [487.075]},
        "2948": {"vr": "DS", "Value": [276.46]},
        "2949": {"vr": "DS", "Value": [4.83]},
        "2950": {"vr": "DS", "Value": [122.595]},
        "2951": {"vr": "DS", "Value": [362.1175]},
        "2952": {"vr": "DS", "Value": [543.9725]},
        "2953": {"vr": "DS", "Value": [241.5525]},
        "2954": {"vr": "DS", "Value": [305.055]},
        "2955": {"vr": "DS", "Value": [404.195]},
        "2956": {"vr": "DS", "Value": [437.64]},
        "2957": {"vr": "DS", "Value": [85.055]},
        "2958": {"vr": "DS", "Value": [91.9525]},
        "2959": {"vr": "DS", "Value": [161.475]},
        "2960": {"vr": "DS", "Value": [177.61]},
        "2961": {"vr": "DS", "Value": [167.3475]},
        "2962": {"vr": "DS", "Value": [166.3025]},
        "2963": {"vr": "DS", "Value": [512.1575]},
        "2964": {"vr": "DS", "Value": [116.3025]},
        "2965": {"vr": "DS", "Value": [504.675]},
        "2966": {"vr": "DS", "Value": [223.5125]},
        "2967": {"vr": "DS", "Value": [63.065]},
        "2968": {"vr": "DS", "Value": [209.2775]},
        "2969": {"vr": "DS", "Value": [124.9575]},
        "2970": {"vr": "DS", "Value": [464.4775]},
        "2971": {"vr": "DS", "Value": [584.02]},
        "2972": {"vr": "DS", "Value": [507.455]},
        "2973": {"vr": "DS", "Value": [335.865]},
        "2974": {"vr": "DS", "Value": [126.2725]},
        "2975": {"vr": "DS", "Value": [45.9025]},
        "2976": {"vr": "DS", "Value": [164.1075]},
        "2977": {"vr": "DS", "Value": [355.075]},
        "2978": {"vr": "DS", "Value": [91.0725]},
        "2979": {"vr": "DS", "Value": [470.4975]},
        "2980": {"vr": "DS", "Value": [318.41]},
        "2981": {"vr": "DS", "Value": [441.3175]},
        "2982": {"vr": "DS", "Value": [367.97]},
        "2983": {"vr": "DS", "Value": [77.57]},
        "2984": {"vr": "DS", "Value": [475.495]},
        "2985": {"vr": "DS", "Value": [210.7425]},
        "2986": {"vr": "DS", "Value": [200.9175]},
        "2987": {"vr": "DS", "Value": [373.99]},
        "2988": {"vr": "DS", "Value": [380.595]},
        "2989": {"vr": "DS", "Value": [453.3375]},
        "2990": {"vr": "DS", "Value": [35.2]},
        "2991": {"vr": "DS", "Value": [410.655]},
        "2992": {"vr": "DS", "Value": [380.7425]},
        "2993": {"vr": "DS", "Value": [320.3125]},
        "2994": {"vr": "DS", "Value": [460.5275]},
        "2995": {"vr": "DS", "Value": [519.035]},
        "2996": {"vr": "DS", "Value": [266.4875]},
        "2997": {"vr": "DS", "Value": [174.6625]},
        "2998": {"vr": "DS", "Value": [337.035]},
        "2999": {"vr": "DS", "Value": [321.3375]},
        "3000": {"vr": "DS", "Value": [468.3025]},
        "3001": {"vr": "DS", "Value": [76.84]},
        "3002": {"vr": "DS", "Value": [508.625]},
        "3003": {"vr": "DS", "Value": [377.3575]},
        "3004": {"vr": "DS", "Value": [445.27]},
        "3005": {"vr": "DS", "Value": [590.9175]},
        "3006": {"vr": "DS", "Value": [444.39]},
        "3007": {"vr": "DS", "Value": [477.9825]},
        "3008": {"vr": "DS", "Value": [66.2825]},
        "3009": {"vr": "DS", "Value": [117.3275]},
        "3010": {"vr": "DS", "Value": [429.1325]},
        "3011": {"vr": "DS", "Value": [221.1725]},
        "3012": {"vr": "DS", "Value": [227.4625]},
        "3013": {"vr": "DS", "Value": [138.2925]},
        "3014": {"vr": "DS", "Value": [576.5375]},
        "3015": {"vr": "DS", "Value": [249.3275]},
        "3016": {"vr": "DS", "Value": [287.455]},
        "3017": {"vr": "DS", "Value": [340.4]},
        "3018": {"vr": "DS", "Value": [521.5425]},
        "3019": {"vr": "DS", "Value": [7.025]},
        "3020": {"vr": "DS", "Value": [251.815]},
        "3021": {"vr": "DS", "Value": [330.2825]},
        "3022": {"vr": "DS", "Value": [199.3075]},
        "3023": {"vr": "DS", "Value": [378.5475]},
        "3024": {"vr": "DS", "Value": [328.235]},
        "3025": {"vr": "DS", "Value": [470.79]},
        "3026": {"vr": "DS", "Value": [23.6]},
        "3027": {"vr": "DS", "Value": [133.025]},
        "3028": {"vr": "DS", "Value": [264.88]},
        "3029": {"vr": "DS", "Value": [403.61]},
        "3030": {"vr": "DS", "Value": [477.69]},
        "3031": {"vr": "DS", "Value": [487.66]},
        "3032": {"vr": "DS", "Value": [579.61]},
        "3033": {"vr": "DS", "Value": [97.6775]},
        "3034": {"vr": "DS", "Value": [176.2925]},
        "3035": {"vr": "DS", "Value": [233.3375]},
        "3036": {"vr": "DS", "Value": [513.62]},
        "3037": {"vr": "DS", "Value": [348.47]},
        "3038": {"vr": "DS", "Value": [101.775]},
        "3039": {"vr": "DS", "Value": [101.3375]},
        "3040": {"vr": "DS", "Value": [102.0675]},
        "3041": {"vr": "DS", "Value": [164.255]},
        "3042": {"vr": "DS", "Value": [374.43]},
        "3043": {"vr": "DS", "Value": [456.1175]},
        "3044": {"vr": "DS", "Value": [489.1225]},
        "3045": {"vr": "DS", "Value": [81.835]},
        "3046": {"vr": "DS", "Value": [132.88]},
        "3047": {"vr": "DS", "Value": [275.1425]},
        "3048": {"vr": "DS", "Value": [251.0825]},
        "3049": {"vr": "DS", "Value": [549.1125]},
        "3050": {"vr": "DS", "Value": [386.45]},
        "3051": {"vr": "DS", "Value": [321.63]},
        "3052": {"vr": "DS", "Value": [147.825]},
        "3053": {"vr": "DS", "Value": [105.6]},
        "3054": {"vr": "DS", "Value": [489.5625]},
        "3055": {"vr": "DS", "Value": [50.8775]},
        "3056": {"vr": "DS", "Value": [534.44]},
        "3057": {"vr": "DS", "Value": [61.6]},
        "3058": {"vr": "DS", "Value": [140.195]},
        "3059": {"vr": "DS", "Value": [140.4875]},
        "3060": {"vr": "DS", "Value": [385.2775]},
        "3061": {"vr": "DS", "Value": [197.6975]},
        "3062": {"vr": "DS", "Value": [560.84]},
        "3063": {"vr": "DS", "Value": [529.465]},
        "3064": {"vr": "DS", "Value": [260.03]},
        "3065": {"vr": "DS", "Value": [371.3575]},
        "3066": {"vr": "DS", "Value": [438.225]},
        "3067": {"vr": "DS", "Value": [315.465]},
        "3068": {"vr": "DS", "Value": [418.43]},
        "3069": {"vr": "DS", "Value": [326.1875]},
        "3070": {"vr": "DS", "Value": [563.3475]},
        "3071": {"vr": "DS", "Value": [313.27]},
        "3072": {"vr": "DS", "Value": [402.0]},
        "3073": {"vr": "DS", "Value": [153.6975]},
        "3074": {"vr": "DS", "Value": [106.3325]},
        "3075": {"vr": "DS", "Value": [575.22]},
        "3076": {"vr": "DS", "Value": [36.665]},
        "3077": {"vr": "DS", "Value": [398.7825]},
        "3078": {"vr": "DS", "Value": [337.7675]},
        "3079": {"vr": "DS", "Value": [253.7175]},
        "3080": {"vr": "DS", "Value": [45.61]},
        "3081": {"vr": "DS", "Value": [508.9175]},
        "3082": {"vr": "DS", "Value": [528.44]},
        "3083": {"vr": "DS", "Value": [226.0]},
        "3084": {"vr": "DS", "Value": [336.45]},
        "3085": {"vr": "DS", "Value": [225.855]},
        "3086": {"vr": "DS", "Value": [335.7175]},
        "3087": {"vr": "DS", "Value": [39.7375]},
        "3088": {"vr": "DS", "Value": [444.83]},
        "3089": {"vr": "DS", "Value": [2.78]},
        "3090": {"vr": "DS", "Value": [536.8025]},
        "3091": {"vr": "DS", "Value": [367.24]},
        "3092": {"vr": "DS", "Value": [110.575]},
        "3093": {"vr": "DS", "Value": [169.5425]},
        "3094": {"vr": "DS", "Value": [461.1125]},
        "3095": {"vr": "DS", "Value": [457.895]},
        "3096": {"vr": "DS", "Value": [352.44]},
        "3097": {"vr": "DS", "Value": [308.1475]},
        "3098": {"vr": "DS", "Value": [257.6875]},
        "3099": {"vr": "DS", "Value": [201.21]},
        "3100": {"vr": "DS", "Value": [141.5325]},
        "3101": {"vr": "DS", "Value": [190.0675]},
        "3102": {"vr": "DS", "Value": [399.22]},
        "3103": {"vr": "DS", "Value": [389.6875]},
        "3104": {"vr": "DS", "Value": [370.625]},
        "3105": {"vr": "DS", "Value": [245.9425]},
        "3106": {"vr": "DS", "Value": [174.5175]},
        "3107": {"vr": "DS", "Value": [536.4875]},
        "3108": {"vr": "DS", "Value": [586.655]},
        "3109": {"vr": "DS", "Value": [564.5175]},
        "3110": {"vr": "DS", "Value": [235.0925]},
        "3111": {"vr": "DS", "Value": [190.3625]},
        "3112": {"vr": "DS", "Value": [192.2625]},
        "3113": {"vr": "DS", "Value": [444.245]},
        "3114": {"vr": "DS", "Value": [179.22]},
        "3115": {"vr": "DS", "Value": [20.9675]},
        "3116": {"vr": "DS", "Value": [114.4]},
        "3117": {"vr": "DS", "Value": [234.07]},
        "3118": {"vr": "DS", "Value": [235.97]},
        "3119": {"vr": "DS", "Value": [104.41]},
        "3120": {"vr": "DS", "Value": [566.42]},
        "3121": {"vr": "DS", "Value": [228.635]},
        "3122": {"vr": "DS", "Value": [81.5425]},
        "3123": {"vr": "DS", "Value": [483.395]},
        "3124": {"vr": "DS", "Value": [36.0775]},
        "3125": {"vr": "DS", "Value": [460.3825]},
        "3126": {"vr": "DS", "Value": [485.025]},
        "3127": {"vr": "DS", "Value": [420.04]},
        "3128": {"vr": "DS", "Value": [478.86]},
        "3129": {"vr": "DS", "Value": [60.555]},
        "3130": {"vr": "DS", "Value": [178.195]},
        "3131": {"vr": "DS", "Value": [211.64]},
        "3132": {"vr": "DS", "Value": [5.415]},
        "3133": {"vr": "DS", "Value": [428.84]},
        "3134": {"vr": "DS", "Value": [326.3325]},
        "3135": {"vr": "DS", "Value": [520.3725]},
        "3136": {"vr": "DS", "Value": [36.225]},
        "3137": {"vr": "DS", "Value": [547.21]},
        "3138": {"vr": "DS", "Value": [53.24]},
        "3139": {"vr": "DS", "Value": [33.2775]},
        "3140": {"vr": "DS", "Value": [334.6925]},
        "3141": {"vr": "DS", "Value": [180.83]},
        "3142": {"vr": "DS", "Value": [501.895]},
        "3143": {"vr": "DS", "Value": [85.9325]},
        "3144": {"vr": "DS", "Value": [135.3675]},
        "3145": {"vr": "DS", "Value": [26.5475]},
        "3146": {"vr": "DS", "Value": [315.61]},
        "3147": {"vr": "DS", "Value": [138.7325]},
        "3148": {"vr": "DS", "Value": [174.37]},
        "3149": {"vr": "DS", "Value": [409.045]},
        "3150": {"vr": "DS", "Value": [338.79]},
        "3151": {"vr": "DS", "Value": [117.7675]},
        "3152": {"vr": "DS", "Value": [355.22]},
        "3153": {"vr": "DS", "Value": [474.1575]},
        "3154": {"vr": "DS", "Value": [167.2]},
        "3155": {"vr": "DS", "Value": [561.865]},
        "3156": {"vr": "DS", "Value": [140.8]},
        "3157": {"vr": "DS", "Value": [465.795]},
        "3158": {"vr": "DS", "Value": [318.265]},
        "3159": {"vr": "DS", "Value": [172.4675]},
        "3160": {"vr": "DS", "Value": [7.3175]},
        "3161": {"vr": "DS", "Value": [298.1575]},
        "3162": {"vr": "DS", "Value": [278.3625]},
        "3163": {"vr": "DS", "Value": [67.3075]},
        "3164": {"vr": "DS", "Value": [152.675]},
        "3165": {"vr": "DS", "Value": [1.61]},
        "3166": {"vr": "DS", "Value": [98.1175]},
        "3167": {"vr": "DS", "Value": [90.05]},
        "3168": {"vr": "DS", "Value": [471.815]},
        "3169": {"vr": "DS", "Value": [298.8875]},
        "3170": {"vr": "DS", "Value": [580.4875]},
        "3171": {"vr": "DS", "Value": [319.5825]},
        "3172": {"vr": "DS", "Value": [595.6]},
        "3173": {"vr": "DS", "Value": [505.845]},
        "3174": {"vr": "DS", "Value": [193.2875]},
        "3175": {"vr": "DS", "Value": [297.2775]},
        "3176": {"vr": "DS", "Value": [588.85]},
        "3177": {"vr": "DS", "Value": [255.4925]},
        "3178": {"vr": "DS", "Value": [364.605]},
        "3179": {"vr": "DS", "Value": [241.99]},
        "3180": {"vr": "DS", "Value": [466.695]},
        "3181": {"vr": "DS", "Value": [476.81]},
        "3182": {"vr": "DS", "Value": [472.985]},
        "3183": {"vr": "DS", "Value": [173.4925]},
        "3184": {"vr": "DS", "Value": [101.4825]},
        "3185": {"vr": "DS", "Value": [478.1275]},
        "3186": {"vr": "DS", "Value": [432.3725]},
        "3187": {"vr": "DS", "Value": [257.1025]},
        "3188": {"vr": "DS", "Value": [161.7675]},
        "3189": {"vr": "DS", "Value": [162.645]},
        "3190": {"vr": "DS", "Value": [529.3175]},
        "3191": {"vr": "DS", "Value": [487.3675]},
        "3192": {"vr": "DS", "Value": [373.845]},
        "3193": {"vr": "DS", "Value": [302.7125]},
        "3194": {"vr": "DS", "Value": [7.61]},
        "3195": {"vr": "DS", "Value": [264.5875]},
        "3196": {"vr": "DS", "Value": [99.58]},
        "3197": {"vr": "DS", "Value": [466.4]},
        "3198": {"vr": "DS", "Value": [313.7075]},
        "3199": {"vr": "DS", "Value": [239.065]},
        "3200": {"vr": "DS", "Value": [24.3325]},
        "3201": {"vr": "DS", "Value": [463.6]},
        "3202": {"vr": "DS", "Value": [581.9725]},
        "3203": {"vr": "DS", "Value": [281.2875]},
        "3204": {"vr": "DS", "Value": [282.48]},
        "3205": {"vr": "DS", "Value": [578.2925]},
        "3206": {"vr": "DS", "Value": [93.855]},
        "3207": {"vr": "DS", "Value": [238.185]},
        "3208": {"vr": "DS", "Value": [257.835]},
        "3209": {"vr": "DS", "Value": [439.5425]},
        "3210": {"vr": "DS", "Value": [88.8775]},
        "3211": {"vr": "DS", "Value": [346.42]},
        "3212": {"vr": "DS", "Value": [294.4975]},
        "3213": {"vr": "DS", "Value": [486.05]},
        "3214": {"vr": "DS", "Value": [593.845]},
        "3215": {"vr": "DS", "Value": [534.585]},
        "3216": {"vr": "DS", "Value": [408.8975]},
        "3217": {"vr": "DS", "Value": [84.615]},
        "3218": {"vr": "DS", "Value": [4.39]},
        "3219": {"vr": "DS", "Value": [161.18]},
        "3220": {"vr": "DS", "Value": [311.3675]},
        "3221": {"vr": "DS", "Value": [129.9325]},
        "3222": {"vr": "DS", "Value": [523.7375]},
        "3223": {"vr": "DS", "Value": [233.4825]},
        "3224": {"vr": "DS", "Value": [21.845]},
        "3225": {"vr": "DS", "Value": [393.3475]},
        "3226": {"vr": "DS", "Value": [381.62]},
        "3227": {"vr": "DS", "Value": [160.595]},
        "3228": {"vr": "DS", "Value": [436.47]},
        "3229": {"vr": "DS", "Value": [80.0775]},
        "3230": {"vr": "DS", "Value": [207.23]},
        "3231": {"vr": "DS", "Value": [414.9175]},
        "3232": {"vr": "DS", "Value": [159.5725]},
        "3233": {"vr": "DS", "Value": [563.9325]},
        "3234": {"vr": "DS", "Value": [169.1025]},
        "3235": {"vr": "DS", "Value": [390.275]},
        "3236": {"vr": "DS", "Value": [230.41]},
        "3237": {"vr": "DS", "Value": [268.0975]},
        "3238": {"vr": "DS", "Value": [522.86]},
        "3239": {"vr": "DS", "Value": [476.9575]},
        "3240": {"vr": "DS", "Value": [586.5075]},
        "3241": {"vr": "DS", "Value": [442.9275]},
        "3242": {"vr": "DS", "Value": [155.455]},
        "3243": {"vr": "DS", "Value": [306.5175]},
        "3244": {"vr": "DS", "Value": [90.3425]},
        "3245": {"vr": "DS", "Value": [22.43]},
        "3246": {"vr": "DS", "Value": [515.085]},
        "3247": {"vr": "DS", "Value": [257.98]},
        "3248": {"vr": "DS", "Value": [386.1575]},
        "3249": {"vr": "DS", "Value": [228.05]},
        "3250": {"vr": "DS", "Value": [517.865]},
        "3251": {"vr": "DS", "Value": [350.9575]},
        "3252": {"vr": "DS", "Value": [345.25]},
        "3253": {"vr": "DS", "Value": [481.64]},
        "3254": {"vr": "DS", "Value": [501.7475]},
        "3255": {"vr": "DS", "Value": [588.5575]},
        "3256": {"vr": "DS", "Value": [402.1475]},
        "3257": {"vr": "DS", "Value": [473.1325]},
        "3258": {"vr": "DS", "Value": [304.47]},
        "3259": {"vr": "DS", "Value": [59.6775]},
        "3260": {"vr": "DS", "Value": [336.595]},
        "3261": {"vr": "DS", "Value": [251.23]},
        "3262": {"vr": "DS", "Value": [255.9325]},
        "3263": {"vr": "DS", "Value": [199.455]},
        "3264": {"vr": "DS", "Value": [306.665]},
        "3265": {"vr": "DS", "Value": [522.275]},
        "3266": {"vr": "DS", "Value": [543.385]},
        "3267": {"vr": "DS", "Value": [258.7125]},
        "3268": {"vr": "DS", "Value": [201.795]},
        "3269": {"vr": "DS", "Value": [440.7325]},
        "3270": {"vr": "DS", "Value": [591.3575]},
        "3271": {"vr": "DS", "Value": [166.45]},
        "3272": {"vr": "DS", "Value": [548.3825]},
        "3273": {"vr": "DS", "Value": [573.7575]},
        "3274": {"vr": "DS", "Value": [587.0925]},
        "3275": {"vr": "DS", "Value": [143.8725]},
        "3276": {"vr": "DS", "Value": [153.1125]},
        "3277": {"vr": "DS", "Value": [337.3275]},
        "3278": {"vr": "DS", "Value": [514.06]},
        "3279": {"vr": "DS", "Value": [515.23]},
        "3280": {"vr": "DS", "Value": [208.4]},
        "3281": {"vr": "DS", "Value": [160.3025]},
        "3282": {"vr": "DS", "Value": [199.8925]},
        "3283": {"vr": "DS", "Value": [95.755]},
        "3284": {"vr": "DS", "Value": [415.65]},
        "3285": {"vr": "DS", "Value": [344.81]},
        "3286": {"vr": "DS", "Value": [375.1625]},
        "3287": {"vr": "DS", "Value": [503.65]},
        "3288": {"vr": "DS", "Value": [173.2]},
        "3289": {"vr": "DS", "Value": [96.4875]},
        "3290": {"vr": "DS", "Value": [91.3675]},
        "3291": {"vr": "DS", "Value": [351.6875]},
        "3292": {"vr": "DS", "Value": [564.3725]},
        "3293": {"vr": "DS", "Value": [290.0875]},
        "3294": {"vr": "DS", "Value": [327.5025]},
        "3295": {"vr": "DS", "Value": [372.235]},
        "3296": {"vr": "DS", "Value": [156.77]},
        "3297": {"vr": "DS", "Value": [153.26]},
        "3298": {"vr": "DS", "Value": [229.385]},
        "3299": {"vr": "DS", "Value": [83.2975]},
        "3300": {"vr": "DS", "Value": [272.635]},
        "3301": {"vr": "DS", "Value": [285.5525]},
        "3302": {"vr": "DS", "Value": [371.9425]},
        "3303": {"vr": "DS", "Value": [584.7525]},
        "3304": {"vr": "DS", "Value": [130.81]},
        "3305": {"vr": "DS", "Value": [266.635]},
        "3306": {"vr": "DS", "Value": [552.7725]},
        "3307": {"vr": "DS", "Value": [61.2875]},
        "3308": {"vr": "DS", "Value": [185.68]},
        "3309": {"vr": "DS", "Value": [428.255]},
        "3310": {"vr": "DS", "Value": [54.7025]},
        "3311": {"vr": "DS", "Value": [217.055]},
        "3312": {"vr": "DS", "Value": [368.995]},
        "3313": {"vr": "DS", "Value": [19.065]},
        "3314": {"vr": "DS", "Value": [276.8975]},
        "3315": {"vr": "DS", "Value": [307.835]},
        "3316": {"vr": "DS", "Value": [140.635]},
        "3317": {"vr": "DS", "Value": [530.49]},
        "3318": {"vr": "DS", "Value": [319.1425]},
        "3319": {"vr": "DS", "Value": [482.81]},
        "3320": {"vr": "DS", "Value": [554.0875]},
        "3321": {"vr": "DS", "Value": [447.61]},
        "3322": {"vr": "DS", "Value": [384.255]},
        "3323": {"vr": "DS", "Value": [333.9425]},
        "3324": {"vr": "DS", "Value": [294.06]},
        "3325": {"vr": "DS", "Value": [135.22]},
        "3326": {"vr": "DS", "Value": [227.9025]},
        "3327": {"vr": "DS", "Value": [271.7575]},
        "3328": {"vr": "DS", "Value": [495.29]},
        "3329": {"vr": "DS", "Value": [179.5125]},
        "3330": {"vr": "DS", "Value": [51.755]},
        "3331": {"vr": "DS", "Value": [582.7025]},
        "3332": {"vr": "DS", "Value": [538.995]},
        "3333": {"vr": "DS", "Value": [183.7575]},
        "3334": {"vr": "DS", "Value": [354.4875]},
        "3335": {"vr": "DS", "Value": [284.0875]},
        "3336": {"vr": "DS", "Value": [100.46]},
        "3337": {"vr": "DS", "Value": [17.6]},
        "3338": {"vr": "DS", "Value": [123.9325]},
        "3339": {"vr": "DS", "Value": [363.7275]},
        "3340": {"vr": "DS", "Value": [272.8]},
        "3341": {"vr": "DS", "Value": [388.5175]},
        "3342": {"vr": "DS", "Value": [476.225]},
        "3343": {"vr": "DS", "Value": [303.445]},
        "3344": {"vr": "DS", "Value": [32.84]},
        "3345": {"vr": "DS", "Value": [367.0925]},
        "3346": {"vr": "DS", "Value": [521.1025]},
        "3347": {"vr": "DS", "Value": [206.06]},
        "3348": {"vr": "DS", "Value": [239.3575]},
        "3349": {"vr": "DS", "Value": [559.9625]},
        "3350": {"vr": "DS", "Value": [123.2]},
        "3351": {"vr": "DS", "Value": [80.81]},
        "3352": {"vr": "DS", "Value": [163.23]},
        "3353": {"vr": "DS", "Value": [504.9675]},
        "3354": {"vr": "DS", "Value": [241.405]},
        "3355": {"vr": "DS", "Value": [294.645]},
        "3356": {"vr": "DS", "Value": [321.775]},
        "3357": {"vr": "DS", "Value": [40.76]},
        "3358": {"vr": "DS", "Value": [182.0]},
        "3359": {"vr": "DS", "Value": [533.1225]},
        "3360": {"vr": "DS", "Value": [513.1825]},
        "3361": {"vr": "DS", "Value": [231.1425]},
        "3362": {"vr": "DS", "Value": [264.7325]},
        "3363": {"vr": "DS", "Value": [518.7425]},
        "3364": {"vr": "DS", "Value": [463.455]},
        "3365": {"vr": "DS", "Value": [594.7225]},
        "3366": {"vr": "DS", "Value": [557.475]},
        "3367": {"vr": "DS", "Value": [522.42]},
        "3368": {"vr": "DS", "Value": [130.225]},
        "3369": {"vr": "DS", "Value": [452.3125]},
        "3370": {"vr": "DS", "Value": [406.1175]},
        "3371": {"vr": "DS", "Value": [260.47]},
        "3372": {"vr": "DS", "Value": [459.3575]},
        "3373": {"vr": "DS", "Value": [427.9625]},
        "3374": {"vr": "DS", "Value": [344.5175]},
        "3375": {"vr": "DS", "Value": [447.1725]},
        "3376": {"vr": "DS", "Value": [206.645]},
        "3377": {"vr": "DS", "Value": [468.7425]},
        "3378": {"vr": "DS", "Value": [237.2875]},
        "3379": {"vr": "DS", "Value": [309.7575]},
        "3380": {"vr": "DS", "Value": [160.45]},
        "3381": {"vr": "DS", "Value": [433.835]},
        "3382": {"vr": "DS", "Value": [303.2975]},
        "3383": {"vr": "DS", "Value": [68.4775]},
        "3384": {"vr": "DS", "Value": [300.9575]},
        "3385": {"vr": "DS", "Value": [186.85]},
        "3386": {"vr": "DS", "Value": [427.67]},
        "3387": {"vr": "DS", "Value": [582.5575]},
        "3388": {"vr": "DS", "Value": [289.21]},
        "3389": {"vr": "DS", "Value": [493.9725]},
        "3390": {"vr": "DS", "Value": [506.87]},
        "3391": {"vr": "DS", "Value": [195.21]},
        "3392": {"vr": "DS", "Value": [172.7625]},
        "3393": {"vr": "DS", "Value": [298.3025]},
        "3394": {"vr": "DS", "Value": [53.6775]},
        "3395": {"vr": "DS", "Value": [427.815]},
        "3396": {"vr": "DS", "Value": [127.2975]},
        "3397": {"vr": "DS", "Value": [186.995]},
        "3398": {"vr": "DS", "Value": [97.0925]},
        "3399": {"vr": "DS", "Value": [442.3425]},
        "3400": {"vr": "DS", "Value": [322.655]},
        "3401": {"vr": "DS", "Value": [289.5025]},
        "3402": {"vr": "DS", "Value": [374.1375]},
        "3403": {"vr": "DS", "Value": [231.875]},
        "3404": {"vr": "DS", "Value": [170.1275]},
        "3405": {"vr": "DS", "Value": [304.03]},
        "3406": {"vr": "DS", "Value": [463.1625]},
        "3407": {"vr": "DS", "Value": [130.0775]},
        "3408": {"vr": "DS", "Value": [85.4925]},
        "3409": {"vr": "DS", "Value": [417.99]},
        "3410": {"vr": "DS", "Value": [366.5075]},
        "3411": {"vr": "DS", "Value": [435.005]},
        "3412": {"vr": "DS", "Value": [541.19]},
        "3413": {"vr": "DS", "Value": [556.01]},
        "3414": {"vr": "DS", "Value": [475.9325]},
        "3415": {"vr": "DS", "Value": [504.09]},
        "3416": {"vr": "DS", "Value": [269.27]},
        "3417": {"vr": "DS", "Value": [382.3525]},
        "3418": {"vr": "DS", "Value": [33.57]},
        "3419": {"vr": "DS", "Value": [515.9625]},
        "3420": {"vr": "DS", "Value": [156.625]},
        "3421": {"vr": "DS", "Value": [92.39]},
        "3422": {"vr": "DS", "Value": [531.075]},
        "3423": {"vr": "DS", "Value": [555.28]},
        "3424": {"vr": "DS", "Value": [315.9025]},
        "3425": {"vr": "DS", "Value": [293.7675]},
        "3426": {"vr": "DS", "Value": [515.3775]},
        "3427": {"vr": "DS", "Value": [373.5525]},
        "3428": {"vr": "DS", "Value": [267.805]},
        "3429": {"vr": "DS", "Value": [275.875]},
        "3430": {"vr": "DS", "Value": [365.4825]},
        "3431": {"vr": "DS", "Value": [496.1675]},
        "3432": {"vr": "DS", "Value": [79.2]},
        "3433": {"vr": "DS", "Value": [76.255]},
        "3434": {"vr": "DS", "Value": [449.095]},
        "3435": {"vr": "DS", "Value": [417.405]},
        "3436": {"vr": "DS", "Value": [497.9225]},
        "3437": {"vr": "DS", "Value": [520.5175]},
        "3438": {"vr": "DS", "Value": [191.97]},
        "3439": {"vr": "DS", "Value": [392.3225]},
        "3440": {"vr": "DS", "Value": [459.21]},
        "3441": {"vr": "DS", "Value": [488.685]},
        "3442": {"vr": "DS", "Value": [416.675]},
        "3443": {"vr": "DS", "Value": [521.835]},
        "3444": {"vr": "DS", "Value": [312.83]},
        "3445": {"vr": "DS", "Value": [30.4975]},
        "3446": {"vr": "DS", "Value": [2.3425]},
        "3447": {"vr": "DS", "Value": [550.1375]},
        "3448": {"vr": "DS", "Value": [277.3375]},
        "3449": {"vr": "DS", "Value": [240.235]},
        "3450": {"vr": "DS", "Value": [462.1375]},
        "3451": {"vr": "DS", "Value": [328.0875]},
        "3452": {"vr": "DS", "Value": [218.225]},
        "3453": {"vr": "DS", "Value": [248.01]},
        "3454": {"vr": "DS", "Value": [204.1575]},
        "3455": {"vr": "DS", "Value": [82.42]},
        "3456": {"vr": "DS", "Value": [268.245]},
        "3457": {"vr": "DS", "Value": [453.19]},
        "3458": {"vr": "DS", "Value": [364.46]},
        "3459": {"vr": "DS", "Value": [539.435]},
        "3460": {"vr": "DS", "Value": [355.805]},
        "3461": {"vr": "DS", "Value": [90.78]},
        "3462": {"vr": "DS", "Value": [182.585]},
        "3463": {"vr": "DS", "Value": [382.06]},
        "3464": {"vr": "DS", "Value": [572.7325]},
        "3465": {"vr": "DS", "Value": [385.865]},
        "3466": {"vr": "DS", "Value": [226.44]},
        "3467": {"vr": "DS", "Value": [514.3525]},
        "3468": {"vr": "DS", "Value": [196.82]},
        "3469": {"vr": "DS", "Value": [139.025]},
        "3470": {"vr": "DS", "Value": [376.185]},
        "3471": {"vr": "DS", "Value": [362.85]},
        "3472": {"vr": "DS", "Value": [524.7625]},
        "3473": {"vr": "DS", "Value": [62.04]},
        "3474": {"vr": "DS", "Value": [112.77]},
        "3475": {"vr": "DS", "Value": [264.2925]},
        "3476": {"vr": "DS", "Value": [45.025]},
        "3477": {"vr": "DS", "Value": [21.6975]},
        "3478": {"vr": "DS", "Value": [527.6875]},
        "3479": {"vr": "DS", "Value": [358.0]},
        "3480": {"vr": "DS", "Value": [129.4925]},
        "3481": {"vr": "DS", "Value": [591.9425]},
        "3482": {"vr": "DS", "Value": [470.9375]},
        "3483": {"vr": "DS", "Value": [525.9325]},
        "3484": {"vr": "DS", "Value": [532.685]},
        "3485": {"vr": "DS", "Value": [381.475]},
        "3486": {"vr": "DS", "Value": [462.43]},
        "3487": {"vr": "DS", "Value": [585.63]},
        "3488": {"vr": "DS", "Value": [42.37]},
        "3489": {"vr": "DS", "Value": [441.61]},
        "3490": {"vr": "DS", "Value": [56.46]},
        "3491": {"vr": "DS", "Value": [512.595]},
        "3492": {"vr": "DS", "Value": [207.375]},
        "3493": {"vr": "DS", "Value": [558.9375]},
        "3494": {"vr": "DS", "Value": [347.2975]},
        "3495": {"vr": "DS", "Value": [446.1475]},
        "3496": {"vr": "DS", "Value": [254.1575]},
        "3497": {"vr": "DS", "Value": [380.45]},
        "3498": {"vr": "DS", "Value": [497.3375]},
        "3499": {"vr": "DS", "Value": [244.9175]},
        "3500": {"vr": "DS", "Value": [479.7375]},
        "3501": {"vr": "DS", "Value": [307.395]},
        "3502": {"vr": "DS", "Value": [308.2925]},
        "3503": {"vr": "DS", "Value": [495.7275]},
        "3504": {"vr": "DS", "Value": [40.9075]},
        "3505": {"vr": "DS", "Value": [179.075]},
        "3506": {"vr": "DS", "Value": [228.9475]},
        "3507": {"vr": "DS", "Value": [339.67]},
        "3508": {"vr": "DS", "Value": [472.6925]},
        "3509": {"vr": "DS", "Value": [411.5325]},
        "3510": {"vr": "DS", "Value": [310.7825]},
        "3511": {"vr": "DS", "Value": [3.66]},
        "3512": {"vr": "DS", "Value": [261.055]},
        "3513": {"vr": "DS", "Value": [353.3175]},
        "3514": {"vr": "DS", "Value": [531.66]},
        "3515": {"vr": "DS", "Value": [316.3425]},
        "3516": {"vr": "DS", "Value": [25.65]},
        "3517": {"vr": "DS", "Value": [550.7225]},
        "3518": {"vr": "DS", "Value": [146.655]},
        "3519": {"vr": "DS", "Value": [318.7025]},
        "3520": {"vr": "DS", "Value": [427.0825]},
        "3521": {"vr": "DS", "Value": [592.9675]},
        "3522": {"vr": "DS", "Value": [0.0]},
        "3523": {"vr": "DS", "Value": [578.1475]},
        "3524": {"vr": "DS", "Value": [392.47]},
        "3525": {"vr": "DS", "Value": [292.3025]},
        "3526": {"vr": "DS", "Value": [214.7125]},
        "3527": {"vr": "DS", "Value": [555.7175]},
        "3528": {"vr": "DS", "Value": [172.175]},
        "3529": {"vr": "DS", "Value": [591.65]},
        "3530": {"vr": "DS", "Value": [189.4825]},
        "3531": {"vr": "DS", "Value": [94.0]},
        "3532": {"vr": "DS", "Value": [202.84]},
        "3533": {"vr": "DS", "Value": [200.77]},
        "3534": {"vr": "DS", "Value": [533.855]},
        "3535": {"vr": "DS", "Value": [430.8875]},
        "3536": {"vr": "DS", "Value": [131.1025]},
        "3537": {"vr": "DS", "Value": [70.84]},
        "3538": {"vr": "DS", "Value": [420.625]},
        "3539": {"vr": "DS", "Value": [596.48]},
        "3540": {"vr": "DS", "Value": [343.4925]},
        "3541": {"vr": "DS", "Value": [422.5475]},
        "3542": {"vr": "DS", "Value": [170.7125]},
        "3543": {"vr": "DS", "Value": [245.3575]},
        "3544": {"vr": "DS", "Value": [274.265]},
        "3545": {"vr": "DS", "Value": [224.5375]},
        "3546": {"vr": "DS", "Value": [295.5225]},
        "3547": {"vr": "DS", "Value": [213.835]},
        "3548": {"vr": "DS", "Value": [360.05]},
        "3549": {"vr": "DS", "Value": [70.6925]},
        "3550": {"vr": "DS", "Value": [392.03]},
        "3551": {"vr": "DS", "Value": [73.035]},
        "3552": {"vr": "DS", "Value": [544.1175]},
        "3553": {"vr": "DS", "Value": [276.3125]},
        "3554": {"vr": "DS", "Value": [213.1025]},
        "3555": {"vr": "DS", "Value": [270.44]},
        "3556": {"vr": "DS", "Value": [189.19]},
        "3557": {"vr": "DS", "Value": [152.82]},
        "3558": {"vr": "DS", "Value": [68.9175]},
        "3559": {"vr": "DS", "Value": [334.4]},
        "3560": {"vr": "DS", "Value": [264.44]},
        "3561": {"vr": "DS", "Value": [454.215]},
        "3562": {"vr": "DS", "Value": [242.575]},
        "3563": {"vr": "DS", "Value": [434.86]},
        "3564": {"vr": "DS", "Value": [250.3525]},
        "3565": {"vr": "DS", "Value": [492.195]},
        "3566": {"vr": "DS", "Value": [335.425]},
        "3567": {"vr": "DS", "Value": [67.455]},
        "3568": {"vr": "DS", "Value": [27.7175]},
        "3569": {"vr": "DS", "Value": [127.8825]},
        "3570": {"vr": "DS", "Value": [199.7475]},
        "3571": {"vr": "DS", "Value": [52.4875]},
        "3572": {"vr": "DS", "Value": [334.5475]},
        "3573": {"vr": "DS", "Value": [44.585]},
        "3574": {"vr": "DS", "Value": [79.9325]},
        "3575": {"vr": "DS", "Value": [112.9175]},
        "3576": {"vr": "DS", "Value": [393.9325]},
        "3577": {"vr": "DS", "Value": [275.435]},
        "3578": {"vr": "DS", "Value": [101.19]},
        "3579": {"vr": "DS", "Value": [293.3275]},
        "3580": {"vr": "DS", "Value": [559.67]},
        "3581": {"vr": "DS", "Value": [480.7625]},
        "3582": {"vr": "DS", "Value": [317.9725]},
        "3583": {"vr": "DS", "Value": [582.85]},
        "3584": {"vr": "DS", "Value": [121.1325]},
        "3585": {"vr": "DS", "Value": [334.235]},
        "3586": {"vr": "DS", "Value": [528.7325]},
        "3587": {"vr": "DS", "Value": [522.5675]},
        "3588": {"vr": "DS", "Value": [238.48]},
        "3589": {"vr": "DS", "Value": [496.3125]},
        "3590": {"vr": "DS", "Value": [218.5175]},
        "3591": {"vr": "DS", "Value": [473.425]},
        "3592": {"vr": "DS", "Value": [244.3325]},
        "3593": {"vr": "DS", "Value": [486.7825]},
        "3594": {"vr": "DS", "Value": [458.9175]},
        "3595": {"vr": "DS", "Value": [141.24]},
        "3596": {"vr": "DS", "Value": [205.9125]},
        "3597": {"vr": "DS", "Value": [150.625]},
        "3598": {"vr": "DS", "Value": [207.9625]},
        "3599": {"vr": "DS", "Value": [38.5675]},
        "3600": {"vr": "DS", "Value": [387.64]},
        "3601": {"vr": "DS", "Value": [448.635]},
        "3602": {"vr": "DS", "Value": [276.605]},
        "3603": {"vr": "DS", "Value": [192.995]},
        "3604": {"vr": "DS", "Value": [244.77]},
        "3605": {"vr": "DS", "Value": [262.225]},
        "3606": {"vr": "DS", "Value": [329.99]},
        "3607": {"vr": "DS", "Value": [572.1475]},
        "3608": {"vr": "DS", "Value": [149.1425]},
        "3609": {"vr": "DS", "Value": [532.0975]},
        "3610": {"vr": "DS", "Value": [493.825]},
        "3611": {"vr": "DS", "Value": [59.24]},
        "3612": {"vr": "DS", "Value": [310.635]},
        "3613": {"vr": "DS", "Value": [454.5075]},
        "3614": {"vr": "DS", "Value": [492.9475]},
        "3615": {"vr": "DS", "Value": [77.7175]},
        "3616": {"vr": "DS", "Value": [273.825]},
        "3617": {"vr": "DS", "Value": [115.425]},
        "3618": {"vr": "DS", "Value": [75.815]},
        "3619": {"vr": "DS", "Value": [28.1575]},
        "3620": {"vr": "DS", "Value": [181.7075]},
        "3621": {"vr": "DS", "Value": [214.1275]},
        "3622": {"vr": "DS", "Value": [58.9475]},
        "3623": {"vr": "DS", "Value": [103.385]},
        "3624": {"vr": "DS", "Value": [580.9475]},
        "3625": {"vr": "DS", "Value": [575.075]},
        "3626": {"vr": "DS", "Value": [259.7375]},
        "3627": {"vr": "DS", "Value": [520.81]},
        "3628": {"vr": "DS", "Value": [404.05]},
        "3629": {"vr": "DS", "Value": [49.415]},
        "3630": {"vr": "DS", "Value": [526.3725]},
        "3631": {"vr": "DS", "Value": [545.2875]},
        "3632": {"vr": "DS", "Value": [151.21]},
        "3633": {"vr": "DS", "Value": [431.9325]},
        "3634": {"vr": "DS", "Value": [530.9275]},
        "3635": {"vr": "DS", "Value": [251.9625]},
        "3636": {"vr": "DS", "Value": [579.3175]},
        "3637": {"vr": "DS", "Value": [47.3675]},
        "3638": {"vr": "DS", "Value": [108.5275]},
        "3639": {"vr": "DS", "Value": [568.615]},
        "3640": {"vr": "DS", "Value": [301.25]},
        "3641": {"vr": "DS", "Value": [221.3175]},
        "3642": {"vr": "DS", "Value": [567.2975]},
        "3643": {"vr": "DS", "Value": [277.19]},
        "3644": {"vr": "DS", "Value": [366.9475]},
        "3645": {"vr": "DS", "Value": [84.9075]},
        "3646": {"vr": "DS", "Value": [127.59]},
        "3647": {"vr": "DS", "Value": [457.1425]},
        "3648": {"vr": "DS", "Value": [435.8825]},
        "3649": {"vr": "DS", "Value": [312.975]},
        "3650": {"vr": "DS", "Value": [231.2875]},
        "3651": {"vr": "DS", "Value": [179.805]},
        "3652": {"vr": "DS", "Value": [321.4825]},
        "3653": {"vr": "DS", "Value": [500.1175]},
        "3654": {"vr": "DS", "Value": [303.59]},
        "3655": {"vr": "DS", "Value": [115.5725]},
        "3656": {"vr": "DS", "Value": [405.5325]},
        "3657": {"vr": "DS", "Value": [545.1425]},
        "3658": {"vr": "DS", "Value": [61.1425]},
        "3659": {"vr": "DS", "Value": [547.065]},
        "3660": {"vr": "DS", "Value": [88.1475]},
        "3661": {"vr": "DS", "Value": [149.6]},
        "3662": {"vr": "DS", "Value": [513.035]},
        "3663": {"vr": "DS", "Value": [516.1075]},
        "3664": {"vr": "DS", "Value": [85.3475]},
        "3665": {"vr": "DS", "Value": [149.2875]},
        "3666": {"vr": "DS", "Value": [440.0]},
        "3667": {"vr": "DS", "Value": [262.0775]},
        "3668": {"vr": "DS", "Value": [110.2825]},
        "3669": {"vr": "DS", "Value": [176.44]},
        "3670": {"vr": "DS", "Value": [171.445]},
        "3671": {"vr": "DS", "Value": [280.1175]},
        "3672": {"vr": "DS", "Value": [47.22]},
        "3673": {"vr": "DS", "Value": [596.9175]},
        "3674": {"vr": "DS", "Value": [77.2775]},
        "3675": {"vr": "DS", "Value": [233.775]},
        "3676": {"vr": "DS", "Value": [438.5175]},
        "3677": {"vr": "DS", "Value": [68.04]},
        "3678": {"vr": "DS", "Value": [434.1275]},
        "3679": {"vr": "DS", "Value": [437.9325]},
        "3680": {"vr": "DS", "Value": [387.9325]},
        "3681": {"vr": "DS", "Value": [114.84]},
        "3682": {"vr": "DS", "Value": [180.0975]},
        "3683": {"vr": "DS", "Value": [282.625]},
        "3684": {"vr": "DS", "Value": [84.7625]},
        "3685": {"vr": "DS", "Value": [423.425]},
        "3686": {"vr": "DS", "Value": [218.6625]},
        "3687": {"vr": "DS", "Value": [399.66]},
        "3688": {"vr": "DS", "Value": [356.245]},
        "3689": {"vr": "DS", "Value": [450.85]},
        "3690": {"vr": "DS", "Value": [37.395]},
        "3691": {"vr": "DS", "Value": [216.7625]},
        "3692": {"vr": "DS", "Value": [63.65]},
        "3693": {"vr": "DS", "Value": [332.77]},
        "3694": {"vr": "DS", "Value": [551.455]},
        "3695": {"vr": "DS", "Value": [71.425]},
        "3696": {"vr": "DS", "Value": [300.08]},
        "3697": {"vr": "DS", "Value": [242.2825]},
        "3698": {"vr": "DS", "Value": [107.3575]},
        "3699": {"vr": "DS", "Value": [186.7025]},
        "3700": {"vr": "DS", "Value": [575.9525]},
        "3701": {"vr": "DS", "Value": [94.44]},
        "3702": {"vr": "DS", "Value": [155.8925]},
        "3703": {"vr": "DS", "Value": [564.08]},
        "3704": {"vr": "DS", "Value": [408.46]},
        "3705": {"vr": "DS", "Value": [63.21]},
        "3706": {"vr": "DS", "Value": [345.835]},
        "3707": {"vr": "DS", "Value": [124.3725]},
        "3708": {"vr": "DS", "Value": [436.615]},
        "3709": {"vr": "DS", "Value": [194.3325]},
        "3710": {"vr": "DS", "Value": [456.5575]},
        "3711": {"vr": "DS", "Value": [503.065]},
        "3712": {"vr": "DS", "Value": [235.825]},
        "3713": {"vr": "DS", "Value": [26.235]},
        "3714": {"vr": "DS", "Value": [565.9825]},
        "3715": {"vr": "DS", "Value": [341.865]},
        "3716": {"vr": "DS", "Value": [399.9525]},
        "3717": {"vr": "DS", "Value": [549.405]},
        "3718": {"vr": "DS", "Value": [517.425]},
        "3719": {"vr": "DS", "Value": [58.8]},
        "3720": {"vr": "DS", "Value": [465.65]},
        "3721": {"vr": "DS", "Value": [285.845]},
        "3722": {"vr": "DS", "Value": [240.5275]},
        "3723": {"vr": "DS", "Value": [206.3525]},
        "3724": {"vr": "DS", "Value": [137.1225]},
        "3725": {"vr": "DS", "Value": [98.41]},
        "3726": {"vr": "DS", "Value": [430.595]},
        "3727": {"vr": "DS", "Value": [344.3725]},
        "3728": {"vr": "DS", "Value": [411.6775]},
        "3729": {"vr": "DS", "Value": [494.5575]},
        "3730": {"vr": "DS", "Value": [72.595]},
        "3731": {"vr": "DS", "Value": [374.5775]},
        "3732": {"vr": "DS", "Value": [126.5675]},
        "3733": {"vr": "DS", "Value": [34.01]},
        "3734": {"vr": "DS", "Value": [550.43]},
        "3735": {"vr": "DS", "Value": [501.2875]},
        "3736": {"vr": "DS", "Value": [537.825]},
        "3737": {"vr": "DS", "Value": [227.61]},
        "3738": {"vr": "DS", "Value": [570.9575]},
        "3739": {"vr": "DS", "Value": [341.7175]},
        "3740": {"vr": "DS", "Value": [184.8]},
        "3741": {"vr": "DS", "Value": [381.9125]},
        "3742": {"vr": "DS", "Value": [299.9325]},
        "3743": {"vr": "DS", "Value": [451.7275]},
        "3744": {"vr": "DS", "Value": [6.2925]},
        "3745": {"vr": "DS", "Value": [30.06]},
        "3746": {"vr": "DS", "Value": [174.0775]},
        "3747": {"vr": "DS", "Value": [539.29]},
        "3748": {"vr": "DS", "Value": [523.445]},
        "3749": {"vr": "DS", "Value": [197.26]},
        "3750": {"vr": "DS", "Value": [223.075]},
        "3751": {"vr": "DS", "Value": [181.1225]},
        "3752": {"vr": "DS", "Value": [183.61]},
        "3753": {"vr": "DS", "Value": [271.17]},
        "3754": {"vr": "DS", "Value": [292.595]},
        "3755": {"vr": "DS", "Value": [315.025]},
        "3756": {"vr": "DS", "Value": [397.025]},
        "3757": {"vr": "DS", "Value": [87.835]},
        "3758": {"vr": "DS", "Value": [505.1125]},
        "3759": {"vr": "DS", "Value": [265.465]},
        "3760": {"vr": "DS", "Value": [95.17]},
        "3761": {"vr": "DS", "Value": [254.01]},
        "3762": {"vr": "DS", "Value": [52.195]},
        "3763": {"vr": "DS", "Value": [402.8775]},
        "3764": {"vr": "DS", "Value": [353.025]},
        "3765": {"vr": "DS", "Value": [583.875]},
        "3766": {"vr": "DS", "Value": [285.1125]},
        "3767": {"vr": "DS", "Value": [383.0825]},
        "3768": {"vr": "DS", "Value": [506.285]},
        "3769": {"vr": "DS", "Value": [104.85]},
        "3770": {"vr": "DS", "Value": [150.9175]},
        "3771": {"vr": "DS", "Value": [569.4925]},
        "3772": {"vr": "DS", "Value": [310.4875]},
        "3773": {"vr": "DS", "Value": [489.7075]},
        "3774": {"vr": "DS", "Value": [262.37]},
        "3775": {"vr": "DS", "Value": [366.8]},
        "3776": {"vr": "DS", "Value": [25.355]},
        "3777": {"vr": "DS", "Value": [311.805]},
        "3778": {"vr": "DS", "Value": [55.1425]},
        "3779": {"vr": "DS", "Value": [212.225]},
        "3780": {"vr": "DS", "Value": [52.8]},
        "3781": {"vr": "DS", "Value": [516.4]},
        "3782": {"vr": "DS", "Value": [92.0975]},
        "3783": {"vr": "DS", "Value": [101.9225]},
        "3784": {"vr": "DS", "Value": [579.7575]},
        "3785": {"vr": "DS", "Value": [105.435]},
        "3786": {"vr": "DS", "Value": [316.05]},
        "3787": {"vr": "DS", "Value": [23.455]},
        "3788": {"vr": "DS", "Value": [109.845]},
        "3789": {"vr": "DS", "Value": [479.2975]},
        "3790": {"vr": "DS", "Value": [117.035]},
        "3791": {"vr": "DS", "Value": [82.5675]},
        "3792": {"vr": "DS", "Value": [154.1375]},
        "3793": {"vr": "DS", "Value": [275.7275]},
        "3794": {"vr": "DS", "Value": [26.0875]},
        "3795": {"vr": "DS", "Value": [400.245]},
        "3796": {"vr": "DS", "Value": [561.7175]},
        "3797": {"vr": "DS", "Value": [163.0825]},
        "3798": {"vr": "DS", "Value": [393.64]},
        "3799": {"vr": "DS", "Value": [156.4775]},
        "3800": {"vr": "DS", "Value": [551.015]},
        "3801": {"vr": "DS", "Value": [276.02]},
        "3802": {"vr": "DS", "Value": [533.27]},
        "3803": {"vr": "DS", "Value": [98.5575]},
        "3804": {"vr": "DS", "Value": [385.425]},
        "3805": {"vr": "DS", "Value": [400.0975]},
        "3806": {"vr": "DS", "Value": [404.4875]},
        "3807": {"vr": "DS", "Value": [475.035]},
        "3808": {"vr": "DS", "Value": [555.865]},
        "3809": {"vr": "DS", "Value": [118.9375]},
        "3810": {"vr": "DS", "Value": [507.7475]},
        "3811": {"vr": "DS", "Value": [446.2925]},
        "3812": {"vr": "DS", "Value": [582.41]},
        "3813": {"vr": "DS", "Value": [429.5725]},
        "3814": {"vr": "DS", "Value": [228.195]},
        "3815": {"vr": "DS", "Value": [367.5325]},
        "3816": {"vr": "DS", "Value": [416.0875]},
        "3817": {"vr": "DS", "Value": [409.4825]},
        "3818": {"vr": "DS", "Value": [102.5075]},
        "3819": {"vr": "DS", "Value": [198.7225]},
        "3820": {"vr": "DS", "Value": [388.665]},
        "3821": {"vr": "DS", "Value": [347.445]},
        "3822": {"vr": "DS", "Value": [559.3775]},
        "3823": {"vr": "DS", "Value": [425.3275]},
        "3824": {"vr": "DS", "Value": [586.8]},
        "3825": {"vr": "DS", "Value": [203.865]},
        "3826": {"vr": "DS", "Value": [45.3175]},
        "3827": {"vr": "DS", "Value": [325.6]},
        "3828": {"vr": "DS", "Value": [194.48]},
        "3829": {"vr": "DS", "Value": [486.9275]},
        "3830": {"vr": "DS", "Value": [243.3075]},
        "3831": {"vr": "DS", "Value": [352.88]},
        "3832": {"vr": "DS", "Value": [306.0775]},
        "3833": {"vr": "DS", "Value": [274.995]},
        "3834": {"vr": "DS", "Value": [59.825]},
        "3835": {"vr": "DS", "Value": [535.3175]},
        "3836": {"vr": "DS", "Value": [439.6875]},
        "3837": {"vr": "DS", "Value": [142.995]},
        "3838": {"vr": "DS", "Value": [18.04]},
        "3839": {"vr": "DS", "Value": [18.4775]},
        "3840": {"vr": "DS", "Value": [476.3725]},
        "3841": {"vr": "DS", "Value": [119.5225]},
        "3842": {"vr": "DS", "Value": [52.9475]},
        "3843": {"vr": "DS", "Value": [362.265]},
        "3844": {"vr": "DS", "Value": [119.0825]},
        "3845": {"vr": "DS", "Value": [205.3275]},
        "3846": {"vr": "DS", "Value": [423.28]},
        "3847": {"vr": "DS", "Value": [386.595]},
        "3848": {"vr": "DS", "Value": [389.5425]},
        "3849": {"vr": "DS", "Value": [552.48]},
        "3850": {"vr": "DS", "Value": [316.635]},
        "3851": {"vr": "DS", "Value": [421.5025]},
        "3852": {"vr": "DS", "Value": [131.5425]},
        "3853": {"vr": "DS", "Value": [52.05]},
        "3854": {"vr": "DS", "Value": [219.835]},
        "3855": {"vr": "DS", "Value": [592.82]},
        "3856": {"vr": "DS", "Value": [32.255]},
        "3857": {"vr": "DS", "Value": [126.7125]},
        "3858": {"vr": "DS", "Value": [30.3525]},
        "3859": {"vr": "DS", "Value": [328.82]},
        "3860": {"vr": "DS", "Value": [142.85]},
        "3861": {"vr": "DS", "Value": [288.4775]},
        "3862": {"vr": "DS", "Value": [162.4975]},
        "3863": {"vr": "DS", "Value": [493.24]},
        "3864": {"vr": "DS", "Value": [232.02]},
        "3865": {"vr": "DS", "Value": [367.385]},
        "3866": {"vr": "DS", "Value": [269.1225]},
        "3867": {"vr": "DS", "Value": [67.8925]},
        "3868": {"vr": "DS", "Value": [116.8875]},
        "3869": {"vr": "DS", "Value": [453.9225]},
        "3870": {"vr": "DS", "Value": [572.44]},
        "3871": {"vr": "DS", "Value": [512.45]},
        "3872": {"vr": "DS", "Value": [66.575]},
        "3873": {"vr": "DS", "Value": [475.7875]},
        "3874": {"vr": "DS", "Value": [395.5425]},
        "3875": {"vr": "DS", "Value": [543.24]},
        "3876": {"vr": "DS", "Value": [159.28]},
        "3877": {"vr": "DS", "Value": [536.3425]},
        "3878": {"vr": "DS", "Value": [498.07]},
        "3879": {"vr": "DS", "Value": [143.2875]},
        "3880": {"vr": "DS", "Value": [418.1375]},
        "3881": {"vr": "DS", "Value": [236.85]},
        "3882": {"vr": "DS", "Value": [404.635]},
        "3883": {"vr": "DS", "Value": [265.1725]},
        "3884": {"vr": "DS", "Value": [308.44]},
        "3885": {"vr": "DS", "Value": [108.9675]},
        "3886": {"vr": "DS", "Value": [488.39]},
        "3887": {"vr": "DS", "Value": [323.6775]},
        "3888": {"vr": "DS", "Value": [183.4625]},
        "3889": {"vr": "DS", "Value": [40.175]},
        "3890": {"vr": "DS", "Value": [259.1525]},
        "3891": {"vr": "DS", "Value": [368.5575]},
        "3892": {"vr": "DS", "Value": [554.84]},
        "3893": {"vr": "DS", "Value": [408.7525]},
        "3894": {"vr": "DS", "Value": [49.855]},
        "3895": {"vr": "DS", "Value": [151.3575]},
        "3896": {"vr": "DS", "Value": [560.5475]},
        "3897": {"vr": "DS", "Value": [519.495]},
        "3898": {"vr": "DS", "Value": [360.9475]},
        "3899": {"vr": "DS", "Value": [423.7175]},
        "3900": {"vr": "DS", "Value": [108.0875]},
        "3901": {"vr": "DS", "Value": [469.9125]},
        "3902": {"vr": "DS", "Value": [324.85]},
        "3903": {"vr": "DS", "Value": [445.7075]},
        "3904": {"vr": "DS", "Value": [288.3325]},
        "3905": {"vr": "DS", "Value": [573.61]},
        "3906": {"vr": "DS", "Value": [335.1325]},
        "3907": {"vr": "DS", "Value": [524.3225]},
        "3908": {"vr": "DS", "Value": [183.3175]},
        "3909": {"vr": "DS", "Value": [100.02]},
        "3910": {"vr": "DS", "Value": [50.44]},
        "3911": {"vr": "DS", "Value": [223.805]},
        "3912": {"vr": "DS", "Value": [545.6025]},
        "3913": {"vr": "DS", "Value": [261.64]},
        "3914": {"vr": "DS", "Value": [350.225]},
        "3915": {"vr": "DS", "Value": [27.5725]},
        "3916": {"vr": "DS", "Value": [206.205]},
        "3917": {"vr": "DS", "Value": [66.43]},
        "3918": {"vr": "DS", "Value": [291.425]},
        "3919": {"vr": "DS", "Value": [251.5225]},
        "3920": {"vr": "DS", "Value": [170.42]},
        "3921": {"vr": "DS", "Value": [503.795]},
        "3922": {"vr": "DS", "Value": [563.495]},
        "3923": {"vr": "DS", "Value": [91.805]},
        "3924": {"vr": "DS", "Value": [28.3025]},
        "3925": {"vr": "DS", "Value": [175.1025]},
        "3926": {"vr": "DS", "Value": [431.035]},
        "3927": {"vr": "DS", "Value": [443.075]},
        "3928": {"vr": "DS", "Value": [304.615]},
        "3929": {"vr": "DS", "Value": [487.22]},
        "3930": {"vr": "DS", "Value": [452.1675]},
        "3931": {"vr": "DS", "Value": [287.8925]},
        "3932": {"vr": "DS", "Value": [408.02]},
        "3933": {"vr": "DS", "Value": [526.81]},
        "3934": {"vr": "DS", "Value": [326.48]},
        "3935": {"vr": "DS", "Value": [525.64]},
        "3936": {"vr": "DS", "Value": [332.185]},
        "3937": {"vr": "DS", "Value": [401.27]},
        "3938": {"vr": "DS", "Value": [560.1075]},
        "3939": {"vr": "DS", "Value": [104.5575]},
        "3940": {"vr": "DS", "Value": [249.18]},
        "3941": {"vr": "DS", "Value": [511.28]},
        "3942": {"vr": "DS", "Value": [425.035]},
        "3943": {"vr": "DS", "Value": [549.5525]},
        "3944": {"vr": "DS", "Value": [343.035]},
        "3945": {"vr": "DS", "Value": [207.5225]},
        "3946": {"vr": "DS", "Value": [550.285]},
        "3947": {"vr": "DS", "Value": [104.7025]},
        "3948": {"vr": "DS", "Value": [194.7725]},
        "3949": {"vr": "DS", "Value": [529.1725]},
        "3950": {"vr": "DS", "Value": [372.82]},
        "3951": {"vr": "DS", "Value": [231.7275]},
        "3952": {"vr": "DS", "Value": [326.04]},
        "3953": {"vr": "DS", "Value": [332.625]},
        "3954": {"vr": "DS", "Value": [76.1075]},
        "3955": {"vr": "DS", "Value": [587.24]},
        "3956": {"vr": "DS", "Value": [317.24]},
        "3957": {"vr": "DS", "Value": [296.4]},
        "3958": {"vr": "DS", "Value": [214.42]},
        "3959": {"vr": "DS", "Value": [523.1525]},
        "3960": {"vr": "DS", "Value": [395.1025]},
        "3961": {"vr": "DS", "Value": [426.205]},
        "3962": {"vr": "DS", "Value": [489.415]},
        "3963": {"vr": "DS", "Value": [138.0]},
        "3964": {"vr": "DS", "Value": [414.48]},
        "3965": {"vr": "DS", "Value": [577.7075]},
        "3966": {"vr": "DS", "Value": [118.3525]},
        "3967": {"vr": "DS", "Value": [240.9675]},
        "3968": {"vr": "DS", "Value": [112.625]},
        "3969": {"vr": "DS", "Value": [52.635]},
        "3970": {"vr": "DS", "Value": [270.8775]},
        "3971": {"vr": "DS", "Value": [65.26]},
        "3972": {"vr": "DS", "Value": [453.7775]},
        "3973": {"vr": "DS", "Value": [236.995]},
        "3974": {"vr": "DS", "Value": [180.6825]},
        "3975": {"vr": "DS", "Value": [468.1575]},
        "3976": {"vr": "DS", "Value": [33.8625]},
        "3977": {"vr": "DS", "Value": [87.395]},
        "3978": {"vr": "DS", "Value": [571.25]},
        "3979": {"vr": "DS", "Value": [260.615]},
        "3980": {"vr": "DS", "Value": [101.045]},
        "3981": {"vr": "DS", "Value": [430.45]},
        "3982": {"vr": "DS", "Value": [288.9175]},
        "3983": {"vr": "DS", "Value": [41.3475]},
        "3984": {"vr": "DS", "Value": [163.9625]},
        "3985": {"vr": "DS", "Value": [347.7375]},
        "3986": {"vr": "DS", "Value": [562.01]},
        "3987": {"vr": "DS", "Value": [248.45]},
        "3988": {"vr": "DS", "Value": [289.3575]},
        "3989": {"vr": "DS", "Value": [222.9275]},
        "3990": {"vr": "DS", "Value": [336.7425]},
        "3991": {"vr": "DS", "Value": [342.01]},
        "3992": {"vr": "DS", "Value": [561.28]},
        "3993": {"vr": "DS", "Value": [514.205]},
        "3994": {"vr": "DS", "Value": [278.8]},
        "3995": {"vr": "DS", "Value": [115.28]},
        "3996": {"vr": "DS", "Value": [58.215]},
        "3997": {"vr": "DS", "Value": [522.7125]},
        "3998": {"vr": "DS", "Value": [277.9225]},
        "3999": {"vr": "DS", "Value": [429.7175]},
        "4000": {"vr": "DS", "Value": [531.22]},
        "4001": {"vr": "DS", "Value": [425.62]},
        "4002": {"vr": "DS", "Value": [459.9425]},
        "4003": {"vr": "DS", "Value": [215.445]},
        "4004": {"vr": "DS", "Value": [515.815]},
        "4005": {"vr": "DS", "Value": [143.1425]},
        "4006": {"vr": "DS", "Value": [74.9375]},
        "4007": {"vr": "DS", "Value": [358.585]},
        "4008": {"vr": "DS", "Value": [133.7575]},
        "4009": {"vr": "DS", "Value": [299.64]},
        "4010": {"vr": "DS", "Value": [311.9525]},
        "4011": {"vr": "DS", "Value": [109.1125]},
        "4012": {"vr": "DS", "Value": [478.5675]},
        "4013": {"vr": "DS", "Value": [99.7275]},
        "4014": {"vr": "DS", "Value": [194.185]},
        "4015": {"vr": "DS", "Value": [545.435]},
        "4016": {"vr": "DS", "Value": [530.7825]},
        "4017": {"vr": "DS", "Value": [288.185]},
        "4018": {"vr": "DS", "Value": [450.7025]},
        "4019": {"vr": "DS", "Value": [357.855]},
    },
    "00211105": {
        "0": {"vr": "IS", "Value": [3000]},
        "1": {"vr": "IS", "Value": [3000]},
        "2": {"vr": "IS", "Value": [3000]},
        "3": {"vr": "IS", "Value": [0]},
        "4": {"vr": "IS", "Value": [3000]},
        "5": {"vr": "IS", "Value": [3000]},
        "6": {"vr": "IS", "Value": [3000]},
        "7": {"vr": "IS", "Value": [3000]},
        "8": {"vr": "IS", "Value": [3000]},
        "9": {"vr": "IS", "Value": [3000]},
        "10": {"vr": "IS", "Value": [3000]},
        "11": {"vr": "IS", "Value": [3000]},
        "12": {"vr": "IS", "Value": [3000]},
        "13": {"vr": "IS", "Value": [0]},
        "14": {"vr": "IS", "Value": [0]},
        "15": {"vr": "IS", "Value": [3000]},
        "16": {"vr": "IS", "Value": [3000]},
        "17": {"vr": "IS", "Value": [3000]},
        "18": {"vr": "IS", "Value": [3000]},
        "19": {"vr": "IS", "Value": [3000]},
        "20": {"vr": "IS", "Value": [3000]},
        "21": {"vr": "IS", "Value": [3000]},
        "22": {"vr": "IS", "Value": [3000]},
        "23": {"vr": "IS", "Value": [3000]},
        "24": {"vr": "IS", "Value": [3000]},
        "25": {"vr": "IS", "Value": [3000]},
        "26": {"vr": "IS", "Value": [3000]},
        "27": {"vr": "IS", "Value": [3000]},
        "28": {"vr": "IS", "Value": [3000]},
        "29": {"vr": "IS", "Value": [3000]},
        "30": {"vr": "IS", "Value": [3000]},
        "31": {"vr": "IS", "Value": [0]},
        "32": {"vr": "IS", "Value": [3000]},
        "33": {"vr": "IS", "Value": [3000]},
        "34": {"vr": "IS", "Value": [0]},
        "35": {"vr": "IS", "Value": [0]},
        "36": {"vr": "IS", "Value": [3000]},
        "37": {"vr": "IS", "Value": [3000]},
        "38": {"vr": "IS", "Value": [3000]},
        "39": {"vr": "IS", "Value": [3000]},
        "40": {"vr": "IS", "Value": [0]},
        "41": {"vr": "IS", "Value": [3000]},
        "42": {"vr": "IS", "Value": [3000]},
        "43": {"vr": "IS", "Value": [3000]},
        "44": {"vr": "IS", "Value": [3000]},
        "45": {"vr": "IS", "Value": [3000]},
        "46": {"vr": "IS", "Value": [3000]},
        "47": {"vr": "IS", "Value": [3000]},
        "48": {"vr": "IS", "Value": [3000]},
        "49": {"vr": "IS", "Value": [3000]},
        "50": {"vr": "IS", "Value": [3000]},
        "51": {"vr": "IS", "Value": [3000]},
        "52": {"vr": "IS", "Value": [3000]},
        "53": {"vr": "IS", "Value": [3000]},
        "54": {"vr": "IS", "Value": [3000]},
        "55": {"vr": "IS", "Value": [3000]},
        "56": {"vr": "IS", "Value": [3000]},
        "57": {"vr": "IS", "Value": [3000]},
        "58": {"vr": "IS", "Value": [3000]},
        "59": {"vr": "IS", "Value": [3000]},
        "60": {"vr": "IS", "Value": [0]},
        "61": {"vr": "IS", "Value": [0]},
        "62": {"vr": "IS", "Value": [3000]},
        "63": {"vr": "IS", "Value": [3000]},
        "64": {"vr": "IS", "Value": [3000]},
        "65": {"vr": "IS", "Value": [3000]},
        "66": {"vr": "IS", "Value": [3000]},
        "67": {"vr": "IS", "Value": [3000]},
        "68": {"vr": "IS", "Value": [0]},
        "69": {"vr": "IS", "Value": [3000]},
        "70": {"vr": "IS", "Value": [3000]},
        "71": {"vr": "IS", "Value": [3000]},
        "72": {"vr": "IS", "Value": [3000]},
        "73": {"vr": "IS", "Value": [3000]},
        "74": {"vr": "IS", "Value": [3000]},
        "75": {"vr": "IS", "Value": [3000]},
        "76": {"vr": "IS", "Value": [3000]},
        "77": {"vr": "IS", "Value": [3000]},
        "78": {"vr": "IS", "Value": [3000]},
        "79": {"vr": "IS", "Value": [3000]},
        "80": {"vr": "IS", "Value": [0]},
        "81": {"vr": "IS", "Value": [3000]},
        "82": {"vr": "IS", "Value": [3000]},
        "83": {"vr": "IS", "Value": [3000]},
        "84": {"vr": "IS", "Value": [3000]},
        "85": {"vr": "IS", "Value": [3000]},
        "86": {"vr": "IS", "Value": [3000]},
        "87": {"vr": "IS", "Value": [3000]},
        "88": {"vr": "IS", "Value": [3000]},
        "89": {"vr": "IS", "Value": [3000]},
        "90": {"vr": "IS", "Value": [0]},
        "91": {"vr": "IS", "Value": [0]},
        "92": {"vr": "IS", "Value": [3000]},
        "93": {"vr": "IS", "Value": [3000]},
        "94": {"vr": "IS", "Value": [3000]},
        "95": {"vr": "IS", "Value": [3000]},
        "96": {"vr": "IS", "Value": [3000]},
        "97": {"vr": "IS", "Value": [3000]},
        "98": {"vr": "IS", "Value": [3000]},
        "99": {"vr": "IS", "Value": [3000]},
        "100": {"vr": "IS", "Value": [3000]},
        "101": {"vr": "IS", "Value": [3000]},
        "102": {"vr": "IS", "Value": [3000]},
        "103": {"vr": "IS", "Value": [3000]},
        "104": {"vr": "IS", "Value": [3000]},
        "105": {"vr": "IS", "Value": [3000]},
        "106": {"vr": "IS", "Value": [3000]},
        "107": {"vr": "IS", "Value": [3000]},
        "108": {"vr": "IS", "Value": [3000]},
        "109": {"vr": "IS", "Value": [3000]},
        "110": {"vr": "IS", "Value": [3000]},
        "111": {"vr": "IS", "Value": [3000]},
        "112": {"vr": "IS", "Value": [0]},
        "113": {"vr": "IS", "Value": [3000]},
        "114": {"vr": "IS", "Value": [0]},
        "115": {"vr": "IS", "Value": [3000]},
        "116": {"vr": "IS", "Value": [3000]},
        "117": {"vr": "IS", "Value": [3000]},
        "118": {"vr": "IS", "Value": [3000]},
        "119": {"vr": "IS", "Value": [3000]},
        "120": {"vr": "IS", "Value": [3000]},
        "121": {"vr": "IS", "Value": [3000]},
        "122": {"vr": "IS", "Value": [3000]},
        "123": {"vr": "IS", "Value": [3000]},
        "124": {"vr": "IS", "Value": [3000]},
        "125": {"vr": "IS", "Value": [3000]},
        "126": {"vr": "IS", "Value": [3000]},
        "127": {"vr": "IS", "Value": [3000]},
        "128": {"vr": "IS", "Value": [0]},
        "129": {"vr": "IS", "Value": [3000]},
        "130": {"vr": "IS", "Value": [3000]},
        "131": {"vr": "IS", "Value": [3000]},
        "132": {"vr": "IS", "Value": [3000]},
        "133": {"vr": "IS", "Value": [3000]},
        "134": {"vr": "IS", "Value": [3000]},
        "135": {"vr": "IS", "Value": [3000]},
        "136": {"vr": "IS", "Value": [3000]},
        "137": {"vr": "IS", "Value": [3000]},
        "138": {"vr": "IS", "Value": [3000]},
        "139": {"vr": "IS", "Value": [3000]},
        "140": {"vr": "IS", "Value": [3000]},
        "141": {"vr": "IS", "Value": [3000]},
        "142": {"vr": "IS", "Value": [3000]},
        "143": {"vr": "IS", "Value": [3000]},
        "144": {"vr": "IS", "Value": [3000]},
        "145": {"vr": "IS", "Value": [3000]},
        "146": {"vr": "IS", "Value": [3000]},
        "147": {"vr": "IS", "Value": [3000]},
        "148": {"vr": "IS", "Value": [3000]},
        "149": {"vr": "IS", "Value": [3000]},
        "150": {"vr": "IS", "Value": [3000]},
        "151": {"vr": "IS", "Value": [3000]},
        "152": {"vr": "IS", "Value": [3000]},
        "153": {"vr": "IS", "Value": [3000]},
        "154": {"vr": "IS", "Value": [3000]},
        "155": {"vr": "IS", "Value": [3000]},
        "156": {"vr": "IS", "Value": [3000]},
        "157": {"vr": "IS", "Value": [3000]},
        "158": {"vr": "IS", "Value": [3000]},
        "159": {"vr": "IS", "Value": [3000]},
        "160": {"vr": "IS", "Value": [0]},
        "161": {"vr": "IS", "Value": [3000]},
        "162": {"vr": "IS", "Value": [3000]},
        "163": {"vr": "IS", "Value": [3000]},
        "164": {"vr": "IS", "Value": [3000]},
        "165": {"vr": "IS", "Value": [3000]},
        "166": {"vr": "IS", "Value": [3000]},
        "167": {"vr": "IS", "Value": [3000]},
        "168": {"vr": "IS", "Value": [3000]},
        "169": {"vr": "IS", "Value": [3000]},
        "170": {"vr": "IS", "Value": [3000]},
        "171": {"vr": "IS", "Value": [3000]},
        "172": {"vr": "IS", "Value": [3000]},
        "173": {"vr": "IS", "Value": [3000]},
        "174": {"vr": "IS", "Value": [3000]},
        "175": {"vr": "IS", "Value": [3000]},
        "176": {"vr": "IS", "Value": [3000]},
        "177": {"vr": "IS", "Value": [3000]},
        "178": {"vr": "IS", "Value": [3000]},
        "179": {"vr": "IS", "Value": [3000]},
        "180": {"vr": "IS", "Value": [3000]},
        "181": {"vr": "IS", "Value": [3000]},
        "182": {"vr": "IS", "Value": [3000]},
        "183": {"vr": "IS", "Value": [3000]},
        "184": {"vr": "IS", "Value": [3000]},
        "185": {"vr": "IS", "Value": [3000]},
        "186": {"vr": "IS", "Value": [3000]},
        "187": {"vr": "IS", "Value": [3000]},
        "188": {"vr": "IS", "Value": [3000]},
        "189": {"vr": "IS", "Value": [3000]},
        "190": {"vr": "IS", "Value": [3000]},
        "191": {"vr": "IS", "Value": [0]},
        "192": {"vr": "IS", "Value": [3000]},
        "193": {"vr": "IS", "Value": [3000]},
        "194": {"vr": "IS", "Value": [3000]},
        "195": {"vr": "IS", "Value": [3000]},
        "196": {"vr": "IS", "Value": [3000]},
        "197": {"vr": "IS", "Value": [3000]},
        "198": {"vr": "IS", "Value": [0]},
        "199": {"vr": "IS", "Value": [3000]},
        "200": {"vr": "IS", "Value": [3000]},
        "201": {"vr": "IS", "Value": [3000]},
        "202": {"vr": "IS", "Value": [3000]},
        "203": {"vr": "IS", "Value": [3000]},
        "204": {"vr": "IS", "Value": [3000]},
        "205": {"vr": "IS", "Value": [3000]},
        "206": {"vr": "IS", "Value": [3000]},
        "207": {"vr": "IS", "Value": [3000]},
        "208": {"vr": "IS", "Value": [3000]},
        "209": {"vr": "IS", "Value": [3000]},
        "210": {"vr": "IS", "Value": [0]},
        "211": {"vr": "IS", "Value": [3000]},
        "212": {"vr": "IS", "Value": [3000]},
        "213": {"vr": "IS", "Value": [3000]},
        "214": {"vr": "IS", "Value": [3000]},
        "215": {"vr": "IS", "Value": [3000]},
        "216": {"vr": "IS", "Value": [3000]},
        "217": {"vr": "IS", "Value": [3000]},
        "218": {"vr": "IS", "Value": [3000]},
        "219": {"vr": "IS", "Value": [3000]},
        "220": {"vr": "IS", "Value": [3000]},
        "221": {"vr": "IS", "Value": [3000]},
        "222": {"vr": "IS", "Value": [3000]},
        "223": {"vr": "IS", "Value": [3000]},
        "224": {"vr": "IS", "Value": [3000]},
        "225": {"vr": "IS", "Value": [3000]},
        "226": {"vr": "IS", "Value": [3000]},
        "227": {"vr": "IS", "Value": [0]},
        "228": {"vr": "IS", "Value": [3000]},
        "229": {"vr": "IS", "Value": [3000]},
        "230": {"vr": "IS", "Value": [3000]},
        "231": {"vr": "IS", "Value": [3000]},
        "232": {"vr": "IS", "Value": [3000]},
        "233": {"vr": "IS", "Value": [3000]},
        "234": {"vr": "IS", "Value": [3000]},
        "235": {"vr": "IS", "Value": [3000]},
        "236": {"vr": "IS", "Value": [3000]},
        "237": {"vr": "IS", "Value": [3000]},
        "238": {"vr": "IS", "Value": [3000]},
        "239": {"vr": "IS", "Value": [3000]},
        "240": {"vr": "IS", "Value": [3000]},
        "241": {"vr": "IS", "Value": [3000]},
        "242": {"vr": "IS", "Value": [3000]},
        "243": {"vr": "IS", "Value": [0]},
        "244": {"vr": "IS", "Value": [3000]},
        "245": {"vr": "IS", "Value": [3000]},
        "246": {"vr": "IS", "Value": [0]},
        "247": {"vr": "IS", "Value": [3000]},
        "248": {"vr": "IS", "Value": [3000]},
        "249": {"vr": "IS", "Value": [3000]},
        "250": {"vr": "IS", "Value": [3000]},
        "251": {"vr": "IS", "Value": [3000]},
        "252": {"vr": "IS", "Value": [3000]},
        "253": {"vr": "IS", "Value": [3000]},
        "254": {"vr": "IS", "Value": [3000]},
        "255": {"vr": "IS", "Value": [3000]},
        "256": {"vr": "IS", "Value": [0]},
        "257": {"vr": "IS", "Value": [3000]},
        "258": {"vr": "IS", "Value": [3000]},
        "259": {"vr": "IS", "Value": [3000]},
        "260": {"vr": "IS", "Value": [3000]},
        "261": {"vr": "IS", "Value": [3000]},
        "262": {"vr": "IS", "Value": [3000]},
        "263": {"vr": "IS", "Value": [3000]},
        "264": {"vr": "IS", "Value": [3000]},
        "265": {"vr": "IS", "Value": [3000]},
        "266": {"vr": "IS", "Value": [3000]},
        "267": {"vr": "IS", "Value": [3000]},
        "268": {"vr": "IS", "Value": [3000]},
        "269": {"vr": "IS", "Value": [3000]},
        "270": {"vr": "IS", "Value": [0]},
        "271": {"vr": "IS", "Value": [3000]},
        "272": {"vr": "IS", "Value": [3000]},
        "273": {"vr": "IS", "Value": [3000]},
        "274": {"vr": "IS", "Value": [3000]},
        "275": {"vr": "IS", "Value": [0]},
        "276": {"vr": "IS", "Value": [3000]},
        "277": {"vr": "IS", "Value": [3000]},
        "278": {"vr": "IS", "Value": [3000]},
        "279": {"vr": "IS", "Value": [3000]},
        "280": {"vr": "IS", "Value": [3000]},
        "281": {"vr": "IS", "Value": [3000]},
        "282": {"vr": "IS", "Value": [3000]},
        "283": {"vr": "IS", "Value": [3000]},
        "284": {"vr": "IS", "Value": [3000]},
        "285": {"vr": "IS", "Value": [3000]},
        "286": {"vr": "IS", "Value": [3000]},
        "287": {"vr": "IS", "Value": [3000]},
        "288": {"vr": "IS", "Value": [3000]},
        "289": {"vr": "IS", "Value": [3000]},
        "290": {"vr": "IS", "Value": [0]},
        "291": {"vr": "IS", "Value": [3000]},
        "292": {"vr": "IS", "Value": [3000]},
        "293": {"vr": "IS", "Value": [3000]},
        "294": {"vr": "IS", "Value": [3000]},
        "295": {"vr": "IS", "Value": [3000]},
        "296": {"vr": "IS", "Value": [3000]},
        "297": {"vr": "IS", "Value": [3000]},
        "298": {"vr": "IS", "Value": [3000]},
        "299": {"vr": "IS", "Value": [3000]},
        "300": {"vr": "IS", "Value": [3000]},
        "301": {"vr": "IS", "Value": [0]},
        "302": {"vr": "IS", "Value": [3000]},
        "303": {"vr": "IS", "Value": [3000]},
        "304": {"vr": "IS", "Value": [3000]},
        "305": {"vr": "IS", "Value": [3000]},
        "306": {"vr": "IS", "Value": [3000]},
        "307": {"vr": "IS", "Value": [3000]},
        "308": {"vr": "IS", "Value": [3000]},
        "309": {"vr": "IS", "Value": [3000]},
        "310": {"vr": "IS", "Value": [3000]},
        "311": {"vr": "IS", "Value": [0]},
        "312": {"vr": "IS", "Value": [3000]},
        "313": {"vr": "IS", "Value": [0]},
        "314": {"vr": "IS", "Value": [3000]},
        "315": {"vr": "IS", "Value": [3000]},
        "316": {"vr": "IS", "Value": [0]},
        "317": {"vr": "IS", "Value": [3000]},
        "318": {"vr": "IS", "Value": [3000]},
        "319": {"vr": "IS", "Value": [3000]},
        "320": {"vr": "IS", "Value": [3000]},
        "321": {"vr": "IS", "Value": [3000]},
        "322": {"vr": "IS", "Value": [3000]},
        "323": {"vr": "IS", "Value": [3000]},
        "324": {"vr": "IS", "Value": [3000]},
        "325": {"vr": "IS", "Value": [3000]},
        "326": {"vr": "IS", "Value": [3000]},
        "327": {"vr": "IS", "Value": [3000]},
        "328": {"vr": "IS", "Value": [3000]},
        "329": {"vr": "IS", "Value": [3000]},
        "330": {"vr": "IS", "Value": [3000]},
        "331": {"vr": "IS", "Value": [3000]},
        "332": {"vr": "IS", "Value": [3000]},
        "333": {"vr": "IS", "Value": [3000]},
        "334": {"vr": "IS", "Value": [3000]},
        "335": {"vr": "IS", "Value": [3000]},
        "336": {"vr": "IS", "Value": [3000]},
        "337": {"vr": "IS", "Value": [3000]},
        "338": {"vr": "IS", "Value": [3000]},
        "339": {"vr": "IS", "Value": [3000]},
        "340": {"vr": "IS", "Value": [3000]},
        "341": {"vr": "IS", "Value": [3000]},
        "342": {"vr": "IS", "Value": [3000]},
        "343": {"vr": "IS", "Value": [3000]},
        "344": {"vr": "IS", "Value": [3000]},
        "345": {"vr": "IS", "Value": [3000]},
        "346": {"vr": "IS", "Value": [3000]},
        "347": {"vr": "IS", "Value": [3000]},
        "348": {"vr": "IS", "Value": [3000]},
        "349": {"vr": "IS", "Value": [0]},
        "350": {"vr": "IS", "Value": [0]},
        "351": {"vr": "IS", "Value": [3000]},
        "352": {"vr": "IS", "Value": [3000]},
        "353": {"vr": "IS", "Value": [3000]},
        "354": {"vr": "IS", "Value": [3000]},
        "355": {"vr": "IS", "Value": [3000]},
        "356": {"vr": "IS", "Value": [3000]},
        "357": {"vr": "IS", "Value": [3000]},
        "358": {"vr": "IS", "Value": [3000]},
        "359": {"vr": "IS", "Value": [3000]},
        "360": {"vr": "IS", "Value": [3000]},
        "361": {"vr": "IS", "Value": [0]},
        "362": {"vr": "IS", "Value": [3000]},
        "363": {"vr": "IS", "Value": [0]},
        "364": {"vr": "IS", "Value": [3000]},
        "365": {"vr": "IS", "Value": [3000]},
        "366": {"vr": "IS", "Value": [3000]},
        "367": {"vr": "IS", "Value": [3000]},
        "368": {"vr": "IS", "Value": [0]},
        "369": {"vr": "IS", "Value": [3000]},
        "370": {"vr": "IS", "Value": [3000]},
        "371": {"vr": "IS", "Value": [3000]},
        "372": {"vr": "IS", "Value": [3000]},
        "373": {"vr": "IS", "Value": [3000]},
        "374": {"vr": "IS", "Value": [3000]},
        "375": {"vr": "IS", "Value": [3000]},
        "376": {"vr": "IS", "Value": [3000]},
        "377": {"vr": "IS", "Value": [3000]},
        "378": {"vr": "IS", "Value": [3000]},
        "379": {"vr": "IS", "Value": [3000]},
        "380": {"vr": "IS", "Value": [3000]},
        "381": {"vr": "IS", "Value": [3000]},
        "382": {"vr": "IS", "Value": [3000]},
        "383": {"vr": "IS", "Value": [0]},
        "384": {"vr": "IS", "Value": [0]},
        "385": {"vr": "IS", "Value": [3000]},
        "386": {"vr": "IS", "Value": [3000]},
        "387": {"vr": "IS", "Value": [3000]},
        "388": {"vr": "IS", "Value": [3000]},
        "389": {"vr": "IS", "Value": [3000]},
        "390": {"vr": "IS", "Value": [3000]},
        "391": {"vr": "IS", "Value": [3000]},
        "392": {"vr": "IS", "Value": [3000]},
        "393": {"vr": "IS", "Value": [3000]},
        "394": {"vr": "IS", "Value": [3000]},
        "395": {"vr": "IS", "Value": [3000]},
        "396": {"vr": "IS", "Value": [0]},
        "397": {"vr": "IS", "Value": [3000]},
        "398": {"vr": "IS", "Value": [3000]},
        "399": {"vr": "IS", "Value": [0]},
        "400": {"vr": "IS", "Value": [3000]},
        "401": {"vr": "IS", "Value": [3000]},
        "402": {"vr": "IS", "Value": [3000]},
        "403": {"vr": "IS", "Value": [3000]},
        "404": {"vr": "IS", "Value": [3000]},
        "405": {"vr": "IS", "Value": [3000]},
        "406": {"vr": "IS", "Value": [3000]},
        "407": {"vr": "IS", "Value": [3000]},
        "408": {"vr": "IS", "Value": [3000]},
        "409": {"vr": "IS", "Value": [3000]},
        "410": {"vr": "IS", "Value": [3000]},
        "411": {"vr": "IS", "Value": [3000]},
        "412": {"vr": "IS", "Value": [3000]},
        "413": {"vr": "IS", "Value": [3000]},
        "414": {"vr": "IS", "Value": [3000]},
        "415": {"vr": "IS", "Value": [3000]},
        "416": {"vr": "IS", "Value": [3000]},
        "417": {"vr": "IS", "Value": [3000]},
        "418": {"vr": "IS", "Value": [0]},
        "419": {"vr": "IS", "Value": [3000]},
        "420": {"vr": "IS", "Value": [3000]},
        "421": {"vr": "IS", "Value": [3000]},
        "422": {"vr": "IS", "Value": [3000]},
        "423": {"vr": "IS", "Value": [3000]},
        "424": {"vr": "IS", "Value": [0]},
        "425": {"vr": "IS", "Value": [3000]},
        "426": {"vr": "IS", "Value": [3000]},
        "427": {"vr": "IS", "Value": [3000]},
        "428": {"vr": "IS", "Value": [3000]},
        "429": {"vr": "IS", "Value": [3000]},
        "430": {"vr": "IS", "Value": [3000]},
        "431": {"vr": "IS", "Value": [3000]},
        "432": {"vr": "IS", "Value": [3000]},
        "433": {"vr": "IS", "Value": [3000]},
        "434": {"vr": "IS", "Value": [3000]},
        "435": {"vr": "IS", "Value": [3000]},
        "436": {"vr": "IS", "Value": [3000]},
        "437": {"vr": "IS", "Value": [3000]},
        "438": {"vr": "IS", "Value": [3000]},
        "439": {"vr": "IS", "Value": [3000]},
        "440": {"vr": "IS", "Value": [3000]},
        "441": {"vr": "IS", "Value": [3000]},
        "442": {"vr": "IS", "Value": [3000]},
        "443": {"vr": "IS", "Value": [3000]},
        "444": {"vr": "IS", "Value": [3000]},
        "445": {"vr": "IS", "Value": [0]},
        "446": {"vr": "IS", "Value": [3000]},
        "447": {"vr": "IS", "Value": [3000]},
        "448": {"vr": "IS", "Value": [0]},
        "449": {"vr": "IS", "Value": [3000]},
        "450": {"vr": "IS", "Value": [3000]},
        "451": {"vr": "IS", "Value": [3000]},
        "452": {"vr": "IS", "Value": [3000]},
        "453": {"vr": "IS", "Value": [3000]},
        "454": {"vr": "IS", "Value": [3000]},
        "455": {"vr": "IS", "Value": [3000]},
        "456": {"vr": "IS", "Value": [3000]},
        "457": {"vr": "IS", "Value": [3000]},
        "458": {"vr": "IS", "Value": [3000]},
        "459": {"vr": "IS", "Value": [3000]},
        "460": {"vr": "IS", "Value": [3000]},
        "461": {"vr": "IS", "Value": [3000]},
        "462": {"vr": "IS", "Value": [3000]},
        "463": {"vr": "IS", "Value": [3000]},
        "464": {"vr": "IS", "Value": [3000]},
        "465": {"vr": "IS", "Value": [3000]},
        "466": {"vr": "IS", "Value": [3000]},
        "467": {"vr": "IS", "Value": [3000]},
        "468": {"vr": "IS", "Value": [3000]},
        "469": {"vr": "IS", "Value": [0]},
        "470": {"vr": "IS", "Value": [3000]},
        "471": {"vr": "IS", "Value": [3000]},
        "472": {"vr": "IS", "Value": [3000]},
        "473": {"vr": "IS", "Value": [3000]},
        "474": {"vr": "IS", "Value": [3000]},
        "475": {"vr": "IS", "Value": [0]},
        "476": {"vr": "IS", "Value": [3000]},
        "477": {"vr": "IS", "Value": [3000]},
        "478": {"vr": "IS", "Value": [3000]},
        "479": {"vr": "IS", "Value": [3000]},
        "480": {"vr": "IS", "Value": [3000]},
        "481": {"vr": "IS", "Value": [3000]},
        "482": {"vr": "IS", "Value": [3000]},
        "483": {"vr": "IS", "Value": [0]},
        "484": {"vr": "IS", "Value": [3000]},
        "485": {"vr": "IS", "Value": [3000]},
        "486": {"vr": "IS", "Value": [3000]},
        "487": {"vr": "IS", "Value": [3000]},
        "488": {"vr": "IS", "Value": [3000]},
        "489": {"vr": "IS", "Value": [3000]},
        "490": {"vr": "IS", "Value": [3000]},
        "491": {"vr": "IS", "Value": [3000]},
        "492": {"vr": "IS", "Value": [3000]},
        "493": {"vr": "IS", "Value": [3000]},
        "494": {"vr": "IS", "Value": [3000]},
        "495": {"vr": "IS", "Value": [3000]},
        "496": {"vr": "IS", "Value": [3000]},
        "497": {"vr": "IS", "Value": [0]},
        "498": {"vr": "IS", "Value": [3000]},
        "499": {"vr": "IS", "Value": [3000]},
        "500": {"vr": "IS", "Value": [3000]},
        "501": {"vr": "IS", "Value": [0]},
        "502": {"vr": "IS", "Value": [3000]},
        "503": {"vr": "IS", "Value": [3000]},
        "504": {"vr": "IS", "Value": [3000]},
        "505": {"vr": "IS", "Value": [3000]},
        "506": {"vr": "IS", "Value": [3000]},
        "507": {"vr": "IS", "Value": [0]},
        "508": {"vr": "IS", "Value": [3000]},
        "509": {"vr": "IS", "Value": [3000]},
        "510": {"vr": "IS", "Value": [3000]},
        "511": {"vr": "IS", "Value": [3000]},
        "512": {"vr": "IS", "Value": [3000]},
        "513": {"vr": "IS", "Value": [3000]},
        "514": {"vr": "IS", "Value": [0]},
        "515": {"vr": "IS", "Value": [0]},
        "516": {"vr": "IS", "Value": [3000]},
        "517": {"vr": "IS", "Value": [3000]},
        "518": {"vr": "IS", "Value": [3000]},
        "519": {"vr": "IS", "Value": [3000]},
        "520": {"vr": "IS", "Value": [0]},
        "521": {"vr": "IS", "Value": [3000]},
        "522": {"vr": "IS", "Value": [3000]},
        "523": {"vr": "IS", "Value": [3000]},
        "524": {"vr": "IS", "Value": [3000]},
        "525": {"vr": "IS", "Value": [3000]},
        "526": {"vr": "IS", "Value": [3000]},
        "527": {"vr": "IS", "Value": [3000]},
        "528": {"vr": "IS", "Value": [3000]},
        "529": {"vr": "IS", "Value": [3000]},
        "530": {"vr": "IS", "Value": [3000]},
        "531": {"vr": "IS", "Value": [0]},
        "532": {"vr": "IS", "Value": [3000]},
        "533": {"vr": "IS", "Value": [3000]},
        "534": {"vr": "IS", "Value": [3000]},
        "535": {"vr": "IS", "Value": [3000]},
        "536": {"vr": "IS", "Value": [3000]},
        "537": {"vr": "IS", "Value": [3000]},
        "538": {"vr": "IS", "Value": [3000]},
        "539": {"vr": "IS", "Value": [0]},
        "540": {"vr": "IS", "Value": [3000]},
        "541": {"vr": "IS", "Value": [3000]},
        "542": {"vr": "IS", "Value": [0]},
        "543": {"vr": "IS", "Value": [3000]},
        "544": {"vr": "IS", "Value": [0]},
        "545": {"vr": "IS", "Value": [3000]},
        "546": {"vr": "IS", "Value": [3000]},
        "547": {"vr": "IS", "Value": [3000]},
        "548": {"vr": "IS", "Value": [0]},
        "549": {"vr": "IS", "Value": [3000]},
        "550": {"vr": "IS", "Value": [3000]},
        "551": {"vr": "IS", "Value": [3000]},
        "552": {"vr": "IS", "Value": [3000]},
        "553": {"vr": "IS", "Value": [0]},
        "554": {"vr": "IS", "Value": [0]},
        "555": {"vr": "IS", "Value": [0]},
        "556": {"vr": "IS", "Value": [3000]},
        "557": {"vr": "IS", "Value": [3000]},
        "558": {"vr": "IS", "Value": [3000]},
        "559": {"vr": "IS", "Value": [3000]},
        "560": {"vr": "IS", "Value": [3000]},
        "561": {"vr": "IS", "Value": [3000]},
        "562": {"vr": "IS", "Value": [3000]},
        "563": {"vr": "IS", "Value": [3000]},
        "564": {"vr": "IS", "Value": [3000]},
        "565": {"vr": "IS", "Value": [3000]},
        "566": {"vr": "IS", "Value": [3000]},
        "567": {"vr": "IS", "Value": [0]},
        "568": {"vr": "IS", "Value": [3000]},
        "569": {"vr": "IS", "Value": [3000]},
        "570": {"vr": "IS", "Value": [3000]},
        "571": {"vr": "IS", "Value": [3000]},
        "572": {"vr": "IS", "Value": [3000]},
        "573": {"vr": "IS", "Value": [3000]},
        "574": {"vr": "IS", "Value": [3000]},
        "575": {"vr": "IS", "Value": [3000]},
        "576": {"vr": "IS", "Value": [3000]},
        "577": {"vr": "IS", "Value": [3000]},
        "578": {"vr": "IS", "Value": [3000]},
        "579": {"vr": "IS", "Value": [3000]},
        "580": {"vr": "IS", "Value": [3000]},
        "581": {"vr": "IS", "Value": [3000]},
        "582": {"vr": "IS", "Value": [3000]},
        "583": {"vr": "IS", "Value": [3000]},
        "584": {"vr": "IS", "Value": [3000]},
        "585": {"vr": "IS", "Value": [0]},
        "586": {"vr": "IS", "Value": [3000]},
        "587": {"vr": "IS", "Value": [0]},
        "588": {"vr": "IS", "Value": [3000]},
        "589": {"vr": "IS", "Value": [3000]},
        "590": {"vr": "IS", "Value": [3000]},
        "591": {"vr": "IS", "Value": [3000]},
        "592": {"vr": "IS", "Value": [3000]},
        "593": {"vr": "IS", "Value": [3000]},
        "594": {"vr": "IS", "Value": [3000]},
        "595": {"vr": "IS", "Value": [3000]},
        "596": {"vr": "IS", "Value": [3000]},
        "597": {"vr": "IS", "Value": [3000]},
        "598": {"vr": "IS", "Value": [3000]},
        "599": {"vr": "IS", "Value": [3000]},
        "600": {"vr": "IS", "Value": [0]},
        "601": {"vr": "IS", "Value": [3000]},
        "602": {"vr": "IS", "Value": [3000]},
        "603": {"vr": "IS", "Value": [3000]},
        "604": {"vr": "IS", "Value": [3000]},
        "605": {"vr": "IS", "Value": [3000]},
        "606": {"vr": "IS", "Value": [3000]},
        "607": {"vr": "IS", "Value": [3000]},
        "608": {"vr": "IS", "Value": [3000]},
        "609": {"vr": "IS", "Value": [3000]},
        "610": {"vr": "IS", "Value": [3000]},
        "611": {"vr": "IS", "Value": [0]},
        "612": {"vr": "IS", "Value": [3000]},
        "613": {"vr": "IS", "Value": [3000]},
        "614": {"vr": "IS", "Value": [3000]},
        "615": {"vr": "IS", "Value": [3000]},
        "616": {"vr": "IS", "Value": [3000]},
        "617": {"vr": "IS", "Value": [3000]},
        "618": {"vr": "IS", "Value": [3000]},
        "619": {"vr": "IS", "Value": [3000]},
        "620": {"vr": "IS", "Value": [3000]},
        "621": {"vr": "IS", "Value": [3000]},
        "622": {"vr": "IS", "Value": [3000]},
        "623": {"vr": "IS", "Value": [3000]},
        "624": {"vr": "IS", "Value": [0]},
        "625": {"vr": "IS", "Value": [3000]},
        "626": {"vr": "IS", "Value": [3000]},
        "627": {"vr": "IS", "Value": [3000]},
        "628": {"vr": "IS", "Value": [3000]},
        "629": {"vr": "IS", "Value": [3000]},
        "630": {"vr": "IS", "Value": [3000]},
        "631": {"vr": "IS", "Value": [3000]},
        "632": {"vr": "IS", "Value": [3000]},
        "633": {"vr": "IS", "Value": [3000]},
        "634": {"vr": "IS", "Value": [3000]},
        "635": {"vr": "IS", "Value": [3000]},
        "636": {"vr": "IS", "Value": [0]},
        "637": {"vr": "IS", "Value": [3000]},
        "638": {"vr": "IS", "Value": [3000]},
        "639": {"vr": "IS", "Value": [3000]},
        "640": {"vr": "IS", "Value": [3000]},
        "641": {"vr": "IS", "Value": [3000]},
        "642": {"vr": "IS", "Value": [3000]},
        "643": {"vr": "IS", "Value": [3000]},
        "644": {"vr": "IS", "Value": [3000]},
        "645": {"vr": "IS", "Value": [3000]},
        "646": {"vr": "IS", "Value": [3000]},
        "647": {"vr": "IS", "Value": [3000]},
        "648": {"vr": "IS", "Value": [3000]},
        "649": {"vr": "IS", "Value": [3000]},
        "650": {"vr": "IS", "Value": [3000]},
        "651": {"vr": "IS", "Value": [3000]},
        "652": {"vr": "IS", "Value": [3000]},
        "653": {"vr": "IS", "Value": [3000]},
        "654": {"vr": "IS", "Value": [3000]},
        "655": {"vr": "IS", "Value": [3000]},
        "656": {"vr": "IS", "Value": [3000]},
        "657": {"vr": "IS", "Value": [3000]},
        "658": {"vr": "IS", "Value": [3000]},
        "659": {"vr": "IS", "Value": [3000]},
        "660": {"vr": "IS", "Value": [3000]},
        "661": {"vr": "IS", "Value": [3000]},
        "662": {"vr": "IS", "Value": [3000]},
        "663": {"vr": "IS", "Value": [0]},
        "664": {"vr": "IS", "Value": [3000]},
        "665": {"vr": "IS", "Value": [3000]},
        "666": {"vr": "IS", "Value": [3000]},
        "667": {"vr": "IS", "Value": [3000]},
        "668": {"vr": "IS", "Value": [0]},
        "669": {"vr": "IS", "Value": [3000]},
        "670": {"vr": "IS", "Value": [3000]},
        "671": {"vr": "IS", "Value": [3000]},
        "672": {"vr": "IS", "Value": [3000]},
        "673": {"vr": "IS", "Value": [3000]},
        "674": {"vr": "IS", "Value": [3000]},
        "675": {"vr": "IS", "Value": [3000]},
        "676": {"vr": "IS", "Value": [3000]},
        "677": {"vr": "IS", "Value": [3000]},
        "678": {"vr": "IS", "Value": [3000]},
        "679": {"vr": "IS", "Value": [0]},
        "680": {"vr": "IS", "Value": [3000]},
        "681": {"vr": "IS", "Value": [3000]},
        "682": {"vr": "IS", "Value": [3000]},
        "683": {"vr": "IS", "Value": [3000]},
        "684": {"vr": "IS", "Value": [3000]},
        "685": {"vr": "IS", "Value": [3000]},
        "686": {"vr": "IS", "Value": [3000]},
        "687": {"vr": "IS", "Value": [0]},
        "688": {"vr": "IS", "Value": [3000]},
        "689": {"vr": "IS", "Value": [3000]},
        "690": {"vr": "IS", "Value": [0]},
        "691": {"vr": "IS", "Value": [3000]},
        "692": {"vr": "IS", "Value": [3000]},
        "693": {"vr": "IS", "Value": [3000]},
        "694": {"vr": "IS", "Value": [3000]},
        "695": {"vr": "IS", "Value": [3000]},
        "696": {"vr": "IS", "Value": [3000]},
        "697": {"vr": "IS", "Value": [3000]},
        "698": {"vr": "IS", "Value": [3000]},
        "699": {"vr": "IS", "Value": [0]},
        "700": {"vr": "IS", "Value": [3000]},
        "701": {"vr": "IS", "Value": [3000]},
        "702": {"vr": "IS", "Value": [3000]},
        "703": {"vr": "IS", "Value": [3000]},
        "704": {"vr": "IS", "Value": [3000]},
        "705": {"vr": "IS", "Value": [3000]},
        "706": {"vr": "IS", "Value": [3000]},
        "707": {"vr": "IS", "Value": [0]},
        "708": {"vr": "IS", "Value": [3000]},
        "709": {"vr": "IS", "Value": [3000]},
        "710": {"vr": "IS", "Value": [3000]},
        "711": {"vr": "IS", "Value": [3000]},
        "712": {"vr": "IS", "Value": [3000]},
        "713": {"vr": "IS", "Value": [3000]},
        "714": {"vr": "IS", "Value": [0]},
        "715": {"vr": "IS", "Value": [0]},
        "716": {"vr": "IS", "Value": [3000]},
        "717": {"vr": "IS", "Value": [3000]},
        "718": {"vr": "IS", "Value": [3000]},
        "719": {"vr": "IS", "Value": [3000]},
        "720": {"vr": "IS", "Value": [3000]},
        "721": {"vr": "IS", "Value": [3000]},
        "722": {"vr": "IS", "Value": [3000]},
        "723": {"vr": "IS", "Value": [3000]},
        "724": {"vr": "IS", "Value": [3000]},
        "725": {"vr": "IS", "Value": [3000]},
        "726": {"vr": "IS", "Value": [3000]},
        "727": {"vr": "IS", "Value": [3000]},
        "728": {"vr": "IS", "Value": [3000]},
        "729": {"vr": "IS", "Value": [3000]},
        "730": {"vr": "IS", "Value": [3000]},
        "731": {"vr": "IS", "Value": [3000]},
        "732": {"vr": "IS", "Value": [0]},
        "733": {"vr": "IS", "Value": [3000]},
        "734": {"vr": "IS", "Value": [3000]},
        "735": {"vr": "IS", "Value": [3000]},
        "736": {"vr": "IS", "Value": [3000]},
        "737": {"vr": "IS", "Value": [3000]},
        "738": {"vr": "IS", "Value": [3000]},
        "739": {"vr": "IS", "Value": [3000]},
        "740": {"vr": "IS", "Value": [3000]},
        "741": {"vr": "IS", "Value": [3000]},
        "742": {"vr": "IS", "Value": [3000]},
        "743": {"vr": "IS", "Value": [3000]},
        "744": {"vr": "IS", "Value": [3000]},
        "745": {"vr": "IS", "Value": [3000]},
        "746": {"vr": "IS", "Value": [3000]},
        "747": {"vr": "IS", "Value": [3000]},
        "748": {"vr": "IS", "Value": [3000]},
        "749": {"vr": "IS", "Value": [3000]},
        "750": {"vr": "IS", "Value": [3000]},
        "751": {"vr": "IS", "Value": [3000]},
        "752": {"vr": "IS", "Value": [3000]},
        "753": {"vr": "IS", "Value": [3000]},
        "754": {"vr": "IS", "Value": [3000]},
        "755": {"vr": "IS", "Value": [3000]},
        "756": {"vr": "IS", "Value": [3000]},
        "757": {"vr": "IS", "Value": [0]},
        "758": {"vr": "IS", "Value": [3000]},
        "759": {"vr": "IS", "Value": [3000]},
        "760": {"vr": "IS", "Value": [3000]},
        "761": {"vr": "IS", "Value": [3000]},
        "762": {"vr": "IS", "Value": [3000]},
        "763": {"vr": "IS", "Value": [3000]},
        "764": {"vr": "IS", "Value": [3000]},
        "765": {"vr": "IS", "Value": [3000]},
        "766": {"vr": "IS", "Value": [3000]},
        "767": {"vr": "IS", "Value": [3000]},
        "768": {"vr": "IS", "Value": [3000]},
        "769": {"vr": "IS", "Value": [3000]},
        "770": {"vr": "IS", "Value": [3000]},
        "771": {"vr": "IS", "Value": [0]},
        "772": {"vr": "IS", "Value": [3000]},
        "773": {"vr": "IS", "Value": [3000]},
        "774": {"vr": "IS", "Value": [3000]},
        "775": {"vr": "IS", "Value": [3000]},
        "776": {"vr": "IS", "Value": [3000]},
        "777": {"vr": "IS", "Value": [0]},
        "778": {"vr": "IS", "Value": [3000]},
        "779": {"vr": "IS", "Value": [3000]},
        "780": {"vr": "IS", "Value": [3000]},
        "781": {"vr": "IS", "Value": [3000]},
        "782": {"vr": "IS", "Value": [3000]},
        "783": {"vr": "IS", "Value": [3000]},
        "784": {"vr": "IS", "Value": [3000]},
        "785": {"vr": "IS", "Value": [3000]},
        "786": {"vr": "IS", "Value": [3000]},
        "787": {"vr": "IS", "Value": [3000]},
        "788": {"vr": "IS", "Value": [0]},
        "789": {"vr": "IS", "Value": [3000]},
        "790": {"vr": "IS", "Value": [3000]},
        "791": {"vr": "IS", "Value": [0]},
        "792": {"vr": "IS", "Value": [3000]},
        "793": {"vr": "IS", "Value": [3000]},
        "794": {"vr": "IS", "Value": [3000]},
        "795": {"vr": "IS", "Value": [3000]},
        "796": {"vr": "IS", "Value": [3000]},
        "797": {"vr": "IS", "Value": [3000]},
        "798": {"vr": "IS", "Value": [3000]},
        "799": {"vr": "IS", "Value": [3000]},
        "800": {"vr": "IS", "Value": [3000]},
        "801": {"vr": "IS", "Value": [3000]},
        "802": {"vr": "IS", "Value": [3000]},
        "803": {"vr": "IS", "Value": [3000]},
        "804": {"vr": "IS", "Value": [3000]},
        "805": {"vr": "IS", "Value": [3000]},
        "806": {"vr": "IS", "Value": [3000]},
        "807": {"vr": "IS", "Value": [3000]},
        "808": {"vr": "IS", "Value": [3000]},
        "809": {"vr": "IS", "Value": [3000]},
        "810": {"vr": "IS", "Value": [0]},
        "811": {"vr": "IS", "Value": [3000]},
        "812": {"vr": "IS", "Value": [3000]},
        "813": {"vr": "IS", "Value": [3000]},
        "814": {"vr": "IS", "Value": [3000]},
        "815": {"vr": "IS", "Value": [3000]},
        "816": {"vr": "IS", "Value": [0]},
        "817": {"vr": "IS", "Value": [3000]},
        "818": {"vr": "IS", "Value": [3000]},
        "819": {"vr": "IS", "Value": [3000]},
        "820": {"vr": "IS", "Value": [0]},
        "821": {"vr": "IS", "Value": [3000]},
        "822": {"vr": "IS", "Value": [3000]},
        "823": {"vr": "IS", "Value": [3000]},
        "824": {"vr": "IS", "Value": [3000]},
        "825": {"vr": "IS", "Value": [3000]},
        "826": {"vr": "IS", "Value": [3000]},
        "827": {"vr": "IS", "Value": [0]},
        "828": {"vr": "IS", "Value": [3000]},
        "829": {"vr": "IS", "Value": [0]},
        "830": {"vr": "IS", "Value": [3000]},
        "831": {"vr": "IS", "Value": [3000]},
        "832": {"vr": "IS", "Value": [3000]},
        "833": {"vr": "IS", "Value": [3000]},
        "834": {"vr": "IS", "Value": [3000]},
        "835": {"vr": "IS", "Value": [3000]},
        "836": {"vr": "IS", "Value": [3000]},
        "837": {"vr": "IS", "Value": [3000]},
        "838": {"vr": "IS", "Value": [3000]},
        "839": {"vr": "IS", "Value": [3000]},
        "840": {"vr": "IS", "Value": [3000]},
        "841": {"vr": "IS", "Value": [3000]},
        "842": {"vr": "IS", "Value": [3000]},
        "843": {"vr": "IS", "Value": [3000]},
        "844": {"vr": "IS", "Value": [3000]},
        "845": {"vr": "IS", "Value": [3000]},
        "846": {"vr": "IS", "Value": [0]},
        "847": {"vr": "IS", "Value": [3000]},
        "848": {"vr": "IS", "Value": [3000]},
        "849": {"vr": "IS", "Value": [3000]},
        "850": {"vr": "IS", "Value": [0]},
        "851": {"vr": "IS", "Value": [3000]},
        "852": {"vr": "IS", "Value": [3000]},
        "853": {"vr": "IS", "Value": [3000]},
        "854": {"vr": "IS", "Value": [3000]},
        "855": {"vr": "IS", "Value": [3000]},
        "856": {"vr": "IS", "Value": [3000]},
        "857": {"vr": "IS", "Value": [3000]},
        "858": {"vr": "IS", "Value": [3000]},
        "859": {"vr": "IS", "Value": [3000]},
        "860": {"vr": "IS", "Value": [3000]},
        "861": {"vr": "IS", "Value": [0]},
        "862": {"vr": "IS", "Value": [3000]},
        "863": {"vr": "IS", "Value": [3000]},
        "864": {"vr": "IS", "Value": [3000]},
        "865": {"vr": "IS", "Value": [3000]},
        "866": {"vr": "IS", "Value": [3000]},
        "867": {"vr": "IS", "Value": [0]},
        "868": {"vr": "IS", "Value": [0]},
        "869": {"vr": "IS", "Value": [3000]},
        "870": {"vr": "IS", "Value": [0]},
        "871": {"vr": "IS", "Value": [3000]},
        "872": {"vr": "IS", "Value": [3000]},
        "873": {"vr": "IS", "Value": [3000]},
        "874": {"vr": "IS", "Value": [3000]},
        "875": {"vr": "IS", "Value": [0]},
        "876": {"vr": "IS", "Value": [3000]},
        "877": {"vr": "IS", "Value": [3000]},
        "878": {"vr": "IS", "Value": [3000]},
        "879": {"vr": "IS", "Value": [3000]},
        "880": {"vr": "IS", "Value": [3000]},
        "881": {"vr": "IS", "Value": [3000]},
        "882": {"vr": "IS", "Value": [3000]},
        "883": {"vr": "IS", "Value": [3000]},
        "884": {"vr": "IS", "Value": [3000]},
        "885": {"vr": "IS", "Value": [0]},
        "886": {"vr": "IS", "Value": [3000]},
        "887": {"vr": "IS", "Value": [3000]},
        "888": {"vr": "IS", "Value": [3000]},
        "889": {"vr": "IS", "Value": [3000]},
        "890": {"vr": "IS", "Value": [3000]},
        "891": {"vr": "IS", "Value": [3000]},
        "892": {"vr": "IS", "Value": [3000]},
        "893": {"vr": "IS", "Value": [3000]},
        "894": {"vr": "IS", "Value": [3000]},
        "895": {"vr": "IS", "Value": [3000]},
        "896": {"vr": "IS", "Value": [3000]},
        "897": {"vr": "IS", "Value": [3000]},
        "898": {"vr": "IS", "Value": [3000]},
        "899": {"vr": "IS", "Value": [3000]},
        "900": {"vr": "IS", "Value": [3000]},
        "901": {"vr": "IS", "Value": [3000]},
        "902": {"vr": "IS", "Value": [3000]},
        "903": {"vr": "IS", "Value": [3000]},
        "904": {"vr": "IS", "Value": [3000]},
        "905": {"vr": "IS", "Value": [3000]},
        "906": {"vr": "IS", "Value": [3000]},
        "907": {"vr": "IS", "Value": [3000]},
        "908": {"vr": "IS", "Value": [3000]},
        "909": {"vr": "IS", "Value": [3000]},
        "910": {"vr": "IS", "Value": [3000]},
        "911": {"vr": "IS", "Value": [3000]},
        "912": {"vr": "IS", "Value": [3000]},
        "913": {"vr": "IS", "Value": [3000]},
        "914": {"vr": "IS", "Value": [3000]},
        "915": {"vr": "IS", "Value": [3000]},
        "916": {"vr": "IS", "Value": [3000]},
        "917": {"vr": "IS", "Value": [3000]},
        "918": {"vr": "IS", "Value": [3000]},
        "919": {"vr": "IS", "Value": [0]},
        "920": {"vr": "IS", "Value": [3000]},
        "921": {"vr": "IS", "Value": [3000]},
        "922": {"vr": "IS", "Value": [3000]},
        "923": {"vr": "IS", "Value": [3000]},
        "924": {"vr": "IS", "Value": [0]},
        "925": {"vr": "IS", "Value": [3000]},
        "926": {"vr": "IS", "Value": [0]},
        "927": {"vr": "IS", "Value": [3000]},
        "928": {"vr": "IS", "Value": [3000]},
        "929": {"vr": "IS", "Value": [3000]},
        "930": {"vr": "IS", "Value": [3000]},
        "931": {"vr": "IS", "Value": [3000]},
        "932": {"vr": "IS", "Value": [0]},
        "933": {"vr": "IS", "Value": [3000]},
        "934": {"vr": "IS", "Value": [3000]},
        "935": {"vr": "IS", "Value": [3000]},
        "936": {"vr": "IS", "Value": [0]},
        "937": {"vr": "IS", "Value": [3000]},
        "938": {"vr": "IS", "Value": [3000]},
        "939": {"vr": "IS", "Value": [3000]},
        "940": {"vr": "IS", "Value": [3000]},
        "941": {"vr": "IS", "Value": [3000]},
        "942": {"vr": "IS", "Value": [3000]},
        "943": {"vr": "IS", "Value": [3000]},
        "944": {"vr": "IS", "Value": [3000]},
        "945": {"vr": "IS", "Value": [3000]},
        "946": {"vr": "IS", "Value": [3000]},
        "947": {"vr": "IS", "Value": [3000]},
        "948": {"vr": "IS", "Value": [0]},
        "949": {"vr": "IS", "Value": [3000]},
        "950": {"vr": "IS", "Value": [3000]},
        "951": {"vr": "IS", "Value": [3000]},
        "952": {"vr": "IS", "Value": [3000]},
        "953": {"vr": "IS", "Value": [3000]},
        "954": {"vr": "IS", "Value": [3000]},
        "955": {"vr": "IS", "Value": [3000]},
        "956": {"vr": "IS", "Value": [0]},
        "957": {"vr": "IS", "Value": [3000]},
        "958": {"vr": "IS", "Value": [3000]},
        "959": {"vr": "IS", "Value": [3000]},
        "960": {"vr": "IS", "Value": [3000]},
        "961": {"vr": "IS", "Value": [0]},
        "962": {"vr": "IS", "Value": [3000]},
        "963": {"vr": "IS", "Value": [3000]},
        "964": {"vr": "IS", "Value": [3000]},
        "965": {"vr": "IS", "Value": [3000]},
        "966": {"vr": "IS", "Value": [3000]},
        "967": {"vr": "IS", "Value": [3000]},
        "968": {"vr": "IS", "Value": [3000]},
        "969": {"vr": "IS", "Value": [3000]},
        "970": {"vr": "IS", "Value": [3000]},
        "971": {"vr": "IS", "Value": [3000]},
        "972": {"vr": "IS", "Value": [3000]},
        "973": {"vr": "IS", "Value": [3000]},
        "974": {"vr": "IS", "Value": [3000]},
        "975": {"vr": "IS", "Value": [3000]},
        "976": {"vr": "IS", "Value": [3000]},
        "977": {"vr": "IS", "Value": [3000]},
        "978": {"vr": "IS", "Value": [0]},
        "979": {"vr": "IS", "Value": [3000]},
        "980": {"vr": "IS", "Value": [3000]},
        "981": {"vr": "IS", "Value": [3000]},
        "982": {"vr": "IS", "Value": [3000]},
        "983": {"vr": "IS", "Value": [0]},
        "984": {"vr": "IS", "Value": [3000]},
        "985": {"vr": "IS", "Value": [3000]},
        "986": {"vr": "IS", "Value": [3000]},
        "987": {"vr": "IS", "Value": [3000]},
        "988": {"vr": "IS", "Value": [3000]},
        "989": {"vr": "IS", "Value": [3000]},
        "990": {"vr": "IS", "Value": [3000]},
        "991": {"vr": "IS", "Value": [3000]},
        "992": {"vr": "IS", "Value": [3000]},
        "993": {"vr": "IS", "Value": [3000]},
        "994": {"vr": "IS", "Value": [3000]},
        "995": {"vr": "IS", "Value": [3000]},
        "996": {"vr": "IS", "Value": [0]},
        "997": {"vr": "IS", "Value": [3000]},
        "998": {"vr": "IS", "Value": [3000]},
        "999": {"vr": "IS", "Value": [3000]},
        "1000": {"vr": "IS", "Value": [3000]},
        "1001": {"vr": "IS", "Value": [3000]},
        "1002": {"vr": "IS", "Value": [3000]},
        "1003": {"vr": "IS", "Value": [3000]},
        "1004": {"vr": "IS", "Value": [3000]},
        "1005": {"vr": "IS", "Value": [3000]},
        "1006": {"vr": "IS", "Value": [3000]},
        "1007": {"vr": "IS", "Value": [3000]},
        "1008": {"vr": "IS", "Value": [3000]},
        "1009": {"vr": "IS", "Value": [3000]},
        "1010": {"vr": "IS", "Value": [3000]},
        "1011": {"vr": "IS", "Value": [3000]},
        "1012": {"vr": "IS", "Value": [3000]},
        "1013": {"vr": "IS", "Value": [3000]},
        "1014": {"vr": "IS", "Value": [3000]},
        "1015": {"vr": "IS", "Value": [0]},
        "1016": {"vr": "IS", "Value": [0]},
        "1017": {"vr": "IS", "Value": [3000]},
        "1018": {"vr": "IS", "Value": [3000]},
        "1019": {"vr": "IS", "Value": [3000]},
        "1020": {"vr": "IS", "Value": [3000]},
        "1021": {"vr": "IS", "Value": [3000]},
        "1022": {"vr": "IS", "Value": [3000]},
        "1023": {"vr": "IS", "Value": [3000]},
        "1024": {"vr": "IS", "Value": [3000]},
        "1025": {"vr": "IS", "Value": [3000]},
        "1026": {"vr": "IS", "Value": [3000]},
        "1027": {"vr": "IS", "Value": [3000]},
        "1028": {"vr": "IS", "Value": [3000]},
        "1029": {"vr": "IS", "Value": [3000]},
        "1030": {"vr": "IS", "Value": [0]},
        "1031": {"vr": "IS", "Value": [3000]},
        "1032": {"vr": "IS", "Value": [0]},
        "1033": {"vr": "IS", "Value": [3000]},
        "1034": {"vr": "IS", "Value": [3000]},
        "1035": {"vr": "IS", "Value": [3000]},
        "1036": {"vr": "IS", "Value": [3000]},
        "1037": {"vr": "IS", "Value": [3000]},
        "1038": {"vr": "IS", "Value": [3000]},
        "1039": {"vr": "IS", "Value": [0]},
        "1040": {"vr": "IS", "Value": [3000]},
        "1041": {"vr": "IS", "Value": [3000]},
        "1042": {"vr": "IS", "Value": [3000]},
        "1043": {"vr": "IS", "Value": [3000]},
        "1044": {"vr": "IS", "Value": [3000]},
        "1045": {"vr": "IS", "Value": [3000]},
        "1046": {"vr": "IS", "Value": [3000]},
        "1047": {"vr": "IS", "Value": [3000]},
        "1048": {"vr": "IS", "Value": [3000]},
        "1049": {"vr": "IS", "Value": [3000]},
        "1050": {"vr": "IS", "Value": [3000]},
        "1051": {"vr": "IS", "Value": [3000]},
        "1052": {"vr": "IS", "Value": [3000]},
        "1053": {"vr": "IS", "Value": [3000]},
        "1054": {"vr": "IS", "Value": [3000]},
        "1055": {"vr": "IS", "Value": [3000]},
        "1056": {"vr": "IS", "Value": [3000]},
        "1057": {"vr": "IS", "Value": [3000]},
        "1058": {"vr": "IS", "Value": [3000]},
        "1059": {"vr": "IS", "Value": [3000]},
        "1060": {"vr": "IS", "Value": [0]},
        "1061": {"vr": "IS", "Value": [3000]},
        "1062": {"vr": "IS", "Value": [3000]},
        "1063": {"vr": "IS", "Value": [3000]},
        "1064": {"vr": "IS", "Value": [3000]},
        "1065": {"vr": "IS", "Value": [0]},
        "1066": {"vr": "IS", "Value": [3000]},
        "1067": {"vr": "IS", "Value": [3000]},
        "1068": {"vr": "IS", "Value": [3000]},
        "1069": {"vr": "IS", "Value": [3000]},
        "1070": {"vr": "IS", "Value": [3000]},
        "1071": {"vr": "IS", "Value": [3000]},
        "1072": {"vr": "IS", "Value": [3000]},
        "1073": {"vr": "IS", "Value": [0]},
        "1074": {"vr": "IS", "Value": [3000]},
        "1075": {"vr": "IS", "Value": [3000]},
        "1076": {"vr": "IS", "Value": [3000]},
        "1077": {"vr": "IS", "Value": [3000]},
        "1078": {"vr": "IS", "Value": [3000]},
        "1079": {"vr": "IS", "Value": [3000]},
        "1080": {"vr": "IS", "Value": [3000]},
        "1081": {"vr": "IS", "Value": [0]},
        "1082": {"vr": "IS", "Value": [3000]},
        "1083": {"vr": "IS", "Value": [3000]},
        "1084": {"vr": "IS", "Value": [3000]},
        "1085": {"vr": "IS", "Value": [3000]},
        "1086": {"vr": "IS", "Value": [3000]},
        "1087": {"vr": "IS", "Value": [3000]},
        "1088": {"vr": "IS", "Value": [0]},
        "1089": {"vr": "IS", "Value": [3000]},
        "1090": {"vr": "IS", "Value": [0]},
        "1091": {"vr": "IS", "Value": [0]},
        "1092": {"vr": "IS", "Value": [3000]},
        "1093": {"vr": "IS", "Value": [3000]},
        "1094": {"vr": "IS", "Value": [3000]},
        "1095": {"vr": "IS", "Value": [3000]},
        "1096": {"vr": "IS", "Value": [3000]},
        "1097": {"vr": "IS", "Value": [0]},
        "1098": {"vr": "IS", "Value": [3000]},
        "1099": {"vr": "IS", "Value": [3000]},
        "1100": {"vr": "IS", "Value": [3000]},
        "1101": {"vr": "IS", "Value": [3000]},
        "1102": {"vr": "IS", "Value": [3000]},
        "1103": {"vr": "IS", "Value": [3000]},
        "1104": {"vr": "IS", "Value": [3000]},
        "1105": {"vr": "IS", "Value": [0]},
        "1106": {"vr": "IS", "Value": [3000]},
        "1107": {"vr": "IS", "Value": [3000]},
        "1108": {"vr": "IS", "Value": [3000]},
        "1109": {"vr": "IS", "Value": [3000]},
        "1110": {"vr": "IS", "Value": [0]},
        "1111": {"vr": "IS", "Value": [3000]},
        "1112": {"vr": "IS", "Value": [3000]},
        "1113": {"vr": "IS", "Value": [3000]},
        "1114": {"vr": "IS", "Value": [3000]},
        "1115": {"vr": "IS", "Value": [3000]},
        "1116": {"vr": "IS", "Value": [3000]},
        "1117": {"vr": "IS", "Value": [3000]},
        "1118": {"vr": "IS", "Value": [3000]},
        "1119": {"vr": "IS", "Value": [3000]},
        "1120": {"vr": "IS", "Value": [3000]},
        "1121": {"vr": "IS", "Value": [3000]},
        "1122": {"vr": "IS", "Value": [3000]},
        "1123": {"vr": "IS", "Value": [3000]},
        "1124": {"vr": "IS", "Value": [3000]},
        "1125": {"vr": "IS", "Value": [3000]},
        "1126": {"vr": "IS", "Value": [3000]},
        "1127": {"vr": "IS", "Value": [3000]},
        "1128": {"vr": "IS", "Value": [3000]},
        "1129": {"vr": "IS", "Value": [3000]},
        "1130": {"vr": "IS", "Value": [3000]},
        "1131": {"vr": "IS", "Value": [0]},
        "1132": {"vr": "IS", "Value": [3000]},
        "1133": {"vr": "IS", "Value": [3000]},
        "1134": {"vr": "IS", "Value": [3000]},
        "1135": {"vr": "IS", "Value": [3000]},
        "1136": {"vr": "IS", "Value": [0]},
        "1137": {"vr": "IS", "Value": [3000]},
        "1138": {"vr": "IS", "Value": [3000]},
        "1139": {"vr": "IS", "Value": [3000]},
        "1140": {"vr": "IS", "Value": [3000]},
        "1141": {"vr": "IS", "Value": [3000]},
        "1142": {"vr": "IS", "Value": [3000]},
        "1143": {"vr": "IS", "Value": [3000]},
        "1144": {"vr": "IS", "Value": [3000]},
        "1145": {"vr": "IS", "Value": [3000]},
        "1146": {"vr": "IS", "Value": [3000]},
        "1147": {"vr": "IS", "Value": [0]},
        "1148": {"vr": "IS", "Value": [0]},
        "1149": {"vr": "IS", "Value": [0]},
        "1150": {"vr": "IS", "Value": [3000]},
        "1151": {"vr": "IS", "Value": [3000]},
        "1152": {"vr": "IS", "Value": [3000]},
        "1153": {"vr": "IS", "Value": [3000]},
        "1154": {"vr": "IS", "Value": [3000]},
        "1155": {"vr": "IS", "Value": [3000]},
        "1156": {"vr": "IS", "Value": [3000]},
        "1157": {"vr": "IS", "Value": [3000]},
        "1158": {"vr": "IS", "Value": [3000]},
        "1159": {"vr": "IS", "Value": [3000]},
        "1160": {"vr": "IS", "Value": [3000]},
        "1161": {"vr": "IS", "Value": [3000]},
        "1162": {"vr": "IS", "Value": [3000]},
        "1163": {"vr": "IS", "Value": [3000]},
        "1164": {"vr": "IS", "Value": [3000]},
        "1165": {"vr": "IS", "Value": [0]},
        "1166": {"vr": "IS", "Value": [0]},
        "1167": {"vr": "IS", "Value": [3000]},
        "1168": {"vr": "IS", "Value": [3000]},
        "1169": {"vr": "IS", "Value": [3000]},
        "1170": {"vr": "IS", "Value": [3000]},
        "1171": {"vr": "IS", "Value": [3000]},
        "1172": {"vr": "IS", "Value": [3000]},
        "1173": {"vr": "IS", "Value": [3000]},
        "1174": {"vr": "IS", "Value": [3000]},
        "1175": {"vr": "IS", "Value": [3000]},
        "1176": {"vr": "IS", "Value": [3000]},
        "1177": {"vr": "IS", "Value": [3000]},
        "1178": {"vr": "IS", "Value": [0]},
        "1179": {"vr": "IS", "Value": [3000]},
        "1180": {"vr": "IS", "Value": [3000]},
        "1181": {"vr": "IS", "Value": [3000]},
        "1182": {"vr": "IS", "Value": [3000]},
        "1183": {"vr": "IS", "Value": [3000]},
        "1184": {"vr": "IS", "Value": [3000]},
        "1185": {"vr": "IS", "Value": [3000]},
        "1186": {"vr": "IS", "Value": [3000]},
        "1187": {"vr": "IS", "Value": [3000]},
        "1188": {"vr": "IS", "Value": [3000]},
        "1189": {"vr": "IS", "Value": [0]},
        "1190": {"vr": "IS", "Value": [3000]},
        "1191": {"vr": "IS", "Value": [0]},
        "1192": {"vr": "IS", "Value": [3000]},
        "1193": {"vr": "IS", "Value": [0]},
        "1194": {"vr": "IS", "Value": [3000]},
        "1195": {"vr": "IS", "Value": [3000]},
        "1196": {"vr": "IS", "Value": [3000]},
        "1197": {"vr": "IS", "Value": [3000]},
        "1198": {"vr": "IS", "Value": [3000]},
        "1199": {"vr": "IS", "Value": [3000]},
        "1200": {"vr": "IS", "Value": [3000]},
        "1201": {"vr": "IS", "Value": [0]},
        "1202": {"vr": "IS", "Value": [0]},
        "1203": {"vr": "IS", "Value": [3000]},
        "1204": {"vr": "IS", "Value": [3000]},
        "1205": {"vr": "IS", "Value": [3000]},
        "1206": {"vr": "IS", "Value": [3000]},
        "1207": {"vr": "IS", "Value": [3000]},
        "1208": {"vr": "IS", "Value": [3000]},
        "1209": {"vr": "IS", "Value": [3000]},
        "1210": {"vr": "IS", "Value": [3000]},
        "1211": {"vr": "IS", "Value": [3000]},
        "1212": {"vr": "IS", "Value": [3000]},
        "1213": {"vr": "IS", "Value": [3000]},
        "1214": {"vr": "IS", "Value": [3000]},
        "1215": {"vr": "IS", "Value": [3000]},
        "1216": {"vr": "IS", "Value": [3000]},
        "1217": {"vr": "IS", "Value": [3000]},
        "1218": {"vr": "IS", "Value": [3000]},
        "1219": {"vr": "IS", "Value": [0]},
        "1220": {"vr": "IS", "Value": [0]},
        "1221": {"vr": "IS", "Value": [3000]},
        "1222": {"vr": "IS", "Value": [3000]},
        "1223": {"vr": "IS", "Value": [3000]},
        "1224": {"vr": "IS", "Value": [3000]},
        "1225": {"vr": "IS", "Value": [3000]},
        "1226": {"vr": "IS", "Value": [3000]},
        "1227": {"vr": "IS", "Value": [3000]},
        "1228": {"vr": "IS", "Value": [3000]},
        "1229": {"vr": "IS", "Value": [3000]},
        "1230": {"vr": "IS", "Value": [3000]},
        "1231": {"vr": "IS", "Value": [3000]},
        "1232": {"vr": "IS", "Value": [3000]},
        "1233": {"vr": "IS", "Value": [3000]},
        "1234": {"vr": "IS", "Value": [3000]},
        "1235": {"vr": "IS", "Value": [3000]},
        "1236": {"vr": "IS", "Value": [3000]},
        "1237": {"vr": "IS", "Value": [3000]},
        "1238": {"vr": "IS", "Value": [3000]},
        "1239": {"vr": "IS", "Value": [3000]},
        "1240": {"vr": "IS", "Value": [3000]},
        "1241": {"vr": "IS", "Value": [3000]},
        "1242": {"vr": "IS", "Value": [3000]},
        "1243": {"vr": "IS", "Value": [3000]},
        "1244": {"vr": "IS", "Value": [3000]},
        "1245": {"vr": "IS", "Value": [3000]},
        "1246": {"vr": "IS", "Value": [3000]},
        "1247": {"vr": "IS", "Value": [3000]},
        "1248": {"vr": "IS", "Value": [3000]},
        "1249": {"vr": "IS", "Value": [3000]},
        "1250": {"vr": "IS", "Value": [3000]},
        "1251": {"vr": "IS", "Value": [3000]},
        "1252": {"vr": "IS", "Value": [3000]},
        "1253": {"vr": "IS", "Value": [3000]},
        "1254": {"vr": "IS", "Value": [3000]},
        "1255": {"vr": "IS", "Value": [3000]},
        "1256": {"vr": "IS", "Value": [3000]},
        "1257": {"vr": "IS", "Value": [3000]},
        "1258": {"vr": "IS", "Value": [3000]},
        "1259": {"vr": "IS", "Value": [3000]},
        "1260": {"vr": "IS", "Value": [0]},
        "1261": {"vr": "IS", "Value": [3000]},
        "1262": {"vr": "IS", "Value": [3000]},
        "1263": {"vr": "IS", "Value": [3000]},
        "1264": {"vr": "IS", "Value": [0]},
        "1265": {"vr": "IS", "Value": [3000]},
        "1266": {"vr": "IS", "Value": [3000]},
        "1267": {"vr": "IS", "Value": [3000]},
        "1268": {"vr": "IS", "Value": [3000]},
        "1269": {"vr": "IS", "Value": [3000]},
        "1270": {"vr": "IS", "Value": [3000]},
        "1271": {"vr": "IS", "Value": [0]},
        "1272": {"vr": "IS", "Value": [3000]},
        "1273": {"vr": "IS", "Value": [3000]},
        "1274": {"vr": "IS", "Value": [3000]},
        "1275": {"vr": "IS", "Value": [3000]},
        "1276": {"vr": "IS", "Value": [3000]},
        "1277": {"vr": "IS", "Value": [3000]},
        "1278": {"vr": "IS", "Value": [3000]},
        "1279": {"vr": "IS", "Value": [3000]},
        "1280": {"vr": "IS", "Value": [3000]},
        "1281": {"vr": "IS", "Value": [3000]},
        "1282": {"vr": "IS", "Value": [0]},
        "1283": {"vr": "IS", "Value": [3000]},
        "1284": {"vr": "IS", "Value": [3000]},
        "1285": {"vr": "IS", "Value": [3000]},
        "1286": {"vr": "IS", "Value": [3000]},
        "1287": {"vr": "IS", "Value": [3000]},
        "1288": {"vr": "IS", "Value": [3000]},
        "1289": {"vr": "IS", "Value": [3000]},
        "1290": {"vr": "IS", "Value": [3000]},
        "1291": {"vr": "IS", "Value": [0]},
        "1292": {"vr": "IS", "Value": [3000]},
        "1293": {"vr": "IS", "Value": [3000]},
        "1294": {"vr": "IS", "Value": [3000]},
        "1295": {"vr": "IS", "Value": [3000]},
        "1296": {"vr": "IS", "Value": [3000]},
        "1297": {"vr": "IS", "Value": [3000]},
        "1298": {"vr": "IS", "Value": [3000]},
        "1299": {"vr": "IS", "Value": [3000]},
        "1300": {"vr": "IS", "Value": [0]},
        "1301": {"vr": "IS", "Value": [3000]},
        "1302": {"vr": "IS", "Value": [3000]},
        "1303": {"vr": "IS", "Value": [3000]},
        "1304": {"vr": "IS", "Value": [3000]},
        "1305": {"vr": "IS", "Value": [3000]},
        "1306": {"vr": "IS", "Value": [3000]},
        "1307": {"vr": "IS", "Value": [3000]},
        "1308": {"vr": "IS", "Value": [3000]},
        "1309": {"vr": "IS", "Value": [0]},
        "1310": {"vr": "IS", "Value": [3000]},
        "1311": {"vr": "IS", "Value": [3000]},
        "1312": {"vr": "IS", "Value": [3000]},
        "1313": {"vr": "IS", "Value": [3000]},
        "1314": {"vr": "IS", "Value": [3000]},
        "1315": {"vr": "IS", "Value": [3000]},
        "1316": {"vr": "IS", "Value": [3000]},
        "1317": {"vr": "IS", "Value": [3000]},
        "1318": {"vr": "IS", "Value": [3000]},
        "1319": {"vr": "IS", "Value": [3000]},
        "1320": {"vr": "IS", "Value": [3000]},
        "1321": {"vr": "IS", "Value": [3000]},
        "1322": {"vr": "IS", "Value": [3000]},
        "1323": {"vr": "IS", "Value": [3000]},
        "1324": {"vr": "IS", "Value": [0]},
        "1325": {"vr": "IS", "Value": [3000]},
        "1326": {"vr": "IS", "Value": [0]},
        "1327": {"vr": "IS", "Value": [3000]},
        "1328": {"vr": "IS", "Value": [3000]},
        "1329": {"vr": "IS", "Value": [3000]},
        "1330": {"vr": "IS", "Value": [0]},
        "1331": {"vr": "IS", "Value": [3000]},
        "1332": {"vr": "IS", "Value": [3000]},
        "1333": {"vr": "IS", "Value": [0]},
        "1334": {"vr": "IS", "Value": [3000]},
        "1335": {"vr": "IS", "Value": [3000]},
        "1336": {"vr": "IS", "Value": [3000]},
        "1337": {"vr": "IS", "Value": [3000]},
        "1338": {"vr": "IS", "Value": [3000]},
        "1339": {"vr": "IS", "Value": [3000]},
        "1340": {"vr": "IS", "Value": [3000]},
        "1341": {"vr": "IS", "Value": [3000]},
        "1342": {"vr": "IS", "Value": [3000]},
        "1343": {"vr": "IS", "Value": [3000]},
        "1344": {"vr": "IS", "Value": [3000]},
        "1345": {"vr": "IS", "Value": [3000]},
        "1346": {"vr": "IS", "Value": [3000]},
        "1347": {"vr": "IS", "Value": [0]},
        "1348": {"vr": "IS", "Value": [3000]},
        "1349": {"vr": "IS", "Value": [3000]},
        "1350": {"vr": "IS", "Value": [3000]},
        "1351": {"vr": "IS", "Value": [3000]},
        "1352": {"vr": "IS", "Value": [3000]},
        "1353": {"vr": "IS", "Value": [3000]},
        "1354": {"vr": "IS", "Value": [3000]},
        "1355": {"vr": "IS", "Value": [3000]},
        "1356": {"vr": "IS", "Value": [3000]},
        "1357": {"vr": "IS", "Value": [3000]},
        "1358": {"vr": "IS", "Value": [0]},
        "1359": {"vr": "IS", "Value": [3000]},
        "1360": {"vr": "IS", "Value": [3000]},
        "1361": {"vr": "IS", "Value": [3000]},
        "1362": {"vr": "IS", "Value": [3000]},
        "1363": {"vr": "IS", "Value": [3000]},
        "1364": {"vr": "IS", "Value": [3000]},
        "1365": {"vr": "IS", "Value": [3000]},
        "1366": {"vr": "IS", "Value": [3000]},
        "1367": {"vr": "IS", "Value": [3000]},
        "1368": {"vr": "IS", "Value": [3000]},
        "1369": {"vr": "IS", "Value": [3000]},
        "1370": {"vr": "IS", "Value": [3000]},
        "1371": {"vr": "IS", "Value": [3000]},
        "1372": {"vr": "IS", "Value": [3000]},
        "1373": {"vr": "IS", "Value": [3000]},
        "1374": {"vr": "IS", "Value": [3000]},
        "1375": {"vr": "IS", "Value": [0]},
        "1376": {"vr": "IS", "Value": [3000]},
        "1377": {"vr": "IS", "Value": [3000]},
        "1378": {"vr": "IS", "Value": [3000]},
        "1379": {"vr": "IS", "Value": [3000]},
        "1380": {"vr": "IS", "Value": [3000]},
        "1381": {"vr": "IS", "Value": [0]},
        "1382": {"vr": "IS", "Value": [3000]},
        "1383": {"vr": "IS", "Value": [3000]},
        "1384": {"vr": "IS", "Value": [3000]},
        "1385": {"vr": "IS", "Value": [3000]},
        "1386": {"vr": "IS", "Value": [3000]},
        "1387": {"vr": "IS", "Value": [3000]},
        "1388": {"vr": "IS", "Value": [3000]},
        "1389": {"vr": "IS", "Value": [3000]},
        "1390": {"vr": "IS", "Value": [3000]},
        "1391": {"vr": "IS", "Value": [3000]},
        "1392": {"vr": "IS", "Value": [3000]},
        "1393": {"vr": "IS", "Value": [3000]},
        "1394": {"vr": "IS", "Value": [3000]},
        "1395": {"vr": "IS", "Value": [3000]},
        "1396": {"vr": "IS", "Value": [3000]},
        "1397": {"vr": "IS", "Value": [3000]},
        "1398": {"vr": "IS", "Value": [3000]},
        "1399": {"vr": "IS", "Value": [3000]},
        "1400": {"vr": "IS", "Value": [3000]},
        "1401": {"vr": "IS", "Value": [3000]},
        "1402": {"vr": "IS", "Value": [3000]},
        "1403": {"vr": "IS", "Value": [3000]},
        "1404": {"vr": "IS", "Value": [0]},
        "1405": {"vr": "IS", "Value": [3000]},
        "1406": {"vr": "IS", "Value": [3000]},
        "1407": {"vr": "IS", "Value": [3000]},
        "1408": {"vr": "IS", "Value": [3000]},
        "1409": {"vr": "IS", "Value": [3000]},
        "1410": {"vr": "IS", "Value": [3000]},
        "1411": {"vr": "IS", "Value": [3000]},
        "1412": {"vr": "IS", "Value": [3000]},
        "1413": {"vr": "IS", "Value": [0]},
        "1414": {"vr": "IS", "Value": [3000]},
        "1415": {"vr": "IS", "Value": [3000]},
        "1416": {"vr": "IS", "Value": [3000]},
        "1417": {"vr": "IS", "Value": [0]},
        "1418": {"vr": "IS", "Value": [3000]},
        "1419": {"vr": "IS", "Value": [3000]},
        "1420": {"vr": "IS", "Value": [3000]},
        "1421": {"vr": "IS", "Value": [3000]},
        "1422": {"vr": "IS", "Value": [3000]},
        "1423": {"vr": "IS", "Value": [3000]},
        "1424": {"vr": "IS", "Value": [3000]},
        "1425": {"vr": "IS", "Value": [3000]},
        "1426": {"vr": "IS", "Value": [3000]},
        "1427": {"vr": "IS", "Value": [3000]},
        "1428": {"vr": "IS", "Value": [3000]},
        "1429": {"vr": "IS", "Value": [3000]},
        "1430": {"vr": "IS", "Value": [0]},
        "1431": {"vr": "IS", "Value": [3000]},
        "1432": {"vr": "IS", "Value": [3000]},
        "1433": {"vr": "IS", "Value": [3000]},
        "1434": {"vr": "IS", "Value": [3000]},
        "1435": {"vr": "IS", "Value": [3000]},
        "1436": {"vr": "IS", "Value": [3000]},
        "1437": {"vr": "IS", "Value": [3000]},
        "1438": {"vr": "IS", "Value": [3000]},
        "1439": {"vr": "IS", "Value": [3000]},
        "1440": {"vr": "IS", "Value": [3000]},
        "1441": {"vr": "IS", "Value": [3000]},
        "1442": {"vr": "IS", "Value": [0]},
        "1443": {"vr": "IS", "Value": [3000]},
        "1444": {"vr": "IS", "Value": [3000]},
        "1445": {"vr": "IS", "Value": [3000]},
        "1446": {"vr": "IS", "Value": [3000]},
        "1447": {"vr": "IS", "Value": [3000]},
        "1448": {"vr": "IS", "Value": [3000]},
        "1449": {"vr": "IS", "Value": [0]},
        "1450": {"vr": "IS", "Value": [3000]},
        "1451": {"vr": "IS", "Value": [3000]},
        "1452": {"vr": "IS", "Value": [3000]},
        "1453": {"vr": "IS", "Value": [3000]},
        "1454": {"vr": "IS", "Value": [3000]},
        "1455": {"vr": "IS", "Value": [0]},
        "1456": {"vr": "IS", "Value": [3000]},
        "1457": {"vr": "IS", "Value": [3000]},
        "1458": {"vr": "IS", "Value": [3000]},
        "1459": {"vr": "IS", "Value": [3000]},
        "1460": {"vr": "IS", "Value": [0]},
        "1461": {"vr": "IS", "Value": [0]},
        "1462": {"vr": "IS", "Value": [3000]},
        "1463": {"vr": "IS", "Value": [3000]},
        "1464": {"vr": "IS", "Value": [3000]},
        "1465": {"vr": "IS", "Value": [3000]},
        "1466": {"vr": "IS", "Value": [3000]},
        "1467": {"vr": "IS", "Value": [3000]},
        "1468": {"vr": "IS", "Value": [3000]},
        "1469": {"vr": "IS", "Value": [3000]},
        "1470": {"vr": "IS", "Value": [3000]},
        "1471": {"vr": "IS", "Value": [3000]},
        "1472": {"vr": "IS", "Value": [3000]},
        "1473": {"vr": "IS", "Value": [3000]},
        "1474": {"vr": "IS", "Value": [0]},
        "1475": {"vr": "IS", "Value": [3000]},
        "1476": {"vr": "IS", "Value": [3000]},
        "1477": {"vr": "IS", "Value": [3000]},
        "1478": {"vr": "IS", "Value": [3000]},
        "1479": {"vr": "IS", "Value": [3000]},
        "1480": {"vr": "IS", "Value": [3000]},
        "1481": {"vr": "IS", "Value": [3000]},
        "1482": {"vr": "IS", "Value": [3000]},
        "1483": {"vr": "IS", "Value": [3000]},
        "1484": {"vr": "IS", "Value": [3000]},
        "1485": {"vr": "IS", "Value": [3000]},
        "1486": {"vr": "IS", "Value": [3000]},
        "1487": {"vr": "IS", "Value": [3000]},
        "1488": {"vr": "IS", "Value": [0]},
        "1489": {"vr": "IS", "Value": [3000]},
        "1490": {"vr": "IS", "Value": [3000]},
        "1491": {"vr": "IS", "Value": [3000]},
        "1492": {"vr": "IS", "Value": [3000]},
        "1493": {"vr": "IS", "Value": [0]},
        "1494": {"vr": "IS", "Value": [3000]},
        "1495": {"vr": "IS", "Value": [3000]},
        "1496": {"vr": "IS", "Value": [3000]},
        "1497": {"vr": "IS", "Value": [3000]},
        "1498": {"vr": "IS", "Value": [3000]},
        "1499": {"vr": "IS", "Value": [3000]},
        "1500": {"vr": "IS", "Value": [3000]},
        "1501": {"vr": "IS", "Value": [3000]},
        "1502": {"vr": "IS", "Value": [3000]},
        "1503": {"vr": "IS", "Value": [3000]},
        "1504": {"vr": "IS", "Value": [3000]},
        "1505": {"vr": "IS", "Value": [3000]},
        "1506": {"vr": "IS", "Value": [3000]},
        "1507": {"vr": "IS", "Value": [3000]},
        "1508": {"vr": "IS", "Value": [3000]},
        "1509": {"vr": "IS", "Value": [3000]},
        "1510": {"vr": "IS", "Value": [3000]},
        "1511": {"vr": "IS", "Value": [3000]},
        "1512": {"vr": "IS", "Value": [0]},
        "1513": {"vr": "IS", "Value": [3000]},
        "1514": {"vr": "IS", "Value": [3000]},
        "1515": {"vr": "IS", "Value": [0]},
        "1516": {"vr": "IS", "Value": [3000]},
        "1517": {"vr": "IS", "Value": [0]},
        "1518": {"vr": "IS", "Value": [3000]},
        "1519": {"vr": "IS", "Value": [3000]},
        "1520": {"vr": "IS", "Value": [3000]},
        "1521": {"vr": "IS", "Value": [3000]},
        "1522": {"vr": "IS", "Value": [3000]},
        "1523": {"vr": "IS", "Value": [3000]},
        "1524": {"vr": "IS", "Value": [3000]},
        "1525": {"vr": "IS", "Value": [3000]},
        "1526": {"vr": "IS", "Value": [3000]},
        "1527": {"vr": "IS", "Value": [3000]},
        "1528": {"vr": "IS", "Value": [3000]},
        "1529": {"vr": "IS", "Value": [3000]},
        "1530": {"vr": "IS", "Value": [3000]},
        "1531": {"vr": "IS", "Value": [3000]},
        "1532": {"vr": "IS", "Value": [3000]},
        "1533": {"vr": "IS", "Value": [3000]},
        "1534": {"vr": "IS", "Value": [3000]},
        "1535": {"vr": "IS", "Value": [3000]},
        "1536": {"vr": "IS", "Value": [0]},
        "1537": {"vr": "IS", "Value": [3000]},
        "1538": {"vr": "IS", "Value": [3000]},
        "1539": {"vr": "IS", "Value": [3000]},
        "1540": {"vr": "IS", "Value": [3000]},
        "1541": {"vr": "IS", "Value": [3000]},
        "1542": {"vr": "IS", "Value": [3000]},
        "1543": {"vr": "IS", "Value": [3000]},
        "1544": {"vr": "IS", "Value": [3000]},
        "1545": {"vr": "IS", "Value": [3000]},
        "1546": {"vr": "IS", "Value": [3000]},
        "1547": {"vr": "IS", "Value": [3000]},
        "1548": {"vr": "IS", "Value": [3000]},
        "1549": {"vr": "IS", "Value": [3000]},
        "1550": {"vr": "IS", "Value": [3000]},
        "1551": {"vr": "IS", "Value": [3000]},
        "1552": {"vr": "IS", "Value": [3000]},
        "1553": {"vr": "IS", "Value": [0]},
        "1554": {"vr": "IS", "Value": [3000]},
        "1555": {"vr": "IS", "Value": [0]},
        "1556": {"vr": "IS", "Value": [3000]},
        "1557": {"vr": "IS", "Value": [3000]},
        "1558": {"vr": "IS", "Value": [3000]},
        "1559": {"vr": "IS", "Value": [0]},
        "1560": {"vr": "IS", "Value": [3000]},
        "1561": {"vr": "IS", "Value": [3000]},
        "1562": {"vr": "IS", "Value": [0]},
        "1563": {"vr": "IS", "Value": [3000]},
        "1564": {"vr": "IS", "Value": [3000]},
        "1565": {"vr": "IS", "Value": [3000]},
        "1566": {"vr": "IS", "Value": [3000]},
        "1567": {"vr": "IS", "Value": [3000]},
        "1568": {"vr": "IS", "Value": [3000]},
        "1569": {"vr": "IS", "Value": [3000]},
        "1570": {"vr": "IS", "Value": [3000]},
        "1571": {"vr": "IS", "Value": [3000]},
        "1572": {"vr": "IS", "Value": [3000]},
        "1573": {"vr": "IS", "Value": [3000]},
        "1574": {"vr": "IS", "Value": [0]},
        "1575": {"vr": "IS", "Value": [3000]},
        "1576": {"vr": "IS", "Value": [3000]},
        "1577": {"vr": "IS", "Value": [3000]},
        "1578": {"vr": "IS", "Value": [3000]},
        "1579": {"vr": "IS", "Value": [3000]},
        "1580": {"vr": "IS", "Value": [3000]},
        "1581": {"vr": "IS", "Value": [3000]},
        "1582": {"vr": "IS", "Value": [3000]},
        "1583": {"vr": "IS", "Value": [3000]},
        "1584": {"vr": "IS", "Value": [3000]},
        "1585": {"vr": "IS", "Value": [3000]},
        "1586": {"vr": "IS", "Value": [3000]},
        "1587": {"vr": "IS", "Value": [3000]},
        "1588": {"vr": "IS", "Value": [3000]},
        "1589": {"vr": "IS", "Value": [3000]},
        "1590": {"vr": "IS", "Value": [0]},
        "1591": {"vr": "IS", "Value": [3000]},
        "1592": {"vr": "IS", "Value": [3000]},
        "1593": {"vr": "IS", "Value": [3000]},
        "1594": {"vr": "IS", "Value": [0]},
        "1595": {"vr": "IS", "Value": [3000]},
        "1596": {"vr": "IS", "Value": [3000]},
        "1597": {"vr": "IS", "Value": [3000]},
        "1598": {"vr": "IS", "Value": [3000]},
        "1599": {"vr": "IS", "Value": [3000]},
        "1600": {"vr": "IS", "Value": [0]},
        "1601": {"vr": "IS", "Value": [0]},
        "1602": {"vr": "IS", "Value": [3000]},
        "1603": {"vr": "IS", "Value": [0]},
        "1604": {"vr": "IS", "Value": [0]},
        "1605": {"vr": "IS", "Value": [3000]},
        "1606": {"vr": "IS", "Value": [3000]},
        "1607": {"vr": "IS", "Value": [3000]},
        "1608": {"vr": "IS", "Value": [3000]},
        "1609": {"vr": "IS", "Value": [3000]},
        "1610": {"vr": "IS", "Value": [0]},
        "1611": {"vr": "IS", "Value": [3000]},
        "1612": {"vr": "IS", "Value": [3000]},
        "1613": {"vr": "IS", "Value": [3000]},
        "1614": {"vr": "IS", "Value": [3000]},
        "1615": {"vr": "IS", "Value": [3000]},
        "1616": {"vr": "IS", "Value": [3000]},
        "1617": {"vr": "IS", "Value": [3000]},
        "1618": {"vr": "IS", "Value": [3000]},
        "1619": {"vr": "IS", "Value": [3000]},
        "1620": {"vr": "IS", "Value": [3000]},
        "1621": {"vr": "IS", "Value": [3000]},
        "1622": {"vr": "IS", "Value": [3000]},
        "1623": {"vr": "IS", "Value": [3000]},
        "1624": {"vr": "IS", "Value": [3000]},
        "1625": {"vr": "IS", "Value": [0]},
        "1626": {"vr": "IS", "Value": [3000]},
        "1627": {"vr": "IS", "Value": [3000]},
        "1628": {"vr": "IS", "Value": [3000]},
        "1629": {"vr": "IS", "Value": [3000]},
        "1630": {"vr": "IS", "Value": [3000]},
        "1631": {"vr": "IS", "Value": [3000]},
        "1632": {"vr": "IS", "Value": [3000]},
        "1633": {"vr": "IS", "Value": [3000]},
        "1634": {"vr": "IS", "Value": [3000]},
        "1635": {"vr": "IS", "Value": [3000]},
        "1636": {"vr": "IS", "Value": [3000]},
        "1637": {"vr": "IS", "Value": [3000]},
        "1638": {"vr": "IS", "Value": [3000]},
        "1639": {"vr": "IS", "Value": [3000]},
        "1640": {"vr": "IS", "Value": [3000]},
        "1641": {"vr": "IS", "Value": [3000]},
        "1642": {"vr": "IS", "Value": [3000]},
        "1643": {"vr": "IS", "Value": [0]},
        "1644": {"vr": "IS", "Value": [0]},
        "1645": {"vr": "IS", "Value": [3000]},
        "1646": {"vr": "IS", "Value": [3000]},
        "1647": {"vr": "IS", "Value": [3000]},
        "1648": {"vr": "IS", "Value": [3000]},
        "1649": {"vr": "IS", "Value": [0]},
        "1650": {"vr": "IS", "Value": [3000]},
        "1651": {"vr": "IS", "Value": [3000]},
        "1652": {"vr": "IS", "Value": [3000]},
        "1653": {"vr": "IS", "Value": [3000]},
        "1654": {"vr": "IS", "Value": [3000]},
        "1655": {"vr": "IS", "Value": [3000]},
        "1656": {"vr": "IS", "Value": [3000]},
        "1657": {"vr": "IS", "Value": [3000]},
        "1658": {"vr": "IS", "Value": [3000]},
        "1659": {"vr": "IS", "Value": [3000]},
        "1660": {"vr": "IS", "Value": [3000]},
        "1661": {"vr": "IS", "Value": [3000]},
        "1662": {"vr": "IS", "Value": [3000]},
        "1663": {"vr": "IS", "Value": [3000]},
        "1664": {"vr": "IS", "Value": [3000]},
        "1665": {"vr": "IS", "Value": [3000]},
        "1666": {"vr": "IS", "Value": [3000]},
        "1667": {"vr": "IS", "Value": [3000]},
        "1668": {"vr": "IS", "Value": [3000]},
        "1669": {"vr": "IS", "Value": [3000]},
        "1670": {"vr": "IS", "Value": [3000]},
        "1671": {"vr": "IS", "Value": [3000]},
        "1672": {"vr": "IS", "Value": [3000]},
        "1673": {"vr": "IS", "Value": [3000]},
        "1674": {"vr": "IS", "Value": [3000]},
        "1675": {"vr": "IS", "Value": [3000]},
        "1676": {"vr": "IS", "Value": [3000]},
        "1677": {"vr": "IS", "Value": [3000]},
        "1678": {"vr": "IS", "Value": [3000]},
        "1679": {"vr": "IS", "Value": [3000]},
        "1680": {"vr": "IS", "Value": [3000]},
        "1681": {"vr": "IS", "Value": [3000]},
        "1682": {"vr": "IS", "Value": [3000]},
        "1683": {"vr": "IS", "Value": [3000]},
        "1684": {"vr": "IS", "Value": [3000]},
        "1685": {"vr": "IS", "Value": [3000]},
        "1686": {"vr": "IS", "Value": [3000]},
        "1687": {"vr": "IS", "Value": [3000]},
        "1688": {"vr": "IS", "Value": [3000]},
        "1689": {"vr": "IS", "Value": [0]},
        "1690": {"vr": "IS", "Value": [3000]},
        "1691": {"vr": "IS", "Value": [0]},
        "1692": {"vr": "IS", "Value": [3000]},
        "1693": {"vr": "IS", "Value": [3000]},
        "1694": {"vr": "IS", "Value": [3000]},
        "1695": {"vr": "IS", "Value": [3000]},
        "1696": {"vr": "IS", "Value": [3000]},
        "1697": {"vr": "IS", "Value": [3000]},
        "1698": {"vr": "IS", "Value": [3000]},
        "1699": {"vr": "IS", "Value": [3000]},
        "1700": {"vr": "IS", "Value": [0]},
        "1701": {"vr": "IS", "Value": [3000]},
        "1702": {"vr": "IS", "Value": [3000]},
        "1703": {"vr": "IS", "Value": [3000]},
        "1704": {"vr": "IS", "Value": [3000]},
        "1705": {"vr": "IS", "Value": [3000]},
        "1706": {"vr": "IS", "Value": [3000]},
        "1707": {"vr": "IS", "Value": [3000]},
        "1708": {"vr": "IS", "Value": [3000]},
        "1709": {"vr": "IS", "Value": [3000]},
        "1710": {"vr": "IS", "Value": [3000]},
        "1711": {"vr": "IS", "Value": [3000]},
        "1712": {"vr": "IS", "Value": [3000]},
        "1713": {"vr": "IS", "Value": [3000]},
        "1714": {"vr": "IS", "Value": [3000]},
        "1715": {"vr": "IS", "Value": [3000]},
        "1716": {"vr": "IS", "Value": [3000]},
        "1717": {"vr": "IS", "Value": [0]},
        "1718": {"vr": "IS", "Value": [3000]},
        "1719": {"vr": "IS", "Value": [3000]},
        "1720": {"vr": "IS", "Value": [0]},
        "1721": {"vr": "IS", "Value": [3000]},
        "1722": {"vr": "IS", "Value": [3000]},
        "1723": {"vr": "IS", "Value": [3000]},
        "1724": {"vr": "IS", "Value": [3000]},
        "1725": {"vr": "IS", "Value": [3000]},
        "1726": {"vr": "IS", "Value": [3000]},
        "1727": {"vr": "IS", "Value": [3000]},
        "1728": {"vr": "IS", "Value": [3000]},
        "1729": {"vr": "IS", "Value": [3000]},
        "1730": {"vr": "IS", "Value": [3000]},
        "1731": {"vr": "IS", "Value": [3000]},
        "1732": {"vr": "IS", "Value": [3000]},
        "1733": {"vr": "IS", "Value": [3000]},
        "1734": {"vr": "IS", "Value": [3000]},
        "1735": {"vr": "IS", "Value": [3000]},
        "1736": {"vr": "IS", "Value": [0]},
        "1737": {"vr": "IS", "Value": [3000]},
        "1738": {"vr": "IS", "Value": [0]},
        "1739": {"vr": "IS", "Value": [3000]},
        "1740": {"vr": "IS", "Value": [3000]},
        "1741": {"vr": "IS", "Value": [3000]},
        "1742": {"vr": "IS", "Value": [3000]},
        "1743": {"vr": "IS", "Value": [3000]},
        "1744": {"vr": "IS", "Value": [3000]},
        "1745": {"vr": "IS", "Value": [3000]},
        "1746": {"vr": "IS", "Value": [3000]},
        "1747": {"vr": "IS", "Value": [3000]},
        "1748": {"vr": "IS", "Value": [3000]},
        "1749": {"vr": "IS", "Value": [3000]},
        "1750": {"vr": "IS", "Value": [3000]},
        "1751": {"vr": "IS", "Value": [3000]},
        "1752": {"vr": "IS", "Value": [3000]},
        "1753": {"vr": "IS", "Value": [3000]},
        "1754": {"vr": "IS", "Value": [3000]},
        "1755": {"vr": "IS", "Value": [3000]},
        "1756": {"vr": "IS", "Value": [3000]},
        "1757": {"vr": "IS", "Value": [3000]},
        "1758": {"vr": "IS", "Value": [3000]},
        "1759": {"vr": "IS", "Value": [3000]},
        "1760": {"vr": "IS", "Value": [3000]},
        "1761": {"vr": "IS", "Value": [3000]},
        "1762": {"vr": "IS", "Value": [3000]},
        "1763": {"vr": "IS", "Value": [3000]},
        "1764": {"vr": "IS", "Value": [3000]},
        "1765": {"vr": "IS", "Value": [3000]},
        "1766": {"vr": "IS", "Value": [3000]},
        "1767": {"vr": "IS", "Value": [3000]},
        "1768": {"vr": "IS", "Value": [3000]},
        "1769": {"vr": "IS", "Value": [3000]},
        "1770": {"vr": "IS", "Value": [3000]},
        "1771": {"vr": "IS", "Value": [3000]},
        "1772": {"vr": "IS", "Value": [3000]},
        "1773": {"vr": "IS", "Value": [3000]},
        "1774": {"vr": "IS", "Value": [3000]},
        "1775": {"vr": "IS", "Value": [0]},
        "1776": {"vr": "IS", "Value": [3000]},
        "1777": {"vr": "IS", "Value": [3000]},
        "1778": {"vr": "IS", "Value": [3000]},
        "1779": {"vr": "IS", "Value": [3000]},
        "1780": {"vr": "IS", "Value": [3000]},
        "1781": {"vr": "IS", "Value": [3000]},
        "1782": {"vr": "IS", "Value": [3000]},
        "1783": {"vr": "IS", "Value": [3000]},
        "1784": {"vr": "IS", "Value": [3000]},
        "1785": {"vr": "IS", "Value": [3000]},
        "1786": {"vr": "IS", "Value": [3000]},
        "1787": {"vr": "IS", "Value": [3000]},
        "1788": {"vr": "IS", "Value": [3000]},
        "1789": {"vr": "IS", "Value": [3000]},
        "1790": {"vr": "IS", "Value": [3000]},
        "1791": {"vr": "IS", "Value": [3000]},
        "1792": {"vr": "IS", "Value": [3000]},
        "1793": {"vr": "IS", "Value": [3000]},
        "1794": {"vr": "IS", "Value": [3000]},
        "1795": {"vr": "IS", "Value": [3000]},
        "1796": {"vr": "IS", "Value": [0]},
        "1797": {"vr": "IS", "Value": [3000]},
        "1798": {"vr": "IS", "Value": [3000]},
        "1799": {"vr": "IS", "Value": [3000]},
        "1800": {"vr": "IS", "Value": [3000]},
        "1801": {"vr": "IS", "Value": [3000]},
        "1802": {"vr": "IS", "Value": [0]},
        "1803": {"vr": "IS", "Value": [3000]},
        "1804": {"vr": "IS", "Value": [3000]},
        "1805": {"vr": "IS", "Value": [0]},
        "1806": {"vr": "IS", "Value": [3000]},
        "1807": {"vr": "IS", "Value": [3000]},
        "1808": {"vr": "IS", "Value": [3000]},
        "1809": {"vr": "IS", "Value": [3000]},
        "1810": {"vr": "IS", "Value": [3000]},
        "1811": {"vr": "IS", "Value": [3000]},
        "1812": {"vr": "IS", "Value": [3000]},
        "1813": {"vr": "IS", "Value": [3000]},
        "1814": {"vr": "IS", "Value": [3000]},
        "1815": {"vr": "IS", "Value": [3000]},
        "1816": {"vr": "IS", "Value": [3000]},
        "1817": {"vr": "IS", "Value": [3000]},
        "1818": {"vr": "IS", "Value": [3000]},
        "1819": {"vr": "IS", "Value": [3000]},
        "1820": {"vr": "IS", "Value": [3000]},
        "1821": {"vr": "IS", "Value": [3000]},
        "1822": {"vr": "IS", "Value": [3000]},
        "1823": {"vr": "IS", "Value": [3000]},
        "1824": {"vr": "IS", "Value": [3000]},
        "1825": {"vr": "IS", "Value": [3000]},
        "1826": {"vr": "IS", "Value": [3000]},
        "1827": {"vr": "IS", "Value": [0]},
        "1828": {"vr": "IS", "Value": [3000]},
        "1829": {"vr": "IS", "Value": [3000]},
        "1830": {"vr": "IS", "Value": [3000]},
        "1831": {"vr": "IS", "Value": [3000]},
        "1832": {"vr": "IS", "Value": [3000]},
        "1833": {"vr": "IS", "Value": [3000]},
        "1834": {"vr": "IS", "Value": [3000]},
        "1835": {"vr": "IS", "Value": [3000]},
        "1836": {"vr": "IS", "Value": [3000]},
        "1837": {"vr": "IS", "Value": [0]},
        "1838": {"vr": "IS", "Value": [0]},
        "1839": {"vr": "IS", "Value": [3000]},
        "1840": {"vr": "IS", "Value": [3000]},
        "1841": {"vr": "IS", "Value": [3000]},
        "1842": {"vr": "IS", "Value": [3000]},
        "1843": {"vr": "IS", "Value": [3000]},
        "1844": {"vr": "IS", "Value": [3000]},
        "1845": {"vr": "IS", "Value": [0]},
        "1846": {"vr": "IS", "Value": [3000]},
        "1847": {"vr": "IS", "Value": [3000]},
        "1848": {"vr": "IS", "Value": [3000]},
        "1849": {"vr": "IS", "Value": [3000]},
        "1850": {"vr": "IS", "Value": [3000]},
        "1851": {"vr": "IS", "Value": [3000]},
        "1852": {"vr": "IS", "Value": [3000]},
        "1853": {"vr": "IS", "Value": [3000]},
        "1854": {"vr": "IS", "Value": [3000]},
        "1855": {"vr": "IS", "Value": [3000]},
        "1856": {"vr": "IS", "Value": [3000]},
        "1857": {"vr": "IS", "Value": [3000]},
        "1858": {"vr": "IS", "Value": [3000]},
        "1859": {"vr": "IS", "Value": [3000]},
        "1860": {"vr": "IS", "Value": [3000]},
        "1861": {"vr": "IS", "Value": [3000]},
        "1862": {"vr": "IS", "Value": [3000]},
        "1863": {"vr": "IS", "Value": [3000]},
        "1864": {"vr": "IS", "Value": [3000]},
        "1865": {"vr": "IS", "Value": [3000]},
        "1866": {"vr": "IS", "Value": [3000]},
        "1867": {"vr": "IS", "Value": [3000]},
        "1868": {"vr": "IS", "Value": [3000]},
        "1869": {"vr": "IS", "Value": [3000]},
        "1870": {"vr": "IS", "Value": [3000]},
        "1871": {"vr": "IS", "Value": [3000]},
        "1872": {"vr": "IS", "Value": [0]},
        "1873": {"vr": "IS", "Value": [0]},
        "1874": {"vr": "IS", "Value": [3000]},
        "1875": {"vr": "IS", "Value": [3000]},
        "1876": {"vr": "IS", "Value": [3000]},
        "1877": {"vr": "IS", "Value": [3000]},
        "1878": {"vr": "IS", "Value": [3000]},
        "1879": {"vr": "IS", "Value": [3000]},
        "1880": {"vr": "IS", "Value": [3000]},
        "1881": {"vr": "IS", "Value": [3000]},
        "1882": {"vr": "IS", "Value": [3000]},
        "1883": {"vr": "IS", "Value": [3000]},
        "1884": {"vr": "IS", "Value": [3000]},
        "1885": {"vr": "IS", "Value": [3000]},
        "1886": {"vr": "IS", "Value": [3000]},
        "1887": {"vr": "IS", "Value": [3000]},
        "1888": {"vr": "IS", "Value": [3000]},
        "1889": {"vr": "IS", "Value": [0]},
        "1890": {"vr": "IS", "Value": [3000]},
        "1891": {"vr": "IS", "Value": [3000]},
        "1892": {"vr": "IS", "Value": [3000]},
        "1893": {"vr": "IS", "Value": [3000]},
        "1894": {"vr": "IS", "Value": [3000]},
        "1895": {"vr": "IS", "Value": [3000]},
        "1896": {"vr": "IS", "Value": [3000]},
        "1897": {"vr": "IS", "Value": [3000]},
        "1898": {"vr": "IS", "Value": [3000]},
        "1899": {"vr": "IS", "Value": [3000]},
        "1900": {"vr": "IS", "Value": [3000]},
        "1901": {"vr": "IS", "Value": [3000]},
        "1902": {"vr": "IS", "Value": [3000]},
        "1903": {"vr": "IS", "Value": [3000]},
        "1904": {"vr": "IS", "Value": [3000]},
        "1905": {"vr": "IS", "Value": [3000]},
        "1906": {"vr": "IS", "Value": [3000]},
        "1907": {"vr": "IS", "Value": [3000]},
        "1908": {"vr": "IS", "Value": [3000]},
        "1909": {"vr": "IS", "Value": [0]},
        "1910": {"vr": "IS", "Value": [3000]},
        "1911": {"vr": "IS", "Value": [3000]},
        "1912": {"vr": "IS", "Value": [3000]},
        "1913": {"vr": "IS", "Value": [3000]},
        "1914": {"vr": "IS", "Value": [0]},
        "1915": {"vr": "IS", "Value": [0]},
        "1916": {"vr": "IS", "Value": [0]},
        "1917": {"vr": "IS", "Value": [3000]},
        "1918": {"vr": "IS", "Value": [0]},
        "1919": {"vr": "IS", "Value": [3000]},
        "1920": {"vr": "IS", "Value": [0]},
        "1921": {"vr": "IS", "Value": [3000]},
        "1922": {"vr": "IS", "Value": [3000]},
        "1923": {"vr": "IS", "Value": [3000]},
        "1924": {"vr": "IS", "Value": [3000]},
        "1925": {"vr": "IS", "Value": [3000]},
        "1926": {"vr": "IS", "Value": [3000]},
        "1927": {"vr": "IS", "Value": [3000]},
        "1928": {"vr": "IS", "Value": [3000]},
        "1929": {"vr": "IS", "Value": [3000]},
        "1930": {"vr": "IS", "Value": [3000]},
        "1931": {"vr": "IS", "Value": [3000]},
        "1932": {"vr": "IS", "Value": [3000]},
        "1933": {"vr": "IS", "Value": [0]},
        "1934": {"vr": "IS", "Value": [3000]},
        "1935": {"vr": "IS", "Value": [3000]},
        "1936": {"vr": "IS", "Value": [3000]},
        "1937": {"vr": "IS", "Value": [3000]},
        "1938": {"vr": "IS", "Value": [3000]},
        "1939": {"vr": "IS", "Value": [3000]},
        "1940": {"vr": "IS", "Value": [3000]},
        "1941": {"vr": "IS", "Value": [3000]},
        "1942": {"vr": "IS", "Value": [3000]},
        "1943": {"vr": "IS", "Value": [3000]},
        "1944": {"vr": "IS", "Value": [3000]},
        "1945": {"vr": "IS", "Value": [3000]},
        "1946": {"vr": "IS", "Value": [3000]},
        "1947": {"vr": "IS", "Value": [3000]},
        "1948": {"vr": "IS", "Value": [3000]},
        "1949": {"vr": "IS", "Value": [0]},
        "1950": {"vr": "IS", "Value": [3000]},
        "1951": {"vr": "IS", "Value": [3000]},
        "1952": {"vr": "IS", "Value": [3000]},
        "1953": {"vr": "IS", "Value": [3000]},
        "1954": {"vr": "IS", "Value": [3000]},
        "1955": {"vr": "IS", "Value": [3000]},
        "1956": {"vr": "IS", "Value": [3000]},
        "1957": {"vr": "IS", "Value": [3000]},
        "1958": {"vr": "IS", "Value": [3000]},
        "1959": {"vr": "IS", "Value": [3000]},
        "1960": {"vr": "IS", "Value": [3000]},
        "1961": {"vr": "IS", "Value": [0]},
        "1962": {"vr": "IS", "Value": [3000]},
        "1963": {"vr": "IS", "Value": [3000]},
        "1964": {"vr": "IS", "Value": [3000]},
        "1965": {"vr": "IS", "Value": [3000]},
        "1966": {"vr": "IS", "Value": [3000]},
        "1967": {"vr": "IS", "Value": [0]},
        "1968": {"vr": "IS", "Value": [3000]},
        "1969": {"vr": "IS", "Value": [3000]},
        "1970": {"vr": "IS", "Value": [3000]},
        "1971": {"vr": "IS", "Value": [3000]},
        "1972": {"vr": "IS", "Value": [3000]},
        "1973": {"vr": "IS", "Value": [0]},
        "1974": {"vr": "IS", "Value": [3000]},
        "1975": {"vr": "IS", "Value": [3000]},
        "1976": {"vr": "IS", "Value": [3000]},
        "1977": {"vr": "IS", "Value": [3000]},
        "1978": {"vr": "IS", "Value": [3000]},
        "1979": {"vr": "IS", "Value": [3000]},
        "1980": {"vr": "IS", "Value": [3000]},
        "1981": {"vr": "IS", "Value": [3000]},
        "1982": {"vr": "IS", "Value": [3000]},
        "1983": {"vr": "IS", "Value": [3000]},
        "1984": {"vr": "IS", "Value": [3000]},
        "1985": {"vr": "IS", "Value": [3000]},
        "1986": {"vr": "IS", "Value": [0]},
        "1987": {"vr": "IS", "Value": [3000]},
        "1988": {"vr": "IS", "Value": [3000]},
        "1989": {"vr": "IS", "Value": [3000]},
        "1990": {"vr": "IS", "Value": [3000]},
        "1991": {"vr": "IS", "Value": [3000]},
        "1992": {"vr": "IS", "Value": [3000]},
        "1993": {"vr": "IS", "Value": [0]},
        "1994": {"vr": "IS", "Value": [3000]},
        "1995": {"vr": "IS", "Value": [3000]},
        "1996": {"vr": "IS", "Value": [0]},
        "1997": {"vr": "IS", "Value": [3000]},
        "1998": {"vr": "IS", "Value": [3000]},
        "1999": {"vr": "IS", "Value": [3000]},
        "2000": {"vr": "IS", "Value": [3000]},
        "2001": {"vr": "IS", "Value": [0]},
        "2002": {"vr": "IS", "Value": [3000]},
        "2003": {"vr": "IS", "Value": [3000]},
        "2004": {"vr": "IS", "Value": [3000]},
        "2005": {"vr": "IS", "Value": [3000]},
        "2006": {"vr": "IS", "Value": [3000]},
        "2007": {"vr": "IS", "Value": [3000]},
        "2008": {"vr": "IS", "Value": [3000]},
        "2009": {"vr": "IS", "Value": [3000]},
        "2010": {"vr": "IS", "Value": [3000]},
        "2011": {"vr": "IS", "Value": [3000]},
        "2012": {"vr": "IS", "Value": [0]},
        "2013": {"vr": "IS", "Value": [3000]},
        "2014": {"vr": "IS", "Value": [3000]},
        "2015": {"vr": "IS", "Value": [3000]},
        "2016": {"vr": "IS", "Value": [3000]},
        "2017": {"vr": "IS", "Value": [0]},
        "2018": {"vr": "IS", "Value": [3000]},
        "2019": {"vr": "IS", "Value": [3000]},
        "2020": {"vr": "IS", "Value": [3000]},
        "2021": {"vr": "IS", "Value": [3000]},
        "2022": {"vr": "IS", "Value": [3000]},
        "2023": {"vr": "IS", "Value": [3000]},
        "2024": {"vr": "IS", "Value": [3000]},
        "2025": {"vr": "IS", "Value": [0]},
        "2026": {"vr": "IS", "Value": [3000]},
        "2027": {"vr": "IS", "Value": [3000]},
        "2028": {"vr": "IS", "Value": [3000]},
        "2029": {"vr": "IS", "Value": [0]},
        "2030": {"vr": "IS", "Value": [3000]},
        "2031": {"vr": "IS", "Value": [3000]},
        "2032": {"vr": "IS", "Value": [3000]},
        "2033": {"vr": "IS", "Value": [3000]},
        "2034": {"vr": "IS", "Value": [3000]},
        "2035": {"vr": "IS", "Value": [3000]},
        "2036": {"vr": "IS", "Value": [3000]},
        "2037": {"vr": "IS", "Value": [3000]},
        "2038": {"vr": "IS", "Value": [3000]},
        "2039": {"vr": "IS", "Value": [3000]},
        "2040": {"vr": "IS", "Value": [3000]},
        "2041": {"vr": "IS", "Value": [3000]},
        "2042": {"vr": "IS", "Value": [3000]},
        "2043": {"vr": "IS", "Value": [3000]},
        "2044": {"vr": "IS", "Value": [3000]},
        "2045": {"vr": "IS", "Value": [3000]},
        "2046": {"vr": "IS", "Value": [3000]},
        "2047": {"vr": "IS", "Value": [3000]},
        "2048": {"vr": "IS", "Value": [3000]},
        "2049": {"vr": "IS", "Value": [3000]},
        "2050": {"vr": "IS", "Value": [3000]},
        "2051": {"vr": "IS", "Value": [3000]},
        "2052": {"vr": "IS", "Value": [3000]},
        "2053": {"vr": "IS", "Value": [3000]},
        "2054": {"vr": "IS", "Value": [3000]},
        "2055": {"vr": "IS", "Value": [3000]},
        "2056": {"vr": "IS", "Value": [3000]},
        "2057": {"vr": "IS", "Value": [3000]},
        "2058": {"vr": "IS", "Value": [3000]},
        "2059": {"vr": "IS", "Value": [3000]},
        "2060": {"vr": "IS", "Value": [3000]},
        "2061": {"vr": "IS", "Value": [3000]},
        "2062": {"vr": "IS", "Value": [3000]},
        "2063": {"vr": "IS", "Value": [3000]},
        "2064": {"vr": "IS", "Value": [0]},
        "2065": {"vr": "IS", "Value": [3000]},
        "2066": {"vr": "IS", "Value": [3000]},
        "2067": {"vr": "IS", "Value": [3000]},
        "2068": {"vr": "IS", "Value": [3000]},
        "2069": {"vr": "IS", "Value": [3000]},
        "2070": {"vr": "IS", "Value": [3000]},
        "2071": {"vr": "IS", "Value": [3000]},
        "2072": {"vr": "IS", "Value": [3000]},
        "2073": {"vr": "IS", "Value": [3000]},
        "2074": {"vr": "IS", "Value": [3000]},
        "2075": {"vr": "IS", "Value": [0]},
        "2076": {"vr": "IS", "Value": [3000]},
        "2077": {"vr": "IS", "Value": [3000]},
        "2078": {"vr": "IS", "Value": [3000]},
        "2079": {"vr": "IS", "Value": [0]},
        "2080": {"vr": "IS", "Value": [3000]},
        "2081": {"vr": "IS", "Value": [3000]},
        "2082": {"vr": "IS", "Value": [0]},
        "2083": {"vr": "IS", "Value": [0]},
        "2084": {"vr": "IS", "Value": [0]},
        "2085": {"vr": "IS", "Value": [3000]},
        "2086": {"vr": "IS", "Value": [0]},
        "2087": {"vr": "IS", "Value": [3000]},
        "2088": {"vr": "IS", "Value": [3000]},
        "2089": {"vr": "IS", "Value": [3000]},
        "2090": {"vr": "IS", "Value": [3000]},
        "2091": {"vr": "IS", "Value": [3000]},
        "2092": {"vr": "IS", "Value": [3000]},
        "2093": {"vr": "IS", "Value": [3000]},
        "2094": {"vr": "IS", "Value": [3000]},
        "2095": {"vr": "IS", "Value": [3000]},
        "2096": {"vr": "IS", "Value": [3000]},
        "2097": {"vr": "IS", "Value": [3000]},
        "2098": {"vr": "IS", "Value": [0]},
        "2099": {"vr": "IS", "Value": [3000]},
        "2100": {"vr": "IS", "Value": [3000]},
        "2101": {"vr": "IS", "Value": [3000]},
        "2102": {"vr": "IS", "Value": [3000]},
        "2103": {"vr": "IS", "Value": [3000]},
        "2104": {"vr": "IS", "Value": [3000]},
        "2105": {"vr": "IS", "Value": [3000]},
        "2106": {"vr": "IS", "Value": [3000]},
        "2107": {"vr": "IS", "Value": [3000]},
        "2108": {"vr": "IS", "Value": [3000]},
        "2109": {"vr": "IS", "Value": [0]},
        "2110": {"vr": "IS", "Value": [3000]},
        "2111": {"vr": "IS", "Value": [3000]},
        "2112": {"vr": "IS", "Value": [3000]},
        "2113": {"vr": "IS", "Value": [3000]},
        "2114": {"vr": "IS", "Value": [3000]},
        "2115": {"vr": "IS", "Value": [3000]},
        "2116": {"vr": "IS", "Value": [3000]},
        "2117": {"vr": "IS", "Value": [3000]},
        "2118": {"vr": "IS", "Value": [3000]},
        "2119": {"vr": "IS", "Value": [3000]},
        "2120": {"vr": "IS", "Value": [3000]},
        "2121": {"vr": "IS", "Value": [3000]},
        "2122": {"vr": "IS", "Value": [3000]},
        "2123": {"vr": "IS", "Value": [3000]},
        "2124": {"vr": "IS", "Value": [3000]},
        "2125": {"vr": "IS", "Value": [3000]},
        "2126": {"vr": "IS", "Value": [3000]},
        "2127": {"vr": "IS", "Value": [3000]},
        "2128": {"vr": "IS", "Value": [3000]},
        "2129": {"vr": "IS", "Value": [3000]},
        "2130": {"vr": "IS", "Value": [3000]},
        "2131": {"vr": "IS", "Value": [3000]},
        "2132": {"vr": "IS", "Value": [0]},
        "2133": {"vr": "IS", "Value": [3000]},
        "2134": {"vr": "IS", "Value": [3000]},
        "2135": {"vr": "IS", "Value": [3000]},
        "2136": {"vr": "IS", "Value": [3000]},
        "2137": {"vr": "IS", "Value": [3000]},
        "2138": {"vr": "IS", "Value": [3000]},
        "2139": {"vr": "IS", "Value": [3000]},
        "2140": {"vr": "IS", "Value": [3000]},
        "2141": {"vr": "IS", "Value": [3000]},
        "2142": {"vr": "IS", "Value": [3000]},
        "2143": {"vr": "IS", "Value": [3000]},
        "2144": {"vr": "IS", "Value": [3000]},
        "2145": {"vr": "IS", "Value": [3000]},
        "2146": {"vr": "IS", "Value": [0]},
        "2147": {"vr": "IS", "Value": [3000]},
        "2148": {"vr": "IS", "Value": [3000]},
        "2149": {"vr": "IS", "Value": [3000]},
        "2150": {"vr": "IS", "Value": [3000]},
        "2151": {"vr": "IS", "Value": [3000]},
        "2152": {"vr": "IS", "Value": [3000]},
        "2153": {"vr": "IS", "Value": [3000]},
        "2154": {"vr": "IS", "Value": [3000]},
        "2155": {"vr": "IS", "Value": [3000]},
        "2156": {"vr": "IS", "Value": [3000]},
        "2157": {"vr": "IS", "Value": [3000]},
        "2158": {"vr": "IS", "Value": [0]},
        "2159": {"vr": "IS", "Value": [3000]},
        "2160": {"vr": "IS", "Value": [3000]},
        "2161": {"vr": "IS", "Value": [3000]},
        "2162": {"vr": "IS", "Value": [3000]},
        "2163": {"vr": "IS", "Value": [3000]},
        "2164": {"vr": "IS", "Value": [3000]},
        "2165": {"vr": "IS", "Value": [0]},
        "2166": {"vr": "IS", "Value": [3000]},
        "2167": {"vr": "IS", "Value": [3000]},
        "2168": {"vr": "IS", "Value": [3000]},
        "2169": {"vr": "IS", "Value": [3000]},
        "2170": {"vr": "IS", "Value": [0]},
        "2171": {"vr": "IS", "Value": [3000]},
        "2172": {"vr": "IS", "Value": [3000]},
        "2173": {"vr": "IS", "Value": [3000]},
        "2174": {"vr": "IS", "Value": [0]},
        "2175": {"vr": "IS", "Value": [3000]},
        "2176": {"vr": "IS", "Value": [3000]},
        "2177": {"vr": "IS", "Value": [3000]},
        "2178": {"vr": "IS", "Value": [3000]},
        "2179": {"vr": "IS", "Value": [3000]},
        "2180": {"vr": "IS", "Value": [3000]},
        "2181": {"vr": "IS", "Value": [3000]},
        "2182": {"vr": "IS", "Value": [3000]},
        "2183": {"vr": "IS", "Value": [3000]},
        "2184": {"vr": "IS", "Value": [3000]},
        "2185": {"vr": "IS", "Value": [3000]},
        "2186": {"vr": "IS", "Value": [3000]},
        "2187": {"vr": "IS", "Value": [0]},
        "2188": {"vr": "IS", "Value": [3000]},
        "2189": {"vr": "IS", "Value": [3000]},
        "2190": {"vr": "IS", "Value": [3000]},
        "2191": {"vr": "IS", "Value": [3000]},
        "2192": {"vr": "IS", "Value": [0]},
        "2193": {"vr": "IS", "Value": [3000]},
        "2194": {"vr": "IS", "Value": [3000]},
        "2195": {"vr": "IS", "Value": [3000]},
        "2196": {"vr": "IS", "Value": [3000]},
        "2197": {"vr": "IS", "Value": [3000]},
        "2198": {"vr": "IS", "Value": [3000]},
        "2199": {"vr": "IS", "Value": [3000]},
        "2200": {"vr": "IS", "Value": [3000]},
        "2201": {"vr": "IS", "Value": [3000]},
        "2202": {"vr": "IS", "Value": [3000]},
        "2203": {"vr": "IS", "Value": [3000]},
        "2204": {"vr": "IS", "Value": [0]},
        "2205": {"vr": "IS", "Value": [3000]},
        "2206": {"vr": "IS", "Value": [3000]},
        "2207": {"vr": "IS", "Value": [3000]},
        "2208": {"vr": "IS", "Value": [3000]},
        "2209": {"vr": "IS", "Value": [3000]},
        "2210": {"vr": "IS", "Value": [3000]},
        "2211": {"vr": "IS", "Value": [3000]},
        "2212": {"vr": "IS", "Value": [3000]},
        "2213": {"vr": "IS", "Value": [3000]},
        "2214": {"vr": "IS", "Value": [3000]},
        "2215": {"vr": "IS", "Value": [3000]},
        "2216": {"vr": "IS", "Value": [3000]},
        "2217": {"vr": "IS", "Value": [3000]},
        "2218": {"vr": "IS", "Value": [3000]},
        "2219": {"vr": "IS", "Value": [3000]},
        "2220": {"vr": "IS", "Value": [0]},
        "2221": {"vr": "IS", "Value": [3000]},
        "2222": {"vr": "IS", "Value": [3000]},
        "2223": {"vr": "IS", "Value": [3000]},
        "2224": {"vr": "IS", "Value": [3000]},
        "2225": {"vr": "IS", "Value": [3000]},
        "2226": {"vr": "IS", "Value": [3000]},
        "2227": {"vr": "IS", "Value": [3000]},
        "2228": {"vr": "IS", "Value": [3000]},
        "2229": {"vr": "IS", "Value": [3000]},
        "2230": {"vr": "IS", "Value": [3000]},
        "2231": {"vr": "IS", "Value": [3000]},
        "2232": {"vr": "IS", "Value": [3000]},
        "2233": {"vr": "IS", "Value": [3000]},
        "2234": {"vr": "IS", "Value": [3000]},
        "2235": {"vr": "IS", "Value": [3000]},
        "2236": {"vr": "IS", "Value": [3000]},
        "2237": {"vr": "IS", "Value": [3000]},
        "2238": {"vr": "IS", "Value": [3000]},
        "2239": {"vr": "IS", "Value": [0]},
        "2240": {"vr": "IS", "Value": [3000]},
        "2241": {"vr": "IS", "Value": [3000]},
        "2242": {"vr": "IS", "Value": [3000]},
        "2243": {"vr": "IS", "Value": [3000]},
        "2244": {"vr": "IS", "Value": [3000]},
        "2245": {"vr": "IS", "Value": [3000]},
        "2246": {"vr": "IS", "Value": [3000]},
        "2247": {"vr": "IS", "Value": [3000]},
        "2248": {"vr": "IS", "Value": [3000]},
        "2249": {"vr": "IS", "Value": [3000]},
        "2250": {"vr": "IS", "Value": [3000]},
        "2251": {"vr": "IS", "Value": [3000]},
        "2252": {"vr": "IS", "Value": [3000]},
        "2253": {"vr": "IS", "Value": [3000]},
        "2254": {"vr": "IS", "Value": [0]},
        "2255": {"vr": "IS", "Value": [3000]},
        "2256": {"vr": "IS", "Value": [3000]},
        "2257": {"vr": "IS", "Value": [3000]},
        "2258": {"vr": "IS", "Value": [3000]},
        "2259": {"vr": "IS", "Value": [0]},
        "2260": {"vr": "IS", "Value": [3000]},
        "2261": {"vr": "IS", "Value": [3000]},
        "2262": {"vr": "IS", "Value": [3000]},
        "2263": {"vr": "IS", "Value": [0]},
        "2264": {"vr": "IS", "Value": [3000]},
        "2265": {"vr": "IS", "Value": [3000]},
        "2266": {"vr": "IS", "Value": [3000]},
        "2267": {"vr": "IS", "Value": [3000]},
        "2268": {"vr": "IS", "Value": [3000]},
        "2269": {"vr": "IS", "Value": [3000]},
        "2270": {"vr": "IS", "Value": [3000]},
        "2271": {"vr": "IS", "Value": [3000]},
        "2272": {"vr": "IS", "Value": [3000]},
        "2273": {"vr": "IS", "Value": [3000]},
        "2274": {"vr": "IS", "Value": [3000]},
        "2275": {"vr": "IS", "Value": [3000]},
        "2276": {"vr": "IS", "Value": [3000]},
        "2277": {"vr": "IS", "Value": [3000]},
        "2278": {"vr": "IS", "Value": [0]},
        "2279": {"vr": "IS", "Value": [3000]},
        "2280": {"vr": "IS", "Value": [3000]},
        "2281": {"vr": "IS", "Value": [3000]},
        "2282": {"vr": "IS", "Value": [3000]},
        "2283": {"vr": "IS", "Value": [3000]},
        "2284": {"vr": "IS", "Value": [3000]},
        "2285": {"vr": "IS", "Value": [3000]},
        "2286": {"vr": "IS", "Value": [3000]},
        "2287": {"vr": "IS", "Value": [0]},
        "2288": {"vr": "IS", "Value": [3000]},
        "2289": {"vr": "IS", "Value": [3000]},
        "2290": {"vr": "IS", "Value": [3000]},
        "2291": {"vr": "IS", "Value": [0]},
        "2292": {"vr": "IS", "Value": [3000]},
        "2293": {"vr": "IS", "Value": [3000]},
        "2294": {"vr": "IS", "Value": [3000]},
        "2295": {"vr": "IS", "Value": [0]},
        "2296": {"vr": "IS", "Value": [0]},
        "2297": {"vr": "IS", "Value": [3000]},
        "2298": {"vr": "IS", "Value": [3000]},
        "2299": {"vr": "IS", "Value": [3000]},
        "2300": {"vr": "IS", "Value": [3000]},
        "2301": {"vr": "IS", "Value": [3000]},
        "2302": {"vr": "IS", "Value": [3000]},
        "2303": {"vr": "IS", "Value": [3000]},
        "2304": {"vr": "IS", "Value": [3000]},
        "2305": {"vr": "IS", "Value": [3000]},
        "2306": {"vr": "IS", "Value": [3000]},
        "2307": {"vr": "IS", "Value": [3000]},
        "2308": {"vr": "IS", "Value": [3000]},
        "2309": {"vr": "IS", "Value": [3000]},
        "2310": {"vr": "IS", "Value": [3000]},
        "2311": {"vr": "IS", "Value": [3000]},
        "2312": {"vr": "IS", "Value": [3000]},
        "2313": {"vr": "IS", "Value": [0]},
        "2314": {"vr": "IS", "Value": [3000]},
        "2315": {"vr": "IS", "Value": [3000]},
        "2316": {"vr": "IS", "Value": [3000]},
        "2317": {"vr": "IS", "Value": [3000]},
        "2318": {"vr": "IS", "Value": [3000]},
        "2319": {"vr": "IS", "Value": [3000]},
        "2320": {"vr": "IS", "Value": [3000]},
        "2321": {"vr": "IS", "Value": [3000]},
        "2322": {"vr": "IS", "Value": [3000]},
        "2323": {"vr": "IS", "Value": [3000]},
        "2324": {"vr": "IS", "Value": [3000]},
        "2325": {"vr": "IS", "Value": [3000]},
        "2326": {"vr": "IS", "Value": [3000]},
        "2327": {"vr": "IS", "Value": [3000]},
        "2328": {"vr": "IS", "Value": [3000]},
        "2329": {"vr": "IS", "Value": [3000]},
        "2330": {"vr": "IS", "Value": [3000]},
        "2331": {"vr": "IS", "Value": [3000]},
        "2332": {"vr": "IS", "Value": [3000]},
        "2333": {"vr": "IS", "Value": [3000]},
        "2334": {"vr": "IS", "Value": [3000]},
        "2335": {"vr": "IS", "Value": [3000]},
        "2336": {"vr": "IS", "Value": [3000]},
        "2337": {"vr": "IS", "Value": [3000]},
        "2338": {"vr": "IS", "Value": [3000]},
        "2339": {"vr": "IS", "Value": [3000]},
        "2340": {"vr": "IS", "Value": [0]},
        "2341": {"vr": "IS", "Value": [3000]},
        "2342": {"vr": "IS", "Value": [3000]},
        "2343": {"vr": "IS", "Value": [3000]},
        "2344": {"vr": "IS", "Value": [3000]},
        "2345": {"vr": "IS", "Value": [3000]},
        "2346": {"vr": "IS", "Value": [0]},
        "2347": {"vr": "IS", "Value": [3000]},
        "2348": {"vr": "IS", "Value": [3000]},
        "2349": {"vr": "IS", "Value": [3000]},
        "2350": {"vr": "IS", "Value": [3000]},
        "2351": {"vr": "IS", "Value": [3000]},
        "2352": {"vr": "IS", "Value": [3000]},
        "2353": {"vr": "IS", "Value": [3000]},
        "2354": {"vr": "IS", "Value": [3000]},
        "2355": {"vr": "IS", "Value": [3000]},
        "2356": {"vr": "IS", "Value": [3000]},
        "2357": {"vr": "IS", "Value": [3000]},
        "2358": {"vr": "IS", "Value": [3000]},
        "2359": {"vr": "IS", "Value": [0]},
        "2360": {"vr": "IS", "Value": [0]},
        "2361": {"vr": "IS", "Value": [3000]},
        "2362": {"vr": "IS", "Value": [3000]},
        "2363": {"vr": "IS", "Value": [3000]},
        "2364": {"vr": "IS", "Value": [3000]},
        "2365": {"vr": "IS", "Value": [3000]},
        "2366": {"vr": "IS", "Value": [3000]},
        "2367": {"vr": "IS", "Value": [3000]},
        "2368": {"vr": "IS", "Value": [3000]},
        "2369": {"vr": "IS", "Value": [0]},
        "2370": {"vr": "IS", "Value": [3000]},
        "2371": {"vr": "IS", "Value": [3000]},
        "2372": {"vr": "IS", "Value": [3000]},
        "2373": {"vr": "IS", "Value": [3000]},
        "2374": {"vr": "IS", "Value": [3000]},
        "2375": {"vr": "IS", "Value": [3000]},
        "2376": {"vr": "IS", "Value": [0]},
        "2377": {"vr": "IS", "Value": [3000]},
        "2378": {"vr": "IS", "Value": [3000]},
        "2379": {"vr": "IS", "Value": [3000]},
        "2380": {"vr": "IS", "Value": [3000]},
        "2381": {"vr": "IS", "Value": [0]},
        "2382": {"vr": "IS", "Value": [0]},
        "2383": {"vr": "IS", "Value": [3000]},
        "2384": {"vr": "IS", "Value": [3000]},
        "2385": {"vr": "IS", "Value": [0]},
        "2386": {"vr": "IS", "Value": [3000]},
        "2387": {"vr": "IS", "Value": [3000]},
        "2388": {"vr": "IS", "Value": [3000]},
        "2389": {"vr": "IS", "Value": [3000]},
        "2390": {"vr": "IS", "Value": [3000]},
        "2391": {"vr": "IS", "Value": [3000]},
        "2392": {"vr": "IS", "Value": [3000]},
        "2393": {"vr": "IS", "Value": [3000]},
        "2394": {"vr": "IS", "Value": [0]},
        "2395": {"vr": "IS", "Value": [3000]},
        "2396": {"vr": "IS", "Value": [3000]},
        "2397": {"vr": "IS", "Value": [3000]},
        "2398": {"vr": "IS", "Value": [3000]},
        "2399": {"vr": "IS", "Value": [3000]},
        "2400": {"vr": "IS", "Value": [0]},
        "2401": {"vr": "IS", "Value": [3000]},
        "2402": {"vr": "IS", "Value": [3000]},
        "2403": {"vr": "IS", "Value": [3000]},
        "2404": {"vr": "IS", "Value": [3000]},
        "2405": {"vr": "IS", "Value": [3000]},
        "2406": {"vr": "IS", "Value": [3000]},
        "2407": {"vr": "IS", "Value": [3000]},
        "2408": {"vr": "IS", "Value": [3000]},
        "2409": {"vr": "IS", "Value": [3000]},
        "2410": {"vr": "IS", "Value": [3000]},
        "2411": {"vr": "IS", "Value": [3000]},
        "2412": {"vr": "IS", "Value": [3000]},
        "2413": {"vr": "IS", "Value": [3000]},
        "2414": {"vr": "IS", "Value": [3000]},
        "2415": {"vr": "IS", "Value": [3000]},
        "2416": {"vr": "IS", "Value": [3000]},
        "2417": {"vr": "IS", "Value": [0]},
        "2418": {"vr": "IS", "Value": [0]},
        "2419": {"vr": "IS", "Value": [3000]},
        "2420": {"vr": "IS", "Value": [3000]},
        "2421": {"vr": "IS", "Value": [3000]},
        "2422": {"vr": "IS", "Value": [3000]},
        "2423": {"vr": "IS", "Value": [3000]},
        "2424": {"vr": "IS", "Value": [3000]},
        "2425": {"vr": "IS", "Value": [3000]},
        "2426": {"vr": "IS", "Value": [3000]},
        "2427": {"vr": "IS", "Value": [3000]},
        "2428": {"vr": "IS", "Value": [3000]},
        "2429": {"vr": "IS", "Value": [3000]},
        "2430": {"vr": "IS", "Value": [3000]},
        "2431": {"vr": "IS", "Value": [3000]},
        "2432": {"vr": "IS", "Value": [3000]},
        "2433": {"vr": "IS", "Value": [0]},
        "2434": {"vr": "IS", "Value": [3000]},
        "2435": {"vr": "IS", "Value": [3000]},
        "2436": {"vr": "IS", "Value": [3000]},
        "2437": {"vr": "IS", "Value": [3000]},
        "2438": {"vr": "IS", "Value": [3000]},
        "2439": {"vr": "IS", "Value": [3000]},
        "2440": {"vr": "IS", "Value": [3000]},
        "2441": {"vr": "IS", "Value": [3000]},
        "2442": {"vr": "IS", "Value": [3000]},
        "2443": {"vr": "IS", "Value": [3000]},
        "2444": {"vr": "IS", "Value": [3000]},
        "2445": {"vr": "IS", "Value": [3000]},
        "2446": {"vr": "IS", "Value": [3000]},
        "2447": {"vr": "IS", "Value": [3000]},
        "2448": {"vr": "IS", "Value": [3000]},
        "2449": {"vr": "IS", "Value": [3000]},
        "2450": {"vr": "IS", "Value": [3000]},
        "2451": {"vr": "IS", "Value": [3000]},
        "2452": {"vr": "IS", "Value": [3000]},
        "2453": {"vr": "IS", "Value": [3000]},
        "2454": {"vr": "IS", "Value": [3000]},
        "2455": {"vr": "IS", "Value": [3000]},
        "2456": {"vr": "IS", "Value": [3000]},
        "2457": {"vr": "IS", "Value": [3000]},
        "2458": {"vr": "IS", "Value": [3000]},
        "2459": {"vr": "IS", "Value": [3000]},
        "2460": {"vr": "IS", "Value": [3000]},
        "2461": {"vr": "IS", "Value": [3000]},
        "2462": {"vr": "IS", "Value": [3000]},
        "2463": {"vr": "IS", "Value": [3000]},
        "2464": {"vr": "IS", "Value": [3000]},
        "2465": {"vr": "IS", "Value": [3000]},
        "2466": {"vr": "IS", "Value": [3000]},
        "2467": {"vr": "IS", "Value": [3000]},
        "2468": {"vr": "IS", "Value": [3000]},
        "2469": {"vr": "IS", "Value": [3000]},
        "2470": {"vr": "IS", "Value": [3000]},
        "2471": {"vr": "IS", "Value": [3000]},
        "2472": {"vr": "IS", "Value": [3000]},
        "2473": {"vr": "IS", "Value": [3000]},
        "2474": {"vr": "IS", "Value": [3000]},
        "2475": {"vr": "IS", "Value": [3000]},
        "2476": {"vr": "IS", "Value": [3000]},
        "2477": {"vr": "IS", "Value": [3000]},
        "2478": {"vr": "IS", "Value": [3000]},
        "2479": {"vr": "IS", "Value": [0]},
        "2480": {"vr": "IS", "Value": [0]},
        "2481": {"vr": "IS", "Value": [3000]},
        "2482": {"vr": "IS", "Value": [3000]},
        "2483": {"vr": "IS", "Value": [3000]},
        "2484": {"vr": "IS", "Value": [3000]},
        "2485": {"vr": "IS", "Value": [3000]},
        "2486": {"vr": "IS", "Value": [3000]},
        "2487": {"vr": "IS", "Value": [3000]},
        "2488": {"vr": "IS", "Value": [3000]},
        "2489": {"vr": "IS", "Value": [3000]},
        "2490": {"vr": "IS", "Value": [3000]},
        "2491": {"vr": "IS", "Value": [3000]},
        "2492": {"vr": "IS", "Value": [3000]},
        "2493": {"vr": "IS", "Value": [3000]},
        "2494": {"vr": "IS", "Value": [3000]},
        "2495": {"vr": "IS", "Value": [3000]},
        "2496": {"vr": "IS", "Value": [3000]},
        "2497": {"vr": "IS", "Value": [3000]},
        "2498": {"vr": "IS", "Value": [3000]},
        "2499": {"vr": "IS", "Value": [3000]},
        "2500": {"vr": "IS", "Value": [3000]},
        "2501": {"vr": "IS", "Value": [3000]},
        "2502": {"vr": "IS", "Value": [3000]},
        "2503": {"vr": "IS", "Value": [3000]},
        "2504": {"vr": "IS", "Value": [3000]},
        "2505": {"vr": "IS", "Value": [3000]},
        "2506": {"vr": "IS", "Value": [3000]},
        "2507": {"vr": "IS", "Value": [3000]},
        "2508": {"vr": "IS", "Value": [3000]},
        "2509": {"vr": "IS", "Value": [3000]},
        "2510": {"vr": "IS", "Value": [3000]},
        "2511": {"vr": "IS", "Value": [3000]},
        "2512": {"vr": "IS", "Value": [3000]},
        "2513": {"vr": "IS", "Value": [3000]},
        "2514": {"vr": "IS", "Value": [3000]},
        "2515": {"vr": "IS", "Value": [3000]},
        "2516": {"vr": "IS", "Value": [3000]},
        "2517": {"vr": "IS", "Value": [3000]},
        "2518": {"vr": "IS", "Value": [3000]},
        "2519": {"vr": "IS", "Value": [3000]},
        "2520": {"vr": "IS", "Value": [0]},
        "2521": {"vr": "IS", "Value": [3000]},
        "2522": {"vr": "IS", "Value": [0]},
        "2523": {"vr": "IS", "Value": [3000]},
        "2524": {"vr": "IS", "Value": [3000]},
        "2525": {"vr": "IS", "Value": [0]},
        "2526": {"vr": "IS", "Value": [3000]},
        "2527": {"vr": "IS", "Value": [3000]},
        "2528": {"vr": "IS", "Value": [3000]},
        "2529": {"vr": "IS", "Value": [3000]},
        "2530": {"vr": "IS", "Value": [3000]},
        "2531": {"vr": "IS", "Value": [3000]},
        "2532": {"vr": "IS", "Value": [3000]},
        "2533": {"vr": "IS", "Value": [3000]},
        "2534": {"vr": "IS", "Value": [0]},
        "2535": {"vr": "IS", "Value": [3000]},
        "2536": {"vr": "IS", "Value": [3000]},
        "2537": {"vr": "IS", "Value": [0]},
        "2538": {"vr": "IS", "Value": [3000]},
        "2539": {"vr": "IS", "Value": [0]},
        "2540": {"vr": "IS", "Value": [3000]},
        "2541": {"vr": "IS", "Value": [3000]},
        "2542": {"vr": "IS", "Value": [3000]},
        "2543": {"vr": "IS", "Value": [3000]},
        "2544": {"vr": "IS", "Value": [3000]},
        "2545": {"vr": "IS", "Value": [3000]},
        "2546": {"vr": "IS", "Value": [0]},
        "2547": {"vr": "IS", "Value": [3000]},
        "2548": {"vr": "IS", "Value": [0]},
        "2549": {"vr": "IS", "Value": [3000]},
        "2550": {"vr": "IS", "Value": [3000]},
        "2551": {"vr": "IS", "Value": [3000]},
        "2552": {"vr": "IS", "Value": [3000]},
        "2553": {"vr": "IS", "Value": [3000]},
        "2554": {"vr": "IS", "Value": [3000]},
        "2555": {"vr": "IS", "Value": [3000]},
        "2556": {"vr": "IS", "Value": [3000]},
        "2557": {"vr": "IS", "Value": [0]},
        "2558": {"vr": "IS", "Value": [3000]},
        "2559": {"vr": "IS", "Value": [3000]},
        "2560": {"vr": "IS", "Value": [3000]},
        "2561": {"vr": "IS", "Value": [3000]},
        "2562": {"vr": "IS", "Value": [3000]},
        "2563": {"vr": "IS", "Value": [3000]},
        "2564": {"vr": "IS", "Value": [3000]},
        "2565": {"vr": "IS", "Value": [3000]},
        "2566": {"vr": "IS", "Value": [3000]},
        "2567": {"vr": "IS", "Value": [3000]},
        "2568": {"vr": "IS", "Value": [3000]},
        "2569": {"vr": "IS", "Value": [3000]},
        "2570": {"vr": "IS", "Value": [3000]},
        "2571": {"vr": "IS", "Value": [0]},
        "2572": {"vr": "IS", "Value": [0]},
        "2573": {"vr": "IS", "Value": [3000]},
        "2574": {"vr": "IS", "Value": [3000]},
        "2575": {"vr": "IS", "Value": [3000]},
        "2576": {"vr": "IS", "Value": [3000]},
        "2577": {"vr": "IS", "Value": [3000]},
        "2578": {"vr": "IS", "Value": [3000]},
        "2579": {"vr": "IS", "Value": [3000]},
        "2580": {"vr": "IS", "Value": [3000]},
        "2581": {"vr": "IS", "Value": [3000]},
        "2582": {"vr": "IS", "Value": [3000]},
        "2583": {"vr": "IS", "Value": [3000]},
        "2584": {"vr": "IS", "Value": [0]},
        "2585": {"vr": "IS", "Value": [0]},
        "2586": {"vr": "IS", "Value": [3000]},
        "2587": {"vr": "IS", "Value": [3000]},
        "2588": {"vr": "IS", "Value": [3000]},
        "2589": {"vr": "IS", "Value": [3000]},
        "2590": {"vr": "IS", "Value": [3000]},
        "2591": {"vr": "IS", "Value": [3000]},
        "2592": {"vr": "IS", "Value": [3000]},
        "2593": {"vr": "IS", "Value": [3000]},
        "2594": {"vr": "IS", "Value": [3000]},
        "2595": {"vr": "IS", "Value": [3000]},
        "2596": {"vr": "IS", "Value": [3000]},
        "2597": {"vr": "IS", "Value": [3000]},
        "2598": {"vr": "IS", "Value": [3000]},
        "2599": {"vr": "IS", "Value": [3000]},
        "2600": {"vr": "IS", "Value": [3000]},
        "2601": {"vr": "IS", "Value": [3000]},
        "2602": {"vr": "IS", "Value": [3000]},
        "2603": {"vr": "IS", "Value": [3000]},
        "2604": {"vr": "IS", "Value": [3000]},
        "2605": {"vr": "IS", "Value": [3000]},
        "2606": {"vr": "IS", "Value": [3000]},
        "2607": {"vr": "IS", "Value": [3000]},
        "2608": {"vr": "IS", "Value": [3000]},
        "2609": {"vr": "IS", "Value": [0]},
        "2610": {"vr": "IS", "Value": [3000]},
        "2611": {"vr": "IS", "Value": [0]},
        "2612": {"vr": "IS", "Value": [3000]},
        "2613": {"vr": "IS", "Value": [3000]},
        "2614": {"vr": "IS", "Value": [3000]},
        "2615": {"vr": "IS", "Value": [3000]},
        "2616": {"vr": "IS", "Value": [3000]},
        "2617": {"vr": "IS", "Value": [3000]},
        "2618": {"vr": "IS", "Value": [0]},
        "2619": {"vr": "IS", "Value": [3000]},
        "2620": {"vr": "IS", "Value": [3000]},
        "2621": {"vr": "IS", "Value": [3000]},
        "2622": {"vr": "IS", "Value": [3000]},
        "2623": {"vr": "IS", "Value": [3000]},
        "2624": {"vr": "IS", "Value": [3000]},
        "2625": {"vr": "IS", "Value": [3000]},
        "2626": {"vr": "IS", "Value": [3000]},
        "2627": {"vr": "IS", "Value": [3000]},
        "2628": {"vr": "IS", "Value": [0]},
        "2629": {"vr": "IS", "Value": [0]},
        "2630": {"vr": "IS", "Value": [3000]},
        "2631": {"vr": "IS", "Value": [3000]},
        "2632": {"vr": "IS", "Value": [3000]},
        "2633": {"vr": "IS", "Value": [3000]},
        "2634": {"vr": "IS", "Value": [3000]},
        "2635": {"vr": "IS", "Value": [3000]},
        "2636": {"vr": "IS", "Value": [0]},
        "2637": {"vr": "IS", "Value": [3000]},
        "2638": {"vr": "IS", "Value": [3000]},
        "2639": {"vr": "IS", "Value": [0]},
        "2640": {"vr": "IS", "Value": [0]},
        "2641": {"vr": "IS", "Value": [3000]},
        "2642": {"vr": "IS", "Value": [3000]},
        "2643": {"vr": "IS", "Value": [3000]},
        "2644": {"vr": "IS", "Value": [3000]},
        "2645": {"vr": "IS", "Value": [3000]},
        "2646": {"vr": "IS", "Value": [3000]},
        "2647": {"vr": "IS", "Value": [3000]},
        "2648": {"vr": "IS", "Value": [3000]},
        "2649": {"vr": "IS", "Value": [3000]},
        "2650": {"vr": "IS", "Value": [3000]},
        "2651": {"vr": "IS", "Value": [3000]},
        "2652": {"vr": "IS", "Value": [3000]},
        "2653": {"vr": "IS", "Value": [3000]},
        "2654": {"vr": "IS", "Value": [3000]},
        "2655": {"vr": "IS", "Value": [3000]},
        "2656": {"vr": "IS", "Value": [3000]},
        "2657": {"vr": "IS", "Value": [3000]},
        "2658": {"vr": "IS", "Value": [0]},
        "2659": {"vr": "IS", "Value": [3000]},
        "2660": {"vr": "IS", "Value": [3000]},
        "2661": {"vr": "IS", "Value": [3000]},
        "2662": {"vr": "IS", "Value": [3000]},
        "2663": {"vr": "IS", "Value": [3000]},
        "2664": {"vr": "IS", "Value": [3000]},
        "2665": {"vr": "IS", "Value": [3000]},
        "2666": {"vr": "IS", "Value": [3000]},
        "2667": {"vr": "IS", "Value": [3000]},
        "2668": {"vr": "IS", "Value": [3000]},
        "2669": {"vr": "IS", "Value": [3000]},
        "2670": {"vr": "IS", "Value": [3000]},
        "2671": {"vr": "IS", "Value": [3000]},
        "2672": {"vr": "IS", "Value": [3000]},
        "2673": {"vr": "IS", "Value": [3000]},
        "2674": {"vr": "IS", "Value": [3000]},
        "2675": {"vr": "IS", "Value": [3000]},
        "2676": {"vr": "IS", "Value": [3000]},
        "2677": {"vr": "IS", "Value": [3000]},
        "2678": {"vr": "IS", "Value": [3000]},
        "2679": {"vr": "IS", "Value": [0]},
        "2680": {"vr": "IS", "Value": [0]},
        "2681": {"vr": "IS", "Value": [3000]},
        "2682": {"vr": "IS", "Value": [3000]},
        "2683": {"vr": "IS", "Value": [3000]},
        "2684": {"vr": "IS", "Value": [3000]},
        "2685": {"vr": "IS", "Value": [3000]},
        "2686": {"vr": "IS", "Value": [3000]},
        "2687": {"vr": "IS", "Value": [3000]},
        "2688": {"vr": "IS", "Value": [3000]},
        "2689": {"vr": "IS", "Value": [3000]},
        "2690": {"vr": "IS", "Value": [3000]},
        "2691": {"vr": "IS", "Value": [3000]},
        "2692": {"vr": "IS", "Value": [3000]},
        "2693": {"vr": "IS", "Value": [3000]},
        "2694": {"vr": "IS", "Value": [3000]},
        "2695": {"vr": "IS", "Value": [3000]},
        "2696": {"vr": "IS", "Value": [3000]},
        "2697": {"vr": "IS", "Value": [3000]},
        "2698": {"vr": "IS", "Value": [3000]},
        "2699": {"vr": "IS", "Value": [3000]},
        "2700": {"vr": "IS", "Value": [3000]},
        "2701": {"vr": "IS", "Value": [3000]},
        "2702": {"vr": "IS", "Value": [0]},
        "2703": {"vr": "IS", "Value": [3000]},
        "2704": {"vr": "IS", "Value": [3000]},
        "2705": {"vr": "IS", "Value": [3000]},
        "2706": {"vr": "IS", "Value": [3000]},
        "2707": {"vr": "IS", "Value": [3000]},
        "2708": {"vr": "IS", "Value": [3000]},
        "2709": {"vr": "IS", "Value": [3000]},
        "2710": {"vr": "IS", "Value": [3000]},
        "2711": {"vr": "IS", "Value": [3000]},
        "2712": {"vr": "IS", "Value": [3000]},
        "2713": {"vr": "IS", "Value": [3000]},
        "2714": {"vr": "IS", "Value": [3000]},
        "2715": {"vr": "IS", "Value": [3000]},
        "2716": {"vr": "IS", "Value": [3000]},
        "2717": {"vr": "IS", "Value": [3000]},
        "2718": {"vr": "IS", "Value": [3000]},
        "2719": {"vr": "IS", "Value": [3000]},
        "2720": {"vr": "IS", "Value": [3000]},
        "2721": {"vr": "IS", "Value": [3000]},
        "2722": {"vr": "IS", "Value": [3000]},
        "2723": {"vr": "IS", "Value": [3000]},
        "2724": {"vr": "IS", "Value": [3000]},
        "2725": {"vr": "IS", "Value": [3000]},
        "2726": {"vr": "IS", "Value": [0]},
        "2727": {"vr": "IS", "Value": [3000]},
        "2728": {"vr": "IS", "Value": [3000]},
        "2729": {"vr": "IS", "Value": [3000]},
        "2730": {"vr": "IS", "Value": [3000]},
        "2731": {"vr": "IS", "Value": [3000]},
        "2732": {"vr": "IS", "Value": [3000]},
        "2733": {"vr": "IS", "Value": [3000]},
        "2734": {"vr": "IS", "Value": [3000]},
        "2735": {"vr": "IS", "Value": [3000]},
        "2736": {"vr": "IS", "Value": [0]},
        "2737": {"vr": "IS", "Value": [3000]},
        "2738": {"vr": "IS", "Value": [3000]},
        "2739": {"vr": "IS", "Value": [3000]},
        "2740": {"vr": "IS", "Value": [3000]},
        "2741": {"vr": "IS", "Value": [0]},
        "2742": {"vr": "IS", "Value": [3000]},
        "2743": {"vr": "IS", "Value": [3000]},
        "2744": {"vr": "IS", "Value": [3000]},
        "2745": {"vr": "IS", "Value": [3000]},
        "2746": {"vr": "IS", "Value": [0]},
        "2747": {"vr": "IS", "Value": [3000]},
        "2748": {"vr": "IS", "Value": [3000]},
        "2749": {"vr": "IS", "Value": [3000]},
        "2750": {"vr": "IS", "Value": [0]},
        "2751": {"vr": "IS", "Value": [3000]},
        "2752": {"vr": "IS", "Value": [3000]},
        "2753": {"vr": "IS", "Value": [3000]},
        "2754": {"vr": "IS", "Value": [3000]},
        "2755": {"vr": "IS", "Value": [3000]},
        "2756": {"vr": "IS", "Value": [3000]},
        "2757": {"vr": "IS", "Value": [0]},
        "2758": {"vr": "IS", "Value": [3000]},
        "2759": {"vr": "IS", "Value": [3000]},
        "2760": {"vr": "IS", "Value": [3000]},
        "2761": {"vr": "IS", "Value": [3000]},
        "2762": {"vr": "IS", "Value": [3000]},
        "2763": {"vr": "IS", "Value": [3000]},
        "2764": {"vr": "IS", "Value": [3000]},
        "2765": {"vr": "IS", "Value": [0]},
        "2766": {"vr": "IS", "Value": [3000]},
        "2767": {"vr": "IS", "Value": [3000]},
        "2768": {"vr": "IS", "Value": [3000]},
        "2769": {"vr": "IS", "Value": [3000]},
        "2770": {"vr": "IS", "Value": [0]},
        "2771": {"vr": "IS", "Value": [3000]},
        "2772": {"vr": "IS", "Value": [3000]},
        "2773": {"vr": "IS", "Value": [3000]},
        "2774": {"vr": "IS", "Value": [3000]},
        "2775": {"vr": "IS", "Value": [3000]},
        "2776": {"vr": "IS", "Value": [3000]},
        "2777": {"vr": "IS", "Value": [0]},
        "2778": {"vr": "IS", "Value": [3000]},
        "2779": {"vr": "IS", "Value": [3000]},
        "2780": {"vr": "IS", "Value": [3000]},
        "2781": {"vr": "IS", "Value": [0]},
        "2782": {"vr": "IS", "Value": [3000]},
        "2783": {"vr": "IS", "Value": [3000]},
        "2784": {"vr": "IS", "Value": [3000]},
        "2785": {"vr": "IS", "Value": [3000]},
        "2786": {"vr": "IS", "Value": [3000]},
        "2787": {"vr": "IS", "Value": [3000]},
        "2788": {"vr": "IS", "Value": [3000]},
        "2789": {"vr": "IS", "Value": [3000]},
        "2790": {"vr": "IS", "Value": [3000]},
        "2791": {"vr": "IS", "Value": [3000]},
        "2792": {"vr": "IS", "Value": [0]},
        "2793": {"vr": "IS", "Value": [3000]},
        "2794": {"vr": "IS", "Value": [3000]},
        "2795": {"vr": "IS", "Value": [3000]},
        "2796": {"vr": "IS", "Value": [3000]},
        "2797": {"vr": "IS", "Value": [0]},
        "2798": {"vr": "IS", "Value": [3000]},
        "2799": {"vr": "IS", "Value": [3000]},
        "2800": {"vr": "IS", "Value": [3000]},
        "2801": {"vr": "IS", "Value": [3000]},
        "2802": {"vr": "IS", "Value": [3000]},
        "2803": {"vr": "IS", "Value": [3000]},
        "2804": {"vr": "IS", "Value": [3000]},
        "2805": {"vr": "IS", "Value": [3000]},
        "2806": {"vr": "IS", "Value": [3000]},
        "2807": {"vr": "IS", "Value": [3000]},
        "2808": {"vr": "IS", "Value": [3000]},
        "2809": {"vr": "IS", "Value": [3000]},
        "2810": {"vr": "IS", "Value": [3000]},
        "2811": {"vr": "IS", "Value": [3000]},
        "2812": {"vr": "IS", "Value": [3000]},
        "2813": {"vr": "IS", "Value": [3000]},
        "2814": {"vr": "IS", "Value": [3000]},
        "2815": {"vr": "IS", "Value": [3000]},
        "2816": {"vr": "IS", "Value": [3000]},
        "2817": {"vr": "IS", "Value": [3000]},
        "2818": {"vr": "IS", "Value": [0]},
        "2819": {"vr": "IS", "Value": [3000]},
        "2820": {"vr": "IS", "Value": [3000]},
        "2821": {"vr": "IS", "Value": [3000]},
        "2822": {"vr": "IS", "Value": [0]},
        "2823": {"vr": "IS", "Value": [3000]},
        "2824": {"vr": "IS", "Value": [3000]},
        "2825": {"vr": "IS", "Value": [3000]},
        "2826": {"vr": "IS", "Value": [3000]},
        "2827": {"vr": "IS", "Value": [3000]},
        "2828": {"vr": "IS", "Value": [3000]},
        "2829": {"vr": "IS", "Value": [3000]},
        "2830": {"vr": "IS", "Value": [0]},
        "2831": {"vr": "IS", "Value": [3000]},
        "2832": {"vr": "IS", "Value": [3000]},
        "2833": {"vr": "IS", "Value": [3000]},
        "2834": {"vr": "IS", "Value": [3000]},
        "2835": {"vr": "IS", "Value": [3000]},
        "2836": {"vr": "IS", "Value": [3000]},
        "2837": {"vr": "IS", "Value": [3000]},
        "2838": {"vr": "IS", "Value": [3000]},
        "2839": {"vr": "IS", "Value": [3000]},
        "2840": {"vr": "IS", "Value": [3000]},
        "2841": {"vr": "IS", "Value": [3000]},
        "2842": {"vr": "IS", "Value": [3000]},
        "2843": {"vr": "IS", "Value": [3000]},
        "2844": {"vr": "IS", "Value": [3000]},
        "2845": {"vr": "IS", "Value": [3000]},
        "2846": {"vr": "IS", "Value": [3000]},
        "2847": {"vr": "IS", "Value": [3000]},
        "2848": {"vr": "IS", "Value": [3000]},
        "2849": {"vr": "IS", "Value": [3000]},
        "2850": {"vr": "IS", "Value": [3000]},
        "2851": {"vr": "IS", "Value": [3000]},
        "2852": {"vr": "IS", "Value": [0]},
        "2853": {"vr": "IS", "Value": [3000]},
        "2854": {"vr": "IS", "Value": [3000]},
        "2855": {"vr": "IS", "Value": [0]},
        "2856": {"vr": "IS", "Value": [3000]},
        "2857": {"vr": "IS", "Value": [3000]},
        "2858": {"vr": "IS", "Value": [3000]},
        "2859": {"vr": "IS", "Value": [3000]},
        "2860": {"vr": "IS", "Value": [3000]},
        "2861": {"vr": "IS", "Value": [3000]},
        "2862": {"vr": "IS", "Value": [0]},
        "2863": {"vr": "IS", "Value": [3000]},
        "2864": {"vr": "IS", "Value": [3000]},
        "2865": {"vr": "IS", "Value": [3000]},
        "2866": {"vr": "IS", "Value": [3000]},
        "2867": {"vr": "IS", "Value": [3000]},
        "2868": {"vr": "IS", "Value": [3000]},
        "2869": {"vr": "IS", "Value": [3000]},
        "2870": {"vr": "IS", "Value": [3000]},
        "2871": {"vr": "IS", "Value": [3000]},
        "2872": {"vr": "IS", "Value": [3000]},
        "2873": {"vr": "IS", "Value": [3000]},
        "2874": {"vr": "IS", "Value": [3000]},
        "2875": {"vr": "IS", "Value": [3000]},
        "2876": {"vr": "IS", "Value": [3000]},
        "2877": {"vr": "IS", "Value": [3000]},
        "2878": {"vr": "IS", "Value": [0]},
        "2879": {"vr": "IS", "Value": [3000]},
        "2880": {"vr": "IS", "Value": [3000]},
        "2881": {"vr": "IS", "Value": [3000]},
        "2882": {"vr": "IS", "Value": [0]},
        "2883": {"vr": "IS", "Value": [3000]},
        "2884": {"vr": "IS", "Value": [3000]},
        "2885": {"vr": "IS", "Value": [3000]},
        "2886": {"vr": "IS", "Value": [3000]},
        "2887": {"vr": "IS", "Value": [3000]},
        "2888": {"vr": "IS", "Value": [3000]},
        "2889": {"vr": "IS", "Value": [3000]},
        "2890": {"vr": "IS", "Value": [3000]},
        "2891": {"vr": "IS", "Value": [3000]},
        "2892": {"vr": "IS", "Value": [3000]},
        "2893": {"vr": "IS", "Value": [3000]},
        "2894": {"vr": "IS", "Value": [3000]},
        "2895": {"vr": "IS", "Value": [3000]},
        "2896": {"vr": "IS", "Value": [3000]},
        "2897": {"vr": "IS", "Value": [3000]},
        "2898": {"vr": "IS", "Value": [3000]},
        "2899": {"vr": "IS", "Value": [3000]},
        "2900": {"vr": "IS", "Value": [3000]},
        "2901": {"vr": "IS", "Value": [3000]},
        "2902": {"vr": "IS", "Value": [3000]},
        "2903": {"vr": "IS", "Value": [3000]},
        "2904": {"vr": "IS", "Value": [3000]},
        "2905": {"vr": "IS", "Value": [3000]},
        "2906": {"vr": "IS", "Value": [0]},
        "2907": {"vr": "IS", "Value": [0]},
        "2908": {"vr": "IS", "Value": [3000]},
        "2909": {"vr": "IS", "Value": [3000]},
        "2910": {"vr": "IS", "Value": [3000]},
        "2911": {"vr": "IS", "Value": [3000]},
        "2912": {"vr": "IS", "Value": [3000]},
        "2913": {"vr": "IS", "Value": [3000]},
        "2914": {"vr": "IS", "Value": [3000]},
        "2915": {"vr": "IS", "Value": [3000]},
        "2916": {"vr": "IS", "Value": [0]},
        "2917": {"vr": "IS", "Value": [3000]},
        "2918": {"vr": "IS", "Value": [0]},
        "2919": {"vr": "IS", "Value": [0]},
        "2920": {"vr": "IS", "Value": [3000]},
        "2921": {"vr": "IS", "Value": [3000]},
        "2922": {"vr": "IS", "Value": [3000]},
        "2923": {"vr": "IS", "Value": [0]},
        "2924": {"vr": "IS", "Value": [3000]},
        "2925": {"vr": "IS", "Value": [3000]},
        "2926": {"vr": "IS", "Value": [3000]},
        "2927": {"vr": "IS", "Value": [3000]},
        "2928": {"vr": "IS", "Value": [3000]},
        "2929": {"vr": "IS", "Value": [3000]},
        "2930": {"vr": "IS", "Value": [0]},
        "2931": {"vr": "IS", "Value": [3000]},
        "2932": {"vr": "IS", "Value": [3000]},
        "2933": {"vr": "IS", "Value": [3000]},
        "2934": {"vr": "IS", "Value": [3000]},
        "2935": {"vr": "IS", "Value": [0]},
        "2936": {"vr": "IS", "Value": [3000]},
        "2937": {"vr": "IS", "Value": [3000]},
        "2938": {"vr": "IS", "Value": [3000]},
        "2939": {"vr": "IS", "Value": [3000]},
        "2940": {"vr": "IS", "Value": [3000]},
        "2941": {"vr": "IS", "Value": [3000]},
        "2942": {"vr": "IS", "Value": [3000]},
        "2943": {"vr": "IS", "Value": [3000]},
        "2944": {"vr": "IS", "Value": [3000]},
        "2945": {"vr": "IS", "Value": [3000]},
        "2946": {"vr": "IS", "Value": [0]},
        "2947": {"vr": "IS", "Value": [3000]},
        "2948": {"vr": "IS", "Value": [3000]},
        "2949": {"vr": "IS", "Value": [0]},
        "2950": {"vr": "IS", "Value": [3000]},
        "2951": {"vr": "IS", "Value": [3000]},
        "2952": {"vr": "IS", "Value": [3000]},
        "2953": {"vr": "IS", "Value": [3000]},
        "2954": {"vr": "IS", "Value": [0]},
        "2955": {"vr": "IS", "Value": [0]},
        "2956": {"vr": "IS", "Value": [3000]},
        "2957": {"vr": "IS", "Value": [3000]},
        "2958": {"vr": "IS", "Value": [3000]},
        "2959": {"vr": "IS", "Value": [3000]},
        "2960": {"vr": "IS", "Value": [3000]},
        "2961": {"vr": "IS", "Value": [3000]},
        "2962": {"vr": "IS", "Value": [3000]},
        "2963": {"vr": "IS", "Value": [3000]},
        "2964": {"vr": "IS", "Value": [3000]},
        "2965": {"vr": "IS", "Value": [3000]},
        "2966": {"vr": "IS", "Value": [3000]},
        "2967": {"vr": "IS", "Value": [3000]},
        "2968": {"vr": "IS", "Value": [0]},
        "2969": {"vr": "IS", "Value": [3000]},
        "2970": {"vr": "IS", "Value": [3000]},
        "2971": {"vr": "IS", "Value": [3000]},
        "2972": {"vr": "IS", "Value": [3000]},
        "2973": {"vr": "IS", "Value": [3000]},
        "2974": {"vr": "IS", "Value": [3000]},
        "2975": {"vr": "IS", "Value": [3000]},
        "2976": {"vr": "IS", "Value": [3000]},
        "2977": {"vr": "IS", "Value": [3000]},
        "2978": {"vr": "IS", "Value": [3000]},
        "2979": {"vr": "IS", "Value": [3000]},
        "2980": {"vr": "IS", "Value": [3000]},
        "2981": {"vr": "IS", "Value": [3000]},
        "2982": {"vr": "IS", "Value": [3000]},
        "2983": {"vr": "IS", "Value": [3000]},
        "2984": {"vr": "IS", "Value": [3000]},
        "2985": {"vr": "IS", "Value": [0]},
        "2986": {"vr": "IS", "Value": [3000]},
        "2987": {"vr": "IS", "Value": [3000]},
        "2988": {"vr": "IS", "Value": [3000]},
        "2989": {"vr": "IS", "Value": [3000]},
        "2990": {"vr": "IS", "Value": [3000]},
        "2991": {"vr": "IS", "Value": [3000]},
        "2992": {"vr": "IS", "Value": [3000]},
        "2993": {"vr": "IS", "Value": [3000]},
        "2994": {"vr": "IS", "Value": [3000]},
        "2995": {"vr": "IS", "Value": [3000]},
        "2996": {"vr": "IS", "Value": [3000]},
        "2997": {"vr": "IS", "Value": [3000]},
        "2998": {"vr": "IS", "Value": [3000]},
        "2999": {"vr": "IS", "Value": [3000]},
        "3000": {"vr": "IS", "Value": [3000]},
        "3001": {"vr": "IS", "Value": [3000]},
        "3002": {"vr": "IS", "Value": [3000]},
        "3003": {"vr": "IS", "Value": [3000]},
        "3004": {"vr": "IS", "Value": [3000]},
        "3005": {"vr": "IS", "Value": [0]},
        "3006": {"vr": "IS", "Value": [3000]},
        "3007": {"vr": "IS", "Value": [3000]},
        "3008": {"vr": "IS", "Value": [3000]},
        "3009": {"vr": "IS", "Value": [3000]},
        "3010": {"vr": "IS", "Value": [3000]},
        "3011": {"vr": "IS", "Value": [3000]},
        "3012": {"vr": "IS", "Value": [3000]},
        "3013": {"vr": "IS", "Value": [3000]},
        "3014": {"vr": "IS", "Value": [3000]},
        "3015": {"vr": "IS", "Value": [3000]},
        "3016": {"vr": "IS", "Value": [3000]},
        "3017": {"vr": "IS", "Value": [3000]},
        "3018": {"vr": "IS", "Value": [3000]},
        "3019": {"vr": "IS", "Value": [0]},
        "3020": {"vr": "IS", "Value": [3000]},
        "3021": {"vr": "IS", "Value": [3000]},
        "3022": {"vr": "IS", "Value": [3000]},
        "3023": {"vr": "IS", "Value": [3000]},
        "3024": {"vr": "IS", "Value": [3000]},
        "3025": {"vr": "IS", "Value": [3000]},
        "3026": {"vr": "IS", "Value": [3000]},
        "3027": {"vr": "IS", "Value": [3000]},
        "3028": {"vr": "IS", "Value": [3000]},
        "3029": {"vr": "IS", "Value": [0]},
        "3030": {"vr": "IS", "Value": [3000]},
        "3031": {"vr": "IS", "Value": [3000]},
        "3032": {"vr": "IS", "Value": [3000]},
        "3033": {"vr": "IS", "Value": [3000]},
        "3034": {"vr": "IS", "Value": [3000]},
        "3035": {"vr": "IS", "Value": [3000]},
        "3036": {"vr": "IS", "Value": [3000]},
        "3037": {"vr": "IS", "Value": [3000]},
        "3038": {"vr": "IS", "Value": [3000]},
        "3039": {"vr": "IS", "Value": [3000]},
        "3040": {"vr": "IS", "Value": [3000]},
        "3041": {"vr": "IS", "Value": [3000]},
        "3042": {"vr": "IS", "Value": [3000]},
        "3043": {"vr": "IS", "Value": [3000]},
        "3044": {"vr": "IS", "Value": [3000]},
        "3045": {"vr": "IS", "Value": [3000]},
        "3046": {"vr": "IS", "Value": [3000]},
        "3047": {"vr": "IS", "Value": [3000]},
        "3048": {"vr": "IS", "Value": [3000]},
        "3049": {"vr": "IS", "Value": [3000]},
        "3050": {"vr": "IS", "Value": [3000]},
        "3051": {"vr": "IS", "Value": [3000]},
        "3052": {"vr": "IS", "Value": [3000]},
        "3053": {"vr": "IS", "Value": [0]},
        "3054": {"vr": "IS", "Value": [3000]},
        "3055": {"vr": "IS", "Value": [3000]},
        "3056": {"vr": "IS", "Value": [3000]},
        "3057": {"vr": "IS", "Value": [3000]},
        "3058": {"vr": "IS", "Value": [3000]},
        "3059": {"vr": "IS", "Value": [3000]},
        "3060": {"vr": "IS", "Value": [3000]},
        "3061": {"vr": "IS", "Value": [3000]},
        "3062": {"vr": "IS", "Value": [3000]},
        "3063": {"vr": "IS", "Value": [3000]},
        "3064": {"vr": "IS", "Value": [3000]},
        "3065": {"vr": "IS", "Value": [3000]},
        "3066": {"vr": "IS", "Value": [3000]},
        "3067": {"vr": "IS", "Value": [3000]},
        "3068": {"vr": "IS", "Value": [3000]},
        "3069": {"vr": "IS", "Value": [3000]},
        "3070": {"vr": "IS", "Value": [3000]},
        "3071": {"vr": "IS", "Value": [3000]},
        "3072": {"vr": "IS", "Value": [0]},
        "3073": {"vr": "IS", "Value": [3000]},
        "3074": {"vr": "IS", "Value": [0]},
        "3075": {"vr": "IS", "Value": [3000]},
        "3076": {"vr": "IS", "Value": [3000]},
        "3077": {"vr": "IS", "Value": [0]},
        "3078": {"vr": "IS", "Value": [3000]},
        "3079": {"vr": "IS", "Value": [3000]},
        "3080": {"vr": "IS", "Value": [3000]},
        "3081": {"vr": "IS", "Value": [3000]},
        "3082": {"vr": "IS", "Value": [3000]},
        "3083": {"vr": "IS", "Value": [3000]},
        "3084": {"vr": "IS", "Value": [3000]},
        "3085": {"vr": "IS", "Value": [3000]},
        "3086": {"vr": "IS", "Value": [3000]},
        "3087": {"vr": "IS", "Value": [3000]},
        "3088": {"vr": "IS", "Value": [3000]},
        "3089": {"vr": "IS", "Value": [0]},
        "3090": {"vr": "IS", "Value": [3000]},
        "3091": {"vr": "IS", "Value": [3000]},
        "3092": {"vr": "IS", "Value": [0]},
        "3093": {"vr": "IS", "Value": [3000]},
        "3094": {"vr": "IS", "Value": [3000]},
        "3095": {"vr": "IS", "Value": [3000]},
        "3096": {"vr": "IS", "Value": [3000]},
        "3097": {"vr": "IS", "Value": [3000]},
        "3098": {"vr": "IS", "Value": [3000]},
        "3099": {"vr": "IS", "Value": [3000]},
        "3100": {"vr": "IS", "Value": [3000]},
        "3101": {"vr": "IS", "Value": [3000]},
        "3102": {"vr": "IS", "Value": [0]},
        "3103": {"vr": "IS", "Value": [3000]},
        "3104": {"vr": "IS", "Value": [3000]},
        "3105": {"vr": "IS", "Value": [3000]},
        "3106": {"vr": "IS", "Value": [3000]},
        "3107": {"vr": "IS", "Value": [3000]},
        "3108": {"vr": "IS", "Value": [3000]},
        "3109": {"vr": "IS", "Value": [3000]},
        "3110": {"vr": "IS", "Value": [3000]},
        "3111": {"vr": "IS", "Value": [3000]},
        "3112": {"vr": "IS", "Value": [3000]},
        "3113": {"vr": "IS", "Value": [3000]},
        "3114": {"vr": "IS", "Value": [3000]},
        "3115": {"vr": "IS", "Value": [3000]},
        "3116": {"vr": "IS", "Value": [3000]},
        "3117": {"vr": "IS", "Value": [3000]},
        "3118": {"vr": "IS", "Value": [3000]},
        "3119": {"vr": "IS", "Value": [3000]},
        "3120": {"vr": "IS", "Value": [3000]},
        "3121": {"vr": "IS", "Value": [3000]},
        "3122": {"vr": "IS", "Value": [3000]},
        "3123": {"vr": "IS", "Value": [3000]},
        "3124": {"vr": "IS", "Value": [3000]},
        "3125": {"vr": "IS", "Value": [3000]},
        "3126": {"vr": "IS", "Value": [3000]},
        "3127": {"vr": "IS", "Value": [3000]},
        "3128": {"vr": "IS", "Value": [3000]},
        "3129": {"vr": "IS", "Value": [3000]},
        "3130": {"vr": "IS", "Value": [3000]},
        "3131": {"vr": "IS", "Value": [3000]},
        "3132": {"vr": "IS", "Value": [0]},
        "3133": {"vr": "IS", "Value": [3000]},
        "3134": {"vr": "IS", "Value": [3000]},
        "3135": {"vr": "IS", "Value": [3000]},
        "3136": {"vr": "IS", "Value": [3000]},
        "3137": {"vr": "IS", "Value": [3000]},
        "3138": {"vr": "IS", "Value": [3000]},
        "3139": {"vr": "IS", "Value": [3000]},
        "3140": {"vr": "IS", "Value": [3000]},
        "3141": {"vr": "IS", "Value": [3000]},
        "3142": {"vr": "IS", "Value": [3000]},
        "3143": {"vr": "IS", "Value": [3000]},
        "3144": {"vr": "IS", "Value": [3000]},
        "3145": {"vr": "IS", "Value": [3000]},
        "3146": {"vr": "IS", "Value": [3000]},
        "3147": {"vr": "IS", "Value": [3000]},
        "3148": {"vr": "IS", "Value": [3000]},
        "3149": {"vr": "IS", "Value": [3000]},
        "3150": {"vr": "IS", "Value": [3000]},
        "3151": {"vr": "IS", "Value": [3000]},
        "3152": {"vr": "IS", "Value": [3000]},
        "3153": {"vr": "IS", "Value": [3000]},
        "3154": {"vr": "IS", "Value": [3000]},
        "3155": {"vr": "IS", "Value": [3000]},
        "3156": {"vr": "IS", "Value": [3000]},
        "3157": {"vr": "IS", "Value": [3000]},
        "3158": {"vr": "IS", "Value": [3000]},
        "3159": {"vr": "IS", "Value": [3000]},
        "3160": {"vr": "IS", "Value": [0]},
        "3161": {"vr": "IS", "Value": [3000]},
        "3162": {"vr": "IS", "Value": [3000]},
        "3163": {"vr": "IS", "Value": [3000]},
        "3164": {"vr": "IS", "Value": [3000]},
        "3165": {"vr": "IS", "Value": [0]},
        "3166": {"vr": "IS", "Value": [3000]},
        "3167": {"vr": "IS", "Value": [3000]},
        "3168": {"vr": "IS", "Value": [3000]},
        "3169": {"vr": "IS", "Value": [3000]},
        "3170": {"vr": "IS", "Value": [3000]},
        "3171": {"vr": "IS", "Value": [3000]},
        "3172": {"vr": "IS", "Value": [0]},
        "3173": {"vr": "IS", "Value": [3000]},
        "3174": {"vr": "IS", "Value": [3000]},
        "3175": {"vr": "IS", "Value": [3000]},
        "3176": {"vr": "IS", "Value": [3000]},
        "3177": {"vr": "IS", "Value": [3000]},
        "3178": {"vr": "IS", "Value": [3000]},
        "3179": {"vr": "IS", "Value": [3000]},
        "3180": {"vr": "IS", "Value": [3000]},
        "3181": {"vr": "IS", "Value": [3000]},
        "3182": {"vr": "IS", "Value": [3000]},
        "3183": {"vr": "IS", "Value": [3000]},
        "3184": {"vr": "IS", "Value": [3000]},
        "3185": {"vr": "IS", "Value": [3000]},
        "3186": {"vr": "IS", "Value": [3000]},
        "3187": {"vr": "IS", "Value": [3000]},
        "3188": {"vr": "IS", "Value": [3000]},
        "3189": {"vr": "IS", "Value": [3000]},
        "3190": {"vr": "IS", "Value": [3000]},
        "3191": {"vr": "IS", "Value": [3000]},
        "3192": {"vr": "IS", "Value": [3000]},
        "3193": {"vr": "IS", "Value": [0]},
        "3194": {"vr": "IS", "Value": [0]},
        "3195": {"vr": "IS", "Value": [3000]},
        "3196": {"vr": "IS", "Value": [3000]},
        "3197": {"vr": "IS", "Value": [3000]},
        "3198": {"vr": "IS", "Value": [3000]},
        "3199": {"vr": "IS", "Value": [3000]},
        "3200": {"vr": "IS", "Value": [3000]},
        "3201": {"vr": "IS", "Value": [3000]},
        "3202": {"vr": "IS", "Value": [3000]},
        "3203": {"vr": "IS", "Value": [3000]},
        "3204": {"vr": "IS", "Value": [3000]},
        "3205": {"vr": "IS", "Value": [3000]},
        "3206": {"vr": "IS", "Value": [3000]},
        "3207": {"vr": "IS", "Value": [3000]},
        "3208": {"vr": "IS", "Value": [3000]},
        "3209": {"vr": "IS", "Value": [3000]},
        "3210": {"vr": "IS", "Value": [3000]},
        "3211": {"vr": "IS", "Value": [3000]},
        "3212": {"vr": "IS", "Value": [3000]},
        "3213": {"vr": "IS", "Value": [3000]},
        "3214": {"vr": "IS", "Value": [0]},
        "3215": {"vr": "IS", "Value": [3000]},
        "3216": {"vr": "IS", "Value": [3000]},
        "3217": {"vr": "IS", "Value": [3000]},
        "3218": {"vr": "IS", "Value": [0]},
        "3219": {"vr": "IS", "Value": [3000]},
        "3220": {"vr": "IS", "Value": [3000]},
        "3221": {"vr": "IS", "Value": [3000]},
        "3222": {"vr": "IS", "Value": [3000]},
        "3223": {"vr": "IS", "Value": [3000]},
        "3224": {"vr": "IS", "Value": [3000]},
        "3225": {"vr": "IS", "Value": [3000]},
        "3226": {"vr": "IS", "Value": [3000]},
        "3227": {"vr": "IS", "Value": [3000]},
        "3228": {"vr": "IS", "Value": [3000]},
        "3229": {"vr": "IS", "Value": [3000]},
        "3230": {"vr": "IS", "Value": [0]},
        "3231": {"vr": "IS", "Value": [3000]},
        "3232": {"vr": "IS", "Value": [3000]},
        "3233": {"vr": "IS", "Value": [3000]},
        "3234": {"vr": "IS", "Value": [3000]},
        "3235": {"vr": "IS", "Value": [3000]},
        "3236": {"vr": "IS", "Value": [3000]},
        "3237": {"vr": "IS", "Value": [3000]},
        "3238": {"vr": "IS", "Value": [3000]},
        "3239": {"vr": "IS", "Value": [3000]},
        "3240": {"vr": "IS", "Value": [3000]},
        "3241": {"vr": "IS", "Value": [3000]},
        "3242": {"vr": "IS", "Value": [3000]},
        "3243": {"vr": "IS", "Value": [0]},
        "3244": {"vr": "IS", "Value": [3000]},
        "3245": {"vr": "IS", "Value": [3000]},
        "3246": {"vr": "IS", "Value": [3000]},
        "3247": {"vr": "IS", "Value": [3000]},
        "3248": {"vr": "IS", "Value": [3000]},
        "3249": {"vr": "IS", "Value": [3000]},
        "3250": {"vr": "IS", "Value": [3000]},
        "3251": {"vr": "IS", "Value": [3000]},
        "3252": {"vr": "IS", "Value": [3000]},
        "3253": {"vr": "IS", "Value": [3000]},
        "3254": {"vr": "IS", "Value": [3000]},
        "3255": {"vr": "IS", "Value": [3000]},
        "3256": {"vr": "IS", "Value": [0]},
        "3257": {"vr": "IS", "Value": [3000]},
        "3258": {"vr": "IS", "Value": [0]},
        "3259": {"vr": "IS", "Value": [3000]},
        "3260": {"vr": "IS", "Value": [3000]},
        "3261": {"vr": "IS", "Value": [3000]},
        "3262": {"vr": "IS", "Value": [3000]},
        "3263": {"vr": "IS", "Value": [3000]},
        "3264": {"vr": "IS", "Value": [0]},
        "3265": {"vr": "IS", "Value": [3000]},
        "3266": {"vr": "IS", "Value": [3000]},
        "3267": {"vr": "IS", "Value": [3000]},
        "3268": {"vr": "IS", "Value": [3000]},
        "3269": {"vr": "IS", "Value": [3000]},
        "3270": {"vr": "IS", "Value": [0]},
        "3271": {"vr": "IS", "Value": [3000]},
        "3272": {"vr": "IS", "Value": [3000]},
        "3273": {"vr": "IS", "Value": [3000]},
        "3274": {"vr": "IS", "Value": [3000]},
        "3275": {"vr": "IS", "Value": [3000]},
        "3276": {"vr": "IS", "Value": [3000]},
        "3277": {"vr": "IS", "Value": [3000]},
        "3278": {"vr": "IS", "Value": [3000]},
        "3279": {"vr": "IS", "Value": [3000]},
        "3280": {"vr": "IS", "Value": [0]},
        "3281": {"vr": "IS", "Value": [3000]},
        "3282": {"vr": "IS", "Value": [3000]},
        "3283": {"vr": "IS", "Value": [3000]},
        "3284": {"vr": "IS", "Value": [3000]},
        "3285": {"vr": "IS", "Value": [3000]},
        "3286": {"vr": "IS", "Value": [3000]},
        "3287": {"vr": "IS", "Value": [3000]},
        "3288": {"vr": "IS", "Value": [3000]},
        "3289": {"vr": "IS", "Value": [3000]},
        "3290": {"vr": "IS", "Value": [3000]},
        "3291": {"vr": "IS", "Value": [3000]},
        "3292": {"vr": "IS", "Value": [3000]},
        "3293": {"vr": "IS", "Value": [3000]},
        "3294": {"vr": "IS", "Value": [3000]},
        "3295": {"vr": "IS", "Value": [3000]},
        "3296": {"vr": "IS", "Value": [3000]},
        "3297": {"vr": "IS", "Value": [3000]},
        "3298": {"vr": "IS", "Value": [3000]},
        "3299": {"vr": "IS", "Value": [3000]},
        "3300": {"vr": "IS", "Value": [3000]},
        "3301": {"vr": "IS", "Value": [3000]},
        "3302": {"vr": "IS", "Value": [3000]},
        "3303": {"vr": "IS", "Value": [3000]},
        "3304": {"vr": "IS", "Value": [3000]},
        "3305": {"vr": "IS", "Value": [3000]},
        "3306": {"vr": "IS", "Value": [3000]},
        "3307": {"vr": "IS", "Value": [3000]},
        "3308": {"vr": "IS", "Value": [3000]},
        "3309": {"vr": "IS", "Value": [3000]},
        "3310": {"vr": "IS", "Value": [3000]},
        "3311": {"vr": "IS", "Value": [3000]},
        "3312": {"vr": "IS", "Value": [3000]},
        "3313": {"vr": "IS", "Value": [3000]},
        "3314": {"vr": "IS", "Value": [3000]},
        "3315": {"vr": "IS", "Value": [0]},
        "3316": {"vr": "IS", "Value": [3000]},
        "3317": {"vr": "IS", "Value": [3000]},
        "3318": {"vr": "IS", "Value": [3000]},
        "3319": {"vr": "IS", "Value": [3000]},
        "3320": {"vr": "IS", "Value": [3000]},
        "3321": {"vr": "IS", "Value": [3000]},
        "3322": {"vr": "IS", "Value": [3000]},
        "3323": {"vr": "IS", "Value": [3000]},
        "3324": {"vr": "IS", "Value": [3000]},
        "3325": {"vr": "IS", "Value": [3000]},
        "3326": {"vr": "IS", "Value": [3000]},
        "3327": {"vr": "IS", "Value": [3000]},
        "3328": {"vr": "IS", "Value": [0]},
        "3329": {"vr": "IS", "Value": [3000]},
        "3330": {"vr": "IS", "Value": [3000]},
        "3331": {"vr": "IS", "Value": [3000]},
        "3332": {"vr": "IS", "Value": [3000]},
        "3333": {"vr": "IS", "Value": [3000]},
        "3334": {"vr": "IS", "Value": [3000]},
        "3335": {"vr": "IS", "Value": [3000]},
        "3336": {"vr": "IS", "Value": [3000]},
        "3337": {"vr": "IS", "Value": [3000]},
        "3338": {"vr": "IS", "Value": [3000]},
        "3339": {"vr": "IS", "Value": [3000]},
        "3340": {"vr": "IS", "Value": [3000]},
        "3341": {"vr": "IS", "Value": [3000]},
        "3342": {"vr": "IS", "Value": [3000]},
        "3343": {"vr": "IS", "Value": [0]},
        "3344": {"vr": "IS", "Value": [3000]},
        "3345": {"vr": "IS", "Value": [3000]},
        "3346": {"vr": "IS", "Value": [3000]},
        "3347": {"vr": "IS", "Value": [0]},
        "3348": {"vr": "IS", "Value": [3000]},
        "3349": {"vr": "IS", "Value": [3000]},
        "3350": {"vr": "IS", "Value": [3000]},
        "3351": {"vr": "IS", "Value": [3000]},
        "3352": {"vr": "IS", "Value": [3000]},
        "3353": {"vr": "IS", "Value": [3000]},
        "3354": {"vr": "IS", "Value": [3000]},
        "3355": {"vr": "IS", "Value": [3000]},
        "3356": {"vr": "IS", "Value": [3000]},
        "3357": {"vr": "IS", "Value": [3000]},
        "3358": {"vr": "IS", "Value": [3000]},
        "3359": {"vr": "IS", "Value": [3000]},
        "3360": {"vr": "IS", "Value": [3000]},
        "3361": {"vr": "IS", "Value": [3000]},
        "3362": {"vr": "IS", "Value": [3000]},
        "3363": {"vr": "IS", "Value": [3000]},
        "3364": {"vr": "IS", "Value": [3000]},
        "3365": {"vr": "IS", "Value": [0]},
        "3366": {"vr": "IS", "Value": [3000]},
        "3367": {"vr": "IS", "Value": [3000]},
        "3368": {"vr": "IS", "Value": [3000]},
        "3369": {"vr": "IS", "Value": [3000]},
        "3370": {"vr": "IS", "Value": [3000]},
        "3371": {"vr": "IS", "Value": [3000]},
        "3372": {"vr": "IS", "Value": [3000]},
        "3373": {"vr": "IS", "Value": [3000]},
        "3374": {"vr": "IS", "Value": [3000]},
        "3375": {"vr": "IS", "Value": [3000]},
        "3376": {"vr": "IS", "Value": [0]},
        "3377": {"vr": "IS", "Value": [3000]},
        "3378": {"vr": "IS", "Value": [3000]},
        "3379": {"vr": "IS", "Value": [3000]},
        "3380": {"vr": "IS", "Value": [3000]},
        "3381": {"vr": "IS", "Value": [3000]},
        "3382": {"vr": "IS", "Value": [0]},
        "3383": {"vr": "IS", "Value": [3000]},
        "3384": {"vr": "IS", "Value": [0]},
        "3385": {"vr": "IS", "Value": [3000]},
        "3386": {"vr": "IS", "Value": [3000]},
        "3387": {"vr": "IS", "Value": [3000]},
        "3388": {"vr": "IS", "Value": [3000]},
        "3389": {"vr": "IS", "Value": [0]},
        "3390": {"vr": "IS", "Value": [3000]},
        "3391": {"vr": "IS", "Value": [3000]},
        "3392": {"vr": "IS", "Value": [3000]},
        "3393": {"vr": "IS", "Value": [3000]},
        "3394": {"vr": "IS", "Value": [3000]},
        "3395": {"vr": "IS", "Value": [3000]},
        "3396": {"vr": "IS", "Value": [3000]},
        "3397": {"vr": "IS", "Value": [3000]},
        "3398": {"vr": "IS", "Value": [3000]},
        "3399": {"vr": "IS", "Value": [3000]},
        "3400": {"vr": "IS", "Value": [3000]},
        "3401": {"vr": "IS", "Value": [3000]},
        "3402": {"vr": "IS", "Value": [3000]},
        "3403": {"vr": "IS", "Value": [3000]},
        "3404": {"vr": "IS", "Value": [3000]},
        "3405": {"vr": "IS", "Value": [0]},
        "3406": {"vr": "IS", "Value": [3000]},
        "3407": {"vr": "IS", "Value": [3000]},
        "3408": {"vr": "IS", "Value": [3000]},
        "3409": {"vr": "IS", "Value": [3000]},
        "3410": {"vr": "IS", "Value": [3000]},
        "3411": {"vr": "IS", "Value": [3000]},
        "3412": {"vr": "IS", "Value": [3000]},
        "3413": {"vr": "IS", "Value": [3000]},
        "3414": {"vr": "IS", "Value": [3000]},
        "3415": {"vr": "IS", "Value": [3000]},
        "3416": {"vr": "IS", "Value": [3000]},
        "3417": {"vr": "IS", "Value": [3000]},
        "3418": {"vr": "IS", "Value": [3000]},
        "3419": {"vr": "IS", "Value": [3000]},
        "3420": {"vr": "IS", "Value": [3000]},
        "3421": {"vr": "IS", "Value": [3000]},
        "3422": {"vr": "IS", "Value": [3000]},
        "3423": {"vr": "IS", "Value": [3000]},
        "3424": {"vr": "IS", "Value": [3000]},
        "3425": {"vr": "IS", "Value": [3000]},
        "3426": {"vr": "IS", "Value": [3000]},
        "3427": {"vr": "IS", "Value": [3000]},
        "3428": {"vr": "IS", "Value": [3000]},
        "3429": {"vr": "IS", "Value": [3000]},
        "3430": {"vr": "IS", "Value": [3000]},
        "3431": {"vr": "IS", "Value": [0]},
        "3432": {"vr": "IS", "Value": [3000]},
        "3433": {"vr": "IS", "Value": [3000]},
        "3434": {"vr": "IS", "Value": [3000]},
        "3435": {"vr": "IS", "Value": [3000]},
        "3436": {"vr": "IS", "Value": [0]},
        "3437": {"vr": "IS", "Value": [3000]},
        "3438": {"vr": "IS", "Value": [3000]},
        "3439": {"vr": "IS", "Value": [3000]},
        "3440": {"vr": "IS", "Value": [3000]},
        "3441": {"vr": "IS", "Value": [3000]},
        "3442": {"vr": "IS", "Value": [3000]},
        "3443": {"vr": "IS", "Value": [3000]},
        "3444": {"vr": "IS", "Value": [3000]},
        "3445": {"vr": "IS", "Value": [3000]},
        "3446": {"vr": "IS", "Value": [0]},
        "3447": {"vr": "IS", "Value": [3000]},
        "3448": {"vr": "IS", "Value": [3000]},
        "3449": {"vr": "IS", "Value": [3000]},
        "3450": {"vr": "IS", "Value": [3000]},
        "3451": {"vr": "IS", "Value": [3000]},
        "3452": {"vr": "IS", "Value": [3000]},
        "3453": {"vr": "IS", "Value": [3000]},
        "3454": {"vr": "IS", "Value": [0]},
        "3455": {"vr": "IS", "Value": [3000]},
        "3456": {"vr": "IS", "Value": [3000]},
        "3457": {"vr": "IS", "Value": [3000]},
        "3458": {"vr": "IS", "Value": [3000]},
        "3459": {"vr": "IS", "Value": [3000]},
        "3460": {"vr": "IS", "Value": [3000]},
        "3461": {"vr": "IS", "Value": [3000]},
        "3462": {"vr": "IS", "Value": [3000]},
        "3463": {"vr": "IS", "Value": [3000]},
        "3464": {"vr": "IS", "Value": [3000]},
        "3465": {"vr": "IS", "Value": [3000]},
        "3466": {"vr": "IS", "Value": [3000]},
        "3467": {"vr": "IS", "Value": [3000]},
        "3468": {"vr": "IS", "Value": [3000]},
        "3469": {"vr": "IS", "Value": [3000]},
        "3470": {"vr": "IS", "Value": [3000]},
        "3471": {"vr": "IS", "Value": [3000]},
        "3472": {"vr": "IS", "Value": [3000]},
        "3473": {"vr": "IS", "Value": [3000]},
        "3474": {"vr": "IS", "Value": [0]},
        "3475": {"vr": "IS", "Value": [3000]},
        "3476": {"vr": "IS", "Value": [3000]},
        "3477": {"vr": "IS", "Value": [3000]},
        "3478": {"vr": "IS", "Value": [3000]},
        "3479": {"vr": "IS", "Value": [3000]},
        "3480": {"vr": "IS", "Value": [3000]},
        "3481": {"vr": "IS", "Value": [0]},
        "3482": {"vr": "IS", "Value": [3000]},
        "3483": {"vr": "IS", "Value": [3000]},
        "3484": {"vr": "IS", "Value": [3000]},
        "3485": {"vr": "IS", "Value": [3000]},
        "3486": {"vr": "IS", "Value": [3000]},
        "3487": {"vr": "IS", "Value": [3000]},
        "3488": {"vr": "IS", "Value": [3000]},
        "3489": {"vr": "IS", "Value": [3000]},
        "3490": {"vr": "IS", "Value": [3000]},
        "3491": {"vr": "IS", "Value": [3000]},
        "3492": {"vr": "IS", "Value": [0]},
        "3493": {"vr": "IS", "Value": [3000]},
        "3494": {"vr": "IS", "Value": [3000]},
        "3495": {"vr": "IS", "Value": [3000]},
        "3496": {"vr": "IS", "Value": [3000]},
        "3497": {"vr": "IS", "Value": [3000]},
        "3498": {"vr": "IS", "Value": [0]},
        "3499": {"vr": "IS", "Value": [3000]},
        "3500": {"vr": "IS", "Value": [3000]},
        "3501": {"vr": "IS", "Value": [0]},
        "3502": {"vr": "IS", "Value": [3000]},
        "3503": {"vr": "IS", "Value": [0]},
        "3504": {"vr": "IS", "Value": [3000]},
        "3505": {"vr": "IS", "Value": [3000]},
        "3506": {"vr": "IS", "Value": [3000]},
        "3507": {"vr": "IS", "Value": [3000]},
        "3508": {"vr": "IS", "Value": [3000]},
        "3509": {"vr": "IS", "Value": [3000]},
        "3510": {"vr": "IS", "Value": [3000]},
        "3511": {"vr": "IS", "Value": [0]},
        "3512": {"vr": "IS", "Value": [3000]},
        "3513": {"vr": "IS", "Value": [3000]},
        "3514": {"vr": "IS", "Value": [3000]},
        "3515": {"vr": "IS", "Value": [3000]},
        "3516": {"vr": "IS", "Value": [3000]},
        "3517": {"vr": "IS", "Value": [3000]},
        "3518": {"vr": "IS", "Value": [3000]},
        "3519": {"vr": "IS", "Value": [3000]},
        "3520": {"vr": "IS", "Value": [3000]},
        "3521": {"vr": "IS", "Value": [0]},
        "3522": {"vr": "IS", "Value": [0]},
        "3523": {"vr": "IS", "Value": [3000]},
        "3524": {"vr": "IS", "Value": [3000]},
        "3525": {"vr": "IS", "Value": [3000]},
        "3526": {"vr": "IS", "Value": [3000]},
        "3527": {"vr": "IS", "Value": [3000]},
        "3528": {"vr": "IS", "Value": [3000]},
        "3529": {"vr": "IS", "Value": [0]},
        "3530": {"vr": "IS", "Value": [3000]},
        "3531": {"vr": "IS", "Value": [3000]},
        "3532": {"vr": "IS", "Value": [0]},
        "3533": {"vr": "IS", "Value": [3000]},
        "3534": {"vr": "IS", "Value": [3000]},
        "3535": {"vr": "IS", "Value": [3000]},
        "3536": {"vr": "IS", "Value": [3000]},
        "3537": {"vr": "IS", "Value": [3000]},
        "3538": {"vr": "IS", "Value": [3000]},
        "3539": {"vr": "IS", "Value": [0]},
        "3540": {"vr": "IS", "Value": [3000]},
        "3541": {"vr": "IS", "Value": [3000]},
        "3542": {"vr": "IS", "Value": [3000]},
        "3543": {"vr": "IS", "Value": [3000]},
        "3544": {"vr": "IS", "Value": [3000]},
        "3545": {"vr": "IS", "Value": [3000]},
        "3546": {"vr": "IS", "Value": [3000]},
        "3547": {"vr": "IS", "Value": [3000]},
        "3548": {"vr": "IS", "Value": [3000]},
        "3549": {"vr": "IS", "Value": [3000]},
        "3550": {"vr": "IS", "Value": [3000]},
        "3551": {"vr": "IS", "Value": [3000]},
        "3552": {"vr": "IS", "Value": [3000]},
        "3553": {"vr": "IS", "Value": [3000]},
        "3554": {"vr": "IS", "Value": [3000]},
        "3555": {"vr": "IS", "Value": [3000]},
        "3556": {"vr": "IS", "Value": [3000]},
        "3557": {"vr": "IS", "Value": [3000]},
        "3558": {"vr": "IS", "Value": [3000]},
        "3559": {"vr": "IS", "Value": [3000]},
        "3560": {"vr": "IS", "Value": [3000]},
        "3561": {"vr": "IS", "Value": [3000]},
        "3562": {"vr": "IS", "Value": [3000]},
        "3563": {"vr": "IS", "Value": [3000]},
        "3564": {"vr": "IS", "Value": [3000]},
        "3565": {"vr": "IS", "Value": [3000]},
        "3566": {"vr": "IS", "Value": [3000]},
        "3567": {"vr": "IS", "Value": [3000]},
        "3568": {"vr": "IS", "Value": [3000]},
        "3569": {"vr": "IS", "Value": [3000]},
        "3570": {"vr": "IS", "Value": [3000]},
        "3571": {"vr": "IS", "Value": [3000]},
        "3572": {"vr": "IS", "Value": [3000]},
        "3573": {"vr": "IS", "Value": [3000]},
        "3574": {"vr": "IS", "Value": [3000]},
        "3575": {"vr": "IS", "Value": [0]},
        "3576": {"vr": "IS", "Value": [3000]},
        "3577": {"vr": "IS", "Value": [3000]},
        "3578": {"vr": "IS", "Value": [3000]},
        "3579": {"vr": "IS", "Value": [3000]},
        "3580": {"vr": "IS", "Value": [3000]},
        "3581": {"vr": "IS", "Value": [3000]},
        "3582": {"vr": "IS", "Value": [3000]},
        "3583": {"vr": "IS", "Value": [3000]},
        "3584": {"vr": "IS", "Value": [3000]},
        "3585": {"vr": "IS", "Value": [3000]},
        "3586": {"vr": "IS", "Value": [3000]},
        "3587": {"vr": "IS", "Value": [3000]},
        "3588": {"vr": "IS", "Value": [3000]},
        "3589": {"vr": "IS", "Value": [0]},
        "3590": {"vr": "IS", "Value": [3000]},
        "3591": {"vr": "IS", "Value": [3000]},
        "3592": {"vr": "IS", "Value": [3000]},
        "3593": {"vr": "IS", "Value": [3000]},
        "3594": {"vr": "IS", "Value": [3000]},
        "3595": {"vr": "IS", "Value": [3000]},
        "3596": {"vr": "IS", "Value": [0]},
        "3597": {"vr": "IS", "Value": [3000]},
        "3598": {"vr": "IS", "Value": [0]},
        "3599": {"vr": "IS", "Value": [3000]},
        "3600": {"vr": "IS", "Value": [3000]},
        "3601": {"vr": "IS", "Value": [3000]},
        "3602": {"vr": "IS", "Value": [3000]},
        "3603": {"vr": "IS", "Value": [3000]},
        "3604": {"vr": "IS", "Value": [3000]},
        "3605": {"vr": "IS", "Value": [3000]},
        "3606": {"vr": "IS", "Value": [3000]},
        "3607": {"vr": "IS", "Value": [3000]},
        "3608": {"vr": "IS", "Value": [3000]},
        "3609": {"vr": "IS", "Value": [3000]},
        "3610": {"vr": "IS", "Value": [0]},
        "3611": {"vr": "IS", "Value": [3000]},
        "3612": {"vr": "IS", "Value": [3000]},
        "3613": {"vr": "IS", "Value": [3000]},
        "3614": {"vr": "IS", "Value": [0]},
        "3615": {"vr": "IS", "Value": [3000]},
        "3616": {"vr": "IS", "Value": [3000]},
        "3617": {"vr": "IS", "Value": [3000]},
        "3618": {"vr": "IS", "Value": [3000]},
        "3619": {"vr": "IS", "Value": [3000]},
        "3620": {"vr": "IS", "Value": [3000]},
        "3621": {"vr": "IS", "Value": [3000]},
        "3622": {"vr": "IS", "Value": [3000]},
        "3623": {"vr": "IS", "Value": [3000]},
        "3624": {"vr": "IS", "Value": [3000]},
        "3625": {"vr": "IS", "Value": [3000]},
        "3626": {"vr": "IS", "Value": [3000]},
        "3627": {"vr": "IS", "Value": [3000]},
        "3628": {"vr": "IS", "Value": [0]},
        "3629": {"vr": "IS", "Value": [3000]},
        "3630": {"vr": "IS", "Value": [3000]},
        "3631": {"vr": "IS", "Value": [3000]},
        "3632": {"vr": "IS", "Value": [3000]},
        "3633": {"vr": "IS", "Value": [3000]},
        "3634": {"vr": "IS", "Value": [3000]},
        "3635": {"vr": "IS", "Value": [3000]},
        "3636": {"vr": "IS", "Value": [3000]},
        "3637": {"vr": "IS", "Value": [3000]},
        "3638": {"vr": "IS", "Value": [0]},
        "3639": {"vr": "IS", "Value": [3000]},
        "3640": {"vr": "IS", "Value": [0]},
        "3641": {"vr": "IS", "Value": [3000]},
        "3642": {"vr": "IS", "Value": [3000]},
        "3643": {"vr": "IS", "Value": [3000]},
        "3644": {"vr": "IS", "Value": [3000]},
        "3645": {"vr": "IS", "Value": [3000]},
        "3646": {"vr": "IS", "Value": [3000]},
        "3647": {"vr": "IS", "Value": [3000]},
        "3648": {"vr": "IS", "Value": [3000]},
        "3649": {"vr": "IS", "Value": [3000]},
        "3650": {"vr": "IS", "Value": [3000]},
        "3651": {"vr": "IS", "Value": [3000]},
        "3652": {"vr": "IS", "Value": [3000]},
        "3653": {"vr": "IS", "Value": [0]},
        "3654": {"vr": "IS", "Value": [0]},
        "3655": {"vr": "IS", "Value": [3000]},
        "3656": {"vr": "IS", "Value": [3000]},
        "3657": {"vr": "IS", "Value": [3000]},
        "3658": {"vr": "IS", "Value": [3000]},
        "3659": {"vr": "IS", "Value": [3000]},
        "3660": {"vr": "IS", "Value": [3000]},
        "3661": {"vr": "IS", "Value": [3000]},
        "3662": {"vr": "IS", "Value": [3000]},
        "3663": {"vr": "IS", "Value": [3000]},
        "3664": {"vr": "IS", "Value": [3000]},
        "3665": {"vr": "IS", "Value": [3000]},
        "3666": {"vr": "IS", "Value": [3000]},
        "3667": {"vr": "IS", "Value": [3000]},
        "3668": {"vr": "IS", "Value": [0]},
        "3669": {"vr": "IS", "Value": [3000]},
        "3670": {"vr": "IS", "Value": [3000]},
        "3671": {"vr": "IS", "Value": [3000]},
        "3672": {"vr": "IS", "Value": [3000]},
        "3673": {"vr": "IS", "Value": [0]},
        "3674": {"vr": "IS", "Value": [3000]},
        "3675": {"vr": "IS", "Value": [3000]},
        "3676": {"vr": "IS", "Value": [3000]},
        "3677": {"vr": "IS", "Value": [3000]},
        "3678": {"vr": "IS", "Value": [3000]},
        "3679": {"vr": "IS", "Value": [3000]},
        "3680": {"vr": "IS", "Value": [3000]},
        "3681": {"vr": "IS", "Value": [3000]},
        "3682": {"vr": "IS", "Value": [3000]},
        "3683": {"vr": "IS", "Value": [3000]},
        "3684": {"vr": "IS", "Value": [3000]},
        "3685": {"vr": "IS", "Value": [3000]},
        "3686": {"vr": "IS", "Value": [3000]},
        "3687": {"vr": "IS", "Value": [0]},
        "3688": {"vr": "IS", "Value": [3000]},
        "3689": {"vr": "IS", "Value": [3000]},
        "3690": {"vr": "IS", "Value": [3000]},
        "3691": {"vr": "IS", "Value": [3000]},
        "3692": {"vr": "IS", "Value": [3000]},
        "3693": {"vr": "IS", "Value": [3000]},
        "3694": {"vr": "IS", "Value": [3000]},
        "3695": {"vr": "IS", "Value": [3000]},
        "3696": {"vr": "IS", "Value": [0]},
        "3697": {"vr": "IS", "Value": [3000]},
        "3698": {"vr": "IS", "Value": [0]},
        "3699": {"vr": "IS", "Value": [3000]},
        "3700": {"vr": "IS", "Value": [3000]},
        "3701": {"vr": "IS", "Value": [3000]},
        "3702": {"vr": "IS", "Value": [3000]},
        "3703": {"vr": "IS", "Value": [3000]},
        "3704": {"vr": "IS", "Value": [3000]},
        "3705": {"vr": "IS", "Value": [3000]},
        "3706": {"vr": "IS", "Value": [3000]},
        "3707": {"vr": "IS", "Value": [3000]},
        "3708": {"vr": "IS", "Value": [3000]},
        "3709": {"vr": "IS", "Value": [3000]},
        "3710": {"vr": "IS", "Value": [3000]},
        "3711": {"vr": "IS", "Value": [3000]},
        "3712": {"vr": "IS", "Value": [3000]},
        "3713": {"vr": "IS", "Value": [3000]},
        "3714": {"vr": "IS", "Value": [3000]},
        "3715": {"vr": "IS", "Value": [3000]},
        "3716": {"vr": "IS", "Value": [0]},
        "3717": {"vr": "IS", "Value": [3000]},
        "3718": {"vr": "IS", "Value": [3000]},
        "3719": {"vr": "IS", "Value": [3000]},
        "3720": {"vr": "IS", "Value": [3000]},
        "3721": {"vr": "IS", "Value": [3000]},
        "3722": {"vr": "IS", "Value": [3000]},
        "3723": {"vr": "IS", "Value": [0]},
        "3724": {"vr": "IS", "Value": [3000]},
        "3725": {"vr": "IS", "Value": [3000]},
        "3726": {"vr": "IS", "Value": [3000]},
        "3727": {"vr": "IS", "Value": [3000]},
        "3728": {"vr": "IS", "Value": [3000]},
        "3729": {"vr": "IS", "Value": [0]},
        "3730": {"vr": "IS", "Value": [3000]},
        "3731": {"vr": "IS", "Value": [3000]},
        "3732": {"vr": "IS", "Value": [3000]},
        "3733": {"vr": "IS", "Value": [3000]},
        "3734": {"vr": "IS", "Value": [3000]},
        "3735": {"vr": "IS", "Value": [0]},
        "3736": {"vr": "IS", "Value": [3000]},
        "3737": {"vr": "IS", "Value": [3000]},
        "3738": {"vr": "IS", "Value": [3000]},
        "3739": {"vr": "IS", "Value": [3000]},
        "3740": {"vr": "IS", "Value": [3000]},
        "3741": {"vr": "IS", "Value": [3000]},
        "3742": {"vr": "IS", "Value": [0]},
        "3743": {"vr": "IS", "Value": [3000]},
        "3744": {"vr": "IS", "Value": [0]},
        "3745": {"vr": "IS", "Value": [3000]},
        "3746": {"vr": "IS", "Value": [3000]},
        "3747": {"vr": "IS", "Value": [3000]},
        "3748": {"vr": "IS", "Value": [3000]},
        "3749": {"vr": "IS", "Value": [3000]},
        "3750": {"vr": "IS", "Value": [3000]},
        "3751": {"vr": "IS", "Value": [3000]},
        "3752": {"vr": "IS", "Value": [3000]},
        "3753": {"vr": "IS", "Value": [3000]},
        "3754": {"vr": "IS", "Value": [3000]},
        "3755": {"vr": "IS", "Value": [3000]},
        "3756": {"vr": "IS", "Value": [0]},
        "3757": {"vr": "IS", "Value": [3000]},
        "3758": {"vr": "IS", "Value": [3000]},
        "3759": {"vr": "IS", "Value": [3000]},
        "3760": {"vr": "IS", "Value": [3000]},
        "3761": {"vr": "IS", "Value": [3000]},
        "3762": {"vr": "IS", "Value": [3000]},
        "3763": {"vr": "IS", "Value": [0]},
        "3764": {"vr": "IS", "Value": [3000]},
        "3765": {"vr": "IS", "Value": [3000]},
        "3766": {"vr": "IS", "Value": [3000]},
        "3767": {"vr": "IS", "Value": [3000]},
        "3768": {"vr": "IS", "Value": [3000]},
        "3769": {"vr": "IS", "Value": [3000]},
        "3770": {"vr": "IS", "Value": [3000]},
        "3771": {"vr": "IS", "Value": [3000]},
        "3772": {"vr": "IS", "Value": [3000]},
        "3773": {"vr": "IS", "Value": [3000]},
        "3774": {"vr": "IS", "Value": [3000]},
        "3775": {"vr": "IS", "Value": [3000]},
        "3776": {"vr": "IS", "Value": [3000]},
        "3777": {"vr": "IS", "Value": [3000]},
        "3778": {"vr": "IS", "Value": [3000]},
        "3779": {"vr": "IS", "Value": [3000]},
        "3780": {"vr": "IS", "Value": [3000]},
        "3781": {"vr": "IS", "Value": [3000]},
        "3782": {"vr": "IS", "Value": [3000]},
        "3783": {"vr": "IS", "Value": [3000]},
        "3784": {"vr": "IS", "Value": [3000]},
        "3785": {"vr": "IS", "Value": [3000]},
        "3786": {"vr": "IS", "Value": [3000]},
        "3787": {"vr": "IS", "Value": [3000]},
        "3788": {"vr": "IS", "Value": [0]},
        "3789": {"vr": "IS", "Value": [3000]},
        "3790": {"vr": "IS", "Value": [3000]},
        "3791": {"vr": "IS", "Value": [3000]},
        "3792": {"vr": "IS", "Value": [3000]},
        "3793": {"vr": "IS", "Value": [3000]},
        "3794": {"vr": "IS", "Value": [3000]},
        "3795": {"vr": "IS", "Value": [0]},
        "3796": {"vr": "IS", "Value": [3000]},
        "3797": {"vr": "IS", "Value": [3000]},
        "3798": {"vr": "IS", "Value": [3000]},
        "3799": {"vr": "IS", "Value": [3000]},
        "3800": {"vr": "IS", "Value": [3000]},
        "3801": {"vr": "IS", "Value": [3000]},
        "3802": {"vr": "IS", "Value": [3000]},
        "3803": {"vr": "IS", "Value": [3000]},
        "3804": {"vr": "IS", "Value": [3000]},
        "3805": {"vr": "IS", "Value": [0]},
        "3806": {"vr": "IS", "Value": [0]},
        "3807": {"vr": "IS", "Value": [3000]},
        "3808": {"vr": "IS", "Value": [3000]},
        "3809": {"vr": "IS", "Value": [3000]},
        "3810": {"vr": "IS", "Value": [3000]},
        "3811": {"vr": "IS", "Value": [3000]},
        "3812": {"vr": "IS", "Value": [3000]},
        "3813": {"vr": "IS", "Value": [3000]},
        "3814": {"vr": "IS", "Value": [3000]},
        "3815": {"vr": "IS", "Value": [3000]},
        "3816": {"vr": "IS", "Value": [3000]},
        "3817": {"vr": "IS", "Value": [3000]},
        "3818": {"vr": "IS", "Value": [3000]},
        "3819": {"vr": "IS", "Value": [3000]},
        "3820": {"vr": "IS", "Value": [3000]},
        "3821": {"vr": "IS", "Value": [3000]},
        "3822": {"vr": "IS", "Value": [3000]},
        "3823": {"vr": "IS", "Value": [3000]},
        "3824": {"vr": "IS", "Value": [3000]},
        "3825": {"vr": "IS", "Value": [0]},
        "3826": {"vr": "IS", "Value": [3000]},
        "3827": {"vr": "IS", "Value": [3000]},
        "3828": {"vr": "IS", "Value": [3000]},
        "3829": {"vr": "IS", "Value": [3000]},
        "3830": {"vr": "IS", "Value": [3000]},
        "3831": {"vr": "IS", "Value": [3000]},
        "3832": {"vr": "IS", "Value": [0]},
        "3833": {"vr": "IS", "Value": [3000]},
        "3834": {"vr": "IS", "Value": [3000]},
        "3835": {"vr": "IS", "Value": [3000]},
        "3836": {"vr": "IS", "Value": [3000]},
        "3837": {"vr": "IS", "Value": [3000]},
        "3838": {"vr": "IS", "Value": [3000]},
        "3839": {"vr": "IS", "Value": [3000]},
        "3840": {"vr": "IS", "Value": [3000]},
        "3841": {"vr": "IS", "Value": [3000]},
        "3842": {"vr": "IS", "Value": [3000]},
        "3843": {"vr": "IS", "Value": [3000]},
        "3844": {"vr": "IS", "Value": [3000]},
        "3845": {"vr": "IS", "Value": [0]},
        "3846": {"vr": "IS", "Value": [3000]},
        "3847": {"vr": "IS", "Value": [3000]},
        "3848": {"vr": "IS", "Value": [3000]},
        "3849": {"vr": "IS", "Value": [3000]},
        "3850": {"vr": "IS", "Value": [3000]},
        "3851": {"vr": "IS", "Value": [3000]},
        "3852": {"vr": "IS", "Value": [3000]},
        "3853": {"vr": "IS", "Value": [3000]},
        "3854": {"vr": "IS", "Value": [3000]},
        "3855": {"vr": "IS", "Value": [0]},
        "3856": {"vr": "IS", "Value": [3000]},
        "3857": {"vr": "IS", "Value": [3000]},
        "3858": {"vr": "IS", "Value": [3000]},
        "3859": {"vr": "IS", "Value": [3000]},
        "3860": {"vr": "IS", "Value": [3000]},
        "3861": {"vr": "IS", "Value": [3000]},
        "3862": {"vr": "IS", "Value": [3000]},
        "3863": {"vr": "IS", "Value": [0]},
        "3864": {"vr": "IS", "Value": [3000]},
        "3865": {"vr": "IS", "Value": [3000]},
        "3866": {"vr": "IS", "Value": [3000]},
        "3867": {"vr": "IS", "Value": [3000]},
        "3868": {"vr": "IS", "Value": [3000]},
        "3869": {"vr": "IS", "Value": [3000]},
        "3870": {"vr": "IS", "Value": [3000]},
        "3871": {"vr": "IS", "Value": [3000]},
        "3872": {"vr": "IS", "Value": [3000]},
        "3873": {"vr": "IS", "Value": [3000]},
        "3874": {"vr": "IS", "Value": [3000]},
        "3875": {"vr": "IS", "Value": [3000]},
        "3876": {"vr": "IS", "Value": [3000]},
        "3877": {"vr": "IS", "Value": [3000]},
        "3878": {"vr": "IS", "Value": [0]},
        "3879": {"vr": "IS", "Value": [3000]},
        "3880": {"vr": "IS", "Value": [3000]},
        "3881": {"vr": "IS", "Value": [3000]},
        "3882": {"vr": "IS", "Value": [0]},
        "3883": {"vr": "IS", "Value": [3000]},
        "3884": {"vr": "IS", "Value": [3000]},
        "3885": {"vr": "IS", "Value": [0]},
        "3886": {"vr": "IS", "Value": [3000]},
        "3887": {"vr": "IS", "Value": [3000]},
        "3888": {"vr": "IS", "Value": [3000]},
        "3889": {"vr": "IS", "Value": [3000]},
        "3890": {"vr": "IS", "Value": [3000]},
        "3891": {"vr": "IS", "Value": [3000]},
        "3892": {"vr": "IS", "Value": [3000]},
        "3893": {"vr": "IS", "Value": [3000]},
        "3894": {"vr": "IS", "Value": [3000]},
        "3895": {"vr": "IS", "Value": [3000]},
        "3896": {"vr": "IS", "Value": [3000]},
        "3897": {"vr": "IS", "Value": [3000]},
        "3898": {"vr": "IS", "Value": [3000]},
        "3899": {"vr": "IS", "Value": [3000]},
        "3900": {"vr": "IS", "Value": [0]},
        "3901": {"vr": "IS", "Value": [3000]},
        "3902": {"vr": "IS", "Value": [3000]},
        "3903": {"vr": "IS", "Value": [3000]},
        "3904": {"vr": "IS", "Value": [3000]},
        "3905": {"vr": "IS", "Value": [3000]},
        "3906": {"vr": "IS", "Value": [3000]},
        "3907": {"vr": "IS", "Value": [3000]},
        "3908": {"vr": "IS", "Value": [3000]},
        "3909": {"vr": "IS", "Value": [3000]},
        "3910": {"vr": "IS", "Value": [3000]},
        "3911": {"vr": "IS", "Value": [3000]},
        "3912": {"vr": "IS", "Value": [3000]},
        "3913": {"vr": "IS", "Value": [3000]},
        "3914": {"vr": "IS", "Value": [3000]},
        "3915": {"vr": "IS", "Value": [3000]},
        "3916": {"vr": "IS", "Value": [0]},
        "3917": {"vr": "IS", "Value": [3000]},
        "3918": {"vr": "IS", "Value": [3000]},
        "3919": {"vr": "IS", "Value": [3000]},
        "3920": {"vr": "IS", "Value": [3000]},
        "3921": {"vr": "IS", "Value": [3000]},
        "3922": {"vr": "IS", "Value": [3000]},
        "3923": {"vr": "IS", "Value": [3000]},
        "3924": {"vr": "IS", "Value": [3000]},
        "3925": {"vr": "IS", "Value": [3000]},
        "3926": {"vr": "IS", "Value": [3000]},
        "3927": {"vr": "IS", "Value": [3000]},
        "3928": {"vr": "IS", "Value": [0]},
        "3929": {"vr": "IS", "Value": [3000]},
        "3930": {"vr": "IS", "Value": [3000]},
        "3931": {"vr": "IS", "Value": [3000]},
        "3932": {"vr": "IS", "Value": [3000]},
        "3933": {"vr": "IS", "Value": [3000]},
        "3934": {"vr": "IS", "Value": [3000]},
        "3935": {"vr": "IS", "Value": [3000]},
        "3936": {"vr": "IS", "Value": [3000]},
        "3937": {"vr": "IS", "Value": [0]},
        "3938": {"vr": "IS", "Value": [3000]},
        "3939": {"vr": "IS", "Value": [3000]},
        "3940": {"vr": "IS", "Value": [3000]},
        "3941": {"vr": "IS", "Value": [3000]},
        "3942": {"vr": "IS", "Value": [3000]},
        "3943": {"vr": "IS", "Value": [3000]},
        "3944": {"vr": "IS", "Value": [3000]},
        "3945": {"vr": "IS", "Value": [0]},
        "3946": {"vr": "IS", "Value": [3000]},
        "3947": {"vr": "IS", "Value": [3000]},
        "3948": {"vr": "IS", "Value": [3000]},
        "3949": {"vr": "IS", "Value": [3000]},
        "3950": {"vr": "IS", "Value": [3000]},
        "3951": {"vr": "IS", "Value": [3000]},
        "3952": {"vr": "IS", "Value": [3000]},
        "3953": {"vr": "IS", "Value": [3000]},
        "3954": {"vr": "IS", "Value": [3000]},
        "3955": {"vr": "IS", "Value": [3000]},
        "3956": {"vr": "IS", "Value": [3000]},
        "3957": {"vr": "IS", "Value": [3000]},
        "3958": {"vr": "IS", "Value": [3000]},
        "3959": {"vr": "IS", "Value": [3000]},
        "3960": {"vr": "IS", "Value": [3000]},
        "3961": {"vr": "IS", "Value": [3000]},
        "3962": {"vr": "IS", "Value": [3000]},
        "3963": {"vr": "IS", "Value": [3000]},
        "3964": {"vr": "IS", "Value": [3000]},
        "3965": {"vr": "IS", "Value": [3000]},
        "3966": {"vr": "IS", "Value": [3000]},
        "3967": {"vr": "IS", "Value": [3000]},
        "3968": {"vr": "IS", "Value": [0]},
        "3969": {"vr": "IS", "Value": [3000]},
        "3970": {"vr": "IS", "Value": [3000]},
        "3971": {"vr": "IS", "Value": [3000]},
        "3972": {"vr": "IS", "Value": [3000]},
        "3973": {"vr": "IS", "Value": [3000]},
        "3974": {"vr": "IS", "Value": [3000]},
        "3975": {"vr": "IS", "Value": [3000]},
        "3976": {"vr": "IS", "Value": [3000]},
        "3977": {"vr": "IS", "Value": [3000]},
        "3978": {"vr": "IS", "Value": [3000]},
        "3979": {"vr": "IS", "Value": [3000]},
        "3980": {"vr": "IS", "Value": [3000]},
        "3981": {"vr": "IS", "Value": [3000]},
        "3982": {"vr": "IS", "Value": [3000]},
        "3983": {"vr": "IS", "Value": [3000]},
        "3984": {"vr": "IS", "Value": [3000]},
        "3985": {"vr": "IS", "Value": [3000]},
        "3986": {"vr": "IS", "Value": [3000]},
        "3987": {"vr": "IS", "Value": [3000]},
        "3988": {"vr": "IS", "Value": [3000]},
        "3989": {"vr": "IS", "Value": [3000]},
        "3990": {"vr": "IS", "Value": [3000]},
        "3991": {"vr": "IS", "Value": [3000]},
        "3992": {"vr": "IS", "Value": [3000]},
        "3993": {"vr": "IS", "Value": [3000]},
        "3994": {"vr": "IS", "Value": [3000]},
        "3995": {"vr": "IS", "Value": [3000]},
        "3996": {"vr": "IS", "Value": [3000]},
        "3997": {"vr": "IS", "Value": [3000]},
        "3998": {"vr": "IS", "Value": [3000]},
        "3999": {"vr": "IS", "Value": [3000]},
        "4000": {"vr": "IS", "Value": [3000]},
        "4001": {"vr": "IS", "Value": [3000]},
        "4002": {"vr": "IS", "Value": [3000]},
        "4003": {"vr": "IS", "Value": [3000]},
        "4004": {"vr": "IS", "Value": [3000]},
        "4005": {"vr": "IS", "Value": [3000]},
        "4006": {"vr": "IS", "Value": [3000]},
        "4007": {"vr": "IS", "Value": [3000]},
        "4008": {"vr": "IS", "Value": [3000]},
        "4009": {"vr": "IS", "Value": [0]},
        "4010": {"vr": "IS", "Value": [3000]},
        "4011": {"vr": "IS", "Value": [0]},
        "4012": {"vr": "IS", "Value": [3000]},
        "4013": {"vr": "IS", "Value": [3000]},
        "4014": {"vr": "IS", "Value": [3000]},
        "4015": {"vr": "IS", "Value": [3000]},
        "4016": {"vr": "IS", "Value": [3000]},
        "4017": {"vr": "IS", "Value": [3000]},
        "4018": {"vr": "IS", "Value": [3000]},
        "4019": {"vr": "IS", "Value": [3000]},
    },
    "00211106": {
        "0": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_49_1_1_37_1_28"]},
        "1": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_58_1_1_55_1_28"]},
        "2": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_11_1_1_22_1_28"]},
        "3": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_36_1_1_11_1_28"]},
        "4": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_11_1_1_22_1_28"]},
        "5": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_14_1_1_28_1_28"]},
        "6": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_3_1_1_6_1_28"]},
        "7": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_9_1_1_18_1_28"]},
        "8": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_13_1_1_26_1_28"]},
        "9": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_53_1_1_45_1_28"]},
        "10": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_48_1_1_35_1_28"]},
        "11": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_24_1_1_48_1_28"]},
        "12": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_54_1_1_47_1_28"]},
        "13": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_25_1_1_50_1_28"]},
        "14": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_10_1_1_20_1_28"]},
        "15": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_57_1_1_53_1_28"]},
        "16": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_15_1_1_30_1_28"]},
        "17": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_16_1_1_32_1_28"]},
        "18": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_37_1_1_13_1_28"]},
        "19": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_21_1_1_42_1_28"]},
        "20": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_2_1_1_4_1_28"]},
        "21": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_34_1_1_7_1_28"]},
        "22": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_58_1_1_55_1_28"]},
        "23": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_50_1_1_39_1_28"]},
        "24": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_12_1_1_24_1_28"]},
        "25": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_21_1_1_42_1_28"]},
        "26": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_3_1_1_6_1_28"]},
        "27": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_35_1_1_9_1_28"]},
        "28": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_7_1_1_14_1_28"]},
        "29": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_8_1_1_16_1_28"]},
        "30": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_16_1_1_32_1_28"]},
        "31": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_41_1_1_21_1_28"]},
        "32": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_52_1_1_43_1_28"]},
        "33": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_19_1_1_38_1_28"]},
        "34": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_56_1_1_51_1_28"]},
        "35": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_2_1_1_4_1_28"]},
        "36": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_51_1_1_41_1_28"]},
        "37": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_2_1_1_4_1_28"]},
        "38": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_55_1_1_49_1_28"]},
        "39": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_16_1_1_32_1_28"]},
        "40": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_53_1_1_45_1_28"]},
        "41": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_39_1_1_17_1_28"]},
        "42": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_15_1_1_30_1_28"]},
        "43": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_38_1_1_15_1_28"]},
        "44": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_33_1_1_5_1_28"]},
        "45": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_58_1_1_55_1_28"]},
        "46": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_56_1_1_51_1_28"]},
        "47": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_15_1_1_30_1_28"]},
        "48": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_25_1_1_50_1_28"]},
        "49": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_58_1_1_55_1_28"]},
        "50": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_18_1_1_36_1_28"]},
        "51": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_16_1_1_32_1_28"]},
        "52": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_22_1_1_44_1_28"]},
        "53": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_31_1_1_1_1_28"]},
        "54": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_51_1_1_41_1_28"]},
        "55": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_19_1_1_38_1_28"]},
        "56": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_24_1_1_48_1_28"]},
        "57": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_18_1_1_36_1_28"]},
        "58": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_7_1_1_14_1_28"]},
        "59": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_2_1_1_4_1_28"]},
        "60": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_55_1_1_49_1_28"]},
        "61": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_15_1_1_30_1_28"]},
        "62": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_30_1_1_60_1_28"]},
        "63": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_55_1_1_49_1_28"]},
        "64": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_54_1_1_47_1_28"]},
        "65": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_4_1_1_8_1_28"]},
        "66": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_39_1_1_17_1_28"]},
        "67": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_43_1_1_25_1_28"]},
        "68": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_57_1_1_53_1_28"]},
        "69": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_43_1_1_25_1_28"]},
        "70": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_11_1_1_22_1_28"]},
        "71": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_58_1_1_55_1_28"]},
        "72": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_21_1_1_42_1_28"]},
        "73": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_35_1_1_9_1_28"]},
        "74": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_46_1_1_31_1_28"]},
        "75": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_31_1_1_1_1_28"]},
        "76": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_12_1_1_24_1_28"]},
        "77": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_26_1_1_52_1_28"]},
        "78": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_12_1_1_24_1_28"]},
        "79": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_13_1_1_26_1_28"]},
        "80": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_43_1_1_25_1_28"]},
        "81": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_43_1_1_25_1_28"]},
        "82": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_29_1_1_58_1_28"]},
        "83": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_51_1_1_41_1_28"]},
        "84": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_57_1_1_53_1_28"]},
        "85": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_45_1_1_29_1_28"]},
        "86": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_50_1_1_39_1_28"]},
        "87": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_28_1_1_56_1_28"]},
        "88": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_13_1_1_26_1_28"]},
        "89": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_54_1_1_47_1_28"]},
        "90": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_15_1_1_30_1_28"]},
        "91": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_39_1_1_17_1_28"]},
        "92": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_11_1_1_22_1_28"]},
        "93": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_5_1_1_10_1_28"]},
        "94": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_31_1_1_1_1_28"]},
        "95": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_48_1_1_35_1_28"]},
        "96": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_56_1_1_51_1_28"]},
        "97": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_39_1_1_17_1_28"]},
        "98": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_26_1_1_52_1_28"]},
        "99": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_31_1_1_1_1_28"]},
        "100": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_55_1_1_49_1_28"]},
        "101": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_40_1_1_19_1_28"]},
        "102": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_9_1_1_18_1_28"]},
        "103": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_3_1_1_6_1_28"]},
        "104": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_19_1_1_38_1_28"]},
        "105": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_11_1_1_22_1_28"]},
        "106": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_14_1_1_28_1_28"]},
        "107": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_18_1_1_36_1_28"]},
        "108": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_28_1_1_56_1_28"]},
        "109": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_38_1_1_15_1_28"]},
        "110": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_49_1_1_37_1_28"]},
        "111": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_42_1_1_23_1_28"]},
        "112": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_6_1_1_12_1_28"]},
        "113": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_18_1_1_36_1_28"]},
        "114": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_42_1_1_23_1_28"]},
        "115": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_16_1_1_32_1_28"]},
        "116": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_47_1_1_33_1_28"]},
        "117": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_30_1_1_60_1_28"]},
        "118": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_26_1_1_52_1_28"]},
        "119": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_57_1_1_53_1_28"]},
        "120": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_58_1_1_55_1_28"]},
        "121": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_54_1_1_47_1_28"]},
        "122": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_53_1_1_45_1_28"]},
        "123": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_16_1_1_32_1_28"]},
        "124": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_44_1_1_27_1_28"]},
        "125": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_8_1_1_16_1_28"]},
        "126": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_55_1_1_49_1_28"]},
        "127": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_40_1_1_19_1_28"]},
        "128": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_6_1_1_12_1_28"]},
        "129": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_44_1_1_27_1_28"]},
        "130": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_30_1_1_60_1_28"]},
        "131": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_14_1_1_28_1_28"]},
        "132": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_8_1_1_16_1_28"]},
        "133": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_22_1_1_44_1_28"]},
        "134": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_18_1_1_36_1_28"]},
        "135": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_49_1_1_37_1_28"]},
        "136": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_19_1_1_38_1_28"]},
        "137": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_11_1_1_22_1_28"]},
        "138": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_49_1_1_37_1_28"]},
        "139": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_48_1_1_35_1_28"]},
        "140": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_1_1_1_2_1_28"]},
        "141": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_48_1_1_35_1_28"]},
        "142": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_27_1_1_54_1_28"]},
        "143": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_58_1_1_55_1_28"]},
        "144": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_10_1_1_20_1_28"]},
        "145": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_42_1_1_23_1_28"]},
        "146": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_19_1_1_38_1_28"]},
        "147": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_33_1_1_5_1_28"]},
        "148": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_5_1_1_10_1_28"]},
        "149": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_45_1_1_29_1_28"]},
        "150": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_51_1_1_41_1_28"]},
        "151": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_54_1_1_47_1_28"]},
        "152": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_57_1_1_53_1_28"]},
        "153": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_36_1_1_11_1_28"]},
        "154": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_8_1_1_16_1_28"]},
        "155": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_41_1_1_21_1_28"]},
        "156": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_18_1_1_36_1_28"]},
        "157": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_34_1_1_7_1_28"]},
        "158": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_27_1_1_54_1_28"]},
        "159": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_46_1_1_31_1_28"]},
        "160": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_49_1_1_37_1_28"]},
        "161": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_27_1_1_54_1_28"]},
        "162": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_60_1_1_59_1_28"]},
        "163": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_36_1_1_11_1_28"]},
        "164": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_54_1_1_47_1_28"]},
        "165": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_6_1_1_12_1_28"]},
        "166": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_56_1_1_51_1_28"]},
        "167": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_23_1_1_46_1_28"]},
        "168": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_48_1_1_35_1_28"]},
        "169": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_27_1_1_54_1_28"]},
        "170": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_21_1_1_42_1_28"]},
        "171": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_31_1_1_1_1_28"]},
        "172": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_7_1_1_14_1_28"]},
        "173": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_41_1_1_21_1_28"]},
        "174": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_21_1_1_42_1_28"]},
        "175": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_46_1_1_31_1_28"]},
        "176": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_17_1_1_34_1_28"]},
        "177": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_1_1_1_2_1_28"]},
        "178": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_37_1_1_13_1_28"]},
        "179": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_19_1_1_38_1_28"]},
        "180": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_18_1_1_36_1_28"]},
        "181": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_60_1_1_59_1_28"]},
        "182": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_20_1_1_40_1_28"]},
        "183": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_53_1_1_45_1_28"]},
        "184": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_6_1_1_12_1_28"]},
        "185": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_34_1_1_7_1_28"]},
        "186": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_9_1_1_18_1_28"]},
        "187": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_19_1_1_38_1_28"]},
        "188": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_26_1_1_52_1_28"]},
        "189": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_30_1_1_60_1_28"]},
        "190": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_44_1_1_27_1_28"]},
        "191": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_59_1_1_57_1_28"]},
        "192": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_31_1_1_1_1_28"]},
        "193": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_26_1_1_52_1_28"]},
        "194": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_8_1_1_16_1_28"]},
        "195": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_37_1_1_13_1_28"]},
        "196": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_1_1_1_2_1_28"]},
        "197": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_46_1_1_31_1_28"]},
        "198": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_18_1_1_36_1_28"]},
        "199": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_37_1_1_13_1_28"]},
        "200": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_51_1_1_41_1_28"]},
        "201": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_9_1_1_18_1_28"]},
        "202": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_23_1_1_46_1_28"]},
        "203": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_32_1_1_3_1_28"]},
        "204": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_10_1_1_20_1_28"]},
        "205": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_46_1_1_31_1_28"]},
        "206": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_9_1_1_18_1_28"]},
        "207": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_4_1_1_8_1_28"]},
        "208": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_58_1_1_55_1_28"]},
        "209": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_18_1_1_36_1_28"]},
        "210": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_43_1_1_25_1_28"]},
        "211": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_14_1_1_28_1_28"]},
        "212": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_55_1_1_49_1_28"]},
        "213": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_3_1_1_6_1_28"]},
        "214": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_49_1_1_37_1_28"]},
        "215": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_31_1_1_1_1_28"]},
        "216": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_10_1_1_20_1_28"]},
        "217": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_60_1_1_59_1_28"]},
        "218": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_15_1_1_30_1_28"]},
        "219": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_59_1_1_57_1_28"]},
        "220": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_18_1_1_36_1_28"]},
        "221": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_41_1_1_21_1_28"]},
        "222": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_54_1_1_47_1_28"]},
        "223": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_59_1_1_57_1_28"]},
        "224": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_51_1_1_41_1_28"]},
        "225": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_19_1_1_38_1_28"]},
        "226": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_9_1_1_18_1_28"]},
        "227": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_34_1_1_7_1_28"]},
        "228": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_49_1_1_37_1_28"]},
        "229": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_43_1_1_25_1_28"]},
        "230": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_60_1_1_59_1_28"]},
        "231": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_50_1_1_39_1_28"]},
        "232": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_4_1_1_8_1_28"]},
        "233": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_15_1_1_30_1_28"]},
        "234": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_30_1_1_60_1_28"]},
        "235": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_7_1_1_14_1_28"]},
        "236": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_39_1_1_17_1_28"]},
        "237": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_57_1_1_53_1_28"]},
        "238": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_33_1_1_5_1_28"]},
        "239": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_20_1_1_40_1_28"]},
        "240": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_23_1_1_46_1_28"]},
        "241": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_32_1_1_3_1_28"]},
        "242": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_47_1_1_33_1_28"]},
        "243": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_23_1_1_46_1_28"]},
        "244": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_54_1_1_47_1_28"]},
        "245": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_32_1_1_3_1_28"]},
        "246": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_24_1_1_48_1_28"]},
        "247": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_8_1_1_16_1_28"]},
        "248": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_32_1_1_3_1_28"]},
        "249": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_39_1_1_17_1_28"]},
        "250": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_57_1_1_53_1_28"]},
        "251": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_18_1_1_36_1_28"]},
        "252": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_22_1_1_44_1_28"]},
        "253": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_2_1_1_4_1_28"]},
        "254": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_55_1_1_49_1_28"]},
        "255": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_59_1_1_57_1_28"]},
        "256": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_46_1_1_31_1_28"]},
        "257": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_2_1_1_4_1_28"]},
        "258": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_10_1_1_20_1_28"]},
        "259": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_45_1_1_29_1_28"]},
        "260": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_39_1_1_17_1_28"]},
        "261": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_43_1_1_25_1_28"]},
        "262": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_11_1_1_22_1_28"]},
        "263": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_44_1_1_27_1_28"]},
        "264": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_9_1_1_18_1_28"]},
        "265": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_13_1_1_26_1_28"]},
        "266": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_31_1_1_1_1_28"]},
        "267": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_31_1_1_1_1_28"]},
        "268": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_59_1_1_57_1_28"]},
        "269": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_47_1_1_33_1_28"]},
        "270": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_58_1_1_55_1_28"]},
        "271": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_32_1_1_3_1_28"]},
        "272": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_58_1_1_55_1_28"]},
        "273": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_33_1_1_5_1_28"]},
        "274": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_10_1_1_20_1_28"]},
        "275": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_40_1_1_19_1_28"]},
        "276": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_55_1_1_49_1_28"]},
        "277": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_15_1_1_30_1_28"]},
        "278": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_12_1_1_24_1_28"]},
        "279": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_44_1_1_27_1_28"]},
        "280": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_41_1_1_21_1_28"]},
        "281": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_2_1_1_4_1_28"]},
        "282": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_41_1_1_21_1_28"]},
        "283": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_58_1_1_55_1_28"]},
        "284": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_3_1_1_6_1_28"]},
        "285": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_42_1_1_23_1_28"]},
        "286": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_57_1_1_53_1_28"]},
        "287": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_36_1_1_11_1_28"]},
        "288": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_39_1_1_17_1_28"]},
        "289": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_58_1_1_55_1_28"]},
        "290": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_3_1_1_6_1_28"]},
        "291": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_43_1_1_25_1_28"]},
        "292": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_45_1_1_29_1_28"]},
        "293": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_23_1_1_46_1_28"]},
        "294": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_60_1_1_59_1_28"]},
        "295": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_33_1_1_5_1_28"]},
        "296": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_1_1_1_2_1_28"]},
        "297": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_5_1_1_10_1_28"]},
        "298": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_33_1_1_5_1_28"]},
        "299": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_46_1_1_31_1_28"]},
        "300": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_16_1_1_32_1_28"]},
        "301": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_26_1_1_52_1_28"]},
        "302": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_10_1_1_20_1_28"]},
        "303": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_31_1_1_1_1_28"]},
        "304": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_24_1_1_48_1_28"]},
        "305": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_17_1_1_34_1_28"]},
        "306": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_55_1_1_49_1_28"]},
        "307": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_39_1_1_17_1_28"]},
        "308": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_16_1_1_32_1_28"]},
        "309": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_42_1_1_23_1_28"]},
        "310": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_25_1_1_50_1_28"]},
        "311": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_5_1_1_10_1_28"]},
        "312": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_42_1_1_23_1_28"]},
        "313": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_33_1_1_5_1_28"]},
        "314": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_7_1_1_14_1_28"]},
        "315": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_52_1_1_43_1_28"]},
        "316": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_9_1_1_18_1_28"]},
        "317": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_55_1_1_49_1_28"]},
        "318": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_28_1_1_56_1_28"]},
        "319": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_30_1_1_60_1_28"]},
        "320": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_8_1_1_16_1_28"]},
        "321": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_34_1_1_7_1_28"]},
        "322": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_23_1_1_46_1_28"]},
        "323": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_50_1_1_39_1_28"]},
        "324": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_21_1_1_42_1_28"]},
        "325": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_5_1_1_10_1_28"]},
        "326": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_29_1_1_58_1_28"]},
        "327": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_42_1_1_23_1_28"]},
        "328": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_50_1_1_39_1_28"]},
        "329": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_50_1_1_39_1_28"]},
        "330": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_44_1_1_27_1_28"]},
        "331": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_39_1_1_17_1_28"]},
        "332": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_50_1_1_39_1_28"]},
        "333": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_45_1_1_29_1_28"]},
        "334": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_46_1_1_31_1_28"]},
        "335": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_19_1_1_38_1_28"]},
        "336": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_25_1_1_50_1_28"]},
        "337": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_53_1_1_45_1_28"]},
        "338": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_38_1_1_15_1_28"]},
        "339": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_53_1_1_45_1_28"]},
        "340": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_13_1_1_26_1_28"]},
        "341": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_10_1_1_20_1_28"]},
        "342": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_57_1_1_53_1_28"]},
        "343": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_48_1_1_35_1_28"]},
        "344": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_8_1_1_16_1_28"]},
        "345": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_11_1_1_22_1_28"]},
        "346": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_16_1_1_32_1_28"]},
        "347": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_45_1_1_29_1_28"]},
        "348": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_17_1_1_34_1_28"]},
        "349": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_23_1_1_46_1_28"]},
        "350": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_40_1_1_19_1_28"]},
        "351": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_44_1_1_27_1_28"]},
        "352": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_28_1_1_56_1_28"]},
        "353": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_9_1_1_18_1_28"]},
        "354": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_12_1_1_24_1_28"]},
        "355": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_8_1_1_16_1_28"]},
        "356": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_47_1_1_33_1_28"]},
        "357": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_49_1_1_37_1_28"]},
        "358": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_56_1_1_51_1_28"]},
        "359": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_39_1_1_17_1_28"]},
        "360": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_5_1_1_10_1_28"]},
        "361": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_28_1_1_56_1_28"]},
        "362": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_25_1_1_50_1_28"]},
        "363": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_59_1_1_57_1_28"]},
        "364": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_7_1_1_14_1_28"]},
        "365": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_5_1_1_10_1_28"]},
        "366": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_19_1_1_38_1_28"]},
        "367": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_44_1_1_27_1_28"]},
        "368": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_15_1_1_30_1_28"]},
        "369": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_17_1_1_34_1_28"]},
        "370": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_27_1_1_54_1_28"]},
        "371": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_22_1_1_44_1_28"]},
        "372": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_54_1_1_47_1_28"]},
        "373": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_51_1_1_41_1_28"]},
        "374": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_22_1_1_44_1_28"]},
        "375": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_6_1_1_12_1_28"]},
        "376": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_32_1_1_3_1_28"]},
        "377": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_53_1_1_45_1_28"]},
        "378": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_22_1_1_44_1_28"]},
        "379": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_52_1_1_43_1_28"]},
        "380": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_59_1_1_57_1_28"]},
        "381": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_29_1_1_58_1_28"]},
        "382": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_46_1_1_31_1_28"]},
        "383": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_42_1_1_23_1_28"]},
        "384": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_19_1_1_38_1_28"]},
        "385": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_27_1_1_54_1_28"]},
        "386": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_34_1_1_7_1_28"]},
        "387": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_17_1_1_34_1_28"]},
        "388": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_37_1_1_13_1_28"]},
        "389": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_9_1_1_18_1_28"]},
        "390": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_27_1_1_54_1_28"]},
        "391": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_2_1_1_4_1_28"]},
        "392": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_6_1_1_12_1_28"]},
        "393": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_27_1_1_54_1_28"]},
        "394": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_6_1_1_12_1_28"]},
        "395": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_50_1_1_39_1_28"]},
        "396": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_31_1_1_1_1_28"]},
        "397": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_3_1_1_6_1_28"]},
        "398": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_32_1_1_3_1_28"]},
        "399": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_47_1_1_33_1_28"]},
        "400": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_5_1_1_10_1_28"]},
        "401": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_50_1_1_39_1_28"]},
        "402": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_47_1_1_33_1_28"]},
        "403": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_41_1_1_21_1_28"]},
        "404": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_9_1_1_18_1_28"]},
        "405": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_42_1_1_23_1_28"]},
        "406": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_50_1_1_39_1_28"]},
        "407": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_17_1_1_34_1_28"]},
        "408": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_45_1_1_29_1_28"]},
        "409": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_1_1_1_2_1_28"]},
        "410": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_38_1_1_15_1_28"]},
        "411": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_24_1_1_48_1_28"]},
        "412": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_35_1_1_9_1_28"]},
        "413": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_40_1_1_19_1_28"]},
        "414": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_41_1_1_21_1_28"]},
        "415": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_34_1_1_7_1_28"]},
        "416": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_1_1_1_2_1_28"]},
        "417": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_32_1_1_3_1_28"]},
        "418": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_48_1_1_35_1_28"]},
        "419": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_44_1_1_27_1_28"]},
        "420": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_45_1_1_29_1_28"]},
        "421": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_11_1_1_22_1_28"]},
        "422": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_26_1_1_52_1_28"]},
        "423": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_34_1_1_7_1_28"]},
        "424": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_21_1_1_42_1_28"]},
        "425": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_24_1_1_48_1_28"]},
        "426": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_14_1_1_28_1_28"]},
        "427": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_9_1_1_18_1_28"]},
        "428": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_39_1_1_17_1_28"]},
        "429": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_35_1_1_9_1_28"]},
        "430": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_55_1_1_49_1_28"]},
        "431": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_49_1_1_37_1_28"]},
        "432": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_27_1_1_54_1_28"]},
        "433": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_53_1_1_45_1_28"]},
        "434": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_7_1_1_14_1_28"]},
        "435": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_34_1_1_7_1_28"]},
        "436": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_6_1_1_12_1_28"]},
        "437": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_33_1_1_5_1_28"]},
        "438": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_28_1_1_56_1_28"]},
        "439": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_35_1_1_9_1_28"]},
        "440": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_9_1_1_18_1_28"]},
        "441": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_14_1_1_28_1_28"]},
        "442": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_17_1_1_34_1_28"]},
        "443": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_30_1_1_60_1_28"]},
        "444": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_38_1_1_15_1_28"]},
        "445": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_19_1_1_38_1_28"]},
        "446": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_5_1_1_10_1_28"]},
        "447": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_38_1_1_15_1_28"]},
        "448": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_58_1_1_55_1_28"]},
        "449": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_12_1_1_24_1_28"]},
        "450": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_44_1_1_27_1_28"]},
        "451": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_40_1_1_19_1_28"]},
        "452": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_13_1_1_26_1_28"]},
        "453": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_49_1_1_37_1_28"]},
        "454": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_26_1_1_52_1_28"]},
        "455": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_16_1_1_32_1_28"]},
        "456": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_45_1_1_29_1_28"]},
        "457": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_18_1_1_36_1_28"]},
        "458": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_35_1_1_9_1_28"]},
        "459": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_35_1_1_9_1_28"]},
        "460": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_27_1_1_54_1_28"]},
        "461": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_15_1_1_30_1_28"]},
        "462": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_17_1_1_34_1_28"]},
        "463": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_37_1_1_13_1_28"]},
        "464": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_7_1_1_14_1_28"]},
        "465": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_5_1_1_10_1_28"]},
        "466": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_29_1_1_58_1_28"]},
        "467": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_57_1_1_53_1_28"]},
        "468": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_45_1_1_29_1_28"]},
        "469": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_8_1_1_16_1_28"]},
        "470": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_55_1_1_49_1_28"]},
        "471": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_56_1_1_51_1_28"]},
        "472": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_3_1_1_6_1_28"]},
        "473": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_8_1_1_16_1_28"]},
        "474": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_32_1_1_3_1_28"]},
        "475": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_36_1_1_11_1_28"]},
        "476": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_33_1_1_5_1_28"]},
        "477": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_53_1_1_45_1_28"]},
        "478": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_54_1_1_47_1_28"]},
        "479": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_11_1_1_22_1_28"]},
        "480": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_9_1_1_18_1_28"]},
        "481": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_40_1_1_19_1_28"]},
        "482": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_34_1_1_7_1_28"]},
        "483": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_31_1_1_1_1_28"]},
        "484": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_5_1_1_10_1_28"]},
        "485": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_34_1_1_7_1_28"]},
        "486": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_20_1_1_40_1_28"]},
        "487": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_20_1_1_40_1_28"]},
        "488": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_16_1_1_32_1_28"]},
        "489": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_26_1_1_52_1_28"]},
        "490": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_39_1_1_17_1_28"]},
        "491": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_50_1_1_39_1_28"]},
        "492": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_46_1_1_31_1_28"]},
        "493": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_31_1_1_1_1_28"]},
        "494": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_48_1_1_35_1_28"]},
        "495": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_35_1_1_9_1_28"]},
        "496": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_39_1_1_17_1_28"]},
        "497": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_58_1_1_55_1_28"]},
        "498": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_47_1_1_33_1_28"]},
        "499": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_18_1_1_36_1_28"]},
        "500": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_28_1_1_56_1_28"]},
        "501": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_54_1_1_47_1_28"]},
        "502": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_40_1_1_19_1_28"]},
        "503": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_3_1_1_6_1_28"]},
        "504": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_22_1_1_44_1_28"]},
        "505": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_40_1_1_19_1_28"]},
        "506": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_30_1_1_60_1_28"]},
        "507": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_37_1_1_13_1_28"]},
        "508": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_25_1_1_50_1_28"]},
        "509": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_4_1_1_8_1_28"]},
        "510": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_5_1_1_10_1_28"]},
        "511": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_35_1_1_9_1_28"]},
        "512": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_57_1_1_53_1_28"]},
        "513": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_40_1_1_19_1_28"]},
        "514": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_27_1_1_54_1_28"]},
        "515": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_20_1_1_40_1_28"]},
        "516": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_9_1_1_18_1_28"]},
        "517": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_15_1_1_30_1_28"]},
        "518": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_24_1_1_48_1_28"]},
        "519": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_35_1_1_9_1_28"]},
        "520": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_54_1_1_47_1_28"]},
        "521": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_36_1_1_11_1_28"]},
        "522": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_43_1_1_25_1_28"]},
        "523": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_18_1_1_36_1_28"]},
        "524": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_5_1_1_10_1_28"]},
        "525": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_2_1_1_4_1_28"]},
        "526": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_57_1_1_53_1_28"]},
        "527": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_17_1_1_34_1_28"]},
        "528": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_53_1_1_45_1_28"]},
        "529": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_30_1_1_60_1_28"]},
        "530": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_32_1_1_3_1_28"]},
        "531": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_55_1_1_49_1_28"]},
        "532": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_20_1_1_40_1_28"]},
        "533": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_14_1_1_28_1_28"]},
        "534": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_18_1_1_36_1_28"]},
        "535": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_54_1_1_47_1_28"]},
        "536": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_55_1_1_49_1_28"]},
        "537": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_29_1_1_58_1_28"]},
        "538": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_29_1_1_58_1_28"]},
        "539": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_7_1_1_14_1_28"]},
        "540": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_34_1_1_7_1_28"]},
        "541": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_24_1_1_48_1_28"]},
        "542": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_53_1_1_45_1_28"]},
        "543": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_58_1_1_55_1_28"]},
        "544": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_12_1_1_24_1_28"]},
        "545": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_40_1_1_19_1_28"]},
        "546": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_30_1_1_60_1_28"]},
        "547": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_13_1_1_26_1_28"]},
        "548": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_53_1_1_45_1_28"]},
        "549": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_14_1_1_28_1_28"]},
        "550": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_38_1_1_15_1_28"]},
        "551": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_40_1_1_19_1_28"]},
        "552": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_33_1_1_5_1_28"]},
        "553": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_22_1_1_44_1_28"]},
        "554": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_55_1_1_49_1_28"]},
        "555": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_16_1_1_32_1_28"]},
        "556": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_9_1_1_18_1_28"]},
        "557": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_35_1_1_9_1_28"]},
        "558": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_9_1_1_18_1_28"]},
        "559": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_7_1_1_14_1_28"]},
        "560": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_51_1_1_41_1_28"]},
        "561": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_48_1_1_35_1_28"]},
        "562": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_58_1_1_55_1_28"]},
        "563": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_10_1_1_20_1_28"]},
        "564": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_54_1_1_47_1_28"]},
        "565": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_48_1_1_35_1_28"]},
        "566": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_27_1_1_54_1_28"]},
        "567": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_52_1_1_43_1_28"]},
        "568": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_52_1_1_43_1_28"]},
        "569": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_15_1_1_30_1_28"]},
        "570": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_1_1_1_2_1_28"]},
        "571": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_46_1_1_31_1_28"]},
        "572": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_57_1_1_53_1_28"]},
        "573": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_46_1_1_31_1_28"]},
        "574": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_40_1_1_19_1_28"]},
        "575": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_11_1_1_22_1_28"]},
        "576": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_30_1_1_60_1_28"]},
        "577": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_31_1_1_1_1_28"]},
        "578": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_44_1_1_27_1_28"]},
        "579": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_4_1_1_8_1_28"]},
        "580": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_30_1_1_60_1_28"]},
        "581": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_22_1_1_44_1_28"]},
        "582": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_16_1_1_32_1_28"]},
        "583": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_24_1_1_48_1_28"]},
        "584": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_55_1_1_49_1_28"]},
        "585": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_35_1_1_9_1_28"]},
        "586": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_43_1_1_25_1_28"]},
        "587": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_3_1_1_6_1_28"]},
        "588": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_27_1_1_54_1_28"]},
        "589": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_12_1_1_24_1_28"]},
        "590": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_47_1_1_33_1_28"]},
        "591": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_25_1_1_50_1_28"]},
        "592": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_7_1_1_14_1_28"]},
        "593": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_26_1_1_52_1_28"]},
        "594": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_18_1_1_36_1_28"]},
        "595": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_8_1_1_16_1_28"]},
        "596": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_49_1_1_37_1_28"]},
        "597": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_17_1_1_34_1_28"]},
        "598": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_55_1_1_49_1_28"]},
        "599": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_12_1_1_24_1_28"]},
        "600": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_51_1_1_41_1_28"]},
        "601": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_4_1_1_8_1_28"]},
        "602": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_38_1_1_15_1_28"]},
        "603": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_7_1_1_14_1_28"]},
        "604": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_1_1_1_2_1_28"]},
        "605": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_31_1_1_1_1_28"]},
        "606": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_5_1_1_10_1_28"]},
        "607": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_59_1_1_57_1_28"]},
        "608": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_7_1_1_14_1_28"]},
        "609": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_18_1_1_36_1_28"]},
        "610": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_33_1_1_5_1_28"]},
        "611": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_39_1_1_17_1_28"]},
        "612": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_32_1_1_3_1_28"]},
        "613": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_39_1_1_17_1_28"]},
        "614": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_53_1_1_45_1_28"]},
        "615": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_60_1_1_59_1_28"]},
        "616": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_1_1_1_2_1_28"]},
        "617": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_37_1_1_13_1_28"]},
        "618": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_59_1_1_57_1_28"]},
        "619": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_55_1_1_49_1_28"]},
        "620": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_36_1_1_11_1_28"]},
        "621": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_57_1_1_53_1_28"]},
        "622": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_33_1_1_5_1_28"]},
        "623": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_60_1_1_59_1_28"]},
        "624": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_14_1_1_28_1_28"]},
        "625": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_51_1_1_41_1_28"]},
        "626": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_2_1_1_4_1_28"]},
        "627": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_22_1_1_44_1_28"]},
        "628": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_4_1_1_8_1_28"]},
        "629": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_14_1_1_28_1_28"]},
        "630": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_23_1_1_46_1_28"]},
        "631": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_32_1_1_3_1_28"]},
        "632": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_31_1_1_1_1_28"]},
        "633": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_47_1_1_33_1_28"]},
        "634": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_5_1_1_10_1_28"]},
        "635": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_29_1_1_58_1_28"]},
        "636": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_60_1_1_59_1_28"]},
        "637": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_12_1_1_24_1_28"]},
        "638": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_5_1_1_10_1_28"]},
        "639": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_16_1_1_32_1_28"]},
        "640": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_55_1_1_49_1_28"]},
        "641": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_15_1_1_30_1_28"]},
        "642": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_20_1_1_40_1_28"]},
        "643": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_2_1_1_4_1_28"]},
        "644": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_32_1_1_3_1_28"]},
        "645": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_51_1_1_41_1_28"]},
        "646": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_60_1_1_59_1_28"]},
        "647": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_12_1_1_24_1_28"]},
        "648": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_56_1_1_51_1_28"]},
        "649": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_59_1_1_57_1_28"]},
        "650": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_26_1_1_52_1_28"]},
        "651": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_2_1_1_4_1_28"]},
        "652": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_14_1_1_28_1_28"]},
        "653": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_3_1_1_6_1_28"]},
        "654": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_51_1_1_41_1_28"]},
        "655": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_17_1_1_34_1_28"]},
        "656": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_37_1_1_13_1_28"]},
        "657": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_37_1_1_13_1_28"]},
        "658": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_15_1_1_30_1_28"]},
        "659": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_47_1_1_33_1_28"]},
        "660": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_9_1_1_18_1_28"]},
        "661": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_11_1_1_22_1_28"]},
        "662": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_45_1_1_29_1_28"]},
        "663": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_60_1_1_59_1_28"]},
        "664": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_11_1_1_22_1_28"]},
        "665": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_6_1_1_12_1_28"]},
        "666": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_36_1_1_11_1_28"]},
        "667": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_33_1_1_5_1_28"]},
        "668": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_22_1_1_44_1_28"]},
        "669": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_7_1_1_14_1_28"]},
        "670": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_52_1_1_43_1_28"]},
        "671": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_29_1_1_58_1_28"]},
        "672": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_32_1_1_3_1_28"]},
        "673": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_35_1_1_9_1_28"]},
        "674": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_42_1_1_23_1_28"]},
        "675": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_1_1_1_2_1_28"]},
        "676": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_15_1_1_30_1_28"]},
        "677": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_39_1_1_17_1_28"]},
        "678": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_52_1_1_43_1_28"]},
        "679": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_18_1_1_36_1_28"]},
        "680": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_35_1_1_9_1_28"]},
        "681": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_25_1_1_50_1_28"]},
        "682": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_6_1_1_12_1_28"]},
        "683": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_60_1_1_59_1_28"]},
        "684": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_28_1_1_56_1_28"]},
        "685": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_6_1_1_12_1_28"]},
        "686": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_52_1_1_43_1_28"]},
        "687": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_32_1_1_3_1_28"]},
        "688": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_38_1_1_15_1_28"]},
        "689": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_37_1_1_13_1_28"]},
        "690": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_5_1_1_10_1_28"]},
        "691": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_10_1_1_20_1_28"]},
        "692": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_3_1_1_6_1_28"]},
        "693": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_35_1_1_9_1_28"]},
        "694": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_51_1_1_41_1_28"]},
        "695": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_55_1_1_49_1_28"]},
        "696": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_47_1_1_33_1_28"]},
        "697": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_32_1_1_3_1_28"]},
        "698": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_4_1_1_8_1_28"]},
        "699": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_57_1_1_53_1_28"]},
        "700": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_28_1_1_56_1_28"]},
        "701": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_52_1_1_43_1_28"]},
        "702": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_15_1_1_30_1_28"]},
        "703": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_48_1_1_35_1_28"]},
        "704": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_28_1_1_56_1_28"]},
        "705": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_46_1_1_31_1_28"]},
        "706": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_4_1_1_8_1_28"]},
        "707": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_45_1_1_29_1_28"]},
        "708": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_33_1_1_5_1_28"]},
        "709": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_33_1_1_5_1_28"]},
        "710": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_50_1_1_39_1_28"]},
        "711": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_52_1_1_43_1_28"]},
        "712": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_25_1_1_50_1_28"]},
        "713": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_13_1_1_26_1_28"]},
        "714": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_17_1_1_34_1_28"]},
        "715": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_14_1_1_28_1_28"]},
        "716": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_18_1_1_36_1_28"]},
        "717": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_29_1_1_58_1_28"]},
        "718": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_35_1_1_9_1_28"]},
        "719": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_38_1_1_15_1_28"]},
        "720": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_52_1_1_43_1_28"]},
        "721": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_57_1_1_53_1_28"]},
        "722": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_1_1_1_2_1_28"]},
        "723": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_58_1_1_55_1_28"]},
        "724": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_48_1_1_35_1_28"]},
        "725": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_44_1_1_27_1_28"]},
        "726": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_18_1_1_36_1_28"]},
        "727": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_17_1_1_34_1_28"]},
        "728": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_19_1_1_38_1_28"]},
        "729": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_22_1_1_44_1_28"]},
        "730": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_17_1_1_34_1_28"]},
        "731": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_16_1_1_32_1_28"]},
        "732": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_17_1_1_34_1_28"]},
        "733": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_28_1_1_56_1_28"]},
        "734": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_34_1_1_7_1_28"]},
        "735": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_54_1_1_47_1_28"]},
        "736": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_19_1_1_38_1_28"]},
        "737": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_37_1_1_13_1_28"]},
        "738": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_17_1_1_34_1_28"]},
        "739": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_2_1_1_4_1_28"]},
        "740": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_48_1_1_35_1_28"]},
        "741": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_10_1_1_20_1_28"]},
        "742": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_52_1_1_43_1_28"]},
        "743": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_42_1_1_23_1_28"]},
        "744": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_45_1_1_29_1_28"]},
        "745": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_11_1_1_22_1_28"]},
        "746": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_37_1_1_13_1_28"]},
        "747": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_2_1_1_4_1_28"]},
        "748": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_40_1_1_19_1_28"]},
        "749": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_8_1_1_16_1_28"]},
        "750": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_7_1_1_14_1_28"]},
        "751": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_43_1_1_25_1_28"]},
        "752": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_57_1_1_53_1_28"]},
        "753": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_21_1_1_42_1_28"]},
        "754": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_33_1_1_5_1_28"]},
        "755": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_5_1_1_10_1_28"]},
        "756": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_56_1_1_51_1_28"]},
        "757": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_34_1_1_7_1_28"]},
        "758": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_8_1_1_16_1_28"]},
        "759": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_16_1_1_32_1_28"]},
        "760": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_39_1_1_17_1_28"]},
        "761": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_59_1_1_57_1_28"]},
        "762": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_50_1_1_39_1_28"]},
        "763": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_41_1_1_21_1_28"]},
        "764": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_11_1_1_22_1_28"]},
        "765": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_52_1_1_43_1_28"]},
        "766": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_26_1_1_52_1_28"]},
        "767": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_14_1_1_28_1_28"]},
        "768": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_34_1_1_7_1_28"]},
        "769": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_28_1_1_56_1_28"]},
        "770": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_45_1_1_29_1_28"]},
        "771": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_41_1_1_21_1_28"]},
        "772": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_6_1_1_12_1_28"]},
        "773": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_17_1_1_34_1_28"]},
        "774": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_37_1_1_13_1_28"]},
        "775": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_1_1_1_2_1_28"]},
        "776": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_36_1_1_11_1_28"]},
        "777": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_24_1_1_48_1_28"]},
        "778": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_30_1_1_60_1_28"]},
        "779": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_52_1_1_43_1_28"]},
        "780": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_26_1_1_52_1_28"]},
        "781": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_42_1_1_23_1_28"]},
        "782": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_35_1_1_9_1_28"]},
        "783": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_25_1_1_50_1_28"]},
        "784": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_49_1_1_37_1_28"]},
        "785": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_51_1_1_41_1_28"]},
        "786": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_7_1_1_14_1_28"]},
        "787": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_30_1_1_60_1_28"]},
        "788": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_23_1_1_46_1_28"]},
        "789": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_55_1_1_49_1_28"]},
        "790": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_28_1_1_56_1_28"]},
        "791": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_39_1_1_17_1_28"]},
        "792": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_47_1_1_33_1_28"]},
        "793": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_9_1_1_18_1_28"]},
        "794": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_51_1_1_41_1_28"]},
        "795": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_44_1_1_27_1_28"]},
        "796": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_46_1_1_31_1_28"]},
        "797": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_20_1_1_40_1_28"]},
        "798": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_43_1_1_25_1_28"]},
        "799": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_31_1_1_1_1_28"]},
        "800": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_4_1_1_8_1_28"]},
        "801": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_3_1_1_6_1_28"]},
        "802": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_34_1_1_7_1_28"]},
        "803": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_14_1_1_28_1_28"]},
        "804": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_41_1_1_21_1_28"]},
        "805": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_47_1_1_33_1_28"]},
        "806": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_30_1_1_60_1_28"]},
        "807": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_14_1_1_28_1_28"]},
        "808": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_38_1_1_15_1_28"]},
        "809": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_37_1_1_13_1_28"]},
        "810": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_49_1_1_37_1_28"]},
        "811": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_13_1_1_26_1_28"]},
        "812": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_30_1_1_60_1_28"]},
        "813": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_35_1_1_9_1_28"]},
        "814": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_7_1_1_14_1_28"]},
        "815": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_45_1_1_29_1_28"]},
        "816": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_50_1_1_39_1_28"]},
        "817": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_46_1_1_31_1_28"]},
        "818": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_54_1_1_47_1_28"]},
        "819": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_28_1_1_56_1_28"]},
        "820": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_12_1_1_24_1_28"]},
        "821": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_56_1_1_51_1_28"]},
        "822": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_42_1_1_23_1_28"]},
        "823": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_56_1_1_51_1_28"]},
        "824": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_12_1_1_24_1_28"]},
        "825": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_12_1_1_24_1_28"]},
        "826": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_29_1_1_58_1_28"]},
        "827": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_21_1_1_42_1_28"]},
        "828": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_10_1_1_20_1_28"]},
        "829": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_15_1_1_30_1_28"]},
        "830": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_28_1_1_56_1_28"]},
        "831": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_15_1_1_30_1_28"]},
        "832": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_6_1_1_12_1_28"]},
        "833": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_32_1_1_3_1_28"]},
        "834": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_33_1_1_5_1_28"]},
        "835": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_16_1_1_32_1_28"]},
        "836": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_54_1_1_47_1_28"]},
        "837": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_42_1_1_23_1_28"]},
        "838": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_18_1_1_36_1_28"]},
        "839": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_37_1_1_13_1_28"]},
        "840": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_35_1_1_9_1_28"]},
        "841": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_2_1_1_4_1_28"]},
        "842": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_16_1_1_32_1_28"]},
        "843": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_49_1_1_37_1_28"]},
        "844": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_20_1_1_40_1_28"]},
        "845": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_26_1_1_52_1_28"]},
        "846": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_32_1_1_3_1_28"]},
        "847": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_37_1_1_13_1_28"]},
        "848": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_29_1_1_58_1_28"]},
        "849": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_53_1_1_45_1_28"]},
        "850": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_1_1_1_2_1_28"]},
        "851": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_34_1_1_7_1_28"]},
        "852": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_24_1_1_48_1_28"]},
        "853": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_41_1_1_21_1_28"]},
        "854": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_47_1_1_33_1_28"]},
        "855": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_14_1_1_28_1_28"]},
        "856": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_39_1_1_17_1_28"]},
        "857": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_53_1_1_45_1_28"]},
        "858": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_31_1_1_1_1_28"]},
        "859": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_24_1_1_48_1_28"]},
        "860": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_26_1_1_52_1_28"]},
        "861": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_4_1_1_8_1_28"]},
        "862": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_42_1_1_23_1_28"]},
        "863": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_46_1_1_31_1_28"]},
        "864": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_1_1_1_2_1_28"]},
        "865": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_26_1_1_52_1_28"]},
        "866": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_40_1_1_19_1_28"]},
        "867": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_38_1_1_15_1_28"]},
        "868": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_11_1_1_22_1_28"]},
        "869": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_26_1_1_52_1_28"]},
        "870": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_29_1_1_58_1_28"]},
        "871": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_55_1_1_49_1_28"]},
        "872": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_43_1_1_25_1_28"]},
        "873": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_45_1_1_29_1_28"]},
        "874": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_39_1_1_17_1_28"]},
        "875": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_54_1_1_47_1_28"]},
        "876": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_56_1_1_51_1_28"]},
        "877": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_38_1_1_15_1_28"]},
        "878": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_16_1_1_32_1_28"]},
        "879": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_13_1_1_26_1_28"]},
        "880": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_53_1_1_45_1_28"]},
        "881": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_45_1_1_29_1_28"]},
        "882": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_21_1_1_42_1_28"]},
        "883": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_4_1_1_8_1_28"]},
        "884": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_38_1_1_15_1_28"]},
        "885": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_55_1_1_49_1_28"]},
        "886": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_53_1_1_45_1_28"]},
        "887": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_42_1_1_23_1_28"]},
        "888": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_25_1_1_50_1_28"]},
        "889": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_3_1_1_6_1_28"]},
        "890": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_9_1_1_18_1_28"]},
        "891": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_60_1_1_59_1_28"]},
        "892": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_44_1_1_27_1_28"]},
        "893": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_44_1_1_27_1_28"]},
        "894": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_18_1_1_36_1_28"]},
        "895": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_4_1_1_8_1_28"]},
        "896": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_58_1_1_55_1_28"]},
        "897": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_7_1_1_14_1_28"]},
        "898": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_53_1_1_45_1_28"]},
        "899": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_14_1_1_28_1_28"]},
        "900": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_15_1_1_30_1_28"]},
        "901": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_50_1_1_39_1_28"]},
        "902": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_22_1_1_44_1_28"]},
        "903": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_50_1_1_39_1_28"]},
        "904": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_23_1_1_46_1_28"]},
        "905": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_44_1_1_27_1_28"]},
        "906": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_10_1_1_20_1_28"]},
        "907": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_38_1_1_15_1_28"]},
        "908": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_13_1_1_26_1_28"]},
        "909": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_37_1_1_13_1_28"]},
        "910": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_28_1_1_56_1_28"]},
        "911": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_15_1_1_30_1_28"]},
        "912": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_55_1_1_49_1_28"]},
        "913": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_60_1_1_59_1_28"]},
        "914": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_20_1_1_40_1_28"]},
        "915": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_36_1_1_11_1_28"]},
        "916": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_30_1_1_60_1_28"]},
        "917": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_1_1_1_2_1_28"]},
        "918": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_50_1_1_39_1_28"]},
        "919": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_32_1_1_3_1_28"]},
        "920": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_29_1_1_58_1_28"]},
        "921": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_14_1_1_28_1_28"]},
        "922": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_45_1_1_29_1_28"]},
        "923": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_59_1_1_57_1_28"]},
        "924": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_3_1_1_6_1_28"]},
        "925": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_17_1_1_34_1_28"]},
        "926": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_9_1_1_18_1_28"]},
        "927": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_28_1_1_56_1_28"]},
        "928": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_2_1_1_4_1_28"]},
        "929": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_32_1_1_3_1_28"]},
        "930": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_47_1_1_33_1_28"]},
        "931": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_57_1_1_53_1_28"]},
        "932": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_27_1_1_54_1_28"]},
        "933": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_15_1_1_30_1_28"]},
        "934": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_21_1_1_42_1_28"]},
        "935": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_54_1_1_47_1_28"]},
        "936": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_45_1_1_29_1_28"]},
        "937": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_46_1_1_31_1_28"]},
        "938": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_60_1_1_59_1_28"]},
        "939": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_39_1_1_17_1_28"]},
        "940": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_46_1_1_31_1_28"]},
        "941": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_28_1_1_56_1_28"]},
        "942": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_42_1_1_23_1_28"]},
        "943": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_47_1_1_33_1_28"]},
        "944": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_9_1_1_18_1_28"]},
        "945": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_52_1_1_43_1_28"]},
        "946": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_21_1_1_42_1_28"]},
        "947": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_11_1_1_22_1_28"]},
        "948": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_44_1_1_27_1_28"]},
        "949": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_10_1_1_20_1_28"]},
        "950": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_18_1_1_36_1_28"]},
        "951": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_7_1_1_14_1_28"]},
        "952": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_11_1_1_22_1_28"]},
        "953": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_43_1_1_25_1_28"]},
        "954": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_58_1_1_55_1_28"]},
        "955": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_7_1_1_14_1_28"]},
        "956": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_51_1_1_41_1_28"]},
        "957": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_45_1_1_29_1_28"]},
        "958": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_4_1_1_8_1_28"]},
        "959": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_2_1_1_4_1_28"]},
        "960": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_26_1_1_52_1_28"]},
        "961": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_21_1_1_42_1_28"]},
        "962": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_54_1_1_47_1_28"]},
        "963": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_48_1_1_35_1_28"]},
        "964": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_44_1_1_27_1_28"]},
        "965": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_17_1_1_34_1_28"]},
        "966": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_60_1_1_59_1_28"]},
        "967": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_2_1_1_4_1_28"]},
        "968": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_36_1_1_11_1_28"]},
        "969": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_57_1_1_53_1_28"]},
        "970": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_15_1_1_30_1_28"]},
        "971": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_46_1_1_31_1_28"]},
        "972": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_54_1_1_47_1_28"]},
        "973": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_27_1_1_54_1_28"]},
        "974": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_57_1_1_53_1_28"]},
        "975": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_7_1_1_14_1_28"]},
        "976": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_19_1_1_38_1_28"]},
        "977": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_45_1_1_29_1_28"]},
        "978": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_40_1_1_19_1_28"]},
        "979": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_13_1_1_26_1_28"]},
        "980": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_4_1_1_8_1_28"]},
        "981": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_57_1_1_53_1_28"]},
        "982": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_38_1_1_15_1_28"]},
        "983": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_50_1_1_39_1_28"]},
        "984": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_36_1_1_11_1_28"]},
        "985": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_44_1_1_27_1_28"]},
        "986": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_35_1_1_9_1_28"]},
        "987": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_18_1_1_36_1_28"]},
        "988": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_59_1_1_57_1_28"]},
        "989": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_1_1_1_2_1_28"]},
        "990": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_57_1_1_53_1_28"]},
        "991": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_48_1_1_35_1_28"]},
        "992": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_42_1_1_23_1_28"]},
        "993": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_46_1_1_31_1_28"]},
        "994": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_6_1_1_12_1_28"]},
        "995": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_49_1_1_37_1_28"]},
        "996": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_2_1_1_4_1_28"]},
        "997": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_29_1_1_58_1_28"]},
        "998": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_24_1_1_48_1_28"]},
        "999": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_42_1_1_23_1_28"]},
        "1000": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_5_1_1_10_1_28"]},
        "1001": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_47_1_1_33_1_28"]},
        "1002": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_23_1_1_46_1_28"]},
        "1003": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_19_1_1_38_1_28"]},
        "1004": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_56_1_1_51_1_28"]},
        "1005": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_35_1_1_9_1_28"]},
        "1006": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_5_1_1_10_1_28"]},
        "1007": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_9_1_1_18_1_28"]},
        "1008": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_24_1_1_48_1_28"]},
        "1009": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_56_1_1_51_1_28"]},
        "1010": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_22_1_1_44_1_28"]},
        "1011": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_25_1_1_50_1_28"]},
        "1012": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_7_1_1_14_1_28"]},
        "1013": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_7_1_1_14_1_28"]},
        "1014": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_18_1_1_36_1_28"]},
        "1015": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_46_1_1_31_1_28"]},
        "1016": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_45_1_1_29_1_28"]},
        "1017": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_5_1_1_10_1_28"]},
        "1018": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_28_1_1_56_1_28"]},
        "1019": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_43_1_1_25_1_28"]},
        "1020": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_22_1_1_44_1_28"]},
        "1021": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_42_1_1_23_1_28"]},
        "1022": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_5_1_1_10_1_28"]},
        "1023": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_3_1_1_6_1_28"]},
        "1024": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_24_1_1_48_1_28"]},
        "1025": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_20_1_1_40_1_28"]},
        "1026": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_11_1_1_22_1_28"]},
        "1027": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_30_1_1_60_1_28"]},
        "1028": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_37_1_1_13_1_28"]},
        "1029": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_27_1_1_54_1_28"]},
        "1030": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_52_1_1_43_1_28"]},
        "1031": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_46_1_1_31_1_28"]},
        "1032": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_12_1_1_24_1_28"]},
        "1033": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_44_1_1_27_1_28"]},
        "1034": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_47_1_1_33_1_28"]},
        "1035": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_38_1_1_15_1_28"]},
        "1036": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_30_1_1_60_1_28"]},
        "1037": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_37_1_1_13_1_28"]},
        "1038": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_58_1_1_55_1_28"]},
        "1039": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_49_1_1_37_1_28"]},
        "1040": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_11_1_1_22_1_28"]},
        "1041": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_20_1_1_40_1_28"]},
        "1042": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_25_1_1_50_1_28"]},
        "1043": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_8_1_1_16_1_28"]},
        "1044": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_30_1_1_60_1_28"]},
        "1045": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_20_1_1_40_1_28"]},
        "1046": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_59_1_1_57_1_28"]},
        "1047": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_8_1_1_16_1_28"]},
        "1048": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_30_1_1_60_1_28"]},
        "1049": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_22_1_1_44_1_28"]},
        "1050": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_30_1_1_60_1_28"]},
        "1051": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_57_1_1_53_1_28"]},
        "1052": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_44_1_1_27_1_28"]},
        "1053": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_1_1_1_2_1_28"]},
        "1054": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_49_1_1_37_1_28"]},
        "1055": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_11_1_1_22_1_28"]},
        "1056": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_43_1_1_25_1_28"]},
        "1057": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_1_1_1_2_1_28"]},
        "1058": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_30_1_1_60_1_28"]},
        "1059": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_8_1_1_16_1_28"]},
        "1060": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_45_1_1_29_1_28"]},
        "1061": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_4_1_1_8_1_28"]},
        "1062": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_11_1_1_22_1_28"]},
        "1063": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_32_1_1_3_1_28"]},
        "1064": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_45_1_1_29_1_28"]},
        "1065": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_50_1_1_39_1_28"]},
        "1066": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_9_1_1_18_1_28"]},
        "1067": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_5_1_1_10_1_28"]},
        "1068": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_37_1_1_13_1_28"]},
        "1069": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_43_1_1_25_1_28"]},
        "1070": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_4_1_1_8_1_28"]},
        "1071": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_23_1_1_46_1_28"]},
        "1072": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_36_1_1_11_1_28"]},
        "1073": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_28_1_1_56_1_28"]},
        "1074": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_53_1_1_45_1_28"]},
        "1075": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_9_1_1_18_1_28"]},
        "1076": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_3_1_1_6_1_28"]},
        "1077": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_2_1_1_4_1_28"]},
        "1078": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_59_1_1_57_1_28"]},
        "1079": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_60_1_1_59_1_28"]},
        "1080": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_32_1_1_3_1_28"]},
        "1081": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_16_1_1_32_1_28"]},
        "1082": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_26_1_1_52_1_28"]},
        "1083": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_42_1_1_23_1_28"]},
        "1084": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_31_1_1_1_1_28"]},
        "1085": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_38_1_1_15_1_28"]},
        "1086": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_4_1_1_8_1_28"]},
        "1087": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_17_1_1_34_1_28"]},
        "1088": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_54_1_1_47_1_28"]},
        "1089": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_54_1_1_47_1_28"]},
        "1090": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_11_1_1_22_1_28"]},
        "1091": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_56_1_1_51_1_28"]},
        "1092": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_24_1_1_48_1_28"]},
        "1093": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_2_1_1_4_1_28"]},
        "1094": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_52_1_1_43_1_28"]},
        "1095": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_39_1_1_17_1_28"]},
        "1096": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_6_1_1_12_1_28"]},
        "1097": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_44_1_1_27_1_28"]},
        "1098": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_58_1_1_55_1_28"]},
        "1099": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_1_1_1_2_1_28"]},
        "1100": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_40_1_1_19_1_28"]},
        "1101": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_32_1_1_3_1_28"]},
        "1102": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_36_1_1_11_1_28"]},
        "1103": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_12_1_1_24_1_28"]},
        "1104": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_43_1_1_25_1_28"]},
        "1105": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_10_1_1_20_1_28"]},
        "1106": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_53_1_1_45_1_28"]},
        "1107": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_18_1_1_36_1_28"]},
        "1108": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_5_1_1_10_1_28"]},
        "1109": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_11_1_1_22_1_28"]},
        "1110": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_1_1_1_2_1_28"]},
        "1111": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_24_1_1_48_1_28"]},
        "1112": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_35_1_1_9_1_28"]},
        "1113": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_56_1_1_51_1_28"]},
        "1114": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_52_1_1_43_1_28"]},
        "1115": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_2_1_1_4_1_28"]},
        "1116": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_48_1_1_35_1_28"]},
        "1117": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_39_1_1_17_1_28"]},
        "1118": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_16_1_1_32_1_28"]},
        "1119": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_53_1_1_45_1_28"]},
        "1120": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_34_1_1_7_1_28"]},
        "1121": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_60_1_1_59_1_28"]},
        "1122": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_56_1_1_51_1_28"]},
        "1123": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_5_1_1_10_1_28"]},
        "1124": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_57_1_1_53_1_28"]},
        "1125": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_40_1_1_19_1_28"]},
        "1126": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_43_1_1_25_1_28"]},
        "1127": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_34_1_1_7_1_28"]},
        "1128": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_12_1_1_24_1_28"]},
        "1129": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_11_1_1_22_1_28"]},
        "1130": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_12_1_1_24_1_28"]},
        "1131": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_56_1_1_51_1_28"]},
        "1132": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_42_1_1_23_1_28"]},
        "1133": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_25_1_1_50_1_28"]},
        "1134": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_1_1_1_2_1_28"]},
        "1135": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_7_1_1_14_1_28"]},
        "1136": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_37_1_1_13_1_28"]},
        "1137": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_30_1_1_60_1_28"]},
        "1138": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_39_1_1_17_1_28"]},
        "1139": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_21_1_1_42_1_28"]},
        "1140": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_53_1_1_45_1_28"]},
        "1141": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_53_1_1_45_1_28"]},
        "1142": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_55_1_1_49_1_28"]},
        "1143": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_37_1_1_13_1_28"]},
        "1144": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_4_1_1_8_1_28"]},
        "1145": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_47_1_1_33_1_28"]},
        "1146": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_36_1_1_11_1_28"]},
        "1147": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_38_1_1_15_1_28"]},
        "1148": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_46_1_1_31_1_28"]},
        "1149": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_19_1_1_38_1_28"]},
        "1150": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_29_1_1_58_1_28"]},
        "1151": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_1_1_1_2_1_28"]},
        "1152": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_53_1_1_45_1_28"]},
        "1153": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_43_1_1_25_1_28"]},
        "1154": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_46_1_1_31_1_28"]},
        "1155": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_9_1_1_18_1_28"]},
        "1156": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_38_1_1_15_1_28"]},
        "1157": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_42_1_1_23_1_28"]},
        "1158": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_8_1_1_16_1_28"]},
        "1159": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_20_1_1_40_1_28"]},
        "1160": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_39_1_1_17_1_28"]},
        "1161": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_16_1_1_32_1_28"]},
        "1162": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_31_1_1_1_1_28"]},
        "1163": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_57_1_1_53_1_28"]},
        "1164": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_27_1_1_54_1_28"]},
        "1165": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_43_1_1_25_1_28"]},
        "1166": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_47_1_1_33_1_28"]},
        "1167": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_24_1_1_48_1_28"]},
        "1168": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_57_1_1_53_1_28"]},
        "1169": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_36_1_1_11_1_28"]},
        "1170": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_26_1_1_52_1_28"]},
        "1171": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_34_1_1_7_1_28"]},
        "1172": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_20_1_1_40_1_28"]},
        "1173": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_16_1_1_32_1_28"]},
        "1174": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_37_1_1_13_1_28"]},
        "1175": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_4_1_1_8_1_28"]},
        "1176": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_17_1_1_34_1_28"]},
        "1177": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_25_1_1_50_1_28"]},
        "1178": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_57_1_1_53_1_28"]},
        "1179": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_18_1_1_36_1_28"]},
        "1180": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_58_1_1_55_1_28"]},
        "1181": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_59_1_1_57_1_28"]},
        "1182": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_27_1_1_54_1_28"]},
        "1183": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_45_1_1_29_1_28"]},
        "1184": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_22_1_1_44_1_28"]},
        "1185": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_25_1_1_50_1_28"]},
        "1186": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_4_1_1_8_1_28"]},
        "1187": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_55_1_1_49_1_28"]},
        "1188": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_44_1_1_27_1_28"]},
        "1189": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_14_1_1_28_1_28"]},
        "1190": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_34_1_1_7_1_28"]},
        "1191": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_43_1_1_25_1_28"]},
        "1192": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_23_1_1_46_1_28"]},
        "1193": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_33_1_1_5_1_28"]},
        "1194": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_36_1_1_11_1_28"]},
        "1195": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_13_1_1_26_1_28"]},
        "1196": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_56_1_1_51_1_28"]},
        "1197": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_51_1_1_41_1_28"]},
        "1198": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_3_1_1_6_1_28"]},
        "1199": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_16_1_1_32_1_28"]},
        "1200": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_13_1_1_26_1_28"]},
        "1201": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_28_1_1_56_1_28"]},
        "1202": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_29_1_1_58_1_28"]},
        "1203": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_35_1_1_9_1_28"]},
        "1204": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_45_1_1_29_1_28"]},
        "1205": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_34_1_1_7_1_28"]},
        "1206": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_45_1_1_29_1_28"]},
        "1207": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_59_1_1_57_1_28"]},
        "1208": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_23_1_1_46_1_28"]},
        "1209": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_28_1_1_56_1_28"]},
        "1210": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_38_1_1_15_1_28"]},
        "1211": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_11_1_1_22_1_28"]},
        "1212": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_52_1_1_43_1_28"]},
        "1213": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_48_1_1_35_1_28"]},
        "1214": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_57_1_1_53_1_28"]},
        "1215": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_43_1_1_25_1_28"]},
        "1216": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_29_1_1_58_1_28"]},
        "1217": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_33_1_1_5_1_28"]},
        "1218": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_1_1_1_2_1_28"]},
        "1219": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_16_1_1_32_1_28"]},
        "1220": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_48_1_1_35_1_28"]},
        "1221": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_14_1_1_28_1_28"]},
        "1222": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_38_1_1_15_1_28"]},
        "1223": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_31_1_1_1_1_28"]},
        "1224": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_54_1_1_47_1_28"]},
        "1225": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_12_1_1_24_1_28"]},
        "1226": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_6_1_1_12_1_28"]},
        "1227": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_33_1_1_5_1_28"]},
        "1228": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_5_1_1_10_1_28"]},
        "1229": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_34_1_1_7_1_28"]},
        "1230": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_45_1_1_29_1_28"]},
        "1231": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_1_1_1_2_1_28"]},
        "1232": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_26_1_1_52_1_28"]},
        "1233": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_46_1_1_31_1_28"]},
        "1234": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_14_1_1_28_1_28"]},
        "1235": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_22_1_1_44_1_28"]},
        "1236": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_55_1_1_49_1_28"]},
        "1237": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_5_1_1_10_1_28"]},
        "1238": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_19_1_1_38_1_28"]},
        "1239": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_2_1_1_4_1_28"]},
        "1240": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_26_1_1_52_1_28"]},
        "1241": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_28_1_1_56_1_28"]},
        "1242": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_42_1_1_23_1_28"]},
        "1243": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_11_1_1_22_1_28"]},
        "1244": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_39_1_1_17_1_28"]},
        "1245": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_10_1_1_20_1_28"]},
        "1246": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_8_1_1_16_1_28"]},
        "1247": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_21_1_1_42_1_28"]},
        "1248": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_25_1_1_50_1_28"]},
        "1249": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_2_1_1_4_1_28"]},
        "1250": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_31_1_1_1_1_28"]},
        "1251": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_13_1_1_26_1_28"]},
        "1252": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_22_1_1_44_1_28"]},
        "1253": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_40_1_1_19_1_28"]},
        "1254": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_6_1_1_12_1_28"]},
        "1255": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_38_1_1_15_1_28"]},
        "1256": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_2_1_1_4_1_28"]},
        "1257": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_51_1_1_41_1_28"]},
        "1258": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_20_1_1_40_1_28"]},
        "1259": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_23_1_1_46_1_28"]},
        "1260": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_4_1_1_8_1_28"]},
        "1261": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_60_1_1_59_1_28"]},
        "1262": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_11_1_1_22_1_28"]},
        "1263": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_19_1_1_38_1_28"]},
        "1264": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_48_1_1_35_1_28"]},
        "1265": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_6_1_1_12_1_28"]},
        "1266": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_40_1_1_19_1_28"]},
        "1267": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_23_1_1_46_1_28"]},
        "1268": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_2_1_1_4_1_28"]},
        "1269": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_60_1_1_59_1_28"]},
        "1270": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_48_1_1_35_1_28"]},
        "1271": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_35_1_1_9_1_28"]},
        "1272": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_2_1_1_4_1_28"]},
        "1273": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_29_1_1_58_1_28"]},
        "1274": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_17_1_1_34_1_28"]},
        "1275": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_35_1_1_9_1_28"]},
        "1276": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_25_1_1_50_1_28"]},
        "1277": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_21_1_1_42_1_28"]},
        "1278": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_5_1_1_10_1_28"]},
        "1279": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_55_1_1_49_1_28"]},
        "1280": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_33_1_1_5_1_28"]},
        "1281": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_46_1_1_31_1_28"]},
        "1282": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_58_1_1_55_1_28"]},
        "1283": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_29_1_1_58_1_28"]},
        "1284": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_44_1_1_27_1_28"]},
        "1285": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_36_1_1_11_1_28"]},
        "1286": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_60_1_1_59_1_28"]},
        "1287": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_6_1_1_12_1_28"]},
        "1288": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_17_1_1_34_1_28"]},
        "1289": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_37_1_1_13_1_28"]},
        "1290": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_15_1_1_30_1_28"]},
        "1291": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_29_1_1_58_1_28"]},
        "1292": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_36_1_1_11_1_28"]},
        "1293": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_11_1_1_22_1_28"]},
        "1294": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_21_1_1_42_1_28"]},
        "1295": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_25_1_1_50_1_28"]},
        "1296": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_15_1_1_30_1_28"]},
        "1297": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_28_1_1_56_1_28"]},
        "1298": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_43_1_1_25_1_28"]},
        "1299": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_30_1_1_60_1_28"]},
        "1300": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_23_1_1_46_1_28"]},
        "1301": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_11_1_1_22_1_28"]},
        "1302": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_3_1_1_6_1_28"]},
        "1303": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_34_1_1_7_1_28"]},
        "1304": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_45_1_1_29_1_28"]},
        "1305": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_31_1_1_1_1_28"]},
        "1306": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_37_1_1_13_1_28"]},
        "1307": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_16_1_1_32_1_28"]},
        "1308": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_50_1_1_39_1_28"]},
        "1309": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_4_1_1_8_1_28"]},
        "1310": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_50_1_1_39_1_28"]},
        "1311": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_17_1_1_34_1_28"]},
        "1312": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_3_1_1_6_1_28"]},
        "1313": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_41_1_1_21_1_28"]},
        "1314": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_37_1_1_13_1_28"]},
        "1315": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_55_1_1_49_1_28"]},
        "1316": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_20_1_1_40_1_28"]},
        "1317": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_20_1_1_40_1_28"]},
        "1318": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_5_1_1_10_1_28"]},
        "1319": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_16_1_1_32_1_28"]},
        "1320": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_54_1_1_47_1_28"]},
        "1321": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_20_1_1_40_1_28"]},
        "1322": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_58_1_1_55_1_28"]},
        "1323": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_45_1_1_29_1_28"]},
        "1324": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_10_1_1_20_1_28"]},
        "1325": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_40_1_1_19_1_28"]},
        "1326": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_3_1_1_6_1_28"]},
        "1327": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_42_1_1_23_1_28"]},
        "1328": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_41_1_1_21_1_28"]},
        "1329": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_17_1_1_34_1_28"]},
        "1330": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_32_1_1_3_1_28"]},
        "1331": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_47_1_1_33_1_28"]},
        "1332": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_44_1_1_27_1_28"]},
        "1333": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_55_1_1_49_1_28"]},
        "1334": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_42_1_1_23_1_28"]},
        "1335": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_3_1_1_6_1_28"]},
        "1336": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_42_1_1_23_1_28"]},
        "1337": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_9_1_1_18_1_28"]},
        "1338": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_23_1_1_46_1_28"]},
        "1339": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_57_1_1_53_1_28"]},
        "1340": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_51_1_1_41_1_28"]},
        "1341": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_43_1_1_25_1_28"]},
        "1342": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_12_1_1_24_1_28"]},
        "1343": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_40_1_1_19_1_28"]},
        "1344": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_40_1_1_19_1_28"]},
        "1345": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_55_1_1_49_1_28"]},
        "1346": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_56_1_1_51_1_28"]},
        "1347": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_50_1_1_39_1_28"]},
        "1348": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_43_1_1_25_1_28"]},
        "1349": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_57_1_1_53_1_28"]},
        "1350": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_34_1_1_7_1_28"]},
        "1351": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_44_1_1_27_1_28"]},
        "1352": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_44_1_1_27_1_28"]},
        "1353": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_29_1_1_58_1_28"]},
        "1354": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_34_1_1_7_1_28"]},
        "1355": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_13_1_1_26_1_28"]},
        "1356": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_40_1_1_19_1_28"]},
        "1357": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_16_1_1_32_1_28"]},
        "1358": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_31_1_1_1_1_28"]},
        "1359": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_48_1_1_35_1_28"]},
        "1360": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_49_1_1_37_1_28"]},
        "1361": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_17_1_1_34_1_28"]},
        "1362": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_15_1_1_30_1_28"]},
        "1363": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_8_1_1_16_1_28"]},
        "1364": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_30_1_1_60_1_28"]},
        "1365": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_5_1_1_10_1_28"]},
        "1366": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_12_1_1_24_1_28"]},
        "1367": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_15_1_1_30_1_28"]},
        "1368": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_28_1_1_56_1_28"]},
        "1369": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_20_1_1_40_1_28"]},
        "1370": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_22_1_1_44_1_28"]},
        "1371": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_27_1_1_54_1_28"]},
        "1372": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_37_1_1_13_1_28"]},
        "1373": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_53_1_1_45_1_28"]},
        "1374": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_6_1_1_12_1_28"]},
        "1375": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_40_1_1_19_1_28"]},
        "1376": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_36_1_1_11_1_28"]},
        "1377": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_38_1_1_15_1_28"]},
        "1378": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_46_1_1_31_1_28"]},
        "1379": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_47_1_1_33_1_28"]},
        "1380": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_5_1_1_10_1_28"]},
        "1381": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_27_1_1_54_1_28"]},
        "1382": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_13_1_1_26_1_28"]},
        "1383": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_47_1_1_33_1_28"]},
        "1384": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_60_1_1_59_1_28"]},
        "1385": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_58_1_1_55_1_28"]},
        "1386": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_49_1_1_37_1_28"]},
        "1387": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_40_1_1_19_1_28"]},
        "1388": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_31_1_1_1_1_28"]},
        "1389": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_18_1_1_36_1_28"]},
        "1390": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_36_1_1_11_1_28"]},
        "1391": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_13_1_1_26_1_28"]},
        "1392": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_6_1_1_12_1_28"]},
        "1393": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_50_1_1_39_1_28"]},
        "1394": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_51_1_1_41_1_28"]},
        "1395": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_24_1_1_48_1_28"]},
        "1396": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_41_1_1_21_1_28"]},
        "1397": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_6_1_1_12_1_28"]},
        "1398": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_46_1_1_31_1_28"]},
        "1399": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_48_1_1_35_1_28"]},
        "1400": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_40_1_1_19_1_28"]},
        "1401": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_3_1_1_6_1_28"]},
        "1402": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_49_1_1_37_1_28"]},
        "1403": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_40_1_1_19_1_28"]},
        "1404": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_8_1_1_16_1_28"]},
        "1405": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_46_1_1_31_1_28"]},
        "1406": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_56_1_1_51_1_28"]},
        "1407": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_15_1_1_30_1_28"]},
        "1408": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_34_1_1_7_1_28"]},
        "1409": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_51_1_1_41_1_28"]},
        "1410": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_58_1_1_55_1_28"]},
        "1411": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_30_1_1_60_1_28"]},
        "1412": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_45_1_1_29_1_28"]},
        "1413": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_47_1_1_33_1_28"]},
        "1414": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_35_1_1_9_1_28"]},
        "1415": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_36_1_1_11_1_28"]},
        "1416": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_8_1_1_16_1_28"]},
        "1417": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_8_1_1_16_1_28"]},
        "1418": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_21_1_1_42_1_28"]},
        "1419": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_21_1_1_42_1_28"]},
        "1420": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_47_1_1_33_1_28"]},
        "1421": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_24_1_1_48_1_28"]},
        "1422": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_23_1_1_46_1_28"]},
        "1423": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_34_1_1_7_1_28"]},
        "1424": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_14_1_1_28_1_28"]},
        "1425": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_28_1_1_56_1_28"]},
        "1426": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_28_1_1_56_1_28"]},
        "1427": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_31_1_1_1_1_28"]},
        "1428": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_12_1_1_24_1_28"]},
        "1429": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_8_1_1_16_1_28"]},
        "1430": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_52_1_1_43_1_28"]},
        "1431": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_32_1_1_3_1_28"]},
        "1432": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_33_1_1_5_1_28"]},
        "1433": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_19_1_1_38_1_28"]},
        "1434": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_25_1_1_50_1_28"]},
        "1435": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_28_1_1_56_1_28"]},
        "1436": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_53_1_1_45_1_28"]},
        "1437": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_58_1_1_55_1_28"]},
        "1438": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_31_1_1_1_1_28"]},
        "1439": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_50_1_1_39_1_28"]},
        "1440": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_38_1_1_15_1_28"]},
        "1441": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_28_1_1_56_1_28"]},
        "1442": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_5_1_1_10_1_28"]},
        "1443": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_17_1_1_34_1_28"]},
        "1444": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_42_1_1_23_1_28"]},
        "1445": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_56_1_1_51_1_28"]},
        "1446": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_53_1_1_45_1_28"]},
        "1447": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_27_1_1_54_1_28"]},
        "1448": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_33_1_1_5_1_28"]},
        "1449": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_7_1_1_14_1_28"]},
        "1450": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_56_1_1_51_1_28"]},
        "1451": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_9_1_1_18_1_28"]},
        "1452": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_14_1_1_28_1_28"]},
        "1453": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_3_1_1_6_1_28"]},
        "1454": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_20_1_1_40_1_28"]},
        "1455": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_37_1_1_13_1_28"]},
        "1456": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_48_1_1_35_1_28"]},
        "1457": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_39_1_1_17_1_28"]},
        "1458": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_60_1_1_59_1_28"]},
        "1459": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_7_1_1_14_1_28"]},
        "1460": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_29_1_1_58_1_28"]},
        "1461": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_43_1_1_25_1_28"]},
        "1462": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_43_1_1_25_1_28"]},
        "1463": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_14_1_1_28_1_28"]},
        "1464": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_25_1_1_50_1_28"]},
        "1465": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_13_1_1_26_1_28"]},
        "1466": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_59_1_1_57_1_28"]},
        "1467": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_14_1_1_28_1_28"]},
        "1468": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_3_1_1_6_1_28"]},
        "1469": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_14_1_1_28_1_28"]},
        "1470": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_44_1_1_27_1_28"]},
        "1471": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_5_1_1_10_1_28"]},
        "1472": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_50_1_1_39_1_28"]},
        "1473": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_16_1_1_32_1_28"]},
        "1474": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_35_1_1_9_1_28"]},
        "1475": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_35_1_1_9_1_28"]},
        "1476": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_55_1_1_49_1_28"]},
        "1477": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_15_1_1_30_1_28"]},
        "1478": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_26_1_1_52_1_28"]},
        "1479": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_3_1_1_6_1_28"]},
        "1480": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_53_1_1_45_1_28"]},
        "1481": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_58_1_1_55_1_28"]},
        "1482": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_49_1_1_37_1_28"]},
        "1483": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_48_1_1_35_1_28"]},
        "1484": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_46_1_1_31_1_28"]},
        "1485": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_32_1_1_3_1_28"]},
        "1486": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_8_1_1_16_1_28"]},
        "1487": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_51_1_1_41_1_28"]},
        "1488": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_25_1_1_50_1_28"]},
        "1489": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_26_1_1_52_1_28"]},
        "1490": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_47_1_1_33_1_28"]},
        "1491": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_9_1_1_18_1_28"]},
        "1492": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_50_1_1_39_1_28"]},
        "1493": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_28_1_1_56_1_28"]},
        "1494": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_6_1_1_12_1_28"]},
        "1495": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_38_1_1_15_1_28"]},
        "1496": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_4_1_1_8_1_28"]},
        "1497": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_27_1_1_54_1_28"]},
        "1498": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_53_1_1_45_1_28"]},
        "1499": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_6_1_1_12_1_28"]},
        "1500": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_21_1_1_42_1_28"]},
        "1501": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_33_1_1_5_1_28"]},
        "1502": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_5_1_1_10_1_28"]},
        "1503": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_36_1_1_11_1_28"]},
        "1504": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_36_1_1_11_1_28"]},
        "1505": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_58_1_1_55_1_28"]},
        "1506": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_24_1_1_48_1_28"]},
        "1507": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_41_1_1_21_1_28"]},
        "1508": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_22_1_1_44_1_28"]},
        "1509": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_6_1_1_12_1_28"]},
        "1510": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_51_1_1_41_1_28"]},
        "1511": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_4_1_1_8_1_28"]},
        "1512": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_33_1_1_5_1_28"]},
        "1513": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_9_1_1_18_1_28"]},
        "1514": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_3_1_1_6_1_28"]},
        "1515": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_13_1_1_26_1_28"]},
        "1516": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_12_1_1_24_1_28"]},
        "1517": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_44_1_1_27_1_28"]},
        "1518": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_55_1_1_49_1_28"]},
        "1519": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_38_1_1_15_1_28"]},
        "1520": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_34_1_1_7_1_28"]},
        "1521": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_58_1_1_55_1_28"]},
        "1522": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_45_1_1_29_1_28"]},
        "1523": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_44_1_1_27_1_28"]},
        "1524": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_29_1_1_58_1_28"]},
        "1525": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_13_1_1_26_1_28"]},
        "1526": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_60_1_1_59_1_28"]},
        "1527": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_9_1_1_18_1_28"]},
        "1528": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_34_1_1_7_1_28"]},
        "1529": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_49_1_1_37_1_28"]},
        "1530": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_39_1_1_17_1_28"]},
        "1531": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_2_1_1_4_1_28"]},
        "1532": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_13_1_1_26_1_28"]},
        "1533": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_40_1_1_19_1_28"]},
        "1534": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_28_1_1_56_1_28"]},
        "1535": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_10_1_1_20_1_28"]},
        "1536": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_17_1_1_34_1_28"]},
        "1537": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_42_1_1_23_1_28"]},
        "1538": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_25_1_1_50_1_28"]},
        "1539": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_22_1_1_44_1_28"]},
        "1540": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_10_1_1_20_1_28"]},
        "1541": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_22_1_1_44_1_28"]},
        "1542": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_43_1_1_25_1_28"]},
        "1543": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_17_1_1_34_1_28"]},
        "1544": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_58_1_1_55_1_28"]},
        "1545": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_12_1_1_24_1_28"]},
        "1546": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_41_1_1_21_1_28"]},
        "1547": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_45_1_1_29_1_28"]},
        "1548": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_54_1_1_47_1_28"]},
        "1549": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_42_1_1_23_1_28"]},
        "1550": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_39_1_1_17_1_28"]},
        "1551": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_54_1_1_47_1_28"]},
        "1552": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_52_1_1_43_1_28"]},
        "1553": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_20_1_1_40_1_28"]},
        "1554": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_12_1_1_24_1_28"]},
        "1555": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_41_1_1_21_1_28"]},
        "1556": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_14_1_1_28_1_28"]},
        "1557": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_27_1_1_54_1_28"]},
        "1558": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_57_1_1_53_1_28"]},
        "1559": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_16_1_1_32_1_28"]},
        "1560": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_4_1_1_8_1_28"]},
        "1561": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_30_1_1_60_1_28"]},
        "1562": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_7_1_1_14_1_28"]},
        "1563": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_54_1_1_47_1_28"]},
        "1564": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_28_1_1_56_1_28"]},
        "1565": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_54_1_1_47_1_28"]},
        "1566": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_3_1_1_6_1_28"]},
        "1567": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_8_1_1_16_1_28"]},
        "1568": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_1_1_1_2_1_28"]},
        "1569": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_52_1_1_43_1_28"]},
        "1570": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_8_1_1_16_1_28"]},
        "1571": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_17_1_1_34_1_28"]},
        "1572": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_31_1_1_1_1_28"]},
        "1573": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_6_1_1_12_1_28"]},
        "1574": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_26_1_1_52_1_28"]},
        "1575": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_58_1_1_55_1_28"]},
        "1576": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_49_1_1_37_1_28"]},
        "1577": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_55_1_1_49_1_28"]},
        "1578": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_41_1_1_21_1_28"]},
        "1579": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_48_1_1_35_1_28"]},
        "1580": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_32_1_1_3_1_28"]},
        "1581": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_16_1_1_32_1_28"]},
        "1582": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_36_1_1_11_1_28"]},
        "1583": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_48_1_1_35_1_28"]},
        "1584": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_7_1_1_14_1_28"]},
        "1585": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_50_1_1_39_1_28"]},
        "1586": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_11_1_1_22_1_28"]},
        "1587": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_51_1_1_41_1_28"]},
        "1588": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_49_1_1_37_1_28"]},
        "1589": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_2_1_1_4_1_28"]},
        "1590": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_60_1_1_59_1_28"]},
        "1591": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_43_1_1_25_1_28"]},
        "1592": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_17_1_1_34_1_28"]},
        "1593": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_29_1_1_58_1_28"]},
        "1594": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_17_1_1_34_1_28"]},
        "1595": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_44_1_1_27_1_28"]},
        "1596": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_2_1_1_4_1_28"]},
        "1597": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_43_1_1_25_1_28"]},
        "1598": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_25_1_1_50_1_28"]},
        "1599": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_8_1_1_16_1_28"]},
        "1600": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_24_1_1_48_1_28"]},
        "1601": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_56_1_1_51_1_28"]},
        "1602": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_23_1_1_46_1_28"]},
        "1603": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_18_1_1_36_1_28"]},
        "1604": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_54_1_1_47_1_28"]},
        "1605": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_24_1_1_48_1_28"]},
        "1606": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_21_1_1_42_1_28"]},
        "1607": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_47_1_1_33_1_28"]},
        "1608": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_2_1_1_4_1_28"]},
        "1609": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_38_1_1_15_1_28"]},
        "1610": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_50_1_1_39_1_28"]},
        "1611": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_60_1_1_59_1_28"]},
        "1612": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_58_1_1_55_1_28"]},
        "1613": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_24_1_1_48_1_28"]},
        "1614": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_40_1_1_19_1_28"]},
        "1615": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_52_1_1_43_1_28"]},
        "1616": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_13_1_1_26_1_28"]},
        "1617": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_34_1_1_7_1_28"]},
        "1618": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_34_1_1_7_1_28"]},
        "1619": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_60_1_1_59_1_28"]},
        "1620": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_33_1_1_5_1_28"]},
        "1621": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_6_1_1_12_1_28"]},
        "1622": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_42_1_1_23_1_28"]},
        "1623": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_49_1_1_37_1_28"]},
        "1624": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_26_1_1_52_1_28"]},
        "1625": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_15_1_1_30_1_28"]},
        "1626": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_17_1_1_34_1_28"]},
        "1627": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_24_1_1_48_1_28"]},
        "1628": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_43_1_1_25_1_28"]},
        "1629": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_43_1_1_25_1_28"]},
        "1630": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_21_1_1_42_1_28"]},
        "1631": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_10_1_1_20_1_28"]},
        "1632": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_31_1_1_1_1_28"]},
        "1633": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_36_1_1_11_1_28"]},
        "1634": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_23_1_1_46_1_28"]},
        "1635": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_35_1_1_9_1_28"]},
        "1636": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_50_1_1_39_1_28"]},
        "1637": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_1_1_1_2_1_28"]},
        "1638": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_8_1_1_16_1_28"]},
        "1639": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_19_1_1_38_1_28"]},
        "1640": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_52_1_1_43_1_28"]},
        "1641": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_55_1_1_49_1_28"]},
        "1642": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_37_1_1_13_1_28"]},
        "1643": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_29_1_1_58_1_28"]},
        "1644": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_14_1_1_28_1_28"]},
        "1645": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_52_1_1_43_1_28"]},
        "1646": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_16_1_1_32_1_28"]},
        "1647": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_14_1_1_28_1_28"]},
        "1648": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_27_1_1_54_1_28"]},
        "1649": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_46_1_1_31_1_28"]},
        "1650": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_32_1_1_3_1_28"]},
        "1651": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_52_1_1_43_1_28"]},
        "1652": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_29_1_1_58_1_28"]},
        "1653": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_37_1_1_13_1_28"]},
        "1654": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_29_1_1_58_1_28"]},
        "1655": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_3_1_1_6_1_28"]},
        "1656": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_20_1_1_40_1_28"]},
        "1657": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_59_1_1_57_1_28"]},
        "1658": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_16_1_1_32_1_28"]},
        "1659": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_1_1_1_2_1_28"]},
        "1660": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_20_1_1_40_1_28"]},
        "1661": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_21_1_1_42_1_28"]},
        "1662": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_52_1_1_43_1_28"]},
        "1663": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_8_1_1_16_1_28"]},
        "1664": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_25_1_1_50_1_28"]},
        "1665": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_56_1_1_51_1_28"]},
        "1666": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_56_1_1_51_1_28"]},
        "1667": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_57_1_1_53_1_28"]},
        "1668": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_48_1_1_35_1_28"]},
        "1669": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_28_1_1_56_1_28"]},
        "1670": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_17_1_1_34_1_28"]},
        "1671": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_56_1_1_51_1_28"]},
        "1672": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_5_1_1_10_1_28"]},
        "1673": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_16_1_1_32_1_28"]},
        "1674": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_59_1_1_57_1_28"]},
        "1675": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_35_1_1_9_1_28"]},
        "1676": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_21_1_1_42_1_28"]},
        "1677": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_6_1_1_12_1_28"]},
        "1678": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_6_1_1_12_1_28"]},
        "1679": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_57_1_1_53_1_28"]},
        "1680": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_12_1_1_24_1_28"]},
        "1681": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_4_1_1_8_1_28"]},
        "1682": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_20_1_1_40_1_28"]},
        "1683": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_2_1_1_4_1_28"]},
        "1684": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_13_1_1_26_1_28"]},
        "1685": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_59_1_1_57_1_28"]},
        "1686": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_31_1_1_1_1_28"]},
        "1687": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_36_1_1_11_1_28"]},
        "1688": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_56_1_1_51_1_28"]},
        "1689": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_8_1_1_16_1_28"]},
        "1690": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_60_1_1_59_1_28"]},
        "1691": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_22_1_1_44_1_28"]},
        "1692": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_10_1_1_20_1_28"]},
        "1693": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_15_1_1_30_1_28"]},
        "1694": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_10_1_1_20_1_28"]},
        "1695": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_32_1_1_3_1_28"]},
        "1696": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_28_1_1_56_1_28"]},
        "1697": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_20_1_1_40_1_28"]},
        "1698": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_36_1_1_11_1_28"]},
        "1699": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_16_1_1_32_1_28"]},
        "1700": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_27_1_1_54_1_28"]},
        "1701": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_44_1_1_27_1_28"]},
        "1702": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_3_1_1_6_1_28"]},
        "1703": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_2_1_1_4_1_28"]},
        "1704": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_20_1_1_40_1_28"]},
        "1705": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_27_1_1_54_1_28"]},
        "1706": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_33_1_1_5_1_28"]},
        "1707": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_2_1_1_4_1_28"]},
        "1708": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_18_1_1_36_1_28"]},
        "1709": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_7_1_1_14_1_28"]},
        "1710": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_8_1_1_16_1_28"]},
        "1711": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_59_1_1_57_1_28"]},
        "1712": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_46_1_1_31_1_28"]},
        "1713": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_4_1_1_8_1_28"]},
        "1714": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_40_1_1_19_1_28"]},
        "1715": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_49_1_1_37_1_28"]},
        "1716": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_47_1_1_33_1_28"]},
        "1717": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_2_1_1_4_1_28"]},
        "1718": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_37_1_1_13_1_28"]},
        "1719": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_9_1_1_18_1_28"]},
        "1720": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_59_1_1_57_1_28"]},
        "1721": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_56_1_1_51_1_28"]},
        "1722": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_6_1_1_12_1_28"]},
        "1723": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_38_1_1_15_1_28"]},
        "1724": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_40_1_1_19_1_28"]},
        "1725": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_32_1_1_3_1_28"]},
        "1726": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_12_1_1_24_1_28"]},
        "1727": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_33_1_1_5_1_28"]},
        "1728": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_15_1_1_30_1_28"]},
        "1729": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_52_1_1_43_1_28"]},
        "1730": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_30_1_1_60_1_28"]},
        "1731": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_3_1_1_6_1_28"]},
        "1732": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_38_1_1_15_1_28"]},
        "1733": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_20_1_1_40_1_28"]},
        "1734": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_35_1_1_9_1_28"]},
        "1735": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_18_1_1_36_1_28"]},
        "1736": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_32_1_1_3_1_28"]},
        "1737": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_16_1_1_32_1_28"]},
        "1738": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_27_1_1_54_1_28"]},
        "1739": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_34_1_1_7_1_28"]},
        "1740": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_21_1_1_42_1_28"]},
        "1741": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_54_1_1_47_1_28"]},
        "1742": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_46_1_1_31_1_28"]},
        "1743": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_23_1_1_46_1_28"]},
        "1744": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_27_1_1_54_1_28"]},
        "1745": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_32_1_1_3_1_28"]},
        "1746": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_47_1_1_33_1_28"]},
        "1747": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_45_1_1_29_1_28"]},
        "1748": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_50_1_1_39_1_28"]},
        "1749": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_1_1_1_2_1_28"]},
        "1750": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_25_1_1_50_1_28"]},
        "1751": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_36_1_1_11_1_28"]},
        "1752": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_11_1_1_22_1_28"]},
        "1753": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_51_1_1_41_1_28"]},
        "1754": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_14_1_1_28_1_28"]},
        "1755": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_21_1_1_42_1_28"]},
        "1756": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_21_1_1_42_1_28"]},
        "1757": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_36_1_1_11_1_28"]},
        "1758": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_23_1_1_46_1_28"]},
        "1759": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_27_1_1_54_1_28"]},
        "1760": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_39_1_1_17_1_28"]},
        "1761": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_32_1_1_3_1_28"]},
        "1762": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_17_1_1_34_1_28"]},
        "1763": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_9_1_1_18_1_28"]},
        "1764": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_46_1_1_31_1_28"]},
        "1765": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_59_1_1_57_1_28"]},
        "1766": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_38_1_1_15_1_28"]},
        "1767": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_13_1_1_26_1_28"]},
        "1768": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_43_1_1_25_1_28"]},
        "1769": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_12_1_1_24_1_28"]},
        "1770": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_3_1_1_6_1_28"]},
        "1771": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_35_1_1_9_1_28"]},
        "1772": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_24_1_1_48_1_28"]},
        "1773": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_3_1_1_6_1_28"]},
        "1774": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_55_1_1_49_1_28"]},
        "1775": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_14_1_1_28_1_28"]},
        "1776": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_39_1_1_17_1_28"]},
        "1777": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_57_1_1_53_1_28"]},
        "1778": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_58_1_1_55_1_28"]},
        "1779": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_60_1_1_59_1_28"]},
        "1780": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_18_1_1_36_1_28"]},
        "1781": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_37_1_1_13_1_28"]},
        "1782": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_10_1_1_20_1_28"]},
        "1783": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_5_1_1_10_1_28"]},
        "1784": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_10_1_1_20_1_28"]},
        "1785": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_39_1_1_17_1_28"]},
        "1786": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_5_1_1_10_1_28"]},
        "1787": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_35_1_1_9_1_28"]},
        "1788": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_53_1_1_45_1_28"]},
        "1789": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_33_1_1_5_1_28"]},
        "1790": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_31_1_1_1_1_28"]},
        "1791": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_21_1_1_42_1_28"]},
        "1792": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_12_1_1_24_1_28"]},
        "1793": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_5_1_1_10_1_28"]},
        "1794": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_47_1_1_33_1_28"]},
        "1795": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_17_1_1_34_1_28"]},
        "1796": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_21_1_1_42_1_28"]},
        "1797": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_57_1_1_53_1_28"]},
        "1798": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_46_1_1_31_1_28"]},
        "1799": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_16_1_1_32_1_28"]},
        "1800": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_24_1_1_48_1_28"]},
        "1801": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_6_1_1_12_1_28"]},
        "1802": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_9_1_1_18_1_28"]},
        "1803": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_26_1_1_52_1_28"]},
        "1804": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_28_1_1_56_1_28"]},
        "1805": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_50_1_1_39_1_28"]},
        "1806": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_30_1_1_60_1_28"]},
        "1807": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_40_1_1_19_1_28"]},
        "1808": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_56_1_1_51_1_28"]},
        "1809": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_58_1_1_55_1_28"]},
        "1810": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_28_1_1_56_1_28"]},
        "1811": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_54_1_1_47_1_28"]},
        "1812": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_38_1_1_15_1_28"]},
        "1813": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_18_1_1_36_1_28"]},
        "1814": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_44_1_1_27_1_28"]},
        "1815": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_40_1_1_19_1_28"]},
        "1816": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_58_1_1_55_1_28"]},
        "1817": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_33_1_1_5_1_28"]},
        "1818": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_41_1_1_21_1_28"]},
        "1819": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_56_1_1_51_1_28"]},
        "1820": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_9_1_1_18_1_28"]},
        "1821": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_60_1_1_59_1_28"]},
        "1822": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_31_1_1_1_1_28"]},
        "1823": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_52_1_1_43_1_28"]},
        "1824": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_26_1_1_52_1_28"]},
        "1825": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_50_1_1_39_1_28"]},
        "1826": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_31_1_1_1_1_28"]},
        "1827": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_49_1_1_37_1_28"]},
        "1828": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_56_1_1_51_1_28"]},
        "1829": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_2_1_1_4_1_28"]},
        "1830": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_15_1_1_30_1_28"]},
        "1831": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_25_1_1_50_1_28"]},
        "1832": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_27_1_1_54_1_28"]},
        "1833": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_15_1_1_30_1_28"]},
        "1834": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_41_1_1_21_1_28"]},
        "1835": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_23_1_1_46_1_28"]},
        "1836": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_18_1_1_36_1_28"]},
        "1837": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_54_1_1_47_1_28"]},
        "1838": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_57_1_1_53_1_28"]},
        "1839": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_13_1_1_26_1_28"]},
        "1840": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_34_1_1_7_1_28"]},
        "1841": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_19_1_1_38_1_28"]},
        "1842": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_53_1_1_45_1_28"]},
        "1843": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_23_1_1_46_1_28"]},
        "1844": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_55_1_1_49_1_28"]},
        "1845": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_1_1_1_2_1_28"]},
        "1846": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_40_1_1_19_1_28"]},
        "1847": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_58_1_1_55_1_28"]},
        "1848": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_23_1_1_46_1_28"]},
        "1849": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_55_1_1_49_1_28"]},
        "1850": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_13_1_1_26_1_28"]},
        "1851": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_2_1_1_4_1_28"]},
        "1852": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_26_1_1_52_1_28"]},
        "1853": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_39_1_1_17_1_28"]},
        "1854": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_37_1_1_13_1_28"]},
        "1855": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_43_1_1_25_1_28"]},
        "1856": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_14_1_1_28_1_28"]},
        "1857": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_1_1_1_2_1_28"]},
        "1858": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_47_1_1_33_1_28"]},
        "1859": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_15_1_1_30_1_28"]},
        "1860": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_50_1_1_39_1_28"]},
        "1861": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_26_1_1_52_1_28"]},
        "1862": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_7_1_1_14_1_28"]},
        "1863": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_20_1_1_40_1_28"]},
        "1864": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_25_1_1_50_1_28"]},
        "1865": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_56_1_1_51_1_28"]},
        "1866": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_47_1_1_33_1_28"]},
        "1867": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_56_1_1_51_1_28"]},
        "1868": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_31_1_1_1_1_28"]},
        "1869": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_44_1_1_27_1_28"]},
        "1870": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_52_1_1_43_1_28"]},
        "1871": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_17_1_1_34_1_28"]},
        "1872": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_44_1_1_27_1_28"]},
        "1873": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_33_1_1_5_1_28"]},
        "1874": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_8_1_1_16_1_28"]},
        "1875": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_58_1_1_55_1_28"]},
        "1876": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_42_1_1_23_1_28"]},
        "1877": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_4_1_1_8_1_28"]},
        "1878": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_27_1_1_54_1_28"]},
        "1879": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_24_1_1_48_1_28"]},
        "1880": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_44_1_1_27_1_28"]},
        "1881": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_59_1_1_57_1_28"]},
        "1882": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_10_1_1_20_1_28"]},
        "1883": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_60_1_1_59_1_28"]},
        "1884": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_13_1_1_26_1_28"]},
        "1885": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_57_1_1_53_1_28"]},
        "1886": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_12_1_1_24_1_28"]},
        "1887": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_27_1_1_54_1_28"]},
        "1888": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_18_1_1_36_1_28"]},
        "1889": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_10_1_1_20_1_28"]},
        "1890": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_12_1_1_24_1_28"]},
        "1891": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_29_1_1_58_1_28"]},
        "1892": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_30_1_1_60_1_28"]},
        "1893": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_6_1_1_12_1_28"]},
        "1894": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_5_1_1_10_1_28"]},
        "1895": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_32_1_1_3_1_28"]},
        "1896": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_50_1_1_39_1_28"]},
        "1897": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_36_1_1_11_1_28"]},
        "1898": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_56_1_1_51_1_28"]},
        "1899": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_54_1_1_47_1_28"]},
        "1900": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_3_1_1_6_1_28"]},
        "1901": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_47_1_1_33_1_28"]},
        "1902": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_6_1_1_12_1_28"]},
        "1903": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_42_1_1_23_1_28"]},
        "1904": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_27_1_1_54_1_28"]},
        "1905": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_23_1_1_46_1_28"]},
        "1906": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_29_1_1_58_1_28"]},
        "1907": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_7_1_1_14_1_28"]},
        "1908": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_19_1_1_38_1_28"]},
        "1909": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_45_1_1_29_1_28"]},
        "1910": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_11_1_1_22_1_28"]},
        "1911": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_14_1_1_28_1_28"]},
        "1912": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_32_1_1_3_1_28"]},
        "1913": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_46_1_1_31_1_28"]},
        "1914": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_41_1_1_21_1_28"]},
        "1915": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_55_1_1_49_1_28"]},
        "1916": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_47_1_1_33_1_28"]},
        "1917": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_7_1_1_14_1_28"]},
        "1918": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_36_1_1_11_1_28"]},
        "1919": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_30_1_1_60_1_28"]},
        "1920": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_33_1_1_5_1_28"]},
        "1921": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_4_1_1_8_1_28"]},
        "1922": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_24_1_1_48_1_28"]},
        "1923": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_48_1_1_35_1_28"]},
        "1924": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_26_1_1_52_1_28"]},
        "1925": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_41_1_1_21_1_28"]},
        "1926": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_49_1_1_37_1_28"]},
        "1927": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_30_1_1_60_1_28"]},
        "1928": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_26_1_1_52_1_28"]},
        "1929": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_12_1_1_24_1_28"]},
        "1930": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_4_1_1_8_1_28"]},
        "1931": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_10_1_1_20_1_28"]},
        "1932": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_5_1_1_10_1_28"]},
        "1933": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_47_1_1_33_1_28"]},
        "1934": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_59_1_1_57_1_28"]},
        "1935": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_53_1_1_45_1_28"]},
        "1936": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_57_1_1_53_1_28"]},
        "1937": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_52_1_1_43_1_28"]},
        "1938": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_41_1_1_21_1_28"]},
        "1939": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_7_1_1_14_1_28"]},
        "1940": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_58_1_1_55_1_28"]},
        "1941": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_17_1_1_34_1_28"]},
        "1942": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_48_1_1_35_1_28"]},
        "1943": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_5_1_1_10_1_28"]},
        "1944": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_52_1_1_43_1_28"]},
        "1945": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_36_1_1_11_1_28"]},
        "1946": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_8_1_1_16_1_28"]},
        "1947": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_46_1_1_31_1_28"]},
        "1948": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_55_1_1_49_1_28"]},
        "1949": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_44_1_1_27_1_28"]},
        "1950": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_3_1_1_6_1_28"]},
        "1951": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_44_1_1_27_1_28"]},
        "1952": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_4_1_1_8_1_28"]},
        "1953": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_56_1_1_51_1_28"]},
        "1954": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_49_1_1_37_1_28"]},
        "1955": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_18_1_1_36_1_28"]},
        "1956": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_22_1_1_44_1_28"]},
        "1957": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_19_1_1_38_1_28"]},
        "1958": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_60_1_1_59_1_28"]},
        "1959": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_15_1_1_30_1_28"]},
        "1960": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_56_1_1_51_1_28"]},
        "1961": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_14_1_1_28_1_28"]},
        "1962": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_39_1_1_17_1_28"]},
        "1963": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_50_1_1_39_1_28"]},
        "1964": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_41_1_1_21_1_28"]},
        "1965": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_41_1_1_21_1_28"]},
        "1966": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_15_1_1_30_1_28"]},
        "1967": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_31_1_1_1_1_28"]},
        "1968": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_32_1_1_3_1_28"]},
        "1969": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_24_1_1_48_1_28"]},
        "1970": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_22_1_1_44_1_28"]},
        "1971": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_47_1_1_33_1_28"]},
        "1972": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_43_1_1_25_1_28"]},
        "1973": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_6_1_1_12_1_28"]},
        "1974": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_55_1_1_49_1_28"]},
        "1975": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_33_1_1_5_1_28"]},
        "1976": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_43_1_1_25_1_28"]},
        "1977": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_46_1_1_31_1_28"]},
        "1978": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_41_1_1_21_1_28"]},
        "1979": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_4_1_1_8_1_28"]},
        "1980": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_2_1_1_4_1_28"]},
        "1981": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_60_1_1_59_1_28"]},
        "1982": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_52_1_1_43_1_28"]},
        "1983": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_25_1_1_50_1_28"]},
        "1984": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_42_1_1_23_1_28"]},
        "1985": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_22_1_1_44_1_28"]},
        "1986": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_60_1_1_59_1_28"]},
        "1987": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_43_1_1_25_1_28"]},
        "1988": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_9_1_1_18_1_28"]},
        "1989": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_31_1_1_1_1_28"]},
        "1990": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_48_1_1_35_1_28"]},
        "1991": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_52_1_1_43_1_28"]},
        "1992": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_57_1_1_53_1_28"]},
        "1993": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_44_1_1_27_1_28"]},
        "1994": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_24_1_1_48_1_28"]},
        "1995": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_42_1_1_23_1_28"]},
        "1996": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_8_1_1_16_1_28"]},
        "1997": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_24_1_1_48_1_28"]},
        "1998": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_2_1_1_4_1_28"]},
        "1999": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_24_1_1_48_1_28"]},
        "2000": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_10_1_1_20_1_28"]},
        "2001": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_25_1_1_50_1_28"]},
        "2002": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_54_1_1_47_1_28"]},
        "2003": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_14_1_1_28_1_28"]},
        "2004": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_44_1_1_27_1_28"]},
        "2005": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_18_1_1_36_1_28"]},
        "2006": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_31_1_1_1_1_28"]},
        "2007": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_27_1_1_54_1_28"]},
        "2008": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_51_1_1_41_1_28"]},
        "2009": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_17_1_1_34_1_28"]},
        "2010": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_9_1_1_18_1_28"]},
        "2011": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_52_1_1_43_1_28"]},
        "2012": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_10_1_1_20_1_28"]},
        "2013": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_55_1_1_49_1_28"]},
        "2014": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_22_1_1_44_1_28"]},
        "2015": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_5_1_1_10_1_28"]},
        "2016": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_38_1_1_15_1_28"]},
        "2017": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_1_1_1_2_1_28"]},
        "2018": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_41_1_1_21_1_28"]},
        "2019": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_35_1_1_9_1_28"]},
        "2020": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_52_1_1_43_1_28"]},
        "2021": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_40_1_1_19_1_28"]},
        "2022": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_39_1_1_17_1_28"]},
        "2023": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_28_1_1_56_1_28"]},
        "2024": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_47_1_1_33_1_28"]},
        "2025": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_55_1_1_49_1_28"]},
        "2026": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_36_1_1_11_1_28"]},
        "2027": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_19_1_1_38_1_28"]},
        "2028": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_14_1_1_28_1_28"]},
        "2029": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_52_1_1_43_1_28"]},
        "2030": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_10_1_1_20_1_28"]},
        "2031": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_29_1_1_58_1_28"]},
        "2032": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_40_1_1_19_1_28"]},
        "2033": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_49_1_1_37_1_28"]},
        "2034": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_17_1_1_34_1_28"]},
        "2035": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_15_1_1_30_1_28"]},
        "2036": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_45_1_1_29_1_28"]},
        "2037": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_55_1_1_49_1_28"]},
        "2038": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_30_1_1_60_1_28"]},
        "2039": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_46_1_1_31_1_28"]},
        "2040": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_10_1_1_20_1_28"]},
        "2041": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_16_1_1_32_1_28"]},
        "2042": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_25_1_1_50_1_28"]},
        "2043": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_15_1_1_30_1_28"]},
        "2044": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_55_1_1_49_1_28"]},
        "2045": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_43_1_1_25_1_28"]},
        "2046": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_11_1_1_22_1_28"]},
        "2047": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_33_1_1_5_1_28"]},
        "2048": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_52_1_1_43_1_28"]},
        "2049": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_39_1_1_17_1_28"]},
        "2050": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_21_1_1_42_1_28"]},
        "2051": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_41_1_1_21_1_28"]},
        "2052": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_29_1_1_58_1_28"]},
        "2053": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_11_1_1_22_1_28"]},
        "2054": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_35_1_1_9_1_28"]},
        "2055": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_16_1_1_32_1_28"]},
        "2056": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_1_1_1_2_1_28"]},
        "2057": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_55_1_1_49_1_28"]},
        "2058": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_52_1_1_43_1_28"]},
        "2059": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_37_1_1_13_1_28"]},
        "2060": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_15_1_1_30_1_28"]},
        "2061": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_40_1_1_19_1_28"]},
        "2062": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_10_1_1_20_1_28"]},
        "2063": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_13_1_1_26_1_28"]},
        "2064": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_11_1_1_22_1_28"]},
        "2065": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_15_1_1_30_1_28"]},
        "2066": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_7_1_1_14_1_28"]},
        "2067": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_51_1_1_41_1_28"]},
        "2068": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_48_1_1_35_1_28"]},
        "2069": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_19_1_1_38_1_28"]},
        "2070": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_52_1_1_43_1_28"]},
        "2071": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_51_1_1_41_1_28"]},
        "2072": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_7_1_1_14_1_28"]},
        "2073": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_38_1_1_15_1_28"]},
        "2074": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_42_1_1_23_1_28"]},
        "2075": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_16_1_1_32_1_28"]},
        "2076": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_25_1_1_50_1_28"]},
        "2077": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_34_1_1_7_1_28"]},
        "2078": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_26_1_1_52_1_28"]},
        "2079": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_43_1_1_25_1_28"]},
        "2080": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_60_1_1_59_1_28"]},
        "2081": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_47_1_1_33_1_28"]},
        "2082": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_38_1_1_15_1_28"]},
        "2083": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_9_1_1_18_1_28"]},
        "2084": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_16_1_1_32_1_28"]},
        "2085": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_38_1_1_15_1_28"]},
        "2086": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_26_1_1_52_1_28"]},
        "2087": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_39_1_1_17_1_28"]},
        "2088": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_12_1_1_24_1_28"]},
        "2089": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_24_1_1_48_1_28"]},
        "2090": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_23_1_1_46_1_28"]},
        "2091": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_20_1_1_40_1_28"]},
        "2092": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_25_1_1_50_1_28"]},
        "2093": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_24_1_1_48_1_28"]},
        "2094": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_27_1_1_54_1_28"]},
        "2095": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_51_1_1_41_1_28"]},
        "2096": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_20_1_1_40_1_28"]},
        "2097": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_43_1_1_25_1_28"]},
        "2098": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_9_1_1_18_1_28"]},
        "2099": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_56_1_1_51_1_28"]},
        "2100": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_58_1_1_55_1_28"]},
        "2101": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_34_1_1_7_1_28"]},
        "2102": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_42_1_1_23_1_28"]},
        "2103": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_19_1_1_38_1_28"]},
        "2104": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_2_1_1_4_1_28"]},
        "2105": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_46_1_1_31_1_28"]},
        "2106": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_30_1_1_60_1_28"]},
        "2107": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_23_1_1_46_1_28"]},
        "2108": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_31_1_1_1_1_28"]},
        "2109": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_3_1_1_6_1_28"]},
        "2110": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_54_1_1_47_1_28"]},
        "2111": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_17_1_1_34_1_28"]},
        "2112": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_60_1_1_59_1_28"]},
        "2113": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_50_1_1_39_1_28"]},
        "2114": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_28_1_1_56_1_28"]},
        "2115": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_29_1_1_58_1_28"]},
        "2116": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_5_1_1_10_1_28"]},
        "2117": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_53_1_1_45_1_28"]},
        "2118": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_48_1_1_35_1_28"]},
        "2119": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_1_1_1_2_1_28"]},
        "2120": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_29_1_1_58_1_28"]},
        "2121": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_19_1_1_38_1_28"]},
        "2122": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_22_1_1_44_1_28"]},
        "2123": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_56_1_1_51_1_28"]},
        "2124": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_36_1_1_11_1_28"]},
        "2125": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_49_1_1_37_1_28"]},
        "2126": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_47_1_1_33_1_28"]},
        "2127": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_11_1_1_22_1_28"]},
        "2128": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_24_1_1_48_1_28"]},
        "2129": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_11_1_1_22_1_28"]},
        "2130": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_9_1_1_18_1_28"]},
        "2131": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_16_1_1_32_1_28"]},
        "2132": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_46_1_1_31_1_28"]},
        "2133": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_57_1_1_53_1_28"]},
        "2134": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_13_1_1_26_1_28"]},
        "2135": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_36_1_1_11_1_28"]},
        "2136": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_24_1_1_48_1_28"]},
        "2137": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_5_1_1_10_1_28"]},
        "2138": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_16_1_1_32_1_28"]},
        "2139": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_26_1_1_52_1_28"]},
        "2140": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_1_1_1_2_1_28"]},
        "2141": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_20_1_1_40_1_28"]},
        "2142": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_52_1_1_43_1_28"]},
        "2143": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_50_1_1_39_1_28"]},
        "2144": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_40_1_1_19_1_28"]},
        "2145": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_51_1_1_41_1_28"]},
        "2146": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_20_1_1_40_1_28"]},
        "2147": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_26_1_1_52_1_28"]},
        "2148": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_33_1_1_5_1_28"]},
        "2149": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_49_1_1_37_1_28"]},
        "2150": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_49_1_1_37_1_28"]},
        "2151": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_31_1_1_1_1_28"]},
        "2152": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_52_1_1_43_1_28"]},
        "2153": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_57_1_1_53_1_28"]},
        "2154": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_48_1_1_35_1_28"]},
        "2155": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_9_1_1_18_1_28"]},
        "2156": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_42_1_1_23_1_28"]},
        "2157": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_10_1_1_20_1_28"]},
        "2158": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_18_1_1_36_1_28"]},
        "2159": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_37_1_1_13_1_28"]},
        "2160": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_56_1_1_51_1_28"]},
        "2161": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_43_1_1_25_1_28"]},
        "2162": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_22_1_1_44_1_28"]},
        "2163": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_14_1_1_28_1_28"]},
        "2164": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_49_1_1_37_1_28"]},
        "2165": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_2_1_1_4_1_28"]},
        "2166": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_8_1_1_16_1_28"]},
        "2167": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_6_1_1_12_1_28"]},
        "2168": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_1_1_1_2_1_28"]},
        "2169": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_10_1_1_20_1_28"]},
        "2170": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_45_1_1_29_1_28"]},
        "2171": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_50_1_1_39_1_28"]},
        "2172": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_38_1_1_15_1_28"]},
        "2173": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_38_1_1_15_1_28"]},
        "2174": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_56_1_1_51_1_28"]},
        "2175": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_50_1_1_39_1_28"]},
        "2176": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_58_1_1_55_1_28"]},
        "2177": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_47_1_1_33_1_28"]},
        "2178": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_31_1_1_1_1_28"]},
        "2179": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_38_1_1_15_1_28"]},
        "2180": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_22_1_1_44_1_28"]},
        "2181": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_24_1_1_48_1_28"]},
        "2182": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_15_1_1_30_1_28"]},
        "2183": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_11_1_1_22_1_28"]},
        "2184": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_36_1_1_11_1_28"]},
        "2185": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_27_1_1_54_1_28"]},
        "2186": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_27_1_1_54_1_28"]},
        "2187": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_1_1_1_2_1_28"]},
        "2188": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_13_1_1_26_1_28"]},
        "2189": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_43_1_1_25_1_28"]},
        "2190": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_39_1_1_17_1_28"]},
        "2191": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_28_1_1_56_1_28"]},
        "2192": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_5_1_1_10_1_28"]},
        "2193": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_57_1_1_53_1_28"]},
        "2194": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_25_1_1_50_1_28"]},
        "2195": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_41_1_1_21_1_28"]},
        "2196": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_45_1_1_29_1_28"]},
        "2197": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_15_1_1_30_1_28"]},
        "2198": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_27_1_1_54_1_28"]},
        "2199": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_35_1_1_9_1_28"]},
        "2200": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_5_1_1_10_1_28"]},
        "2201": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_1_1_1_2_1_28"]},
        "2202": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_1_1_1_2_1_28"]},
        "2203": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_9_1_1_18_1_28"]},
        "2204": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_22_1_1_44_1_28"]},
        "2205": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_8_1_1_16_1_28"]},
        "2206": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_5_1_1_10_1_28"]},
        "2207": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_48_1_1_35_1_28"]},
        "2208": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_21_1_1_42_1_28"]},
        "2209": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_37_1_1_13_1_28"]},
        "2210": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_37_1_1_13_1_28"]},
        "2211": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_1_1_1_2_1_28"]},
        "2212": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_10_1_1_20_1_28"]},
        "2213": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_55_1_1_49_1_28"]},
        "2214": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_48_1_1_35_1_28"]},
        "2215": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_48_1_1_35_1_28"]},
        "2216": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_9_1_1_18_1_28"]},
        "2217": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_19_1_1_38_1_28"]},
        "2218": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_17_1_1_34_1_28"]},
        "2219": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_27_1_1_54_1_28"]},
        "2220": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_39_1_1_17_1_28"]},
        "2221": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_27_1_1_54_1_28"]},
        "2222": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_10_1_1_20_1_28"]},
        "2223": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_56_1_1_51_1_28"]},
        "2224": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_53_1_1_45_1_28"]},
        "2225": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_60_1_1_59_1_28"]},
        "2226": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_37_1_1_13_1_28"]},
        "2227": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_49_1_1_37_1_28"]},
        "2228": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_51_1_1_41_1_28"]},
        "2229": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_60_1_1_59_1_28"]},
        "2230": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_59_1_1_57_1_28"]},
        "2231": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_30_1_1_60_1_28"]},
        "2232": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_18_1_1_36_1_28"]},
        "2233": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_48_1_1_35_1_28"]},
        "2234": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_21_1_1_42_1_28"]},
        "2235": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_14_1_1_28_1_28"]},
        "2236": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_25_1_1_50_1_28"]},
        "2237": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_48_1_1_35_1_28"]},
        "2238": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_1_1_1_2_1_28"]},
        "2239": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_42_1_1_23_1_28"]},
        "2240": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_20_1_1_40_1_28"]},
        "2241": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_58_1_1_55_1_28"]},
        "2242": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_43_1_1_25_1_28"]},
        "2243": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_6_1_1_12_1_28"]},
        "2244": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_20_1_1_40_1_28"]},
        "2245": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_44_1_1_27_1_28"]},
        "2246": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_24_1_1_48_1_28"]},
        "2247": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_31_1_1_1_1_28"]},
        "2248": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_22_1_1_44_1_28"]},
        "2249": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_4_1_1_8_1_28"]},
        "2250": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_59_1_1_57_1_28"]},
        "2251": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_20_1_1_40_1_28"]},
        "2252": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_32_1_1_3_1_28"]},
        "2253": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_10_1_1_20_1_28"]},
        "2254": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_52_1_1_43_1_28"]},
        "2255": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_27_1_1_54_1_28"]},
        "2256": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_3_1_1_6_1_28"]},
        "2257": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_56_1_1_51_1_28"]},
        "2258": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_12_1_1_24_1_28"]},
        "2259": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_19_1_1_38_1_28"]},
        "2260": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_2_1_1_4_1_28"]},
        "2261": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_12_1_1_24_1_28"]},
        "2262": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_26_1_1_52_1_28"]},
        "2263": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_34_1_1_7_1_28"]},
        "2264": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_23_1_1_46_1_28"]},
        "2265": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_48_1_1_35_1_28"]},
        "2266": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_39_1_1_17_1_28"]},
        "2267": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_29_1_1_58_1_28"]},
        "2268": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_59_1_1_57_1_28"]},
        "2269": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_3_1_1_6_1_28"]},
        "2270": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_24_1_1_48_1_28"]},
        "2271": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_14_1_1_28_1_28"]},
        "2272": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_25_1_1_50_1_28"]},
        "2273": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_26_1_1_52_1_28"]},
        "2274": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_45_1_1_29_1_28"]},
        "2275": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_51_1_1_41_1_28"]},
        "2276": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_34_1_1_7_1_28"]},
        "2277": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_26_1_1_52_1_28"]},
        "2278": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_35_1_1_9_1_28"]},
        "2279": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_8_1_1_16_1_28"]},
        "2280": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_25_1_1_50_1_28"]},
        "2281": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_29_1_1_58_1_28"]},
        "2282": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_39_1_1_17_1_28"]},
        "2283": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_52_1_1_43_1_28"]},
        "2284": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_33_1_1_5_1_28"]},
        "2285": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_7_1_1_14_1_28"]},
        "2286": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_13_1_1_26_1_28"]},
        "2287": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_30_1_1_60_1_28"]},
        "2288": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_26_1_1_52_1_28"]},
        "2289": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_39_1_1_17_1_28"]},
        "2290": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_19_1_1_38_1_28"]},
        "2291": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_41_1_1_21_1_28"]},
        "2292": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_15_1_1_30_1_28"]},
        "2293": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_45_1_1_29_1_28"]},
        "2294": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_15_1_1_30_1_28"]},
        "2295": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_27_1_1_54_1_28"]},
        "2296": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_5_1_1_10_1_28"]},
        "2297": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_42_1_1_23_1_28"]},
        "2298": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_29_1_1_58_1_28"]},
        "2299": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_31_1_1_1_1_28"]},
        "2300": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_43_1_1_25_1_28"]},
        "2301": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_40_1_1_19_1_28"]},
        "2302": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_51_1_1_41_1_28"]},
        "2303": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_21_1_1_42_1_28"]},
        "2304": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_13_1_1_26_1_28"]},
        "2305": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_27_1_1_54_1_28"]},
        "2306": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_2_1_1_4_1_28"]},
        "2307": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_54_1_1_47_1_28"]},
        "2308": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_26_1_1_52_1_28"]},
        "2309": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_26_1_1_52_1_28"]},
        "2310": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_25_1_1_50_1_28"]},
        "2311": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_24_1_1_48_1_28"]},
        "2312": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_57_1_1_53_1_28"]},
        "2313": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_6_1_1_12_1_28"]},
        "2314": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_31_1_1_1_1_28"]},
        "2315": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_32_1_1_3_1_28"]},
        "2316": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_47_1_1_33_1_28"]},
        "2317": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_15_1_1_30_1_28"]},
        "2318": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_31_1_1_1_1_28"]},
        "2319": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_50_1_1_39_1_28"]},
        "2320": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_56_1_1_51_1_28"]},
        "2321": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_6_1_1_12_1_28"]},
        "2322": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_40_1_1_19_1_28"]},
        "2323": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_20_1_1_40_1_28"]},
        "2324": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_25_1_1_50_1_28"]},
        "2325": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_8_1_1_16_1_28"]},
        "2326": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_54_1_1_47_1_28"]},
        "2327": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_32_1_1_3_1_28"]},
        "2328": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_21_1_1_42_1_28"]},
        "2329": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_31_1_1_1_1_28"]},
        "2330": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_8_1_1_16_1_28"]},
        "2331": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_17_1_1_34_1_28"]},
        "2332": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_26_1_1_52_1_28"]},
        "2333": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_51_1_1_41_1_28"]},
        "2334": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_16_1_1_32_1_28"]},
        "2335": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_58_1_1_55_1_28"]},
        "2336": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_6_1_1_12_1_28"]},
        "2337": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_53_1_1_45_1_28"]},
        "2338": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_25_1_1_50_1_28"]},
        "2339": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_8_1_1_16_1_28"]},
        "2340": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_42_1_1_23_1_28"]},
        "2341": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_35_1_1_9_1_28"]},
        "2342": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_44_1_1_27_1_28"]},
        "2343": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_12_1_1_24_1_28"]},
        "2344": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_43_1_1_25_1_28"]},
        "2345": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_43_1_1_25_1_28"]},
        "2346": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_38_1_1_15_1_28"]},
        "2347": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_49_1_1_37_1_28"]},
        "2348": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_3_1_1_6_1_28"]},
        "2349": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_34_1_1_7_1_28"]},
        "2350": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_18_1_1_36_1_28"]},
        "2351": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_40_1_1_19_1_28"]},
        "2352": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_47_1_1_33_1_28"]},
        "2353": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_40_1_1_19_1_28"]},
        "2354": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_20_1_1_40_1_28"]},
        "2355": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_53_1_1_45_1_28"]},
        "2356": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_36_1_1_11_1_28"]},
        "2357": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_53_1_1_45_1_28"]},
        "2358": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_38_1_1_15_1_28"]},
        "2359": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_30_1_1_60_1_28"]},
        "2360": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_26_1_1_52_1_28"]},
        "2361": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_11_1_1_22_1_28"]},
        "2362": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_51_1_1_41_1_28"]},
        "2363": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_20_1_1_40_1_28"]},
        "2364": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_27_1_1_54_1_28"]},
        "2365": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_47_1_1_33_1_28"]},
        "2366": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_46_1_1_31_1_28"]},
        "2367": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_22_1_1_44_1_28"]},
        "2368": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_51_1_1_41_1_28"]},
        "2369": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_22_1_1_44_1_28"]},
        "2370": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_50_1_1_39_1_28"]},
        "2371": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_47_1_1_33_1_28"]},
        "2372": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_58_1_1_55_1_28"]},
        "2373": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_15_1_1_30_1_28"]},
        "2374": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_27_1_1_54_1_28"]},
        "2375": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_1_1_1_2_1_28"]},
        "2376": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_41_1_1_21_1_28"]},
        "2377": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_46_1_1_31_1_28"]},
        "2378": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_30_1_1_60_1_28"]},
        "2379": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_47_1_1_33_1_28"]},
        "2380": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_1_1_1_2_1_28"]},
        "2381": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_49_1_1_37_1_28"]},
        "2382": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_38_1_1_15_1_28"]},
        "2383": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_4_1_1_8_1_28"]},
        "2384": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_6_1_1_12_1_28"]},
        "2385": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_35_1_1_9_1_28"]},
        "2386": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_59_1_1_57_1_28"]},
        "2387": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_43_1_1_25_1_28"]},
        "2388": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_59_1_1_57_1_28"]},
        "2389": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_25_1_1_50_1_28"]},
        "2390": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_37_1_1_13_1_28"]},
        "2391": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_60_1_1_59_1_28"]},
        "2392": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_54_1_1_47_1_28"]},
        "2393": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_13_1_1_26_1_28"]},
        "2394": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_9_1_1_18_1_28"]},
        "2395": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_29_1_1_58_1_28"]},
        "2396": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_4_1_1_8_1_28"]},
        "2397": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_54_1_1_47_1_28"]},
        "2398": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_52_1_1_43_1_28"]},
        "2399": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_41_1_1_21_1_28"]},
        "2400": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_6_1_1_12_1_28"]},
        "2401": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_29_1_1_58_1_28"]},
        "2402": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_47_1_1_33_1_28"]},
        "2403": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_46_1_1_31_1_28"]},
        "2404": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_16_1_1_32_1_28"]},
        "2405": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_50_1_1_39_1_28"]},
        "2406": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_23_1_1_46_1_28"]},
        "2407": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_10_1_1_20_1_28"]},
        "2408": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_22_1_1_44_1_28"]},
        "2409": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_3_1_1_6_1_28"]},
        "2410": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_42_1_1_23_1_28"]},
        "2411": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_47_1_1_33_1_28"]},
        "2412": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_32_1_1_3_1_28"]},
        "2413": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_41_1_1_21_1_28"]},
        "2414": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_33_1_1_5_1_28"]},
        "2415": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_60_1_1_59_1_28"]},
        "2416": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_51_1_1_41_1_28"]},
        "2417": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_47_1_1_33_1_28"]},
        "2418": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_3_1_1_6_1_28"]},
        "2419": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_59_1_1_57_1_28"]},
        "2420": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_3_1_1_6_1_28"]},
        "2421": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_40_1_1_19_1_28"]},
        "2422": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_41_1_1_21_1_28"]},
        "2423": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_57_1_1_53_1_28"]},
        "2424": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_3_1_1_6_1_28"]},
        "2425": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_7_1_1_14_1_28"]},
        "2426": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_19_1_1_38_1_28"]},
        "2427": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_36_1_1_11_1_28"]},
        "2428": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_35_1_1_9_1_28"]},
        "2429": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_20_1_1_40_1_28"]},
        "2430": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_52_1_1_43_1_28"]},
        "2431": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_34_1_1_7_1_28"]},
        "2432": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_55_1_1_49_1_28"]},
        "2433": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_18_1_1_36_1_28"]},
        "2434": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_25_1_1_50_1_28"]},
        "2435": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_57_1_1_53_1_28"]},
        "2436": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_41_1_1_21_1_28"]},
        "2437": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_44_1_1_27_1_28"]},
        "2438": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_39_1_1_17_1_28"]},
        "2439": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_44_1_1_27_1_28"]},
        "2440": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_47_1_1_33_1_28"]},
        "2441": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_47_1_1_33_1_28"]},
        "2442": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_60_1_1_59_1_28"]},
        "2443": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_43_1_1_25_1_28"]},
        "2444": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_38_1_1_15_1_28"]},
        "2445": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_51_1_1_41_1_28"]},
        "2446": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_8_1_1_16_1_28"]},
        "2447": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_34_1_1_7_1_28"]},
        "2448": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_38_1_1_15_1_28"]},
        "2449": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_56_1_1_51_1_28"]},
        "2450": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_13_1_1_26_1_28"]},
        "2451": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_13_1_1_26_1_28"]},
        "2452": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_13_1_1_26_1_28"]},
        "2453": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_42_1_1_23_1_28"]},
        "2454": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_14_1_1_28_1_28"]},
        "2455": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_28_1_1_56_1_28"]},
        "2456": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_24_1_1_48_1_28"]},
        "2457": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_47_1_1_33_1_28"]},
        "2458": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_39_1_1_17_1_28"]},
        "2459": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_36_1_1_11_1_28"]},
        "2460": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_16_1_1_32_1_28"]},
        "2461": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_7_1_1_14_1_28"]},
        "2462": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_22_1_1_44_1_28"]},
        "2463": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_12_1_1_24_1_28"]},
        "2464": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_41_1_1_21_1_28"]},
        "2465": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_7_1_1_14_1_28"]},
        "2466": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_58_1_1_55_1_28"]},
        "2467": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_11_1_1_22_1_28"]},
        "2468": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_9_1_1_18_1_28"]},
        "2469": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_21_1_1_42_1_28"]},
        "2470": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_35_1_1_9_1_28"]},
        "2471": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_19_1_1_38_1_28"]},
        "2472": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_15_1_1_30_1_28"]},
        "2473": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_32_1_1_3_1_28"]},
        "2474": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_58_1_1_55_1_28"]},
        "2475": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_30_1_1_60_1_28"]},
        "2476": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_49_1_1_37_1_28"]},
        "2477": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_48_1_1_35_1_28"]},
        "2478": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_45_1_1_29_1_28"]},
        "2479": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_11_1_1_22_1_28"]},
        "2480": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_28_1_1_56_1_28"]},
        "2481": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_51_1_1_41_1_28"]},
        "2482": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_33_1_1_5_1_28"]},
        "2483": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_50_1_1_39_1_28"]},
        "2484": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_27_1_1_54_1_28"]},
        "2485": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_38_1_1_15_1_28"]},
        "2486": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_23_1_1_46_1_28"]},
        "2487": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_59_1_1_57_1_28"]},
        "2488": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_57_1_1_53_1_28"]},
        "2489": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_41_1_1_21_1_28"]},
        "2490": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_46_1_1_31_1_28"]},
        "2491": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_54_1_1_47_1_28"]},
        "2492": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_46_1_1_31_1_28"]},
        "2493": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_18_1_1_36_1_28"]},
        "2494": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_56_1_1_51_1_28"]},
        "2495": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_21_1_1_42_1_28"]},
        "2496": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_11_1_1_22_1_28"]},
        "2497": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_46_1_1_31_1_28"]},
        "2498": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_43_1_1_25_1_28"]},
        "2499": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_44_1_1_27_1_28"]},
        "2500": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_51_1_1_41_1_28"]},
        "2501": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_30_1_1_60_1_28"]},
        "2502": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_39_1_1_17_1_28"]},
        "2503": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_51_1_1_41_1_28"]},
        "2504": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_12_1_1_24_1_28"]},
        "2505": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_27_1_1_54_1_28"]},
        "2506": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_31_1_1_1_1_28"]},
        "2507": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_16_1_1_32_1_28"]},
        "2508": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_53_1_1_45_1_28"]},
        "2509": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_55_1_1_49_1_28"]},
        "2510": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_60_1_1_59_1_28"]},
        "2511": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_14_1_1_28_1_28"]},
        "2512": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_20_1_1_40_1_28"]},
        "2513": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_13_1_1_26_1_28"]},
        "2514": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_3_1_1_6_1_28"]},
        "2515": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_56_1_1_51_1_28"]},
        "2516": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_13_1_1_26_1_28"]},
        "2517": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_1_1_1_2_1_28"]},
        "2518": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_13_1_1_26_1_28"]},
        "2519": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_7_1_1_14_1_28"]},
        "2520": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_31_1_1_1_1_28"]},
        "2521": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_52_1_1_43_1_28"]},
        "2522": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_12_1_1_24_1_28"]},
        "2523": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_9_1_1_18_1_28"]},
        "2524": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_44_1_1_27_1_28"]},
        "2525": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_39_1_1_17_1_28"]},
        "2526": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_11_1_1_22_1_28"]},
        "2527": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_2_1_1_4_1_28"]},
        "2528": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_56_1_1_51_1_28"]},
        "2529": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_48_1_1_35_1_28"]},
        "2530": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_58_1_1_55_1_28"]},
        "2531": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_27_1_1_54_1_28"]},
        "2532": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_17_1_1_34_1_28"]},
        "2533": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_30_1_1_60_1_28"]},
        "2534": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_58_1_1_55_1_28"]},
        "2535": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_22_1_1_44_1_28"]},
        "2536": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_57_1_1_53_1_28"]},
        "2537": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_54_1_1_47_1_28"]},
        "2538": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_2_1_1_4_1_28"]},
        "2539": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_5_1_1_10_1_28"]},
        "2540": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_6_1_1_12_1_28"]},
        "2541": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_30_1_1_60_1_28"]},
        "2542": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_37_1_1_13_1_28"]},
        "2543": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_34_1_1_7_1_28"]},
        "2544": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_55_1_1_49_1_28"]},
        "2545": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_38_1_1_15_1_28"]},
        "2546": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_13_1_1_26_1_28"]},
        "2547": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_46_1_1_31_1_28"]},
        "2548": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_14_1_1_28_1_28"]},
        "2549": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_28_1_1_56_1_28"]},
        "2550": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_10_1_1_20_1_28"]},
        "2551": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_21_1_1_42_1_28"]},
        "2552": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_19_1_1_38_1_28"]},
        "2553": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_54_1_1_47_1_28"]},
        "2554": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_49_1_1_37_1_28"]},
        "2555": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_40_1_1_19_1_28"]},
        "2556": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_28_1_1_56_1_28"]},
        "2557": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_40_1_1_19_1_28"]},
        "2558": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_59_1_1_57_1_28"]},
        "2559": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_31_1_1_1_1_28"]},
        "2560": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_18_1_1_36_1_28"]},
        "2561": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_23_1_1_46_1_28"]},
        "2562": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_7_1_1_14_1_28"]},
        "2563": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_37_1_1_13_1_28"]},
        "2564": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_20_1_1_40_1_28"]},
        "2565": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_46_1_1_31_1_28"]},
        "2566": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_49_1_1_37_1_28"]},
        "2567": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_54_1_1_47_1_28"]},
        "2568": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_5_1_1_10_1_28"]},
        "2569": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_11_1_1_22_1_28"]},
        "2570": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_45_1_1_29_1_28"]},
        "2571": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_36_1_1_11_1_28"]},
        "2572": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_57_1_1_53_1_28"]},
        "2573": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_19_1_1_38_1_28"]},
        "2574": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_10_1_1_20_1_28"]},
        "2575": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_35_1_1_9_1_28"]},
        "2576": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_28_1_1_56_1_28"]},
        "2577": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_22_1_1_44_1_28"]},
        "2578": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_11_1_1_22_1_28"]},
        "2579": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_5_1_1_10_1_28"]},
        "2580": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_51_1_1_41_1_28"]},
        "2581": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_36_1_1_11_1_28"]},
        "2582": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_59_1_1_57_1_28"]},
        "2583": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_44_1_1_27_1_28"]},
        "2584": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_47_1_1_33_1_28"]},
        "2585": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_56_1_1_51_1_28"]},
        "2586": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_60_1_1_59_1_28"]},
        "2587": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_35_1_1_9_1_28"]},
        "2588": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_44_1_1_27_1_28"]},
        "2589": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_46_1_1_31_1_28"]},
        "2590": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_52_1_1_43_1_28"]},
        "2591": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_9_1_1_18_1_28"]},
        "2592": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_48_1_1_35_1_28"]},
        "2593": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_60_1_1_59_1_28"]},
        "2594": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_5_1_1_10_1_28"]},
        "2595": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_7_1_1_14_1_28"]},
        "2596": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_59_1_1_57_1_28"]},
        "2597": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_27_1_1_54_1_28"]},
        "2598": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_6_1_1_12_1_28"]},
        "2599": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_35_1_1_9_1_28"]},
        "2600": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_19_1_1_38_1_28"]},
        "2601": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_21_1_1_42_1_28"]},
        "2602": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_52_1_1_43_1_28"]},
        "2603": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_23_1_1_46_1_28"]},
        "2604": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_46_1_1_31_1_28"]},
        "2605": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_52_1_1_43_1_28"]},
        "2606": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_14_1_1_28_1_28"]},
        "2607": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_57_1_1_53_1_28"]},
        "2608": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_3_1_1_6_1_28"]},
        "2609": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_7_1_1_14_1_28"]},
        "2610": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_49_1_1_37_1_28"]},
        "2611": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_19_1_1_38_1_28"]},
        "2612": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_19_1_1_38_1_28"]},
        "2613": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_20_1_1_40_1_28"]},
        "2614": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_20_1_1_40_1_28"]},
        "2615": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_35_1_1_9_1_28"]},
        "2616": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_9_1_1_18_1_28"]},
        "2617": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_48_1_1_35_1_28"]},
        "2618": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_34_1_1_7_1_28"]},
        "2619": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_49_1_1_37_1_28"]},
        "2620": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_33_1_1_5_1_28"]},
        "2621": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_8_1_1_16_1_28"]},
        "2622": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_14_1_1_28_1_28"]},
        "2623": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_10_1_1_20_1_28"]},
        "2624": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_6_1_1_12_1_28"]},
        "2625": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_19_1_1_38_1_28"]},
        "2626": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_20_1_1_40_1_28"]},
        "2627": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_55_1_1_49_1_28"]},
        "2628": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_11_1_1_22_1_28"]},
        "2629": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_53_1_1_45_1_28"]},
        "2630": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_4_1_1_8_1_28"]},
        "2631": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_53_1_1_45_1_28"]},
        "2632": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_25_1_1_50_1_28"]},
        "2633": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_45_1_1_29_1_28"]},
        "2634": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_56_1_1_51_1_28"]},
        "2635": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_18_1_1_36_1_28"]},
        "2636": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_33_1_1_5_1_28"]},
        "2637": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_46_1_1_31_1_28"]},
        "2638": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_16_1_1_32_1_28"]},
        "2639": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_17_1_1_34_1_28"]},
        "2640": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_46_1_1_31_1_28"]},
        "2641": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_1_1_1_2_1_28"]},
        "2642": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_37_1_1_13_1_28"]},
        "2643": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_33_1_1_5_1_28"]},
        "2644": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_5_1_1_10_1_28"]},
        "2645": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_41_1_1_21_1_28"]},
        "2646": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_48_1_1_35_1_28"]},
        "2647": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_5_1_1_10_1_28"]},
        "2648": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_28_1_1_56_1_28"]},
        "2649": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_32_1_1_3_1_28"]},
        "2650": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_34_1_1_7_1_28"]},
        "2651": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_59_1_1_57_1_28"]},
        "2652": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_5_1_1_10_1_28"]},
        "2653": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_52_1_1_43_1_28"]},
        "2654": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_16_1_1_32_1_28"]},
        "2655": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_53_1_1_45_1_28"]},
        "2656": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_53_1_1_45_1_28"]},
        "2657": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_35_1_1_9_1_28"]},
        "2658": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_53_1_1_45_1_28"]},
        "2659": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_35_1_1_9_1_28"]},
        "2660": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_20_1_1_40_1_28"]},
        "2661": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_29_1_1_58_1_28"]},
        "2662": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_21_1_1_42_1_28"]},
        "2663": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_39_1_1_17_1_28"]},
        "2664": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_13_1_1_26_1_28"]},
        "2665": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_59_1_1_57_1_28"]},
        "2666": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_12_1_1_24_1_28"]},
        "2667": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_16_1_1_32_1_28"]},
        "2668": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_29_1_1_58_1_28"]},
        "2669": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_35_1_1_9_1_28"]},
        "2670": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_23_1_1_46_1_28"]},
        "2671": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_4_1_1_8_1_28"]},
        "2672": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_59_1_1_57_1_28"]},
        "2673": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_34_1_1_7_1_28"]},
        "2674": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_56_1_1_51_1_28"]},
        "2675": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_52_1_1_43_1_28"]},
        "2676": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_10_1_1_20_1_28"]},
        "2677": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_49_1_1_37_1_28"]},
        "2678": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_6_1_1_12_1_28"]},
        "2679": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_46_1_1_31_1_28"]},
        "2680": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_60_1_1_59_1_28"]},
        "2681": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_43_1_1_25_1_28"]},
        "2682": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_49_1_1_37_1_28"]},
        "2683": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_20_1_1_40_1_28"]},
        "2684": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_42_1_1_23_1_28"]},
        "2685": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_50_1_1_39_1_28"]},
        "2686": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_22_1_1_44_1_28"]},
        "2687": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_53_1_1_45_1_28"]},
        "2688": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_14_1_1_28_1_28"]},
        "2689": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_45_1_1_29_1_28"]},
        "2690": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_21_1_1_42_1_28"]},
        "2691": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_36_1_1_11_1_28"]},
        "2692": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_43_1_1_25_1_28"]},
        "2693": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_19_1_1_38_1_28"]},
        "2694": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_55_1_1_49_1_28"]},
        "2695": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_32_1_1_3_1_28"]},
        "2696": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_21_1_1_42_1_28"]},
        "2697": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_30_1_1_60_1_28"]},
        "2698": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_25_1_1_50_1_28"]},
        "2699": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_12_1_1_24_1_28"]},
        "2700": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_3_1_1_6_1_28"]},
        "2701": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_18_1_1_36_1_28"]},
        "2702": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_59_1_1_57_1_28"]},
        "2703": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_17_1_1_34_1_28"]},
        "2704": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_37_1_1_13_1_28"]},
        "2705": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_12_1_1_24_1_28"]},
        "2706": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_55_1_1_49_1_28"]},
        "2707": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_33_1_1_5_1_28"]},
        "2708": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_5_1_1_10_1_28"]},
        "2709": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_54_1_1_47_1_28"]},
        "2710": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_3_1_1_6_1_28"]},
        "2711": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_36_1_1_11_1_28"]},
        "2712": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_11_1_1_22_1_28"]},
        "2713": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_24_1_1_48_1_28"]},
        "2714": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_60_1_1_59_1_28"]},
        "2715": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_55_1_1_49_1_28"]},
        "2716": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_36_1_1_11_1_28"]},
        "2717": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_15_1_1_30_1_28"]},
        "2718": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_36_1_1_11_1_28"]},
        "2719": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_18_1_1_36_1_28"]},
        "2720": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_1_1_1_2_1_28"]},
        "2721": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_19_1_1_38_1_28"]},
        "2722": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_50_1_1_39_1_28"]},
        "2723": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_8_1_1_16_1_28"]},
        "2724": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_37_1_1_13_1_28"]},
        "2725": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_8_1_1_16_1_28"]},
        "2726": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_20_1_1_40_1_28"]},
        "2727": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_50_1_1_39_1_28"]},
        "2728": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_42_1_1_23_1_28"]},
        "2729": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_59_1_1_57_1_28"]},
        "2730": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_38_1_1_15_1_28"]},
        "2731": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_29_1_1_58_1_28"]},
        "2732": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_14_1_1_28_1_28"]},
        "2733": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_38_1_1_15_1_28"]},
        "2734": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_58_1_1_55_1_28"]},
        "2735": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_25_1_1_50_1_28"]},
        "2736": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_40_1_1_19_1_28"]},
        "2737": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_4_1_1_8_1_28"]},
        "2738": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_35_1_1_9_1_28"]},
        "2739": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_26_1_1_52_1_28"]},
        "2740": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_48_1_1_35_1_28"]},
        "2741": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_19_1_1_38_1_28"]},
        "2742": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_19_1_1_38_1_28"]},
        "2743": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_43_1_1_25_1_28"]},
        "2744": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_13_1_1_26_1_28"]},
        "2745": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_25_1_1_50_1_28"]},
        "2746": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_22_1_1_44_1_28"]},
        "2747": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_16_1_1_32_1_28"]},
        "2748": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_57_1_1_53_1_28"]},
        "2749": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_57_1_1_53_1_28"]},
        "2750": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_10_1_1_20_1_28"]},
        "2751": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_11_1_1_22_1_28"]},
        "2752": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_31_1_1_1_1_28"]},
        "2753": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_45_1_1_29_1_28"]},
        "2754": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_29_1_1_58_1_28"]},
        "2755": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_51_1_1_41_1_28"]},
        "2756": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_29_1_1_58_1_28"]},
        "2757": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_22_1_1_44_1_28"]},
        "2758": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_3_1_1_6_1_28"]},
        "2759": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_16_1_1_32_1_28"]},
        "2760": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_21_1_1_42_1_28"]},
        "2761": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_55_1_1_49_1_28"]},
        "2762": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_8_1_1_16_1_28"]},
        "2763": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_58_1_1_55_1_28"]},
        "2764": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_23_1_1_46_1_28"]},
        "2765": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_2_1_1_4_1_28"]},
        "2766": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_37_1_1_13_1_28"]},
        "2767": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_14_1_1_28_1_28"]},
        "2768": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_15_1_1_30_1_28"]},
        "2769": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_35_1_1_9_1_28"]},
        "2770": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_12_1_1_24_1_28"]},
        "2771": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_29_1_1_58_1_28"]},
        "2772": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_6_1_1_12_1_28"]},
        "2773": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_36_1_1_11_1_28"]},
        "2774": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_2_1_1_4_1_28"]},
        "2775": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_10_1_1_20_1_28"]},
        "2776": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_43_1_1_25_1_28"]},
        "2777": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_39_1_1_17_1_28"]},
        "2778": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_10_1_1_20_1_28"]},
        "2779": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_44_1_1_27_1_28"]},
        "2780": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_58_1_1_55_1_28"]},
        "2781": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_16_1_1_32_1_28"]},
        "2782": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_54_1_1_47_1_28"]},
        "2783": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_28_1_1_56_1_28"]},
        "2784": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_60_1_1_59_1_28"]},
        "2785": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_6_1_1_12_1_28"]},
        "2786": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_10_1_1_20_1_28"]},
        "2787": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_17_1_1_34_1_28"]},
        "2788": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_32_1_1_3_1_28"]},
        "2789": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_12_1_1_24_1_28"]},
        "2790": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_20_1_1_40_1_28"]},
        "2791": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_6_1_1_12_1_28"]},
        "2792": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_19_1_1_38_1_28"]},
        "2793": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_1_1_1_2_1_28"]},
        "2794": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_12_1_1_24_1_28"]},
        "2795": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_31_1_1_1_1_28"]},
        "2796": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_59_1_1_57_1_28"]},
        "2797": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_52_1_1_43_1_28"]},
        "2798": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_38_1_1_15_1_28"]},
        "2799": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_3_1_1_6_1_28"]},
        "2800": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_11_1_1_22_1_28"]},
        "2801": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_30_1_1_60_1_28"]},
        "2802": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_4_1_1_8_1_28"]},
        "2803": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_13_1_1_26_1_28"]},
        "2804": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_35_1_1_9_1_28"]},
        "2805": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_29_1_1_58_1_28"]},
        "2806": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_2_1_1_4_1_28"]},
        "2807": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_23_1_1_46_1_28"]},
        "2808": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_24_1_1_48_1_28"]},
        "2809": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_1_1_1_2_1_28"]},
        "2810": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_52_1_1_43_1_28"]},
        "2811": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_59_1_1_57_1_28"]},
        "2812": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_18_1_1_36_1_28"]},
        "2813": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_38_1_1_15_1_28"]},
        "2814": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_36_1_1_11_1_28"]},
        "2815": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_27_1_1_54_1_28"]},
        "2816": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_14_1_1_28_1_28"]},
        "2817": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_14_1_1_28_1_28"]},
        "2818": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_24_1_1_48_1_28"]},
        "2819": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_4_1_1_8_1_28"]},
        "2820": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_13_1_1_26_1_28"]},
        "2821": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_22_1_1_44_1_28"]},
        "2822": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_2_1_1_4_1_28"]},
        "2823": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_56_1_1_51_1_28"]},
        "2824": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_60_1_1_59_1_28"]},
        "2825": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_55_1_1_49_1_28"]},
        "2826": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_11_1_1_22_1_28"]},
        "2827": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_28_1_1_56_1_28"]},
        "2828": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_29_1_1_58_1_28"]},
        "2829": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_2_1_1_4_1_28"]},
        "2830": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_58_1_1_55_1_28"]},
        "2831": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_54_1_1_47_1_28"]},
        "2832": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_34_1_1_7_1_28"]},
        "2833": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_28_1_1_56_1_28"]},
        "2834": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_44_1_1_27_1_28"]},
        "2835": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_9_1_1_18_1_28"]},
        "2836": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_49_1_1_37_1_28"]},
        "2837": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_42_1_1_23_1_28"]},
        "2838": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_42_1_1_23_1_28"]},
        "2839": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_40_1_1_19_1_28"]},
        "2840": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_33_1_1_5_1_28"]},
        "2841": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_18_1_1_36_1_28"]},
        "2842": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_46_1_1_31_1_28"]},
        "2843": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_55_1_1_49_1_28"]},
        "2844": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_45_1_1_29_1_28"]},
        "2845": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_4_1_1_8_1_28"]},
        "2846": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_53_1_1_45_1_28"]},
        "2847": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_39_1_1_17_1_28"]},
        "2848": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_59_1_1_57_1_28"]},
        "2849": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_27_1_1_54_1_28"]},
        "2850": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_46_1_1_31_1_28"]},
        "2851": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_9_1_1_18_1_28"]},
        "2852": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_3_1_1_6_1_28"]},
        "2853": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_5_1_1_10_1_28"]},
        "2854": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_4_1_1_8_1_28"]},
        "2855": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_4_1_1_8_1_28"]},
        "2856": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_20_1_1_40_1_28"]},
        "2857": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_24_1_1_48_1_28"]},
        "2858": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_34_1_1_7_1_28"]},
        "2859": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_43_1_1_25_1_28"]},
        "2860": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_28_1_1_56_1_28"]},
        "2861": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_27_1_1_54_1_28"]},
        "2862": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_40_1_1_19_1_28"]},
        "2863": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_19_1_1_38_1_28"]},
        "2864": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_17_1_1_34_1_28"]},
        "2865": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_50_1_1_39_1_28"]},
        "2866": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_35_1_1_9_1_28"]},
        "2867": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_59_1_1_57_1_28"]},
        "2868": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_17_1_1_34_1_28"]},
        "2869": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_13_1_1_26_1_28"]},
        "2870": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_58_1_1_55_1_28"]},
        "2871": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_22_1_1_44_1_28"]},
        "2872": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_26_1_1_52_1_28"]},
        "2873": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_16_1_1_32_1_28"]},
        "2874": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_49_1_1_37_1_28"]},
        "2875": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_43_1_1_25_1_28"]},
        "2876": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_23_1_1_46_1_28"]},
        "2877": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_18_1_1_36_1_28"]},
        "2878": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_5_1_1_10_1_28"]},
        "2879": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_36_1_1_11_1_28"]},
        "2880": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_8_1_1_16_1_28"]},
        "2881": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_41_1_1_21_1_28"]},
        "2882": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_23_1_1_46_1_28"]},
        "2883": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_49_1_1_37_1_28"]},
        "2884": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_8_1_1_16_1_28"]},
        "2885": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_13_1_1_26_1_28"]},
        "2886": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_4_1_1_8_1_28"]},
        "2887": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_2_1_1_4_1_28"]},
        "2888": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_29_1_1_58_1_28"]},
        "2889": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_9_1_1_18_1_28"]},
        "2890": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_56_1_1_51_1_28"]},
        "2891": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_21_1_1_42_1_28"]},
        "2892": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_6_1_1_12_1_28"]},
        "2893": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_41_1_1_21_1_28"]},
        "2894": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_60_1_1_59_1_28"]},
        "2895": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_42_1_1_23_1_28"]},
        "2896": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_53_1_1_45_1_28"]},
        "2897": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_3_1_1_6_1_28"]},
        "2898": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_42_1_1_23_1_28"]},
        "2899": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_53_1_1_45_1_28"]},
        "2900": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_22_1_1_44_1_28"]},
        "2901": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_14_1_1_28_1_28"]},
        "2902": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_10_1_1_20_1_28"]},
        "2903": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_19_1_1_38_1_28"]},
        "2904": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_33_1_1_5_1_28"]},
        "2905": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_4_1_1_8_1_28"]},
        "2906": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_11_1_1_22_1_28"]},
        "2907": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_7_1_1_14_1_28"]},
        "2908": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_34_1_1_7_1_28"]},
        "2909": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_19_1_1_38_1_28"]},
        "2910": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_3_1_1_6_1_28"]},
        "2911": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_5_1_1_10_1_28"]},
        "2912": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_46_1_1_31_1_28"]},
        "2913": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_35_1_1_9_1_28"]},
        "2914": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_18_1_1_36_1_28"]},
        "2915": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_26_1_1_52_1_28"]},
        "2916": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_12_1_1_24_1_28"]},
        "2917": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_60_1_1_59_1_28"]},
        "2918": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_37_1_1_13_1_28"]},
        "2919": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_45_1_1_29_1_28"]},
        "2920": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_53_1_1_45_1_28"]},
        "2921": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_23_1_1_46_1_28"]},
        "2922": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_58_1_1_55_1_28"]},
        "2923": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_20_1_1_40_1_28"]},
        "2924": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_5_1_1_10_1_28"]},
        "2925": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_30_1_1_60_1_28"]},
        "2926": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_12_1_1_24_1_28"]},
        "2927": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_47_1_1_33_1_28"]},
        "2928": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_13_1_1_26_1_28"]},
        "2929": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_52_1_1_43_1_28"]},
        "2930": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_32_1_1_3_1_28"]},
        "2931": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_38_1_1_15_1_28"]},
        "2932": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_37_1_1_13_1_28"]},
        "2933": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_19_1_1_38_1_28"]},
        "2934": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_2_1_1_4_1_28"]},
        "2935": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_59_1_1_57_1_28"]},
        "2936": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_30_1_1_60_1_28"]},
        "2937": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_4_1_1_8_1_28"]},
        "2938": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_19_1_1_38_1_28"]},
        "2939": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_14_1_1_28_1_28"]},
        "2940": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_22_1_1_44_1_28"]},
        "2941": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_21_1_1_42_1_28"]},
        "2942": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_44_1_1_27_1_28"]},
        "2943": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_53_1_1_45_1_28"]},
        "2944": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_53_1_1_45_1_28"]},
        "2945": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_49_1_1_37_1_28"]},
        "2946": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_7_1_1_14_1_28"]},
        "2947": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_22_1_1_44_1_28"]},
        "2948": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_26_1_1_52_1_28"]},
        "2949": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_34_1_1_7_1_28"]},
        "2950": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_57_1_1_53_1_28"]},
        "2951": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_10_1_1_20_1_28"]},
        "2952": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_50_1_1_39_1_28"]},
        "2953": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_28_1_1_56_1_28"]},
        "2954": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_41_1_1_21_1_28"]},
        "2955": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_57_1_1_53_1_28"]},
        "2956": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_45_1_1_29_1_28"]},
        "2957": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_41_1_1_21_1_28"]},
        "2958": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_28_1_1_56_1_28"]},
        "2959": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_22_1_1_44_1_28"]},
        "2960": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_12_1_1_24_1_28"]},
        "2961": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_2_1_1_4_1_28"]},
        "2962": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_55_1_1_49_1_28"]},
        "2963": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_13_1_1_26_1_28"]},
        "2964": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_14_1_1_28_1_28"]},
        "2965": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_22_1_1_44_1_28"]},
        "2966": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_25_1_1_50_1_28"]},
        "2967": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_11_1_1_22_1_28"]},
        "2968": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_48_1_1_35_1_28"]},
        "2969": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_13_1_1_26_1_28"]},
        "2970": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_48_1_1_35_1_28"]},
        "2971": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_23_1_1_46_1_28"]},
        "2972": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_41_1_1_21_1_28"]},
        "2973": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_11_1_1_22_1_28"]},
        "2974": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_22_1_1_44_1_28"]},
        "2975": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_14_1_1_28_1_28"]},
        "2976": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_40_1_1_19_1_28"]},
        "2977": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_22_1_1_44_1_28"]},
        "2978": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_22_1_1_44_1_28"]},
        "2979": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_29_1_1_58_1_28"]},
        "2980": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_12_1_1_24_1_28"]},
        "2981": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_10_1_1_20_1_28"]},
        "2982": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_50_1_1_39_1_28"]},
        "2983": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_50_1_1_39_1_28"]},
        "2984": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_3_1_1_6_1_28"]},
        "2985": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_58_1_1_55_1_28"]},
        "2986": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_51_1_1_41_1_28"]},
        "2987": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_31_1_1_1_1_28"]},
        "2988": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_16_1_1_32_1_28"]},
        "2989": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_32_1_1_3_1_28"]},
        "2990": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_1_1_1_2_1_28"]},
        "2991": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_41_1_1_21_1_28"]},
        "2992": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_17_1_1_34_1_28"]},
        "2993": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_25_1_1_50_1_28"]},
        "2994": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_21_1_1_42_1_28"]},
        "2995": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_60_1_1_59_1_28"]},
        "2996": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_18_1_1_36_1_28"]},
        "2997": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_52_1_1_43_1_28"]},
        "2998": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_19_1_1_38_1_28"]},
        "2999": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_32_1_1_3_1_28"]},
        "3000": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_14_1_1_28_1_28"]},
        "3001": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_45_1_1_29_1_28"]},
        "3002": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_49_1_1_37_1_28"]},
        "3003": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_54_1_1_47_1_28"]},
        "3004": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_37_1_1_13_1_28"]},
        "3005": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_10_1_1_20_1_28"]},
        "3006": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_31_1_1_1_1_28"]},
        "3007": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_20_1_1_40_1_28"]},
        "3008": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_33_1_1_5_1_28"]},
        "3009": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_21_1_1_42_1_28"]},
        "3010": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_47_1_1_33_1_28"]},
        "3011": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_9_1_1_18_1_28"]},
        "3012": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_52_1_1_43_1_28"]},
        "3013": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_44_1_1_27_1_28"]},
        "3014": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_32_1_1_3_1_28"]},
        "3015": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_21_1_1_42_1_28"]},
        "3016": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_41_1_1_21_1_28"]},
        "3017": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_42_1_1_23_1_28"]},
        "3018": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_17_1_1_34_1_28"]},
        "3019": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_49_1_1_37_1_28"]},
        "3020": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_38_1_1_15_1_28"]},
        "3021": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_33_1_1_5_1_28"]},
        "3022": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_40_1_1_19_1_28"]},
        "3023": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_2_1_1_4_1_28"]},
        "3024": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_19_1_1_38_1_28"]},
        "3025": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_31_1_1_1_1_28"]},
        "3026": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_42_1_1_23_1_28"]},
        "3027": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_8_1_1_16_1_28"]},
        "3028": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_7_1_1_14_1_28"]},
        "3029": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_53_1_1_45_1_28"]},
        "3030": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_18_1_1_36_1_28"]},
        "3031": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_26_1_1_52_1_28"]},
        "3032": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_53_1_1_45_1_28"]},
        "3033": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_7_1_1_14_1_28"]},
        "3034": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_3_1_1_6_1_28"]},
        "3035": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_32_1_1_3_1_28"]},
        "3036": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_23_1_1_46_1_28"]},
        "3037": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_37_1_1_13_1_28"]},
        "3038": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_35_1_1_9_1_28"]},
        "3039": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_32_1_1_3_1_28"]},
        "3040": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_37_1_1_13_1_28"]},
        "3041": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_41_1_1_21_1_28"]},
        "3042": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_34_1_1_7_1_28"]},
        "3043": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_51_1_1_41_1_28"]},
        "3044": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_36_1_1_11_1_28"]},
        "3045": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_19_1_1_38_1_28"]},
        "3046": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_7_1_1_14_1_28"]},
        "3047": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_17_1_1_34_1_28"]},
        "3048": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_33_1_1_5_1_28"]},
        "3049": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_25_1_1_50_1_28"]},
        "3050": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_56_1_1_51_1_28"]},
        "3051": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_34_1_1_7_1_28"]},
        "3052": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_49_1_1_37_1_28"]},
        "3053": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_1_1_1_2_1_28"]},
        "3054": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_39_1_1_17_1_28"]},
        "3055": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_48_1_1_35_1_28"]},
        "3056": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_45_1_1_29_1_28"]},
        "3057": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_1_1_1_2_1_28"]},
        "3058": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_57_1_1_53_1_28"]},
        "3059": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_59_1_1_57_1_28"]},
        "3060": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_48_1_1_35_1_28"]},
        "3061": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_29_1_1_58_1_28"]},
        "3062": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_45_1_1_29_1_28"]},
        "3063": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_11_1_1_22_1_28"]},
        "3064": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_34_1_1_7_1_28"]},
        "3065": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_13_1_1_26_1_28"]},
        "3066": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_49_1_1_37_1_28"]},
        "3067": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_52_1_1_43_1_28"]},
        "3068": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_34_1_1_7_1_28"]},
        "3069": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_5_1_1_10_1_28"]},
        "3070": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_2_1_1_4_1_28"]},
        "3071": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_37_1_1_13_1_28"]},
        "3072": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_42_1_1_23_1_28"]},
        "3073": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_29_1_1_58_1_28"]},
        "3074": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_6_1_1_12_1_28"]},
        "3075": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_23_1_1_46_1_28"]},
        "3076": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_11_1_1_22_1_28"]},
        "3077": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_20_1_1_40_1_28"]},
        "3078": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_24_1_1_48_1_28"]},
        "3079": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_51_1_1_41_1_28"]},
        "3080": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_12_1_1_24_1_28"]},
        "3081": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_51_1_1_41_1_28"]},
        "3082": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_4_1_1_8_1_28"]},
        "3083": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_42_1_1_23_1_28"]},
        "3084": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_15_1_1_30_1_28"]},
        "3085": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_41_1_1_21_1_28"]},
        "3086": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_10_1_1_20_1_28"]},
        "3087": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_32_1_1_3_1_28"]},
        "3088": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_34_1_1_7_1_28"]},
        "3089": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_20_1_1_40_1_28"]},
        "3090": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_1_1_1_2_1_28"]},
        "3091": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_45_1_1_29_1_28"]},
        "3092": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_35_1_1_9_1_28"]},
        "3093": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_17_1_1_34_1_28"]},
        "3094": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_25_1_1_50_1_28"]},
        "3095": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_3_1_1_6_1_28"]},
        "3096": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_4_1_1_8_1_28"]},
        "3097": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_2_1_1_4_1_28"]},
        "3098": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_18_1_1_36_1_28"]},
        "3099": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_53_1_1_45_1_28"]},
        "3100": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_6_1_1_12_1_28"]},
        "3101": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_37_1_1_13_1_28"]},
        "3102": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_23_1_1_46_1_28"]},
        "3103": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_18_1_1_36_1_28"]},
        "3104": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_8_1_1_16_1_28"]},
        "3105": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_58_1_1_55_1_28"]},
        "3106": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_51_1_1_41_1_28"]},
        "3107": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_59_1_1_57_1_28"]},
        "3108": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_41_1_1_21_1_28"]},
        "3109": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_10_1_1_20_1_28"]},
        "3110": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_44_1_1_27_1_28"]},
        "3111": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_39_1_1_17_1_28"]},
        "3112": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_52_1_1_43_1_28"]},
        "3113": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_30_1_1_60_1_28"]},
        "3114": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_23_1_1_46_1_28"]},
        "3115": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_24_1_1_48_1_28"]},
        "3116": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_1_1_1_2_1_28"]},
        "3117": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_37_1_1_13_1_28"]},
        "3118": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_50_1_1_39_1_28"]},
        "3119": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_53_1_1_45_1_28"]},
        "3120": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_23_1_1_46_1_28"]},
        "3121": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_60_1_1_59_1_28"]},
        "3122": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_17_1_1_34_1_28"]},
        "3123": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_57_1_1_53_1_28"]},
        "3124": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_7_1_1_14_1_28"]},
        "3125": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_20_1_1_40_1_28"]},
        "3126": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_8_1_1_16_1_28"]},
        "3127": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_45_1_1_29_1_28"]},
        "3128": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_26_1_1_52_1_28"]},
        "3129": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_54_1_1_47_1_28"]},
        "3130": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_16_1_1_32_1_28"]},
        "3131": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_4_1_1_8_1_28"]},
        "3132": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_38_1_1_15_1_28"]},
        "3133": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_45_1_1_29_1_28"]},
        "3134": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_6_1_1_12_1_28"]},
        "3135": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_9_1_1_18_1_28"]},
        "3136": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_8_1_1_16_1_28"]},
        "3137": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_12_1_1_24_1_28"]},
        "3138": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_4_1_1_8_1_28"]},
        "3139": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_48_1_1_35_1_28"]},
        "3140": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_3_1_1_6_1_28"]},
        "3141": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_34_1_1_7_1_28"]},
        "3142": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_3_1_1_6_1_28"]},
        "3143": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_47_1_1_33_1_28"]},
        "3144": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_24_1_1_48_1_28"]},
        "3145": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_2_1_1_4_1_28"]},
        "3146": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_53_1_1_45_1_28"]},
        "3147": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_47_1_1_33_1_28"]},
        "3148": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_50_1_1_39_1_28"]},
        "3149": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_30_1_1_60_1_28"]},
        "3150": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_31_1_1_1_1_28"]},
        "3151": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_24_1_1_48_1_28"]},
        "3152": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_23_1_1_46_1_28"]},
        "3153": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_54_1_1_47_1_28"]},
        "3154": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_1_1_1_2_1_28"]},
        "3155": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_52_1_1_43_1_28"]},
        "3156": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_1_1_1_2_1_28"]},
        "3157": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_57_1_1_53_1_28"]},
        "3158": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_11_1_1_22_1_28"]},
        "3159": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_37_1_1_13_1_28"]},
        "3160": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_51_1_1_41_1_28"]},
        "3161": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_54_1_1_47_1_28"]},
        "3162": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_39_1_1_17_1_28"]},
        "3163": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_40_1_1_19_1_28"]},
        "3164": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_22_1_1_44_1_28"]},
        "3165": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_12_1_1_24_1_28"]},
        "3166": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_10_1_1_20_1_28"]},
        "3167": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_15_1_1_30_1_28"]},
        "3168": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_38_1_1_15_1_28"]},
        "3169": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_59_1_1_57_1_28"]},
        "3170": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_59_1_1_57_1_28"]},
        "3171": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_20_1_1_40_1_28"]},
        "3172": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_42_1_1_23_1_28"]},
        "3173": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_30_1_1_60_1_28"]},
        "3174": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_59_1_1_57_1_28"]},
        "3175": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_48_1_1_35_1_28"]},
        "3176": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_56_1_1_51_1_28"]},
        "3177": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_3_1_1_6_1_28"]},
        "3178": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_27_1_1_54_1_28"]},
        "3179": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_31_1_1_1_1_28"]},
        "3180": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_3_1_1_6_1_28"]},
        "3181": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_12_1_1_24_1_28"]},
        "3182": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_46_1_1_31_1_28"]},
        "3183": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_44_1_1_27_1_28"]},
        "3184": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_33_1_1_5_1_28"]},
        "3185": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_21_1_1_42_1_28"]},
        "3186": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_9_1_1_18_1_28"]},
        "3187": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_14_1_1_28_1_28"]},
        "3188": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_24_1_1_48_1_28"]},
        "3189": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_30_1_1_60_1_28"]},
        "3190": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_10_1_1_20_1_28"]},
        "3191": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_24_1_1_48_1_28"]},
        "3192": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_30_1_1_60_1_28"]},
        "3193": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_25_1_1_50_1_28"]},
        "3194": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_53_1_1_45_1_28"]},
        "3195": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_5_1_1_10_1_28"]},
        "3196": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_20_1_1_40_1_28"]},
        "3197": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_1_1_1_2_1_28"]},
        "3198": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_40_1_1_19_1_28"]},
        "3199": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_11_1_1_22_1_28"]},
        "3200": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_47_1_1_33_1_28"]},
        "3201": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_42_1_1_23_1_28"]},
        "3202": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_9_1_1_18_1_28"]},
        "3203": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_59_1_1_57_1_28"]},
        "3204": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_7_1_1_14_1_28"]},
        "3205": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_44_1_1_27_1_28"]},
        "3206": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_41_1_1_21_1_28"]},
        "3207": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_5_1_1_10_1_28"]},
        "3208": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_19_1_1_38_1_28"]},
        "3209": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_58_1_1_55_1_28"]},
        "3210": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_7_1_1_14_1_28"]},
        "3211": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_23_1_1_46_1_28"]},
        "3212": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_29_1_1_58_1_28"]},
        "3213": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_15_1_1_30_1_28"]},
        "3214": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_30_1_1_60_1_28"]},
        "3215": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_46_1_1_31_1_28"]},
        "3216": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_29_1_1_58_1_28"]},
        "3217": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_38_1_1_15_1_28"]},
        "3218": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_31_1_1_1_1_28"]},
        "3219": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_20_1_1_40_1_28"]},
        "3220": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_24_1_1_48_1_28"]},
        "3221": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_47_1_1_33_1_28"]},
        "3222": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_32_1_1_3_1_28"]},
        "3223": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_33_1_1_5_1_28"]},
        "3224": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_30_1_1_60_1_28"]},
        "3225": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_43_1_1_25_1_28"]},
        "3226": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_23_1_1_46_1_28"]},
        "3227": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_16_1_1_32_1_28"]},
        "3228": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_37_1_1_13_1_28"]},
        "3229": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_7_1_1_14_1_28"]},
        "3230": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_34_1_1_7_1_28"]},
        "3231": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_10_1_1_20_1_28"]},
        "3232": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_9_1_1_18_1_28"]},
        "3233": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_6_1_1_12_1_28"]},
        "3234": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_14_1_1_28_1_28"]},
        "3235": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_22_1_1_44_1_28"]},
        "3236": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_12_1_1_24_1_28"]},
        "3237": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_29_1_1_58_1_28"]},
        "3238": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_26_1_1_52_1_28"]},
        "3239": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_13_1_1_26_1_28"]},
        "3240": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_40_1_1_19_1_28"]},
        "3241": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_21_1_1_42_1_28"]},
        "3242": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_41_1_1_21_1_28"]},
        "3243": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_51_1_1_41_1_28"]},
        "3244": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_17_1_1_34_1_28"]},
        "3245": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_34_1_1_7_1_28"]},
        "3246": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_33_1_1_5_1_28"]},
        "3247": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_20_1_1_40_1_28"]},
        "3248": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_54_1_1_47_1_28"]},
        "3249": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_56_1_1_51_1_28"]},
        "3250": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_52_1_1_43_1_28"]},
        "3251": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_54_1_1_47_1_28"]},
        "3252": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_15_1_1_30_1_28"]},
        "3253": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_45_1_1_29_1_28"]},
        "3254": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_2_1_1_4_1_28"]},
        "3255": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_54_1_1_47_1_28"]},
        "3256": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_43_1_1_25_1_28"]},
        "3257": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_47_1_1_33_1_28"]},
        "3258": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_37_1_1_13_1_28"]},
        "3259": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_48_1_1_35_1_28"]},
        "3260": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_16_1_1_32_1_28"]},
        "3261": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_34_1_1_7_1_28"]},
        "3262": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_6_1_1_12_1_28"]},
        "3263": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_41_1_1_21_1_28"]},
        "3264": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_52_1_1_43_1_28"]},
        "3265": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_22_1_1_44_1_28"]},
        "3266": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_46_1_1_31_1_28"]},
        "3267": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_25_1_1_50_1_28"]},
        "3268": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_57_1_1_53_1_28"]},
        "3269": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_6_1_1_12_1_28"]},
        "3270": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_13_1_1_26_1_28"]},
        "3271": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_56_1_1_51_1_28"]},
        "3272": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_20_1_1_40_1_28"]},
        "3273": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_13_1_1_26_1_28"]},
        "3274": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_44_1_1_27_1_28"]},
        "3275": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_22_1_1_44_1_28"]},
        "3276": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_25_1_1_50_1_28"]},
        "3277": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_21_1_1_42_1_28"]},
        "3278": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_26_1_1_52_1_28"]},
        "3279": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_34_1_1_7_1_28"]},
        "3280": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_42_1_1_23_1_28"]},
        "3281": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_14_1_1_28_1_28"]},
        "3282": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_44_1_1_27_1_28"]},
        "3283": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_54_1_1_47_1_28"]},
        "3284": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_15_1_1_30_1_28"]},
        "3285": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_12_1_1_24_1_28"]},
        "3286": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_39_1_1_17_1_28"]},
        "3287": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_15_1_1_30_1_28"]},
        "3288": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_42_1_1_23_1_28"]},
        "3289": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_59_1_1_57_1_28"]},
        "3290": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_24_1_1_48_1_28"]},
        "3291": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_59_1_1_57_1_28"]},
        "3292": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_9_1_1_18_1_28"]},
        "3293": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_59_1_1_57_1_28"]},
        "3294": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_14_1_1_28_1_28"]},
        "3295": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_19_1_1_38_1_28"]},
        "3296": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_50_1_1_39_1_28"]},
        "3297": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_26_1_1_52_1_28"]},
        "3298": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_5_1_1_10_1_28"]},
        "3299": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_29_1_1_58_1_28"]},
        "3300": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_60_1_1_59_1_28"]},
        "3301": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_28_1_1_56_1_28"]},
        "3302": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_17_1_1_34_1_28"]},
        "3303": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_28_1_1_56_1_28"]},
        "3304": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_53_1_1_45_1_28"]},
        "3305": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_19_1_1_38_1_28"]},
        "3306": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_50_1_1_39_1_28"]},
        "3307": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_59_1_1_57_1_28"]},
        "3308": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_7_1_1_14_1_28"]},
        "3309": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_41_1_1_21_1_28"]},
        "3310": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_14_1_1_28_1_28"]},
        "3311": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_41_1_1_21_1_28"]},
        "3312": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_57_1_1_53_1_28"]},
        "3313": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_11_1_1_22_1_28"]},
        "3314": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_29_1_1_58_1_28"]},
        "3315": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_60_1_1_59_1_28"]},
        "3316": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_60_1_1_59_1_28"]},
        "3317": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_18_1_1_36_1_28"]},
        "3318": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_17_1_1_34_1_28"]},
        "3319": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_53_1_1_45_1_28"]},
        "3320": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_59_1_1_57_1_28"]},
        "3321": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_53_1_1_45_1_28"]},
        "3322": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_41_1_1_21_1_28"]},
        "3323": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_58_1_1_55_1_28"]},
        "3324": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_26_1_1_52_1_28"]},
        "3325": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_23_1_1_46_1_28"]},
        "3326": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_55_1_1_49_1_28"]},
        "3327": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_54_1_1_47_1_28"]},
        "3328": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_18_1_1_36_1_28"]},
        "3329": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_25_1_1_50_1_28"]},
        "3330": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_54_1_1_47_1_28"]},
        "3331": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_14_1_1_28_1_28"]},
        "3332": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_16_1_1_32_1_28"]},
        "3333": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_54_1_1_47_1_28"]},
        "3334": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_18_1_1_36_1_28"]},
        "3335": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_18_1_1_36_1_28"]},
        "3336": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_26_1_1_52_1_28"]},
        "3337": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_1_1_1_2_1_28"]},
        "3338": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_6_1_1_12_1_28"]},
        "3339": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_21_1_1_42_1_28"]},
        "3340": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_1_1_1_2_1_28"]},
        "3341": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_10_1_1_20_1_28"]},
        "3342": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_8_1_1_16_1_28"]},
        "3343": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_30_1_1_60_1_28"]},
        "3344": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_45_1_1_29_1_28"]},
        "3345": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_44_1_1_27_1_28"]},
        "3346": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_14_1_1_28_1_28"]},
        "3347": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_26_1_1_52_1_28"]},
        "3348": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_13_1_1_26_1_28"]},
        "3349": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_39_1_1_17_1_28"]},
        "3350": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_1_1_1_2_1_28"]},
        "3351": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_12_1_1_24_1_28"]},
        "3352": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_34_1_1_7_1_28"]},
        "3353": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_24_1_1_48_1_28"]},
        "3354": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_27_1_1_54_1_28"]},
        "3355": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_30_1_1_60_1_28"]},
        "3356": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_35_1_1_9_1_28"]},
        "3357": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_39_1_1_17_1_28"]},
        "3358": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_42_1_1_23_1_28"]},
        "3359": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_36_1_1_11_1_28"]},
        "3360": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_20_1_1_40_1_28"]},
        "3361": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_17_1_1_34_1_28"]},
        "3362": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_6_1_1_12_1_28"]},
        "3363": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_58_1_1_55_1_28"]},
        "3364": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_41_1_1_21_1_28"]},
        "3365": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_36_1_1_11_1_28"]},
        "3366": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_22_1_1_44_1_28"]},
        "3367": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_23_1_1_46_1_28"]},
        "3368": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_49_1_1_37_1_28"]},
        "3369": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_25_1_1_50_1_28"]},
        "3370": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_10_1_1_20_1_28"]},
        "3371": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_37_1_1_13_1_28"]},
        "3372": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_13_1_1_26_1_28"]},
        "3373": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_39_1_1_17_1_28"]},
        "3374": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_10_1_1_20_1_28"]},
        "3375": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_50_1_1_39_1_28"]},
        "3376": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_30_1_1_60_1_28"]},
        "3377": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_17_1_1_34_1_28"]},
        "3378": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_59_1_1_57_1_28"]},
        "3379": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_13_1_1_26_1_28"]},
        "3380": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_15_1_1_30_1_28"]},
        "3381": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_19_1_1_38_1_28"]},
        "3382": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_29_1_1_58_1_28"]},
        "3383": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_48_1_1_35_1_28"]},
        "3384": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_13_1_1_26_1_28"]},
        "3385": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_15_1_1_30_1_28"]},
        "3386": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_37_1_1_13_1_28"]},
        "3387": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_13_1_1_26_1_28"]},
        "3388": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_53_1_1_45_1_28"]},
        "3389": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_9_1_1_18_1_28"]},
        "3390": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_37_1_1_13_1_28"]},
        "3391": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_12_1_1_24_1_28"]},
        "3392": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_39_1_1_17_1_28"]},
        "3393": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_55_1_1_49_1_28"]},
        "3394": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_7_1_1_14_1_28"]},
        "3395": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_38_1_1_15_1_28"]},
        "3396": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_29_1_1_58_1_28"]},
        "3397": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_16_1_1_32_1_28"]},
        "3398": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_3_1_1_6_1_28"]},
        "3399": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_17_1_1_34_1_28"]},
        "3400": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_41_1_1_21_1_28"]},
        "3401": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_55_1_1_49_1_28"]},
        "3402": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_32_1_1_3_1_28"]},
        "3403": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_22_1_1_44_1_28"]},
        "3404": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_21_1_1_42_1_28"]},
        "3405": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_34_1_1_7_1_28"]},
        "3406": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_39_1_1_17_1_28"]},
        "3407": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_48_1_1_35_1_28"]},
        "3408": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_44_1_1_27_1_28"]},
        "3409": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_31_1_1_1_1_28"]},
        "3410": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_40_1_1_19_1_28"]},
        "3411": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_27_1_1_54_1_28"]},
        "3412": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_31_1_1_1_1_28"]},
        "3413": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_12_1_1_24_1_28"]},
        "3414": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_6_1_1_12_1_28"]},
        "3415": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_18_1_1_36_1_28"]},
        "3416": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_37_1_1_13_1_28"]},
        "3417": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_28_1_1_56_1_28"]},
        "3418": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_50_1_1_39_1_28"]},
        "3419": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_39_1_1_17_1_28"]},
        "3420": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_49_1_1_37_1_28"]},
        "3421": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_31_1_1_1_1_28"]},
        "3422": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_22_1_1_44_1_28"]},
        "3423": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_7_1_1_14_1_28"]},
        "3424": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_55_1_1_49_1_28"]},
        "3425": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_24_1_1_48_1_28"]},
        "3426": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_35_1_1_9_1_28"]},
        "3427": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_28_1_1_56_1_28"]},
        "3428": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_27_1_1_54_1_28"]},
        "3429": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_22_1_1_44_1_28"]},
        "3430": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_33_1_1_5_1_28"]},
        "3431": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_24_1_1_48_1_28"]},
        "3432": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_1_1_1_2_1_28"]},
        "3433": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_41_1_1_21_1_28"]},
        "3434": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_3_1_1_6_1_28"]},
        "3435": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_27_1_1_54_1_28"]},
        "3436": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_36_1_1_11_1_28"]},
        "3437": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_10_1_1_20_1_28"]},
        "3438": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_50_1_1_39_1_28"]},
        "3439": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_36_1_1_11_1_28"]},
        "3440": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_12_1_1_24_1_28"]},
        "3441": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_33_1_1_5_1_28"]},
        "3442": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_22_1_1_44_1_28"]},
        "3443": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_19_1_1_38_1_28"]},
        "3444": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_34_1_1_7_1_28"]},
        "3445": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_29_1_1_58_1_28"]},
        "3446": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_17_1_1_34_1_28"]},
        "3447": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_32_1_1_3_1_28"]},
        "3448": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_32_1_1_3_1_28"]},
        "3449": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_19_1_1_38_1_28"]},
        "3450": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_32_1_1_3_1_28"]},
        "3451": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_18_1_1_36_1_28"]},
        "3452": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_49_1_1_37_1_28"]},
        "3453": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_12_1_1_24_1_28"]},
        "3454": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_13_1_1_26_1_28"]},
        "3455": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_23_1_1_46_1_28"]},
        "3456": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_30_1_1_60_1_28"]},
        "3457": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_31_1_1_1_1_28"]},
        "3458": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_26_1_1_52_1_28"]},
        "3459": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_19_1_1_38_1_28"]},
        "3460": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_27_1_1_54_1_28"]},
        "3461": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_20_1_1_40_1_28"]},
        "3462": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_46_1_1_31_1_28"]},
        "3463": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_26_1_1_52_1_28"]},
        "3464": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_6_1_1_12_1_28"]},
        "3465": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_52_1_1_43_1_28"]},
        "3466": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_45_1_1_29_1_28"]},
        "3467": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_28_1_1_56_1_28"]},
        "3468": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_23_1_1_46_1_28"]},
        "3469": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_49_1_1_37_1_28"]},
        "3470": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_46_1_1_31_1_28"]},
        "3471": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_15_1_1_30_1_28"]},
        "3472": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_39_1_1_17_1_28"]},
        "3473": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_4_1_1_8_1_28"]},
        "3474": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_50_1_1_39_1_28"]},
        "3475": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_3_1_1_6_1_28"]},
        "3476": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_8_1_1_16_1_28"]},
        "3477": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_29_1_1_58_1_28"]},
        "3478": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_59_1_1_57_1_28"]},
        "3479": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_42_1_1_23_1_28"]},
        "3480": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_44_1_1_27_1_28"]},
        "3481": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_17_1_1_34_1_28"]},
        "3482": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_32_1_1_3_1_28"]},
        "3483": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_47_1_1_33_1_28"]},
        "3484": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_33_1_1_5_1_28"]},
        "3485": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_22_1_1_44_1_28"]},
        "3486": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_34_1_1_7_1_28"]},
        "3487": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_34_1_1_7_1_28"]},
        "3488": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_50_1_1_39_1_28"]},
        "3489": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_12_1_1_24_1_28"]},
        "3490": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_26_1_1_52_1_28"]},
        "3491": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_16_1_1_32_1_28"]},
        "3492": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_35_1_1_9_1_28"]},
        "3493": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_32_1_1_3_1_28"]},
        "3494": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_29_1_1_58_1_28"]},
        "3495": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_43_1_1_25_1_28"]},
        "3496": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_54_1_1_47_1_28"]},
        "3497": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_15_1_1_30_1_28"]},
        "3498": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_32_1_1_3_1_28"]},
        "3499": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_51_1_1_41_1_28"]},
        "3500": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_32_1_1_3_1_28"]},
        "3501": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_57_1_1_53_1_28"]},
        "3502": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_3_1_1_6_1_28"]},
        "3503": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_21_1_1_42_1_28"]},
        "3504": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_40_1_1_19_1_28"]},
        "3505": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_22_1_1_44_1_28"]},
        "3506": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_2_1_1_4_1_28"]},
        "3507": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_37_1_1_13_1_28"]},
        "3508": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_44_1_1_27_1_28"]},
        "3509": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_47_1_1_33_1_28"]},
        "3510": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_20_1_1_40_1_28"]},
        "3511": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_26_1_1_52_1_28"]},
        "3512": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_41_1_1_21_1_28"]},
        "3513": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_10_1_1_20_1_28"]},
        "3514": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_26_1_1_52_1_28"]},
        "3515": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_58_1_1_55_1_28"]},
        "3516": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_56_1_1_51_1_28"]},
        "3517": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_36_1_1_11_1_28"]},
        "3518": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_41_1_1_21_1_28"]},
        "3519": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_14_1_1_28_1_28"]},
        "3520": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_33_1_1_5_1_28"]},
        "3521": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_24_1_1_48_1_28"]},
        "3522": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_1_1_1_2_1_28"]},
        "3523": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_43_1_1_25_1_28"]},
        "3524": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_37_1_1_13_1_28"]},
        "3525": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_14_1_1_28_1_28"]},
        "3526": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_25_1_1_50_1_28"]},
        "3527": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_10_1_1_20_1_28"]},
        "3528": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_35_1_1_9_1_28"]},
        "3529": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_15_1_1_30_1_28"]},
        "3530": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_33_1_1_5_1_28"]},
        "3531": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_42_1_1_23_1_28"]},
        "3532": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_4_1_1_8_1_28"]},
        "3533": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_50_1_1_39_1_28"]},
        "3534": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_41_1_1_21_1_28"]},
        "3535": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_59_1_1_57_1_28"]},
        "3536": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_55_1_1_49_1_28"]},
        "3537": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_4_1_1_8_1_28"]},
        "3538": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_49_1_1_37_1_28"]},
        "3539": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_48_1_1_35_1_28"]},
        "3540": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_3_1_1_6_1_28"]},
        "3541": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_2_1_1_4_1_28"]},
        "3542": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_25_1_1_50_1_28"]},
        "3543": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_54_1_1_47_1_28"]},
        "3544": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_11_1_1_22_1_28"]},
        "3545": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_32_1_1_3_1_28"]},
        "3546": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_36_1_1_11_1_28"]},
        "3547": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_19_1_1_38_1_28"]},
        "3548": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_56_1_1_51_1_28"]},
        "3549": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_3_1_1_6_1_28"]},
        "3550": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_34_1_1_7_1_28"]},
        "3551": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_19_1_1_38_1_28"]},
        "3552": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_51_1_1_41_1_28"]},
        "3553": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_25_1_1_50_1_28"]},
        "3554": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_14_1_1_28_1_28"]},
        "3555": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_45_1_1_29_1_28"]},
        "3556": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_31_1_1_1_1_28"]},
        "3557": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_23_1_1_46_1_28"]},
        "3558": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_51_1_1_41_1_28"]},
        "3559": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_1_1_1_2_1_28"]},
        "3560": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_4_1_1_8_1_28"]},
        "3561": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_38_1_1_15_1_28"]},
        "3562": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_35_1_1_9_1_28"]},
        "3563": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_26_1_1_52_1_28"]},
        "3564": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_28_1_1_56_1_28"]},
        "3565": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_57_1_1_53_1_28"]},
        "3566": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_8_1_1_16_1_28"]},
        "3567": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_41_1_1_21_1_28"]},
        "3568": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_10_1_1_20_1_28"]},
        "3569": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_33_1_1_5_1_28"]},
        "3570": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_43_1_1_25_1_28"]},
        "3571": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_59_1_1_57_1_28"]},
        "3572": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_2_1_1_4_1_28"]},
        "3573": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_5_1_1_10_1_28"]},
        "3574": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_6_1_1_12_1_28"]},
        "3575": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_51_1_1_41_1_28"]},
        "3576": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_47_1_1_33_1_28"]},
        "3577": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_19_1_1_38_1_28"]},
        "3578": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_31_1_1_1_1_28"]},
        "3579": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_21_1_1_42_1_28"]},
        "3580": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_37_1_1_13_1_28"]},
        "3581": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_39_1_1_17_1_28"]},
        "3582": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_9_1_1_18_1_28"]},
        "3583": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_15_1_1_30_1_28"]},
        "3584": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_47_1_1_33_1_28"]},
        "3585": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_60_1_1_59_1_28"]},
        "3586": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_6_1_1_12_1_28"]},
        "3587": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_24_1_1_48_1_28"]},
        "3588": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_7_1_1_14_1_28"]},
        "3589": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_25_1_1_50_1_28"]},
        "3590": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_51_1_1_41_1_28"]},
        "3591": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_49_1_1_37_1_28"]},
        "3592": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_47_1_1_33_1_28"]},
        "3593": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_20_1_1_40_1_28"]},
        "3594": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_10_1_1_20_1_28"]},
        "3595": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_4_1_1_8_1_28"]},
        "3596": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_25_1_1_50_1_28"]},
        "3597": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_8_1_1_16_1_28"]},
        "3598": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_39_1_1_17_1_28"]},
        "3599": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_24_1_1_48_1_28"]},
        "3600": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_4_1_1_8_1_28"]},
        "3601": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_60_1_1_59_1_28"]},
        "3602": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_27_1_1_54_1_28"]},
        "3603": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_57_1_1_53_1_28"]},
        "3604": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_50_1_1_39_1_28"]},
        "3605": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_49_1_1_37_1_28"]},
        "3606": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_31_1_1_1_1_28"]},
        "3607": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_2_1_1_4_1_28"]},
        "3608": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_58_1_1_55_1_28"]},
        "3609": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_29_1_1_58_1_28"]},
        "3610": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_8_1_1_16_1_28"]},
        "3611": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_45_1_1_29_1_28"]},
        "3612": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_19_1_1_38_1_28"]},
        "3613": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_40_1_1_19_1_28"]},
        "3614": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_2_1_1_4_1_28"]},
        "3615": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_51_1_1_41_1_28"]},
        "3616": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_8_1_1_16_1_28"]},
        "3617": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_8_1_1_16_1_28"]},
        "3618": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_38_1_1_15_1_28"]},
        "3619": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_13_1_1_26_1_28"]},
        "3620": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_40_1_1_19_1_28"]},
        "3621": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_21_1_1_42_1_28"]},
        "3622": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_43_1_1_25_1_28"]},
        "3623": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_46_1_1_31_1_28"]},
        "3624": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_2_1_1_4_1_28"]},
        "3625": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_22_1_1_44_1_28"]},
        "3626": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_32_1_1_3_1_28"]},
        "3627": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_12_1_1_24_1_28"]},
        "3628": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_56_1_1_51_1_28"]},
        "3629": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_38_1_1_15_1_28"]},
        "3630": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_50_1_1_39_1_28"]},
        "3631": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_59_1_1_57_1_28"]},
        "3632": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_12_1_1_24_1_28"]},
        "3633": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_6_1_1_12_1_28"]},
        "3634": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_21_1_1_42_1_28"]},
        "3635": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_39_1_1_17_1_28"]},
        "3636": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_51_1_1_41_1_28"]},
        "3637": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_24_1_1_48_1_28"]},
        "3638": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_21_1_1_42_1_28"]},
        "3639": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_38_1_1_15_1_28"]},
        "3640": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_15_1_1_30_1_28"]},
        "3641": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_10_1_1_20_1_28"]},
        "3642": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_29_1_1_58_1_28"]},
        "3643": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_31_1_1_1_1_28"]},
        "3644": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_43_1_1_25_1_28"]},
        "3645": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_40_1_1_19_1_28"]},
        "3646": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_31_1_1_1_1_28"]},
        "3647": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_58_1_1_55_1_28"]},
        "3648": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_33_1_1_5_1_28"]},
        "3649": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_35_1_1_9_1_28"]},
        "3650": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_18_1_1_36_1_28"]},
        "3651": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_27_1_1_54_1_28"]},
        "3652": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_33_1_1_5_1_28"]},
        "3653": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_51_1_1_41_1_28"]},
        "3654": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_31_1_1_1_1_28"]},
        "3655": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_9_1_1_18_1_28"]},
        "3656": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_6_1_1_12_1_28"]},
        "3657": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_58_1_1_55_1_28"]},
        "3658": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_58_1_1_55_1_28"]},
        "3659": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_11_1_1_22_1_28"]},
        "3660": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_2_1_1_4_1_28"]},
        "3661": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_1_1_1_2_1_28"]},
        "3662": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_19_1_1_38_1_28"]},
        "3663": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_40_1_1_19_1_28"]},
        "3664": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_43_1_1_25_1_28"]},
        "3665": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_59_1_1_57_1_28"]},
        "3666": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_1_1_1_2_1_28"]},
        "3667": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_48_1_1_35_1_28"]},
        "3668": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_33_1_1_5_1_28"]},
        "3669": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_4_1_1_8_1_28"]},
        "3670": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_30_1_1_60_1_28"]},
        "3671": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_51_1_1_41_1_28"]},
        "3672": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_23_1_1_46_1_28"]},
        "3673": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_51_1_1_41_1_28"]},
        "3674": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_48_1_1_35_1_28"]},
        "3675": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_35_1_1_9_1_28"]},
        "3676": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_51_1_1_41_1_28"]},
        "3677": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_45_1_1_29_1_28"]},
        "3678": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_21_1_1_42_1_28"]},
        "3679": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_47_1_1_33_1_28"]},
        "3680": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_6_1_1_12_1_28"]},
        "3681": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_4_1_1_8_1_28"]},
        "3682": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_29_1_1_58_1_28"]},
        "3683": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_8_1_1_16_1_28"]},
        "3684": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_39_1_1_17_1_28"]},
        "3685": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_8_1_1_16_1_28"]},
        "3686": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_52_1_1_43_1_28"]},
        "3687": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_26_1_1_52_1_28"]},
        "3688": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_30_1_1_60_1_28"]},
        "3689": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_15_1_1_30_1_28"]},
        "3690": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_16_1_1_32_1_28"]},
        "3691": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_39_1_1_17_1_28"]},
        "3692": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_15_1_1_30_1_28"]},
        "3693": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_50_1_1_39_1_28"]},
        "3694": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_41_1_1_21_1_28"]},
        "3695": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_8_1_1_16_1_28"]},
        "3696": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_7_1_1_14_1_28"]},
        "3697": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_33_1_1_5_1_28"]},
        "3698": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_13_1_1_26_1_28"]},
        "3699": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_14_1_1_28_1_28"]},
        "3700": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_28_1_1_56_1_28"]},
        "3701": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_45_1_1_29_1_28"]},
        "3702": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_44_1_1_27_1_28"]},
        "3703": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_7_1_1_14_1_28"]},
        "3704": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_26_1_1_52_1_28"]},
        "3705": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_12_1_1_24_1_28"]},
        "3706": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_19_1_1_38_1_28"]},
        "3707": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_9_1_1_18_1_28"]},
        "3708": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_38_1_1_15_1_28"]},
        "3709": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_6_1_1_12_1_28"]},
        "3710": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_54_1_1_47_1_28"]},
        "3711": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_11_1_1_22_1_28"]},
        "3712": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_49_1_1_37_1_28"]},
        "3713": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_60_1_1_59_1_28"]},
        "3714": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_20_1_1_40_1_28"]},
        "3715": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_52_1_1_43_1_28"]},
        "3716": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_28_1_1_56_1_28"]},
        "3717": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_27_1_1_54_1_28"]},
        "3718": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_49_1_1_37_1_28"]},
        "3719": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_42_1_1_23_1_28"]},
        "3720": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_56_1_1_51_1_28"]},
        "3721": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_30_1_1_60_1_28"]},
        "3722": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_21_1_1_42_1_28"]},
        "3723": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_28_1_1_56_1_28"]},
        "3724": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_36_1_1_11_1_28"]},
        "3725": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_12_1_1_24_1_28"]},
        "3726": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_57_1_1_53_1_28"]},
        "3727": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_9_1_1_18_1_28"]},
        "3728": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_48_1_1_35_1_28"]},
        "3729": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_13_1_1_26_1_28"]},
        "3730": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_16_1_1_32_1_28"]},
        "3731": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_35_1_1_9_1_28"]},
        "3732": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_24_1_1_48_1_28"]},
        "3733": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_53_1_1_45_1_28"]},
        "3734": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_34_1_1_7_1_28"]},
        "3735": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_59_1_1_57_1_28"]},
        "3736": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_8_1_1_16_1_28"]},
        "3737": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_53_1_1_45_1_28"]},
        "3738": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_54_1_1_47_1_28"]},
        "3739": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_51_1_1_41_1_28"]},
        "3740": {"vr": "LO", "Value": ["X_1_1_1_21_1_1_1_1_1_2_1_28"]},
        "3741": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_25_1_1_50_1_28"]},
        "3742": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_6_1_1_12_1_28"]},
        "3743": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_21_1_1_42_1_28"]},
        "3744": {"vr": "LO", "Value": ["X_1_1_1_1_1_1_44_1_1_27_1_28"]},
        "3745": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_26_1_1_52_1_28"]},
        "3746": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_48_1_1_35_1_28"]},
        "3747": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_18_1_1_36_1_28"]},
        "3748": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_30_1_1_60_1_28"]},
        "3749": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_26_1_1_52_1_28"]},
        "3750": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_22_1_1_44_1_28"]},
        "3751": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_36_1_1_11_1_28"]},
        "3752": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_53_1_1_45_1_28"]},
        "3753": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_50_1_1_39_1_28"]},
        "3754": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_16_1_1_32_1_28"]},
        "3755": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_49_1_1_37_1_28"]},
        "3756": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_8_1_1_16_1_28"]},
        "3757": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_60_1_1_59_1_28"]},
        "3758": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_25_1_1_50_1_28"]},
        "3759": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_11_1_1_22_1_28"]},
        "3760": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_50_1_1_39_1_28"]},
        "3761": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_53_1_1_45_1_28"]},
        "3762": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_57_1_1_53_1_28"]},
        "3763": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_48_1_1_35_1_28"]},
        "3764": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_8_1_1_16_1_28"]},
        "3765": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_22_1_1_44_1_28"]},
        "3766": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_25_1_1_50_1_28"]},
        "3767": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_33_1_1_5_1_28"]},
        "3768": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_33_1_1_5_1_28"]},
        "3769": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_56_1_1_51_1_28"]},
        "3770": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_10_1_1_20_1_28"]},
        "3771": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_44_1_1_27_1_28"]},
        "3772": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_18_1_1_36_1_28"]},
        "3773": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_40_1_1_19_1_28"]},
        "3774": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_50_1_1_39_1_28"]},
        "3775": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_42_1_1_23_1_28"]},
        "3776": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_54_1_1_47_1_28"]},
        "3777": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_27_1_1_54_1_28"]},
        "3778": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_17_1_1_34_1_28"]},
        "3779": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_8_1_1_16_1_28"]},
        "3780": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_1_1_1_2_1_28"]},
        "3781": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_42_1_1_23_1_28"]},
        "3782": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_29_1_1_58_1_28"]},
        "3783": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_36_1_1_11_1_28"]},
        "3784": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_54_1_1_47_1_28"]},
        "3785": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_60_1_1_59_1_28"]},
        "3786": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_56_1_1_51_1_28"]},
        "3787": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_41_1_1_21_1_28"]},
        "3788": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_30_1_1_60_1_28"]},
        "3789": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_29_1_1_58_1_28"]},
        "3790": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_19_1_1_38_1_28"]},
        "3791": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_24_1_1_48_1_28"]},
        "3792": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_32_1_1_3_1_28"]},
        "3793": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_21_1_1_42_1_28"]},
        "3794": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_59_1_1_57_1_28"]},
        "3795": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_30_1_1_60_1_28"]},
        "3796": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_51_1_1_41_1_28"]},
        "3797": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_33_1_1_5_1_28"]},
        "3798": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_45_1_1_29_1_28"]},
        "3799": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_48_1_1_35_1_28"]},
        "3800": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_38_1_1_15_1_28"]},
        "3801": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_23_1_1_46_1_28"]},
        "3802": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_37_1_1_13_1_28"]},
        "3803": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_13_1_1_26_1_28"]},
        "3804": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_49_1_1_37_1_28"]},
        "3805": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_29_1_1_58_1_28"]},
        "3806": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_59_1_1_57_1_28"]},
        "3807": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_60_1_1_59_1_28"]},
        "3808": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_11_1_1_22_1_28"]},
        "3809": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_32_1_1_3_1_28"]},
        "3810": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_43_1_1_25_1_28"]},
        "3811": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_44_1_1_27_1_28"]},
        "3812": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_12_1_1_24_1_28"]},
        "3813": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_50_1_1_39_1_28"]},
        "3814": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_57_1_1_53_1_28"]},
        "3815": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_47_1_1_33_1_28"]},
        "3816": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_18_1_1_36_1_28"]},
        "3817": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_33_1_1_5_1_28"]},
        "3818": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_40_1_1_19_1_28"]},
        "3819": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_36_1_1_11_1_28"]},
        "3820": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_11_1_1_22_1_28"]},
        "3821": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_30_1_1_60_1_28"]},
        "3822": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_35_1_1_9_1_28"]},
        "3823": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_21_1_1_42_1_28"]},
        "3824": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_42_1_1_23_1_28"]},
        "3825": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_11_1_1_22_1_28"]},
        "3826": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_10_1_1_20_1_28"]},
        "3827": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_1_1_1_2_1_28"]},
        "3828": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_7_1_1_14_1_28"]},
        "3829": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_21_1_1_42_1_28"]},
        "3830": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_40_1_1_19_1_28"]},
        "3831": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_7_1_1_14_1_28"]},
        "3832": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_48_1_1_35_1_28"]},
        "3833": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_16_1_1_32_1_28"]},
        "3834": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_49_1_1_37_1_28"]},
        "3835": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_51_1_1_41_1_28"]},
        "3836": {"vr": "LO", "Value": ["X_1_1_1_49_1_1_59_1_1_57_1_28"]},
        "3837": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_16_1_1_32_1_28"]},
        "3838": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_4_1_1_8_1_28"]},
        "3839": {"vr": "LO", "Value": ["X_1_1_1_2_1_1_7_1_1_14_1_28"]},
        "3840": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_9_1_1_18_1_28"]},
        "3841": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_36_1_1_11_1_28"]},
        "3842": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_2_1_1_4_1_28"]},
        "3843": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_11_1_1_22_1_28"]},
        "3844": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_33_1_1_5_1_28"]},
        "3845": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_21_1_1_42_1_28"]},
        "3846": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_7_1_1_14_1_28"]},
        "3847": {"vr": "LO", "Value": ["X_1_1_1_43_1_1_57_1_1_53_1_28"]},
        "3848": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_17_1_1_34_1_28"]},
        "3849": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_48_1_1_35_1_28"]},
        "3850": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_60_1_1_59_1_28"]},
        "3851": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_55_1_1_49_1_28"]},
        "3852": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_58_1_1_55_1_28"]},
        "3853": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_56_1_1_51_1_28"]},
        "3854": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_60_1_1_59_1_28"]},
        "3855": {"vr": "LO", "Value": ["X_1_1_1_67_1_1_23_1_1_46_1_28"]},
        "3856": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_41_1_1_21_1_28"]},
        "3857": {"vr": "LO", "Value": ["X_1_1_1_14_1_1_25_1_1_50_1_28"]},
        "3858": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_28_1_1_56_1_28"]},
        "3859": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_23_1_1_46_1_28"]},
        "3860": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_15_1_1_30_1_28"]},
        "3861": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_48_1_1_35_1_28"]},
        "3862": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_29_1_1_58_1_28"]},
        "3863": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_4_1_1_8_1_28"]},
        "3864": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_23_1_1_46_1_28"]},
        "3865": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_46_1_1_31_1_28"]},
        "3866": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_36_1_1_11_1_28"]},
        "3867": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_44_1_1_27_1_28"]},
        "3868": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_18_1_1_36_1_28"]},
        "3869": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_36_1_1_11_1_28"]},
        "3870": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_4_1_1_8_1_28"]},
        "3871": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_15_1_1_30_1_28"]},
        "3872": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_35_1_1_9_1_28"]},
        "3873": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_5_1_1_10_1_28"]},
        "3874": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_58_1_1_55_1_28"]},
        "3875": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_45_1_1_29_1_28"]},
        "3876": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_7_1_1_14_1_28"]},
        "3877": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_58_1_1_55_1_28"]},
        "3878": {"vr": "LO", "Value": ["X_1_1_1_56_1_1_37_1_1_13_1_28"]},
        "3879": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_18_1_1_36_1_28"]},
        "3880": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_32_1_1_3_1_28"]},
        "3881": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_56_1_1_51_1_28"]},
        "3882": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_60_1_1_59_1_28"]},
        "3883": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_9_1_1_18_1_28"]},
        "3884": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_4_1_1_8_1_28"]},
        "3885": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_24_1_1_48_1_28"]},
        "3886": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_31_1_1_1_1_28"]},
        "3887": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_48_1_1_35_1_28"]},
        "3888": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_52_1_1_43_1_28"]},
        "3889": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_35_1_1_9_1_28"]},
        "3890": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_28_1_1_56_1_28"]},
        "3891": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_54_1_1_47_1_28"]},
        "3892": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_4_1_1_8_1_28"]},
        "3893": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_28_1_1_56_1_28"]},
        "3894": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_41_1_1_21_1_28"]},
        "3895": {"vr": "LO", "Value": ["X_1_1_1_17_1_1_13_1_1_26_1_28"]},
        "3896": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_43_1_1_25_1_28"]},
        "3897": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_3_1_1_6_1_28"]},
        "3898": {"vr": "LO", "Value": ["X_1_1_1_41_1_1_2_1_1_4_1_28"]},
        "3899": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_10_1_1_20_1_28"]},
        "3900": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_18_1_1_36_1_28"]},
        "3901": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_25_1_1_50_1_28"]},
        "3902": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_56_1_1_51_1_28"]},
        "3903": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_40_1_1_19_1_28"]},
        "3904": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_47_1_1_33_1_28"]},
        "3905": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_12_1_1_24_1_28"]},
        "3906": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_6_1_1_12_1_28"]},
        "3907": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_36_1_1_11_1_28"]},
        "3908": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_51_1_1_41_1_28"]},
        "3909": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_23_1_1_46_1_28"]},
        "3910": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_45_1_1_29_1_28"]},
        "3911": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_27_1_1_54_1_28"]},
        "3912": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_1_1_1_2_1_28"]},
        "3913": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_45_1_1_29_1_28"]},
        "3914": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_49_1_1_37_1_28"]},
        "3915": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_9_1_1_18_1_28"]},
        "3916": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_27_1_1_54_1_28"]},
        "3917": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_34_1_1_7_1_28"]},
        "3918": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_8_1_1_16_1_28"]},
        "3919": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_36_1_1_11_1_28"]},
        "3920": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_23_1_1_46_1_28"]},
        "3921": {"vr": "LO", "Value": ["X_1_1_1_57_1_1_16_1_1_32_1_28"]},
        "3922": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_3_1_1_6_1_28"]},
        "3923": {"vr": "LO", "Value": ["X_1_1_1_10_1_1_27_1_1_54_1_28"]},
        "3924": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_14_1_1_28_1_28"]},
        "3925": {"vr": "LO", "Value": ["X_1_1_1_19_1_1_55_1_1_49_1_28"]},
        "3926": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_60_1_1_59_1_28"]},
        "3927": {"vr": "LO", "Value": ["X_1_1_1_50_1_1_22_1_1_44_1_28"]},
        "3928": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_38_1_1_15_1_28"]},
        "3929": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_23_1_1_46_1_28"]},
        "3930": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_24_1_1_48_1_28"]},
        "3931": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_44_1_1_27_1_28"]},
        "3932": {"vr": "LO", "Value": ["X_1_1_1_46_1_1_23_1_1_46_1_28"]},
        "3933": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_53_1_1_45_1_28"]},
        "3934": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_7_1_1_14_1_28"]},
        "3935": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_45_1_1_29_1_28"]},
        "3936": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_46_1_1_31_1_28"]},
        "3937": {"vr": "LO", "Value": ["X_1_1_1_45_1_1_37_1_1_13_1_28"]},
        "3938": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_40_1_1_19_1_28"]},
        "3939": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_54_1_1_47_1_28"]},
        "3940": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_20_1_1_40_1_28"]},
        "3941": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_7_1_1_14_1_28"]},
        "3942": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_19_1_1_38_1_28"]},
        "3943": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_28_1_1_56_1_28"]},
        "3944": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_60_1_1_59_1_28"]},
        "3945": {"vr": "LO", "Value": ["X_1_1_1_23_1_1_36_1_1_11_1_28"]},
        "3946": {"vr": "LO", "Value": ["X_1_1_1_62_1_1_33_1_1_5_1_28"]},
        "3947": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_55_1_1_49_1_28"]},
        "3948": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_9_1_1_18_1_28"]},
        "3949": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_9_1_1_18_1_28"]},
        "3950": {"vr": "LO", "Value": ["X_1_1_1_42_1_1_23_1_1_46_1_28"]},
        "3951": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_21_1_1_42_1_28"]},
        "3952": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_4_1_1_8_1_28"]},
        "3953": {"vr": "LO", "Value": ["X_1_1_1_37_1_1_49_1_1_37_1_28"]},
        "3954": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_40_1_1_19_1_28"]},
        "3955": {"vr": "LO", "Value": ["X_1_1_1_66_1_1_45_1_1_29_1_28"]},
        "3956": {"vr": "LO", "Value": ["X_1_1_1_36_1_1_4_1_1_8_1_28"]},
        "3957": {"vr": "LO", "Value": ["X_1_1_1_33_1_1_42_1_1_23_1_28"]},
        "3958": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_23_1_1_46_1_28"]},
        "3959": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_28_1_1_56_1_28"]},
        "3960": {"vr": "LO", "Value": ["X_1_1_1_44_1_1_55_1_1_49_1_28"]},
        "3961": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_27_1_1_54_1_28"]},
        "3962": {"vr": "LO", "Value": ["X_1_1_1_55_1_1_38_1_1_15_1_28"]},
        "3963": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_42_1_1_23_1_28"]},
        "3964": {"vr": "LO", "Value": ["X_1_1_1_47_1_1_7_1_1_14_1_28"]},
        "3965": {"vr": "LO", "Value": ["X_1_1_1_65_1_1_40_1_1_19_1_28"]},
        "3966": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_28_1_1_56_1_28"]},
        "3967": {"vr": "LO", "Value": ["X_1_1_1_27_1_1_24_1_1_48_1_28"]},
        "3968": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_49_1_1_37_1_28"]},
        "3969": {"vr": "LO", "Value": ["X_1_1_1_5_1_1_60_1_1_59_1_28"]},
        "3970": {"vr": "LO", "Value": ["X_1_1_1_30_1_1_48_1_1_35_1_28"]},
        "3971": {"vr": "LO", "Value": ["X_1_1_1_7_1_1_26_1_1_52_1_28"]},
        "3972": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_35_1_1_9_1_28"]},
        "3973": {"vr": "LO", "Value": ["X_1_1_1_26_1_1_57_1_1_53_1_28"]},
        "3974": {"vr": "LO", "Value": ["X_1_1_1_20_1_1_33_1_1_5_1_28"]},
        "3975": {"vr": "LO", "Value": ["X_1_1_1_53_1_1_13_1_1_26_1_28"]},
        "3976": {"vr": "LO", "Value": ["X_1_1_1_3_1_1_52_1_1_43_1_28"]},
        "3977": {"vr": "LO", "Value": ["X_1_1_1_9_1_1_57_1_1_53_1_28"]},
        "3978": {"vr": "LO", "Value": ["X_1_1_1_64_1_1_56_1_1_51_1_28"]},
        "3979": {"vr": "LO", "Value": ["X_1_1_1_29_1_1_38_1_1_15_1_28"]},
        "3980": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_30_1_1_60_1_28"]},
        "3981": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_56_1_1_51_1_28"]},
        "3982": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_51_1_1_41_1_28"]},
        "3983": {"vr": "LO", "Value": ["X_1_1_1_4_1_1_43_1_1_25_1_28"]},
        "3984": {"vr": "LO", "Value": ["X_1_1_1_18_1_1_39_1_1_17_1_28"]},
        "3985": {"vr": "LO", "Value": ["X_1_1_1_39_1_1_32_1_1_3_1_28"]},
        "3986": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_53_1_1_45_1_28"]},
        "3987": {"vr": "LO", "Value": ["X_1_1_1_28_1_1_15_1_1_30_1_28"]},
        "3988": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_54_1_1_47_1_28"]},
        "3989": {"vr": "LO", "Value": ["X_1_1_1_25_1_1_21_1_1_42_1_28"]},
        "3990": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_17_1_1_34_1_28"]},
        "3991": {"vr": "LO", "Value": ["X_1_1_1_38_1_1_53_1_1_45_1_28"]},
        "3992": {"vr": "LO", "Value": ["X_1_1_1_63_1_1_48_1_1_35_1_28"]},
        "3993": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_27_1_1_54_1_28"]},
        "3994": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_42_1_1_23_1_28"]},
        "3995": {"vr": "LO", "Value": ["X_1_1_1_13_1_1_7_1_1_14_1_28"]},
        "3996": {"vr": "LO", "Value": ["X_1_1_1_6_1_1_38_1_1_15_1_28"]},
        "3997": {"vr": "LO", "Value": ["X_1_1_1_59_1_1_25_1_1_50_1_28"]},
        "3998": {"vr": "LO", "Value": ["X_1_1_1_31_1_1_36_1_1_11_1_28"]},
        "3999": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_51_1_1_41_1_28"]},
        "4000": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_23_1_1_46_1_28"]},
        "4001": {"vr": "LO", "Value": ["X_1_1_1_48_1_1_23_1_1_46_1_28"]},
        "4002": {"vr": "LO", "Value": ["X_1_1_1_52_1_1_17_1_1_34_1_28"]},
        "4003": {"vr": "LO", "Value": ["X_1_1_1_24_1_1_30_1_1_60_1_28"]},
        "4004": {"vr": "LO", "Value": ["X_1_1_1_58_1_1_38_1_1_15_1_28"]},
        "4005": {"vr": "LO", "Value": ["X_1_1_1_16_1_1_17_1_1_34_1_28"]},
        "4006": {"vr": "LO", "Value": ["X_1_1_1_8_1_1_32_1_1_3_1_28"]},
        "4007": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_46_1_1_31_1_28"]},
        "4008": {"vr": "LO", "Value": ["X_1_1_1_15_1_1_13_1_1_26_1_28"]},
        "4009": {"vr": "LO", "Value": ["X_1_1_1_34_1_1_4_1_1_8_1_28"]},
        "4010": {"vr": "LO", "Value": ["X_1_1_1_35_1_1_28_1_1_56_1_28"]},
        "4011": {"vr": "LO", "Value": ["X_1_1_1_12_1_1_25_1_1_50_1_28"]},
        "4012": {"vr": "LO", "Value": ["X_1_1_1_54_1_1_24_1_1_48_1_28"]},
        "4013": {"vr": "LO", "Value": ["X_1_1_1_11_1_1_21_1_1_42_1_28"]},
        "4014": {"vr": "LO", "Value": ["X_1_1_1_22_1_1_5_1_1_10_1_28"]},
        "4015": {"vr": "LO", "Value": ["X_1_1_1_61_1_1_60_1_1_59_1_28"]},
        "4016": {"vr": "LO", "Value": ["X_1_1_1_60_1_1_20_1_1_40_1_28"]},
        "4017": {"vr": "LO", "Value": ["X_1_1_1_32_1_1_46_1_1_31_1_28"]},
        "4018": {"vr": "LO", "Value": ["X_1_1_1_51_1_1_14_1_1_28_1_28"]},
        "4019": {"vr": "LO", "Value": ["X_1_1_1_40_1_1_41_1_1_21_1_28"]},
    },
    "00211121": {
        "0": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3": {"vr": "CS", "Value": ["NONE"]},
        "4": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "5": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "6": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "7": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "8": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "9": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "10": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "11": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "12": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "13": {"vr": "CS", "Value": ["NONE"]},
        "14": {"vr": "CS", "Value": ["NONE"]},
        "15": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "16": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "17": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "18": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "19": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "20": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "21": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "22": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "23": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "24": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "25": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "26": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "27": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "28": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "29": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "30": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "31": {"vr": "CS", "Value": ["NONE"]},
        "32": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "33": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "34": {"vr": "CS", "Value": ["NONE"]},
        "35": {"vr": "CS", "Value": ["NONE"]},
        "36": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "37": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "38": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "39": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "40": {"vr": "CS", "Value": ["NONE"]},
        "41": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "42": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "43": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "44": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "45": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "46": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "47": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "48": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "49": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "50": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "51": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "52": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "53": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "54": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "55": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "56": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "57": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "58": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "59": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "60": {"vr": "CS", "Value": ["NONE"]},
        "61": {"vr": "CS", "Value": ["NONE"]},
        "62": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "63": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "64": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "65": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "66": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "67": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "68": {"vr": "CS", "Value": ["NONE"]},
        "69": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "70": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "71": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "72": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "73": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "74": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "75": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "76": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "77": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "78": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "79": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "80": {"vr": "CS", "Value": ["NONE"]},
        "81": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "82": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "83": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "84": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "85": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "86": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "87": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "88": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "89": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "90": {"vr": "CS", "Value": ["NONE"]},
        "91": {"vr": "CS", "Value": ["NONE"]},
        "92": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "93": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "94": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "95": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "96": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "97": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "98": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "99": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "112": {"vr": "CS", "Value": ["NONE"]},
        "113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "114": {"vr": "CS", "Value": ["NONE"]},
        "115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "128": {"vr": "CS", "Value": ["NONE"]},
        "129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "132": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "160": {"vr": "CS", "Value": ["NONE"]},
        "161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "165": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "191": {"vr": "CS", "Value": ["NONE"]},
        "192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "193": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "198": {"vr": "CS", "Value": ["NONE"]},
        "199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "210": {"vr": "CS", "Value": ["NONE"]},
        "211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "220": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "227": {"vr": "CS", "Value": ["NONE"]},
        "228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "243": {"vr": "CS", "Value": ["NONE"]},
        "244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "246": {"vr": "CS", "Value": ["NONE"]},
        "247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "256": {"vr": "CS", "Value": ["NONE"]},
        "257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "264": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "270": {"vr": "CS", "Value": ["NONE"]},
        "271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "275": {"vr": "CS", "Value": ["NONE"]},
        "276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "290": {"vr": "CS", "Value": ["NONE"]},
        "291": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "301": {"vr": "CS", "Value": ["NONE"]},
        "302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "311": {"vr": "CS", "Value": ["NONE"]},
        "312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "313": {"vr": "CS", "Value": ["NONE"]},
        "314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "316": {"vr": "CS", "Value": ["NONE"]},
        "317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "347": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "349": {"vr": "CS", "Value": ["NONE"]},
        "350": {"vr": "CS", "Value": ["NONE"]},
        "351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "361": {"vr": "CS", "Value": ["NONE"]},
        "362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "363": {"vr": "CS", "Value": ["NONE"]},
        "364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "368": {"vr": "CS", "Value": ["NONE"]},
        "369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "376": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "381": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "382": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "383": {"vr": "CS", "Value": ["NONE"]},
        "384": {"vr": "CS", "Value": ["NONE"]},
        "385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "396": {"vr": "CS", "Value": ["NONE"]},
        "397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "399": {"vr": "CS", "Value": ["NONE"]},
        "400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "417": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "418": {"vr": "CS", "Value": ["NONE"]},
        "419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "424": {"vr": "CS", "Value": ["NONE"]},
        "425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "445": {"vr": "CS", "Value": ["NONE"]},
        "446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "448": {"vr": "CS", "Value": ["NONE"]},
        "449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "469": {"vr": "CS", "Value": ["NONE"]},
        "470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "474": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "475": {"vr": "CS", "Value": ["NONE"]},
        "476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "483": {"vr": "CS", "Value": ["NONE"]},
        "484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "497": {"vr": "CS", "Value": ["NONE"]},
        "498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "501": {"vr": "CS", "Value": ["NONE"]},
        "502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "507": {"vr": "CS", "Value": ["NONE"]},
        "508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "514": {"vr": "CS", "Value": ["NONE"]},
        "515": {"vr": "CS", "Value": ["NONE"]},
        "516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "520": {"vr": "CS", "Value": ["NONE"]},
        "521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "522": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "531": {"vr": "CS", "Value": ["NONE"]},
        "532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "539": {"vr": "CS", "Value": ["NONE"]},
        "540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "542": {"vr": "CS", "Value": ["NONE"]},
        "543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "544": {"vr": "CS", "Value": ["NONE"]},
        "545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "548": {"vr": "CS", "Value": ["NONE"]},
        "549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "553": {"vr": "CS", "Value": ["NONE"]},
        "554": {"vr": "CS", "Value": ["NONE"]},
        "555": {"vr": "CS", "Value": ["NONE"]},
        "556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "567": {"vr": "CS", "Value": ["NONE"]},
        "568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "585": {"vr": "CS", "Value": ["NONE"]},
        "586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "587": {"vr": "CS", "Value": ["NONE"]},
        "588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "600": {"vr": "CS", "Value": ["NONE"]},
        "601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "610": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "611": {"vr": "CS", "Value": ["NONE"]},
        "612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "624": {"vr": "CS", "Value": ["NONE"]},
        "625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "628": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "636": {"vr": "CS", "Value": ["NONE"]},
        "637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "640": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "663": {"vr": "CS", "Value": ["NONE"]},
        "664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "668": {"vr": "CS", "Value": ["NONE"]},
        "669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "679": {"vr": "CS", "Value": ["NONE"]},
        "680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "687": {"vr": "CS", "Value": ["NONE"]},
        "688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "690": {"vr": "CS", "Value": ["NONE"]},
        "691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "699": {"vr": "CS", "Value": ["NONE"]},
        "700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "707": {"vr": "CS", "Value": ["NONE"]},
        "708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "714": {"vr": "CS", "Value": ["NONE"]},
        "715": {"vr": "CS", "Value": ["NONE"]},
        "716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "732": {"vr": "CS", "Value": ["NONE"]},
        "733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "736": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "757": {"vr": "CS", "Value": ["NONE"]},
        "758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "771": {"vr": "CS", "Value": ["NONE"]},
        "772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "777": {"vr": "CS", "Value": ["NONE"]},
        "778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "788": {"vr": "CS", "Value": ["NONE"]},
        "789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "791": {"vr": "CS", "Value": ["NONE"]},
        "792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "805": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "810": {"vr": "CS", "Value": ["NONE"]},
        "811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "816": {"vr": "CS", "Value": ["NONE"]},
        "817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "820": {"vr": "CS", "Value": ["NONE"]},
        "821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "827": {"vr": "CS", "Value": ["NONE"]},
        "828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "829": {"vr": "CS", "Value": ["NONE"]},
        "830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "845": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "846": {"vr": "CS", "Value": ["NONE"]},
        "847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "850": {"vr": "CS", "Value": ["NONE"]},
        "851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "855": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "861": {"vr": "CS", "Value": ["NONE"]},
        "862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "867": {"vr": "CS", "Value": ["NONE"]},
        "868": {"vr": "CS", "Value": ["NONE"]},
        "869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "870": {"vr": "CS", "Value": ["NONE"]},
        "871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "875": {"vr": "CS", "Value": ["NONE"]},
        "876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "878": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "882": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "885": {"vr": "CS", "Value": ["NONE"]},
        "886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "916": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "918": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "919": {"vr": "CS", "Value": ["NONE"]},
        "920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "924": {"vr": "CS", "Value": ["NONE"]},
        "925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "926": {"vr": "CS", "Value": ["NONE"]},
        "927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "932": {"vr": "CS", "Value": ["NONE"]},
        "933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "936": {"vr": "CS", "Value": ["NONE"]},
        "937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "948": {"vr": "CS", "Value": ["NONE"]},
        "949": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "956": {"vr": "CS", "Value": ["NONE"]},
        "957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "961": {"vr": "CS", "Value": ["NONE"]},
        "962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "968": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "978": {"vr": "CS", "Value": ["NONE"]},
        "979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "983": {"vr": "CS", "Value": ["NONE"]},
        "984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "996": {"vr": "CS", "Value": ["NONE"]},
        "997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1015": {"vr": "CS", "Value": ["NONE"]},
        "1016": {"vr": "CS", "Value": ["NONE"]},
        "1017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1025": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1029": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1030": {"vr": "CS", "Value": ["NONE"]},
        "1031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1032": {"vr": "CS", "Value": ["NONE"]},
        "1033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1039": {"vr": "CS", "Value": ["NONE"]},
        "1040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1053": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1060": {"vr": "CS", "Value": ["NONE"]},
        "1061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1064": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1065": {"vr": "CS", "Value": ["NONE"]},
        "1066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1072": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1073": {"vr": "CS", "Value": ["NONE"]},
        "1074": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1075": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1077": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1079": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1081": {"vr": "CS", "Value": ["NONE"]},
        "1082": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1083": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1084": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1086": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1088": {"vr": "CS", "Value": ["NONE"]},
        "1089": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1090": {"vr": "CS", "Value": ["NONE"]},
        "1091": {"vr": "CS", "Value": ["NONE"]},
        "1092": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1097": {"vr": "CS", "Value": ["NONE"]},
        "1098": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1105": {"vr": "CS", "Value": ["NONE"]},
        "1106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1110": {"vr": "CS", "Value": ["NONE"]},
        "1111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1131": {"vr": "CS", "Value": ["NONE"]},
        "1132": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1136": {"vr": "CS", "Value": ["NONE"]},
        "1137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1147": {"vr": "CS", "Value": ["NONE"]},
        "1148": {"vr": "CS", "Value": ["NONE"]},
        "1149": {"vr": "CS", "Value": ["NONE"]},
        "1150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1160": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1165": {"vr": "CS", "Value": ["NONE"]},
        "1166": {"vr": "CS", "Value": ["NONE"]},
        "1167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1178": {"vr": "CS", "Value": ["NONE"]},
        "1179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1189": {"vr": "CS", "Value": ["NONE"]},
        "1190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1191": {"vr": "CS", "Value": ["NONE"]},
        "1192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1193": {"vr": "CS", "Value": ["NONE"]},
        "1194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1201": {"vr": "CS", "Value": ["NONE"]},
        "1202": {"vr": "CS", "Value": ["NONE"]},
        "1203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1219": {"vr": "CS", "Value": ["NONE"]},
        "1220": {"vr": "CS", "Value": ["NONE"]},
        "1221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1243": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1256": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1260": {"vr": "CS", "Value": ["NONE"]},
        "1261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1264": {"vr": "CS", "Value": ["NONE"]},
        "1265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1270": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1271": {"vr": "CS", "Value": ["NONE"]},
        "1272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1282": {"vr": "CS", "Value": ["NONE"]},
        "1283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1291": {"vr": "CS", "Value": ["NONE"]},
        "1292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1300": {"vr": "CS", "Value": ["NONE"]},
        "1301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1309": {"vr": "CS", "Value": ["NONE"]},
        "1310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1313": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1324": {"vr": "CS", "Value": ["NONE"]},
        "1325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1326": {"vr": "CS", "Value": ["NONE"]},
        "1327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1330": {"vr": "CS", "Value": ["NONE"]},
        "1331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1333": {"vr": "CS", "Value": ["NONE"]},
        "1334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1347": {"vr": "CS", "Value": ["NONE"]},
        "1348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1358": {"vr": "CS", "Value": ["NONE"]},
        "1359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1375": {"vr": "CS", "Value": ["NONE"]},
        "1376": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1381": {"vr": "CS", "Value": ["NONE"]},
        "1382": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1384": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1404": {"vr": "CS", "Value": ["NONE"]},
        "1405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1413": {"vr": "CS", "Value": ["NONE"]},
        "1414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1417": {"vr": "CS", "Value": ["NONE"]},
        "1418": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1430": {"vr": "CS", "Value": ["NONE"]},
        "1431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1442": {"vr": "CS", "Value": ["NONE"]},
        "1443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1449": {"vr": "CS", "Value": ["NONE"]},
        "1450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1455": {"vr": "CS", "Value": ["NONE"]},
        "1456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1460": {"vr": "CS", "Value": ["NONE"]},
        "1461": {"vr": "CS", "Value": ["NONE"]},
        "1462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1474": {"vr": "CS", "Value": ["NONE"]},
        "1475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1488": {"vr": "CS", "Value": ["NONE"]},
        "1489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1493": {"vr": "CS", "Value": ["NONE"]},
        "1494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1501": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1512": {"vr": "CS", "Value": ["NONE"]},
        "1513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1515": {"vr": "CS", "Value": ["NONE"]},
        "1516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1517": {"vr": "CS", "Value": ["NONE"]},
        "1518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1520": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1522": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1536": {"vr": "CS", "Value": ["NONE"]},
        "1537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1539": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1548": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1553": {"vr": "CS", "Value": ["NONE"]},
        "1554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1555": {"vr": "CS", "Value": ["NONE"]},
        "1556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1559": {"vr": "CS", "Value": ["NONE"]},
        "1560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1562": {"vr": "CS", "Value": ["NONE"]},
        "1563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1574": {"vr": "CS", "Value": ["NONE"]},
        "1575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1585": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1590": {"vr": "CS", "Value": ["NONE"]},
        "1591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1594": {"vr": "CS", "Value": ["NONE"]},
        "1595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1600": {"vr": "CS", "Value": ["NONE"]},
        "1601": {"vr": "CS", "Value": ["NONE"]},
        "1602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1603": {"vr": "CS", "Value": ["NONE"]},
        "1604": {"vr": "CS", "Value": ["NONE"]},
        "1605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1610": {"vr": "CS", "Value": ["NONE"]},
        "1611": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1625": {"vr": "CS", "Value": ["NONE"]},
        "1626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1628": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1636": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1640": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1643": {"vr": "CS", "Value": ["NONE"]},
        "1644": {"vr": "CS", "Value": ["NONE"]},
        "1645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1649": {"vr": "CS", "Value": ["NONE"]},
        "1650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1668": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1679": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1687": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1689": {"vr": "CS", "Value": ["NONE"]},
        "1690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1691": {"vr": "CS", "Value": ["NONE"]},
        "1692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1700": {"vr": "CS", "Value": ["NONE"]},
        "1701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1717": {"vr": "CS", "Value": ["NONE"]},
        "1718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1720": {"vr": "CS", "Value": ["NONE"]},
        "1721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1736": {"vr": "CS", "Value": ["NONE"]},
        "1737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1738": {"vr": "CS", "Value": ["NONE"]},
        "1739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1757": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1775": {"vr": "CS", "Value": ["NONE"]},
        "1776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1777": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1788": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1796": {"vr": "CS", "Value": ["NONE"]},
        "1797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1802": {"vr": "CS", "Value": ["NONE"]},
        "1803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1805": {"vr": "CS", "Value": ["NONE"]},
        "1806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1827": {"vr": "CS", "Value": ["NONE"]},
        "1828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1837": {"vr": "CS", "Value": ["NONE"]},
        "1838": {"vr": "CS", "Value": ["NONE"]},
        "1839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1845": {"vr": "CS", "Value": ["NONE"]},
        "1846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1855": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1872": {"vr": "CS", "Value": ["NONE"]},
        "1873": {"vr": "CS", "Value": ["NONE"]},
        "1874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1878": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1882": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1885": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1889": {"vr": "CS", "Value": ["NONE"]},
        "1890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1909": {"vr": "CS", "Value": ["NONE"]},
        "1910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1914": {"vr": "CS", "Value": ["NONE"]},
        "1915": {"vr": "CS", "Value": ["NONE"]},
        "1916": {"vr": "CS", "Value": ["NONE"]},
        "1917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1918": {"vr": "CS", "Value": ["NONE"]},
        "1919": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1920": {"vr": "CS", "Value": ["NONE"]},
        "1921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1933": {"vr": "CS", "Value": ["NONE"]},
        "1934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1949": {"vr": "CS", "Value": ["NONE"]},
        "1950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1961": {"vr": "CS", "Value": ["NONE"]},
        "1962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1967": {"vr": "CS", "Value": ["NONE"]},
        "1968": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1973": {"vr": "CS", "Value": ["NONE"]},
        "1974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1986": {"vr": "CS", "Value": ["NONE"]},
        "1987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1993": {"vr": "CS", "Value": ["NONE"]},
        "1994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1996": {"vr": "CS", "Value": ["NONE"]},
        "1997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "1999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2001": {"vr": "CS", "Value": ["NONE"]},
        "2002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2012": {"vr": "CS", "Value": ["NONE"]},
        "2013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2017": {"vr": "CS", "Value": ["NONE"]},
        "2018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2025": {"vr": "CS", "Value": ["NONE"]},
        "2026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2029": {"vr": "CS", "Value": ["NONE"]},
        "2030": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2032": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2039": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2053": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2060": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2064": {"vr": "CS", "Value": ["NONE"]},
        "2065": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2072": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2073": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2074": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2075": {"vr": "CS", "Value": ["NONE"]},
        "2076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2077": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2079": {"vr": "CS", "Value": ["NONE"]},
        "2080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2081": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2082": {"vr": "CS", "Value": ["NONE"]},
        "2083": {"vr": "CS", "Value": ["NONE"]},
        "2084": {"vr": "CS", "Value": ["NONE"]},
        "2085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2086": {"vr": "CS", "Value": ["NONE"]},
        "2087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2088": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2089": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2090": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2091": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2092": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2097": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2098": {"vr": "CS", "Value": ["NONE"]},
        "2099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2102": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2109": {"vr": "CS", "Value": ["NONE"]},
        "2110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2132": {"vr": "CS", "Value": ["NONE"]},
        "2133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2146": {"vr": "CS", "Value": ["NONE"]},
        "2147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2158": {"vr": "CS", "Value": ["NONE"]},
        "2159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2160": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2165": {"vr": "CS", "Value": ["NONE"]},
        "2166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2170": {"vr": "CS", "Value": ["NONE"]},
        "2171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2172": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2174": {"vr": "CS", "Value": ["NONE"]},
        "2175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2187": {"vr": "CS", "Value": ["NONE"]},
        "2188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2191": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2192": {"vr": "CS", "Value": ["NONE"]},
        "2193": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2194": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2204": {"vr": "CS", "Value": ["NONE"]},
        "2205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2214": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2218": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2220": {"vr": "CS", "Value": ["NONE"]},
        "2221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2230": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2239": {"vr": "CS", "Value": ["NONE"]},
        "2240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2243": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2254": {"vr": "CS", "Value": ["NONE"]},
        "2255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2256": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2258": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2259": {"vr": "CS", "Value": ["NONE"]},
        "2260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2263": {"vr": "CS", "Value": ["NONE"]},
        "2264": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2270": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2278": {"vr": "CS", "Value": ["NONE"]},
        "2279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2280": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2287": {"vr": "CS", "Value": ["NONE"]},
        "2288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2291": {"vr": "CS", "Value": ["NONE"]},
        "2292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2295": {"vr": "CS", "Value": ["NONE"]},
        "2296": {"vr": "CS", "Value": ["NONE"]},
        "2297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2313": {"vr": "CS", "Value": ["NONE"]},
        "2314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2315": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2328": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2340": {"vr": "CS", "Value": ["NONE"]},
        "2341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2343": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2346": {"vr": "CS", "Value": ["NONE"]},
        "2347": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2359": {"vr": "CS", "Value": ["NONE"]},
        "2360": {"vr": "CS", "Value": ["NONE"]},
        "2361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2365": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2369": {"vr": "CS", "Value": ["NONE"]},
        "2370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2376": {"vr": "CS", "Value": ["NONE"]},
        "2377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2381": {"vr": "CS", "Value": ["NONE"]},
        "2382": {"vr": "CS", "Value": ["NONE"]},
        "2383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2384": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2385": {"vr": "CS", "Value": ["NONE"]},
        "2386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2389": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2394": {"vr": "CS", "Value": ["NONE"]},
        "2395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2400": {"vr": "CS", "Value": ["NONE"]},
        "2401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2405": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2417": {"vr": "CS", "Value": ["NONE"]},
        "2418": {"vr": "CS", "Value": ["NONE"]},
        "2419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2431": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2433": {"vr": "CS", "Value": ["NONE"]},
        "2434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2436": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2446": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2454": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2474": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2479": {"vr": "CS", "Value": ["NONE"]},
        "2480": {"vr": "CS", "Value": ["NONE"]},
        "2481": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2492": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2498": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2501": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2503": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2511": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2515": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2520": {"vr": "CS", "Value": ["NONE"]},
        "2521": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2522": {"vr": "CS", "Value": ["NONE"]},
        "2523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2525": {"vr": "CS", "Value": ["NONE"]},
        "2526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2529": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2532": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2534": {"vr": "CS", "Value": ["NONE"]},
        "2535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2537": {"vr": "CS", "Value": ["NONE"]},
        "2538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2539": {"vr": "CS", "Value": ["NONE"]},
        "2540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2546": {"vr": "CS", "Value": ["NONE"]},
        "2547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2548": {"vr": "CS", "Value": ["NONE"]},
        "2549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2553": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2555": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2557": {"vr": "CS", "Value": ["NONE"]},
        "2558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2571": {"vr": "CS", "Value": ["NONE"]},
        "2572": {"vr": "CS", "Value": ["NONE"]},
        "2573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2575": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2584": {"vr": "CS", "Value": ["NONE"]},
        "2585": {"vr": "CS", "Value": ["NONE"]},
        "2586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2589": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2596": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2598": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2600": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2609": {"vr": "CS", "Value": ["NONE"]},
        "2610": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2611": {"vr": "CS", "Value": ["NONE"]},
        "2612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2614": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2618": {"vr": "CS", "Value": ["NONE"]},
        "2619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2628": {"vr": "CS", "Value": ["NONE"]},
        "2629": {"vr": "CS", "Value": ["NONE"]},
        "2630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2636": {"vr": "CS", "Value": ["NONE"]},
        "2637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2638": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2639": {"vr": "CS", "Value": ["NONE"]},
        "2640": {"vr": "CS", "Value": ["NONE"]},
        "2641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2653": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2654": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2658": {"vr": "CS", "Value": ["NONE"]},
        "2659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2668": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2673": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2679": {"vr": "CS", "Value": ["NONE"]},
        "2680": {"vr": "CS", "Value": ["NONE"]},
        "2681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2687": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2696": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2698": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2702": {"vr": "CS", "Value": ["NONE"]},
        "2703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2716": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2723": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2726": {"vr": "CS", "Value": ["NONE"]},
        "2727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2729": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2735": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2736": {"vr": "CS", "Value": ["NONE"]},
        "2737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2741": {"vr": "CS", "Value": ["NONE"]},
        "2742": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2744": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2746": {"vr": "CS", "Value": ["NONE"]},
        "2747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2750": {"vr": "CS", "Value": ["NONE"]},
        "2751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2756": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2757": {"vr": "CS", "Value": ["NONE"]},
        "2758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2763": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2765": {"vr": "CS", "Value": ["NONE"]},
        "2766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2770": {"vr": "CS", "Value": ["NONE"]},
        "2771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2777": {"vr": "CS", "Value": ["NONE"]},
        "2778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2781": {"vr": "CS", "Value": ["NONE"]},
        "2782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2788": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2792": {"vr": "CS", "Value": ["NONE"]},
        "2793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2795": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2797": {"vr": "CS", "Value": ["NONE"]},
        "2798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2805": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2806": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2818": {"vr": "CS", "Value": ["NONE"]},
        "2819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2822": {"vr": "CS", "Value": ["NONE"]},
        "2823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2825": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2827": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2830": {"vr": "CS", "Value": ["NONE"]},
        "2831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2832": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2845": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2852": {"vr": "CS", "Value": ["NONE"]},
        "2853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2855": {"vr": "CS", "Value": ["NONE"]},
        "2856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2862": {"vr": "CS", "Value": ["NONE"]},
        "2863": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2878": {"vr": "CS", "Value": ["NONE"]},
        "2879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2882": {"vr": "CS", "Value": ["NONE"]},
        "2883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2885": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2900": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2906": {"vr": "CS", "Value": ["NONE"]},
        "2907": {"vr": "CS", "Value": ["NONE"]},
        "2908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2916": {"vr": "CS", "Value": ["NONE"]},
        "2917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2918": {"vr": "CS", "Value": ["NONE"]},
        "2919": {"vr": "CS", "Value": ["NONE"]},
        "2920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2923": {"vr": "CS", "Value": ["NONE"]},
        "2924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2928": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2930": {"vr": "CS", "Value": ["NONE"]},
        "2931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2935": {"vr": "CS", "Value": ["NONE"]},
        "2936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2937": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2945": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2946": {"vr": "CS", "Value": ["NONE"]},
        "2947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2949": {"vr": "CS", "Value": ["NONE"]},
        "2950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2954": {"vr": "CS", "Value": ["NONE"]},
        "2955": {"vr": "CS", "Value": ["NONE"]},
        "2956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2961": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2968": {"vr": "CS", "Value": ["NONE"]},
        "2969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2985": {"vr": "CS", "Value": ["NONE"]},
        "2986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2996": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "2999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3005": {"vr": "CS", "Value": ["NONE"]},
        "3006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3009": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3011": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3019": {"vr": "CS", "Value": ["NONE"]},
        "3020": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3021": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3022": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3023": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3024": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3025": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3026": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3027": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3028": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3029": {"vr": "CS", "Value": ["NONE"]},
        "3030": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3031": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3032": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3033": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3034": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3035": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3036": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3037": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3038": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3039": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3040": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3041": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3042": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3043": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3044": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3045": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3046": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3047": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3048": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3049": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3050": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3051": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3052": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3053": {"vr": "CS", "Value": ["NONE"]},
        "3054": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3055": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3056": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3057": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3058": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3059": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3060": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3061": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3062": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3063": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3064": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3065": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3066": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3067": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3068": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3069": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3070": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3071": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3072": {"vr": "CS", "Value": ["NONE"]},
        "3073": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3074": {"vr": "CS", "Value": ["NONE"]},
        "3075": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3076": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3077": {"vr": "CS", "Value": ["NONE"]},
        "3078": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3079": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3080": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3081": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3082": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3083": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3084": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3085": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3086": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3087": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3088": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3089": {"vr": "CS", "Value": ["NONE"]},
        "3090": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3091": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3092": {"vr": "CS", "Value": ["NONE"]},
        "3093": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3094": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3095": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3096": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3097": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3098": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3099": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3100": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3101": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3102": {"vr": "CS", "Value": ["NONE"]},
        "3103": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3104": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3105": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3106": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3107": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3108": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3109": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3110": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3111": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3112": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3113": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3114": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3115": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3116": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3117": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3118": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3119": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3120": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3121": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3122": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3123": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3124": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3125": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3126": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3127": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3128": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3129": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3130": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3131": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3132": {"vr": "CS", "Value": ["NONE"]},
        "3133": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3134": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3135": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3136": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3137": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3138": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3139": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3140": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3141": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3142": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3143": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3144": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3145": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3146": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3147": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3148": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3149": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3150": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3151": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3152": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3153": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3154": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3155": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3156": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3157": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3158": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3159": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3160": {"vr": "CS", "Value": ["NONE"]},
        "3161": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3162": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3163": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3164": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3165": {"vr": "CS", "Value": ["NONE"]},
        "3166": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3167": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3168": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3169": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3170": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3171": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3172": {"vr": "CS", "Value": ["NONE"]},
        "3173": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3174": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3175": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3176": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3177": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3178": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3179": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3180": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3181": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3182": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3183": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3184": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3185": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3186": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3187": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3188": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3189": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3190": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3191": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3192": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3193": {"vr": "CS", "Value": ["NONE"]},
        "3194": {"vr": "CS", "Value": ["NONE"]},
        "3195": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3196": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3197": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3198": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3199": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3200": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3201": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3202": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3203": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3204": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3205": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3206": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3207": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3208": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3209": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3210": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3211": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3212": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3213": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3214": {"vr": "CS", "Value": ["NONE"]},
        "3215": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3216": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3217": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3218": {"vr": "CS", "Value": ["NONE"]},
        "3219": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3220": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3221": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3222": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3223": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3224": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3225": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3226": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3227": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3228": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3229": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3230": {"vr": "CS", "Value": ["NONE"]},
        "3231": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3232": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3233": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3234": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3235": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3236": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3237": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3238": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3239": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3240": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3241": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3242": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3243": {"vr": "CS", "Value": ["NONE"]},
        "3244": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3245": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3246": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3247": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3248": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3249": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3250": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3251": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3252": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3253": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3254": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3255": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3256": {"vr": "CS", "Value": ["NONE"]},
        "3257": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3258": {"vr": "CS", "Value": ["NONE"]},
        "3259": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3260": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3261": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3262": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3263": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3264": {"vr": "CS", "Value": ["NONE"]},
        "3265": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3266": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3267": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3268": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3269": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3270": {"vr": "CS", "Value": ["NONE"]},
        "3271": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3272": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3273": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3274": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3275": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3276": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3277": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3278": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3279": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3280": {"vr": "CS", "Value": ["NONE"]},
        "3281": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3282": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3283": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3284": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3285": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3286": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3287": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3288": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3289": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3290": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3291": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3292": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3293": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3294": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3295": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3296": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3297": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3298": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3299": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3300": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3301": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3302": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3303": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3304": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3305": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3306": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3307": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3308": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3309": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3310": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3311": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3312": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3313": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3314": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3315": {"vr": "CS", "Value": ["NONE"]},
        "3316": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3317": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3318": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3319": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3320": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3321": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3322": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3323": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3324": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3325": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3326": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3327": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3328": {"vr": "CS", "Value": ["NONE"]},
        "3329": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3330": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3331": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3332": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3333": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3334": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3335": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3336": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3337": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3338": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3339": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3340": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3341": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3342": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3343": {"vr": "CS", "Value": ["NONE"]},
        "3344": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3345": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3346": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3347": {"vr": "CS", "Value": ["NONE"]},
        "3348": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3349": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3350": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3351": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3352": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3353": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3354": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3355": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3356": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3357": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3358": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3359": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3360": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3361": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3362": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3363": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3364": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3365": {"vr": "CS", "Value": ["NONE"]},
        "3366": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3367": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3368": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3369": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3370": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3371": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3372": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3373": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3374": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3375": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3376": {"vr": "CS", "Value": ["NONE"]},
        "3377": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3378": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3379": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3380": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3381": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3382": {"vr": "CS", "Value": ["NONE"]},
        "3383": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3384": {"vr": "CS", "Value": ["NONE"]},
        "3385": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3386": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3387": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3388": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3389": {"vr": "CS", "Value": ["NONE"]},
        "3390": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3391": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3392": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3393": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3394": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3395": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3396": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3397": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3398": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3399": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3400": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3401": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3402": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3403": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3404": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3405": {"vr": "CS", "Value": ["NONE"]},
        "3406": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3407": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3408": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3409": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3410": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3411": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3412": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3413": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3414": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3415": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3416": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3417": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3418": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3419": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3420": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3421": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3422": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3423": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3424": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3425": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3426": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3427": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3428": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3429": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3430": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3431": {"vr": "CS", "Value": ["NONE"]},
        "3432": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3433": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3434": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3435": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3436": {"vr": "CS", "Value": ["NONE"]},
        "3437": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3438": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3439": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3440": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3441": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3442": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3443": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3444": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3445": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3446": {"vr": "CS", "Value": ["NONE"]},
        "3447": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3448": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3449": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3450": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3451": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3452": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3453": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3454": {"vr": "CS", "Value": ["NONE"]},
        "3455": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3456": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3457": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3458": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3459": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3460": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3461": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3462": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3463": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3464": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3465": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3466": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3467": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3468": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3469": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3470": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3471": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3472": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3473": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3474": {"vr": "CS", "Value": ["NONE"]},
        "3475": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3476": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3477": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3478": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3479": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3480": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3481": {"vr": "CS", "Value": ["NONE"]},
        "3482": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3483": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3484": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3485": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3486": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3487": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3488": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3489": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3490": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3491": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3492": {"vr": "CS", "Value": ["NONE"]},
        "3493": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3494": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3495": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3496": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3497": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3498": {"vr": "CS", "Value": ["NONE"]},
        "3499": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3500": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3501": {"vr": "CS", "Value": ["NONE"]},
        "3502": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3503": {"vr": "CS", "Value": ["NONE"]},
        "3504": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3505": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3506": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3507": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3508": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3509": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3510": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3511": {"vr": "CS", "Value": ["NONE"]},
        "3512": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3513": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3514": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3515": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3516": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3517": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3518": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3519": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3520": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3521": {"vr": "CS", "Value": ["NONE"]},
        "3522": {"vr": "CS", "Value": ["NONE"]},
        "3523": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3524": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3525": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3526": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3527": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3528": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3529": {"vr": "CS", "Value": ["NONE"]},
        "3530": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3531": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3532": {"vr": "CS", "Value": ["NONE"]},
        "3533": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3534": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3535": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3536": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3537": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3538": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3539": {"vr": "CS", "Value": ["NONE"]},
        "3540": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3541": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3542": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3543": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3544": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3545": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3546": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3547": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3548": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3549": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3550": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3551": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3552": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3553": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3554": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3555": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3556": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3557": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3558": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3559": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3560": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3561": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3562": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3563": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3564": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3565": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3566": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3567": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3568": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3569": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3570": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3571": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3572": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3573": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3574": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3575": {"vr": "CS", "Value": ["NONE"]},
        "3576": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3577": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3578": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3579": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3580": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3581": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3582": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3583": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3584": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3585": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3586": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3587": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3588": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3589": {"vr": "CS", "Value": ["NONE"]},
        "3590": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3591": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3592": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3593": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3594": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3595": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3596": {"vr": "CS", "Value": ["NONE"]},
        "3597": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3598": {"vr": "CS", "Value": ["NONE"]},
        "3599": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3600": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3601": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3602": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3603": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3604": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3605": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3606": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3607": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3608": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3609": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3610": {"vr": "CS", "Value": ["NONE"]},
        "3611": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3612": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3613": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3614": {"vr": "CS", "Value": ["NONE"]},
        "3615": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3616": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3617": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3618": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3619": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3620": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3621": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3622": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3623": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3624": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3625": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3626": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3627": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3628": {"vr": "CS", "Value": ["NONE"]},
        "3629": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3630": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3631": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3632": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3633": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3634": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3635": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3636": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3637": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3638": {"vr": "CS", "Value": ["NONE"]},
        "3639": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3640": {"vr": "CS", "Value": ["NONE"]},
        "3641": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3642": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3643": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3644": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3645": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3646": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3647": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3648": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3649": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3650": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3651": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3652": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3653": {"vr": "CS", "Value": ["NONE"]},
        "3654": {"vr": "CS", "Value": ["NONE"]},
        "3655": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3656": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3657": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3658": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3659": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3660": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3661": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3662": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3663": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3664": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3665": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3666": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3667": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3668": {"vr": "CS", "Value": ["NONE"]},
        "3669": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3670": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3671": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3672": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3673": {"vr": "CS", "Value": ["NONE"]},
        "3674": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3675": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3676": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3677": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3678": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3679": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3680": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3681": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3682": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3683": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3684": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3685": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3686": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3687": {"vr": "CS", "Value": ["NONE"]},
        "3688": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3689": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3690": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3691": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3692": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3693": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3694": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3695": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3696": {"vr": "CS", "Value": ["NONE"]},
        "3697": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3698": {"vr": "CS", "Value": ["NONE"]},
        "3699": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3700": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3701": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3702": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3703": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3704": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3705": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3706": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3707": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3708": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3709": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3710": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3711": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3712": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3713": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3714": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3715": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3716": {"vr": "CS", "Value": ["NONE"]},
        "3717": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3718": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3719": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3720": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3721": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3722": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3723": {"vr": "CS", "Value": ["NONE"]},
        "3724": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3725": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3726": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3727": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3728": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3729": {"vr": "CS", "Value": ["NONE"]},
        "3730": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3731": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3732": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3733": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3734": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3735": {"vr": "CS", "Value": ["NONE"]},
        "3736": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3737": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3738": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3739": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3740": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3741": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3742": {"vr": "CS", "Value": ["NONE"]},
        "3743": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3744": {"vr": "CS", "Value": ["NONE"]},
        "3745": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3746": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3747": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3748": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3749": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3750": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3751": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3752": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3753": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3754": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3755": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3756": {"vr": "CS", "Value": ["NONE"]},
        "3757": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3758": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3759": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3760": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3761": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3762": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3763": {"vr": "CS", "Value": ["NONE"]},
        "3764": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3765": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3766": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3767": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3768": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3769": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3770": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3771": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3772": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3773": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3774": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3775": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3776": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3777": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3778": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3779": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3780": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3781": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3782": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3783": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3784": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3785": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3786": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3787": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3788": {"vr": "CS", "Value": ["NONE"]},
        "3789": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3790": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3791": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3792": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3793": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3794": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3795": {"vr": "CS", "Value": ["NONE"]},
        "3796": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3797": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3798": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3799": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3800": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3801": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3802": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3803": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3804": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3805": {"vr": "CS", "Value": ["NONE"]},
        "3806": {"vr": "CS", "Value": ["NONE"]},
        "3807": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3808": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3809": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3810": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3811": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3812": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3813": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3814": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3815": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3816": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3817": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3818": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3819": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3820": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3821": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3822": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3823": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3824": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3825": {"vr": "CS", "Value": ["NONE"]},
        "3826": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3827": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3828": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3829": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3830": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3831": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3832": {"vr": "CS", "Value": ["NONE"]},
        "3833": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3834": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3835": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3836": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3837": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3838": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3839": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3840": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3841": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3842": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3843": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3844": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3845": {"vr": "CS", "Value": ["NONE"]},
        "3846": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3847": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3848": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3849": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3850": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3851": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3852": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3853": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3854": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3855": {"vr": "CS", "Value": ["NONE"]},
        "3856": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3857": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3858": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3859": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3860": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3861": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3862": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3863": {"vr": "CS", "Value": ["NONE"]},
        "3864": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3865": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3866": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3867": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3868": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3869": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3870": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3871": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3872": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3873": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3874": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3875": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3876": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3877": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3878": {"vr": "CS", "Value": ["NONE"]},
        "3879": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3880": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3881": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3882": {"vr": "CS", "Value": ["NONE"]},
        "3883": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3884": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3885": {"vr": "CS", "Value": ["NONE"]},
        "3886": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3887": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3888": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3889": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3890": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3891": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3892": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3893": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3894": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3895": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3896": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3897": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3898": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3899": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3900": {"vr": "CS", "Value": ["NONE"]},
        "3901": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3902": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3903": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3904": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3905": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3906": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3907": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3908": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3909": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3910": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3911": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3912": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3913": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3914": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3915": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3916": {"vr": "CS", "Value": ["NONE"]},
        "3917": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3918": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3919": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3920": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3921": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3922": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3923": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3924": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3925": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3926": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3927": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3928": {"vr": "CS", "Value": ["NONE"]},
        "3929": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3930": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3931": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3932": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3933": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3934": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3935": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3936": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3937": {"vr": "CS", "Value": ["NONE"]},
        "3938": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3939": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3940": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3941": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3942": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3943": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3944": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3945": {"vr": "CS", "Value": ["NONE"]},
        "3946": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3947": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3948": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3949": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3950": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3951": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3952": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3953": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3954": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3955": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3956": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3957": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3958": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3959": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3960": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3961": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3962": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3963": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3964": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3965": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3966": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3967": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3968": {"vr": "CS", "Value": ["NONE"]},
        "3969": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3970": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3971": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3972": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3973": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3974": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3975": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3976": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3977": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3978": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3979": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3980": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3981": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3982": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3983": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3984": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3985": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3986": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3987": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3988": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3989": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3990": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3991": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3992": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3993": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3994": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3995": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3996": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3997": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3998": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "3999": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4000": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4001": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4002": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4003": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4004": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4005": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4006": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4007": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4008": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4009": {"vr": "CS", "Value": ["NONE"]},
        "4010": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4011": {"vr": "CS", "Value": ["NONE"]},
        "4012": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4013": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4014": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4015": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4016": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4017": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4018": {"vr": "CS", "Value": ["DIRECTIONAL"]},
        "4019": {"vr": "CS", "Value": ["DIRECTIONAL"]},
    },
    "00211123": {
        "0": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "4": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "5": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "6": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "7": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "8": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "9": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "10": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "11": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "12": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "15": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "16": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "17": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "18": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "19": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "20": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "21": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "22": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "23": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "24": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "25": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "26": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "27": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "28": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "29": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "30": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "32": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "33": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "36": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "37": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "38": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "39": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "41": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "42": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "43": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "44": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "45": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "46": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "47": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "48": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "49": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "50": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "51": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "52": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "53": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "54": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "55": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "56": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "57": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "58": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "59": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "62": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "63": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "64": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "65": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "66": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "67": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "69": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "70": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "71": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "72": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "73": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "74": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "75": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "76": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "77": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "78": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "79": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "81": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "82": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "83": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "84": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "85": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "86": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "87": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "88": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "89": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "92": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "93": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "94": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "95": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "96": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "97": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "98": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "99": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "100": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "101": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "102": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "103": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "104": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "105": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "106": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "107": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "108": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "109": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "110": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "111": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "113": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "115": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "116": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "117": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "118": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "119": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "120": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "121": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "122": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "123": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "124": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "125": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "126": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "127": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "129": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "130": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "131": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "132": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "133": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "134": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "135": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "136": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "137": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "138": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "139": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "140": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "141": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "142": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "143": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "144": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "145": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "146": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "147": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "148": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "149": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "150": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "151": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "152": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "153": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "154": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "155": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "156": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "157": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "158": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "159": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "161": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "162": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "163": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "164": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "165": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "166": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "167": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "168": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "169": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "170": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "171": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "172": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "173": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "174": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "175": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "176": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "177": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "178": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "179": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "180": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "181": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "182": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "183": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "184": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "185": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "186": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "187": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "188": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "189": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "190": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "192": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "193": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "194": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "195": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "196": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "197": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "199": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "200": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "201": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "202": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "203": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "204": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "205": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "206": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "207": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "208": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "209": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "211": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "212": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "213": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "214": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "215": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "216": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "217": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "218": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "219": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "220": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "221": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "222": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "223": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "224": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "225": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "226": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "228": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "229": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "230": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "231": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "232": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "233": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "234": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "235": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "236": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "237": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "238": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "239": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "240": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "241": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "242": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "244": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "245": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "247": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "248": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "249": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "250": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "251": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "252": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "253": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "254": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "255": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "257": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "258": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "259": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "260": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "261": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "262": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "263": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "264": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "265": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "266": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "267": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "268": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "269": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "271": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "272": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "273": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "274": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "276": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "277": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "278": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "279": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "280": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "281": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "282": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "283": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "284": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "285": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "286": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "287": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "288": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "289": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "291": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "292": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "293": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "294": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "295": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "296": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "297": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "298": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "299": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "300": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "302": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "303": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "304": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "305": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "306": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "307": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "308": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "309": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "310": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "312": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "314": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "315": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "317": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "318": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "319": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "320": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "321": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "322": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "323": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "324": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "325": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "326": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "327": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "328": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "329": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "330": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "331": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "332": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "333": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "334": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "335": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "336": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "337": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "338": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "339": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "340": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "341": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "342": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "343": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "344": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "345": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "346": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "347": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "348": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "351": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "352": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "353": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "354": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "355": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "356": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "357": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "358": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "359": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "360": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "362": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "364": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "365": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "366": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "367": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "369": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "370": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "371": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "372": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "373": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "374": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "375": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "376": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "377": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "378": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "379": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "380": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "381": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "382": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "385": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "386": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "387": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "388": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "389": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "390": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "391": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "392": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "393": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "394": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "395": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "397": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "398": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "400": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "401": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "402": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "403": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "404": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "405": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "406": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "407": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "408": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "409": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "410": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "411": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "412": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "413": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "414": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "415": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "416": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "417": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "419": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "420": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "421": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "422": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "423": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "425": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "426": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "427": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "428": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "429": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "430": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "431": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "432": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "433": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "434": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "435": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "436": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "437": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "438": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "439": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "440": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "441": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "442": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "443": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "444": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "446": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "447": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "449": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "450": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "451": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "452": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "453": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "454": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "455": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "456": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "457": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "458": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "459": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "460": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "461": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "462": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "463": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "464": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "465": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "466": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "467": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "468": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "470": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "471": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "472": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "473": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "474": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "476": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "477": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "478": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "479": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "480": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "481": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "482": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "484": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "485": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "486": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "487": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "488": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "489": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "490": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "491": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "492": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "493": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "494": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "495": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "496": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "498": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "499": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "500": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "502": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "503": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "504": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "505": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "506": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "508": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "509": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "510": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "511": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "512": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "513": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "516": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "517": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "518": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "519": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "521": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "522": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "523": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "524": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "525": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "526": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "527": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "528": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "529": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "530": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "532": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "533": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "534": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "535": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "536": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "537": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "538": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "540": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "541": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "543": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "545": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "546": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "547": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "549": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "550": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "551": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "552": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "556": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "557": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "558": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "559": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "560": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "561": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "562": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "563": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "564": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "565": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "566": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "568": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "569": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "570": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "571": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "572": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "573": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "574": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "575": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "576": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "577": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "578": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "579": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "580": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "581": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "582": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "583": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "584": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "586": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "588": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "589": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "590": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "591": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "592": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "593": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "594": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "595": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "596": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "597": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "598": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "599": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "601": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "602": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "603": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "604": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "605": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "606": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "607": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "608": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "609": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "610": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "612": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "613": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "614": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "615": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "616": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "617": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "618": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "619": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "620": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "621": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "622": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "623": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "625": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "626": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "627": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "628": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "629": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "630": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "631": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "632": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "633": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "634": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "635": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "637": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "638": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "639": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "640": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "641": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "642": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "643": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "644": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "645": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "646": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "647": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "648": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "649": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "650": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "651": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "652": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "653": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "654": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "655": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "656": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "657": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "658": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "659": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "660": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "661": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "662": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "664": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "665": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "666": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "667": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "669": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "670": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "671": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "672": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "673": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "674": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "675": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "676": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "677": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "678": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "680": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "681": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "682": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "683": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "684": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "685": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "686": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "688": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "689": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "691": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "692": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "693": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "694": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "695": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "696": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "697": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "698": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "700": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "701": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "702": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "703": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "704": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "705": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "706": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "708": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "709": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "710": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "711": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "712": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "713": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "716": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "717": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "718": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "719": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "720": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "721": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "722": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "723": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "724": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "725": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "726": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "727": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "728": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "729": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "730": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "731": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "733": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "734": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "735": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "736": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "737": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "738": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "739": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "740": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "741": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "742": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "743": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "744": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "745": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "746": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "747": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "748": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "749": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "750": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "751": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "752": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "753": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "754": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "755": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "756": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "758": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "759": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "760": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "761": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "762": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "763": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "764": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "765": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "766": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "767": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "768": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "769": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "770": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "772": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "773": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "774": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "775": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "776": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "778": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "779": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "780": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "781": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "782": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "783": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "784": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "785": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "786": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "787": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "789": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "790": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "792": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "793": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "794": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "795": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "796": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "797": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "798": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "799": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "800": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "801": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "802": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "803": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "804": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "805": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "806": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "807": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "808": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "809": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "811": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "812": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "813": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "814": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "815": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "817": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "818": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "819": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "821": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "822": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "823": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "824": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "825": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "826": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "828": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "830": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "831": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "832": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "833": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "834": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "835": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "836": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "837": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "838": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "839": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "840": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "841": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "842": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "843": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "844": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "845": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "847": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "848": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "849": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "851": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "852": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "853": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "854": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "855": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "856": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "857": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "858": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "859": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "860": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "862": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "863": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "864": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "865": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "866": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "869": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "871": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "872": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "873": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "874": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "876": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "877": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "878": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "879": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "880": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "881": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "882": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "883": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "884": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "886": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "887": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "888": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "889": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "890": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "891": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "892": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "893": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "894": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "895": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "896": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "897": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "898": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "899": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "900": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "901": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "902": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "903": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "904": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "905": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "906": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "907": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "908": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "909": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "910": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "911": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "912": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "913": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "914": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "915": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "916": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "917": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "918": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "920": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "921": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "922": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "923": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "925": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "927": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "928": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "929": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "930": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "931": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "933": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "934": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "935": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "937": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "938": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "939": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "940": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "941": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "942": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "943": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "944": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "945": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "946": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "947": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "949": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "950": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "951": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "952": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "953": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "954": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "955": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "957": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "958": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "959": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "960": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "962": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "963": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "964": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "965": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "966": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "967": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "968": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "969": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "970": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "971": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "972": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "973": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "974": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "975": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "976": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "977": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "979": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "980": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "981": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "982": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "984": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "985": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "986": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "987": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "988": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "989": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "990": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "991": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "992": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "993": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "994": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "995": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "997": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "998": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "999": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1000": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1001": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1002": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1003": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1004": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1005": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1006": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1007": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1008": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1009": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1010": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1011": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1012": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1013": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1014": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1017": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1018": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1019": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1020": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1021": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1022": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1023": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1024": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1025": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1026": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1027": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1028": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1029": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1031": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1033": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1034": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1035": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1036": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1037": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1038": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1040": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1041": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1042": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1043": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1044": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1045": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1046": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1047": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1048": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1049": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1050": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1051": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1052": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1053": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1054": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1055": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1056": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1057": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1058": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1059": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1061": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1062": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1063": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1064": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1066": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1067": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1068": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1069": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1070": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1071": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1072": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1074": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1075": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1076": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1077": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1078": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1079": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1080": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1082": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1083": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1084": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1085": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1086": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1087": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1089": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1092": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1093": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1094": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1095": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1096": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1098": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1099": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1100": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1101": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1102": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1103": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1104": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1106": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1107": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1108": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1109": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1111": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1112": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1113": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1114": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1115": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1116": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1117": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1118": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1119": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1120": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1121": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1122": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1123": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1124": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1125": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1126": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1127": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1128": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1129": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1130": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1132": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1133": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1134": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1135": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1137": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1138": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1139": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1140": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1141": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1142": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1143": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1144": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1145": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1146": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1150": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1151": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1152": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1153": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1154": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1155": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1156": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1157": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1158": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1159": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1160": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1161": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1162": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1163": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1164": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1167": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1168": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1169": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1170": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1171": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1172": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1173": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1174": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1175": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1176": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1177": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1179": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1180": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1181": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1182": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1183": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1184": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1185": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1186": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1187": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1188": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1190": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1192": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1194": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1195": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1196": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1197": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1198": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1199": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1200": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1203": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1204": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1205": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1206": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1207": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1208": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1209": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1210": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1211": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1212": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1213": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1214": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1215": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1216": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1217": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1218": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1221": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1222": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1223": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1224": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1225": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1226": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1227": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1228": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1229": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1230": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1231": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1232": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1233": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1234": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1235": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1236": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1237": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1238": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1239": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1240": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1241": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1242": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1243": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1244": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1245": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1246": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1247": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1248": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1249": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1250": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1251": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1252": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1253": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1254": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1255": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1256": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1257": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1258": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1259": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1261": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1262": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1263": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1265": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1266": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1267": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1268": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1269": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1270": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1272": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1273": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1274": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1275": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1276": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1277": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1278": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1279": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1280": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1281": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1283": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1284": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1285": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1286": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1287": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1288": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1289": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1290": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1292": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1293": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1294": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1295": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1296": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1297": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1298": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1299": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1301": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1302": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1303": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1304": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1305": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1306": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1307": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1308": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1310": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1311": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1312": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1313": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1314": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1315": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1316": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1317": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1318": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1319": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1320": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1321": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1322": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1323": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1325": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1327": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1328": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1329": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1331": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1332": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1334": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1335": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1336": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1337": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1338": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1339": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1340": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1341": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1342": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1343": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1344": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1345": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1346": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1348": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1349": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1350": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1351": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1352": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1353": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1354": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1355": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1356": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1357": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1359": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1360": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1361": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1362": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1363": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1364": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1365": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1366": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1367": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1368": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1369": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1370": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1371": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1372": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1373": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1374": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1376": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1377": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1378": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1379": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1380": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1382": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1383": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1384": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1385": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1386": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1387": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1388": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1389": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1390": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1391": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1392": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1393": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1394": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1395": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1396": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1397": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1398": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1399": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1400": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1401": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1402": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1403": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1405": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1406": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1407": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1408": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1409": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1410": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1411": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1412": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1414": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1415": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1416": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1418": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1419": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1420": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1421": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1422": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1423": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1424": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1425": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1426": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1427": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1428": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1429": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1431": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1432": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1433": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1434": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1435": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1436": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1437": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1438": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1439": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1440": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1441": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1443": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1444": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1445": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1446": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1447": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1448": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1450": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1451": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1452": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1453": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1454": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1456": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1457": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1458": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1459": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1462": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1463": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1464": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1465": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1466": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1467": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1468": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1469": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1470": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1471": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1472": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1473": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1475": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1476": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1477": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1478": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1479": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1480": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1481": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1482": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1483": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1484": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1485": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1486": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1487": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1489": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1490": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1491": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1492": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1494": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1495": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1496": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1497": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1498": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1499": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1500": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1501": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1502": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1503": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1504": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1505": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1506": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1507": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1508": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1509": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1510": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1511": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1513": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1514": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1516": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1518": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1519": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1520": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1521": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1522": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1523": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1524": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1525": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1526": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1527": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1528": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1529": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1530": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1531": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1532": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1533": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1534": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1535": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1537": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1538": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1539": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1540": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1541": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1542": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1543": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1544": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1545": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1546": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1547": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1548": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1549": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1550": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1551": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1552": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1554": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1556": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1557": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1558": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1560": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1561": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1563": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1564": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1565": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1566": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1567": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1568": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1569": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1570": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1571": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1572": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1573": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1575": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1576": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1577": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1578": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1579": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1580": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "1581": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1582": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1583": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1584": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1585": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1586": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1587": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1588": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1589": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1591": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1592": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1593": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1595": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1596": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1597": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1598": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1599": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1602": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1605": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1606": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1607": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1608": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1609": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1611": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1612": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1613": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1614": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1615": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1616": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1617": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1618": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1619": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1620": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1621": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1622": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1623": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1624": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1626": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1627": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1628": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1629": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1630": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1631": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1632": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1633": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1634": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1635": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1636": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1637": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1638": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1639": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1640": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1641": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1642": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1645": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1646": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1647": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1648": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1650": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1651": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1652": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1653": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1654": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1655": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1656": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1657": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1658": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1659": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1660": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1661": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1662": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1663": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1664": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1665": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1666": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1667": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1668": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1669": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1670": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1671": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1672": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1673": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1674": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1675": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1676": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1677": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1678": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1679": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1680": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1681": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1682": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1683": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1684": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1685": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1686": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1687": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1688": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1690": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1692": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1693": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1694": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1695": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1696": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1697": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1698": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1699": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1701": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1702": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1703": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1704": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1705": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1706": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1707": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1708": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1709": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1710": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1711": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1712": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1713": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1714": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1715": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1716": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1718": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1719": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1721": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1722": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1723": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1724": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1725": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1726": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1727": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1728": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1729": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1730": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1731": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1732": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1733": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1734": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1735": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1737": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1739": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1740": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1741": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1742": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1743": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1744": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1745": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1746": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1747": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1748": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1749": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1750": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1751": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1752": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1753": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1754": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1755": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1756": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1757": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1758": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1759": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "1760": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1761": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1762": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1763": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1764": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1765": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1766": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1767": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1768": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1769": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1770": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1771": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1772": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1773": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1774": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1776": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1777": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1778": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1779": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1780": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1781": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1782": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1783": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1784": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1785": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1786": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1787": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1788": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1789": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1790": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1791": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "1792": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1793": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1794": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1795": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1797": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1798": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1799": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1800": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1801": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1803": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1804": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1806": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1807": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1808": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1809": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1810": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1811": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1812": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1813": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1814": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1815": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1816": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1817": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1818": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1819": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1820": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1821": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1822": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1823": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1824": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "1825": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1826": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1828": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "1829": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "1830": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1831": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1832": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1833": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1834": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1835": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1836": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1839": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1840": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1841": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1842": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1843": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "1844": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1846": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1847": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1848": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1849": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1850": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1851": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1852": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1853": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "1854": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1855": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1856": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1857": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1858": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1859": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1860": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1861": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1862": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "1863": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "1864": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1865": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1866": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "1867": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "1868": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1869": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1870": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1871": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1874": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1875": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "1876": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1877": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1878": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1879": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "1880": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1881": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1882": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "1883": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1884": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1885": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1886": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1887": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "1888": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1890": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1891": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "1892": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1893": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1894": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1895": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1896": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1897": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1898": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1899": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1900": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "1901": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "1902": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1903": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1904": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1905": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1906": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1907": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1908": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1910": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1911": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1912": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1913": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1917": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1919": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "1921": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1922": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1923": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1924": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1925": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1926": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "1927": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1928": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1929": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "1930": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1931": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "1932": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1934": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "1935": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1936": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1937": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1938": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "1939": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1940": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1941": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "1942": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1943": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1944": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1945": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "1946": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1947": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1948": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "1950": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "1951": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "1952": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1953": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1954": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1955": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "1956": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "1957": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "1958": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1959": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "1960": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "1962": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "1963": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "1964": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "1965": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "1966": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1968": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "1969": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "1970": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "1971": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1972": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1974": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "1975": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "1976": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "1977": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1978": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "1979": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1980": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "1981": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "1982": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "1983": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1984": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "1985": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1987": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "1988": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "1989": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "1990": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "1991": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "1992": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "1994": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "1995": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "1997": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "1998": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "1999": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2000": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2002": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2003": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2004": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2005": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2006": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2007": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2008": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2009": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2010": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2011": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2013": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2014": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2015": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2016": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2018": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2019": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2020": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2021": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2022": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2023": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2024": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2026": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2027": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2028": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2030": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2031": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2032": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2033": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2034": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2035": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2036": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2037": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2038": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2039": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2040": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2041": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2042": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2043": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2044": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2045": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2046": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2047": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2048": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2049": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2050": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2051": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2052": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2053": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2054": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2055": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2056": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2057": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2058": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2059": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2060": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2061": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2062": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2063": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2065": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2066": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2067": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2068": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2069": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2070": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2071": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2072": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2073": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2074": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2076": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2077": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2078": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2080": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2081": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2085": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2087": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2088": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2089": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2090": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2091": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2092": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2093": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2094": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2095": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2096": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2097": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2099": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2100": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2101": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2102": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2103": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2104": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2105": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2106": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2107": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2108": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2110": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2111": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2112": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2113": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2114": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2115": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2116": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2117": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2118": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2119": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2120": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2121": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2122": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2123": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2124": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2125": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2126": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2127": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2128": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2129": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2130": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2131": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2133": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2134": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2135": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2136": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2137": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2138": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2139": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2140": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2141": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2142": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2143": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2144": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2145": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2147": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2148": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2149": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2150": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2151": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2152": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2153": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2154": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2155": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2156": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2157": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2159": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2160": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2161": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2162": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2163": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2164": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2166": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2167": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2168": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2169": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2171": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2172": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2173": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2175": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2176": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2177": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2178": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2179": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2180": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2181": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2182": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2183": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2184": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2185": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2186": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2188": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2189": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2190": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2191": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2193": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2194": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2195": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2196": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2197": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2198": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2199": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2200": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2201": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2202": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2203": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2205": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2206": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2207": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2208": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2209": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2210": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2211": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2212": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2213": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2214": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2215": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2216": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2217": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2218": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2219": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2221": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2222": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2223": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2224": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2225": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2226": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2227": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2228": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2229": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2230": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2231": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2232": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2233": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2234": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2235": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2236": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2237": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2238": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2240": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2241": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2242": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2243": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2244": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2245": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2246": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2247": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2248": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2249": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2250": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2251": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2252": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2253": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2255": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2256": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2257": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2258": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2260": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2261": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2262": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2264": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2265": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2266": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2267": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2268": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2269": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2270": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2271": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2272": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2273": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2274": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2275": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2276": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2277": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2279": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2280": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2281": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2282": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2283": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2284": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2285": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2286": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2288": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2289": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2290": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2292": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2293": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2294": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2297": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2298": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2299": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2300": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2301": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2302": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2303": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2304": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2305": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2306": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2307": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2308": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2309": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2310": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2311": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2312": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2314": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2315": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2316": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2317": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2318": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2319": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2320": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2321": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2322": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2323": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2324": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2325": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2326": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2327": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2328": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2329": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2330": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2331": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2332": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2333": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2334": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2335": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2336": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2337": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2338": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2339": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2341": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2342": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2343": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2344": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2345": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2347": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2348": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2349": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2350": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2351": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2352": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2353": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2354": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2355": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2356": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2357": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2358": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2361": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2362": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2363": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2364": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2365": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2366": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2367": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2368": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2370": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2371": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2372": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2373": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2374": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2375": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2377": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2378": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2379": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2380": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2383": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2384": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2386": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2387": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2388": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2389": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2390": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2391": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2392": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2393": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2395": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2396": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2397": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2398": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2399": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2401": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2402": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2403": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2404": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2405": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2406": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2407": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2408": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2409": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2410": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2411": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2412": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2413": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2414": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2415": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2416": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2419": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2420": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2421": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2422": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2423": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2424": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2425": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2426": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2427": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2428": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2429": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2430": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2431": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2432": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2434": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2435": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2436": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2437": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2438": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2439": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2440": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2441": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2442": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2443": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2444": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2445": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2446": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2447": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2448": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2449": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2450": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2451": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2452": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2453": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2454": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2455": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2456": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2457": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2458": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2459": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2460": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2461": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2462": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2463": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2464": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2465": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2466": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2467": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2468": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2469": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2470": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2471": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2472": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2473": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2474": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2475": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2476": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2477": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2478": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2481": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2482": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2483": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2484": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2485": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2486": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2487": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2488": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2489": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2490": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2491": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2492": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2493": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2494": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2495": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2496": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2497": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2498": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2499": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2500": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2501": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2502": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2503": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2504": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2505": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2506": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2507": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2508": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2509": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2510": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2511": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2512": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2513": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2514": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2515": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2516": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2517": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2518": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2519": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2521": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2523": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2524": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2526": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2527": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2528": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2529": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2530": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2531": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2532": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2533": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2535": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2536": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2538": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2540": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2541": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2542": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2543": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2544": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2545": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2547": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2549": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2550": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2551": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2552": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2553": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2554": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2555": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2556": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2558": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2559": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2560": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2561": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2562": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2563": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2564": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2565": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2566": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2567": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2568": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2569": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2570": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2573": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2574": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2575": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2576": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2577": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2578": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2579": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2580": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2581": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2582": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2583": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2586": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2587": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2588": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2589": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2590": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2591": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2592": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2593": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2594": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2595": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2596": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2597": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2598": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2599": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2600": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2601": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2602": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2603": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2604": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2605": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2606": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2607": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2608": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2610": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2612": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2613": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2614": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2615": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2616": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2617": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2619": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2620": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2621": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2622": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2623": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2624": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2625": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2626": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2627": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2630": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2631": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2632": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2633": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2634": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2635": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2637": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2638": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2641": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2642": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2643": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2644": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2645": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2646": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2647": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2648": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2649": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2650": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2651": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2652": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2653": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2654": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2655": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2656": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2657": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2659": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2660": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2661": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2662": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2663": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2664": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2665": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2666": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2667": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2668": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2669": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2670": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2671": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2672": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2673": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2674": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2675": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2676": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2677": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2678": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2681": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2682": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2683": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2684": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2685": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2686": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2687": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2688": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2689": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2690": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2691": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2692": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2693": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2694": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2695": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2696": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2697": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2698": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2699": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2700": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2701": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2703": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2704": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2705": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2706": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2707": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2708": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2709": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2710": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2711": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2712": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2713": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2714": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2715": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2716": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2717": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2718": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2719": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2720": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2721": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2722": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2723": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2724": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2725": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2727": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2728": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2729": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2730": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2731": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2732": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2733": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2734": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2735": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2737": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2738": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2739": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2740": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2742": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2743": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2744": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2745": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2747": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2748": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2749": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "2751": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2752": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2753": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2754": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2755": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2756": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2758": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2759": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2760": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2761": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2762": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2763": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2764": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2766": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2767": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2768": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2769": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2771": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2772": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2773": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2774": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2775": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2776": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2778": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2779": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2780": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2782": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2783": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2784": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2785": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "2786": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2787": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2788": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2789": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2790": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2791": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "2793": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2794": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2795": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2796": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2798": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2799": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2800": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2801": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2802": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2803": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2804": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2805": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2806": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "2807": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2808": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2809": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2810": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2811": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2812": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2813": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2814": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2815": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2816": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2817": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2819": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2820": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2821": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2823": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2824": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "2825": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2826": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2827": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2828": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "2829": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2831": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2832": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2833": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2834": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2835": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2836": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2837": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2838": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2839": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2840": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2841": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2842": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2843": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2844": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2845": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2846": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2847": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2848": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2849": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2850": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2851": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2853": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2854": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2856": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2857": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2858": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "2859": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2860": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2861": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2863": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "2864": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2865": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2866": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2867": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2868": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2869": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2870": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "2871": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "2872": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2873": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2874": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2875": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "2876": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2877": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2879": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2880": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "2881": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2883": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2884": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2885": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2886": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2887": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2888": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2889": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "2890": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2891": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2892": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2893": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2894": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "2895": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2896": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2897": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2898": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2899": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "2900": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2901": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2902": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2903": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2904": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2905": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2908": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2909": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "2910": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "2911": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2912": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2913": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "2914": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2915": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "2917": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2920": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2921": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "2922": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2924": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2925": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "2926": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2927": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2928": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2929": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "2931": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2932": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "2933": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2934": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2936": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "2937": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2938": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2939": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2940": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "2941": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "2942": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2943": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2944": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2945": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2947": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "2948": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "2950": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2951": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2952": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "2953": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "2956": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "2957": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "2958": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2959": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2960": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "2961": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2962": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2963": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2964": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "2965": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2966": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "2967": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "2969": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2970": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2971": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "2972": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "2973": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2974": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "2975": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "2976": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "2977": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "2978": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "2979": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "2980": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2981": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "2982": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "2983": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "2984": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "2986": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "2987": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "2988": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2989": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "2990": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "2991": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "2992": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "2993": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "2994": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "2995": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "2996": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "2997": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "2998": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "2999": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3000": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3001": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3002": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3003": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3004": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3006": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3007": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3008": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3009": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3010": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3011": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3012": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3013": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3014": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3015": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3016": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3017": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3018": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3020": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3021": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3022": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3023": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3024": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3025": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3026": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3027": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3028": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3030": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3031": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3032": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3033": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3034": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3035": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3036": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3037": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3038": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3039": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3040": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3041": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3042": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3043": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3044": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3045": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3046": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3047": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3048": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3049": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3050": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3051": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3052": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3054": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3055": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3056": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3057": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3058": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3059": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3060": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3061": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3062": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3063": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3064": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3065": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3066": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3067": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3068": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3069": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3070": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3071": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3073": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3075": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3076": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3078": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3079": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3080": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3081": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3082": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3083": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3084": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3085": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3086": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3087": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3088": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3090": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3091": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3093": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3094": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3095": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3096": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3097": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3098": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3099": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3100": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3101": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3103": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3104": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3105": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3106": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3107": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3108": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3109": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3110": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3111": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3112": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3113": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3114": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3115": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3116": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3117": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3118": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3119": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3120": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3121": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3122": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3123": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3124": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3125": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3126": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3127": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3128": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3129": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3130": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3131": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3133": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3134": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3135": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3136": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3137": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3138": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3139": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3140": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3141": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3142": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3143": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3144": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3145": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3146": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3147": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3148": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3149": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3150": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3151": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3152": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3153": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3154": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3155": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3156": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3157": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3158": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3159": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3161": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3162": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3163": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3164": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3166": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3167": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3168": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3169": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3170": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3171": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3173": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3174": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3175": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3176": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3177": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3178": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3179": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3180": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3181": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3182": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3183": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3184": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3185": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3186": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3187": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3188": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3189": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3190": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3191": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3192": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3195": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3196": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3197": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3198": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3199": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3200": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3201": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3202": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3203": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3204": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3205": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3206": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3207": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3208": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3209": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3210": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3211": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3212": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3213": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3215": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3216": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3217": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3219": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3220": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3221": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3222": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3223": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3224": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3225": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3226": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3227": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3228": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3229": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3231": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3232": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3233": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3234": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3235": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3236": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3237": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3238": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3239": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3240": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3241": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3242": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3244": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3245": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3246": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3247": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3248": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3249": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3250": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3251": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3252": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3253": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3254": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3255": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3257": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3259": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3260": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3261": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3262": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3263": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3265": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3266": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3267": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3268": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3269": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3271": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3272": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3273": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3274": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3275": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3276": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3277": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3278": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3279": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3281": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3282": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3283": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3284": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3285": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3286": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3287": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3288": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3289": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3290": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3291": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3292": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3293": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3294": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3295": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3296": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3297": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3298": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3299": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3300": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3301": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3302": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3303": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3304": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3305": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3306": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3307": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3308": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3309": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3310": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3311": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3312": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3313": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3314": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3316": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3317": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3318": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3319": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3320": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3321": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3322": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3323": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3324": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3325": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3326": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3327": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3329": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3330": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3331": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3332": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3333": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3334": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3335": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3336": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3337": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3338": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3339": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3340": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3341": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3342": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3344": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3345": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3346": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3348": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3349": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3350": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3351": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3352": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3353": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3354": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3355": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3356": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3357": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3358": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3359": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3360": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3361": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3362": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3363": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3364": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3366": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3367": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3368": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3369": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3370": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3371": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3372": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3373": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3374": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3375": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3377": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3378": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3379": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3380": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3381": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3383": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3385": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3386": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3387": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3388": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3390": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3391": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3392": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3393": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3394": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3395": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3396": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3397": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3398": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3399": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3400": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3401": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3402": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3403": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3404": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3406": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3407": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3408": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3409": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3410": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3411": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3412": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3413": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3414": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3415": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3416": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3417": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3418": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3419": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3420": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3421": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3422": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3423": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3424": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3425": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3426": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3427": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3428": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3429": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3430": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3432": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3433": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3434": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3435": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3437": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3438": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3439": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3440": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3441": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3442": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3443": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3444": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3445": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3447": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3448": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3449": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3450": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3451": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3452": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3453": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3455": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3456": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3457": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3458": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3459": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3460": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3461": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3462": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3463": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3464": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3465": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3466": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3467": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3468": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3469": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3470": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3471": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3472": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3473": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3475": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3476": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3477": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3478": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3479": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3480": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3482": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3483": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3484": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3485": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3486": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3487": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3488": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3489": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3490": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3491": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3493": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3494": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3495": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3496": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3497": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3499": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3500": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3502": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3504": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3505": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3506": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3507": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3508": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3509": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3510": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3512": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3513": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3514": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3515": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3516": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3517": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3518": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3519": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3520": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3523": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3524": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3525": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3526": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3527": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3528": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3530": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3531": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3533": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3534": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3535": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3536": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3537": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3538": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3540": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3541": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3542": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3543": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3544": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3545": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3546": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3547": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3548": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3549": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3550": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3551": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3552": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3553": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3554": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3555": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3556": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3557": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3558": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3559": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3560": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3561": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3562": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3563": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3564": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3565": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3566": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3567": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3568": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3569": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3570": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3571": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3572": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3573": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3574": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3576": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3577": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3578": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3579": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3580": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3581": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3582": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3583": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3584": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3585": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3586": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3587": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3588": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3590": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3591": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3592": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3593": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3594": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3595": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3597": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3599": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3600": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3601": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3602": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3603": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3604": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3605": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3606": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3607": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3608": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3609": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3611": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3612": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3613": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3615": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3616": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3617": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3618": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3619": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3620": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3621": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3622": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3623": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3624": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3625": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3626": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3627": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3629": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3630": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3631": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3632": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3633": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3634": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3635": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3636": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3637": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3639": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3641": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3642": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3643": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3644": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3645": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3646": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3647": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3648": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3649": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3650": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3651": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3652": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3655": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3656": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3657": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3658": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3659": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3660": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3661": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3662": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3663": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3664": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3665": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3666": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3667": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3669": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3670": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3671": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3672": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3674": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3675": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3676": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3677": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3678": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3679": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3680": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3681": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3682": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3683": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3684": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3685": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3686": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3688": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3689": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3690": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3691": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3692": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3693": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3694": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3695": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3697": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3699": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3700": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3701": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3702": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3703": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3704": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3705": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3706": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3707": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3708": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3709": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3710": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3711": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3712": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3713": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3714": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3715": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3717": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3718": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3719": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3720": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "3721": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3722": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3724": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3725": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3726": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3727": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3728": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3730": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3731": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3732": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3733": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3734": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3736": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3737": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3738": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3739": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3740": {"vr": "FD", "Value": [1157.0, -334.0, 1417.0, 97.0, -409.0, 1737.0]},
        "3741": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3743": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3745": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3746": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3747": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3748": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3749": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3750": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3751": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3752": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3753": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3754": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3755": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3757": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3758": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3759": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3760": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3761": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3762": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3764": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3765": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3766": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3767": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3768": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3769": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3770": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3771": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3772": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3773": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3774": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3775": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3776": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3777": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3778": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3779": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3780": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3781": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3782": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3783": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3784": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3785": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3786": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3787": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3789": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3790": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3791": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3792": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3793": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3794": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3796": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3797": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3798": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3799": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3800": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3801": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3802": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3803": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3804": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3807": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3808": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3809": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3810": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3811": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3812": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3813": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3814": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3815": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3816": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3817": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3818": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3819": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3820": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3821": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3822": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3823": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3824": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3826": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3827": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3828": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3829": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3830": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3831": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "3833": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3834": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3835": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3836": {"vr": "FD", "Value": [1919.0, 1203.0, -791.0, 755.0, -496.0, 327.0]},
        "3837": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3838": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3839": {"vr": "FD", "Value": [0.0, 0.0, -7.0, 1.0, -1.0, 2977.0]},
        "3840": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3841": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3842": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3843": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3844": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3846": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3847": {"vr": "FD", "Value": [1646.0, -1491.0, 76.0, 1351.0, -69.0, 4.0]},
        "3848": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3849": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3850": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3851": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3852": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3853": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3854": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3856": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3857": {"vr": "FD", "Value": [2705.0, -323.0, 834.0, 39.0, -99.0, 258.0]},
        "3858": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3859": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3860": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3861": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3862": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3864": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3865": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3866": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3867": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3868": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3869": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3870": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3871": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3872": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3873": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "3874": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3875": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "3876": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3877": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3879": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "3880": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3881": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3883": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3884": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "3886": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3887": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3888": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3889": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3890": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3891": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3892": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3893": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3894": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3895": {"vr": "FD", "Value": [12.0, -117.0, -147.0, 1144.0, 1444.0, 1824.0]},
        "3896": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3897": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3898": {"vr": "FD", "Value": [912.0, 771.0, 1140.0, 651.0, 963.0, 1427.0]},
        "3899": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3901": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3902": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3903": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3904": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3905": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3906": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3907": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3908": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3909": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3910": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3911": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3912": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3913": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3914": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3915": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3917": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3918": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3919": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3920": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3921": {"vr": "FD", "Value": [238.0, 149.0, -793.0, 94.0, -496.0, 2652.0]},
        "3922": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3923": {"vr": "FD", "Value": [330.0, 17.0, 935.0, 1.0, 49.0, 2652.0]},
        "3924": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3925": {"vr": "FD", "Value": [868.0, 1330.0, 277.0, 2039.0, 424.0, 89.0]},
        "3926": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3927": {"vr": "FD", "Value": [707.0, 1194.0, -440.0, 2016.0, -743.0, 274.0]},
        "3929": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3930": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3931": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3932": {"vr": "FD", "Value": [1620.0, -1344.0, -648.0, 1116.0, 538.0, 260.0]},
        "3933": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3934": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3935": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3936": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3938": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3939": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3940": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3941": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3942": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3943": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3944": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3946": {"vr": "FD", "Value": [233.0, -640.0, -480.0, 1760.0, 1321.0, 992.0]},
        "3947": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3948": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "3949": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "3950": {"vr": "FD", "Value": [451.0, -880.0, 608.0, 1719.0, -1188.0, 823.0]},
        "3951": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3952": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3953": {"vr": "FD", "Value": [80.0, -457.0, -152.0, 2617.0, 873.0, 292.0]},
        "3954": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "3955": {"vr": "FD", "Value": [2009.0, 35.0, 1406.0, 1.0, 25.0, 985.0]},
        "3956": {"vr": "FD", "Value": [2102.0, 1311.0, 408.0, 818.0, 254.0, 80.0]},
        "3957": {"vr": "FD", "Value": [130.0, -581.0, 183.0, 2604.0, -822.0, 260.0]},
        "3958": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "3959": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3960": {"vr": "FD", "Value": [351.0, -319.0, 907.0, 289.0, -822.0, 2345.0]},
        "3961": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3962": {"vr": "FD", "Value": [10.0, -138.0, 96.0, 1994.0, -1400.0, 984.0]},
        "3963": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "3964": {"vr": "FD", "Value": [1068.0, 270.0, 1405.0, 69.0, 357.0, 1852.0]},
        "3965": {"vr": "FD", "Value": [1531.0, 680.0, -1332.0, 303.0, -592.0, 1161.0]},
        "3966": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3967": {"vr": "FD", "Value": [985.0, 143.0, -1397.0, 21.0, -202.0, 1982.0]},
        "3969": {"vr": "FD", "Value": [214.0, 507.0, 578.0, 1201.0, 1372.0, 1568.0]},
        "3970": {"vr": "FD", "Value": [84.0, 478.0, 125.0, 2719.0, 710.0, 186.0]},
        "3971": {"vr": "FD", "Value": [277.0, 314.0, 806.0, 356.0, 914.0, 2350.0]},
        "3972": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "3973": {"vr": "FD", "Value": [848.0, -791.0, 1091.0, 739.0, -1018.0, 1405.0]},
        "3974": {"vr": "FD", "Value": [2668.0, 922.0, -222.0, 319.0, -77.0, 19.0]},
        "3975": {"vr": "FD", "Value": [4.0, -32.0, -92.0, 321.0, 922.0, 2654.0]},
        "3976": {"vr": "FD", "Value": [3005.0, 2.0, -40.0, 0.0, 0.0, 1.0]},
        "3977": {"vr": "FD", "Value": [2495.0, -1081.0, -306.0, 469.0, 132.0, 38.0]},
        "3978": {"vr": "FD", "Value": [981.0, 1046.0, -938.0, 1115.0, -1000.0, 898.0]},
        "3979": {"vr": "FD", "Value": [944.0, -992.0, -972.0, 1042.0, 1022.0, 1003.0]},
        "3980": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "3981": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "3982": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3983": {"vr": "FD", "Value": [2655.0, -373.0, -880.0, 53.0, 123.0, 293.0]},
        "3984": {"vr": "FD", "Value": [2459.0, 519.0, -1029.0, 110.0, -217.0, 431.0]},
        "3985": {"vr": "FD", "Value": [800.0, -1281.0, 343.0, 2051.0, -550.0, 148.0]},
        "3986": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3987": {"vr": "FD", "Value": [42.0, 212.0, -280.0, 1068.0, -1414.0, 1874.0]},
        "3988": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "3989": {"vr": "FD", "Value": [1501.0, 1489.0, -184.0, 1478.0, -182.0, 23.0]},
        "3990": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3991": {"vr": "FD", "Value": [1.0, -17.0, 46.0, 328.0, -931.0, 2651.0]},
        "3992": {"vr": "FD", "Value": [2700.0, 611.0, 662.0, 138.0, 150.0, 163.0]},
        "3993": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "3994": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3995": {"vr": "FD", "Value": [1.0, -55.0, 2.0, 2986.0, -83.0, 3.0]},
        "3996": {"vr": "FD", "Value": [349.0, -960.0, -31.0, 2642.0, 87.0, 3.0]},
        "3997": {"vr": "FD", "Value": [1283.0, 1234.0, 819.0, 1187.0, 788.0, 524.0]},
        "3998": {"vr": "FD", "Value": [1897.0, 809.0, 1194.0, 345.0, 509.0, 753.0]},
        "3999": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "4000": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "4001": {"vr": "FD", "Value": [2317.0, -1130.0, 557.0, 551.0, -272.0, 135.0]},
        "4002": {"vr": "FD", "Value": [312.0, -149.0, -900.0, 72.0, 432.0, 2598.0]},
        "4003": {"vr": "FD", "Value": [240.0, 657.0, -478.0, 1797.0, -1308.0, 953.0]},
        "4004": {"vr": "FD", "Value": [9.0, 135.0, 89.0, 2072.0, 1366.0, 901.0]},
        "4005": {"vr": "FD", "Value": [1387.0, -1240.0, 834.0, 1109.0, -745.0, 502.0]},
        "4006": {"vr": "FD", "Value": [1908.0, -752.0, 1229.0, 297.0, -484.0, 792.0]},
        "4007": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
        "4008": {"vr": "FD", "Value": [684.0, -1174.0, -446.0, 2016.0, 766.0, 292.0]},
        "4010": {"vr": "FD", "Value": [1077.0, -442.0, -1364.0, 181.0, 559.0, 1730.0]},
        "4012": {"vr": "FD", "Value": [146.0, -396.0, 507.0, 1073.0, -1376.0, 1766.0]},
        "4013": {"vr": "FD", "Value": [51.0, 365.0, -124.0, 2638.0, -895.0, 304.0]},
        "4014": {"vr": "FD", "Value": [524.0, 554.0, -992.0, 586.0, -1048.0, 1878.0]},
        "4015": {"vr": "FD", "Value": [1916.0, -81.0, -1434.0, 4.0, 61.0, 1075.0]},
        "4016": {"vr": "FD", "Value": [377.0, -493.0, -859.0, 646.0, 1125.0, 1961.0]},
        "4017": {"vr": "FD", "Value": [1853.0, -837.0, -1188.0, 379.0, 537.0, 763.0]},
        "4018": {"vr": "FD", "Value": [421.0, 902.0, 516.0, 1932.0, 1107.0, 635.0]},
        "4019": {"vr": "FD", "Value": [304.0, 903.0, -46.0, 2683.0, -136.0, 7.0]},
    },
    "00211146": {
        "0": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "4": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "5": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "6": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "7": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "8": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "9": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "10": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "11": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "12": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "15": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "16": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "17": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "18": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "19": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "20": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "21": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "22": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "23": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "24": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "25": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "26": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "27": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "28": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "29": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "30": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "32": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "33": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "36": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "37": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "38": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "39": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "41": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "42": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "43": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "44": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "45": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "46": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "47": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "48": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "49": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "50": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "51": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "52": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "53": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "54": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "55": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "56": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "57": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "58": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "59": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "62": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "63": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "64": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "65": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "66": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "67": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "69": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "70": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "71": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "72": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "73": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "74": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "75": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "76": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "77": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "78": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "79": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "81": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "82": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "83": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "84": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "85": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "86": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "87": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "88": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "89": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "92": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "93": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "94": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "95": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "96": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "97": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "98": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "99": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "100": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "101": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "102": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "103": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "104": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "105": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "106": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "107": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "108": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "109": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "110": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "111": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "113": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "115": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "116": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "117": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "118": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "119": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "120": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "121": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "122": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "123": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "124": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "125": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "126": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "127": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "129": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "130": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "131": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "132": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "133": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "134": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "135": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "136": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "137": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "138": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "139": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "140": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "141": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "142": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "143": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "144": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "145": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "146": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "147": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "148": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "149": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "150": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "151": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "152": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "153": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "154": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "155": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "156": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "157": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "158": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "159": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "161": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "162": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "163": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "164": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "165": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "166": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "167": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "168": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "169": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "170": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "171": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "172": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "173": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "174": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "175": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "176": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "177": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "178": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "179": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "180": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "181": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "182": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "183": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "184": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "185": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "186": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "187": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "188": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "189": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "190": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "192": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "193": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "194": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "195": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "196": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "197": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "199": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "200": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "201": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "202": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "203": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "204": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "205": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "206": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "207": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "208": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "209": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "211": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "212": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "213": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "214": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "215": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "216": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "217": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "218": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "219": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "220": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "221": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "222": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "223": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "224": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "225": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "226": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "228": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "229": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "230": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "231": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "232": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "233": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "234": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "235": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "236": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "237": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "238": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "239": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "240": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "241": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "242": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "244": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "245": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "247": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "248": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "249": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "250": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "251": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "252": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "253": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "254": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "255": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "257": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "258": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "259": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "260": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "261": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "262": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "263": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "264": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "265": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "266": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "267": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "268": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "269": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "271": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "272": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "273": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "274": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "276": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "277": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "278": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "279": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "280": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "281": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "282": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "283": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "284": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "285": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "286": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "287": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "288": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "289": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "291": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "292": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "293": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "294": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "295": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "296": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "297": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "298": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "299": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "300": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "302": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "303": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "304": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "305": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "306": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "307": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "308": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "309": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "310": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "312": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "314": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "315": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "317": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "318": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "319": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "320": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "321": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "322": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "323": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "324": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "325": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "326": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "327": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "328": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "329": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "330": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "331": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "332": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "333": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "334": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "335": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "336": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "337": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "338": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "339": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "340": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "341": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "342": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "343": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "344": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "345": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "346": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "347": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "348": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "351": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "352": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "353": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "354": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "355": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "356": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "357": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "358": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "359": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "360": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "362": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "364": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "365": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "366": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "367": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "369": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "370": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "371": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "372": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "373": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "374": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "375": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "376": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "377": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "378": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "379": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "380": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "381": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "382": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "385": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "386": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "387": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "388": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "389": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "390": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "391": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "392": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "393": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "394": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "395": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "397": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "398": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "400": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "401": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "402": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "403": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "404": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "405": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "406": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "407": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "408": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "409": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "410": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "411": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "412": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "413": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "414": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "415": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "416": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "417": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "419": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "420": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "421": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "422": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "423": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "425": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "426": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "427": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "428": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "429": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "430": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "431": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "432": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "433": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "434": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "435": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "436": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "437": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "438": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "439": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "440": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "441": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "442": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "443": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "444": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "446": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "447": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "449": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "450": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "451": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "452": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "453": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "454": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "455": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "456": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "457": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "458": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "459": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "460": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "461": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "462": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "463": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "464": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "465": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "466": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "467": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "468": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "470": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "471": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "472": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "473": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "474": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "476": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "477": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "478": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "479": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "480": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "481": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "482": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "484": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "485": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "486": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "487": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "488": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "489": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "490": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "491": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "492": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "493": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "494": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "495": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "496": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "498": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "499": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "500": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "502": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "503": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "504": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "505": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "506": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "508": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "509": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "510": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "511": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "512": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "513": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "516": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "517": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "518": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "519": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "521": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "522": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "523": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "524": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "525": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "526": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "527": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "528": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "529": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "530": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "532": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "533": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "534": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "535": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "536": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "537": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "538": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "540": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "541": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "543": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "545": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "546": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "547": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "549": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "550": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "551": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "552": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "556": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "557": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "558": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "559": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "560": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "561": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "562": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "563": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "564": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "565": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "566": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "568": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "569": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "570": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "571": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "572": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "573": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "574": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "575": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "576": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "577": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "578": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "579": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "580": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "581": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "582": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "583": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "584": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "586": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "588": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "589": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "590": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "591": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "592": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "593": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "594": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "595": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "596": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "597": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "598": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "599": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "601": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "602": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "603": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "604": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "605": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "606": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "607": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "608": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "609": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "610": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "612": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "613": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "614": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "615": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "616": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "617": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "618": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "619": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "620": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "621": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "622": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "623": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "625": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "626": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "627": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "628": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "629": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "630": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "631": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "632": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "633": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "634": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "635": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "637": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "638": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "639": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "640": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "641": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "642": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "643": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "644": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "645": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "646": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "647": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "648": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "649": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "650": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "651": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "652": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "653": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "654": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "655": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "656": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "657": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "658": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "659": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "660": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "661": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "662": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "664": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "665": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "666": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "667": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "669": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "670": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "671": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "672": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "673": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "674": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "675": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "676": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "677": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "678": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "680": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "681": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "682": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "683": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "684": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "685": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "686": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "688": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "689": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "691": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "692": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "693": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "694": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "695": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "696": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "697": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "698": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "700": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "701": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "702": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "703": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "704": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "705": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "706": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "708": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "709": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "710": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "711": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "712": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "713": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "716": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "717": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "718": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "719": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "720": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "721": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "722": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "723": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "724": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "725": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "726": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "727": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "728": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "729": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "730": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "731": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "733": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "734": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "735": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "736": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "737": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "738": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "739": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "740": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "741": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "742": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "743": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "744": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "745": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "746": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "747": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "748": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "749": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "750": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "751": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "752": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "753": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "754": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "755": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "756": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "758": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "759": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "760": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "761": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "762": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "763": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "764": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "765": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "766": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "767": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "768": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "769": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "770": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "772": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "773": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "774": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "775": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "776": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "778": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "779": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "780": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "781": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "782": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "783": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "784": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "785": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "786": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "787": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "789": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "790": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "792": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "793": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "794": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "795": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "796": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "797": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "798": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "799": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "800": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "801": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "802": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "803": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "804": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "805": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "806": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "807": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "808": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "809": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "811": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "812": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "813": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "814": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "815": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "817": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "818": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "819": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "821": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "822": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "823": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "824": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "825": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "826": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "828": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "830": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "831": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "832": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "833": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "834": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "835": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "836": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "837": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "838": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "839": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "840": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "841": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "842": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "843": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "844": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "845": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "847": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "848": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "849": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "851": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "852": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "853": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "854": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "855": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "856": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "857": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "858": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "859": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "860": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "862": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "863": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "864": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "865": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "866": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "869": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "871": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "872": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "873": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "874": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "876": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "877": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "878": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "879": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "880": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "881": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "882": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "883": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "884": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "886": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "887": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "888": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "889": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "890": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "891": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "892": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "893": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "894": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "895": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "896": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "897": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "898": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "899": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "900": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "901": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "902": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "903": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "904": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "905": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "906": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "907": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "908": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "909": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "910": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "911": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "912": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "913": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "914": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "915": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "916": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "917": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "918": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "920": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "921": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "922": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "923": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "925": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "927": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "928": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "929": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "930": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "931": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "933": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "934": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "935": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "937": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "938": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "939": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "940": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "941": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "942": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "943": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "944": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "945": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "946": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "947": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "949": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "950": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "951": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "952": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "953": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "954": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "955": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "957": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "958": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "959": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "960": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "962": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "963": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "964": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "965": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "966": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "967": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "968": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "969": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "970": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "971": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "972": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "973": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "974": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "975": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "976": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "977": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "979": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "980": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "981": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "982": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "984": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "985": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "986": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "987": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "988": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "989": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "990": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "991": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "992": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "993": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "994": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "995": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "997": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "998": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "999": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1000": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1001": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1002": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1003": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1004": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1005": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1006": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1007": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1008": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1009": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1010": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1011": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1012": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1013": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1014": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1017": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1018": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1019": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1020": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1021": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1022": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1023": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1024": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1025": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1026": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1027": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1028": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1029": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1031": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1033": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1034": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1035": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1036": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1037": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1038": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1040": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1041": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1042": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1043": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1044": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1045": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1046": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1047": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1048": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1049": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1050": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1051": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1052": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1053": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1054": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1055": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1056": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1057": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1058": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1059": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1061": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1062": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1063": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1064": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1066": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1067": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1068": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1069": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1070": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1071": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1072": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1074": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1075": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1076": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1077": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1078": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1079": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1080": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1082": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1083": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1084": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1085": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1086": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1087": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1089": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1092": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1093": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1094": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1095": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1096": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1098": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1099": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1100": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1101": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1102": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1103": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1104": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1106": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1107": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1108": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1109": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1111": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1112": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1113": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1114": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1115": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1116": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1117": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1118": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1119": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1120": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1121": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1122": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1123": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1124": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1125": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1126": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1127": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1128": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1129": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1130": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1132": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1133": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1134": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1135": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1137": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1138": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1139": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1140": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1141": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1142": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1143": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1144": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1145": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1146": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1150": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1151": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1152": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1153": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1154": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1155": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1156": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1157": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1158": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1159": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1160": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1161": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1162": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1163": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1164": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1167": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1168": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1169": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1170": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1171": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1172": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1173": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1174": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1175": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1176": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1177": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1179": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1180": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1181": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1182": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1183": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1184": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1185": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1186": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1187": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1188": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1190": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1192": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1194": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1195": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1196": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1197": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1198": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1199": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1200": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1203": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1204": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1205": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1206": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1207": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1208": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1209": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1210": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1211": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1212": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1213": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1214": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1215": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1216": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1217": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1218": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1221": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1222": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1223": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1224": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1225": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1226": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1227": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1228": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1229": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1230": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1231": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1232": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1233": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1234": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1235": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1236": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1237": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1238": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1239": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1240": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1241": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1242": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1243": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1244": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1245": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1246": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1247": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1248": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1249": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1250": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1251": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1252": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1253": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1254": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1255": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1256": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1257": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1258": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1259": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1261": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1262": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1263": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1265": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1266": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1267": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1268": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1269": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1270": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1272": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1273": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1274": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1275": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1276": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1277": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1278": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1279": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1280": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1281": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1283": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1284": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1285": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1286": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1287": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1288": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1289": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1290": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1292": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1293": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1294": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1295": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1296": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1297": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1298": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1299": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1301": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1302": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1303": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1304": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1305": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1306": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1307": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1308": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1310": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1311": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1312": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1313": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1314": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1315": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1316": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1317": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1318": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1319": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1320": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1321": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1322": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1323": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1325": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1327": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1328": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1329": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1331": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1332": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1334": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1335": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1336": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1337": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1338": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1339": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1340": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1341": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1342": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1343": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1344": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1345": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1346": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1348": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1349": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1350": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1351": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1352": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1353": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1354": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1355": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1356": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1357": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1359": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1360": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1361": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1362": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1363": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1364": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1365": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1366": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1367": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1368": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1369": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1370": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1371": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1372": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1373": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1374": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1376": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1377": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1378": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1379": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1380": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1382": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1383": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1384": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1385": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1386": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1387": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1388": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1389": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1390": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1391": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1392": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1393": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1394": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1395": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1396": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1397": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1398": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1399": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1400": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1401": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1402": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1403": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1405": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1406": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1407": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1408": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1409": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1410": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1411": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1412": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1414": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1415": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1416": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1418": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1419": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1420": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1421": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1422": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1423": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1424": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1425": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1426": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1427": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1428": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1429": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1431": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1432": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1433": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1434": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1435": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1436": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1437": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1438": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1439": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1440": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1441": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1443": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1444": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1445": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1446": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1447": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1448": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1450": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1451": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1452": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1453": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1454": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1456": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1457": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1458": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1459": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1462": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1463": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1464": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1465": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1466": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1467": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1468": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1469": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1470": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1471": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1472": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1473": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1475": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1476": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1477": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1478": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1479": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1480": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1481": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1482": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1483": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1484": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1485": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1486": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1487": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1489": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1490": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1491": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1492": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1494": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1495": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1496": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1497": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1498": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1499": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1500": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1501": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1502": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1503": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1504": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1505": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1506": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1507": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1508": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1509": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1510": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1511": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1513": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1514": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1516": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1518": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1519": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1520": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1521": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1522": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1523": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1524": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1525": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1526": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1527": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1528": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1529": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1530": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1531": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1532": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1533": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1534": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1535": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1537": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1538": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1539": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1540": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1541": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1542": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1543": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1544": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1545": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1546": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1547": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1548": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1549": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1550": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1551": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1552": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1554": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1556": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1557": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1558": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1560": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1561": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1563": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1564": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1565": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1566": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1567": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1568": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1569": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1570": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1571": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1572": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1573": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1575": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1576": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1577": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1578": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1579": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1580": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "1581": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1582": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1583": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1584": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1585": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1586": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1587": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1588": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1589": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1591": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1592": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1593": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1595": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1596": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1597": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1598": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1599": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1602": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1605": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1606": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1607": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1608": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1609": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1611": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1612": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1613": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1614": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1615": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1616": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1617": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1618": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1619": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1620": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1621": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1622": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1623": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1624": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1626": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1627": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1628": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1629": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1630": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1631": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1632": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1633": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1634": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1635": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1636": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1637": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1638": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1639": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1640": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1641": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1642": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1645": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1646": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1647": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1648": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1650": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1651": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1652": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1653": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1654": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1655": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1656": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1657": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1658": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1659": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1660": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1661": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1662": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1663": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1664": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1665": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1666": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1667": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1668": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1669": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1670": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1671": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1672": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1673": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1674": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1675": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1676": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1677": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1678": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1679": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1680": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1681": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1682": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1683": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1684": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1685": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1686": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1687": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1688": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1690": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1692": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1693": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1694": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1695": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1696": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1697": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1698": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1699": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1701": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1702": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1703": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1704": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1705": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1706": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1707": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1708": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1709": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1710": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1711": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1712": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1713": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1714": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1715": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1716": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1718": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1719": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1721": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1722": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1723": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1724": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1725": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1726": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1727": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1728": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1729": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1730": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1731": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1732": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1733": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1734": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1735": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1737": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1739": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1740": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1741": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1742": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1743": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1744": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1745": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1746": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1747": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1748": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1749": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1750": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1751": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1752": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1753": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1754": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1755": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1756": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1757": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1758": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1759": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "1760": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1761": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1762": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1763": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1764": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1765": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1766": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1767": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1768": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1769": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1770": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1771": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1772": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1773": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1774": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1776": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1777": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1778": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1779": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1780": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1781": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1782": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1783": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1784": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1785": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1786": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1787": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1788": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1789": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1790": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1791": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "1792": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1793": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1794": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1795": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1797": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1798": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1799": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1800": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1801": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1803": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1804": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1806": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1807": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1808": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1809": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1810": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1811": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1812": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1813": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1814": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1815": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1816": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1817": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1818": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1819": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1820": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1821": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1822": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1823": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1824": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "1825": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1826": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1828": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "1829": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "1830": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1831": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1832": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1833": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1834": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1835": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1836": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1839": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1840": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1841": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1842": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1843": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "1844": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1846": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1847": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1848": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1849": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1850": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1851": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1852": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1853": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "1854": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1855": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1856": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1857": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1858": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1859": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1860": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1861": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1862": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "1863": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "1864": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1865": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1866": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "1867": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "1868": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1869": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1870": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1871": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1874": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1875": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "1876": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1877": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1878": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1879": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "1880": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1881": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1882": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "1883": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1884": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1885": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1886": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1887": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "1888": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1890": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1891": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "1892": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1893": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1894": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1895": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1896": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1897": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1898": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1899": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1900": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "1901": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "1902": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1903": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1904": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1905": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1906": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1907": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1908": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1910": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1911": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1912": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1913": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1917": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1919": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "1921": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1922": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1923": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1924": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1925": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1926": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "1927": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1928": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1929": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "1930": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1931": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "1932": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1934": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "1935": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1936": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1937": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1938": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "1939": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1940": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1941": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "1942": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1943": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1944": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1945": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "1946": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1947": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1948": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "1950": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "1951": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "1952": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1953": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1954": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1955": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "1956": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "1957": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "1958": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1959": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "1960": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "1962": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "1963": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "1964": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "1965": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "1966": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1968": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "1969": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "1970": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "1971": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1972": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1974": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "1975": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "1976": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "1977": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1978": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "1979": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1980": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "1981": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "1982": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "1983": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1984": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "1985": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1987": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "1988": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "1989": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "1990": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "1991": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "1992": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "1994": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "1995": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "1997": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "1998": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "1999": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2000": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2002": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2003": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2004": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2005": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2006": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2007": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2008": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2009": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2010": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2011": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2013": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2014": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2015": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2016": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2018": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2019": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2020": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2021": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2022": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2023": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2024": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2026": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2027": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2028": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2030": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2031": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2032": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2033": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2034": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2035": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2036": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2037": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2038": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2039": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2040": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2041": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2042": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2043": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2044": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2045": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2046": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2047": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2048": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2049": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2050": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2051": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2052": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2053": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2054": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2055": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2056": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2057": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2058": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2059": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2060": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2061": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2062": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2063": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2065": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2066": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2067": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2068": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2069": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2070": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2071": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2072": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2073": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2074": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2076": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2077": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2078": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2080": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2081": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2085": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2087": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2088": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2089": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2090": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2091": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2092": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2093": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2094": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2095": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2096": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2097": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2099": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2100": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2101": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2102": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2103": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2104": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2105": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2106": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2107": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2108": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2110": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2111": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2112": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2113": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2114": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2115": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2116": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2117": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2118": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2119": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2120": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2121": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2122": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2123": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2124": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2125": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2126": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2127": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2128": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2129": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2130": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2131": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2133": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2134": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2135": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2136": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2137": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2138": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2139": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2140": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2141": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2142": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2143": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2144": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2145": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2147": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2148": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2149": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2150": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2151": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2152": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2153": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2154": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2155": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2156": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2157": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2159": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2160": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2161": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2162": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2163": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2164": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2166": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2167": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2168": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2169": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2171": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2172": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2173": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2175": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2176": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2177": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2178": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2179": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2180": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2181": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2182": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2183": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2184": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2185": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2186": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2188": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2189": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2190": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2191": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2193": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2194": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2195": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2196": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2197": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2198": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2199": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2200": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2201": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2202": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2203": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2205": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2206": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2207": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2208": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2209": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2210": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2211": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2212": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2213": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2214": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2215": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2216": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2217": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2218": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2219": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2221": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2222": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2223": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2224": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2225": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2226": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2227": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2228": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2229": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2230": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2231": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2232": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2233": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2234": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2235": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2236": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2237": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2238": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2240": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2241": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2242": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2243": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2244": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2245": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2246": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2247": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2248": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2249": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2250": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2251": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2252": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2253": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2255": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2256": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2257": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2258": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2260": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2261": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2262": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2264": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2265": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2266": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2267": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2268": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2269": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2270": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2271": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2272": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2273": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2274": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2275": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2276": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2277": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2279": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2280": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2281": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2282": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2283": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2284": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2285": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2286": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2288": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2289": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2290": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2292": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2293": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2294": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2297": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2298": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2299": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2300": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2301": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2302": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2303": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2304": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2305": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2306": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2307": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2308": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2309": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2310": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2311": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2312": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2314": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2315": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2316": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2317": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2318": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2319": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2320": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2321": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2322": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2323": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2324": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2325": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2326": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2327": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2328": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2329": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2330": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2331": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2332": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2333": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2334": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2335": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2336": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2337": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2338": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2339": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2341": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2342": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2343": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2344": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2345": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2347": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2348": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2349": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2350": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2351": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2352": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2353": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2354": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2355": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2356": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2357": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2358": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2361": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2362": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2363": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2364": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2365": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2366": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2367": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2368": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2370": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2371": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2372": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2373": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2374": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2375": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2377": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2378": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2379": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2380": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2383": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2384": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2386": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2387": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2388": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2389": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2390": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2391": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2392": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2393": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2395": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2396": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2397": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2398": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2399": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2401": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2402": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2403": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2404": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2405": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2406": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2407": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2408": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2409": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2410": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2411": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2412": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2413": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2414": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2415": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2416": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2419": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2420": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2421": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2422": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2423": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2424": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2425": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2426": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2427": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2428": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2429": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2430": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2431": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2432": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2434": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2435": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2436": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2437": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2438": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2439": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2440": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2441": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2442": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2443": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2444": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2445": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2446": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2447": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2448": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2449": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2450": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2451": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2452": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2453": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2454": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2455": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2456": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2457": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2458": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2459": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2460": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2461": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2462": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2463": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2464": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2465": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2466": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2467": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2468": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2469": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2470": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2471": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2472": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2473": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2474": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2475": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2476": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2477": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2478": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2481": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2482": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2483": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2484": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2485": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2486": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2487": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2488": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2489": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2490": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2491": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2492": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2493": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2494": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2495": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2496": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2497": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2498": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2499": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2500": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2501": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2502": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2503": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2504": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2505": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2506": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2507": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2508": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2509": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2510": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2511": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2512": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2513": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2514": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2515": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2516": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2517": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2518": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2519": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2521": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2523": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2524": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2526": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2527": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2528": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2529": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2530": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2531": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2532": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2533": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2535": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2536": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2538": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2540": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2541": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2542": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2543": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2544": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2545": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2547": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2549": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2550": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2551": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2552": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2553": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2554": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2555": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2556": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2558": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2559": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2560": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2561": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2562": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2563": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2564": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2565": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2566": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2567": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2568": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2569": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2570": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2573": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2574": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2575": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2576": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2577": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2578": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2579": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2580": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2581": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2582": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2583": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2586": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2587": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2588": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2589": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2590": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2591": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2592": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2593": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2594": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2595": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2596": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2597": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2598": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2599": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2600": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2601": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2602": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2603": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2604": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2605": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2606": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2607": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2608": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2610": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2612": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2613": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2614": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2615": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2616": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2617": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2619": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2620": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2621": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2622": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2623": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2624": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2625": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2626": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2627": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2630": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2631": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2632": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2633": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2634": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2635": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2637": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2638": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2641": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2642": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2643": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2644": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2645": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2646": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2647": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2648": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2649": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2650": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2651": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2652": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2653": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2654": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2655": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2656": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2657": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2659": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2660": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2661": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2662": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2663": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2664": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2665": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2666": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2667": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2668": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2669": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2670": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2671": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2672": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2673": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2674": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2675": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2676": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2677": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2678": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2681": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2682": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2683": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2684": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2685": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2686": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2687": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2688": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2689": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2690": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2691": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2692": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2693": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2694": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2695": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2696": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2697": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2698": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2699": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2700": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2701": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2703": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2704": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2705": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2706": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2707": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2708": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2709": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2710": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2711": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2712": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2713": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2714": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2715": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2716": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2717": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2718": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2719": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2720": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2721": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2722": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2723": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2724": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2725": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2727": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2728": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2729": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2730": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2731": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2732": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2733": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2734": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2735": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2737": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2738": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2739": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2740": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2742": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2743": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2744": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2745": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2747": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2748": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2749": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "2751": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2752": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2753": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2754": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2755": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2756": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2758": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2759": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2760": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2761": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2762": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2763": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2764": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2766": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2767": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2768": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2769": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2771": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2772": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2773": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2774": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2775": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2776": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2778": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2779": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2780": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2782": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2783": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2784": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2785": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "2786": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2787": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2788": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2789": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2790": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2791": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "2793": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2794": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2795": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2796": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2798": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2799": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2800": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2801": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2802": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2803": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2804": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2805": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2806": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "2807": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2808": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2809": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2810": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2811": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2812": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2813": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2814": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2815": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2816": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2817": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2819": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2820": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2821": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2823": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2824": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "2825": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2826": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2827": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2828": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "2829": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2831": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2832": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2833": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2834": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2835": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2836": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2837": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2838": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2839": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2840": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2841": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2842": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2843": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2844": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2845": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2846": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2847": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2848": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2849": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2850": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2851": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2853": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2854": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2856": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2857": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2858": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "2859": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2860": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2861": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2863": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "2864": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2865": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2866": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2867": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2868": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2869": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2870": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "2871": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "2872": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2873": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2874": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2875": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "2876": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2877": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2879": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2880": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "2881": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2883": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2884": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2885": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2886": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2887": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2888": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2889": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "2890": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2891": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2892": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2893": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2894": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "2895": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2896": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2897": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2898": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2899": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "2900": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2901": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2902": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2903": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2904": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2905": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2908": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2909": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "2910": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "2911": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2912": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2913": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "2914": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2915": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "2917": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2920": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2921": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "2922": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2924": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2925": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "2926": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2927": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2928": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2929": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "2931": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2932": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "2933": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2934": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2936": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "2937": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2938": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2939": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2940": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "2941": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "2942": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2943": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2944": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2945": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2947": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "2948": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "2950": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2951": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2952": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "2953": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "2956": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "2957": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "2958": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2959": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2960": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "2961": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2962": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2963": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2964": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "2965": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2966": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "2967": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "2969": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2970": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2971": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "2972": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "2973": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2974": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "2975": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "2976": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "2977": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "2978": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "2979": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "2980": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2981": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "2982": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "2983": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "2984": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "2986": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "2987": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "2988": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2989": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "2990": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "2991": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "2992": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "2993": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "2994": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "2995": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "2996": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "2997": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "2998": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "2999": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3000": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3001": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3002": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3003": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3004": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3006": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3007": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3008": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3009": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3010": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3011": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3012": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3013": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3014": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3015": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3016": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3017": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3018": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3020": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3021": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3022": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3023": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3024": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3025": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3026": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3027": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3028": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3030": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3031": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3032": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3033": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3034": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3035": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3036": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3037": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3038": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3039": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3040": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3041": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3042": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3043": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3044": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3045": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3046": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3047": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3048": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3049": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3050": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3051": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3052": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3054": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3055": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3056": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3057": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3058": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3059": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3060": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3061": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3062": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3063": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3064": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3065": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3066": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3067": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3068": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3069": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3070": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3071": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3073": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3075": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3076": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3078": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3079": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3080": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3081": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3082": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3083": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3084": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3085": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3086": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3087": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3088": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3090": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3091": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3093": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3094": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3095": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3096": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3097": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3098": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3099": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3100": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3101": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3103": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3104": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3105": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3106": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3107": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3108": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3109": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3110": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3111": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3112": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3113": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3114": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3115": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3116": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3117": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3118": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3119": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3120": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3121": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3122": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3123": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3124": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3125": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3126": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3127": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3128": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3129": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3130": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3131": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3133": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3134": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3135": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3136": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3137": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3138": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3139": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3140": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3141": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3142": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3143": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3144": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3145": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3146": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3147": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3148": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3149": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3150": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3151": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3152": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3153": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3154": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3155": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3156": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3157": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3158": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3159": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3161": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3162": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3163": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3164": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3166": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3167": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3168": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3169": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3170": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3171": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3173": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3174": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3175": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3176": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3177": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3178": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3179": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3180": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3181": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3182": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3183": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3184": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3185": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3186": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3187": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3188": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3189": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3190": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3191": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3192": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3195": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3196": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3197": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3198": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3199": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3200": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3201": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3202": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3203": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3204": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3205": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3206": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3207": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3208": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3209": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3210": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3211": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3212": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3213": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3215": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3216": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3217": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3219": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3220": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3221": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3222": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3223": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3224": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3225": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3226": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3227": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3228": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3229": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3231": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3232": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3233": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3234": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3235": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3236": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3237": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3238": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3239": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3240": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3241": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3242": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3244": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3245": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3246": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3247": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3248": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3249": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3250": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3251": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3252": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3253": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3254": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3255": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3257": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3259": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3260": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3261": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3262": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3263": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3265": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3266": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3267": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3268": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3269": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3271": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3272": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3273": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3274": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3275": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3276": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3277": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3278": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3279": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3281": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3282": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3283": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3284": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3285": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3286": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3287": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3288": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3289": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3290": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3291": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3292": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3293": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3294": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3295": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3296": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3297": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3298": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3299": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3300": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3301": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3302": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3303": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3304": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3305": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3306": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3307": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3308": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3309": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3310": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3311": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3312": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3313": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3314": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3316": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3317": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3318": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3319": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3320": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3321": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3322": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3323": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3324": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3325": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3326": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3327": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3329": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3330": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3331": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3332": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3333": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3334": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3335": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3336": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3337": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3338": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3339": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3340": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3341": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3342": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3344": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3345": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3346": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3348": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3349": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3350": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3351": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3352": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3353": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3354": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3355": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3356": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3357": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3358": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3359": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3360": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3361": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3362": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3363": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3364": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3366": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3367": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3368": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3369": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3370": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3371": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3372": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3373": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3374": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3375": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3377": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3378": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3379": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3380": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3381": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3383": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3385": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3386": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3387": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3388": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3390": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3391": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3392": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3393": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3394": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3395": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3396": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3397": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3398": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3399": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3400": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3401": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3402": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3403": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3404": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3406": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3407": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3408": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3409": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3410": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3411": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3412": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3413": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3414": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3415": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3416": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3417": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3418": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3419": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3420": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3421": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3422": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3423": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3424": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3425": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3426": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3427": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3428": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3429": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3430": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3432": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3433": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3434": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3435": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3437": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3438": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3439": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3440": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3441": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3442": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3443": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3444": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3445": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3447": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3448": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3449": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3450": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3451": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3452": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3453": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3455": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3456": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3457": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3458": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3459": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3460": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3461": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3462": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3463": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3464": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3465": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3466": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3467": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3468": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3469": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3470": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3471": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3472": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3473": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3475": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3476": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3477": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3478": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3479": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3480": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3482": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3483": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3484": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3485": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3486": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3487": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3488": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3489": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3490": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3491": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3493": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3494": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3495": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3496": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3497": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3499": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3500": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3502": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3504": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3505": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3506": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3507": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3508": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3509": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3510": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3512": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3513": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3514": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3515": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3516": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3517": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3518": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3519": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3520": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3523": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3524": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3525": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3526": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3527": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3528": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3530": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3531": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3533": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3534": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3535": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3536": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3537": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3538": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3540": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3541": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3542": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3543": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3544": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3545": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3546": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3547": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3548": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3549": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3550": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3551": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3552": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3553": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3554": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3555": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3556": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3557": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3558": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3559": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3560": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3561": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3562": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3563": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3564": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3565": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3566": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3567": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3568": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3569": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3570": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3571": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3572": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3573": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3574": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3576": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3577": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3578": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3579": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3580": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3581": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3582": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3583": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3584": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3585": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3586": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3587": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3588": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3590": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3591": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3592": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3593": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3594": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3595": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3597": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3599": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3600": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3601": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3602": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3603": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3604": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3605": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3606": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3607": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3608": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3609": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3611": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3612": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3613": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3615": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3616": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3617": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3618": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3619": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3620": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3621": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3622": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3623": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3624": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3625": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3626": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3627": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3629": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3630": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3631": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3632": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3633": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3634": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3635": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3636": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3637": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3639": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3641": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3642": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3643": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3644": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3645": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3646": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3647": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3648": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3649": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3650": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3651": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3652": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3655": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3656": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3657": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3658": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3659": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3660": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3661": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3662": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3663": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3664": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3665": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3666": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3667": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3669": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3670": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3671": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3672": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3674": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3675": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3676": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3677": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3678": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3679": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3680": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3681": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3682": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3683": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3684": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3685": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3686": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3688": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3689": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3690": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3691": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3692": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3693": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3694": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3695": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3697": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3699": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3700": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3701": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3702": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3703": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3704": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3705": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3706": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3707": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3708": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3709": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3710": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3711": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3712": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3713": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3714": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3715": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3717": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3718": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3719": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3720": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "3721": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3722": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3724": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3725": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3726": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3727": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3728": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3730": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3731": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3732": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3733": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3734": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3736": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3737": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3738": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3739": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3740": {"vr": "FD", "Value": [-0.62198764, 0.17957446, -0.76215762]},
        "3741": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3743": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3745": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3746": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3747": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3748": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3749": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3750": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3751": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3752": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3753": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3754": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3755": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3757": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3758": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3759": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3760": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3761": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3762": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3764": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3765": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3766": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3767": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3768": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3769": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3770": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3771": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3772": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3773": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3774": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3775": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3776": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3777": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3778": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3779": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3780": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3781": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3782": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3783": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3784": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3785": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3786": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3787": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3789": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3790": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3791": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3792": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3793": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3794": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3796": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3797": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3798": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3799": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3800": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3801": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3802": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3803": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3804": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3807": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3808": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3809": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3810": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3811": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3812": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3813": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3814": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3815": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3816": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3817": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3818": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3819": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3820": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3821": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3822": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3823": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3824": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3826": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3827": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3828": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3829": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3830": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3831": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "3833": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3834": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3835": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3836": {"vr": "FD", "Value": [-0.7998029, -0.50154459, 0.32980067]},
        "3837": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3838": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3839": {"vr": "FD", "Value": [0.00235134, 0.0003361, -0.99999726]},
        "3840": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3841": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3842": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3843": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3844": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3846": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3847": {"vr": "FD", "Value": [0.74066055, -0.67100638, 0.03423884]},
        "3848": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3849": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3850": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3851": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3852": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3853": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3854": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3856": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3857": {"vr": "FD", "Value": [-0.94943678, 0.11332987, -0.29279041]},
        "3858": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3859": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3860": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3861": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3862": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3864": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3865": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3866": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3867": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3868": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3869": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3870": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3871": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3872": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3873": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "3874": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3875": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "3876": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3877": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3879": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "3880": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3881": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3883": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3884": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "3886": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3887": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3888": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3889": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3890": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3891": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3892": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3893": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3894": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3895": {"vr": "FD", "Value": [0.06318755, -0.61957717, -0.78238827]},
        "3896": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3897": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3898": {"vr": "FD", "Value": [0.55233914, 0.46664691, 0.69076937]},
        "3899": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3901": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3902": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3903": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3904": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3905": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3906": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3907": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3908": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3909": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3910": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3911": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3912": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3913": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3914": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3915": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3917": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3918": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3919": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3920": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3921": {"vr": "FD", "Value": [0.28210151, 0.17650741, -0.94300789]},
        "3922": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3923": {"vr": "FD", "Value": [-0.33248705, -0.01739244, -0.94294751]},
        "3924": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3925": {"vr": "FD", "Value": [0.5382936, 0.82508194, 0.17169723]},
        "3926": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3927": {"vr": "FD", "Value": [0.48572865, 0.82017738, -0.30228627]},
        "3929": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3930": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3931": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3932": {"vr": "FD", "Value": [0.73541385, -0.61035973, -0.29432568]},
        "3933": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3934": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3935": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3936": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3938": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3939": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3940": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3941": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3942": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3943": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3944": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3946": {"vr": "FD", "Value": [0.27920806, -0.76794505, -0.57645768]},
        "3947": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3948": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "3949": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "3950": {"vr": "FD", "Value": [-0.38808951, 0.75802702, -0.52419609]},
        "3951": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3952": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3953": {"vr": "FD", "Value": [-0.16338813, 0.93584615, 0.31224382]},
        "3954": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "3955": {"vr": "FD", "Value": [-0.81911284, -0.01436893, -0.57345247]},
        "3956": {"vr": "FD", "Value": [-0.83720863, -0.52219409, -0.16246542]},
        "3957": {"vr": "FD", "Value": [-0.20809577, 0.932733, -0.29445738]},
        "3958": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "3959": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3960": {"vr": "FD", "Value": [-0.34297323, 0.31092295, -0.8863951]},
        "3961": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3962": {"vr": "FD", "Value": [-0.05638221, 0.8170324, -0.57382876]},
        "3963": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "3964": {"vr": "FD", "Value": [-0.59765112, -0.1516044, -0.7872923]},
        "3965": {"vr": "FD", "Value": [0.71508586, 0.3177923, -0.62262368]},
        "3966": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3967": {"vr": "FD", "Value": [0.57417601, 0.08314252, -0.81449932]},
        "3969": {"vr": "FD", "Value": [-0.2676087, -0.63461119, -0.72502023]},
        "3970": {"vr": "FD", "Value": [0.16769838, 0.95383984, 0.24913217]},
        "3971": {"vr": "FD", "Value": [-0.30457005, -0.34536016, -0.88767302]},
        "3972": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "3973": {"vr": "FD", "Value": [-0.53239393, 0.4968785, -0.68532354]},
        "3974": {"vr": "FD", "Value": [-0.94222695, -0.32566041, 0.07844551]},
        "3975": {"vr": "FD", "Value": [0.03273984, -0.32805452, -0.94409126]},
        "3976": {"vr": "FD", "Value": [-0.99991119, -0.00066538, 0.01331203]},
        "3977": {"vr": "FD", "Value": [0.91180575, -0.3951174, -0.11176988]},
        "3978": {"vr": "FD", "Value": [0.57246637, 0.6103071, -0.54754668]},
        "3979": {"vr": "FD", "Value": [0.5619635, -0.59056222, -0.57916605]},
        "3980": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "3981": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "3982": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3983": {"vr": "FD", "Value": [0.94086152, -0.13214193, -0.31195849]},
        "3984": {"vr": "FD", "Value": [0.90546983, 0.19111598, -0.37894464]},
        "3985": {"vr": "FD", "Value": [-0.51651448, 0.82707024, -0.22173771]},
        "3986": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3987": {"vr": "FD", "Value": [0.11856415, 0.59822345, -0.79250932]},
        "3988": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "3989": {"vr": "FD", "Value": [0.70717508, 0.70171767, -0.08657814]},
        "3990": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3991": {"vr": "FD", "Value": [-0.01646399, 0.33141178, -0.94334269]},
        "3992": {"vr": "FD", "Value": [-0.94857776, -0.2146554, -0.23264422]},
        "3993": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "3994": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3995": {"vr": "FD", "Value": [-0.01841336, 0.99944419, -0.02779028]},
        "3996": {"vr": "FD", "Value": [-0.34136367, 0.93942434, 0.03086642]},
        "3997": {"vr": "FD", "Value": [0.6546728, 0.62973601, 0.41813433]},
        "3998": {"vr": "FD", "Value": [-0.79597211, -0.33941871, -0.5012219]},
        "3999": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "4000": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "4001": {"vr": "FD", "Value": [-0.8785044, 0.42845654, -0.21131736]},
        "4002": {"vr": "FD", "Value": [0.32336244, -0.15515655, -0.93346834]},
        "4003": {"vr": "FD", "Value": [0.28339049, 0.77528363, -0.56446874]},
        "4004": {"vr": "FD", "Value": [-0.05431764, -0.83362091, -0.54965967]},
        "4005": {"vr": "FD", "Value": [-0.68029809, 0.6081993, -0.40900865]},
        "4006": {"vr": "FD", "Value": [-0.79801679, 0.31452075, -0.51404864]},
        "4007": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
        "4008": {"vr": "FD", "Value": [0.47813982, -0.82098705, -0.31202987]},
        "4010": {"vr": "FD", "Value": [0.60035211, -0.24615157, -0.76091188]},
        "4012": {"vr": "FD", "Value": [-0.22105293, 0.59956974, -0.76918906]},
        "4013": {"vr": "FD", "Value": [0.12995306, 0.93893874, -0.31860039]},
        "4014": {"vr": "FD", "Value": [0.41885969, 0.44267127, -0.79284209]},
        "4015": {"vr": "FD", "Value": [0.79997158, -0.03390114, -0.59907961]},
        "4016": {"vr": "FD", "Value": [0.35526568, -0.465242, -0.81076264]},
        "4017": {"vr": "FD", "Value": [0.78671545, -0.35553342, -0.5046531]},
        "4018": {"vr": "FD", "Value": [-0.37532908, -0.80422676, -0.46081209]},
        "4019": {"vr": "FD", "Value": [0.31862506, 0.94666427, -0.04801187]},
    },
    "0021115B": {
        "0": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "4": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "5": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "6": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "7": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "8": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "9": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "10": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "11": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "12": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "13": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "14": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "15": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "16": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "17": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "18": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "19": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "20": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "21": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "22": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "23": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "24": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "25": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "26": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "27": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "28": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "29": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "30": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "31": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "32": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "33": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "34": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "35": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "36": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "37": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "38": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "39": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "40": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "41": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "42": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "43": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "44": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "45": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "46": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "47": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "48": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "49": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "50": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "51": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "52": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "53": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "54": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "55": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "56": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "57": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "58": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "59": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "60": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "61": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "62": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "63": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "64": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "65": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "66": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "67": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "68": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "69": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "70": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "71": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "72": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "73": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "74": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "75": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "76": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "77": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "78": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "79": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "80": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "81": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "82": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "83": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "84": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "85": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "86": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "87": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "88": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "89": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "90": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "91": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "92": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "93": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "94": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "95": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "96": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "97": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "98": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "99": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "100": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "101": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "102": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "103": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "104": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "105": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "106": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "107": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "108": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "109": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "110": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "111": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "112": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "113": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "114": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "115": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "116": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "117": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "118": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "119": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "120": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "121": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "122": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "123": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "124": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "125": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "126": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "127": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "128": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "129": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "130": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "131": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "132": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "133": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "134": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "135": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "136": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "137": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "138": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "139": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "140": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "141": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "142": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "143": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "144": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "145": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "146": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "147": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "148": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "149": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "150": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "151": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "152": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "153": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "154": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "155": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "156": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "157": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "158": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "159": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "160": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "161": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "162": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "163": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "164": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "165": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "166": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "167": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "168": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "169": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "170": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "171": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "172": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "173": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "174": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "175": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "176": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "177": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "178": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "179": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "180": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "181": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "182": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "183": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "184": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "185": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "186": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "187": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "188": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "189": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "190": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "191": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "192": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "193": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "194": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "195": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "196": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "197": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "198": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "199": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "200": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "201": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "202": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "203": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "204": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "205": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "206": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "207": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "208": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "209": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "210": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "211": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "212": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "213": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "214": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "215": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "216": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "217": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "218": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "219": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "220": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "221": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "222": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "223": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "224": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "225": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "226": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "227": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "228": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "229": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "230": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "231": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "232": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "233": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "234": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "235": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "236": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "237": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "238": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "239": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "240": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "241": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "242": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "243": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "244": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "245": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "246": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "247": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "248": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "249": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "250": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "251": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "252": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "253": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "254": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "255": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "256": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "257": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "258": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "259": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "260": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "261": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "262": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "263": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "264": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "265": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "266": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "267": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "268": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "269": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "270": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "271": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "272": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "273": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "274": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "275": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "276": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "277": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "278": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "279": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "280": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "281": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "282": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "283": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "284": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "285": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "286": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "287": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "288": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "289": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "290": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "291": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "292": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "293": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "294": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "295": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "296": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "297": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "298": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "299": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "300": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "301": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "302": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "303": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "304": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "305": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "306": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "307": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "308": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "309": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "310": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "311": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "312": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "313": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "314": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "315": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "316": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "317": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "318": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "319": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "320": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "321": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "322": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "323": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "324": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "325": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "326": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "327": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "328": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "329": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "330": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "331": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "332": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "333": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "334": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "335": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "336": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "337": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "338": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "339": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "340": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "341": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "342": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "343": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "344": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "345": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "346": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "347": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "348": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "349": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "350": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "351": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "352": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "353": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "354": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "355": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "356": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "357": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "358": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "359": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "360": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "361": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "362": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "363": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "364": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "365": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "366": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "367": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "368": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "369": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "370": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "371": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "372": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "373": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "374": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "375": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "376": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "377": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "378": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "379": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "380": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "381": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "382": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "383": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "384": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "385": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "386": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "387": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "388": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "389": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "390": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "391": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "392": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "393": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "394": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "395": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "396": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "397": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "398": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "399": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "400": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "401": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "402": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "403": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "404": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "405": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "406": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "407": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "408": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "409": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "410": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "411": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "412": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "413": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "414": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "415": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "416": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "417": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "418": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "419": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "420": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "421": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "422": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "423": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "424": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "425": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "426": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "427": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "428": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "429": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "430": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "431": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "432": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "433": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "434": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "435": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "436": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "437": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "438": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "439": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "440": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "441": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "442": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "443": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "444": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "445": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "446": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "447": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "448": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "449": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "450": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "451": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "452": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "453": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "454": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "455": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "456": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "457": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "458": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "459": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "460": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "461": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "462": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "463": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "464": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "465": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "466": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "467": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "468": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "469": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "470": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "471": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "472": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "473": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "474": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "475": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "476": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "477": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "478": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "479": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "480": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "481": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "482": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "483": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "484": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "485": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "486": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "487": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "488": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "489": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "490": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "491": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "492": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "493": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "494": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "495": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "496": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "497": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "498": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "499": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "500": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "501": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "502": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "503": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "504": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "505": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "506": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "507": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "508": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "509": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "510": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "511": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "512": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "513": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "514": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "515": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "516": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "517": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "518": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "519": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "520": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "521": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "522": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "523": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "524": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "525": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "526": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "527": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "528": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "529": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "530": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "531": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "532": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "533": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "534": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "535": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "536": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "537": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "538": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "539": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "540": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "541": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "542": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "543": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "544": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "545": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "546": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "547": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "548": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "549": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "550": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "551": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "552": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "553": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "554": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "555": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "556": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "557": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "558": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "559": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "560": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "561": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "562": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "563": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "564": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "565": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "566": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "567": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "568": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "569": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "570": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "571": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "572": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "573": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "574": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "575": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "576": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "577": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "578": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "579": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "580": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "581": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "582": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "583": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "584": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "585": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "586": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "587": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "588": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "589": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "590": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "591": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "592": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "593": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "594": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "595": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "596": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "597": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "598": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "599": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "600": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "601": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "602": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "603": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "604": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "605": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "606": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "607": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "608": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "609": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "610": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "611": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "612": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "613": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "614": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "615": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "616": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "617": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "618": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "619": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "620": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "621": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "622": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "623": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "624": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "625": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "626": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "627": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "628": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "629": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "630": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "631": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "632": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "633": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "634": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "635": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "636": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "637": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "638": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "639": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "640": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "641": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "642": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "643": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "644": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "645": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "646": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "647": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "648": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "649": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "650": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "651": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "652": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "653": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "654": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "655": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "656": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "657": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "658": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "659": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "660": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "661": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "662": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "663": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "664": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "665": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "666": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "667": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "668": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "669": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "670": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "671": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "672": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "673": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "674": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "675": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "676": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "677": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "678": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "679": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "680": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "681": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "682": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "683": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "684": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "685": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "686": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "687": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "688": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "689": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "690": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "691": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "692": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "693": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "694": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "695": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "696": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "697": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "698": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "699": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "700": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "701": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "702": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "703": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "704": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "705": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "706": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "707": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "708": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "709": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "710": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "711": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "712": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "713": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "714": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "715": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "716": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "717": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "718": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "719": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "720": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "721": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "722": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "723": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "724": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "725": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "726": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "727": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "728": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "729": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "730": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "731": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "732": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "733": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "734": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "735": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "736": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "737": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "738": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "739": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "740": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "741": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "742": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "743": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "744": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "745": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "746": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "747": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "748": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "749": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "750": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "751": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "752": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "753": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "754": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "755": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "756": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "757": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "758": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "759": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "760": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "761": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "762": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "763": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "764": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "765": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "766": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "767": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "768": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "769": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "770": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "771": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "772": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "773": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "774": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "775": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "776": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "777": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "778": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "779": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "780": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "781": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "782": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "783": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "784": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "785": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "786": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "787": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "788": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "789": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "790": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "791": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "792": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "793": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "794": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "795": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "796": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "797": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "798": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "799": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "800": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "801": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "802": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "803": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "804": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "805": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "806": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "807": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "808": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "809": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "810": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "811": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "812": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "813": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "814": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "815": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "816": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "817": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "818": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "819": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "820": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "821": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "822": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "823": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "824": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "825": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "826": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "827": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "828": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "829": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "830": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "831": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "832": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "833": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "834": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "835": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "836": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "837": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "838": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "839": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "840": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "841": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "842": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "843": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "844": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "845": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "846": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "847": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "848": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "849": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "850": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "851": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "852": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "853": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "854": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "855": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "856": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "857": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "858": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "859": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "860": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "861": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "862": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "863": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "864": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "865": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "866": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "867": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "868": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "869": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "870": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "871": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "872": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "873": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "874": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "875": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "876": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "877": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "878": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "879": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "880": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "881": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "882": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "883": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "884": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "885": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "886": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "887": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "888": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "889": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "890": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "891": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "892": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "893": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "894": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "895": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "896": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "897": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "898": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "899": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "900": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "901": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "902": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "903": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "904": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "905": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "906": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "907": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "908": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "909": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "910": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "911": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "912": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "913": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "914": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "915": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "916": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "917": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "918": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "919": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "920": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "921": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "922": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "923": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "924": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "925": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "926": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "927": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "928": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "929": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "930": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "931": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "932": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "933": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "934": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "935": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "936": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "937": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "938": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "939": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "940": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "941": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "942": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "943": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "944": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "945": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "946": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "947": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "948": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "949": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "950": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "951": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "952": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "953": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "954": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "955": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "956": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "957": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "958": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "959": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "960": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "961": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "962": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "963": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "964": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "965": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "966": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "967": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "968": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "969": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "970": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "971": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "972": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "973": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "974": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "975": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "976": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "977": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "978": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "979": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "980": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "981": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "982": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "983": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "984": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "985": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "986": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "987": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "988": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "989": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "990": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "991": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "992": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "993": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "994": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "995": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "996": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "997": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "998": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "999": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1000": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1001": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1002": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1003": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1004": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1005": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1006": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1007": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1008": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1009": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1010": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1011": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1012": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1013": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1014": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1015": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1016": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1017": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1018": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1019": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1020": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1021": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1022": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1023": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1024": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1025": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1026": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1027": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1028": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1029": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1030": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1031": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1032": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1033": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1034": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1035": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1036": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1037": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1038": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1039": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1040": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1041": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1042": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1043": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1044": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1045": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1046": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1047": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1048": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1049": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1050": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1051": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1052": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1053": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1054": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1055": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1056": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1057": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1058": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1059": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1060": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1061": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1062": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1063": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1064": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1065": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1066": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1067": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1068": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1069": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1070": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1071": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1072": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1073": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1074": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1075": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1076": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1077": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1078": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1079": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1080": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1081": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1082": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1083": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1084": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1085": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1086": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1087": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1088": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1089": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1090": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1091": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1092": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1093": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1094": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1095": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1096": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1097": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1098": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1099": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1100": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1101": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1102": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1103": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1104": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1105": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1106": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1107": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1108": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1109": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1110": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1111": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1112": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1113": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1114": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1115": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1116": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1117": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1118": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1119": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1120": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1121": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1122": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1123": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1124": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1125": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1126": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1127": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1128": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1129": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1130": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1131": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1132": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1133": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1134": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1135": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1136": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1137": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1138": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1139": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1140": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1141": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1142": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1143": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1144": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1145": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1146": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1147": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1148": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1149": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1150": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1151": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1152": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1153": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1154": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1155": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1156": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1157": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1158": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1159": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1160": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1161": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1162": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1163": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1164": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1165": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1166": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1167": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1168": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1169": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1170": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1171": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1172": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1173": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1174": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1175": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1176": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1177": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1178": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1179": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1180": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1181": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1182": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1183": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1184": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1185": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1186": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1187": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1188": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1189": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1190": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1191": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1192": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1193": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1194": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1195": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1196": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1197": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1198": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1199": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1200": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1201": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1202": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1203": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1204": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1205": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1206": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1207": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1208": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1209": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1210": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1211": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1212": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1213": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1214": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1215": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1216": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1217": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1218": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1219": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1220": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1221": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1222": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1223": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1224": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1225": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1226": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1227": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1228": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1229": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1230": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1231": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1232": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1233": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1234": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1235": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1236": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1237": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1238": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1239": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1240": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1241": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1242": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1243": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1244": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1245": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1246": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1247": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1248": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1249": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1250": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1251": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1252": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1253": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1254": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1255": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1256": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1257": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1258": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1259": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1260": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1261": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1262": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1263": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1264": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1265": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1266": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1267": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1268": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1269": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1270": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1271": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1272": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1273": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1274": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1275": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1276": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1277": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1278": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1279": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1280": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1281": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1282": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1283": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1284": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1285": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1286": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1287": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1288": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1289": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1290": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1291": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1292": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1293": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1294": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1295": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1296": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1297": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1298": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1299": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1300": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1301": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1302": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1303": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1304": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1305": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1306": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1307": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1308": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1309": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1310": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1311": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1312": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1313": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1314": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1315": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1316": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1317": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1318": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1319": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1320": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1321": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1322": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1323": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1324": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1325": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1326": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1327": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1328": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1329": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1330": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1331": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1332": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1333": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1334": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1335": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1336": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1337": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1338": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1339": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1340": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1341": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1342": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1343": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1344": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1345": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1346": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1347": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1348": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1349": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1350": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1351": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1352": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1353": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1354": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1355": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1356": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1357": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1358": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1359": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1360": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1361": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1362": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1363": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1364": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1365": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1366": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1367": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1368": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1369": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1370": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1371": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1372": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1373": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1374": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1375": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1376": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1377": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1378": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1379": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1380": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1381": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1382": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1383": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1384": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1385": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1386": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1387": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1388": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1389": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1390": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1391": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1392": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1393": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1394": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1395": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1396": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1397": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1398": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1399": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1400": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1401": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1402": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1403": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1404": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1405": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1406": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1407": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1408": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1409": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1410": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1411": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1412": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1413": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1414": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1415": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1416": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1417": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1418": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1419": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1420": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1421": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1422": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1423": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1424": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1425": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1426": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1427": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1428": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1429": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1430": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1431": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1432": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1433": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1434": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1435": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1436": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1437": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1438": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1439": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1440": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1441": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1442": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1443": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1444": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1445": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1446": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1447": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1448": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1449": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1450": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1451": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1452": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1453": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1454": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1455": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1456": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1457": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1458": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1459": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1460": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1461": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1462": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1463": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1464": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1465": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1466": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1467": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1468": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1469": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1470": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1471": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1472": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1473": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1474": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1475": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1476": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1477": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1478": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1479": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1480": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1481": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1482": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1483": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1484": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1485": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1486": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1487": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1488": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1489": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1490": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1491": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1492": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1493": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1494": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1495": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1496": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1497": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1498": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1499": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1500": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1501": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1502": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1503": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1504": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1505": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1506": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1507": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1508": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1509": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1510": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1511": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1512": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1513": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1514": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1515": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1516": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1517": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1518": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1519": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1520": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1521": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1522": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1523": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1524": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1525": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1526": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1527": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1528": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1529": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1530": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1531": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1532": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1533": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1534": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1535": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1536": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1537": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1538": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1539": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1540": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1541": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1542": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1543": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1544": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1545": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1546": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1547": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1548": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1549": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1550": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1551": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1552": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1553": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1554": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1555": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1556": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1557": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1558": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1559": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1560": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1561": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1562": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1563": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1564": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1565": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1566": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1567": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1568": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1569": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1570": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1571": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1572": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1573": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1574": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1575": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1576": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1577": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1578": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1579": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1580": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1581": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1582": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1583": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1584": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1585": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1586": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1587": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1588": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1589": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1590": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1591": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1592": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1593": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1594": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1595": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1596": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1597": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1598": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1599": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1600": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1601": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1602": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1603": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1604": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1605": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1606": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1607": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1608": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1609": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1610": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1611": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1612": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1613": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1614": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1615": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1616": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1617": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1618": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1619": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1620": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1621": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1622": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1623": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1624": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1625": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1626": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1627": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1628": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1629": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1630": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1631": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1632": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1633": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1634": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1635": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1636": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1637": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1638": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1639": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1640": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1641": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1642": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1643": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1644": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1645": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1646": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1647": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1648": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1649": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1650": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1651": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1652": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1653": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1654": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1655": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1656": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1657": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1658": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1659": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1660": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1661": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1662": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1663": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1664": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1665": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1666": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1667": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1668": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1669": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1670": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1671": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1672": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1673": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1674": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1675": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1676": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1677": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1678": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1679": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1680": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1681": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1682": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1683": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1684": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1685": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1686": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1687": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1688": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1689": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1690": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1691": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1692": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1693": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1694": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1695": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1696": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1697": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1698": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1699": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1700": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1701": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1702": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1703": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1704": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1705": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1706": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1707": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1708": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1709": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1710": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1711": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1712": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1713": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1714": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1715": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1716": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1717": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1718": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1719": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1720": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1721": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1722": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1723": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1724": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1725": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1726": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1727": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1728": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1729": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1730": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1731": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1732": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1733": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1734": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1735": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1736": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1737": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1738": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1739": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1740": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1741": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1742": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1743": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1744": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1745": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1746": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1747": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1748": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1749": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1750": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1751": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1752": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1753": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "1754": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1755": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1756": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1757": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1758": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1759": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1760": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1761": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1762": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1763": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1764": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1765": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1766": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1767": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1768": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1769": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1770": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1771": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1772": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1773": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1774": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1775": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1776": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1777": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1778": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1779": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1780": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1781": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1782": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1783": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1784": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1785": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1786": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1787": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "1788": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1789": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1790": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1791": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1792": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1793": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1794": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1795": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1796": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "1797": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1798": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1799": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "1800": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1801": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1802": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1803": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1804": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1805": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1806": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1807": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1808": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1809": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1810": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "1811": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1812": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "1813": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1814": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1815": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1816": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1817": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1818": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1819": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1820": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1821": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1822": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1823": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1824": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1825": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1826": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1827": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1828": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1829": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1830": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1831": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1832": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1833": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1834": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1835": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1836": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1837": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1838": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1839": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1840": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "1841": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1842": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1843": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1844": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1845": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1846": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "1847": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1848": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1849": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1850": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1851": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1852": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1853": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1854": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "1855": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1856": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1857": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "1858": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1859": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1860": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1861": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1862": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1863": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "1864": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1865": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1866": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1867": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1868": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1869": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1870": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1871": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1872": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1873": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1874": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1875": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1876": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1877": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1878": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1879": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1880": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1881": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1882": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1883": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1884": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "1885": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1886": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1887": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1888": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1889": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1890": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1891": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1892": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1893": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1894": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1895": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1896": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1897": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1898": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1899": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "1900": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1901": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1902": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1903": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1904": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "1905": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "1906": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "1907": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1908": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1909": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "1910": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "1911": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1912": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1913": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1914": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1915": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1916": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1917": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1918": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1919": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1920": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1921": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1922": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1923": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1924": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1925": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1926": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1927": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "1928": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "1929": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "1930": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1931": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "1932": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1933": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1934": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "1935": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "1936": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1937": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1938": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1939": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "1940": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "1941": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "1942": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1943": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "1944": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1945": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "1946": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1947": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1948": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1949": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1950": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "1951": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1952": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1953": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1954": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "1955": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "1956": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1957": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "1958": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1959": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1960": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "1961": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "1962": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "1963": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "1964": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1965": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1966": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "1967": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1968": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "1969": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1970": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1971": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "1972": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1973": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "1974": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "1975": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "1976": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1977": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "1978": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "1979": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "1980": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1981": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1982": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1983": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "1984": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1985": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "1986": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "1987": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "1988": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "1989": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "1990": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "1991": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "1992": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "1993": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "1994": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1995": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "1996": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "1997": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "1998": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "1999": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2000": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2001": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2002": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2003": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2004": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2005": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2006": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2007": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2008": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2009": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2010": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2011": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2012": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2013": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2014": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2015": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2016": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2017": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2018": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2019": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2020": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2021": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2022": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2023": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2024": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2025": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2026": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2027": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2028": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2029": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2030": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2031": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2032": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2033": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2034": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2035": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2036": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2037": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2038": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2039": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2040": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2041": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2042": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2043": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2044": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2045": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2046": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2047": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2048": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2049": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2050": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2051": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2052": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2053": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2054": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2055": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2056": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2057": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2058": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2059": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2060": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2061": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2062": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2063": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2064": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2065": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2066": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2067": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2068": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2069": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2070": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2071": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2072": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2073": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2074": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2075": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2076": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2077": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2078": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2079": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2080": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2081": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2082": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2083": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2084": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2085": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2086": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2087": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2088": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2089": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2090": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2091": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2092": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2093": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2094": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2095": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2096": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2097": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2098": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2099": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2100": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2101": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2102": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2103": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2104": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2105": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2106": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2107": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2108": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2109": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2110": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2111": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2112": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2113": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2114": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2115": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2116": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2117": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2118": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2119": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2120": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2121": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2122": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2123": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2124": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2125": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2126": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2127": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2128": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2129": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2130": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2131": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2132": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2133": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2134": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2135": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2136": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2137": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2138": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2139": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2140": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2141": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2142": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2143": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2144": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2145": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2146": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2147": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2148": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2149": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2150": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2151": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2152": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2153": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2154": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2155": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2156": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2157": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2158": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2159": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2160": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2161": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2162": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2163": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2164": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2165": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2166": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2167": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2168": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2169": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2170": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2171": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2172": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2173": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2174": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2175": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2176": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2177": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2178": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2179": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2180": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2181": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2182": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2183": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2184": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2185": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2186": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2187": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2188": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2189": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2190": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2191": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2192": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2193": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2194": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2195": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2196": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2197": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2198": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2199": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2200": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2201": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2202": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2203": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2204": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2205": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2206": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2207": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2208": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2209": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2210": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2211": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2212": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2213": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2214": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2215": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2216": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2217": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2218": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2219": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2220": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2221": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2222": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2223": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2224": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2225": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2226": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2227": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2228": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2229": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2230": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2231": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2232": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2233": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2234": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2235": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2236": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2237": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2238": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2239": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2240": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2241": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2242": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2243": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2244": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2245": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2246": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2247": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2248": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2249": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2250": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2251": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2252": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2253": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2254": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2255": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2256": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2257": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2258": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2259": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2260": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2261": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2262": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2263": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2264": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2265": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2266": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2267": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2268": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2269": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2270": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2271": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2272": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2273": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2274": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2275": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2276": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2277": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2278": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2279": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2280": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2281": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2282": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2283": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2284": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2285": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2286": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2287": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2288": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2289": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2290": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2291": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2292": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2293": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2294": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2295": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2296": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2297": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2298": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2299": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2300": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2301": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2302": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2303": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2304": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2305": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2306": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2307": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2308": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2309": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2310": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2311": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2312": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2313": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2314": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2315": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2316": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2317": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2318": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2319": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2320": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2321": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2322": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2323": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2324": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2325": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2326": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2327": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2328": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2329": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2330": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2331": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2332": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2333": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2334": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2335": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2336": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2337": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2338": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2339": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2340": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2341": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2342": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2343": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2344": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2345": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2346": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2347": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2348": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2349": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2350": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2351": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2352": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2353": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2354": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2355": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2356": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2357": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2358": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2359": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2360": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2361": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2362": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2363": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2364": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2365": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2366": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2367": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2368": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2369": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2370": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2371": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2372": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2373": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2374": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2375": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2376": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2377": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2378": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2379": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2380": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2381": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2382": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2383": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2384": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2385": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2386": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2387": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2388": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2389": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2390": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2391": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2392": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2393": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2394": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2395": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2396": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2397": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2398": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2399": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2400": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2401": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2402": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2403": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2404": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2405": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2406": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2407": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2408": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2409": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2410": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2411": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2412": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2413": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2414": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2415": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2416": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2417": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2418": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2419": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2420": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2421": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2422": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2423": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2424": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2425": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2426": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2427": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2428": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2429": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2430": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2431": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2432": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2433": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2434": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2435": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2436": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2437": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2438": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2439": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2440": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2441": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2442": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2443": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2444": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2445": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2446": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2447": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2448": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2449": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2450": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2451": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2452": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2453": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2454": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2455": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2456": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2457": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2458": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2459": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2460": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2461": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2462": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2463": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2464": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2465": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2466": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2467": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2468": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2469": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2470": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2471": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2472": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2473": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2474": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2475": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2476": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2477": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2478": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2479": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2480": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2481": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2482": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2483": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2484": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2485": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2486": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2487": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2488": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2489": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2490": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2491": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2492": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2493": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2494": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2495": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2496": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2497": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2498": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2499": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2500": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2501": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2502": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2503": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2504": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2505": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2506": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2507": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2508": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2509": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2510": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2511": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2512": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2513": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2514": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2515": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2516": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2517": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2518": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2519": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2520": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2521": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2522": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2523": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2524": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2525": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2526": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2527": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2528": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2529": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2530": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2531": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2532": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2533": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2534": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2535": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2536": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2537": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2538": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2539": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2540": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2541": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2542": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2543": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2544": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2545": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2546": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2547": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2548": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2549": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2550": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2551": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2552": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2553": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2554": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2555": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2556": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2557": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2558": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2559": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2560": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2561": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2562": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2563": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2564": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2565": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2566": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2567": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2568": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2569": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2570": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2571": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2572": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2573": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2574": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2575": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2576": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2577": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2578": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2579": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2580": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2581": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2582": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2583": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2584": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2585": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2586": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2587": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2588": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2589": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2590": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2591": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2592": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2593": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2594": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2595": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2596": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2597": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2598": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2599": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2600": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2601": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2602": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2603": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2604": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2605": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2606": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2607": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2608": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2609": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2610": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2611": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2612": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2613": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2614": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2615": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2616": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2617": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2618": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2619": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2620": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2621": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2622": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2623": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2624": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2625": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2626": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2627": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2628": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2629": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2630": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2631": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2632": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2633": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2634": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2635": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2636": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2637": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2638": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2639": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2640": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2641": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2642": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2643": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2644": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2645": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2646": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2647": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2648": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2649": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2650": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2651": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2652": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2653": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2654": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2655": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2656": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2657": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2658": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2659": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2660": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2661": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2662": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2663": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2664": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2665": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2666": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2667": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2668": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2669": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2670": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2671": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2672": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2673": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2674": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2675": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2676": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2677": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2678": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2679": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2680": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2681": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2682": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2683": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2684": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2685": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2686": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2687": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2688": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2689": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2690": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2691": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2692": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2693": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2694": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2695": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2696": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2697": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2698": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2699": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2700": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2701": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2702": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2703": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2704": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2705": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2706": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2707": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2708": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2709": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2710": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2711": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2712": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2713": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2714": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2715": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2716": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2717": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2718": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2719": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2720": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2721": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2722": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2723": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2724": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2725": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2726": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2727": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2728": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2729": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2730": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2731": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2732": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2733": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2734": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2735": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2736": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2737": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2738": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2739": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2740": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2741": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2742": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2743": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2744": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2745": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2746": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2747": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2748": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2749": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2750": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2751": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2752": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2753": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2754": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2755": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2756": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2757": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2758": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2759": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2760": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2761": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2762": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2763": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2764": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2765": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2766": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2767": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2768": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "2769": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2770": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2771": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2772": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2773": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2774": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2775": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2776": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2777": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2778": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2779": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2780": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2781": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2782": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2783": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2784": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2785": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2786": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2787": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2788": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2789": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2790": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2791": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2792": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2793": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2794": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2795": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2796": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2797": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2798": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2799": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2800": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2801": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2802": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2803": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2804": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2805": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2806": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2807": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2808": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2809": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2810": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2811": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2812": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2813": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2814": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2815": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2816": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2817": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2818": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2819": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2820": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2821": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2822": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2823": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2824": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2825": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2826": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2827": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2828": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2829": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2830": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2831": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "2832": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2833": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2834": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2835": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2836": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2837": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2838": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2839": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2840": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2841": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2842": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2843": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2844": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2845": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2846": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2847": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "2848": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2849": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2850": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2851": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2852": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2853": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2854": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2855": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2856": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2857": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "2858": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2859": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2860": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2861": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "2862": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2863": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2864": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2865": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2866": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2867": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2868": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2869": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2870": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2871": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2872": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2873": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2874": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2875": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "2876": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2877": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2878": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2879": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "2880": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2881": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2882": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2883": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2884": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "2885": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2886": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2887": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2888": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2889": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "2890": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "2891": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2892": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "2893": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2894": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2895": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2896": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2897": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2898": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "2899": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2900": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2901": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2902": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2903": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2904": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "2905": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2906": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2907": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2908": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2909": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2910": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2911": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2912": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "2913": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "2914": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2915": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2916": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2917": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2918": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2919": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2920": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2921": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2922": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2923": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "2924": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "2925": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2926": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2927": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "2928": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2929": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2930": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2931": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "2932": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "2933": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2934": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2935": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "2936": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "2937": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "2938": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2939": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2940": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2941": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2942": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "2943": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2944": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "2945": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "2946": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "2947": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2948": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "2949": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "2950": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2951": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2952": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2953": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2954": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2955": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "2956": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "2957": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2958": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "2959": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2960": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2961": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "2962": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "2963": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2964": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2965": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2966": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2967": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2968": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2969": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "2970": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "2971": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "2972": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2973": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "2974": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2975": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "2976": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "2977": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2978": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "2979": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "2980": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "2981": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "2982": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2983": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "2984": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "2985": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "2986": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "2987": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "2988": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "2989": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "2990": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "2991": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "2992": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "2993": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "2994": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "2995": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "2996": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "2997": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "2998": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "2999": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3000": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3001": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3002": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3003": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3004": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3005": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3006": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3007": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3008": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3009": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3010": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3011": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3012": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3013": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3014": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3015": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3016": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3017": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3018": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3019": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3020": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3021": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3022": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3023": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3024": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3025": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3026": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3027": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3028": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3029": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3030": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3031": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3032": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3033": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3034": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3035": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3036": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3037": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3038": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3039": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3040": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3041": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3042": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3043": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3044": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3045": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3046": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3047": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3048": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3049": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3050": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3051": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3052": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3053": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3054": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3055": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3056": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3057": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3058": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3059": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3060": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3061": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3062": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3063": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3064": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3065": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3066": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3067": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3068": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3069": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3070": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3071": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3072": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3073": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3074": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3075": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3076": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3077": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3078": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3079": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3080": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3081": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3082": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3083": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3084": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3085": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3086": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3087": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3088": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3089": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3090": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3091": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3092": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3093": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3094": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3095": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3096": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3097": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3098": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3099": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3100": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3101": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3102": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3103": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3104": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3105": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3106": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3107": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3108": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3109": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3110": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3111": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3112": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3113": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3114": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3115": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3116": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3117": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3118": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3119": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3120": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3121": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3122": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3123": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3124": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3125": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3126": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3127": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3128": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3129": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3130": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3131": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3132": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3133": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3134": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3135": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3136": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3137": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3138": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3139": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3140": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3141": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3142": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3143": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3144": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3145": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3146": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3147": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3148": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3149": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3150": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3151": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3152": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3153": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3154": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3155": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3156": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3157": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3158": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3159": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3160": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3161": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3162": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3163": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3164": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3165": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3166": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3167": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3168": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3169": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3170": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3171": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3172": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3173": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3174": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3175": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3176": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3177": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3178": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3179": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3180": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3181": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3182": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3183": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3184": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3185": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3186": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3187": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3188": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3189": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3190": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3191": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3192": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3193": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3194": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3195": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3196": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3197": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3198": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3199": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3200": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3201": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3202": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3203": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3204": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3205": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3206": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3207": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3208": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3209": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3210": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3211": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3212": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3213": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3214": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3215": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3216": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3217": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3218": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3219": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3220": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3221": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3222": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3223": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3224": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3225": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3226": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3227": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3228": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3229": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3230": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3231": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3232": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3233": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3234": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3235": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3236": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3237": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3238": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3239": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3240": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3241": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3242": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3243": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3244": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3245": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3246": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3247": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3248": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3249": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3250": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3251": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3252": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3253": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3254": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3255": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3256": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3257": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3258": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3259": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3260": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3261": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3262": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3263": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3264": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3265": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3266": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3267": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3268": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3269": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3270": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3271": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3272": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3273": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3274": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3275": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3276": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3277": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3278": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3279": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3280": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3281": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3282": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3283": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3284": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3285": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3286": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3287": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3288": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3289": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3290": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3291": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3292": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3293": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3294": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3295": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3296": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3297": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3298": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3299": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3300": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3301": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3302": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3303": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3304": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3305": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3306": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3307": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3308": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3309": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3310": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3311": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3312": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3313": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3314": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3315": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3316": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3317": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3318": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3319": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3320": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3321": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3322": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3323": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3324": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3325": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3326": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3327": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3328": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3329": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3330": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3331": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3332": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3333": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3334": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3335": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3336": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3337": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3338": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3339": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3340": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3341": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3342": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3343": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3344": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3345": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3346": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3347": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3348": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3349": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3350": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3351": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3352": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3353": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3354": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3355": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3356": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3357": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3358": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3359": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3360": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3361": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3362": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3363": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3364": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3365": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3366": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3367": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3368": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3369": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3370": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3371": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3372": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3373": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3374": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3375": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3376": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3377": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3378": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3379": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3380": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3381": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3382": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3383": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3384": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3385": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3386": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3387": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3388": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3389": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3390": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3391": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3392": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3393": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3394": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3395": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3396": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3397": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3398": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3399": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3400": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3401": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3402": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3403": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3404": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3405": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3406": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3407": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3408": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3409": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3410": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3411": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3412": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3413": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3414": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3415": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3416": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3417": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3418": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3419": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3420": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3421": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3422": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3423": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3424": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3425": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3426": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3427": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3428": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3429": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3430": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3431": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3432": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3433": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3434": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3435": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3436": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3437": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3438": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3439": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3440": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3441": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3442": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3443": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3444": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3445": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3446": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3447": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3448": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3449": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3450": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3451": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3452": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3453": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3454": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3455": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3456": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3457": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3458": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3459": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3460": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3461": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3462": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3463": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3464": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3465": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3466": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3467": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3468": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3469": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3470": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3471": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3472": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3473": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3474": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3475": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3476": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3477": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3478": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3479": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3480": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3481": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3482": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3483": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3484": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3485": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3486": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3487": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3488": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3489": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3490": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3491": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3492": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3493": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3494": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3495": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3496": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3497": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3498": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3499": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3500": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3501": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3502": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3503": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3504": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3505": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3506": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3507": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3508": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3509": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3510": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3511": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3512": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3513": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3514": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3515": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3516": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3517": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3518": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3519": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3520": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3521": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3522": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3523": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3524": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3525": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3526": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3527": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3528": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3529": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3530": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3531": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3532": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3533": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3534": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3535": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3536": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3537": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3538": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3539": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3540": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3541": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3542": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3543": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3544": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3545": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3546": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3547": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3548": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3549": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3550": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3551": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3552": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3553": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3554": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3555": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3556": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3557": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3558": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3559": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3560": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3561": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3562": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3563": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3564": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3565": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3566": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3567": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3568": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3569": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3570": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3571": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3572": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3573": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3574": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3575": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3576": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3577": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3578": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3579": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3580": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3581": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3582": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3583": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3584": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3585": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3586": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3587": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3588": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3589": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3590": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3591": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3592": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3593": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3594": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3595": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3596": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3597": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3598": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3599": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3600": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3601": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3602": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3603": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3604": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3605": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3606": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3607": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3608": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3609": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3610": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3611": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3612": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3613": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3614": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3615": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3616": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3617": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3618": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3619": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3620": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3621": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3622": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3623": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3624": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3625": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3626": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3627": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3628": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3629": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3630": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3631": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3632": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3633": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3634": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3635": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3636": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3637": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3638": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3639": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3640": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3641": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3642": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3643": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3644": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3645": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3646": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3647": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3648": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3649": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3650": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3651": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3652": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3653": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3654": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3655": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3656": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3657": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3658": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3659": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3660": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3661": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3662": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3663": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3664": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3665": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3666": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3667": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3668": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3669": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3670": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3671": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3672": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3673": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3674": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3675": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3676": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3677": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3678": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3679": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3680": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3681": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3682": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3683": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3684": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3685": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3686": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3687": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3688": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3689": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3690": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3691": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3692": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3693": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3694": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3695": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3696": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3697": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3698": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3699": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3700": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3701": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3702": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3703": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3704": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3705": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3706": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3707": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3708": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3709": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3710": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3711": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3712": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3713": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3714": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3715": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3716": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3717": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3718": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3719": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3720": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3721": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3722": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3723": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3724": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3725": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3726": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3727": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3728": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3729": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3730": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3731": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3732": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3733": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3734": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3735": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3736": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3737": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3738": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3739": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3740": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3741": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3742": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3743": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3744": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3745": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3746": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3747": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3748": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3749": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3750": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3751": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3752": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3753": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3754": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3755": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3756": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3757": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3758": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3759": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3760": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3761": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3762": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3763": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3764": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3765": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3766": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3767": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3768": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3769": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3770": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3771": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3772": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3773": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3774": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3775": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3776": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3777": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3778": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3779": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3780": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3781": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3782": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3783": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3784": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3785": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3786": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3787": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3788": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3789": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3790": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3791": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3792": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3793": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3794": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3795": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3796": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3797": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3798": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3799": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3800": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3801": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3802": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3803": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3804": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3805": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3806": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3807": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3808": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3809": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3810": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3811": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3812": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3813": {"vr": "FD", "Value": [-117.42307591, -94.20575257, 43.45140429]},
        "3814": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3815": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3816": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3817": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3818": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3819": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3820": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3821": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3822": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3823": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3824": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3825": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3826": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3827": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3828": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3829": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3830": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3831": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3832": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3833": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3834": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3835": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3836": {"vr": "FD", "Value": [-117.42307591, -84.54266473, 87.40165492]},
        "3837": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3838": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3839": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3840": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3841": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3842": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3843": {"vr": "FD", "Value": [-117.42307591, -103.33200475, 1.94283267]},
        "3844": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3845": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3846": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3847": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3848": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3849": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3850": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3851": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3852": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3853": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3854": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3855": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3856": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3857": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3858": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3859": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3860": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3861": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3862": {"vr": "FD", "Value": [-117.42307591, -84.0058262, 89.84333583]},
        "3863": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3864": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3865": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3866": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3867": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3868": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3869": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3870": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3871": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3872": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3873": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "3874": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3875": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3876": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3877": {"vr": "FD", "Value": [-117.42307591, -85.61633988, 82.5182931]},
        "3878": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3879": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3880": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3881": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3882": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3883": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3884": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3885": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3886": {"vr": "FD", "Value": [-117.42307591, -114.60560962, -49.33246068]},
        "3887": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3888": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3889": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3890": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3891": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3892": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3893": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3894": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
        "3895": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3896": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3897": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3898": {"vr": "FD", "Value": [-117.42307591, -112.9950945, -42.00741796]},
        "3899": {"vr": "FD", "Value": [-117.42307591, -104.40568181, -2.94052915]},
        "3900": {"vr": "FD", "Value": [-117.42307591, -95.81626817, 36.12636157]},
        "3901": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3902": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3903": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3904": {"vr": "FD", "Value": [-117.42307591, -97.42678376, 28.80131956]},
        "3905": {"vr": "FD", "Value": [-117.42307591, -102.25832864, 6.82619258]},
        "3906": {"vr": "FD", "Value": [-117.42307591, -108.70038816, -22.47397451]},
        "3907": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3908": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3909": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3910": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3911": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3912": {"vr": "FD", "Value": [-117.42307591, -114.06877132, -46.89077977]},
        "3913": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3914": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3915": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3916": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3917": {"vr": "FD", "Value": [-117.42307591, -111.38457986, -34.68237905]},
        "3918": {"vr": "FD", "Value": [-117.42307591, -106.55303498, -12.70725087]},
        "3919": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3920": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3921": {"vr": "FD", "Value": [-117.42307591, -97.96362229, 26.35963877]},
        "3922": {"vr": "FD", "Value": [-117.42307591, -111.92141791, -37.12405996]},
        "3923": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3924": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "3925": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3926": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3927": {"vr": "FD", "Value": [-117.42307591, -91.52156182, 55.65980693]},
        "3928": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3929": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3930": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3931": {"vr": "FD", "Value": [-117.42307591, -100.64781304, 14.1512353]},
        "3932": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3933": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3934": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3935": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3936": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "3937": {"vr": "FD", "Value": [-117.42307591, -108.16354962, -20.0322936]},
        "3938": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3939": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3940": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "3941": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3942": {"vr": "FD", "Value": [-117.42307591, -94.74259111, 41.00972338]},
        "3943": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3944": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3945": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3946": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3947": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3948": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3949": {"vr": "FD", "Value": [-117.42307591, -105.47935792, -7.82388906]},
        "3950": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3951": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3952": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3953": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3954": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3955": {"vr": "FD", "Value": [-117.42307591, -99.57413598, 19.03459664]},
        "3956": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "3957": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3958": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "3959": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3960": {"vr": "FD", "Value": [-117.42307591, -88.83737107, 67.86821147]},
        "3961": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3962": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3963": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3964": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3965": {"vr": "FD", "Value": [-117.42307591, -104.94251939, -5.38221006]},
        "3966": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "3967": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "3968": {"vr": "FD", "Value": [-117.42307591, -95.27942964, 38.56804248]},
        "3969": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "3970": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3971": {"vr": "FD", "Value": [-117.42307591, -87.22685548, 75.19325419]},
        "3972": {"vr": "FD", "Value": [-117.42307591, -110.3109028, -29.79901723]},
        "3973": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3974": {"vr": "FD", "Value": [-117.42307591, -112.45825645, -39.56573705]},
        "3975": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "3976": {"vr": "FD", "Value": [-117.42307591, -92.05840036, 53.21812602]},
        "3977": {"vr": "FD", "Value": [-117.42307591, -86.69001695, 77.6349351]},
        "3978": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3979": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3980": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "3981": {"vr": "FD", "Value": [-117.42307591, -87.76369401, 72.75157328]},
        "3982": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "3983": {"vr": "FD", "Value": [-117.42307591, -101.72149011, 9.26787348]},
        "3984": {"vr": "FD", "Value": [-117.42307591, -106.01619645, -10.26556997]},
        "3985": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "3986": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3987": {"vr": "FD", "Value": [-117.42307591, -99.03729745, 21.47627755]},
        "3988": {"vr": "FD", "Value": [-117.42307591, -89.91104623, 62.98484965]},
        "3989": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "3990": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "3991": {"vr": "FD", "Value": [-117.42307591, -90.98472329, 58.10148783]},
        "3992": {"vr": "FD", "Value": [-117.42307591, -96.3531067, 33.68468066]},
        "3993": {"vr": "FD", "Value": [-117.42307591, -86.15317842, 80.07661219]},
        "3994": {"vr": "FD", "Value": [-117.42307591, -102.79516622, 4.38451167]},
        "3995": {"vr": "FD", "Value": [-117.42307591, -107.62671109, -17.59061269]},
        "3996": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "3997": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "3998": {"vr": "FD", "Value": [-117.42307591, -109.23722621, -24.91565542]},
        "3999": {"vr": "FD", "Value": [-117.42307591, -93.13207742, 48.3347642]},
        "4000": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "4001": {"vr": "FD", "Value": [-117.42307591, -90.44788476, 60.54316874]},
        "4002": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "4003": {"vr": "FD", "Value": [-117.42307591, -82.93214913, 94.72669764]},
        "4004": {"vr": "FD", "Value": [-117.42307591, -107.08987351, -15.14893178]},
        "4005": {"vr": "FD", "Value": [-117.42307591, -96.88994523, 31.24300023]},
        "4006": {"vr": "FD", "Value": [-117.42307591, -113.53193303, -44.44909887]},
        "4007": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "4008": {"vr": "FD", "Value": [-117.42307591, -101.18465158, 11.70955439]},
        "4009": {"vr": "FD", "Value": [-117.42307591, -110.84774133, -32.24069814]},
        "4010": {"vr": "FD", "Value": [-117.42307591, -85.07950326, 84.95997401]},
        "4011": {"vr": "FD", "Value": [-117.42307591, -88.30053254, 70.30989237]},
        "4012": {"vr": "FD", "Value": [-117.42307591, -89.3742077, 65.42653056]},
        "4013": {"vr": "FD", "Value": [-117.42307591, -92.59523889, 50.77644511]},
        "4014": {"vr": "FD", "Value": [-117.42307591, -109.77406474, -27.35733632]},
        "4015": {"vr": "FD", "Value": [-117.42307591, -83.46898767, 92.28501673]},
        "4016": {"vr": "FD", "Value": [-117.42307591, -93.66891595, 45.8930852]},
        "4017": {"vr": "FD", "Value": [-117.42307591, -98.50046083, 23.9179581]},
        "4018": {"vr": "FD", "Value": [-117.42307591, -100.11097451, 16.59291621]},
        "4019": {"vr": "FD", "Value": [-117.42307591, -103.86884328, -0.49884824]},
    },
    "0021115E": {
        "0": {"vr": "IS", "Value": [36]},
        "1": {"vr": "IS", "Value": [54]},
        "2": {"vr": "IS", "Value": [21]},
        "3": {"vr": "IS", "Value": [10]},
        "4": {"vr": "IS", "Value": [21]},
        "5": {"vr": "IS", "Value": [27]},
        "6": {"vr": "IS", "Value": [5]},
        "7": {"vr": "IS", "Value": [17]},
        "8": {"vr": "IS", "Value": [25]},
        "9": {"vr": "IS", "Value": [44]},
        "10": {"vr": "IS", "Value": [34]},
        "11": {"vr": "IS", "Value": [47]},
        "12": {"vr": "IS", "Value": [46]},
        "13": {"vr": "IS", "Value": [49]},
        "14": {"vr": "IS", "Value": [19]},
        "15": {"vr": "IS", "Value": [52]},
        "16": {"vr": "IS", "Value": [29]},
        "17": {"vr": "IS", "Value": [31]},
        "18": {"vr": "IS", "Value": [12]},
        "19": {"vr": "IS", "Value": [41]},
        "20": {"vr": "IS", "Value": [3]},
        "21": {"vr": "IS", "Value": [6]},
        "22": {"vr": "IS", "Value": [54]},
        "23": {"vr": "IS", "Value": [38]},
        "24": {"vr": "IS", "Value": [23]},
        "25": {"vr": "IS", "Value": [41]},
        "26": {"vr": "IS", "Value": [5]},
        "27": {"vr": "IS", "Value": [8]},
        "28": {"vr": "IS", "Value": [13]},
        "29": {"vr": "IS", "Value": [15]},
        "30": {"vr": "IS", "Value": [31]},
        "31": {"vr": "IS", "Value": [20]},
        "32": {"vr": "IS", "Value": [42]},
        "33": {"vr": "IS", "Value": [37]},
        "34": {"vr": "IS", "Value": [50]},
        "35": {"vr": "IS", "Value": [3]},
        "36": {"vr": "IS", "Value": [40]},
        "37": {"vr": "IS", "Value": [3]},
        "38": {"vr": "IS", "Value": [48]},
        "39": {"vr": "IS", "Value": [31]},
        "40": {"vr": "IS", "Value": [44]},
        "41": {"vr": "IS", "Value": [16]},
        "42": {"vr": "IS", "Value": [29]},
        "43": {"vr": "IS", "Value": [14]},
        "44": {"vr": "IS", "Value": [4]},
        "45": {"vr": "IS", "Value": [54]},
        "46": {"vr": "IS", "Value": [50]},
        "47": {"vr": "IS", "Value": [29]},
        "48": {"vr": "IS", "Value": [49]},
        "49": {"vr": "IS", "Value": [54]},
        "50": {"vr": "IS", "Value": [35]},
        "51": {"vr": "IS", "Value": [31]},
        "52": {"vr": "IS", "Value": [43]},
        "53": {"vr": "IS", "Value": [0]},
        "54": {"vr": "IS", "Value": [40]},
        "55": {"vr": "IS", "Value": [37]},
        "56": {"vr": "IS", "Value": [47]},
        "57": {"vr": "IS", "Value": [35]},
        "58": {"vr": "IS", "Value": [13]},
        "59": {"vr": "IS", "Value": [3]},
        "60": {"vr": "IS", "Value": [48]},
        "61": {"vr": "IS", "Value": [29]},
        "62": {"vr": "IS", "Value": [59]},
        "63": {"vr": "IS", "Value": [48]},
        "64": {"vr": "IS", "Value": [46]},
        "65": {"vr": "IS", "Value": [7]},
        "66": {"vr": "IS", "Value": [16]},
        "67": {"vr": "IS", "Value": [24]},
        "68": {"vr": "IS", "Value": [52]},
        "69": {"vr": "IS", "Value": [24]},
        "70": {"vr": "IS", "Value": [21]},
        "71": {"vr": "IS", "Value": [54]},
        "72": {"vr": "IS", "Value": [41]},
        "73": {"vr": "IS", "Value": [8]},
        "74": {"vr": "IS", "Value": [30]},
        "75": {"vr": "IS", "Value": [0]},
        "76": {"vr": "IS", "Value": [23]},
        "77": {"vr": "IS", "Value": [51]},
        "78": {"vr": "IS", "Value": [23]},
        "79": {"vr": "IS", "Value": [25]},
        "80": {"vr": "IS", "Value": [24]},
        "81": {"vr": "IS", "Value": [24]},
        "82": {"vr": "IS", "Value": [57]},
        "83": {"vr": "IS", "Value": [40]},
        "84": {"vr": "IS", "Value": [52]},
        "85": {"vr": "IS", "Value": [28]},
        "86": {"vr": "IS", "Value": [38]},
        "87": {"vr": "IS", "Value": [55]},
        "88": {"vr": "IS", "Value": [25]},
        "89": {"vr": "IS", "Value": [46]},
        "90": {"vr": "IS", "Value": [29]},
        "91": {"vr": "IS", "Value": [16]},
        "92": {"vr": "IS", "Value": [21]},
        "93": {"vr": "IS", "Value": [9]},
        "94": {"vr": "IS", "Value": [0]},
        "95": {"vr": "IS", "Value": [34]},
        "96": {"vr": "IS", "Value": [50]},
        "97": {"vr": "IS", "Value": [16]},
        "98": {"vr": "IS", "Value": [51]},
        "99": {"vr": "IS", "Value": [0]},
        "100": {"vr": "IS", "Value": [48]},
        "101": {"vr": "IS", "Value": [18]},
        "102": {"vr": "IS", "Value": [17]},
        "103": {"vr": "IS", "Value": [5]},
        "104": {"vr": "IS", "Value": [37]},
        "105": {"vr": "IS", "Value": [21]},
        "106": {"vr": "IS", "Value": [27]},
        "107": {"vr": "IS", "Value": [35]},
        "108": {"vr": "IS", "Value": [55]},
        "109": {"vr": "IS", "Value": [14]},
        "110": {"vr": "IS", "Value": [36]},
        "111": {"vr": "IS", "Value": [22]},
        "112": {"vr": "IS", "Value": [11]},
        "113": {"vr": "IS", "Value": [35]},
        "114": {"vr": "IS", "Value": [22]},
        "115": {"vr": "IS", "Value": [31]},
        "116": {"vr": "IS", "Value": [32]},
        "117": {"vr": "IS", "Value": [59]},
        "118": {"vr": "IS", "Value": [51]},
        "119": {"vr": "IS", "Value": [52]},
        "120": {"vr": "IS", "Value": [54]},
        "121": {"vr": "IS", "Value": [46]},
        "122": {"vr": "IS", "Value": [44]},
        "123": {"vr": "IS", "Value": [31]},
        "124": {"vr": "IS", "Value": [26]},
        "125": {"vr": "IS", "Value": [15]},
        "126": {"vr": "IS", "Value": [48]},
        "127": {"vr": "IS", "Value": [18]},
        "128": {"vr": "IS", "Value": [11]},
        "129": {"vr": "IS", "Value": [26]},
        "130": {"vr": "IS", "Value": [59]},
        "131": {"vr": "IS", "Value": [27]},
        "132": {"vr": "IS", "Value": [15]},
        "133": {"vr": "IS", "Value": [43]},
        "134": {"vr": "IS", "Value": [35]},
        "135": {"vr": "IS", "Value": [36]},
        "136": {"vr": "IS", "Value": [37]},
        "137": {"vr": "IS", "Value": [21]},
        "138": {"vr": "IS", "Value": [36]},
        "139": {"vr": "IS", "Value": [34]},
        "140": {"vr": "IS", "Value": [1]},
        "141": {"vr": "IS", "Value": [34]},
        "142": {"vr": "IS", "Value": [53]},
        "143": {"vr": "IS", "Value": [54]},
        "144": {"vr": "IS", "Value": [19]},
        "145": {"vr": "IS", "Value": [22]},
        "146": {"vr": "IS", "Value": [37]},
        "147": {"vr": "IS", "Value": [4]},
        "148": {"vr": "IS", "Value": [9]},
        "149": {"vr": "IS", "Value": [28]},
        "150": {"vr": "IS", "Value": [40]},
        "151": {"vr": "IS", "Value": [46]},
        "152": {"vr": "IS", "Value": [52]},
        "153": {"vr": "IS", "Value": [10]},
        "154": {"vr": "IS", "Value": [15]},
        "155": {"vr": "IS", "Value": [20]},
        "156": {"vr": "IS", "Value": [35]},
        "157": {"vr": "IS", "Value": [6]},
        "158": {"vr": "IS", "Value": [53]},
        "159": {"vr": "IS", "Value": [30]},
        "160": {"vr": "IS", "Value": [36]},
        "161": {"vr": "IS", "Value": [53]},
        "162": {"vr": "IS", "Value": [58]},
        "163": {"vr": "IS", "Value": [10]},
        "164": {"vr": "IS", "Value": [46]},
        "165": {"vr": "IS", "Value": [11]},
        "166": {"vr": "IS", "Value": [50]},
        "167": {"vr": "IS", "Value": [45]},
        "168": {"vr": "IS", "Value": [34]},
        "169": {"vr": "IS", "Value": [53]},
        "170": {"vr": "IS", "Value": [41]},
        "171": {"vr": "IS", "Value": [0]},
        "172": {"vr": "IS", "Value": [13]},
        "173": {"vr": "IS", "Value": [20]},
        "174": {"vr": "IS", "Value": [41]},
        "175": {"vr": "IS", "Value": [30]},
        "176": {"vr": "IS", "Value": [33]},
        "177": {"vr": "IS", "Value": [1]},
        "178": {"vr": "IS", "Value": [12]},
        "179": {"vr": "IS", "Value": [37]},
        "180": {"vr": "IS", "Value": [35]},
        "181": {"vr": "IS", "Value": [58]},
        "182": {"vr": "IS", "Value": [39]},
        "183": {"vr": "IS", "Value": [44]},
        "184": {"vr": "IS", "Value": [11]},
        "185": {"vr": "IS", "Value": [6]},
        "186": {"vr": "IS", "Value": [17]},
        "187": {"vr": "IS", "Value": [37]},
        "188": {"vr": "IS", "Value": [51]},
        "189": {"vr": "IS", "Value": [59]},
        "190": {"vr": "IS", "Value": [26]},
        "191": {"vr": "IS", "Value": [56]},
        "192": {"vr": "IS", "Value": [0]},
        "193": {"vr": "IS", "Value": [51]},
        "194": {"vr": "IS", "Value": [15]},
        "195": {"vr": "IS", "Value": [12]},
        "196": {"vr": "IS", "Value": [1]},
        "197": {"vr": "IS", "Value": [30]},
        "198": {"vr": "IS", "Value": [35]},
        "199": {"vr": "IS", "Value": [12]},
        "200": {"vr": "IS", "Value": [40]},
        "201": {"vr": "IS", "Value": [17]},
        "202": {"vr": "IS", "Value": [45]},
        "203": {"vr": "IS", "Value": [2]},
        "204": {"vr": "IS", "Value": [19]},
        "205": {"vr": "IS", "Value": [30]},
        "206": {"vr": "IS", "Value": [17]},
        "207": {"vr": "IS", "Value": [7]},
        "208": {"vr": "IS", "Value": [54]},
        "209": {"vr": "IS", "Value": [35]},
        "210": {"vr": "IS", "Value": [24]},
        "211": {"vr": "IS", "Value": [27]},
        "212": {"vr": "IS", "Value": [48]},
        "213": {"vr": "IS", "Value": [5]},
        "214": {"vr": "IS", "Value": [36]},
        "215": {"vr": "IS", "Value": [0]},
        "216": {"vr": "IS", "Value": [19]},
        "217": {"vr": "IS", "Value": [58]},
        "218": {"vr": "IS", "Value": [29]},
        "219": {"vr": "IS", "Value": [56]},
        "220": {"vr": "IS", "Value": [35]},
        "221": {"vr": "IS", "Value": [20]},
        "222": {"vr": "IS", "Value": [46]},
        "223": {"vr": "IS", "Value": [56]},
        "224": {"vr": "IS", "Value": [40]},
        "225": {"vr": "IS", "Value": [37]},
        "226": {"vr": "IS", "Value": [17]},
        "227": {"vr": "IS", "Value": [6]},
        "228": {"vr": "IS", "Value": [36]},
        "229": {"vr": "IS", "Value": [24]},
        "230": {"vr": "IS", "Value": [58]},
        "231": {"vr": "IS", "Value": [38]},
        "232": {"vr": "IS", "Value": [7]},
        "233": {"vr": "IS", "Value": [29]},
        "234": {"vr": "IS", "Value": [59]},
        "235": {"vr": "IS", "Value": [13]},
        "236": {"vr": "IS", "Value": [16]},
        "237": {"vr": "IS", "Value": [52]},
        "238": {"vr": "IS", "Value": [4]},
        "239": {"vr": "IS", "Value": [39]},
        "240": {"vr": "IS", "Value": [45]},
        "241": {"vr": "IS", "Value": [2]},
        "242": {"vr": "IS", "Value": [32]},
        "243": {"vr": "IS", "Value": [45]},
        "244": {"vr": "IS", "Value": [46]},
        "245": {"vr": "IS", "Value": [2]},
        "246": {"vr": "IS", "Value": [47]},
        "247": {"vr": "IS", "Value": [15]},
        "248": {"vr": "IS", "Value": [2]},
        "249": {"vr": "IS", "Value": [16]},
        "250": {"vr": "IS", "Value": [52]},
        "251": {"vr": "IS", "Value": [35]},
        "252": {"vr": "IS", "Value": [43]},
        "253": {"vr": "IS", "Value": [3]},
        "254": {"vr": "IS", "Value": [48]},
        "255": {"vr": "IS", "Value": [56]},
        "256": {"vr": "IS", "Value": [30]},
        "257": {"vr": "IS", "Value": [3]},
        "258": {"vr": "IS", "Value": [19]},
        "259": {"vr": "IS", "Value": [28]},
        "260": {"vr": "IS", "Value": [16]},
        "261": {"vr": "IS", "Value": [24]},
        "262": {"vr": "IS", "Value": [21]},
        "263": {"vr": "IS", "Value": [26]},
        "264": {"vr": "IS", "Value": [17]},
        "265": {"vr": "IS", "Value": [25]},
        "266": {"vr": "IS", "Value": [0]},
        "267": {"vr": "IS", "Value": [0]},
        "268": {"vr": "IS", "Value": [56]},
        "269": {"vr": "IS", "Value": [32]},
        "270": {"vr": "IS", "Value": [54]},
        "271": {"vr": "IS", "Value": [2]},
        "272": {"vr": "IS", "Value": [54]},
        "273": {"vr": "IS", "Value": [4]},
        "274": {"vr": "IS", "Value": [19]},
        "275": {"vr": "IS", "Value": [18]},
        "276": {"vr": "IS", "Value": [48]},
        "277": {"vr": "IS", "Value": [29]},
        "278": {"vr": "IS", "Value": [23]},
        "279": {"vr": "IS", "Value": [26]},
        "280": {"vr": "IS", "Value": [20]},
        "281": {"vr": "IS", "Value": [3]},
        "282": {"vr": "IS", "Value": [20]},
        "283": {"vr": "IS", "Value": [54]},
        "284": {"vr": "IS", "Value": [5]},
        "285": {"vr": "IS", "Value": [22]},
        "286": {"vr": "IS", "Value": [52]},
        "287": {"vr": "IS", "Value": [10]},
        "288": {"vr": "IS", "Value": [16]},
        "289": {"vr": "IS", "Value": [54]},
        "290": {"vr": "IS", "Value": [5]},
        "291": {"vr": "IS", "Value": [24]},
        "292": {"vr": "IS", "Value": [28]},
        "293": {"vr": "IS", "Value": [45]},
        "294": {"vr": "IS", "Value": [58]},
        "295": {"vr": "IS", "Value": [4]},
        "296": {"vr": "IS", "Value": [1]},
        "297": {"vr": "IS", "Value": [9]},
        "298": {"vr": "IS", "Value": [4]},
        "299": {"vr": "IS", "Value": [30]},
        "300": {"vr": "IS", "Value": [31]},
        "301": {"vr": "IS", "Value": [51]},
        "302": {"vr": "IS", "Value": [19]},
        "303": {"vr": "IS", "Value": [0]},
        "304": {"vr": "IS", "Value": [47]},
        "305": {"vr": "IS", "Value": [33]},
        "306": {"vr": "IS", "Value": [48]},
        "307": {"vr": "IS", "Value": [16]},
        "308": {"vr": "IS", "Value": [31]},
        "309": {"vr": "IS", "Value": [22]},
        "310": {"vr": "IS", "Value": [49]},
        "311": {"vr": "IS", "Value": [9]},
        "312": {"vr": "IS", "Value": [22]},
        "313": {"vr": "IS", "Value": [4]},
        "314": {"vr": "IS", "Value": [13]},
        "315": {"vr": "IS", "Value": [42]},
        "316": {"vr": "IS", "Value": [17]},
        "317": {"vr": "IS", "Value": [48]},
        "318": {"vr": "IS", "Value": [55]},
        "319": {"vr": "IS", "Value": [59]},
        "320": {"vr": "IS", "Value": [15]},
        "321": {"vr": "IS", "Value": [6]},
        "322": {"vr": "IS", "Value": [45]},
        "323": {"vr": "IS", "Value": [38]},
        "324": {"vr": "IS", "Value": [41]},
        "325": {"vr": "IS", "Value": [9]},
        "326": {"vr": "IS", "Value": [57]},
        "327": {"vr": "IS", "Value": [22]},
        "328": {"vr": "IS", "Value": [38]},
        "329": {"vr": "IS", "Value": [38]},
        "330": {"vr": "IS", "Value": [26]},
        "331": {"vr": "IS", "Value": [16]},
        "332": {"vr": "IS", "Value": [38]},
        "333": {"vr": "IS", "Value": [28]},
        "334": {"vr": "IS", "Value": [30]},
        "335": {"vr": "IS", "Value": [37]},
        "336": {"vr": "IS", "Value": [49]},
        "337": {"vr": "IS", "Value": [44]},
        "338": {"vr": "IS", "Value": [14]},
        "339": {"vr": "IS", "Value": [44]},
        "340": {"vr": "IS", "Value": [25]},
        "341": {"vr": "IS", "Value": [19]},
        "342": {"vr": "IS", "Value": [52]},
        "343": {"vr": "IS", "Value": [34]},
        "344": {"vr": "IS", "Value": [15]},
        "345": {"vr": "IS", "Value": [21]},
        "346": {"vr": "IS", "Value": [31]},
        "347": {"vr": "IS", "Value": [28]},
        "348": {"vr": "IS", "Value": [33]},
        "349": {"vr": "IS", "Value": [45]},
        "350": {"vr": "IS", "Value": [18]},
        "351": {"vr": "IS", "Value": [26]},
        "352": {"vr": "IS", "Value": [55]},
        "353": {"vr": "IS", "Value": [17]},
        "354": {"vr": "IS", "Value": [23]},
        "355": {"vr": "IS", "Value": [15]},
        "356": {"vr": "IS", "Value": [32]},
        "357": {"vr": "IS", "Value": [36]},
        "358": {"vr": "IS", "Value": [50]},
        "359": {"vr": "IS", "Value": [16]},
        "360": {"vr": "IS", "Value": [9]},
        "361": {"vr": "IS", "Value": [55]},
        "362": {"vr": "IS", "Value": [49]},
        "363": {"vr": "IS", "Value": [56]},
        "364": {"vr": "IS", "Value": [13]},
        "365": {"vr": "IS", "Value": [9]},
        "366": {"vr": "IS", "Value": [37]},
        "367": {"vr": "IS", "Value": [26]},
        "368": {"vr": "IS", "Value": [29]},
        "369": {"vr": "IS", "Value": [33]},
        "370": {"vr": "IS", "Value": [53]},
        "371": {"vr": "IS", "Value": [43]},
        "372": {"vr": "IS", "Value": [46]},
        "373": {"vr": "IS", "Value": [40]},
        "374": {"vr": "IS", "Value": [43]},
        "375": {"vr": "IS", "Value": [11]},
        "376": {"vr": "IS", "Value": [2]},
        "377": {"vr": "IS", "Value": [44]},
        "378": {"vr": "IS", "Value": [43]},
        "379": {"vr": "IS", "Value": [42]},
        "380": {"vr": "IS", "Value": [56]},
        "381": {"vr": "IS", "Value": [57]},
        "382": {"vr": "IS", "Value": [30]},
        "383": {"vr": "IS", "Value": [22]},
        "384": {"vr": "IS", "Value": [37]},
        "385": {"vr": "IS", "Value": [53]},
        "386": {"vr": "IS", "Value": [6]},
        "387": {"vr": "IS", "Value": [33]},
        "388": {"vr": "IS", "Value": [12]},
        "389": {"vr": "IS", "Value": [17]},
        "390": {"vr": "IS", "Value": [53]},
        "391": {"vr": "IS", "Value": [3]},
        "392": {"vr": "IS", "Value": [11]},
        "393": {"vr": "IS", "Value": [53]},
        "394": {"vr": "IS", "Value": [11]},
        "395": {"vr": "IS", "Value": [38]},
        "396": {"vr": "IS", "Value": [0]},
        "397": {"vr": "IS", "Value": [5]},
        "398": {"vr": "IS", "Value": [2]},
        "399": {"vr": "IS", "Value": [32]},
        "400": {"vr": "IS", "Value": [9]},
        "401": {"vr": "IS", "Value": [38]},
        "402": {"vr": "IS", "Value": [32]},
        "403": {"vr": "IS", "Value": [20]},
        "404": {"vr": "IS", "Value": [17]},
        "405": {"vr": "IS", "Value": [22]},
        "406": {"vr": "IS", "Value": [38]},
        "407": {"vr": "IS", "Value": [33]},
        "408": {"vr": "IS", "Value": [28]},
        "409": {"vr": "IS", "Value": [1]},
        "410": {"vr": "IS", "Value": [14]},
        "411": {"vr": "IS", "Value": [47]},
        "412": {"vr": "IS", "Value": [8]},
        "413": {"vr": "IS", "Value": [18]},
        "414": {"vr": "IS", "Value": [20]},
        "415": {"vr": "IS", "Value": [6]},
        "416": {"vr": "IS", "Value": [1]},
        "417": {"vr": "IS", "Value": [2]},
        "418": {"vr": "IS", "Value": [34]},
        "419": {"vr": "IS", "Value": [26]},
        "420": {"vr": "IS", "Value": [28]},
        "421": {"vr": "IS", "Value": [21]},
        "422": {"vr": "IS", "Value": [51]},
        "423": {"vr": "IS", "Value": [6]},
        "424": {"vr": "IS", "Value": [41]},
        "425": {"vr": "IS", "Value": [47]},
        "426": {"vr": "IS", "Value": [27]},
        "427": {"vr": "IS", "Value": [17]},
        "428": {"vr": "IS", "Value": [16]},
        "429": {"vr": "IS", "Value": [8]},
        "430": {"vr": "IS", "Value": [48]},
        "431": {"vr": "IS", "Value": [36]},
        "432": {"vr": "IS", "Value": [53]},
        "433": {"vr": "IS", "Value": [44]},
        "434": {"vr": "IS", "Value": [13]},
        "435": {"vr": "IS", "Value": [6]},
        "436": {"vr": "IS", "Value": [11]},
        "437": {"vr": "IS", "Value": [4]},
        "438": {"vr": "IS", "Value": [55]},
        "439": {"vr": "IS", "Value": [8]},
        "440": {"vr": "IS", "Value": [17]},
        "441": {"vr": "IS", "Value": [27]},
        "442": {"vr": "IS", "Value": [33]},
        "443": {"vr": "IS", "Value": [59]},
        "444": {"vr": "IS", "Value": [14]},
        "445": {"vr": "IS", "Value": [37]},
        "446": {"vr": "IS", "Value": [9]},
        "447": {"vr": "IS", "Value": [14]},
        "448": {"vr": "IS", "Value": [54]},
        "449": {"vr": "IS", "Value": [23]},
        "450": {"vr": "IS", "Value": [26]},
        "451": {"vr": "IS", "Value": [18]},
        "452": {"vr": "IS", "Value": [25]},
        "453": {"vr": "IS", "Value": [36]},
        "454": {"vr": "IS", "Value": [51]},
        "455": {"vr": "IS", "Value": [31]},
        "456": {"vr": "IS", "Value": [28]},
        "457": {"vr": "IS", "Value": [35]},
        "458": {"vr": "IS", "Value": [8]},
        "459": {"vr": "IS", "Value": [8]},
        "460": {"vr": "IS", "Value": [53]},
        "461": {"vr": "IS", "Value": [29]},
        "462": {"vr": "IS", "Value": [33]},
        "463": {"vr": "IS", "Value": [12]},
        "464": {"vr": "IS", "Value": [13]},
        "465": {"vr": "IS", "Value": [9]},
        "466": {"vr": "IS", "Value": [57]},
        "467": {"vr": "IS", "Value": [52]},
        "468": {"vr": "IS", "Value": [28]},
        "469": {"vr": "IS", "Value": [15]},
        "470": {"vr": "IS", "Value": [48]},
        "471": {"vr": "IS", "Value": [50]},
        "472": {"vr": "IS", "Value": [5]},
        "473": {"vr": "IS", "Value": [15]},
        "474": {"vr": "IS", "Value": [2]},
        "475": {"vr": "IS", "Value": [10]},
        "476": {"vr": "IS", "Value": [4]},
        "477": {"vr": "IS", "Value": [44]},
        "478": {"vr": "IS", "Value": [46]},
        "479": {"vr": "IS", "Value": [21]},
        "480": {"vr": "IS", "Value": [17]},
        "481": {"vr": "IS", "Value": [18]},
        "482": {"vr": "IS", "Value": [6]},
        "483": {"vr": "IS", "Value": [0]},
        "484": {"vr": "IS", "Value": [9]},
        "485": {"vr": "IS", "Value": [6]},
        "486": {"vr": "IS", "Value": [39]},
        "487": {"vr": "IS", "Value": [39]},
        "488": {"vr": "IS", "Value": [31]},
        "489": {"vr": "IS", "Value": [51]},
        "490": {"vr": "IS", "Value": [16]},
        "491": {"vr": "IS", "Value": [38]},
        "492": {"vr": "IS", "Value": [30]},
        "493": {"vr": "IS", "Value": [0]},
        "494": {"vr": "IS", "Value": [34]},
        "495": {"vr": "IS", "Value": [8]},
        "496": {"vr": "IS", "Value": [16]},
        "497": {"vr": "IS", "Value": [54]},
        "498": {"vr": "IS", "Value": [32]},
        "499": {"vr": "IS", "Value": [35]},
        "500": {"vr": "IS", "Value": [55]},
        "501": {"vr": "IS", "Value": [46]},
        "502": {"vr": "IS", "Value": [18]},
        "503": {"vr": "IS", "Value": [5]},
        "504": {"vr": "IS", "Value": [43]},
        "505": {"vr": "IS", "Value": [18]},
        "506": {"vr": "IS", "Value": [59]},
        "507": {"vr": "IS", "Value": [12]},
        "508": {"vr": "IS", "Value": [49]},
        "509": {"vr": "IS", "Value": [7]},
        "510": {"vr": "IS", "Value": [9]},
        "511": {"vr": "IS", "Value": [8]},
        "512": {"vr": "IS", "Value": [52]},
        "513": {"vr": "IS", "Value": [18]},
        "514": {"vr": "IS", "Value": [53]},
        "515": {"vr": "IS", "Value": [39]},
        "516": {"vr": "IS", "Value": [17]},
        "517": {"vr": "IS", "Value": [29]},
        "518": {"vr": "IS", "Value": [47]},
        "519": {"vr": "IS", "Value": [8]},
        "520": {"vr": "IS", "Value": [46]},
        "521": {"vr": "IS", "Value": [10]},
        "522": {"vr": "IS", "Value": [24]},
        "523": {"vr": "IS", "Value": [35]},
        "524": {"vr": "IS", "Value": [9]},
        "525": {"vr": "IS", "Value": [3]},
        "526": {"vr": "IS", "Value": [52]},
        "527": {"vr": "IS", "Value": [33]},
        "528": {"vr": "IS", "Value": [44]},
        "529": {"vr": "IS", "Value": [59]},
        "530": {"vr": "IS", "Value": [2]},
        "531": {"vr": "IS", "Value": [48]},
        "532": {"vr": "IS", "Value": [39]},
        "533": {"vr": "IS", "Value": [27]},
        "534": {"vr": "IS", "Value": [35]},
        "535": {"vr": "IS", "Value": [46]},
        "536": {"vr": "IS", "Value": [48]},
        "537": {"vr": "IS", "Value": [57]},
        "538": {"vr": "IS", "Value": [57]},
        "539": {"vr": "IS", "Value": [13]},
        "540": {"vr": "IS", "Value": [6]},
        "541": {"vr": "IS", "Value": [47]},
        "542": {"vr": "IS", "Value": [44]},
        "543": {"vr": "IS", "Value": [54]},
        "544": {"vr": "IS", "Value": [23]},
        "545": {"vr": "IS", "Value": [18]},
        "546": {"vr": "IS", "Value": [59]},
        "547": {"vr": "IS", "Value": [25]},
        "548": {"vr": "IS", "Value": [44]},
        "549": {"vr": "IS", "Value": [27]},
        "550": {"vr": "IS", "Value": [14]},
        "551": {"vr": "IS", "Value": [18]},
        "552": {"vr": "IS", "Value": [4]},
        "553": {"vr": "IS", "Value": [43]},
        "554": {"vr": "IS", "Value": [48]},
        "555": {"vr": "IS", "Value": [31]},
        "556": {"vr": "IS", "Value": [17]},
        "557": {"vr": "IS", "Value": [8]},
        "558": {"vr": "IS", "Value": [17]},
        "559": {"vr": "IS", "Value": [13]},
        "560": {"vr": "IS", "Value": [40]},
        "561": {"vr": "IS", "Value": [34]},
        "562": {"vr": "IS", "Value": [54]},
        "563": {"vr": "IS", "Value": [19]},
        "564": {"vr": "IS", "Value": [46]},
        "565": {"vr": "IS", "Value": [34]},
        "566": {"vr": "IS", "Value": [53]},
        "567": {"vr": "IS", "Value": [42]},
        "568": {"vr": "IS", "Value": [42]},
        "569": {"vr": "IS", "Value": [29]},
        "570": {"vr": "IS", "Value": [1]},
        "571": {"vr": "IS", "Value": [30]},
        "572": {"vr": "IS", "Value": [52]},
        "573": {"vr": "IS", "Value": [30]},
        "574": {"vr": "IS", "Value": [18]},
        "575": {"vr": "IS", "Value": [21]},
        "576": {"vr": "IS", "Value": [59]},
        "577": {"vr": "IS", "Value": [0]},
        "578": {"vr": "IS", "Value": [26]},
        "579": {"vr": "IS", "Value": [7]},
        "580": {"vr": "IS", "Value": [59]},
        "581": {"vr": "IS", "Value": [43]},
        "582": {"vr": "IS", "Value": [31]},
        "583": {"vr": "IS", "Value": [47]},
        "584": {"vr": "IS", "Value": [48]},
        "585": {"vr": "IS", "Value": [8]},
        "586": {"vr": "IS", "Value": [24]},
        "587": {"vr": "IS", "Value": [5]},
        "588": {"vr": "IS", "Value": [53]},
        "589": {"vr": "IS", "Value": [23]},
        "590": {"vr": "IS", "Value": [32]},
        "591": {"vr": "IS", "Value": [49]},
        "592": {"vr": "IS", "Value": [13]},
        "593": {"vr": "IS", "Value": [51]},
        "594": {"vr": "IS", "Value": [35]},
        "595": {"vr": "IS", "Value": [15]},
        "596": {"vr": "IS", "Value": [36]},
        "597": {"vr": "IS", "Value": [33]},
        "598": {"vr": "IS", "Value": [48]},
        "599": {"vr": "IS", "Value": [23]},
        "600": {"vr": "IS", "Value": [40]},
        "601": {"vr": "IS", "Value": [7]},
        "602": {"vr": "IS", "Value": [14]},
        "603": {"vr": "IS", "Value": [13]},
        "604": {"vr": "IS", "Value": [1]},
        "605": {"vr": "IS", "Value": [0]},
        "606": {"vr": "IS", "Value": [9]},
        "607": {"vr": "IS", "Value": [56]},
        "608": {"vr": "IS", "Value": [13]},
        "609": {"vr": "IS", "Value": [35]},
        "610": {"vr": "IS", "Value": [4]},
        "611": {"vr": "IS", "Value": [16]},
        "612": {"vr": "IS", "Value": [2]},
        "613": {"vr": "IS", "Value": [16]},
        "614": {"vr": "IS", "Value": [44]},
        "615": {"vr": "IS", "Value": [58]},
        "616": {"vr": "IS", "Value": [1]},
        "617": {"vr": "IS", "Value": [12]},
        "618": {"vr": "IS", "Value": [56]},
        "619": {"vr": "IS", "Value": [48]},
        "620": {"vr": "IS", "Value": [10]},
        "621": {"vr": "IS", "Value": [52]},
        "622": {"vr": "IS", "Value": [4]},
        "623": {"vr": "IS", "Value": [58]},
        "624": {"vr": "IS", "Value": [27]},
        "625": {"vr": "IS", "Value": [40]},
        "626": {"vr": "IS", "Value": [3]},
        "627": {"vr": "IS", "Value": [43]},
        "628": {"vr": "IS", "Value": [7]},
        "629": {"vr": "IS", "Value": [27]},
        "630": {"vr": "IS", "Value": [45]},
        "631": {"vr": "IS", "Value": [2]},
        "632": {"vr": "IS", "Value": [0]},
        "633": {"vr": "IS", "Value": [32]},
        "634": {"vr": "IS", "Value": [9]},
        "635": {"vr": "IS", "Value": [57]},
        "636": {"vr": "IS", "Value": [58]},
        "637": {"vr": "IS", "Value": [23]},
        "638": {"vr": "IS", "Value": [9]},
        "639": {"vr": "IS", "Value": [31]},
        "640": {"vr": "IS", "Value": [48]},
        "641": {"vr": "IS", "Value": [29]},
        "642": {"vr": "IS", "Value": [39]},
        "643": {"vr": "IS", "Value": [3]},
        "644": {"vr": "IS", "Value": [2]},
        "645": {"vr": "IS", "Value": [40]},
        "646": {"vr": "IS", "Value": [58]},
        "647": {"vr": "IS", "Value": [23]},
        "648": {"vr": "IS", "Value": [50]},
        "649": {"vr": "IS", "Value": [56]},
        "650": {"vr": "IS", "Value": [51]},
        "651": {"vr": "IS", "Value": [3]},
        "652": {"vr": "IS", "Value": [27]},
        "653": {"vr": "IS", "Value": [5]},
        "654": {"vr": "IS", "Value": [40]},
        "655": {"vr": "IS", "Value": [33]},
        "656": {"vr": "IS", "Value": [12]},
        "657": {"vr": "IS", "Value": [12]},
        "658": {"vr": "IS", "Value": [29]},
        "659": {"vr": "IS", "Value": [32]},
        "660": {"vr": "IS", "Value": [17]},
        "661": {"vr": "IS", "Value": [21]},
        "662": {"vr": "IS", "Value": [28]},
        "663": {"vr": "IS", "Value": [58]},
        "664": {"vr": "IS", "Value": [21]},
        "665": {"vr": "IS", "Value": [11]},
        "666": {"vr": "IS", "Value": [10]},
        "667": {"vr": "IS", "Value": [4]},
        "668": {"vr": "IS", "Value": [43]},
        "669": {"vr": "IS", "Value": [13]},
        "670": {"vr": "IS", "Value": [42]},
        "671": {"vr": "IS", "Value": [57]},
        "672": {"vr": "IS", "Value": [2]},
        "673": {"vr": "IS", "Value": [8]},
        "674": {"vr": "IS", "Value": [22]},
        "675": {"vr": "IS", "Value": [1]},
        "676": {"vr": "IS", "Value": [29]},
        "677": {"vr": "IS", "Value": [16]},
        "678": {"vr": "IS", "Value": [42]},
        "679": {"vr": "IS", "Value": [35]},
        "680": {"vr": "IS", "Value": [8]},
        "681": {"vr": "IS", "Value": [49]},
        "682": {"vr": "IS", "Value": [11]},
        "683": {"vr": "IS", "Value": [58]},
        "684": {"vr": "IS", "Value": [55]},
        "685": {"vr": "IS", "Value": [11]},
        "686": {"vr": "IS", "Value": [42]},
        "687": {"vr": "IS", "Value": [2]},
        "688": {"vr": "IS", "Value": [14]},
        "689": {"vr": "IS", "Value": [12]},
        "690": {"vr": "IS", "Value": [9]},
        "691": {"vr": "IS", "Value": [19]},
        "692": {"vr": "IS", "Value": [5]},
        "693": {"vr": "IS", "Value": [8]},
        "694": {"vr": "IS", "Value": [40]},
        "695": {"vr": "IS", "Value": [48]},
        "696": {"vr": "IS", "Value": [32]},
        "697": {"vr": "IS", "Value": [2]},
        "698": {"vr": "IS", "Value": [7]},
        "699": {"vr": "IS", "Value": [52]},
        "700": {"vr": "IS", "Value": [55]},
        "701": {"vr": "IS", "Value": [42]},
        "702": {"vr": "IS", "Value": [29]},
        "703": {"vr": "IS", "Value": [34]},
        "704": {"vr": "IS", "Value": [55]},
        "705": {"vr": "IS", "Value": [30]},
        "706": {"vr": "IS", "Value": [7]},
        "707": {"vr": "IS", "Value": [28]},
        "708": {"vr": "IS", "Value": [4]},
        "709": {"vr": "IS", "Value": [4]},
        "710": {"vr": "IS", "Value": [38]},
        "711": {"vr": "IS", "Value": [42]},
        "712": {"vr": "IS", "Value": [49]},
        "713": {"vr": "IS", "Value": [25]},
        "714": {"vr": "IS", "Value": [33]},
        "715": {"vr": "IS", "Value": [27]},
        "716": {"vr": "IS", "Value": [35]},
        "717": {"vr": "IS", "Value": [57]},
        "718": {"vr": "IS", "Value": [8]},
        "719": {"vr": "IS", "Value": [14]},
        "720": {"vr": "IS", "Value": [42]},
        "721": {"vr": "IS", "Value": [52]},
        "722": {"vr": "IS", "Value": [1]},
        "723": {"vr": "IS", "Value": [54]},
        "724": {"vr": "IS", "Value": [34]},
        "725": {"vr": "IS", "Value": [26]},
        "726": {"vr": "IS", "Value": [35]},
        "727": {"vr": "IS", "Value": [33]},
        "728": {"vr": "IS", "Value": [37]},
        "729": {"vr": "IS", "Value": [43]},
        "730": {"vr": "IS", "Value": [33]},
        "731": {"vr": "IS", "Value": [31]},
        "732": {"vr": "IS", "Value": [33]},
        "733": {"vr": "IS", "Value": [55]},
        "734": {"vr": "IS", "Value": [6]},
        "735": {"vr": "IS", "Value": [46]},
        "736": {"vr": "IS", "Value": [37]},
        "737": {"vr": "IS", "Value": [12]},
        "738": {"vr": "IS", "Value": [33]},
        "739": {"vr": "IS", "Value": [3]},
        "740": {"vr": "IS", "Value": [34]},
        "741": {"vr": "IS", "Value": [19]},
        "742": {"vr": "IS", "Value": [42]},
        "743": {"vr": "IS", "Value": [22]},
        "744": {"vr": "IS", "Value": [28]},
        "745": {"vr": "IS", "Value": [21]},
        "746": {"vr": "IS", "Value": [12]},
        "747": {"vr": "IS", "Value": [3]},
        "748": {"vr": "IS", "Value": [18]},
        "749": {"vr": "IS", "Value": [15]},
        "750": {"vr": "IS", "Value": [13]},
        "751": {"vr": "IS", "Value": [24]},
        "752": {"vr": "IS", "Value": [52]},
        "753": {"vr": "IS", "Value": [41]},
        "754": {"vr": "IS", "Value": [4]},
        "755": {"vr": "IS", "Value": [9]},
        "756": {"vr": "IS", "Value": [50]},
        "757": {"vr": "IS", "Value": [6]},
        "758": {"vr": "IS", "Value": [15]},
        "759": {"vr": "IS", "Value": [31]},
        "760": {"vr": "IS", "Value": [16]},
        "761": {"vr": "IS", "Value": [56]},
        "762": {"vr": "IS", "Value": [38]},
        "763": {"vr": "IS", "Value": [20]},
        "764": {"vr": "IS", "Value": [21]},
        "765": {"vr": "IS", "Value": [42]},
        "766": {"vr": "IS", "Value": [51]},
        "767": {"vr": "IS", "Value": [27]},
        "768": {"vr": "IS", "Value": [6]},
        "769": {"vr": "IS", "Value": [55]},
        "770": {"vr": "IS", "Value": [28]},
        "771": {"vr": "IS", "Value": [20]},
        "772": {"vr": "IS", "Value": [11]},
        "773": {"vr": "IS", "Value": [33]},
        "774": {"vr": "IS", "Value": [12]},
        "775": {"vr": "IS", "Value": [1]},
        "776": {"vr": "IS", "Value": [10]},
        "777": {"vr": "IS", "Value": [47]},
        "778": {"vr": "IS", "Value": [59]},
        "779": {"vr": "IS", "Value": [42]},
        "780": {"vr": "IS", "Value": [51]},
        "781": {"vr": "IS", "Value": [22]},
        "782": {"vr": "IS", "Value": [8]},
        "783": {"vr": "IS", "Value": [49]},
        "784": {"vr": "IS", "Value": [36]},
        "785": {"vr": "IS", "Value": [40]},
        "786": {"vr": "IS", "Value": [13]},
        "787": {"vr": "IS", "Value": [59]},
        "788": {"vr": "IS", "Value": [45]},
        "789": {"vr": "IS", "Value": [48]},
        "790": {"vr": "IS", "Value": [55]},
        "791": {"vr": "IS", "Value": [16]},
        "792": {"vr": "IS", "Value": [32]},
        "793": {"vr": "IS", "Value": [17]},
        "794": {"vr": "IS", "Value": [40]},
        "795": {"vr": "IS", "Value": [26]},
        "796": {"vr": "IS", "Value": [30]},
        "797": {"vr": "IS", "Value": [39]},
        "798": {"vr": "IS", "Value": [24]},
        "799": {"vr": "IS", "Value": [0]},
        "800": {"vr": "IS", "Value": [7]},
        "801": {"vr": "IS", "Value": [5]},
        "802": {"vr": "IS", "Value": [6]},
        "803": {"vr": "IS", "Value": [27]},
        "804": {"vr": "IS", "Value": [20]},
        "805": {"vr": "IS", "Value": [32]},
        "806": {"vr": "IS", "Value": [59]},
        "807": {"vr": "IS", "Value": [27]},
        "808": {"vr": "IS", "Value": [14]},
        "809": {"vr": "IS", "Value": [12]},
        "810": {"vr": "IS", "Value": [36]},
        "811": {"vr": "IS", "Value": [25]},
        "812": {"vr": "IS", "Value": [59]},
        "813": {"vr": "IS", "Value": [8]},
        "814": {"vr": "IS", "Value": [13]},
        "815": {"vr": "IS", "Value": [28]},
        "816": {"vr": "IS", "Value": [38]},
        "817": {"vr": "IS", "Value": [30]},
        "818": {"vr": "IS", "Value": [46]},
        "819": {"vr": "IS", "Value": [55]},
        "820": {"vr": "IS", "Value": [23]},
        "821": {"vr": "IS", "Value": [50]},
        "822": {"vr": "IS", "Value": [22]},
        "823": {"vr": "IS", "Value": [50]},
        "824": {"vr": "IS", "Value": [23]},
        "825": {"vr": "IS", "Value": [23]},
        "826": {"vr": "IS", "Value": [57]},
        "827": {"vr": "IS", "Value": [41]},
        "828": {"vr": "IS", "Value": [19]},
        "829": {"vr": "IS", "Value": [29]},
        "830": {"vr": "IS", "Value": [55]},
        "831": {"vr": "IS", "Value": [29]},
        "832": {"vr": "IS", "Value": [11]},
        "833": {"vr": "IS", "Value": [2]},
        "834": {"vr": "IS", "Value": [4]},
        "835": {"vr": "IS", "Value": [31]},
        "836": {"vr": "IS", "Value": [46]},
        "837": {"vr": "IS", "Value": [22]},
        "838": {"vr": "IS", "Value": [35]},
        "839": {"vr": "IS", "Value": [12]},
        "840": {"vr": "IS", "Value": [8]},
        "841": {"vr": "IS", "Value": [3]},
        "842": {"vr": "IS", "Value": [31]},
        "843": {"vr": "IS", "Value": [36]},
        "844": {"vr": "IS", "Value": [39]},
        "845": {"vr": "IS", "Value": [51]},
        "846": {"vr": "IS", "Value": [2]},
        "847": {"vr": "IS", "Value": [12]},
        "848": {"vr": "IS", "Value": [57]},
        "849": {"vr": "IS", "Value": [44]},
        "850": {"vr": "IS", "Value": [1]},
        "851": {"vr": "IS", "Value": [6]},
        "852": {"vr": "IS", "Value": [47]},
        "853": {"vr": "IS", "Value": [20]},
        "854": {"vr": "IS", "Value": [32]},
        "855": {"vr": "IS", "Value": [27]},
        "856": {"vr": "IS", "Value": [16]},
        "857": {"vr": "IS", "Value": [44]},
        "858": {"vr": "IS", "Value": [0]},
        "859": {"vr": "IS", "Value": [47]},
        "860": {"vr": "IS", "Value": [51]},
        "861": {"vr": "IS", "Value": [7]},
        "862": {"vr": "IS", "Value": [22]},
        "863": {"vr": "IS", "Value": [30]},
        "864": {"vr": "IS", "Value": [1]},
        "865": {"vr": "IS", "Value": [51]},
        "866": {"vr": "IS", "Value": [18]},
        "867": {"vr": "IS", "Value": [14]},
        "868": {"vr": "IS", "Value": [21]},
        "869": {"vr": "IS", "Value": [51]},
        "870": {"vr": "IS", "Value": [57]},
        "871": {"vr": "IS", "Value": [48]},
        "872": {"vr": "IS", "Value": [24]},
        "873": {"vr": "IS", "Value": [28]},
        "874": {"vr": "IS", "Value": [16]},
        "875": {"vr": "IS", "Value": [46]},
        "876": {"vr": "IS", "Value": [50]},
        "877": {"vr": "IS", "Value": [14]},
        "878": {"vr": "IS", "Value": [31]},
        "879": {"vr": "IS", "Value": [25]},
        "880": {"vr": "IS", "Value": [44]},
        "881": {"vr": "IS", "Value": [28]},
        "882": {"vr": "IS", "Value": [41]},
        "883": {"vr": "IS", "Value": [7]},
        "884": {"vr": "IS", "Value": [14]},
        "885": {"vr": "IS", "Value": [48]},
        "886": {"vr": "IS", "Value": [44]},
        "887": {"vr": "IS", "Value": [22]},
        "888": {"vr": "IS", "Value": [49]},
        "889": {"vr": "IS", "Value": [5]},
        "890": {"vr": "IS", "Value": [17]},
        "891": {"vr": "IS", "Value": [58]},
        "892": {"vr": "IS", "Value": [26]},
        "893": {"vr": "IS", "Value": [26]},
        "894": {"vr": "IS", "Value": [35]},
        "895": {"vr": "IS", "Value": [7]},
        "896": {"vr": "IS", "Value": [54]},
        "897": {"vr": "IS", "Value": [13]},
        "898": {"vr": "IS", "Value": [44]},
        "899": {"vr": "IS", "Value": [27]},
        "900": {"vr": "IS", "Value": [29]},
        "901": {"vr": "IS", "Value": [38]},
        "902": {"vr": "IS", "Value": [43]},
        "903": {"vr": "IS", "Value": [38]},
        "904": {"vr": "IS", "Value": [45]},
        "905": {"vr": "IS", "Value": [26]},
        "906": {"vr": "IS", "Value": [19]},
        "907": {"vr": "IS", "Value": [14]},
        "908": {"vr": "IS", "Value": [25]},
        "909": {"vr": "IS", "Value": [12]},
        "910": {"vr": "IS", "Value": [55]},
        "911": {"vr": "IS", "Value": [29]},
        "912": {"vr": "IS", "Value": [48]},
        "913": {"vr": "IS", "Value": [58]},
        "914": {"vr": "IS", "Value": [39]},
        "915": {"vr": "IS", "Value": [10]},
        "916": {"vr": "IS", "Value": [59]},
        "917": {"vr": "IS", "Value": [1]},
        "918": {"vr": "IS", "Value": [38]},
        "919": {"vr": "IS", "Value": [2]},
        "920": {"vr": "IS", "Value": [57]},
        "921": {"vr": "IS", "Value": [27]},
        "922": {"vr": "IS", "Value": [28]},
        "923": {"vr": "IS", "Value": [56]},
        "924": {"vr": "IS", "Value": [5]},
        "925": {"vr": "IS", "Value": [33]},
        "926": {"vr": "IS", "Value": [17]},
        "927": {"vr": "IS", "Value": [55]},
        "928": {"vr": "IS", "Value": [3]},
        "929": {"vr": "IS", "Value": [2]},
        "930": {"vr": "IS", "Value": [32]},
        "931": {"vr": "IS", "Value": [52]},
        "932": {"vr": "IS", "Value": [53]},
        "933": {"vr": "IS", "Value": [29]},
        "934": {"vr": "IS", "Value": [41]},
        "935": {"vr": "IS", "Value": [46]},
        "936": {"vr": "IS", "Value": [28]},
        "937": {"vr": "IS", "Value": [30]},
        "938": {"vr": "IS", "Value": [58]},
        "939": {"vr": "IS", "Value": [16]},
        "940": {"vr": "IS", "Value": [30]},
        "941": {"vr": "IS", "Value": [55]},
        "942": {"vr": "IS", "Value": [22]},
        "943": {"vr": "IS", "Value": [32]},
        "944": {"vr": "IS", "Value": [17]},
        "945": {"vr": "IS", "Value": [42]},
        "946": {"vr": "IS", "Value": [41]},
        "947": {"vr": "IS", "Value": [21]},
        "948": {"vr": "IS", "Value": [26]},
        "949": {"vr": "IS", "Value": [19]},
        "950": {"vr": "IS", "Value": [35]},
        "951": {"vr": "IS", "Value": [13]},
        "952": {"vr": "IS", "Value": [21]},
        "953": {"vr": "IS", "Value": [24]},
        "954": {"vr": "IS", "Value": [54]},
        "955": {"vr": "IS", "Value": [13]},
        "956": {"vr": "IS", "Value": [40]},
        "957": {"vr": "IS", "Value": [28]},
        "958": {"vr": "IS", "Value": [7]},
        "959": {"vr": "IS", "Value": [3]},
        "960": {"vr": "IS", "Value": [51]},
        "961": {"vr": "IS", "Value": [41]},
        "962": {"vr": "IS", "Value": [46]},
        "963": {"vr": "IS", "Value": [34]},
        "964": {"vr": "IS", "Value": [26]},
        "965": {"vr": "IS", "Value": [33]},
        "966": {"vr": "IS", "Value": [58]},
        "967": {"vr": "IS", "Value": [3]},
        "968": {"vr": "IS", "Value": [10]},
        "969": {"vr": "IS", "Value": [52]},
        "970": {"vr": "IS", "Value": [29]},
        "971": {"vr": "IS", "Value": [30]},
        "972": {"vr": "IS", "Value": [46]},
        "973": {"vr": "IS", "Value": [53]},
        "974": {"vr": "IS", "Value": [52]},
        "975": {"vr": "IS", "Value": [13]},
        "976": {"vr": "IS", "Value": [37]},
        "977": {"vr": "IS", "Value": [28]},
        "978": {"vr": "IS", "Value": [18]},
        "979": {"vr": "IS", "Value": [25]},
        "980": {"vr": "IS", "Value": [7]},
        "981": {"vr": "IS", "Value": [52]},
        "982": {"vr": "IS", "Value": [14]},
        "983": {"vr": "IS", "Value": [38]},
        "984": {"vr": "IS", "Value": [10]},
        "985": {"vr": "IS", "Value": [26]},
        "986": {"vr": "IS", "Value": [8]},
        "987": {"vr": "IS", "Value": [35]},
        "988": {"vr": "IS", "Value": [56]},
        "989": {"vr": "IS", "Value": [1]},
        "990": {"vr": "IS", "Value": [52]},
        "991": {"vr": "IS", "Value": [34]},
        "992": {"vr": "IS", "Value": [22]},
        "993": {"vr": "IS", "Value": [30]},
        "994": {"vr": "IS", "Value": [11]},
        "995": {"vr": "IS", "Value": [36]},
        "996": {"vr": "IS", "Value": [3]},
        "997": {"vr": "IS", "Value": [57]},
        "998": {"vr": "IS", "Value": [47]},
        "999": {"vr": "IS", "Value": [22]},
        "1000": {"vr": "IS", "Value": [9]},
        "1001": {"vr": "IS", "Value": [32]},
        "1002": {"vr": "IS", "Value": [45]},
        "1003": {"vr": "IS", "Value": [37]},
        "1004": {"vr": "IS", "Value": [50]},
        "1005": {"vr": "IS", "Value": [8]},
        "1006": {"vr": "IS", "Value": [9]},
        "1007": {"vr": "IS", "Value": [17]},
        "1008": {"vr": "IS", "Value": [47]},
        "1009": {"vr": "IS", "Value": [50]},
        "1010": {"vr": "IS", "Value": [43]},
        "1011": {"vr": "IS", "Value": [49]},
        "1012": {"vr": "IS", "Value": [13]},
        "1013": {"vr": "IS", "Value": [13]},
        "1014": {"vr": "IS", "Value": [35]},
        "1015": {"vr": "IS", "Value": [30]},
        "1016": {"vr": "IS", "Value": [28]},
        "1017": {"vr": "IS", "Value": [9]},
        "1018": {"vr": "IS", "Value": [55]},
        "1019": {"vr": "IS", "Value": [24]},
        "1020": {"vr": "IS", "Value": [43]},
        "1021": {"vr": "IS", "Value": [22]},
        "1022": {"vr": "IS", "Value": [9]},
        "1023": {"vr": "IS", "Value": [5]},
        "1024": {"vr": "IS", "Value": [47]},
        "1025": {"vr": "IS", "Value": [39]},
        "1026": {"vr": "IS", "Value": [21]},
        "1027": {"vr": "IS", "Value": [59]},
        "1028": {"vr": "IS", "Value": [12]},
        "1029": {"vr": "IS", "Value": [53]},
        "1030": {"vr": "IS", "Value": [42]},
        "1031": {"vr": "IS", "Value": [30]},
        "1032": {"vr": "IS", "Value": [23]},
        "1033": {"vr": "IS", "Value": [26]},
        "1034": {"vr": "IS", "Value": [32]},
        "1035": {"vr": "IS", "Value": [14]},
        "1036": {"vr": "IS", "Value": [59]},
        "1037": {"vr": "IS", "Value": [12]},
        "1038": {"vr": "IS", "Value": [54]},
        "1039": {"vr": "IS", "Value": [36]},
        "1040": {"vr": "IS", "Value": [21]},
        "1041": {"vr": "IS", "Value": [39]},
        "1042": {"vr": "IS", "Value": [49]},
        "1043": {"vr": "IS", "Value": [15]},
        "1044": {"vr": "IS", "Value": [59]},
        "1045": {"vr": "IS", "Value": [39]},
        "1046": {"vr": "IS", "Value": [56]},
        "1047": {"vr": "IS", "Value": [15]},
        "1048": {"vr": "IS", "Value": [59]},
        "1049": {"vr": "IS", "Value": [43]},
        "1050": {"vr": "IS", "Value": [59]},
        "1051": {"vr": "IS", "Value": [52]},
        "1052": {"vr": "IS", "Value": [26]},
        "1053": {"vr": "IS", "Value": [1]},
        "1054": {"vr": "IS", "Value": [36]},
        "1055": {"vr": "IS", "Value": [21]},
        "1056": {"vr": "IS", "Value": [24]},
        "1057": {"vr": "IS", "Value": [1]},
        "1058": {"vr": "IS", "Value": [59]},
        "1059": {"vr": "IS", "Value": [15]},
        "1060": {"vr": "IS", "Value": [28]},
        "1061": {"vr": "IS", "Value": [7]},
        "1062": {"vr": "IS", "Value": [21]},
        "1063": {"vr": "IS", "Value": [2]},
        "1064": {"vr": "IS", "Value": [28]},
        "1065": {"vr": "IS", "Value": [38]},
        "1066": {"vr": "IS", "Value": [17]},
        "1067": {"vr": "IS", "Value": [9]},
        "1068": {"vr": "IS", "Value": [12]},
        "1069": {"vr": "IS", "Value": [24]},
        "1070": {"vr": "IS", "Value": [7]},
        "1071": {"vr": "IS", "Value": [45]},
        "1072": {"vr": "IS", "Value": [10]},
        "1073": {"vr": "IS", "Value": [55]},
        "1074": {"vr": "IS", "Value": [44]},
        "1075": {"vr": "IS", "Value": [17]},
        "1076": {"vr": "IS", "Value": [5]},
        "1077": {"vr": "IS", "Value": [3]},
        "1078": {"vr": "IS", "Value": [56]},
        "1079": {"vr": "IS", "Value": [58]},
        "1080": {"vr": "IS", "Value": [2]},
        "1081": {"vr": "IS", "Value": [31]},
        "1082": {"vr": "IS", "Value": [51]},
        "1083": {"vr": "IS", "Value": [22]},
        "1084": {"vr": "IS", "Value": [0]},
        "1085": {"vr": "IS", "Value": [14]},
        "1086": {"vr": "IS", "Value": [7]},
        "1087": {"vr": "IS", "Value": [33]},
        "1088": {"vr": "IS", "Value": [46]},
        "1089": {"vr": "IS", "Value": [46]},
        "1090": {"vr": "IS", "Value": [21]},
        "1091": {"vr": "IS", "Value": [50]},
        "1092": {"vr": "IS", "Value": [47]},
        "1093": {"vr": "IS", "Value": [3]},
        "1094": {"vr": "IS", "Value": [42]},
        "1095": {"vr": "IS", "Value": [16]},
        "1096": {"vr": "IS", "Value": [11]},
        "1097": {"vr": "IS", "Value": [26]},
        "1098": {"vr": "IS", "Value": [54]},
        "1099": {"vr": "IS", "Value": [1]},
        "1100": {"vr": "IS", "Value": [18]},
        "1101": {"vr": "IS", "Value": [2]},
        "1102": {"vr": "IS", "Value": [10]},
        "1103": {"vr": "IS", "Value": [23]},
        "1104": {"vr": "IS", "Value": [24]},
        "1105": {"vr": "IS", "Value": [19]},
        "1106": {"vr": "IS", "Value": [44]},
        "1107": {"vr": "IS", "Value": [35]},
        "1108": {"vr": "IS", "Value": [9]},
        "1109": {"vr": "IS", "Value": [21]},
        "1110": {"vr": "IS", "Value": [1]},
        "1111": {"vr": "IS", "Value": [47]},
        "1112": {"vr": "IS", "Value": [8]},
        "1113": {"vr": "IS", "Value": [50]},
        "1114": {"vr": "IS", "Value": [42]},
        "1115": {"vr": "IS", "Value": [3]},
        "1116": {"vr": "IS", "Value": [34]},
        "1117": {"vr": "IS", "Value": [16]},
        "1118": {"vr": "IS", "Value": [31]},
        "1119": {"vr": "IS", "Value": [44]},
        "1120": {"vr": "IS", "Value": [6]},
        "1121": {"vr": "IS", "Value": [58]},
        "1122": {"vr": "IS", "Value": [50]},
        "1123": {"vr": "IS", "Value": [9]},
        "1124": {"vr": "IS", "Value": [52]},
        "1125": {"vr": "IS", "Value": [18]},
        "1126": {"vr": "IS", "Value": [24]},
        "1127": {"vr": "IS", "Value": [6]},
        "1128": {"vr": "IS", "Value": [23]},
        "1129": {"vr": "IS", "Value": [21]},
        "1130": {"vr": "IS", "Value": [23]},
        "1131": {"vr": "IS", "Value": [50]},
        "1132": {"vr": "IS", "Value": [22]},
        "1133": {"vr": "IS", "Value": [49]},
        "1134": {"vr": "IS", "Value": [1]},
        "1135": {"vr": "IS", "Value": [13]},
        "1136": {"vr": "IS", "Value": [12]},
        "1137": {"vr": "IS", "Value": [59]},
        "1138": {"vr": "IS", "Value": [16]},
        "1139": {"vr": "IS", "Value": [41]},
        "1140": {"vr": "IS", "Value": [44]},
        "1141": {"vr": "IS", "Value": [44]},
        "1142": {"vr": "IS", "Value": [48]},
        "1143": {"vr": "IS", "Value": [12]},
        "1144": {"vr": "IS", "Value": [7]},
        "1145": {"vr": "IS", "Value": [32]},
        "1146": {"vr": "IS", "Value": [10]},
        "1147": {"vr": "IS", "Value": [14]},
        "1148": {"vr": "IS", "Value": [30]},
        "1149": {"vr": "IS", "Value": [37]},
        "1150": {"vr": "IS", "Value": [57]},
        "1151": {"vr": "IS", "Value": [1]},
        "1152": {"vr": "IS", "Value": [44]},
        "1153": {"vr": "IS", "Value": [24]},
        "1154": {"vr": "IS", "Value": [30]},
        "1155": {"vr": "IS", "Value": [17]},
        "1156": {"vr": "IS", "Value": [14]},
        "1157": {"vr": "IS", "Value": [22]},
        "1158": {"vr": "IS", "Value": [15]},
        "1159": {"vr": "IS", "Value": [39]},
        "1160": {"vr": "IS", "Value": [16]},
        "1161": {"vr": "IS", "Value": [31]},
        "1162": {"vr": "IS", "Value": [0]},
        "1163": {"vr": "IS", "Value": [52]},
        "1164": {"vr": "IS", "Value": [53]},
        "1165": {"vr": "IS", "Value": [24]},
        "1166": {"vr": "IS", "Value": [32]},
        "1167": {"vr": "IS", "Value": [47]},
        "1168": {"vr": "IS", "Value": [52]},
        "1169": {"vr": "IS", "Value": [10]},
        "1170": {"vr": "IS", "Value": [51]},
        "1171": {"vr": "IS", "Value": [6]},
        "1172": {"vr": "IS", "Value": [39]},
        "1173": {"vr": "IS", "Value": [31]},
        "1174": {"vr": "IS", "Value": [12]},
        "1175": {"vr": "IS", "Value": [7]},
        "1176": {"vr": "IS", "Value": [33]},
        "1177": {"vr": "IS", "Value": [49]},
        "1178": {"vr": "IS", "Value": [52]},
        "1179": {"vr": "IS", "Value": [35]},
        "1180": {"vr": "IS", "Value": [54]},
        "1181": {"vr": "IS", "Value": [56]},
        "1182": {"vr": "IS", "Value": [53]},
        "1183": {"vr": "IS", "Value": [28]},
        "1184": {"vr": "IS", "Value": [43]},
        "1185": {"vr": "IS", "Value": [49]},
        "1186": {"vr": "IS", "Value": [7]},
        "1187": {"vr": "IS", "Value": [48]},
        "1188": {"vr": "IS", "Value": [26]},
        "1189": {"vr": "IS", "Value": [27]},
        "1190": {"vr": "IS", "Value": [6]},
        "1191": {"vr": "IS", "Value": [24]},
        "1192": {"vr": "IS", "Value": [45]},
        "1193": {"vr": "IS", "Value": [4]},
        "1194": {"vr": "IS", "Value": [10]},
        "1195": {"vr": "IS", "Value": [25]},
        "1196": {"vr": "IS", "Value": [50]},
        "1197": {"vr": "IS", "Value": [40]},
        "1198": {"vr": "IS", "Value": [5]},
        "1199": {"vr": "IS", "Value": [31]},
        "1200": {"vr": "IS", "Value": [25]},
        "1201": {"vr": "IS", "Value": [55]},
        "1202": {"vr": "IS", "Value": [57]},
        "1203": {"vr": "IS", "Value": [8]},
        "1204": {"vr": "IS", "Value": [28]},
        "1205": {"vr": "IS", "Value": [6]},
        "1206": {"vr": "IS", "Value": [28]},
        "1207": {"vr": "IS", "Value": [56]},
        "1208": {"vr": "IS", "Value": [45]},
        "1209": {"vr": "IS", "Value": [55]},
        "1210": {"vr": "IS", "Value": [14]},
        "1211": {"vr": "IS", "Value": [21]},
        "1212": {"vr": "IS", "Value": [42]},
        "1213": {"vr": "IS", "Value": [34]},
        "1214": {"vr": "IS", "Value": [52]},
        "1215": {"vr": "IS", "Value": [24]},
        "1216": {"vr": "IS", "Value": [57]},
        "1217": {"vr": "IS", "Value": [4]},
        "1218": {"vr": "IS", "Value": [1]},
        "1219": {"vr": "IS", "Value": [31]},
        "1220": {"vr": "IS", "Value": [34]},
        "1221": {"vr": "IS", "Value": [27]},
        "1222": {"vr": "IS", "Value": [14]},
        "1223": {"vr": "IS", "Value": [0]},
        "1224": {"vr": "IS", "Value": [46]},
        "1225": {"vr": "IS", "Value": [23]},
        "1226": {"vr": "IS", "Value": [11]},
        "1227": {"vr": "IS", "Value": [4]},
        "1228": {"vr": "IS", "Value": [9]},
        "1229": {"vr": "IS", "Value": [6]},
        "1230": {"vr": "IS", "Value": [28]},
        "1231": {"vr": "IS", "Value": [1]},
        "1232": {"vr": "IS", "Value": [51]},
        "1233": {"vr": "IS", "Value": [30]},
        "1234": {"vr": "IS", "Value": [27]},
        "1235": {"vr": "IS", "Value": [43]},
        "1236": {"vr": "IS", "Value": [48]},
        "1237": {"vr": "IS", "Value": [9]},
        "1238": {"vr": "IS", "Value": [37]},
        "1239": {"vr": "IS", "Value": [3]},
        "1240": {"vr": "IS", "Value": [51]},
        "1241": {"vr": "IS", "Value": [55]},
        "1242": {"vr": "IS", "Value": [22]},
        "1243": {"vr": "IS", "Value": [21]},
        "1244": {"vr": "IS", "Value": [16]},
        "1245": {"vr": "IS", "Value": [19]},
        "1246": {"vr": "IS", "Value": [15]},
        "1247": {"vr": "IS", "Value": [41]},
        "1248": {"vr": "IS", "Value": [49]},
        "1249": {"vr": "IS", "Value": [3]},
        "1250": {"vr": "IS", "Value": [0]},
        "1251": {"vr": "IS", "Value": [25]},
        "1252": {"vr": "IS", "Value": [43]},
        "1253": {"vr": "IS", "Value": [18]},
        "1254": {"vr": "IS", "Value": [11]},
        "1255": {"vr": "IS", "Value": [14]},
        "1256": {"vr": "IS", "Value": [3]},
        "1257": {"vr": "IS", "Value": [40]},
        "1258": {"vr": "IS", "Value": [39]},
        "1259": {"vr": "IS", "Value": [45]},
        "1260": {"vr": "IS", "Value": [7]},
        "1261": {"vr": "IS", "Value": [58]},
        "1262": {"vr": "IS", "Value": [21]},
        "1263": {"vr": "IS", "Value": [37]},
        "1264": {"vr": "IS", "Value": [34]},
        "1265": {"vr": "IS", "Value": [11]},
        "1266": {"vr": "IS", "Value": [18]},
        "1267": {"vr": "IS", "Value": [45]},
        "1268": {"vr": "IS", "Value": [3]},
        "1269": {"vr": "IS", "Value": [58]},
        "1270": {"vr": "IS", "Value": [34]},
        "1271": {"vr": "IS", "Value": [8]},
        "1272": {"vr": "IS", "Value": [3]},
        "1273": {"vr": "IS", "Value": [57]},
        "1274": {"vr": "IS", "Value": [33]},
        "1275": {"vr": "IS", "Value": [8]},
        "1276": {"vr": "IS", "Value": [49]},
        "1277": {"vr": "IS", "Value": [41]},
        "1278": {"vr": "IS", "Value": [9]},
        "1279": {"vr": "IS", "Value": [48]},
        "1280": {"vr": "IS", "Value": [4]},
        "1281": {"vr": "IS", "Value": [30]},
        "1282": {"vr": "IS", "Value": [54]},
        "1283": {"vr": "IS", "Value": [57]},
        "1284": {"vr": "IS", "Value": [26]},
        "1285": {"vr": "IS", "Value": [10]},
        "1286": {"vr": "IS", "Value": [58]},
        "1287": {"vr": "IS", "Value": [11]},
        "1288": {"vr": "IS", "Value": [33]},
        "1289": {"vr": "IS", "Value": [12]},
        "1290": {"vr": "IS", "Value": [29]},
        "1291": {"vr": "IS", "Value": [57]},
        "1292": {"vr": "IS", "Value": [10]},
        "1293": {"vr": "IS", "Value": [21]},
        "1294": {"vr": "IS", "Value": [41]},
        "1295": {"vr": "IS", "Value": [49]},
        "1296": {"vr": "IS", "Value": [29]},
        "1297": {"vr": "IS", "Value": [55]},
        "1298": {"vr": "IS", "Value": [24]},
        "1299": {"vr": "IS", "Value": [59]},
        "1300": {"vr": "IS", "Value": [45]},
        "1301": {"vr": "IS", "Value": [21]},
        "1302": {"vr": "IS", "Value": [5]},
        "1303": {"vr": "IS", "Value": [6]},
        "1304": {"vr": "IS", "Value": [28]},
        "1305": {"vr": "IS", "Value": [0]},
        "1306": {"vr": "IS", "Value": [12]},
        "1307": {"vr": "IS", "Value": [31]},
        "1308": {"vr": "IS", "Value": [38]},
        "1309": {"vr": "IS", "Value": [7]},
        "1310": {"vr": "IS", "Value": [38]},
        "1311": {"vr": "IS", "Value": [33]},
        "1312": {"vr": "IS", "Value": [5]},
        "1313": {"vr": "IS", "Value": [20]},
        "1314": {"vr": "IS", "Value": [12]},
        "1315": {"vr": "IS", "Value": [48]},
        "1316": {"vr": "IS", "Value": [39]},
        "1317": {"vr": "IS", "Value": [39]},
        "1318": {"vr": "IS", "Value": [9]},
        "1319": {"vr": "IS", "Value": [31]},
        "1320": {"vr": "IS", "Value": [46]},
        "1321": {"vr": "IS", "Value": [39]},
        "1322": {"vr": "IS", "Value": [54]},
        "1323": {"vr": "IS", "Value": [28]},
        "1324": {"vr": "IS", "Value": [19]},
        "1325": {"vr": "IS", "Value": [18]},
        "1326": {"vr": "IS", "Value": [5]},
        "1327": {"vr": "IS", "Value": [22]},
        "1328": {"vr": "IS", "Value": [20]},
        "1329": {"vr": "IS", "Value": [33]},
        "1330": {"vr": "IS", "Value": [2]},
        "1331": {"vr": "IS", "Value": [32]},
        "1332": {"vr": "IS", "Value": [26]},
        "1333": {"vr": "IS", "Value": [48]},
        "1334": {"vr": "IS", "Value": [22]},
        "1335": {"vr": "IS", "Value": [5]},
        "1336": {"vr": "IS", "Value": [22]},
        "1337": {"vr": "IS", "Value": [17]},
        "1338": {"vr": "IS", "Value": [45]},
        "1339": {"vr": "IS", "Value": [52]},
        "1340": {"vr": "IS", "Value": [40]},
        "1341": {"vr": "IS", "Value": [24]},
        "1342": {"vr": "IS", "Value": [23]},
        "1343": {"vr": "IS", "Value": [18]},
        "1344": {"vr": "IS", "Value": [18]},
        "1345": {"vr": "IS", "Value": [48]},
        "1346": {"vr": "IS", "Value": [50]},
        "1347": {"vr": "IS", "Value": [38]},
        "1348": {"vr": "IS", "Value": [24]},
        "1349": {"vr": "IS", "Value": [52]},
        "1350": {"vr": "IS", "Value": [6]},
        "1351": {"vr": "IS", "Value": [26]},
        "1352": {"vr": "IS", "Value": [26]},
        "1353": {"vr": "IS", "Value": [57]},
        "1354": {"vr": "IS", "Value": [6]},
        "1355": {"vr": "IS", "Value": [25]},
        "1356": {"vr": "IS", "Value": [18]},
        "1357": {"vr": "IS", "Value": [31]},
        "1358": {"vr": "IS", "Value": [0]},
        "1359": {"vr": "IS", "Value": [34]},
        "1360": {"vr": "IS", "Value": [36]},
        "1361": {"vr": "IS", "Value": [33]},
        "1362": {"vr": "IS", "Value": [29]},
        "1363": {"vr": "IS", "Value": [15]},
        "1364": {"vr": "IS", "Value": [59]},
        "1365": {"vr": "IS", "Value": [9]},
        "1366": {"vr": "IS", "Value": [23]},
        "1367": {"vr": "IS", "Value": [29]},
        "1368": {"vr": "IS", "Value": [55]},
        "1369": {"vr": "IS", "Value": [39]},
        "1370": {"vr": "IS", "Value": [43]},
        "1371": {"vr": "IS", "Value": [53]},
        "1372": {"vr": "IS", "Value": [12]},
        "1373": {"vr": "IS", "Value": [44]},
        "1374": {"vr": "IS", "Value": [11]},
        "1375": {"vr": "IS", "Value": [18]},
        "1376": {"vr": "IS", "Value": [10]},
        "1377": {"vr": "IS", "Value": [14]},
        "1378": {"vr": "IS", "Value": [30]},
        "1379": {"vr": "IS", "Value": [32]},
        "1380": {"vr": "IS", "Value": [9]},
        "1381": {"vr": "IS", "Value": [53]},
        "1382": {"vr": "IS", "Value": [25]},
        "1383": {"vr": "IS", "Value": [32]},
        "1384": {"vr": "IS", "Value": [58]},
        "1385": {"vr": "IS", "Value": [54]},
        "1386": {"vr": "IS", "Value": [36]},
        "1387": {"vr": "IS", "Value": [18]},
        "1388": {"vr": "IS", "Value": [0]},
        "1389": {"vr": "IS", "Value": [35]},
        "1390": {"vr": "IS", "Value": [10]},
        "1391": {"vr": "IS", "Value": [25]},
        "1392": {"vr": "IS", "Value": [11]},
        "1393": {"vr": "IS", "Value": [38]},
        "1394": {"vr": "IS", "Value": [40]},
        "1395": {"vr": "IS", "Value": [47]},
        "1396": {"vr": "IS", "Value": [20]},
        "1397": {"vr": "IS", "Value": [11]},
        "1398": {"vr": "IS", "Value": [30]},
        "1399": {"vr": "IS", "Value": [34]},
        "1400": {"vr": "IS", "Value": [18]},
        "1401": {"vr": "IS", "Value": [5]},
        "1402": {"vr": "IS", "Value": [36]},
        "1403": {"vr": "IS", "Value": [18]},
        "1404": {"vr": "IS", "Value": [15]},
        "1405": {"vr": "IS", "Value": [30]},
        "1406": {"vr": "IS", "Value": [50]},
        "1407": {"vr": "IS", "Value": [29]},
        "1408": {"vr": "IS", "Value": [6]},
        "1409": {"vr": "IS", "Value": [40]},
        "1410": {"vr": "IS", "Value": [54]},
        "1411": {"vr": "IS", "Value": [59]},
        "1412": {"vr": "IS", "Value": [28]},
        "1413": {"vr": "IS", "Value": [32]},
        "1414": {"vr": "IS", "Value": [8]},
        "1415": {"vr": "IS", "Value": [10]},
        "1416": {"vr": "IS", "Value": [15]},
        "1417": {"vr": "IS", "Value": [15]},
        "1418": {"vr": "IS", "Value": [41]},
        "1419": {"vr": "IS", "Value": [41]},
        "1420": {"vr": "IS", "Value": [32]},
        "1421": {"vr": "IS", "Value": [47]},
        "1422": {"vr": "IS", "Value": [45]},
        "1423": {"vr": "IS", "Value": [6]},
        "1424": {"vr": "IS", "Value": [27]},
        "1425": {"vr": "IS", "Value": [55]},
        "1426": {"vr": "IS", "Value": [55]},
        "1427": {"vr": "IS", "Value": [0]},
        "1428": {"vr": "IS", "Value": [23]},
        "1429": {"vr": "IS", "Value": [15]},
        "1430": {"vr": "IS", "Value": [42]},
        "1431": {"vr": "IS", "Value": [2]},
        "1432": {"vr": "IS", "Value": [4]},
        "1433": {"vr": "IS", "Value": [37]},
        "1434": {"vr": "IS", "Value": [49]},
        "1435": {"vr": "IS", "Value": [55]},
        "1436": {"vr": "IS", "Value": [44]},
        "1437": {"vr": "IS", "Value": [54]},
        "1438": {"vr": "IS", "Value": [0]},
        "1439": {"vr": "IS", "Value": [38]},
        "1440": {"vr": "IS", "Value": [14]},
        "1441": {"vr": "IS", "Value": [55]},
        "1442": {"vr": "IS", "Value": [9]},
        "1443": {"vr": "IS", "Value": [33]},
        "1444": {"vr": "IS", "Value": [22]},
        "1445": {"vr": "IS", "Value": [50]},
        "1446": {"vr": "IS", "Value": [44]},
        "1447": {"vr": "IS", "Value": [53]},
        "1448": {"vr": "IS", "Value": [4]},
        "1449": {"vr": "IS", "Value": [13]},
        "1450": {"vr": "IS", "Value": [50]},
        "1451": {"vr": "IS", "Value": [17]},
        "1452": {"vr": "IS", "Value": [27]},
        "1453": {"vr": "IS", "Value": [5]},
        "1454": {"vr": "IS", "Value": [39]},
        "1455": {"vr": "IS", "Value": [12]},
        "1456": {"vr": "IS", "Value": [34]},
        "1457": {"vr": "IS", "Value": [16]},
        "1458": {"vr": "IS", "Value": [58]},
        "1459": {"vr": "IS", "Value": [13]},
        "1460": {"vr": "IS", "Value": [57]},
        "1461": {"vr": "IS", "Value": [24]},
        "1462": {"vr": "IS", "Value": [24]},
        "1463": {"vr": "IS", "Value": [27]},
        "1464": {"vr": "IS", "Value": [49]},
        "1465": {"vr": "IS", "Value": [25]},
        "1466": {"vr": "IS", "Value": [56]},
        "1467": {"vr": "IS", "Value": [27]},
        "1468": {"vr": "IS", "Value": [5]},
        "1469": {"vr": "IS", "Value": [27]},
        "1470": {"vr": "IS", "Value": [26]},
        "1471": {"vr": "IS", "Value": [9]},
        "1472": {"vr": "IS", "Value": [38]},
        "1473": {"vr": "IS", "Value": [31]},
        "1474": {"vr": "IS", "Value": [8]},
        "1475": {"vr": "IS", "Value": [8]},
        "1476": {"vr": "IS", "Value": [48]},
        "1477": {"vr": "IS", "Value": [29]},
        "1478": {"vr": "IS", "Value": [51]},
        "1479": {"vr": "IS", "Value": [5]},
        "1480": {"vr": "IS", "Value": [44]},
        "1481": {"vr": "IS", "Value": [54]},
        "1482": {"vr": "IS", "Value": [36]},
        "1483": {"vr": "IS", "Value": [34]},
        "1484": {"vr": "IS", "Value": [30]},
        "1485": {"vr": "IS", "Value": [2]},
        "1486": {"vr": "IS", "Value": [15]},
        "1487": {"vr": "IS", "Value": [40]},
        "1488": {"vr": "IS", "Value": [49]},
        "1489": {"vr": "IS", "Value": [51]},
        "1490": {"vr": "IS", "Value": [32]},
        "1491": {"vr": "IS", "Value": [17]},
        "1492": {"vr": "IS", "Value": [38]},
        "1493": {"vr": "IS", "Value": [55]},
        "1494": {"vr": "IS", "Value": [11]},
        "1495": {"vr": "IS", "Value": [14]},
        "1496": {"vr": "IS", "Value": [7]},
        "1497": {"vr": "IS", "Value": [53]},
        "1498": {"vr": "IS", "Value": [44]},
        "1499": {"vr": "IS", "Value": [11]},
        "1500": {"vr": "IS", "Value": [41]},
        "1501": {"vr": "IS", "Value": [4]},
        "1502": {"vr": "IS", "Value": [9]},
        "1503": {"vr": "IS", "Value": [10]},
        "1504": {"vr": "IS", "Value": [10]},
        "1505": {"vr": "IS", "Value": [54]},
        "1506": {"vr": "IS", "Value": [47]},
        "1507": {"vr": "IS", "Value": [20]},
        "1508": {"vr": "IS", "Value": [43]},
        "1509": {"vr": "IS", "Value": [11]},
        "1510": {"vr": "IS", "Value": [40]},
        "1511": {"vr": "IS", "Value": [7]},
        "1512": {"vr": "IS", "Value": [4]},
        "1513": {"vr": "IS", "Value": [17]},
        "1514": {"vr": "IS", "Value": [5]},
        "1515": {"vr": "IS", "Value": [25]},
        "1516": {"vr": "IS", "Value": [23]},
        "1517": {"vr": "IS", "Value": [26]},
        "1518": {"vr": "IS", "Value": [48]},
        "1519": {"vr": "IS", "Value": [14]},
        "1520": {"vr": "IS", "Value": [6]},
        "1521": {"vr": "IS", "Value": [54]},
        "1522": {"vr": "IS", "Value": [28]},
        "1523": {"vr": "IS", "Value": [26]},
        "1524": {"vr": "IS", "Value": [57]},
        "1525": {"vr": "IS", "Value": [25]},
        "1526": {"vr": "IS", "Value": [58]},
        "1527": {"vr": "IS", "Value": [17]},
        "1528": {"vr": "IS", "Value": [6]},
        "1529": {"vr": "IS", "Value": [36]},
        "1530": {"vr": "IS", "Value": [16]},
        "1531": {"vr": "IS", "Value": [3]},
        "1532": {"vr": "IS", "Value": [25]},
        "1533": {"vr": "IS", "Value": [18]},
        "1534": {"vr": "IS", "Value": [55]},
        "1535": {"vr": "IS", "Value": [19]},
        "1536": {"vr": "IS", "Value": [33]},
        "1537": {"vr": "IS", "Value": [22]},
        "1538": {"vr": "IS", "Value": [49]},
        "1539": {"vr": "IS", "Value": [43]},
        "1540": {"vr": "IS", "Value": [19]},
        "1541": {"vr": "IS", "Value": [43]},
        "1542": {"vr": "IS", "Value": [24]},
        "1543": {"vr": "IS", "Value": [33]},
        "1544": {"vr": "IS", "Value": [54]},
        "1545": {"vr": "IS", "Value": [23]},
        "1546": {"vr": "IS", "Value": [20]},
        "1547": {"vr": "IS", "Value": [28]},
        "1548": {"vr": "IS", "Value": [46]},
        "1549": {"vr": "IS", "Value": [22]},
        "1550": {"vr": "IS", "Value": [16]},
        "1551": {"vr": "IS", "Value": [46]},
        "1552": {"vr": "IS", "Value": [42]},
        "1553": {"vr": "IS", "Value": [39]},
        "1554": {"vr": "IS", "Value": [23]},
        "1555": {"vr": "IS", "Value": [20]},
        "1556": {"vr": "IS", "Value": [27]},
        "1557": {"vr": "IS", "Value": [53]},
        "1558": {"vr": "IS", "Value": [52]},
        "1559": {"vr": "IS", "Value": [31]},
        "1560": {"vr": "IS", "Value": [7]},
        "1561": {"vr": "IS", "Value": [59]},
        "1562": {"vr": "IS", "Value": [13]},
        "1563": {"vr": "IS", "Value": [46]},
        "1564": {"vr": "IS", "Value": [55]},
        "1565": {"vr": "IS", "Value": [46]},
        "1566": {"vr": "IS", "Value": [5]},
        "1567": {"vr": "IS", "Value": [15]},
        "1568": {"vr": "IS", "Value": [1]},
        "1569": {"vr": "IS", "Value": [42]},
        "1570": {"vr": "IS", "Value": [15]},
        "1571": {"vr": "IS", "Value": [33]},
        "1572": {"vr": "IS", "Value": [0]},
        "1573": {"vr": "IS", "Value": [11]},
        "1574": {"vr": "IS", "Value": [51]},
        "1575": {"vr": "IS", "Value": [54]},
        "1576": {"vr": "IS", "Value": [36]},
        "1577": {"vr": "IS", "Value": [48]},
        "1578": {"vr": "IS", "Value": [20]},
        "1579": {"vr": "IS", "Value": [34]},
        "1580": {"vr": "IS", "Value": [2]},
        "1581": {"vr": "IS", "Value": [31]},
        "1582": {"vr": "IS", "Value": [10]},
        "1583": {"vr": "IS", "Value": [34]},
        "1584": {"vr": "IS", "Value": [13]},
        "1585": {"vr": "IS", "Value": [38]},
        "1586": {"vr": "IS", "Value": [21]},
        "1587": {"vr": "IS", "Value": [40]},
        "1588": {"vr": "IS", "Value": [36]},
        "1589": {"vr": "IS", "Value": [3]},
        "1590": {"vr": "IS", "Value": [58]},
        "1591": {"vr": "IS", "Value": [24]},
        "1592": {"vr": "IS", "Value": [33]},
        "1593": {"vr": "IS", "Value": [57]},
        "1594": {"vr": "IS", "Value": [33]},
        "1595": {"vr": "IS", "Value": [26]},
        "1596": {"vr": "IS", "Value": [3]},
        "1597": {"vr": "IS", "Value": [24]},
        "1598": {"vr": "IS", "Value": [49]},
        "1599": {"vr": "IS", "Value": [15]},
        "1600": {"vr": "IS", "Value": [47]},
        "1601": {"vr": "IS", "Value": [50]},
        "1602": {"vr": "IS", "Value": [45]},
        "1603": {"vr": "IS", "Value": [35]},
        "1604": {"vr": "IS", "Value": [46]},
        "1605": {"vr": "IS", "Value": [47]},
        "1606": {"vr": "IS", "Value": [41]},
        "1607": {"vr": "IS", "Value": [32]},
        "1608": {"vr": "IS", "Value": [3]},
        "1609": {"vr": "IS", "Value": [14]},
        "1610": {"vr": "IS", "Value": [38]},
        "1611": {"vr": "IS", "Value": [58]},
        "1612": {"vr": "IS", "Value": [54]},
        "1613": {"vr": "IS", "Value": [47]},
        "1614": {"vr": "IS", "Value": [18]},
        "1615": {"vr": "IS", "Value": [42]},
        "1616": {"vr": "IS", "Value": [25]},
        "1617": {"vr": "IS", "Value": [6]},
        "1618": {"vr": "IS", "Value": [6]},
        "1619": {"vr": "IS", "Value": [58]},
        "1620": {"vr": "IS", "Value": [4]},
        "1621": {"vr": "IS", "Value": [11]},
        "1622": {"vr": "IS", "Value": [22]},
        "1623": {"vr": "IS", "Value": [36]},
        "1624": {"vr": "IS", "Value": [51]},
        "1625": {"vr": "IS", "Value": [29]},
        "1626": {"vr": "IS", "Value": [33]},
        "1627": {"vr": "IS", "Value": [47]},
        "1628": {"vr": "IS", "Value": [24]},
        "1629": {"vr": "IS", "Value": [24]},
        "1630": {"vr": "IS", "Value": [41]},
        "1631": {"vr": "IS", "Value": [19]},
        "1632": {"vr": "IS", "Value": [0]},
        "1633": {"vr": "IS", "Value": [10]},
        "1634": {"vr": "IS", "Value": [45]},
        "1635": {"vr": "IS", "Value": [8]},
        "1636": {"vr": "IS", "Value": [38]},
        "1637": {"vr": "IS", "Value": [1]},
        "1638": {"vr": "IS", "Value": [15]},
        "1639": {"vr": "IS", "Value": [37]},
        "1640": {"vr": "IS", "Value": [42]},
        "1641": {"vr": "IS", "Value": [48]},
        "1642": {"vr": "IS", "Value": [12]},
        "1643": {"vr": "IS", "Value": [57]},
        "1644": {"vr": "IS", "Value": [27]},
        "1645": {"vr": "IS", "Value": [42]},
        "1646": {"vr": "IS", "Value": [31]},
        "1647": {"vr": "IS", "Value": [27]},
        "1648": {"vr": "IS", "Value": [53]},
        "1649": {"vr": "IS", "Value": [30]},
        "1650": {"vr": "IS", "Value": [2]},
        "1651": {"vr": "IS", "Value": [42]},
        "1652": {"vr": "IS", "Value": [57]},
        "1653": {"vr": "IS", "Value": [12]},
        "1654": {"vr": "IS", "Value": [57]},
        "1655": {"vr": "IS", "Value": [5]},
        "1656": {"vr": "IS", "Value": [39]},
        "1657": {"vr": "IS", "Value": [56]},
        "1658": {"vr": "IS", "Value": [31]},
        "1659": {"vr": "IS", "Value": [1]},
        "1660": {"vr": "IS", "Value": [39]},
        "1661": {"vr": "IS", "Value": [41]},
        "1662": {"vr": "IS", "Value": [42]},
        "1663": {"vr": "IS", "Value": [15]},
        "1664": {"vr": "IS", "Value": [49]},
        "1665": {"vr": "IS", "Value": [50]},
        "1666": {"vr": "IS", "Value": [50]},
        "1667": {"vr": "IS", "Value": [52]},
        "1668": {"vr": "IS", "Value": [34]},
        "1669": {"vr": "IS", "Value": [55]},
        "1670": {"vr": "IS", "Value": [33]},
        "1671": {"vr": "IS", "Value": [50]},
        "1672": {"vr": "IS", "Value": [9]},
        "1673": {"vr": "IS", "Value": [31]},
        "1674": {"vr": "IS", "Value": [56]},
        "1675": {"vr": "IS", "Value": [8]},
        "1676": {"vr": "IS", "Value": [41]},
        "1677": {"vr": "IS", "Value": [11]},
        "1678": {"vr": "IS", "Value": [11]},
        "1679": {"vr": "IS", "Value": [52]},
        "1680": {"vr": "IS", "Value": [23]},
        "1681": {"vr": "IS", "Value": [7]},
        "1682": {"vr": "IS", "Value": [39]},
        "1683": {"vr": "IS", "Value": [3]},
        "1684": {"vr": "IS", "Value": [25]},
        "1685": {"vr": "IS", "Value": [56]},
        "1686": {"vr": "IS", "Value": [0]},
        "1687": {"vr": "IS", "Value": [10]},
        "1688": {"vr": "IS", "Value": [50]},
        "1689": {"vr": "IS", "Value": [15]},
        "1690": {"vr": "IS", "Value": [58]},
        "1691": {"vr": "IS", "Value": [43]},
        "1692": {"vr": "IS", "Value": [19]},
        "1693": {"vr": "IS", "Value": [29]},
        "1694": {"vr": "IS", "Value": [19]},
        "1695": {"vr": "IS", "Value": [2]},
        "1696": {"vr": "IS", "Value": [55]},
        "1697": {"vr": "IS", "Value": [39]},
        "1698": {"vr": "IS", "Value": [10]},
        "1699": {"vr": "IS", "Value": [31]},
        "1700": {"vr": "IS", "Value": [53]},
        "1701": {"vr": "IS", "Value": [26]},
        "1702": {"vr": "IS", "Value": [5]},
        "1703": {"vr": "IS", "Value": [3]},
        "1704": {"vr": "IS", "Value": [39]},
        "1705": {"vr": "IS", "Value": [53]},
        "1706": {"vr": "IS", "Value": [4]},
        "1707": {"vr": "IS", "Value": [3]},
        "1708": {"vr": "IS", "Value": [35]},
        "1709": {"vr": "IS", "Value": [13]},
        "1710": {"vr": "IS", "Value": [15]},
        "1711": {"vr": "IS", "Value": [56]},
        "1712": {"vr": "IS", "Value": [30]},
        "1713": {"vr": "IS", "Value": [7]},
        "1714": {"vr": "IS", "Value": [18]},
        "1715": {"vr": "IS", "Value": [36]},
        "1716": {"vr": "IS", "Value": [32]},
        "1717": {"vr": "IS", "Value": [3]},
        "1718": {"vr": "IS", "Value": [12]},
        "1719": {"vr": "IS", "Value": [17]},
        "1720": {"vr": "IS", "Value": [56]},
        "1721": {"vr": "IS", "Value": [50]},
        "1722": {"vr": "IS", "Value": [11]},
        "1723": {"vr": "IS", "Value": [14]},
        "1724": {"vr": "IS", "Value": [18]},
        "1725": {"vr": "IS", "Value": [2]},
        "1726": {"vr": "IS", "Value": [23]},
        "1727": {"vr": "IS", "Value": [4]},
        "1728": {"vr": "IS", "Value": [29]},
        "1729": {"vr": "IS", "Value": [42]},
        "1730": {"vr": "IS", "Value": [59]},
        "1731": {"vr": "IS", "Value": [5]},
        "1732": {"vr": "IS", "Value": [14]},
        "1733": {"vr": "IS", "Value": [39]},
        "1734": {"vr": "IS", "Value": [8]},
        "1735": {"vr": "IS", "Value": [35]},
        "1736": {"vr": "IS", "Value": [2]},
        "1737": {"vr": "IS", "Value": [31]},
        "1738": {"vr": "IS", "Value": [53]},
        "1739": {"vr": "IS", "Value": [6]},
        "1740": {"vr": "IS", "Value": [41]},
        "1741": {"vr": "IS", "Value": [46]},
        "1742": {"vr": "IS", "Value": [30]},
        "1743": {"vr": "IS", "Value": [45]},
        "1744": {"vr": "IS", "Value": [53]},
        "1745": {"vr": "IS", "Value": [2]},
        "1746": {"vr": "IS", "Value": [32]},
        "1747": {"vr": "IS", "Value": [28]},
        "1748": {"vr": "IS", "Value": [38]},
        "1749": {"vr": "IS", "Value": [1]},
        "1750": {"vr": "IS", "Value": [49]},
        "1751": {"vr": "IS", "Value": [10]},
        "1752": {"vr": "IS", "Value": [21]},
        "1753": {"vr": "IS", "Value": [40]},
        "1754": {"vr": "IS", "Value": [27]},
        "1755": {"vr": "IS", "Value": [41]},
        "1756": {"vr": "IS", "Value": [41]},
        "1757": {"vr": "IS", "Value": [10]},
        "1758": {"vr": "IS", "Value": [45]},
        "1759": {"vr": "IS", "Value": [53]},
        "1760": {"vr": "IS", "Value": [16]},
        "1761": {"vr": "IS", "Value": [2]},
        "1762": {"vr": "IS", "Value": [33]},
        "1763": {"vr": "IS", "Value": [17]},
        "1764": {"vr": "IS", "Value": [30]},
        "1765": {"vr": "IS", "Value": [56]},
        "1766": {"vr": "IS", "Value": [14]},
        "1767": {"vr": "IS", "Value": [25]},
        "1768": {"vr": "IS", "Value": [24]},
        "1769": {"vr": "IS", "Value": [23]},
        "1770": {"vr": "IS", "Value": [5]},
        "1771": {"vr": "IS", "Value": [8]},
        "1772": {"vr": "IS", "Value": [47]},
        "1773": {"vr": "IS", "Value": [5]},
        "1774": {"vr": "IS", "Value": [48]},
        "1775": {"vr": "IS", "Value": [27]},
        "1776": {"vr": "IS", "Value": [16]},
        "1777": {"vr": "IS", "Value": [52]},
        "1778": {"vr": "IS", "Value": [54]},
        "1779": {"vr": "IS", "Value": [58]},
        "1780": {"vr": "IS", "Value": [35]},
        "1781": {"vr": "IS", "Value": [12]},
        "1782": {"vr": "IS", "Value": [19]},
        "1783": {"vr": "IS", "Value": [9]},
        "1784": {"vr": "IS", "Value": [19]},
        "1785": {"vr": "IS", "Value": [16]},
        "1786": {"vr": "IS", "Value": [9]},
        "1787": {"vr": "IS", "Value": [8]},
        "1788": {"vr": "IS", "Value": [44]},
        "1789": {"vr": "IS", "Value": [4]},
        "1790": {"vr": "IS", "Value": [0]},
        "1791": {"vr": "IS", "Value": [41]},
        "1792": {"vr": "IS", "Value": [23]},
        "1793": {"vr": "IS", "Value": [9]},
        "1794": {"vr": "IS", "Value": [32]},
        "1795": {"vr": "IS", "Value": [33]},
        "1796": {"vr": "IS", "Value": [41]},
        "1797": {"vr": "IS", "Value": [52]},
        "1798": {"vr": "IS", "Value": [30]},
        "1799": {"vr": "IS", "Value": [31]},
        "1800": {"vr": "IS", "Value": [47]},
        "1801": {"vr": "IS", "Value": [11]},
        "1802": {"vr": "IS", "Value": [17]},
        "1803": {"vr": "IS", "Value": [51]},
        "1804": {"vr": "IS", "Value": [55]},
        "1805": {"vr": "IS", "Value": [38]},
        "1806": {"vr": "IS", "Value": [59]},
        "1807": {"vr": "IS", "Value": [18]},
        "1808": {"vr": "IS", "Value": [50]},
        "1809": {"vr": "IS", "Value": [54]},
        "1810": {"vr": "IS", "Value": [55]},
        "1811": {"vr": "IS", "Value": [46]},
        "1812": {"vr": "IS", "Value": [14]},
        "1813": {"vr": "IS", "Value": [35]},
        "1814": {"vr": "IS", "Value": [26]},
        "1815": {"vr": "IS", "Value": [18]},
        "1816": {"vr": "IS", "Value": [54]},
        "1817": {"vr": "IS", "Value": [4]},
        "1818": {"vr": "IS", "Value": [20]},
        "1819": {"vr": "IS", "Value": [50]},
        "1820": {"vr": "IS", "Value": [17]},
        "1821": {"vr": "IS", "Value": [58]},
        "1822": {"vr": "IS", "Value": [0]},
        "1823": {"vr": "IS", "Value": [42]},
        "1824": {"vr": "IS", "Value": [51]},
        "1825": {"vr": "IS", "Value": [38]},
        "1826": {"vr": "IS", "Value": [0]},
        "1827": {"vr": "IS", "Value": [36]},
        "1828": {"vr": "IS", "Value": [50]},
        "1829": {"vr": "IS", "Value": [3]},
        "1830": {"vr": "IS", "Value": [29]},
        "1831": {"vr": "IS", "Value": [49]},
        "1832": {"vr": "IS", "Value": [53]},
        "1833": {"vr": "IS", "Value": [29]},
        "1834": {"vr": "IS", "Value": [20]},
        "1835": {"vr": "IS", "Value": [45]},
        "1836": {"vr": "IS", "Value": [35]},
        "1837": {"vr": "IS", "Value": [46]},
        "1838": {"vr": "IS", "Value": [52]},
        "1839": {"vr": "IS", "Value": [25]},
        "1840": {"vr": "IS", "Value": [6]},
        "1841": {"vr": "IS", "Value": [37]},
        "1842": {"vr": "IS", "Value": [44]},
        "1843": {"vr": "IS", "Value": [45]},
        "1844": {"vr": "IS", "Value": [48]},
        "1845": {"vr": "IS", "Value": [1]},
        "1846": {"vr": "IS", "Value": [18]},
        "1847": {"vr": "IS", "Value": [54]},
        "1848": {"vr": "IS", "Value": [45]},
        "1849": {"vr": "IS", "Value": [48]},
        "1850": {"vr": "IS", "Value": [25]},
        "1851": {"vr": "IS", "Value": [3]},
        "1852": {"vr": "IS", "Value": [51]},
        "1853": {"vr": "IS", "Value": [16]},
        "1854": {"vr": "IS", "Value": [12]},
        "1855": {"vr": "IS", "Value": [24]},
        "1856": {"vr": "IS", "Value": [27]},
        "1857": {"vr": "IS", "Value": [1]},
        "1858": {"vr": "IS", "Value": [32]},
        "1859": {"vr": "IS", "Value": [29]},
        "1860": {"vr": "IS", "Value": [38]},
        "1861": {"vr": "IS", "Value": [51]},
        "1862": {"vr": "IS", "Value": [13]},
        "1863": {"vr": "IS", "Value": [39]},
        "1864": {"vr": "IS", "Value": [49]},
        "1865": {"vr": "IS", "Value": [50]},
        "1866": {"vr": "IS", "Value": [32]},
        "1867": {"vr": "IS", "Value": [50]},
        "1868": {"vr": "IS", "Value": [0]},
        "1869": {"vr": "IS", "Value": [26]},
        "1870": {"vr": "IS", "Value": [42]},
        "1871": {"vr": "IS", "Value": [33]},
        "1872": {"vr": "IS", "Value": [26]},
        "1873": {"vr": "IS", "Value": [4]},
        "1874": {"vr": "IS", "Value": [15]},
        "1875": {"vr": "IS", "Value": [54]},
        "1876": {"vr": "IS", "Value": [22]},
        "1877": {"vr": "IS", "Value": [7]},
        "1878": {"vr": "IS", "Value": [53]},
        "1879": {"vr": "IS", "Value": [47]},
        "1880": {"vr": "IS", "Value": [26]},
        "1881": {"vr": "IS", "Value": [56]},
        "1882": {"vr": "IS", "Value": [19]},
        "1883": {"vr": "IS", "Value": [58]},
        "1884": {"vr": "IS", "Value": [25]},
        "1885": {"vr": "IS", "Value": [52]},
        "1886": {"vr": "IS", "Value": [23]},
        "1887": {"vr": "IS", "Value": [53]},
        "1888": {"vr": "IS", "Value": [35]},
        "1889": {"vr": "IS", "Value": [19]},
        "1890": {"vr": "IS", "Value": [23]},
        "1891": {"vr": "IS", "Value": [57]},
        "1892": {"vr": "IS", "Value": [59]},
        "1893": {"vr": "IS", "Value": [11]},
        "1894": {"vr": "IS", "Value": [9]},
        "1895": {"vr": "IS", "Value": [2]},
        "1896": {"vr": "IS", "Value": [38]},
        "1897": {"vr": "IS", "Value": [10]},
        "1898": {"vr": "IS", "Value": [50]},
        "1899": {"vr": "IS", "Value": [46]},
        "1900": {"vr": "IS", "Value": [5]},
        "1901": {"vr": "IS", "Value": [32]},
        "1902": {"vr": "IS", "Value": [11]},
        "1903": {"vr": "IS", "Value": [22]},
        "1904": {"vr": "IS", "Value": [53]},
        "1905": {"vr": "IS", "Value": [45]},
        "1906": {"vr": "IS", "Value": [57]},
        "1907": {"vr": "IS", "Value": [13]},
        "1908": {"vr": "IS", "Value": [37]},
        "1909": {"vr": "IS", "Value": [28]},
        "1910": {"vr": "IS", "Value": [21]},
        "1911": {"vr": "IS", "Value": [27]},
        "1912": {"vr": "IS", "Value": [2]},
        "1913": {"vr": "IS", "Value": [30]},
        "1914": {"vr": "IS", "Value": [20]},
        "1915": {"vr": "IS", "Value": [48]},
        "1916": {"vr": "IS", "Value": [32]},
        "1917": {"vr": "IS", "Value": [13]},
        "1918": {"vr": "IS", "Value": [10]},
        "1919": {"vr": "IS", "Value": [59]},
        "1920": {"vr": "IS", "Value": [4]},
        "1921": {"vr": "IS", "Value": [7]},
        "1922": {"vr": "IS", "Value": [47]},
        "1923": {"vr": "IS", "Value": [34]},
        "1924": {"vr": "IS", "Value": [51]},
        "1925": {"vr": "IS", "Value": [20]},
        "1926": {"vr": "IS", "Value": [36]},
        "1927": {"vr": "IS", "Value": [59]},
        "1928": {"vr": "IS", "Value": [51]},
        "1929": {"vr": "IS", "Value": [23]},
        "1930": {"vr": "IS", "Value": [7]},
        "1931": {"vr": "IS", "Value": [19]},
        "1932": {"vr": "IS", "Value": [9]},
        "1933": {"vr": "IS", "Value": [32]},
        "1934": {"vr": "IS", "Value": [56]},
        "1935": {"vr": "IS", "Value": [44]},
        "1936": {"vr": "IS", "Value": [52]},
        "1937": {"vr": "IS", "Value": [42]},
        "1938": {"vr": "IS", "Value": [20]},
        "1939": {"vr": "IS", "Value": [13]},
        "1940": {"vr": "IS", "Value": [54]},
        "1941": {"vr": "IS", "Value": [33]},
        "1942": {"vr": "IS", "Value": [34]},
        "1943": {"vr": "IS", "Value": [9]},
        "1944": {"vr": "IS", "Value": [42]},
        "1945": {"vr": "IS", "Value": [10]},
        "1946": {"vr": "IS", "Value": [15]},
        "1947": {"vr": "IS", "Value": [30]},
        "1948": {"vr": "IS", "Value": [48]},
        "1949": {"vr": "IS", "Value": [26]},
        "1950": {"vr": "IS", "Value": [5]},
        "1951": {"vr": "IS", "Value": [26]},
        "1952": {"vr": "IS", "Value": [7]},
        "1953": {"vr": "IS", "Value": [50]},
        "1954": {"vr": "IS", "Value": [36]},
        "1955": {"vr": "IS", "Value": [35]},
        "1956": {"vr": "IS", "Value": [43]},
        "1957": {"vr": "IS", "Value": [37]},
        "1958": {"vr": "IS", "Value": [58]},
        "1959": {"vr": "IS", "Value": [29]},
        "1960": {"vr": "IS", "Value": [50]},
        "1961": {"vr": "IS", "Value": [27]},
        "1962": {"vr": "IS", "Value": [16]},
        "1963": {"vr": "IS", "Value": [38]},
        "1964": {"vr": "IS", "Value": [20]},
        "1965": {"vr": "IS", "Value": [20]},
        "1966": {"vr": "IS", "Value": [29]},
        "1967": {"vr": "IS", "Value": [0]},
        "1968": {"vr": "IS", "Value": [2]},
        "1969": {"vr": "IS", "Value": [47]},
        "1970": {"vr": "IS", "Value": [43]},
        "1971": {"vr": "IS", "Value": [32]},
        "1972": {"vr": "IS", "Value": [24]},
        "1973": {"vr": "IS", "Value": [11]},
        "1974": {"vr": "IS", "Value": [48]},
        "1975": {"vr": "IS", "Value": [4]},
        "1976": {"vr": "IS", "Value": [24]},
        "1977": {"vr": "IS", "Value": [30]},
        "1978": {"vr": "IS", "Value": [20]},
        "1979": {"vr": "IS", "Value": [7]},
        "1980": {"vr": "IS", "Value": [3]},
        "1981": {"vr": "IS", "Value": [58]},
        "1982": {"vr": "IS", "Value": [42]},
        "1983": {"vr": "IS", "Value": [49]},
        "1984": {"vr": "IS", "Value": [22]},
        "1985": {"vr": "IS", "Value": [43]},
        "1986": {"vr": "IS", "Value": [58]},
        "1987": {"vr": "IS", "Value": [24]},
        "1988": {"vr": "IS", "Value": [17]},
        "1989": {"vr": "IS", "Value": [0]},
        "1990": {"vr": "IS", "Value": [34]},
        "1991": {"vr": "IS", "Value": [42]},
        "1992": {"vr": "IS", "Value": [52]},
        "1993": {"vr": "IS", "Value": [26]},
        "1994": {"vr": "IS", "Value": [47]},
        "1995": {"vr": "IS", "Value": [22]},
        "1996": {"vr": "IS", "Value": [15]},
        "1997": {"vr": "IS", "Value": [47]},
        "1998": {"vr": "IS", "Value": [3]},
        "1999": {"vr": "IS", "Value": [47]},
        "2000": {"vr": "IS", "Value": [19]},
        "2001": {"vr": "IS", "Value": [49]},
        "2002": {"vr": "IS", "Value": [46]},
        "2003": {"vr": "IS", "Value": [27]},
        "2004": {"vr": "IS", "Value": [26]},
        "2005": {"vr": "IS", "Value": [35]},
        "2006": {"vr": "IS", "Value": [0]},
        "2007": {"vr": "IS", "Value": [53]},
        "2008": {"vr": "IS", "Value": [40]},
        "2009": {"vr": "IS", "Value": [33]},
        "2010": {"vr": "IS", "Value": [17]},
        "2011": {"vr": "IS", "Value": [42]},
        "2012": {"vr": "IS", "Value": [19]},
        "2013": {"vr": "IS", "Value": [48]},
        "2014": {"vr": "IS", "Value": [43]},
        "2015": {"vr": "IS", "Value": [9]},
        "2016": {"vr": "IS", "Value": [14]},
        "2017": {"vr": "IS", "Value": [1]},
        "2018": {"vr": "IS", "Value": [20]},
        "2019": {"vr": "IS", "Value": [8]},
        "2020": {"vr": "IS", "Value": [42]},
        "2021": {"vr": "IS", "Value": [18]},
        "2022": {"vr": "IS", "Value": [16]},
        "2023": {"vr": "IS", "Value": [55]},
        "2024": {"vr": "IS", "Value": [32]},
        "2025": {"vr": "IS", "Value": [48]},
        "2026": {"vr": "IS", "Value": [10]},
        "2027": {"vr": "IS", "Value": [37]},
        "2028": {"vr": "IS", "Value": [27]},
        "2029": {"vr": "IS", "Value": [42]},
        "2030": {"vr": "IS", "Value": [19]},
        "2031": {"vr": "IS", "Value": [57]},
        "2032": {"vr": "IS", "Value": [18]},
        "2033": {"vr": "IS", "Value": [36]},
        "2034": {"vr": "IS", "Value": [33]},
        "2035": {"vr": "IS", "Value": [29]},
        "2036": {"vr": "IS", "Value": [28]},
        "2037": {"vr": "IS", "Value": [48]},
        "2038": {"vr": "IS", "Value": [59]},
        "2039": {"vr": "IS", "Value": [30]},
        "2040": {"vr": "IS", "Value": [19]},
        "2041": {"vr": "IS", "Value": [31]},
        "2042": {"vr": "IS", "Value": [49]},
        "2043": {"vr": "IS", "Value": [29]},
        "2044": {"vr": "IS", "Value": [48]},
        "2045": {"vr": "IS", "Value": [24]},
        "2046": {"vr": "IS", "Value": [21]},
        "2047": {"vr": "IS", "Value": [4]},
        "2048": {"vr": "IS", "Value": [42]},
        "2049": {"vr": "IS", "Value": [16]},
        "2050": {"vr": "IS", "Value": [41]},
        "2051": {"vr": "IS", "Value": [20]},
        "2052": {"vr": "IS", "Value": [57]},
        "2053": {"vr": "IS", "Value": [21]},
        "2054": {"vr": "IS", "Value": [8]},
        "2055": {"vr": "IS", "Value": [31]},
        "2056": {"vr": "IS", "Value": [1]},
        "2057": {"vr": "IS", "Value": [48]},
        "2058": {"vr": "IS", "Value": [42]},
        "2059": {"vr": "IS", "Value": [12]},
        "2060": {"vr": "IS", "Value": [29]},
        "2061": {"vr": "IS", "Value": [18]},
        "2062": {"vr": "IS", "Value": [19]},
        "2063": {"vr": "IS", "Value": [25]},
        "2064": {"vr": "IS", "Value": [21]},
        "2065": {"vr": "IS", "Value": [29]},
        "2066": {"vr": "IS", "Value": [13]},
        "2067": {"vr": "IS", "Value": [40]},
        "2068": {"vr": "IS", "Value": [34]},
        "2069": {"vr": "IS", "Value": [37]},
        "2070": {"vr": "IS", "Value": [42]},
        "2071": {"vr": "IS", "Value": [40]},
        "2072": {"vr": "IS", "Value": [13]},
        "2073": {"vr": "IS", "Value": [14]},
        "2074": {"vr": "IS", "Value": [22]},
        "2075": {"vr": "IS", "Value": [31]},
        "2076": {"vr": "IS", "Value": [49]},
        "2077": {"vr": "IS", "Value": [6]},
        "2078": {"vr": "IS", "Value": [51]},
        "2079": {"vr": "IS", "Value": [24]},
        "2080": {"vr": "IS", "Value": [58]},
        "2081": {"vr": "IS", "Value": [32]},
        "2082": {"vr": "IS", "Value": [14]},
        "2083": {"vr": "IS", "Value": [17]},
        "2084": {"vr": "IS", "Value": [31]},
        "2085": {"vr": "IS", "Value": [14]},
        "2086": {"vr": "IS", "Value": [51]},
        "2087": {"vr": "IS", "Value": [16]},
        "2088": {"vr": "IS", "Value": [23]},
        "2089": {"vr": "IS", "Value": [47]},
        "2090": {"vr": "IS", "Value": [45]},
        "2091": {"vr": "IS", "Value": [39]},
        "2092": {"vr": "IS", "Value": [49]},
        "2093": {"vr": "IS", "Value": [47]},
        "2094": {"vr": "IS", "Value": [53]},
        "2095": {"vr": "IS", "Value": [40]},
        "2096": {"vr": "IS", "Value": [39]},
        "2097": {"vr": "IS", "Value": [24]},
        "2098": {"vr": "IS", "Value": [17]},
        "2099": {"vr": "IS", "Value": [50]},
        "2100": {"vr": "IS", "Value": [54]},
        "2101": {"vr": "IS", "Value": [6]},
        "2102": {"vr": "IS", "Value": [22]},
        "2103": {"vr": "IS", "Value": [37]},
        "2104": {"vr": "IS", "Value": [3]},
        "2105": {"vr": "IS", "Value": [30]},
        "2106": {"vr": "IS", "Value": [59]},
        "2107": {"vr": "IS", "Value": [45]},
        "2108": {"vr": "IS", "Value": [0]},
        "2109": {"vr": "IS", "Value": [5]},
        "2110": {"vr": "IS", "Value": [46]},
        "2111": {"vr": "IS", "Value": [33]},
        "2112": {"vr": "IS", "Value": [58]},
        "2113": {"vr": "IS", "Value": [38]},
        "2114": {"vr": "IS", "Value": [55]},
        "2115": {"vr": "IS", "Value": [57]},
        "2116": {"vr": "IS", "Value": [9]},
        "2117": {"vr": "IS", "Value": [44]},
        "2118": {"vr": "IS", "Value": [34]},
        "2119": {"vr": "IS", "Value": [1]},
        "2120": {"vr": "IS", "Value": [57]},
        "2121": {"vr": "IS", "Value": [37]},
        "2122": {"vr": "IS", "Value": [43]},
        "2123": {"vr": "IS", "Value": [50]},
        "2124": {"vr": "IS", "Value": [10]},
        "2125": {"vr": "IS", "Value": [36]},
        "2126": {"vr": "IS", "Value": [32]},
        "2127": {"vr": "IS", "Value": [21]},
        "2128": {"vr": "IS", "Value": [47]},
        "2129": {"vr": "IS", "Value": [21]},
        "2130": {"vr": "IS", "Value": [17]},
        "2131": {"vr": "IS", "Value": [31]},
        "2132": {"vr": "IS", "Value": [30]},
        "2133": {"vr": "IS", "Value": [52]},
        "2134": {"vr": "IS", "Value": [25]},
        "2135": {"vr": "IS", "Value": [10]},
        "2136": {"vr": "IS", "Value": [47]},
        "2137": {"vr": "IS", "Value": [9]},
        "2138": {"vr": "IS", "Value": [31]},
        "2139": {"vr": "IS", "Value": [51]},
        "2140": {"vr": "IS", "Value": [1]},
        "2141": {"vr": "IS", "Value": [39]},
        "2142": {"vr": "IS", "Value": [42]},
        "2143": {"vr": "IS", "Value": [38]},
        "2144": {"vr": "IS", "Value": [18]},
        "2145": {"vr": "IS", "Value": [40]},
        "2146": {"vr": "IS", "Value": [39]},
        "2147": {"vr": "IS", "Value": [51]},
        "2148": {"vr": "IS", "Value": [4]},
        "2149": {"vr": "IS", "Value": [36]},
        "2150": {"vr": "IS", "Value": [36]},
        "2151": {"vr": "IS", "Value": [0]},
        "2152": {"vr": "IS", "Value": [42]},
        "2153": {"vr": "IS", "Value": [52]},
        "2154": {"vr": "IS", "Value": [34]},
        "2155": {"vr": "IS", "Value": [17]},
        "2156": {"vr": "IS", "Value": [22]},
        "2157": {"vr": "IS", "Value": [19]},
        "2158": {"vr": "IS", "Value": [35]},
        "2159": {"vr": "IS", "Value": [12]},
        "2160": {"vr": "IS", "Value": [50]},
        "2161": {"vr": "IS", "Value": [24]},
        "2162": {"vr": "IS", "Value": [43]},
        "2163": {"vr": "IS", "Value": [27]},
        "2164": {"vr": "IS", "Value": [36]},
        "2165": {"vr": "IS", "Value": [3]},
        "2166": {"vr": "IS", "Value": [15]},
        "2167": {"vr": "IS", "Value": [11]},
        "2168": {"vr": "IS", "Value": [1]},
        "2169": {"vr": "IS", "Value": [19]},
        "2170": {"vr": "IS", "Value": [28]},
        "2171": {"vr": "IS", "Value": [38]},
        "2172": {"vr": "IS", "Value": [14]},
        "2173": {"vr": "IS", "Value": [14]},
        "2174": {"vr": "IS", "Value": [50]},
        "2175": {"vr": "IS", "Value": [38]},
        "2176": {"vr": "IS", "Value": [54]},
        "2177": {"vr": "IS", "Value": [32]},
        "2178": {"vr": "IS", "Value": [0]},
        "2179": {"vr": "IS", "Value": [14]},
        "2180": {"vr": "IS", "Value": [43]},
        "2181": {"vr": "IS", "Value": [47]},
        "2182": {"vr": "IS", "Value": [29]},
        "2183": {"vr": "IS", "Value": [21]},
        "2184": {"vr": "IS", "Value": [10]},
        "2185": {"vr": "IS", "Value": [53]},
        "2186": {"vr": "IS", "Value": [53]},
        "2187": {"vr": "IS", "Value": [1]},
        "2188": {"vr": "IS", "Value": [25]},
        "2189": {"vr": "IS", "Value": [24]},
        "2190": {"vr": "IS", "Value": [16]},
        "2191": {"vr": "IS", "Value": [55]},
        "2192": {"vr": "IS", "Value": [9]},
        "2193": {"vr": "IS", "Value": [52]},
        "2194": {"vr": "IS", "Value": [49]},
        "2195": {"vr": "IS", "Value": [20]},
        "2196": {"vr": "IS", "Value": [28]},
        "2197": {"vr": "IS", "Value": [29]},
        "2198": {"vr": "IS", "Value": [53]},
        "2199": {"vr": "IS", "Value": [8]},
        "2200": {"vr": "IS", "Value": [9]},
        "2201": {"vr": "IS", "Value": [1]},
        "2202": {"vr": "IS", "Value": [1]},
        "2203": {"vr": "IS", "Value": [17]},
        "2204": {"vr": "IS", "Value": [43]},
        "2205": {"vr": "IS", "Value": [15]},
        "2206": {"vr": "IS", "Value": [9]},
        "2207": {"vr": "IS", "Value": [34]},
        "2208": {"vr": "IS", "Value": [41]},
        "2209": {"vr": "IS", "Value": [12]},
        "2210": {"vr": "IS", "Value": [12]},
        "2211": {"vr": "IS", "Value": [1]},
        "2212": {"vr": "IS", "Value": [19]},
        "2213": {"vr": "IS", "Value": [48]},
        "2214": {"vr": "IS", "Value": [34]},
        "2215": {"vr": "IS", "Value": [34]},
        "2216": {"vr": "IS", "Value": [17]},
        "2217": {"vr": "IS", "Value": [37]},
        "2218": {"vr": "IS", "Value": [33]},
        "2219": {"vr": "IS", "Value": [53]},
        "2220": {"vr": "IS", "Value": [16]},
        "2221": {"vr": "IS", "Value": [53]},
        "2222": {"vr": "IS", "Value": [19]},
        "2223": {"vr": "IS", "Value": [50]},
        "2224": {"vr": "IS", "Value": [44]},
        "2225": {"vr": "IS", "Value": [58]},
        "2226": {"vr": "IS", "Value": [12]},
        "2227": {"vr": "IS", "Value": [36]},
        "2228": {"vr": "IS", "Value": [40]},
        "2229": {"vr": "IS", "Value": [58]},
        "2230": {"vr": "IS", "Value": [56]},
        "2231": {"vr": "IS", "Value": [59]},
        "2232": {"vr": "IS", "Value": [35]},
        "2233": {"vr": "IS", "Value": [34]},
        "2234": {"vr": "IS", "Value": [41]},
        "2235": {"vr": "IS", "Value": [27]},
        "2236": {"vr": "IS", "Value": [49]},
        "2237": {"vr": "IS", "Value": [34]},
        "2238": {"vr": "IS", "Value": [1]},
        "2239": {"vr": "IS", "Value": [22]},
        "2240": {"vr": "IS", "Value": [39]},
        "2241": {"vr": "IS", "Value": [54]},
        "2242": {"vr": "IS", "Value": [24]},
        "2243": {"vr": "IS", "Value": [11]},
        "2244": {"vr": "IS", "Value": [39]},
        "2245": {"vr": "IS", "Value": [26]},
        "2246": {"vr": "IS", "Value": [47]},
        "2247": {"vr": "IS", "Value": [0]},
        "2248": {"vr": "IS", "Value": [43]},
        "2249": {"vr": "IS", "Value": [7]},
        "2250": {"vr": "IS", "Value": [56]},
        "2251": {"vr": "IS", "Value": [39]},
        "2252": {"vr": "IS", "Value": [2]},
        "2253": {"vr": "IS", "Value": [19]},
        "2254": {"vr": "IS", "Value": [42]},
        "2255": {"vr": "IS", "Value": [53]},
        "2256": {"vr": "IS", "Value": [5]},
        "2257": {"vr": "IS", "Value": [50]},
        "2258": {"vr": "IS", "Value": [23]},
        "2259": {"vr": "IS", "Value": [37]},
        "2260": {"vr": "IS", "Value": [3]},
        "2261": {"vr": "IS", "Value": [23]},
        "2262": {"vr": "IS", "Value": [51]},
        "2263": {"vr": "IS", "Value": [6]},
        "2264": {"vr": "IS", "Value": [45]},
        "2265": {"vr": "IS", "Value": [34]},
        "2266": {"vr": "IS", "Value": [16]},
        "2267": {"vr": "IS", "Value": [57]},
        "2268": {"vr": "IS", "Value": [56]},
        "2269": {"vr": "IS", "Value": [5]},
        "2270": {"vr": "IS", "Value": [47]},
        "2271": {"vr": "IS", "Value": [27]},
        "2272": {"vr": "IS", "Value": [49]},
        "2273": {"vr": "IS", "Value": [51]},
        "2274": {"vr": "IS", "Value": [28]},
        "2275": {"vr": "IS", "Value": [40]},
        "2276": {"vr": "IS", "Value": [6]},
        "2277": {"vr": "IS", "Value": [51]},
        "2278": {"vr": "IS", "Value": [8]},
        "2279": {"vr": "IS", "Value": [15]},
        "2280": {"vr": "IS", "Value": [49]},
        "2281": {"vr": "IS", "Value": [57]},
        "2282": {"vr": "IS", "Value": [16]},
        "2283": {"vr": "IS", "Value": [42]},
        "2284": {"vr": "IS", "Value": [4]},
        "2285": {"vr": "IS", "Value": [13]},
        "2286": {"vr": "IS", "Value": [25]},
        "2287": {"vr": "IS", "Value": [59]},
        "2288": {"vr": "IS", "Value": [51]},
        "2289": {"vr": "IS", "Value": [16]},
        "2290": {"vr": "IS", "Value": [37]},
        "2291": {"vr": "IS", "Value": [20]},
        "2292": {"vr": "IS", "Value": [29]},
        "2293": {"vr": "IS", "Value": [28]},
        "2294": {"vr": "IS", "Value": [29]},
        "2295": {"vr": "IS", "Value": [53]},
        "2296": {"vr": "IS", "Value": [9]},
        "2297": {"vr": "IS", "Value": [22]},
        "2298": {"vr": "IS", "Value": [57]},
        "2299": {"vr": "IS", "Value": [0]},
        "2300": {"vr": "IS", "Value": [24]},
        "2301": {"vr": "IS", "Value": [18]},
        "2302": {"vr": "IS", "Value": [40]},
        "2303": {"vr": "IS", "Value": [41]},
        "2304": {"vr": "IS", "Value": [25]},
        "2305": {"vr": "IS", "Value": [53]},
        "2306": {"vr": "IS", "Value": [3]},
        "2307": {"vr": "IS", "Value": [46]},
        "2308": {"vr": "IS", "Value": [51]},
        "2309": {"vr": "IS", "Value": [51]},
        "2310": {"vr": "IS", "Value": [49]},
        "2311": {"vr": "IS", "Value": [47]},
        "2312": {"vr": "IS", "Value": [52]},
        "2313": {"vr": "IS", "Value": [11]},
        "2314": {"vr": "IS", "Value": [0]},
        "2315": {"vr": "IS", "Value": [2]},
        "2316": {"vr": "IS", "Value": [32]},
        "2317": {"vr": "IS", "Value": [29]},
        "2318": {"vr": "IS", "Value": [0]},
        "2319": {"vr": "IS", "Value": [38]},
        "2320": {"vr": "IS", "Value": [50]},
        "2321": {"vr": "IS", "Value": [11]},
        "2322": {"vr": "IS", "Value": [18]},
        "2323": {"vr": "IS", "Value": [39]},
        "2324": {"vr": "IS", "Value": [49]},
        "2325": {"vr": "IS", "Value": [15]},
        "2326": {"vr": "IS", "Value": [46]},
        "2327": {"vr": "IS", "Value": [2]},
        "2328": {"vr": "IS", "Value": [41]},
        "2329": {"vr": "IS", "Value": [0]},
        "2330": {"vr": "IS", "Value": [15]},
        "2331": {"vr": "IS", "Value": [33]},
        "2332": {"vr": "IS", "Value": [51]},
        "2333": {"vr": "IS", "Value": [40]},
        "2334": {"vr": "IS", "Value": [31]},
        "2335": {"vr": "IS", "Value": [54]},
        "2336": {"vr": "IS", "Value": [11]},
        "2337": {"vr": "IS", "Value": [44]},
        "2338": {"vr": "IS", "Value": [49]},
        "2339": {"vr": "IS", "Value": [15]},
        "2340": {"vr": "IS", "Value": [22]},
        "2341": {"vr": "IS", "Value": [8]},
        "2342": {"vr": "IS", "Value": [26]},
        "2343": {"vr": "IS", "Value": [23]},
        "2344": {"vr": "IS", "Value": [24]},
        "2345": {"vr": "IS", "Value": [24]},
        "2346": {"vr": "IS", "Value": [14]},
        "2347": {"vr": "IS", "Value": [36]},
        "2348": {"vr": "IS", "Value": [5]},
        "2349": {"vr": "IS", "Value": [6]},
        "2350": {"vr": "IS", "Value": [35]},
        "2351": {"vr": "IS", "Value": [18]},
        "2352": {"vr": "IS", "Value": [32]},
        "2353": {"vr": "IS", "Value": [18]},
        "2354": {"vr": "IS", "Value": [39]},
        "2355": {"vr": "IS", "Value": [44]},
        "2356": {"vr": "IS", "Value": [10]},
        "2357": {"vr": "IS", "Value": [44]},
        "2358": {"vr": "IS", "Value": [14]},
        "2359": {"vr": "IS", "Value": [59]},
        "2360": {"vr": "IS", "Value": [51]},
        "2361": {"vr": "IS", "Value": [21]},
        "2362": {"vr": "IS", "Value": [40]},
        "2363": {"vr": "IS", "Value": [39]},
        "2364": {"vr": "IS", "Value": [53]},
        "2365": {"vr": "IS", "Value": [32]},
        "2366": {"vr": "IS", "Value": [30]},
        "2367": {"vr": "IS", "Value": [43]},
        "2368": {"vr": "IS", "Value": [40]},
        "2369": {"vr": "IS", "Value": [43]},
        "2370": {"vr": "IS", "Value": [38]},
        "2371": {"vr": "IS", "Value": [32]},
        "2372": {"vr": "IS", "Value": [54]},
        "2373": {"vr": "IS", "Value": [29]},
        "2374": {"vr": "IS", "Value": [53]},
        "2375": {"vr": "IS", "Value": [1]},
        "2376": {"vr": "IS", "Value": [20]},
        "2377": {"vr": "IS", "Value": [30]},
        "2378": {"vr": "IS", "Value": [59]},
        "2379": {"vr": "IS", "Value": [32]},
        "2380": {"vr": "IS", "Value": [1]},
        "2381": {"vr": "IS", "Value": [36]},
        "2382": {"vr": "IS", "Value": [14]},
        "2383": {"vr": "IS", "Value": [7]},
        "2384": {"vr": "IS", "Value": [11]},
        "2385": {"vr": "IS", "Value": [8]},
        "2386": {"vr": "IS", "Value": [56]},
        "2387": {"vr": "IS", "Value": [24]},
        "2388": {"vr": "IS", "Value": [56]},
        "2389": {"vr": "IS", "Value": [49]},
        "2390": {"vr": "IS", "Value": [12]},
        "2391": {"vr": "IS", "Value": [58]},
        "2392": {"vr": "IS", "Value": [46]},
        "2393": {"vr": "IS", "Value": [25]},
        "2394": {"vr": "IS", "Value": [17]},
        "2395": {"vr": "IS", "Value": [57]},
        "2396": {"vr": "IS", "Value": [7]},
        "2397": {"vr": "IS", "Value": [46]},
        "2398": {"vr": "IS", "Value": [42]},
        "2399": {"vr": "IS", "Value": [20]},
        "2400": {"vr": "IS", "Value": [11]},
        "2401": {"vr": "IS", "Value": [57]},
        "2402": {"vr": "IS", "Value": [32]},
        "2403": {"vr": "IS", "Value": [30]},
        "2404": {"vr": "IS", "Value": [31]},
        "2405": {"vr": "IS", "Value": [38]},
        "2406": {"vr": "IS", "Value": [45]},
        "2407": {"vr": "IS", "Value": [19]},
        "2408": {"vr": "IS", "Value": [43]},
        "2409": {"vr": "IS", "Value": [5]},
        "2410": {"vr": "IS", "Value": [22]},
        "2411": {"vr": "IS", "Value": [32]},
        "2412": {"vr": "IS", "Value": [2]},
        "2413": {"vr": "IS", "Value": [20]},
        "2414": {"vr": "IS", "Value": [4]},
        "2415": {"vr": "IS", "Value": [58]},
        "2416": {"vr": "IS", "Value": [40]},
        "2417": {"vr": "IS", "Value": [32]},
        "2418": {"vr": "IS", "Value": [5]},
        "2419": {"vr": "IS", "Value": [56]},
        "2420": {"vr": "IS", "Value": [5]},
        "2421": {"vr": "IS", "Value": [18]},
        "2422": {"vr": "IS", "Value": [20]},
        "2423": {"vr": "IS", "Value": [52]},
        "2424": {"vr": "IS", "Value": [5]},
        "2425": {"vr": "IS", "Value": [13]},
        "2426": {"vr": "IS", "Value": [37]},
        "2427": {"vr": "IS", "Value": [10]},
        "2428": {"vr": "IS", "Value": [8]},
        "2429": {"vr": "IS", "Value": [39]},
        "2430": {"vr": "IS", "Value": [42]},
        "2431": {"vr": "IS", "Value": [6]},
        "2432": {"vr": "IS", "Value": [48]},
        "2433": {"vr": "IS", "Value": [35]},
        "2434": {"vr": "IS", "Value": [49]},
        "2435": {"vr": "IS", "Value": [52]},
        "2436": {"vr": "IS", "Value": [20]},
        "2437": {"vr": "IS", "Value": [26]},
        "2438": {"vr": "IS", "Value": [16]},
        "2439": {"vr": "IS", "Value": [26]},
        "2440": {"vr": "IS", "Value": [32]},
        "2441": {"vr": "IS", "Value": [32]},
        "2442": {"vr": "IS", "Value": [58]},
        "2443": {"vr": "IS", "Value": [24]},
        "2444": {"vr": "IS", "Value": [14]},
        "2445": {"vr": "IS", "Value": [40]},
        "2446": {"vr": "IS", "Value": [15]},
        "2447": {"vr": "IS", "Value": [6]},
        "2448": {"vr": "IS", "Value": [14]},
        "2449": {"vr": "IS", "Value": [50]},
        "2450": {"vr": "IS", "Value": [25]},
        "2451": {"vr": "IS", "Value": [25]},
        "2452": {"vr": "IS", "Value": [25]},
        "2453": {"vr": "IS", "Value": [22]},
        "2454": {"vr": "IS", "Value": [27]},
        "2455": {"vr": "IS", "Value": [55]},
        "2456": {"vr": "IS", "Value": [47]},
        "2457": {"vr": "IS", "Value": [32]},
        "2458": {"vr": "IS", "Value": [16]},
        "2459": {"vr": "IS", "Value": [10]},
        "2460": {"vr": "IS", "Value": [31]},
        "2461": {"vr": "IS", "Value": [13]},
        "2462": {"vr": "IS", "Value": [43]},
        "2463": {"vr": "IS", "Value": [23]},
        "2464": {"vr": "IS", "Value": [20]},
        "2465": {"vr": "IS", "Value": [13]},
        "2466": {"vr": "IS", "Value": [54]},
        "2467": {"vr": "IS", "Value": [21]},
        "2468": {"vr": "IS", "Value": [17]},
        "2469": {"vr": "IS", "Value": [41]},
        "2470": {"vr": "IS", "Value": [8]},
        "2471": {"vr": "IS", "Value": [37]},
        "2472": {"vr": "IS", "Value": [29]},
        "2473": {"vr": "IS", "Value": [2]},
        "2474": {"vr": "IS", "Value": [54]},
        "2475": {"vr": "IS", "Value": [59]},
        "2476": {"vr": "IS", "Value": [36]},
        "2477": {"vr": "IS", "Value": [34]},
        "2478": {"vr": "IS", "Value": [28]},
        "2479": {"vr": "IS", "Value": [21]},
        "2480": {"vr": "IS", "Value": [55]},
        "2481": {"vr": "IS", "Value": [40]},
        "2482": {"vr": "IS", "Value": [4]},
        "2483": {"vr": "IS", "Value": [38]},
        "2484": {"vr": "IS", "Value": [53]},
        "2485": {"vr": "IS", "Value": [14]},
        "2486": {"vr": "IS", "Value": [45]},
        "2487": {"vr": "IS", "Value": [56]},
        "2488": {"vr": "IS", "Value": [52]},
        "2489": {"vr": "IS", "Value": [20]},
        "2490": {"vr": "IS", "Value": [30]},
        "2491": {"vr": "IS", "Value": [46]},
        "2492": {"vr": "IS", "Value": [30]},
        "2493": {"vr": "IS", "Value": [35]},
        "2494": {"vr": "IS", "Value": [50]},
        "2495": {"vr": "IS", "Value": [41]},
        "2496": {"vr": "IS", "Value": [21]},
        "2497": {"vr": "IS", "Value": [30]},
        "2498": {"vr": "IS", "Value": [24]},
        "2499": {"vr": "IS", "Value": [26]},
        "2500": {"vr": "IS", "Value": [40]},
        "2501": {"vr": "IS", "Value": [59]},
        "2502": {"vr": "IS", "Value": [16]},
        "2503": {"vr": "IS", "Value": [40]},
        "2504": {"vr": "IS", "Value": [23]},
        "2505": {"vr": "IS", "Value": [53]},
        "2506": {"vr": "IS", "Value": [0]},
        "2507": {"vr": "IS", "Value": [31]},
        "2508": {"vr": "IS", "Value": [44]},
        "2509": {"vr": "IS", "Value": [48]},
        "2510": {"vr": "IS", "Value": [58]},
        "2511": {"vr": "IS", "Value": [27]},
        "2512": {"vr": "IS", "Value": [39]},
        "2513": {"vr": "IS", "Value": [25]},
        "2514": {"vr": "IS", "Value": [5]},
        "2515": {"vr": "IS", "Value": [50]},
        "2516": {"vr": "IS", "Value": [25]},
        "2517": {"vr": "IS", "Value": [1]},
        "2518": {"vr": "IS", "Value": [25]},
        "2519": {"vr": "IS", "Value": [13]},
        "2520": {"vr": "IS", "Value": [0]},
        "2521": {"vr": "IS", "Value": [42]},
        "2522": {"vr": "IS", "Value": [23]},
        "2523": {"vr": "IS", "Value": [17]},
        "2524": {"vr": "IS", "Value": [26]},
        "2525": {"vr": "IS", "Value": [16]},
        "2526": {"vr": "IS", "Value": [21]},
        "2527": {"vr": "IS", "Value": [3]},
        "2528": {"vr": "IS", "Value": [50]},
        "2529": {"vr": "IS", "Value": [34]},
        "2530": {"vr": "IS", "Value": [54]},
        "2531": {"vr": "IS", "Value": [53]},
        "2532": {"vr": "IS", "Value": [33]},
        "2533": {"vr": "IS", "Value": [59]},
        "2534": {"vr": "IS", "Value": [54]},
        "2535": {"vr": "IS", "Value": [43]},
        "2536": {"vr": "IS", "Value": [52]},
        "2537": {"vr": "IS", "Value": [46]},
        "2538": {"vr": "IS", "Value": [3]},
        "2539": {"vr": "IS", "Value": [9]},
        "2540": {"vr": "IS", "Value": [11]},
        "2541": {"vr": "IS", "Value": [59]},
        "2542": {"vr": "IS", "Value": [12]},
        "2543": {"vr": "IS", "Value": [6]},
        "2544": {"vr": "IS", "Value": [48]},
        "2545": {"vr": "IS", "Value": [14]},
        "2546": {"vr": "IS", "Value": [25]},
        "2547": {"vr": "IS", "Value": [30]},
        "2548": {"vr": "IS", "Value": [27]},
        "2549": {"vr": "IS", "Value": [55]},
        "2550": {"vr": "IS", "Value": [19]},
        "2551": {"vr": "IS", "Value": [41]},
        "2552": {"vr": "IS", "Value": [37]},
        "2553": {"vr": "IS", "Value": [46]},
        "2554": {"vr": "IS", "Value": [36]},
        "2555": {"vr": "IS", "Value": [18]},
        "2556": {"vr": "IS", "Value": [55]},
        "2557": {"vr": "IS", "Value": [18]},
        "2558": {"vr": "IS", "Value": [56]},
        "2559": {"vr": "IS", "Value": [0]},
        "2560": {"vr": "IS", "Value": [35]},
        "2561": {"vr": "IS", "Value": [45]},
        "2562": {"vr": "IS", "Value": [13]},
        "2563": {"vr": "IS", "Value": [12]},
        "2564": {"vr": "IS", "Value": [39]},
        "2565": {"vr": "IS", "Value": [30]},
        "2566": {"vr": "IS", "Value": [36]},
        "2567": {"vr": "IS", "Value": [46]},
        "2568": {"vr": "IS", "Value": [9]},
        "2569": {"vr": "IS", "Value": [21]},
        "2570": {"vr": "IS", "Value": [28]},
        "2571": {"vr": "IS", "Value": [10]},
        "2572": {"vr": "IS", "Value": [52]},
        "2573": {"vr": "IS", "Value": [37]},
        "2574": {"vr": "IS", "Value": [19]},
        "2575": {"vr": "IS", "Value": [8]},
        "2576": {"vr": "IS", "Value": [55]},
        "2577": {"vr": "IS", "Value": [43]},
        "2578": {"vr": "IS", "Value": [21]},
        "2579": {"vr": "IS", "Value": [9]},
        "2580": {"vr": "IS", "Value": [40]},
        "2581": {"vr": "IS", "Value": [10]},
        "2582": {"vr": "IS", "Value": [56]},
        "2583": {"vr": "IS", "Value": [26]},
        "2584": {"vr": "IS", "Value": [32]},
        "2585": {"vr": "IS", "Value": [50]},
        "2586": {"vr": "IS", "Value": [58]},
        "2587": {"vr": "IS", "Value": [8]},
        "2588": {"vr": "IS", "Value": [26]},
        "2589": {"vr": "IS", "Value": [30]},
        "2590": {"vr": "IS", "Value": [42]},
        "2591": {"vr": "IS", "Value": [17]},
        "2592": {"vr": "IS", "Value": [34]},
        "2593": {"vr": "IS", "Value": [58]},
        "2594": {"vr": "IS", "Value": [9]},
        "2595": {"vr": "IS", "Value": [13]},
        "2596": {"vr": "IS", "Value": [56]},
        "2597": {"vr": "IS", "Value": [53]},
        "2598": {"vr": "IS", "Value": [11]},
        "2599": {"vr": "IS", "Value": [8]},
        "2600": {"vr": "IS", "Value": [37]},
        "2601": {"vr": "IS", "Value": [41]},
        "2602": {"vr": "IS", "Value": [42]},
        "2603": {"vr": "IS", "Value": [45]},
        "2604": {"vr": "IS", "Value": [30]},
        "2605": {"vr": "IS", "Value": [42]},
        "2606": {"vr": "IS", "Value": [27]},
        "2607": {"vr": "IS", "Value": [52]},
        "2608": {"vr": "IS", "Value": [5]},
        "2609": {"vr": "IS", "Value": [13]},
        "2610": {"vr": "IS", "Value": [36]},
        "2611": {"vr": "IS", "Value": [37]},
        "2612": {"vr": "IS", "Value": [37]},
        "2613": {"vr": "IS", "Value": [39]},
        "2614": {"vr": "IS", "Value": [39]},
        "2615": {"vr": "IS", "Value": [8]},
        "2616": {"vr": "IS", "Value": [17]},
        "2617": {"vr": "IS", "Value": [34]},
        "2618": {"vr": "IS", "Value": [6]},
        "2619": {"vr": "IS", "Value": [36]},
        "2620": {"vr": "IS", "Value": [4]},
        "2621": {"vr": "IS", "Value": [15]},
        "2622": {"vr": "IS", "Value": [27]},
        "2623": {"vr": "IS", "Value": [19]},
        "2624": {"vr": "IS", "Value": [11]},
        "2625": {"vr": "IS", "Value": [37]},
        "2626": {"vr": "IS", "Value": [39]},
        "2627": {"vr": "IS", "Value": [48]},
        "2628": {"vr": "IS", "Value": [21]},
        "2629": {"vr": "IS", "Value": [44]},
        "2630": {"vr": "IS", "Value": [7]},
        "2631": {"vr": "IS", "Value": [44]},
        "2632": {"vr": "IS", "Value": [49]},
        "2633": {"vr": "IS", "Value": [28]},
        "2634": {"vr": "IS", "Value": [50]},
        "2635": {"vr": "IS", "Value": [35]},
        "2636": {"vr": "IS", "Value": [4]},
        "2637": {"vr": "IS", "Value": [30]},
        "2638": {"vr": "IS", "Value": [31]},
        "2639": {"vr": "IS", "Value": [33]},
        "2640": {"vr": "IS", "Value": [30]},
        "2641": {"vr": "IS", "Value": [1]},
        "2642": {"vr": "IS", "Value": [12]},
        "2643": {"vr": "IS", "Value": [4]},
        "2644": {"vr": "IS", "Value": [9]},
        "2645": {"vr": "IS", "Value": [20]},
        "2646": {"vr": "IS", "Value": [34]},
        "2647": {"vr": "IS", "Value": [9]},
        "2648": {"vr": "IS", "Value": [55]},
        "2649": {"vr": "IS", "Value": [2]},
        "2650": {"vr": "IS", "Value": [6]},
        "2651": {"vr": "IS", "Value": [56]},
        "2652": {"vr": "IS", "Value": [9]},
        "2653": {"vr": "IS", "Value": [42]},
        "2654": {"vr": "IS", "Value": [31]},
        "2655": {"vr": "IS", "Value": [44]},
        "2656": {"vr": "IS", "Value": [44]},
        "2657": {"vr": "IS", "Value": [8]},
        "2658": {"vr": "IS", "Value": [44]},
        "2659": {"vr": "IS", "Value": [8]},
        "2660": {"vr": "IS", "Value": [39]},
        "2661": {"vr": "IS", "Value": [57]},
        "2662": {"vr": "IS", "Value": [41]},
        "2663": {"vr": "IS", "Value": [16]},
        "2664": {"vr": "IS", "Value": [25]},
        "2665": {"vr": "IS", "Value": [56]},
        "2666": {"vr": "IS", "Value": [23]},
        "2667": {"vr": "IS", "Value": [31]},
        "2668": {"vr": "IS", "Value": [57]},
        "2669": {"vr": "IS", "Value": [8]},
        "2670": {"vr": "IS", "Value": [45]},
        "2671": {"vr": "IS", "Value": [7]},
        "2672": {"vr": "IS", "Value": [56]},
        "2673": {"vr": "IS", "Value": [6]},
        "2674": {"vr": "IS", "Value": [50]},
        "2675": {"vr": "IS", "Value": [42]},
        "2676": {"vr": "IS", "Value": [19]},
        "2677": {"vr": "IS", "Value": [36]},
        "2678": {"vr": "IS", "Value": [11]},
        "2679": {"vr": "IS", "Value": [30]},
        "2680": {"vr": "IS", "Value": [58]},
        "2681": {"vr": "IS", "Value": [24]},
        "2682": {"vr": "IS", "Value": [36]},
        "2683": {"vr": "IS", "Value": [39]},
        "2684": {"vr": "IS", "Value": [22]},
        "2685": {"vr": "IS", "Value": [38]},
        "2686": {"vr": "IS", "Value": [43]},
        "2687": {"vr": "IS", "Value": [44]},
        "2688": {"vr": "IS", "Value": [27]},
        "2689": {"vr": "IS", "Value": [28]},
        "2690": {"vr": "IS", "Value": [41]},
        "2691": {"vr": "IS", "Value": [10]},
        "2692": {"vr": "IS", "Value": [24]},
        "2693": {"vr": "IS", "Value": [37]},
        "2694": {"vr": "IS", "Value": [48]},
        "2695": {"vr": "IS", "Value": [2]},
        "2696": {"vr": "IS", "Value": [41]},
        "2697": {"vr": "IS", "Value": [59]},
        "2698": {"vr": "IS", "Value": [49]},
        "2699": {"vr": "IS", "Value": [23]},
        "2700": {"vr": "IS", "Value": [5]},
        "2701": {"vr": "IS", "Value": [35]},
        "2702": {"vr": "IS", "Value": [56]},
        "2703": {"vr": "IS", "Value": [33]},
        "2704": {"vr": "IS", "Value": [12]},
        "2705": {"vr": "IS", "Value": [23]},
        "2706": {"vr": "IS", "Value": [48]},
        "2707": {"vr": "IS", "Value": [4]},
        "2708": {"vr": "IS", "Value": [9]},
        "2709": {"vr": "IS", "Value": [46]},
        "2710": {"vr": "IS", "Value": [5]},
        "2711": {"vr": "IS", "Value": [10]},
        "2712": {"vr": "IS", "Value": [21]},
        "2713": {"vr": "IS", "Value": [47]},
        "2714": {"vr": "IS", "Value": [58]},
        "2715": {"vr": "IS", "Value": [48]},
        "2716": {"vr": "IS", "Value": [10]},
        "2717": {"vr": "IS", "Value": [29]},
        "2718": {"vr": "IS", "Value": [10]},
        "2719": {"vr": "IS", "Value": [35]},
        "2720": {"vr": "IS", "Value": [1]},
        "2721": {"vr": "IS", "Value": [37]},
        "2722": {"vr": "IS", "Value": [38]},
        "2723": {"vr": "IS", "Value": [15]},
        "2724": {"vr": "IS", "Value": [12]},
        "2725": {"vr": "IS", "Value": [15]},
        "2726": {"vr": "IS", "Value": [39]},
        "2727": {"vr": "IS", "Value": [38]},
        "2728": {"vr": "IS", "Value": [22]},
        "2729": {"vr": "IS", "Value": [56]},
        "2730": {"vr": "IS", "Value": [14]},
        "2731": {"vr": "IS", "Value": [57]},
        "2732": {"vr": "IS", "Value": [27]},
        "2733": {"vr": "IS", "Value": [14]},
        "2734": {"vr": "IS", "Value": [54]},
        "2735": {"vr": "IS", "Value": [49]},
        "2736": {"vr": "IS", "Value": [18]},
        "2737": {"vr": "IS", "Value": [7]},
        "2738": {"vr": "IS", "Value": [8]},
        "2739": {"vr": "IS", "Value": [51]},
        "2740": {"vr": "IS", "Value": [34]},
        "2741": {"vr": "IS", "Value": [37]},
        "2742": {"vr": "IS", "Value": [37]},
        "2743": {"vr": "IS", "Value": [24]},
        "2744": {"vr": "IS", "Value": [25]},
        "2745": {"vr": "IS", "Value": [49]},
        "2746": {"vr": "IS", "Value": [43]},
        "2747": {"vr": "IS", "Value": [31]},
        "2748": {"vr": "IS", "Value": [52]},
        "2749": {"vr": "IS", "Value": [52]},
        "2750": {"vr": "IS", "Value": [19]},
        "2751": {"vr": "IS", "Value": [21]},
        "2752": {"vr": "IS", "Value": [0]},
        "2753": {"vr": "IS", "Value": [28]},
        "2754": {"vr": "IS", "Value": [57]},
        "2755": {"vr": "IS", "Value": [40]},
        "2756": {"vr": "IS", "Value": [57]},
        "2757": {"vr": "IS", "Value": [43]},
        "2758": {"vr": "IS", "Value": [5]},
        "2759": {"vr": "IS", "Value": [31]},
        "2760": {"vr": "IS", "Value": [41]},
        "2761": {"vr": "IS", "Value": [48]},
        "2762": {"vr": "IS", "Value": [15]},
        "2763": {"vr": "IS", "Value": [54]},
        "2764": {"vr": "IS", "Value": [45]},
        "2765": {"vr": "IS", "Value": [3]},
        "2766": {"vr": "IS", "Value": [12]},
        "2767": {"vr": "IS", "Value": [27]},
        "2768": {"vr": "IS", "Value": [29]},
        "2769": {"vr": "IS", "Value": [8]},
        "2770": {"vr": "IS", "Value": [23]},
        "2771": {"vr": "IS", "Value": [57]},
        "2772": {"vr": "IS", "Value": [11]},
        "2773": {"vr": "IS", "Value": [10]},
        "2774": {"vr": "IS", "Value": [3]},
        "2775": {"vr": "IS", "Value": [19]},
        "2776": {"vr": "IS", "Value": [24]},
        "2777": {"vr": "IS", "Value": [16]},
        "2778": {"vr": "IS", "Value": [19]},
        "2779": {"vr": "IS", "Value": [26]},
        "2780": {"vr": "IS", "Value": [54]},
        "2781": {"vr": "IS", "Value": [31]},
        "2782": {"vr": "IS", "Value": [46]},
        "2783": {"vr": "IS", "Value": [55]},
        "2784": {"vr": "IS", "Value": [58]},
        "2785": {"vr": "IS", "Value": [11]},
        "2786": {"vr": "IS", "Value": [19]},
        "2787": {"vr": "IS", "Value": [33]},
        "2788": {"vr": "IS", "Value": [2]},
        "2789": {"vr": "IS", "Value": [23]},
        "2790": {"vr": "IS", "Value": [39]},
        "2791": {"vr": "IS", "Value": [11]},
        "2792": {"vr": "IS", "Value": [37]},
        "2793": {"vr": "IS", "Value": [1]},
        "2794": {"vr": "IS", "Value": [23]},
        "2795": {"vr": "IS", "Value": [0]},
        "2796": {"vr": "IS", "Value": [56]},
        "2797": {"vr": "IS", "Value": [42]},
        "2798": {"vr": "IS", "Value": [14]},
        "2799": {"vr": "IS", "Value": [5]},
        "2800": {"vr": "IS", "Value": [21]},
        "2801": {"vr": "IS", "Value": [59]},
        "2802": {"vr": "IS", "Value": [7]},
        "2803": {"vr": "IS", "Value": [25]},
        "2804": {"vr": "IS", "Value": [8]},
        "2805": {"vr": "IS", "Value": [57]},
        "2806": {"vr": "IS", "Value": [3]},
        "2807": {"vr": "IS", "Value": [45]},
        "2808": {"vr": "IS", "Value": [47]},
        "2809": {"vr": "IS", "Value": [1]},
        "2810": {"vr": "IS", "Value": [42]},
        "2811": {"vr": "IS", "Value": [56]},
        "2812": {"vr": "IS", "Value": [35]},
        "2813": {"vr": "IS", "Value": [14]},
        "2814": {"vr": "IS", "Value": [10]},
        "2815": {"vr": "IS", "Value": [53]},
        "2816": {"vr": "IS", "Value": [27]},
        "2817": {"vr": "IS", "Value": [27]},
        "2818": {"vr": "IS", "Value": [47]},
        "2819": {"vr": "IS", "Value": [7]},
        "2820": {"vr": "IS", "Value": [25]},
        "2821": {"vr": "IS", "Value": [43]},
        "2822": {"vr": "IS", "Value": [3]},
        "2823": {"vr": "IS", "Value": [50]},
        "2824": {"vr": "IS", "Value": [58]},
        "2825": {"vr": "IS", "Value": [48]},
        "2826": {"vr": "IS", "Value": [21]},
        "2827": {"vr": "IS", "Value": [55]},
        "2828": {"vr": "IS", "Value": [57]},
        "2829": {"vr": "IS", "Value": [3]},
        "2830": {"vr": "IS", "Value": [54]},
        "2831": {"vr": "IS", "Value": [46]},
        "2832": {"vr": "IS", "Value": [6]},
        "2833": {"vr": "IS", "Value": [55]},
        "2834": {"vr": "IS", "Value": [26]},
        "2835": {"vr": "IS", "Value": [17]},
        "2836": {"vr": "IS", "Value": [36]},
        "2837": {"vr": "IS", "Value": [22]},
        "2838": {"vr": "IS", "Value": [22]},
        "2839": {"vr": "IS", "Value": [18]},
        "2840": {"vr": "IS", "Value": [4]},
        "2841": {"vr": "IS", "Value": [35]},
        "2842": {"vr": "IS", "Value": [30]},
        "2843": {"vr": "IS", "Value": [48]},
        "2844": {"vr": "IS", "Value": [28]},
        "2845": {"vr": "IS", "Value": [7]},
        "2846": {"vr": "IS", "Value": [44]},
        "2847": {"vr": "IS", "Value": [16]},
        "2848": {"vr": "IS", "Value": [56]},
        "2849": {"vr": "IS", "Value": [53]},
        "2850": {"vr": "IS", "Value": [30]},
        "2851": {"vr": "IS", "Value": [17]},
        "2852": {"vr": "IS", "Value": [5]},
        "2853": {"vr": "IS", "Value": [9]},
        "2854": {"vr": "IS", "Value": [7]},
        "2855": {"vr": "IS", "Value": [7]},
        "2856": {"vr": "IS", "Value": [39]},
        "2857": {"vr": "IS", "Value": [47]},
        "2858": {"vr": "IS", "Value": [6]},
        "2859": {"vr": "IS", "Value": [24]},
        "2860": {"vr": "IS", "Value": [55]},
        "2861": {"vr": "IS", "Value": [53]},
        "2862": {"vr": "IS", "Value": [18]},
        "2863": {"vr": "IS", "Value": [37]},
        "2864": {"vr": "IS", "Value": [33]},
        "2865": {"vr": "IS", "Value": [38]},
        "2866": {"vr": "IS", "Value": [8]},
        "2867": {"vr": "IS", "Value": [56]},
        "2868": {"vr": "IS", "Value": [33]},
        "2869": {"vr": "IS", "Value": [25]},
        "2870": {"vr": "IS", "Value": [54]},
        "2871": {"vr": "IS", "Value": [43]},
        "2872": {"vr": "IS", "Value": [51]},
        "2873": {"vr": "IS", "Value": [31]},
        "2874": {"vr": "IS", "Value": [36]},
        "2875": {"vr": "IS", "Value": [24]},
        "2876": {"vr": "IS", "Value": [45]},
        "2877": {"vr": "IS", "Value": [35]},
        "2878": {"vr": "IS", "Value": [9]},
        "2879": {"vr": "IS", "Value": [10]},
        "2880": {"vr": "IS", "Value": [15]},
        "2881": {"vr": "IS", "Value": [20]},
        "2882": {"vr": "IS", "Value": [45]},
        "2883": {"vr": "IS", "Value": [36]},
        "2884": {"vr": "IS", "Value": [15]},
        "2885": {"vr": "IS", "Value": [25]},
        "2886": {"vr": "IS", "Value": [7]},
        "2887": {"vr": "IS", "Value": [3]},
        "2888": {"vr": "IS", "Value": [57]},
        "2889": {"vr": "IS", "Value": [17]},
        "2890": {"vr": "IS", "Value": [50]},
        "2891": {"vr": "IS", "Value": [41]},
        "2892": {"vr": "IS", "Value": [11]},
        "2893": {"vr": "IS", "Value": [20]},
        "2894": {"vr": "IS", "Value": [58]},
        "2895": {"vr": "IS", "Value": [22]},
        "2896": {"vr": "IS", "Value": [44]},
        "2897": {"vr": "IS", "Value": [5]},
        "2898": {"vr": "IS", "Value": [22]},
        "2899": {"vr": "IS", "Value": [44]},
        "2900": {"vr": "IS", "Value": [43]},
        "2901": {"vr": "IS", "Value": [27]},
        "2902": {"vr": "IS", "Value": [19]},
        "2903": {"vr": "IS", "Value": [37]},
        "2904": {"vr": "IS", "Value": [4]},
        "2905": {"vr": "IS", "Value": [7]},
        "2906": {"vr": "IS", "Value": [21]},
        "2907": {"vr": "IS", "Value": [13]},
        "2908": {"vr": "IS", "Value": [6]},
        "2909": {"vr": "IS", "Value": [37]},
        "2910": {"vr": "IS", "Value": [5]},
        "2911": {"vr": "IS", "Value": [9]},
        "2912": {"vr": "IS", "Value": [30]},
        "2913": {"vr": "IS", "Value": [8]},
        "2914": {"vr": "IS", "Value": [35]},
        "2915": {"vr": "IS", "Value": [51]},
        "2916": {"vr": "IS", "Value": [23]},
        "2917": {"vr": "IS", "Value": [58]},
        "2918": {"vr": "IS", "Value": [12]},
        "2919": {"vr": "IS", "Value": [28]},
        "2920": {"vr": "IS", "Value": [44]},
        "2921": {"vr": "IS", "Value": [45]},
        "2922": {"vr": "IS", "Value": [54]},
        "2923": {"vr": "IS", "Value": [39]},
        "2924": {"vr": "IS", "Value": [9]},
        "2925": {"vr": "IS", "Value": [59]},
        "2926": {"vr": "IS", "Value": [23]},
        "2927": {"vr": "IS", "Value": [32]},
        "2928": {"vr": "IS", "Value": [25]},
        "2929": {"vr": "IS", "Value": [42]},
        "2930": {"vr": "IS", "Value": [2]},
        "2931": {"vr": "IS", "Value": [14]},
        "2932": {"vr": "IS", "Value": [12]},
        "2933": {"vr": "IS", "Value": [37]},
        "2934": {"vr": "IS", "Value": [3]},
        "2935": {"vr": "IS", "Value": [56]},
        "2936": {"vr": "IS", "Value": [59]},
        "2937": {"vr": "IS", "Value": [7]},
        "2938": {"vr": "IS", "Value": [37]},
        "2939": {"vr": "IS", "Value": [27]},
        "2940": {"vr": "IS", "Value": [43]},
        "2941": {"vr": "IS", "Value": [41]},
        "2942": {"vr": "IS", "Value": [26]},
        "2943": {"vr": "IS", "Value": [44]},
        "2944": {"vr": "IS", "Value": [44]},
        "2945": {"vr": "IS", "Value": [36]},
        "2946": {"vr": "IS", "Value": [13]},
        "2947": {"vr": "IS", "Value": [43]},
        "2948": {"vr": "IS", "Value": [51]},
        "2949": {"vr": "IS", "Value": [6]},
        "2950": {"vr": "IS", "Value": [52]},
        "2951": {"vr": "IS", "Value": [19]},
        "2952": {"vr": "IS", "Value": [38]},
        "2953": {"vr": "IS", "Value": [55]},
        "2954": {"vr": "IS", "Value": [20]},
        "2955": {"vr": "IS", "Value": [52]},
        "2956": {"vr": "IS", "Value": [28]},
        "2957": {"vr": "IS", "Value": [20]},
        "2958": {"vr": "IS", "Value": [55]},
        "2959": {"vr": "IS", "Value": [43]},
        "2960": {"vr": "IS", "Value": [23]},
        "2961": {"vr": "IS", "Value": [3]},
        "2962": {"vr": "IS", "Value": [48]},
        "2963": {"vr": "IS", "Value": [25]},
        "2964": {"vr": "IS", "Value": [27]},
        "2965": {"vr": "IS", "Value": [43]},
        "2966": {"vr": "IS", "Value": [49]},
        "2967": {"vr": "IS", "Value": [21]},
        "2968": {"vr": "IS", "Value": [34]},
        "2969": {"vr": "IS", "Value": [25]},
        "2970": {"vr": "IS", "Value": [34]},
        "2971": {"vr": "IS", "Value": [45]},
        "2972": {"vr": "IS", "Value": [20]},
        "2973": {"vr": "IS", "Value": [21]},
        "2974": {"vr": "IS", "Value": [43]},
        "2975": {"vr": "IS", "Value": [27]},
        "2976": {"vr": "IS", "Value": [18]},
        "2977": {"vr": "IS", "Value": [43]},
        "2978": {"vr": "IS", "Value": [43]},
        "2979": {"vr": "IS", "Value": [57]},
        "2980": {"vr": "IS", "Value": [23]},
        "2981": {"vr": "IS", "Value": [19]},
        "2982": {"vr": "IS", "Value": [38]},
        "2983": {"vr": "IS", "Value": [38]},
        "2984": {"vr": "IS", "Value": [5]},
        "2985": {"vr": "IS", "Value": [54]},
        "2986": {"vr": "IS", "Value": [40]},
        "2987": {"vr": "IS", "Value": [0]},
        "2988": {"vr": "IS", "Value": [31]},
        "2989": {"vr": "IS", "Value": [2]},
        "2990": {"vr": "IS", "Value": [1]},
        "2991": {"vr": "IS", "Value": [20]},
        "2992": {"vr": "IS", "Value": [33]},
        "2993": {"vr": "IS", "Value": [49]},
        "2994": {"vr": "IS", "Value": [41]},
        "2995": {"vr": "IS", "Value": [58]},
        "2996": {"vr": "IS", "Value": [35]},
        "2997": {"vr": "IS", "Value": [42]},
        "2998": {"vr": "IS", "Value": [37]},
        "2999": {"vr": "IS", "Value": [2]},
        "3000": {"vr": "IS", "Value": [27]},
        "3001": {"vr": "IS", "Value": [28]},
        "3002": {"vr": "IS", "Value": [36]},
        "3003": {"vr": "IS", "Value": [46]},
        "3004": {"vr": "IS", "Value": [12]},
        "3005": {"vr": "IS", "Value": [19]},
        "3006": {"vr": "IS", "Value": [0]},
        "3007": {"vr": "IS", "Value": [39]},
        "3008": {"vr": "IS", "Value": [4]},
        "3009": {"vr": "IS", "Value": [41]},
        "3010": {"vr": "IS", "Value": [32]},
        "3011": {"vr": "IS", "Value": [17]},
        "3012": {"vr": "IS", "Value": [42]},
        "3013": {"vr": "IS", "Value": [26]},
        "3014": {"vr": "IS", "Value": [2]},
        "3015": {"vr": "IS", "Value": [41]},
        "3016": {"vr": "IS", "Value": [20]},
        "3017": {"vr": "IS", "Value": [22]},
        "3018": {"vr": "IS", "Value": [33]},
        "3019": {"vr": "IS", "Value": [36]},
        "3020": {"vr": "IS", "Value": [14]},
        "3021": {"vr": "IS", "Value": [4]},
        "3022": {"vr": "IS", "Value": [18]},
        "3023": {"vr": "IS", "Value": [3]},
        "3024": {"vr": "IS", "Value": [37]},
        "3025": {"vr": "IS", "Value": [0]},
        "3026": {"vr": "IS", "Value": [22]},
        "3027": {"vr": "IS", "Value": [15]},
        "3028": {"vr": "IS", "Value": [13]},
        "3029": {"vr": "IS", "Value": [44]},
        "3030": {"vr": "IS", "Value": [35]},
        "3031": {"vr": "IS", "Value": [51]},
        "3032": {"vr": "IS", "Value": [44]},
        "3033": {"vr": "IS", "Value": [13]},
        "3034": {"vr": "IS", "Value": [5]},
        "3035": {"vr": "IS", "Value": [2]},
        "3036": {"vr": "IS", "Value": [45]},
        "3037": {"vr": "IS", "Value": [12]},
        "3038": {"vr": "IS", "Value": [8]},
        "3039": {"vr": "IS", "Value": [2]},
        "3040": {"vr": "IS", "Value": [12]},
        "3041": {"vr": "IS", "Value": [20]},
        "3042": {"vr": "IS", "Value": [6]},
        "3043": {"vr": "IS", "Value": [40]},
        "3044": {"vr": "IS", "Value": [10]},
        "3045": {"vr": "IS", "Value": [37]},
        "3046": {"vr": "IS", "Value": [13]},
        "3047": {"vr": "IS", "Value": [33]},
        "3048": {"vr": "IS", "Value": [4]},
        "3049": {"vr": "IS", "Value": [49]},
        "3050": {"vr": "IS", "Value": [50]},
        "3051": {"vr": "IS", "Value": [6]},
        "3052": {"vr": "IS", "Value": [36]},
        "3053": {"vr": "IS", "Value": [1]},
        "3054": {"vr": "IS", "Value": [16]},
        "3055": {"vr": "IS", "Value": [34]},
        "3056": {"vr": "IS", "Value": [28]},
        "3057": {"vr": "IS", "Value": [1]},
        "3058": {"vr": "IS", "Value": [52]},
        "3059": {"vr": "IS", "Value": [56]},
        "3060": {"vr": "IS", "Value": [34]},
        "3061": {"vr": "IS", "Value": [57]},
        "3062": {"vr": "IS", "Value": [28]},
        "3063": {"vr": "IS", "Value": [21]},
        "3064": {"vr": "IS", "Value": [6]},
        "3065": {"vr": "IS", "Value": [25]},
        "3066": {"vr": "IS", "Value": [36]},
        "3067": {"vr": "IS", "Value": [42]},
        "3068": {"vr": "IS", "Value": [6]},
        "3069": {"vr": "IS", "Value": [9]},
        "3070": {"vr": "IS", "Value": [3]},
        "3071": {"vr": "IS", "Value": [12]},
        "3072": {"vr": "IS", "Value": [22]},
        "3073": {"vr": "IS", "Value": [57]},
        "3074": {"vr": "IS", "Value": [11]},
        "3075": {"vr": "IS", "Value": [45]},
        "3076": {"vr": "IS", "Value": [21]},
        "3077": {"vr": "IS", "Value": [39]},
        "3078": {"vr": "IS", "Value": [47]},
        "3079": {"vr": "IS", "Value": [40]},
        "3080": {"vr": "IS", "Value": [23]},
        "3081": {"vr": "IS", "Value": [40]},
        "3082": {"vr": "IS", "Value": [7]},
        "3083": {"vr": "IS", "Value": [22]},
        "3084": {"vr": "IS", "Value": [29]},
        "3085": {"vr": "IS", "Value": [20]},
        "3086": {"vr": "IS", "Value": [19]},
        "3087": {"vr": "IS", "Value": [2]},
        "3088": {"vr": "IS", "Value": [6]},
        "3089": {"vr": "IS", "Value": [39]},
        "3090": {"vr": "IS", "Value": [1]},
        "3091": {"vr": "IS", "Value": [28]},
        "3092": {"vr": "IS", "Value": [8]},
        "3093": {"vr": "IS", "Value": [33]},
        "3094": {"vr": "IS", "Value": [49]},
        "3095": {"vr": "IS", "Value": [5]},
        "3096": {"vr": "IS", "Value": [7]},
        "3097": {"vr": "IS", "Value": [3]},
        "3098": {"vr": "IS", "Value": [35]},
        "3099": {"vr": "IS", "Value": [44]},
        "3100": {"vr": "IS", "Value": [11]},
        "3101": {"vr": "IS", "Value": [12]},
        "3102": {"vr": "IS", "Value": [45]},
        "3103": {"vr": "IS", "Value": [35]},
        "3104": {"vr": "IS", "Value": [15]},
        "3105": {"vr": "IS", "Value": [54]},
        "3106": {"vr": "IS", "Value": [40]},
        "3107": {"vr": "IS", "Value": [56]},
        "3108": {"vr": "IS", "Value": [20]},
        "3109": {"vr": "IS", "Value": [19]},
        "3110": {"vr": "IS", "Value": [26]},
        "3111": {"vr": "IS", "Value": [16]},
        "3112": {"vr": "IS", "Value": [42]},
        "3113": {"vr": "IS", "Value": [59]},
        "3114": {"vr": "IS", "Value": [45]},
        "3115": {"vr": "IS", "Value": [47]},
        "3116": {"vr": "IS", "Value": [1]},
        "3117": {"vr": "IS", "Value": [12]},
        "3118": {"vr": "IS", "Value": [38]},
        "3119": {"vr": "IS", "Value": [44]},
        "3120": {"vr": "IS", "Value": [45]},
        "3121": {"vr": "IS", "Value": [58]},
        "3122": {"vr": "IS", "Value": [33]},
        "3123": {"vr": "IS", "Value": [52]},
        "3124": {"vr": "IS", "Value": [13]},
        "3125": {"vr": "IS", "Value": [39]},
        "3126": {"vr": "IS", "Value": [15]},
        "3127": {"vr": "IS", "Value": [28]},
        "3128": {"vr": "IS", "Value": [51]},
        "3129": {"vr": "IS", "Value": [46]},
        "3130": {"vr": "IS", "Value": [31]},
        "3131": {"vr": "IS", "Value": [7]},
        "3132": {"vr": "IS", "Value": [14]},
        "3133": {"vr": "IS", "Value": [28]},
        "3134": {"vr": "IS", "Value": [11]},
        "3135": {"vr": "IS", "Value": [17]},
        "3136": {"vr": "IS", "Value": [15]},
        "3137": {"vr": "IS", "Value": [23]},
        "3138": {"vr": "IS", "Value": [7]},
        "3139": {"vr": "IS", "Value": [34]},
        "3140": {"vr": "IS", "Value": [5]},
        "3141": {"vr": "IS", "Value": [6]},
        "3142": {"vr": "IS", "Value": [5]},
        "3143": {"vr": "IS", "Value": [32]},
        "3144": {"vr": "IS", "Value": [47]},
        "3145": {"vr": "IS", "Value": [3]},
        "3146": {"vr": "IS", "Value": [44]},
        "3147": {"vr": "IS", "Value": [32]},
        "3148": {"vr": "IS", "Value": [38]},
        "3149": {"vr": "IS", "Value": [59]},
        "3150": {"vr": "IS", "Value": [0]},
        "3151": {"vr": "IS", "Value": [47]},
        "3152": {"vr": "IS", "Value": [45]},
        "3153": {"vr": "IS", "Value": [46]},
        "3154": {"vr": "IS", "Value": [1]},
        "3155": {"vr": "IS", "Value": [42]},
        "3156": {"vr": "IS", "Value": [1]},
        "3157": {"vr": "IS", "Value": [52]},
        "3158": {"vr": "IS", "Value": [21]},
        "3159": {"vr": "IS", "Value": [12]},
        "3160": {"vr": "IS", "Value": [40]},
        "3161": {"vr": "IS", "Value": [46]},
        "3162": {"vr": "IS", "Value": [16]},
        "3163": {"vr": "IS", "Value": [18]},
        "3164": {"vr": "IS", "Value": [43]},
        "3165": {"vr": "IS", "Value": [23]},
        "3166": {"vr": "IS", "Value": [19]},
        "3167": {"vr": "IS", "Value": [29]},
        "3168": {"vr": "IS", "Value": [14]},
        "3169": {"vr": "IS", "Value": [56]},
        "3170": {"vr": "IS", "Value": [56]},
        "3171": {"vr": "IS", "Value": [39]},
        "3172": {"vr": "IS", "Value": [22]},
        "3173": {"vr": "IS", "Value": [59]},
        "3174": {"vr": "IS", "Value": [56]},
        "3175": {"vr": "IS", "Value": [34]},
        "3176": {"vr": "IS", "Value": [50]},
        "3177": {"vr": "IS", "Value": [5]},
        "3178": {"vr": "IS", "Value": [53]},
        "3179": {"vr": "IS", "Value": [0]},
        "3180": {"vr": "IS", "Value": [5]},
        "3181": {"vr": "IS", "Value": [23]},
        "3182": {"vr": "IS", "Value": [30]},
        "3183": {"vr": "IS", "Value": [26]},
        "3184": {"vr": "IS", "Value": [4]},
        "3185": {"vr": "IS", "Value": [41]},
        "3186": {"vr": "IS", "Value": [17]},
        "3187": {"vr": "IS", "Value": [27]},
        "3188": {"vr": "IS", "Value": [47]},
        "3189": {"vr": "IS", "Value": [59]},
        "3190": {"vr": "IS", "Value": [19]},
        "3191": {"vr": "IS", "Value": [47]},
        "3192": {"vr": "IS", "Value": [59]},
        "3193": {"vr": "IS", "Value": [49]},
        "3194": {"vr": "IS", "Value": [44]},
        "3195": {"vr": "IS", "Value": [9]},
        "3196": {"vr": "IS", "Value": [39]},
        "3197": {"vr": "IS", "Value": [1]},
        "3198": {"vr": "IS", "Value": [18]},
        "3199": {"vr": "IS", "Value": [21]},
        "3200": {"vr": "IS", "Value": [32]},
        "3201": {"vr": "IS", "Value": [22]},
        "3202": {"vr": "IS", "Value": [17]},
        "3203": {"vr": "IS", "Value": [56]},
        "3204": {"vr": "IS", "Value": [13]},
        "3205": {"vr": "IS", "Value": [26]},
        "3206": {"vr": "IS", "Value": [20]},
        "3207": {"vr": "IS", "Value": [9]},
        "3208": {"vr": "IS", "Value": [37]},
        "3209": {"vr": "IS", "Value": [54]},
        "3210": {"vr": "IS", "Value": [13]},
        "3211": {"vr": "IS", "Value": [45]},
        "3212": {"vr": "IS", "Value": [57]},
        "3213": {"vr": "IS", "Value": [29]},
        "3214": {"vr": "IS", "Value": [59]},
        "3215": {"vr": "IS", "Value": [30]},
        "3216": {"vr": "IS", "Value": [57]},
        "3217": {"vr": "IS", "Value": [14]},
        "3218": {"vr": "IS", "Value": [0]},
        "3219": {"vr": "IS", "Value": [39]},
        "3220": {"vr": "IS", "Value": [47]},
        "3221": {"vr": "IS", "Value": [32]},
        "3222": {"vr": "IS", "Value": [2]},
        "3223": {"vr": "IS", "Value": [4]},
        "3224": {"vr": "IS", "Value": [59]},
        "3225": {"vr": "IS", "Value": [24]},
        "3226": {"vr": "IS", "Value": [45]},
        "3227": {"vr": "IS", "Value": [31]},
        "3228": {"vr": "IS", "Value": [12]},
        "3229": {"vr": "IS", "Value": [13]},
        "3230": {"vr": "IS", "Value": [6]},
        "3231": {"vr": "IS", "Value": [19]},
        "3232": {"vr": "IS", "Value": [17]},
        "3233": {"vr": "IS", "Value": [11]},
        "3234": {"vr": "IS", "Value": [27]},
        "3235": {"vr": "IS", "Value": [43]},
        "3236": {"vr": "IS", "Value": [23]},
        "3237": {"vr": "IS", "Value": [57]},
        "3238": {"vr": "IS", "Value": [51]},
        "3239": {"vr": "IS", "Value": [25]},
        "3240": {"vr": "IS", "Value": [18]},
        "3241": {"vr": "IS", "Value": [41]},
        "3242": {"vr": "IS", "Value": [20]},
        "3243": {"vr": "IS", "Value": [40]},
        "3244": {"vr": "IS", "Value": [33]},
        "3245": {"vr": "IS", "Value": [6]},
        "3246": {"vr": "IS", "Value": [4]},
        "3247": {"vr": "IS", "Value": [39]},
        "3248": {"vr": "IS", "Value": [46]},
        "3249": {"vr": "IS", "Value": [50]},
        "3250": {"vr": "IS", "Value": [42]},
        "3251": {"vr": "IS", "Value": [46]},
        "3252": {"vr": "IS", "Value": [29]},
        "3253": {"vr": "IS", "Value": [28]},
        "3254": {"vr": "IS", "Value": [3]},
        "3255": {"vr": "IS", "Value": [46]},
        "3256": {"vr": "IS", "Value": [24]},
        "3257": {"vr": "IS", "Value": [32]},
        "3258": {"vr": "IS", "Value": [12]},
        "3259": {"vr": "IS", "Value": [34]},
        "3260": {"vr": "IS", "Value": [31]},
        "3261": {"vr": "IS", "Value": [6]},
        "3262": {"vr": "IS", "Value": [11]},
        "3263": {"vr": "IS", "Value": [20]},
        "3264": {"vr": "IS", "Value": [42]},
        "3265": {"vr": "IS", "Value": [43]},
        "3266": {"vr": "IS", "Value": [30]},
        "3267": {"vr": "IS", "Value": [49]},
        "3268": {"vr": "IS", "Value": [52]},
        "3269": {"vr": "IS", "Value": [11]},
        "3270": {"vr": "IS", "Value": [25]},
        "3271": {"vr": "IS", "Value": [50]},
        "3272": {"vr": "IS", "Value": [39]},
        "3273": {"vr": "IS", "Value": [25]},
        "3274": {"vr": "IS", "Value": [26]},
        "3275": {"vr": "IS", "Value": [43]},
        "3276": {"vr": "IS", "Value": [49]},
        "3277": {"vr": "IS", "Value": [41]},
        "3278": {"vr": "IS", "Value": [51]},
        "3279": {"vr": "IS", "Value": [6]},
        "3280": {"vr": "IS", "Value": [22]},
        "3281": {"vr": "IS", "Value": [27]},
        "3282": {"vr": "IS", "Value": [26]},
        "3283": {"vr": "IS", "Value": [46]},
        "3284": {"vr": "IS", "Value": [29]},
        "3285": {"vr": "IS", "Value": [23]},
        "3286": {"vr": "IS", "Value": [16]},
        "3287": {"vr": "IS", "Value": [29]},
        "3288": {"vr": "IS", "Value": [22]},
        "3289": {"vr": "IS", "Value": [56]},
        "3290": {"vr": "IS", "Value": [47]},
        "3291": {"vr": "IS", "Value": [56]},
        "3292": {"vr": "IS", "Value": [17]},
        "3293": {"vr": "IS", "Value": [56]},
        "3294": {"vr": "IS", "Value": [27]},
        "3295": {"vr": "IS", "Value": [37]},
        "3296": {"vr": "IS", "Value": [38]},
        "3297": {"vr": "IS", "Value": [51]},
        "3298": {"vr": "IS", "Value": [9]},
        "3299": {"vr": "IS", "Value": [57]},
        "3300": {"vr": "IS", "Value": [58]},
        "3301": {"vr": "IS", "Value": [55]},
        "3302": {"vr": "IS", "Value": [33]},
        "3303": {"vr": "IS", "Value": [55]},
        "3304": {"vr": "IS", "Value": [44]},
        "3305": {"vr": "IS", "Value": [37]},
        "3306": {"vr": "IS", "Value": [38]},
        "3307": {"vr": "IS", "Value": [56]},
        "3308": {"vr": "IS", "Value": [13]},
        "3309": {"vr": "IS", "Value": [20]},
        "3310": {"vr": "IS", "Value": [27]},
        "3311": {"vr": "IS", "Value": [20]},
        "3312": {"vr": "IS", "Value": [52]},
        "3313": {"vr": "IS", "Value": [21]},
        "3314": {"vr": "IS", "Value": [57]},
        "3315": {"vr": "IS", "Value": [58]},
        "3316": {"vr": "IS", "Value": [58]},
        "3317": {"vr": "IS", "Value": [35]},
        "3318": {"vr": "IS", "Value": [33]},
        "3319": {"vr": "IS", "Value": [44]},
        "3320": {"vr": "IS", "Value": [56]},
        "3321": {"vr": "IS", "Value": [44]},
        "3322": {"vr": "IS", "Value": [20]},
        "3323": {"vr": "IS", "Value": [54]},
        "3324": {"vr": "IS", "Value": [51]},
        "3325": {"vr": "IS", "Value": [45]},
        "3326": {"vr": "IS", "Value": [48]},
        "3327": {"vr": "IS", "Value": [46]},
        "3328": {"vr": "IS", "Value": [35]},
        "3329": {"vr": "IS", "Value": [49]},
        "3330": {"vr": "IS", "Value": [46]},
        "3331": {"vr": "IS", "Value": [27]},
        "3332": {"vr": "IS", "Value": [31]},
        "3333": {"vr": "IS", "Value": [46]},
        "3334": {"vr": "IS", "Value": [35]},
        "3335": {"vr": "IS", "Value": [35]},
        "3336": {"vr": "IS", "Value": [51]},
        "3337": {"vr": "IS", "Value": [1]},
        "3338": {"vr": "IS", "Value": [11]},
        "3339": {"vr": "IS", "Value": [41]},
        "3340": {"vr": "IS", "Value": [1]},
        "3341": {"vr": "IS", "Value": [19]},
        "3342": {"vr": "IS", "Value": [15]},
        "3343": {"vr": "IS", "Value": [59]},
        "3344": {"vr": "IS", "Value": [28]},
        "3345": {"vr": "IS", "Value": [26]},
        "3346": {"vr": "IS", "Value": [27]},
        "3347": {"vr": "IS", "Value": [51]},
        "3348": {"vr": "IS", "Value": [25]},
        "3349": {"vr": "IS", "Value": [16]},
        "3350": {"vr": "IS", "Value": [1]},
        "3351": {"vr": "IS", "Value": [23]},
        "3352": {"vr": "IS", "Value": [6]},
        "3353": {"vr": "IS", "Value": [47]},
        "3354": {"vr": "IS", "Value": [53]},
        "3355": {"vr": "IS", "Value": [59]},
        "3356": {"vr": "IS", "Value": [8]},
        "3357": {"vr": "IS", "Value": [16]},
        "3358": {"vr": "IS", "Value": [22]},
        "3359": {"vr": "IS", "Value": [10]},
        "3360": {"vr": "IS", "Value": [39]},
        "3361": {"vr": "IS", "Value": [33]},
        "3362": {"vr": "IS", "Value": [11]},
        "3363": {"vr": "IS", "Value": [54]},
        "3364": {"vr": "IS", "Value": [20]},
        "3365": {"vr": "IS", "Value": [10]},
        "3366": {"vr": "IS", "Value": [43]},
        "3367": {"vr": "IS", "Value": [45]},
        "3368": {"vr": "IS", "Value": [36]},
        "3369": {"vr": "IS", "Value": [49]},
        "3370": {"vr": "IS", "Value": [19]},
        "3371": {"vr": "IS", "Value": [12]},
        "3372": {"vr": "IS", "Value": [25]},
        "3373": {"vr": "IS", "Value": [16]},
        "3374": {"vr": "IS", "Value": [19]},
        "3375": {"vr": "IS", "Value": [38]},
        "3376": {"vr": "IS", "Value": [59]},
        "3377": {"vr": "IS", "Value": [33]},
        "3378": {"vr": "IS", "Value": [56]},
        "3379": {"vr": "IS", "Value": [25]},
        "3380": {"vr": "IS", "Value": [29]},
        "3381": {"vr": "IS", "Value": [37]},
        "3382": {"vr": "IS", "Value": [57]},
        "3383": {"vr": "IS", "Value": [34]},
        "3384": {"vr": "IS", "Value": [25]},
        "3385": {"vr": "IS", "Value": [29]},
        "3386": {"vr": "IS", "Value": [12]},
        "3387": {"vr": "IS", "Value": [25]},
        "3388": {"vr": "IS", "Value": [44]},
        "3389": {"vr": "IS", "Value": [17]},
        "3390": {"vr": "IS", "Value": [12]},
        "3391": {"vr": "IS", "Value": [23]},
        "3392": {"vr": "IS", "Value": [16]},
        "3393": {"vr": "IS", "Value": [48]},
        "3394": {"vr": "IS", "Value": [13]},
        "3395": {"vr": "IS", "Value": [14]},
        "3396": {"vr": "IS", "Value": [57]},
        "3397": {"vr": "IS", "Value": [31]},
        "3398": {"vr": "IS", "Value": [5]},
        "3399": {"vr": "IS", "Value": [33]},
        "3400": {"vr": "IS", "Value": [20]},
        "3401": {"vr": "IS", "Value": [48]},
        "3402": {"vr": "IS", "Value": [2]},
        "3403": {"vr": "IS", "Value": [43]},
        "3404": {"vr": "IS", "Value": [41]},
        "3405": {"vr": "IS", "Value": [6]},
        "3406": {"vr": "IS", "Value": [16]},
        "3407": {"vr": "IS", "Value": [34]},
        "3408": {"vr": "IS", "Value": [26]},
        "3409": {"vr": "IS", "Value": [0]},
        "3410": {"vr": "IS", "Value": [18]},
        "3411": {"vr": "IS", "Value": [53]},
        "3412": {"vr": "IS", "Value": [0]},
        "3413": {"vr": "IS", "Value": [23]},
        "3414": {"vr": "IS", "Value": [11]},
        "3415": {"vr": "IS", "Value": [35]},
        "3416": {"vr": "IS", "Value": [12]},
        "3417": {"vr": "IS", "Value": [55]},
        "3418": {"vr": "IS", "Value": [38]},
        "3419": {"vr": "IS", "Value": [16]},
        "3420": {"vr": "IS", "Value": [36]},
        "3421": {"vr": "IS", "Value": [0]},
        "3422": {"vr": "IS", "Value": [43]},
        "3423": {"vr": "IS", "Value": [13]},
        "3424": {"vr": "IS", "Value": [48]},
        "3425": {"vr": "IS", "Value": [47]},
        "3426": {"vr": "IS", "Value": [8]},
        "3427": {"vr": "IS", "Value": [55]},
        "3428": {"vr": "IS", "Value": [53]},
        "3429": {"vr": "IS", "Value": [43]},
        "3430": {"vr": "IS", "Value": [4]},
        "3431": {"vr": "IS", "Value": [47]},
        "3432": {"vr": "IS", "Value": [1]},
        "3433": {"vr": "IS", "Value": [20]},
        "3434": {"vr": "IS", "Value": [5]},
        "3435": {"vr": "IS", "Value": [53]},
        "3436": {"vr": "IS", "Value": [10]},
        "3437": {"vr": "IS", "Value": [19]},
        "3438": {"vr": "IS", "Value": [38]},
        "3439": {"vr": "IS", "Value": [10]},
        "3440": {"vr": "IS", "Value": [23]},
        "3441": {"vr": "IS", "Value": [4]},
        "3442": {"vr": "IS", "Value": [43]},
        "3443": {"vr": "IS", "Value": [37]},
        "3444": {"vr": "IS", "Value": [6]},
        "3445": {"vr": "IS", "Value": [57]},
        "3446": {"vr": "IS", "Value": [33]},
        "3447": {"vr": "IS", "Value": [2]},
        "3448": {"vr": "IS", "Value": [2]},
        "3449": {"vr": "IS", "Value": [37]},
        "3450": {"vr": "IS", "Value": [2]},
        "3451": {"vr": "IS", "Value": [35]},
        "3452": {"vr": "IS", "Value": [36]},
        "3453": {"vr": "IS", "Value": [23]},
        "3454": {"vr": "IS", "Value": [25]},
        "3455": {"vr": "IS", "Value": [45]},
        "3456": {"vr": "IS", "Value": [59]},
        "3457": {"vr": "IS", "Value": [0]},
        "3458": {"vr": "IS", "Value": [51]},
        "3459": {"vr": "IS", "Value": [37]},
        "3460": {"vr": "IS", "Value": [53]},
        "3461": {"vr": "IS", "Value": [39]},
        "3462": {"vr": "IS", "Value": [30]},
        "3463": {"vr": "IS", "Value": [51]},
        "3464": {"vr": "IS", "Value": [11]},
        "3465": {"vr": "IS", "Value": [42]},
        "3466": {"vr": "IS", "Value": [28]},
        "3467": {"vr": "IS", "Value": [55]},
        "3468": {"vr": "IS", "Value": [45]},
        "3469": {"vr": "IS", "Value": [36]},
        "3470": {"vr": "IS", "Value": [30]},
        "3471": {"vr": "IS", "Value": [29]},
        "3472": {"vr": "IS", "Value": [16]},
        "3473": {"vr": "IS", "Value": [7]},
        "3474": {"vr": "IS", "Value": [38]},
        "3475": {"vr": "IS", "Value": [5]},
        "3476": {"vr": "IS", "Value": [15]},
        "3477": {"vr": "IS", "Value": [57]},
        "3478": {"vr": "IS", "Value": [56]},
        "3479": {"vr": "IS", "Value": [22]},
        "3480": {"vr": "IS", "Value": [26]},
        "3481": {"vr": "IS", "Value": [33]},
        "3482": {"vr": "IS", "Value": [2]},
        "3483": {"vr": "IS", "Value": [32]},
        "3484": {"vr": "IS", "Value": [4]},
        "3485": {"vr": "IS", "Value": [43]},
        "3486": {"vr": "IS", "Value": [6]},
        "3487": {"vr": "IS", "Value": [6]},
        "3488": {"vr": "IS", "Value": [38]},
        "3489": {"vr": "IS", "Value": [23]},
        "3490": {"vr": "IS", "Value": [51]},
        "3491": {"vr": "IS", "Value": [31]},
        "3492": {"vr": "IS", "Value": [8]},
        "3493": {"vr": "IS", "Value": [2]},
        "3494": {"vr": "IS", "Value": [57]},
        "3495": {"vr": "IS", "Value": [24]},
        "3496": {"vr": "IS", "Value": [46]},
        "3497": {"vr": "IS", "Value": [29]},
        "3498": {"vr": "IS", "Value": [2]},
        "3499": {"vr": "IS", "Value": [40]},
        "3500": {"vr": "IS", "Value": [2]},
        "3501": {"vr": "IS", "Value": [52]},
        "3502": {"vr": "IS", "Value": [5]},
        "3503": {"vr": "IS", "Value": [41]},
        "3504": {"vr": "IS", "Value": [18]},
        "3505": {"vr": "IS", "Value": [43]},
        "3506": {"vr": "IS", "Value": [3]},
        "3507": {"vr": "IS", "Value": [12]},
        "3508": {"vr": "IS", "Value": [26]},
        "3509": {"vr": "IS", "Value": [32]},
        "3510": {"vr": "IS", "Value": [39]},
        "3511": {"vr": "IS", "Value": [51]},
        "3512": {"vr": "IS", "Value": [20]},
        "3513": {"vr": "IS", "Value": [19]},
        "3514": {"vr": "IS", "Value": [51]},
        "3515": {"vr": "IS", "Value": [54]},
        "3516": {"vr": "IS", "Value": [50]},
        "3517": {"vr": "IS", "Value": [10]},
        "3518": {"vr": "IS", "Value": [20]},
        "3519": {"vr": "IS", "Value": [27]},
        "3520": {"vr": "IS", "Value": [4]},
        "3521": {"vr": "IS", "Value": [47]},
        "3522": {"vr": "IS", "Value": [1]},
        "3523": {"vr": "IS", "Value": [24]},
        "3524": {"vr": "IS", "Value": [12]},
        "3525": {"vr": "IS", "Value": [27]},
        "3526": {"vr": "IS", "Value": [49]},
        "3527": {"vr": "IS", "Value": [19]},
        "3528": {"vr": "IS", "Value": [8]},
        "3529": {"vr": "IS", "Value": [29]},
        "3530": {"vr": "IS", "Value": [4]},
        "3531": {"vr": "IS", "Value": [22]},
        "3532": {"vr": "IS", "Value": [7]},
        "3533": {"vr": "IS", "Value": [38]},
        "3534": {"vr": "IS", "Value": [20]},
        "3535": {"vr": "IS", "Value": [56]},
        "3536": {"vr": "IS", "Value": [48]},
        "3537": {"vr": "IS", "Value": [7]},
        "3538": {"vr": "IS", "Value": [36]},
        "3539": {"vr": "IS", "Value": [34]},
        "3540": {"vr": "IS", "Value": [5]},
        "3541": {"vr": "IS", "Value": [3]},
        "3542": {"vr": "IS", "Value": [49]},
        "3543": {"vr": "IS", "Value": [46]},
        "3544": {"vr": "IS", "Value": [21]},
        "3545": {"vr": "IS", "Value": [2]},
        "3546": {"vr": "IS", "Value": [10]},
        "3547": {"vr": "IS", "Value": [37]},
        "3548": {"vr": "IS", "Value": [50]},
        "3549": {"vr": "IS", "Value": [5]},
        "3550": {"vr": "IS", "Value": [6]},
        "3551": {"vr": "IS", "Value": [37]},
        "3552": {"vr": "IS", "Value": [40]},
        "3553": {"vr": "IS", "Value": [49]},
        "3554": {"vr": "IS", "Value": [27]},
        "3555": {"vr": "IS", "Value": [28]},
        "3556": {"vr": "IS", "Value": [0]},
        "3557": {"vr": "IS", "Value": [45]},
        "3558": {"vr": "IS", "Value": [40]},
        "3559": {"vr": "IS", "Value": [1]},
        "3560": {"vr": "IS", "Value": [7]},
        "3561": {"vr": "IS", "Value": [14]},
        "3562": {"vr": "IS", "Value": [8]},
        "3563": {"vr": "IS", "Value": [51]},
        "3564": {"vr": "IS", "Value": [55]},
        "3565": {"vr": "IS", "Value": [52]},
        "3566": {"vr": "IS", "Value": [15]},
        "3567": {"vr": "IS", "Value": [20]},
        "3568": {"vr": "IS", "Value": [19]},
        "3569": {"vr": "IS", "Value": [4]},
        "3570": {"vr": "IS", "Value": [24]},
        "3571": {"vr": "IS", "Value": [56]},
        "3572": {"vr": "IS", "Value": [3]},
        "3573": {"vr": "IS", "Value": [9]},
        "3574": {"vr": "IS", "Value": [11]},
        "3575": {"vr": "IS", "Value": [40]},
        "3576": {"vr": "IS", "Value": [32]},
        "3577": {"vr": "IS", "Value": [37]},
        "3578": {"vr": "IS", "Value": [0]},
        "3579": {"vr": "IS", "Value": [41]},
        "3580": {"vr": "IS", "Value": [12]},
        "3581": {"vr": "IS", "Value": [16]},
        "3582": {"vr": "IS", "Value": [17]},
        "3583": {"vr": "IS", "Value": [29]},
        "3584": {"vr": "IS", "Value": [32]},
        "3585": {"vr": "IS", "Value": [58]},
        "3586": {"vr": "IS", "Value": [11]},
        "3587": {"vr": "IS", "Value": [47]},
        "3588": {"vr": "IS", "Value": [13]},
        "3589": {"vr": "IS", "Value": [49]},
        "3590": {"vr": "IS", "Value": [40]},
        "3591": {"vr": "IS", "Value": [36]},
        "3592": {"vr": "IS", "Value": [32]},
        "3593": {"vr": "IS", "Value": [39]},
        "3594": {"vr": "IS", "Value": [19]},
        "3595": {"vr": "IS", "Value": [7]},
        "3596": {"vr": "IS", "Value": [49]},
        "3597": {"vr": "IS", "Value": [15]},
        "3598": {"vr": "IS", "Value": [16]},
        "3599": {"vr": "IS", "Value": [47]},
        "3600": {"vr": "IS", "Value": [7]},
        "3601": {"vr": "IS", "Value": [58]},
        "3602": {"vr": "IS", "Value": [53]},
        "3603": {"vr": "IS", "Value": [52]},
        "3604": {"vr": "IS", "Value": [38]},
        "3605": {"vr": "IS", "Value": [36]},
        "3606": {"vr": "IS", "Value": [0]},
        "3607": {"vr": "IS", "Value": [3]},
        "3608": {"vr": "IS", "Value": [54]},
        "3609": {"vr": "IS", "Value": [57]},
        "3610": {"vr": "IS", "Value": [15]},
        "3611": {"vr": "IS", "Value": [28]},
        "3612": {"vr": "IS", "Value": [37]},
        "3613": {"vr": "IS", "Value": [18]},
        "3614": {"vr": "IS", "Value": [3]},
        "3615": {"vr": "IS", "Value": [40]},
        "3616": {"vr": "IS", "Value": [15]},
        "3617": {"vr": "IS", "Value": [15]},
        "3618": {"vr": "IS", "Value": [14]},
        "3619": {"vr": "IS", "Value": [25]},
        "3620": {"vr": "IS", "Value": [18]},
        "3621": {"vr": "IS", "Value": [41]},
        "3622": {"vr": "IS", "Value": [24]},
        "3623": {"vr": "IS", "Value": [30]},
        "3624": {"vr": "IS", "Value": [3]},
        "3625": {"vr": "IS", "Value": [43]},
        "3626": {"vr": "IS", "Value": [2]},
        "3627": {"vr": "IS", "Value": [23]},
        "3628": {"vr": "IS", "Value": [50]},
        "3629": {"vr": "IS", "Value": [14]},
        "3630": {"vr": "IS", "Value": [38]},
        "3631": {"vr": "IS", "Value": [56]},
        "3632": {"vr": "IS", "Value": [23]},
        "3633": {"vr": "IS", "Value": [11]},
        "3634": {"vr": "IS", "Value": [41]},
        "3635": {"vr": "IS", "Value": [16]},
        "3636": {"vr": "IS", "Value": [40]},
        "3637": {"vr": "IS", "Value": [47]},
        "3638": {"vr": "IS", "Value": [41]},
        "3639": {"vr": "IS", "Value": [14]},
        "3640": {"vr": "IS", "Value": [29]},
        "3641": {"vr": "IS", "Value": [19]},
        "3642": {"vr": "IS", "Value": [57]},
        "3643": {"vr": "IS", "Value": [0]},
        "3644": {"vr": "IS", "Value": [24]},
        "3645": {"vr": "IS", "Value": [18]},
        "3646": {"vr": "IS", "Value": [0]},
        "3647": {"vr": "IS", "Value": [54]},
        "3648": {"vr": "IS", "Value": [4]},
        "3649": {"vr": "IS", "Value": [8]},
        "3650": {"vr": "IS", "Value": [35]},
        "3651": {"vr": "IS", "Value": [53]},
        "3652": {"vr": "IS", "Value": [4]},
        "3653": {"vr": "IS", "Value": [40]},
        "3654": {"vr": "IS", "Value": [0]},
        "3655": {"vr": "IS", "Value": [17]},
        "3656": {"vr": "IS", "Value": [11]},
        "3657": {"vr": "IS", "Value": [54]},
        "3658": {"vr": "IS", "Value": [54]},
        "3659": {"vr": "IS", "Value": [21]},
        "3660": {"vr": "IS", "Value": [3]},
        "3661": {"vr": "IS", "Value": [1]},
        "3662": {"vr": "IS", "Value": [37]},
        "3663": {"vr": "IS", "Value": [18]},
        "3664": {"vr": "IS", "Value": [24]},
        "3665": {"vr": "IS", "Value": [56]},
        "3666": {"vr": "IS", "Value": [1]},
        "3667": {"vr": "IS", "Value": [34]},
        "3668": {"vr": "IS", "Value": [4]},
        "3669": {"vr": "IS", "Value": [7]},
        "3670": {"vr": "IS", "Value": [59]},
        "3671": {"vr": "IS", "Value": [40]},
        "3672": {"vr": "IS", "Value": [45]},
        "3673": {"vr": "IS", "Value": [40]},
        "3674": {"vr": "IS", "Value": [34]},
        "3675": {"vr": "IS", "Value": [8]},
        "3676": {"vr": "IS", "Value": [40]},
        "3677": {"vr": "IS", "Value": [28]},
        "3678": {"vr": "IS", "Value": [41]},
        "3679": {"vr": "IS", "Value": [32]},
        "3680": {"vr": "IS", "Value": [11]},
        "3681": {"vr": "IS", "Value": [7]},
        "3682": {"vr": "IS", "Value": [57]},
        "3683": {"vr": "IS", "Value": [15]},
        "3684": {"vr": "IS", "Value": [16]},
        "3685": {"vr": "IS", "Value": [15]},
        "3686": {"vr": "IS", "Value": [42]},
        "3687": {"vr": "IS", "Value": [51]},
        "3688": {"vr": "IS", "Value": [59]},
        "3689": {"vr": "IS", "Value": [29]},
        "3690": {"vr": "IS", "Value": [31]},
        "3691": {"vr": "IS", "Value": [16]},
        "3692": {"vr": "IS", "Value": [29]},
        "3693": {"vr": "IS", "Value": [38]},
        "3694": {"vr": "IS", "Value": [20]},
        "3695": {"vr": "IS", "Value": [15]},
        "3696": {"vr": "IS", "Value": [13]},
        "3697": {"vr": "IS", "Value": [4]},
        "3698": {"vr": "IS", "Value": [25]},
        "3699": {"vr": "IS", "Value": [27]},
        "3700": {"vr": "IS", "Value": [55]},
        "3701": {"vr": "IS", "Value": [28]},
        "3702": {"vr": "IS", "Value": [26]},
        "3703": {"vr": "IS", "Value": [13]},
        "3704": {"vr": "IS", "Value": [51]},
        "3705": {"vr": "IS", "Value": [23]},
        "3706": {"vr": "IS", "Value": [37]},
        "3707": {"vr": "IS", "Value": [17]},
        "3708": {"vr": "IS", "Value": [14]},
        "3709": {"vr": "IS", "Value": [11]},
        "3710": {"vr": "IS", "Value": [46]},
        "3711": {"vr": "IS", "Value": [21]},
        "3712": {"vr": "IS", "Value": [36]},
        "3713": {"vr": "IS", "Value": [58]},
        "3714": {"vr": "IS", "Value": [39]},
        "3715": {"vr": "IS", "Value": [42]},
        "3716": {"vr": "IS", "Value": [55]},
        "3717": {"vr": "IS", "Value": [53]},
        "3718": {"vr": "IS", "Value": [36]},
        "3719": {"vr": "IS", "Value": [22]},
        "3720": {"vr": "IS", "Value": [50]},
        "3721": {"vr": "IS", "Value": [59]},
        "3722": {"vr": "IS", "Value": [41]},
        "3723": {"vr": "IS", "Value": [55]},
        "3724": {"vr": "IS", "Value": [10]},
        "3725": {"vr": "IS", "Value": [23]},
        "3726": {"vr": "IS", "Value": [52]},
        "3727": {"vr": "IS", "Value": [17]},
        "3728": {"vr": "IS", "Value": [34]},
        "3729": {"vr": "IS", "Value": [25]},
        "3730": {"vr": "IS", "Value": [31]},
        "3731": {"vr": "IS", "Value": [8]},
        "3732": {"vr": "IS", "Value": [47]},
        "3733": {"vr": "IS", "Value": [44]},
        "3734": {"vr": "IS", "Value": [6]},
        "3735": {"vr": "IS", "Value": [56]},
        "3736": {"vr": "IS", "Value": [15]},
        "3737": {"vr": "IS", "Value": [44]},
        "3738": {"vr": "IS", "Value": [46]},
        "3739": {"vr": "IS", "Value": [40]},
        "3740": {"vr": "IS", "Value": [1]},
        "3741": {"vr": "IS", "Value": [49]},
        "3742": {"vr": "IS", "Value": [11]},
        "3743": {"vr": "IS", "Value": [41]},
        "3744": {"vr": "IS", "Value": [26]},
        "3745": {"vr": "IS", "Value": [51]},
        "3746": {"vr": "IS", "Value": [34]},
        "3747": {"vr": "IS", "Value": [35]},
        "3748": {"vr": "IS", "Value": [59]},
        "3749": {"vr": "IS", "Value": [51]},
        "3750": {"vr": "IS", "Value": [43]},
        "3751": {"vr": "IS", "Value": [10]},
        "3752": {"vr": "IS", "Value": [44]},
        "3753": {"vr": "IS", "Value": [38]},
        "3754": {"vr": "IS", "Value": [31]},
        "3755": {"vr": "IS", "Value": [36]},
        "3756": {"vr": "IS", "Value": [15]},
        "3757": {"vr": "IS", "Value": [58]},
        "3758": {"vr": "IS", "Value": [49]},
        "3759": {"vr": "IS", "Value": [21]},
        "3760": {"vr": "IS", "Value": [38]},
        "3761": {"vr": "IS", "Value": [44]},
        "3762": {"vr": "IS", "Value": [52]},
        "3763": {"vr": "IS", "Value": [34]},
        "3764": {"vr": "IS", "Value": [15]},
        "3765": {"vr": "IS", "Value": [43]},
        "3766": {"vr": "IS", "Value": [49]},
        "3767": {"vr": "IS", "Value": [4]},
        "3768": {"vr": "IS", "Value": [4]},
        "3769": {"vr": "IS", "Value": [50]},
        "3770": {"vr": "IS", "Value": [19]},
        "3771": {"vr": "IS", "Value": [26]},
        "3772": {"vr": "IS", "Value": [35]},
        "3773": {"vr": "IS", "Value": [18]},
        "3774": {"vr": "IS", "Value": [38]},
        "3775": {"vr": "IS", "Value": [22]},
        "3776": {"vr": "IS", "Value": [46]},
        "3777": {"vr": "IS", "Value": [53]},
        "3778": {"vr": "IS", "Value": [33]},
        "3779": {"vr": "IS", "Value": [15]},
        "3780": {"vr": "IS", "Value": [1]},
        "3781": {"vr": "IS", "Value": [22]},
        "3782": {"vr": "IS", "Value": [57]},
        "3783": {"vr": "IS", "Value": [10]},
        "3784": {"vr": "IS", "Value": [46]},
        "3785": {"vr": "IS", "Value": [58]},
        "3786": {"vr": "IS", "Value": [50]},
        "3787": {"vr": "IS", "Value": [20]},
        "3788": {"vr": "IS", "Value": [59]},
        "3789": {"vr": "IS", "Value": [57]},
        "3790": {"vr": "IS", "Value": [37]},
        "3791": {"vr": "IS", "Value": [47]},
        "3792": {"vr": "IS", "Value": [2]},
        "3793": {"vr": "IS", "Value": [41]},
        "3794": {"vr": "IS", "Value": [56]},
        "3795": {"vr": "IS", "Value": [59]},
        "3796": {"vr": "IS", "Value": [40]},
        "3797": {"vr": "IS", "Value": [4]},
        "3798": {"vr": "IS", "Value": [28]},
        "3799": {"vr": "IS", "Value": [34]},
        "3800": {"vr": "IS", "Value": [14]},
        "3801": {"vr": "IS", "Value": [45]},
        "3802": {"vr": "IS", "Value": [12]},
        "3803": {"vr": "IS", "Value": [25]},
        "3804": {"vr": "IS", "Value": [36]},
        "3805": {"vr": "IS", "Value": [57]},
        "3806": {"vr": "IS", "Value": [56]},
        "3807": {"vr": "IS", "Value": [58]},
        "3808": {"vr": "IS", "Value": [21]},
        "3809": {"vr": "IS", "Value": [2]},
        "3810": {"vr": "IS", "Value": [24]},
        "3811": {"vr": "IS", "Value": [26]},
        "3812": {"vr": "IS", "Value": [23]},
        "3813": {"vr": "IS", "Value": [38]},
        "3814": {"vr": "IS", "Value": [52]},
        "3815": {"vr": "IS", "Value": [32]},
        "3816": {"vr": "IS", "Value": [35]},
        "3817": {"vr": "IS", "Value": [4]},
        "3818": {"vr": "IS", "Value": [18]},
        "3819": {"vr": "IS", "Value": [10]},
        "3820": {"vr": "IS", "Value": [21]},
        "3821": {"vr": "IS", "Value": [59]},
        "3822": {"vr": "IS", "Value": [8]},
        "3823": {"vr": "IS", "Value": [41]},
        "3824": {"vr": "IS", "Value": [22]},
        "3825": {"vr": "IS", "Value": [21]},
        "3826": {"vr": "IS", "Value": [19]},
        "3827": {"vr": "IS", "Value": [1]},
        "3828": {"vr": "IS", "Value": [13]},
        "3829": {"vr": "IS", "Value": [41]},
        "3830": {"vr": "IS", "Value": [18]},
        "3831": {"vr": "IS", "Value": [13]},
        "3832": {"vr": "IS", "Value": [34]},
        "3833": {"vr": "IS", "Value": [31]},
        "3834": {"vr": "IS", "Value": [36]},
        "3835": {"vr": "IS", "Value": [40]},
        "3836": {"vr": "IS", "Value": [56]},
        "3837": {"vr": "IS", "Value": [31]},
        "3838": {"vr": "IS", "Value": [7]},
        "3839": {"vr": "IS", "Value": [13]},
        "3840": {"vr": "IS", "Value": [17]},
        "3841": {"vr": "IS", "Value": [10]},
        "3842": {"vr": "IS", "Value": [3]},
        "3843": {"vr": "IS", "Value": [21]},
        "3844": {"vr": "IS", "Value": [4]},
        "3845": {"vr": "IS", "Value": [41]},
        "3846": {"vr": "IS", "Value": [13]},
        "3847": {"vr": "IS", "Value": [52]},
        "3848": {"vr": "IS", "Value": [33]},
        "3849": {"vr": "IS", "Value": [34]},
        "3850": {"vr": "IS", "Value": [58]},
        "3851": {"vr": "IS", "Value": [48]},
        "3852": {"vr": "IS", "Value": [54]},
        "3853": {"vr": "IS", "Value": [50]},
        "3854": {"vr": "IS", "Value": [58]},
        "3855": {"vr": "IS", "Value": [45]},
        "3856": {"vr": "IS", "Value": [20]},
        "3857": {"vr": "IS", "Value": [49]},
        "3858": {"vr": "IS", "Value": [55]},
        "3859": {"vr": "IS", "Value": [45]},
        "3860": {"vr": "IS", "Value": [29]},
        "3861": {"vr": "IS", "Value": [34]},
        "3862": {"vr": "IS", "Value": [57]},
        "3863": {"vr": "IS", "Value": [7]},
        "3864": {"vr": "IS", "Value": [45]},
        "3865": {"vr": "IS", "Value": [30]},
        "3866": {"vr": "IS", "Value": [10]},
        "3867": {"vr": "IS", "Value": [26]},
        "3868": {"vr": "IS", "Value": [35]},
        "3869": {"vr": "IS", "Value": [10]},
        "3870": {"vr": "IS", "Value": [7]},
        "3871": {"vr": "IS", "Value": [29]},
        "3872": {"vr": "IS", "Value": [8]},
        "3873": {"vr": "IS", "Value": [9]},
        "3874": {"vr": "IS", "Value": [54]},
        "3875": {"vr": "IS", "Value": [28]},
        "3876": {"vr": "IS", "Value": [13]},
        "3877": {"vr": "IS", "Value": [54]},
        "3878": {"vr": "IS", "Value": [12]},
        "3879": {"vr": "IS", "Value": [35]},
        "3880": {"vr": "IS", "Value": [2]},
        "3881": {"vr": "IS", "Value": [50]},
        "3882": {"vr": "IS", "Value": [58]},
        "3883": {"vr": "IS", "Value": [17]},
        "3884": {"vr": "IS", "Value": [7]},
        "3885": {"vr": "IS", "Value": [47]},
        "3886": {"vr": "IS", "Value": [0]},
        "3887": {"vr": "IS", "Value": [34]},
        "3888": {"vr": "IS", "Value": [42]},
        "3889": {"vr": "IS", "Value": [8]},
        "3890": {"vr": "IS", "Value": [55]},
        "3891": {"vr": "IS", "Value": [46]},
        "3892": {"vr": "IS", "Value": [7]},
        "3893": {"vr": "IS", "Value": [55]},
        "3894": {"vr": "IS", "Value": [20]},
        "3895": {"vr": "IS", "Value": [25]},
        "3896": {"vr": "IS", "Value": [24]},
        "3897": {"vr": "IS", "Value": [5]},
        "3898": {"vr": "IS", "Value": [3]},
        "3899": {"vr": "IS", "Value": [19]},
        "3900": {"vr": "IS", "Value": [35]},
        "3901": {"vr": "IS", "Value": [49]},
        "3902": {"vr": "IS", "Value": [50]},
        "3903": {"vr": "IS", "Value": [18]},
        "3904": {"vr": "IS", "Value": [32]},
        "3905": {"vr": "IS", "Value": [23]},
        "3906": {"vr": "IS", "Value": [11]},
        "3907": {"vr": "IS", "Value": [10]},
        "3908": {"vr": "IS", "Value": [40]},
        "3909": {"vr": "IS", "Value": [45]},
        "3910": {"vr": "IS", "Value": [28]},
        "3911": {"vr": "IS", "Value": [53]},
        "3912": {"vr": "IS", "Value": [1]},
        "3913": {"vr": "IS", "Value": [28]},
        "3914": {"vr": "IS", "Value": [36]},
        "3915": {"vr": "IS", "Value": [17]},
        "3916": {"vr": "IS", "Value": [53]},
        "3917": {"vr": "IS", "Value": [6]},
        "3918": {"vr": "IS", "Value": [15]},
        "3919": {"vr": "IS", "Value": [10]},
        "3920": {"vr": "IS", "Value": [45]},
        "3921": {"vr": "IS", "Value": [31]},
        "3922": {"vr": "IS", "Value": [5]},
        "3923": {"vr": "IS", "Value": [53]},
        "3924": {"vr": "IS", "Value": [27]},
        "3925": {"vr": "IS", "Value": [48]},
        "3926": {"vr": "IS", "Value": [58]},
        "3927": {"vr": "IS", "Value": [43]},
        "3928": {"vr": "IS", "Value": [14]},
        "3929": {"vr": "IS", "Value": [45]},
        "3930": {"vr": "IS", "Value": [47]},
        "3931": {"vr": "IS", "Value": [26]},
        "3932": {"vr": "IS", "Value": [45]},
        "3933": {"vr": "IS", "Value": [44]},
        "3934": {"vr": "IS", "Value": [13]},
        "3935": {"vr": "IS", "Value": [28]},
        "3936": {"vr": "IS", "Value": [30]},
        "3937": {"vr": "IS", "Value": [12]},
        "3938": {"vr": "IS", "Value": [18]},
        "3939": {"vr": "IS", "Value": [46]},
        "3940": {"vr": "IS", "Value": [39]},
        "3941": {"vr": "IS", "Value": [13]},
        "3942": {"vr": "IS", "Value": [37]},
        "3943": {"vr": "IS", "Value": [55]},
        "3944": {"vr": "IS", "Value": [58]},
        "3945": {"vr": "IS", "Value": [10]},
        "3946": {"vr": "IS", "Value": [4]},
        "3947": {"vr": "IS", "Value": [48]},
        "3948": {"vr": "IS", "Value": [17]},
        "3949": {"vr": "IS", "Value": [17]},
        "3950": {"vr": "IS", "Value": [45]},
        "3951": {"vr": "IS", "Value": [41]},
        "3952": {"vr": "IS", "Value": [7]},
        "3953": {"vr": "IS", "Value": [36]},
        "3954": {"vr": "IS", "Value": [18]},
        "3955": {"vr": "IS", "Value": [28]},
        "3956": {"vr": "IS", "Value": [7]},
        "3957": {"vr": "IS", "Value": [22]},
        "3958": {"vr": "IS", "Value": [45]},
        "3959": {"vr": "IS", "Value": [55]},
        "3960": {"vr": "IS", "Value": [48]},
        "3961": {"vr": "IS", "Value": [53]},
        "3962": {"vr": "IS", "Value": [14]},
        "3963": {"vr": "IS", "Value": [22]},
        "3964": {"vr": "IS", "Value": [13]},
        "3965": {"vr": "IS", "Value": [18]},
        "3966": {"vr": "IS", "Value": [55]},
        "3967": {"vr": "IS", "Value": [47]},
        "3968": {"vr": "IS", "Value": [36]},
        "3969": {"vr": "IS", "Value": [58]},
        "3970": {"vr": "IS", "Value": [34]},
        "3971": {"vr": "IS", "Value": [51]},
        "3972": {"vr": "IS", "Value": [8]},
        "3973": {"vr": "IS", "Value": [52]},
        "3974": {"vr": "IS", "Value": [4]},
        "3975": {"vr": "IS", "Value": [25]},
        "3976": {"vr": "IS", "Value": [42]},
        "3977": {"vr": "IS", "Value": [52]},
        "3978": {"vr": "IS", "Value": [50]},
        "3979": {"vr": "IS", "Value": [14]},
        "3980": {"vr": "IS", "Value": [59]},
        "3981": {"vr": "IS", "Value": [50]},
        "3982": {"vr": "IS", "Value": [40]},
        "3983": {"vr": "IS", "Value": [24]},
        "3984": {"vr": "IS", "Value": [16]},
        "3985": {"vr": "IS", "Value": [2]},
        "3986": {"vr": "IS", "Value": [44]},
        "3987": {"vr": "IS", "Value": [29]},
        "3988": {"vr": "IS", "Value": [46]},
        "3989": {"vr": "IS", "Value": [41]},
        "3990": {"vr": "IS", "Value": [33]},
        "3991": {"vr": "IS", "Value": [44]},
        "3992": {"vr": "IS", "Value": [34]},
        "3993": {"vr": "IS", "Value": [53]},
        "3994": {"vr": "IS", "Value": [22]},
        "3995": {"vr": "IS", "Value": [13]},
        "3996": {"vr": "IS", "Value": [14]},
        "3997": {"vr": "IS", "Value": [49]},
        "3998": {"vr": "IS", "Value": [10]},
        "3999": {"vr": "IS", "Value": [40]},
        "4000": {"vr": "IS", "Value": [45]},
        "4001": {"vr": "IS", "Value": [45]},
        "4002": {"vr": "IS", "Value": [33]},
        "4003": {"vr": "IS", "Value": [59]},
        "4004": {"vr": "IS", "Value": [14]},
        "4005": {"vr": "IS", "Value": [33]},
        "4006": {"vr": "IS", "Value": [2]},
        "4007": {"vr": "IS", "Value": [30]},
        "4008": {"vr": "IS", "Value": [25]},
        "4009": {"vr": "IS", "Value": [7]},
        "4010": {"vr": "IS", "Value": [55]},
        "4011": {"vr": "IS", "Value": [49]},
        "4012": {"vr": "IS", "Value": [47]},
        "4013": {"vr": "IS", "Value": [41]},
        "4014": {"vr": "IS", "Value": [9]},
        "4015": {"vr": "IS", "Value": [58]},
        "4016": {"vr": "IS", "Value": [39]},
        "4017": {"vr": "IS", "Value": [30]},
        "4018": {"vr": "IS", "Value": [27]},
        "4019": {"vr": "IS", "Value": [20]},
    },
    "00280107": {
        "0": {"vr": "US", "Value": [87]},
        "1": {"vr": "US", "Value": [36]},
        "2": {"vr": "US", "Value": [66]},
        "3": {"vr": "US", "Value": [1836]},
        "4": {"vr": "US", "Value": [112]},
        "5": {"vr": "US", "Value": [106]},
        "6": {"vr": "US", "Value": [85]},
        "7": {"vr": "US", "Value": [130]},
        "8": {"vr": "US", "Value": [100]},
        "9": {"vr": "US", "Value": [78]},
        "10": {"vr": "US", "Value": [106]},
        "11": {"vr": "US", "Value": [74]},
        "12": {"vr": "US", "Value": [88]},
        "13": {"vr": "US", "Value": [791]},
        "14": {"vr": "US", "Value": [887]},
        "15": {"vr": "US", "Value": [53]},
        "16": {"vr": "US", "Value": [99]},
        "17": {"vr": "US", "Value": [89]},
        "18": {"vr": "US", "Value": [133]},
        "19": {"vr": "US", "Value": [73]},
        "20": {"vr": "US", "Value": [117]},
        "21": {"vr": "US", "Value": [87]},
        "22": {"vr": "US", "Value": [40]},
        "23": {"vr": "US", "Value": [75]},
        "24": {"vr": "US", "Value": [91]},
        "25": {"vr": "US", "Value": [87]},
        "26": {"vr": "US", "Value": [86]},
        "27": {"vr": "US", "Value": [84]},
        "28": {"vr": "US", "Value": [103]},
        "29": {"vr": "US", "Value": [144]},
        "30": {"vr": "US", "Value": [82]},
        "31": {"vr": "US", "Value": [720]},
        "32": {"vr": "US", "Value": [80]},
        "33": {"vr": "US", "Value": [73]},
        "34": {"vr": "US", "Value": [836]},
        "35": {"vr": "US", "Value": [1056]},
        "36": {"vr": "US", "Value": [84]},
        "37": {"vr": "US", "Value": [105]},
        "38": {"vr": "US", "Value": [55]},
        "39": {"vr": "US", "Value": [87]},
        "40": {"vr": "US", "Value": [795]},
        "41": {"vr": "US", "Value": [100]},
        "42": {"vr": "US", "Value": [88]},
        "43": {"vr": "US", "Value": [100]},
        "44": {"vr": "US", "Value": [85]},
        "45": {"vr": "US", "Value": [46]},
        "46": {"vr": "US", "Value": [46]},
        "47": {"vr": "US", "Value": [93]},
        "48": {"vr": "US", "Value": [44]},
        "49": {"vr": "US", "Value": [43]},
        "50": {"vr": "US", "Value": [99]},
        "51": {"vr": "US", "Value": [83]},
        "52": {"vr": "US", "Value": [60]},
        "53": {"vr": "US", "Value": [64]},
        "54": {"vr": "US", "Value": [65]},
        "55": {"vr": "US", "Value": [90]},
        "56": {"vr": "US", "Value": [77]},
        "57": {"vr": "US", "Value": [101]},
        "58": {"vr": "US", "Value": [70]},
        "59": {"vr": "US", "Value": [87]},
        "60": {"vr": "US", "Value": [830]},
        "61": {"vr": "US", "Value": [882]},
        "62": {"vr": "US", "Value": [21]},
        "63": {"vr": "US", "Value": [68]},
        "64": {"vr": "US", "Value": [57]},
        "65": {"vr": "US", "Value": [71]},
        "66": {"vr": "US", "Value": [119]},
        "67": {"vr": "US", "Value": [93]},
        "68": {"vr": "US", "Value": [864]},
        "69": {"vr": "US", "Value": [90]},
        "70": {"vr": "US", "Value": [67]},
        "71": {"vr": "US", "Value": [49]},
        "72": {"vr": "US", "Value": [80]},
        "73": {"vr": "US", "Value": [82]},
        "74": {"vr": "US", "Value": [87]},
        "75": {"vr": "US", "Value": [84]},
        "76": {"vr": "US", "Value": [94]},
        "77": {"vr": "US", "Value": [48]},
        "78": {"vr": "US", "Value": [74]},
        "79": {"vr": "US", "Value": [81]},
        "80": {"vr": "US", "Value": [1034]},
        "81": {"vr": "US", "Value": [75]},
        "82": {"vr": "US", "Value": [68]},
        "83": {"vr": "US", "Value": [80]},
        "84": {"vr": "US", "Value": [30]},
        "85": {"vr": "US", "Value": [99]},
        "86": {"vr": "US", "Value": [90]},
        "87": {"vr": "US", "Value": [56]},
        "88": {"vr": "US", "Value": [89]},
        "89": {"vr": "US", "Value": [69]},
        "90": {"vr": "US", "Value": [881]},
        "91": {"vr": "US", "Value": [926]},
        "92": {"vr": "US", "Value": [98]},
        "93": {"vr": "US", "Value": [89]},
        "94": {"vr": "US", "Value": [117]},
        "95": {"vr": "US", "Value": [86]},
        "96": {"vr": "US", "Value": [41]},
        "97": {"vr": "US", "Value": [107]},
        "98": {"vr": "US", "Value": [31]},
        "99": {"vr": "US", "Value": [87]},
        "100": {"vr": "US", "Value": [67]},
        "101": {"vr": "US", "Value": [91]},
        "102": {"vr": "US", "Value": [113]},
        "103": {"vr": "US", "Value": [96]},
        "104": {"vr": "US", "Value": [95]},
        "105": {"vr": "US", "Value": [79]},
        "106": {"vr": "US", "Value": [99]},
        "107": {"vr": "US", "Value": [94]},
        "108": {"vr": "US", "Value": [39]},
        "109": {"vr": "US", "Value": [137]},
        "110": {"vr": "US", "Value": [68]},
        "111": {"vr": "US", "Value": [68]},
        "112": {"vr": "US", "Value": [1238]},
        "113": {"vr": "US", "Value": [75]},
        "114": {"vr": "US", "Value": [786]},
        "115": {"vr": "US", "Value": [107]},
        "116": {"vr": "US", "Value": [95]},
        "117": {"vr": "US", "Value": [22]},
        "118": {"vr": "US", "Value": [33]},
        "119": {"vr": "US", "Value": [43]},
        "120": {"vr": "US", "Value": [38]},
        "121": {"vr": "US", "Value": [78]},
        "122": {"vr": "US", "Value": [56]},
        "123": {"vr": "US", "Value": [91]},
        "124": {"vr": "US", "Value": [88]},
        "125": {"vr": "US", "Value": [104]},
        "126": {"vr": "US", "Value": [65]},
        "127": {"vr": "US", "Value": [95]},
        "128": {"vr": "US", "Value": [1213]},
        "129": {"vr": "US", "Value": [71]},
        "130": {"vr": "US", "Value": [25]},
        "131": {"vr": "US", "Value": [116]},
        "132": {"vr": "US", "Value": [113]},
        "133": {"vr": "US", "Value": [93]},
        "134": {"vr": "US", "Value": [86]},
        "135": {"vr": "US", "Value": [73]},
        "136": {"vr": "US", "Value": [81]},
        "137": {"vr": "US", "Value": [87]},
        "138": {"vr": "US", "Value": [76]},
        "139": {"vr": "US", "Value": [69]},
        "140": {"vr": "US", "Value": [105]},
        "141": {"vr": "US", "Value": [75]},
        "142": {"vr": "US", "Value": [38]},
        "143": {"vr": "US", "Value": [41]},
        "144": {"vr": "US", "Value": [106]},
        "145": {"vr": "US", "Value": [73]},
        "146": {"vr": "US", "Value": [77]},
        "147": {"vr": "US", "Value": [82]},
        "148": {"vr": "US", "Value": [91]},
        "149": {"vr": "US", "Value": [101]},
        "150": {"vr": "US", "Value": [80]},
        "151": {"vr": "US", "Value": [68]},
        "152": {"vr": "US", "Value": [49]},
        "153": {"vr": "US", "Value": [131]},
        "154": {"vr": "US", "Value": [102]},
        "155": {"vr": "US", "Value": [64]},
        "156": {"vr": "US", "Value": [86]},
        "157": {"vr": "US", "Value": [91]},
        "158": {"vr": "US", "Value": [37]},
        "159": {"vr": "US", "Value": [80]},
        "160": {"vr": "US", "Value": [783]},
        "161": {"vr": "US", "Value": [38]},
        "162": {"vr": "US", "Value": [37]},
        "163": {"vr": "US", "Value": [90]},
        "164": {"vr": "US", "Value": [79]},
        "165": {"vr": "US", "Value": [85]},
        "166": {"vr": "US", "Value": [72]},
        "167": {"vr": "US", "Value": [72]},
        "168": {"vr": "US", "Value": [83]},
        "169": {"vr": "US", "Value": [36]},
        "170": {"vr": "US", "Value": [81]},
        "171": {"vr": "US", "Value": [137]},
        "172": {"vr": "US", "Value": [118]},
        "173": {"vr": "US", "Value": [96]},
        "174": {"vr": "US", "Value": [75]},
        "175": {"vr": "US", "Value": [79]},
        "176": {"vr": "US", "Value": [81]},
        "177": {"vr": "US", "Value": [108]},
        "178": {"vr": "US", "Value": [115]},
        "179": {"vr": "US", "Value": [68]},
        "180": {"vr": "US", "Value": [86]},
        "181": {"vr": "US", "Value": [45]},
        "182": {"vr": "US", "Value": [78]},
        "183": {"vr": "US", "Value": [79]},
        "184": {"vr": "US", "Value": [121]},
        "185": {"vr": "US", "Value": [87]},
        "186": {"vr": "US", "Value": [86]},
        "187": {"vr": "US", "Value": [82]},
        "188": {"vr": "US", "Value": [49]},
        "189": {"vr": "US", "Value": [19]},
        "190": {"vr": "US", "Value": [79]},
        "191": {"vr": "US", "Value": [278]},
        "192": {"vr": "US", "Value": [95]},
        "193": {"vr": "US", "Value": [48]},
        "194": {"vr": "US", "Value": [104]},
        "195": {"vr": "US", "Value": [85]},
        "196": {"vr": "US", "Value": [102]},
        "197": {"vr": "US", "Value": [73]},
        "198": {"vr": "US", "Value": [793]},
        "199": {"vr": "US", "Value": [99]},
        "200": {"vr": "US", "Value": [90]},
        "201": {"vr": "US", "Value": [118]},
        "202": {"vr": "US", "Value": [90]},
        "203": {"vr": "US", "Value": [112]},
        "204": {"vr": "US", "Value": [86]},
        "205": {"vr": "US", "Value": [94]},
        "206": {"vr": "US", "Value": [118]},
        "207": {"vr": "US", "Value": [87]},
        "208": {"vr": "US", "Value": [33]},
        "209": {"vr": "US", "Value": [76]},
        "210": {"vr": "US", "Value": [1095]},
        "211": {"vr": "US", "Value": [111]},
        "212": {"vr": "US", "Value": [65]},
        "213": {"vr": "US", "Value": [78]},
        "214": {"vr": "US", "Value": [75]},
        "215": {"vr": "US", "Value": [113]},
        "216": {"vr": "US", "Value": [95]},
        "217": {"vr": "US", "Value": [45]},
        "218": {"vr": "US", "Value": [100]},
        "219": {"vr": "US", "Value": [57]},
        "220": {"vr": "US", "Value": [96]},
        "221": {"vr": "US", "Value": [73]},
        "222": {"vr": "US", "Value": [74]},
        "223": {"vr": "US", "Value": [50]},
        "224": {"vr": "US", "Value": [63]},
        "225": {"vr": "US", "Value": [90]},
        "226": {"vr": "US", "Value": [96]},
        "227": {"vr": "US", "Value": [1119]},
        "228": {"vr": "US", "Value": [92]},
        "229": {"vr": "US", "Value": [69]},
        "230": {"vr": "US", "Value": [53]},
        "231": {"vr": "US", "Value": [88]},
        "232": {"vr": "US", "Value": [85]},
        "233": {"vr": "US", "Value": [107]},
        "234": {"vr": "US", "Value": [20]},
        "235": {"vr": "US", "Value": [103]},
        "236": {"vr": "US", "Value": [110]},
        "237": {"vr": "US", "Value": [52]},
        "238": {"vr": "US", "Value": [87]},
        "239": {"vr": "US", "Value": [71]},
        "240": {"vr": "US", "Value": [81]},
        "241": {"vr": "US", "Value": [105]},
        "242": {"vr": "US", "Value": [92]},
        "243": {"vr": "US", "Value": [750]},
        "244": {"vr": "US", "Value": [72]},
        "245": {"vr": "US", "Value": [104]},
        "246": {"vr": "US", "Value": [777]},
        "247": {"vr": "US", "Value": [160]},
        "248": {"vr": "US", "Value": [93]},
        "249": {"vr": "US", "Value": [105]},
        "250": {"vr": "US", "Value": [37]},
        "251": {"vr": "US", "Value": [82]},
        "252": {"vr": "US", "Value": [90]},
        "253": {"vr": "US", "Value": [117]},
        "254": {"vr": "US", "Value": [76]},
        "255": {"vr": "US", "Value": [56]},
        "256": {"vr": "US", "Value": [869]},
        "257": {"vr": "US", "Value": [87]},
        "258": {"vr": "US", "Value": [80]},
        "259": {"vr": "US", "Value": [109]},
        "260": {"vr": "US", "Value": [98]},
        "261": {"vr": "US", "Value": [98]},
        "262": {"vr": "US", "Value": [70]},
        "263": {"vr": "US", "Value": [75]},
        "264": {"vr": "US", "Value": [108]},
        "265": {"vr": "US", "Value": [102]},
        "266": {"vr": "US", "Value": [71]},
        "267": {"vr": "US", "Value": [69]},
        "268": {"vr": "US", "Value": [48]},
        "269": {"vr": "US", "Value": [81]},
        "270": {"vr": "US", "Value": [831]},
        "271": {"vr": "US", "Value": [108]},
        "272": {"vr": "US", "Value": [36]},
        "273": {"vr": "US", "Value": [94]},
        "274": {"vr": "US", "Value": [59]},
        "275": {"vr": "US", "Value": [1088]},
        "276": {"vr": "US", "Value": [69]},
        "277": {"vr": "US", "Value": [99]},
        "278": {"vr": "US", "Value": [92]},
        "279": {"vr": "US", "Value": [75]},
        "280": {"vr": "US", "Value": [59]},
        "281": {"vr": "US", "Value": [85]},
        "282": {"vr": "US", "Value": [81]},
        "283": {"vr": "US", "Value": [38]},
        "284": {"vr": "US", "Value": [87]},
        "285": {"vr": "US", "Value": [100]},
        "286": {"vr": "US", "Value": [38]},
        "287": {"vr": "US", "Value": [107]},
        "288": {"vr": "US", "Value": [117]},
        "289": {"vr": "US", "Value": [38]},
        "290": {"vr": "US", "Value": [973]},
        "291": {"vr": "US", "Value": [67]},
        "292": {"vr": "US", "Value": [92]},
        "293": {"vr": "US", "Value": [87]},
        "294": {"vr": "US", "Value": [51]},
        "295": {"vr": "US", "Value": [81]},
        "296": {"vr": "US", "Value": [106]},
        "297": {"vr": "US", "Value": [108]},
        "298": {"vr": "US", "Value": [106]},
        "299": {"vr": "US", "Value": [100]},
        "300": {"vr": "US", "Value": [110]},
        "301": {"vr": "US", "Value": [781]},
        "302": {"vr": "US", "Value": [82]},
        "303": {"vr": "US", "Value": [109]},
        "304": {"vr": "US", "Value": [78]},
        "305": {"vr": "US", "Value": [74]},
        "306": {"vr": "US", "Value": [76]},
        "307": {"vr": "US", "Value": [125]},
        "308": {"vr": "US", "Value": [90]},
        "309": {"vr": "US", "Value": [96]},
        "310": {"vr": "US", "Value": [72]},
        "311": {"vr": "US", "Value": [1091]},
        "312": {"vr": "US", "Value": [74]},
        "313": {"vr": "US", "Value": [799]},
        "314": {"vr": "US", "Value": [112]},
        "315": {"vr": "US", "Value": [67]},
        "316": {"vr": "US", "Value": [1267]},
        "317": {"vr": "US", "Value": [54]},
        "318": {"vr": "US", "Value": [48]},
        "319": {"vr": "US", "Value": [23]},
        "320": {"vr": "US", "Value": [84]},
        "321": {"vr": "US", "Value": [106]},
        "322": {"vr": "US", "Value": [58]},
        "323": {"vr": "US", "Value": [89]},
        "324": {"vr": "US", "Value": [89]},
        "325": {"vr": "US", "Value": [104]},
        "326": {"vr": "US", "Value": [60]},
        "327": {"vr": "US", "Value": [74]},
        "328": {"vr": "US", "Value": [89]},
        "329": {"vr": "US", "Value": [85]},
        "330": {"vr": "US", "Value": [82]},
        "331": {"vr": "US", "Value": [107]},
        "332": {"vr": "US", "Value": [80]},
        "333": {"vr": "US", "Value": [93]},
        "334": {"vr": "US", "Value": [86]},
        "335": {"vr": "US", "Value": [97]},
        "336": {"vr": "US", "Value": [79]},
        "337": {"vr": "US", "Value": [78]},
        "338": {"vr": "US", "Value": [96]},
        "339": {"vr": "US", "Value": [85]},
        "340": {"vr": "US", "Value": [72]},
        "341": {"vr": "US", "Value": [106]},
        "342": {"vr": "US", "Value": [44]},
        "343": {"vr": "US", "Value": [92]},
        "344": {"vr": "US", "Value": [96]},
        "345": {"vr": "US", "Value": [75]},
        "346": {"vr": "US", "Value": [75]},
        "347": {"vr": "US", "Value": [85]},
        "348": {"vr": "US", "Value": [103]},
        "349": {"vr": "US", "Value": [752]},
        "350": {"vr": "US", "Value": [1020]},
        "351": {"vr": "US", "Value": [80]},
        "352": {"vr": "US", "Value": [52]},
        "353": {"vr": "US", "Value": [93]},
        "354": {"vr": "US", "Value": [106]},
        "355": {"vr": "US", "Value": [114]},
        "356": {"vr": "US", "Value": [93]},
        "357": {"vr": "US", "Value": [84]},
        "358": {"vr": "US", "Value": [63]},
        "359": {"vr": "US", "Value": [102]},
        "360": {"vr": "US", "Value": [88]},
        "361": {"vr": "US", "Value": [572]},
        "362": {"vr": "US", "Value": [72]},
        "363": {"vr": "US", "Value": [303]},
        "364": {"vr": "US", "Value": [90]},
        "365": {"vr": "US", "Value": [88]},
        "366": {"vr": "US", "Value": [74]},
        "367": {"vr": "US", "Value": [90]},
        "368": {"vr": "US", "Value": [866]},
        "369": {"vr": "US", "Value": [99]},
        "370": {"vr": "US", "Value": [38]},
        "371": {"vr": "US", "Value": [82]},
        "372": {"vr": "US", "Value": [71]},
        "373": {"vr": "US", "Value": [74]},
        "374": {"vr": "US", "Value": [82]},
        "375": {"vr": "US", "Value": [116]},
        "376": {"vr": "US", "Value": [100]},
        "377": {"vr": "US", "Value": [78]},
        "378": {"vr": "US", "Value": [66]},
        "379": {"vr": "US", "Value": [50]},
        "380": {"vr": "US", "Value": [50]},
        "381": {"vr": "US", "Value": [60]},
        "382": {"vr": "US", "Value": [83]},
        "383": {"vr": "US", "Value": [828]},
        "384": {"vr": "US", "Value": [833]},
        "385": {"vr": "US", "Value": [35]},
        "386": {"vr": "US", "Value": [86]},
        "387": {"vr": "US", "Value": [77]},
        "388": {"vr": "US", "Value": [117]},
        "389": {"vr": "US", "Value": [116]},
        "390": {"vr": "US", "Value": [38]},
        "391": {"vr": "US", "Value": [81]},
        "392": {"vr": "US", "Value": [100]},
        "393": {"vr": "US", "Value": [42]},
        "394": {"vr": "US", "Value": [115]},
        "395": {"vr": "US", "Value": [87]},
        "396": {"vr": "US", "Value": [1170]},
        "397": {"vr": "US", "Value": [89]},
        "398": {"vr": "US", "Value": [99]},
        "399": {"vr": "US", "Value": [852]},
        "400": {"vr": "US", "Value": [80]},
        "401": {"vr": "US", "Value": [84]},
        "402": {"vr": "US", "Value": [87]},
        "403": {"vr": "US", "Value": [69]},
        "404": {"vr": "US", "Value": [93]},
        "405": {"vr": "US", "Value": [87]},
        "406": {"vr": "US", "Value": [70]},
        "407": {"vr": "US", "Value": [74]},
        "408": {"vr": "US", "Value": [100]},
        "409": {"vr": "US", "Value": [114]},
        "410": {"vr": "US", "Value": [109]},
        "411": {"vr": "US", "Value": [59]},
        "412": {"vr": "US", "Value": [93]},
        "413": {"vr": "US", "Value": [121]},
        "414": {"vr": "US", "Value": [96]},
        "415": {"vr": "US", "Value": [104]},
        "416": {"vr": "US", "Value": [90]},
        "417": {"vr": "US", "Value": [99]},
        "418": {"vr": "US", "Value": [803]},
        "419": {"vr": "US", "Value": [85]},
        "420": {"vr": "US", "Value": [105]},
        "421": {"vr": "US", "Value": [75]},
        "422": {"vr": "US", "Value": [57]},
        "423": {"vr": "US", "Value": [85]},
        "424": {"vr": "US", "Value": [841]},
        "425": {"vr": "US", "Value": [67]},
        "426": {"vr": "US", "Value": [102]},
        "427": {"vr": "US", "Value": [129]},
        "428": {"vr": "US", "Value": [117]},
        "429": {"vr": "US", "Value": [88]},
        "430": {"vr": "US", "Value": [69]},
        "431": {"vr": "US", "Value": [104]},
        "432": {"vr": "US", "Value": [40]},
        "433": {"vr": "US", "Value": [84]},
        "434": {"vr": "US", "Value": [94]},
        "435": {"vr": "US", "Value": [83]},
        "436": {"vr": "US", "Value": [82]},
        "437": {"vr": "US", "Value": [77]},
        "438": {"vr": "US", "Value": [49]},
        "439": {"vr": "US", "Value": [70]},
        "440": {"vr": "US", "Value": [112]},
        "441": {"vr": "US", "Value": [112]},
        "442": {"vr": "US", "Value": [105]},
        "443": {"vr": "US", "Value": [23]},
        "444": {"vr": "US", "Value": [108]},
        "445": {"vr": "US", "Value": [858]},
        "446": {"vr": "US", "Value": [117]},
        "447": {"vr": "US", "Value": [114]},
        "448": {"vr": "US", "Value": [841]},
        "449": {"vr": "US", "Value": [65]},
        "450": {"vr": "US", "Value": [74]},
        "451": {"vr": "US", "Value": [93]},
        "452": {"vr": "US", "Value": [77]},
        "453": {"vr": "US", "Value": [81]},
        "454": {"vr": "US", "Value": [38]},
        "455": {"vr": "US", "Value": [87]},
        "456": {"vr": "US", "Value": [81]},
        "457": {"vr": "US", "Value": [79]},
        "458": {"vr": "US", "Value": [77]},
        "459": {"vr": "US", "Value": [104]},
        "460": {"vr": "US", "Value": [34]},
        "461": {"vr": "US", "Value": [96]},
        "462": {"vr": "US", "Value": [79]},
        "463": {"vr": "US", "Value": [109]},
        "464": {"vr": "US", "Value": [68]},
        "465": {"vr": "US", "Value": [117]},
        "466": {"vr": "US", "Value": [62]},
        "467": {"vr": "US", "Value": [40]},
        "468": {"vr": "US", "Value": [94]},
        "469": {"vr": "US", "Value": [1011]},
        "470": {"vr": "US", "Value": [45]},
        "471": {"vr": "US", "Value": [58]},
        "472": {"vr": "US", "Value": [82]},
        "473": {"vr": "US", "Value": [94]},
        "474": {"vr": "US", "Value": [95]},
        "475": {"vr": "US", "Value": [1706]},
        "476": {"vr": "US", "Value": [84]},
        "477": {"vr": "US", "Value": [85]},
        "478": {"vr": "US", "Value": [62]},
        "479": {"vr": "US", "Value": [75]},
        "480": {"vr": "US", "Value": [109]},
        "481": {"vr": "US", "Value": [91]},
        "482": {"vr": "US", "Value": [84]},
        "483": {"vr": "US", "Value": [1309]},
        "484": {"vr": "US", "Value": [95]},
        "485": {"vr": "US", "Value": [72]},
        "486": {"vr": "US", "Value": [70]},
        "487": {"vr": "US", "Value": [74]},
        "488": {"vr": "US", "Value": [98]},
        "489": {"vr": "US", "Value": [32]},
        "490": {"vr": "US", "Value": [114]},
        "491": {"vr": "US", "Value": [81]},
        "492": {"vr": "US", "Value": [83]},
        "493": {"vr": "US", "Value": [66]},
        "494": {"vr": "US", "Value": [82]},
        "495": {"vr": "US", "Value": [76]},
        "496": {"vr": "US", "Value": [95]},
        "497": {"vr": "US", "Value": [838]},
        "498": {"vr": "US", "Value": [77]},
        "499": {"vr": "US", "Value": [106]},
        "500": {"vr": "US", "Value": [53]},
        "501": {"vr": "US", "Value": [742]},
        "502": {"vr": "US", "Value": [98]},
        "503": {"vr": "US", "Value": [87]},
        "504": {"vr": "US", "Value": [91]},
        "505": {"vr": "US", "Value": [85]},
        "506": {"vr": "US", "Value": [19]},
        "507": {"vr": "US", "Value": [1024]},
        "508": {"vr": "US", "Value": [72]},
        "509": {"vr": "US", "Value": [83]},
        "510": {"vr": "US", "Value": [103]},
        "511": {"vr": "US", "Value": [87]},
        "512": {"vr": "US", "Value": [45]},
        "513": {"vr": "US", "Value": [99]},
        "514": {"vr": "US", "Value": [770]},
        "515": {"vr": "US", "Value": [778]},
        "516": {"vr": "US", "Value": [134]},
        "517": {"vr": "US", "Value": [107]},
        "518": {"vr": "US", "Value": [67]},
        "519": {"vr": "US", "Value": [89]},
        "520": {"vr": "US", "Value": [750]},
        "521": {"vr": "US", "Value": [106]},
        "522": {"vr": "US", "Value": [77]},
        "523": {"vr": "US", "Value": [82]},
        "524": {"vr": "US", "Value": [99]},
        "525": {"vr": "US", "Value": [107]},
        "526": {"vr": "US", "Value": [39]},
        "527": {"vr": "US", "Value": [74]},
        "528": {"vr": "US", "Value": [56]},
        "529": {"vr": "US", "Value": [23]},
        "530": {"vr": "US", "Value": [93]},
        "531": {"vr": "US", "Value": [839]},
        "532": {"vr": "US", "Value": [88]},
        "533": {"vr": "US", "Value": [109]},
        "534": {"vr": "US", "Value": [75]},
        "535": {"vr": "US", "Value": [72]},
        "536": {"vr": "US", "Value": [72]},
        "537": {"vr": "US", "Value": [58]},
        "538": {"vr": "US", "Value": [62]},
        "539": {"vr": "US", "Value": [1000]},
        "540": {"vr": "US", "Value": [79]},
        "541": {"vr": "US", "Value": [64]},
        "542": {"vr": "US", "Value": [805]},
        "543": {"vr": "US", "Value": [46]},
        "544": {"vr": "US", "Value": [840]},
        "545": {"vr": "US", "Value": [98]},
        "546": {"vr": "US", "Value": [22]},
        "547": {"vr": "US", "Value": [84]},
        "548": {"vr": "US", "Value": [799]},
        "549": {"vr": "US", "Value": [104]},
        "550": {"vr": "US", "Value": [95]},
        "551": {"vr": "US", "Value": [97]},
        "552": {"vr": "US", "Value": [113]},
        "553": {"vr": "US", "Value": [799]},
        "554": {"vr": "US", "Value": [833]},
        "555": {"vr": "US", "Value": [837]},
        "556": {"vr": "US", "Value": [101]},
        "557": {"vr": "US", "Value": [90]},
        "558": {"vr": "US", "Value": [101]},
        "559": {"vr": "US", "Value": [126]},
        "560": {"vr": "US", "Value": [78]},
        "561": {"vr": "US", "Value": [93]},
        "562": {"vr": "US", "Value": [47]},
        "563": {"vr": "US", "Value": [85]},
        "564": {"vr": "US", "Value": [80]},
        "565": {"vr": "US", "Value": [72]},
        "566": {"vr": "US", "Value": [36]},
        "567": {"vr": "US", "Value": [855]},
        "568": {"vr": "US", "Value": [83]},
        "569": {"vr": "US", "Value": [83]},
        "570": {"vr": "US", "Value": [107]},
        "571": {"vr": "US", "Value": [80]},
        "572": {"vr": "US", "Value": [40]},
        "573": {"vr": "US", "Value": [82]},
        "574": {"vr": "US", "Value": [86]},
        "575": {"vr": "US", "Value": [73]},
        "576": {"vr": "US", "Value": [19]},
        "577": {"vr": "US", "Value": [98]},
        "578": {"vr": "US", "Value": [79]},
        "579": {"vr": "US", "Value": [77]},
        "580": {"vr": "US", "Value": [24]},
        "581": {"vr": "US", "Value": [86]},
        "582": {"vr": "US", "Value": [83]},
        "583": {"vr": "US", "Value": [73]},
        "584": {"vr": "US", "Value": [61]},
        "585": {"vr": "US", "Value": [1256]},
        "586": {"vr": "US", "Value": [78]},
        "587": {"vr": "US", "Value": [916]},
        "588": {"vr": "US", "Value": [37]},
        "589": {"vr": "US", "Value": [70]},
        "590": {"vr": "US", "Value": [97]},
        "591": {"vr": "US", "Value": [44]},
        "592": {"vr": "US", "Value": [125]},
        "593": {"vr": "US", "Value": [37]},
        "594": {"vr": "US", "Value": [80]},
        "595": {"vr": "US", "Value": [127]},
        "596": {"vr": "US", "Value": [82]},
        "597": {"vr": "US", "Value": [64]},
        "598": {"vr": "US", "Value": [44]},
        "599": {"vr": "US", "Value": [86]},
        "600": {"vr": "US", "Value": [731]},
        "601": {"vr": "US", "Value": [78]},
        "602": {"vr": "US", "Value": [101]},
        "603": {"vr": "US", "Value": [112]},
        "604": {"vr": "US", "Value": [93]},
        "605": {"vr": "US", "Value": [118]},
        "606": {"vr": "US", "Value": [84]},
        "607": {"vr": "US", "Value": [51]},
        "608": {"vr": "US", "Value": [116]},
        "609": {"vr": "US", "Value": [69]},
        "610": {"vr": "US", "Value": [78]},
        "611": {"vr": "US", "Value": [962]},
        "612": {"vr": "US", "Value": [109]},
        "613": {"vr": "US", "Value": [131]},
        "614": {"vr": "US", "Value": [90]},
        "615": {"vr": "US", "Value": [48]},
        "616": {"vr": "US", "Value": [95]},
        "617": {"vr": "US", "Value": [113]},
        "618": {"vr": "US", "Value": [55]},
        "619": {"vr": "US", "Value": [69]},
        "620": {"vr": "US", "Value": [106]},
        "621": {"vr": "US", "Value": [33]},
        "622": {"vr": "US", "Value": [87]},
        "623": {"vr": "US", "Value": [45]},
        "624": {"vr": "US", "Value": [1470]},
        "625": {"vr": "US", "Value": [73]},
        "626": {"vr": "US", "Value": [77]},
        "627": {"vr": "US", "Value": [88]},
        "628": {"vr": "US", "Value": [100]},
        "629": {"vr": "US", "Value": [118]},
        "630": {"vr": "US", "Value": [75]},
        "631": {"vr": "US", "Value": [97]},
        "632": {"vr": "US", "Value": [73]},
        "633": {"vr": "US", "Value": [80]},
        "634": {"vr": "US", "Value": [85]},
        "635": {"vr": "US", "Value": [69]},
        "636": {"vr": "US", "Value": [107]},
        "637": {"vr": "US", "Value": [75]},
        "638": {"vr": "US", "Value": [107]},
        "639": {"vr": "US", "Value": [82]},
        "640": {"vr": "US", "Value": [65]},
        "641": {"vr": "US", "Value": [82]},
        "642": {"vr": "US", "Value": [85]},
        "643": {"vr": "US", "Value": [97]},
        "644": {"vr": "US", "Value": [92]},
        "645": {"vr": "US", "Value": [75]},
        "646": {"vr": "US", "Value": [48]},
        "647": {"vr": "US", "Value": [78]},
        "648": {"vr": "US", "Value": [44]},
        "649": {"vr": "US", "Value": [60]},
        "650": {"vr": "US", "Value": [63]},
        "651": {"vr": "US", "Value": [90]},
        "652": {"vr": "US", "Value": [108]},
        "653": {"vr": "US", "Value": [79]},
        "654": {"vr": "US", "Value": [69]},
        "655": {"vr": "US", "Value": [83]},
        "656": {"vr": "US", "Value": [115]},
        "657": {"vr": "US", "Value": [95]},
        "658": {"vr": "US", "Value": [94]},
        "659": {"vr": "US", "Value": [82]},
        "660": {"vr": "US", "Value": [110]},
        "661": {"vr": "US", "Value": [62]},
        "662": {"vr": "US", "Value": [114]},
        "663": {"vr": "US", "Value": [95]},
        "664": {"vr": "US", "Value": [66]},
        "665": {"vr": "US", "Value": [149]},
        "666": {"vr": "US", "Value": [108]},
        "667": {"vr": "US", "Value": [103]},
        "668": {"vr": "US", "Value": [798]},
        "669": {"vr": "US", "Value": [116]},
        "670": {"vr": "US", "Value": [83]},
        "671": {"vr": "US", "Value": [53]},
        "672": {"vr": "US", "Value": [98]},
        "673": {"vr": "US", "Value": [77]},
        "674": {"vr": "US", "Value": [70]},
        "675": {"vr": "US", "Value": [110]},
        "676": {"vr": "US", "Value": [86]},
        "677": {"vr": "US", "Value": [123]},
        "678": {"vr": "US", "Value": [60]},
        "679": {"vr": "US", "Value": [760]},
        "680": {"vr": "US", "Value": [65]},
        "681": {"vr": "US", "Value": [61]},
        "682": {"vr": "US", "Value": [121]},
        "683": {"vr": "US", "Value": [43]},
        "684": {"vr": "US", "Value": [52]},
        "685": {"vr": "US", "Value": [81]},
        "686": {"vr": "US", "Value": [66]},
        "687": {"vr": "US", "Value": [1403]},
        "688": {"vr": "US", "Value": [124]},
        "689": {"vr": "US", "Value": [91]},
        "690": {"vr": "US", "Value": [1286]},
        "691": {"vr": "US", "Value": [76]},
        "692": {"vr": "US", "Value": [84]},
        "693": {"vr": "US", "Value": [107]},
        "694": {"vr": "US", "Value": [80]},
        "695": {"vr": "US", "Value": [79]},
        "696": {"vr": "US", "Value": [92]},
        "697": {"vr": "US", "Value": [98]},
        "698": {"vr": "US", "Value": [82]},
        "699": {"vr": "US", "Value": [829]},
        "700": {"vr": "US", "Value": [54]},
        "701": {"vr": "US", "Value": [84]},
        "702": {"vr": "US", "Value": [116]},
        "703": {"vr": "US", "Value": [73]},
        "704": {"vr": "US", "Value": [53]},
        "705": {"vr": "US", "Value": [83]},
        "706": {"vr": "US", "Value": [70]},
        "707": {"vr": "US", "Value": [840]},
        "708": {"vr": "US", "Value": [82]},
        "709": {"vr": "US", "Value": [83]},
        "710": {"vr": "US", "Value": [72]},
        "711": {"vr": "US", "Value": [83]},
        "712": {"vr": "US", "Value": [34]},
        "713": {"vr": "US", "Value": [116]},
        "714": {"vr": "US", "Value": [831]},
        "715": {"vr": "US", "Value": [1438]},
        "716": {"vr": "US", "Value": [72]},
        "717": {"vr": "US", "Value": [71]},
        "718": {"vr": "US", "Value": [99]},
        "719": {"vr": "US", "Value": [122]},
        "720": {"vr": "US", "Value": [63]},
        "721": {"vr": "US", "Value": [42]},
        "722": {"vr": "US", "Value": [100]},
        "723": {"vr": "US", "Value": [37]},
        "724": {"vr": "US", "Value": [88]},
        "725": {"vr": "US", "Value": [73]},
        "726": {"vr": "US", "Value": [97]},
        "727": {"vr": "US", "Value": [84]},
        "728": {"vr": "US", "Value": [86]},
        "729": {"vr": "US", "Value": [52]},
        "730": {"vr": "US", "Value": [68]},
        "731": {"vr": "US", "Value": [89]},
        "732": {"vr": "US", "Value": [819]},
        "733": {"vr": "US", "Value": [54]},
        "734": {"vr": "US", "Value": [96]},
        "735": {"vr": "US", "Value": [78]},
        "736": {"vr": "US", "Value": [85]},
        "737": {"vr": "US", "Value": [109]},
        "738": {"vr": "US", "Value": [96]},
        "739": {"vr": "US", "Value": [79]},
        "740": {"vr": "US", "Value": [105]},
        "741": {"vr": "US", "Value": [100]},
        "742": {"vr": "US", "Value": [95]},
        "743": {"vr": "US", "Value": [72]},
        "744": {"vr": "US", "Value": [90]},
        "745": {"vr": "US", "Value": [110]},
        "746": {"vr": "US", "Value": [107]},
        "747": {"vr": "US", "Value": [102]},
        "748": {"vr": "US", "Value": [93]},
        "749": {"vr": "US", "Value": [110]},
        "750": {"vr": "US", "Value": [96]},
        "751": {"vr": "US", "Value": [75]},
        "752": {"vr": "US", "Value": [38]},
        "753": {"vr": "US", "Value": [80]},
        "754": {"vr": "US", "Value": [74]},
        "755": {"vr": "US", "Value": [97]},
        "756": {"vr": "US", "Value": [47]},
        "757": {"vr": "US", "Value": [1154]},
        "758": {"vr": "US", "Value": [122]},
        "759": {"vr": "US", "Value": [83]},
        "760": {"vr": "US", "Value": [110]},
        "761": {"vr": "US", "Value": [50]},
        "762": {"vr": "US", "Value": [70]},
        "763": {"vr": "US", "Value": [61]},
        "764": {"vr": "US", "Value": [85]},
        "765": {"vr": "US", "Value": [101]},
        "766": {"vr": "US", "Value": [73]},
        "767": {"vr": "US", "Value": [109]},
        "768": {"vr": "US", "Value": [69]},
        "769": {"vr": "US", "Value": [50]},
        "770": {"vr": "US", "Value": [92]},
        "771": {"vr": "US", "Value": [709]},
        "772": {"vr": "US", "Value": [95]},
        "773": {"vr": "US", "Value": [96]},
        "774": {"vr": "US", "Value": [124]},
        "775": {"vr": "US", "Value": [95]},
        "776": {"vr": "US", "Value": [85]},
        "777": {"vr": "US", "Value": [774]},
        "778": {"vr": "US", "Value": [22]},
        "779": {"vr": "US", "Value": [88]},
        "780": {"vr": "US", "Value": [57]},
        "781": {"vr": "US", "Value": [68]},
        "782": {"vr": "US", "Value": [94]},
        "783": {"vr": "US", "Value": [98]},
        "784": {"vr": "US", "Value": [84]},
        "785": {"vr": "US", "Value": [73]},
        "786": {"vr": "US", "Value": [92]},
        "787": {"vr": "US", "Value": [19]},
        "788": {"vr": "US", "Value": [715]},
        "789": {"vr": "US", "Value": [59]},
        "790": {"vr": "US", "Value": [47]},
        "791": {"vr": "US", "Value": [956]},
        "792": {"vr": "US", "Value": [85]},
        "793": {"vr": "US", "Value": [109]},
        "794": {"vr": "US", "Value": [73]},
        "795": {"vr": "US", "Value": [89]},
        "796": {"vr": "US", "Value": [93]},
        "797": {"vr": "US", "Value": [78]},
        "798": {"vr": "US", "Value": [65]},
        "799": {"vr": "US", "Value": [119]},
        "800": {"vr": "US", "Value": [74]},
        "801": {"vr": "US", "Value": [85]},
        "802": {"vr": "US", "Value": [88]},
        "803": {"vr": "US", "Value": [116]},
        "804": {"vr": "US", "Value": [94]},
        "805": {"vr": "US", "Value": [88]},
        "806": {"vr": "US", "Value": [18]},
        "807": {"vr": "US", "Value": [119]},
        "808": {"vr": "US", "Value": [99]},
        "809": {"vr": "US", "Value": [114]},
        "810": {"vr": "US", "Value": [781]},
        "811": {"vr": "US", "Value": [78]},
        "812": {"vr": "US", "Value": [21]},
        "813": {"vr": "US", "Value": [80]},
        "814": {"vr": "US", "Value": [109]},
        "815": {"vr": "US", "Value": [99]},
        "816": {"vr": "US", "Value": [755]},
        "817": {"vr": "US", "Value": [82]},
        "818": {"vr": "US", "Value": [69]},
        "819": {"vr": "US", "Value": [42]},
        "820": {"vr": "US", "Value": [836]},
        "821": {"vr": "US", "Value": [68]},
        "822": {"vr": "US", "Value": [94]},
        "823": {"vr": "US", "Value": [59]},
        "824": {"vr": "US", "Value": [83]},
        "825": {"vr": "US", "Value": [89]},
        "826": {"vr": "US", "Value": [70]},
        "827": {"vr": "US", "Value": [825]},
        "828": {"vr": "US", "Value": [88]},
        "829": {"vr": "US", "Value": [901]},
        "830": {"vr": "US", "Value": [50]},
        "831": {"vr": "US", "Value": [71]},
        "832": {"vr": "US", "Value": [113]},
        "833": {"vr": "US", "Value": [74]},
        "834": {"vr": "US", "Value": [67]},
        "835": {"vr": "US", "Value": [98]},
        "836": {"vr": "US", "Value": [66]},
        "837": {"vr": "US", "Value": [76]},
        "838": {"vr": "US", "Value": [86]},
        "839": {"vr": "US", "Value": [115]},
        "840": {"vr": "US", "Value": [77]},
        "841": {"vr": "US", "Value": [120]},
        "842": {"vr": "US", "Value": [85]},
        "843": {"vr": "US", "Value": [120]},
        "844": {"vr": "US", "Value": [80]},
        "845": {"vr": "US", "Value": [55]},
        "846": {"vr": "US", "Value": [1336]},
        "847": {"vr": "US", "Value": [109]},
        "848": {"vr": "US", "Value": [57]},
        "849": {"vr": "US", "Value": [86]},
        "850": {"vr": "US", "Value": [1217]},
        "851": {"vr": "US", "Value": [90]},
        "852": {"vr": "US", "Value": [78]},
        "853": {"vr": "US", "Value": [84]},
        "854": {"vr": "US", "Value": [79]},
        "855": {"vr": "US", "Value": [105]},
        "856": {"vr": "US", "Value": [96]},
        "857": {"vr": "US", "Value": [81]},
        "858": {"vr": "US", "Value": [118]},
        "859": {"vr": "US", "Value": [47]},
        "860": {"vr": "US", "Value": [48]},
        "861": {"vr": "US", "Value": [1169]},
        "862": {"vr": "US", "Value": [80]},
        "863": {"vr": "US", "Value": [90]},
        "864": {"vr": "US", "Value": [86]},
        "865": {"vr": "US", "Value": [43]},
        "866": {"vr": "US", "Value": [91]},
        "867": {"vr": "US", "Value": [1119]},
        "868": {"vr": "US", "Value": [766]},
        "869": {"vr": "US", "Value": [65]},
        "870": {"vr": "US", "Value": [118]},
        "871": {"vr": "US", "Value": [75]},
        "872": {"vr": "US", "Value": [75]},
        "873": {"vr": "US", "Value": [103]},
        "874": {"vr": "US", "Value": [115]},
        "875": {"vr": "US", "Value": [770]},
        "876": {"vr": "US", "Value": [73]},
        "877": {"vr": "US", "Value": [111]},
        "878": {"vr": "US", "Value": [78]},
        "879": {"vr": "US", "Value": [72]},
        "880": {"vr": "US", "Value": [83]},
        "881": {"vr": "US", "Value": [87]},
        "882": {"vr": "US", "Value": [70]},
        "883": {"vr": "US", "Value": [85]},
        "884": {"vr": "US", "Value": [107]},
        "885": {"vr": "US", "Value": [820]},
        "886": {"vr": "US", "Value": [72]},
        "887": {"vr": "US", "Value": [87]},
        "888": {"vr": "US", "Value": [83]},
        "889": {"vr": "US", "Value": [117]},
        "890": {"vr": "US", "Value": [105]},
        "891": {"vr": "US", "Value": [48]},
        "892": {"vr": "US", "Value": [79]},
        "893": {"vr": "US", "Value": [74]},
        "894": {"vr": "US", "Value": [74]},
        "895": {"vr": "US", "Value": [93]},
        "896": {"vr": "US", "Value": [40]},
        "897": {"vr": "US", "Value": [93]},
        "898": {"vr": "US", "Value": [91]},
        "899": {"vr": "US", "Value": [102]},
        "900": {"vr": "US", "Value": [92]},
        "901": {"vr": "US", "Value": [76]},
        "902": {"vr": "US", "Value": [81]},
        "903": {"vr": "US", "Value": [84]},
        "904": {"vr": "US", "Value": [83]},
        "905": {"vr": "US", "Value": [84]},
        "906": {"vr": "US", "Value": [77]},
        "907": {"vr": "US", "Value": [125]},
        "908": {"vr": "US", "Value": [113]},
        "909": {"vr": "US", "Value": [104]},
        "910": {"vr": "US", "Value": [44]},
        "911": {"vr": "US", "Value": [102]},
        "912": {"vr": "US", "Value": [73]},
        "913": {"vr": "US", "Value": [40]},
        "914": {"vr": "US", "Value": [77]},
        "915": {"vr": "US", "Value": [79]},
        "916": {"vr": "US", "Value": [25]},
        "917": {"vr": "US", "Value": [123]},
        "918": {"vr": "US", "Value": [80]},
        "919": {"vr": "US", "Value": [1402]},
        "920": {"vr": "US", "Value": [62]},
        "921": {"vr": "US", "Value": [86]},
        "922": {"vr": "US", "Value": [101]},
        "923": {"vr": "US", "Value": [56]},
        "924": {"vr": "US", "Value": [863]},
        "925": {"vr": "US", "Value": [89]},
        "926": {"vr": "US", "Value": [1247]},
        "927": {"vr": "US", "Value": [54]},
        "928": {"vr": "US", "Value": [87]},
        "929": {"vr": "US", "Value": [128]},
        "930": {"vr": "US", "Value": [76]},
        "931": {"vr": "US", "Value": [41]},
        "932": {"vr": "US", "Value": [768]},
        "933": {"vr": "US", "Value": [92]},
        "934": {"vr": "US", "Value": [79]},
        "935": {"vr": "US", "Value": [70]},
        "936": {"vr": "US", "Value": [878]},
        "937": {"vr": "US", "Value": [95]},
        "938": {"vr": "US", "Value": [52]},
        "939": {"vr": "US", "Value": [107]},
        "940": {"vr": "US", "Value": [100]},
        "941": {"vr": "US", "Value": [50]},
        "942": {"vr": "US", "Value": [82]},
        "943": {"vr": "US", "Value": [84]},
        "944": {"vr": "US", "Value": [100]},
        "945": {"vr": "US", "Value": [87]},
        "946": {"vr": "US", "Value": [82]},
        "947": {"vr": "US", "Value": [75]},
        "948": {"vr": "US", "Value": [1974]},
        "949": {"vr": "US", "Value": [69]},
        "950": {"vr": "US", "Value": [89]},
        "951": {"vr": "US", "Value": [92]},
        "952": {"vr": "US", "Value": [85]},
        "953": {"vr": "US", "Value": [80]},
        "954": {"vr": "US", "Value": [48]},
        "955": {"vr": "US", "Value": [99]},
        "956": {"vr": "US", "Value": [737]},
        "957": {"vr": "US", "Value": [100]},
        "958": {"vr": "US", "Value": [84]},
        "959": {"vr": "US", "Value": [72]},
        "960": {"vr": "US", "Value": [48]},
        "961": {"vr": "US", "Value": [839]},
        "962": {"vr": "US", "Value": [70]},
        "963": {"vr": "US", "Value": [90]},
        "964": {"vr": "US", "Value": [116]},
        "965": {"vr": "US", "Value": [92]},
        "966": {"vr": "US", "Value": [44]},
        "967": {"vr": "US", "Value": [93]},
        "968": {"vr": "US", "Value": [113]},
        "969": {"vr": "US", "Value": [40]},
        "970": {"vr": "US", "Value": [100]},
        "971": {"vr": "US", "Value": [87]},
        "972": {"vr": "US", "Value": [81]},
        "973": {"vr": "US", "Value": [36]},
        "974": {"vr": "US", "Value": [46]},
        "975": {"vr": "US", "Value": [94]},
        "976": {"vr": "US", "Value": [85]},
        "977": {"vr": "US", "Value": [88]},
        "978": {"vr": "US", "Value": [1131]},
        "979": {"vr": "US", "Value": [80]},
        "980": {"vr": "US", "Value": [73]},
        "981": {"vr": "US", "Value": [40]},
        "982": {"vr": "US", "Value": [106]},
        "983": {"vr": "US", "Value": [760]},
        "984": {"vr": "US", "Value": [74]},
        "985": {"vr": "US", "Value": [85]},
        "986": {"vr": "US", "Value": [95]},
        "987": {"vr": "US", "Value": [85]},
        "988": {"vr": "US", "Value": [55]},
        "989": {"vr": "US", "Value": [92]},
        "990": {"vr": "US", "Value": [38]},
        "991": {"vr": "US", "Value": [80]},
        "992": {"vr": "US", "Value": [78]},
        "993": {"vr": "US", "Value": [83]},
        "994": {"vr": "US", "Value": [97]},
        "995": {"vr": "US", "Value": [115]},
        "996": {"vr": "US", "Value": [1178]},
        "997": {"vr": "US", "Value": [62]},
        "998": {"vr": "US", "Value": [49]},
        "999": {"vr": "US", "Value": [87]},
        "1000": {"vr": "US", "Value": [103]},
        "1001": {"vr": "US", "Value": [109]},
        "1002": {"vr": "US", "Value": [78]},
        "1003": {"vr": "US", "Value": [77]},
        "1004": {"vr": "US", "Value": [40]},
        "1005": {"vr": "US", "Value": [89]},
        "1006": {"vr": "US", "Value": [97]},
        "1007": {"vr": "US", "Value": [118]},
        "1008": {"vr": "US", "Value": [70]},
        "1009": {"vr": "US", "Value": [63]},
        "1010": {"vr": "US", "Value": [64]},
        "1011": {"vr": "US", "Value": [49]},
        "1012": {"vr": "US", "Value": [140]},
        "1013": {"vr": "US", "Value": [92]},
        "1014": {"vr": "US", "Value": [90]},
        "1015": {"vr": "US", "Value": [849]},
        "1016": {"vr": "US", "Value": [863]},
        "1017": {"vr": "US", "Value": [83]},
        "1018": {"vr": "US", "Value": [47]},
        "1019": {"vr": "US", "Value": [91]},
        "1020": {"vr": "US", "Value": [86]},
        "1021": {"vr": "US", "Value": [80]},
        "1022": {"vr": "US", "Value": [100]},
        "1023": {"vr": "US", "Value": [81]},
        "1024": {"vr": "US", "Value": [63]},
        "1025": {"vr": "US", "Value": [86]},
        "1026": {"vr": "US", "Value": [79]},
        "1027": {"vr": "US", "Value": [24]},
        "1028": {"vr": "US", "Value": [99]},
        "1029": {"vr": "US", "Value": [44]},
        "1030": {"vr": "US", "Value": [849]},
        "1031": {"vr": "US", "Value": [103]},
        "1032": {"vr": "US", "Value": [844]},
        "1033": {"vr": "US", "Value": [77]},
        "1034": {"vr": "US", "Value": [96]},
        "1035": {"vr": "US", "Value": [111]},
        "1036": {"vr": "US", "Value": [21]},
        "1037": {"vr": "US", "Value": [109]},
        "1038": {"vr": "US", "Value": [32]},
        "1039": {"vr": "US", "Value": [781]},
        "1040": {"vr": "US", "Value": [70]},
        "1041": {"vr": "US", "Value": [80]},
        "1042": {"vr": "US", "Value": [47]},
        "1043": {"vr": "US", "Value": [105]},
        "1044": {"vr": "US", "Value": [26]},
        "1045": {"vr": "US", "Value": [72]},
        "1046": {"vr": "US", "Value": [61]},
        "1047": {"vr": "US", "Value": [111]},
        "1048": {"vr": "US", "Value": [23]},
        "1049": {"vr": "US", "Value": [103]},
        "1050": {"vr": "US", "Value": [22]},
        "1051": {"vr": "US", "Value": [58]},
        "1052": {"vr": "US", "Value": [73]},
        "1053": {"vr": "US", "Value": [90]},
        "1054": {"vr": "US", "Value": [66]},
        "1055": {"vr": "US", "Value": [93]},
        "1056": {"vr": "US", "Value": [65]},
        "1057": {"vr": "US", "Value": [102]},
        "1058": {"vr": "US", "Value": [24]},
        "1059": {"vr": "US", "Value": [112]},
        "1060": {"vr": "US", "Value": [832]},
        "1061": {"vr": "US", "Value": [85]},
        "1062": {"vr": "US", "Value": [69]},
        "1063": {"vr": "US", "Value": [94]},
        "1064": {"vr": "US", "Value": [94]},
        "1065": {"vr": "US", "Value": [749]},
        "1066": {"vr": "US", "Value": [118]},
        "1067": {"vr": "US", "Value": [111]},
        "1068": {"vr": "US", "Value": [79]},
        "1069": {"vr": "US", "Value": [126]},
        "1070": {"vr": "US", "Value": [80]},
        "1071": {"vr": "US", "Value": [81]},
        "1072": {"vr": "US", "Value": [125]},
        "1073": {"vr": "US", "Value": [533]},
        "1074": {"vr": "US", "Value": [80]},
        "1075": {"vr": "US", "Value": [84]},
        "1076": {"vr": "US", "Value": [108]},
        "1077": {"vr": "US", "Value": [90]},
        "1078": {"vr": "US", "Value": [60]},
        "1079": {"vr": "US", "Value": [51]},
        "1080": {"vr": "US", "Value": [91]},
        "1081": {"vr": "US", "Value": [853]},
        "1082": {"vr": "US", "Value": [58]},
        "1083": {"vr": "US", "Value": [65]},
        "1084": {"vr": "US", "Value": [75]},
        "1085": {"vr": "US", "Value": [90]},
        "1086": {"vr": "US", "Value": [76]},
        "1087": {"vr": "US", "Value": [86]},
        "1088": {"vr": "US", "Value": [757]},
        "1089": {"vr": "US", "Value": [83]},
        "1090": {"vr": "US", "Value": [767]},
        "1091": {"vr": "US", "Value": [851]},
        "1092": {"vr": "US", "Value": [78]},
        "1093": {"vr": "US", "Value": [130]},
        "1094": {"vr": "US", "Value": [93]},
        "1095": {"vr": "US", "Value": [86]},
        "1096": {"vr": "US", "Value": [124]},
        "1097": {"vr": "US", "Value": [2005]},
        "1098": {"vr": "US", "Value": [44]},
        "1099": {"vr": "US", "Value": [95]},
        "1100": {"vr": "US", "Value": [100]},
        "1101": {"vr": "US", "Value": [99]},
        "1102": {"vr": "US", "Value": [95]},
        "1103": {"vr": "US", "Value": [72]},
        "1104": {"vr": "US", "Value": [74]},
        "1105": {"vr": "US", "Value": [921]},
        "1106": {"vr": "US", "Value": [54]},
        "1107": {"vr": "US", "Value": [113]},
        "1108": {"vr": "US", "Value": [112]},
        "1109": {"vr": "US", "Value": [110]},
        "1110": {"vr": "US", "Value": [910]},
        "1111": {"vr": "US", "Value": [73]},
        "1112": {"vr": "US", "Value": [89]},
        "1113": {"vr": "US", "Value": [61]},
        "1114": {"vr": "US", "Value": [84]},
        "1115": {"vr": "US", "Value": [100]},
        "1116": {"vr": "US", "Value": [74]},
        "1117": {"vr": "US", "Value": [113]},
        "1118": {"vr": "US", "Value": [97]},
        "1119": {"vr": "US", "Value": [59]},
        "1120": {"vr": "US", "Value": [80]},
        "1121": {"vr": "US", "Value": [50]},
        "1122": {"vr": "US", "Value": [55]},
        "1123": {"vr": "US", "Value": [94]},
        "1124": {"vr": "US", "Value": [42]},
        "1125": {"vr": "US", "Value": [82]},
        "1126": {"vr": "US", "Value": [75]},
        "1127": {"vr": "US", "Value": [82]},
        "1128": {"vr": "US", "Value": [94]},
        "1129": {"vr": "US", "Value": [86]},
        "1130": {"vr": "US", "Value": [119]},
        "1131": {"vr": "US", "Value": [856]},
        "1132": {"vr": "US", "Value": [103]},
        "1133": {"vr": "US", "Value": [71]},
        "1134": {"vr": "US", "Value": [98]},
        "1135": {"vr": "US", "Value": [116]},
        "1136": {"vr": "US", "Value": [1056]},
        "1137": {"vr": "US", "Value": [22]},
        "1138": {"vr": "US", "Value": [126]},
        "1139": {"vr": "US", "Value": [72]},
        "1140": {"vr": "US", "Value": [74]},
        "1141": {"vr": "US", "Value": [81]},
        "1142": {"vr": "US", "Value": [52]},
        "1143": {"vr": "US", "Value": [76]},
        "1144": {"vr": "US", "Value": [73]},
        "1145": {"vr": "US", "Value": [97]},
        "1146": {"vr": "US", "Value": [100]},
        "1147": {"vr": "US", "Value": [1095]},
        "1148": {"vr": "US", "Value": [830]},
        "1149": {"vr": "US", "Value": [849]},
        "1150": {"vr": "US", "Value": [64]},
        "1151": {"vr": "US", "Value": [117]},
        "1152": {"vr": "US", "Value": [79]},
        "1153": {"vr": "US", "Value": [103]},
        "1154": {"vr": "US", "Value": [87]},
        "1155": {"vr": "US", "Value": [136]},
        "1156": {"vr": "US", "Value": [88]},
        "1157": {"vr": "US", "Value": [73]},
        "1158": {"vr": "US", "Value": [80]},
        "1159": {"vr": "US", "Value": [78]},
        "1160": {"vr": "US", "Value": [100]},
        "1161": {"vr": "US", "Value": [93]},
        "1162": {"vr": "US", "Value": [90]},
        "1163": {"vr": "US", "Value": [38]},
        "1164": {"vr": "US", "Value": [40]},
        "1165": {"vr": "US", "Value": [1066]},
        "1166": {"vr": "US", "Value": [845]},
        "1167": {"vr": "US", "Value": [78]},
        "1168": {"vr": "US", "Value": [45]},
        "1169": {"vr": "US", "Value": [77]},
        "1170": {"vr": "US", "Value": [35]},
        "1171": {"vr": "US", "Value": [108]},
        "1172": {"vr": "US", "Value": [79]},
        "1173": {"vr": "US", "Value": [96]},
        "1174": {"vr": "US", "Value": [136]},
        "1175": {"vr": "US", "Value": [73]},
        "1176": {"vr": "US", "Value": [77]},
        "1177": {"vr": "US", "Value": [57]},
        "1178": {"vr": "US", "Value": [840]},
        "1179": {"vr": "US", "Value": [99]},
        "1180": {"vr": "US", "Value": [40]},
        "1181": {"vr": "US", "Value": [54]},
        "1182": {"vr": "US", "Value": [38]},
        "1183": {"vr": "US", "Value": [82]},
        "1184": {"vr": "US", "Value": [71]},
        "1185": {"vr": "US", "Value": [51]},
        "1186": {"vr": "US", "Value": [75]},
        "1187": {"vr": "US", "Value": [65]},
        "1188": {"vr": "US", "Value": [79]},
        "1189": {"vr": "US", "Value": [1450]},
        "1190": {"vr": "US", "Value": [91]},
        "1191": {"vr": "US", "Value": [1124]},
        "1192": {"vr": "US", "Value": [85]},
        "1193": {"vr": "US", "Value": [903]},
        "1194": {"vr": "US", "Value": [115]},
        "1195": {"vr": "US", "Value": [70]},
        "1196": {"vr": "US", "Value": [75]},
        "1197": {"vr": "US", "Value": [69]},
        "1198": {"vr": "US", "Value": [81]},
        "1199": {"vr": "US", "Value": [91]},
        "1200": {"vr": "US", "Value": [103]},
        "1201": {"vr": "US", "Value": [533]},
        "1202": {"vr": "US", "Value": [101]},
        "1203": {"vr": "US", "Value": [71]},
        "1204": {"vr": "US", "Value": [107]},
        "1205": {"vr": "US", "Value": [94]},
        "1206": {"vr": "US", "Value": [90]},
        "1207": {"vr": "US", "Value": [61]},
        "1208": {"vr": "US", "Value": [82]},
        "1209": {"vr": "US", "Value": [44]},
        "1210": {"vr": "US", "Value": [116]},
        "1211": {"vr": "US", "Value": [86]},
        "1212": {"vr": "US", "Value": [85]},
        "1213": {"vr": "US", "Value": [74]},
        "1214": {"vr": "US", "Value": [36]},
        "1215": {"vr": "US", "Value": [64]},
        "1216": {"vr": "US", "Value": [70]},
        "1217": {"vr": "US", "Value": [88]},
        "1218": {"vr": "US", "Value": [122]},
        "1219": {"vr": "US", "Value": [845]},
        "1220": {"vr": "US", "Value": [832]},
        "1221": {"vr": "US", "Value": [87]},
        "1222": {"vr": "US", "Value": [99]},
        "1223": {"vr": "US", "Value": [67]},
        "1224": {"vr": "US", "Value": [81]},
        "1225": {"vr": "US", "Value": [68]},
        "1226": {"vr": "US", "Value": [126]},
        "1227": {"vr": "US", "Value": [88]},
        "1228": {"vr": "US", "Value": [102]},
        "1229": {"vr": "US", "Value": [111]},
        "1230": {"vr": "US", "Value": [99]},
        "1231": {"vr": "US", "Value": [96]},
        "1232": {"vr": "US", "Value": [43]},
        "1233": {"vr": "US", "Value": [80]},
        "1234": {"vr": "US", "Value": [111]},
        "1235": {"vr": "US", "Value": [73]},
        "1236": {"vr": "US", "Value": [69]},
        "1237": {"vr": "US", "Value": [120]},
        "1238": {"vr": "US", "Value": [86]},
        "1239": {"vr": "US", "Value": [84]},
        "1240": {"vr": "US", "Value": [47]},
        "1241": {"vr": "US", "Value": [45]},
        "1242": {"vr": "US", "Value": [86]},
        "1243": {"vr": "US", "Value": [72]},
        "1244": {"vr": "US", "Value": [120]},
        "1245": {"vr": "US", "Value": [77]},
        "1246": {"vr": "US", "Value": [94]},
        "1247": {"vr": "US", "Value": [61]},
        "1248": {"vr": "US", "Value": [82]},
        "1249": {"vr": "US", "Value": [98]},
        "1250": {"vr": "US", "Value": [75]},
        "1251": {"vr": "US", "Value": [81]},
        "1252": {"vr": "US", "Value": [92]},
        "1253": {"vr": "US", "Value": [92]},
        "1254": {"vr": "US", "Value": [88]},
        "1255": {"vr": "US", "Value": [100]},
        "1256": {"vr": "US", "Value": [88]},
        "1257": {"vr": "US", "Value": [64]},
        "1258": {"vr": "US", "Value": [71]},
        "1259": {"vr": "US", "Value": [51]},
        "1260": {"vr": "US", "Value": [1143]},
        "1261": {"vr": "US", "Value": [45]},
        "1262": {"vr": "US", "Value": [92]},
        "1263": {"vr": "US", "Value": [81]},
        "1264": {"vr": "US", "Value": [810]},
        "1265": {"vr": "US", "Value": [115]},
        "1266": {"vr": "US", "Value": [112]},
        "1267": {"vr": "US", "Value": [46]},
        "1268": {"vr": "US", "Value": [87]},
        "1269": {"vr": "US", "Value": [45]},
        "1270": {"vr": "US", "Value": [87]},
        "1271": {"vr": "US", "Value": [1375]},
        "1272": {"vr": "US", "Value": [122]},
        "1273": {"vr": "US", "Value": [58]},
        "1274": {"vr": "US", "Value": [77]},
        "1275": {"vr": "US", "Value": [90]},
        "1276": {"vr": "US", "Value": [77]},
        "1277": {"vr": "US", "Value": [102]},
        "1278": {"vr": "US", "Value": [126]},
        "1279": {"vr": "US", "Value": [59]},
        "1280": {"vr": "US", "Value": [112]},
        "1281": {"vr": "US", "Value": [101]},
        "1282": {"vr": "US", "Value": [868]},
        "1283": {"vr": "US", "Value": [67]},
        "1284": {"vr": "US", "Value": [86]},
        "1285": {"vr": "US", "Value": [84]},
        "1286": {"vr": "US", "Value": [51]},
        "1287": {"vr": "US", "Value": [77]},
        "1288": {"vr": "US", "Value": [73]},
        "1289": {"vr": "US", "Value": [90]},
        "1290": {"vr": "US", "Value": [99]},
        "1291": {"vr": "US", "Value": [106]},
        "1292": {"vr": "US", "Value": [122]},
        "1293": {"vr": "US", "Value": [66]},
        "1294": {"vr": "US", "Value": [81]},
        "1295": {"vr": "US", "Value": [64]},
        "1296": {"vr": "US", "Value": [78]},
        "1297": {"vr": "US", "Value": [51]},
        "1298": {"vr": "US", "Value": [71]},
        "1299": {"vr": "US", "Value": [19]},
        "1300": {"vr": "US", "Value": [738]},
        "1301": {"vr": "US", "Value": [63]},
        "1302": {"vr": "US", "Value": [109]},
        "1303": {"vr": "US", "Value": [90]},
        "1304": {"vr": "US", "Value": [88]},
        "1305": {"vr": "US", "Value": [101]},
        "1306": {"vr": "US", "Value": [122]},
        "1307": {"vr": "US", "Value": [78]},
        "1308": {"vr": "US", "Value": [69]},
        "1309": {"vr": "US", "Value": [1161]},
        "1310": {"vr": "US", "Value": [75]},
        "1311": {"vr": "US", "Value": [85]},
        "1312": {"vr": "US", "Value": [99]},
        "1313": {"vr": "US", "Value": [92]},
        "1314": {"vr": "US", "Value": [101]},
        "1315": {"vr": "US", "Value": [46]},
        "1316": {"vr": "US", "Value": [79]},
        "1317": {"vr": "US", "Value": [81]},
        "1318": {"vr": "US", "Value": [109]},
        "1319": {"vr": "US", "Value": [91]},
        "1320": {"vr": "US", "Value": [59]},
        "1321": {"vr": "US", "Value": [80]},
        "1322": {"vr": "US", "Value": [42]},
        "1323": {"vr": "US", "Value": [109]},
        "1324": {"vr": "US", "Value": [904]},
        "1325": {"vr": "US", "Value": [95]},
        "1326": {"vr": "US", "Value": [621]},
        "1327": {"vr": "US", "Value": [78]},
        "1328": {"vr": "US", "Value": [102]},
        "1329": {"vr": "US", "Value": [79]},
        "1330": {"vr": "US", "Value": [1466]},
        "1331": {"vr": "US", "Value": [91]},
        "1332": {"vr": "US", "Value": [91]},
        "1333": {"vr": "US", "Value": [822]},
        "1334": {"vr": "US", "Value": [86]},
        "1335": {"vr": "US", "Value": [101]},
        "1336": {"vr": "US", "Value": [78]},
        "1337": {"vr": "US", "Value": [107]},
        "1338": {"vr": "US", "Value": [77]},
        "1339": {"vr": "US", "Value": [45]},
        "1340": {"vr": "US", "Value": [69]},
        "1341": {"vr": "US", "Value": [79]},
        "1342": {"vr": "US", "Value": [85]},
        "1343": {"vr": "US", "Value": [79]},
        "1344": {"vr": "US", "Value": [83]},
        "1345": {"vr": "US", "Value": [67]},
        "1346": {"vr": "US", "Value": [42]},
        "1347": {"vr": "US", "Value": [762]},
        "1348": {"vr": "US", "Value": [95]},
        "1349": {"vr": "US", "Value": [40]},
        "1350": {"vr": "US", "Value": [98]},
        "1351": {"vr": "US", "Value": [77]},
        "1352": {"vr": "US", "Value": [111]},
        "1353": {"vr": "US", "Value": [59]},
        "1354": {"vr": "US", "Value": [91]},
        "1355": {"vr": "US", "Value": [76]},
        "1356": {"vr": "US", "Value": [99]},
        "1357": {"vr": "US", "Value": [86]},
        "1358": {"vr": "US", "Value": [1206]},
        "1359": {"vr": "US", "Value": [82]},
        "1360": {"vr": "US", "Value": [98]},
        "1361": {"vr": "US", "Value": [85]},
        "1362": {"vr": "US", "Value": [103]},
        "1363": {"vr": "US", "Value": [108]},
        "1364": {"vr": "US", "Value": [19]},
        "1365": {"vr": "US", "Value": [74]},
        "1366": {"vr": "US", "Value": [82]},
        "1367": {"vr": "US", "Value": [81]},
        "1368": {"vr": "US", "Value": [48]},
        "1369": {"vr": "US", "Value": [76]},
        "1370": {"vr": "US", "Value": [95]},
        "1371": {"vr": "US", "Value": [35]},
        "1372": {"vr": "US", "Value": [104]},
        "1373": {"vr": "US", "Value": [80]},
        "1374": {"vr": "US", "Value": [98]},
        "1375": {"vr": "US", "Value": [1078]},
        "1376": {"vr": "US", "Value": [148]},
        "1377": {"vr": "US", "Value": [120]},
        "1378": {"vr": "US", "Value": [97]},
        "1379": {"vr": "US", "Value": [94]},
        "1380": {"vr": "US", "Value": [96]},
        "1381": {"vr": "US", "Value": [758]},
        "1382": {"vr": "US", "Value": [67]},
        "1383": {"vr": "US", "Value": [83]},
        "1384": {"vr": "US", "Value": [55]},
        "1385": {"vr": "US", "Value": [39]},
        "1386": {"vr": "US", "Value": [96]},
        "1387": {"vr": "US", "Value": [128]},
        "1388": {"vr": "US", "Value": [116]},
        "1389": {"vr": "US", "Value": [80]},
        "1390": {"vr": "US", "Value": [92]},
        "1391": {"vr": "US", "Value": [72]},
        "1392": {"vr": "US", "Value": [104]},
        "1393": {"vr": "US", "Value": [77]},
        "1394": {"vr": "US", "Value": [81]},
        "1395": {"vr": "US", "Value": [75]},
        "1396": {"vr": "US", "Value": [86]},
        "1397": {"vr": "US", "Value": [99]},
        "1398": {"vr": "US", "Value": [88]},
        "1399": {"vr": "US", "Value": [83]},
        "1400": {"vr": "US", "Value": [78]},
        "1401": {"vr": "US", "Value": [85]},
        "1402": {"vr": "US", "Value": [95]},
        "1403": {"vr": "US", "Value": [71]},
        "1404": {"vr": "US", "Value": [989]},
        "1405": {"vr": "US", "Value": [91]},
        "1406": {"vr": "US", "Value": [72]},
        "1407": {"vr": "US", "Value": [104]},
        "1408": {"vr": "US", "Value": [87]},
        "1409": {"vr": "US", "Value": [84]},
        "1410": {"vr": "US", "Value": [39]},
        "1411": {"vr": "US", "Value": [21]},
        "1412": {"vr": "US", "Value": [102]},
        "1413": {"vr": "US", "Value": [887]},
        "1414": {"vr": "US", "Value": [86]},
        "1415": {"vr": "US", "Value": [129]},
        "1416": {"vr": "US", "Value": [102]},
        "1417": {"vr": "US", "Value": [1013]},
        "1418": {"vr": "US", "Value": [76]},
        "1419": {"vr": "US", "Value": [71]},
        "1420": {"vr": "US", "Value": [82]},
        "1421": {"vr": "US", "Value": [74]},
        "1422": {"vr": "US", "Value": [62]},
        "1423": {"vr": "US", "Value": [86]},
        "1424": {"vr": "US", "Value": [110]},
        "1425": {"vr": "US", "Value": [53]},
        "1426": {"vr": "US", "Value": [47]},
        "1427": {"vr": "US", "Value": [87]},
        "1428": {"vr": "US", "Value": [71]},
        "1429": {"vr": "US", "Value": [111]},
        "1430": {"vr": "US", "Value": [856]},
        "1431": {"vr": "US", "Value": [74]},
        "1432": {"vr": "US", "Value": [81]},
        "1433": {"vr": "US", "Value": [98]},
        "1434": {"vr": "US", "Value": [47]},
        "1435": {"vr": "US", "Value": [53]},
        "1436": {"vr": "US", "Value": [51]},
        "1437": {"vr": "US", "Value": [34]},
        "1438": {"vr": "US", "Value": [80]},
        "1439": {"vr": "US", "Value": [79]},
        "1440": {"vr": "US", "Value": [104]},
        "1441": {"vr": "US", "Value": [48]},
        "1442": {"vr": "US", "Value": [1164]},
        "1443": {"vr": "US", "Value": [89]},
        "1444": {"vr": "US", "Value": [77]},
        "1445": {"vr": "US", "Value": [48]},
        "1446": {"vr": "US", "Value": [75]},
        "1447": {"vr": "US", "Value": [47]},
        "1448": {"vr": "US", "Value": [93]},
        "1449": {"vr": "US", "Value": [985]},
        "1450": {"vr": "US", "Value": [54]},
        "1451": {"vr": "US", "Value": [103]},
        "1452": {"vr": "US", "Value": [121]},
        "1453": {"vr": "US", "Value": [99]},
        "1454": {"vr": "US", "Value": [80]},
        "1455": {"vr": "US", "Value": [1126]},
        "1456": {"vr": "US", "Value": [92]},
        "1457": {"vr": "US", "Value": [109]},
        "1458": {"vr": "US", "Value": [47]},
        "1459": {"vr": "US", "Value": [77]},
        "1460": {"vr": "US", "Value": [122]},
        "1461": {"vr": "US", "Value": [1138]},
        "1462": {"vr": "US", "Value": [111]},
        "1463": {"vr": "US", "Value": [109]},
        "1464": {"vr": "US", "Value": [66]},
        "1465": {"vr": "US", "Value": [67]},
        "1466": {"vr": "US", "Value": [52]},
        "1467": {"vr": "US", "Value": [114]},
        "1468": {"vr": "US", "Value": [88]},
        "1469": {"vr": "US", "Value": [111]},
        "1470": {"vr": "US", "Value": [86]},
        "1471": {"vr": "US", "Value": [77]},
        "1472": {"vr": "US", "Value": [79]},
        "1473": {"vr": "US", "Value": [78]},
        "1474": {"vr": "US", "Value": [1320]},
        "1475": {"vr": "US", "Value": [86]},
        "1476": {"vr": "US", "Value": [66]},
        "1477": {"vr": "US", "Value": [92]},
        "1478": {"vr": "US", "Value": [50]},
        "1479": {"vr": "US", "Value": [106]},
        "1480": {"vr": "US", "Value": [80]},
        "1481": {"vr": "US", "Value": [51]},
        "1482": {"vr": "US", "Value": [103]},
        "1483": {"vr": "US", "Value": [90]},
        "1484": {"vr": "US", "Value": [89]},
        "1485": {"vr": "US", "Value": [104]},
        "1486": {"vr": "US", "Value": [95]},
        "1487": {"vr": "US", "Value": [74]},
        "1488": {"vr": "US", "Value": [771]},
        "1489": {"vr": "US", "Value": [46]},
        "1490": {"vr": "US", "Value": [80]},
        "1491": {"vr": "US", "Value": [127]},
        "1492": {"vr": "US", "Value": [87]},
        "1493": {"vr": "US", "Value": [545]},
        "1494": {"vr": "US", "Value": [111]},
        "1495": {"vr": "US", "Value": [155]},
        "1496": {"vr": "US", "Value": [87]},
        "1497": {"vr": "US", "Value": [37]},
        "1498": {"vr": "US", "Value": [69]},
        "1499": {"vr": "US", "Value": [105]},
        "1500": {"vr": "US", "Value": [75]},
        "1501": {"vr": "US", "Value": [86]},
        "1502": {"vr": "US", "Value": [81]},
        "1503": {"vr": "US", "Value": [78]},
        "1504": {"vr": "US", "Value": [109]},
        "1505": {"vr": "US", "Value": [38]},
        "1506": {"vr": "US", "Value": [62]},
        "1507": {"vr": "US", "Value": [71]},
        "1508": {"vr": "US", "Value": [68]},
        "1509": {"vr": "US", "Value": [112]},
        "1510": {"vr": "US", "Value": [67]},
        "1511": {"vr": "US", "Value": [74]},
        "1512": {"vr": "US", "Value": [876]},
        "1513": {"vr": "US", "Value": [99]},
        "1514": {"vr": "US", "Value": [92]},
        "1515": {"vr": "US", "Value": [1555]},
        "1516": {"vr": "US", "Value": [67]},
        "1517": {"vr": "US", "Value": [2002]},
        "1518": {"vr": "US", "Value": [43]},
        "1519": {"vr": "US", "Value": [118]},
        "1520": {"vr": "US", "Value": [81]},
        "1521": {"vr": "US", "Value": [51]},
        "1522": {"vr": "US", "Value": [84]},
        "1523": {"vr": "US", "Value": [101]},
        "1524": {"vr": "US", "Value": [57]},
        "1525": {"vr": "US", "Value": [73]},
        "1526": {"vr": "US", "Value": [46]},
        "1527": {"vr": "US", "Value": [126]},
        "1528": {"vr": "US", "Value": [101]},
        "1529": {"vr": "US", "Value": [85]},
        "1530": {"vr": "US", "Value": [92]},
        "1531": {"vr": "US", "Value": [72]},
        "1532": {"vr": "US", "Value": [75]},
        "1533": {"vr": "US", "Value": [87]},
        "1534": {"vr": "US", "Value": [45]},
        "1535": {"vr": "US", "Value": [95]},
        "1536": {"vr": "US", "Value": [823]},
        "1537": {"vr": "US", "Value": [77]},
        "1538": {"vr": "US", "Value": [45]},
        "1539": {"vr": "US", "Value": [91]},
        "1540": {"vr": "US", "Value": [87]},
        "1541": {"vr": "US", "Value": [59]},
        "1542": {"vr": "US", "Value": [81]},
        "1543": {"vr": "US", "Value": [83]},
        "1544": {"vr": "US", "Value": [44]},
        "1545": {"vr": "US", "Value": [77]},
        "1546": {"vr": "US", "Value": [84]},
        "1547": {"vr": "US", "Value": [96]},
        "1548": {"vr": "US", "Value": [63]},
        "1549": {"vr": "US", "Value": [71]},
        "1550": {"vr": "US", "Value": [103]},
        "1551": {"vr": "US", "Value": [76]},
        "1552": {"vr": "US", "Value": [79]},
        "1553": {"vr": "US", "Value": [794]},
        "1554": {"vr": "US", "Value": [87]},
        "1555": {"vr": "US", "Value": [702]},
        "1556": {"vr": "US", "Value": [111]},
        "1557": {"vr": "US", "Value": [39]},
        "1558": {"vr": "US", "Value": [46]},
        "1559": {"vr": "US", "Value": [856]},
        "1560": {"vr": "US", "Value": [115]},
        "1561": {"vr": "US", "Value": [19]},
        "1562": {"vr": "US", "Value": [1043]},
        "1563": {"vr": "US", "Value": [94]},
        "1564": {"vr": "US", "Value": [48]},
        "1565": {"vr": "US", "Value": [77]},
        "1566": {"vr": "US", "Value": [90]},
        "1567": {"vr": "US", "Value": [114]},
        "1568": {"vr": "US", "Value": [116]},
        "1569": {"vr": "US", "Value": [57]},
        "1570": {"vr": "US", "Value": [94]},
        "1571": {"vr": "US", "Value": [78]},
        "1572": {"vr": "US", "Value": [124]},
        "1573": {"vr": "US", "Value": [109]},
        "1574": {"vr": "US", "Value": [794]},
        "1575": {"vr": "US", "Value": [41]},
        "1576": {"vr": "US", "Value": [87]},
        "1577": {"vr": "US", "Value": [73]},
        "1578": {"vr": "US", "Value": [97]},
        "1579": {"vr": "US", "Value": [85]},
        "1580": {"vr": "US", "Value": [91]},
        "1581": {"vr": "US", "Value": [87]},
        "1582": {"vr": "US", "Value": [119]},
        "1583": {"vr": "US", "Value": [97]},
        "1584": {"vr": "US", "Value": [69]},
        "1585": {"vr": "US", "Value": [74]},
        "1586": {"vr": "US", "Value": [73]},
        "1587": {"vr": "US", "Value": [71]},
        "1588": {"vr": "US", "Value": [112]},
        "1589": {"vr": "US", "Value": [75]},
        "1590": {"vr": "US", "Value": [89]},
        "1591": {"vr": "US", "Value": [96]},
        "1592": {"vr": "US", "Value": [90]},
        "1593": {"vr": "US", "Value": [66]},
        "1594": {"vr": "US", "Value": [828]},
        "1595": {"vr": "US", "Value": [81]},
        "1596": {"vr": "US", "Value": [72]},
        "1597": {"vr": "US", "Value": [93]},
        "1598": {"vr": "US", "Value": [40]},
        "1599": {"vr": "US", "Value": [90]},
        "1600": {"vr": "US", "Value": [771]},
        "1601": {"vr": "US", "Value": [858]},
        "1602": {"vr": "US", "Value": [91]},
        "1603": {"vr": "US", "Value": [762]},
        "1604": {"vr": "US", "Value": [779]},
        "1605": {"vr": "US", "Value": [58]},
        "1606": {"vr": "US", "Value": [90]},
        "1607": {"vr": "US", "Value": [101]},
        "1608": {"vr": "US", "Value": [73]},
        "1609": {"vr": "US", "Value": [112]},
        "1610": {"vr": "US", "Value": [739]},
        "1611": {"vr": "US", "Value": [48]},
        "1612": {"vr": "US", "Value": [43]},
        "1613": {"vr": "US", "Value": [53]},
        "1614": {"vr": "US", "Value": [91]},
        "1615": {"vr": "US", "Value": [60]},
        "1616": {"vr": "US", "Value": [90]},
        "1617": {"vr": "US", "Value": [84]},
        "1618": {"vr": "US", "Value": [95]},
        "1619": {"vr": "US", "Value": [45]},
        "1620": {"vr": "US", "Value": [104]},
        "1621": {"vr": "US", "Value": [102]},
        "1622": {"vr": "US", "Value": [68]},
        "1623": {"vr": "US", "Value": [85]},
        "1624": {"vr": "US", "Value": [47]},
        "1625": {"vr": "US", "Value": [883]},
        "1626": {"vr": "US", "Value": [78]},
        "1627": {"vr": "US", "Value": [85]},
        "1628": {"vr": "US", "Value": [99]},
        "1629": {"vr": "US", "Value": [67]},
        "1630": {"vr": "US", "Value": [82]},
        "1631": {"vr": "US", "Value": [111]},
        "1632": {"vr": "US", "Value": [67]},
        "1633": {"vr": "US", "Value": [81]},
        "1634": {"vr": "US", "Value": [108]},
        "1635": {"vr": "US", "Value": [106]},
        "1636": {"vr": "US", "Value": [82]},
        "1637": {"vr": "US", "Value": [92]},
        "1638": {"vr": "US", "Value": [135]},
        "1639": {"vr": "US", "Value": [78]},
        "1640": {"vr": "US", "Value": [96]},
        "1641": {"vr": "US", "Value": [70]},
        "1642": {"vr": "US", "Value": [124]},
        "1643": {"vr": "US", "Value": [98]},
        "1644": {"vr": "US", "Value": [1359]},
        "1645": {"vr": "US", "Value": [62]},
        "1646": {"vr": "US", "Value": [88]},
        "1647": {"vr": "US", "Value": [88]},
        "1648": {"vr": "US", "Value": [31]},
        "1649": {"vr": "US", "Value": [835]},
        "1650": {"vr": "US", "Value": [99]},
        "1651": {"vr": "US", "Value": [59]},
        "1652": {"vr": "US", "Value": [62]},
        "1653": {"vr": "US", "Value": [107]},
        "1654": {"vr": "US", "Value": [61]},
        "1655": {"vr": "US", "Value": [115]},
        "1656": {"vr": "US", "Value": [78]},
        "1657": {"vr": "US", "Value": [54]},
        "1658": {"vr": "US", "Value": [97]},
        "1659": {"vr": "US", "Value": [124]},
        "1660": {"vr": "US", "Value": [66]},
        "1661": {"vr": "US", "Value": [62]},
        "1662": {"vr": "US", "Value": [78]},
        "1663": {"vr": "US", "Value": [125]},
        "1664": {"vr": "US", "Value": [47]},
        "1665": {"vr": "US", "Value": [57]},
        "1666": {"vr": "US", "Value": [47]},
        "1667": {"vr": "US", "Value": [47]},
        "1668": {"vr": "US", "Value": [89]},
        "1669": {"vr": "US", "Value": [46]},
        "1670": {"vr": "US", "Value": [91]},
        "1671": {"vr": "US", "Value": [39]},
        "1672": {"vr": "US", "Value": [112]},
        "1673": {"vr": "US", "Value": [78]},
        "1674": {"vr": "US", "Value": [55]},
        "1675": {"vr": "US", "Value": [111]},
        "1676": {"vr": "US", "Value": [95]},
        "1677": {"vr": "US", "Value": [102]},
        "1678": {"vr": "US", "Value": [98]},
        "1679": {"vr": "US", "Value": [40]},
        "1680": {"vr": "US", "Value": [86]},
        "1681": {"vr": "US", "Value": [108]},
        "1682": {"vr": "US", "Value": [78]},
        "1683": {"vr": "US", "Value": [68]},
        "1684": {"vr": "US", "Value": [61]},
        "1685": {"vr": "US", "Value": [59]},
        "1686": {"vr": "US", "Value": [125]},
        "1687": {"vr": "US", "Value": [127]},
        "1688": {"vr": "US", "Value": [66]},
        "1689": {"vr": "US", "Value": [1013]},
        "1690": {"vr": "US", "Value": [45]},
        "1691": {"vr": "US", "Value": [810]},
        "1692": {"vr": "US", "Value": [74]},
        "1693": {"vr": "US", "Value": [94]},
        "1694": {"vr": "US", "Value": [63]},
        "1695": {"vr": "US", "Value": [102]},
        "1696": {"vr": "US", "Value": [41]},
        "1697": {"vr": "US", "Value": [67]},
        "1698": {"vr": "US", "Value": [97]},
        "1699": {"vr": "US", "Value": [91]},
        "1700": {"vr": "US", "Value": [768]},
        "1701": {"vr": "US", "Value": [82]},
        "1702": {"vr": "US", "Value": [100]},
        "1703": {"vr": "US", "Value": [78]},
        "1704": {"vr": "US", "Value": [83]},
        "1705": {"vr": "US", "Value": [42]},
        "1706": {"vr": "US", "Value": [92]},
        "1707": {"vr": "US", "Value": [66]},
        "1708": {"vr": "US", "Value": [93]},
        "1709": {"vr": "US", "Value": [118]},
        "1710": {"vr": "US", "Value": [96]},
        "1711": {"vr": "US", "Value": [55]},
        "1712": {"vr": "US", "Value": [82]},
        "1713": {"vr": "US", "Value": [101]},
        "1714": {"vr": "US", "Value": [94]},
        "1715": {"vr": "US", "Value": [96]},
        "1716": {"vr": "US", "Value": [78]},
        "1717": {"vr": "US", "Value": [1112]},
        "1718": {"vr": "US", "Value": [99]},
        "1719": {"vr": "US", "Value": [115]},
        "1720": {"vr": "US", "Value": [291]},
        "1721": {"vr": "US", "Value": [49]},
        "1722": {"vr": "US", "Value": [120]},
        "1723": {"vr": "US", "Value": [118]},
        "1724": {"vr": "US", "Value": [96]},
        "1725": {"vr": "US", "Value": [105]},
        "1726": {"vr": "US", "Value": [87]},
        "1727": {"vr": "US", "Value": [83]},
        "1728": {"vr": "US", "Value": [89]},
        "1729": {"vr": "US", "Value": [91]},
        "1730": {"vr": "US", "Value": [19]},
        "1731": {"vr": "US", "Value": [101]},
        "1732": {"vr": "US", "Value": [123]},
        "1733": {"vr": "US", "Value": [65]},
        "1734": {"vr": "US", "Value": [102]},
        "1735": {"vr": "US", "Value": [112]},
        "1736": {"vr": "US", "Value": [1400]},
        "1737": {"vr": "US", "Value": [89]},
        "1738": {"vr": "US", "Value": [794]},
        "1739": {"vr": "US", "Value": [90]},
        "1740": {"vr": "US", "Value": [88]},
        "1741": {"vr": "US", "Value": [69]},
        "1742": {"vr": "US", "Value": [88]},
        "1743": {"vr": "US", "Value": [101]},
        "1744": {"vr": "US", "Value": [37]},
        "1745": {"vr": "US", "Value": [99]},
        "1746": {"vr": "US", "Value": [92]},
        "1747": {"vr": "US", "Value": [108]},
        "1748": {"vr": "US", "Value": [78]},
        "1749": {"vr": "US", "Value": [118]},
        "1750": {"vr": "US", "Value": [69]},
        "1751": {"vr": "US", "Value": [76]},
        "1752": {"vr": "US", "Value": [66]},
        "1753": {"vr": "US", "Value": [70]},
        "1754": {"vr": "US", "Value": [111]},
        "1755": {"vr": "US", "Value": [70]},
        "1756": {"vr": "US", "Value": [90]},
        "1757": {"vr": "US", "Value": [123]},
        "1758": {"vr": "US", "Value": [50]},
        "1759": {"vr": "US", "Value": [42]},
        "1760": {"vr": "US", "Value": [103]},
        "1761": {"vr": "US", "Value": [72]},
        "1762": {"vr": "US", "Value": [72]},
        "1763": {"vr": "US", "Value": [109]},
        "1764": {"vr": "US", "Value": [88]},
        "1765": {"vr": "US", "Value": [54]},
        "1766": {"vr": "US", "Value": [87]},
        "1767": {"vr": "US", "Value": [76]},
        "1768": {"vr": "US", "Value": [70]},
        "1769": {"vr": "US", "Value": [63]},
        "1770": {"vr": "US", "Value": [96]},
        "1771": {"vr": "US", "Value": [77]},
        "1772": {"vr": "US", "Value": [80]},
        "1773": {"vr": "US", "Value": [90]},
        "1774": {"vr": "US", "Value": [65]},
        "1775": {"vr": "US", "Value": [1311]},
        "1776": {"vr": "US", "Value": [110]},
        "1777": {"vr": "US", "Value": [39]},
        "1778": {"vr": "US", "Value": [35]},
        "1779": {"vr": "US", "Value": [45]},
        "1780": {"vr": "US", "Value": [77]},
        "1781": {"vr": "US", "Value": [117]},
        "1782": {"vr": "US", "Value": [100]},
        "1783": {"vr": "US", "Value": [97]},
        "1784": {"vr": "US", "Value": [98]},
        "1785": {"vr": "US", "Value": [92]},
        "1786": {"vr": "US", "Value": [114]},
        "1787": {"vr": "US", "Value": [86]},
        "1788": {"vr": "US", "Value": [70]},
        "1789": {"vr": "US", "Value": [90]},
        "1790": {"vr": "US", "Value": [108]},
        "1791": {"vr": "US", "Value": [62]},
        "1792": {"vr": "US", "Value": [87]},
        "1793": {"vr": "US", "Value": [88]},
        "1794": {"vr": "US", "Value": [81]},
        "1795": {"vr": "US", "Value": [75]},
        "1796": {"vr": "US", "Value": [850]},
        "1797": {"vr": "US", "Value": [37]},
        "1798": {"vr": "US", "Value": [91]},
        "1799": {"vr": "US", "Value": [92]},
        "1800": {"vr": "US", "Value": [88]},
        "1801": {"vr": "US", "Value": [84]},
        "1802": {"vr": "US", "Value": [1270]},
        "1803": {"vr": "US", "Value": [43]},
        "1804": {"vr": "US", "Value": [49]},
        "1805": {"vr": "US", "Value": [757]},
        "1806": {"vr": "US", "Value": [25]},
        "1807": {"vr": "US", "Value": [107]},
        "1808": {"vr": "US", "Value": [41]},
        "1809": {"vr": "US", "Value": [38]},
        "1810": {"vr": "US", "Value": [56]},
        "1811": {"vr": "US", "Value": [71]},
        "1812": {"vr": "US", "Value": [101]},
        "1813": {"vr": "US", "Value": [81]},
        "1814": {"vr": "US", "Value": [99]},
        "1815": {"vr": "US", "Value": [72]},
        "1816": {"vr": "US", "Value": [41]},
        "1817": {"vr": "US", "Value": [90]},
        "1818": {"vr": "US", "Value": [65]},
        "1819": {"vr": "US", "Value": [57]},
        "1820": {"vr": "US", "Value": [99]},
        "1821": {"vr": "US", "Value": [48]},
        "1822": {"vr": "US", "Value": [78]},
        "1823": {"vr": "US", "Value": [57]},
        "1824": {"vr": "US", "Value": [49]},
        "1825": {"vr": "US", "Value": [87]},
        "1826": {"vr": "US", "Value": [91]},
        "1827": {"vr": "US", "Value": [790]},
        "1828": {"vr": "US", "Value": [44]},
        "1829": {"vr": "US", "Value": [67]},
        "1830": {"vr": "US", "Value": [99]},
        "1831": {"vr": "US", "Value": [85]},
        "1832": {"vr": "US", "Value": [39]},
        "1833": {"vr": "US", "Value": [93]},
        "1834": {"vr": "US", "Value": [90]},
        "1835": {"vr": "US", "Value": [79]},
        "1836": {"vr": "US", "Value": [90]},
        "1837": {"vr": "US", "Value": [775]},
        "1838": {"vr": "US", "Value": [819]},
        "1839": {"vr": "US", "Value": [100]},
        "1840": {"vr": "US", "Value": [98]},
        "1841": {"vr": "US", "Value": [108]},
        "1842": {"vr": "US", "Value": [101]},
        "1843": {"vr": "US", "Value": [79]},
        "1844": {"vr": "US", "Value": [71]},
        "1845": {"vr": "US", "Value": [964]},
        "1846": {"vr": "US", "Value": [102]},
        "1847": {"vr": "US", "Value": [44]},
        "1848": {"vr": "US", "Value": [90]},
        "1849": {"vr": "US", "Value": [62]},
        "1850": {"vr": "US", "Value": [81]},
        "1851": {"vr": "US", "Value": [74]},
        "1852": {"vr": "US", "Value": [56]},
        "1853": {"vr": "US", "Value": [131]},
        "1854": {"vr": "US", "Value": [133]},
        "1855": {"vr": "US", "Value": [91]},
        "1856": {"vr": "US", "Value": [104]},
        "1857": {"vr": "US", "Value": [101]},
        "1858": {"vr": "US", "Value": [89]},
        "1859": {"vr": "US", "Value": [92]},
        "1860": {"vr": "US", "Value": [68]},
        "1861": {"vr": "US", "Value": [51]},
        "1862": {"vr": "US", "Value": [113]},
        "1863": {"vr": "US", "Value": [73]},
        "1864": {"vr": "US", "Value": [44]},
        "1865": {"vr": "US", "Value": [79]},
        "1866": {"vr": "US", "Value": [101]},
        "1867": {"vr": "US", "Value": [43]},
        "1868": {"vr": "US", "Value": [80]},
        "1869": {"vr": "US", "Value": [77]},
        "1870": {"vr": "US", "Value": [58]},
        "1871": {"vr": "US", "Value": [91]},
        "1872": {"vr": "US", "Value": [1987]},
        "1873": {"vr": "US", "Value": [920]},
        "1874": {"vr": "US", "Value": [107]},
        "1875": {"vr": "US", "Value": [47]},
        "1876": {"vr": "US", "Value": [73]},
        "1877": {"vr": "US", "Value": [84]},
        "1878": {"vr": "US", "Value": [43]},
        "1879": {"vr": "US", "Value": [77]},
        "1880": {"vr": "US", "Value": [91]},
        "1881": {"vr": "US", "Value": [57]},
        "1882": {"vr": "US", "Value": [115]},
        "1883": {"vr": "US", "Value": [37]},
        "1884": {"vr": "US", "Value": [85]},
        "1885": {"vr": "US", "Value": [41]},
        "1886": {"vr": "US", "Value": [82]},
        "1887": {"vr": "US", "Value": [35]},
        "1888": {"vr": "US", "Value": [82]},
        "1889": {"vr": "US", "Value": [838]},
        "1890": {"vr": "US", "Value": [109]},
        "1891": {"vr": "US", "Value": [60]},
        "1892": {"vr": "US", "Value": [20]},
        "1893": {"vr": "US", "Value": [103]},
        "1894": {"vr": "US", "Value": [103]},
        "1895": {"vr": "US", "Value": [105]},
        "1896": {"vr": "US", "Value": [81]},
        "1897": {"vr": "US", "Value": [80]},
        "1898": {"vr": "US", "Value": [56]},
        "1899": {"vr": "US", "Value": [106]},
        "1900": {"vr": "US", "Value": [106]},
        "1901": {"vr": "US", "Value": [88]},
        "1902": {"vr": "US", "Value": [106]},
        "1903": {"vr": "US", "Value": [77]},
        "1904": {"vr": "US", "Value": [36]},
        "1905": {"vr": "US", "Value": [66]},
        "1906": {"vr": "US", "Value": [63]},
        "1907": {"vr": "US", "Value": [75]},
        "1908": {"vr": "US", "Value": [107]},
        "1909": {"vr": "US", "Value": [879]},
        "1910": {"vr": "US", "Value": [71]},
        "1911": {"vr": "US", "Value": [84]},
        "1912": {"vr": "US", "Value": [114]},
        "1913": {"vr": "US", "Value": [98]},
        "1914": {"vr": "US", "Value": [757]},
        "1915": {"vr": "US", "Value": [834]},
        "1916": {"vr": "US", "Value": [856]},
        "1917": {"vr": "US", "Value": [115]},
        "1918": {"vr": "US", "Value": [1776]},
        "1919": {"vr": "US", "Value": [27]},
        "1920": {"vr": "US", "Value": [898]},
        "1921": {"vr": "US", "Value": [60]},
        "1922": {"vr": "US", "Value": [67]},
        "1923": {"vr": "US", "Value": [103]},
        "1924": {"vr": "US", "Value": [36]},
        "1925": {"vr": "US", "Value": [79]},
        "1926": {"vr": "US", "Value": [119]},
        "1927": {"vr": "US", "Value": [18]},
        "1928": {"vr": "US", "Value": [64]},
        "1929": {"vr": "US", "Value": [80]},
        "1930": {"vr": "US", "Value": [100]},
        "1931": {"vr": "US", "Value": [67]},
        "1932": {"vr": "US", "Value": [88]},
        "1933": {"vr": "US", "Value": [868]},
        "1934": {"vr": "US", "Value": [59]},
        "1935": {"vr": "US", "Value": [72]},
        "1936": {"vr": "US", "Value": [45]},
        "1937": {"vr": "US", "Value": [91]},
        "1938": {"vr": "US", "Value": [90]},
        "1939": {"vr": "US", "Value": [120]},
        "1940": {"vr": "US", "Value": [42]},
        "1941": {"vr": "US", "Value": [102]},
        "1942": {"vr": "US", "Value": [106]},
        "1943": {"vr": "US", "Value": [114]},
        "1944": {"vr": "US", "Value": [84]},
        "1945": {"vr": "US", "Value": [86]},
        "1946": {"vr": "US", "Value": [126]},
        "1947": {"vr": "US", "Value": [97]},
        "1948": {"vr": "US", "Value": [78]},
        "1949": {"vr": "US", "Value": [2024]},
        "1950": {"vr": "US", "Value": [99]},
        "1951": {"vr": "US", "Value": [101]},
        "1952": {"vr": "US", "Value": [87]},
        "1953": {"vr": "US", "Value": [46]},
        "1954": {"vr": "US", "Value": [99]},
        "1955": {"vr": "US", "Value": [103]},
        "1956": {"vr": "US", "Value": [59]},
        "1957": {"vr": "US", "Value": [94]},
        "1958": {"vr": "US", "Value": [48]},
        "1959": {"vr": "US", "Value": [97]},
        "1960": {"vr": "US", "Value": [43]},
        "1961": {"vr": "US", "Value": [1259]},
        "1962": {"vr": "US", "Value": [113]},
        "1963": {"vr": "US", "Value": [76]},
        "1964": {"vr": "US", "Value": [82]},
        "1965": {"vr": "US", "Value": [73]},
        "1966": {"vr": "US", "Value": [104]},
        "1967": {"vr": "US", "Value": [1257]},
        "1968": {"vr": "US", "Value": [95]},
        "1969": {"vr": "US", "Value": [72]},
        "1970": {"vr": "US", "Value": [74]},
        "1971": {"vr": "US", "Value": [79]},
        "1972": {"vr": "US", "Value": [87]},
        "1973": {"vr": "US", "Value": [1244]},
        "1974": {"vr": "US", "Value": [68]},
        "1975": {"vr": "US", "Value": [71]},
        "1976": {"vr": "US", "Value": [68]},
        "1977": {"vr": "US", "Value": [92]},
        "1978": {"vr": "US", "Value": [104]},
        "1979": {"vr": "US", "Value": [100]},
        "1980": {"vr": "US", "Value": [97]},
        "1981": {"vr": "US", "Value": [47]},
        "1982": {"vr": "US", "Value": [73]},
        "1983": {"vr": "US", "Value": [60]},
        "1984": {"vr": "US", "Value": [67]},
        "1985": {"vr": "US", "Value": [78]},
        "1986": {"vr": "US", "Value": [128]},
        "1987": {"vr": "US", "Value": [118]},
        "1988": {"vr": "US", "Value": [112]},
        "1989": {"vr": "US", "Value": [76]},
        "1990": {"vr": "US", "Value": [79]},
        "1991": {"vr": "US", "Value": [66]},
        "1992": {"vr": "US", "Value": [47]},
        "1993": {"vr": "US", "Value": [1994]},
        "1994": {"vr": "US", "Value": [54]},
        "1995": {"vr": "US", "Value": [77]},
        "1996": {"vr": "US", "Value": [994]},
        "1997": {"vr": "US", "Value": [79]},
        "1998": {"vr": "US", "Value": [70]},
        "1999": {"vr": "US", "Value": [53]},
        "2000": {"vr": "US", "Value": [103]},
        "2001": {"vr": "US", "Value": [737]},
        "2002": {"vr": "US", "Value": [82]},
        "2003": {"vr": "US", "Value": [114]},
        "2004": {"vr": "US", "Value": [87]},
        "2005": {"vr": "US", "Value": [122]},
        "2006": {"vr": "US", "Value": [89]},
        "2007": {"vr": "US", "Value": [36]},
        "2008": {"vr": "US", "Value": [72]},
        "2009": {"vr": "US", "Value": [75]},
        "2010": {"vr": "US", "Value": [126]},
        "2011": {"vr": "US", "Value": [66]},
        "2012": {"vr": "US", "Value": [857]},
        "2013": {"vr": "US", "Value": [59]},
        "2014": {"vr": "US", "Value": [73]},
        "2015": {"vr": "US", "Value": [86]},
        "2016": {"vr": "US", "Value": [99]},
        "2017": {"vr": "US", "Value": [1067]},
        "2018": {"vr": "US", "Value": [87]},
        "2019": {"vr": "US", "Value": [77]},
        "2020": {"vr": "US", "Value": [89]},
        "2021": {"vr": "US", "Value": [74]},
        "2022": {"vr": "US", "Value": [109]},
        "2023": {"vr": "US", "Value": [47]},
        "2024": {"vr": "US", "Value": [85]},
        "2025": {"vr": "US", "Value": [847]},
        "2026": {"vr": "US", "Value": [86]},
        "2027": {"vr": "US", "Value": [87]},
        "2028": {"vr": "US", "Value": [101]},
        "2029": {"vr": "US", "Value": [860]},
        "2030": {"vr": "US", "Value": [86]},
        "2031": {"vr": "US", "Value": [67]},
        "2032": {"vr": "US", "Value": [112]},
        "2033": {"vr": "US", "Value": [77]},
        "2034": {"vr": "US", "Value": [95]},
        "2035": {"vr": "US", "Value": [110]},
        "2036": {"vr": "US", "Value": [89]},
        "2037": {"vr": "US", "Value": [65]},
        "2038": {"vr": "US", "Value": [23]},
        "2039": {"vr": "US", "Value": [87]},
        "2040": {"vr": "US", "Value": [72]},
        "2041": {"vr": "US", "Value": [88]},
        "2042": {"vr": "US", "Value": [75]},
        "2043": {"vr": "US", "Value": [115]},
        "2044": {"vr": "US", "Value": [63]},
        "2045": {"vr": "US", "Value": [96]},
        "2046": {"vr": "US", "Value": [91]},
        "2047": {"vr": "US", "Value": [86]},
        "2048": {"vr": "US", "Value": [76]},
        "2049": {"vr": "US", "Value": [121]},
        "2050": {"vr": "US", "Value": [64]},
        "2051": {"vr": "US", "Value": [62]},
        "2052": {"vr": "US", "Value": [68]},
        "2053": {"vr": "US", "Value": [81]},
        "2054": {"vr": "US", "Value": [85]},
        "2055": {"vr": "US", "Value": [90]},
        "2056": {"vr": "US", "Value": [109]},
        "2057": {"vr": "US", "Value": [72]},
        "2058": {"vr": "US", "Value": [96]},
        "2059": {"vr": "US", "Value": [116]},
        "2060": {"vr": "US", "Value": [93]},
        "2061": {"vr": "US", "Value": [103]},
        "2062": {"vr": "US", "Value": [105]},
        "2063": {"vr": "US", "Value": [104]},
        "2064": {"vr": "US", "Value": [720]},
        "2065": {"vr": "US", "Value": [78]},
        "2066": {"vr": "US", "Value": [90]},
        "2067": {"vr": "US", "Value": [76]},
        "2068": {"vr": "US", "Value": [82]},
        "2069": {"vr": "US", "Value": [81]},
        "2070": {"vr": "US", "Value": [88]},
        "2071": {"vr": "US", "Value": [78]},
        "2072": {"vr": "US", "Value": [102]},
        "2073": {"vr": "US", "Value": [96]},
        "2074": {"vr": "US", "Value": [81]},
        "2075": {"vr": "US", "Value": [847]},
        "2076": {"vr": "US", "Value": [66]},
        "2077": {"vr": "US", "Value": [60]},
        "2078": {"vr": "US", "Value": [42]},
        "2079": {"vr": "US", "Value": [1125]},
        "2080": {"vr": "US", "Value": [49]},
        "2081": {"vr": "US", "Value": [80]},
        "2082": {"vr": "US", "Value": [1117]},
        "2083": {"vr": "US", "Value": [1268]},
        "2084": {"vr": "US", "Value": [875]},
        "2085": {"vr": "US", "Value": [107]},
        "2086": {"vr": "US", "Value": [779]},
        "2087": {"vr": "US", "Value": [108]},
        "2088": {"vr": "US", "Value": [69]},
        "2089": {"vr": "US", "Value": [70]},
        "2090": {"vr": "US", "Value": [82]},
        "2091": {"vr": "US", "Value": [83]},
        "2092": {"vr": "US", "Value": [67]},
        "2093": {"vr": "US", "Value": [85]},
        "2094": {"vr": "US", "Value": [36]},
        "2095": {"vr": "US", "Value": [74]},
        "2096": {"vr": "US", "Value": [84]},
        "2097": {"vr": "US", "Value": [114]},
        "2098": {"vr": "US", "Value": [1300]},
        "2099": {"vr": "US", "Value": [39]},
        "2100": {"vr": "US", "Value": [45]},
        "2101": {"vr": "US", "Value": [72]},
        "2102": {"vr": "US", "Value": [85]},
        "2103": {"vr": "US", "Value": [78]},
        "2104": {"vr": "US", "Value": [64]},
        "2105": {"vr": "US", "Value": [80]},
        "2106": {"vr": "US", "Value": [25]},
        "2107": {"vr": "US", "Value": [75]},
        "2108": {"vr": "US", "Value": [108]},
        "2109": {"vr": "US", "Value": [768]},
        "2110": {"vr": "US", "Value": [67]},
        "2111": {"vr": "US", "Value": [85]},
        "2112": {"vr": "US", "Value": [43]},
        "2113": {"vr": "US", "Value": [81]},
        "2114": {"vr": "US", "Value": [47]},
        "2115": {"vr": "US", "Value": [65]},
        "2116": {"vr": "US", "Value": [115]},
        "2117": {"vr": "US", "Value": [74]},
        "2118": {"vr": "US", "Value": [85]},
        "2119": {"vr": "US", "Value": [89]},
        "2120": {"vr": "US", "Value": [70]},
        "2121": {"vr": "US", "Value": [104]},
        "2122": {"vr": "US", "Value": [68]},
        "2123": {"vr": "US", "Value": [46]},
        "2124": {"vr": "US", "Value": [107]},
        "2125": {"vr": "US", "Value": [94]},
        "2126": {"vr": "US", "Value": [96]},
        "2127": {"vr": "US", "Value": [80]},
        "2128": {"vr": "US", "Value": [74]},
        "2129": {"vr": "US", "Value": [73]},
        "2130": {"vr": "US", "Value": [98]},
        "2131": {"vr": "US", "Value": [94]},
        "2132": {"vr": "US", "Value": [855]},
        "2133": {"vr": "US", "Value": [39]},
        "2134": {"vr": "US", "Value": [108]},
        "2135": {"vr": "US", "Value": [113]},
        "2136": {"vr": "US", "Value": [85]},
        "2137": {"vr": "US", "Value": [103]},
        "2138": {"vr": "US", "Value": [88]},
        "2139": {"vr": "US", "Value": [39]},
        "2140": {"vr": "US", "Value": [109]},
        "2141": {"vr": "US", "Value": [89]},
        "2142": {"vr": "US", "Value": [87]},
        "2143": {"vr": "US", "Value": [79]},
        "2144": {"vr": "US", "Value": [134]},
        "2145": {"vr": "US", "Value": [93]},
        "2146": {"vr": "US", "Value": [762]},
        "2147": {"vr": "US", "Value": [38]},
        "2148": {"vr": "US", "Value": [93]},
        "2149": {"vr": "US", "Value": [95]},
        "2150": {"vr": "US", "Value": [79]},
        "2151": {"vr": "US", "Value": [108]},
        "2152": {"vr": "US", "Value": [80]},
        "2153": {"vr": "US", "Value": [37]},
        "2154": {"vr": "US", "Value": [100]},
        "2155": {"vr": "US", "Value": [101]},
        "2156": {"vr": "US", "Value": [77]},
        "2157": {"vr": "US", "Value": [72]},
        "2158": {"vr": "US", "Value": [766]},
        "2159": {"vr": "US", "Value": [94]},
        "2160": {"vr": "US", "Value": [56]},
        "2161": {"vr": "US", "Value": [81]},
        "2162": {"vr": "US", "Value": [86]},
        "2163": {"vr": "US", "Value": [89]},
        "2164": {"vr": "US", "Value": [107]},
        "2165": {"vr": "US", "Value": [1195]},
        "2166": {"vr": "US", "Value": [127]},
        "2167": {"vr": "US", "Value": [129]},
        "2168": {"vr": "US", "Value": [76]},
        "2169": {"vr": "US", "Value": [86]},
        "2170": {"vr": "US", "Value": [858]},
        "2171": {"vr": "US", "Value": [89]},
        "2172": {"vr": "US", "Value": [126]},
        "2173": {"vr": "US", "Value": [109]},
        "2174": {"vr": "US", "Value": [848]},
        "2175": {"vr": "US", "Value": [91]},
        "2176": {"vr": "US", "Value": [36]},
        "2177": {"vr": "US", "Value": [78]},
        "2178": {"vr": "US", "Value": [92]},
        "2179": {"vr": "US", "Value": [87]},
        "2180": {"vr": "US", "Value": [86]},
        "2181": {"vr": "US", "Value": [59]},
        "2182": {"vr": "US", "Value": [108]},
        "2183": {"vr": "US", "Value": [87]},
        "2184": {"vr": "US", "Value": [103]},
        "2185": {"vr": "US", "Value": [43]},
        "2186": {"vr": "US", "Value": [34]},
        "2187": {"vr": "US", "Value": [1158]},
        "2188": {"vr": "US", "Value": [91]},
        "2189": {"vr": "US", "Value": [80]},
        "2190": {"vr": "US", "Value": [110]},
        "2191": {"vr": "US", "Value": [52]},
        "2192": {"vr": "US", "Value": [1211]},
        "2193": {"vr": "US", "Value": [37]},
        "2194": {"vr": "US", "Value": [63]},
        "2195": {"vr": "US", "Value": [77]},
        "2196": {"vr": "US", "Value": [95]},
        "2197": {"vr": "US", "Value": [94]},
        "2198": {"vr": "US", "Value": [33]},
        "2199": {"vr": "US", "Value": [79]},
        "2200": {"vr": "US", "Value": [100]},
        "2201": {"vr": "US", "Value": [110]},
        "2202": {"vr": "US", "Value": [76]},
        "2203": {"vr": "US", "Value": [102]},
        "2204": {"vr": "US", "Value": [799]},
        "2205": {"vr": "US", "Value": [87]},
        "2206": {"vr": "US", "Value": [87]},
        "2207": {"vr": "US", "Value": [93]},
        "2208": {"vr": "US", "Value": [90]},
        "2209": {"vr": "US", "Value": [83]},
        "2210": {"vr": "US", "Value": [108]},
        "2211": {"vr": "US", "Value": [89]},
        "2212": {"vr": "US", "Value": [109]},
        "2213": {"vr": "US", "Value": [86]},
        "2214": {"vr": "US", "Value": [73]},
        "2215": {"vr": "US", "Value": [109]},
        "2216": {"vr": "US", "Value": [113]},
        "2217": {"vr": "US", "Value": [91]},
        "2218": {"vr": "US", "Value": [100]},
        "2219": {"vr": "US", "Value": [38]},
        "2220": {"vr": "US", "Value": [913]},
        "2221": {"vr": "US", "Value": [37]},
        "2222": {"vr": "US", "Value": [77]},
        "2223": {"vr": "US", "Value": [34]},
        "2224": {"vr": "US", "Value": [56]},
        "2225": {"vr": "US", "Value": [50]},
        "2226": {"vr": "US", "Value": [79]},
        "2227": {"vr": "US", "Value": [77]},
        "2228": {"vr": "US", "Value": [81]},
        "2229": {"vr": "US", "Value": [40]},
        "2230": {"vr": "US", "Value": [52]},
        "2231": {"vr": "US", "Value": [28]},
        "2232": {"vr": "US", "Value": [100]},
        "2233": {"vr": "US", "Value": [70]},
        "2234": {"vr": "US", "Value": [90]},
        "2235": {"vr": "US", "Value": [88]},
        "2236": {"vr": "US", "Value": [69]},
        "2237": {"vr": "US", "Value": [82]},
        "2238": {"vr": "US", "Value": [108]},
        "2239": {"vr": "US", "Value": [808]},
        "2240": {"vr": "US", "Value": [74]},
        "2241": {"vr": "US", "Value": [37]},
        "2242": {"vr": "US", "Value": [80]},
        "2243": {"vr": "US", "Value": [119]},
        "2244": {"vr": "US", "Value": [73]},
        "2245": {"vr": "US", "Value": [88]},
        "2246": {"vr": "US", "Value": [74]},
        "2247": {"vr": "US", "Value": [74]},
        "2248": {"vr": "US", "Value": [88]},
        "2249": {"vr": "US", "Value": [87]},
        "2250": {"vr": "US", "Value": [59]},
        "2251": {"vr": "US", "Value": [77]},
        "2252": {"vr": "US", "Value": [108]},
        "2253": {"vr": "US", "Value": [90]},
        "2254": {"vr": "US", "Value": [847]},
        "2255": {"vr": "US", "Value": [38]},
        "2256": {"vr": "US", "Value": [89]},
        "2257": {"vr": "US", "Value": [45]},
        "2258": {"vr": "US", "Value": [73]},
        "2259": {"vr": "US", "Value": [840]},
        "2260": {"vr": "US", "Value": [124]},
        "2261": {"vr": "US", "Value": [78]},
        "2262": {"vr": "US", "Value": [49]},
        "2263": {"vr": "US", "Value": [1178]},
        "2264": {"vr": "US", "Value": [74]},
        "2265": {"vr": "US", "Value": [77]},
        "2266": {"vr": "US", "Value": [116]},
        "2267": {"vr": "US", "Value": [75]},
        "2268": {"vr": "US", "Value": [53]},
        "2269": {"vr": "US", "Value": [69]},
        "2270": {"vr": "US", "Value": [66]},
        "2271": {"vr": "US", "Value": [117]},
        "2272": {"vr": "US", "Value": [70]},
        "2273": {"vr": "US", "Value": [37]},
        "2274": {"vr": "US", "Value": [95]},
        "2275": {"vr": "US", "Value": [75]},
        "2276": {"vr": "US", "Value": [89]},
        "2277": {"vr": "US", "Value": [48]},
        "2278": {"vr": "US", "Value": [1382]},
        "2279": {"vr": "US", "Value": [110]},
        "2280": {"vr": "US", "Value": [76]},
        "2281": {"vr": "US", "Value": [68]},
        "2282": {"vr": "US", "Value": [112]},
        "2283": {"vr": "US", "Value": [96]},
        "2284": {"vr": "US", "Value": [85]},
        "2285": {"vr": "US", "Value": [75]},
        "2286": {"vr": "US", "Value": [78]},
        "2287": {"vr": "US", "Value": [100]},
        "2288": {"vr": "US", "Value": [38]},
        "2289": {"vr": "US", "Value": [115]},
        "2290": {"vr": "US", "Value": [74]},
        "2291": {"vr": "US", "Value": [753]},
        "2292": {"vr": "US", "Value": [98]},
        "2293": {"vr": "US", "Value": [96]},
        "2294": {"vr": "US", "Value": [78]},
        "2295": {"vr": "US", "Value": [787]},
        "2296": {"vr": "US", "Value": [1199]},
        "2297": {"vr": "US", "Value": [77]},
        "2298": {"vr": "US", "Value": [65]},
        "2299": {"vr": "US", "Value": [70]},
        "2300": {"vr": "US", "Value": [73]},
        "2301": {"vr": "US", "Value": [93]},
        "2302": {"vr": "US", "Value": [70]},
        "2303": {"vr": "US", "Value": [76]},
        "2304": {"vr": "US", "Value": [82]},
        "2305": {"vr": "US", "Value": [34]},
        "2306": {"vr": "US", "Value": [118]},
        "2307": {"vr": "US", "Value": [75]},
        "2308": {"vr": "US", "Value": [52]},
        "2309": {"vr": "US", "Value": [46]},
        "2310": {"vr": "US", "Value": [54]},
        "2311": {"vr": "US", "Value": [85]},
        "2312": {"vr": "US", "Value": [32]},
        "2313": {"vr": "US", "Value": [1256]},
        "2314": {"vr": "US", "Value": [95]},
        "2315": {"vr": "US", "Value": [83]},
        "2316": {"vr": "US", "Value": [81]},
        "2317": {"vr": "US", "Value": [95]},
        "2318": {"vr": "US", "Value": [140]},
        "2319": {"vr": "US", "Value": [79]},
        "2320": {"vr": "US", "Value": [53]},
        "2321": {"vr": "US", "Value": [107]},
        "2322": {"vr": "US", "Value": [99]},
        "2323": {"vr": "US", "Value": [78]},
        "2324": {"vr": "US", "Value": [40]},
        "2325": {"vr": "US", "Value": [110]},
        "2326": {"vr": "US", "Value": [86]},
        "2327": {"vr": "US", "Value": [103]},
        "2328": {"vr": "US", "Value": [67]},
        "2329": {"vr": "US", "Value": [72]},
        "2330": {"vr": "US", "Value": [102]},
        "2331": {"vr": "US", "Value": [85]},
        "2332": {"vr": "US", "Value": [37]},
        "2333": {"vr": "US", "Value": [80]},
        "2334": {"vr": "US", "Value": [91]},
        "2335": {"vr": "US", "Value": [39]},
        "2336": {"vr": "US", "Value": [99]},
        "2337": {"vr": "US", "Value": [60]},
        "2338": {"vr": "US", "Value": [53]},
        "2339": {"vr": "US", "Value": [109]},
        "2340": {"vr": "US", "Value": [741]},
        "2341": {"vr": "US", "Value": [91]},
        "2342": {"vr": "US", "Value": [84]},
        "2343": {"vr": "US", "Value": [74]},
        "2344": {"vr": "US", "Value": [118]},
        "2345": {"vr": "US", "Value": [70]},
        "2346": {"vr": "US", "Value": [1098]},
        "2347": {"vr": "US", "Value": [116]},
        "2348": {"vr": "US", "Value": [90]},
        "2349": {"vr": "US", "Value": [74]},
        "2350": {"vr": "US", "Value": [81]},
        "2351": {"vr": "US", "Value": [88]},
        "2352": {"vr": "US", "Value": [77]},
        "2353": {"vr": "US", "Value": [100]},
        "2354": {"vr": "US", "Value": [85]},
        "2355": {"vr": "US", "Value": [41]},
        "2356": {"vr": "US", "Value": [92]},
        "2357": {"vr": "US", "Value": [95]},
        "2358": {"vr": "US", "Value": [98]},
        "2359": {"vr": "US", "Value": [90]},
        "2360": {"vr": "US", "Value": [813]},
        "2361": {"vr": "US", "Value": [72]},
        "2362": {"vr": "US", "Value": [66]},
        "2363": {"vr": "US", "Value": [78]},
        "2364": {"vr": "US", "Value": [45]},
        "2365": {"vr": "US", "Value": [91]},
        "2366": {"vr": "US", "Value": [88]},
        "2367": {"vr": "US", "Value": [79]},
        "2368": {"vr": "US", "Value": [62]},
        "2369": {"vr": "US", "Value": [808]},
        "2370": {"vr": "US", "Value": [77]},
        "2371": {"vr": "US", "Value": [94]},
        "2372": {"vr": "US", "Value": [40]},
        "2373": {"vr": "US", "Value": [98]},
        "2374": {"vr": "US", "Value": [37]},
        "2375": {"vr": "US", "Value": [89]},
        "2376": {"vr": "US", "Value": [711]},
        "2377": {"vr": "US", "Value": [86]},
        "2378": {"vr": "US", "Value": [23]},
        "2379": {"vr": "US", "Value": [82]},
        "2380": {"vr": "US", "Value": [97]},
        "2381": {"vr": "US", "Value": [781]},
        "2382": {"vr": "US", "Value": [1110]},
        "2383": {"vr": "US", "Value": [71]},
        "2384": {"vr": "US", "Value": [104]},
        "2385": {"vr": "US", "Value": [1335]},
        "2386": {"vr": "US", "Value": [56]},
        "2387": {"vr": "US", "Value": [83]},
        "2388": {"vr": "US", "Value": [63]},
        "2389": {"vr": "US", "Value": [83]},
        "2390": {"vr": "US", "Value": [127]},
        "2391": {"vr": "US", "Value": [37]},
        "2392": {"vr": "US", "Value": [54]},
        "2393": {"vr": "US", "Value": [67]},
        "2394": {"vr": "US", "Value": [1284]},
        "2395": {"vr": "US", "Value": [63]},
        "2396": {"vr": "US", "Value": [72]},
        "2397": {"vr": "US", "Value": [70]},
        "2398": {"vr": "US", "Value": [73]},
        "2399": {"vr": "US", "Value": [82]},
        "2400": {"vr": "US", "Value": [1225]},
        "2401": {"vr": "US", "Value": [59]},
        "2402": {"vr": "US", "Value": [81]},
        "2403": {"vr": "US", "Value": [98]},
        "2404": {"vr": "US", "Value": [86]},
        "2405": {"vr": "US", "Value": [75]},
        "2406": {"vr": "US", "Value": [50]},
        "2407": {"vr": "US", "Value": [60]},
        "2408": {"vr": "US", "Value": [60]},
        "2409": {"vr": "US", "Value": [92]},
        "2410": {"vr": "US", "Value": [79]},
        "2411": {"vr": "US", "Value": [101]},
        "2412": {"vr": "US", "Value": [112]},
        "2413": {"vr": "US", "Value": [67]},
        "2414": {"vr": "US", "Value": [74]},
        "2415": {"vr": "US", "Value": [45]},
        "2416": {"vr": "US", "Value": [81]},
        "2417": {"vr": "US", "Value": [861]},
        "2418": {"vr": "US", "Value": [851]},
        "2419": {"vr": "US", "Value": [56]},
        "2420": {"vr": "US", "Value": [109]},
        "2421": {"vr": "US", "Value": [92]},
        "2422": {"vr": "US", "Value": [97]},
        "2423": {"vr": "US", "Value": [38]},
        "2424": {"vr": "US", "Value": [105]},
        "2425": {"vr": "US", "Value": [87]},
        "2426": {"vr": "US", "Value": [74]},
        "2427": {"vr": "US", "Value": [99]},
        "2428": {"vr": "US", "Value": [90]},
        "2429": {"vr": "US", "Value": [82]},
        "2430": {"vr": "US", "Value": [73]},
        "2431": {"vr": "US", "Value": [110]},
        "2432": {"vr": "US", "Value": [68]},
        "2433": {"vr": "US", "Value": [745]},
        "2434": {"vr": "US", "Value": [46]},
        "2435": {"vr": "US", "Value": [52]},
        "2436": {"vr": "US", "Value": [74]},
        "2437": {"vr": "US", "Value": [76]},
        "2438": {"vr": "US", "Value": [96]},
        "2439": {"vr": "US", "Value": [87]},
        "2440": {"vr": "US", "Value": [95]},
        "2441": {"vr": "US", "Value": [89]},
        "2442": {"vr": "US", "Value": [45]},
        "2443": {"vr": "US", "Value": [70]},
        "2444": {"vr": "US", "Value": [115]},
        "2445": {"vr": "US", "Value": [78]},
        "2446": {"vr": "US", "Value": [102]},
        "2447": {"vr": "US", "Value": [96]},
        "2448": {"vr": "US", "Value": [141]},
        "2449": {"vr": "US", "Value": [59]},
        "2450": {"vr": "US", "Value": [91]},
        "2451": {"vr": "US", "Value": [94]},
        "2452": {"vr": "US", "Value": [69]},
        "2453": {"vr": "US", "Value": [82]},
        "2454": {"vr": "US", "Value": [106]},
        "2455": {"vr": "US", "Value": [45]},
        "2456": {"vr": "US", "Value": [68]},
        "2457": {"vr": "US", "Value": [78]},
        "2458": {"vr": "US", "Value": [115]},
        "2459": {"vr": "US", "Value": [104]},
        "2460": {"vr": "US", "Value": [94]},
        "2461": {"vr": "US", "Value": [124]},
        "2462": {"vr": "US", "Value": [72]},
        "2463": {"vr": "US", "Value": [79]},
        "2464": {"vr": "US", "Value": [58]},
        "2465": {"vr": "US", "Value": [86]},
        "2466": {"vr": "US", "Value": [37]},
        "2467": {"vr": "US", "Value": [68]},
        "2468": {"vr": "US", "Value": [112]},
        "2469": {"vr": "US", "Value": [72]},
        "2470": {"vr": "US", "Value": [79]},
        "2471": {"vr": "US", "Value": [78]},
        "2472": {"vr": "US", "Value": [101]},
        "2473": {"vr": "US", "Value": [77]},
        "2474": {"vr": "US", "Value": [40]},
        "2475": {"vr": "US", "Value": [20]},
        "2476": {"vr": "US", "Value": [105]},
        "2477": {"vr": "US", "Value": [87]},
        "2478": {"vr": "US", "Value": [97]},
        "2479": {"vr": "US", "Value": [693]},
        "2480": {"vr": "US", "Value": [555]},
        "2481": {"vr": "US", "Value": [78]},
        "2482": {"vr": "US", "Value": [106]},
        "2483": {"vr": "US", "Value": [68]},
        "2484": {"vr": "US", "Value": [37]},
        "2485": {"vr": "US", "Value": [118]},
        "2486": {"vr": "US", "Value": [72]},
        "2487": {"vr": "US", "Value": [59]},
        "2488": {"vr": "US", "Value": [43]},
        "2489": {"vr": "US", "Value": [91]},
        "2490": {"vr": "US", "Value": [92]},
        "2491": {"vr": "US", "Value": [106]},
        "2492": {"vr": "US", "Value": [84]},
        "2493": {"vr": "US", "Value": [92]},
        "2494": {"vr": "US", "Value": [50]},
        "2495": {"vr": "US", "Value": [81]},
        "2496": {"vr": "US", "Value": [71]},
        "2497": {"vr": "US", "Value": [81]},
        "2498": {"vr": "US", "Value": [88]},
        "2499": {"vr": "US", "Value": [92]},
        "2500": {"vr": "US", "Value": [69]},
        "2501": {"vr": "US", "Value": [23]},
        "2502": {"vr": "US", "Value": [126]},
        "2503": {"vr": "US", "Value": [84]},
        "2504": {"vr": "US", "Value": [80]},
        "2505": {"vr": "US", "Value": [38]},
        "2506": {"vr": "US", "Value": [72]},
        "2507": {"vr": "US", "Value": [107]},
        "2508": {"vr": "US", "Value": [71]},
        "2509": {"vr": "US", "Value": [82]},
        "2510": {"vr": "US", "Value": [53]},
        "2511": {"vr": "US", "Value": [129]},
        "2512": {"vr": "US", "Value": [76]},
        "2513": {"vr": "US", "Value": [77]},
        "2514": {"vr": "US", "Value": [87]},
        "2515": {"vr": "US", "Value": [80]},
        "2516": {"vr": "US", "Value": [109]},
        "2517": {"vr": "US", "Value": [124]},
        "2518": {"vr": "US", "Value": [94]},
        "2519": {"vr": "US", "Value": [102]},
        "2520": {"vr": "US", "Value": [1334]},
        "2521": {"vr": "US", "Value": [86]},
        "2522": {"vr": "US", "Value": [833]},
        "2523": {"vr": "US", "Value": [112]},
        "2524": {"vr": "US", "Value": [76]},
        "2525": {"vr": "US", "Value": [943]},
        "2526": {"vr": "US", "Value": [64]},
        "2527": {"vr": "US", "Value": [74]},
        "2528": {"vr": "US", "Value": [41]},
        "2529": {"vr": "US", "Value": [104]},
        "2530": {"vr": "US", "Value": [41]},
        "2531": {"vr": "US", "Value": [43]},
        "2532": {"vr": "US", "Value": [101]},
        "2533": {"vr": "US", "Value": [22]},
        "2534": {"vr": "US", "Value": [851]},
        "2535": {"vr": "US", "Value": [76]},
        "2536": {"vr": "US", "Value": [47]},
        "2537": {"vr": "US", "Value": [753]},
        "2538": {"vr": "US", "Value": [67]},
        "2539": {"vr": "US", "Value": [1181]},
        "2540": {"vr": "US", "Value": [127]},
        "2541": {"vr": "US", "Value": [25]},
        "2542": {"vr": "US", "Value": [94]},
        "2543": {"vr": "US", "Value": [108]},
        "2544": {"vr": "US", "Value": [48]},
        "2545": {"vr": "US", "Value": [113]},
        "2546": {"vr": "US", "Value": [1477]},
        "2547": {"vr": "US", "Value": [85]},
        "2548": {"vr": "US", "Value": [1369]},
        "2549": {"vr": "US", "Value": [54]},
        "2550": {"vr": "US", "Value": [108]},
        "2551": {"vr": "US", "Value": [65]},
        "2552": {"vr": "US", "Value": [72]},
        "2553": {"vr": "US", "Value": [54]},
        "2554": {"vr": "US", "Value": [79]},
        "2555": {"vr": "US", "Value": [78]},
        "2556": {"vr": "US", "Value": [48]},
        "2557": {"vr": "US", "Value": [1196]},
        "2558": {"vr": "US", "Value": [58]},
        "2559": {"vr": "US", "Value": [79]},
        "2560": {"vr": "US", "Value": [86]},
        "2561": {"vr": "US", "Value": [72]},
        "2562": {"vr": "US", "Value": [93]},
        "2563": {"vr": "US", "Value": [112]},
        "2564": {"vr": "US", "Value": [73]},
        "2565": {"vr": "US", "Value": [85]},
        "2566": {"vr": "US", "Value": [87]},
        "2567": {"vr": "US", "Value": [67]},
        "2568": {"vr": "US", "Value": [106]},
        "2569": {"vr": "US", "Value": [107]},
        "2570": {"vr": "US", "Value": [95]},
        "2571": {"vr": "US", "Value": [1818]},
        "2572": {"vr": "US", "Value": [810]},
        "2573": {"vr": "US", "Value": [79]},
        "2574": {"vr": "US", "Value": [106]},
        "2575": {"vr": "US", "Value": [76]},
        "2576": {"vr": "US", "Value": [47]},
        "2577": {"vr": "US", "Value": [79]},
        "2578": {"vr": "US", "Value": [81]},
        "2579": {"vr": "US", "Value": [77]},
        "2580": {"vr": "US", "Value": [82]},
        "2581": {"vr": "US", "Value": [99]},
        "2582": {"vr": "US", "Value": [57]},
        "2583": {"vr": "US", "Value": [86]},
        "2584": {"vr": "US", "Value": [854]},
        "2585": {"vr": "US", "Value": [834]},
        "2586": {"vr": "US", "Value": [35]},
        "2587": {"vr": "US", "Value": [92]},
        "2588": {"vr": "US", "Value": [88]},
        "2589": {"vr": "US", "Value": [87]},
        "2590": {"vr": "US", "Value": [79]},
        "2591": {"vr": "US", "Value": [106]},
        "2592": {"vr": "US", "Value": [90]},
        "2593": {"vr": "US", "Value": [40]},
        "2594": {"vr": "US", "Value": [106]},
        "2595": {"vr": "US", "Value": [120]},
        "2596": {"vr": "US", "Value": [61]},
        "2597": {"vr": "US", "Value": [34]},
        "2598": {"vr": "US", "Value": [84]},
        "2599": {"vr": "US", "Value": [74]},
        "2600": {"vr": "US", "Value": [97]},
        "2601": {"vr": "US", "Value": [64]},
        "2602": {"vr": "US", "Value": [70]},
        "2603": {"vr": "US", "Value": [52]},
        "2604": {"vr": "US", "Value": [90]},
        "2605": {"vr": "US", "Value": [78]},
        "2606": {"vr": "US", "Value": [103]},
        "2607": {"vr": "US", "Value": [42]},
        "2608": {"vr": "US", "Value": [80]},
        "2609": {"vr": "US", "Value": [997]},
        "2610": {"vr": "US", "Value": [96]},
        "2611": {"vr": "US", "Value": [839]},
        "2612": {"vr": "US", "Value": [92]},
        "2613": {"vr": "US", "Value": [72]},
        "2614": {"vr": "US", "Value": [74]},
        "2615": {"vr": "US", "Value": [76]},
        "2616": {"vr": "US", "Value": [95]},
        "2617": {"vr": "US", "Value": [79]},
        "2618": {"vr": "US", "Value": [989]},
        "2619": {"vr": "US", "Value": [109]},
        "2620": {"vr": "US", "Value": [106]},
        "2621": {"vr": "US", "Value": [124]},
        "2622": {"vr": "US", "Value": [121]},
        "2623": {"vr": "US", "Value": [92]},
        "2624": {"vr": "US", "Value": [88]},
        "2625": {"vr": "US", "Value": [78]},
        "2626": {"vr": "US", "Value": [74]},
        "2627": {"vr": "US", "Value": [80]},
        "2628": {"vr": "US", "Value": [710]},
        "2629": {"vr": "US", "Value": [798]},
        "2630": {"vr": "US", "Value": [90]},
        "2631": {"vr": "US", "Value": [78]},
        "2632": {"vr": "US", "Value": [74]},
        "2633": {"vr": "US", "Value": [100]},
        "2634": {"vr": "US", "Value": [56]},
        "2635": {"vr": "US", "Value": [71]},
        "2636": {"vr": "US", "Value": [960]},
        "2637": {"vr": "US", "Value": [93]},
        "2638": {"vr": "US", "Value": [87]},
        "2639": {"vr": "US", "Value": [835]},
        "2640": {"vr": "US", "Value": [817]},
        "2641": {"vr": "US", "Value": [93]},
        "2642": {"vr": "US", "Value": [83]},
        "2643": {"vr": "US", "Value": [72]},
        "2644": {"vr": "US", "Value": [101]},
        "2645": {"vr": "US", "Value": [60]},
        "2646": {"vr": "US", "Value": [86]},
        "2647": {"vr": "US", "Value": [110]},
        "2648": {"vr": "US", "Value": [48]},
        "2649": {"vr": "US", "Value": [93]},
        "2650": {"vr": "US", "Value": [83]},
        "2651": {"vr": "US", "Value": [52]},
        "2652": {"vr": "US", "Value": [101]},
        "2653": {"vr": "US", "Value": [66]},
        "2654": {"vr": "US", "Value": [86]},
        "2655": {"vr": "US", "Value": [109]},
        "2656": {"vr": "US", "Value": [87]},
        "2657": {"vr": "US", "Value": [98]},
        "2658": {"vr": "US", "Value": [783]},
        "2659": {"vr": "US", "Value": [94]},
        "2660": {"vr": "US", "Value": [74]},
        "2661": {"vr": "US", "Value": [57]},
        "2662": {"vr": "US", "Value": [79]},
        "2663": {"vr": "US", "Value": [107]},
        "2664": {"vr": "US", "Value": [81]},
        "2665": {"vr": "US", "Value": [58]},
        "2666": {"vr": "US", "Value": [82]},
        "2667": {"vr": "US", "Value": [83]},
        "2668": {"vr": "US", "Value": [64]},
        "2669": {"vr": "US", "Value": [75]},
        "2670": {"vr": "US", "Value": [69]},
        "2671": {"vr": "US", "Value": [96]},
        "2672": {"vr": "US", "Value": [56]},
        "2673": {"vr": "US", "Value": [107]},
        "2674": {"vr": "US", "Value": [40]},
        "2675": {"vr": "US", "Value": [76]},
        "2676": {"vr": "US", "Value": [92]},
        "2677": {"vr": "US", "Value": [106]},
        "2678": {"vr": "US", "Value": [111]},
        "2679": {"vr": "US", "Value": [837]},
        "2680": {"vr": "US", "Value": [110]},
        "2681": {"vr": "US", "Value": [103]},
        "2682": {"vr": "US", "Value": [85]},
        "2683": {"vr": "US", "Value": [75]},
        "2684": {"vr": "US", "Value": [74]},
        "2685": {"vr": "US", "Value": [73]},
        "2686": {"vr": "US", "Value": [69]},
        "2687": {"vr": "US", "Value": [81]},
        "2688": {"vr": "US", "Value": [108]},
        "2689": {"vr": "US", "Value": [96]},
        "2690": {"vr": "US", "Value": [66]},
        "2691": {"vr": "US", "Value": [105]},
        "2692": {"vr": "US", "Value": [78]},
        "2693": {"vr": "US", "Value": [86]},
        "2694": {"vr": "US", "Value": [53]},
        "2695": {"vr": "US", "Value": [94]},
        "2696": {"vr": "US", "Value": [69]},
        "2697": {"vr": "US", "Value": [24]},
        "2698": {"vr": "US", "Value": [46]},
        "2699": {"vr": "US", "Value": [91]},
        "2700": {"vr": "US", "Value": [110]},
        "2701": {"vr": "US", "Value": [69]},
        "2702": {"vr": "US", "Value": [308]},
        "2703": {"vr": "US", "Value": [101]},
        "2704": {"vr": "US", "Value": [110]},
        "2705": {"vr": "US", "Value": [118]},
        "2706": {"vr": "US", "Value": [77]},
        "2707": {"vr": "US", "Value": [88]},
        "2708": {"vr": "US", "Value": [86]},
        "2709": {"vr": "US", "Value": [81]},
        "2710": {"vr": "US", "Value": [88]},
        "2711": {"vr": "US", "Value": [124]},
        "2712": {"vr": "US", "Value": [61]},
        "2713": {"vr": "US", "Value": [73]},
        "2714": {"vr": "US", "Value": [46]},
        "2715": {"vr": "US", "Value": [85]},
        "2716": {"vr": "US", "Value": [83]},
        "2717": {"vr": "US", "Value": [89]},
        "2718": {"vr": "US", "Value": [85]},
        "2719": {"vr": "US", "Value": [93]},
        "2720": {"vr": "US", "Value": [105]},
        "2721": {"vr": "US", "Value": [67]},
        "2722": {"vr": "US", "Value": [77]},
        "2723": {"vr": "US", "Value": [109]},
        "2724": {"vr": "US", "Value": [110]},
        "2725": {"vr": "US", "Value": [108]},
        "2726": {"vr": "US", "Value": [757]},
        "2727": {"vr": "US", "Value": [79]},
        "2728": {"vr": "US", "Value": [84]},
        "2729": {"vr": "US", "Value": [50]},
        "2730": {"vr": "US", "Value": [116]},
        "2731": {"vr": "US", "Value": [64]},
        "2732": {"vr": "US", "Value": [111]},
        "2733": {"vr": "US", "Value": [101]},
        "2734": {"vr": "US", "Value": [37]},
        "2735": {"vr": "US", "Value": [38]},
        "2736": {"vr": "US", "Value": [1146]},
        "2737": {"vr": "US", "Value": [85]},
        "2738": {"vr": "US", "Value": [74]},
        "2739": {"vr": "US", "Value": [36]},
        "2740": {"vr": "US", "Value": [80]},
        "2741": {"vr": "US", "Value": [853]},
        "2742": {"vr": "US", "Value": [91]},
        "2743": {"vr": "US", "Value": [82]},
        "2744": {"vr": "US", "Value": [74]},
        "2745": {"vr": "US", "Value": [81]},
        "2746": {"vr": "US", "Value": [793]},
        "2747": {"vr": "US", "Value": [86]},
        "2748": {"vr": "US", "Value": [39]},
        "2749": {"vr": "US", "Value": [41]},
        "2750": {"vr": "US", "Value": [858]},
        "2751": {"vr": "US", "Value": [93]},
        "2752": {"vr": "US", "Value": [89]},
        "2753": {"vr": "US", "Value": [103]},
        "2754": {"vr": "US", "Value": [56]},
        "2755": {"vr": "US", "Value": [74]},
        "2756": {"vr": "US", "Value": [64]},
        "2757": {"vr": "US", "Value": [793]},
        "2758": {"vr": "US", "Value": [91]},
        "2759": {"vr": "US", "Value": [91]},
        "2760": {"vr": "US", "Value": [66]},
        "2761": {"vr": "US", "Value": [72]},
        "2762": {"vr": "US", "Value": [138]},
        "2763": {"vr": "US", "Value": [40]},
        "2764": {"vr": "US", "Value": [53]},
        "2765": {"vr": "US", "Value": [1227]},
        "2766": {"vr": "US", "Value": [114]},
        "2767": {"vr": "US", "Value": [108]},
        "2768": {"vr": "US", "Value": [102]},
        "2769": {"vr": "US", "Value": [94]},
        "2770": {"vr": "US", "Value": [840]},
        "2771": {"vr": "US", "Value": [56]},
        "2772": {"vr": "US", "Value": [99]},
        "2773": {"vr": "US", "Value": [80]},
        "2774": {"vr": "US", "Value": [82]},
        "2775": {"vr": "US", "Value": [88]},
        "2776": {"vr": "US", "Value": [86]},
        "2777": {"vr": "US", "Value": [919]},
        "2778": {"vr": "US", "Value": [83]},
        "2779": {"vr": "US", "Value": [78]},
        "2780": {"vr": "US", "Value": [43]},
        "2781": {"vr": "US", "Value": [887]},
        "2782": {"vr": "US", "Value": [82]},
        "2783": {"vr": "US", "Value": [39]},
        "2784": {"vr": "US", "Value": [40]},
        "2785": {"vr": "US", "Value": [92]},
        "2786": {"vr": "US", "Value": [96]},
        "2787": {"vr": "US", "Value": [74]},
        "2788": {"vr": "US", "Value": [82]},
        "2789": {"vr": "US", "Value": [66]},
        "2790": {"vr": "US", "Value": [75]},
        "2791": {"vr": "US", "Value": [148]},
        "2792": {"vr": "US", "Value": [842]},
        "2793": {"vr": "US", "Value": [124]},
        "2794": {"vr": "US", "Value": [73]},
        "2795": {"vr": "US", "Value": [106]},
        "2796": {"vr": "US", "Value": [60]},
        "2797": {"vr": "US", "Value": [842]},
        "2798": {"vr": "US", "Value": [104]},
        "2799": {"vr": "US", "Value": [84]},
        "2800": {"vr": "US", "Value": [87]},
        "2801": {"vr": "US", "Value": [23]},
        "2802": {"vr": "US", "Value": [85]},
        "2803": {"vr": "US", "Value": [77]},
        "2804": {"vr": "US", "Value": [66]},
        "2805": {"vr": "US", "Value": [53]},
        "2806": {"vr": "US", "Value": [79]},
        "2807": {"vr": "US", "Value": [79]},
        "2808": {"vr": "US", "Value": [78]},
        "2809": {"vr": "US", "Value": [108]},
        "2810": {"vr": "US", "Value": [62]},
        "2811": {"vr": "US", "Value": [61]},
        "2812": {"vr": "US", "Value": [76]},
        "2813": {"vr": "US", "Value": [107]},
        "2814": {"vr": "US", "Value": [91]},
        "2815": {"vr": "US", "Value": [39]},
        "2816": {"vr": "US", "Value": [99]},
        "2817": {"vr": "US", "Value": [108]},
        "2818": {"vr": "US", "Value": [777]},
        "2819": {"vr": "US", "Value": [86]},
        "2820": {"vr": "US", "Value": [74]},
        "2821": {"vr": "US", "Value": [94]},
        "2822": {"vr": "US", "Value": [1253]},
        "2823": {"vr": "US", "Value": [46]},
        "2824": {"vr": "US", "Value": [43]},
        "2825": {"vr": "US", "Value": [56]},
        "2826": {"vr": "US", "Value": [86]},
        "2827": {"vr": "US", "Value": [45]},
        "2828": {"vr": "US", "Value": [61]},
        "2829": {"vr": "US", "Value": [70]},
        "2830": {"vr": "US", "Value": [867]},
        "2831": {"vr": "US", "Value": [60]},
        "2832": {"vr": "US", "Value": [97]},
        "2833": {"vr": "US", "Value": [51]},
        "2834": {"vr": "US", "Value": [101]},
        "2835": {"vr": "US", "Value": [123]},
        "2836": {"vr": "US", "Value": [111]},
        "2837": {"vr": "US", "Value": [111]},
        "2838": {"vr": "US", "Value": [80]},
        "2839": {"vr": "US", "Value": [103]},
        "2840": {"vr": "US", "Value": [117]},
        "2841": {"vr": "US", "Value": [95]},
        "2842": {"vr": "US", "Value": [85]},
        "2843": {"vr": "US", "Value": [68]},
        "2844": {"vr": "US", "Value": [94]},
        "2845": {"vr": "US", "Value": [67]},
        "2846": {"vr": "US", "Value": [102]},
        "2847": {"vr": "US", "Value": [132]},
        "2848": {"vr": "US", "Value": [56]},
        "2849": {"vr": "US", "Value": [44]},
        "2850": {"vr": "US", "Value": [94]},
        "2851": {"vr": "US", "Value": [109]},
        "2852": {"vr": "US", "Value": [873]},
        "2853": {"vr": "US", "Value": [100]},
        "2854": {"vr": "US", "Value": [66]},
        "2855": {"vr": "US", "Value": [1269]},
        "2856": {"vr": "US", "Value": [79]},
        "2857": {"vr": "US", "Value": [71]},
        "2858": {"vr": "US", "Value": [62]},
        "2859": {"vr": "US", "Value": [85]},
        "2860": {"vr": "US", "Value": [50]},
        "2861": {"vr": "US", "Value": [35]},
        "2862": {"vr": "US", "Value": [1093]},
        "2863": {"vr": "US", "Value": [110]},
        "2864": {"vr": "US", "Value": [73]},
        "2865": {"vr": "US", "Value": [85]},
        "2866": {"vr": "US", "Value": [74]},
        "2867": {"vr": "US", "Value": [66]},
        "2868": {"vr": "US", "Value": [90]},
        "2869": {"vr": "US", "Value": [63]},
        "2870": {"vr": "US", "Value": [38]},
        "2871": {"vr": "US", "Value": [95]},
        "2872": {"vr": "US", "Value": [35]},
        "2873": {"vr": "US", "Value": [97]},
        "2874": {"vr": "US", "Value": [76]},
        "2875": {"vr": "US", "Value": [89]},
        "2876": {"vr": "US", "Value": [92]},
        "2877": {"vr": "US", "Value": [109]},
        "2878": {"vr": "US", "Value": [1269]},
        "2879": {"vr": "US", "Value": [154]},
        "2880": {"vr": "US", "Value": [98]},
        "2881": {"vr": "US", "Value": [78]},
        "2882": {"vr": "US", "Value": [736]},
        "2883": {"vr": "US", "Value": [94]},
        "2884": {"vr": "US", "Value": [107]},
        "2885": {"vr": "US", "Value": [93]},
        "2886": {"vr": "US", "Value": [64]},
        "2887": {"vr": "US", "Value": [72]},
        "2888": {"vr": "US", "Value": [60]},
        "2889": {"vr": "US", "Value": [106]},
        "2890": {"vr": "US", "Value": [74]},
        "2891": {"vr": "US", "Value": [93]},
        "2892": {"vr": "US", "Value": [108]},
        "2893": {"vr": "US", "Value": [71]},
        "2894": {"vr": "US", "Value": [40]},
        "2895": {"vr": "US", "Value": [74]},
        "2896": {"vr": "US", "Value": [53]},
        "2897": {"vr": "US", "Value": [82]},
        "2898": {"vr": "US", "Value": [78]},
        "2899": {"vr": "US", "Value": [50]},
        "2900": {"vr": "US", "Value": [77]},
        "2901": {"vr": "US", "Value": [96]},
        "2902": {"vr": "US", "Value": [94]},
        "2903": {"vr": "US", "Value": [73]},
        "2904": {"vr": "US", "Value": [72]},
        "2905": {"vr": "US", "Value": [92]},
        "2906": {"vr": "US", "Value": [719]},
        "2907": {"vr": "US", "Value": [1033]},
        "2908": {"vr": "US", "Value": [86]},
        "2909": {"vr": "US", "Value": [79]},
        "2910": {"vr": "US", "Value": [87]},
        "2911": {"vr": "US", "Value": [78]},
        "2912": {"vr": "US", "Value": [89]},
        "2913": {"vr": "US", "Value": [91]},
        "2914": {"vr": "US", "Value": [88]},
        "2915": {"vr": "US", "Value": [63]},
        "2916": {"vr": "US", "Value": [840]},
        "2917": {"vr": "US", "Value": [47]},
        "2918": {"vr": "US", "Value": [1046]},
        "2919": {"vr": "US", "Value": [886]},
        "2920": {"vr": "US", "Value": [85]},
        "2921": {"vr": "US", "Value": [59]},
        "2922": {"vr": "US", "Value": [37]},
        "2923": {"vr": "US", "Value": [783]},
        "2924": {"vr": "US", "Value": [104]},
        "2925": {"vr": "US", "Value": [22]},
        "2926": {"vr": "US", "Value": [101]},
        "2927": {"vr": "US", "Value": [102]},
        "2928": {"vr": "US", "Value": [85]},
        "2929": {"vr": "US", "Value": [52]},
        "2930": {"vr": "US", "Value": [1368]},
        "2931": {"vr": "US", "Value": [105]},
        "2932": {"vr": "US", "Value": [126]},
        "2933": {"vr": "US", "Value": [81]},
        "2934": {"vr": "US", "Value": [93]},
        "2935": {"vr": "US", "Value": [285]},
        "2936": {"vr": "US", "Value": [26]},
        "2937": {"vr": "US", "Value": [74]},
        "2938": {"vr": "US", "Value": [108]},
        "2939": {"vr": "US", "Value": [114]},
        "2940": {"vr": "US", "Value": [68]},
        "2941": {"vr": "US", "Value": [81]},
        "2942": {"vr": "US", "Value": [80]},
        "2943": {"vr": "US", "Value": [89]},
        "2944": {"vr": "US", "Value": [108]},
        "2945": {"vr": "US", "Value": [74]},
        "2946": {"vr": "US", "Value": [1065]},
        "2947": {"vr": "US", "Value": [82]},
        "2948": {"vr": "US", "Value": [37]},
        "2949": {"vr": "US", "Value": [1099]},
        "2950": {"vr": "US", "Value": [49]},
        "2951": {"vr": "US", "Value": [93]},
        "2952": {"vr": "US", "Value": [87]},
        "2953": {"vr": "US", "Value": [44]},
        "2954": {"vr": "US", "Value": [730]},
        "2955": {"vr": "US", "Value": [845]},
        "2956": {"vr": "US", "Value": [99]},
        "2957": {"vr": "US", "Value": [90]},
        "2958": {"vr": "US", "Value": [52]},
        "2959": {"vr": "US", "Value": [101]},
        "2960": {"vr": "US", "Value": [79]},
        "2961": {"vr": "US", "Value": [134]},
        "2962": {"vr": "US", "Value": [62]},
        "2963": {"vr": "US", "Value": [67]},
        "2964": {"vr": "US", "Value": [111]},
        "2965": {"vr": "US", "Value": [56]},
        "2966": {"vr": "US", "Value": [75]},
        "2967": {"vr": "US", "Value": [72]},
        "2968": {"vr": "US", "Value": [805]},
        "2969": {"vr": "US", "Value": [73]},
        "2970": {"vr": "US", "Value": [83]},
        "2971": {"vr": "US", "Value": [78]},
        "2972": {"vr": "US", "Value": [88]},
        "2973": {"vr": "US", "Value": [70]},
        "2974": {"vr": "US", "Value": [93]},
        "2975": {"vr": "US", "Value": [100]},
        "2976": {"vr": "US", "Value": [120]},
        "2977": {"vr": "US", "Value": [75]},
        "2978": {"vr": "US", "Value": [64]},
        "2979": {"vr": "US", "Value": [62]},
        "2980": {"vr": "US", "Value": [73]},
        "2981": {"vr": "US", "Value": [120]},
        "2982": {"vr": "US", "Value": [84]},
        "2983": {"vr": "US", "Value": [83]},
        "2984": {"vr": "US", "Value": [93]},
        "2985": {"vr": "US", "Value": [859]},
        "2986": {"vr": "US", "Value": [75]},
        "2987": {"vr": "US", "Value": [69]},
        "2988": {"vr": "US", "Value": [91]},
        "2989": {"vr": "US", "Value": [97]},
        "2990": {"vr": "US", "Value": [117]},
        "2991": {"vr": "US", "Value": [69]},
        "2992": {"vr": "US", "Value": [91]},
        "2993": {"vr": "US", "Value": [69]},
        "2994": {"vr": "US", "Value": [60]},
        "2995": {"vr": "US", "Value": [46]},
        "2996": {"vr": "US", "Value": [101]},
        "2997": {"vr": "US", "Value": [75]},
        "2998": {"vr": "US", "Value": [72]},
        "2999": {"vr": "US", "Value": [108]},
        "3000": {"vr": "US", "Value": [107]},
        "3001": {"vr": "US", "Value": [81]},
        "3002": {"vr": "US", "Value": [97]},
        "3003": {"vr": "US", "Value": [79]},
        "3004": {"vr": "US", "Value": [112]},
        "3005": {"vr": "US", "Value": [930]},
        "3006": {"vr": "US", "Value": [94]},
        "3007": {"vr": "US", "Value": [71]},
        "3008": {"vr": "US", "Value": [81]},
        "3009": {"vr": "US", "Value": [78]},
        "3010": {"vr": "US", "Value": [89]},
        "3011": {"vr": "US", "Value": [101]},
        "3012": {"vr": "US", "Value": [82]},
        "3013": {"vr": "US", "Value": [81]},
        "3014": {"vr": "US", "Value": [90]},
        "3015": {"vr": "US", "Value": [77]},
        "3016": {"vr": "US", "Value": [72]},
        "3017": {"vr": "US", "Value": [65]},
        "3018": {"vr": "US", "Value": [100]},
        "3019": {"vr": "US", "Value": [770]},
        "3020": {"vr": "US", "Value": [89]},
        "3021": {"vr": "US", "Value": [104]},
        "3022": {"vr": "US", "Value": [87]},
        "3023": {"vr": "US", "Value": [116]},
        "3024": {"vr": "US", "Value": [66]},
        "3025": {"vr": "US", "Value": [74]},
        "3026": {"vr": "US", "Value": [72]},
        "3027": {"vr": "US", "Value": [102]},
        "3028": {"vr": "US", "Value": [99]},
        "3029": {"vr": "US", "Value": [788]},
        "3030": {"vr": "US", "Value": [110]},
        "3031": {"vr": "US", "Value": [59]},
        "3032": {"vr": "US", "Value": [88]},
        "3033": {"vr": "US", "Value": [92]},
        "3034": {"vr": "US", "Value": [91]},
        "3035": {"vr": "US", "Value": [107]},
        "3036": {"vr": "US", "Value": [71]},
        "3037": {"vr": "US", "Value": [93]},
        "3038": {"vr": "US", "Value": [81]},
        "3039": {"vr": "US", "Value": [83]},
        "3040": {"vr": "US", "Value": [93]},
        "3041": {"vr": "US", "Value": [76]},
        "3042": {"vr": "US", "Value": [82]},
        "3043": {"vr": "US", "Value": [61]},
        "3044": {"vr": "US", "Value": [114]},
        "3045": {"vr": "US", "Value": [65]},
        "3046": {"vr": "US", "Value": [97]},
        "3047": {"vr": "US", "Value": [66]},
        "3048": {"vr": "US", "Value": [63]},
        "3049": {"vr": "US", "Value": [57]},
        "3050": {"vr": "US", "Value": [84]},
        "3051": {"vr": "US", "Value": [90]},
        "3052": {"vr": "US", "Value": [74]},
        "3053": {"vr": "US", "Value": [973]},
        "3054": {"vr": "US", "Value": [107]},
        "3055": {"vr": "US", "Value": [90]},
        "3056": {"vr": "US", "Value": [115]},
        "3057": {"vr": "US", "Value": [85]},
        "3058": {"vr": "US", "Value": [56]},
        "3059": {"vr": "US", "Value": [52]},
        "3060": {"vr": "US", "Value": [80]},
        "3061": {"vr": "US", "Value": [62]},
        "3062": {"vr": "US", "Value": [97]},
        "3063": {"vr": "US", "Value": [77]},
        "3064": {"vr": "US", "Value": [91]},
        "3065": {"vr": "US", "Value": [92]},
        "3066": {"vr": "US", "Value": [69]},
        "3067": {"vr": "US", "Value": [66]},
        "3068": {"vr": "US", "Value": [72]},
        "3069": {"vr": "US", "Value": [95]},
        "3070": {"vr": "US", "Value": [73]},
        "3071": {"vr": "US", "Value": [92]},
        "3072": {"vr": "US", "Value": [764]},
        "3073": {"vr": "US", "Value": [62]},
        "3074": {"vr": "US", "Value": [1230]},
        "3075": {"vr": "US", "Value": [90]},
        "3076": {"vr": "US", "Value": [69]},
        "3077": {"vr": "US", "Value": [753]},
        "3078": {"vr": "US", "Value": [51]},
        "3079": {"vr": "US", "Value": [72]},
        "3080": {"vr": "US", "Value": [77]},
        "3081": {"vr": "US", "Value": [65]},
        "3082": {"vr": "US", "Value": [80]},
        "3083": {"vr": "US", "Value": [91]},
        "3084": {"vr": "US", "Value": [108]},
        "3085": {"vr": "US", "Value": [81]},
        "3086": {"vr": "US", "Value": [86]},
        "3087": {"vr": "US", "Value": [94]},
        "3088": {"vr": "US", "Value": [93]},
        "3089": {"vr": "US", "Value": [768]},
        "3090": {"vr": "US", "Value": [94]},
        "3091": {"vr": "US", "Value": [92]},
        "3092": {"vr": "US", "Value": [1310]},
        "3093": {"vr": "US", "Value": [75]},
        "3094": {"vr": "US", "Value": [36]},
        "3095": {"vr": "US", "Value": [78]},
        "3096": {"vr": "US", "Value": [97]},
        "3097": {"vr": "US", "Value": [77]},
        "3098": {"vr": "US", "Value": [91]},
        "3099": {"vr": "US", "Value": [83]},
        "3100": {"vr": "US", "Value": [120]},
        "3101": {"vr": "US", "Value": [85]},
        "3102": {"vr": "US", "Value": [734]},
        "3103": {"vr": "US", "Value": [97]},
        "3104": {"vr": "US", "Value": [114]},
        "3105": {"vr": "US", "Value": [35]},
        "3106": {"vr": "US", "Value": [69]},
        "3107": {"vr": "US", "Value": [59]},
        "3108": {"vr": "US", "Value": [79]},
        "3109": {"vr": "US", "Value": [102]},
        "3110": {"vr": "US", "Value": [84]},
        "3111": {"vr": "US", "Value": [114]},
        "3112": {"vr": "US", "Value": [71]},
        "3113": {"vr": "US", "Value": [23]},
        "3114": {"vr": "US", "Value": [76]},
        "3115": {"vr": "US", "Value": [47]},
        "3116": {"vr": "US", "Value": [94]},
        "3117": {"vr": "US", "Value": [69]},
        "3118": {"vr": "US", "Value": [80]},
        "3119": {"vr": "US", "Value": [88]},
        "3120": {"vr": "US", "Value": [83]},
        "3121": {"vr": "US", "Value": [42]},
        "3122": {"vr": "US", "Value": [80]},
        "3123": {"vr": "US", "Value": [42]},
        "3124": {"vr": "US", "Value": [109]},
        "3125": {"vr": "US", "Value": [82]},
        "3126": {"vr": "US", "Value": [111]},
        "3127": {"vr": "US", "Value": [98]},
        "3128": {"vr": "US", "Value": [38]},
        "3129": {"vr": "US", "Value": [72]},
        "3130": {"vr": "US", "Value": [86]},
        "3131": {"vr": "US", "Value": [91]},
        "3132": {"vr": "US", "Value": [1064]},
        "3133": {"vr": "US", "Value": [92]},
        "3134": {"vr": "US", "Value": [86]},
        "3135": {"vr": "US", "Value": [113]},
        "3136": {"vr": "US", "Value": [109]},
        "3137": {"vr": "US", "Value": [80]},
        "3138": {"vr": "US", "Value": [89]},
        "3139": {"vr": "US", "Value": [75]},
        "3140": {"vr": "US", "Value": [79]},
        "3141": {"vr": "US", "Value": [109]},
        "3142": {"vr": "US", "Value": [72]},
        "3143": {"vr": "US", "Value": [78]},
        "3144": {"vr": "US", "Value": [77]},
        "3145": {"vr": "US", "Value": [123]},
        "3146": {"vr": "US", "Value": [86]},
        "3147": {"vr": "US", "Value": [88]},
        "3148": {"vr": "US", "Value": [81]},
        "3149": {"vr": "US", "Value": [20]},
        "3150": {"vr": "US", "Value": [88]},
        "3151": {"vr": "US", "Value": [71]},
        "3152": {"vr": "US", "Value": [85]},
        "3153": {"vr": "US", "Value": [52]},
        "3154": {"vr": "US", "Value": [130]},
        "3155": {"vr": "US", "Value": [104]},
        "3156": {"vr": "US", "Value": [82]},
        "3157": {"vr": "US", "Value": [40]},
        "3158": {"vr": "US", "Value": [82]},
        "3159": {"vr": "US", "Value": [97]},
        "3160": {"vr": "US", "Value": [752]},
        "3161": {"vr": "US", "Value": [89]},
        "3162": {"vr": "US", "Value": [99]},
        "3163": {"vr": "US", "Value": [88]},
        "3164": {"vr": "US", "Value": [61]},
        "3165": {"vr": "US", "Value": [836]},
        "3166": {"vr": "US", "Value": [99]},
        "3167": {"vr": "US", "Value": [98]},
        "3168": {"vr": "US", "Value": [101]},
        "3169": {"vr": "US", "Value": [58]},
        "3170": {"vr": "US", "Value": [54]},
        "3171": {"vr": "US", "Value": [79]},
        "3172": {"vr": "US", "Value": [739]},
        "3173": {"vr": "US", "Value": [24]},
        "3174": {"vr": "US", "Value": [62]},
        "3175": {"vr": "US", "Value": [101]},
        "3176": {"vr": "US", "Value": [49]},
        "3177": {"vr": "US", "Value": [86]},
        "3178": {"vr": "US", "Value": [33]},
        "3179": {"vr": "US", "Value": [72]},
        "3180": {"vr": "US", "Value": [76]},
        "3181": {"vr": "US", "Value": [74]},
        "3182": {"vr": "US", "Value": [100]},
        "3183": {"vr": "US", "Value": [85]},
        "3184": {"vr": "US", "Value": [83]},
        "3185": {"vr": "US", "Value": [76]},
        "3186": {"vr": "US", "Value": [90]},
        "3187": {"vr": "US", "Value": [113]},
        "3188": {"vr": "US", "Value": [67]},
        "3189": {"vr": "US", "Value": [19]},
        "3190": {"vr": "US", "Value": [93]},
        "3191": {"vr": "US", "Value": [78]},
        "3192": {"vr": "US", "Value": [21]},
        "3193": {"vr": "US", "Value": [771]},
        "3194": {"vr": "US", "Value": [787]},
        "3195": {"vr": "US", "Value": [88]},
        "3196": {"vr": "US", "Value": [80]},
        "3197": {"vr": "US", "Value": [89]},
        "3198": {"vr": "US", "Value": [77]},
        "3199": {"vr": "US", "Value": [74]},
        "3200": {"vr": "US", "Value": [78]},
        "3201": {"vr": "US", "Value": [73]},
        "3202": {"vr": "US", "Value": [109]},
        "3203": {"vr": "US", "Value": [59]},
        "3204": {"vr": "US", "Value": [124]},
        "3205": {"vr": "US", "Value": [84]},
        "3206": {"vr": "US", "Value": [64]},
        "3207": {"vr": "US", "Value": [76]},
        "3208": {"vr": "US", "Value": [95]},
        "3209": {"vr": "US", "Value": [47]},
        "3210": {"vr": "US", "Value": [84]},
        "3211": {"vr": "US", "Value": [84]},
        "3212": {"vr": "US", "Value": [66]},
        "3213": {"vr": "US", "Value": [89]},
        "3214": {"vr": "US", "Value": [93]},
        "3215": {"vr": "US", "Value": [87]},
        "3216": {"vr": "US", "Value": [59]},
        "3217": {"vr": "US", "Value": [137]},
        "3218": {"vr": "US", "Value": [1191]},
        "3219": {"vr": "US", "Value": [80]},
        "3220": {"vr": "US", "Value": [68]},
        "3221": {"vr": "US", "Value": [76]},
        "3222": {"vr": "US", "Value": [96]},
        "3223": {"vr": "US", "Value": [70]},
        "3224": {"vr": "US", "Value": [17]},
        "3225": {"vr": "US", "Value": [62]},
        "3226": {"vr": "US", "Value": [92]},
        "3227": {"vr": "US", "Value": [83]},
        "3228": {"vr": "US", "Value": [132]},
        "3229": {"vr": "US", "Value": [120]},
        "3230": {"vr": "US", "Value": [1101]},
        "3231": {"vr": "US", "Value": [73]},
        "3232": {"vr": "US", "Value": [94]},
        "3233": {"vr": "US", "Value": [109]},
        "3234": {"vr": "US", "Value": [111]},
        "3235": {"vr": "US", "Value": [59]},
        "3236": {"vr": "US", "Value": [66]},
        "3237": {"vr": "US", "Value": [60]},
        "3238": {"vr": "US", "Value": [41]},
        "3239": {"vr": "US", "Value": [78]},
        "3240": {"vr": "US", "Value": [94]},
        "3241": {"vr": "US", "Value": [87]},
        "3242": {"vr": "US", "Value": [78]},
        "3243": {"vr": "US", "Value": [734]},
        "3244": {"vr": "US", "Value": [79]},
        "3245": {"vr": "US", "Value": [71]},
        "3246": {"vr": "US", "Value": [91]},
        "3247": {"vr": "US", "Value": [72]},
        "3248": {"vr": "US", "Value": [93]},
        "3249": {"vr": "US", "Value": [58]},
        "3250": {"vr": "US", "Value": [63]},
        "3251": {"vr": "US", "Value": [83]},
        "3252": {"vr": "US", "Value": [95]},
        "3253": {"vr": "US", "Value": [111]},
        "3254": {"vr": "US", "Value": [69]},
        "3255": {"vr": "US", "Value": [86]},
        "3256": {"vr": "US", "Value": [1052]},
        "3257": {"vr": "US", "Value": [75]},
        "3258": {"vr": "US", "Value": [1012]},
        "3259": {"vr": "US", "Value": [91]},
        "3260": {"vr": "US", "Value": [90]},
        "3261": {"vr": "US", "Value": [71]},
        "3262": {"vr": "US", "Value": [120]},
        "3263": {"vr": "US", "Value": [74]},
        "3264": {"vr": "US", "Value": [842]},
        "3265": {"vr": "US", "Value": [87]},
        "3266": {"vr": "US", "Value": [73]},
        "3267": {"vr": "US", "Value": [64]},
        "3268": {"vr": "US", "Value": [37]},
        "3269": {"vr": "US", "Value": [98]},
        "3270": {"vr": "US", "Value": [1458]},
        "3271": {"vr": "US", "Value": [62]},
        "3272": {"vr": "US", "Value": [81]},
        "3273": {"vr": "US", "Value": [76]},
        "3274": {"vr": "US", "Value": [75]},
        "3275": {"vr": "US", "Value": [88]},
        "3276": {"vr": "US", "Value": [48]},
        "3277": {"vr": "US", "Value": [62]},
        "3278": {"vr": "US", "Value": [41]},
        "3279": {"vr": "US", "Value": [90]},
        "3280": {"vr": "US", "Value": [801]},
        "3281": {"vr": "US", "Value": [119]},
        "3282": {"vr": "US", "Value": [86]},
        "3283": {"vr": "US", "Value": [59]},
        "3284": {"vr": "US", "Value": [104]},
        "3285": {"vr": "US", "Value": [116]},
        "3286": {"vr": "US", "Value": [114]},
        "3287": {"vr": "US", "Value": [73]},
        "3288": {"vr": "US", "Value": [81]},
        "3289": {"vr": "US", "Value": [61]},
        "3290": {"vr": "US", "Value": [52]},
        "3291": {"vr": "US", "Value": [60]},
        "3292": {"vr": "US", "Value": [98]},
        "3293": {"vr": "US", "Value": [49]},
        "3294": {"vr": "US", "Value": [105]},
        "3295": {"vr": "US", "Value": [105]},
        "3296": {"vr": "US", "Value": [81]},
        "3297": {"vr": "US", "Value": [35]},
        "3298": {"vr": "US", "Value": [84]},
        "3299": {"vr": "US", "Value": [55]},
        "3300": {"vr": "US", "Value": [43]},
        "3301": {"vr": "US", "Value": [40]},
        "3302": {"vr": "US", "Value": [96]},
        "3303": {"vr": "US", "Value": [51]},
        "3304": {"vr": "US", "Value": [89]},
        "3305": {"vr": "US", "Value": [90]},
        "3306": {"vr": "US", "Value": [68]},
        "3307": {"vr": "US", "Value": [58]},
        "3308": {"vr": "US", "Value": [92]},
        "3309": {"vr": "US", "Value": [91]},
        "3310": {"vr": "US", "Value": [111]},
        "3311": {"vr": "US", "Value": [91]},
        "3312": {"vr": "US", "Value": [35]},
        "3313": {"vr": "US", "Value": [67]},
        "3314": {"vr": "US", "Value": [67]},
        "3315": {"vr": "US", "Value": [94]},
        "3316": {"vr": "US", "Value": [39]},
        "3317": {"vr": "US", "Value": [104]},
        "3318": {"vr": "US", "Value": [74]},
        "3319": {"vr": "US", "Value": [79]},
        "3320": {"vr": "US", "Value": [53]},
        "3321": {"vr": "US", "Value": [89]},
        "3322": {"vr": "US", "Value": [87]},
        "3323": {"vr": "US", "Value": [42]},
        "3324": {"vr": "US", "Value": [61]},
        "3325": {"vr": "US", "Value": [69]},
        "3326": {"vr": "US", "Value": [77]},
        "3327": {"vr": "US", "Value": [69]},
        "3328": {"vr": "US", "Value": [748]},
        "3329": {"vr": "US", "Value": [72]},
        "3330": {"vr": "US", "Value": [58]},
        "3331": {"vr": "US", "Value": [91]},
        "3332": {"vr": "US", "Value": [86]},
        "3333": {"vr": "US", "Value": [79]},
        "3334": {"vr": "US", "Value": [100]},
        "3335": {"vr": "US", "Value": [84]},
        "3336": {"vr": "US", "Value": [56]},
        "3337": {"vr": "US", "Value": [99]},
        "3338": {"vr": "US", "Value": [117]},
        "3339": {"vr": "US", "Value": [75]},
        "3340": {"vr": "US", "Value": [89]},
        "3341": {"vr": "US", "Value": [98]},
        "3342": {"vr": "US", "Value": [133]},
        "3343": {"vr": "US", "Value": [93]},
        "3344": {"vr": "US", "Value": [84]},
        "3345": {"vr": "US", "Value": [76]},
        "3346": {"vr": "US", "Value": [110]},
        "3347": {"vr": "US", "Value": [810]},
        "3348": {"vr": "US", "Value": [76]},
        "3349": {"vr": "US", "Value": [121]},
        "3350": {"vr": "US", "Value": [100]},
        "3351": {"vr": "US", "Value": [64]},
        "3352": {"vr": "US", "Value": [115]},
        "3353": {"vr": "US", "Value": [48]},
        "3354": {"vr": "US", "Value": [33]},
        "3355": {"vr": "US", "Value": [22]},
        "3356": {"vr": "US", "Value": [93]},
        "3357": {"vr": "US", "Value": [121]},
        "3358": {"vr": "US", "Value": [71]},
        "3359": {"vr": "US", "Value": [139]},
        "3360": {"vr": "US", "Value": [71]},
        "3361": {"vr": "US", "Value": [84]},
        "3362": {"vr": "US", "Value": [71]},
        "3363": {"vr": "US", "Value": [39]},
        "3364": {"vr": "US", "Value": [65]},
        "3365": {"vr": "US", "Value": [1879]},
        "3366": {"vr": "US", "Value": [106]},
        "3367": {"vr": "US", "Value": [84]},
        "3368": {"vr": "US", "Value": [72]},
        "3369": {"vr": "US", "Value": [53]},
        "3370": {"vr": "US", "Value": [91]},
        "3371": {"vr": "US", "Value": [104]},
        "3372": {"vr": "US", "Value": [72]},
        "3373": {"vr": "US", "Value": [103]},
        "3374": {"vr": "US", "Value": [117]},
        "3375": {"vr": "US", "Value": [76]},
        "3376": {"vr": "US", "Value": [90]},
        "3377": {"vr": "US", "Value": [78]},
        "3378": {"vr": "US", "Value": [61]},
        "3379": {"vr": "US", "Value": [75]},
        "3380": {"vr": "US", "Value": [109]},
        "3381": {"vr": "US", "Value": [81]},
        "3382": {"vr": "US", "Value": [81]},
        "3383": {"vr": "US", "Value": [75]},
        "3384": {"vr": "US", "Value": [1488]},
        "3385": {"vr": "US", "Value": [87]},
        "3386": {"vr": "US", "Value": [110]},
        "3387": {"vr": "US", "Value": [91]},
        "3388": {"vr": "US", "Value": [106]},
        "3389": {"vr": "US", "Value": [1183]},
        "3390": {"vr": "US", "Value": [104]},
        "3391": {"vr": "US", "Value": [68]},
        "3392": {"vr": "US", "Value": [100]},
        "3393": {"vr": "US", "Value": [80]},
        "3394": {"vr": "US", "Value": [121]},
        "3395": {"vr": "US", "Value": [97]},
        "3396": {"vr": "US", "Value": [66]},
        "3397": {"vr": "US", "Value": [76]},
        "3398": {"vr": "US", "Value": [96]},
        "3399": {"vr": "US", "Value": [102]},
        "3400": {"vr": "US", "Value": [76]},
        "3401": {"vr": "US", "Value": [73]},
        "3402": {"vr": "US", "Value": [104]},
        "3403": {"vr": "US", "Value": [75]},
        "3404": {"vr": "US", "Value": [71]},
        "3405": {"vr": "US", "Value": [1234]},
        "3406": {"vr": "US", "Value": [131]},
        "3407": {"vr": "US", "Value": [80]},
        "3408": {"vr": "US", "Value": [79]},
        "3409": {"vr": "US", "Value": [83]},
        "3410": {"vr": "US", "Value": [95]},
        "3411": {"vr": "US", "Value": [37]},
        "3412": {"vr": "US", "Value": [82]},
        "3413": {"vr": "US", "Value": [73]},
        "3414": {"vr": "US", "Value": [99]},
        "3415": {"vr": "US", "Value": [95]},
        "3416": {"vr": "US", "Value": [113]},
        "3417": {"vr": "US", "Value": [38]},
        "3418": {"vr": "US", "Value": [78]},
        "3419": {"vr": "US", "Value": [132]},
        "3420": {"vr": "US", "Value": [84]},
        "3421": {"vr": "US", "Value": [73]},
        "3422": {"vr": "US", "Value": [68]},
        "3423": {"vr": "US", "Value": [151]},
        "3424": {"vr": "US", "Value": [67]},
        "3425": {"vr": "US", "Value": [90]},
        "3426": {"vr": "US", "Value": [92]},
        "3427": {"vr": "US", "Value": [55]},
        "3428": {"vr": "US", "Value": [38]},
        "3429": {"vr": "US", "Value": [103]},
        "3430": {"vr": "US", "Value": [88]},
        "3431": {"vr": "US", "Value": [762]},
        "3432": {"vr": "US", "Value": [120]},
        "3433": {"vr": "US", "Value": [71]},
        "3434": {"vr": "US", "Value": [88]},
        "3435": {"vr": "US", "Value": [42]},
        "3436": {"vr": "US", "Value": [1705]},
        "3437": {"vr": "US", "Value": [99]},
        "3438": {"vr": "US", "Value": [70]},
        "3439": {"vr": "US", "Value": [90]},
        "3440": {"vr": "US", "Value": [85]},
        "3441": {"vr": "US", "Value": [76]},
        "3442": {"vr": "US", "Value": [74]},
        "3443": {"vr": "US", "Value": [105]},
        "3444": {"vr": "US", "Value": [76]},
        "3445": {"vr": "US", "Value": [61]},
        "3446": {"vr": "US", "Value": [804]},
        "3447": {"vr": "US", "Value": [89]},
        "3448": {"vr": "US", "Value": [106]},
        "3449": {"vr": "US", "Value": [95]},
        "3450": {"vr": "US", "Value": [97]},
        "3451": {"vr": "US", "Value": [95]},
        "3452": {"vr": "US", "Value": [87]},
        "3453": {"vr": "US", "Value": [67]},
        "3454": {"vr": "US", "Value": [1514]},
        "3455": {"vr": "US", "Value": [100]},
        "3456": {"vr": "US", "Value": [21]},
        "3457": {"vr": "US", "Value": [87]},
        "3458": {"vr": "US", "Value": [36]},
        "3459": {"vr": "US", "Value": [78]},
        "3460": {"vr": "US", "Value": [38]},
        "3461": {"vr": "US", "Value": [73]},
        "3462": {"vr": "US", "Value": [92]},
        "3463": {"vr": "US", "Value": [70]},
        "3464": {"vr": "US", "Value": [109]},
        "3465": {"vr": "US", "Value": [81]},
        "3466": {"vr": "US", "Value": [89]},
        "3467": {"vr": "US", "Value": [47]},
        "3468": {"vr": "US", "Value": [76]},
        "3469": {"vr": "US", "Value": [104]},
        "3470": {"vr": "US", "Value": [92]},
        "3471": {"vr": "US", "Value": [89]},
        "3472": {"vr": "US", "Value": [106]},
        "3473": {"vr": "US", "Value": [90]},
        "3474": {"vr": "US", "Value": [736]},
        "3475": {"vr": "US", "Value": [99]},
        "3476": {"vr": "US", "Value": [74]},
        "3477": {"vr": "US", "Value": [58]},
        "3478": {"vr": "US", "Value": [57]},
        "3479": {"vr": "US", "Value": [95]},
        "3480": {"vr": "US", "Value": [77]},
        "3481": {"vr": "US", "Value": [861]},
        "3482": {"vr": "US", "Value": [90]},
        "3483": {"vr": "US", "Value": [86]},
        "3484": {"vr": "US", "Value": [81]},
        "3485": {"vr": "US", "Value": [77]},
        "3486": {"vr": "US", "Value": [77]},
        "3487": {"vr": "US", "Value": [69]},
        "3488": {"vr": "US", "Value": [82]},
        "3489": {"vr": "US", "Value": [95]},
        "3490": {"vr": "US", "Value": [68]},
        "3491": {"vr": "US", "Value": [89]},
        "3492": {"vr": "US", "Value": [1324]},
        "3493": {"vr": "US", "Value": [100]},
        "3494": {"vr": "US", "Value": [64]},
        "3495": {"vr": "US", "Value": [129]},
        "3496": {"vr": "US", "Value": [65]},
        "3497": {"vr": "US", "Value": [112]},
        "3498": {"vr": "US", "Value": [1482]},
        "3499": {"vr": "US", "Value": [79]},
        "3500": {"vr": "US", "Value": [68]},
        "3501": {"vr": "US", "Value": [846]},
        "3502": {"vr": "US", "Value": [89]},
        "3503": {"vr": "US", "Value": [820]},
        "3504": {"vr": "US", "Value": [88]},
        "3505": {"vr": "US", "Value": [94]},
        "3506": {"vr": "US", "Value": [71]},
        "3507": {"vr": "US", "Value": [91]},
        "3508": {"vr": "US", "Value": [74]},
        "3509": {"vr": "US", "Value": [87]},
        "3510": {"vr": "US", "Value": [84]},
        "3511": {"vr": "US", "Value": [831]},
        "3512": {"vr": "US", "Value": [73]},
        "3513": {"vr": "US", "Value": [79]},
        "3514": {"vr": "US", "Value": [35]},
        "3515": {"vr": "US", "Value": [37]},
        "3516": {"vr": "US", "Value": [35]},
        "3517": {"vr": "US", "Value": [114]},
        "3518": {"vr": "US", "Value": [73]},
        "3519": {"vr": "US", "Value": [84]},
        "3520": {"vr": "US", "Value": [85]},
        "3521": {"vr": "US", "Value": [759]},
        "3522": {"vr": "US", "Value": [876]},
        "3523": {"vr": "US", "Value": [86]},
        "3524": {"vr": "US", "Value": [84]},
        "3525": {"vr": "US", "Value": [99]},
        "3526": {"vr": "US", "Value": [59]},
        "3527": {"vr": "US", "Value": [88]},
        "3528": {"vr": "US", "Value": [86]},
        "3529": {"vr": "US", "Value": [900]},
        "3530": {"vr": "US", "Value": [94]},
        "3531": {"vr": "US", "Value": [69]},
        "3532": {"vr": "US", "Value": [1182]},
        "3533": {"vr": "US", "Value": [74]},
        "3534": {"vr": "US", "Value": [71]},
        "3535": {"vr": "US", "Value": [63]},
        "3536": {"vr": "US", "Value": [76]},
        "3537": {"vr": "US", "Value": [99]},
        "3538": {"vr": "US", "Value": [92]},
        "3539": {"vr": "US", "Value": [845]},
        "3540": {"vr": "US", "Value": [85]},
        "3541": {"vr": "US", "Value": [87]},
        "3542": {"vr": "US", "Value": [68]},
        "3543": {"vr": "US", "Value": [63]},
        "3544": {"vr": "US", "Value": [79]},
        "3545": {"vr": "US", "Value": [100]},
        "3546": {"vr": "US", "Value": [116]},
        "3547": {"vr": "US", "Value": [86]},
        "3548": {"vr": "US", "Value": [63]},
        "3549": {"vr": "US", "Value": [89]},
        "3550": {"vr": "US", "Value": [81]},
        "3551": {"vr": "US", "Value": [76]},
        "3552": {"vr": "US", "Value": [91]},
        "3553": {"vr": "US", "Value": [51]},
        "3554": {"vr": "US", "Value": [118]},
        "3555": {"vr": "US", "Value": [95]},
        "3556": {"vr": "US", "Value": [91]},
        "3557": {"vr": "US", "Value": [53]},
        "3558": {"vr": "US", "Value": [75]},
        "3559": {"vr": "US", "Value": [90]},
        "3560": {"vr": "US", "Value": [65]},
        "3561": {"vr": "US", "Value": [117]},
        "3562": {"vr": "US", "Value": [63]},
        "3563": {"vr": "US", "Value": [55]},
        "3564": {"vr": "US", "Value": [47]},
        "3565": {"vr": "US", "Value": [45]},
        "3566": {"vr": "US", "Value": [126]},
        "3567": {"vr": "US", "Value": [58]},
        "3568": {"vr": "US", "Value": [82]},
        "3569": {"vr": "US", "Value": [76]},
        "3570": {"vr": "US", "Value": [86]},
        "3571": {"vr": "US", "Value": [60]},
        "3572": {"vr": "US", "Value": [70]},
        "3573": {"vr": "US", "Value": [102]},
        "3574": {"vr": "US", "Value": [148]},
        "3575": {"vr": "US", "Value": [741]},
        "3576": {"vr": "US", "Value": [98]},
        "3577": {"vr": "US", "Value": [87]},
        "3578": {"vr": "US", "Value": [87]},
        "3579": {"vr": "US", "Value": [85]},
        "3580": {"vr": "US", "Value": [103]},
        "3581": {"vr": "US", "Value": [105]},
        "3582": {"vr": "US", "Value": [111]},
        "3583": {"vr": "US", "Value": [97]},
        "3584": {"vr": "US", "Value": [83]},
        "3585": {"vr": "US", "Value": [48]},
        "3586": {"vr": "US", "Value": [113]},
        "3587": {"vr": "US", "Value": [67]},
        "3588": {"vr": "US", "Value": [103]},
        "3589": {"vr": "US", "Value": [736]},
        "3590": {"vr": "US", "Value": [69]},
        "3591": {"vr": "US", "Value": [94]},
        "3592": {"vr": "US", "Value": [81]},
        "3593": {"vr": "US", "Value": [86]},
        "3594": {"vr": "US", "Value": [87]},
        "3595": {"vr": "US", "Value": [75]},
        "3596": {"vr": "US", "Value": [780]},
        "3597": {"vr": "US", "Value": [77]},
        "3598": {"vr": "US", "Value": [921]},
        "3599": {"vr": "US", "Value": [73]},
        "3600": {"vr": "US", "Value": [72]},
        "3601": {"vr": "US", "Value": [48]},
        "3602": {"vr": "US", "Value": [39]},
        "3603": {"vr": "US", "Value": [42]},
        "3604": {"vr": "US", "Value": [73]},
        "3605": {"vr": "US", "Value": [97]},
        "3606": {"vr": "US", "Value": [121]},
        "3607": {"vr": "US", "Value": [88]},
        "3608": {"vr": "US", "Value": [40]},
        "3609": {"vr": "US", "Value": [65]},
        "3610": {"vr": "US", "Value": [985]},
        "3611": {"vr": "US", "Value": [88]},
        "3612": {"vr": "US", "Value": [88]},
        "3613": {"vr": "US", "Value": [104]},
        "3614": {"vr": "US", "Value": [1180]},
        "3615": {"vr": "US", "Value": [70]},
        "3616": {"vr": "US", "Value": [96]},
        "3617": {"vr": "US", "Value": [110]},
        "3618": {"vr": "US", "Value": [101]},
        "3619": {"vr": "US", "Value": [74]},
        "3620": {"vr": "US", "Value": [92]},
        "3621": {"vr": "US", "Value": [89]},
        "3622": {"vr": "US", "Value": [95]},
        "3623": {"vr": "US", "Value": [93]},
        "3624": {"vr": "US", "Value": [64]},
        "3625": {"vr": "US", "Value": [95]},
        "3626": {"vr": "US", "Value": [93]},
        "3627": {"vr": "US", "Value": [92]},
        "3628": {"vr": "US", "Value": [849]},
        "3629": {"vr": "US", "Value": [104]},
        "3630": {"vr": "US", "Value": [84]},
        "3631": {"vr": "US", "Value": [50]},
        "3632": {"vr": "US", "Value": [76]},
        "3633": {"vr": "US", "Value": [124]},
        "3634": {"vr": "US", "Value": [60]},
        "3635": {"vr": "US", "Value": [103]},
        "3636": {"vr": "US", "Value": [86]},
        "3637": {"vr": "US", "Value": [54]},
        "3638": {"vr": "US", "Value": [848]},
        "3639": {"vr": "US", "Value": [95]},
        "3640": {"vr": "US", "Value": [864]},
        "3641": {"vr": "US", "Value": [97]},
        "3642": {"vr": "US", "Value": [63]},
        "3643": {"vr": "US", "Value": [84]},
        "3644": {"vr": "US", "Value": [72]},
        "3645": {"vr": "US", "Value": [95]},
        "3646": {"vr": "US", "Value": [102]},
        "3647": {"vr": "US", "Value": [43]},
        "3648": {"vr": "US", "Value": [92]},
        "3649": {"vr": "US", "Value": [88]},
        "3650": {"vr": "US", "Value": [89]},
        "3651": {"vr": "US", "Value": [40]},
        "3652": {"vr": "US", "Value": [104]},
        "3653": {"vr": "US", "Value": [722]},
        "3654": {"vr": "US", "Value": [1338]},
        "3655": {"vr": "US", "Value": [97]},
        "3656": {"vr": "US", "Value": [125]},
        "3657": {"vr": "US", "Value": [39]},
        "3658": {"vr": "US", "Value": [40]},
        "3659": {"vr": "US", "Value": [79]},
        "3660": {"vr": "US", "Value": [68]},
        "3661": {"vr": "US", "Value": [106]},
        "3662": {"vr": "US", "Value": [79]},
        "3663": {"vr": "US", "Value": [105]},
        "3664": {"vr": "US", "Value": [80]},
        "3665": {"vr": "US", "Value": [56]},
        "3666": {"vr": "US", "Value": [72]},
        "3667": {"vr": "US", "Value": [91]},
        "3668": {"vr": "US", "Value": [917]},
        "3669": {"vr": "US", "Value": [99]},
        "3670": {"vr": "US", "Value": [20]},
        "3671": {"vr": "US", "Value": [87]},
        "3672": {"vr": "US", "Value": [62]},
        "3673": {"vr": "US", "Value": [714]},
        "3674": {"vr": "US", "Value": [81]},
        "3675": {"vr": "US", "Value": [79]},
        "3676": {"vr": "US", "Value": [73]},
        "3677": {"vr": "US", "Value": [99]},
        "3678": {"vr": "US", "Value": [82]},
        "3679": {"vr": "US", "Value": [95]},
        "3680": {"vr": "US", "Value": [94]},
        "3681": {"vr": "US", "Value": [92]},
        "3682": {"vr": "US", "Value": [68]},
        "3683": {"vr": "US", "Value": [84]},
        "3684": {"vr": "US", "Value": [131]},
        "3685": {"vr": "US", "Value": [97]},
        "3686": {"vr": "US", "Value": [87]},
        "3687": {"vr": "US", "Value": [797]},
        "3688": {"vr": "US", "Value": [22]},
        "3689": {"vr": "US", "Value": [111]},
        "3690": {"vr": "US", "Value": [82]},
        "3691": {"vr": "US", "Value": [97]},
        "3692": {"vr": "US", "Value": [95]},
        "3693": {"vr": "US", "Value": [71]},
        "3694": {"vr": "US", "Value": [78]},
        "3695": {"vr": "US", "Value": [101]},
        "3696": {"vr": "US", "Value": [1025]},
        "3697": {"vr": "US", "Value": [86]},
        "3698": {"vr": "US", "Value": [1511]},
        "3699": {"vr": "US", "Value": [102]},
        "3700": {"vr": "US", "Value": [49]},
        "3701": {"vr": "US", "Value": [103]},
        "3702": {"vr": "US", "Value": [77]},
        "3703": {"vr": "US", "Value": [106]},
        "3704": {"vr": "US", "Value": [66]},
        "3705": {"vr": "US", "Value": [70]},
        "3706": {"vr": "US", "Value": [94]},
        "3707": {"vr": "US", "Value": [113]},
        "3708": {"vr": "US", "Value": [107]},
        "3709": {"vr": "US", "Value": [91]},
        "3710": {"vr": "US", "Value": [60]},
        "3711": {"vr": "US", "Value": [70]},
        "3712": {"vr": "US", "Value": [91]},
        "3713": {"vr": "US", "Value": [38]},
        "3714": {"vr": "US", "Value": [67]},
        "3715": {"vr": "US", "Value": [53]},
        "3716": {"vr": "US", "Value": [568]},
        "3717": {"vr": "US", "Value": [33]},
        "3718": {"vr": "US", "Value": [92]},
        "3719": {"vr": "US", "Value": [90]},
        "3720": {"vr": "US", "Value": [42]},
        "3721": {"vr": "US", "Value": [23]},
        "3722": {"vr": "US", "Value": [72]},
        "3723": {"vr": "US", "Value": [582]},
        "3724": {"vr": "US", "Value": [92]},
        "3725": {"vr": "US", "Value": [120]},
        "3726": {"vr": "US", "Value": [39]},
        "3727": {"vr": "US", "Value": [92]},
        "3728": {"vr": "US", "Value": [81]},
        "3729": {"vr": "US", "Value": [1466]},
        "3730": {"vr": "US", "Value": [76]},
        "3731": {"vr": "US", "Value": [77]},
        "3732": {"vr": "US", "Value": [73]},
        "3733": {"vr": "US", "Value": [84]},
        "3734": {"vr": "US", "Value": [85]},
        "3735": {"vr": "US", "Value": [315]},
        "3736": {"vr": "US", "Value": [104]},
        "3737": {"vr": "US", "Value": [82]},
        "3738": {"vr": "US", "Value": [78]},
        "3739": {"vr": "US", "Value": [69]},
        "3740": {"vr": "US", "Value": [87]},
        "3741": {"vr": "US", "Value": [85]},
        "3742": {"vr": "US", "Value": [1213]},
        "3743": {"vr": "US", "Value": [74]},
        "3744": {"vr": "US", "Value": [2012]},
        "3745": {"vr": "US", "Value": [57]},
        "3746": {"vr": "US", "Value": [80]},
        "3747": {"vr": "US", "Value": [68]},
        "3748": {"vr": "US", "Value": [18]},
        "3749": {"vr": "US", "Value": [44]},
        "3750": {"vr": "US", "Value": [87]},
        "3751": {"vr": "US", "Value": [97]},
        "3752": {"vr": "US", "Value": [84]},
        "3753": {"vr": "US", "Value": [76]},
        "3754": {"vr": "US", "Value": [91]},
        "3755": {"vr": "US", "Value": [98]},
        "3756": {"vr": "US", "Value": [953]},
        "3757": {"vr": "US", "Value": [39]},
        "3758": {"vr": "US", "Value": [37]},
        "3759": {"vr": "US", "Value": [76]},
        "3760": {"vr": "US", "Value": [79]},
        "3761": {"vr": "US", "Value": [84]},
        "3762": {"vr": "US", "Value": [35]},
        "3763": {"vr": "US", "Value": [843]},
        "3764": {"vr": "US", "Value": [105]},
        "3765": {"vr": "US", "Value": [93]},
        "3766": {"vr": "US", "Value": [77]},
        "3767": {"vr": "US", "Value": [104]},
        "3768": {"vr": "US", "Value": [78]},
        "3769": {"vr": "US", "Value": [66]},
        "3770": {"vr": "US", "Value": [68]},
        "3771": {"vr": "US", "Value": [102]},
        "3772": {"vr": "US", "Value": [77]},
        "3773": {"vr": "US", "Value": [71]},
        "3774": {"vr": "US", "Value": [70]},
        "3775": {"vr": "US", "Value": [86]},
        "3776": {"vr": "US", "Value": [50]},
        "3777": {"vr": "US", "Value": [37]},
        "3778": {"vr": "US", "Value": [81]},
        "3779": {"vr": "US", "Value": [128]},
        "3780": {"vr": "US", "Value": [101]},
        "3781": {"vr": "US", "Value": [85]},
        "3782": {"vr": "US", "Value": [67]},
        "3783": {"vr": "US", "Value": [114]},
        "3784": {"vr": "US", "Value": [76]},
        "3785": {"vr": "US", "Value": [44]},
        "3786": {"vr": "US", "Value": [49]},
        "3787": {"vr": "US", "Value": [64]},
        "3788": {"vr": "US", "Value": [102]},
        "3789": {"vr": "US", "Value": [65]},
        "3790": {"vr": "US", "Value": [103]},
        "3791": {"vr": "US", "Value": [91]},
        "3792": {"vr": "US", "Value": [92]},
        "3793": {"vr": "US", "Value": [85]},
        "3794": {"vr": "US", "Value": [57]},
        "3795": {"vr": "US", "Value": [94]},
        "3796": {"vr": "US", "Value": [88]},
        "3797": {"vr": "US", "Value": [99]},
        "3798": {"vr": "US", "Value": [91]},
        "3799": {"vr": "US", "Value": [93]},
        "3800": {"vr": "US", "Value": [107]},
        "3801": {"vr": "US", "Value": [81]},
        "3802": {"vr": "US", "Value": [100]},
        "3803": {"vr": "US", "Value": [124]},
        "3804": {"vr": "US", "Value": [79]},
        "3805": {"vr": "US", "Value": [116]},
        "3806": {"vr": "US", "Value": [300]},
        "3807": {"vr": "US", "Value": [41]},
        "3808": {"vr": "US", "Value": [77]},
        "3809": {"vr": "US", "Value": [93]},
        "3810": {"vr": "US", "Value": [63]},
        "3811": {"vr": "US", "Value": [123]},
        "3812": {"vr": "US", "Value": [83]},
        "3813": {"vr": "US", "Value": [68]},
        "3814": {"vr": "US", "Value": [41]},
        "3815": {"vr": "US", "Value": [84]},
        "3816": {"vr": "US", "Value": [83]},
        "3817": {"vr": "US", "Value": [111]},
        "3818": {"vr": "US", "Value": [111]},
        "3819": {"vr": "US", "Value": [80]},
        "3820": {"vr": "US", "Value": [62]},
        "3821": {"vr": "US", "Value": [23]},
        "3822": {"vr": "US", "Value": [77]},
        "3823": {"vr": "US", "Value": [95]},
        "3824": {"vr": "US", "Value": [79]},
        "3825": {"vr": "US", "Value": [755]},
        "3826": {"vr": "US", "Value": [94]},
        "3827": {"vr": "US", "Value": [130]},
        "3828": {"vr": "US", "Value": [100]},
        "3829": {"vr": "US", "Value": [92]},
        "3830": {"vr": "US", "Value": [98]},
        "3831": {"vr": "US", "Value": [109]},
        "3832": {"vr": "US", "Value": [821]},
        "3833": {"vr": "US", "Value": [91]},
        "3834": {"vr": "US", "Value": [109]},
        "3835": {"vr": "US", "Value": [69]},
        "3836": {"vr": "US", "Value": [58]},
        "3837": {"vr": "US", "Value": [97]},
        "3838": {"vr": "US", "Value": [82]},
        "3839": {"vr": "US", "Value": [81]},
        "3840": {"vr": "US", "Value": [126]},
        "3841": {"vr": "US", "Value": [98]},
        "3842": {"vr": "US", "Value": [82]},
        "3843": {"vr": "US", "Value": [67]},
        "3844": {"vr": "US", "Value": [105]},
        "3845": {"vr": "US", "Value": [850]},
        "3846": {"vr": "US", "Value": [102]},
        "3847": {"vr": "US", "Value": [41]},
        "3848": {"vr": "US", "Value": [90]},
        "3849": {"vr": "US", "Value": [98]},
        "3850": {"vr": "US", "Value": [44]},
        "3851": {"vr": "US", "Value": [57]},
        "3852": {"vr": "US", "Value": [47]},
        "3853": {"vr": "US", "Value": [41]},
        "3854": {"vr": "US", "Value": [40]},
        "3855": {"vr": "US", "Value": [736]},
        "3856": {"vr": "US", "Value": [89]},
        "3857": {"vr": "US", "Value": [72]},
        "3858": {"vr": "US", "Value": [50]},
        "3859": {"vr": "US", "Value": [73]},
        "3860": {"vr": "US", "Value": [104]},
        "3861": {"vr": "US", "Value": [83]},
        "3862": {"vr": "US", "Value": [56]},
        "3863": {"vr": "US", "Value": [1123]},
        "3864": {"vr": "US", "Value": [76]},
        "3865": {"vr": "US", "Value": [95]},
        "3866": {"vr": "US", "Value": [89]},
        "3867": {"vr": "US", "Value": [76]},
        "3868": {"vr": "US", "Value": [109]},
        "3869": {"vr": "US", "Value": [92]},
        "3870": {"vr": "US", "Value": [87]},
        "3871": {"vr": "US", "Value": [79]},
        "3872": {"vr": "US", "Value": [97]},
        "3873": {"vr": "US", "Value": [91]},
        "3874": {"vr": "US", "Value": [43]},
        "3875": {"vr": "US", "Value": [106]},
        "3876": {"vr": "US", "Value": [110]},
        "3877": {"vr": "US", "Value": [42]},
        "3878": {"vr": "US", "Value": [1093]},
        "3879": {"vr": "US", "Value": [85]},
        "3880": {"vr": "US", "Value": [84]},
        "3881": {"vr": "US", "Value": [43]},
        "3882": {"vr": "US", "Value": [91]},
        "3883": {"vr": "US", "Value": [106]},
        "3884": {"vr": "US", "Value": [77]},
        "3885": {"vr": "US", "Value": [782]},
        "3886": {"vr": "US", "Value": [96]},
        "3887": {"vr": "US", "Value": [82]},
        "3888": {"vr": "US", "Value": [93]},
        "3889": {"vr": "US", "Value": [82]},
        "3890": {"vr": "US", "Value": [40]},
        "3891": {"vr": "US", "Value": [63]},
        "3892": {"vr": "US", "Value": [84]},
        "3893": {"vr": "US", "Value": [43]},
        "3894": {"vr": "US", "Value": [68]},
        "3895": {"vr": "US", "Value": [64]},
        "3896": {"vr": "US", "Value": [81]},
        "3897": {"vr": "US", "Value": [86]},
        "3898": {"vr": "US", "Value": [72]},
        "3899": {"vr": "US", "Value": [116]},
        "3900": {"vr": "US", "Value": [758]},
        "3901": {"vr": "US", "Value": [34]},
        "3902": {"vr": "US", "Value": [52]},
        "3903": {"vr": "US", "Value": [70]},
        "3904": {"vr": "US", "Value": [76]},
        "3905": {"vr": "US", "Value": [91]},
        "3906": {"vr": "US", "Value": [90]},
        "3907": {"vr": "US", "Value": [100]},
        "3908": {"vr": "US", "Value": [84]},
        "3909": {"vr": "US", "Value": [84]},
        "3910": {"vr": "US", "Value": [94]},
        "3911": {"vr": "US", "Value": [35]},
        "3912": {"vr": "US", "Value": [97]},
        "3913": {"vr": "US", "Value": [113]},
        "3914": {"vr": "US", "Value": [96]},
        "3915": {"vr": "US", "Value": [109]},
        "3916": {"vr": "US", "Value": [775]},
        "3917": {"vr": "US", "Value": [85]},
        "3918": {"vr": "US", "Value": [102]},
        "3919": {"vr": "US", "Value": [89]},
        "3920": {"vr": "US", "Value": [88]},
        "3921": {"vr": "US", "Value": [89]},
        "3922": {"vr": "US", "Value": [88]},
        "3923": {"vr": "US", "Value": [39]},
        "3924": {"vr": "US", "Value": [98]},
        "3925": {"vr": "US", "Value": [66]},
        "3926": {"vr": "US", "Value": [51]},
        "3927": {"vr": "US", "Value": [94]},
        "3928": {"vr": "US", "Value": [1133]},
        "3929": {"vr": "US", "Value": [91]},
        "3930": {"vr": "US", "Value": [63]},
        "3931": {"vr": "US", "Value": [77]},
        "3932": {"vr": "US", "Value": [89]},
        "3933": {"vr": "US", "Value": [80]},
        "3934": {"vr": "US", "Value": [108]},
        "3935": {"vr": "US", "Value": [87]},
        "3936": {"vr": "US", "Value": [85]},
        "3937": {"vr": "US", "Value": [1131]},
        "3938": {"vr": "US", "Value": [96]},
        "3939": {"vr": "US", "Value": [82]},
        "3940": {"vr": "US", "Value": [74]},
        "3941": {"vr": "US", "Value": [116]},
        "3942": {"vr": "US", "Value": [71]},
        "3943": {"vr": "US", "Value": [50]},
        "3944": {"vr": "US", "Value": [46]},
        "3945": {"vr": "US", "Value": [1753]},
        "3946": {"vr": "US", "Value": [89]},
        "3947": {"vr": "US", "Value": [77]},
        "3948": {"vr": "US", "Value": [118]},
        "3949": {"vr": "US", "Value": [111]},
        "3950": {"vr": "US", "Value": [88]},
        "3951": {"vr": "US", "Value": [74]},
        "3952": {"vr": "US", "Value": [70]},
        "3953": {"vr": "US", "Value": [88]},
        "3954": {"vr": "US", "Value": [77]},
        "3955": {"vr": "US", "Value": [90]},
        "3956": {"vr": "US", "Value": [89]},
        "3957": {"vr": "US", "Value": [108]},
        "3958": {"vr": "US", "Value": [93]},
        "3959": {"vr": "US", "Value": [42]},
        "3960": {"vr": "US", "Value": [49]},
        "3961": {"vr": "US", "Value": [45]},
        "3962": {"vr": "US", "Value": [96]},
        "3963": {"vr": "US", "Value": [71]},
        "3964": {"vr": "US", "Value": [95]},
        "3965": {"vr": "US", "Value": [84]},
        "3966": {"vr": "US", "Value": [46]},
        "3967": {"vr": "US", "Value": [62]},
        "3968": {"vr": "US", "Value": [773]},
        "3969": {"vr": "US", "Value": [40]},
        "3970": {"vr": "US", "Value": [86]},
        "3971": {"vr": "US", "Value": [30]},
        "3972": {"vr": "US", "Value": [84]},
        "3973": {"vr": "US", "Value": [41]},
        "3974": {"vr": "US", "Value": [95]},
        "3975": {"vr": "US", "Value": [71]},
        "3976": {"vr": "US", "Value": [96]},
        "3977": {"vr": "US", "Value": [46]},
        "3978": {"vr": "US", "Value": [55]},
        "3979": {"vr": "US", "Value": [86]},
        "3980": {"vr": "US", "Value": [19]},
        "3981": {"vr": "US", "Value": [79]},
        "3982": {"vr": "US", "Value": [80]},
        "3983": {"vr": "US", "Value": [79]},
        "3984": {"vr": "US", "Value": [106]},
        "3985": {"vr": "US", "Value": [98]},
        "3986": {"vr": "US", "Value": [87]},
        "3987": {"vr": "US", "Value": [91]},
        "3988": {"vr": "US", "Value": [79]},
        "3989": {"vr": "US", "Value": [69]},
        "3990": {"vr": "US", "Value": [79]},
        "3991": {"vr": "US", "Value": [56]},
        "3992": {"vr": "US", "Value": [85]},
        "3993": {"vr": "US", "Value": [39]},
        "3994": {"vr": "US", "Value": [75]},
        "3995": {"vr": "US", "Value": [118]},
        "3996": {"vr": "US", "Value": [104]},
        "3997": {"vr": "US", "Value": [62]},
        "3998": {"vr": "US", "Value": [101]},
        "3999": {"vr": "US", "Value": [84]},
        "4000": {"vr": "US", "Value": [55]},
        "4001": {"vr": "US", "Value": [68]},
        "4002": {"vr": "US", "Value": [68]},
        "4003": {"vr": "US", "Value": [23]},
        "4004": {"vr": "US", "Value": [114]},
        "4005": {"vr": "US", "Value": [89]},
        "4006": {"vr": "US", "Value": [88]},
        "4007": {"vr": "US", "Value": [95]},
        "4008": {"vr": "US", "Value": [83]},
        "4009": {"vr": "US", "Value": [1201]},
        "4010": {"vr": "US", "Value": [47]},
        "4011": {"vr": "US", "Value": [786]},
        "4012": {"vr": "US", "Value": [64]},
        "4013": {"vr": "US", "Value": [81]},
        "4014": {"vr": "US", "Value": [80]},
        "4015": {"vr": "US", "Value": [45]},
        "4016": {"vr": "US", "Value": [75]},
        "4017": {"vr": "US", "Value": [86]},
        "4018": {"vr": "US", "Value": [95]},
        "4019": {"vr": "US", "Value": [87]},
    },
    "00281050": {
        "0": {"vr": "DS", "Value": [56.0]},
        "1": {"vr": "DS", "Value": [24.0]},
        "2": {"vr": "DS", "Value": [46.0]},
        "3": {"vr": "DS", "Value": [322.0]},
        "4": {"vr": "DS", "Value": [50.0]},
        "5": {"vr": "DS", "Value": [53.0]},
        "6": {"vr": "DS", "Value": [42.0]},
        "7": {"vr": "DS", "Value": [53.0]},
        "8": {"vr": "DS", "Value": [51.0]},
        "9": {"vr": "DS", "Value": [53.0]},
        "10": {"vr": "DS", "Value": [60.0]},
        "11": {"vr": "DS", "Value": [46.0]},
        "12": {"vr": "DS", "Value": [49.0]},
        "13": {"vr": "DS", "Value": [308.0]},
        "14": {"vr": "DS", "Value": [288.0]},
        "15": {"vr": "DS", "Value": [29.0]},
        "16": {"vr": "DS", "Value": [57.0]},
        "17": {"vr": "DS", "Value": [53.0]},
        "18": {"vr": "DS", "Value": [60.0]},
        "19": {"vr": "DS", "Value": [53.0]},
        "20": {"vr": "DS", "Value": [41.0]},
        "21": {"vr": "DS", "Value": [42.0]},
        "22": {"vr": "DS", "Value": [24.0]},
        "23": {"vr": "DS", "Value": [56.0]},
        "24": {"vr": "DS", "Value": [54.0]},
        "25": {"vr": "DS", "Value": [59.0]},
        "26": {"vr": "DS", "Value": [41.0]},
        "27": {"vr": "DS", "Value": [41.0]},
        "28": {"vr": "DS", "Value": [49.0]},
        "29": {"vr": "DS", "Value": [54.0]},
        "30": {"vr": "DS", "Value": [54.0]},
        "31": {"vr": "DS", "Value": [274.0]},
        "32": {"vr": "DS", "Value": [56.0]},
        "33": {"vr": "DS", "Value": [57.0]},
        "34": {"vr": "DS", "Value": [314.0]},
        "35": {"vr": "DS", "Value": [236.0]},
        "36": {"vr": "DS", "Value": [55.0]},
        "37": {"vr": "DS", "Value": [39.0]},
        "38": {"vr": "DS", "Value": [40.0]},
        "39": {"vr": "DS", "Value": [54.0]},
        "40": {"vr": "DS", "Value": [299.0]},
        "41": {"vr": "DS", "Value": [48.0]},
        "42": {"vr": "DS", "Value": [54.0]},
        "43": {"vr": "DS", "Value": [50.0]},
        "44": {"vr": "DS", "Value": [40.0]},
        "45": {"vr": "DS", "Value": [24.0]},
        "46": {"vr": "DS", "Value": [31.0]},
        "47": {"vr": "DS", "Value": [55.0]},
        "48": {"vr": "DS", "Value": [34.0]},
        "49": {"vr": "DS", "Value": [23.0]},
        "50": {"vr": "DS", "Value": [58.0]},
        "51": {"vr": "DS", "Value": [53.0]},
        "52": {"vr": "DS", "Value": [47.0]},
        "53": {"vr": "DS", "Value": [32.0]},
        "54": {"vr": "DS", "Value": [52.0]},
        "55": {"vr": "DS", "Value": [58.0]},
        "56": {"vr": "DS", "Value": [48.0]},
        "57": {"vr": "DS", "Value": [60.0]},
        "58": {"vr": "DS", "Value": [46.0]},
        "59": {"vr": "DS", "Value": [37.0]},
        "60": {"vr": "DS", "Value": [319.0]},
        "61": {"vr": "DS", "Value": [280.0]},
        "62": {"vr": "DS", "Value": [10.0]},
        "63": {"vr": "DS", "Value": [42.0]},
        "64": {"vr": "DS", "Value": [41.0]},
        "65": {"vr": "DS", "Value": [41.0]},
        "66": {"vr": "DS", "Value": [52.0]},
        "67": {"vr": "DS", "Value": [51.0]},
        "68": {"vr": "DS", "Value": [339.0]},
        "69": {"vr": "DS", "Value": [51.0]},
        "70": {"vr": "DS", "Value": [49.0]},
        "71": {"vr": "DS", "Value": [25.0]},
        "72": {"vr": "DS", "Value": [56.0]},
        "73": {"vr": "DS", "Value": [42.0]},
        "74": {"vr": "DS", "Value": [53.0]},
        "75": {"vr": "DS", "Value": [33.0]},
        "76": {"vr": "DS", "Value": [51.0]},
        "77": {"vr": "DS", "Value": [31.0]},
        "78": {"vr": "DS", "Value": [48.0]},
        "79": {"vr": "DS", "Value": [52.0]},
        "80": {"vr": "DS", "Value": [272.0]},
        "81": {"vr": "DS", "Value": [55.0]},
        "82": {"vr": "DS", "Value": [27.0]},
        "83": {"vr": "DS", "Value": [57.0]},
        "84": {"vr": "DS", "Value": [26.0]},
        "85": {"vr": "DS", "Value": [53.0]},
        "86": {"vr": "DS", "Value": [57.0]},
        "87": {"vr": "DS", "Value": [25.0]},
        "88": {"vr": "DS", "Value": [51.0]},
        "89": {"vr": "DS", "Value": [49.0]},
        "90": {"vr": "DS", "Value": [276.0]},
        "91": {"vr": "DS", "Value": [263.0]},
        "92": {"vr": "DS", "Value": [49.0]},
        "93": {"vr": "DS", "Value": [46.0]},
        "94": {"vr": "DS", "Value": [37.0]},
        "95": {"vr": "DS", "Value": [54.0]},
        "96": {"vr": "DS", "Value": [33.0]},
        "97": {"vr": "DS", "Value": [49.0]},
        "98": {"vr": "DS", "Value": [27.0]},
        "99": {"vr": "DS", "Value": [34.0]},
        "100": {"vr": "DS", "Value": [43.0]},
        "101": {"vr": "DS", "Value": [50.0]},
        "102": {"vr": "DS", "Value": [52.0]},
        "103": {"vr": "DS", "Value": [42.0]},
        "104": {"vr": "DS", "Value": [59.0]},
        "105": {"vr": "DS", "Value": [50.0]},
        "106": {"vr": "DS", "Value": [54.0]},
        "107": {"vr": "DS", "Value": [61.0]},
        "108": {"vr": "DS", "Value": [23.0]},
        "109": {"vr": "DS", "Value": [54.0]},
        "110": {"vr": "DS", "Value": [54.0]},
        "111": {"vr": "DS", "Value": [47.0]},
        "112": {"vr": "DS", "Value": [300.0]},
        "113": {"vr": "DS", "Value": [53.0]},
        "114": {"vr": "DS", "Value": [264.0]},
        "115": {"vr": "DS", "Value": [53.0]},
        "116": {"vr": "DS", "Value": [56.0]},
        "117": {"vr": "DS", "Value": [11.0]},
        "118": {"vr": "DS", "Value": [29.0]},
        "119": {"vr": "DS", "Value": [28.0]},
        "120": {"vr": "DS", "Value": [24.0]},
        "121": {"vr": "DS", "Value": [48.0]},
        "122": {"vr": "DS", "Value": [45.0]},
        "123": {"vr": "DS", "Value": [55.0]},
        "124": {"vr": "DS", "Value": [52.0]},
        "125": {"vr": "DS", "Value": [49.0]},
        "126": {"vr": "DS", "Value": [40.0]},
        "127": {"vr": "DS", "Value": [49.0]},
        "128": {"vr": "DS", "Value": [301.0]},
        "129": {"vr": "DS", "Value": [52.0]},
        "130": {"vr": "DS", "Value": [12.0]},
        "131": {"vr": "DS", "Value": [55.0]},
        "132": {"vr": "DS", "Value": [52.0]},
        "133": {"vr": "DS", "Value": [57.0]},
        "134": {"vr": "DS", "Value": [55.0]},
        "135": {"vr": "DS", "Value": [54.0]},
        "136": {"vr": "DS", "Value": [55.0]},
        "137": {"vr": "DS", "Value": [48.0]},
        "138": {"vr": "DS", "Value": [55.0]},
        "139": {"vr": "DS", "Value": [53.0]},
        "140": {"vr": "DS", "Value": [37.0]},
        "141": {"vr": "DS", "Value": [54.0]},
        "142": {"vr": "DS", "Value": [26.0]},
        "143": {"vr": "DS", "Value": [23.0]},
        "144": {"vr": "DS", "Value": [49.0]},
        "145": {"vr": "DS", "Value": [52.0]},
        "146": {"vr": "DS", "Value": [53.0]},
        "147": {"vr": "DS", "Value": [40.0]},
        "148": {"vr": "DS", "Value": [44.0]},
        "149": {"vr": "DS", "Value": [54.0]},
        "150": {"vr": "DS", "Value": [55.0]},
        "151": {"vr": "DS", "Value": [47.0]},
        "152": {"vr": "DS", "Value": [29.0]},
        "153": {"vr": "DS", "Value": [57.0]},
        "154": {"vr": "DS", "Value": [49.0]},
        "155": {"vr": "DS", "Value": [48.0]},
        "156": {"vr": "DS", "Value": [54.0]},
        "157": {"vr": "DS", "Value": [43.0]},
        "158": {"vr": "DS", "Value": [27.0]},
        "159": {"vr": "DS", "Value": [50.0]},
        "160": {"vr": "DS", "Value": [249.0]},
        "161": {"vr": "DS", "Value": [25.0]},
        "162": {"vr": "DS", "Value": [22.0]},
        "163": {"vr": "DS", "Value": [47.0]},
        "164": {"vr": "DS", "Value": [50.0]},
        "165": {"vr": "DS", "Value": [44.0]},
        "166": {"vr": "DS", "Value": [38.0]},
        "167": {"vr": "DS", "Value": [50.0]},
        "168": {"vr": "DS", "Value": [54.0]},
        "169": {"vr": "DS", "Value": [25.0]},
        "170": {"vr": "DS", "Value": [54.0]},
        "171": {"vr": "DS", "Value": [39.0]},
        "172": {"vr": "DS", "Value": [53.0]},
        "173": {"vr": "DS", "Value": [51.0]},
        "174": {"vr": "DS", "Value": [52.0]},
        "175": {"vr": "DS", "Value": [54.0]},
        "176": {"vr": "DS", "Value": [53.0]},
        "177": {"vr": "DS", "Value": [36.0]},
        "178": {"vr": "DS", "Value": [53.0]},
        "179": {"vr": "DS", "Value": [51.0]},
        "180": {"vr": "DS", "Value": [54.0]},
        "181": {"vr": "DS", "Value": [23.0]},
        "182": {"vr": "DS", "Value": [53.0]},
        "183": {"vr": "DS", "Value": [53.0]},
        "184": {"vr": "DS", "Value": [50.0]},
        "185": {"vr": "DS", "Value": [44.0]},
        "186": {"vr": "DS", "Value": [46.0]},
        "187": {"vr": "DS", "Value": [55.0]},
        "188": {"vr": "DS", "Value": [31.0]},
        "189": {"vr": "DS", "Value": [9.0]},
        "190": {"vr": "DS", "Value": [52.0]},
        "191": {"vr": "DS", "Value": [76.0]},
        "192": {"vr": "DS", "Value": [35.0]},
        "193": {"vr": "DS", "Value": [31.0]},
        "194": {"vr": "DS", "Value": [50.0]},
        "195": {"vr": "DS", "Value": [46.0]},
        "196": {"vr": "DS", "Value": [36.0]},
        "197": {"vr": "DS", "Value": [54.0]},
        "198": {"vr": "DS", "Value": [255.0]},
        "199": {"vr": "DS", "Value": [45.0]},
        "200": {"vr": "DS", "Value": [62.0]},
        "201": {"vr": "DS", "Value": [52.0]},
        "202": {"vr": "DS", "Value": [56.0]},
        "203": {"vr": "DS", "Value": [39.0]},
        "204": {"vr": "DS", "Value": [49.0]},
        "205": {"vr": "DS", "Value": [54.0]},
        "206": {"vr": "DS", "Value": [51.0]},
        "207": {"vr": "DS", "Value": [42.0]},
        "208": {"vr": "DS", "Value": [23.0]},
        "209": {"vr": "DS", "Value": [52.0]},
        "210": {"vr": "DS", "Value": [271.0]},
        "211": {"vr": "DS", "Value": [55.0]},
        "212": {"vr": "DS", "Value": [42.0]},
        "213": {"vr": "DS", "Value": [40.0]},
        "214": {"vr": "DS", "Value": [55.0]},
        "215": {"vr": "DS", "Value": [37.0]},
        "216": {"vr": "DS", "Value": [51.0]},
        "217": {"vr": "DS", "Value": [23.0]},
        "218": {"vr": "DS", "Value": [55.0]},
        "219": {"vr": "DS", "Value": [25.0]},
        "220": {"vr": "DS", "Value": [59.0]},
        "221": {"vr": "DS", "Value": [49.0]},
        "222": {"vr": "DS", "Value": [48.0]},
        "223": {"vr": "DS", "Value": [24.0]},
        "224": {"vr": "DS", "Value": [50.0]},
        "225": {"vr": "DS", "Value": [54.0]},
        "226": {"vr": "DS", "Value": [49.0]},
        "227": {"vr": "DS", "Value": [240.0]},
        "228": {"vr": "DS", "Value": [60.0]},
        "229": {"vr": "DS", "Value": [52.0]},
        "230": {"vr": "DS", "Value": [25.0]},
        "231": {"vr": "DS", "Value": [57.0]},
        "232": {"vr": "DS", "Value": [42.0]},
        "233": {"vr": "DS", "Value": [57.0]},
        "234": {"vr": "DS", "Value": [10.0]},
        "235": {"vr": "DS", "Value": [52.0]},
        "236": {"vr": "DS", "Value": [51.0]},
        "237": {"vr": "DS", "Value": [29.0]},
        "238": {"vr": "DS", "Value": [38.0]},
        "239": {"vr": "DS", "Value": [56.0]},
        "240": {"vr": "DS", "Value": [49.0]},
        "241": {"vr": "DS", "Value": [37.0]},
        "242": {"vr": "DS", "Value": [56.0]},
        "243": {"vr": "DS", "Value": [300.0]},
        "244": {"vr": "DS", "Value": [52.0]},
        "245": {"vr": "DS", "Value": [38.0]},
        "246": {"vr": "DS", "Value": [315.0]},
        "247": {"vr": "DS", "Value": [55.0]},
        "248": {"vr": "DS", "Value": [36.0]},
        "249": {"vr": "DS", "Value": [48.0]},
        "250": {"vr": "DS", "Value": [26.0]},
        "251": {"vr": "DS", "Value": [54.0]},
        "252": {"vr": "DS", "Value": [55.0]},
        "253": {"vr": "DS", "Value": [42.0]},
        "254": {"vr": "DS", "Value": [46.0]},
        "255": {"vr": "DS", "Value": [25.0]},
        "256": {"vr": "DS", "Value": [286.0]},
        "257": {"vr": "DS", "Value": [38.0]},
        "258": {"vr": "DS", "Value": [49.0]},
        "259": {"vr": "DS", "Value": [54.0]},
        "260": {"vr": "DS", "Value": [47.0]},
        "261": {"vr": "DS", "Value": [50.0]},
        "262": {"vr": "DS", "Value": [49.0]},
        "263": {"vr": "DS", "Value": [52.0]},
        "264": {"vr": "DS", "Value": [48.0]},
        "265": {"vr": "DS", "Value": [52.0]},
        "266": {"vr": "DS", "Value": [32.0]},
        "267": {"vr": "DS", "Value": [32.0]},
        "268": {"vr": "DS", "Value": [24.0]},
        "269": {"vr": "DS", "Value": [53.0]},
        "270": {"vr": "DS", "Value": [295.0]},
        "271": {"vr": "DS", "Value": [38.0]},
        "272": {"vr": "DS", "Value": [24.0]},
        "273": {"vr": "DS", "Value": [42.0]},
        "274": {"vr": "DS", "Value": [46.0]},
        "275": {"vr": "DS", "Value": [280.0]},
        "276": {"vr": "DS", "Value": [42.0]},
        "277": {"vr": "DS", "Value": [56.0]},
        "278": {"vr": "DS", "Value": [49.0]},
        "279": {"vr": "DS", "Value": [52.0]},
        "280": {"vr": "DS", "Value": [46.0]},
        "281": {"vr": "DS", "Value": [38.0]},
        "282": {"vr": "DS", "Value": [50.0]},
        "283": {"vr": "DS", "Value": [23.0]},
        "284": {"vr": "DS", "Value": [43.0]},
        "285": {"vr": "DS", "Value": [51.0]},
        "286": {"vr": "DS", "Value": [29.0]},
        "287": {"vr": "DS", "Value": [47.0]},
        "288": {"vr": "DS", "Value": [51.0]},
        "289": {"vr": "DS", "Value": [23.0]},
        "290": {"vr": "DS", "Value": [235.0]},
        "291": {"vr": "DS", "Value": [53.0]},
        "292": {"vr": "DS", "Value": [54.0]},
        "293": {"vr": "DS", "Value": [51.0]},
        "294": {"vr": "DS", "Value": [25.0]},
        "295": {"vr": "DS", "Value": [39.0]},
        "296": {"vr": "DS", "Value": [37.0]},
        "297": {"vr": "DS", "Value": [45.0]},
        "298": {"vr": "DS", "Value": [42.0]},
        "299": {"vr": "DS", "Value": [56.0]},
        "300": {"vr": "DS", "Value": [56.0]},
        "301": {"vr": "DS", "Value": [303.0]},
        "302": {"vr": "DS", "Value": [46.0]},
        "303": {"vr": "DS", "Value": [35.0]},
        "304": {"vr": "DS", "Value": [46.0]},
        "305": {"vr": "DS", "Value": [52.0]},
        "306": {"vr": "DS", "Value": [44.0]},
        "307": {"vr": "DS", "Value": [52.0]},
        "308": {"vr": "DS", "Value": [55.0]},
        "309": {"vr": "DS", "Value": [49.0]},
        "310": {"vr": "DS", "Value": [42.0]},
        "311": {"vr": "DS", "Value": [261.0]},
        "312": {"vr": "DS", "Value": [54.0]},
        "313": {"vr": "DS", "Value": [220.0]},
        "314": {"vr": "DS", "Value": [54.0]},
        "315": {"vr": "DS", "Value": [51.0]},
        "316": {"vr": "DS", "Value": [281.0]},
        "317": {"vr": "DS", "Value": [39.0]},
        "318": {"vr": "DS", "Value": [24.0]},
        "319": {"vr": "DS", "Value": [11.0]},
        "320": {"vr": "DS", "Value": [46.0]},
        "321": {"vr": "DS", "Value": [44.0]},
        "322": {"vr": "DS", "Value": [48.0]},
        "323": {"vr": "DS", "Value": [59.0]},
        "324": {"vr": "DS", "Value": [52.0]},
        "325": {"vr": "DS", "Value": [46.0]},
        "326": {"vr": "DS", "Value": [27.0]},
        "327": {"vr": "DS", "Value": [47.0]},
        "328": {"vr": "DS", "Value": [61.0]},
        "329": {"vr": "DS", "Value": [59.0]},
        "330": {"vr": "DS", "Value": [51.0]},
        "331": {"vr": "DS", "Value": [48.0]},
        "332": {"vr": "DS", "Value": [56.0]},
        "333": {"vr": "DS", "Value": [52.0]},
        "334": {"vr": "DS", "Value": [53.0]},
        "335": {"vr": "DS", "Value": [55.0]},
        "336": {"vr": "DS", "Value": [42.0]},
        "337": {"vr": "DS", "Value": [50.0]},
        "338": {"vr": "DS", "Value": [50.0]},
        "339": {"vr": "DS", "Value": [54.0]},
        "340": {"vr": "DS", "Value": [53.0]},
        "341": {"vr": "DS", "Value": [52.0]},
        "342": {"vr": "DS", "Value": [29.0]},
        "343": {"vr": "DS", "Value": [58.0]},
        "344": {"vr": "DS", "Value": [50.0]},
        "345": {"vr": "DS", "Value": [49.0]},
        "346": {"vr": "DS", "Value": [53.0]},
        "347": {"vr": "DS", "Value": [51.0]},
        "348": {"vr": "DS", "Value": [56.0]},
        "349": {"vr": "DS", "Value": [294.0]},
        "350": {"vr": "DS", "Value": [280.0]},
        "351": {"vr": "DS", "Value": [53.0]},
        "352": {"vr": "DS", "Value": [24.0]},
        "353": {"vr": "DS", "Value": [48.0]},
        "354": {"vr": "DS", "Value": [49.0]},
        "355": {"vr": "DS", "Value": [52.0]},
        "356": {"vr": "DS", "Value": [56.0]},
        "357": {"vr": "DS", "Value": [57.0]},
        "358": {"vr": "DS", "Value": [37.0]},
        "359": {"vr": "DS", "Value": [48.0]},
        "360": {"vr": "DS", "Value": [45.0]},
        "361": {"vr": "DS", "Value": [154.0]},
        "362": {"vr": "DS", "Value": [43.0]},
        "363": {"vr": "DS", "Value": [77.0]},
        "364": {"vr": "DS", "Value": [51.0]},
        "365": {"vr": "DS", "Value": [47.0]},
        "366": {"vr": "DS", "Value": [56.0]},
        "367": {"vr": "DS", "Value": [50.0]},
        "368": {"vr": "DS", "Value": [276.0]},
        "369": {"vr": "DS", "Value": [59.0]},
        "370": {"vr": "DS", "Value": [26.0]},
        "371": {"vr": "DS", "Value": [56.0]},
        "372": {"vr": "DS", "Value": [45.0]},
        "373": {"vr": "DS", "Value": [57.0]},
        "374": {"vr": "DS", "Value": [50.0]},
        "375": {"vr": "DS", "Value": [56.0]},
        "376": {"vr": "DS", "Value": [38.0]},
        "377": {"vr": "DS", "Value": [52.0]},
        "378": {"vr": "DS", "Value": [51.0]},
        "379": {"vr": "DS", "Value": [46.0]},
        "380": {"vr": "DS", "Value": [24.0]},
        "381": {"vr": "DS", "Value": [27.0]},
        "382": {"vr": "DS", "Value": [54.0]},
        "383": {"vr": "DS", "Value": [260.0]},
        "384": {"vr": "DS", "Value": [264.0]},
        "385": {"vr": "DS", "Value": [26.0]},
        "386": {"vr": "DS", "Value": [42.0]},
        "387": {"vr": "DS", "Value": [52.0]},
        "388": {"vr": "DS", "Value": [55.0]},
        "389": {"vr": "DS", "Value": [52.0]},
        "390": {"vr": "DS", "Value": [26.0]},
        "391": {"vr": "DS", "Value": [38.0]},
        "392": {"vr": "DS", "Value": [49.0]},
        "393": {"vr": "DS", "Value": [26.0]},
        "394": {"vr": "DS", "Value": [49.0]},
        "395": {"vr": "DS", "Value": [59.0]},
        "396": {"vr": "DS", "Value": [281.0]},
        "397": {"vr": "DS", "Value": [44.0]},
        "398": {"vr": "DS", "Value": [37.0]},
        "399": {"vr": "DS", "Value": [286.0]},
        "400": {"vr": "DS", "Value": [47.0]},
        "401": {"vr": "DS", "Value": [57.0]},
        "402": {"vr": "DS", "Value": [52.0]},
        "403": {"vr": "DS", "Value": [48.0]},
        "404": {"vr": "DS", "Value": [47.0]},
        "405": {"vr": "DS", "Value": [53.0]},
        "406": {"vr": "DS", "Value": [52.0]},
        "407": {"vr": "DS", "Value": [53.0]},
        "408": {"vr": "DS", "Value": [55.0]},
        "409": {"vr": "DS", "Value": [39.0]},
        "410": {"vr": "DS", "Value": [51.0]},
        "411": {"vr": "DS", "Value": [44.0]},
        "412": {"vr": "DS", "Value": [47.0]},
        "413": {"vr": "DS", "Value": [49.0]},
        "414": {"vr": "DS", "Value": [48.0]},
        "415": {"vr": "DS", "Value": [43.0]},
        "416": {"vr": "DS", "Value": [36.0]},
        "417": {"vr": "DS", "Value": [37.0]},
        "418": {"vr": "DS", "Value": [267.0]},
        "419": {"vr": "DS", "Value": [50.0]},
        "420": {"vr": "DS", "Value": [55.0]},
        "421": {"vr": "DS", "Value": [49.0]},
        "422": {"vr": "DS", "Value": [33.0]},
        "423": {"vr": "DS", "Value": [44.0]},
        "424": {"vr": "DS", "Value": [285.0]},
        "425": {"vr": "DS", "Value": [44.0]},
        "426": {"vr": "DS", "Value": [53.0]},
        "427": {"vr": "DS", "Value": [52.0]},
        "428": {"vr": "DS", "Value": [51.0]},
        "429": {"vr": "DS", "Value": [43.0]},
        "430": {"vr": "DS", "Value": [44.0]},
        "431": {"vr": "DS", "Value": [61.0]},
        "432": {"vr": "DS", "Value": [27.0]},
        "433": {"vr": "DS", "Value": [53.0]},
        "434": {"vr": "DS", "Value": [48.0]},
        "435": {"vr": "DS", "Value": [39.0]},
        "436": {"vr": "DS", "Value": [55.0]},
        "437": {"vr": "DS", "Value": [37.0]},
        "438": {"vr": "DS", "Value": [24.0]},
        "439": {"vr": "DS", "Value": [42.0]},
        "440": {"vr": "DS", "Value": [51.0]},
        "441": {"vr": "DS", "Value": [56.0]},
        "442": {"vr": "DS", "Value": [56.0]},
        "443": {"vr": "DS", "Value": [20.0]},
        "444": {"vr": "DS", "Value": [52.0]},
        "445": {"vr": "DS", "Value": [265.0]},
        "446": {"vr": "DS", "Value": [54.0]},
        "447": {"vr": "DS", "Value": [53.0]},
        "448": {"vr": "DS", "Value": [302.0]},
        "449": {"vr": "DS", "Value": [51.0]},
        "450": {"vr": "DS", "Value": [51.0]},
        "451": {"vr": "DS", "Value": [49.0]},
        "452": {"vr": "DS", "Value": [49.0]},
        "453": {"vr": "DS", "Value": [56.0]},
        "454": {"vr": "DS", "Value": [29.0]},
        "455": {"vr": "DS", "Value": [51.0]},
        "456": {"vr": "DS", "Value": [55.0]},
        "457": {"vr": "DS", "Value": [57.0]},
        "458": {"vr": "DS", "Value": [42.0]},
        "459": {"vr": "DS", "Value": [44.0]},
        "460": {"vr": "DS", "Value": [26.0]},
        "461": {"vr": "DS", "Value": [53.0]},
        "462": {"vr": "DS", "Value": [52.0]},
        "463": {"vr": "DS", "Value": [52.0]},
        "464": {"vr": "DS", "Value": [44.0]},
        "465": {"vr": "DS", "Value": [47.0]},
        "466": {"vr": "DS", "Value": [26.0]},
        "467": {"vr": "DS", "Value": [28.0]},
        "468": {"vr": "DS", "Value": [56.0]},
        "469": {"vr": "DS", "Value": [277.0]},
        "470": {"vr": "DS", "Value": [38.0]},
        "471": {"vr": "DS", "Value": [36.0]},
        "472": {"vr": "DS", "Value": [43.0]},
        "473": {"vr": "DS", "Value": [48.0]},
        "474": {"vr": "DS", "Value": [38.0]},
        "475": {"vr": "DS", "Value": [311.0]},
        "476": {"vr": "DS", "Value": [37.0]},
        "477": {"vr": "DS", "Value": [53.0]},
        "478": {"vr": "DS", "Value": [45.0]},
        "479": {"vr": "DS", "Value": [50.0]},
        "480": {"vr": "DS", "Value": [49.0]},
        "481": {"vr": "DS", "Value": [50.0]},
        "482": {"vr": "DS", "Value": [43.0]},
        "483": {"vr": "DS", "Value": [304.0]},
        "484": {"vr": "DS", "Value": [47.0]},
        "485": {"vr": "DS", "Value": [45.0]},
        "486": {"vr": "DS", "Value": [54.0]},
        "487": {"vr": "DS", "Value": [55.0]},
        "488": {"vr": "DS", "Value": [55.0]},
        "489": {"vr": "DS", "Value": [30.0]},
        "490": {"vr": "DS", "Value": [50.0]},
        "491": {"vr": "DS", "Value": [58.0]},
        "492": {"vr": "DS", "Value": [52.0]},
        "493": {"vr": "DS", "Value": [32.0]},
        "494": {"vr": "DS", "Value": [56.0]},
        "495": {"vr": "DS", "Value": [41.0]},
        "496": {"vr": "DS", "Value": [47.0]},
        "497": {"vr": "DS", "Value": [301.0]},
        "498": {"vr": "DS", "Value": [54.0]},
        "499": {"vr": "DS", "Value": [56.0]},
        "500": {"vr": "DS", "Value": [26.0]},
        "501": {"vr": "DS", "Value": [312.0]},
        "502": {"vr": "DS", "Value": [49.0]},
        "503": {"vr": "DS", "Value": [41.0]},
        "504": {"vr": "DS", "Value": [54.0]},
        "505": {"vr": "DS", "Value": [45.0]},
        "506": {"vr": "DS", "Value": [9.0]},
        "507": {"vr": "DS", "Value": [288.0]},
        "508": {"vr": "DS", "Value": [42.0]},
        "509": {"vr": "DS", "Value": [42.0]},
        "510": {"vr": "DS", "Value": [49.0]},
        "511": {"vr": "DS", "Value": [42.0]},
        "512": {"vr": "DS", "Value": [29.0]},
        "513": {"vr": "DS", "Value": [49.0]},
        "514": {"vr": "DS", "Value": [317.0]},
        "515": {"vr": "DS", "Value": [271.0]},
        "516": {"vr": "DS", "Value": [53.0]},
        "517": {"vr": "DS", "Value": [54.0]},
        "518": {"vr": "DS", "Value": [42.0]},
        "519": {"vr": "DS", "Value": [40.0]},
        "520": {"vr": "DS", "Value": [314.0]},
        "521": {"vr": "DS", "Value": [51.0]},
        "522": {"vr": "DS", "Value": [53.0]},
        "523": {"vr": "DS", "Value": [55.0]},
        "524": {"vr": "DS", "Value": [49.0]},
        "525": {"vr": "DS", "Value": [39.0]},
        "526": {"vr": "DS", "Value": [29.0]},
        "527": {"vr": "DS", "Value": [54.0]},
        "528": {"vr": "DS", "Value": [44.0]},
        "529": {"vr": "DS", "Value": [11.0]},
        "530": {"vr": "DS", "Value": [37.0]},
        "531": {"vr": "DS", "Value": [317.0]},
        "532": {"vr": "DS", "Value": [57.0]},
        "533": {"vr": "DS", "Value": [53.0]},
        "534": {"vr": "DS", "Value": [55.0]},
        "535": {"vr": "DS", "Value": [50.0]},
        "536": {"vr": "DS", "Value": [43.0]},
        "537": {"vr": "DS", "Value": [26.0]},
        "538": {"vr": "DS", "Value": [27.0]},
        "539": {"vr": "DS", "Value": [282.0]},
        "540": {"vr": "DS", "Value": [42.0]},
        "541": {"vr": "DS", "Value": [44.0]},
        "542": {"vr": "DS", "Value": [298.0]},
        "543": {"vr": "DS", "Value": [25.0]},
        "544": {"vr": "DS", "Value": [259.0]},
        "545": {"vr": "DS", "Value": [48.0]},
        "546": {"vr": "DS", "Value": [20.0]},
        "547": {"vr": "DS", "Value": [53.0]},
        "548": {"vr": "DS", "Value": [299.0]},
        "549": {"vr": "DS", "Value": [51.0]},
        "550": {"vr": "DS", "Value": [48.0]},
        "551": {"vr": "DS", "Value": [50.0]},
        "552": {"vr": "DS", "Value": [45.0]},
        "553": {"vr": "DS", "Value": [296.0]},
        "554": {"vr": "DS", "Value": [324.0]},
        "555": {"vr": "DS", "Value": [283.0]},
        "556": {"vr": "DS", "Value": [48.0]},
        "557": {"vr": "DS", "Value": [44.0]},
        "558": {"vr": "DS", "Value": [49.0]},
        "559": {"vr": "DS", "Value": [56.0]},
        "560": {"vr": "DS", "Value": [54.0]},
        "561": {"vr": "DS", "Value": [55.0]},
        "562": {"vr": "DS", "Value": [25.0]},
        "563": {"vr": "DS", "Value": [50.0]},
        "564": {"vr": "DS", "Value": [49.0]},
        "565": {"vr": "DS", "Value": [55.0]},
        "566": {"vr": "DS", "Value": [26.0]},
        "567": {"vr": "DS", "Value": [295.0]},
        "568": {"vr": "DS", "Value": [53.0]},
        "569": {"vr": "DS", "Value": [51.0]},
        "570": {"vr": "DS", "Value": [36.0]},
        "571": {"vr": "DS", "Value": [52.0]},
        "572": {"vr": "DS", "Value": [29.0]},
        "573": {"vr": "DS", "Value": [53.0]},
        "574": {"vr": "DS", "Value": [47.0]},
        "575": {"vr": "DS", "Value": [46.0]},
        "576": {"vr": "DS", "Value": [9.0]},
        "577": {"vr": "DS", "Value": [35.0]},
        "578": {"vr": "DS", "Value": [52.0]},
        "579": {"vr": "DS", "Value": [42.0]},
        "580": {"vr": "DS", "Value": [12.0]},
        "581": {"vr": "DS", "Value": [53.0]},
        "582": {"vr": "DS", "Value": [54.0]},
        "583": {"vr": "DS", "Value": [49.0]},
        "584": {"vr": "DS", "Value": [43.0]},
        "585": {"vr": "DS", "Value": [266.0]},
        "586": {"vr": "DS", "Value": [50.0]},
        "587": {"vr": "DS", "Value": [231.0]},
        "588": {"vr": "DS", "Value": [25.0]},
        "589": {"vr": "DS", "Value": [55.0]},
        "590": {"vr": "DS", "Value": [55.0]},
        "591": {"vr": "DS", "Value": [35.0]},
        "592": {"vr": "DS", "Value": [53.0]},
        "593": {"vr": "DS", "Value": [31.0]},
        "594": {"vr": "DS", "Value": [58.0]},
        "595": {"vr": "DS", "Value": [51.0]},
        "596": {"vr": "DS", "Value": [54.0]},
        "597": {"vr": "DS", "Value": [53.0]},
        "598": {"vr": "DS", "Value": [35.0]},
        "599": {"vr": "DS", "Value": [53.0]},
        "600": {"vr": "DS", "Value": [279.0]},
        "601": {"vr": "DS", "Value": [40.0]},
        "602": {"vr": "DS", "Value": [49.0]},
        "603": {"vr": "DS", "Value": [54.0]},
        "604": {"vr": "DS", "Value": [35.0]},
        "605": {"vr": "DS", "Value": [36.0]},
        "606": {"vr": "DS", "Value": [43.0]},
        "607": {"vr": "DS", "Value": [24.0]},
        "608": {"vr": "DS", "Value": [54.0]},
        "609": {"vr": "DS", "Value": [53.0]},
        "610": {"vr": "DS", "Value": [40.0]},
        "611": {"vr": "DS", "Value": [264.0]},
        "612": {"vr": "DS", "Value": [38.0]},
        "613": {"vr": "DS", "Value": [53.0]},
        "614": {"vr": "DS", "Value": [57.0]},
        "615": {"vr": "DS", "Value": [23.0]},
        "616": {"vr": "DS", "Value": [36.0]},
        "617": {"vr": "DS", "Value": [61.0]},
        "618": {"vr": "DS", "Value": [25.0]},
        "619": {"vr": "DS", "Value": [45.0]},
        "620": {"vr": "DS", "Value": [47.0]},
        "621": {"vr": "DS", "Value": [27.0]},
        "622": {"vr": "DS", "Value": [40.0]},
        "623": {"vr": "DS", "Value": [23.0]},
        "624": {"vr": "DS", "Value": [263.0]},
        "625": {"vr": "DS", "Value": [57.0]},
        "626": {"vr": "DS", "Value": [38.0]},
        "627": {"vr": "DS", "Value": [55.0]},
        "628": {"vr": "DS", "Value": [44.0]},
        "629": {"vr": "DS", "Value": [54.0]},
        "630": {"vr": "DS", "Value": [51.0]},
        "631": {"vr": "DS", "Value": [38.0]},
        "632": {"vr": "DS", "Value": [33.0]},
        "633": {"vr": "DS", "Value": [53.0]},
        "634": {"vr": "DS", "Value": [43.0]},
        "635": {"vr": "DS", "Value": [27.0]},
        "636": {"vr": "DS", "Value": [58.0]},
        "637": {"vr": "DS", "Value": [51.0]},
        "638": {"vr": "DS", "Value": [48.0]},
        "639": {"vr": "DS", "Value": [54.0]},
        "640": {"vr": "DS", "Value": [44.0]},
        "641": {"vr": "DS", "Value": [54.0]},
        "642": {"vr": "DS", "Value": [59.0]},
        "643": {"vr": "DS", "Value": [40.0]},
        "644": {"vr": "DS", "Value": [39.0]},
        "645": {"vr": "DS", "Value": [53.0]},
        "646": {"vr": "DS", "Value": [24.0]},
        "647": {"vr": "DS", "Value": [55.0]},
        "648": {"vr": "DS", "Value": [34.0]},
        "649": {"vr": "DS", "Value": [25.0]},
        "650": {"vr": "DS", "Value": [31.0]},
        "651": {"vr": "DS", "Value": [39.0]},
        "652": {"vr": "DS", "Value": [53.0]},
        "653": {"vr": "DS", "Value": [42.0]},
        "654": {"vr": "DS", "Value": [55.0]},
        "655": {"vr": "DS", "Value": [54.0]},
        "656": {"vr": "DS", "Value": [50.0]},
        "657": {"vr": "DS", "Value": [54.0]},
        "658": {"vr": "DS", "Value": [55.0]},
        "659": {"vr": "DS", "Value": [54.0]},
        "660": {"vr": "DS", "Value": [50.0]},
        "661": {"vr": "DS", "Value": [46.0]},
        "662": {"vr": "DS", "Value": [54.0]},
        "663": {"vr": "DS", "Value": [56.0]},
        "664": {"vr": "DS", "Value": [49.0]},
        "665": {"vr": "DS", "Value": [56.0]},
        "666": {"vr": "DS", "Value": [47.0]},
        "667": {"vr": "DS", "Value": [41.0]},
        "668": {"vr": "DS", "Value": [295.0]},
        "669": {"vr": "DS", "Value": [52.0]},
        "670": {"vr": "DS", "Value": [56.0]},
        "671": {"vr": "DS", "Value": [25.0]},
        "672": {"vr": "DS", "Value": [39.0]},
        "673": {"vr": "DS", "Value": [42.0]},
        "674": {"vr": "DS", "Value": [48.0]},
        "675": {"vr": "DS", "Value": [38.0]},
        "676": {"vr": "DS", "Value": [52.0]},
        "677": {"vr": "DS", "Value": [51.0]},
        "678": {"vr": "DS", "Value": [47.0]},
        "679": {"vr": "DS", "Value": [257.0]},
        "680": {"vr": "DS", "Value": [38.0]},
        "681": {"vr": "DS", "Value": [37.0]},
        "682": {"vr": "DS", "Value": [55.0]},
        "683": {"vr": "DS", "Value": [23.0]},
        "684": {"vr": "DS", "Value": [26.0]},
        "685": {"vr": "DS", "Value": [40.0]},
        "686": {"vr": "DS", "Value": [54.0]},
        "687": {"vr": "DS", "Value": [268.0]},
        "688": {"vr": "DS", "Value": [52.0]},
        "689": {"vr": "DS", "Value": [54.0]},
        "690": {"vr": "DS", "Value": [268.0]},
        "691": {"vr": "DS", "Value": [48.0]},
        "692": {"vr": "DS", "Value": [42.0]},
        "693": {"vr": "DS", "Value": [48.0]},
        "694": {"vr": "DS", "Value": [50.0]},
        "695": {"vr": "DS", "Value": [45.0]},
        "696": {"vr": "DS", "Value": [54.0]},
        "697": {"vr": "DS", "Value": [36.0]},
        "698": {"vr": "DS", "Value": [43.0]},
        "699": {"vr": "DS", "Value": [337.0]},
        "700": {"vr": "DS", "Value": [24.0]},
        "701": {"vr": "DS", "Value": [56.0]},
        "702": {"vr": "DS", "Value": [56.0]},
        "703": {"vr": "DS", "Value": [55.0]},
        "704": {"vr": "DS", "Value": [25.0]},
        "705": {"vr": "DS", "Value": [54.0]},
        "706": {"vr": "DS", "Value": [43.0]},
        "707": {"vr": "DS", "Value": [269.0]},
        "708": {"vr": "DS", "Value": [41.0]},
        "709": {"vr": "DS", "Value": [38.0]},
        "710": {"vr": "DS", "Value": [57.0]},
        "711": {"vr": "DS", "Value": [55.0]},
        "712": {"vr": "DS", "Value": [35.0]},
        "713": {"vr": "DS", "Value": [51.0]},
        "714": {"vr": "DS", "Value": [286.0]},
        "715": {"vr": "DS", "Value": [266.0]},
        "716": {"vr": "DS", "Value": [52.0]},
        "717": {"vr": "DS", "Value": [28.0]},
        "718": {"vr": "DS", "Value": [47.0]},
        "719": {"vr": "DS", "Value": [54.0]},
        "720": {"vr": "DS", "Value": [47.0]},
        "721": {"vr": "DS", "Value": [29.0]},
        "722": {"vr": "DS", "Value": [37.0]},
        "723": {"vr": "DS", "Value": [24.0]},
        "724": {"vr": "DS", "Value": [53.0]},
        "725": {"vr": "DS", "Value": [51.0]},
        "726": {"vr": "DS", "Value": [60.0]},
        "727": {"vr": "DS", "Value": [54.0]},
        "728": {"vr": "DS", "Value": [57.0]},
        "729": {"vr": "DS", "Value": [47.0]},
        "730": {"vr": "DS", "Value": [50.0]},
        "731": {"vr": "DS", "Value": [52.0]},
        "732": {"vr": "DS", "Value": [281.0]},
        "733": {"vr": "DS", "Value": [24.0]},
        "734": {"vr": "DS", "Value": [45.0]},
        "735": {"vr": "DS", "Value": [48.0]},
        "736": {"vr": "DS", "Value": [55.0]},
        "737": {"vr": "DS", "Value": [47.0]},
        "738": {"vr": "DS", "Value": [57.0]},
        "739": {"vr": "DS", "Value": [38.0]},
        "740": {"vr": "DS", "Value": [57.0]},
        "741": {"vr": "DS", "Value": [49.0]},
        "742": {"vr": "DS", "Value": [56.0]},
        "743": {"vr": "DS", "Value": [52.0]},
        "744": {"vr": "DS", "Value": [52.0]},
        "745": {"vr": "DS", "Value": [50.0]},
        "746": {"vr": "DS", "Value": [47.0]},
        "747": {"vr": "DS", "Value": [40.0]},
        "748": {"vr": "DS", "Value": [48.0]},
        "749": {"vr": "DS", "Value": [48.0]},
        "750": {"vr": "DS", "Value": [49.0]},
        "751": {"vr": "DS", "Value": [51.0]},
        "752": {"vr": "DS", "Value": [28.0]},
        "753": {"vr": "DS", "Value": [57.0]},
        "754": {"vr": "DS", "Value": [39.0]},
        "755": {"vr": "DS", "Value": [45.0]},
        "756": {"vr": "DS", "Value": [33.0]},
        "757": {"vr": "DS", "Value": [236.0]},
        "758": {"vr": "DS", "Value": [50.0]},
        "759": {"vr": "DS", "Value": [53.0]},
        "760": {"vr": "DS", "Value": [50.0]},
        "761": {"vr": "DS", "Value": [25.0]},
        "762": {"vr": "DS", "Value": [58.0]},
        "763": {"vr": "DS", "Value": [47.0]},
        "764": {"vr": "DS", "Value": [46.0]},
        "765": {"vr": "DS", "Value": [57.0]},
        "766": {"vr": "DS", "Value": [33.0]},
        "767": {"vr": "DS", "Value": [54.0]},
        "768": {"vr": "DS", "Value": [40.0]},
        "769": {"vr": "DS", "Value": [24.0]},
        "770": {"vr": "DS", "Value": [53.0]},
        "771": {"vr": "DS", "Value": [277.0]},
        "772": {"vr": "DS", "Value": [50.0]},
        "773": {"vr": "DS", "Value": [55.0]},
        "774": {"vr": "DS", "Value": [55.0]},
        "775": {"vr": "DS", "Value": [36.0]},
        "776": {"vr": "DS", "Value": [42.0]},
        "777": {"vr": "DS", "Value": [312.0]},
        "778": {"vr": "DS", "Value": [11.0]},
        "779": {"vr": "DS", "Value": [59.0]},
        "780": {"vr": "DS", "Value": [33.0]},
        "781": {"vr": "DS", "Value": [48.0]},
        "782": {"vr": "DS", "Value": [45.0]},
        "783": {"vr": "DS", "Value": [46.0]},
        "784": {"vr": "DS", "Value": [56.0]},
        "785": {"vr": "DS", "Value": [55.0]},
        "786": {"vr": "DS", "Value": [47.0]},
        "787": {"vr": "DS", "Value": [9.0]},
        "788": {"vr": "DS", "Value": [296.0]},
        "789": {"vr": "DS", "Value": [38.0]},
        "790": {"vr": "DS", "Value": [24.0]},
        "791": {"vr": "DS", "Value": [269.0]},
        "792": {"vr": "DS", "Value": [52.0]},
        "793": {"vr": "DS", "Value": [50.0]},
        "794": {"vr": "DS", "Value": [56.0]},
        "795": {"vr": "DS", "Value": [53.0]},
        "796": {"vr": "DS", "Value": [57.0]},
        "797": {"vr": "DS", "Value": [56.0]},
        "798": {"vr": "DS", "Value": [54.0]},
        "799": {"vr": "DS", "Value": [36.0]},
        "800": {"vr": "DS", "Value": [42.0]},
        "801": {"vr": "DS", "Value": [40.0]},
        "802": {"vr": "DS", "Value": [40.0]},
        "803": {"vr": "DS", "Value": [55.0]},
        "804": {"vr": "DS", "Value": [50.0]},
        "805": {"vr": "DS", "Value": [53.0]},
        "806": {"vr": "DS", "Value": [9.0]},
        "807": {"vr": "DS", "Value": [54.0]},
        "808": {"vr": "DS", "Value": [50.0]},
        "809": {"vr": "DS", "Value": [54.0]},
        "810": {"vr": "DS", "Value": [250.0]},
        "811": {"vr": "DS", "Value": [51.0]},
        "812": {"vr": "DS", "Value": [10.0]},
        "813": {"vr": "DS", "Value": [40.0]},
        "814": {"vr": "DS", "Value": [53.0]},
        "815": {"vr": "DS", "Value": [55.0]},
        "816": {"vr": "DS", "Value": [264.0]},
        "817": {"vr": "DS", "Value": [55.0]},
        "818": {"vr": "DS", "Value": [47.0]},
        "819": {"vr": "DS", "Value": [24.0]},
        "820": {"vr": "DS", "Value": [263.0]},
        "821": {"vr": "DS", "Value": [34.0]},
        "822": {"vr": "DS", "Value": [49.0]},
        "823": {"vr": "DS", "Value": [33.0]},
        "824": {"vr": "DS", "Value": [56.0]},
        "825": {"vr": "DS", "Value": [49.0]},
        "826": {"vr": "DS", "Value": [28.0]},
        "827": {"vr": "DS", "Value": [284.0]},
        "828": {"vr": "DS", "Value": [50.0]},
        "829": {"vr": "DS", "Value": [276.0]},
        "830": {"vr": "DS", "Value": [25.0]},
        "831": {"vr": "DS", "Value": [52.0]},
        "832": {"vr": "DS", "Value": [53.0]},
        "833": {"vr": "DS", "Value": [34.0]},
        "834": {"vr": "DS", "Value": [37.0]},
        "835": {"vr": "DS", "Value": [56.0]},
        "836": {"vr": "DS", "Value": [43.0]},
        "837": {"vr": "DS", "Value": [52.0]},
        "838": {"vr": "DS", "Value": [55.0]},
        "839": {"vr": "DS", "Value": [54.0]},
        "840": {"vr": "DS", "Value": [42.0]},
        "841": {"vr": "DS", "Value": [41.0]},
        "842": {"vr": "DS", "Value": [52.0]},
        "843": {"vr": "DS", "Value": [62.0]},
        "844": {"vr": "DS", "Value": [54.0]},
        "845": {"vr": "DS", "Value": [32.0]},
        "846": {"vr": "DS", "Value": [248.0]},
        "847": {"vr": "DS", "Value": [48.0]},
        "848": {"vr": "DS", "Value": [26.0]},
        "849": {"vr": "DS", "Value": [54.0]},
        "850": {"vr": "DS", "Value": [262.0]},
        "851": {"vr": "DS", "Value": [45.0]},
        "852": {"vr": "DS", "Value": [46.0]},
        "853": {"vr": "DS", "Value": [49.0]},
        "854": {"vr": "DS", "Value": [54.0]},
        "855": {"vr": "DS", "Value": [53.0]},
        "856": {"vr": "DS", "Value": [47.0]},
        "857": {"vr": "DS", "Value": [48.0]},
        "858": {"vr": "DS", "Value": [36.0]},
        "859": {"vr": "DS", "Value": [41.0]},
        "860": {"vr": "DS", "Value": [31.0]},
        "861": {"vr": "DS", "Value": [248.0]},
        "862": {"vr": "DS", "Value": [52.0]},
        "863": {"vr": "DS", "Value": [55.0]},
        "864": {"vr": "DS", "Value": [34.0]},
        "865": {"vr": "DS", "Value": [29.0]},
        "866": {"vr": "DS", "Value": [49.0]},
        "867": {"vr": "DS", "Value": [281.0]},
        "868": {"vr": "DS", "Value": [269.0]},
        "869": {"vr": "DS", "Value": [33.0]},
        "870": {"vr": "DS", "Value": [60.0]},
        "871": {"vr": "DS", "Value": [42.0]},
        "872": {"vr": "DS", "Value": [51.0]},
        "873": {"vr": "DS", "Value": [51.0]},
        "874": {"vr": "DS", "Value": [51.0]},
        "875": {"vr": "DS", "Value": [313.0]},
        "876": {"vr": "DS", "Value": [40.0]},
        "877": {"vr": "DS", "Value": [54.0]},
        "878": {"vr": "DS", "Value": [53.0]},
        "879": {"vr": "DS", "Value": [51.0]},
        "880": {"vr": "DS", "Value": [54.0]},
        "881": {"vr": "DS", "Value": [54.0]},
        "882": {"vr": "DS", "Value": [51.0]},
        "883": {"vr": "DS", "Value": [40.0]},
        "884": {"vr": "DS", "Value": [52.0]},
        "885": {"vr": "DS", "Value": [320.0]},
        "886": {"vr": "DS", "Value": [51.0]},
        "887": {"vr": "DS", "Value": [53.0]},
        "888": {"vr": "DS", "Value": [44.0]},
        "889": {"vr": "DS", "Value": [50.0]},
        "890": {"vr": "DS", "Value": [48.0]},
        "891": {"vr": "DS", "Value": [24.0]},
        "892": {"vr": "DS", "Value": [48.0]},
        "893": {"vr": "DS", "Value": [52.0]},
        "894": {"vr": "DS", "Value": [54.0]},
        "895": {"vr": "DS", "Value": [43.0]},
        "896": {"vr": "DS", "Value": [25.0]},
        "897": {"vr": "DS", "Value": [48.0]},
        "898": {"vr": "DS", "Value": [53.0]},
        "899": {"vr": "DS", "Value": [54.0]},
        "900": {"vr": "DS", "Value": [52.0]},
        "901": {"vr": "DS", "Value": [57.0]},
        "902": {"vr": "DS", "Value": [50.0]},
        "903": {"vr": "DS", "Value": [56.0]},
        "904": {"vr": "DS", "Value": [54.0]},
        "905": {"vr": "DS", "Value": [51.0]},
        "906": {"vr": "DS", "Value": [48.0]},
        "907": {"vr": "DS", "Value": [54.0]},
        "908": {"vr": "DS", "Value": [51.0]},
        "909": {"vr": "DS", "Value": [53.0]},
        "910": {"vr": "DS", "Value": [24.0]},
        "911": {"vr": "DS", "Value": [54.0]},
        "912": {"vr": "DS", "Value": [43.0]},
        "913": {"vr": "DS", "Value": [23.0]},
        "914": {"vr": "DS", "Value": [55.0]},
        "915": {"vr": "DS", "Value": [46.0]},
        "916": {"vr": "DS", "Value": [12.0]},
        "917": {"vr": "DS", "Value": [39.0]},
        "918": {"vr": "DS", "Value": [56.0]},
        "919": {"vr": "DS", "Value": [264.0]},
        "920": {"vr": "DS", "Value": [26.0]},
        "921": {"vr": "DS", "Value": [54.0]},
        "922": {"vr": "DS", "Value": [58.0]},
        "923": {"vr": "DS", "Value": [25.0]},
        "924": {"vr": "DS", "Value": [229.0]},
        "925": {"vr": "DS", "Value": [53.0]},
        "926": {"vr": "DS", "Value": [278.0]},
        "927": {"vr": "DS", "Value": [25.0]},
        "928": {"vr": "DS", "Value": [39.0]},
        "929": {"vr": "DS", "Value": [40.0]},
        "930": {"vr": "DS", "Value": [53.0]},
        "931": {"vr": "DS", "Value": [29.0]},
        "932": {"vr": "DS", "Value": [309.0]},
        "933": {"vr": "DS", "Value": [54.0]},
        "934": {"vr": "DS", "Value": [58.0]},
        "935": {"vr": "DS", "Value": [45.0]},
        "936": {"vr": "DS", "Value": [273.0]},
        "937": {"vr": "DS", "Value": [54.0]},
        "938": {"vr": "DS", "Value": [25.0]},
        "939": {"vr": "DS", "Value": [50.0]},
        "940": {"vr": "DS", "Value": [55.0]},
        "941": {"vr": "DS", "Value": [25.0]},
        "942": {"vr": "DS", "Value": [52.0]},
        "943": {"vr": "DS", "Value": [53.0]},
        "944": {"vr": "DS", "Value": [50.0]},
        "945": {"vr": "DS", "Value": [58.0]},
        "946": {"vr": "DS", "Value": [57.0]},
        "947": {"vr": "DS", "Value": [49.0]},
        "948": {"vr": "DS", "Value": [290.0]},
        "949": {"vr": "DS", "Value": [47.0]},
        "950": {"vr": "DS", "Value": [58.0]},
        "951": {"vr": "DS", "Value": [50.0]},
        "952": {"vr": "DS", "Value": [48.0]},
        "953": {"vr": "DS", "Value": [51.0]},
        "954": {"vr": "DS", "Value": [25.0]},
        "955": {"vr": "DS", "Value": [53.0]},
        "956": {"vr": "DS", "Value": [280.0]},
        "957": {"vr": "DS", "Value": [53.0]},
        "958": {"vr": "DS", "Value": [42.0]},
        "959": {"vr": "DS", "Value": [39.0]},
        "960": {"vr": "DS", "Value": [31.0]},
        "961": {"vr": "DS", "Value": [286.0]},
        "962": {"vr": "DS", "Value": [48.0]},
        "963": {"vr": "DS", "Value": [54.0]},
        "964": {"vr": "DS", "Value": [52.0]},
        "965": {"vr": "DS", "Value": [55.0]},
        "966": {"vr": "DS", "Value": [23.0]},
        "967": {"vr": "DS", "Value": [39.0]},
        "968": {"vr": "DS", "Value": [52.0]},
        "969": {"vr": "DS", "Value": [28.0]},
        "970": {"vr": "DS", "Value": [55.0]},
        "971": {"vr": "DS", "Value": [53.0]},
        "972": {"vr": "DS", "Value": [48.0]},
        "973": {"vr": "DS", "Value": [25.0]},
        "974": {"vr": "DS", "Value": [30.0]},
        "975": {"vr": "DS", "Value": [49.0]},
        "976": {"vr": "DS", "Value": [55.0]},
        "977": {"vr": "DS", "Value": [52.0]},
        "978": {"vr": "DS", "Value": [280.0]},
        "979": {"vr": "DS", "Value": [50.0]},
        "980": {"vr": "DS", "Value": [40.0]},
        "981": {"vr": "DS", "Value": [28.0]},
        "982": {"vr": "DS", "Value": [52.0]},
        "983": {"vr": "DS", "Value": [264.0]},
        "984": {"vr": "DS", "Value": [43.0]},
        "985": {"vr": "DS", "Value": [52.0]},
        "986": {"vr": "DS", "Value": [44.0]},
        "987": {"vr": "DS", "Value": [56.0]},
        "988": {"vr": "DS", "Value": [26.0]},
        "989": {"vr": "DS", "Value": [37.0]},
        "990": {"vr": "DS", "Value": [28.0]},
        "991": {"vr": "DS", "Value": [55.0]},
        "992": {"vr": "DS", "Value": [53.0]},
        "993": {"vr": "DS", "Value": [54.0]},
        "994": {"vr": "DS", "Value": [49.0]},
        "995": {"vr": "DS", "Value": [65.0]},
        "996": {"vr": "DS", "Value": [243.0]},
        "997": {"vr": "DS", "Value": [27.0]},
        "998": {"vr": "DS", "Value": [39.0]},
        "999": {"vr": "DS", "Value": [51.0]},
        "1000": {"vr": "DS", "Value": [45.0]},
        "1001": {"vr": "DS", "Value": [56.0]},
        "1002": {"vr": "DS", "Value": [53.0]},
        "1003": {"vr": "DS", "Value": [54.0]},
        "1004": {"vr": "DS", "Value": [32.0]},
        "1005": {"vr": "DS", "Value": [43.0]},
        "1006": {"vr": "DS", "Value": [45.0]},
        "1007": {"vr": "DS", "Value": [51.0]},
        "1008": {"vr": "DS", "Value": [46.0]},
        "1009": {"vr": "DS", "Value": [34.0]},
        "1010": {"vr": "DS", "Value": [47.0]},
        "1011": {"vr": "DS", "Value": [38.0]},
        "1012": {"vr": "DS", "Value": [56.0]},
        "1013": {"vr": "DS", "Value": [49.0]},
        "1014": {"vr": "DS", "Value": [56.0]},
        "1015": {"vr": "DS", "Value": [287.0]},
        "1016": {"vr": "DS", "Value": [270.0]},
        "1017": {"vr": "DS", "Value": [43.0]},
        "1018": {"vr": "DS", "Value": [24.0]},
        "1019": {"vr": "DS", "Value": [52.0]},
        "1020": {"vr": "DS", "Value": [55.0]},
        "1021": {"vr": "DS", "Value": [52.0]},
        "1022": {"vr": "DS", "Value": [45.0]},
        "1023": {"vr": "DS", "Value": [43.0]},
        "1024": {"vr": "DS", "Value": [45.0]},
        "1025": {"vr": "DS", "Value": [61.0]},
        "1026": {"vr": "DS", "Value": [48.0]},
        "1027": {"vr": "DS", "Value": [21.0]},
        "1028": {"vr": "DS", "Value": [50.0]},
        "1029": {"vr": "DS", "Value": [26.0]},
        "1030": {"vr": "DS", "Value": [294.0]},
        "1031": {"vr": "DS", "Value": [56.0]},
        "1032": {"vr": "DS", "Value": [257.0]},
        "1033": {"vr": "DS", "Value": [48.0]},
        "1034": {"vr": "DS", "Value": [54.0]},
        "1035": {"vr": "DS", "Value": [53.0]},
        "1036": {"vr": "DS", "Value": [10.0]},
        "1037": {"vr": "DS", "Value": [49.0]},
        "1038": {"vr": "DS", "Value": [23.0]},
        "1039": {"vr": "DS", "Value": [250.0]},
        "1040": {"vr": "DS", "Value": [50.0]},
        "1041": {"vr": "DS", "Value": [55.0]},
        "1042": {"vr": "DS", "Value": [35.0]},
        "1043": {"vr": "DS", "Value": [49.0]},
        "1044": {"vr": "DS", "Value": [20.0]},
        "1045": {"vr": "DS", "Value": [53.0]},
        "1046": {"vr": "DS", "Value": [25.0]},
        "1047": {"vr": "DS", "Value": [51.0]},
        "1048": {"vr": "DS", "Value": [21.0]},
        "1049": {"vr": "DS", "Value": [58.0]},
        "1050": {"vr": "DS", "Value": [11.0]},
        "1051": {"vr": "DS", "Value": [29.0]},
        "1052": {"vr": "DS", "Value": [53.0]},
        "1053": {"vr": "DS", "Value": [35.0]},
        "1054": {"vr": "DS", "Value": [54.0]},
        "1055": {"vr": "DS", "Value": [49.0]},
        "1056": {"vr": "DS", "Value": [49.0]},
        "1057": {"vr": "DS", "Value": [36.0]},
        "1058": {"vr": "DS", "Value": [20.0]},
        "1059": {"vr": "DS", "Value": [51.0]},
        "1060": {"vr": "DS", "Value": [269.0]},
        "1061": {"vr": "DS", "Value": [43.0]},
        "1062": {"vr": "DS", "Value": [45.0]},
        "1063": {"vr": "DS", "Value": [37.0]},
        "1064": {"vr": "DS", "Value": [54.0]},
        "1065": {"vr": "DS", "Value": [260.0]},
        "1066": {"vr": "DS", "Value": [51.0]},
        "1067": {"vr": "DS", "Value": [50.0]},
        "1068": {"vr": "DS", "Value": [47.0]},
        "1069": {"vr": "DS", "Value": [51.0]},
        "1070": {"vr": "DS", "Value": [41.0]},
        "1071": {"vr": "DS", "Value": [48.0]},
        "1072": {"vr": "DS", "Value": [51.0]},
        "1073": {"vr": "DS", "Value": [133.0]},
        "1074": {"vr": "DS", "Value": [51.0]},
        "1075": {"vr": "DS", "Value": [45.0]},
        "1076": {"vr": "DS", "Value": [45.0]},
        "1077": {"vr": "DS", "Value": [37.0]},
        "1078": {"vr": "DS", "Value": [26.0]},
        "1079": {"vr": "DS", "Value": [25.0]},
        "1080": {"vr": "DS", "Value": [37.0]},
        "1081": {"vr": "DS", "Value": [282.0]},
        "1082": {"vr": "DS", "Value": [31.0]},
        "1083": {"vr": "DS", "Value": [49.0]},
        "1084": {"vr": "DS", "Value": [34.0]},
        "1085": {"vr": "DS", "Value": [50.0]},
        "1086": {"vr": "DS", "Value": [41.0]},
        "1087": {"vr": "DS", "Value": [52.0]},
        "1088": {"vr": "DS", "Value": [309.0]},
        "1089": {"vr": "DS", "Value": [50.0]},
        "1090": {"vr": "DS", "Value": [266.0]},
        "1091": {"vr": "DS", "Value": [322.0]},
        "1092": {"vr": "DS", "Value": [47.0]},
        "1093": {"vr": "DS", "Value": [43.0]},
        "1094": {"vr": "DS", "Value": [57.0]},
        "1095": {"vr": "DS", "Value": [45.0]},
        "1096": {"vr": "DS", "Value": [50.0]},
        "1097": {"vr": "DS", "Value": [286.0]},
        "1098": {"vr": "DS", "Value": [24.0]},
        "1099": {"vr": "DS", "Value": [35.0]},
        "1100": {"vr": "DS", "Value": [49.0]},
        "1101": {"vr": "DS", "Value": [37.0]},
        "1102": {"vr": "DS", "Value": [47.0]},
        "1103": {"vr": "DS", "Value": [48.0]},
        "1104": {"vr": "DS", "Value": [54.0]},
        "1105": {"vr": "DS", "Value": [287.0]},
        "1106": {"vr": "DS", "Value": [43.0]},
        "1107": {"vr": "DS", "Value": [60.0]},
        "1108": {"vr": "DS", "Value": [55.0]},
        "1109": {"vr": "DS", "Value": [52.0]},
        "1110": {"vr": "DS", "Value": [239.0]},
        "1111": {"vr": "DS", "Value": [49.0]},
        "1112": {"vr": "DS", "Value": [42.0]},
        "1113": {"vr": "DS", "Value": [35.0]},
        "1114": {"vr": "DS", "Value": [55.0]},
        "1115": {"vr": "DS", "Value": [39.0]},
        "1116": {"vr": "DS", "Value": [57.0]},
        "1117": {"vr": "DS", "Value": [50.0]},
        "1118": {"vr": "DS", "Value": [54.0]},
        "1119": {"vr": "DS", "Value": [46.0]},
        "1120": {"vr": "DS", "Value": [42.0]},
        "1121": {"vr": "DS", "Value": [25.0]},
        "1122": {"vr": "DS", "Value": [35.0]},
        "1123": {"vr": "DS", "Value": [47.0]},
        "1124": {"vr": "DS", "Value": [29.0]},
        "1125": {"vr": "DS", "Value": [47.0]},
        "1126": {"vr": "DS", "Value": [55.0]},
        "1127": {"vr": "DS", "Value": [42.0]},
        "1128": {"vr": "DS", "Value": [50.0]},
        "1129": {"vr": "DS", "Value": [49.0]},
        "1130": {"vr": "DS", "Value": [54.0]},
        "1131": {"vr": "DS", "Value": [317.0]},
        "1132": {"vr": "DS", "Value": [49.0]},
        "1133": {"vr": "DS", "Value": [44.0]},
        "1134": {"vr": "DS", "Value": [37.0]},
        "1135": {"vr": "DS", "Value": [51.0]},
        "1136": {"vr": "DS", "Value": [292.0]},
        "1137": {"vr": "DS", "Value": [11.0]},
        "1138": {"vr": "DS", "Value": [51.0]},
        "1139": {"vr": "DS", "Value": [54.0]},
        "1140": {"vr": "DS", "Value": [47.0]},
        "1141": {"vr": "DS", "Value": [49.0]},
        "1142": {"vr": "DS", "Value": [39.0]},
        "1143": {"vr": "DS", "Value": [49.0]},
        "1144": {"vr": "DS", "Value": [42.0]},
        "1145": {"vr": "DS", "Value": [55.0]},
        "1146": {"vr": "DS", "Value": [51.0]},
        "1147": {"vr": "DS", "Value": [285.0]},
        "1148": {"vr": "DS", "Value": [284.0]},
        "1149": {"vr": "DS", "Value": [266.0]},
        "1150": {"vr": "DS", "Value": [26.0]},
        "1151": {"vr": "DS", "Value": [36.0]},
        "1152": {"vr": "DS", "Value": [51.0]},
        "1153": {"vr": "DS", "Value": [50.0]},
        "1154": {"vr": "DS", "Value": [51.0]},
        "1155": {"vr": "DS", "Value": [55.0]},
        "1156": {"vr": "DS", "Value": [47.0]},
        "1157": {"vr": "DS", "Value": [51.0]},
        "1158": {"vr": "DS", "Value": [44.0]},
        "1159": {"vr": "DS", "Value": [57.0]},
        "1160": {"vr": "DS", "Value": [48.0]},
        "1161": {"vr": "DS", "Value": [52.0]},
        "1162": {"vr": "DS", "Value": [35.0]},
        "1163": {"vr": "DS", "Value": [28.0]},
        "1164": {"vr": "DS", "Value": [26.0]},
        "1165": {"vr": "DS", "Value": [273.0]},
        "1166": {"vr": "DS", "Value": [284.0]},
        "1167": {"vr": "DS", "Value": [47.0]},
        "1168": {"vr": "DS", "Value": [29.0]},
        "1169": {"vr": "DS", "Value": [46.0]},
        "1170": {"vr": "DS", "Value": [29.0]},
        "1171": {"vr": "DS", "Value": [44.0]},
        "1172": {"vr": "DS", "Value": [53.0]},
        "1173": {"vr": "DS", "Value": [54.0]},
        "1174": {"vr": "DS", "Value": [53.0]},
        "1175": {"vr": "DS", "Value": [42.0]},
        "1176": {"vr": "DS", "Value": [53.0]},
        "1177": {"vr": "DS", "Value": [38.0]},
        "1178": {"vr": "DS", "Value": [339.0]},
        "1179": {"vr": "DS", "Value": [59.0]},
        "1180": {"vr": "DS", "Value": [23.0]},
        "1181": {"vr": "DS", "Value": [25.0]},
        "1182": {"vr": "DS", "Value": [26.0]},
        "1183": {"vr": "DS", "Value": [53.0]},
        "1184": {"vr": "DS", "Value": [51.0]},
        "1185": {"vr": "DS", "Value": [37.0]},
        "1186": {"vr": "DS", "Value": [42.0]},
        "1187": {"vr": "DS", "Value": [42.0]},
        "1188": {"vr": "DS", "Value": [52.0]},
        "1189": {"vr": "DS", "Value": [264.0]},
        "1190": {"vr": "DS", "Value": [44.0]},
        "1191": {"vr": "DS", "Value": [271.0]},
        "1192": {"vr": "DS", "Value": [54.0]},
        "1193": {"vr": "DS", "Value": [223.0]},
        "1194": {"vr": "DS", "Value": [50.0]},
        "1195": {"vr": "DS", "Value": [49.0]},
        "1196": {"vr": "DS", "Value": [40.0]},
        "1197": {"vr": "DS", "Value": [50.0]},
        "1198": {"vr": "DS", "Value": [43.0]},
        "1199": {"vr": "DS", "Value": [55.0]},
        "1200": {"vr": "DS", "Value": [51.0]},
        "1201": {"vr": "DS", "Value": [142.0]},
        "1202": {"vr": "DS", "Value": [59.0]},
        "1203": {"vr": "DS", "Value": [41.0]},
        "1204": {"vr": "DS", "Value": [54.0]},
        "1205": {"vr": "DS", "Value": [45.0]},
        "1206": {"vr": "DS", "Value": [54.0]},
        "1207": {"vr": "DS", "Value": [26.0]},
        "1208": {"vr": "DS", "Value": [52.0]},
        "1209": {"vr": "DS", "Value": [24.0]},
        "1210": {"vr": "DS", "Value": [52.0]},
        "1211": {"vr": "DS", "Value": [51.0]},
        "1212": {"vr": "DS", "Value": [55.0]},
        "1213": {"vr": "DS", "Value": [56.0]},
        "1214": {"vr": "DS", "Value": [28.0]},
        "1215": {"vr": "DS", "Value": [51.0]},
        "1216": {"vr": "DS", "Value": [29.0]},
        "1217": {"vr": "DS", "Value": [39.0]},
        "1218": {"vr": "DS", "Value": [39.0]},
        "1219": {"vr": "DS", "Value": [282.0]},
        "1220": {"vr": "DS", "Value": [273.0]},
        "1221": {"vr": "DS", "Value": [52.0]},
        "1222": {"vr": "DS", "Value": [50.0]},
        "1223": {"vr": "DS", "Value": [31.0]},
        "1224": {"vr": "DS", "Value": [50.0]},
        "1225": {"vr": "DS", "Value": [51.0]},
        "1226": {"vr": "DS", "Value": [50.0]},
        "1227": {"vr": "DS", "Value": [39.0]},
        "1228": {"vr": "DS", "Value": [46.0]},
        "1229": {"vr": "DS", "Value": [46.0]},
        "1230": {"vr": "DS", "Value": [54.0]},
        "1231": {"vr": "DS", "Value": [36.0]},
        "1232": {"vr": "DS", "Value": [31.0]},
        "1233": {"vr": "DS", "Value": [51.0]},
        "1234": {"vr": "DS", "Value": [54.0]},
        "1235": {"vr": "DS", "Value": [52.0]},
        "1236": {"vr": "DS", "Value": [43.0]},
        "1237": {"vr": "DS", "Value": [49.0]},
        "1238": {"vr": "DS", "Value": [55.0]},
        "1239": {"vr": "DS", "Value": [41.0]},
        "1240": {"vr": "DS", "Value": [30.0]},
        "1241": {"vr": "DS", "Value": [24.0]},
        "1242": {"vr": "DS", "Value": [50.0]},
        "1243": {"vr": "DS", "Value": [50.0]},
        "1244": {"vr": "DS", "Value": [53.0]},
        "1245": {"vr": "DS", "Value": [49.0]},
        "1246": {"vr": "DS", "Value": [49.0]},
        "1247": {"vr": "DS", "Value": [46.0]},
        "1248": {"vr": "DS", "Value": [45.0]},
        "1249": {"vr": "DS", "Value": [39.0]},
        "1250": {"vr": "DS", "Value": [34.0]},
        "1251": {"vr": "DS", "Value": [53.0]},
        "1252": {"vr": "DS", "Value": [58.0]},
        "1253": {"vr": "DS", "Value": [48.0]},
        "1254": {"vr": "DS", "Value": [48.0]},
        "1255": {"vr": "DS", "Value": [50.0]},
        "1256": {"vr": "DS", "Value": [38.0]},
        "1257": {"vr": "DS", "Value": [50.0]},
        "1258": {"vr": "DS", "Value": [54.0]},
        "1259": {"vr": "DS", "Value": [44.0]},
        "1260": {"vr": "DS", "Value": [250.0]},
        "1261": {"vr": "DS", "Value": [23.0]},
        "1262": {"vr": "DS", "Value": [51.0]},
        "1263": {"vr": "DS", "Value": [52.0]},
        "1264": {"vr": "DS", "Value": [269.0]},
        "1265": {"vr": "DS", "Value": [51.0]},
        "1266": {"vr": "DS", "Value": [50.0]},
        "1267": {"vr": "DS", "Value": [43.0]},
        "1268": {"vr": "DS", "Value": [38.0]},
        "1269": {"vr": "DS", "Value": [23.0]},
        "1270": {"vr": "DS", "Value": [54.0]},
        "1271": {"vr": "DS", "Value": [262.0]},
        "1272": {"vr": "DS", "Value": [42.0]},
        "1273": {"vr": "DS", "Value": [26.0]},
        "1274": {"vr": "DS", "Value": [54.0]},
        "1275": {"vr": "DS", "Value": [47.0]},
        "1276": {"vr": "DS", "Value": [41.0]},
        "1277": {"vr": "DS", "Value": [58.0]},
        "1278": {"vr": "DS", "Value": [52.0]},
        "1279": {"vr": "DS", "Value": [41.0]},
        "1280": {"vr": "DS", "Value": [44.0]},
        "1281": {"vr": "DS", "Value": [56.0]},
        "1282": {"vr": "DS", "Value": [313.0]},
        "1283": {"vr": "DS", "Value": [27.0]},
        "1284": {"vr": "DS", "Value": [52.0]},
        "1285": {"vr": "DS", "Value": [46.0]},
        "1286": {"vr": "DS", "Value": [24.0]},
        "1287": {"vr": "DS", "Value": [47.0]},
        "1288": {"vr": "DS", "Value": [53.0]},
        "1289": {"vr": "DS", "Value": [50.0]},
        "1290": {"vr": "DS", "Value": [56.0]},
        "1291": {"vr": "DS", "Value": [50.0]},
        "1292": {"vr": "DS", "Value": [52.0]},
        "1293": {"vr": "DS", "Value": [48.0]},
        "1294": {"vr": "DS", "Value": [51.0]},
        "1295": {"vr": "DS", "Value": [41.0]},
        "1296": {"vr": "DS", "Value": [51.0]},
        "1297": {"vr": "DS", "Value": [25.0]},
        "1298": {"vr": "DS", "Value": [55.0]},
        "1299": {"vr": "DS", "Value": [9.0]},
        "1300": {"vr": "DS", "Value": [294.0]},
        "1301": {"vr": "DS", "Value": [47.0]},
        "1302": {"vr": "DS", "Value": [43.0]},
        "1303": {"vr": "DS", "Value": [45.0]},
        "1304": {"vr": "DS", "Value": [50.0]},
        "1305": {"vr": "DS", "Value": [36.0]},
        "1306": {"vr": "DS", "Value": [56.0]},
        "1307": {"vr": "DS", "Value": [51.0]},
        "1308": {"vr": "DS", "Value": [53.0]},
        "1309": {"vr": "DS", "Value": [247.0]},
        "1310": {"vr": "DS", "Value": [54.0]},
        "1311": {"vr": "DS", "Value": [53.0]},
        "1312": {"vr": "DS", "Value": [42.0]},
        "1313": {"vr": "DS", "Value": [49.0]},
        "1314": {"vr": "DS", "Value": [50.0]},
        "1315": {"vr": "DS", "Value": [35.0]},
        "1316": {"vr": "DS", "Value": [53.0]},
        "1317": {"vr": "DS", "Value": [57.0]},
        "1318": {"vr": "DS", "Value": [46.0]},
        "1319": {"vr": "DS", "Value": [56.0]},
        "1320": {"vr": "DS", "Value": [42.0]},
        "1321": {"vr": "DS", "Value": [58.0]},
        "1322": {"vr": "DS", "Value": [25.0]},
        "1323": {"vr": "DS", "Value": [54.0]},
        "1324": {"vr": "DS", "Value": [286.0]},
        "1325": {"vr": "DS", "Value": [48.0]},
        "1326": {"vr": "DS", "Value": [210.0]},
        "1327": {"vr": "DS", "Value": [54.0]},
        "1328": {"vr": "DS", "Value": [49.0]},
        "1329": {"vr": "DS", "Value": [52.0]},
        "1330": {"vr": "DS", "Value": [263.0]},
        "1331": {"vr": "DS", "Value": [55.0]},
        "1332": {"vr": "DS", "Value": [52.0]},
        "1333": {"vr": "DS", "Value": [318.0]},
        "1334": {"vr": "DS", "Value": [50.0]},
        "1335": {"vr": "DS", "Value": [45.0]},
        "1336": {"vr": "DS", "Value": [52.0]},
        "1337": {"vr": "DS", "Value": [50.0]},
        "1338": {"vr": "DS", "Value": [54.0]},
        "1339": {"vr": "DS", "Value": [29.0]},
        "1340": {"vr": "DS", "Value": [51.0]},
        "1341": {"vr": "DS", "Value": [50.0]},
        "1342": {"vr": "DS", "Value": [52.0]},
        "1343": {"vr": "DS", "Value": [46.0]},
        "1344": {"vr": "DS", "Value": [47.0]},
        "1345": {"vr": "DS", "Value": [42.0]},
        "1346": {"vr": "DS", "Value": [34.0]},
        "1347": {"vr": "DS", "Value": [265.0]},
        "1348": {"vr": "DS", "Value": [52.0]},
        "1349": {"vr": "DS", "Value": [27.0]},
        "1350": {"vr": "DS", "Value": [46.0]},
        "1351": {"vr": "DS", "Value": [50.0]},
        "1352": {"vr": "DS", "Value": [52.0]},
        "1353": {"vr": "DS", "Value": [26.0]},
        "1354": {"vr": "DS", "Value": [43.0]},
        "1355": {"vr": "DS", "Value": [52.0]},
        "1356": {"vr": "DS", "Value": [50.0]},
        "1357": {"vr": "DS", "Value": [51.0]},
        "1358": {"vr": "DS", "Value": [288.0]},
        "1359": {"vr": "DS", "Value": [58.0]},
        "1360": {"vr": "DS", "Value": [58.0]},
        "1361": {"vr": "DS", "Value": [54.0]},
        "1362": {"vr": "DS", "Value": [56.0]},
        "1363": {"vr": "DS", "Value": [48.0]},
        "1364": {"vr": "DS", "Value": [9.0]},
        "1365": {"vr": "DS", "Value": [41.0]},
        "1366": {"vr": "DS", "Value": [50.0]},
        "1367": {"vr": "DS", "Value": [51.0]},
        "1368": {"vr": "DS", "Value": [25.0]},
        "1369": {"vr": "DS", "Value": [57.0]},
        "1370": {"vr": "DS", "Value": [55.0]},
        "1371": {"vr": "DS", "Value": [26.0]},
        "1372": {"vr": "DS", "Value": [51.0]},
        "1373": {"vr": "DS", "Value": [54.0]},
        "1374": {"vr": "DS", "Value": [52.0]},
        "1375": {"vr": "DS", "Value": [277.0]},
        "1376": {"vr": "DS", "Value": [54.0]},
        "1377": {"vr": "DS", "Value": [55.0]},
        "1378": {"vr": "DS", "Value": [56.0]},
        "1379": {"vr": "DS", "Value": [55.0]},
        "1380": {"vr": "DS", "Value": [45.0]},
        "1381": {"vr": "DS", "Value": [304.0]},
        "1382": {"vr": "DS", "Value": [53.0]},
        "1383": {"vr": "DS", "Value": [53.0]},
        "1384": {"vr": "DS", "Value": [25.0]},
        "1385": {"vr": "DS", "Value": [24.0]},
        "1386": {"vr": "DS", "Value": [54.0]},
        "1387": {"vr": "DS", "Value": [51.0]},
        "1388": {"vr": "DS", "Value": [37.0]},
        "1389": {"vr": "DS", "Value": [54.0]},
        "1390": {"vr": "DS", "Value": [47.0]},
        "1391": {"vr": "DS", "Value": [53.0]},
        "1392": {"vr": "DS", "Value": [51.0]},
        "1393": {"vr": "DS", "Value": [56.0]},
        "1394": {"vr": "DS", "Value": [58.0]},
        "1395": {"vr": "DS", "Value": [48.0]},
        "1396": {"vr": "DS", "Value": [46.0]},
        "1397": {"vr": "DS", "Value": [49.0]},
        "1398": {"vr": "DS", "Value": [52.0]},
        "1399": {"vr": "DS", "Value": [56.0]},
        "1400": {"vr": "DS", "Value": [46.0]},
        "1401": {"vr": "DS", "Value": [41.0]},
        "1402": {"vr": "DS", "Value": [56.0]},
        "1403": {"vr": "DS", "Value": [45.0]},
        "1404": {"vr": "DS", "Value": [269.0]},
        "1405": {"vr": "DS", "Value": [54.0]},
        "1406": {"vr": "DS", "Value": [36.0]},
        "1407": {"vr": "DS", "Value": [55.0]},
        "1408": {"vr": "DS", "Value": [40.0]},
        "1409": {"vr": "DS", "Value": [56.0]},
        "1410": {"vr": "DS", "Value": [24.0]},
        "1411": {"vr": "DS", "Value": [10.0]},
        "1412": {"vr": "DS", "Value": [56.0]},
        "1413": {"vr": "DS", "Value": [287.0]},
        "1414": {"vr": "DS", "Value": [42.0]},
        "1415": {"vr": "DS", "Value": [51.0]},
        "1416": {"vr": "DS", "Value": [48.0]},
        "1417": {"vr": "DS", "Value": [273.0]},
        "1418": {"vr": "DS", "Value": [57.0]},
        "1419": {"vr": "DS", "Value": [55.0]},
        "1420": {"vr": "DS", "Value": [52.0]},
        "1421": {"vr": "DS", "Value": [48.0]},
        "1422": {"vr": "DS", "Value": [45.0]},
        "1423": {"vr": "DS", "Value": [41.0]},
        "1424": {"vr": "DS", "Value": [53.0]},
        "1425": {"vr": "DS", "Value": [25.0]},
        "1426": {"vr": "DS", "Value": [25.0]},
        "1427": {"vr": "DS", "Value": [34.0]},
        "1428": {"vr": "DS", "Value": [50.0]},
        "1429": {"vr": "DS", "Value": [51.0]},
        "1430": {"vr": "DS", "Value": [295.0]},
        "1431": {"vr": "DS", "Value": [35.0]},
        "1432": {"vr": "DS", "Value": [39.0]},
        "1433": {"vr": "DS", "Value": [56.0]},
        "1434": {"vr": "DS", "Value": [35.0]},
        "1435": {"vr": "DS", "Value": [25.0]},
        "1436": {"vr": "DS", "Value": [43.0]},
        "1437": {"vr": "DS", "Value": [23.0]},
        "1438": {"vr": "DS", "Value": [32.0]},
        "1439": {"vr": "DS", "Value": [60.0]},
        "1440": {"vr": "DS", "Value": [52.0]},
        "1441": {"vr": "DS", "Value": [24.0]},
        "1442": {"vr": "DS", "Value": [265.0]},
        "1443": {"vr": "DS", "Value": [54.0]},
        "1444": {"vr": "DS", "Value": [49.0]},
        "1445": {"vr": "DS", "Value": [34.0]},
        "1446": {"vr": "DS", "Value": [48.0]},
        "1447": {"vr": "DS", "Value": [26.0]},
        "1448": {"vr": "DS", "Value": [41.0]},
        "1449": {"vr": "DS", "Value": [282.0]},
        "1450": {"vr": "DS", "Value": [36.0]},
        "1451": {"vr": "DS", "Value": [49.0]},
        "1452": {"vr": "DS", "Value": [57.0]},
        "1453": {"vr": "DS", "Value": [44.0]},
        "1454": {"vr": "DS", "Value": [60.0]},
        "1455": {"vr": "DS", "Value": [295.0]},
        "1456": {"vr": "DS", "Value": [59.0]},
        "1457": {"vr": "DS", "Value": [48.0]},
        "1458": {"vr": "DS", "Value": [24.0]},
        "1459": {"vr": "DS", "Value": [47.0]},
        "1460": {"vr": "DS", "Value": [59.0]},
        "1461": {"vr": "DS", "Value": [272.0]},
        "1462": {"vr": "DS", "Value": [49.0]},
        "1463": {"vr": "DS", "Value": [50.0]},
        "1464": {"vr": "DS", "Value": [39.0]},
        "1465": {"vr": "DS", "Value": [52.0]},
        "1466": {"vr": "DS", "Value": [25.0]},
        "1467": {"vr": "DS", "Value": [52.0]},
        "1468": {"vr": "DS", "Value": [40.0]},
        "1469": {"vr": "DS", "Value": [54.0]},
        "1470": {"vr": "DS", "Value": [50.0]},
        "1471": {"vr": "DS", "Value": [45.0]},
        "1472": {"vr": "DS", "Value": [57.0]},
        "1473": {"vr": "DS", "Value": [52.0]},
        "1474": {"vr": "DS", "Value": [267.0]},
        "1475": {"vr": "DS", "Value": [44.0]},
        "1476": {"vr": "DS", "Value": [41.0]},
        "1477": {"vr": "DS", "Value": [54.0]},
        "1478": {"vr": "DS", "Value": [33.0]},
        "1479": {"vr": "DS", "Value": [44.0]},
        "1480": {"vr": "DS", "Value": [48.0]},
        "1481": {"vr": "DS", "Value": [25.0]},
        "1482": {"vr": "DS", "Value": [57.0]},
        "1483": {"vr": "DS", "Value": [54.0]},
        "1484": {"vr": "DS", "Value": [53.0]},
        "1485": {"vr": "DS", "Value": [37.0]},
        "1486": {"vr": "DS", "Value": [47.0]},
        "1487": {"vr": "DS", "Value": [57.0]},
        "1488": {"vr": "DS", "Value": [300.0]},
        "1489": {"vr": "DS", "Value": [28.0]},
        "1490": {"vr": "DS", "Value": [53.0]},
        "1491": {"vr": "DS", "Value": [52.0]},
        "1492": {"vr": "DS", "Value": [55.0]},
        "1493": {"vr": "DS", "Value": [142.0]},
        "1494": {"vr": "DS", "Value": [51.0]},
        "1495": {"vr": "DS", "Value": [55.0]},
        "1496": {"vr": "DS", "Value": [44.0]},
        "1497": {"vr": "DS", "Value": [26.0]},
        "1498": {"vr": "DS", "Value": [48.0]},
        "1499": {"vr": "DS", "Value": [52.0]},
        "1500": {"vr": "DS", "Value": [54.0]},
        "1501": {"vr": "DS", "Value": [40.0]},
        "1502": {"vr": "DS", "Value": [42.0]},
        "1503": {"vr": "DS", "Value": [46.0]},
        "1504": {"vr": "DS", "Value": [51.0]},
        "1505": {"vr": "DS", "Value": [25.0]},
        "1506": {"vr": "DS", "Value": [40.0]},
        "1507": {"vr": "DS", "Value": [46.0]},
        "1508": {"vr": "DS", "Value": [46.0]},
        "1509": {"vr": "DS", "Value": [49.0]},
        "1510": {"vr": "DS", "Value": [55.0]},
        "1511": {"vr": "DS", "Value": [41.0]},
        "1512": {"vr": "DS", "Value": [224.0]},
        "1513": {"vr": "DS", "Value": [49.0]},
        "1514": {"vr": "DS", "Value": [42.0]},
        "1515": {"vr": "DS", "Value": [272.0]},
        "1516": {"vr": "DS", "Value": [50.0]},
        "1517": {"vr": "DS", "Value": [283.0]},
        "1518": {"vr": "DS", "Value": [38.0]},
        "1519": {"vr": "DS", "Value": [53.0]},
        "1520": {"vr": "DS", "Value": [42.0]},
        "1521": {"vr": "DS", "Value": [25.0]},
        "1522": {"vr": "DS", "Value": [51.0]},
        "1523": {"vr": "DS", "Value": [52.0]},
        "1524": {"vr": "DS", "Value": [26.0]},
        "1525": {"vr": "DS", "Value": [51.0]},
        "1526": {"vr": "DS", "Value": [24.0]},
        "1527": {"vr": "DS", "Value": [51.0]},
        "1528": {"vr": "DS", "Value": [44.0]},
        "1529": {"vr": "DS", "Value": [55.0]},
        "1530": {"vr": "DS", "Value": [48.0]},
        "1531": {"vr": "DS", "Value": [37.0]},
        "1532": {"vr": "DS", "Value": [49.0]},
        "1533": {"vr": "DS", "Value": [44.0]},
        "1534": {"vr": "DS", "Value": [23.0]},
        "1535": {"vr": "DS", "Value": [49.0]},
        "1536": {"vr": "DS", "Value": [284.0]},
        "1537": {"vr": "DS", "Value": [51.0]},
        "1538": {"vr": "DS", "Value": [37.0]},
        "1539": {"vr": "DS", "Value": [57.0]},
        "1540": {"vr": "DS", "Value": [49.0]},
        "1541": {"vr": "DS", "Value": [47.0]},
        "1542": {"vr": "DS", "Value": [52.0]},
        "1543": {"vr": "DS", "Value": [52.0]},
        "1544": {"vr": "DS", "Value": [24.0]},
        "1545": {"vr": "DS", "Value": [53.0]},
        "1546": {"vr": "DS", "Value": [47.0]},
        "1547": {"vr": "DS", "Value": [51.0]},
        "1548": {"vr": "DS", "Value": [43.0]},
        "1549": {"vr": "DS", "Value": [55.0]},
        "1550": {"vr": "DS", "Value": [49.0]},
        "1551": {"vr": "DS", "Value": [46.0]},
        "1552": {"vr": "DS", "Value": [52.0]},
        "1553": {"vr": "DS", "Value": [271.0]},
        "1554": {"vr": "DS", "Value": [48.0]},
        "1555": {"vr": "DS", "Value": [274.0]},
        "1556": {"vr": "DS", "Value": [52.0]},
        "1557": {"vr": "DS", "Value": [26.0]},
        "1558": {"vr": "DS", "Value": [27.0]},
        "1559": {"vr": "DS", "Value": [288.0]},
        "1560": {"vr": "DS", "Value": [45.0]},
        "1561": {"vr": "DS", "Value": [9.0]},
        "1562": {"vr": "DS", "Value": [286.0]},
        "1563": {"vr": "DS", "Value": [50.0]},
        "1564": {"vr": "DS", "Value": [24.0]},
        "1565": {"vr": "DS", "Value": [49.0]},
        "1566": {"vr": "DS", "Value": [43.0]},
        "1567": {"vr": "DS", "Value": [52.0]},
        "1568": {"vr": "DS", "Value": [37.0]},
        "1569": {"vr": "DS", "Value": [49.0]},
        "1570": {"vr": "DS", "Value": [48.0]},
        "1571": {"vr": "DS", "Value": [55.0]},
        "1572": {"vr": "DS", "Value": [38.0]},
        "1573": {"vr": "DS", "Value": [46.0]},
        "1574": {"vr": "DS", "Value": [298.0]},
        "1575": {"vr": "DS", "Value": [24.0]},
        "1576": {"vr": "DS", "Value": [56.0]},
        "1577": {"vr": "DS", "Value": [45.0]},
        "1578": {"vr": "DS", "Value": [52.0]},
        "1579": {"vr": "DS", "Value": [55.0]},
        "1580": {"vr": "DS", "Value": [34.0]},
        "1581": {"vr": "DS", "Value": [52.0]},
        "1582": {"vr": "DS", "Value": [49.0]},
        "1583": {"vr": "DS", "Value": [56.0]},
        "1584": {"vr": "DS", "Value": [42.0]},
        "1585": {"vr": "DS", "Value": [52.0]},
        "1586": {"vr": "DS", "Value": [50.0]},
        "1587": {"vr": "DS", "Value": [54.0]},
        "1588": {"vr": "DS", "Value": [61.0]},
        "1589": {"vr": "DS", "Value": [37.0]},
        "1590": {"vr": "DS", "Value": [51.0]},
        "1591": {"vr": "DS", "Value": [51.0]},
        "1592": {"vr": "DS", "Value": [56.0]},
        "1593": {"vr": "DS", "Value": [27.0]},
        "1594": {"vr": "DS", "Value": [287.0]},
        "1595": {"vr": "DS", "Value": [53.0]},
        "1596": {"vr": "DS", "Value": [38.0]},
        "1597": {"vr": "DS", "Value": [53.0]},
        "1598": {"vr": "DS", "Value": [36.0]},
        "1599": {"vr": "DS", "Value": [49.0]},
        "1600": {"vr": "DS", "Value": [315.0]},
        "1601": {"vr": "DS", "Value": [319.0]},
        "1602": {"vr": "DS", "Value": [52.0]},
        "1603": {"vr": "DS", "Value": [259.0]},
        "1604": {"vr": "DS", "Value": [308.0]},
        "1605": {"vr": "DS", "Value": [42.0]},
        "1606": {"vr": "DS", "Value": [57.0]},
        "1607": {"vr": "DS", "Value": [54.0]},
        "1608": {"vr": "DS", "Value": [37.0]},
        "1609": {"vr": "DS", "Value": [52.0]},
        "1610": {"vr": "DS", "Value": [264.0]},
        "1611": {"vr": "DS", "Value": [24.0]},
        "1612": {"vr": "DS", "Value": [24.0]},
        "1613": {"vr": "DS", "Value": [40.0]},
        "1614": {"vr": "DS", "Value": [49.0]},
        "1615": {"vr": "DS", "Value": [48.0]},
        "1616": {"vr": "DS", "Value": [51.0]},
        "1617": {"vr": "DS", "Value": [41.0]},
        "1618": {"vr": "DS", "Value": [44.0]},
        "1619": {"vr": "DS", "Value": [23.0]},
        "1620": {"vr": "DS", "Value": [42.0]},
        "1621": {"vr": "DS", "Value": [46.0]},
        "1622": {"vr": "DS", "Value": [47.0]},
        "1623": {"vr": "DS", "Value": [54.0]},
        "1624": {"vr": "DS", "Value": [30.0]},
        "1625": {"vr": "DS", "Value": [278.0]},
        "1626": {"vr": "DS", "Value": [52.0]},
        "1627": {"vr": "DS", "Value": [47.0]},
        "1628": {"vr": "DS", "Value": [50.0]},
        "1629": {"vr": "DS", "Value": [48.0]},
        "1630": {"vr": "DS", "Value": [57.0]},
        "1631": {"vr": "DS", "Value": [50.0]},
        "1632": {"vr": "DS", "Value": [31.0]},
        "1633": {"vr": "DS", "Value": [47.0]},
        "1634": {"vr": "DS", "Value": [54.0]},
        "1635": {"vr": "DS", "Value": [44.0]},
        "1636": {"vr": "DS", "Value": [54.0]},
        "1637": {"vr": "DS", "Value": [36.0]},
        "1638": {"vr": "DS", "Value": [54.0]},
        "1639": {"vr": "DS", "Value": [56.0]},
        "1640": {"vr": "DS", "Value": [58.0]},
        "1641": {"vr": "DS", "Value": [43.0]},
        "1642": {"vr": "DS", "Value": [51.0]},
        "1643": {"vr": "DS", "Value": [57.0]},
        "1644": {"vr": "DS", "Value": [264.0]},
        "1645": {"vr": "DS", "Value": [49.0]},
        "1646": {"vr": "DS", "Value": [53.0]},
        "1647": {"vr": "DS", "Value": [50.0]},
        "1648": {"vr": "DS", "Value": [25.0]},
        "1649": {"vr": "DS", "Value": [283.0]},
        "1650": {"vr": "DS", "Value": [38.0]},
        "1651": {"vr": "DS", "Value": [50.0]},
        "1652": {"vr": "DS", "Value": [26.0]},
        "1653": {"vr": "DS", "Value": [51.0]},
        "1654": {"vr": "DS", "Value": [27.0]},
        "1655": {"vr": "DS", "Value": [45.0]},
        "1656": {"vr": "DS", "Value": [60.0]},
        "1657": {"vr": "DS", "Value": [26.0]},
        "1658": {"vr": "DS", "Value": [56.0]},
        "1659": {"vr": "DS", "Value": [37.0]},
        "1660": {"vr": "DS", "Value": [54.0]},
        "1661": {"vr": "DS", "Value": [48.0]},
        "1662": {"vr": "DS", "Value": [54.0]},
        "1663": {"vr": "DS", "Value": [52.0]},
        "1664": {"vr": "DS", "Value": [36.0]},
        "1665": {"vr": "DS", "Value": [36.0]},
        "1666": {"vr": "DS", "Value": [30.0]},
        "1667": {"vr": "DS", "Value": [29.0]},
        "1668": {"vr": "DS", "Value": [56.0]},
        "1669": {"vr": "DS", "Value": [25.0]},
        "1670": {"vr": "DS", "Value": [56.0]},
        "1671": {"vr": "DS", "Value": [30.0]},
        "1672": {"vr": "DS", "Value": [53.0]},
        "1673": {"vr": "DS", "Value": [54.0]},
        "1674": {"vr": "DS", "Value": [26.0]},
        "1675": {"vr": "DS", "Value": [51.0]},
        "1676": {"vr": "DS", "Value": [62.0]},
        "1677": {"vr": "DS", "Value": [51.0]},
        "1678": {"vr": "DS", "Value": [49.0]},
        "1679": {"vr": "DS", "Value": [28.0]},
        "1680": {"vr": "DS", "Value": [50.0]},
        "1681": {"vr": "DS", "Value": [45.0]},
        "1682": {"vr": "DS", "Value": [58.0]},
        "1683": {"vr": "DS", "Value": [37.0]},
        "1684": {"vr": "DS", "Value": [48.0]},
        "1685": {"vr": "DS", "Value": [25.0]},
        "1686": {"vr": "DS", "Value": [37.0]},
        "1687": {"vr": "DS", "Value": [50.0]},
        "1688": {"vr": "DS", "Value": [36.0]},
        "1689": {"vr": "DS", "Value": [270.0]},
        "1690": {"vr": "DS", "Value": [24.0]},
        "1691": {"vr": "DS", "Value": [296.0]},
        "1692": {"vr": "DS", "Value": [48.0]},
        "1693": {"vr": "DS", "Value": [53.0]},
        "1694": {"vr": "DS", "Value": [44.0]},
        "1695": {"vr": "DS", "Value": [37.0]},
        "1696": {"vr": "DS", "Value": [23.0]},
        "1697": {"vr": "DS", "Value": [51.0]},
        "1698": {"vr": "DS", "Value": [45.0]},
        "1699": {"vr": "DS", "Value": [53.0]},
        "1700": {"vr": "DS", "Value": [317.0]},
        "1701": {"vr": "DS", "Value": [52.0]},
        "1702": {"vr": "DS", "Value": [43.0]},
        "1703": {"vr": "DS", "Value": [35.0]},
        "1704": {"vr": "DS", "Value": [60.0]},
        "1705": {"vr": "DS", "Value": [26.0]},
        "1706": {"vr": "DS", "Value": [41.0]},
        "1707": {"vr": "DS", "Value": [36.0]},
        "1708": {"vr": "DS", "Value": [57.0]},
        "1709": {"vr": "DS", "Value": [53.0]},
        "1710": {"vr": "DS", "Value": [49.0]},
        "1711": {"vr": "DS", "Value": [25.0]},
        "1712": {"vr": "DS", "Value": [53.0]},
        "1713": {"vr": "DS", "Value": [44.0]},
        "1714": {"vr": "DS", "Value": [48.0]},
        "1715": {"vr": "DS", "Value": [58.0]},
        "1716": {"vr": "DS", "Value": [54.0]},
        "1717": {"vr": "DS", "Value": [244.0]},
        "1718": {"vr": "DS", "Value": [49.0]},
        "1719": {"vr": "DS", "Value": [52.0]},
        "1720": {"vr": "DS", "Value": [77.0]},
        "1721": {"vr": "DS", "Value": [32.0]},
        "1722": {"vr": "DS", "Value": [54.0]},
        "1723": {"vr": "DS", "Value": [54.0]},
        "1724": {"vr": "DS", "Value": [50.0]},
        "1725": {"vr": "DS", "Value": [37.0]},
        "1726": {"vr": "DS", "Value": [53.0]},
        "1727": {"vr": "DS", "Value": [36.0]},
        "1728": {"vr": "DS", "Value": [52.0]},
        "1729": {"vr": "DS", "Value": [58.0]},
        "1730": {"vr": "DS", "Value": [9.0]},
        "1731": {"vr": "DS", "Value": [44.0]},
        "1732": {"vr": "DS", "Value": [53.0]},
        "1733": {"vr": "DS", "Value": [52.0]},
        "1734": {"vr": "DS", "Value": [44.0]},
        "1735": {"vr": "DS", "Value": [65.0]},
        "1736": {"vr": "DS", "Value": [265.0]},
        "1737": {"vr": "DS", "Value": [54.0]},
        "1738": {"vr": "DS", "Value": [322.0]},
        "1739": {"vr": "DS", "Value": [43.0]},
        "1740": {"vr": "DS", "Value": [59.0]},
        "1741": {"vr": "DS", "Value": [48.0]},
        "1742": {"vr": "DS", "Value": [56.0]},
        "1743": {"vr": "DS", "Value": [57.0]},
        "1744": {"vr": "DS", "Value": [25.0]},
        "1745": {"vr": "DS", "Value": [38.0]},
        "1746": {"vr": "DS", "Value": [55.0]},
        "1747": {"vr": "DS", "Value": [54.0]},
        "1748": {"vr": "DS", "Value": [56.0]},
        "1749": {"vr": "DS", "Value": [37.0]},
        "1750": {"vr": "DS", "Value": [40.0]},
        "1751": {"vr": "DS", "Value": [43.0]},
        "1752": {"vr": "DS", "Value": [49.0]},
        "1753": {"vr": "DS", "Value": [51.0]},
        "1754": {"vr": "DS", "Value": [53.0]},
        "1755": {"vr": "DS", "Value": [53.0]},
        "1756": {"vr": "DS", "Value": [61.0]},
        "1757": {"vr": "DS", "Value": [51.0]},
        "1758": {"vr": "DS", "Value": [42.0]},
        "1759": {"vr": "DS", "Value": [26.0]},
        "1760": {"vr": "DS", "Value": [48.0]},
        "1761": {"vr": "DS", "Value": [33.0]},
        "1762": {"vr": "DS", "Value": [53.0]},
        "1763": {"vr": "DS", "Value": [49.0]},
        "1764": {"vr": "DS", "Value": [52.0]},
        "1765": {"vr": "DS", "Value": [25.0]},
        "1766": {"vr": "DS", "Value": [47.0]},
        "1767": {"vr": "DS", "Value": [51.0]},
        "1768": {"vr": "DS", "Value": [50.0]},
        "1769": {"vr": "DS", "Value": [53.0]},
        "1770": {"vr": "DS", "Value": [42.0]},
        "1771": {"vr": "DS", "Value": [41.0]},
        "1772": {"vr": "DS", "Value": [44.0]},
        "1773": {"vr": "DS", "Value": [41.0]},
        "1774": {"vr": "DS", "Value": [39.0]},
        "1775": {"vr": "DS", "Value": [266.0]},
        "1776": {"vr": "DS", "Value": [51.0]},
        "1777": {"vr": "DS", "Value": [28.0]},
        "1778": {"vr": "DS", "Value": [23.0]},
        "1779": {"vr": "DS", "Value": [23.0]},
        "1780": {"vr": "DS", "Value": [57.0]},
        "1781": {"vr": "DS", "Value": [60.0]},
        "1782": {"vr": "DS", "Value": [51.0]},
        "1783": {"vr": "DS", "Value": [44.0]},
        "1784": {"vr": "DS", "Value": [50.0]},
        "1785": {"vr": "DS", "Value": [47.0]},
        "1786": {"vr": "DS", "Value": [50.0]},
        "1787": {"vr": "DS", "Value": [42.0]},
        "1788": {"vr": "DS", "Value": [50.0]},
        "1789": {"vr": "DS", "Value": [40.0]},
        "1790": {"vr": "DS", "Value": [34.0]},
        "1791": {"vr": "DS", "Value": [48.0]},
        "1792": {"vr": "DS", "Value": [48.0]},
        "1793": {"vr": "DS", "Value": [43.0]},
        "1794": {"vr": "DS", "Value": [53.0]},
        "1795": {"vr": "DS", "Value": [53.0]},
        "1796": {"vr": "DS", "Value": [287.0]},
        "1797": {"vr": "DS", "Value": [25.0]},
        "1798": {"vr": "DS", "Value": [55.0]},
        "1799": {"vr": "DS", "Value": [54.0]},
        "1800": {"vr": "DS", "Value": [45.0]},
        "1801": {"vr": "DS", "Value": [47.0]},
        "1802": {"vr": "DS", "Value": [275.0]},
        "1803": {"vr": "DS", "Value": [31.0]},
        "1804": {"vr": "DS", "Value": [25.0]},
        "1805": {"vr": "DS", "Value": [264.0]},
        "1806": {"vr": "DS", "Value": [12.0]},
        "1807": {"vr": "DS", "Value": [50.0]},
        "1808": {"vr": "DS", "Value": [32.0]},
        "1809": {"vr": "DS", "Value": [23.0]},
        "1810": {"vr": "DS", "Value": [25.0]},
        "1811": {"vr": "DS", "Value": [49.0]},
        "1812": {"vr": "DS", "Value": [51.0]},
        "1813": {"vr": "DS", "Value": [53.0]},
        "1814": {"vr": "DS", "Value": [52.0]},
        "1815": {"vr": "DS", "Value": [47.0]},
        "1816": {"vr": "DS", "Value": [24.0]},
        "1817": {"vr": "DS", "Value": [42.0]},
        "1818": {"vr": "DS", "Value": [44.0]},
        "1819": {"vr": "DS", "Value": [34.0]},
        "1820": {"vr": "DS", "Value": [48.0]},
        "1821": {"vr": "DS", "Value": [24.0]},
        "1822": {"vr": "DS", "Value": [33.0]},
        "1823": {"vr": "DS", "Value": [49.0]},
        "1824": {"vr": "DS", "Value": [31.0]},
        "1825": {"vr": "DS", "Value": [55.0]},
        "1826": {"vr": "DS", "Value": [35.0]},
        "1827": {"vr": "DS", "Value": [250.0]},
        "1828": {"vr": "DS", "Value": [33.0]},
        "1829": {"vr": "DS", "Value": [37.0]},
        "1830": {"vr": "DS", "Value": [54.0]},
        "1831": {"vr": "DS", "Value": [45.0]},
        "1832": {"vr": "DS", "Value": [25.0]},
        "1833": {"vr": "DS", "Value": [51.0]},
        "1834": {"vr": "DS", "Value": [51.0]},
        "1835": {"vr": "DS", "Value": [51.0]},
        "1836": {"vr": "DS", "Value": [54.0]},
        "1837": {"vr": "DS", "Value": [312.0]},
        "1838": {"vr": "DS", "Value": [337.0]},
        "1839": {"vr": "DS", "Value": [51.0]},
        "1840": {"vr": "DS", "Value": [48.0]},
        "1841": {"vr": "DS", "Value": [57.0]},
        "1842": {"vr": "DS", "Value": [52.0]},
        "1843": {"vr": "DS", "Value": [51.0]},
        "1844": {"vr": "DS", "Value": [47.0]},
        "1845": {"vr": "DS", "Value": [242.0]},
        "1846": {"vr": "DS", "Value": [50.0]},
        "1847": {"vr": "DS", "Value": [24.0]},
        "1848": {"vr": "DS", "Value": [56.0]},
        "1849": {"vr": "DS", "Value": [42.0]},
        "1850": {"vr": "DS", "Value": [52.0]},
        "1851": {"vr": "DS", "Value": [38.0]},
        "1852": {"vr": "DS", "Value": [30.0]},
        "1853": {"vr": "DS", "Value": [54.0]},
        "1854": {"vr": "DS", "Value": [54.0]},
        "1855": {"vr": "DS", "Value": [53.0]},
        "1856": {"vr": "DS", "Value": [50.0]},
        "1857": {"vr": "DS", "Value": [36.0]},
        "1858": {"vr": "DS", "Value": [54.0]},
        "1859": {"vr": "DS", "Value": [53.0]},
        "1860": {"vr": "DS", "Value": [53.0]},
        "1861": {"vr": "DS", "Value": [32.0]},
        "1862": {"vr": "DS", "Value": [55.0]},
        "1863": {"vr": "DS", "Value": [54.0]},
        "1864": {"vr": "DS", "Value": [35.0]},
        "1865": {"vr": "DS", "Value": [37.0]},
        "1866": {"vr": "DS", "Value": [58.0]},
        "1867": {"vr": "DS", "Value": [34.0]},
        "1868": {"vr": "DS", "Value": [34.0]},
        "1869": {"vr": "DS", "Value": [52.0]},
        "1870": {"vr": "DS", "Value": [48.0]},
        "1871": {"vr": "DS", "Value": [54.0]},
        "1872": {"vr": "DS", "Value": [283.0]},
        "1873": {"vr": "DS", "Value": [223.0]},
        "1874": {"vr": "DS", "Value": [49.0]},
        "1875": {"vr": "DS", "Value": [25.0]},
        "1876": {"vr": "DS", "Value": [53.0]},
        "1877": {"vr": "DS", "Value": [39.0]},
        "1878": {"vr": "DS", "Value": [26.0]},
        "1879": {"vr": "DS", "Value": [42.0]},
        "1880": {"vr": "DS", "Value": [53.0]},
        "1881": {"vr": "DS", "Value": [26.0]},
        "1882": {"vr": "DS", "Value": [51.0]},
        "1883": {"vr": "DS", "Value": [22.0]},
        "1884": {"vr": "DS", "Value": [51.0]},
        "1885": {"vr": "DS", "Value": [28.0]},
        "1886": {"vr": "DS", "Value": [54.0]},
        "1887": {"vr": "DS", "Value": [25.0]},
        "1888": {"vr": "DS", "Value": [55.0]},
        "1889": {"vr": "DS", "Value": [284.0]},
        "1890": {"vr": "DS", "Value": [50.0]},
        "1891": {"vr": "DS", "Value": [26.0]},
        "1892": {"vr": "DS", "Value": [10.0]},
        "1893": {"vr": "DS", "Value": [49.0]},
        "1894": {"vr": "DS", "Value": [48.0]},
        "1895": {"vr": "DS", "Value": [37.0]},
        "1896": {"vr": "DS", "Value": [53.0]},
        "1897": {"vr": "DS", "Value": [46.0]},
        "1898": {"vr": "DS", "Value": [34.0]},
        "1899": {"vr": "DS", "Value": [52.0]},
        "1900": {"vr": "DS", "Value": [45.0]},
        "1901": {"vr": "DS", "Value": [54.0]},
        "1902": {"vr": "DS", "Value": [46.0]},
        "1903": {"vr": "DS", "Value": [54.0]},
        "1904": {"vr": "DS", "Value": [25.0]},
        "1905": {"vr": "DS", "Value": [49.0]},
        "1906": {"vr": "DS", "Value": [27.0]},
        "1907": {"vr": "DS", "Value": [46.0]},
        "1908": {"vr": "DS", "Value": [59.0]},
        "1909": {"vr": "DS", "Value": [270.0]},
        "1910": {"vr": "DS", "Value": [51.0]},
        "1911": {"vr": "DS", "Value": [52.0]},
        "1912": {"vr": "DS", "Value": [40.0]},
        "1913": {"vr": "DS", "Value": [55.0]},
        "1914": {"vr": "DS", "Value": [279.0]},
        "1915": {"vr": "DS", "Value": [312.0]},
        "1916": {"vr": "DS", "Value": [287.0]},
        "1917": {"vr": "DS", "Value": [53.0]},
        "1918": {"vr": "DS", "Value": [321.0]},
        "1919": {"vr": "DS", "Value": [21.0]},
        "1920": {"vr": "DS", "Value": [224.0]},
        "1921": {"vr": "DS", "Value": [39.0]},
        "1922": {"vr": "DS", "Value": [43.0]},
        "1923": {"vr": "DS", "Value": [59.0]},
        "1924": {"vr": "DS", "Value": [29.0]},
        "1925": {"vr": "DS", "Value": [49.0]},
        "1926": {"vr": "DS", "Value": [63.0]},
        "1927": {"vr": "DS", "Value": [9.0]},
        "1928": {"vr": "DS", "Value": [32.0]},
        "1929": {"vr": "DS", "Value": [52.0]},
        "1930": {"vr": "DS", "Value": [44.0]},
        "1931": {"vr": "DS", "Value": [45.0]},
        "1932": {"vr": "DS", "Value": [44.0]},
        "1933": {"vr": "DS", "Value": [288.0]},
        "1934": {"vr": "DS", "Value": [25.0]},
        "1935": {"vr": "DS", "Value": [48.0]},
        "1936": {"vr": "DS", "Value": [29.0]},
        "1937": {"vr": "DS", "Value": [58.0]},
        "1938": {"vr": "DS", "Value": [51.0]},
        "1939": {"vr": "DS", "Value": [53.0]},
        "1940": {"vr": "DS", "Value": [24.0]},
        "1941": {"vr": "DS", "Value": [57.0]},
        "1942": {"vr": "DS", "Value": [59.0]},
        "1943": {"vr": "DS", "Value": [52.0]},
        "1944": {"vr": "DS", "Value": [57.0]},
        "1945": {"vr": "DS", "Value": [46.0]},
        "1946": {"vr": "DS", "Value": [52.0]},
        "1947": {"vr": "DS", "Value": [55.0]},
        "1948": {"vr": "DS", "Value": [41.0]},
        "1949": {"vr": "DS", "Value": [285.0]},
        "1950": {"vr": "DS", "Value": [46.0]},
        "1951": {"vr": "DS", "Value": [51.0]},
        "1952": {"vr": "DS", "Value": [42.0]},
        "1953": {"vr": "DS", "Value": [34.0]},
        "1954": {"vr": "DS", "Value": [58.0]},
        "1955": {"vr": "DS", "Value": [56.0]},
        "1956": {"vr": "DS", "Value": [48.0]},
        "1957": {"vr": "DS", "Value": [56.0]},
        "1958": {"vr": "DS", "Value": [24.0]},
        "1959": {"vr": "DS", "Value": [54.0]},
        "1960": {"vr": "DS", "Value": [33.0]},
        "1961": {"vr": "DS", "Value": [260.0]},
        "1962": {"vr": "DS", "Value": [51.0]},
        "1963": {"vr": "DS", "Value": [55.0]},
        "1964": {"vr": "DS", "Value": [46.0]},
        "1965": {"vr": "DS", "Value": [48.0]},
        "1966": {"vr": "DS", "Value": [55.0]},
        "1967": {"vr": "DS", "Value": [286.0]},
        "1968": {"vr": "DS", "Value": [37.0]},
        "1969": {"vr": "DS", "Value": [45.0]},
        "1970": {"vr": "DS", "Value": [51.0]},
        "1971": {"vr": "DS", "Value": [54.0]},
        "1972": {"vr": "DS", "Value": [54.0]},
        "1973": {"vr": "DS", "Value": [294.0]},
        "1974": {"vr": "DS", "Value": [44.0]},
        "1975": {"vr": "DS", "Value": [37.0]},
        "1976": {"vr": "DS", "Value": [50.0]},
        "1977": {"vr": "DS", "Value": [54.0]},
        "1978": {"vr": "DS", "Value": [48.0]},
        "1979": {"vr": "DS", "Value": [42.0]},
        "1980": {"vr": "DS", "Value": [40.0]},
        "1981": {"vr": "DS", "Value": [23.0]},
        "1982": {"vr": "DS", "Value": [50.0]},
        "1983": {"vr": "DS", "Value": [36.0]},
        "1984": {"vr": "DS", "Value": [50.0]},
        "1985": {"vr": "DS", "Value": [53.0]},
        "1986": {"vr": "DS", "Value": [62.0]},
        "1987": {"vr": "DS", "Value": [54.0]},
        "1988": {"vr": "DS", "Value": [52.0]},
        "1989": {"vr": "DS", "Value": [32.0]},
        "1990": {"vr": "DS", "Value": [52.0]},
        "1991": {"vr": "DS", "Value": [49.0]},
        "1992": {"vr": "DS", "Value": [29.0]},
        "1993": {"vr": "DS", "Value": [284.0]},
        "1994": {"vr": "DS", "Value": [42.0]},
        "1995": {"vr": "DS", "Value": [49.0]},
        "1996": {"vr": "DS", "Value": [269.0]},
        "1997": {"vr": "DS", "Value": [48.0]},
        "1998": {"vr": "DS", "Value": [38.0]},
        "1999": {"vr": "DS", "Value": [42.0]},
        "2000": {"vr": "DS", "Value": [50.0]},
        "2001": {"vr": "DS", "Value": [301.0]},
        "2002": {"vr": "DS", "Value": [53.0]},
        "2003": {"vr": "DS", "Value": [53.0]},
        "2004": {"vr": "DS", "Value": [51.0]},
        "2005": {"vr": "DS", "Value": [61.0]},
        "2006": {"vr": "DS", "Value": [34.0]},
        "2007": {"vr": "DS", "Value": [25.0]},
        "2008": {"vr": "DS", "Value": [53.0]},
        "2009": {"vr": "DS", "Value": [53.0]},
        "2010": {"vr": "DS", "Value": [51.0]},
        "2011": {"vr": "DS", "Value": [53.0]},
        "2012": {"vr": "DS", "Value": [285.0]},
        "2013": {"vr": "DS", "Value": [38.0]},
        "2014": {"vr": "DS", "Value": [50.0]},
        "2015": {"vr": "DS", "Value": [44.0]},
        "2016": {"vr": "DS", "Value": [51.0]},
        "2017": {"vr": "DS", "Value": [246.0]},
        "2018": {"vr": "DS", "Value": [49.0]},
        "2019": {"vr": "DS", "Value": [45.0]},
        "2020": {"vr": "DS", "Value": [58.0]},
        "2021": {"vr": "DS", "Value": [45.0]},
        "2022": {"vr": "DS", "Value": [48.0]},
        "2023": {"vr": "DS", "Value": [24.0]},
        "2024": {"vr": "DS", "Value": [54.0]},
        "2025": {"vr": "DS", "Value": [315.0]},
        "2026": {"vr": "DS", "Value": [43.0]},
        "2027": {"vr": "DS", "Value": [57.0]},
        "2028": {"vr": "DS", "Value": [51.0]},
        "2029": {"vr": "DS", "Value": [294.0]},
        "2030": {"vr": "DS", "Value": [50.0]},
        "2031": {"vr": "DS", "Value": [27.0]},
        "2032": {"vr": "DS", "Value": [52.0]},
        "2033": {"vr": "DS", "Value": [55.0]},
        "2034": {"vr": "DS", "Value": [56.0]},
        "2035": {"vr": "DS", "Value": [56.0]},
        "2036": {"vr": "DS", "Value": [54.0]},
        "2037": {"vr": "DS", "Value": [39.0]},
        "2038": {"vr": "DS", "Value": [11.0]},
        "2039": {"vr": "DS", "Value": [52.0]},
        "2040": {"vr": "DS", "Value": [45.0]},
        "2041": {"vr": "DS", "Value": [50.0]},
        "2042": {"vr": "DS", "Value": [44.0]},
        "2043": {"vr": "DS", "Value": [55.0]},
        "2044": {"vr": "DS", "Value": [41.0]},
        "2045": {"vr": "DS", "Value": [49.0]},
        "2046": {"vr": "DS", "Value": [50.0]},
        "2047": {"vr": "DS", "Value": [38.0]},
        "2048": {"vr": "DS", "Value": [52.0]},
        "2049": {"vr": "DS", "Value": [51.0]},
        "2050": {"vr": "DS", "Value": [50.0]},
        "2051": {"vr": "DS", "Value": [47.0]},
        "2052": {"vr": "DS", "Value": [27.0]},
        "2053": {"vr": "DS", "Value": [49.0]},
        "2054": {"vr": "DS", "Value": [41.0]},
        "2055": {"vr": "DS", "Value": [55.0]},
        "2056": {"vr": "DS", "Value": [36.0]},
        "2057": {"vr": "DS", "Value": [43.0]},
        "2058": {"vr": "DS", "Value": [57.0]},
        "2059": {"vr": "DS", "Value": [57.0]},
        "2060": {"vr": "DS", "Value": [51.0]},
        "2061": {"vr": "DS", "Value": [48.0]},
        "2062": {"vr": "DS", "Value": [52.0]},
        "2063": {"vr": "DS", "Value": [50.0]},
        "2064": {"vr": "DS", "Value": [266.0]},
        "2065": {"vr": "DS", "Value": [52.0]},
        "2066": {"vr": "DS", "Value": [51.0]},
        "2067": {"vr": "DS", "Value": [56.0]},
        "2068": {"vr": "DS", "Value": [53.0]},
        "2069": {"vr": "DS", "Value": [52.0]},
        "2070": {"vr": "DS", "Value": [57.0]},
        "2071": {"vr": "DS", "Value": [56.0]},
        "2072": {"vr": "DS", "Value": [50.0]},
        "2073": {"vr": "DS", "Value": [50.0]},
        "2074": {"vr": "DS", "Value": [52.0]},
        "2075": {"vr": "DS", "Value": [281.0]},
        "2076": {"vr": "DS", "Value": [38.0]},
        "2077": {"vr": "DS", "Value": [42.0]},
        "2078": {"vr": "DS", "Value": [32.0]},
        "2079": {"vr": "DS", "Value": [273.0]},
        "2080": {"vr": "DS", "Value": [24.0]},
        "2081": {"vr": "DS", "Value": [53.0]},
        "2082": {"vr": "DS", "Value": [284.0]},
        "2083": {"vr": "DS", "Value": [278.0]},
        "2084": {"vr": "DS", "Value": [284.0]},
        "2085": {"vr": "DS", "Value": [48.0]},
        "2086": {"vr": "DS", "Value": [292.0]},
        "2087": {"vr": "DS", "Value": [46.0]},
        "2088": {"vr": "DS", "Value": [53.0]},
        "2089": {"vr": "DS", "Value": [50.0]},
        "2090": {"vr": "DS", "Value": [46.0]},
        "2091": {"vr": "DS", "Value": [56.0]},
        "2092": {"vr": "DS", "Value": [41.0]},
        "2093": {"vr": "DS", "Value": [44.0]},
        "2094": {"vr": "DS", "Value": [26.0]},
        "2095": {"vr": "DS", "Value": [57.0]},
        "2096": {"vr": "DS", "Value": [54.0]},
        "2097": {"vr": "DS", "Value": [50.0]},
        "2098": {"vr": "DS", "Value": [282.0]},
        "2099": {"vr": "DS", "Value": [33.0]},
        "2100": {"vr": "DS", "Value": [24.0]},
        "2101": {"vr": "DS", "Value": [40.0]},
        "2102": {"vr": "DS", "Value": [49.0]},
        "2103": {"vr": "DS", "Value": [54.0]},
        "2104": {"vr": "DS", "Value": [36.0]},
        "2105": {"vr": "DS", "Value": [53.0]},
        "2106": {"vr": "DS", "Value": [12.0]},
        "2107": {"vr": "DS", "Value": [47.0]},
        "2108": {"vr": "DS", "Value": [37.0]},
        "2109": {"vr": "DS", "Value": [222.0]},
        "2110": {"vr": "DS", "Value": [44.0]},
        "2111": {"vr": "DS", "Value": [52.0]},
        "2112": {"vr": "DS", "Value": [23.0]},
        "2113": {"vr": "DS", "Value": [58.0]},
        "2114": {"vr": "DS", "Value": [24.0]},
        "2115": {"vr": "DS", "Value": [27.0]},
        "2116": {"vr": "DS", "Value": [48.0]},
        "2117": {"vr": "DS", "Value": [48.0]},
        "2118": {"vr": "DS", "Value": [54.0]},
        "2119": {"vr": "DS", "Value": [35.0]},
        "2120": {"vr": "DS", "Value": [29.0]},
        "2121": {"vr": "DS", "Value": [61.0]},
        "2122": {"vr": "DS", "Value": [44.0]},
        "2123": {"vr": "DS", "Value": [31.0]},
        "2124": {"vr": "DS", "Value": [53.0]},
        "2125": {"vr": "DS", "Value": [57.0]},
        "2126": {"vr": "DS", "Value": [56.0]},
        "2127": {"vr": "DS", "Value": [49.0]},
        "2128": {"vr": "DS", "Value": [48.0]},
        "2129": {"vr": "DS", "Value": [51.0]},
        "2130": {"vr": "DS", "Value": [47.0]},
        "2131": {"vr": "DS", "Value": [55.0]},
        "2132": {"vr": "DS", "Value": [292.0]},
        "2133": {"vr": "DS", "Value": [27.0]},
        "2134": {"vr": "DS", "Value": [50.0]},
        "2135": {"vr": "DS", "Value": [49.0]},
        "2136": {"vr": "DS", "Value": [47.0]},
        "2137": {"vr": "DS", "Value": [45.0]},
        "2138": {"vr": "DS", "Value": [53.0]},
        "2139": {"vr": "DS", "Value": [30.0]},
        "2140": {"vr": "DS", "Value": [35.0]},
        "2141": {"vr": "DS", "Value": [58.0]},
        "2142": {"vr": "DS", "Value": [54.0]},
        "2143": {"vr": "DS", "Value": [58.0]},
        "2144": {"vr": "DS", "Value": [51.0]},
        "2145": {"vr": "DS", "Value": [60.0]},
        "2146": {"vr": "DS", "Value": [268.0]},
        "2147": {"vr": "DS", "Value": [28.0]},
        "2148": {"vr": "DS", "Value": [39.0]},
        "2149": {"vr": "DS", "Value": [59.0]},
        "2150": {"vr": "DS", "Value": [56.0]},
        "2151": {"vr": "DS", "Value": [36.0]},
        "2152": {"vr": "DS", "Value": [54.0]},
        "2153": {"vr": "DS", "Value": [28.0]},
        "2154": {"vr": "DS", "Value": [60.0]},
        "2155": {"vr": "DS", "Value": [48.0]},
        "2156": {"vr": "DS", "Value": [53.0]},
        "2157": {"vr": "DS", "Value": [47.0]},
        "2158": {"vr": "DS", "Value": [260.0]},
        "2159": {"vr": "DS", "Value": [47.0]},
        "2160": {"vr": "DS", "Value": [34.0]},
        "2161": {"vr": "DS", "Value": [52.0]},
        "2162": {"vr": "DS", "Value": [50.0]},
        "2163": {"vr": "DS", "Value": [52.0]},
        "2164": {"vr": "DS", "Value": [58.0]},
        "2165": {"vr": "DS", "Value": [244.0]},
        "2166": {"vr": "DS", "Value": [51.0]},
        "2167": {"vr": "DS", "Value": [51.0]},
        "2168": {"vr": "DS", "Value": [34.0]},
        "2169": {"vr": "DS", "Value": [48.0]},
        "2170": {"vr": "DS", "Value": [269.0]},
        "2171": {"vr": "DS", "Value": [61.0]},
        "2172": {"vr": "DS", "Value": [52.0]},
        "2173": {"vr": "DS", "Value": [52.0]},
        "2174": {"vr": "DS", "Value": [318.0]},
        "2175": {"vr": "DS", "Value": [61.0]},
        "2176": {"vr": "DS", "Value": [24.0]},
        "2177": {"vr": "DS", "Value": [54.0]},
        "2178": {"vr": "DS", "Value": [35.0]},
        "2179": {"vr": "DS", "Value": [45.0]},
        "2180": {"vr": "DS", "Value": [56.0]},
        "2181": {"vr": "DS", "Value": [43.0]},
        "2182": {"vr": "DS", "Value": [55.0]},
        "2183": {"vr": "DS", "Value": [49.0]},
        "2184": {"vr": "DS", "Value": [47.0]},
        "2185": {"vr": "DS", "Value": [26.0]},
        "2186": {"vr": "DS", "Value": [25.0]},
        "2187": {"vr": "DS", "Value": [262.0]},
        "2188": {"vr": "DS", "Value": [51.0]},
        "2189": {"vr": "DS", "Value": [49.0]},
        "2190": {"vr": "DS", "Value": [50.0]},
        "2191": {"vr": "DS", "Value": [25.0]},
        "2192": {"vr": "DS", "Value": [264.0]},
        "2193": {"vr": "DS", "Value": [27.0]},
        "2194": {"vr": "DS", "Value": [42.0]},
        "2195": {"vr": "DS", "Value": [48.0]},
        "2196": {"vr": "DS", "Value": [54.0]},
        "2197": {"vr": "DS", "Value": [53.0]},
        "2198": {"vr": "DS", "Value": [25.0]},
        "2199": {"vr": "DS", "Value": [43.0]},
        "2200": {"vr": "DS", "Value": [45.0]},
        "2201": {"vr": "DS", "Value": [37.0]},
        "2202": {"vr": "DS", "Value": [33.0]},
        "2203": {"vr": "DS", "Value": [49.0]},
        "2204": {"vr": "DS", "Value": [305.0]},
        "2205": {"vr": "DS", "Value": [46.0]},
        "2206": {"vr": "DS", "Value": [43.0]},
        "2207": {"vr": "DS", "Value": [55.0]},
        "2208": {"vr": "DS", "Value": [56.0]},
        "2209": {"vr": "DS", "Value": [45.0]},
        "2210": {"vr": "DS", "Value": [52.0]},
        "2211": {"vr": "DS", "Value": [35.0]},
        "2212": {"vr": "DS", "Value": [52.0]},
        "2213": {"vr": "DS", "Value": [44.0]},
        "2214": {"vr": "DS", "Value": [52.0]},
        "2215": {"vr": "DS", "Value": [61.0]},
        "2216": {"vr": "DS", "Value": [51.0]},
        "2217": {"vr": "DS", "Value": [56.0]},
        "2218": {"vr": "DS", "Value": [58.0]},
        "2219": {"vr": "DS", "Value": [26.0]},
        "2220": {"vr": "DS", "Value": [266.0]},
        "2221": {"vr": "DS", "Value": [26.0]},
        "2222": {"vr": "DS", "Value": [48.0]},
        "2223": {"vr": "DS", "Value": [31.0]},
        "2224": {"vr": "DS", "Value": [45.0]},
        "2225": {"vr": "DS", "Value": [25.0]},
        "2226": {"vr": "DS", "Value": [50.0]},
        "2227": {"vr": "DS", "Value": [56.0]},
        "2228": {"vr": "DS", "Value": [59.0]},
        "2229": {"vr": "DS", "Value": [23.0]},
        "2230": {"vr": "DS", "Value": [24.0]},
        "2231": {"vr": "DS", "Value": [20.0]},
        "2232": {"vr": "DS", "Value": [61.0]},
        "2233": {"vr": "DS", "Value": [54.0]},
        "2234": {"vr": "DS", "Value": [53.0]},
        "2235": {"vr": "DS", "Value": [54.0]},
        "2236": {"vr": "DS", "Value": [43.0]},
        "2237": {"vr": "DS", "Value": [53.0]},
        "2238": {"vr": "DS", "Value": [37.0]},
        "2239": {"vr": "DS", "Value": [258.0]},
        "2240": {"vr": "DS", "Value": [56.0]},
        "2241": {"vr": "DS", "Value": [23.0]},
        "2242": {"vr": "DS", "Value": [48.0]},
        "2243": {"vr": "DS", "Value": [51.0]},
        "2244": {"vr": "DS", "Value": [53.0]},
        "2245": {"vr": "DS", "Value": [49.0]},
        "2246": {"vr": "DS", "Value": [48.0]},
        "2247": {"vr": "DS", "Value": [32.0]},
        "2248": {"vr": "DS", "Value": [56.0]},
        "2249": {"vr": "DS", "Value": [41.0]},
        "2250": {"vr": "DS", "Value": [26.0]},
        "2251": {"vr": "DS", "Value": [59.0]},
        "2252": {"vr": "DS", "Value": [38.0]},
        "2253": {"vr": "DS", "Value": [51.0]},
        "2254": {"vr": "DS", "Value": [292.0]},
        "2255": {"vr": "DS", "Value": [25.0]},
        "2256": {"vr": "DS", "Value": [41.0]},
        "2257": {"vr": "DS", "Value": [32.0]},
        "2258": {"vr": "DS", "Value": [55.0]},
        "2259": {"vr": "DS", "Value": [264.0]},
        "2260": {"vr": "DS", "Value": [41.0]},
        "2261": {"vr": "DS", "Value": [48.0]},
        "2262": {"vr": "DS", "Value": [31.0]},
        "2263": {"vr": "DS", "Value": [240.0]},
        "2264": {"vr": "DS", "Value": [47.0]},
        "2265": {"vr": "DS", "Value": [53.0]},
        "2266": {"vr": "DS", "Value": [52.0]},
        "2267": {"vr": "DS", "Value": [28.0]},
        "2268": {"vr": "DS", "Value": [25.0]},
        "2269": {"vr": "DS", "Value": [39.0]},
        "2270": {"vr": "DS", "Value": [42.0]},
        "2271": {"vr": "DS", "Value": [54.0]},
        "2272": {"vr": "DS", "Value": [41.0]},
        "2273": {"vr": "DS", "Value": [31.0]},
        "2274": {"vr": "DS", "Value": [54.0]},
        "2275": {"vr": "DS", "Value": [52.0]},
        "2276": {"vr": "DS", "Value": [45.0]},
        "2277": {"vr": "DS", "Value": [31.0]},
        "2278": {"vr": "DS", "Value": [269.0]},
        "2279": {"vr": "DS", "Value": [52.0]},
        "2280": {"vr": "DS", "Value": [44.0]},
        "2281": {"vr": "DS", "Value": [27.0]},
        "2282": {"vr": "DS", "Value": [49.0]},
        "2283": {"vr": "DS", "Value": [60.0]},
        "2284": {"vr": "DS", "Value": [41.0]},
        "2285": {"vr": "DS", "Value": [45.0]},
        "2286": {"vr": "DS", "Value": [52.0]},
        "2287": {"vr": "DS", "Value": [51.0]},
        "2288": {"vr": "DS", "Value": [30.0]},
        "2289": {"vr": "DS", "Value": [50.0]},
        "2290": {"vr": "DS", "Value": [56.0]},
        "2291": {"vr": "DS", "Value": [282.0]},
        "2292": {"vr": "DS", "Value": [55.0]},
        "2293": {"vr": "DS", "Value": [52.0]},
        "2294": {"vr": "DS", "Value": [53.0]},
        "2295": {"vr": "DS", "Value": [323.0]},
        "2296": {"vr": "DS", "Value": [261.0]},
        "2297": {"vr": "DS", "Value": [52.0]},
        "2298": {"vr": "DS", "Value": [27.0]},
        "2299": {"vr": "DS", "Value": [33.0]},
        "2300": {"vr": "DS", "Value": [56.0]},
        "2301": {"vr": "DS", "Value": [49.0]},
        "2302": {"vr": "DS", "Value": [53.0]},
        "2303": {"vr": "DS", "Value": [53.0]},
        "2304": {"vr": "DS", "Value": [52.0]},
        "2305": {"vr": "DS", "Value": [24.0]},
        "2306": {"vr": "DS", "Value": [41.0]},
        "2307": {"vr": "DS", "Value": [50.0]},
        "2308": {"vr": "DS", "Value": [32.0]},
        "2309": {"vr": "DS", "Value": [31.0]},
        "2310": {"vr": "DS", "Value": [39.0]},
        "2311": {"vr": "DS", "Value": [46.0]},
        "2312": {"vr": "DS", "Value": [27.0]},
        "2313": {"vr": "DS", "Value": [294.0]},
        "2314": {"vr": "DS", "Value": [34.0]},
        "2315": {"vr": "DS", "Value": [34.0]},
        "2316": {"vr": "DS", "Value": [54.0]},
        "2317": {"vr": "DS", "Value": [54.0]},
        "2318": {"vr": "DS", "Value": [36.0]},
        "2319": {"vr": "DS", "Value": [60.0]},
        "2320": {"vr": "DS", "Value": [36.0]},
        "2321": {"vr": "DS", "Value": [48.0]},
        "2322": {"vr": "DS", "Value": [49.0]},
        "2323": {"vr": "DS", "Value": [56.0]},
        "2324": {"vr": "DS", "Value": [36.0]},
        "2325": {"vr": "DS", "Value": [50.0]},
        "2326": {"vr": "DS", "Value": [51.0]},
        "2327": {"vr": "DS", "Value": [38.0]},
        "2328": {"vr": "DS", "Value": [50.0]},
        "2329": {"vr": "DS", "Value": [33.0]},
        "2330": {"vr": "DS", "Value": [49.0]},
        "2331": {"vr": "DS", "Value": [52.0]},
        "2332": {"vr": "DS", "Value": [29.0]},
        "2333": {"vr": "DS", "Value": [58.0]},
        "2334": {"vr": "DS", "Value": [53.0]},
        "2335": {"vr": "DS", "Value": [24.0]},
        "2336": {"vr": "DS", "Value": [48.0]},
        "2337": {"vr": "DS", "Value": [45.0]},
        "2338": {"vr": "DS", "Value": [38.0]},
        "2339": {"vr": "DS", "Value": [50.0]},
        "2340": {"vr": "DS", "Value": [266.0]},
        "2341": {"vr": "DS", "Value": [45.0]},
        "2342": {"vr": "DS", "Value": [53.0]},
        "2343": {"vr": "DS", "Value": [53.0]},
        "2344": {"vr": "DS", "Value": [52.0]},
        "2345": {"vr": "DS", "Value": [50.0]},
        "2346": {"vr": "DS", "Value": [283.0]},
        "2347": {"vr": "DS", "Value": [63.0]},
        "2348": {"vr": "DS", "Value": [43.0]},
        "2349": {"vr": "DS", "Value": [43.0]},
        "2350": {"vr": "DS", "Value": [56.0]},
        "2351": {"vr": "DS", "Value": [47.0]},
        "2352": {"vr": "DS", "Value": [54.0]},
        "2353": {"vr": "DS", "Value": [49.0]},
        "2354": {"vr": "DS", "Value": [57.0]},
        "2355": {"vr": "DS", "Value": [41.0]},
        "2356": {"vr": "DS", "Value": [45.0]},
        "2357": {"vr": "DS", "Value": [56.0]},
        "2358": {"vr": "DS", "Value": [50.0]},
        "2359": {"vr": "DS", "Value": [58.0]},
        "2360": {"vr": "DS", "Value": [303.0]},
        "2361": {"vr": "DS", "Value": [51.0]},
        "2362": {"vr": "DS", "Value": [52.0]},
        "2363": {"vr": "DS", "Value": [59.0]},
        "2364": {"vr": "DS", "Value": [26.0]},
        "2365": {"vr": "DS", "Value": [53.0]},
        "2366": {"vr": "DS", "Value": [53.0]},
        "2367": {"vr": "DS", "Value": [54.0]},
        "2368": {"vr": "DS", "Value": [52.0]},
        "2369": {"vr": "DS", "Value": [297.0]},
        "2370": {"vr": "DS", "Value": [55.0]},
        "2371": {"vr": "DS", "Value": [53.0]},
        "2372": {"vr": "DS", "Value": [23.0]},
        "2373": {"vr": "DS", "Value": [55.0]},
        "2374": {"vr": "DS", "Value": [26.0]},
        "2375": {"vr": "DS", "Value": [35.0]},
        "2376": {"vr": "DS", "Value": [274.0]},
        "2377": {"vr": "DS", "Value": [54.0]},
        "2378": {"vr": "DS", "Value": [11.0]},
        "2379": {"vr": "DS", "Value": [54.0]},
        "2380": {"vr": "DS", "Value": [37.0]},
        "2381": {"vr": "DS", "Value": [251.0]},
        "2382": {"vr": "DS", "Value": [285.0]},
        "2383": {"vr": "DS", "Value": [40.0]},
        "2384": {"vr": "DS", "Value": [49.0]},
        "2385": {"vr": "DS", "Value": [268.0]},
        "2386": {"vr": "DS", "Value": [25.0]},
        "2387": {"vr": "DS", "Value": [53.0]},
        "2388": {"vr": "DS", "Value": [26.0]},
        "2389": {"vr": "DS", "Value": [44.0]},
        "2390": {"vr": "DS", "Value": [53.0]},
        "2391": {"vr": "DS", "Value": [22.0]},
        "2392": {"vr": "DS", "Value": [44.0]},
        "2393": {"vr": "DS", "Value": [50.0]},
        "2394": {"vr": "DS", "Value": [279.0]},
        "2395": {"vr": "DS", "Value": [27.0]},
        "2396": {"vr": "DS", "Value": [42.0]},
        "2397": {"vr": "DS", "Value": [47.0]},
        "2398": {"vr": "DS", "Value": [53.0]},
        "2399": {"vr": "DS", "Value": [51.0]},
        "2400": {"vr": "DS", "Value": [296.0]},
        "2401": {"vr": "DS", "Value": [26.0]},
        "2402": {"vr": "DS", "Value": [54.0]},
        "2403": {"vr": "DS", "Value": [55.0]},
        "2404": {"vr": "DS", "Value": [54.0]},
        "2405": {"vr": "DS", "Value": [56.0]},
        "2406": {"vr": "DS", "Value": [42.0]},
        "2407": {"vr": "DS", "Value": [47.0]},
        "2408": {"vr": "DS", "Value": [46.0]},
        "2409": {"vr": "DS", "Value": [43.0]},
        "2410": {"vr": "DS", "Value": [55.0]},
        "2411": {"vr": "DS", "Value": [54.0]},
        "2412": {"vr": "DS", "Value": [38.0]},
        "2413": {"vr": "DS", "Value": [46.0]},
        "2414": {"vr": "DS", "Value": [40.0]},
        "2415": {"vr": "DS", "Value": [23.0]},
        "2416": {"vr": "DS", "Value": [55.0]},
        "2417": {"vr": "DS", "Value": [285.0]},
        "2418": {"vr": "DS", "Value": [227.0]},
        "2419": {"vr": "DS", "Value": [25.0]},
        "2420": {"vr": "DS", "Value": [46.0]},
        "2421": {"vr": "DS", "Value": [48.0]},
        "2422": {"vr": "DS", "Value": [49.0]},
        "2423": {"vr": "DS", "Value": [29.0]},
        "2424": {"vr": "DS", "Value": [43.0]},
        "2425": {"vr": "DS", "Value": [45.0]},
        "2426": {"vr": "DS", "Value": [57.0]},
        "2427": {"vr": "DS", "Value": [47.0]},
        "2428": {"vr": "DS", "Value": [44.0]},
        "2429": {"vr": "DS", "Value": [53.0]},
        "2430": {"vr": "DS", "Value": [51.0]},
        "2431": {"vr": "DS", "Value": [47.0]},
        "2432": {"vr": "DS", "Value": [44.0]},
        "2433": {"vr": "DS", "Value": [258.0]},
        "2434": {"vr": "DS", "Value": [36.0]},
        "2435": {"vr": "DS", "Value": [29.0]},
        "2436": {"vr": "DS", "Value": [46.0]},
        "2437": {"vr": "DS", "Value": [53.0]},
        "2438": {"vr": "DS", "Value": [48.0]},
        "2439": {"vr": "DS", "Value": [51.0]},
        "2440": {"vr": "DS", "Value": [53.0]},
        "2441": {"vr": "DS", "Value": [53.0]},
        "2442": {"vr": "DS", "Value": [24.0]},
        "2443": {"vr": "DS", "Value": [55.0]},
        "2444": {"vr": "DS", "Value": [51.0]},
        "2445": {"vr": "DS", "Value": [56.0]},
        "2446": {"vr": "DS", "Value": [49.0]},
        "2447": {"vr": "DS", "Value": [44.0]},
        "2448": {"vr": "DS", "Value": [55.0]},
        "2449": {"vr": "DS", "Value": [37.0]},
        "2450": {"vr": "DS", "Value": [52.0]},
        "2451": {"vr": "DS", "Value": [50.0]},
        "2452": {"vr": "DS", "Value": [53.0]},
        "2453": {"vr": "DS", "Value": [51.0]},
        "2454": {"vr": "DS", "Value": [54.0]},
        "2455": {"vr": "DS", "Value": [23.0]},
        "2456": {"vr": "DS", "Value": [45.0]},
        "2457": {"vr": "DS", "Value": [53.0]},
        "2458": {"vr": "DS", "Value": [50.0]},
        "2459": {"vr": "DS", "Value": [46.0]},
        "2460": {"vr": "DS", "Value": [54.0]},
        "2461": {"vr": "DS", "Value": [53.0]},
        "2462": {"vr": "DS", "Value": [51.0]},
        "2463": {"vr": "DS", "Value": [54.0]},
        "2464": {"vr": "DS", "Value": [46.0]},
        "2465": {"vr": "DS", "Value": [46.0]},
        "2466": {"vr": "DS", "Value": [23.0]},
        "2467": {"vr": "DS", "Value": [45.0]},
        "2468": {"vr": "DS", "Value": [52.0]},
        "2469": {"vr": "DS", "Value": [58.0]},
        "2470": {"vr": "DS", "Value": [42.0]},
        "2471": {"vr": "DS", "Value": [56.0]},
        "2472": {"vr": "DS", "Value": [55.0]},
        "2473": {"vr": "DS", "Value": [34.0]},
        "2474": {"vr": "DS", "Value": [24.0]},
        "2475": {"vr": "DS", "Value": [10.0]},
        "2476": {"vr": "DS", "Value": [61.0]},
        "2477": {"vr": "DS", "Value": [55.0]},
        "2478": {"vr": "DS", "Value": [55.0]},
        "2479": {"vr": "DS", "Value": [265.0]},
        "2480": {"vr": "DS", "Value": [144.0]},
        "2481": {"vr": "DS", "Value": [53.0]},
        "2482": {"vr": "DS", "Value": [40.0]},
        "2483": {"vr": "DS", "Value": [55.0]},
        "2484": {"vr": "DS", "Value": [26.0]},
        "2485": {"vr": "DS", "Value": [54.0]},
        "2486": {"vr": "DS", "Value": [48.0]},
        "2487": {"vr": "DS", "Value": [26.0]},
        "2488": {"vr": "DS", "Value": [28.0]},
        "2489": {"vr": "DS", "Value": [52.0]},
        "2490": {"vr": "DS", "Value": [55.0]},
        "2491": {"vr": "DS", "Value": [52.0]},
        "2492": {"vr": "DS", "Value": [54.0]},
        "2493": {"vr": "DS", "Value": [56.0]},
        "2494": {"vr": "DS", "Value": [36.0]},
        "2495": {"vr": "DS", "Value": [54.0]},
        "2496": {"vr": "DS", "Value": [49.0]},
        "2497": {"vr": "DS", "Value": [54.0]},
        "2498": {"vr": "DS", "Value": [51.0]},
        "2499": {"vr": "DS", "Value": [52.0]},
        "2500": {"vr": "DS", "Value": [55.0]},
        "2501": {"vr": "DS", "Value": [20.0]},
        "2502": {"vr": "DS", "Value": [50.0]},
        "2503": {"vr": "DS", "Value": [59.0]},
        "2504": {"vr": "DS", "Value": [49.0]},
        "2505": {"vr": "DS", "Value": [26.0]},
        "2506": {"vr": "DS", "Value": [33.0]},
        "2507": {"vr": "DS", "Value": [56.0]},
        "2508": {"vr": "DS", "Value": [54.0]},
        "2509": {"vr": "DS", "Value": [43.0]},
        "2510": {"vr": "DS", "Value": [25.0]},
        "2511": {"vr": "DS", "Value": [54.0]},
        "2512": {"vr": "DS", "Value": [53.0]},
        "2513": {"vr": "DS", "Value": [53.0]},
        "2514": {"vr": "DS", "Value": [42.0]},
        "2515": {"vr": "DS", "Value": [40.0]},
        "2516": {"vr": "DS", "Value": [48.0]},
        "2517": {"vr": "DS", "Value": [37.0]},
        "2518": {"vr": "DS", "Value": [49.0]},
        "2519": {"vr": "DS", "Value": [50.0]},
        "2520": {"vr": "DS", "Value": [316.0]},
        "2521": {"vr": "DS", "Value": [57.0]},
        "2522": {"vr": "DS", "Value": [261.0]},
        "2523": {"vr": "DS", "Value": [51.0]},
        "2524": {"vr": "DS", "Value": [48.0]},
        "2525": {"vr": "DS", "Value": [269.0]},
        "2526": {"vr": "DS", "Value": [49.0]},
        "2527": {"vr": "DS", "Value": [37.0]},
        "2528": {"vr": "DS", "Value": [31.0]},
        "2529": {"vr": "DS", "Value": [57.0]},
        "2530": {"vr": "DS", "Value": [24.0]},
        "2531": {"vr": "DS", "Value": [26.0]},
        "2532": {"vr": "DS", "Value": [54.0]},
        "2533": {"vr": "DS", "Value": [20.0]},
        "2534": {"vr": "DS", "Value": [313.0]},
        "2535": {"vr": "DS", "Value": [52.0]},
        "2536": {"vr": "DS", "Value": [29.0]},
        "2537": {"vr": "DS", "Value": [311.0]},
        "2538": {"vr": "DS", "Value": [37.0]},
        "2539": {"vr": "DS", "Value": [255.0]},
        "2540": {"vr": "DS", "Value": [53.0]},
        "2541": {"vr": "DS", "Value": [12.0]},
        "2542": {"vr": "DS", "Value": [54.0]},
        "2543": {"vr": "DS", "Value": [45.0]},
        "2544": {"vr": "DS", "Value": [37.0]},
        "2545": {"vr": "DS", "Value": [52.0]},
        "2546": {"vr": "DS", "Value": [278.0]},
        "2547": {"vr": "DS", "Value": [51.0]},
        "2548": {"vr": "DS", "Value": [267.0]},
        "2549": {"vr": "DS", "Value": [25.0]},
        "2550": {"vr": "DS", "Value": [51.0]},
        "2551": {"vr": "DS", "Value": [50.0]},
        "2552": {"vr": "DS", "Value": [55.0]},
        "2553": {"vr": "DS", "Value": [42.0]},
        "2554": {"vr": "DS", "Value": [55.0]},
        "2555": {"vr": "DS", "Value": [46.0]},
        "2556": {"vr": "DS", "Value": [24.0]},
        "2557": {"vr": "DS", "Value": [283.0]},
        "2558": {"vr": "DS", "Value": [26.0]},
        "2559": {"vr": "DS", "Value": [33.0]},
        "2560": {"vr": "DS", "Value": [58.0]},
        "2561": {"vr": "DS", "Value": [48.0]},
        "2562": {"vr": "DS", "Value": [48.0]},
        "2563": {"vr": "DS", "Value": [53.0]},
        "2564": {"vr": "DS", "Value": [54.0]},
        "2565": {"vr": "DS", "Value": [53.0]},
        "2566": {"vr": "DS", "Value": [57.0]},
        "2567": {"vr": "DS", "Value": [43.0]},
        "2568": {"vr": "DS", "Value": [47.0]},
        "2569": {"vr": "DS", "Value": [48.0]},
        "2570": {"vr": "DS", "Value": [51.0]},
        "2571": {"vr": "DS", "Value": [318.0]},
        "2572": {"vr": "DS", "Value": [336.0]},
        "2573": {"vr": "DS", "Value": [54.0]},
        "2574": {"vr": "DS", "Value": [50.0]},
        "2575": {"vr": "DS", "Value": [42.0]},
        "2576": {"vr": "DS", "Value": [24.0]},
        "2577": {"vr": "DS", "Value": [49.0]},
        "2578": {"vr": "DS", "Value": [49.0]},
        "2579": {"vr": "DS", "Value": [47.0]},
        "2580": {"vr": "DS", "Value": [57.0]},
        "2581": {"vr": "DS", "Value": [47.0]},
        "2582": {"vr": "DS", "Value": [25.0]},
        "2583": {"vr": "DS", "Value": [51.0]},
        "2584": {"vr": "DS", "Value": [286.0]},
        "2585": {"vr": "DS", "Value": [317.0]},
        "2586": {"vr": "DS", "Value": [22.0]},
        "2587": {"vr": "DS", "Value": [43.0]},
        "2588": {"vr": "DS", "Value": [51.0]},
        "2589": {"vr": "DS", "Value": [54.0]},
        "2590": {"vr": "DS", "Value": [51.0]},
        "2591": {"vr": "DS", "Value": [46.0]},
        "2592": {"vr": "DS", "Value": [58.0]},
        "2593": {"vr": "DS", "Value": [22.0]},
        "2594": {"vr": "DS", "Value": [45.0]},
        "2595": {"vr": "DS", "Value": [52.0]},
        "2596": {"vr": "DS", "Value": [26.0]},
        "2597": {"vr": "DS", "Value": [26.0]},
        "2598": {"vr": "DS", "Value": [45.0]},
        "2599": {"vr": "DS", "Value": [40.0]},
        "2600": {"vr": "DS", "Value": [56.0]},
        "2601": {"vr": "DS", "Value": [51.0]},
        "2602": {"vr": "DS", "Value": [52.0]},
        "2603": {"vr": "DS", "Value": [43.0]},
        "2604": {"vr": "DS", "Value": [53.0]},
        "2605": {"vr": "DS", "Value": [55.0]},
        "2606": {"vr": "DS", "Value": [53.0]},
        "2607": {"vr": "DS", "Value": [27.0]},
        "2608": {"vr": "DS", "Value": [42.0]},
        "2609": {"vr": "DS", "Value": [289.0]},
        "2610": {"vr": "DS", "Value": [56.0]},
        "2611": {"vr": "DS", "Value": [263.0]},
        "2612": {"vr": "DS", "Value": [52.0]},
        "2613": {"vr": "DS", "Value": [54.0]},
        "2614": {"vr": "DS", "Value": [53.0]},
        "2615": {"vr": "DS", "Value": [43.0]},
        "2616": {"vr": "DS", "Value": [49.0]},
        "2617": {"vr": "DS", "Value": [53.0]},
        "2618": {"vr": "DS", "Value": [229.0]},
        "2619": {"vr": "DS", "Value": [63.0]},
        "2620": {"vr": "DS", "Value": [39.0]},
        "2621": {"vr": "DS", "Value": [51.0]},
        "2622": {"vr": "DS", "Value": [55.0]},
        "2623": {"vr": "DS", "Value": [52.0]},
        "2624": {"vr": "DS", "Value": [45.0]},
        "2625": {"vr": "DS", "Value": [56.0]},
        "2626": {"vr": "DS", "Value": [59.0]},
        "2627": {"vr": "DS", "Value": [44.0]},
        "2628": {"vr": "DS", "Value": [265.0]},
        "2629": {"vr": "DS", "Value": [304.0]},
        "2630": {"vr": "DS", "Value": [43.0]},
        "2631": {"vr": "DS", "Value": [53.0]},
        "2632": {"vr": "DS", "Value": [43.0]},
        "2633": {"vr": "DS", "Value": [52.0]},
        "2634": {"vr": "DS", "Value": [35.0]},
        "2635": {"vr": "DS", "Value": [54.0]},
        "2636": {"vr": "DS", "Value": [230.0]},
        "2637": {"vr": "DS", "Value": [54.0]},
        "2638": {"vr": "DS", "Value": [54.0]},
        "2639": {"vr": "DS", "Value": [288.0]},
        "2640": {"vr": "DS", "Value": [283.0]},
        "2641": {"vr": "DS", "Value": [35.0]},
        "2642": {"vr": "DS", "Value": [48.0]},
        "2643": {"vr": "DS", "Value": [37.0]},
        "2644": {"vr": "DS", "Value": [44.0]},
        "2645": {"vr": "DS", "Value": [44.0]},
        "2646": {"vr": "DS", "Value": [54.0]},
        "2647": {"vr": "DS", "Value": [48.0]},
        "2648": {"vr": "DS", "Value": [24.0]},
        "2649": {"vr": "DS", "Value": [37.0]},
        "2650": {"vr": "DS", "Value": [45.0]},
        "2651": {"vr": "DS", "Value": [25.0]},
        "2652": {"vr": "DS", "Value": [45.0]},
        "2653": {"vr": "DS", "Value": [48.0]},
        "2654": {"vr": "DS", "Value": [55.0]},
        "2655": {"vr": "DS", "Value": [57.0]},
        "2656": {"vr": "DS", "Value": [54.0]},
        "2657": {"vr": "DS", "Value": [43.0]},
        "2658": {"vr": "DS", "Value": [300.0]},
        "2659": {"vr": "DS", "Value": [44.0]},
        "2660": {"vr": "DS", "Value": [59.0]},
        "2661": {"vr": "DS", "Value": [26.0]},
        "2662": {"vr": "DS", "Value": [51.0]},
        "2663": {"vr": "DS", "Value": [48.0]},
        "2664": {"vr": "DS", "Value": [52.0]},
        "2665": {"vr": "DS", "Value": [26.0]},
        "2666": {"vr": "DS", "Value": [50.0]},
        "2667": {"vr": "DS", "Value": [52.0]},
        "2668": {"vr": "DS", "Value": [27.0]},
        "2669": {"vr": "DS", "Value": [44.0]},
        "2670": {"vr": "DS", "Value": [51.0]},
        "2671": {"vr": "DS", "Value": [44.0]},
        "2672": {"vr": "DS", "Value": [26.0]},
        "2673": {"vr": "DS", "Value": [45.0]},
        "2674": {"vr": "DS", "Value": [32.0]},
        "2675": {"vr": "DS", "Value": [55.0]},
        "2676": {"vr": "DS", "Value": [50.0]},
        "2677": {"vr": "DS", "Value": [60.0]},
        "2678": {"vr": "DS", "Value": [55.0]},
        "2679": {"vr": "DS", "Value": [285.0]},
        "2680": {"vr": "DS", "Value": [57.0]},
        "2681": {"vr": "DS", "Value": [52.0]},
        "2682": {"vr": "DS", "Value": [55.0]},
        "2683": {"vr": "DS", "Value": [55.0]},
        "2684": {"vr": "DS", "Value": [50.0]},
        "2685": {"vr": "DS", "Value": [55.0]},
        "2686": {"vr": "DS", "Value": [50.0]},
        "2687": {"vr": "DS", "Value": [53.0]},
        "2688": {"vr": "DS", "Value": [52.0]},
        "2689": {"vr": "DS", "Value": [54.0]},
        "2690": {"vr": "DS", "Value": [52.0]},
        "2691": {"vr": "DS", "Value": [49.0]},
        "2692": {"vr": "DS", "Value": [46.0]},
        "2693": {"vr": "DS", "Value": [55.0]},
        "2694": {"vr": "DS", "Value": [37.0]},
        "2695": {"vr": "DS", "Value": [38.0]},
        "2696": {"vr": "DS", "Value": [54.0]},
        "2697": {"vr": "DS", "Value": [12.0]},
        "2698": {"vr": "DS", "Value": [36.0]},
        "2699": {"vr": "DS", "Value": [50.0]},
        "2700": {"vr": "DS", "Value": [47.0]},
        "2701": {"vr": "DS", "Value": [54.0]},
        "2702": {"vr": "DS", "Value": [79.0]},
        "2703": {"vr": "DS", "Value": [56.0]},
        "2704": {"vr": "DS", "Value": [59.0]},
        "2705": {"vr": "DS", "Value": [50.0]},
        "2706": {"vr": "DS", "Value": [47.0]},
        "2707": {"vr": "DS", "Value": [37.0]},
        "2708": {"vr": "DS", "Value": [44.0]},
        "2709": {"vr": "DS", "Value": [48.0]},
        "2710": {"vr": "DS", "Value": [43.0]},
        "2711": {"vr": "DS", "Value": [52.0]},
        "2712": {"vr": "DS", "Value": [47.0]},
        "2713": {"vr": "DS", "Value": [46.0]},
        "2714": {"vr": "DS", "Value": [24.0]},
        "2715": {"vr": "DS", "Value": [46.0]},
        "2716": {"vr": "DS", "Value": [42.0]},
        "2717": {"vr": "DS", "Value": [53.0]},
        "2718": {"vr": "DS", "Value": [47.0]},
        "2719": {"vr": "DS", "Value": [62.0]},
        "2720": {"vr": "DS", "Value": [36.0]},
        "2721": {"vr": "DS", "Value": [50.0]},
        "2722": {"vr": "DS", "Value": [58.0]},
        "2723": {"vr": "DS", "Value": [48.0]},
        "2724": {"vr": "DS", "Value": [56.0]},
        "2725": {"vr": "DS", "Value": [46.0]},
        "2726": {"vr": "DS", "Value": [271.0]},
        "2727": {"vr": "DS", "Value": [57.0]},
        "2728": {"vr": "DS", "Value": [49.0]},
        "2729": {"vr": "DS", "Value": [25.0]},
        "2730": {"vr": "DS", "Value": [55.0]},
        "2731": {"vr": "DS", "Value": [27.0]},
        "2732": {"vr": "DS", "Value": [56.0]},
        "2733": {"vr": "DS", "Value": [51.0]},
        "2734": {"vr": "DS", "Value": [24.0]},
        "2735": {"vr": "DS", "Value": [35.0]},
        "2736": {"vr": "DS", "Value": [283.0]},
        "2737": {"vr": "DS", "Value": [43.0]},
        "2738": {"vr": "DS", "Value": [41.0]},
        "2739": {"vr": "DS", "Value": [27.0]},
        "2740": {"vr": "DS", "Value": [55.0]},
        "2741": {"vr": "DS", "Value": [265.0]},
        "2742": {"vr": "DS", "Value": [57.0]},
        "2743": {"vr": "DS", "Value": [53.0]},
        "2744": {"vr": "DS", "Value": [53.0]},
        "2745": {"vr": "DS", "Value": [43.0]},
        "2746": {"vr": "DS", "Value": [302.0]},
        "2747": {"vr": "DS", "Value": [55.0]},
        "2748": {"vr": "DS", "Value": [29.0]},
        "2749": {"vr": "DS", "Value": [28.0]},
        "2750": {"vr": "DS", "Value": [285.0]},
        "2751": {"vr": "DS", "Value": [51.0]},
        "2752": {"vr": "DS", "Value": [34.0]},
        "2753": {"vr": "DS", "Value": [57.0]},
        "2754": {"vr": "DS", "Value": [26.0]},
        "2755": {"vr": "DS", "Value": [56.0]},
        "2756": {"vr": "DS", "Value": [27.0]},
        "2757": {"vr": "DS", "Value": [295.0]},
        "2758": {"vr": "DS", "Value": [44.0]},
        "2759": {"vr": "DS", "Value": [54.0]},
        "2760": {"vr": "DS", "Value": [52.0]},
        "2761": {"vr": "DS", "Value": [40.0]},
        "2762": {"vr": "DS", "Value": [55.0]},
        "2763": {"vr": "DS", "Value": [25.0]},
        "2764": {"vr": "DS", "Value": [45.0]},
        "2765": {"vr": "DS", "Value": [239.0]},
        "2766": {"vr": "DS", "Value": [60.0]},
        "2767": {"vr": "DS", "Value": [53.0]},
        "2768": {"vr": "DS", "Value": [56.0]},
        "2769": {"vr": "DS", "Value": [43.0]},
        "2770": {"vr": "DS", "Value": [263.0]},
        "2771": {"vr": "DS", "Value": [25.0]},
        "2772": {"vr": "DS", "Value": [50.0]},
        "2773": {"vr": "DS", "Value": [43.0]},
        "2774": {"vr": "DS", "Value": [38.0]},
        "2775": {"vr": "DS", "Value": [49.0]},
        "2776": {"vr": "DS", "Value": [52.0]},
        "2777": {"vr": "DS", "Value": [263.0]},
        "2778": {"vr": "DS", "Value": [50.0]},
        "2779": {"vr": "DS", "Value": [50.0]},
        "2780": {"vr": "DS", "Value": [23.0]},
        "2781": {"vr": "DS", "Value": [286.0]},
        "2782": {"vr": "DS", "Value": [49.0]},
        "2783": {"vr": "DS", "Value": [23.0]},
        "2784": {"vr": "DS", "Value": [22.0]},
        "2785": {"vr": "DS", "Value": [48.0]},
        "2786": {"vr": "DS", "Value": [50.0]},
        "2787": {"vr": "DS", "Value": [53.0]},
        "2788": {"vr": "DS", "Value": [38.0]},
        "2789": {"vr": "DS", "Value": [52.0]},
        "2790": {"vr": "DS", "Value": [52.0]},
        "2791": {"vr": "DS", "Value": [53.0]},
        "2792": {"vr": "DS", "Value": [265.0]},
        "2793": {"vr": "DS", "Value": [36.0]},
        "2794": {"vr": "DS", "Value": [53.0]},
        "2795": {"vr": "DS", "Value": [34.0]},
        "2796": {"vr": "DS", "Value": [26.0]},
        "2797": {"vr": "DS", "Value": [293.0]},
        "2798": {"vr": "DS", "Value": [49.0]},
        "2799": {"vr": "DS", "Value": [40.0]},
        "2800": {"vr": "DS", "Value": [48.0]},
        "2801": {"vr": "DS", "Value": [11.0]},
        "2802": {"vr": "DS", "Value": [41.0]},
        "2803": {"vr": "DS", "Value": [53.0]},
        "2804": {"vr": "DS", "Value": [40.0]},
        "2805": {"vr": "DS", "Value": [25.0]},
        "2806": {"vr": "DS", "Value": [37.0]},
        "2807": {"vr": "DS", "Value": [52.0]},
        "2808": {"vr": "DS", "Value": [44.0]},
        "2809": {"vr": "DS", "Value": [36.0]},
        "2810": {"vr": "DS", "Value": [49.0]},
        "2811": {"vr": "DS", "Value": [26.0]},
        "2812": {"vr": "DS", "Value": [56.0]},
        "2813": {"vr": "DS", "Value": [51.0]},
        "2814": {"vr": "DS", "Value": [49.0]},
        "2815": {"vr": "DS", "Value": [25.0]},
        "2816": {"vr": "DS", "Value": [54.0]},
        "2817": {"vr": "DS", "Value": [53.0]},
        "2818": {"vr": "DS", "Value": [314.0]},
        "2819": {"vr": "DS", "Value": [42.0]},
        "2820": {"vr": "DS", "Value": [51.0]},
        "2821": {"vr": "DS", "Value": [55.0]},
        "2822": {"vr": "DS", "Value": [249.0]},
        "2823": {"vr": "DS", "Value": [33.0]},
        "2824": {"vr": "DS", "Value": [23.0]},
        "2825": {"vr": "DS", "Value": [40.0]},
        "2826": {"vr": "DS", "Value": [46.0]},
        "2827": {"vr": "DS", "Value": [24.0]},
        "2828": {"vr": "DS", "Value": [26.0]},
        "2829": {"vr": "DS", "Value": [36.0]},
        "2830": {"vr": "DS", "Value": [309.0]},
        "2831": {"vr": "DS", "Value": [42.0]},
        "2832": {"vr": "DS", "Value": [44.0]},
        "2833": {"vr": "DS", "Value": [26.0]},
        "2834": {"vr": "DS", "Value": [52.0]},
        "2835": {"vr": "DS", "Value": [52.0]},
        "2836": {"vr": "DS", "Value": [57.0]},
        "2837": {"vr": "DS", "Value": [49.0]},
        "2838": {"vr": "DS", "Value": [52.0]},
        "2839": {"vr": "DS", "Value": [48.0]},
        "2840": {"vr": "DS", "Value": [44.0]},
        "2841": {"vr": "DS", "Value": [60.0]},
        "2842": {"vr": "DS", "Value": [52.0]},
        "2843": {"vr": "DS", "Value": [43.0]},
        "2844": {"vr": "DS", "Value": [54.0]},
        "2845": {"vr": "DS", "Value": [39.0]},
        "2846": {"vr": "DS", "Value": [55.0]},
        "2847": {"vr": "DS", "Value": [54.0]},
        "2848": {"vr": "DS", "Value": [25.0]},
        "2849": {"vr": "DS", "Value": [26.0]},
        "2850": {"vr": "DS", "Value": [56.0]},
        "2851": {"vr": "DS", "Value": [50.0]},
        "2852": {"vr": "DS", "Value": [228.0]},
        "2853": {"vr": "DS", "Value": [45.0]},
        "2854": {"vr": "DS", "Value": [39.0]},
        "2855": {"vr": "DS", "Value": [255.0]},
        "2856": {"vr": "DS", "Value": [57.0]},
        "2857": {"vr": "DS", "Value": [43.0]},
        "2858": {"vr": "DS", "Value": [38.0]},
        "2859": {"vr": "DS", "Value": [51.0]},
        "2860": {"vr": "DS", "Value": [25.0]},
        "2861": {"vr": "DS", "Value": [26.0]},
        "2862": {"vr": "DS", "Value": [276.0]},
        "2863": {"vr": "DS", "Value": [62.0]},
        "2864": {"vr": "DS", "Value": [53.0]},
        "2865": {"vr": "DS", "Value": [54.0]},
        "2866": {"vr": "DS", "Value": [41.0]},
        "2867": {"vr": "DS", "Value": [26.0]},
        "2868": {"vr": "DS", "Value": [55.0]},
        "2869": {"vr": "DS", "Value": [51.0]},
        "2870": {"vr": "DS", "Value": [24.0]},
        "2871": {"vr": "DS", "Value": [57.0]},
        "2872": {"vr": "DS", "Value": [29.0]},
        "2873": {"vr": "DS", "Value": [56.0]},
        "2874": {"vr": "DS", "Value": [53.0]},
        "2875": {"vr": "DS", "Value": [54.0]},
        "2876": {"vr": "DS", "Value": [50.0]},
        "2877": {"vr": "DS", "Value": [56.0]},
        "2878": {"vr": "DS", "Value": [267.0]},
        "2879": {"vr": "DS", "Value": [53.0]},
        "2880": {"vr": "DS", "Value": [48.0]},
        "2881": {"vr": "DS", "Value": [49.0]},
        "2882": {"vr": "DS", "Value": [297.0]},
        "2883": {"vr": "DS", "Value": [55.0]},
        "2884": {"vr": "DS", "Value": [47.0]},
        "2885": {"vr": "DS", "Value": [53.0]},
        "2886": {"vr": "DS", "Value": [40.0]},
        "2887": {"vr": "DS", "Value": [38.0]},
        "2888": {"vr": "DS", "Value": [26.0]},
        "2889": {"vr": "DS", "Value": [50.0]},
        "2890": {"vr": "DS", "Value": [39.0]},
        "2891": {"vr": "DS", "Value": [58.0]},
        "2892": {"vr": "DS", "Value": [47.0]},
        "2893": {"vr": "DS", "Value": [50.0]},
        "2894": {"vr": "DS", "Value": [23.0]},
        "2895": {"vr": "DS", "Value": [52.0]},
        "2896": {"vr": "DS", "Value": [46.0]},
        "2897": {"vr": "DS", "Value": [43.0]},
        "2898": {"vr": "DS", "Value": [52.0]},
        "2899": {"vr": "DS", "Value": [44.0]},
        "2900": {"vr": "DS", "Value": [56.0]},
        "2901": {"vr": "DS", "Value": [54.0]},
        "2902": {"vr": "DS", "Value": [50.0]},
        "2903": {"vr": "DS", "Value": [56.0]},
        "2904": {"vr": "DS", "Value": [39.0]},
        "2905": {"vr": "DS", "Value": [43.0]},
        "2906": {"vr": "DS", "Value": [263.0]},
        "2907": {"vr": "DS", "Value": [289.0]},
        "2908": {"vr": "DS", "Value": [42.0]},
        "2909": {"vr": "DS", "Value": [59.0]},
        "2910": {"vr": "DS", "Value": [40.0]},
        "2911": {"vr": "DS", "Value": [43.0]},
        "2912": {"vr": "DS", "Value": [53.0]},
        "2913": {"vr": "DS", "Value": [45.0]},
        "2914": {"vr": "DS", "Value": [58.0]},
        "2915": {"vr": "DS", "Value": [32.0]},
        "2916": {"vr": "DS", "Value": [261.0]},
        "2917": {"vr": "DS", "Value": [24.0]},
        "2918": {"vr": "DS", "Value": [286.0]},
        "2919": {"vr": "DS", "Value": [271.0]},
        "2920": {"vr": "DS", "Value": [54.0]},
        "2921": {"vr": "DS", "Value": [45.0]},
        "2922": {"vr": "DS", "Value": [23.0]},
        "2923": {"vr": "DS", "Value": [270.0]},
        "2924": {"vr": "DS", "Value": [46.0]},
        "2925": {"vr": "DS", "Value": [11.0]},
        "2926": {"vr": "DS", "Value": [48.0]},
        "2927": {"vr": "DS", "Value": [56.0]},
        "2928": {"vr": "DS", "Value": [50.0]},
        "2929": {"vr": "DS", "Value": [46.0]},
        "2930": {"vr": "DS", "Value": [262.0]},
        "2931": {"vr": "DS", "Value": [50.0]},
        "2932": {"vr": "DS", "Value": [54.0]},
        "2933": {"vr": "DS", "Value": [52.0]},
        "2934": {"vr": "DS", "Value": [40.0]},
        "2935": {"vr": "DS", "Value": [77.0]},
        "2936": {"vr": "DS", "Value": [20.0]},
        "2937": {"vr": "DS", "Value": [40.0]},
        "2938": {"vr": "DS", "Value": [65.0]},
        "2939": {"vr": "DS", "Value": [53.0]},
        "2940": {"vr": "DS", "Value": [48.0]},
        "2941": {"vr": "DS", "Value": [54.0]},
        "2942": {"vr": "DS", "Value": [48.0]},
        "2943": {"vr": "DS", "Value": [52.0]},
        "2944": {"vr": "DS", "Value": [56.0]},
        "2945": {"vr": "DS", "Value": [56.0]},
        "2946": {"vr": "DS", "Value": [288.0]},
        "2947": {"vr": "DS", "Value": [56.0]},
        "2948": {"vr": "DS", "Value": [30.0]},
        "2949": {"vr": "DS", "Value": [237.0]},
        "2950": {"vr": "DS", "Value": [29.0]},
        "2951": {"vr": "DS", "Value": [51.0]},
        "2952": {"vr": "DS", "Value": [60.0]},
        "2953": {"vr": "DS", "Value": [24.0]},
        "2954": {"vr": "DS", "Value": [278.0]},
        "2955": {"vr": "DS", "Value": [337.0]},
        "2956": {"vr": "DS", "Value": [55.0]},
        "2957": {"vr": "DS", "Value": [50.0]},
        "2958": {"vr": "DS", "Value": [24.0]},
        "2959": {"vr": "DS", "Value": [58.0]},
        "2960": {"vr": "DS", "Value": [53.0]},
        "2961": {"vr": "DS", "Value": [44.0]},
        "2962": {"vr": "DS", "Value": [41.0]},
        "2963": {"vr": "DS", "Value": [47.0]},
        "2964": {"vr": "DS", "Value": [52.0]},
        "2965": {"vr": "DS", "Value": [46.0]},
        "2966": {"vr": "DS", "Value": [45.0]},
        "2967": {"vr": "DS", "Value": [48.0]},
        "2968": {"vr": "DS", "Value": [270.0]},
        "2969": {"vr": "DS", "Value": [51.0]},
        "2970": {"vr": "DS", "Value": [57.0]},
        "2971": {"vr": "DS", "Value": [50.0]},
        "2972": {"vr": "DS", "Value": [50.0]},
        "2973": {"vr": "DS", "Value": [49.0]},
        "2974": {"vr": "DS", "Value": [54.0]},
        "2975": {"vr": "DS", "Value": [51.0]},
        "2976": {"vr": "DS", "Value": [52.0]},
        "2977": {"vr": "DS", "Value": [53.0]},
        "2978": {"vr": "DS", "Value": [45.0]},
        "2979": {"vr": "DS", "Value": [27.0]},
        "2980": {"vr": "DS", "Value": [52.0]},
        "2981": {"vr": "DS", "Value": [50.0]},
        "2982": {"vr": "DS", "Value": [57.0]},
        "2983": {"vr": "DS", "Value": [55.0]},
        "2984": {"vr": "DS", "Value": [43.0]},
        "2985": {"vr": "DS", "Value": [311.0]},
        "2986": {"vr": "DS", "Value": [55.0]},
        "2987": {"vr": "DS", "Value": [34.0]},
        "2988": {"vr": "DS", "Value": [56.0]},
        "2989": {"vr": "DS", "Value": [37.0]},
        "2990": {"vr": "DS", "Value": [38.0]},
        "2991": {"vr": "DS", "Value": [46.0]},
        "2992": {"vr": "DS", "Value": [56.0]},
        "2993": {"vr": "DS", "Value": [40.0]},
        "2994": {"vr": "DS", "Value": [51.0]},
        "2995": {"vr": "DS", "Value": [24.0]},
        "2996": {"vr": "DS", "Value": [58.0]},
        "2997": {"vr": "DS", "Value": [54.0]},
        "2998": {"vr": "DS", "Value": [55.0]},
        "2999": {"vr": "DS", "Value": [38.0]},
        "3000": {"vr": "DS", "Value": [54.0]},
        "3001": {"vr": "DS", "Value": [53.0]},
        "3002": {"vr": "DS", "Value": [59.0]},
        "3003": {"vr": "DS", "Value": [48.0]},
        "3004": {"vr": "DS", "Value": [51.0]},
        "3005": {"vr": "DS", "Value": [289.0]},
        "3006": {"vr": "DS", "Value": [36.0]},
        "3007": {"vr": "DS", "Value": [57.0]},
        "3008": {"vr": "DS", "Value": [39.0]},
        "3009": {"vr": "DS", "Value": [54.0]},
        "3010": {"vr": "DS", "Value": [53.0]},
        "3011": {"vr": "DS", "Value": [49.0]},
        "3012": {"vr": "DS", "Value": [55.0]},
        "3013": {"vr": "DS", "Value": [48.0]},
        "3014": {"vr": "DS", "Value": [36.0]},
        "3015": {"vr": "DS", "Value": [54.0]},
        "3016": {"vr": "DS", "Value": [48.0]},
        "3017": {"vr": "DS", "Value": [50.0]},
        "3018": {"vr": "DS", "Value": [55.0]},
        "3019": {"vr": "DS", "Value": [247.0]},
        "3020": {"vr": "DS", "Value": [46.0]},
        "3021": {"vr": "DS", "Value": [40.0]},
        "3022": {"vr": "DS", "Value": [47.0]},
        "3023": {"vr": "DS", "Value": [39.0]},
        "3024": {"vr": "DS", "Value": [54.0]},
        "3025": {"vr": "DS", "Value": [32.0]},
        "3026": {"vr": "DS", "Value": [53.0]},
        "3027": {"vr": "DS", "Value": [46.0]},
        "3028": {"vr": "DS", "Value": [46.0]},
        "3029": {"vr": "DS", "Value": [299.0]},
        "3030": {"vr": "DS", "Value": [65.0]},
        "3031": {"vr": "DS", "Value": [31.0]},
        "3032": {"vr": "DS", "Value": [53.0]},
        "3033": {"vr": "DS", "Value": [47.0]},
        "3034": {"vr": "DS", "Value": [44.0]},
        "3035": {"vr": "DS", "Value": [36.0]},
        "3036": {"vr": "DS", "Value": [48.0]},
        "3037": {"vr": "DS", "Value": [46.0]},
        "3038": {"vr": "DS", "Value": [41.0]},
        "3039": {"vr": "DS", "Value": [35.0]},
        "3040": {"vr": "DS", "Value": [49.0]},
        "3041": {"vr": "DS", "Value": [48.0]},
        "3042": {"vr": "DS", "Value": [41.0]},
        "3043": {"vr": "DS", "Value": [50.0]},
        "3044": {"vr": "DS", "Value": [49.0]},
        "3045": {"vr": "DS", "Value": [53.0]},
        "3046": {"vr": "DS", "Value": [48.0]},
        "3047": {"vr": "DS", "Value": [52.0]},
        "3048": {"vr": "DS", "Value": [34.0]},
        "3049": {"vr": "DS", "Value": [38.0]},
        "3050": {"vr": "DS", "Value": [38.0]},
        "3051": {"vr": "DS", "Value": [44.0]},
        "3052": {"vr": "DS", "Value": [55.0]},
        "3053": {"vr": "DS", "Value": [246.0]},
        "3054": {"vr": "DS", "Value": [48.0]},
        "3055": {"vr": "DS", "Value": [56.0]},
        "3056": {"vr": "DS", "Value": [56.0]},
        "3057": {"vr": "DS", "Value": [34.0]},
        "3058": {"vr": "DS", "Value": [30.0]},
        "3059": {"vr": "DS", "Value": [24.0]},
        "3060": {"vr": "DS", "Value": [55.0]},
        "3061": {"vr": "DS", "Value": [26.0]},
        "3062": {"vr": "DS", "Value": [55.0]},
        "3063": {"vr": "DS", "Value": [50.0]},
        "3064": {"vr": "DS", "Value": [43.0]},
        "3065": {"vr": "DS", "Value": [51.0]},
        "3066": {"vr": "DS", "Value": [53.0]},
        "3067": {"vr": "DS", "Value": [50.0]},
        "3068": {"vr": "DS", "Value": [41.0]},
        "3069": {"vr": "DS", "Value": [45.0]},
        "3070": {"vr": "DS", "Value": [37.0]},
        "3071": {"vr": "DS", "Value": [51.0]},
        "3072": {"vr": "DS", "Value": [266.0]},
        "3073": {"vr": "DS", "Value": [26.0]},
        "3074": {"vr": "DS", "Value": [297.0]},
        "3075": {"vr": "DS", "Value": [49.0]},
        "3076": {"vr": "DS", "Value": [48.0]},
        "3077": {"vr": "DS", "Value": [270.0]},
        "3078": {"vr": "DS", "Value": [38.0]},
        "3079": {"vr": "DS", "Value": [55.0]},
        "3080": {"vr": "DS", "Value": [52.0]},
        "3081": {"vr": "DS", "Value": [52.0]},
        "3082": {"vr": "DS", "Value": [43.0]},
        "3083": {"vr": "DS", "Value": [51.0]},
        "3084": {"vr": "DS", "Value": [56.0]},
        "3085": {"vr": "DS", "Value": [48.0]},
        "3086": {"vr": "DS", "Value": [50.0]},
        "3087": {"vr": "DS", "Value": [37.0]},
        "3088": {"vr": "DS", "Value": [43.0]},
        "3089": {"vr": "DS", "Value": [270.0]},
        "3090": {"vr": "DS", "Value": [35.0]},
        "3091": {"vr": "DS", "Value": [54.0]},
        "3092": {"vr": "DS", "Value": [268.0]},
        "3093": {"vr": "DS", "Value": [53.0]},
        "3094": {"vr": "DS", "Value": [35.0]},
        "3095": {"vr": "DS", "Value": [41.0]},
        "3096": {"vr": "DS", "Value": [42.0]},
        "3097": {"vr": "DS", "Value": [38.0]},
        "3098": {"vr": "DS", "Value": [58.0]},
        "3099": {"vr": "DS", "Value": [49.0]},
        "3100": {"vr": "DS", "Value": [50.0]},
        "3101": {"vr": "DS", "Value": [48.0]},
        "3102": {"vr": "DS", "Value": [299.0]},
        "3103": {"vr": "DS", "Value": [60.0]},
        "3104": {"vr": "DS", "Value": [50.0]},
        "3105": {"vr": "DS", "Value": [24.0]},
        "3106": {"vr": "DS", "Value": [52.0]},
        "3107": {"vr": "DS", "Value": [25.0]},
        "3108": {"vr": "DS", "Value": [51.0]},
        "3109": {"vr": "DS", "Value": [51.0]},
        "3110": {"vr": "DS", "Value": [51.0]},
        "3111": {"vr": "DS", "Value": [52.0]},
        "3112": {"vr": "DS", "Value": [53.0]},
        "3113": {"vr": "DS", "Value": [20.0]},
        "3114": {"vr": "DS", "Value": [50.0]},
        "3115": {"vr": "DS", "Value": [39.0]},
        "3116": {"vr": "DS", "Value": [37.0]},
        "3117": {"vr": "DS", "Value": [48.0]},
        "3118": {"vr": "DS", "Value": [57.0]},
        "3119": {"vr": "DS", "Value": [56.0]},
        "3120": {"vr": "DS", "Value": [53.0]},
        "3121": {"vr": "DS", "Value": [23.0]},
        "3122": {"vr": "DS", "Value": [55.0]},
        "3123": {"vr": "DS", "Value": [26.0]},
        "3124": {"vr": "DS", "Value": [51.0]},
        "3125": {"vr": "DS", "Value": [56.0]},
        "3126": {"vr": "DS", "Value": [52.0]},
        "3127": {"vr": "DS", "Value": [53.0]},
        "3128": {"vr": "DS", "Value": [29.0]},
        "3129": {"vr": "DS", "Value": [52.0]},
        "3130": {"vr": "DS", "Value": [54.0]},
        "3131": {"vr": "DS", "Value": [43.0]},
        "3132": {"vr": "DS", "Value": [283.0]},
        "3133": {"vr": "DS", "Value": [55.0]},
        "3134": {"vr": "DS", "Value": [45.0]},
        "3135": {"vr": "DS", "Value": [51.0]},
        "3136": {"vr": "DS", "Value": [49.0]},
        "3137": {"vr": "DS", "Value": [50.0]},
        "3138": {"vr": "DS", "Value": [42.0]},
        "3139": {"vr": "DS", "Value": [54.0]},
        "3140": {"vr": "DS", "Value": [39.0]},
        "3141": {"vr": "DS", "Value": [44.0]},
        "3142": {"vr": "DS", "Value": [41.0]},
        "3143": {"vr": "DS", "Value": [54.0]},
        "3144": {"vr": "DS", "Value": [47.0]},
        "3145": {"vr": "DS", "Value": [41.0]},
        "3146": {"vr": "DS", "Value": [48.0]},
        "3147": {"vr": "DS", "Value": [52.0]},
        "3148": {"vr": "DS", "Value": [55.0]},
        "3149": {"vr": "DS", "Value": [10.0]},
        "3150": {"vr": "DS", "Value": [32.0]},
        "3151": {"vr": "DS", "Value": [50.0]},
        "3152": {"vr": "DS", "Value": [50.0]},
        "3153": {"vr": "DS", "Value": [43.0]},
        "3154": {"vr": "DS", "Value": [40.0]},
        "3155": {"vr": "DS", "Value": [61.0]},
        "3156": {"vr": "DS", "Value": [34.0]},
        "3157": {"vr": "DS", "Value": [27.0]},
        "3158": {"vr": "DS", "Value": [50.0]},
        "3159": {"vr": "DS", "Value": [49.0]},
        "3160": {"vr": "DS", "Value": [280.0]},
        "3161": {"vr": "DS", "Value": [52.0]},
        "3162": {"vr": "DS", "Value": [49.0]},
        "3163": {"vr": "DS", "Value": [47.0]},
        "3164": {"vr": "DS", "Value": [44.0]},
        "3165": {"vr": "DS", "Value": [257.0]},
        "3166": {"vr": "DS", "Value": [48.0]},
        "3167": {"vr": "DS", "Value": [57.0]},
        "3168": {"vr": "DS", "Value": [52.0]},
        "3169": {"vr": "DS", "Value": [26.0]},
        "3170": {"vr": "DS", "Value": [25.0]},
        "3171": {"vr": "DS", "Value": [56.0]},
        "3172": {"vr": "DS", "Value": [259.0]},
        "3173": {"vr": "DS", "Value": [12.0]},
        "3174": {"vr": "DS", "Value": [26.0]},
        "3175": {"vr": "DS", "Value": [58.0]},
        "3176": {"vr": "DS", "Value": [35.0]},
        "3177": {"vr": "DS", "Value": [42.0]},
        "3178": {"vr": "DS", "Value": [25.0]},
        "3179": {"vr": "DS", "Value": [34.0]},
        "3180": {"vr": "DS", "Value": [40.0]},
        "3181": {"vr": "DS", "Value": [50.0]},
        "3182": {"vr": "DS", "Value": [54.0]},
        "3183": {"vr": "DS", "Value": [51.0]},
        "3184": {"vr": "DS", "Value": [40.0]},
        "3185": {"vr": "DS", "Value": [53.0]},
        "3186": {"vr": "DS", "Value": [49.0]},
        "3187": {"vr": "DS", "Value": [54.0]},
        "3188": {"vr": "DS", "Value": [49.0]},
        "3189": {"vr": "DS", "Value": [9.0]},
        "3190": {"vr": "DS", "Value": [51.0]},
        "3191": {"vr": "DS", "Value": [47.0]},
        "3192": {"vr": "DS", "Value": [10.0]},
        "3193": {"vr": "DS", "Value": [303.0]},
        "3194": {"vr": "DS", "Value": [300.0]},
        "3195": {"vr": "DS", "Value": [42.0]},
        "3196": {"vr": "DS", "Value": [56.0]},
        "3197": {"vr": "DS", "Value": [36.0]},
        "3198": {"vr": "DS", "Value": [45.0]},
        "3199": {"vr": "DS", "Value": [52.0]},
        "3200": {"vr": "DS", "Value": [53.0]},
        "3201": {"vr": "DS", "Value": [54.0]},
        "3202": {"vr": "DS", "Value": [50.0]},
        "3203": {"vr": "DS", "Value": [26.0]},
        "3204": {"vr": "DS", "Value": [52.0]},
        "3205": {"vr": "DS", "Value": [53.0]},
        "3206": {"vr": "DS", "Value": [47.0]},
        "3207": {"vr": "DS", "Value": [44.0]},
        "3208": {"vr": "DS", "Value": [55.0]},
        "3209": {"vr": "DS", "Value": [24.0]},
        "3210": {"vr": "DS", "Value": [49.0]},
        "3211": {"vr": "DS", "Value": [50.0]},
        "3212": {"vr": "DS", "Value": [27.0]},
        "3213": {"vr": "DS", "Value": [53.0]},
        "3214": {"vr": "DS", "Value": [57.0]},
        "3215": {"vr": "DS", "Value": [54.0]},
        "3216": {"vr": "DS", "Value": [26.0]},
        "3217": {"vr": "DS", "Value": [54.0]},
        "3218": {"vr": "DS", "Value": [280.0]},
        "3219": {"vr": "DS", "Value": [60.0]},
        "3220": {"vr": "DS", "Value": [45.0]},
        "3221": {"vr": "DS", "Value": [53.0]},
        "3222": {"vr": "DS", "Value": [37.0]},
        "3223": {"vr": "DS", "Value": [39.0]},
        "3224": {"vr": "DS", "Value": [8.0]},
        "3225": {"vr": "DS", "Value": [52.0]},
        "3226": {"vr": "DS", "Value": [55.0]},
        "3227": {"vr": "DS", "Value": [55.0]},
        "3228": {"vr": "DS", "Value": [57.0]},
        "3229": {"vr": "DS", "Value": [50.0]},
        "3230": {"vr": "DS", "Value": [237.0]},
        "3231": {"vr": "DS", "Value": [49.0]},
        "3232": {"vr": "DS", "Value": [48.0]},
        "3233": {"vr": "DS", "Value": [50.0]},
        "3234": {"vr": "DS", "Value": [52.0]},
        "3235": {"vr": "DS", "Value": [48.0]},
        "3236": {"vr": "DS", "Value": [49.0]},
        "3237": {"vr": "DS", "Value": [26.0]},
        "3238": {"vr": "DS", "Value": [31.0]},
        "3239": {"vr": "DS", "Value": [50.0]},
        "3240": {"vr": "DS", "Value": [51.0]},
        "3241": {"vr": "DS", "Value": [56.0]},
        "3242": {"vr": "DS", "Value": [49.0]},
        "3243": {"vr": "DS", "Value": [278.0]},
        "3244": {"vr": "DS", "Value": [54.0]},
        "3245": {"vr": "DS", "Value": [41.0]},
        "3246": {"vr": "DS", "Value": [42.0]},
        "3247": {"vr": "DS", "Value": [53.0]},
        "3248": {"vr": "DS", "Value": [52.0]},
        "3249": {"vr": "DS", "Value": [35.0]},
        "3250": {"vr": "DS", "Value": [49.0]},
        "3251": {"vr": "DS", "Value": [52.0]},
        "3252": {"vr": "DS", "Value": [52.0]},
        "3253": {"vr": "DS", "Value": [55.0]},
        "3254": {"vr": "DS", "Value": [36.0]},
        "3255": {"vr": "DS", "Value": [50.0]},
        "3256": {"vr": "DS", "Value": [276.0]},
        "3257": {"vr": "DS", "Value": [51.0]},
        "3258": {"vr": "DS", "Value": [286.0]},
        "3259": {"vr": "DS", "Value": [54.0]},
        "3260": {"vr": "DS", "Value": [56.0]},
        "3261": {"vr": "DS", "Value": [41.0]},
        "3262": {"vr": "DS", "Value": [53.0]},
        "3263": {"vr": "DS", "Value": [48.0]},
        "3264": {"vr": "DS", "Value": [295.0]},
        "3265": {"vr": "DS", "Value": [51.0]},
        "3266": {"vr": "DS", "Value": [54.0]},
        "3267": {"vr": "DS", "Value": [40.0]},
        "3268": {"vr": "DS", "Value": [27.0]},
        "3269": {"vr": "DS", "Value": [48.0]},
        "3270": {"vr": "DS", "Value": [272.0]},
        "3271": {"vr": "DS", "Value": [36.0]},
        "3272": {"vr": "DS", "Value": [53.0]},
        "3273": {"vr": "DS", "Value": [53.0]},
        "3274": {"vr": "DS", "Value": [52.0]},
        "3275": {"vr": "DS", "Value": [53.0]},
        "3276": {"vr": "DS", "Value": [36.0]},
        "3277": {"vr": "DS", "Value": [50.0]},
        "3278": {"vr": "DS", "Value": [30.0]},
        "3279": {"vr": "DS", "Value": [44.0]},
        "3280": {"vr": "DS", "Value": [261.0]},
        "3281": {"vr": "DS", "Value": [55.0]},
        "3282": {"vr": "DS", "Value": [52.0]},
        "3283": {"vr": "DS", "Value": [42.0]},
        "3284": {"vr": "DS", "Value": [55.0]},
        "3285": {"vr": "DS", "Value": [50.0]},
        "3286": {"vr": "DS", "Value": [49.0]},
        "3287": {"vr": "DS", "Value": [52.0]},
        "3288": {"vr": "DS", "Value": [49.0]},
        "3289": {"vr": "DS", "Value": [26.0]},
        "3290": {"vr": "DS", "Value": [40.0]},
        "3291": {"vr": "DS", "Value": [26.0]},
        "3292": {"vr": "DS", "Value": [47.0]},
        "3293": {"vr": "DS", "Value": [25.0]},
        "3294": {"vr": "DS", "Value": [51.0]},
        "3295": {"vr": "DS", "Value": [61.0]},
        "3296": {"vr": "DS", "Value": [53.0]},
        "3297": {"vr": "DS", "Value": [29.0]},
        "3298": {"vr": "DS", "Value": [45.0]},
        "3299": {"vr": "DS", "Value": [25.0]},
        "3300": {"vr": "DS", "Value": [23.0]},
        "3301": {"vr": "DS", "Value": [24.0]},
        "3302": {"vr": "DS", "Value": [56.0]},
        "3303": {"vr": "DS", "Value": [25.0]},
        "3304": {"vr": "DS", "Value": [51.0]},
        "3305": {"vr": "DS", "Value": [55.0]},
        "3306": {"vr": "DS", "Value": [49.0]},
        "3307": {"vr": "DS", "Value": [26.0]},
        "3308": {"vr": "DS", "Value": [49.0]},
        "3309": {"vr": "DS", "Value": [50.0]},
        "3310": {"vr": "DS", "Value": [51.0]},
        "3311": {"vr": "DS", "Value": [49.0]},
        "3312": {"vr": "DS", "Value": [28.0]},
        "3313": {"vr": "DS", "Value": [47.0]},
        "3314": {"vr": "DS", "Value": [28.0]},
        "3315": {"vr": "DS", "Value": [56.0]},
        "3316": {"vr": "DS", "Value": [23.0]},
        "3317": {"vr": "DS", "Value": [61.0]},
        "3318": {"vr": "DS", "Value": [50.0]},
        "3319": {"vr": "DS", "Value": [47.0]},
        "3320": {"vr": "DS", "Value": [25.0]},
        "3321": {"vr": "DS", "Value": [53.0]},
        "3322": {"vr": "DS", "Value": [48.0]},
        "3323": {"vr": "DS", "Value": [25.0]},
        "3324": {"vr": "DS", "Value": [32.0]},
        "3325": {"vr": "DS", "Value": [49.0]},
        "3326": {"vr": "DS", "Value": [46.0]},
        "3327": {"vr": "DS", "Value": [50.0]},
        "3328": {"vr": "DS", "Value": [258.0]},
        "3329": {"vr": "DS", "Value": [41.0]},
        "3330": {"vr": "DS", "Value": [45.0]},
        "3331": {"vr": "DS", "Value": [53.0]},
        "3332": {"vr": "DS", "Value": [54.0]},
        "3333": {"vr": "DS", "Value": [49.0]},
        "3334": {"vr": "DS", "Value": [57.0]},
        "3335": {"vr": "DS", "Value": [57.0]},
        "3336": {"vr": "DS", "Value": [31.0]},
        "3337": {"vr": "DS", "Value": [35.0]},
        "3338": {"vr": "DS", "Value": [50.0]},
        "3339": {"vr": "DS", "Value": [51.0]},
        "3340": {"vr": "DS", "Value": [34.0]},
        "3341": {"vr": "DS", "Value": [52.0]},
        "3342": {"vr": "DS", "Value": [54.0]},
        "3343": {"vr": "DS", "Value": [56.0]},
        "3344": {"vr": "DS", "Value": [54.0]},
        "3345": {"vr": "DS", "Value": [52.0]},
        "3346": {"vr": "DS", "Value": [54.0]},
        "3347": {"vr": "DS", "Value": [301.0]},
        "3348": {"vr": "DS", "Value": [53.0]},
        "3349": {"vr": "DS", "Value": [52.0]},
        "3350": {"vr": "DS", "Value": [36.0]},
        "3351": {"vr": "DS", "Value": [49.0]},
        "3352": {"vr": "DS", "Value": [49.0]},
        "3353": {"vr": "DS", "Value": [37.0]},
        "3354": {"vr": "DS", "Value": [26.0]},
        "3355": {"vr": "DS", "Value": [20.0]},
        "3356": {"vr": "DS", "Value": [43.0]},
        "3357": {"vr": "DS", "Value": [51.0]},
        "3358": {"vr": "DS", "Value": [52.0]},
        "3359": {"vr": "DS", "Value": [56.0]},
        "3360": {"vr": "DS", "Value": [52.0]},
        "3361": {"vr": "DS", "Value": [54.0]},
        "3362": {"vr": "DS", "Value": [43.0]},
        "3363": {"vr": "DS", "Value": [24.0]},
        "3364": {"vr": "DS", "Value": [47.0]},
        "3365": {"vr": "DS", "Value": [316.0]},
        "3366": {"vr": "DS", "Value": [58.0]},
        "3367": {"vr": "DS", "Value": [51.0]},
        "3368": {"vr": "DS", "Value": [51.0]},
        "3369": {"vr": "DS", "Value": [38.0]},
        "3370": {"vr": "DS", "Value": [51.0]},
        "3371": {"vr": "DS", "Value": [51.0]},
        "3372": {"vr": "DS", "Value": [53.0]},
        "3373": {"vr": "DS", "Value": [49.0]},
        "3374": {"vr": "DS", "Value": [50.0]},
        "3375": {"vr": "DS", "Value": [54.0]},
        "3376": {"vr": "DS", "Value": [57.0]},
        "3377": {"vr": "DS", "Value": [53.0]},
        "3378": {"vr": "DS", "Value": [26.0]},
        "3379": {"vr": "DS", "Value": [52.0]},
        "3380": {"vr": "DS", "Value": [56.0]},
        "3381": {"vr": "DS", "Value": [57.0]},
        "3382": {"vr": "DS", "Value": [52.0]},
        "3383": {"vr": "DS", "Value": [54.0]},
        "3384": {"vr": "DS", "Value": [274.0]},
        "3385": {"vr": "DS", "Value": [52.0]},
        "3386": {"vr": "DS", "Value": [53.0]},
        "3387": {"vr": "DS", "Value": [55.0]},
        "3388": {"vr": "DS", "Value": [53.0]},
        "3389": {"vr": "DS", "Value": [271.0]},
        "3390": {"vr": "DS", "Value": [51.0]},
        "3391": {"vr": "DS", "Value": [51.0]},
        "3392": {"vr": "DS", "Value": [48.0]},
        "3393": {"vr": "DS", "Value": [47.0]},
        "3394": {"vr": "DS", "Value": [50.0]},
        "3395": {"vr": "DS", "Value": [51.0]},
        "3396": {"vr": "DS", "Value": [27.0]},
        "3397": {"vr": "DS", "Value": [55.0]},
        "3398": {"vr": "DS", "Value": [44.0]},
        "3399": {"vr": "DS", "Value": [56.0]},
        "3400": {"vr": "DS", "Value": [49.0]},
        "3401": {"vr": "DS", "Value": [43.0]},
        "3402": {"vr": "DS", "Value": [37.0]},
        "3403": {"vr": "DS", "Value": [51.0]},
        "3404": {"vr": "DS", "Value": [52.0]},
        "3405": {"vr": "DS", "Value": [244.0]},
        "3406": {"vr": "DS", "Value": [52.0]},
        "3407": {"vr": "DS", "Value": [53.0]},
        "3408": {"vr": "DS", "Value": [52.0]},
        "3409": {"vr": "DS", "Value": [32.0]},
        "3410": {"vr": "DS", "Value": [50.0]},
        "3411": {"vr": "DS", "Value": [27.0]},
        "3412": {"vr": "DS", "Value": [34.0]},
        "3413": {"vr": "DS", "Value": [52.0]},
        "3414": {"vr": "DS", "Value": [47.0]},
        "3415": {"vr": "DS", "Value": [60.0]},
        "3416": {"vr": "DS", "Value": [46.0]},
        "3417": {"vr": "DS", "Value": [23.0]},
        "3418": {"vr": "DS", "Value": [61.0]},
        "3419": {"vr": "DS", "Value": [51.0]},
        "3420": {"vr": "DS", "Value": [57.0]},
        "3421": {"vr": "DS", "Value": [32.0]},
        "3422": {"vr": "DS", "Value": [49.0]},
        "3423": {"vr": "DS", "Value": [58.0]},
        "3424": {"vr": "DS", "Value": [41.0]},
        "3425": {"vr": "DS", "Value": [51.0]},
        "3426": {"vr": "DS", "Value": [46.0]},
        "3427": {"vr": "DS", "Value": [25.0]},
        "3428": {"vr": "DS", "Value": [26.0]},
        "3429": {"vr": "DS", "Value": [57.0]},
        "3430": {"vr": "DS", "Value": [38.0]},
        "3431": {"vr": "DS", "Value": [316.0]},
        "3432": {"vr": "DS", "Value": [38.0]},
        "3433": {"vr": "DS", "Value": [49.0]},
        "3434": {"vr": "DS", "Value": [41.0]},
        "3435": {"vr": "DS", "Value": [26.0]},
        "3436": {"vr": "DS", "Value": [310.0]},
        "3437": {"vr": "DS", "Value": [51.0]},
        "3438": {"vr": "DS", "Value": [55.0]},
        "3439": {"vr": "DS", "Value": [52.0]},
        "3440": {"vr": "DS", "Value": [54.0]},
        "3441": {"vr": "DS", "Value": [38.0]},
        "3442": {"vr": "DS", "Value": [52.0]},
        "3443": {"vr": "DS", "Value": [58.0]},
        "3444": {"vr": "DS", "Value": [38.0]},
        "3445": {"vr": "DS", "Value": [27.0]},
        "3446": {"vr": "DS", "Value": [283.0]},
        "3447": {"vr": "DS", "Value": [36.0]},
        "3448": {"vr": "DS", "Value": [37.0]},
        "3449": {"vr": "DS", "Value": [56.0]},
        "3450": {"vr": "DS", "Value": [37.0]},
        "3451": {"vr": "DS", "Value": [60.0]},
        "3452": {"vr": "DS", "Value": [59.0]},
        "3453": {"vr": "DS", "Value": [49.0]},
        "3454": {"vr": "DS", "Value": [270.0]},
        "3455": {"vr": "DS", "Value": [55.0]},
        "3456": {"vr": "DS", "Value": [10.0]},
        "3457": {"vr": "DS", "Value": [34.0]},
        "3458": {"vr": "DS", "Value": [30.0]},
        "3459": {"vr": "DS", "Value": [57.0]},
        "3460": {"vr": "DS", "Value": [26.0]},
        "3461": {"vr": "DS", "Value": [55.0]},
        "3462": {"vr": "DS", "Value": [56.0]},
        "3463": {"vr": "DS", "Value": [34.0]},
        "3464": {"vr": "DS", "Value": [50.0]},
        "3465": {"vr": "DS", "Value": [54.0]},
        "3466": {"vr": "DS", "Value": [53.0]},
        "3467": {"vr": "DS", "Value": [24.0]},
        "3468": {"vr": "DS", "Value": [48.0]},
        "3469": {"vr": "DS", "Value": [55.0]},
        "3470": {"vr": "DS", "Value": [53.0]},
        "3471": {"vr": "DS", "Value": [54.0]},
        "3472": {"vr": "DS", "Value": [48.0]},
        "3473": {"vr": "DS", "Value": [45.0]},
        "3474": {"vr": "DS", "Value": [264.0]},
        "3475": {"vr": "DS", "Value": [45.0]},
        "3476": {"vr": "DS", "Value": [45.0]},
        "3477": {"vr": "DS", "Value": [26.0]},
        "3478": {"vr": "DS", "Value": [25.0]},
        "3479": {"vr": "DS", "Value": [50.0]},
        "3480": {"vr": "DS", "Value": [53.0]},
        "3481": {"vr": "DS", "Value": [287.0]},
        "3482": {"vr": "DS", "Value": [37.0]},
        "3483": {"vr": "DS", "Value": [53.0]},
        "3484": {"vr": "DS", "Value": [42.0]},
        "3485": {"vr": "DS", "Value": [52.0]},
        "3486": {"vr": "DS", "Value": [42.0]},
        "3487": {"vr": "DS", "Value": [40.0]},
        "3488": {"vr": "DS", "Value": [58.0]},
        "3489": {"vr": "DS", "Value": [50.0]},
        "3490": {"vr": "DS", "Value": [34.0]},
        "3491": {"vr": "DS", "Value": [52.0]},
        "3492": {"vr": "DS", "Value": [262.0]},
        "3493": {"vr": "DS", "Value": [37.0]},
        "3494": {"vr": "DS", "Value": [27.0]},
        "3495": {"vr": "DS", "Value": [51.0]},
        "3496": {"vr": "DS", "Value": [46.0]},
        "3497": {"vr": "DS", "Value": [56.0]},
        "3498": {"vr": "DS", "Value": [265.0]},
        "3499": {"vr": "DS", "Value": [56.0]},
        "3500": {"vr": "DS", "Value": [35.0]},
        "3501": {"vr": "DS", "Value": [341.0]},
        "3502": {"vr": "DS", "Value": [42.0]},
        "3503": {"vr": "DS", "Value": [286.0]},
        "3504": {"vr": "DS", "Value": [46.0]},
        "3505": {"vr": "DS", "Value": [54.0]},
        "3506": {"vr": "DS", "Value": [34.0]},
        "3507": {"vr": "DS", "Value": [49.0]},
        "3508": {"vr": "DS", "Value": [52.0]},
        "3509": {"vr": "DS", "Value": [54.0]},
        "3510": {"vr": "DS", "Value": [56.0]},
        "3511": {"vr": "DS", "Value": [303.0]},
        "3512": {"vr": "DS", "Value": [48.0]},
        "3513": {"vr": "DS", "Value": [46.0]},
        "3514": {"vr": "DS", "Value": [30.0]},
        "3515": {"vr": "DS", "Value": [24.0]},
        "3516": {"vr": "DS", "Value": [32.0]},
        "3517": {"vr": "DS", "Value": [51.0]},
        "3518": {"vr": "DS", "Value": [47.0]},
        "3519": {"vr": "DS", "Value": [52.0]},
        "3520": {"vr": "DS", "Value": [38.0]},
        "3521": {"vr": "DS", "Value": [315.0]},
        "3522": {"vr": "DS", "Value": [227.0]},
        "3523": {"vr": "DS", "Value": [52.0]},
        "3524": {"vr": "DS", "Value": [45.0]},
        "3525": {"vr": "DS", "Value": [53.0]},
        "3526": {"vr": "DS", "Value": [37.0]},
        "3527": {"vr": "DS", "Value": [50.0]},
        "3528": {"vr": "DS", "Value": [42.0]},
        "3529": {"vr": "DS", "Value": [279.0]},
        "3530": {"vr": "DS", "Value": [41.0]},
        "3531": {"vr": "DS", "Value": [53.0]},
        "3532": {"vr": "DS", "Value": [247.0]},
        "3533": {"vr": "DS", "Value": [57.0]},
        "3534": {"vr": "DS", "Value": [47.0]},
        "3535": {"vr": "DS", "Value": [26.0]},
        "3536": {"vr": "DS", "Value": [43.0]},
        "3537": {"vr": "DS", "Value": [42.0]},
        "3538": {"vr": "DS", "Value": [58.0]},
        "3539": {"vr": "DS", "Value": [275.0]},
        "3540": {"vr": "DS", "Value": [41.0]},
        "3541": {"vr": "DS", "Value": [39.0]},
        "3542": {"vr": "DS", "Value": [41.0]},
        "3543": {"vr": "DS", "Value": [46.0]},
        "3544": {"vr": "DS", "Value": [51.0]},
        "3545": {"vr": "DS", "Value": [38.0]},
        "3546": {"vr": "DS", "Value": [50.0]},
        "3547": {"vr": "DS", "Value": [58.0]},
        "3548": {"vr": "DS", "Value": [37.0]},
        "3549": {"vr": "DS", "Value": [40.0]},
        "3550": {"vr": "DS", "Value": [40.0]},
        "3551": {"vr": "DS", "Value": [54.0]},
        "3552": {"vr": "DS", "Value": [61.0]},
        "3553": {"vr": "DS", "Value": [36.0]},
        "3554": {"vr": "DS", "Value": [53.0]},
        "3555": {"vr": "DS", "Value": [51.0]},
        "3556": {"vr": "DS", "Value": [33.0]},
        "3557": {"vr": "DS", "Value": [43.0]},
        "3558": {"vr": "DS", "Value": [51.0]},
        "3559": {"vr": "DS", "Value": [36.0]},
        "3560": {"vr": "DS", "Value": [40.0]},
        "3561": {"vr": "DS", "Value": [54.0]},
        "3562": {"vr": "DS", "Value": [38.0]},
        "3563": {"vr": "DS", "Value": [33.0]},
        "3564": {"vr": "DS", "Value": [24.0]},
        "3565": {"vr": "DS", "Value": [28.0]},
        "3566": {"vr": "DS", "Value": [53.0]},
        "3567": {"vr": "DS", "Value": [46.0]},
        "3568": {"vr": "DS", "Value": [49.0]},
        "3569": {"vr": "DS", "Value": [40.0]},
        "3570": {"vr": "DS", "Value": [53.0]},
        "3571": {"vr": "DS", "Value": [25.0]},
        "3572": {"vr": "DS", "Value": [37.0]},
        "3573": {"vr": "DS", "Value": [49.0]},
        "3574": {"vr": "DS", "Value": [52.0]},
        "3575": {"vr": "DS", "Value": [281.0]},
        "3576": {"vr": "DS", "Value": [57.0]},
        "3577": {"vr": "DS", "Value": [56.0]},
        "3578": {"vr": "DS", "Value": [34.0]},
        "3579": {"vr": "DS", "Value": [56.0]},
        "3580": {"vr": "DS", "Value": [49.0]},
        "3581": {"vr": "DS", "Value": [49.0]},
        "3582": {"vr": "DS", "Value": [52.0]},
        "3583": {"vr": "DS", "Value": [54.0]},
        "3584": {"vr": "DS", "Value": [51.0]},
        "3585": {"vr": "DS", "Value": [24.0]},
        "3586": {"vr": "DS", "Value": [54.0]},
        "3587": {"vr": "DS", "Value": [45.0]},
        "3588": {"vr": "DS", "Value": [52.0]},
        "3589": {"vr": "DS", "Value": [300.0]},
        "3590": {"vr": "DS", "Value": [55.0]},
        "3591": {"vr": "DS", "Value": [59.0]},
        "3592": {"vr": "DS", "Value": [53.0]},
        "3593": {"vr": "DS", "Value": [59.0]},
        "3594": {"vr": "DS", "Value": [49.0]},
        "3595": {"vr": "DS", "Value": [41.0]},
        "3596": {"vr": "DS", "Value": [303.0]},
        "3597": {"vr": "DS", "Value": [45.0]},
        "3598": {"vr": "DS", "Value": [264.0]},
        "3599": {"vr": "DS", "Value": [47.0]},
        "3600": {"vr": "DS", "Value": [41.0]},
        "3601": {"vr": "DS", "Value": [24.0]},
        "3602": {"vr": "DS", "Value": [26.0]},
        "3603": {"vr": "DS", "Value": [28.0]},
        "3604": {"vr": "DS", "Value": [58.0]},
        "3605": {"vr": "DS", "Value": [56.0]},
        "3606": {"vr": "DS", "Value": [37.0]},
        "3607": {"vr": "DS", "Value": [37.0]},
        "3608": {"vr": "DS", "Value": [23.0]},
        "3609": {"vr": "DS", "Value": [26.0]},
        "3610": {"vr": "DS", "Value": [272.0]},
        "3611": {"vr": "DS", "Value": [51.0]},
        "3612": {"vr": "DS", "Value": [57.0]},
        "3613": {"vr": "DS", "Value": [50.0]},
        "3614": {"vr": "DS", "Value": [240.0]},
        "3615": {"vr": "DS", "Value": [55.0]},
        "3616": {"vr": "DS", "Value": [49.0]},
        "3617": {"vr": "DS", "Value": [51.0]},
        "3618": {"vr": "DS", "Value": [49.0]},
        "3619": {"vr": "DS", "Value": [51.0]},
        "3620": {"vr": "DS", "Value": [49.0]},
        "3621": {"vr": "DS", "Value": [56.0]},
        "3622": {"vr": "DS", "Value": [49.0]},
        "3623": {"vr": "DS", "Value": [53.0]},
        "3624": {"vr": "DS", "Value": [35.0]},
        "3625": {"vr": "DS", "Value": [56.0]},
        "3626": {"vr": "DS", "Value": [36.0]},
        "3627": {"vr": "DS", "Value": [52.0]},
        "3628": {"vr": "DS", "Value": [316.0]},
        "3629": {"vr": "DS", "Value": [49.0]},
        "3630": {"vr": "DS", "Value": [56.0]},
        "3631": {"vr": "DS", "Value": [25.0]},
        "3632": {"vr": "DS", "Value": [53.0]},
        "3633": {"vr": "DS", "Value": [55.0]},
        "3634": {"vr": "DS", "Value": [50.0]},
        "3635": {"vr": "DS", "Value": [47.0]},
        "3636": {"vr": "DS", "Value": [58.0]},
        "3637": {"vr": "DS", "Value": [42.0]},
        "3638": {"vr": "DS", "Value": [285.0]},
        "3639": {"vr": "DS", "Value": [50.0]},
        "3640": {"vr": "DS", "Value": [274.0]},
        "3641": {"vr": "DS", "Value": [49.0]},
        "3642": {"vr": "DS", "Value": [27.0]},
        "3643": {"vr": "DS", "Value": [34.0]},
        "3644": {"vr": "DS", "Value": [54.0]},
        "3645": {"vr": "DS", "Value": [48.0]},
        "3646": {"vr": "DS", "Value": [36.0]},
        "3647": {"vr": "DS", "Value": [25.0]},
        "3648": {"vr": "DS", "Value": [41.0]},
        "3649": {"vr": "DS", "Value": [43.0]},
        "3650": {"vr": "DS", "Value": [56.0]},
        "3651": {"vr": "DS", "Value": [26.0]},
        "3652": {"vr": "DS", "Value": [40.0]},
        "3653": {"vr": "DS", "Value": [281.0]},
        "3654": {"vr": "DS", "Value": [302.0]},
        "3655": {"vr": "DS", "Value": [48.0]},
        "3656": {"vr": "DS", "Value": [51.0]},
        "3657": {"vr": "DS", "Value": [23.0]},
        "3658": {"vr": "DS", "Value": [24.0]},
        "3659": {"vr": "DS", "Value": [48.0]},
        "3660": {"vr": "DS", "Value": [35.0]},
        "3661": {"vr": "DS", "Value": [36.0]},
        "3662": {"vr": "DS", "Value": [54.0]},
        "3663": {"vr": "DS", "Value": [48.0]},
        "3664": {"vr": "DS", "Value": [51.0]},
        "3665": {"vr": "DS", "Value": [26.0]},
        "3666": {"vr": "DS", "Value": [34.0]},
        "3667": {"vr": "DS", "Value": [57.0]},
        "3668": {"vr": "DS", "Value": [226.0]},
        "3669": {"vr": "DS", "Value": [43.0]},
        "3670": {"vr": "DS", "Value": [10.0]},
        "3671": {"vr": "DS", "Value": [56.0]},
        "3672": {"vr": "DS", "Value": [47.0]},
        "3673": {"vr": "DS", "Value": [279.0]},
        "3674": {"vr": "DS", "Value": [54.0]},
        "3675": {"vr": "DS", "Value": [40.0]},
        "3676": {"vr": "DS", "Value": [57.0]},
        "3677": {"vr": "DS", "Value": [56.0]},
        "3678": {"vr": "DS", "Value": [58.0]},
        "3679": {"vr": "DS", "Value": [55.0]},
        "3680": {"vr": "DS", "Value": [48.0]},
        "3681": {"vr": "DS", "Value": [45.0]},
        "3682": {"vr": "DS", "Value": [27.0]},
        "3683": {"vr": "DS", "Value": [46.0]},
        "3684": {"vr": "DS", "Value": [52.0]},
        "3685": {"vr": "DS", "Value": [49.0]},
        "3686": {"vr": "DS", "Value": [55.0]},
        "3687": {"vr": "DS", "Value": [296.0]},
        "3688": {"vr": "DS", "Value": [20.0]},
        "3689": {"vr": "DS", "Value": [53.0]},
        "3690": {"vr": "DS", "Value": [54.0]},
        "3691": {"vr": "DS", "Value": [47.0]},
        "3692": {"vr": "DS", "Value": [56.0]},
        "3693": {"vr": "DS", "Value": [53.0]},
        "3694": {"vr": "DS", "Value": [48.0]},
        "3695": {"vr": "DS", "Value": [49.0]},
        "3696": {"vr": "DS", "Value": [287.0]},
        "3697": {"vr": "DS", "Value": [39.0]},
        "3698": {"vr": "DS", "Value": [273.0]},
        "3699": {"vr": "DS", "Value": [53.0]},
        "3700": {"vr": "DS", "Value": [24.0]},
        "3701": {"vr": "DS", "Value": [56.0]},
        "3702": {"vr": "DS", "Value": [49.0]},
        "3703": {"vr": "DS", "Value": [51.0]},
        "3704": {"vr": "DS", "Value": [31.0]},
        "3705": {"vr": "DS", "Value": [53.0]},
        "3706": {"vr": "DS", "Value": [58.0]},
        "3707": {"vr": "DS", "Value": [51.0]},
        "3708": {"vr": "DS", "Value": [51.0]},
        "3709": {"vr": "DS", "Value": [48.0]},
        "3710": {"vr": "DS", "Value": [47.0]},
        "3711": {"vr": "DS", "Value": [50.0]},
        "3712": {"vr": "DS", "Value": [57.0]},
        "3713": {"vr": "DS", "Value": [22.0]},
        "3714": {"vr": "DS", "Value": [56.0]},
        "3715": {"vr": "DS", "Value": [46.0]},
        "3716": {"vr": "DS", "Value": [144.0]},
        "3717": {"vr": "DS", "Value": [26.0]},
        "3718": {"vr": "DS", "Value": [57.0]},
        "3719": {"vr": "DS", "Value": [48.0]},
        "3720": {"vr": "DS", "Value": [32.0]},
        "3721": {"vr": "DS", "Value": [11.0]},
        "3722": {"vr": "DS", "Value": [55.0]},
        "3723": {"vr": "DS", "Value": [150.0]},
        "3724": {"vr": "DS", "Value": [48.0]},
        "3725": {"vr": "DS", "Value": [50.0]},
        "3726": {"vr": "DS", "Value": [29.0]},
        "3727": {"vr": "DS", "Value": [48.0]},
        "3728": {"vr": "DS", "Value": [53.0]},
        "3729": {"vr": "DS", "Value": [272.0]},
        "3730": {"vr": "DS", "Value": [53.0]},
        "3731": {"vr": "DS", "Value": [41.0]},
        "3732": {"vr": "DS", "Value": [46.0]},
        "3733": {"vr": "DS", "Value": [52.0]},
        "3734": {"vr": "DS", "Value": [43.0]},
        "3735": {"vr": "DS", "Value": [79.0]},
        "3736": {"vr": "DS", "Value": [49.0]},
        "3737": {"vr": "DS", "Value": [55.0]},
        "3738": {"vr": "DS", "Value": [49.0]},
        "3739": {"vr": "DS", "Value": [52.0]},
        "3740": {"vr": "DS", "Value": [35.0]},
        "3741": {"vr": "DS", "Value": [43.0]},
        "3742": {"vr": "DS", "Value": [299.0]},
        "3743": {"vr": "DS", "Value": [52.0]},
        "3744": {"vr": "DS", "Value": [285.0]},
        "3745": {"vr": "DS", "Value": [33.0]},
        "3746": {"vr": "DS", "Value": [53.0]},
        "3747": {"vr": "DS", "Value": [56.0]},
        "3748": {"vr": "DS", "Value": [9.0]},
        "3749": {"vr": "DS", "Value": [30.0]},
        "3750": {"vr": "DS", "Value": [55.0]},
        "3751": {"vr": "DS", "Value": [50.0]},
        "3752": {"vr": "DS", "Value": [56.0]},
        "3753": {"vr": "DS", "Value": [53.0]},
        "3754": {"vr": "DS", "Value": [52.0]},
        "3755": {"vr": "DS", "Value": [57.0]},
        "3756": {"vr": "DS", "Value": [271.0]},
        "3757": {"vr": "DS", "Value": [22.0]},
        "3758": {"vr": "DS", "Value": [31.0]},
        "3759": {"vr": "DS", "Value": [48.0]},
        "3760": {"vr": "DS", "Value": [53.0]},
        "3761": {"vr": "DS", "Value": [48.0]},
        "3762": {"vr": "DS", "Value": [28.0]},
        "3763": {"vr": "DS", "Value": [270.0]},
        "3764": {"vr": "DS", "Value": [50.0]},
        "3765": {"vr": "DS", "Value": [54.0]},
        "3766": {"vr": "DS", "Value": [41.0]},
        "3767": {"vr": "DS", "Value": [42.0]},
        "3768": {"vr": "DS", "Value": [39.0]},
        "3769": {"vr": "DS", "Value": [36.0]},
        "3770": {"vr": "DS", "Value": [44.0]},
        "3771": {"vr": "DS", "Value": [53.0]},
        "3772": {"vr": "DS", "Value": [56.0]},
        "3773": {"vr": "DS", "Value": [46.0]},
        "3774": {"vr": "DS", "Value": [53.0]},
        "3775": {"vr": "DS", "Value": [55.0]},
        "3776": {"vr": "DS", "Value": [42.0]},
        "3777": {"vr": "DS", "Value": [26.0]},
        "3778": {"vr": "DS", "Value": [54.0]},
        "3779": {"vr": "DS", "Value": [49.0]},
        "3780": {"vr": "DS", "Value": [38.0]},
        "3781": {"vr": "DS", "Value": [50.0]},
        "3782": {"vr": "DS", "Value": [27.0]},
        "3783": {"vr": "DS", "Value": [49.0]},
        "3784": {"vr": "DS", "Value": [48.0]},
        "3785": {"vr": "DS", "Value": [23.0]},
        "3786": {"vr": "DS", "Value": [34.0]},
        "3787": {"vr": "DS", "Value": [47.0]},
        "3788": {"vr": "DS", "Value": [57.0]},
        "3789": {"vr": "DS", "Value": [27.0]},
        "3790": {"vr": "DS", "Value": [59.0]},
        "3791": {"vr": "DS", "Value": [49.0]},
        "3792": {"vr": "DS", "Value": [37.0]},
        "3793": {"vr": "DS", "Value": [58.0]},
        "3794": {"vr": "DS", "Value": [24.0]},
        "3795": {"vr": "DS", "Value": [59.0]},
        "3796": {"vr": "DS", "Value": [61.0]},
        "3797": {"vr": "DS", "Value": [43.0]},
        "3798": {"vr": "DS", "Value": [52.0]},
        "3799": {"vr": "DS", "Value": [59.0]},
        "3800": {"vr": "DS", "Value": [50.0]},
        "3801": {"vr": "DS", "Value": [51.0]},
        "3802": {"vr": "DS", "Value": [53.0]},
        "3803": {"vr": "DS", "Value": [50.0]},
        "3804": {"vr": "DS", "Value": [52.0]},
        "3805": {"vr": "DS", "Value": [60.0]},
        "3806": {"vr": "DS", "Value": [80.0]},
        "3807": {"vr": "DS", "Value": [23.0]},
        "3808": {"vr": "DS", "Value": [51.0]},
        "3809": {"vr": "DS", "Value": [38.0]},
        "3810": {"vr": "DS", "Value": [53.0]},
        "3811": {"vr": "DS", "Value": [53.0]},
        "3812": {"vr": "DS", "Value": [53.0]},
        "3813": {"vr": "DS", "Value": [55.0]},
        "3814": {"vr": "DS", "Value": [29.0]},
        "3815": {"vr": "DS", "Value": [55.0]},
        "3816": {"vr": "DS", "Value": [57.0]},
        "3817": {"vr": "DS", "Value": [45.0]},
        "3818": {"vr": "DS", "Value": [49.0]},
        "3819": {"vr": "DS", "Value": [45.0]},
        "3820": {"vr": "DS", "Value": [47.0]},
        "3821": {"vr": "DS", "Value": [11.0]},
        "3822": {"vr": "DS", "Value": [43.0]},
        "3823": {"vr": "DS", "Value": [56.0]},
        "3824": {"vr": "DS", "Value": [52.0]},
        "3825": {"vr": "DS", "Value": [265.0]},
        "3826": {"vr": "DS", "Value": [49.0]},
        "3827": {"vr": "DS", "Value": [38.0]},
        "3828": {"vr": "DS", "Value": [52.0]},
        "3829": {"vr": "DS", "Value": [58.0]},
        "3830": {"vr": "DS", "Value": [50.0]},
        "3831": {"vr": "DS", "Value": [48.0]},
        "3832": {"vr": "DS", "Value": [271.0]},
        "3833": {"vr": "DS", "Value": [55.0]},
        "3834": {"vr": "DS", "Value": [58.0]},
        "3835": {"vr": "DS", "Value": [54.0]},
        "3836": {"vr": "DS", "Value": [26.0]},
        "3837": {"vr": "DS", "Value": [55.0]},
        "3838": {"vr": "DS", "Value": [43.0]},
        "3839": {"vr": "DS", "Value": [49.0]},
        "3840": {"vr": "DS", "Value": [52.0]},
        "3841": {"vr": "DS", "Value": [46.0]},
        "3842": {"vr": "DS", "Value": [36.0]},
        "3843": {"vr": "DS", "Value": [47.0]},
        "3844": {"vr": "DS", "Value": [43.0]},
        "3845": {"vr": "DS", "Value": [286.0]},
        "3846": {"vr": "DS", "Value": [49.0]},
        "3847": {"vr": "DS", "Value": [29.0]},
        "3848": {"vr": "DS", "Value": [58.0]},
        "3849": {"vr": "DS", "Value": [57.0]},
        "3850": {"vr": "DS", "Value": [23.0]},
        "3851": {"vr": "DS", "Value": [37.0]},
        "3852": {"vr": "DS", "Value": [25.0]},
        "3853": {"vr": "DS", "Value": [32.0]},
        "3854": {"vr": "DS", "Value": [23.0]},
        "3855": {"vr": "DS", "Value": [296.0]},
        "3856": {"vr": "DS", "Value": [49.0]},
        "3857": {"vr": "DS", "Value": [42.0]},
        "3858": {"vr": "DS", "Value": [25.0]},
        "3859": {"vr": "DS", "Value": [51.0]},
        "3860": {"vr": "DS", "Value": [54.0]},
        "3861": {"vr": "DS", "Value": [56.0]},
        "3862": {"vr": "DS", "Value": [26.0]},
        "3863": {"vr": "DS", "Value": [247.0]},
        "3864": {"vr": "DS", "Value": [49.0]},
        "3865": {"vr": "DS", "Value": [55.0]},
        "3866": {"vr": "DS", "Value": [44.0]},
        "3867": {"vr": "DS", "Value": [52.0]},
        "3868": {"vr": "DS", "Value": [59.0]},
        "3869": {"vr": "DS", "Value": [46.0]},
        "3870": {"vr": "DS", "Value": [42.0]},
        "3871": {"vr": "DS", "Value": [51.0]},
        "3872": {"vr": "DS", "Value": [48.0]},
        "3873": {"vr": "DS", "Value": [45.0]},
        "3874": {"vr": "DS", "Value": [24.0]},
        "3875": {"vr": "DS", "Value": [55.0]},
        "3876": {"vr": "DS", "Value": [53.0]},
        "3877": {"vr": "DS", "Value": [25.0]},
        "3878": {"vr": "DS", "Value": [291.0]},
        "3879": {"vr": "DS", "Value": [54.0]},
        "3880": {"vr": "DS", "Value": [35.0]},
        "3881": {"vr": "DS", "Value": [31.0]},
        "3882": {"vr": "DS", "Value": [57.0]},
        "3883": {"vr": "DS", "Value": [49.0]},
        "3884": {"vr": "DS", "Value": [42.0]},
        "3885": {"vr": "DS", "Value": [313.0]},
        "3886": {"vr": "DS", "Value": [35.0]},
        "3887": {"vr": "DS", "Value": [53.0]},
        "3888": {"vr": "DS", "Value": [59.0]},
        "3889": {"vr": "DS", "Value": [42.0]},
        "3890": {"vr": "DS", "Value": [23.0]},
        "3891": {"vr": "DS", "Value": [44.0]},
        "3892": {"vr": "DS", "Value": [42.0]},
        "3893": {"vr": "DS", "Value": [23.0]},
        "3894": {"vr": "DS", "Value": [46.0]},
        "3895": {"vr": "DS", "Value": [49.0]},
        "3896": {"vr": "DS", "Value": [53.0]},
        "3897": {"vr": "DS", "Value": [41.0]},
        "3898": {"vr": "DS", "Value": [38.0]},
        "3899": {"vr": "DS", "Value": [52.0]},
        "3900": {"vr": "DS", "Value": [255.0]},
        "3901": {"vr": "DS", "Value": [34.0]},
        "3902": {"vr": "DS", "Value": [35.0]},
        "3903": {"vr": "DS", "Value": [44.0]},
        "3904": {"vr": "DS", "Value": [55.0]},
        "3905": {"vr": "DS", "Value": [56.0]},
        "3906": {"vr": "DS", "Value": [49.0]},
        "3907": {"vr": "DS", "Value": [47.0]},
        "3908": {"vr": "DS", "Value": [56.0]},
        "3909": {"vr": "DS", "Value": [52.0]},
        "3910": {"vr": "DS", "Value": [53.0]},
        "3911": {"vr": "DS", "Value": [26.0]},
        "3912": {"vr": "DS", "Value": [36.0]},
        "3913": {"vr": "DS", "Value": [55.0]},
        "3914": {"vr": "DS", "Value": [58.0]},
        "3915": {"vr": "DS", "Value": [51.0]},
        "3916": {"vr": "DS", "Value": [319.0]},
        "3917": {"vr": "DS", "Value": [43.0]},
        "3918": {"vr": "DS", "Value": [49.0]},
        "3919": {"vr": "DS", "Value": [46.0]},
        "3920": {"vr": "DS", "Value": [52.0]},
        "3921": {"vr": "DS", "Value": [53.0]},
        "3922": {"vr": "DS", "Value": [39.0]},
        "3923": {"vr": "DS", "Value": [25.0]},
        "3924": {"vr": "DS", "Value": [52.0]},
        "3925": {"vr": "DS", "Value": [44.0]},
        "3926": {"vr": "DS", "Value": [25.0]},
        "3927": {"vr": "DS", "Value": [58.0]},
        "3928": {"vr": "DS", "Value": [278.0]},
        "3929": {"vr": "DS", "Value": [55.0]},
        "3930": {"vr": "DS", "Value": [44.0]},
        "3931": {"vr": "DS", "Value": [51.0]},
        "3932": {"vr": "DS", "Value": [52.0]},
        "3933": {"vr": "DS", "Value": [53.0]},
        "3934": {"vr": "DS", "Value": [49.0]},
        "3935": {"vr": "DS", "Value": [52.0]},
        "3936": {"vr": "DS", "Value": [52.0]},
        "3937": {"vr": "DS", "Value": [294.0]},
        "3938": {"vr": "DS", "Value": [50.0]},
        "3939": {"vr": "DS", "Value": [53.0]},
        "3940": {"vr": "DS", "Value": [56.0]},
        "3941": {"vr": "DS", "Value": [50.0]},
        "3942": {"vr": "DS", "Value": [55.0]},
        "3943": {"vr": "DS", "Value": [25.0]},
        "3944": {"vr": "DS", "Value": [24.0]},
        "3945": {"vr": "DS", "Value": [315.0]},
        "3946": {"vr": "DS", "Value": [38.0]},
        "3947": {"vr": "DS", "Value": [47.0]},
        "3948": {"vr": "DS", "Value": [49.0]},
        "3949": {"vr": "DS", "Value": [51.0]},
        "3950": {"vr": "DS", "Value": [51.0]},
        "3951": {"vr": "DS", "Value": [54.0]},
        "3952": {"vr": "DS", "Value": [41.0]},
        "3953": {"vr": "DS", "Value": [58.0]},
        "3954": {"vr": "DS", "Value": [46.0]},
        "3955": {"vr": "DS", "Value": [54.0]},
        "3956": {"vr": "DS", "Value": [40.0]},
        "3957": {"vr": "DS", "Value": [50.0]},
        "3958": {"vr": "DS", "Value": [54.0]},
        "3959": {"vr": "DS", "Value": [23.0]},
        "3960": {"vr": "DS", "Value": [36.0]},
        "3961": {"vr": "DS", "Value": [27.0]},
        "3962": {"vr": "DS", "Value": [49.0]},
        "3963": {"vr": "DS", "Value": [48.0]},
        "3964": {"vr": "DS", "Value": [51.0]},
        "3965": {"vr": "DS", "Value": [48.0]},
        "3966": {"vr": "DS", "Value": [24.0]},
        "3967": {"vr": "DS", "Value": [42.0]},
        "3968": {"vr": "DS", "Value": [250.0]},
        "3969": {"vr": "DS", "Value": [23.0]},
        "3970": {"vr": "DS", "Value": [55.0]},
        "3971": {"vr": "DS", "Value": [28.0]},
        "3972": {"vr": "DS", "Value": [42.0]},
        "3973": {"vr": "DS", "Value": [28.0]},
        "3974": {"vr": "DS", "Value": [42.0]},
        "3975": {"vr": "DS", "Value": [54.0]},
        "3976": {"vr": "DS", "Value": [57.0]},
        "3977": {"vr": "DS", "Value": [29.0]},
        "3978": {"vr": "DS", "Value": [35.0]},
        "3979": {"vr": "DS", "Value": [47.0]},
        "3980": {"vr": "DS", "Value": [9.0]},
        "3981": {"vr": "DS", "Value": [37.0]},
        "3982": {"vr": "DS", "Value": [58.0]},
        "3983": {"vr": "DS", "Value": [51.0]},
        "3984": {"vr": "DS", "Value": [49.0]},
        "3985": {"vr": "DS", "Value": [37.0]},
        "3986": {"vr": "DS", "Value": [56.0]},
        "3987": {"vr": "DS", "Value": [54.0]},
        "3988": {"vr": "DS", "Value": [48.0]},
        "3989": {"vr": "DS", "Value": [54.0]},
        "3990": {"vr": "DS", "Value": [54.0]},
        "3991": {"vr": "DS", "Value": [46.0]},
        "3992": {"vr": "DS", "Value": [53.0]},
        "3993": {"vr": "DS", "Value": [26.0]},
        "3994": {"vr": "DS", "Value": [53.0]},
        "3995": {"vr": "DS", "Value": [51.0]},
        "3996": {"vr": "DS", "Value": [49.0]},
        "3997": {"vr": "DS", "Value": [39.0]},
        "3998": {"vr": "DS", "Value": [48.0]},
        "3999": {"vr": "DS", "Value": [57.0]},
        "4000": {"vr": "DS", "Value": [43.0]},
        "4001": {"vr": "DS", "Value": [51.0]},
        "4002": {"vr": "DS", "Value": [50.0]},
        "4003": {"vr": "DS", "Value": [11.0]},
        "4004": {"vr": "DS", "Value": [53.0]},
        "4005": {"vr": "DS", "Value": [53.0]},
        "4006": {"vr": "DS", "Value": [36.0]},
        "4007": {"vr": "DS", "Value": [53.0]},
        "4008": {"vr": "DS", "Value": [49.0]},
        "4009": {"vr": "DS", "Value": [251.0]},
        "4010": {"vr": "DS", "Value": [24.0]},
        "4011": {"vr": "DS", "Value": [307.0]},
        "4012": {"vr": "DS", "Value": [42.0]},
        "4013": {"vr": "DS", "Value": [56.0]},
        "4014": {"vr": "DS", "Value": [42.0]},
        "4015": {"vr": "DS", "Value": [23.0]},
        "4016": {"vr": "DS", "Value": [56.0]},
        "4017": {"vr": "DS", "Value": [54.0]},
        "4018": {"vr": "DS", "Value": [52.0]},
        "4019": {"vr": "DS", "Value": [46.0]},
    },
    "00281051": {
        "0": {"vr": "DS", "Value": [149.0]},
        "1": {"vr": "DS", "Value": [62.0]},
        "2": {"vr": "DS", "Value": [124.0]},
        "3": {"vr": "DS", "Value": [770.0]},
        "4": {"vr": "DS", "Value": [133.0]},
        "5": {"vr": "DS", "Value": [143.0]},
        "6": {"vr": "DS", "Value": [116.0]},
        "7": {"vr": "DS", "Value": [146.0]},
        "8": {"vr": "DS", "Value": [135.0]},
        "9": {"vr": "DS", "Value": [143.0]},
        "10": {"vr": "DS", "Value": [160.0]},
        "11": {"vr": "DS", "Value": [125.0]},
        "12": {"vr": "DS", "Value": [134.0]},
        "13": {"vr": "DS", "Value": [705.0]},
        "14": {"vr": "DS", "Value": [669.0]},
        "15": {"vr": "DS", "Value": [77.0]},
        "16": {"vr": "DS", "Value": [153.0]},
        "17": {"vr": "DS", "Value": [143.0]},
        "18": {"vr": "DS", "Value": [164.0]},
        "19": {"vr": "DS", "Value": [141.0]},
        "20": {"vr": "DS", "Value": [116.0]},
        "21": {"vr": "DS", "Value": [117.0]},
        "22": {"vr": "DS", "Value": [60.0]},
        "23": {"vr": "DS", "Value": [148.0]},
        "24": {"vr": "DS", "Value": [143.0]},
        "25": {"vr": "DS", "Value": [159.0]},
        "26": {"vr": "DS", "Value": [115.0]},
        "27": {"vr": "DS", "Value": [112.0]},
        "28": {"vr": "DS", "Value": [135.0]},
        "29": {"vr": "DS", "Value": [148.0]},
        "30": {"vr": "DS", "Value": [146.0]},
        "31": {"vr": "DS", "Value": [634.0]},
        "32": {"vr": "DS", "Value": [151.0]},
        "33": {"vr": "DS", "Value": [150.0]},
        "34": {"vr": "DS", "Value": [717.0]},
        "35": {"vr": "DS", "Value": [559.0]},
        "36": {"vr": "DS", "Value": [148.0]},
        "37": {"vr": "DS", "Value": [107.0]},
        "38": {"vr": "DS", "Value": [107.0]},
        "39": {"vr": "DS", "Value": [143.0]},
        "40": {"vr": "DS", "Value": [691.0]},
        "41": {"vr": "DS", "Value": [133.0]},
        "42": {"vr": "DS", "Value": [145.0]},
        "43": {"vr": "DS", "Value": [137.0]},
        "44": {"vr": "DS", "Value": [110.0]},
        "45": {"vr": "DS", "Value": [62.0]},
        "46": {"vr": "DS", "Value": [82.0]},
        "47": {"vr": "DS", "Value": [147.0]},
        "48": {"vr": "DS", "Value": [91.0]},
        "49": {"vr": "DS", "Value": [59.0]},
        "50": {"vr": "DS", "Value": [155.0]},
        "51": {"vr": "DS", "Value": [143.0]},
        "52": {"vr": "DS", "Value": [123.0]},
        "53": {"vr": "DS", "Value": [85.0]},
        "54": {"vr": "DS", "Value": [136.0]},
        "55": {"vr": "DS", "Value": [154.0]},
        "56": {"vr": "DS", "Value": [132.0]},
        "57": {"vr": "DS", "Value": [161.0]},
        "58": {"vr": "DS", "Value": [126.0]},
        "59": {"vr": "DS", "Value": [104.0]},
        "60": {"vr": "DS", "Value": [729.0]},
        "61": {"vr": "DS", "Value": [675.0]},
        "62": {"vr": "DS", "Value": [21.0]},
        "63": {"vr": "DS", "Value": [113.0]},
        "64": {"vr": "DS", "Value": [109.0]},
        "65": {"vr": "DS", "Value": [113.0]},
        "66": {"vr": "DS", "Value": [141.0]},
        "67": {"vr": "DS", "Value": [136.0]},
        "68": {"vr": "DS", "Value": [760.0]},
        "69": {"vr": "DS", "Value": [134.0]},
        "70": {"vr": "DS", "Value": [130.0]},
        "71": {"vr": "DS", "Value": [62.0]},
        "72": {"vr": "DS", "Value": [148.0]},
        "73": {"vr": "DS", "Value": [116.0]},
        "74": {"vr": "DS", "Value": [143.0]},
        "75": {"vr": "DS", "Value": [89.0]},
        "76": {"vr": "DS", "Value": [136.0]},
        "77": {"vr": "DS", "Value": [82.0]},
        "78": {"vr": "DS", "Value": [126.0]},
        "79": {"vr": "DS", "Value": [138.0]},
        "80": {"vr": "DS", "Value": [643.0]},
        "81": {"vr": "DS", "Value": [145.0]},
        "82": {"vr": "DS", "Value": [71.0]},
        "83": {"vr": "DS", "Value": [151.0]},
        "84": {"vr": "DS", "Value": [68.0]},
        "85": {"vr": "DS", "Value": [142.0]},
        "86": {"vr": "DS", "Value": [151.0]},
        "87": {"vr": "DS", "Value": [64.0]},
        "88": {"vr": "DS", "Value": [135.0]},
        "89": {"vr": "DS", "Value": [131.0]},
        "90": {"vr": "DS", "Value": [666.0]},
        "91": {"vr": "DS", "Value": [632.0]},
        "92": {"vr": "DS", "Value": [132.0]},
        "93": {"vr": "DS", "Value": [129.0]},
        "94": {"vr": "DS", "Value": [101.0]},
        "95": {"vr": "DS", "Value": [145.0]},
        "96": {"vr": "DS", "Value": [89.0]},
        "97": {"vr": "DS", "Value": [135.0]},
        "98": {"vr": "DS", "Value": [70.0]},
        "99": {"vr": "DS", "Value": [92.0]},
        "100": {"vr": "DS", "Value": [115.0]},
        "101": {"vr": "DS", "Value": [136.0]},
        "102": {"vr": "DS", "Value": [143.0]},
        "103": {"vr": "DS", "Value": [117.0]},
        "104": {"vr": "DS", "Value": [157.0]},
        "105": {"vr": "DS", "Value": [134.0]},
        "106": {"vr": "DS", "Value": [145.0]},
        "107": {"vr": "DS", "Value": [163.0]},
        "108": {"vr": "DS", "Value": [57.0]},
        "109": {"vr": "DS", "Value": [148.0]},
        "110": {"vr": "DS", "Value": [141.0]},
        "111": {"vr": "DS", "Value": [126.0]},
        "112": {"vr": "DS", "Value": [724.0]},
        "113": {"vr": "DS", "Value": [142.0]},
        "114": {"vr": "DS", "Value": [617.0]},
        "115": {"vr": "DS", "Value": [144.0]},
        "116": {"vr": "DS", "Value": [149.0]},
        "117": {"vr": "DS", "Value": [22.0]},
        "118": {"vr": "DS", "Value": [75.0]},
        "119": {"vr": "DS", "Value": [73.0]},
        "120": {"vr": "DS", "Value": [62.0]},
        "121": {"vr": "DS", "Value": [131.0]},
        "122": {"vr": "DS", "Value": [118.0]},
        "123": {"vr": "DS", "Value": [148.0]},
        "124": {"vr": "DS", "Value": [139.0]},
        "125": {"vr": "DS", "Value": [135.0]},
        "126": {"vr": "DS", "Value": [108.0]},
        "127": {"vr": "DS", "Value": [134.0]},
        "128": {"vr": "DS", "Value": [725.0]},
        "129": {"vr": "DS", "Value": [136.0]},
        "130": {"vr": "DS", "Value": [25.0]},
        "131": {"vr": "DS", "Value": [148.0]},
        "132": {"vr": "DS", "Value": [143.0]},
        "133": {"vr": "DS", "Value": [153.0]},
        "134": {"vr": "DS", "Value": [147.0]},
        "135": {"vr": "DS", "Value": [144.0]},
        "136": {"vr": "DS", "Value": [146.0]},
        "137": {"vr": "DS", "Value": [129.0]},
        "138": {"vr": "DS", "Value": [145.0]},
        "139": {"vr": "DS", "Value": [140.0]},
        "140": {"vr": "DS", "Value": [103.0]},
        "141": {"vr": "DS", "Value": [144.0]},
        "142": {"vr": "DS", "Value": [68.0]},
        "143": {"vr": "DS", "Value": [59.0]},
        "144": {"vr": "DS", "Value": [134.0]},
        "145": {"vr": "DS", "Value": [139.0]},
        "146": {"vr": "DS", "Value": [139.0]},
        "147": {"vr": "DS", "Value": [109.0]},
        "148": {"vr": "DS", "Value": [122.0]},
        "149": {"vr": "DS", "Value": [143.0]},
        "150": {"vr": "DS", "Value": [147.0]},
        "151": {"vr": "DS", "Value": [128.0]},
        "152": {"vr": "DS", "Value": [75.0]},
        "153": {"vr": "DS", "Value": [158.0]},
        "154": {"vr": "DS", "Value": [135.0]},
        "155": {"vr": "DS", "Value": [130.0]},
        "156": {"vr": "DS", "Value": [143.0]},
        "157": {"vr": "DS", "Value": [119.0]},
        "158": {"vr": "DS", "Value": [69.0]},
        "159": {"vr": "DS", "Value": [134.0]},
        "160": {"vr": "DS", "Value": [594.0]},
        "161": {"vr": "DS", "Value": [65.0]},
        "162": {"vr": "DS", "Value": [55.0]},
        "163": {"vr": "DS", "Value": [132.0]},
        "164": {"vr": "DS", "Value": [136.0]},
        "165": {"vr": "DS", "Value": [124.0]},
        "166": {"vr": "DS", "Value": [105.0]},
        "167": {"vr": "DS", "Value": [131.0]},
        "168": {"vr": "DS", "Value": [144.0]},
        "169": {"vr": "DS", "Value": [64.0]},
        "170": {"vr": "DS", "Value": [141.0]},
        "171": {"vr": "DS", "Value": [106.0]},
        "172": {"vr": "DS", "Value": [148.0]},
        "173": {"vr": "DS", "Value": [137.0]},
        "174": {"vr": "DS", "Value": [137.0]},
        "175": {"vr": "DS", "Value": [142.0]},
        "176": {"vr": "DS", "Value": [142.0]},
        "177": {"vr": "DS", "Value": [98.0]},
        "178": {"vr": "DS", "Value": [145.0]},
        "179": {"vr": "DS", "Value": [136.0]},
        "180": {"vr": "DS", "Value": [144.0]},
        "181": {"vr": "DS", "Value": [58.0]},
        "182": {"vr": "DS", "Value": [139.0]},
        "183": {"vr": "DS", "Value": [142.0]},
        "184": {"vr": "DS", "Value": [138.0]},
        "185": {"vr": "DS", "Value": [122.0]},
        "186": {"vr": "DS", "Value": [127.0]},
        "187": {"vr": "DS", "Value": [148.0]},
        "188": {"vr": "DS", "Value": [82.0]},
        "189": {"vr": "DS", "Value": [19.0]},
        "190": {"vr": "DS", "Value": [139.0]},
        "191": {"vr": "DS", "Value": [206.0]},
        "192": {"vr": "DS", "Value": [95.0]},
        "193": {"vr": "DS", "Value": [80.0]},
        "194": {"vr": "DS", "Value": [138.0]},
        "195": {"vr": "DS", "Value": [127.0]},
        "196": {"vr": "DS", "Value": [97.0]},
        "197": {"vr": "DS", "Value": [143.0]},
        "198": {"vr": "DS", "Value": [612.0]},
        "199": {"vr": "DS", "Value": [123.0]},
        "200": {"vr": "DS", "Value": [165.0]},
        "201": {"vr": "DS", "Value": [144.0]},
        "202": {"vr": "DS", "Value": [149.0]},
        "203": {"vr": "DS", "Value": [109.0]},
        "204": {"vr": "DS", "Value": [132.0]},
        "205": {"vr": "DS", "Value": [145.0]},
        "206": {"vr": "DS", "Value": [141.0]},
        "207": {"vr": "DS", "Value": [116.0]},
        "208": {"vr": "DS", "Value": [59.0]},
        "209": {"vr": "DS", "Value": [139.0]},
        "210": {"vr": "DS", "Value": [641.0]},
        "211": {"vr": "DS", "Value": [146.0]},
        "212": {"vr": "DS", "Value": [113.0]},
        "213": {"vr": "DS", "Value": [110.0]},
        "214": {"vr": "DS", "Value": [146.0]},
        "215": {"vr": "DS", "Value": [100.0]},
        "216": {"vr": "DS", "Value": [138.0]},
        "217": {"vr": "DS", "Value": [59.0]},
        "218": {"vr": "DS", "Value": [148.0]},
        "219": {"vr": "DS", "Value": [65.0]},
        "220": {"vr": "DS", "Value": [158.0]},
        "221": {"vr": "DS", "Value": [132.0]},
        "222": {"vr": "DS", "Value": [129.0]},
        "223": {"vr": "DS", "Value": [60.0]},
        "224": {"vr": "DS", "Value": [132.0]},
        "225": {"vr": "DS", "Value": [145.0]},
        "226": {"vr": "DS", "Value": [135.0]},
        "227": {"vr": "DS", "Value": [591.0]},
        "228": {"vr": "DS", "Value": [159.0]},
        "229": {"vr": "DS", "Value": [138.0]},
        "230": {"vr": "DS", "Value": [64.0]},
        "231": {"vr": "DS", "Value": [151.0]},
        "232": {"vr": "DS", "Value": [117.0]},
        "233": {"vr": "DS", "Value": [153.0]},
        "234": {"vr": "DS", "Value": [20.0]},
        "235": {"vr": "DS", "Value": [144.0]},
        "236": {"vr": "DS", "Value": [139.0]},
        "237": {"vr": "DS", "Value": [75.0]},
        "238": {"vr": "DS", "Value": [105.0]},
        "239": {"vr": "DS", "Value": [146.0]},
        "240": {"vr": "DS", "Value": [130.0]},
        "241": {"vr": "DS", "Value": [102.0]},
        "242": {"vr": "DS", "Value": [149.0]},
        "243": {"vr": "DS", "Value": [694.0]},
        "244": {"vr": "DS", "Value": [139.0]},
        "245": {"vr": "DS", "Value": [104.0]},
        "246": {"vr": "DS", "Value": [718.0]},
        "247": {"vr": "DS", "Value": [150.0]},
        "248": {"vr": "DS", "Value": [100.0]},
        "249": {"vr": "DS", "Value": [131.0]},
        "250": {"vr": "DS", "Value": [69.0]},
        "251": {"vr": "DS", "Value": [143.0]},
        "252": {"vr": "DS", "Value": [148.0]},
        "253": {"vr": "DS", "Value": [118.0]},
        "254": {"vr": "DS", "Value": [126.0]},
        "255": {"vr": "DS", "Value": [64.0]},
        "256": {"vr": "DS", "Value": [686.0]},
        "257": {"vr": "DS", "Value": [106.0]},
        "258": {"vr": "DS", "Value": [133.0]},
        "259": {"vr": "DS", "Value": [144.0]},
        "260": {"vr": "DS", "Value": [130.0]},
        "261": {"vr": "DS", "Value": [132.0]},
        "262": {"vr": "DS", "Value": [131.0]},
        "263": {"vr": "DS", "Value": [139.0]},
        "264": {"vr": "DS", "Value": [134.0]},
        "265": {"vr": "DS", "Value": [138.0]},
        "266": {"vr": "DS", "Value": [87.0]},
        "267": {"vr": "DS", "Value": [85.0]},
        "268": {"vr": "DS", "Value": [60.0]},
        "269": {"vr": "DS", "Value": [143.0]},
        "270": {"vr": "DS", "Value": [667.0]},
        "271": {"vr": "DS", "Value": [105.0]},
        "272": {"vr": "DS", "Value": [62.0]},
        "273": {"vr": "DS", "Value": [116.0]},
        "274": {"vr": "DS", "Value": [124.0]},
        "275": {"vr": "DS", "Value": [664.0]},
        "276": {"vr": "DS", "Value": [116.0]},
        "277": {"vr": "DS", "Value": [148.0]},
        "278": {"vr": "DS", "Value": [131.0]},
        "279": {"vr": "DS", "Value": [138.0]},
        "280": {"vr": "DS", "Value": [123.0]},
        "281": {"vr": "DS", "Value": [105.0]},
        "282": {"vr": "DS", "Value": [134.0]},
        "283": {"vr": "DS", "Value": [58.0]},
        "284": {"vr": "DS", "Value": [119.0]},
        "285": {"vr": "DS", "Value": [136.0]},
        "286": {"vr": "DS", "Value": [74.0]},
        "287": {"vr": "DS", "Value": [131.0]},
        "288": {"vr": "DS", "Value": [140.0]},
        "289": {"vr": "DS", "Value": [59.0]},
        "290": {"vr": "DS", "Value": [573.0]},
        "291": {"vr": "DS", "Value": [140.0]},
        "292": {"vr": "DS", "Value": [144.0]},
        "293": {"vr": "DS", "Value": [138.0]},
        "294": {"vr": "DS", "Value": [65.0]},
        "295": {"vr": "DS", "Value": [107.0]},
        "296": {"vr": "DS", "Value": [101.0]},
        "297": {"vr": "DS", "Value": [125.0]},
        "298": {"vr": "DS", "Value": [118.0]},
        "299": {"vr": "DS", "Value": [150.0]},
        "300": {"vr": "DS", "Value": [150.0]},
        "301": {"vr": "DS", "Value": [695.0]},
        "302": {"vr": "DS", "Value": [124.0]},
        "303": {"vr": "DS", "Value": [94.0]},
        "304": {"vr": "DS", "Value": [124.0]},
        "305": {"vr": "DS", "Value": [140.0]},
        "306": {"vr": "DS", "Value": [119.0]},
        "307": {"vr": "DS", "Value": [144.0]},
        "308": {"vr": "DS", "Value": [148.0]},
        "309": {"vr": "DS", "Value": [131.0]},
        "310": {"vr": "DS", "Value": [114.0]},
        "311": {"vr": "DS", "Value": [650.0]},
        "312": {"vr": "DS", "Value": [141.0]},
        "313": {"vr": "DS", "Value": [523.0]},
        "314": {"vr": "DS", "Value": [150.0]},
        "315": {"vr": "DS", "Value": [134.0]},
        "316": {"vr": "DS", "Value": [671.0]},
        "317": {"vr": "DS", "Value": [106.0]},
        "318": {"vr": "DS", "Value": [61.0]},
        "319": {"vr": "DS", "Value": [23.0]},
        "320": {"vr": "DS", "Value": [127.0]},
        "321": {"vr": "DS", "Value": [124.0]},
        "322": {"vr": "DS", "Value": [125.0]},
        "323": {"vr": "DS", "Value": [157.0]},
        "324": {"vr": "DS", "Value": [137.0]},
        "325": {"vr": "DS", "Value": [128.0]},
        "326": {"vr": "DS", "Value": [70.0]},
        "327": {"vr": "DS", "Value": [127.0]},
        "328": {"vr": "DS", "Value": [163.0]},
        "329": {"vr": "DS", "Value": [157.0]},
        "330": {"vr": "DS", "Value": [137.0]},
        "331": {"vr": "DS", "Value": [133.0]},
        "332": {"vr": "DS", "Value": [149.0]},
        "333": {"vr": "DS", "Value": [140.0]},
        "334": {"vr": "DS", "Value": [142.0]},
        "335": {"vr": "DS", "Value": [146.0]},
        "336": {"vr": "DS", "Value": [114.0]},
        "337": {"vr": "DS", "Value": [134.0]},
        "338": {"vr": "DS", "Value": [137.0]},
        "339": {"vr": "DS", "Value": [145.0]},
        "340": {"vr": "DS", "Value": [140.0]},
        "341": {"vr": "DS", "Value": [141.0]},
        "342": {"vr": "DS", "Value": [76.0]},
        "343": {"vr": "DS", "Value": [154.0]},
        "344": {"vr": "DS", "Value": [136.0]},
        "345": {"vr": "DS", "Value": [131.0]},
        "346": {"vr": "DS", "Value": [143.0]},
        "347": {"vr": "DS", "Value": [136.0]},
        "348": {"vr": "DS", "Value": [149.0]},
        "349": {"vr": "DS", "Value": [683.0]},
        "350": {"vr": "DS", "Value": [665.0]},
        "351": {"vr": "DS", "Value": [141.0]},
        "352": {"vr": "DS", "Value": [62.0]},
        "353": {"vr": "DS", "Value": [131.0]},
        "354": {"vr": "DS", "Value": [131.0]},
        "355": {"vr": "DS", "Value": [141.0]},
        "356": {"vr": "DS", "Value": [151.0]},
        "357": {"vr": "DS", "Value": [151.0]},
        "358": {"vr": "DS", "Value": [99.0]},
        "359": {"vr": "DS", "Value": [133.0]},
        "360": {"vr": "DS", "Value": [124.0]},
        "361": {"vr": "DS", "Value": [414.0]},
        "362": {"vr": "DS", "Value": [117.0]},
        "363": {"vr": "DS", "Value": [211.0]},
        "364": {"vr": "DS", "Value": [141.0]},
        "365": {"vr": "DS", "Value": [131.0]},
        "366": {"vr": "DS", "Value": [148.0]},
        "367": {"vr": "DS", "Value": [133.0]},
        "368": {"vr": "DS", "Value": [665.0]},
        "369": {"vr": "DS", "Value": [156.0]},
        "370": {"vr": "DS", "Value": [67.0]},
        "371": {"vr": "DS", "Value": [151.0]},
        "372": {"vr": "DS", "Value": [121.0]},
        "373": {"vr": "DS", "Value": [150.0]},
        "374": {"vr": "DS", "Value": [134.0]},
        "375": {"vr": "DS", "Value": [155.0]},
        "376": {"vr": "DS", "Value": [105.0]},
        "377": {"vr": "DS", "Value": [140.0]},
        "378": {"vr": "DS", "Value": [135.0]},
        "379": {"vr": "DS", "Value": [121.0]},
        "380": {"vr": "DS", "Value": [62.0]},
        "381": {"vr": "DS", "Value": [69.0]},
        "382": {"vr": "DS", "Value": [143.0]},
        "383": {"vr": "DS", "Value": [608.0]},
        "384": {"vr": "DS", "Value": [616.0]},
        "385": {"vr": "DS", "Value": [66.0]},
        "386": {"vr": "DS", "Value": [118.0]},
        "387": {"vr": "DS", "Value": [140.0]},
        "388": {"vr": "DS", "Value": [151.0]},
        "389": {"vr": "DS", "Value": [143.0]},
        "390": {"vr": "DS", "Value": [67.0]},
        "391": {"vr": "DS", "Value": [104.0]},
        "392": {"vr": "DS", "Value": [135.0]},
        "393": {"vr": "DS", "Value": [66.0]},
        "394": {"vr": "DS", "Value": [135.0]},
        "395": {"vr": "DS", "Value": [159.0]},
        "396": {"vr": "DS", "Value": [662.0]},
        "397": {"vr": "DS", "Value": [121.0]},
        "398": {"vr": "DS", "Value": [103.0]},
        "399": {"vr": "DS", "Value": [693.0]},
        "400": {"vr": "DS", "Value": [127.0]},
        "401": {"vr": "DS", "Value": [153.0]},
        "402": {"vr": "DS", "Value": [139.0]},
        "403": {"vr": "DS", "Value": [128.0]},
        "404": {"vr": "DS", "Value": [129.0]},
        "405": {"vr": "DS", "Value": [141.0]},
        "406": {"vr": "DS", "Value": [137.0]},
        "407": {"vr": "DS", "Value": [140.0]},
        "408": {"vr": "DS", "Value": [145.0]},
        "409": {"vr": "DS", "Value": [108.0]},
        "410": {"vr": "DS", "Value": [139.0]},
        "411": {"vr": "DS", "Value": [117.0]},
        "412": {"vr": "DS", "Value": [129.0]},
        "413": {"vr": "DS", "Value": [135.0]},
        "414": {"vr": "DS", "Value": [129.0]},
        "415": {"vr": "DS", "Value": [119.0]},
        "416": {"vr": "DS", "Value": [99.0]},
        "417": {"vr": "DS", "Value": [101.0]},
        "418": {"vr": "DS", "Value": [647.0]},
        "419": {"vr": "DS", "Value": [132.0]},
        "420": {"vr": "DS", "Value": [147.0]},
        "421": {"vr": "DS", "Value": [131.0]},
        "422": {"vr": "DS", "Value": [87.0]},
        "423": {"vr": "DS", "Value": [122.0]},
        "424": {"vr": "DS", "Value": [662.0]},
        "425": {"vr": "DS", "Value": [118.0]},
        "426": {"vr": "DS", "Value": [139.0]},
        "427": {"vr": "DS", "Value": [141.0]},
        "428": {"vr": "DS", "Value": [140.0]},
        "429": {"vr": "DS", "Value": [118.0]},
        "430": {"vr": "DS", "Value": [119.0]},
        "431": {"vr": "DS", "Value": [163.0]},
        "432": {"vr": "DS", "Value": [68.0]},
        "433": {"vr": "DS", "Value": [144.0]},
        "434": {"vr": "DS", "Value": [132.0]},
        "435": {"vr": "DS", "Value": [109.0]},
        "436": {"vr": "DS", "Value": [150.0]},
        "437": {"vr": "DS", "Value": [104.0]},
        "438": {"vr": "DS", "Value": [61.0]},
        "439": {"vr": "DS", "Value": [115.0]},
        "440": {"vr": "DS", "Value": [139.0]},
        "441": {"vr": "DS", "Value": [148.0]},
        "442": {"vr": "DS", "Value": [150.0]},
        "443": {"vr": "DS", "Value": [50.0]},
        "444": {"vr": "DS", "Value": [142.0]},
        "445": {"vr": "DS", "Value": [619.0]},
        "446": {"vr": "DS", "Value": [151.0]},
        "447": {"vr": "DS", "Value": [145.0]},
        "448": {"vr": "DS", "Value": [676.0]},
        "449": {"vr": "DS", "Value": [134.0]},
        "450": {"vr": "DS", "Value": [134.0]},
        "451": {"vr": "DS", "Value": [134.0]},
        "452": {"vr": "DS", "Value": [131.0]},
        "453": {"vr": "DS", "Value": [149.0]},
        "454": {"vr": "DS", "Value": [77.0]},
        "455": {"vr": "DS", "Value": [138.0]},
        "456": {"vr": "DS", "Value": [146.0]},
        "457": {"vr": "DS", "Value": [151.0]},
        "458": {"vr": "DS", "Value": [116.0]},
        "459": {"vr": "DS", "Value": [121.0]},
        "460": {"vr": "DS", "Value": [66.0]},
        "461": {"vr": "DS", "Value": [142.0]},
        "462": {"vr": "DS", "Value": [140.0]},
        "463": {"vr": "DS", "Value": [146.0]},
        "464": {"vr": "DS", "Value": [120.0]},
        "465": {"vr": "DS", "Value": [130.0]},
        "466": {"vr": "DS", "Value": [69.0]},
        "467": {"vr": "DS", "Value": [74.0]},
        "468": {"vr": "DS", "Value": [148.0]},
        "469": {"vr": "DS", "Value": [659.0]},
        "470": {"vr": "DS", "Value": [101.0]},
        "471": {"vr": "DS", "Value": [97.0]},
        "472": {"vr": "DS", "Value": [119.0]},
        "473": {"vr": "DS", "Value": [133.0]},
        "474": {"vr": "DS", "Value": [104.0]},
        "475": {"vr": "DS", "Value": [746.0]},
        "476": {"vr": "DS", "Value": [102.0]},
        "477": {"vr": "DS", "Value": [144.0]},
        "478": {"vr": "DS", "Value": [120.0]},
        "479": {"vr": "DS", "Value": [133.0]},
        "480": {"vr": "DS", "Value": [135.0]},
        "481": {"vr": "DS", "Value": [136.0]},
        "482": {"vr": "DS", "Value": [119.0]},
        "483": {"vr": "DS", "Value": [703.0]},
        "484": {"vr": "DS", "Value": [129.0]},
        "485": {"vr": "DS", "Value": [122.0]},
        "486": {"vr": "DS", "Value": [140.0]},
        "487": {"vr": "DS", "Value": [144.0]},
        "488": {"vr": "DS", "Value": [148.0]},
        "489": {"vr": "DS", "Value": [78.0]},
        "490": {"vr": "DS", "Value": [140.0]},
        "491": {"vr": "DS", "Value": [152.0]},
        "492": {"vr": "DS", "Value": [141.0]},
        "493": {"vr": "DS", "Value": [84.0]},
        "494": {"vr": "DS", "Value": [149.0]},
        "495": {"vr": "DS", "Value": [113.0]},
        "496": {"vr": "DS", "Value": [129.0]},
        "497": {"vr": "DS", "Value": [677.0]},
        "498": {"vr": "DS", "Value": [144.0]},
        "499": {"vr": "DS", "Value": [151.0]},
        "500": {"vr": "DS", "Value": [67.0]},
        "501": {"vr": "DS", "Value": [711.0]},
        "502": {"vr": "DS", "Value": [135.0]},
        "503": {"vr": "DS", "Value": [113.0]},
        "504": {"vr": "DS", "Value": [145.0]},
        "505": {"vr": "DS", "Value": [122.0]},
        "506": {"vr": "DS", "Value": [19.0]},
        "507": {"vr": "DS", "Value": [696.0]},
        "508": {"vr": "DS", "Value": [113.0]},
        "509": {"vr": "DS", "Value": [118.0]},
        "510": {"vr": "DS", "Value": [139.0]},
        "511": {"vr": "DS", "Value": [116.0]},
        "512": {"vr": "DS", "Value": [75.0]},
        "513": {"vr": "DS", "Value": [133.0]},
        "514": {"vr": "DS", "Value": [719.0]},
        "515": {"vr": "DS", "Value": [635.0]},
        "516": {"vr": "DS", "Value": [145.0]},
        "517": {"vr": "DS", "Value": [144.0]},
        "518": {"vr": "DS", "Value": [114.0]},
        "519": {"vr": "DS", "Value": [110.0]},
        "520": {"vr": "DS", "Value": [714.0]},
        "521": {"vr": "DS", "Value": [141.0]},
        "522": {"vr": "DS", "Value": [141.0]},
        "523": {"vr": "DS", "Value": [146.0]},
        "524": {"vr": "DS", "Value": [135.0]},
        "525": {"vr": "DS", "Value": [109.0]},
        "526": {"vr": "DS", "Value": [75.0]},
        "527": {"vr": "DS", "Value": [144.0]},
        "528": {"vr": "DS", "Value": [117.0]},
        "529": {"vr": "DS", "Value": [23.0]},
        "530": {"vr": "DS", "Value": [101.0]},
        "531": {"vr": "DS", "Value": [724.0]},
        "532": {"vr": "DS", "Value": [153.0]},
        "533": {"vr": "DS", "Value": [141.0]},
        "534": {"vr": "DS", "Value": [145.0]},
        "535": {"vr": "DS", "Value": [134.0]},
        "536": {"vr": "DS", "Value": [118.0]},
        "537": {"vr": "DS", "Value": [68.0]},
        "538": {"vr": "DS", "Value": [70.0]},
        "539": {"vr": "DS", "Value": [684.0]},
        "540": {"vr": "DS", "Value": [116.0]},
        "541": {"vr": "DS", "Value": [118.0]},
        "542": {"vr": "DS", "Value": [693.0]},
        "543": {"vr": "DS", "Value": [66.0]},
        "544": {"vr": "DS", "Value": [613.0]},
        "545": {"vr": "DS", "Value": [132.0]},
        "546": {"vr": "DS", "Value": [50.0]},
        "547": {"vr": "DS", "Value": [139.0]},
        "548": {"vr": "DS", "Value": [692.0]},
        "549": {"vr": "DS", "Value": [138.0]},
        "550": {"vr": "DS", "Value": [132.0]},
        "551": {"vr": "DS", "Value": [137.0]},
        "552": {"vr": "DS", "Value": [127.0]},
        "553": {"vr": "DS", "Value": [687.0]},
        "554": {"vr": "DS", "Value": [739.0]},
        "555": {"vr": "DS", "Value": [679.0]},
        "556": {"vr": "DS", "Value": [131.0]},
        "557": {"vr": "DS", "Value": [122.0]},
        "558": {"vr": "DS", "Value": [134.0]},
        "559": {"vr": "DS", "Value": [154.0]},
        "560": {"vr": "DS", "Value": [142.0]},
        "561": {"vr": "DS", "Value": [147.0]},
        "562": {"vr": "DS", "Value": [66.0]},
        "563": {"vr": "DS", "Value": [135.0]},
        "564": {"vr": "DS", "Value": [133.0]},
        "565": {"vr": "DS", "Value": [145.0]},
        "566": {"vr": "DS", "Value": [66.0]},
        "567": {"vr": "DS", "Value": [682.0]},
        "568": {"vr": "DS", "Value": [142.0]},
        "569": {"vr": "DS", "Value": [136.0]},
        "570": {"vr": "DS", "Value": [97.0]},
        "571": {"vr": "DS", "Value": [138.0]},
        "572": {"vr": "DS", "Value": [74.0]},
        "573": {"vr": "DS", "Value": [140.0]},
        "574": {"vr": "DS", "Value": [129.0]},
        "575": {"vr": "DS", "Value": [124.0]},
        "576": {"vr": "DS", "Value": [19.0]},
        "577": {"vr": "DS", "Value": [96.0]},
        "578": {"vr": "DS", "Value": [136.0]},
        "579": {"vr": "DS", "Value": [115.0]},
        "580": {"vr": "DS", "Value": [24.0]},
        "581": {"vr": "DS", "Value": [142.0]},
        "582": {"vr": "DS", "Value": [143.0]},
        "583": {"vr": "DS", "Value": [133.0]},
        "584": {"vr": "DS", "Value": [118.0]},
        "585": {"vr": "DS", "Value": [642.0]},
        "586": {"vr": "DS", "Value": [132.0]},
        "587": {"vr": "DS", "Value": [561.0]},
        "588": {"vr": "DS", "Value": [65.0]},
        "589": {"vr": "DS", "Value": [143.0]},
        "590": {"vr": "DS", "Value": [147.0]},
        "591": {"vr": "DS", "Value": [93.0]},
        "592": {"vr": "DS", "Value": [148.0]},
        "593": {"vr": "DS", "Value": [82.0]},
        "594": {"vr": "DS", "Value": [154.0]},
        "595": {"vr": "DS", "Value": [140.0]},
        "596": {"vr": "DS", "Value": [145.0]},
        "597": {"vr": "DS", "Value": [139.0]},
        "598": {"vr": "DS", "Value": [94.0]},
        "599": {"vr": "DS", "Value": [142.0]},
        "600": {"vr": "DS", "Value": [652.0]},
        "601": {"vr": "DS", "Value": [112.0]},
        "602": {"vr": "DS", "Value": [135.0]},
        "603": {"vr": "DS", "Value": [147.0]},
        "604": {"vr": "DS", "Value": [96.0]},
        "605": {"vr": "DS", "Value": [98.0]},
        "606": {"vr": "DS", "Value": [119.0]},
        "607": {"vr": "DS", "Value": [62.0]},
        "608": {"vr": "DS", "Value": [148.0]},
        "609": {"vr": "DS", "Value": [140.0]},
        "610": {"vr": "DS", "Value": [110.0]},
        "611": {"vr": "DS", "Value": [633.0]},
        "612": {"vr": "DS", "Value": [105.0]},
        "613": {"vr": "DS", "Value": [144.0]},
        "614": {"vr": "DS", "Value": [154.0]},
        "615": {"vr": "DS", "Value": [57.0]},
        "616": {"vr": "DS", "Value": [99.0]},
        "617": {"vr": "DS", "Value": [166.0]},
        "618": {"vr": "DS", "Value": [66.0]},
        "619": {"vr": "DS", "Value": [121.0]},
        "620": {"vr": "DS", "Value": [129.0]},
        "621": {"vr": "DS", "Value": [69.0]},
        "622": {"vr": "DS", "Value": [110.0]},
        "623": {"vr": "DS", "Value": [56.0]},
        "624": {"vr": "DS", "Value": [635.0]},
        "625": {"vr": "DS", "Value": [149.0]},
        "626": {"vr": "DS", "Value": [104.0]},
        "627": {"vr": "DS", "Value": [146.0]},
        "628": {"vr": "DS", "Value": [121.0]},
        "629": {"vr": "DS", "Value": [143.0]},
        "630": {"vr": "DS", "Value": [138.0]},
        "631": {"vr": "DS", "Value": [107.0]},
        "632": {"vr": "DS", "Value": [87.0]},
        "633": {"vr": "DS", "Value": [142.0]},
        "634": {"vr": "DS", "Value": [118.0]},
        "635": {"vr": "DS", "Value": [72.0]},
        "636": {"vr": "DS", "Value": [160.0]},
        "637": {"vr": "DS", "Value": [134.0]},
        "638": {"vr": "DS", "Value": [133.0]},
        "639": {"vr": "DS", "Value": [145.0]},
        "640": {"vr": "DS", "Value": [119.0]},
        "641": {"vr": "DS", "Value": [143.0]},
        "642": {"vr": "DS", "Value": [157.0]},
        "643": {"vr": "DS", "Value": [112.0]},
        "644": {"vr": "DS", "Value": [108.0]},
        "645": {"vr": "DS", "Value": [139.0]},
        "646": {"vr": "DS", "Value": [62.0]},
        "647": {"vr": "DS", "Value": [145.0]},
        "648": {"vr": "DS", "Value": [91.0]},
        "649": {"vr": "DS", "Value": [65.0]},
        "650": {"vr": "DS", "Value": [82.0]},
        "651": {"vr": "DS", "Value": [109.0]},
        "652": {"vr": "DS", "Value": [142.0]},
        "653": {"vr": "DS", "Value": [118.0]},
        "654": {"vr": "DS", "Value": [142.0]},
        "655": {"vr": "DS", "Value": [144.0]},
        "656": {"vr": "DS", "Value": [139.0]},
        "657": {"vr": "DS", "Value": [146.0]},
        "658": {"vr": "DS", "Value": [148.0]},
        "659": {"vr": "DS", "Value": [145.0]},
        "660": {"vr": "DS", "Value": [137.0]},
        "661": {"vr": "DS", "Value": [123.0]},
        "662": {"vr": "DS", "Value": [146.0]},
        "663": {"vr": "DS", "Value": [155.0]},
        "664": {"vr": "DS", "Value": [131.0]},
        "665": {"vr": "DS", "Value": [154.0]},
        "666": {"vr": "DS", "Value": [131.0]},
        "667": {"vr": "DS", "Value": [114.0]},
        "668": {"vr": "DS", "Value": [684.0]},
        "669": {"vr": "DS", "Value": [144.0]},
        "670": {"vr": "DS", "Value": [150.0]},
        "671": {"vr": "DS", "Value": [65.0]},
        "672": {"vr": "DS", "Value": [107.0]},
        "673": {"vr": "DS", "Value": [116.0]},
        "674": {"vr": "DS", "Value": [127.0]},
        "675": {"vr": "DS", "Value": [103.0]},
        "676": {"vr": "DS", "Value": [140.0]},
        "677": {"vr": "DS", "Value": [140.0]},
        "678": {"vr": "DS", "Value": [124.0]},
        "679": {"vr": "DS", "Value": [620.0]},
        "680": {"vr": "DS", "Value": [103.0]},
        "681": {"vr": "DS", "Value": [101.0]},
        "682": {"vr": "DS", "Value": [152.0]},
        "683": {"vr": "DS", "Value": [58.0]},
        "684": {"vr": "DS", "Value": [67.0]},
        "685": {"vr": "DS", "Value": [111.0]},
        "686": {"vr": "DS", "Value": [141.0]},
        "687": {"vr": "DS", "Value": [634.0]},
        "688": {"vr": "DS", "Value": [143.0]},
        "689": {"vr": "DS", "Value": [147.0]},
        "690": {"vr": "DS", "Value": [663.0]},
        "691": {"vr": "DS", "Value": [129.0]},
        "692": {"vr": "DS", "Value": [116.0]},
        "693": {"vr": "DS", "Value": [133.0]},
        "694": {"vr": "DS", "Value": [133.0]},
        "695": {"vr": "DS", "Value": [124.0]},
        "696": {"vr": "DS", "Value": [147.0]},
        "697": {"vr": "DS", "Value": [98.0]},
        "698": {"vr": "DS", "Value": [119.0]},
        "699": {"vr": "DS", "Value": [756.0]},
        "700": {"vr": "DS", "Value": [62.0]},
        "701": {"vr": "DS", "Value": [147.0]},
        "702": {"vr": "DS", "Value": [151.0]},
        "703": {"vr": "DS", "Value": [147.0]},
        "704": {"vr": "DS", "Value": [63.0]},
        "705": {"vr": "DS", "Value": [145.0]},
        "706": {"vr": "DS", "Value": [118.0]},
        "707": {"vr": "DS", "Value": [649.0]},
        "708": {"vr": "DS", "Value": [113.0]},
        "709": {"vr": "DS", "Value": [106.0]},
        "710": {"vr": "DS", "Value": [151.0]},
        "711": {"vr": "DS", "Value": [147.0]},
        "712": {"vr": "DS", "Value": [93.0]},
        "713": {"vr": "DS", "Value": [138.0]},
        "714": {"vr": "DS", "Value": [697.0]},
        "715": {"vr": "DS", "Value": [639.0]},
        "716": {"vr": "DS", "Value": [139.0]},
        "717": {"vr": "DS", "Value": [75.0]},
        "718": {"vr": "DS", "Value": [130.0]},
        "719": {"vr": "DS", "Value": [147.0]},
        "720": {"vr": "DS", "Value": [126.0]},
        "721": {"vr": "DS", "Value": [77.0]},
        "722": {"vr": "DS", "Value": [101.0]},
        "723": {"vr": "DS", "Value": [59.0]},
        "724": {"vr": "DS", "Value": [143.0]},
        "725": {"vr": "DS", "Value": [136.0]},
        "726": {"vr": "DS", "Value": [160.0]},
        "727": {"vr": "DS", "Value": [145.0]},
        "728": {"vr": "DS", "Value": [151.0]},
        "729": {"vr": "DS", "Value": [123.0]},
        "730": {"vr": "DS", "Value": [135.0]},
        "731": {"vr": "DS", "Value": [138.0]},
        "732": {"vr": "DS", "Value": [684.0]},
        "733": {"vr": "DS", "Value": [61.0]},
        "734": {"vr": "DS", "Value": [126.0]},
        "735": {"vr": "DS", "Value": [130.0]},
        "736": {"vr": "DS", "Value": [147.0]},
        "737": {"vr": "DS", "Value": [129.0]},
        "738": {"vr": "DS", "Value": [154.0]},
        "739": {"vr": "DS", "Value": [105.0]},
        "740": {"vr": "DS", "Value": [155.0]},
        "741": {"vr": "DS", "Value": [132.0]},
        "742": {"vr": "DS", "Value": [147.0]},
        "743": {"vr": "DS", "Value": [138.0]},
        "744": {"vr": "DS", "Value": [140.0]},
        "745": {"vr": "DS", "Value": [134.0]},
        "746": {"vr": "DS", "Value": [131.0]},
        "747": {"vr": "DS", "Value": [111.0]},
        "748": {"vr": "DS", "Value": [132.0]},
        "749": {"vr": "DS", "Value": [131.0]},
        "750": {"vr": "DS", "Value": [134.0]},
        "751": {"vr": "DS", "Value": [136.0]},
        "752": {"vr": "DS", "Value": [74.0]},
        "753": {"vr": "DS", "Value": [152.0]},
        "754": {"vr": "DS", "Value": [107.0]},
        "755": {"vr": "DS", "Value": [125.0]},
        "756": {"vr": "DS", "Value": [88.0]},
        "757": {"vr": "DS", "Value": [582.0]},
        "758": {"vr": "DS", "Value": [137.0]},
        "759": {"vr": "DS", "Value": [141.0]},
        "760": {"vr": "DS", "Value": [138.0]},
        "761": {"vr": "DS", "Value": [63.0]},
        "762": {"vr": "DS", "Value": [151.0]},
        "763": {"vr": "DS", "Value": [128.0]},
        "764": {"vr": "DS", "Value": [124.0]},
        "765": {"vr": "DS", "Value": [156.0]},
        "766": {"vr": "DS", "Value": [90.0]},
        "767": {"vr": "DS", "Value": [142.0]},
        "768": {"vr": "DS", "Value": [109.0]},
        "769": {"vr": "DS", "Value": [62.0]},
        "770": {"vr": "DS", "Value": [140.0]},
        "771": {"vr": "DS", "Value": [638.0]},
        "772": {"vr": "DS", "Value": [139.0]},
        "773": {"vr": "DS", "Value": [148.0]},
        "774": {"vr": "DS", "Value": [151.0]},
        "775": {"vr": "DS", "Value": [98.0]},
        "776": {"vr": "DS", "Value": [116.0]},
        "777": {"vr": "DS", "Value": [712.0]},
        "778": {"vr": "DS", "Value": [22.0]},
        "779": {"vr": "DS", "Value": [159.0]},
        "780": {"vr": "DS", "Value": [88.0]},
        "781": {"vr": "DS", "Value": [128.0]},
        "782": {"vr": "DS", "Value": [125.0]},
        "783": {"vr": "DS", "Value": [126.0]},
        "784": {"vr": "DS", "Value": [149.0]},
        "785": {"vr": "DS", "Value": [143.0]},
        "786": {"vr": "DS", "Value": [129.0]},
        "787": {"vr": "DS", "Value": [19.0]},
        "788": {"vr": "DS", "Value": [685.0]},
        "789": {"vr": "DS", "Value": [103.0]},
        "790": {"vr": "DS", "Value": [60.0]},
        "791": {"vr": "DS", "Value": [643.0]},
        "792": {"vr": "DS", "Value": [140.0]},
        "793": {"vr": "DS", "Value": [136.0]},
        "794": {"vr": "DS", "Value": [147.0]},
        "795": {"vr": "DS", "Value": [139.0]},
        "796": {"vr": "DS", "Value": [151.0]},
        "797": {"vr": "DS", "Value": [147.0]},
        "798": {"vr": "DS", "Value": [142.0]},
        "799": {"vr": "DS", "Value": [99.0]},
        "800": {"vr": "DS", "Value": [117.0]},
        "801": {"vr": "DS", "Value": [111.0]},
        "802": {"vr": "DS", "Value": [111.0]},
        "803": {"vr": "DS", "Value": [144.0]},
        "804": {"vr": "DS", "Value": [136.0]},
        "805": {"vr": "DS", "Value": [142.0]},
        "806": {"vr": "DS", "Value": [18.0]},
        "807": {"vr": "DS", "Value": [146.0]},
        "808": {"vr": "DS", "Value": [137.0]},
        "809": {"vr": "DS", "Value": [150.0]},
        "810": {"vr": "DS", "Value": [596.0]},
        "811": {"vr": "DS", "Value": [135.0]},
        "812": {"vr": "DS", "Value": [21.0]},
        "813": {"vr": "DS", "Value": [112.0]},
        "814": {"vr": "DS", "Value": [146.0]},
        "815": {"vr": "DS", "Value": [146.0]},
        "816": {"vr": "DS", "Value": [622.0]},
        "817": {"vr": "DS", "Value": [147.0]},
        "818": {"vr": "DS", "Value": [125.0]},
        "819": {"vr": "DS", "Value": [60.0]},
        "820": {"vr": "DS", "Value": [621.0]},
        "821": {"vr": "DS", "Value": [91.0]},
        "822": {"vr": "DS", "Value": [130.0]},
        "823": {"vr": "DS", "Value": [88.0]},
        "824": {"vr": "DS", "Value": [147.0]},
        "825": {"vr": "DS", "Value": [130.0]},
        "826": {"vr": "DS", "Value": [76.0]},
        "827": {"vr": "DS", "Value": [660.0]},
        "828": {"vr": "DS", "Value": [135.0]},
        "829": {"vr": "DS", "Value": [667.0]},
        "830": {"vr": "DS", "Value": [63.0]},
        "831": {"vr": "DS", "Value": [137.0]},
        "832": {"vr": "DS", "Value": [145.0]},
        "833": {"vr": "DS", "Value": [94.0]},
        "834": {"vr": "DS", "Value": [101.0]},
        "835": {"vr": "DS", "Value": [149.0]},
        "836": {"vr": "DS", "Value": [117.0]},
        "837": {"vr": "DS", "Value": [137.0]},
        "838": {"vr": "DS", "Value": [149.0]},
        "839": {"vr": "DS", "Value": [146.0]},
        "840": {"vr": "DS", "Value": [115.0]},
        "841": {"vr": "DS", "Value": [113.0]},
        "842": {"vr": "DS", "Value": [139.0]},
        "843": {"vr": "DS", "Value": [168.0]},
        "844": {"vr": "DS", "Value": [141.0]},
        "845": {"vr": "DS", "Value": [85.0]},
        "846": {"vr": "DS", "Value": [574.0]},
        "847": {"vr": "DS", "Value": [134.0]},
        "848": {"vr": "DS", "Value": [66.0]},
        "849": {"vr": "DS", "Value": [145.0]},
        "850": {"vr": "DS", "Value": [622.0]},
        "851": {"vr": "DS", "Value": [123.0]},
        "852": {"vr": "DS", "Value": [125.0]},
        "853": {"vr": "DS", "Value": [132.0]},
        "854": {"vr": "DS", "Value": [144.0]},
        "855": {"vr": "DS", "Value": [142.0]},
        "856": {"vr": "DS", "Value": [130.0]},
        "857": {"vr": "DS", "Value": [128.0]},
        "858": {"vr": "DS", "Value": [98.0]},
        "859": {"vr": "DS", "Value": [109.0]},
        "860": {"vr": "DS", "Value": [82.0]},
        "861": {"vr": "DS", "Value": [623.0]},
        "862": {"vr": "DS", "Value": [138.0]},
        "863": {"vr": "DS", "Value": [146.0]},
        "864": {"vr": "DS", "Value": [92.0]},
        "865": {"vr": "DS", "Value": [75.0]},
        "866": {"vr": "DS", "Value": [134.0]},
        "867": {"vr": "DS", "Value": [672.0]},
        "868": {"vr": "DS", "Value": [619.0]},
        "869": {"vr": "DS", "Value": [88.0]},
        "870": {"vr": "DS", "Value": [167.0]},
        "871": {"vr": "DS", "Value": [115.0]},
        "872": {"vr": "DS", "Value": [136.0]},
        "873": {"vr": "DS", "Value": [135.0]},
        "874": {"vr": "DS", "Value": [140.0]},
        "875": {"vr": "DS", "Value": [714.0]},
        "876": {"vr": "DS", "Value": [111.0]},
        "877": {"vr": "DS", "Value": [146.0]},
        "878": {"vr": "DS", "Value": [143.0]},
        "879": {"vr": "DS", "Value": [135.0]},
        "880": {"vr": "DS", "Value": [145.0]},
        "881": {"vr": "DS", "Value": [143.0]},
        "882": {"vr": "DS", "Value": [135.0]},
        "883": {"vr": "DS", "Value": [110.0]},
        "884": {"vr": "DS", "Value": [141.0]},
        "885": {"vr": "DS", "Value": [731.0]},
        "886": {"vr": "DS", "Value": [137.0]},
        "887": {"vr": "DS", "Value": [139.0]},
        "888": {"vr": "DS", "Value": [120.0]},
        "889": {"vr": "DS", "Value": [138.0]},
        "890": {"vr": "DS", "Value": [134.0]},
        "891": {"vr": "DS", "Value": [59.0]},
        "892": {"vr": "DS", "Value": [128.0]},
        "893": {"vr": "DS", "Value": [137.0]},
        "894": {"vr": "DS", "Value": [143.0]},
        "895": {"vr": "DS", "Value": [118.0]},
        "896": {"vr": "DS", "Value": [63.0]},
        "897": {"vr": "DS", "Value": [131.0]},
        "898": {"vr": "DS", "Value": [142.0]},
        "899": {"vr": "DS", "Value": [143.0]},
        "900": {"vr": "DS", "Value": [137.0]},
        "901": {"vr": "DS", "Value": [148.0]},
        "902": {"vr": "DS", "Value": [133.0]},
        "903": {"vr": "DS", "Value": [150.0]},
        "904": {"vr": "DS", "Value": [143.0]},
        "905": {"vr": "DS", "Value": [135.0]},
        "906": {"vr": "DS", "Value": [130.0]},
        "907": {"vr": "DS", "Value": [146.0]},
        "908": {"vr": "DS", "Value": [139.0]},
        "909": {"vr": "DS", "Value": [148.0]},
        "910": {"vr": "DS", "Value": [62.0]},
        "911": {"vr": "DS", "Value": [141.0]},
        "912": {"vr": "DS", "Value": [116.0]},
        "913": {"vr": "DS", "Value": [56.0]},
        "914": {"vr": "DS", "Value": [146.0]},
        "915": {"vr": "DS", "Value": [127.0]},
        "916": {"vr": "DS", "Value": [25.0]},
        "917": {"vr": "DS", "Value": [108.0]},
        "918": {"vr": "DS", "Value": [148.0]},
        "919": {"vr": "DS", "Value": [620.0]},
        "920": {"vr": "DS", "Value": [69.0]},
        "921": {"vr": "DS", "Value": [142.0]},
        "922": {"vr": "DS", "Value": [156.0]},
        "923": {"vr": "DS", "Value": [66.0]},
        "924": {"vr": "DS", "Value": [558.0]},
        "925": {"vr": "DS", "Value": [142.0]},
        "926": {"vr": "DS", "Value": [664.0]},
        "927": {"vr": "DS", "Value": [64.0]},
        "928": {"vr": "DS", "Value": [107.0]},
        "929": {"vr": "DS", "Value": [112.0]},
        "930": {"vr": "DS", "Value": [140.0]},
        "931": {"vr": "DS", "Value": [76.0]},
        "932": {"vr": "DS", "Value": [698.0]},
        "933": {"vr": "DS", "Value": [144.0]},
        "934": {"vr": "DS", "Value": [155.0]},
        "935": {"vr": "DS", "Value": [122.0]},
        "936": {"vr": "DS", "Value": [657.0]},
        "937": {"vr": "DS", "Value": [144.0]},
        "938": {"vr": "DS", "Value": [65.0]},
        "939": {"vr": "DS", "Value": [136.0]},
        "940": {"vr": "DS", "Value": [148.0]},
        "941": {"vr": "DS", "Value": [64.0]},
        "942": {"vr": "DS", "Value": [137.0]},
        "943": {"vr": "DS", "Value": [143.0]},
        "944": {"vr": "DS", "Value": [137.0]},
        "945": {"vr": "DS", "Value": [157.0]},
        "946": {"vr": "DS", "Value": [152.0]},
        "947": {"vr": "DS", "Value": [130.0]},
        "948": {"vr": "DS", "Value": [681.0]},
        "949": {"vr": "DS", "Value": [126.0]},
        "950": {"vr": "DS", "Value": [155.0]},
        "951": {"vr": "DS", "Value": [136.0]},
        "952": {"vr": "DS", "Value": [130.0]},
        "953": {"vr": "DS", "Value": [136.0]},
        "954": {"vr": "DS", "Value": [62.0]},
        "955": {"vr": "DS", "Value": [147.0]},
        "956": {"vr": "DS", "Value": [656.0]},
        "957": {"vr": "DS", "Value": [141.0]},
        "958": {"vr": "DS", "Value": [118.0]},
        "959": {"vr": "DS", "Value": [109.0]},
        "960": {"vr": "DS", "Value": [83.0]},
        "961": {"vr": "DS", "Value": [665.0]},
        "962": {"vr": "DS", "Value": [128.0]},
        "963": {"vr": "DS", "Value": [144.0]},
        "964": {"vr": "DS", "Value": [140.0]},
        "965": {"vr": "DS", "Value": [147.0]},
        "966": {"vr": "DS", "Value": [58.0]},
        "967": {"vr": "DS", "Value": [108.0]},
        "968": {"vr": "DS", "Value": [142.0]},
        "969": {"vr": "DS", "Value": [74.0]},
        "970": {"vr": "DS", "Value": [149.0]},
        "971": {"vr": "DS", "Value": [140.0]},
        "972": {"vr": "DS", "Value": [129.0]},
        "973": {"vr": "DS", "Value": [63.0]},
        "974": {"vr": "DS", "Value": [78.0]},
        "975": {"vr": "DS", "Value": [135.0]},
        "976": {"vr": "DS", "Value": [145.0]},
        "977": {"vr": "DS", "Value": [138.0]},
        "978": {"vr": "DS", "Value": [664.0]},
        "979": {"vr": "DS", "Value": [133.0]},
        "980": {"vr": "DS", "Value": [109.0]},
        "981": {"vr": "DS", "Value": [74.0]},
        "982": {"vr": "DS", "Value": [143.0]},
        "983": {"vr": "DS", "Value": [622.0]},
        "984": {"vr": "DS", "Value": [120.0]},
        "985": {"vr": "DS", "Value": [138.0]},
        "986": {"vr": "DS", "Value": [121.0]},
        "987": {"vr": "DS", "Value": [148.0]},
        "988": {"vr": "DS", "Value": [66.0]},
        "989": {"vr": "DS", "Value": [102.0]},
        "990": {"vr": "DS", "Value": [73.0]},
        "991": {"vr": "DS", "Value": [146.0]},
        "992": {"vr": "DS", "Value": [140.0]},
        "993": {"vr": "DS", "Value": [144.0]},
        "994": {"vr": "DS", "Value": [134.0]},
        "995": {"vr": "DS", "Value": [173.0]},
        "996": {"vr": "DS", "Value": [584.0]},
        "997": {"vr": "DS", "Value": [70.0]},
        "998": {"vr": "DS", "Value": [104.0]},
        "999": {"vr": "DS", "Value": [135.0]},
        "1000": {"vr": "DS", "Value": [124.0]},
        "1001": {"vr": "DS", "Value": [150.0]},
        "1002": {"vr": "DS", "Value": [141.0]},
        "1003": {"vr": "DS", "Value": [141.0]},
        "1004": {"vr": "DS", "Value": [84.0]},
        "1005": {"vr": "DS", "Value": [119.0]},
        "1006": {"vr": "DS", "Value": [125.0]},
        "1007": {"vr": "DS", "Value": [140.0]},
        "1008": {"vr": "DS", "Value": [124.0]},
        "1009": {"vr": "DS", "Value": [90.0]},
        "1010": {"vr": "DS", "Value": [124.0]},
        "1011": {"vr": "DS", "Value": [102.0]},
        "1012": {"vr": "DS", "Value": [156.0]},
        "1013": {"vr": "DS", "Value": [136.0]},
        "1014": {"vr": "DS", "Value": [146.0]},
        "1015": {"vr": "DS", "Value": [689.0]},
        "1016": {"vr": "DS", "Value": [652.0]},
        "1017": {"vr": "DS", "Value": [117.0]},
        "1018": {"vr": "DS", "Value": [60.0]},
        "1019": {"vr": "DS", "Value": [137.0]},
        "1020": {"vr": "DS", "Value": [148.0]},
        "1021": {"vr": "DS", "Value": [138.0]},
        "1022": {"vr": "DS", "Value": [123.0]},
        "1023": {"vr": "DS", "Value": [118.0]},
        "1024": {"vr": "DS", "Value": [122.0]},
        "1025": {"vr": "DS", "Value": [161.0]},
        "1026": {"vr": "DS", "Value": [128.0]},
        "1027": {"vr": "DS", "Value": [51.0]},
        "1028": {"vr": "DS", "Value": [138.0]},
        "1029": {"vr": "DS", "Value": [68.0]},
        "1030": {"vr": "DS", "Value": [681.0]},
        "1031": {"vr": "DS", "Value": [151.0]},
        "1032": {"vr": "DS", "Value": [613.0]},
        "1033": {"vr": "DS", "Value": [129.0]},
        "1034": {"vr": "DS", "Value": [146.0]},
        "1035": {"vr": "DS", "Value": [145.0]},
        "1036": {"vr": "DS", "Value": [21.0]},
        "1037": {"vr": "DS", "Value": [134.0]},
        "1038": {"vr": "DS", "Value": [58.0]},
        "1039": {"vr": "DS", "Value": [597.0]},
        "1040": {"vr": "DS", "Value": [134.0]},
        "1041": {"vr": "DS", "Value": [145.0]},
        "1042": {"vr": "DS", "Value": [94.0]},
        "1043": {"vr": "DS", "Value": [134.0]},
        "1044": {"vr": "DS", "Value": [51.0]},
        "1045": {"vr": "DS", "Value": [140.0]},
        "1046": {"vr": "DS", "Value": [65.0]},
        "1047": {"vr": "DS", "Value": [141.0]},
        "1048": {"vr": "DS", "Value": [52.0]},
        "1049": {"vr": "DS", "Value": [157.0]},
        "1050": {"vr": "DS", "Value": [22.0]},
        "1051": {"vr": "DS", "Value": [77.0]},
        "1052": {"vr": "DS", "Value": [138.0]},
        "1053": {"vr": "DS", "Value": [97.0]},
        "1054": {"vr": "DS", "Value": [142.0]},
        "1055": {"vr": "DS", "Value": [130.0]},
        "1056": {"vr": "DS", "Value": [128.0]},
        "1057": {"vr": "DS", "Value": [99.0]},
        "1058": {"vr": "DS", "Value": [51.0]},
        "1059": {"vr": "DS", "Value": [138.0]},
        "1060": {"vr": "DS", "Value": [650.0]},
        "1061": {"vr": "DS", "Value": [121.0]},
        "1062": {"vr": "DS", "Value": [122.0]},
        "1063": {"vr": "DS", "Value": [103.0]},
        "1064": {"vr": "DS", "Value": [144.0]},
        "1065": {"vr": "DS", "Value": [617.0]},
        "1066": {"vr": "DS", "Value": [140.0]},
        "1067": {"vr": "DS", "Value": [138.0]},
        "1068": {"vr": "DS", "Value": [129.0]},
        "1069": {"vr": "DS", "Value": [138.0]},
        "1070": {"vr": "DS", "Value": [113.0]},
        "1071": {"vr": "DS", "Value": [127.0]},
        "1072": {"vr": "DS", "Value": [141.0]},
        "1073": {"vr": "DS", "Value": [373.0]},
        "1074": {"vr": "DS", "Value": [138.0]},
        "1075": {"vr": "DS", "Value": [123.0]},
        "1076": {"vr": "DS", "Value": [126.0]},
        "1077": {"vr": "DS", "Value": [102.0]},
        "1078": {"vr": "DS", "Value": [68.0]},
        "1079": {"vr": "DS", "Value": [65.0]},
        "1080": {"vr": "DS", "Value": [102.0]},
        "1081": {"vr": "DS", "Value": [679.0]},
        "1082": {"vr": "DS", "Value": [83.0]},
        "1083": {"vr": "DS", "Value": [129.0]},
        "1084": {"vr": "DS", "Value": [91.0]},
        "1085": {"vr": "DS", "Value": [137.0]},
        "1086": {"vr": "DS", "Value": [112.0]},
        "1087": {"vr": "DS", "Value": [141.0]},
        "1088": {"vr": "DS", "Value": [707.0]},
        "1089": {"vr": "DS", "Value": [134.0]},
        "1090": {"vr": "DS", "Value": [614.0]},
        "1091": {"vr": "DS", "Value": [730.0]},
        "1092": {"vr": "DS", "Value": [128.0]},
        "1093": {"vr": "DS", "Value": [121.0]},
        "1094": {"vr": "DS", "Value": [153.0]},
        "1095": {"vr": "DS", "Value": [124.0]},
        "1096": {"vr": "DS", "Value": [136.0]},
        "1097": {"vr": "DS", "Value": [671.0]},
        "1098": {"vr": "DS", "Value": [60.0]},
        "1099": {"vr": "DS", "Value": [95.0]},
        "1100": {"vr": "DS", "Value": [134.0]},
        "1101": {"vr": "DS", "Value": [104.0]},
        "1102": {"vr": "DS", "Value": [129.0]},
        "1103": {"vr": "DS", "Value": [126.0]},
        "1104": {"vr": "DS", "Value": [142.0]},
        "1105": {"vr": "DS", "Value": [666.0]},
        "1106": {"vr": "DS", "Value": [115.0]},
        "1107": {"vr": "DS", "Value": [164.0]},
        "1108": {"vr": "DS", "Value": [154.0]},
        "1109": {"vr": "DS", "Value": [139.0]},
        "1110": {"vr": "DS", "Value": [581.0]},
        "1111": {"vr": "DS", "Value": [131.0]},
        "1112": {"vr": "DS", "Value": [117.0]},
        "1113": {"vr": "DS", "Value": [95.0]},
        "1114": {"vr": "DS", "Value": [147.0]},
        "1115": {"vr": "DS", "Value": [109.0]},
        "1116": {"vr": "DS", "Value": [150.0]},
        "1117": {"vr": "DS", "Value": [139.0]},
        "1118": {"vr": "DS", "Value": [145.0]},
        "1119": {"vr": "DS", "Value": [123.0]},
        "1120": {"vr": "DS", "Value": [117.0]},
        "1121": {"vr": "DS", "Value": [63.0]},
        "1122": {"vr": "DS", "Value": [94.0]},
        "1123": {"vr": "DS", "Value": [130.0]},
        "1124": {"vr": "DS", "Value": [76.0]},
        "1125": {"vr": "DS", "Value": [128.0]},
        "1126": {"vr": "DS", "Value": [144.0]},
        "1127": {"vr": "DS", "Value": [117.0]},
        "1128": {"vr": "DS", "Value": [133.0]},
        "1129": {"vr": "DS", "Value": [132.0]},
        "1130": {"vr": "DS", "Value": [143.0]},
        "1131": {"vr": "DS", "Value": [724.0]},
        "1132": {"vr": "DS", "Value": [131.0]},
        "1133": {"vr": "DS", "Value": [120.0]},
        "1134": {"vr": "DS", "Value": [101.0]},
        "1135": {"vr": "DS", "Value": [140.0]},
        "1136": {"vr": "DS", "Value": [704.0]},
        "1137": {"vr": "DS", "Value": [22.0]},
        "1138": {"vr": "DS", "Value": [139.0]},
        "1139": {"vr": "DS", "Value": [144.0]},
        "1140": {"vr": "DS", "Value": [124.0]},
        "1141": {"vr": "DS", "Value": [132.0]},
        "1142": {"vr": "DS", "Value": [104.0]},
        "1143": {"vr": "DS", "Value": [134.0]},
        "1144": {"vr": "DS", "Value": [116.0]},
        "1145": {"vr": "DS", "Value": [148.0]},
        "1146": {"vr": "DS", "Value": [141.0]},
        "1147": {"vr": "DS", "Value": [682.0]},
        "1148": {"vr": "DS", "Value": [682.0]},
        "1149": {"vr": "DS", "Value": [621.0]},
        "1150": {"vr": "DS", "Value": [69.0]},
        "1151": {"vr": "DS", "Value": [100.0]},
        "1152": {"vr": "DS", "Value": [134.0]},
        "1153": {"vr": "DS", "Value": [134.0]},
        "1154": {"vr": "DS", "Value": [137.0]},
        "1155": {"vr": "DS", "Value": [149.0]},
        "1156": {"vr": "DS", "Value": [128.0]},
        "1157": {"vr": "DS", "Value": [136.0]},
        "1158": {"vr": "DS", "Value": [120.0]},
        "1159": {"vr": "DS", "Value": [152.0]},
        "1160": {"vr": "DS", "Value": [133.0]},
        "1161": {"vr": "DS", "Value": [139.0]},
        "1162": {"vr": "DS", "Value": [96.0]},
        "1163": {"vr": "DS", "Value": [74.0]},
        "1164": {"vr": "DS", "Value": [66.0]},
        "1165": {"vr": "DS", "Value": [646.0]},
        "1166": {"vr": "DS", "Value": [686.0]},
        "1167": {"vr": "DS", "Value": [127.0]},
        "1168": {"vr": "DS", "Value": [76.0]},
        "1169": {"vr": "DS", "Value": [127.0]},
        "1170": {"vr": "DS", "Value": [75.0]},
        "1171": {"vr": "DS", "Value": [122.0]},
        "1172": {"vr": "DS", "Value": [140.0]},
        "1173": {"vr": "DS", "Value": [144.0]},
        "1174": {"vr": "DS", "Value": [146.0]},
        "1175": {"vr": "DS", "Value": [116.0]},
        "1176": {"vr": "DS", "Value": [142.0]},
        "1177": {"vr": "DS", "Value": [102.0]},
        "1178": {"vr": "DS", "Value": [760.0]},
        "1179": {"vr": "DS", "Value": [156.0]},
        "1180": {"vr": "DS", "Value": [59.0]},
        "1181": {"vr": "DS", "Value": [65.0]},
        "1182": {"vr": "DS", "Value": [66.0]},
        "1183": {"vr": "DS", "Value": [142.0]},
        "1184": {"vr": "DS", "Value": [134.0]},
        "1185": {"vr": "DS", "Value": [99.0]},
        "1186": {"vr": "DS", "Value": [115.0]},
        "1187": {"vr": "DS", "Value": [113.0]},
        "1188": {"vr": "DS", "Value": [138.0]},
        "1189": {"vr": "DS", "Value": [636.0]},
        "1190": {"vr": "DS", "Value": [121.0]},
        "1191": {"vr": "DS", "Value": [640.0]},
        "1192": {"vr": "DS", "Value": [143.0]},
        "1193": {"vr": "DS", "Value": [532.0]},
        "1194": {"vr": "DS", "Value": [138.0]},
        "1195": {"vr": "DS", "Value": [129.0]},
        "1196": {"vr": "DS", "Value": [108.0]},
        "1197": {"vr": "DS", "Value": [133.0]},
        "1198": {"vr": "DS", "Value": [120.0]},
        "1199": {"vr": "DS", "Value": [148.0]},
        "1200": {"vr": "DS", "Value": [136.0]},
        "1201": {"vr": "DS", "Value": [392.0]},
        "1202": {"vr": "DS", "Value": [162.0]},
        "1203": {"vr": "DS", "Value": [112.0]},
        "1204": {"vr": "DS", "Value": [144.0]},
        "1205": {"vr": "DS", "Value": [123.0]},
        "1206": {"vr": "DS", "Value": [144.0]},
        "1207": {"vr": "DS", "Value": [68.0]},
        "1208": {"vr": "DS", "Value": [140.0]},
        "1209": {"vr": "DS", "Value": [62.0]},
        "1210": {"vr": "DS", "Value": [144.0]},
        "1211": {"vr": "DS", "Value": [137.0]},
        "1212": {"vr": "DS", "Value": [147.0]},
        "1213": {"vr": "DS", "Value": [146.0]},
        "1214": {"vr": "DS", "Value": [73.0]},
        "1215": {"vr": "DS", "Value": [134.0]},
        "1216": {"vr": "DS", "Value": [77.0]},
        "1217": {"vr": "DS", "Value": [110.0]},
        "1218": {"vr": "DS", "Value": [108.0]},
        "1219": {"vr": "DS", "Value": [677.0]},
        "1220": {"vr": "DS", "Value": [664.0]},
        "1221": {"vr": "DS", "Value": [140.0]},
        "1222": {"vr": "DS", "Value": [137.0]},
        "1223": {"vr": "DS", "Value": [83.0]},
        "1224": {"vr": "DS", "Value": [134.0]},
        "1225": {"vr": "DS", "Value": [134.0]},
        "1226": {"vr": "DS", "Value": [139.0]},
        "1227": {"vr": "DS", "Value": [108.0]},
        "1228": {"vr": "DS", "Value": [128.0]},
        "1229": {"vr": "DS", "Value": [130.0]},
        "1230": {"vr": "DS", "Value": [145.0]},
        "1231": {"vr": "DS", "Value": [100.0]},
        "1232": {"vr": "DS", "Value": [81.0]},
        "1233": {"vr": "DS", "Value": [136.0]},
        "1234": {"vr": "DS", "Value": [144.0]},
        "1235": {"vr": "DS", "Value": [138.0]},
        "1236": {"vr": "DS", "Value": [118.0]},
        "1237": {"vr": "DS", "Value": [136.0]},
        "1238": {"vr": "DS", "Value": [146.0]},
        "1239": {"vr": "DS", "Value": [113.0]},
        "1240": {"vr": "DS", "Value": [79.0]},
        "1241": {"vr": "DS", "Value": [61.0]},
        "1242": {"vr": "DS", "Value": [133.0]},
        "1243": {"vr": "DS", "Value": [135.0]},
        "1244": {"vr": "DS", "Value": [145.0]},
        "1245": {"vr": "DS", "Value": [132.0]},
        "1246": {"vr": "DS", "Value": [134.0]},
        "1247": {"vr": "DS", "Value": [123.0]},
        "1248": {"vr": "DS", "Value": [124.0]},
        "1249": {"vr": "DS", "Value": [109.0]},
        "1250": {"vr": "DS", "Value": [91.0]},
        "1251": {"vr": "DS", "Value": [139.0]},
        "1252": {"vr": "DS", "Value": [155.0]},
        "1253": {"vr": "DS", "Value": [132.0]},
        "1254": {"vr": "DS", "Value": [132.0]},
        "1255": {"vr": "DS", "Value": [138.0]},
        "1256": {"vr": "DS", "Value": [106.0]},
        "1257": {"vr": "DS", "Value": [130.0]},
        "1258": {"vr": "DS", "Value": [143.0]},
        "1259": {"vr": "DS", "Value": [115.0]},
        "1260": {"vr": "DS", "Value": [620.0]},
        "1261": {"vr": "DS", "Value": [58.0]},
        "1262": {"vr": "DS", "Value": [135.0]},
        "1263": {"vr": "DS", "Value": [139.0]},
        "1264": {"vr": "DS", "Value": [654.0]},
        "1265": {"vr": "DS", "Value": [140.0]},
        "1266": {"vr": "DS", "Value": [136.0]},
        "1267": {"vr": "DS", "Value": [114.0]},
        "1268": {"vr": "DS", "Value": [106.0]},
        "1269": {"vr": "DS", "Value": [59.0]},
        "1270": {"vr": "DS", "Value": [143.0]},
        "1271": {"vr": "DS", "Value": [633.0]},
        "1272": {"vr": "DS", "Value": [117.0]},
        "1273": {"vr": "DS", "Value": [66.0]},
        "1274": {"vr": "DS", "Value": [143.0]},
        "1275": {"vr": "DS", "Value": [131.0]},
        "1276": {"vr": "DS", "Value": [110.0]},
        "1277": {"vr": "DS", "Value": [159.0]},
        "1278": {"vr": "DS", "Value": [147.0]},
        "1279": {"vr": "DS", "Value": [111.0]},
        "1280": {"vr": "DS", "Value": [124.0]},
        "1281": {"vr": "DS", "Value": [148.0]},
        "1282": {"vr": "DS", "Value": [701.0]},
        "1283": {"vr": "DS", "Value": [72.0]},
        "1284": {"vr": "DS", "Value": [140.0]},
        "1285": {"vr": "DS", "Value": [128.0]},
        "1286": {"vr": "DS", "Value": [61.0]},
        "1287": {"vr": "DS", "Value": [128.0]},
        "1288": {"vr": "DS", "Value": [141.0]},
        "1289": {"vr": "DS", "Value": [138.0]},
        "1290": {"vr": "DS", "Value": [149.0]},
        "1291": {"vr": "DS", "Value": [141.0]},
        "1292": {"vr": "DS", "Value": [144.0]},
        "1293": {"vr": "DS", "Value": [127.0]},
        "1294": {"vr": "DS", "Value": [133.0]},
        "1295": {"vr": "DS", "Value": [110.0]},
        "1296": {"vr": "DS", "Value": [136.0]},
        "1297": {"vr": "DS", "Value": [63.0]},
        "1298": {"vr": "DS", "Value": [144.0]},
        "1299": {"vr": "DS", "Value": [19.0]},
        "1300": {"vr": "DS", "Value": [682.0]},
        "1301": {"vr": "DS", "Value": [126.0]},
        "1302": {"vr": "DS", "Value": [119.0]},
        "1303": {"vr": "DS", "Value": [126.0]},
        "1304": {"vr": "DS", "Value": [133.0]},
        "1305": {"vr": "DS", "Value": [97.0]},
        "1306": {"vr": "DS", "Value": [155.0]},
        "1307": {"vr": "DS", "Value": [135.0]},
        "1308": {"vr": "DS", "Value": [141.0]},
        "1309": {"vr": "DS", "Value": [611.0]},
        "1310": {"vr": "DS", "Value": [141.0]},
        "1311": {"vr": "DS", "Value": [143.0]},
        "1312": {"vr": "DS", "Value": [117.0]},
        "1313": {"vr": "DS", "Value": [134.0]},
        "1314": {"vr": "DS", "Value": [136.0]},
        "1315": {"vr": "DS", "Value": [93.0]},
        "1316": {"vr": "DS", "Value": [140.0]},
        "1317": {"vr": "DS", "Value": [150.0]},
        "1318": {"vr": "DS", "Value": [127.0]},
        "1319": {"vr": "DS", "Value": [150.0]},
        "1320": {"vr": "DS", "Value": [112.0]},
        "1321": {"vr": "DS", "Value": [153.0]},
        "1322": {"vr": "DS", "Value": [64.0]},
        "1323": {"vr": "DS", "Value": [146.0]},
        "1324": {"vr": "DS", "Value": [663.0]},
        "1325": {"vr": "DS", "Value": [130.0]},
        "1326": {"vr": "DS", "Value": [498.0]},
        "1327": {"vr": "DS", "Value": [142.0]},
        "1328": {"vr": "DS", "Value": [132.0]},
        "1329": {"vr": "DS", "Value": [141.0]},
        "1330": {"vr": "DS", "Value": [617.0]},
        "1331": {"vr": "DS", "Value": [148.0]},
        "1332": {"vr": "DS", "Value": [139.0]},
        "1333": {"vr": "DS", "Value": [730.0]},
        "1334": {"vr": "DS", "Value": [134.0]},
        "1335": {"vr": "DS", "Value": [125.0]},
        "1336": {"vr": "DS", "Value": [140.0]},
        "1337": {"vr": "DS", "Value": [136.0]},
        "1338": {"vr": "DS", "Value": [144.0]},
        "1339": {"vr": "DS", "Value": [76.0]},
        "1340": {"vr": "DS", "Value": [135.0]},
        "1341": {"vr": "DS", "Value": [133.0]},
        "1342": {"vr": "DS", "Value": [137.0]},
        "1343": {"vr": "DS", "Value": [126.0]},
        "1344": {"vr": "DS", "Value": [128.0]},
        "1345": {"vr": "DS", "Value": [116.0]},
        "1346": {"vr": "DS", "Value": [90.0]},
        "1347": {"vr": "DS", "Value": [626.0]},
        "1348": {"vr": "DS", "Value": [139.0]},
        "1349": {"vr": "DS", "Value": [70.0]},
        "1350": {"vr": "DS", "Value": [127.0]},
        "1351": {"vr": "DS", "Value": [131.0]},
        "1352": {"vr": "DS", "Value": [140.0]},
        "1353": {"vr": "DS", "Value": [69.0]},
        "1354": {"vr": "DS", "Value": [119.0]},
        "1355": {"vr": "DS", "Value": [137.0]},
        "1356": {"vr": "DS", "Value": [137.0]},
        "1357": {"vr": "DS", "Value": [136.0]},
        "1358": {"vr": "DS", "Value": [675.0]},
        "1359": {"vr": "DS", "Value": [152.0]},
        "1360": {"vr": "DS", "Value": [154.0]},
        "1361": {"vr": "DS", "Value": [143.0]},
        "1362": {"vr": "DS", "Value": [151.0]},
        "1363": {"vr": "DS", "Value": [132.0]},
        "1364": {"vr": "DS", "Value": [19.0]},
        "1365": {"vr": "DS", "Value": [113.0]},
        "1366": {"vr": "DS", "Value": [134.0]},
        "1367": {"vr": "DS", "Value": [137.0]},
        "1368": {"vr": "DS", "Value": [63.0]},
        "1369": {"vr": "DS", "Value": [151.0]},
        "1370": {"vr": "DS", "Value": [149.0]},
        "1371": {"vr": "DS", "Value": [67.0]},
        "1372": {"vr": "DS", "Value": [138.0]},
        "1373": {"vr": "DS", "Value": [146.0]},
        "1374": {"vr": "DS", "Value": [143.0]},
        "1375": {"vr": "DS", "Value": [656.0]},
        "1376": {"vr": "DS", "Value": [150.0]},
        "1377": {"vr": "DS", "Value": [148.0]},
        "1378": {"vr": "DS", "Value": [149.0]},
        "1379": {"vr": "DS", "Value": [147.0]},
        "1380": {"vr": "DS", "Value": [125.0]},
        "1381": {"vr": "DS", "Value": [691.0]},
        "1382": {"vr": "DS", "Value": [140.0]},
        "1383": {"vr": "DS", "Value": [142.0]},
        "1384": {"vr": "DS", "Value": [66.0]},
        "1385": {"vr": "DS", "Value": [63.0]},
        "1386": {"vr": "DS", "Value": [145.0]},
        "1387": {"vr": "DS", "Value": [139.0]},
        "1388": {"vr": "DS", "Value": [100.0]},
        "1389": {"vr": "DS", "Value": [143.0]},
        "1390": {"vr": "DS", "Value": [129.0]},
        "1391": {"vr": "DS", "Value": [138.0]},
        "1392": {"vr": "DS", "Value": [140.0]},
        "1393": {"vr": "DS", "Value": [148.0]},
        "1394": {"vr": "DS", "Value": [152.0]},
        "1395": {"vr": "DS", "Value": [129.0]},
        "1396": {"vr": "DS", "Value": [125.0]},
        "1397": {"vr": "DS", "Value": [135.0]},
        "1398": {"vr": "DS", "Value": [140.0]},
        "1399": {"vr": "DS", "Value": [147.0]},
        "1400": {"vr": "DS", "Value": [126.0]},
        "1401": {"vr": "DS", "Value": [113.0]},
        "1402": {"vr": "DS", "Value": [149.0]},
        "1403": {"vr": "DS", "Value": [123.0]},
        "1404": {"vr": "DS", "Value": [637.0]},
        "1405": {"vr": "DS", "Value": [145.0]},
        "1406": {"vr": "DS", "Value": [99.0]},
        "1407": {"vr": "DS", "Value": [148.0]},
        "1408": {"vr": "DS", "Value": [111.0]},
        "1409": {"vr": "DS", "Value": [151.0]},
        "1410": {"vr": "DS", "Value": [62.0]},
        "1411": {"vr": "DS", "Value": [21.0]},
        "1412": {"vr": "DS", "Value": [149.0]},
        "1413": {"vr": "DS", "Value": [698.0]},
        "1414": {"vr": "DS", "Value": [116.0]},
        "1415": {"vr": "DS", "Value": [140.0]},
        "1416": {"vr": "DS", "Value": [132.0]},
        "1417": {"vr": "DS", "Value": [647.0]},
        "1418": {"vr": "DS", "Value": [150.0]},
        "1419": {"vr": "DS", "Value": [145.0]},
        "1420": {"vr": "DS", "Value": [139.0]},
        "1421": {"vr": "DS", "Value": [130.0]},
        "1422": {"vr": "DS", "Value": [117.0]},
        "1423": {"vr": "DS", "Value": [115.0]},
        "1424": {"vr": "DS", "Value": [142.0]},
        "1425": {"vr": "DS", "Value": [64.0]},
        "1426": {"vr": "DS", "Value": [65.0]},
        "1427": {"vr": "DS", "Value": [93.0]},
        "1428": {"vr": "DS", "Value": [132.0]},
        "1429": {"vr": "DS", "Value": [141.0]},
        "1430": {"vr": "DS", "Value": [680.0]},
        "1431": {"vr": "DS", "Value": [94.0]},
        "1432": {"vr": "DS", "Value": [108.0]},
        "1433": {"vr": "DS", "Value": [150.0]},
        "1434": {"vr": "DS", "Value": [94.0]},
        "1435": {"vr": "DS", "Value": [63.0]},
        "1436": {"vr": "DS", "Value": [113.0]},
        "1437": {"vr": "DS", "Value": [60.0]},
        "1438": {"vr": "DS", "Value": [86.0]},
        "1439": {"vr": "DS", "Value": [158.0]},
        "1440": {"vr": "DS", "Value": [141.0]},
        "1441": {"vr": "DS", "Value": [62.0]},
        "1442": {"vr": "DS", "Value": [661.0]},
        "1443": {"vr": "DS", "Value": [145.0]},
        "1444": {"vr": "DS", "Value": [131.0]},
        "1445": {"vr": "DS", "Value": [91.0]},
        "1446": {"vr": "DS", "Value": [128.0]},
        "1447": {"vr": "DS", "Value": [68.0]},
        "1448": {"vr": "DS", "Value": [112.0]},
        "1449": {"vr": "DS", "Value": [682.0]},
        "1450": {"vr": "DS", "Value": [98.0]},
        "1451": {"vr": "DS", "Value": [135.0]},
        "1452": {"vr": "DS", "Value": [150.0]},
        "1453": {"vr": "DS", "Value": [121.0]},
        "1454": {"vr": "DS", "Value": [159.0]},
        "1455": {"vr": "DS", "Value": [712.0]},
        "1456": {"vr": "DS", "Value": [156.0]},
        "1457": {"vr": "DS", "Value": [132.0]},
        "1458": {"vr": "DS", "Value": [59.0]},
        "1459": {"vr": "DS", "Value": [128.0]},
        "1460": {"vr": "DS", "Value": [165.0]},
        "1461": {"vr": "DS", "Value": [643.0]},
        "1462": {"vr": "DS", "Value": [131.0]},
        "1463": {"vr": "DS", "Value": [133.0]},
        "1464": {"vr": "DS", "Value": [107.0]},
        "1465": {"vr": "DS", "Value": [138.0]},
        "1466": {"vr": "DS", "Value": [63.0]},
        "1467": {"vr": "DS", "Value": [139.0]},
        "1468": {"vr": "DS", "Value": [111.0]},
        "1469": {"vr": "DS", "Value": [144.0]},
        "1470": {"vr": "DS", "Value": [135.0]},
        "1471": {"vr": "DS", "Value": [125.0]},
        "1472": {"vr": "DS", "Value": [149.0]},
        "1473": {"vr": "DS", "Value": [140.0]},
        "1474": {"vr": "DS", "Value": [644.0]},
        "1475": {"vr": "DS", "Value": [120.0]},
        "1476": {"vr": "DS", "Value": [112.0]},
        "1477": {"vr": "DS", "Value": [144.0]},
        "1478": {"vr": "DS", "Value": [87.0]},
        "1479": {"vr": "DS", "Value": [123.0]},
        "1480": {"vr": "DS", "Value": [129.0]},
        "1481": {"vr": "DS", "Value": [65.0]},
        "1482": {"vr": "DS", "Value": [154.0]},
        "1483": {"vr": "DS", "Value": [147.0]},
        "1484": {"vr": "DS", "Value": [141.0]},
        "1485": {"vr": "DS", "Value": [101.0]},
        "1486": {"vr": "DS", "Value": [129.0]},
        "1487": {"vr": "DS", "Value": [150.0]},
        "1488": {"vr": "DS", "Value": [695.0]},
        "1489": {"vr": "DS", "Value": [73.0]},
        "1490": {"vr": "DS", "Value": [142.0]},
        "1491": {"vr": "DS", "Value": [142.0]},
        "1492": {"vr": "DS", "Value": [146.0]},
        "1493": {"vr": "DS", "Value": [394.0]},
        "1494": {"vr": "DS", "Value": [142.0]},
        "1495": {"vr": "DS", "Value": [151.0]},
        "1496": {"vr": "DS", "Value": [122.0]},
        "1497": {"vr": "DS", "Value": [67.0]},
        "1498": {"vr": "DS", "Value": [129.0]},
        "1499": {"vr": "DS", "Value": [144.0]},
        "1500": {"vr": "DS", "Value": [144.0]},
        "1501": {"vr": "DS", "Value": [113.0]},
        "1502": {"vr": "DS", "Value": [116.0]},
        "1503": {"vr": "DS", "Value": [127.0]},
        "1504": {"vr": "DS", "Value": [141.0]},
        "1505": {"vr": "DS", "Value": [63.0]},
        "1506": {"vr": "DS", "Value": [108.0]},
        "1507": {"vr": "DS", "Value": [125.0]},
        "1508": {"vr": "DS", "Value": [123.0]},
        "1509": {"vr": "DS", "Value": [134.0]},
        "1510": {"vr": "DS", "Value": [143.0]},
        "1511": {"vr": "DS", "Value": [114.0]},
        "1512": {"vr": "DS", "Value": [535.0]},
        "1513": {"vr": "DS", "Value": [133.0]},
        "1514": {"vr": "DS", "Value": [116.0]},
        "1515": {"vr": "DS", "Value": [646.0]},
        "1516": {"vr": "DS", "Value": [133.0]},
        "1517": {"vr": "DS", "Value": [667.0]},
        "1518": {"vr": "DS", "Value": [100.0]},
        "1519": {"vr": "DS", "Value": [147.0]},
        "1520": {"vr": "DS", "Value": [116.0]},
        "1521": {"vr": "DS", "Value": [62.0]},
        "1522": {"vr": "DS", "Value": [136.0]},
        "1523": {"vr": "DS", "Value": [139.0]},
        "1524": {"vr": "DS", "Value": [66.0]},
        "1525": {"vr": "DS", "Value": [135.0]},
        "1526": {"vr": "DS", "Value": [59.0]},
        "1527": {"vr": "DS", "Value": [141.0]},
        "1528": {"vr": "DS", "Value": [122.0]},
        "1529": {"vr": "DS", "Value": [146.0]},
        "1530": {"vr": "DS", "Value": [132.0]},
        "1531": {"vr": "DS", "Value": [103.0]},
        "1532": {"vr": "DS", "Value": [130.0]},
        "1533": {"vr": "DS", "Value": [121.0]},
        "1534": {"vr": "DS", "Value": [59.0]},
        "1535": {"vr": "DS", "Value": [131.0]},
        "1536": {"vr": "DS", "Value": [692.0]},
        "1537": {"vr": "DS", "Value": [136.0]},
        "1538": {"vr": "DS", "Value": [98.0]},
        "1539": {"vr": "DS", "Value": [151.0]},
        "1540": {"vr": "DS", "Value": [133.0]},
        "1541": {"vr": "DS", "Value": [122.0]},
        "1542": {"vr": "DS", "Value": [139.0]},
        "1543": {"vr": "DS", "Value": [140.0]},
        "1544": {"vr": "DS", "Value": [61.0]},
        "1545": {"vr": "DS", "Value": [140.0]},
        "1546": {"vr": "DS", "Value": [125.0]},
        "1547": {"vr": "DS", "Value": [137.0]},
        "1548": {"vr": "DS", "Value": [117.0]},
        "1549": {"vr": "DS", "Value": [145.0]},
        "1550": {"vr": "DS", "Value": [135.0]},
        "1551": {"vr": "DS", "Value": [123.0]},
        "1552": {"vr": "DS", "Value": [139.0]},
        "1553": {"vr": "DS", "Value": [635.0]},
        "1554": {"vr": "DS", "Value": [126.0]},
        "1555": {"vr": "DS", "Value": [633.0]},
        "1556": {"vr": "DS", "Value": [139.0]},
        "1557": {"vr": "DS", "Value": [67.0]},
        "1558": {"vr": "DS", "Value": [71.0]},
        "1559": {"vr": "DS", "Value": [689.0]},
        "1560": {"vr": "DS", "Value": [125.0]},
        "1561": {"vr": "DS", "Value": [19.0]},
        "1562": {"vr": "DS", "Value": [691.0]},
        "1563": {"vr": "DS", "Value": [135.0]},
        "1564": {"vr": "DS", "Value": [60.0]},
        "1565": {"vr": "DS", "Value": [132.0]},
        "1566": {"vr": "DS", "Value": [120.0]},
        "1567": {"vr": "DS", "Value": [141.0]},
        "1568": {"vr": "DS", "Value": [103.0]},
        "1569": {"vr": "DS", "Value": [127.0]},
        "1570": {"vr": "DS", "Value": [131.0]},
        "1571": {"vr": "DS", "Value": [147.0]},
        "1572": {"vr": "DS", "Value": [104.0]},
        "1573": {"vr": "DS", "Value": [126.0]},
        "1574": {"vr": "DS", "Value": [685.0]},
        "1575": {"vr": "DS", "Value": [61.0]},
        "1576": {"vr": "DS", "Value": [148.0]},
        "1577": {"vr": "DS", "Value": [123.0]},
        "1578": {"vr": "DS", "Value": [139.0]},
        "1579": {"vr": "DS", "Value": [144.0]},
        "1580": {"vr": "DS", "Value": [93.0]},
        "1581": {"vr": "DS", "Value": [140.0]},
        "1582": {"vr": "DS", "Value": [136.0]},
        "1583": {"vr": "DS", "Value": [149.0]},
        "1584": {"vr": "DS", "Value": [115.0]},
        "1585": {"vr": "DS", "Value": [138.0]},
        "1586": {"vr": "DS", "Value": [132.0]},
        "1587": {"vr": "DS", "Value": [144.0]},
        "1588": {"vr": "DS", "Value": [161.0]},
        "1589": {"vr": "DS", "Value": [101.0]},
        "1590": {"vr": "DS", "Value": [143.0]},
        "1591": {"vr": "DS", "Value": [137.0]},
        "1592": {"vr": "DS", "Value": [150.0]},
        "1593": {"vr": "DS", "Value": [71.0]},
        "1594": {"vr": "DS", "Value": [698.0]},
        "1595": {"vr": "DS", "Value": [142.0]},
        "1596": {"vr": "DS", "Value": [103.0]},
        "1597": {"vr": "DS", "Value": [139.0]},
        "1598": {"vr": "DS", "Value": [95.0]},
        "1599": {"vr": "DS", "Value": [134.0]},
        "1600": {"vr": "DS", "Value": [716.0]},
        "1601": {"vr": "DS", "Value": [727.0]},
        "1602": {"vr": "DS", "Value": [141.0]},
        "1603": {"vr": "DS", "Value": [621.0]},
        "1604": {"vr": "DS", "Value": [706.0]},
        "1605": {"vr": "DS", "Value": [113.0]},
        "1606": {"vr": "DS", "Value": [151.0]},
        "1607": {"vr": "DS", "Value": [147.0]},
        "1608": {"vr": "DS", "Value": [102.0]},
        "1609": {"vr": "DS", "Value": [143.0]},
        "1610": {"vr": "DS", "Value": [623.0]},
        "1611": {"vr": "DS", "Value": [60.0]},
        "1612": {"vr": "DS", "Value": [60.0]},
        "1613": {"vr": "DS", "Value": [108.0]},
        "1614": {"vr": "DS", "Value": [134.0]},
        "1615": {"vr": "DS", "Value": [124.0]},
        "1616": {"vr": "DS", "Value": [136.0]},
        "1617": {"vr": "DS", "Value": [112.0]},
        "1618": {"vr": "DS", "Value": [124.0]},
        "1619": {"vr": "DS", "Value": [58.0]},
        "1620": {"vr": "DS", "Value": [118.0]},
        "1621": {"vr": "DS", "Value": [129.0]},
        "1622": {"vr": "DS", "Value": [125.0]},
        "1623": {"vr": "DS", "Value": [144.0]},
        "1624": {"vr": "DS", "Value": [80.0]},
        "1625": {"vr": "DS", "Value": [670.0]},
        "1626": {"vr": "DS", "Value": [139.0]},
        "1627": {"vr": "DS", "Value": [128.0]},
        "1628": {"vr": "DS", "Value": [134.0]},
        "1629": {"vr": "DS", "Value": [126.0]},
        "1630": {"vr": "DS", "Value": [152.0]},
        "1631": {"vr": "DS", "Value": [136.0]},
        "1632": {"vr": "DS", "Value": [83.0]},
        "1633": {"vr": "DS", "Value": [128.0]},
        "1634": {"vr": "DS", "Value": [147.0]},
        "1635": {"vr": "DS", "Value": [122.0]},
        "1636": {"vr": "DS", "Value": [145.0]},
        "1637": {"vr": "DS", "Value": [99.0]},
        "1638": {"vr": "DS", "Value": [146.0]},
        "1639": {"vr": "DS", "Value": [148.0]},
        "1640": {"vr": "DS", "Value": [153.0]},
        "1641": {"vr": "DS", "Value": [116.0]},
        "1642": {"vr": "DS", "Value": [141.0]},
        "1643": {"vr": "DS", "Value": [159.0]},
        "1644": {"vr": "DS", "Value": [634.0]},
        "1645": {"vr": "DS", "Value": [129.0]},
        "1646": {"vr": "DS", "Value": [140.0]},
        "1647": {"vr": "DS", "Value": [133.0]},
        "1648": {"vr": "DS", "Value": [64.0]},
        "1649": {"vr": "DS", "Value": [678.0]},
        "1650": {"vr": "DS", "Value": [105.0]},
        "1651": {"vr": "DS", "Value": [130.0]},
        "1652": {"vr": "DS", "Value": [67.0]},
        "1653": {"vr": "DS", "Value": [141.0]},
        "1654": {"vr": "DS", "Value": [69.0]},
        "1655": {"vr": "DS", "Value": [127.0]},
        "1656": {"vr": "DS", "Value": [158.0]},
        "1657": {"vr": "DS", "Value": [66.0]},
        "1658": {"vr": "DS", "Value": [151.0]},
        "1659": {"vr": "DS", "Value": [102.0]},
        "1660": {"vr": "DS", "Value": [142.0]},
        "1661": {"vr": "DS", "Value": [126.0]},
        "1662": {"vr": "DS", "Value": [143.0]},
        "1663": {"vr": "DS", "Value": [141.0]},
        "1664": {"vr": "DS", "Value": [97.0]},
        "1665": {"vr": "DS", "Value": [96.0]},
        "1666": {"vr": "DS", "Value": [78.0]},
        "1667": {"vr": "DS", "Value": [76.0]},
        "1668": {"vr": "DS", "Value": [150.0]},
        "1669": {"vr": "DS", "Value": [63.0]},
        "1670": {"vr": "DS", "Value": [150.0]},
        "1671": {"vr": "DS", "Value": [79.0]},
        "1672": {"vr": "DS", "Value": [147.0]},
        "1673": {"vr": "DS", "Value": [143.0]},
        "1674": {"vr": "DS", "Value": [66.0]},
        "1675": {"vr": "DS", "Value": [144.0]},
        "1676": {"vr": "DS", "Value": [167.0]},
        "1677": {"vr": "DS", "Value": [141.0]},
        "1678": {"vr": "DS", "Value": [137.0]},
        "1679": {"vr": "DS", "Value": [72.0]},
        "1680": {"vr": "DS", "Value": [132.0]},
        "1681": {"vr": "DS", "Value": [124.0]},
        "1682": {"vr": "DS", "Value": [152.0]},
        "1683": {"vr": "DS", "Value": [100.0]},
        "1684": {"vr": "DS", "Value": [126.0]},
        "1685": {"vr": "DS", "Value": [65.0]},
        "1686": {"vr": "DS", "Value": [101.0]},
        "1687": {"vr": "DS", "Value": [138.0]},
        "1688": {"vr": "DS", "Value": [98.0]},
        "1689": {"vr": "DS", "Value": [640.0]},
        "1690": {"vr": "DS", "Value": [60.0]},
        "1691": {"vr": "DS", "Value": [687.0]},
        "1692": {"vr": "DS", "Value": [129.0]},
        "1693": {"vr": "DS", "Value": [142.0]},
        "1694": {"vr": "DS", "Value": [120.0]},
        "1695": {"vr": "DS", "Value": [104.0]},
        "1696": {"vr": "DS", "Value": [57.0]},
        "1697": {"vr": "DS", "Value": [135.0]},
        "1698": {"vr": "DS", "Value": [124.0]},
        "1699": {"vr": "DS", "Value": [143.0]},
        "1700": {"vr": "DS", "Value": [718.0]},
        "1701": {"vr": "DS", "Value": [138.0]},
        "1702": {"vr": "DS", "Value": [121.0]},
        "1703": {"vr": "DS", "Value": [96.0]},
        "1704": {"vr": "DS", "Value": [160.0]},
        "1705": {"vr": "DS", "Value": [67.0]},
        "1706": {"vr": "DS", "Value": [113.0]},
        "1707": {"vr": "DS", "Value": [100.0]},
        "1708": {"vr": "DS", "Value": [153.0]},
        "1709": {"vr": "DS", "Value": [147.0]},
        "1710": {"vr": "DS", "Value": [134.0]},
        "1711": {"vr": "DS", "Value": [65.0]},
        "1712": {"vr": "DS", "Value": [141.0]},
        "1713": {"vr": "DS", "Value": [123.0]},
        "1714": {"vr": "DS", "Value": [131.0]},
        "1715": {"vr": "DS", "Value": [155.0]},
        "1716": {"vr": "DS", "Value": [143.0]},
        "1717": {"vr": "DS", "Value": [586.0]},
        "1718": {"vr": "DS", "Value": [136.0]},
        "1719": {"vr": "DS", "Value": [143.0]},
        "1720": {"vr": "DS", "Value": [210.0]},
        "1721": {"vr": "DS", "Value": [86.0]},
        "1722": {"vr": "DS", "Value": [149.0]},
        "1723": {"vr": "DS", "Value": [148.0]},
        "1724": {"vr": "DS", "Value": [135.0]},
        "1725": {"vr": "DS", "Value": [104.0]},
        "1726": {"vr": "DS", "Value": [140.0]},
        "1727": {"vr": "DS", "Value": [100.0]},
        "1728": {"vr": "DS", "Value": [140.0]},
        "1729": {"vr": "DS", "Value": [154.0]},
        "1730": {"vr": "DS", "Value": [19.0]},
        "1731": {"vr": "DS", "Value": [125.0]},
        "1732": {"vr": "DS", "Value": [145.0]},
        "1733": {"vr": "DS", "Value": [135.0]},
        "1734": {"vr": "DS", "Value": [122.0]},
        "1735": {"vr": "DS", "Value": [176.0]},
        "1736": {"vr": "DS", "Value": [626.0]},
        "1737": {"vr": "DS", "Value": [145.0]},
        "1738": {"vr": "DS", "Value": [727.0]},
        "1739": {"vr": "DS", "Value": [119.0]},
        "1740": {"vr": "DS", "Value": [157.0]},
        "1741": {"vr": "DS", "Value": [128.0]},
        "1742": {"vr": "DS", "Value": [149.0]},
        "1743": {"vr": "DS", "Value": [153.0]},
        "1744": {"vr": "DS", "Value": [63.0]},
        "1745": {"vr": "DS", "Value": [105.0]},
        "1746": {"vr": "DS", "Value": [147.0]},
        "1747": {"vr": "DS", "Value": [144.0]},
        "1748": {"vr": "DS", "Value": [148.0]},
        "1749": {"vr": "DS", "Value": [101.0]},
        "1750": {"vr": "DS", "Value": [108.0]},
        "1751": {"vr": "DS", "Value": [118.0]},
        "1752": {"vr": "DS", "Value": [130.0]},
        "1753": {"vr": "DS", "Value": [134.0]},
        "1754": {"vr": "DS", "Value": [140.0]},
        "1755": {"vr": "DS", "Value": [138.0]},
        "1756": {"vr": "DS", "Value": [161.0]},
        "1757": {"vr": "DS", "Value": [143.0]},
        "1758": {"vr": "DS", "Value": [112.0]},
        "1759": {"vr": "DS", "Value": [68.0]},
        "1760": {"vr": "DS", "Value": [133.0]},
        "1761": {"vr": "DS", "Value": [89.0]},
        "1762": {"vr": "DS", "Value": [140.0]},
        "1763": {"vr": "DS", "Value": [134.0]},
        "1764": {"vr": "DS", "Value": [138.0]},
        "1765": {"vr": "DS", "Value": [64.0]},
        "1766": {"vr": "DS", "Value": [129.0]},
        "1767": {"vr": "DS", "Value": [134.0]},
        "1768": {"vr": "DS", "Value": [132.0]},
        "1769": {"vr": "DS", "Value": [139.0]},
        "1770": {"vr": "DS", "Value": [118.0]},
        "1771": {"vr": "DS", "Value": [114.0]},
        "1772": {"vr": "DS", "Value": [121.0]},
        "1773": {"vr": "DS", "Value": [114.0]},
        "1774": {"vr": "DS", "Value": [106.0]},
        "1775": {"vr": "DS", "Value": [640.0]},
        "1776": {"vr": "DS", "Value": [138.0]},
        "1777": {"vr": "DS", "Value": [72.0]},
        "1778": {"vr": "DS", "Value": [57.0]},
        "1779": {"vr": "DS", "Value": [58.0]},
        "1780": {"vr": "DS", "Value": [149.0]},
        "1781": {"vr": "DS", "Value": [166.0]},
        "1782": {"vr": "DS", "Value": [137.0]},
        "1783": {"vr": "DS", "Value": [123.0]},
        "1784": {"vr": "DS", "Value": [136.0]},
        "1785": {"vr": "DS", "Value": [130.0]},
        "1786": {"vr": "DS", "Value": [140.0]},
        "1787": {"vr": "DS", "Value": [117.0]},
        "1788": {"vr": "DS", "Value": [134.0]},
        "1789": {"vr": "DS", "Value": [111.0]},
        "1790": {"vr": "DS", "Value": [91.0]},
        "1791": {"vr": "DS", "Value": [126.0]},
        "1792": {"vr": "DS", "Value": [128.0]},
        "1793": {"vr": "DS", "Value": [120.0]},
        "1794": {"vr": "DS", "Value": [143.0]},
        "1795": {"vr": "DS", "Value": [142.0]},
        "1796": {"vr": "DS", "Value": [667.0]},
        "1797": {"vr": "DS", "Value": [65.0]},
        "1798": {"vr": "DS", "Value": [147.0]},
        "1799": {"vr": "DS", "Value": [146.0]},
        "1800": {"vr": "DS", "Value": [125.0]},
        "1801": {"vr": "DS", "Value": [129.0]},
        "1802": {"vr": "DS", "Value": [654.0]},
        "1803": {"vr": "DS", "Value": [83.0]},
        "1804": {"vr": "DS", "Value": [63.0]},
        "1805": {"vr": "DS", "Value": [621.0]},
        "1806": {"vr": "DS", "Value": [25.0]},
        "1807": {"vr": "DS", "Value": [138.0]},
        "1808": {"vr": "DS", "Value": [84.0]},
        "1809": {"vr": "DS", "Value": [58.0]},
        "1810": {"vr": "DS", "Value": [64.0]},
        "1811": {"vr": "DS", "Value": [131.0]},
        "1812": {"vr": "DS", "Value": [139.0]},
        "1813": {"vr": "DS", "Value": [141.0]},
        "1814": {"vr": "DS", "Value": [140.0]},
        "1815": {"vr": "DS", "Value": [128.0]},
        "1816": {"vr": "DS", "Value": [61.0]},
        "1817": {"vr": "DS", "Value": [117.0]},
        "1818": {"vr": "DS", "Value": [117.0]},
        "1819": {"vr": "DS", "Value": [91.0]},
        "1820": {"vr": "DS", "Value": [131.0]},
        "1821": {"vr": "DS", "Value": [59.0]},
        "1822": {"vr": "DS", "Value": [88.0]},
        "1823": {"vr": "DS", "Value": [128.0]},
        "1824": {"vr": "DS", "Value": [82.0]},
        "1825": {"vr": "DS", "Value": [148.0]},
        "1826": {"vr": "DS", "Value": [95.0]},
        "1827": {"vr": "DS", "Value": [596.0]},
        "1828": {"vr": "DS", "Value": [89.0]},
        "1829": {"vr": "DS", "Value": [102.0]},
        "1830": {"vr": "DS", "Value": [144.0]},
        "1831": {"vr": "DS", "Value": [123.0]},
        "1832": {"vr": "DS", "Value": [64.0]},
        "1833": {"vr": "DS", "Value": [136.0]},
        "1834": {"vr": "DS", "Value": [136.0]},
        "1835": {"vr": "DS", "Value": [138.0]},
        "1836": {"vr": "DS", "Value": [143.0]},
        "1837": {"vr": "DS", "Value": [712.0]},
        "1838": {"vr": "DS", "Value": [754.0]},
        "1839": {"vr": "DS", "Value": [135.0]},
        "1840": {"vr": "DS", "Value": [132.0]},
        "1841": {"vr": "DS", "Value": [153.0]},
        "1842": {"vr": "DS", "Value": [141.0]},
        "1843": {"vr": "DS", "Value": [139.0]},
        "1844": {"vr": "DS", "Value": [128.0]},
        "1845": {"vr": "DS", "Value": [589.0]},
        "1846": {"vr": "DS", "Value": [137.0]},
        "1847": {"vr": "DS", "Value": [62.0]},
        "1848": {"vr": "DS", "Value": [150.0]},
        "1849": {"vr": "DS", "Value": [113.0]},
        "1850": {"vr": "DS", "Value": [139.0]},
        "1851": {"vr": "DS", "Value": [105.0]},
        "1852": {"vr": "DS", "Value": [79.0]},
        "1853": {"vr": "DS", "Value": [148.0]},
        "1854": {"vr": "DS", "Value": [148.0]},
        "1855": {"vr": "DS", "Value": [140.0]},
        "1856": {"vr": "DS", "Value": [135.0]},
        "1857": {"vr": "DS", "Value": [99.0]},
        "1858": {"vr": "DS", "Value": [142.0]},
        "1859": {"vr": "DS", "Value": [142.0]},
        "1860": {"vr": "DS", "Value": [139.0]},
        "1861": {"vr": "DS", "Value": [84.0]},
        "1862": {"vr": "DS", "Value": [151.0]},
        "1863": {"vr": "DS", "Value": [142.0]},
        "1864": {"vr": "DS", "Value": [94.0]},
        "1865": {"vr": "DS", "Value": [100.0]},
        "1866": {"vr": "DS", "Value": [154.0]},
        "1867": {"vr": "DS", "Value": [90.0]},
        "1868": {"vr": "DS", "Value": [90.0]},
        "1869": {"vr": "DS", "Value": [137.0]},
        "1870": {"vr": "DS", "Value": [126.0]},
        "1871": {"vr": "DS", "Value": [143.0]},
        "1872": {"vr": "DS", "Value": [667.0]},
        "1873": {"vr": "DS", "Value": [534.0]},
        "1874": {"vr": "DS", "Value": [135.0]},
        "1875": {"vr": "DS", "Value": [62.0]},
        "1876": {"vr": "DS", "Value": [139.0]},
        "1877": {"vr": "DS", "Value": [109.0]},
        "1878": {"vr": "DS", "Value": [68.0]},
        "1879": {"vr": "DS", "Value": [112.0]},
        "1880": {"vr": "DS", "Value": [142.0]},
        "1881": {"vr": "DS", "Value": [66.0]},
        "1882": {"vr": "DS", "Value": [140.0]},
        "1883": {"vr": "DS", "Value": [54.0]},
        "1884": {"vr": "DS", "Value": [136.0]},
        "1885": {"vr": "DS", "Value": [74.0]},
        "1886": {"vr": "DS", "Value": [143.0]},
        "1887": {"vr": "DS", "Value": [64.0]},
        "1888": {"vr": "DS", "Value": [147.0]},
        "1889": {"vr": "DS", "Value": [658.0]},
        "1890": {"vr": "DS", "Value": [133.0]},
        "1891": {"vr": "DS", "Value": [69.0]},
        "1892": {"vr": "DS", "Value": [20.0]},
        "1893": {"vr": "DS", "Value": [137.0]},
        "1894": {"vr": "DS", "Value": [133.0]},
        "1895": {"vr": "DS", "Value": [101.0]},
        "1896": {"vr": "DS", "Value": [140.0]},
        "1897": {"vr": "DS", "Value": [125.0]},
        "1898": {"vr": "DS", "Value": [92.0]},
        "1899": {"vr": "DS", "Value": [141.0]},
        "1900": {"vr": "DS", "Value": [127.0]},
        "1901": {"vr": "DS", "Value": [144.0]},
        "1902": {"vr": "DS", "Value": [126.0]},
        "1903": {"vr": "DS", "Value": [142.0]},
        "1904": {"vr": "DS", "Value": [63.0]},
        "1905": {"vr": "DS", "Value": [129.0]},
        "1906": {"vr": "DS", "Value": [70.0]},
        "1907": {"vr": "DS", "Value": [127.0]},
        "1908": {"vr": "DS", "Value": [158.0]},
        "1909": {"vr": "DS", "Value": [653.0]},
        "1910": {"vr": "DS", "Value": [135.0]},
        "1911": {"vr": "DS", "Value": [139.0]},
        "1912": {"vr": "DS", "Value": [111.0]},
        "1913": {"vr": "DS", "Value": [146.0]},
        "1914": {"vr": "DS", "Value": [647.0]},
        "1915": {"vr": "DS", "Value": [715.0]},
        "1916": {"vr": "DS", "Value": [695.0]},
        "1917": {"vr": "DS", "Value": [145.0]},
        "1918": {"vr": "DS", "Value": [762.0]},
        "1919": {"vr": "DS", "Value": [53.0]},
        "1920": {"vr": "DS", "Value": [531.0]},
        "1921": {"vr": "DS", "Value": [107.0]},
        "1922": {"vr": "DS", "Value": [116.0]},
        "1923": {"vr": "DS", "Value": [157.0]},
        "1924": {"vr": "DS", "Value": [77.0]},
        "1925": {"vr": "DS", "Value": [133.0]},
        "1926": {"vr": "DS", "Value": [171.0]},
        "1927": {"vr": "DS", "Value": [18.0]},
        "1928": {"vr": "DS", "Value": [86.0]},
        "1929": {"vr": "DS", "Value": [137.0]},
        "1930": {"vr": "DS", "Value": [122.0]},
        "1931": {"vr": "DS", "Value": [122.0]},
        "1932": {"vr": "DS", "Value": [122.0]},
        "1933": {"vr": "DS", "Value": [698.0]},
        "1934": {"vr": "DS", "Value": [66.0]},
        "1935": {"vr": "DS", "Value": [127.0]},
        "1936": {"vr": "DS", "Value": [75.0]},
        "1937": {"vr": "DS", "Value": [154.0]},
        "1938": {"vr": "DS", "Value": [137.0]},
        "1939": {"vr": "DS", "Value": [147.0]},
        "1940": {"vr": "DS", "Value": [62.0]},
        "1941": {"vr": "DS", "Value": [154.0]},
        "1942": {"vr": "DS", "Value": [158.0]},
        "1943": {"vr": "DS", "Value": [144.0]},
        "1944": {"vr": "DS", "Value": [151.0]},
        "1945": {"vr": "DS", "Value": [126.0]},
        "1946": {"vr": "DS", "Value": [141.0]},
        "1947": {"vr": "DS", "Value": [146.0]},
        "1948": {"vr": "DS", "Value": [112.0]},
        "1949": {"vr": "DS", "Value": [668.0]},
        "1950": {"vr": "DS", "Value": [128.0]},
        "1951": {"vr": "DS", "Value": [136.0]},
        "1952": {"vr": "DS", "Value": [116.0]},
        "1953": {"vr": "DS", "Value": [92.0]},
        "1954": {"vr": "DS", "Value": [154.0]},
        "1955": {"vr": "DS", "Value": [149.0]},
        "1956": {"vr": "DS", "Value": [126.0]},
        "1957": {"vr": "DS", "Value": [150.0]},
        "1958": {"vr": "DS", "Value": [61.0]},
        "1959": {"vr": "DS", "Value": [144.0]},
        "1960": {"vr": "DS", "Value": [89.0]},
        "1961": {"vr": "DS", "Value": [627.0]},
        "1962": {"vr": "DS", "Value": [139.0]},
        "1963": {"vr": "DS", "Value": [145.0]},
        "1964": {"vr": "DS", "Value": [125.0]},
        "1965": {"vr": "DS", "Value": [130.0]},
        "1966": {"vr": "DS", "Value": [147.0]},
        "1967": {"vr": "DS", "Value": [674.0]},
        "1968": {"vr": "DS", "Value": [101.0]},
        "1969": {"vr": "DS", "Value": [123.0]},
        "1970": {"vr": "DS", "Value": [135.0]},
        "1971": {"vr": "DS", "Value": [143.0]},
        "1972": {"vr": "DS", "Value": [141.0]},
        "1973": {"vr": "DS", "Value": [715.0]},
        "1974": {"vr": "DS", "Value": [120.0]},
        "1975": {"vr": "DS", "Value": [103.0]},
        "1976": {"vr": "DS", "Value": [132.0]},
        "1977": {"vr": "DS", "Value": [144.0]},
        "1978": {"vr": "DS", "Value": [129.0]},
        "1979": {"vr": "DS", "Value": [116.0]},
        "1980": {"vr": "DS", "Value": [112.0]},
        "1981": {"vr": "DS", "Value": [58.0]},
        "1982": {"vr": "DS", "Value": [132.0]},
        "1983": {"vr": "DS", "Value": [96.0]},
        "1984": {"vr": "DS", "Value": [133.0]},
        "1985": {"vr": "DS", "Value": [140.0]},
        "1986": {"vr": "DS", "Value": [169.0]},
        "1987": {"vr": "DS", "Value": [144.0]},
        "1988": {"vr": "DS", "Value": [141.0]},
        "1989": {"vr": "DS", "Value": [87.0]},
        "1990": {"vr": "DS", "Value": [139.0]},
        "1991": {"vr": "DS", "Value": [129.0]},
        "1992": {"vr": "DS", "Value": [75.0]},
        "1993": {"vr": "DS", "Value": [665.0]},
        "1994": {"vr": "DS", "Value": [112.0]},
        "1995": {"vr": "DS", "Value": [131.0]},
        "1996": {"vr": "DS", "Value": [638.0]},
        "1997": {"vr": "DS", "Value": [130.0]},
        "1998": {"vr": "DS", "Value": [105.0]},
        "1999": {"vr": "DS", "Value": [112.0]},
        "2000": {"vr": "DS", "Value": [136.0]},
        "2001": {"vr": "DS", "Value": [693.0]},
        "2002": {"vr": "DS", "Value": [141.0]},
        "2003": {"vr": "DS", "Value": [142.0]},
        "2004": {"vr": "DS", "Value": [135.0]},
        "2005": {"vr": "DS", "Value": [164.0]},
        "2006": {"vr": "DS", "Value": [93.0]},
        "2007": {"vr": "DS", "Value": [64.0]},
        "2008": {"vr": "DS", "Value": [141.0]},
        "2009": {"vr": "DS", "Value": [141.0]},
        "2010": {"vr": "DS", "Value": [140.0]},
        "2011": {"vr": "DS", "Value": [140.0]},
        "2012": {"vr": "DS", "Value": [659.0]},
        "2013": {"vr": "DS", "Value": [104.0]},
        "2014": {"vr": "DS", "Value": [134.0]},
        "2015": {"vr": "DS", "Value": [123.0]},
        "2016": {"vr": "DS", "Value": [139.0]},
        "2017": {"vr": "DS", "Value": [598.0]},
        "2018": {"vr": "DS", "Value": [131.0]},
        "2019": {"vr": "DS", "Value": [122.0]},
        "2020": {"vr": "DS", "Value": [154.0]},
        "2021": {"vr": "DS", "Value": [123.0]},
        "2022": {"vr": "DS", "Value": [132.0]},
        "2023": {"vr": "DS", "Value": [61.0]},
        "2024": {"vr": "DS", "Value": [144.0]},
        "2025": {"vr": "DS", "Value": [722.0]},
        "2026": {"vr": "DS", "Value": [119.0]},
        "2027": {"vr": "DS", "Value": [152.0]},
        "2028": {"vr": "DS", "Value": [137.0]},
        "2029": {"vr": "DS", "Value": [679.0]},
        "2030": {"vr": "DS", "Value": [135.0]},
        "2031": {"vr": "DS", "Value": [71.0]},
        "2032": {"vr": "DS", "Value": [141.0]},
        "2033": {"vr": "DS", "Value": [145.0]},
        "2034": {"vr": "DS", "Value": [150.0]},
        "2035": {"vr": "DS", "Value": [149.0]},
        "2036": {"vr": "DS", "Value": [142.0]},
        "2037": {"vr": "DS", "Value": [105.0]},
        "2038": {"vr": "DS", "Value": [23.0]},
        "2039": {"vr": "DS", "Value": [139.0]},
        "2040": {"vr": "DS", "Value": [122.0]},
        "2041": {"vr": "DS", "Value": [135.0]},
        "2042": {"vr": "DS", "Value": [119.0]},
        "2043": {"vr": "DS", "Value": [145.0]},
        "2044": {"vr": "DS", "Value": [110.0]},
        "2045": {"vr": "DS", "Value": [133.0]},
        "2046": {"vr": "DS", "Value": [134.0]},
        "2047": {"vr": "DS", "Value": [106.0]},
        "2048": {"vr": "DS", "Value": [137.0]},
        "2049": {"vr": "DS", "Value": [139.0]},
        "2050": {"vr": "DS", "Value": [130.0]},
        "2051": {"vr": "DS", "Value": [125.0]},
        "2052": {"vr": "DS", "Value": [71.0]},
        "2053": {"vr": "DS", "Value": [132.0]},
        "2054": {"vr": "DS", "Value": [112.0]},
        "2055": {"vr": "DS", "Value": [146.0]},
        "2056": {"vr": "DS", "Value": [100.0]},
        "2057": {"vr": "DS", "Value": [115.0]},
        "2058": {"vr": "DS", "Value": [154.0]},
        "2059": {"vr": "DS", "Value": [158.0]},
        "2060": {"vr": "DS", "Value": [136.0]},
        "2061": {"vr": "DS", "Value": [132.0]},
        "2062": {"vr": "DS", "Value": [140.0]},
        "2063": {"vr": "DS", "Value": [136.0]},
        "2064": {"vr": "DS", "Value": [613.0]},
        "2065": {"vr": "DS", "Value": [137.0]},
        "2066": {"vr": "DS", "Value": [139.0]},
        "2067": {"vr": "DS", "Value": [147.0]},
        "2068": {"vr": "DS", "Value": [140.0]},
        "2069": {"vr": "DS", "Value": [138.0]},
        "2070": {"vr": "DS", "Value": [151.0]},
        "2071": {"vr": "DS", "Value": [147.0]},
        "2072": {"vr": "DS", "Value": [139.0]},
        "2073": {"vr": "DS", "Value": [136.0]},
        "2074": {"vr": "DS", "Value": [139.0]},
        "2075": {"vr": "DS", "Value": [677.0]},
        "2076": {"vr": "DS", "Value": [103.0]},
        "2077": {"vr": "DS", "Value": [114.0]},
        "2078": {"vr": "DS", "Value": [86.0]},
        "2079": {"vr": "DS", "Value": [646.0]},
        "2080": {"vr": "DS", "Value": [60.0]},
        "2081": {"vr": "DS", "Value": [140.0]},
        "2082": {"vr": "DS", "Value": [678.0]},
        "2083": {"vr": "DS", "Value": [663.0]},
        "2084": {"vr": "DS", "Value": [683.0]},
        "2085": {"vr": "DS", "Value": [133.0]},
        "2086": {"vr": "DS", "Value": [673.0]},
        "2087": {"vr": "DS", "Value": [127.0]},
        "2088": {"vr": "DS", "Value": [141.0]},
        "2089": {"vr": "DS", "Value": [134.0]},
        "2090": {"vr": "DS", "Value": [124.0]},
        "2091": {"vr": "DS", "Value": [148.0]},
        "2092": {"vr": "DS", "Value": [113.0]},
        "2093": {"vr": "DS", "Value": [118.0]},
        "2094": {"vr": "DS", "Value": [67.0]},
        "2095": {"vr": "DS", "Value": [151.0]},
        "2096": {"vr": "DS", "Value": [143.0]},
        "2097": {"vr": "DS", "Value": [135.0]},
        "2098": {"vr": "DS", "Value": [671.0]},
        "2099": {"vr": "DS", "Value": [87.0]},
        "2100": {"vr": "DS", "Value": [62.0]},
        "2101": {"vr": "DS", "Value": [112.0]},
        "2102": {"vr": "DS", "Value": [131.0]},
        "2103": {"vr": "DS", "Value": [142.0]},
        "2104": {"vr": "DS", "Value": [97.0]},
        "2105": {"vr": "DS", "Value": [140.0]},
        "2106": {"vr": "DS", "Value": [25.0]},
        "2107": {"vr": "DS", "Value": [125.0]},
        "2108": {"vr": "DS", "Value": [101.0]},
        "2109": {"vr": "DS", "Value": [529.0]},
        "2110": {"vr": "DS", "Value": [117.0]},
        "2111": {"vr": "DS", "Value": [141.0]},
        "2112": {"vr": "DS", "Value": [58.0]},
        "2113": {"vr": "DS", "Value": [154.0]},
        "2114": {"vr": "DS", "Value": [61.0]},
        "2115": {"vr": "DS", "Value": [69.0]},
        "2116": {"vr": "DS", "Value": [131.0]},
        "2117": {"vr": "DS", "Value": [129.0]},
        "2118": {"vr": "DS", "Value": [143.0]},
        "2119": {"vr": "DS", "Value": [94.0]},
        "2120": {"vr": "DS", "Value": [77.0]},
        "2121": {"vr": "DS", "Value": [163.0]},
        "2122": {"vr": "DS", "Value": [117.0]},
        "2123": {"vr": "DS", "Value": [82.0]},
        "2124": {"vr": "DS", "Value": [147.0]},
        "2125": {"vr": "DS", "Value": [151.0]},
        "2126": {"vr": "DS", "Value": [150.0]},
        "2127": {"vr": "DS", "Value": [131.0]},
        "2128": {"vr": "DS", "Value": [130.0]},
        "2129": {"vr": "DS", "Value": [137.0]},
        "2130": {"vr": "DS", "Value": [128.0]},
        "2131": {"vr": "DS", "Value": [147.0]},
        "2132": {"vr": "DS", "Value": [697.0]},
        "2133": {"vr": "DS", "Value": [69.0]},
        "2134": {"vr": "DS", "Value": [134.0]},
        "2135": {"vr": "DS", "Value": [135.0]},
        "2136": {"vr": "DS", "Value": [129.0]},
        "2137": {"vr": "DS", "Value": [124.0]},
        "2138": {"vr": "DS", "Value": [142.0]},
        "2139": {"vr": "DS", "Value": [79.0]},
        "2140": {"vr": "DS", "Value": [97.0]},
        "2141": {"vr": "DS", "Value": [155.0]},
        "2142": {"vr": "DS", "Value": [145.0]},
        "2143": {"vr": "DS", "Value": [153.0]},
        "2144": {"vr": "DS", "Value": [141.0]},
        "2145": {"vr": "DS", "Value": [160.0]},
        "2146": {"vr": "DS", "Value": [630.0]},
        "2147": {"vr": "DS", "Value": [74.0]},
        "2148": {"vr": "DS", "Value": [107.0]},
        "2149": {"vr": "DS", "Value": [157.0]},
        "2150": {"vr": "DS", "Value": [148.0]},
        "2151": {"vr": "DS", "Value": [97.0]},
        "2152": {"vr": "DS", "Value": [143.0]},
        "2153": {"vr": "DS", "Value": [74.0]},
        "2154": {"vr": "DS", "Value": [159.0]},
        "2155": {"vr": "DS", "Value": [133.0]},
        "2156": {"vr": "DS", "Value": [141.0]},
        "2157": {"vr": "DS", "Value": [127.0]},
        "2158": {"vr": "DS", "Value": [626.0]},
        "2159": {"vr": "DS", "Value": [130.0]},
        "2160": {"vr": "DS", "Value": [91.0]},
        "2161": {"vr": "DS", "Value": [137.0]},
        "2162": {"vr": "DS", "Value": [136.0]},
        "2163": {"vr": "DS", "Value": [138.0]},
        "2164": {"vr": "DS", "Value": [155.0]},
        "2165": {"vr": "DS", "Value": [587.0]},
        "2166": {"vr": "DS", "Value": [140.0]},
        "2167": {"vr": "DS", "Value": [143.0]},
        "2168": {"vr": "DS", "Value": [91.0]},
        "2169": {"vr": "DS", "Value": [130.0]},
        "2170": {"vr": "DS", "Value": [649.0]},
        "2171": {"vr": "DS", "Value": [162.0]},
        "2172": {"vr": "DS", "Value": [143.0]},
        "2173": {"vr": "DS", "Value": [142.0]},
        "2174": {"vr": "DS", "Value": [723.0]},
        "2175": {"vr": "DS", "Value": [160.0]},
        "2176": {"vr": "DS", "Value": [61.0]},
        "2177": {"vr": "DS", "Value": [144.0]},
        "2178": {"vr": "DS", "Value": [96.0]},
        "2179": {"vr": "DS", "Value": [125.0]},
        "2180": {"vr": "DS", "Value": [149.0]},
        "2181": {"vr": "DS", "Value": [114.0]},
        "2182": {"vr": "DS", "Value": [147.0]},
        "2183": {"vr": "DS", "Value": [131.0]},
        "2184": {"vr": "DS", "Value": [130.0]},
        "2185": {"vr": "DS", "Value": [67.0]},
        "2186": {"vr": "DS", "Value": [64.0]},
        "2187": {"vr": "DS", "Value": [625.0]},
        "2188": {"vr": "DS", "Value": [135.0]},
        "2189": {"vr": "DS", "Value": [130.0]},
        "2190": {"vr": "DS", "Value": [137.0]},
        "2191": {"vr": "DS", "Value": [66.0]},
        "2192": {"vr": "DS", "Value": [655.0]},
        "2193": {"vr": "DS", "Value": [69.0]},
        "2194": {"vr": "DS", "Value": [115.0]},
        "2195": {"vr": "DS", "Value": [128.0]},
        "2196": {"vr": "DS", "Value": [144.0]},
        "2197": {"vr": "DS", "Value": [142.0]},
        "2198": {"vr": "DS", "Value": [65.0]},
        "2199": {"vr": "DS", "Value": [119.0]},
        "2200": {"vr": "DS", "Value": [123.0]},
        "2201": {"vr": "DS", "Value": [104.0]},
        "2202": {"vr": "DS", "Value": [90.0]},
        "2203": {"vr": "DS", "Value": [134.0]},
        "2204": {"vr": "DS", "Value": [706.0]},
        "2205": {"vr": "DS", "Value": [125.0]},
        "2206": {"vr": "DS", "Value": [118.0]},
        "2207": {"vr": "DS", "Value": [147.0]},
        "2208": {"vr": "DS", "Value": [151.0]},
        "2209": {"vr": "DS", "Value": [122.0]},
        "2210": {"vr": "DS", "Value": [141.0]},
        "2211": {"vr": "DS", "Value": [96.0]},
        "2212": {"vr": "DS", "Value": [140.0]},
        "2213": {"vr": "DS", "Value": [119.0]},
        "2214": {"vr": "DS", "Value": [138.0]},
        "2215": {"vr": "DS", "Value": [164.0]},
        "2216": {"vr": "DS", "Value": [139.0]},
        "2217": {"vr": "DS", "Value": [148.0]},
        "2218": {"vr": "DS", "Value": [155.0]},
        "2219": {"vr": "DS", "Value": [66.0]},
        "2220": {"vr": "DS", "Value": [638.0]},
        "2221": {"vr": "DS", "Value": [66.0]},
        "2222": {"vr": "DS", "Value": [130.0]},
        "2223": {"vr": "DS", "Value": [81.0]},
        "2224": {"vr": "DS", "Value": [119.0]},
        "2225": {"vr": "DS", "Value": [64.0]},
        "2226": {"vr": "DS", "Value": [136.0]},
        "2227": {"vr": "DS", "Value": [148.0]},
        "2228": {"vr": "DS", "Value": [157.0]},
        "2229": {"vr": "DS", "Value": [56.0]},
        "2230": {"vr": "DS", "Value": [62.0]},
        "2231": {"vr": "DS", "Value": [51.0]},
        "2232": {"vr": "DS", "Value": [165.0]},
        "2233": {"vr": "DS", "Value": [142.0]},
        "2234": {"vr": "DS", "Value": [139.0]},
        "2235": {"vr": "DS", "Value": [143.0]},
        "2236": {"vr": "DS", "Value": [117.0]},
        "2237": {"vr": "DS", "Value": [143.0]},
        "2238": {"vr": "DS", "Value": [102.0]},
        "2239": {"vr": "DS", "Value": [603.0]},
        "2240": {"vr": "DS", "Value": [148.0]},
        "2241": {"vr": "DS", "Value": [58.0]},
        "2242": {"vr": "DS", "Value": [128.0]},
        "2243": {"vr": "DS", "Value": [141.0]},
        "2244": {"vr": "DS", "Value": [138.0]},
        "2245": {"vr": "DS", "Value": [131.0]},
        "2246": {"vr": "DS", "Value": [130.0]},
        "2247": {"vr": "DS", "Value": [87.0]},
        "2248": {"vr": "DS", "Value": [149.0]},
        "2249": {"vr": "DS", "Value": [115.0]},
        "2250": {"vr": "DS", "Value": [68.0]},
        "2251": {"vr": "DS", "Value": [155.0]},
        "2252": {"vr": "DS", "Value": [104.0]},
        "2253": {"vr": "DS", "Value": [137.0]},
        "2254": {"vr": "DS", "Value": [675.0]},
        "2255": {"vr": "DS", "Value": [63.0]},
        "2256": {"vr": "DS", "Value": [113.0]},
        "2257": {"vr": "DS", "Value": [86.0]},
        "2258": {"vr": "DS", "Value": [143.0]},
        "2259": {"vr": "DS", "Value": [617.0]},
        "2260": {"vr": "DS", "Value": [116.0]},
        "2261": {"vr": "DS", "Value": [128.0]},
        "2262": {"vr": "DS", "Value": [83.0]},
        "2263": {"vr": "DS", "Value": [599.0]},
        "2264": {"vr": "DS", "Value": [124.0]},
        "2265": {"vr": "DS", "Value": [140.0]},
        "2266": {"vr": "DS", "Value": [143.0]},
        "2267": {"vr": "DS", "Value": [76.0]},
        "2268": {"vr": "DS", "Value": [62.0]},
        "2269": {"vr": "DS", "Value": [108.0]},
        "2270": {"vr": "DS", "Value": [113.0]},
        "2271": {"vr": "DS", "Value": [142.0]},
        "2272": {"vr": "DS", "Value": [112.0]},
        "2273": {"vr": "DS", "Value": [81.0]},
        "2274": {"vr": "DS", "Value": [145.0]},
        "2275": {"vr": "DS", "Value": [136.0]},
        "2276": {"vr": "DS", "Value": [124.0]},
        "2277": {"vr": "DS", "Value": [83.0]},
        "2278": {"vr": "DS", "Value": [654.0]},
        "2279": {"vr": "DS", "Value": [141.0]},
        "2280": {"vr": "DS", "Value": [122.0]},
        "2281": {"vr": "DS", "Value": [72.0]},
        "2282": {"vr": "DS", "Value": [135.0]},
        "2283": {"vr": "DS", "Value": [162.0]},
        "2284": {"vr": "DS", "Value": [112.0]},
        "2285": {"vr": "DS", "Value": [125.0]},
        "2286": {"vr": "DS", "Value": [139.0]},
        "2287": {"vr": "DS", "Value": [142.0]},
        "2288": {"vr": "DS", "Value": [79.0]},
        "2289": {"vr": "DS", "Value": [137.0]},
        "2290": {"vr": "DS", "Value": [149.0]},
        "2291": {"vr": "DS", "Value": [654.0]},
        "2292": {"vr": "DS", "Value": [146.0]},
        "2293": {"vr": "DS", "Value": [140.0]},
        "2294": {"vr": "DS", "Value": [141.0]},
        "2295": {"vr": "DS", "Value": [729.0]},
        "2296": {"vr": "DS", "Value": [646.0]},
        "2297": {"vr": "DS", "Value": [140.0]},
        "2298": {"vr": "DS", "Value": [70.0]},
        "2299": {"vr": "DS", "Value": [87.0]},
        "2300": {"vr": "DS", "Value": [148.0]},
        "2301": {"vr": "DS", "Value": [134.0]},
        "2302": {"vr": "DS", "Value": [138.0]},
        "2303": {"vr": "DS", "Value": [141.0]},
        "2304": {"vr": "DS", "Value": [138.0]},
        "2305": {"vr": "DS", "Value": [62.0]},
        "2306": {"vr": "DS", "Value": [116.0]},
        "2307": {"vr": "DS", "Value": [136.0]},
        "2308": {"vr": "DS", "Value": [84.0]},
        "2309": {"vr": "DS", "Value": [83.0]},
        "2310": {"vr": "DS", "Value": [104.0]},
        "2311": {"vr": "DS", "Value": [126.0]},
        "2312": {"vr": "DS", "Value": [69.0]},
        "2313": {"vr": "DS", "Value": [714.0]},
        "2314": {"vr": "DS", "Value": [93.0]},
        "2315": {"vr": "DS", "Value": [94.0]},
        "2316": {"vr": "DS", "Value": [144.0]},
        "2317": {"vr": "DS", "Value": [145.0]},
        "2318": {"vr": "DS", "Value": [99.0]},
        "2319": {"vr": "DS", "Value": [159.0]},
        "2320": {"vr": "DS", "Value": [98.0]},
        "2321": {"vr": "DS", "Value": [135.0]},
        "2322": {"vr": "DS", "Value": [133.0]},
        "2323": {"vr": "DS", "Value": [147.0]},
        "2324": {"vr": "DS", "Value": [96.0]},
        "2325": {"vr": "DS", "Value": [137.0]},
        "2326": {"vr": "DS", "Value": [139.0]},
        "2327": {"vr": "DS", "Value": [108.0]},
        "2328": {"vr": "DS", "Value": [134.0]},
        "2329": {"vr": "DS", "Value": [89.0]},
        "2330": {"vr": "DS", "Value": [135.0]},
        "2331": {"vr": "DS", "Value": [139.0]},
        "2332": {"vr": "DS", "Value": [77.0]},
        "2333": {"vr": "DS", "Value": [155.0]},
        "2334": {"vr": "DS", "Value": [142.0]},
        "2335": {"vr": "DS", "Value": [59.0]},
        "2336": {"vr": "DS", "Value": [131.0]},
        "2337": {"vr": "DS", "Value": [121.0]},
        "2338": {"vr": "DS", "Value": [103.0]},
        "2339": {"vr": "DS", "Value": [137.0]},
        "2340": {"vr": "DS", "Value": [621.0]},
        "2341": {"vr": "DS", "Value": [123.0]},
        "2342": {"vr": "DS", "Value": [140.0]},
        "2343": {"vr": "DS", "Value": [141.0]},
        "2344": {"vr": "DS", "Value": [138.0]},
        "2345": {"vr": "DS", "Value": [132.0]},
        "2346": {"vr": "DS", "Value": [679.0]},
        "2347": {"vr": "DS", "Value": [168.0]},
        "2348": {"vr": "DS", "Value": [119.0]},
        "2349": {"vr": "DS", "Value": [119.0]},
        "2350": {"vr": "DS", "Value": [149.0]},
        "2351": {"vr": "DS", "Value": [129.0]},
        "2352": {"vr": "DS", "Value": [142.0]},
        "2353": {"vr": "DS", "Value": [134.0]},
        "2354": {"vr": "DS", "Value": [151.0]},
        "2355": {"vr": "DS", "Value": [110.0]},
        "2356": {"vr": "DS", "Value": [123.0]},
        "2357": {"vr": "DS", "Value": [150.0]},
        "2358": {"vr": "DS", "Value": [137.0]},
        "2359": {"vr": "DS", "Value": [158.0]},
        "2360": {"vr": "DS", "Value": [691.0]},
        "2361": {"vr": "DS", "Value": [138.0]},
        "2362": {"vr": "DS", "Value": [136.0]},
        "2363": {"vr": "DS", "Value": [154.0]},
        "2364": {"vr": "DS", "Value": [67.0]},
        "2365": {"vr": "DS", "Value": [142.0]},
        "2366": {"vr": "DS", "Value": [143.0]},
        "2367": {"vr": "DS", "Value": [146.0]},
        "2368": {"vr": "DS", "Value": [136.0]},
        "2369": {"vr": "DS", "Value": [688.0]},
        "2370": {"vr": "DS", "Value": [144.0]},
        "2371": {"vr": "DS", "Value": [144.0]},
        "2372": {"vr": "DS", "Value": [58.0]},
        "2373": {"vr": "DS", "Value": [147.0]},
        "2374": {"vr": "DS", "Value": [67.0]},
        "2375": {"vr": "DS", "Value": [96.0]},
        "2376": {"vr": "DS", "Value": [637.0]},
        "2377": {"vr": "DS", "Value": [144.0]},
        "2378": {"vr": "DS", "Value": [23.0]},
        "2379": {"vr": "DS", "Value": [144.0]},
        "2380": {"vr": "DS", "Value": [101.0]},
        "2381": {"vr": "DS", "Value": [598.0]},
        "2382": {"vr": "DS", "Value": [681.0]},
        "2383": {"vr": "DS", "Value": [110.0]},
        "2384": {"vr": "DS", "Value": [135.0]},
        "2385": {"vr": "DS", "Value": [653.0]},
        "2386": {"vr": "DS", "Value": [65.0]},
        "2387": {"vr": "DS", "Value": [139.0]},
        "2388": {"vr": "DS", "Value": [68.0]},
        "2389": {"vr": "DS", "Value": [121.0]},
        "2390": {"vr": "DS", "Value": [146.0]},
        "2391": {"vr": "DS", "Value": [53.0]},
        "2392": {"vr": "DS", "Value": [116.0]},
        "2393": {"vr": "DS", "Value": [131.0]},
        "2394": {"vr": "DS", "Value": [668.0]},
        "2395": {"vr": "DS", "Value": [69.0]},
        "2396": {"vr": "DS", "Value": [116.0]},
        "2397": {"vr": "DS", "Value": [126.0]},
        "2398": {"vr": "DS", "Value": [138.0]},
        "2399": {"vr": "DS", "Value": [137.0]},
        "2400": {"vr": "DS", "Value": [716.0]},
        "2401": {"vr": "DS", "Value": [68.0]},
        "2402": {"vr": "DS", "Value": [143.0]},
        "2403": {"vr": "DS", "Value": [147.0]},
        "2404": {"vr": "DS", "Value": [145.0]},
        "2405": {"vr": "DS", "Value": [146.0]},
        "2406": {"vr": "DS", "Value": [111.0]},
        "2407": {"vr": "DS", "Value": [126.0]},
        "2408": {"vr": "DS", "Value": [122.0]},
        "2409": {"vr": "DS", "Value": [118.0]},
        "2410": {"vr": "DS", "Value": [146.0]},
        "2411": {"vr": "DS", "Value": [146.0]},
        "2412": {"vr": "DS", "Value": [107.0]},
        "2413": {"vr": "DS", "Value": [124.0]},
        "2414": {"vr": "DS", "Value": [110.0]},
        "2415": {"vr": "DS", "Value": [58.0]},
        "2416": {"vr": "DS", "Value": [146.0]},
        "2417": {"vr": "DS", "Value": [692.0]},
        "2418": {"vr": "DS", "Value": [551.0]},
        "2419": {"vr": "DS", "Value": [64.0]},
        "2420": {"vr": "DS", "Value": [128.0]},
        "2421": {"vr": "DS", "Value": [132.0]},
        "2422": {"vr": "DS", "Value": [132.0]},
        "2423": {"vr": "DS", "Value": [75.0]},
        "2424": {"vr": "DS", "Value": [120.0]},
        "2425": {"vr": "DS", "Value": [123.0]},
        "2426": {"vr": "DS", "Value": [151.0]},
        "2427": {"vr": "DS", "Value": [130.0]},
        "2428": {"vr": "DS", "Value": [122.0]},
        "2429": {"vr": "DS", "Value": [138.0]},
        "2430": {"vr": "DS", "Value": [135.0]},
        "2431": {"vr": "DS", "Value": [131.0]},
        "2432": {"vr": "DS", "Value": [120.0]},
        "2433": {"vr": "DS", "Value": [620.0]},
        "2434": {"vr": "DS", "Value": [97.0]},
        "2435": {"vr": "DS", "Value": [75.0]},
        "2436": {"vr": "DS", "Value": [123.0]},
        "2437": {"vr": "DS", "Value": [139.0]},
        "2438": {"vr": "DS", "Value": [130.0]},
        "2439": {"vr": "DS", "Value": [136.0]},
        "2440": {"vr": "DS", "Value": [141.0]},
        "2441": {"vr": "DS", "Value": [143.0]},
        "2442": {"vr": "DS", "Value": [60.0]},
        "2443": {"vr": "DS", "Value": [144.0]},
        "2444": {"vr": "DS", "Value": [141.0]},
        "2445": {"vr": "DS", "Value": [148.0]},
        "2446": {"vr": "DS", "Value": [135.0]},
        "2447": {"vr": "DS", "Value": [123.0]},
        "2448": {"vr": "DS", "Value": [152.0]},
        "2449": {"vr": "DS", "Value": [99.0]},
        "2450": {"vr": "DS", "Value": [137.0]},
        "2451": {"vr": "DS", "Value": [133.0]},
        "2452": {"vr": "DS", "Value": [139.0]},
        "2453": {"vr": "DS", "Value": [136.0]},
        "2454": {"vr": "DS", "Value": [145.0]},
        "2455": {"vr": "DS", "Value": [59.0]},
        "2456": {"vr": "DS", "Value": [123.0]},
        "2457": {"vr": "DS", "Value": [141.0]},
        "2458": {"vr": "DS", "Value": [139.0]},
        "2459": {"vr": "DS", "Value": [125.0]},
        "2460": {"vr": "DS", "Value": [144.0]},
        "2461": {"vr": "DS", "Value": [146.0]},
        "2462": {"vr": "DS", "Value": [134.0]},
        "2463": {"vr": "DS", "Value": [144.0]},
        "2464": {"vr": "DS", "Value": [123.0]},
        "2465": {"vr": "DS", "Value": [126.0]},
        "2466": {"vr": "DS", "Value": [59.0]},
        "2467": {"vr": "DS", "Value": [122.0]},
        "2468": {"vr": "DS", "Value": [141.0]},
        "2469": {"vr": "DS", "Value": [153.0]},
        "2470": {"vr": "DS", "Value": [117.0]},
        "2471": {"vr": "DS", "Value": [147.0]},
        "2472": {"vr": "DS", "Value": [148.0]},
        "2473": {"vr": "DS", "Value": [92.0]},
        "2474": {"vr": "DS", "Value": [61.0]},
        "2475": {"vr": "DS", "Value": [20.0]},
        "2476": {"vr": "DS", "Value": [164.0]},
        "2477": {"vr": "DS", "Value": [148.0]},
        "2478": {"vr": "DS", "Value": [147.0]},
        "2479": {"vr": "DS", "Value": [612.0]},
        "2480": {"vr": "DS", "Value": [394.0]},
        "2481": {"vr": "DS", "Value": [138.0]},
        "2482": {"vr": "DS", "Value": [110.0]},
        "2483": {"vr": "DS", "Value": [145.0]},
        "2484": {"vr": "DS", "Value": [67.0]},
        "2485": {"vr": "DS", "Value": [146.0]},
        "2486": {"vr": "DS", "Value": [127.0]},
        "2487": {"vr": "DS", "Value": [68.0]},
        "2488": {"vr": "DS", "Value": [73.0]},
        "2489": {"vr": "DS", "Value": [139.0]},
        "2490": {"vr": "DS", "Value": [148.0]},
        "2491": {"vr": "DS", "Value": [141.0]},
        "2492": {"vr": "DS", "Value": [143.0]},
        "2493": {"vr": "DS", "Value": [150.0]},
        "2494": {"vr": "DS", "Value": [96.0]},
        "2495": {"vr": "DS", "Value": [141.0]},
        "2496": {"vr": "DS", "Value": [132.0]},
        "2497": {"vr": "DS", "Value": [142.0]},
        "2498": {"vr": "DS", "Value": [135.0]},
        "2499": {"vr": "DS", "Value": [140.0]},
        "2500": {"vr": "DS", "Value": [144.0]},
        "2501": {"vr": "DS", "Value": [50.0]},
        "2502": {"vr": "DS", "Value": [137.0]},
        "2503": {"vr": "DS", "Value": [156.0]},
        "2504": {"vr": "DS", "Value": [130.0]},
        "2505": {"vr": "DS", "Value": [67.0]},
        "2506": {"vr": "DS", "Value": [87.0]},
        "2507": {"vr": "DS", "Value": [151.0]},
        "2508": {"vr": "DS", "Value": [143.0]},
        "2509": {"vr": "DS", "Value": [117.0]},
        "2510": {"vr": "DS", "Value": [65.0]},
        "2511": {"vr": "DS", "Value": [142.0]},
        "2512": {"vr": "DS", "Value": [142.0]},
        "2513": {"vr": "DS", "Value": [140.0]},
        "2514": {"vr": "DS", "Value": [116.0]},
        "2515": {"vr": "DS", "Value": [111.0]},
        "2516": {"vr": "DS", "Value": [130.0]},
        "2517": {"vr": "DS", "Value": [102.0]},
        "2518": {"vr": "DS", "Value": [131.0]},
        "2519": {"vr": "DS", "Value": [138.0]},
        "2520": {"vr": "DS", "Value": [722.0]},
        "2521": {"vr": "DS", "Value": [152.0]},
        "2522": {"vr": "DS", "Value": [619.0]},
        "2523": {"vr": "DS", "Value": [140.0]},
        "2524": {"vr": "DS", "Value": [129.0]},
        "2525": {"vr": "DS", "Value": [641.0]},
        "2526": {"vr": "DS", "Value": [132.0]},
        "2527": {"vr": "DS", "Value": [101.0]},
        "2528": {"vr": "DS", "Value": [82.0]},
        "2529": {"vr": "DS", "Value": [155.0]},
        "2530": {"vr": "DS", "Value": [62.0]},
        "2531": {"vr": "DS", "Value": [67.0]},
        "2532": {"vr": "DS", "Value": [144.0]},
        "2533": {"vr": "DS", "Value": [50.0]},
        "2534": {"vr": "DS", "Value": [700.0]},
        "2535": {"vr": "DS", "Value": [138.0]},
        "2536": {"vr": "DS", "Value": [75.0]},
        "2537": {"vr": "DS", "Value": [709.0]},
        "2538": {"vr": "DS", "Value": [102.0]},
        "2539": {"vr": "DS", "Value": [635.0]},
        "2540": {"vr": "DS", "Value": [147.0]},
        "2541": {"vr": "DS", "Value": [25.0]},
        "2542": {"vr": "DS", "Value": [149.0]},
        "2543": {"vr": "DS", "Value": [126.0]},
        "2544": {"vr": "DS", "Value": [99.0]},
        "2545": {"vr": "DS", "Value": [144.0]},
        "2546": {"vr": "DS", "Value": [659.0]},
        "2547": {"vr": "DS", "Value": [136.0]},
        "2548": {"vr": "DS", "Value": [643.0]},
        "2549": {"vr": "DS", "Value": [63.0]},
        "2550": {"vr": "DS", "Value": [138.0]},
        "2551": {"vr": "DS", "Value": [129.0]},
        "2552": {"vr": "DS", "Value": [145.0]},
        "2553": {"vr": "DS", "Value": [112.0]},
        "2554": {"vr": "DS", "Value": [146.0]},
        "2555": {"vr": "DS", "Value": [125.0]},
        "2556": {"vr": "DS", "Value": [62.0]},
        "2557": {"vr": "DS", "Value": [673.0]},
        "2558": {"vr": "DS", "Value": [66.0]},
        "2559": {"vr": "DS", "Value": [90.0]},
        "2560": {"vr": "DS", "Value": [155.0]},
        "2561": {"vr": "DS", "Value": [128.0]},
        "2562": {"vr": "DS", "Value": [133.0]},
        "2563": {"vr": "DS", "Value": [148.0]},
        "2564": {"vr": "DS", "Value": [142.0]},
        "2565": {"vr": "DS", "Value": [141.0]},
        "2566": {"vr": "DS", "Value": [152.0]},
        "2567": {"vr": "DS", "Value": [115.0]},
        "2568": {"vr": "DS", "Value": [128.0]},
        "2569": {"vr": "DS", "Value": [128.0]},
        "2570": {"vr": "DS", "Value": [136.0]},
        "2571": {"vr": "DS", "Value": [760.0]},
        "2572": {"vr": "DS", "Value": [753.0]},
        "2573": {"vr": "DS", "Value": [143.0]},
        "2574": {"vr": "DS", "Value": [134.0]},
        "2575": {"vr": "DS", "Value": [115.0]},
        "2576": {"vr": "DS", "Value": [61.0]},
        "2577": {"vr": "DS", "Value": [133.0]},
        "2578": {"vr": "DS", "Value": [131.0]},
        "2579": {"vr": "DS", "Value": [129.0]},
        "2580": {"vr": "DS", "Value": [151.0]},
        "2581": {"vr": "DS", "Value": [131.0]},
        "2582": {"vr": "DS", "Value": [64.0]},
        "2583": {"vr": "DS", "Value": [137.0]},
        "2584": {"vr": "DS", "Value": [693.0]},
        "2585": {"vr": "DS", "Value": [721.0]},
        "2586": {"vr": "DS", "Value": [54.0]},
        "2587": {"vr": "DS", "Value": [119.0]},
        "2588": {"vr": "DS", "Value": [136.0]},
        "2589": {"vr": "DS", "Value": [144.0]},
        "2590": {"vr": "DS", "Value": [136.0]},
        "2591": {"vr": "DS", "Value": [128.0]},
        "2592": {"vr": "DS", "Value": [154.0]},
        "2593": {"vr": "DS", "Value": [55.0]},
        "2594": {"vr": "DS", "Value": [125.0]},
        "2595": {"vr": "DS", "Value": [144.0]},
        "2596": {"vr": "DS", "Value": [67.0]},
        "2597": {"vr": "DS", "Value": [66.0]},
        "2598": {"vr": "DS", "Value": [126.0]},
        "2599": {"vr": "DS", "Value": [111.0]},
        "2600": {"vr": "DS", "Value": [149.0]},
        "2601": {"vr": "DS", "Value": [133.0]},
        "2602": {"vr": "DS", "Value": [137.0]},
        "2603": {"vr": "DS", "Value": [113.0]},
        "2604": {"vr": "DS", "Value": [143.0]},
        "2605": {"vr": "DS", "Value": [144.0]},
        "2606": {"vr": "DS", "Value": [141.0]},
        "2607": {"vr": "DS", "Value": [71.0]},
        "2608": {"vr": "DS", "Value": [117.0]},
        "2609": {"vr": "DS", "Value": [697.0]},
        "2610": {"vr": "DS", "Value": [149.0]},
        "2611": {"vr": "DS", "Value": [615.0]},
        "2612": {"vr": "DS", "Value": [140.0]},
        "2613": {"vr": "DS", "Value": [145.0]},
        "2614": {"vr": "DS", "Value": [140.0]},
        "2615": {"vr": "DS", "Value": [119.0]},
        "2616": {"vr": "DS", "Value": [135.0]},
        "2617": {"vr": "DS", "Value": [142.0]},
        "2618": {"vr": "DS", "Value": [559.0]},
        "2619": {"vr": "DS", "Value": [167.0]},
        "2620": {"vr": "DS", "Value": [110.0]},
        "2621": {"vr": "DS", "Value": [141.0]},
        "2622": {"vr": "DS", "Value": [147.0]},
        "2623": {"vr": "DS", "Value": [140.0]},
        "2624": {"vr": "DS", "Value": [125.0]},
        "2625": {"vr": "DS", "Value": [148.0]},
        "2626": {"vr": "DS", "Value": [156.0]},
        "2627": {"vr": "DS", "Value": [121.0]},
        "2628": {"vr": "DS", "Value": [611.0]},
        "2629": {"vr": "DS", "Value": [701.0]},
        "2630": {"vr": "DS", "Value": [121.0]},
        "2631": {"vr": "DS", "Value": [140.0]},
        "2632": {"vr": "DS", "Value": [116.0]},
        "2633": {"vr": "DS", "Value": [140.0]},
        "2634": {"vr": "DS", "Value": [94.0]},
        "2635": {"vr": "DS", "Value": [145.0]},
        "2636": {"vr": "DS", "Value": [549.0]},
        "2637": {"vr": "DS", "Value": [144.0]},
        "2638": {"vr": "DS", "Value": [144.0]},
        "2639": {"vr": "DS", "Value": [700.0]},
        "2640": {"vr": "DS", "Value": [679.0]},
        "2641": {"vr": "DS", "Value": [96.0]},
        "2642": {"vr": "DS", "Value": [132.0]},
        "2643": {"vr": "DS", "Value": [102.0]},
        "2644": {"vr": "DS", "Value": [121.0]},
        "2645": {"vr": "DS", "Value": [119.0]},
        "2646": {"vr": "DS", "Value": [145.0]},
        "2647": {"vr": "DS", "Value": [131.0]},
        "2648": {"vr": "DS", "Value": [62.0]},
        "2649": {"vr": "DS", "Value": [102.0]},
        "2650": {"vr": "DS", "Value": [124.0]},
        "2651": {"vr": "DS", "Value": [64.0]},
        "2652": {"vr": "DS", "Value": [124.0]},
        "2653": {"vr": "DS", "Value": [125.0]},
        "2654": {"vr": "DS", "Value": [148.0]},
        "2655": {"vr": "DS", "Value": [153.0]},
        "2656": {"vr": "DS", "Value": [146.0]},
        "2657": {"vr": "DS", "Value": [120.0]},
        "2658": {"vr": "DS", "Value": [694.0]},
        "2659": {"vr": "DS", "Value": [122.0]},
        "2660": {"vr": "DS", "Value": [154.0]},
        "2661": {"vr": "DS", "Value": [68.0]},
        "2662": {"vr": "DS", "Value": [133.0]},
        "2663": {"vr": "DS", "Value": [133.0]},
        "2664": {"vr": "DS", "Value": [138.0]},
        "2665": {"vr": "DS", "Value": [67.0]},
        "2666": {"vr": "DS", "Value": [133.0]},
        "2667": {"vr": "DS", "Value": [140.0]},
        "2668": {"vr": "DS", "Value": [69.0]},
        "2669": {"vr": "DS", "Value": [120.0]},
        "2670": {"vr": "DS", "Value": [135.0]},
        "2671": {"vr": "DS", "Value": [122.0]},
        "2672": {"vr": "DS", "Value": [65.0]},
        "2673": {"vr": "DS", "Value": [125.0]},
        "2674": {"vr": "DS", "Value": [85.0]},
        "2675": {"vr": "DS", "Value": [148.0]},
        "2676": {"vr": "DS", "Value": [135.0]},
        "2677": {"vr": "DS", "Value": [160.0]},
        "2678": {"vr": "DS", "Value": [154.0]},
        "2679": {"vr": "DS", "Value": [684.0]},
        "2680": {"vr": "DS", "Value": [158.0]},
        "2681": {"vr": "DS", "Value": [138.0]},
        "2682": {"vr": "DS", "Value": [146.0]},
        "2683": {"vr": "DS", "Value": [146.0]},
        "2684": {"vr": "DS", "Value": [133.0]},
        "2685": {"vr": "DS", "Value": [142.0]},
        "2686": {"vr": "DS", "Value": [132.0]},
        "2687": {"vr": "DS", "Value": [144.0]},
        "2688": {"vr": "DS", "Value": [137.0]},
        "2689": {"vr": "DS", "Value": [144.0]},
        "2690": {"vr": "DS", "Value": [136.0]},
        "2691": {"vr": "DS", "Value": [136.0]},
        "2692": {"vr": "DS", "Value": [123.0]},
        "2693": {"vr": "DS", "Value": [147.0]},
        "2694": {"vr": "DS", "Value": [99.0]},
        "2695": {"vr": "DS", "Value": [106.0]},
        "2696": {"vr": "DS", "Value": [145.0]},
        "2697": {"vr": "DS", "Value": [24.0]},
        "2698": {"vr": "DS", "Value": [97.0]},
        "2699": {"vr": "DS", "Value": [132.0]},
        "2700": {"vr": "DS", "Value": [132.0]},
        "2701": {"vr": "DS", "Value": [143.0]},
        "2702": {"vr": "DS", "Value": [217.0]},
        "2703": {"vr": "DS", "Value": [151.0]},
        "2704": {"vr": "DS", "Value": [161.0]},
        "2705": {"vr": "DS", "Value": [134.0]},
        "2706": {"vr": "DS", "Value": [129.0]},
        "2707": {"vr": "DS", "Value": [103.0]},
        "2708": {"vr": "DS", "Value": [122.0]},
        "2709": {"vr": "DS", "Value": [130.0]},
        "2710": {"vr": "DS", "Value": [118.0]},
        "2711": {"vr": "DS", "Value": [145.0]},
        "2712": {"vr": "DS", "Value": [126.0]},
        "2713": {"vr": "DS", "Value": [124.0]},
        "2714": {"vr": "DS", "Value": [59.0]},
        "2715": {"vr": "DS", "Value": [127.0]},
        "2716": {"vr": "DS", "Value": [115.0]},
        "2717": {"vr": "DS", "Value": [142.0]},
        "2718": {"vr": "DS", "Value": [131.0]},
        "2719": {"vr": "DS", "Value": [164.0]},
        "2720": {"vr": "DS", "Value": [100.0]},
        "2721": {"vr": "DS", "Value": [132.0]},
        "2722": {"vr": "DS", "Value": [153.0]},
        "2723": {"vr": "DS", "Value": [130.0]},
        "2724": {"vr": "DS", "Value": [156.0]},
        "2725": {"vr": "DS", "Value": [127.0]},
        "2726": {"vr": "DS", "Value": [635.0]},
        "2727": {"vr": "DS", "Value": [149.0]},
        "2728": {"vr": "DS", "Value": [131.0]},
        "2729": {"vr": "DS", "Value": [63.0]},
        "2730": {"vr": "DS", "Value": [149.0]},
        "2731": {"vr": "DS", "Value": [70.0]},
        "2732": {"vr": "DS", "Value": [148.0]},
        "2733": {"vr": "DS", "Value": [139.0]},
        "2734": {"vr": "DS", "Value": [61.0]},
        "2735": {"vr": "DS", "Value": [93.0]},
        "2736": {"vr": "DS", "Value": [669.0]},
        "2737": {"vr": "DS", "Value": [120.0]},
        "2738": {"vr": "DS", "Value": [113.0]},
        "2739": {"vr": "DS", "Value": [70.0]},
        "2740": {"vr": "DS", "Value": [145.0]},
        "2741": {"vr": "DS", "Value": [617.0]},
        "2742": {"vr": "DS", "Value": [151.0]},
        "2743": {"vr": "DS", "Value": [141.0]},
        "2744": {"vr": "DS", "Value": [140.0]},
        "2745": {"vr": "DS", "Value": [118.0]},
        "2746": {"vr": "DS", "Value": [700.0]},
        "2747": {"vr": "DS", "Value": [144.0]},
        "2748": {"vr": "DS", "Value": [75.0]},
        "2749": {"vr": "DS", "Value": [73.0]},
        "2750": {"vr": "DS", "Value": [660.0]},
        "2751": {"vr": "DS", "Value": [136.0]},
        "2752": {"vr": "DS", "Value": [91.0]},
        "2753": {"vr": "DS", "Value": [153.0]},
        "2754": {"vr": "DS", "Value": [67.0]},
        "2755": {"vr": "DS", "Value": [149.0]},
        "2756": {"vr": "DS", "Value": [70.0]},
        "2757": {"vr": "DS", "Value": [684.0]},
        "2758": {"vr": "DS", "Value": [120.0]},
        "2759": {"vr": "DS", "Value": [144.0]},
        "2760": {"vr": "DS", "Value": [137.0]},
        "2761": {"vr": "DS", "Value": [108.0]},
        "2762": {"vr": "DS", "Value": [149.0]},
        "2763": {"vr": "DS", "Value": [63.0]},
        "2764": {"vr": "DS", "Value": [117.0]},
        "2765": {"vr": "DS", "Value": [571.0]},
        "2766": {"vr": "DS", "Value": [163.0]},
        "2767": {"vr": "DS", "Value": [139.0]},
        "2768": {"vr": "DS", "Value": [150.0]},
        "2769": {"vr": "DS", "Value": [119.0]},
        "2770": {"vr": "DS", "Value": [625.0]},
        "2771": {"vr": "DS", "Value": [65.0]},
        "2772": {"vr": "DS", "Value": [137.0]},
        "2773": {"vr": "DS", "Value": [120.0]},
        "2774": {"vr": "DS", "Value": [105.0]},
        "2775": {"vr": "DS", "Value": [132.0]},
        "2776": {"vr": "DS", "Value": [138.0]},
        "2777": {"vr": "DS", "Value": [627.0]},
        "2778": {"vr": "DS", "Value": [134.0]},
        "2779": {"vr": "DS", "Value": [132.0]},
        "2780": {"vr": "DS", "Value": [59.0]},
        "2781": {"vr": "DS", "Value": [687.0]},
        "2782": {"vr": "DS", "Value": [132.0]},
        "2783": {"vr": "DS", "Value": [57.0]},
        "2784": {"vr": "DS", "Value": [56.0]},
        "2785": {"vr": "DS", "Value": [134.0]},
        "2786": {"vr": "DS", "Value": [136.0]},
        "2787": {"vr": "DS", "Value": [141.0]},
        "2788": {"vr": "DS", "Value": [106.0]},
        "2789": {"vr": "DS", "Value": [136.0]},
        "2790": {"vr": "DS", "Value": [136.0]},
        "2791": {"vr": "DS", "Value": [149.0]},
        "2792": {"vr": "DS", "Value": [617.0]},
        "2793": {"vr": "DS", "Value": [100.0]},
        "2794": {"vr": "DS", "Value": [139.0]},
        "2795": {"vr": "DS", "Value": [92.0]},
        "2796": {"vr": "DS", "Value": [67.0]},
        "2797": {"vr": "DS", "Value": [677.0]},
        "2798": {"vr": "DS", "Value": [136.0]},
        "2799": {"vr": "DS", "Value": [112.0]},
        "2800": {"vr": "DS", "Value": [129.0]},
        "2801": {"vr": "DS", "Value": [23.0]},
        "2802": {"vr": "DS", "Value": [114.0]},
        "2803": {"vr": "DS", "Value": [140.0]},
        "2804": {"vr": "DS", "Value": [110.0]},
        "2805": {"vr": "DS", "Value": [65.0]},
        "2806": {"vr": "DS", "Value": [101.0]},
        "2807": {"vr": "DS", "Value": [140.0]},
        "2808": {"vr": "DS", "Value": [120.0]},
        "2809": {"vr": "DS", "Value": [100.0]},
        "2810": {"vr": "DS", "Value": [131.0]},
        "2811": {"vr": "DS", "Value": [68.0]},
        "2812": {"vr": "DS", "Value": [148.0]},
        "2813": {"vr": "DS", "Value": [139.0]},
        "2814": {"vr": "DS", "Value": [132.0]},
        "2815": {"vr": "DS", "Value": [64.0]},
        "2816": {"vr": "DS", "Value": [143.0]},
        "2817": {"vr": "DS", "Value": [143.0]},
        "2818": {"vr": "DS", "Value": [715.0]},
        "2819": {"vr": "DS", "Value": [115.0]},
        "2820": {"vr": "DS", "Value": [134.0]},
        "2821": {"vr": "DS", "Value": [151.0]},
        "2822": {"vr": "DS", "Value": [596.0]},
        "2823": {"vr": "DS", "Value": [89.0]},
        "2824": {"vr": "DS", "Value": [57.0]},
        "2825": {"vr": "DS", "Value": [108.0]},
        "2826": {"vr": "DS", "Value": [125.0]},
        "2827": {"vr": "DS", "Value": [62.0]},
        "2828": {"vr": "DS", "Value": [68.0]},
        "2829": {"vr": "DS", "Value": [99.0]},
        "2830": {"vr": "DS", "Value": [694.0]},
        "2831": {"vr": "DS", "Value": [112.0]},
        "2832": {"vr": "DS", "Value": [123.0]},
        "2833": {"vr": "DS", "Value": [67.0]},
        "2834": {"vr": "DS", "Value": [139.0]},
        "2835": {"vr": "DS", "Value": [141.0]},
        "2836": {"vr": "DS", "Value": [155.0]},
        "2837": {"vr": "DS", "Value": [132.0]},
        "2838": {"vr": "DS", "Value": [137.0]},
        "2839": {"vr": "DS", "Value": [132.0]},
        "2840": {"vr": "DS", "Value": [123.0]},
        "2841": {"vr": "DS", "Value": [158.0]},
        "2842": {"vr": "DS", "Value": [140.0]},
        "2843": {"vr": "DS", "Value": [118.0]},
        "2844": {"vr": "DS", "Value": [144.0]},
        "2845": {"vr": "DS", "Value": [106.0]},
        "2846": {"vr": "DS", "Value": [150.0]},
        "2847": {"vr": "DS", "Value": [148.0]},
        "2848": {"vr": "DS", "Value": [65.0]},
        "2849": {"vr": "DS", "Value": [66.0]},
        "2850": {"vr": "DS", "Value": [150.0]},
        "2851": {"vr": "DS", "Value": [137.0]},
        "2852": {"vr": "DS", "Value": [548.0]},
        "2853": {"vr": "DS", "Value": [123.0]},
        "2854": {"vr": "DS", "Value": [108.0]},
        "2855": {"vr": "DS", "Value": [624.0]},
        "2856": {"vr": "DS", "Value": [149.0]},
        "2857": {"vr": "DS", "Value": [115.0]},
        "2858": {"vr": "DS", "Value": [105.0]},
        "2859": {"vr": "DS", "Value": [136.0]},
        "2860": {"vr": "DS", "Value": [64.0]},
        "2861": {"vr": "DS", "Value": [68.0]},
        "2862": {"vr": "DS", "Value": [655.0]},
        "2863": {"vr": "DS", "Value": [166.0]},
        "2864": {"vr": "DS", "Value": [141.0]},
        "2865": {"vr": "DS", "Value": [142.0]},
        "2866": {"vr": "DS", "Value": [112.0]},
        "2867": {"vr": "DS", "Value": [67.0]},
        "2868": {"vr": "DS", "Value": [146.0]},
        "2869": {"vr": "DS", "Value": [135.0]},
        "2870": {"vr": "DS", "Value": [61.0]},
        "2871": {"vr": "DS", "Value": [153.0]},
        "2872": {"vr": "DS", "Value": [75.0]},
        "2873": {"vr": "DS", "Value": [150.0]},
        "2874": {"vr": "DS", "Value": [141.0]},
        "2875": {"vr": "DS", "Value": [143.0]},
        "2876": {"vr": "DS", "Value": [135.0]},
        "2877": {"vr": "DS", "Value": [152.0]},
        "2878": {"vr": "DS", "Value": [662.0]},
        "2879": {"vr": "DS", "Value": [146.0]},
        "2880": {"vr": "DS", "Value": [132.0]},
        "2881": {"vr": "DS", "Value": [133.0]},
        "2882": {"vr": "DS", "Value": [689.0]},
        "2883": {"vr": "DS", "Value": [148.0]},
        "2884": {"vr": "DS", "Value": [129.0]},
        "2885": {"vr": "DS", "Value": [141.0]},
        "2886": {"vr": "DS", "Value": [111.0]},
        "2887": {"vr": "DS", "Value": [105.0]},
        "2888": {"vr": "DS", "Value": [69.0]},
        "2889": {"vr": "DS", "Value": [136.0]},
        "2890": {"vr": "DS", "Value": [106.0]},
        "2891": {"vr": "DS", "Value": [157.0]},
        "2892": {"vr": "DS", "Value": [130.0]},
        "2893": {"vr": "DS", "Value": [133.0]},
        "2894": {"vr": "DS", "Value": [56.0]},
        "2895": {"vr": "DS", "Value": [138.0]},
        "2896": {"vr": "DS", "Value": [121.0]},
        "2897": {"vr": "DS", "Value": [119.0]},
        "2898": {"vr": "DS", "Value": [137.0]},
        "2899": {"vr": "DS", "Value": [117.0]},
        "2900": {"vr": "DS", "Value": [148.0]},
        "2901": {"vr": "DS", "Value": [142.0]},
        "2902": {"vr": "DS", "Value": [136.0]},
        "2903": {"vr": "DS", "Value": [146.0]},
        "2904": {"vr": "DS", "Value": [108.0]},
        "2905": {"vr": "DS", "Value": [120.0]},
        "2906": {"vr": "DS", "Value": [606.0]},
        "2907": {"vr": "DS", "Value": [698.0]},
        "2908": {"vr": "DS", "Value": [117.0]},
        "2909": {"vr": "DS", "Value": [155.0]},
        "2910": {"vr": "DS", "Value": [109.0]},
        "2911": {"vr": "DS", "Value": [118.0]},
        "2912": {"vr": "DS", "Value": [141.0]},
        "2913": {"vr": "DS", "Value": [125.0]},
        "2914": {"vr": "DS", "Value": [154.0]},
        "2915": {"vr": "DS", "Value": [84.0]},
        "2916": {"vr": "DS", "Value": [619.0]},
        "2917": {"vr": "DS", "Value": [61.0]},
        "2918": {"vr": "DS", "Value": [690.0]},
        "2919": {"vr": "DS", "Value": [652.0]},
        "2920": {"vr": "DS", "Value": [145.0]},
        "2921": {"vr": "DS", "Value": [119.0]},
        "2922": {"vr": "DS", "Value": [59.0]},
        "2923": {"vr": "DS", "Value": [634.0]},
        "2924": {"vr": "DS", "Value": [129.0]},
        "2925": {"vr": "DS", "Value": [22.0]},
        "2926": {"vr": "DS", "Value": [128.0]},
        "2927": {"vr": "DS", "Value": [151.0]},
        "2928": {"vr": "DS", "Value": [134.0]},
        "2929": {"vr": "DS", "Value": [121.0]},
        "2930": {"vr": "DS", "Value": [621.0]},
        "2931": {"vr": "DS", "Value": [137.0]},
        "2932": {"vr": "DS", "Value": [149.0]},
        "2933": {"vr": "DS", "Value": [139.0]},
        "2934": {"vr": "DS", "Value": [112.0]},
        "2935": {"vr": "DS", "Value": [208.0]},
        "2936": {"vr": "DS", "Value": [50.0]},
        "2937": {"vr": "DS", "Value": [110.0]},
        "2938": {"vr": "DS", "Value": [174.0]},
        "2939": {"vr": "DS", "Value": [143.0]},
        "2940": {"vr": "DS", "Value": [128.0]},
        "2941": {"vr": "DS", "Value": [146.0]},
        "2942": {"vr": "DS", "Value": [127.0]},
        "2943": {"vr": "DS", "Value": [140.0]},
        "2944": {"vr": "DS", "Value": [152.0]},
        "2945": {"vr": "DS", "Value": [149.0]},
        "2946": {"vr": "DS", "Value": [693.0]},
        "2947": {"vr": "DS", "Value": [149.0]},
        "2948": {"vr": "DS", "Value": [80.0]},
        "2949": {"vr": "DS", "Value": [587.0]},
        "2950": {"vr": "DS", "Value": [77.0]},
        "2951": {"vr": "DS", "Value": [139.0]},
        "2952": {"vr": "DS", "Value": [158.0]},
        "2953": {"vr": "DS", "Value": [60.0]},
        "2954": {"vr": "DS", "Value": [645.0]},
        "2955": {"vr": "DS", "Value": [756.0]},
        "2956": {"vr": "DS", "Value": [147.0]},
        "2957": {"vr": "DS", "Value": [133.0]},
        "2958": {"vr": "DS", "Value": [62.0]},
        "2959": {"vr": "DS", "Value": [158.0]},
        "2960": {"vr": "DS", "Value": [140.0]},
        "2961": {"vr": "DS", "Value": [123.0]},
        "2962": {"vr": "DS", "Value": [112.0]},
        "2963": {"vr": "DS", "Value": [125.0]},
        "2964": {"vr": "DS", "Value": [138.0]},
        "2965": {"vr": "DS", "Value": [121.0]},
        "2966": {"vr": "DS", "Value": [122.0]},
        "2967": {"vr": "DS", "Value": [129.0]},
        "2968": {"vr": "DS", "Value": [655.0]},
        "2969": {"vr": "DS", "Value": [137.0]},
        "2970": {"vr": "DS", "Value": [150.0]},
        "2971": {"vr": "DS", "Value": [135.0]},
        "2972": {"vr": "DS", "Value": [134.0]},
        "2973": {"vr": "DS", "Value": [131.0]},
        "2974": {"vr": "DS", "Value": [147.0]},
        "2975": {"vr": "DS", "Value": [136.0]},
        "2976": {"vr": "DS", "Value": [142.0]},
        "2977": {"vr": "DS", "Value": [140.0]},
        "2978": {"vr": "DS", "Value": [120.0]},
        "2979": {"vr": "DS", "Value": [71.0]},
        "2980": {"vr": "DS", "Value": [138.0]},
        "2981": {"vr": "DS", "Value": [136.0]},
        "2982": {"vr": "DS", "Value": [149.0]},
        "2983": {"vr": "DS", "Value": [145.0]},
        "2984": {"vr": "DS", "Value": [119.0]},
        "2985": {"vr": "DS", "Value": [692.0]},
        "2986": {"vr": "DS", "Value": [144.0]},
        "2987": {"vr": "DS", "Value": [90.0]},
        "2988": {"vr": "DS", "Value": [149.0]},
        "2989": {"vr": "DS", "Value": [104.0]},
        "2990": {"vr": "DS", "Value": [105.0]},
        "2991": {"vr": "DS", "Value": [123.0]},
        "2992": {"vr": "DS", "Value": [149.0]},
        "2993": {"vr": "DS", "Value": [109.0]},
        "2994": {"vr": "DS", "Value": [134.0]},
        "2995": {"vr": "DS", "Value": [60.0]},
        "2996": {"vr": "DS", "Value": [155.0]},
        "2997": {"vr": "DS", "Value": [141.0]},
        "2998": {"vr": "DS", "Value": [144.0]},
        "2999": {"vr": "DS", "Value": [104.0]},
        "3000": {"vr": "DS", "Value": [144.0]},
        "3001": {"vr": "DS", "Value": [142.0]},
        "3002": {"vr": "DS", "Value": [158.0]},
        "3003": {"vr": "DS", "Value": [131.0]},
        "3004": {"vr": "DS", "Value": [140.0]},
        "3005": {"vr": "DS", "Value": [673.0]},
        "3006": {"vr": "DS", "Value": [99.0]},
        "3007": {"vr": "DS", "Value": [149.0]},
        "3008": {"vr": "DS", "Value": [108.0]},
        "3009": {"vr": "DS", "Value": [142.0]},
        "3010": {"vr": "DS", "Value": [141.0]},
        "3011": {"vr": "DS", "Value": [136.0]},
        "3012": {"vr": "DS", "Value": [145.0]},
        "3013": {"vr": "DS", "Value": [128.0]},
        "3014": {"vr": "DS", "Value": [99.0]},
        "3015": {"vr": "DS", "Value": [141.0]},
        "3016": {"vr": "DS", "Value": [127.0]},
        "3017": {"vr": "DS", "Value": [133.0]},
        "3018": {"vr": "DS", "Value": [145.0]},
        "3019": {"vr": "DS", "Value": [588.0]},
        "3020": {"vr": "DS", "Value": [127.0]},
        "3021": {"vr": "DS", "Value": [112.0]},
        "3022": {"vr": "DS", "Value": [128.0]},
        "3023": {"vr": "DS", "Value": [108.0]},
        "3024": {"vr": "DS", "Value": [143.0]},
        "3025": {"vr": "DS", "Value": [86.0]},
        "3026": {"vr": "DS", "Value": [140.0]},
        "3027": {"vr": "DS", "Value": [127.0]},
        "3028": {"vr": "DS", "Value": [126.0]},
        "3029": {"vr": "DS", "Value": [691.0]},
        "3030": {"vr": "DS", "Value": [173.0]},
        "3031": {"vr": "DS", "Value": [82.0]},
        "3032": {"vr": "DS", "Value": [144.0]},
        "3033": {"vr": "DS", "Value": [129.0]},
        "3034": {"vr": "DS", "Value": [123.0]},
        "3035": {"vr": "DS", "Value": [98.0]},
        "3036": {"vr": "DS", "Value": [126.0]},
        "3037": {"vr": "DS", "Value": [126.0]},
        "3038": {"vr": "DS", "Value": [113.0]},
        "3039": {"vr": "DS", "Value": [98.0]},
        "3040": {"vr": "DS", "Value": [133.0]},
        "3041": {"vr": "DS", "Value": [129.0]},
        "3042": {"vr": "DS", "Value": [114.0]},
        "3043": {"vr": "DS", "Value": [131.0]},
        "3044": {"vr": "DS", "Value": [136.0]},
        "3045": {"vr": "DS", "Value": [139.0]},
        "3046": {"vr": "DS", "Value": [131.0]},
        "3047": {"vr": "DS", "Value": [138.0]},
        "3048": {"vr": "DS", "Value": [93.0]},
        "3049": {"vr": "DS", "Value": [102.0]},
        "3050": {"vr": "DS", "Value": [106.0]},
        "3051": {"vr": "DS", "Value": [123.0]},
        "3052": {"vr": "DS", "Value": [147.0]},
        "3053": {"vr": "DS", "Value": [585.0]},
        "3054": {"vr": "DS", "Value": [133.0]},
        "3055": {"vr": "DS", "Value": [148.0]},
        "3056": {"vr": "DS", "Value": [150.0]},
        "3057": {"vr": "DS", "Value": [91.0]},
        "3058": {"vr": "DS", "Value": [78.0]},
        "3059": {"vr": "DS", "Value": [62.0]},
        "3060": {"vr": "DS", "Value": [148.0]},
        "3061": {"vr": "DS", "Value": [69.0]},
        "3062": {"vr": "DS", "Value": [146.0]},
        "3063": {"vr": "DS", "Value": [133.0]},
        "3064": {"vr": "DS", "Value": [120.0]},
        "3065": {"vr": "DS", "Value": [136.0]},
        "3066": {"vr": "DS", "Value": [141.0]},
        "3067": {"vr": "DS", "Value": [134.0]},
        "3068": {"vr": "DS", "Value": [113.0]},
        "3069": {"vr": "DS", "Value": [124.0]},
        "3070": {"vr": "DS", "Value": [101.0]},
        "3071": {"vr": "DS", "Value": [141.0]},
        "3072": {"vr": "DS", "Value": [620.0]},
        "3073": {"vr": "DS", "Value": [68.0]},
        "3074": {"vr": "DS", "Value": [713.0]},
        "3075": {"vr": "DS", "Value": [132.0]},
        "3076": {"vr": "DS", "Value": [130.0]},
        "3077": {"vr": "DS", "Value": [633.0]},
        "3078": {"vr": "DS", "Value": [102.0]},
        "3079": {"vr": "DS", "Value": [144.0]},
        "3080": {"vr": "DS", "Value": [137.0]},
        "3081": {"vr": "DS", "Value": [136.0]},
        "3082": {"vr": "DS", "Value": [119.0]},
        "3083": {"vr": "DS", "Value": [136.0]},
        "3084": {"vr": "DS", "Value": [149.0]},
        "3085": {"vr": "DS", "Value": [129.0]},
        "3086": {"vr": "DS", "Value": [134.0]},
        "3087": {"vr": "DS", "Value": [102.0]},
        "3088": {"vr": "DS", "Value": [120.0]},
        "3089": {"vr": "DS", "Value": [634.0]},
        "3090": {"vr": "DS", "Value": [97.0]},
        "3091": {"vr": "DS", "Value": [144.0]},
        "3092": {"vr": "DS", "Value": [651.0]},
        "3093": {"vr": "DS", "Value": [140.0]},
        "3094": {"vr": "DS", "Value": [93.0]},
        "3095": {"vr": "DS", "Value": [114.0]},
        "3096": {"vr": "DS", "Value": [117.0]},
        "3097": {"vr": "DS", "Value": [104.0]},
        "3098": {"vr": "DS", "Value": [153.0]},
        "3099": {"vr": "DS", "Value": [131.0]},
        "3100": {"vr": "DS", "Value": [137.0]},
        "3101": {"vr": "DS", "Value": [129.0]},
        "3102": {"vr": "DS", "Value": [692.0]},
        "3103": {"vr": "DS", "Value": [161.0]},
        "3104": {"vr": "DS", "Value": [137.0]},
        "3105": {"vr": "DS", "Value": [61.0]},
        "3106": {"vr": "DS", "Value": [137.0]},
        "3107": {"vr": "DS", "Value": [65.0]},
        "3108": {"vr": "DS", "Value": [137.0]},
        "3109": {"vr": "DS", "Value": [137.0]},
        "3110": {"vr": "DS", "Value": [136.0]},
        "3111": {"vr": "DS", "Value": [141.0]},
        "3112": {"vr": "DS", "Value": [139.0]},
        "3113": {"vr": "DS", "Value": [51.0]},
        "3114": {"vr": "DS", "Value": [135.0]},
        "3115": {"vr": "DS", "Value": [104.0]},
        "3116": {"vr": "DS", "Value": [101.0]},
        "3117": {"vr": "DS", "Value": [130.0]},
        "3118": {"vr": "DS", "Value": [150.0]},
        "3119": {"vr": "DS", "Value": [150.0]},
        "3120": {"vr": "DS", "Value": [142.0]},
        "3121": {"vr": "DS", "Value": [56.0]},
        "3122": {"vr": "DS", "Value": [146.0]},
        "3123": {"vr": "DS", "Value": [68.0]},
        "3124": {"vr": "DS", "Value": [139.0]},
        "3125": {"vr": "DS", "Value": [148.0]},
        "3126": {"vr": "DS", "Value": [141.0]},
        "3127": {"vr": "DS", "Value": [140.0]},
        "3128": {"vr": "DS", "Value": [77.0]},
        "3129": {"vr": "DS", "Value": [140.0]},
        "3130": {"vr": "DS", "Value": [144.0]},
        "3131": {"vr": "DS", "Value": [118.0]},
        "3132": {"vr": "DS", "Value": [674.0]},
        "3133": {"vr": "DS", "Value": [147.0]},
        "3134": {"vr": "DS", "Value": [123.0]},
        "3135": {"vr": "DS", "Value": [139.0]},
        "3136": {"vr": "DS", "Value": [135.0]},
        "3137": {"vr": "DS", "Value": [131.0]},
        "3138": {"vr": "DS", "Value": [115.0]},
        "3139": {"vr": "DS", "Value": [143.0]},
        "3140": {"vr": "DS", "Value": [108.0]},
        "3141": {"vr": "DS", "Value": [124.0]},
        "3142": {"vr": "DS", "Value": [114.0]},
        "3143": {"vr": "DS", "Value": [144.0]},
        "3144": {"vr": "DS", "Value": [127.0]},
        "3145": {"vr": "DS", "Value": [115.0]},
        "3146": {"vr": "DS", "Value": [130.0]},
        "3147": {"vr": "DS", "Value": [140.0]},
        "3148": {"vr": "DS", "Value": [144.0]},
        "3149": {"vr": "DS", "Value": [20.0]},
        "3150": {"vr": "DS", "Value": [87.0]},
        "3151": {"vr": "DS", "Value": [135.0]},
        "3152": {"vr": "DS", "Value": [136.0]},
        "3153": {"vr": "DS", "Value": [113.0]},
        "3154": {"vr": "DS", "Value": [112.0]},
        "3155": {"vr": "DS", "Value": [164.0]},
        "3156": {"vr": "DS", "Value": [93.0]},
        "3157": {"vr": "DS", "Value": [69.0]},
        "3158": {"vr": "DS", "Value": [133.0]},
        "3159": {"vr": "DS", "Value": [136.0]},
        "3160": {"vr": "DS", "Value": [656.0]},
        "3161": {"vr": "DS", "Value": [141.0]},
        "3162": {"vr": "DS", "Value": [135.0]},
        "3163": {"vr": "DS", "Value": [128.0]},
        "3164": {"vr": "DS", "Value": [117.0]},
        "3165": {"vr": "DS", "Value": [612.0]},
        "3166": {"vr": "DS", "Value": [129.0]},
        "3167": {"vr": "DS", "Value": [152.0]},
        "3168": {"vr": "DS", "Value": [142.0]},
        "3169": {"vr": "DS", "Value": [67.0]},
        "3170": {"vr": "DS", "Value": [65.0]},
        "3171": {"vr": "DS", "Value": [148.0]},
        "3172": {"vr": "DS", "Value": [607.0]},
        "3173": {"vr": "DS", "Value": [24.0]},
        "3174": {"vr": "DS", "Value": [68.0]},
        "3175": {"vr": "DS", "Value": [156.0]},
        "3176": {"vr": "DS", "Value": [93.0]},
        "3177": {"vr": "DS", "Value": [116.0]},
        "3178": {"vr": "DS", "Value": [65.0]},
        "3179": {"vr": "DS", "Value": [91.0]},
        "3180": {"vr": "DS", "Value": [111.0]},
        "3181": {"vr": "DS", "Value": [131.0]},
        "3182": {"vr": "DS", "Value": [145.0]},
        "3183": {"vr": "DS", "Value": [137.0]},
        "3184": {"vr": "DS", "Value": [112.0]},
        "3185": {"vr": "DS", "Value": [141.0]},
        "3186": {"vr": "DS", "Value": [133.0]},
        "3187": {"vr": "DS", "Value": [143.0]},
        "3188": {"vr": "DS", "Value": [132.0]},
        "3189": {"vr": "DS", "Value": [19.0]},
        "3190": {"vr": "DS", "Value": [138.0]},
        "3191": {"vr": "DS", "Value": [128.0]},
        "3192": {"vr": "DS", "Value": [21.0]},
        "3193": {"vr": "DS", "Value": [697.0]},
        "3194": {"vr": "DS", "Value": [695.0]},
        "3195": {"vr": "DS", "Value": [116.0]},
        "3196": {"vr": "DS", "Value": [149.0]},
        "3197": {"vr": "DS", "Value": [97.0]},
        "3198": {"vr": "DS", "Value": [124.0]},
        "3199": {"vr": "DS", "Value": [140.0]},
        "3200": {"vr": "DS", "Value": [142.0]},
        "3201": {"vr": "DS", "Value": [143.0]},
        "3202": {"vr": "DS", "Value": [136.0]},
        "3203": {"vr": "DS", "Value": [66.0]},
        "3204": {"vr": "DS", "Value": [141.0]},
        "3205": {"vr": "DS", "Value": [141.0]},
        "3206": {"vr": "DS", "Value": [126.0]},
        "3207": {"vr": "DS", "Value": [121.0]},
        "3208": {"vr": "DS", "Value": [145.0]},
        "3209": {"vr": "DS", "Value": [62.0]},
        "3210": {"vr": "DS", "Value": [134.0]},
        "3211": {"vr": "DS", "Value": [137.0]},
        "3212": {"vr": "DS", "Value": [71.0]},
        "3213": {"vr": "DS", "Value": [141.0]},
        "3214": {"vr": "DS", "Value": [156.0]},
        "3215": {"vr": "DS", "Value": [143.0]},
        "3216": {"vr": "DS", "Value": [67.0]},
        "3217": {"vr": "DS", "Value": [147.0]},
        "3218": {"vr": "DS", "Value": [651.0]},
        "3219": {"vr": "DS", "Value": [159.0]},
        "3220": {"vr": "DS", "Value": [119.0]},
        "3221": {"vr": "DS", "Value": [141.0]},
        "3222": {"vr": "DS", "Value": [104.0]},
        "3223": {"vr": "DS", "Value": [106.0]},
        "3224": {"vr": "DS", "Value": [17.0]},
        "3225": {"vr": "DS", "Value": [137.0]},
        "3226": {"vr": "DS", "Value": [148.0]},
        "3227": {"vr": "DS", "Value": [147.0]},
        "3228": {"vr": "DS", "Value": [158.0]},
        "3229": {"vr": "DS", "Value": [138.0]},
        "3230": {"vr": "DS", "Value": [588.0]},
        "3231": {"vr": "DS", "Value": [132.0]},
        "3232": {"vr": "DS", "Value": [132.0]},
        "3233": {"vr": "DS", "Value": [138.0]},
        "3234": {"vr": "DS", "Value": [139.0]},
        "3235": {"vr": "DS", "Value": [126.0]},
        "3236": {"vr": "DS", "Value": [131.0]},
        "3237": {"vr": "DS", "Value": [67.0]},
        "3238": {"vr": "DS", "Value": [83.0]},
        "3239": {"vr": "DS", "Value": [133.0]},
        "3240": {"vr": "DS", "Value": [138.0]},
        "3241": {"vr": "DS", "Value": [148.0]},
        "3242": {"vr": "DS", "Value": [131.0]},
        "3243": {"vr": "DS", "Value": [650.0]},
        "3244": {"vr": "DS", "Value": [143.0]},
        "3245": {"vr": "DS", "Value": [114.0]},
        "3246": {"vr": "DS", "Value": [117.0]},
        "3247": {"vr": "DS", "Value": [140.0]},
        "3248": {"vr": "DS", "Value": [141.0]},
        "3249": {"vr": "DS", "Value": [95.0]},
        "3250": {"vr": "DS", "Value": [129.0]},
        "3251": {"vr": "DS", "Value": [140.0]},
        "3252": {"vr": "DS", "Value": [139.0]},
        "3253": {"vr": "DS", "Value": [148.0]},
        "3254": {"vr": "DS", "Value": [100.0]},
        "3255": {"vr": "DS", "Value": [133.0]},
        "3256": {"vr": "DS", "Value": [652.0]},
        "3257": {"vr": "DS", "Value": [135.0]},
        "3258": {"vr": "DS", "Value": [695.0]},
        "3259": {"vr": "DS", "Value": [144.0]},
        "3260": {"vr": "DS", "Value": [150.0]},
        "3261": {"vr": "DS", "Value": [114.0]},
        "3262": {"vr": "DS", "Value": [147.0]},
        "3263": {"vr": "DS", "Value": [128.0]},
        "3264": {"vr": "DS", "Value": [681.0]},
        "3265": {"vr": "DS", "Value": [136.0]},
        "3266": {"vr": "DS", "Value": [143.0]},
        "3267": {"vr": "DS", "Value": [107.0]},
        "3268": {"vr": "DS", "Value": [71.0]},
        "3269": {"vr": "DS", "Value": [132.0]},
        "3270": {"vr": "DS", "Value": [647.0]},
        "3271": {"vr": "DS", "Value": [99.0]},
        "3272": {"vr": "DS", "Value": [140.0]},
        "3273": {"vr": "DS", "Value": [140.0]},
        "3274": {"vr": "DS", "Value": [139.0]},
        "3275": {"vr": "DS", "Value": [144.0]},
        "3276": {"vr": "DS", "Value": [96.0]},
        "3277": {"vr": "DS", "Value": [129.0]},
        "3278": {"vr": "DS", "Value": [80.0]},
        "3279": {"vr": "DS", "Value": [123.0]},
        "3280": {"vr": "DS", "Value": [611.0]},
        "3281": {"vr": "DS", "Value": [147.0]},
        "3282": {"vr": "DS", "Value": [139.0]},
        "3283": {"vr": "DS", "Value": [112.0]},
        "3284": {"vr": "DS", "Value": [147.0]},
        "3285": {"vr": "DS", "Value": [133.0]},
        "3286": {"vr": "DS", "Value": [135.0]},
        "3287": {"vr": "DS", "Value": [138.0]},
        "3288": {"vr": "DS", "Value": [130.0]},
        "3289": {"vr": "DS", "Value": [66.0]},
        "3290": {"vr": "DS", "Value": [107.0]},
        "3291": {"vr": "DS", "Value": [68.0]},
        "3292": {"vr": "DS", "Value": [130.0]},
        "3293": {"vr": "DS", "Value": [63.0]},
        "3294": {"vr": "DS", "Value": [135.0]},
        "3295": {"vr": "DS", "Value": [164.0]},
        "3296": {"vr": "DS", "Value": [141.0]},
        "3297": {"vr": "DS", "Value": [77.0]},
        "3298": {"vr": "DS", "Value": [124.0]},
        "3299": {"vr": "DS", "Value": [65.0]},
        "3300": {"vr": "DS", "Value": [58.0]},
        "3301": {"vr": "DS", "Value": [59.0]},
        "3302": {"vr": "DS", "Value": [151.0]},
        "3303": {"vr": "DS", "Value": [64.0]},
        "3304": {"vr": "DS", "Value": [140.0]},
        "3305": {"vr": "DS", "Value": [146.0]},
        "3306": {"vr": "DS", "Value": [130.0]},
        "3307": {"vr": "DS", "Value": [66.0]},
        "3308": {"vr": "DS", "Value": [135.0]},
        "3309": {"vr": "DS", "Value": [133.0]},
        "3310": {"vr": "DS", "Value": [135.0]},
        "3311": {"vr": "DS", "Value": [131.0]},
        "3312": {"vr": "DS", "Value": [72.0]},
        "3313": {"vr": "DS", "Value": [127.0]},
        "3314": {"vr": "DS", "Value": [72.0]},
        "3315": {"vr": "DS", "Value": [155.0]},
        "3316": {"vr": "DS", "Value": [56.0]},
        "3317": {"vr": "DS", "Value": [161.0]},
        "3318": {"vr": "DS", "Value": [134.0]},
        "3319": {"vr": "DS", "Value": [127.0]},
        "3320": {"vr": "DS", "Value": [64.0]},
        "3321": {"vr": "DS", "Value": [142.0]},
        "3322": {"vr": "DS", "Value": [130.0]},
        "3323": {"vr": "DS", "Value": [64.0]},
        "3324": {"vr": "DS", "Value": [86.0]},
        "3325": {"vr": "DS", "Value": [132.0]},
        "3326": {"vr": "DS", "Value": [127.0]},
        "3327": {"vr": "DS", "Value": [132.0]},
        "3328": {"vr": "DS", "Value": [620.0]},
        "3329": {"vr": "DS", "Value": [113.0]},
        "3330": {"vr": "DS", "Value": [119.0]},
        "3331": {"vr": "DS", "Value": [141.0]},
        "3332": {"vr": "DS", "Value": [143.0]},
        "3333": {"vr": "DS", "Value": [134.0]},
        "3334": {"vr": "DS", "Value": [153.0]},
        "3335": {"vr": "DS", "Value": [149.0]},
        "3336": {"vr": "DS", "Value": [81.0]},
        "3337": {"vr": "DS", "Value": [96.0]},
        "3338": {"vr": "DS", "Value": [140.0]},
        "3339": {"vr": "DS", "Value": [136.0]},
        "3340": {"vr": "DS", "Value": [93.0]},
        "3341": {"vr": "DS", "Value": [139.0]},
        "3342": {"vr": "DS", "Value": [147.0]},
        "3343": {"vr": "DS", "Value": [154.0]},
        "3344": {"vr": "DS", "Value": [144.0]},
        "3345": {"vr": "DS", "Value": [136.0]},
        "3346": {"vr": "DS", "Value": [143.0]},
        "3347": {"vr": "DS", "Value": [688.0]},
        "3348": {"vr": "DS", "Value": [139.0]},
        "3349": {"vr": "DS", "Value": [144.0]},
        "3350": {"vr": "DS", "Value": [99.0]},
        "3351": {"vr": "DS", "Value": [130.0]},
        "3352": {"vr": "DS", "Value": [136.0]},
        "3353": {"vr": "DS", "Value": [100.0]},
        "3354": {"vr": "DS", "Value": [66.0]},
        "3355": {"vr": "DS", "Value": [50.0]},
        "3356": {"vr": "DS", "Value": [119.0]},
        "3357": {"vr": "DS", "Value": [140.0]},
        "3358": {"vr": "DS", "Value": [137.0]},
        "3359": {"vr": "DS", "Value": [154.0]},
        "3360": {"vr": "DS", "Value": [136.0]},
        "3361": {"vr": "DS", "Value": [144.0]},
        "3362": {"vr": "DS", "Value": [118.0]},
        "3363": {"vr": "DS", "Value": [63.0]},
        "3364": {"vr": "DS", "Value": [126.0]},
        "3365": {"vr": "DS", "Value": [759.0]},
        "3366": {"vr": "DS", "Value": [157.0]},
        "3367": {"vr": "DS", "Value": [135.0]},
        "3368": {"vr": "DS", "Value": [137.0]},
        "3369": {"vr": "DS", "Value": [102.0]},
        "3370": {"vr": "DS", "Value": [138.0]},
        "3371": {"vr": "DS", "Value": [140.0]},
        "3372": {"vr": "DS", "Value": [140.0]},
        "3373": {"vr": "DS", "Value": [135.0]},
        "3374": {"vr": "DS", "Value": [135.0]},
        "3375": {"vr": "DS", "Value": [144.0]},
        "3376": {"vr": "DS", "Value": [157.0]},
        "3377": {"vr": "DS", "Value": [141.0]},
        "3378": {"vr": "DS", "Value": [66.0]},
        "3379": {"vr": "DS", "Value": [137.0]},
        "3380": {"vr": "DS", "Value": [151.0]},
        "3381": {"vr": "DS", "Value": [150.0]},
        "3382": {"vr": "DS", "Value": [145.0]},
        "3383": {"vr": "DS", "Value": [142.0]},
        "3384": {"vr": "DS", "Value": [650.0]},
        "3385": {"vr": "DS", "Value": [139.0]},
        "3386": {"vr": "DS", "Value": [144.0]},
        "3387": {"vr": "DS", "Value": [145.0]},
        "3388": {"vr": "DS", "Value": [143.0]},
        "3389": {"vr": "DS", "Value": [645.0]},
        "3390": {"vr": "DS", "Value": [143.0]},
        "3391": {"vr": "DS", "Value": [134.0]},
        "3392": {"vr": "DS", "Value": [133.0]},
        "3393": {"vr": "DS", "Value": [130.0]},
        "3394": {"vr": "DS", "Value": [138.0]},
        "3395": {"vr": "DS", "Value": [138.0]},
        "3396": {"vr": "DS", "Value": [71.0]},
        "3397": {"vr": "DS", "Value": [146.0]},
        "3398": {"vr": "DS", "Value": [122.0]},
        "3399": {"vr": "DS", "Value": [151.0]},
        "3400": {"vr": "DS", "Value": [133.0]},
        "3401": {"vr": "DS", "Value": [117.0]},
        "3402": {"vr": "DS", "Value": [102.0]},
        "3403": {"vr": "DS", "Value": [136.0]},
        "3404": {"vr": "DS", "Value": [138.0]},
        "3405": {"vr": "DS", "Value": [605.0]},
        "3406": {"vr": "DS", "Value": [143.0]},
        "3407": {"vr": "DS", "Value": [142.0]},
        "3408": {"vr": "DS", "Value": [138.0]},
        "3409": {"vr": "DS", "Value": [85.0]},
        "3410": {"vr": "DS", "Value": [137.0]},
        "3411": {"vr": "DS", "Value": [69.0]},
        "3412": {"vr": "DS", "Value": [90.0]},
        "3413": {"vr": "DS", "Value": [139.0]},
        "3414": {"vr": "DS", "Value": [129.0]},
        "3415": {"vr": "DS", "Value": [160.0]},
        "3416": {"vr": "DS", "Value": [128.0]},
        "3417": {"vr": "DS", "Value": [57.0]},
        "3418": {"vr": "DS", "Value": [160.0]},
        "3419": {"vr": "DS", "Value": [141.0]},
        "3420": {"vr": "DS", "Value": [150.0]},
        "3421": {"vr": "DS", "Value": [86.0]},
        "3422": {"vr": "DS", "Value": [128.0]},
        "3423": {"vr": "DS", "Value": [157.0]},
        "3424": {"vr": "DS", "Value": [111.0]},
        "3425": {"vr": "DS", "Value": [141.0]},
        "3426": {"vr": "DS", "Value": [127.0]},
        "3427": {"vr": "DS", "Value": [64.0]},
        "3428": {"vr": "DS", "Value": [67.0]},
        "3429": {"vr": "DS", "Value": [152.0]},
        "3430": {"vr": "DS", "Value": [105.0]},
        "3431": {"vr": "DS", "Value": [718.0]},
        "3432": {"vr": "DS", "Value": [105.0]},
        "3433": {"vr": "DS", "Value": [132.0]},
        "3434": {"vr": "DS", "Value": [115.0]},
        "3435": {"vr": "DS", "Value": [66.0]},
        "3436": {"vr": "DS", "Value": [745.0]},
        "3437": {"vr": "DS", "Value": [138.0]},
        "3438": {"vr": "DS", "Value": [144.0]},
        "3439": {"vr": "DS", "Value": [143.0]},
        "3440": {"vr": "DS", "Value": [144.0]},
        "3441": {"vr": "DS", "Value": [106.0]},
        "3442": {"vr": "DS", "Value": [137.0]},
        "3443": {"vr": "DS", "Value": [155.0]},
        "3444": {"vr": "DS", "Value": [105.0]},
        "3445": {"vr": "DS", "Value": [69.0]},
        "3446": {"vr": "DS", "Value": [688.0]},
        "3447": {"vr": "DS", "Value": [99.0]},
        "3448": {"vr": "DS", "Value": [101.0]},
        "3449": {"vr": "DS", "Value": [149.0]},
        "3450": {"vr": "DS", "Value": [101.0]},
        "3451": {"vr": "DS", "Value": [159.0]},
        "3452": {"vr": "DS", "Value": [159.0]},
        "3453": {"vr": "DS", "Value": [128.0]},
        "3454": {"vr": "DS", "Value": [643.0]},
        "3455": {"vr": "DS", "Value": [148.0]},
        "3456": {"vr": "DS", "Value": [21.0]},
        "3457": {"vr": "DS", "Value": [91.0]},
        "3458": {"vr": "DS", "Value": [79.0]},
        "3459": {"vr": "DS", "Value": [151.0]},
        "3460": {"vr": "DS", "Value": [68.0]},
        "3461": {"vr": "DS", "Value": [143.0]},
        "3462": {"vr": "DS", "Value": [148.0]},
        "3463": {"vr": "DS", "Value": [92.0]},
        "3464": {"vr": "DS", "Value": [138.0]},
        "3465": {"vr": "DS", "Value": [144.0]},
        "3466": {"vr": "DS", "Value": [142.0]},
        "3467": {"vr": "DS", "Value": [61.0]},
        "3468": {"vr": "DS", "Value": [127.0]},
        "3469": {"vr": "DS", "Value": [147.0]},
        "3470": {"vr": "DS", "Value": [141.0]},
        "3471": {"vr": "DS", "Value": [144.0]},
        "3472": {"vr": "DS", "Value": [132.0]},
        "3473": {"vr": "DS", "Value": [126.0]},
        "3474": {"vr": "DS", "Value": [623.0]},
        "3475": {"vr": "DS", "Value": [126.0]},
        "3476": {"vr": "DS", "Value": [122.0]},
        "3477": {"vr": "DS", "Value": [66.0]},
        "3478": {"vr": "DS", "Value": [65.0]},
        "3479": {"vr": "DS", "Value": [133.0]},
        "3480": {"vr": "DS", "Value": [141.0]},
        "3481": {"vr": "DS", "Value": [701.0]},
        "3482": {"vr": "DS", "Value": [103.0]},
        "3483": {"vr": "DS", "Value": [141.0]},
        "3484": {"vr": "DS", "Value": [116.0]},
        "3485": {"vr": "DS", "Value": [141.0]},
        "3486": {"vr": "DS", "Value": [115.0]},
        "3487": {"vr": "DS", "Value": [111.0]},
        "3488": {"vr": "DS", "Value": [155.0]},
        "3489": {"vr": "DS", "Value": [132.0]},
        "3490": {"vr": "DS", "Value": [91.0]},
        "3491": {"vr": "DS", "Value": [141.0]},
        "3492": {"vr": "DS", "Value": [634.0]},
        "3493": {"vr": "DS", "Value": [103.0]},
        "3494": {"vr": "DS", "Value": [71.0]},
        "3495": {"vr": "DS", "Value": [137.0]},
        "3496": {"vr": "DS", "Value": [124.0]},
        "3497": {"vr": "DS", "Value": [150.0]},
        "3498": {"vr": "DS", "Value": [635.0]},
        "3499": {"vr": "DS", "Value": [148.0]},
        "3500": {"vr": "DS", "Value": [94.0]},
        "3501": {"vr": "DS", "Value": [763.0]},
        "3502": {"vr": "DS", "Value": [116.0]},
        "3503": {"vr": "DS", "Value": [663.0]},
        "3504": {"vr": "DS", "Value": [125.0]},
        "3505": {"vr": "DS", "Value": [146.0]},
        "3506": {"vr": "DS", "Value": [92.0]},
        "3507": {"vr": "DS", "Value": [134.0]},
        "3508": {"vr": "DS", "Value": [135.0]},
        "3509": {"vr": "DS", "Value": [145.0]},
        "3510": {"vr": "DS", "Value": [149.0]},
        "3511": {"vr": "DS", "Value": [692.0]},
        "3512": {"vr": "DS", "Value": [130.0]},
        "3513": {"vr": "DS", "Value": [125.0]},
        "3514": {"vr": "DS", "Value": [78.0]},
        "3515": {"vr": "DS", "Value": [61.0]},
        "3516": {"vr": "DS", "Value": [84.0]},
        "3517": {"vr": "DS", "Value": [142.0]},
        "3518": {"vr": "DS", "Value": [127.0]},
        "3519": {"vr": "DS", "Value": [139.0]},
        "3520": {"vr": "DS", "Value": [104.0]},
        "3521": {"vr": "DS", "Value": [716.0]},
        "3522": {"vr": "DS", "Value": [545.0]},
        "3523": {"vr": "DS", "Value": [139.0]},
        "3524": {"vr": "DS", "Value": [124.0]},
        "3525": {"vr": "DS", "Value": [142.0]},
        "3526": {"vr": "DS", "Value": [102.0]},
        "3527": {"vr": "DS", "Value": [135.0]},
        "3528": {"vr": "DS", "Value": [115.0]},
        "3529": {"vr": "DS", "Value": [674.0]},
        "3530": {"vr": "DS", "Value": [112.0]},
        "3531": {"vr": "DS", "Value": [140.0]},
        "3532": {"vr": "DS", "Value": [607.0]},
        "3533": {"vr": "DS", "Value": [148.0]},
        "3534": {"vr": "DS", "Value": [127.0]},
        "3535": {"vr": "DS", "Value": [68.0]},
        "3536": {"vr": "DS", "Value": [116.0]},
        "3537": {"vr": "DS", "Value": [116.0]},
        "3538": {"vr": "DS", "Value": [154.0]},
        "3539": {"vr": "DS", "Value": [669.0]},
        "3540": {"vr": "DS", "Value": [114.0]},
        "3541": {"vr": "DS", "Value": [109.0]},
        "3542": {"vr": "DS", "Value": [112.0]},
        "3543": {"vr": "DS", "Value": [122.0]},
        "3544": {"vr": "DS", "Value": [135.0]},
        "3545": {"vr": "DS", "Value": [106.0]},
        "3546": {"vr": "DS", "Value": [137.0]},
        "3547": {"vr": "DS", "Value": [155.0]},
        "3548": {"vr": "DS", "Value": [100.0]},
        "3549": {"vr": "DS", "Value": [110.0]},
        "3550": {"vr": "DS", "Value": [110.0]},
        "3551": {"vr": "DS", "Value": [144.0]},
        "3552": {"vr": "DS", "Value": [162.0]},
        "3553": {"vr": "DS", "Value": [97.0]},
        "3554": {"vr": "DS", "Value": [142.0]},
        "3555": {"vr": "DS", "Value": [137.0]},
        "3556": {"vr": "DS", "Value": [89.0]},
        "3557": {"vr": "DS", "Value": [114.0]},
        "3558": {"vr": "DS", "Value": [136.0]},
        "3559": {"vr": "DS", "Value": [98.0]},
        "3560": {"vr": "DS", "Value": [109.0]},
        "3561": {"vr": "DS", "Value": [147.0]},
        "3562": {"vr": "DS", "Value": [104.0]},
        "3563": {"vr": "DS", "Value": [87.0]},
        "3564": {"vr": "DS", "Value": [61.0]},
        "3565": {"vr": "DS", "Value": [74.0]},
        "3566": {"vr": "DS", "Value": [144.0]},
        "3567": {"vr": "DS", "Value": [124.0]},
        "3568": {"vr": "DS", "Value": [132.0]},
        "3569": {"vr": "DS", "Value": [112.0]},
        "3570": {"vr": "DS", "Value": [138.0]},
        "3571": {"vr": "DS", "Value": [65.0]},
        "3572": {"vr": "DS", "Value": [103.0]},
        "3573": {"vr": "DS", "Value": [137.0]},
        "3574": {"vr": "DS", "Value": [146.0]},
        "3575": {"vr": "DS", "Value": [657.0]},
        "3576": {"vr": "DS", "Value": [153.0]},
        "3577": {"vr": "DS", "Value": [149.0]},
        "3578": {"vr": "DS", "Value": [91.0]},
        "3579": {"vr": "DS", "Value": [149.0]},
        "3580": {"vr": "DS", "Value": [135.0]},
        "3581": {"vr": "DS", "Value": [136.0]},
        "3582": {"vr": "DS", "Value": [142.0]},
        "3583": {"vr": "DS", "Value": [142.0]},
        "3584": {"vr": "DS", "Value": [138.0]},
        "3585": {"vr": "DS", "Value": [59.0]},
        "3586": {"vr": "DS", "Value": [149.0]},
        "3587": {"vr": "DS", "Value": [122.0]},
        "3588": {"vr": "DS", "Value": [144.0]},
        "3589": {"vr": "DS", "Value": [692.0]},
        "3590": {"vr": "DS", "Value": [145.0]},
        "3591": {"vr": "DS", "Value": [156.0]},
        "3592": {"vr": "DS", "Value": [139.0]},
        "3593": {"vr": "DS", "Value": [157.0]},
        "3594": {"vr": "DS", "Value": [133.0]},
        "3595": {"vr": "DS", "Value": [112.0]},
        "3596": {"vr": "DS", "Value": [697.0]},
        "3597": {"vr": "DS", "Value": [122.0]},
        "3598": {"vr": "DS", "Value": [632.0]},
        "3599": {"vr": "DS", "Value": [128.0]},
        "3600": {"vr": "DS", "Value": [114.0]},
        "3601": {"vr": "DS", "Value": [59.0]},
        "3602": {"vr": "DS", "Value": [67.0]},
        "3603": {"vr": "DS", "Value": [72.0]},
        "3604": {"vr": "DS", "Value": [153.0]},
        "3605": {"vr": "DS", "Value": [150.0]},
        "3606": {"vr": "DS", "Value": [101.0]},
        "3607": {"vr": "DS", "Value": [101.0]},
        "3608": {"vr": "DS", "Value": [59.0]},
        "3609": {"vr": "DS", "Value": [68.0]},
        "3610": {"vr": "DS", "Value": [647.0]},
        "3611": {"vr": "DS", "Value": [135.0]},
        "3612": {"vr": "DS", "Value": [151.0]},
        "3613": {"vr": "DS", "Value": [137.0]},
        "3614": {"vr": "DS", "Value": [572.0]},
        "3615": {"vr": "DS", "Value": [145.0]},
        "3616": {"vr": "DS", "Value": [135.0]},
        "3617": {"vr": "DS", "Value": [140.0]},
        "3618": {"vr": "DS", "Value": [134.0]},
        "3619": {"vr": "DS", "Value": [135.0]},
        "3620": {"vr": "DS", "Value": [134.0]},
        "3621": {"vr": "DS", "Value": [147.0]},
        "3622": {"vr": "DS", "Value": [132.0]},
        "3623": {"vr": "DS", "Value": [142.0]},
        "3624": {"vr": "DS", "Value": [94.0]},
        "3625": {"vr": "DS", "Value": [152.0]},
        "3626": {"vr": "DS", "Value": [99.0]},
        "3627": {"vr": "DS", "Value": [139.0]},
        "3628": {"vr": "DS", "Value": [721.0]},
        "3629": {"vr": "DS", "Value": [135.0]},
        "3630": {"vr": "DS", "Value": [149.0]},
        "3631": {"vr": "DS", "Value": [63.0]},
        "3632": {"vr": "DS", "Value": [139.0]},
        "3633": {"vr": "DS", "Value": [151.0]},
        "3634": {"vr": "DS", "Value": [131.0]},
        "3635": {"vr": "DS", "Value": [129.0]},
        "3636": {"vr": "DS", "Value": [154.0]},
        "3637": {"vr": "DS", "Value": [112.0]},
        "3638": {"vr": "DS", "Value": [664.0]},
        "3639": {"vr": "DS", "Value": [136.0]},
        "3640": {"vr": "DS", "Value": [664.0]},
        "3641": {"vr": "DS", "Value": [132.0]},
        "3642": {"vr": "DS", "Value": [69.0]},
        "3643": {"vr": "DS", "Value": [92.0]},
        "3644": {"vr": "DS", "Value": [141.0]},
        "3645": {"vr": "DS", "Value": [132.0]},
        "3646": {"vr": "DS", "Value": [97.0]},
        "3647": {"vr": "DS", "Value": [64.0]},
        "3648": {"vr": "DS", "Value": [115.0]},
        "3649": {"vr": "DS", "Value": [118.0]},
        "3650": {"vr": "DS", "Value": [151.0]},
        "3651": {"vr": "DS", "Value": [68.0]},
        "3652": {"vr": "DS", "Value": [112.0]},
        "3653": {"vr": "DS", "Value": [654.0]},
        "3654": {"vr": "DS", "Value": [702.0]},
        "3655": {"vr": "DS", "Value": [131.0]},
        "3656": {"vr": "DS", "Value": [143.0]},
        "3657": {"vr": "DS", "Value": [58.0]},
        "3658": {"vr": "DS", "Value": [59.0]},
        "3659": {"vr": "DS", "Value": [129.0]},
        "3660": {"vr": "DS", "Value": [95.0]},
        "3661": {"vr": "DS", "Value": [99.0]},
        "3662": {"vr": "DS", "Value": [142.0]},
        "3663": {"vr": "DS", "Value": [132.0]},
        "3664": {"vr": "DS", "Value": [136.0]},
        "3665": {"vr": "DS", "Value": [67.0]},
        "3666": {"vr": "DS", "Value": [93.0]},
        "3667": {"vr": "DS", "Value": [152.0]},
        "3668": {"vr": "DS", "Value": [541.0]},
        "3669": {"vr": "DS", "Value": [120.0]},
        "3670": {"vr": "DS", "Value": [20.0]},
        "3671": {"vr": "DS", "Value": [149.0]},
        "3672": {"vr": "DS", "Value": [122.0]},
        "3673": {"vr": "DS", "Value": [653.0]},
        "3674": {"vr": "DS", "Value": [144.0]},
        "3675": {"vr": "DS", "Value": [111.0]},
        "3676": {"vr": "DS", "Value": [151.0]},
        "3677": {"vr": "DS", "Value": [149.0]},
        "3678": {"vr": "DS", "Value": [153.0]},
        "3679": {"vr": "DS", "Value": [148.0]},
        "3680": {"vr": "DS", "Value": [132.0]},
        "3681": {"vr": "DS", "Value": [124.0]},
        "3682": {"vr": "DS", "Value": [72.0]},
        "3683": {"vr": "DS", "Value": [126.0]},
        "3684": {"vr": "DS", "Value": [142.0]},
        "3685": {"vr": "DS", "Value": [135.0]},
        "3686": {"vr": "DS", "Value": [147.0]},
        "3687": {"vr": "DS", "Value": [681.0]},
        "3688": {"vr": "DS", "Value": [50.0]},
        "3689": {"vr": "DS", "Value": [143.0]},
        "3690": {"vr": "DS", "Value": [145.0]},
        "3691": {"vr": "DS", "Value": [129.0]},
        "3692": {"vr": "DS", "Value": [149.0]},
        "3693": {"vr": "DS", "Value": [140.0]},
        "3694": {"vr": "DS", "Value": [130.0]},
        "3695": {"vr": "DS", "Value": [134.0]},
        "3696": {"vr": "DS", "Value": [692.0]},
        "3697": {"vr": "DS", "Value": [107.0]},
        "3698": {"vr": "DS", "Value": [650.0]},
        "3699": {"vr": "DS", "Value": [142.0]},
        "3700": {"vr": "DS", "Value": [62.0]},
        "3701": {"vr": "DS", "Value": [148.0]},
        "3702": {"vr": "DS", "Value": [130.0]},
        "3703": {"vr": "DS", "Value": [141.0]},
        "3704": {"vr": "DS", "Value": [83.0]},
        "3705": {"vr": "DS", "Value": [139.0]},
        "3706": {"vr": "DS", "Value": [155.0]},
        "3707": {"vr": "DS", "Value": [139.0]},
        "3708": {"vr": "DS", "Value": [140.0]},
        "3709": {"vr": "DS", "Value": [133.0]},
        "3710": {"vr": "DS", "Value": [125.0]},
        "3711": {"vr": "DS", "Value": [133.0]},
        "3712": {"vr": "DS", "Value": [152.0]},
        "3713": {"vr": "DS", "Value": [56.0]},
        "3714": {"vr": "DS", "Value": [149.0]},
        "3715": {"vr": "DS", "Value": [121.0]},
        "3716": {"vr": "DS", "Value": [399.0]},
        "3717": {"vr": "DS", "Value": [66.0]},
        "3718": {"vr": "DS", "Value": [153.0]},
        "3719": {"vr": "DS", "Value": [129.0]},
        "3720": {"vr": "DS", "Value": [86.0]},
        "3721": {"vr": "DS", "Value": [23.0]},
        "3722": {"vr": "DS", "Value": [145.0]},
        "3723": {"vr": "DS", "Value": [409.0]},
        "3724": {"vr": "DS", "Value": [132.0]},
        "3725": {"vr": "DS", "Value": [133.0]},
        "3726": {"vr": "DS", "Value": [76.0]},
        "3727": {"vr": "DS", "Value": [132.0]},
        "3728": {"vr": "DS", "Value": [142.0]},
        "3729": {"vr": "DS", "Value": [646.0]},
        "3730": {"vr": "DS", "Value": [142.0]},
        "3731": {"vr": "DS", "Value": [113.0]},
        "3732": {"vr": "DS", "Value": [124.0]},
        "3733": {"vr": "DS", "Value": [140.0]},
        "3734": {"vr": "DS", "Value": [120.0]},
        "3735": {"vr": "DS", "Value": [217.0]},
        "3736": {"vr": "DS", "Value": [134.0]},
        "3737": {"vr": "DS", "Value": [145.0]},
        "3738": {"vr": "DS", "Value": [132.0]},
        "3739": {"vr": "DS", "Value": [135.0]},
        "3740": {"vr": "DS", "Value": [94.0]},
        "3741": {"vr": "DS", "Value": [119.0]},
        "3742": {"vr": "DS", "Value": [721.0]},
        "3743": {"vr": "DS", "Value": [137.0]},
        "3744": {"vr": "DS", "Value": [669.0]},
        "3745": {"vr": "DS", "Value": [88.0]},
        "3746": {"vr": "DS", "Value": [141.0]},
        "3747": {"vr": "DS", "Value": [146.0]},
        "3748": {"vr": "DS", "Value": [18.0]},
        "3749": {"vr": "DS", "Value": [77.0]},
        "3750": {"vr": "DS", "Value": [144.0]},
        "3751": {"vr": "DS", "Value": [138.0]},
        "3752": {"vr": "DS", "Value": [149.0]},
        "3753": {"vr": "DS", "Value": [141.0]},
        "3754": {"vr": "DS", "Value": [141.0]},
        "3755": {"vr": "DS", "Value": [152.0]},
        "3756": {"vr": "DS", "Value": [646.0]},
        "3757": {"vr": "DS", "Value": [55.0]},
        "3758": {"vr": "DS", "Value": [83.0]},
        "3759": {"vr": "DS", "Value": [129.0]},
        "3760": {"vr": "DS", "Value": [141.0]},
        "3761": {"vr": "DS", "Value": [127.0]},
        "3762": {"vr": "DS", "Value": [72.0]},
        "3763": {"vr": "DS", "Value": [659.0]},
        "3764": {"vr": "DS", "Value": [137.0]},
        "3765": {"vr": "DS", "Value": [147.0]},
        "3766": {"vr": "DS", "Value": [111.0]},
        "3767": {"vr": "DS", "Value": [117.0]},
        "3768": {"vr": "DS", "Value": [107.0]},
        "3769": {"vr": "DS", "Value": [98.0]},
        "3770": {"vr": "DS", "Value": [118.0]},
        "3771": {"vr": "DS", "Value": [141.0]},
        "3772": {"vr": "DS", "Value": [148.0]},
        "3773": {"vr": "DS", "Value": [125.0]},
        "3774": {"vr": "DS", "Value": [138.0]},
        "3775": {"vr": "DS", "Value": [145.0]},
        "3776": {"vr": "DS", "Value": [110.0]},
        "3777": {"vr": "DS", "Value": [66.0]},
        "3778": {"vr": "DS", "Value": [143.0]},
        "3779": {"vr": "DS", "Value": [135.0]},
        "3780": {"vr": "DS", "Value": [104.0]},
        "3781": {"vr": "DS", "Value": [134.0]},
        "3782": {"vr": "DS", "Value": [70.0]},
        "3783": {"vr": "DS", "Value": [134.0]},
        "3784": {"vr": "DS", "Value": [129.0]},
        "3785": {"vr": "DS", "Value": [57.0]},
        "3786": {"vr": "DS", "Value": [90.0]},
        "3787": {"vr": "DS", "Value": [126.0]},
        "3788": {"vr": "DS", "Value": [157.0]},
        "3789": {"vr": "DS", "Value": [72.0]},
        "3790": {"vr": "DS", "Value": [157.0]},
        "3791": {"vr": "DS", "Value": [133.0]},
        "3792": {"vr": "DS", "Value": [102.0]},
        "3793": {"vr": "DS", "Value": [155.0]},
        "3794": {"vr": "DS", "Value": [62.0]},
        "3795": {"vr": "DS", "Value": [161.0]},
        "3796": {"vr": "DS", "Value": [162.0]},
        "3797": {"vr": "DS", "Value": [120.0]},
        "3798": {"vr": "DS", "Value": [139.0]},
        "3799": {"vr": "DS", "Value": [155.0]},
        "3800": {"vr": "DS", "Value": [137.0]},
        "3801": {"vr": "DS", "Value": [137.0]},
        "3802": {"vr": "DS", "Value": [148.0]},
        "3803": {"vr": "DS", "Value": [135.0]},
        "3804": {"vr": "DS", "Value": [139.0]},
        "3805": {"vr": "DS", "Value": [166.0]},
        "3806": {"vr": "DS", "Value": [218.0]},
        "3807": {"vr": "DS", "Value": [58.0]},
        "3808": {"vr": "DS", "Value": [137.0]},
        "3809": {"vr": "DS", "Value": [105.0]},
        "3810": {"vr": "DS", "Value": [139.0]},
        "3811": {"vr": "DS", "Value": [141.0]},
        "3812": {"vr": "DS", "Value": [141.0]},
        "3813": {"vr": "DS", "Value": [144.0]},
        "3814": {"vr": "DS", "Value": [76.0]},
        "3815": {"vr": "DS", "Value": [147.0]},
        "3816": {"vr": "DS", "Value": [151.0]},
        "3817": {"vr": "DS", "Value": [126.0]},
        "3818": {"vr": "DS", "Value": [134.0]},
        "3819": {"vr": "DS", "Value": [122.0]},
        "3820": {"vr": "DS", "Value": [128.0]},
        "3821": {"vr": "DS", "Value": [23.0]},
        "3822": {"vr": "DS", "Value": [118.0]},
        "3823": {"vr": "DS", "Value": [151.0]},
        "3824": {"vr": "DS", "Value": [140.0]},
        "3825": {"vr": "DS", "Value": [611.0]},
        "3826": {"vr": "DS", "Value": [133.0]},
        "3827": {"vr": "DS", "Value": [106.0]},
        "3828": {"vr": "DS", "Value": [142.0]},
        "3829": {"vr": "DS", "Value": [154.0]},
        "3830": {"vr": "DS", "Value": [137.0]},
        "3831": {"vr": "DS", "Value": [133.0]},
        "3832": {"vr": "DS", "Value": [660.0]},
        "3833": {"vr": "DS", "Value": [145.0]},
        "3834": {"vr": "DS", "Value": [157.0]},
        "3835": {"vr": "DS", "Value": [141.0]},
        "3836": {"vr": "DS", "Value": [67.0]},
        "3837": {"vr": "DS", "Value": [148.0]},
        "3838": {"vr": "DS", "Value": [118.0]},
        "3839": {"vr": "DS", "Value": [134.0]},
        "3840": {"vr": "DS", "Value": [141.0]},
        "3841": {"vr": "DS", "Value": [127.0]},
        "3842": {"vr": "DS", "Value": [100.0]},
        "3843": {"vr": "DS", "Value": [126.0]},
        "3844": {"vr": "DS", "Value": [119.0]},
        "3845": {"vr": "DS", "Value": [664.0]},
        "3846": {"vr": "DS", "Value": [133.0]},
        "3847": {"vr": "DS", "Value": [75.0]},
        "3848": {"vr": "DS", "Value": [153.0]},
        "3849": {"vr": "DS", "Value": [153.0]},
        "3850": {"vr": "DS", "Value": [58.0]},
        "3851": {"vr": "DS", "Value": [101.0]},
        "3852": {"vr": "DS", "Value": [65.0]},
        "3853": {"vr": "DS", "Value": [86.0]},
        "3854": {"vr": "DS", "Value": [57.0]},
        "3855": {"vr": "DS", "Value": [686.0]},
        "3856": {"vr": "DS", "Value": [133.0]},
        "3857": {"vr": "DS", "Value": [115.0]},
        "3858": {"vr": "DS", "Value": [66.0]},
        "3859": {"vr": "DS", "Value": [135.0]},
        "3860": {"vr": "DS", "Value": [145.0]},
        "3861": {"vr": "DS", "Value": [148.0]},
        "3862": {"vr": "DS", "Value": [66.0]},
        "3863": {"vr": "DS", "Value": [608.0]},
        "3864": {"vr": "DS", "Value": [132.0]},
        "3865": {"vr": "DS", "Value": [147.0]},
        "3866": {"vr": "DS", "Value": [122.0]},
        "3867": {"vr": "DS", "Value": [137.0]},
        "3868": {"vr": "DS", "Value": [160.0]},
        "3869": {"vr": "DS", "Value": [128.0]},
        "3870": {"vr": "DS", "Value": [116.0]},
        "3871": {"vr": "DS", "Value": [136.0]},
        "3872": {"vr": "DS", "Value": [134.0]},
        "3873": {"vr": "DS", "Value": [125.0]},
        "3874": {"vr": "DS", "Value": [61.0]},
        "3875": {"vr": "DS", "Value": [147.0]},
        "3876": {"vr": "DS", "Value": [147.0]},
        "3877": {"vr": "DS", "Value": [63.0]},
        "3878": {"vr": "DS", "Value": [703.0]},
        "3879": {"vr": "DS", "Value": [145.0]},
        "3880": {"vr": "DS", "Value": [96.0]},
        "3881": {"vr": "DS", "Value": [82.0]},
        "3882": {"vr": "DS", "Value": [156.0]},
        "3883": {"vr": "DS", "Value": [135.0]},
        "3884": {"vr": "DS", "Value": [118.0]},
        "3885": {"vr": "DS", "Value": [714.0]},
        "3886": {"vr": "DS", "Value": [93.0]},
        "3887": {"vr": "DS", "Value": [141.0]},
        "3888": {"vr": "DS", "Value": [157.0]},
        "3889": {"vr": "DS", "Value": [117.0]},
        "3890": {"vr": "DS", "Value": [59.0]},
        "3891": {"vr": "DS", "Value": [119.0]},
        "3892": {"vr": "DS", "Value": [116.0]},
        "3893": {"vr": "DS", "Value": [59.0]},
        "3894": {"vr": "DS", "Value": [124.0]},
        "3895": {"vr": "DS", "Value": [130.0]},
        "3896": {"vr": "DS", "Value": [142.0]},
        "3897": {"vr": "DS", "Value": [114.0]},
        "3898": {"vr": "DS", "Value": [104.0]},
        "3899": {"vr": "DS", "Value": [141.0]},
        "3900": {"vr": "DS", "Value": [615.0]},
        "3901": {"vr": "DS", "Value": [90.0]},
        "3902": {"vr": "DS", "Value": [94.0]},
        "3903": {"vr": "DS", "Value": [119.0]},
        "3904": {"vr": "DS", "Value": [147.0]},
        "3905": {"vr": "DS", "Value": [148.0]},
        "3906": {"vr": "DS", "Value": [135.0]},
        "3907": {"vr": "DS", "Value": [131.0]},
        "3908": {"vr": "DS", "Value": [150.0]},
        "3909": {"vr": "DS", "Value": [140.0]},
        "3910": {"vr": "DS", "Value": [141.0]},
        "3911": {"vr": "DS", "Value": [67.0]},
        "3912": {"vr": "DS", "Value": [100.0]},
        "3913": {"vr": "DS", "Value": [146.0]},
        "3914": {"vr": "DS", "Value": [155.0]},
        "3915": {"vr": "DS", "Value": [139.0]},
        "3916": {"vr": "DS", "Value": [722.0]},
        "3917": {"vr": "DS", "Value": [120.0]},
        "3918": {"vr": "DS", "Value": [133.0]},
        "3919": {"vr": "DS", "Value": [126.0]},
        "3920": {"vr": "DS", "Value": [137.0]},
        "3921": {"vr": "DS", "Value": [140.0]},
        "3922": {"vr": "DS", "Value": [109.0]},
        "3923": {"vr": "DS", "Value": [64.0]},
        "3924": {"vr": "DS", "Value": [140.0]},
        "3925": {"vr": "DS", "Value": [120.0]},
        "3926": {"vr": "DS", "Value": [65.0]},
        "3927": {"vr": "DS", "Value": [153.0]},
        "3928": {"vr": "DS", "Value": [667.0]},
        "3929": {"vr": "DS", "Value": [146.0]},
        "3930": {"vr": "DS", "Value": [119.0]},
        "3931": {"vr": "DS", "Value": [134.0]},
        "3932": {"vr": "DS", "Value": [141.0]},
        "3933": {"vr": "DS", "Value": [140.0]},
        "3934": {"vr": "DS", "Value": [136.0]},
        "3935": {"vr": "DS", "Value": [140.0]},
        "3936": {"vr": "DS", "Value": [138.0]},
        "3937": {"vr": "DS", "Value": [711.0]},
        "3938": {"vr": "DS", "Value": [136.0]},
        "3939": {"vr": "DS", "Value": [143.0]},
        "3940": {"vr": "DS", "Value": [146.0]},
        "3941": {"vr": "DS", "Value": [139.0]},
        "3942": {"vr": "DS", "Value": [145.0]},
        "3943": {"vr": "DS", "Value": [64.0]},
        "3944": {"vr": "DS", "Value": [60.0]},
        "3945": {"vr": "DS", "Value": [751.0]},
        "3946": {"vr": "DS", "Value": [104.0]},
        "3947": {"vr": "DS", "Value": [129.0]},
        "3948": {"vr": "DS", "Value": [133.0]},
        "3949": {"vr": "DS", "Value": [140.0]},
        "3950": {"vr": "DS", "Value": [138.0]},
        "3951": {"vr": "DS", "Value": [144.0]},
        "3952": {"vr": "DS", "Value": [114.0]},
        "3953": {"vr": "DS", "Value": [155.0]},
        "3954": {"vr": "DS", "Value": [126.0]},
        "3955": {"vr": "DS", "Value": [143.0]},
        "3956": {"vr": "DS", "Value": [112.0]},
        "3957": {"vr": "DS", "Value": [132.0]},
        "3958": {"vr": "DS", "Value": [144.0]},
        "3959": {"vr": "DS", "Value": [59.0]},
        "3960": {"vr": "DS", "Value": [97.0]},
        "3961": {"vr": "DS", "Value": [69.0]},
        "3962": {"vr": "DS", "Value": [134.0]},
        "3963": {"vr": "DS", "Value": [128.0]},
        "3964": {"vr": "DS", "Value": [141.0]},
        "3965": {"vr": "DS", "Value": [130.0]},
        "3966": {"vr": "DS", "Value": [61.0]},
        "3967": {"vr": "DS", "Value": [113.0]},
        "3968": {"vr": "DS", "Value": [596.0]},
        "3969": {"vr": "DS", "Value": [56.0]},
        "3970": {"vr": "DS", "Value": [148.0]},
        "3971": {"vr": "DS", "Value": [74.0]},
        "3972": {"vr": "DS", "Value": [117.0]},
        "3973": {"vr": "DS", "Value": [72.0]},
        "3974": {"vr": "DS", "Value": [118.0]},
        "3975": {"vr": "DS", "Value": [140.0]},
        "3976": {"vr": "DS", "Value": [154.0]},
        "3977": {"vr": "DS", "Value": [75.0]},
        "3978": {"vr": "DS", "Value": [93.0]},
        "3979": {"vr": "DS", "Value": [128.0]},
        "3980": {"vr": "DS", "Value": [19.0]},
        "3981": {"vr": "DS", "Value": [100.0]},
        "3982": {"vr": "DS", "Value": [152.0]},
        "3983": {"vr": "DS", "Value": [135.0]},
        "3984": {"vr": "DS", "Value": [135.0]},
        "3985": {"vr": "DS", "Value": [101.0]},
        "3986": {"vr": "DS", "Value": [151.0]},
        "3987": {"vr": "DS", "Value": [143.0]},
        "3988": {"vr": "DS", "Value": [131.0]},
        "3989": {"vr": "DS", "Value": [143.0]},
        "3990": {"vr": "DS", "Value": [143.0]},
        "3991": {"vr": "DS", "Value": [120.0]},
        "3992": {"vr": "DS", "Value": [142.0]},
        "3993": {"vr": "DS", "Value": [66.0]},
        "3994": {"vr": "DS", "Value": [140.0]},
        "3995": {"vr": "DS", "Value": [142.0]},
        "3996": {"vr": "DS", "Value": [135.0]},
        "3997": {"vr": "DS", "Value": [106.0]},
        "3998": {"vr": "DS", "Value": [132.0]},
        "3999": {"vr": "DS", "Value": [151.0]},
        "4000": {"vr": "DS", "Value": [116.0]},
        "4001": {"vr": "DS", "Value": [138.0]},
        "4002": {"vr": "DS", "Value": [132.0]},
        "4003": {"vr": "DS", "Value": [23.0]},
        "4004": {"vr": "DS", "Value": [144.0]},
        "4005": {"vr": "DS", "Value": [143.0]},
        "4006": {"vr": "DS", "Value": [98.0]},
        "4007": {"vr": "DS", "Value": [143.0]},
        "4008": {"vr": "DS", "Value": [130.0]},
        "4009": {"vr": "DS", "Value": [622.0]},
        "4010": {"vr": "DS", "Value": [60.0]},
        "4011": {"vr": "DS", "Value": [705.0]},
        "4012": {"vr": "DS", "Value": [112.0]},
        "4013": {"vr": "DS", "Value": [148.0]},
        "4014": {"vr": "DS", "Value": [116.0]},
        "4015": {"vr": "DS", "Value": [58.0]},
        "4016": {"vr": "DS", "Value": [147.0]},
        "4017": {"vr": "DS", "Value": [144.0]},
        "4018": {"vr": "DS", "Value": [137.0]},
        "4019": {"vr": "DS", "Value": [125.0]},
    },
    "0051100D": {
        "0": {"vr": "SH", "Value": ["SP H17.2"]},
        "1": {"vr": "SH", "Value": ["SP H62.2"]},
        "2": {"vr": "SH", "Value": ["SP F20.3"]},
        "3": {"vr": "SH", "Value": ["SP F47.8"]},
        "4": {"vr": "SH", "Value": ["SP F20.3"]},
        "5": {"vr": "SH", "Value": ["SP F5.3"]},
        "6": {"vr": "SH", "Value": ["SP F60.3"]},
        "7": {"vr": "SH", "Value": ["SP F30.3"]},
        "8": {"vr": "SH", "Value": ["SP F10.3"]},
        "9": {"vr": "SH", "Value": ["SP H37.2"]},
        "10": {"vr": "SH", "Value": ["SP H12.2"]},
        "11": {"vr": "SH", "Value": ["SP H44.7"]},
        "12": {"vr": "SH", "Value": ["SP H42.2"]},
        "13": {"vr": "SH", "Value": ["SP H49.7"]},
        "14": {"vr": "SH", "Value": ["SP F25.3"]},
        "15": {"vr": "SH", "Value": ["SP H57.2"]},
        "16": {"vr": "SH", "Value": ["SP F0.3"]},
        "17": {"vr": "SH", "Value": ["SP H4.7"]},
        "18": {"vr": "SH", "Value": ["SP F42.8"]},
        "19": {"vr": "SH", "Value": ["SP H29.7"]},
        "20": {"vr": "SH", "Value": ["SP F65.3"]},
        "21": {"vr": "SH", "Value": ["SP F57.8"]},
        "22": {"vr": "SH", "Value": ["SP H62.2"]},
        "23": {"vr": "SH", "Value": ["SP H22.2"]},
        "24": {"vr": "SH", "Value": ["SP F15.3"]},
        "25": {"vr": "SH", "Value": ["SP H29.7"]},
        "26": {"vr": "SH", "Value": ["SP F60.3"]},
        "27": {"vr": "SH", "Value": ["SP F52.8"]},
        "28": {"vr": "SH", "Value": ["SP F40.3"]},
        "29": {"vr": "SH", "Value": ["SP F35.3"]},
        "30": {"vr": "SH", "Value": ["SP H4.7"]},
        "31": {"vr": "SH", "Value": ["SP F22.8"]},
        "32": {"vr": "SH", "Value": ["SP H32.2"]},
        "33": {"vr": "SH", "Value": ["SP H19.7"]},
        "34": {"vr": "SH", "Value": ["SP H52.2"]},
        "35": {"vr": "SH", "Value": ["SP F65.3"]},
        "36": {"vr": "SH", "Value": ["SP H27.2"]},
        "37": {"vr": "SH", "Value": ["SP F65.3"]},
        "38": {"vr": "SH", "Value": ["SP H47.2"]},
        "39": {"vr": "SH", "Value": ["SP H4.7"]},
        "40": {"vr": "SH", "Value": ["SP H37.2"]},
        "41": {"vr": "SH", "Value": ["SP F32.8"]},
        "42": {"vr": "SH", "Value": ["SP F0.3"]},
        "43": {"vr": "SH", "Value": ["SP F37.8"]},
        "44": {"vr": "SH", "Value": ["SP F62.8"]},
        "45": {"vr": "SH", "Value": ["SP H62.2"]},
        "46": {"vr": "SH", "Value": ["SP H52.2"]},
        "47": {"vr": "SH", "Value": ["SP F0.3"]},
        "48": {"vr": "SH", "Value": ["SP H49.7"]},
        "49": {"vr": "SH", "Value": ["SP H62.2"]},
        "50": {"vr": "SH", "Value": ["SP H14.7"]},
        "51": {"vr": "SH", "Value": ["SP H4.7"]},
        "52": {"vr": "SH", "Value": ["SP H34.7"]},
        "53": {"vr": "SH", "Value": ["SP F72.8"]},
        "54": {"vr": "SH", "Value": ["SP H27.2"]},
        "55": {"vr": "SH", "Value": ["SP H19.7"]},
        "56": {"vr": "SH", "Value": ["SP H44.7"]},
        "57": {"vr": "SH", "Value": ["SP H14.7"]},
        "58": {"vr": "SH", "Value": ["SP F40.3"]},
        "59": {"vr": "SH", "Value": ["SP F65.3"]},
        "60": {"vr": "SH", "Value": ["SP H47.2"]},
        "61": {"vr": "SH", "Value": ["SP F0.3"]},
        "62": {"vr": "SH", "Value": ["SP H74.7"]},
        "63": {"vr": "SH", "Value": ["SP H47.2"]},
        "64": {"vr": "SH", "Value": ["SP H42.2"]},
        "65": {"vr": "SH", "Value": ["SP F55.3"]},
        "66": {"vr": "SH", "Value": ["SP F32.8"]},
        "67": {"vr": "SH", "Value": ["SP F12.8"]},
        "68": {"vr": "SH", "Value": ["SP H57.2"]},
        "69": {"vr": "SH", "Value": ["SP F12.8"]},
        "70": {"vr": "SH", "Value": ["SP F20.3"]},
        "71": {"vr": "SH", "Value": ["SP H62.2"]},
        "72": {"vr": "SH", "Value": ["SP H29.7"]},
        "73": {"vr": "SH", "Value": ["SP F52.8"]},
        "74": {"vr": "SH", "Value": ["SP H2.2"]},
        "75": {"vr": "SH", "Value": ["SP F72.8"]},
        "76": {"vr": "SH", "Value": ["SP F15.3"]},
        "77": {"vr": "SH", "Value": ["SP H54.7"]},
        "78": {"vr": "SH", "Value": ["SP F15.3"]},
        "79": {"vr": "SH", "Value": ["SP F10.3"]},
        "80": {"vr": "SH", "Value": ["SP F12.8"]},
        "81": {"vr": "SH", "Value": ["SP F12.8"]},
        "82": {"vr": "SH", "Value": ["SP H69.7"]},
        "83": {"vr": "SH", "Value": ["SP H27.2"]},
        "84": {"vr": "SH", "Value": ["SP H57.2"]},
        "85": {"vr": "SH", "Value": ["SP F2.8"]},
        "86": {"vr": "SH", "Value": ["SP H22.2"]},
        "87": {"vr": "SH", "Value": ["SP H64.7"]},
        "88": {"vr": "SH", "Value": ["SP F10.3"]},
        "89": {"vr": "SH", "Value": ["SP H42.2"]},
        "90": {"vr": "SH", "Value": ["SP F0.3"]},
        "91": {"vr": "SH", "Value": ["SP F32.8"]},
        "92": {"vr": "SH", "Value": ["SP F20.3"]},
        "93": {"vr": "SH", "Value": ["SP F50.3"]},
        "94": {"vr": "SH", "Value": ["SP F72.8"]},
        "95": {"vr": "SH", "Value": ["SP H12.2"]},
        "96": {"vr": "SH", "Value": ["SP H52.2"]},
        "97": {"vr": "SH", "Value": ["SP F32.8"]},
        "98": {"vr": "SH", "Value": ["SP H54.7"]},
        "99": {"vr": "SH", "Value": ["SP F72.8"]},
        "100": {"vr": "SH", "Value": ["SP H47.2"]},
        "101": {"vr": "SH", "Value": ["SP F27.8"]},
        "102": {"vr": "SH", "Value": ["SP F30.3"]},
        "103": {"vr": "SH", "Value": ["SP F60.3"]},
        "104": {"vr": "SH", "Value": ["SP H19.7"]},
        "105": {"vr": "SH", "Value": ["SP F20.3"]},
        "106": {"vr": "SH", "Value": ["SP F5.3"]},
        "107": {"vr": "SH", "Value": ["SP H14.7"]},
        "108": {"vr": "SH", "Value": ["SP H64.7"]},
        "109": {"vr": "SH", "Value": ["SP F37.8"]},
        "110": {"vr": "SH", "Value": ["SP H17.2"]},
        "111": {"vr": "SH", "Value": ["SP F17.8"]},
        "112": {"vr": "SH", "Value": ["SP F45.3"]},
        "113": {"vr": "SH", "Value": ["SP H14.7"]},
        "114": {"vr": "SH", "Value": ["SP F17.8"]},
        "115": {"vr": "SH", "Value": ["SP H4.7"]},
        "116": {"vr": "SH", "Value": ["SP H7.2"]},
        "117": {"vr": "SH", "Value": ["SP H74.7"]},
        "118": {"vr": "SH", "Value": ["SP H54.7"]},
        "119": {"vr": "SH", "Value": ["SP H57.2"]},
        "120": {"vr": "SH", "Value": ["SP H62.2"]},
        "121": {"vr": "SH", "Value": ["SP H42.2"]},
        "122": {"vr": "SH", "Value": ["SP H37.2"]},
        "123": {"vr": "SH", "Value": ["SP H4.7"]},
        "124": {"vr": "SH", "Value": ["SP F7.8"]},
        "125": {"vr": "SH", "Value": ["SP F35.3"]},
        "126": {"vr": "SH", "Value": ["SP H47.2"]},
        "127": {"vr": "SH", "Value": ["SP F27.8"]},
        "128": {"vr": "SH", "Value": ["SP F45.3"]},
        "129": {"vr": "SH", "Value": ["SP F7.8"]},
        "130": {"vr": "SH", "Value": ["SP H74.7"]},
        "131": {"vr": "SH", "Value": ["SP F5.3"]},
        "132": {"vr": "SH", "Value": ["SP F35.3"]},
        "133": {"vr": "SH", "Value": ["SP H34.7"]},
        "134": {"vr": "SH", "Value": ["SP H14.7"]},
        "135": {"vr": "SH", "Value": ["SP H17.2"]},
        "136": {"vr": "SH", "Value": ["SP H19.7"]},
        "137": {"vr": "SH", "Value": ["SP F20.3"]},
        "138": {"vr": "SH", "Value": ["SP H17.2"]},
        "139": {"vr": "SH", "Value": ["SP H12.2"]},
        "140": {"vr": "SH", "Value": ["SP F70.3"]},
        "141": {"vr": "SH", "Value": ["SP H12.2"]},
        "142": {"vr": "SH", "Value": ["SP H59.7"]},
        "143": {"vr": "SH", "Value": ["SP H62.2"]},
        "144": {"vr": "SH", "Value": ["SP F25.3"]},
        "145": {"vr": "SH", "Value": ["SP F17.8"]},
        "146": {"vr": "SH", "Value": ["SP H19.7"]},
        "147": {"vr": "SH", "Value": ["SP F62.8"]},
        "148": {"vr": "SH", "Value": ["SP F50.3"]},
        "149": {"vr": "SH", "Value": ["SP F2.8"]},
        "150": {"vr": "SH", "Value": ["SP H27.2"]},
        "151": {"vr": "SH", "Value": ["SP H42.2"]},
        "152": {"vr": "SH", "Value": ["SP H57.2"]},
        "153": {"vr": "SH", "Value": ["SP F47.8"]},
        "154": {"vr": "SH", "Value": ["SP F35.3"]},
        "155": {"vr": "SH", "Value": ["SP F22.8"]},
        "156": {"vr": "SH", "Value": ["SP H14.7"]},
        "157": {"vr": "SH", "Value": ["SP F57.8"]},
        "158": {"vr": "SH", "Value": ["SP H59.7"]},
        "159": {"vr": "SH", "Value": ["SP H2.2"]},
        "160": {"vr": "SH", "Value": ["SP H17.2"]},
        "161": {"vr": "SH", "Value": ["SP H59.7"]},
        "162": {"vr": "SH", "Value": ["SP H72.2"]},
        "163": {"vr": "SH", "Value": ["SP F47.8"]},
        "164": {"vr": "SH", "Value": ["SP H42.2"]},
        "165": {"vr": "SH", "Value": ["SP F45.3"]},
        "166": {"vr": "SH", "Value": ["SP H52.2"]},
        "167": {"vr": "SH", "Value": ["SP H39.7"]},
        "168": {"vr": "SH", "Value": ["SP H12.2"]},
        "169": {"vr": "SH", "Value": ["SP H59.7"]},
        "170": {"vr": "SH", "Value": ["SP H29.7"]},
        "171": {"vr": "SH", "Value": ["SP F72.8"]},
        "172": {"vr": "SH", "Value": ["SP F40.3"]},
        "173": {"vr": "SH", "Value": ["SP F22.8"]},
        "174": {"vr": "SH", "Value": ["SP H29.7"]},
        "175": {"vr": "SH", "Value": ["SP H2.2"]},
        "176": {"vr": "SH", "Value": ["SP H9.7"]},
        "177": {"vr": "SH", "Value": ["SP F70.3"]},
        "178": {"vr": "SH", "Value": ["SP F42.8"]},
        "179": {"vr": "SH", "Value": ["SP H19.7"]},
        "180": {"vr": "SH", "Value": ["SP H14.7"]},
        "181": {"vr": "SH", "Value": ["SP H72.2"]},
        "182": {"vr": "SH", "Value": ["SP H24.7"]},
        "183": {"vr": "SH", "Value": ["SP H37.2"]},
        "184": {"vr": "SH", "Value": ["SP F45.3"]},
        "185": {"vr": "SH", "Value": ["SP F57.8"]},
        "186": {"vr": "SH", "Value": ["SP F30.3"]},
        "187": {"vr": "SH", "Value": ["SP H19.7"]},
        "188": {"vr": "SH", "Value": ["SP H54.7"]},
        "189": {"vr": "SH", "Value": ["SP H74.7"]},
        "190": {"vr": "SH", "Value": ["SP F7.8"]},
        "191": {"vr": "SH", "Value": ["SP H67.2"]},
        "192": {"vr": "SH", "Value": ["SP F72.8"]},
        "193": {"vr": "SH", "Value": ["SP H54.7"]},
        "194": {"vr": "SH", "Value": ["SP F35.3"]},
        "195": {"vr": "SH", "Value": ["SP F42.8"]},
        "196": {"vr": "SH", "Value": ["SP F70.3"]},
        "197": {"vr": "SH", "Value": ["SP H2.2"]},
        "198": {"vr": "SH", "Value": ["SP H14.7"]},
        "199": {"vr": "SH", "Value": ["SP F42.8"]},
        "200": {"vr": "SH", "Value": ["SP H27.2"]},
        "201": {"vr": "SH", "Value": ["SP F30.3"]},
        "202": {"vr": "SH", "Value": ["SP H39.7"]},
        "203": {"vr": "SH", "Value": ["SP F67.8"]},
        "204": {"vr": "SH", "Value": ["SP F25.3"]},
        "205": {"vr": "SH", "Value": ["SP H2.2"]},
        "206": {"vr": "SH", "Value": ["SP F30.3"]},
        "207": {"vr": "SH", "Value": ["SP F55.3"]},
        "208": {"vr": "SH", "Value": ["SP H62.2"]},
        "209": {"vr": "SH", "Value": ["SP H14.7"]},
        "210": {"vr": "SH", "Value": ["SP F12.8"]},
        "211": {"vr": "SH", "Value": ["SP F5.3"]},
        "212": {"vr": "SH", "Value": ["SP H47.2"]},
        "213": {"vr": "SH", "Value": ["SP F60.3"]},
        "214": {"vr": "SH", "Value": ["SP H17.2"]},
        "215": {"vr": "SH", "Value": ["SP F72.8"]},
        "216": {"vr": "SH", "Value": ["SP F25.3"]},
        "217": {"vr": "SH", "Value": ["SP H72.2"]},
        "218": {"vr": "SH", "Value": ["SP F0.3"]},
        "219": {"vr": "SH", "Value": ["SP H67.2"]},
        "220": {"vr": "SH", "Value": ["SP H14.7"]},
        "221": {"vr": "SH", "Value": ["SP F22.8"]},
        "222": {"vr": "SH", "Value": ["SP H42.2"]},
        "223": {"vr": "SH", "Value": ["SP H67.2"]},
        "224": {"vr": "SH", "Value": ["SP H27.2"]},
        "225": {"vr": "SH", "Value": ["SP H19.7"]},
        "226": {"vr": "SH", "Value": ["SP F30.3"]},
        "227": {"vr": "SH", "Value": ["SP F57.8"]},
        "228": {"vr": "SH", "Value": ["SP H17.2"]},
        "229": {"vr": "SH", "Value": ["SP F12.8"]},
        "230": {"vr": "SH", "Value": ["SP H72.2"]},
        "231": {"vr": "SH", "Value": ["SP H22.2"]},
        "232": {"vr": "SH", "Value": ["SP F55.3"]},
        "233": {"vr": "SH", "Value": ["SP F0.3"]},
        "234": {"vr": "SH", "Value": ["SP H74.7"]},
        "235": {"vr": "SH", "Value": ["SP F40.3"]},
        "236": {"vr": "SH", "Value": ["SP F32.8"]},
        "237": {"vr": "SH", "Value": ["SP H57.2"]},
        "238": {"vr": "SH", "Value": ["SP F62.8"]},
        "239": {"vr": "SH", "Value": ["SP H24.7"]},
        "240": {"vr": "SH", "Value": ["SP H39.7"]},
        "241": {"vr": "SH", "Value": ["SP F67.8"]},
        "242": {"vr": "SH", "Value": ["SP H7.2"]},
        "243": {"vr": "SH", "Value": ["SP H39.7"]},
        "244": {"vr": "SH", "Value": ["SP H42.2"]},
        "245": {"vr": "SH", "Value": ["SP F67.8"]},
        "246": {"vr": "SH", "Value": ["SP H44.7"]},
        "247": {"vr": "SH", "Value": ["SP F35.3"]},
        "248": {"vr": "SH", "Value": ["SP F67.8"]},
        "249": {"vr": "SH", "Value": ["SP F32.8"]},
        "250": {"vr": "SH", "Value": ["SP H57.2"]},
        "251": {"vr": "SH", "Value": ["SP H14.7"]},
        "252": {"vr": "SH", "Value": ["SP H34.7"]},
        "253": {"vr": "SH", "Value": ["SP F65.3"]},
        "254": {"vr": "SH", "Value": ["SP H47.2"]},
        "255": {"vr": "SH", "Value": ["SP H67.2"]},
        "256": {"vr": "SH", "Value": ["SP H2.2"]},
        "257": {"vr": "SH", "Value": ["SP F65.3"]},
        "258": {"vr": "SH", "Value": ["SP F25.3"]},
        "259": {"vr": "SH", "Value": ["SP F2.8"]},
        "260": {"vr": "SH", "Value": ["SP F32.8"]},
        "261": {"vr": "SH", "Value": ["SP F12.8"]},
        "262": {"vr": "SH", "Value": ["SP F20.3"]},
        "263": {"vr": "SH", "Value": ["SP F7.8"]},
        "264": {"vr": "SH", "Value": ["SP F30.3"]},
        "265": {"vr": "SH", "Value": ["SP F10.3"]},
        "266": {"vr": "SH", "Value": ["SP F72.8"]},
        "267": {"vr": "SH", "Value": ["SP F72.8"]},
        "268": {"vr": "SH", "Value": ["SP H67.2"]},
        "269": {"vr": "SH", "Value": ["SP H7.2"]},
        "270": {"vr": "SH", "Value": ["SP H62.2"]},
        "271": {"vr": "SH", "Value": ["SP F67.8"]},
        "272": {"vr": "SH", "Value": ["SP H62.2"]},
        "273": {"vr": "SH", "Value": ["SP F62.8"]},
        "274": {"vr": "SH", "Value": ["SP F25.3"]},
        "275": {"vr": "SH", "Value": ["SP F27.8"]},
        "276": {"vr": "SH", "Value": ["SP H47.2"]},
        "277": {"vr": "SH", "Value": ["SP F0.3"]},
        "278": {"vr": "SH", "Value": ["SP F15.3"]},
        "279": {"vr": "SH", "Value": ["SP F7.8"]},
        "280": {"vr": "SH", "Value": ["SP F22.8"]},
        "281": {"vr": "SH", "Value": ["SP F65.3"]},
        "282": {"vr": "SH", "Value": ["SP F22.8"]},
        "283": {"vr": "SH", "Value": ["SP H62.2"]},
        "284": {"vr": "SH", "Value": ["SP F60.3"]},
        "285": {"vr": "SH", "Value": ["SP F17.8"]},
        "286": {"vr": "SH", "Value": ["SP H57.2"]},
        "287": {"vr": "SH", "Value": ["SP F47.8"]},
        "288": {"vr": "SH", "Value": ["SP F32.8"]},
        "289": {"vr": "SH", "Value": ["SP H62.2"]},
        "290": {"vr": "SH", "Value": ["SP F60.3"]},
        "291": {"vr": "SH", "Value": ["SP F12.8"]},
        "292": {"vr": "SH", "Value": ["SP F2.8"]},
        "293": {"vr": "SH", "Value": ["SP H39.7"]},
        "294": {"vr": "SH", "Value": ["SP H72.2"]},
        "295": {"vr": "SH", "Value": ["SP F62.8"]},
        "296": {"vr": "SH", "Value": ["SP F70.3"]},
        "297": {"vr": "SH", "Value": ["SP F50.3"]},
        "298": {"vr": "SH", "Value": ["SP F62.8"]},
        "299": {"vr": "SH", "Value": ["SP H2.2"]},
        "300": {"vr": "SH", "Value": ["SP H4.7"]},
        "301": {"vr": "SH", "Value": ["SP H54.7"]},
        "302": {"vr": "SH", "Value": ["SP F25.3"]},
        "303": {"vr": "SH", "Value": ["SP F72.8"]},
        "304": {"vr": "SH", "Value": ["SP H44.7"]},
        "305": {"vr": "SH", "Value": ["SP H9.7"]},
        "306": {"vr": "SH", "Value": ["SP H47.2"]},
        "307": {"vr": "SH", "Value": ["SP F32.8"]},
        "308": {"vr": "SH", "Value": ["SP H4.7"]},
        "309": {"vr": "SH", "Value": ["SP F17.8"]},
        "310": {"vr": "SH", "Value": ["SP H49.7"]},
        "311": {"vr": "SH", "Value": ["SP F50.3"]},
        "312": {"vr": "SH", "Value": ["SP F17.8"]},
        "313": {"vr": "SH", "Value": ["SP F62.8"]},
        "314": {"vr": "SH", "Value": ["SP F40.3"]},
        "315": {"vr": "SH", "Value": ["SP H32.2"]},
        "316": {"vr": "SH", "Value": ["SP F30.3"]},
        "317": {"vr": "SH", "Value": ["SP H47.2"]},
        "318": {"vr": "SH", "Value": ["SP H64.7"]},
        "319": {"vr": "SH", "Value": ["SP H74.7"]},
        "320": {"vr": "SH", "Value": ["SP F35.3"]},
        "321": {"vr": "SH", "Value": ["SP F57.8"]},
        "322": {"vr": "SH", "Value": ["SP H39.7"]},
        "323": {"vr": "SH", "Value": ["SP H22.2"]},
        "324": {"vr": "SH", "Value": ["SP H29.7"]},
        "325": {"vr": "SH", "Value": ["SP F50.3"]},
        "326": {"vr": "SH", "Value": ["SP H69.7"]},
        "327": {"vr": "SH", "Value": ["SP F17.8"]},
        "328": {"vr": "SH", "Value": ["SP H22.2"]},
        "329": {"vr": "SH", "Value": ["SP H22.2"]},
        "330": {"vr": "SH", "Value": ["SP F7.8"]},
        "331": {"vr": "SH", "Value": ["SP F32.8"]},
        "332": {"vr": "SH", "Value": ["SP H22.2"]},
        "333": {"vr": "SH", "Value": ["SP F2.8"]},
        "334": {"vr": "SH", "Value": ["SP H2.2"]},
        "335": {"vr": "SH", "Value": ["SP H19.7"]},
        "336": {"vr": "SH", "Value": ["SP H49.7"]},
        "337": {"vr": "SH", "Value": ["SP H37.2"]},
        "338": {"vr": "SH", "Value": ["SP F37.8"]},
        "339": {"vr": "SH", "Value": ["SP H37.2"]},
        "340": {"vr": "SH", "Value": ["SP F10.3"]},
        "341": {"vr": "SH", "Value": ["SP F25.3"]},
        "342": {"vr": "SH", "Value": ["SP H57.2"]},
        "343": {"vr": "SH", "Value": ["SP H12.2"]},
        "344": {"vr": "SH", "Value": ["SP F35.3"]},
        "345": {"vr": "SH", "Value": ["SP F20.3"]},
        "346": {"vr": "SH", "Value": ["SP H4.7"]},
        "347": {"vr": "SH", "Value": ["SP F2.8"]},
        "348": {"vr": "SH", "Value": ["SP H9.7"]},
        "349": {"vr": "SH", "Value": ["SP H39.7"]},
        "350": {"vr": "SH", "Value": ["SP F27.8"]},
        "351": {"vr": "SH", "Value": ["SP F7.8"]},
        "352": {"vr": "SH", "Value": ["SP H64.7"]},
        "353": {"vr": "SH", "Value": ["SP F30.3"]},
        "354": {"vr": "SH", "Value": ["SP F15.3"]},
        "355": {"vr": "SH", "Value": ["SP F35.3"]},
        "356": {"vr": "SH", "Value": ["SP H7.2"]},
        "357": {"vr": "SH", "Value": ["SP H17.2"]},
        "358": {"vr": "SH", "Value": ["SP H52.2"]},
        "359": {"vr": "SH", "Value": ["SP F32.8"]},
        "360": {"vr": "SH", "Value": ["SP F50.3"]},
        "361": {"vr": "SH", "Value": ["SP H64.7"]},
        "362": {"vr": "SH", "Value": ["SP H49.7"]},
        "363": {"vr": "SH", "Value": ["SP H67.2"]},
        "364": {"vr": "SH", "Value": ["SP F40.3"]},
        "365": {"vr": "SH", "Value": ["SP F50.3"]},
        "366": {"vr": "SH", "Value": ["SP H19.7"]},
        "367": {"vr": "SH", "Value": ["SP F7.8"]},
        "368": {"vr": "SH", "Value": ["SP F0.3"]},
        "369": {"vr": "SH", "Value": ["SP H9.7"]},
        "370": {"vr": "SH", "Value": ["SP H59.7"]},
        "371": {"vr": "SH", "Value": ["SP H34.7"]},
        "372": {"vr": "SH", "Value": ["SP H42.2"]},
        "373": {"vr": "SH", "Value": ["SP H27.2"]},
        "374": {"vr": "SH", "Value": ["SP H34.7"]},
        "375": {"vr": "SH", "Value": ["SP F45.3"]},
        "376": {"vr": "SH", "Value": ["SP F67.8"]},
        "377": {"vr": "SH", "Value": ["SP H37.2"]},
        "378": {"vr": "SH", "Value": ["SP H34.7"]},
        "379": {"vr": "SH", "Value": ["SP H32.2"]},
        "380": {"vr": "SH", "Value": ["SP H67.2"]},
        "381": {"vr": "SH", "Value": ["SP H69.7"]},
        "382": {"vr": "SH", "Value": ["SP H2.2"]},
        "383": {"vr": "SH", "Value": ["SP F17.8"]},
        "384": {"vr": "SH", "Value": ["SP H19.7"]},
        "385": {"vr": "SH", "Value": ["SP H59.7"]},
        "386": {"vr": "SH", "Value": ["SP F57.8"]},
        "387": {"vr": "SH", "Value": ["SP H9.7"]},
        "388": {"vr": "SH", "Value": ["SP F42.8"]},
        "389": {"vr": "SH", "Value": ["SP F30.3"]},
        "390": {"vr": "SH", "Value": ["SP H59.7"]},
        "391": {"vr": "SH", "Value": ["SP F65.3"]},
        "392": {"vr": "SH", "Value": ["SP F45.3"]},
        "393": {"vr": "SH", "Value": ["SP H59.7"]},
        "394": {"vr": "SH", "Value": ["SP F45.3"]},
        "395": {"vr": "SH", "Value": ["SP H22.2"]},
        "396": {"vr": "SH", "Value": ["SP F72.8"]},
        "397": {"vr": "SH", "Value": ["SP F60.3"]},
        "398": {"vr": "SH", "Value": ["SP F67.8"]},
        "399": {"vr": "SH", "Value": ["SP H7.2"]},
        "400": {"vr": "SH", "Value": ["SP F50.3"]},
        "401": {"vr": "SH", "Value": ["SP H22.2"]},
        "402": {"vr": "SH", "Value": ["SP H7.2"]},
        "403": {"vr": "SH", "Value": ["SP F22.8"]},
        "404": {"vr": "SH", "Value": ["SP F30.3"]},
        "405": {"vr": "SH", "Value": ["SP F17.8"]},
        "406": {"vr": "SH", "Value": ["SP H22.2"]},
        "407": {"vr": "SH", "Value": ["SP H9.7"]},
        "408": {"vr": "SH", "Value": ["SP F2.8"]},
        "409": {"vr": "SH", "Value": ["SP F70.3"]},
        "410": {"vr": "SH", "Value": ["SP F37.8"]},
        "411": {"vr": "SH", "Value": ["SP H44.7"]},
        "412": {"vr": "SH", "Value": ["SP F52.8"]},
        "413": {"vr": "SH", "Value": ["SP F27.8"]},
        "414": {"vr": "SH", "Value": ["SP F22.8"]},
        "415": {"vr": "SH", "Value": ["SP F57.8"]},
        "416": {"vr": "SH", "Value": ["SP F70.3"]},
        "417": {"vr": "SH", "Value": ["SP F67.8"]},
        "418": {"vr": "SH", "Value": ["SP H12.2"]},
        "419": {"vr": "SH", "Value": ["SP F7.8"]},
        "420": {"vr": "SH", "Value": ["SP F2.8"]},
        "421": {"vr": "SH", "Value": ["SP F20.3"]},
        "422": {"vr": "SH", "Value": ["SP H54.7"]},
        "423": {"vr": "SH", "Value": ["SP F57.8"]},
        "424": {"vr": "SH", "Value": ["SP H29.7"]},
        "425": {"vr": "SH", "Value": ["SP H44.7"]},
        "426": {"vr": "SH", "Value": ["SP F5.3"]},
        "427": {"vr": "SH", "Value": ["SP F30.3"]},
        "428": {"vr": "SH", "Value": ["SP F32.8"]},
        "429": {"vr": "SH", "Value": ["SP F52.8"]},
        "430": {"vr": "SH", "Value": ["SP H47.2"]},
        "431": {"vr": "SH", "Value": ["SP H17.2"]},
        "432": {"vr": "SH", "Value": ["SP H59.7"]},
        "433": {"vr": "SH", "Value": ["SP H37.2"]},
        "434": {"vr": "SH", "Value": ["SP F40.3"]},
        "435": {"vr": "SH", "Value": ["SP F57.8"]},
        "436": {"vr": "SH", "Value": ["SP F45.3"]},
        "437": {"vr": "SH", "Value": ["SP F62.8"]},
        "438": {"vr": "SH", "Value": ["SP H64.7"]},
        "439": {"vr": "SH", "Value": ["SP F52.8"]},
        "440": {"vr": "SH", "Value": ["SP F30.3"]},
        "441": {"vr": "SH", "Value": ["SP F5.3"]},
        "442": {"vr": "SH", "Value": ["SP H9.7"]},
        "443": {"vr": "SH", "Value": ["SP H74.7"]},
        "444": {"vr": "SH", "Value": ["SP F37.8"]},
        "445": {"vr": "SH", "Value": ["SP H19.7"]},
        "446": {"vr": "SH", "Value": ["SP F50.3"]},
        "447": {"vr": "SH", "Value": ["SP F37.8"]},
        "448": {"vr": "SH", "Value": ["SP H62.2"]},
        "449": {"vr": "SH", "Value": ["SP F15.3"]},
        "450": {"vr": "SH", "Value": ["SP F7.8"]},
        "451": {"vr": "SH", "Value": ["SP F27.8"]},
        "452": {"vr": "SH", "Value": ["SP F10.3"]},
        "453": {"vr": "SH", "Value": ["SP H17.2"]},
        "454": {"vr": "SH", "Value": ["SP H54.7"]},
        "455": {"vr": "SH", "Value": ["SP H4.7"]},
        "456": {"vr": "SH", "Value": ["SP F2.8"]},
        "457": {"vr": "SH", "Value": ["SP H14.7"]},
        "458": {"vr": "SH", "Value": ["SP F52.8"]},
        "459": {"vr": "SH", "Value": ["SP F52.8"]},
        "460": {"vr": "SH", "Value": ["SP H59.7"]},
        "461": {"vr": "SH", "Value": ["SP F0.3"]},
        "462": {"vr": "SH", "Value": ["SP H9.7"]},
        "463": {"vr": "SH", "Value": ["SP F42.8"]},
        "464": {"vr": "SH", "Value": ["SP F40.3"]},
        "465": {"vr": "SH", "Value": ["SP F50.3"]},
        "466": {"vr": "SH", "Value": ["SP H69.7"]},
        "467": {"vr": "SH", "Value": ["SP H57.2"]},
        "468": {"vr": "SH", "Value": ["SP F2.8"]},
        "469": {"vr": "SH", "Value": ["SP F35.3"]},
        "470": {"vr": "SH", "Value": ["SP H47.2"]},
        "471": {"vr": "SH", "Value": ["SP H52.2"]},
        "472": {"vr": "SH", "Value": ["SP F60.3"]},
        "473": {"vr": "SH", "Value": ["SP F35.3"]},
        "474": {"vr": "SH", "Value": ["SP F67.8"]},
        "475": {"vr": "SH", "Value": ["SP F47.8"]},
        "476": {"vr": "SH", "Value": ["SP F62.8"]},
        "477": {"vr": "SH", "Value": ["SP H37.2"]},
        "478": {"vr": "SH", "Value": ["SP H42.2"]},
        "479": {"vr": "SH", "Value": ["SP F20.3"]},
        "480": {"vr": "SH", "Value": ["SP F30.3"]},
        "481": {"vr": "SH", "Value": ["SP F27.8"]},
        "482": {"vr": "SH", "Value": ["SP F57.8"]},
        "483": {"vr": "SH", "Value": ["SP F72.8"]},
        "484": {"vr": "SH", "Value": ["SP F50.3"]},
        "485": {"vr": "SH", "Value": ["SP F57.8"]},
        "486": {"vr": "SH", "Value": ["SP H24.7"]},
        "487": {"vr": "SH", "Value": ["SP H24.7"]},
        "488": {"vr": "SH", "Value": ["SP H4.7"]},
        "489": {"vr": "SH", "Value": ["SP H54.7"]},
        "490": {"vr": "SH", "Value": ["SP F32.8"]},
        "491": {"vr": "SH", "Value": ["SP H22.2"]},
        "492": {"vr": "SH", "Value": ["SP H2.2"]},
        "493": {"vr": "SH", "Value": ["SP F72.8"]},
        "494": {"vr": "SH", "Value": ["SP H12.2"]},
        "495": {"vr": "SH", "Value": ["SP F52.8"]},
        "496": {"vr": "SH", "Value": ["SP F32.8"]},
        "497": {"vr": "SH", "Value": ["SP H62.2"]},
        "498": {"vr": "SH", "Value": ["SP H7.2"]},
        "499": {"vr": "SH", "Value": ["SP H14.7"]},
        "500": {"vr": "SH", "Value": ["SP H64.7"]},
        "501": {"vr": "SH", "Value": ["SP H42.2"]},
        "502": {"vr": "SH", "Value": ["SP F27.8"]},
        "503": {"vr": "SH", "Value": ["SP F60.3"]},
        "504": {"vr": "SH", "Value": ["SP H34.7"]},
        "505": {"vr": "SH", "Value": ["SP F27.8"]},
        "506": {"vr": "SH", "Value": ["SP H74.7"]},
        "507": {"vr": "SH", "Value": ["SP F42.8"]},
        "508": {"vr": "SH", "Value": ["SP H49.7"]},
        "509": {"vr": "SH", "Value": ["SP F55.3"]},
        "510": {"vr": "SH", "Value": ["SP F50.3"]},
        "511": {"vr": "SH", "Value": ["SP F52.8"]},
        "512": {"vr": "SH", "Value": ["SP H57.2"]},
        "513": {"vr": "SH", "Value": ["SP F27.8"]},
        "514": {"vr": "SH", "Value": ["SP H59.7"]},
        "515": {"vr": "SH", "Value": ["SP H24.7"]},
        "516": {"vr": "SH", "Value": ["SP F30.3"]},
        "517": {"vr": "SH", "Value": ["SP F0.3"]},
        "518": {"vr": "SH", "Value": ["SP H44.7"]},
        "519": {"vr": "SH", "Value": ["SP F52.8"]},
        "520": {"vr": "SH", "Value": ["SP H42.2"]},
        "521": {"vr": "SH", "Value": ["SP F47.8"]},
        "522": {"vr": "SH", "Value": ["SP F12.8"]},
        "523": {"vr": "SH", "Value": ["SP H14.7"]},
        "524": {"vr": "SH", "Value": ["SP F50.3"]},
        "525": {"vr": "SH", "Value": ["SP F65.3"]},
        "526": {"vr": "SH", "Value": ["SP H57.2"]},
        "527": {"vr": "SH", "Value": ["SP H9.7"]},
        "528": {"vr": "SH", "Value": ["SP H37.2"]},
        "529": {"vr": "SH", "Value": ["SP H74.7"]},
        "530": {"vr": "SH", "Value": ["SP F67.8"]},
        "531": {"vr": "SH", "Value": ["SP H47.2"]},
        "532": {"vr": "SH", "Value": ["SP H24.7"]},
        "533": {"vr": "SH", "Value": ["SP F5.3"]},
        "534": {"vr": "SH", "Value": ["SP H14.7"]},
        "535": {"vr": "SH", "Value": ["SP H42.2"]},
        "536": {"vr": "SH", "Value": ["SP H47.2"]},
        "537": {"vr": "SH", "Value": ["SP H69.7"]},
        "538": {"vr": "SH", "Value": ["SP H69.7"]},
        "539": {"vr": "SH", "Value": ["SP F40.3"]},
        "540": {"vr": "SH", "Value": ["SP F57.8"]},
        "541": {"vr": "SH", "Value": ["SP H44.7"]},
        "542": {"vr": "SH", "Value": ["SP H37.2"]},
        "543": {"vr": "SH", "Value": ["SP H62.2"]},
        "544": {"vr": "SH", "Value": ["SP F15.3"]},
        "545": {"vr": "SH", "Value": ["SP F27.8"]},
        "546": {"vr": "SH", "Value": ["SP H74.7"]},
        "547": {"vr": "SH", "Value": ["SP F10.3"]},
        "548": {"vr": "SH", "Value": ["SP H37.2"]},
        "549": {"vr": "SH", "Value": ["SP F5.3"]},
        "550": {"vr": "SH", "Value": ["SP F37.8"]},
        "551": {"vr": "SH", "Value": ["SP F27.8"]},
        "552": {"vr": "SH", "Value": ["SP F62.8"]},
        "553": {"vr": "SH", "Value": ["SP H34.7"]},
        "554": {"vr": "SH", "Value": ["SP H47.2"]},
        "555": {"vr": "SH", "Value": ["SP H4.7"]},
        "556": {"vr": "SH", "Value": ["SP F30.3"]},
        "557": {"vr": "SH", "Value": ["SP F52.8"]},
        "558": {"vr": "SH", "Value": ["SP F30.3"]},
        "559": {"vr": "SH", "Value": ["SP F40.3"]},
        "560": {"vr": "SH", "Value": ["SP H27.2"]},
        "561": {"vr": "SH", "Value": ["SP H12.2"]},
        "562": {"vr": "SH", "Value": ["SP H62.2"]},
        "563": {"vr": "SH", "Value": ["SP F25.3"]},
        "564": {"vr": "SH", "Value": ["SP H42.2"]},
        "565": {"vr": "SH", "Value": ["SP H12.2"]},
        "566": {"vr": "SH", "Value": ["SP H59.7"]},
        "567": {"vr": "SH", "Value": ["SP H32.2"]},
        "568": {"vr": "SH", "Value": ["SP H32.2"]},
        "569": {"vr": "SH", "Value": ["SP F0.3"]},
        "570": {"vr": "SH", "Value": ["SP F70.3"]},
        "571": {"vr": "SH", "Value": ["SP H2.2"]},
        "572": {"vr": "SH", "Value": ["SP H57.2"]},
        "573": {"vr": "SH", "Value": ["SP H2.2"]},
        "574": {"vr": "SH", "Value": ["SP F27.8"]},
        "575": {"vr": "SH", "Value": ["SP F20.3"]},
        "576": {"vr": "SH", "Value": ["SP H74.7"]},
        "577": {"vr": "SH", "Value": ["SP F72.8"]},
        "578": {"vr": "SH", "Value": ["SP F7.8"]},
        "579": {"vr": "SH", "Value": ["SP F55.3"]},
        "580": {"vr": "SH", "Value": ["SP H74.7"]},
        "581": {"vr": "SH", "Value": ["SP H34.7"]},
        "582": {"vr": "SH", "Value": ["SP H4.7"]},
        "583": {"vr": "SH", "Value": ["SP H44.7"]},
        "584": {"vr": "SH", "Value": ["SP H47.2"]},
        "585": {"vr": "SH", "Value": ["SP F52.8"]},
        "586": {"vr": "SH", "Value": ["SP F12.8"]},
        "587": {"vr": "SH", "Value": ["SP F60.3"]},
        "588": {"vr": "SH", "Value": ["SP H59.7"]},
        "589": {"vr": "SH", "Value": ["SP F15.3"]},
        "590": {"vr": "SH", "Value": ["SP H7.2"]},
        "591": {"vr": "SH", "Value": ["SP H49.7"]},
        "592": {"vr": "SH", "Value": ["SP F40.3"]},
        "593": {"vr": "SH", "Value": ["SP H54.7"]},
        "594": {"vr": "SH", "Value": ["SP H14.7"]},
        "595": {"vr": "SH", "Value": ["SP F35.3"]},
        "596": {"vr": "SH", "Value": ["SP H17.2"]},
        "597": {"vr": "SH", "Value": ["SP H9.7"]},
        "598": {"vr": "SH", "Value": ["SP H47.2"]},
        "599": {"vr": "SH", "Value": ["SP F15.3"]},
        "600": {"vr": "SH", "Value": ["SP H27.2"]},
        "601": {"vr": "SH", "Value": ["SP F55.3"]},
        "602": {"vr": "SH", "Value": ["SP F37.8"]},
        "603": {"vr": "SH", "Value": ["SP F40.3"]},
        "604": {"vr": "SH", "Value": ["SP F70.3"]},
        "605": {"vr": "SH", "Value": ["SP F72.8"]},
        "606": {"vr": "SH", "Value": ["SP F50.3"]},
        "607": {"vr": "SH", "Value": ["SP H67.2"]},
        "608": {"vr": "SH", "Value": ["SP F40.3"]},
        "609": {"vr": "SH", "Value": ["SP H14.7"]},
        "610": {"vr": "SH", "Value": ["SP F62.8"]},
        "611": {"vr": "SH", "Value": ["SP F32.8"]},
        "612": {"vr": "SH", "Value": ["SP F67.8"]},
        "613": {"vr": "SH", "Value": ["SP F32.8"]},
        "614": {"vr": "SH", "Value": ["SP H37.2"]},
        "615": {"vr": "SH", "Value": ["SP H72.2"]},
        "616": {"vr": "SH", "Value": ["SP F70.3"]},
        "617": {"vr": "SH", "Value": ["SP F42.8"]},
        "618": {"vr": "SH", "Value": ["SP H67.2"]},
        "619": {"vr": "SH", "Value": ["SP H47.2"]},
        "620": {"vr": "SH", "Value": ["SP F47.8"]},
        "621": {"vr": "SH", "Value": ["SP H57.2"]},
        "622": {"vr": "SH", "Value": ["SP F62.8"]},
        "623": {"vr": "SH", "Value": ["SP H72.2"]},
        "624": {"vr": "SH", "Value": ["SP F5.3"]},
        "625": {"vr": "SH", "Value": ["SP H27.2"]},
        "626": {"vr": "SH", "Value": ["SP F65.3"]},
        "627": {"vr": "SH", "Value": ["SP H34.7"]},
        "628": {"vr": "SH", "Value": ["SP F55.3"]},
        "629": {"vr": "SH", "Value": ["SP F5.3"]},
        "630": {"vr": "SH", "Value": ["SP H39.7"]},
        "631": {"vr": "SH", "Value": ["SP F67.8"]},
        "632": {"vr": "SH", "Value": ["SP F72.8"]},
        "633": {"vr": "SH", "Value": ["SP H7.2"]},
        "634": {"vr": "SH", "Value": ["SP F50.3"]},
        "635": {"vr": "SH", "Value": ["SP H69.7"]},
        "636": {"vr": "SH", "Value": ["SP H72.2"]},
        "637": {"vr": "SH", "Value": ["SP F15.3"]},
        "638": {"vr": "SH", "Value": ["SP F50.3"]},
        "639": {"vr": "SH", "Value": ["SP H4.7"]},
        "640": {"vr": "SH", "Value": ["SP H47.2"]},
        "641": {"vr": "SH", "Value": ["SP F0.3"]},
        "642": {"vr": "SH", "Value": ["SP H24.7"]},
        "643": {"vr": "SH", "Value": ["SP F65.3"]},
        "644": {"vr": "SH", "Value": ["SP F67.8"]},
        "645": {"vr": "SH", "Value": ["SP H27.2"]},
        "646": {"vr": "SH", "Value": ["SP H72.2"]},
        "647": {"vr": "SH", "Value": ["SP F15.3"]},
        "648": {"vr": "SH", "Value": ["SP H52.2"]},
        "649": {"vr": "SH", "Value": ["SP H67.2"]},
        "650": {"vr": "SH", "Value": ["SP H54.7"]},
        "651": {"vr": "SH", "Value": ["SP F65.3"]},
        "652": {"vr": "SH", "Value": ["SP F5.3"]},
        "653": {"vr": "SH", "Value": ["SP F60.3"]},
        "654": {"vr": "SH", "Value": ["SP H27.2"]},
        "655": {"vr": "SH", "Value": ["SP H9.7"]},
        "656": {"vr": "SH", "Value": ["SP F42.8"]},
        "657": {"vr": "SH", "Value": ["SP F42.8"]},
        "658": {"vr": "SH", "Value": ["SP F0.3"]},
        "659": {"vr": "SH", "Value": ["SP H7.2"]},
        "660": {"vr": "SH", "Value": ["SP F30.3"]},
        "661": {"vr": "SH", "Value": ["SP F20.3"]},
        "662": {"vr": "SH", "Value": ["SP F2.8"]},
        "663": {"vr": "SH", "Value": ["SP H72.2"]},
        "664": {"vr": "SH", "Value": ["SP F20.3"]},
        "665": {"vr": "SH", "Value": ["SP F45.3"]},
        "666": {"vr": "SH", "Value": ["SP F47.8"]},
        "667": {"vr": "SH", "Value": ["SP F62.8"]},
        "668": {"vr": "SH", "Value": ["SP H34.7"]},
        "669": {"vr": "SH", "Value": ["SP F40.3"]},
        "670": {"vr": "SH", "Value": ["SP H32.2"]},
        "671": {"vr": "SH", "Value": ["SP H69.7"]},
        "672": {"vr": "SH", "Value": ["SP F67.8"]},
        "673": {"vr": "SH", "Value": ["SP F52.8"]},
        "674": {"vr": "SH", "Value": ["SP F17.8"]},
        "675": {"vr": "SH", "Value": ["SP F70.3"]},
        "676": {"vr": "SH", "Value": ["SP F0.3"]},
        "677": {"vr": "SH", "Value": ["SP F32.8"]},
        "678": {"vr": "SH", "Value": ["SP H32.2"]},
        "679": {"vr": "SH", "Value": ["SP H14.7"]},
        "680": {"vr": "SH", "Value": ["SP F52.8"]},
        "681": {"vr": "SH", "Value": ["SP H49.7"]},
        "682": {"vr": "SH", "Value": ["SP F45.3"]},
        "683": {"vr": "SH", "Value": ["SP H72.2"]},
        "684": {"vr": "SH", "Value": ["SP H64.7"]},
        "685": {"vr": "SH", "Value": ["SP F45.3"]},
        "686": {"vr": "SH", "Value": ["SP H32.2"]},
        "687": {"vr": "SH", "Value": ["SP F67.8"]},
        "688": {"vr": "SH", "Value": ["SP F37.8"]},
        "689": {"vr": "SH", "Value": ["SP F42.8"]},
        "690": {"vr": "SH", "Value": ["SP F50.3"]},
        "691": {"vr": "SH", "Value": ["SP F25.3"]},
        "692": {"vr": "SH", "Value": ["SP F60.3"]},
        "693": {"vr": "SH", "Value": ["SP F52.8"]},
        "694": {"vr": "SH", "Value": ["SP H27.2"]},
        "695": {"vr": "SH", "Value": ["SP H47.2"]},
        "696": {"vr": "SH", "Value": ["SP H7.2"]},
        "697": {"vr": "SH", "Value": ["SP F67.8"]},
        "698": {"vr": "SH", "Value": ["SP F55.3"]},
        "699": {"vr": "SH", "Value": ["SP H57.2"]},
        "700": {"vr": "SH", "Value": ["SP H64.7"]},
        "701": {"vr": "SH", "Value": ["SP H32.2"]},
        "702": {"vr": "SH", "Value": ["SP F0.3"]},
        "703": {"vr": "SH", "Value": ["SP H12.2"]},
        "704": {"vr": "SH", "Value": ["SP H64.7"]},
        "705": {"vr": "SH", "Value": ["SP H2.2"]},
        "706": {"vr": "SH", "Value": ["SP F55.3"]},
        "707": {"vr": "SH", "Value": ["SP F2.8"]},
        "708": {"vr": "SH", "Value": ["SP F62.8"]},
        "709": {"vr": "SH", "Value": ["SP F62.8"]},
        "710": {"vr": "SH", "Value": ["SP H22.2"]},
        "711": {"vr": "SH", "Value": ["SP H32.2"]},
        "712": {"vr": "SH", "Value": ["SP H49.7"]},
        "713": {"vr": "SH", "Value": ["SP F10.3"]},
        "714": {"vr": "SH", "Value": ["SP H9.7"]},
        "715": {"vr": "SH", "Value": ["SP F5.3"]},
        "716": {"vr": "SH", "Value": ["SP H14.7"]},
        "717": {"vr": "SH", "Value": ["SP H69.7"]},
        "718": {"vr": "SH", "Value": ["SP F52.8"]},
        "719": {"vr": "SH", "Value": ["SP F37.8"]},
        "720": {"vr": "SH", "Value": ["SP H32.2"]},
        "721": {"vr": "SH", "Value": ["SP H57.2"]},
        "722": {"vr": "SH", "Value": ["SP F70.3"]},
        "723": {"vr": "SH", "Value": ["SP H62.2"]},
        "724": {"vr": "SH", "Value": ["SP H12.2"]},
        "725": {"vr": "SH", "Value": ["SP F7.8"]},
        "726": {"vr": "SH", "Value": ["SP H14.7"]},
        "727": {"vr": "SH", "Value": ["SP H9.7"]},
        "728": {"vr": "SH", "Value": ["SP H19.7"]},
        "729": {"vr": "SH", "Value": ["SP H34.7"]},
        "730": {"vr": "SH", "Value": ["SP H9.7"]},
        "731": {"vr": "SH", "Value": ["SP H4.7"]},
        "732": {"vr": "SH", "Value": ["SP H9.7"]},
        "733": {"vr": "SH", "Value": ["SP H64.7"]},
        "734": {"vr": "SH", "Value": ["SP F57.8"]},
        "735": {"vr": "SH", "Value": ["SP H42.2"]},
        "736": {"vr": "SH", "Value": ["SP H19.7"]},
        "737": {"vr": "SH", "Value": ["SP F42.8"]},
        "738": {"vr": "SH", "Value": ["SP H9.7"]},
        "739": {"vr": "SH", "Value": ["SP F65.3"]},
        "740": {"vr": "SH", "Value": ["SP H12.2"]},
        "741": {"vr": "SH", "Value": ["SP F25.3"]},
        "742": {"vr": "SH", "Value": ["SP H32.2"]},
        "743": {"vr": "SH", "Value": ["SP F17.8"]},
        "744": {"vr": "SH", "Value": ["SP F2.8"]},
        "745": {"vr": "SH", "Value": ["SP F20.3"]},
        "746": {"vr": "SH", "Value": ["SP F42.8"]},
        "747": {"vr": "SH", "Value": ["SP F65.3"]},
        "748": {"vr": "SH", "Value": ["SP F27.8"]},
        "749": {"vr": "SH", "Value": ["SP F35.3"]},
        "750": {"vr": "SH", "Value": ["SP F40.3"]},
        "751": {"vr": "SH", "Value": ["SP F12.8"]},
        "752": {"vr": "SH", "Value": ["SP H57.2"]},
        "753": {"vr": "SH", "Value": ["SP H29.7"]},
        "754": {"vr": "SH", "Value": ["SP F62.8"]},
        "755": {"vr": "SH", "Value": ["SP F50.3"]},
        "756": {"vr": "SH", "Value": ["SP H52.2"]},
        "757": {"vr": "SH", "Value": ["SP F57.8"]},
        "758": {"vr": "SH", "Value": ["SP F35.3"]},
        "759": {"vr": "SH", "Value": ["SP H4.7"]},
        "760": {"vr": "SH", "Value": ["SP F32.8"]},
        "761": {"vr": "SH", "Value": ["SP H67.2"]},
        "762": {"vr": "SH", "Value": ["SP H22.2"]},
        "763": {"vr": "SH", "Value": ["SP F22.8"]},
        "764": {"vr": "SH", "Value": ["SP F20.3"]},
        "765": {"vr": "SH", "Value": ["SP H32.2"]},
        "766": {"vr": "SH", "Value": ["SP H54.7"]},
        "767": {"vr": "SH", "Value": ["SP F5.3"]},
        "768": {"vr": "SH", "Value": ["SP F57.8"]},
        "769": {"vr": "SH", "Value": ["SP H64.7"]},
        "770": {"vr": "SH", "Value": ["SP F2.8"]},
        "771": {"vr": "SH", "Value": ["SP F22.8"]},
        "772": {"vr": "SH", "Value": ["SP F45.3"]},
        "773": {"vr": "SH", "Value": ["SP H9.7"]},
        "774": {"vr": "SH", "Value": ["SP F42.8"]},
        "775": {"vr": "SH", "Value": ["SP F70.3"]},
        "776": {"vr": "SH", "Value": ["SP F47.8"]},
        "777": {"vr": "SH", "Value": ["SP H44.7"]},
        "778": {"vr": "SH", "Value": ["SP H74.7"]},
        "779": {"vr": "SH", "Value": ["SP H32.2"]},
        "780": {"vr": "SH", "Value": ["SP H54.7"]},
        "781": {"vr": "SH", "Value": ["SP F17.8"]},
        "782": {"vr": "SH", "Value": ["SP F52.8"]},
        "783": {"vr": "SH", "Value": ["SP H49.7"]},
        "784": {"vr": "SH", "Value": ["SP H17.2"]},
        "785": {"vr": "SH", "Value": ["SP H27.2"]},
        "786": {"vr": "SH", "Value": ["SP F40.3"]},
        "787": {"vr": "SH", "Value": ["SP H74.7"]},
        "788": {"vr": "SH", "Value": ["SP H39.7"]},
        "789": {"vr": "SH", "Value": ["SP H47.2"]},
        "790": {"vr": "SH", "Value": ["SP H64.7"]},
        "791": {"vr": "SH", "Value": ["SP F32.8"]},
        "792": {"vr": "SH", "Value": ["SP H7.2"]},
        "793": {"vr": "SH", "Value": ["SP F30.3"]},
        "794": {"vr": "SH", "Value": ["SP H27.2"]},
        "795": {"vr": "SH", "Value": ["SP F7.8"]},
        "796": {"vr": "SH", "Value": ["SP H2.2"]},
        "797": {"vr": "SH", "Value": ["SP H24.7"]},
        "798": {"vr": "SH", "Value": ["SP F12.8"]},
        "799": {"vr": "SH", "Value": ["SP F72.8"]},
        "800": {"vr": "SH", "Value": ["SP F55.3"]},
        "801": {"vr": "SH", "Value": ["SP F60.3"]},
        "802": {"vr": "SH", "Value": ["SP F57.8"]},
        "803": {"vr": "SH", "Value": ["SP F5.3"]},
        "804": {"vr": "SH", "Value": ["SP F22.8"]},
        "805": {"vr": "SH", "Value": ["SP H7.2"]},
        "806": {"vr": "SH", "Value": ["SP H74.7"]},
        "807": {"vr": "SH", "Value": ["SP F5.3"]},
        "808": {"vr": "SH", "Value": ["SP F37.8"]},
        "809": {"vr": "SH", "Value": ["SP F42.8"]},
        "810": {"vr": "SH", "Value": ["SP H17.2"]},
        "811": {"vr": "SH", "Value": ["SP F10.3"]},
        "812": {"vr": "SH", "Value": ["SP H74.7"]},
        "813": {"vr": "SH", "Value": ["SP F52.8"]},
        "814": {"vr": "SH", "Value": ["SP F40.3"]},
        "815": {"vr": "SH", "Value": ["SP F2.8"]},
        "816": {"vr": "SH", "Value": ["SP H22.2"]},
        "817": {"vr": "SH", "Value": ["SP H2.2"]},
        "818": {"vr": "SH", "Value": ["SP H42.2"]},
        "819": {"vr": "SH", "Value": ["SP H64.7"]},
        "820": {"vr": "SH", "Value": ["SP F15.3"]},
        "821": {"vr": "SH", "Value": ["SP H52.2"]},
        "822": {"vr": "SH", "Value": ["SP F17.8"]},
        "823": {"vr": "SH", "Value": ["SP H52.2"]},
        "824": {"vr": "SH", "Value": ["SP F15.3"]},
        "825": {"vr": "SH", "Value": ["SP F15.3"]},
        "826": {"vr": "SH", "Value": ["SP H69.7"]},
        "827": {"vr": "SH", "Value": ["SP H29.7"]},
        "828": {"vr": "SH", "Value": ["SP F25.3"]},
        "829": {"vr": "SH", "Value": ["SP F0.3"]},
        "830": {"vr": "SH", "Value": ["SP H64.7"]},
        "831": {"vr": "SH", "Value": ["SP F0.3"]},
        "832": {"vr": "SH", "Value": ["SP F45.3"]},
        "833": {"vr": "SH", "Value": ["SP F67.8"]},
        "834": {"vr": "SH", "Value": ["SP F62.8"]},
        "835": {"vr": "SH", "Value": ["SP H4.7"]},
        "836": {"vr": "SH", "Value": ["SP H42.2"]},
        "837": {"vr": "SH", "Value": ["SP F17.8"]},
        "838": {"vr": "SH", "Value": ["SP H14.7"]},
        "839": {"vr": "SH", "Value": ["SP F42.8"]},
        "840": {"vr": "SH", "Value": ["SP F52.8"]},
        "841": {"vr": "SH", "Value": ["SP F65.3"]},
        "842": {"vr": "SH", "Value": ["SP H4.7"]},
        "843": {"vr": "SH", "Value": ["SP H17.2"]},
        "844": {"vr": "SH", "Value": ["SP H24.7"]},
        "845": {"vr": "SH", "Value": ["SP H54.7"]},
        "846": {"vr": "SH", "Value": ["SP F67.8"]},
        "847": {"vr": "SH", "Value": ["SP F42.8"]},
        "848": {"vr": "SH", "Value": ["SP H69.7"]},
        "849": {"vr": "SH", "Value": ["SP H37.2"]},
        "850": {"vr": "SH", "Value": ["SP F70.3"]},
        "851": {"vr": "SH", "Value": ["SP F57.8"]},
        "852": {"vr": "SH", "Value": ["SP H44.7"]},
        "853": {"vr": "SH", "Value": ["SP F22.8"]},
        "854": {"vr": "SH", "Value": ["SP H7.2"]},
        "855": {"vr": "SH", "Value": ["SP F5.3"]},
        "856": {"vr": "SH", "Value": ["SP F32.8"]},
        "857": {"vr": "SH", "Value": ["SP H37.2"]},
        "858": {"vr": "SH", "Value": ["SP F72.8"]},
        "859": {"vr": "SH", "Value": ["SP H44.7"]},
        "860": {"vr": "SH", "Value": ["SP H54.7"]},
        "861": {"vr": "SH", "Value": ["SP F55.3"]},
        "862": {"vr": "SH", "Value": ["SP F17.8"]},
        "863": {"vr": "SH", "Value": ["SP H2.2"]},
        "864": {"vr": "SH", "Value": ["SP F70.3"]},
        "865": {"vr": "SH", "Value": ["SP H54.7"]},
        "866": {"vr": "SH", "Value": ["SP F27.8"]},
        "867": {"vr": "SH", "Value": ["SP F37.8"]},
        "868": {"vr": "SH", "Value": ["SP F20.3"]},
        "869": {"vr": "SH", "Value": ["SP H54.7"]},
        "870": {"vr": "SH", "Value": ["SP H69.7"]},
        "871": {"vr": "SH", "Value": ["SP H47.2"]},
        "872": {"vr": "SH", "Value": ["SP F12.8"]},
        "873": {"vr": "SH", "Value": ["SP F2.8"]},
        "874": {"vr": "SH", "Value": ["SP F32.8"]},
        "875": {"vr": "SH", "Value": ["SP H42.2"]},
        "876": {"vr": "SH", "Value": ["SP H52.2"]},
        "877": {"vr": "SH", "Value": ["SP F37.8"]},
        "878": {"vr": "SH", "Value": ["SP H4.7"]},
        "879": {"vr": "SH", "Value": ["SP F10.3"]},
        "880": {"vr": "SH", "Value": ["SP H37.2"]},
        "881": {"vr": "SH", "Value": ["SP F2.8"]},
        "882": {"vr": "SH", "Value": ["SP H29.7"]},
        "883": {"vr": "SH", "Value": ["SP F55.3"]},
        "884": {"vr": "SH", "Value": ["SP F37.8"]},
        "885": {"vr": "SH", "Value": ["SP H47.2"]},
        "886": {"vr": "SH", "Value": ["SP H37.2"]},
        "887": {"vr": "SH", "Value": ["SP F17.8"]},
        "888": {"vr": "SH", "Value": ["SP H49.7"]},
        "889": {"vr": "SH", "Value": ["SP F60.3"]},
        "890": {"vr": "SH", "Value": ["SP F30.3"]},
        "891": {"vr": "SH", "Value": ["SP H72.2"]},
        "892": {"vr": "SH", "Value": ["SP F7.8"]},
        "893": {"vr": "SH", "Value": ["SP F7.8"]},
        "894": {"vr": "SH", "Value": ["SP H14.7"]},
        "895": {"vr": "SH", "Value": ["SP F55.3"]},
        "896": {"vr": "SH", "Value": ["SP H62.2"]},
        "897": {"vr": "SH", "Value": ["SP F40.3"]},
        "898": {"vr": "SH", "Value": ["SP H37.2"]},
        "899": {"vr": "SH", "Value": ["SP F5.3"]},
        "900": {"vr": "SH", "Value": ["SP F0.3"]},
        "901": {"vr": "SH", "Value": ["SP H22.2"]},
        "902": {"vr": "SH", "Value": ["SP H34.7"]},
        "903": {"vr": "SH", "Value": ["SP H22.2"]},
        "904": {"vr": "SH", "Value": ["SP H39.7"]},
        "905": {"vr": "SH", "Value": ["SP F7.8"]},
        "906": {"vr": "SH", "Value": ["SP F25.3"]},
        "907": {"vr": "SH", "Value": ["SP F37.8"]},
        "908": {"vr": "SH", "Value": ["SP F10.3"]},
        "909": {"vr": "SH", "Value": ["SP F42.8"]},
        "910": {"vr": "SH", "Value": ["SP H64.7"]},
        "911": {"vr": "SH", "Value": ["SP F0.3"]},
        "912": {"vr": "SH", "Value": ["SP H47.2"]},
        "913": {"vr": "SH", "Value": ["SP H72.2"]},
        "914": {"vr": "SH", "Value": ["SP H24.7"]},
        "915": {"vr": "SH", "Value": ["SP F47.8"]},
        "916": {"vr": "SH", "Value": ["SP H74.7"]},
        "917": {"vr": "SH", "Value": ["SP F70.3"]},
        "918": {"vr": "SH", "Value": ["SP H22.2"]},
        "919": {"vr": "SH", "Value": ["SP F67.8"]},
        "920": {"vr": "SH", "Value": ["SP H69.7"]},
        "921": {"vr": "SH", "Value": ["SP F5.3"]},
        "922": {"vr": "SH", "Value": ["SP F2.8"]},
        "923": {"vr": "SH", "Value": ["SP H67.2"]},
        "924": {"vr": "SH", "Value": ["SP F60.3"]},
        "925": {"vr": "SH", "Value": ["SP H9.7"]},
        "926": {"vr": "SH", "Value": ["SP F30.3"]},
        "927": {"vr": "SH", "Value": ["SP H64.7"]},
        "928": {"vr": "SH", "Value": ["SP F65.3"]},
        "929": {"vr": "SH", "Value": ["SP F67.8"]},
        "930": {"vr": "SH", "Value": ["SP H7.2"]},
        "931": {"vr": "SH", "Value": ["SP H57.2"]},
        "932": {"vr": "SH", "Value": ["SP H59.7"]},
        "933": {"vr": "SH", "Value": ["SP F0.3"]},
        "934": {"vr": "SH", "Value": ["SP H29.7"]},
        "935": {"vr": "SH", "Value": ["SP H42.2"]},
        "936": {"vr": "SH", "Value": ["SP F2.8"]},
        "937": {"vr": "SH", "Value": ["SP H2.2"]},
        "938": {"vr": "SH", "Value": ["SP H72.2"]},
        "939": {"vr": "SH", "Value": ["SP F32.8"]},
        "940": {"vr": "SH", "Value": ["SP H2.2"]},
        "941": {"vr": "SH", "Value": ["SP H64.7"]},
        "942": {"vr": "SH", "Value": ["SP F17.8"]},
        "943": {"vr": "SH", "Value": ["SP H7.2"]},
        "944": {"vr": "SH", "Value": ["SP F30.3"]},
        "945": {"vr": "SH", "Value": ["SP H32.2"]},
        "946": {"vr": "SH", "Value": ["SP H29.7"]},
        "947": {"vr": "SH", "Value": ["SP F20.3"]},
        "948": {"vr": "SH", "Value": ["SP F7.8"]},
        "949": {"vr": "SH", "Value": ["SP F25.3"]},
        "950": {"vr": "SH", "Value": ["SP H14.7"]},
        "951": {"vr": "SH", "Value": ["SP F40.3"]},
        "952": {"vr": "SH", "Value": ["SP F20.3"]},
        "953": {"vr": "SH", "Value": ["SP F12.8"]},
        "954": {"vr": "SH", "Value": ["SP H62.2"]},
        "955": {"vr": "SH", "Value": ["SP F40.3"]},
        "956": {"vr": "SH", "Value": ["SP H27.2"]},
        "957": {"vr": "SH", "Value": ["SP F2.8"]},
        "958": {"vr": "SH", "Value": ["SP F55.3"]},
        "959": {"vr": "SH", "Value": ["SP F65.3"]},
        "960": {"vr": "SH", "Value": ["SP H54.7"]},
        "961": {"vr": "SH", "Value": ["SP H29.7"]},
        "962": {"vr": "SH", "Value": ["SP H42.2"]},
        "963": {"vr": "SH", "Value": ["SP H12.2"]},
        "964": {"vr": "SH", "Value": ["SP F7.8"]},
        "965": {"vr": "SH", "Value": ["SP H9.7"]},
        "966": {"vr": "SH", "Value": ["SP H72.2"]},
        "967": {"vr": "SH", "Value": ["SP F65.3"]},
        "968": {"vr": "SH", "Value": ["SP F47.8"]},
        "969": {"vr": "SH", "Value": ["SP H57.2"]},
        "970": {"vr": "SH", "Value": ["SP F0.3"]},
        "971": {"vr": "SH", "Value": ["SP H2.2"]},
        "972": {"vr": "SH", "Value": ["SP H42.2"]},
        "973": {"vr": "SH", "Value": ["SP H59.7"]},
        "974": {"vr": "SH", "Value": ["SP H57.2"]},
        "975": {"vr": "SH", "Value": ["SP F40.3"]},
        "976": {"vr": "SH", "Value": ["SP H19.7"]},
        "977": {"vr": "SH", "Value": ["SP F2.8"]},
        "978": {"vr": "SH", "Value": ["SP F27.8"]},
        "979": {"vr": "SH", "Value": ["SP F10.3"]},
        "980": {"vr": "SH", "Value": ["SP F55.3"]},
        "981": {"vr": "SH", "Value": ["SP H57.2"]},
        "982": {"vr": "SH", "Value": ["SP F37.8"]},
        "983": {"vr": "SH", "Value": ["SP H22.2"]},
        "984": {"vr": "SH", "Value": ["SP F47.8"]},
        "985": {"vr": "SH", "Value": ["SP F7.8"]},
        "986": {"vr": "SH", "Value": ["SP F52.8"]},
        "987": {"vr": "SH", "Value": ["SP H14.7"]},
        "988": {"vr": "SH", "Value": ["SP H67.2"]},
        "989": {"vr": "SH", "Value": ["SP F70.3"]},
        "990": {"vr": "SH", "Value": ["SP H57.2"]},
        "991": {"vr": "SH", "Value": ["SP H12.2"]},
        "992": {"vr": "SH", "Value": ["SP F17.8"]},
        "993": {"vr": "SH", "Value": ["SP H2.2"]},
        "994": {"vr": "SH", "Value": ["SP F45.3"]},
        "995": {"vr": "SH", "Value": ["SP H17.2"]},
        "996": {"vr": "SH", "Value": ["SP F65.3"]},
        "997": {"vr": "SH", "Value": ["SP H69.7"]},
        "998": {"vr": "SH", "Value": ["SP H44.7"]},
        "999": {"vr": "SH", "Value": ["SP F17.8"]},
        "1000": {"vr": "SH", "Value": ["SP F50.3"]},
        "1001": {"vr": "SH", "Value": ["SP H7.2"]},
        "1002": {"vr": "SH", "Value": ["SP H39.7"]},
        "1003": {"vr": "SH", "Value": ["SP H19.7"]},
        "1004": {"vr": "SH", "Value": ["SP H52.2"]},
        "1005": {"vr": "SH", "Value": ["SP F52.8"]},
        "1006": {"vr": "SH", "Value": ["SP F50.3"]},
        "1007": {"vr": "SH", "Value": ["SP F30.3"]},
        "1008": {"vr": "SH", "Value": ["SP H44.7"]},
        "1009": {"vr": "SH", "Value": ["SP H52.2"]},
        "1010": {"vr": "SH", "Value": ["SP H34.7"]},
        "1011": {"vr": "SH", "Value": ["SP H49.7"]},
        "1012": {"vr": "SH", "Value": ["SP F40.3"]},
        "1013": {"vr": "SH", "Value": ["SP F40.3"]},
        "1014": {"vr": "SH", "Value": ["SP H14.7"]},
        "1015": {"vr": "SH", "Value": ["SP H2.2"]},
        "1016": {"vr": "SH", "Value": ["SP F2.8"]},
        "1017": {"vr": "SH", "Value": ["SP F50.3"]},
        "1018": {"vr": "SH", "Value": ["SP H64.7"]},
        "1019": {"vr": "SH", "Value": ["SP F12.8"]},
        "1020": {"vr": "SH", "Value": ["SP H34.7"]},
        "1021": {"vr": "SH", "Value": ["SP F17.8"]},
        "1022": {"vr": "SH", "Value": ["SP F50.3"]},
        "1023": {"vr": "SH", "Value": ["SP F60.3"]},
        "1024": {"vr": "SH", "Value": ["SP H44.7"]},
        "1025": {"vr": "SH", "Value": ["SP H24.7"]},
        "1026": {"vr": "SH", "Value": ["SP F20.3"]},
        "1027": {"vr": "SH", "Value": ["SP H74.7"]},
        "1028": {"vr": "SH", "Value": ["SP F42.8"]},
        "1029": {"vr": "SH", "Value": ["SP H59.7"]},
        "1030": {"vr": "SH", "Value": ["SP H32.2"]},
        "1031": {"vr": "SH", "Value": ["SP H2.2"]},
        "1032": {"vr": "SH", "Value": ["SP F15.3"]},
        "1033": {"vr": "SH", "Value": ["SP F7.8"]},
        "1034": {"vr": "SH", "Value": ["SP H7.2"]},
        "1035": {"vr": "SH", "Value": ["SP F37.8"]},
        "1036": {"vr": "SH", "Value": ["SP H74.7"]},
        "1037": {"vr": "SH", "Value": ["SP F42.8"]},
        "1038": {"vr": "SH", "Value": ["SP H62.2"]},
        "1039": {"vr": "SH", "Value": ["SP H17.2"]},
        "1040": {"vr": "SH", "Value": ["SP F20.3"]},
        "1041": {"vr": "SH", "Value": ["SP H24.7"]},
        "1042": {"vr": "SH", "Value": ["SP H49.7"]},
        "1043": {"vr": "SH", "Value": ["SP F35.3"]},
        "1044": {"vr": "SH", "Value": ["SP H74.7"]},
        "1045": {"vr": "SH", "Value": ["SP H24.7"]},
        "1046": {"vr": "SH", "Value": ["SP H67.2"]},
        "1047": {"vr": "SH", "Value": ["SP F35.3"]},
        "1048": {"vr": "SH", "Value": ["SP H74.7"]},
        "1049": {"vr": "SH", "Value": ["SP H34.7"]},
        "1050": {"vr": "SH", "Value": ["SP H74.7"]},
        "1051": {"vr": "SH", "Value": ["SP H57.2"]},
        "1052": {"vr": "SH", "Value": ["SP F7.8"]},
        "1053": {"vr": "SH", "Value": ["SP F70.3"]},
        "1054": {"vr": "SH", "Value": ["SP H17.2"]},
        "1055": {"vr": "SH", "Value": ["SP F20.3"]},
        "1056": {"vr": "SH", "Value": ["SP F12.8"]},
        "1057": {"vr": "SH", "Value": ["SP F70.3"]},
        "1058": {"vr": "SH", "Value": ["SP H74.7"]},
        "1059": {"vr": "SH", "Value": ["SP F35.3"]},
        "1060": {"vr": "SH", "Value": ["SP F2.8"]},
        "1061": {"vr": "SH", "Value": ["SP F55.3"]},
        "1062": {"vr": "SH", "Value": ["SP F20.3"]},
        "1063": {"vr": "SH", "Value": ["SP F67.8"]},
        "1064": {"vr": "SH", "Value": ["SP F2.8"]},
        "1065": {"vr": "SH", "Value": ["SP H22.2"]},
        "1066": {"vr": "SH", "Value": ["SP F30.3"]},
        "1067": {"vr": "SH", "Value": ["SP F50.3"]},
        "1068": {"vr": "SH", "Value": ["SP F42.8"]},
        "1069": {"vr": "SH", "Value": ["SP F12.8"]},
        "1070": {"vr": "SH", "Value": ["SP F55.3"]},
        "1071": {"vr": "SH", "Value": ["SP H39.7"]},
        "1072": {"vr": "SH", "Value": ["SP F47.8"]},
        "1073": {"vr": "SH", "Value": ["SP H64.7"]},
        "1074": {"vr": "SH", "Value": ["SP H37.2"]},
        "1075": {"vr": "SH", "Value": ["SP F30.3"]},
        "1076": {"vr": "SH", "Value": ["SP F60.3"]},
        "1077": {"vr": "SH", "Value": ["SP F65.3"]},
        "1078": {"vr": "SH", "Value": ["SP H67.2"]},
        "1079": {"vr": "SH", "Value": ["SP H72.2"]},
        "1080": {"vr": "SH", "Value": ["SP F67.8"]},
        "1081": {"vr": "SH", "Value": ["SP H4.7"]},
        "1082": {"vr": "SH", "Value": ["SP H54.7"]},
        "1083": {"vr": "SH", "Value": ["SP F17.8"]},
        "1084": {"vr": "SH", "Value": ["SP F72.8"]},
        "1085": {"vr": "SH", "Value": ["SP F37.8"]},
        "1086": {"vr": "SH", "Value": ["SP F55.3"]},
        "1087": {"vr": "SH", "Value": ["SP H9.7"]},
        "1088": {"vr": "SH", "Value": ["SP H42.2"]},
        "1089": {"vr": "SH", "Value": ["SP H42.2"]},
        "1090": {"vr": "SH", "Value": ["SP F20.3"]},
        "1091": {"vr": "SH", "Value": ["SP H52.2"]},
        "1092": {"vr": "SH", "Value": ["SP H44.7"]},
        "1093": {"vr": "SH", "Value": ["SP F65.3"]},
        "1094": {"vr": "SH", "Value": ["SP H32.2"]},
        "1095": {"vr": "SH", "Value": ["SP F32.8"]},
        "1096": {"vr": "SH", "Value": ["SP F45.3"]},
        "1097": {"vr": "SH", "Value": ["SP F7.8"]},
        "1098": {"vr": "SH", "Value": ["SP H62.2"]},
        "1099": {"vr": "SH", "Value": ["SP F70.3"]},
        "1100": {"vr": "SH", "Value": ["SP F27.8"]},
        "1101": {"vr": "SH", "Value": ["SP F67.8"]},
        "1102": {"vr": "SH", "Value": ["SP F47.8"]},
        "1103": {"vr": "SH", "Value": ["SP F15.3"]},
        "1104": {"vr": "SH", "Value": ["SP F12.8"]},
        "1105": {"vr": "SH", "Value": ["SP F25.3"]},
        "1106": {"vr": "SH", "Value": ["SP H37.2"]},
        "1107": {"vr": "SH", "Value": ["SP H14.7"]},
        "1108": {"vr": "SH", "Value": ["SP F50.3"]},
        "1109": {"vr": "SH", "Value": ["SP F20.3"]},
        "1110": {"vr": "SH", "Value": ["SP F70.3"]},
        "1111": {"vr": "SH", "Value": ["SP H44.7"]},
        "1112": {"vr": "SH", "Value": ["SP F52.8"]},
        "1113": {"vr": "SH", "Value": ["SP H52.2"]},
        "1114": {"vr": "SH", "Value": ["SP H32.2"]},
        "1115": {"vr": "SH", "Value": ["SP F65.3"]},
        "1116": {"vr": "SH", "Value": ["SP H12.2"]},
        "1117": {"vr": "SH", "Value": ["SP F32.8"]},
        "1118": {"vr": "SH", "Value": ["SP H4.7"]},
        "1119": {"vr": "SH", "Value": ["SP H37.2"]},
        "1120": {"vr": "SH", "Value": ["SP F57.8"]},
        "1121": {"vr": "SH", "Value": ["SP H72.2"]},
        "1122": {"vr": "SH", "Value": ["SP H52.2"]},
        "1123": {"vr": "SH", "Value": ["SP F50.3"]},
        "1124": {"vr": "SH", "Value": ["SP H57.2"]},
        "1125": {"vr": "SH", "Value": ["SP F27.8"]},
        "1126": {"vr": "SH", "Value": ["SP F12.8"]},
        "1127": {"vr": "SH", "Value": ["SP F57.8"]},
        "1128": {"vr": "SH", "Value": ["SP F15.3"]},
        "1129": {"vr": "SH", "Value": ["SP F20.3"]},
        "1130": {"vr": "SH", "Value": ["SP F15.3"]},
        "1131": {"vr": "SH", "Value": ["SP H52.2"]},
        "1132": {"vr": "SH", "Value": ["SP F17.8"]},
        "1133": {"vr": "SH", "Value": ["SP H49.7"]},
        "1134": {"vr": "SH", "Value": ["SP F70.3"]},
        "1135": {"vr": "SH", "Value": ["SP F40.3"]},
        "1136": {"vr": "SH", "Value": ["SP F42.8"]},
        "1137": {"vr": "SH", "Value": ["SP H74.7"]},
        "1138": {"vr": "SH", "Value": ["SP F32.8"]},
        "1139": {"vr": "SH", "Value": ["SP H29.7"]},
        "1140": {"vr": "SH", "Value": ["SP H37.2"]},
        "1141": {"vr": "SH", "Value": ["SP H37.2"]},
        "1142": {"vr": "SH", "Value": ["SP H47.2"]},
        "1143": {"vr": "SH", "Value": ["SP F42.8"]},
        "1144": {"vr": "SH", "Value": ["SP F55.3"]},
        "1145": {"vr": "SH", "Value": ["SP H7.2"]},
        "1146": {"vr": "SH", "Value": ["SP F47.8"]},
        "1147": {"vr": "SH", "Value": ["SP F37.8"]},
        "1148": {"vr": "SH", "Value": ["SP H2.2"]},
        "1149": {"vr": "SH", "Value": ["SP H19.7"]},
        "1150": {"vr": "SH", "Value": ["SP H69.7"]},
        "1151": {"vr": "SH", "Value": ["SP F70.3"]},
        "1152": {"vr": "SH", "Value": ["SP H37.2"]},
        "1153": {"vr": "SH", "Value": ["SP F12.8"]},
        "1154": {"vr": "SH", "Value": ["SP H2.2"]},
        "1155": {"vr": "SH", "Value": ["SP F30.3"]},
        "1156": {"vr": "SH", "Value": ["SP F37.8"]},
        "1157": {"vr": "SH", "Value": ["SP F17.8"]},
        "1158": {"vr": "SH", "Value": ["SP F35.3"]},
        "1159": {"vr": "SH", "Value": ["SP H24.7"]},
        "1160": {"vr": "SH", "Value": ["SP F32.8"]},
        "1161": {"vr": "SH", "Value": ["SP H4.7"]},
        "1162": {"vr": "SH", "Value": ["SP F72.8"]},
        "1163": {"vr": "SH", "Value": ["SP H57.2"]},
        "1164": {"vr": "SH", "Value": ["SP H59.7"]},
        "1165": {"vr": "SH", "Value": ["SP F12.8"]},
        "1166": {"vr": "SH", "Value": ["SP H7.2"]},
        "1167": {"vr": "SH", "Value": ["SP H44.7"]},
        "1168": {"vr": "SH", "Value": ["SP H57.2"]},
        "1169": {"vr": "SH", "Value": ["SP F47.8"]},
        "1170": {"vr": "SH", "Value": ["SP H54.7"]},
        "1171": {"vr": "SH", "Value": ["SP F57.8"]},
        "1172": {"vr": "SH", "Value": ["SP H24.7"]},
        "1173": {"vr": "SH", "Value": ["SP H4.7"]},
        "1174": {"vr": "SH", "Value": ["SP F42.8"]},
        "1175": {"vr": "SH", "Value": ["SP F55.3"]},
        "1176": {"vr": "SH", "Value": ["SP H9.7"]},
        "1177": {"vr": "SH", "Value": ["SP H49.7"]},
        "1178": {"vr": "SH", "Value": ["SP H57.2"]},
        "1179": {"vr": "SH", "Value": ["SP H14.7"]},
        "1180": {"vr": "SH", "Value": ["SP H62.2"]},
        "1181": {"vr": "SH", "Value": ["SP H67.2"]},
        "1182": {"vr": "SH", "Value": ["SP H59.7"]},
        "1183": {"vr": "SH", "Value": ["SP F2.8"]},
        "1184": {"vr": "SH", "Value": ["SP H34.7"]},
        "1185": {"vr": "SH", "Value": ["SP H49.7"]},
        "1186": {"vr": "SH", "Value": ["SP F55.3"]},
        "1187": {"vr": "SH", "Value": ["SP H47.2"]},
        "1188": {"vr": "SH", "Value": ["SP F7.8"]},
        "1189": {"vr": "SH", "Value": ["SP F5.3"]},
        "1190": {"vr": "SH", "Value": ["SP F57.8"]},
        "1191": {"vr": "SH", "Value": ["SP F12.8"]},
        "1192": {"vr": "SH", "Value": ["SP H39.7"]},
        "1193": {"vr": "SH", "Value": ["SP F62.8"]},
        "1194": {"vr": "SH", "Value": ["SP F47.8"]},
        "1195": {"vr": "SH", "Value": ["SP F10.3"]},
        "1196": {"vr": "SH", "Value": ["SP H52.2"]},
        "1197": {"vr": "SH", "Value": ["SP H27.2"]},
        "1198": {"vr": "SH", "Value": ["SP F60.3"]},
        "1199": {"vr": "SH", "Value": ["SP H4.7"]},
        "1200": {"vr": "SH", "Value": ["SP F10.3"]},
        "1201": {"vr": "SH", "Value": ["SP H64.7"]},
        "1202": {"vr": "SH", "Value": ["SP H69.7"]},
        "1203": {"vr": "SH", "Value": ["SP F52.8"]},
        "1204": {"vr": "SH", "Value": ["SP F2.8"]},
        "1205": {"vr": "SH", "Value": ["SP F57.8"]},
        "1206": {"vr": "SH", "Value": ["SP F2.8"]},
        "1207": {"vr": "SH", "Value": ["SP H67.2"]},
        "1208": {"vr": "SH", "Value": ["SP H39.7"]},
        "1209": {"vr": "SH", "Value": ["SP H64.7"]},
        "1210": {"vr": "SH", "Value": ["SP F37.8"]},
        "1211": {"vr": "SH", "Value": ["SP F20.3"]},
        "1212": {"vr": "SH", "Value": ["SP H32.2"]},
        "1213": {"vr": "SH", "Value": ["SP H12.2"]},
        "1214": {"vr": "SH", "Value": ["SP H57.2"]},
        "1215": {"vr": "SH", "Value": ["SP F12.8"]},
        "1216": {"vr": "SH", "Value": ["SP H69.7"]},
        "1217": {"vr": "SH", "Value": ["SP F62.8"]},
        "1218": {"vr": "SH", "Value": ["SP F70.3"]},
        "1219": {"vr": "SH", "Value": ["SP H4.7"]},
        "1220": {"vr": "SH", "Value": ["SP H12.2"]},
        "1221": {"vr": "SH", "Value": ["SP F5.3"]},
        "1222": {"vr": "SH", "Value": ["SP F37.8"]},
        "1223": {"vr": "SH", "Value": ["SP F72.8"]},
        "1224": {"vr": "SH", "Value": ["SP H42.2"]},
        "1225": {"vr": "SH", "Value": ["SP F15.3"]},
        "1226": {"vr": "SH", "Value": ["SP F45.3"]},
        "1227": {"vr": "SH", "Value": ["SP F62.8"]},
        "1228": {"vr": "SH", "Value": ["SP F50.3"]},
        "1229": {"vr": "SH", "Value": ["SP F57.8"]},
        "1230": {"vr": "SH", "Value": ["SP F2.8"]},
        "1231": {"vr": "SH", "Value": ["SP F70.3"]},
        "1232": {"vr": "SH", "Value": ["SP H54.7"]},
        "1233": {"vr": "SH", "Value": ["SP H2.2"]},
        "1234": {"vr": "SH", "Value": ["SP F5.3"]},
        "1235": {"vr": "SH", "Value": ["SP H34.7"]},
        "1236": {"vr": "SH", "Value": ["SP H47.2"]},
        "1237": {"vr": "SH", "Value": ["SP F50.3"]},
        "1238": {"vr": "SH", "Value": ["SP H19.7"]},
        "1239": {"vr": "SH", "Value": ["SP F65.3"]},
        "1240": {"vr": "SH", "Value": ["SP H54.7"]},
        "1241": {"vr": "SH", "Value": ["SP H64.7"]},
        "1242": {"vr": "SH", "Value": ["SP F17.8"]},
        "1243": {"vr": "SH", "Value": ["SP F20.3"]},
        "1244": {"vr": "SH", "Value": ["SP F32.8"]},
        "1245": {"vr": "SH", "Value": ["SP F25.3"]},
        "1246": {"vr": "SH", "Value": ["SP F35.3"]},
        "1247": {"vr": "SH", "Value": ["SP H29.7"]},
        "1248": {"vr": "SH", "Value": ["SP H49.7"]},
        "1249": {"vr": "SH", "Value": ["SP F65.3"]},
        "1250": {"vr": "SH", "Value": ["SP F72.8"]},
        "1251": {"vr": "SH", "Value": ["SP F10.3"]},
        "1252": {"vr": "SH", "Value": ["SP H34.7"]},
        "1253": {"vr": "SH", "Value": ["SP F27.8"]},
        "1254": {"vr": "SH", "Value": ["SP F45.3"]},
        "1255": {"vr": "SH", "Value": ["SP F37.8"]},
        "1256": {"vr": "SH", "Value": ["SP F65.3"]},
        "1257": {"vr": "SH", "Value": ["SP H27.2"]},
        "1258": {"vr": "SH", "Value": ["SP H24.7"]},
        "1259": {"vr": "SH", "Value": ["SP H39.7"]},
        "1260": {"vr": "SH", "Value": ["SP F55.3"]},
        "1261": {"vr": "SH", "Value": ["SP H72.2"]},
        "1262": {"vr": "SH", "Value": ["SP F20.3"]},
        "1263": {"vr": "SH", "Value": ["SP H19.7"]},
        "1264": {"vr": "SH", "Value": ["SP H12.2"]},
        "1265": {"vr": "SH", "Value": ["SP F45.3"]},
        "1266": {"vr": "SH", "Value": ["SP F27.8"]},
        "1267": {"vr": "SH", "Value": ["SP H39.7"]},
        "1268": {"vr": "SH", "Value": ["SP F65.3"]},
        "1269": {"vr": "SH", "Value": ["SP H72.2"]},
        "1270": {"vr": "SH", "Value": ["SP H12.2"]},
        "1271": {"vr": "SH", "Value": ["SP F52.8"]},
        "1272": {"vr": "SH", "Value": ["SP F65.3"]},
        "1273": {"vr": "SH", "Value": ["SP H69.7"]},
        "1274": {"vr": "SH", "Value": ["SP H9.7"]},
        "1275": {"vr": "SH", "Value": ["SP F52.8"]},
        "1276": {"vr": "SH", "Value": ["SP H49.7"]},
        "1277": {"vr": "SH", "Value": ["SP H29.7"]},
        "1278": {"vr": "SH", "Value": ["SP F50.3"]},
        "1279": {"vr": "SH", "Value": ["SP H47.2"]},
        "1280": {"vr": "SH", "Value": ["SP F62.8"]},
        "1281": {"vr": "SH", "Value": ["SP H2.2"]},
        "1282": {"vr": "SH", "Value": ["SP H62.2"]},
        "1283": {"vr": "SH", "Value": ["SP H69.7"]},
        "1284": {"vr": "SH", "Value": ["SP F7.8"]},
        "1285": {"vr": "SH", "Value": ["SP F47.8"]},
        "1286": {"vr": "SH", "Value": ["SP H72.2"]},
        "1287": {"vr": "SH", "Value": ["SP F45.3"]},
        "1288": {"vr": "SH", "Value": ["SP H9.7"]},
        "1289": {"vr": "SH", "Value": ["SP F42.8"]},
        "1290": {"vr": "SH", "Value": ["SP F0.3"]},
        "1291": {"vr": "SH", "Value": ["SP H69.7"]},
        "1292": {"vr": "SH", "Value": ["SP F47.8"]},
        "1293": {"vr": "SH", "Value": ["SP F20.3"]},
        "1294": {"vr": "SH", "Value": ["SP H29.7"]},
        "1295": {"vr": "SH", "Value": ["SP H49.7"]},
        "1296": {"vr": "SH", "Value": ["SP F0.3"]},
        "1297": {"vr": "SH", "Value": ["SP H64.7"]},
        "1298": {"vr": "SH", "Value": ["SP F12.8"]},
        "1299": {"vr": "SH", "Value": ["SP H74.7"]},
        "1300": {"vr": "SH", "Value": ["SP H39.7"]},
        "1301": {"vr": "SH", "Value": ["SP F20.3"]},
        "1302": {"vr": "SH", "Value": ["SP F60.3"]},
        "1303": {"vr": "SH", "Value": ["SP F57.8"]},
        "1304": {"vr": "SH", "Value": ["SP F2.8"]},
        "1305": {"vr": "SH", "Value": ["SP F72.8"]},
        "1306": {"vr": "SH", "Value": ["SP F42.8"]},
        "1307": {"vr": "SH", "Value": ["SP H4.7"]},
        "1308": {"vr": "SH", "Value": ["SP H22.2"]},
        "1309": {"vr": "SH", "Value": ["SP F55.3"]},
        "1310": {"vr": "SH", "Value": ["SP H22.2"]},
        "1311": {"vr": "SH", "Value": ["SP H9.7"]},
        "1312": {"vr": "SH", "Value": ["SP F60.3"]},
        "1313": {"vr": "SH", "Value": ["SP F22.8"]},
        "1314": {"vr": "SH", "Value": ["SP F42.8"]},
        "1315": {"vr": "SH", "Value": ["SP H47.2"]},
        "1316": {"vr": "SH", "Value": ["SP H24.7"]},
        "1317": {"vr": "SH", "Value": ["SP H24.7"]},
        "1318": {"vr": "SH", "Value": ["SP F50.3"]},
        "1319": {"vr": "SH", "Value": ["SP H4.7"]},
        "1320": {"vr": "SH", "Value": ["SP H42.2"]},
        "1321": {"vr": "SH", "Value": ["SP H24.7"]},
        "1322": {"vr": "SH", "Value": ["SP H62.2"]},
        "1323": {"vr": "SH", "Value": ["SP F2.8"]},
        "1324": {"vr": "SH", "Value": ["SP F25.3"]},
        "1325": {"vr": "SH", "Value": ["SP F27.8"]},
        "1326": {"vr": "SH", "Value": ["SP F60.3"]},
        "1327": {"vr": "SH", "Value": ["SP F17.8"]},
        "1328": {"vr": "SH", "Value": ["SP F22.8"]},
        "1329": {"vr": "SH", "Value": ["SP H9.7"]},
        "1330": {"vr": "SH", "Value": ["SP F67.8"]},
        "1331": {"vr": "SH", "Value": ["SP H7.2"]},
        "1332": {"vr": "SH", "Value": ["SP F7.8"]},
        "1333": {"vr": "SH", "Value": ["SP H47.2"]},
        "1334": {"vr": "SH", "Value": ["SP F17.8"]},
        "1335": {"vr": "SH", "Value": ["SP F60.3"]},
        "1336": {"vr": "SH", "Value": ["SP F17.8"]},
        "1337": {"vr": "SH", "Value": ["SP F30.3"]},
        "1338": {"vr": "SH", "Value": ["SP H39.7"]},
        "1339": {"vr": "SH", "Value": ["SP H57.2"]},
        "1340": {"vr": "SH", "Value": ["SP H27.2"]},
        "1341": {"vr": "SH", "Value": ["SP F12.8"]},
        "1342": {"vr": "SH", "Value": ["SP F15.3"]},
        "1343": {"vr": "SH", "Value": ["SP F27.8"]},
        "1344": {"vr": "SH", "Value": ["SP F27.8"]},
        "1345": {"vr": "SH", "Value": ["SP H47.2"]},
        "1346": {"vr": "SH", "Value": ["SP H52.2"]},
        "1347": {"vr": "SH", "Value": ["SP H22.2"]},
        "1348": {"vr": "SH", "Value": ["SP F12.8"]},
        "1349": {"vr": "SH", "Value": ["SP H57.2"]},
        "1350": {"vr": "SH", "Value": ["SP F57.8"]},
        "1351": {"vr": "SH", "Value": ["SP F7.8"]},
        "1352": {"vr": "SH", "Value": ["SP F7.8"]},
        "1353": {"vr": "SH", "Value": ["SP H69.7"]},
        "1354": {"vr": "SH", "Value": ["SP F57.8"]},
        "1355": {"vr": "SH", "Value": ["SP F10.3"]},
        "1356": {"vr": "SH", "Value": ["SP F27.8"]},
        "1357": {"vr": "SH", "Value": ["SP H4.7"]},
        "1358": {"vr": "SH", "Value": ["SP F72.8"]},
        "1359": {"vr": "SH", "Value": ["SP H12.2"]},
        "1360": {"vr": "SH", "Value": ["SP H17.2"]},
        "1361": {"vr": "SH", "Value": ["SP H9.7"]},
        "1362": {"vr": "SH", "Value": ["SP F0.3"]},
        "1363": {"vr": "SH", "Value": ["SP F35.3"]},
        "1364": {"vr": "SH", "Value": ["SP H74.7"]},
        "1365": {"vr": "SH", "Value": ["SP F50.3"]},
        "1366": {"vr": "SH", "Value": ["SP F15.3"]},
        "1367": {"vr": "SH", "Value": ["SP F0.3"]},
        "1368": {"vr": "SH", "Value": ["SP H64.7"]},
        "1369": {"vr": "SH", "Value": ["SP H24.7"]},
        "1370": {"vr": "SH", "Value": ["SP H34.7"]},
        "1371": {"vr": "SH", "Value": ["SP H59.7"]},
        "1372": {"vr": "SH", "Value": ["SP F42.8"]},
        "1373": {"vr": "SH", "Value": ["SP H37.2"]},
        "1374": {"vr": "SH", "Value": ["SP F45.3"]},
        "1375": {"vr": "SH", "Value": ["SP F27.8"]},
        "1376": {"vr": "SH", "Value": ["SP F47.8"]},
        "1377": {"vr": "SH", "Value": ["SP F37.8"]},
        "1378": {"vr": "SH", "Value": ["SP H2.2"]},
        "1379": {"vr": "SH", "Value": ["SP H7.2"]},
        "1380": {"vr": "SH", "Value": ["SP F50.3"]},
        "1381": {"vr": "SH", "Value": ["SP H59.7"]},
        "1382": {"vr": "SH", "Value": ["SP F10.3"]},
        "1383": {"vr": "SH", "Value": ["SP H7.2"]},
        "1384": {"vr": "SH", "Value": ["SP H72.2"]},
        "1385": {"vr": "SH", "Value": ["SP H62.2"]},
        "1386": {"vr": "SH", "Value": ["SP H17.2"]},
        "1387": {"vr": "SH", "Value": ["SP F27.8"]},
        "1388": {"vr": "SH", "Value": ["SP F72.8"]},
        "1389": {"vr": "SH", "Value": ["SP H14.7"]},
        "1390": {"vr": "SH", "Value": ["SP F47.8"]},
        "1391": {"vr": "SH", "Value": ["SP F10.3"]},
        "1392": {"vr": "SH", "Value": ["SP F45.3"]},
        "1393": {"vr": "SH", "Value": ["SP H22.2"]},
        "1394": {"vr": "SH", "Value": ["SP H27.2"]},
        "1395": {"vr": "SH", "Value": ["SP H44.7"]},
        "1396": {"vr": "SH", "Value": ["SP F22.8"]},
        "1397": {"vr": "SH", "Value": ["SP F45.3"]},
        "1398": {"vr": "SH", "Value": ["SP H2.2"]},
        "1399": {"vr": "SH", "Value": ["SP H12.2"]},
        "1400": {"vr": "SH", "Value": ["SP F27.8"]},
        "1401": {"vr": "SH", "Value": ["SP F60.3"]},
        "1402": {"vr": "SH", "Value": ["SP H17.2"]},
        "1403": {"vr": "SH", "Value": ["SP F27.8"]},
        "1404": {"vr": "SH", "Value": ["SP F35.3"]},
        "1405": {"vr": "SH", "Value": ["SP H2.2"]},
        "1406": {"vr": "SH", "Value": ["SP H52.2"]},
        "1407": {"vr": "SH", "Value": ["SP F0.3"]},
        "1408": {"vr": "SH", "Value": ["SP F57.8"]},
        "1409": {"vr": "SH", "Value": ["SP H27.2"]},
        "1410": {"vr": "SH", "Value": ["SP H62.2"]},
        "1411": {"vr": "SH", "Value": ["SP H74.7"]},
        "1412": {"vr": "SH", "Value": ["SP F2.8"]},
        "1413": {"vr": "SH", "Value": ["SP H7.2"]},
        "1414": {"vr": "SH", "Value": ["SP F52.8"]},
        "1415": {"vr": "SH", "Value": ["SP F47.8"]},
        "1416": {"vr": "SH", "Value": ["SP F35.3"]},
        "1417": {"vr": "SH", "Value": ["SP F35.3"]},
        "1418": {"vr": "SH", "Value": ["SP H29.7"]},
        "1419": {"vr": "SH", "Value": ["SP H29.7"]},
        "1420": {"vr": "SH", "Value": ["SP H7.2"]},
        "1421": {"vr": "SH", "Value": ["SP H44.7"]},
        "1422": {"vr": "SH", "Value": ["SP H39.7"]},
        "1423": {"vr": "SH", "Value": ["SP F57.8"]},
        "1424": {"vr": "SH", "Value": ["SP F5.3"]},
        "1425": {"vr": "SH", "Value": ["SP H64.7"]},
        "1426": {"vr": "SH", "Value": ["SP H64.7"]},
        "1427": {"vr": "SH", "Value": ["SP F72.8"]},
        "1428": {"vr": "SH", "Value": ["SP F15.3"]},
        "1429": {"vr": "SH", "Value": ["SP F35.3"]},
        "1430": {"vr": "SH", "Value": ["SP H32.2"]},
        "1431": {"vr": "SH", "Value": ["SP F67.8"]},
        "1432": {"vr": "SH", "Value": ["SP F62.8"]},
        "1433": {"vr": "SH", "Value": ["SP H19.7"]},
        "1434": {"vr": "SH", "Value": ["SP H49.7"]},
        "1435": {"vr": "SH", "Value": ["SP H64.7"]},
        "1436": {"vr": "SH", "Value": ["SP H37.2"]},
        "1437": {"vr": "SH", "Value": ["SP H62.2"]},
        "1438": {"vr": "SH", "Value": ["SP F72.8"]},
        "1439": {"vr": "SH", "Value": ["SP H22.2"]},
        "1440": {"vr": "SH", "Value": ["SP F37.8"]},
        "1441": {"vr": "SH", "Value": ["SP H64.7"]},
        "1442": {"vr": "SH", "Value": ["SP F50.3"]},
        "1443": {"vr": "SH", "Value": ["SP H9.7"]},
        "1444": {"vr": "SH", "Value": ["SP F17.8"]},
        "1445": {"vr": "SH", "Value": ["SP H52.2"]},
        "1446": {"vr": "SH", "Value": ["SP H37.2"]},
        "1447": {"vr": "SH", "Value": ["SP H59.7"]},
        "1448": {"vr": "SH", "Value": ["SP F62.8"]},
        "1449": {"vr": "SH", "Value": ["SP F40.3"]},
        "1450": {"vr": "SH", "Value": ["SP H52.2"]},
        "1451": {"vr": "SH", "Value": ["SP F30.3"]},
        "1452": {"vr": "SH", "Value": ["SP F5.3"]},
        "1453": {"vr": "SH", "Value": ["SP F60.3"]},
        "1454": {"vr": "SH", "Value": ["SP H24.7"]},
        "1455": {"vr": "SH", "Value": ["SP F42.8"]},
        "1456": {"vr": "SH", "Value": ["SP H12.2"]},
        "1457": {"vr": "SH", "Value": ["SP F32.8"]},
        "1458": {"vr": "SH", "Value": ["SP H72.2"]},
        "1459": {"vr": "SH", "Value": ["SP F40.3"]},
        "1460": {"vr": "SH", "Value": ["SP H69.7"]},
        "1461": {"vr": "SH", "Value": ["SP F12.8"]},
        "1462": {"vr": "SH", "Value": ["SP F12.8"]},
        "1463": {"vr": "SH", "Value": ["SP F5.3"]},
        "1464": {"vr": "SH", "Value": ["SP H49.7"]},
        "1465": {"vr": "SH", "Value": ["SP F10.3"]},
        "1466": {"vr": "SH", "Value": ["SP H67.2"]},
        "1467": {"vr": "SH", "Value": ["SP F5.3"]},
        "1468": {"vr": "SH", "Value": ["SP F60.3"]},
        "1469": {"vr": "SH", "Value": ["SP F5.3"]},
        "1470": {"vr": "SH", "Value": ["SP F7.8"]},
        "1471": {"vr": "SH", "Value": ["SP F50.3"]},
        "1472": {"vr": "SH", "Value": ["SP H22.2"]},
        "1473": {"vr": "SH", "Value": ["SP H4.7"]},
        "1474": {"vr": "SH", "Value": ["SP F52.8"]},
        "1475": {"vr": "SH", "Value": ["SP F52.8"]},
        "1476": {"vr": "SH", "Value": ["SP H47.2"]},
        "1477": {"vr": "SH", "Value": ["SP F0.3"]},
        "1478": {"vr": "SH", "Value": ["SP H54.7"]},
        "1479": {"vr": "SH", "Value": ["SP F60.3"]},
        "1480": {"vr": "SH", "Value": ["SP H37.2"]},
        "1481": {"vr": "SH", "Value": ["SP H62.2"]},
        "1482": {"vr": "SH", "Value": ["SP H17.2"]},
        "1483": {"vr": "SH", "Value": ["SP H12.2"]},
        "1484": {"vr": "SH", "Value": ["SP H2.2"]},
        "1485": {"vr": "SH", "Value": ["SP F67.8"]},
        "1486": {"vr": "SH", "Value": ["SP F35.3"]},
        "1487": {"vr": "SH", "Value": ["SP H27.2"]},
        "1488": {"vr": "SH", "Value": ["SP H49.7"]},
        "1489": {"vr": "SH", "Value": ["SP H54.7"]},
        "1490": {"vr": "SH", "Value": ["SP H7.2"]},
        "1491": {"vr": "SH", "Value": ["SP F30.3"]},
        "1492": {"vr": "SH", "Value": ["SP H22.2"]},
        "1493": {"vr": "SH", "Value": ["SP H64.7"]},
        "1494": {"vr": "SH", "Value": ["SP F45.3"]},
        "1495": {"vr": "SH", "Value": ["SP F37.8"]},
        "1496": {"vr": "SH", "Value": ["SP F55.3"]},
        "1497": {"vr": "SH", "Value": ["SP H59.7"]},
        "1498": {"vr": "SH", "Value": ["SP H37.2"]},
        "1499": {"vr": "SH", "Value": ["SP F45.3"]},
        "1500": {"vr": "SH", "Value": ["SP H29.7"]},
        "1501": {"vr": "SH", "Value": ["SP F62.8"]},
        "1502": {"vr": "SH", "Value": ["SP F50.3"]},
        "1503": {"vr": "SH", "Value": ["SP F47.8"]},
        "1504": {"vr": "SH", "Value": ["SP F47.8"]},
        "1505": {"vr": "SH", "Value": ["SP H62.2"]},
        "1506": {"vr": "SH", "Value": ["SP H44.7"]},
        "1507": {"vr": "SH", "Value": ["SP F22.8"]},
        "1508": {"vr": "SH", "Value": ["SP H34.7"]},
        "1509": {"vr": "SH", "Value": ["SP F45.3"]},
        "1510": {"vr": "SH", "Value": ["SP H27.2"]},
        "1511": {"vr": "SH", "Value": ["SP F55.3"]},
        "1512": {"vr": "SH", "Value": ["SP F62.8"]},
        "1513": {"vr": "SH", "Value": ["SP F30.3"]},
        "1514": {"vr": "SH", "Value": ["SP F60.3"]},
        "1515": {"vr": "SH", "Value": ["SP F10.3"]},
        "1516": {"vr": "SH", "Value": ["SP F15.3"]},
        "1517": {"vr": "SH", "Value": ["SP F7.8"]},
        "1518": {"vr": "SH", "Value": ["SP H47.2"]},
        "1519": {"vr": "SH", "Value": ["SP F37.8"]},
        "1520": {"vr": "SH", "Value": ["SP F57.8"]},
        "1521": {"vr": "SH", "Value": ["SP H62.2"]},
        "1522": {"vr": "SH", "Value": ["SP F2.8"]},
        "1523": {"vr": "SH", "Value": ["SP F7.8"]},
        "1524": {"vr": "SH", "Value": ["SP H69.7"]},
        "1525": {"vr": "SH", "Value": ["SP F10.3"]},
        "1526": {"vr": "SH", "Value": ["SP H72.2"]},
        "1527": {"vr": "SH", "Value": ["SP F30.3"]},
        "1528": {"vr": "SH", "Value": ["SP F57.8"]},
        "1529": {"vr": "SH", "Value": ["SP H17.2"]},
        "1530": {"vr": "SH", "Value": ["SP F32.8"]},
        "1531": {"vr": "SH", "Value": ["SP F65.3"]},
        "1532": {"vr": "SH", "Value": ["SP F10.3"]},
        "1533": {"vr": "SH", "Value": ["SP F27.8"]},
        "1534": {"vr": "SH", "Value": ["SP H64.7"]},
        "1535": {"vr": "SH", "Value": ["SP F25.3"]},
        "1536": {"vr": "SH", "Value": ["SP H9.7"]},
        "1537": {"vr": "SH", "Value": ["SP F17.8"]},
        "1538": {"vr": "SH", "Value": ["SP H49.7"]},
        "1539": {"vr": "SH", "Value": ["SP H34.7"]},
        "1540": {"vr": "SH", "Value": ["SP F25.3"]},
        "1541": {"vr": "SH", "Value": ["SP H34.7"]},
        "1542": {"vr": "SH", "Value": ["SP F12.8"]},
        "1543": {"vr": "SH", "Value": ["SP H9.7"]},
        "1544": {"vr": "SH", "Value": ["SP H62.2"]},
        "1545": {"vr": "SH", "Value": ["SP F15.3"]},
        "1546": {"vr": "SH", "Value": ["SP F22.8"]},
        "1547": {"vr": "SH", "Value": ["SP F2.8"]},
        "1548": {"vr": "SH", "Value": ["SP H42.2"]},
        "1549": {"vr": "SH", "Value": ["SP F17.8"]},
        "1550": {"vr": "SH", "Value": ["SP F32.8"]},
        "1551": {"vr": "SH", "Value": ["SP H42.2"]},
        "1552": {"vr": "SH", "Value": ["SP H32.2"]},
        "1553": {"vr": "SH", "Value": ["SP H24.7"]},
        "1554": {"vr": "SH", "Value": ["SP F15.3"]},
        "1555": {"vr": "SH", "Value": ["SP F22.8"]},
        "1556": {"vr": "SH", "Value": ["SP F5.3"]},
        "1557": {"vr": "SH", "Value": ["SP H59.7"]},
        "1558": {"vr": "SH", "Value": ["SP H57.2"]},
        "1559": {"vr": "SH", "Value": ["SP H4.7"]},
        "1560": {"vr": "SH", "Value": ["SP F55.3"]},
        "1561": {"vr": "SH", "Value": ["SP H74.7"]},
        "1562": {"vr": "SH", "Value": ["SP F40.3"]},
        "1563": {"vr": "SH", "Value": ["SP H42.2"]},
        "1564": {"vr": "SH", "Value": ["SP H64.7"]},
        "1565": {"vr": "SH", "Value": ["SP H42.2"]},
        "1566": {"vr": "SH", "Value": ["SP F60.3"]},
        "1567": {"vr": "SH", "Value": ["SP F35.3"]},
        "1568": {"vr": "SH", "Value": ["SP F70.3"]},
        "1569": {"vr": "SH", "Value": ["SP H32.2"]},
        "1570": {"vr": "SH", "Value": ["SP F35.3"]},
        "1571": {"vr": "SH", "Value": ["SP H9.7"]},
        "1572": {"vr": "SH", "Value": ["SP F72.8"]},
        "1573": {"vr": "SH", "Value": ["SP F45.3"]},
        "1574": {"vr": "SH", "Value": ["SP H54.7"]},
        "1575": {"vr": "SH", "Value": ["SP H62.2"]},
        "1576": {"vr": "SH", "Value": ["SP H17.2"]},
        "1577": {"vr": "SH", "Value": ["SP H47.2"]},
        "1578": {"vr": "SH", "Value": ["SP F22.8"]},
        "1579": {"vr": "SH", "Value": ["SP H12.2"]},
        "1580": {"vr": "SH", "Value": ["SP F67.8"]},
        "1581": {"vr": "SH", "Value": ["SP H4.7"]},
        "1582": {"vr": "SH", "Value": ["SP F47.8"]},
        "1583": {"vr": "SH", "Value": ["SP H12.2"]},
        "1584": {"vr": "SH", "Value": ["SP F40.3"]},
        "1585": {"vr": "SH", "Value": ["SP H22.2"]},
        "1586": {"vr": "SH", "Value": ["SP F20.3"]},
        "1587": {"vr": "SH", "Value": ["SP H27.2"]},
        "1588": {"vr": "SH", "Value": ["SP H17.2"]},
        "1589": {"vr": "SH", "Value": ["SP F65.3"]},
        "1590": {"vr": "SH", "Value": ["SP H72.2"]},
        "1591": {"vr": "SH", "Value": ["SP F12.8"]},
        "1592": {"vr": "SH", "Value": ["SP H9.7"]},
        "1593": {"vr": "SH", "Value": ["SP H69.7"]},
        "1594": {"vr": "SH", "Value": ["SP H9.7"]},
        "1595": {"vr": "SH", "Value": ["SP F7.8"]},
        "1596": {"vr": "SH", "Value": ["SP F65.3"]},
        "1597": {"vr": "SH", "Value": ["SP F12.8"]},
        "1598": {"vr": "SH", "Value": ["SP H49.7"]},
        "1599": {"vr": "SH", "Value": ["SP F35.3"]},
        "1600": {"vr": "SH", "Value": ["SP H44.7"]},
        "1601": {"vr": "SH", "Value": ["SP H52.2"]},
        "1602": {"vr": "SH", "Value": ["SP H39.7"]},
        "1603": {"vr": "SH", "Value": ["SP H14.7"]},
        "1604": {"vr": "SH", "Value": ["SP H42.2"]},
        "1605": {"vr": "SH", "Value": ["SP H44.7"]},
        "1606": {"vr": "SH", "Value": ["SP H29.7"]},
        "1607": {"vr": "SH", "Value": ["SP H7.2"]},
        "1608": {"vr": "SH", "Value": ["SP F65.3"]},
        "1609": {"vr": "SH", "Value": ["SP F37.8"]},
        "1610": {"vr": "SH", "Value": ["SP H22.2"]},
        "1611": {"vr": "SH", "Value": ["SP H72.2"]},
        "1612": {"vr": "SH", "Value": ["SP H62.2"]},
        "1613": {"vr": "SH", "Value": ["SP H44.7"]},
        "1614": {"vr": "SH", "Value": ["SP F27.8"]},
        "1615": {"vr": "SH", "Value": ["SP H32.2"]},
        "1616": {"vr": "SH", "Value": ["SP F10.3"]},
        "1617": {"vr": "SH", "Value": ["SP F57.8"]},
        "1618": {"vr": "SH", "Value": ["SP F57.8"]},
        "1619": {"vr": "SH", "Value": ["SP H72.2"]},
        "1620": {"vr": "SH", "Value": ["SP F62.8"]},
        "1621": {"vr": "SH", "Value": ["SP F45.3"]},
        "1622": {"vr": "SH", "Value": ["SP F17.8"]},
        "1623": {"vr": "SH", "Value": ["SP H17.2"]},
        "1624": {"vr": "SH", "Value": ["SP H54.7"]},
        "1625": {"vr": "SH", "Value": ["SP F0.3"]},
        "1626": {"vr": "SH", "Value": ["SP H9.7"]},
        "1627": {"vr": "SH", "Value": ["SP H44.7"]},
        "1628": {"vr": "SH", "Value": ["SP F12.8"]},
        "1629": {"vr": "SH", "Value": ["SP F12.8"]},
        "1630": {"vr": "SH", "Value": ["SP H29.7"]},
        "1631": {"vr": "SH", "Value": ["SP F25.3"]},
        "1632": {"vr": "SH", "Value": ["SP F72.8"]},
        "1633": {"vr": "SH", "Value": ["SP F47.8"]},
        "1634": {"vr": "SH", "Value": ["SP H39.7"]},
        "1635": {"vr": "SH", "Value": ["SP F52.8"]},
        "1636": {"vr": "SH", "Value": ["SP H22.2"]},
        "1637": {"vr": "SH", "Value": ["SP F70.3"]},
        "1638": {"vr": "SH", "Value": ["SP F35.3"]},
        "1639": {"vr": "SH", "Value": ["SP H19.7"]},
        "1640": {"vr": "SH", "Value": ["SP H32.2"]},
        "1641": {"vr": "SH", "Value": ["SP H47.2"]},
        "1642": {"vr": "SH", "Value": ["SP F42.8"]},
        "1643": {"vr": "SH", "Value": ["SP H69.7"]},
        "1644": {"vr": "SH", "Value": ["SP F5.3"]},
        "1645": {"vr": "SH", "Value": ["SP H32.2"]},
        "1646": {"vr": "SH", "Value": ["SP H4.7"]},
        "1647": {"vr": "SH", "Value": ["SP F5.3"]},
        "1648": {"vr": "SH", "Value": ["SP H59.7"]},
        "1649": {"vr": "SH", "Value": ["SP H2.2"]},
        "1650": {"vr": "SH", "Value": ["SP F67.8"]},
        "1651": {"vr": "SH", "Value": ["SP H32.2"]},
        "1652": {"vr": "SH", "Value": ["SP H69.7"]},
        "1653": {"vr": "SH", "Value": ["SP F42.8"]},
        "1654": {"vr": "SH", "Value": ["SP H69.7"]},
        "1655": {"vr": "SH", "Value": ["SP F60.3"]},
        "1656": {"vr": "SH", "Value": ["SP H24.7"]},
        "1657": {"vr": "SH", "Value": ["SP H67.2"]},
        "1658": {"vr": "SH", "Value": ["SP H4.7"]},
        "1659": {"vr": "SH", "Value": ["SP F70.3"]},
        "1660": {"vr": "SH", "Value": ["SP H24.7"]},
        "1661": {"vr": "SH", "Value": ["SP H29.7"]},
        "1662": {"vr": "SH", "Value": ["SP H32.2"]},
        "1663": {"vr": "SH", "Value": ["SP F35.3"]},
        "1664": {"vr": "SH", "Value": ["SP H49.7"]},
        "1665": {"vr": "SH", "Value": ["SP H52.2"]},
        "1666": {"vr": "SH", "Value": ["SP H52.2"]},
        "1667": {"vr": "SH", "Value": ["SP H57.2"]},
        "1668": {"vr": "SH", "Value": ["SP H12.2"]},
        "1669": {"vr": "SH", "Value": ["SP H64.7"]},
        "1670": {"vr": "SH", "Value": ["SP H9.7"]},
        "1671": {"vr": "SH", "Value": ["SP H52.2"]},
        "1672": {"vr": "SH", "Value": ["SP F50.3"]},
        "1673": {"vr": "SH", "Value": ["SP H4.7"]},
        "1674": {"vr": "SH", "Value": ["SP H67.2"]},
        "1675": {"vr": "SH", "Value": ["SP F52.8"]},
        "1676": {"vr": "SH", "Value": ["SP H29.7"]},
        "1677": {"vr": "SH", "Value": ["SP F45.3"]},
        "1678": {"vr": "SH", "Value": ["SP F45.3"]},
        "1679": {"vr": "SH", "Value": ["SP H57.2"]},
        "1680": {"vr": "SH", "Value": ["SP F15.3"]},
        "1681": {"vr": "SH", "Value": ["SP F55.3"]},
        "1682": {"vr": "SH", "Value": ["SP H24.7"]},
        "1683": {"vr": "SH", "Value": ["SP F65.3"]},
        "1684": {"vr": "SH", "Value": ["SP F10.3"]},
        "1685": {"vr": "SH", "Value": ["SP H67.2"]},
        "1686": {"vr": "SH", "Value": ["SP F72.8"]},
        "1687": {"vr": "SH", "Value": ["SP F47.8"]},
        "1688": {"vr": "SH", "Value": ["SP H52.2"]},
        "1689": {"vr": "SH", "Value": ["SP F35.3"]},
        "1690": {"vr": "SH", "Value": ["SP H72.2"]},
        "1691": {"vr": "SH", "Value": ["SP H34.7"]},
        "1692": {"vr": "SH", "Value": ["SP F25.3"]},
        "1693": {"vr": "SH", "Value": ["SP F0.3"]},
        "1694": {"vr": "SH", "Value": ["SP F25.3"]},
        "1695": {"vr": "SH", "Value": ["SP F67.8"]},
        "1696": {"vr": "SH", "Value": ["SP H64.7"]},
        "1697": {"vr": "SH", "Value": ["SP H24.7"]},
        "1698": {"vr": "SH", "Value": ["SP F47.8"]},
        "1699": {"vr": "SH", "Value": ["SP H4.7"]},
        "1700": {"vr": "SH", "Value": ["SP H59.7"]},
        "1701": {"vr": "SH", "Value": ["SP F7.8"]},
        "1702": {"vr": "SH", "Value": ["SP F60.3"]},
        "1703": {"vr": "SH", "Value": ["SP F65.3"]},
        "1704": {"vr": "SH", "Value": ["SP H24.7"]},
        "1705": {"vr": "SH", "Value": ["SP H59.7"]},
        "1706": {"vr": "SH", "Value": ["SP F62.8"]},
        "1707": {"vr": "SH", "Value": ["SP F65.3"]},
        "1708": {"vr": "SH", "Value": ["SP H14.7"]},
        "1709": {"vr": "SH", "Value": ["SP F40.3"]},
        "1710": {"vr": "SH", "Value": ["SP F35.3"]},
        "1711": {"vr": "SH", "Value": ["SP H67.2"]},
        "1712": {"vr": "SH", "Value": ["SP H2.2"]},
        "1713": {"vr": "SH", "Value": ["SP F55.3"]},
        "1714": {"vr": "SH", "Value": ["SP F27.8"]},
        "1715": {"vr": "SH", "Value": ["SP H17.2"]},
        "1716": {"vr": "SH", "Value": ["SP H7.2"]},
        "1717": {"vr": "SH", "Value": ["SP F65.3"]},
        "1718": {"vr": "SH", "Value": ["SP F42.8"]},
        "1719": {"vr": "SH", "Value": ["SP F30.3"]},
        "1720": {"vr": "SH", "Value": ["SP H67.2"]},
        "1721": {"vr": "SH", "Value": ["SP H52.2"]},
        "1722": {"vr": "SH", "Value": ["SP F45.3"]},
        "1723": {"vr": "SH", "Value": ["SP F37.8"]},
        "1724": {"vr": "SH", "Value": ["SP F27.8"]},
        "1725": {"vr": "SH", "Value": ["SP F67.8"]},
        "1726": {"vr": "SH", "Value": ["SP F15.3"]},
        "1727": {"vr": "SH", "Value": ["SP F62.8"]},
        "1728": {"vr": "SH", "Value": ["SP F0.3"]},
        "1729": {"vr": "SH", "Value": ["SP H32.2"]},
        "1730": {"vr": "SH", "Value": ["SP H74.7"]},
        "1731": {"vr": "SH", "Value": ["SP F60.3"]},
        "1732": {"vr": "SH", "Value": ["SP F37.8"]},
        "1733": {"vr": "SH", "Value": ["SP H24.7"]},
        "1734": {"vr": "SH", "Value": ["SP F52.8"]},
        "1735": {"vr": "SH", "Value": ["SP H14.7"]},
        "1736": {"vr": "SH", "Value": ["SP F67.8"]},
        "1737": {"vr": "SH", "Value": ["SP H4.7"]},
        "1738": {"vr": "SH", "Value": ["SP H59.7"]},
        "1739": {"vr": "SH", "Value": ["SP F57.8"]},
        "1740": {"vr": "SH", "Value": ["SP H29.7"]},
        "1741": {"vr": "SH", "Value": ["SP H42.2"]},
        "1742": {"vr": "SH", "Value": ["SP H2.2"]},
        "1743": {"vr": "SH", "Value": ["SP H39.7"]},
        "1744": {"vr": "SH", "Value": ["SP H59.7"]},
        "1745": {"vr": "SH", "Value": ["SP F67.8"]},
        "1746": {"vr": "SH", "Value": ["SP H7.2"]},
        "1747": {"vr": "SH", "Value": ["SP F2.8"]},
        "1748": {"vr": "SH", "Value": ["SP H22.2"]},
        "1749": {"vr": "SH", "Value": ["SP F70.3"]},
        "1750": {"vr": "SH", "Value": ["SP H49.7"]},
        "1751": {"vr": "SH", "Value": ["SP F47.8"]},
        "1752": {"vr": "SH", "Value": ["SP F20.3"]},
        "1753": {"vr": "SH", "Value": ["SP H27.2"]},
        "1754": {"vr": "SH", "Value": ["SP F5.3"]},
        "1755": {"vr": "SH", "Value": ["SP H29.7"]},
        "1756": {"vr": "SH", "Value": ["SP H29.7"]},
        "1757": {"vr": "SH", "Value": ["SP F47.8"]},
        "1758": {"vr": "SH", "Value": ["SP H39.7"]},
        "1759": {"vr": "SH", "Value": ["SP H59.7"]},
        "1760": {"vr": "SH", "Value": ["SP F32.8"]},
        "1761": {"vr": "SH", "Value": ["SP F67.8"]},
        "1762": {"vr": "SH", "Value": ["SP H9.7"]},
        "1763": {"vr": "SH", "Value": ["SP F30.3"]},
        "1764": {"vr": "SH", "Value": ["SP H2.2"]},
        "1765": {"vr": "SH", "Value": ["SP H67.2"]},
        "1766": {"vr": "SH", "Value": ["SP F37.8"]},
        "1767": {"vr": "SH", "Value": ["SP F10.3"]},
        "1768": {"vr": "SH", "Value": ["SP F12.8"]},
        "1769": {"vr": "SH", "Value": ["SP F15.3"]},
        "1770": {"vr": "SH", "Value": ["SP F60.3"]},
        "1771": {"vr": "SH", "Value": ["SP F52.8"]},
        "1772": {"vr": "SH", "Value": ["SP H44.7"]},
        "1773": {"vr": "SH", "Value": ["SP F60.3"]},
        "1774": {"vr": "SH", "Value": ["SP H47.2"]},
        "1775": {"vr": "SH", "Value": ["SP F5.3"]},
        "1776": {"vr": "SH", "Value": ["SP F32.8"]},
        "1777": {"vr": "SH", "Value": ["SP H57.2"]},
        "1778": {"vr": "SH", "Value": ["SP H62.2"]},
        "1779": {"vr": "SH", "Value": ["SP H72.2"]},
        "1780": {"vr": "SH", "Value": ["SP H14.7"]},
        "1781": {"vr": "SH", "Value": ["SP F42.8"]},
        "1782": {"vr": "SH", "Value": ["SP F25.3"]},
        "1783": {"vr": "SH", "Value": ["SP F50.3"]},
        "1784": {"vr": "SH", "Value": ["SP F25.3"]},
        "1785": {"vr": "SH", "Value": ["SP F32.8"]},
        "1786": {"vr": "SH", "Value": ["SP F50.3"]},
        "1787": {"vr": "SH", "Value": ["SP F52.8"]},
        "1788": {"vr": "SH", "Value": ["SP H37.2"]},
        "1789": {"vr": "SH", "Value": ["SP F62.8"]},
        "1790": {"vr": "SH", "Value": ["SP F72.8"]},
        "1791": {"vr": "SH", "Value": ["SP H29.7"]},
        "1792": {"vr": "SH", "Value": ["SP F15.3"]},
        "1793": {"vr": "SH", "Value": ["SP F50.3"]},
        "1794": {"vr": "SH", "Value": ["SP H7.2"]},
        "1795": {"vr": "SH", "Value": ["SP H9.7"]},
        "1796": {"vr": "SH", "Value": ["SP H29.7"]},
        "1797": {"vr": "SH", "Value": ["SP H57.2"]},
        "1798": {"vr": "SH", "Value": ["SP H2.2"]},
        "1799": {"vr": "SH", "Value": ["SP H4.7"]},
        "1800": {"vr": "SH", "Value": ["SP H44.7"]},
        "1801": {"vr": "SH", "Value": ["SP F45.3"]},
        "1802": {"vr": "SH", "Value": ["SP F30.3"]},
        "1803": {"vr": "SH", "Value": ["SP H54.7"]},
        "1804": {"vr": "SH", "Value": ["SP H64.7"]},
        "1805": {"vr": "SH", "Value": ["SP H22.2"]},
        "1806": {"vr": "SH", "Value": ["SP H74.7"]},
        "1807": {"vr": "SH", "Value": ["SP F27.8"]},
        "1808": {"vr": "SH", "Value": ["SP H52.2"]},
        "1809": {"vr": "SH", "Value": ["SP H62.2"]},
        "1810": {"vr": "SH", "Value": ["SP H64.7"]},
        "1811": {"vr": "SH", "Value": ["SP H42.2"]},
        "1812": {"vr": "SH", "Value": ["SP F37.8"]},
        "1813": {"vr": "SH", "Value": ["SP H14.7"]},
        "1814": {"vr": "SH", "Value": ["SP F7.8"]},
        "1815": {"vr": "SH", "Value": ["SP F27.8"]},
        "1816": {"vr": "SH", "Value": ["SP H62.2"]},
        "1817": {"vr": "SH", "Value": ["SP F62.8"]},
        "1818": {"vr": "SH", "Value": ["SP F22.8"]},
        "1819": {"vr": "SH", "Value": ["SP H52.2"]},
        "1820": {"vr": "SH", "Value": ["SP F30.3"]},
        "1821": {"vr": "SH", "Value": ["SP H72.2"]},
        "1822": {"vr": "SH", "Value": ["SP F72.8"]},
        "1823": {"vr": "SH", "Value": ["SP H32.2"]},
        "1824": {"vr": "SH", "Value": ["SP H54.7"]},
        "1825": {"vr": "SH", "Value": ["SP H22.2"]},
        "1826": {"vr": "SH", "Value": ["SP F72.8"]},
        "1827": {"vr": "SH", "Value": ["SP H17.2"]},
        "1828": {"vr": "SH", "Value": ["SP H52.2"]},
        "1829": {"vr": "SH", "Value": ["SP F65.3"]},
        "1830": {"vr": "SH", "Value": ["SP F0.3"]},
        "1831": {"vr": "SH", "Value": ["SP H49.7"]},
        "1832": {"vr": "SH", "Value": ["SP H59.7"]},
        "1833": {"vr": "SH", "Value": ["SP F0.3"]},
        "1834": {"vr": "SH", "Value": ["SP F22.8"]},
        "1835": {"vr": "SH", "Value": ["SP H39.7"]},
        "1836": {"vr": "SH", "Value": ["SP H14.7"]},
        "1837": {"vr": "SH", "Value": ["SP H42.2"]},
        "1838": {"vr": "SH", "Value": ["SP H57.2"]},
        "1839": {"vr": "SH", "Value": ["SP F10.3"]},
        "1840": {"vr": "SH", "Value": ["SP F57.8"]},
        "1841": {"vr": "SH", "Value": ["SP H19.7"]},
        "1842": {"vr": "SH", "Value": ["SP H37.2"]},
        "1843": {"vr": "SH", "Value": ["SP H39.7"]},
        "1844": {"vr": "SH", "Value": ["SP H47.2"]},
        "1845": {"vr": "SH", "Value": ["SP F70.3"]},
        "1846": {"vr": "SH", "Value": ["SP F27.8"]},
        "1847": {"vr": "SH", "Value": ["SP H62.2"]},
        "1848": {"vr": "SH", "Value": ["SP H39.7"]},
        "1849": {"vr": "SH", "Value": ["SP H47.2"]},
        "1850": {"vr": "SH", "Value": ["SP F10.3"]},
        "1851": {"vr": "SH", "Value": ["SP F65.3"]},
        "1852": {"vr": "SH", "Value": ["SP H54.7"]},
        "1853": {"vr": "SH", "Value": ["SP F32.8"]},
        "1854": {"vr": "SH", "Value": ["SP F42.8"]},
        "1855": {"vr": "SH", "Value": ["SP F12.8"]},
        "1856": {"vr": "SH", "Value": ["SP F5.3"]},
        "1857": {"vr": "SH", "Value": ["SP F70.3"]},
        "1858": {"vr": "SH", "Value": ["SP H7.2"]},
        "1859": {"vr": "SH", "Value": ["SP F0.3"]},
        "1860": {"vr": "SH", "Value": ["SP H22.2"]},
        "1861": {"vr": "SH", "Value": ["SP H54.7"]},
        "1862": {"vr": "SH", "Value": ["SP F40.3"]},
        "1863": {"vr": "SH", "Value": ["SP H24.7"]},
        "1864": {"vr": "SH", "Value": ["SP H49.7"]},
        "1865": {"vr": "SH", "Value": ["SP H52.2"]},
        "1866": {"vr": "SH", "Value": ["SP H7.2"]},
        "1867": {"vr": "SH", "Value": ["SP H52.2"]},
        "1868": {"vr": "SH", "Value": ["SP F72.8"]},
        "1869": {"vr": "SH", "Value": ["SP F7.8"]},
        "1870": {"vr": "SH", "Value": ["SP H32.2"]},
        "1871": {"vr": "SH", "Value": ["SP H9.7"]},
        "1872": {"vr": "SH", "Value": ["SP F7.8"]},
        "1873": {"vr": "SH", "Value": ["SP F62.8"]},
        "1874": {"vr": "SH", "Value": ["SP F35.3"]},
        "1875": {"vr": "SH", "Value": ["SP H62.2"]},
        "1876": {"vr": "SH", "Value": ["SP F17.8"]},
        "1877": {"vr": "SH", "Value": ["SP F55.3"]},
        "1878": {"vr": "SH", "Value": ["SP H59.7"]},
        "1879": {"vr": "SH", "Value": ["SP H44.7"]},
        "1880": {"vr": "SH", "Value": ["SP F7.8"]},
        "1881": {"vr": "SH", "Value": ["SP H67.2"]},
        "1882": {"vr": "SH", "Value": ["SP F25.3"]},
        "1883": {"vr": "SH", "Value": ["SP H72.2"]},
        "1884": {"vr": "SH", "Value": ["SP F10.3"]},
        "1885": {"vr": "SH", "Value": ["SP H57.2"]},
        "1886": {"vr": "SH", "Value": ["SP F15.3"]},
        "1887": {"vr": "SH", "Value": ["SP H59.7"]},
        "1888": {"vr": "SH", "Value": ["SP H14.7"]},
        "1889": {"vr": "SH", "Value": ["SP F25.3"]},
        "1890": {"vr": "SH", "Value": ["SP F15.3"]},
        "1891": {"vr": "SH", "Value": ["SP H69.7"]},
        "1892": {"vr": "SH", "Value": ["SP H74.7"]},
        "1893": {"vr": "SH", "Value": ["SP F45.3"]},
        "1894": {"vr": "SH", "Value": ["SP F50.3"]},
        "1895": {"vr": "SH", "Value": ["SP F67.8"]},
        "1896": {"vr": "SH", "Value": ["SP H22.2"]},
        "1897": {"vr": "SH", "Value": ["SP F47.8"]},
        "1898": {"vr": "SH", "Value": ["SP H52.2"]},
        "1899": {"vr": "SH", "Value": ["SP H42.2"]},
        "1900": {"vr": "SH", "Value": ["SP F60.3"]},
        "1901": {"vr": "SH", "Value": ["SP H7.2"]},
        "1902": {"vr": "SH", "Value": ["SP F45.3"]},
        "1903": {"vr": "SH", "Value": ["SP F17.8"]},
        "1904": {"vr": "SH", "Value": ["SP H59.7"]},
        "1905": {"vr": "SH", "Value": ["SP H39.7"]},
        "1906": {"vr": "SH", "Value": ["SP H69.7"]},
        "1907": {"vr": "SH", "Value": ["SP F40.3"]},
        "1908": {"vr": "SH", "Value": ["SP H19.7"]},
        "1909": {"vr": "SH", "Value": ["SP F2.8"]},
        "1910": {"vr": "SH", "Value": ["SP F20.3"]},
        "1911": {"vr": "SH", "Value": ["SP F5.3"]},
        "1912": {"vr": "SH", "Value": ["SP F67.8"]},
        "1913": {"vr": "SH", "Value": ["SP H2.2"]},
        "1914": {"vr": "SH", "Value": ["SP F22.8"]},
        "1915": {"vr": "SH", "Value": ["SP H47.2"]},
        "1916": {"vr": "SH", "Value": ["SP H7.2"]},
        "1917": {"vr": "SH", "Value": ["SP F40.3"]},
        "1918": {"vr": "SH", "Value": ["SP F47.8"]},
        "1919": {"vr": "SH", "Value": ["SP H74.7"]},
        "1920": {"vr": "SH", "Value": ["SP F62.8"]},
        "1921": {"vr": "SH", "Value": ["SP F55.3"]},
        "1922": {"vr": "SH", "Value": ["SP H44.7"]},
        "1923": {"vr": "SH", "Value": ["SP H12.2"]},
        "1924": {"vr": "SH", "Value": ["SP H54.7"]},
        "1925": {"vr": "SH", "Value": ["SP F22.8"]},
        "1926": {"vr": "SH", "Value": ["SP H17.2"]},
        "1927": {"vr": "SH", "Value": ["SP H74.7"]},
        "1928": {"vr": "SH", "Value": ["SP H54.7"]},
        "1929": {"vr": "SH", "Value": ["SP F15.3"]},
        "1930": {"vr": "SH", "Value": ["SP F55.3"]},
        "1931": {"vr": "SH", "Value": ["SP F25.3"]},
        "1932": {"vr": "SH", "Value": ["SP F50.3"]},
        "1933": {"vr": "SH", "Value": ["SP H7.2"]},
        "1934": {"vr": "SH", "Value": ["SP H67.2"]},
        "1935": {"vr": "SH", "Value": ["SP H37.2"]},
        "1936": {"vr": "SH", "Value": ["SP H57.2"]},
        "1937": {"vr": "SH", "Value": ["SP H32.2"]},
        "1938": {"vr": "SH", "Value": ["SP F22.8"]},
        "1939": {"vr": "SH", "Value": ["SP F40.3"]},
        "1940": {"vr": "SH", "Value": ["SP H62.2"]},
        "1941": {"vr": "SH", "Value": ["SP H9.7"]},
        "1942": {"vr": "SH", "Value": ["SP H12.2"]},
        "1943": {"vr": "SH", "Value": ["SP F50.3"]},
        "1944": {"vr": "SH", "Value": ["SP H32.2"]},
        "1945": {"vr": "SH", "Value": ["SP F47.8"]},
        "1946": {"vr": "SH", "Value": ["SP F35.3"]},
        "1947": {"vr": "SH", "Value": ["SP H2.2"]},
        "1948": {"vr": "SH", "Value": ["SP H47.2"]},
        "1949": {"vr": "SH", "Value": ["SP F7.8"]},
        "1950": {"vr": "SH", "Value": ["SP F60.3"]},
        "1951": {"vr": "SH", "Value": ["SP F7.8"]},
        "1952": {"vr": "SH", "Value": ["SP F55.3"]},
        "1953": {"vr": "SH", "Value": ["SP H52.2"]},
        "1954": {"vr": "SH", "Value": ["SP H17.2"]},
        "1955": {"vr": "SH", "Value": ["SP H14.7"]},
        "1956": {"vr": "SH", "Value": ["SP H34.7"]},
        "1957": {"vr": "SH", "Value": ["SP H19.7"]},
        "1958": {"vr": "SH", "Value": ["SP H72.2"]},
        "1959": {"vr": "SH", "Value": ["SP F0.3"]},
        "1960": {"vr": "SH", "Value": ["SP H52.2"]},
        "1961": {"vr": "SH", "Value": ["SP F5.3"]},
        "1962": {"vr": "SH", "Value": ["SP F32.8"]},
        "1963": {"vr": "SH", "Value": ["SP H22.2"]},
        "1964": {"vr": "SH", "Value": ["SP F22.8"]},
        "1965": {"vr": "SH", "Value": ["SP F22.8"]},
        "1966": {"vr": "SH", "Value": ["SP F0.3"]},
        "1967": {"vr": "SH", "Value": ["SP F72.8"]},
        "1968": {"vr": "SH", "Value": ["SP F67.8"]},
        "1969": {"vr": "SH", "Value": ["SP H44.7"]},
        "1970": {"vr": "SH", "Value": ["SP H34.7"]},
        "1971": {"vr": "SH", "Value": ["SP H7.2"]},
        "1972": {"vr": "SH", "Value": ["SP F12.8"]},
        "1973": {"vr": "SH", "Value": ["SP F45.3"]},
        "1974": {"vr": "SH", "Value": ["SP H47.2"]},
        "1975": {"vr": "SH", "Value": ["SP F62.8"]},
        "1976": {"vr": "SH", "Value": ["SP F12.8"]},
        "1977": {"vr": "SH", "Value": ["SP H2.2"]},
        "1978": {"vr": "SH", "Value": ["SP F22.8"]},
        "1979": {"vr": "SH", "Value": ["SP F55.3"]},
        "1980": {"vr": "SH", "Value": ["SP F65.3"]},
        "1981": {"vr": "SH", "Value": ["SP H72.2"]},
        "1982": {"vr": "SH", "Value": ["SP H32.2"]},
        "1983": {"vr": "SH", "Value": ["SP H49.7"]},
        "1984": {"vr": "SH", "Value": ["SP F17.8"]},
        "1985": {"vr": "SH", "Value": ["SP H34.7"]},
        "1986": {"vr": "SH", "Value": ["SP H72.2"]},
        "1987": {"vr": "SH", "Value": ["SP F12.8"]},
        "1988": {"vr": "SH", "Value": ["SP F30.3"]},
        "1989": {"vr": "SH", "Value": ["SP F72.8"]},
        "1990": {"vr": "SH", "Value": ["SP H12.2"]},
        "1991": {"vr": "SH", "Value": ["SP H32.2"]},
        "1992": {"vr": "SH", "Value": ["SP H57.2"]},
        "1993": {"vr": "SH", "Value": ["SP F7.8"]},
        "1994": {"vr": "SH", "Value": ["SP H44.7"]},
        "1995": {"vr": "SH", "Value": ["SP F17.8"]},
        "1996": {"vr": "SH", "Value": ["SP F35.3"]},
        "1997": {"vr": "SH", "Value": ["SP H44.7"]},
        "1998": {"vr": "SH", "Value": ["SP F65.3"]},
        "1999": {"vr": "SH", "Value": ["SP H44.7"]},
        "2000": {"vr": "SH", "Value": ["SP F25.3"]},
        "2001": {"vr": "SH", "Value": ["SP H49.7"]},
        "2002": {"vr": "SH", "Value": ["SP H42.2"]},
        "2003": {"vr": "SH", "Value": ["SP F5.3"]},
        "2004": {"vr": "SH", "Value": ["SP F7.8"]},
        "2005": {"vr": "SH", "Value": ["SP H14.7"]},
        "2006": {"vr": "SH", "Value": ["SP F72.8"]},
        "2007": {"vr": "SH", "Value": ["SP H59.7"]},
        "2008": {"vr": "SH", "Value": ["SP H27.2"]},
        "2009": {"vr": "SH", "Value": ["SP H9.7"]},
        "2010": {"vr": "SH", "Value": ["SP F30.3"]},
        "2011": {"vr": "SH", "Value": ["SP H32.2"]},
        "2012": {"vr": "SH", "Value": ["SP F25.3"]},
        "2013": {"vr": "SH", "Value": ["SP H47.2"]},
        "2014": {"vr": "SH", "Value": ["SP H34.7"]},
        "2015": {"vr": "SH", "Value": ["SP F50.3"]},
        "2016": {"vr": "SH", "Value": ["SP F37.8"]},
        "2017": {"vr": "SH", "Value": ["SP F70.3"]},
        "2018": {"vr": "SH", "Value": ["SP F22.8"]},
        "2019": {"vr": "SH", "Value": ["SP F52.8"]},
        "2020": {"vr": "SH", "Value": ["SP H32.2"]},
        "2021": {"vr": "SH", "Value": ["SP F27.8"]},
        "2022": {"vr": "SH", "Value": ["SP F32.8"]},
        "2023": {"vr": "SH", "Value": ["SP H64.7"]},
        "2024": {"vr": "SH", "Value": ["SP H7.2"]},
        "2025": {"vr": "SH", "Value": ["SP H47.2"]},
        "2026": {"vr": "SH", "Value": ["SP F47.8"]},
        "2027": {"vr": "SH", "Value": ["SP H19.7"]},
        "2028": {"vr": "SH", "Value": ["SP F5.3"]},
        "2029": {"vr": "SH", "Value": ["SP H32.2"]},
        "2030": {"vr": "SH", "Value": ["SP F25.3"]},
        "2031": {"vr": "SH", "Value": ["SP H69.7"]},
        "2032": {"vr": "SH", "Value": ["SP F27.8"]},
        "2033": {"vr": "SH", "Value": ["SP H17.2"]},
        "2034": {"vr": "SH", "Value": ["SP H9.7"]},
        "2035": {"vr": "SH", "Value": ["SP F0.3"]},
        "2036": {"vr": "SH", "Value": ["SP F2.8"]},
        "2037": {"vr": "SH", "Value": ["SP H47.2"]},
        "2038": {"vr": "SH", "Value": ["SP H74.7"]},
        "2039": {"vr": "SH", "Value": ["SP H2.2"]},
        "2040": {"vr": "SH", "Value": ["SP F25.3"]},
        "2041": {"vr": "SH", "Value": ["SP H4.7"]},
        "2042": {"vr": "SH", "Value": ["SP H49.7"]},
        "2043": {"vr": "SH", "Value": ["SP F0.3"]},
        "2044": {"vr": "SH", "Value": ["SP H47.2"]},
        "2045": {"vr": "SH", "Value": ["SP F12.8"]},
        "2046": {"vr": "SH", "Value": ["SP F20.3"]},
        "2047": {"vr": "SH", "Value": ["SP F62.8"]},
        "2048": {"vr": "SH", "Value": ["SP H32.2"]},
        "2049": {"vr": "SH", "Value": ["SP F32.8"]},
        "2050": {"vr": "SH", "Value": ["SP H29.7"]},
        "2051": {"vr": "SH", "Value": ["SP F22.8"]},
        "2052": {"vr": "SH", "Value": ["SP H69.7"]},
        "2053": {"vr": "SH", "Value": ["SP F20.3"]},
        "2054": {"vr": "SH", "Value": ["SP F52.8"]},
        "2055": {"vr": "SH", "Value": ["SP H4.7"]},
        "2056": {"vr": "SH", "Value": ["SP F70.3"]},
        "2057": {"vr": "SH", "Value": ["SP H47.2"]},
        "2058": {"vr": "SH", "Value": ["SP H32.2"]},
        "2059": {"vr": "SH", "Value": ["SP F42.8"]},
        "2060": {"vr": "SH", "Value": ["SP F0.3"]},
        "2061": {"vr": "SH", "Value": ["SP F27.8"]},
        "2062": {"vr": "SH", "Value": ["SP F25.3"]},
        "2063": {"vr": "SH", "Value": ["SP F10.3"]},
        "2064": {"vr": "SH", "Value": ["SP F20.3"]},
        "2065": {"vr": "SH", "Value": ["SP F0.3"]},
        "2066": {"vr": "SH", "Value": ["SP F40.3"]},
        "2067": {"vr": "SH", "Value": ["SP H27.2"]},
        "2068": {"vr": "SH", "Value": ["SP H12.2"]},
        "2069": {"vr": "SH", "Value": ["SP H19.7"]},
        "2070": {"vr": "SH", "Value": ["SP H32.2"]},
        "2071": {"vr": "SH", "Value": ["SP H27.2"]},
        "2072": {"vr": "SH", "Value": ["SP F40.3"]},
        "2073": {"vr": "SH", "Value": ["SP F37.8"]},
        "2074": {"vr": "SH", "Value": ["SP F17.8"]},
        "2075": {"vr": "SH", "Value": ["SP H4.7"]},
        "2076": {"vr": "SH", "Value": ["SP H49.7"]},
        "2077": {"vr": "SH", "Value": ["SP F57.8"]},
        "2078": {"vr": "SH", "Value": ["SP H54.7"]},
        "2079": {"vr": "SH", "Value": ["SP F12.8"]},
        "2080": {"vr": "SH", "Value": ["SP H72.2"]},
        "2081": {"vr": "SH", "Value": ["SP H7.2"]},
        "2082": {"vr": "SH", "Value": ["SP F37.8"]},
        "2083": {"vr": "SH", "Value": ["SP F30.3"]},
        "2084": {"vr": "SH", "Value": ["SP H4.7"]},
        "2085": {"vr": "SH", "Value": ["SP F37.8"]},
        "2086": {"vr": "SH", "Value": ["SP H54.7"]},
        "2087": {"vr": "SH", "Value": ["SP F32.8"]},
        "2088": {"vr": "SH", "Value": ["SP F15.3"]},
        "2089": {"vr": "SH", "Value": ["SP H44.7"]},
        "2090": {"vr": "SH", "Value": ["SP H39.7"]},
        "2091": {"vr": "SH", "Value": ["SP H24.7"]},
        "2092": {"vr": "SH", "Value": ["SP H49.7"]},
        "2093": {"vr": "SH", "Value": ["SP H44.7"]},
        "2094": {"vr": "SH", "Value": ["SP H59.7"]},
        "2095": {"vr": "SH", "Value": ["SP H27.2"]},
        "2096": {"vr": "SH", "Value": ["SP H24.7"]},
        "2097": {"vr": "SH", "Value": ["SP F12.8"]},
        "2098": {"vr": "SH", "Value": ["SP F30.3"]},
        "2099": {"vr": "SH", "Value": ["SP H52.2"]},
        "2100": {"vr": "SH", "Value": ["SP H62.2"]},
        "2101": {"vr": "SH", "Value": ["SP F57.8"]},
        "2102": {"vr": "SH", "Value": ["SP F17.8"]},
        "2103": {"vr": "SH", "Value": ["SP H19.7"]},
        "2104": {"vr": "SH", "Value": ["SP F65.3"]},
        "2105": {"vr": "SH", "Value": ["SP H2.2"]},
        "2106": {"vr": "SH", "Value": ["SP H74.7"]},
        "2107": {"vr": "SH", "Value": ["SP H39.7"]},
        "2108": {"vr": "SH", "Value": ["SP F72.8"]},
        "2109": {"vr": "SH", "Value": ["SP F60.3"]},
        "2110": {"vr": "SH", "Value": ["SP H42.2"]},
        "2111": {"vr": "SH", "Value": ["SP H9.7"]},
        "2112": {"vr": "SH", "Value": ["SP H72.2"]},
        "2113": {"vr": "SH", "Value": ["SP H22.2"]},
        "2114": {"vr": "SH", "Value": ["SP H64.7"]},
        "2115": {"vr": "SH", "Value": ["SP H69.7"]},
        "2116": {"vr": "SH", "Value": ["SP F50.3"]},
        "2117": {"vr": "SH", "Value": ["SP H37.2"]},
        "2118": {"vr": "SH", "Value": ["SP H12.2"]},
        "2119": {"vr": "SH", "Value": ["SP F70.3"]},
        "2120": {"vr": "SH", "Value": ["SP H69.7"]},
        "2121": {"vr": "SH", "Value": ["SP H19.7"]},
        "2122": {"vr": "SH", "Value": ["SP H34.7"]},
        "2123": {"vr": "SH", "Value": ["SP H52.2"]},
        "2124": {"vr": "SH", "Value": ["SP F47.8"]},
        "2125": {"vr": "SH", "Value": ["SP H17.2"]},
        "2126": {"vr": "SH", "Value": ["SP H7.2"]},
        "2127": {"vr": "SH", "Value": ["SP F20.3"]},
        "2128": {"vr": "SH", "Value": ["SP H44.7"]},
        "2129": {"vr": "SH", "Value": ["SP F20.3"]},
        "2130": {"vr": "SH", "Value": ["SP F30.3"]},
        "2131": {"vr": "SH", "Value": ["SP H4.7"]},
        "2132": {"vr": "SH", "Value": ["SP H2.2"]},
        "2133": {"vr": "SH", "Value": ["SP H57.2"]},
        "2134": {"vr": "SH", "Value": ["SP F10.3"]},
        "2135": {"vr": "SH", "Value": ["SP F47.8"]},
        "2136": {"vr": "SH", "Value": ["SP H44.7"]},
        "2137": {"vr": "SH", "Value": ["SP F50.3"]},
        "2138": {"vr": "SH", "Value": ["SP H4.7"]},
        "2139": {"vr": "SH", "Value": ["SP H54.7"]},
        "2140": {"vr": "SH", "Value": ["SP F70.3"]},
        "2141": {"vr": "SH", "Value": ["SP H24.7"]},
        "2142": {"vr": "SH", "Value": ["SP H32.2"]},
        "2143": {"vr": "SH", "Value": ["SP H22.2"]},
        "2144": {"vr": "SH", "Value": ["SP F27.8"]},
        "2145": {"vr": "SH", "Value": ["SP H27.2"]},
        "2146": {"vr": "SH", "Value": ["SP H24.7"]},
        "2147": {"vr": "SH", "Value": ["SP H54.7"]},
        "2148": {"vr": "SH", "Value": ["SP F62.8"]},
        "2149": {"vr": "SH", "Value": ["SP H17.2"]},
        "2150": {"vr": "SH", "Value": ["SP H17.2"]},
        "2151": {"vr": "SH", "Value": ["SP F72.8"]},
        "2152": {"vr": "SH", "Value": ["SP H32.2"]},
        "2153": {"vr": "SH", "Value": ["SP H57.2"]},
        "2154": {"vr": "SH", "Value": ["SP H12.2"]},
        "2155": {"vr": "SH", "Value": ["SP F30.3"]},
        "2156": {"vr": "SH", "Value": ["SP F17.8"]},
        "2157": {"vr": "SH", "Value": ["SP F25.3"]},
        "2158": {"vr": "SH", "Value": ["SP H14.7"]},
        "2159": {"vr": "SH", "Value": ["SP F42.8"]},
        "2160": {"vr": "SH", "Value": ["SP H52.2"]},
        "2161": {"vr": "SH", "Value": ["SP F12.8"]},
        "2162": {"vr": "SH", "Value": ["SP H34.7"]},
        "2163": {"vr": "SH", "Value": ["SP F5.3"]},
        "2164": {"vr": "SH", "Value": ["SP H17.2"]},
        "2165": {"vr": "SH", "Value": ["SP F65.3"]},
        "2166": {"vr": "SH", "Value": ["SP F35.3"]},
        "2167": {"vr": "SH", "Value": ["SP F45.3"]},
        "2168": {"vr": "SH", "Value": ["SP F70.3"]},
        "2169": {"vr": "SH", "Value": ["SP F25.3"]},
        "2170": {"vr": "SH", "Value": ["SP F2.8"]},
        "2171": {"vr": "SH", "Value": ["SP H22.2"]},
        "2172": {"vr": "SH", "Value": ["SP F37.8"]},
        "2173": {"vr": "SH", "Value": ["SP F37.8"]},
        "2174": {"vr": "SH", "Value": ["SP H52.2"]},
        "2175": {"vr": "SH", "Value": ["SP H22.2"]},
        "2176": {"vr": "SH", "Value": ["SP H62.2"]},
        "2177": {"vr": "SH", "Value": ["SP H7.2"]},
        "2178": {"vr": "SH", "Value": ["SP F72.8"]},
        "2179": {"vr": "SH", "Value": ["SP F37.8"]},
        "2180": {"vr": "SH", "Value": ["SP H34.7"]},
        "2181": {"vr": "SH", "Value": ["SP H44.7"]},
        "2182": {"vr": "SH", "Value": ["SP F0.3"]},
        "2183": {"vr": "SH", "Value": ["SP F20.3"]},
        "2184": {"vr": "SH", "Value": ["SP F47.8"]},
        "2185": {"vr": "SH", "Value": ["SP H59.7"]},
        "2186": {"vr": "SH", "Value": ["SP H59.7"]},
        "2187": {"vr": "SH", "Value": ["SP F70.3"]},
        "2188": {"vr": "SH", "Value": ["SP F10.3"]},
        "2189": {"vr": "SH", "Value": ["SP F12.8"]},
        "2190": {"vr": "SH", "Value": ["SP F32.8"]},
        "2191": {"vr": "SH", "Value": ["SP H64.7"]},
        "2192": {"vr": "SH", "Value": ["SP F50.3"]},
        "2193": {"vr": "SH", "Value": ["SP H57.2"]},
        "2194": {"vr": "SH", "Value": ["SP H49.7"]},
        "2195": {"vr": "SH", "Value": ["SP F22.8"]},
        "2196": {"vr": "SH", "Value": ["SP F2.8"]},
        "2197": {"vr": "SH", "Value": ["SP F0.3"]},
        "2198": {"vr": "SH", "Value": ["SP H59.7"]},
        "2199": {"vr": "SH", "Value": ["SP F52.8"]},
        "2200": {"vr": "SH", "Value": ["SP F50.3"]},
        "2201": {"vr": "SH", "Value": ["SP F70.3"]},
        "2202": {"vr": "SH", "Value": ["SP F70.3"]},
        "2203": {"vr": "SH", "Value": ["SP F30.3"]},
        "2204": {"vr": "SH", "Value": ["SP H34.7"]},
        "2205": {"vr": "SH", "Value": ["SP F35.3"]},
        "2206": {"vr": "SH", "Value": ["SP F50.3"]},
        "2207": {"vr": "SH", "Value": ["SP H12.2"]},
        "2208": {"vr": "SH", "Value": ["SP H29.7"]},
        "2209": {"vr": "SH", "Value": ["SP F42.8"]},
        "2210": {"vr": "SH", "Value": ["SP F42.8"]},
        "2211": {"vr": "SH", "Value": ["SP F70.3"]},
        "2212": {"vr": "SH", "Value": ["SP F25.3"]},
        "2213": {"vr": "SH", "Value": ["SP H47.2"]},
        "2214": {"vr": "SH", "Value": ["SP H12.2"]},
        "2215": {"vr": "SH", "Value": ["SP H12.2"]},
        "2216": {"vr": "SH", "Value": ["SP F30.3"]},
        "2217": {"vr": "SH", "Value": ["SP H19.7"]},
        "2218": {"vr": "SH", "Value": ["SP H9.7"]},
        "2219": {"vr": "SH", "Value": ["SP H59.7"]},
        "2220": {"vr": "SH", "Value": ["SP F32.8"]},
        "2221": {"vr": "SH", "Value": ["SP H59.7"]},
        "2222": {"vr": "SH", "Value": ["SP F25.3"]},
        "2223": {"vr": "SH", "Value": ["SP H52.2"]},
        "2224": {"vr": "SH", "Value": ["SP H37.2"]},
        "2225": {"vr": "SH", "Value": ["SP H72.2"]},
        "2226": {"vr": "SH", "Value": ["SP F42.8"]},
        "2227": {"vr": "SH", "Value": ["SP H17.2"]},
        "2228": {"vr": "SH", "Value": ["SP H27.2"]},
        "2229": {"vr": "SH", "Value": ["SP H72.2"]},
        "2230": {"vr": "SH", "Value": ["SP H67.2"]},
        "2231": {"vr": "SH", "Value": ["SP H74.7"]},
        "2232": {"vr": "SH", "Value": ["SP H14.7"]},
        "2233": {"vr": "SH", "Value": ["SP H12.2"]},
        "2234": {"vr": "SH", "Value": ["SP H29.7"]},
        "2235": {"vr": "SH", "Value": ["SP F5.3"]},
        "2236": {"vr": "SH", "Value": ["SP H49.7"]},
        "2237": {"vr": "SH", "Value": ["SP H12.2"]},
        "2238": {"vr": "SH", "Value": ["SP F70.3"]},
        "2239": {"vr": "SH", "Value": ["SP F17.8"]},
        "2240": {"vr": "SH", "Value": ["SP H24.7"]},
        "2241": {"vr": "SH", "Value": ["SP H62.2"]},
        "2242": {"vr": "SH", "Value": ["SP F12.8"]},
        "2243": {"vr": "SH", "Value": ["SP F45.3"]},
        "2244": {"vr": "SH", "Value": ["SP H24.7"]},
        "2245": {"vr": "SH", "Value": ["SP F7.8"]},
        "2246": {"vr": "SH", "Value": ["SP H44.7"]},
        "2247": {"vr": "SH", "Value": ["SP F72.8"]},
        "2248": {"vr": "SH", "Value": ["SP H34.7"]},
        "2249": {"vr": "SH", "Value": ["SP F55.3"]},
        "2250": {"vr": "SH", "Value": ["SP H67.2"]},
        "2251": {"vr": "SH", "Value": ["SP H24.7"]},
        "2252": {"vr": "SH", "Value": ["SP F67.8"]},
        "2253": {"vr": "SH", "Value": ["SP F25.3"]},
        "2254": {"vr": "SH", "Value": ["SP H32.2"]},
        "2255": {"vr": "SH", "Value": ["SP H59.7"]},
        "2256": {"vr": "SH", "Value": ["SP F60.3"]},
        "2257": {"vr": "SH", "Value": ["SP H52.2"]},
        "2258": {"vr": "SH", "Value": ["SP F15.3"]},
        "2259": {"vr": "SH", "Value": ["SP H19.7"]},
        "2260": {"vr": "SH", "Value": ["SP F65.3"]},
        "2261": {"vr": "SH", "Value": ["SP F15.3"]},
        "2262": {"vr": "SH", "Value": ["SP H54.7"]},
        "2263": {"vr": "SH", "Value": ["SP F57.8"]},
        "2264": {"vr": "SH", "Value": ["SP H39.7"]},
        "2265": {"vr": "SH", "Value": ["SP H12.2"]},
        "2266": {"vr": "SH", "Value": ["SP F32.8"]},
        "2267": {"vr": "SH", "Value": ["SP H69.7"]},
        "2268": {"vr": "SH", "Value": ["SP H67.2"]},
        "2269": {"vr": "SH", "Value": ["SP F60.3"]},
        "2270": {"vr": "SH", "Value": ["SP H44.7"]},
        "2271": {"vr": "SH", "Value": ["SP F5.3"]},
        "2272": {"vr": "SH", "Value": ["SP H49.7"]},
        "2273": {"vr": "SH", "Value": ["SP H54.7"]},
        "2274": {"vr": "SH", "Value": ["SP F2.8"]},
        "2275": {"vr": "SH", "Value": ["SP H27.2"]},
        "2276": {"vr": "SH", "Value": ["SP F57.8"]},
        "2277": {"vr": "SH", "Value": ["SP H54.7"]},
        "2278": {"vr": "SH", "Value": ["SP F52.8"]},
        "2279": {"vr": "SH", "Value": ["SP F35.3"]},
        "2280": {"vr": "SH", "Value": ["SP H49.7"]},
        "2281": {"vr": "SH", "Value": ["SP H69.7"]},
        "2282": {"vr": "SH", "Value": ["SP F32.8"]},
        "2283": {"vr": "SH", "Value": ["SP H32.2"]},
        "2284": {"vr": "SH", "Value": ["SP F62.8"]},
        "2285": {"vr": "SH", "Value": ["SP F40.3"]},
        "2286": {"vr": "SH", "Value": ["SP F10.3"]},
        "2287": {"vr": "SH", "Value": ["SP H74.7"]},
        "2288": {"vr": "SH", "Value": ["SP H54.7"]},
        "2289": {"vr": "SH", "Value": ["SP F32.8"]},
        "2290": {"vr": "SH", "Value": ["SP H19.7"]},
        "2291": {"vr": "SH", "Value": ["SP F22.8"]},
        "2292": {"vr": "SH", "Value": ["SP F0.3"]},
        "2293": {"vr": "SH", "Value": ["SP F2.8"]},
        "2294": {"vr": "SH", "Value": ["SP F0.3"]},
        "2295": {"vr": "SH", "Value": ["SP H59.7"]},
        "2296": {"vr": "SH", "Value": ["SP F50.3"]},
        "2297": {"vr": "SH", "Value": ["SP F17.8"]},
        "2298": {"vr": "SH", "Value": ["SP H69.7"]},
        "2299": {"vr": "SH", "Value": ["SP F72.8"]},
        "2300": {"vr": "SH", "Value": ["SP F12.8"]},
        "2301": {"vr": "SH", "Value": ["SP F27.8"]},
        "2302": {"vr": "SH", "Value": ["SP H27.2"]},
        "2303": {"vr": "SH", "Value": ["SP H29.7"]},
        "2304": {"vr": "SH", "Value": ["SP F10.3"]},
        "2305": {"vr": "SH", "Value": ["SP H59.7"]},
        "2306": {"vr": "SH", "Value": ["SP F65.3"]},
        "2307": {"vr": "SH", "Value": ["SP H42.2"]},
        "2308": {"vr": "SH", "Value": ["SP H54.7"]},
        "2309": {"vr": "SH", "Value": ["SP H54.7"]},
        "2310": {"vr": "SH", "Value": ["SP H49.7"]},
        "2311": {"vr": "SH", "Value": ["SP H44.7"]},
        "2312": {"vr": "SH", "Value": ["SP H57.2"]},
        "2313": {"vr": "SH", "Value": ["SP F45.3"]},
        "2314": {"vr": "SH", "Value": ["SP F72.8"]},
        "2315": {"vr": "SH", "Value": ["SP F67.8"]},
        "2316": {"vr": "SH", "Value": ["SP H7.2"]},
        "2317": {"vr": "SH", "Value": ["SP F0.3"]},
        "2318": {"vr": "SH", "Value": ["SP F72.8"]},
        "2319": {"vr": "SH", "Value": ["SP H22.2"]},
        "2320": {"vr": "SH", "Value": ["SP H52.2"]},
        "2321": {"vr": "SH", "Value": ["SP F45.3"]},
        "2322": {"vr": "SH", "Value": ["SP F27.8"]},
        "2323": {"vr": "SH", "Value": ["SP H24.7"]},
        "2324": {"vr": "SH", "Value": ["SP H49.7"]},
        "2325": {"vr": "SH", "Value": ["SP F35.3"]},
        "2326": {"vr": "SH", "Value": ["SP H42.2"]},
        "2327": {"vr": "SH", "Value": ["SP F67.8"]},
        "2328": {"vr": "SH", "Value": ["SP H29.7"]},
        "2329": {"vr": "SH", "Value": ["SP F72.8"]},
        "2330": {"vr": "SH", "Value": ["SP F35.3"]},
        "2331": {"vr": "SH", "Value": ["SP H9.7"]},
        "2332": {"vr": "SH", "Value": ["SP H54.7"]},
        "2333": {"vr": "SH", "Value": ["SP H27.2"]},
        "2334": {"vr": "SH", "Value": ["SP H4.7"]},
        "2335": {"vr": "SH", "Value": ["SP H62.2"]},
        "2336": {"vr": "SH", "Value": ["SP F45.3"]},
        "2337": {"vr": "SH", "Value": ["SP H37.2"]},
        "2338": {"vr": "SH", "Value": ["SP H49.7"]},
        "2339": {"vr": "SH", "Value": ["SP F35.3"]},
        "2340": {"vr": "SH", "Value": ["SP F17.8"]},
        "2341": {"vr": "SH", "Value": ["SP F52.8"]},
        "2342": {"vr": "SH", "Value": ["SP F7.8"]},
        "2343": {"vr": "SH", "Value": ["SP F15.3"]},
        "2344": {"vr": "SH", "Value": ["SP F12.8"]},
        "2345": {"vr": "SH", "Value": ["SP F12.8"]},
        "2346": {"vr": "SH", "Value": ["SP F37.8"]},
        "2347": {"vr": "SH", "Value": ["SP H17.2"]},
        "2348": {"vr": "SH", "Value": ["SP F60.3"]},
        "2349": {"vr": "SH", "Value": ["SP F57.8"]},
        "2350": {"vr": "SH", "Value": ["SP H14.7"]},
        "2351": {"vr": "SH", "Value": ["SP F27.8"]},
        "2352": {"vr": "SH", "Value": ["SP H7.2"]},
        "2353": {"vr": "SH", "Value": ["SP F27.8"]},
        "2354": {"vr": "SH", "Value": ["SP H24.7"]},
        "2355": {"vr": "SH", "Value": ["SP H37.2"]},
        "2356": {"vr": "SH", "Value": ["SP F47.8"]},
        "2357": {"vr": "SH", "Value": ["SP H37.2"]},
        "2358": {"vr": "SH", "Value": ["SP F37.8"]},
        "2359": {"vr": "SH", "Value": ["SP H74.7"]},
        "2360": {"vr": "SH", "Value": ["SP H54.7"]},
        "2361": {"vr": "SH", "Value": ["SP F20.3"]},
        "2362": {"vr": "SH", "Value": ["SP H27.2"]},
        "2363": {"vr": "SH", "Value": ["SP H24.7"]},
        "2364": {"vr": "SH", "Value": ["SP H59.7"]},
        "2365": {"vr": "SH", "Value": ["SP H7.2"]},
        "2366": {"vr": "SH", "Value": ["SP H2.2"]},
        "2367": {"vr": "SH", "Value": ["SP H34.7"]},
        "2368": {"vr": "SH", "Value": ["SP H27.2"]},
        "2369": {"vr": "SH", "Value": ["SP H34.7"]},
        "2370": {"vr": "SH", "Value": ["SP H22.2"]},
        "2371": {"vr": "SH", "Value": ["SP H7.2"]},
        "2372": {"vr": "SH", "Value": ["SP H62.2"]},
        "2373": {"vr": "SH", "Value": ["SP F0.3"]},
        "2374": {"vr": "SH", "Value": ["SP H59.7"]},
        "2375": {"vr": "SH", "Value": ["SP F70.3"]},
        "2376": {"vr": "SH", "Value": ["SP F22.8"]},
        "2377": {"vr": "SH", "Value": ["SP H2.2"]},
        "2378": {"vr": "SH", "Value": ["SP H74.7"]},
        "2379": {"vr": "SH", "Value": ["SP H7.2"]},
        "2380": {"vr": "SH", "Value": ["SP F70.3"]},
        "2381": {"vr": "SH", "Value": ["SP H17.2"]},
        "2382": {"vr": "SH", "Value": ["SP F37.8"]},
        "2383": {"vr": "SH", "Value": ["SP F55.3"]},
        "2384": {"vr": "SH", "Value": ["SP F45.3"]},
        "2385": {"vr": "SH", "Value": ["SP F52.8"]},
        "2386": {"vr": "SH", "Value": ["SP H67.2"]},
        "2387": {"vr": "SH", "Value": ["SP F12.8"]},
        "2388": {"vr": "SH", "Value": ["SP H67.2"]},
        "2389": {"vr": "SH", "Value": ["SP H49.7"]},
        "2390": {"vr": "SH", "Value": ["SP F42.8"]},
        "2391": {"vr": "SH", "Value": ["SP H72.2"]},
        "2392": {"vr": "SH", "Value": ["SP H42.2"]},
        "2393": {"vr": "SH", "Value": ["SP F10.3"]},
        "2394": {"vr": "SH", "Value": ["SP F30.3"]},
        "2395": {"vr": "SH", "Value": ["SP H69.7"]},
        "2396": {"vr": "SH", "Value": ["SP F55.3"]},
        "2397": {"vr": "SH", "Value": ["SP H42.2"]},
        "2398": {"vr": "SH", "Value": ["SP H32.2"]},
        "2399": {"vr": "SH", "Value": ["SP F22.8"]},
        "2400": {"vr": "SH", "Value": ["SP F45.3"]},
        "2401": {"vr": "SH", "Value": ["SP H69.7"]},
        "2402": {"vr": "SH", "Value": ["SP H7.2"]},
        "2403": {"vr": "SH", "Value": ["SP H2.2"]},
        "2404": {"vr": "SH", "Value": ["SP H4.7"]},
        "2405": {"vr": "SH", "Value": ["SP H22.2"]},
        "2406": {"vr": "SH", "Value": ["SP H39.7"]},
        "2407": {"vr": "SH", "Value": ["SP F25.3"]},
        "2408": {"vr": "SH", "Value": ["SP H34.7"]},
        "2409": {"vr": "SH", "Value": ["SP F60.3"]},
        "2410": {"vr": "SH", "Value": ["SP F17.8"]},
        "2411": {"vr": "SH", "Value": ["SP H7.2"]},
        "2412": {"vr": "SH", "Value": ["SP F67.8"]},
        "2413": {"vr": "SH", "Value": ["SP F22.8"]},
        "2414": {"vr": "SH", "Value": ["SP F62.8"]},
        "2415": {"vr": "SH", "Value": ["SP H72.2"]},
        "2416": {"vr": "SH", "Value": ["SP H27.2"]},
        "2417": {"vr": "SH", "Value": ["SP H7.2"]},
        "2418": {"vr": "SH", "Value": ["SP F60.3"]},
        "2419": {"vr": "SH", "Value": ["SP H67.2"]},
        "2420": {"vr": "SH", "Value": ["SP F60.3"]},
        "2421": {"vr": "SH", "Value": ["SP F27.8"]},
        "2422": {"vr": "SH", "Value": ["SP F22.8"]},
        "2423": {"vr": "SH", "Value": ["SP H57.2"]},
        "2424": {"vr": "SH", "Value": ["SP F60.3"]},
        "2425": {"vr": "SH", "Value": ["SP F40.3"]},
        "2426": {"vr": "SH", "Value": ["SP H19.7"]},
        "2427": {"vr": "SH", "Value": ["SP F47.8"]},
        "2428": {"vr": "SH", "Value": ["SP F52.8"]},
        "2429": {"vr": "SH", "Value": ["SP H24.7"]},
        "2430": {"vr": "SH", "Value": ["SP H32.2"]},
        "2431": {"vr": "SH", "Value": ["SP F57.8"]},
        "2432": {"vr": "SH", "Value": ["SP H47.2"]},
        "2433": {"vr": "SH", "Value": ["SP H14.7"]},
        "2434": {"vr": "SH", "Value": ["SP H49.7"]},
        "2435": {"vr": "SH", "Value": ["SP H57.2"]},
        "2436": {"vr": "SH", "Value": ["SP F22.8"]},
        "2437": {"vr": "SH", "Value": ["SP F7.8"]},
        "2438": {"vr": "SH", "Value": ["SP F32.8"]},
        "2439": {"vr": "SH", "Value": ["SP F7.8"]},
        "2440": {"vr": "SH", "Value": ["SP H7.2"]},
        "2441": {"vr": "SH", "Value": ["SP H7.2"]},
        "2442": {"vr": "SH", "Value": ["SP H72.2"]},
        "2443": {"vr": "SH", "Value": ["SP F12.8"]},
        "2444": {"vr": "SH", "Value": ["SP F37.8"]},
        "2445": {"vr": "SH", "Value": ["SP H27.2"]},
        "2446": {"vr": "SH", "Value": ["SP F35.3"]},
        "2447": {"vr": "SH", "Value": ["SP F57.8"]},
        "2448": {"vr": "SH", "Value": ["SP F37.8"]},
        "2449": {"vr": "SH", "Value": ["SP H52.2"]},
        "2450": {"vr": "SH", "Value": ["SP F10.3"]},
        "2451": {"vr": "SH", "Value": ["SP F10.3"]},
        "2452": {"vr": "SH", "Value": ["SP F10.3"]},
        "2453": {"vr": "SH", "Value": ["SP F17.8"]},
        "2454": {"vr": "SH", "Value": ["SP F5.3"]},
        "2455": {"vr": "SH", "Value": ["SP H64.7"]},
        "2456": {"vr": "SH", "Value": ["SP H44.7"]},
        "2457": {"vr": "SH", "Value": ["SP H7.2"]},
        "2458": {"vr": "SH", "Value": ["SP F32.8"]},
        "2459": {"vr": "SH", "Value": ["SP F47.8"]},
        "2460": {"vr": "SH", "Value": ["SP H4.7"]},
        "2461": {"vr": "SH", "Value": ["SP F40.3"]},
        "2462": {"vr": "SH", "Value": ["SP H34.7"]},
        "2463": {"vr": "SH", "Value": ["SP F15.3"]},
        "2464": {"vr": "SH", "Value": ["SP F22.8"]},
        "2465": {"vr": "SH", "Value": ["SP F40.3"]},
        "2466": {"vr": "SH", "Value": ["SP H62.2"]},
        "2467": {"vr": "SH", "Value": ["SP F20.3"]},
        "2468": {"vr": "SH", "Value": ["SP F30.3"]},
        "2469": {"vr": "SH", "Value": ["SP H29.7"]},
        "2470": {"vr": "SH", "Value": ["SP F52.8"]},
        "2471": {"vr": "SH", "Value": ["SP H19.7"]},
        "2472": {"vr": "SH", "Value": ["SP F0.3"]},
        "2473": {"vr": "SH", "Value": ["SP F67.8"]},
        "2474": {"vr": "SH", "Value": ["SP H62.2"]},
        "2475": {"vr": "SH", "Value": ["SP H74.7"]},
        "2476": {"vr": "SH", "Value": ["SP H17.2"]},
        "2477": {"vr": "SH", "Value": ["SP H12.2"]},
        "2478": {"vr": "SH", "Value": ["SP F2.8"]},
        "2479": {"vr": "SH", "Value": ["SP F20.3"]},
        "2480": {"vr": "SH", "Value": ["SP H64.7"]},
        "2481": {"vr": "SH", "Value": ["SP H27.2"]},
        "2482": {"vr": "SH", "Value": ["SP F62.8"]},
        "2483": {"vr": "SH", "Value": ["SP H22.2"]},
        "2484": {"vr": "SH", "Value": ["SP H59.7"]},
        "2485": {"vr": "SH", "Value": ["SP F37.8"]},
        "2486": {"vr": "SH", "Value": ["SP H39.7"]},
        "2487": {"vr": "SH", "Value": ["SP H67.2"]},
        "2488": {"vr": "SH", "Value": ["SP H57.2"]},
        "2489": {"vr": "SH", "Value": ["SP F22.8"]},
        "2490": {"vr": "SH", "Value": ["SP H2.2"]},
        "2491": {"vr": "SH", "Value": ["SP H42.2"]},
        "2492": {"vr": "SH", "Value": ["SP H2.2"]},
        "2493": {"vr": "SH", "Value": ["SP H14.7"]},
        "2494": {"vr": "SH", "Value": ["SP H52.2"]},
        "2495": {"vr": "SH", "Value": ["SP H29.7"]},
        "2496": {"vr": "SH", "Value": ["SP F20.3"]},
        "2497": {"vr": "SH", "Value": ["SP H2.2"]},
        "2498": {"vr": "SH", "Value": ["SP F12.8"]},
        "2499": {"vr": "SH", "Value": ["SP F7.8"]},
        "2500": {"vr": "SH", "Value": ["SP H27.2"]},
        "2501": {"vr": "SH", "Value": ["SP H74.7"]},
        "2502": {"vr": "SH", "Value": ["SP F32.8"]},
        "2503": {"vr": "SH", "Value": ["SP H27.2"]},
        "2504": {"vr": "SH", "Value": ["SP F15.3"]},
        "2505": {"vr": "SH", "Value": ["SP H59.7"]},
        "2506": {"vr": "SH", "Value": ["SP F72.8"]},
        "2507": {"vr": "SH", "Value": ["SP H4.7"]},
        "2508": {"vr": "SH", "Value": ["SP H37.2"]},
        "2509": {"vr": "SH", "Value": ["SP H47.2"]},
        "2510": {"vr": "SH", "Value": ["SP H72.2"]},
        "2511": {"vr": "SH", "Value": ["SP F5.3"]},
        "2512": {"vr": "SH", "Value": ["SP H24.7"]},
        "2513": {"vr": "SH", "Value": ["SP F10.3"]},
        "2514": {"vr": "SH", "Value": ["SP F60.3"]},
        "2515": {"vr": "SH", "Value": ["SP H52.2"]},
        "2516": {"vr": "SH", "Value": ["SP F10.3"]},
        "2517": {"vr": "SH", "Value": ["SP F70.3"]},
        "2518": {"vr": "SH", "Value": ["SP F10.3"]},
        "2519": {"vr": "SH", "Value": ["SP F40.3"]},
        "2520": {"vr": "SH", "Value": ["SP F72.8"]},
        "2521": {"vr": "SH", "Value": ["SP H32.2"]},
        "2522": {"vr": "SH", "Value": ["SP F15.3"]},
        "2523": {"vr": "SH", "Value": ["SP F30.3"]},
        "2524": {"vr": "SH", "Value": ["SP F7.8"]},
        "2525": {"vr": "SH", "Value": ["SP F32.8"]},
        "2526": {"vr": "SH", "Value": ["SP F20.3"]},
        "2527": {"vr": "SH", "Value": ["SP F65.3"]},
        "2528": {"vr": "SH", "Value": ["SP H52.2"]},
        "2529": {"vr": "SH", "Value": ["SP H12.2"]},
        "2530": {"vr": "SH", "Value": ["SP H62.2"]},
        "2531": {"vr": "SH", "Value": ["SP H59.7"]},
        "2532": {"vr": "SH", "Value": ["SP H9.7"]},
        "2533": {"vr": "SH", "Value": ["SP H74.7"]},
        "2534": {"vr": "SH", "Value": ["SP H62.2"]},
        "2535": {"vr": "SH", "Value": ["SP H34.7"]},
        "2536": {"vr": "SH", "Value": ["SP H57.2"]},
        "2537": {"vr": "SH", "Value": ["SP H42.2"]},
        "2538": {"vr": "SH", "Value": ["SP F65.3"]},
        "2539": {"vr": "SH", "Value": ["SP F50.3"]},
        "2540": {"vr": "SH", "Value": ["SP F45.3"]},
        "2541": {"vr": "SH", "Value": ["SP H74.7"]},
        "2542": {"vr": "SH", "Value": ["SP F42.8"]},
        "2543": {"vr": "SH", "Value": ["SP F57.8"]},
        "2544": {"vr": "SH", "Value": ["SP H47.2"]},
        "2545": {"vr": "SH", "Value": ["SP F37.8"]},
        "2546": {"vr": "SH", "Value": ["SP F10.3"]},
        "2547": {"vr": "SH", "Value": ["SP H2.2"]},
        "2548": {"vr": "SH", "Value": ["SP F5.3"]},
        "2549": {"vr": "SH", "Value": ["SP H64.7"]},
        "2550": {"vr": "SH", "Value": ["SP F25.3"]},
        "2551": {"vr": "SH", "Value": ["SP H29.7"]},
        "2552": {"vr": "SH", "Value": ["SP H19.7"]},
        "2553": {"vr": "SH", "Value": ["SP H42.2"]},
        "2554": {"vr": "SH", "Value": ["SP H17.2"]},
        "2555": {"vr": "SH", "Value": ["SP F27.8"]},
        "2556": {"vr": "SH", "Value": ["SP H64.7"]},
        "2557": {"vr": "SH", "Value": ["SP F27.8"]},
        "2558": {"vr": "SH", "Value": ["SP H67.2"]},
        "2559": {"vr": "SH", "Value": ["SP F72.8"]},
        "2560": {"vr": "SH", "Value": ["SP H14.7"]},
        "2561": {"vr": "SH", "Value": ["SP H39.7"]},
        "2562": {"vr": "SH", "Value": ["SP F40.3"]},
        "2563": {"vr": "SH", "Value": ["SP F42.8"]},
        "2564": {"vr": "SH", "Value": ["SP H24.7"]},
        "2565": {"vr": "SH", "Value": ["SP H2.2"]},
        "2566": {"vr": "SH", "Value": ["SP H17.2"]},
        "2567": {"vr": "SH", "Value": ["SP H42.2"]},
        "2568": {"vr": "SH", "Value": ["SP F50.3"]},
        "2569": {"vr": "SH", "Value": ["SP F20.3"]},
        "2570": {"vr": "SH", "Value": ["SP F2.8"]},
        "2571": {"vr": "SH", "Value": ["SP F47.8"]},
        "2572": {"vr": "SH", "Value": ["SP H57.2"]},
        "2573": {"vr": "SH", "Value": ["SP H19.7"]},
        "2574": {"vr": "SH", "Value": ["SP F25.3"]},
        "2575": {"vr": "SH", "Value": ["SP F52.8"]},
        "2576": {"vr": "SH", "Value": ["SP H64.7"]},
        "2577": {"vr": "SH", "Value": ["SP H34.7"]},
        "2578": {"vr": "SH", "Value": ["SP F20.3"]},
        "2579": {"vr": "SH", "Value": ["SP F50.3"]},
        "2580": {"vr": "SH", "Value": ["SP H27.2"]},
        "2581": {"vr": "SH", "Value": ["SP F47.8"]},
        "2582": {"vr": "SH", "Value": ["SP H67.2"]},
        "2583": {"vr": "SH", "Value": ["SP F7.8"]},
        "2584": {"vr": "SH", "Value": ["SP H7.2"]},
        "2585": {"vr": "SH", "Value": ["SP H52.2"]},
        "2586": {"vr": "SH", "Value": ["SP H72.2"]},
        "2587": {"vr": "SH", "Value": ["SP F52.8"]},
        "2588": {"vr": "SH", "Value": ["SP F7.8"]},
        "2589": {"vr": "SH", "Value": ["SP H2.2"]},
        "2590": {"vr": "SH", "Value": ["SP H32.2"]},
        "2591": {"vr": "SH", "Value": ["SP F30.3"]},
        "2592": {"vr": "SH", "Value": ["SP H12.2"]},
        "2593": {"vr": "SH", "Value": ["SP H72.2"]},
        "2594": {"vr": "SH", "Value": ["SP F50.3"]},
        "2595": {"vr": "SH", "Value": ["SP F40.3"]},
        "2596": {"vr": "SH", "Value": ["SP H67.2"]},
        "2597": {"vr": "SH", "Value": ["SP H59.7"]},
        "2598": {"vr": "SH", "Value": ["SP F45.3"]},
        "2599": {"vr": "SH", "Value": ["SP F52.8"]},
        "2600": {"vr": "SH", "Value": ["SP H19.7"]},
        "2601": {"vr": "SH", "Value": ["SP H29.7"]},
        "2602": {"vr": "SH", "Value": ["SP H32.2"]},
        "2603": {"vr": "SH", "Value": ["SP H39.7"]},
        "2604": {"vr": "SH", "Value": ["SP H2.2"]},
        "2605": {"vr": "SH", "Value": ["SP H32.2"]},
        "2606": {"vr": "SH", "Value": ["SP F5.3"]},
        "2607": {"vr": "SH", "Value": ["SP H57.2"]},
        "2608": {"vr": "SH", "Value": ["SP F60.3"]},
        "2609": {"vr": "SH", "Value": ["SP F40.3"]},
        "2610": {"vr": "SH", "Value": ["SP H17.2"]},
        "2611": {"vr": "SH", "Value": ["SP H19.7"]},
        "2612": {"vr": "SH", "Value": ["SP H19.7"]},
        "2613": {"vr": "SH", "Value": ["SP H24.7"]},
        "2614": {"vr": "SH", "Value": ["SP H24.7"]},
        "2615": {"vr": "SH", "Value": ["SP F52.8"]},
        "2616": {"vr": "SH", "Value": ["SP F30.3"]},
        "2617": {"vr": "SH", "Value": ["SP H12.2"]},
        "2618": {"vr": "SH", "Value": ["SP F57.8"]},
        "2619": {"vr": "SH", "Value": ["SP H17.2"]},
        "2620": {"vr": "SH", "Value": ["SP F62.8"]},
        "2621": {"vr": "SH", "Value": ["SP F35.3"]},
        "2622": {"vr": "SH", "Value": ["SP F5.3"]},
        "2623": {"vr": "SH", "Value": ["SP F25.3"]},
        "2624": {"vr": "SH", "Value": ["SP F45.3"]},
        "2625": {"vr": "SH", "Value": ["SP H19.7"]},
        "2626": {"vr": "SH", "Value": ["SP H24.7"]},
        "2627": {"vr": "SH", "Value": ["SP H47.2"]},
        "2628": {"vr": "SH", "Value": ["SP F20.3"]},
        "2629": {"vr": "SH", "Value": ["SP H37.2"]},
        "2630": {"vr": "SH", "Value": ["SP F55.3"]},
        "2631": {"vr": "SH", "Value": ["SP H37.2"]},
        "2632": {"vr": "SH", "Value": ["SP H49.7"]},
        "2633": {"vr": "SH", "Value": ["SP F2.8"]},
        "2634": {"vr": "SH", "Value": ["SP H52.2"]},
        "2635": {"vr": "SH", "Value": ["SP H14.7"]},
        "2636": {"vr": "SH", "Value": ["SP F62.8"]},
        "2637": {"vr": "SH", "Value": ["SP H2.2"]},
        "2638": {"vr": "SH", "Value": ["SP H4.7"]},
        "2639": {"vr": "SH", "Value": ["SP H9.7"]},
        "2640": {"vr": "SH", "Value": ["SP H2.2"]},
        "2641": {"vr": "SH", "Value": ["SP F70.3"]},
        "2642": {"vr": "SH", "Value": ["SP F42.8"]},
        "2643": {"vr": "SH", "Value": ["SP F62.8"]},
        "2644": {"vr": "SH", "Value": ["SP F50.3"]},
        "2645": {"vr": "SH", "Value": ["SP F22.8"]},
        "2646": {"vr": "SH", "Value": ["SP H12.2"]},
        "2647": {"vr": "SH", "Value": ["SP F50.3"]},
        "2648": {"vr": "SH", "Value": ["SP H64.7"]},
        "2649": {"vr": "SH", "Value": ["SP F67.8"]},
        "2650": {"vr": "SH", "Value": ["SP F57.8"]},
        "2651": {"vr": "SH", "Value": ["SP H67.2"]},
        "2652": {"vr": "SH", "Value": ["SP F50.3"]},
        "2653": {"vr": "SH", "Value": ["SP H32.2"]},
        "2654": {"vr": "SH", "Value": ["SP H4.7"]},
        "2655": {"vr": "SH", "Value": ["SP H37.2"]},
        "2656": {"vr": "SH", "Value": ["SP H37.2"]},
        "2657": {"vr": "SH", "Value": ["SP F52.8"]},
        "2658": {"vr": "SH", "Value": ["SP H37.2"]},
        "2659": {"vr": "SH", "Value": ["SP F52.8"]},
        "2660": {"vr": "SH", "Value": ["SP H24.7"]},
        "2661": {"vr": "SH", "Value": ["SP H69.7"]},
        "2662": {"vr": "SH", "Value": ["SP H29.7"]},
        "2663": {"vr": "SH", "Value": ["SP F32.8"]},
        "2664": {"vr": "SH", "Value": ["SP F10.3"]},
        "2665": {"vr": "SH", "Value": ["SP H67.2"]},
        "2666": {"vr": "SH", "Value": ["SP F15.3"]},
        "2667": {"vr": "SH", "Value": ["SP H4.7"]},
        "2668": {"vr": "SH", "Value": ["SP H69.7"]},
        "2669": {"vr": "SH", "Value": ["SP F52.8"]},
        "2670": {"vr": "SH", "Value": ["SP H39.7"]},
        "2671": {"vr": "SH", "Value": ["SP F55.3"]},
        "2672": {"vr": "SH", "Value": ["SP H67.2"]},
        "2673": {"vr": "SH", "Value": ["SP F57.8"]},
        "2674": {"vr": "SH", "Value": ["SP H52.2"]},
        "2675": {"vr": "SH", "Value": ["SP H32.2"]},
        "2676": {"vr": "SH", "Value": ["SP F25.3"]},
        "2677": {"vr": "SH", "Value": ["SP H17.2"]},
        "2678": {"vr": "SH", "Value": ["SP F45.3"]},
        "2679": {"vr": "SH", "Value": ["SP H2.2"]},
        "2680": {"vr": "SH", "Value": ["SP H72.2"]},
        "2681": {"vr": "SH", "Value": ["SP F12.8"]},
        "2682": {"vr": "SH", "Value": ["SP H17.2"]},
        "2683": {"vr": "SH", "Value": ["SP H24.7"]},
        "2684": {"vr": "SH", "Value": ["SP F17.8"]},
        "2685": {"vr": "SH", "Value": ["SP H22.2"]},
        "2686": {"vr": "SH", "Value": ["SP H34.7"]},
        "2687": {"vr": "SH", "Value": ["SP H37.2"]},
        "2688": {"vr": "SH", "Value": ["SP F5.3"]},
        "2689": {"vr": "SH", "Value": ["SP F2.8"]},
        "2690": {"vr": "SH", "Value": ["SP H29.7"]},
        "2691": {"vr": "SH", "Value": ["SP F47.8"]},
        "2692": {"vr": "SH", "Value": ["SP F12.8"]},
        "2693": {"vr": "SH", "Value": ["SP H19.7"]},
        "2694": {"vr": "SH", "Value": ["SP H47.2"]},
        "2695": {"vr": "SH", "Value": ["SP F67.8"]},
        "2696": {"vr": "SH", "Value": ["SP H29.7"]},
        "2697": {"vr": "SH", "Value": ["SP H74.7"]},
        "2698": {"vr": "SH", "Value": ["SP H49.7"]},
        "2699": {"vr": "SH", "Value": ["SP F15.3"]},
        "2700": {"vr": "SH", "Value": ["SP F60.3"]},
        "2701": {"vr": "SH", "Value": ["SP H14.7"]},
        "2702": {"vr": "SH", "Value": ["SP H67.2"]},
        "2703": {"vr": "SH", "Value": ["SP H9.7"]},
        "2704": {"vr": "SH", "Value": ["SP F42.8"]},
        "2705": {"vr": "SH", "Value": ["SP F15.3"]},
        "2706": {"vr": "SH", "Value": ["SP H47.2"]},
        "2707": {"vr": "SH", "Value": ["SP F62.8"]},
        "2708": {"vr": "SH", "Value": ["SP F50.3"]},
        "2709": {"vr": "SH", "Value": ["SP H42.2"]},
        "2710": {"vr": "SH", "Value": ["SP F60.3"]},
        "2711": {"vr": "SH", "Value": ["SP F47.8"]},
        "2712": {"vr": "SH", "Value": ["SP F20.3"]},
        "2713": {"vr": "SH", "Value": ["SP H44.7"]},
        "2714": {"vr": "SH", "Value": ["SP H72.2"]},
        "2715": {"vr": "SH", "Value": ["SP H47.2"]},
        "2716": {"vr": "SH", "Value": ["SP F47.8"]},
        "2717": {"vr": "SH", "Value": ["SP F0.3"]},
        "2718": {"vr": "SH", "Value": ["SP F47.8"]},
        "2719": {"vr": "SH", "Value": ["SP H14.7"]},
        "2720": {"vr": "SH", "Value": ["SP F70.3"]},
        "2721": {"vr": "SH", "Value": ["SP H19.7"]},
        "2722": {"vr": "SH", "Value": ["SP H22.2"]},
        "2723": {"vr": "SH", "Value": ["SP F35.3"]},
        "2724": {"vr": "SH", "Value": ["SP F42.8"]},
        "2725": {"vr": "SH", "Value": ["SP F35.3"]},
        "2726": {"vr": "SH", "Value": ["SP H24.7"]},
        "2727": {"vr": "SH", "Value": ["SP H22.2"]},
        "2728": {"vr": "SH", "Value": ["SP F17.8"]},
        "2729": {"vr": "SH", "Value": ["SP H67.2"]},
        "2730": {"vr": "SH", "Value": ["SP F37.8"]},
        "2731": {"vr": "SH", "Value": ["SP H69.7"]},
        "2732": {"vr": "SH", "Value": ["SP F5.3"]},
        "2733": {"vr": "SH", "Value": ["SP F37.8"]},
        "2734": {"vr": "SH", "Value": ["SP H62.2"]},
        "2735": {"vr": "SH", "Value": ["SP H49.7"]},
        "2736": {"vr": "SH", "Value": ["SP F27.8"]},
        "2737": {"vr": "SH", "Value": ["SP F55.3"]},
        "2738": {"vr": "SH", "Value": ["SP F52.8"]},
        "2739": {"vr": "SH", "Value": ["SP H54.7"]},
        "2740": {"vr": "SH", "Value": ["SP H12.2"]},
        "2741": {"vr": "SH", "Value": ["SP H19.7"]},
        "2742": {"vr": "SH", "Value": ["SP H19.7"]},
        "2743": {"vr": "SH", "Value": ["SP F12.8"]},
        "2744": {"vr": "SH", "Value": ["SP F10.3"]},
        "2745": {"vr": "SH", "Value": ["SP H49.7"]},
        "2746": {"vr": "SH", "Value": ["SP H34.7"]},
        "2747": {"vr": "SH", "Value": ["SP H4.7"]},
        "2748": {"vr": "SH", "Value": ["SP H57.2"]},
        "2749": {"vr": "SH", "Value": ["SP H57.2"]},
        "2750": {"vr": "SH", "Value": ["SP F25.3"]},
        "2751": {"vr": "SH", "Value": ["SP F20.3"]},
        "2752": {"vr": "SH", "Value": ["SP F72.8"]},
        "2753": {"vr": "SH", "Value": ["SP F2.8"]},
        "2754": {"vr": "SH", "Value": ["SP H69.7"]},
        "2755": {"vr": "SH", "Value": ["SP H27.2"]},
        "2756": {"vr": "SH", "Value": ["SP H69.7"]},
        "2757": {"vr": "SH", "Value": ["SP H34.7"]},
        "2758": {"vr": "SH", "Value": ["SP F60.3"]},
        "2759": {"vr": "SH", "Value": ["SP H4.7"]},
        "2760": {"vr": "SH", "Value": ["SP H29.7"]},
        "2761": {"vr": "SH", "Value": ["SP H47.2"]},
        "2762": {"vr": "SH", "Value": ["SP F35.3"]},
        "2763": {"vr": "SH", "Value": ["SP H62.2"]},
        "2764": {"vr": "SH", "Value": ["SP H39.7"]},
        "2765": {"vr": "SH", "Value": ["SP F65.3"]},
        "2766": {"vr": "SH", "Value": ["SP F42.8"]},
        "2767": {"vr": "SH", "Value": ["SP F5.3"]},
        "2768": {"vr": "SH", "Value": ["SP F0.3"]},
        "2769": {"vr": "SH", "Value": ["SP F52.8"]},
        "2770": {"vr": "SH", "Value": ["SP F15.3"]},
        "2771": {"vr": "SH", "Value": ["SP H69.7"]},
        "2772": {"vr": "SH", "Value": ["SP F45.3"]},
        "2773": {"vr": "SH", "Value": ["SP F47.8"]},
        "2774": {"vr": "SH", "Value": ["SP F65.3"]},
        "2775": {"vr": "SH", "Value": ["SP F25.3"]},
        "2776": {"vr": "SH", "Value": ["SP F12.8"]},
        "2777": {"vr": "SH", "Value": ["SP F32.8"]},
        "2778": {"vr": "SH", "Value": ["SP F25.3"]},
        "2779": {"vr": "SH", "Value": ["SP F7.8"]},
        "2780": {"vr": "SH", "Value": ["SP H62.2"]},
        "2781": {"vr": "SH", "Value": ["SP H4.7"]},
        "2782": {"vr": "SH", "Value": ["SP H42.2"]},
        "2783": {"vr": "SH", "Value": ["SP H64.7"]},
        "2784": {"vr": "SH", "Value": ["SP H72.2"]},
        "2785": {"vr": "SH", "Value": ["SP F45.3"]},
        "2786": {"vr": "SH", "Value": ["SP F25.3"]},
        "2787": {"vr": "SH", "Value": ["SP H9.7"]},
        "2788": {"vr": "SH", "Value": ["SP F67.8"]},
        "2789": {"vr": "SH", "Value": ["SP F15.3"]},
        "2790": {"vr": "SH", "Value": ["SP H24.7"]},
        "2791": {"vr": "SH", "Value": ["SP F45.3"]},
        "2792": {"vr": "SH", "Value": ["SP H19.7"]},
        "2793": {"vr": "SH", "Value": ["SP F70.3"]},
        "2794": {"vr": "SH", "Value": ["SP F15.3"]},
        "2795": {"vr": "SH", "Value": ["SP F72.8"]},
        "2796": {"vr": "SH", "Value": ["SP H67.2"]},
        "2797": {"vr": "SH", "Value": ["SP H32.2"]},
        "2798": {"vr": "SH", "Value": ["SP F37.8"]},
        "2799": {"vr": "SH", "Value": ["SP F60.3"]},
        "2800": {"vr": "SH", "Value": ["SP F20.3"]},
        "2801": {"vr": "SH", "Value": ["SP H74.7"]},
        "2802": {"vr": "SH", "Value": ["SP F55.3"]},
        "2803": {"vr": "SH", "Value": ["SP F10.3"]},
        "2804": {"vr": "SH", "Value": ["SP F52.8"]},
        "2805": {"vr": "SH", "Value": ["SP H69.7"]},
        "2806": {"vr": "SH", "Value": ["SP F65.3"]},
        "2807": {"vr": "SH", "Value": ["SP H39.7"]},
        "2808": {"vr": "SH", "Value": ["SP H44.7"]},
        "2809": {"vr": "SH", "Value": ["SP F70.3"]},
        "2810": {"vr": "SH", "Value": ["SP H32.2"]},
        "2811": {"vr": "SH", "Value": ["SP H67.2"]},
        "2812": {"vr": "SH", "Value": ["SP H14.7"]},
        "2813": {"vr": "SH", "Value": ["SP F37.8"]},
        "2814": {"vr": "SH", "Value": ["SP F47.8"]},
        "2815": {"vr": "SH", "Value": ["SP H59.7"]},
        "2816": {"vr": "SH", "Value": ["SP F5.3"]},
        "2817": {"vr": "SH", "Value": ["SP F5.3"]},
        "2818": {"vr": "SH", "Value": ["SP H44.7"]},
        "2819": {"vr": "SH", "Value": ["SP F55.3"]},
        "2820": {"vr": "SH", "Value": ["SP F10.3"]},
        "2821": {"vr": "SH", "Value": ["SP H34.7"]},
        "2822": {"vr": "SH", "Value": ["SP F65.3"]},
        "2823": {"vr": "SH", "Value": ["SP H52.2"]},
        "2824": {"vr": "SH", "Value": ["SP H72.2"]},
        "2825": {"vr": "SH", "Value": ["SP H47.2"]},
        "2826": {"vr": "SH", "Value": ["SP F20.3"]},
        "2827": {"vr": "SH", "Value": ["SP H64.7"]},
        "2828": {"vr": "SH", "Value": ["SP H69.7"]},
        "2829": {"vr": "SH", "Value": ["SP F65.3"]},
        "2830": {"vr": "SH", "Value": ["SP H62.2"]},
        "2831": {"vr": "SH", "Value": ["SP H42.2"]},
        "2832": {"vr": "SH", "Value": ["SP F57.8"]},
        "2833": {"vr": "SH", "Value": ["SP H64.7"]},
        "2834": {"vr": "SH", "Value": ["SP F7.8"]},
        "2835": {"vr": "SH", "Value": ["SP F30.3"]},
        "2836": {"vr": "SH", "Value": ["SP H17.2"]},
        "2837": {"vr": "SH", "Value": ["SP F17.8"]},
        "2838": {"vr": "SH", "Value": ["SP F17.8"]},
        "2839": {"vr": "SH", "Value": ["SP F27.8"]},
        "2840": {"vr": "SH", "Value": ["SP F62.8"]},
        "2841": {"vr": "SH", "Value": ["SP H14.7"]},
        "2842": {"vr": "SH", "Value": ["SP H2.2"]},
        "2843": {"vr": "SH", "Value": ["SP H47.2"]},
        "2844": {"vr": "SH", "Value": ["SP F2.8"]},
        "2845": {"vr": "SH", "Value": ["SP F55.3"]},
        "2846": {"vr": "SH", "Value": ["SP H37.2"]},
        "2847": {"vr": "SH", "Value": ["SP F32.8"]},
        "2848": {"vr": "SH", "Value": ["SP H67.2"]},
        "2849": {"vr": "SH", "Value": ["SP H59.7"]},
        "2850": {"vr": "SH", "Value": ["SP H2.2"]},
        "2851": {"vr": "SH", "Value": ["SP F30.3"]},
        "2852": {"vr": "SH", "Value": ["SP F60.3"]},
        "2853": {"vr": "SH", "Value": ["SP F50.3"]},
        "2854": {"vr": "SH", "Value": ["SP F55.3"]},
        "2855": {"vr": "SH", "Value": ["SP F55.3"]},
        "2856": {"vr": "SH", "Value": ["SP H24.7"]},
        "2857": {"vr": "SH", "Value": ["SP H44.7"]},
        "2858": {"vr": "SH", "Value": ["SP F57.8"]},
        "2859": {"vr": "SH", "Value": ["SP F12.8"]},
        "2860": {"vr": "SH", "Value": ["SP H64.7"]},
        "2861": {"vr": "SH", "Value": ["SP H59.7"]},
        "2862": {"vr": "SH", "Value": ["SP F27.8"]},
        "2863": {"vr": "SH", "Value": ["SP H19.7"]},
        "2864": {"vr": "SH", "Value": ["SP H9.7"]},
        "2865": {"vr": "SH", "Value": ["SP H22.2"]},
        "2866": {"vr": "SH", "Value": ["SP F52.8"]},
        "2867": {"vr": "SH", "Value": ["SP H67.2"]},
        "2868": {"vr": "SH", "Value": ["SP H9.7"]},
        "2869": {"vr": "SH", "Value": ["SP F10.3"]},
        "2870": {"vr": "SH", "Value": ["SP H62.2"]},
        "2871": {"vr": "SH", "Value": ["SP H34.7"]},
        "2872": {"vr": "SH", "Value": ["SP H54.7"]},
        "2873": {"vr": "SH", "Value": ["SP H4.7"]},
        "2874": {"vr": "SH", "Value": ["SP H17.2"]},
        "2875": {"vr": "SH", "Value": ["SP F12.8"]},
        "2876": {"vr": "SH", "Value": ["SP H39.7"]},
        "2877": {"vr": "SH", "Value": ["SP H14.7"]},
        "2878": {"vr": "SH", "Value": ["SP F50.3"]},
        "2879": {"vr": "SH", "Value": ["SP F47.8"]},
        "2880": {"vr": "SH", "Value": ["SP F35.3"]},
        "2881": {"vr": "SH", "Value": ["SP F22.8"]},
        "2882": {"vr": "SH", "Value": ["SP H39.7"]},
        "2883": {"vr": "SH", "Value": ["SP H17.2"]},
        "2884": {"vr": "SH", "Value": ["SP F35.3"]},
        "2885": {"vr": "SH", "Value": ["SP F10.3"]},
        "2886": {"vr": "SH", "Value": ["SP F55.3"]},
        "2887": {"vr": "SH", "Value": ["SP F65.3"]},
        "2888": {"vr": "SH", "Value": ["SP H69.7"]},
        "2889": {"vr": "SH", "Value": ["SP F30.3"]},
        "2890": {"vr": "SH", "Value": ["SP H52.2"]},
        "2891": {"vr": "SH", "Value": ["SP H29.7"]},
        "2892": {"vr": "SH", "Value": ["SP F45.3"]},
        "2893": {"vr": "SH", "Value": ["SP F22.8"]},
        "2894": {"vr": "SH", "Value": ["SP H72.2"]},
        "2895": {"vr": "SH", "Value": ["SP F17.8"]},
        "2896": {"vr": "SH", "Value": ["SP H37.2"]},
        "2897": {"vr": "SH", "Value": ["SP F60.3"]},
        "2898": {"vr": "SH", "Value": ["SP F17.8"]},
        "2899": {"vr": "SH", "Value": ["SP H37.2"]},
        "2900": {"vr": "SH", "Value": ["SP H34.7"]},
        "2901": {"vr": "SH", "Value": ["SP F5.3"]},
        "2902": {"vr": "SH", "Value": ["SP F25.3"]},
        "2903": {"vr": "SH", "Value": ["SP H19.7"]},
        "2904": {"vr": "SH", "Value": ["SP F62.8"]},
        "2905": {"vr": "SH", "Value": ["SP F55.3"]},
        "2906": {"vr": "SH", "Value": ["SP F20.3"]},
        "2907": {"vr": "SH", "Value": ["SP F40.3"]},
        "2908": {"vr": "SH", "Value": ["SP F57.8"]},
        "2909": {"vr": "SH", "Value": ["SP H19.7"]},
        "2910": {"vr": "SH", "Value": ["SP F60.3"]},
        "2911": {"vr": "SH", "Value": ["SP F50.3"]},
        "2912": {"vr": "SH", "Value": ["SP H2.2"]},
        "2913": {"vr": "SH", "Value": ["SP F52.8"]},
        "2914": {"vr": "SH", "Value": ["SP H14.7"]},
        "2915": {"vr": "SH", "Value": ["SP H54.7"]},
        "2916": {"vr": "SH", "Value": ["SP F15.3"]},
        "2917": {"vr": "SH", "Value": ["SP H72.2"]},
        "2918": {"vr": "SH", "Value": ["SP F42.8"]},
        "2919": {"vr": "SH", "Value": ["SP F2.8"]},
        "2920": {"vr": "SH", "Value": ["SP H37.2"]},
        "2921": {"vr": "SH", "Value": ["SP H39.7"]},
        "2922": {"vr": "SH", "Value": ["SP H62.2"]},
        "2923": {"vr": "SH", "Value": ["SP H24.7"]},
        "2924": {"vr": "SH", "Value": ["SP F50.3"]},
        "2925": {"vr": "SH", "Value": ["SP H74.7"]},
        "2926": {"vr": "SH", "Value": ["SP F15.3"]},
        "2927": {"vr": "SH", "Value": ["SP H7.2"]},
        "2928": {"vr": "SH", "Value": ["SP F10.3"]},
        "2929": {"vr": "SH", "Value": ["SP H32.2"]},
        "2930": {"vr": "SH", "Value": ["SP F67.8"]},
        "2931": {"vr": "SH", "Value": ["SP F37.8"]},
        "2932": {"vr": "SH", "Value": ["SP F42.8"]},
        "2933": {"vr": "SH", "Value": ["SP H19.7"]},
        "2934": {"vr": "SH", "Value": ["SP F65.3"]},
        "2935": {"vr": "SH", "Value": ["SP H67.2"]},
        "2936": {"vr": "SH", "Value": ["SP H74.7"]},
        "2937": {"vr": "SH", "Value": ["SP F55.3"]},
        "2938": {"vr": "SH", "Value": ["SP H19.7"]},
        "2939": {"vr": "SH", "Value": ["SP F5.3"]},
        "2940": {"vr": "SH", "Value": ["SP H34.7"]},
        "2941": {"vr": "SH", "Value": ["SP H29.7"]},
        "2942": {"vr": "SH", "Value": ["SP F7.8"]},
        "2943": {"vr": "SH", "Value": ["SP H37.2"]},
        "2944": {"vr": "SH", "Value": ["SP H37.2"]},
        "2945": {"vr": "SH", "Value": ["SP H17.2"]},
        "2946": {"vr": "SH", "Value": ["SP F40.3"]},
        "2947": {"vr": "SH", "Value": ["SP H34.7"]},
        "2948": {"vr": "SH", "Value": ["SP H54.7"]},
        "2949": {"vr": "SH", "Value": ["SP F57.8"]},
        "2950": {"vr": "SH", "Value": ["SP H57.2"]},
        "2951": {"vr": "SH", "Value": ["SP F25.3"]},
        "2952": {"vr": "SH", "Value": ["SP H22.2"]},
        "2953": {"vr": "SH", "Value": ["SP H64.7"]},
        "2954": {"vr": "SH", "Value": ["SP F22.8"]},
        "2955": {"vr": "SH", "Value": ["SP H57.2"]},
        "2956": {"vr": "SH", "Value": ["SP F2.8"]},
        "2957": {"vr": "SH", "Value": ["SP F22.8"]},
        "2958": {"vr": "SH", "Value": ["SP H64.7"]},
        "2959": {"vr": "SH", "Value": ["SP H34.7"]},
        "2960": {"vr": "SH", "Value": ["SP F15.3"]},
        "2961": {"vr": "SH", "Value": ["SP F65.3"]},
        "2962": {"vr": "SH", "Value": ["SP H47.2"]},
        "2963": {"vr": "SH", "Value": ["SP F10.3"]},
        "2964": {"vr": "SH", "Value": ["SP F5.3"]},
        "2965": {"vr": "SH", "Value": ["SP H34.7"]},
        "2966": {"vr": "SH", "Value": ["SP H49.7"]},
        "2967": {"vr": "SH", "Value": ["SP F20.3"]},
        "2968": {"vr": "SH", "Value": ["SP H12.2"]},
        "2969": {"vr": "SH", "Value": ["SP F10.3"]},
        "2970": {"vr": "SH", "Value": ["SP H12.2"]},
        "2971": {"vr": "SH", "Value": ["SP H39.7"]},
        "2972": {"vr": "SH", "Value": ["SP F22.8"]},
        "2973": {"vr": "SH", "Value": ["SP F20.3"]},
        "2974": {"vr": "SH", "Value": ["SP H34.7"]},
        "2975": {"vr": "SH", "Value": ["SP F5.3"]},
        "2976": {"vr": "SH", "Value": ["SP F27.8"]},
        "2977": {"vr": "SH", "Value": ["SP H34.7"]},
        "2978": {"vr": "SH", "Value": ["SP H34.7"]},
        "2979": {"vr": "SH", "Value": ["SP H69.7"]},
        "2980": {"vr": "SH", "Value": ["SP F15.3"]},
        "2981": {"vr": "SH", "Value": ["SP F25.3"]},
        "2982": {"vr": "SH", "Value": ["SP H22.2"]},
        "2983": {"vr": "SH", "Value": ["SP H22.2"]},
        "2984": {"vr": "SH", "Value": ["SP F60.3"]},
        "2985": {"vr": "SH", "Value": ["SP H62.2"]},
        "2986": {"vr": "SH", "Value": ["SP H27.2"]},
        "2987": {"vr": "SH", "Value": ["SP F72.8"]},
        "2988": {"vr": "SH", "Value": ["SP H4.7"]},
        "2989": {"vr": "SH", "Value": ["SP F67.8"]},
        "2990": {"vr": "SH", "Value": ["SP F70.3"]},
        "2991": {"vr": "SH", "Value": ["SP F22.8"]},
        "2992": {"vr": "SH", "Value": ["SP H9.7"]},
        "2993": {"vr": "SH", "Value": ["SP H49.7"]},
        "2994": {"vr": "SH", "Value": ["SP H29.7"]},
        "2995": {"vr": "SH", "Value": ["SP H72.2"]},
        "2996": {"vr": "SH", "Value": ["SP H14.7"]},
        "2997": {"vr": "SH", "Value": ["SP H32.2"]},
        "2998": {"vr": "SH", "Value": ["SP H19.7"]},
        "2999": {"vr": "SH", "Value": ["SP F67.8"]},
        "3000": {"vr": "SH", "Value": ["SP F5.3"]},
        "3001": {"vr": "SH", "Value": ["SP F2.8"]},
        "3002": {"vr": "SH", "Value": ["SP H17.2"]},
        "3003": {"vr": "SH", "Value": ["SP H42.2"]},
        "3004": {"vr": "SH", "Value": ["SP F42.8"]},
        "3005": {"vr": "SH", "Value": ["SP F25.3"]},
        "3006": {"vr": "SH", "Value": ["SP F72.8"]},
        "3007": {"vr": "SH", "Value": ["SP H24.7"]},
        "3008": {"vr": "SH", "Value": ["SP F62.8"]},
        "3009": {"vr": "SH", "Value": ["SP H29.7"]},
        "3010": {"vr": "SH", "Value": ["SP H7.2"]},
        "3011": {"vr": "SH", "Value": ["SP F30.3"]},
        "3012": {"vr": "SH", "Value": ["SP H32.2"]},
        "3013": {"vr": "SH", "Value": ["SP F7.8"]},
        "3014": {"vr": "SH", "Value": ["SP F67.8"]},
        "3015": {"vr": "SH", "Value": ["SP H29.7"]},
        "3016": {"vr": "SH", "Value": ["SP F22.8"]},
        "3017": {"vr": "SH", "Value": ["SP F17.8"]},
        "3018": {"vr": "SH", "Value": ["SP H9.7"]},
        "3019": {"vr": "SH", "Value": ["SP H17.2"]},
        "3020": {"vr": "SH", "Value": ["SP F37.8"]},
        "3021": {"vr": "SH", "Value": ["SP F62.8"]},
        "3022": {"vr": "SH", "Value": ["SP F27.8"]},
        "3023": {"vr": "SH", "Value": ["SP F65.3"]},
        "3024": {"vr": "SH", "Value": ["SP H19.7"]},
        "3025": {"vr": "SH", "Value": ["SP F72.8"]},
        "3026": {"vr": "SH", "Value": ["SP F17.8"]},
        "3027": {"vr": "SH", "Value": ["SP F35.3"]},
        "3028": {"vr": "SH", "Value": ["SP F40.3"]},
        "3029": {"vr": "SH", "Value": ["SP H37.2"]},
        "3030": {"vr": "SH", "Value": ["SP H14.7"]},
        "3031": {"vr": "SH", "Value": ["SP H54.7"]},
        "3032": {"vr": "SH", "Value": ["SP H37.2"]},
        "3033": {"vr": "SH", "Value": ["SP F40.3"]},
        "3034": {"vr": "SH", "Value": ["SP F60.3"]},
        "3035": {"vr": "SH", "Value": ["SP F67.8"]},
        "3036": {"vr": "SH", "Value": ["SP H39.7"]},
        "3037": {"vr": "SH", "Value": ["SP F42.8"]},
        "3038": {"vr": "SH", "Value": ["SP F52.8"]},
        "3039": {"vr": "SH", "Value": ["SP F67.8"]},
        "3040": {"vr": "SH", "Value": ["SP F42.8"]},
        "3041": {"vr": "SH", "Value": ["SP F22.8"]},
        "3042": {"vr": "SH", "Value": ["SP F57.8"]},
        "3043": {"vr": "SH", "Value": ["SP H27.2"]},
        "3044": {"vr": "SH", "Value": ["SP F47.8"]},
        "3045": {"vr": "SH", "Value": ["SP H19.7"]},
        "3046": {"vr": "SH", "Value": ["SP F40.3"]},
        "3047": {"vr": "SH", "Value": ["SP H9.7"]},
        "3048": {"vr": "SH", "Value": ["SP F62.8"]},
        "3049": {"vr": "SH", "Value": ["SP H49.7"]},
        "3050": {"vr": "SH", "Value": ["SP H52.2"]},
        "3051": {"vr": "SH", "Value": ["SP F57.8"]},
        "3052": {"vr": "SH", "Value": ["SP H17.2"]},
        "3053": {"vr": "SH", "Value": ["SP F70.3"]},
        "3054": {"vr": "SH", "Value": ["SP F32.8"]},
        "3055": {"vr": "SH", "Value": ["SP H12.2"]},
        "3056": {"vr": "SH", "Value": ["SP F2.8"]},
        "3057": {"vr": "SH", "Value": ["SP F70.3"]},
        "3058": {"vr": "SH", "Value": ["SP H57.2"]},
        "3059": {"vr": "SH", "Value": ["SP H67.2"]},
        "3060": {"vr": "SH", "Value": ["SP H12.2"]},
        "3061": {"vr": "SH", "Value": ["SP H69.7"]},
        "3062": {"vr": "SH", "Value": ["SP F2.8"]},
        "3063": {"vr": "SH", "Value": ["SP F20.3"]},
        "3064": {"vr": "SH", "Value": ["SP F57.8"]},
        "3065": {"vr": "SH", "Value": ["SP F10.3"]},
        "3066": {"vr": "SH", "Value": ["SP H17.2"]},
        "3067": {"vr": "SH", "Value": ["SP H32.2"]},
        "3068": {"vr": "SH", "Value": ["SP F57.8"]},
        "3069": {"vr": "SH", "Value": ["SP F50.3"]},
        "3070": {"vr": "SH", "Value": ["SP F65.3"]},
        "3071": {"vr": "SH", "Value": ["SP F42.8"]},
        "3072": {"vr": "SH", "Value": ["SP F17.8"]},
        "3073": {"vr": "SH", "Value": ["SP H69.7"]},
        "3074": {"vr": "SH", "Value": ["SP F45.3"]},
        "3075": {"vr": "SH", "Value": ["SP H39.7"]},
        "3076": {"vr": "SH", "Value": ["SP F20.3"]},
        "3077": {"vr": "SH", "Value": ["SP H24.7"]},
        "3078": {"vr": "SH", "Value": ["SP H44.7"]},
        "3079": {"vr": "SH", "Value": ["SP H27.2"]},
        "3080": {"vr": "SH", "Value": ["SP F15.3"]},
        "3081": {"vr": "SH", "Value": ["SP H27.2"]},
        "3082": {"vr": "SH", "Value": ["SP F55.3"]},
        "3083": {"vr": "SH", "Value": ["SP F17.8"]},
        "3084": {"vr": "SH", "Value": ["SP F0.3"]},
        "3085": {"vr": "SH", "Value": ["SP F22.8"]},
        "3086": {"vr": "SH", "Value": ["SP F25.3"]},
        "3087": {"vr": "SH", "Value": ["SP F67.8"]},
        "3088": {"vr": "SH", "Value": ["SP F57.8"]},
        "3089": {"vr": "SH", "Value": ["SP H24.7"]},
        "3090": {"vr": "SH", "Value": ["SP F70.3"]},
        "3091": {"vr": "SH", "Value": ["SP F2.8"]},
        "3092": {"vr": "SH", "Value": ["SP F52.8"]},
        "3093": {"vr": "SH", "Value": ["SP H9.7"]},
        "3094": {"vr": "SH", "Value": ["SP H49.7"]},
        "3095": {"vr": "SH", "Value": ["SP F60.3"]},
        "3096": {"vr": "SH", "Value": ["SP F55.3"]},
        "3097": {"vr": "SH", "Value": ["SP F65.3"]},
        "3098": {"vr": "SH", "Value": ["SP H14.7"]},
        "3099": {"vr": "SH", "Value": ["SP H37.2"]},
        "3100": {"vr": "SH", "Value": ["SP F45.3"]},
        "3101": {"vr": "SH", "Value": ["SP F42.8"]},
        "3102": {"vr": "SH", "Value": ["SP H39.7"]},
        "3103": {"vr": "SH", "Value": ["SP H14.7"]},
        "3104": {"vr": "SH", "Value": ["SP F35.3"]},
        "3105": {"vr": "SH", "Value": ["SP H62.2"]},
        "3106": {"vr": "SH", "Value": ["SP H27.2"]},
        "3107": {"vr": "SH", "Value": ["SP H67.2"]},
        "3108": {"vr": "SH", "Value": ["SP F22.8"]},
        "3109": {"vr": "SH", "Value": ["SP F25.3"]},
        "3110": {"vr": "SH", "Value": ["SP F7.8"]},
        "3111": {"vr": "SH", "Value": ["SP F32.8"]},
        "3112": {"vr": "SH", "Value": ["SP H32.2"]},
        "3113": {"vr": "SH", "Value": ["SP H74.7"]},
        "3114": {"vr": "SH", "Value": ["SP H39.7"]},
        "3115": {"vr": "SH", "Value": ["SP H44.7"]},
        "3116": {"vr": "SH", "Value": ["SP F70.3"]},
        "3117": {"vr": "SH", "Value": ["SP F42.8"]},
        "3118": {"vr": "SH", "Value": ["SP H22.2"]},
        "3119": {"vr": "SH", "Value": ["SP H37.2"]},
        "3120": {"vr": "SH", "Value": ["SP H39.7"]},
        "3121": {"vr": "SH", "Value": ["SP H72.2"]},
        "3122": {"vr": "SH", "Value": ["SP H9.7"]},
        "3123": {"vr": "SH", "Value": ["SP H57.2"]},
        "3124": {"vr": "SH", "Value": ["SP F40.3"]},
        "3125": {"vr": "SH", "Value": ["SP H24.7"]},
        "3126": {"vr": "SH", "Value": ["SP F35.3"]},
        "3127": {"vr": "SH", "Value": ["SP F2.8"]},
        "3128": {"vr": "SH", "Value": ["SP H54.7"]},
        "3129": {"vr": "SH", "Value": ["SP H42.2"]},
        "3130": {"vr": "SH", "Value": ["SP H4.7"]},
        "3131": {"vr": "SH", "Value": ["SP F55.3"]},
        "3132": {"vr": "SH", "Value": ["SP F37.8"]},
        "3133": {"vr": "SH", "Value": ["SP F2.8"]},
        "3134": {"vr": "SH", "Value": ["SP F45.3"]},
        "3135": {"vr": "SH", "Value": ["SP F30.3"]},
        "3136": {"vr": "SH", "Value": ["SP F35.3"]},
        "3137": {"vr": "SH", "Value": ["SP F15.3"]},
        "3138": {"vr": "SH", "Value": ["SP F55.3"]},
        "3139": {"vr": "SH", "Value": ["SP H12.2"]},
        "3140": {"vr": "SH", "Value": ["SP F60.3"]},
        "3141": {"vr": "SH", "Value": ["SP F57.8"]},
        "3142": {"vr": "SH", "Value": ["SP F60.3"]},
        "3143": {"vr": "SH", "Value": ["SP H7.2"]},
        "3144": {"vr": "SH", "Value": ["SP H44.7"]},
        "3145": {"vr": "SH", "Value": ["SP F65.3"]},
        "3146": {"vr": "SH", "Value": ["SP H37.2"]},
        "3147": {"vr": "SH", "Value": ["SP H7.2"]},
        "3148": {"vr": "SH", "Value": ["SP H22.2"]},
        "3149": {"vr": "SH", "Value": ["SP H74.7"]},
        "3150": {"vr": "SH", "Value": ["SP F72.8"]},
        "3151": {"vr": "SH", "Value": ["SP H44.7"]},
        "3152": {"vr": "SH", "Value": ["SP H39.7"]},
        "3153": {"vr": "SH", "Value": ["SP H42.2"]},
        "3154": {"vr": "SH", "Value": ["SP F70.3"]},
        "3155": {"vr": "SH", "Value": ["SP H32.2"]},
        "3156": {"vr": "SH", "Value": ["SP F70.3"]},
        "3157": {"vr": "SH", "Value": ["SP H57.2"]},
        "3158": {"vr": "SH", "Value": ["SP F20.3"]},
        "3159": {"vr": "SH", "Value": ["SP F42.8"]},
        "3160": {"vr": "SH", "Value": ["SP H27.2"]},
        "3161": {"vr": "SH", "Value": ["SP H42.2"]},
        "3162": {"vr": "SH", "Value": ["SP F32.8"]},
        "3163": {"vr": "SH", "Value": ["SP F27.8"]},
        "3164": {"vr": "SH", "Value": ["SP H34.7"]},
        "3165": {"vr": "SH", "Value": ["SP F15.3"]},
        "3166": {"vr": "SH", "Value": ["SP F25.3"]},
        "3167": {"vr": "SH", "Value": ["SP F0.3"]},
        "3168": {"vr": "SH", "Value": ["SP F37.8"]},
        "3169": {"vr": "SH", "Value": ["SP H67.2"]},
        "3170": {"vr": "SH", "Value": ["SP H67.2"]},
        "3171": {"vr": "SH", "Value": ["SP H24.7"]},
        "3172": {"vr": "SH", "Value": ["SP F17.8"]},
        "3173": {"vr": "SH", "Value": ["SP H74.7"]},
        "3174": {"vr": "SH", "Value": ["SP H67.2"]},
        "3175": {"vr": "SH", "Value": ["SP H12.2"]},
        "3176": {"vr": "SH", "Value": ["SP H52.2"]},
        "3177": {"vr": "SH", "Value": ["SP F60.3"]},
        "3178": {"vr": "SH", "Value": ["SP H59.7"]},
        "3179": {"vr": "SH", "Value": ["SP F72.8"]},
        "3180": {"vr": "SH", "Value": ["SP F60.3"]},
        "3181": {"vr": "SH", "Value": ["SP F15.3"]},
        "3182": {"vr": "SH", "Value": ["SP H2.2"]},
        "3183": {"vr": "SH", "Value": ["SP F7.8"]},
        "3184": {"vr": "SH", "Value": ["SP F62.8"]},
        "3185": {"vr": "SH", "Value": ["SP H29.7"]},
        "3186": {"vr": "SH", "Value": ["SP F30.3"]},
        "3187": {"vr": "SH", "Value": ["SP F5.3"]},
        "3188": {"vr": "SH", "Value": ["SP H44.7"]},
        "3189": {"vr": "SH", "Value": ["SP H74.7"]},
        "3190": {"vr": "SH", "Value": ["SP F25.3"]},
        "3191": {"vr": "SH", "Value": ["SP H44.7"]},
        "3192": {"vr": "SH", "Value": ["SP H74.7"]},
        "3193": {"vr": "SH", "Value": ["SP H49.7"]},
        "3194": {"vr": "SH", "Value": ["SP H37.2"]},
        "3195": {"vr": "SH", "Value": ["SP F50.3"]},
        "3196": {"vr": "SH", "Value": ["SP H24.7"]},
        "3197": {"vr": "SH", "Value": ["SP F70.3"]},
        "3198": {"vr": "SH", "Value": ["SP F27.8"]},
        "3199": {"vr": "SH", "Value": ["SP F20.3"]},
        "3200": {"vr": "SH", "Value": ["SP H7.2"]},
        "3201": {"vr": "SH", "Value": ["SP F17.8"]},
        "3202": {"vr": "SH", "Value": ["SP F30.3"]},
        "3203": {"vr": "SH", "Value": ["SP H67.2"]},
        "3204": {"vr": "SH", "Value": ["SP F40.3"]},
        "3205": {"vr": "SH", "Value": ["SP F7.8"]},
        "3206": {"vr": "SH", "Value": ["SP F22.8"]},
        "3207": {"vr": "SH", "Value": ["SP F50.3"]},
        "3208": {"vr": "SH", "Value": ["SP H19.7"]},
        "3209": {"vr": "SH", "Value": ["SP H62.2"]},
        "3210": {"vr": "SH", "Value": ["SP F40.3"]},
        "3211": {"vr": "SH", "Value": ["SP H39.7"]},
        "3212": {"vr": "SH", "Value": ["SP H69.7"]},
        "3213": {"vr": "SH", "Value": ["SP F0.3"]},
        "3214": {"vr": "SH", "Value": ["SP H74.7"]},
        "3215": {"vr": "SH", "Value": ["SP H2.2"]},
        "3216": {"vr": "SH", "Value": ["SP H69.7"]},
        "3217": {"vr": "SH", "Value": ["SP F37.8"]},
        "3218": {"vr": "SH", "Value": ["SP F72.8"]},
        "3219": {"vr": "SH", "Value": ["SP H24.7"]},
        "3220": {"vr": "SH", "Value": ["SP H44.7"]},
        "3221": {"vr": "SH", "Value": ["SP H7.2"]},
        "3222": {"vr": "SH", "Value": ["SP F67.8"]},
        "3223": {"vr": "SH", "Value": ["SP F62.8"]},
        "3224": {"vr": "SH", "Value": ["SP H74.7"]},
        "3225": {"vr": "SH", "Value": ["SP F12.8"]},
        "3226": {"vr": "SH", "Value": ["SP H39.7"]},
        "3227": {"vr": "SH", "Value": ["SP H4.7"]},
        "3228": {"vr": "SH", "Value": ["SP F42.8"]},
        "3229": {"vr": "SH", "Value": ["SP F40.3"]},
        "3230": {"vr": "SH", "Value": ["SP F57.8"]},
        "3231": {"vr": "SH", "Value": ["SP F25.3"]},
        "3232": {"vr": "SH", "Value": ["SP F30.3"]},
        "3233": {"vr": "SH", "Value": ["SP F45.3"]},
        "3234": {"vr": "SH", "Value": ["SP F5.3"]},
        "3235": {"vr": "SH", "Value": ["SP H34.7"]},
        "3236": {"vr": "SH", "Value": ["SP F15.3"]},
        "3237": {"vr": "SH", "Value": ["SP H69.7"]},
        "3238": {"vr": "SH", "Value": ["SP H54.7"]},
        "3239": {"vr": "SH", "Value": ["SP F10.3"]},
        "3240": {"vr": "SH", "Value": ["SP F27.8"]},
        "3241": {"vr": "SH", "Value": ["SP H29.7"]},
        "3242": {"vr": "SH", "Value": ["SP F22.8"]},
        "3243": {"vr": "SH", "Value": ["SP H27.2"]},
        "3244": {"vr": "SH", "Value": ["SP H9.7"]},
        "3245": {"vr": "SH", "Value": ["SP F57.8"]},
        "3246": {"vr": "SH", "Value": ["SP F62.8"]},
        "3247": {"vr": "SH", "Value": ["SP H24.7"]},
        "3248": {"vr": "SH", "Value": ["SP H42.2"]},
        "3249": {"vr": "SH", "Value": ["SP H52.2"]},
        "3250": {"vr": "SH", "Value": ["SP H32.2"]},
        "3251": {"vr": "SH", "Value": ["SP H42.2"]},
        "3252": {"vr": "SH", "Value": ["SP F0.3"]},
        "3253": {"vr": "SH", "Value": ["SP F2.8"]},
        "3254": {"vr": "SH", "Value": ["SP F65.3"]},
        "3255": {"vr": "SH", "Value": ["SP H42.2"]},
        "3256": {"vr": "SH", "Value": ["SP F12.8"]},
        "3257": {"vr": "SH", "Value": ["SP H7.2"]},
        "3258": {"vr": "SH", "Value": ["SP F42.8"]},
        "3259": {"vr": "SH", "Value": ["SP H12.2"]},
        "3260": {"vr": "SH", "Value": ["SP H4.7"]},
        "3261": {"vr": "SH", "Value": ["SP F57.8"]},
        "3262": {"vr": "SH", "Value": ["SP F45.3"]},
        "3263": {"vr": "SH", "Value": ["SP F22.8"]},
        "3264": {"vr": "SH", "Value": ["SP H32.2"]},
        "3265": {"vr": "SH", "Value": ["SP H34.7"]},
        "3266": {"vr": "SH", "Value": ["SP H2.2"]},
        "3267": {"vr": "SH", "Value": ["SP H49.7"]},
        "3268": {"vr": "SH", "Value": ["SP H57.2"]},
        "3269": {"vr": "SH", "Value": ["SP F45.3"]},
        "3270": {"vr": "SH", "Value": ["SP F10.3"]},
        "3271": {"vr": "SH", "Value": ["SP H52.2"]},
        "3272": {"vr": "SH", "Value": ["SP H24.7"]},
        "3273": {"vr": "SH", "Value": ["SP F10.3"]},
        "3274": {"vr": "SH", "Value": ["SP F7.8"]},
        "3275": {"vr": "SH", "Value": ["SP H34.7"]},
        "3276": {"vr": "SH", "Value": ["SP H49.7"]},
        "3277": {"vr": "SH", "Value": ["SP H29.7"]},
        "3278": {"vr": "SH", "Value": ["SP H54.7"]},
        "3279": {"vr": "SH", "Value": ["SP F57.8"]},
        "3280": {"vr": "SH", "Value": ["SP F17.8"]},
        "3281": {"vr": "SH", "Value": ["SP F5.3"]},
        "3282": {"vr": "SH", "Value": ["SP F7.8"]},
        "3283": {"vr": "SH", "Value": ["SP H42.2"]},
        "3284": {"vr": "SH", "Value": ["SP F0.3"]},
        "3285": {"vr": "SH", "Value": ["SP F15.3"]},
        "3286": {"vr": "SH", "Value": ["SP F32.8"]},
        "3287": {"vr": "SH", "Value": ["SP F0.3"]},
        "3288": {"vr": "SH", "Value": ["SP F17.8"]},
        "3289": {"vr": "SH", "Value": ["SP H67.2"]},
        "3290": {"vr": "SH", "Value": ["SP H44.7"]},
        "3291": {"vr": "SH", "Value": ["SP H67.2"]},
        "3292": {"vr": "SH", "Value": ["SP F30.3"]},
        "3293": {"vr": "SH", "Value": ["SP H67.2"]},
        "3294": {"vr": "SH", "Value": ["SP F5.3"]},
        "3295": {"vr": "SH", "Value": ["SP H19.7"]},
        "3296": {"vr": "SH", "Value": ["SP H22.2"]},
        "3297": {"vr": "SH", "Value": ["SP H54.7"]},
        "3298": {"vr": "SH", "Value": ["SP F50.3"]},
        "3299": {"vr": "SH", "Value": ["SP H69.7"]},
        "3300": {"vr": "SH", "Value": ["SP H72.2"]},
        "3301": {"vr": "SH", "Value": ["SP H64.7"]},
        "3302": {"vr": "SH", "Value": ["SP H9.7"]},
        "3303": {"vr": "SH", "Value": ["SP H64.7"]},
        "3304": {"vr": "SH", "Value": ["SP H37.2"]},
        "3305": {"vr": "SH", "Value": ["SP H19.7"]},
        "3306": {"vr": "SH", "Value": ["SP H22.2"]},
        "3307": {"vr": "SH", "Value": ["SP H67.2"]},
        "3308": {"vr": "SH", "Value": ["SP F40.3"]},
        "3309": {"vr": "SH", "Value": ["SP F22.8"]},
        "3310": {"vr": "SH", "Value": ["SP F5.3"]},
        "3311": {"vr": "SH", "Value": ["SP F22.8"]},
        "3312": {"vr": "SH", "Value": ["SP H57.2"]},
        "3313": {"vr": "SH", "Value": ["SP F20.3"]},
        "3314": {"vr": "SH", "Value": ["SP H69.7"]},
        "3315": {"vr": "SH", "Value": ["SP H72.2"]},
        "3316": {"vr": "SH", "Value": ["SP H72.2"]},
        "3317": {"vr": "SH", "Value": ["SP H14.7"]},
        "3318": {"vr": "SH", "Value": ["SP H9.7"]},
        "3319": {"vr": "SH", "Value": ["SP H37.2"]},
        "3320": {"vr": "SH", "Value": ["SP H67.2"]},
        "3321": {"vr": "SH", "Value": ["SP H37.2"]},
        "3322": {"vr": "SH", "Value": ["SP F22.8"]},
        "3323": {"vr": "SH", "Value": ["SP H62.2"]},
        "3324": {"vr": "SH", "Value": ["SP H54.7"]},
        "3325": {"vr": "SH", "Value": ["SP H39.7"]},
        "3326": {"vr": "SH", "Value": ["SP H47.2"]},
        "3327": {"vr": "SH", "Value": ["SP H42.2"]},
        "3328": {"vr": "SH", "Value": ["SP H14.7"]},
        "3329": {"vr": "SH", "Value": ["SP H49.7"]},
        "3330": {"vr": "SH", "Value": ["SP H42.2"]},
        "3331": {"vr": "SH", "Value": ["SP F5.3"]},
        "3332": {"vr": "SH", "Value": ["SP H4.7"]},
        "3333": {"vr": "SH", "Value": ["SP H42.2"]},
        "3334": {"vr": "SH", "Value": ["SP H14.7"]},
        "3335": {"vr": "SH", "Value": ["SP H14.7"]},
        "3336": {"vr": "SH", "Value": ["SP H54.7"]},
        "3337": {"vr": "SH", "Value": ["SP F70.3"]},
        "3338": {"vr": "SH", "Value": ["SP F45.3"]},
        "3339": {"vr": "SH", "Value": ["SP H29.7"]},
        "3340": {"vr": "SH", "Value": ["SP F70.3"]},
        "3341": {"vr": "SH", "Value": ["SP F25.3"]},
        "3342": {"vr": "SH", "Value": ["SP F35.3"]},
        "3343": {"vr": "SH", "Value": ["SP H74.7"]},
        "3344": {"vr": "SH", "Value": ["SP F2.8"]},
        "3345": {"vr": "SH", "Value": ["SP F7.8"]},
        "3346": {"vr": "SH", "Value": ["SP F5.3"]},
        "3347": {"vr": "SH", "Value": ["SP H54.7"]},
        "3348": {"vr": "SH", "Value": ["SP F10.3"]},
        "3349": {"vr": "SH", "Value": ["SP F32.8"]},
        "3350": {"vr": "SH", "Value": ["SP F70.3"]},
        "3351": {"vr": "SH", "Value": ["SP F15.3"]},
        "3352": {"vr": "SH", "Value": ["SP F57.8"]},
        "3353": {"vr": "SH", "Value": ["SP H44.7"]},
        "3354": {"vr": "SH", "Value": ["SP H59.7"]},
        "3355": {"vr": "SH", "Value": ["SP H74.7"]},
        "3356": {"vr": "SH", "Value": ["SP F52.8"]},
        "3357": {"vr": "SH", "Value": ["SP F32.8"]},
        "3358": {"vr": "SH", "Value": ["SP F17.8"]},
        "3359": {"vr": "SH", "Value": ["SP F47.8"]},
        "3360": {"vr": "SH", "Value": ["SP H24.7"]},
        "3361": {"vr": "SH", "Value": ["SP H9.7"]},
        "3362": {"vr": "SH", "Value": ["SP F45.3"]},
        "3363": {"vr": "SH", "Value": ["SP H62.2"]},
        "3364": {"vr": "SH", "Value": ["SP F22.8"]},
        "3365": {"vr": "SH", "Value": ["SP F47.8"]},
        "3366": {"vr": "SH", "Value": ["SP H34.7"]},
        "3367": {"vr": "SH", "Value": ["SP H39.7"]},
        "3368": {"vr": "SH", "Value": ["SP H17.2"]},
        "3369": {"vr": "SH", "Value": ["SP H49.7"]},
        "3370": {"vr": "SH", "Value": ["SP F25.3"]},
        "3371": {"vr": "SH", "Value": ["SP F42.8"]},
        "3372": {"vr": "SH", "Value": ["SP F10.3"]},
        "3373": {"vr": "SH", "Value": ["SP F32.8"]},
        "3374": {"vr": "SH", "Value": ["SP F25.3"]},
        "3375": {"vr": "SH", "Value": ["SP H22.2"]},
        "3376": {"vr": "SH", "Value": ["SP H74.7"]},
        "3377": {"vr": "SH", "Value": ["SP H9.7"]},
        "3378": {"vr": "SH", "Value": ["SP H67.2"]},
        "3379": {"vr": "SH", "Value": ["SP F10.3"]},
        "3380": {"vr": "SH", "Value": ["SP F0.3"]},
        "3381": {"vr": "SH", "Value": ["SP H19.7"]},
        "3382": {"vr": "SH", "Value": ["SP H69.7"]},
        "3383": {"vr": "SH", "Value": ["SP H12.2"]},
        "3384": {"vr": "SH", "Value": ["SP F10.3"]},
        "3385": {"vr": "SH", "Value": ["SP F0.3"]},
        "3386": {"vr": "SH", "Value": ["SP F42.8"]},
        "3387": {"vr": "SH", "Value": ["SP F10.3"]},
        "3388": {"vr": "SH", "Value": ["SP H37.2"]},
        "3389": {"vr": "SH", "Value": ["SP F30.3"]},
        "3390": {"vr": "SH", "Value": ["SP F42.8"]},
        "3391": {"vr": "SH", "Value": ["SP F15.3"]},
        "3392": {"vr": "SH", "Value": ["SP F32.8"]},
        "3393": {"vr": "SH", "Value": ["SP H47.2"]},
        "3394": {"vr": "SH", "Value": ["SP F40.3"]},
        "3395": {"vr": "SH", "Value": ["SP F37.8"]},
        "3396": {"vr": "SH", "Value": ["SP H69.7"]},
        "3397": {"vr": "SH", "Value": ["SP H4.7"]},
        "3398": {"vr": "SH", "Value": ["SP F60.3"]},
        "3399": {"vr": "SH", "Value": ["SP H9.7"]},
        "3400": {"vr": "SH", "Value": ["SP F22.8"]},
        "3401": {"vr": "SH", "Value": ["SP H47.2"]},
        "3402": {"vr": "SH", "Value": ["SP F67.8"]},
        "3403": {"vr": "SH", "Value": ["SP H34.7"]},
        "3404": {"vr": "SH", "Value": ["SP H29.7"]},
        "3405": {"vr": "SH", "Value": ["SP F57.8"]},
        "3406": {"vr": "SH", "Value": ["SP F32.8"]},
        "3407": {"vr": "SH", "Value": ["SP H12.2"]},
        "3408": {"vr": "SH", "Value": ["SP F7.8"]},
        "3409": {"vr": "SH", "Value": ["SP F72.8"]},
        "3410": {"vr": "SH", "Value": ["SP F27.8"]},
        "3411": {"vr": "SH", "Value": ["SP H59.7"]},
        "3412": {"vr": "SH", "Value": ["SP F72.8"]},
        "3413": {"vr": "SH", "Value": ["SP F15.3"]},
        "3414": {"vr": "SH", "Value": ["SP F45.3"]},
        "3415": {"vr": "SH", "Value": ["SP H14.7"]},
        "3416": {"vr": "SH", "Value": ["SP F42.8"]},
        "3417": {"vr": "SH", "Value": ["SP H64.7"]},
        "3418": {"vr": "SH", "Value": ["SP H22.2"]},
        "3419": {"vr": "SH", "Value": ["SP F32.8"]},
        "3420": {"vr": "SH", "Value": ["SP H17.2"]},
        "3421": {"vr": "SH", "Value": ["SP F72.8"]},
        "3422": {"vr": "SH", "Value": ["SP H34.7"]},
        "3423": {"vr": "SH", "Value": ["SP F40.3"]},
        "3424": {"vr": "SH", "Value": ["SP H47.2"]},
        "3425": {"vr": "SH", "Value": ["SP H44.7"]},
        "3426": {"vr": "SH", "Value": ["SP F52.8"]},
        "3427": {"vr": "SH", "Value": ["SP H64.7"]},
        "3428": {"vr": "SH", "Value": ["SP H59.7"]},
        "3429": {"vr": "SH", "Value": ["SP H34.7"]},
        "3430": {"vr": "SH", "Value": ["SP F62.8"]},
        "3431": {"vr": "SH", "Value": ["SP H44.7"]},
        "3432": {"vr": "SH", "Value": ["SP F70.3"]},
        "3433": {"vr": "SH", "Value": ["SP F22.8"]},
        "3434": {"vr": "SH", "Value": ["SP F60.3"]},
        "3435": {"vr": "SH", "Value": ["SP H59.7"]},
        "3436": {"vr": "SH", "Value": ["SP F47.8"]},
        "3437": {"vr": "SH", "Value": ["SP F25.3"]},
        "3438": {"vr": "SH", "Value": ["SP H22.2"]},
        "3439": {"vr": "SH", "Value": ["SP F47.8"]},
        "3440": {"vr": "SH", "Value": ["SP F15.3"]},
        "3441": {"vr": "SH", "Value": ["SP F62.8"]},
        "3442": {"vr": "SH", "Value": ["SP H34.7"]},
        "3443": {"vr": "SH", "Value": ["SP H19.7"]},
        "3444": {"vr": "SH", "Value": ["SP F57.8"]},
        "3445": {"vr": "SH", "Value": ["SP H69.7"]},
        "3446": {"vr": "SH", "Value": ["SP H9.7"]},
        "3447": {"vr": "SH", "Value": ["SP F67.8"]},
        "3448": {"vr": "SH", "Value": ["SP F67.8"]},
        "3449": {"vr": "SH", "Value": ["SP H19.7"]},
        "3450": {"vr": "SH", "Value": ["SP F67.8"]},
        "3451": {"vr": "SH", "Value": ["SP H14.7"]},
        "3452": {"vr": "SH", "Value": ["SP H17.2"]},
        "3453": {"vr": "SH", "Value": ["SP F15.3"]},
        "3454": {"vr": "SH", "Value": ["SP F10.3"]},
        "3455": {"vr": "SH", "Value": ["SP H39.7"]},
        "3456": {"vr": "SH", "Value": ["SP H74.7"]},
        "3457": {"vr": "SH", "Value": ["SP F72.8"]},
        "3458": {"vr": "SH", "Value": ["SP H54.7"]},
        "3459": {"vr": "SH", "Value": ["SP H19.7"]},
        "3460": {"vr": "SH", "Value": ["SP H59.7"]},
        "3461": {"vr": "SH", "Value": ["SP H24.7"]},
        "3462": {"vr": "SH", "Value": ["SP H2.2"]},
        "3463": {"vr": "SH", "Value": ["SP H54.7"]},
        "3464": {"vr": "SH", "Value": ["SP F45.3"]},
        "3465": {"vr": "SH", "Value": ["SP H32.2"]},
        "3466": {"vr": "SH", "Value": ["SP F2.8"]},
        "3467": {"vr": "SH", "Value": ["SP H64.7"]},
        "3468": {"vr": "SH", "Value": ["SP H39.7"]},
        "3469": {"vr": "SH", "Value": ["SP H17.2"]},
        "3470": {"vr": "SH", "Value": ["SP H2.2"]},
        "3471": {"vr": "SH", "Value": ["SP F0.3"]},
        "3472": {"vr": "SH", "Value": ["SP F32.8"]},
        "3473": {"vr": "SH", "Value": ["SP F55.3"]},
        "3474": {"vr": "SH", "Value": ["SP H22.2"]},
        "3475": {"vr": "SH", "Value": ["SP F60.3"]},
        "3476": {"vr": "SH", "Value": ["SP F35.3"]},
        "3477": {"vr": "SH", "Value": ["SP H69.7"]},
        "3478": {"vr": "SH", "Value": ["SP H67.2"]},
        "3479": {"vr": "SH", "Value": ["SP F17.8"]},
        "3480": {"vr": "SH", "Value": ["SP F7.8"]},
        "3481": {"vr": "SH", "Value": ["SP H9.7"]},
        "3482": {"vr": "SH", "Value": ["SP F67.8"]},
        "3483": {"vr": "SH", "Value": ["SP H7.2"]},
        "3484": {"vr": "SH", "Value": ["SP F62.8"]},
        "3485": {"vr": "SH", "Value": ["SP H34.7"]},
        "3486": {"vr": "SH", "Value": ["SP F57.8"]},
        "3487": {"vr": "SH", "Value": ["SP F57.8"]},
        "3488": {"vr": "SH", "Value": ["SP H22.2"]},
        "3489": {"vr": "SH", "Value": ["SP F15.3"]},
        "3490": {"vr": "SH", "Value": ["SP H54.7"]},
        "3491": {"vr": "SH", "Value": ["SP H4.7"]},
        "3492": {"vr": "SH", "Value": ["SP F52.8"]},
        "3493": {"vr": "SH", "Value": ["SP F67.8"]},
        "3494": {"vr": "SH", "Value": ["SP H69.7"]},
        "3495": {"vr": "SH", "Value": ["SP F12.8"]},
        "3496": {"vr": "SH", "Value": ["SP H42.2"]},
        "3497": {"vr": "SH", "Value": ["SP F0.3"]},
        "3498": {"vr": "SH", "Value": ["SP F67.8"]},
        "3499": {"vr": "SH", "Value": ["SP H27.2"]},
        "3500": {"vr": "SH", "Value": ["SP F67.8"]},
        "3501": {"vr": "SH", "Value": ["SP H57.2"]},
        "3502": {"vr": "SH", "Value": ["SP F60.3"]},
        "3503": {"vr": "SH", "Value": ["SP H29.7"]},
        "3504": {"vr": "SH", "Value": ["SP F27.8"]},
        "3505": {"vr": "SH", "Value": ["SP H34.7"]},
        "3506": {"vr": "SH", "Value": ["SP F65.3"]},
        "3507": {"vr": "SH", "Value": ["SP F42.8"]},
        "3508": {"vr": "SH", "Value": ["SP F7.8"]},
        "3509": {"vr": "SH", "Value": ["SP H7.2"]},
        "3510": {"vr": "SH", "Value": ["SP H24.7"]},
        "3511": {"vr": "SH", "Value": ["SP H54.7"]},
        "3512": {"vr": "SH", "Value": ["SP F22.8"]},
        "3513": {"vr": "SH", "Value": ["SP F25.3"]},
        "3514": {"vr": "SH", "Value": ["SP H54.7"]},
        "3515": {"vr": "SH", "Value": ["SP H62.2"]},
        "3516": {"vr": "SH", "Value": ["SP H52.2"]},
        "3517": {"vr": "SH", "Value": ["SP F47.8"]},
        "3518": {"vr": "SH", "Value": ["SP F22.8"]},
        "3519": {"vr": "SH", "Value": ["SP F5.3"]},
        "3520": {"vr": "SH", "Value": ["SP F62.8"]},
        "3521": {"vr": "SH", "Value": ["SP H44.7"]},
        "3522": {"vr": "SH", "Value": ["SP F70.3"]},
        "3523": {"vr": "SH", "Value": ["SP F12.8"]},
        "3524": {"vr": "SH", "Value": ["SP F42.8"]},
        "3525": {"vr": "SH", "Value": ["SP F5.3"]},
        "3526": {"vr": "SH", "Value": ["SP H49.7"]},
        "3527": {"vr": "SH", "Value": ["SP F25.3"]},
        "3528": {"vr": "SH", "Value": ["SP F52.8"]},
        "3529": {"vr": "SH", "Value": ["SP F0.3"]},
        "3530": {"vr": "SH", "Value": ["SP F62.8"]},
        "3531": {"vr": "SH", "Value": ["SP F17.8"]},
        "3532": {"vr": "SH", "Value": ["SP F55.3"]},
        "3533": {"vr": "SH", "Value": ["SP H22.2"]},
        "3534": {"vr": "SH", "Value": ["SP F22.8"]},
        "3535": {"vr": "SH", "Value": ["SP H67.2"]},
        "3536": {"vr": "SH", "Value": ["SP H47.2"]},
        "3537": {"vr": "SH", "Value": ["SP F55.3"]},
        "3538": {"vr": "SH", "Value": ["SP H17.2"]},
        "3539": {"vr": "SH", "Value": ["SP H12.2"]},
        "3540": {"vr": "SH", "Value": ["SP F60.3"]},
        "3541": {"vr": "SH", "Value": ["SP F65.3"]},
        "3542": {"vr": "SH", "Value": ["SP H49.7"]},
        "3543": {"vr": "SH", "Value": ["SP H42.2"]},
        "3544": {"vr": "SH", "Value": ["SP F20.3"]},
        "3545": {"vr": "SH", "Value": ["SP F67.8"]},
        "3546": {"vr": "SH", "Value": ["SP F47.8"]},
        "3547": {"vr": "SH", "Value": ["SP H19.7"]},
        "3548": {"vr": "SH", "Value": ["SP H52.2"]},
        "3549": {"vr": "SH", "Value": ["SP F60.3"]},
        "3550": {"vr": "SH", "Value": ["SP F57.8"]},
        "3551": {"vr": "SH", "Value": ["SP H19.7"]},
        "3552": {"vr": "SH", "Value": ["SP H27.2"]},
        "3553": {"vr": "SH", "Value": ["SP H49.7"]},
        "3554": {"vr": "SH", "Value": ["SP F5.3"]},
        "3555": {"vr": "SH", "Value": ["SP F2.8"]},
        "3556": {"vr": "SH", "Value": ["SP F72.8"]},
        "3557": {"vr": "SH", "Value": ["SP H39.7"]},
        "3558": {"vr": "SH", "Value": ["SP H27.2"]},
        "3559": {"vr": "SH", "Value": ["SP F70.3"]},
        "3560": {"vr": "SH", "Value": ["SP F55.3"]},
        "3561": {"vr": "SH", "Value": ["SP F37.8"]},
        "3562": {"vr": "SH", "Value": ["SP F52.8"]},
        "3563": {"vr": "SH", "Value": ["SP H54.7"]},
        "3564": {"vr": "SH", "Value": ["SP H64.7"]},
        "3565": {"vr": "SH", "Value": ["SP H57.2"]},
        "3566": {"vr": "SH", "Value": ["SP F35.3"]},
        "3567": {"vr": "SH", "Value": ["SP F22.8"]},
        "3568": {"vr": "SH", "Value": ["SP F25.3"]},
        "3569": {"vr": "SH", "Value": ["SP F62.8"]},
        "3570": {"vr": "SH", "Value": ["SP F12.8"]},
        "3571": {"vr": "SH", "Value": ["SP H67.2"]},
        "3572": {"vr": "SH", "Value": ["SP F65.3"]},
        "3573": {"vr": "SH", "Value": ["SP F50.3"]},
        "3574": {"vr": "SH", "Value": ["SP F45.3"]},
        "3575": {"vr": "SH", "Value": ["SP H27.2"]},
        "3576": {"vr": "SH", "Value": ["SP H7.2"]},
        "3577": {"vr": "SH", "Value": ["SP H19.7"]},
        "3578": {"vr": "SH", "Value": ["SP F72.8"]},
        "3579": {"vr": "SH", "Value": ["SP H29.7"]},
        "3580": {"vr": "SH", "Value": ["SP F42.8"]},
        "3581": {"vr": "SH", "Value": ["SP F32.8"]},
        "3582": {"vr": "SH", "Value": ["SP F30.3"]},
        "3583": {"vr": "SH", "Value": ["SP F0.3"]},
        "3584": {"vr": "SH", "Value": ["SP H7.2"]},
        "3585": {"vr": "SH", "Value": ["SP H72.2"]},
        "3586": {"vr": "SH", "Value": ["SP F45.3"]},
        "3587": {"vr": "SH", "Value": ["SP H44.7"]},
        "3588": {"vr": "SH", "Value": ["SP F40.3"]},
        "3589": {"vr": "SH", "Value": ["SP H49.7"]},
        "3590": {"vr": "SH", "Value": ["SP H27.2"]},
        "3591": {"vr": "SH", "Value": ["SP H17.2"]},
        "3592": {"vr": "SH", "Value": ["SP H7.2"]},
        "3593": {"vr": "SH", "Value": ["SP H24.7"]},
        "3594": {"vr": "SH", "Value": ["SP F25.3"]},
        "3595": {"vr": "SH", "Value": ["SP F55.3"]},
        "3596": {"vr": "SH", "Value": ["SP H49.7"]},
        "3597": {"vr": "SH", "Value": ["SP F35.3"]},
        "3598": {"vr": "SH", "Value": ["SP F32.8"]},
        "3599": {"vr": "SH", "Value": ["SP H44.7"]},
        "3600": {"vr": "SH", "Value": ["SP F55.3"]},
        "3601": {"vr": "SH", "Value": ["SP H72.2"]},
        "3602": {"vr": "SH", "Value": ["SP H59.7"]},
        "3603": {"vr": "SH", "Value": ["SP H57.2"]},
        "3604": {"vr": "SH", "Value": ["SP H22.2"]},
        "3605": {"vr": "SH", "Value": ["SP H17.2"]},
        "3606": {"vr": "SH", "Value": ["SP F72.8"]},
        "3607": {"vr": "SH", "Value": ["SP F65.3"]},
        "3608": {"vr": "SH", "Value": ["SP H62.2"]},
        "3609": {"vr": "SH", "Value": ["SP H69.7"]},
        "3610": {"vr": "SH", "Value": ["SP F35.3"]},
        "3611": {"vr": "SH", "Value": ["SP F2.8"]},
        "3612": {"vr": "SH", "Value": ["SP H19.7"]},
        "3613": {"vr": "SH", "Value": ["SP F27.8"]},
        "3614": {"vr": "SH", "Value": ["SP F65.3"]},
        "3615": {"vr": "SH", "Value": ["SP H27.2"]},
        "3616": {"vr": "SH", "Value": ["SP F35.3"]},
        "3617": {"vr": "SH", "Value": ["SP F35.3"]},
        "3618": {"vr": "SH", "Value": ["SP F37.8"]},
        "3619": {"vr": "SH", "Value": ["SP F10.3"]},
        "3620": {"vr": "SH", "Value": ["SP F27.8"]},
        "3621": {"vr": "SH", "Value": ["SP H29.7"]},
        "3622": {"vr": "SH", "Value": ["SP F12.8"]},
        "3623": {"vr": "SH", "Value": ["SP H2.2"]},
        "3624": {"vr": "SH", "Value": ["SP F65.3"]},
        "3625": {"vr": "SH", "Value": ["SP H34.7"]},
        "3626": {"vr": "SH", "Value": ["SP F67.8"]},
        "3627": {"vr": "SH", "Value": ["SP F15.3"]},
        "3628": {"vr": "SH", "Value": ["SP H52.2"]},
        "3629": {"vr": "SH", "Value": ["SP F37.8"]},
        "3630": {"vr": "SH", "Value": ["SP H22.2"]},
        "3631": {"vr": "SH", "Value": ["SP H67.2"]},
        "3632": {"vr": "SH", "Value": ["SP F15.3"]},
        "3633": {"vr": "SH", "Value": ["SP F45.3"]},
        "3634": {"vr": "SH", "Value": ["SP H29.7"]},
        "3635": {"vr": "SH", "Value": ["SP F32.8"]},
        "3636": {"vr": "SH", "Value": ["SP H27.2"]},
        "3637": {"vr": "SH", "Value": ["SP H44.7"]},
        "3638": {"vr": "SH", "Value": ["SP H29.7"]},
        "3639": {"vr": "SH", "Value": ["SP F37.8"]},
        "3640": {"vr": "SH", "Value": ["SP F0.3"]},
        "3641": {"vr": "SH", "Value": ["SP F25.3"]},
        "3642": {"vr": "SH", "Value": ["SP H69.7"]},
        "3643": {"vr": "SH", "Value": ["SP F72.8"]},
        "3644": {"vr": "SH", "Value": ["SP F12.8"]},
        "3645": {"vr": "SH", "Value": ["SP F27.8"]},
        "3646": {"vr": "SH", "Value": ["SP F72.8"]},
        "3647": {"vr": "SH", "Value": ["SP H62.2"]},
        "3648": {"vr": "SH", "Value": ["SP F62.8"]},
        "3649": {"vr": "SH", "Value": ["SP F52.8"]},
        "3650": {"vr": "SH", "Value": ["SP H14.7"]},
        "3651": {"vr": "SH", "Value": ["SP H59.7"]},
        "3652": {"vr": "SH", "Value": ["SP F62.8"]},
        "3653": {"vr": "SH", "Value": ["SP H27.2"]},
        "3654": {"vr": "SH", "Value": ["SP F72.8"]},
        "3655": {"vr": "SH", "Value": ["SP F30.3"]},
        "3656": {"vr": "SH", "Value": ["SP F45.3"]},
        "3657": {"vr": "SH", "Value": ["SP H62.2"]},
        "3658": {"vr": "SH", "Value": ["SP H62.2"]},
        "3659": {"vr": "SH", "Value": ["SP F20.3"]},
        "3660": {"vr": "SH", "Value": ["SP F65.3"]},
        "3661": {"vr": "SH", "Value": ["SP F70.3"]},
        "3662": {"vr": "SH", "Value": ["SP H19.7"]},
        "3663": {"vr": "SH", "Value": ["SP F27.8"]},
        "3664": {"vr": "SH", "Value": ["SP F12.8"]},
        "3665": {"vr": "SH", "Value": ["SP H67.2"]},
        "3666": {"vr": "SH", "Value": ["SP F70.3"]},
        "3667": {"vr": "SH", "Value": ["SP H12.2"]},
        "3668": {"vr": "SH", "Value": ["SP F62.8"]},
        "3669": {"vr": "SH", "Value": ["SP F55.3"]},
        "3670": {"vr": "SH", "Value": ["SP H74.7"]},
        "3671": {"vr": "SH", "Value": ["SP H27.2"]},
        "3672": {"vr": "SH", "Value": ["SP H39.7"]},
        "3673": {"vr": "SH", "Value": ["SP H27.2"]},
        "3674": {"vr": "SH", "Value": ["SP H12.2"]},
        "3675": {"vr": "SH", "Value": ["SP F52.8"]},
        "3676": {"vr": "SH", "Value": ["SP H27.2"]},
        "3677": {"vr": "SH", "Value": ["SP F2.8"]},
        "3678": {"vr": "SH", "Value": ["SP H29.7"]},
        "3679": {"vr": "SH", "Value": ["SP H7.2"]},
        "3680": {"vr": "SH", "Value": ["SP F45.3"]},
        "3681": {"vr": "SH", "Value": ["SP F55.3"]},
        "3682": {"vr": "SH", "Value": ["SP H69.7"]},
        "3683": {"vr": "SH", "Value": ["SP F35.3"]},
        "3684": {"vr": "SH", "Value": ["SP F32.8"]},
        "3685": {"vr": "SH", "Value": ["SP F35.3"]},
        "3686": {"vr": "SH", "Value": ["SP H32.2"]},
        "3687": {"vr": "SH", "Value": ["SP H54.7"]},
        "3688": {"vr": "SH", "Value": ["SP H74.7"]},
        "3689": {"vr": "SH", "Value": ["SP F0.3"]},
        "3690": {"vr": "SH", "Value": ["SP H4.7"]},
        "3691": {"vr": "SH", "Value": ["SP F32.8"]},
        "3692": {"vr": "SH", "Value": ["SP F0.3"]},
        "3693": {"vr": "SH", "Value": ["SP H22.2"]},
        "3694": {"vr": "SH", "Value": ["SP F22.8"]},
        "3695": {"vr": "SH", "Value": ["SP F35.3"]},
        "3696": {"vr": "SH", "Value": ["SP F40.3"]},
        "3697": {"vr": "SH", "Value": ["SP F62.8"]},
        "3698": {"vr": "SH", "Value": ["SP F10.3"]},
        "3699": {"vr": "SH", "Value": ["SP F5.3"]},
        "3700": {"vr": "SH", "Value": ["SP H64.7"]},
        "3701": {"vr": "SH", "Value": ["SP F2.8"]},
        "3702": {"vr": "SH", "Value": ["SP F7.8"]},
        "3703": {"vr": "SH", "Value": ["SP F40.3"]},
        "3704": {"vr": "SH", "Value": ["SP H54.7"]},
        "3705": {"vr": "SH", "Value": ["SP F15.3"]},
        "3706": {"vr": "SH", "Value": ["SP H19.7"]},
        "3707": {"vr": "SH", "Value": ["SP F30.3"]},
        "3708": {"vr": "SH", "Value": ["SP F37.8"]},
        "3709": {"vr": "SH", "Value": ["SP F45.3"]},
        "3710": {"vr": "SH", "Value": ["SP H42.2"]},
        "3711": {"vr": "SH", "Value": ["SP F20.3"]},
        "3712": {"vr": "SH", "Value": ["SP H17.2"]},
        "3713": {"vr": "SH", "Value": ["SP H72.2"]},
        "3714": {"vr": "SH", "Value": ["SP H24.7"]},
        "3715": {"vr": "SH", "Value": ["SP H32.2"]},
        "3716": {"vr": "SH", "Value": ["SP H64.7"]},
        "3717": {"vr": "SH", "Value": ["SP H59.7"]},
        "3718": {"vr": "SH", "Value": ["SP H17.2"]},
        "3719": {"vr": "SH", "Value": ["SP F17.8"]},
        "3720": {"vr": "SH", "Value": ["SP H52.2"]},
        "3721": {"vr": "SH", "Value": ["SP H74.7"]},
        "3722": {"vr": "SH", "Value": ["SP H29.7"]},
        "3723": {"vr": "SH", "Value": ["SP H64.7"]},
        "3724": {"vr": "SH", "Value": ["SP F47.8"]},
        "3725": {"vr": "SH", "Value": ["SP F15.3"]},
        "3726": {"vr": "SH", "Value": ["SP H57.2"]},
        "3727": {"vr": "SH", "Value": ["SP F30.3"]},
        "3728": {"vr": "SH", "Value": ["SP H12.2"]},
        "3729": {"vr": "SH", "Value": ["SP F10.3"]},
        "3730": {"vr": "SH", "Value": ["SP H4.7"]},
        "3731": {"vr": "SH", "Value": ["SP F52.8"]},
        "3732": {"vr": "SH", "Value": ["SP H44.7"]},
        "3733": {"vr": "SH", "Value": ["SP H37.2"]},
        "3734": {"vr": "SH", "Value": ["SP F57.8"]},
        "3735": {"vr": "SH", "Value": ["SP H67.2"]},
        "3736": {"vr": "SH", "Value": ["SP F35.3"]},
        "3737": {"vr": "SH", "Value": ["SP H37.2"]},
        "3738": {"vr": "SH", "Value": ["SP H42.2"]},
        "3739": {"vr": "SH", "Value": ["SP H27.2"]},
        "3740": {"vr": "SH", "Value": ["SP F70.3"]},
        "3741": {"vr": "SH", "Value": ["SP H49.7"]},
        "3742": {"vr": "SH", "Value": ["SP F45.3"]},
        "3743": {"vr": "SH", "Value": ["SP H29.7"]},
        "3744": {"vr": "SH", "Value": ["SP F7.8"]},
        "3745": {"vr": "SH", "Value": ["SP H54.7"]},
        "3746": {"vr": "SH", "Value": ["SP H12.2"]},
        "3747": {"vr": "SH", "Value": ["SP H14.7"]},
        "3748": {"vr": "SH", "Value": ["SP H74.7"]},
        "3749": {"vr": "SH", "Value": ["SP H54.7"]},
        "3750": {"vr": "SH", "Value": ["SP H34.7"]},
        "3751": {"vr": "SH", "Value": ["SP F47.8"]},
        "3752": {"vr": "SH", "Value": ["SP H37.2"]},
        "3753": {"vr": "SH", "Value": ["SP H22.2"]},
        "3754": {"vr": "SH", "Value": ["SP H4.7"]},
        "3755": {"vr": "SH", "Value": ["SP H17.2"]},
        "3756": {"vr": "SH", "Value": ["SP F35.3"]},
        "3757": {"vr": "SH", "Value": ["SP H72.2"]},
        "3758": {"vr": "SH", "Value": ["SP H49.7"]},
        "3759": {"vr": "SH", "Value": ["SP F20.3"]},
        "3760": {"vr": "SH", "Value": ["SP H22.2"]},
        "3761": {"vr": "SH", "Value": ["SP H37.2"]},
        "3762": {"vr": "SH", "Value": ["SP H57.2"]},
        "3763": {"vr": "SH", "Value": ["SP H12.2"]},
        "3764": {"vr": "SH", "Value": ["SP F35.3"]},
        "3765": {"vr": "SH", "Value": ["SP H34.7"]},
        "3766": {"vr": "SH", "Value": ["SP H49.7"]},
        "3767": {"vr": "SH", "Value": ["SP F62.8"]},
        "3768": {"vr": "SH", "Value": ["SP F62.8"]},
        "3769": {"vr": "SH", "Value": ["SP H52.2"]},
        "3770": {"vr": "SH", "Value": ["SP F25.3"]},
        "3771": {"vr": "SH", "Value": ["SP F7.8"]},
        "3772": {"vr": "SH", "Value": ["SP H14.7"]},
        "3773": {"vr": "SH", "Value": ["SP F27.8"]},
        "3774": {"vr": "SH", "Value": ["SP H22.2"]},
        "3775": {"vr": "SH", "Value": ["SP F17.8"]},
        "3776": {"vr": "SH", "Value": ["SP H42.2"]},
        "3777": {"vr": "SH", "Value": ["SP H59.7"]},
        "3778": {"vr": "SH", "Value": ["SP H9.7"]},
        "3779": {"vr": "SH", "Value": ["SP F35.3"]},
        "3780": {"vr": "SH", "Value": ["SP F70.3"]},
        "3781": {"vr": "SH", "Value": ["SP F17.8"]},
        "3782": {"vr": "SH", "Value": ["SP H69.7"]},
        "3783": {"vr": "SH", "Value": ["SP F47.8"]},
        "3784": {"vr": "SH", "Value": ["SP H42.2"]},
        "3785": {"vr": "SH", "Value": ["SP H72.2"]},
        "3786": {"vr": "SH", "Value": ["SP H52.2"]},
        "3787": {"vr": "SH", "Value": ["SP F22.8"]},
        "3788": {"vr": "SH", "Value": ["SP H74.7"]},
        "3789": {"vr": "SH", "Value": ["SP H69.7"]},
        "3790": {"vr": "SH", "Value": ["SP H19.7"]},
        "3791": {"vr": "SH", "Value": ["SP H44.7"]},
        "3792": {"vr": "SH", "Value": ["SP F67.8"]},
        "3793": {"vr": "SH", "Value": ["SP H29.7"]},
        "3794": {"vr": "SH", "Value": ["SP H67.2"]},
        "3795": {"vr": "SH", "Value": ["SP H74.7"]},
        "3796": {"vr": "SH", "Value": ["SP H27.2"]},
        "3797": {"vr": "SH", "Value": ["SP F62.8"]},
        "3798": {"vr": "SH", "Value": ["SP F2.8"]},
        "3799": {"vr": "SH", "Value": ["SP H12.2"]},
        "3800": {"vr": "SH", "Value": ["SP F37.8"]},
        "3801": {"vr": "SH", "Value": ["SP H39.7"]},
        "3802": {"vr": "SH", "Value": ["SP F42.8"]},
        "3803": {"vr": "SH", "Value": ["SP F10.3"]},
        "3804": {"vr": "SH", "Value": ["SP H17.2"]},
        "3805": {"vr": "SH", "Value": ["SP H69.7"]},
        "3806": {"vr": "SH", "Value": ["SP H67.2"]},
        "3807": {"vr": "SH", "Value": ["SP H72.2"]},
        "3808": {"vr": "SH", "Value": ["SP F20.3"]},
        "3809": {"vr": "SH", "Value": ["SP F67.8"]},
        "3810": {"vr": "SH", "Value": ["SP F12.8"]},
        "3811": {"vr": "SH", "Value": ["SP F7.8"]},
        "3812": {"vr": "SH", "Value": ["SP F15.3"]},
        "3813": {"vr": "SH", "Value": ["SP H22.2"]},
        "3814": {"vr": "SH", "Value": ["SP H57.2"]},
        "3815": {"vr": "SH", "Value": ["SP H7.2"]},
        "3816": {"vr": "SH", "Value": ["SP H14.7"]},
        "3817": {"vr": "SH", "Value": ["SP F62.8"]},
        "3818": {"vr": "SH", "Value": ["SP F27.8"]},
        "3819": {"vr": "SH", "Value": ["SP F47.8"]},
        "3820": {"vr": "SH", "Value": ["SP F20.3"]},
        "3821": {"vr": "SH", "Value": ["SP H74.7"]},
        "3822": {"vr": "SH", "Value": ["SP F52.8"]},
        "3823": {"vr": "SH", "Value": ["SP H29.7"]},
        "3824": {"vr": "SH", "Value": ["SP F17.8"]},
        "3825": {"vr": "SH", "Value": ["SP F20.3"]},
        "3826": {"vr": "SH", "Value": ["SP F25.3"]},
        "3827": {"vr": "SH", "Value": ["SP F70.3"]},
        "3828": {"vr": "SH", "Value": ["SP F40.3"]},
        "3829": {"vr": "SH", "Value": ["SP H29.7"]},
        "3830": {"vr": "SH", "Value": ["SP F27.8"]},
        "3831": {"vr": "SH", "Value": ["SP F40.3"]},
        "3832": {"vr": "SH", "Value": ["SP H12.2"]},
        "3833": {"vr": "SH", "Value": ["SP H4.7"]},
        "3834": {"vr": "SH", "Value": ["SP H17.2"]},
        "3835": {"vr": "SH", "Value": ["SP H27.2"]},
        "3836": {"vr": "SH", "Value": ["SP H67.2"]},
        "3837": {"vr": "SH", "Value": ["SP H4.7"]},
        "3838": {"vr": "SH", "Value": ["SP F55.3"]},
        "3839": {"vr": "SH", "Value": ["SP F40.3"]},
        "3840": {"vr": "SH", "Value": ["SP F30.3"]},
        "3841": {"vr": "SH", "Value": ["SP F47.8"]},
        "3842": {"vr": "SH", "Value": ["SP F65.3"]},
        "3843": {"vr": "SH", "Value": ["SP F20.3"]},
        "3844": {"vr": "SH", "Value": ["SP F62.8"]},
        "3845": {"vr": "SH", "Value": ["SP H29.7"]},
        "3846": {"vr": "SH", "Value": ["SP F40.3"]},
        "3847": {"vr": "SH", "Value": ["SP H57.2"]},
        "3848": {"vr": "SH", "Value": ["SP H9.7"]},
        "3849": {"vr": "SH", "Value": ["SP H12.2"]},
        "3850": {"vr": "SH", "Value": ["SP H72.2"]},
        "3851": {"vr": "SH", "Value": ["SP H47.2"]},
        "3852": {"vr": "SH", "Value": ["SP H62.2"]},
        "3853": {"vr": "SH", "Value": ["SP H52.2"]},
        "3854": {"vr": "SH", "Value": ["SP H72.2"]},
        "3855": {"vr": "SH", "Value": ["SP H39.7"]},
        "3856": {"vr": "SH", "Value": ["SP F22.8"]},
        "3857": {"vr": "SH", "Value": ["SP H49.7"]},
        "3858": {"vr": "SH", "Value": ["SP H64.7"]},
        "3859": {"vr": "SH", "Value": ["SP H39.7"]},
        "3860": {"vr": "SH", "Value": ["SP F0.3"]},
        "3861": {"vr": "SH", "Value": ["SP H12.2"]},
        "3862": {"vr": "SH", "Value": ["SP H69.7"]},
        "3863": {"vr": "SH", "Value": ["SP F55.3"]},
        "3864": {"vr": "SH", "Value": ["SP H39.7"]},
        "3865": {"vr": "SH", "Value": ["SP H2.2"]},
        "3866": {"vr": "SH", "Value": ["SP F47.8"]},
        "3867": {"vr": "SH", "Value": ["SP F7.8"]},
        "3868": {"vr": "SH", "Value": ["SP H14.7"]},
        "3869": {"vr": "SH", "Value": ["SP F47.8"]},
        "3870": {"vr": "SH", "Value": ["SP F55.3"]},
        "3871": {"vr": "SH", "Value": ["SP F0.3"]},
        "3872": {"vr": "SH", "Value": ["SP F52.8"]},
        "3873": {"vr": "SH", "Value": ["SP F50.3"]},
        "3874": {"vr": "SH", "Value": ["SP H62.2"]},
        "3875": {"vr": "SH", "Value": ["SP F2.8"]},
        "3876": {"vr": "SH", "Value": ["SP F40.3"]},
        "3877": {"vr": "SH", "Value": ["SP H62.2"]},
        "3878": {"vr": "SH", "Value": ["SP F42.8"]},
        "3879": {"vr": "SH", "Value": ["SP H14.7"]},
        "3880": {"vr": "SH", "Value": ["SP F67.8"]},
        "3881": {"vr": "SH", "Value": ["SP H52.2"]},
        "3882": {"vr": "SH", "Value": ["SP H72.2"]},
        "3883": {"vr": "SH", "Value": ["SP F30.3"]},
        "3884": {"vr": "SH", "Value": ["SP F55.3"]},
        "3885": {"vr": "SH", "Value": ["SP H44.7"]},
        "3886": {"vr": "SH", "Value": ["SP F72.8"]},
        "3887": {"vr": "SH", "Value": ["SP H12.2"]},
        "3888": {"vr": "SH", "Value": ["SP H32.2"]},
        "3889": {"vr": "SH", "Value": ["SP F52.8"]},
        "3890": {"vr": "SH", "Value": ["SP H64.7"]},
        "3891": {"vr": "SH", "Value": ["SP H42.2"]},
        "3892": {"vr": "SH", "Value": ["SP F55.3"]},
        "3893": {"vr": "SH", "Value": ["SP H64.7"]},
        "3894": {"vr": "SH", "Value": ["SP F22.8"]},
        "3895": {"vr": "SH", "Value": ["SP F10.3"]},
        "3896": {"vr": "SH", "Value": ["SP F12.8"]},
        "3897": {"vr": "SH", "Value": ["SP F60.3"]},
        "3898": {"vr": "SH", "Value": ["SP F65.3"]},
        "3899": {"vr": "SH", "Value": ["SP F25.3"]},
        "3900": {"vr": "SH", "Value": ["SP H14.7"]},
        "3901": {"vr": "SH", "Value": ["SP H49.7"]},
        "3902": {"vr": "SH", "Value": ["SP H52.2"]},
        "3903": {"vr": "SH", "Value": ["SP F27.8"]},
        "3904": {"vr": "SH", "Value": ["SP H7.2"]},
        "3905": {"vr": "SH", "Value": ["SP F15.3"]},
        "3906": {"vr": "SH", "Value": ["SP F45.3"]},
        "3907": {"vr": "SH", "Value": ["SP F47.8"]},
        "3908": {"vr": "SH", "Value": ["SP H27.2"]},
        "3909": {"vr": "SH", "Value": ["SP H39.7"]},
        "3910": {"vr": "SH", "Value": ["SP F2.8"]},
        "3911": {"vr": "SH", "Value": ["SP H59.7"]},
        "3912": {"vr": "SH", "Value": ["SP F70.3"]},
        "3913": {"vr": "SH", "Value": ["SP F2.8"]},
        "3914": {"vr": "SH", "Value": ["SP H17.2"]},
        "3915": {"vr": "SH", "Value": ["SP F30.3"]},
        "3916": {"vr": "SH", "Value": ["SP H59.7"]},
        "3917": {"vr": "SH", "Value": ["SP F57.8"]},
        "3918": {"vr": "SH", "Value": ["SP F35.3"]},
        "3919": {"vr": "SH", "Value": ["SP F47.8"]},
        "3920": {"vr": "SH", "Value": ["SP H39.7"]},
        "3921": {"vr": "SH", "Value": ["SP H4.7"]},
        "3922": {"vr": "SH", "Value": ["SP F60.3"]},
        "3923": {"vr": "SH", "Value": ["SP H59.7"]},
        "3924": {"vr": "SH", "Value": ["SP F5.3"]},
        "3925": {"vr": "SH", "Value": ["SP H47.2"]},
        "3926": {"vr": "SH", "Value": ["SP H72.2"]},
        "3927": {"vr": "SH", "Value": ["SP H34.7"]},
        "3928": {"vr": "SH", "Value": ["SP F37.8"]},
        "3929": {"vr": "SH", "Value": ["SP H39.7"]},
        "3930": {"vr": "SH", "Value": ["SP H44.7"]},
        "3931": {"vr": "SH", "Value": ["SP F7.8"]},
        "3932": {"vr": "SH", "Value": ["SP H39.7"]},
        "3933": {"vr": "SH", "Value": ["SP H37.2"]},
        "3934": {"vr": "SH", "Value": ["SP F40.3"]},
        "3935": {"vr": "SH", "Value": ["SP F2.8"]},
        "3936": {"vr": "SH", "Value": ["SP H2.2"]},
        "3937": {"vr": "SH", "Value": ["SP F42.8"]},
        "3938": {"vr": "SH", "Value": ["SP F27.8"]},
        "3939": {"vr": "SH", "Value": ["SP H42.2"]},
        "3940": {"vr": "SH", "Value": ["SP H24.7"]},
        "3941": {"vr": "SH", "Value": ["SP F40.3"]},
        "3942": {"vr": "SH", "Value": ["SP H19.7"]},
        "3943": {"vr": "SH", "Value": ["SP H64.7"]},
        "3944": {"vr": "SH", "Value": ["SP H72.2"]},
        "3945": {"vr": "SH", "Value": ["SP F47.8"]},
        "3946": {"vr": "SH", "Value": ["SP F62.8"]},
        "3947": {"vr": "SH", "Value": ["SP H47.2"]},
        "3948": {"vr": "SH", "Value": ["SP F30.3"]},
        "3949": {"vr": "SH", "Value": ["SP F30.3"]},
        "3950": {"vr": "SH", "Value": ["SP H39.7"]},
        "3951": {"vr": "SH", "Value": ["SP H29.7"]},
        "3952": {"vr": "SH", "Value": ["SP F55.3"]},
        "3953": {"vr": "SH", "Value": ["SP H17.2"]},
        "3954": {"vr": "SH", "Value": ["SP F27.8"]},
        "3955": {"vr": "SH", "Value": ["SP F2.8"]},
        "3956": {"vr": "SH", "Value": ["SP F55.3"]},
        "3957": {"vr": "SH", "Value": ["SP F17.8"]},
        "3958": {"vr": "SH", "Value": ["SP H39.7"]},
        "3959": {"vr": "SH", "Value": ["SP H64.7"]},
        "3960": {"vr": "SH", "Value": ["SP H47.2"]},
        "3961": {"vr": "SH", "Value": ["SP H59.7"]},
        "3962": {"vr": "SH", "Value": ["SP F37.8"]},
        "3963": {"vr": "SH", "Value": ["SP F17.8"]},
        "3964": {"vr": "SH", "Value": ["SP F40.3"]},
        "3965": {"vr": "SH", "Value": ["SP F27.8"]},
        "3966": {"vr": "SH", "Value": ["SP H64.7"]},
        "3967": {"vr": "SH", "Value": ["SP H44.7"]},
        "3968": {"vr": "SH", "Value": ["SP H17.2"]},
        "3969": {"vr": "SH", "Value": ["SP H72.2"]},
        "3970": {"vr": "SH", "Value": ["SP H12.2"]},
        "3971": {"vr": "SH", "Value": ["SP H54.7"]},
        "3972": {"vr": "SH", "Value": ["SP F52.8"]},
        "3973": {"vr": "SH", "Value": ["SP H57.2"]},
        "3974": {"vr": "SH", "Value": ["SP F62.8"]},
        "3975": {"vr": "SH", "Value": ["SP F10.3"]},
        "3976": {"vr": "SH", "Value": ["SP H32.2"]},
        "3977": {"vr": "SH", "Value": ["SP H57.2"]},
        "3978": {"vr": "SH", "Value": ["SP H52.2"]},
        "3979": {"vr": "SH", "Value": ["SP F37.8"]},
        "3980": {"vr": "SH", "Value": ["SP H74.7"]},
        "3981": {"vr": "SH", "Value": ["SP H52.2"]},
        "3982": {"vr": "SH", "Value": ["SP H27.2"]},
        "3983": {"vr": "SH", "Value": ["SP F12.8"]},
        "3984": {"vr": "SH", "Value": ["SP F32.8"]},
        "3985": {"vr": "SH", "Value": ["SP F67.8"]},
        "3986": {"vr": "SH", "Value": ["SP H37.2"]},
        "3987": {"vr": "SH", "Value": ["SP F0.3"]},
        "3988": {"vr": "SH", "Value": ["SP H42.2"]},
        "3989": {"vr": "SH", "Value": ["SP H29.7"]},
        "3990": {"vr": "SH", "Value": ["SP H9.7"]},
        "3991": {"vr": "SH", "Value": ["SP H37.2"]},
        "3992": {"vr": "SH", "Value": ["SP H12.2"]},
        "3993": {"vr": "SH", "Value": ["SP H59.7"]},
        "3994": {"vr": "SH", "Value": ["SP F17.8"]},
        "3995": {"vr": "SH", "Value": ["SP F40.3"]},
        "3996": {"vr": "SH", "Value": ["SP F37.8"]},
        "3997": {"vr": "SH", "Value": ["SP H49.7"]},
        "3998": {"vr": "SH", "Value": ["SP F47.8"]},
        "3999": {"vr": "SH", "Value": ["SP H27.2"]},
        "4000": {"vr": "SH", "Value": ["SP H39.7"]},
        "4001": {"vr": "SH", "Value": ["SP H39.7"]},
        "4002": {"vr": "SH", "Value": ["SP H9.7"]},
        "4003": {"vr": "SH", "Value": ["SP H74.7"]},
        "4004": {"vr": "SH", "Value": ["SP F37.8"]},
        "4005": {"vr": "SH", "Value": ["SP H9.7"]},
        "4006": {"vr": "SH", "Value": ["SP F67.8"]},
        "4007": {"vr": "SH", "Value": ["SP H2.2"]},
        "4008": {"vr": "SH", "Value": ["SP F10.3"]},
        "4009": {"vr": "SH", "Value": ["SP F55.3"]},
        "4010": {"vr": "SH", "Value": ["SP H64.7"]},
        "4011": {"vr": "SH", "Value": ["SP H49.7"]},
        "4012": {"vr": "SH", "Value": ["SP H44.7"]},
        "4013": {"vr": "SH", "Value": ["SP H29.7"]},
        "4014": {"vr": "SH", "Value": ["SP F50.3"]},
        "4015": {"vr": "SH", "Value": ["SP H72.2"]},
        "4016": {"vr": "SH", "Value": ["SP H24.7"]},
        "4017": {"vr": "SH", "Value": ["SP H2.2"]},
        "4018": {"vr": "SH", "Value": ["SP F5.3"]},
        "4019": {"vr": "SH", "Value": ["SP F22.8"]},
    },
}


collated_data = {
    "00211019": {
        "0": {"vr": "OB", "BinaryLength": 183288},
        "1": {"vr": "OB", "BinaryLength": 183288},
        "2": {"vr": "OB", "BinaryLength": 183288},
        "3": {"vr": "OB", "BinaryLength": 183288},
        "4": {"vr": "OB", "BinaryLength": 183288},
        "5": {"vr": "OB", "BinaryLength": 183288},
        "6": {"vr": "OB", "BinaryLength": 183288},
        "7": {"vr": "OB", "BinaryLength": 183288},
        "8": {"vr": "OB", "BinaryLength": 183288},
        "9": {"vr": "OB", "BinaryLength": 183288},
        "10": {"vr": "OB", "BinaryLength": 183288},
        "11": {"vr": "OB", "BinaryLength": 183288},
        "12": {"vr": "OB", "BinaryLength": 183288},
        "13": {"vr": "OB", "BinaryLength": 183288},
        "14": {"vr": "OB", "BinaryLength": 183288},
        "15": {"vr": "OB", "BinaryLength": 183288},
        "16": {"vr": "OB", "BinaryLength": 183288},
        "17": {"vr": "OB", "BinaryLength": 183288},
        "18": {"vr": "OB", "BinaryLength": 183288},
        "19": {"vr": "OB", "BinaryLength": 183288},
        "20": {"vr": "OB", "BinaryLength": 183288},
        "21": {"vr": "OB", "BinaryLength": 183288},
        "22": {"vr": "OB", "BinaryLength": 183288},
        "23": {"vr": "OB", "BinaryLength": 183288},
        "24": {"vr": "OB", "BinaryLength": 183288},
        "25": {"vr": "OB", "BinaryLength": 183288},
        "26": {"vr": "OB", "BinaryLength": 183288},
        "27": {"vr": "OB", "BinaryLength": 183288},
        "28": {"vr": "OB", "BinaryLength": 183288},
        "29": {"vr": "OB", "BinaryLength": 183288},
        "30": {"vr": "OB", "BinaryLength": 183288},
        "31": {"vr": "OB", "BinaryLength": 183288},
        "32": {"vr": "OB", "BinaryLength": 183288},
        "33": {"vr": "OB", "BinaryLength": 183288},
        "34": {"vr": "OB", "BinaryLength": 183288},
        "35": {"vr": "OB", "BinaryLength": 183288},
        "36": {"vr": "OB", "BinaryLength": 183288},
        "37": {"vr": "OB", "BinaryLength": 183288},
        "38": {"vr": "OB", "BinaryLength": 183288},
        "39": {"vr": "OB", "BinaryLength": 183288},
        "40": {"vr": "OB", "BinaryLength": 183288},
        "41": {"vr": "OB", "BinaryLength": 183288},
        "42": {"vr": "OB", "BinaryLength": 183288},
        "43": {"vr": "OB", "BinaryLength": 183288},
        "44": {"vr": "OB", "BinaryLength": 183288},
        "45": {"vr": "OB", "BinaryLength": 183288},
        "46": {"vr": "OB", "BinaryLength": 183288},
        "47": {"vr": "OB", "BinaryLength": 183288},
        "48": {"vr": "OB", "BinaryLength": 183288},
        "49": {"vr": "OB", "BinaryLength": 183288},
        "50": {"vr": "OB", "BinaryLength": 183288},
        "51": {"vr": "OB", "BinaryLength": 183288},
        "52": {"vr": "OB", "BinaryLength": 183288},
        "53": {"vr": "OB", "BinaryLength": 183288},
        "54": {"vr": "OB", "BinaryLength": 183288},
        "55": {"vr": "OB", "BinaryLength": 183288},
        "56": {"vr": "OB", "BinaryLength": 183288},
        "57": {"vr": "OB", "BinaryLength": 183288},
        "58": {"vr": "OB", "BinaryLength": 183288},
        "59": {"vr": "OB", "BinaryLength": 183288},
        "60": {"vr": "OB", "BinaryLength": 183288},
        "61": {"vr": "OB", "BinaryLength": 183288},
        "62": {"vr": "OB", "BinaryLength": 183288},
        "63": {"vr": "OB", "BinaryLength": 183288},
        "64": {"vr": "OB", "BinaryLength": 183288},
        "65": {"vr": "OB", "BinaryLength": 183288},
        "66": {"vr": "OB", "BinaryLength": 183288},
        "67": {"vr": "OB", "BinaryLength": 183288},
        "68": {"vr": "OB", "BinaryLength": 183288},
        "69": {"vr": "OB", "BinaryLength": 183288},
        "70": {"vr": "OB", "BinaryLength": 183288},
        "71": {"vr": "OB", "BinaryLength": 183288},
        "72": {"vr": "OB", "BinaryLength": 183288},
        "73": {"vr": "OB", "BinaryLength": 183288},
        "74": {"vr": "OB", "BinaryLength": 183288},
        "75": {"vr": "OB", "BinaryLength": 183288},
        "76": {"vr": "OB", "BinaryLength": 183288},
        "77": {"vr": "OB", "BinaryLength": 183288},
        "78": {"vr": "OB", "BinaryLength": 183288},
        "79": {"vr": "OB", "BinaryLength": 183288},
        "80": {"vr": "OB", "BinaryLength": 183288},
        "81": {"vr": "OB", "BinaryLength": 183288},
        "82": {"vr": "OB", "BinaryLength": 183288},
        "83": {"vr": "OB", "BinaryLength": 183288},
        "84": {"vr": "OB", "BinaryLength": 183288},
        "85": {"vr": "OB", "BinaryLength": 183288},
        "86": {"vr": "OB", "BinaryLength": 183288},
        "87": {"vr": "OB", "BinaryLength": 183288},
        "88": {"vr": "OB", "BinaryLength": 183288},
        "89": {"vr": "OB", "BinaryLength": 183288},
        "90": {"vr": "OB", "BinaryLength": 183288},
        "91": {"vr": "OB", "BinaryLength": 183288},
        "92": {"vr": "OB", "BinaryLength": 183288},
        "93": {"vr": "OB", "BinaryLength": 183288},
        "94": {"vr": "OB", "BinaryLength": 183288},
        "95": {"vr": "OB", "BinaryLength": 183288},
        "96": {"vr": "OB", "BinaryLength": 183288},
        "97": {"vr": "OB", "BinaryLength": 183288},
        "98": {"vr": "OB", "BinaryLength": 183288},
        "99": {"vr": "OB", "BinaryLength": 183288},
        "100": {"vr": "OB", "BinaryLength": 183288},
        "101": {"vr": "OB", "BinaryLength": 183288},
        "102": {"vr": "OB", "BinaryLength": 183288},
        "103": {"vr": "OB", "BinaryLength": 183288},
        "104": {"vr": "OB", "BinaryLength": 183288},
        "105": {"vr": "OB", "BinaryLength": 183288},
        "106": {"vr": "OB", "BinaryLength": 183288},
        "107": {"vr": "OB", "BinaryLength": 183288},
        "108": {"vr": "OB", "BinaryLength": 183288},
        "109": {"vr": "OB", "BinaryLength": 183288},
        "110": {"vr": "OB", "BinaryLength": 183288},
        "111": {"vr": "OB", "BinaryLength": 183288},
        "112": {"vr": "OB", "BinaryLength": 183288},
        "113": {"vr": "OB", "BinaryLength": 183288},
        "114": {"vr": "OB", "BinaryLength": 183288},
        "115": {"vr": "OB", "BinaryLength": 183288},
        "116": {"vr": "OB", "BinaryLength": 183288},
        "117": {"vr": "OB", "BinaryLength": 183288},
        "118": {"vr": "OB", "BinaryLength": 183288},
        "119": {"vr": "OB", "BinaryLength": 183288},
        "120": {"vr": "OB", "BinaryLength": 183288},
        "121": {"vr": "OB", "BinaryLength": 183288},
        "122": {"vr": "OB", "BinaryLength": 183288},
        "123": {"vr": "OB", "BinaryLength": 183288},
        "124": {"vr": "OB", "BinaryLength": 183288},
        "125": {"vr": "OB", "BinaryLength": 183288},
        "126": {"vr": "OB", "BinaryLength": 183288},
        "127": {"vr": "OB", "BinaryLength": 183288},
        "128": {"vr": "OB", "BinaryLength": 183288},
        "129": {"vr": "OB", "BinaryLength": 183288},
        "130": {"vr": "OB", "BinaryLength": 183288},
        "131": {"vr": "OB", "BinaryLength": 183288},
        "132": {"vr": "OB", "BinaryLength": 183288},
        "133": {"vr": "OB", "BinaryLength": 183288},
        "134": {"vr": "OB", "BinaryLength": 183288},
        "135": {"vr": "OB", "BinaryLength": 183288},
        "136": {"vr": "OB", "BinaryLength": 183288},
        "137": {"vr": "OB", "BinaryLength": 183288},
        "138": {"vr": "OB", "BinaryLength": 183288},
        "139": {"vr": "OB", "BinaryLength": 183288},
        "140": {"vr": "OB", "BinaryLength": 183288},
        "141": {"vr": "OB", "BinaryLength": 183288},
        "142": {"vr": "OB", "BinaryLength": 183288},
        "143": {"vr": "OB", "BinaryLength": 183288},
        "144": {"vr": "OB", "BinaryLength": 183288},
        "145": {"vr": "OB", "BinaryLength": 183288},
        "146": {"vr": "OB", "BinaryLength": 183288},
        "147": {"vr": "OB", "BinaryLength": 183288},
        "148": {"vr": "OB", "BinaryLength": 183288},
        "149": {"vr": "OB", "BinaryLength": 183288},
        "150": {"vr": "OB", "BinaryLength": 183288},
        "151": {"vr": "OB", "BinaryLength": 183288},
        "152": {"vr": "OB", "BinaryLength": 183288},
        "153": {"vr": "OB", "BinaryLength": 183288},
        "154": {"vr": "OB", "BinaryLength": 183288},
        "155": {"vr": "OB", "BinaryLength": 183288},
        "156": {"vr": "OB", "BinaryLength": 183288},
        "157": {"vr": "OB", "BinaryLength": 183288},
        "158": {"vr": "OB", "BinaryLength": 183288},
        "159": {"vr": "OB", "BinaryLength": 183288},
        "160": {"vr": "OB", "BinaryLength": 183288},
        "161": {"vr": "OB", "BinaryLength": 183288},
        "162": {"vr": "OB", "BinaryLength": 183288},
        "163": {"vr": "OB", "BinaryLength": 183288},
        "164": {"vr": "OB", "BinaryLength": 183288},
        "165": {"vr": "OB", "BinaryLength": 183288},
        "166": {"vr": "OB", "BinaryLength": 183288},
        "167": {"vr": "OB", "BinaryLength": 183288},
        "168": {"vr": "OB", "BinaryLength": 183288},
        "169": {"vr": "OB", "BinaryLength": 183288},
        "170": {"vr": "OB", "BinaryLength": 183288},
        "171": {"vr": "OB", "BinaryLength": 183288},
        "172": {"vr": "OB", "BinaryLength": 183288},
        "173": {"vr": "OB", "BinaryLength": 183288},
        "174": {"vr": "OB", "BinaryLength": 183288},
        "175": {"vr": "OB", "BinaryLength": 183288},
        "176": {"vr": "OB", "BinaryLength": 183288},
        "177": {"vr": "OB", "BinaryLength": 183288},
        "178": {"vr": "OB", "BinaryLength": 183288},
        "179": {"vr": "OB", "BinaryLength": 183288},
        "180": {"vr": "OB", "BinaryLength": 183288},
        "181": {"vr": "OB", "BinaryLength": 183288},
        "182": {"vr": "OB", "BinaryLength": 183288},
        "183": {"vr": "OB", "BinaryLength": 183288},
        "184": {"vr": "OB", "BinaryLength": 183288},
        "185": {"vr": "OB", "BinaryLength": 183288},
        "186": {"vr": "OB", "BinaryLength": 183288},
        "187": {"vr": "OB", "BinaryLength": 183288},
        "188": {"vr": "OB", "BinaryLength": 183288},
        "189": {"vr": "OB", "BinaryLength": 183288},
        "190": {"vr": "OB", "BinaryLength": 183288},
        "191": {"vr": "OB", "BinaryLength": 183288},
        "192": {"vr": "OB", "BinaryLength": 183288},
        "193": {"vr": "OB", "BinaryLength": 183288},
        "194": {"vr": "OB", "BinaryLength": 183288},
        "195": {"vr": "OB", "BinaryLength": 183288},
        "196": {"vr": "OB", "BinaryLength": 183288},
        "197": {"vr": "OB", "BinaryLength": 183288},
        "198": {"vr": "OB", "BinaryLength": 183288},
        "199": {"vr": "OB", "BinaryLength": 183288},
        "200": {"vr": "OB", "BinaryLength": 183288},
        "201": {"vr": "OB", "BinaryLength": 183288},
        "202": {"vr": "OB", "BinaryLength": 183288},
        "203": {"vr": "OB", "BinaryLength": 183288},
        "204": {"vr": "OB", "BinaryLength": 183288},
        "205": {"vr": "OB", "BinaryLength": 183288},
        "206": {"vr": "OB", "BinaryLength": 183288},
        "207": {"vr": "OB", "BinaryLength": 183288},
        "208": {"vr": "OB", "BinaryLength": 183288},
        "209": {"vr": "OB", "BinaryLength": 183288},
        "210": {"vr": "OB", "BinaryLength": 183288},
        "211": {"vr": "OB", "BinaryLength": 183288},
        "212": {"vr": "OB", "BinaryLength": 183288},
        "213": {"vr": "OB", "BinaryLength": 183288},
        "214": {"vr": "OB", "BinaryLength": 183288},
        "215": {"vr": "OB", "BinaryLength": 183288},
        "216": {"vr": "OB", "BinaryLength": 183288},
        "217": {"vr": "OB", "BinaryLength": 183288},
        "218": {"vr": "OB", "BinaryLength": 183288},
        "219": {"vr": "OB", "BinaryLength": 183288},
        "220": {"vr": "OB", "BinaryLength": 183288},
        "221": {"vr": "OB", "BinaryLength": 183288},
        "222": {"vr": "OB", "BinaryLength": 183288},
        "223": {"vr": "OB", "BinaryLength": 183288},
        "224": {"vr": "OB", "BinaryLength": 183288},
        "225": {"vr": "OB", "BinaryLength": 183288},
        "226": {"vr": "OB", "BinaryLength": 183288},
        "227": {"vr": "OB", "BinaryLength": 183288},
        "228": {"vr": "OB", "BinaryLength": 183288},
        "229": {"vr": "OB", "BinaryLength": 183288},
        "230": {"vr": "OB", "BinaryLength": 183288},
        "231": {"vr": "OB", "BinaryLength": 183288},
        "232": {"vr": "OB", "BinaryLength": 183288},
        "233": {"vr": "OB", "BinaryLength": 183288},
        "234": {"vr": "OB", "BinaryLength": 183288},
        "235": {"vr": "OB", "BinaryLength": 183288},
        "236": {"vr": "OB", "BinaryLength": 183288},
        "237": {"vr": "OB", "BinaryLength": 183288},
        "238": {"vr": "OB", "BinaryLength": 183288},
        "239": {"vr": "OB", "BinaryLength": 183288},
        "240": {"vr": "OB", "BinaryLength": 183288},
        "241": {"vr": "OB", "BinaryLength": 183288},
        "242": {"vr": "OB", "BinaryLength": 183288},
        "243": {"vr": "OB", "BinaryLength": 183288},
        "244": {"vr": "OB", "BinaryLength": 183288},
        "245": {"vr": "OB", "BinaryLength": 183288},
        "246": {"vr": "OB", "BinaryLength": 183288},
        "247": {"vr": "OB", "BinaryLength": 183288},
        "248": {"vr": "OB", "BinaryLength": 183288},
        "249": {"vr": "OB", "BinaryLength": 183288},
        "250": {"vr": "OB", "BinaryLength": 183288},
        "251": {"vr": "OB", "BinaryLength": 183288},
        "252": {"vr": "OB", "BinaryLength": 183288},
        "253": {"vr": "OB", "BinaryLength": 183288},
        "254": {"vr": "OB", "BinaryLength": 183288},
        "255": {"vr": "OB", "BinaryLength": 183288},
        "256": {"vr": "OB", "BinaryLength": 183288},
        "257": {"vr": "OB", "BinaryLength": 183288},
        "258": {"vr": "OB", "BinaryLength": 183288},
        "259": {"vr": "OB", "BinaryLength": 183288},
        "260": {"vr": "OB", "BinaryLength": 183288},
        "261": {"vr": "OB", "BinaryLength": 183288},
        "262": {"vr": "OB", "BinaryLength": 183288},
        "263": {"vr": "OB", "BinaryLength": 183288},
        "264": {"vr": "OB", "BinaryLength": 183288},
        "265": {"vr": "OB", "BinaryLength": 183288},
        "266": {"vr": "OB", "BinaryLength": 183288},
        "267": {"vr": "OB", "BinaryLength": 183288},
        "268": {"vr": "OB", "BinaryLength": 183288},
        "269": {"vr": "OB", "BinaryLength": 183288},
        "270": {"vr": "OB", "BinaryLength": 183288},
        "271": {"vr": "OB", "BinaryLength": 183288},
        "272": {"vr": "OB", "BinaryLength": 183288},
        "273": {"vr": "OB", "BinaryLength": 183288},
        "274": {"vr": "OB", "BinaryLength": 183288},
        "275": {"vr": "OB", "BinaryLength": 183288},
        "276": {"vr": "OB", "BinaryLength": 183288},
        "277": {"vr": "OB", "BinaryLength": 183288},
        "278": {"vr": "OB", "BinaryLength": 183288},
        "279": {"vr": "OB", "BinaryLength": 183288},
        "280": {"vr": "OB", "BinaryLength": 183288},
        "281": {"vr": "OB", "BinaryLength": 183288},
        "282": {"vr": "OB", "BinaryLength": 183288},
        "283": {"vr": "OB", "BinaryLength": 183288},
        "284": {"vr": "OB", "BinaryLength": 183288},
        "285": {"vr": "OB", "BinaryLength": 183288},
        "286": {"vr": "OB", "BinaryLength": 183288},
        "287": {"vr": "OB", "BinaryLength": 183288},
        "288": {"vr": "OB", "BinaryLength": 183288},
        "289": {"vr": "OB", "BinaryLength": 183288},
        "290": {"vr": "OB", "BinaryLength": 183288},
        "291": {"vr": "OB", "BinaryLength": 183288},
        "292": {"vr": "OB", "BinaryLength": 183288},
        "293": {"vr": "OB", "BinaryLength": 183288},
        "294": {"vr": "OB", "BinaryLength": 183288},
        "295": {"vr": "OB", "BinaryLength": 183288},
        "296": {"vr": "OB", "BinaryLength": 183288},
        "297": {"vr": "OB", "BinaryLength": 183288},
        "298": {"vr": "OB", "BinaryLength": 183288},
        "299": {"vr": "OB", "BinaryLength": 183288},
        "300": {"vr": "OB", "BinaryLength": 183288},
        "301": {"vr": "OB", "BinaryLength": 183288},
        "302": {"vr": "OB", "BinaryLength": 183288},
        "303": {"vr": "OB", "BinaryLength": 183288},
        "304": {"vr": "OB", "BinaryLength": 183288},
        "305": {"vr": "OB", "BinaryLength": 183288},
        "306": {"vr": "OB", "BinaryLength": 183288},
        "307": {"vr": "OB", "BinaryLength": 183288},
        "308": {"vr": "OB", "BinaryLength": 183288},
        "309": {"vr": "OB", "BinaryLength": 183288},
        "310": {"vr": "OB", "BinaryLength": 183288},
        "311": {"vr": "OB", "BinaryLength": 183288},
        "312": {"vr": "OB", "BinaryLength": 183288},
        "313": {"vr": "OB", "BinaryLength": 183288},
        "314": {"vr": "OB", "BinaryLength": 183288},
        "315": {"vr": "OB", "BinaryLength": 183288},
        "316": {"vr": "OB", "BinaryLength": 183288},
        "317": {"vr": "OB", "BinaryLength": 183288},
        "318": {"vr": "OB", "BinaryLength": 183288},
        "319": {"vr": "OB", "BinaryLength": 183288},
        "320": {"vr": "OB", "BinaryLength": 183288},
        "321": {"vr": "OB", "BinaryLength": 183288},
        "322": {"vr": "OB", "BinaryLength": 183288},
        "323": {"vr": "OB", "BinaryLength": 183288},
        "324": {"vr": "OB", "BinaryLength": 183288},
        "325": {"vr": "OB", "BinaryLength": 183288},
        "326": {"vr": "OB", "BinaryLength": 183288},
        "327": {"vr": "OB", "BinaryLength": 183288},
        "328": {"vr": "OB", "BinaryLength": 183288},
        "329": {"vr": "OB", "BinaryLength": 183288},
        "330": {"vr": "OB", "BinaryLength": 183288},
        "331": {"vr": "OB", "BinaryLength": 183288},
        "332": {"vr": "OB", "BinaryLength": 183288},
        "333": {"vr": "OB", "BinaryLength": 183288},
        "334": {"vr": "OB", "BinaryLength": 183288},
        "335": {"vr": "OB", "BinaryLength": 183288},
        "336": {"vr": "OB", "BinaryLength": 183288},
        "337": {"vr": "OB", "BinaryLength": 183288},
        "338": {"vr": "OB", "BinaryLength": 183288},
        "339": {"vr": "OB", "BinaryLength": 183288},
        "340": {"vr": "OB", "BinaryLength": 183288},
        "341": {"vr": "OB", "BinaryLength": 183288},
        "342": {"vr": "OB", "BinaryLength": 183288},
        "343": {"vr": "OB", "BinaryLength": 183288},
        "344": {"vr": "OB", "BinaryLength": 183288},
        "345": {"vr": "OB", "BinaryLength": 183288},
        "346": {"vr": "OB", "BinaryLength": 183288},
        "347": {"vr": "OB", "BinaryLength": 183288},
        "348": {"vr": "OB", "BinaryLength": 183288},
        "349": {"vr": "OB", "BinaryLength": 183288},
        "350": {"vr": "OB", "BinaryLength": 183288},
        "351": {"vr": "OB", "BinaryLength": 183288},
        "352": {"vr": "OB", "BinaryLength": 183288},
        "353": {"vr": "OB", "BinaryLength": 183288},
        "354": {"vr": "OB", "BinaryLength": 183288},
        "355": {"vr": "OB", "BinaryLength": 183288},
        "356": {"vr": "OB", "BinaryLength": 183288},
        "357": {"vr": "OB", "BinaryLength": 183288},
        "358": {"vr": "OB", "BinaryLength": 183288},
        "359": {"vr": "OB", "BinaryLength": 183288},
        "360": {"vr": "OB", "BinaryLength": 183288},
        "361": {"vr": "OB", "BinaryLength": 183288},
        "362": {"vr": "OB", "BinaryLength": 183288},
        "363": {"vr": "OB", "BinaryLength": 183288},
        "364": {"vr": "OB", "BinaryLength": 183288},
        "365": {"vr": "OB", "BinaryLength": 183288},
        "366": {"vr": "OB", "BinaryLength": 183288},
        "367": {"vr": "OB", "BinaryLength": 183288},
        "368": {"vr": "OB", "BinaryLength": 183288},
        "369": {"vr": "OB", "BinaryLength": 183288},
        "370": {"vr": "OB", "BinaryLength": 183288},
        "371": {"vr": "OB", "BinaryLength": 183288},
        "372": {"vr": "OB", "BinaryLength": 183288},
        "373": {"vr": "OB", "BinaryLength": 183288},
        "374": {"vr": "OB", "BinaryLength": 183288},
        "375": {"vr": "OB", "BinaryLength": 183288},
        "376": {"vr": "OB", "BinaryLength": 183288},
        "377": {"vr": "OB", "BinaryLength": 183288},
        "378": {"vr": "OB", "BinaryLength": 183288},
        "379": {"vr": "OB", "BinaryLength": 183288},
        "380": {"vr": "OB", "BinaryLength": 183288},
        "381": {"vr": "OB", "BinaryLength": 183288},
        "382": {"vr": "OB", "BinaryLength": 183288},
        "383": {"vr": "OB", "BinaryLength": 183288},
        "384": {"vr": "OB", "BinaryLength": 183288},
        "385": {"vr": "OB", "BinaryLength": 183288},
        "386": {"vr": "OB", "BinaryLength": 183288},
        "387": {"vr": "OB", "BinaryLength": 183288},
        "388": {"vr": "OB", "BinaryLength": 183288},
        "389": {"vr": "OB", "BinaryLength": 183288},
        "390": {"vr": "OB", "BinaryLength": 183288},
        "391": {"vr": "OB", "BinaryLength": 183288},
        "392": {"vr": "OB", "BinaryLength": 183288},
        "393": {"vr": "OB", "BinaryLength": 183288},
        "394": {"vr": "OB", "BinaryLength": 183288},
        "395": {"vr": "OB", "BinaryLength": 183288},
        "396": {"vr": "OB", "BinaryLength": 183288},
        "397": {"vr": "OB", "BinaryLength": 183288},
        "398": {"vr": "OB", "BinaryLength": 183288},
        "399": {"vr": "OB", "BinaryLength": 183288},
        "400": {"vr": "OB", "BinaryLength": 183288},
        "401": {"vr": "OB", "BinaryLength": 183288},
        "402": {"vr": "OB", "BinaryLength": 183288},
        "403": {"vr": "OB", "BinaryLength": 183288},
        "404": {"vr": "OB", "BinaryLength": 183288},
        "405": {"vr": "OB", "BinaryLength": 183288},
        "406": {"vr": "OB", "BinaryLength": 183288},
        "407": {"vr": "OB", "BinaryLength": 183288},
        "408": {"vr": "OB", "BinaryLength": 183288},
        "409": {"vr": "OB", "BinaryLength": 183288},
        "410": {"vr": "OB", "BinaryLength": 183288},
        "411": {"vr": "OB", "BinaryLength": 183288},
        "412": {"vr": "OB", "BinaryLength": 183288},
        "413": {"vr": "OB", "BinaryLength": 183288},
        "414": {"vr": "OB", "BinaryLength": 183288},
        "415": {"vr": "OB", "BinaryLength": 183288},
        "416": {"vr": "OB", "BinaryLength": 183288},
        "417": {"vr": "OB", "BinaryLength": 183288},
        "418": {"vr": "OB", "BinaryLength": 183288},
        "419": {"vr": "OB", "BinaryLength": 183288},
        "420": {"vr": "OB", "BinaryLength": 183288},
        "421": {"vr": "OB", "BinaryLength": 183288},
        "422": {"vr": "OB", "BinaryLength": 183288},
        "423": {"vr": "OB", "BinaryLength": 183288},
        "424": {"vr": "OB", "BinaryLength": 183288},
        "425": {"vr": "OB", "BinaryLength": 183288},
        "426": {"vr": "OB", "BinaryLength": 183288},
        "427": {"vr": "OB", "BinaryLength": 183288},
        "428": {"vr": "OB", "BinaryLength": 183288},
        "429": {"vr": "OB", "BinaryLength": 183288},
        "430": {"vr": "OB", "BinaryLength": 183288},
        "431": {"vr": "OB", "BinaryLength": 183288},
        "432": {"vr": "OB", "BinaryLength": 183288},
        "433": {"vr": "OB", "BinaryLength": 183288},
        "434": {"vr": "OB", "BinaryLength": 183288},
        "435": {"vr": "OB", "BinaryLength": 183288},
        "436": {"vr": "OB", "BinaryLength": 183288},
        "437": {"vr": "OB", "BinaryLength": 183288},
        "438": {"vr": "OB", "BinaryLength": 183288},
        "439": {"vr": "OB", "BinaryLength": 183288},
        "440": {"vr": "OB", "BinaryLength": 183288},
        "441": {"vr": "OB", "BinaryLength": 183288},
        "442": {"vr": "OB", "BinaryLength": 183288},
        "443": {"vr": "OB", "BinaryLength": 183288},
        "444": {"vr": "OB", "BinaryLength": 183288},
        "445": {"vr": "OB", "BinaryLength": 183288},
        "446": {"vr": "OB", "BinaryLength": 183288},
        "447": {"vr": "OB", "BinaryLength": 183288},
        "448": {"vr": "OB", "BinaryLength": 183288},
        "449": {"vr": "OB", "BinaryLength": 183288},
        "450": {"vr": "OB", "BinaryLength": 183288},
        "451": {"vr": "OB", "BinaryLength": 183288},
        "452": {"vr": "OB", "BinaryLength": 183288},
        "453": {"vr": "OB", "BinaryLength": 183288},
        "454": {"vr": "OB", "BinaryLength": 183288},
        "455": {"vr": "OB", "BinaryLength": 183288},
        "456": {"vr": "OB", "BinaryLength": 183288},
        "457": {"vr": "OB", "BinaryLength": 183288},
        "458": {"vr": "OB", "BinaryLength": 183288},
        "459": {"vr": "OB", "BinaryLength": 183288},
        "460": {"vr": "OB", "BinaryLength": 183288},
        "461": {"vr": "OB", "BinaryLength": 183288},
        "462": {"vr": "OB", "BinaryLength": 183288},
        "463": {"vr": "OB", "BinaryLength": 183288},
        "464": {"vr": "OB", "BinaryLength": 183288},
        "465": {"vr": "OB", "BinaryLength": 183288},
        "466": {"vr": "OB", "BinaryLength": 183288},
        "467": {"vr": "OB", "BinaryLength": 183288},
        "468": {"vr": "OB", "BinaryLength": 183288},
        "469": {"vr": "OB", "BinaryLength": 183288},
        "470": {"vr": "OB", "BinaryLength": 183288},
        "471": {"vr": "OB", "BinaryLength": 183288},
        "472": {"vr": "OB", "BinaryLength": 183288},
        "473": {"vr": "OB", "BinaryLength": 183288},
        "474": {"vr": "OB", "BinaryLength": 183288},
        "475": {"vr": "OB", "BinaryLength": 183288},
        "476": {"vr": "OB", "BinaryLength": 183288},
        "477": {"vr": "OB", "BinaryLength": 183288},
        "478": {"vr": "OB", "BinaryLength": 183288},
        "479": {"vr": "OB", "BinaryLength": 183288},
        "480": {"vr": "OB", "BinaryLength": 183288},
        "481": {"vr": "OB", "BinaryLength": 183288},
        "482": {"vr": "OB", "BinaryLength": 183288},
        "483": {"vr": "OB", "BinaryLength": 183288},
        "484": {"vr": "OB", "BinaryLength": 183288},
        "485": {"vr": "OB", "BinaryLength": 183288},
        "486": {"vr": "OB", "BinaryLength": 183288},
        "487": {"vr": "OB", "BinaryLength": 183288},
        "488": {"vr": "OB", "BinaryLength": 183288},
        "489": {"vr": "OB", "BinaryLength": 183288},
        "490": {"vr": "OB", "BinaryLength": 183288},
        "491": {"vr": "OB", "BinaryLength": 183288},
        "492": {"vr": "OB", "BinaryLength": 183288},
        "493": {"vr": "OB", "BinaryLength": 183288},
        "494": {"vr": "OB", "BinaryLength": 183288},
        "495": {"vr": "OB", "BinaryLength": 183288},
        "496": {"vr": "OB", "BinaryLength": 183288},
        "497": {"vr": "OB", "BinaryLength": 183288},
        "498": {"vr": "OB", "BinaryLength": 183288},
        "499": {"vr": "OB", "BinaryLength": 183288},
        "500": {"vr": "OB", "BinaryLength": 183288},
        "501": {"vr": "OB", "BinaryLength": 183288},
        "502": {"vr": "OB", "BinaryLength": 183288},
        "503": {"vr": "OB", "BinaryLength": 183288},
        "504": {"vr": "OB", "BinaryLength": 183288},
        "505": {"vr": "OB", "BinaryLength": 183288},
        "506": {"vr": "OB", "BinaryLength": 183288},
        "507": {"vr": "OB", "BinaryLength": 183288},
        "508": {"vr": "OB", "BinaryLength": 183288},
        "509": {"vr": "OB", "BinaryLength": 183288},
        "510": {"vr": "OB", "BinaryLength": 183288},
        "511": {"vr": "OB", "BinaryLength": 183288},
        "512": {"vr": "OB", "BinaryLength": 183288},
        "513": {"vr": "OB", "BinaryLength": 183288},
        "514": {"vr": "OB", "BinaryLength": 183288},
        "515": {"vr": "OB", "BinaryLength": 183288},
        "516": {"vr": "OB", "BinaryLength": 183288},
        "517": {"vr": "OB", "BinaryLength": 183288},
        "518": {"vr": "OB", "BinaryLength": 183288},
        "519": {"vr": "OB", "BinaryLength": 183288},
        "520": {"vr": "OB", "BinaryLength": 183288},
        "521": {"vr": "OB", "BinaryLength": 183288},
        "522": {"vr": "OB", "BinaryLength": 183288},
        "523": {"vr": "OB", "BinaryLength": 183288},
        "524": {"vr": "OB", "BinaryLength": 183288},
        "525": {"vr": "OB", "BinaryLength": 183288},
        "526": {"vr": "OB", "BinaryLength": 183288},
        "527": {"vr": "OB", "BinaryLength": 183288},
        "528": {"vr": "OB", "BinaryLength": 183288},
        "529": {"vr": "OB", "BinaryLength": 183288},
        "530": {"vr": "OB", "BinaryLength": 183288},
        "531": {"vr": "OB", "BinaryLength": 183288},
        "532": {"vr": "OB", "BinaryLength": 183288},
        "533": {"vr": "OB", "BinaryLength": 183288},
        "534": {"vr": "OB", "BinaryLength": 183288},
        "535": {"vr": "OB", "BinaryLength": 183288},
        "536": {"vr": "OB", "BinaryLength": 183288},
        "537": {"vr": "OB", "BinaryLength": 183288},
        "538": {"vr": "OB", "BinaryLength": 183288},
        "539": {"vr": "OB", "BinaryLength": 183288},
        "540": {"vr": "OB", "BinaryLength": 183288},
        "541": {"vr": "OB", "BinaryLength": 183288},
        "542": {"vr": "OB", "BinaryLength": 183288},
        "543": {"vr": "OB", "BinaryLength": 183288},
        "544": {"vr": "OB", "BinaryLength": 183288},
        "545": {"vr": "OB", "BinaryLength": 183288},
        "546": {"vr": "OB", "BinaryLength": 183288},
        "547": {"vr": "OB", "BinaryLength": 183288},
        "548": {"vr": "OB", "BinaryLength": 183288},
        "549": {"vr": "OB", "BinaryLength": 183288},
        "550": {"vr": "OB", "BinaryLength": 183288},
        "551": {"vr": "OB", "BinaryLength": 183288},
        "552": {"vr": "OB", "BinaryLength": 183288},
        "553": {"vr": "OB", "BinaryLength": 183288},
        "554": {"vr": "OB", "BinaryLength": 183288},
        "555": {"vr": "OB", "BinaryLength": 183288},
        "556": {"vr": "OB", "BinaryLength": 183288},
        "557": {"vr": "OB", "BinaryLength": 183288},
        "558": {"vr": "OB", "BinaryLength": 183288},
        "559": {"vr": "OB", "BinaryLength": 183288},
        "560": {"vr": "OB", "BinaryLength": 183288},
        "561": {"vr": "OB", "BinaryLength": 183288},
        "562": {"vr": "OB", "BinaryLength": 183288},
        "563": {"vr": "OB", "BinaryLength": 183288},
        "564": {"vr": "OB", "BinaryLength": 183288},
        "565": {"vr": "OB", "BinaryLength": 183288},
        "566": {"vr": "OB", "BinaryLength": 183288},
        "567": {"vr": "OB", "BinaryLength": 183288},
        "568": {"vr": "OB", "BinaryLength": 183288},
        "569": {"vr": "OB", "BinaryLength": 183288},
        "570": {"vr": "OB", "BinaryLength": 183288},
        "571": {"vr": "OB", "BinaryLength": 183288},
        "572": {"vr": "OB", "BinaryLength": 183288},
        "573": {"vr": "OB", "BinaryLength": 183288},
        "574": {"vr": "OB", "BinaryLength": 183288},
        "575": {"vr": "OB", "BinaryLength": 183288},
        "576": {"vr": "OB", "BinaryLength": 183288},
        "577": {"vr": "OB", "BinaryLength": 183288},
        "578": {"vr": "OB", "BinaryLength": 183288},
        "579": {"vr": "OB", "BinaryLength": 183288},
        "580": {"vr": "OB", "BinaryLength": 183288},
        "581": {"vr": "OB", "BinaryLength": 183288},
        "582": {"vr": "OB", "BinaryLength": 183288},
        "583": {"vr": "OB", "BinaryLength": 183288},
        "584": {"vr": "OB", "BinaryLength": 183288},
        "585": {"vr": "OB", "BinaryLength": 183288},
        "586": {"vr": "OB", "BinaryLength": 183288},
        "587": {"vr": "OB", "BinaryLength": 183288},
        "588": {"vr": "OB", "BinaryLength": 183288},
        "589": {"vr": "OB", "BinaryLength": 183288},
        "590": {"vr": "OB", "BinaryLength": 183288},
        "591": {"vr": "OB", "BinaryLength": 183288},
        "592": {"vr": "OB", "BinaryLength": 183288},
        "593": {"vr": "OB", "BinaryLength": 183288},
        "594": {"vr": "OB", "BinaryLength": 183288},
        "595": {"vr": "OB", "BinaryLength": 183288},
        "596": {"vr": "OB", "BinaryLength": 183288},
        "597": {"vr": "OB", "BinaryLength": 183288},
        "598": {"vr": "OB", "BinaryLength": 183288},
        "599": {"vr": "OB", "BinaryLength": 183288},
        "600": {"vr": "OB", "BinaryLength": 183288},
        "601": {"vr": "OB", "BinaryLength": 183288},
        "602": {"vr": "OB", "BinaryLength": 183288},
        "603": {"vr": "OB", "BinaryLength": 183288},
        "604": {"vr": "OB", "BinaryLength": 183288},
        "605": {"vr": "OB", "BinaryLength": 183288},
        "606": {"vr": "OB", "BinaryLength": 183288},
        "607": {"vr": "OB", "BinaryLength": 183288},
        "608": {"vr": "OB", "BinaryLength": 183288},
        "609": {"vr": "OB", "BinaryLength": 183288},
        "610": {"vr": "OB", "BinaryLength": 183288},
        "611": {"vr": "OB", "BinaryLength": 183288},
        "612": {"vr": "OB", "BinaryLength": 183288},
        "613": {"vr": "OB", "BinaryLength": 183288},
        "614": {"vr": "OB", "BinaryLength": 183288},
        "615": {"vr": "OB", "BinaryLength": 183288},
        "616": {"vr": "OB", "BinaryLength": 183288},
        "617": {"vr": "OB", "BinaryLength": 183288},
        "618": {"vr": "OB", "BinaryLength": 183288},
        "619": {"vr": "OB", "BinaryLength": 183288},
        "620": {"vr": "OB", "BinaryLength": 183288},
        "621": {"vr": "OB", "BinaryLength": 183288},
        "622": {"vr": "OB", "BinaryLength": 183288},
        "623": {"vr": "OB", "BinaryLength": 183288},
        "624": {"vr": "OB", "BinaryLength": 183288},
        "625": {"vr": "OB", "BinaryLength": 183288},
        "626": {"vr": "OB", "BinaryLength": 183288},
        "627": {"vr": "OB", "BinaryLength": 183288},
        "628": {"vr": "OB", "BinaryLength": 183288},
        "629": {"vr": "OB", "BinaryLength": 183288},
        "630": {"vr": "OB", "BinaryLength": 183288},
        "631": {"vr": "OB", "BinaryLength": 183288},
        "632": {"vr": "OB", "BinaryLength": 183288},
        "633": {"vr": "OB", "BinaryLength": 183288},
        "634": {"vr": "OB", "BinaryLength": 183288},
        "635": {"vr": "OB", "BinaryLength": 183288},
        "636": {"vr": "OB", "BinaryLength": 183288},
        "637": {"vr": "OB", "BinaryLength": 183288},
        "638": {"vr": "OB", "BinaryLength": 183288},
        "639": {"vr": "OB", "BinaryLength": 183288},
        "640": {"vr": "OB", "BinaryLength": 183288},
        "641": {"vr": "OB", "BinaryLength": 183288},
        "642": {"vr": "OB", "BinaryLength": 183288},
        "643": {"vr": "OB", "BinaryLength": 183288},
        "644": {"vr": "OB", "BinaryLength": 183288},
        "645": {"vr": "OB", "BinaryLength": 183288},
        "646": {"vr": "OB", "BinaryLength": 183288},
        "647": {"vr": "OB", "BinaryLength": 183288},
        "648": {"vr": "OB", "BinaryLength": 183288},
        "649": {"vr": "OB", "BinaryLength": 183288},
        "650": {"vr": "OB", "BinaryLength": 183288},
        "651": {"vr": "OB", "BinaryLength": 183288},
        "652": {"vr": "OB", "BinaryLength": 183288},
        "653": {"vr": "OB", "BinaryLength": 183288},
        "654": {"vr": "OB", "BinaryLength": 183288},
        "655": {"vr": "OB", "BinaryLength": 183288},
        "656": {"vr": "OB", "BinaryLength": 183288},
        "657": {"vr": "OB", "BinaryLength": 183288},
        "658": {"vr": "OB", "BinaryLength": 183288},
        "659": {"vr": "OB", "BinaryLength": 183288},
        "660": {"vr": "OB", "BinaryLength": 183288},
        "661": {"vr": "OB", "BinaryLength": 183288},
        "662": {"vr": "OB", "BinaryLength": 183288},
        "663": {"vr": "OB", "BinaryLength": 183288},
        "664": {"vr": "OB", "BinaryLength": 183288},
        "665": {"vr": "OB", "BinaryLength": 183288},
        "666": {"vr": "OB", "BinaryLength": 183288},
        "667": {"vr": "OB", "BinaryLength": 183288},
        "668": {"vr": "OB", "BinaryLength": 183288},
        "669": {"vr": "OB", "BinaryLength": 183288},
        "670": {"vr": "OB", "BinaryLength": 183288},
        "671": {"vr": "OB", "BinaryLength": 183288},
        "672": {"vr": "OB", "BinaryLength": 183288},
        "673": {"vr": "OB", "BinaryLength": 183288},
        "674": {"vr": "OB", "BinaryLength": 183288},
        "675": {"vr": "OB", "BinaryLength": 183288},
        "676": {"vr": "OB", "BinaryLength": 183288},
        "677": {"vr": "OB", "BinaryLength": 183288},
        "678": {"vr": "OB", "BinaryLength": 183288},
        "679": {"vr": "OB", "BinaryLength": 183288},
        "680": {"vr": "OB", "BinaryLength": 183288},
        "681": {"vr": "OB", "BinaryLength": 183288},
        "682": {"vr": "OB", "BinaryLength": 183288},
        "683": {"vr": "OB", "BinaryLength": 183288},
        "684": {"vr": "OB", "BinaryLength": 183288},
        "685": {"vr": "OB", "BinaryLength": 183288},
        "686": {"vr": "OB", "BinaryLength": 183288},
        "687": {"vr": "OB", "BinaryLength": 183288},
        "688": {"vr": "OB", "BinaryLength": 183288},
        "689": {"vr": "OB", "BinaryLength": 183288},
        "690": {"vr": "OB", "BinaryLength": 183288},
        "691": {"vr": "OB", "BinaryLength": 183288},
        "692": {"vr": "OB", "BinaryLength": 183288},
        "693": {"vr": "OB", "BinaryLength": 183288},
        "694": {"vr": "OB", "BinaryLength": 183288},
        "695": {"vr": "OB", "BinaryLength": 183288},
        "696": {"vr": "OB", "BinaryLength": 183288},
        "697": {"vr": "OB", "BinaryLength": 183288},
        "698": {"vr": "OB", "BinaryLength": 183288},
        "699": {"vr": "OB", "BinaryLength": 183288},
        "700": {"vr": "OB", "BinaryLength": 183288},
        "701": {"vr": "OB", "BinaryLength": 183288},
        "702": {"vr": "OB", "BinaryLength": 183288},
        "703": {"vr": "OB", "BinaryLength": 183288},
        "704": {"vr": "OB", "BinaryLength": 183288},
        "705": {"vr": "OB", "BinaryLength": 183288},
        "706": {"vr": "OB", "BinaryLength": 183288},
        "707": {"vr": "OB", "BinaryLength": 183288},
        "708": {"vr": "OB", "BinaryLength": 183288},
        "709": {"vr": "OB", "BinaryLength": 183288},
        "710": {"vr": "OB", "BinaryLength": 183288},
        "711": {"vr": "OB", "BinaryLength": 183288},
        "712": {"vr": "OB", "BinaryLength": 183288},
        "713": {"vr": "OB", "BinaryLength": 183288},
        "714": {"vr": "OB", "BinaryLength": 183288},
        "715": {"vr": "OB", "BinaryLength": 183288},
        "716": {"vr": "OB", "BinaryLength": 183288},
        "717": {"vr": "OB", "BinaryLength": 183288},
        "718": {"vr": "OB", "BinaryLength": 183288},
        "719": {"vr": "OB", "BinaryLength": 183288},
        "720": {"vr": "OB", "BinaryLength": 183288},
        "721": {"vr": "OB", "BinaryLength": 183288},
        "722": {"vr": "OB", "BinaryLength": 183288},
        "723": {"vr": "OB", "BinaryLength": 183288},
        "724": {"vr": "OB", "BinaryLength": 183288},
        "725": {"vr": "OB", "BinaryLength": 183288},
        "726": {"vr": "OB", "BinaryLength": 183288},
        "727": {"vr": "OB", "BinaryLength": 183288},
        "728": {"vr": "OB", "BinaryLength": 183288},
        "729": {"vr": "OB", "BinaryLength": 183288},
        "730": {"vr": "OB", "BinaryLength": 183288},
        "731": {"vr": "OB", "BinaryLength": 183288},
        "732": {"vr": "OB", "BinaryLength": 183288},
        "733": {"vr": "OB", "BinaryLength": 183288},
        "734": {"vr": "OB", "BinaryLength": 183288},
        "735": {"vr": "OB", "BinaryLength": 183288},
        "736": {"vr": "OB", "BinaryLength": 183288},
        "737": {"vr": "OB", "BinaryLength": 183288},
        "738": {"vr": "OB", "BinaryLength": 183288},
        "739": {"vr": "OB", "BinaryLength": 183288},
        "740": {"vr": "OB", "BinaryLength": 183288},
        "741": {"vr": "OB", "BinaryLength": 183288},
        "742": {"vr": "OB", "BinaryLength": 183288},
        "743": {"vr": "OB", "BinaryLength": 183288},
        "744": {"vr": "OB", "BinaryLength": 183288},
        "745": {"vr": "OB", "BinaryLength": 183288},
        "746": {"vr": "OB", "BinaryLength": 183288},
        "747": {"vr": "OB", "BinaryLength": 183288},
        "748": {"vr": "OB", "BinaryLength": 183288},
        "749": {"vr": "OB", "BinaryLength": 183288},
        "750": {"vr": "OB", "BinaryLength": 183288},
        "751": {"vr": "OB", "BinaryLength": 183288},
        "752": {"vr": "OB", "BinaryLength": 183288},
        "753": {"vr": "OB", "BinaryLength": 183288},
        "754": {"vr": "OB", "BinaryLength": 183288},
        "755": {"vr": "OB", "BinaryLength": 183288},
        "756": {"vr": "OB", "BinaryLength": 183288},
        "757": {"vr": "OB", "BinaryLength": 183288},
        "758": {"vr": "OB", "BinaryLength": 183288},
        "759": {"vr": "OB", "BinaryLength": 183288},
        "760": {"vr": "OB", "BinaryLength": 183288},
        "761": {"vr": "OB", "BinaryLength": 183288},
        "762": {"vr": "OB", "BinaryLength": 183288},
        "763": {"vr": "OB", "BinaryLength": 183288},
        "764": {"vr": "OB", "BinaryLength": 183288},
        "765": {"vr": "OB", "BinaryLength": 183288},
        "766": {"vr": "OB", "BinaryLength": 183288},
        "767": {"vr": "OB", "BinaryLength": 183288},
        "768": {"vr": "OB", "BinaryLength": 183288},
        "769": {"vr": "OB", "BinaryLength": 183288},
        "770": {"vr": "OB", "BinaryLength": 183288},
        "771": {"vr": "OB", "BinaryLength": 183288},
        "772": {"vr": "OB", "BinaryLength": 183288},
        "773": {"vr": "OB", "BinaryLength": 183288},
        "774": {"vr": "OB", "BinaryLength": 183288},
        "775": {"vr": "OB", "BinaryLength": 183288},
        "776": {"vr": "OB", "BinaryLength": 183288},
        "777": {"vr": "OB", "BinaryLength": 183288},
        "778": {"vr": "OB", "BinaryLength": 183288},
        "779": {"vr": "OB", "BinaryLength": 183288},
        "780": {"vr": "OB", "BinaryLength": 183288},
        "781": {"vr": "OB", "BinaryLength": 183288},
        "782": {"vr": "OB", "BinaryLength": 183288},
        "783": {"vr": "OB", "BinaryLength": 183288},
        "784": {"vr": "OB", "BinaryLength": 183288},
        "785": {"vr": "OB", "BinaryLength": 183288},
        "786": {"vr": "OB", "BinaryLength": 183288},
        "787": {"vr": "OB", "BinaryLength": 183288},
        "788": {"vr": "OB", "BinaryLength": 183288},
        "789": {"vr": "OB", "BinaryLength": 183288},
        "790": {"vr": "OB", "BinaryLength": 183288},
        "791": {"vr": "OB", "BinaryLength": 183288},
        "792": {"vr": "OB", "BinaryLength": 183288},
        "793": {"vr": "OB", "BinaryLength": 183288},
        "794": {"vr": "OB", "BinaryLength": 183288},
        "795": {"vr": "OB", "BinaryLength": 183288},
        "796": {"vr": "OB", "BinaryLength": 183288},
        "797": {"vr": "OB", "BinaryLength": 183288},
        "798": {"vr": "OB", "BinaryLength": 183288},
        "799": {"vr": "OB", "BinaryLength": 183288},
        "800": {"vr": "OB", "BinaryLength": 183288},
        "801": {"vr": "OB", "BinaryLength": 183288},
        "802": {"vr": "OB", "BinaryLength": 183288},
        "803": {"vr": "OB", "BinaryLength": 183288},
        "804": {"vr": "OB", "BinaryLength": 183288},
        "805": {"vr": "OB", "BinaryLength": 183288},
        "806": {"vr": "OB", "BinaryLength": 183288},
        "807": {"vr": "OB", "BinaryLength": 183288},
        "808": {"vr": "OB", "BinaryLength": 183288},
        "809": {"vr": "OB", "BinaryLength": 183288},
        "810": {"vr": "OB", "BinaryLength": 183288},
        "811": {"vr": "OB", "BinaryLength": 183288},
        "812": {"vr": "OB", "BinaryLength": 183288},
        "813": {"vr": "OB", "BinaryLength": 183288},
        "814": {"vr": "OB", "BinaryLength": 183288},
        "815": {"vr": "OB", "BinaryLength": 183288},
        "816": {"vr": "OB", "BinaryLength": 183288},
        "817": {"vr": "OB", "BinaryLength": 183288},
        "818": {"vr": "OB", "BinaryLength": 183288},
        "819": {"vr": "OB", "BinaryLength": 183288},
        "820": {"vr": "OB", "BinaryLength": 183288},
        "821": {"vr": "OB", "BinaryLength": 183288},
        "822": {"vr": "OB", "BinaryLength": 183288},
        "823": {"vr": "OB", "BinaryLength": 183288},
        "824": {"vr": "OB", "BinaryLength": 183288},
        "825": {"vr": "OB", "BinaryLength": 183288},
        "826": {"vr": "OB", "BinaryLength": 183288},
        "827": {"vr": "OB", "BinaryLength": 183288},
        "828": {"vr": "OB", "BinaryLength": 183288},
        "829": {"vr": "OB", "BinaryLength": 183288},
        "830": {"vr": "OB", "BinaryLength": 183288},
        "831": {"vr": "OB", "BinaryLength": 183288},
        "832": {"vr": "OB", "BinaryLength": 183288},
        "833": {"vr": "OB", "BinaryLength": 183288},
        "834": {"vr": "OB", "BinaryLength": 183288},
        "835": {"vr": "OB", "BinaryLength": 183288},
        "836": {"vr": "OB", "BinaryLength": 183288},
        "837": {"vr": "OB", "BinaryLength": 183288},
        "838": {"vr": "OB", "BinaryLength": 183288},
        "839": {"vr": "OB", "BinaryLength": 183288},
        "840": {"vr": "OB", "BinaryLength": 183288},
        "841": {"vr": "OB", "BinaryLength": 183288},
        "842": {"vr": "OB", "BinaryLength": 183288},
        "843": {"vr": "OB", "BinaryLength": 183288},
        "844": {"vr": "OB", "BinaryLength": 183288},
        "845": {"vr": "OB", "BinaryLength": 183288},
        "846": {"vr": "OB", "BinaryLength": 183288},
        "847": {"vr": "OB", "BinaryLength": 183288},
        "848": {"vr": "OB", "BinaryLength": 183288},
        "849": {"vr": "OB", "BinaryLength": 183288},
        "850": {"vr": "OB", "BinaryLength": 183288},
        "851": {"vr": "OB", "BinaryLength": 183288},
        "852": {"vr": "OB", "BinaryLength": 183288},
        "853": {"vr": "OB", "BinaryLength": 183288},
        "854": {"vr": "OB", "BinaryLength": 183288},
        "855": {"vr": "OB", "BinaryLength": 183288},
        "856": {"vr": "OB", "BinaryLength": 183288},
        "857": {"vr": "OB", "BinaryLength": 183288},
        "858": {"vr": "OB", "BinaryLength": 183288},
        "859": {"vr": "OB", "BinaryLength": 183288},
        "860": {"vr": "OB", "BinaryLength": 183288},
        "861": {"vr": "OB", "BinaryLength": 183288},
        "862": {"vr": "OB", "BinaryLength": 183288},
        "863": {"vr": "OB", "BinaryLength": 183288},
        "864": {"vr": "OB", "BinaryLength": 183288},
        "865": {"vr": "OB", "BinaryLength": 183288},
        "866": {"vr": "OB", "BinaryLength": 183288},
        "867": {"vr": "OB", "BinaryLength": 183288},
        "868": {"vr": "OB", "BinaryLength": 183288},
        "869": {"vr": "OB", "BinaryLength": 183288},
        "870": {"vr": "OB", "BinaryLength": 183288},
        "871": {"vr": "OB", "BinaryLength": 183288},
        "872": {"vr": "OB", "BinaryLength": 183288},
        "873": {"vr": "OB", "BinaryLength": 183288},
        "874": {"vr": "OB", "BinaryLength": 183288},
        "875": {"vr": "OB", "BinaryLength": 183288},
        "876": {"vr": "OB", "BinaryLength": 183288},
        "877": {"vr": "OB", "BinaryLength": 183288},
        "878": {"vr": "OB", "BinaryLength": 183288},
        "879": {"vr": "OB", "BinaryLength": 183288},
        "880": {"vr": "OB", "BinaryLength": 183288},
        "881": {"vr": "OB", "BinaryLength": 183288},
        "882": {"vr": "OB", "BinaryLength": 183288},
        "883": {"vr": "OB", "BinaryLength": 183288},
        "884": {"vr": "OB", "BinaryLength": 183288},
        "885": {"vr": "OB", "BinaryLength": 183288},
        "886": {"vr": "OB", "BinaryLength": 183288},
        "887": {"vr": "OB", "BinaryLength": 183288},
        "888": {"vr": "OB", "BinaryLength": 183288},
        "889": {"vr": "OB", "BinaryLength": 183288},
        "890": {"vr": "OB", "BinaryLength": 183288},
        "891": {"vr": "OB", "BinaryLength": 183288},
        "892": {"vr": "OB", "BinaryLength": 183288},
        "893": {"vr": "OB", "BinaryLength": 183288},
        "894": {"vr": "OB", "BinaryLength": 183288},
        "895": {"vr": "OB", "BinaryLength": 183288},
        "896": {"vr": "OB", "BinaryLength": 183288},
        "897": {"vr": "OB", "BinaryLength": 183288},
        "898": {"vr": "OB", "BinaryLength": 183288},
        "899": {"vr": "OB", "BinaryLength": 183288},
        "900": {"vr": "OB", "BinaryLength": 183288},
        "901": {"vr": "OB", "BinaryLength": 183288},
        "902": {"vr": "OB", "BinaryLength": 183288},
        "903": {"vr": "OB", "BinaryLength": 183288},
        "904": {"vr": "OB", "BinaryLength": 183288},
        "905": {"vr": "OB", "BinaryLength": 183288},
        "906": {"vr": "OB", "BinaryLength": 183288},
        "907": {"vr": "OB", "BinaryLength": 183288},
        "908": {"vr": "OB", "BinaryLength": 183288},
        "909": {"vr": "OB", "BinaryLength": 183288},
        "910": {"vr": "OB", "BinaryLength": 183288},
        "911": {"vr": "OB", "BinaryLength": 183288},
        "912": {"vr": "OB", "BinaryLength": 183288},
        "913": {"vr": "OB", "BinaryLength": 183288},
        "914": {"vr": "OB", "BinaryLength": 183288},
        "915": {"vr": "OB", "BinaryLength": 183288},
        "916": {"vr": "OB", "BinaryLength": 183288},
        "917": {"vr": "OB", "BinaryLength": 183288},
        "918": {"vr": "OB", "BinaryLength": 183288},
        "919": {"vr": "OB", "BinaryLength": 183288},
        "920": {"vr": "OB", "BinaryLength": 183288},
        "921": {"vr": "OB", "BinaryLength": 183288},
        "922": {"vr": "OB", "BinaryLength": 183288},
        "923": {"vr": "OB", "BinaryLength": 183288},
        "924": {"vr": "OB", "BinaryLength": 183288},
        "925": {"vr": "OB", "BinaryLength": 183288},
        "926": {"vr": "OB", "BinaryLength": 183288},
        "927": {"vr": "OB", "BinaryLength": 183288},
        "928": {"vr": "OB", "BinaryLength": 183288},
        "929": {"vr": "OB", "BinaryLength": 183288},
        "930": {"vr": "OB", "BinaryLength": 183288},
        "931": {"vr": "OB", "BinaryLength": 183288},
        "932": {"vr": "OB", "BinaryLength": 183288},
        "933": {"vr": "OB", "BinaryLength": 183288},
        "934": {"vr": "OB", "BinaryLength": 183288},
        "935": {"vr": "OB", "BinaryLength": 183288},
        "936": {"vr": "OB", "BinaryLength": 183288},
        "937": {"vr": "OB", "BinaryLength": 183288},
        "938": {"vr": "OB", "BinaryLength": 183288},
        "939": {"vr": "OB", "BinaryLength": 183288},
        "940": {"vr": "OB", "BinaryLength": 183288},
        "941": {"vr": "OB", "BinaryLength": 183288},
        "942": {"vr": "OB", "BinaryLength": 183288},
        "943": {"vr": "OB", "BinaryLength": 183288},
        "944": {"vr": "OB", "BinaryLength": 183288},
        "945": {"vr": "OB", "BinaryLength": 183288},
        "946": {"vr": "OB", "BinaryLength": 183288},
        "947": {"vr": "OB", "BinaryLength": 183288},
        "948": {"vr": "OB", "BinaryLength": 183288},
        "949": {"vr": "OB", "BinaryLength": 183288},
        "950": {"vr": "OB", "BinaryLength": 183288},
        "951": {"vr": "OB", "BinaryLength": 183288},
        "952": {"vr": "OB", "BinaryLength": 183288},
        "953": {"vr": "OB", "BinaryLength": 183288},
        "954": {"vr": "OB", "BinaryLength": 183288},
        "955": {"vr": "OB", "BinaryLength": 183288},
        "956": {"vr": "OB", "BinaryLength": 183288},
        "957": {"vr": "OB", "BinaryLength": 183288},
        "958": {"vr": "OB", "BinaryLength": 183288},
        "959": {"vr": "OB", "BinaryLength": 183288},
        "960": {"vr": "OB", "BinaryLength": 183288},
        "961": {"vr": "OB", "BinaryLength": 183288},
        "962": {"vr": "OB", "BinaryLength": 183288},
        "963": {"vr": "OB", "BinaryLength": 183288},
        "964": {"vr": "OB", "BinaryLength": 183288},
        "965": {"vr": "OB", "BinaryLength": 183288},
        "966": {"vr": "OB", "BinaryLength": 183288},
        "967": {"vr": "OB", "BinaryLength": 183288},
        "968": {"vr": "OB", "BinaryLength": 183288},
        "969": {"vr": "OB", "BinaryLength": 183288},
        "970": {"vr": "OB", "BinaryLength": 183288},
        "971": {"vr": "OB", "BinaryLength": 183288},
        "972": {"vr": "OB", "BinaryLength": 183288},
        "973": {"vr": "OB", "BinaryLength": 183288},
        "974": {"vr": "OB", "BinaryLength": 183288},
        "975": {"vr": "OB", "BinaryLength": 183288},
        "976": {"vr": "OB", "BinaryLength": 183288},
        "977": {"vr": "OB", "BinaryLength": 183288},
        "978": {"vr": "OB", "BinaryLength": 183288},
        "979": {"vr": "OB", "BinaryLength": 183288},
        "980": {"vr": "OB", "BinaryLength": 183288},
        "981": {"vr": "OB", "BinaryLength": 183288},
        "982": {"vr": "OB", "BinaryLength": 183288},
        "983": {"vr": "OB", "BinaryLength": 183288},
        "984": {"vr": "OB", "BinaryLength": 183288},
        "985": {"vr": "OB", "BinaryLength": 183288},
        "986": {"vr": "OB", "BinaryLength": 183288},
        "987": {"vr": "OB", "BinaryLength": 183288},
        "988": {"vr": "OB", "BinaryLength": 183288},
        "989": {"vr": "OB", "BinaryLength": 183288},
        "990": {"vr": "OB", "BinaryLength": 183288},
        "991": {"vr": "OB", "BinaryLength": 183288},
        "992": {"vr": "OB", "BinaryLength": 183288},
        "993": {"vr": "OB", "BinaryLength": 183288},
        "994": {"vr": "OB", "BinaryLength": 183288},
        "995": {"vr": "OB", "BinaryLength": 183288},
        "996": {"vr": "OB", "BinaryLength": 183288},
        "997": {"vr": "OB", "BinaryLength": 183288},
        "998": {"vr": "OB", "BinaryLength": 183288},
        "999": {"vr": "OB", "BinaryLength": 183288},
        "1000": {"vr": "OB", "BinaryLength": 183288},
        "1001": {"vr": "OB", "BinaryLength": 183288},
        "1002": {"vr": "OB", "BinaryLength": 183288},
        "1003": {"vr": "OB", "BinaryLength": 183288},
        "1004": {"vr": "OB", "BinaryLength": 183288},
        "1005": {"vr": "OB", "BinaryLength": 183288},
        "1006": {"vr": "OB", "BinaryLength": 183288},
        "1007": {"vr": "OB", "BinaryLength": 183288},
        "1008": {"vr": "OB", "BinaryLength": 183288},
        "1009": {"vr": "OB", "BinaryLength": 183288},
        "1010": {"vr": "OB", "BinaryLength": 183288},
        "1011": {"vr": "OB", "BinaryLength": 183288},
        "1012": {"vr": "OB", "BinaryLength": 183288},
        "1013": {"vr": "OB", "BinaryLength": 183288},
        "1014": {"vr": "OB", "BinaryLength": 183288},
        "1015": {"vr": "OB", "BinaryLength": 183288},
        "1016": {"vr": "OB", "BinaryLength": 183288},
        "1017": {"vr": "OB", "BinaryLength": 183288},
        "1018": {"vr": "OB", "BinaryLength": 183288},
        "1019": {"vr": "OB", "BinaryLength": 183288},
        "1020": {"vr": "OB", "BinaryLength": 183288},
        "1021": {"vr": "OB", "BinaryLength": 183288},
        "1022": {"vr": "OB", "BinaryLength": 183288},
        "1023": {"vr": "OB", "BinaryLength": 183288},
        "1024": {"vr": "OB", "BinaryLength": 183288},
        "1025": {"vr": "OB", "BinaryLength": 183288},
        "1026": {"vr": "OB", "BinaryLength": 183288},
        "1027": {"vr": "OB", "BinaryLength": 183288},
        "1028": {"vr": "OB", "BinaryLength": 183288},
        "1029": {"vr": "OB", "BinaryLength": 183288},
        "1030": {"vr": "OB", "BinaryLength": 183288},
        "1031": {"vr": "OB", "BinaryLength": 183288},
        "1032": {"vr": "OB", "BinaryLength": 183288},
        "1033": {"vr": "OB", "BinaryLength": 183288},
        "1034": {"vr": "OB", "BinaryLength": 183288},
        "1035": {"vr": "OB", "BinaryLength": 183288},
        "1036": {"vr": "OB", "BinaryLength": 183288},
        "1037": {"vr": "OB", "BinaryLength": 183288},
        "1038": {"vr": "OB", "BinaryLength": 183288},
        "1039": {"vr": "OB", "BinaryLength": 183288},
        "1040": {"vr": "OB", "BinaryLength": 183288},
        "1041": {"vr": "OB", "BinaryLength": 183288},
        "1042": {"vr": "OB", "BinaryLength": 183288},
        "1043": {"vr": "OB", "BinaryLength": 183288},
        "1044": {"vr": "OB", "BinaryLength": 183288},
        "1045": {"vr": "OB", "BinaryLength": 183288},
        "1046": {"vr": "OB", "BinaryLength": 183288},
        "1047": {"vr": "OB", "BinaryLength": 183288},
        "1048": {"vr": "OB", "BinaryLength": 183288},
        "1049": {"vr": "OB", "BinaryLength": 183288},
        "1050": {"vr": "OB", "BinaryLength": 183288},
        "1051": {"vr": "OB", "BinaryLength": 183288},
        "1052": {"vr": "OB", "BinaryLength": 183288},
        "1053": {"vr": "OB", "BinaryLength": 183288},
        "1054": {"vr": "OB", "BinaryLength": 183288},
        "1055": {"vr": "OB", "BinaryLength": 183288},
        "1056": {"vr": "OB", "BinaryLength": 183288},
        "1057": {"vr": "OB", "BinaryLength": 183288},
        "1058": {"vr": "OB", "BinaryLength": 183288},
        "1059": {"vr": "OB", "BinaryLength": 183288},
        "1060": {"vr": "OB", "BinaryLength": 183288},
        "1061": {"vr": "OB", "BinaryLength": 183288},
        "1062": {"vr": "OB", "BinaryLength": 183288},
        "1063": {"vr": "OB", "BinaryLength": 183288},
        "1064": {"vr": "OB", "BinaryLength": 183288},
        "1065": {"vr": "OB", "BinaryLength": 183288},
        "1066": {"vr": "OB", "BinaryLength": 183288},
        "1067": {"vr": "OB", "BinaryLength": 183288},
        "1068": {"vr": "OB", "BinaryLength": 183288},
        "1069": {"vr": "OB", "BinaryLength": 183288},
        "1070": {"vr": "OB", "BinaryLength": 183288},
        "1071": {"vr": "OB", "BinaryLength": 183288},
        "1072": {"vr": "OB", "BinaryLength": 183288},
        "1073": {"vr": "OB", "BinaryLength": 183288},
        "1074": {"vr": "OB", "BinaryLength": 183288},
        "1075": {"vr": "OB", "BinaryLength": 183288},
        "1076": {"vr": "OB", "BinaryLength": 183288},
        "1077": {"vr": "OB", "BinaryLength": 183288},
        "1078": {"vr": "OB", "BinaryLength": 183288},
        "1079": {"vr": "OB", "BinaryLength": 183288},
        "1080": {"vr": "OB", "BinaryLength": 183288},
        "1081": {"vr": "OB", "BinaryLength": 183288},
        "1082": {"vr": "OB", "BinaryLength": 183288},
        "1083": {"vr": "OB", "BinaryLength": 183288},
        "1084": {"vr": "OB", "BinaryLength": 183288},
        "1085": {"vr": "OB", "BinaryLength": 183288},
        "1086": {"vr": "OB", "BinaryLength": 183288},
        "1087": {"vr": "OB", "BinaryLength": 183288},
        "1088": {"vr": "OB", "BinaryLength": 183288},
        "1089": {"vr": "OB", "BinaryLength": 183288},
        "1090": {"vr": "OB", "BinaryLength": 183288},
        "1091": {"vr": "OB", "BinaryLength": 183288},
        "1092": {"vr": "OB", "BinaryLength": 183288},
        "1093": {"vr": "OB", "BinaryLength": 183288},
        "1094": {"vr": "OB", "BinaryLength": 183288},
        "1095": {"vr": "OB", "BinaryLength": 183288},
        "1096": {"vr": "OB", "BinaryLength": 183288},
        "1097": {"vr": "OB", "BinaryLength": 183288},
        "1098": {"vr": "OB", "BinaryLength": 183288},
        "1099": {"vr": "OB", "BinaryLength": 183288},
        "1100": {"vr": "OB", "BinaryLength": 183288},
        "1101": {"vr": "OB", "BinaryLength": 183288},
        "1102": {"vr": "OB", "BinaryLength": 183288},
        "1103": {"vr": "OB", "BinaryLength": 183288},
        "1104": {"vr": "OB", "BinaryLength": 183288},
        "1105": {"vr": "OB", "BinaryLength": 183288},
        "1106": {"vr": "OB", "BinaryLength": 183288},
        "1107": {"vr": "OB", "BinaryLength": 183288},
        "1108": {"vr": "OB", "BinaryLength": 183288},
        "1109": {"vr": "OB", "BinaryLength": 183288},
        "1110": {"vr": "OB", "BinaryLength": 183288},
        "1111": {"vr": "OB", "BinaryLength": 183288},
        "1112": {"vr": "OB", "BinaryLength": 183288},
        "1113": {"vr": "OB", "BinaryLength": 183288},
        "1114": {"vr": "OB", "BinaryLength": 183288},
        "1115": {"vr": "OB", "BinaryLength": 183288},
        "1116": {"vr": "OB", "BinaryLength": 183288},
        "1117": {"vr": "OB", "BinaryLength": 183288},
        "1118": {"vr": "OB", "BinaryLength": 183288},
        "1119": {"vr": "OB", "BinaryLength": 183288},
        "1120": {"vr": "OB", "BinaryLength": 183288},
        "1121": {"vr": "OB", "BinaryLength": 183288},
        "1122": {"vr": "OB", "BinaryLength": 183288},
        "1123": {"vr": "OB", "BinaryLength": 183288},
        "1124": {"vr": "OB", "BinaryLength": 183288},
        "1125": {"vr": "OB", "BinaryLength": 183288},
        "1126": {"vr": "OB", "BinaryLength": 183288},
        "1127": {"vr": "OB", "BinaryLength": 183288},
        "1128": {"vr": "OB", "BinaryLength": 183288},
        "1129": {"vr": "OB", "BinaryLength": 183288},
        "1130": {"vr": "OB", "BinaryLength": 183288},
        "1131": {"vr": "OB", "BinaryLength": 183288},
        "1132": {"vr": "OB", "BinaryLength": 183288},
        "1133": {"vr": "OB", "BinaryLength": 183288},
        "1134": {"vr": "OB", "BinaryLength": 183288},
        "1135": {"vr": "OB", "BinaryLength": 183288},
        "1136": {"vr": "OB", "BinaryLength": 183288},
        "1137": {"vr": "OB", "BinaryLength": 183288},
        "1138": {"vr": "OB", "BinaryLength": 183288},
        "1139": {"vr": "OB", "BinaryLength": 183288},
        "1140": {"vr": "OB", "BinaryLength": 183288},
        "1141": {"vr": "OB", "BinaryLength": 183288},
        "1142": {"vr": "OB", "BinaryLength": 183288},
        "1143": {"vr": "OB", "BinaryLength": 183288},
        "1144": {"vr": "OB", "BinaryLength": 183288},
        "1145": {"vr": "OB", "BinaryLength": 183288},
        "1146": {"vr": "OB", "BinaryLength": 183288},
        "1147": {"vr": "OB", "BinaryLength": 183288},
        "1148": {"vr": "OB", "BinaryLength": 183288},
        "1149": {"vr": "OB", "BinaryLength": 183288},
        "1150": {"vr": "OB", "BinaryLength": 183288},
        "1151": {"vr": "OB", "BinaryLength": 183288},
        "1152": {"vr": "OB", "BinaryLength": 183288},
        "1153": {"vr": "OB", "BinaryLength": 183288},
        "1154": {"vr": "OB", "BinaryLength": 183288},
        "1155": {"vr": "OB", "BinaryLength": 183288},
        "1156": {"vr": "OB", "BinaryLength": 183288},
        "1157": {"vr": "OB", "BinaryLength": 183288},
        "1158": {"vr": "OB", "BinaryLength": 183288},
        "1159": {"vr": "OB", "BinaryLength": 183288},
        "1160": {"vr": "OB", "BinaryLength": 183288},
        "1161": {"vr": "OB", "BinaryLength": 183288},
        "1162": {"vr": "OB", "BinaryLength": 183288},
        "1163": {"vr": "OB", "BinaryLength": 183288},
        "1164": {"vr": "OB", "BinaryLength": 183288},
        "1165": {"vr": "OB", "BinaryLength": 183288},
        "1166": {"vr": "OB", "BinaryLength": 183288},
        "1167": {"vr": "OB", "BinaryLength": 183288},
        "1168": {"vr": "OB", "BinaryLength": 183288},
        "1169": {"vr": "OB", "BinaryLength": 183288},
        "1170": {"vr": "OB", "BinaryLength": 183288},
        "1171": {"vr": "OB", "BinaryLength": 183288},
        "1172": {"vr": "OB", "BinaryLength": 183288},
        "1173": {"vr": "OB", "BinaryLength": 183288},
        "1174": {"vr": "OB", "BinaryLength": 183288},
        "1175": {"vr": "OB", "BinaryLength": 183288},
        "1176": {"vr": "OB", "BinaryLength": 183288},
        "1177": {"vr": "OB", "BinaryLength": 183288},
        "1178": {"vr": "OB", "BinaryLength": 183288},
        "1179": {"vr": "OB", "BinaryLength": 183288},
        "1180": {"vr": "OB", "BinaryLength": 183288},
        "1181": {"vr": "OB", "BinaryLength": 183288},
        "1182": {"vr": "OB", "BinaryLength": 183288},
        "1183": {"vr": "OB", "BinaryLength": 183288},
        "1184": {"vr": "OB", "BinaryLength": 183288},
        "1185": {"vr": "OB", "BinaryLength": 183288},
        "1186": {"vr": "OB", "BinaryLength": 183288},
        "1187": {"vr": "OB", "BinaryLength": 183288},
        "1188": {"vr": "OB", "BinaryLength": 183288},
        "1189": {"vr": "OB", "BinaryLength": 183288},
        "1190": {"vr": "OB", "BinaryLength": 183288},
        "1191": {"vr": "OB", "BinaryLength": 183288},
        "1192": {"vr": "OB", "BinaryLength": 183288},
        "1193": {"vr": "OB", "BinaryLength": 183288},
        "1194": {"vr": "OB", "BinaryLength": 183288},
        "1195": {"vr": "OB", "BinaryLength": 183288},
        "1196": {"vr": "OB", "BinaryLength": 183288},
        "1197": {"vr": "OB", "BinaryLength": 183288},
        "1198": {"vr": "OB", "BinaryLength": 183288},
        "1199": {"vr": "OB", "BinaryLength": 183288},
        "1200": {"vr": "OB", "BinaryLength": 183288},
        "1201": {"vr": "OB", "BinaryLength": 183288},
        "1202": {"vr": "OB", "BinaryLength": 183288},
        "1203": {"vr": "OB", "BinaryLength": 183288},
        "1204": {"vr": "OB", "BinaryLength": 183288},
        "1205": {"vr": "OB", "BinaryLength": 183288},
        "1206": {"vr": "OB", "BinaryLength": 183288},
        "1207": {"vr": "OB", "BinaryLength": 183288},
        "1208": {"vr": "OB", "BinaryLength": 183288},
        "1209": {"vr": "OB", "BinaryLength": 183288},
        "1210": {"vr": "OB", "BinaryLength": 183288},
        "1211": {"vr": "OB", "BinaryLength": 183288},
        "1212": {"vr": "OB", "BinaryLength": 183288},
        "1213": {"vr": "OB", "BinaryLength": 183288},
        "1214": {"vr": "OB", "BinaryLength": 183288},
        "1215": {"vr": "OB", "BinaryLength": 183288},
        "1216": {"vr": "OB", "BinaryLength": 183288},
        "1217": {"vr": "OB", "BinaryLength": 183288},
        "1218": {"vr": "OB", "BinaryLength": 183288},
        "1219": {"vr": "OB", "BinaryLength": 183288},
        "1220": {"vr": "OB", "BinaryLength": 183288},
        "1221": {"vr": "OB", "BinaryLength": 183288},
        "1222": {"vr": "OB", "BinaryLength": 183288},
        "1223": {"vr": "OB", "BinaryLength": 183288},
        "1224": {"vr": "OB", "BinaryLength": 183288},
        "1225": {"vr": "OB", "BinaryLength": 183288},
        "1226": {"vr": "OB", "BinaryLength": 183288},
        "1227": {"vr": "OB", "BinaryLength": 183288},
        "1228": {"vr": "OB", "BinaryLength": 183288},
        "1229": {"vr": "OB", "BinaryLength": 183288},
        "1230": {"vr": "OB", "BinaryLength": 183288},
        "1231": {"vr": "OB", "BinaryLength": 183288},
        "1232": {"vr": "OB", "BinaryLength": 183288},
        "1233": {"vr": "OB", "BinaryLength": 183288},
        "1234": {"vr": "OB", "BinaryLength": 183288},
        "1235": {"vr": "OB", "BinaryLength": 183288},
        "1236": {"vr": "OB", "BinaryLength": 183288},
        "1237": {"vr": "OB", "BinaryLength": 183288},
        "1238": {"vr": "OB", "BinaryLength": 183288},
        "1239": {"vr": "OB", "BinaryLength": 183288},
        "1240": {"vr": "OB", "BinaryLength": 183288},
        "1241": {"vr": "OB", "BinaryLength": 183288},
        "1242": {"vr": "OB", "BinaryLength": 183288},
        "1243": {"vr": "OB", "BinaryLength": 183288},
        "1244": {"vr": "OB", "BinaryLength": 183288},
        "1245": {"vr": "OB", "BinaryLength": 183288},
        "1246": {"vr": "OB", "BinaryLength": 183288},
        "1247": {"vr": "OB", "BinaryLength": 183288},
        "1248": {"vr": "OB", "BinaryLength": 183288},
        "1249": {"vr": "OB", "BinaryLength": 183288},
        "1250": {"vr": "OB", "BinaryLength": 183288},
        "1251": {"vr": "OB", "BinaryLength": 183288},
        "1252": {"vr": "OB", "BinaryLength": 183288},
        "1253": {"vr": "OB", "BinaryLength": 183288},
        "1254": {"vr": "OB", "BinaryLength": 183288},
        "1255": {"vr": "OB", "BinaryLength": 183288},
        "1256": {"vr": "OB", "BinaryLength": 183288},
        "1257": {"vr": "OB", "BinaryLength": 183288},
        "1258": {"vr": "OB", "BinaryLength": 183288},
        "1259": {"vr": "OB", "BinaryLength": 183288},
        "1260": {"vr": "OB", "BinaryLength": 183288},
        "1261": {"vr": "OB", "BinaryLength": 183288},
        "1262": {"vr": "OB", "BinaryLength": 183288},
        "1263": {"vr": "OB", "BinaryLength": 183288},
        "1264": {"vr": "OB", "BinaryLength": 183288},
        "1265": {"vr": "OB", "BinaryLength": 183288},
        "1266": {"vr": "OB", "BinaryLength": 183288},
        "1267": {"vr": "OB", "BinaryLength": 183288},
        "1268": {"vr": "OB", "BinaryLength": 183288},
        "1269": {"vr": "OB", "BinaryLength": 183288},
        "1270": {"vr": "OB", "BinaryLength": 183288},
        "1271": {"vr": "OB", "BinaryLength": 183288},
        "1272": {"vr": "OB", "BinaryLength": 183288},
        "1273": {"vr": "OB", "BinaryLength": 183288},
        "1274": {"vr": "OB", "BinaryLength": 183288},
        "1275": {"vr": "OB", "BinaryLength": 183288},
        "1276": {"vr": "OB", "BinaryLength": 183288},
        "1277": {"vr": "OB", "BinaryLength": 183288},
        "1278": {"vr": "OB", "BinaryLength": 183288},
        "1279": {"vr": "OB", "BinaryLength": 183288},
        "1280": {"vr": "OB", "BinaryLength": 183288},
        "1281": {"vr": "OB", "BinaryLength": 183288},
        "1282": {"vr": "OB", "BinaryLength": 183288},
        "1283": {"vr": "OB", "BinaryLength": 183288},
        "1284": {"vr": "OB", "BinaryLength": 183288},
        "1285": {"vr": "OB", "BinaryLength": 183288},
        "1286": {"vr": "OB", "BinaryLength": 183288},
        "1287": {"vr": "OB", "BinaryLength": 183288},
        "1288": {"vr": "OB", "BinaryLength": 183288},
        "1289": {"vr": "OB", "BinaryLength": 183288},
        "1290": {"vr": "OB", "BinaryLength": 183288},
        "1291": {"vr": "OB", "BinaryLength": 183288},
        "1292": {"vr": "OB", "BinaryLength": 183288},
        "1293": {"vr": "OB", "BinaryLength": 183288},
        "1294": {"vr": "OB", "BinaryLength": 183288},
        "1295": {"vr": "OB", "BinaryLength": 183288},
        "1296": {"vr": "OB", "BinaryLength": 183288},
        "1297": {"vr": "OB", "BinaryLength": 183288},
        "1298": {"vr": "OB", "BinaryLength": 183288},
        "1299": {"vr": "OB", "BinaryLength": 183288},
        "1300": {"vr": "OB", "BinaryLength": 183288},
        "1301": {"vr": "OB", "BinaryLength": 183288},
        "1302": {"vr": "OB", "BinaryLength": 183288},
        "1303": {"vr": "OB", "BinaryLength": 183288},
        "1304": {"vr": "OB", "BinaryLength": 183288},
        "1305": {"vr": "OB", "BinaryLength": 183288},
        "1306": {"vr": "OB", "BinaryLength": 183288},
        "1307": {"vr": "OB", "BinaryLength": 183288},
        "1308": {"vr": "OB", "BinaryLength": 183288},
        "1309": {"vr": "OB", "BinaryLength": 183288},
        "1310": {"vr": "OB", "BinaryLength": 183288},
        "1311": {"vr": "OB", "BinaryLength": 183288},
        "1312": {"vr": "OB", "BinaryLength": 183288},
        "1313": {"vr": "OB", "BinaryLength": 183288},
        "1314": {"vr": "OB", "BinaryLength": 183288},
        "1315": {"vr": "OB", "BinaryLength": 183288},
        "1316": {"vr": "OB", "BinaryLength": 183288},
        "1317": {"vr": "OB", "BinaryLength": 183288},
        "1318": {"vr": "OB", "BinaryLength": 183288},
        "1319": {"vr": "OB", "BinaryLength": 183288},
        "1320": {"vr": "OB", "BinaryLength": 183288},
        "1321": {"vr": "OB", "BinaryLength": 183288},
        "1322": {"vr": "OB", "BinaryLength": 183288},
        "1323": {"vr": "OB", "BinaryLength": 183288},
        "1324": {"vr": "OB", "BinaryLength": 183288},
        "1325": {"vr": "OB", "BinaryLength": 183288},
        "1326": {"vr": "OB", "BinaryLength": 183288},
        "1327": {"vr": "OB", "BinaryLength": 183288},
        "1328": {"vr": "OB", "BinaryLength": 183288},
        "1329": {"vr": "OB", "BinaryLength": 183288},
        "1330": {"vr": "OB", "BinaryLength": 183288},
        "1331": {"vr": "OB", "BinaryLength": 183288},
        "1332": {"vr": "OB", "BinaryLength": 183288},
        "1333": {"vr": "OB", "BinaryLength": 183288},
        "1334": {"vr": "OB", "BinaryLength": 183288},
        "1335": {"vr": "OB", "BinaryLength": 183288},
        "1336": {"vr": "OB", "BinaryLength": 183288},
        "1337": {"vr": "OB", "BinaryLength": 183288},
        "1338": {"vr": "OB", "BinaryLength": 183288},
        "1339": {"vr": "OB", "BinaryLength": 183288},
        "1340": {"vr": "OB", "BinaryLength": 183288},
        "1341": {"vr": "OB", "BinaryLength": 183288},
        "1342": {"vr": "OB", "BinaryLength": 183288},
        "1343": {"vr": "OB", "BinaryLength": 183288},
        "1344": {"vr": "OB", "BinaryLength": 183288},
        "1345": {"vr": "OB", "BinaryLength": 183288},
        "1346": {"vr": "OB", "BinaryLength": 183288},
        "1347": {"vr": "OB", "BinaryLength": 183288},
        "1348": {"vr": "OB", "BinaryLength": 183288},
        "1349": {"vr": "OB", "BinaryLength": 183288},
        "1350": {"vr": "OB", "BinaryLength": 183288},
        "1351": {"vr": "OB", "BinaryLength": 183288},
        "1352": {"vr": "OB", "BinaryLength": 183288},
        "1353": {"vr": "OB", "BinaryLength": 183288},
        "1354": {"vr": "OB", "BinaryLength": 183288},
        "1355": {"vr": "OB", "BinaryLength": 183288},
        "1356": {"vr": "OB", "BinaryLength": 183288},
        "1357": {"vr": "OB", "BinaryLength": 183288},
        "1358": {"vr": "OB", "BinaryLength": 183288},
        "1359": {"vr": "OB", "BinaryLength": 183288},
        "1360": {"vr": "OB", "BinaryLength": 183288},
        "1361": {"vr": "OB", "BinaryLength": 183288},
        "1362": {"vr": "OB", "BinaryLength": 183288},
        "1363": {"vr": "OB", "BinaryLength": 183288},
        "1364": {"vr": "OB", "BinaryLength": 183288},
        "1365": {"vr": "OB", "BinaryLength": 183288},
        "1366": {"vr": "OB", "BinaryLength": 183288},
        "1367": {"vr": "OB", "BinaryLength": 183288},
        "1368": {"vr": "OB", "BinaryLength": 183288},
        "1369": {"vr": "OB", "BinaryLength": 183288},
        "1370": {"vr": "OB", "BinaryLength": 183288},
        "1371": {"vr": "OB", "BinaryLength": 183288},
        "1372": {"vr": "OB", "BinaryLength": 183288},
        "1373": {"vr": "OB", "BinaryLength": 183288},
        "1374": {"vr": "OB", "BinaryLength": 183288},
        "1375": {"vr": "OB", "BinaryLength": 183288},
        "1376": {"vr": "OB", "BinaryLength": 183288},
        "1377": {"vr": "OB", "BinaryLength": 183288},
        "1378": {"vr": "OB", "BinaryLength": 183288},
        "1379": {"vr": "OB", "BinaryLength": 183288},
        "1380": {"vr": "OB", "BinaryLength": 183288},
        "1381": {"vr": "OB", "BinaryLength": 183288},
        "1382": {"vr": "OB", "BinaryLength": 183288},
        "1383": {"vr": "OB", "BinaryLength": 183288},
        "1384": {"vr": "OB", "BinaryLength": 183288},
        "1385": {"vr": "OB", "BinaryLength": 183288},
        "1386": {"vr": "OB", "BinaryLength": 183288},
        "1387": {"vr": "OB", "BinaryLength": 183288},
        "1388": {"vr": "OB", "BinaryLength": 183288},
        "1389": {"vr": "OB", "BinaryLength": 183288},
        "1390": {"vr": "OB", "BinaryLength": 183288},
        "1391": {"vr": "OB", "BinaryLength": 183288},
        "1392": {"vr": "OB", "BinaryLength": 183288},
        "1393": {"vr": "OB", "BinaryLength": 183288},
        "1394": {"vr": "OB", "BinaryLength": 183288},
        "1395": {"vr": "OB", "BinaryLength": 183288},
        "1396": {"vr": "OB", "BinaryLength": 183288},
        "1397": {"vr": "OB", "BinaryLength": 183288},
        "1398": {"vr": "OB", "BinaryLength": 183288},
        "1399": {"vr": "OB", "BinaryLength": 183288},
        "1400": {"vr": "OB", "BinaryLength": 183288},
        "1401": {"vr": "OB", "BinaryLength": 183288},
        "1402": {"vr": "OB", "BinaryLength": 183288},
        "1403": {"vr": "OB", "BinaryLength": 183288},
        "1404": {"vr": "OB", "BinaryLength": 183288},
        "1405": {"vr": "OB", "BinaryLength": 183288},
        "1406": {"vr": "OB", "BinaryLength": 183288},
        "1407": {"vr": "OB", "BinaryLength": 183288},
        "1408": {"vr": "OB", "BinaryLength": 183288},
        "1409": {"vr": "OB", "BinaryLength": 183288},
        "1410": {"vr": "OB", "BinaryLength": 183288},
        "1411": {"vr": "OB", "BinaryLength": 183288},
        "1412": {"vr": "OB", "BinaryLength": 183288},
        "1413": {"vr": "OB", "BinaryLength": 183288},
        "1414": {"vr": "OB", "BinaryLength": 183288},
        "1415": {"vr": "OB", "BinaryLength": 183288},
        "1416": {"vr": "OB", "BinaryLength": 183288},
        "1417": {"vr": "OB", "BinaryLength": 183288},
        "1418": {"vr": "OB", "BinaryLength": 183288},
        "1419": {"vr": "OB", "BinaryLength": 183288},
        "1420": {"vr": "OB", "BinaryLength": 183288},
        "1421": {"vr": "OB", "BinaryLength": 183288},
        "1422": {"vr": "OB", "BinaryLength": 183288},
        "1423": {"vr": "OB", "BinaryLength": 183288},
        "1424": {"vr": "OB", "BinaryLength": 183288},
        "1425": {"vr": "OB", "BinaryLength": 183288},
        "1426": {"vr": "OB", "BinaryLength": 183288},
        "1427": {"vr": "OB", "BinaryLength": 183288},
        "1428": {"vr": "OB", "BinaryLength": 183288},
        "1429": {"vr": "OB", "BinaryLength": 183288},
        "1430": {"vr": "OB", "BinaryLength": 183288},
        "1431": {"vr": "OB", "BinaryLength": 183288},
        "1432": {"vr": "OB", "BinaryLength": 183288},
        "1433": {"vr": "OB", "BinaryLength": 183288},
        "1434": {"vr": "OB", "BinaryLength": 183288},
        "1435": {"vr": "OB", "BinaryLength": 183288},
        "1436": {"vr": "OB", "BinaryLength": 183288},
        "1437": {"vr": "OB", "BinaryLength": 183288},
        "1438": {"vr": "OB", "BinaryLength": 183288},
        "1439": {"vr": "OB", "BinaryLength": 183288},
        "1440": {"vr": "OB", "BinaryLength": 183288},
        "1441": {"vr": "OB", "BinaryLength": 183288},
        "1442": {"vr": "OB", "BinaryLength": 183288},
        "1443": {"vr": "OB", "BinaryLength": 183288},
        "1444": {"vr": "OB", "BinaryLength": 183288},
        "1445": {"vr": "OB", "BinaryLength": 183288},
        "1446": {"vr": "OB", "BinaryLength": 183288},
        "1447": {"vr": "OB", "BinaryLength": 183288},
        "1448": {"vr": "OB", "BinaryLength": 183288},
        "1449": {"vr": "OB", "BinaryLength": 183288},
        "1450": {"vr": "OB", "BinaryLength": 183288},
        "1451": {"vr": "OB", "BinaryLength": 183288},
        "1452": {"vr": "OB", "BinaryLength": 183288},
        "1453": {"vr": "OB", "BinaryLength": 183288},
        "1454": {"vr": "OB", "BinaryLength": 183288},
        "1455": {"vr": "OB", "BinaryLength": 183288},
        "1456": {"vr": "OB", "BinaryLength": 183288},
        "1457": {"vr": "OB", "BinaryLength": 183288},
        "1458": {"vr": "OB", "BinaryLength": 183288},
        "1459": {"vr": "OB", "BinaryLength": 183288},
        "1460": {"vr": "OB", "BinaryLength": 183288},
        "1461": {"vr": "OB", "BinaryLength": 183288},
        "1462": {"vr": "OB", "BinaryLength": 183288},
        "1463": {"vr": "OB", "BinaryLength": 183288},
        "1464": {"vr": "OB", "BinaryLength": 183288},
        "1465": {"vr": "OB", "BinaryLength": 183288},
        "1466": {"vr": "OB", "BinaryLength": 183288},
        "1467": {"vr": "OB", "BinaryLength": 183288},
        "1468": {"vr": "OB", "BinaryLength": 183288},
        "1469": {"vr": "OB", "BinaryLength": 183288},
        "1470": {"vr": "OB", "BinaryLength": 183288},
        "1471": {"vr": "OB", "BinaryLength": 183288},
        "1472": {"vr": "OB", "BinaryLength": 183288},
        "1473": {"vr": "OB", "BinaryLength": 183288},
        "1474": {"vr": "OB", "BinaryLength": 183288},
        "1475": {"vr": "OB", "BinaryLength": 183288},
        "1476": {"vr": "OB", "BinaryLength": 183288},
        "1477": {"vr": "OB", "BinaryLength": 183288},
        "1478": {"vr": "OB", "BinaryLength": 183288},
        "1479": {"vr": "OB", "BinaryLength": 183288},
        "1480": {"vr": "OB", "BinaryLength": 183288},
        "1481": {"vr": "OB", "BinaryLength": 183288},
        "1482": {"vr": "OB", "BinaryLength": 183288},
        "1483": {"vr": "OB", "BinaryLength": 183288},
        "1484": {"vr": "OB", "BinaryLength": 183288},
        "1485": {"vr": "OB", "BinaryLength": 183288},
        "1486": {"vr": "OB", "BinaryLength": 183288},
        "1487": {"vr": "OB", "BinaryLength": 183288},
        "1488": {"vr": "OB", "BinaryLength": 183288},
        "1489": {"vr": "OB", "BinaryLength": 183288},
        "1490": {"vr": "OB", "BinaryLength": 183288},
        "1491": {"vr": "OB", "BinaryLength": 183288},
        "1492": {"vr": "OB", "BinaryLength": 183288},
        "1493": {"vr": "OB", "BinaryLength": 183288},
        "1494": {"vr": "OB", "BinaryLength": 183288},
        "1495": {"vr": "OB", "BinaryLength": 183288},
        "1496": {"vr": "OB", "BinaryLength": 183288},
        "1497": {"vr": "OB", "BinaryLength": 183288},
        "1498": {"vr": "OB", "BinaryLength": 183288},
        "1499": {"vr": "OB", "BinaryLength": 183288},
        "1500": {"vr": "OB", "BinaryLength": 183288},
        "1501": {"vr": "OB", "BinaryLength": 183288},
        "1502": {"vr": "OB", "BinaryLength": 183288},
        "1503": {"vr": "OB", "BinaryLength": 183288},
        "1504": {"vr": "OB", "BinaryLength": 183288},
        "1505": {"vr": "OB", "BinaryLength": 183288},
        "1506": {"vr": "OB", "BinaryLength": 183288},
        "1507": {"vr": "OB", "BinaryLength": 183288},
        "1508": {"vr": "OB", "BinaryLength": 183288},
        "1509": {"vr": "OB", "BinaryLength": 183288},
        "1510": {"vr": "OB", "BinaryLength": 183288},
        "1511": {"vr": "OB", "BinaryLength": 183288},
        "1512": {"vr": "OB", "BinaryLength": 183288},
        "1513": {"vr": "OB", "BinaryLength": 183288},
        "1514": {"vr": "OB", "BinaryLength": 183288},
        "1515": {"vr": "OB", "BinaryLength": 183288},
        "1516": {"vr": "OB", "BinaryLength": 183288},
        "1517": {"vr": "OB", "BinaryLength": 183288},
        "1518": {"vr": "OB", "BinaryLength": 183288},
        "1519": {"vr": "OB", "BinaryLength": 183288},
        "1520": {"vr": "OB", "BinaryLength": 183288},
        "1521": {"vr": "OB", "BinaryLength": 183288},
        "1522": {"vr": "OB", "BinaryLength": 183288},
        "1523": {"vr": "OB", "BinaryLength": 183288},
        "1524": {"vr": "OB", "BinaryLength": 183288},
        "1525": {"vr": "OB", "BinaryLength": 183288},
        "1526": {"vr": "OB", "BinaryLength": 183288},
        "1527": {"vr": "OB", "BinaryLength": 183288},
        "1528": {"vr": "OB", "BinaryLength": 183288},
        "1529": {"vr": "OB", "BinaryLength": 183288},
        "1530": {"vr": "OB", "BinaryLength": 183288},
        "1531": {"vr": "OB", "BinaryLength": 183288},
        "1532": {"vr": "OB", "BinaryLength": 183288},
        "1533": {"vr": "OB", "BinaryLength": 183288},
        "1534": {"vr": "OB", "BinaryLength": 183288},
        "1535": {"vr": "OB", "BinaryLength": 183288},
        "1536": {"vr": "OB", "BinaryLength": 183288},
        "1537": {"vr": "OB", "BinaryLength": 183288},
        "1538": {"vr": "OB", "BinaryLength": 183288},
        "1539": {"vr": "OB", "BinaryLength": 183288},
        "1540": {"vr": "OB", "BinaryLength": 183288},
        "1541": {"vr": "OB", "BinaryLength": 183288},
        "1542": {"vr": "OB", "BinaryLength": 183288},
        "1543": {"vr": "OB", "BinaryLength": 183288},
        "1544": {"vr": "OB", "BinaryLength": 183288},
        "1545": {"vr": "OB", "BinaryLength": 183288},
        "1546": {"vr": "OB", "BinaryLength": 183288},
        "1547": {"vr": "OB", "BinaryLength": 183288},
        "1548": {"vr": "OB", "BinaryLength": 183288},
        "1549": {"vr": "OB", "BinaryLength": 183288},
        "1550": {"vr": "OB", "BinaryLength": 183288},
        "1551": {"vr": "OB", "BinaryLength": 183288},
        "1552": {"vr": "OB", "BinaryLength": 183288},
        "1553": {"vr": "OB", "BinaryLength": 183288},
        "1554": {"vr": "OB", "BinaryLength": 183288},
        "1555": {"vr": "OB", "BinaryLength": 183288},
        "1556": {"vr": "OB", "BinaryLength": 183288},
        "1557": {"vr": "OB", "BinaryLength": 183288},
        "1558": {"vr": "OB", "BinaryLength": 183288},
        "1559": {"vr": "OB", "BinaryLength": 183288},
        "1560": {"vr": "OB", "BinaryLength": 183288},
        "1561": {"vr": "OB", "BinaryLength": 183288},
        "1562": {"vr": "OB", "BinaryLength": 183288},
        "1563": {"vr": "OB", "BinaryLength": 183288},
        "1564": {"vr": "OB", "BinaryLength": 183288},
        "1565": {"vr": "OB", "BinaryLength": 183288},
        "1566": {"vr": "OB", "BinaryLength": 183288},
        "1567": {"vr": "OB", "BinaryLength": 183288},
        "1568": {"vr": "OB", "BinaryLength": 183288},
        "1569": {"vr": "OB", "BinaryLength": 183288},
        "1570": {"vr": "OB", "BinaryLength": 183288},
        "1571": {"vr": "OB", "BinaryLength": 183288},
        "1572": {"vr": "OB", "BinaryLength": 183288},
        "1573": {"vr": "OB", "BinaryLength": 183288},
        "1574": {"vr": "OB", "BinaryLength": 183288},
        "1575": {"vr": "OB", "BinaryLength": 183288},
        "1576": {"vr": "OB", "BinaryLength": 183288},
        "1577": {"vr": "OB", "BinaryLength": 183288},
        "1578": {"vr": "OB", "BinaryLength": 183288},
        "1579": {"vr": "OB", "BinaryLength": 183288},
        "1580": {"vr": "OB", "BinaryLength": 183288},
        "1581": {"vr": "OB", "BinaryLength": 183288},
        "1582": {"vr": "OB", "BinaryLength": 183288},
        "1583": {"vr": "OB", "BinaryLength": 183288},
        "1584": {"vr": "OB", "BinaryLength": 183288},
        "1585": {"vr": "OB", "BinaryLength": 183288},
        "1586": {"vr": "OB", "BinaryLength": 183288},
        "1587": {"vr": "OB", "BinaryLength": 183288},
        "1588": {"vr": "OB", "BinaryLength": 183288},
        "1589": {"vr": "OB", "BinaryLength": 183288},
        "1590": {"vr": "OB", "BinaryLength": 183288},
        "1591": {"vr": "OB", "BinaryLength": 183288},
        "1592": {"vr": "OB", "BinaryLength": 183288},
        "1593": {"vr": "OB", "BinaryLength": 183288},
        "1594": {"vr": "OB", "BinaryLength": 183288},
        "1595": {"vr": "OB", "BinaryLength": 183288},
        "1596": {"vr": "OB", "BinaryLength": 183288},
        "1597": {"vr": "OB", "BinaryLength": 183288},
        "1598": {"vr": "OB", "BinaryLength": 183288},
        "1599": {"vr": "OB", "BinaryLength": 183288},
        "1600": {"vr": "OB", "BinaryLength": 183288},
        "1601": {"vr": "OB", "BinaryLength": 183288},
        "1602": {"vr": "OB", "BinaryLength": 183288},
        "1603": {"vr": "OB", "BinaryLength": 183288},
        "1604": {"vr": "OB", "BinaryLength": 183288},
        "1605": {"vr": "OB", "BinaryLength": 183288},
        "1606": {"vr": "OB", "BinaryLength": 183288},
        "1607": {"vr": "OB", "BinaryLength": 183288},
        "1608": {"vr": "OB", "BinaryLength": 183288},
        "1609": {"vr": "OB", "BinaryLength": 183288},
        "1610": {"vr": "OB", "BinaryLength": 183288},
        "1611": {"vr": "OB", "BinaryLength": 183288},
        "1612": {"vr": "OB", "BinaryLength": 183288},
        "1613": {"vr": "OB", "BinaryLength": 183288},
        "1614": {"vr": "OB", "BinaryLength": 183288},
        "1615": {"vr": "OB", "BinaryLength": 183288},
        "1616": {"vr": "OB", "BinaryLength": 183288},
        "1617": {"vr": "OB", "BinaryLength": 183288},
        "1618": {"vr": "OB", "BinaryLength": 183288},
        "1619": {"vr": "OB", "BinaryLength": 183288},
        "1620": {"vr": "OB", "BinaryLength": 183288},
        "1621": {"vr": "OB", "BinaryLength": 183288},
        "1622": {"vr": "OB", "BinaryLength": 183288},
        "1623": {"vr": "OB", "BinaryLength": 183288},
        "1624": {"vr": "OB", "BinaryLength": 183288},
        "1625": {"vr": "OB", "BinaryLength": 183288},
        "1626": {"vr": "OB", "BinaryLength": 183288},
        "1627": {"vr": "OB", "BinaryLength": 183288},
        "1628": {"vr": "OB", "BinaryLength": 183288},
        "1629": {"vr": "OB", "BinaryLength": 183288},
        "1630": {"vr": "OB", "BinaryLength": 183288},
        "1631": {"vr": "OB", "BinaryLength": 183288},
        "1632": {"vr": "OB", "BinaryLength": 183288},
        "1633": {"vr": "OB", "BinaryLength": 183288},
        "1634": {"vr": "OB", "BinaryLength": 183288},
        "1635": {"vr": "OB", "BinaryLength": 183288},
        "1636": {"vr": "OB", "BinaryLength": 183288},
        "1637": {"vr": "OB", "BinaryLength": 183288},
        "1638": {"vr": "OB", "BinaryLength": 183288},
        "1639": {"vr": "OB", "BinaryLength": 183288},
        "1640": {"vr": "OB", "BinaryLength": 183288},
        "1641": {"vr": "OB", "BinaryLength": 183288},
        "1642": {"vr": "OB", "BinaryLength": 183288},
        "1643": {"vr": "OB", "BinaryLength": 183288},
        "1644": {"vr": "OB", "BinaryLength": 183288},
        "1645": {"vr": "OB", "BinaryLength": 183288},
        "1646": {"vr": "OB", "BinaryLength": 183288},
        "1647": {"vr": "OB", "BinaryLength": 183288},
        "1648": {"vr": "OB", "BinaryLength": 183288},
        "1649": {"vr": "OB", "BinaryLength": 183288},
        "1650": {"vr": "OB", "BinaryLength": 183288},
        "1651": {"vr": "OB", "BinaryLength": 183288},
        "1652": {"vr": "OB", "BinaryLength": 183288},
        "1653": {"vr": "OB", "BinaryLength": 183288},
        "1654": {"vr": "OB", "BinaryLength": 183288},
        "1655": {"vr": "OB", "BinaryLength": 183288},
        "1656": {"vr": "OB", "BinaryLength": 183288},
        "1657": {"vr": "OB", "BinaryLength": 183288},
        "1658": {"vr": "OB", "BinaryLength": 183288},
        "1659": {"vr": "OB", "BinaryLength": 183288},
        "1660": {"vr": "OB", "BinaryLength": 183288},
        "1661": {"vr": "OB", "BinaryLength": 183288},
        "1662": {"vr": "OB", "BinaryLength": 183288},
        "1663": {"vr": "OB", "BinaryLength": 183288},
        "1664": {"vr": "OB", "BinaryLength": 183288},
        "1665": {"vr": "OB", "BinaryLength": 183288},
        "1666": {"vr": "OB", "BinaryLength": 183288},
        "1667": {"vr": "OB", "BinaryLength": 183288},
        "1668": {"vr": "OB", "BinaryLength": 183288},
        "1669": {"vr": "OB", "BinaryLength": 183288},
        "1670": {"vr": "OB", "BinaryLength": 183288},
        "1671": {"vr": "OB", "BinaryLength": 183288},
        "1672": {"vr": "OB", "BinaryLength": 183288},
        "1673": {"vr": "OB", "BinaryLength": 183288},
        "1674": {"vr": "OB", "BinaryLength": 183288},
        "1675": {"vr": "OB", "BinaryLength": 183288},
        "1676": {"vr": "OB", "BinaryLength": 183288},
        "1677": {"vr": "OB", "BinaryLength": 183288},
        "1678": {"vr": "OB", "BinaryLength": 183288},
        "1679": {"vr": "OB", "BinaryLength": 183288},
        "1680": {"vr": "OB", "BinaryLength": 183288},
        "1681": {"vr": "OB", "BinaryLength": 183288},
        "1682": {"vr": "OB", "BinaryLength": 183288},
        "1683": {"vr": "OB", "BinaryLength": 183288},
        "1684": {"vr": "OB", "BinaryLength": 183288},
        "1685": {"vr": "OB", "BinaryLength": 183288},
        "1686": {"vr": "OB", "BinaryLength": 183288},
        "1687": {"vr": "OB", "BinaryLength": 183288},
        "1688": {"vr": "OB", "BinaryLength": 183288},
        "1689": {"vr": "OB", "BinaryLength": 183288},
        "1690": {"vr": "OB", "BinaryLength": 183288},
        "1691": {"vr": "OB", "BinaryLength": 183288},
        "1692": {"vr": "OB", "BinaryLength": 183288},
        "1693": {"vr": "OB", "BinaryLength": 183288},
        "1694": {"vr": "OB", "BinaryLength": 183288},
        "1695": {"vr": "OB", "BinaryLength": 183288},
        "1696": {"vr": "OB", "BinaryLength": 183288},
        "1697": {"vr": "OB", "BinaryLength": 183288},
        "1698": {"vr": "OB", "BinaryLength": 183288},
        "1699": {"vr": "OB", "BinaryLength": 183288},
        "1700": {"vr": "OB", "BinaryLength": 183288},
        "1701": {"vr": "OB", "BinaryLength": 183288},
        "1702": {"vr": "OB", "BinaryLength": 183288},
        "1703": {"vr": "OB", "BinaryLength": 183288},
        "1704": {"vr": "OB", "BinaryLength": 183288},
        "1705": {"vr": "OB", "BinaryLength": 183288},
        "1706": {"vr": "OB", "BinaryLength": 183288},
        "1707": {"vr": "OB", "BinaryLength": 183288},
        "1708": {"vr": "OB", "BinaryLength": 183288},
        "1709": {"vr": "OB", "BinaryLength": 183288},
        "1710": {"vr": "OB", "BinaryLength": 183288},
        "1711": {"vr": "OB", "BinaryLength": 183288},
        "1712": {"vr": "OB", "BinaryLength": 183288},
        "1713": {"vr": "OB", "BinaryLength": 183288},
        "1714": {"vr": "OB", "BinaryLength": 183288},
        "1715": {"vr": "OB", "BinaryLength": 183288},
        "1716": {"vr": "OB", "BinaryLength": 183288},
        "1717": {"vr": "OB", "BinaryLength": 183288},
        "1718": {"vr": "OB", "BinaryLength": 183288},
        "1719": {"vr": "OB", "BinaryLength": 183288},
        "1720": {"vr": "OB", "BinaryLength": 183288},
        "1721": {"vr": "OB", "BinaryLength": 183288},
        "1722": {"vr": "OB", "BinaryLength": 183288},
        "1723": {"vr": "OB", "BinaryLength": 183288},
        "1724": {"vr": "OB", "BinaryLength": 183288},
        "1725": {"vr": "OB", "BinaryLength": 183288},
        "1726": {"vr": "OB", "BinaryLength": 183288},
        "1727": {"vr": "OB", "BinaryLength": 183288},
        "1728": {"vr": "OB", "BinaryLength": 183288},
        "1729": {"vr": "OB", "BinaryLength": 183288},
        "1730": {"vr": "OB", "BinaryLength": 183288},
        "1731": {"vr": "OB", "BinaryLength": 183288},
        "1732": {"vr": "OB", "BinaryLength": 183288},
        "1733": {"vr": "OB", "BinaryLength": 183288},
        "1734": {"vr": "OB", "BinaryLength": 183288},
        "1735": {"vr": "OB", "BinaryLength": 183288},
        "1736": {"vr": "OB", "BinaryLength": 183288},
        "1737": {"vr": "OB", "BinaryLength": 183288},
        "1738": {"vr": "OB", "BinaryLength": 183288},
        "1739": {"vr": "OB", "BinaryLength": 183288},
        "1740": {"vr": "OB", "BinaryLength": 183288},
        "1741": {"vr": "OB", "BinaryLength": 183288},
        "1742": {"vr": "OB", "BinaryLength": 183288},
        "1743": {"vr": "OB", "BinaryLength": 183288},
        "1744": {"vr": "OB", "BinaryLength": 183288},
        "1745": {"vr": "OB", "BinaryLength": 183288},
        "1746": {"vr": "OB", "BinaryLength": 183288},
        "1747": {"vr": "OB", "BinaryLength": 183288},
        "1748": {"vr": "OB", "BinaryLength": 183288},
        "1749": {"vr": "OB", "BinaryLength": 183288},
        "1750": {"vr": "OB", "BinaryLength": 183288},
        "1751": {"vr": "OB", "BinaryLength": 183288},
        "1752": {"vr": "OB", "BinaryLength": 183288},
        "1753": {"vr": "OB", "BinaryLength": 183288},
        "1754": {"vr": "OB", "BinaryLength": 183288},
        "1755": {"vr": "OB", "BinaryLength": 183288},
        "1756": {"vr": "OB", "BinaryLength": 183288},
        "1757": {"vr": "OB", "BinaryLength": 183288},
        "1758": {"vr": "OB", "BinaryLength": 183288},
        "1759": {"vr": "OB", "BinaryLength": 183288},
        "1760": {"vr": "OB", "BinaryLength": 183288},
        "1761": {"vr": "OB", "BinaryLength": 183288},
        "1762": {"vr": "OB", "BinaryLength": 183288},
        "1763": {"vr": "OB", "BinaryLength": 183288},
        "1764": {"vr": "OB", "BinaryLength": 183288},
        "1765": {"vr": "OB", "BinaryLength": 183288},
        "1766": {"vr": "OB", "BinaryLength": 183288},
        "1767": {"vr": "OB", "BinaryLength": 183288},
        "1768": {"vr": "OB", "BinaryLength": 183288},
        "1769": {"vr": "OB", "BinaryLength": 183288},
        "1770": {"vr": "OB", "BinaryLength": 183288},
        "1771": {"vr": "OB", "BinaryLength": 183288},
        "1772": {"vr": "OB", "BinaryLength": 183288},
        "1773": {"vr": "OB", "BinaryLength": 183288},
        "1774": {"vr": "OB", "BinaryLength": 183288},
        "1775": {"vr": "OB", "BinaryLength": 183288},
        "1776": {"vr": "OB", "BinaryLength": 183288},
        "1777": {"vr": "OB", "BinaryLength": 183288},
        "1778": {"vr": "OB", "BinaryLength": 183288},
        "1779": {"vr": "OB", "BinaryLength": 183288},
        "1780": {"vr": "OB", "BinaryLength": 183288},
        "1781": {"vr": "OB", "BinaryLength": 183288},
        "1782": {"vr": "OB", "BinaryLength": 183288},
        "1783": {"vr": "OB", "BinaryLength": 183288},
        "1784": {"vr": "OB", "BinaryLength": 183288},
        "1785": {"vr": "OB", "BinaryLength": 183288},
        "1786": {"vr": "OB", "BinaryLength": 183288},
        "1787": {"vr": "OB", "BinaryLength": 183288},
        "1788": {"vr": "OB", "BinaryLength": 183288},
        "1789": {"vr": "OB", "BinaryLength": 183288},
        "1790": {"vr": "OB", "BinaryLength": 183288},
        "1791": {"vr": "OB", "BinaryLength": 183288},
        "1792": {"vr": "OB", "BinaryLength": 183288},
        "1793": {"vr": "OB", "BinaryLength": 183288},
        "1794": {"vr": "OB", "BinaryLength": 183288},
        "1795": {"vr": "OB", "BinaryLength": 183288},
        "1796": {"vr": "OB", "BinaryLength": 183288},
        "1797": {"vr": "OB", "BinaryLength": 183288},
        "1798": {"vr": "OB", "BinaryLength": 183288},
        "1799": {"vr": "OB", "BinaryLength": 183288},
        "1800": {"vr": "OB", "BinaryLength": 183288},
        "1801": {"vr": "OB", "BinaryLength": 183288},
        "1802": {"vr": "OB", "BinaryLength": 183288},
        "1803": {"vr": "OB", "BinaryLength": 183288},
        "1804": {"vr": "OB", "BinaryLength": 183288},
        "1805": {"vr": "OB", "BinaryLength": 183288},
        "1806": {"vr": "OB", "BinaryLength": 183288},
        "1807": {"vr": "OB", "BinaryLength": 183288},
        "1808": {"vr": "OB", "BinaryLength": 183288},
        "1809": {"vr": "OB", "BinaryLength": 183288},
        "1810": {"vr": "OB", "BinaryLength": 183288},
        "1811": {"vr": "OB", "BinaryLength": 183288},
        "1812": {"vr": "OB", "BinaryLength": 183288},
        "1813": {"vr": "OB", "BinaryLength": 183288},
        "1814": {"vr": "OB", "BinaryLength": 183288},
        "1815": {"vr": "OB", "BinaryLength": 183288},
        "1816": {"vr": "OB", "BinaryLength": 183288},
        "1817": {"vr": "OB", "BinaryLength": 183288},
        "1818": {"vr": "OB", "BinaryLength": 183288},
        "1819": {"vr": "OB", "BinaryLength": 183288},
        "1820": {"vr": "OB", "BinaryLength": 183288},
        "1821": {"vr": "OB", "BinaryLength": 183288},
        "1822": {"vr": "OB", "BinaryLength": 183288},
        "1823": {"vr": "OB", "BinaryLength": 183288},
        "1824": {"vr": "OB", "BinaryLength": 183288},
        "1825": {"vr": "OB", "BinaryLength": 183288},
        "1826": {"vr": "OB", "BinaryLength": 183288},
        "1827": {"vr": "OB", "BinaryLength": 183288},
        "1828": {"vr": "OB", "BinaryLength": 183288},
        "1829": {"vr": "OB", "BinaryLength": 183288},
        "1830": {"vr": "OB", "BinaryLength": 183288},
        "1831": {"vr": "OB", "BinaryLength": 183288},
        "1832": {"vr": "OB", "BinaryLength": 183288},
        "1833": {"vr": "OB", "BinaryLength": 183288},
        "1834": {"vr": "OB", "BinaryLength": 183288},
        "1835": {"vr": "OB", "BinaryLength": 183288},
        "1836": {"vr": "OB", "BinaryLength": 183288},
        "1837": {"vr": "OB", "BinaryLength": 183288},
        "1838": {"vr": "OB", "BinaryLength": 183288},
        "1839": {"vr": "OB", "BinaryLength": 183288},
        "1840": {"vr": "OB", "BinaryLength": 183288},
        "1841": {"vr": "OB", "BinaryLength": 183288},
        "1842": {"vr": "OB", "BinaryLength": 183288},
        "1843": {"vr": "OB", "BinaryLength": 183288},
        "1844": {"vr": "OB", "BinaryLength": 183288},
        "1845": {"vr": "OB", "BinaryLength": 183288},
        "1846": {"vr": "OB", "BinaryLength": 183288},
        "1847": {"vr": "OB", "BinaryLength": 183288},
        "1848": {"vr": "OB", "BinaryLength": 183288},
        "1849": {"vr": "OB", "BinaryLength": 183288},
        "1850": {"vr": "OB", "BinaryLength": 183288},
        "1851": {"vr": "OB", "BinaryLength": 183288},
        "1852": {"vr": "OB", "BinaryLength": 183288},
        "1853": {"vr": "OB", "BinaryLength": 183288},
        "1854": {"vr": "OB", "BinaryLength": 183288},
        "1855": {"vr": "OB", "BinaryLength": 183288},
        "1856": {"vr": "OB", "BinaryLength": 183288},
        "1857": {"vr": "OB", "BinaryLength": 183288},
        "1858": {"vr": "OB", "BinaryLength": 183288},
        "1859": {"vr": "OB", "BinaryLength": 183288},
        "1860": {"vr": "OB", "BinaryLength": 183288},
        "1861": {"vr": "OB", "BinaryLength": 183288},
        "1862": {"vr": "OB", "BinaryLength": 183288},
        "1863": {"vr": "OB", "BinaryLength": 183288},
        "1864": {"vr": "OB", "BinaryLength": 183288},
        "1865": {"vr": "OB", "BinaryLength": 183288},
        "1866": {"vr": "OB", "BinaryLength": 183288},
        "1867": {"vr": "OB", "BinaryLength": 183288},
        "1868": {"vr": "OB", "BinaryLength": 183288},
        "1869": {"vr": "OB", "BinaryLength": 183288},
        "1870": {"vr": "OB", "BinaryLength": 183288},
        "1871": {"vr": "OB", "BinaryLength": 183288},
        "1872": {"vr": "OB", "BinaryLength": 183288},
        "1873": {"vr": "OB", "BinaryLength": 183288},
        "1874": {"vr": "OB", "BinaryLength": 183288},
        "1875": {"vr": "OB", "BinaryLength": 183288},
        "1876": {"vr": "OB", "BinaryLength": 183288},
        "1877": {"vr": "OB", "BinaryLength": 183288},
        "1878": {"vr": "OB", "BinaryLength": 183288},
        "1879": {"vr": "OB", "BinaryLength": 183288},
        "1880": {"vr": "OB", "BinaryLength": 183288},
        "1881": {"vr": "OB", "BinaryLength": 183288},
        "1882": {"vr": "OB", "BinaryLength": 183288},
        "1883": {"vr": "OB", "BinaryLength": 183288},
        "1884": {"vr": "OB", "BinaryLength": 183288},
        "1885": {"vr": "OB", "BinaryLength": 183288},
        "1886": {"vr": "OB", "BinaryLength": 183288},
        "1887": {"vr": "OB", "BinaryLength": 183288},
        "1888": {"vr": "OB", "BinaryLength": 183288},
        "1889": {"vr": "OB", "BinaryLength": 183288},
        "1890": {"vr": "OB", "BinaryLength": 183288},
        "1891": {"vr": "OB", "BinaryLength": 183288},
        "1892": {"vr": "OB", "BinaryLength": 183288},
        "1893": {"vr": "OB", "BinaryLength": 183288},
        "1894": {"vr": "OB", "BinaryLength": 183288},
        "1895": {"vr": "OB", "BinaryLength": 183288},
        "1896": {"vr": "OB", "BinaryLength": 183288},
        "1897": {"vr": "OB", "BinaryLength": 183288},
        "1898": {"vr": "OB", "BinaryLength": 183288},
        "1899": {"vr": "OB", "BinaryLength": 183288},
        "1900": {"vr": "OB", "BinaryLength": 183288},
        "1901": {"vr": "OB", "BinaryLength": 183288},
        "1902": {"vr": "OB", "BinaryLength": 183288},
        "1903": {"vr": "OB", "BinaryLength": 183288},
        "1904": {"vr": "OB", "BinaryLength": 183288},
        "1905": {"vr": "OB", "BinaryLength": 183288},
        "1906": {"vr": "OB", "BinaryLength": 183288},
        "1907": {"vr": "OB", "BinaryLength": 183288},
        "1908": {"vr": "OB", "BinaryLength": 183288},
        "1909": {"vr": "OB", "BinaryLength": 183288},
        "1910": {"vr": "OB", "BinaryLength": 183288},
        "1911": {"vr": "OB", "BinaryLength": 183288},
        "1912": {"vr": "OB", "BinaryLength": 183288},
        "1913": {"vr": "OB", "BinaryLength": 183288},
        "1914": {"vr": "OB", "BinaryLength": 183288},
        "1915": {"vr": "OB", "BinaryLength": 183288},
        "1916": {"vr": "OB", "BinaryLength": 183288},
        "1917": {"vr": "OB", "BinaryLength": 183288},
        "1918": {"vr": "OB", "BinaryLength": 183288},
        "1919": {"vr": "OB", "BinaryLength": 183288},
        "1920": {"vr": "OB", "BinaryLength": 183288},
        "1921": {"vr": "OB", "BinaryLength": 183288},
        "1922": {"vr": "OB", "BinaryLength": 183288},
        "1923": {"vr": "OB", "BinaryLength": 183288},
        "1924": {"vr": "OB", "BinaryLength": 183288},
        "1925": {"vr": "OB", "BinaryLength": 183288},
        "1926": {"vr": "OB", "BinaryLength": 183288},
        "1927": {"vr": "OB", "BinaryLength": 183288},
        "1928": {"vr": "OB", "BinaryLength": 183288},
        "1929": {"vr": "OB", "BinaryLength": 183288},
        "1930": {"vr": "OB", "BinaryLength": 183288},
        "1931": {"vr": "OB", "BinaryLength": 183288},
        "1932": {"vr": "OB", "BinaryLength": 183288},
        "1933": {"vr": "OB", "BinaryLength": 183288},
        "1934": {"vr": "OB", "BinaryLength": 183288},
        "1935": {"vr": "OB", "BinaryLength": 183288},
        "1936": {"vr": "OB", "BinaryLength": 183288},
        "1937": {"vr": "OB", "BinaryLength": 183288},
        "1938": {"vr": "OB", "BinaryLength": 183288},
        "1939": {"vr": "OB", "BinaryLength": 183288},
        "1940": {"vr": "OB", "BinaryLength": 183288},
        "1941": {"vr": "OB", "BinaryLength": 183288},
        "1942": {"vr": "OB", "BinaryLength": 183288},
        "1943": {"vr": "OB", "BinaryLength": 183288},
        "1944": {"vr": "OB", "BinaryLength": 183288},
        "1945": {"vr": "OB", "BinaryLength": 183288},
        "1946": {"vr": "OB", "BinaryLength": 183288},
        "1947": {"vr": "OB", "BinaryLength": 183288},
        "1948": {"vr": "OB", "BinaryLength": 183288},
        "1949": {"vr": "OB", "BinaryLength": 183288},
        "1950": {"vr": "OB", "BinaryLength": 183288},
        "1951": {"vr": "OB", "BinaryLength": 183288},
        "1952": {"vr": "OB", "BinaryLength": 183288},
        "1953": {"vr": "OB", "BinaryLength": 183288},
        "1954": {"vr": "OB", "BinaryLength": 183288},
        "1955": {"vr": "OB", "BinaryLength": 183288},
        "1956": {"vr": "OB", "BinaryLength": 183288},
        "1957": {"vr": "OB", "BinaryLength": 183288},
        "1958": {"vr": "OB", "BinaryLength": 183288},
        "1959": {"vr": "OB", "BinaryLength": 183288},
        "1960": {"vr": "OB", "BinaryLength": 183288},
        "1961": {"vr": "OB", "BinaryLength": 183288},
        "1962": {"vr": "OB", "BinaryLength": 183288},
        "1963": {"vr": "OB", "BinaryLength": 183288},
        "1964": {"vr": "OB", "BinaryLength": 183288},
        "1965": {"vr": "OB", "BinaryLength": 183288},
        "1966": {"vr": "OB", "BinaryLength": 183288},
        "1967": {"vr": "OB", "BinaryLength": 183288},
        "1968": {"vr": "OB", "BinaryLength": 183288},
        "1969": {"vr": "OB", "BinaryLength": 183288},
        "1970": {"vr": "OB", "BinaryLength": 183288},
        "1971": {"vr": "OB", "BinaryLength": 183288},
        "1972": {"vr": "OB", "BinaryLength": 183288},
        "1973": {"vr": "OB", "BinaryLength": 183288},
        "1974": {"vr": "OB", "BinaryLength": 183288},
        "1975": {"vr": "OB", "BinaryLength": 183288},
        "1976": {"vr": "OB", "BinaryLength": 183288},
        "1977": {"vr": "OB", "BinaryLength": 183288},
        "1978": {"vr": "OB", "BinaryLength": 183288},
        "1979": {"vr": "OB", "BinaryLength": 183288},
        "1980": {"vr": "OB", "BinaryLength": 183288},
        "1981": {"vr": "OB", "BinaryLength": 183288},
        "1982": {"vr": "OB", "BinaryLength": 183288},
        "1983": {"vr": "OB", "BinaryLength": 183288},
        "1984": {"vr": "OB", "BinaryLength": 183288},
        "1985": {"vr": "OB", "BinaryLength": 183288},
        "1986": {"vr": "OB", "BinaryLength": 183288},
        "1987": {"vr": "OB", "BinaryLength": 183288},
        "1988": {"vr": "OB", "BinaryLength": 183288},
        "1989": {"vr": "OB", "BinaryLength": 183288},
        "1990": {"vr": "OB", "BinaryLength": 183288},
        "1991": {"vr": "OB", "BinaryLength": 183288},
        "1992": {"vr": "OB", "BinaryLength": 183288},
        "1993": {"vr": "OB", "BinaryLength": 183288},
        "1994": {"vr": "OB", "BinaryLength": 183288},
        "1995": {"vr": "OB", "BinaryLength": 183288},
        "1996": {"vr": "OB", "BinaryLength": 183288},
        "1997": {"vr": "OB", "BinaryLength": 183288},
        "1998": {"vr": "OB", "BinaryLength": 183288},
        "1999": {"vr": "OB", "BinaryLength": 183288},
        "2000": {"vr": "OB", "BinaryLength": 183288},
        "2001": {"vr": "OB", "BinaryLength": 183288},
        "2002": {"vr": "OB", "BinaryLength": 183288},
        "2003": {"vr": "OB", "BinaryLength": 183288},
        "2004": {"vr": "OB", "BinaryLength": 183288},
        "2005": {"vr": "OB", "BinaryLength": 183288},
        "2006": {"vr": "OB", "BinaryLength": 183288},
        "2007": {"vr": "OB", "BinaryLength": 183288},
        "2008": {"vr": "OB", "BinaryLength": 183288},
        "2009": {"vr": "OB", "BinaryLength": 183288},
        "2010": {"vr": "OB", "BinaryLength": 183288},
        "2011": {"vr": "OB", "BinaryLength": 183288},
        "2012": {"vr": "OB", "BinaryLength": 183288},
        "2013": {"vr": "OB", "BinaryLength": 183288},
        "2014": {"vr": "OB", "BinaryLength": 183288},
        "2015": {"vr": "OB", "BinaryLength": 183288},
        "2016": {"vr": "OB", "BinaryLength": 183288},
        "2017": {"vr": "OB", "BinaryLength": 183288},
        "2018": {"vr": "OB", "BinaryLength": 183288},
        "2019": {"vr": "OB", "BinaryLength": 183288},
        "2020": {"vr": "OB", "BinaryLength": 183288},
        "2021": {"vr": "OB", "BinaryLength": 183288},
        "2022": {"vr": "OB", "BinaryLength": 183288},
        "2023": {"vr": "OB", "BinaryLength": 183288},
        "2024": {"vr": "OB", "BinaryLength": 183288},
        "2025": {"vr": "OB", "BinaryLength": 183288},
        "2026": {"vr": "OB", "BinaryLength": 183288},
        "2027": {"vr": "OB", "BinaryLength": 183288},
        "2028": {"vr": "OB", "BinaryLength": 183288},
        "2029": {"vr": "OB", "BinaryLength": 183288},
        "2030": {"vr": "OB", "BinaryLength": 183288},
        "2031": {"vr": "OB", "BinaryLength": 183288},
        "2032": {"vr": "OB", "BinaryLength": 183288},
        "2033": {"vr": "OB", "BinaryLength": 183288},
        "2034": {"vr": "OB", "BinaryLength": 183288},
        "2035": {"vr": "OB", "BinaryLength": 183288},
        "2036": {"vr": "OB", "BinaryLength": 183288},
        "2037": {"vr": "OB", "BinaryLength": 183288},
        "2038": {"vr": "OB", "BinaryLength": 183288},
        "2039": {"vr": "OB", "BinaryLength": 183288},
        "2040": {"vr": "OB", "BinaryLength": 183288},
        "2041": {"vr": "OB", "BinaryLength": 183288},
        "2042": {"vr": "OB", "BinaryLength": 183288},
        "2043": {"vr": "OB", "BinaryLength": 183288},
        "2044": {"vr": "OB", "BinaryLength": 183288},
        "2045": {"vr": "OB", "BinaryLength": 183288},
        "2046": {"vr": "OB", "BinaryLength": 183288},
        "2047": {"vr": "OB", "BinaryLength": 183288},
        "2048": {"vr": "OB", "BinaryLength": 183288},
        "2049": {"vr": "OB", "BinaryLength": 183288},
        "2050": {"vr": "OB", "BinaryLength": 183288},
        "2051": {"vr": "OB", "BinaryLength": 183288},
        "2052": {"vr": "OB", "BinaryLength": 183288},
        "2053": {"vr": "OB", "BinaryLength": 183288},
        "2054": {"vr": "OB", "BinaryLength": 183288},
        "2055": {"vr": "OB", "BinaryLength": 183288},
        "2056": {"vr": "OB", "BinaryLength": 183288},
        "2057": {"vr": "OB", "BinaryLength": 183288},
        "2058": {"vr": "OB", "BinaryLength": 183288},
        "2059": {"vr": "OB", "BinaryLength": 183288},
        "2060": {"vr": "OB", "BinaryLength": 183288},
        "2061": {"vr": "OB", "BinaryLength": 183288},
        "2062": {"vr": "OB", "BinaryLength": 183288},
        "2063": {"vr": "OB", "BinaryLength": 183288},
        "2064": {"vr": "OB", "BinaryLength": 183288},
        "2065": {"vr": "OB", "BinaryLength": 183288},
        "2066": {"vr": "OB", "BinaryLength": 183288},
        "2067": {"vr": "OB", "BinaryLength": 183288},
        "2068": {"vr": "OB", "BinaryLength": 183288},
        "2069": {"vr": "OB", "BinaryLength": 183288},
        "2070": {"vr": "OB", "BinaryLength": 183288},
        "2071": {"vr": "OB", "BinaryLength": 183288},
        "2072": {"vr": "OB", "BinaryLength": 183288},
        "2073": {"vr": "OB", "BinaryLength": 183288},
        "2074": {"vr": "OB", "BinaryLength": 183288},
        "2075": {"vr": "OB", "BinaryLength": 183288},
        "2076": {"vr": "OB", "BinaryLength": 183288},
        "2077": {"vr": "OB", "BinaryLength": 183288},
        "2078": {"vr": "OB", "BinaryLength": 183288},
        "2079": {"vr": "OB", "BinaryLength": 183288},
        "2080": {"vr": "OB", "BinaryLength": 183288},
        "2081": {"vr": "OB", "BinaryLength": 183288},
        "2082": {"vr": "OB", "BinaryLength": 183288},
        "2083": {"vr": "OB", "BinaryLength": 183288},
        "2084": {"vr": "OB", "BinaryLength": 183288},
        "2085": {"vr": "OB", "BinaryLength": 183288},
        "2086": {"vr": "OB", "BinaryLength": 183288},
        "2087": {"vr": "OB", "BinaryLength": 183288},
        "2088": {"vr": "OB", "BinaryLength": 183288},
        "2089": {"vr": "OB", "BinaryLength": 183288},
        "2090": {"vr": "OB", "BinaryLength": 183288},
        "2091": {"vr": "OB", "BinaryLength": 183288},
        "2092": {"vr": "OB", "BinaryLength": 183288},
        "2093": {"vr": "OB", "BinaryLength": 183288},
        "2094": {"vr": "OB", "BinaryLength": 183288},
        "2095": {"vr": "OB", "BinaryLength": 183288},
        "2096": {"vr": "OB", "BinaryLength": 183288},
        "2097": {"vr": "OB", "BinaryLength": 183288},
        "2098": {"vr": "OB", "BinaryLength": 183288},
        "2099": {"vr": "OB", "BinaryLength": 183288},
        "2100": {"vr": "OB", "BinaryLength": 183288},
        "2101": {"vr": "OB", "BinaryLength": 183288},
        "2102": {"vr": "OB", "BinaryLength": 183288},
        "2103": {"vr": "OB", "BinaryLength": 183288},
        "2104": {"vr": "OB", "BinaryLength": 183288},
        "2105": {"vr": "OB", "BinaryLength": 183288},
        "2106": {"vr": "OB", "BinaryLength": 183288},
        "2107": {"vr": "OB", "BinaryLength": 183288},
        "2108": {"vr": "OB", "BinaryLength": 183288},
        "2109": {"vr": "OB", "BinaryLength": 183288},
        "2110": {"vr": "OB", "BinaryLength": 183288},
        "2111": {"vr": "OB", "BinaryLength": 183288},
        "2112": {"vr": "OB", "BinaryLength": 183288},
        "2113": {"vr": "OB", "BinaryLength": 183288},
        "2114": {"vr": "OB", "BinaryLength": 183288},
        "2115": {"vr": "OB", "BinaryLength": 183288},
        "2116": {"vr": "OB", "BinaryLength": 183288},
        "2117": {"vr": "OB", "BinaryLength": 183288},
        "2118": {"vr": "OB", "BinaryLength": 183288},
        "2119": {"vr": "OB", "BinaryLength": 183288},
        "2120": {"vr": "OB", "BinaryLength": 183288},
        "2121": {"vr": "OB", "BinaryLength": 183288},
        "2122": {"vr": "OB", "BinaryLength": 183288},
        "2123": {"vr": "OB", "BinaryLength": 183288},
        "2124": {"vr": "OB", "BinaryLength": 183288},
        "2125": {"vr": "OB", "BinaryLength": 183288},
        "2126": {"vr": "OB", "BinaryLength": 183288},
        "2127": {"vr": "OB", "BinaryLength": 183288},
        "2128": {"vr": "OB", "BinaryLength": 183288},
        "2129": {"vr": "OB", "BinaryLength": 183288},
        "2130": {"vr": "OB", "BinaryLength": 183288},
        "2131": {"vr": "OB", "BinaryLength": 183288},
        "2132": {"vr": "OB", "BinaryLength": 183288},
        "2133": {"vr": "OB", "BinaryLength": 183288},
        "2134": {"vr": "OB", "BinaryLength": 183288},
        "2135": {"vr": "OB", "BinaryLength": 183288},
        "2136": {"vr": "OB", "BinaryLength": 183288},
        "2137": {"vr": "OB", "BinaryLength": 183288},
        "2138": {"vr": "OB", "BinaryLength": 183288},
        "2139": {"vr": "OB", "BinaryLength": 183288},
        "2140": {"vr": "OB", "BinaryLength": 183288},
        "2141": {"vr": "OB", "BinaryLength": 183288},
        "2142": {"vr": "OB", "BinaryLength": 183288},
        "2143": {"vr": "OB", "BinaryLength": 183288},
        "2144": {"vr": "OB", "BinaryLength": 183288},
        "2145": {"vr": "OB", "BinaryLength": 183288},
        "2146": {"vr": "OB", "BinaryLength": 183288},
        "2147": {"vr": "OB", "BinaryLength": 183288},
        "2148": {"vr": "OB", "BinaryLength": 183288},
        "2149": {"vr": "OB", "BinaryLength": 183288},
        "2150": {"vr": "OB", "BinaryLength": 183288},
        "2151": {"vr": "OB", "BinaryLength": 183288},
        "2152": {"vr": "OB", "BinaryLength": 183288},
        "2153": {"vr": "OB", "BinaryLength": 183288},
        "2154": {"vr": "OB", "BinaryLength": 183288},
        "2155": {"vr": "OB", "BinaryLength": 183288},
        "2156": {"vr": "OB", "BinaryLength": 183288},
        "2157": {"vr": "OB", "BinaryLength": 183288},
        "2158": {"vr": "OB", "BinaryLength": 183288},
        "2159": {"vr": "OB", "BinaryLength": 183288},
        "2160": {"vr": "OB", "BinaryLength": 183288},
        "2161": {"vr": "OB", "BinaryLength": 183288},
        "2162": {"vr": "OB", "BinaryLength": 183288},
        "2163": {"vr": "OB", "BinaryLength": 183288},
        "2164": {"vr": "OB", "BinaryLength": 183288},
        "2165": {"vr": "OB", "BinaryLength": 183288},
        "2166": {"vr": "OB", "BinaryLength": 183288},
        "2167": {"vr": "OB", "BinaryLength": 183288},
        "2168": {"vr": "OB", "BinaryLength": 183288},
        "2169": {"vr": "OB", "BinaryLength": 183288},
        "2170": {"vr": "OB", "BinaryLength": 183288},
        "2171": {"vr": "OB", "BinaryLength": 183288},
        "2172": {"vr": "OB", "BinaryLength": 183288},
        "2173": {"vr": "OB", "BinaryLength": 183288},
        "2174": {"vr": "OB", "BinaryLength": 183288},
        "2175": {"vr": "OB", "BinaryLength": 183288},
        "2176": {"vr": "OB", "BinaryLength": 183288},
        "2177": {"vr": "OB", "BinaryLength": 183288},
        "2178": {"vr": "OB", "BinaryLength": 183288},
        "2179": {"vr": "OB", "BinaryLength": 183288},
        "2180": {"vr": "OB", "BinaryLength": 183288},
        "2181": {"vr": "OB", "BinaryLength": 183288},
        "2182": {"vr": "OB", "BinaryLength": 183288},
        "2183": {"vr": "OB", "BinaryLength": 183288},
        "2184": {"vr": "OB", "BinaryLength": 183288},
        "2185": {"vr": "OB", "BinaryLength": 183288},
        "2186": {"vr": "OB", "BinaryLength": 183288},
        "2187": {"vr": "OB", "BinaryLength": 183288},
        "2188": {"vr": "OB", "BinaryLength": 183288},
        "2189": {"vr": "OB", "BinaryLength": 183288},
        "2190": {"vr": "OB", "BinaryLength": 183288},
        "2191": {"vr": "OB", "BinaryLength": 183288},
        "2192": {"vr": "OB", "BinaryLength": 183288},
        "2193": {"vr": "OB", "BinaryLength": 183288},
        "2194": {"vr": "OB", "BinaryLength": 183288},
        "2195": {"vr": "OB", "BinaryLength": 183288},
        "2196": {"vr": "OB", "BinaryLength": 183288},
        "2197": {"vr": "OB", "BinaryLength": 183288},
        "2198": {"vr": "OB", "BinaryLength": 183288},
        "2199": {"vr": "OB", "BinaryLength": 183288},
        "2200": {"vr": "OB", "BinaryLength": 183288},
        "2201": {"vr": "OB", "BinaryLength": 183288},
        "2202": {"vr": "OB", "BinaryLength": 183288},
        "2203": {"vr": "OB", "BinaryLength": 183288},
        "2204": {"vr": "OB", "BinaryLength": 183288},
        "2205": {"vr": "OB", "BinaryLength": 183288},
        "2206": {"vr": "OB", "BinaryLength": 183288},
        "2207": {"vr": "OB", "BinaryLength": 183288},
        "2208": {"vr": "OB", "BinaryLength": 183288},
        "2209": {"vr": "OB", "BinaryLength": 183288},
        "2210": {"vr": "OB", "BinaryLength": 183288},
        "2211": {"vr": "OB", "BinaryLength": 183288},
        "2212": {"vr": "OB", "BinaryLength": 183288},
        "2213": {"vr": "OB", "BinaryLength": 183288},
        "2214": {"vr": "OB", "BinaryLength": 183288},
        "2215": {"vr": "OB", "BinaryLength": 183288},
        "2216": {"vr": "OB", "BinaryLength": 183288},
        "2217": {"vr": "OB", "BinaryLength": 183288},
        "2218": {"vr": "OB", "BinaryLength": 183288},
        "2219": {"vr": "OB", "BinaryLength": 183288},
        "2220": {"vr": "OB", "BinaryLength": 183288},
        "2221": {"vr": "OB", "BinaryLength": 183288},
        "2222": {"vr": "OB", "BinaryLength": 183288},
        "2223": {"vr": "OB", "BinaryLength": 183288},
        "2224": {"vr": "OB", "BinaryLength": 183288},
        "2225": {"vr": "OB", "BinaryLength": 183288},
        "2226": {"vr": "OB", "BinaryLength": 183288},
        "2227": {"vr": "OB", "BinaryLength": 183288},
        "2228": {"vr": "OB", "BinaryLength": 183288},
        "2229": {"vr": "OB", "BinaryLength": 183288},
        "2230": {"vr": "OB", "BinaryLength": 183288},
        "2231": {"vr": "OB", "BinaryLength": 183288},
        "2232": {"vr": "OB", "BinaryLength": 183288},
        "2233": {"vr": "OB", "BinaryLength": 183288},
        "2234": {"vr": "OB", "BinaryLength": 183288},
        "2235": {"vr": "OB", "BinaryLength": 183288},
        "2236": {"vr": "OB", "BinaryLength": 183288},
        "2237": {"vr": "OB", "BinaryLength": 183288},
        "2238": {"vr": "OB", "BinaryLength": 183288},
        "2239": {"vr": "OB", "BinaryLength": 183288},
        "2240": {"vr": "OB", "BinaryLength": 183288},
        "2241": {"vr": "OB", "BinaryLength": 183288},
        "2242": {"vr": "OB", "BinaryLength": 183288},
        "2243": {"vr": "OB", "BinaryLength": 183288},
        "2244": {"vr": "OB", "BinaryLength": 183288},
        "2245": {"vr": "OB", "BinaryLength": 183288},
        "2246": {"vr": "OB", "BinaryLength": 183288},
        "2247": {"vr": "OB", "BinaryLength": 183288},
        "2248": {"vr": "OB", "BinaryLength": 183288},
        "2249": {"vr": "OB", "BinaryLength": 183288},
        "2250": {"vr": "OB", "BinaryLength": 183288},
        "2251": {"vr": "OB", "BinaryLength": 183288},
        "2252": {"vr": "OB", "BinaryLength": 183288},
        "2253": {"vr": "OB", "BinaryLength": 183288},
        "2254": {"vr": "OB", "BinaryLength": 183288},
        "2255": {"vr": "OB", "BinaryLength": 183288},
        "2256": {"vr": "OB", "BinaryLength": 183288},
        "2257": {"vr": "OB", "BinaryLength": 183288},
        "2258": {"vr": "OB", "BinaryLength": 183288},
        "2259": {"vr": "OB", "BinaryLength": 183288},
        "2260": {"vr": "OB", "BinaryLength": 183288},
        "2261": {"vr": "OB", "BinaryLength": 183288},
        "2262": {"vr": "OB", "BinaryLength": 183288},
        "2263": {"vr": "OB", "BinaryLength": 183288},
        "2264": {"vr": "OB", "BinaryLength": 183288},
        "2265": {"vr": "OB", "BinaryLength": 183288},
        "2266": {"vr": "OB", "BinaryLength": 183288},
        "2267": {"vr": "OB", "BinaryLength": 183288},
        "2268": {"vr": "OB", "BinaryLength": 183288},
        "2269": {"vr": "OB", "BinaryLength": 183288},
        "2270": {"vr": "OB", "BinaryLength": 183288},
        "2271": {"vr": "OB", "BinaryLength": 183288},
        "2272": {"vr": "OB", "BinaryLength": 183288},
        "2273": {"vr": "OB", "BinaryLength": 183288},
        "2274": {"vr": "OB", "BinaryLength": 183288},
        "2275": {"vr": "OB", "BinaryLength": 183288},
        "2276": {"vr": "OB", "BinaryLength": 183288},
        "2277": {"vr": "OB", "BinaryLength": 183288},
        "2278": {"vr": "OB", "BinaryLength": 183288},
        "2279": {"vr": "OB", "BinaryLength": 183288},
        "2280": {"vr": "OB", "BinaryLength": 183288},
        "2281": {"vr": "OB", "BinaryLength": 183288},
        "2282": {"vr": "OB", "BinaryLength": 183288},
        "2283": {"vr": "OB", "BinaryLength": 183288},
        "2284": {"vr": "OB", "BinaryLength": 183288},
        "2285": {"vr": "OB", "BinaryLength": 183288},
        "2286": {"vr": "OB", "BinaryLength": 183288},
        "2287": {"vr": "OB", "BinaryLength": 183288},
        "2288": {"vr": "OB", "BinaryLength": 183288},
        "2289": {"vr": "OB", "BinaryLength": 183288},
        "2290": {"vr": "OB", "BinaryLength": 183288},
        "2291": {"vr": "OB", "BinaryLength": 183288},
        "2292": {"vr": "OB", "BinaryLength": 183288},
        "2293": {"vr": "OB", "BinaryLength": 183288},
        "2294": {"vr": "OB", "BinaryLength": 183288},
        "2295": {"vr": "OB", "BinaryLength": 183288},
        "2296": {"vr": "OB", "BinaryLength": 183288},
        "2297": {"vr": "OB", "BinaryLength": 183288},
        "2298": {"vr": "OB", "BinaryLength": 183288},
        "2299": {"vr": "OB", "BinaryLength": 183288},
        "2300": {"vr": "OB", "BinaryLength": 183288},
        "2301": {"vr": "OB", "BinaryLength": 183288},
        "2302": {"vr": "OB", "BinaryLength": 183288},
        "2303": {"vr": "OB", "BinaryLength": 183288},
        "2304": {"vr": "OB", "BinaryLength": 183288},
        "2305": {"vr": "OB", "BinaryLength": 183288},
        "2306": {"vr": "OB", "BinaryLength": 183288},
        "2307": {"vr": "OB", "BinaryLength": 183288},
        "2308": {"vr": "OB", "BinaryLength": 183288},
        "2309": {"vr": "OB", "BinaryLength": 183288},
        "2310": {"vr": "OB", "BinaryLength": 183288},
        "2311": {"vr": "OB", "BinaryLength": 183288},
        "2312": {"vr": "OB", "BinaryLength": 183288},
        "2313": {"vr": "OB", "BinaryLength": 183288},
        "2314": {"vr": "OB", "BinaryLength": 183288},
        "2315": {"vr": "OB", "BinaryLength": 183288},
        "2316": {"vr": "OB", "BinaryLength": 183288},
        "2317": {"vr": "OB", "BinaryLength": 183288},
        "2318": {"vr": "OB", "BinaryLength": 183288},
        "2319": {"vr": "OB", "BinaryLength": 183288},
        "2320": {"vr": "OB", "BinaryLength": 183288},
        "2321": {"vr": "OB", "BinaryLength": 183288},
        "2322": {"vr": "OB", "BinaryLength": 183288},
        "2323": {"vr": "OB", "BinaryLength": 183288},
        "2324": {"vr": "OB", "BinaryLength": 183288},
        "2325": {"vr": "OB", "BinaryLength": 183288},
        "2326": {"vr": "OB", "BinaryLength": 183288},
        "2327": {"vr": "OB", "BinaryLength": 183288},
        "2328": {"vr": "OB", "BinaryLength": 183288},
        "2329": {"vr": "OB", "BinaryLength": 183288},
        "2330": {"vr": "OB", "BinaryLength": 183288},
        "2331": {"vr": "OB", "BinaryLength": 183288},
        "2332": {"vr": "OB", "BinaryLength": 183288},
        "2333": {"vr": "OB", "BinaryLength": 183288},
        "2334": {"vr": "OB", "BinaryLength": 183288},
        "2335": {"vr": "OB", "BinaryLength": 183288},
        "2336": {"vr": "OB", "BinaryLength": 183288},
        "2337": {"vr": "OB", "BinaryLength": 183288},
        "2338": {"vr": "OB", "BinaryLength": 183288},
        "2339": {"vr": "OB", "BinaryLength": 183288},
        "2340": {"vr": "OB", "BinaryLength": 183288},
        "2341": {"vr": "OB", "BinaryLength": 183288},
        "2342": {"vr": "OB", "BinaryLength": 183288},
        "2343": {"vr": "OB", "BinaryLength": 183288},
        "2344": {"vr": "OB", "BinaryLength": 183288},
        "2345": {"vr": "OB", "BinaryLength": 183288},
        "2346": {"vr": "OB", "BinaryLength": 183288},
        "2347": {"vr": "OB", "BinaryLength": 183288},
        "2348": {"vr": "OB", "BinaryLength": 183288},
        "2349": {"vr": "OB", "BinaryLength": 183288},
        "2350": {"vr": "OB", "BinaryLength": 183288},
        "2351": {"vr": "OB", "BinaryLength": 183288},
        "2352": {"vr": "OB", "BinaryLength": 183288},
        "2353": {"vr": "OB", "BinaryLength": 183288},
        "2354": {"vr": "OB", "BinaryLength": 183288},
        "2355": {"vr": "OB", "BinaryLength": 183288},
        "2356": {"vr": "OB", "BinaryLength": 183288},
        "2357": {"vr": "OB", "BinaryLength": 183288},
        "2358": {"vr": "OB", "BinaryLength": 183288},
        "2359": {"vr": "OB", "BinaryLength": 183288},
        "2360": {"vr": "OB", "BinaryLength": 183288},
        "2361": {"vr": "OB", "BinaryLength": 183288},
        "2362": {"vr": "OB", "BinaryLength": 183288},
        "2363": {"vr": "OB", "BinaryLength": 183288},
        "2364": {"vr": "OB", "BinaryLength": 183288},
        "2365": {"vr": "OB", "BinaryLength": 183288},
        "2366": {"vr": "OB", "BinaryLength": 183288},
        "2367": {"vr": "OB", "BinaryLength": 183288},
        "2368": {"vr": "OB", "BinaryLength": 183288},
        "2369": {"vr": "OB", "BinaryLength": 183288},
        "2370": {"vr": "OB", "BinaryLength": 183288},
        "2371": {"vr": "OB", "BinaryLength": 183288},
        "2372": {"vr": "OB", "BinaryLength": 183288},
        "2373": {"vr": "OB", "BinaryLength": 183288},
        "2374": {"vr": "OB", "BinaryLength": 183288},
        "2375": {"vr": "OB", "BinaryLength": 183288},
        "2376": {"vr": "OB", "BinaryLength": 183288},
        "2377": {"vr": "OB", "BinaryLength": 183288},
        "2378": {"vr": "OB", "BinaryLength": 183288},
        "2379": {"vr": "OB", "BinaryLength": 183288},
        "2380": {"vr": "OB", "BinaryLength": 183288},
        "2381": {"vr": "OB", "BinaryLength": 183288},
        "2382": {"vr": "OB", "BinaryLength": 183288},
        "2383": {"vr": "OB", "BinaryLength": 183288},
        "2384": {"vr": "OB", "BinaryLength": 183288},
        "2385": {"vr": "OB", "BinaryLength": 183288},
        "2386": {"vr": "OB", "BinaryLength": 183288},
        "2387": {"vr": "OB", "BinaryLength": 183288},
        "2388": {"vr": "OB", "BinaryLength": 183288},
        "2389": {"vr": "OB", "BinaryLength": 183288},
        "2390": {"vr": "OB", "BinaryLength": 183288},
        "2391": {"vr": "OB", "BinaryLength": 183288},
        "2392": {"vr": "OB", "BinaryLength": 183288},
        "2393": {"vr": "OB", "BinaryLength": 183288},
        "2394": {"vr": "OB", "BinaryLength": 183288},
        "2395": {"vr": "OB", "BinaryLength": 183288},
        "2396": {"vr": "OB", "BinaryLength": 183288},
        "2397": {"vr": "OB", "BinaryLength": 183288},
        "2398": {"vr": "OB", "BinaryLength": 183288},
        "2399": {"vr": "OB", "BinaryLength": 183288},
        "2400": {"vr": "OB", "BinaryLength": 183288},
        "2401": {"vr": "OB", "BinaryLength": 183288},
        "2402": {"vr": "OB", "BinaryLength": 183288},
        "2403": {"vr": "OB", "BinaryLength": 183288},
        "2404": {"vr": "OB", "BinaryLength": 183288},
        "2405": {"vr": "OB", "BinaryLength": 183288},
        "2406": {"vr": "OB", "BinaryLength": 183288},
        "2407": {"vr": "OB", "BinaryLength": 183288},
        "2408": {"vr": "OB", "BinaryLength": 183288},
        "2409": {"vr": "OB", "BinaryLength": 183288},
        "2410": {"vr": "OB", "BinaryLength": 183288},
        "2411": {"vr": "OB", "BinaryLength": 183288},
        "2412": {"vr": "OB", "BinaryLength": 183288},
        "2413": {"vr": "OB", "BinaryLength": 183288},
        "2414": {"vr": "OB", "BinaryLength": 183288},
        "2415": {"vr": "OB", "BinaryLength": 183288},
        "2416": {"vr": "OB", "BinaryLength": 183288},
        "2417": {"vr": "OB", "BinaryLength": 183288},
        "2418": {"vr": "OB", "BinaryLength": 183288},
        "2419": {"vr": "OB", "BinaryLength": 183288},
        "2420": {"vr": "OB", "BinaryLength": 183288},
        "2421": {"vr": "OB", "BinaryLength": 183288},
        "2422": {"vr": "OB", "BinaryLength": 183288},
        "2423": {"vr": "OB", "BinaryLength": 183288},
        "2424": {"vr": "OB", "BinaryLength": 183288},
        "2425": {"vr": "OB", "BinaryLength": 183288},
        "2426": {"vr": "OB", "BinaryLength": 183288},
        "2427": {"vr": "OB", "BinaryLength": 183288},
        "2428": {"vr": "OB", "BinaryLength": 183288},
        "2429": {"vr": "OB", "BinaryLength": 183288},
        "2430": {"vr": "OB", "BinaryLength": 183288},
        "2431": {"vr": "OB", "BinaryLength": 183288},
        "2432": {"vr": "OB", "BinaryLength": 183288},
        "2433": {"vr": "OB", "BinaryLength": 183288},
        "2434": {"vr": "OB", "BinaryLength": 183288},
        "2435": {"vr": "OB", "BinaryLength": 183288},
        "2436": {"vr": "OB", "BinaryLength": 183288},
        "2437": {"vr": "OB", "BinaryLength": 183288},
        "2438": {"vr": "OB", "BinaryLength": 183288},
        "2439": {"vr": "OB", "BinaryLength": 183288},
        "2440": {"vr": "OB", "BinaryLength": 183288},
        "2441": {"vr": "OB", "BinaryLength": 183288},
        "2442": {"vr": "OB", "BinaryLength": 183288},
        "2443": {"vr": "OB", "BinaryLength": 183288},
        "2444": {"vr": "OB", "BinaryLength": 183288},
        "2445": {"vr": "OB", "BinaryLength": 183288},
        "2446": {"vr": "OB", "BinaryLength": 183288},
        "2447": {"vr": "OB", "BinaryLength": 183288},
        "2448": {"vr": "OB", "BinaryLength": 183288},
        "2449": {"vr": "OB", "BinaryLength": 183288},
        "2450": {"vr": "OB", "BinaryLength": 183288},
        "2451": {"vr": "OB", "BinaryLength": 183288},
        "2452": {"vr": "OB", "BinaryLength": 183288},
        "2453": {"vr": "OB", "BinaryLength": 183288},
        "2454": {"vr": "OB", "BinaryLength": 183288},
        "2455": {"vr": "OB", "BinaryLength": 183288},
        "2456": {"vr": "OB", "BinaryLength": 183288},
        "2457": {"vr": "OB", "BinaryLength": 183288},
        "2458": {"vr": "OB", "BinaryLength": 183288},
        "2459": {"vr": "OB", "BinaryLength": 183288},
        "2460": {"vr": "OB", "BinaryLength": 183288},
        "2461": {"vr": "OB", "BinaryLength": 183288},
        "2462": {"vr": "OB", "BinaryLength": 183288},
        "2463": {"vr": "OB", "BinaryLength": 183288},
        "2464": {"vr": "OB", "BinaryLength": 183288},
        "2465": {"vr": "OB", "BinaryLength": 183288},
        "2466": {"vr": "OB", "BinaryLength": 183288},
        "2467": {"vr": "OB", "BinaryLength": 183288},
        "2468": {"vr": "OB", "BinaryLength": 183288},
        "2469": {"vr": "OB", "BinaryLength": 183288},
        "2470": {"vr": "OB", "BinaryLength": 183288},
        "2471": {"vr": "OB", "BinaryLength": 183288},
        "2472": {"vr": "OB", "BinaryLength": 183288},
        "2473": {"vr": "OB", "BinaryLength": 183288},
        "2474": {"vr": "OB", "BinaryLength": 183288},
        "2475": {"vr": "OB", "BinaryLength": 183288},
        "2476": {"vr": "OB", "BinaryLength": 183288},
        "2477": {"vr": "OB", "BinaryLength": 183288},
        "2478": {"vr": "OB", "BinaryLength": 183288},
        "2479": {"vr": "OB", "BinaryLength": 183288},
        "2480": {"vr": "OB", "BinaryLength": 183288},
        "2481": {"vr": "OB", "BinaryLength": 183288},
        "2482": {"vr": "OB", "BinaryLength": 183288},
        "2483": {"vr": "OB", "BinaryLength": 183288},
        "2484": {"vr": "OB", "BinaryLength": 183288},
        "2485": {"vr": "OB", "BinaryLength": 183288},
        "2486": {"vr": "OB", "BinaryLength": 183288},
        "2487": {"vr": "OB", "BinaryLength": 183288},
        "2488": {"vr": "OB", "BinaryLength": 183288},
        "2489": {"vr": "OB", "BinaryLength": 183288},
        "2490": {"vr": "OB", "BinaryLength": 183288},
        "2491": {"vr": "OB", "BinaryLength": 183288},
        "2492": {"vr": "OB", "BinaryLength": 183288},
        "2493": {"vr": "OB", "BinaryLength": 183288},
        "2494": {"vr": "OB", "BinaryLength": 183288},
        "2495": {"vr": "OB", "BinaryLength": 183288},
        "2496": {"vr": "OB", "BinaryLength": 183288},
        "2497": {"vr": "OB", "BinaryLength": 183288},
        "2498": {"vr": "OB", "BinaryLength": 183288},
        "2499": {"vr": "OB", "BinaryLength": 183288},
        "2500": {"vr": "OB", "BinaryLength": 183288},
        "2501": {"vr": "OB", "BinaryLength": 183288},
        "2502": {"vr": "OB", "BinaryLength": 183288},
        "2503": {"vr": "OB", "BinaryLength": 183288},
        "2504": {"vr": "OB", "BinaryLength": 183288},
        "2505": {"vr": "OB", "BinaryLength": 183288},
        "2506": {"vr": "OB", "BinaryLength": 183288},
        "2507": {"vr": "OB", "BinaryLength": 183288},
        "2508": {"vr": "OB", "BinaryLength": 183288},
        "2509": {"vr": "OB", "BinaryLength": 183288},
        "2510": {"vr": "OB", "BinaryLength": 183288},
        "2511": {"vr": "OB", "BinaryLength": 183288},
        "2512": {"vr": "OB", "BinaryLength": 183288},
        "2513": {"vr": "OB", "BinaryLength": 183288},
        "2514": {"vr": "OB", "BinaryLength": 183288},
        "2515": {"vr": "OB", "BinaryLength": 183288},
        "2516": {"vr": "OB", "BinaryLength": 183288},
        "2517": {"vr": "OB", "BinaryLength": 183288},
        "2518": {"vr": "OB", "BinaryLength": 183288},
        "2519": {"vr": "OB", "BinaryLength": 183288},
        "2520": {"vr": "OB", "BinaryLength": 183288},
        "2521": {"vr": "OB", "BinaryLength": 183288},
        "2522": {"vr": "OB", "BinaryLength": 183288},
        "2523": {"vr": "OB", "BinaryLength": 183288},
        "2524": {"vr": "OB", "BinaryLength": 183288},
        "2525": {"vr": "OB", "BinaryLength": 183288},
        "2526": {"vr": "OB", "BinaryLength": 183288},
        "2527": {"vr": "OB", "BinaryLength": 183288},
        "2528": {"vr": "OB", "BinaryLength": 183288},
        "2529": {"vr": "OB", "BinaryLength": 183288},
        "2530": {"vr": "OB", "BinaryLength": 183288},
        "2531": {"vr": "OB", "BinaryLength": 183288},
        "2532": {"vr": "OB", "BinaryLength": 183288},
        "2533": {"vr": "OB", "BinaryLength": 183288},
        "2534": {"vr": "OB", "BinaryLength": 183288},
        "2535": {"vr": "OB", "BinaryLength": 183288},
        "2536": {"vr": "OB", "BinaryLength": 183288},
        "2537": {"vr": "OB", "BinaryLength": 183288},
        "2538": {"vr": "OB", "BinaryLength": 183288},
        "2539": {"vr": "OB", "BinaryLength": 183288},
        "2540": {"vr": "OB", "BinaryLength": 183288},
        "2541": {"vr": "OB", "BinaryLength": 183288},
        "2542": {"vr": "OB", "BinaryLength": 183288},
        "2543": {"vr": "OB", "BinaryLength": 183288},
        "2544": {"vr": "OB", "BinaryLength": 183288},
        "2545": {"vr": "OB", "BinaryLength": 183288},
        "2546": {"vr": "OB", "BinaryLength": 183288},
        "2547": {"vr": "OB", "BinaryLength": 183288},
        "2548": {"vr": "OB", "BinaryLength": 183288},
        "2549": {"vr": "OB", "BinaryLength": 183288},
        "2550": {"vr": "OB", "BinaryLength": 183288},
        "2551": {"vr": "OB", "BinaryLength": 183288},
        "2552": {"vr": "OB", "BinaryLength": 183288},
        "2553": {"vr": "OB", "BinaryLength": 183288},
        "2554": {"vr": "OB", "BinaryLength": 183288},
        "2555": {"vr": "OB", "BinaryLength": 183288},
        "2556": {"vr": "OB", "BinaryLength": 183288},
        "2557": {"vr": "OB", "BinaryLength": 183288},
        "2558": {"vr": "OB", "BinaryLength": 183288},
        "2559": {"vr": "OB", "BinaryLength": 183288},
        "2560": {"vr": "OB", "BinaryLength": 183288},
        "2561": {"vr": "OB", "BinaryLength": 183288},
        "2562": {"vr": "OB", "BinaryLength": 183288},
        "2563": {"vr": "OB", "BinaryLength": 183288},
        "2564": {"vr": "OB", "BinaryLength": 183288},
        "2565": {"vr": "OB", "BinaryLength": 183288},
        "2566": {"vr": "OB", "BinaryLength": 183288},
        "2567": {"vr": "OB", "BinaryLength": 183288},
        "2568": {"vr": "OB", "BinaryLength": 183288},
        "2569": {"vr": "OB", "BinaryLength": 183288},
        "2570": {"vr": "OB", "BinaryLength": 183288},
        "2571": {"vr": "OB", "BinaryLength": 183288},
        "2572": {"vr": "OB", "BinaryLength": 183288},
        "2573": {"vr": "OB", "BinaryLength": 183288},
        "2574": {"vr": "OB", "BinaryLength": 183288},
        "2575": {"vr": "OB", "BinaryLength": 183288},
        "2576": {"vr": "OB", "BinaryLength": 183288},
        "2577": {"vr": "OB", "BinaryLength": 183288},
        "2578": {"vr": "OB", "BinaryLength": 183288},
        "2579": {"vr": "OB", "BinaryLength": 183288},
        "2580": {"vr": "OB", "BinaryLength": 183288},
        "2581": {"vr": "OB", "BinaryLength": 183288},
        "2582": {"vr": "OB", "BinaryLength": 183288},
        "2583": {"vr": "OB", "BinaryLength": 183288},
        "2584": {"vr": "OB", "BinaryLength": 183288},
        "2585": {"vr": "OB", "BinaryLength": 183288},
        "2586": {"vr": "OB", "BinaryLength": 183288},
        "2587": {"vr": "OB", "BinaryLength": 183288},
        "2588": {"vr": "OB", "BinaryLength": 183288},
        "2589": {"vr": "OB", "BinaryLength": 183288},
        "2590": {"vr": "OB", "BinaryLength": 183288},
        "2591": {"vr": "OB", "BinaryLength": 183288},
        "2592": {"vr": "OB", "BinaryLength": 183288},
        "2593": {"vr": "OB", "BinaryLength": 183288},
        "2594": {"vr": "OB", "BinaryLength": 183288},
        "2595": {"vr": "OB", "BinaryLength": 183288},
        "2596": {"vr": "OB", "BinaryLength": 183288},
        "2597": {"vr": "OB", "BinaryLength": 183288},
        "2598": {"vr": "OB", "BinaryLength": 183288},
        "2599": {"vr": "OB", "BinaryLength": 183288},
        "2600": {"vr": "OB", "BinaryLength": 183288},
        "2601": {"vr": "OB", "BinaryLength": 183288},
        "2602": {"vr": "OB", "BinaryLength": 183288},
        "2603": {"vr": "OB", "BinaryLength": 183288},
        "2604": {"vr": "OB", "BinaryLength": 183288},
        "2605": {"vr": "OB", "BinaryLength": 183288},
        "2606": {"vr": "OB", "BinaryLength": 183288},
        "2607": {"vr": "OB", "BinaryLength": 183288},
        "2608": {"vr": "OB", "BinaryLength": 183288},
        "2609": {"vr": "OB", "BinaryLength": 183288},
        "2610": {"vr": "OB", "BinaryLength": 183288},
        "2611": {"vr": "OB", "BinaryLength": 183288},
        "2612": {"vr": "OB", "BinaryLength": 183288},
        "2613": {"vr": "OB", "BinaryLength": 183288},
        "2614": {"vr": "OB", "BinaryLength": 183288},
        "2615": {"vr": "OB", "BinaryLength": 183288},
        "2616": {"vr": "OB", "BinaryLength": 183288},
        "2617": {"vr": "OB", "BinaryLength": 183288},
        "2618": {"vr": "OB", "BinaryLength": 183288},
        "2619": {"vr": "OB", "BinaryLength": 183288},
        "2620": {"vr": "OB", "BinaryLength": 183288},
        "2621": {"vr": "OB", "BinaryLength": 183288},
        "2622": {"vr": "OB", "BinaryLength": 183288},
        "2623": {"vr": "OB", "BinaryLength": 183288},
        "2624": {"vr": "OB", "BinaryLength": 183288},
        "2625": {"vr": "OB", "BinaryLength": 183288},
        "2626": {"vr": "OB", "BinaryLength": 183288},
        "2627": {"vr": "OB", "BinaryLength": 183288},
        "2628": {"vr": "OB", "BinaryLength": 183288},
        "2629": {"vr": "OB", "BinaryLength": 183288},
        "2630": {"vr": "OB", "BinaryLength": 183288},
        "2631": {"vr": "OB", "BinaryLength": 183288},
        "2632": {"vr": "OB", "BinaryLength": 183288},
        "2633": {"vr": "OB", "BinaryLength": 183288},
        "2634": {"vr": "OB", "BinaryLength": 183288},
        "2635": {"vr": "OB", "BinaryLength": 183288},
        "2636": {"vr": "OB", "BinaryLength": 183288},
        "2637": {"vr": "OB", "BinaryLength": 183288},
        "2638": {"vr": "OB", "BinaryLength": 183288},
        "2639": {"vr": "OB", "BinaryLength": 183288},
        "2640": {"vr": "OB", "BinaryLength": 183288},
        "2641": {"vr": "OB", "BinaryLength": 183288},
        "2642": {"vr": "OB", "BinaryLength": 183288},
        "2643": {"vr": "OB", "BinaryLength": 183288},
        "2644": {"vr": "OB", "BinaryLength": 183288},
        "2645": {"vr": "OB", "BinaryLength": 183288},
        "2646": {"vr": "OB", "BinaryLength": 183288},
        "2647": {"vr": "OB", "BinaryLength": 183288},
        "2648": {"vr": "OB", "BinaryLength": 183288},
        "2649": {"vr": "OB", "BinaryLength": 183288},
        "2650": {"vr": "OB", "BinaryLength": 183288},
        "2651": {"vr": "OB", "BinaryLength": 183288},
        "2652": {"vr": "OB", "BinaryLength": 183288},
        "2653": {"vr": "OB", "BinaryLength": 183288},
        "2654": {"vr": "OB", "BinaryLength": 183288},
        "2655": {"vr": "OB", "BinaryLength": 183288},
        "2656": {"vr": "OB", "BinaryLength": 183288},
        "2657": {"vr": "OB", "BinaryLength": 183288},
        "2658": {"vr": "OB", "BinaryLength": 183288},
        "2659": {"vr": "OB", "BinaryLength": 183288},
        "2660": {"vr": "OB", "BinaryLength": 183288},
        "2661": {"vr": "OB", "BinaryLength": 183288},
        "2662": {"vr": "OB", "BinaryLength": 183288},
        "2663": {"vr": "OB", "BinaryLength": 183288},
        "2664": {"vr": "OB", "BinaryLength": 183288},
        "2665": {"vr": "OB", "BinaryLength": 183288},
        "2666": {"vr": "OB", "BinaryLength": 183288},
        "2667": {"vr": "OB", "BinaryLength": 183288},
        "2668": {"vr": "OB", "BinaryLength": 183288},
        "2669": {"vr": "OB", "BinaryLength": 183288},
        "2670": {"vr": "OB", "BinaryLength": 183288},
        "2671": {"vr": "OB", "BinaryLength": 183288},
        "2672": {"vr": "OB", "BinaryLength": 183288},
        "2673": {"vr": "OB", "BinaryLength": 183288},
        "2674": {"vr": "OB", "BinaryLength": 183288},
        "2675": {"vr": "OB", "BinaryLength": 183288},
        "2676": {"vr": "OB", "BinaryLength": 183288},
        "2677": {"vr": "OB", "BinaryLength": 183288},
        "2678": {"vr": "OB", "BinaryLength": 183288},
        "2679": {"vr": "OB", "BinaryLength": 183288},
        "2680": {"vr": "OB", "BinaryLength": 183288},
        "2681": {"vr": "OB", "BinaryLength": 183288},
        "2682": {"vr": "OB", "BinaryLength": 183288},
        "2683": {"vr": "OB", "BinaryLength": 183288},
        "2684": {"vr": "OB", "BinaryLength": 183288},
        "2685": {"vr": "OB", "BinaryLength": 183288},
        "2686": {"vr": "OB", "BinaryLength": 183288},
        "2687": {"vr": "OB", "BinaryLength": 183288},
        "2688": {"vr": "OB", "BinaryLength": 183288},
        "2689": {"vr": "OB", "BinaryLength": 183288},
        "2690": {"vr": "OB", "BinaryLength": 183288},
        "2691": {"vr": "OB", "BinaryLength": 183288},
        "2692": {"vr": "OB", "BinaryLength": 183288},
        "2693": {"vr": "OB", "BinaryLength": 183288},
        "2694": {"vr": "OB", "BinaryLength": 183288},
        "2695": {"vr": "OB", "BinaryLength": 183288},
        "2696": {"vr": "OB", "BinaryLength": 183288},
        "2697": {"vr": "OB", "BinaryLength": 183288},
        "2698": {"vr": "OB", "BinaryLength": 183288},
        "2699": {"vr": "OB", "BinaryLength": 183288},
        "2700": {"vr": "OB", "BinaryLength": 183288},
        "2701": {"vr": "OB", "BinaryLength": 183288},
        "2702": {"vr": "OB", "BinaryLength": 183288},
        "2703": {"vr": "OB", "BinaryLength": 183288},
        "2704": {"vr": "OB", "BinaryLength": 183288},
        "2705": {"vr": "OB", "BinaryLength": 183288},
        "2706": {"vr": "OB", "BinaryLength": 183288},
        "2707": {"vr": "OB", "BinaryLength": 183288},
        "2708": {"vr": "OB", "BinaryLength": 183288},
        "2709": {"vr": "OB", "BinaryLength": 183288},
        "2710": {"vr": "OB", "BinaryLength": 183288},
        "2711": {"vr": "OB", "BinaryLength": 183288},
        "2712": {"vr": "OB", "BinaryLength": 183288},
        "2713": {"vr": "OB", "BinaryLength": 183288},
        "2714": {"vr": "OB", "BinaryLength": 183288},
        "2715": {"vr": "OB", "BinaryLength": 183288},
        "2716": {"vr": "OB", "BinaryLength": 183288},
        "2717": {"vr": "OB", "BinaryLength": 183288},
        "2718": {"vr": "OB", "BinaryLength": 183288},
        "2719": {"vr": "OB", "BinaryLength": 183288},
        "2720": {"vr": "OB", "BinaryLength": 183288},
        "2721": {"vr": "OB", "BinaryLength": 183288},
        "2722": {"vr": "OB", "BinaryLength": 183288},
        "2723": {"vr": "OB", "BinaryLength": 183288},
        "2724": {"vr": "OB", "BinaryLength": 183288},
        "2725": {"vr": "OB", "BinaryLength": 183288},
        "2726": {"vr": "OB", "BinaryLength": 183288},
        "2727": {"vr": "OB", "BinaryLength": 183288},
        "2728": {"vr": "OB", "BinaryLength": 183288},
        "2729": {"vr": "OB", "BinaryLength": 183288},
        "2730": {"vr": "OB", "BinaryLength": 183288},
        "2731": {"vr": "OB", "BinaryLength": 183288},
        "2732": {"vr": "OB", "BinaryLength": 183288},
        "2733": {"vr": "OB", "BinaryLength": 183288},
        "2734": {"vr": "OB", "BinaryLength": 183288},
        "2735": {"vr": "OB", "BinaryLength": 183288},
        "2736": {"vr": "OB", "BinaryLength": 183288},
        "2737": {"vr": "OB", "BinaryLength": 183288},
        "2738": {"vr": "OB", "BinaryLength": 183288},
        "2739": {"vr": "OB", "BinaryLength": 183288},
        "2740": {"vr": "OB", "BinaryLength": 183288},
        "2741": {"vr": "OB", "BinaryLength": 183288},
        "2742": {"vr": "OB", "BinaryLength": 183288},
        "2743": {"vr": "OB", "BinaryLength": 183288},
        "2744": {"vr": "OB", "BinaryLength": 183288},
        "2745": {"vr": "OB", "BinaryLength": 183288},
        "2746": {"vr": "OB", "BinaryLength": 183288},
        "2747": {"vr": "OB", "BinaryLength": 183288},
        "2748": {"vr": "OB", "BinaryLength": 183288},
        "2749": {"vr": "OB", "BinaryLength": 183288},
        "2750": {"vr": "OB", "BinaryLength": 183288},
        "2751": {"vr": "OB", "BinaryLength": 183288},
        "2752": {"vr": "OB", "BinaryLength": 183288},
        "2753": {"vr": "OB", "BinaryLength": 183288},
        "2754": {"vr": "OB", "BinaryLength": 183288},
        "2755": {"vr": "OB", "BinaryLength": 183288},
        "2756": {"vr": "OB", "BinaryLength": 183288},
        "2757": {"vr": "OB", "BinaryLength": 183288},
        "2758": {"vr": "OB", "BinaryLength": 183288},
        "2759": {"vr": "OB", "BinaryLength": 183288},
        "2760": {"vr": "OB", "BinaryLength": 183288},
        "2761": {"vr": "OB", "BinaryLength": 183288},
        "2762": {"vr": "OB", "BinaryLength": 183288},
        "2763": {"vr": "OB", "BinaryLength": 183288},
        "2764": {"vr": "OB", "BinaryLength": 183288},
        "2765": {"vr": "OB", "BinaryLength": 183288},
        "2766": {"vr": "OB", "BinaryLength": 183288},
        "2767": {"vr": "OB", "BinaryLength": 183288},
        "2768": {"vr": "OB", "BinaryLength": 183288},
        "2769": {"vr": "OB", "BinaryLength": 183288},
        "2770": {"vr": "OB", "BinaryLength": 183288},
        "2771": {"vr": "OB", "BinaryLength": 183288},
        "2772": {"vr": "OB", "BinaryLength": 183288},
        "2773": {"vr": "OB", "BinaryLength": 183288},
        "2774": {"vr": "OB", "BinaryLength": 183288},
        "2775": {"vr": "OB", "BinaryLength": 183288},
        "2776": {"vr": "OB", "BinaryLength": 183288},
        "2777": {"vr": "OB", "BinaryLength": 183288},
        "2778": {"vr": "OB", "BinaryLength": 183288},
        "2779": {"vr": "OB", "BinaryLength": 183288},
        "2780": {"vr": "OB", "BinaryLength": 183288},
        "2781": {"vr": "OB", "BinaryLength": 183288},
        "2782": {"vr": "OB", "BinaryLength": 183288},
        "2783": {"vr": "OB", "BinaryLength": 183288},
        "2784": {"vr": "OB", "BinaryLength": 183288},
        "2785": {"vr": "OB", "BinaryLength": 183288},
        "2786": {"vr": "OB", "BinaryLength": 183288},
        "2787": {"vr": "OB", "BinaryLength": 183288},
        "2788": {"vr": "OB", "BinaryLength": 183288},
        "2789": {"vr": "OB", "BinaryLength": 183288},
        "2790": {"vr": "OB", "BinaryLength": 183288},
        "2791": {"vr": "OB", "BinaryLength": 183288},
        "2792": {"vr": "OB", "BinaryLength": 183288},
        "2793": {"vr": "OB", "BinaryLength": 183288},
        "2794": {"vr": "OB", "BinaryLength": 183288},
        "2795": {"vr": "OB", "BinaryLength": 183288},
        "2796": {"vr": "OB", "BinaryLength": 183288},
        "2797": {"vr": "OB", "BinaryLength": 183288},
        "2798": {"vr": "OB", "BinaryLength": 183288},
        "2799": {"vr": "OB", "BinaryLength": 183288},
        "2800": {"vr": "OB", "BinaryLength": 183288},
        "2801": {"vr": "OB", "BinaryLength": 183288},
        "2802": {"vr": "OB", "BinaryLength": 183288},
        "2803": {"vr": "OB", "BinaryLength": 183288},
        "2804": {"vr": "OB", "BinaryLength": 183288},
        "2805": {"vr": "OB", "BinaryLength": 183288},
        "2806": {"vr": "OB", "BinaryLength": 183288},
        "2807": {"vr": "OB", "BinaryLength": 183288},
        "2808": {"vr": "OB", "BinaryLength": 183288},
        "2809": {"vr": "OB", "BinaryLength": 183288},
        "2810": {"vr": "OB", "BinaryLength": 183288},
        "2811": {"vr": "OB", "BinaryLength": 183288},
        "2812": {"vr": "OB", "BinaryLength": 183288},
        "2813": {"vr": "OB", "BinaryLength": 183288},
        "2814": {"vr": "OB", "BinaryLength": 183288},
        "2815": {"vr": "OB", "BinaryLength": 183288},
        "2816": {"vr": "OB", "BinaryLength": 183288},
        "2817": {"vr": "OB", "BinaryLength": 183288},
        "2818": {"vr": "OB", "BinaryLength": 183288},
        "2819": {"vr": "OB", "BinaryLength": 183288},
        "2820": {"vr": "OB", "BinaryLength": 183288},
        "2821": {"vr": "OB", "BinaryLength": 183288},
        "2822": {"vr": "OB", "BinaryLength": 183288},
        "2823": {"vr": "OB", "BinaryLength": 183288},
        "2824": {"vr": "OB", "BinaryLength": 183288},
        "2825": {"vr": "OB", "BinaryLength": 183288},
        "2826": {"vr": "OB", "BinaryLength": 183288},
        "2827": {"vr": "OB", "BinaryLength": 183288},
        "2828": {"vr": "OB", "BinaryLength": 183288},
        "2829": {"vr": "OB", "BinaryLength": 183288},
        "2830": {"vr": "OB", "BinaryLength": 183288},
        "2831": {"vr": "OB", "BinaryLength": 183288},
        "2832": {"vr": "OB", "BinaryLength": 183288},
        "2833": {"vr": "OB", "BinaryLength": 183288},
        "2834": {"vr": "OB", "BinaryLength": 183288},
        "2835": {"vr": "OB", "BinaryLength": 183288},
        "2836": {"vr": "OB", "BinaryLength": 183288},
        "2837": {"vr": "OB", "BinaryLength": 183288},
        "2838": {"vr": "OB", "BinaryLength": 183288},
        "2839": {"vr": "OB", "BinaryLength": 183288},
        "2840": {"vr": "OB", "BinaryLength": 183288},
        "2841": {"vr": "OB", "BinaryLength": 183288},
        "2842": {"vr": "OB", "BinaryLength": 183288},
        "2843": {"vr": "OB", "BinaryLength": 183288},
        "2844": {"vr": "OB", "BinaryLength": 183288},
        "2845": {"vr": "OB", "BinaryLength": 183288},
        "2846": {"vr": "OB", "BinaryLength": 183288},
        "2847": {"vr": "OB", "BinaryLength": 183288},
        "2848": {"vr": "OB", "BinaryLength": 183288},
        "2849": {"vr": "OB", "BinaryLength": 183288},
        "2850": {"vr": "OB", "BinaryLength": 183288},
        "2851": {"vr": "OB", "BinaryLength": 183288},
        "2852": {"vr": "OB", "BinaryLength": 183288},
        "2853": {"vr": "OB", "BinaryLength": 183288},
        "2854": {"vr": "OB", "BinaryLength": 183288},
        "2855": {"vr": "OB", "BinaryLength": 183288},
        "2856": {"vr": "OB", "BinaryLength": 183288},
        "2857": {"vr": "OB", "BinaryLength": 183288},
        "2858": {"vr": "OB", "BinaryLength": 183288},
        "2859": {"vr": "OB", "BinaryLength": 183288},
        "2860": {"vr": "OB", "BinaryLength": 183288},
        "2861": {"vr": "OB", "BinaryLength": 183288},
        "2862": {"vr": "OB", "BinaryLength": 183288},
        "2863": {"vr": "OB", "BinaryLength": 183288},
        "2864": {"vr": "OB", "BinaryLength": 183288},
        "2865": {"vr": "OB", "BinaryLength": 183288},
        "2866": {"vr": "OB", "BinaryLength": 183288},
        "2867": {"vr": "OB", "BinaryLength": 183288},
        "2868": {"vr": "OB", "BinaryLength": 183288},
        "2869": {"vr": "OB", "BinaryLength": 183288},
        "2870": {"vr": "OB", "BinaryLength": 183288},
        "2871": {"vr": "OB", "BinaryLength": 183288},
        "2872": {"vr": "OB", "BinaryLength": 183288},
        "2873": {"vr": "OB", "BinaryLength": 183288},
        "2874": {"vr": "OB", "BinaryLength": 183288},
        "2875": {"vr": "OB", "BinaryLength": 183288},
        "2876": {"vr": "OB", "BinaryLength": 183288},
        "2877": {"vr": "OB", "BinaryLength": 183288},
        "2878": {"vr": "OB", "BinaryLength": 183288},
        "2879": {"vr": "OB", "BinaryLength": 183288},
        "2880": {"vr": "OB", "BinaryLength": 183288},
        "2881": {"vr": "OB", "BinaryLength": 183288},
        "2882": {"vr": "OB", "BinaryLength": 183288},
        "2883": {"vr": "OB", "BinaryLength": 183288},
        "2884": {"vr": "OB", "BinaryLength": 183288},
        "2885": {"vr": "OB", "BinaryLength": 183288},
        "2886": {"vr": "OB", "BinaryLength": 183288},
        "2887": {"vr": "OB", "BinaryLength": 183288},
        "2888": {"vr": "OB", "BinaryLength": 183288},
        "2889": {"vr": "OB", "BinaryLength": 183288},
        "2890": {"vr": "OB", "BinaryLength": 183288},
        "2891": {"vr": "OB", "BinaryLength": 183288},
        "2892": {"vr": "OB", "BinaryLength": 183288},
        "2893": {"vr": "OB", "BinaryLength": 183288},
        "2894": {"vr": "OB", "BinaryLength": 183288},
        "2895": {"vr": "OB", "BinaryLength": 183288},
        "2896": {"vr": "OB", "BinaryLength": 183288},
        "2897": {"vr": "OB", "BinaryLength": 183288},
        "2898": {"vr": "OB", "BinaryLength": 183288},
        "2899": {"vr": "OB", "BinaryLength": 183288},
        "2900": {"vr": "OB", "BinaryLength": 183288},
        "2901": {"vr": "OB", "BinaryLength": 183288},
        "2902": {"vr": "OB", "BinaryLength": 183288},
        "2903": {"vr": "OB", "BinaryLength": 183288},
        "2904": {"vr": "OB", "BinaryLength": 183288},
        "2905": {"vr": "OB", "BinaryLength": 183288},
        "2906": {"vr": "OB", "BinaryLength": 183288},
        "2907": {"vr": "OB", "BinaryLength": 183288},
        "2908": {"vr": "OB", "BinaryLength": 183288},
        "2909": {"vr": "OB", "BinaryLength": 183288},
        "2910": {"vr": "OB", "BinaryLength": 183288},
        "2911": {"vr": "OB", "BinaryLength": 183288},
        "2912": {"vr": "OB", "BinaryLength": 183288},
        "2913": {"vr": "OB", "BinaryLength": 183288},
        "2914": {"vr": "OB", "BinaryLength": 183288},
        "2915": {"vr": "OB", "BinaryLength": 183288},
        "2916": {"vr": "OB", "BinaryLength": 183288},
        "2917": {"vr": "OB", "BinaryLength": 183288},
        "2918": {"vr": "OB", "BinaryLength": 183288},
        "2919": {"vr": "OB", "BinaryLength": 183288},
        "2920": {"vr": "OB", "BinaryLength": 183288},
        "2921": {"vr": "OB", "BinaryLength": 183288},
        "2922": {"vr": "OB", "BinaryLength": 183288},
        "2923": {"vr": "OB", "BinaryLength": 183288},
        "2924": {"vr": "OB", "BinaryLength": 183288},
        "2925": {"vr": "OB", "BinaryLength": 183288},
        "2926": {"vr": "OB", "BinaryLength": 183288},
        "2927": {"vr": "OB", "BinaryLength": 183288},
        "2928": {"vr": "OB", "BinaryLength": 183288},
        "2929": {"vr": "OB", "BinaryLength": 183288},
        "2930": {"vr": "OB", "BinaryLength": 183288},
        "2931": {"vr": "OB", "BinaryLength": 183288},
        "2932": {"vr": "OB", "BinaryLength": 183288},
        "2933": {"vr": "OB", "BinaryLength": 183288},
        "2934": {"vr": "OB", "BinaryLength": 183288},
        "2935": {"vr": "OB", "BinaryLength": 183288},
        "2936": {"vr": "OB", "BinaryLength": 183288},
        "2937": {"vr": "OB", "BinaryLength": 183288},
        "2938": {"vr": "OB", "BinaryLength": 183288},
        "2939": {"vr": "OB", "BinaryLength": 183288},
        "2940": {"vr": "OB", "BinaryLength": 183288},
        "2941": {"vr": "OB", "BinaryLength": 183288},
        "2942": {"vr": "OB", "BinaryLength": 183288},
        "2943": {"vr": "OB", "BinaryLength": 183288},
        "2944": {"vr": "OB", "BinaryLength": 183288},
        "2945": {"vr": "OB", "BinaryLength": 183288},
        "2946": {"vr": "OB", "BinaryLength": 183288},
        "2947": {"vr": "OB", "BinaryLength": 183288},
        "2948": {"vr": "OB", "BinaryLength": 183288},
        "2949": {"vr": "OB", "BinaryLength": 183288},
        "2950": {"vr": "OB", "BinaryLength": 183288},
        "2951": {"vr": "OB", "BinaryLength": 183288},
        "2952": {"vr": "OB", "BinaryLength": 183288},
        "2953": {"vr": "OB", "BinaryLength": 183288},
        "2954": {"vr": "OB", "BinaryLength": 183288},
        "2955": {"vr": "OB", "BinaryLength": 183288},
        "2956": {"vr": "OB", "BinaryLength": 183288},
        "2957": {"vr": "OB", "BinaryLength": 183288},
        "2958": {"vr": "OB", "BinaryLength": 183288},
        "2959": {"vr": "OB", "BinaryLength": 183288},
        "2960": {"vr": "OB", "BinaryLength": 183288},
        "2961": {"vr": "OB", "BinaryLength": 183288},
        "2962": {"vr": "OB", "BinaryLength": 183288},
        "2963": {"vr": "OB", "BinaryLength": 183288},
        "2964": {"vr": "OB", "BinaryLength": 183288},
        "2965": {"vr": "OB", "BinaryLength": 183288},
        "2966": {"vr": "OB", "BinaryLength": 183288},
        "2967": {"vr": "OB", "BinaryLength": 183288},
        "2968": {"vr": "OB", "BinaryLength": 183288},
        "2969": {"vr": "OB", "BinaryLength": 183288},
        "2970": {"vr": "OB", "BinaryLength": 183288},
        "2971": {"vr": "OB", "BinaryLength": 183288},
        "2972": {"vr": "OB", "BinaryLength": 183288},
        "2973": {"vr": "OB", "BinaryLength": 183288},
        "2974": {"vr": "OB", "BinaryLength": 183288},
        "2975": {"vr": "OB", "BinaryLength": 183288},
        "2976": {"vr": "OB", "BinaryLength": 183288},
        "2977": {"vr": "OB", "BinaryLength": 183288},
        "2978": {"vr": "OB", "BinaryLength": 183288},
        "2979": {"vr": "OB", "BinaryLength": 183288},
        "2980": {"vr": "OB", "BinaryLength": 183288},
        "2981": {"vr": "OB", "BinaryLength": 183288},
        "2982": {"vr": "OB", "BinaryLength": 183288},
        "2983": {"vr": "OB", "BinaryLength": 183288},
        "2984": {"vr": "OB", "BinaryLength": 183288},
        "2985": {"vr": "OB", "BinaryLength": 183288},
        "2986": {"vr": "OB", "BinaryLength": 183288},
        "2987": {"vr": "OB", "BinaryLength": 183288},
        "2988": {"vr": "OB", "BinaryLength": 183288},
        "2989": {"vr": "OB", "BinaryLength": 183288},
        "2990": {"vr": "OB", "BinaryLength": 183288},
        "2991": {"vr": "OB", "BinaryLength": 183288},
        "2992": {"vr": "OB", "BinaryLength": 183288},
        "2993": {"vr": "OB", "BinaryLength": 183288},
        "2994": {"vr": "OB", "BinaryLength": 183288},
        "2995": {"vr": "OB", "BinaryLength": 183288},
        "2996": {"vr": "OB", "BinaryLength": 183288},
        "2997": {"vr": "OB", "BinaryLength": 183288},
        "2998": {"vr": "OB", "BinaryLength": 183288},
        "2999": {"vr": "OB", "BinaryLength": 183288},
        "3000": {"vr": "OB", "BinaryLength": 183288},
        "3001": {"vr": "OB", "BinaryLength": 183288},
        "3002": {"vr": "OB", "BinaryLength": 183288},
        "3003": {"vr": "OB", "BinaryLength": 183288},
        "3004": {"vr": "OB", "BinaryLength": 183288},
        "3005": {"vr": "OB", "BinaryLength": 183288},
        "3006": {"vr": "OB", "BinaryLength": 183288},
        "3007": {"vr": "OB", "BinaryLength": 183288},
        "3008": {"vr": "OB", "BinaryLength": 183288},
        "3009": {"vr": "OB", "BinaryLength": 183288},
        "3010": {"vr": "OB", "BinaryLength": 183288},
        "3011": {"vr": "OB", "BinaryLength": 183288},
        "3012": {"vr": "OB", "BinaryLength": 183288},
        "3013": {"vr": "OB", "BinaryLength": 183288},
        "3014": {"vr": "OB", "BinaryLength": 183288},
        "3015": {"vr": "OB", "BinaryLength": 183288},
        "3016": {"vr": "OB", "BinaryLength": 183288},
        "3017": {"vr": "OB", "BinaryLength": 183288},
        "3018": {"vr": "OB", "BinaryLength": 183288},
        "3019": {"vr": "OB", "BinaryLength": 183288},
        "3020": {"vr": "OB", "BinaryLength": 183288},
        "3021": {"vr": "OB", "BinaryLength": 183288},
        "3022": {"vr": "OB", "BinaryLength": 183288},
        "3023": {"vr": "OB", "BinaryLength": 183288},
        "3024": {"vr": "OB", "BinaryLength": 183288},
        "3025": {"vr": "OB", "BinaryLength": 183288},
        "3026": {"vr": "OB", "BinaryLength": 183288},
        "3027": {"vr": "OB", "BinaryLength": 183288},
        "3028": {"vr": "OB", "BinaryLength": 183288},
        "3029": {"vr": "OB", "BinaryLength": 183288},
        "3030": {"vr": "OB", "BinaryLength": 183288},
        "3031": {"vr": "OB", "BinaryLength": 183288},
        "3032": {"vr": "OB", "BinaryLength": 183288},
        "3033": {"vr": "OB", "BinaryLength": 183288},
        "3034": {"vr": "OB", "BinaryLength": 183288},
        "3035": {"vr": "OB", "BinaryLength": 183288},
        "3036": {"vr": "OB", "BinaryLength": 183288},
        "3037": {"vr": "OB", "BinaryLength": 183288},
        "3038": {"vr": "OB", "BinaryLength": 183288},
        "3039": {"vr": "OB", "BinaryLength": 183288},
        "3040": {"vr": "OB", "BinaryLength": 183288},
        "3041": {"vr": "OB", "BinaryLength": 183288},
        "3042": {"vr": "OB", "BinaryLength": 183288},
        "3043": {"vr": "OB", "BinaryLength": 183288},
        "3044": {"vr": "OB", "BinaryLength": 183288},
        "3045": {"vr": "OB", "BinaryLength": 183288},
        "3046": {"vr": "OB", "BinaryLength": 183288},
        "3047": {"vr": "OB", "BinaryLength": 183288},
        "3048": {"vr": "OB", "BinaryLength": 183288},
        "3049": {"vr": "OB", "BinaryLength": 183288},
        "3050": {"vr": "OB", "BinaryLength": 183288},
        "3051": {"vr": "OB", "BinaryLength": 183288},
        "3052": {"vr": "OB", "BinaryLength": 183288},
        "3053": {"vr": "OB", "BinaryLength": 183288},
        "3054": {"vr": "OB", "BinaryLength": 183288},
        "3055": {"vr": "OB", "BinaryLength": 183288},
        "3056": {"vr": "OB", "BinaryLength": 183288},
        "3057": {"vr": "OB", "BinaryLength": 183288},
        "3058": {"vr": "OB", "BinaryLength": 183288},
        "3059": {"vr": "OB", "BinaryLength": 183288},
        "3060": {"vr": "OB", "BinaryLength": 183288},
        "3061": {"vr": "OB", "BinaryLength": 183288},
        "3062": {"vr": "OB", "BinaryLength": 183288},
        "3063": {"vr": "OB", "BinaryLength": 183288},
        "3064": {"vr": "OB", "BinaryLength": 183288},
        "3065": {"vr": "OB", "BinaryLength": 183288},
        "3066": {"vr": "OB", "BinaryLength": 183288},
        "3067": {"vr": "OB", "BinaryLength": 183288},
        "3068": {"vr": "OB", "BinaryLength": 183288},
        "3069": {"vr": "OB", "BinaryLength": 183288},
        "3070": {"vr": "OB", "BinaryLength": 183288},
        "3071": {"vr": "OB", "BinaryLength": 183288},
        "3072": {"vr": "OB", "BinaryLength": 183288},
        "3073": {"vr": "OB", "BinaryLength": 183288},
        "3074": {"vr": "OB", "BinaryLength": 183288},
        "3075": {"vr": "OB", "BinaryLength": 183288},
        "3076": {"vr": "OB", "BinaryLength": 183288},
        "3077": {"vr": "OB", "BinaryLength": 183288},
        "3078": {"vr": "OB", "BinaryLength": 183288},
        "3079": {"vr": "OB", "BinaryLength": 183288},
        "3080": {"vr": "OB", "BinaryLength": 183288},
        "3081": {"vr": "OB", "BinaryLength": 183288},
        "3082": {"vr": "OB", "BinaryLength": 183288},
        "3083": {"vr": "OB", "BinaryLength": 183288},
        "3084": {"vr": "OB", "BinaryLength": 183288},
        "3085": {"vr": "OB", "BinaryLength": 183288},
        "3086": {"vr": "OB", "BinaryLength": 183288},
        "3087": {"vr": "OB", "BinaryLength": 183288},
        "3088": {"vr": "OB", "BinaryLength": 183288},
        "3089": {"vr": "OB", "BinaryLength": 183288},
        "3090": {"vr": "OB", "BinaryLength": 183288},
        "3091": {"vr": "OB", "BinaryLength": 183288},
        "3092": {"vr": "OB", "BinaryLength": 183288},
        "3093": {"vr": "OB", "BinaryLength": 183288},
        "3094": {"vr": "OB", "BinaryLength": 183288},
        "3095": {"vr": "OB", "BinaryLength": 183288},
        "3096": {"vr": "OB", "BinaryLength": 183288},
        "3097": {"vr": "OB", "BinaryLength": 183288},
        "3098": {"vr": "OB", "BinaryLength": 183288},
        "3099": {"vr": "OB", "BinaryLength": 183288},
        "3100": {"vr": "OB", "BinaryLength": 183288},
        "3101": {"vr": "OB", "BinaryLength": 183288},
        "3102": {"vr": "OB", "BinaryLength": 183288},
        "3103": {"vr": "OB", "BinaryLength": 183288},
        "3104": {"vr": "OB", "BinaryLength": 183288},
        "3105": {"vr": "OB", "BinaryLength": 183288},
        "3106": {"vr": "OB", "BinaryLength": 183288},
        "3107": {"vr": "OB", "BinaryLength": 183288},
        "3108": {"vr": "OB", "BinaryLength": 183288},
        "3109": {"vr": "OB", "BinaryLength": 183288},
        "3110": {"vr": "OB", "BinaryLength": 183288},
        "3111": {"vr": "OB", "BinaryLength": 183288},
        "3112": {"vr": "OB", "BinaryLength": 183288},
        "3113": {"vr": "OB", "BinaryLength": 183288},
        "3114": {"vr": "OB", "BinaryLength": 183288},
        "3115": {"vr": "OB", "BinaryLength": 183288},
        "3116": {"vr": "OB", "BinaryLength": 183288},
        "3117": {"vr": "OB", "BinaryLength": 183288},
        "3118": {"vr": "OB", "BinaryLength": 183288},
        "3119": {"vr": "OB", "BinaryLength": 183288},
        "3120": {"vr": "OB", "BinaryLength": 183288},
        "3121": {"vr": "OB", "BinaryLength": 183288},
        "3122": {"vr": "OB", "BinaryLength": 183288},
        "3123": {"vr": "OB", "BinaryLength": 183288},
        "3124": {"vr": "OB", "BinaryLength": 183288},
        "3125": {"vr": "OB", "BinaryLength": 183288},
        "3126": {"vr": "OB", "BinaryLength": 183288},
        "3127": {"vr": "OB", "BinaryLength": 183288},
        "3128": {"vr": "OB", "BinaryLength": 183288},
        "3129": {"vr": "OB", "BinaryLength": 183288},
        "3130": {"vr": "OB", "BinaryLength": 183288},
        "3131": {"vr": "OB", "BinaryLength": 183288},
        "3132": {"vr": "OB", "BinaryLength": 183288},
        "3133": {"vr": "OB", "BinaryLength": 183288},
        "3134": {"vr": "OB", "BinaryLength": 183288},
        "3135": {"vr": "OB", "BinaryLength": 183288},
        "3136": {"vr": "OB", "BinaryLength": 183288},
        "3137": {"vr": "OB", "BinaryLength": 183288},
        "3138": {"vr": "OB", "BinaryLength": 183288},
        "3139": {"vr": "OB", "BinaryLength": 183288},
        "3140": {"vr": "OB", "BinaryLength": 183288},
        "3141": {"vr": "OB", "BinaryLength": 183288},
        "3142": {"vr": "OB", "BinaryLength": 183288},
        "3143": {"vr": "OB", "BinaryLength": 183288},
        "3144": {"vr": "OB", "BinaryLength": 183288},
        "3145": {"vr": "OB", "BinaryLength": 183288},
        "3146": {"vr": "OB", "BinaryLength": 183288},
        "3147": {"vr": "OB", "BinaryLength": 183288},
        "3148": {"vr": "OB", "BinaryLength": 183288},
        "3149": {"vr": "OB", "BinaryLength": 183288},
        "3150": {"vr": "OB", "BinaryLength": 183288},
        "3151": {"vr": "OB", "BinaryLength": 183288},
        "3152": {"vr": "OB", "BinaryLength": 183288},
        "3153": {"vr": "OB", "BinaryLength": 183288},
        "3154": {"vr": "OB", "BinaryLength": 183288},
        "3155": {"vr": "OB", "BinaryLength": 183288},
        "3156": {"vr": "OB", "BinaryLength": 183288},
        "3157": {"vr": "OB", "BinaryLength": 183288},
        "3158": {"vr": "OB", "BinaryLength": 183288},
        "3159": {"vr": "OB", "BinaryLength": 183288},
        "3160": {"vr": "OB", "BinaryLength": 183288},
        "3161": {"vr": "OB", "BinaryLength": 183288},
        "3162": {"vr": "OB", "BinaryLength": 183288},
        "3163": {"vr": "OB", "BinaryLength": 183288},
        "3164": {"vr": "OB", "BinaryLength": 183288},
        "3165": {"vr": "OB", "BinaryLength": 183288},
        "3166": {"vr": "OB", "BinaryLength": 183288},
        "3167": {"vr": "OB", "BinaryLength": 183288},
        "3168": {"vr": "OB", "BinaryLength": 183288},
        "3169": {"vr": "OB", "BinaryLength": 183288},
        "3170": {"vr": "OB", "BinaryLength": 183288},
        "3171": {"vr": "OB", "BinaryLength": 183288},
        "3172": {"vr": "OB", "BinaryLength": 183288},
        "3173": {"vr": "OB", "BinaryLength": 183288},
        "3174": {"vr": "OB", "BinaryLength": 183288},
        "3175": {"vr": "OB", "BinaryLength": 183288},
        "3176": {"vr": "OB", "BinaryLength": 183288},
        "3177": {"vr": "OB", "BinaryLength": 183288},
        "3178": {"vr": "OB", "BinaryLength": 183288},
        "3179": {"vr": "OB", "BinaryLength": 183288},
        "3180": {"vr": "OB", "BinaryLength": 183288},
        "3181": {"vr": "OB", "BinaryLength": 183288},
        "3182": {"vr": "OB", "BinaryLength": 183288},
        "3183": {"vr": "OB", "BinaryLength": 183288},
        "3184": {"vr": "OB", "BinaryLength": 183288},
        "3185": {"vr": "OB", "BinaryLength": 183288},
        "3186": {"vr": "OB", "BinaryLength": 183288},
        "3187": {"vr": "OB", "BinaryLength": 183288},
        "3188": {"vr": "OB", "BinaryLength": 183288},
        "3189": {"vr": "OB", "BinaryLength": 183288},
        "3190": {"vr": "OB", "BinaryLength": 183288},
        "3191": {"vr": "OB", "BinaryLength": 183288},
        "3192": {"vr": "OB", "BinaryLength": 183288},
        "3193": {"vr": "OB", "BinaryLength": 183288},
        "3194": {"vr": "OB", "BinaryLength": 183288},
        "3195": {"vr": "OB", "BinaryLength": 183288},
        "3196": {"vr": "OB", "BinaryLength": 183288},
        "3197": {"vr": "OB", "BinaryLength": 183288},
        "3198": {"vr": "OB", "BinaryLength": 183288},
        "3199": {"vr": "OB", "BinaryLength": 183288},
        "3200": {"vr": "OB", "BinaryLength": 183288},
        "3201": {"vr": "OB", "BinaryLength": 183288},
        "3202": {"vr": "OB", "BinaryLength": 183288},
        "3203": {"vr": "OB", "BinaryLength": 183288},
        "3204": {"vr": "OB", "BinaryLength": 183288},
        "3205": {"vr": "OB", "BinaryLength": 183288},
        "3206": {"vr": "OB", "BinaryLength": 183288},
        "3207": {"vr": "OB", "BinaryLength": 183288},
        "3208": {"vr": "OB", "BinaryLength": 183288},
        "3209": {"vr": "OB", "BinaryLength": 183288},
        "3210": {"vr": "OB", "BinaryLength": 183288},
        "3211": {"vr": "OB", "BinaryLength": 183288},
        "3212": {"vr": "OB", "BinaryLength": 183288},
        "3213": {"vr": "OB", "BinaryLength": 183288},
        "3214": {"vr": "OB", "BinaryLength": 183288},
        "3215": {"vr": "OB", "BinaryLength": 183288},
        "3216": {"vr": "OB", "BinaryLength": 183288},
        "3217": {"vr": "OB", "BinaryLength": 183288},
        "3218": {"vr": "OB", "BinaryLength": 183288},
        "3219": {"vr": "OB", "BinaryLength": 183288},
        "3220": {"vr": "OB", "BinaryLength": 183288},
        "3221": {"vr": "OB", "BinaryLength": 183288},
        "3222": {"vr": "OB", "BinaryLength": 183288},
        "3223": {"vr": "OB", "BinaryLength": 183288},
        "3224": {"vr": "OB", "BinaryLength": 183288},
        "3225": {"vr": "OB", "BinaryLength": 183288},
        "3226": {"vr": "OB", "BinaryLength": 183288},
        "3227": {"vr": "OB", "BinaryLength": 183288},
        "3228": {"vr": "OB", "BinaryLength": 183288},
        "3229": {"vr": "OB", "BinaryLength": 183288},
        "3230": {"vr": "OB", "BinaryLength": 183288},
        "3231": {"vr": "OB", "BinaryLength": 183288},
        "3232": {"vr": "OB", "BinaryLength": 183288},
        "3233": {"vr": "OB", "BinaryLength": 183288},
        "3234": {"vr": "OB", "BinaryLength": 183288},
        "3235": {"vr": "OB", "BinaryLength": 183288},
        "3236": {"vr": "OB", "BinaryLength": 183288},
        "3237": {"vr": "OB", "BinaryLength": 183288},
        "3238": {"vr": "OB", "BinaryLength": 183288},
        "3239": {"vr": "OB", "BinaryLength": 183288},
        "3240": {"vr": "OB", "BinaryLength": 183288},
        "3241": {"vr": "OB", "BinaryLength": 183288},
        "3242": {"vr": "OB", "BinaryLength": 183288},
        "3243": {"vr": "OB", "BinaryLength": 183288},
        "3244": {"vr": "OB", "BinaryLength": 183288},
        "3245": {"vr": "OB", "BinaryLength": 183288},
        "3246": {"vr": "OB", "BinaryLength": 183288},
        "3247": {"vr": "OB", "BinaryLength": 183288},
        "3248": {"vr": "OB", "BinaryLength": 183288},
        "3249": {"vr": "OB", "BinaryLength": 183288},
        "3250": {"vr": "OB", "BinaryLength": 183288},
        "3251": {"vr": "OB", "BinaryLength": 183288},
        "3252": {"vr": "OB", "BinaryLength": 183288},
        "3253": {"vr": "OB", "BinaryLength": 183288},
        "3254": {"vr": "OB", "BinaryLength": 183288},
        "3255": {"vr": "OB", "BinaryLength": 183288},
        "3256": {"vr": "OB", "BinaryLength": 183288},
        "3257": {"vr": "OB", "BinaryLength": 183288},
        "3258": {"vr": "OB", "BinaryLength": 183288},
        "3259": {"vr": "OB", "BinaryLength": 183288},
        "3260": {"vr": "OB", "BinaryLength": 183288},
        "3261": {"vr": "OB", "BinaryLength": 183288},
        "3262": {"vr": "OB", "BinaryLength": 183288},
        "3263": {"vr": "OB", "BinaryLength": 183288},
        "3264": {"vr": "OB", "BinaryLength": 183288},
        "3265": {"vr": "OB", "BinaryLength": 183288},
        "3266": {"vr": "OB", "BinaryLength": 183288},
        "3267": {"vr": "OB", "BinaryLength": 183288},
        "3268": {"vr": "OB", "BinaryLength": 183288},
        "3269": {"vr": "OB", "BinaryLength": 183288},
        "3270": {"vr": "OB", "BinaryLength": 183288},
        "3271": {"vr": "OB", "BinaryLength": 183288},
        "3272": {"vr": "OB", "BinaryLength": 183288},
        "3273": {"vr": "OB", "BinaryLength": 183288},
        "3274": {"vr": "OB", "BinaryLength": 183288},
        "3275": {"vr": "OB", "BinaryLength": 183288},
        "3276": {"vr": "OB", "BinaryLength": 183288},
        "3277": {"vr": "OB", "BinaryLength": 183288},
        "3278": {"vr": "OB", "BinaryLength": 183288},
        "3279": {"vr": "OB", "BinaryLength": 183288},
        "3280": {"vr": "OB", "BinaryLength": 183288},
        "3281": {"vr": "OB", "BinaryLength": 183288},
        "3282": {"vr": "OB", "BinaryLength": 183288},
        "3283": {"vr": "OB", "BinaryLength": 183288},
        "3284": {"vr": "OB", "BinaryLength": 183288},
        "3285": {"vr": "OB", "BinaryLength": 183288},
        "3286": {"vr": "OB", "BinaryLength": 183288},
        "3287": {"vr": "OB", "BinaryLength": 183288},
        "3288": {"vr": "OB", "BinaryLength": 183288},
        "3289": {"vr": "OB", "BinaryLength": 183288},
        "3290": {"vr": "OB", "BinaryLength": 183288},
        "3291": {"vr": "OB", "BinaryLength": 183288},
        "3292": {"vr": "OB", "BinaryLength": 183288},
        "3293": {"vr": "OB", "BinaryLength": 183288},
        "3294": {"vr": "OB", "BinaryLength": 183288},
        "3295": {"vr": "OB", "BinaryLength": 183288},
        "3296": {"vr": "OB", "BinaryLength": 183288},
        "3297": {"vr": "OB", "BinaryLength": 183288},
        "3298": {"vr": "OB", "BinaryLength": 183288},
        "3299": {"vr": "OB", "BinaryLength": 183288},
        "3300": {"vr": "OB", "BinaryLength": 183288},
        "3301": {"vr": "OB", "BinaryLength": 183288},
        "3302": {"vr": "OB", "BinaryLength": 183288},
        "3303": {"vr": "OB", "BinaryLength": 183288},
        "3304": {"vr": "OB", "BinaryLength": 183288},
        "3305": {"vr": "OB", "BinaryLength": 183288},
        "3306": {"vr": "OB", "BinaryLength": 183288},
        "3307": {"vr": "OB", "BinaryLength": 183288},
        "3308": {"vr": "OB", "BinaryLength": 183288},
        "3309": {"vr": "OB", "BinaryLength": 183288},
        "3310": {"vr": "OB", "BinaryLength": 183288},
        "3311": {"vr": "OB", "BinaryLength": 183288},
        "3312": {"vr": "OB", "BinaryLength": 183288},
        "3313": {"vr": "OB", "BinaryLength": 183288},
        "3314": {"vr": "OB", "BinaryLength": 183288},
        "3315": {"vr": "OB", "BinaryLength": 183288},
        "3316": {"vr": "OB", "BinaryLength": 183288},
        "3317": {"vr": "OB", "BinaryLength": 183288},
        "3318": {"vr": "OB", "BinaryLength": 183288},
        "3319": {"vr": "OB", "BinaryLength": 183288},
        "3320": {"vr": "OB", "BinaryLength": 183288},
        "3321": {"vr": "OB", "BinaryLength": 183288},
        "3322": {"vr": "OB", "BinaryLength": 183288},
        "3323": {"vr": "OB", "BinaryLength": 183288},
        "3324": {"vr": "OB", "BinaryLength": 183288},
        "3325": {"vr": "OB", "BinaryLength": 183288},
        "3326": {"vr": "OB", "BinaryLength": 183288},
        "3327": {"vr": "OB", "BinaryLength": 183288},
        "3328": {"vr": "OB", "BinaryLength": 183288},
        "3329": {"vr": "OB", "BinaryLength": 183288},
        "3330": {"vr": "OB", "BinaryLength": 183288},
        "3331": {"vr": "OB", "BinaryLength": 183288},
        "3332": {"vr": "OB", "BinaryLength": 183288},
        "3333": {"vr": "OB", "BinaryLength": 183288},
        "3334": {"vr": "OB", "BinaryLength": 183288},
        "3335": {"vr": "OB", "BinaryLength": 183288},
        "3336": {"vr": "OB", "BinaryLength": 183288},
        "3337": {"vr": "OB", "BinaryLength": 183288},
        "3338": {"vr": "OB", "BinaryLength": 183288},
        "3339": {"vr": "OB", "BinaryLength": 183288},
        "3340": {"vr": "OB", "BinaryLength": 183288},
        "3341": {"vr": "OB", "BinaryLength": 183288},
        "3342": {"vr": "OB", "BinaryLength": 183288},
        "3343": {"vr": "OB", "BinaryLength": 183288},
        "3344": {"vr": "OB", "BinaryLength": 183288},
        "3345": {"vr": "OB", "BinaryLength": 183288},
        "3346": {"vr": "OB", "BinaryLength": 183288},
        "3347": {"vr": "OB", "BinaryLength": 183288},
        "3348": {"vr": "OB", "BinaryLength": 183288},
        "3349": {"vr": "OB", "BinaryLength": 183288},
        "3350": {"vr": "OB", "BinaryLength": 183288},
        "3351": {"vr": "OB", "BinaryLength": 183288},
        "3352": {"vr": "OB", "BinaryLength": 183288},
        "3353": {"vr": "OB", "BinaryLength": 183288},
        "3354": {"vr": "OB", "BinaryLength": 183288},
        "3355": {"vr": "OB", "BinaryLength": 183288},
        "3356": {"vr": "OB", "BinaryLength": 183288},
        "3357": {"vr": "OB", "BinaryLength": 183288},
        "3358": {"vr": "OB", "BinaryLength": 183288},
        "3359": {"vr": "OB", "BinaryLength": 183288},
        "3360": {"vr": "OB", "BinaryLength": 183288},
        "3361": {"vr": "OB", "BinaryLength": 183288},
        "3362": {"vr": "OB", "BinaryLength": 183288},
        "3363": {"vr": "OB", "BinaryLength": 183288},
        "3364": {"vr": "OB", "BinaryLength": 183288},
        "3365": {"vr": "OB", "BinaryLength": 183288},
        "3366": {"vr": "OB", "BinaryLength": 183288},
        "3367": {"vr": "OB", "BinaryLength": 183288},
        "3368": {"vr": "OB", "BinaryLength": 183288},
        "3369": {"vr": "OB", "BinaryLength": 183288},
        "3370": {"vr": "OB", "BinaryLength": 183288},
        "3371": {"vr": "OB", "BinaryLength": 183288},
        "3372": {"vr": "OB", "BinaryLength": 183288},
        "3373": {"vr": "OB", "BinaryLength": 183288},
        "3374": {"vr": "OB", "BinaryLength": 183288},
        "3375": {"vr": "OB", "BinaryLength": 183288},
        "3376": {"vr": "OB", "BinaryLength": 183288},
        "3377": {"vr": "OB", "BinaryLength": 183288},
        "3378": {"vr": "OB", "BinaryLength": 183288},
        "3379": {"vr": "OB", "BinaryLength": 183288},
        "3380": {"vr": "OB", "BinaryLength": 183288},
        "3381": {"vr": "OB", "BinaryLength": 183288},
        "3382": {"vr": "OB", "BinaryLength": 183288},
        "3383": {"vr": "OB", "BinaryLength": 183288},
        "3384": {"vr": "OB", "BinaryLength": 183288},
        "3385": {"vr": "OB", "BinaryLength": 183288},
        "3386": {"vr": "OB", "BinaryLength": 183288},
        "3387": {"vr": "OB", "BinaryLength": 183288},
        "3388": {"vr": "OB", "BinaryLength": 183288},
        "3389": {"vr": "OB", "BinaryLength": 183288},
        "3390": {"vr": "OB", "BinaryLength": 183288},
        "3391": {"vr": "OB", "BinaryLength": 183288},
        "3392": {"vr": "OB", "BinaryLength": 183288},
        "3393": {"vr": "OB", "BinaryLength": 183288},
        "3394": {"vr": "OB", "BinaryLength": 183288},
        "3395": {"vr": "OB", "BinaryLength": 183288},
        "3396": {"vr": "OB", "BinaryLength": 183288},
        "3397": {"vr": "OB", "BinaryLength": 183288},
        "3398": {"vr": "OB", "BinaryLength": 183288},
        "3399": {"vr": "OB", "BinaryLength": 183288},
        "3400": {"vr": "OB", "BinaryLength": 183288},
        "3401": {"vr": "OB", "BinaryLength": 183288},
        "3402": {"vr": "OB", "BinaryLength": 183288},
        "3403": {"vr": "OB", "BinaryLength": 183288},
        "3404": {"vr": "OB", "BinaryLength": 183288},
        "3405": {"vr": "OB", "BinaryLength": 183288},
        "3406": {"vr": "OB", "BinaryLength": 183288},
        "3407": {"vr": "OB", "BinaryLength": 183288},
        "3408": {"vr": "OB", "BinaryLength": 183288},
        "3409": {"vr": "OB", "BinaryLength": 183288},
        "3410": {"vr": "OB", "BinaryLength": 183288},
        "3411": {"vr": "OB", "BinaryLength": 183288},
        "3412": {"vr": "OB", "BinaryLength": 183288},
        "3413": {"vr": "OB", "BinaryLength": 183288},
        "3414": {"vr": "OB", "BinaryLength": 183288},
        "3415": {"vr": "OB", "BinaryLength": 183288},
        "3416": {"vr": "OB", "BinaryLength": 183288},
        "3417": {"vr": "OB", "BinaryLength": 183288},
        "3418": {"vr": "OB", "BinaryLength": 183288},
        "3419": {"vr": "OB", "BinaryLength": 183288},
        "3420": {"vr": "OB", "BinaryLength": 183288},
        "3421": {"vr": "OB", "BinaryLength": 183288},
        "3422": {"vr": "OB", "BinaryLength": 183288},
        "3423": {"vr": "OB", "BinaryLength": 183288},
        "3424": {"vr": "OB", "BinaryLength": 183288},
        "3425": {"vr": "OB", "BinaryLength": 183288},
        "3426": {"vr": "OB", "BinaryLength": 183288},
        "3427": {"vr": "OB", "BinaryLength": 183288},
        "3428": {"vr": "OB", "BinaryLength": 183288},
        "3429": {"vr": "OB", "BinaryLength": 183288},
        "3430": {"vr": "OB", "BinaryLength": 183288},
        "3431": {"vr": "OB", "BinaryLength": 183288},
        "3432": {"vr": "OB", "BinaryLength": 183288},
        "3433": {"vr": "OB", "BinaryLength": 183288},
        "3434": {"vr": "OB", "BinaryLength": 183288},
        "3435": {"vr": "OB", "BinaryLength": 183288},
        "3436": {"vr": "OB", "BinaryLength": 183288},
        "3437": {"vr": "OB", "BinaryLength": 183288},
        "3438": {"vr": "OB", "BinaryLength": 183288},
        "3439": {"vr": "OB", "BinaryLength": 183288},
        "3440": {"vr": "OB", "BinaryLength": 183288},
        "3441": {"vr": "OB", "BinaryLength": 183288},
        "3442": {"vr": "OB", "BinaryLength": 183288},
        "3443": {"vr": "OB", "BinaryLength": 183288},
        "3444": {"vr": "OB", "BinaryLength": 183288},
        "3445": {"vr": "OB", "BinaryLength": 183288},
        "3446": {"vr": "OB", "BinaryLength": 183288},
        "3447": {"vr": "OB", "BinaryLength": 183288},
        "3448": {"vr": "OB", "BinaryLength": 183288},
        "3449": {"vr": "OB", "BinaryLength": 183288},
        "3450": {"vr": "OB", "BinaryLength": 183288},
        "3451": {"vr": "OB", "BinaryLength": 183288},
        "3452": {"vr": "OB", "BinaryLength": 183288},
        "3453": {"vr": "OB", "BinaryLength": 183288},
        "3454": {"vr": "OB", "BinaryLength": 183288},
        "3455": {"vr": "OB", "BinaryLength": 183288},
        "3456": {"vr": "OB", "BinaryLength": 183288},
        "3457": {"vr": "OB", "BinaryLength": 183288},
        "3458": {"vr": "OB", "BinaryLength": 183288},
        "3459": {"vr": "OB", "BinaryLength": 183288},
        "3460": {"vr": "OB", "BinaryLength": 183288},
        "3461": {"vr": "OB", "BinaryLength": 183288},
        "3462": {"vr": "OB", "BinaryLength": 183288},
        "3463": {"vr": "OB", "BinaryLength": 183288},
        "3464": {"vr": "OB", "BinaryLength": 183288},
        "3465": {"vr": "OB", "BinaryLength": 183288},
        "3466": {"vr": "OB", "BinaryLength": 183288},
        "3467": {"vr": "OB", "BinaryLength": 183288},
        "3468": {"vr": "OB", "BinaryLength": 183288},
        "3469": {"vr": "OB", "BinaryLength": 183288},
        "3470": {"vr": "OB", "BinaryLength": 183288},
        "3471": {"vr": "OB", "BinaryLength": 183288},
        "3472": {"vr": "OB", "BinaryLength": 183288},
        "3473": {"vr": "OB", "BinaryLength": 183288},
        "3474": {"vr": "OB", "BinaryLength": 183288},
        "3475": {"vr": "OB", "BinaryLength": 183288},
        "3476": {"vr": "OB", "BinaryLength": 183288},
        "3477": {"vr": "OB", "BinaryLength": 183288},
        "3478": {"vr": "OB", "BinaryLength": 183288},
        "3479": {"vr": "OB", "BinaryLength": 183288},
        "3480": {"vr": "OB", "BinaryLength": 183288},
        "3481": {"vr": "OB", "BinaryLength": 183288},
        "3482": {"vr": "OB", "BinaryLength": 183288},
        "3483": {"vr": "OB", "BinaryLength": 183288},
        "3484": {"vr": "OB", "BinaryLength": 183288},
        "3485": {"vr": "OB", "BinaryLength": 183288},
        "3486": {"vr": "OB", "BinaryLength": 183288},
        "3487": {"vr": "OB", "BinaryLength": 183288},
        "3488": {"vr": "OB", "BinaryLength": 183288},
        "3489": {"vr": "OB", "BinaryLength": 183288},
        "3490": {"vr": "OB", "BinaryLength": 183288},
        "3491": {"vr": "OB", "BinaryLength": 183288},
        "3492": {"vr": "OB", "BinaryLength": 183288},
        "3493": {"vr": "OB", "BinaryLength": 183288},
        "3494": {"vr": "OB", "BinaryLength": 183288},
        "3495": {"vr": "OB", "BinaryLength": 183288},
        "3496": {"vr": "OB", "BinaryLength": 183288},
        "3497": {"vr": "OB", "BinaryLength": 183288},
        "3498": {"vr": "OB", "BinaryLength": 183288},
        "3499": {"vr": "OB", "BinaryLength": 183288},
        "3500": {"vr": "OB", "BinaryLength": 183288},
        "3501": {"vr": "OB", "BinaryLength": 183288},
        "3502": {"vr": "OB", "BinaryLength": 183288},
        "3503": {"vr": "OB", "BinaryLength": 183288},
        "3504": {"vr": "OB", "BinaryLength": 183288},
        "3505": {"vr": "OB", "BinaryLength": 183288},
        "3506": {"vr": "OB", "BinaryLength": 183288},
        "3507": {"vr": "OB", "BinaryLength": 183288},
        "3508": {"vr": "OB", "BinaryLength": 183288},
        "3509": {"vr": "OB", "BinaryLength": 183288},
        "3510": {"vr": "OB", "BinaryLength": 183288},
        "3511": {"vr": "OB", "BinaryLength": 183288},
        "3512": {"vr": "OB", "BinaryLength": 183288},
        "3513": {"vr": "OB", "BinaryLength": 183288},
        "3514": {"vr": "OB", "BinaryLength": 183288},
        "3515": {"vr": "OB", "BinaryLength": 183288},
        "3516": {"vr": "OB", "BinaryLength": 183288},
        "3517": {"vr": "OB", "BinaryLength": 183288},
        "3518": {"vr": "OB", "BinaryLength": 183288},
        "3519": {"vr": "OB", "BinaryLength": 183288},
        "3520": {"vr": "OB", "BinaryLength": 183288},
        "3521": {"vr": "OB", "BinaryLength": 183288},
        "3522": {"vr": "OB", "BinaryLength": 183288},
        "3523": {"vr": "OB", "BinaryLength": 183288},
        "3524": {"vr": "OB", "BinaryLength": 183288},
        "3525": {"vr": "OB", "BinaryLength": 183288},
        "3526": {"vr": "OB", "BinaryLength": 183288},
        "3527": {"vr": "OB", "BinaryLength": 183288},
        "3528": {"vr": "OB", "BinaryLength": 183288},
        "3529": {"vr": "OB", "BinaryLength": 183288},
        "3530": {"vr": "OB", "BinaryLength": 183288},
        "3531": {"vr": "OB", "BinaryLength": 183288},
        "3532": {"vr": "OB", "BinaryLength": 183288},
        "3533": {"vr": "OB", "BinaryLength": 183288},
        "3534": {"vr": "OB", "BinaryLength": 183288},
        "3535": {"vr": "OB", "BinaryLength": 183288},
        "3536": {"vr": "OB", "BinaryLength": 183288},
        "3537": {"vr": "OB", "BinaryLength": 183288},
        "3538": {"vr": "OB", "BinaryLength": 183288},
        "3539": {"vr": "OB", "BinaryLength": 183288},
        "3540": {"vr": "OB", "BinaryLength": 183288},
        "3541": {"vr": "OB", "BinaryLength": 183288},
        "3542": {"vr": "OB", "BinaryLength": 183288},
        "3543": {"vr": "OB", "BinaryLength": 183288},
        "3544": {"vr": "OB", "BinaryLength": 183288},
        "3545": {"vr": "OB", "BinaryLength": 183288},
        "3546": {"vr": "OB", "BinaryLength": 183288},
        "3547": {"vr": "OB", "BinaryLength": 183288},
        "3548": {"vr": "OB", "BinaryLength": 183288},
        "3549": {"vr": "OB", "BinaryLength": 183288},
        "3550": {"vr": "OB", "BinaryLength": 183288},
        "3551": {"vr": "OB", "BinaryLength": 183288},
        "3552": {"vr": "OB", "BinaryLength": 183288},
        "3553": {"vr": "OB", "BinaryLength": 183288},
        "3554": {"vr": "OB", "BinaryLength": 183288},
        "3555": {"vr": "OB", "BinaryLength": 183288},
        "3556": {"vr": "OB", "BinaryLength": 183288},
        "3557": {"vr": "OB", "BinaryLength": 183288},
        "3558": {"vr": "OB", "BinaryLength": 183288},
        "3559": {"vr": "OB", "BinaryLength": 183288},
        "3560": {"vr": "OB", "BinaryLength": 183288},
        "3561": {"vr": "OB", "BinaryLength": 183288},
        "3562": {"vr": "OB", "BinaryLength": 183288},
        "3563": {"vr": "OB", "BinaryLength": 183288},
        "3564": {"vr": "OB", "BinaryLength": 183288},
        "3565": {"vr": "OB", "BinaryLength": 183288},
        "3566": {"vr": "OB", "BinaryLength": 183288},
        "3567": {"vr": "OB", "BinaryLength": 183288},
        "3568": {"vr": "OB", "BinaryLength": 183288},
        "3569": {"vr": "OB", "BinaryLength": 183288},
        "3570": {"vr": "OB", "BinaryLength": 183288},
        "3571": {"vr": "OB", "BinaryLength": 183288},
        "3572": {"vr": "OB", "BinaryLength": 183288},
        "3573": {"vr": "OB", "BinaryLength": 183288},
        "3574": {"vr": "OB", "BinaryLength": 183288},
        "3575": {"vr": "OB", "BinaryLength": 183288},
        "3576": {"vr": "OB", "BinaryLength": 183288},
        "3577": {"vr": "OB", "BinaryLength": 183288},
        "3578": {"vr": "OB", "BinaryLength": 183288},
        "3579": {"vr": "OB", "BinaryLength": 183288},
        "3580": {"vr": "OB", "BinaryLength": 183288},
        "3581": {"vr": "OB", "BinaryLength": 183288},
        "3582": {"vr": "OB", "BinaryLength": 183288},
        "3583": {"vr": "OB", "BinaryLength": 183288},
        "3584": {"vr": "OB", "BinaryLength": 183288},
        "3585": {"vr": "OB", "BinaryLength": 183288},
        "3586": {"vr": "OB", "BinaryLength": 183288},
        "3587": {"vr": "OB", "BinaryLength": 183288},
        "3588": {"vr": "OB", "BinaryLength": 183288},
        "3589": {"vr": "OB", "BinaryLength": 183288},
        "3590": {"vr": "OB", "BinaryLength": 183288},
        "3591": {"vr": "OB", "BinaryLength": 183288},
        "3592": {"vr": "OB", "BinaryLength": 183288},
        "3593": {"vr": "OB", "BinaryLength": 183288},
        "3594": {"vr": "OB", "BinaryLength": 183288},
        "3595": {"vr": "OB", "BinaryLength": 183288},
        "3596": {"vr": "OB", "BinaryLength": 183288},
        "3597": {"vr": "OB", "BinaryLength": 183288},
        "3598": {"vr": "OB", "BinaryLength": 183288},
        "3599": {"vr": "OB", "BinaryLength": 183288},
        "3600": {"vr": "OB", "BinaryLength": 183288},
        "3601": {"vr": "OB", "BinaryLength": 183288},
        "3602": {"vr": "OB", "BinaryLength": 183288},
        "3603": {"vr": "OB", "BinaryLength": 183288},
        "3604": {"vr": "OB", "BinaryLength": 183288},
        "3605": {"vr": "OB", "BinaryLength": 183288},
        "3606": {"vr": "OB", "BinaryLength": 183288},
        "3607": {"vr": "OB", "BinaryLength": 183288},
        "3608": {"vr": "OB", "BinaryLength": 183288},
        "3609": {"vr": "OB", "BinaryLength": 183288},
        "3610": {"vr": "OB", "BinaryLength": 183288},
        "3611": {"vr": "OB", "BinaryLength": 183288},
        "3612": {"vr": "OB", "BinaryLength": 183288},
        "3613": {"vr": "OB", "BinaryLength": 183288},
        "3614": {"vr": "OB", "BinaryLength": 183288},
        "3615": {"vr": "OB", "BinaryLength": 183288},
        "3616": {"vr": "OB", "BinaryLength": 183288},
        "3617": {"vr": "OB", "BinaryLength": 183288},
        "3618": {"vr": "OB", "BinaryLength": 183288},
        "3619": {"vr": "OB", "BinaryLength": 183288},
        "3620": {"vr": "OB", "BinaryLength": 183288},
        "3621": {"vr": "OB", "BinaryLength": 183288},
        "3622": {"vr": "OB", "BinaryLength": 183288},
        "3623": {"vr": "OB", "BinaryLength": 183288},
        "3624": {"vr": "OB", "BinaryLength": 183288},
        "3625": {"vr": "OB", "BinaryLength": 183288},
        "3626": {"vr": "OB", "BinaryLength": 183288},
        "3627": {"vr": "OB", "BinaryLength": 183288},
        "3628": {"vr": "OB", "BinaryLength": 183288},
        "3629": {"vr": "OB", "BinaryLength": 183288},
        "3630": {"vr": "OB", "BinaryLength": 183288},
        "3631": {"vr": "OB", "BinaryLength": 183288},
        "3632": {"vr": "OB", "BinaryLength": 183288},
        "3633": {"vr": "OB", "BinaryLength": 183288},
        "3634": {"vr": "OB", "BinaryLength": 183288},
        "3635": {"vr": "OB", "BinaryLength": 183288},
        "3636": {"vr": "OB", "BinaryLength": 183288},
        "3637": {"vr": "OB", "BinaryLength": 183288},
        "3638": {"vr": "OB", "BinaryLength": 183288},
        "3639": {"vr": "OB", "BinaryLength": 183288},
        "3640": {"vr": "OB", "BinaryLength": 183288},
        "3641": {"vr": "OB", "BinaryLength": 183288},
        "3642": {"vr": "OB", "BinaryLength": 183288},
        "3643": {"vr": "OB", "BinaryLength": 183288},
        "3644": {"vr": "OB", "BinaryLength": 183288},
        "3645": {"vr": "OB", "BinaryLength": 183288},
        "3646": {"vr": "OB", "BinaryLength": 183288},
        "3647": {"vr": "OB", "BinaryLength": 183288},
        "3648": {"vr": "OB", "BinaryLength": 183288},
        "3649": {"vr": "OB", "BinaryLength": 183288},
        "3650": {"vr": "OB", "BinaryLength": 183288},
        "3651": {"vr": "OB", "BinaryLength": 183288},
        "3652": {"vr": "OB", "BinaryLength": 183288},
        "3653": {"vr": "OB", "BinaryLength": 183288},
        "3654": {"vr": "OB", "BinaryLength": 183288},
        "3655": {"vr": "OB", "BinaryLength": 183288},
        "3656": {"vr": "OB", "BinaryLength": 183288},
        "3657": {"vr": "OB", "BinaryLength": 183288},
        "3658": {"vr": "OB", "BinaryLength": 183288},
        "3659": {"vr": "OB", "BinaryLength": 183288},
        "3660": {"vr": "OB", "BinaryLength": 183288},
        "3661": {"vr": "OB", "BinaryLength": 183288},
        "3662": {"vr": "OB", "BinaryLength": 183288},
        "3663": {"vr": "OB", "BinaryLength": 183288},
        "3664": {"vr": "OB", "BinaryLength": 183288},
        "3665": {"vr": "OB", "BinaryLength": 183288},
        "3666": {"vr": "OB", "BinaryLength": 183288},
        "3667": {"vr": "OB", "BinaryLength": 183288},
        "3668": {"vr": "OB", "BinaryLength": 183288},
        "3669": {"vr": "OB", "BinaryLength": 183288},
        "3670": {"vr": "OB", "BinaryLength": 183288},
        "3671": {"vr": "OB", "BinaryLength": 183288},
        "3672": {"vr": "OB", "BinaryLength": 183288},
        "3673": {"vr": "OB", "BinaryLength": 183288},
        "3674": {"vr": "OB", "BinaryLength": 183288},
        "3675": {"vr": "OB", "BinaryLength": 183288},
        "3676": {"vr": "OB", "BinaryLength": 183288},
        "3677": {"vr": "OB", "BinaryLength": 183288},
        "3678": {"vr": "OB", "BinaryLength": 183288},
        "3679": {"vr": "OB", "BinaryLength": 183288},
        "3680": {"vr": "OB", "BinaryLength": 183288},
        "3681": {"vr": "OB", "BinaryLength": 183288},
        "3682": {"vr": "OB", "BinaryLength": 183288},
        "3683": {"vr": "OB", "BinaryLength": 183288},
        "3684": {"vr": "OB", "BinaryLength": 183288},
        "3685": {"vr": "OB", "BinaryLength": 183288},
        "3686": {"vr": "OB", "BinaryLength": 183288},
        "3687": {"vr": "OB", "BinaryLength": 183288},
        "3688": {"vr": "OB", "BinaryLength": 183288},
        "3689": {"vr": "OB", "BinaryLength": 183288},
        "3690": {"vr": "OB", "BinaryLength": 183288},
        "3691": {"vr": "OB", "BinaryLength": 183288},
        "3692": {"vr": "OB", "BinaryLength": 183288},
        "3693": {"vr": "OB", "BinaryLength": 183288},
        "3694": {"vr": "OB", "BinaryLength": 183288},
        "3695": {"vr": "OB", "BinaryLength": 183288},
        "3696": {"vr": "OB", "BinaryLength": 183288},
        "3697": {"vr": "OB", "BinaryLength": 183288},
        "3698": {"vr": "OB", "BinaryLength": 183288},
        "3699": {"vr": "OB", "BinaryLength": 183288},
        "3700": {"vr": "OB", "BinaryLength": 183288},
        "3701": {"vr": "OB", "BinaryLength": 183288},
        "3702": {"vr": "OB", "BinaryLength": 183288},
        "3703": {"vr": "OB", "BinaryLength": 183288},
        "3704": {"vr": "OB", "BinaryLength": 183288},
        "3705": {"vr": "OB", "BinaryLength": 183288},
        "3706": {"vr": "OB", "BinaryLength": 183288},
        "3707": {"vr": "OB", "BinaryLength": 183288},
        "3708": {"vr": "OB", "BinaryLength": 183288},
        "3709": {"vr": "OB", "BinaryLength": 183288},
        "3710": {"vr": "OB", "BinaryLength": 183288},
        "3711": {"vr": "OB", "BinaryLength": 183288},
        "3712": {"vr": "OB", "BinaryLength": 183288},
        "3713": {"vr": "OB", "BinaryLength": 183288},
        "3714": {"vr": "OB", "BinaryLength": 183288},
        "3715": {"vr": "OB", "BinaryLength": 183288},
        "3716": {"vr": "OB", "BinaryLength": 183288},
        "3717": {"vr": "OB", "BinaryLength": 183288},
        "3718": {"vr": "OB", "BinaryLength": 183288},
        "3719": {"vr": "OB", "BinaryLength": 183288},
        "3720": {"vr": "OB", "BinaryLength": 183288},
        "3721": {"vr": "OB", "BinaryLength": 183288},
        "3722": {"vr": "OB", "BinaryLength": 183288},
        "3723": {"vr": "OB", "BinaryLength": 183288},
        "3724": {"vr": "OB", "BinaryLength": 183288},
        "3725": {"vr": "OB", "BinaryLength": 183288},
        "3726": {"vr": "OB", "BinaryLength": 183288},
        "3727": {"vr": "OB", "BinaryLength": 183288},
        "3728": {"vr": "OB", "BinaryLength": 183288},
        "3729": {"vr": "OB", "BinaryLength": 183288},
        "3730": {"vr": "OB", "BinaryLength": 183288},
        "3731": {"vr": "OB", "BinaryLength": 183288},
        "3732": {"vr": "OB", "BinaryLength": 183288},
        "3733": {"vr": "OB", "BinaryLength": 183288},
        "3734": {"vr": "OB", "BinaryLength": 183288},
        "3735": {"vr": "OB", "BinaryLength": 183288},
        "3736": {"vr": "OB", "BinaryLength": 183288},
        "3737": {"vr": "OB", "BinaryLength": 183288},
        "3738": {"vr": "OB", "BinaryLength": 183288},
        "3739": {"vr": "OB", "BinaryLength": 183288},
        "3740": {"vr": "OB", "BinaryLength": 183288},
        "3741": {"vr": "OB", "BinaryLength": 183288},
        "3742": {"vr": "OB", "BinaryLength": 183288},
        "3743": {"vr": "OB", "BinaryLength": 183288},
        "3744": {"vr": "OB", "BinaryLength": 183288},
        "3745": {"vr": "OB", "BinaryLength": 183288},
        "3746": {"vr": "OB", "BinaryLength": 183288},
        "3747": {"vr": "OB", "BinaryLength": 183288},
        "3748": {"vr": "OB", "BinaryLength": 183288},
        "3749": {"vr": "OB", "BinaryLength": 183288},
        "3750": {"vr": "OB", "BinaryLength": 183288},
        "3751": {"vr": "OB", "BinaryLength": 183288},
        "3752": {"vr": "OB", "BinaryLength": 183288},
        "3753": {"vr": "OB", "BinaryLength": 183288},
        "3754": {"vr": "OB", "BinaryLength": 183288},
        "3755": {"vr": "OB", "BinaryLength": 183288},
        "3756": {"vr": "OB", "BinaryLength": 183288},
        "3757": {"vr": "OB", "BinaryLength": 183288},
        "3758": {"vr": "OB", "BinaryLength": 183288},
        "3759": {"vr": "OB", "BinaryLength": 183288},
        "3760": {"vr": "OB", "BinaryLength": 183288},
        "3761": {"vr": "OB", "BinaryLength": 183288},
        "3762": {"vr": "OB", "BinaryLength": 183288},
        "3763": {"vr": "OB", "BinaryLength": 183288},
        "3764": {"vr": "OB", "BinaryLength": 183288},
        "3765": {"vr": "OB", "BinaryLength": 183288},
        "3766": {"vr": "OB", "BinaryLength": 183288},
        "3767": {"vr": "OB", "BinaryLength": 183288},
        "3768": {"vr": "OB", "BinaryLength": 183288},
        "3769": {"vr": "OB", "BinaryLength": 183288},
        "3770": {"vr": "OB", "BinaryLength": 183288},
        "3771": {"vr": "OB", "BinaryLength": 183288},
        "3772": {"vr": "OB", "BinaryLength": 183288},
        "3773": {"vr": "OB", "BinaryLength": 183288},
        "3774": {"vr": "OB", "BinaryLength": 183288},
        "3775": {"vr": "OB", "BinaryLength": 183288},
        "3776": {"vr": "OB", "BinaryLength": 183288},
        "3777": {"vr": "OB", "BinaryLength": 183288},
        "3778": {"vr": "OB", "BinaryLength": 183288},
        "3779": {"vr": "OB", "BinaryLength": 183288},
        "3780": {"vr": "OB", "BinaryLength": 183288},
        "3781": {"vr": "OB", "BinaryLength": 183288},
        "3782": {"vr": "OB", "BinaryLength": 183288},
        "3783": {"vr": "OB", "BinaryLength": 183288},
        "3784": {"vr": "OB", "BinaryLength": 183288},
        "3785": {"vr": "OB", "BinaryLength": 183288},
        "3786": {"vr": "OB", "BinaryLength": 183288},
        "3787": {"vr": "OB", "BinaryLength": 183288},
        "3788": {"vr": "OB", "BinaryLength": 183288},
        "3789": {"vr": "OB", "BinaryLength": 183288},
        "3790": {"vr": "OB", "BinaryLength": 183288},
        "3791": {"vr": "OB", "BinaryLength": 183288},
        "3792": {"vr": "OB", "BinaryLength": 183288},
        "3793": {"vr": "OB", "BinaryLength": 183288},
        "3794": {"vr": "OB", "BinaryLength": 183288},
        "3795": {"vr": "OB", "BinaryLength": 183288},
        "3796": {"vr": "OB", "BinaryLength": 183288},
        "3797": {"vr": "OB", "BinaryLength": 183288},
        "3798": {"vr": "OB", "BinaryLength": 183288},
        "3799": {"vr": "OB", "BinaryLength": 183288},
        "3800": {"vr": "OB", "BinaryLength": 183288},
        "3801": {"vr": "OB", "BinaryLength": 183288},
        "3802": {"vr": "OB", "BinaryLength": 183288},
        "3803": {"vr": "OB", "BinaryLength": 183288},
        "3804": {"vr": "OB", "BinaryLength": 183288},
        "3805": {"vr": "OB", "BinaryLength": 183288},
        "3806": {"vr": "OB", "BinaryLength": 183288},
        "3807": {"vr": "OB", "BinaryLength": 183288},
        "3808": {"vr": "OB", "BinaryLength": 183288},
        "3809": {"vr": "OB", "BinaryLength": 183288},
        "3810": {"vr": "OB", "BinaryLength": 183288},
        "3811": {"vr": "OB", "BinaryLength": 183288},
        "3812": {"vr": "OB", "BinaryLength": 183288},
        "3813": {"vr": "OB", "BinaryLength": 183288},
        "3814": {"vr": "OB", "BinaryLength": 183288},
        "3815": {"vr": "OB", "BinaryLength": 183288},
        "3816": {"vr": "OB", "BinaryLength": 183288},
        "3817": {"vr": "OB", "BinaryLength": 183288},
        "3818": {"vr": "OB", "BinaryLength": 183288},
        "3819": {"vr": "OB", "BinaryLength": 183288},
        "3820": {"vr": "OB", "BinaryLength": 183288},
        "3821": {"vr": "OB", "BinaryLength": 183288},
        "3822": {"vr": "OB", "BinaryLength": 183288},
        "3823": {"vr": "OB", "BinaryLength": 183288},
        "3824": {"vr": "OB", "BinaryLength": 183288},
        "3825": {"vr": "OB", "BinaryLength": 183288},
        "3826": {"vr": "OB", "BinaryLength": 183288},
        "3827": {"vr": "OB", "BinaryLength": 183288},
        "3828": {"vr": "OB", "BinaryLength": 183288},
        "3829": {"vr": "OB", "BinaryLength": 183288},
        "3830": {"vr": "OB", "BinaryLength": 183288},
        "3831": {"vr": "OB", "BinaryLength": 183288},
        "3832": {"vr": "OB", "BinaryLength": 183288},
        "3833": {"vr": "OB", "BinaryLength": 183288},
        "3834": {"vr": "OB", "BinaryLength": 183288},
        "3835": {"vr": "OB", "BinaryLength": 183288},
        "3836": {"vr": "OB", "BinaryLength": 183288},
        "3837": {"vr": "OB", "BinaryLength": 183288},
        "3838": {"vr": "OB", "BinaryLength": 183288},
        "3839": {"vr": "OB", "BinaryLength": 183288},
        "3840": {"vr": "OB", "BinaryLength": 183288},
        "3841": {"vr": "OB", "BinaryLength": 183288},
        "3842": {"vr": "OB", "BinaryLength": 183288},
        "3843": {"vr": "OB", "BinaryLength": 183288},
        "3844": {"vr": "OB", "BinaryLength": 183288},
        "3845": {"vr": "OB", "BinaryLength": 183288},
        "3846": {"vr": "OB", "BinaryLength": 183288},
        "3847": {"vr": "OB", "BinaryLength": 183288},
        "3848": {"vr": "OB", "BinaryLength": 183288},
        "3849": {"vr": "OB", "BinaryLength": 183288},
        "3850": {"vr": "OB", "BinaryLength": 183288},
        "3851": {"vr": "OB", "BinaryLength": 183288},
        "3852": {"vr": "OB", "BinaryLength": 183288},
        "3853": {"vr": "OB", "BinaryLength": 183288},
        "3854": {"vr": "OB", "BinaryLength": 183288},
        "3855": {"vr": "OB", "BinaryLength": 183288},
        "3856": {"vr": "OB", "BinaryLength": 183288},
        "3857": {"vr": "OB", "BinaryLength": 183288},
        "3858": {"vr": "OB", "BinaryLength": 183288},
        "3859": {"vr": "OB", "BinaryLength": 183288},
        "3860": {"vr": "OB", "BinaryLength": 183288},
        "3861": {"vr": "OB", "BinaryLength": 183288},
        "3862": {"vr": "OB", "BinaryLength": 183288},
        "3863": {"vr": "OB", "BinaryLength": 183288},
        "3864": {"vr": "OB", "BinaryLength": 183288},
        "3865": {"vr": "OB", "BinaryLength": 183288},
        "3866": {"vr": "OB", "BinaryLength": 183288},
        "3867": {"vr": "OB", "BinaryLength": 183288},
        "3868": {"vr": "OB", "BinaryLength": 183288},
        "3869": {"vr": "OB", "BinaryLength": 183288},
        "3870": {"vr": "OB", "BinaryLength": 183288},
        "3871": {"vr": "OB", "BinaryLength": 183288},
        "3872": {"vr": "OB", "BinaryLength": 183288},
        "3873": {"vr": "OB", "BinaryLength": 183288},
        "3874": {"vr": "OB", "BinaryLength": 183288},
        "3875": {"vr": "OB", "BinaryLength": 183288},
        "3876": {"vr": "OB", "BinaryLength": 183288},
        "3877": {"vr": "OB", "BinaryLength": 183288},
        "3878": {"vr": "OB", "BinaryLength": 183288},
        "3879": {"vr": "OB", "BinaryLength": 183288},
        "3880": {"vr": "OB", "BinaryLength": 183288},
        "3881": {"vr": "OB", "BinaryLength": 183288},
        "3882": {"vr": "OB", "BinaryLength": 183288},
        "3883": {"vr": "OB", "BinaryLength": 183288},
        "3884": {"vr": "OB", "BinaryLength": 183288},
        "3885": {"vr": "OB", "BinaryLength": 183288},
        "3886": {"vr": "OB", "BinaryLength": 183288},
        "3887": {"vr": "OB", "BinaryLength": 183288},
        "3888": {"vr": "OB", "BinaryLength": 183288},
        "3889": {"vr": "OB", "BinaryLength": 183288},
        "3890": {"vr": "OB", "BinaryLength": 183288},
        "3891": {"vr": "OB", "BinaryLength": 183288},
        "3892": {"vr": "OB", "BinaryLength": 183288},
        "3893": {"vr": "OB", "BinaryLength": 183288},
        "3894": {"vr": "OB", "BinaryLength": 183288},
        "3895": {"vr": "OB", "BinaryLength": 183288},
        "3896": {"vr": "OB", "BinaryLength": 183288},
        "3897": {"vr": "OB", "BinaryLength": 183288},
        "3898": {"vr": "OB", "BinaryLength": 183288},
        "3899": {"vr": "OB", "BinaryLength": 183288},
        "3900": {"vr": "OB", "BinaryLength": 183288},
        "3901": {"vr": "OB", "BinaryLength": 183288},
        "3902": {"vr": "OB", "BinaryLength": 183288},
        "3903": {"vr": "OB", "BinaryLength": 183288},
        "3904": {"vr": "OB", "BinaryLength": 183288},
        "3905": {"vr": "OB", "BinaryLength": 183288},
        "3906": {"vr": "OB", "BinaryLength": 183288},
        "3907": {"vr": "OB", "BinaryLength": 183288},
        "3908": {"vr": "OB", "BinaryLength": 183288},
        "3909": {"vr": "OB", "BinaryLength": 183288},
        "3910": {"vr": "OB", "BinaryLength": 183288},
        "3911": {"vr": "OB", "BinaryLength": 183288},
        "3912": {"vr": "OB", "BinaryLength": 183288},
        "3913": {"vr": "OB", "BinaryLength": 183288},
        "3914": {"vr": "OB", "BinaryLength": 183288},
        "3915": {"vr": "OB", "BinaryLength": 183288},
        "3916": {"vr": "OB", "BinaryLength": 183288},
        "3917": {"vr": "OB", "BinaryLength": 183288},
        "3918": {"vr": "OB", "BinaryLength": 183288},
        "3919": {"vr": "OB", "BinaryLength": 183288},
        "3920": {"vr": "OB", "BinaryLength": 183288},
        "3921": {"vr": "OB", "BinaryLength": 183288},
        "3922": {"vr": "OB", "BinaryLength": 183288},
        "3923": {"vr": "OB", "BinaryLength": 183288},
        "3924": {"vr": "OB", "BinaryLength": 183288},
        "3925": {"vr": "OB", "BinaryLength": 183288},
        "3926": {"vr": "OB", "BinaryLength": 183288},
        "3927": {"vr": "OB", "BinaryLength": 183288},
        "3928": {"vr": "OB", "BinaryLength": 183288},
        "3929": {"vr": "OB", "BinaryLength": 183288},
        "3930": {"vr": "OB", "BinaryLength": 183288},
        "3931": {"vr": "OB", "BinaryLength": 183288},
        "3932": {"vr": "OB", "BinaryLength": 183288},
        "3933": {"vr": "OB", "BinaryLength": 183288},
        "3934": {"vr": "OB", "BinaryLength": 183288},
        "3935": {"vr": "OB", "BinaryLength": 183288},
        "3936": {"vr": "OB", "BinaryLength": 183288},
        "3937": {"vr": "OB", "BinaryLength": 183288},
        "3938": {"vr": "OB", "BinaryLength": 183288},
        "3939": {"vr": "OB", "BinaryLength": 183288},
        "3940": {"vr": "OB", "BinaryLength": 183288},
        "3941": {"vr": "OB", "BinaryLength": 183288},
        "3942": {"vr": "OB", "BinaryLength": 183288},
        "3943": {"vr": "OB", "BinaryLength": 183288},
        "3944": {"vr": "OB", "BinaryLength": 183288},
        "3945": {"vr": "OB", "BinaryLength": 183288},
        "3946": {"vr": "OB", "BinaryLength": 183288},
        "3947": {"vr": "OB", "BinaryLength": 183288},
        "3948": {"vr": "OB", "BinaryLength": 183288},
        "3949": {"vr": "OB", "BinaryLength": 183288},
        "3950": {"vr": "OB", "BinaryLength": 183288},
        "3951": {"vr": "OB", "BinaryLength": 183288},
        "3952": {"vr": "OB", "BinaryLength": 183288},
        "3953": {"vr": "OB", "BinaryLength": 183288},
        "3954": {"vr": "OB", "BinaryLength": 183288},
        "3955": {"vr": "OB", "BinaryLength": 183288},
        "3956": {"vr": "OB", "BinaryLength": 183288},
        "3957": {"vr": "OB", "BinaryLength": 183288},
        "3958": {"vr": "OB", "BinaryLength": 183288},
        "3959": {"vr": "OB", "BinaryLength": 183288},
        "3960": {"vr": "OB", "BinaryLength": 183288},
        "3961": {"vr": "OB", "BinaryLength": 183288},
        "3962": {"vr": "OB", "BinaryLength": 183288},
        "3963": {"vr": "OB", "BinaryLength": 183288},
        "3964": {"vr": "OB", "BinaryLength": 183288},
        "3965": {"vr": "OB", "BinaryLength": 183288},
        "3966": {"vr": "OB", "BinaryLength": 183288},
        "3967": {"vr": "OB", "BinaryLength": 183288},
        "3968": {"vr": "OB", "BinaryLength": 183288},
        "3969": {"vr": "OB", "BinaryLength": 183288},
        "3970": {"vr": "OB", "BinaryLength": 183288},
        "3971": {"vr": "OB", "BinaryLength": 183288},
        "3972": {"vr": "OB", "BinaryLength": 183288},
        "3973": {"vr": "OB", "BinaryLength": 183288},
        "3974": {"vr": "OB", "BinaryLength": 183288},
        "3975": {"vr": "OB", "BinaryLength": 183288},
        "3976": {"vr": "OB", "BinaryLength": 183288},
        "3977": {"vr": "OB", "BinaryLength": 183288},
        "3978": {"vr": "OB", "BinaryLength": 183288},
        "3979": {"vr": "OB", "BinaryLength": 183288},
        "3980": {"vr": "OB", "BinaryLength": 183288},
        "3981": {"vr": "OB", "BinaryLength": 183288},
        "3982": {"vr": "OB", "BinaryLength": 183288},
        "3983": {"vr": "OB", "BinaryLength": 183288},
        "3984": {"vr": "OB", "BinaryLength": 183288},
        "3985": {"vr": "OB", "BinaryLength": 183288},
        "3986": {"vr": "OB", "BinaryLength": 183288},
        "3987": {"vr": "OB", "BinaryLength": 183288},
        "3988": {"vr": "OB", "BinaryLength": 183288},
        "3989": {"vr": "OB", "BinaryLength": 183288},
        "3990": {"vr": "OB", "BinaryLength": 183288},
        "3991": {"vr": "OB", "BinaryLength": 183288},
        "3992": {"vr": "OB", "BinaryLength": 183288},
        "3993": {"vr": "OB", "BinaryLength": 183288},
        "3994": {"vr": "OB", "BinaryLength": 183288},
        "3995": {"vr": "OB", "BinaryLength": 183288},
        "3996": {"vr": "OB", "BinaryLength": 183288},
        "3997": {"vr": "OB", "BinaryLength": 183288},
        "3998": {"vr": "OB", "BinaryLength": 183288},
        "3999": {"vr": "OB", "BinaryLength": 183288},
        "4000": {"vr": "OB", "BinaryLength": 183288},
        "4001": {"vr": "OB", "BinaryLength": 183288},
        "4002": {"vr": "OB", "BinaryLength": 183288},
        "4003": {"vr": "OB", "BinaryLength": 183288},
        "4004": {"vr": "OB", "BinaryLength": 183288},
        "4005": {"vr": "OB", "BinaryLength": 183288},
        "4006": {"vr": "OB", "BinaryLength": 183288},
        "4007": {"vr": "OB", "BinaryLength": 183288},
        "4008": {"vr": "OB", "BinaryLength": 183288},
        "4009": {"vr": "OB", "BinaryLength": 183288},
        "4010": {"vr": "OB", "BinaryLength": 183288},
        "4011": {"vr": "OB", "BinaryLength": 183288},
        "4012": {"vr": "OB", "BinaryLength": 183288},
        "4013": {"vr": "OB", "BinaryLength": 183288},
        "4014": {"vr": "OB", "BinaryLength": 183288},
        "4015": {"vr": "OB", "BinaryLength": 183288},
        "4016": {"vr": "OB", "BinaryLength": 183288},
        "4017": {"vr": "OB", "BinaryLength": 183288},
        "4018": {"vr": "OB", "BinaryLength": 183288},
        "4019": {"vr": "OB", "BinaryLength": 183288},
    },
    "00211168": {
        "0": {"vr": "OB", "BinaryLength": 488},
        "1": {"vr": "OB", "BinaryLength": 488},
        "2": {"vr": "OB", "BinaryLength": 488},
        "3": {"vr": "OB", "BinaryLength": 124},
        "4": {"vr": "OB", "BinaryLength": 488},
        "5": {"vr": "OB", "BinaryLength": 488},
        "6": {"vr": "OB", "BinaryLength": 488},
        "7": {"vr": "OB", "BinaryLength": 488},
        "8": {"vr": "OB", "BinaryLength": 488},
        "9": {"vr": "OB", "BinaryLength": 488},
        "10": {"vr": "OB", "BinaryLength": 488},
        "11": {"vr": "OB", "BinaryLength": 488},
        "12": {"vr": "OB", "BinaryLength": 488},
        "13": {"vr": "OB", "BinaryLength": 124},
        "14": {"vr": "OB", "BinaryLength": 124},
        "15": {"vr": "OB", "BinaryLength": 488},
        "16": {"vr": "OB", "BinaryLength": 488},
        "17": {"vr": "OB", "BinaryLength": 488},
        "18": {"vr": "OB", "BinaryLength": 488},
        "19": {"vr": "OB", "BinaryLength": 488},
        "20": {"vr": "OB", "BinaryLength": 488},
        "21": {"vr": "OB", "BinaryLength": 488},
        "22": {"vr": "OB", "BinaryLength": 488},
        "23": {"vr": "OB", "BinaryLength": 488},
        "24": {"vr": "OB", "BinaryLength": 488},
        "25": {"vr": "OB", "BinaryLength": 488},
        "26": {"vr": "OB", "BinaryLength": 488},
        "27": {"vr": "OB", "BinaryLength": 488},
        "28": {"vr": "OB", "BinaryLength": 488},
        "29": {"vr": "OB", "BinaryLength": 488},
        "30": {"vr": "OB", "BinaryLength": 488},
        "31": {"vr": "OB", "BinaryLength": 124},
        "32": {"vr": "OB", "BinaryLength": 488},
        "33": {"vr": "OB", "BinaryLength": 488},
        "34": {"vr": "OB", "BinaryLength": 124},
        "35": {"vr": "OB", "BinaryLength": 124},
        "36": {"vr": "OB", "BinaryLength": 488},
        "37": {"vr": "OB", "BinaryLength": 488},
        "38": {"vr": "OB", "BinaryLength": 488},
        "39": {"vr": "OB", "BinaryLength": 488},
        "40": {"vr": "OB", "BinaryLength": 124},
        "41": {"vr": "OB", "BinaryLength": 488},
        "42": {"vr": "OB", "BinaryLength": 488},
        "43": {"vr": "OB", "BinaryLength": 488},
        "44": {"vr": "OB", "BinaryLength": 488},
        "45": {"vr": "OB", "BinaryLength": 488},
        "46": {"vr": "OB", "BinaryLength": 488},
        "47": {"vr": "OB", "BinaryLength": 488},
        "48": {"vr": "OB", "BinaryLength": 488},
        "49": {"vr": "OB", "BinaryLength": 488},
        "50": {"vr": "OB", "BinaryLength": 488},
        "51": {"vr": "OB", "BinaryLength": 488},
        "52": {"vr": "OB", "BinaryLength": 488},
        "53": {"vr": "OB", "BinaryLength": 488},
        "54": {"vr": "OB", "BinaryLength": 488},
        "55": {"vr": "OB", "BinaryLength": 488},
        "56": {"vr": "OB", "BinaryLength": 488},
        "57": {"vr": "OB", "BinaryLength": 488},
        "58": {"vr": "OB", "BinaryLength": 488},
        "59": {"vr": "OB", "BinaryLength": 488},
        "60": {"vr": "OB", "BinaryLength": 124},
        "61": {"vr": "OB", "BinaryLength": 124},
        "62": {"vr": "OB", "BinaryLength": 488},
        "63": {"vr": "OB", "BinaryLength": 488},
        "64": {"vr": "OB", "BinaryLength": 488},
        "65": {"vr": "OB", "BinaryLength": 488},
        "66": {"vr": "OB", "BinaryLength": 488},
        "67": {"vr": "OB", "BinaryLength": 488},
        "68": {"vr": "OB", "BinaryLength": 124},
        "69": {"vr": "OB", "BinaryLength": 488},
        "70": {"vr": "OB", "BinaryLength": 488},
        "71": {"vr": "OB", "BinaryLength": 488},
        "72": {"vr": "OB", "BinaryLength": 488},
        "73": {"vr": "OB", "BinaryLength": 488},
        "74": {"vr": "OB", "BinaryLength": 488},
        "75": {"vr": "OB", "BinaryLength": 488},
        "76": {"vr": "OB", "BinaryLength": 488},
        "77": {"vr": "OB", "BinaryLength": 488},
        "78": {"vr": "OB", "BinaryLength": 488},
        "79": {"vr": "OB", "BinaryLength": 488},
        "80": {"vr": "OB", "BinaryLength": 124},
        "81": {"vr": "OB", "BinaryLength": 488},
        "82": {"vr": "OB", "BinaryLength": 488},
        "83": {"vr": "OB", "BinaryLength": 488},
        "84": {"vr": "OB", "BinaryLength": 488},
        "85": {"vr": "OB", "BinaryLength": 488},
        "86": {"vr": "OB", "BinaryLength": 488},
        "87": {"vr": "OB", "BinaryLength": 488},
        "88": {"vr": "OB", "BinaryLength": 488},
        "89": {"vr": "OB", "BinaryLength": 488},
        "90": {"vr": "OB", "BinaryLength": 124},
        "91": {"vr": "OB", "BinaryLength": 124},
        "92": {"vr": "OB", "BinaryLength": 488},
        "93": {"vr": "OB", "BinaryLength": 488},
        "94": {"vr": "OB", "BinaryLength": 488},
        "95": {"vr": "OB", "BinaryLength": 488},
        "96": {"vr": "OB", "BinaryLength": 488},
        "97": {"vr": "OB", "BinaryLength": 488},
        "98": {"vr": "OB", "BinaryLength": 488},
        "99": {"vr": "OB", "BinaryLength": 488},
        "100": {"vr": "OB", "BinaryLength": 488},
        "101": {"vr": "OB", "BinaryLength": 488},
        "102": {"vr": "OB", "BinaryLength": 488},
        "103": {"vr": "OB", "BinaryLength": 488},
        "104": {"vr": "OB", "BinaryLength": 488},
        "105": {"vr": "OB", "BinaryLength": 488},
        "106": {"vr": "OB", "BinaryLength": 488},
        "107": {"vr": "OB", "BinaryLength": 488},
        "108": {"vr": "OB", "BinaryLength": 488},
        "109": {"vr": "OB", "BinaryLength": 488},
        "110": {"vr": "OB", "BinaryLength": 488},
        "111": {"vr": "OB", "BinaryLength": 488},
        "112": {"vr": "OB", "BinaryLength": 124},
        "113": {"vr": "OB", "BinaryLength": 488},
        "114": {"vr": "OB", "BinaryLength": 124},
        "115": {"vr": "OB", "BinaryLength": 488},
        "116": {"vr": "OB", "BinaryLength": 488},
        "117": {"vr": "OB", "BinaryLength": 488},
        "118": {"vr": "OB", "BinaryLength": 488},
        "119": {"vr": "OB", "BinaryLength": 488},
        "120": {"vr": "OB", "BinaryLength": 488},
        "121": {"vr": "OB", "BinaryLength": 488},
        "122": {"vr": "OB", "BinaryLength": 488},
        "123": {"vr": "OB", "BinaryLength": 488},
        "124": {"vr": "OB", "BinaryLength": 488},
        "125": {"vr": "OB", "BinaryLength": 488},
        "126": {"vr": "OB", "BinaryLength": 488},
        "127": {"vr": "OB", "BinaryLength": 488},
        "128": {"vr": "OB", "BinaryLength": 124},
        "129": {"vr": "OB", "BinaryLength": 488},
        "130": {"vr": "OB", "BinaryLength": 488},
        "131": {"vr": "OB", "BinaryLength": 488},
        "132": {"vr": "OB", "BinaryLength": 488},
        "133": {"vr": "OB", "BinaryLength": 488},
        "134": {"vr": "OB", "BinaryLength": 488},
        "135": {"vr": "OB", "BinaryLength": 488},
        "136": {"vr": "OB", "BinaryLength": 488},
        "137": {"vr": "OB", "BinaryLength": 488},
        "138": {"vr": "OB", "BinaryLength": 488},
        "139": {"vr": "OB", "BinaryLength": 488},
        "140": {"vr": "OB", "BinaryLength": 488},
        "141": {"vr": "OB", "BinaryLength": 488},
        "142": {"vr": "OB", "BinaryLength": 488},
        "143": {"vr": "OB", "BinaryLength": 488},
        "144": {"vr": "OB", "BinaryLength": 488},
        "145": {"vr": "OB", "BinaryLength": 488},
        "146": {"vr": "OB", "BinaryLength": 488},
        "147": {"vr": "OB", "BinaryLength": 488},
        "148": {"vr": "OB", "BinaryLength": 488},
        "149": {"vr": "OB", "BinaryLength": 488},
        "150": {"vr": "OB", "BinaryLength": 488},
        "151": {"vr": "OB", "BinaryLength": 488},
        "152": {"vr": "OB", "BinaryLength": 488},
        "153": {"vr": "OB", "BinaryLength": 488},
        "154": {"vr": "OB", "BinaryLength": 488},
        "155": {"vr": "OB", "BinaryLength": 488},
        "156": {"vr": "OB", "BinaryLength": 488},
        "157": {"vr": "OB", "BinaryLength": 488},
        "158": {"vr": "OB", "BinaryLength": 488},
        "159": {"vr": "OB", "BinaryLength": 488},
        "160": {"vr": "OB", "BinaryLength": 124},
        "161": {"vr": "OB", "BinaryLength": 488},
        "162": {"vr": "OB", "BinaryLength": 488},
        "163": {"vr": "OB", "BinaryLength": 488},
        "164": {"vr": "OB", "BinaryLength": 488},
        "165": {"vr": "OB", "BinaryLength": 488},
        "166": {"vr": "OB", "BinaryLength": 488},
        "167": {"vr": "OB", "BinaryLength": 488},
        "168": {"vr": "OB", "BinaryLength": 488},
        "169": {"vr": "OB", "BinaryLength": 488},
        "170": {"vr": "OB", "BinaryLength": 488},
        "171": {"vr": "OB", "BinaryLength": 488},
        "172": {"vr": "OB", "BinaryLength": 488},
        "173": {"vr": "OB", "BinaryLength": 488},
        "174": {"vr": "OB", "BinaryLength": 488},
        "175": {"vr": "OB", "BinaryLength": 488},
        "176": {"vr": "OB", "BinaryLength": 488},
        "177": {"vr": "OB", "BinaryLength": 488},
        "178": {"vr": "OB", "BinaryLength": 488},
        "179": {"vr": "OB", "BinaryLength": 488},
        "180": {"vr": "OB", "BinaryLength": 488},
        "181": {"vr": "OB", "BinaryLength": 488},
        "182": {"vr": "OB", "BinaryLength": 488},
        "183": {"vr": "OB", "BinaryLength": 488},
        "184": {"vr": "OB", "BinaryLength": 488},
        "185": {"vr": "OB", "BinaryLength": 488},
        "186": {"vr": "OB", "BinaryLength": 488},
        "187": {"vr": "OB", "BinaryLength": 488},
        "188": {"vr": "OB", "BinaryLength": 488},
        "189": {"vr": "OB", "BinaryLength": 488},
        "190": {"vr": "OB", "BinaryLength": 488},
        "191": {"vr": "OB", "BinaryLength": 124},
        "192": {"vr": "OB", "BinaryLength": 488},
        "193": {"vr": "OB", "BinaryLength": 488},
        "194": {"vr": "OB", "BinaryLength": 488},
        "195": {"vr": "OB", "BinaryLength": 488},
        "196": {"vr": "OB", "BinaryLength": 488},
        "197": {"vr": "OB", "BinaryLength": 488},
        "198": {"vr": "OB", "BinaryLength": 124},
        "199": {"vr": "OB", "BinaryLength": 488},
        "200": {"vr": "OB", "BinaryLength": 488},
        "201": {"vr": "OB", "BinaryLength": 488},
        "202": {"vr": "OB", "BinaryLength": 488},
        "203": {"vr": "OB", "BinaryLength": 488},
        "204": {"vr": "OB", "BinaryLength": 488},
        "205": {"vr": "OB", "BinaryLength": 488},
        "206": {"vr": "OB", "BinaryLength": 488},
        "207": {"vr": "OB", "BinaryLength": 488},
        "208": {"vr": "OB", "BinaryLength": 488},
        "209": {"vr": "OB", "BinaryLength": 488},
        "210": {"vr": "OB", "BinaryLength": 124},
        "211": {"vr": "OB", "BinaryLength": 488},
        "212": {"vr": "OB", "BinaryLength": 488},
        "213": {"vr": "OB", "BinaryLength": 488},
        "214": {"vr": "OB", "BinaryLength": 488},
        "215": {"vr": "OB", "BinaryLength": 488},
        "216": {"vr": "OB", "BinaryLength": 488},
        "217": {"vr": "OB", "BinaryLength": 488},
        "218": {"vr": "OB", "BinaryLength": 488},
        "219": {"vr": "OB", "BinaryLength": 488},
        "220": {"vr": "OB", "BinaryLength": 488},
        "221": {"vr": "OB", "BinaryLength": 488},
        "222": {"vr": "OB", "BinaryLength": 488},
        "223": {"vr": "OB", "BinaryLength": 488},
        "224": {"vr": "OB", "BinaryLength": 488},
        "225": {"vr": "OB", "BinaryLength": 488},
        "226": {"vr": "OB", "BinaryLength": 488},
        "227": {"vr": "OB", "BinaryLength": 124},
        "228": {"vr": "OB", "BinaryLength": 488},
        "229": {"vr": "OB", "BinaryLength": 488},
        "230": {"vr": "OB", "BinaryLength": 488},
        "231": {"vr": "OB", "BinaryLength": 488},
        "232": {"vr": "OB", "BinaryLength": 488},
        "233": {"vr": "OB", "BinaryLength": 488},
        "234": {"vr": "OB", "BinaryLength": 488},
        "235": {"vr": "OB", "BinaryLength": 488},
        "236": {"vr": "OB", "BinaryLength": 488},
        "237": {"vr": "OB", "BinaryLength": 488},
        "238": {"vr": "OB", "BinaryLength": 488},
        "239": {"vr": "OB", "BinaryLength": 488},
        "240": {"vr": "OB", "BinaryLength": 488},
        "241": {"vr": "OB", "BinaryLength": 488},
        "242": {"vr": "OB", "BinaryLength": 488},
        "243": {"vr": "OB", "BinaryLength": 124},
        "244": {"vr": "OB", "BinaryLength": 488},
        "245": {"vr": "OB", "BinaryLength": 488},
        "246": {"vr": "OB", "BinaryLength": 124},
        "247": {"vr": "OB", "BinaryLength": 488},
        "248": {"vr": "OB", "BinaryLength": 488},
        "249": {"vr": "OB", "BinaryLength": 488},
        "250": {"vr": "OB", "BinaryLength": 488},
        "251": {"vr": "OB", "BinaryLength": 488},
        "252": {"vr": "OB", "BinaryLength": 488},
        "253": {"vr": "OB", "BinaryLength": 488},
        "254": {"vr": "OB", "BinaryLength": 488},
        "255": {"vr": "OB", "BinaryLength": 488},
        "256": {"vr": "OB", "BinaryLength": 124},
        "257": {"vr": "OB", "BinaryLength": 488},
        "258": {"vr": "OB", "BinaryLength": 488},
        "259": {"vr": "OB", "BinaryLength": 488},
        "260": {"vr": "OB", "BinaryLength": 488},
        "261": {"vr": "OB", "BinaryLength": 488},
        "262": {"vr": "OB", "BinaryLength": 488},
        "263": {"vr": "OB", "BinaryLength": 488},
        "264": {"vr": "OB", "BinaryLength": 488},
        "265": {"vr": "OB", "BinaryLength": 488},
        "266": {"vr": "OB", "BinaryLength": 488},
        "267": {"vr": "OB", "BinaryLength": 488},
        "268": {"vr": "OB", "BinaryLength": 488},
        "269": {"vr": "OB", "BinaryLength": 488},
        "270": {"vr": "OB", "BinaryLength": 124},
        "271": {"vr": "OB", "BinaryLength": 488},
        "272": {"vr": "OB", "BinaryLength": 488},
        "273": {"vr": "OB", "BinaryLength": 488},
        "274": {"vr": "OB", "BinaryLength": 488},
        "275": {"vr": "OB", "BinaryLength": 124},
        "276": {"vr": "OB", "BinaryLength": 488},
        "277": {"vr": "OB", "BinaryLength": 488},
        "278": {"vr": "OB", "BinaryLength": 488},
        "279": {"vr": "OB", "BinaryLength": 488},
        "280": {"vr": "OB", "BinaryLength": 488},
        "281": {"vr": "OB", "BinaryLength": 488},
        "282": {"vr": "OB", "BinaryLength": 488},
        "283": {"vr": "OB", "BinaryLength": 488},
        "284": {"vr": "OB", "BinaryLength": 488},
        "285": {"vr": "OB", "BinaryLength": 488},
        "286": {"vr": "OB", "BinaryLength": 488},
        "287": {"vr": "OB", "BinaryLength": 488},
        "288": {"vr": "OB", "BinaryLength": 488},
        "289": {"vr": "OB", "BinaryLength": 488},
        "290": {"vr": "OB", "BinaryLength": 124},
        "291": {"vr": "OB", "BinaryLength": 488},
        "292": {"vr": "OB", "BinaryLength": 488},
        "293": {"vr": "OB", "BinaryLength": 488},
        "294": {"vr": "OB", "BinaryLength": 488},
        "295": {"vr": "OB", "BinaryLength": 488},
        "296": {"vr": "OB", "BinaryLength": 488},
        "297": {"vr": "OB", "BinaryLength": 488},
        "298": {"vr": "OB", "BinaryLength": 488},
        "299": {"vr": "OB", "BinaryLength": 488},
        "300": {"vr": "OB", "BinaryLength": 488},
        "301": {"vr": "OB", "BinaryLength": 124},
        "302": {"vr": "OB", "BinaryLength": 488},
        "303": {"vr": "OB", "BinaryLength": 488},
        "304": {"vr": "OB", "BinaryLength": 488},
        "305": {"vr": "OB", "BinaryLength": 488},
        "306": {"vr": "OB", "BinaryLength": 488},
        "307": {"vr": "OB", "BinaryLength": 488},
        "308": {"vr": "OB", "BinaryLength": 488},
        "309": {"vr": "OB", "BinaryLength": 488},
        "310": {"vr": "OB", "BinaryLength": 488},
        "311": {"vr": "OB", "BinaryLength": 124},
        "312": {"vr": "OB", "BinaryLength": 488},
        "313": {"vr": "OB", "BinaryLength": 124},
        "314": {"vr": "OB", "BinaryLength": 488},
        "315": {"vr": "OB", "BinaryLength": 488},
        "316": {"vr": "OB", "BinaryLength": 124},
        "317": {"vr": "OB", "BinaryLength": 488},
        "318": {"vr": "OB", "BinaryLength": 488},
        "319": {"vr": "OB", "BinaryLength": 488},
        "320": {"vr": "OB", "BinaryLength": 488},
        "321": {"vr": "OB", "BinaryLength": 488},
        "322": {"vr": "OB", "BinaryLength": 488},
        "323": {"vr": "OB", "BinaryLength": 488},
        "324": {"vr": "OB", "BinaryLength": 488},
        "325": {"vr": "OB", "BinaryLength": 488},
        "326": {"vr": "OB", "BinaryLength": 488},
        "327": {"vr": "OB", "BinaryLength": 488},
        "328": {"vr": "OB", "BinaryLength": 488},
        "329": {"vr": "OB", "BinaryLength": 488},
        "330": {"vr": "OB", "BinaryLength": 488},
        "331": {"vr": "OB", "BinaryLength": 488},
        "332": {"vr": "OB", "BinaryLength": 488},
        "333": {"vr": "OB", "BinaryLength": 488},
        "334": {"vr": "OB", "BinaryLength": 488},
        "335": {"vr": "OB", "BinaryLength": 488},
        "336": {"vr": "OB", "BinaryLength": 488},
        "337": {"vr": "OB", "BinaryLength": 488},
        "338": {"vr": "OB", "BinaryLength": 488},
        "339": {"vr": "OB", "BinaryLength": 488},
        "340": {"vr": "OB", "BinaryLength": 488},
        "341": {"vr": "OB", "BinaryLength": 488},
        "342": {"vr": "OB", "BinaryLength": 488},
        "343": {"vr": "OB", "BinaryLength": 488},
        "344": {"vr": "OB", "BinaryLength": 488},
        "345": {"vr": "OB", "BinaryLength": 488},
        "346": {"vr": "OB", "BinaryLength": 488},
        "347": {"vr": "OB", "BinaryLength": 488},
        "348": {"vr": "OB", "BinaryLength": 488},
        "349": {"vr": "OB", "BinaryLength": 124},
        "350": {"vr": "OB", "BinaryLength": 124},
        "351": {"vr": "OB", "BinaryLength": 488},
        "352": {"vr": "OB", "BinaryLength": 488},
        "353": {"vr": "OB", "BinaryLength": 488},
        "354": {"vr": "OB", "BinaryLength": 488},
        "355": {"vr": "OB", "BinaryLength": 488},
        "356": {"vr": "OB", "BinaryLength": 488},
        "357": {"vr": "OB", "BinaryLength": 488},
        "358": {"vr": "OB", "BinaryLength": 488},
        "359": {"vr": "OB", "BinaryLength": 488},
        "360": {"vr": "OB", "BinaryLength": 488},
        "361": {"vr": "OB", "BinaryLength": 124},
        "362": {"vr": "OB", "BinaryLength": 488},
        "363": {"vr": "OB", "BinaryLength": 124},
        "364": {"vr": "OB", "BinaryLength": 488},
        "365": {"vr": "OB", "BinaryLength": 488},
        "366": {"vr": "OB", "BinaryLength": 488},
        "367": {"vr": "OB", "BinaryLength": 488},
        "368": {"vr": "OB", "BinaryLength": 124},
        "369": {"vr": "OB", "BinaryLength": 488},
        "370": {"vr": "OB", "BinaryLength": 488},
        "371": {"vr": "OB", "BinaryLength": 488},
        "372": {"vr": "OB", "BinaryLength": 488},
        "373": {"vr": "OB", "BinaryLength": 488},
        "374": {"vr": "OB", "BinaryLength": 488},
        "375": {"vr": "OB", "BinaryLength": 488},
        "376": {"vr": "OB", "BinaryLength": 488},
        "377": {"vr": "OB", "BinaryLength": 488},
        "378": {"vr": "OB", "BinaryLength": 488},
        "379": {"vr": "OB", "BinaryLength": 488},
        "380": {"vr": "OB", "BinaryLength": 488},
        "381": {"vr": "OB", "BinaryLength": 488},
        "382": {"vr": "OB", "BinaryLength": 488},
        "383": {"vr": "OB", "BinaryLength": 124},
        "384": {"vr": "OB", "BinaryLength": 124},
        "385": {"vr": "OB", "BinaryLength": 488},
        "386": {"vr": "OB", "BinaryLength": 488},
        "387": {"vr": "OB", "BinaryLength": 488},
        "388": {"vr": "OB", "BinaryLength": 488},
        "389": {"vr": "OB", "BinaryLength": 488},
        "390": {"vr": "OB", "BinaryLength": 488},
        "391": {"vr": "OB", "BinaryLength": 488},
        "392": {"vr": "OB", "BinaryLength": 488},
        "393": {"vr": "OB", "BinaryLength": 488},
        "394": {"vr": "OB", "BinaryLength": 488},
        "395": {"vr": "OB", "BinaryLength": 488},
        "396": {"vr": "OB", "BinaryLength": 124},
        "397": {"vr": "OB", "BinaryLength": 488},
        "398": {"vr": "OB", "BinaryLength": 488},
        "399": {"vr": "OB", "BinaryLength": 124},
        "400": {"vr": "OB", "BinaryLength": 488},
        "401": {"vr": "OB", "BinaryLength": 488},
        "402": {"vr": "OB", "BinaryLength": 488},
        "403": {"vr": "OB", "BinaryLength": 488},
        "404": {"vr": "OB", "BinaryLength": 488},
        "405": {"vr": "OB", "BinaryLength": 488},
        "406": {"vr": "OB", "BinaryLength": 488},
        "407": {"vr": "OB", "BinaryLength": 488},
        "408": {"vr": "OB", "BinaryLength": 488},
        "409": {"vr": "OB", "BinaryLength": 488},
        "410": {"vr": "OB", "BinaryLength": 488},
        "411": {"vr": "OB", "BinaryLength": 488},
        "412": {"vr": "OB", "BinaryLength": 488},
        "413": {"vr": "OB", "BinaryLength": 488},
        "414": {"vr": "OB", "BinaryLength": 488},
        "415": {"vr": "OB", "BinaryLength": 488},
        "416": {"vr": "OB", "BinaryLength": 488},
        "417": {"vr": "OB", "BinaryLength": 488},
        "418": {"vr": "OB", "BinaryLength": 124},
        "419": {"vr": "OB", "BinaryLength": 488},
        "420": {"vr": "OB", "BinaryLength": 488},
        "421": {"vr": "OB", "BinaryLength": 488},
        "422": {"vr": "OB", "BinaryLength": 488},
        "423": {"vr": "OB", "BinaryLength": 488},
        "424": {"vr": "OB", "BinaryLength": 124},
        "425": {"vr": "OB", "BinaryLength": 488},
        "426": {"vr": "OB", "BinaryLength": 488},
        "427": {"vr": "OB", "BinaryLength": 488},
        "428": {"vr": "OB", "BinaryLength": 488},
        "429": {"vr": "OB", "BinaryLength": 488},
        "430": {"vr": "OB", "BinaryLength": 488},
        "431": {"vr": "OB", "BinaryLength": 488},
        "432": {"vr": "OB", "BinaryLength": 488},
        "433": {"vr": "OB", "BinaryLength": 488},
        "434": {"vr": "OB", "BinaryLength": 488},
        "435": {"vr": "OB", "BinaryLength": 488},
        "436": {"vr": "OB", "BinaryLength": 488},
        "437": {"vr": "OB", "BinaryLength": 488},
        "438": {"vr": "OB", "BinaryLength": 488},
        "439": {"vr": "OB", "BinaryLength": 488},
        "440": {"vr": "OB", "BinaryLength": 488},
        "441": {"vr": "OB", "BinaryLength": 488},
        "442": {"vr": "OB", "BinaryLength": 488},
        "443": {"vr": "OB", "BinaryLength": 488},
        "444": {"vr": "OB", "BinaryLength": 488},
        "445": {"vr": "OB", "BinaryLength": 124},
        "446": {"vr": "OB", "BinaryLength": 488},
        "447": {"vr": "OB", "BinaryLength": 488},
        "448": {"vr": "OB", "BinaryLength": 124},
        "449": {"vr": "OB", "BinaryLength": 488},
        "450": {"vr": "OB", "BinaryLength": 488},
        "451": {"vr": "OB", "BinaryLength": 488},
        "452": {"vr": "OB", "BinaryLength": 488},
        "453": {"vr": "OB", "BinaryLength": 488},
        "454": {"vr": "OB", "BinaryLength": 488},
        "455": {"vr": "OB", "BinaryLength": 488},
        "456": {"vr": "OB", "BinaryLength": 488},
        "457": {"vr": "OB", "BinaryLength": 488},
        "458": {"vr": "OB", "BinaryLength": 488},
        "459": {"vr": "OB", "BinaryLength": 488},
        "460": {"vr": "OB", "BinaryLength": 488},
        "461": {"vr": "OB", "BinaryLength": 488},
        "462": {"vr": "OB", "BinaryLength": 488},
        "463": {"vr": "OB", "BinaryLength": 488},
        "464": {"vr": "OB", "BinaryLength": 488},
        "465": {"vr": "OB", "BinaryLength": 488},
        "466": {"vr": "OB", "BinaryLength": 488},
        "467": {"vr": "OB", "BinaryLength": 488},
        "468": {"vr": "OB", "BinaryLength": 488},
        "469": {"vr": "OB", "BinaryLength": 124},
        "470": {"vr": "OB", "BinaryLength": 488},
        "471": {"vr": "OB", "BinaryLength": 488},
        "472": {"vr": "OB", "BinaryLength": 488},
        "473": {"vr": "OB", "BinaryLength": 488},
        "474": {"vr": "OB", "BinaryLength": 488},
        "475": {"vr": "OB", "BinaryLength": 124},
        "476": {"vr": "OB", "BinaryLength": 488},
        "477": {"vr": "OB", "BinaryLength": 488},
        "478": {"vr": "OB", "BinaryLength": 488},
        "479": {"vr": "OB", "BinaryLength": 488},
        "480": {"vr": "OB", "BinaryLength": 488},
        "481": {"vr": "OB", "BinaryLength": 488},
        "482": {"vr": "OB", "BinaryLength": 488},
        "483": {"vr": "OB", "BinaryLength": 124},
        "484": {"vr": "OB", "BinaryLength": 488},
        "485": {"vr": "OB", "BinaryLength": 488},
        "486": {"vr": "OB", "BinaryLength": 488},
        "487": {"vr": "OB", "BinaryLength": 488},
        "488": {"vr": "OB", "BinaryLength": 488},
        "489": {"vr": "OB", "BinaryLength": 488},
        "490": {"vr": "OB", "BinaryLength": 488},
        "491": {"vr": "OB", "BinaryLength": 488},
        "492": {"vr": "OB", "BinaryLength": 488},
        "493": {"vr": "OB", "BinaryLength": 488},
        "494": {"vr": "OB", "BinaryLength": 488},
        "495": {"vr": "OB", "BinaryLength": 488},
        "496": {"vr": "OB", "BinaryLength": 488},
        "497": {"vr": "OB", "BinaryLength": 124},
        "498": {"vr": "OB", "BinaryLength": 488},
        "499": {"vr": "OB", "BinaryLength": 488},
        "500": {"vr": "OB", "BinaryLength": 488},
        "501": {"vr": "OB", "BinaryLength": 124},
        "502": {"vr": "OB", "BinaryLength": 488},
        "503": {"vr": "OB", "BinaryLength": 488},
        "504": {"vr": "OB", "BinaryLength": 488},
        "505": {"vr": "OB", "BinaryLength": 488},
        "506": {"vr": "OB", "BinaryLength": 488},
        "507": {"vr": "OB", "BinaryLength": 124},
        "508": {"vr": "OB", "BinaryLength": 488},
        "509": {"vr": "OB", "BinaryLength": 488},
        "510": {"vr": "OB", "BinaryLength": 488},
        "511": {"vr": "OB", "BinaryLength": 488},
        "512": {"vr": "OB", "BinaryLength": 488},
        "513": {"vr": "OB", "BinaryLength": 488},
        "514": {"vr": "OB", "BinaryLength": 124},
        "515": {"vr": "OB", "BinaryLength": 124},
        "516": {"vr": "OB", "BinaryLength": 488},
        "517": {"vr": "OB", "BinaryLength": 488},
        "518": {"vr": "OB", "BinaryLength": 488},
        "519": {"vr": "OB", "BinaryLength": 488},
        "520": {"vr": "OB", "BinaryLength": 124},
        "521": {"vr": "OB", "BinaryLength": 488},
        "522": {"vr": "OB", "BinaryLength": 488},
        "523": {"vr": "OB", "BinaryLength": 488},
        "524": {"vr": "OB", "BinaryLength": 488},
        "525": {"vr": "OB", "BinaryLength": 488},
        "526": {"vr": "OB", "BinaryLength": 488},
        "527": {"vr": "OB", "BinaryLength": 488},
        "528": {"vr": "OB", "BinaryLength": 488},
        "529": {"vr": "OB", "BinaryLength": 488},
        "530": {"vr": "OB", "BinaryLength": 488},
        "531": {"vr": "OB", "BinaryLength": 124},
        "532": {"vr": "OB", "BinaryLength": 488},
        "533": {"vr": "OB", "BinaryLength": 488},
        "534": {"vr": "OB", "BinaryLength": 488},
        "535": {"vr": "OB", "BinaryLength": 488},
        "536": {"vr": "OB", "BinaryLength": 488},
        "537": {"vr": "OB", "BinaryLength": 488},
        "538": {"vr": "OB", "BinaryLength": 488},
        "539": {"vr": "OB", "BinaryLength": 124},
        "540": {"vr": "OB", "BinaryLength": 488},
        "541": {"vr": "OB", "BinaryLength": 488},
        "542": {"vr": "OB", "BinaryLength": 124},
        "543": {"vr": "OB", "BinaryLength": 488},
        "544": {"vr": "OB", "BinaryLength": 124},
        "545": {"vr": "OB", "BinaryLength": 488},
        "546": {"vr": "OB", "BinaryLength": 488},
        "547": {"vr": "OB", "BinaryLength": 488},
        "548": {"vr": "OB", "BinaryLength": 124},
        "549": {"vr": "OB", "BinaryLength": 488},
        "550": {"vr": "OB", "BinaryLength": 488},
        "551": {"vr": "OB", "BinaryLength": 488},
        "552": {"vr": "OB", "BinaryLength": 488},
        "553": {"vr": "OB", "BinaryLength": 124},
        "554": {"vr": "OB", "BinaryLength": 124},
        "555": {"vr": "OB", "BinaryLength": 124},
        "556": {"vr": "OB", "BinaryLength": 488},
        "557": {"vr": "OB", "BinaryLength": 488},
        "558": {"vr": "OB", "BinaryLength": 488},
        "559": {"vr": "OB", "BinaryLength": 488},
        "560": {"vr": "OB", "BinaryLength": 488},
        "561": {"vr": "OB", "BinaryLength": 488},
        "562": {"vr": "OB", "BinaryLength": 488},
        "563": {"vr": "OB", "BinaryLength": 488},
        "564": {"vr": "OB", "BinaryLength": 488},
        "565": {"vr": "OB", "BinaryLength": 488},
        "566": {"vr": "OB", "BinaryLength": 488},
        "567": {"vr": "OB", "BinaryLength": 124},
        "568": {"vr": "OB", "BinaryLength": 488},
        "569": {"vr": "OB", "BinaryLength": 488},
        "570": {"vr": "OB", "BinaryLength": 488},
        "571": {"vr": "OB", "BinaryLength": 488},
        "572": {"vr": "OB", "BinaryLength": 488},
        "573": {"vr": "OB", "BinaryLength": 488},
        "574": {"vr": "OB", "BinaryLength": 488},
        "575": {"vr": "OB", "BinaryLength": 488},
        "576": {"vr": "OB", "BinaryLength": 488},
        "577": {"vr": "OB", "BinaryLength": 488},
        "578": {"vr": "OB", "BinaryLength": 488},
        "579": {"vr": "OB", "BinaryLength": 488},
        "580": {"vr": "OB", "BinaryLength": 488},
        "581": {"vr": "OB", "BinaryLength": 488},
        "582": {"vr": "OB", "BinaryLength": 488},
        "583": {"vr": "OB", "BinaryLength": 488},
        "584": {"vr": "OB", "BinaryLength": 488},
        "585": {"vr": "OB", "BinaryLength": 124},
        "586": {"vr": "OB", "BinaryLength": 488},
        "587": {"vr": "OB", "BinaryLength": 124},
        "588": {"vr": "OB", "BinaryLength": 488},
        "589": {"vr": "OB", "BinaryLength": 488},
        "590": {"vr": "OB", "BinaryLength": 488},
        "591": {"vr": "OB", "BinaryLength": 488},
        "592": {"vr": "OB", "BinaryLength": 488},
        "593": {"vr": "OB", "BinaryLength": 488},
        "594": {"vr": "OB", "BinaryLength": 488},
        "595": {"vr": "OB", "BinaryLength": 488},
        "596": {"vr": "OB", "BinaryLength": 488},
        "597": {"vr": "OB", "BinaryLength": 488},
        "598": {"vr": "OB", "BinaryLength": 488},
        "599": {"vr": "OB", "BinaryLength": 488},
        "600": {"vr": "OB", "BinaryLength": 124},
        "601": {"vr": "OB", "BinaryLength": 488},
        "602": {"vr": "OB", "BinaryLength": 488},
        "603": {"vr": "OB", "BinaryLength": 488},
        "604": {"vr": "OB", "BinaryLength": 488},
        "605": {"vr": "OB", "BinaryLength": 488},
        "606": {"vr": "OB", "BinaryLength": 488},
        "607": {"vr": "OB", "BinaryLength": 488},
        "608": {"vr": "OB", "BinaryLength": 488},
        "609": {"vr": "OB", "BinaryLength": 488},
        "610": {"vr": "OB", "BinaryLength": 488},
        "611": {"vr": "OB", "BinaryLength": 124},
        "612": {"vr": "OB", "BinaryLength": 488},
        "613": {"vr": "OB", "BinaryLength": 488},
        "614": {"vr": "OB", "BinaryLength": 488},
        "615": {"vr": "OB", "BinaryLength": 488},
        "616": {"vr": "OB", "BinaryLength": 488},
        "617": {"vr": "OB", "BinaryLength": 488},
        "618": {"vr": "OB", "BinaryLength": 488},
        "619": {"vr": "OB", "BinaryLength": 488},
        "620": {"vr": "OB", "BinaryLength": 488},
        "621": {"vr": "OB", "BinaryLength": 488},
        "622": {"vr": "OB", "BinaryLength": 488},
        "623": {"vr": "OB", "BinaryLength": 488},
        "624": {"vr": "OB", "BinaryLength": 124},
        "625": {"vr": "OB", "BinaryLength": 488},
        "626": {"vr": "OB", "BinaryLength": 488},
        "627": {"vr": "OB", "BinaryLength": 488},
        "628": {"vr": "OB", "BinaryLength": 488},
        "629": {"vr": "OB", "BinaryLength": 488},
        "630": {"vr": "OB", "BinaryLength": 488},
        "631": {"vr": "OB", "BinaryLength": 488},
        "632": {"vr": "OB", "BinaryLength": 488},
        "633": {"vr": "OB", "BinaryLength": 488},
        "634": {"vr": "OB", "BinaryLength": 488},
        "635": {"vr": "OB", "BinaryLength": 488},
        "636": {"vr": "OB", "BinaryLength": 124},
        "637": {"vr": "OB", "BinaryLength": 488},
        "638": {"vr": "OB", "BinaryLength": 488},
        "639": {"vr": "OB", "BinaryLength": 488},
        "640": {"vr": "OB", "BinaryLength": 488},
        "641": {"vr": "OB", "BinaryLength": 488},
        "642": {"vr": "OB", "BinaryLength": 488},
        "643": {"vr": "OB", "BinaryLength": 488},
        "644": {"vr": "OB", "BinaryLength": 488},
        "645": {"vr": "OB", "BinaryLength": 488},
        "646": {"vr": "OB", "BinaryLength": 488},
        "647": {"vr": "OB", "BinaryLength": 488},
        "648": {"vr": "OB", "BinaryLength": 488},
        "649": {"vr": "OB", "BinaryLength": 488},
        "650": {"vr": "OB", "BinaryLength": 488},
        "651": {"vr": "OB", "BinaryLength": 488},
        "652": {"vr": "OB", "BinaryLength": 488},
        "653": {"vr": "OB", "BinaryLength": 488},
        "654": {"vr": "OB", "BinaryLength": 488},
        "655": {"vr": "OB", "BinaryLength": 488},
        "656": {"vr": "OB", "BinaryLength": 488},
        "657": {"vr": "OB", "BinaryLength": 488},
        "658": {"vr": "OB", "BinaryLength": 488},
        "659": {"vr": "OB", "BinaryLength": 488},
        "660": {"vr": "OB", "BinaryLength": 488},
        "661": {"vr": "OB", "BinaryLength": 488},
        "662": {"vr": "OB", "BinaryLength": 488},
        "663": {"vr": "OB", "BinaryLength": 124},
        "664": {"vr": "OB", "BinaryLength": 488},
        "665": {"vr": "OB", "BinaryLength": 488},
        "666": {"vr": "OB", "BinaryLength": 488},
        "667": {"vr": "OB", "BinaryLength": 488},
        "668": {"vr": "OB", "BinaryLength": 124},
        "669": {"vr": "OB", "BinaryLength": 488},
        "670": {"vr": "OB", "BinaryLength": 488},
        "671": {"vr": "OB", "BinaryLength": 488},
        "672": {"vr": "OB", "BinaryLength": 488},
        "673": {"vr": "OB", "BinaryLength": 488},
        "674": {"vr": "OB", "BinaryLength": 488},
        "675": {"vr": "OB", "BinaryLength": 488},
        "676": {"vr": "OB", "BinaryLength": 488},
        "677": {"vr": "OB", "BinaryLength": 488},
        "678": {"vr": "OB", "BinaryLength": 488},
        "679": {"vr": "OB", "BinaryLength": 124},
        "680": {"vr": "OB", "BinaryLength": 488},
        "681": {"vr": "OB", "BinaryLength": 488},
        "682": {"vr": "OB", "BinaryLength": 488},
        "683": {"vr": "OB", "BinaryLength": 488},
        "684": {"vr": "OB", "BinaryLength": 488},
        "685": {"vr": "OB", "BinaryLength": 488},
        "686": {"vr": "OB", "BinaryLength": 488},
        "687": {"vr": "OB", "BinaryLength": 124},
        "688": {"vr": "OB", "BinaryLength": 488},
        "689": {"vr": "OB", "BinaryLength": 488},
        "690": {"vr": "OB", "BinaryLength": 124},
        "691": {"vr": "OB", "BinaryLength": 488},
        "692": {"vr": "OB", "BinaryLength": 488},
        "693": {"vr": "OB", "BinaryLength": 488},
        "694": {"vr": "OB", "BinaryLength": 488},
        "695": {"vr": "OB", "BinaryLength": 488},
        "696": {"vr": "OB", "BinaryLength": 488},
        "697": {"vr": "OB", "BinaryLength": 488},
        "698": {"vr": "OB", "BinaryLength": 488},
        "699": {"vr": "OB", "BinaryLength": 124},
        "700": {"vr": "OB", "BinaryLength": 488},
        "701": {"vr": "OB", "BinaryLength": 488},
        "702": {"vr": "OB", "BinaryLength": 488},
        "703": {"vr": "OB", "BinaryLength": 488},
        "704": {"vr": "OB", "BinaryLength": 488},
        "705": {"vr": "OB", "BinaryLength": 488},
        "706": {"vr": "OB", "BinaryLength": 488},
        "707": {"vr": "OB", "BinaryLength": 124},
        "708": {"vr": "OB", "BinaryLength": 488},
        "709": {"vr": "OB", "BinaryLength": 488},
        "710": {"vr": "OB", "BinaryLength": 488},
        "711": {"vr": "OB", "BinaryLength": 488},
        "712": {"vr": "OB", "BinaryLength": 488},
        "713": {"vr": "OB", "BinaryLength": 488},
        "714": {"vr": "OB", "BinaryLength": 124},
        "715": {"vr": "OB", "BinaryLength": 124},
        "716": {"vr": "OB", "BinaryLength": 488},
        "717": {"vr": "OB", "BinaryLength": 488},
        "718": {"vr": "OB", "BinaryLength": 488},
        "719": {"vr": "OB", "BinaryLength": 488},
        "720": {"vr": "OB", "BinaryLength": 488},
        "721": {"vr": "OB", "BinaryLength": 488},
        "722": {"vr": "OB", "BinaryLength": 488},
        "723": {"vr": "OB", "BinaryLength": 488},
        "724": {"vr": "OB", "BinaryLength": 488},
        "725": {"vr": "OB", "BinaryLength": 488},
        "726": {"vr": "OB", "BinaryLength": 488},
        "727": {"vr": "OB", "BinaryLength": 488},
        "728": {"vr": "OB", "BinaryLength": 488},
        "729": {"vr": "OB", "BinaryLength": 488},
        "730": {"vr": "OB", "BinaryLength": 488},
        "731": {"vr": "OB", "BinaryLength": 488},
        "732": {"vr": "OB", "BinaryLength": 124},
        "733": {"vr": "OB", "BinaryLength": 488},
        "734": {"vr": "OB", "BinaryLength": 488},
        "735": {"vr": "OB", "BinaryLength": 488},
        "736": {"vr": "OB", "BinaryLength": 488},
        "737": {"vr": "OB", "BinaryLength": 488},
        "738": {"vr": "OB", "BinaryLength": 488},
        "739": {"vr": "OB", "BinaryLength": 488},
        "740": {"vr": "OB", "BinaryLength": 488},
        "741": {"vr": "OB", "BinaryLength": 488},
        "742": {"vr": "OB", "BinaryLength": 488},
        "743": {"vr": "OB", "BinaryLength": 488},
        "744": {"vr": "OB", "BinaryLength": 488},
        "745": {"vr": "OB", "BinaryLength": 488},
        "746": {"vr": "OB", "BinaryLength": 488},
        "747": {"vr": "OB", "BinaryLength": 488},
        "748": {"vr": "OB", "BinaryLength": 488},
        "749": {"vr": "OB", "BinaryLength": 488},
        "750": {"vr": "OB", "BinaryLength": 488},
        "751": {"vr": "OB", "BinaryLength": 488},
        "752": {"vr": "OB", "BinaryLength": 488},
        "753": {"vr": "OB", "BinaryLength": 488},
        "754": {"vr": "OB", "BinaryLength": 488},
        "755": {"vr": "OB", "BinaryLength": 488},
        "756": {"vr": "OB", "BinaryLength": 488},
        "757": {"vr": "OB", "BinaryLength": 124},
        "758": {"vr": "OB", "BinaryLength": 488},
        "759": {"vr": "OB", "BinaryLength": 488},
        "760": {"vr": "OB", "BinaryLength": 488},
        "761": {"vr": "OB", "BinaryLength": 488},
        "762": {"vr": "OB", "BinaryLength": 488},
        "763": {"vr": "OB", "BinaryLength": 488},
        "764": {"vr": "OB", "BinaryLength": 488},
        "765": {"vr": "OB", "BinaryLength": 488},
        "766": {"vr": "OB", "BinaryLength": 488},
        "767": {"vr": "OB", "BinaryLength": 488},
        "768": {"vr": "OB", "BinaryLength": 488},
        "769": {"vr": "OB", "BinaryLength": 488},
        "770": {"vr": "OB", "BinaryLength": 488},
        "771": {"vr": "OB", "BinaryLength": 124},
        "772": {"vr": "OB", "BinaryLength": 488},
        "773": {"vr": "OB", "BinaryLength": 488},
        "774": {"vr": "OB", "BinaryLength": 488},
        "775": {"vr": "OB", "BinaryLength": 488},
        "776": {"vr": "OB", "BinaryLength": 488},
        "777": {"vr": "OB", "BinaryLength": 124},
        "778": {"vr": "OB", "BinaryLength": 488},
        "779": {"vr": "OB", "BinaryLength": 488},
        "780": {"vr": "OB", "BinaryLength": 488},
        "781": {"vr": "OB", "BinaryLength": 488},
        "782": {"vr": "OB", "BinaryLength": 488},
        "783": {"vr": "OB", "BinaryLength": 488},
        "784": {"vr": "OB", "BinaryLength": 488},
        "785": {"vr": "OB", "BinaryLength": 488},
        "786": {"vr": "OB", "BinaryLength": 488},
        "787": {"vr": "OB", "BinaryLength": 488},
        "788": {"vr": "OB", "BinaryLength": 124},
        "789": {"vr": "OB", "BinaryLength": 488},
        "790": {"vr": "OB", "BinaryLength": 488},
        "791": {"vr": "OB", "BinaryLength": 124},
        "792": {"vr": "OB", "BinaryLength": 488},
        "793": {"vr": "OB", "BinaryLength": 488},
        "794": {"vr": "OB", "BinaryLength": 488},
        "795": {"vr": "OB", "BinaryLength": 488},
        "796": {"vr": "OB", "BinaryLength": 488},
        "797": {"vr": "OB", "BinaryLength": 488},
        "798": {"vr": "OB", "BinaryLength": 488},
        "799": {"vr": "OB", "BinaryLength": 488},
        "800": {"vr": "OB", "BinaryLength": 488},
        "801": {"vr": "OB", "BinaryLength": 488},
        "802": {"vr": "OB", "BinaryLength": 488},
        "803": {"vr": "OB", "BinaryLength": 488},
        "804": {"vr": "OB", "BinaryLength": 488},
        "805": {"vr": "OB", "BinaryLength": 488},
        "806": {"vr": "OB", "BinaryLength": 488},
        "807": {"vr": "OB", "BinaryLength": 488},
        "808": {"vr": "OB", "BinaryLength": 488},
        "809": {"vr": "OB", "BinaryLength": 488},
        "810": {"vr": "OB", "BinaryLength": 124},
        "811": {"vr": "OB", "BinaryLength": 488},
        "812": {"vr": "OB", "BinaryLength": 488},
        "813": {"vr": "OB", "BinaryLength": 488},
        "814": {"vr": "OB", "BinaryLength": 488},
        "815": {"vr": "OB", "BinaryLength": 488},
        "816": {"vr": "OB", "BinaryLength": 124},
        "817": {"vr": "OB", "BinaryLength": 488},
        "818": {"vr": "OB", "BinaryLength": 488},
        "819": {"vr": "OB", "BinaryLength": 488},
        "820": {"vr": "OB", "BinaryLength": 124},
        "821": {"vr": "OB", "BinaryLength": 488},
        "822": {"vr": "OB", "BinaryLength": 488},
        "823": {"vr": "OB", "BinaryLength": 488},
        "824": {"vr": "OB", "BinaryLength": 488},
        "825": {"vr": "OB", "BinaryLength": 488},
        "826": {"vr": "OB", "BinaryLength": 488},
        "827": {"vr": "OB", "BinaryLength": 124},
        "828": {"vr": "OB", "BinaryLength": 488},
        "829": {"vr": "OB", "BinaryLength": 124},
        "830": {"vr": "OB", "BinaryLength": 488},
        "831": {"vr": "OB", "BinaryLength": 488},
        "832": {"vr": "OB", "BinaryLength": 488},
        "833": {"vr": "OB", "BinaryLength": 488},
        "834": {"vr": "OB", "BinaryLength": 488},
        "835": {"vr": "OB", "BinaryLength": 488},
        "836": {"vr": "OB", "BinaryLength": 488},
        "837": {"vr": "OB", "BinaryLength": 488},
        "838": {"vr": "OB", "BinaryLength": 488},
        "839": {"vr": "OB", "BinaryLength": 488},
        "840": {"vr": "OB", "BinaryLength": 488},
        "841": {"vr": "OB", "BinaryLength": 488},
        "842": {"vr": "OB", "BinaryLength": 488},
        "843": {"vr": "OB", "BinaryLength": 488},
        "844": {"vr": "OB", "BinaryLength": 488},
        "845": {"vr": "OB", "BinaryLength": 488},
        "846": {"vr": "OB", "BinaryLength": 124},
        "847": {"vr": "OB", "BinaryLength": 488},
        "848": {"vr": "OB", "BinaryLength": 488},
        "849": {"vr": "OB", "BinaryLength": 488},
        "850": {"vr": "OB", "BinaryLength": 124},
        "851": {"vr": "OB", "BinaryLength": 488},
        "852": {"vr": "OB", "BinaryLength": 488},
        "853": {"vr": "OB", "BinaryLength": 488},
        "854": {"vr": "OB", "BinaryLength": 488},
        "855": {"vr": "OB", "BinaryLength": 488},
        "856": {"vr": "OB", "BinaryLength": 488},
        "857": {"vr": "OB", "BinaryLength": 488},
        "858": {"vr": "OB", "BinaryLength": 488},
        "859": {"vr": "OB", "BinaryLength": 488},
        "860": {"vr": "OB", "BinaryLength": 488},
        "861": {"vr": "OB", "BinaryLength": 124},
        "862": {"vr": "OB", "BinaryLength": 488},
        "863": {"vr": "OB", "BinaryLength": 488},
        "864": {"vr": "OB", "BinaryLength": 488},
        "865": {"vr": "OB", "BinaryLength": 488},
        "866": {"vr": "OB", "BinaryLength": 488},
        "867": {"vr": "OB", "BinaryLength": 124},
        "868": {"vr": "OB", "BinaryLength": 124},
        "869": {"vr": "OB", "BinaryLength": 488},
        "870": {"vr": "OB", "BinaryLength": 124},
        "871": {"vr": "OB", "BinaryLength": 488},
        "872": {"vr": "OB", "BinaryLength": 488},
        "873": {"vr": "OB", "BinaryLength": 488},
        "874": {"vr": "OB", "BinaryLength": 488},
        "875": {"vr": "OB", "BinaryLength": 124},
        "876": {"vr": "OB", "BinaryLength": 488},
        "877": {"vr": "OB", "BinaryLength": 488},
        "878": {"vr": "OB", "BinaryLength": 488},
        "879": {"vr": "OB", "BinaryLength": 488},
        "880": {"vr": "OB", "BinaryLength": 488},
        "881": {"vr": "OB", "BinaryLength": 488},
        "882": {"vr": "OB", "BinaryLength": 488},
        "883": {"vr": "OB", "BinaryLength": 488},
        "884": {"vr": "OB", "BinaryLength": 488},
        "885": {"vr": "OB", "BinaryLength": 124},
        "886": {"vr": "OB", "BinaryLength": 488},
        "887": {"vr": "OB", "BinaryLength": 488},
        "888": {"vr": "OB", "BinaryLength": 488},
        "889": {"vr": "OB", "BinaryLength": 488},
        "890": {"vr": "OB", "BinaryLength": 488},
        "891": {"vr": "OB", "BinaryLength": 488},
        "892": {"vr": "OB", "BinaryLength": 488},
        "893": {"vr": "OB", "BinaryLength": 488},
        "894": {"vr": "OB", "BinaryLength": 488},
        "895": {"vr": "OB", "BinaryLength": 488},
        "896": {"vr": "OB", "BinaryLength": 488},
        "897": {"vr": "OB", "BinaryLength": 488},
        "898": {"vr": "OB", "BinaryLength": 488},
        "899": {"vr": "OB", "BinaryLength": 488},
        "900": {"vr": "OB", "BinaryLength": 488},
        "901": {"vr": "OB", "BinaryLength": 488},
        "902": {"vr": "OB", "BinaryLength": 488},
        "903": {"vr": "OB", "BinaryLength": 488},
        "904": {"vr": "OB", "BinaryLength": 488},
        "905": {"vr": "OB", "BinaryLength": 488},
        "906": {"vr": "OB", "BinaryLength": 488},
        "907": {"vr": "OB", "BinaryLength": 488},
        "908": {"vr": "OB", "BinaryLength": 488},
        "909": {"vr": "OB", "BinaryLength": 488},
        "910": {"vr": "OB", "BinaryLength": 488},
        "911": {"vr": "OB", "BinaryLength": 488},
        "912": {"vr": "OB", "BinaryLength": 488},
        "913": {"vr": "OB", "BinaryLength": 488},
        "914": {"vr": "OB", "BinaryLength": 488},
        "915": {"vr": "OB", "BinaryLength": 488},
        "916": {"vr": "OB", "BinaryLength": 488},
        "917": {"vr": "OB", "BinaryLength": 488},
        "918": {"vr": "OB", "BinaryLength": 488},
        "919": {"vr": "OB", "BinaryLength": 124},
        "920": {"vr": "OB", "BinaryLength": 488},
        "921": {"vr": "OB", "BinaryLength": 488},
        "922": {"vr": "OB", "BinaryLength": 488},
        "923": {"vr": "OB", "BinaryLength": 488},
        "924": {"vr": "OB", "BinaryLength": 124},
        "925": {"vr": "OB", "BinaryLength": 488},
        "926": {"vr": "OB", "BinaryLength": 124},
        "927": {"vr": "OB", "BinaryLength": 488},
        "928": {"vr": "OB", "BinaryLength": 488},
        "929": {"vr": "OB", "BinaryLength": 488},
        "930": {"vr": "OB", "BinaryLength": 488},
        "931": {"vr": "OB", "BinaryLength": 488},
        "932": {"vr": "OB", "BinaryLength": 124},
        "933": {"vr": "OB", "BinaryLength": 488},
        "934": {"vr": "OB", "BinaryLength": 488},
        "935": {"vr": "OB", "BinaryLength": 488},
        "936": {"vr": "OB", "BinaryLength": 124},
        "937": {"vr": "OB", "BinaryLength": 488},
        "938": {"vr": "OB", "BinaryLength": 488},
        "939": {"vr": "OB", "BinaryLength": 488},
        "940": {"vr": "OB", "BinaryLength": 488},
        "941": {"vr": "OB", "BinaryLength": 488},
        "942": {"vr": "OB", "BinaryLength": 488},
        "943": {"vr": "OB", "BinaryLength": 488},
        "944": {"vr": "OB", "BinaryLength": 488},
        "945": {"vr": "OB", "BinaryLength": 488},
        "946": {"vr": "OB", "BinaryLength": 488},
        "947": {"vr": "OB", "BinaryLength": 488},
        "948": {"vr": "OB", "BinaryLength": 124},
        "949": {"vr": "OB", "BinaryLength": 488},
        "950": {"vr": "OB", "BinaryLength": 488},
        "951": {"vr": "OB", "BinaryLength": 488},
        "952": {"vr": "OB", "BinaryLength": 488},
        "953": {"vr": "OB", "BinaryLength": 488},
        "954": {"vr": "OB", "BinaryLength": 488},
        "955": {"vr": "OB", "BinaryLength": 488},
        "956": {"vr": "OB", "BinaryLength": 124},
        "957": {"vr": "OB", "BinaryLength": 488},
        "958": {"vr": "OB", "BinaryLength": 488},
        "959": {"vr": "OB", "BinaryLength": 488},
        "960": {"vr": "OB", "BinaryLength": 488},
        "961": {"vr": "OB", "BinaryLength": 124},
        "962": {"vr": "OB", "BinaryLength": 488},
        "963": {"vr": "OB", "BinaryLength": 488},
        "964": {"vr": "OB", "BinaryLength": 488},
        "965": {"vr": "OB", "BinaryLength": 488},
        "966": {"vr": "OB", "BinaryLength": 488},
        "967": {"vr": "OB", "BinaryLength": 488},
        "968": {"vr": "OB", "BinaryLength": 488},
        "969": {"vr": "OB", "BinaryLength": 488},
        "970": {"vr": "OB", "BinaryLength": 488},
        "971": {"vr": "OB", "BinaryLength": 488},
        "972": {"vr": "OB", "BinaryLength": 488},
        "973": {"vr": "OB", "BinaryLength": 488},
        "974": {"vr": "OB", "BinaryLength": 488},
        "975": {"vr": "OB", "BinaryLength": 488},
        "976": {"vr": "OB", "BinaryLength": 488},
        "977": {"vr": "OB", "BinaryLength": 488},
        "978": {"vr": "OB", "BinaryLength": 124},
        "979": {"vr": "OB", "BinaryLength": 488},
        "980": {"vr": "OB", "BinaryLength": 488},
        "981": {"vr": "OB", "BinaryLength": 488},
        "982": {"vr": "OB", "BinaryLength": 488},
        "983": {"vr": "OB", "BinaryLength": 124},
        "984": {"vr": "OB", "BinaryLength": 488},
        "985": {"vr": "OB", "BinaryLength": 488},
        "986": {"vr": "OB", "BinaryLength": 488},
        "987": {"vr": "OB", "BinaryLength": 488},
        "988": {"vr": "OB", "BinaryLength": 488},
        "989": {"vr": "OB", "BinaryLength": 488},
        "990": {"vr": "OB", "BinaryLength": 488},
        "991": {"vr": "OB", "BinaryLength": 488},
        "992": {"vr": "OB", "BinaryLength": 488},
        "993": {"vr": "OB", "BinaryLength": 488},
        "994": {"vr": "OB", "BinaryLength": 488},
        "995": {"vr": "OB", "BinaryLength": 488},
        "996": {"vr": "OB", "BinaryLength": 124},
        "997": {"vr": "OB", "BinaryLength": 488},
        "998": {"vr": "OB", "BinaryLength": 488},
        "999": {"vr": "OB", "BinaryLength": 488},
        "1000": {"vr": "OB", "BinaryLength": 488},
        "1001": {"vr": "OB", "BinaryLength": 488},
        "1002": {"vr": "OB", "BinaryLength": 488},
        "1003": {"vr": "OB", "BinaryLength": 488},
        "1004": {"vr": "OB", "BinaryLength": 488},
        "1005": {"vr": "OB", "BinaryLength": 488},
        "1006": {"vr": "OB", "BinaryLength": 488},
        "1007": {"vr": "OB", "BinaryLength": 488},
        "1008": {"vr": "OB", "BinaryLength": 488},
        "1009": {"vr": "OB", "BinaryLength": 488},
        "1010": {"vr": "OB", "BinaryLength": 488},
        "1011": {"vr": "OB", "BinaryLength": 488},
        "1012": {"vr": "OB", "BinaryLength": 488},
        "1013": {"vr": "OB", "BinaryLength": 488},
        "1014": {"vr": "OB", "BinaryLength": 488},
        "1015": {"vr": "OB", "BinaryLength": 124},
        "1016": {"vr": "OB", "BinaryLength": 124},
        "1017": {"vr": "OB", "BinaryLength": 488},
        "1018": {"vr": "OB", "BinaryLength": 488},
        "1019": {"vr": "OB", "BinaryLength": 488},
        "1020": {"vr": "OB", "BinaryLength": 488},
        "1021": {"vr": "OB", "BinaryLength": 488},
        "1022": {"vr": "OB", "BinaryLength": 488},
        "1023": {"vr": "OB", "BinaryLength": 488},
        "1024": {"vr": "OB", "BinaryLength": 488},
        "1025": {"vr": "OB", "BinaryLength": 488},
        "1026": {"vr": "OB", "BinaryLength": 488},
        "1027": {"vr": "OB", "BinaryLength": 488},
        "1028": {"vr": "OB", "BinaryLength": 488},
        "1029": {"vr": "OB", "BinaryLength": 488},
        "1030": {"vr": "OB", "BinaryLength": 124},
        "1031": {"vr": "OB", "BinaryLength": 488},
        "1032": {"vr": "OB", "BinaryLength": 124},
        "1033": {"vr": "OB", "BinaryLength": 488},
        "1034": {"vr": "OB", "BinaryLength": 488},
        "1035": {"vr": "OB", "BinaryLength": 488},
        "1036": {"vr": "OB", "BinaryLength": 488},
        "1037": {"vr": "OB", "BinaryLength": 488},
        "1038": {"vr": "OB", "BinaryLength": 488},
        "1039": {"vr": "OB", "BinaryLength": 124},
        "1040": {"vr": "OB", "BinaryLength": 488},
        "1041": {"vr": "OB", "BinaryLength": 488},
        "1042": {"vr": "OB", "BinaryLength": 488},
        "1043": {"vr": "OB", "BinaryLength": 488},
        "1044": {"vr": "OB", "BinaryLength": 488},
        "1045": {"vr": "OB", "BinaryLength": 488},
        "1046": {"vr": "OB", "BinaryLength": 488},
        "1047": {"vr": "OB", "BinaryLength": 488},
        "1048": {"vr": "OB", "BinaryLength": 488},
        "1049": {"vr": "OB", "BinaryLength": 488},
        "1050": {"vr": "OB", "BinaryLength": 488},
        "1051": {"vr": "OB", "BinaryLength": 488},
        "1052": {"vr": "OB", "BinaryLength": 488},
        "1053": {"vr": "OB", "BinaryLength": 488},
        "1054": {"vr": "OB", "BinaryLength": 488},
        "1055": {"vr": "OB", "BinaryLength": 488},
        "1056": {"vr": "OB", "BinaryLength": 488},
        "1057": {"vr": "OB", "BinaryLength": 488},
        "1058": {"vr": "OB", "BinaryLength": 488},
        "1059": {"vr": "OB", "BinaryLength": 488},
        "1060": {"vr": "OB", "BinaryLength": 124},
        "1061": {"vr": "OB", "BinaryLength": 488},
        "1062": {"vr": "OB", "BinaryLength": 488},
        "1063": {"vr": "OB", "BinaryLength": 488},
        "1064": {"vr": "OB", "BinaryLength": 488},
        "1065": {"vr": "OB", "BinaryLength": 124},
        "1066": {"vr": "OB", "BinaryLength": 488},
        "1067": {"vr": "OB", "BinaryLength": 488},
        "1068": {"vr": "OB", "BinaryLength": 488},
        "1069": {"vr": "OB", "BinaryLength": 488},
        "1070": {"vr": "OB", "BinaryLength": 488},
        "1071": {"vr": "OB", "BinaryLength": 488},
        "1072": {"vr": "OB", "BinaryLength": 488},
        "1073": {"vr": "OB", "BinaryLength": 124},
        "1074": {"vr": "OB", "BinaryLength": 488},
        "1075": {"vr": "OB", "BinaryLength": 488},
        "1076": {"vr": "OB", "BinaryLength": 488},
        "1077": {"vr": "OB", "BinaryLength": 488},
        "1078": {"vr": "OB", "BinaryLength": 488},
        "1079": {"vr": "OB", "BinaryLength": 488},
        "1080": {"vr": "OB", "BinaryLength": 488},
        "1081": {"vr": "OB", "BinaryLength": 124},
        "1082": {"vr": "OB", "BinaryLength": 488},
        "1083": {"vr": "OB", "BinaryLength": 488},
        "1084": {"vr": "OB", "BinaryLength": 488},
        "1085": {"vr": "OB", "BinaryLength": 488},
        "1086": {"vr": "OB", "BinaryLength": 488},
        "1087": {"vr": "OB", "BinaryLength": 488},
        "1088": {"vr": "OB", "BinaryLength": 124},
        "1089": {"vr": "OB", "BinaryLength": 488},
        "1090": {"vr": "OB", "BinaryLength": 124},
        "1091": {"vr": "OB", "BinaryLength": 124},
        "1092": {"vr": "OB", "BinaryLength": 488},
        "1093": {"vr": "OB", "BinaryLength": 488},
        "1094": {"vr": "OB", "BinaryLength": 488},
        "1095": {"vr": "OB", "BinaryLength": 488},
        "1096": {"vr": "OB", "BinaryLength": 488},
        "1097": {"vr": "OB", "BinaryLength": 124},
        "1098": {"vr": "OB", "BinaryLength": 488},
        "1099": {"vr": "OB", "BinaryLength": 488},
        "1100": {"vr": "OB", "BinaryLength": 488},
        "1101": {"vr": "OB", "BinaryLength": 488},
        "1102": {"vr": "OB", "BinaryLength": 488},
        "1103": {"vr": "OB", "BinaryLength": 488},
        "1104": {"vr": "OB", "BinaryLength": 488},
        "1105": {"vr": "OB", "BinaryLength": 124},
        "1106": {"vr": "OB", "BinaryLength": 488},
        "1107": {"vr": "OB", "BinaryLength": 488},
        "1108": {"vr": "OB", "BinaryLength": 488},
        "1109": {"vr": "OB", "BinaryLength": 488},
        "1110": {"vr": "OB", "BinaryLength": 124},
        "1111": {"vr": "OB", "BinaryLength": 488},
        "1112": {"vr": "OB", "BinaryLength": 488},
        "1113": {"vr": "OB", "BinaryLength": 488},
        "1114": {"vr": "OB", "BinaryLength": 488},
        "1115": {"vr": "OB", "BinaryLength": 488},
        "1116": {"vr": "OB", "BinaryLength": 488},
        "1117": {"vr": "OB", "BinaryLength": 488},
        "1118": {"vr": "OB", "BinaryLength": 488},
        "1119": {"vr": "OB", "BinaryLength": 488},
        "1120": {"vr": "OB", "BinaryLength": 488},
        "1121": {"vr": "OB", "BinaryLength": 488},
        "1122": {"vr": "OB", "BinaryLength": 488},
        "1123": {"vr": "OB", "BinaryLength": 488},
        "1124": {"vr": "OB", "BinaryLength": 488},
        "1125": {"vr": "OB", "BinaryLength": 488},
        "1126": {"vr": "OB", "BinaryLength": 488},
        "1127": {"vr": "OB", "BinaryLength": 488},
        "1128": {"vr": "OB", "BinaryLength": 488},
        "1129": {"vr": "OB", "BinaryLength": 488},
        "1130": {"vr": "OB", "BinaryLength": 488},
        "1131": {"vr": "OB", "BinaryLength": 124},
        "1132": {"vr": "OB", "BinaryLength": 488},
        "1133": {"vr": "OB", "BinaryLength": 488},
        "1134": {"vr": "OB", "BinaryLength": 488},
        "1135": {"vr": "OB", "BinaryLength": 488},
        "1136": {"vr": "OB", "BinaryLength": 124},
        "1137": {"vr": "OB", "BinaryLength": 488},
        "1138": {"vr": "OB", "BinaryLength": 488},
        "1139": {"vr": "OB", "BinaryLength": 488},
        "1140": {"vr": "OB", "BinaryLength": 488},
        "1141": {"vr": "OB", "BinaryLength": 488},
        "1142": {"vr": "OB", "BinaryLength": 488},
        "1143": {"vr": "OB", "BinaryLength": 488},
        "1144": {"vr": "OB", "BinaryLength": 488},
        "1145": {"vr": "OB", "BinaryLength": 488},
        "1146": {"vr": "OB", "BinaryLength": 488},
        "1147": {"vr": "OB", "BinaryLength": 124},
        "1148": {"vr": "OB", "BinaryLength": 124},
        "1149": {"vr": "OB", "BinaryLength": 124},
        "1150": {"vr": "OB", "BinaryLength": 488},
        "1151": {"vr": "OB", "BinaryLength": 488},
        "1152": {"vr": "OB", "BinaryLength": 488},
        "1153": {"vr": "OB", "BinaryLength": 488},
        "1154": {"vr": "OB", "BinaryLength": 488},
        "1155": {"vr": "OB", "BinaryLength": 488},
        "1156": {"vr": "OB", "BinaryLength": 488},
        "1157": {"vr": "OB", "BinaryLength": 488},
        "1158": {"vr": "OB", "BinaryLength": 488},
        "1159": {"vr": "OB", "BinaryLength": 488},
        "1160": {"vr": "OB", "BinaryLength": 488},
        "1161": {"vr": "OB", "BinaryLength": 488},
        "1162": {"vr": "OB", "BinaryLength": 488},
        "1163": {"vr": "OB", "BinaryLength": 488},
        "1164": {"vr": "OB", "BinaryLength": 488},
        "1165": {"vr": "OB", "BinaryLength": 124},
        "1166": {"vr": "OB", "BinaryLength": 124},
        "1167": {"vr": "OB", "BinaryLength": 488},
        "1168": {"vr": "OB", "BinaryLength": 488},
        "1169": {"vr": "OB", "BinaryLength": 488},
        "1170": {"vr": "OB", "BinaryLength": 488},
        "1171": {"vr": "OB", "BinaryLength": 488},
        "1172": {"vr": "OB", "BinaryLength": 488},
        "1173": {"vr": "OB", "BinaryLength": 488},
        "1174": {"vr": "OB", "BinaryLength": 488},
        "1175": {"vr": "OB", "BinaryLength": 488},
        "1176": {"vr": "OB", "BinaryLength": 488},
        "1177": {"vr": "OB", "BinaryLength": 488},
        "1178": {"vr": "OB", "BinaryLength": 124},
        "1179": {"vr": "OB", "BinaryLength": 488},
        "1180": {"vr": "OB", "BinaryLength": 488},
        "1181": {"vr": "OB", "BinaryLength": 488},
        "1182": {"vr": "OB", "BinaryLength": 488},
        "1183": {"vr": "OB", "BinaryLength": 488},
        "1184": {"vr": "OB", "BinaryLength": 488},
        "1185": {"vr": "OB", "BinaryLength": 488},
        "1186": {"vr": "OB", "BinaryLength": 488},
        "1187": {"vr": "OB", "BinaryLength": 488},
        "1188": {"vr": "OB", "BinaryLength": 488},
        "1189": {"vr": "OB", "BinaryLength": 124},
        "1190": {"vr": "OB", "BinaryLength": 488},
        "1191": {"vr": "OB", "BinaryLength": 124},
        "1192": {"vr": "OB", "BinaryLength": 488},
        "1193": {"vr": "OB", "BinaryLength": 124},
        "1194": {"vr": "OB", "BinaryLength": 488},
        "1195": {"vr": "OB", "BinaryLength": 488},
        "1196": {"vr": "OB", "BinaryLength": 488},
        "1197": {"vr": "OB", "BinaryLength": 488},
        "1198": {"vr": "OB", "BinaryLength": 488},
        "1199": {"vr": "OB", "BinaryLength": 488},
        "1200": {"vr": "OB", "BinaryLength": 488},
        "1201": {"vr": "OB", "BinaryLength": 124},
        "1202": {"vr": "OB", "BinaryLength": 124},
        "1203": {"vr": "OB", "BinaryLength": 488},
        "1204": {"vr": "OB", "BinaryLength": 488},
        "1205": {"vr": "OB", "BinaryLength": 488},
        "1206": {"vr": "OB", "BinaryLength": 488},
        "1207": {"vr": "OB", "BinaryLength": 488},
        "1208": {"vr": "OB", "BinaryLength": 488},
        "1209": {"vr": "OB", "BinaryLength": 488},
        "1210": {"vr": "OB", "BinaryLength": 488},
        "1211": {"vr": "OB", "BinaryLength": 488},
        "1212": {"vr": "OB", "BinaryLength": 488},
        "1213": {"vr": "OB", "BinaryLength": 488},
        "1214": {"vr": "OB", "BinaryLength": 488},
        "1215": {"vr": "OB", "BinaryLength": 488},
        "1216": {"vr": "OB", "BinaryLength": 488},
        "1217": {"vr": "OB", "BinaryLength": 488},
        "1218": {"vr": "OB", "BinaryLength": 488},
        "1219": {"vr": "OB", "BinaryLength": 124},
        "1220": {"vr": "OB", "BinaryLength": 124},
        "1221": {"vr": "OB", "BinaryLength": 488},
        "1222": {"vr": "OB", "BinaryLength": 488},
        "1223": {"vr": "OB", "BinaryLength": 488},
        "1224": {"vr": "OB", "BinaryLength": 488},
        "1225": {"vr": "OB", "BinaryLength": 488},
        "1226": {"vr": "OB", "BinaryLength": 488},
        "1227": {"vr": "OB", "BinaryLength": 488},
        "1228": {"vr": "OB", "BinaryLength": 488},
        "1229": {"vr": "OB", "BinaryLength": 488},
        "1230": {"vr": "OB", "BinaryLength": 488},
        "1231": {"vr": "OB", "BinaryLength": 488},
        "1232": {"vr": "OB", "BinaryLength": 488},
        "1233": {"vr": "OB", "BinaryLength": 488},
        "1234": {"vr": "OB", "BinaryLength": 488},
        "1235": {"vr": "OB", "BinaryLength": 488},
        "1236": {"vr": "OB", "BinaryLength": 488},
        "1237": {"vr": "OB", "BinaryLength": 488},
        "1238": {"vr": "OB", "BinaryLength": 488},
        "1239": {"vr": "OB", "BinaryLength": 488},
        "1240": {"vr": "OB", "BinaryLength": 488},
        "1241": {"vr": "OB", "BinaryLength": 488},
        "1242": {"vr": "OB", "BinaryLength": 488},
        "1243": {"vr": "OB", "BinaryLength": 488},
        "1244": {"vr": "OB", "BinaryLength": 488},
        "1245": {"vr": "OB", "BinaryLength": 488},
        "1246": {"vr": "OB", "BinaryLength": 488},
        "1247": {"vr": "OB", "BinaryLength": 488},
        "1248": {"vr": "OB", "BinaryLength": 488},
        "1249": {"vr": "OB", "BinaryLength": 488},
        "1250": {"vr": "OB", "BinaryLength": 488},
        "1251": {"vr": "OB", "BinaryLength": 488},
        "1252": {"vr": "OB", "BinaryLength": 488},
        "1253": {"vr": "OB", "BinaryLength": 488},
        "1254": {"vr": "OB", "BinaryLength": 488},
        "1255": {"vr": "OB", "BinaryLength": 488},
        "1256": {"vr": "OB", "BinaryLength": 488},
        "1257": {"vr": "OB", "BinaryLength": 488},
        "1258": {"vr": "OB", "BinaryLength": 488},
        "1259": {"vr": "OB", "BinaryLength": 488},
        "1260": {"vr": "OB", "BinaryLength": 124},
        "1261": {"vr": "OB", "BinaryLength": 488},
        "1262": {"vr": "OB", "BinaryLength": 488},
        "1263": {"vr": "OB", "BinaryLength": 488},
        "1264": {"vr": "OB", "BinaryLength": 124},
        "1265": {"vr": "OB", "BinaryLength": 488},
        "1266": {"vr": "OB", "BinaryLength": 488},
        "1267": {"vr": "OB", "BinaryLength": 488},
        "1268": {"vr": "OB", "BinaryLength": 488},
        "1269": {"vr": "OB", "BinaryLength": 488},
        "1270": {"vr": "OB", "BinaryLength": 488},
        "1271": {"vr": "OB", "BinaryLength": 124},
        "1272": {"vr": "OB", "BinaryLength": 488},
        "1273": {"vr": "OB", "BinaryLength": 488},
        "1274": {"vr": "OB", "BinaryLength": 488},
        "1275": {"vr": "OB", "BinaryLength": 488},
        "1276": {"vr": "OB", "BinaryLength": 488},
        "1277": {"vr": "OB", "BinaryLength": 488},
        "1278": {"vr": "OB", "BinaryLength": 488},
        "1279": {"vr": "OB", "BinaryLength": 488},
        "1280": {"vr": "OB", "BinaryLength": 488},
        "1281": {"vr": "OB", "BinaryLength": 488},
        "1282": {"vr": "OB", "BinaryLength": 124},
        "1283": {"vr": "OB", "BinaryLength": 488},
        "1284": {"vr": "OB", "BinaryLength": 488},
        "1285": {"vr": "OB", "BinaryLength": 488},
        "1286": {"vr": "OB", "BinaryLength": 488},
        "1287": {"vr": "OB", "BinaryLength": 488},
        "1288": {"vr": "OB", "BinaryLength": 488},
        "1289": {"vr": "OB", "BinaryLength": 488},
        "1290": {"vr": "OB", "BinaryLength": 488},
        "1291": {"vr": "OB", "BinaryLength": 124},
        "1292": {"vr": "OB", "BinaryLength": 488},
        "1293": {"vr": "OB", "BinaryLength": 488},
        "1294": {"vr": "OB", "BinaryLength": 488},
        "1295": {"vr": "OB", "BinaryLength": 488},
        "1296": {"vr": "OB", "BinaryLength": 488},
        "1297": {"vr": "OB", "BinaryLength": 488},
        "1298": {"vr": "OB", "BinaryLength": 488},
        "1299": {"vr": "OB", "BinaryLength": 488},
        "1300": {"vr": "OB", "BinaryLength": 124},
        "1301": {"vr": "OB", "BinaryLength": 488},
        "1302": {"vr": "OB", "BinaryLength": 488},
        "1303": {"vr": "OB", "BinaryLength": 488},
        "1304": {"vr": "OB", "BinaryLength": 488},
        "1305": {"vr": "OB", "BinaryLength": 488},
        "1306": {"vr": "OB", "BinaryLength": 488},
        "1307": {"vr": "OB", "BinaryLength": 488},
        "1308": {"vr": "OB", "BinaryLength": 488},
        "1309": {"vr": "OB", "BinaryLength": 124},
        "1310": {"vr": "OB", "BinaryLength": 488},
        "1311": {"vr": "OB", "BinaryLength": 488},
        "1312": {"vr": "OB", "BinaryLength": 488},
        "1313": {"vr": "OB", "BinaryLength": 488},
        "1314": {"vr": "OB", "BinaryLength": 488},
        "1315": {"vr": "OB", "BinaryLength": 488},
        "1316": {"vr": "OB", "BinaryLength": 488},
        "1317": {"vr": "OB", "BinaryLength": 488},
        "1318": {"vr": "OB", "BinaryLength": 488},
        "1319": {"vr": "OB", "BinaryLength": 488},
        "1320": {"vr": "OB", "BinaryLength": 488},
        "1321": {"vr": "OB", "BinaryLength": 488},
        "1322": {"vr": "OB", "BinaryLength": 488},
        "1323": {"vr": "OB", "BinaryLength": 488},
        "1324": {"vr": "OB", "BinaryLength": 124},
        "1325": {"vr": "OB", "BinaryLength": 488},
        "1326": {"vr": "OB", "BinaryLength": 124},
        "1327": {"vr": "OB", "BinaryLength": 488},
        "1328": {"vr": "OB", "BinaryLength": 488},
        "1329": {"vr": "OB", "BinaryLength": 488},
        "1330": {"vr": "OB", "BinaryLength": 124},
        "1331": {"vr": "OB", "BinaryLength": 488},
        "1332": {"vr": "OB", "BinaryLength": 488},
        "1333": {"vr": "OB", "BinaryLength": 124},
        "1334": {"vr": "OB", "BinaryLength": 488},
        "1335": {"vr": "OB", "BinaryLength": 488},
        "1336": {"vr": "OB", "BinaryLength": 488},
        "1337": {"vr": "OB", "BinaryLength": 488},
        "1338": {"vr": "OB", "BinaryLength": 488},
        "1339": {"vr": "OB", "BinaryLength": 488},
        "1340": {"vr": "OB", "BinaryLength": 488},
        "1341": {"vr": "OB", "BinaryLength": 488},
        "1342": {"vr": "OB", "BinaryLength": 488},
        "1343": {"vr": "OB", "BinaryLength": 488},
        "1344": {"vr": "OB", "BinaryLength": 488},
        "1345": {"vr": "OB", "BinaryLength": 488},
        "1346": {"vr": "OB", "BinaryLength": 488},
        "1347": {"vr": "OB", "BinaryLength": 124},
        "1348": {"vr": "OB", "BinaryLength": 488},
        "1349": {"vr": "OB", "BinaryLength": 488},
        "1350": {"vr": "OB", "BinaryLength": 488},
        "1351": {"vr": "OB", "BinaryLength": 488},
        "1352": {"vr": "OB", "BinaryLength": 488},
        "1353": {"vr": "OB", "BinaryLength": 488},
        "1354": {"vr": "OB", "BinaryLength": 488},
        "1355": {"vr": "OB", "BinaryLength": 488},
        "1356": {"vr": "OB", "BinaryLength": 488},
        "1357": {"vr": "OB", "BinaryLength": 488},
        "1358": {"vr": "OB", "BinaryLength": 124},
        "1359": {"vr": "OB", "BinaryLength": 488},
        "1360": {"vr": "OB", "BinaryLength": 488},
        "1361": {"vr": "OB", "BinaryLength": 488},
        "1362": {"vr": "OB", "BinaryLength": 488},
        "1363": {"vr": "OB", "BinaryLength": 488},
        "1364": {"vr": "OB", "BinaryLength": 488},
        "1365": {"vr": "OB", "BinaryLength": 488},
        "1366": {"vr": "OB", "BinaryLength": 488},
        "1367": {"vr": "OB", "BinaryLength": 488},
        "1368": {"vr": "OB", "BinaryLength": 488},
        "1369": {"vr": "OB", "BinaryLength": 488},
        "1370": {"vr": "OB", "BinaryLength": 488},
        "1371": {"vr": "OB", "BinaryLength": 488},
        "1372": {"vr": "OB", "BinaryLength": 488},
        "1373": {"vr": "OB", "BinaryLength": 488},
        "1374": {"vr": "OB", "BinaryLength": 488},
        "1375": {"vr": "OB", "BinaryLength": 124},
        "1376": {"vr": "OB", "BinaryLength": 488},
        "1377": {"vr": "OB", "BinaryLength": 488},
        "1378": {"vr": "OB", "BinaryLength": 488},
        "1379": {"vr": "OB", "BinaryLength": 488},
        "1380": {"vr": "OB", "BinaryLength": 488},
        "1381": {"vr": "OB", "BinaryLength": 124},
        "1382": {"vr": "OB", "BinaryLength": 488},
        "1383": {"vr": "OB", "BinaryLength": 488},
        "1384": {"vr": "OB", "BinaryLength": 488},
        "1385": {"vr": "OB", "BinaryLength": 488},
        "1386": {"vr": "OB", "BinaryLength": 488},
        "1387": {"vr": "OB", "BinaryLength": 488},
        "1388": {"vr": "OB", "BinaryLength": 488},
        "1389": {"vr": "OB", "BinaryLength": 488},
        "1390": {"vr": "OB", "BinaryLength": 488},
        "1391": {"vr": "OB", "BinaryLength": 488},
        "1392": {"vr": "OB", "BinaryLength": 488},
        "1393": {"vr": "OB", "BinaryLength": 488},
        "1394": {"vr": "OB", "BinaryLength": 488},
        "1395": {"vr": "OB", "BinaryLength": 488},
        "1396": {"vr": "OB", "BinaryLength": 488},
        "1397": {"vr": "OB", "BinaryLength": 488},
        "1398": {"vr": "OB", "BinaryLength": 488},
        "1399": {"vr": "OB", "BinaryLength": 488},
        "1400": {"vr": "OB", "BinaryLength": 488},
        "1401": {"vr": "OB", "BinaryLength": 488},
        "1402": {"vr": "OB", "BinaryLength": 488},
        "1403": {"vr": "OB", "BinaryLength": 488},
        "1404": {"vr": "OB", "BinaryLength": 124},
        "1405": {"vr": "OB", "BinaryLength": 488},
        "1406": {"vr": "OB", "BinaryLength": 488},
        "1407": {"vr": "OB", "BinaryLength": 488},
        "1408": {"vr": "OB", "BinaryLength": 488},
        "1409": {"vr": "OB", "BinaryLength": 488},
        "1410": {"vr": "OB", "BinaryLength": 488},
        "1411": {"vr": "OB", "BinaryLength": 488},
        "1412": {"vr": "OB", "BinaryLength": 488},
        "1413": {"vr": "OB", "BinaryLength": 124},
        "1414": {"vr": "OB", "BinaryLength": 488},
        "1415": {"vr": "OB", "BinaryLength": 488},
        "1416": {"vr": "OB", "BinaryLength": 488},
        "1417": {"vr": "OB", "BinaryLength": 124},
        "1418": {"vr": "OB", "BinaryLength": 488},
        "1419": {"vr": "OB", "BinaryLength": 488},
        "1420": {"vr": "OB", "BinaryLength": 488},
        "1421": {"vr": "OB", "BinaryLength": 488},
        "1422": {"vr": "OB", "BinaryLength": 488},
        "1423": {"vr": "OB", "BinaryLength": 488},
        "1424": {"vr": "OB", "BinaryLength": 488},
        "1425": {"vr": "OB", "BinaryLength": 488},
        "1426": {"vr": "OB", "BinaryLength": 488},
        "1427": {"vr": "OB", "BinaryLength": 488},
        "1428": {"vr": "OB", "BinaryLength": 488},
        "1429": {"vr": "OB", "BinaryLength": 488},
        "1430": {"vr": "OB", "BinaryLength": 124},
        "1431": {"vr": "OB", "BinaryLength": 488},
        "1432": {"vr": "OB", "BinaryLength": 488},
        "1433": {"vr": "OB", "BinaryLength": 488},
        "1434": {"vr": "OB", "BinaryLength": 488},
        "1435": {"vr": "OB", "BinaryLength": 488},
        "1436": {"vr": "OB", "BinaryLength": 488},
        "1437": {"vr": "OB", "BinaryLength": 488},
        "1438": {"vr": "OB", "BinaryLength": 488},
        "1439": {"vr": "OB", "BinaryLength": 488},
        "1440": {"vr": "OB", "BinaryLength": 488},
        "1441": {"vr": "OB", "BinaryLength": 488},
        "1442": {"vr": "OB", "BinaryLength": 124},
        "1443": {"vr": "OB", "BinaryLength": 488},
        "1444": {"vr": "OB", "BinaryLength": 488},
        "1445": {"vr": "OB", "BinaryLength": 488},
        "1446": {"vr": "OB", "BinaryLength": 488},
        "1447": {"vr": "OB", "BinaryLength": 488},
        "1448": {"vr": "OB", "BinaryLength": 488},
        "1449": {"vr": "OB", "BinaryLength": 124},
        "1450": {"vr": "OB", "BinaryLength": 488},
        "1451": {"vr": "OB", "BinaryLength": 488},
        "1452": {"vr": "OB", "BinaryLength": 488},
        "1453": {"vr": "OB", "BinaryLength": 488},
        "1454": {"vr": "OB", "BinaryLength": 488},
        "1455": {"vr": "OB", "BinaryLength": 124},
        "1456": {"vr": "OB", "BinaryLength": 488},
        "1457": {"vr": "OB", "BinaryLength": 488},
        "1458": {"vr": "OB", "BinaryLength": 488},
        "1459": {"vr": "OB", "BinaryLength": 488},
        "1460": {"vr": "OB", "BinaryLength": 124},
        "1461": {"vr": "OB", "BinaryLength": 124},
        "1462": {"vr": "OB", "BinaryLength": 488},
        "1463": {"vr": "OB", "BinaryLength": 488},
        "1464": {"vr": "OB", "BinaryLength": 488},
        "1465": {"vr": "OB", "BinaryLength": 488},
        "1466": {"vr": "OB", "BinaryLength": 488},
        "1467": {"vr": "OB", "BinaryLength": 488},
        "1468": {"vr": "OB", "BinaryLength": 488},
        "1469": {"vr": "OB", "BinaryLength": 488},
        "1470": {"vr": "OB", "BinaryLength": 488},
        "1471": {"vr": "OB", "BinaryLength": 488},
        "1472": {"vr": "OB", "BinaryLength": 488},
        "1473": {"vr": "OB", "BinaryLength": 488},
        "1474": {"vr": "OB", "BinaryLength": 124},
        "1475": {"vr": "OB", "BinaryLength": 488},
        "1476": {"vr": "OB", "BinaryLength": 488},
        "1477": {"vr": "OB", "BinaryLength": 488},
        "1478": {"vr": "OB", "BinaryLength": 488},
        "1479": {"vr": "OB", "BinaryLength": 488},
        "1480": {"vr": "OB", "BinaryLength": 488},
        "1481": {"vr": "OB", "BinaryLength": 488},
        "1482": {"vr": "OB", "BinaryLength": 488},
        "1483": {"vr": "OB", "BinaryLength": 488},
        "1484": {"vr": "OB", "BinaryLength": 488},
        "1485": {"vr": "OB", "BinaryLength": 488},
        "1486": {"vr": "OB", "BinaryLength": 488},
        "1487": {"vr": "OB", "BinaryLength": 488},
        "1488": {"vr": "OB", "BinaryLength": 124},
        "1489": {"vr": "OB", "BinaryLength": 488},
        "1490": {"vr": "OB", "BinaryLength": 488},
        "1491": {"vr": "OB", "BinaryLength": 488},
        "1492": {"vr": "OB", "BinaryLength": 488},
        "1493": {"vr": "OB", "BinaryLength": 124},
        "1494": {"vr": "OB", "BinaryLength": 488},
        "1495": {"vr": "OB", "BinaryLength": 488},
        "1496": {"vr": "OB", "BinaryLength": 488},
        "1497": {"vr": "OB", "BinaryLength": 488},
        "1498": {"vr": "OB", "BinaryLength": 488},
        "1499": {"vr": "OB", "BinaryLength": 488},
        "1500": {"vr": "OB", "BinaryLength": 488},
        "1501": {"vr": "OB", "BinaryLength": 488},
        "1502": {"vr": "OB", "BinaryLength": 488},
        "1503": {"vr": "OB", "BinaryLength": 488},
        "1504": {"vr": "OB", "BinaryLength": 488},
        "1505": {"vr": "OB", "BinaryLength": 488},
        "1506": {"vr": "OB", "BinaryLength": 488},
        "1507": {"vr": "OB", "BinaryLength": 488},
        "1508": {"vr": "OB", "BinaryLength": 488},
        "1509": {"vr": "OB", "BinaryLength": 488},
        "1510": {"vr": "OB", "BinaryLength": 488},
        "1511": {"vr": "OB", "BinaryLength": 488},
        "1512": {"vr": "OB", "BinaryLength": 124},
        "1513": {"vr": "OB", "BinaryLength": 488},
        "1514": {"vr": "OB", "BinaryLength": 488},
        "1515": {"vr": "OB", "BinaryLength": 124},
        "1516": {"vr": "OB", "BinaryLength": 488},
        "1517": {"vr": "OB", "BinaryLength": 124},
        "1518": {"vr": "OB", "BinaryLength": 488},
        "1519": {"vr": "OB", "BinaryLength": 488},
        "1520": {"vr": "OB", "BinaryLength": 488},
        "1521": {"vr": "OB", "BinaryLength": 488},
        "1522": {"vr": "OB", "BinaryLength": 488},
        "1523": {"vr": "OB", "BinaryLength": 488},
        "1524": {"vr": "OB", "BinaryLength": 488},
        "1525": {"vr": "OB", "BinaryLength": 488},
        "1526": {"vr": "OB", "BinaryLength": 488},
        "1527": {"vr": "OB", "BinaryLength": 488},
        "1528": {"vr": "OB", "BinaryLength": 488},
        "1529": {"vr": "OB", "BinaryLength": 488},
        "1530": {"vr": "OB", "BinaryLength": 488},
        "1531": {"vr": "OB", "BinaryLength": 488},
        "1532": {"vr": "OB", "BinaryLength": 488},
        "1533": {"vr": "OB", "BinaryLength": 488},
        "1534": {"vr": "OB", "BinaryLength": 488},
        "1535": {"vr": "OB", "BinaryLength": 488},
        "1536": {"vr": "OB", "BinaryLength": 124},
        "1537": {"vr": "OB", "BinaryLength": 488},
        "1538": {"vr": "OB", "BinaryLength": 488},
        "1539": {"vr": "OB", "BinaryLength": 488},
        "1540": {"vr": "OB", "BinaryLength": 488},
        "1541": {"vr": "OB", "BinaryLength": 488},
        "1542": {"vr": "OB", "BinaryLength": 488},
        "1543": {"vr": "OB", "BinaryLength": 488},
        "1544": {"vr": "OB", "BinaryLength": 488},
        "1545": {"vr": "OB", "BinaryLength": 488},
        "1546": {"vr": "OB", "BinaryLength": 488},
        "1547": {"vr": "OB", "BinaryLength": 488},
        "1548": {"vr": "OB", "BinaryLength": 488},
        "1549": {"vr": "OB", "BinaryLength": 488},
        "1550": {"vr": "OB", "BinaryLength": 488},
        "1551": {"vr": "OB", "BinaryLength": 488},
        "1552": {"vr": "OB", "BinaryLength": 488},
        "1553": {"vr": "OB", "BinaryLength": 124},
        "1554": {"vr": "OB", "BinaryLength": 488},
        "1555": {"vr": "OB", "BinaryLength": 124},
        "1556": {"vr": "OB", "BinaryLength": 488},
        "1557": {"vr": "OB", "BinaryLength": 488},
        "1558": {"vr": "OB", "BinaryLength": 488},
        "1559": {"vr": "OB", "BinaryLength": 124},
        "1560": {"vr": "OB", "BinaryLength": 488},
        "1561": {"vr": "OB", "BinaryLength": 488},
        "1562": {"vr": "OB", "BinaryLength": 124},
        "1563": {"vr": "OB", "BinaryLength": 488},
        "1564": {"vr": "OB", "BinaryLength": 488},
        "1565": {"vr": "OB", "BinaryLength": 488},
        "1566": {"vr": "OB", "BinaryLength": 488},
        "1567": {"vr": "OB", "BinaryLength": 488},
        "1568": {"vr": "OB", "BinaryLength": 488},
        "1569": {"vr": "OB", "BinaryLength": 488},
        "1570": {"vr": "OB", "BinaryLength": 488},
        "1571": {"vr": "OB", "BinaryLength": 488},
        "1572": {"vr": "OB", "BinaryLength": 488},
        "1573": {"vr": "OB", "BinaryLength": 488},
        "1574": {"vr": "OB", "BinaryLength": 124},
        "1575": {"vr": "OB", "BinaryLength": 488},
        "1576": {"vr": "OB", "BinaryLength": 488},
        "1577": {"vr": "OB", "BinaryLength": 488},
        "1578": {"vr": "OB", "BinaryLength": 488},
        "1579": {"vr": "OB", "BinaryLength": 488},
        "1580": {"vr": "OB", "BinaryLength": 488},
        "1581": {"vr": "OB", "BinaryLength": 488},
        "1582": {"vr": "OB", "BinaryLength": 488},
        "1583": {"vr": "OB", "BinaryLength": 488},
        "1584": {"vr": "OB", "BinaryLength": 488},
        "1585": {"vr": "OB", "BinaryLength": 488},
        "1586": {"vr": "OB", "BinaryLength": 488},
        "1587": {"vr": "OB", "BinaryLength": 488},
        "1588": {"vr": "OB", "BinaryLength": 488},
        "1589": {"vr": "OB", "BinaryLength": 488},
        "1590": {"vr": "OB", "BinaryLength": 124},
        "1591": {"vr": "OB", "BinaryLength": 488},
        "1592": {"vr": "OB", "BinaryLength": 488},
        "1593": {"vr": "OB", "BinaryLength": 488},
        "1594": {"vr": "OB", "BinaryLength": 124},
        "1595": {"vr": "OB", "BinaryLength": 488},
        "1596": {"vr": "OB", "BinaryLength": 488},
        "1597": {"vr": "OB", "BinaryLength": 488},
        "1598": {"vr": "OB", "BinaryLength": 488},
        "1599": {"vr": "OB", "BinaryLength": 488},
        "1600": {"vr": "OB", "BinaryLength": 124},
        "1601": {"vr": "OB", "BinaryLength": 124},
        "1602": {"vr": "OB", "BinaryLength": 488},
        "1603": {"vr": "OB", "BinaryLength": 124},
        "1604": {"vr": "OB", "BinaryLength": 124},
        "1605": {"vr": "OB", "BinaryLength": 488},
        "1606": {"vr": "OB", "BinaryLength": 488},
        "1607": {"vr": "OB", "BinaryLength": 488},
        "1608": {"vr": "OB", "BinaryLength": 488},
        "1609": {"vr": "OB", "BinaryLength": 488},
        "1610": {"vr": "OB", "BinaryLength": 124},
        "1611": {"vr": "OB", "BinaryLength": 488},
        "1612": {"vr": "OB", "BinaryLength": 488},
        "1613": {"vr": "OB", "BinaryLength": 488},
        "1614": {"vr": "OB", "BinaryLength": 488},
        "1615": {"vr": "OB", "BinaryLength": 488},
        "1616": {"vr": "OB", "BinaryLength": 488},
        "1617": {"vr": "OB", "BinaryLength": 488},
        "1618": {"vr": "OB", "BinaryLength": 488},
        "1619": {"vr": "OB", "BinaryLength": 488},
        "1620": {"vr": "OB", "BinaryLength": 488},
        "1621": {"vr": "OB", "BinaryLength": 488},
        "1622": {"vr": "OB", "BinaryLength": 488},
        "1623": {"vr": "OB", "BinaryLength": 488},
        "1624": {"vr": "OB", "BinaryLength": 488},
        "1625": {"vr": "OB", "BinaryLength": 124},
        "1626": {"vr": "OB", "BinaryLength": 488},
        "1627": {"vr": "OB", "BinaryLength": 488},
        "1628": {"vr": "OB", "BinaryLength": 488},
        "1629": {"vr": "OB", "BinaryLength": 488},
        "1630": {"vr": "OB", "BinaryLength": 488},
        "1631": {"vr": "OB", "BinaryLength": 488},
        "1632": {"vr": "OB", "BinaryLength": 488},
        "1633": {"vr": "OB", "BinaryLength": 488},
        "1634": {"vr": "OB", "BinaryLength": 488},
        "1635": {"vr": "OB", "BinaryLength": 488},
        "1636": {"vr": "OB", "BinaryLength": 488},
        "1637": {"vr": "OB", "BinaryLength": 488},
        "1638": {"vr": "OB", "BinaryLength": 488},
        "1639": {"vr": "OB", "BinaryLength": 488},
        "1640": {"vr": "OB", "BinaryLength": 488},
        "1641": {"vr": "OB", "BinaryLength": 488},
        "1642": {"vr": "OB", "BinaryLength": 488},
        "1643": {"vr": "OB", "BinaryLength": 124},
        "1644": {"vr": "OB", "BinaryLength": 124},
        "1645": {"vr": "OB", "BinaryLength": 488},
        "1646": {"vr": "OB", "BinaryLength": 488},
        "1647": {"vr": "OB", "BinaryLength": 488},
        "1648": {"vr": "OB", "BinaryLength": 488},
        "1649": {"vr": "OB", "BinaryLength": 124},
        "1650": {"vr": "OB", "BinaryLength": 488},
        "1651": {"vr": "OB", "BinaryLength": 488},
        "1652": {"vr": "OB", "BinaryLength": 488},
        "1653": {"vr": "OB", "BinaryLength": 488},
        "1654": {"vr": "OB", "BinaryLength": 488},
        "1655": {"vr": "OB", "BinaryLength": 488},
        "1656": {"vr": "OB", "BinaryLength": 488},
        "1657": {"vr": "OB", "BinaryLength": 488},
        "1658": {"vr": "OB", "BinaryLength": 488},
        "1659": {"vr": "OB", "BinaryLength": 488},
        "1660": {"vr": "OB", "BinaryLength": 488},
        "1661": {"vr": "OB", "BinaryLength": 488},
        "1662": {"vr": "OB", "BinaryLength": 488},
        "1663": {"vr": "OB", "BinaryLength": 488},
        "1664": {"vr": "OB", "BinaryLength": 488},
        "1665": {"vr": "OB", "BinaryLength": 488},
        "1666": {"vr": "OB", "BinaryLength": 488},
        "1667": {"vr": "OB", "BinaryLength": 488},
        "1668": {"vr": "OB", "BinaryLength": 488},
        "1669": {"vr": "OB", "BinaryLength": 488},
        "1670": {"vr": "OB", "BinaryLength": 488},
        "1671": {"vr": "OB", "BinaryLength": 488},
        "1672": {"vr": "OB", "BinaryLength": 488},
        "1673": {"vr": "OB", "BinaryLength": 488},
        "1674": {"vr": "OB", "BinaryLength": 488},
        "1675": {"vr": "OB", "BinaryLength": 488},
        "1676": {"vr": "OB", "BinaryLength": 488},
        "1677": {"vr": "OB", "BinaryLength": 488},
        "1678": {"vr": "OB", "BinaryLength": 488},
        "1679": {"vr": "OB", "BinaryLength": 488},
        "1680": {"vr": "OB", "BinaryLength": 488},
        "1681": {"vr": "OB", "BinaryLength": 488},
        "1682": {"vr": "OB", "BinaryLength": 488},
        "1683": {"vr": "OB", "BinaryLength": 488},
        "1684": {"vr": "OB", "BinaryLength": 488},
        "1685": {"vr": "OB", "BinaryLength": 488},
        "1686": {"vr": "OB", "BinaryLength": 488},
        "1687": {"vr": "OB", "BinaryLength": 488},
        "1688": {"vr": "OB", "BinaryLength": 488},
        "1689": {"vr": "OB", "BinaryLength": 124},
        "1690": {"vr": "OB", "BinaryLength": 488},
        "1691": {"vr": "OB", "BinaryLength": 124},
        "1692": {"vr": "OB", "BinaryLength": 488},
        "1693": {"vr": "OB", "BinaryLength": 488},
        "1694": {"vr": "OB", "BinaryLength": 488},
        "1695": {"vr": "OB", "BinaryLength": 488},
        "1696": {"vr": "OB", "BinaryLength": 488},
        "1697": {"vr": "OB", "BinaryLength": 488},
        "1698": {"vr": "OB", "BinaryLength": 488},
        "1699": {"vr": "OB", "BinaryLength": 488},
        "1700": {"vr": "OB", "BinaryLength": 124},
        "1701": {"vr": "OB", "BinaryLength": 488},
        "1702": {"vr": "OB", "BinaryLength": 488},
        "1703": {"vr": "OB", "BinaryLength": 488},
        "1704": {"vr": "OB", "BinaryLength": 488},
        "1705": {"vr": "OB", "BinaryLength": 488},
        "1706": {"vr": "OB", "BinaryLength": 488},
        "1707": {"vr": "OB", "BinaryLength": 488},
        "1708": {"vr": "OB", "BinaryLength": 488},
        "1709": {"vr": "OB", "BinaryLength": 488},
        "1710": {"vr": "OB", "BinaryLength": 488},
        "1711": {"vr": "OB", "BinaryLength": 488},
        "1712": {"vr": "OB", "BinaryLength": 488},
        "1713": {"vr": "OB", "BinaryLength": 488},
        "1714": {"vr": "OB", "BinaryLength": 488},
        "1715": {"vr": "OB", "BinaryLength": 488},
        "1716": {"vr": "OB", "BinaryLength": 488},
        "1717": {"vr": "OB", "BinaryLength": 124},
        "1718": {"vr": "OB", "BinaryLength": 488},
        "1719": {"vr": "OB", "BinaryLength": 488},
        "1720": {"vr": "OB", "BinaryLength": 124},
        "1721": {"vr": "OB", "BinaryLength": 488},
        "1722": {"vr": "OB", "BinaryLength": 488},
        "1723": {"vr": "OB", "BinaryLength": 488},
        "1724": {"vr": "OB", "BinaryLength": 488},
        "1725": {"vr": "OB", "BinaryLength": 488},
        "1726": {"vr": "OB", "BinaryLength": 488},
        "1727": {"vr": "OB", "BinaryLength": 488},
        "1728": {"vr": "OB", "BinaryLength": 488},
        "1729": {"vr": "OB", "BinaryLength": 488},
        "1730": {"vr": "OB", "BinaryLength": 488},
        "1731": {"vr": "OB", "BinaryLength": 488},
        "1732": {"vr": "OB", "BinaryLength": 488},
        "1733": {"vr": "OB", "BinaryLength": 488},
        "1734": {"vr": "OB", "BinaryLength": 488},
        "1735": {"vr": "OB", "BinaryLength": 488},
        "1736": {"vr": "OB", "BinaryLength": 124},
        "1737": {"vr": "OB", "BinaryLength": 488},
        "1738": {"vr": "OB", "BinaryLength": 124},
        "1739": {"vr": "OB", "BinaryLength": 488},
        "1740": {"vr": "OB", "BinaryLength": 488},
        "1741": {"vr": "OB", "BinaryLength": 488},
        "1742": {"vr": "OB", "BinaryLength": 488},
        "1743": {"vr": "OB", "BinaryLength": 488},
        "1744": {"vr": "OB", "BinaryLength": 488},
        "1745": {"vr": "OB", "BinaryLength": 488},
        "1746": {"vr": "OB", "BinaryLength": 488},
        "1747": {"vr": "OB", "BinaryLength": 488},
        "1748": {"vr": "OB", "BinaryLength": 488},
        "1749": {"vr": "OB", "BinaryLength": 488},
        "1750": {"vr": "OB", "BinaryLength": 488},
        "1751": {"vr": "OB", "BinaryLength": 488},
        "1752": {"vr": "OB", "BinaryLength": 488},
        "1753": {"vr": "OB", "BinaryLength": 488},
        "1754": {"vr": "OB", "BinaryLength": 488},
        "1755": {"vr": "OB", "BinaryLength": 488},
        "1756": {"vr": "OB", "BinaryLength": 488},
        "1757": {"vr": "OB", "BinaryLength": 488},
        "1758": {"vr": "OB", "BinaryLength": 488},
        "1759": {"vr": "OB", "BinaryLength": 488},
        "1760": {"vr": "OB", "BinaryLength": 488},
        "1761": {"vr": "OB", "BinaryLength": 488},
        "1762": {"vr": "OB", "BinaryLength": 488},
        "1763": {"vr": "OB", "BinaryLength": 488},
        "1764": {"vr": "OB", "BinaryLength": 488},
        "1765": {"vr": "OB", "BinaryLength": 488},
        "1766": {"vr": "OB", "BinaryLength": 488},
        "1767": {"vr": "OB", "BinaryLength": 488},
        "1768": {"vr": "OB", "BinaryLength": 488},
        "1769": {"vr": "OB", "BinaryLength": 488},
        "1770": {"vr": "OB", "BinaryLength": 488},
        "1771": {"vr": "OB", "BinaryLength": 488},
        "1772": {"vr": "OB", "BinaryLength": 488},
        "1773": {"vr": "OB", "BinaryLength": 488},
        "1774": {"vr": "OB", "BinaryLength": 488},
        "1775": {"vr": "OB", "BinaryLength": 124},
        "1776": {"vr": "OB", "BinaryLength": 488},
        "1777": {"vr": "OB", "BinaryLength": 488},
        "1778": {"vr": "OB", "BinaryLength": 488},
        "1779": {"vr": "OB", "BinaryLength": 488},
        "1780": {"vr": "OB", "BinaryLength": 488},
        "1781": {"vr": "OB", "BinaryLength": 488},
        "1782": {"vr": "OB", "BinaryLength": 488},
        "1783": {"vr": "OB", "BinaryLength": 488},
        "1784": {"vr": "OB", "BinaryLength": 488},
        "1785": {"vr": "OB", "BinaryLength": 488},
        "1786": {"vr": "OB", "BinaryLength": 488},
        "1787": {"vr": "OB", "BinaryLength": 488},
        "1788": {"vr": "OB", "BinaryLength": 488},
        "1789": {"vr": "OB", "BinaryLength": 488},
        "1790": {"vr": "OB", "BinaryLength": 488},
        "1791": {"vr": "OB", "BinaryLength": 488},
        "1792": {"vr": "OB", "BinaryLength": 488},
        "1793": {"vr": "OB", "BinaryLength": 488},
        "1794": {"vr": "OB", "BinaryLength": 488},
        "1795": {"vr": "OB", "BinaryLength": 488},
        "1796": {"vr": "OB", "BinaryLength": 124},
        "1797": {"vr": "OB", "BinaryLength": 488},
        "1798": {"vr": "OB", "BinaryLength": 488},
        "1799": {"vr": "OB", "BinaryLength": 488},
        "1800": {"vr": "OB", "BinaryLength": 488},
        "1801": {"vr": "OB", "BinaryLength": 488},
        "1802": {"vr": "OB", "BinaryLength": 124},
        "1803": {"vr": "OB", "BinaryLength": 488},
        "1804": {"vr": "OB", "BinaryLength": 488},
        "1805": {"vr": "OB", "BinaryLength": 124},
        "1806": {"vr": "OB", "BinaryLength": 488},
        "1807": {"vr": "OB", "BinaryLength": 488},
        "1808": {"vr": "OB", "BinaryLength": 488},
        "1809": {"vr": "OB", "BinaryLength": 488},
        "1810": {"vr": "OB", "BinaryLength": 488},
        "1811": {"vr": "OB", "BinaryLength": 488},
        "1812": {"vr": "OB", "BinaryLength": 488},
        "1813": {"vr": "OB", "BinaryLength": 488},
        "1814": {"vr": "OB", "BinaryLength": 488},
        "1815": {"vr": "OB", "BinaryLength": 488},
        "1816": {"vr": "OB", "BinaryLength": 488},
        "1817": {"vr": "OB", "BinaryLength": 488},
        "1818": {"vr": "OB", "BinaryLength": 488},
        "1819": {"vr": "OB", "BinaryLength": 488},
        "1820": {"vr": "OB", "BinaryLength": 488},
        "1821": {"vr": "OB", "BinaryLength": 488},
        "1822": {"vr": "OB", "BinaryLength": 488},
        "1823": {"vr": "OB", "BinaryLength": 488},
        "1824": {"vr": "OB", "BinaryLength": 488},
        "1825": {"vr": "OB", "BinaryLength": 488},
        "1826": {"vr": "OB", "BinaryLength": 488},
        "1827": {"vr": "OB", "BinaryLength": 124},
        "1828": {"vr": "OB", "BinaryLength": 488},
        "1829": {"vr": "OB", "BinaryLength": 488},
        "1830": {"vr": "OB", "BinaryLength": 488},
        "1831": {"vr": "OB", "BinaryLength": 488},
        "1832": {"vr": "OB", "BinaryLength": 488},
        "1833": {"vr": "OB", "BinaryLength": 488},
        "1834": {"vr": "OB", "BinaryLength": 488},
        "1835": {"vr": "OB", "BinaryLength": 488},
        "1836": {"vr": "OB", "BinaryLength": 488},
        "1837": {"vr": "OB", "BinaryLength": 124},
        "1838": {"vr": "OB", "BinaryLength": 124},
        "1839": {"vr": "OB", "BinaryLength": 488},
        "1840": {"vr": "OB", "BinaryLength": 488},
        "1841": {"vr": "OB", "BinaryLength": 488},
        "1842": {"vr": "OB", "BinaryLength": 488},
        "1843": {"vr": "OB", "BinaryLength": 488},
        "1844": {"vr": "OB", "BinaryLength": 488},
        "1845": {"vr": "OB", "BinaryLength": 124},
        "1846": {"vr": "OB", "BinaryLength": 488},
        "1847": {"vr": "OB", "BinaryLength": 488},
        "1848": {"vr": "OB", "BinaryLength": 488},
        "1849": {"vr": "OB", "BinaryLength": 488},
        "1850": {"vr": "OB", "BinaryLength": 488},
        "1851": {"vr": "OB", "BinaryLength": 488},
        "1852": {"vr": "OB", "BinaryLength": 488},
        "1853": {"vr": "OB", "BinaryLength": 488},
        "1854": {"vr": "OB", "BinaryLength": 488},
        "1855": {"vr": "OB", "BinaryLength": 488},
        "1856": {"vr": "OB", "BinaryLength": 488},
        "1857": {"vr": "OB", "BinaryLength": 488},
        "1858": {"vr": "OB", "BinaryLength": 488},
        "1859": {"vr": "OB", "BinaryLength": 488},
        "1860": {"vr": "OB", "BinaryLength": 488},
        "1861": {"vr": "OB", "BinaryLength": 488},
        "1862": {"vr": "OB", "BinaryLength": 488},
        "1863": {"vr": "OB", "BinaryLength": 488},
        "1864": {"vr": "OB", "BinaryLength": 488},
        "1865": {"vr": "OB", "BinaryLength": 488},
        "1866": {"vr": "OB", "BinaryLength": 488},
        "1867": {"vr": "OB", "BinaryLength": 488},
        "1868": {"vr": "OB", "BinaryLength": 488},
        "1869": {"vr": "OB", "BinaryLength": 488},
        "1870": {"vr": "OB", "BinaryLength": 488},
        "1871": {"vr": "OB", "BinaryLength": 488},
        "1872": {"vr": "OB", "BinaryLength": 124},
        "1873": {"vr": "OB", "BinaryLength": 124},
        "1874": {"vr": "OB", "BinaryLength": 488},
        "1875": {"vr": "OB", "BinaryLength": 488},
        "1876": {"vr": "OB", "BinaryLength": 488},
        "1877": {"vr": "OB", "BinaryLength": 488},
        "1878": {"vr": "OB", "BinaryLength": 488},
        "1879": {"vr": "OB", "BinaryLength": 488},
        "1880": {"vr": "OB", "BinaryLength": 488},
        "1881": {"vr": "OB", "BinaryLength": 488},
        "1882": {"vr": "OB", "BinaryLength": 488},
        "1883": {"vr": "OB", "BinaryLength": 488},
        "1884": {"vr": "OB", "BinaryLength": 488},
        "1885": {"vr": "OB", "BinaryLength": 488},
        "1886": {"vr": "OB", "BinaryLength": 488},
        "1887": {"vr": "OB", "BinaryLength": 488},
        "1888": {"vr": "OB", "BinaryLength": 488},
        "1889": {"vr": "OB", "BinaryLength": 124},
        "1890": {"vr": "OB", "BinaryLength": 488},
        "1891": {"vr": "OB", "BinaryLength": 488},
        "1892": {"vr": "OB", "BinaryLength": 488},
        "1893": {"vr": "OB", "BinaryLength": 488},
        "1894": {"vr": "OB", "BinaryLength": 488},
        "1895": {"vr": "OB", "BinaryLength": 488},
        "1896": {"vr": "OB", "BinaryLength": 488},
        "1897": {"vr": "OB", "BinaryLength": 488},
        "1898": {"vr": "OB", "BinaryLength": 488},
        "1899": {"vr": "OB", "BinaryLength": 488},
        "1900": {"vr": "OB", "BinaryLength": 488},
        "1901": {"vr": "OB", "BinaryLength": 488},
        "1902": {"vr": "OB", "BinaryLength": 488},
        "1903": {"vr": "OB", "BinaryLength": 488},
        "1904": {"vr": "OB", "BinaryLength": 488},
        "1905": {"vr": "OB", "BinaryLength": 488},
        "1906": {"vr": "OB", "BinaryLength": 488},
        "1907": {"vr": "OB", "BinaryLength": 488},
        "1908": {"vr": "OB", "BinaryLength": 488},
        "1909": {"vr": "OB", "BinaryLength": 124},
        "1910": {"vr": "OB", "BinaryLength": 488},
        "1911": {"vr": "OB", "BinaryLength": 488},
        "1912": {"vr": "OB", "BinaryLength": 488},
        "1913": {"vr": "OB", "BinaryLength": 488},
        "1914": {"vr": "OB", "BinaryLength": 124},
        "1915": {"vr": "OB", "BinaryLength": 124},
        "1916": {"vr": "OB", "BinaryLength": 124},
        "1917": {"vr": "OB", "BinaryLength": 488},
        "1918": {"vr": "OB", "BinaryLength": 124},
        "1919": {"vr": "OB", "BinaryLength": 488},
        "1920": {"vr": "OB", "BinaryLength": 124},
        "1921": {"vr": "OB", "BinaryLength": 488},
        "1922": {"vr": "OB", "BinaryLength": 488},
        "1923": {"vr": "OB", "BinaryLength": 488},
        "1924": {"vr": "OB", "BinaryLength": 488},
        "1925": {"vr": "OB", "BinaryLength": 488},
        "1926": {"vr": "OB", "BinaryLength": 488},
        "1927": {"vr": "OB", "BinaryLength": 488},
        "1928": {"vr": "OB", "BinaryLength": 488},
        "1929": {"vr": "OB", "BinaryLength": 488},
        "1930": {"vr": "OB", "BinaryLength": 488},
        "1931": {"vr": "OB", "BinaryLength": 488},
        "1932": {"vr": "OB", "BinaryLength": 488},
        "1933": {"vr": "OB", "BinaryLength": 124},
        "1934": {"vr": "OB", "BinaryLength": 488},
        "1935": {"vr": "OB", "BinaryLength": 488},
        "1936": {"vr": "OB", "BinaryLength": 488},
        "1937": {"vr": "OB", "BinaryLength": 488},
        "1938": {"vr": "OB", "BinaryLength": 488},
        "1939": {"vr": "OB", "BinaryLength": 488},
        "1940": {"vr": "OB", "BinaryLength": 488},
        "1941": {"vr": "OB", "BinaryLength": 488},
        "1942": {"vr": "OB", "BinaryLength": 488},
        "1943": {"vr": "OB", "BinaryLength": 488},
        "1944": {"vr": "OB", "BinaryLength": 488},
        "1945": {"vr": "OB", "BinaryLength": 488},
        "1946": {"vr": "OB", "BinaryLength": 488},
        "1947": {"vr": "OB", "BinaryLength": 488},
        "1948": {"vr": "OB", "BinaryLength": 488},
        "1949": {"vr": "OB", "BinaryLength": 124},
        "1950": {"vr": "OB", "BinaryLength": 488},
        "1951": {"vr": "OB", "BinaryLength": 488},
        "1952": {"vr": "OB", "BinaryLength": 488},
        "1953": {"vr": "OB", "BinaryLength": 488},
        "1954": {"vr": "OB", "BinaryLength": 488},
        "1955": {"vr": "OB", "BinaryLength": 488},
        "1956": {"vr": "OB", "BinaryLength": 488},
        "1957": {"vr": "OB", "BinaryLength": 488},
        "1958": {"vr": "OB", "BinaryLength": 488},
        "1959": {"vr": "OB", "BinaryLength": 488},
        "1960": {"vr": "OB", "BinaryLength": 488},
        "1961": {"vr": "OB", "BinaryLength": 124},
        "1962": {"vr": "OB", "BinaryLength": 488},
        "1963": {"vr": "OB", "BinaryLength": 488},
        "1964": {"vr": "OB", "BinaryLength": 488},
        "1965": {"vr": "OB", "BinaryLength": 488},
        "1966": {"vr": "OB", "BinaryLength": 488},
        "1967": {"vr": "OB", "BinaryLength": 124},
        "1968": {"vr": "OB", "BinaryLength": 488},
        "1969": {"vr": "OB", "BinaryLength": 488},
        "1970": {"vr": "OB", "BinaryLength": 488},
        "1971": {"vr": "OB", "BinaryLength": 488},
        "1972": {"vr": "OB", "BinaryLength": 488},
        "1973": {"vr": "OB", "BinaryLength": 124},
        "1974": {"vr": "OB", "BinaryLength": 488},
        "1975": {"vr": "OB", "BinaryLength": 488},
        "1976": {"vr": "OB", "BinaryLength": 488},
        "1977": {"vr": "OB", "BinaryLength": 488},
        "1978": {"vr": "OB", "BinaryLength": 488},
        "1979": {"vr": "OB", "BinaryLength": 488},
        "1980": {"vr": "OB", "BinaryLength": 488},
        "1981": {"vr": "OB", "BinaryLength": 488},
        "1982": {"vr": "OB", "BinaryLength": 488},
        "1983": {"vr": "OB", "BinaryLength": 488},
        "1984": {"vr": "OB", "BinaryLength": 488},
        "1985": {"vr": "OB", "BinaryLength": 488},
        "1986": {"vr": "OB", "BinaryLength": 124},
        "1987": {"vr": "OB", "BinaryLength": 488},
        "1988": {"vr": "OB", "BinaryLength": 488},
        "1989": {"vr": "OB", "BinaryLength": 488},
        "1990": {"vr": "OB", "BinaryLength": 488},
        "1991": {"vr": "OB", "BinaryLength": 488},
        "1992": {"vr": "OB", "BinaryLength": 488},
        "1993": {"vr": "OB", "BinaryLength": 124},
        "1994": {"vr": "OB", "BinaryLength": 488},
        "1995": {"vr": "OB", "BinaryLength": 488},
        "1996": {"vr": "OB", "BinaryLength": 124},
        "1997": {"vr": "OB", "BinaryLength": 488},
        "1998": {"vr": "OB", "BinaryLength": 488},
        "1999": {"vr": "OB", "BinaryLength": 488},
        "2000": {"vr": "OB", "BinaryLength": 488},
        "2001": {"vr": "OB", "BinaryLength": 124},
        "2002": {"vr": "OB", "BinaryLength": 488},
        "2003": {"vr": "OB", "BinaryLength": 488},
        "2004": {"vr": "OB", "BinaryLength": 488},
        "2005": {"vr": "OB", "BinaryLength": 488},
        "2006": {"vr": "OB", "BinaryLength": 488},
        "2007": {"vr": "OB", "BinaryLength": 488},
        "2008": {"vr": "OB", "BinaryLength": 488},
        "2009": {"vr": "OB", "BinaryLength": 488},
        "2010": {"vr": "OB", "BinaryLength": 488},
        "2011": {"vr": "OB", "BinaryLength": 488},
        "2012": {"vr": "OB", "BinaryLength": 124},
        "2013": {"vr": "OB", "BinaryLength": 488},
        "2014": {"vr": "OB", "BinaryLength": 488},
        "2015": {"vr": "OB", "BinaryLength": 488},
        "2016": {"vr": "OB", "BinaryLength": 488},
        "2017": {"vr": "OB", "BinaryLength": 124},
        "2018": {"vr": "OB", "BinaryLength": 488},
        "2019": {"vr": "OB", "BinaryLength": 488},
        "2020": {"vr": "OB", "BinaryLength": 488},
        "2021": {"vr": "OB", "BinaryLength": 488},
        "2022": {"vr": "OB", "BinaryLength": 488},
        "2023": {"vr": "OB", "BinaryLength": 488},
        "2024": {"vr": "OB", "BinaryLength": 488},
        "2025": {"vr": "OB", "BinaryLength": 124},
        "2026": {"vr": "OB", "BinaryLength": 488},
        "2027": {"vr": "OB", "BinaryLength": 488},
        "2028": {"vr": "OB", "BinaryLength": 488},
        "2029": {"vr": "OB", "BinaryLength": 124},
        "2030": {"vr": "OB", "BinaryLength": 488},
        "2031": {"vr": "OB", "BinaryLength": 488},
        "2032": {"vr": "OB", "BinaryLength": 488},
        "2033": {"vr": "OB", "BinaryLength": 488},
        "2034": {"vr": "OB", "BinaryLength": 488},
        "2035": {"vr": "OB", "BinaryLength": 488},
        "2036": {"vr": "OB", "BinaryLength": 488},
        "2037": {"vr": "OB", "BinaryLength": 488},
        "2038": {"vr": "OB", "BinaryLength": 488},
        "2039": {"vr": "OB", "BinaryLength": 488},
        "2040": {"vr": "OB", "BinaryLength": 488},
        "2041": {"vr": "OB", "BinaryLength": 488},
        "2042": {"vr": "OB", "BinaryLength": 488},
        "2043": {"vr": "OB", "BinaryLength": 488},
        "2044": {"vr": "OB", "BinaryLength": 488},
        "2045": {"vr": "OB", "BinaryLength": 488},
        "2046": {"vr": "OB", "BinaryLength": 488},
        "2047": {"vr": "OB", "BinaryLength": 488},
        "2048": {"vr": "OB", "BinaryLength": 488},
        "2049": {"vr": "OB", "BinaryLength": 488},
        "2050": {"vr": "OB", "BinaryLength": 488},
        "2051": {"vr": "OB", "BinaryLength": 488},
        "2052": {"vr": "OB", "BinaryLength": 488},
        "2053": {"vr": "OB", "BinaryLength": 488},
        "2054": {"vr": "OB", "BinaryLength": 488},
        "2055": {"vr": "OB", "BinaryLength": 488},
        "2056": {"vr": "OB", "BinaryLength": 488},
        "2057": {"vr": "OB", "BinaryLength": 488},
        "2058": {"vr": "OB", "BinaryLength": 488},
        "2059": {"vr": "OB", "BinaryLength": 488},
        "2060": {"vr": "OB", "BinaryLength": 488},
        "2061": {"vr": "OB", "BinaryLength": 488},
        "2062": {"vr": "OB", "BinaryLength": 488},
        "2063": {"vr": "OB", "BinaryLength": 488},
        "2064": {"vr": "OB", "BinaryLength": 124},
        "2065": {"vr": "OB", "BinaryLength": 488},
        "2066": {"vr": "OB", "BinaryLength": 488},
        "2067": {"vr": "OB", "BinaryLength": 488},
        "2068": {"vr": "OB", "BinaryLength": 488},
        "2069": {"vr": "OB", "BinaryLength": 488},
        "2070": {"vr": "OB", "BinaryLength": 488},
        "2071": {"vr": "OB", "BinaryLength": 488},
        "2072": {"vr": "OB", "BinaryLength": 488},
        "2073": {"vr": "OB", "BinaryLength": 488},
        "2074": {"vr": "OB", "BinaryLength": 488},
        "2075": {"vr": "OB", "BinaryLength": 124},
        "2076": {"vr": "OB", "BinaryLength": 488},
        "2077": {"vr": "OB", "BinaryLength": 488},
        "2078": {"vr": "OB", "BinaryLength": 488},
        "2079": {"vr": "OB", "BinaryLength": 124},
        "2080": {"vr": "OB", "BinaryLength": 488},
        "2081": {"vr": "OB", "BinaryLength": 488},
        "2082": {"vr": "OB", "BinaryLength": 124},
        "2083": {"vr": "OB", "BinaryLength": 124},
        "2084": {"vr": "OB", "BinaryLength": 124},
        "2085": {"vr": "OB", "BinaryLength": 488},
        "2086": {"vr": "OB", "BinaryLength": 124},
        "2087": {"vr": "OB", "BinaryLength": 488},
        "2088": {"vr": "OB", "BinaryLength": 488},
        "2089": {"vr": "OB", "BinaryLength": 488},
        "2090": {"vr": "OB", "BinaryLength": 488},
        "2091": {"vr": "OB", "BinaryLength": 488},
        "2092": {"vr": "OB", "BinaryLength": 488},
        "2093": {"vr": "OB", "BinaryLength": 488},
        "2094": {"vr": "OB", "BinaryLength": 488},
        "2095": {"vr": "OB", "BinaryLength": 488},
        "2096": {"vr": "OB", "BinaryLength": 488},
        "2097": {"vr": "OB", "BinaryLength": 488},
        "2098": {"vr": "OB", "BinaryLength": 124},
        "2099": {"vr": "OB", "BinaryLength": 488},
        "2100": {"vr": "OB", "BinaryLength": 488},
        "2101": {"vr": "OB", "BinaryLength": 488},
        "2102": {"vr": "OB", "BinaryLength": 488},
        "2103": {"vr": "OB", "BinaryLength": 488},
        "2104": {"vr": "OB", "BinaryLength": 488},
        "2105": {"vr": "OB", "BinaryLength": 488},
        "2106": {"vr": "OB", "BinaryLength": 488},
        "2107": {"vr": "OB", "BinaryLength": 488},
        "2108": {"vr": "OB", "BinaryLength": 488},
        "2109": {"vr": "OB", "BinaryLength": 124},
        "2110": {"vr": "OB", "BinaryLength": 488},
        "2111": {"vr": "OB", "BinaryLength": 488},
        "2112": {"vr": "OB", "BinaryLength": 488},
        "2113": {"vr": "OB", "BinaryLength": 488},
        "2114": {"vr": "OB", "BinaryLength": 488},
        "2115": {"vr": "OB", "BinaryLength": 488},
        "2116": {"vr": "OB", "BinaryLength": 488},
        "2117": {"vr": "OB", "BinaryLength": 488},
        "2118": {"vr": "OB", "BinaryLength": 488},
        "2119": {"vr": "OB", "BinaryLength": 488},
        "2120": {"vr": "OB", "BinaryLength": 488},
        "2121": {"vr": "OB", "BinaryLength": 488},
        "2122": {"vr": "OB", "BinaryLength": 488},
        "2123": {"vr": "OB", "BinaryLength": 488},
        "2124": {"vr": "OB", "BinaryLength": 488},
        "2125": {"vr": "OB", "BinaryLength": 488},
        "2126": {"vr": "OB", "BinaryLength": 488},
        "2127": {"vr": "OB", "BinaryLength": 488},
        "2128": {"vr": "OB", "BinaryLength": 488},
        "2129": {"vr": "OB", "BinaryLength": 488},
        "2130": {"vr": "OB", "BinaryLength": 488},
        "2131": {"vr": "OB", "BinaryLength": 488},
        "2132": {"vr": "OB", "BinaryLength": 124},
        "2133": {"vr": "OB", "BinaryLength": 488},
        "2134": {"vr": "OB", "BinaryLength": 488},
        "2135": {"vr": "OB", "BinaryLength": 488},
        "2136": {"vr": "OB", "BinaryLength": 488},
        "2137": {"vr": "OB", "BinaryLength": 488},
        "2138": {"vr": "OB", "BinaryLength": 488},
        "2139": {"vr": "OB", "BinaryLength": 488},
        "2140": {"vr": "OB", "BinaryLength": 488},
        "2141": {"vr": "OB", "BinaryLength": 488},
        "2142": {"vr": "OB", "BinaryLength": 488},
        "2143": {"vr": "OB", "BinaryLength": 488},
        "2144": {"vr": "OB", "BinaryLength": 488},
        "2145": {"vr": "OB", "BinaryLength": 488},
        "2146": {"vr": "OB", "BinaryLength": 124},
        "2147": {"vr": "OB", "BinaryLength": 488},
        "2148": {"vr": "OB", "BinaryLength": 488},
        "2149": {"vr": "OB", "BinaryLength": 488},
        "2150": {"vr": "OB", "BinaryLength": 488},
        "2151": {"vr": "OB", "BinaryLength": 488},
        "2152": {"vr": "OB", "BinaryLength": 488},
        "2153": {"vr": "OB", "BinaryLength": 488},
        "2154": {"vr": "OB", "BinaryLength": 488},
        "2155": {"vr": "OB", "BinaryLength": 488},
        "2156": {"vr": "OB", "BinaryLength": 488},
        "2157": {"vr": "OB", "BinaryLength": 488},
        "2158": {"vr": "OB", "BinaryLength": 124},
        "2159": {"vr": "OB", "BinaryLength": 488},
        "2160": {"vr": "OB", "BinaryLength": 488},
        "2161": {"vr": "OB", "BinaryLength": 488},
        "2162": {"vr": "OB", "BinaryLength": 488},
        "2163": {"vr": "OB", "BinaryLength": 488},
        "2164": {"vr": "OB", "BinaryLength": 488},
        "2165": {"vr": "OB", "BinaryLength": 124},
        "2166": {"vr": "OB", "BinaryLength": 488},
        "2167": {"vr": "OB", "BinaryLength": 488},
        "2168": {"vr": "OB", "BinaryLength": 488},
        "2169": {"vr": "OB", "BinaryLength": 488},
        "2170": {"vr": "OB", "BinaryLength": 124},
        "2171": {"vr": "OB", "BinaryLength": 488},
        "2172": {"vr": "OB", "BinaryLength": 488},
        "2173": {"vr": "OB", "BinaryLength": 488},
        "2174": {"vr": "OB", "BinaryLength": 124},
        "2175": {"vr": "OB", "BinaryLength": 488},
        "2176": {"vr": "OB", "BinaryLength": 488},
        "2177": {"vr": "OB", "BinaryLength": 488},
        "2178": {"vr": "OB", "BinaryLength": 488},
        "2179": {"vr": "OB", "BinaryLength": 488},
        "2180": {"vr": "OB", "BinaryLength": 488},
        "2181": {"vr": "OB", "BinaryLength": 488},
        "2182": {"vr": "OB", "BinaryLength": 488},
        "2183": {"vr": "OB", "BinaryLength": 488},
        "2184": {"vr": "OB", "BinaryLength": 488},
        "2185": {"vr": "OB", "BinaryLength": 488},
        "2186": {"vr": "OB", "BinaryLength": 488},
        "2187": {"vr": "OB", "BinaryLength": 124},
        "2188": {"vr": "OB", "BinaryLength": 488},
        "2189": {"vr": "OB", "BinaryLength": 488},
        "2190": {"vr": "OB", "BinaryLength": 488},
        "2191": {"vr": "OB", "BinaryLength": 488},
        "2192": {"vr": "OB", "BinaryLength": 124},
        "2193": {"vr": "OB", "BinaryLength": 488},
        "2194": {"vr": "OB", "BinaryLength": 488},
        "2195": {"vr": "OB", "BinaryLength": 488},
        "2196": {"vr": "OB", "BinaryLength": 488},
        "2197": {"vr": "OB", "BinaryLength": 488},
        "2198": {"vr": "OB", "BinaryLength": 488},
        "2199": {"vr": "OB", "BinaryLength": 488},
        "2200": {"vr": "OB", "BinaryLength": 488},
        "2201": {"vr": "OB", "BinaryLength": 488},
        "2202": {"vr": "OB", "BinaryLength": 488},
        "2203": {"vr": "OB", "BinaryLength": 488},
        "2204": {"vr": "OB", "BinaryLength": 124},
        "2205": {"vr": "OB", "BinaryLength": 488},
        "2206": {"vr": "OB", "BinaryLength": 488},
        "2207": {"vr": "OB", "BinaryLength": 488},
        "2208": {"vr": "OB", "BinaryLength": 488},
        "2209": {"vr": "OB", "BinaryLength": 488},
        "2210": {"vr": "OB", "BinaryLength": 488},
        "2211": {"vr": "OB", "BinaryLength": 488},
        "2212": {"vr": "OB", "BinaryLength": 488},
        "2213": {"vr": "OB", "BinaryLength": 488},
        "2214": {"vr": "OB", "BinaryLength": 488},
        "2215": {"vr": "OB", "BinaryLength": 488},
        "2216": {"vr": "OB", "BinaryLength": 488},
        "2217": {"vr": "OB", "BinaryLength": 488},
        "2218": {"vr": "OB", "BinaryLength": 488},
        "2219": {"vr": "OB", "BinaryLength": 488},
        "2220": {"vr": "OB", "BinaryLength": 124},
        "2221": {"vr": "OB", "BinaryLength": 488},
        "2222": {"vr": "OB", "BinaryLength": 488},
        "2223": {"vr": "OB", "BinaryLength": 488},
        "2224": {"vr": "OB", "BinaryLength": 488},
        "2225": {"vr": "OB", "BinaryLength": 488},
        "2226": {"vr": "OB", "BinaryLength": 488},
        "2227": {"vr": "OB", "BinaryLength": 488},
        "2228": {"vr": "OB", "BinaryLength": 488},
        "2229": {"vr": "OB", "BinaryLength": 488},
        "2230": {"vr": "OB", "BinaryLength": 488},
        "2231": {"vr": "OB", "BinaryLength": 488},
        "2232": {"vr": "OB", "BinaryLength": 488},
        "2233": {"vr": "OB", "BinaryLength": 488},
        "2234": {"vr": "OB", "BinaryLength": 488},
        "2235": {"vr": "OB", "BinaryLength": 488},
        "2236": {"vr": "OB", "BinaryLength": 488},
        "2237": {"vr": "OB", "BinaryLength": 488},
        "2238": {"vr": "OB", "BinaryLength": 488},
        "2239": {"vr": "OB", "BinaryLength": 124},
        "2240": {"vr": "OB", "BinaryLength": 488},
        "2241": {"vr": "OB", "BinaryLength": 488},
        "2242": {"vr": "OB", "BinaryLength": 488},
        "2243": {"vr": "OB", "BinaryLength": 488},
        "2244": {"vr": "OB", "BinaryLength": 488},
        "2245": {"vr": "OB", "BinaryLength": 488},
        "2246": {"vr": "OB", "BinaryLength": 488},
        "2247": {"vr": "OB", "BinaryLength": 488},
        "2248": {"vr": "OB", "BinaryLength": 488},
        "2249": {"vr": "OB", "BinaryLength": 488},
        "2250": {"vr": "OB", "BinaryLength": 488},
        "2251": {"vr": "OB", "BinaryLength": 488},
        "2252": {"vr": "OB", "BinaryLength": 488},
        "2253": {"vr": "OB", "BinaryLength": 488},
        "2254": {"vr": "OB", "BinaryLength": 124},
        "2255": {"vr": "OB", "BinaryLength": 488},
        "2256": {"vr": "OB", "BinaryLength": 488},
        "2257": {"vr": "OB", "BinaryLength": 488},
        "2258": {"vr": "OB", "BinaryLength": 488},
        "2259": {"vr": "OB", "BinaryLength": 124},
        "2260": {"vr": "OB", "BinaryLength": 488},
        "2261": {"vr": "OB", "BinaryLength": 488},
        "2262": {"vr": "OB", "BinaryLength": 488},
        "2263": {"vr": "OB", "BinaryLength": 124},
        "2264": {"vr": "OB", "BinaryLength": 488},
        "2265": {"vr": "OB", "BinaryLength": 488},
        "2266": {"vr": "OB", "BinaryLength": 488},
        "2267": {"vr": "OB", "BinaryLength": 488},
        "2268": {"vr": "OB", "BinaryLength": 488},
        "2269": {"vr": "OB", "BinaryLength": 488},
        "2270": {"vr": "OB", "BinaryLength": 488},
        "2271": {"vr": "OB", "BinaryLength": 488},
        "2272": {"vr": "OB", "BinaryLength": 488},
        "2273": {"vr": "OB", "BinaryLength": 488},
        "2274": {"vr": "OB", "BinaryLength": 488},
        "2275": {"vr": "OB", "BinaryLength": 488},
        "2276": {"vr": "OB", "BinaryLength": 488},
        "2277": {"vr": "OB", "BinaryLength": 488},
        "2278": {"vr": "OB", "BinaryLength": 124},
        "2279": {"vr": "OB", "BinaryLength": 488},
        "2280": {"vr": "OB", "BinaryLength": 488},
        "2281": {"vr": "OB", "BinaryLength": 488},
        "2282": {"vr": "OB", "BinaryLength": 488},
        "2283": {"vr": "OB", "BinaryLength": 488},
        "2284": {"vr": "OB", "BinaryLength": 488},
        "2285": {"vr": "OB", "BinaryLength": 488},
        "2286": {"vr": "OB", "BinaryLength": 488},
        "2287": {"vr": "OB", "BinaryLength": 124},
        "2288": {"vr": "OB", "BinaryLength": 488},
        "2289": {"vr": "OB", "BinaryLength": 488},
        "2290": {"vr": "OB", "BinaryLength": 488},
        "2291": {"vr": "OB", "BinaryLength": 124},
        "2292": {"vr": "OB", "BinaryLength": 488},
        "2293": {"vr": "OB", "BinaryLength": 488},
        "2294": {"vr": "OB", "BinaryLength": 488},
        "2295": {"vr": "OB", "BinaryLength": 124},
        "2296": {"vr": "OB", "BinaryLength": 124},
        "2297": {"vr": "OB", "BinaryLength": 488},
        "2298": {"vr": "OB", "BinaryLength": 488},
        "2299": {"vr": "OB", "BinaryLength": 488},
        "2300": {"vr": "OB", "BinaryLength": 488},
        "2301": {"vr": "OB", "BinaryLength": 488},
        "2302": {"vr": "OB", "BinaryLength": 488},
        "2303": {"vr": "OB", "BinaryLength": 488},
        "2304": {"vr": "OB", "BinaryLength": 488},
        "2305": {"vr": "OB", "BinaryLength": 488},
        "2306": {"vr": "OB", "BinaryLength": 488},
        "2307": {"vr": "OB", "BinaryLength": 488},
        "2308": {"vr": "OB", "BinaryLength": 488},
        "2309": {"vr": "OB", "BinaryLength": 488},
        "2310": {"vr": "OB", "BinaryLength": 488},
        "2311": {"vr": "OB", "BinaryLength": 488},
        "2312": {"vr": "OB", "BinaryLength": 488},
        "2313": {"vr": "OB", "BinaryLength": 124},
        "2314": {"vr": "OB", "BinaryLength": 488},
        "2315": {"vr": "OB", "BinaryLength": 488},
        "2316": {"vr": "OB", "BinaryLength": 488},
        "2317": {"vr": "OB", "BinaryLength": 488},
        "2318": {"vr": "OB", "BinaryLength": 488},
        "2319": {"vr": "OB", "BinaryLength": 488},
        "2320": {"vr": "OB", "BinaryLength": 488},
        "2321": {"vr": "OB", "BinaryLength": 488},
        "2322": {"vr": "OB", "BinaryLength": 488},
        "2323": {"vr": "OB", "BinaryLength": 488},
        "2324": {"vr": "OB", "BinaryLength": 488},
        "2325": {"vr": "OB", "BinaryLength": 488},
        "2326": {"vr": "OB", "BinaryLength": 488},
        "2327": {"vr": "OB", "BinaryLength": 488},
        "2328": {"vr": "OB", "BinaryLength": 488},
        "2329": {"vr": "OB", "BinaryLength": 488},
        "2330": {"vr": "OB", "BinaryLength": 488},
        "2331": {"vr": "OB", "BinaryLength": 488},
        "2332": {"vr": "OB", "BinaryLength": 488},
        "2333": {"vr": "OB", "BinaryLength": 488},
        "2334": {"vr": "OB", "BinaryLength": 488},
        "2335": {"vr": "OB", "BinaryLength": 488},
        "2336": {"vr": "OB", "BinaryLength": 488},
        "2337": {"vr": "OB", "BinaryLength": 488},
        "2338": {"vr": "OB", "BinaryLength": 488},
        "2339": {"vr": "OB", "BinaryLength": 488},
        "2340": {"vr": "OB", "BinaryLength": 124},
        "2341": {"vr": "OB", "BinaryLength": 488},
        "2342": {"vr": "OB", "BinaryLength": 488},
        "2343": {"vr": "OB", "BinaryLength": 488},
        "2344": {"vr": "OB", "BinaryLength": 488},
        "2345": {"vr": "OB", "BinaryLength": 488},
        "2346": {"vr": "OB", "BinaryLength": 124},
        "2347": {"vr": "OB", "BinaryLength": 488},
        "2348": {"vr": "OB", "BinaryLength": 488},
        "2349": {"vr": "OB", "BinaryLength": 488},
        "2350": {"vr": "OB", "BinaryLength": 488},
        "2351": {"vr": "OB", "BinaryLength": 488},
        "2352": {"vr": "OB", "BinaryLength": 488},
        "2353": {"vr": "OB", "BinaryLength": 488},
        "2354": {"vr": "OB", "BinaryLength": 488},
        "2355": {"vr": "OB", "BinaryLength": 488},
        "2356": {"vr": "OB", "BinaryLength": 488},
        "2357": {"vr": "OB", "BinaryLength": 488},
        "2358": {"vr": "OB", "BinaryLength": 488},
        "2359": {"vr": "OB", "BinaryLength": 124},
        "2360": {"vr": "OB", "BinaryLength": 124},
        "2361": {"vr": "OB", "BinaryLength": 488},
        "2362": {"vr": "OB", "BinaryLength": 488},
        "2363": {"vr": "OB", "BinaryLength": 488},
        "2364": {"vr": "OB", "BinaryLength": 488},
        "2365": {"vr": "OB", "BinaryLength": 488},
        "2366": {"vr": "OB", "BinaryLength": 488},
        "2367": {"vr": "OB", "BinaryLength": 488},
        "2368": {"vr": "OB", "BinaryLength": 488},
        "2369": {"vr": "OB", "BinaryLength": 124},
        "2370": {"vr": "OB", "BinaryLength": 488},
        "2371": {"vr": "OB", "BinaryLength": 488},
        "2372": {"vr": "OB", "BinaryLength": 488},
        "2373": {"vr": "OB", "BinaryLength": 488},
        "2374": {"vr": "OB", "BinaryLength": 488},
        "2375": {"vr": "OB", "BinaryLength": 488},
        "2376": {"vr": "OB", "BinaryLength": 124},
        "2377": {"vr": "OB", "BinaryLength": 488},
        "2378": {"vr": "OB", "BinaryLength": 488},
        "2379": {"vr": "OB", "BinaryLength": 488},
        "2380": {"vr": "OB", "BinaryLength": 488},
        "2381": {"vr": "OB", "BinaryLength": 124},
        "2382": {"vr": "OB", "BinaryLength": 124},
        "2383": {"vr": "OB", "BinaryLength": 488},
        "2384": {"vr": "OB", "BinaryLength": 488},
        "2385": {"vr": "OB", "BinaryLength": 124},
        "2386": {"vr": "OB", "BinaryLength": 488},
        "2387": {"vr": "OB", "BinaryLength": 488},
        "2388": {"vr": "OB", "BinaryLength": 488},
        "2389": {"vr": "OB", "BinaryLength": 488},
        "2390": {"vr": "OB", "BinaryLength": 488},
        "2391": {"vr": "OB", "BinaryLength": 488},
        "2392": {"vr": "OB", "BinaryLength": 488},
        "2393": {"vr": "OB", "BinaryLength": 488},
        "2394": {"vr": "OB", "BinaryLength": 124},
        "2395": {"vr": "OB", "BinaryLength": 488},
        "2396": {"vr": "OB", "BinaryLength": 488},
        "2397": {"vr": "OB", "BinaryLength": 488},
        "2398": {"vr": "OB", "BinaryLength": 488},
        "2399": {"vr": "OB", "BinaryLength": 488},
        "2400": {"vr": "OB", "BinaryLength": 124},
        "2401": {"vr": "OB", "BinaryLength": 488},
        "2402": {"vr": "OB", "BinaryLength": 488},
        "2403": {"vr": "OB", "BinaryLength": 488},
        "2404": {"vr": "OB", "BinaryLength": 488},
        "2405": {"vr": "OB", "BinaryLength": 488},
        "2406": {"vr": "OB", "BinaryLength": 488},
        "2407": {"vr": "OB", "BinaryLength": 488},
        "2408": {"vr": "OB", "BinaryLength": 488},
        "2409": {"vr": "OB", "BinaryLength": 488},
        "2410": {"vr": "OB", "BinaryLength": 488},
        "2411": {"vr": "OB", "BinaryLength": 488},
        "2412": {"vr": "OB", "BinaryLength": 488},
        "2413": {"vr": "OB", "BinaryLength": 488},
        "2414": {"vr": "OB", "BinaryLength": 488},
        "2415": {"vr": "OB", "BinaryLength": 488},
        "2416": {"vr": "OB", "BinaryLength": 488},
        "2417": {"vr": "OB", "BinaryLength": 124},
        "2418": {"vr": "OB", "BinaryLength": 124},
        "2419": {"vr": "OB", "BinaryLength": 488},
        "2420": {"vr": "OB", "BinaryLength": 488},
        "2421": {"vr": "OB", "BinaryLength": 488},
        "2422": {"vr": "OB", "BinaryLength": 488},
        "2423": {"vr": "OB", "BinaryLength": 488},
        "2424": {"vr": "OB", "BinaryLength": 488},
        "2425": {"vr": "OB", "BinaryLength": 488},
        "2426": {"vr": "OB", "BinaryLength": 488},
        "2427": {"vr": "OB", "BinaryLength": 488},
        "2428": {"vr": "OB", "BinaryLength": 488},
        "2429": {"vr": "OB", "BinaryLength": 488},
        "2430": {"vr": "OB", "BinaryLength": 488},
        "2431": {"vr": "OB", "BinaryLength": 488},
        "2432": {"vr": "OB", "BinaryLength": 488},
        "2433": {"vr": "OB", "BinaryLength": 124},
        "2434": {"vr": "OB", "BinaryLength": 488},
        "2435": {"vr": "OB", "BinaryLength": 488},
        "2436": {"vr": "OB", "BinaryLength": 488},
        "2437": {"vr": "OB", "BinaryLength": 488},
        "2438": {"vr": "OB", "BinaryLength": 488},
        "2439": {"vr": "OB", "BinaryLength": 488},
        "2440": {"vr": "OB", "BinaryLength": 488},
        "2441": {"vr": "OB", "BinaryLength": 488},
        "2442": {"vr": "OB", "BinaryLength": 488},
        "2443": {"vr": "OB", "BinaryLength": 488},
        "2444": {"vr": "OB", "BinaryLength": 488},
        "2445": {"vr": "OB", "BinaryLength": 488},
        "2446": {"vr": "OB", "BinaryLength": 488},
        "2447": {"vr": "OB", "BinaryLength": 488},
        "2448": {"vr": "OB", "BinaryLength": 488},
        "2449": {"vr": "OB", "BinaryLength": 488},
        "2450": {"vr": "OB", "BinaryLength": 488},
        "2451": {"vr": "OB", "BinaryLength": 488},
        "2452": {"vr": "OB", "BinaryLength": 488},
        "2453": {"vr": "OB", "BinaryLength": 488},
        "2454": {"vr": "OB", "BinaryLength": 488},
        "2455": {"vr": "OB", "BinaryLength": 488},
        "2456": {"vr": "OB", "BinaryLength": 488},
        "2457": {"vr": "OB", "BinaryLength": 488},
        "2458": {"vr": "OB", "BinaryLength": 488},
        "2459": {"vr": "OB", "BinaryLength": 488},
        "2460": {"vr": "OB", "BinaryLength": 488},
        "2461": {"vr": "OB", "BinaryLength": 488},
        "2462": {"vr": "OB", "BinaryLength": 488},
        "2463": {"vr": "OB", "BinaryLength": 488},
        "2464": {"vr": "OB", "BinaryLength": 488},
        "2465": {"vr": "OB", "BinaryLength": 488},
        "2466": {"vr": "OB", "BinaryLength": 488},
        "2467": {"vr": "OB", "BinaryLength": 488},
        "2468": {"vr": "OB", "BinaryLength": 488},
        "2469": {"vr": "OB", "BinaryLength": 488},
        "2470": {"vr": "OB", "BinaryLength": 488},
        "2471": {"vr": "OB", "BinaryLength": 488},
        "2472": {"vr": "OB", "BinaryLength": 488},
        "2473": {"vr": "OB", "BinaryLength": 488},
        "2474": {"vr": "OB", "BinaryLength": 488},
        "2475": {"vr": "OB", "BinaryLength": 488},
        "2476": {"vr": "OB", "BinaryLength": 488},
        "2477": {"vr": "OB", "BinaryLength": 488},
        "2478": {"vr": "OB", "BinaryLength": 488},
        "2479": {"vr": "OB", "BinaryLength": 124},
        "2480": {"vr": "OB", "BinaryLength": 124},
        "2481": {"vr": "OB", "BinaryLength": 488},
        "2482": {"vr": "OB", "BinaryLength": 488},
        "2483": {"vr": "OB", "BinaryLength": 488},
        "2484": {"vr": "OB", "BinaryLength": 488},
        "2485": {"vr": "OB", "BinaryLength": 488},
        "2486": {"vr": "OB", "BinaryLength": 488},
        "2487": {"vr": "OB", "BinaryLength": 488},
        "2488": {"vr": "OB", "BinaryLength": 488},
        "2489": {"vr": "OB", "BinaryLength": 488},
        "2490": {"vr": "OB", "BinaryLength": 488},
        "2491": {"vr": "OB", "BinaryLength": 488},
        "2492": {"vr": "OB", "BinaryLength": 488},
        "2493": {"vr": "OB", "BinaryLength": 488},
        "2494": {"vr": "OB", "BinaryLength": 488},
        "2495": {"vr": "OB", "BinaryLength": 488},
        "2496": {"vr": "OB", "BinaryLength": 488},
        "2497": {"vr": "OB", "BinaryLength": 488},
        "2498": {"vr": "OB", "BinaryLength": 488},
        "2499": {"vr": "OB", "BinaryLength": 488},
        "2500": {"vr": "OB", "BinaryLength": 488},
        "2501": {"vr": "OB", "BinaryLength": 488},
        "2502": {"vr": "OB", "BinaryLength": 488},
        "2503": {"vr": "OB", "BinaryLength": 488},
        "2504": {"vr": "OB", "BinaryLength": 488},
        "2505": {"vr": "OB", "BinaryLength": 488},
        "2506": {"vr": "OB", "BinaryLength": 488},
        "2507": {"vr": "OB", "BinaryLength": 488},
        "2508": {"vr": "OB", "BinaryLength": 488},
        "2509": {"vr": "OB", "BinaryLength": 488},
        "2510": {"vr": "OB", "BinaryLength": 488},
        "2511": {"vr": "OB", "BinaryLength": 488},
        "2512": {"vr": "OB", "BinaryLength": 488},
        "2513": {"vr": "OB", "BinaryLength": 488},
        "2514": {"vr": "OB", "BinaryLength": 488},
        "2515": {"vr": "OB", "BinaryLength": 488},
        "2516": {"vr": "OB", "BinaryLength": 488},
        "2517": {"vr": "OB", "BinaryLength": 488},
        "2518": {"vr": "OB", "BinaryLength": 488},
        "2519": {"vr": "OB", "BinaryLength": 488},
        "2520": {"vr": "OB", "BinaryLength": 124},
        "2521": {"vr": "OB", "BinaryLength": 488},
        "2522": {"vr": "OB", "BinaryLength": 124},
        "2523": {"vr": "OB", "BinaryLength": 488},
        "2524": {"vr": "OB", "BinaryLength": 488},
        "2525": {"vr": "OB", "BinaryLength": 124},
        "2526": {"vr": "OB", "BinaryLength": 488},
        "2527": {"vr": "OB", "BinaryLength": 488},
        "2528": {"vr": "OB", "BinaryLength": 488},
        "2529": {"vr": "OB", "BinaryLength": 488},
        "2530": {"vr": "OB", "BinaryLength": 488},
        "2531": {"vr": "OB", "BinaryLength": 488},
        "2532": {"vr": "OB", "BinaryLength": 488},
        "2533": {"vr": "OB", "BinaryLength": 488},
        "2534": {"vr": "OB", "BinaryLength": 124},
        "2535": {"vr": "OB", "BinaryLength": 488},
        "2536": {"vr": "OB", "BinaryLength": 488},
        "2537": {"vr": "OB", "BinaryLength": 124},
        "2538": {"vr": "OB", "BinaryLength": 488},
        "2539": {"vr": "OB", "BinaryLength": 124},
        "2540": {"vr": "OB", "BinaryLength": 488},
        "2541": {"vr": "OB", "BinaryLength": 488},
        "2542": {"vr": "OB", "BinaryLength": 488},
        "2543": {"vr": "OB", "BinaryLength": 488},
        "2544": {"vr": "OB", "BinaryLength": 488},
        "2545": {"vr": "OB", "BinaryLength": 488},
        "2546": {"vr": "OB", "BinaryLength": 124},
        "2547": {"vr": "OB", "BinaryLength": 488},
        "2548": {"vr": "OB", "BinaryLength": 124},
        "2549": {"vr": "OB", "BinaryLength": 488},
        "2550": {"vr": "OB", "BinaryLength": 488},
        "2551": {"vr": "OB", "BinaryLength": 488},
        "2552": {"vr": "OB", "BinaryLength": 488},
        "2553": {"vr": "OB", "BinaryLength": 488},
        "2554": {"vr": "OB", "BinaryLength": 488},
        "2555": {"vr": "OB", "BinaryLength": 488},
        "2556": {"vr": "OB", "BinaryLength": 488},
        "2557": {"vr": "OB", "BinaryLength": 124},
        "2558": {"vr": "OB", "BinaryLength": 488},
        "2559": {"vr": "OB", "BinaryLength": 488},
        "2560": {"vr": "OB", "BinaryLength": 488},
        "2561": {"vr": "OB", "BinaryLength": 488},
        "2562": {"vr": "OB", "BinaryLength": 488},
        "2563": {"vr": "OB", "BinaryLength": 488},
        "2564": {"vr": "OB", "BinaryLength": 488},
        "2565": {"vr": "OB", "BinaryLength": 488},
        "2566": {"vr": "OB", "BinaryLength": 488},
        "2567": {"vr": "OB", "BinaryLength": 488},
        "2568": {"vr": "OB", "BinaryLength": 488},
        "2569": {"vr": "OB", "BinaryLength": 488},
        "2570": {"vr": "OB", "BinaryLength": 488},
        "2571": {"vr": "OB", "BinaryLength": 124},
        "2572": {"vr": "OB", "BinaryLength": 124},
        "2573": {"vr": "OB", "BinaryLength": 488},
        "2574": {"vr": "OB", "BinaryLength": 488},
        "2575": {"vr": "OB", "BinaryLength": 488},
        "2576": {"vr": "OB", "BinaryLength": 488},
        "2577": {"vr": "OB", "BinaryLength": 488},
        "2578": {"vr": "OB", "BinaryLength": 488},
        "2579": {"vr": "OB", "BinaryLength": 488},
        "2580": {"vr": "OB", "BinaryLength": 488},
        "2581": {"vr": "OB", "BinaryLength": 488},
        "2582": {"vr": "OB", "BinaryLength": 488},
        "2583": {"vr": "OB", "BinaryLength": 488},
        "2584": {"vr": "OB", "BinaryLength": 124},
        "2585": {"vr": "OB", "BinaryLength": 124},
        "2586": {"vr": "OB", "BinaryLength": 488},
        "2587": {"vr": "OB", "BinaryLength": 488},
        "2588": {"vr": "OB", "BinaryLength": 488},
        "2589": {"vr": "OB", "BinaryLength": 488},
        "2590": {"vr": "OB", "BinaryLength": 488},
        "2591": {"vr": "OB", "BinaryLength": 488},
        "2592": {"vr": "OB", "BinaryLength": 488},
        "2593": {"vr": "OB", "BinaryLength": 488},
        "2594": {"vr": "OB", "BinaryLength": 488},
        "2595": {"vr": "OB", "BinaryLength": 488},
        "2596": {"vr": "OB", "BinaryLength": 488},
        "2597": {"vr": "OB", "BinaryLength": 488},
        "2598": {"vr": "OB", "BinaryLength": 488},
        "2599": {"vr": "OB", "BinaryLength": 488},
        "2600": {"vr": "OB", "BinaryLength": 488},
        "2601": {"vr": "OB", "BinaryLength": 488},
        "2602": {"vr": "OB", "BinaryLength": 488},
        "2603": {"vr": "OB", "BinaryLength": 488},
        "2604": {"vr": "OB", "BinaryLength": 488},
        "2605": {"vr": "OB", "BinaryLength": 488},
        "2606": {"vr": "OB", "BinaryLength": 488},
        "2607": {"vr": "OB", "BinaryLength": 488},
        "2608": {"vr": "OB", "BinaryLength": 488},
        "2609": {"vr": "OB", "BinaryLength": 124},
        "2610": {"vr": "OB", "BinaryLength": 488},
        "2611": {"vr": "OB", "BinaryLength": 124},
        "2612": {"vr": "OB", "BinaryLength": 488},
        "2613": {"vr": "OB", "BinaryLength": 488},
        "2614": {"vr": "OB", "BinaryLength": 488},
        "2615": {"vr": "OB", "BinaryLength": 488},
        "2616": {"vr": "OB", "BinaryLength": 488},
        "2617": {"vr": "OB", "BinaryLength": 488},
        "2618": {"vr": "OB", "BinaryLength": 124},
        "2619": {"vr": "OB", "BinaryLength": 488},
        "2620": {"vr": "OB", "BinaryLength": 488},
        "2621": {"vr": "OB", "BinaryLength": 488},
        "2622": {"vr": "OB", "BinaryLength": 488},
        "2623": {"vr": "OB", "BinaryLength": 488},
        "2624": {"vr": "OB", "BinaryLength": 488},
        "2625": {"vr": "OB", "BinaryLength": 488},
        "2626": {"vr": "OB", "BinaryLength": 488},
        "2627": {"vr": "OB", "BinaryLength": 488},
        "2628": {"vr": "OB", "BinaryLength": 124},
        "2629": {"vr": "OB", "BinaryLength": 124},
        "2630": {"vr": "OB", "BinaryLength": 488},
        "2631": {"vr": "OB", "BinaryLength": 488},
        "2632": {"vr": "OB", "BinaryLength": 488},
        "2633": {"vr": "OB", "BinaryLength": 488},
        "2634": {"vr": "OB", "BinaryLength": 488},
        "2635": {"vr": "OB", "BinaryLength": 488},
        "2636": {"vr": "OB", "BinaryLength": 124},
        "2637": {"vr": "OB", "BinaryLength": 488},
        "2638": {"vr": "OB", "BinaryLength": 488},
        "2639": {"vr": "OB", "BinaryLength": 124},
        "2640": {"vr": "OB", "BinaryLength": 124},
        "2641": {"vr": "OB", "BinaryLength": 488},
        "2642": {"vr": "OB", "BinaryLength": 488},
        "2643": {"vr": "OB", "BinaryLength": 488},
        "2644": {"vr": "OB", "BinaryLength": 488},
        "2645": {"vr": "OB", "BinaryLength": 488},
        "2646": {"vr": "OB", "BinaryLength": 488},
        "2647": {"vr": "OB", "BinaryLength": 488},
        "2648": {"vr": "OB", "BinaryLength": 488},
        "2649": {"vr": "OB", "BinaryLength": 488},
        "2650": {"vr": "OB", "BinaryLength": 488},
        "2651": {"vr": "OB", "BinaryLength": 488},
        "2652": {"vr": "OB", "BinaryLength": 488},
        "2653": {"vr": "OB", "BinaryLength": 488},
        "2654": {"vr": "OB", "BinaryLength": 488},
        "2655": {"vr": "OB", "BinaryLength": 488},
        "2656": {"vr": "OB", "BinaryLength": 488},
        "2657": {"vr": "OB", "BinaryLength": 488},
        "2658": {"vr": "OB", "BinaryLength": 124},
        "2659": {"vr": "OB", "BinaryLength": 488},
        "2660": {"vr": "OB", "BinaryLength": 488},
        "2661": {"vr": "OB", "BinaryLength": 488},
        "2662": {"vr": "OB", "BinaryLength": 488},
        "2663": {"vr": "OB", "BinaryLength": 488},
        "2664": {"vr": "OB", "BinaryLength": 488},
        "2665": {"vr": "OB", "BinaryLength": 488},
        "2666": {"vr": "OB", "BinaryLength": 488},
        "2667": {"vr": "OB", "BinaryLength": 488},
        "2668": {"vr": "OB", "BinaryLength": 488},
        "2669": {"vr": "OB", "BinaryLength": 488},
        "2670": {"vr": "OB", "BinaryLength": 488},
        "2671": {"vr": "OB", "BinaryLength": 488},
        "2672": {"vr": "OB", "BinaryLength": 488},
        "2673": {"vr": "OB", "BinaryLength": 488},
        "2674": {"vr": "OB", "BinaryLength": 488},
        "2675": {"vr": "OB", "BinaryLength": 488},
        "2676": {"vr": "OB", "BinaryLength": 488},
        "2677": {"vr": "OB", "BinaryLength": 488},
        "2678": {"vr": "OB", "BinaryLength": 488},
        "2679": {"vr": "OB", "BinaryLength": 124},
        "2680": {"vr": "OB", "BinaryLength": 124},
        "2681": {"vr": "OB", "BinaryLength": 488},
        "2682": {"vr": "OB", "BinaryLength": 488},
        "2683": {"vr": "OB", "BinaryLength": 488},
        "2684": {"vr": "OB", "BinaryLength": 488},
        "2685": {"vr": "OB", "BinaryLength": 488},
        "2686": {"vr": "OB", "BinaryLength": 488},
        "2687": {"vr": "OB", "BinaryLength": 488},
        "2688": {"vr": "OB", "BinaryLength": 488},
        "2689": {"vr": "OB", "BinaryLength": 488},
        "2690": {"vr": "OB", "BinaryLength": 488},
        "2691": {"vr": "OB", "BinaryLength": 488},
        "2692": {"vr": "OB", "BinaryLength": 488},
        "2693": {"vr": "OB", "BinaryLength": 488},
        "2694": {"vr": "OB", "BinaryLength": 488},
        "2695": {"vr": "OB", "BinaryLength": 488},
        "2696": {"vr": "OB", "BinaryLength": 488},
        "2697": {"vr": "OB", "BinaryLength": 488},
        "2698": {"vr": "OB", "BinaryLength": 488},
        "2699": {"vr": "OB", "BinaryLength": 488},
        "2700": {"vr": "OB", "BinaryLength": 488},
        "2701": {"vr": "OB", "BinaryLength": 488},
        "2702": {"vr": "OB", "BinaryLength": 124},
        "2703": {"vr": "OB", "BinaryLength": 488},
        "2704": {"vr": "OB", "BinaryLength": 488},
        "2705": {"vr": "OB", "BinaryLength": 488},
        "2706": {"vr": "OB", "BinaryLength": 488},
        "2707": {"vr": "OB", "BinaryLength": 488},
        "2708": {"vr": "OB", "BinaryLength": 488},
        "2709": {"vr": "OB", "BinaryLength": 488},
        "2710": {"vr": "OB", "BinaryLength": 488},
        "2711": {"vr": "OB", "BinaryLength": 488},
        "2712": {"vr": "OB", "BinaryLength": 488},
        "2713": {"vr": "OB", "BinaryLength": 488},
        "2714": {"vr": "OB", "BinaryLength": 488},
        "2715": {"vr": "OB", "BinaryLength": 488},
        "2716": {"vr": "OB", "BinaryLength": 488},
        "2717": {"vr": "OB", "BinaryLength": 488},
        "2718": {"vr": "OB", "BinaryLength": 488},
        "2719": {"vr": "OB", "BinaryLength": 488},
        "2720": {"vr": "OB", "BinaryLength": 488},
        "2721": {"vr": "OB", "BinaryLength": 488},
        "2722": {"vr": "OB", "BinaryLength": 488},
        "2723": {"vr": "OB", "BinaryLength": 488},
        "2724": {"vr": "OB", "BinaryLength": 488},
        "2725": {"vr": "OB", "BinaryLength": 488},
        "2726": {"vr": "OB", "BinaryLength": 124},
        "2727": {"vr": "OB", "BinaryLength": 488},
        "2728": {"vr": "OB", "BinaryLength": 488},
        "2729": {"vr": "OB", "BinaryLength": 488},
        "2730": {"vr": "OB", "BinaryLength": 488},
        "2731": {"vr": "OB", "BinaryLength": 488},
        "2732": {"vr": "OB", "BinaryLength": 488},
        "2733": {"vr": "OB", "BinaryLength": 488},
        "2734": {"vr": "OB", "BinaryLength": 488},
        "2735": {"vr": "OB", "BinaryLength": 488},
        "2736": {"vr": "OB", "BinaryLength": 124},
        "2737": {"vr": "OB", "BinaryLength": 488},
        "2738": {"vr": "OB", "BinaryLength": 488},
        "2739": {"vr": "OB", "BinaryLength": 488},
        "2740": {"vr": "OB", "BinaryLength": 488},
        "2741": {"vr": "OB", "BinaryLength": 124},
        "2742": {"vr": "OB", "BinaryLength": 488},
        "2743": {"vr": "OB", "BinaryLength": 488},
        "2744": {"vr": "OB", "BinaryLength": 488},
        "2745": {"vr": "OB", "BinaryLength": 488},
        "2746": {"vr": "OB", "BinaryLength": 124},
        "2747": {"vr": "OB", "BinaryLength": 488},
        "2748": {"vr": "OB", "BinaryLength": 488},
        "2749": {"vr": "OB", "BinaryLength": 488},
        "2750": {"vr": "OB", "BinaryLength": 124},
        "2751": {"vr": "OB", "BinaryLength": 488},
        "2752": {"vr": "OB", "BinaryLength": 488},
        "2753": {"vr": "OB", "BinaryLength": 488},
        "2754": {"vr": "OB", "BinaryLength": 488},
        "2755": {"vr": "OB", "BinaryLength": 488},
        "2756": {"vr": "OB", "BinaryLength": 488},
        "2757": {"vr": "OB", "BinaryLength": 124},
        "2758": {"vr": "OB", "BinaryLength": 488},
        "2759": {"vr": "OB", "BinaryLength": 488},
        "2760": {"vr": "OB", "BinaryLength": 488},
        "2761": {"vr": "OB", "BinaryLength": 488},
        "2762": {"vr": "OB", "BinaryLength": 488},
        "2763": {"vr": "OB", "BinaryLength": 488},
        "2764": {"vr": "OB", "BinaryLength": 488},
        "2765": {"vr": "OB", "BinaryLength": 124},
        "2766": {"vr": "OB", "BinaryLength": 488},
        "2767": {"vr": "OB", "BinaryLength": 488},
        "2768": {"vr": "OB", "BinaryLength": 488},
        "2769": {"vr": "OB", "BinaryLength": 488},
        "2770": {"vr": "OB", "BinaryLength": 124},
        "2771": {"vr": "OB", "BinaryLength": 488},
        "2772": {"vr": "OB", "BinaryLength": 488},
        "2773": {"vr": "OB", "BinaryLength": 488},
        "2774": {"vr": "OB", "BinaryLength": 488},
        "2775": {"vr": "OB", "BinaryLength": 488},
        "2776": {"vr": "OB", "BinaryLength": 488},
        "2777": {"vr": "OB", "BinaryLength": 124},
        "2778": {"vr": "OB", "BinaryLength": 488},
        "2779": {"vr": "OB", "BinaryLength": 488},
        "2780": {"vr": "OB", "BinaryLength": 488},
        "2781": {"vr": "OB", "BinaryLength": 124},
        "2782": {"vr": "OB", "BinaryLength": 488},
        "2783": {"vr": "OB", "BinaryLength": 488},
        "2784": {"vr": "OB", "BinaryLength": 488},
        "2785": {"vr": "OB", "BinaryLength": 488},
        "2786": {"vr": "OB", "BinaryLength": 488},
        "2787": {"vr": "OB", "BinaryLength": 488},
        "2788": {"vr": "OB", "BinaryLength": 488},
        "2789": {"vr": "OB", "BinaryLength": 488},
        "2790": {"vr": "OB", "BinaryLength": 488},
        "2791": {"vr": "OB", "BinaryLength": 488},
        "2792": {"vr": "OB", "BinaryLength": 124},
        "2793": {"vr": "OB", "BinaryLength": 488},
        "2794": {"vr": "OB", "BinaryLength": 488},
        "2795": {"vr": "OB", "BinaryLength": 488},
        "2796": {"vr": "OB", "BinaryLength": 488},
        "2797": {"vr": "OB", "BinaryLength": 124},
        "2798": {"vr": "OB", "BinaryLength": 488},
        "2799": {"vr": "OB", "BinaryLength": 488},
        "2800": {"vr": "OB", "BinaryLength": 488},
        "2801": {"vr": "OB", "BinaryLength": 488},
        "2802": {"vr": "OB", "BinaryLength": 488},
        "2803": {"vr": "OB", "BinaryLength": 488},
        "2804": {"vr": "OB", "BinaryLength": 488},
        "2805": {"vr": "OB", "BinaryLength": 488},
        "2806": {"vr": "OB", "BinaryLength": 488},
        "2807": {"vr": "OB", "BinaryLength": 488},
        "2808": {"vr": "OB", "BinaryLength": 488},
        "2809": {"vr": "OB", "BinaryLength": 488},
        "2810": {"vr": "OB", "BinaryLength": 488},
        "2811": {"vr": "OB", "BinaryLength": 488},
        "2812": {"vr": "OB", "BinaryLength": 488},
        "2813": {"vr": "OB", "BinaryLength": 488},
        "2814": {"vr": "OB", "BinaryLength": 488},
        "2815": {"vr": "OB", "BinaryLength": 488},
        "2816": {"vr": "OB", "BinaryLength": 488},
        "2817": {"vr": "OB", "BinaryLength": 488},
        "2818": {"vr": "OB", "BinaryLength": 124},
        "2819": {"vr": "OB", "BinaryLength": 488},
        "2820": {"vr": "OB", "BinaryLength": 488},
        "2821": {"vr": "OB", "BinaryLength": 488},
        "2822": {"vr": "OB", "BinaryLength": 124},
        "2823": {"vr": "OB", "BinaryLength": 488},
        "2824": {"vr": "OB", "BinaryLength": 488},
        "2825": {"vr": "OB", "BinaryLength": 488},
        "2826": {"vr": "OB", "BinaryLength": 488},
        "2827": {"vr": "OB", "BinaryLength": 488},
        "2828": {"vr": "OB", "BinaryLength": 488},
        "2829": {"vr": "OB", "BinaryLength": 488},
        "2830": {"vr": "OB", "BinaryLength": 124},
        "2831": {"vr": "OB", "BinaryLength": 488},
        "2832": {"vr": "OB", "BinaryLength": 488},
        "2833": {"vr": "OB", "BinaryLength": 488},
        "2834": {"vr": "OB", "BinaryLength": 488},
        "2835": {"vr": "OB", "BinaryLength": 488},
        "2836": {"vr": "OB", "BinaryLength": 488},
        "2837": {"vr": "OB", "BinaryLength": 488},
        "2838": {"vr": "OB", "BinaryLength": 488},
        "2839": {"vr": "OB", "BinaryLength": 488},
        "2840": {"vr": "OB", "BinaryLength": 488},
        "2841": {"vr": "OB", "BinaryLength": 488},
        "2842": {"vr": "OB", "BinaryLength": 488},
        "2843": {"vr": "OB", "BinaryLength": 488},
        "2844": {"vr": "OB", "BinaryLength": 488},
        "2845": {"vr": "OB", "BinaryLength": 488},
        "2846": {"vr": "OB", "BinaryLength": 488},
        "2847": {"vr": "OB", "BinaryLength": 488},
        "2848": {"vr": "OB", "BinaryLength": 488},
        "2849": {"vr": "OB", "BinaryLength": 488},
        "2850": {"vr": "OB", "BinaryLength": 488},
        "2851": {"vr": "OB", "BinaryLength": 488},
        "2852": {"vr": "OB", "BinaryLength": 124},
        "2853": {"vr": "OB", "BinaryLength": 488},
        "2854": {"vr": "OB", "BinaryLength": 488},
        "2855": {"vr": "OB", "BinaryLength": 124},
        "2856": {"vr": "OB", "BinaryLength": 488},
        "2857": {"vr": "OB", "BinaryLength": 488},
        "2858": {"vr": "OB", "BinaryLength": 488},
        "2859": {"vr": "OB", "BinaryLength": 488},
        "2860": {"vr": "OB", "BinaryLength": 488},
        "2861": {"vr": "OB", "BinaryLength": 488},
        "2862": {"vr": "OB", "BinaryLength": 124},
        "2863": {"vr": "OB", "BinaryLength": 488},
        "2864": {"vr": "OB", "BinaryLength": 488},
        "2865": {"vr": "OB", "BinaryLength": 488},
        "2866": {"vr": "OB", "BinaryLength": 488},
        "2867": {"vr": "OB", "BinaryLength": 488},
        "2868": {"vr": "OB", "BinaryLength": 488},
        "2869": {"vr": "OB", "BinaryLength": 488},
        "2870": {"vr": "OB", "BinaryLength": 488},
        "2871": {"vr": "OB", "BinaryLength": 488},
        "2872": {"vr": "OB", "BinaryLength": 488},
        "2873": {"vr": "OB", "BinaryLength": 488},
        "2874": {"vr": "OB", "BinaryLength": 488},
        "2875": {"vr": "OB", "BinaryLength": 488},
        "2876": {"vr": "OB", "BinaryLength": 488},
        "2877": {"vr": "OB", "BinaryLength": 488},
        "2878": {"vr": "OB", "BinaryLength": 124},
        "2879": {"vr": "OB", "BinaryLength": 488},
        "2880": {"vr": "OB", "BinaryLength": 488},
        "2881": {"vr": "OB", "BinaryLength": 488},
        "2882": {"vr": "OB", "BinaryLength": 124},
        "2883": {"vr": "OB", "BinaryLength": 488},
        "2884": {"vr": "OB", "BinaryLength": 488},
        "2885": {"vr": "OB", "BinaryLength": 488},
        "2886": {"vr": "OB", "BinaryLength": 488},
        "2887": {"vr": "OB", "BinaryLength": 488},
        "2888": {"vr": "OB", "BinaryLength": 488},
        "2889": {"vr": "OB", "BinaryLength": 488},
        "2890": {"vr": "OB", "BinaryLength": 488},
        "2891": {"vr": "OB", "BinaryLength": 488},
        "2892": {"vr": "OB", "BinaryLength": 488},
        "2893": {"vr": "OB", "BinaryLength": 488},
        "2894": {"vr": "OB", "BinaryLength": 488},
        "2895": {"vr": "OB", "BinaryLength": 488},
        "2896": {"vr": "OB", "BinaryLength": 488},
        "2897": {"vr": "OB", "BinaryLength": 488},
        "2898": {"vr": "OB", "BinaryLength": 488},
        "2899": {"vr": "OB", "BinaryLength": 488},
        "2900": {"vr": "OB", "BinaryLength": 488},
        "2901": {"vr": "OB", "BinaryLength": 488},
        "2902": {"vr": "OB", "BinaryLength": 488},
        "2903": {"vr": "OB", "BinaryLength": 488},
        "2904": {"vr": "OB", "BinaryLength": 488},
        "2905": {"vr": "OB", "BinaryLength": 488},
        "2906": {"vr": "OB", "BinaryLength": 124},
        "2907": {"vr": "OB", "BinaryLength": 124},
        "2908": {"vr": "OB", "BinaryLength": 488},
        "2909": {"vr": "OB", "BinaryLength": 488},
        "2910": {"vr": "OB", "BinaryLength": 488},
        "2911": {"vr": "OB", "BinaryLength": 488},
        "2912": {"vr": "OB", "BinaryLength": 488},
        "2913": {"vr": "OB", "BinaryLength": 488},
        "2914": {"vr": "OB", "BinaryLength": 488},
        "2915": {"vr": "OB", "BinaryLength": 488},
        "2916": {"vr": "OB", "BinaryLength": 124},
        "2917": {"vr": "OB", "BinaryLength": 488},
        "2918": {"vr": "OB", "BinaryLength": 124},
        "2919": {"vr": "OB", "BinaryLength": 124},
        "2920": {"vr": "OB", "BinaryLength": 488},
        "2921": {"vr": "OB", "BinaryLength": 488},
        "2922": {"vr": "OB", "BinaryLength": 488},
        "2923": {"vr": "OB", "BinaryLength": 124},
        "2924": {"vr": "OB", "BinaryLength": 488},
        "2925": {"vr": "OB", "BinaryLength": 488},
        "2926": {"vr": "OB", "BinaryLength": 488},
        "2927": {"vr": "OB", "BinaryLength": 488},
        "2928": {"vr": "OB", "BinaryLength": 488},
        "2929": {"vr": "OB", "BinaryLength": 488},
        "2930": {"vr": "OB", "BinaryLength": 124},
        "2931": {"vr": "OB", "BinaryLength": 488},
        "2932": {"vr": "OB", "BinaryLength": 488},
        "2933": {"vr": "OB", "BinaryLength": 488},
        "2934": {"vr": "OB", "BinaryLength": 488},
        "2935": {"vr": "OB", "BinaryLength": 124},
        "2936": {"vr": "OB", "BinaryLength": 488},
        "2937": {"vr": "OB", "BinaryLength": 488},
        "2938": {"vr": "OB", "BinaryLength": 488},
        "2939": {"vr": "OB", "BinaryLength": 488},
        "2940": {"vr": "OB", "BinaryLength": 488},
        "2941": {"vr": "OB", "BinaryLength": 488},
        "2942": {"vr": "OB", "BinaryLength": 488},
        "2943": {"vr": "OB", "BinaryLength": 488},
        "2944": {"vr": "OB", "BinaryLength": 488},
        "2945": {"vr": "OB", "BinaryLength": 488},
        "2946": {"vr": "OB", "BinaryLength": 124},
        "2947": {"vr": "OB", "BinaryLength": 488},
        "2948": {"vr": "OB", "BinaryLength": 488},
        "2949": {"vr": "OB", "BinaryLength": 124},
        "2950": {"vr": "OB", "BinaryLength": 488},
        "2951": {"vr": "OB", "BinaryLength": 488},
        "2952": {"vr": "OB", "BinaryLength": 488},
        "2953": {"vr": "OB", "BinaryLength": 488},
        "2954": {"vr": "OB", "BinaryLength": 124},
        "2955": {"vr": "OB", "BinaryLength": 124},
        "2956": {"vr": "OB", "BinaryLength": 488},
        "2957": {"vr": "OB", "BinaryLength": 488},
        "2958": {"vr": "OB", "BinaryLength": 488},
        "2959": {"vr": "OB", "BinaryLength": 488},
        "2960": {"vr": "OB", "BinaryLength": 488},
        "2961": {"vr": "OB", "BinaryLength": 488},
        "2962": {"vr": "OB", "BinaryLength": 488},
        "2963": {"vr": "OB", "BinaryLength": 488},
        "2964": {"vr": "OB", "BinaryLength": 488},
        "2965": {"vr": "OB", "BinaryLength": 488},
        "2966": {"vr": "OB", "BinaryLength": 488},
        "2967": {"vr": "OB", "BinaryLength": 488},
        "2968": {"vr": "OB", "BinaryLength": 124},
        "2969": {"vr": "OB", "BinaryLength": 488},
        "2970": {"vr": "OB", "BinaryLength": 488},
        "2971": {"vr": "OB", "BinaryLength": 488},
        "2972": {"vr": "OB", "BinaryLength": 488},
        "2973": {"vr": "OB", "BinaryLength": 488},
        "2974": {"vr": "OB", "BinaryLength": 488},
        "2975": {"vr": "OB", "BinaryLength": 488},
        "2976": {"vr": "OB", "BinaryLength": 488},
        "2977": {"vr": "OB", "BinaryLength": 488},
        "2978": {"vr": "OB", "BinaryLength": 488},
        "2979": {"vr": "OB", "BinaryLength": 488},
        "2980": {"vr": "OB", "BinaryLength": 488},
        "2981": {"vr": "OB", "BinaryLength": 488},
        "2982": {"vr": "OB", "BinaryLength": 488},
        "2983": {"vr": "OB", "BinaryLength": 488},
        "2984": {"vr": "OB", "BinaryLength": 488},
        "2985": {"vr": "OB", "BinaryLength": 124},
        "2986": {"vr": "OB", "BinaryLength": 488},
        "2987": {"vr": "OB", "BinaryLength": 488},
        "2988": {"vr": "OB", "BinaryLength": 488},
        "2989": {"vr": "OB", "BinaryLength": 488},
        "2990": {"vr": "OB", "BinaryLength": 488},
        "2991": {"vr": "OB", "BinaryLength": 488},
        "2992": {"vr": "OB", "BinaryLength": 488},
        "2993": {"vr": "OB", "BinaryLength": 488},
        "2994": {"vr": "OB", "BinaryLength": 488},
        "2995": {"vr": "OB", "BinaryLength": 488},
        "2996": {"vr": "OB", "BinaryLength": 488},
        "2997": {"vr": "OB", "BinaryLength": 488},
        "2998": {"vr": "OB", "BinaryLength": 488},
        "2999": {"vr": "OB", "BinaryLength": 488},
        "3000": {"vr": "OB", "BinaryLength": 488},
        "3001": {"vr": "OB", "BinaryLength": 488},
        "3002": {"vr": "OB", "BinaryLength": 488},
        "3003": {"vr": "OB", "BinaryLength": 488},
        "3004": {"vr": "OB", "BinaryLength": 488},
        "3005": {"vr": "OB", "BinaryLength": 124},
        "3006": {"vr": "OB", "BinaryLength": 488},
        "3007": {"vr": "OB", "BinaryLength": 488},
        "3008": {"vr": "OB", "BinaryLength": 488},
        "3009": {"vr": "OB", "BinaryLength": 488},
        "3010": {"vr": "OB", "BinaryLength": 488},
        "3011": {"vr": "OB", "BinaryLength": 488},
        "3012": {"vr": "OB", "BinaryLength": 488},
        "3013": {"vr": "OB", "BinaryLength": 488},
        "3014": {"vr": "OB", "BinaryLength": 488},
        "3015": {"vr": "OB", "BinaryLength": 488},
        "3016": {"vr": "OB", "BinaryLength": 488},
        "3017": {"vr": "OB", "BinaryLength": 488},
        "3018": {"vr": "OB", "BinaryLength": 488},
        "3019": {"vr": "OB", "BinaryLength": 124},
        "3020": {"vr": "OB", "BinaryLength": 488},
        "3021": {"vr": "OB", "BinaryLength": 488},
        "3022": {"vr": "OB", "BinaryLength": 488},
        "3023": {"vr": "OB", "BinaryLength": 488},
        "3024": {"vr": "OB", "BinaryLength": 488},
        "3025": {"vr": "OB", "BinaryLength": 488},
        "3026": {"vr": "OB", "BinaryLength": 488},
        "3027": {"vr": "OB", "BinaryLength": 488},
        "3028": {"vr": "OB", "BinaryLength": 488},
        "3029": {"vr": "OB", "BinaryLength": 124},
        "3030": {"vr": "OB", "BinaryLength": 488},
        "3031": {"vr": "OB", "BinaryLength": 488},
        "3032": {"vr": "OB", "BinaryLength": 488},
        "3033": {"vr": "OB", "BinaryLength": 488},
        "3034": {"vr": "OB", "BinaryLength": 488},
        "3035": {"vr": "OB", "BinaryLength": 488},
        "3036": {"vr": "OB", "BinaryLength": 488},
        "3037": {"vr": "OB", "BinaryLength": 488},
        "3038": {"vr": "OB", "BinaryLength": 488},
        "3039": {"vr": "OB", "BinaryLength": 488},
        "3040": {"vr": "OB", "BinaryLength": 488},
        "3041": {"vr": "OB", "BinaryLength": 488},
        "3042": {"vr": "OB", "BinaryLength": 488},
        "3043": {"vr": "OB", "BinaryLength": 488},
        "3044": {"vr": "OB", "BinaryLength": 488},
        "3045": {"vr": "OB", "BinaryLength": 488},
        "3046": {"vr": "OB", "BinaryLength": 488},
        "3047": {"vr": "OB", "BinaryLength": 488},
        "3048": {"vr": "OB", "BinaryLength": 488},
        "3049": {"vr": "OB", "BinaryLength": 488},
        "3050": {"vr": "OB", "BinaryLength": 488},
        "3051": {"vr": "OB", "BinaryLength": 488},
        "3052": {"vr": "OB", "BinaryLength": 488},
        "3053": {"vr": "OB", "BinaryLength": 124},
        "3054": {"vr": "OB", "BinaryLength": 488},
        "3055": {"vr": "OB", "BinaryLength": 488},
        "3056": {"vr": "OB", "BinaryLength": 488},
        "3057": {"vr": "OB", "BinaryLength": 488},
        "3058": {"vr": "OB", "BinaryLength": 488},
        "3059": {"vr": "OB", "BinaryLength": 488},
        "3060": {"vr": "OB", "BinaryLength": 488},
        "3061": {"vr": "OB", "BinaryLength": 488},
        "3062": {"vr": "OB", "BinaryLength": 488},
        "3063": {"vr": "OB", "BinaryLength": 488},
        "3064": {"vr": "OB", "BinaryLength": 488},
        "3065": {"vr": "OB", "BinaryLength": 488},
        "3066": {"vr": "OB", "BinaryLength": 488},
        "3067": {"vr": "OB", "BinaryLength": 488},
        "3068": {"vr": "OB", "BinaryLength": 488},
        "3069": {"vr": "OB", "BinaryLength": 488},
        "3070": {"vr": "OB", "BinaryLength": 488},
        "3071": {"vr": "OB", "BinaryLength": 488},
        "3072": {"vr": "OB", "BinaryLength": 124},
        "3073": {"vr": "OB", "BinaryLength": 488},
        "3074": {"vr": "OB", "BinaryLength": 124},
        "3075": {"vr": "OB", "BinaryLength": 488},
        "3076": {"vr": "OB", "BinaryLength": 488},
        "3077": {"vr": "OB", "BinaryLength": 124},
        "3078": {"vr": "OB", "BinaryLength": 488},
        "3079": {"vr": "OB", "BinaryLength": 488},
        "3080": {"vr": "OB", "BinaryLength": 488},
        "3081": {"vr": "OB", "BinaryLength": 488},
        "3082": {"vr": "OB", "BinaryLength": 488},
        "3083": {"vr": "OB", "BinaryLength": 488},
        "3084": {"vr": "OB", "BinaryLength": 488},
        "3085": {"vr": "OB", "BinaryLength": 488},
        "3086": {"vr": "OB", "BinaryLength": 488},
        "3087": {"vr": "OB", "BinaryLength": 488},
        "3088": {"vr": "OB", "BinaryLength": 488},
        "3089": {"vr": "OB", "BinaryLength": 124},
        "3090": {"vr": "OB", "BinaryLength": 488},
        "3091": {"vr": "OB", "BinaryLength": 488},
        "3092": {"vr": "OB", "BinaryLength": 124},
        "3093": {"vr": "OB", "BinaryLength": 488},
        "3094": {"vr": "OB", "BinaryLength": 488},
        "3095": {"vr": "OB", "BinaryLength": 488},
        "3096": {"vr": "OB", "BinaryLength": 488},
        "3097": {"vr": "OB", "BinaryLength": 488},
        "3098": {"vr": "OB", "BinaryLength": 488},
        "3099": {"vr": "OB", "BinaryLength": 488},
        "3100": {"vr": "OB", "BinaryLength": 488},
        "3101": {"vr": "OB", "BinaryLength": 488},
        "3102": {"vr": "OB", "BinaryLength": 124},
        "3103": {"vr": "OB", "BinaryLength": 488},
        "3104": {"vr": "OB", "BinaryLength": 488},
        "3105": {"vr": "OB", "BinaryLength": 488},
        "3106": {"vr": "OB", "BinaryLength": 488},
        "3107": {"vr": "OB", "BinaryLength": 488},
        "3108": {"vr": "OB", "BinaryLength": 488},
        "3109": {"vr": "OB", "BinaryLength": 488},
        "3110": {"vr": "OB", "BinaryLength": 488},
        "3111": {"vr": "OB", "BinaryLength": 488},
        "3112": {"vr": "OB", "BinaryLength": 488},
        "3113": {"vr": "OB", "BinaryLength": 488},
        "3114": {"vr": "OB", "BinaryLength": 488},
        "3115": {"vr": "OB", "BinaryLength": 488},
        "3116": {"vr": "OB", "BinaryLength": 488},
        "3117": {"vr": "OB", "BinaryLength": 488},
        "3118": {"vr": "OB", "BinaryLength": 488},
        "3119": {"vr": "OB", "BinaryLength": 488},
        "3120": {"vr": "OB", "BinaryLength": 488},
        "3121": {"vr": "OB", "BinaryLength": 488},
        "3122": {"vr": "OB", "BinaryLength": 488},
        "3123": {"vr": "OB", "BinaryLength": 488},
        "3124": {"vr": "OB", "BinaryLength": 488},
        "3125": {"vr": "OB", "BinaryLength": 488},
        "3126": {"vr": "OB", "BinaryLength": 488},
        "3127": {"vr": "OB", "BinaryLength": 488},
        "3128": {"vr": "OB", "BinaryLength": 488},
        "3129": {"vr": "OB", "BinaryLength": 488},
        "3130": {"vr": "OB", "BinaryLength": 488},
        "3131": {"vr": "OB", "BinaryLength": 488},
        "3132": {"vr": "OB", "BinaryLength": 124},
        "3133": {"vr": "OB", "BinaryLength": 488},
        "3134": {"vr": "OB", "BinaryLength": 488},
        "3135": {"vr": "OB", "BinaryLength": 488},
        "3136": {"vr": "OB", "BinaryLength": 488},
        "3137": {"vr": "OB", "BinaryLength": 488},
        "3138": {"vr": "OB", "BinaryLength": 488},
        "3139": {"vr": "OB", "BinaryLength": 488},
        "3140": {"vr": "OB", "BinaryLength": 488},
        "3141": {"vr": "OB", "BinaryLength": 488},
        "3142": {"vr": "OB", "BinaryLength": 488},
        "3143": {"vr": "OB", "BinaryLength": 488},
        "3144": {"vr": "OB", "BinaryLength": 488},
        "3145": {"vr": "OB", "BinaryLength": 488},
        "3146": {"vr": "OB", "BinaryLength": 488},
        "3147": {"vr": "OB", "BinaryLength": 488},
        "3148": {"vr": "OB", "BinaryLength": 488},
        "3149": {"vr": "OB", "BinaryLength": 488},
        "3150": {"vr": "OB", "BinaryLength": 488},
        "3151": {"vr": "OB", "BinaryLength": 488},
        "3152": {"vr": "OB", "BinaryLength": 488},
        "3153": {"vr": "OB", "BinaryLength": 488},
        "3154": {"vr": "OB", "BinaryLength": 488},
        "3155": {"vr": "OB", "BinaryLength": 488},
        "3156": {"vr": "OB", "BinaryLength": 488},
        "3157": {"vr": "OB", "BinaryLength": 488},
        "3158": {"vr": "OB", "BinaryLength": 488},
        "3159": {"vr": "OB", "BinaryLength": 488},
        "3160": {"vr": "OB", "BinaryLength": 124},
        "3161": {"vr": "OB", "BinaryLength": 488},
        "3162": {"vr": "OB", "BinaryLength": 488},
        "3163": {"vr": "OB", "BinaryLength": 488},
        "3164": {"vr": "OB", "BinaryLength": 488},
        "3165": {"vr": "OB", "BinaryLength": 124},
        "3166": {"vr": "OB", "BinaryLength": 488},
        "3167": {"vr": "OB", "BinaryLength": 488},
        "3168": {"vr": "OB", "BinaryLength": 488},
        "3169": {"vr": "OB", "BinaryLength": 488},
        "3170": {"vr": "OB", "BinaryLength": 488},
        "3171": {"vr": "OB", "BinaryLength": 488},
        "3172": {"vr": "OB", "BinaryLength": 124},
        "3173": {"vr": "OB", "BinaryLength": 488},
        "3174": {"vr": "OB", "BinaryLength": 488},
        "3175": {"vr": "OB", "BinaryLength": 488},
        "3176": {"vr": "OB", "BinaryLength": 488},
        "3177": {"vr": "OB", "BinaryLength": 488},
        "3178": {"vr": "OB", "BinaryLength": 488},
        "3179": {"vr": "OB", "BinaryLength": 488},
        "3180": {"vr": "OB", "BinaryLength": 488},
        "3181": {"vr": "OB", "BinaryLength": 488},
        "3182": {"vr": "OB", "BinaryLength": 488},
        "3183": {"vr": "OB", "BinaryLength": 488},
        "3184": {"vr": "OB", "BinaryLength": 488},
        "3185": {"vr": "OB", "BinaryLength": 488},
        "3186": {"vr": "OB", "BinaryLength": 488},
        "3187": {"vr": "OB", "BinaryLength": 488},
        "3188": {"vr": "OB", "BinaryLength": 488},
        "3189": {"vr": "OB", "BinaryLength": 488},
        "3190": {"vr": "OB", "BinaryLength": 488},
        "3191": {"vr": "OB", "BinaryLength": 488},
        "3192": {"vr": "OB", "BinaryLength": 488},
        "3193": {"vr": "OB", "BinaryLength": 124},
        "3194": {"vr": "OB", "BinaryLength": 124},
        "3195": {"vr": "OB", "BinaryLength": 488},
        "3196": {"vr": "OB", "BinaryLength": 488},
        "3197": {"vr": "OB", "BinaryLength": 488},
        "3198": {"vr": "OB", "BinaryLength": 488},
        "3199": {"vr": "OB", "BinaryLength": 488},
        "3200": {"vr": "OB", "BinaryLength": 488},
        "3201": {"vr": "OB", "BinaryLength": 488},
        "3202": {"vr": "OB", "BinaryLength": 488},
        "3203": {"vr": "OB", "BinaryLength": 488},
        "3204": {"vr": "OB", "BinaryLength": 488},
        "3205": {"vr": "OB", "BinaryLength": 488},
        "3206": {"vr": "OB", "BinaryLength": 488},
        "3207": {"vr": "OB", "BinaryLength": 488},
        "3208": {"vr": "OB", "BinaryLength": 488},
        "3209": {"vr": "OB", "BinaryLength": 488},
        "3210": {"vr": "OB", "BinaryLength": 488},
        "3211": {"vr": "OB", "BinaryLength": 488},
        "3212": {"vr": "OB", "BinaryLength": 488},
        "3213": {"vr": "OB", "BinaryLength": 488},
        "3214": {"vr": "OB", "BinaryLength": 124},
        "3215": {"vr": "OB", "BinaryLength": 488},
        "3216": {"vr": "OB", "BinaryLength": 488},
        "3217": {"vr": "OB", "BinaryLength": 488},
        "3218": {"vr": "OB", "BinaryLength": 124},
        "3219": {"vr": "OB", "BinaryLength": 488},
        "3220": {"vr": "OB", "BinaryLength": 488},
        "3221": {"vr": "OB", "BinaryLength": 488},
        "3222": {"vr": "OB", "BinaryLength": 488},
        "3223": {"vr": "OB", "BinaryLength": 488},
        "3224": {"vr": "OB", "BinaryLength": 488},
        "3225": {"vr": "OB", "BinaryLength": 488},
        "3226": {"vr": "OB", "BinaryLength": 488},
        "3227": {"vr": "OB", "BinaryLength": 488},
        "3228": {"vr": "OB", "BinaryLength": 488},
        "3229": {"vr": "OB", "BinaryLength": 488},
        "3230": {"vr": "OB", "BinaryLength": 124},
        "3231": {"vr": "OB", "BinaryLength": 488},
        "3232": {"vr": "OB", "BinaryLength": 488},
        "3233": {"vr": "OB", "BinaryLength": 488},
        "3234": {"vr": "OB", "BinaryLength": 488},
        "3235": {"vr": "OB", "BinaryLength": 488},
        "3236": {"vr": "OB", "BinaryLength": 488},
        "3237": {"vr": "OB", "BinaryLength": 488},
        "3238": {"vr": "OB", "BinaryLength": 488},
        "3239": {"vr": "OB", "BinaryLength": 488},
        "3240": {"vr": "OB", "BinaryLength": 488},
        "3241": {"vr": "OB", "BinaryLength": 488},
        "3242": {"vr": "OB", "BinaryLength": 488},
        "3243": {"vr": "OB", "BinaryLength": 124},
        "3244": {"vr": "OB", "BinaryLength": 488},
        "3245": {"vr": "OB", "BinaryLength": 488},
        "3246": {"vr": "OB", "BinaryLength": 488},
        "3247": {"vr": "OB", "BinaryLength": 488},
        "3248": {"vr": "OB", "BinaryLength": 488},
        "3249": {"vr": "OB", "BinaryLength": 488},
        "3250": {"vr": "OB", "BinaryLength": 488},
        "3251": {"vr": "OB", "BinaryLength": 488},
        "3252": {"vr": "OB", "BinaryLength": 488},
        "3253": {"vr": "OB", "BinaryLength": 488},
        "3254": {"vr": "OB", "BinaryLength": 488},
        "3255": {"vr": "OB", "BinaryLength": 488},
        "3256": {"vr": "OB", "BinaryLength": 124},
        "3257": {"vr": "OB", "BinaryLength": 488},
        "3258": {"vr": "OB", "BinaryLength": 124},
        "3259": {"vr": "OB", "BinaryLength": 488},
        "3260": {"vr": "OB", "BinaryLength": 488},
        "3261": {"vr": "OB", "BinaryLength": 488},
        "3262": {"vr": "OB", "BinaryLength": 488},
        "3263": {"vr": "OB", "BinaryLength": 488},
        "3264": {"vr": "OB", "BinaryLength": 124},
        "3265": {"vr": "OB", "BinaryLength": 488},
        "3266": {"vr": "OB", "BinaryLength": 488},
        "3267": {"vr": "OB", "BinaryLength": 488},
        "3268": {"vr": "OB", "BinaryLength": 488},
        "3269": {"vr": "OB", "BinaryLength": 488},
        "3270": {"vr": "OB", "BinaryLength": 124},
        "3271": {"vr": "OB", "BinaryLength": 488},
        "3272": {"vr": "OB", "BinaryLength": 488},
        "3273": {"vr": "OB", "BinaryLength": 488},
        "3274": {"vr": "OB", "BinaryLength": 488},
        "3275": {"vr": "OB", "BinaryLength": 488},
        "3276": {"vr": "OB", "BinaryLength": 488},
        "3277": {"vr": "OB", "BinaryLength": 488},
        "3278": {"vr": "OB", "BinaryLength": 488},
        "3279": {"vr": "OB", "BinaryLength": 488},
        "3280": {"vr": "OB", "BinaryLength": 124},
        "3281": {"vr": "OB", "BinaryLength": 488},
        "3282": {"vr": "OB", "BinaryLength": 488},
        "3283": {"vr": "OB", "BinaryLength": 488},
        "3284": {"vr": "OB", "BinaryLength": 488},
        "3285": {"vr": "OB", "BinaryLength": 488},
        "3286": {"vr": "OB", "BinaryLength": 488},
        "3287": {"vr": "OB", "BinaryLength": 488},
        "3288": {"vr": "OB", "BinaryLength": 488},
        "3289": {"vr": "OB", "BinaryLength": 488},
        "3290": {"vr": "OB", "BinaryLength": 488},
        "3291": {"vr": "OB", "BinaryLength": 488},
        "3292": {"vr": "OB", "BinaryLength": 488},
        "3293": {"vr": "OB", "BinaryLength": 488},
        "3294": {"vr": "OB", "BinaryLength": 488},
        "3295": {"vr": "OB", "BinaryLength": 488},
        "3296": {"vr": "OB", "BinaryLength": 488},
        "3297": {"vr": "OB", "BinaryLength": 488},
        "3298": {"vr": "OB", "BinaryLength": 488},
        "3299": {"vr": "OB", "BinaryLength": 488},
        "3300": {"vr": "OB", "BinaryLength": 488},
        "3301": {"vr": "OB", "BinaryLength": 488},
        "3302": {"vr": "OB", "BinaryLength": 488},
        "3303": {"vr": "OB", "BinaryLength": 488},
        "3304": {"vr": "OB", "BinaryLength": 488},
        "3305": {"vr": "OB", "BinaryLength": 488},
        "3306": {"vr": "OB", "BinaryLength": 488},
        "3307": {"vr": "OB", "BinaryLength": 488},
        "3308": {"vr": "OB", "BinaryLength": 488},
        "3309": {"vr": "OB", "BinaryLength": 488},
        "3310": {"vr": "OB", "BinaryLength": 488},
        "3311": {"vr": "OB", "BinaryLength": 488},
        "3312": {"vr": "OB", "BinaryLength": 488},
        "3313": {"vr": "OB", "BinaryLength": 488},
        "3314": {"vr": "OB", "BinaryLength": 488},
        "3315": {"vr": "OB", "BinaryLength": 124},
        "3316": {"vr": "OB", "BinaryLength": 488},
        "3317": {"vr": "OB", "BinaryLength": 488},
        "3318": {"vr": "OB", "BinaryLength": 488},
        "3319": {"vr": "OB", "BinaryLength": 488},
        "3320": {"vr": "OB", "BinaryLength": 488},
        "3321": {"vr": "OB", "BinaryLength": 488},
        "3322": {"vr": "OB", "BinaryLength": 488},
        "3323": {"vr": "OB", "BinaryLength": 488},
        "3324": {"vr": "OB", "BinaryLength": 488},
        "3325": {"vr": "OB", "BinaryLength": 488},
        "3326": {"vr": "OB", "BinaryLength": 488},
        "3327": {"vr": "OB", "BinaryLength": 488},
        "3328": {"vr": "OB", "BinaryLength": 124},
        "3329": {"vr": "OB", "BinaryLength": 488},
        "3330": {"vr": "OB", "BinaryLength": 488},
        "3331": {"vr": "OB", "BinaryLength": 488},
        "3332": {"vr": "OB", "BinaryLength": 488},
        "3333": {"vr": "OB", "BinaryLength": 488},
        "3334": {"vr": "OB", "BinaryLength": 488},
        "3335": {"vr": "OB", "BinaryLength": 488},
        "3336": {"vr": "OB", "BinaryLength": 488},
        "3337": {"vr": "OB", "BinaryLength": 488},
        "3338": {"vr": "OB", "BinaryLength": 488},
        "3339": {"vr": "OB", "BinaryLength": 488},
        "3340": {"vr": "OB", "BinaryLength": 488},
        "3341": {"vr": "OB", "BinaryLength": 488},
        "3342": {"vr": "OB", "BinaryLength": 488},
        "3343": {"vr": "OB", "BinaryLength": 124},
        "3344": {"vr": "OB", "BinaryLength": 488},
        "3345": {"vr": "OB", "BinaryLength": 488},
        "3346": {"vr": "OB", "BinaryLength": 488},
        "3347": {"vr": "OB", "BinaryLength": 124},
        "3348": {"vr": "OB", "BinaryLength": 488},
        "3349": {"vr": "OB", "BinaryLength": 488},
        "3350": {"vr": "OB", "BinaryLength": 488},
        "3351": {"vr": "OB", "BinaryLength": 488},
        "3352": {"vr": "OB", "BinaryLength": 488},
        "3353": {"vr": "OB", "BinaryLength": 488},
        "3354": {"vr": "OB", "BinaryLength": 488},
        "3355": {"vr": "OB", "BinaryLength": 488},
        "3356": {"vr": "OB", "BinaryLength": 488},
        "3357": {"vr": "OB", "BinaryLength": 488},
        "3358": {"vr": "OB", "BinaryLength": 488},
        "3359": {"vr": "OB", "BinaryLength": 488},
        "3360": {"vr": "OB", "BinaryLength": 488},
        "3361": {"vr": "OB", "BinaryLength": 488},
        "3362": {"vr": "OB", "BinaryLength": 488},
        "3363": {"vr": "OB", "BinaryLength": 488},
        "3364": {"vr": "OB", "BinaryLength": 488},
        "3365": {"vr": "OB", "BinaryLength": 124},
        "3366": {"vr": "OB", "BinaryLength": 488},
        "3367": {"vr": "OB", "BinaryLength": 488},
        "3368": {"vr": "OB", "BinaryLength": 488},
        "3369": {"vr": "OB", "BinaryLength": 488},
        "3370": {"vr": "OB", "BinaryLength": 488},
        "3371": {"vr": "OB", "BinaryLength": 488},
        "3372": {"vr": "OB", "BinaryLength": 488},
        "3373": {"vr": "OB", "BinaryLength": 488},
        "3374": {"vr": "OB", "BinaryLength": 488},
        "3375": {"vr": "OB", "BinaryLength": 488},
        "3376": {"vr": "OB", "BinaryLength": 124},
        "3377": {"vr": "OB", "BinaryLength": 488},
        "3378": {"vr": "OB", "BinaryLength": 488},
        "3379": {"vr": "OB", "BinaryLength": 488},
        "3380": {"vr": "OB", "BinaryLength": 488},
        "3381": {"vr": "OB", "BinaryLength": 488},
        "3382": {"vr": "OB", "BinaryLength": 124},
        "3383": {"vr": "OB", "BinaryLength": 488},
        "3384": {"vr": "OB", "BinaryLength": 124},
        "3385": {"vr": "OB", "BinaryLength": 488},
        "3386": {"vr": "OB", "BinaryLength": 488},
        "3387": {"vr": "OB", "BinaryLength": 488},
        "3388": {"vr": "OB", "BinaryLength": 488},
        "3389": {"vr": "OB", "BinaryLength": 124},
        "3390": {"vr": "OB", "BinaryLength": 488},
        "3391": {"vr": "OB", "BinaryLength": 488},
        "3392": {"vr": "OB", "BinaryLength": 488},
        "3393": {"vr": "OB", "BinaryLength": 488},
        "3394": {"vr": "OB", "BinaryLength": 488},
        "3395": {"vr": "OB", "BinaryLength": 488},
        "3396": {"vr": "OB", "BinaryLength": 488},
        "3397": {"vr": "OB", "BinaryLength": 488},
        "3398": {"vr": "OB", "BinaryLength": 488},
        "3399": {"vr": "OB", "BinaryLength": 488},
        "3400": {"vr": "OB", "BinaryLength": 488},
        "3401": {"vr": "OB", "BinaryLength": 488},
        "3402": {"vr": "OB", "BinaryLength": 488},
        "3403": {"vr": "OB", "BinaryLength": 488},
        "3404": {"vr": "OB", "BinaryLength": 488},
        "3405": {"vr": "OB", "BinaryLength": 124},
        "3406": {"vr": "OB", "BinaryLength": 488},
        "3407": {"vr": "OB", "BinaryLength": 488},
        "3408": {"vr": "OB", "BinaryLength": 488},
        "3409": {"vr": "OB", "BinaryLength": 488},
        "3410": {"vr": "OB", "BinaryLength": 488},
        "3411": {"vr": "OB", "BinaryLength": 488},
        "3412": {"vr": "OB", "BinaryLength": 488},
        "3413": {"vr": "OB", "BinaryLength": 488},
        "3414": {"vr": "OB", "BinaryLength": 488},
        "3415": {"vr": "OB", "BinaryLength": 488},
        "3416": {"vr": "OB", "BinaryLength": 488},
        "3417": {"vr": "OB", "BinaryLength": 488},
        "3418": {"vr": "OB", "BinaryLength": 488},
        "3419": {"vr": "OB", "BinaryLength": 488},
        "3420": {"vr": "OB", "BinaryLength": 488},
        "3421": {"vr": "OB", "BinaryLength": 488},
        "3422": {"vr": "OB", "BinaryLength": 488},
        "3423": {"vr": "OB", "BinaryLength": 488},
        "3424": {"vr": "OB", "BinaryLength": 488},
        "3425": {"vr": "OB", "BinaryLength": 488},
        "3426": {"vr": "OB", "BinaryLength": 488},
        "3427": {"vr": "OB", "BinaryLength": 488},
        "3428": {"vr": "OB", "BinaryLength": 488},
        "3429": {"vr": "OB", "BinaryLength": 488},
        "3430": {"vr": "OB", "BinaryLength": 488},
        "3431": {"vr": "OB", "BinaryLength": 124},
        "3432": {"vr": "OB", "BinaryLength": 488},
        "3433": {"vr": "OB", "BinaryLength": 488},
        "3434": {"vr": "OB", "BinaryLength": 488},
        "3435": {"vr": "OB", "BinaryLength": 488},
        "3436": {"vr": "OB", "BinaryLength": 124},
        "3437": {"vr": "OB", "BinaryLength": 488},
        "3438": {"vr": "OB", "BinaryLength": 488},
        "3439": {"vr": "OB", "BinaryLength": 488},
        "3440": {"vr": "OB", "BinaryLength": 488},
        "3441": {"vr": "OB", "BinaryLength": 488},
        "3442": {"vr": "OB", "BinaryLength": 488},
        "3443": {"vr": "OB", "BinaryLength": 488},
        "3444": {"vr": "OB", "BinaryLength": 488},
        "3445": {"vr": "OB", "BinaryLength": 488},
        "3446": {"vr": "OB", "BinaryLength": 124},
        "3447": {"vr": "OB", "BinaryLength": 488},
        "3448": {"vr": "OB", "BinaryLength": 488},
        "3449": {"vr": "OB", "BinaryLength": 488},
        "3450": {"vr": "OB", "BinaryLength": 488},
        "3451": {"vr": "OB", "BinaryLength": 488},
        "3452": {"vr": "OB", "BinaryLength": 488},
        "3453": {"vr": "OB", "BinaryLength": 488},
        "3454": {"vr": "OB", "BinaryLength": 124},
        "3455": {"vr": "OB", "BinaryLength": 488},
        "3456": {"vr": "OB", "BinaryLength": 488},
        "3457": {"vr": "OB", "BinaryLength": 488},
        "3458": {"vr": "OB", "BinaryLength": 488},
        "3459": {"vr": "OB", "BinaryLength": 488},
        "3460": {"vr": "OB", "BinaryLength": 488},
        "3461": {"vr": "OB", "BinaryLength": 488},
        "3462": {"vr": "OB", "BinaryLength": 488},
        "3463": {"vr": "OB", "BinaryLength": 488},
        "3464": {"vr": "OB", "BinaryLength": 488},
        "3465": {"vr": "OB", "BinaryLength": 488},
        "3466": {"vr": "OB", "BinaryLength": 488},
        "3467": {"vr": "OB", "BinaryLength": 488},
        "3468": {"vr": "OB", "BinaryLength": 488},
        "3469": {"vr": "OB", "BinaryLength": 488},
        "3470": {"vr": "OB", "BinaryLength": 488},
        "3471": {"vr": "OB", "BinaryLength": 488},
        "3472": {"vr": "OB", "BinaryLength": 488},
        "3473": {"vr": "OB", "BinaryLength": 488},
        "3474": {"vr": "OB", "BinaryLength": 124},
        "3475": {"vr": "OB", "BinaryLength": 488},
        "3476": {"vr": "OB", "BinaryLength": 488},
        "3477": {"vr": "OB", "BinaryLength": 488},
        "3478": {"vr": "OB", "BinaryLength": 488},
        "3479": {"vr": "OB", "BinaryLength": 488},
        "3480": {"vr": "OB", "BinaryLength": 488},
        "3481": {"vr": "OB", "BinaryLength": 124},
        "3482": {"vr": "OB", "BinaryLength": 488},
        "3483": {"vr": "OB", "BinaryLength": 488},
        "3484": {"vr": "OB", "BinaryLength": 488},
        "3485": {"vr": "OB", "BinaryLength": 488},
        "3486": {"vr": "OB", "BinaryLength": 488},
        "3487": {"vr": "OB", "BinaryLength": 488},
        "3488": {"vr": "OB", "BinaryLength": 488},
        "3489": {"vr": "OB", "BinaryLength": 488},
        "3490": {"vr": "OB", "BinaryLength": 488},
        "3491": {"vr": "OB", "BinaryLength": 488},
        "3492": {"vr": "OB", "BinaryLength": 124},
        "3493": {"vr": "OB", "BinaryLength": 488},
        "3494": {"vr": "OB", "BinaryLength": 488},
        "3495": {"vr": "OB", "BinaryLength": 488},
        "3496": {"vr": "OB", "BinaryLength": 488},
        "3497": {"vr": "OB", "BinaryLength": 488},
        "3498": {"vr": "OB", "BinaryLength": 124},
        "3499": {"vr": "OB", "BinaryLength": 488},
        "3500": {"vr": "OB", "BinaryLength": 488},
        "3501": {"vr": "OB", "BinaryLength": 124},
        "3502": {"vr": "OB", "BinaryLength": 488},
        "3503": {"vr": "OB", "BinaryLength": 124},
        "3504": {"vr": "OB", "BinaryLength": 488},
        "3505": {"vr": "OB", "BinaryLength": 488},
        "3506": {"vr": "OB", "BinaryLength": 488},
        "3507": {"vr": "OB", "BinaryLength": 488},
        "3508": {"vr": "OB", "BinaryLength": 488},
        "3509": {"vr": "OB", "BinaryLength": 488},
        "3510": {"vr": "OB", "BinaryLength": 488},
        "3511": {"vr": "OB", "BinaryLength": 124},
        "3512": {"vr": "OB", "BinaryLength": 488},
        "3513": {"vr": "OB", "BinaryLength": 488},
        "3514": {"vr": "OB", "BinaryLength": 488},
        "3515": {"vr": "OB", "BinaryLength": 488},
        "3516": {"vr": "OB", "BinaryLength": 488},
        "3517": {"vr": "OB", "BinaryLength": 488},
        "3518": {"vr": "OB", "BinaryLength": 488},
        "3519": {"vr": "OB", "BinaryLength": 488},
        "3520": {"vr": "OB", "BinaryLength": 488},
        "3521": {"vr": "OB", "BinaryLength": 124},
        "3522": {"vr": "OB", "BinaryLength": 124},
        "3523": {"vr": "OB", "BinaryLength": 488},
        "3524": {"vr": "OB", "BinaryLength": 488},
        "3525": {"vr": "OB", "BinaryLength": 488},
        "3526": {"vr": "OB", "BinaryLength": 488},
        "3527": {"vr": "OB", "BinaryLength": 488},
        "3528": {"vr": "OB", "BinaryLength": 488},
        "3529": {"vr": "OB", "BinaryLength": 124},
        "3530": {"vr": "OB", "BinaryLength": 488},
        "3531": {"vr": "OB", "BinaryLength": 488},
        "3532": {"vr": "OB", "BinaryLength": 124},
        "3533": {"vr": "OB", "BinaryLength": 488},
        "3534": {"vr": "OB", "BinaryLength": 488},
        "3535": {"vr": "OB", "BinaryLength": 488},
        "3536": {"vr": "OB", "BinaryLength": 488},
        "3537": {"vr": "OB", "BinaryLength": 488},
        "3538": {"vr": "OB", "BinaryLength": 488},
        "3539": {"vr": "OB", "BinaryLength": 124},
        "3540": {"vr": "OB", "BinaryLength": 488},
        "3541": {"vr": "OB", "BinaryLength": 488},
        "3542": {"vr": "OB", "BinaryLength": 488},
        "3543": {"vr": "OB", "BinaryLength": 488},
        "3544": {"vr": "OB", "BinaryLength": 488},
        "3545": {"vr": "OB", "BinaryLength": 488},
        "3546": {"vr": "OB", "BinaryLength": 488},
        "3547": {"vr": "OB", "BinaryLength": 488},
        "3548": {"vr": "OB", "BinaryLength": 488},
        "3549": {"vr": "OB", "BinaryLength": 488},
        "3550": {"vr": "OB", "BinaryLength": 488},
        "3551": {"vr": "OB", "BinaryLength": 488},
        "3552": {"vr": "OB", "BinaryLength": 488},
        "3553": {"vr": "OB", "BinaryLength": 488},
        "3554": {"vr": "OB", "BinaryLength": 488},
        "3555": {"vr": "OB", "BinaryLength": 488},
        "3556": {"vr": "OB", "BinaryLength": 488},
        "3557": {"vr": "OB", "BinaryLength": 488},
        "3558": {"vr": "OB", "BinaryLength": 488},
        "3559": {"vr": "OB", "BinaryLength": 488},
        "3560": {"vr": "OB", "BinaryLength": 488},
        "3561": {"vr": "OB", "BinaryLength": 488},
        "3562": {"vr": "OB", "BinaryLength": 488},
        "3563": {"vr": "OB", "BinaryLength": 488},
        "3564": {"vr": "OB", "BinaryLength": 488},
        "3565": {"vr": "OB", "BinaryLength": 488},
        "3566": {"vr": "OB", "BinaryLength": 488},
        "3567": {"vr": "OB", "BinaryLength": 488},
        "3568": {"vr": "OB", "BinaryLength": 488},
        "3569": {"vr": "OB", "BinaryLength": 488},
        "3570": {"vr": "OB", "BinaryLength": 488},
        "3571": {"vr": "OB", "BinaryLength": 488},
        "3572": {"vr": "OB", "BinaryLength": 488},
        "3573": {"vr": "OB", "BinaryLength": 488},
        "3574": {"vr": "OB", "BinaryLength": 488},
        "3575": {"vr": "OB", "BinaryLength": 124},
        "3576": {"vr": "OB", "BinaryLength": 488},
        "3577": {"vr": "OB", "BinaryLength": 488},
        "3578": {"vr": "OB", "BinaryLength": 488},
        "3579": {"vr": "OB", "BinaryLength": 488},
        "3580": {"vr": "OB", "BinaryLength": 488},
        "3581": {"vr": "OB", "BinaryLength": 488},
        "3582": {"vr": "OB", "BinaryLength": 488},
        "3583": {"vr": "OB", "BinaryLength": 488},
        "3584": {"vr": "OB", "BinaryLength": 488},
        "3585": {"vr": "OB", "BinaryLength": 488},
        "3586": {"vr": "OB", "BinaryLength": 488},
        "3587": {"vr": "OB", "BinaryLength": 488},
        "3588": {"vr": "OB", "BinaryLength": 488},
        "3589": {"vr": "OB", "BinaryLength": 124},
        "3590": {"vr": "OB", "BinaryLength": 488},
        "3591": {"vr": "OB", "BinaryLength": 488},
        "3592": {"vr": "OB", "BinaryLength": 488},
        "3593": {"vr": "OB", "BinaryLength": 488},
        "3594": {"vr": "OB", "BinaryLength": 488},
        "3595": {"vr": "OB", "BinaryLength": 488},
        "3596": {"vr": "OB", "BinaryLength": 124},
        "3597": {"vr": "OB", "BinaryLength": 488},
        "3598": {"vr": "OB", "BinaryLength": 124},
        "3599": {"vr": "OB", "BinaryLength": 488},
        "3600": {"vr": "OB", "BinaryLength": 488},
        "3601": {"vr": "OB", "BinaryLength": 488},
        "3602": {"vr": "OB", "BinaryLength": 488},
        "3603": {"vr": "OB", "BinaryLength": 488},
        "3604": {"vr": "OB", "BinaryLength": 488},
        "3605": {"vr": "OB", "BinaryLength": 488},
        "3606": {"vr": "OB", "BinaryLength": 488},
        "3607": {"vr": "OB", "BinaryLength": 488},
        "3608": {"vr": "OB", "BinaryLength": 488},
        "3609": {"vr": "OB", "BinaryLength": 488},
        "3610": {"vr": "OB", "BinaryLength": 124},
        "3611": {"vr": "OB", "BinaryLength": 488},
        "3612": {"vr": "OB", "BinaryLength": 488},
        "3613": {"vr": "OB", "BinaryLength": 488},
        "3614": {"vr": "OB", "BinaryLength": 124},
        "3615": {"vr": "OB", "BinaryLength": 488},
        "3616": {"vr": "OB", "BinaryLength": 488},
        "3617": {"vr": "OB", "BinaryLength": 488},
        "3618": {"vr": "OB", "BinaryLength": 488},
        "3619": {"vr": "OB", "BinaryLength": 488},
        "3620": {"vr": "OB", "BinaryLength": 488},
        "3621": {"vr": "OB", "BinaryLength": 488},
        "3622": {"vr": "OB", "BinaryLength": 488},
        "3623": {"vr": "OB", "BinaryLength": 488},
        "3624": {"vr": "OB", "BinaryLength": 488},
        "3625": {"vr": "OB", "BinaryLength": 488},
        "3626": {"vr": "OB", "BinaryLength": 488},
        "3627": {"vr": "OB", "BinaryLength": 488},
        "3628": {"vr": "OB", "BinaryLength": 124},
        "3629": {"vr": "OB", "BinaryLength": 488},
        "3630": {"vr": "OB", "BinaryLength": 488},
        "3631": {"vr": "OB", "BinaryLength": 488},
        "3632": {"vr": "OB", "BinaryLength": 488},
        "3633": {"vr": "OB", "BinaryLength": 488},
        "3634": {"vr": "OB", "BinaryLength": 488},
        "3635": {"vr": "OB", "BinaryLength": 488},
        "3636": {"vr": "OB", "BinaryLength": 488},
        "3637": {"vr": "OB", "BinaryLength": 488},
        "3638": {"vr": "OB", "BinaryLength": 124},
        "3639": {"vr": "OB", "BinaryLength": 488},
        "3640": {"vr": "OB", "BinaryLength": 124},
        "3641": {"vr": "OB", "BinaryLength": 488},
        "3642": {"vr": "OB", "BinaryLength": 488},
        "3643": {"vr": "OB", "BinaryLength": 488},
        "3644": {"vr": "OB", "BinaryLength": 488},
        "3645": {"vr": "OB", "BinaryLength": 488},
        "3646": {"vr": "OB", "BinaryLength": 488},
        "3647": {"vr": "OB", "BinaryLength": 488},
        "3648": {"vr": "OB", "BinaryLength": 488},
        "3649": {"vr": "OB", "BinaryLength": 488},
        "3650": {"vr": "OB", "BinaryLength": 488},
        "3651": {"vr": "OB", "BinaryLength": 488},
        "3652": {"vr": "OB", "BinaryLength": 488},
        "3653": {"vr": "OB", "BinaryLength": 124},
        "3654": {"vr": "OB", "BinaryLength": 124},
        "3655": {"vr": "OB", "BinaryLength": 488},
        "3656": {"vr": "OB", "BinaryLength": 488},
        "3657": {"vr": "OB", "BinaryLength": 488},
        "3658": {"vr": "OB", "BinaryLength": 488},
        "3659": {"vr": "OB", "BinaryLength": 488},
        "3660": {"vr": "OB", "BinaryLength": 488},
        "3661": {"vr": "OB", "BinaryLength": 488},
        "3662": {"vr": "OB", "BinaryLength": 488},
        "3663": {"vr": "OB", "BinaryLength": 488},
        "3664": {"vr": "OB", "BinaryLength": 488},
        "3665": {"vr": "OB", "BinaryLength": 488},
        "3666": {"vr": "OB", "BinaryLength": 488},
        "3667": {"vr": "OB", "BinaryLength": 488},
        "3668": {"vr": "OB", "BinaryLength": 124},
        "3669": {"vr": "OB", "BinaryLength": 488},
        "3670": {"vr": "OB", "BinaryLength": 488},
        "3671": {"vr": "OB", "BinaryLength": 488},
        "3672": {"vr": "OB", "BinaryLength": 488},
        "3673": {"vr": "OB", "BinaryLength": 124},
        "3674": {"vr": "OB", "BinaryLength": 488},
        "3675": {"vr": "OB", "BinaryLength": 488},
        "3676": {"vr": "OB", "BinaryLength": 488},
        "3677": {"vr": "OB", "BinaryLength": 488},
        "3678": {"vr": "OB", "BinaryLength": 488},
        "3679": {"vr": "OB", "BinaryLength": 488},
        "3680": {"vr": "OB", "BinaryLength": 488},
        "3681": {"vr": "OB", "BinaryLength": 488},
        "3682": {"vr": "OB", "BinaryLength": 488},
        "3683": {"vr": "OB", "BinaryLength": 488},
        "3684": {"vr": "OB", "BinaryLength": 488},
        "3685": {"vr": "OB", "BinaryLength": 488},
        "3686": {"vr": "OB", "BinaryLength": 488},
        "3687": {"vr": "OB", "BinaryLength": 124},
        "3688": {"vr": "OB", "BinaryLength": 488},
        "3689": {"vr": "OB", "BinaryLength": 488},
        "3690": {"vr": "OB", "BinaryLength": 488},
        "3691": {"vr": "OB", "BinaryLength": 488},
        "3692": {"vr": "OB", "BinaryLength": 488},
        "3693": {"vr": "OB", "BinaryLength": 488},
        "3694": {"vr": "OB", "BinaryLength": 488},
        "3695": {"vr": "OB", "BinaryLength": 488},
        "3696": {"vr": "OB", "BinaryLength": 124},
        "3697": {"vr": "OB", "BinaryLength": 488},
        "3698": {"vr": "OB", "BinaryLength": 124},
        "3699": {"vr": "OB", "BinaryLength": 488},
        "3700": {"vr": "OB", "BinaryLength": 488},
        "3701": {"vr": "OB", "BinaryLength": 488},
        "3702": {"vr": "OB", "BinaryLength": 488},
        "3703": {"vr": "OB", "BinaryLength": 488},
        "3704": {"vr": "OB", "BinaryLength": 488},
        "3705": {"vr": "OB", "BinaryLength": 488},
        "3706": {"vr": "OB", "BinaryLength": 488},
        "3707": {"vr": "OB", "BinaryLength": 488},
        "3708": {"vr": "OB", "BinaryLength": 488},
        "3709": {"vr": "OB", "BinaryLength": 488},
        "3710": {"vr": "OB", "BinaryLength": 488},
        "3711": {"vr": "OB", "BinaryLength": 488},
        "3712": {"vr": "OB", "BinaryLength": 488},
        "3713": {"vr": "OB", "BinaryLength": 488},
        "3714": {"vr": "OB", "BinaryLength": 488},
        "3715": {"vr": "OB", "BinaryLength": 488},
        "3716": {"vr": "OB", "BinaryLength": 124},
        "3717": {"vr": "OB", "BinaryLength": 488},
        "3718": {"vr": "OB", "BinaryLength": 488},
        "3719": {"vr": "OB", "BinaryLength": 488},
        "3720": {"vr": "OB", "BinaryLength": 488},
        "3721": {"vr": "OB", "BinaryLength": 488},
        "3722": {"vr": "OB", "BinaryLength": 488},
        "3723": {"vr": "OB", "BinaryLength": 124},
        "3724": {"vr": "OB", "BinaryLength": 488},
        "3725": {"vr": "OB", "BinaryLength": 488},
        "3726": {"vr": "OB", "BinaryLength": 488},
        "3727": {"vr": "OB", "BinaryLength": 488},
        "3728": {"vr": "OB", "BinaryLength": 488},
        "3729": {"vr": "OB", "BinaryLength": 124},
        "3730": {"vr": "OB", "BinaryLength": 488},
        "3731": {"vr": "OB", "BinaryLength": 488},
        "3732": {"vr": "OB", "BinaryLength": 488},
        "3733": {"vr": "OB", "BinaryLength": 488},
        "3734": {"vr": "OB", "BinaryLength": 488},
        "3735": {"vr": "OB", "BinaryLength": 124},
        "3736": {"vr": "OB", "BinaryLength": 488},
        "3737": {"vr": "OB", "BinaryLength": 488},
        "3738": {"vr": "OB", "BinaryLength": 488},
        "3739": {"vr": "OB", "BinaryLength": 488},
        "3740": {"vr": "OB", "BinaryLength": 488},
        "3741": {"vr": "OB", "BinaryLength": 488},
        "3742": {"vr": "OB", "BinaryLength": 124},
        "3743": {"vr": "OB", "BinaryLength": 488},
        "3744": {"vr": "OB", "BinaryLength": 124},
        "3745": {"vr": "OB", "BinaryLength": 488},
        "3746": {"vr": "OB", "BinaryLength": 488},
        "3747": {"vr": "OB", "BinaryLength": 488},
        "3748": {"vr": "OB", "BinaryLength": 488},
        "3749": {"vr": "OB", "BinaryLength": 488},
        "3750": {"vr": "OB", "BinaryLength": 488},
        "3751": {"vr": "OB", "BinaryLength": 488},
        "3752": {"vr": "OB", "BinaryLength": 488},
        "3753": {"vr": "OB", "BinaryLength": 488},
        "3754": {"vr": "OB", "BinaryLength": 488},
        "3755": {"vr": "OB", "BinaryLength": 488},
        "3756": {"vr": "OB", "BinaryLength": 124},
        "3757": {"vr": "OB", "BinaryLength": 488},
        "3758": {"vr": "OB", "BinaryLength": 488},
        "3759": {"vr": "OB", "BinaryLength": 488},
        "3760": {"vr": "OB", "BinaryLength": 488},
        "3761": {"vr": "OB", "BinaryLength": 488},
        "3762": {"vr": "OB", "BinaryLength": 488},
        "3763": {"vr": "OB", "BinaryLength": 124},
        "3764": {"vr": "OB", "BinaryLength": 488},
        "3765": {"vr": "OB", "BinaryLength": 488},
        "3766": {"vr": "OB", "BinaryLength": 488},
        "3767": {"vr": "OB", "BinaryLength": 488},
        "3768": {"vr": "OB", "BinaryLength": 488},
        "3769": {"vr": "OB", "BinaryLength": 488},
        "3770": {"vr": "OB", "BinaryLength": 488},
        "3771": {"vr": "OB", "BinaryLength": 488},
        "3772": {"vr": "OB", "BinaryLength": 488},
        "3773": {"vr": "OB", "BinaryLength": 488},
        "3774": {"vr": "OB", "BinaryLength": 488},
        "3775": {"vr": "OB", "BinaryLength": 488},
        "3776": {"vr": "OB", "BinaryLength": 488},
        "3777": {"vr": "OB", "BinaryLength": 488},
        "3778": {"vr": "OB", "BinaryLength": 488},
        "3779": {"vr": "OB", "BinaryLength": 488},
        "3780": {"vr": "OB", "BinaryLength": 488},
        "3781": {"vr": "OB", "BinaryLength": 488},
        "3782": {"vr": "OB", "BinaryLength": 488},
        "3783": {"vr": "OB", "BinaryLength": 488},
        "3784": {"vr": "OB", "BinaryLength": 488},
        "3785": {"vr": "OB", "BinaryLength": 488},
        "3786": {"vr": "OB", "BinaryLength": 488},
        "3787": {"vr": "OB", "BinaryLength": 488},
        "3788": {"vr": "OB", "BinaryLength": 124},
        "3789": {"vr": "OB", "BinaryLength": 488},
        "3790": {"vr": "OB", "BinaryLength": 488},
        "3791": {"vr": "OB", "BinaryLength": 488},
        "3792": {"vr": "OB", "BinaryLength": 488},
        "3793": {"vr": "OB", "BinaryLength": 488},
        "3794": {"vr": "OB", "BinaryLength": 488},
        "3795": {"vr": "OB", "BinaryLength": 124},
        "3796": {"vr": "OB", "BinaryLength": 488},
        "3797": {"vr": "OB", "BinaryLength": 488},
        "3798": {"vr": "OB", "BinaryLength": 488},
        "3799": {"vr": "OB", "BinaryLength": 488},
        "3800": {"vr": "OB", "BinaryLength": 488},
        "3801": {"vr": "OB", "BinaryLength": 488},
        "3802": {"vr": "OB", "BinaryLength": 488},
        "3803": {"vr": "OB", "BinaryLength": 488},
        "3804": {"vr": "OB", "BinaryLength": 488},
        "3805": {"vr": "OB", "BinaryLength": 124},
        "3806": {"vr": "OB", "BinaryLength": 124},
        "3807": {"vr": "OB", "BinaryLength": 488},
        "3808": {"vr": "OB", "BinaryLength": 488},
        "3809": {"vr": "OB", "BinaryLength": 488},
        "3810": {"vr": "OB", "BinaryLength": 488},
        "3811": {"vr": "OB", "BinaryLength": 488},
        "3812": {"vr": "OB", "BinaryLength": 488},
        "3813": {"vr": "OB", "BinaryLength": 488},
        "3814": {"vr": "OB", "BinaryLength": 488},
        "3815": {"vr": "OB", "BinaryLength": 488},
        "3816": {"vr": "OB", "BinaryLength": 488},
        "3817": {"vr": "OB", "BinaryLength": 488},
        "3818": {"vr": "OB", "BinaryLength": 488},
        "3819": {"vr": "OB", "BinaryLength": 488},
        "3820": {"vr": "OB", "BinaryLength": 488},
        "3821": {"vr": "OB", "BinaryLength": 488},
        "3822": {"vr": "OB", "BinaryLength": 488},
        "3823": {"vr": "OB", "BinaryLength": 488},
        "3824": {"vr": "OB", "BinaryLength": 488},
        "3825": {"vr": "OB", "BinaryLength": 124},
        "3826": {"vr": "OB", "BinaryLength": 488},
        "3827": {"vr": "OB", "BinaryLength": 488},
        "3828": {"vr": "OB", "BinaryLength": 488},
        "3829": {"vr": "OB", "BinaryLength": 488},
        "3830": {"vr": "OB", "BinaryLength": 488},
        "3831": {"vr": "OB", "BinaryLength": 488},
        "3832": {"vr": "OB", "BinaryLength": 124},
        "3833": {"vr": "OB", "BinaryLength": 488},
        "3834": {"vr": "OB", "BinaryLength": 488},
        "3835": {"vr": "OB", "BinaryLength": 488},
        "3836": {"vr": "OB", "BinaryLength": 488},
        "3837": {"vr": "OB", "BinaryLength": 488},
        "3838": {"vr": "OB", "BinaryLength": 488},
        "3839": {"vr": "OB", "BinaryLength": 488},
        "3840": {"vr": "OB", "BinaryLength": 488},
        "3841": {"vr": "OB", "BinaryLength": 488},
        "3842": {"vr": "OB", "BinaryLength": 488},
        "3843": {"vr": "OB", "BinaryLength": 488},
        "3844": {"vr": "OB", "BinaryLength": 488},
        "3845": {"vr": "OB", "BinaryLength": 124},
        "3846": {"vr": "OB", "BinaryLength": 488},
        "3847": {"vr": "OB", "BinaryLength": 488},
        "3848": {"vr": "OB", "BinaryLength": 488},
        "3849": {"vr": "OB", "BinaryLength": 488},
        "3850": {"vr": "OB", "BinaryLength": 488},
        "3851": {"vr": "OB", "BinaryLength": 488},
        "3852": {"vr": "OB", "BinaryLength": 488},
        "3853": {"vr": "OB", "BinaryLength": 488},
        "3854": {"vr": "OB", "BinaryLength": 488},
        "3855": {"vr": "OB", "BinaryLength": 124},
        "3856": {"vr": "OB", "BinaryLength": 488},
        "3857": {"vr": "OB", "BinaryLength": 488},
        "3858": {"vr": "OB", "BinaryLength": 488},
        "3859": {"vr": "OB", "BinaryLength": 488},
        "3860": {"vr": "OB", "BinaryLength": 488},
        "3861": {"vr": "OB", "BinaryLength": 488},
        "3862": {"vr": "OB", "BinaryLength": 488},
        "3863": {"vr": "OB", "BinaryLength": 124},
        "3864": {"vr": "OB", "BinaryLength": 488},
        "3865": {"vr": "OB", "BinaryLength": 488},
        "3866": {"vr": "OB", "BinaryLength": 488},
        "3867": {"vr": "OB", "BinaryLength": 488},
        "3868": {"vr": "OB", "BinaryLength": 488},
        "3869": {"vr": "OB", "BinaryLength": 488},
        "3870": {"vr": "OB", "BinaryLength": 488},
        "3871": {"vr": "OB", "BinaryLength": 488},
        "3872": {"vr": "OB", "BinaryLength": 488},
        "3873": {"vr": "OB", "BinaryLength": 488},
        "3874": {"vr": "OB", "BinaryLength": 488},
        "3875": {"vr": "OB", "BinaryLength": 488},
        "3876": {"vr": "OB", "BinaryLength": 488},
        "3877": {"vr": "OB", "BinaryLength": 488},
        "3878": {"vr": "OB", "BinaryLength": 124},
        "3879": {"vr": "OB", "BinaryLength": 488},
        "3880": {"vr": "OB", "BinaryLength": 488},
        "3881": {"vr": "OB", "BinaryLength": 488},
        "3882": {"vr": "OB", "BinaryLength": 124},
        "3883": {"vr": "OB", "BinaryLength": 488},
        "3884": {"vr": "OB", "BinaryLength": 488},
        "3885": {"vr": "OB", "BinaryLength": 124},
        "3886": {"vr": "OB", "BinaryLength": 488},
        "3887": {"vr": "OB", "BinaryLength": 488},
        "3888": {"vr": "OB", "BinaryLength": 488},
        "3889": {"vr": "OB", "BinaryLength": 488},
        "3890": {"vr": "OB", "BinaryLength": 488},
        "3891": {"vr": "OB", "BinaryLength": 488},
        "3892": {"vr": "OB", "BinaryLength": 488},
        "3893": {"vr": "OB", "BinaryLength": 488},
        "3894": {"vr": "OB", "BinaryLength": 488},
        "3895": {"vr": "OB", "BinaryLength": 488},
        "3896": {"vr": "OB", "BinaryLength": 488},
        "3897": {"vr": "OB", "BinaryLength": 488},
        "3898": {"vr": "OB", "BinaryLength": 488},
        "3899": {"vr": "OB", "BinaryLength": 488},
        "3900": {"vr": "OB", "BinaryLength": 124},
        "3901": {"vr": "OB", "BinaryLength": 488},
        "3902": {"vr": "OB", "BinaryLength": 488},
        "3903": {"vr": "OB", "BinaryLength": 488},
        "3904": {"vr": "OB", "BinaryLength": 488},
        "3905": {"vr": "OB", "BinaryLength": 488},
        "3906": {"vr": "OB", "BinaryLength": 488},
        "3907": {"vr": "OB", "BinaryLength": 488},
        "3908": {"vr": "OB", "BinaryLength": 488},
        "3909": {"vr": "OB", "BinaryLength": 488},
        "3910": {"vr": "OB", "BinaryLength": 488},
        "3911": {"vr": "OB", "BinaryLength": 488},
        "3912": {"vr": "OB", "BinaryLength": 488},
        "3913": {"vr": "OB", "BinaryLength": 488},
        "3914": {"vr": "OB", "BinaryLength": 488},
        "3915": {"vr": "OB", "BinaryLength": 488},
        "3916": {"vr": "OB", "BinaryLength": 124},
        "3917": {"vr": "OB", "BinaryLength": 488},
        "3918": {"vr": "OB", "BinaryLength": 488},
        "3919": {"vr": "OB", "BinaryLength": 488},
        "3920": {"vr": "OB", "BinaryLength": 488},
        "3921": {"vr": "OB", "BinaryLength": 488},
        "3922": {"vr": "OB", "BinaryLength": 488},
        "3923": {"vr": "OB", "BinaryLength": 488},
        "3924": {"vr": "OB", "BinaryLength": 488},
        "3925": {"vr": "OB", "BinaryLength": 488},
        "3926": {"vr": "OB", "BinaryLength": 488},
        "3927": {"vr": "OB", "BinaryLength": 488},
        "3928": {"vr": "OB", "BinaryLength": 124},
        "3929": {"vr": "OB", "BinaryLength": 488},
        "3930": {"vr": "OB", "BinaryLength": 488},
        "3931": {"vr": "OB", "BinaryLength": 488},
        "3932": {"vr": "OB", "BinaryLength": 488},
        "3933": {"vr": "OB", "BinaryLength": 488},
        "3934": {"vr": "OB", "BinaryLength": 488},
        "3935": {"vr": "OB", "BinaryLength": 488},
        "3936": {"vr": "OB", "BinaryLength": 488},
        "3937": {"vr": "OB", "BinaryLength": 124},
        "3938": {"vr": "OB", "BinaryLength": 488},
        "3939": {"vr": "OB", "BinaryLength": 488},
        "3940": {"vr": "OB", "BinaryLength": 488},
        "3941": {"vr": "OB", "BinaryLength": 488},
        "3942": {"vr": "OB", "BinaryLength": 488},
        "3943": {"vr": "OB", "BinaryLength": 488},
        "3944": {"vr": "OB", "BinaryLength": 488},
        "3945": {"vr": "OB", "BinaryLength": 124},
        "3946": {"vr": "OB", "BinaryLength": 488},
        "3947": {"vr": "OB", "BinaryLength": 488},
        "3948": {"vr": "OB", "BinaryLength": 488},
        "3949": {"vr": "OB", "BinaryLength": 488},
        "3950": {"vr": "OB", "BinaryLength": 488},
        "3951": {"vr": "OB", "BinaryLength": 488},
        "3952": {"vr": "OB", "BinaryLength": 488},
        "3953": {"vr": "OB", "BinaryLength": 488},
        "3954": {"vr": "OB", "BinaryLength": 488},
        "3955": {"vr": "OB", "BinaryLength": 488},
        "3956": {"vr": "OB", "BinaryLength": 488},
        "3957": {"vr": "OB", "BinaryLength": 488},
        "3958": {"vr": "OB", "BinaryLength": 488},
        "3959": {"vr": "OB", "BinaryLength": 488},
        "3960": {"vr": "OB", "BinaryLength": 488},
        "3961": {"vr": "OB", "BinaryLength": 488},
        "3962": {"vr": "OB", "BinaryLength": 488},
        "3963": {"vr": "OB", "BinaryLength": 488},
        "3964": {"vr": "OB", "BinaryLength": 488},
        "3965": {"vr": "OB", "BinaryLength": 488},
        "3966": {"vr": "OB", "BinaryLength": 488},
        "3967": {"vr": "OB", "BinaryLength": 488},
        "3968": {"vr": "OB", "BinaryLength": 124},
        "3969": {"vr": "OB", "BinaryLength": 488},
        "3970": {"vr": "OB", "BinaryLength": 488},
        "3971": {"vr": "OB", "BinaryLength": 488},
        "3972": {"vr": "OB", "BinaryLength": 488},
        "3973": {"vr": "OB", "BinaryLength": 488},
        "3974": {"vr": "OB", "BinaryLength": 488},
        "3975": {"vr": "OB", "BinaryLength": 488},
        "3976": {"vr": "OB", "BinaryLength": 488},
        "3977": {"vr": "OB", "BinaryLength": 488},
        "3978": {"vr": "OB", "BinaryLength": 488},
        "3979": {"vr": "OB", "BinaryLength": 488},
        "3980": {"vr": "OB", "BinaryLength": 488},
        "3981": {"vr": "OB", "BinaryLength": 488},
        "3982": {"vr": "OB", "BinaryLength": 488},
        "3983": {"vr": "OB", "BinaryLength": 488},
        "3984": {"vr": "OB", "BinaryLength": 488},
        "3985": {"vr": "OB", "BinaryLength": 488},
        "3986": {"vr": "OB", "BinaryLength": 488},
        "3987": {"vr": "OB", "BinaryLength": 488},
        "3988": {"vr": "OB", "BinaryLength": 488},
        "3989": {"vr": "OB", "BinaryLength": 488},
        "3990": {"vr": "OB", "BinaryLength": 488},
        "3991": {"vr": "OB", "BinaryLength": 488},
        "3992": {"vr": "OB", "BinaryLength": 488},
        "3993": {"vr": "OB", "BinaryLength": 488},
        "3994": {"vr": "OB", "BinaryLength": 488},
        "3995": {"vr": "OB", "BinaryLength": 488},
        "3996": {"vr": "OB", "BinaryLength": 488},
        "3997": {"vr": "OB", "BinaryLength": 488},
        "3998": {"vr": "OB", "BinaryLength": 488},
        "3999": {"vr": "OB", "BinaryLength": 488},
        "4000": {"vr": "OB", "BinaryLength": 488},
        "4001": {"vr": "OB", "BinaryLength": 488},
        "4002": {"vr": "OB", "BinaryLength": 488},
        "4003": {"vr": "OB", "BinaryLength": 488},
        "4004": {"vr": "OB", "BinaryLength": 488},
        "4005": {"vr": "OB", "BinaryLength": 488},
        "4006": {"vr": "OB", "BinaryLength": 488},
        "4007": {"vr": "OB", "BinaryLength": 488},
        "4008": {"vr": "OB", "BinaryLength": 488},
        "4009": {"vr": "OB", "BinaryLength": 124},
        "4010": {"vr": "OB", "BinaryLength": 488},
        "4011": {"vr": "OB", "BinaryLength": 124},
        "4012": {"vr": "OB", "BinaryLength": 488},
        "4013": {"vr": "OB", "BinaryLength": 488},
        "4014": {"vr": "OB", "BinaryLength": 488},
        "4015": {"vr": "OB", "BinaryLength": 488},
        "4016": {"vr": "OB", "BinaryLength": 488},
        "4017": {"vr": "OB", "BinaryLength": 488},
        "4018": {"vr": "OB", "BinaryLength": 488},
        "4019": {"vr": "OB", "BinaryLength": 488},
    },
    "00291010": {
        "0": {"vr": "OB", "BinaryLength": 16428},
        "1": {"vr": "OB", "BinaryLength": 16424},
        "2": {"vr": "OB", "BinaryLength": 16416},
        "3": {"vr": "OB", "BinaryLength": 15628},
        "4": {"vr": "OB", "BinaryLength": 16424},
        "5": {"vr": "OB", "BinaryLength": 16428},
        "6": {"vr": "OB", "BinaryLength": 16416},
        "7": {"vr": "OB", "BinaryLength": 16424},
        "8": {"vr": "OB", "BinaryLength": 16428},
        "9": {"vr": "OB", "BinaryLength": 16412},
        "10": {"vr": "OB", "BinaryLength": 16428},
        "11": {"vr": "OB", "BinaryLength": 16424},
        "12": {"vr": "OB", "BinaryLength": 16428},
        "13": {"vr": "OB", "BinaryLength": 15616},
        "14": {"vr": "OB", "BinaryLength": 15624},
        "15": {"vr": "OB", "BinaryLength": 16428},
        "16": {"vr": "OB", "BinaryLength": 16424},
        "17": {"vr": "OB", "BinaryLength": 16424},
        "18": {"vr": "OB", "BinaryLength": 16428},
        "19": {"vr": "OB", "BinaryLength": 16424},
        "20": {"vr": "OB", "BinaryLength": 16428},
        "21": {"vr": "OB", "BinaryLength": 16432},
        "22": {"vr": "OB", "BinaryLength": 16428},
        "23": {"vr": "OB", "BinaryLength": 16428},
        "24": {"vr": "OB", "BinaryLength": 16428},
        "25": {"vr": "OB", "BinaryLength": 16424},
        "26": {"vr": "OB", "BinaryLength": 16428},
        "27": {"vr": "OB", "BinaryLength": 16432},
        "28": {"vr": "OB", "BinaryLength": 16428},
        "29": {"vr": "OB", "BinaryLength": 16432},
        "30": {"vr": "OB", "BinaryLength": 16428},
        "31": {"vr": "OB", "BinaryLength": 15624},
        "32": {"vr": "OB", "BinaryLength": 16424},
        "33": {"vr": "OB", "BinaryLength": 16428},
        "34": {"vr": "OB", "BinaryLength": 15624},
        "35": {"vr": "OB", "BinaryLength": 15616},
        "36": {"vr": "OB", "BinaryLength": 16424},
        "37": {"vr": "OB", "BinaryLength": 16424},
        "38": {"vr": "OB", "BinaryLength": 16428},
        "39": {"vr": "OB", "BinaryLength": 16428},
        "40": {"vr": "OB", "BinaryLength": 15624},
        "41": {"vr": "OB", "BinaryLength": 16432},
        "42": {"vr": "OB", "BinaryLength": 16428},
        "43": {"vr": "OB", "BinaryLength": 16428},
        "44": {"vr": "OB", "BinaryLength": 16428},
        "45": {"vr": "OB", "BinaryLength": 16424},
        "46": {"vr": "OB", "BinaryLength": 16428},
        "47": {"vr": "OB", "BinaryLength": 16428},
        "48": {"vr": "OB", "BinaryLength": 16424},
        "49": {"vr": "OB", "BinaryLength": 16400},
        "50": {"vr": "OB", "BinaryLength": 16428},
        "51": {"vr": "OB", "BinaryLength": 16424},
        "52": {"vr": "OB", "BinaryLength": 16424},
        "53": {"vr": "OB", "BinaryLength": 16432},
        "54": {"vr": "OB", "BinaryLength": 16408},
        "55": {"vr": "OB", "BinaryLength": 16428},
        "56": {"vr": "OB", "BinaryLength": 16428},
        "57": {"vr": "OB", "BinaryLength": 16424},
        "58": {"vr": "OB", "BinaryLength": 16432},
        "59": {"vr": "OB", "BinaryLength": 16424},
        "60": {"vr": "OB", "BinaryLength": 15624},
        "61": {"vr": "OB", "BinaryLength": 15624},
        "62": {"vr": "OB", "BinaryLength": 16428},
        "63": {"vr": "OB", "BinaryLength": 16428},
        "64": {"vr": "OB", "BinaryLength": 16416},
        "65": {"vr": "OB", "BinaryLength": 16412},
        "66": {"vr": "OB", "BinaryLength": 16432},
        "67": {"vr": "OB", "BinaryLength": 16424},
        "68": {"vr": "OB", "BinaryLength": 15624},
        "69": {"vr": "OB", "BinaryLength": 16428},
        "70": {"vr": "OB", "BinaryLength": 16408},
        "71": {"vr": "OB", "BinaryLength": 16428},
        "72": {"vr": "OB", "BinaryLength": 16428},
        "73": {"vr": "OB", "BinaryLength": 16432},
        "74": {"vr": "OB", "BinaryLength": 16424},
        "75": {"vr": "OB", "BinaryLength": 16432},
        "76": {"vr": "OB", "BinaryLength": 16428},
        "77": {"vr": "OB", "BinaryLength": 16428},
        "78": {"vr": "OB", "BinaryLength": 16428},
        "79": {"vr": "OB", "BinaryLength": 16428},
        "80": {"vr": "OB", "BinaryLength": 15624},
        "81": {"vr": "OB", "BinaryLength": 16424},
        "82": {"vr": "OB", "BinaryLength": 16428},
        "83": {"vr": "OB", "BinaryLength": 16424},
        "84": {"vr": "OB", "BinaryLength": 16396},
        "85": {"vr": "OB", "BinaryLength": 16428},
        "86": {"vr": "OB", "BinaryLength": 16424},
        "87": {"vr": "OB", "BinaryLength": 16428},
        "88": {"vr": "OB", "BinaryLength": 16424},
        "89": {"vr": "OB", "BinaryLength": 16428},
        "90": {"vr": "OB", "BinaryLength": 15616},
        "91": {"vr": "OB", "BinaryLength": 15628},
        "92": {"vr": "OB", "BinaryLength": 16428},
        "93": {"vr": "OB", "BinaryLength": 16412},
        "94": {"vr": "OB", "BinaryLength": 16432},
        "95": {"vr": "OB", "BinaryLength": 16428},
        "96": {"vr": "OB", "BinaryLength": 16424},
        "97": {"vr": "OB", "BinaryLength": 16416},
        "98": {"vr": "OB", "BinaryLength": 16396},
        "99": {"vr": "OB", "BinaryLength": 16396},
        "100": {"vr": "OB", "BinaryLength": 16424},
        "101": {"vr": "OB", "BinaryLength": 16428},
        "102": {"vr": "OB", "BinaryLength": 16412},
        "103": {"vr": "OB", "BinaryLength": 16424},
        "104": {"vr": "OB", "BinaryLength": 16428},
        "105": {"vr": "OB", "BinaryLength": 16428},
        "106": {"vr": "OB", "BinaryLength": 16428},
        "107": {"vr": "OB", "BinaryLength": 16416},
        "108": {"vr": "OB", "BinaryLength": 16428},
        "109": {"vr": "OB", "BinaryLength": 16432},
        "110": {"vr": "OB", "BinaryLength": 16428},
        "111": {"vr": "OB", "BinaryLength": 16428},
        "112": {"vr": "OB", "BinaryLength": 15628},
        "113": {"vr": "OB", "BinaryLength": 16428},
        "114": {"vr": "OB", "BinaryLength": 15624},
        "115": {"vr": "OB", "BinaryLength": 16428},
        "116": {"vr": "OB", "BinaryLength": 16416},
        "117": {"vr": "OB", "BinaryLength": 16424},
        "118": {"vr": "OB", "BinaryLength": 16428},
        "119": {"vr": "OB", "BinaryLength": 16412},
        "120": {"vr": "OB", "BinaryLength": 16424},
        "121": {"vr": "OB", "BinaryLength": 16400},
        "122": {"vr": "OB", "BinaryLength": 16424},
        "123": {"vr": "OB", "BinaryLength": 16396},
        "124": {"vr": "OB", "BinaryLength": 16428},
        "125": {"vr": "OB", "BinaryLength": 16432},
        "126": {"vr": "OB", "BinaryLength": 16428},
        "127": {"vr": "OB", "BinaryLength": 16428},
        "128": {"vr": "OB", "BinaryLength": 15628},
        "129": {"vr": "OB", "BinaryLength": 16424},
        "130": {"vr": "OB", "BinaryLength": 16424},
        "131": {"vr": "OB", "BinaryLength": 16428},
        "132": {"vr": "OB", "BinaryLength": 16432},
        "133": {"vr": "OB", "BinaryLength": 16428},
        "134": {"vr": "OB", "BinaryLength": 16428},
        "135": {"vr": "OB", "BinaryLength": 16428},
        "136": {"vr": "OB", "BinaryLength": 16428},
        "137": {"vr": "OB", "BinaryLength": 16428},
        "138": {"vr": "OB", "BinaryLength": 16424},
        "139": {"vr": "OB", "BinaryLength": 16424},
        "140": {"vr": "OB", "BinaryLength": 16424},
        "141": {"vr": "OB", "BinaryLength": 16416},
        "142": {"vr": "OB", "BinaryLength": 16424},
        "143": {"vr": "OB", "BinaryLength": 16424},
        "144": {"vr": "OB", "BinaryLength": 16424},
        "145": {"vr": "OB", "BinaryLength": 16424},
        "146": {"vr": "OB", "BinaryLength": 16424},
        "147": {"vr": "OB", "BinaryLength": 16432},
        "148": {"vr": "OB", "BinaryLength": 16424},
        "149": {"vr": "OB", "BinaryLength": 16424},
        "150": {"vr": "OB", "BinaryLength": 16428},
        "151": {"vr": "OB", "BinaryLength": 16428},
        "152": {"vr": "OB", "BinaryLength": 16428},
        "153": {"vr": "OB", "BinaryLength": 16428},
        "154": {"vr": "OB", "BinaryLength": 16396},
        "155": {"vr": "OB", "BinaryLength": 16424},
        "156": {"vr": "OB", "BinaryLength": 16424},
        "157": {"vr": "OB", "BinaryLength": 16428},
        "158": {"vr": "OB", "BinaryLength": 16424},
        "159": {"vr": "OB", "BinaryLength": 16412},
        "160": {"vr": "OB", "BinaryLength": 15624},
        "161": {"vr": "OB", "BinaryLength": 16428},
        "162": {"vr": "OB", "BinaryLength": 16424},
        "163": {"vr": "OB", "BinaryLength": 16428},
        "164": {"vr": "OB", "BinaryLength": 16412},
        "165": {"vr": "OB", "BinaryLength": 16432},
        "166": {"vr": "OB", "BinaryLength": 16428},
        "167": {"vr": "OB", "BinaryLength": 16424},
        "168": {"vr": "OB", "BinaryLength": 16408},
        "169": {"vr": "OB", "BinaryLength": 16424},
        "170": {"vr": "OB", "BinaryLength": 16412},
        "171": {"vr": "OB", "BinaryLength": 16428},
        "172": {"vr": "OB", "BinaryLength": 16424},
        "173": {"vr": "OB", "BinaryLength": 16428},
        "174": {"vr": "OB", "BinaryLength": 16428},
        "175": {"vr": "OB", "BinaryLength": 16428},
        "176": {"vr": "OB", "BinaryLength": 16400},
        "177": {"vr": "OB", "BinaryLength": 16428},
        "178": {"vr": "OB", "BinaryLength": 16432},
        "179": {"vr": "OB", "BinaryLength": 16424},
        "180": {"vr": "OB", "BinaryLength": 16424},
        "181": {"vr": "OB", "BinaryLength": 16428},
        "182": {"vr": "OB", "BinaryLength": 16428},
        "183": {"vr": "OB", "BinaryLength": 16428},
        "184": {"vr": "OB", "BinaryLength": 16416},
        "185": {"vr": "OB", "BinaryLength": 16428},
        "186": {"vr": "OB", "BinaryLength": 16428},
        "187": {"vr": "OB", "BinaryLength": 16428},
        "188": {"vr": "OB", "BinaryLength": 16428},
        "189": {"vr": "OB", "BinaryLength": 16424},
        "190": {"vr": "OB", "BinaryLength": 16424},
        "191": {"vr": "OB", "BinaryLength": 15616},
        "192": {"vr": "OB", "BinaryLength": 16432},
        "193": {"vr": "OB", "BinaryLength": 16424},
        "194": {"vr": "OB", "BinaryLength": 16432},
        "195": {"vr": "OB", "BinaryLength": 16428},
        "196": {"vr": "OB", "BinaryLength": 16428},
        "197": {"vr": "OB", "BinaryLength": 16424},
        "198": {"vr": "OB", "BinaryLength": 15616},
        "199": {"vr": "OB", "BinaryLength": 16432},
        "200": {"vr": "OB", "BinaryLength": 16400},
        "201": {"vr": "OB", "BinaryLength": 16428},
        "202": {"vr": "OB", "BinaryLength": 16428},
        "203": {"vr": "OB", "BinaryLength": 16428},
        "204": {"vr": "OB", "BinaryLength": 16428},
        "205": {"vr": "OB", "BinaryLength": 16428},
        "206": {"vr": "OB", "BinaryLength": 16424},
        "207": {"vr": "OB", "BinaryLength": 16428},
        "208": {"vr": "OB", "BinaryLength": 16416},
        "209": {"vr": "OB", "BinaryLength": 16416},
        "210": {"vr": "OB", "BinaryLength": 15624},
        "211": {"vr": "OB", "BinaryLength": 16416},
        "212": {"vr": "OB", "BinaryLength": 16428},
        "213": {"vr": "OB", "BinaryLength": 16428},
        "214": {"vr": "OB", "BinaryLength": 16428},
        "215": {"vr": "OB", "BinaryLength": 16428},
        "216": {"vr": "OB", "BinaryLength": 16428},
        "217": {"vr": "OB", "BinaryLength": 16412},
        "218": {"vr": "OB", "BinaryLength": 16428},
        "219": {"vr": "OB", "BinaryLength": 16424},
        "220": {"vr": "OB", "BinaryLength": 16428},
        "221": {"vr": "OB", "BinaryLength": 16428},
        "222": {"vr": "OB", "BinaryLength": 16424},
        "223": {"vr": "OB", "BinaryLength": 16416},
        "224": {"vr": "OB", "BinaryLength": 16424},
        "225": {"vr": "OB", "BinaryLength": 16412},
        "226": {"vr": "OB", "BinaryLength": 16428},
        "227": {"vr": "OB", "BinaryLength": 15628},
        "228": {"vr": "OB", "BinaryLength": 16416},
        "229": {"vr": "OB", "BinaryLength": 16424},
        "230": {"vr": "OB", "BinaryLength": 16424},
        "231": {"vr": "OB", "BinaryLength": 16412},
        "232": {"vr": "OB", "BinaryLength": 16428},
        "233": {"vr": "OB", "BinaryLength": 16424},
        "234": {"vr": "OB", "BinaryLength": 16424},
        "235": {"vr": "OB", "BinaryLength": 16428},
        "236": {"vr": "OB", "BinaryLength": 16432},
        "237": {"vr": "OB", "BinaryLength": 16416},
        "238": {"vr": "OB", "BinaryLength": 16432},
        "239": {"vr": "OB", "BinaryLength": 16424},
        "240": {"vr": "OB", "BinaryLength": 16424},
        "241": {"vr": "OB", "BinaryLength": 16432},
        "242": {"vr": "OB", "BinaryLength": 16416},
        "243": {"vr": "OB", "BinaryLength": 15624},
        "244": {"vr": "OB", "BinaryLength": 16428},
        "245": {"vr": "OB", "BinaryLength": 16428},
        "246": {"vr": "OB", "BinaryLength": 15616},
        "247": {"vr": "OB", "BinaryLength": 16416},
        "248": {"vr": "OB", "BinaryLength": 16424},
        "249": {"vr": "OB", "BinaryLength": 16432},
        "250": {"vr": "OB", "BinaryLength": 16428},
        "251": {"vr": "OB", "BinaryLength": 16424},
        "252": {"vr": "OB", "BinaryLength": 16424},
        "253": {"vr": "OB", "BinaryLength": 16424},
        "254": {"vr": "OB", "BinaryLength": 16424},
        "255": {"vr": "OB", "BinaryLength": 16424},
        "256": {"vr": "OB", "BinaryLength": 15624},
        "257": {"vr": "OB", "BinaryLength": 16428},
        "258": {"vr": "OB", "BinaryLength": 16424},
        "259": {"vr": "OB", "BinaryLength": 16428},
        "260": {"vr": "OB", "BinaryLength": 16428},
        "261": {"vr": "OB", "BinaryLength": 16416},
        "262": {"vr": "OB", "BinaryLength": 16424},
        "263": {"vr": "OB", "BinaryLength": 16424},
        "264": {"vr": "OB", "BinaryLength": 16416},
        "265": {"vr": "OB", "BinaryLength": 16428},
        "266": {"vr": "OB", "BinaryLength": 16432},
        "267": {"vr": "OB", "BinaryLength": 16432},
        "268": {"vr": "OB", "BinaryLength": 16416},
        "269": {"vr": "OB", "BinaryLength": 16424},
        "270": {"vr": "OB", "BinaryLength": 15624},
        "271": {"vr": "OB", "BinaryLength": 16432},
        "272": {"vr": "OB", "BinaryLength": 16428},
        "273": {"vr": "OB", "BinaryLength": 16432},
        "274": {"vr": "OB", "BinaryLength": 16408},
        "275": {"vr": "OB", "BinaryLength": 15624},
        "276": {"vr": "OB", "BinaryLength": 16428},
        "277": {"vr": "OB", "BinaryLength": 16416},
        "278": {"vr": "OB", "BinaryLength": 16428},
        "279": {"vr": "OB", "BinaryLength": 16424},
        "280": {"vr": "OB", "BinaryLength": 16428},
        "281": {"vr": "OB", "BinaryLength": 16424},
        "282": {"vr": "OB", "BinaryLength": 16416},
        "283": {"vr": "OB", "BinaryLength": 16428},
        "284": {"vr": "OB", "BinaryLength": 16428},
        "285": {"vr": "OB", "BinaryLength": 16428},
        "286": {"vr": "OB", "BinaryLength": 16424},
        "287": {"vr": "OB", "BinaryLength": 16428},
        "288": {"vr": "OB", "BinaryLength": 16432},
        "289": {"vr": "OB", "BinaryLength": 16428},
        "290": {"vr": "OB", "BinaryLength": 15624},
        "291": {"vr": "OB", "BinaryLength": 16424},
        "292": {"vr": "OB", "BinaryLength": 16428},
        "293": {"vr": "OB", "BinaryLength": 16428},
        "294": {"vr": "OB", "BinaryLength": 16428},
        "295": {"vr": "OB", "BinaryLength": 16432},
        "296": {"vr": "OB", "BinaryLength": 16428},
        "297": {"vr": "OB", "BinaryLength": 16400},
        "298": {"vr": "OB", "BinaryLength": 16400},
        "299": {"vr": "OB", "BinaryLength": 16396},
        "300": {"vr": "OB", "BinaryLength": 16428},
        "301": {"vr": "OB", "BinaryLength": 15624},
        "302": {"vr": "OB", "BinaryLength": 16428},
        "303": {"vr": "OB", "BinaryLength": 16428},
        "304": {"vr": "OB", "BinaryLength": 16428},
        "305": {"vr": "OB", "BinaryLength": 16424},
        "306": {"vr": "OB", "BinaryLength": 16416},
        "307": {"vr": "OB", "BinaryLength": 16428},
        "308": {"vr": "OB", "BinaryLength": 16428},
        "309": {"vr": "OB", "BinaryLength": 16428},
        "310": {"vr": "OB", "BinaryLength": 16424},
        "311": {"vr": "OB", "BinaryLength": 15628},
        "312": {"vr": "OB", "BinaryLength": 16428},
        "313": {"vr": "OB", "BinaryLength": 15628},
        "314": {"vr": "OB", "BinaryLength": 16432},
        "315": {"vr": "OB", "BinaryLength": 16428},
        "316": {"vr": "OB", "BinaryLength": 15624},
        "317": {"vr": "OB", "BinaryLength": 16428},
        "318": {"vr": "OB", "BinaryLength": 16428},
        "319": {"vr": "OB", "BinaryLength": 16424},
        "320": {"vr": "OB", "BinaryLength": 16424},
        "321": {"vr": "OB", "BinaryLength": 16432},
        "322": {"vr": "OB", "BinaryLength": 16428},
        "323": {"vr": "OB", "BinaryLength": 16428},
        "324": {"vr": "OB", "BinaryLength": 16424},
        "325": {"vr": "OB", "BinaryLength": 16432},
        "326": {"vr": "OB", "BinaryLength": 16412},
        "327": {"vr": "OB", "BinaryLength": 16428},
        "328": {"vr": "OB", "BinaryLength": 16416},
        "329": {"vr": "OB", "BinaryLength": 16428},
        "330": {"vr": "OB", "BinaryLength": 16416},
        "331": {"vr": "OB", "BinaryLength": 16432},
        "332": {"vr": "OB", "BinaryLength": 16424},
        "333": {"vr": "OB", "BinaryLength": 16428},
        "334": {"vr": "OB", "BinaryLength": 16424},
        "335": {"vr": "OB", "BinaryLength": 16424},
        "336": {"vr": "OB", "BinaryLength": 16428},
        "337": {"vr": "OB", "BinaryLength": 16424},
        "338": {"vr": "OB", "BinaryLength": 16424},
        "339": {"vr": "OB", "BinaryLength": 16428},
        "340": {"vr": "OB", "BinaryLength": 16408},
        "341": {"vr": "OB", "BinaryLength": 16428},
        "342": {"vr": "OB", "BinaryLength": 16424},
        "343": {"vr": "OB", "BinaryLength": 16416},
        "344": {"vr": "OB", "BinaryLength": 16428},
        "345": {"vr": "OB", "BinaryLength": 16428},
        "346": {"vr": "OB", "BinaryLength": 16416},
        "347": {"vr": "OB", "BinaryLength": 16412},
        "348": {"vr": "OB", "BinaryLength": 16428},
        "349": {"vr": "OB", "BinaryLength": 15616},
        "350": {"vr": "OB", "BinaryLength": 15624},
        "351": {"vr": "OB", "BinaryLength": 16416},
        "352": {"vr": "OB", "BinaryLength": 16428},
        "353": {"vr": "OB", "BinaryLength": 16428},
        "354": {"vr": "OB", "BinaryLength": 16424},
        "355": {"vr": "OB", "BinaryLength": 16428},
        "356": {"vr": "OB", "BinaryLength": 16428},
        "357": {"vr": "OB", "BinaryLength": 16400},
        "358": {"vr": "OB", "BinaryLength": 16428},
        "359": {"vr": "OB", "BinaryLength": 16428},
        "360": {"vr": "OB", "BinaryLength": 16416},
        "361": {"vr": "OB", "BinaryLength": 15624},
        "362": {"vr": "OB", "BinaryLength": 16428},
        "363": {"vr": "OB", "BinaryLength": 15624},
        "364": {"vr": "OB", "BinaryLength": 16428},
        "365": {"vr": "OB", "BinaryLength": 16432},
        "366": {"vr": "OB", "BinaryLength": 16428},
        "367": {"vr": "OB", "BinaryLength": 16412},
        "368": {"vr": "OB", "BinaryLength": 15624},
        "369": {"vr": "OB", "BinaryLength": 16416},
        "370": {"vr": "OB", "BinaryLength": 16428},
        "371": {"vr": "OB", "BinaryLength": 16428},
        "372": {"vr": "OB", "BinaryLength": 16424},
        "373": {"vr": "OB", "BinaryLength": 16428},
        "374": {"vr": "OB", "BinaryLength": 16424},
        "375": {"vr": "OB", "BinaryLength": 16432},
        "376": {"vr": "OB", "BinaryLength": 16432},
        "377": {"vr": "OB", "BinaryLength": 16416},
        "378": {"vr": "OB", "BinaryLength": 16428},
        "379": {"vr": "OB", "BinaryLength": 16424},
        "380": {"vr": "OB", "BinaryLength": 16424},
        "381": {"vr": "OB", "BinaryLength": 16428},
        "382": {"vr": "OB", "BinaryLength": 16424},
        "383": {"vr": "OB", "BinaryLength": 15616},
        "384": {"vr": "OB", "BinaryLength": 15624},
        "385": {"vr": "OB", "BinaryLength": 16428},
        "386": {"vr": "OB", "BinaryLength": 16432},
        "387": {"vr": "OB", "BinaryLength": 16428},
        "388": {"vr": "OB", "BinaryLength": 16424},
        "389": {"vr": "OB", "BinaryLength": 16424},
        "390": {"vr": "OB", "BinaryLength": 16412},
        "391": {"vr": "OB", "BinaryLength": 16428},
        "392": {"vr": "OB", "BinaryLength": 16428},
        "393": {"vr": "OB", "BinaryLength": 16428},
        "394": {"vr": "OB", "BinaryLength": 16428},
        "395": {"vr": "OB", "BinaryLength": 16428},
        "396": {"vr": "OB", "BinaryLength": 15628},
        "397": {"vr": "OB", "BinaryLength": 16428},
        "398": {"vr": "OB", "BinaryLength": 16412},
        "399": {"vr": "OB", "BinaryLength": 15624},
        "400": {"vr": "OB", "BinaryLength": 16428},
        "401": {"vr": "OB", "BinaryLength": 16424},
        "402": {"vr": "OB", "BinaryLength": 16424},
        "403": {"vr": "OB", "BinaryLength": 16416},
        "404": {"vr": "OB", "BinaryLength": 16408},
        "405": {"vr": "OB", "BinaryLength": 16428},
        "406": {"vr": "OB", "BinaryLength": 16428},
        "407": {"vr": "OB", "BinaryLength": 16424},
        "408": {"vr": "OB", "BinaryLength": 16428},
        "409": {"vr": "OB", "BinaryLength": 16424},
        "410": {"vr": "OB", "BinaryLength": 16428},
        "411": {"vr": "OB", "BinaryLength": 16416},
        "412": {"vr": "OB", "BinaryLength": 16400},
        "413": {"vr": "OB", "BinaryLength": 16412},
        "414": {"vr": "OB", "BinaryLength": 16412},
        "415": {"vr": "OB", "BinaryLength": 16432},
        "416": {"vr": "OB", "BinaryLength": 16428},
        "417": {"vr": "OB", "BinaryLength": 16424},
        "418": {"vr": "OB", "BinaryLength": 15616},
        "419": {"vr": "OB", "BinaryLength": 16412},
        "420": {"vr": "OB", "BinaryLength": 16428},
        "421": {"vr": "OB", "BinaryLength": 16416},
        "422": {"vr": "OB", "BinaryLength": 16428},
        "423": {"vr": "OB", "BinaryLength": 16428},
        "424": {"vr": "OB", "BinaryLength": 15624},
        "425": {"vr": "OB", "BinaryLength": 16428},
        "426": {"vr": "OB", "BinaryLength": 16424},
        "427": {"vr": "OB", "BinaryLength": 16428},
        "428": {"vr": "OB", "BinaryLength": 16424},
        "429": {"vr": "OB", "BinaryLength": 16428},
        "430": {"vr": "OB", "BinaryLength": 16424},
        "431": {"vr": "OB", "BinaryLength": 16424},
        "432": {"vr": "OB", "BinaryLength": 16428},
        "433": {"vr": "OB", "BinaryLength": 16416},
        "434": {"vr": "OB", "BinaryLength": 16428},
        "435": {"vr": "OB", "BinaryLength": 16432},
        "436": {"vr": "OB", "BinaryLength": 16396},
        "437": {"vr": "OB", "BinaryLength": 16432},
        "438": {"vr": "OB", "BinaryLength": 16424},
        "439": {"vr": "OB", "BinaryLength": 16432},
        "440": {"vr": "OB", "BinaryLength": 16416},
        "441": {"vr": "OB", "BinaryLength": 16416},
        "442": {"vr": "OB", "BinaryLength": 16416},
        "443": {"vr": "OB", "BinaryLength": 16416},
        "444": {"vr": "OB", "BinaryLength": 16432},
        "445": {"vr": "OB", "BinaryLength": 15624},
        "446": {"vr": "OB", "BinaryLength": 16428},
        "447": {"vr": "OB", "BinaryLength": 16400},
        "448": {"vr": "OB", "BinaryLength": 15624},
        "449": {"vr": "OB", "BinaryLength": 16416},
        "450": {"vr": "OB", "BinaryLength": 16428},
        "451": {"vr": "OB", "BinaryLength": 16424},
        "452": {"vr": "OB", "BinaryLength": 16428},
        "453": {"vr": "OB", "BinaryLength": 16416},
        "454": {"vr": "OB", "BinaryLength": 16424},
        "455": {"vr": "OB", "BinaryLength": 16424},
        "456": {"vr": "OB", "BinaryLength": 16424},
        "457": {"vr": "OB", "BinaryLength": 16428},
        "458": {"vr": "OB", "BinaryLength": 16428},
        "459": {"vr": "OB", "BinaryLength": 16428},
        "460": {"vr": "OB", "BinaryLength": 16428},
        "461": {"vr": "OB", "BinaryLength": 16424},
        "462": {"vr": "OB", "BinaryLength": 16424},
        "463": {"vr": "OB", "BinaryLength": 16432},
        "464": {"vr": "OB", "BinaryLength": 16424},
        "465": {"vr": "OB", "BinaryLength": 16428},
        "466": {"vr": "OB", "BinaryLength": 16412},
        "467": {"vr": "OB", "BinaryLength": 16428},
        "468": {"vr": "OB", "BinaryLength": 16416},
        "469": {"vr": "OB", "BinaryLength": 15628},
        "470": {"vr": "OB", "BinaryLength": 16416},
        "471": {"vr": "OB", "BinaryLength": 16424},
        "472": {"vr": "OB", "BinaryLength": 16424},
        "473": {"vr": "OB", "BinaryLength": 16432},
        "474": {"vr": "OB", "BinaryLength": 16424},
        "475": {"vr": "OB", "BinaryLength": 15624},
        "476": {"vr": "OB", "BinaryLength": 16432},
        "477": {"vr": "OB", "BinaryLength": 16428},
        "478": {"vr": "OB", "BinaryLength": 16428},
        "479": {"vr": "OB", "BinaryLength": 16428},
        "480": {"vr": "OB", "BinaryLength": 16428},
        "481": {"vr": "OB", "BinaryLength": 16396},
        "482": {"vr": "OB", "BinaryLength": 16428},
        "483": {"vr": "OB", "BinaryLength": 15628},
        "484": {"vr": "OB", "BinaryLength": 16432},
        "485": {"vr": "OB", "BinaryLength": 16432},
        "486": {"vr": "OB", "BinaryLength": 16428},
        "487": {"vr": "OB", "BinaryLength": 16424},
        "488": {"vr": "OB", "BinaryLength": 16428},
        "489": {"vr": "OB", "BinaryLength": 16424},
        "490": {"vr": "OB", "BinaryLength": 16428},
        "491": {"vr": "OB", "BinaryLength": 16428},
        "492": {"vr": "OB", "BinaryLength": 16428},
        "493": {"vr": "OB", "BinaryLength": 16432},
        "494": {"vr": "OB", "BinaryLength": 16424},
        "495": {"vr": "OB", "BinaryLength": 16432},
        "496": {"vr": "OB", "BinaryLength": 16432},
        "497": {"vr": "OB", "BinaryLength": 15616},
        "498": {"vr": "OB", "BinaryLength": 16428},
        "499": {"vr": "OB", "BinaryLength": 16412},
        "500": {"vr": "OB", "BinaryLength": 16424},
        "501": {"vr": "OB", "BinaryLength": 15624},
        "502": {"vr": "OB", "BinaryLength": 16424},
        "503": {"vr": "OB", "BinaryLength": 16424},
        "504": {"vr": "OB", "BinaryLength": 16428},
        "505": {"vr": "OB", "BinaryLength": 16412},
        "506": {"vr": "OB", "BinaryLength": 16428},
        "507": {"vr": "OB", "BinaryLength": 15628},
        "508": {"vr": "OB", "BinaryLength": 16428},
        "509": {"vr": "OB", "BinaryLength": 16428},
        "510": {"vr": "OB", "BinaryLength": 16432},
        "511": {"vr": "OB", "BinaryLength": 16428},
        "512": {"vr": "OB", "BinaryLength": 16424},
        "513": {"vr": "OB", "BinaryLength": 16428},
        "514": {"vr": "OB", "BinaryLength": 15624},
        "515": {"vr": "OB", "BinaryLength": 15624},
        "516": {"vr": "OB", "BinaryLength": 16392},
        "517": {"vr": "OB", "BinaryLength": 16428},
        "518": {"vr": "OB", "BinaryLength": 16428},
        "519": {"vr": "OB", "BinaryLength": 16428},
        "520": {"vr": "OB", "BinaryLength": 15624},
        "521": {"vr": "OB", "BinaryLength": 16408},
        "522": {"vr": "OB", "BinaryLength": 16428},
        "523": {"vr": "OB", "BinaryLength": 16412},
        "524": {"vr": "OB", "BinaryLength": 16428},
        "525": {"vr": "OB", "BinaryLength": 16428},
        "526": {"vr": "OB", "BinaryLength": 16428},
        "527": {"vr": "OB", "BinaryLength": 16416},
        "528": {"vr": "OB", "BinaryLength": 16428},
        "529": {"vr": "OB", "BinaryLength": 16400},
        "530": {"vr": "OB", "BinaryLength": 16432},
        "531": {"vr": "OB", "BinaryLength": 15624},
        "532": {"vr": "OB", "BinaryLength": 16400},
        "533": {"vr": "OB", "BinaryLength": 16424},
        "534": {"vr": "OB", "BinaryLength": 16424},
        "535": {"vr": "OB", "BinaryLength": 16428},
        "536": {"vr": "OB", "BinaryLength": 16428},
        "537": {"vr": "OB", "BinaryLength": 16428},
        "538": {"vr": "OB", "BinaryLength": 16424},
        "539": {"vr": "OB", "BinaryLength": 15616},
        "540": {"vr": "OB", "BinaryLength": 16428},
        "541": {"vr": "OB", "BinaryLength": 16428},
        "542": {"vr": "OB", "BinaryLength": 15624},
        "543": {"vr": "OB", "BinaryLength": 16412},
        "544": {"vr": "OB", "BinaryLength": 15624},
        "545": {"vr": "OB", "BinaryLength": 16424},
        "546": {"vr": "OB", "BinaryLength": 16416},
        "547": {"vr": "OB", "BinaryLength": 16416},
        "548": {"vr": "OB", "BinaryLength": 15624},
        "549": {"vr": "OB", "BinaryLength": 16416},
        "550": {"vr": "OB", "BinaryLength": 16432},
        "551": {"vr": "OB", "BinaryLength": 16428},
        "552": {"vr": "OB", "BinaryLength": 16428},
        "553": {"vr": "OB", "BinaryLength": 15624},
        "554": {"vr": "OB", "BinaryLength": 15624},
        "555": {"vr": "OB", "BinaryLength": 15616},
        "556": {"vr": "OB", "BinaryLength": 16424},
        "557": {"vr": "OB", "BinaryLength": 16432},
        "558": {"vr": "OB", "BinaryLength": 16428},
        "559": {"vr": "OB", "BinaryLength": 16428},
        "560": {"vr": "OB", "BinaryLength": 16424},
        "561": {"vr": "OB", "BinaryLength": 16428},
        "562": {"vr": "OB", "BinaryLength": 16424},
        "563": {"vr": "OB", "BinaryLength": 16424},
        "564": {"vr": "OB", "BinaryLength": 16424},
        "565": {"vr": "OB", "BinaryLength": 16424},
        "566": {"vr": "OB", "BinaryLength": 16416},
        "567": {"vr": "OB", "BinaryLength": 15624},
        "568": {"vr": "OB", "BinaryLength": 16428},
        "569": {"vr": "OB", "BinaryLength": 16428},
        "570": {"vr": "OB", "BinaryLength": 16428},
        "571": {"vr": "OB", "BinaryLength": 16416},
        "572": {"vr": "OB", "BinaryLength": 16428},
        "573": {"vr": "OB", "BinaryLength": 16428},
        "574": {"vr": "OB", "BinaryLength": 16428},
        "575": {"vr": "OB", "BinaryLength": 16428},
        "576": {"vr": "OB", "BinaryLength": 16416},
        "577": {"vr": "OB", "BinaryLength": 16424},
        "578": {"vr": "OB", "BinaryLength": 16428},
        "579": {"vr": "OB", "BinaryLength": 16428},
        "580": {"vr": "OB", "BinaryLength": 16428},
        "581": {"vr": "OB", "BinaryLength": 16428},
        "582": {"vr": "OB", "BinaryLength": 16428},
        "583": {"vr": "OB", "BinaryLength": 16416},
        "584": {"vr": "OB", "BinaryLength": 16428},
        "585": {"vr": "OB", "BinaryLength": 15616},
        "586": {"vr": "OB", "BinaryLength": 16416},
        "587": {"vr": "OB", "BinaryLength": 15624},
        "588": {"vr": "OB", "BinaryLength": 16428},
        "589": {"vr": "OB", "BinaryLength": 16424},
        "590": {"vr": "OB", "BinaryLength": 16428},
        "591": {"vr": "OB", "BinaryLength": 16416},
        "592": {"vr": "OB", "BinaryLength": 16432},
        "593": {"vr": "OB", "BinaryLength": 16428},
        "594": {"vr": "OB", "BinaryLength": 16396},
        "595": {"vr": "OB", "BinaryLength": 16400},
        "596": {"vr": "OB", "BinaryLength": 16428},
        "597": {"vr": "OB", "BinaryLength": 16424},
        "598": {"vr": "OB", "BinaryLength": 16424},
        "599": {"vr": "OB", "BinaryLength": 16428},
        "600": {"vr": "OB", "BinaryLength": 15624},
        "601": {"vr": "OB", "BinaryLength": 16428},
        "602": {"vr": "OB", "BinaryLength": 16432},
        "603": {"vr": "OB", "BinaryLength": 16432},
        "604": {"vr": "OB", "BinaryLength": 16424},
        "605": {"vr": "OB", "BinaryLength": 16432},
        "606": {"vr": "OB", "BinaryLength": 16432},
        "607": {"vr": "OB", "BinaryLength": 16416},
        "608": {"vr": "OB", "BinaryLength": 16424},
        "609": {"vr": "OB", "BinaryLength": 16428},
        "610": {"vr": "OB", "BinaryLength": 16432},
        "611": {"vr": "OB", "BinaryLength": 15628},
        "612": {"vr": "OB", "BinaryLength": 16400},
        "613": {"vr": "OB", "BinaryLength": 16428},
        "614": {"vr": "OB", "BinaryLength": 16428},
        "615": {"vr": "OB", "BinaryLength": 16428},
        "616": {"vr": "OB", "BinaryLength": 16428},
        "617": {"vr": "OB", "BinaryLength": 16428},
        "618": {"vr": "OB", "BinaryLength": 16412},
        "619": {"vr": "OB", "BinaryLength": 16424},
        "620": {"vr": "OB", "BinaryLength": 16428},
        "621": {"vr": "OB", "BinaryLength": 16408},
        "622": {"vr": "OB", "BinaryLength": 16396},
        "623": {"vr": "OB", "BinaryLength": 16428},
        "624": {"vr": "OB", "BinaryLength": 15624},
        "625": {"vr": "OB", "BinaryLength": 16428},
        "626": {"vr": "OB", "BinaryLength": 16428},
        "627": {"vr": "OB", "BinaryLength": 16412},
        "628": {"vr": "OB", "BinaryLength": 16400},
        "629": {"vr": "OB", "BinaryLength": 16424},
        "630": {"vr": "OB", "BinaryLength": 16428},
        "631": {"vr": "OB", "BinaryLength": 16428},
        "632": {"vr": "OB", "BinaryLength": 16424},
        "633": {"vr": "OB", "BinaryLength": 16424},
        "634": {"vr": "OB", "BinaryLength": 16428},
        "635": {"vr": "OB", "BinaryLength": 16428},
        "636": {"vr": "OB", "BinaryLength": 15624},
        "637": {"vr": "OB", "BinaryLength": 16424},
        "638": {"vr": "OB", "BinaryLength": 16428},
        "639": {"vr": "OB", "BinaryLength": 16428},
        "640": {"vr": "OB", "BinaryLength": 16416},
        "641": {"vr": "OB", "BinaryLength": 16424},
        "642": {"vr": "OB", "BinaryLength": 16424},
        "643": {"vr": "OB", "BinaryLength": 16428},
        "644": {"vr": "OB", "BinaryLength": 16424},
        "645": {"vr": "OB", "BinaryLength": 16428},
        "646": {"vr": "OB", "BinaryLength": 16416},
        "647": {"vr": "OB", "BinaryLength": 16428},
        "648": {"vr": "OB", "BinaryLength": 16428},
        "649": {"vr": "OB", "BinaryLength": 16424},
        "650": {"vr": "OB", "BinaryLength": 16416},
        "651": {"vr": "OB", "BinaryLength": 16428},
        "652": {"vr": "OB", "BinaryLength": 16416},
        "653": {"vr": "OB", "BinaryLength": 16424},
        "654": {"vr": "OB", "BinaryLength": 16428},
        "655": {"vr": "OB", "BinaryLength": 16428},
        "656": {"vr": "OB", "BinaryLength": 16424},
        "657": {"vr": "OB", "BinaryLength": 16424},
        "658": {"vr": "OB", "BinaryLength": 16428},
        "659": {"vr": "OB", "BinaryLength": 16408},
        "660": {"vr": "OB", "BinaryLength": 16424},
        "661": {"vr": "OB", "BinaryLength": 16416},
        "662": {"vr": "OB", "BinaryLength": 16424},
        "663": {"vr": "OB", "BinaryLength": 15624},
        "664": {"vr": "OB", "BinaryLength": 16424},
        "665": {"vr": "OB", "BinaryLength": 16428},
        "666": {"vr": "OB", "BinaryLength": 16432},
        "667": {"vr": "OB", "BinaryLength": 16416},
        "668": {"vr": "OB", "BinaryLength": 15624},
        "669": {"vr": "OB", "BinaryLength": 16400},
        "670": {"vr": "OB", "BinaryLength": 16424},
        "671": {"vr": "OB", "BinaryLength": 16428},
        "672": {"vr": "OB", "BinaryLength": 16424},
        "673": {"vr": "OB", "BinaryLength": 16412},
        "674": {"vr": "OB", "BinaryLength": 16416},
        "675": {"vr": "OB", "BinaryLength": 16428},
        "676": {"vr": "OB", "BinaryLength": 16428},
        "677": {"vr": "OB", "BinaryLength": 16428},
        "678": {"vr": "OB", "BinaryLength": 16408},
        "679": {"vr": "OB", "BinaryLength": 15624},
        "680": {"vr": "OB", "BinaryLength": 16432},
        "681": {"vr": "OB", "BinaryLength": 16428},
        "682": {"vr": "OB", "BinaryLength": 16428},
        "683": {"vr": "OB", "BinaryLength": 16428},
        "684": {"vr": "OB", "BinaryLength": 16428},
        "685": {"vr": "OB", "BinaryLength": 16424},
        "686": {"vr": "OB", "BinaryLength": 16424},
        "687": {"vr": "OB", "BinaryLength": 15628},
        "688": {"vr": "OB", "BinaryLength": 16432},
        "689": {"vr": "OB", "BinaryLength": 16400},
        "690": {"vr": "OB", "BinaryLength": 15628},
        "691": {"vr": "OB", "BinaryLength": 16416},
        "692": {"vr": "OB", "BinaryLength": 16424},
        "693": {"vr": "OB", "BinaryLength": 16424},
        "694": {"vr": "OB", "BinaryLength": 16424},
        "695": {"vr": "OB", "BinaryLength": 16412},
        "696": {"vr": "OB", "BinaryLength": 16428},
        "697": {"vr": "OB", "BinaryLength": 16428},
        "698": {"vr": "OB", "BinaryLength": 16428},
        "699": {"vr": "OB", "BinaryLength": 15624},
        "700": {"vr": "OB", "BinaryLength": 16412},
        "701": {"vr": "OB", "BinaryLength": 16428},
        "702": {"vr": "OB", "BinaryLength": 16416},
        "703": {"vr": "OB", "BinaryLength": 16424},
        "704": {"vr": "OB", "BinaryLength": 16424},
        "705": {"vr": "OB", "BinaryLength": 16424},
        "706": {"vr": "OB", "BinaryLength": 16428},
        "707": {"vr": "OB", "BinaryLength": 15624},
        "708": {"vr": "OB", "BinaryLength": 16432},
        "709": {"vr": "OB", "BinaryLength": 16428},
        "710": {"vr": "OB", "BinaryLength": 16428},
        "711": {"vr": "OB", "BinaryLength": 16428},
        "712": {"vr": "OB", "BinaryLength": 16396},
        "713": {"vr": "OB", "BinaryLength": 16428},
        "714": {"vr": "OB", "BinaryLength": 15624},
        "715": {"vr": "OB", "BinaryLength": 15624},
        "716": {"vr": "OB", "BinaryLength": 16428},
        "717": {"vr": "OB", "BinaryLength": 16416},
        "718": {"vr": "OB", "BinaryLength": 16432},
        "719": {"vr": "OB", "BinaryLength": 16432},
        "720": {"vr": "OB", "BinaryLength": 16424},
        "721": {"vr": "OB", "BinaryLength": 16424},
        "722": {"vr": "OB", "BinaryLength": 16416},
        "723": {"vr": "OB", "BinaryLength": 16428},
        "724": {"vr": "OB", "BinaryLength": 16428},
        "725": {"vr": "OB", "BinaryLength": 16400},
        "726": {"vr": "OB", "BinaryLength": 16428},
        "727": {"vr": "OB", "BinaryLength": 16428},
        "728": {"vr": "OB", "BinaryLength": 16400},
        "729": {"vr": "OB", "BinaryLength": 16428},
        "730": {"vr": "OB", "BinaryLength": 16428},
        "731": {"vr": "OB", "BinaryLength": 16424},
        "732": {"vr": "OB", "BinaryLength": 15624},
        "733": {"vr": "OB", "BinaryLength": 16428},
        "734": {"vr": "OB", "BinaryLength": 16424},
        "735": {"vr": "OB", "BinaryLength": 16428},
        "736": {"vr": "OB", "BinaryLength": 16428},
        "737": {"vr": "OB", "BinaryLength": 16428},
        "738": {"vr": "OB", "BinaryLength": 16428},
        "739": {"vr": "OB", "BinaryLength": 16396},
        "740": {"vr": "OB", "BinaryLength": 16424},
        "741": {"vr": "OB", "BinaryLength": 16412},
        "742": {"vr": "OB", "BinaryLength": 16412},
        "743": {"vr": "OB", "BinaryLength": 16424},
        "744": {"vr": "OB", "BinaryLength": 16424},
        "745": {"vr": "OB", "BinaryLength": 16412},
        "746": {"vr": "OB", "BinaryLength": 16416},
        "747": {"vr": "OB", "BinaryLength": 16428},
        "748": {"vr": "OB", "BinaryLength": 16428},
        "749": {"vr": "OB", "BinaryLength": 16428},
        "750": {"vr": "OB", "BinaryLength": 16416},
        "751": {"vr": "OB", "BinaryLength": 16424},
        "752": {"vr": "OB", "BinaryLength": 16428},
        "753": {"vr": "OB", "BinaryLength": 16424},
        "754": {"vr": "OB", "BinaryLength": 16428},
        "755": {"vr": "OB", "BinaryLength": 16432},
        "756": {"vr": "OB", "BinaryLength": 16428},
        "757": {"vr": "OB", "BinaryLength": 15628},
        "758": {"vr": "OB", "BinaryLength": 16428},
        "759": {"vr": "OB", "BinaryLength": 16424},
        "760": {"vr": "OB", "BinaryLength": 16432},
        "761": {"vr": "OB", "BinaryLength": 16428},
        "762": {"vr": "OB", "BinaryLength": 16428},
        "763": {"vr": "OB", "BinaryLength": 16428},
        "764": {"vr": "OB", "BinaryLength": 16428},
        "765": {"vr": "OB", "BinaryLength": 16424},
        "766": {"vr": "OB", "BinaryLength": 16428},
        "767": {"vr": "OB", "BinaryLength": 16424},
        "768": {"vr": "OB", "BinaryLength": 16424},
        "769": {"vr": "OB", "BinaryLength": 16428},
        "770": {"vr": "OB", "BinaryLength": 16428},
        "771": {"vr": "OB", "BinaryLength": 15624},
        "772": {"vr": "OB", "BinaryLength": 16428},
        "773": {"vr": "OB", "BinaryLength": 16428},
        "774": {"vr": "OB", "BinaryLength": 16432},
        "775": {"vr": "OB", "BinaryLength": 16428},
        "776": {"vr": "OB", "BinaryLength": 16428},
        "777": {"vr": "OB", "BinaryLength": 15624},
        "778": {"vr": "OB", "BinaryLength": 16428},
        "779": {"vr": "OB", "BinaryLength": 16416},
        "780": {"vr": "OB", "BinaryLength": 16428},
        "781": {"vr": "OB", "BinaryLength": 16428},
        "782": {"vr": "OB", "BinaryLength": 16432},
        "783": {"vr": "OB", "BinaryLength": 16428},
        "784": {"vr": "OB", "BinaryLength": 16396},
        "785": {"vr": "OB", "BinaryLength": 16428},
        "786": {"vr": "OB", "BinaryLength": 16432},
        "787": {"vr": "OB", "BinaryLength": 16412},
        "788": {"vr": "OB", "BinaryLength": 15624},
        "789": {"vr": "OB", "BinaryLength": 16424},
        "790": {"vr": "OB", "BinaryLength": 16416},
        "791": {"vr": "OB", "BinaryLength": 15628},
        "792": {"vr": "OB", "BinaryLength": 16424},
        "793": {"vr": "OB", "BinaryLength": 16424},
        "794": {"vr": "OB", "BinaryLength": 16424},
        "795": {"vr": "OB", "BinaryLength": 16424},
        "796": {"vr": "OB", "BinaryLength": 16428},
        "797": {"vr": "OB", "BinaryLength": 16428},
        "798": {"vr": "OB", "BinaryLength": 16424},
        "799": {"vr": "OB", "BinaryLength": 16416},
        "800": {"vr": "OB", "BinaryLength": 16408},
        "801": {"vr": "OB", "BinaryLength": 16396},
        "802": {"vr": "OB", "BinaryLength": 16424},
        "803": {"vr": "OB", "BinaryLength": 16424},
        "804": {"vr": "OB", "BinaryLength": 16428},
        "805": {"vr": "OB", "BinaryLength": 16424},
        "806": {"vr": "OB", "BinaryLength": 16428},
        "807": {"vr": "OB", "BinaryLength": 16428},
        "808": {"vr": "OB", "BinaryLength": 16428},
        "809": {"vr": "OB", "BinaryLength": 16428},
        "810": {"vr": "OB", "BinaryLength": 15624},
        "811": {"vr": "OB", "BinaryLength": 16428},
        "812": {"vr": "OB", "BinaryLength": 16424},
        "813": {"vr": "OB", "BinaryLength": 16428},
        "814": {"vr": "OB", "BinaryLength": 16432},
        "815": {"vr": "OB", "BinaryLength": 16428},
        "816": {"vr": "OB", "BinaryLength": 15624},
        "817": {"vr": "OB", "BinaryLength": 16428},
        "818": {"vr": "OB", "BinaryLength": 16424},
        "819": {"vr": "OB", "BinaryLength": 16424},
        "820": {"vr": "OB", "BinaryLength": 15624},
        "821": {"vr": "OB", "BinaryLength": 16416},
        "822": {"vr": "OB", "BinaryLength": 16428},
        "823": {"vr": "OB", "BinaryLength": 16428},
        "824": {"vr": "OB", "BinaryLength": 16424},
        "825": {"vr": "OB", "BinaryLength": 16428},
        "826": {"vr": "OB", "BinaryLength": 16424},
        "827": {"vr": "OB", "BinaryLength": 15624},
        "828": {"vr": "OB", "BinaryLength": 16428},
        "829": {"vr": "OB", "BinaryLength": 15624},
        "830": {"vr": "OB", "BinaryLength": 16424},
        "831": {"vr": "OB", "BinaryLength": 16428},
        "832": {"vr": "OB", "BinaryLength": 16432},
        "833": {"vr": "OB", "BinaryLength": 16412},
        "834": {"vr": "OB", "BinaryLength": 16424},
        "835": {"vr": "OB", "BinaryLength": 16412},
        "836": {"vr": "OB", "BinaryLength": 16428},
        "837": {"vr": "OB", "BinaryLength": 16424},
        "838": {"vr": "OB", "BinaryLength": 16424},
        "839": {"vr": "OB", "BinaryLength": 16432},
        "840": {"vr": "OB", "BinaryLength": 16424},
        "841": {"vr": "OB", "BinaryLength": 16428},
        "842": {"vr": "OB", "BinaryLength": 16412},
        "843": {"vr": "OB", "BinaryLength": 16428},
        "844": {"vr": "OB", "BinaryLength": 16424},
        "845": {"vr": "OB", "BinaryLength": 16416},
        "846": {"vr": "OB", "BinaryLength": 15628},
        "847": {"vr": "OB", "BinaryLength": 16428},
        "848": {"vr": "OB", "BinaryLength": 16428},
        "849": {"vr": "OB", "BinaryLength": 16424},
        "850": {"vr": "OB", "BinaryLength": 15624},
        "851": {"vr": "OB", "BinaryLength": 16428},
        "852": {"vr": "OB", "BinaryLength": 16424},
        "853": {"vr": "OB", "BinaryLength": 16428},
        "854": {"vr": "OB", "BinaryLength": 16424},
        "855": {"vr": "OB", "BinaryLength": 16428},
        "856": {"vr": "OB", "BinaryLength": 16432},
        "857": {"vr": "OB", "BinaryLength": 16428},
        "858": {"vr": "OB", "BinaryLength": 16428},
        "859": {"vr": "OB", "BinaryLength": 16424},
        "860": {"vr": "OB", "BinaryLength": 16428},
        "861": {"vr": "OB", "BinaryLength": 15624},
        "862": {"vr": "OB", "BinaryLength": 16428},
        "863": {"vr": "OB", "BinaryLength": 16416},
        "864": {"vr": "OB", "BinaryLength": 16412},
        "865": {"vr": "OB", "BinaryLength": 16428},
        "866": {"vr": "OB", "BinaryLength": 16428},
        "867": {"vr": "OB", "BinaryLength": 15628},
        "868": {"vr": "OB", "BinaryLength": 15624},
        "869": {"vr": "OB", "BinaryLength": 16412},
        "870": {"vr": "OB", "BinaryLength": 15624},
        "871": {"vr": "OB", "BinaryLength": 16428},
        "872": {"vr": "OB", "BinaryLength": 16400},
        "873": {"vr": "OB", "BinaryLength": 16416},
        "874": {"vr": "OB", "BinaryLength": 16432},
        "875": {"vr": "OB", "BinaryLength": 15616},
        "876": {"vr": "OB", "BinaryLength": 16412},
        "877": {"vr": "OB", "BinaryLength": 16428},
        "878": {"vr": "OB", "BinaryLength": 16428},
        "879": {"vr": "OB", "BinaryLength": 16416},
        "880": {"vr": "OB", "BinaryLength": 16412},
        "881": {"vr": "OB", "BinaryLength": 16424},
        "882": {"vr": "OB", "BinaryLength": 16424},
        "883": {"vr": "OB", "BinaryLength": 16424},
        "884": {"vr": "OB", "BinaryLength": 16428},
        "885": {"vr": "OB", "BinaryLength": 15624},
        "886": {"vr": "OB", "BinaryLength": 16428},
        "887": {"vr": "OB", "BinaryLength": 16428},
        "888": {"vr": "OB", "BinaryLength": 16412},
        "889": {"vr": "OB", "BinaryLength": 16412},
        "890": {"vr": "OB", "BinaryLength": 16424},
        "891": {"vr": "OB", "BinaryLength": 16428},
        "892": {"vr": "OB", "BinaryLength": 16428},
        "893": {"vr": "OB", "BinaryLength": 16416},
        "894": {"vr": "OB", "BinaryLength": 16428},
        "895": {"vr": "OB", "BinaryLength": 16428},
        "896": {"vr": "OB", "BinaryLength": 16408},
        "897": {"vr": "OB", "BinaryLength": 16432},
        "898": {"vr": "OB", "BinaryLength": 16424},
        "899": {"vr": "OB", "BinaryLength": 16428},
        "900": {"vr": "OB", "BinaryLength": 16424},
        "901": {"vr": "OB", "BinaryLength": 16424},
        "902": {"vr": "OB", "BinaryLength": 16424},
        "903": {"vr": "OB", "BinaryLength": 16412},
        "904": {"vr": "OB", "BinaryLength": 16424},
        "905": {"vr": "OB", "BinaryLength": 16428},
        "906": {"vr": "OB", "BinaryLength": 16424},
        "907": {"vr": "OB", "BinaryLength": 16428},
        "908": {"vr": "OB", "BinaryLength": 16428},
        "909": {"vr": "OB", "BinaryLength": 16432},
        "910": {"vr": "OB", "BinaryLength": 16428},
        "911": {"vr": "OB", "BinaryLength": 16424},
        "912": {"vr": "OB", "BinaryLength": 16428},
        "913": {"vr": "OB", "BinaryLength": 16428},
        "914": {"vr": "OB", "BinaryLength": 16428},
        "915": {"vr": "OB", "BinaryLength": 16424},
        "916": {"vr": "OB", "BinaryLength": 16428},
        "917": {"vr": "OB", "BinaryLength": 16428},
        "918": {"vr": "OB", "BinaryLength": 16424},
        "919": {"vr": "OB", "BinaryLength": 15616},
        "920": {"vr": "OB", "BinaryLength": 16424},
        "921": {"vr": "OB", "BinaryLength": 16424},
        "922": {"vr": "OB", "BinaryLength": 16424},
        "923": {"vr": "OB", "BinaryLength": 16428},
        "924": {"vr": "OB", "BinaryLength": 15616},
        "925": {"vr": "OB", "BinaryLength": 16424},
        "926": {"vr": "OB", "BinaryLength": 15624},
        "927": {"vr": "OB", "BinaryLength": 16424},
        "928": {"vr": "OB", "BinaryLength": 16416},
        "929": {"vr": "OB", "BinaryLength": 16428},
        "930": {"vr": "OB", "BinaryLength": 16428},
        "931": {"vr": "OB", "BinaryLength": 16428},
        "932": {"vr": "OB", "BinaryLength": 15624},
        "933": {"vr": "OB", "BinaryLength": 16428},
        "934": {"vr": "OB", "BinaryLength": 16416},
        "935": {"vr": "OB", "BinaryLength": 16428},
        "936": {"vr": "OB", "BinaryLength": 15624},
        "937": {"vr": "OB", "BinaryLength": 16428},
        "938": {"vr": "OB", "BinaryLength": 16412},
        "939": {"vr": "OB", "BinaryLength": 16432},
        "940": {"vr": "OB", "BinaryLength": 16428},
        "941": {"vr": "OB", "BinaryLength": 16428},
        "942": {"vr": "OB", "BinaryLength": 16424},
        "943": {"vr": "OB", "BinaryLength": 16428},
        "944": {"vr": "OB", "BinaryLength": 16416},
        "945": {"vr": "OB", "BinaryLength": 16416},
        "946": {"vr": "OB", "BinaryLength": 16428},
        "947": {"vr": "OB", "BinaryLength": 16424},
        "948": {"vr": "OB", "BinaryLength": 15624},
        "949": {"vr": "OB", "BinaryLength": 16428},
        "950": {"vr": "OB", "BinaryLength": 16424},
        "951": {"vr": "OB", "BinaryLength": 16428},
        "952": {"vr": "OB", "BinaryLength": 16428},
        "953": {"vr": "OB", "BinaryLength": 16424},
        "954": {"vr": "OB", "BinaryLength": 16428},
        "955": {"vr": "OB", "BinaryLength": 16424},
        "956": {"vr": "OB", "BinaryLength": 15624},
        "957": {"vr": "OB", "BinaryLength": 16424},
        "958": {"vr": "OB", "BinaryLength": 16424},
        "959": {"vr": "OB", "BinaryLength": 16428},
        "960": {"vr": "OB", "BinaryLength": 16428},
        "961": {"vr": "OB", "BinaryLength": 15624},
        "962": {"vr": "OB", "BinaryLength": 16428},
        "963": {"vr": "OB", "BinaryLength": 16424},
        "964": {"vr": "OB", "BinaryLength": 16424},
        "965": {"vr": "OB", "BinaryLength": 16428},
        "966": {"vr": "OB", "BinaryLength": 16424},
        "967": {"vr": "OB", "BinaryLength": 16416},
        "968": {"vr": "OB", "BinaryLength": 16428},
        "969": {"vr": "OB", "BinaryLength": 16424},
        "970": {"vr": "OB", "BinaryLength": 16400},
        "971": {"vr": "OB", "BinaryLength": 16428},
        "972": {"vr": "OB", "BinaryLength": 16416},
        "973": {"vr": "OB", "BinaryLength": 16424},
        "974": {"vr": "OB", "BinaryLength": 16424},
        "975": {"vr": "OB", "BinaryLength": 16432},
        "976": {"vr": "OB", "BinaryLength": 16424},
        "977": {"vr": "OB", "BinaryLength": 16428},
        "978": {"vr": "OB", "BinaryLength": 15624},
        "979": {"vr": "OB", "BinaryLength": 16428},
        "980": {"vr": "OB", "BinaryLength": 16424},
        "981": {"vr": "OB", "BinaryLength": 16416},
        "982": {"vr": "OB", "BinaryLength": 16428},
        "983": {"vr": "OB", "BinaryLength": 15624},
        "984": {"vr": "OB", "BinaryLength": 16428},
        "985": {"vr": "OB", "BinaryLength": 16428},
        "986": {"vr": "OB", "BinaryLength": 16432},
        "987": {"vr": "OB", "BinaryLength": 16400},
        "988": {"vr": "OB", "BinaryLength": 16424},
        "989": {"vr": "OB", "BinaryLength": 16428},
        "990": {"vr": "OB", "BinaryLength": 16428},
        "991": {"vr": "OB", "BinaryLength": 16416},
        "992": {"vr": "OB", "BinaryLength": 16424},
        "993": {"vr": "OB", "BinaryLength": 16428},
        "994": {"vr": "OB", "BinaryLength": 16424},
        "995": {"vr": "OB", "BinaryLength": 16428},
        "996": {"vr": "OB", "BinaryLength": 15624},
        "997": {"vr": "OB", "BinaryLength": 16428},
        "998": {"vr": "OB", "BinaryLength": 16424},
        "999": {"vr": "OB", "BinaryLength": 16428},
        "1000": {"vr": "OB", "BinaryLength": 16432},
        "1001": {"vr": "OB", "BinaryLength": 16428},
        "1002": {"vr": "OB", "BinaryLength": 16412},
        "1003": {"vr": "OB", "BinaryLength": 16424},
        "1004": {"vr": "OB", "BinaryLength": 16416},
        "1005": {"vr": "OB", "BinaryLength": 16432},
        "1006": {"vr": "OB", "BinaryLength": 16432},
        "1007": {"vr": "OB", "BinaryLength": 16428},
        "1008": {"vr": "OB", "BinaryLength": 16424},
        "1009": {"vr": "OB", "BinaryLength": 16428},
        "1010": {"vr": "OB", "BinaryLength": 16416},
        "1011": {"vr": "OB", "BinaryLength": 16412},
        "1012": {"vr": "OB", "BinaryLength": 16432},
        "1013": {"vr": "OB", "BinaryLength": 16432},
        "1014": {"vr": "OB", "BinaryLength": 16428},
        "1015": {"vr": "OB", "BinaryLength": 15624},
        "1016": {"vr": "OB", "BinaryLength": 15624},
        "1017": {"vr": "OB", "BinaryLength": 16432},
        "1018": {"vr": "OB", "BinaryLength": 16424},
        "1019": {"vr": "OB", "BinaryLength": 16428},
        "1020": {"vr": "OB", "BinaryLength": 16428},
        "1021": {"vr": "OB", "BinaryLength": 16428},
        "1022": {"vr": "OB", "BinaryLength": 16428},
        "1023": {"vr": "OB", "BinaryLength": 16424},
        "1024": {"vr": "OB", "BinaryLength": 16428},
        "1025": {"vr": "OB", "BinaryLength": 16416},
        "1026": {"vr": "OB", "BinaryLength": 16424},
        "1027": {"vr": "OB", "BinaryLength": 16428},
        "1028": {"vr": "OB", "BinaryLength": 16424},
        "1029": {"vr": "OB", "BinaryLength": 16428},
        "1030": {"vr": "OB", "BinaryLength": 15616},
        "1031": {"vr": "OB", "BinaryLength": 16408},
        "1032": {"vr": "OB", "BinaryLength": 15624},
        "1033": {"vr": "OB", "BinaryLength": 16424},
        "1034": {"vr": "OB", "BinaryLength": 16424},
        "1035": {"vr": "OB", "BinaryLength": 16432},
        "1036": {"vr": "OB", "BinaryLength": 16424},
        "1037": {"vr": "OB", "BinaryLength": 16428},
        "1038": {"vr": "OB", "BinaryLength": 16416},
        "1039": {"vr": "OB", "BinaryLength": 15624},
        "1040": {"vr": "OB", "BinaryLength": 16428},
        "1041": {"vr": "OB", "BinaryLength": 16428},
        "1042": {"vr": "OB", "BinaryLength": 16428},
        "1043": {"vr": "OB", "BinaryLength": 16428},
        "1044": {"vr": "OB", "BinaryLength": 16424},
        "1045": {"vr": "OB", "BinaryLength": 16412},
        "1046": {"vr": "OB", "BinaryLength": 16424},
        "1047": {"vr": "OB", "BinaryLength": 16432},
        "1048": {"vr": "OB", "BinaryLength": 16428},
        "1049": {"vr": "OB", "BinaryLength": 16416},
        "1050": {"vr": "OB", "BinaryLength": 16416},
        "1051": {"vr": "OB", "BinaryLength": 16428},
        "1052": {"vr": "OB", "BinaryLength": 16408},
        "1053": {"vr": "OB", "BinaryLength": 16428},
        "1054": {"vr": "OB", "BinaryLength": 16416},
        "1055": {"vr": "OB", "BinaryLength": 16428},
        "1056": {"vr": "OB", "BinaryLength": 16428},
        "1057": {"vr": "OB", "BinaryLength": 16428},
        "1058": {"vr": "OB", "BinaryLength": 16428},
        "1059": {"vr": "OB", "BinaryLength": 16428},
        "1060": {"vr": "OB", "BinaryLength": 15616},
        "1061": {"vr": "OB", "BinaryLength": 16424},
        "1062": {"vr": "OB", "BinaryLength": 16428},
        "1063": {"vr": "OB", "BinaryLength": 16432},
        "1064": {"vr": "OB", "BinaryLength": 16428},
        "1065": {"vr": "OB", "BinaryLength": 15624},
        "1066": {"vr": "OB", "BinaryLength": 16428},
        "1067": {"vr": "OB", "BinaryLength": 16432},
        "1068": {"vr": "OB", "BinaryLength": 16424},
        "1069": {"vr": "OB", "BinaryLength": 16428},
        "1070": {"vr": "OB", "BinaryLength": 16428},
        "1071": {"vr": "OB", "BinaryLength": 16428},
        "1072": {"vr": "OB", "BinaryLength": 16432},
        "1073": {"vr": "OB", "BinaryLength": 15624},
        "1074": {"vr": "OB", "BinaryLength": 16412},
        "1075": {"vr": "OB", "BinaryLength": 16416},
        "1076": {"vr": "OB", "BinaryLength": 16424},
        "1077": {"vr": "OB", "BinaryLength": 16428},
        "1078": {"vr": "OB", "BinaryLength": 16424},
        "1079": {"vr": "OB", "BinaryLength": 16428},
        "1080": {"vr": "OB", "BinaryLength": 16432},
        "1081": {"vr": "OB", "BinaryLength": 15624},
        "1082": {"vr": "OB", "BinaryLength": 16428},
        "1083": {"vr": "OB", "BinaryLength": 16428},
        "1084": {"vr": "OB", "BinaryLength": 16424},
        "1085": {"vr": "OB", "BinaryLength": 16432},
        "1086": {"vr": "OB", "BinaryLength": 16428},
        "1087": {"vr": "OB", "BinaryLength": 16428},
        "1088": {"vr": "OB", "BinaryLength": 15624},
        "1089": {"vr": "OB", "BinaryLength": 16428},
        "1090": {"vr": "OB", "BinaryLength": 15624},
        "1091": {"vr": "OB", "BinaryLength": 15624},
        "1092": {"vr": "OB", "BinaryLength": 16428},
        "1093": {"vr": "OB", "BinaryLength": 16416},
        "1094": {"vr": "OB", "BinaryLength": 16428},
        "1095": {"vr": "OB", "BinaryLength": 16432},
        "1096": {"vr": "OB", "BinaryLength": 16432},
        "1097": {"vr": "OB", "BinaryLength": 15624},
        "1098": {"vr": "OB", "BinaryLength": 16424},
        "1099": {"vr": "OB", "BinaryLength": 16428},
        "1100": {"vr": "OB", "BinaryLength": 16428},
        "1101": {"vr": "OB", "BinaryLength": 16424},
        "1102": {"vr": "OB", "BinaryLength": 16432},
        "1103": {"vr": "OB", "BinaryLength": 16416},
        "1104": {"vr": "OB", "BinaryLength": 16408},
        "1105": {"vr": "OB", "BinaryLength": 15624},
        "1106": {"vr": "OB", "BinaryLength": 16408},
        "1107": {"vr": "OB", "BinaryLength": 16428},
        "1108": {"vr": "OB", "BinaryLength": 16428},
        "1109": {"vr": "OB", "BinaryLength": 16428},
        "1110": {"vr": "OB", "BinaryLength": 15624},
        "1111": {"vr": "OB", "BinaryLength": 16424},
        "1112": {"vr": "OB", "BinaryLength": 16432},
        "1113": {"vr": "OB", "BinaryLength": 16428},
        "1114": {"vr": "OB", "BinaryLength": 16428},
        "1115": {"vr": "OB", "BinaryLength": 16428},
        "1116": {"vr": "OB", "BinaryLength": 16396},
        "1117": {"vr": "OB", "BinaryLength": 16432},
        "1118": {"vr": "OB", "BinaryLength": 16428},
        "1119": {"vr": "OB", "BinaryLength": 16428},
        "1120": {"vr": "OB", "BinaryLength": 16432},
        "1121": {"vr": "OB", "BinaryLength": 16428},
        "1122": {"vr": "OB", "BinaryLength": 16424},
        "1123": {"vr": "OB", "BinaryLength": 16424},
        "1124": {"vr": "OB", "BinaryLength": 16424},
        "1125": {"vr": "OB", "BinaryLength": 16424},
        "1126": {"vr": "OB", "BinaryLength": 16412},
        "1127": {"vr": "OB", "BinaryLength": 16428},
        "1128": {"vr": "OB", "BinaryLength": 16416},
        "1129": {"vr": "OB", "BinaryLength": 16424},
        "1130": {"vr": "OB", "BinaryLength": 16428},
        "1131": {"vr": "OB", "BinaryLength": 15624},
        "1132": {"vr": "OB", "BinaryLength": 16424},
        "1133": {"vr": "OB", "BinaryLength": 16424},
        "1134": {"vr": "OB", "BinaryLength": 16428},
        "1135": {"vr": "OB", "BinaryLength": 16432},
        "1136": {"vr": "OB", "BinaryLength": 15628},
        "1137": {"vr": "OB", "BinaryLength": 16424},
        "1138": {"vr": "OB", "BinaryLength": 16412},
        "1139": {"vr": "OB", "BinaryLength": 16428},
        "1140": {"vr": "OB", "BinaryLength": 16424},
        "1141": {"vr": "OB", "BinaryLength": 16428},
        "1142": {"vr": "OB", "BinaryLength": 16424},
        "1143": {"vr": "OB", "BinaryLength": 16412},
        "1144": {"vr": "OB", "BinaryLength": 16424},
        "1145": {"vr": "OB", "BinaryLength": 16428},
        "1146": {"vr": "OB", "BinaryLength": 16428},
        "1147": {"vr": "OB", "BinaryLength": 15628},
        "1148": {"vr": "OB", "BinaryLength": 15624},
        "1149": {"vr": "OB", "BinaryLength": 15616},
        "1150": {"vr": "OB", "BinaryLength": 16428},
        "1151": {"vr": "OB", "BinaryLength": 16424},
        "1152": {"vr": "OB", "BinaryLength": 16424},
        "1153": {"vr": "OB", "BinaryLength": 16428},
        "1154": {"vr": "OB", "BinaryLength": 16428},
        "1155": {"vr": "OB", "BinaryLength": 16416},
        "1156": {"vr": "OB", "BinaryLength": 16428},
        "1157": {"vr": "OB", "BinaryLength": 16400},
        "1158": {"vr": "OB", "BinaryLength": 16428},
        "1159": {"vr": "OB", "BinaryLength": 16428},
        "1160": {"vr": "OB", "BinaryLength": 16428},
        "1161": {"vr": "OB", "BinaryLength": 16412},
        "1162": {"vr": "OB", "BinaryLength": 16424},
        "1163": {"vr": "OB", "BinaryLength": 16428},
        "1164": {"vr": "OB", "BinaryLength": 16428},
        "1165": {"vr": "OB", "BinaryLength": 15624},
        "1166": {"vr": "OB", "BinaryLength": 15616},
        "1167": {"vr": "OB", "BinaryLength": 16428},
        "1168": {"vr": "OB", "BinaryLength": 16412},
        "1169": {"vr": "OB", "BinaryLength": 16432},
        "1170": {"vr": "OB", "BinaryLength": 16424},
        "1171": {"vr": "OB", "BinaryLength": 16416},
        "1172": {"vr": "OB", "BinaryLength": 16428},
        "1173": {"vr": "OB", "BinaryLength": 16428},
        "1174": {"vr": "OB", "BinaryLength": 16432},
        "1175": {"vr": "OB", "BinaryLength": 16424},
        "1176": {"vr": "OB", "BinaryLength": 16428},
        "1177": {"vr": "OB", "BinaryLength": 16416},
        "1178": {"vr": "OB", "BinaryLength": 15616},
        "1179": {"vr": "OB", "BinaryLength": 16424},
        "1180": {"vr": "OB", "BinaryLength": 16428},
        "1181": {"vr": "OB", "BinaryLength": 16428},
        "1182": {"vr": "OB", "BinaryLength": 16424},
        "1183": {"vr": "OB", "BinaryLength": 16424},
        "1184": {"vr": "OB", "BinaryLength": 16428},
        "1185": {"vr": "OB", "BinaryLength": 16424},
        "1186": {"vr": "OB", "BinaryLength": 16416},
        "1187": {"vr": "OB", "BinaryLength": 16428},
        "1188": {"vr": "OB", "BinaryLength": 16424},
        "1189": {"vr": "OB", "BinaryLength": 15624},
        "1190": {"vr": "OB", "BinaryLength": 16424},
        "1191": {"vr": "OB", "BinaryLength": 15616},
        "1192": {"vr": "OB", "BinaryLength": 16412},
        "1193": {"vr": "OB", "BinaryLength": 15628},
        "1194": {"vr": "OB", "BinaryLength": 16416},
        "1195": {"vr": "OB", "BinaryLength": 16428},
        "1196": {"vr": "OB", "BinaryLength": 16400},
        "1197": {"vr": "OB", "BinaryLength": 16428},
        "1198": {"vr": "OB", "BinaryLength": 16428},
        "1199": {"vr": "OB", "BinaryLength": 16428},
        "1200": {"vr": "OB", "BinaryLength": 16416},
        "1201": {"vr": "OB", "BinaryLength": 15616},
        "1202": {"vr": "OB", "BinaryLength": 15624},
        "1203": {"vr": "OB", "BinaryLength": 16432},
        "1204": {"vr": "OB", "BinaryLength": 16428},
        "1205": {"vr": "OB", "BinaryLength": 16432},
        "1206": {"vr": "OB", "BinaryLength": 16424},
        "1207": {"vr": "OB", "BinaryLength": 16428},
        "1208": {"vr": "OB", "BinaryLength": 16400},
        "1209": {"vr": "OB", "BinaryLength": 16424},
        "1210": {"vr": "OB", "BinaryLength": 16428},
        "1211": {"vr": "OB", "BinaryLength": 16428},
        "1212": {"vr": "OB", "BinaryLength": 16428},
        "1213": {"vr": "OB", "BinaryLength": 16428},
        "1214": {"vr": "OB", "BinaryLength": 16428},
        "1215": {"vr": "OB", "BinaryLength": 16416},
        "1216": {"vr": "OB", "BinaryLength": 16428},
        "1217": {"vr": "OB", "BinaryLength": 16432},
        "1218": {"vr": "OB", "BinaryLength": 16400},
        "1219": {"vr": "OB", "BinaryLength": 15624},
        "1220": {"vr": "OB", "BinaryLength": 15624},
        "1221": {"vr": "OB", "BinaryLength": 16428},
        "1222": {"vr": "OB", "BinaryLength": 16428},
        "1223": {"vr": "OB", "BinaryLength": 16432},
        "1224": {"vr": "OB", "BinaryLength": 16424},
        "1225": {"vr": "OB", "BinaryLength": 16416},
        "1226": {"vr": "OB", "BinaryLength": 16400},
        "1227": {"vr": "OB", "BinaryLength": 16432},
        "1228": {"vr": "OB", "BinaryLength": 16432},
        "1229": {"vr": "OB", "BinaryLength": 16432},
        "1230": {"vr": "OB", "BinaryLength": 16416},
        "1231": {"vr": "OB", "BinaryLength": 16428},
        "1232": {"vr": "OB", "BinaryLength": 16428},
        "1233": {"vr": "OB", "BinaryLength": 16424},
        "1234": {"vr": "OB", "BinaryLength": 16408},
        "1235": {"vr": "OB", "BinaryLength": 16428},
        "1236": {"vr": "OB", "BinaryLength": 16400},
        "1237": {"vr": "OB", "BinaryLength": 16416},
        "1238": {"vr": "OB", "BinaryLength": 16428},
        "1239": {"vr": "OB", "BinaryLength": 16412},
        "1240": {"vr": "OB", "BinaryLength": 16424},
        "1241": {"vr": "OB", "BinaryLength": 16396},
        "1242": {"vr": "OB", "BinaryLength": 16428},
        "1243": {"vr": "OB", "BinaryLength": 16424},
        "1244": {"vr": "OB", "BinaryLength": 16424},
        "1245": {"vr": "OB", "BinaryLength": 16428},
        "1246": {"vr": "OB", "BinaryLength": 16428},
        "1247": {"vr": "OB", "BinaryLength": 16424},
        "1248": {"vr": "OB", "BinaryLength": 16428},
        "1249": {"vr": "OB", "BinaryLength": 16428},
        "1250": {"vr": "OB", "BinaryLength": 16424},
        "1251": {"vr": "OB", "BinaryLength": 16428},
        "1252": {"vr": "OB", "BinaryLength": 16428},
        "1253": {"vr": "OB", "BinaryLength": 16424},
        "1254": {"vr": "OB", "BinaryLength": 16432},
        "1255": {"vr": "OB", "BinaryLength": 16428},
        "1256": {"vr": "OB", "BinaryLength": 16428},
        "1257": {"vr": "OB", "BinaryLength": 16396},
        "1258": {"vr": "OB", "BinaryLength": 16424},
        "1259": {"vr": "OB", "BinaryLength": 16424},
        "1260": {"vr": "OB", "BinaryLength": 15624},
        "1261": {"vr": "OB", "BinaryLength": 16408},
        "1262": {"vr": "OB", "BinaryLength": 16424},
        "1263": {"vr": "OB", "BinaryLength": 16428},
        "1264": {"vr": "OB", "BinaryLength": 15624},
        "1265": {"vr": "OB", "BinaryLength": 16432},
        "1266": {"vr": "OB", "BinaryLength": 16424},
        "1267": {"vr": "OB", "BinaryLength": 16416},
        "1268": {"vr": "OB", "BinaryLength": 16428},
        "1269": {"vr": "OB", "BinaryLength": 16412},
        "1270": {"vr": "OB", "BinaryLength": 16416},
        "1271": {"vr": "OB", "BinaryLength": 15628},
        "1272": {"vr": "OB", "BinaryLength": 16424},
        "1273": {"vr": "OB", "BinaryLength": 16428},
        "1274": {"vr": "OB", "BinaryLength": 16424},
        "1275": {"vr": "OB", "BinaryLength": 16428},
        "1276": {"vr": "OB", "BinaryLength": 16416},
        "1277": {"vr": "OB", "BinaryLength": 16428},
        "1278": {"vr": "OB", "BinaryLength": 16432},
        "1279": {"vr": "OB", "BinaryLength": 16428},
        "1280": {"vr": "OB", "BinaryLength": 16412},
        "1281": {"vr": "OB", "BinaryLength": 16424},
        "1282": {"vr": "OB", "BinaryLength": 15624},
        "1283": {"vr": "OB", "BinaryLength": 16424},
        "1284": {"vr": "OB", "BinaryLength": 16428},
        "1285": {"vr": "OB", "BinaryLength": 16428},
        "1286": {"vr": "OB", "BinaryLength": 16428},
        "1287": {"vr": "OB", "BinaryLength": 16428},
        "1288": {"vr": "OB", "BinaryLength": 16424},
        "1289": {"vr": "OB", "BinaryLength": 16432},
        "1290": {"vr": "OB", "BinaryLength": 16424},
        "1291": {"vr": "OB", "BinaryLength": 15616},
        "1292": {"vr": "OB", "BinaryLength": 16432},
        "1293": {"vr": "OB", "BinaryLength": 16428},
        "1294": {"vr": "OB", "BinaryLength": 16416},
        "1295": {"vr": "OB", "BinaryLength": 16424},
        "1296": {"vr": "OB", "BinaryLength": 16428},
        "1297": {"vr": "OB", "BinaryLength": 16424},
        "1298": {"vr": "OB", "BinaryLength": 16396},
        "1299": {"vr": "OB", "BinaryLength": 16416},
        "1300": {"vr": "OB", "BinaryLength": 15624},
        "1301": {"vr": "OB", "BinaryLength": 16428},
        "1302": {"vr": "OB", "BinaryLength": 16400},
        "1303": {"vr": "OB", "BinaryLength": 16432},
        "1304": {"vr": "OB", "BinaryLength": 16424},
        "1305": {"vr": "OB", "BinaryLength": 16432},
        "1306": {"vr": "OB", "BinaryLength": 16428},
        "1307": {"vr": "OB", "BinaryLength": 16416},
        "1308": {"vr": "OB", "BinaryLength": 16416},
        "1309": {"vr": "OB", "BinaryLength": 15624},
        "1310": {"vr": "OB", "BinaryLength": 16396},
        "1311": {"vr": "OB", "BinaryLength": 16428},
        "1312": {"vr": "OB", "BinaryLength": 16428},
        "1313": {"vr": "OB", "BinaryLength": 16424},
        "1314": {"vr": "OB", "BinaryLength": 16432},
        "1315": {"vr": "OB", "BinaryLength": 16396},
        "1316": {"vr": "OB", "BinaryLength": 16424},
        "1317": {"vr": "OB", "BinaryLength": 16428},
        "1318": {"vr": "OB", "BinaryLength": 16412},
        "1319": {"vr": "OB", "BinaryLength": 16408},
        "1320": {"vr": "OB", "BinaryLength": 16424},
        "1321": {"vr": "OB", "BinaryLength": 16428},
        "1322": {"vr": "OB", "BinaryLength": 16424},
        "1323": {"vr": "OB", "BinaryLength": 16428},
        "1324": {"vr": "OB", "BinaryLength": 15624},
        "1325": {"vr": "OB", "BinaryLength": 16400},
        "1326": {"vr": "OB", "BinaryLength": 15624},
        "1327": {"vr": "OB", "BinaryLength": 16416},
        "1328": {"vr": "OB", "BinaryLength": 16428},
        "1329": {"vr": "OB", "BinaryLength": 16428},
        "1330": {"vr": "OB", "BinaryLength": 15628},
        "1331": {"vr": "OB", "BinaryLength": 16424},
        "1332": {"vr": "OB", "BinaryLength": 16428},
        "1333": {"vr": "OB", "BinaryLength": 15624},
        "1334": {"vr": "OB", "BinaryLength": 16428},
        "1335": {"vr": "OB", "BinaryLength": 16424},
        "1336": {"vr": "OB", "BinaryLength": 16428},
        "1337": {"vr": "OB", "BinaryLength": 16428},
        "1338": {"vr": "OB", "BinaryLength": 16424},
        "1339": {"vr": "OB", "BinaryLength": 16428},
        "1340": {"vr": "OB", "BinaryLength": 16412},
        "1341": {"vr": "OB", "BinaryLength": 16428},
        "1342": {"vr": "OB", "BinaryLength": 16424},
        "1343": {"vr": "OB", "BinaryLength": 16424},
        "1344": {"vr": "OB", "BinaryLength": 16428},
        "1345": {"vr": "OB", "BinaryLength": 16428},
        "1346": {"vr": "OB", "BinaryLength": 16424},
        "1347": {"vr": "OB", "BinaryLength": 15616},
        "1348": {"vr": "OB", "BinaryLength": 16416},
        "1349": {"vr": "OB", "BinaryLength": 16424},
        "1350": {"vr": "OB", "BinaryLength": 16424},
        "1351": {"vr": "OB", "BinaryLength": 16424},
        "1352": {"vr": "OB", "BinaryLength": 16428},
        "1353": {"vr": "OB", "BinaryLength": 16424},
        "1354": {"vr": "OB", "BinaryLength": 16432},
        "1355": {"vr": "OB", "BinaryLength": 16428},
        "1356": {"vr": "OB", "BinaryLength": 16428},
        "1357": {"vr": "OB", "BinaryLength": 16424},
        "1358": {"vr": "OB", "BinaryLength": 15628},
        "1359": {"vr": "OB", "BinaryLength": 16428},
        "1360": {"vr": "OB", "BinaryLength": 16428},
        "1361": {"vr": "OB", "BinaryLength": 16424},
        "1362": {"vr": "OB", "BinaryLength": 16396},
        "1363": {"vr": "OB", "BinaryLength": 16428},
        "1364": {"vr": "OB", "BinaryLength": 16428},
        "1365": {"vr": "OB", "BinaryLength": 16424},
        "1366": {"vr": "OB", "BinaryLength": 16424},
        "1367": {"vr": "OB", "BinaryLength": 16412},
        "1368": {"vr": "OB", "BinaryLength": 16424},
        "1369": {"vr": "OB", "BinaryLength": 16428},
        "1370": {"vr": "OB", "BinaryLength": 16428},
        "1371": {"vr": "OB", "BinaryLength": 16416},
        "1372": {"vr": "OB", "BinaryLength": 16416},
        "1373": {"vr": "OB", "BinaryLength": 16428},
        "1374": {"vr": "OB", "BinaryLength": 16428},
        "1375": {"vr": "OB", "BinaryLength": 15624},
        "1376": {"vr": "OB", "BinaryLength": 16424},
        "1377": {"vr": "OB", "BinaryLength": 16412},
        "1378": {"vr": "OB", "BinaryLength": 16428},
        "1379": {"vr": "OB", "BinaryLength": 16428},
        "1380": {"vr": "OB", "BinaryLength": 16432},
        "1381": {"vr": "OB", "BinaryLength": 15624},
        "1382": {"vr": "OB", "BinaryLength": 16424},
        "1383": {"vr": "OB", "BinaryLength": 16428},
        "1384": {"vr": "OB", "BinaryLength": 16424},
        "1385": {"vr": "OB", "BinaryLength": 16424},
        "1386": {"vr": "OB", "BinaryLength": 16428},
        "1387": {"vr": "OB", "BinaryLength": 16424},
        "1388": {"vr": "OB", "BinaryLength": 16432},
        "1389": {"vr": "OB", "BinaryLength": 16424},
        "1390": {"vr": "OB", "BinaryLength": 16432},
        "1391": {"vr": "OB", "BinaryLength": 16396},
        "1392": {"vr": "OB", "BinaryLength": 16424},
        "1393": {"vr": "OB", "BinaryLength": 16424},
        "1394": {"vr": "OB", "BinaryLength": 16428},
        "1395": {"vr": "OB", "BinaryLength": 16424},
        "1396": {"vr": "OB", "BinaryLength": 16428},
        "1397": {"vr": "OB", "BinaryLength": 16432},
        "1398": {"vr": "OB", "BinaryLength": 16424},
        "1399": {"vr": "OB", "BinaryLength": 16428},
        "1400": {"vr": "OB", "BinaryLength": 16428},
        "1401": {"vr": "OB", "BinaryLength": 16428},
        "1402": {"vr": "OB", "BinaryLength": 16428},
        "1403": {"vr": "OB", "BinaryLength": 16428},
        "1404": {"vr": "OB", "BinaryLength": 15616},
        "1405": {"vr": "OB", "BinaryLength": 16400},
        "1406": {"vr": "OB", "BinaryLength": 16428},
        "1407": {"vr": "OB", "BinaryLength": 16424},
        "1408": {"vr": "OB", "BinaryLength": 16432},
        "1409": {"vr": "OB", "BinaryLength": 16424},
        "1410": {"vr": "OB", "BinaryLength": 16428},
        "1411": {"vr": "OB", "BinaryLength": 16408},
        "1412": {"vr": "OB", "BinaryLength": 16416},
        "1413": {"vr": "OB", "BinaryLength": 15624},
        "1414": {"vr": "OB", "BinaryLength": 16424},
        "1415": {"vr": "OB", "BinaryLength": 16424},
        "1416": {"vr": "OB", "BinaryLength": 16432},
        "1417": {"vr": "OB", "BinaryLength": 15628},
        "1418": {"vr": "OB", "BinaryLength": 16424},
        "1419": {"vr": "OB", "BinaryLength": 16428},
        "1420": {"vr": "OB", "BinaryLength": 16428},
        "1421": {"vr": "OB", "BinaryLength": 16428},
        "1422": {"vr": "OB", "BinaryLength": 16424},
        "1423": {"vr": "OB", "BinaryLength": 16432},
        "1424": {"vr": "OB", "BinaryLength": 16428},
        "1425": {"vr": "OB", "BinaryLength": 16428},
        "1426": {"vr": "OB", "BinaryLength": 16424},
        "1427": {"vr": "OB", "BinaryLength": 16432},
        "1428": {"vr": "OB", "BinaryLength": 16428},
        "1429": {"vr": "OB", "BinaryLength": 16424},
        "1430": {"vr": "OB", "BinaryLength": 15624},
        "1431": {"vr": "OB", "BinaryLength": 16432},
        "1432": {"vr": "OB", "BinaryLength": 16432},
        "1433": {"vr": "OB", "BinaryLength": 16428},
        "1434": {"vr": "OB", "BinaryLength": 16428},
        "1435": {"vr": "OB", "BinaryLength": 16416},
        "1436": {"vr": "OB", "BinaryLength": 16424},
        "1437": {"vr": "OB", "BinaryLength": 16416},
        "1438": {"vr": "OB", "BinaryLength": 16412},
        "1439": {"vr": "OB", "BinaryLength": 16428},
        "1440": {"vr": "OB", "BinaryLength": 16432},
        "1441": {"vr": "OB", "BinaryLength": 16424},
        "1442": {"vr": "OB", "BinaryLength": 15616},
        "1443": {"vr": "OB", "BinaryLength": 16428},
        "1444": {"vr": "OB", "BinaryLength": 16424},
        "1445": {"vr": "OB", "BinaryLength": 16428},
        "1446": {"vr": "OB", "BinaryLength": 16424},
        "1447": {"vr": "OB", "BinaryLength": 16428},
        "1448": {"vr": "OB", "BinaryLength": 16424},
        "1449": {"vr": "OB", "BinaryLength": 15628},
        "1450": {"vr": "OB", "BinaryLength": 16424},
        "1451": {"vr": "OB", "BinaryLength": 16428},
        "1452": {"vr": "OB", "BinaryLength": 16396},
        "1453": {"vr": "OB", "BinaryLength": 16428},
        "1454": {"vr": "OB", "BinaryLength": 16428},
        "1455": {"vr": "OB", "BinaryLength": 15628},
        "1456": {"vr": "OB", "BinaryLength": 16416},
        "1457": {"vr": "OB", "BinaryLength": 16416},
        "1458": {"vr": "OB", "BinaryLength": 16428},
        "1459": {"vr": "OB", "BinaryLength": 16424},
        "1460": {"vr": "OB", "BinaryLength": 15624},
        "1461": {"vr": "OB", "BinaryLength": 15624},
        "1462": {"vr": "OB", "BinaryLength": 16424},
        "1463": {"vr": "OB", "BinaryLength": 16424},
        "1464": {"vr": "OB", "BinaryLength": 16416},
        "1465": {"vr": "OB", "BinaryLength": 16428},
        "1466": {"vr": "OB", "BinaryLength": 16424},
        "1467": {"vr": "OB", "BinaryLength": 16428},
        "1468": {"vr": "OB", "BinaryLength": 16424},
        "1469": {"vr": "OB", "BinaryLength": 16416},
        "1470": {"vr": "OB", "BinaryLength": 16424},
        "1471": {"vr": "OB", "BinaryLength": 16428},
        "1472": {"vr": "OB", "BinaryLength": 16428},
        "1473": {"vr": "OB", "BinaryLength": 16424},
        "1474": {"vr": "OB", "BinaryLength": 15628},
        "1475": {"vr": "OB", "BinaryLength": 16428},
        "1476": {"vr": "OB", "BinaryLength": 16428},
        "1477": {"vr": "OB", "BinaryLength": 16424},
        "1478": {"vr": "OB", "BinaryLength": 16424},
        "1479": {"vr": "OB", "BinaryLength": 16416},
        "1480": {"vr": "OB", "BinaryLength": 16428},
        "1481": {"vr": "OB", "BinaryLength": 16428},
        "1482": {"vr": "OB", "BinaryLength": 16428},
        "1483": {"vr": "OB", "BinaryLength": 16428},
        "1484": {"vr": "OB", "BinaryLength": 16416},
        "1485": {"vr": "OB", "BinaryLength": 16428},
        "1486": {"vr": "OB", "BinaryLength": 16424},
        "1487": {"vr": "OB", "BinaryLength": 16428},
        "1488": {"vr": "OB", "BinaryLength": 15624},
        "1489": {"vr": "OB", "BinaryLength": 16424},
        "1490": {"vr": "OB", "BinaryLength": 16424},
        "1491": {"vr": "OB", "BinaryLength": 16424},
        "1492": {"vr": "OB", "BinaryLength": 16424},
        "1493": {"vr": "OB", "BinaryLength": 15624},
        "1494": {"vr": "OB", "BinaryLength": 16432},
        "1495": {"vr": "OB", "BinaryLength": 16432},
        "1496": {"vr": "OB", "BinaryLength": 16428},
        "1497": {"vr": "OB", "BinaryLength": 16424},
        "1498": {"vr": "OB", "BinaryLength": 16428},
        "1499": {"vr": "OB", "BinaryLength": 16432},
        "1500": {"vr": "OB", "BinaryLength": 16416},
        "1501": {"vr": "OB", "BinaryLength": 16428},
        "1502": {"vr": "OB", "BinaryLength": 16432},
        "1503": {"vr": "OB", "BinaryLength": 16428},
        "1504": {"vr": "OB", "BinaryLength": 16432},
        "1505": {"vr": "OB", "BinaryLength": 16424},
        "1506": {"vr": "OB", "BinaryLength": 16424},
        "1507": {"vr": "OB", "BinaryLength": 16424},
        "1508": {"vr": "OB", "BinaryLength": 16424},
        "1509": {"vr": "OB", "BinaryLength": 16416},
        "1510": {"vr": "OB", "BinaryLength": 16416},
        "1511": {"vr": "OB", "BinaryLength": 16424},
        "1512": {"vr": "OB", "BinaryLength": 15628},
        "1513": {"vr": "OB", "BinaryLength": 16416},
        "1514": {"vr": "OB", "BinaryLength": 16428},
        "1515": {"vr": "OB", "BinaryLength": 15616},
        "1516": {"vr": "OB", "BinaryLength": 16400},
        "1517": {"vr": "OB", "BinaryLength": 15624},
        "1518": {"vr": "OB", "BinaryLength": 16424},
        "1519": {"vr": "OB", "BinaryLength": 16428},
        "1520": {"vr": "OB", "BinaryLength": 16432},
        "1521": {"vr": "OB", "BinaryLength": 16416},
        "1522": {"vr": "OB", "BinaryLength": 16424},
        "1523": {"vr": "OB", "BinaryLength": 16428},
        "1524": {"vr": "OB", "BinaryLength": 16428},
        "1525": {"vr": "OB", "BinaryLength": 16416},
        "1526": {"vr": "OB", "BinaryLength": 16428},
        "1527": {"vr": "OB", "BinaryLength": 16424},
        "1528": {"vr": "OB", "BinaryLength": 16400},
        "1529": {"vr": "OB", "BinaryLength": 16424},
        "1530": {"vr": "OB", "BinaryLength": 16432},
        "1531": {"vr": "OB", "BinaryLength": 16428},
        "1532": {"vr": "OB", "BinaryLength": 16428},
        "1533": {"vr": "OB", "BinaryLength": 16424},
        "1534": {"vr": "OB", "BinaryLength": 16424},
        "1535": {"vr": "OB", "BinaryLength": 16428},
        "1536": {"vr": "OB", "BinaryLength": 15624},
        "1537": {"vr": "OB", "BinaryLength": 16424},
        "1538": {"vr": "OB", "BinaryLength": 16424},
        "1539": {"vr": "OB", "BinaryLength": 16416},
        "1540": {"vr": "OB", "BinaryLength": 16424},
        "1541": {"vr": "OB", "BinaryLength": 16416},
        "1542": {"vr": "OB", "BinaryLength": 16428},
        "1543": {"vr": "OB", "BinaryLength": 16424},
        "1544": {"vr": "OB", "BinaryLength": 16428},
        "1545": {"vr": "OB", "BinaryLength": 16428},
        "1546": {"vr": "OB", "BinaryLength": 16428},
        "1547": {"vr": "OB", "BinaryLength": 16424},
        "1548": {"vr": "OB", "BinaryLength": 16428},
        "1549": {"vr": "OB", "BinaryLength": 16424},
        "1550": {"vr": "OB", "BinaryLength": 16428},
        "1551": {"vr": "OB", "BinaryLength": 16424},
        "1552": {"vr": "OB", "BinaryLength": 16428},
        "1553": {"vr": "OB", "BinaryLength": 15624},
        "1554": {"vr": "OB", "BinaryLength": 16428},
        "1555": {"vr": "OB", "BinaryLength": 15616},
        "1556": {"vr": "OB", "BinaryLength": 16424},
        "1557": {"vr": "OB", "BinaryLength": 16428},
        "1558": {"vr": "OB", "BinaryLength": 16424},
        "1559": {"vr": "OB", "BinaryLength": 15624},
        "1560": {"vr": "OB", "BinaryLength": 16428},
        "1561": {"vr": "OB", "BinaryLength": 16428},
        "1562": {"vr": "OB", "BinaryLength": 15628},
        "1563": {"vr": "OB", "BinaryLength": 16428},
        "1564": {"vr": "OB", "BinaryLength": 16424},
        "1565": {"vr": "OB", "BinaryLength": 16424},
        "1566": {"vr": "OB", "BinaryLength": 16424},
        "1567": {"vr": "OB", "BinaryLength": 16428},
        "1568": {"vr": "OB", "BinaryLength": 16424},
        "1569": {"vr": "OB", "BinaryLength": 16424},
        "1570": {"vr": "OB", "BinaryLength": 16432},
        "1571": {"vr": "OB", "BinaryLength": 16416},
        "1572": {"vr": "OB", "BinaryLength": 16428},
        "1573": {"vr": "OB", "BinaryLength": 16432},
        "1574": {"vr": "OB", "BinaryLength": 15624},
        "1575": {"vr": "OB", "BinaryLength": 16424},
        "1576": {"vr": "OB", "BinaryLength": 16408},
        "1577": {"vr": "OB", "BinaryLength": 16428},
        "1578": {"vr": "OB", "BinaryLength": 16428},
        "1579": {"vr": "OB", "BinaryLength": 16428},
        "1580": {"vr": "OB", "BinaryLength": 16432},
        "1581": {"vr": "OB", "BinaryLength": 16424},
        "1582": {"vr": "OB", "BinaryLength": 16432},
        "1583": {"vr": "OB", "BinaryLength": 16428},
        "1584": {"vr": "OB", "BinaryLength": 16432},
        "1585": {"vr": "OB", "BinaryLength": 16416},
        "1586": {"vr": "OB", "BinaryLength": 16424},
        "1587": {"vr": "OB", "BinaryLength": 16428},
        "1588": {"vr": "OB", "BinaryLength": 16428},
        "1589": {"vr": "OB", "BinaryLength": 16424},
        "1590": {"vr": "OB", "BinaryLength": 15624},
        "1591": {"vr": "OB", "BinaryLength": 16428},
        "1592": {"vr": "OB", "BinaryLength": 16416},
        "1593": {"vr": "OB", "BinaryLength": 16416},
        "1594": {"vr": "OB", "BinaryLength": 15624},
        "1595": {"vr": "OB", "BinaryLength": 16428},
        "1596": {"vr": "OB", "BinaryLength": 16424},
        "1597": {"vr": "OB", "BinaryLength": 16428},
        "1598": {"vr": "OB", "BinaryLength": 16428},
        "1599": {"vr": "OB", "BinaryLength": 16432},
        "1600": {"vr": "OB", "BinaryLength": 15624},
        "1601": {"vr": "OB", "BinaryLength": 15616},
        "1602": {"vr": "OB", "BinaryLength": 16416},
        "1603": {"vr": "OB", "BinaryLength": 15624},
        "1604": {"vr": "OB", "BinaryLength": 15624},
        "1605": {"vr": "OB", "BinaryLength": 16428},
        "1606": {"vr": "OB", "BinaryLength": 16428},
        "1607": {"vr": "OB", "BinaryLength": 16428},
        "1608": {"vr": "OB", "BinaryLength": 16416},
        "1609": {"vr": "OB", "BinaryLength": 16428},
        "1610": {"vr": "OB", "BinaryLength": 15624},
        "1611": {"vr": "OB", "BinaryLength": 16428},
        "1612": {"vr": "OB", "BinaryLength": 16428},
        "1613": {"vr": "OB", "BinaryLength": 16424},
        "1614": {"vr": "OB", "BinaryLength": 16428},
        "1615": {"vr": "OB", "BinaryLength": 16424},
        "1616": {"vr": "OB", "BinaryLength": 16428},
        "1617": {"vr": "OB", "BinaryLength": 16432},
        "1618": {"vr": "OB", "BinaryLength": 16432},
        "1619": {"vr": "OB", "BinaryLength": 16400},
        "1620": {"vr": "OB", "BinaryLength": 16432},
        "1621": {"vr": "OB", "BinaryLength": 16432},
        "1622": {"vr": "OB", "BinaryLength": 16416},
        "1623": {"vr": "OB", "BinaryLength": 16428},
        "1624": {"vr": "OB", "BinaryLength": 16416},
        "1625": {"vr": "OB", "BinaryLength": 15624},
        "1626": {"vr": "OB", "BinaryLength": 16424},
        "1627": {"vr": "OB", "BinaryLength": 16428},
        "1628": {"vr": "OB", "BinaryLength": 16424},
        "1629": {"vr": "OB", "BinaryLength": 16428},
        "1630": {"vr": "OB", "BinaryLength": 16428},
        "1631": {"vr": "OB", "BinaryLength": 16412},
        "1632": {"vr": "OB", "BinaryLength": 16432},
        "1633": {"vr": "OB", "BinaryLength": 16428},
        "1634": {"vr": "OB", "BinaryLength": 16416},
        "1635": {"vr": "OB", "BinaryLength": 16432},
        "1636": {"vr": "OB", "BinaryLength": 16412},
        "1637": {"vr": "OB", "BinaryLength": 16424},
        "1638": {"vr": "OB", "BinaryLength": 16428},
        "1639": {"vr": "OB", "BinaryLength": 16424},
        "1640": {"vr": "OB", "BinaryLength": 16424},
        "1641": {"vr": "OB", "BinaryLength": 16412},
        "1642": {"vr": "OB", "BinaryLength": 16408},
        "1643": {"vr": "OB", "BinaryLength": 15624},
        "1644": {"vr": "OB", "BinaryLength": 15624},
        "1645": {"vr": "OB", "BinaryLength": 16428},
        "1646": {"vr": "OB", "BinaryLength": 16428},
        "1647": {"vr": "OB", "BinaryLength": 16416},
        "1648": {"vr": "OB", "BinaryLength": 16424},
        "1649": {"vr": "OB", "BinaryLength": 15624},
        "1650": {"vr": "OB", "BinaryLength": 16432},
        "1651": {"vr": "OB", "BinaryLength": 16424},
        "1652": {"vr": "OB", "BinaryLength": 16424},
        "1653": {"vr": "OB", "BinaryLength": 16432},
        "1654": {"vr": "OB", "BinaryLength": 16424},
        "1655": {"vr": "OB", "BinaryLength": 16428},
        "1656": {"vr": "OB", "BinaryLength": 16428},
        "1657": {"vr": "OB", "BinaryLength": 16428},
        "1658": {"vr": "OB", "BinaryLength": 16428},
        "1659": {"vr": "OB", "BinaryLength": 16424},
        "1660": {"vr": "OB", "BinaryLength": 16416},
        "1661": {"vr": "OB", "BinaryLength": 16396},
        "1662": {"vr": "OB", "BinaryLength": 16424},
        "1663": {"vr": "OB", "BinaryLength": 16432},
        "1664": {"vr": "OB", "BinaryLength": 16428},
        "1665": {"vr": "OB", "BinaryLength": 16428},
        "1666": {"vr": "OB", "BinaryLength": 16424},
        "1667": {"vr": "OB", "BinaryLength": 16428},
        "1668": {"vr": "OB", "BinaryLength": 16412},
        "1669": {"vr": "OB", "BinaryLength": 16428},
        "1670": {"vr": "OB", "BinaryLength": 16428},
        "1671": {"vr": "OB", "BinaryLength": 16428},
        "1672": {"vr": "OB", "BinaryLength": 16424},
        "1673": {"vr": "OB", "BinaryLength": 16428},
        "1674": {"vr": "OB", "BinaryLength": 16424},
        "1675": {"vr": "OB", "BinaryLength": 16428},
        "1676": {"vr": "OB", "BinaryLength": 16400},
        "1677": {"vr": "OB", "BinaryLength": 16432},
        "1678": {"vr": "OB", "BinaryLength": 16428},
        "1679": {"vr": "OB", "BinaryLength": 16424},
        "1680": {"vr": "OB", "BinaryLength": 16428},
        "1681": {"vr": "OB", "BinaryLength": 16416},
        "1682": {"vr": "OB", "BinaryLength": 16428},
        "1683": {"vr": "OB", "BinaryLength": 16428},
        "1684": {"vr": "OB", "BinaryLength": 16428},
        "1685": {"vr": "OB", "BinaryLength": 16424},
        "1686": {"vr": "OB", "BinaryLength": 16400},
        "1687": {"vr": "OB", "BinaryLength": 16428},
        "1688": {"vr": "OB", "BinaryLength": 16424},
        "1689": {"vr": "OB", "BinaryLength": 15628},
        "1690": {"vr": "OB", "BinaryLength": 16424},
        "1691": {"vr": "OB", "BinaryLength": 15624},
        "1692": {"vr": "OB", "BinaryLength": 16428},
        "1693": {"vr": "OB", "BinaryLength": 16428},
        "1694": {"vr": "OB", "BinaryLength": 16416},
        "1695": {"vr": "OB", "BinaryLength": 16432},
        "1696": {"vr": "OB", "BinaryLength": 16416},
        "1697": {"vr": "OB", "BinaryLength": 16416},
        "1698": {"vr": "OB", "BinaryLength": 16432},
        "1699": {"vr": "OB", "BinaryLength": 16428},
        "1700": {"vr": "OB", "BinaryLength": 15616},
        "1701": {"vr": "OB", "BinaryLength": 16428},
        "1702": {"vr": "OB", "BinaryLength": 16428},
        "1703": {"vr": "OB", "BinaryLength": 16424},
        "1704": {"vr": "OB", "BinaryLength": 16416},
        "1705": {"vr": "OB", "BinaryLength": 16416},
        "1706": {"vr": "OB", "BinaryLength": 16416},
        "1707": {"vr": "OB", "BinaryLength": 16428},
        "1708": {"vr": "OB", "BinaryLength": 16428},
        "1709": {"vr": "OB", "BinaryLength": 16428},
        "1710": {"vr": "OB", "BinaryLength": 16432},
        "1711": {"vr": "OB", "BinaryLength": 16400},
        "1712": {"vr": "OB", "BinaryLength": 16428},
        "1713": {"vr": "OB", "BinaryLength": 16428},
        "1714": {"vr": "OB", "BinaryLength": 16416},
        "1715": {"vr": "OB", "BinaryLength": 16424},
        "1716": {"vr": "OB", "BinaryLength": 16424},
        "1717": {"vr": "OB", "BinaryLength": 15624},
        "1718": {"vr": "OB", "BinaryLength": 16432},
        "1719": {"vr": "OB", "BinaryLength": 16428},
        "1720": {"vr": "OB", "BinaryLength": 15624},
        "1721": {"vr": "OB", "BinaryLength": 16416},
        "1722": {"vr": "OB", "BinaryLength": 16428},
        "1723": {"vr": "OB", "BinaryLength": 16432},
        "1724": {"vr": "OB", "BinaryLength": 16424},
        "1725": {"vr": "OB", "BinaryLength": 16432},
        "1726": {"vr": "OB", "BinaryLength": 16428},
        "1727": {"vr": "OB", "BinaryLength": 16432},
        "1728": {"vr": "OB", "BinaryLength": 16424},
        "1729": {"vr": "OB", "BinaryLength": 16428},
        "1730": {"vr": "OB", "BinaryLength": 16416},
        "1731": {"vr": "OB", "BinaryLength": 16424},
        "1732": {"vr": "OB", "BinaryLength": 16408},
        "1733": {"vr": "OB", "BinaryLength": 16396},
        "1734": {"vr": "OB", "BinaryLength": 16424},
        "1735": {"vr": "OB", "BinaryLength": 16416},
        "1736": {"vr": "OB", "BinaryLength": 15628},
        "1737": {"vr": "OB", "BinaryLength": 16424},
        "1738": {"vr": "OB", "BinaryLength": 15624},
        "1739": {"vr": "OB", "BinaryLength": 16428},
        "1740": {"vr": "OB", "BinaryLength": 16416},
        "1741": {"vr": "OB", "BinaryLength": 16424},
        "1742": {"vr": "OB", "BinaryLength": 16416},
        "1743": {"vr": "OB", "BinaryLength": 16428},
        "1744": {"vr": "OB", "BinaryLength": 16428},
        "1745": {"vr": "OB", "BinaryLength": 16432},
        "1746": {"vr": "OB", "BinaryLength": 16424},
        "1747": {"vr": "OB", "BinaryLength": 16428},
        "1748": {"vr": "OB", "BinaryLength": 16428},
        "1749": {"vr": "OB", "BinaryLength": 16416},
        "1750": {"vr": "OB", "BinaryLength": 16428},
        "1751": {"vr": "OB", "BinaryLength": 16432},
        "1752": {"vr": "OB", "BinaryLength": 16424},
        "1753": {"vr": "OB", "BinaryLength": 16424},
        "1754": {"vr": "OB", "BinaryLength": 16428},
        "1755": {"vr": "OB", "BinaryLength": 16428},
        "1756": {"vr": "OB", "BinaryLength": 16428},
        "1757": {"vr": "OB", "BinaryLength": 16424},
        "1758": {"vr": "OB", "BinaryLength": 16396},
        "1759": {"vr": "OB", "BinaryLength": 16400},
        "1760": {"vr": "OB", "BinaryLength": 16424},
        "1761": {"vr": "OB", "BinaryLength": 16424},
        "1762": {"vr": "OB", "BinaryLength": 16396},
        "1763": {"vr": "OB", "BinaryLength": 16416},
        "1764": {"vr": "OB", "BinaryLength": 16424},
        "1765": {"vr": "OB", "BinaryLength": 16424},
        "1766": {"vr": "OB", "BinaryLength": 16432},
        "1767": {"vr": "OB", "BinaryLength": 16428},
        "1768": {"vr": "OB", "BinaryLength": 16428},
        "1769": {"vr": "OB", "BinaryLength": 16396},
        "1770": {"vr": "OB", "BinaryLength": 16428},
        "1771": {"vr": "OB", "BinaryLength": 16432},
        "1772": {"vr": "OB", "BinaryLength": 16428},
        "1773": {"vr": "OB", "BinaryLength": 16416},
        "1774": {"vr": "OB", "BinaryLength": 16424},
        "1775": {"vr": "OB", "BinaryLength": 15624},
        "1776": {"vr": "OB", "BinaryLength": 16432},
        "1777": {"vr": "OB", "BinaryLength": 16424},
        "1778": {"vr": "OB", "BinaryLength": 16428},
        "1779": {"vr": "OB", "BinaryLength": 16424},
        "1780": {"vr": "OB", "BinaryLength": 16424},
        "1781": {"vr": "OB", "BinaryLength": 16428},
        "1782": {"vr": "OB", "BinaryLength": 16424},
        "1783": {"vr": "OB", "BinaryLength": 16432},
        "1784": {"vr": "OB", "BinaryLength": 16428},
        "1785": {"vr": "OB", "BinaryLength": 16428},
        "1786": {"vr": "OB", "BinaryLength": 16432},
        "1787": {"vr": "OB", "BinaryLength": 16416},
        "1788": {"vr": "OB", "BinaryLength": 16424},
        "1789": {"vr": "OB", "BinaryLength": 16432},
        "1790": {"vr": "OB", "BinaryLength": 16432},
        "1791": {"vr": "OB", "BinaryLength": 16408},
        "1792": {"vr": "OB", "BinaryLength": 16424},
        "1793": {"vr": "OB", "BinaryLength": 16432},
        "1794": {"vr": "OB", "BinaryLength": 16424},
        "1795": {"vr": "OB", "BinaryLength": 16424},
        "1796": {"vr": "OB", "BinaryLength": 15616},
        "1797": {"vr": "OB", "BinaryLength": 16416},
        "1798": {"vr": "OB", "BinaryLength": 16424},
        "1799": {"vr": "OB", "BinaryLength": 16428},
        "1800": {"vr": "OB", "BinaryLength": 16428},
        "1801": {"vr": "OB", "BinaryLength": 16424},
        "1802": {"vr": "OB", "BinaryLength": 15624},
        "1803": {"vr": "OB", "BinaryLength": 16428},
        "1804": {"vr": "OB", "BinaryLength": 16428},
        "1805": {"vr": "OB", "BinaryLength": 15624},
        "1806": {"vr": "OB", "BinaryLength": 16424},
        "1807": {"vr": "OB", "BinaryLength": 16428},
        "1808": {"vr": "OB", "BinaryLength": 16428},
        "1809": {"vr": "OB", "BinaryLength": 16424},
        "1810": {"vr": "OB", "BinaryLength": 16428},
        "1811": {"vr": "OB", "BinaryLength": 16428},
        "1812": {"vr": "OB", "BinaryLength": 16432},
        "1813": {"vr": "OB", "BinaryLength": 16424},
        "1814": {"vr": "OB", "BinaryLength": 16416},
        "1815": {"vr": "OB", "BinaryLength": 16428},
        "1816": {"vr": "OB", "BinaryLength": 16424},
        "1817": {"vr": "OB", "BinaryLength": 16432},
        "1818": {"vr": "OB", "BinaryLength": 16424},
        "1819": {"vr": "OB", "BinaryLength": 16428},
        "1820": {"vr": "OB", "BinaryLength": 16428},
        "1821": {"vr": "OB", "BinaryLength": 16428},
        "1822": {"vr": "OB", "BinaryLength": 16428},
        "1823": {"vr": "OB", "BinaryLength": 16428},
        "1824": {"vr": "OB", "BinaryLength": 16428},
        "1825": {"vr": "OB", "BinaryLength": 16428},
        "1826": {"vr": "OB", "BinaryLength": 16432},
        "1827": {"vr": "OB", "BinaryLength": 15624},
        "1828": {"vr": "OB", "BinaryLength": 16424},
        "1829": {"vr": "OB", "BinaryLength": 16424},
        "1830": {"vr": "OB", "BinaryLength": 16424},
        "1831": {"vr": "OB", "BinaryLength": 16428},
        "1832": {"vr": "OB", "BinaryLength": 16428},
        "1833": {"vr": "OB", "BinaryLength": 16424},
        "1834": {"vr": "OB", "BinaryLength": 16424},
        "1835": {"vr": "OB", "BinaryLength": 16424},
        "1836": {"vr": "OB", "BinaryLength": 16416},
        "1837": {"vr": "OB", "BinaryLength": 15624},
        "1838": {"vr": "OB", "BinaryLength": 15624},
        "1839": {"vr": "OB", "BinaryLength": 16428},
        "1840": {"vr": "OB", "BinaryLength": 16412},
        "1841": {"vr": "OB", "BinaryLength": 16424},
        "1842": {"vr": "OB", "BinaryLength": 16428},
        "1843": {"vr": "OB", "BinaryLength": 16424},
        "1844": {"vr": "OB", "BinaryLength": 16416},
        "1845": {"vr": "OB", "BinaryLength": 15624},
        "1846": {"vr": "OB", "BinaryLength": 16424},
        "1847": {"vr": "OB", "BinaryLength": 16424},
        "1848": {"vr": "OB", "BinaryLength": 16428},
        "1849": {"vr": "OB", "BinaryLength": 16428},
        "1850": {"vr": "OB", "BinaryLength": 16424},
        "1851": {"vr": "OB", "BinaryLength": 16424},
        "1852": {"vr": "OB", "BinaryLength": 16428},
        "1853": {"vr": "OB", "BinaryLength": 16400},
        "1854": {"vr": "OB", "BinaryLength": 16424},
        "1855": {"vr": "OB", "BinaryLength": 16428},
        "1856": {"vr": "OB", "BinaryLength": 16416},
        "1857": {"vr": "OB", "BinaryLength": 16428},
        "1858": {"vr": "OB", "BinaryLength": 16428},
        "1859": {"vr": "OB", "BinaryLength": 16416},
        "1860": {"vr": "OB", "BinaryLength": 16416},
        "1861": {"vr": "OB", "BinaryLength": 16424},
        "1862": {"vr": "OB", "BinaryLength": 16428},
        "1863": {"vr": "OB", "BinaryLength": 16424},
        "1864": {"vr": "OB", "BinaryLength": 16424},
        "1865": {"vr": "OB", "BinaryLength": 16428},
        "1866": {"vr": "OB", "BinaryLength": 16416},
        "1867": {"vr": "OB", "BinaryLength": 16428},
        "1868": {"vr": "OB", "BinaryLength": 16416},
        "1869": {"vr": "OB", "BinaryLength": 16424},
        "1870": {"vr": "OB", "BinaryLength": 16424},
        "1871": {"vr": "OB", "BinaryLength": 16428},
        "1872": {"vr": "OB", "BinaryLength": 15624},
        "1873": {"vr": "OB", "BinaryLength": 15616},
        "1874": {"vr": "OB", "BinaryLength": 16432},
        "1875": {"vr": "OB", "BinaryLength": 16428},
        "1876": {"vr": "OB", "BinaryLength": 16424},
        "1877": {"vr": "OB", "BinaryLength": 16416},
        "1878": {"vr": "OB", "BinaryLength": 16412},
        "1879": {"vr": "OB", "BinaryLength": 16428},
        "1880": {"vr": "OB", "BinaryLength": 16428},
        "1881": {"vr": "OB", "BinaryLength": 16428},
        "1882": {"vr": "OB", "BinaryLength": 16424},
        "1883": {"vr": "OB", "BinaryLength": 16416},
        "1884": {"vr": "OB", "BinaryLength": 16424},
        "1885": {"vr": "OB", "BinaryLength": 16428},
        "1886": {"vr": "OB", "BinaryLength": 16428},
        "1887": {"vr": "OB", "BinaryLength": 16424},
        "1888": {"vr": "OB", "BinaryLength": 16428},
        "1889": {"vr": "OB", "BinaryLength": 15624},
        "1890": {"vr": "OB", "BinaryLength": 16424},
        "1891": {"vr": "OB", "BinaryLength": 16424},
        "1892": {"vr": "OB", "BinaryLength": 16428},
        "1893": {"vr": "OB", "BinaryLength": 16424},
        "1894": {"vr": "OB", "BinaryLength": 16432},
        "1895": {"vr": "OB", "BinaryLength": 16432},
        "1896": {"vr": "OB", "BinaryLength": 16428},
        "1897": {"vr": "OB", "BinaryLength": 16428},
        "1898": {"vr": "OB", "BinaryLength": 16428},
        "1899": {"vr": "OB", "BinaryLength": 16416},
        "1900": {"vr": "OB", "BinaryLength": 16412},
        "1901": {"vr": "OB", "BinaryLength": 16416},
        "1902": {"vr": "OB", "BinaryLength": 16432},
        "1903": {"vr": "OB", "BinaryLength": 16428},
        "1904": {"vr": "OB", "BinaryLength": 16424},
        "1905": {"vr": "OB", "BinaryLength": 16428},
        "1906": {"vr": "OB", "BinaryLength": 16428},
        "1907": {"vr": "OB", "BinaryLength": 16432},
        "1908": {"vr": "OB", "BinaryLength": 16424},
        "1909": {"vr": "OB", "BinaryLength": 15624},
        "1910": {"vr": "OB", "BinaryLength": 16428},
        "1911": {"vr": "OB", "BinaryLength": 16424},
        "1912": {"vr": "OB", "BinaryLength": 16416},
        "1913": {"vr": "OB", "BinaryLength": 16424},
        "1914": {"vr": "OB", "BinaryLength": 15624},
        "1915": {"vr": "OB", "BinaryLength": 15616},
        "1916": {"vr": "OB", "BinaryLength": 15624},
        "1917": {"vr": "OB", "BinaryLength": 16432},
        "1918": {"vr": "OB", "BinaryLength": 15628},
        "1919": {"vr": "OB", "BinaryLength": 16412},
        "1920": {"vr": "OB", "BinaryLength": 15628},
        "1921": {"vr": "OB", "BinaryLength": 16428},
        "1922": {"vr": "OB", "BinaryLength": 16428},
        "1923": {"vr": "OB", "BinaryLength": 16424},
        "1924": {"vr": "OB", "BinaryLength": 16424},
        "1925": {"vr": "OB", "BinaryLength": 16424},
        "1926": {"vr": "OB", "BinaryLength": 16416},
        "1927": {"vr": "OB", "BinaryLength": 16428},
        "1928": {"vr": "OB", "BinaryLength": 16424},
        "1929": {"vr": "OB", "BinaryLength": 16428},
        "1930": {"vr": "OB", "BinaryLength": 16428},
        "1931": {"vr": "OB", "BinaryLength": 16424},
        "1932": {"vr": "OB", "BinaryLength": 16424},
        "1933": {"vr": "OB", "BinaryLength": 15624},
        "1934": {"vr": "OB", "BinaryLength": 16424},
        "1935": {"vr": "OB", "BinaryLength": 16416},
        "1936": {"vr": "OB", "BinaryLength": 16424},
        "1937": {"vr": "OB", "BinaryLength": 16428},
        "1938": {"vr": "OB", "BinaryLength": 16428},
        "1939": {"vr": "OB", "BinaryLength": 16432},
        "1940": {"vr": "OB", "BinaryLength": 16424},
        "1941": {"vr": "OB", "BinaryLength": 16428},
        "1942": {"vr": "OB", "BinaryLength": 16428},
        "1943": {"vr": "OB", "BinaryLength": 16416},
        "1944": {"vr": "OB", "BinaryLength": 16428},
        "1945": {"vr": "OB", "BinaryLength": 16432},
        "1946": {"vr": "OB", "BinaryLength": 16432},
        "1947": {"vr": "OB", "BinaryLength": 16428},
        "1948": {"vr": "OB", "BinaryLength": 16416},
        "1949": {"vr": "OB", "BinaryLength": 15624},
        "1950": {"vr": "OB", "BinaryLength": 16428},
        "1951": {"vr": "OB", "BinaryLength": 16428},
        "1952": {"vr": "OB", "BinaryLength": 16416},
        "1953": {"vr": "OB", "BinaryLength": 16428},
        "1954": {"vr": "OB", "BinaryLength": 16424},
        "1955": {"vr": "OB", "BinaryLength": 16428},
        "1956": {"vr": "OB", "BinaryLength": 16424},
        "1957": {"vr": "OB", "BinaryLength": 16424},
        "1958": {"vr": "OB", "BinaryLength": 16428},
        "1959": {"vr": "OB", "BinaryLength": 16428},
        "1960": {"vr": "OB", "BinaryLength": 16424},
        "1961": {"vr": "OB", "BinaryLength": 15616},
        "1962": {"vr": "OB", "BinaryLength": 16428},
        "1963": {"vr": "OB", "BinaryLength": 16416},
        "1964": {"vr": "OB", "BinaryLength": 16428},
        "1965": {"vr": "OB", "BinaryLength": 16428},
        "1966": {"vr": "OB", "BinaryLength": 16428},
        "1967": {"vr": "OB", "BinaryLength": 15628},
        "1968": {"vr": "OB", "BinaryLength": 16432},
        "1969": {"vr": "OB", "BinaryLength": 16428},
        "1970": {"vr": "OB", "BinaryLength": 16424},
        "1971": {"vr": "OB", "BinaryLength": 16424},
        "1972": {"vr": "OB", "BinaryLength": 16428},
        "1973": {"vr": "OB", "BinaryLength": 15628},
        "1974": {"vr": "OB", "BinaryLength": 16424},
        "1975": {"vr": "OB", "BinaryLength": 16432},
        "1976": {"vr": "OB", "BinaryLength": 16424},
        "1977": {"vr": "OB", "BinaryLength": 16428},
        "1978": {"vr": "OB", "BinaryLength": 16424},
        "1979": {"vr": "OB", "BinaryLength": 16428},
        "1980": {"vr": "OB", "BinaryLength": 16424},
        "1981": {"vr": "OB", "BinaryLength": 16424},
        "1982": {"vr": "OB", "BinaryLength": 16428},
        "1983": {"vr": "OB", "BinaryLength": 16428},
        "1984": {"vr": "OB", "BinaryLength": 16416},
        "1985": {"vr": "OB", "BinaryLength": 16428},
        "1986": {"vr": "OB", "BinaryLength": 15624},
        "1987": {"vr": "OB", "BinaryLength": 16428},
        "1988": {"vr": "OB", "BinaryLength": 16412},
        "1989": {"vr": "OB", "BinaryLength": 16432},
        "1990": {"vr": "OB", "BinaryLength": 16428},
        "1991": {"vr": "OB", "BinaryLength": 16428},
        "1992": {"vr": "OB", "BinaryLength": 16428},
        "1993": {"vr": "OB", "BinaryLength": 15624},
        "1994": {"vr": "OB", "BinaryLength": 16428},
        "1995": {"vr": "OB", "BinaryLength": 16428},
        "1996": {"vr": "OB", "BinaryLength": 15628},
        "1997": {"vr": "OB", "BinaryLength": 16412},
        "1998": {"vr": "OB", "BinaryLength": 16428},
        "1999": {"vr": "OB", "BinaryLength": 16428},
        "2000": {"vr": "OB", "BinaryLength": 16424},
        "2001": {"vr": "OB", "BinaryLength": 15624},
        "2002": {"vr": "OB", "BinaryLength": 16428},
        "2003": {"vr": "OB", "BinaryLength": 16416},
        "2004": {"vr": "OB", "BinaryLength": 16428},
        "2005": {"vr": "OB", "BinaryLength": 16416},
        "2006": {"vr": "OB", "BinaryLength": 16432},
        "2007": {"vr": "OB", "BinaryLength": 16424},
        "2008": {"vr": "OB", "BinaryLength": 16412},
        "2009": {"vr": "OB", "BinaryLength": 16412},
        "2010": {"vr": "OB", "BinaryLength": 16408},
        "2011": {"vr": "OB", "BinaryLength": 16428},
        "2012": {"vr": "OB", "BinaryLength": 15616},
        "2013": {"vr": "OB", "BinaryLength": 16428},
        "2014": {"vr": "OB", "BinaryLength": 16424},
        "2015": {"vr": "OB", "BinaryLength": 16428},
        "2016": {"vr": "OB", "BinaryLength": 16432},
        "2017": {"vr": "OB", "BinaryLength": 15624},
        "2018": {"vr": "OB", "BinaryLength": 16416},
        "2019": {"vr": "OB", "BinaryLength": 16432},
        "2020": {"vr": "OB", "BinaryLength": 16428},
        "2021": {"vr": "OB", "BinaryLength": 16428},
        "2022": {"vr": "OB", "BinaryLength": 16432},
        "2023": {"vr": "OB", "BinaryLength": 16428},
        "2024": {"vr": "OB", "BinaryLength": 16428},
        "2025": {"vr": "OB", "BinaryLength": 15624},
        "2026": {"vr": "OB", "BinaryLength": 16424},
        "2027": {"vr": "OB", "BinaryLength": 16424},
        "2028": {"vr": "OB", "BinaryLength": 16428},
        "2029": {"vr": "OB", "BinaryLength": 15624},
        "2030": {"vr": "OB", "BinaryLength": 16412},
        "2031": {"vr": "OB", "BinaryLength": 16424},
        "2032": {"vr": "OB", "BinaryLength": 16408},
        "2033": {"vr": "OB", "BinaryLength": 16428},
        "2034": {"vr": "OB", "BinaryLength": 16428},
        "2035": {"vr": "OB", "BinaryLength": 16428},
        "2036": {"vr": "OB", "BinaryLength": 16424},
        "2037": {"vr": "OB", "BinaryLength": 16424},
        "2038": {"vr": "OB", "BinaryLength": 16424},
        "2039": {"vr": "OB", "BinaryLength": 16428},
        "2040": {"vr": "OB", "BinaryLength": 16416},
        "2041": {"vr": "OB", "BinaryLength": 16428},
        "2042": {"vr": "OB", "BinaryLength": 16416},
        "2043": {"vr": "OB", "BinaryLength": 16428},
        "2044": {"vr": "OB", "BinaryLength": 16424},
        "2045": {"vr": "OB", "BinaryLength": 16424},
        "2046": {"vr": "OB", "BinaryLength": 16424},
        "2047": {"vr": "OB", "BinaryLength": 16432},
        "2048": {"vr": "OB", "BinaryLength": 16428},
        "2049": {"vr": "OB", "BinaryLength": 16432},
        "2050": {"vr": "OB", "BinaryLength": 16424},
        "2051": {"vr": "OB", "BinaryLength": 16424},
        "2052": {"vr": "OB", "BinaryLength": 16424},
        "2053": {"vr": "OB", "BinaryLength": 16428},
        "2054": {"vr": "OB", "BinaryLength": 16432},
        "2055": {"vr": "OB", "BinaryLength": 16424},
        "2056": {"vr": "OB", "BinaryLength": 16416},
        "2057": {"vr": "OB", "BinaryLength": 16428},
        "2058": {"vr": "OB", "BinaryLength": 16412},
        "2059": {"vr": "OB", "BinaryLength": 16432},
        "2060": {"vr": "OB", "BinaryLength": 16412},
        "2061": {"vr": "OB", "BinaryLength": 16416},
        "2062": {"vr": "OB", "BinaryLength": 16428},
        "2063": {"vr": "OB", "BinaryLength": 16424},
        "2064": {"vr": "OB", "BinaryLength": 15624},
        "2065": {"vr": "OB", "BinaryLength": 16428},
        "2066": {"vr": "OB", "BinaryLength": 16424},
        "2067": {"vr": "OB", "BinaryLength": 16424},
        "2068": {"vr": "OB", "BinaryLength": 16424},
        "2069": {"vr": "OB", "BinaryLength": 16428},
        "2070": {"vr": "OB", "BinaryLength": 16428},
        "2071": {"vr": "OB", "BinaryLength": 16428},
        "2072": {"vr": "OB", "BinaryLength": 16432},
        "2073": {"vr": "OB", "BinaryLength": 16424},
        "2074": {"vr": "OB", "BinaryLength": 16424},
        "2075": {"vr": "OB", "BinaryLength": 15624},
        "2076": {"vr": "OB", "BinaryLength": 16428},
        "2077": {"vr": "OB", "BinaryLength": 16424},
        "2078": {"vr": "OB", "BinaryLength": 16424},
        "2079": {"vr": "OB", "BinaryLength": 15624},
        "2080": {"vr": "OB", "BinaryLength": 16424},
        "2081": {"vr": "OB", "BinaryLength": 16428},
        "2082": {"vr": "OB", "BinaryLength": 15628},
        "2083": {"vr": "OB", "BinaryLength": 15624},
        "2084": {"vr": "OB", "BinaryLength": 15624},
        "2085": {"vr": "OB", "BinaryLength": 16432},
        "2086": {"vr": "OB", "BinaryLength": 15624},
        "2087": {"vr": "OB", "BinaryLength": 16432},
        "2088": {"vr": "OB", "BinaryLength": 16424},
        "2089": {"vr": "OB", "BinaryLength": 16424},
        "2090": {"vr": "OB", "BinaryLength": 16428},
        "2091": {"vr": "OB", "BinaryLength": 16428},
        "2092": {"vr": "OB", "BinaryLength": 16428},
        "2093": {"vr": "OB", "BinaryLength": 16412},
        "2094": {"vr": "OB", "BinaryLength": 16428},
        "2095": {"vr": "OB", "BinaryLength": 16428},
        "2096": {"vr": "OB", "BinaryLength": 16412},
        "2097": {"vr": "OB", "BinaryLength": 16412},
        "2098": {"vr": "OB", "BinaryLength": 15612},
        "2099": {"vr": "OB", "BinaryLength": 16424},
        "2100": {"vr": "OB", "BinaryLength": 16428},
        "2101": {"vr": "OB", "BinaryLength": 16428},
        "2102": {"vr": "OB", "BinaryLength": 16424},
        "2103": {"vr": "OB", "BinaryLength": 16396},
        "2104": {"vr": "OB", "BinaryLength": 16424},
        "2105": {"vr": "OB", "BinaryLength": 16424},
        "2106": {"vr": "OB", "BinaryLength": 16424},
        "2107": {"vr": "OB", "BinaryLength": 16428},
        "2108": {"vr": "OB", "BinaryLength": 16416},
        "2109": {"vr": "OB", "BinaryLength": 15624},
        "2110": {"vr": "OB", "BinaryLength": 16428},
        "2111": {"vr": "OB", "BinaryLength": 16412},
        "2112": {"vr": "OB", "BinaryLength": 16424},
        "2113": {"vr": "OB", "BinaryLength": 16424},
        "2114": {"vr": "OB", "BinaryLength": 16424},
        "2115": {"vr": "OB", "BinaryLength": 16424},
        "2116": {"vr": "OB", "BinaryLength": 16428},
        "2117": {"vr": "OB", "BinaryLength": 16424},
        "2118": {"vr": "OB", "BinaryLength": 16428},
        "2119": {"vr": "OB", "BinaryLength": 16428},
        "2120": {"vr": "OB", "BinaryLength": 16412},
        "2121": {"vr": "OB", "BinaryLength": 16416},
        "2122": {"vr": "OB", "BinaryLength": 16396},
        "2123": {"vr": "OB", "BinaryLength": 16408},
        "2124": {"vr": "OB", "BinaryLength": 16428},
        "2125": {"vr": "OB", "BinaryLength": 16424},
        "2126": {"vr": "OB", "BinaryLength": 16416},
        "2127": {"vr": "OB", "BinaryLength": 16428},
        "2128": {"vr": "OB", "BinaryLength": 16424},
        "2129": {"vr": "OB", "BinaryLength": 16416},
        "2130": {"vr": "OB", "BinaryLength": 16428},
        "2131": {"vr": "OB", "BinaryLength": 16428},
        "2132": {"vr": "OB", "BinaryLength": 15624},
        "2133": {"vr": "OB", "BinaryLength": 16424},
        "2134": {"vr": "OB", "BinaryLength": 16412},
        "2135": {"vr": "OB", "BinaryLength": 16432},
        "2136": {"vr": "OB", "BinaryLength": 16424},
        "2137": {"vr": "OB", "BinaryLength": 16432},
        "2138": {"vr": "OB", "BinaryLength": 16424},
        "2139": {"vr": "OB", "BinaryLength": 16428},
        "2140": {"vr": "OB", "BinaryLength": 16428},
        "2141": {"vr": "OB", "BinaryLength": 16428},
        "2142": {"vr": "OB", "BinaryLength": 16428},
        "2143": {"vr": "OB", "BinaryLength": 16428},
        "2144": {"vr": "OB", "BinaryLength": 16424},
        "2145": {"vr": "OB", "BinaryLength": 16428},
        "2146": {"vr": "OB", "BinaryLength": 15624},
        "2147": {"vr": "OB", "BinaryLength": 16408},
        "2148": {"vr": "OB", "BinaryLength": 16412},
        "2149": {"vr": "OB", "BinaryLength": 16428},
        "2150": {"vr": "OB", "BinaryLength": 16428},
        "2151": {"vr": "OB", "BinaryLength": 16428},
        "2152": {"vr": "OB", "BinaryLength": 16412},
        "2153": {"vr": "OB", "BinaryLength": 16428},
        "2154": {"vr": "OB", "BinaryLength": 16428},
        "2155": {"vr": "OB", "BinaryLength": 16424},
        "2156": {"vr": "OB", "BinaryLength": 16424},
        "2157": {"vr": "OB", "BinaryLength": 16428},
        "2158": {"vr": "OB", "BinaryLength": 15624},
        "2159": {"vr": "OB", "BinaryLength": 16432},
        "2160": {"vr": "OB", "BinaryLength": 16428},
        "2161": {"vr": "OB", "BinaryLength": 16424},
        "2162": {"vr": "OB", "BinaryLength": 16412},
        "2163": {"vr": "OB", "BinaryLength": 16428},
        "2164": {"vr": "OB", "BinaryLength": 16428},
        "2165": {"vr": "OB", "BinaryLength": 15624},
        "2166": {"vr": "OB", "BinaryLength": 16428},
        "2167": {"vr": "OB", "BinaryLength": 16424},
        "2168": {"vr": "OB", "BinaryLength": 16428},
        "2169": {"vr": "OB", "BinaryLength": 16424},
        "2170": {"vr": "OB", "BinaryLength": 15624},
        "2171": {"vr": "OB", "BinaryLength": 16428},
        "2172": {"vr": "OB", "BinaryLength": 16416},
        "2173": {"vr": "OB", "BinaryLength": 16428},
        "2174": {"vr": "OB", "BinaryLength": 15624},
        "2175": {"vr": "OB", "BinaryLength": 16424},
        "2176": {"vr": "OB", "BinaryLength": 16428},
        "2177": {"vr": "OB", "BinaryLength": 16412},
        "2178": {"vr": "OB", "BinaryLength": 16416},
        "2179": {"vr": "OB", "BinaryLength": 16432},
        "2180": {"vr": "OB", "BinaryLength": 16416},
        "2181": {"vr": "OB", "BinaryLength": 16424},
        "2182": {"vr": "OB", "BinaryLength": 16428},
        "2183": {"vr": "OB", "BinaryLength": 16416},
        "2184": {"vr": "OB", "BinaryLength": 16432},
        "2185": {"vr": "OB", "BinaryLength": 16428},
        "2186": {"vr": "OB", "BinaryLength": 16424},
        "2187": {"vr": "OB", "BinaryLength": 15624},
        "2188": {"vr": "OB", "BinaryLength": 16416},
        "2189": {"vr": "OB", "BinaryLength": 16424},
        "2190": {"vr": "OB", "BinaryLength": 16428},
        "2191": {"vr": "OB", "BinaryLength": 16424},
        "2192": {"vr": "OB", "BinaryLength": 15628},
        "2193": {"vr": "OB", "BinaryLength": 16424},
        "2194": {"vr": "OB", "BinaryLength": 16416},
        "2195": {"vr": "OB", "BinaryLength": 16424},
        "2196": {"vr": "OB", "BinaryLength": 16428},
        "2197": {"vr": "OB", "BinaryLength": 16428},
        "2198": {"vr": "OB", "BinaryLength": 16428},
        "2199": {"vr": "OB", "BinaryLength": 16428},
        "2200": {"vr": "OB", "BinaryLength": 16416},
        "2201": {"vr": "OB", "BinaryLength": 16424},
        "2202": {"vr": "OB", "BinaryLength": 16424},
        "2203": {"vr": "OB", "BinaryLength": 16428},
        "2204": {"vr": "OB", "BinaryLength": 15624},
        "2205": {"vr": "OB", "BinaryLength": 16424},
        "2206": {"vr": "OB", "BinaryLength": 16432},
        "2207": {"vr": "OB", "BinaryLength": 16424},
        "2208": {"vr": "OB", "BinaryLength": 16412},
        "2209": {"vr": "OB", "BinaryLength": 16432},
        "2210": {"vr": "OB", "BinaryLength": 16428},
        "2211": {"vr": "OB", "BinaryLength": 16424},
        "2212": {"vr": "OB", "BinaryLength": 16428},
        "2213": {"vr": "OB", "BinaryLength": 16428},
        "2214": {"vr": "OB", "BinaryLength": 16424},
        "2215": {"vr": "OB", "BinaryLength": 16416},
        "2216": {"vr": "OB", "BinaryLength": 16428},
        "2217": {"vr": "OB", "BinaryLength": 16424},
        "2218": {"vr": "OB", "BinaryLength": 16424},
        "2219": {"vr": "OB", "BinaryLength": 16428},
        "2220": {"vr": "OB", "BinaryLength": 15624},
        "2221": {"vr": "OB", "BinaryLength": 16424},
        "2222": {"vr": "OB", "BinaryLength": 16428},
        "2223": {"vr": "OB", "BinaryLength": 16416},
        "2224": {"vr": "OB", "BinaryLength": 16424},
        "2225": {"vr": "OB", "BinaryLength": 16428},
        "2226": {"vr": "OB", "BinaryLength": 16432},
        "2227": {"vr": "OB", "BinaryLength": 16416},
        "2228": {"vr": "OB", "BinaryLength": 16416},
        "2229": {"vr": "OB", "BinaryLength": 16428},
        "2230": {"vr": "OB", "BinaryLength": 16428},
        "2231": {"vr": "OB", "BinaryLength": 16428},
        "2232": {"vr": "OB", "BinaryLength": 16428},
        "2233": {"vr": "OB", "BinaryLength": 16412},
        "2234": {"vr": "OB", "BinaryLength": 16424},
        "2235": {"vr": "OB", "BinaryLength": 16428},
        "2236": {"vr": "OB", "BinaryLength": 16428},
        "2237": {"vr": "OB", "BinaryLength": 16428},
        "2238": {"vr": "OB", "BinaryLength": 16428},
        "2239": {"vr": "OB", "BinaryLength": 15624},
        "2240": {"vr": "OB", "BinaryLength": 16424},
        "2241": {"vr": "OB", "BinaryLength": 16424},
        "2242": {"vr": "OB", "BinaryLength": 16428},
        "2243": {"vr": "OB", "BinaryLength": 16424},
        "2244": {"vr": "OB", "BinaryLength": 16424},
        "2245": {"vr": "OB", "BinaryLength": 16428},
        "2246": {"vr": "OB", "BinaryLength": 16400},
        "2247": {"vr": "OB", "BinaryLength": 16432},
        "2248": {"vr": "OB", "BinaryLength": 16424},
        "2249": {"vr": "OB", "BinaryLength": 16416},
        "2250": {"vr": "OB", "BinaryLength": 16428},
        "2251": {"vr": "OB", "BinaryLength": 16424},
        "2252": {"vr": "OB", "BinaryLength": 16396},
        "2253": {"vr": "OB", "BinaryLength": 16416},
        "2254": {"vr": "OB", "BinaryLength": 15624},
        "2255": {"vr": "OB", "BinaryLength": 16428},
        "2256": {"vr": "OB", "BinaryLength": 16412},
        "2257": {"vr": "OB", "BinaryLength": 16424},
        "2258": {"vr": "OB", "BinaryLength": 16408},
        "2259": {"vr": "OB", "BinaryLength": 15624},
        "2260": {"vr": "OB", "BinaryLength": 16424},
        "2261": {"vr": "OB", "BinaryLength": 16424},
        "2262": {"vr": "OB", "BinaryLength": 16428},
        "2263": {"vr": "OB", "BinaryLength": 15628},
        "2264": {"vr": "OB", "BinaryLength": 16424},
        "2265": {"vr": "OB", "BinaryLength": 16428},
        "2266": {"vr": "OB", "BinaryLength": 16432},
        "2267": {"vr": "OB", "BinaryLength": 16428},
        "2268": {"vr": "OB", "BinaryLength": 16428},
        "2269": {"vr": "OB", "BinaryLength": 16408},
        "2270": {"vr": "OB", "BinaryLength": 16424},
        "2271": {"vr": "OB", "BinaryLength": 16428},
        "2272": {"vr": "OB", "BinaryLength": 16428},
        "2273": {"vr": "OB", "BinaryLength": 16424},
        "2274": {"vr": "OB", "BinaryLength": 16416},
        "2275": {"vr": "OB", "BinaryLength": 16424},
        "2276": {"vr": "OB", "BinaryLength": 16432},
        "2277": {"vr": "OB", "BinaryLength": 16424},
        "2278": {"vr": "OB", "BinaryLength": 15628},
        "2279": {"vr": "OB", "BinaryLength": 16432},
        "2280": {"vr": "OB", "BinaryLength": 16424},
        "2281": {"vr": "OB", "BinaryLength": 16428},
        "2282": {"vr": "OB", "BinaryLength": 16428},
        "2283": {"vr": "OB", "BinaryLength": 16428},
        "2284": {"vr": "OB", "BinaryLength": 16432},
        "2285": {"vr": "OB", "BinaryLength": 16432},
        "2286": {"vr": "OB", "BinaryLength": 16428},
        "2287": {"vr": "OB", "BinaryLength": 15616},
        "2288": {"vr": "OB", "BinaryLength": 16412},
        "2289": {"vr": "OB", "BinaryLength": 16408},
        "2290": {"vr": "OB", "BinaryLength": 16424},
        "2291": {"vr": "OB", "BinaryLength": 15624},
        "2292": {"vr": "OB", "BinaryLength": 16428},
        "2293": {"vr": "OB", "BinaryLength": 16428},
        "2294": {"vr": "OB", "BinaryLength": 16424},
        "2295": {"vr": "OB", "BinaryLength": 15624},
        "2296": {"vr": "OB", "BinaryLength": 15628},
        "2297": {"vr": "OB", "BinaryLength": 16428},
        "2298": {"vr": "OB", "BinaryLength": 16428},
        "2299": {"vr": "OB", "BinaryLength": 16432},
        "2300": {"vr": "OB", "BinaryLength": 16424},
        "2301": {"vr": "OB", "BinaryLength": 16416},
        "2302": {"vr": "OB", "BinaryLength": 16428},
        "2303": {"vr": "OB", "BinaryLength": 16428},
        "2304": {"vr": "OB", "BinaryLength": 16416},
        "2305": {"vr": "OB", "BinaryLength": 16396},
        "2306": {"vr": "OB", "BinaryLength": 16416},
        "2307": {"vr": "OB", "BinaryLength": 16428},
        "2308": {"vr": "OB", "BinaryLength": 16428},
        "2309": {"vr": "OB", "BinaryLength": 16424},
        "2310": {"vr": "OB", "BinaryLength": 16428},
        "2311": {"vr": "OB", "BinaryLength": 16428},
        "2312": {"vr": "OB", "BinaryLength": 16424},
        "2313": {"vr": "OB", "BinaryLength": 15616},
        "2314": {"vr": "OB", "BinaryLength": 16432},
        "2315": {"vr": "OB", "BinaryLength": 16416},
        "2316": {"vr": "OB", "BinaryLength": 16400},
        "2317": {"vr": "OB", "BinaryLength": 16428},
        "2318": {"vr": "OB", "BinaryLength": 16432},
        "2319": {"vr": "OB", "BinaryLength": 16428},
        "2320": {"vr": "OB", "BinaryLength": 16424},
        "2321": {"vr": "OB", "BinaryLength": 16428},
        "2322": {"vr": "OB", "BinaryLength": 16424},
        "2323": {"vr": "OB", "BinaryLength": 16428},
        "2324": {"vr": "OB", "BinaryLength": 16424},
        "2325": {"vr": "OB", "BinaryLength": 16432},
        "2326": {"vr": "OB", "BinaryLength": 16428},
        "2327": {"vr": "OB", "BinaryLength": 16428},
        "2328": {"vr": "OB", "BinaryLength": 16424},
        "2329": {"vr": "OB", "BinaryLength": 16428},
        "2330": {"vr": "OB", "BinaryLength": 16432},
        "2331": {"vr": "OB", "BinaryLength": 16428},
        "2332": {"vr": "OB", "BinaryLength": 16424},
        "2333": {"vr": "OB", "BinaryLength": 16428},
        "2334": {"vr": "OB", "BinaryLength": 16424},
        "2335": {"vr": "OB", "BinaryLength": 16428},
        "2336": {"vr": "OB", "BinaryLength": 16412},
        "2337": {"vr": "OB", "BinaryLength": 16428},
        "2338": {"vr": "OB", "BinaryLength": 16424},
        "2339": {"vr": "OB", "BinaryLength": 16428},
        "2340": {"vr": "OB", "BinaryLength": 15624},
        "2341": {"vr": "OB", "BinaryLength": 16432},
        "2342": {"vr": "OB", "BinaryLength": 16424},
        "2343": {"vr": "OB", "BinaryLength": 16424},
        "2344": {"vr": "OB", "BinaryLength": 16428},
        "2345": {"vr": "OB", "BinaryLength": 16424},
        "2346": {"vr": "OB", "BinaryLength": 15628},
        "2347": {"vr": "OB", "BinaryLength": 16412},
        "2348": {"vr": "OB", "BinaryLength": 16428},
        "2349": {"vr": "OB", "BinaryLength": 16432},
        "2350": {"vr": "OB", "BinaryLength": 16424},
        "2351": {"vr": "OB", "BinaryLength": 16428},
        "2352": {"vr": "OB", "BinaryLength": 16424},
        "2353": {"vr": "OB", "BinaryLength": 16428},
        "2354": {"vr": "OB", "BinaryLength": 16416},
        "2355": {"vr": "OB", "BinaryLength": 16396},
        "2356": {"vr": "OB", "BinaryLength": 16432},
        "2357": {"vr": "OB", "BinaryLength": 16428},
        "2358": {"vr": "OB", "BinaryLength": 16432},
        "2359": {"vr": "OB", "BinaryLength": 15624},
        "2360": {"vr": "OB", "BinaryLength": 15624},
        "2361": {"vr": "OB", "BinaryLength": 16412},
        "2362": {"vr": "OB", "BinaryLength": 16424},
        "2363": {"vr": "OB", "BinaryLength": 16428},
        "2364": {"vr": "OB", "BinaryLength": 16416},
        "2365": {"vr": "OB", "BinaryLength": 16412},
        "2366": {"vr": "OB", "BinaryLength": 16428},
        "2367": {"vr": "OB", "BinaryLength": 16428},
        "2368": {"vr": "OB", "BinaryLength": 16424},
        "2369": {"vr": "OB", "BinaryLength": 15616},
        "2370": {"vr": "OB", "BinaryLength": 16424},
        "2371": {"vr": "OB", "BinaryLength": 16428},
        "2372": {"vr": "OB", "BinaryLength": 16428},
        "2373": {"vr": "OB", "BinaryLength": 16416},
        "2374": {"vr": "OB", "BinaryLength": 16412},
        "2375": {"vr": "OB", "BinaryLength": 16428},
        "2376": {"vr": "OB", "BinaryLength": 15624},
        "2377": {"vr": "OB", "BinaryLength": 16416},
        "2378": {"vr": "OB", "BinaryLength": 16416},
        "2379": {"vr": "OB", "BinaryLength": 16424},
        "2380": {"vr": "OB", "BinaryLength": 16416},
        "2381": {"vr": "OB", "BinaryLength": 15624},
        "2382": {"vr": "OB", "BinaryLength": 15628},
        "2383": {"vr": "OB", "BinaryLength": 16424},
        "2384": {"vr": "OB", "BinaryLength": 16432},
        "2385": {"vr": "OB", "BinaryLength": 15628},
        "2386": {"vr": "OB", "BinaryLength": 16416},
        "2387": {"vr": "OB", "BinaryLength": 16424},
        "2388": {"vr": "OB", "BinaryLength": 16428},
        "2389": {"vr": "OB", "BinaryLength": 16412},
        "2390": {"vr": "OB", "BinaryLength": 16416},
        "2391": {"vr": "OB", "BinaryLength": 16428},
        "2392": {"vr": "OB", "BinaryLength": 16424},
        "2393": {"vr": "OB", "BinaryLength": 16424},
        "2394": {"vr": "OB", "BinaryLength": 15624},
        "2395": {"vr": "OB", "BinaryLength": 16428},
        "2396": {"vr": "OB", "BinaryLength": 16424},
        "2397": {"vr": "OB", "BinaryLength": 16416},
        "2398": {"vr": "OB", "BinaryLength": 16428},
        "2399": {"vr": "OB", "BinaryLength": 16416},
        "2400": {"vr": "OB", "BinaryLength": 15628},
        "2401": {"vr": "OB", "BinaryLength": 16424},
        "2402": {"vr": "OB", "BinaryLength": 16424},
        "2403": {"vr": "OB", "BinaryLength": 16428},
        "2404": {"vr": "OB", "BinaryLength": 16428},
        "2405": {"vr": "OB", "BinaryLength": 16424},
        "2406": {"vr": "OB", "BinaryLength": 16408},
        "2407": {"vr": "OB", "BinaryLength": 16424},
        "2408": {"vr": "OB", "BinaryLength": 16424},
        "2409": {"vr": "OB", "BinaryLength": 16428},
        "2410": {"vr": "OB", "BinaryLength": 16428},
        "2411": {"vr": "OB", "BinaryLength": 16428},
        "2412": {"vr": "OB", "BinaryLength": 16432},
        "2413": {"vr": "OB", "BinaryLength": 16424},
        "2414": {"vr": "OB", "BinaryLength": 16424},
        "2415": {"vr": "OB", "BinaryLength": 16424},
        "2416": {"vr": "OB", "BinaryLength": 16416},
        "2417": {"vr": "OB", "BinaryLength": 15624},
        "2418": {"vr": "OB", "BinaryLength": 15624},
        "2419": {"vr": "OB", "BinaryLength": 16424},
        "2420": {"vr": "OB", "BinaryLength": 16428},
        "2421": {"vr": "OB", "BinaryLength": 16424},
        "2422": {"vr": "OB", "BinaryLength": 16428},
        "2423": {"vr": "OB", "BinaryLength": 16400},
        "2424": {"vr": "OB", "BinaryLength": 16416},
        "2425": {"vr": "OB", "BinaryLength": 16432},
        "2426": {"vr": "OB", "BinaryLength": 16416},
        "2427": {"vr": "OB", "BinaryLength": 16432},
        "2428": {"vr": "OB", "BinaryLength": 16428},
        "2429": {"vr": "OB", "BinaryLength": 16424},
        "2430": {"vr": "OB", "BinaryLength": 16424},
        "2431": {"vr": "OB", "BinaryLength": 16416},
        "2432": {"vr": "OB", "BinaryLength": 16416},
        "2433": {"vr": "OB", "BinaryLength": 15624},
        "2434": {"vr": "OB", "BinaryLength": 16424},
        "2435": {"vr": "OB", "BinaryLength": 16416},
        "2436": {"vr": "OB", "BinaryLength": 16412},
        "2437": {"vr": "OB", "BinaryLength": 16428},
        "2438": {"vr": "OB", "BinaryLength": 16428},
        "2439": {"vr": "OB", "BinaryLength": 16416},
        "2440": {"vr": "OB", "BinaryLength": 16424},
        "2441": {"vr": "OB", "BinaryLength": 16416},
        "2442": {"vr": "OB", "BinaryLength": 16424},
        "2443": {"vr": "OB", "BinaryLength": 16424},
        "2444": {"vr": "OB", "BinaryLength": 16432},
        "2445": {"vr": "OB", "BinaryLength": 16424},
        "2446": {"vr": "OB", "BinaryLength": 16412},
        "2447": {"vr": "OB", "BinaryLength": 16428},
        "2448": {"vr": "OB", "BinaryLength": 16432},
        "2449": {"vr": "OB", "BinaryLength": 16416},
        "2450": {"vr": "OB", "BinaryLength": 16428},
        "2451": {"vr": "OB", "BinaryLength": 16424},
        "2452": {"vr": "OB", "BinaryLength": 16424},
        "2453": {"vr": "OB", "BinaryLength": 16428},
        "2454": {"vr": "OB", "BinaryLength": 16428},
        "2455": {"vr": "OB", "BinaryLength": 16428},
        "2456": {"vr": "OB", "BinaryLength": 16424},
        "2457": {"vr": "OB", "BinaryLength": 16428},
        "2458": {"vr": "OB", "BinaryLength": 16428},
        "2459": {"vr": "OB", "BinaryLength": 16432},
        "2460": {"vr": "OB", "BinaryLength": 16428},
        "2461": {"vr": "OB", "BinaryLength": 16428},
        "2462": {"vr": "OB", "BinaryLength": 16428},
        "2463": {"vr": "OB", "BinaryLength": 16416},
        "2464": {"vr": "OB", "BinaryLength": 16428},
        "2465": {"vr": "OB", "BinaryLength": 16432},
        "2466": {"vr": "OB", "BinaryLength": 16424},
        "2467": {"vr": "OB", "BinaryLength": 16424},
        "2468": {"vr": "OB", "BinaryLength": 16416},
        "2469": {"vr": "OB", "BinaryLength": 16428},
        "2470": {"vr": "OB", "BinaryLength": 16416},
        "2471": {"vr": "OB", "BinaryLength": 16428},
        "2472": {"vr": "OB", "BinaryLength": 16428},
        "2473": {"vr": "OB", "BinaryLength": 16428},
        "2474": {"vr": "OB", "BinaryLength": 16396},
        "2475": {"vr": "OB", "BinaryLength": 16428},
        "2476": {"vr": "OB", "BinaryLength": 16428},
        "2477": {"vr": "OB", "BinaryLength": 16428},
        "2478": {"vr": "OB", "BinaryLength": 16416},
        "2479": {"vr": "OB", "BinaryLength": 15624},
        "2480": {"vr": "OB", "BinaryLength": 15624},
        "2481": {"vr": "OB", "BinaryLength": 16416},
        "2482": {"vr": "OB", "BinaryLength": 16428},
        "2483": {"vr": "OB", "BinaryLength": 16424},
        "2484": {"vr": "OB", "BinaryLength": 16424},
        "2485": {"vr": "OB", "BinaryLength": 16428},
        "2486": {"vr": "OB", "BinaryLength": 16424},
        "2487": {"vr": "OB", "BinaryLength": 16416},
        "2488": {"vr": "OB", "BinaryLength": 16428},
        "2489": {"vr": "OB", "BinaryLength": 16428},
        "2490": {"vr": "OB", "BinaryLength": 16428},
        "2491": {"vr": "OB", "BinaryLength": 16416},
        "2492": {"vr": "OB", "BinaryLength": 16424},
        "2493": {"vr": "OB", "BinaryLength": 16428},
        "2494": {"vr": "OB", "BinaryLength": 16428},
        "2495": {"vr": "OB", "BinaryLength": 16428},
        "2496": {"vr": "OB", "BinaryLength": 16424},
        "2497": {"vr": "OB", "BinaryLength": 16424},
        "2498": {"vr": "OB", "BinaryLength": 16428},
        "2499": {"vr": "OB", "BinaryLength": 16424},
        "2500": {"vr": "OB", "BinaryLength": 16428},
        "2501": {"vr": "OB", "BinaryLength": 16428},
        "2502": {"vr": "OB", "BinaryLength": 16428},
        "2503": {"vr": "OB", "BinaryLength": 16416},
        "2504": {"vr": "OB", "BinaryLength": 16428},
        "2505": {"vr": "OB", "BinaryLength": 16428},
        "2506": {"vr": "OB", "BinaryLength": 16432},
        "2507": {"vr": "OB", "BinaryLength": 16428},
        "2508": {"vr": "OB", "BinaryLength": 16424},
        "2509": {"vr": "OB", "BinaryLength": 16428},
        "2510": {"vr": "OB", "BinaryLength": 16428},
        "2511": {"vr": "OB", "BinaryLength": 16424},
        "2512": {"vr": "OB", "BinaryLength": 16424},
        "2513": {"vr": "OB", "BinaryLength": 16428},
        "2514": {"vr": "OB", "BinaryLength": 16428},
        "2515": {"vr": "OB", "BinaryLength": 16412},
        "2516": {"vr": "OB", "BinaryLength": 16412},
        "2517": {"vr": "OB", "BinaryLength": 16428},
        "2518": {"vr": "OB", "BinaryLength": 16424},
        "2519": {"vr": "OB", "BinaryLength": 16428},
        "2520": {"vr": "OB", "BinaryLength": 15628},
        "2521": {"vr": "OB", "BinaryLength": 16416},
        "2522": {"vr": "OB", "BinaryLength": 15624},
        "2523": {"vr": "OB", "BinaryLength": 16416},
        "2524": {"vr": "OB", "BinaryLength": 16424},
        "2525": {"vr": "OB", "BinaryLength": 15628},
        "2526": {"vr": "OB", "BinaryLength": 16424},
        "2527": {"vr": "OB", "BinaryLength": 16424},
        "2528": {"vr": "OB", "BinaryLength": 16424},
        "2529": {"vr": "OB", "BinaryLength": 16428},
        "2530": {"vr": "OB", "BinaryLength": 16424},
        "2531": {"vr": "OB", "BinaryLength": 16428},
        "2532": {"vr": "OB", "BinaryLength": 16424},
        "2533": {"vr": "OB", "BinaryLength": 16424},
        "2534": {"vr": "OB", "BinaryLength": 15624},
        "2535": {"vr": "OB", "BinaryLength": 16428},
        "2536": {"vr": "OB", "BinaryLength": 16428},
        "2537": {"vr": "OB", "BinaryLength": 15624},
        "2538": {"vr": "OB", "BinaryLength": 16424},
        "2539": {"vr": "OB", "BinaryLength": 15628},
        "2540": {"vr": "OB", "BinaryLength": 16416},
        "2541": {"vr": "OB", "BinaryLength": 16424},
        "2542": {"vr": "OB", "BinaryLength": 16432},
        "2543": {"vr": "OB", "BinaryLength": 16432},
        "2544": {"vr": "OB", "BinaryLength": 16408},
        "2545": {"vr": "OB", "BinaryLength": 16428},
        "2546": {"vr": "OB", "BinaryLength": 15624},
        "2547": {"vr": "OB", "BinaryLength": 16412},
        "2548": {"vr": "OB", "BinaryLength": 15624},
        "2549": {"vr": "OB", "BinaryLength": 16424},
        "2550": {"vr": "OB", "BinaryLength": 16428},
        "2551": {"vr": "OB", "BinaryLength": 16424},
        "2552": {"vr": "OB", "BinaryLength": 16428},
        "2553": {"vr": "OB", "BinaryLength": 16424},
        "2554": {"vr": "OB", "BinaryLength": 16424},
        "2555": {"vr": "OB", "BinaryLength": 16428},
        "2556": {"vr": "OB", "BinaryLength": 16428},
        "2557": {"vr": "OB", "BinaryLength": 15624},
        "2558": {"vr": "OB", "BinaryLength": 16416},
        "2559": {"vr": "OB", "BinaryLength": 16428},
        "2560": {"vr": "OB", "BinaryLength": 16428},
        "2561": {"vr": "OB", "BinaryLength": 16428},
        "2562": {"vr": "OB", "BinaryLength": 16424},
        "2563": {"vr": "OB", "BinaryLength": 16428},
        "2564": {"vr": "OB", "BinaryLength": 16424},
        "2565": {"vr": "OB", "BinaryLength": 16416},
        "2566": {"vr": "OB", "BinaryLength": 16428},
        "2567": {"vr": "OB", "BinaryLength": 16428},
        "2568": {"vr": "OB", "BinaryLength": 16432},
        "2569": {"vr": "OB", "BinaryLength": 16416},
        "2570": {"vr": "OB", "BinaryLength": 16428},
        "2571": {"vr": "OB", "BinaryLength": 15628},
        "2572": {"vr": "OB", "BinaryLength": 15624},
        "2573": {"vr": "OB", "BinaryLength": 16424},
        "2574": {"vr": "OB", "BinaryLength": 16416},
        "2575": {"vr": "OB", "BinaryLength": 16424},
        "2576": {"vr": "OB", "BinaryLength": 16424},
        "2577": {"vr": "OB", "BinaryLength": 16424},
        "2578": {"vr": "OB", "BinaryLength": 16400},
        "2579": {"vr": "OB", "BinaryLength": 16396},
        "2580": {"vr": "OB", "BinaryLength": 16412},
        "2581": {"vr": "OB", "BinaryLength": 16432},
        "2582": {"vr": "OB", "BinaryLength": 16428},
        "2583": {"vr": "OB", "BinaryLength": 16424},
        "2584": {"vr": "OB", "BinaryLength": 15624},
        "2585": {"vr": "OB", "BinaryLength": 15624},
        "2586": {"vr": "OB", "BinaryLength": 16416},
        "2587": {"vr": "OB", "BinaryLength": 16432},
        "2588": {"vr": "OB", "BinaryLength": 16396},
        "2589": {"vr": "OB", "BinaryLength": 16412},
        "2590": {"vr": "OB", "BinaryLength": 16428},
        "2591": {"vr": "OB", "BinaryLength": 16428},
        "2592": {"vr": "OB", "BinaryLength": 16428},
        "2593": {"vr": "OB", "BinaryLength": 16428},
        "2594": {"vr": "OB", "BinaryLength": 16428},
        "2595": {"vr": "OB", "BinaryLength": 16432},
        "2596": {"vr": "OB", "BinaryLength": 16424},
        "2597": {"vr": "OB", "BinaryLength": 16428},
        "2598": {"vr": "OB", "BinaryLength": 16428},
        "2599": {"vr": "OB", "BinaryLength": 16432},
        "2600": {"vr": "OB", "BinaryLength": 16424},
        "2601": {"vr": "OB", "BinaryLength": 16424},
        "2602": {"vr": "OB", "BinaryLength": 16424},
        "2603": {"vr": "OB", "BinaryLength": 16424},
        "2604": {"vr": "OB", "BinaryLength": 16428},
        "2605": {"vr": "OB", "BinaryLength": 16424},
        "2606": {"vr": "OB", "BinaryLength": 16428},
        "2607": {"vr": "OB", "BinaryLength": 16424},
        "2608": {"vr": "OB", "BinaryLength": 16428},
        "2609": {"vr": "OB", "BinaryLength": 15628},
        "2610": {"vr": "OB", "BinaryLength": 16424},
        "2611": {"vr": "OB", "BinaryLength": 15624},
        "2612": {"vr": "OB", "BinaryLength": 16428},
        "2613": {"vr": "OB", "BinaryLength": 16424},
        "2614": {"vr": "OB", "BinaryLength": 16428},
        "2615": {"vr": "OB", "BinaryLength": 16432},
        "2616": {"vr": "OB", "BinaryLength": 16424},
        "2617": {"vr": "OB", "BinaryLength": 16428},
        "2618": {"vr": "OB", "BinaryLength": 15628},
        "2619": {"vr": "OB", "BinaryLength": 16424},
        "2620": {"vr": "OB", "BinaryLength": 16428},
        "2621": {"vr": "OB", "BinaryLength": 16428},
        "2622": {"vr": "OB", "BinaryLength": 16428},
        "2623": {"vr": "OB", "BinaryLength": 16424},
        "2624": {"vr": "OB", "BinaryLength": 16428},
        "2625": {"vr": "OB", "BinaryLength": 16424},
        "2626": {"vr": "OB", "BinaryLength": 16412},
        "2627": {"vr": "OB", "BinaryLength": 16416},
        "2628": {"vr": "OB", "BinaryLength": 15624},
        "2629": {"vr": "OB", "BinaryLength": 15624},
        "2630": {"vr": "OB", "BinaryLength": 16428},
        "2631": {"vr": "OB", "BinaryLength": 16424},
        "2632": {"vr": "OB", "BinaryLength": 16428},
        "2633": {"vr": "OB", "BinaryLength": 16428},
        "2634": {"vr": "OB", "BinaryLength": 16428},
        "2635": {"vr": "OB", "BinaryLength": 16416},
        "2636": {"vr": "OB", "BinaryLength": 15628},
        "2637": {"vr": "OB", "BinaryLength": 16428},
        "2638": {"vr": "OB", "BinaryLength": 16400},
        "2639": {"vr": "OB", "BinaryLength": 15624},
        "2640": {"vr": "OB", "BinaryLength": 15616},
        "2641": {"vr": "OB", "BinaryLength": 16408},
        "2642": {"vr": "OB", "BinaryLength": 16428},
        "2643": {"vr": "OB", "BinaryLength": 16416},
        "2644": {"vr": "OB", "BinaryLength": 16428},
        "2645": {"vr": "OB", "BinaryLength": 16416},
        "2646": {"vr": "OB", "BinaryLength": 16424},
        "2647": {"vr": "OB", "BinaryLength": 16432},
        "2648": {"vr": "OB", "BinaryLength": 16428},
        "2649": {"vr": "OB", "BinaryLength": 16428},
        "2650": {"vr": "OB", "BinaryLength": 16428},
        "2651": {"vr": "OB", "BinaryLength": 16428},
        "2652": {"vr": "OB", "BinaryLength": 16424},
        "2653": {"vr": "OB", "BinaryLength": 16428},
        "2654": {"vr": "OB", "BinaryLength": 16428},
        "2655": {"vr": "OB", "BinaryLength": 16416},
        "2656": {"vr": "OB", "BinaryLength": 16416},
        "2657": {"vr": "OB", "BinaryLength": 16432},
        "2658": {"vr": "OB", "BinaryLength": 15624},
        "2659": {"vr": "OB", "BinaryLength": 16428},
        "2660": {"vr": "OB", "BinaryLength": 16424},
        "2661": {"vr": "OB", "BinaryLength": 16416},
        "2662": {"vr": "OB", "BinaryLength": 16428},
        "2663": {"vr": "OB", "BinaryLength": 16416},
        "2664": {"vr": "OB", "BinaryLength": 16424},
        "2665": {"vr": "OB", "BinaryLength": 16424},
        "2666": {"vr": "OB", "BinaryLength": 16416},
        "2667": {"vr": "OB", "BinaryLength": 16424},
        "2668": {"vr": "OB", "BinaryLength": 16424},
        "2669": {"vr": "OB", "BinaryLength": 16412},
        "2670": {"vr": "OB", "BinaryLength": 16424},
        "2671": {"vr": "OB", "BinaryLength": 16424},
        "2672": {"vr": "OB", "BinaryLength": 16424},
        "2673": {"vr": "OB", "BinaryLength": 16416},
        "2674": {"vr": "OB", "BinaryLength": 16424},
        "2675": {"vr": "OB", "BinaryLength": 16416},
        "2676": {"vr": "OB", "BinaryLength": 16424},
        "2677": {"vr": "OB", "BinaryLength": 16424},
        "2678": {"vr": "OB", "BinaryLength": 16428},
        "2679": {"vr": "OB", "BinaryLength": 15624},
        "2680": {"vr": "OB", "BinaryLength": 15616},
        "2681": {"vr": "OB", "BinaryLength": 16428},
        "2682": {"vr": "OB", "BinaryLength": 16424},
        "2683": {"vr": "OB", "BinaryLength": 16428},
        "2684": {"vr": "OB", "BinaryLength": 16424},
        "2685": {"vr": "OB", "BinaryLength": 16428},
        "2686": {"vr": "OB", "BinaryLength": 16428},
        "2687": {"vr": "OB", "BinaryLength": 16428},
        "2688": {"vr": "OB", "BinaryLength": 16428},
        "2689": {"vr": "OB", "BinaryLength": 16428},
        "2690": {"vr": "OB", "BinaryLength": 16428},
        "2691": {"vr": "OB", "BinaryLength": 16412},
        "2692": {"vr": "OB", "BinaryLength": 16424},
        "2693": {"vr": "OB", "BinaryLength": 16428},
        "2694": {"vr": "OB", "BinaryLength": 16424},
        "2695": {"vr": "OB", "BinaryLength": 16432},
        "2696": {"vr": "OB", "BinaryLength": 16416},
        "2697": {"vr": "OB", "BinaryLength": 16428},
        "2698": {"vr": "OB", "BinaryLength": 16428},
        "2699": {"vr": "OB", "BinaryLength": 16428},
        "2700": {"vr": "OB", "BinaryLength": 16416},
        "2701": {"vr": "OB", "BinaryLength": 16424},
        "2702": {"vr": "OB", "BinaryLength": 15624},
        "2703": {"vr": "OB", "BinaryLength": 16428},
        "2704": {"vr": "OB", "BinaryLength": 16428},
        "2705": {"vr": "OB", "BinaryLength": 16412},
        "2706": {"vr": "OB", "BinaryLength": 16412},
        "2707": {"vr": "OB", "BinaryLength": 16424},
        "2708": {"vr": "OB", "BinaryLength": 16432},
        "2709": {"vr": "OB", "BinaryLength": 16416},
        "2710": {"vr": "OB", "BinaryLength": 16428},
        "2711": {"vr": "OB", "BinaryLength": 16428},
        "2712": {"vr": "OB", "BinaryLength": 16428},
        "2713": {"vr": "OB", "BinaryLength": 16428},
        "2714": {"vr": "OB", "BinaryLength": 16424},
        "2715": {"vr": "OB", "BinaryLength": 16428},
        "2716": {"vr": "OB", "BinaryLength": 16428},
        "2717": {"vr": "OB", "BinaryLength": 16424},
        "2718": {"vr": "OB", "BinaryLength": 16400},
        "2719": {"vr": "OB", "BinaryLength": 16416},
        "2720": {"vr": "OB", "BinaryLength": 16428},
        "2721": {"vr": "OB", "BinaryLength": 16428},
        "2722": {"vr": "OB", "BinaryLength": 16428},
        "2723": {"vr": "OB", "BinaryLength": 16416},
        "2724": {"vr": "OB", "BinaryLength": 16428},
        "2725": {"vr": "OB", "BinaryLength": 16432},
        "2726": {"vr": "OB", "BinaryLength": 15624},
        "2727": {"vr": "OB", "BinaryLength": 16424},
        "2728": {"vr": "OB", "BinaryLength": 16428},
        "2729": {"vr": "OB", "BinaryLength": 16428},
        "2730": {"vr": "OB", "BinaryLength": 16424},
        "2731": {"vr": "OB", "BinaryLength": 16428},
        "2732": {"vr": "OB", "BinaryLength": 16428},
        "2733": {"vr": "OB", "BinaryLength": 16424},
        "2734": {"vr": "OB", "BinaryLength": 16428},
        "2735": {"vr": "OB", "BinaryLength": 16408},
        "2736": {"vr": "OB", "BinaryLength": 15624},
        "2737": {"vr": "OB", "BinaryLength": 16428},
        "2738": {"vr": "OB", "BinaryLength": 16396},
        "2739": {"vr": "OB", "BinaryLength": 16416},
        "2740": {"vr": "OB", "BinaryLength": 16428},
        "2741": {"vr": "OB", "BinaryLength": 15624},
        "2742": {"vr": "OB", "BinaryLength": 16412},
        "2743": {"vr": "OB", "BinaryLength": 16416},
        "2744": {"vr": "OB", "BinaryLength": 16424},
        "2745": {"vr": "OB", "BinaryLength": 16400},
        "2746": {"vr": "OB", "BinaryLength": 15624},
        "2747": {"vr": "OB", "BinaryLength": 16424},
        "2748": {"vr": "OB", "BinaryLength": 16428},
        "2749": {"vr": "OB", "BinaryLength": 16428},
        "2750": {"vr": "OB", "BinaryLength": 15624},
        "2751": {"vr": "OB", "BinaryLength": 16428},
        "2752": {"vr": "OB", "BinaryLength": 16432},
        "2753": {"vr": "OB", "BinaryLength": 16396},
        "2754": {"vr": "OB", "BinaryLength": 16416},
        "2755": {"vr": "OB", "BinaryLength": 16428},
        "2756": {"vr": "OB", "BinaryLength": 16424},
        "2757": {"vr": "OB", "BinaryLength": 15624},
        "2758": {"vr": "OB", "BinaryLength": 16424},
        "2759": {"vr": "OB", "BinaryLength": 16416},
        "2760": {"vr": "OB", "BinaryLength": 16424},
        "2761": {"vr": "OB", "BinaryLength": 16424},
        "2762": {"vr": "OB", "BinaryLength": 16432},
        "2763": {"vr": "OB", "BinaryLength": 16412},
        "2764": {"vr": "OB", "BinaryLength": 16424},
        "2765": {"vr": "OB", "BinaryLength": 15624},
        "2766": {"vr": "OB", "BinaryLength": 16428},
        "2767": {"vr": "OB", "BinaryLength": 16428},
        "2768": {"vr": "OB", "BinaryLength": 16428},
        "2769": {"vr": "OB", "BinaryLength": 16416},
        "2770": {"vr": "OB", "BinaryLength": 15624},
        "2771": {"vr": "OB", "BinaryLength": 16416},
        "2772": {"vr": "OB", "BinaryLength": 16412},
        "2773": {"vr": "OB", "BinaryLength": 16424},
        "2774": {"vr": "OB", "BinaryLength": 16428},
        "2775": {"vr": "OB", "BinaryLength": 16396},
        "2776": {"vr": "OB", "BinaryLength": 16424},
        "2777": {"vr": "OB", "BinaryLength": 15628},
        "2778": {"vr": "OB", "BinaryLength": 16428},
        "2779": {"vr": "OB", "BinaryLength": 16428},
        "2780": {"vr": "OB", "BinaryLength": 16416},
        "2781": {"vr": "OB", "BinaryLength": 15624},
        "2782": {"vr": "OB", "BinaryLength": 16424},
        "2783": {"vr": "OB", "BinaryLength": 16416},
        "2784": {"vr": "OB", "BinaryLength": 16424},
        "2785": {"vr": "OB", "BinaryLength": 16432},
        "2786": {"vr": "OB", "BinaryLength": 16428},
        "2787": {"vr": "OB", "BinaryLength": 16428},
        "2788": {"vr": "OB", "BinaryLength": 16428},
        "2789": {"vr": "OB", "BinaryLength": 16428},
        "2790": {"vr": "OB", "BinaryLength": 16428},
        "2791": {"vr": "OB", "BinaryLength": 16432},
        "2792": {"vr": "OB", "BinaryLength": 15624},
        "2793": {"vr": "OB", "BinaryLength": 16424},
        "2794": {"vr": "OB", "BinaryLength": 16424},
        "2795": {"vr": "OB", "BinaryLength": 16428},
        "2796": {"vr": "OB", "BinaryLength": 16424},
        "2797": {"vr": "OB", "BinaryLength": 15624},
        "2798": {"vr": "OB", "BinaryLength": 16432},
        "2799": {"vr": "OB", "BinaryLength": 16416},
        "2800": {"vr": "OB", "BinaryLength": 16428},
        "2801": {"vr": "OB", "BinaryLength": 16428},
        "2802": {"vr": "OB", "BinaryLength": 16428},
        "2803": {"vr": "OB", "BinaryLength": 16428},
        "2804": {"vr": "OB", "BinaryLength": 16424},
        "2805": {"vr": "OB", "BinaryLength": 16416},
        "2806": {"vr": "OB", "BinaryLength": 16416},
        "2807": {"vr": "OB", "BinaryLength": 16428},
        "2808": {"vr": "OB", "BinaryLength": 16416},
        "2809": {"vr": "OB", "BinaryLength": 16424},
        "2810": {"vr": "OB", "BinaryLength": 16424},
        "2811": {"vr": "OB", "BinaryLength": 16412},
        "2812": {"vr": "OB", "BinaryLength": 16428},
        "2813": {"vr": "OB", "BinaryLength": 16432},
        "2814": {"vr": "OB", "BinaryLength": 16416},
        "2815": {"vr": "OB", "BinaryLength": 16416},
        "2816": {"vr": "OB", "BinaryLength": 16424},
        "2817": {"vr": "OB", "BinaryLength": 16428},
        "2818": {"vr": "OB", "BinaryLength": 15624},
        "2819": {"vr": "OB", "BinaryLength": 16416},
        "2820": {"vr": "OB", "BinaryLength": 16428},
        "2821": {"vr": "OB", "BinaryLength": 16416},
        "2822": {"vr": "OB", "BinaryLength": 15624},
        "2823": {"vr": "OB", "BinaryLength": 16428},
        "2824": {"vr": "OB", "BinaryLength": 16428},
        "2825": {"vr": "OB", "BinaryLength": 16428},
        "2826": {"vr": "OB", "BinaryLength": 16412},
        "2827": {"vr": "OB", "BinaryLength": 16428},
        "2828": {"vr": "OB", "BinaryLength": 16428},
        "2829": {"vr": "OB", "BinaryLength": 16428},
        "2830": {"vr": "OB", "BinaryLength": 15624},
        "2831": {"vr": "OB", "BinaryLength": 16424},
        "2832": {"vr": "OB", "BinaryLength": 16428},
        "2833": {"vr": "OB", "BinaryLength": 16428},
        "2834": {"vr": "OB", "BinaryLength": 16428},
        "2835": {"vr": "OB", "BinaryLength": 16424},
        "2836": {"vr": "OB", "BinaryLength": 16424},
        "2837": {"vr": "OB", "BinaryLength": 16412},
        "2838": {"vr": "OB", "BinaryLength": 16428},
        "2839": {"vr": "OB", "BinaryLength": 16424},
        "2840": {"vr": "OB", "BinaryLength": 16428},
        "2841": {"vr": "OB", "BinaryLength": 16424},
        "2842": {"vr": "OB", "BinaryLength": 16428},
        "2843": {"vr": "OB", "BinaryLength": 16424},
        "2844": {"vr": "OB", "BinaryLength": 16424},
        "2845": {"vr": "OB", "BinaryLength": 16428},
        "2846": {"vr": "OB", "BinaryLength": 16428},
        "2847": {"vr": "OB", "BinaryLength": 16428},
        "2848": {"vr": "OB", "BinaryLength": 16428},
        "2849": {"vr": "OB", "BinaryLength": 16416},
        "2850": {"vr": "OB", "BinaryLength": 16428},
        "2851": {"vr": "OB", "BinaryLength": 16428},
        "2852": {"vr": "OB", "BinaryLength": 15624},
        "2853": {"vr": "OB", "BinaryLength": 16432},
        "2854": {"vr": "OB", "BinaryLength": 16424},
        "2855": {"vr": "OB", "BinaryLength": 15616},
        "2856": {"vr": "OB", "BinaryLength": 16424},
        "2857": {"vr": "OB", "BinaryLength": 16424},
        "2858": {"vr": "OB", "BinaryLength": 16432},
        "2859": {"vr": "OB", "BinaryLength": 16428},
        "2860": {"vr": "OB", "BinaryLength": 16416},
        "2861": {"vr": "OB", "BinaryLength": 16424},
        "2862": {"vr": "OB", "BinaryLength": 15616},
        "2863": {"vr": "OB", "BinaryLength": 16428},
        "2864": {"vr": "OB", "BinaryLength": 16424},
        "2865": {"vr": "OB", "BinaryLength": 16428},
        "2866": {"vr": "OB", "BinaryLength": 16428},
        "2867": {"vr": "OB", "BinaryLength": 16424},
        "2868": {"vr": "OB", "BinaryLength": 16424},
        "2869": {"vr": "OB", "BinaryLength": 16424},
        "2870": {"vr": "OB", "BinaryLength": 16428},
        "2871": {"vr": "OB", "BinaryLength": 16400},
        "2872": {"vr": "OB", "BinaryLength": 16424},
        "2873": {"vr": "OB", "BinaryLength": 16424},
        "2874": {"vr": "OB", "BinaryLength": 16424},
        "2875": {"vr": "OB", "BinaryLength": 16428},
        "2876": {"vr": "OB", "BinaryLength": 16428},
        "2877": {"vr": "OB", "BinaryLength": 16428},
        "2878": {"vr": "OB", "BinaryLength": 15628},
        "2879": {"vr": "OB", "BinaryLength": 16432},
        "2880": {"vr": "OB", "BinaryLength": 16432},
        "2881": {"vr": "OB", "BinaryLength": 16428},
        "2882": {"vr": "OB", "BinaryLength": 15624},
        "2883": {"vr": "OB", "BinaryLength": 16424},
        "2884": {"vr": "OB", "BinaryLength": 16412},
        "2885": {"vr": "OB", "BinaryLength": 16424},
        "2886": {"vr": "OB", "BinaryLength": 16416},
        "2887": {"vr": "OB", "BinaryLength": 16424},
        "2888": {"vr": "OB", "BinaryLength": 16424},
        "2889": {"vr": "OB", "BinaryLength": 16428},
        "2890": {"vr": "OB", "BinaryLength": 16416},
        "2891": {"vr": "OB", "BinaryLength": 16424},
        "2892": {"vr": "OB", "BinaryLength": 16424},
        "2893": {"vr": "OB", "BinaryLength": 16424},
        "2894": {"vr": "OB", "BinaryLength": 16428},
        "2895": {"vr": "OB", "BinaryLength": 16416},
        "2896": {"vr": "OB", "BinaryLength": 16424},
        "2897": {"vr": "OB", "BinaryLength": 16428},
        "2898": {"vr": "OB", "BinaryLength": 16424},
        "2899": {"vr": "OB", "BinaryLength": 16424},
        "2900": {"vr": "OB", "BinaryLength": 16428},
        "2901": {"vr": "OB", "BinaryLength": 16424},
        "2902": {"vr": "OB", "BinaryLength": 16416},
        "2903": {"vr": "OB", "BinaryLength": 16416},
        "2904": {"vr": "OB", "BinaryLength": 16432},
        "2905": {"vr": "OB", "BinaryLength": 16424},
        "2906": {"vr": "OB", "BinaryLength": 15616},
        "2907": {"vr": "OB", "BinaryLength": 15628},
        "2908": {"vr": "OB", "BinaryLength": 16412},
        "2909": {"vr": "OB", "BinaryLength": 16428},
        "2910": {"vr": "OB", "BinaryLength": 16424},
        "2911": {"vr": "OB", "BinaryLength": 16424},
        "2912": {"vr": "OB", "BinaryLength": 16424},
        "2913": {"vr": "OB", "BinaryLength": 16432},
        "2914": {"vr": "OB", "BinaryLength": 16408},
        "2915": {"vr": "OB", "BinaryLength": 16424},
        "2916": {"vr": "OB", "BinaryLength": 15624},
        "2917": {"vr": "OB", "BinaryLength": 16424},
        "2918": {"vr": "OB", "BinaryLength": 15624},
        "2919": {"vr": "OB", "BinaryLength": 15624},
        "2920": {"vr": "OB", "BinaryLength": 16428},
        "2921": {"vr": "OB", "BinaryLength": 16428},
        "2922": {"vr": "OB", "BinaryLength": 16428},
        "2923": {"vr": "OB", "BinaryLength": 15624},
        "2924": {"vr": "OB", "BinaryLength": 16424},
        "2925": {"vr": "OB", "BinaryLength": 16412},
        "2926": {"vr": "OB", "BinaryLength": 16412},
        "2927": {"vr": "OB", "BinaryLength": 16428},
        "2928": {"vr": "OB", "BinaryLength": 16424},
        "2929": {"vr": "OB", "BinaryLength": 16396},
        "2930": {"vr": "OB", "BinaryLength": 15628},
        "2931": {"vr": "OB", "BinaryLength": 16416},
        "2932": {"vr": "OB", "BinaryLength": 16432},
        "2933": {"vr": "OB", "BinaryLength": 16408},
        "2934": {"vr": "OB", "BinaryLength": 16424},
        "2935": {"vr": "OB", "BinaryLength": 15624},
        "2936": {"vr": "OB", "BinaryLength": 16424},
        "2937": {"vr": "OB", "BinaryLength": 16416},
        "2938": {"vr": "OB", "BinaryLength": 16416},
        "2939": {"vr": "OB", "BinaryLength": 16424},
        "2940": {"vr": "OB", "BinaryLength": 16424},
        "2941": {"vr": "OB", "BinaryLength": 16428},
        "2942": {"vr": "OB", "BinaryLength": 16416},
        "2943": {"vr": "OB", "BinaryLength": 16428},
        "2944": {"vr": "OB", "BinaryLength": 16416},
        "2945": {"vr": "OB", "BinaryLength": 16412},
        "2946": {"vr": "OB", "BinaryLength": 15628},
        "2947": {"vr": "OB", "BinaryLength": 16416},
        "2948": {"vr": "OB", "BinaryLength": 16428},
        "2949": {"vr": "OB", "BinaryLength": 15616},
        "2950": {"vr": "OB", "BinaryLength": 16412},
        "2951": {"vr": "OB", "BinaryLength": 16428},
        "2952": {"vr": "OB", "BinaryLength": 16416},
        "2953": {"vr": "OB", "BinaryLength": 16424},
        "2954": {"vr": "OB", "BinaryLength": 15624},
        "2955": {"vr": "OB", "BinaryLength": 15624},
        "2956": {"vr": "OB", "BinaryLength": 16428},
        "2957": {"vr": "OB", "BinaryLength": 16416},
        "2958": {"vr": "OB", "BinaryLength": 16408},
        "2959": {"vr": "OB", "BinaryLength": 16428},
        "2960": {"vr": "OB", "BinaryLength": 16424},
        "2961": {"vr": "OB", "BinaryLength": 16424},
        "2962": {"vr": "OB", "BinaryLength": 16428},
        "2963": {"vr": "OB", "BinaryLength": 16416},
        "2964": {"vr": "OB", "BinaryLength": 16412},
        "2965": {"vr": "OB", "BinaryLength": 16424},
        "2966": {"vr": "OB", "BinaryLength": 16424},
        "2967": {"vr": "OB", "BinaryLength": 16424},
        "2968": {"vr": "OB", "BinaryLength": 15624},
        "2969": {"vr": "OB", "BinaryLength": 16424},
        "2970": {"vr": "OB", "BinaryLength": 16424},
        "2971": {"vr": "OB", "BinaryLength": 16412},
        "2972": {"vr": "OB", "BinaryLength": 16424},
        "2973": {"vr": "OB", "BinaryLength": 16416},
        "2974": {"vr": "OB", "BinaryLength": 16424},
        "2975": {"vr": "OB", "BinaryLength": 16424},
        "2976": {"vr": "OB", "BinaryLength": 16428},
        "2977": {"vr": "OB", "BinaryLength": 16424},
        "2978": {"vr": "OB", "BinaryLength": 16408},
        "2979": {"vr": "OB", "BinaryLength": 16424},
        "2980": {"vr": "OB", "BinaryLength": 16424},
        "2981": {"vr": "OB", "BinaryLength": 16428},
        "2982": {"vr": "OB", "BinaryLength": 16428},
        "2983": {"vr": "OB", "BinaryLength": 16424},
        "2984": {"vr": "OB", "BinaryLength": 16428},
        "2985": {"vr": "OB", "BinaryLength": 15624},
        "2986": {"vr": "OB", "BinaryLength": 16428},
        "2987": {"vr": "OB", "BinaryLength": 16432},
        "2988": {"vr": "OB", "BinaryLength": 16416},
        "2989": {"vr": "OB", "BinaryLength": 16432},
        "2990": {"vr": "OB", "BinaryLength": 16416},
        "2991": {"vr": "OB", "BinaryLength": 16428},
        "2992": {"vr": "OB", "BinaryLength": 16416},
        "2993": {"vr": "OB", "BinaryLength": 16424},
        "2994": {"vr": "OB", "BinaryLength": 16424},
        "2995": {"vr": "OB", "BinaryLength": 16416},
        "2996": {"vr": "OB", "BinaryLength": 16424},
        "2997": {"vr": "OB", "BinaryLength": 16424},
        "2998": {"vr": "OB", "BinaryLength": 16416},
        "2999": {"vr": "OB", "BinaryLength": 16428},
        "3000": {"vr": "OB", "BinaryLength": 16424},
        "3001": {"vr": "OB", "BinaryLength": 16424},
        "3002": {"vr": "OB", "BinaryLength": 16424},
        "3003": {"vr": "OB", "BinaryLength": 16428},
        "3004": {"vr": "OB", "BinaryLength": 16432},
        "3005": {"vr": "OB", "BinaryLength": 15624},
        "3006": {"vr": "OB", "BinaryLength": 16432},
        "3007": {"vr": "OB", "BinaryLength": 16428},
        "3008": {"vr": "OB", "BinaryLength": 16424},
        "3009": {"vr": "OB", "BinaryLength": 16412},
        "3010": {"vr": "OB", "BinaryLength": 16428},
        "3011": {"vr": "OB", "BinaryLength": 16424},
        "3012": {"vr": "OB", "BinaryLength": 16424},
        "3013": {"vr": "OB", "BinaryLength": 16428},
        "3014": {"vr": "OB", "BinaryLength": 16432},
        "3015": {"vr": "OB", "BinaryLength": 16424},
        "3016": {"vr": "OB", "BinaryLength": 16428},
        "3017": {"vr": "OB", "BinaryLength": 16416},
        "3018": {"vr": "OB", "BinaryLength": 16428},
        "3019": {"vr": "OB", "BinaryLength": 15616},
        "3020": {"vr": "OB", "BinaryLength": 16428},
        "3021": {"vr": "OB", "BinaryLength": 16428},
        "3022": {"vr": "OB", "BinaryLength": 16428},
        "3023": {"vr": "OB", "BinaryLength": 16416},
        "3024": {"vr": "OB", "BinaryLength": 16424},
        "3025": {"vr": "OB", "BinaryLength": 16428},
        "3026": {"vr": "OB", "BinaryLength": 16396},
        "3027": {"vr": "OB", "BinaryLength": 16432},
        "3028": {"vr": "OB", "BinaryLength": 16428},
        "3029": {"vr": "OB", "BinaryLength": 15624},
        "3030": {"vr": "OB", "BinaryLength": 16428},
        "3031": {"vr": "OB", "BinaryLength": 16416},
        "3032": {"vr": "OB", "BinaryLength": 16428},
        "3033": {"vr": "OB", "BinaryLength": 16424},
        "3034": {"vr": "OB", "BinaryLength": 16424},
        "3035": {"vr": "OB", "BinaryLength": 16432},
        "3036": {"vr": "OB", "BinaryLength": 16416},
        "3037": {"vr": "OB", "BinaryLength": 16432},
        "3038": {"vr": "OB", "BinaryLength": 16428},
        "3039": {"vr": "OB", "BinaryLength": 16428},
        "3040": {"vr": "OB", "BinaryLength": 16428},
        "3041": {"vr": "OB", "BinaryLength": 16428},
        "3042": {"vr": "OB", "BinaryLength": 16432},
        "3043": {"vr": "OB", "BinaryLength": 16428},
        "3044": {"vr": "OB", "BinaryLength": 16424},
        "3045": {"vr": "OB", "BinaryLength": 16416},
        "3046": {"vr": "OB", "BinaryLength": 16432},
        "3047": {"vr": "OB", "BinaryLength": 16428},
        "3048": {"vr": "OB", "BinaryLength": 16428},
        "3049": {"vr": "OB", "BinaryLength": 16428},
        "3050": {"vr": "OB", "BinaryLength": 16416},
        "3051": {"vr": "OB", "BinaryLength": 16428},
        "3052": {"vr": "OB", "BinaryLength": 16428},
        "3053": {"vr": "OB", "BinaryLength": 15624},
        "3054": {"vr": "OB", "BinaryLength": 16424},
        "3055": {"vr": "OB", "BinaryLength": 16424},
        "3056": {"vr": "OB", "BinaryLength": 16428},
        "3057": {"vr": "OB", "BinaryLength": 16424},
        "3058": {"vr": "OB", "BinaryLength": 16428},
        "3059": {"vr": "OB", "BinaryLength": 16428},
        "3060": {"vr": "OB", "BinaryLength": 16416},
        "3061": {"vr": "OB", "BinaryLength": 16428},
        "3062": {"vr": "OB", "BinaryLength": 16428},
        "3063": {"vr": "OB", "BinaryLength": 16428},
        "3064": {"vr": "OB", "BinaryLength": 16432},
        "3065": {"vr": "OB", "BinaryLength": 16428},
        "3066": {"vr": "OB", "BinaryLength": 16428},
        "3067": {"vr": "OB", "BinaryLength": 16428},
        "3068": {"vr": "OB", "BinaryLength": 16428},
        "3069": {"vr": "OB", "BinaryLength": 16428},
        "3070": {"vr": "OB", "BinaryLength": 16428},
        "3071": {"vr": "OB", "BinaryLength": 16432},
        "3072": {"vr": "OB", "BinaryLength": 15624},
        "3073": {"vr": "OB", "BinaryLength": 16424},
        "3074": {"vr": "OB", "BinaryLength": 15628},
        "3075": {"vr": "OB", "BinaryLength": 16428},
        "3076": {"vr": "OB", "BinaryLength": 16416},
        "3077": {"vr": "OB", "BinaryLength": 15624},
        "3078": {"vr": "OB", "BinaryLength": 16416},
        "3079": {"vr": "OB", "BinaryLength": 16424},
        "3080": {"vr": "OB", "BinaryLength": 16424},
        "3081": {"vr": "OB", "BinaryLength": 16424},
        "3082": {"vr": "OB", "BinaryLength": 16428},
        "3083": {"vr": "OB", "BinaryLength": 16424},
        "3084": {"vr": "OB", "BinaryLength": 16416},
        "3085": {"vr": "OB", "BinaryLength": 16424},
        "3086": {"vr": "OB", "BinaryLength": 16416},
        "3087": {"vr": "OB", "BinaryLength": 16416},
        "3088": {"vr": "OB", "BinaryLength": 16432},
        "3089": {"vr": "OB", "BinaryLength": 15616},
        "3090": {"vr": "OB", "BinaryLength": 16416},
        "3091": {"vr": "OB", "BinaryLength": 16428},
        "3092": {"vr": "OB", "BinaryLength": 15628},
        "3093": {"vr": "OB", "BinaryLength": 16424},
        "3094": {"vr": "OB", "BinaryLength": 16424},
        "3095": {"vr": "OB", "BinaryLength": 16424},
        "3096": {"vr": "OB", "BinaryLength": 16424},
        "3097": {"vr": "OB", "BinaryLength": 16428},
        "3098": {"vr": "OB", "BinaryLength": 16428},
        "3099": {"vr": "OB", "BinaryLength": 16428},
        "3100": {"vr": "OB", "BinaryLength": 16432},
        "3101": {"vr": "OB", "BinaryLength": 16428},
        "3102": {"vr": "OB", "BinaryLength": 15624},
        "3103": {"vr": "OB", "BinaryLength": 16428},
        "3104": {"vr": "OB", "BinaryLength": 16432},
        "3105": {"vr": "OB", "BinaryLength": 16424},
        "3106": {"vr": "OB", "BinaryLength": 16424},
        "3107": {"vr": "OB", "BinaryLength": 16428},
        "3108": {"vr": "OB", "BinaryLength": 16412},
        "3109": {"vr": "OB", "BinaryLength": 16428},
        "3110": {"vr": "OB", "BinaryLength": 16428},
        "3111": {"vr": "OB", "BinaryLength": 16428},
        "3112": {"vr": "OB", "BinaryLength": 16424},
        "3113": {"vr": "OB", "BinaryLength": 16428},
        "3114": {"vr": "OB", "BinaryLength": 16424},
        "3115": {"vr": "OB", "BinaryLength": 16396},
        "3116": {"vr": "OB", "BinaryLength": 16412},
        "3117": {"vr": "OB", "BinaryLength": 16432},
        "3118": {"vr": "OB", "BinaryLength": 16428},
        "3119": {"vr": "OB", "BinaryLength": 16424},
        "3120": {"vr": "OB", "BinaryLength": 16428},
        "3121": {"vr": "OB", "BinaryLength": 16424},
        "3122": {"vr": "OB", "BinaryLength": 16416},
        "3123": {"vr": "OB", "BinaryLength": 16428},
        "3124": {"vr": "OB", "BinaryLength": 16416},
        "3125": {"vr": "OB", "BinaryLength": 16424},
        "3126": {"vr": "OB", "BinaryLength": 16424},
        "3127": {"vr": "OB", "BinaryLength": 16424},
        "3128": {"vr": "OB", "BinaryLength": 16428},
        "3129": {"vr": "OB", "BinaryLength": 16412},
        "3130": {"vr": "OB", "BinaryLength": 16424},
        "3131": {"vr": "OB", "BinaryLength": 16428},
        "3132": {"vr": "OB", "BinaryLength": 15624},
        "3133": {"vr": "OB", "BinaryLength": 16428},
        "3134": {"vr": "OB", "BinaryLength": 16428},
        "3135": {"vr": "OB", "BinaryLength": 16428},
        "3136": {"vr": "OB", "BinaryLength": 16416},
        "3137": {"vr": "OB", "BinaryLength": 16428},
        "3138": {"vr": "OB", "BinaryLength": 16412},
        "3139": {"vr": "OB", "BinaryLength": 16400},
        "3140": {"vr": "OB", "BinaryLength": 16416},
        "3141": {"vr": "OB", "BinaryLength": 16428},
        "3142": {"vr": "OB", "BinaryLength": 16424},
        "3143": {"vr": "OB", "BinaryLength": 16416},
        "3144": {"vr": "OB", "BinaryLength": 16428},
        "3145": {"vr": "OB", "BinaryLength": 16400},
        "3146": {"vr": "OB", "BinaryLength": 16428},
        "3147": {"vr": "OB", "BinaryLength": 16428},
        "3148": {"vr": "OB", "BinaryLength": 16424},
        "3149": {"vr": "OB", "BinaryLength": 16428},
        "3150": {"vr": "OB", "BinaryLength": 16424},
        "3151": {"vr": "OB", "BinaryLength": 16412},
        "3152": {"vr": "OB", "BinaryLength": 16424},
        "3153": {"vr": "OB", "BinaryLength": 16424},
        "3154": {"vr": "OB", "BinaryLength": 16424},
        "3155": {"vr": "OB", "BinaryLength": 16428},
        "3156": {"vr": "OB", "BinaryLength": 16428},
        "3157": {"vr": "OB", "BinaryLength": 16424},
        "3158": {"vr": "OB", "BinaryLength": 16424},
        "3159": {"vr": "OB", "BinaryLength": 16428},
        "3160": {"vr": "OB", "BinaryLength": 15616},
        "3161": {"vr": "OB", "BinaryLength": 16428},
        "3162": {"vr": "OB", "BinaryLength": 16432},
        "3163": {"vr": "OB", "BinaryLength": 16424},
        "3164": {"vr": "OB", "BinaryLength": 16424},
        "3165": {"vr": "OB", "BinaryLength": 15616},
        "3166": {"vr": "OB", "BinaryLength": 16416},
        "3167": {"vr": "OB", "BinaryLength": 16408},
        "3168": {"vr": "OB", "BinaryLength": 16428},
        "3169": {"vr": "OB", "BinaryLength": 16428},
        "3170": {"vr": "OB", "BinaryLength": 16428},
        "3171": {"vr": "OB", "BinaryLength": 16424},
        "3172": {"vr": "OB", "BinaryLength": 15624},
        "3173": {"vr": "OB", "BinaryLength": 16424},
        "3174": {"vr": "OB", "BinaryLength": 16424},
        "3175": {"vr": "OB", "BinaryLength": 16428},
        "3176": {"vr": "OB", "BinaryLength": 16412},
        "3177": {"vr": "OB", "BinaryLength": 16428},
        "3178": {"vr": "OB", "BinaryLength": 16428},
        "3179": {"vr": "OB", "BinaryLength": 16428},
        "3180": {"vr": "OB", "BinaryLength": 16424},
        "3181": {"vr": "OB", "BinaryLength": 16428},
        "3182": {"vr": "OB", "BinaryLength": 16424},
        "3183": {"vr": "OB", "BinaryLength": 16424},
        "3184": {"vr": "OB", "BinaryLength": 16428},
        "3185": {"vr": "OB", "BinaryLength": 16428},
        "3186": {"vr": "OB", "BinaryLength": 16428},
        "3187": {"vr": "OB", "BinaryLength": 16428},
        "3188": {"vr": "OB", "BinaryLength": 16428},
        "3189": {"vr": "OB", "BinaryLength": 16428},
        "3190": {"vr": "OB", "BinaryLength": 16428},
        "3191": {"vr": "OB", "BinaryLength": 16416},
        "3192": {"vr": "OB", "BinaryLength": 16428},
        "3193": {"vr": "OB", "BinaryLength": 15624},
        "3194": {"vr": "OB", "BinaryLength": 15616},
        "3195": {"vr": "OB", "BinaryLength": 16428},
        "3196": {"vr": "OB", "BinaryLength": 16416},
        "3197": {"vr": "OB", "BinaryLength": 16424},
        "3198": {"vr": "OB", "BinaryLength": 16428},
        "3199": {"vr": "OB", "BinaryLength": 16424},
        "3200": {"vr": "OB", "BinaryLength": 16396},
        "3201": {"vr": "OB", "BinaryLength": 16424},
        "3202": {"vr": "OB", "BinaryLength": 16412},
        "3203": {"vr": "OB", "BinaryLength": 16428},
        "3204": {"vr": "OB", "BinaryLength": 16432},
        "3205": {"vr": "OB", "BinaryLength": 16428},
        "3206": {"vr": "OB", "BinaryLength": 16408},
        "3207": {"vr": "OB", "BinaryLength": 16428},
        "3208": {"vr": "OB", "BinaryLength": 16428},
        "3209": {"vr": "OB", "BinaryLength": 16428},
        "3210": {"vr": "OB", "BinaryLength": 16412},
        "3211": {"vr": "OB", "BinaryLength": 16428},
        "3212": {"vr": "OB", "BinaryLength": 16428},
        "3213": {"vr": "OB", "BinaryLength": 16416},
        "3214": {"vr": "OB", "BinaryLength": 15624},
        "3215": {"vr": "OB", "BinaryLength": 16428},
        "3216": {"vr": "OB", "BinaryLength": 16428},
        "3217": {"vr": "OB", "BinaryLength": 16424},
        "3218": {"vr": "OB", "BinaryLength": 15616},
        "3219": {"vr": "OB", "BinaryLength": 16428},
        "3220": {"vr": "OB", "BinaryLength": 16428},
        "3221": {"vr": "OB", "BinaryLength": 16424},
        "3222": {"vr": "OB", "BinaryLength": 16432},
        "3223": {"vr": "OB", "BinaryLength": 16432},
        "3224": {"vr": "OB", "BinaryLength": 16396},
        "3225": {"vr": "OB", "BinaryLength": 16428},
        "3226": {"vr": "OB", "BinaryLength": 16416},
        "3227": {"vr": "OB", "BinaryLength": 16428},
        "3228": {"vr": "OB", "BinaryLength": 16432},
        "3229": {"vr": "OB", "BinaryLength": 16416},
        "3230": {"vr": "OB", "BinaryLength": 15628},
        "3231": {"vr": "OB", "BinaryLength": 16424},
        "3232": {"vr": "OB", "BinaryLength": 16428},
        "3233": {"vr": "OB", "BinaryLength": 16432},
        "3234": {"vr": "OB", "BinaryLength": 16424},
        "3235": {"vr": "OB", "BinaryLength": 16428},
        "3236": {"vr": "OB", "BinaryLength": 16428},
        "3237": {"vr": "OB", "BinaryLength": 16424},
        "3238": {"vr": "OB", "BinaryLength": 16428},
        "3239": {"vr": "OB", "BinaryLength": 16428},
        "3240": {"vr": "OB", "BinaryLength": 16412},
        "3241": {"vr": "OB", "BinaryLength": 16428},
        "3242": {"vr": "OB", "BinaryLength": 16424},
        "3243": {"vr": "OB", "BinaryLength": 15624},
        "3244": {"vr": "OB", "BinaryLength": 16408},
        "3245": {"vr": "OB", "BinaryLength": 16396},
        "3246": {"vr": "OB", "BinaryLength": 16424},
        "3247": {"vr": "OB", "BinaryLength": 16428},
        "3248": {"vr": "OB", "BinaryLength": 16416},
        "3249": {"vr": "OB", "BinaryLength": 16424},
        "3250": {"vr": "OB", "BinaryLength": 16416},
        "3251": {"vr": "OB", "BinaryLength": 16428},
        "3252": {"vr": "OB", "BinaryLength": 16428},
        "3253": {"vr": "OB", "BinaryLength": 16428},
        "3254": {"vr": "OB", "BinaryLength": 16424},
        "3255": {"vr": "OB", "BinaryLength": 16412},
        "3256": {"vr": "OB", "BinaryLength": 15624},
        "3257": {"vr": "OB", "BinaryLength": 16424},
        "3258": {"vr": "OB", "BinaryLength": 15628},
        "3259": {"vr": "OB", "BinaryLength": 16412},
        "3260": {"vr": "OB", "BinaryLength": 16416},
        "3261": {"vr": "OB", "BinaryLength": 16428},
        "3262": {"vr": "OB", "BinaryLength": 16432},
        "3263": {"vr": "OB", "BinaryLength": 16428},
        "3264": {"vr": "OB", "BinaryLength": 15624},
        "3265": {"vr": "OB", "BinaryLength": 16428},
        "3266": {"vr": "OB", "BinaryLength": 16416},
        "3267": {"vr": "OB", "BinaryLength": 16428},
        "3268": {"vr": "OB", "BinaryLength": 16428},
        "3269": {"vr": "OB", "BinaryLength": 16432},
        "3270": {"vr": "OB", "BinaryLength": 15624},
        "3271": {"vr": "OB", "BinaryLength": 16428},
        "3272": {"vr": "OB", "BinaryLength": 16428},
        "3273": {"vr": "OB", "BinaryLength": 16428},
        "3274": {"vr": "OB", "BinaryLength": 16412},
        "3275": {"vr": "OB", "BinaryLength": 16428},
        "3276": {"vr": "OB", "BinaryLength": 16424},
        "3277": {"vr": "OB", "BinaryLength": 16416},
        "3278": {"vr": "OB", "BinaryLength": 16416},
        "3279": {"vr": "OB", "BinaryLength": 16424},
        "3280": {"vr": "OB", "BinaryLength": 15624},
        "3281": {"vr": "OB", "BinaryLength": 16428},
        "3282": {"vr": "OB", "BinaryLength": 16428},
        "3283": {"vr": "OB", "BinaryLength": 16408},
        "3284": {"vr": "OB", "BinaryLength": 16424},
        "3285": {"vr": "OB", "BinaryLength": 16428},
        "3286": {"vr": "OB", "BinaryLength": 16432},
        "3287": {"vr": "OB", "BinaryLength": 16424},
        "3288": {"vr": "OB", "BinaryLength": 16424},
        "3289": {"vr": "OB", "BinaryLength": 16408},
        "3290": {"vr": "OB", "BinaryLength": 16408},
        "3291": {"vr": "OB", "BinaryLength": 16428},
        "3292": {"vr": "OB", "BinaryLength": 16428},
        "3293": {"vr": "OB", "BinaryLength": 16428},
        "3294": {"vr": "OB", "BinaryLength": 16424},
        "3295": {"vr": "OB", "BinaryLength": 16428},
        "3296": {"vr": "OB", "BinaryLength": 16424},
        "3297": {"vr": "OB", "BinaryLength": 16424},
        "3298": {"vr": "OB", "BinaryLength": 16432},
        "3299": {"vr": "OB", "BinaryLength": 16416},
        "3300": {"vr": "OB", "BinaryLength": 16424},
        "3301": {"vr": "OB", "BinaryLength": 16428},
        "3302": {"vr": "OB", "BinaryLength": 16428},
        "3303": {"vr": "OB", "BinaryLength": 16412},
        "3304": {"vr": "OB", "BinaryLength": 16424},
        "3305": {"vr": "OB", "BinaryLength": 16424},
        "3306": {"vr": "OB", "BinaryLength": 16428},
        "3307": {"vr": "OB", "BinaryLength": 16412},
        "3308": {"vr": "OB", "BinaryLength": 16428},
        "3309": {"vr": "OB", "BinaryLength": 16428},
        "3310": {"vr": "OB", "BinaryLength": 16412},
        "3311": {"vr": "OB", "BinaryLength": 16428},
        "3312": {"vr": "OB", "BinaryLength": 16428},
        "3313": {"vr": "OB", "BinaryLength": 16396},
        "3314": {"vr": "OB", "BinaryLength": 16428},
        "3315": {"vr": "OB", "BinaryLength": 15624},
        "3316": {"vr": "OB", "BinaryLength": 16428},
        "3317": {"vr": "OB", "BinaryLength": 16428},
        "3318": {"vr": "OB", "BinaryLength": 16424},
        "3319": {"vr": "OB", "BinaryLength": 16428},
        "3320": {"vr": "OB", "BinaryLength": 16428},
        "3321": {"vr": "OB", "BinaryLength": 16428},
        "3322": {"vr": "OB", "BinaryLength": 16416},
        "3323": {"vr": "OB", "BinaryLength": 16424},
        "3324": {"vr": "OB", "BinaryLength": 16428},
        "3325": {"vr": "OB", "BinaryLength": 16428},
        "3326": {"vr": "OB", "BinaryLength": 16424},
        "3327": {"vr": "OB", "BinaryLength": 16424},
        "3328": {"vr": "OB", "BinaryLength": 15624},
        "3329": {"vr": "OB", "BinaryLength": 16424},
        "3330": {"vr": "OB", "BinaryLength": 16424},
        "3331": {"vr": "OB", "BinaryLength": 16412},
        "3332": {"vr": "OB", "BinaryLength": 16416},
        "3333": {"vr": "OB", "BinaryLength": 16424},
        "3334": {"vr": "OB", "BinaryLength": 16424},
        "3335": {"vr": "OB", "BinaryLength": 16428},
        "3336": {"vr": "OB", "BinaryLength": 16424},
        "3337": {"vr": "OB", "BinaryLength": 16396},
        "3338": {"vr": "OB", "BinaryLength": 16428},
        "3339": {"vr": "OB", "BinaryLength": 16428},
        "3340": {"vr": "OB", "BinaryLength": 16428},
        "3341": {"vr": "OB", "BinaryLength": 16428},
        "3342": {"vr": "OB", "BinaryLength": 16432},
        "3343": {"vr": "OB", "BinaryLength": 15624},
        "3344": {"vr": "OB", "BinaryLength": 16400},
        "3345": {"vr": "OB", "BinaryLength": 16428},
        "3346": {"vr": "OB", "BinaryLength": 16428},
        "3347": {"vr": "OB", "BinaryLength": 15624},
        "3348": {"vr": "OB", "BinaryLength": 16424},
        "3349": {"vr": "OB", "BinaryLength": 16432},
        "3350": {"vr": "OB", "BinaryLength": 16424},
        "3351": {"vr": "OB", "BinaryLength": 16416},
        "3352": {"vr": "OB", "BinaryLength": 16432},
        "3353": {"vr": "OB", "BinaryLength": 16424},
        "3354": {"vr": "OB", "BinaryLength": 16424},
        "3355": {"vr": "OB", "BinaryLength": 16428},
        "3356": {"vr": "OB", "BinaryLength": 16428},
        "3357": {"vr": "OB", "BinaryLength": 16424},
        "3358": {"vr": "OB", "BinaryLength": 16424},
        "3359": {"vr": "OB", "BinaryLength": 16432},
        "3360": {"vr": "OB", "BinaryLength": 16416},
        "3361": {"vr": "OB", "BinaryLength": 16428},
        "3362": {"vr": "OB", "BinaryLength": 16428},
        "3363": {"vr": "OB", "BinaryLength": 16416},
        "3364": {"vr": "OB", "BinaryLength": 16424},
        "3365": {"vr": "OB", "BinaryLength": 15628},
        "3366": {"vr": "OB", "BinaryLength": 16428},
        "3367": {"vr": "OB", "BinaryLength": 16428},
        "3368": {"vr": "OB", "BinaryLength": 16424},
        "3369": {"vr": "OB", "BinaryLength": 16428},
        "3370": {"vr": "OB", "BinaryLength": 16428},
        "3371": {"vr": "OB", "BinaryLength": 16432},
        "3372": {"vr": "OB", "BinaryLength": 16424},
        "3373": {"vr": "OB", "BinaryLength": 16432},
        "3374": {"vr": "OB", "BinaryLength": 16428},
        "3375": {"vr": "OB", "BinaryLength": 16428},
        "3376": {"vr": "OB", "BinaryLength": 15624},
        "3377": {"vr": "OB", "BinaryLength": 16424},
        "3378": {"vr": "OB", "BinaryLength": 16428},
        "3379": {"vr": "OB", "BinaryLength": 16428},
        "3380": {"vr": "OB", "BinaryLength": 16428},
        "3381": {"vr": "OB", "BinaryLength": 16428},
        "3382": {"vr": "OB", "BinaryLength": 15624},
        "3383": {"vr": "OB", "BinaryLength": 16424},
        "3384": {"vr": "OB", "BinaryLength": 15624},
        "3385": {"vr": "OB", "BinaryLength": 16424},
        "3386": {"vr": "OB", "BinaryLength": 16432},
        "3387": {"vr": "OB", "BinaryLength": 16412},
        "3388": {"vr": "OB", "BinaryLength": 16428},
        "3389": {"vr": "OB", "BinaryLength": 15624},
        "3390": {"vr": "OB", "BinaryLength": 16428},
        "3391": {"vr": "OB", "BinaryLength": 16428},
        "3392": {"vr": "OB", "BinaryLength": 16428},
        "3393": {"vr": "OB", "BinaryLength": 16428},
        "3394": {"vr": "OB", "BinaryLength": 16412},
        "3395": {"vr": "OB", "BinaryLength": 16432},
        "3396": {"vr": "OB", "BinaryLength": 16424},
        "3397": {"vr": "OB", "BinaryLength": 16424},
        "3398": {"vr": "OB", "BinaryLength": 16416},
        "3399": {"vr": "OB", "BinaryLength": 16428},
        "3400": {"vr": "OB", "BinaryLength": 16424},
        "3401": {"vr": "OB", "BinaryLength": 16428},
        "3402": {"vr": "OB", "BinaryLength": 16432},
        "3403": {"vr": "OB", "BinaryLength": 16428},
        "3404": {"vr": "OB", "BinaryLength": 16424},
        "3405": {"vr": "OB", "BinaryLength": 15628},
        "3406": {"vr": "OB", "BinaryLength": 16428},
        "3407": {"vr": "OB", "BinaryLength": 16424},
        "3408": {"vr": "OB", "BinaryLength": 16416},
        "3409": {"vr": "OB", "BinaryLength": 16428},
        "3410": {"vr": "OB", "BinaryLength": 16428},
        "3411": {"vr": "OB", "BinaryLength": 16428},
        "3412": {"vr": "OB", "BinaryLength": 16424},
        "3413": {"vr": "OB", "BinaryLength": 16428},
        "3414": {"vr": "OB", "BinaryLength": 16432},
        "3415": {"vr": "OB", "BinaryLength": 16424},
        "3416": {"vr": "OB", "BinaryLength": 16428},
        "3417": {"vr": "OB", "BinaryLength": 16416},
        "3418": {"vr": "OB", "BinaryLength": 16400},
        "3419": {"vr": "OB", "BinaryLength": 16424},
        "3420": {"vr": "OB", "BinaryLength": 16424},
        "3421": {"vr": "OB", "BinaryLength": 16412},
        "3422": {"vr": "OB", "BinaryLength": 16428},
        "3423": {"vr": "OB", "BinaryLength": 16432},
        "3424": {"vr": "OB", "BinaryLength": 16428},
        "3425": {"vr": "OB", "BinaryLength": 16428},
        "3426": {"vr": "OB", "BinaryLength": 16424},
        "3427": {"vr": "OB", "BinaryLength": 16428},
        "3428": {"vr": "OB", "BinaryLength": 16424},
        "3429": {"vr": "OB", "BinaryLength": 16428},
        "3430": {"vr": "OB", "BinaryLength": 16432},
        "3431": {"vr": "OB", "BinaryLength": 15624},
        "3432": {"vr": "OB", "BinaryLength": 16416},
        "3433": {"vr": "OB", "BinaryLength": 16424},
        "3434": {"vr": "OB", "BinaryLength": 16428},
        "3435": {"vr": "OB", "BinaryLength": 16424},
        "3436": {"vr": "OB", "BinaryLength": 15628},
        "3437": {"vr": "OB", "BinaryLength": 16428},
        "3438": {"vr": "OB", "BinaryLength": 16424},
        "3439": {"vr": "OB", "BinaryLength": 16432},
        "3440": {"vr": "OB", "BinaryLength": 16424},
        "3441": {"vr": "OB", "BinaryLength": 16424},
        "3442": {"vr": "OB", "BinaryLength": 16424},
        "3443": {"vr": "OB", "BinaryLength": 16428},
        "3444": {"vr": "OB", "BinaryLength": 16432},
        "3445": {"vr": "OB", "BinaryLength": 16400},
        "3446": {"vr": "OB", "BinaryLength": 15616},
        "3447": {"vr": "OB", "BinaryLength": 16432},
        "3448": {"vr": "OB", "BinaryLength": 16432},
        "3449": {"vr": "OB", "BinaryLength": 16424},
        "3450": {"vr": "OB", "BinaryLength": 16428},
        "3451": {"vr": "OB", "BinaryLength": 16424},
        "3452": {"vr": "OB", "BinaryLength": 16428},
        "3453": {"vr": "OB", "BinaryLength": 16424},
        "3454": {"vr": "OB", "BinaryLength": 15624},
        "3455": {"vr": "OB", "BinaryLength": 16416},
        "3456": {"vr": "OB", "BinaryLength": 16424},
        "3457": {"vr": "OB", "BinaryLength": 16432},
        "3458": {"vr": "OB", "BinaryLength": 16428},
        "3459": {"vr": "OB", "BinaryLength": 16416},
        "3460": {"vr": "OB", "BinaryLength": 16424},
        "3461": {"vr": "OB", "BinaryLength": 16408},
        "3462": {"vr": "OB", "BinaryLength": 16424},
        "3463": {"vr": "OB", "BinaryLength": 16416},
        "3464": {"vr": "OB", "BinaryLength": 16432},
        "3465": {"vr": "OB", "BinaryLength": 16416},
        "3466": {"vr": "OB", "BinaryLength": 16424},
        "3467": {"vr": "OB", "BinaryLength": 16416},
        "3468": {"vr": "OB", "BinaryLength": 16428},
        "3469": {"vr": "OB", "BinaryLength": 16428},
        "3470": {"vr": "OB", "BinaryLength": 16428},
        "3471": {"vr": "OB", "BinaryLength": 16428},
        "3472": {"vr": "OB", "BinaryLength": 16432},
        "3473": {"vr": "OB", "BinaryLength": 16424},
        "3474": {"vr": "OB", "BinaryLength": 15624},
        "3475": {"vr": "OB", "BinaryLength": 16424},
        "3476": {"vr": "OB", "BinaryLength": 16424},
        "3477": {"vr": "OB", "BinaryLength": 16396},
        "3478": {"vr": "OB", "BinaryLength": 16428},
        "3479": {"vr": "OB", "BinaryLength": 16424},
        "3480": {"vr": "OB", "BinaryLength": 16424},
        "3481": {"vr": "OB", "BinaryLength": 15624},
        "3482": {"vr": "OB", "BinaryLength": 16428},
        "3483": {"vr": "OB", "BinaryLength": 16428},
        "3484": {"vr": "OB", "BinaryLength": 16432},
        "3485": {"vr": "OB", "BinaryLength": 16416},
        "3486": {"vr": "OB", "BinaryLength": 16428},
        "3487": {"vr": "OB", "BinaryLength": 16416},
        "3488": {"vr": "OB", "BinaryLength": 16416},
        "3489": {"vr": "OB", "BinaryLength": 16428},
        "3490": {"vr": "OB", "BinaryLength": 16412},
        "3491": {"vr": "OB", "BinaryLength": 16416},
        "3492": {"vr": "OB", "BinaryLength": 15628},
        "3493": {"vr": "OB", "BinaryLength": 16432},
        "3494": {"vr": "OB", "BinaryLength": 16428},
        "3495": {"vr": "OB", "BinaryLength": 16428},
        "3496": {"vr": "OB", "BinaryLength": 16424},
        "3497": {"vr": "OB", "BinaryLength": 16416},
        "3498": {"vr": "OB", "BinaryLength": 15628},
        "3499": {"vr": "OB", "BinaryLength": 16424},
        "3500": {"vr": "OB", "BinaryLength": 16432},
        "3501": {"vr": "OB", "BinaryLength": 15624},
        "3502": {"vr": "OB", "BinaryLength": 16428},
        "3503": {"vr": "OB", "BinaryLength": 15624},
        "3504": {"vr": "OB", "BinaryLength": 16416},
        "3505": {"vr": "OB", "BinaryLength": 16424},
        "3506": {"vr": "OB", "BinaryLength": 16428},
        "3507": {"vr": "OB", "BinaryLength": 16424},
        "3508": {"vr": "OB", "BinaryLength": 16424},
        "3509": {"vr": "OB", "BinaryLength": 16428},
        "3510": {"vr": "OB", "BinaryLength": 16428},
        "3511": {"vr": "OB", "BinaryLength": 15616},
        "3512": {"vr": "OB", "BinaryLength": 16428},
        "3513": {"vr": "OB", "BinaryLength": 16424},
        "3514": {"vr": "OB", "BinaryLength": 16428},
        "3515": {"vr": "OB", "BinaryLength": 16428},
        "3516": {"vr": "OB", "BinaryLength": 16396},
        "3517": {"vr": "OB", "BinaryLength": 16432},
        "3518": {"vr": "OB", "BinaryLength": 16428},
        "3519": {"vr": "OB", "BinaryLength": 16424},
        "3520": {"vr": "OB", "BinaryLength": 16432},
        "3521": {"vr": "OB", "BinaryLength": 15624},
        "3522": {"vr": "OB", "BinaryLength": 15616},
        "3523": {"vr": "OB", "BinaryLength": 16428},
        "3524": {"vr": "OB", "BinaryLength": 16432},
        "3525": {"vr": "OB", "BinaryLength": 16428},
        "3526": {"vr": "OB", "BinaryLength": 16428},
        "3527": {"vr": "OB", "BinaryLength": 16428},
        "3528": {"vr": "OB", "BinaryLength": 16428},
        "3529": {"vr": "OB", "BinaryLength": 15624},
        "3530": {"vr": "OB", "BinaryLength": 16428},
        "3531": {"vr": "OB", "BinaryLength": 16408},
        "3532": {"vr": "OB", "BinaryLength": 15624},
        "3533": {"vr": "OB", "BinaryLength": 16428},
        "3534": {"vr": "OB", "BinaryLength": 16428},
        "3535": {"vr": "OB", "BinaryLength": 16428},
        "3536": {"vr": "OB", "BinaryLength": 16424},
        "3537": {"vr": "OB", "BinaryLength": 16424},
        "3538": {"vr": "OB", "BinaryLength": 16424},
        "3539": {"vr": "OB", "BinaryLength": 15624},
        "3540": {"vr": "OB", "BinaryLength": 16428},
        "3541": {"vr": "OB", "BinaryLength": 16428},
        "3542": {"vr": "OB", "BinaryLength": 16424},
        "3543": {"vr": "OB", "BinaryLength": 16424},
        "3544": {"vr": "OB", "BinaryLength": 16428},
        "3545": {"vr": "OB", "BinaryLength": 16428},
        "3546": {"vr": "OB", "BinaryLength": 16432},
        "3547": {"vr": "OB", "BinaryLength": 16428},
        "3548": {"vr": "OB", "BinaryLength": 16424},
        "3549": {"vr": "OB", "BinaryLength": 16424},
        "3550": {"vr": "OB", "BinaryLength": 16432},
        "3551": {"vr": "OB", "BinaryLength": 16424},
        "3552": {"vr": "OB", "BinaryLength": 16416},
        "3553": {"vr": "OB", "BinaryLength": 16428},
        "3554": {"vr": "OB", "BinaryLength": 16428},
        "3555": {"vr": "OB", "BinaryLength": 16424},
        "3556": {"vr": "OB", "BinaryLength": 16428},
        "3557": {"vr": "OB", "BinaryLength": 16424},
        "3558": {"vr": "OB", "BinaryLength": 16424},
        "3559": {"vr": "OB", "BinaryLength": 16416},
        "3560": {"vr": "OB", "BinaryLength": 16424},
        "3561": {"vr": "OB", "BinaryLength": 16432},
        "3562": {"vr": "OB", "BinaryLength": 16428},
        "3563": {"vr": "OB", "BinaryLength": 16428},
        "3564": {"vr": "OB", "BinaryLength": 16424},
        "3565": {"vr": "OB", "BinaryLength": 16416},
        "3566": {"vr": "OB", "BinaryLength": 16424},
        "3567": {"vr": "OB", "BinaryLength": 16424},
        "3568": {"vr": "OB", "BinaryLength": 16400},
        "3569": {"vr": "OB", "BinaryLength": 16428},
        "3570": {"vr": "OB", "BinaryLength": 16428},
        "3571": {"vr": "OB", "BinaryLength": 16424},
        "3572": {"vr": "OB", "BinaryLength": 16416},
        "3573": {"vr": "OB", "BinaryLength": 16424},
        "3574": {"vr": "OB", "BinaryLength": 16416},
        "3575": {"vr": "OB", "BinaryLength": 15624},
        "3576": {"vr": "OB", "BinaryLength": 16428},
        "3577": {"vr": "OB", "BinaryLength": 16428},
        "3578": {"vr": "OB", "BinaryLength": 16428},
        "3579": {"vr": "OB", "BinaryLength": 16428},
        "3580": {"vr": "OB", "BinaryLength": 16432},
        "3581": {"vr": "OB", "BinaryLength": 16432},
        "3582": {"vr": "OB", "BinaryLength": 16424},
        "3583": {"vr": "OB", "BinaryLength": 16412},
        "3584": {"vr": "OB", "BinaryLength": 16412},
        "3585": {"vr": "OB", "BinaryLength": 16424},
        "3586": {"vr": "OB", "BinaryLength": 16432},
        "3587": {"vr": "OB", "BinaryLength": 16428},
        "3588": {"vr": "OB", "BinaryLength": 16428},
        "3589": {"vr": "OB", "BinaryLength": 15624},
        "3590": {"vr": "OB", "BinaryLength": 16428},
        "3591": {"vr": "OB", "BinaryLength": 16424},
        "3592": {"vr": "OB", "BinaryLength": 16424},
        "3593": {"vr": "OB", "BinaryLength": 16416},
        "3594": {"vr": "OB", "BinaryLength": 16424},
        "3595": {"vr": "OB", "BinaryLength": 16428},
        "3596": {"vr": "OB", "BinaryLength": 15624},
        "3597": {"vr": "OB", "BinaryLength": 16428},
        "3598": {"vr": "OB", "BinaryLength": 15628},
        "3599": {"vr": "OB", "BinaryLength": 16416},
        "3600": {"vr": "OB", "BinaryLength": 16428},
        "3601": {"vr": "OB", "BinaryLength": 16428},
        "3602": {"vr": "OB", "BinaryLength": 16428},
        "3603": {"vr": "OB", "BinaryLength": 16424},
        "3604": {"vr": "OB", "BinaryLength": 16424},
        "3605": {"vr": "OB", "BinaryLength": 16428},
        "3606": {"vr": "OB", "BinaryLength": 16428},
        "3607": {"vr": "OB", "BinaryLength": 16428},
        "3608": {"vr": "OB", "BinaryLength": 16428},
        "3609": {"vr": "OB", "BinaryLength": 16428},
        "3610": {"vr": "OB", "BinaryLength": 15628},
        "3611": {"vr": "OB", "BinaryLength": 16412},
        "3612": {"vr": "OB", "BinaryLength": 16428},
        "3613": {"vr": "OB", "BinaryLength": 16428},
        "3614": {"vr": "OB", "BinaryLength": 15624},
        "3615": {"vr": "OB", "BinaryLength": 16424},
        "3616": {"vr": "OB", "BinaryLength": 16432},
        "3617": {"vr": "OB", "BinaryLength": 16416},
        "3618": {"vr": "OB", "BinaryLength": 16428},
        "3619": {"vr": "OB", "BinaryLength": 16400},
        "3620": {"vr": "OB", "BinaryLength": 16424},
        "3621": {"vr": "OB", "BinaryLength": 16428},
        "3622": {"vr": "OB", "BinaryLength": 16412},
        "3623": {"vr": "OB", "BinaryLength": 16424},
        "3624": {"vr": "OB", "BinaryLength": 16412},
        "3625": {"vr": "OB", "BinaryLength": 16428},
        "3626": {"vr": "OB", "BinaryLength": 16432},
        "3627": {"vr": "OB", "BinaryLength": 16428},
        "3628": {"vr": "OB", "BinaryLength": 15624},
        "3629": {"vr": "OB", "BinaryLength": 16428},
        "3630": {"vr": "OB", "BinaryLength": 16428},
        "3631": {"vr": "OB", "BinaryLength": 16416},
        "3632": {"vr": "OB", "BinaryLength": 16424},
        "3633": {"vr": "OB", "BinaryLength": 16432},
        "3634": {"vr": "OB", "BinaryLength": 16428},
        "3635": {"vr": "OB", "BinaryLength": 16428},
        "3636": {"vr": "OB", "BinaryLength": 16428},
        "3637": {"vr": "OB", "BinaryLength": 16424},
        "3638": {"vr": "OB", "BinaryLength": 15624},
        "3639": {"vr": "OB", "BinaryLength": 16432},
        "3640": {"vr": "OB", "BinaryLength": 15624},
        "3641": {"vr": "OB", "BinaryLength": 16424},
        "3642": {"vr": "OB", "BinaryLength": 16428},
        "3643": {"vr": "OB", "BinaryLength": 16432},
        "3644": {"vr": "OB", "BinaryLength": 16428},
        "3645": {"vr": "OB", "BinaryLength": 16416},
        "3646": {"vr": "OB", "BinaryLength": 16428},
        "3647": {"vr": "OB", "BinaryLength": 16428},
        "3648": {"vr": "OB", "BinaryLength": 16432},
        "3649": {"vr": "OB", "BinaryLength": 16432},
        "3650": {"vr": "OB", "BinaryLength": 16428},
        "3651": {"vr": "OB", "BinaryLength": 16424},
        "3652": {"vr": "OB", "BinaryLength": 16428},
        "3653": {"vr": "OB", "BinaryLength": 15624},
        "3654": {"vr": "OB", "BinaryLength": 15628},
        "3655": {"vr": "OB", "BinaryLength": 16412},
        "3656": {"vr": "OB", "BinaryLength": 16432},
        "3657": {"vr": "OB", "BinaryLength": 16416},
        "3658": {"vr": "OB", "BinaryLength": 16412},
        "3659": {"vr": "OB", "BinaryLength": 16428},
        "3660": {"vr": "OB", "BinaryLength": 16408},
        "3661": {"vr": "OB", "BinaryLength": 16424},
        "3662": {"vr": "OB", "BinaryLength": 16416},
        "3663": {"vr": "OB", "BinaryLength": 16416},
        "3664": {"vr": "OB", "BinaryLength": 16416},
        "3665": {"vr": "OB", "BinaryLength": 16428},
        "3666": {"vr": "OB", "BinaryLength": 16428},
        "3667": {"vr": "OB", "BinaryLength": 16428},
        "3668": {"vr": "OB", "BinaryLength": 15628},
        "3669": {"vr": "OB", "BinaryLength": 16424},
        "3670": {"vr": "OB", "BinaryLength": 16424},
        "3671": {"vr": "OB", "BinaryLength": 16428},
        "3672": {"vr": "OB", "BinaryLength": 16424},
        "3673": {"vr": "OB", "BinaryLength": 15624},
        "3674": {"vr": "OB", "BinaryLength": 16424},
        "3675": {"vr": "OB", "BinaryLength": 16432},
        "3676": {"vr": "OB", "BinaryLength": 16428},
        "3677": {"vr": "OB", "BinaryLength": 16424},
        "3678": {"vr": "OB", "BinaryLength": 16428},
        "3679": {"vr": "OB", "BinaryLength": 16428},
        "3680": {"vr": "OB", "BinaryLength": 16432},
        "3681": {"vr": "OB", "BinaryLength": 16412},
        "3682": {"vr": "OB", "BinaryLength": 16424},
        "3683": {"vr": "OB", "BinaryLength": 16432},
        "3684": {"vr": "OB", "BinaryLength": 16424},
        "3685": {"vr": "OB", "BinaryLength": 16432},
        "3686": {"vr": "OB", "BinaryLength": 16428},
        "3687": {"vr": "OB", "BinaryLength": 15624},
        "3688": {"vr": "OB", "BinaryLength": 16424},
        "3689": {"vr": "OB", "BinaryLength": 16428},
        "3690": {"vr": "OB", "BinaryLength": 16416},
        "3691": {"vr": "OB", "BinaryLength": 16432},
        "3692": {"vr": "OB", "BinaryLength": 16424},
        "3693": {"vr": "OB", "BinaryLength": 16424},
        "3694": {"vr": "OB", "BinaryLength": 16428},
        "3695": {"vr": "OB", "BinaryLength": 16424},
        "3696": {"vr": "OB", "BinaryLength": 15628},
        "3697": {"vr": "OB", "BinaryLength": 16428},
        "3698": {"vr": "OB", "BinaryLength": 15624},
        "3699": {"vr": "OB", "BinaryLength": 16424},
        "3700": {"vr": "OB", "BinaryLength": 16428},
        "3701": {"vr": "OB", "BinaryLength": 16408},
        "3702": {"vr": "OB", "BinaryLength": 16424},
        "3703": {"vr": "OB", "BinaryLength": 16432},
        "3704": {"vr": "OB", "BinaryLength": 16428},
        "3705": {"vr": "OB", "BinaryLength": 16424},
        "3706": {"vr": "OB", "BinaryLength": 16428},
        "3707": {"vr": "OB", "BinaryLength": 16424},
        "3708": {"vr": "OB", "BinaryLength": 16432},
        "3709": {"vr": "OB", "BinaryLength": 16432},
        "3710": {"vr": "OB", "BinaryLength": 16428},
        "3711": {"vr": "OB", "BinaryLength": 16424},
        "3712": {"vr": "OB", "BinaryLength": 16428},
        "3713": {"vr": "OB", "BinaryLength": 16396},
        "3714": {"vr": "OB", "BinaryLength": 16428},
        "3715": {"vr": "OB", "BinaryLength": 16416},
        "3716": {"vr": "OB", "BinaryLength": 15624},
        "3717": {"vr": "OB", "BinaryLength": 16428},
        "3718": {"vr": "OB", "BinaryLength": 16416},
        "3719": {"vr": "OB", "BinaryLength": 16412},
        "3720": {"vr": "OB", "BinaryLength": 16424},
        "3721": {"vr": "OB", "BinaryLength": 16428},
        "3722": {"vr": "OB", "BinaryLength": 16424},
        "3723": {"vr": "OB", "BinaryLength": 15624},
        "3724": {"vr": "OB", "BinaryLength": 16432},
        "3725": {"vr": "OB", "BinaryLength": 16416},
        "3726": {"vr": "OB", "BinaryLength": 16428},
        "3727": {"vr": "OB", "BinaryLength": 16428},
        "3728": {"vr": "OB", "BinaryLength": 16428},
        "3729": {"vr": "OB", "BinaryLength": 15624},
        "3730": {"vr": "OB", "BinaryLength": 16424},
        "3731": {"vr": "OB", "BinaryLength": 16432},
        "3732": {"vr": "OB", "BinaryLength": 16424},
        "3733": {"vr": "OB", "BinaryLength": 16400},
        "3734": {"vr": "OB", "BinaryLength": 16432},
        "3735": {"vr": "OB", "BinaryLength": 15624},
        "3736": {"vr": "OB", "BinaryLength": 16424},
        "3737": {"vr": "OB", "BinaryLength": 16424},
        "3738": {"vr": "OB", "BinaryLength": 16428},
        "3739": {"vr": "OB", "BinaryLength": 16416},
        "3740": {"vr": "OB", "BinaryLength": 16424},
        "3741": {"vr": "OB", "BinaryLength": 16416},
        "3742": {"vr": "OB", "BinaryLength": 15628},
        "3743": {"vr": "OB", "BinaryLength": 16428},
        "3744": {"vr": "OB", "BinaryLength": 15616},
        "3745": {"vr": "OB", "BinaryLength": 16400},
        "3746": {"vr": "OB", "BinaryLength": 16424},
        "3747": {"vr": "OB", "BinaryLength": 16416},
        "3748": {"vr": "OB", "BinaryLength": 16428},
        "3749": {"vr": "OB", "BinaryLength": 16428},
        "3750": {"vr": "OB", "BinaryLength": 16424},
        "3751": {"vr": "OB", "BinaryLength": 16428},
        "3752": {"vr": "OB", "BinaryLength": 16424},
        "3753": {"vr": "OB", "BinaryLength": 16424},
        "3754": {"vr": "OB", "BinaryLength": 16428},
        "3755": {"vr": "OB", "BinaryLength": 16428},
        "3756": {"vr": "OB", "BinaryLength": 15628},
        "3757": {"vr": "OB", "BinaryLength": 16416},
        "3758": {"vr": "OB", "BinaryLength": 16424},
        "3759": {"vr": "OB", "BinaryLength": 16424},
        "3760": {"vr": "OB", "BinaryLength": 16408},
        "3761": {"vr": "OB", "BinaryLength": 16424},
        "3762": {"vr": "OB", "BinaryLength": 16424},
        "3763": {"vr": "OB", "BinaryLength": 15624},
        "3764": {"vr": "OB", "BinaryLength": 16428},
        "3765": {"vr": "OB", "BinaryLength": 16412},
        "3766": {"vr": "OB", "BinaryLength": 16428},
        "3767": {"vr": "OB", "BinaryLength": 16424},
        "3768": {"vr": "OB", "BinaryLength": 16428},
        "3769": {"vr": "OB", "BinaryLength": 16424},
        "3770": {"vr": "OB", "BinaryLength": 16424},
        "3771": {"vr": "OB", "BinaryLength": 16428},
        "3772": {"vr": "OB", "BinaryLength": 16428},
        "3773": {"vr": "OB", "BinaryLength": 16416},
        "3774": {"vr": "OB", "BinaryLength": 16428},
        "3775": {"vr": "OB", "BinaryLength": 16428},
        "3776": {"vr": "OB", "BinaryLength": 16396},
        "3777": {"vr": "OB", "BinaryLength": 16428},
        "3778": {"vr": "OB", "BinaryLength": 16412},
        "3779": {"vr": "OB", "BinaryLength": 16432},
        "3780": {"vr": "OB", "BinaryLength": 16412},
        "3781": {"vr": "OB", "BinaryLength": 16416},
        "3782": {"vr": "OB", "BinaryLength": 16408},
        "3783": {"vr": "OB", "BinaryLength": 16428},
        "3784": {"vr": "OB", "BinaryLength": 16428},
        "3785": {"vr": "OB", "BinaryLength": 16424},
        "3786": {"vr": "OB", "BinaryLength": 16428},
        "3787": {"vr": "OB", "BinaryLength": 16396},
        "3788": {"vr": "OB", "BinaryLength": 15624},
        "3789": {"vr": "OB", "BinaryLength": 16428},
        "3790": {"vr": "OB", "BinaryLength": 16412},
        "3791": {"vr": "OB", "BinaryLength": 16416},
        "3792": {"vr": "OB", "BinaryLength": 16428},
        "3793": {"vr": "OB", "BinaryLength": 16428},
        "3794": {"vr": "OB", "BinaryLength": 16396},
        "3795": {"vr": "OB", "BinaryLength": 15624},
        "3796": {"vr": "OB", "BinaryLength": 16428},
        "3797": {"vr": "OB", "BinaryLength": 16432},
        "3798": {"vr": "OB", "BinaryLength": 16428},
        "3799": {"vr": "OB", "BinaryLength": 16424},
        "3800": {"vr": "OB", "BinaryLength": 16432},
        "3801": {"vr": "OB", "BinaryLength": 16428},
        "3802": {"vr": "OB", "BinaryLength": 16432},
        "3803": {"vr": "OB", "BinaryLength": 16416},
        "3804": {"vr": "OB", "BinaryLength": 16416},
        "3805": {"vr": "OB", "BinaryLength": 15624},
        "3806": {"vr": "OB", "BinaryLength": 15624},
        "3807": {"vr": "OB", "BinaryLength": 16424},
        "3808": {"vr": "OB", "BinaryLength": 16428},
        "3809": {"vr": "OB", "BinaryLength": 16416},
        "3810": {"vr": "OB", "BinaryLength": 16424},
        "3811": {"vr": "OB", "BinaryLength": 16428},
        "3812": {"vr": "OB", "BinaryLength": 16412},
        "3813": {"vr": "OB", "BinaryLength": 16428},
        "3814": {"vr": "OB", "BinaryLength": 16424},
        "3815": {"vr": "OB", "BinaryLength": 16428},
        "3816": {"vr": "OB", "BinaryLength": 16424},
        "3817": {"vr": "OB", "BinaryLength": 16432},
        "3818": {"vr": "OB", "BinaryLength": 16424},
        "3819": {"vr": "OB", "BinaryLength": 16432},
        "3820": {"vr": "OB", "BinaryLength": 16428},
        "3821": {"vr": "OB", "BinaryLength": 16428},
        "3822": {"vr": "OB", "BinaryLength": 16432},
        "3823": {"vr": "OB", "BinaryLength": 16428},
        "3824": {"vr": "OB", "BinaryLength": 16412},
        "3825": {"vr": "OB", "BinaryLength": 15624},
        "3826": {"vr": "OB", "BinaryLength": 16424},
        "3827": {"vr": "OB", "BinaryLength": 16424},
        "3828": {"vr": "OB", "BinaryLength": 16432},
        "3829": {"vr": "OB", "BinaryLength": 16416},
        "3830": {"vr": "OB", "BinaryLength": 16424},
        "3831": {"vr": "OB", "BinaryLength": 16428},
        "3832": {"vr": "OB", "BinaryLength": 15624},
        "3833": {"vr": "OB", "BinaryLength": 16428},
        "3834": {"vr": "OB", "BinaryLength": 16412},
        "3835": {"vr": "OB", "BinaryLength": 16428},
        "3836": {"vr": "OB", "BinaryLength": 16428},
        "3837": {"vr": "OB", "BinaryLength": 16428},
        "3838": {"vr": "OB", "BinaryLength": 16396},
        "3839": {"vr": "OB", "BinaryLength": 16396},
        "3840": {"vr": "OB", "BinaryLength": 16428},
        "3841": {"vr": "OB", "BinaryLength": 16416},
        "3842": {"vr": "OB", "BinaryLength": 16412},
        "3843": {"vr": "OB", "BinaryLength": 16428},
        "3844": {"vr": "OB", "BinaryLength": 16416},
        "3845": {"vr": "OB", "BinaryLength": 15624},
        "3846": {"vr": "OB", "BinaryLength": 16432},
        "3847": {"vr": "OB", "BinaryLength": 16416},
        "3848": {"vr": "OB", "BinaryLength": 16428},
        "3849": {"vr": "OB", "BinaryLength": 16428},
        "3850": {"vr": "OB", "BinaryLength": 16428},
        "3851": {"vr": "OB", "BinaryLength": 16424},
        "3852": {"vr": "OB", "BinaryLength": 16424},
        "3853": {"vr": "OB", "BinaryLength": 16424},
        "3854": {"vr": "OB", "BinaryLength": 16428},
        "3855": {"vr": "OB", "BinaryLength": 15624},
        "3856": {"vr": "OB", "BinaryLength": 16400},
        "3857": {"vr": "OB", "BinaryLength": 16424},
        "3858": {"vr": "OB", "BinaryLength": 16400},
        "3859": {"vr": "OB", "BinaryLength": 16424},
        "3860": {"vr": "OB", "BinaryLength": 16428},
        "3861": {"vr": "OB", "BinaryLength": 16428},
        "3862": {"vr": "OB", "BinaryLength": 16428},
        "3863": {"vr": "OB", "BinaryLength": 15624},
        "3864": {"vr": "OB", "BinaryLength": 16428},
        "3865": {"vr": "OB", "BinaryLength": 16428},
        "3866": {"vr": "OB", "BinaryLength": 16428},
        "3867": {"vr": "OB", "BinaryLength": 16424},
        "3868": {"vr": "OB", "BinaryLength": 16412},
        "3869": {"vr": "OB", "BinaryLength": 16432},
        "3870": {"vr": "OB", "BinaryLength": 16428},
        "3871": {"vr": "OB", "BinaryLength": 16416},
        "3872": {"vr": "OB", "BinaryLength": 16424},
        "3873": {"vr": "OB", "BinaryLength": 16432},
        "3874": {"vr": "OB", "BinaryLength": 16428},
        "3875": {"vr": "OB", "BinaryLength": 16416},
        "3876": {"vr": "OB", "BinaryLength": 16432},
        "3877": {"vr": "OB", "BinaryLength": 16428},
        "3878": {"vr": "OB", "BinaryLength": 15628},
        "3879": {"vr": "OB", "BinaryLength": 16428},
        "3880": {"vr": "OB", "BinaryLength": 16428},
        "3881": {"vr": "OB", "BinaryLength": 16428},
        "3882": {"vr": "OB", "BinaryLength": 15624},
        "3883": {"vr": "OB", "BinaryLength": 16424},
        "3884": {"vr": "OB", "BinaryLength": 16428},
        "3885": {"vr": "OB", "BinaryLength": 15624},
        "3886": {"vr": "OB", "BinaryLength": 16424},
        "3887": {"vr": "OB", "BinaryLength": 16424},
        "3888": {"vr": "OB", "BinaryLength": 16424},
        "3889": {"vr": "OB", "BinaryLength": 16416},
        "3890": {"vr": "OB", "BinaryLength": 16428},
        "3891": {"vr": "OB", "BinaryLength": 16428},
        "3892": {"vr": "OB", "BinaryLength": 16428},
        "3893": {"vr": "OB", "BinaryLength": 16428},
        "3894": {"vr": "OB", "BinaryLength": 16424},
        "3895": {"vr": "OB", "BinaryLength": 16424},
        "3896": {"vr": "OB", "BinaryLength": 16428},
        "3897": {"vr": "OB", "BinaryLength": 16428},
        "3898": {"vr": "OB", "BinaryLength": 16428},
        "3899": {"vr": "OB", "BinaryLength": 16428},
        "3900": {"vr": "OB", "BinaryLength": 15624},
        "3901": {"vr": "OB", "BinaryLength": 16424},
        "3902": {"vr": "OB", "BinaryLength": 16424},
        "3903": {"vr": "OB", "BinaryLength": 16428},
        "3904": {"vr": "OB", "BinaryLength": 16428},
        "3905": {"vr": "OB", "BinaryLength": 16428},
        "3906": {"vr": "OB", "BinaryLength": 16424},
        "3907": {"vr": "OB", "BinaryLength": 16432},
        "3908": {"vr": "OB", "BinaryLength": 16424},
        "3909": {"vr": "OB", "BinaryLength": 16424},
        "3910": {"vr": "OB", "BinaryLength": 16424},
        "3911": {"vr": "OB", "BinaryLength": 16424},
        "3912": {"vr": "OB", "BinaryLength": 16428},
        "3913": {"vr": "OB", "BinaryLength": 16428},
        "3914": {"vr": "OB", "BinaryLength": 16428},
        "3915": {"vr": "OB", "BinaryLength": 16396},
        "3916": {"vr": "OB", "BinaryLength": 15624},
        "3917": {"vr": "OB", "BinaryLength": 16424},
        "3918": {"vr": "OB", "BinaryLength": 16432},
        "3919": {"vr": "OB", "BinaryLength": 16428},
        "3920": {"vr": "OB", "BinaryLength": 16424},
        "3921": {"vr": "OB", "BinaryLength": 16424},
        "3922": {"vr": "OB", "BinaryLength": 16428},
        "3923": {"vr": "OB", "BinaryLength": 16408},
        "3924": {"vr": "OB", "BinaryLength": 16400},
        "3925": {"vr": "OB", "BinaryLength": 16424},
        "3926": {"vr": "OB", "BinaryLength": 16428},
        "3927": {"vr": "OB", "BinaryLength": 16428},
        "3928": {"vr": "OB", "BinaryLength": 15628},
        "3929": {"vr": "OB", "BinaryLength": 16416},
        "3930": {"vr": "OB", "BinaryLength": 16428},
        "3931": {"vr": "OB", "BinaryLength": 16428},
        "3932": {"vr": "OB", "BinaryLength": 16428},
        "3933": {"vr": "OB", "BinaryLength": 16428},
        "3934": {"vr": "OB", "BinaryLength": 16428},
        "3935": {"vr": "OB", "BinaryLength": 16428},
        "3936": {"vr": "OB", "BinaryLength": 16424},
        "3937": {"vr": "OB", "BinaryLength": 15628},
        "3938": {"vr": "OB", "BinaryLength": 16428},
        "3939": {"vr": "OB", "BinaryLength": 16424},
        "3940": {"vr": "OB", "BinaryLength": 16424},
        "3941": {"vr": "OB", "BinaryLength": 16424},
        "3942": {"vr": "OB", "BinaryLength": 16428},
        "3943": {"vr": "OB", "BinaryLength": 16428},
        "3944": {"vr": "OB", "BinaryLength": 16416},
        "3945": {"vr": "OB", "BinaryLength": 15628},
        "3946": {"vr": "OB", "BinaryLength": 16432},
        "3947": {"vr": "OB", "BinaryLength": 16424},
        "3948": {"vr": "OB", "BinaryLength": 16428},
        "3949": {"vr": "OB", "BinaryLength": 16428},
        "3950": {"vr": "OB", "BinaryLength": 16428},
        "3951": {"vr": "OB", "BinaryLength": 16428},
        "3952": {"vr": "OB", "BinaryLength": 16424},
        "3953": {"vr": "OB", "BinaryLength": 16424},
        "3954": {"vr": "OB", "BinaryLength": 16424},
        "3955": {"vr": "OB", "BinaryLength": 16412},
        "3956": {"vr": "OB", "BinaryLength": 16424},
        "3957": {"vr": "OB", "BinaryLength": 16428},
        "3958": {"vr": "OB", "BinaryLength": 16428},
        "3959": {"vr": "OB", "BinaryLength": 16428},
        "3960": {"vr": "OB", "BinaryLength": 16428},
        "3961": {"vr": "OB", "BinaryLength": 16428},
        "3962": {"vr": "OB", "BinaryLength": 16424},
        "3963": {"vr": "OB", "BinaryLength": 16428},
        "3964": {"vr": "OB", "BinaryLength": 16428},
        "3965": {"vr": "OB", "BinaryLength": 16428},
        "3966": {"vr": "OB", "BinaryLength": 16412},
        "3967": {"vr": "OB", "BinaryLength": 16424},
        "3968": {"vr": "OB", "BinaryLength": 15624},
        "3969": {"vr": "OB", "BinaryLength": 16424},
        "3970": {"vr": "OB", "BinaryLength": 16424},
        "3971": {"vr": "OB", "BinaryLength": 16424},
        "3972": {"vr": "OB", "BinaryLength": 16432},
        "3973": {"vr": "OB", "BinaryLength": 16428},
        "3974": {"vr": "OB", "BinaryLength": 16428},
        "3975": {"vr": "OB", "BinaryLength": 16424},
        "3976": {"vr": "OB", "BinaryLength": 16400},
        "3977": {"vr": "OB", "BinaryLength": 16416},
        "3978": {"vr": "OB", "BinaryLength": 16428},
        "3979": {"vr": "OB", "BinaryLength": 16432},
        "3980": {"vr": "OB", "BinaryLength": 16424},
        "3981": {"vr": "OB", "BinaryLength": 16428},
        "3982": {"vr": "OB", "BinaryLength": 16428},
        "3983": {"vr": "OB", "BinaryLength": 16416},
        "3984": {"vr": "OB", "BinaryLength": 16432},
        "3985": {"vr": "OB", "BinaryLength": 16432},
        "3986": {"vr": "OB", "BinaryLength": 16428},
        "3987": {"vr": "OB", "BinaryLength": 16424},
        "3988": {"vr": "OB", "BinaryLength": 16428},
        "3989": {"vr": "OB", "BinaryLength": 16424},
        "3990": {"vr": "OB", "BinaryLength": 16416},
        "3991": {"vr": "OB", "BinaryLength": 16416},
        "3992": {"vr": "OB", "BinaryLength": 16428},
        "3993": {"vr": "OB", "BinaryLength": 16416},
        "3994": {"vr": "OB", "BinaryLength": 16428},
        "3995": {"vr": "OB", "BinaryLength": 16416},
        "3996": {"vr": "OB", "BinaryLength": 16416},
        "3997": {"vr": "OB", "BinaryLength": 16428},
        "3998": {"vr": "OB", "BinaryLength": 16432},
        "3999": {"vr": "OB", "BinaryLength": 16428},
        "4000": {"vr": "OB", "BinaryLength": 16428},
        "4001": {"vr": "OB", "BinaryLength": 16428},
        "4002": {"vr": "OB", "BinaryLength": 16424},
        "4003": {"vr": "OB", "BinaryLength": 16428},
        "4004": {"vr": "OB", "BinaryLength": 16424},
        "4005": {"vr": "OB", "BinaryLength": 16428},
        "4006": {"vr": "OB", "BinaryLength": 16424},
        "4007": {"vr": "OB", "BinaryLength": 16424},
        "4008": {"vr": "OB", "BinaryLength": 16428},
        "4009": {"vr": "OB", "BinaryLength": 15624},
        "4010": {"vr": "OB", "BinaryLength": 16428},
        "4011": {"vr": "OB", "BinaryLength": 15624},
        "4012": {"vr": "OB", "BinaryLength": 16428},
        "4013": {"vr": "OB", "BinaryLength": 16416},
        "4014": {"vr": "OB", "BinaryLength": 16432},
        "4015": {"vr": "OB", "BinaryLength": 16416},
        "4016": {"vr": "OB", "BinaryLength": 16428},
        "4017": {"vr": "OB", "BinaryLength": 16428},
        "4018": {"vr": "OB", "BinaryLength": 16428},
        "4019": {"vr": "OB", "BinaryLength": 16424},
    },
    "00291020": {
        "0": {"vr": "OB", "BinaryLength": 201600},
        "1": {"vr": "OB", "BinaryLength": 201600},
        "2": {"vr": "OB", "BinaryLength": 201600},
        "3": {"vr": "OB", "BinaryLength": 201600},
        "4": {"vr": "OB", "BinaryLength": 201600},
        "5": {"vr": "OB", "BinaryLength": 201600},
        "6": {"vr": "OB", "BinaryLength": 201600},
        "7": {"vr": "OB", "BinaryLength": 201600},
        "8": {"vr": "OB", "BinaryLength": 201600},
        "9": {"vr": "OB", "BinaryLength": 201600},
        "10": {"vr": "OB", "BinaryLength": 201600},
        "11": {"vr": "OB", "BinaryLength": 201600},
        "12": {"vr": "OB", "BinaryLength": 201600},
        "13": {"vr": "OB", "BinaryLength": 201600},
        "14": {"vr": "OB", "BinaryLength": 201600},
        "15": {"vr": "OB", "BinaryLength": 201600},
        "16": {"vr": "OB", "BinaryLength": 201600},
        "17": {"vr": "OB", "BinaryLength": 201600},
        "18": {"vr": "OB", "BinaryLength": 201600},
        "19": {"vr": "OB", "BinaryLength": 201600},
        "20": {"vr": "OB", "BinaryLength": 201600},
        "21": {"vr": "OB", "BinaryLength": 201600},
        "22": {"vr": "OB", "BinaryLength": 201600},
        "23": {"vr": "OB", "BinaryLength": 201600},
        "24": {"vr": "OB", "BinaryLength": 201600},
        "25": {"vr": "OB", "BinaryLength": 201600},
        "26": {"vr": "OB", "BinaryLength": 201600},
        "27": {"vr": "OB", "BinaryLength": 201600},
        "28": {"vr": "OB", "BinaryLength": 201600},
        "29": {"vr": "OB", "BinaryLength": 201600},
        "30": {"vr": "OB", "BinaryLength": 201600},
        "31": {"vr": "OB", "BinaryLength": 201600},
        "32": {"vr": "OB", "BinaryLength": 201600},
        "33": {"vr": "OB", "BinaryLength": 201600},
        "34": {"vr": "OB", "BinaryLength": 201600},
        "35": {"vr": "OB", "BinaryLength": 201600},
        "36": {"vr": "OB", "BinaryLength": 201600},
        "37": {"vr": "OB", "BinaryLength": 201600},
        "38": {"vr": "OB", "BinaryLength": 201600},
        "39": {"vr": "OB", "BinaryLength": 201600},
        "40": {"vr": "OB", "BinaryLength": 201600},
        "41": {"vr": "OB", "BinaryLength": 201600},
        "42": {"vr": "OB", "BinaryLength": 201600},
        "43": {"vr": "OB", "BinaryLength": 201600},
        "44": {"vr": "OB", "BinaryLength": 201600},
        "45": {"vr": "OB", "BinaryLength": 201600},
        "46": {"vr": "OB", "BinaryLength": 201600},
        "47": {"vr": "OB", "BinaryLength": 201600},
        "48": {"vr": "OB", "BinaryLength": 201600},
        "49": {"vr": "OB", "BinaryLength": 201600},
        "50": {"vr": "OB", "BinaryLength": 201600},
        "51": {"vr": "OB", "BinaryLength": 201600},
        "52": {"vr": "OB", "BinaryLength": 201600},
        "53": {"vr": "OB", "BinaryLength": 201600},
        "54": {"vr": "OB", "BinaryLength": 201600},
        "55": {"vr": "OB", "BinaryLength": 201600},
        "56": {"vr": "OB", "BinaryLength": 201600},
        "57": {"vr": "OB", "BinaryLength": 201600},
        "58": {"vr": "OB", "BinaryLength": 201600},
        "59": {"vr": "OB", "BinaryLength": 201600},
        "60": {"vr": "OB", "BinaryLength": 201600},
        "61": {"vr": "OB", "BinaryLength": 201600},
        "62": {"vr": "OB", "BinaryLength": 201600},
        "63": {"vr": "OB", "BinaryLength": 201600},
        "64": {"vr": "OB", "BinaryLength": 201600},
        "65": {"vr": "OB", "BinaryLength": 201600},
        "66": {"vr": "OB", "BinaryLength": 201600},
        "67": {"vr": "OB", "BinaryLength": 201600},
        "68": {"vr": "OB", "BinaryLength": 201600},
        "69": {"vr": "OB", "BinaryLength": 201600},
        "70": {"vr": "OB", "BinaryLength": 201600},
        "71": {"vr": "OB", "BinaryLength": 201600},
        "72": {"vr": "OB", "BinaryLength": 201600},
        "73": {"vr": "OB", "BinaryLength": 201600},
        "74": {"vr": "OB", "BinaryLength": 201600},
        "75": {"vr": "OB", "BinaryLength": 201600},
        "76": {"vr": "OB", "BinaryLength": 201600},
        "77": {"vr": "OB", "BinaryLength": 201600},
        "78": {"vr": "OB", "BinaryLength": 201600},
        "79": {"vr": "OB", "BinaryLength": 201600},
        "80": {"vr": "OB", "BinaryLength": 201600},
        "81": {"vr": "OB", "BinaryLength": 201600},
        "82": {"vr": "OB", "BinaryLength": 201600},
        "83": {"vr": "OB", "BinaryLength": 201600},
        "84": {"vr": "OB", "BinaryLength": 201600},
        "85": {"vr": "OB", "BinaryLength": 201600},
        "86": {"vr": "OB", "BinaryLength": 201600},
        "87": {"vr": "OB", "BinaryLength": 201600},
        "88": {"vr": "OB", "BinaryLength": 201600},
        "89": {"vr": "OB", "BinaryLength": 201600},
        "90": {"vr": "OB", "BinaryLength": 201600},
        "91": {"vr": "OB", "BinaryLength": 201600},
        "92": {"vr": "OB", "BinaryLength": 201600},
        "93": {"vr": "OB", "BinaryLength": 201600},
        "94": {"vr": "OB", "BinaryLength": 201600},
        "95": {"vr": "OB", "BinaryLength": 201600},
        "96": {"vr": "OB", "BinaryLength": 201600},
        "97": {"vr": "OB", "BinaryLength": 201600},
        "98": {"vr": "OB", "BinaryLength": 201600},
        "99": {"vr": "OB", "BinaryLength": 201600},
        "100": {"vr": "OB", "BinaryLength": 201600},
        "101": {"vr": "OB", "BinaryLength": 201600},
        "102": {"vr": "OB", "BinaryLength": 201600},
        "103": {"vr": "OB", "BinaryLength": 201600},
        "104": {"vr": "OB", "BinaryLength": 201600},
        "105": {"vr": "OB", "BinaryLength": 201600},
        "106": {"vr": "OB", "BinaryLength": 201600},
        "107": {"vr": "OB", "BinaryLength": 201600},
        "108": {"vr": "OB", "BinaryLength": 201600},
        "109": {"vr": "OB", "BinaryLength": 201600},
        "110": {"vr": "OB", "BinaryLength": 201600},
        "111": {"vr": "OB", "BinaryLength": 201600},
        "112": {"vr": "OB", "BinaryLength": 201600},
        "113": {"vr": "OB", "BinaryLength": 201600},
        "114": {"vr": "OB", "BinaryLength": 201600},
        "115": {"vr": "OB", "BinaryLength": 201600},
        "116": {"vr": "OB", "BinaryLength": 201600},
        "117": {"vr": "OB", "BinaryLength": 201600},
        "118": {"vr": "OB", "BinaryLength": 201600},
        "119": {"vr": "OB", "BinaryLength": 201600},
        "120": {"vr": "OB", "BinaryLength": 201600},
        "121": {"vr": "OB", "BinaryLength": 201600},
        "122": {"vr": "OB", "BinaryLength": 201600},
        "123": {"vr": "OB", "BinaryLength": 201600},
        "124": {"vr": "OB", "BinaryLength": 201600},
        "125": {"vr": "OB", "BinaryLength": 201600},
        "126": {"vr": "OB", "BinaryLength": 201600},
        "127": {"vr": "OB", "BinaryLength": 201600},
        "128": {"vr": "OB", "BinaryLength": 201600},
        "129": {"vr": "OB", "BinaryLength": 201600},
        "130": {"vr": "OB", "BinaryLength": 201600},
        "131": {"vr": "OB", "BinaryLength": 201600},
        "132": {"vr": "OB", "BinaryLength": 201600},
        "133": {"vr": "OB", "BinaryLength": 201600},
        "134": {"vr": "OB", "BinaryLength": 201600},
        "135": {"vr": "OB", "BinaryLength": 201600},
        "136": {"vr": "OB", "BinaryLength": 201600},
        "137": {"vr": "OB", "BinaryLength": 201600},
        "138": {"vr": "OB", "BinaryLength": 201600},
        "139": {"vr": "OB", "BinaryLength": 201600},
        "140": {"vr": "OB", "BinaryLength": 201600},
        "141": {"vr": "OB", "BinaryLength": 201600},
        "142": {"vr": "OB", "BinaryLength": 201600},
        "143": {"vr": "OB", "BinaryLength": 201600},
        "144": {"vr": "OB", "BinaryLength": 201600},
        "145": {"vr": "OB", "BinaryLength": 201600},
        "146": {"vr": "OB", "BinaryLength": 201600},
        "147": {"vr": "OB", "BinaryLength": 201600},
        "148": {"vr": "OB", "BinaryLength": 201600},
        "149": {"vr": "OB", "BinaryLength": 201600},
        "150": {"vr": "OB", "BinaryLength": 201600},
        "151": {"vr": "OB", "BinaryLength": 201600},
        "152": {"vr": "OB", "BinaryLength": 201600},
        "153": {"vr": "OB", "BinaryLength": 201600},
        "154": {"vr": "OB", "BinaryLength": 201600},
        "155": {"vr": "OB", "BinaryLength": 201600},
        "156": {"vr": "OB", "BinaryLength": 201600},
        "157": {"vr": "OB", "BinaryLength": 201600},
        "158": {"vr": "OB", "BinaryLength": 201600},
        "159": {"vr": "OB", "BinaryLength": 201600},
        "160": {"vr": "OB", "BinaryLength": 201600},
        "161": {"vr": "OB", "BinaryLength": 201600},
        "162": {"vr": "OB", "BinaryLength": 201600},
        "163": {"vr": "OB", "BinaryLength": 201600},
        "164": {"vr": "OB", "BinaryLength": 201600},
        "165": {"vr": "OB", "BinaryLength": 201600},
        "166": {"vr": "OB", "BinaryLength": 201600},
        "167": {"vr": "OB", "BinaryLength": 201600},
        "168": {"vr": "OB", "BinaryLength": 201600},
        "169": {"vr": "OB", "BinaryLength": 201600},
        "170": {"vr": "OB", "BinaryLength": 201600},
        "171": {"vr": "OB", "BinaryLength": 201600},
        "172": {"vr": "OB", "BinaryLength": 201600},
        "173": {"vr": "OB", "BinaryLength": 201600},
        "174": {"vr": "OB", "BinaryLength": 201600},
        "175": {"vr": "OB", "BinaryLength": 201600},
        "176": {"vr": "OB", "BinaryLength": 201600},
        "177": {"vr": "OB", "BinaryLength": 201600},
        "178": {"vr": "OB", "BinaryLength": 201600},
        "179": {"vr": "OB", "BinaryLength": 201600},
        "180": {"vr": "OB", "BinaryLength": 201600},
        "181": {"vr": "OB", "BinaryLength": 201600},
        "182": {"vr": "OB", "BinaryLength": 201600},
        "183": {"vr": "OB", "BinaryLength": 201600},
        "184": {"vr": "OB", "BinaryLength": 201600},
        "185": {"vr": "OB", "BinaryLength": 201600},
        "186": {"vr": "OB", "BinaryLength": 201600},
        "187": {"vr": "OB", "BinaryLength": 201600},
        "188": {"vr": "OB", "BinaryLength": 201600},
        "189": {"vr": "OB", "BinaryLength": 201600},
        "190": {"vr": "OB", "BinaryLength": 201600},
        "191": {"vr": "OB", "BinaryLength": 201600},
        "192": {"vr": "OB", "BinaryLength": 201600},
        "193": {"vr": "OB", "BinaryLength": 201600},
        "194": {"vr": "OB", "BinaryLength": 201600},
        "195": {"vr": "OB", "BinaryLength": 201600},
        "196": {"vr": "OB", "BinaryLength": 201600},
        "197": {"vr": "OB", "BinaryLength": 201600},
        "198": {"vr": "OB", "BinaryLength": 201600},
        "199": {"vr": "OB", "BinaryLength": 201600},
        "200": {"vr": "OB", "BinaryLength": 201600},
        "201": {"vr": "OB", "BinaryLength": 201600},
        "202": {"vr": "OB", "BinaryLength": 201600},
        "203": {"vr": "OB", "BinaryLength": 201600},
        "204": {"vr": "OB", "BinaryLength": 201600},
        "205": {"vr": "OB", "BinaryLength": 201600},
        "206": {"vr": "OB", "BinaryLength": 201600},
        "207": {"vr": "OB", "BinaryLength": 201600},
        "208": {"vr": "OB", "BinaryLength": 201600},
        "209": {"vr": "OB", "BinaryLength": 201600},
        "210": {"vr": "OB", "BinaryLength": 201600},
        "211": {"vr": "OB", "BinaryLength": 201600},
        "212": {"vr": "OB", "BinaryLength": 201600},
        "213": {"vr": "OB", "BinaryLength": 201600},
        "214": {"vr": "OB", "BinaryLength": 201600},
        "215": {"vr": "OB", "BinaryLength": 201600},
        "216": {"vr": "OB", "BinaryLength": 201600},
        "217": {"vr": "OB", "BinaryLength": 201600},
        "218": {"vr": "OB", "BinaryLength": 201600},
        "219": {"vr": "OB", "BinaryLength": 201600},
        "220": {"vr": "OB", "BinaryLength": 201600},
        "221": {"vr": "OB", "BinaryLength": 201600},
        "222": {"vr": "OB", "BinaryLength": 201600},
        "223": {"vr": "OB", "BinaryLength": 201600},
        "224": {"vr": "OB", "BinaryLength": 201600},
        "225": {"vr": "OB", "BinaryLength": 201600},
        "226": {"vr": "OB", "BinaryLength": 201600},
        "227": {"vr": "OB", "BinaryLength": 201600},
        "228": {"vr": "OB", "BinaryLength": 201600},
        "229": {"vr": "OB", "BinaryLength": 201600},
        "230": {"vr": "OB", "BinaryLength": 201600},
        "231": {"vr": "OB", "BinaryLength": 201600},
        "232": {"vr": "OB", "BinaryLength": 201600},
        "233": {"vr": "OB", "BinaryLength": 201600},
        "234": {"vr": "OB", "BinaryLength": 201600},
        "235": {"vr": "OB", "BinaryLength": 201600},
        "236": {"vr": "OB", "BinaryLength": 201600},
        "237": {"vr": "OB", "BinaryLength": 201600},
        "238": {"vr": "OB", "BinaryLength": 201600},
        "239": {"vr": "OB", "BinaryLength": 201600},
        "240": {"vr": "OB", "BinaryLength": 201600},
        "241": {"vr": "OB", "BinaryLength": 201600},
        "242": {"vr": "OB", "BinaryLength": 201600},
        "243": {"vr": "OB", "BinaryLength": 201600},
        "244": {"vr": "OB", "BinaryLength": 201600},
        "245": {"vr": "OB", "BinaryLength": 201600},
        "246": {"vr": "OB", "BinaryLength": 201600},
        "247": {"vr": "OB", "BinaryLength": 201600},
        "248": {"vr": "OB", "BinaryLength": 201600},
        "249": {"vr": "OB", "BinaryLength": 201600},
        "250": {"vr": "OB", "BinaryLength": 201600},
        "251": {"vr": "OB", "BinaryLength": 201600},
        "252": {"vr": "OB", "BinaryLength": 201600},
        "253": {"vr": "OB", "BinaryLength": 201600},
        "254": {"vr": "OB", "BinaryLength": 201600},
        "255": {"vr": "OB", "BinaryLength": 201600},
        "256": {"vr": "OB", "BinaryLength": 201600},
        "257": {"vr": "OB", "BinaryLength": 201600},
        "258": {"vr": "OB", "BinaryLength": 201600},
        "259": {"vr": "OB", "BinaryLength": 201600},
        "260": {"vr": "OB", "BinaryLength": 201600},
        "261": {"vr": "OB", "BinaryLength": 201600},
        "262": {"vr": "OB", "BinaryLength": 201600},
        "263": {"vr": "OB", "BinaryLength": 201600},
        "264": {"vr": "OB", "BinaryLength": 201600},
        "265": {"vr": "OB", "BinaryLength": 201600},
        "266": {"vr": "OB", "BinaryLength": 201600},
        "267": {"vr": "OB", "BinaryLength": 201600},
        "268": {"vr": "OB", "BinaryLength": 201600},
        "269": {"vr": "OB", "BinaryLength": 201600},
        "270": {"vr": "OB", "BinaryLength": 201600},
        "271": {"vr": "OB", "BinaryLength": 201600},
        "272": {"vr": "OB", "BinaryLength": 201600},
        "273": {"vr": "OB", "BinaryLength": 201600},
        "274": {"vr": "OB", "BinaryLength": 201600},
        "275": {"vr": "OB", "BinaryLength": 201600},
        "276": {"vr": "OB", "BinaryLength": 201600},
        "277": {"vr": "OB", "BinaryLength": 201600},
        "278": {"vr": "OB", "BinaryLength": 201600},
        "279": {"vr": "OB", "BinaryLength": 201600},
        "280": {"vr": "OB", "BinaryLength": 201600},
        "281": {"vr": "OB", "BinaryLength": 201600},
        "282": {"vr": "OB", "BinaryLength": 201600},
        "283": {"vr": "OB", "BinaryLength": 201600},
        "284": {"vr": "OB", "BinaryLength": 201600},
        "285": {"vr": "OB", "BinaryLength": 201600},
        "286": {"vr": "OB", "BinaryLength": 201600},
        "287": {"vr": "OB", "BinaryLength": 201600},
        "288": {"vr": "OB", "BinaryLength": 201600},
        "289": {"vr": "OB", "BinaryLength": 201600},
        "290": {"vr": "OB", "BinaryLength": 201600},
        "291": {"vr": "OB", "BinaryLength": 201600},
        "292": {"vr": "OB", "BinaryLength": 201600},
        "293": {"vr": "OB", "BinaryLength": 201600},
        "294": {"vr": "OB", "BinaryLength": 201600},
        "295": {"vr": "OB", "BinaryLength": 201600},
        "296": {"vr": "OB", "BinaryLength": 201600},
        "297": {"vr": "OB", "BinaryLength": 201600},
        "298": {"vr": "OB", "BinaryLength": 201600},
        "299": {"vr": "OB", "BinaryLength": 201600},
        "300": {"vr": "OB", "BinaryLength": 201600},
        "301": {"vr": "OB", "BinaryLength": 201600},
        "302": {"vr": "OB", "BinaryLength": 201600},
        "303": {"vr": "OB", "BinaryLength": 201600},
        "304": {"vr": "OB", "BinaryLength": 201600},
        "305": {"vr": "OB", "BinaryLength": 201600},
        "306": {"vr": "OB", "BinaryLength": 201600},
        "307": {"vr": "OB", "BinaryLength": 201600},
        "308": {"vr": "OB", "BinaryLength": 201600},
        "309": {"vr": "OB", "BinaryLength": 201600},
        "310": {"vr": "OB", "BinaryLength": 201600},
        "311": {"vr": "OB", "BinaryLength": 201600},
        "312": {"vr": "OB", "BinaryLength": 201600},
        "313": {"vr": "OB", "BinaryLength": 201600},
        "314": {"vr": "OB", "BinaryLength": 201600},
        "315": {"vr": "OB", "BinaryLength": 201600},
        "316": {"vr": "OB", "BinaryLength": 201600},
        "317": {"vr": "OB", "BinaryLength": 201600},
        "318": {"vr": "OB", "BinaryLength": 201600},
        "319": {"vr": "OB", "BinaryLength": 201600},
        "320": {"vr": "OB", "BinaryLength": 201600},
        "321": {"vr": "OB", "BinaryLength": 201600},
        "322": {"vr": "OB", "BinaryLength": 201600},
        "323": {"vr": "OB", "BinaryLength": 201600},
        "324": {"vr": "OB", "BinaryLength": 201600},
        "325": {"vr": "OB", "BinaryLength": 201600},
        "326": {"vr": "OB", "BinaryLength": 201600},
        "327": {"vr": "OB", "BinaryLength": 201600},
        "328": {"vr": "OB", "BinaryLength": 201600},
        "329": {"vr": "OB", "BinaryLength": 201600},
        "330": {"vr": "OB", "BinaryLength": 201600},
        "331": {"vr": "OB", "BinaryLength": 201600},
        "332": {"vr": "OB", "BinaryLength": 201600},
        "333": {"vr": "OB", "BinaryLength": 201600},
        "334": {"vr": "OB", "BinaryLength": 201600},
        "335": {"vr": "OB", "BinaryLength": 201600},
        "336": {"vr": "OB", "BinaryLength": 201600},
        "337": {"vr": "OB", "BinaryLength": 201600},
        "338": {"vr": "OB", "BinaryLength": 201600},
        "339": {"vr": "OB", "BinaryLength": 201600},
        "340": {"vr": "OB", "BinaryLength": 201600},
        "341": {"vr": "OB", "BinaryLength": 201600},
        "342": {"vr": "OB", "BinaryLength": 201600},
        "343": {"vr": "OB", "BinaryLength": 201600},
        "344": {"vr": "OB", "BinaryLength": 201600},
        "345": {"vr": "OB", "BinaryLength": 201600},
        "346": {"vr": "OB", "BinaryLength": 201600},
        "347": {"vr": "OB", "BinaryLength": 201600},
        "348": {"vr": "OB", "BinaryLength": 201600},
        "349": {"vr": "OB", "BinaryLength": 201600},
        "350": {"vr": "OB", "BinaryLength": 201600},
        "351": {"vr": "OB", "BinaryLength": 201600},
        "352": {"vr": "OB", "BinaryLength": 201600},
        "353": {"vr": "OB", "BinaryLength": 201600},
        "354": {"vr": "OB", "BinaryLength": 201600},
        "355": {"vr": "OB", "BinaryLength": 201600},
        "356": {"vr": "OB", "BinaryLength": 201600},
        "357": {"vr": "OB", "BinaryLength": 201600},
        "358": {"vr": "OB", "BinaryLength": 201600},
        "359": {"vr": "OB", "BinaryLength": 201600},
        "360": {"vr": "OB", "BinaryLength": 201600},
        "361": {"vr": "OB", "BinaryLength": 201600},
        "362": {"vr": "OB", "BinaryLength": 201600},
        "363": {"vr": "OB", "BinaryLength": 201600},
        "364": {"vr": "OB", "BinaryLength": 201600},
        "365": {"vr": "OB", "BinaryLength": 201600},
        "366": {"vr": "OB", "BinaryLength": 201600},
        "367": {"vr": "OB", "BinaryLength": 201600},
        "368": {"vr": "OB", "BinaryLength": 201600},
        "369": {"vr": "OB", "BinaryLength": 201600},
        "370": {"vr": "OB", "BinaryLength": 201600},
        "371": {"vr": "OB", "BinaryLength": 201600},
        "372": {"vr": "OB", "BinaryLength": 201600},
        "373": {"vr": "OB", "BinaryLength": 201600},
        "374": {"vr": "OB", "BinaryLength": 201600},
        "375": {"vr": "OB", "BinaryLength": 201600},
        "376": {"vr": "OB", "BinaryLength": 201600},
        "377": {"vr": "OB", "BinaryLength": 201600},
        "378": {"vr": "OB", "BinaryLength": 201600},
        "379": {"vr": "OB", "BinaryLength": 201600},
        "380": {"vr": "OB", "BinaryLength": 201600},
        "381": {"vr": "OB", "BinaryLength": 201600},
        "382": {"vr": "OB", "BinaryLength": 201600},
        "383": {"vr": "OB", "BinaryLength": 201600},
        "384": {"vr": "OB", "BinaryLength": 201600},
        "385": {"vr": "OB", "BinaryLength": 201600},
        "386": {"vr": "OB", "BinaryLength": 201600},
        "387": {"vr": "OB", "BinaryLength": 201600},
        "388": {"vr": "OB", "BinaryLength": 201600},
        "389": {"vr": "OB", "BinaryLength": 201600},
        "390": {"vr": "OB", "BinaryLength": 201600},
        "391": {"vr": "OB", "BinaryLength": 201600},
        "392": {"vr": "OB", "BinaryLength": 201600},
        "393": {"vr": "OB", "BinaryLength": 201600},
        "394": {"vr": "OB", "BinaryLength": 201600},
        "395": {"vr": "OB", "BinaryLength": 201600},
        "396": {"vr": "OB", "BinaryLength": 201600},
        "397": {"vr": "OB", "BinaryLength": 201600},
        "398": {"vr": "OB", "BinaryLength": 201600},
        "399": {"vr": "OB", "BinaryLength": 201600},
        "400": {"vr": "OB", "BinaryLength": 201600},
        "401": {"vr": "OB", "BinaryLength": 201600},
        "402": {"vr": "OB", "BinaryLength": 201600},
        "403": {"vr": "OB", "BinaryLength": 201600},
        "404": {"vr": "OB", "BinaryLength": 201600},
        "405": {"vr": "OB", "BinaryLength": 201600},
        "406": {"vr": "OB", "BinaryLength": 201600},
        "407": {"vr": "OB", "BinaryLength": 201600},
        "408": {"vr": "OB", "BinaryLength": 201600},
        "409": {"vr": "OB", "BinaryLength": 201600},
        "410": {"vr": "OB", "BinaryLength": 201600},
        "411": {"vr": "OB", "BinaryLength": 201600},
        "412": {"vr": "OB", "BinaryLength": 201600},
        "413": {"vr": "OB", "BinaryLength": 201600},
        "414": {"vr": "OB", "BinaryLength": 201600},
        "415": {"vr": "OB", "BinaryLength": 201600},
        "416": {"vr": "OB", "BinaryLength": 201600},
        "417": {"vr": "OB", "BinaryLength": 201600},
        "418": {"vr": "OB", "BinaryLength": 201600},
        "419": {"vr": "OB", "BinaryLength": 201600},
        "420": {"vr": "OB", "BinaryLength": 201600},
        "421": {"vr": "OB", "BinaryLength": 201600},
        "422": {"vr": "OB", "BinaryLength": 201600},
        "423": {"vr": "OB", "BinaryLength": 201600},
        "424": {"vr": "OB", "BinaryLength": 201600},
        "425": {"vr": "OB", "BinaryLength": 201600},
        "426": {"vr": "OB", "BinaryLength": 201600},
        "427": {"vr": "OB", "BinaryLength": 201600},
        "428": {"vr": "OB", "BinaryLength": 201600},
        "429": {"vr": "OB", "BinaryLength": 201600},
        "430": {"vr": "OB", "BinaryLength": 201600},
        "431": {"vr": "OB", "BinaryLength": 201600},
        "432": {"vr": "OB", "BinaryLength": 201600},
        "433": {"vr": "OB", "BinaryLength": 201600},
        "434": {"vr": "OB", "BinaryLength": 201600},
        "435": {"vr": "OB", "BinaryLength": 201600},
        "436": {"vr": "OB", "BinaryLength": 201600},
        "437": {"vr": "OB", "BinaryLength": 201600},
        "438": {"vr": "OB", "BinaryLength": 201600},
        "439": {"vr": "OB", "BinaryLength": 201600},
        "440": {"vr": "OB", "BinaryLength": 201600},
        "441": {"vr": "OB", "BinaryLength": 201600},
        "442": {"vr": "OB", "BinaryLength": 201600},
        "443": {"vr": "OB", "BinaryLength": 201600},
        "444": {"vr": "OB", "BinaryLength": 201600},
        "445": {"vr": "OB", "BinaryLength": 201600},
        "446": {"vr": "OB", "BinaryLength": 201600},
        "447": {"vr": "OB", "BinaryLength": 201600},
        "448": {"vr": "OB", "BinaryLength": 201600},
        "449": {"vr": "OB", "BinaryLength": 201600},
        "450": {"vr": "OB", "BinaryLength": 201600},
        "451": {"vr": "OB", "BinaryLength": 201600},
        "452": {"vr": "OB", "BinaryLength": 201600},
        "453": {"vr": "OB", "BinaryLength": 201600},
        "454": {"vr": "OB", "BinaryLength": 201600},
        "455": {"vr": "OB", "BinaryLength": 201600},
        "456": {"vr": "OB", "BinaryLength": 201600},
        "457": {"vr": "OB", "BinaryLength": 201600},
        "458": {"vr": "OB", "BinaryLength": 201600},
        "459": {"vr": "OB", "BinaryLength": 201600},
        "460": {"vr": "OB", "BinaryLength": 201600},
        "461": {"vr": "OB", "BinaryLength": 201600},
        "462": {"vr": "OB", "BinaryLength": 201600},
        "463": {"vr": "OB", "BinaryLength": 201600},
        "464": {"vr": "OB", "BinaryLength": 201600},
        "465": {"vr": "OB", "BinaryLength": 201600},
        "466": {"vr": "OB", "BinaryLength": 201600},
        "467": {"vr": "OB", "BinaryLength": 201600},
        "468": {"vr": "OB", "BinaryLength": 201600},
        "469": {"vr": "OB", "BinaryLength": 201600},
        "470": {"vr": "OB", "BinaryLength": 201600},
        "471": {"vr": "OB", "BinaryLength": 201600},
        "472": {"vr": "OB", "BinaryLength": 201600},
        "473": {"vr": "OB", "BinaryLength": 201600},
        "474": {"vr": "OB", "BinaryLength": 201600},
        "475": {"vr": "OB", "BinaryLength": 201600},
        "476": {"vr": "OB", "BinaryLength": 201600},
        "477": {"vr": "OB", "BinaryLength": 201600},
        "478": {"vr": "OB", "BinaryLength": 201600},
        "479": {"vr": "OB", "BinaryLength": 201600},
        "480": {"vr": "OB", "BinaryLength": 201600},
        "481": {"vr": "OB", "BinaryLength": 201600},
        "482": {"vr": "OB", "BinaryLength": 201600},
        "483": {"vr": "OB", "BinaryLength": 201600},
        "484": {"vr": "OB", "BinaryLength": 201600},
        "485": {"vr": "OB", "BinaryLength": 201600},
        "486": {"vr": "OB", "BinaryLength": 201600},
        "487": {"vr": "OB", "BinaryLength": 201600},
        "488": {"vr": "OB", "BinaryLength": 201600},
        "489": {"vr": "OB", "BinaryLength": 201600},
        "490": {"vr": "OB", "BinaryLength": 201600},
        "491": {"vr": "OB", "BinaryLength": 201600},
        "492": {"vr": "OB", "BinaryLength": 201600},
        "493": {"vr": "OB", "BinaryLength": 201600},
        "494": {"vr": "OB", "BinaryLength": 201600},
        "495": {"vr": "OB", "BinaryLength": 201600},
        "496": {"vr": "OB", "BinaryLength": 201600},
        "497": {"vr": "OB", "BinaryLength": 201600},
        "498": {"vr": "OB", "BinaryLength": 201600},
        "499": {"vr": "OB", "BinaryLength": 201600},
        "500": {"vr": "OB", "BinaryLength": 201600},
        "501": {"vr": "OB", "BinaryLength": 201600},
        "502": {"vr": "OB", "BinaryLength": 201600},
        "503": {"vr": "OB", "BinaryLength": 201600},
        "504": {"vr": "OB", "BinaryLength": 201600},
        "505": {"vr": "OB", "BinaryLength": 201600},
        "506": {"vr": "OB", "BinaryLength": 201600},
        "507": {"vr": "OB", "BinaryLength": 201600},
        "508": {"vr": "OB", "BinaryLength": 201600},
        "509": {"vr": "OB", "BinaryLength": 201600},
        "510": {"vr": "OB", "BinaryLength": 201600},
        "511": {"vr": "OB", "BinaryLength": 201600},
        "512": {"vr": "OB", "BinaryLength": 201600},
        "513": {"vr": "OB", "BinaryLength": 201600},
        "514": {"vr": "OB", "BinaryLength": 201600},
        "515": {"vr": "OB", "BinaryLength": 201600},
        "516": {"vr": "OB", "BinaryLength": 201600},
        "517": {"vr": "OB", "BinaryLength": 201600},
        "518": {"vr": "OB", "BinaryLength": 201600},
        "519": {"vr": "OB", "BinaryLength": 201600},
        "520": {"vr": "OB", "BinaryLength": 201600},
        "521": {"vr": "OB", "BinaryLength": 201600},
        "522": {"vr": "OB", "BinaryLength": 201600},
        "523": {"vr": "OB", "BinaryLength": 201600},
        "524": {"vr": "OB", "BinaryLength": 201600},
        "525": {"vr": "OB", "BinaryLength": 201600},
        "526": {"vr": "OB", "BinaryLength": 201600},
        "527": {"vr": "OB", "BinaryLength": 201600},
        "528": {"vr": "OB", "BinaryLength": 201600},
        "529": {"vr": "OB", "BinaryLength": 201600},
        "530": {"vr": "OB", "BinaryLength": 201600},
        "531": {"vr": "OB", "BinaryLength": 201600},
        "532": {"vr": "OB", "BinaryLength": 201600},
        "533": {"vr": "OB", "BinaryLength": 201600},
        "534": {"vr": "OB", "BinaryLength": 201600},
        "535": {"vr": "OB", "BinaryLength": 201600},
        "536": {"vr": "OB", "BinaryLength": 201600},
        "537": {"vr": "OB", "BinaryLength": 201600},
        "538": {"vr": "OB", "BinaryLength": 201600},
        "539": {"vr": "OB", "BinaryLength": 201600},
        "540": {"vr": "OB", "BinaryLength": 201600},
        "541": {"vr": "OB", "BinaryLength": 201600},
        "542": {"vr": "OB", "BinaryLength": 201600},
        "543": {"vr": "OB", "BinaryLength": 201600},
        "544": {"vr": "OB", "BinaryLength": 201600},
        "545": {"vr": "OB", "BinaryLength": 201600},
        "546": {"vr": "OB", "BinaryLength": 201600},
        "547": {"vr": "OB", "BinaryLength": 201600},
        "548": {"vr": "OB", "BinaryLength": 201600},
        "549": {"vr": "OB", "BinaryLength": 201600},
        "550": {"vr": "OB", "BinaryLength": 201600},
        "551": {"vr": "OB", "BinaryLength": 201600},
        "552": {"vr": "OB", "BinaryLength": 201600},
        "553": {"vr": "OB", "BinaryLength": 201600},
        "554": {"vr": "OB", "BinaryLength": 201600},
        "555": {"vr": "OB", "BinaryLength": 201600},
        "556": {"vr": "OB", "BinaryLength": 201600},
        "557": {"vr": "OB", "BinaryLength": 201600},
        "558": {"vr": "OB", "BinaryLength": 201600},
        "559": {"vr": "OB", "BinaryLength": 201600},
        "560": {"vr": "OB", "BinaryLength": 201600},
        "561": {"vr": "OB", "BinaryLength": 201600},
        "562": {"vr": "OB", "BinaryLength": 201600},
        "563": {"vr": "OB", "BinaryLength": 201600},
        "564": {"vr": "OB", "BinaryLength": 201600},
        "565": {"vr": "OB", "BinaryLength": 201600},
        "566": {"vr": "OB", "BinaryLength": 201600},
        "567": {"vr": "OB", "BinaryLength": 201600},
        "568": {"vr": "OB", "BinaryLength": 201600},
        "569": {"vr": "OB", "BinaryLength": 201600},
        "570": {"vr": "OB", "BinaryLength": 201600},
        "571": {"vr": "OB", "BinaryLength": 201600},
        "572": {"vr": "OB", "BinaryLength": 201600},
        "573": {"vr": "OB", "BinaryLength": 201600},
        "574": {"vr": "OB", "BinaryLength": 201600},
        "575": {"vr": "OB", "BinaryLength": 201600},
        "576": {"vr": "OB", "BinaryLength": 201600},
        "577": {"vr": "OB", "BinaryLength": 201600},
        "578": {"vr": "OB", "BinaryLength": 201600},
        "579": {"vr": "OB", "BinaryLength": 201600},
        "580": {"vr": "OB", "BinaryLength": 201600},
        "581": {"vr": "OB", "BinaryLength": 201600},
        "582": {"vr": "OB", "BinaryLength": 201600},
        "583": {"vr": "OB", "BinaryLength": 201600},
        "584": {"vr": "OB", "BinaryLength": 201600},
        "585": {"vr": "OB", "BinaryLength": 201600},
        "586": {"vr": "OB", "BinaryLength": 201600},
        "587": {"vr": "OB", "BinaryLength": 201600},
        "588": {"vr": "OB", "BinaryLength": 201600},
        "589": {"vr": "OB", "BinaryLength": 201600},
        "590": {"vr": "OB", "BinaryLength": 201600},
        "591": {"vr": "OB", "BinaryLength": 201600},
        "592": {"vr": "OB", "BinaryLength": 201600},
        "593": {"vr": "OB", "BinaryLength": 201600},
        "594": {"vr": "OB", "BinaryLength": 201600},
        "595": {"vr": "OB", "BinaryLength": 201600},
        "596": {"vr": "OB", "BinaryLength": 201600},
        "597": {"vr": "OB", "BinaryLength": 201600},
        "598": {"vr": "OB", "BinaryLength": 201600},
        "599": {"vr": "OB", "BinaryLength": 201600},
        "600": {"vr": "OB", "BinaryLength": 201600},
        "601": {"vr": "OB", "BinaryLength": 201600},
        "602": {"vr": "OB", "BinaryLength": 201600},
        "603": {"vr": "OB", "BinaryLength": 201600},
        "604": {"vr": "OB", "BinaryLength": 201600},
        "605": {"vr": "OB", "BinaryLength": 201600},
        "606": {"vr": "OB", "BinaryLength": 201600},
        "607": {"vr": "OB", "BinaryLength": 201600},
        "608": {"vr": "OB", "BinaryLength": 201600},
        "609": {"vr": "OB", "BinaryLength": 201600},
        "610": {"vr": "OB", "BinaryLength": 201600},
        "611": {"vr": "OB", "BinaryLength": 201600},
        "612": {"vr": "OB", "BinaryLength": 201600},
        "613": {"vr": "OB", "BinaryLength": 201600},
        "614": {"vr": "OB", "BinaryLength": 201600},
        "615": {"vr": "OB", "BinaryLength": 201600},
        "616": {"vr": "OB", "BinaryLength": 201600},
        "617": {"vr": "OB", "BinaryLength": 201600},
        "618": {"vr": "OB", "BinaryLength": 201600},
        "619": {"vr": "OB", "BinaryLength": 201600},
        "620": {"vr": "OB", "BinaryLength": 201600},
        "621": {"vr": "OB", "BinaryLength": 201600},
        "622": {"vr": "OB", "BinaryLength": 201600},
        "623": {"vr": "OB", "BinaryLength": 201600},
        "624": {"vr": "OB", "BinaryLength": 201600},
        "625": {"vr": "OB", "BinaryLength": 201600},
        "626": {"vr": "OB", "BinaryLength": 201600},
        "627": {"vr": "OB", "BinaryLength": 201600},
        "628": {"vr": "OB", "BinaryLength": 201600},
        "629": {"vr": "OB", "BinaryLength": 201600},
        "630": {"vr": "OB", "BinaryLength": 201600},
        "631": {"vr": "OB", "BinaryLength": 201600},
        "632": {"vr": "OB", "BinaryLength": 201600},
        "633": {"vr": "OB", "BinaryLength": 201600},
        "634": {"vr": "OB", "BinaryLength": 201600},
        "635": {"vr": "OB", "BinaryLength": 201600},
        "636": {"vr": "OB", "BinaryLength": 201600},
        "637": {"vr": "OB", "BinaryLength": 201600},
        "638": {"vr": "OB", "BinaryLength": 201600},
        "639": {"vr": "OB", "BinaryLength": 201600},
        "640": {"vr": "OB", "BinaryLength": 201600},
        "641": {"vr": "OB", "BinaryLength": 201600},
        "642": {"vr": "OB", "BinaryLength": 201600},
        "643": {"vr": "OB", "BinaryLength": 201600},
        "644": {"vr": "OB", "BinaryLength": 201600},
        "645": {"vr": "OB", "BinaryLength": 201600},
        "646": {"vr": "OB", "BinaryLength": 201600},
        "647": {"vr": "OB", "BinaryLength": 201600},
        "648": {"vr": "OB", "BinaryLength": 201600},
        "649": {"vr": "OB", "BinaryLength": 201600},
        "650": {"vr": "OB", "BinaryLength": 201600},
        "651": {"vr": "OB", "BinaryLength": 201600},
        "652": {"vr": "OB", "BinaryLength": 201600},
        "653": {"vr": "OB", "BinaryLength": 201600},
        "654": {"vr": "OB", "BinaryLength": 201600},
        "655": {"vr": "OB", "BinaryLength": 201600},
        "656": {"vr": "OB", "BinaryLength": 201600},
        "657": {"vr": "OB", "BinaryLength": 201600},
        "658": {"vr": "OB", "BinaryLength": 201600},
        "659": {"vr": "OB", "BinaryLength": 201600},
        "660": {"vr": "OB", "BinaryLength": 201600},
        "661": {"vr": "OB", "BinaryLength": 201600},
        "662": {"vr": "OB", "BinaryLength": 201600},
        "663": {"vr": "OB", "BinaryLength": 201600},
        "664": {"vr": "OB", "BinaryLength": 201600},
        "665": {"vr": "OB", "BinaryLength": 201600},
        "666": {"vr": "OB", "BinaryLength": 201600},
        "667": {"vr": "OB", "BinaryLength": 201600},
        "668": {"vr": "OB", "BinaryLength": 201600},
        "669": {"vr": "OB", "BinaryLength": 201600},
        "670": {"vr": "OB", "BinaryLength": 201600},
        "671": {"vr": "OB", "BinaryLength": 201600},
        "672": {"vr": "OB", "BinaryLength": 201600},
        "673": {"vr": "OB", "BinaryLength": 201600},
        "674": {"vr": "OB", "BinaryLength": 201600},
        "675": {"vr": "OB", "BinaryLength": 201600},
        "676": {"vr": "OB", "BinaryLength": 201600},
        "677": {"vr": "OB", "BinaryLength": 201600},
        "678": {"vr": "OB", "BinaryLength": 201600},
        "679": {"vr": "OB", "BinaryLength": 201600},
        "680": {"vr": "OB", "BinaryLength": 201600},
        "681": {"vr": "OB", "BinaryLength": 201600},
        "682": {"vr": "OB", "BinaryLength": 201600},
        "683": {"vr": "OB", "BinaryLength": 201600},
        "684": {"vr": "OB", "BinaryLength": 201600},
        "685": {"vr": "OB", "BinaryLength": 201600},
        "686": {"vr": "OB", "BinaryLength": 201600},
        "687": {"vr": "OB", "BinaryLength": 201600},
        "688": {"vr": "OB", "BinaryLength": 201600},
        "689": {"vr": "OB", "BinaryLength": 201600},
        "690": {"vr": "OB", "BinaryLength": 201600},
        "691": {"vr": "OB", "BinaryLength": 201600},
        "692": {"vr": "OB", "BinaryLength": 201600},
        "693": {"vr": "OB", "BinaryLength": 201600},
        "694": {"vr": "OB", "BinaryLength": 201600},
        "695": {"vr": "OB", "BinaryLength": 201600},
        "696": {"vr": "OB", "BinaryLength": 201600},
        "697": {"vr": "OB", "BinaryLength": 201600},
        "698": {"vr": "OB", "BinaryLength": 201600},
        "699": {"vr": "OB", "BinaryLength": 201600},
        "700": {"vr": "OB", "BinaryLength": 201600},
        "701": {"vr": "OB", "BinaryLength": 201600},
        "702": {"vr": "OB", "BinaryLength": 201600},
        "703": {"vr": "OB", "BinaryLength": 201600},
        "704": {"vr": "OB", "BinaryLength": 201600},
        "705": {"vr": "OB", "BinaryLength": 201600},
        "706": {"vr": "OB", "BinaryLength": 201600},
        "707": {"vr": "OB", "BinaryLength": 201600},
        "708": {"vr": "OB", "BinaryLength": 201600},
        "709": {"vr": "OB", "BinaryLength": 201600},
        "710": {"vr": "OB", "BinaryLength": 201600},
        "711": {"vr": "OB", "BinaryLength": 201600},
        "712": {"vr": "OB", "BinaryLength": 201600},
        "713": {"vr": "OB", "BinaryLength": 201600},
        "714": {"vr": "OB", "BinaryLength": 201600},
        "715": {"vr": "OB", "BinaryLength": 201600},
        "716": {"vr": "OB", "BinaryLength": 201600},
        "717": {"vr": "OB", "BinaryLength": 201600},
        "718": {"vr": "OB", "BinaryLength": 201600},
        "719": {"vr": "OB", "BinaryLength": 201600},
        "720": {"vr": "OB", "BinaryLength": 201600},
        "721": {"vr": "OB", "BinaryLength": 201600},
        "722": {"vr": "OB", "BinaryLength": 201600},
        "723": {"vr": "OB", "BinaryLength": 201600},
        "724": {"vr": "OB", "BinaryLength": 201600},
        "725": {"vr": "OB", "BinaryLength": 201600},
        "726": {"vr": "OB", "BinaryLength": 201600},
        "727": {"vr": "OB", "BinaryLength": 201600},
        "728": {"vr": "OB", "BinaryLength": 201600},
        "729": {"vr": "OB", "BinaryLength": 201600},
        "730": {"vr": "OB", "BinaryLength": 201600},
        "731": {"vr": "OB", "BinaryLength": 201600},
        "732": {"vr": "OB", "BinaryLength": 201600},
        "733": {"vr": "OB", "BinaryLength": 201600},
        "734": {"vr": "OB", "BinaryLength": 201600},
        "735": {"vr": "OB", "BinaryLength": 201600},
        "736": {"vr": "OB", "BinaryLength": 201600},
        "737": {"vr": "OB", "BinaryLength": 201600},
        "738": {"vr": "OB", "BinaryLength": 201600},
        "739": {"vr": "OB", "BinaryLength": 201600},
        "740": {"vr": "OB", "BinaryLength": 201600},
        "741": {"vr": "OB", "BinaryLength": 201600},
        "742": {"vr": "OB", "BinaryLength": 201600},
        "743": {"vr": "OB", "BinaryLength": 201600},
        "744": {"vr": "OB", "BinaryLength": 201600},
        "745": {"vr": "OB", "BinaryLength": 201600},
        "746": {"vr": "OB", "BinaryLength": 201600},
        "747": {"vr": "OB", "BinaryLength": 201600},
        "748": {"vr": "OB", "BinaryLength": 201600},
        "749": {"vr": "OB", "BinaryLength": 201600},
        "750": {"vr": "OB", "BinaryLength": 201600},
        "751": {"vr": "OB", "BinaryLength": 201600},
        "752": {"vr": "OB", "BinaryLength": 201600},
        "753": {"vr": "OB", "BinaryLength": 201600},
        "754": {"vr": "OB", "BinaryLength": 201600},
        "755": {"vr": "OB", "BinaryLength": 201600},
        "756": {"vr": "OB", "BinaryLength": 201600},
        "757": {"vr": "OB", "BinaryLength": 201600},
        "758": {"vr": "OB", "BinaryLength": 201600},
        "759": {"vr": "OB", "BinaryLength": 201600},
        "760": {"vr": "OB", "BinaryLength": 201600},
        "761": {"vr": "OB", "BinaryLength": 201600},
        "762": {"vr": "OB", "BinaryLength": 201600},
        "763": {"vr": "OB", "BinaryLength": 201600},
        "764": {"vr": "OB", "BinaryLength": 201600},
        "765": {"vr": "OB", "BinaryLength": 201600},
        "766": {"vr": "OB", "BinaryLength": 201600},
        "767": {"vr": "OB", "BinaryLength": 201600},
        "768": {"vr": "OB", "BinaryLength": 201600},
        "769": {"vr": "OB", "BinaryLength": 201600},
        "770": {"vr": "OB", "BinaryLength": 201600},
        "771": {"vr": "OB", "BinaryLength": 201600},
        "772": {"vr": "OB", "BinaryLength": 201600},
        "773": {"vr": "OB", "BinaryLength": 201600},
        "774": {"vr": "OB", "BinaryLength": 201600},
        "775": {"vr": "OB", "BinaryLength": 201600},
        "776": {"vr": "OB", "BinaryLength": 201600},
        "777": {"vr": "OB", "BinaryLength": 201600},
        "778": {"vr": "OB", "BinaryLength": 201600},
        "779": {"vr": "OB", "BinaryLength": 201600},
        "780": {"vr": "OB", "BinaryLength": 201600},
        "781": {"vr": "OB", "BinaryLength": 201600},
        "782": {"vr": "OB", "BinaryLength": 201600},
        "783": {"vr": "OB", "BinaryLength": 201600},
        "784": {"vr": "OB", "BinaryLength": 201600},
        "785": {"vr": "OB", "BinaryLength": 201600},
        "786": {"vr": "OB", "BinaryLength": 201600},
        "787": {"vr": "OB", "BinaryLength": 201600},
        "788": {"vr": "OB", "BinaryLength": 201600},
        "789": {"vr": "OB", "BinaryLength": 201600},
        "790": {"vr": "OB", "BinaryLength": 201600},
        "791": {"vr": "OB", "BinaryLength": 201600},
        "792": {"vr": "OB", "BinaryLength": 201600},
        "793": {"vr": "OB", "BinaryLength": 201600},
        "794": {"vr": "OB", "BinaryLength": 201600},
        "795": {"vr": "OB", "BinaryLength": 201600},
        "796": {"vr": "OB", "BinaryLength": 201600},
        "797": {"vr": "OB", "BinaryLength": 201600},
        "798": {"vr": "OB", "BinaryLength": 201600},
        "799": {"vr": "OB", "BinaryLength": 201600},
        "800": {"vr": "OB", "BinaryLength": 201600},
        "801": {"vr": "OB", "BinaryLength": 201600},
        "802": {"vr": "OB", "BinaryLength": 201600},
        "803": {"vr": "OB", "BinaryLength": 201600},
        "804": {"vr": "OB", "BinaryLength": 201600},
        "805": {"vr": "OB", "BinaryLength": 201600},
        "806": {"vr": "OB", "BinaryLength": 201600},
        "807": {"vr": "OB", "BinaryLength": 201600},
        "808": {"vr": "OB", "BinaryLength": 201600},
        "809": {"vr": "OB", "BinaryLength": 201600},
        "810": {"vr": "OB", "BinaryLength": 201600},
        "811": {"vr": "OB", "BinaryLength": 201600},
        "812": {"vr": "OB", "BinaryLength": 201600},
        "813": {"vr": "OB", "BinaryLength": 201600},
        "814": {"vr": "OB", "BinaryLength": 201600},
        "815": {"vr": "OB", "BinaryLength": 201600},
        "816": {"vr": "OB", "BinaryLength": 201600},
        "817": {"vr": "OB", "BinaryLength": 201600},
        "818": {"vr": "OB", "BinaryLength": 201600},
        "819": {"vr": "OB", "BinaryLength": 201600},
        "820": {"vr": "OB", "BinaryLength": 201600},
        "821": {"vr": "OB", "BinaryLength": 201600},
        "822": {"vr": "OB", "BinaryLength": 201600},
        "823": {"vr": "OB", "BinaryLength": 201600},
        "824": {"vr": "OB", "BinaryLength": 201600},
        "825": {"vr": "OB", "BinaryLength": 201600},
        "826": {"vr": "OB", "BinaryLength": 201600},
        "827": {"vr": "OB", "BinaryLength": 201600},
        "828": {"vr": "OB", "BinaryLength": 201600},
        "829": {"vr": "OB", "BinaryLength": 201600},
        "830": {"vr": "OB", "BinaryLength": 201600},
        "831": {"vr": "OB", "BinaryLength": 201600},
        "832": {"vr": "OB", "BinaryLength": 201600},
        "833": {"vr": "OB", "BinaryLength": 201600},
        "834": {"vr": "OB", "BinaryLength": 201600},
        "835": {"vr": "OB", "BinaryLength": 201600},
        "836": {"vr": "OB", "BinaryLength": 201600},
        "837": {"vr": "OB", "BinaryLength": 201600},
        "838": {"vr": "OB", "BinaryLength": 201600},
        "839": {"vr": "OB", "BinaryLength": 201600},
        "840": {"vr": "OB", "BinaryLength": 201600},
        "841": {"vr": "OB", "BinaryLength": 201600},
        "842": {"vr": "OB", "BinaryLength": 201600},
        "843": {"vr": "OB", "BinaryLength": 201600},
        "844": {"vr": "OB", "BinaryLength": 201600},
        "845": {"vr": "OB", "BinaryLength": 201600},
        "846": {"vr": "OB", "BinaryLength": 201600},
        "847": {"vr": "OB", "BinaryLength": 201600},
        "848": {"vr": "OB", "BinaryLength": 201600},
        "849": {"vr": "OB", "BinaryLength": 201600},
        "850": {"vr": "OB", "BinaryLength": 201600},
        "851": {"vr": "OB", "BinaryLength": 201600},
        "852": {"vr": "OB", "BinaryLength": 201600},
        "853": {"vr": "OB", "BinaryLength": 201600},
        "854": {"vr": "OB", "BinaryLength": 201600},
        "855": {"vr": "OB", "BinaryLength": 201600},
        "856": {"vr": "OB", "BinaryLength": 201600},
        "857": {"vr": "OB", "BinaryLength": 201600},
        "858": {"vr": "OB", "BinaryLength": 201600},
        "859": {"vr": "OB", "BinaryLength": 201600},
        "860": {"vr": "OB", "BinaryLength": 201600},
        "861": {"vr": "OB", "BinaryLength": 201600},
        "862": {"vr": "OB", "BinaryLength": 201600},
        "863": {"vr": "OB", "BinaryLength": 201600},
        "864": {"vr": "OB", "BinaryLength": 201600},
        "865": {"vr": "OB", "BinaryLength": 201600},
        "866": {"vr": "OB", "BinaryLength": 201600},
        "867": {"vr": "OB", "BinaryLength": 201600},
        "868": {"vr": "OB", "BinaryLength": 201600},
        "869": {"vr": "OB", "BinaryLength": 201600},
        "870": {"vr": "OB", "BinaryLength": 201600},
        "871": {"vr": "OB", "BinaryLength": 201600},
        "872": {"vr": "OB", "BinaryLength": 201600},
        "873": {"vr": "OB", "BinaryLength": 201600},
        "874": {"vr": "OB", "BinaryLength": 201600},
        "875": {"vr": "OB", "BinaryLength": 201600},
        "876": {"vr": "OB", "BinaryLength": 201600},
        "877": {"vr": "OB", "BinaryLength": 201600},
        "878": {"vr": "OB", "BinaryLength": 201600},
        "879": {"vr": "OB", "BinaryLength": 201600},
        "880": {"vr": "OB", "BinaryLength": 201600},
        "881": {"vr": "OB", "BinaryLength": 201600},
        "882": {"vr": "OB", "BinaryLength": 201600},
        "883": {"vr": "OB", "BinaryLength": 201600},
        "884": {"vr": "OB", "BinaryLength": 201600},
        "885": {"vr": "OB", "BinaryLength": 201600},
        "886": {"vr": "OB", "BinaryLength": 201600},
        "887": {"vr": "OB", "BinaryLength": 201600},
        "888": {"vr": "OB", "BinaryLength": 201600},
        "889": {"vr": "OB", "BinaryLength": 201600},
        "890": {"vr": "OB", "BinaryLength": 201600},
        "891": {"vr": "OB", "BinaryLength": 201600},
        "892": {"vr": "OB", "BinaryLength": 201600},
        "893": {"vr": "OB", "BinaryLength": 201600},
        "894": {"vr": "OB", "BinaryLength": 201600},
        "895": {"vr": "OB", "BinaryLength": 201600},
        "896": {"vr": "OB", "BinaryLength": 201600},
        "897": {"vr": "OB", "BinaryLength": 201600},
        "898": {"vr": "OB", "BinaryLength": 201600},
        "899": {"vr": "OB", "BinaryLength": 201600},
        "900": {"vr": "OB", "BinaryLength": 201600},
        "901": {"vr": "OB", "BinaryLength": 201600},
        "902": {"vr": "OB", "BinaryLength": 201600},
        "903": {"vr": "OB", "BinaryLength": 201600},
        "904": {"vr": "OB", "BinaryLength": 201600},
        "905": {"vr": "OB", "BinaryLength": 201600},
        "906": {"vr": "OB", "BinaryLength": 201600},
        "907": {"vr": "OB", "BinaryLength": 201600},
        "908": {"vr": "OB", "BinaryLength": 201600},
        "909": {"vr": "OB", "BinaryLength": 201600},
        "910": {"vr": "OB", "BinaryLength": 201600},
        "911": {"vr": "OB", "BinaryLength": 201600},
        "912": {"vr": "OB", "BinaryLength": 201600},
        "913": {"vr": "OB", "BinaryLength": 201600},
        "914": {"vr": "OB", "BinaryLength": 201600},
        "915": {"vr": "OB", "BinaryLength": 201600},
        "916": {"vr": "OB", "BinaryLength": 201600},
        "917": {"vr": "OB", "BinaryLength": 201600},
        "918": {"vr": "OB", "BinaryLength": 201600},
        "919": {"vr": "OB", "BinaryLength": 201600},
        "920": {"vr": "OB", "BinaryLength": 201600},
        "921": {"vr": "OB", "BinaryLength": 201600},
        "922": {"vr": "OB", "BinaryLength": 201600},
        "923": {"vr": "OB", "BinaryLength": 201600},
        "924": {"vr": "OB", "BinaryLength": 201600},
        "925": {"vr": "OB", "BinaryLength": 201600},
        "926": {"vr": "OB", "BinaryLength": 201600},
        "927": {"vr": "OB", "BinaryLength": 201600},
        "928": {"vr": "OB", "BinaryLength": 201600},
        "929": {"vr": "OB", "BinaryLength": 201600},
        "930": {"vr": "OB", "BinaryLength": 201600},
        "931": {"vr": "OB", "BinaryLength": 201600},
        "932": {"vr": "OB", "BinaryLength": 201600},
        "933": {"vr": "OB", "BinaryLength": 201600},
        "934": {"vr": "OB", "BinaryLength": 201600},
        "935": {"vr": "OB", "BinaryLength": 201600},
        "936": {"vr": "OB", "BinaryLength": 201600},
        "937": {"vr": "OB", "BinaryLength": 201600},
        "938": {"vr": "OB", "BinaryLength": 201600},
        "939": {"vr": "OB", "BinaryLength": 201600},
        "940": {"vr": "OB", "BinaryLength": 201600},
        "941": {"vr": "OB", "BinaryLength": 201600},
        "942": {"vr": "OB", "BinaryLength": 201600},
        "943": {"vr": "OB", "BinaryLength": 201600},
        "944": {"vr": "OB", "BinaryLength": 201600},
        "945": {"vr": "OB", "BinaryLength": 201600},
        "946": {"vr": "OB", "BinaryLength": 201600},
        "947": {"vr": "OB", "BinaryLength": 201600},
        "948": {"vr": "OB", "BinaryLength": 201600},
        "949": {"vr": "OB", "BinaryLength": 201600},
        "950": {"vr": "OB", "BinaryLength": 201600},
        "951": {"vr": "OB", "BinaryLength": 201600},
        "952": {"vr": "OB", "BinaryLength": 201600},
        "953": {"vr": "OB", "BinaryLength": 201600},
        "954": {"vr": "OB", "BinaryLength": 201600},
        "955": {"vr": "OB", "BinaryLength": 201600},
        "956": {"vr": "OB", "BinaryLength": 201600},
        "957": {"vr": "OB", "BinaryLength": 201600},
        "958": {"vr": "OB", "BinaryLength": 201600},
        "959": {"vr": "OB", "BinaryLength": 201600},
        "960": {"vr": "OB", "BinaryLength": 201600},
        "961": {"vr": "OB", "BinaryLength": 201600},
        "962": {"vr": "OB", "BinaryLength": 201600},
        "963": {"vr": "OB", "BinaryLength": 201600},
        "964": {"vr": "OB", "BinaryLength": 201600},
        "965": {"vr": "OB", "BinaryLength": 201600},
        "966": {"vr": "OB", "BinaryLength": 201600},
        "967": {"vr": "OB", "BinaryLength": 201600},
        "968": {"vr": "OB", "BinaryLength": 201600},
        "969": {"vr": "OB", "BinaryLength": 201600},
        "970": {"vr": "OB", "BinaryLength": 201600},
        "971": {"vr": "OB", "BinaryLength": 201600},
        "972": {"vr": "OB", "BinaryLength": 201600},
        "973": {"vr": "OB", "BinaryLength": 201600},
        "974": {"vr": "OB", "BinaryLength": 201600},
        "975": {"vr": "OB", "BinaryLength": 201600},
        "976": {"vr": "OB", "BinaryLength": 201600},
        "977": {"vr": "OB", "BinaryLength": 201600},
        "978": {"vr": "OB", "BinaryLength": 201600},
        "979": {"vr": "OB", "BinaryLength": 201600},
        "980": {"vr": "OB", "BinaryLength": 201600},
        "981": {"vr": "OB", "BinaryLength": 201600},
        "982": {"vr": "OB", "BinaryLength": 201600},
        "983": {"vr": "OB", "BinaryLength": 201600},
        "984": {"vr": "OB", "BinaryLength": 201600},
        "985": {"vr": "OB", "BinaryLength": 201600},
        "986": {"vr": "OB", "BinaryLength": 201600},
        "987": {"vr": "OB", "BinaryLength": 201600},
        "988": {"vr": "OB", "BinaryLength": 201600},
        "989": {"vr": "OB", "BinaryLength": 201600},
        "990": {"vr": "OB", "BinaryLength": 201600},
        "991": {"vr": "OB", "BinaryLength": 201600},
        "992": {"vr": "OB", "BinaryLength": 201600},
        "993": {"vr": "OB", "BinaryLength": 201600},
        "994": {"vr": "OB", "BinaryLength": 201600},
        "995": {"vr": "OB", "BinaryLength": 201600},
        "996": {"vr": "OB", "BinaryLength": 201600},
        "997": {"vr": "OB", "BinaryLength": 201600},
        "998": {"vr": "OB", "BinaryLength": 201600},
        "999": {"vr": "OB", "BinaryLength": 201600},
        "1000": {"vr": "OB", "BinaryLength": 201600},
        "1001": {"vr": "OB", "BinaryLength": 201600},
        "1002": {"vr": "OB", "BinaryLength": 201600},
        "1003": {"vr": "OB", "BinaryLength": 201600},
        "1004": {"vr": "OB", "BinaryLength": 201600},
        "1005": {"vr": "OB", "BinaryLength": 201600},
        "1006": {"vr": "OB", "BinaryLength": 201600},
        "1007": {"vr": "OB", "BinaryLength": 201600},
        "1008": {"vr": "OB", "BinaryLength": 201600},
        "1009": {"vr": "OB", "BinaryLength": 201600},
        "1010": {"vr": "OB", "BinaryLength": 201600},
        "1011": {"vr": "OB", "BinaryLength": 201600},
        "1012": {"vr": "OB", "BinaryLength": 201600},
        "1013": {"vr": "OB", "BinaryLength": 201600},
        "1014": {"vr": "OB", "BinaryLength": 201600},
        "1015": {"vr": "OB", "BinaryLength": 201600},
        "1016": {"vr": "OB", "BinaryLength": 201600},
        "1017": {"vr": "OB", "BinaryLength": 201600},
        "1018": {"vr": "OB", "BinaryLength": 201600},
        "1019": {"vr": "OB", "BinaryLength": 201600},
        "1020": {"vr": "OB", "BinaryLength": 201600},
        "1021": {"vr": "OB", "BinaryLength": 201600},
        "1022": {"vr": "OB", "BinaryLength": 201600},
        "1023": {"vr": "OB", "BinaryLength": 201600},
        "1024": {"vr": "OB", "BinaryLength": 201600},
        "1025": {"vr": "OB", "BinaryLength": 201600},
        "1026": {"vr": "OB", "BinaryLength": 201600},
        "1027": {"vr": "OB", "BinaryLength": 201600},
        "1028": {"vr": "OB", "BinaryLength": 201600},
        "1029": {"vr": "OB", "BinaryLength": 201600},
        "1030": {"vr": "OB", "BinaryLength": 201600},
        "1031": {"vr": "OB", "BinaryLength": 201600},
        "1032": {"vr": "OB", "BinaryLength": 201600},
        "1033": {"vr": "OB", "BinaryLength": 201600},
        "1034": {"vr": "OB", "BinaryLength": 201600},
        "1035": {"vr": "OB", "BinaryLength": 201600},
        "1036": {"vr": "OB", "BinaryLength": 201600},
        "1037": {"vr": "OB", "BinaryLength": 201600},
        "1038": {"vr": "OB", "BinaryLength": 201600},
        "1039": {"vr": "OB", "BinaryLength": 201600},
        "1040": {"vr": "OB", "BinaryLength": 201600},
        "1041": {"vr": "OB", "BinaryLength": 201600},
        "1042": {"vr": "OB", "BinaryLength": 201600},
        "1043": {"vr": "OB", "BinaryLength": 201600},
        "1044": {"vr": "OB", "BinaryLength": 201600},
        "1045": {"vr": "OB", "BinaryLength": 201600},
        "1046": {"vr": "OB", "BinaryLength": 201600},
        "1047": {"vr": "OB", "BinaryLength": 201600},
        "1048": {"vr": "OB", "BinaryLength": 201600},
        "1049": {"vr": "OB", "BinaryLength": 201600},
        "1050": {"vr": "OB", "BinaryLength": 201600},
        "1051": {"vr": "OB", "BinaryLength": 201600},
        "1052": {"vr": "OB", "BinaryLength": 201600},
        "1053": {"vr": "OB", "BinaryLength": 201600},
        "1054": {"vr": "OB", "BinaryLength": 201600},
        "1055": {"vr": "OB", "BinaryLength": 201600},
        "1056": {"vr": "OB", "BinaryLength": 201600},
        "1057": {"vr": "OB", "BinaryLength": 201600},
        "1058": {"vr": "OB", "BinaryLength": 201600},
        "1059": {"vr": "OB", "BinaryLength": 201600},
        "1060": {"vr": "OB", "BinaryLength": 201600},
        "1061": {"vr": "OB", "BinaryLength": 201600},
        "1062": {"vr": "OB", "BinaryLength": 201600},
        "1063": {"vr": "OB", "BinaryLength": 201600},
        "1064": {"vr": "OB", "BinaryLength": 201600},
        "1065": {"vr": "OB", "BinaryLength": 201600},
        "1066": {"vr": "OB", "BinaryLength": 201600},
        "1067": {"vr": "OB", "BinaryLength": 201600},
        "1068": {"vr": "OB", "BinaryLength": 201600},
        "1069": {"vr": "OB", "BinaryLength": 201600},
        "1070": {"vr": "OB", "BinaryLength": 201600},
        "1071": {"vr": "OB", "BinaryLength": 201600},
        "1072": {"vr": "OB", "BinaryLength": 201600},
        "1073": {"vr": "OB", "BinaryLength": 201600},
        "1074": {"vr": "OB", "BinaryLength": 201600},
        "1075": {"vr": "OB", "BinaryLength": 201600},
        "1076": {"vr": "OB", "BinaryLength": 201600},
        "1077": {"vr": "OB", "BinaryLength": 201600},
        "1078": {"vr": "OB", "BinaryLength": 201600},
        "1079": {"vr": "OB", "BinaryLength": 201600},
        "1080": {"vr": "OB", "BinaryLength": 201600},
        "1081": {"vr": "OB", "BinaryLength": 201600},
        "1082": {"vr": "OB", "BinaryLength": 201600},
        "1083": {"vr": "OB", "BinaryLength": 201600},
        "1084": {"vr": "OB", "BinaryLength": 201600},
        "1085": {"vr": "OB", "BinaryLength": 201600},
        "1086": {"vr": "OB", "BinaryLength": 201600},
        "1087": {"vr": "OB", "BinaryLength": 201600},
        "1088": {"vr": "OB", "BinaryLength": 201600},
        "1089": {"vr": "OB", "BinaryLength": 201600},
        "1090": {"vr": "OB", "BinaryLength": 201600},
        "1091": {"vr": "OB", "BinaryLength": 201600},
        "1092": {"vr": "OB", "BinaryLength": 201600},
        "1093": {"vr": "OB", "BinaryLength": 201600},
        "1094": {"vr": "OB", "BinaryLength": 201600},
        "1095": {"vr": "OB", "BinaryLength": 201600},
        "1096": {"vr": "OB", "BinaryLength": 201600},
        "1097": {"vr": "OB", "BinaryLength": 201600},
        "1098": {"vr": "OB", "BinaryLength": 201600},
        "1099": {"vr": "OB", "BinaryLength": 201600},
        "1100": {"vr": "OB", "BinaryLength": 201600},
        "1101": {"vr": "OB", "BinaryLength": 201600},
        "1102": {"vr": "OB", "BinaryLength": 201600},
        "1103": {"vr": "OB", "BinaryLength": 201600},
        "1104": {"vr": "OB", "BinaryLength": 201600},
        "1105": {"vr": "OB", "BinaryLength": 201600},
        "1106": {"vr": "OB", "BinaryLength": 201600},
        "1107": {"vr": "OB", "BinaryLength": 201600},
        "1108": {"vr": "OB", "BinaryLength": 201600},
        "1109": {"vr": "OB", "BinaryLength": 201600},
        "1110": {"vr": "OB", "BinaryLength": 201600},
        "1111": {"vr": "OB", "BinaryLength": 201600},
        "1112": {"vr": "OB", "BinaryLength": 201600},
        "1113": {"vr": "OB", "BinaryLength": 201600},
        "1114": {"vr": "OB", "BinaryLength": 201600},
        "1115": {"vr": "OB", "BinaryLength": 201600},
        "1116": {"vr": "OB", "BinaryLength": 201600},
        "1117": {"vr": "OB", "BinaryLength": 201600},
        "1118": {"vr": "OB", "BinaryLength": 201600},
        "1119": {"vr": "OB", "BinaryLength": 201600},
        "1120": {"vr": "OB", "BinaryLength": 201600},
        "1121": {"vr": "OB", "BinaryLength": 201600},
        "1122": {"vr": "OB", "BinaryLength": 201600},
        "1123": {"vr": "OB", "BinaryLength": 201600},
        "1124": {"vr": "OB", "BinaryLength": 201600},
        "1125": {"vr": "OB", "BinaryLength": 201600},
        "1126": {"vr": "OB", "BinaryLength": 201600},
        "1127": {"vr": "OB", "BinaryLength": 201600},
        "1128": {"vr": "OB", "BinaryLength": 201600},
        "1129": {"vr": "OB", "BinaryLength": 201600},
        "1130": {"vr": "OB", "BinaryLength": 201600},
        "1131": {"vr": "OB", "BinaryLength": 201600},
        "1132": {"vr": "OB", "BinaryLength": 201600},
        "1133": {"vr": "OB", "BinaryLength": 201600},
        "1134": {"vr": "OB", "BinaryLength": 201600},
        "1135": {"vr": "OB", "BinaryLength": 201600},
        "1136": {"vr": "OB", "BinaryLength": 201600},
        "1137": {"vr": "OB", "BinaryLength": 201600},
        "1138": {"vr": "OB", "BinaryLength": 201600},
        "1139": {"vr": "OB", "BinaryLength": 201600},
        "1140": {"vr": "OB", "BinaryLength": 201600},
        "1141": {"vr": "OB", "BinaryLength": 201600},
        "1142": {"vr": "OB", "BinaryLength": 201600},
        "1143": {"vr": "OB", "BinaryLength": 201600},
        "1144": {"vr": "OB", "BinaryLength": 201600},
        "1145": {"vr": "OB", "BinaryLength": 201600},
        "1146": {"vr": "OB", "BinaryLength": 201600},
        "1147": {"vr": "OB", "BinaryLength": 201600},
        "1148": {"vr": "OB", "BinaryLength": 201600},
        "1149": {"vr": "OB", "BinaryLength": 201600},
        "1150": {"vr": "OB", "BinaryLength": 201600},
        "1151": {"vr": "OB", "BinaryLength": 201600},
        "1152": {"vr": "OB", "BinaryLength": 201600},
        "1153": {"vr": "OB", "BinaryLength": 201600},
        "1154": {"vr": "OB", "BinaryLength": 201600},
        "1155": {"vr": "OB", "BinaryLength": 201600},
        "1156": {"vr": "OB", "BinaryLength": 201600},
        "1157": {"vr": "OB", "BinaryLength": 201600},
        "1158": {"vr": "OB", "BinaryLength": 201600},
        "1159": {"vr": "OB", "BinaryLength": 201600},
        "1160": {"vr": "OB", "BinaryLength": 201600},
        "1161": {"vr": "OB", "BinaryLength": 201600},
        "1162": {"vr": "OB", "BinaryLength": 201600},
        "1163": {"vr": "OB", "BinaryLength": 201600},
        "1164": {"vr": "OB", "BinaryLength": 201600},
        "1165": {"vr": "OB", "BinaryLength": 201600},
        "1166": {"vr": "OB", "BinaryLength": 201600},
        "1167": {"vr": "OB", "BinaryLength": 201600},
        "1168": {"vr": "OB", "BinaryLength": 201600},
        "1169": {"vr": "OB", "BinaryLength": 201600},
        "1170": {"vr": "OB", "BinaryLength": 201600},
        "1171": {"vr": "OB", "BinaryLength": 201600},
        "1172": {"vr": "OB", "BinaryLength": 201600},
        "1173": {"vr": "OB", "BinaryLength": 201600},
        "1174": {"vr": "OB", "BinaryLength": 201600},
        "1175": {"vr": "OB", "BinaryLength": 201600},
        "1176": {"vr": "OB", "BinaryLength": 201600},
        "1177": {"vr": "OB", "BinaryLength": 201600},
        "1178": {"vr": "OB", "BinaryLength": 201600},
        "1179": {"vr": "OB", "BinaryLength": 201600},
        "1180": {"vr": "OB", "BinaryLength": 201600},
        "1181": {"vr": "OB", "BinaryLength": 201600},
        "1182": {"vr": "OB", "BinaryLength": 201600},
        "1183": {"vr": "OB", "BinaryLength": 201600},
        "1184": {"vr": "OB", "BinaryLength": 201600},
        "1185": {"vr": "OB", "BinaryLength": 201600},
        "1186": {"vr": "OB", "BinaryLength": 201600},
        "1187": {"vr": "OB", "BinaryLength": 201600},
        "1188": {"vr": "OB", "BinaryLength": 201600},
        "1189": {"vr": "OB", "BinaryLength": 201600},
        "1190": {"vr": "OB", "BinaryLength": 201600},
        "1191": {"vr": "OB", "BinaryLength": 201600},
        "1192": {"vr": "OB", "BinaryLength": 201600},
        "1193": {"vr": "OB", "BinaryLength": 201600},
        "1194": {"vr": "OB", "BinaryLength": 201600},
        "1195": {"vr": "OB", "BinaryLength": 201600},
        "1196": {"vr": "OB", "BinaryLength": 201600},
        "1197": {"vr": "OB", "BinaryLength": 201600},
        "1198": {"vr": "OB", "BinaryLength": 201600},
        "1199": {"vr": "OB", "BinaryLength": 201600},
        "1200": {"vr": "OB", "BinaryLength": 201600},
        "1201": {"vr": "OB", "BinaryLength": 201600},
        "1202": {"vr": "OB", "BinaryLength": 201600},
        "1203": {"vr": "OB", "BinaryLength": 201600},
        "1204": {"vr": "OB", "BinaryLength": 201600},
        "1205": {"vr": "OB", "BinaryLength": 201600},
        "1206": {"vr": "OB", "BinaryLength": 201600},
        "1207": {"vr": "OB", "BinaryLength": 201600},
        "1208": {"vr": "OB", "BinaryLength": 201600},
        "1209": {"vr": "OB", "BinaryLength": 201600},
        "1210": {"vr": "OB", "BinaryLength": 201600},
        "1211": {"vr": "OB", "BinaryLength": 201600},
        "1212": {"vr": "OB", "BinaryLength": 201600},
        "1213": {"vr": "OB", "BinaryLength": 201600},
        "1214": {"vr": "OB", "BinaryLength": 201600},
        "1215": {"vr": "OB", "BinaryLength": 201600},
        "1216": {"vr": "OB", "BinaryLength": 201600},
        "1217": {"vr": "OB", "BinaryLength": 201600},
        "1218": {"vr": "OB", "BinaryLength": 201600},
        "1219": {"vr": "OB", "BinaryLength": 201600},
        "1220": {"vr": "OB", "BinaryLength": 201600},
        "1221": {"vr": "OB", "BinaryLength": 201600},
        "1222": {"vr": "OB", "BinaryLength": 201600},
        "1223": {"vr": "OB", "BinaryLength": 201600},
        "1224": {"vr": "OB", "BinaryLength": 201600},
        "1225": {"vr": "OB", "BinaryLength": 201600},
        "1226": {"vr": "OB", "BinaryLength": 201600},
        "1227": {"vr": "OB", "BinaryLength": 201600},
        "1228": {"vr": "OB", "BinaryLength": 201600},
        "1229": {"vr": "OB", "BinaryLength": 201600},
        "1230": {"vr": "OB", "BinaryLength": 201600},
        "1231": {"vr": "OB", "BinaryLength": 201600},
        "1232": {"vr": "OB", "BinaryLength": 201600},
        "1233": {"vr": "OB", "BinaryLength": 201600},
        "1234": {"vr": "OB", "BinaryLength": 201600},
        "1235": {"vr": "OB", "BinaryLength": 201600},
        "1236": {"vr": "OB", "BinaryLength": 201600},
        "1237": {"vr": "OB", "BinaryLength": 201600},
        "1238": {"vr": "OB", "BinaryLength": 201600},
        "1239": {"vr": "OB", "BinaryLength": 201600},
        "1240": {"vr": "OB", "BinaryLength": 201600},
        "1241": {"vr": "OB", "BinaryLength": 201600},
        "1242": {"vr": "OB", "BinaryLength": 201600},
        "1243": {"vr": "OB", "BinaryLength": 201600},
        "1244": {"vr": "OB", "BinaryLength": 201600},
        "1245": {"vr": "OB", "BinaryLength": 201600},
        "1246": {"vr": "OB", "BinaryLength": 201600},
        "1247": {"vr": "OB", "BinaryLength": 201600},
        "1248": {"vr": "OB", "BinaryLength": 201600},
        "1249": {"vr": "OB", "BinaryLength": 201600},
        "1250": {"vr": "OB", "BinaryLength": 201600},
        "1251": {"vr": "OB", "BinaryLength": 201600},
        "1252": {"vr": "OB", "BinaryLength": 201600},
        "1253": {"vr": "OB", "BinaryLength": 201600},
        "1254": {"vr": "OB", "BinaryLength": 201600},
        "1255": {"vr": "OB", "BinaryLength": 201600},
        "1256": {"vr": "OB", "BinaryLength": 201600},
        "1257": {"vr": "OB", "BinaryLength": 201600},
        "1258": {"vr": "OB", "BinaryLength": 201600},
        "1259": {"vr": "OB", "BinaryLength": 201600},
        "1260": {"vr": "OB", "BinaryLength": 201600},
        "1261": {"vr": "OB", "BinaryLength": 201600},
        "1262": {"vr": "OB", "BinaryLength": 201600},
        "1263": {"vr": "OB", "BinaryLength": 201600},
        "1264": {"vr": "OB", "BinaryLength": 201600},
        "1265": {"vr": "OB", "BinaryLength": 201600},
        "1266": {"vr": "OB", "BinaryLength": 201600},
        "1267": {"vr": "OB", "BinaryLength": 201600},
        "1268": {"vr": "OB", "BinaryLength": 201600},
        "1269": {"vr": "OB", "BinaryLength": 201600},
        "1270": {"vr": "OB", "BinaryLength": 201600},
        "1271": {"vr": "OB", "BinaryLength": 201600},
        "1272": {"vr": "OB", "BinaryLength": 201600},
        "1273": {"vr": "OB", "BinaryLength": 201600},
        "1274": {"vr": "OB", "BinaryLength": 201600},
        "1275": {"vr": "OB", "BinaryLength": 201600},
        "1276": {"vr": "OB", "BinaryLength": 201600},
        "1277": {"vr": "OB", "BinaryLength": 201600},
        "1278": {"vr": "OB", "BinaryLength": 201600},
        "1279": {"vr": "OB", "BinaryLength": 201600},
        "1280": {"vr": "OB", "BinaryLength": 201600},
        "1281": {"vr": "OB", "BinaryLength": 201600},
        "1282": {"vr": "OB", "BinaryLength": 201600},
        "1283": {"vr": "OB", "BinaryLength": 201600},
        "1284": {"vr": "OB", "BinaryLength": 201600},
        "1285": {"vr": "OB", "BinaryLength": 201600},
        "1286": {"vr": "OB", "BinaryLength": 201600},
        "1287": {"vr": "OB", "BinaryLength": 201600},
        "1288": {"vr": "OB", "BinaryLength": 201600},
        "1289": {"vr": "OB", "BinaryLength": 201600},
        "1290": {"vr": "OB", "BinaryLength": 201600},
        "1291": {"vr": "OB", "BinaryLength": 201600},
        "1292": {"vr": "OB", "BinaryLength": 201600},
        "1293": {"vr": "OB", "BinaryLength": 201600},
        "1294": {"vr": "OB", "BinaryLength": 201600},
        "1295": {"vr": "OB", "BinaryLength": 201600},
        "1296": {"vr": "OB", "BinaryLength": 201600},
        "1297": {"vr": "OB", "BinaryLength": 201600},
        "1298": {"vr": "OB", "BinaryLength": 201600},
        "1299": {"vr": "OB", "BinaryLength": 201600},
        "1300": {"vr": "OB", "BinaryLength": 201600},
        "1301": {"vr": "OB", "BinaryLength": 201600},
        "1302": {"vr": "OB", "BinaryLength": 201600},
        "1303": {"vr": "OB", "BinaryLength": 201600},
        "1304": {"vr": "OB", "BinaryLength": 201600},
        "1305": {"vr": "OB", "BinaryLength": 201600},
        "1306": {"vr": "OB", "BinaryLength": 201600},
        "1307": {"vr": "OB", "BinaryLength": 201600},
        "1308": {"vr": "OB", "BinaryLength": 201600},
        "1309": {"vr": "OB", "BinaryLength": 201600},
        "1310": {"vr": "OB", "BinaryLength": 201600},
        "1311": {"vr": "OB", "BinaryLength": 201600},
        "1312": {"vr": "OB", "BinaryLength": 201600},
        "1313": {"vr": "OB", "BinaryLength": 201600},
        "1314": {"vr": "OB", "BinaryLength": 201600},
        "1315": {"vr": "OB", "BinaryLength": 201600},
        "1316": {"vr": "OB", "BinaryLength": 201600},
        "1317": {"vr": "OB", "BinaryLength": 201600},
        "1318": {"vr": "OB", "BinaryLength": 201600},
        "1319": {"vr": "OB", "BinaryLength": 201600},
        "1320": {"vr": "OB", "BinaryLength": 201600},
        "1321": {"vr": "OB", "BinaryLength": 201600},
        "1322": {"vr": "OB", "BinaryLength": 201600},
        "1323": {"vr": "OB", "BinaryLength": 201600},
        "1324": {"vr": "OB", "BinaryLength": 201600},
        "1325": {"vr": "OB", "BinaryLength": 201600},
        "1326": {"vr": "OB", "BinaryLength": 201600},
        "1327": {"vr": "OB", "BinaryLength": 201600},
        "1328": {"vr": "OB", "BinaryLength": 201600},
        "1329": {"vr": "OB", "BinaryLength": 201600},
        "1330": {"vr": "OB", "BinaryLength": 201600},
        "1331": {"vr": "OB", "BinaryLength": 201600},
        "1332": {"vr": "OB", "BinaryLength": 201600},
        "1333": {"vr": "OB", "BinaryLength": 201600},
        "1334": {"vr": "OB", "BinaryLength": 201600},
        "1335": {"vr": "OB", "BinaryLength": 201600},
        "1336": {"vr": "OB", "BinaryLength": 201600},
        "1337": {"vr": "OB", "BinaryLength": 201600},
        "1338": {"vr": "OB", "BinaryLength": 201600},
        "1339": {"vr": "OB", "BinaryLength": 201600},
        "1340": {"vr": "OB", "BinaryLength": 201600},
        "1341": {"vr": "OB", "BinaryLength": 201600},
        "1342": {"vr": "OB", "BinaryLength": 201600},
        "1343": {"vr": "OB", "BinaryLength": 201600},
        "1344": {"vr": "OB", "BinaryLength": 201600},
        "1345": {"vr": "OB", "BinaryLength": 201600},
        "1346": {"vr": "OB", "BinaryLength": 201600},
        "1347": {"vr": "OB", "BinaryLength": 201600},
        "1348": {"vr": "OB", "BinaryLength": 201600},
        "1349": {"vr": "OB", "BinaryLength": 201600},
        "1350": {"vr": "OB", "BinaryLength": 201600},
        "1351": {"vr": "OB", "BinaryLength": 201600},
        "1352": {"vr": "OB", "BinaryLength": 201600},
        "1353": {"vr": "OB", "BinaryLength": 201600},
        "1354": {"vr": "OB", "BinaryLength": 201600},
        "1355": {"vr": "OB", "BinaryLength": 201600},
        "1356": {"vr": "OB", "BinaryLength": 201600},
        "1357": {"vr": "OB", "BinaryLength": 201600},
        "1358": {"vr": "OB", "BinaryLength": 201600},
        "1359": {"vr": "OB", "BinaryLength": 201600},
        "1360": {"vr": "OB", "BinaryLength": 201600},
        "1361": {"vr": "OB", "BinaryLength": 201600},
        "1362": {"vr": "OB", "BinaryLength": 201600},
        "1363": {"vr": "OB", "BinaryLength": 201600},
        "1364": {"vr": "OB", "BinaryLength": 201600},
        "1365": {"vr": "OB", "BinaryLength": 201600},
        "1366": {"vr": "OB", "BinaryLength": 201600},
        "1367": {"vr": "OB", "BinaryLength": 201600},
        "1368": {"vr": "OB", "BinaryLength": 201600},
        "1369": {"vr": "OB", "BinaryLength": 201600},
        "1370": {"vr": "OB", "BinaryLength": 201600},
        "1371": {"vr": "OB", "BinaryLength": 201600},
        "1372": {"vr": "OB", "BinaryLength": 201600},
        "1373": {"vr": "OB", "BinaryLength": 201600},
        "1374": {"vr": "OB", "BinaryLength": 201600},
        "1375": {"vr": "OB", "BinaryLength": 201600},
        "1376": {"vr": "OB", "BinaryLength": 201600},
        "1377": {"vr": "OB", "BinaryLength": 201600},
        "1378": {"vr": "OB", "BinaryLength": 201600},
        "1379": {"vr": "OB", "BinaryLength": 201600},
        "1380": {"vr": "OB", "BinaryLength": 201600},
        "1381": {"vr": "OB", "BinaryLength": 201600},
        "1382": {"vr": "OB", "BinaryLength": 201600},
        "1383": {"vr": "OB", "BinaryLength": 201600},
        "1384": {"vr": "OB", "BinaryLength": 201600},
        "1385": {"vr": "OB", "BinaryLength": 201600},
        "1386": {"vr": "OB", "BinaryLength": 201600},
        "1387": {"vr": "OB", "BinaryLength": 201600},
        "1388": {"vr": "OB", "BinaryLength": 201600},
        "1389": {"vr": "OB", "BinaryLength": 201600},
        "1390": {"vr": "OB", "BinaryLength": 201600},
        "1391": {"vr": "OB", "BinaryLength": 201600},
        "1392": {"vr": "OB", "BinaryLength": 201600},
        "1393": {"vr": "OB", "BinaryLength": 201600},
        "1394": {"vr": "OB", "BinaryLength": 201600},
        "1395": {"vr": "OB", "BinaryLength": 201600},
        "1396": {"vr": "OB", "BinaryLength": 201600},
        "1397": {"vr": "OB", "BinaryLength": 201600},
        "1398": {"vr": "OB", "BinaryLength": 201600},
        "1399": {"vr": "OB", "BinaryLength": 201600},
        "1400": {"vr": "OB", "BinaryLength": 201600},
        "1401": {"vr": "OB", "BinaryLength": 201600},
        "1402": {"vr": "OB", "BinaryLength": 201600},
        "1403": {"vr": "OB", "BinaryLength": 201600},
        "1404": {"vr": "OB", "BinaryLength": 201600},
        "1405": {"vr": "OB", "BinaryLength": 201600},
        "1406": {"vr": "OB", "BinaryLength": 201600},
        "1407": {"vr": "OB", "BinaryLength": 201600},
        "1408": {"vr": "OB", "BinaryLength": 201600},
        "1409": {"vr": "OB", "BinaryLength": 201600},
        "1410": {"vr": "OB", "BinaryLength": 201600},
        "1411": {"vr": "OB", "BinaryLength": 201600},
        "1412": {"vr": "OB", "BinaryLength": 201600},
        "1413": {"vr": "OB", "BinaryLength": 201600},
        "1414": {"vr": "OB", "BinaryLength": 201600},
        "1415": {"vr": "OB", "BinaryLength": 201600},
        "1416": {"vr": "OB", "BinaryLength": 201600},
        "1417": {"vr": "OB", "BinaryLength": 201600},
        "1418": {"vr": "OB", "BinaryLength": 201600},
        "1419": {"vr": "OB", "BinaryLength": 201600},
        "1420": {"vr": "OB", "BinaryLength": 201600},
        "1421": {"vr": "OB", "BinaryLength": 201600},
        "1422": {"vr": "OB", "BinaryLength": 201600},
        "1423": {"vr": "OB", "BinaryLength": 201600},
        "1424": {"vr": "OB", "BinaryLength": 201600},
        "1425": {"vr": "OB", "BinaryLength": 201600},
        "1426": {"vr": "OB", "BinaryLength": 201600},
        "1427": {"vr": "OB", "BinaryLength": 201600},
        "1428": {"vr": "OB", "BinaryLength": 201600},
        "1429": {"vr": "OB", "BinaryLength": 201600},
        "1430": {"vr": "OB", "BinaryLength": 201600},
        "1431": {"vr": "OB", "BinaryLength": 201600},
        "1432": {"vr": "OB", "BinaryLength": 201600},
        "1433": {"vr": "OB", "BinaryLength": 201600},
        "1434": {"vr": "OB", "BinaryLength": 201600},
        "1435": {"vr": "OB", "BinaryLength": 201600},
        "1436": {"vr": "OB", "BinaryLength": 201600},
        "1437": {"vr": "OB", "BinaryLength": 201600},
        "1438": {"vr": "OB", "BinaryLength": 201600},
        "1439": {"vr": "OB", "BinaryLength": 201600},
        "1440": {"vr": "OB", "BinaryLength": 201600},
        "1441": {"vr": "OB", "BinaryLength": 201600},
        "1442": {"vr": "OB", "BinaryLength": 201600},
        "1443": {"vr": "OB", "BinaryLength": 201600},
        "1444": {"vr": "OB", "BinaryLength": 201600},
        "1445": {"vr": "OB", "BinaryLength": 201600},
        "1446": {"vr": "OB", "BinaryLength": 201600},
        "1447": {"vr": "OB", "BinaryLength": 201600},
        "1448": {"vr": "OB", "BinaryLength": 201600},
        "1449": {"vr": "OB", "BinaryLength": 201600},
        "1450": {"vr": "OB", "BinaryLength": 201600},
        "1451": {"vr": "OB", "BinaryLength": 201600},
        "1452": {"vr": "OB", "BinaryLength": 201600},
        "1453": {"vr": "OB", "BinaryLength": 201600},
        "1454": {"vr": "OB", "BinaryLength": 201600},
        "1455": {"vr": "OB", "BinaryLength": 201600},
        "1456": {"vr": "OB", "BinaryLength": 201600},
        "1457": {"vr": "OB", "BinaryLength": 201600},
        "1458": {"vr": "OB", "BinaryLength": 201600},
        "1459": {"vr": "OB", "BinaryLength": 201600},
        "1460": {"vr": "OB", "BinaryLength": 201600},
        "1461": {"vr": "OB", "BinaryLength": 201600},
        "1462": {"vr": "OB", "BinaryLength": 201600},
        "1463": {"vr": "OB", "BinaryLength": 201600},
        "1464": {"vr": "OB", "BinaryLength": 201600},
        "1465": {"vr": "OB", "BinaryLength": 201600},
        "1466": {"vr": "OB", "BinaryLength": 201600},
        "1467": {"vr": "OB", "BinaryLength": 201600},
        "1468": {"vr": "OB", "BinaryLength": 201600},
        "1469": {"vr": "OB", "BinaryLength": 201600},
        "1470": {"vr": "OB", "BinaryLength": 201600},
        "1471": {"vr": "OB", "BinaryLength": 201600},
        "1472": {"vr": "OB", "BinaryLength": 201600},
        "1473": {"vr": "OB", "BinaryLength": 201600},
        "1474": {"vr": "OB", "BinaryLength": 201600},
        "1475": {"vr": "OB", "BinaryLength": 201600},
        "1476": {"vr": "OB", "BinaryLength": 201600},
        "1477": {"vr": "OB", "BinaryLength": 201600},
        "1478": {"vr": "OB", "BinaryLength": 201600},
        "1479": {"vr": "OB", "BinaryLength": 201600},
        "1480": {"vr": "OB", "BinaryLength": 201600},
        "1481": {"vr": "OB", "BinaryLength": 201600},
        "1482": {"vr": "OB", "BinaryLength": 201600},
        "1483": {"vr": "OB", "BinaryLength": 201600},
        "1484": {"vr": "OB", "BinaryLength": 201600},
        "1485": {"vr": "OB", "BinaryLength": 201600},
        "1486": {"vr": "OB", "BinaryLength": 201600},
        "1487": {"vr": "OB", "BinaryLength": 201600},
        "1488": {"vr": "OB", "BinaryLength": 201600},
        "1489": {"vr": "OB", "BinaryLength": 201600},
        "1490": {"vr": "OB", "BinaryLength": 201600},
        "1491": {"vr": "OB", "BinaryLength": 201600},
        "1492": {"vr": "OB", "BinaryLength": 201600},
        "1493": {"vr": "OB", "BinaryLength": 201600},
        "1494": {"vr": "OB", "BinaryLength": 201600},
        "1495": {"vr": "OB", "BinaryLength": 201600},
        "1496": {"vr": "OB", "BinaryLength": 201600},
        "1497": {"vr": "OB", "BinaryLength": 201600},
        "1498": {"vr": "OB", "BinaryLength": 201600},
        "1499": {"vr": "OB", "BinaryLength": 201600},
        "1500": {"vr": "OB", "BinaryLength": 201600},
        "1501": {"vr": "OB", "BinaryLength": 201600},
        "1502": {"vr": "OB", "BinaryLength": 201600},
        "1503": {"vr": "OB", "BinaryLength": 201600},
        "1504": {"vr": "OB", "BinaryLength": 201600},
        "1505": {"vr": "OB", "BinaryLength": 201600},
        "1506": {"vr": "OB", "BinaryLength": 201600},
        "1507": {"vr": "OB", "BinaryLength": 201600},
        "1508": {"vr": "OB", "BinaryLength": 201600},
        "1509": {"vr": "OB", "BinaryLength": 201600},
        "1510": {"vr": "OB", "BinaryLength": 201600},
        "1511": {"vr": "OB", "BinaryLength": 201600},
        "1512": {"vr": "OB", "BinaryLength": 201600},
        "1513": {"vr": "OB", "BinaryLength": 201600},
        "1514": {"vr": "OB", "BinaryLength": 201600},
        "1515": {"vr": "OB", "BinaryLength": 201600},
        "1516": {"vr": "OB", "BinaryLength": 201600},
        "1517": {"vr": "OB", "BinaryLength": 201600},
        "1518": {"vr": "OB", "BinaryLength": 201600},
        "1519": {"vr": "OB", "BinaryLength": 201600},
        "1520": {"vr": "OB", "BinaryLength": 201600},
        "1521": {"vr": "OB", "BinaryLength": 201600},
        "1522": {"vr": "OB", "BinaryLength": 201600},
        "1523": {"vr": "OB", "BinaryLength": 201600},
        "1524": {"vr": "OB", "BinaryLength": 201600},
        "1525": {"vr": "OB", "BinaryLength": 201600},
        "1526": {"vr": "OB", "BinaryLength": 201600},
        "1527": {"vr": "OB", "BinaryLength": 201600},
        "1528": {"vr": "OB", "BinaryLength": 201600},
        "1529": {"vr": "OB", "BinaryLength": 201600},
        "1530": {"vr": "OB", "BinaryLength": 201600},
        "1531": {"vr": "OB", "BinaryLength": 201600},
        "1532": {"vr": "OB", "BinaryLength": 201600},
        "1533": {"vr": "OB", "BinaryLength": 201600},
        "1534": {"vr": "OB", "BinaryLength": 201600},
        "1535": {"vr": "OB", "BinaryLength": 201600},
        "1536": {"vr": "OB", "BinaryLength": 201600},
        "1537": {"vr": "OB", "BinaryLength": 201600},
        "1538": {"vr": "OB", "BinaryLength": 201600},
        "1539": {"vr": "OB", "BinaryLength": 201600},
        "1540": {"vr": "OB", "BinaryLength": 201600},
        "1541": {"vr": "OB", "BinaryLength": 201600},
        "1542": {"vr": "OB", "BinaryLength": 201600},
        "1543": {"vr": "OB", "BinaryLength": 201600},
        "1544": {"vr": "OB", "BinaryLength": 201600},
        "1545": {"vr": "OB", "BinaryLength": 201600},
        "1546": {"vr": "OB", "BinaryLength": 201600},
        "1547": {"vr": "OB", "BinaryLength": 201600},
        "1548": {"vr": "OB", "BinaryLength": 201600},
        "1549": {"vr": "OB", "BinaryLength": 201600},
        "1550": {"vr": "OB", "BinaryLength": 201600},
        "1551": {"vr": "OB", "BinaryLength": 201600},
        "1552": {"vr": "OB", "BinaryLength": 201600},
        "1553": {"vr": "OB", "BinaryLength": 201600},
        "1554": {"vr": "OB", "BinaryLength": 201600},
        "1555": {"vr": "OB", "BinaryLength": 201600},
        "1556": {"vr": "OB", "BinaryLength": 201600},
        "1557": {"vr": "OB", "BinaryLength": 201600},
        "1558": {"vr": "OB", "BinaryLength": 201600},
        "1559": {"vr": "OB", "BinaryLength": 201600},
        "1560": {"vr": "OB", "BinaryLength": 201600},
        "1561": {"vr": "OB", "BinaryLength": 201600},
        "1562": {"vr": "OB", "BinaryLength": 201600},
        "1563": {"vr": "OB", "BinaryLength": 201600},
        "1564": {"vr": "OB", "BinaryLength": 201600},
        "1565": {"vr": "OB", "BinaryLength": 201600},
        "1566": {"vr": "OB", "BinaryLength": 201600},
        "1567": {"vr": "OB", "BinaryLength": 201600},
        "1568": {"vr": "OB", "BinaryLength": 201600},
        "1569": {"vr": "OB", "BinaryLength": 201600},
        "1570": {"vr": "OB", "BinaryLength": 201600},
        "1571": {"vr": "OB", "BinaryLength": 201600},
        "1572": {"vr": "OB", "BinaryLength": 201600},
        "1573": {"vr": "OB", "BinaryLength": 201600},
        "1574": {"vr": "OB", "BinaryLength": 201600},
        "1575": {"vr": "OB", "BinaryLength": 201600},
        "1576": {"vr": "OB", "BinaryLength": 201600},
        "1577": {"vr": "OB", "BinaryLength": 201600},
        "1578": {"vr": "OB", "BinaryLength": 201600},
        "1579": {"vr": "OB", "BinaryLength": 201600},
        "1580": {"vr": "OB", "BinaryLength": 201600},
        "1581": {"vr": "OB", "BinaryLength": 201600},
        "1582": {"vr": "OB", "BinaryLength": 201600},
        "1583": {"vr": "OB", "BinaryLength": 201600},
        "1584": {"vr": "OB", "BinaryLength": 201600},
        "1585": {"vr": "OB", "BinaryLength": 201600},
        "1586": {"vr": "OB", "BinaryLength": 201600},
        "1587": {"vr": "OB", "BinaryLength": 201600},
        "1588": {"vr": "OB", "BinaryLength": 201600},
        "1589": {"vr": "OB", "BinaryLength": 201600},
        "1590": {"vr": "OB", "BinaryLength": 201600},
        "1591": {"vr": "OB", "BinaryLength": 201600},
        "1592": {"vr": "OB", "BinaryLength": 201600},
        "1593": {"vr": "OB", "BinaryLength": 201600},
        "1594": {"vr": "OB", "BinaryLength": 201600},
        "1595": {"vr": "OB", "BinaryLength": 201600},
        "1596": {"vr": "OB", "BinaryLength": 201600},
        "1597": {"vr": "OB", "BinaryLength": 201600},
        "1598": {"vr": "OB", "BinaryLength": 201600},
        "1599": {"vr": "OB", "BinaryLength": 201600},
        "1600": {"vr": "OB", "BinaryLength": 201600},
        "1601": {"vr": "OB", "BinaryLength": 201600},
        "1602": {"vr": "OB", "BinaryLength": 201600},
        "1603": {"vr": "OB", "BinaryLength": 201600},
        "1604": {"vr": "OB", "BinaryLength": 201600},
        "1605": {"vr": "OB", "BinaryLength": 201600},
        "1606": {"vr": "OB", "BinaryLength": 201600},
        "1607": {"vr": "OB", "BinaryLength": 201600},
        "1608": {"vr": "OB", "BinaryLength": 201600},
        "1609": {"vr": "OB", "BinaryLength": 201600},
        "1610": {"vr": "OB", "BinaryLength": 201600},
        "1611": {"vr": "OB", "BinaryLength": 201600},
        "1612": {"vr": "OB", "BinaryLength": 201600},
        "1613": {"vr": "OB", "BinaryLength": 201600},
        "1614": {"vr": "OB", "BinaryLength": 201600},
        "1615": {"vr": "OB", "BinaryLength": 201600},
        "1616": {"vr": "OB", "BinaryLength": 201600},
        "1617": {"vr": "OB", "BinaryLength": 201600},
        "1618": {"vr": "OB", "BinaryLength": 201600},
        "1619": {"vr": "OB", "BinaryLength": 201600},
        "1620": {"vr": "OB", "BinaryLength": 201600},
        "1621": {"vr": "OB", "BinaryLength": 201600},
        "1622": {"vr": "OB", "BinaryLength": 201600},
        "1623": {"vr": "OB", "BinaryLength": 201600},
        "1624": {"vr": "OB", "BinaryLength": 201600},
        "1625": {"vr": "OB", "BinaryLength": 201600},
        "1626": {"vr": "OB", "BinaryLength": 201600},
        "1627": {"vr": "OB", "BinaryLength": 201600},
        "1628": {"vr": "OB", "BinaryLength": 201600},
        "1629": {"vr": "OB", "BinaryLength": 201600},
        "1630": {"vr": "OB", "BinaryLength": 201600},
        "1631": {"vr": "OB", "BinaryLength": 201600},
        "1632": {"vr": "OB", "BinaryLength": 201600},
        "1633": {"vr": "OB", "BinaryLength": 201600},
        "1634": {"vr": "OB", "BinaryLength": 201600},
        "1635": {"vr": "OB", "BinaryLength": 201600},
        "1636": {"vr": "OB", "BinaryLength": 201600},
        "1637": {"vr": "OB", "BinaryLength": 201600},
        "1638": {"vr": "OB", "BinaryLength": 201600},
        "1639": {"vr": "OB", "BinaryLength": 201600},
        "1640": {"vr": "OB", "BinaryLength": 201600},
        "1641": {"vr": "OB", "BinaryLength": 201600},
        "1642": {"vr": "OB", "BinaryLength": 201600},
        "1643": {"vr": "OB", "BinaryLength": 201600},
        "1644": {"vr": "OB", "BinaryLength": 201600},
        "1645": {"vr": "OB", "BinaryLength": 201600},
        "1646": {"vr": "OB", "BinaryLength": 201600},
        "1647": {"vr": "OB", "BinaryLength": 201600},
        "1648": {"vr": "OB", "BinaryLength": 201600},
        "1649": {"vr": "OB", "BinaryLength": 201600},
        "1650": {"vr": "OB", "BinaryLength": 201600},
        "1651": {"vr": "OB", "BinaryLength": 201600},
        "1652": {"vr": "OB", "BinaryLength": 201600},
        "1653": {"vr": "OB", "BinaryLength": 201600},
        "1654": {"vr": "OB", "BinaryLength": 201600},
        "1655": {"vr": "OB", "BinaryLength": 201600},
        "1656": {"vr": "OB", "BinaryLength": 201600},
        "1657": {"vr": "OB", "BinaryLength": 201600},
        "1658": {"vr": "OB", "BinaryLength": 201600},
        "1659": {"vr": "OB", "BinaryLength": 201600},
        "1660": {"vr": "OB", "BinaryLength": 201600},
        "1661": {"vr": "OB", "BinaryLength": 201600},
        "1662": {"vr": "OB", "BinaryLength": 201600},
        "1663": {"vr": "OB", "BinaryLength": 201600},
        "1664": {"vr": "OB", "BinaryLength": 201600},
        "1665": {"vr": "OB", "BinaryLength": 201600},
        "1666": {"vr": "OB", "BinaryLength": 201600},
        "1667": {"vr": "OB", "BinaryLength": 201600},
        "1668": {"vr": "OB", "BinaryLength": 201600},
        "1669": {"vr": "OB", "BinaryLength": 201600},
        "1670": {"vr": "OB", "BinaryLength": 201600},
        "1671": {"vr": "OB", "BinaryLength": 201600},
        "1672": {"vr": "OB", "BinaryLength": 201600},
        "1673": {"vr": "OB", "BinaryLength": 201600},
        "1674": {"vr": "OB", "BinaryLength": 201600},
        "1675": {"vr": "OB", "BinaryLength": 201600},
        "1676": {"vr": "OB", "BinaryLength": 201600},
        "1677": {"vr": "OB", "BinaryLength": 201600},
        "1678": {"vr": "OB", "BinaryLength": 201600},
        "1679": {"vr": "OB", "BinaryLength": 201600},
        "1680": {"vr": "OB", "BinaryLength": 201600},
        "1681": {"vr": "OB", "BinaryLength": 201600},
        "1682": {"vr": "OB", "BinaryLength": 201600},
        "1683": {"vr": "OB", "BinaryLength": 201600},
        "1684": {"vr": "OB", "BinaryLength": 201600},
        "1685": {"vr": "OB", "BinaryLength": 201600},
        "1686": {"vr": "OB", "BinaryLength": 201600},
        "1687": {"vr": "OB", "BinaryLength": 201600},
        "1688": {"vr": "OB", "BinaryLength": 201600},
        "1689": {"vr": "OB", "BinaryLength": 201600},
        "1690": {"vr": "OB", "BinaryLength": 201600},
        "1691": {"vr": "OB", "BinaryLength": 201600},
        "1692": {"vr": "OB", "BinaryLength": 201600},
        "1693": {"vr": "OB", "BinaryLength": 201600},
        "1694": {"vr": "OB", "BinaryLength": 201600},
        "1695": {"vr": "OB", "BinaryLength": 201600},
        "1696": {"vr": "OB", "BinaryLength": 201600},
        "1697": {"vr": "OB", "BinaryLength": 201600},
        "1698": {"vr": "OB", "BinaryLength": 201600},
        "1699": {"vr": "OB", "BinaryLength": 201600},
        "1700": {"vr": "OB", "BinaryLength": 201600},
        "1701": {"vr": "OB", "BinaryLength": 201600},
        "1702": {"vr": "OB", "BinaryLength": 201600},
        "1703": {"vr": "OB", "BinaryLength": 201600},
        "1704": {"vr": "OB", "BinaryLength": 201600},
        "1705": {"vr": "OB", "BinaryLength": 201600},
        "1706": {"vr": "OB", "BinaryLength": 201600},
        "1707": {"vr": "OB", "BinaryLength": 201600},
        "1708": {"vr": "OB", "BinaryLength": 201600},
        "1709": {"vr": "OB", "BinaryLength": 201600},
        "1710": {"vr": "OB", "BinaryLength": 201600},
        "1711": {"vr": "OB", "BinaryLength": 201600},
        "1712": {"vr": "OB", "BinaryLength": 201600},
        "1713": {"vr": "OB", "BinaryLength": 201600},
        "1714": {"vr": "OB", "BinaryLength": 201600},
        "1715": {"vr": "OB", "BinaryLength": 201600},
        "1716": {"vr": "OB", "BinaryLength": 201600},
        "1717": {"vr": "OB", "BinaryLength": 201600},
        "1718": {"vr": "OB", "BinaryLength": 201600},
        "1719": {"vr": "OB", "BinaryLength": 201600},
        "1720": {"vr": "OB", "BinaryLength": 201600},
        "1721": {"vr": "OB", "BinaryLength": 201600},
        "1722": {"vr": "OB", "BinaryLength": 201600},
        "1723": {"vr": "OB", "BinaryLength": 201600},
        "1724": {"vr": "OB", "BinaryLength": 201600},
        "1725": {"vr": "OB", "BinaryLength": 201600},
        "1726": {"vr": "OB", "BinaryLength": 201600},
        "1727": {"vr": "OB", "BinaryLength": 201600},
        "1728": {"vr": "OB", "BinaryLength": 201600},
        "1729": {"vr": "OB", "BinaryLength": 201600},
        "1730": {"vr": "OB", "BinaryLength": 201600},
        "1731": {"vr": "OB", "BinaryLength": 201600},
        "1732": {"vr": "OB", "BinaryLength": 201600},
        "1733": {"vr": "OB", "BinaryLength": 201600},
        "1734": {"vr": "OB", "BinaryLength": 201600},
        "1735": {"vr": "OB", "BinaryLength": 201600},
        "1736": {"vr": "OB", "BinaryLength": 201600},
        "1737": {"vr": "OB", "BinaryLength": 201600},
        "1738": {"vr": "OB", "BinaryLength": 201600},
        "1739": {"vr": "OB", "BinaryLength": 201600},
        "1740": {"vr": "OB", "BinaryLength": 201600},
        "1741": {"vr": "OB", "BinaryLength": 201600},
        "1742": {"vr": "OB", "BinaryLength": 201600},
        "1743": {"vr": "OB", "BinaryLength": 201600},
        "1744": {"vr": "OB", "BinaryLength": 201600},
        "1745": {"vr": "OB", "BinaryLength": 201600},
        "1746": {"vr": "OB", "BinaryLength": 201600},
        "1747": {"vr": "OB", "BinaryLength": 201600},
        "1748": {"vr": "OB", "BinaryLength": 201600},
        "1749": {"vr": "OB", "BinaryLength": 201600},
        "1750": {"vr": "OB", "BinaryLength": 201600},
        "1751": {"vr": "OB", "BinaryLength": 201600},
        "1752": {"vr": "OB", "BinaryLength": 201600},
        "1753": {"vr": "OB", "BinaryLength": 201600},
        "1754": {"vr": "OB", "BinaryLength": 201600},
        "1755": {"vr": "OB", "BinaryLength": 201600},
        "1756": {"vr": "OB", "BinaryLength": 201600},
        "1757": {"vr": "OB", "BinaryLength": 201600},
        "1758": {"vr": "OB", "BinaryLength": 201600},
        "1759": {"vr": "OB", "BinaryLength": 201600},
        "1760": {"vr": "OB", "BinaryLength": 201600},
        "1761": {"vr": "OB", "BinaryLength": 201600},
        "1762": {"vr": "OB", "BinaryLength": 201600},
        "1763": {"vr": "OB", "BinaryLength": 201600},
        "1764": {"vr": "OB", "BinaryLength": 201600},
        "1765": {"vr": "OB", "BinaryLength": 201600},
        "1766": {"vr": "OB", "BinaryLength": 201600},
        "1767": {"vr": "OB", "BinaryLength": 201600},
        "1768": {"vr": "OB", "BinaryLength": 201600},
        "1769": {"vr": "OB", "BinaryLength": 201600},
        "1770": {"vr": "OB", "BinaryLength": 201600},
        "1771": {"vr": "OB", "BinaryLength": 201600},
        "1772": {"vr": "OB", "BinaryLength": 201600},
        "1773": {"vr": "OB", "BinaryLength": 201600},
        "1774": {"vr": "OB", "BinaryLength": 201600},
        "1775": {"vr": "OB", "BinaryLength": 201600},
        "1776": {"vr": "OB", "BinaryLength": 201600},
        "1777": {"vr": "OB", "BinaryLength": 201600},
        "1778": {"vr": "OB", "BinaryLength": 201600},
        "1779": {"vr": "OB", "BinaryLength": 201600},
        "1780": {"vr": "OB", "BinaryLength": 201600},
        "1781": {"vr": "OB", "BinaryLength": 201600},
        "1782": {"vr": "OB", "BinaryLength": 201600},
        "1783": {"vr": "OB", "BinaryLength": 201600},
        "1784": {"vr": "OB", "BinaryLength": 201600},
        "1785": {"vr": "OB", "BinaryLength": 201600},
        "1786": {"vr": "OB", "BinaryLength": 201600},
        "1787": {"vr": "OB", "BinaryLength": 201600},
        "1788": {"vr": "OB", "BinaryLength": 201600},
        "1789": {"vr": "OB", "BinaryLength": 201600},
        "1790": {"vr": "OB", "BinaryLength": 201600},
        "1791": {"vr": "OB", "BinaryLength": 201600},
        "1792": {"vr": "OB", "BinaryLength": 201600},
        "1793": {"vr": "OB", "BinaryLength": 201600},
        "1794": {"vr": "OB", "BinaryLength": 201600},
        "1795": {"vr": "OB", "BinaryLength": 201600},
        "1796": {"vr": "OB", "BinaryLength": 201600},
        "1797": {"vr": "OB", "BinaryLength": 201600},
        "1798": {"vr": "OB", "BinaryLength": 201600},
        "1799": {"vr": "OB", "BinaryLength": 201600},
        "1800": {"vr": "OB", "BinaryLength": 201600},
        "1801": {"vr": "OB", "BinaryLength": 201600},
        "1802": {"vr": "OB", "BinaryLength": 201600},
        "1803": {"vr": "OB", "BinaryLength": 201600},
        "1804": {"vr": "OB", "BinaryLength": 201600},
        "1805": {"vr": "OB", "BinaryLength": 201600},
        "1806": {"vr": "OB", "BinaryLength": 201600},
        "1807": {"vr": "OB", "BinaryLength": 201600},
        "1808": {"vr": "OB", "BinaryLength": 201600},
        "1809": {"vr": "OB", "BinaryLength": 201600},
        "1810": {"vr": "OB", "BinaryLength": 201600},
        "1811": {"vr": "OB", "BinaryLength": 201600},
        "1812": {"vr": "OB", "BinaryLength": 201600},
        "1813": {"vr": "OB", "BinaryLength": 201600},
        "1814": {"vr": "OB", "BinaryLength": 201600},
        "1815": {"vr": "OB", "BinaryLength": 201600},
        "1816": {"vr": "OB", "BinaryLength": 201600},
        "1817": {"vr": "OB", "BinaryLength": 201600},
        "1818": {"vr": "OB", "BinaryLength": 201600},
        "1819": {"vr": "OB", "BinaryLength": 201600},
        "1820": {"vr": "OB", "BinaryLength": 201600},
        "1821": {"vr": "OB", "BinaryLength": 201600},
        "1822": {"vr": "OB", "BinaryLength": 201600},
        "1823": {"vr": "OB", "BinaryLength": 201600},
        "1824": {"vr": "OB", "BinaryLength": 201600},
        "1825": {"vr": "OB", "BinaryLength": 201600},
        "1826": {"vr": "OB", "BinaryLength": 201600},
        "1827": {"vr": "OB", "BinaryLength": 201600},
        "1828": {"vr": "OB", "BinaryLength": 201600},
        "1829": {"vr": "OB", "BinaryLength": 201600},
        "1830": {"vr": "OB", "BinaryLength": 201600},
        "1831": {"vr": "OB", "BinaryLength": 201600},
        "1832": {"vr": "OB", "BinaryLength": 201600},
        "1833": {"vr": "OB", "BinaryLength": 201600},
        "1834": {"vr": "OB", "BinaryLength": 201600},
        "1835": {"vr": "OB", "BinaryLength": 201600},
        "1836": {"vr": "OB", "BinaryLength": 201600},
        "1837": {"vr": "OB", "BinaryLength": 201600},
        "1838": {"vr": "OB", "BinaryLength": 201600},
        "1839": {"vr": "OB", "BinaryLength": 201600},
        "1840": {"vr": "OB", "BinaryLength": 201600},
        "1841": {"vr": "OB", "BinaryLength": 201600},
        "1842": {"vr": "OB", "BinaryLength": 201600},
        "1843": {"vr": "OB", "BinaryLength": 201600},
        "1844": {"vr": "OB", "BinaryLength": 201600},
        "1845": {"vr": "OB", "BinaryLength": 201600},
        "1846": {"vr": "OB", "BinaryLength": 201600},
        "1847": {"vr": "OB", "BinaryLength": 201600},
        "1848": {"vr": "OB", "BinaryLength": 201600},
        "1849": {"vr": "OB", "BinaryLength": 201600},
        "1850": {"vr": "OB", "BinaryLength": 201600},
        "1851": {"vr": "OB", "BinaryLength": 201600},
        "1852": {"vr": "OB", "BinaryLength": 201600},
        "1853": {"vr": "OB", "BinaryLength": 201600},
        "1854": {"vr": "OB", "BinaryLength": 201600},
        "1855": {"vr": "OB", "BinaryLength": 201600},
        "1856": {"vr": "OB", "BinaryLength": 201600},
        "1857": {"vr": "OB", "BinaryLength": 201600},
        "1858": {"vr": "OB", "BinaryLength": 201600},
        "1859": {"vr": "OB", "BinaryLength": 201600},
        "1860": {"vr": "OB", "BinaryLength": 201600},
        "1861": {"vr": "OB", "BinaryLength": 201600},
        "1862": {"vr": "OB", "BinaryLength": 201600},
        "1863": {"vr": "OB", "BinaryLength": 201600},
        "1864": {"vr": "OB", "BinaryLength": 201600},
        "1865": {"vr": "OB", "BinaryLength": 201600},
        "1866": {"vr": "OB", "BinaryLength": 201600},
        "1867": {"vr": "OB", "BinaryLength": 201600},
        "1868": {"vr": "OB", "BinaryLength": 201600},
        "1869": {"vr": "OB", "BinaryLength": 201600},
        "1870": {"vr": "OB", "BinaryLength": 201600},
        "1871": {"vr": "OB", "BinaryLength": 201600},
        "1872": {"vr": "OB", "BinaryLength": 201600},
        "1873": {"vr": "OB", "BinaryLength": 201600},
        "1874": {"vr": "OB", "BinaryLength": 201600},
        "1875": {"vr": "OB", "BinaryLength": 201600},
        "1876": {"vr": "OB", "BinaryLength": 201600},
        "1877": {"vr": "OB", "BinaryLength": 201600},
        "1878": {"vr": "OB", "BinaryLength": 201600},
        "1879": {"vr": "OB", "BinaryLength": 201600},
        "1880": {"vr": "OB", "BinaryLength": 201600},
        "1881": {"vr": "OB", "BinaryLength": 201600},
        "1882": {"vr": "OB", "BinaryLength": 201600},
        "1883": {"vr": "OB", "BinaryLength": 201600},
        "1884": {"vr": "OB", "BinaryLength": 201600},
        "1885": {"vr": "OB", "BinaryLength": 201600},
        "1886": {"vr": "OB", "BinaryLength": 201600},
        "1887": {"vr": "OB", "BinaryLength": 201600},
        "1888": {"vr": "OB", "BinaryLength": 201600},
        "1889": {"vr": "OB", "BinaryLength": 201600},
        "1890": {"vr": "OB", "BinaryLength": 201600},
        "1891": {"vr": "OB", "BinaryLength": 201600},
        "1892": {"vr": "OB", "BinaryLength": 201600},
        "1893": {"vr": "OB", "BinaryLength": 201600},
        "1894": {"vr": "OB", "BinaryLength": 201600},
        "1895": {"vr": "OB", "BinaryLength": 201600},
        "1896": {"vr": "OB", "BinaryLength": 201600},
        "1897": {"vr": "OB", "BinaryLength": 201600},
        "1898": {"vr": "OB", "BinaryLength": 201600},
        "1899": {"vr": "OB", "BinaryLength": 201600},
        "1900": {"vr": "OB", "BinaryLength": 201600},
        "1901": {"vr": "OB", "BinaryLength": 201600},
        "1902": {"vr": "OB", "BinaryLength": 201600},
        "1903": {"vr": "OB", "BinaryLength": 201600},
        "1904": {"vr": "OB", "BinaryLength": 201600},
        "1905": {"vr": "OB", "BinaryLength": 201600},
        "1906": {"vr": "OB", "BinaryLength": 201600},
        "1907": {"vr": "OB", "BinaryLength": 201600},
        "1908": {"vr": "OB", "BinaryLength": 201600},
        "1909": {"vr": "OB", "BinaryLength": 201600},
        "1910": {"vr": "OB", "BinaryLength": 201600},
        "1911": {"vr": "OB", "BinaryLength": 201600},
        "1912": {"vr": "OB", "BinaryLength": 201600},
        "1913": {"vr": "OB", "BinaryLength": 201600},
        "1914": {"vr": "OB", "BinaryLength": 201600},
        "1915": {"vr": "OB", "BinaryLength": 201600},
        "1916": {"vr": "OB", "BinaryLength": 201600},
        "1917": {"vr": "OB", "BinaryLength": 201600},
        "1918": {"vr": "OB", "BinaryLength": 201600},
        "1919": {"vr": "OB", "BinaryLength": 201600},
        "1920": {"vr": "OB", "BinaryLength": 201600},
        "1921": {"vr": "OB", "BinaryLength": 201600},
        "1922": {"vr": "OB", "BinaryLength": 201600},
        "1923": {"vr": "OB", "BinaryLength": 201600},
        "1924": {"vr": "OB", "BinaryLength": 201600},
        "1925": {"vr": "OB", "BinaryLength": 201600},
        "1926": {"vr": "OB", "BinaryLength": 201600},
        "1927": {"vr": "OB", "BinaryLength": 201600},
        "1928": {"vr": "OB", "BinaryLength": 201600},
        "1929": {"vr": "OB", "BinaryLength": 201600},
        "1930": {"vr": "OB", "BinaryLength": 201600},
        "1931": {"vr": "OB", "BinaryLength": 201600},
        "1932": {"vr": "OB", "BinaryLength": 201600},
        "1933": {"vr": "OB", "BinaryLength": 201600},
        "1934": {"vr": "OB", "BinaryLength": 201600},
        "1935": {"vr": "OB", "BinaryLength": 201600},
        "1936": {"vr": "OB", "BinaryLength": 201600},
        "1937": {"vr": "OB", "BinaryLength": 201600},
        "1938": {"vr": "OB", "BinaryLength": 201600},
        "1939": {"vr": "OB", "BinaryLength": 201600},
        "1940": {"vr": "OB", "BinaryLength": 201600},
        "1941": {"vr": "OB", "BinaryLength": 201600},
        "1942": {"vr": "OB", "BinaryLength": 201600},
        "1943": {"vr": "OB", "BinaryLength": 201600},
        "1944": {"vr": "OB", "BinaryLength": 201600},
        "1945": {"vr": "OB", "BinaryLength": 201600},
        "1946": {"vr": "OB", "BinaryLength": 201600},
        "1947": {"vr": "OB", "BinaryLength": 201600},
        "1948": {"vr": "OB", "BinaryLength": 201600},
        "1949": {"vr": "OB", "BinaryLength": 201600},
        "1950": {"vr": "OB", "BinaryLength": 201600},
        "1951": {"vr": "OB", "BinaryLength": 201600},
        "1952": {"vr": "OB", "BinaryLength": 201600},
        "1953": {"vr": "OB", "BinaryLength": 201600},
        "1954": {"vr": "OB", "BinaryLength": 201600},
        "1955": {"vr": "OB", "BinaryLength": 201600},
        "1956": {"vr": "OB", "BinaryLength": 201600},
        "1957": {"vr": "OB", "BinaryLength": 201600},
        "1958": {"vr": "OB", "BinaryLength": 201600},
        "1959": {"vr": "OB", "BinaryLength": 201600},
        "1960": {"vr": "OB", "BinaryLength": 201600},
        "1961": {"vr": "OB", "BinaryLength": 201600},
        "1962": {"vr": "OB", "BinaryLength": 201600},
        "1963": {"vr": "OB", "BinaryLength": 201600},
        "1964": {"vr": "OB", "BinaryLength": 201600},
        "1965": {"vr": "OB", "BinaryLength": 201600},
        "1966": {"vr": "OB", "BinaryLength": 201600},
        "1967": {"vr": "OB", "BinaryLength": 201600},
        "1968": {"vr": "OB", "BinaryLength": 201600},
        "1969": {"vr": "OB", "BinaryLength": 201600},
        "1970": {"vr": "OB", "BinaryLength": 201600},
        "1971": {"vr": "OB", "BinaryLength": 201600},
        "1972": {"vr": "OB", "BinaryLength": 201600},
        "1973": {"vr": "OB", "BinaryLength": 201600},
        "1974": {"vr": "OB", "BinaryLength": 201600},
        "1975": {"vr": "OB", "BinaryLength": 201600},
        "1976": {"vr": "OB", "BinaryLength": 201600},
        "1977": {"vr": "OB", "BinaryLength": 201600},
        "1978": {"vr": "OB", "BinaryLength": 201600},
        "1979": {"vr": "OB", "BinaryLength": 201600},
        "1980": {"vr": "OB", "BinaryLength": 201600},
        "1981": {"vr": "OB", "BinaryLength": 201600},
        "1982": {"vr": "OB", "BinaryLength": 201600},
        "1983": {"vr": "OB", "BinaryLength": 201600},
        "1984": {"vr": "OB", "BinaryLength": 201600},
        "1985": {"vr": "OB", "BinaryLength": 201600},
        "1986": {"vr": "OB", "BinaryLength": 201600},
        "1987": {"vr": "OB", "BinaryLength": 201600},
        "1988": {"vr": "OB", "BinaryLength": 201600},
        "1989": {"vr": "OB", "BinaryLength": 201600},
        "1990": {"vr": "OB", "BinaryLength": 201600},
        "1991": {"vr": "OB", "BinaryLength": 201600},
        "1992": {"vr": "OB", "BinaryLength": 201600},
        "1993": {"vr": "OB", "BinaryLength": 201600},
        "1994": {"vr": "OB", "BinaryLength": 201600},
        "1995": {"vr": "OB", "BinaryLength": 201600},
        "1996": {"vr": "OB", "BinaryLength": 201600},
        "1997": {"vr": "OB", "BinaryLength": 201600},
        "1998": {"vr": "OB", "BinaryLength": 201600},
        "1999": {"vr": "OB", "BinaryLength": 201600},
        "2000": {"vr": "OB", "BinaryLength": 201600},
        "2001": {"vr": "OB", "BinaryLength": 201600},
        "2002": {"vr": "OB", "BinaryLength": 201600},
        "2003": {"vr": "OB", "BinaryLength": 201600},
        "2004": {"vr": "OB", "BinaryLength": 201600},
        "2005": {"vr": "OB", "BinaryLength": 201600},
        "2006": {"vr": "OB", "BinaryLength": 201600},
        "2007": {"vr": "OB", "BinaryLength": 201600},
        "2008": {"vr": "OB", "BinaryLength": 201600},
        "2009": {"vr": "OB", "BinaryLength": 201600},
        "2010": {"vr": "OB", "BinaryLength": 201600},
        "2011": {"vr": "OB", "BinaryLength": 201600},
        "2012": {"vr": "OB", "BinaryLength": 201600},
        "2013": {"vr": "OB", "BinaryLength": 201600},
        "2014": {"vr": "OB", "BinaryLength": 201600},
        "2015": {"vr": "OB", "BinaryLength": 201600},
        "2016": {"vr": "OB", "BinaryLength": 201600},
        "2017": {"vr": "OB", "BinaryLength": 201600},
        "2018": {"vr": "OB", "BinaryLength": 201600},
        "2019": {"vr": "OB", "BinaryLength": 201600},
        "2020": {"vr": "OB", "BinaryLength": 201600},
        "2021": {"vr": "OB", "BinaryLength": 201600},
        "2022": {"vr": "OB", "BinaryLength": 201600},
        "2023": {"vr": "OB", "BinaryLength": 201600},
        "2024": {"vr": "OB", "BinaryLength": 201600},
        "2025": {"vr": "OB", "BinaryLength": 201600},
        "2026": {"vr": "OB", "BinaryLength": 201600},
        "2027": {"vr": "OB", "BinaryLength": 201600},
        "2028": {"vr": "OB", "BinaryLength": 201600},
        "2029": {"vr": "OB", "BinaryLength": 201600},
        "2030": {"vr": "OB", "BinaryLength": 201600},
        "2031": {"vr": "OB", "BinaryLength": 201600},
        "2032": {"vr": "OB", "BinaryLength": 201600},
        "2033": {"vr": "OB", "BinaryLength": 201600},
        "2034": {"vr": "OB", "BinaryLength": 201600},
        "2035": {"vr": "OB", "BinaryLength": 201600},
        "2036": {"vr": "OB", "BinaryLength": 201600},
        "2037": {"vr": "OB", "BinaryLength": 201600},
        "2038": {"vr": "OB", "BinaryLength": 201600},
        "2039": {"vr": "OB", "BinaryLength": 201600},
        "2040": {"vr": "OB", "BinaryLength": 201600},
        "2041": {"vr": "OB", "BinaryLength": 201600},
        "2042": {"vr": "OB", "BinaryLength": 201600},
        "2043": {"vr": "OB", "BinaryLength": 201600},
        "2044": {"vr": "OB", "BinaryLength": 201600},
        "2045": {"vr": "OB", "BinaryLength": 201600},
        "2046": {"vr": "OB", "BinaryLength": 201600},
        "2047": {"vr": "OB", "BinaryLength": 201600},
        "2048": {"vr": "OB", "BinaryLength": 201600},
        "2049": {"vr": "OB", "BinaryLength": 201600},
        "2050": {"vr": "OB", "BinaryLength": 201600},
        "2051": {"vr": "OB", "BinaryLength": 201600},
        "2052": {"vr": "OB", "BinaryLength": 201600},
        "2053": {"vr": "OB", "BinaryLength": 201600},
        "2054": {"vr": "OB", "BinaryLength": 201600},
        "2055": {"vr": "OB", "BinaryLength": 201600},
        "2056": {"vr": "OB", "BinaryLength": 201600},
        "2057": {"vr": "OB", "BinaryLength": 201600},
        "2058": {"vr": "OB", "BinaryLength": 201600},
        "2059": {"vr": "OB", "BinaryLength": 201600},
        "2060": {"vr": "OB", "BinaryLength": 201600},
        "2061": {"vr": "OB", "BinaryLength": 201600},
        "2062": {"vr": "OB", "BinaryLength": 201600},
        "2063": {"vr": "OB", "BinaryLength": 201600},
        "2064": {"vr": "OB", "BinaryLength": 201600},
        "2065": {"vr": "OB", "BinaryLength": 201600},
        "2066": {"vr": "OB", "BinaryLength": 201600},
        "2067": {"vr": "OB", "BinaryLength": 201600},
        "2068": {"vr": "OB", "BinaryLength": 201600},
        "2069": {"vr": "OB", "BinaryLength": 201600},
        "2070": {"vr": "OB", "BinaryLength": 201600},
        "2071": {"vr": "OB", "BinaryLength": 201600},
        "2072": {"vr": "OB", "BinaryLength": 201600},
        "2073": {"vr": "OB", "BinaryLength": 201600},
        "2074": {"vr": "OB", "BinaryLength": 201600},
        "2075": {"vr": "OB", "BinaryLength": 201600},
        "2076": {"vr": "OB", "BinaryLength": 201600},
        "2077": {"vr": "OB", "BinaryLength": 201600},
        "2078": {"vr": "OB", "BinaryLength": 201600},
        "2079": {"vr": "OB", "BinaryLength": 201600},
        "2080": {"vr": "OB", "BinaryLength": 201600},
        "2081": {"vr": "OB", "BinaryLength": 201600},
        "2082": {"vr": "OB", "BinaryLength": 201600},
        "2083": {"vr": "OB", "BinaryLength": 201600},
        "2084": {"vr": "OB", "BinaryLength": 201600},
        "2085": {"vr": "OB", "BinaryLength": 201600},
        "2086": {"vr": "OB", "BinaryLength": 201600},
        "2087": {"vr": "OB", "BinaryLength": 201600},
        "2088": {"vr": "OB", "BinaryLength": 201600},
        "2089": {"vr": "OB", "BinaryLength": 201600},
        "2090": {"vr": "OB", "BinaryLength": 201600},
        "2091": {"vr": "OB", "BinaryLength": 201600},
        "2092": {"vr": "OB", "BinaryLength": 201600},
        "2093": {"vr": "OB", "BinaryLength": 201600},
        "2094": {"vr": "OB", "BinaryLength": 201600},
        "2095": {"vr": "OB", "BinaryLength": 201600},
        "2096": {"vr": "OB", "BinaryLength": 201600},
        "2097": {"vr": "OB", "BinaryLength": 201600},
        "2098": {"vr": "OB", "BinaryLength": 201600},
        "2099": {"vr": "OB", "BinaryLength": 201600},
        "2100": {"vr": "OB", "BinaryLength": 201600},
        "2101": {"vr": "OB", "BinaryLength": 201600},
        "2102": {"vr": "OB", "BinaryLength": 201600},
        "2103": {"vr": "OB", "BinaryLength": 201600},
        "2104": {"vr": "OB", "BinaryLength": 201600},
        "2105": {"vr": "OB", "BinaryLength": 201600},
        "2106": {"vr": "OB", "BinaryLength": 201600},
        "2107": {"vr": "OB", "BinaryLength": 201600},
        "2108": {"vr": "OB", "BinaryLength": 201600},
        "2109": {"vr": "OB", "BinaryLength": 201600},
        "2110": {"vr": "OB", "BinaryLength": 201600},
        "2111": {"vr": "OB", "BinaryLength": 201600},
        "2112": {"vr": "OB", "BinaryLength": 201600},
        "2113": {"vr": "OB", "BinaryLength": 201600},
        "2114": {"vr": "OB", "BinaryLength": 201600},
        "2115": {"vr": "OB", "BinaryLength": 201600},
        "2116": {"vr": "OB", "BinaryLength": 201600},
        "2117": {"vr": "OB", "BinaryLength": 201600},
        "2118": {"vr": "OB", "BinaryLength": 201600},
        "2119": {"vr": "OB", "BinaryLength": 201600},
        "2120": {"vr": "OB", "BinaryLength": 201600},
        "2121": {"vr": "OB", "BinaryLength": 201600},
        "2122": {"vr": "OB", "BinaryLength": 201600},
        "2123": {"vr": "OB", "BinaryLength": 201600},
        "2124": {"vr": "OB", "BinaryLength": 201600},
        "2125": {"vr": "OB", "BinaryLength": 201600},
        "2126": {"vr": "OB", "BinaryLength": 201600},
        "2127": {"vr": "OB", "BinaryLength": 201600},
        "2128": {"vr": "OB", "BinaryLength": 201600},
        "2129": {"vr": "OB", "BinaryLength": 201600},
        "2130": {"vr": "OB", "BinaryLength": 201600},
        "2131": {"vr": "OB", "BinaryLength": 201600},
        "2132": {"vr": "OB", "BinaryLength": 201600},
        "2133": {"vr": "OB", "BinaryLength": 201600},
        "2134": {"vr": "OB", "BinaryLength": 201600},
        "2135": {"vr": "OB", "BinaryLength": 201600},
        "2136": {"vr": "OB", "BinaryLength": 201600},
        "2137": {"vr": "OB", "BinaryLength": 201600},
        "2138": {"vr": "OB", "BinaryLength": 201600},
        "2139": {"vr": "OB", "BinaryLength": 201600},
        "2140": {"vr": "OB", "BinaryLength": 201600},
        "2141": {"vr": "OB", "BinaryLength": 201600},
        "2142": {"vr": "OB", "BinaryLength": 201600},
        "2143": {"vr": "OB", "BinaryLength": 201600},
        "2144": {"vr": "OB", "BinaryLength": 201600},
        "2145": {"vr": "OB", "BinaryLength": 201600},
        "2146": {"vr": "OB", "BinaryLength": 201600},
        "2147": {"vr": "OB", "BinaryLength": 201600},
        "2148": {"vr": "OB", "BinaryLength": 201600},
        "2149": {"vr": "OB", "BinaryLength": 201600},
        "2150": {"vr": "OB", "BinaryLength": 201600},
        "2151": {"vr": "OB", "BinaryLength": 201600},
        "2152": {"vr": "OB", "BinaryLength": 201600},
        "2153": {"vr": "OB", "BinaryLength": 201600},
        "2154": {"vr": "OB", "BinaryLength": 201600},
        "2155": {"vr": "OB", "BinaryLength": 201600},
        "2156": {"vr": "OB", "BinaryLength": 201600},
        "2157": {"vr": "OB", "BinaryLength": 201600},
        "2158": {"vr": "OB", "BinaryLength": 201600},
        "2159": {"vr": "OB", "BinaryLength": 201600},
        "2160": {"vr": "OB", "BinaryLength": 201600},
        "2161": {"vr": "OB", "BinaryLength": 201600},
        "2162": {"vr": "OB", "BinaryLength": 201600},
        "2163": {"vr": "OB", "BinaryLength": 201600},
        "2164": {"vr": "OB", "BinaryLength": 201600},
        "2165": {"vr": "OB", "BinaryLength": 201600},
        "2166": {"vr": "OB", "BinaryLength": 201600},
        "2167": {"vr": "OB", "BinaryLength": 201600},
        "2168": {"vr": "OB", "BinaryLength": 201600},
        "2169": {"vr": "OB", "BinaryLength": 201600},
        "2170": {"vr": "OB", "BinaryLength": 201600},
        "2171": {"vr": "OB", "BinaryLength": 201600},
        "2172": {"vr": "OB", "BinaryLength": 201600},
        "2173": {"vr": "OB", "BinaryLength": 201600},
        "2174": {"vr": "OB", "BinaryLength": 201600},
        "2175": {"vr": "OB", "BinaryLength": 201600},
        "2176": {"vr": "OB", "BinaryLength": 201600},
        "2177": {"vr": "OB", "BinaryLength": 201600},
        "2178": {"vr": "OB", "BinaryLength": 201600},
        "2179": {"vr": "OB", "BinaryLength": 201600},
        "2180": {"vr": "OB", "BinaryLength": 201600},
        "2181": {"vr": "OB", "BinaryLength": 201600},
        "2182": {"vr": "OB", "BinaryLength": 201600},
        "2183": {"vr": "OB", "BinaryLength": 201600},
        "2184": {"vr": "OB", "BinaryLength": 201600},
        "2185": {"vr": "OB", "BinaryLength": 201600},
        "2186": {"vr": "OB", "BinaryLength": 201600},
        "2187": {"vr": "OB", "BinaryLength": 201600},
        "2188": {"vr": "OB", "BinaryLength": 201600},
        "2189": {"vr": "OB", "BinaryLength": 201600},
        "2190": {"vr": "OB", "BinaryLength": 201600},
        "2191": {"vr": "OB", "BinaryLength": 201600},
        "2192": {"vr": "OB", "BinaryLength": 201600},
        "2193": {"vr": "OB", "BinaryLength": 201600},
        "2194": {"vr": "OB", "BinaryLength": 201600},
        "2195": {"vr": "OB", "BinaryLength": 201600},
        "2196": {"vr": "OB", "BinaryLength": 201600},
        "2197": {"vr": "OB", "BinaryLength": 201600},
        "2198": {"vr": "OB", "BinaryLength": 201600},
        "2199": {"vr": "OB", "BinaryLength": 201600},
        "2200": {"vr": "OB", "BinaryLength": 201600},
        "2201": {"vr": "OB", "BinaryLength": 201600},
        "2202": {"vr": "OB", "BinaryLength": 201600},
        "2203": {"vr": "OB", "BinaryLength": 201600},
        "2204": {"vr": "OB", "BinaryLength": 201600},
        "2205": {"vr": "OB", "BinaryLength": 201600},
        "2206": {"vr": "OB", "BinaryLength": 201600},
        "2207": {"vr": "OB", "BinaryLength": 201600},
        "2208": {"vr": "OB", "BinaryLength": 201600},
        "2209": {"vr": "OB", "BinaryLength": 201600},
        "2210": {"vr": "OB", "BinaryLength": 201600},
        "2211": {"vr": "OB", "BinaryLength": 201600},
        "2212": {"vr": "OB", "BinaryLength": 201600},
        "2213": {"vr": "OB", "BinaryLength": 201600},
        "2214": {"vr": "OB", "BinaryLength": 201600},
        "2215": {"vr": "OB", "BinaryLength": 201600},
        "2216": {"vr": "OB", "BinaryLength": 201600},
        "2217": {"vr": "OB", "BinaryLength": 201600},
        "2218": {"vr": "OB", "BinaryLength": 201600},
        "2219": {"vr": "OB", "BinaryLength": 201600},
        "2220": {"vr": "OB", "BinaryLength": 201600},
        "2221": {"vr": "OB", "BinaryLength": 201600},
        "2222": {"vr": "OB", "BinaryLength": 201600},
        "2223": {"vr": "OB", "BinaryLength": 201600},
        "2224": {"vr": "OB", "BinaryLength": 201600},
        "2225": {"vr": "OB", "BinaryLength": 201600},
        "2226": {"vr": "OB", "BinaryLength": 201600},
        "2227": {"vr": "OB", "BinaryLength": 201600},
        "2228": {"vr": "OB", "BinaryLength": 201600},
        "2229": {"vr": "OB", "BinaryLength": 201600},
        "2230": {"vr": "OB", "BinaryLength": 201600},
        "2231": {"vr": "OB", "BinaryLength": 201600},
        "2232": {"vr": "OB", "BinaryLength": 201600},
        "2233": {"vr": "OB", "BinaryLength": 201600},
        "2234": {"vr": "OB", "BinaryLength": 201600},
        "2235": {"vr": "OB", "BinaryLength": 201600},
        "2236": {"vr": "OB", "BinaryLength": 201600},
        "2237": {"vr": "OB", "BinaryLength": 201600},
        "2238": {"vr": "OB", "BinaryLength": 201600},
        "2239": {"vr": "OB", "BinaryLength": 201600},
        "2240": {"vr": "OB", "BinaryLength": 201600},
        "2241": {"vr": "OB", "BinaryLength": 201600},
        "2242": {"vr": "OB", "BinaryLength": 201600},
        "2243": {"vr": "OB", "BinaryLength": 201600},
        "2244": {"vr": "OB", "BinaryLength": 201600},
        "2245": {"vr": "OB", "BinaryLength": 201600},
        "2246": {"vr": "OB", "BinaryLength": 201600},
        "2247": {"vr": "OB", "BinaryLength": 201600},
        "2248": {"vr": "OB", "BinaryLength": 201600},
        "2249": {"vr": "OB", "BinaryLength": 201600},
        "2250": {"vr": "OB", "BinaryLength": 201600},
        "2251": {"vr": "OB", "BinaryLength": 201600},
        "2252": {"vr": "OB", "BinaryLength": 201600},
        "2253": {"vr": "OB", "BinaryLength": 201600},
        "2254": {"vr": "OB", "BinaryLength": 201600},
        "2255": {"vr": "OB", "BinaryLength": 201600},
        "2256": {"vr": "OB", "BinaryLength": 201600},
        "2257": {"vr": "OB", "BinaryLength": 201600},
        "2258": {"vr": "OB", "BinaryLength": 201600},
        "2259": {"vr": "OB", "BinaryLength": 201600},
        "2260": {"vr": "OB", "BinaryLength": 201600},
        "2261": {"vr": "OB", "BinaryLength": 201600},
        "2262": {"vr": "OB", "BinaryLength": 201600},
        "2263": {"vr": "OB", "BinaryLength": 201600},
        "2264": {"vr": "OB", "BinaryLength": 201600},
        "2265": {"vr": "OB", "BinaryLength": 201600},
        "2266": {"vr": "OB", "BinaryLength": 201600},
        "2267": {"vr": "OB", "BinaryLength": 201600},
        "2268": {"vr": "OB", "BinaryLength": 201600},
        "2269": {"vr": "OB", "BinaryLength": 201600},
        "2270": {"vr": "OB", "BinaryLength": 201600},
        "2271": {"vr": "OB", "BinaryLength": 201600},
        "2272": {"vr": "OB", "BinaryLength": 201600},
        "2273": {"vr": "OB", "BinaryLength": 201600},
        "2274": {"vr": "OB", "BinaryLength": 201600},
        "2275": {"vr": "OB", "BinaryLength": 201600},
        "2276": {"vr": "OB", "BinaryLength": 201600},
        "2277": {"vr": "OB", "BinaryLength": 201600},
        "2278": {"vr": "OB", "BinaryLength": 201600},
        "2279": {"vr": "OB", "BinaryLength": 201600},
        "2280": {"vr": "OB", "BinaryLength": 201600},
        "2281": {"vr": "OB", "BinaryLength": 201600},
        "2282": {"vr": "OB", "BinaryLength": 201600},
        "2283": {"vr": "OB", "BinaryLength": 201600},
        "2284": {"vr": "OB", "BinaryLength": 201600},
        "2285": {"vr": "OB", "BinaryLength": 201600},
        "2286": {"vr": "OB", "BinaryLength": 201600},
        "2287": {"vr": "OB", "BinaryLength": 201600},
        "2288": {"vr": "OB", "BinaryLength": 201600},
        "2289": {"vr": "OB", "BinaryLength": 201600},
        "2290": {"vr": "OB", "BinaryLength": 201600},
        "2291": {"vr": "OB", "BinaryLength": 201600},
        "2292": {"vr": "OB", "BinaryLength": 201600},
        "2293": {"vr": "OB", "BinaryLength": 201600},
        "2294": {"vr": "OB", "BinaryLength": 201600},
        "2295": {"vr": "OB", "BinaryLength": 201600},
        "2296": {"vr": "OB", "BinaryLength": 201600},
        "2297": {"vr": "OB", "BinaryLength": 201600},
        "2298": {"vr": "OB", "BinaryLength": 201600},
        "2299": {"vr": "OB", "BinaryLength": 201600},
        "2300": {"vr": "OB", "BinaryLength": 201600},
        "2301": {"vr": "OB", "BinaryLength": 201600},
        "2302": {"vr": "OB", "BinaryLength": 201600},
        "2303": {"vr": "OB", "BinaryLength": 201600},
        "2304": {"vr": "OB", "BinaryLength": 201600},
        "2305": {"vr": "OB", "BinaryLength": 201600},
        "2306": {"vr": "OB", "BinaryLength": 201600},
        "2307": {"vr": "OB", "BinaryLength": 201600},
        "2308": {"vr": "OB", "BinaryLength": 201600},
        "2309": {"vr": "OB", "BinaryLength": 201600},
        "2310": {"vr": "OB", "BinaryLength": 201600},
        "2311": {"vr": "OB", "BinaryLength": 201600},
        "2312": {"vr": "OB", "BinaryLength": 201600},
        "2313": {"vr": "OB", "BinaryLength": 201600},
        "2314": {"vr": "OB", "BinaryLength": 201600},
        "2315": {"vr": "OB", "BinaryLength": 201600},
        "2316": {"vr": "OB", "BinaryLength": 201600},
        "2317": {"vr": "OB", "BinaryLength": 201600},
        "2318": {"vr": "OB", "BinaryLength": 201600},
        "2319": {"vr": "OB", "BinaryLength": 201600},
        "2320": {"vr": "OB", "BinaryLength": 201600},
        "2321": {"vr": "OB", "BinaryLength": 201600},
        "2322": {"vr": "OB", "BinaryLength": 201600},
        "2323": {"vr": "OB", "BinaryLength": 201600},
        "2324": {"vr": "OB", "BinaryLength": 201600},
        "2325": {"vr": "OB", "BinaryLength": 201600},
        "2326": {"vr": "OB", "BinaryLength": 201600},
        "2327": {"vr": "OB", "BinaryLength": 201600},
        "2328": {"vr": "OB", "BinaryLength": 201600},
        "2329": {"vr": "OB", "BinaryLength": 201600},
        "2330": {"vr": "OB", "BinaryLength": 201600},
        "2331": {"vr": "OB", "BinaryLength": 201600},
        "2332": {"vr": "OB", "BinaryLength": 201600},
        "2333": {"vr": "OB", "BinaryLength": 201600},
        "2334": {"vr": "OB", "BinaryLength": 201600},
        "2335": {"vr": "OB", "BinaryLength": 201600},
        "2336": {"vr": "OB", "BinaryLength": 201600},
        "2337": {"vr": "OB", "BinaryLength": 201600},
        "2338": {"vr": "OB", "BinaryLength": 201600},
        "2339": {"vr": "OB", "BinaryLength": 201600},
        "2340": {"vr": "OB", "BinaryLength": 201600},
        "2341": {"vr": "OB", "BinaryLength": 201600},
        "2342": {"vr": "OB", "BinaryLength": 201600},
        "2343": {"vr": "OB", "BinaryLength": 201600},
        "2344": {"vr": "OB", "BinaryLength": 201600},
        "2345": {"vr": "OB", "BinaryLength": 201600},
        "2346": {"vr": "OB", "BinaryLength": 201600},
        "2347": {"vr": "OB", "BinaryLength": 201600},
        "2348": {"vr": "OB", "BinaryLength": 201600},
        "2349": {"vr": "OB", "BinaryLength": 201600},
        "2350": {"vr": "OB", "BinaryLength": 201600},
        "2351": {"vr": "OB", "BinaryLength": 201600},
        "2352": {"vr": "OB", "BinaryLength": 201600},
        "2353": {"vr": "OB", "BinaryLength": 201600},
        "2354": {"vr": "OB", "BinaryLength": 201600},
        "2355": {"vr": "OB", "BinaryLength": 201600},
        "2356": {"vr": "OB", "BinaryLength": 201600},
        "2357": {"vr": "OB", "BinaryLength": 201600},
        "2358": {"vr": "OB", "BinaryLength": 201600},
        "2359": {"vr": "OB", "BinaryLength": 201600},
        "2360": {"vr": "OB", "BinaryLength": 201600},
        "2361": {"vr": "OB", "BinaryLength": 201600},
        "2362": {"vr": "OB", "BinaryLength": 201600},
        "2363": {"vr": "OB", "BinaryLength": 201600},
        "2364": {"vr": "OB", "BinaryLength": 201600},
        "2365": {"vr": "OB", "BinaryLength": 201600},
        "2366": {"vr": "OB", "BinaryLength": 201600},
        "2367": {"vr": "OB", "BinaryLength": 201600},
        "2368": {"vr": "OB", "BinaryLength": 201600},
        "2369": {"vr": "OB", "BinaryLength": 201600},
        "2370": {"vr": "OB", "BinaryLength": 201600},
        "2371": {"vr": "OB", "BinaryLength": 201600},
        "2372": {"vr": "OB", "BinaryLength": 201600},
        "2373": {"vr": "OB", "BinaryLength": 201600},
        "2374": {"vr": "OB", "BinaryLength": 201600},
        "2375": {"vr": "OB", "BinaryLength": 201600},
        "2376": {"vr": "OB", "BinaryLength": 201600},
        "2377": {"vr": "OB", "BinaryLength": 201600},
        "2378": {"vr": "OB", "BinaryLength": 201600},
        "2379": {"vr": "OB", "BinaryLength": 201600},
        "2380": {"vr": "OB", "BinaryLength": 201600},
        "2381": {"vr": "OB", "BinaryLength": 201600},
        "2382": {"vr": "OB", "BinaryLength": 201600},
        "2383": {"vr": "OB", "BinaryLength": 201600},
        "2384": {"vr": "OB", "BinaryLength": 201600},
        "2385": {"vr": "OB", "BinaryLength": 201600},
        "2386": {"vr": "OB", "BinaryLength": 201600},
        "2387": {"vr": "OB", "BinaryLength": 201600},
        "2388": {"vr": "OB", "BinaryLength": 201600},
        "2389": {"vr": "OB", "BinaryLength": 201600},
        "2390": {"vr": "OB", "BinaryLength": 201600},
        "2391": {"vr": "OB", "BinaryLength": 201600},
        "2392": {"vr": "OB", "BinaryLength": 201600},
        "2393": {"vr": "OB", "BinaryLength": 201600},
        "2394": {"vr": "OB", "BinaryLength": 201600},
        "2395": {"vr": "OB", "BinaryLength": 201600},
        "2396": {"vr": "OB", "BinaryLength": 201600},
        "2397": {"vr": "OB", "BinaryLength": 201600},
        "2398": {"vr": "OB", "BinaryLength": 201600},
        "2399": {"vr": "OB", "BinaryLength": 201600},
        "2400": {"vr": "OB", "BinaryLength": 201600},
        "2401": {"vr": "OB", "BinaryLength": 201600},
        "2402": {"vr": "OB", "BinaryLength": 201600},
        "2403": {"vr": "OB", "BinaryLength": 201600},
        "2404": {"vr": "OB", "BinaryLength": 201600},
        "2405": {"vr": "OB", "BinaryLength": 201600},
        "2406": {"vr": "OB", "BinaryLength": 201600},
        "2407": {"vr": "OB", "BinaryLength": 201600},
        "2408": {"vr": "OB", "BinaryLength": 201600},
        "2409": {"vr": "OB", "BinaryLength": 201600},
        "2410": {"vr": "OB", "BinaryLength": 201600},
        "2411": {"vr": "OB", "BinaryLength": 201600},
        "2412": {"vr": "OB", "BinaryLength": 201600},
        "2413": {"vr": "OB", "BinaryLength": 201600},
        "2414": {"vr": "OB", "BinaryLength": 201600},
        "2415": {"vr": "OB", "BinaryLength": 201600},
        "2416": {"vr": "OB", "BinaryLength": 201600},
        "2417": {"vr": "OB", "BinaryLength": 201600},
        "2418": {"vr": "OB", "BinaryLength": 201600},
        "2419": {"vr": "OB", "BinaryLength": 201600},
        "2420": {"vr": "OB", "BinaryLength": 201600},
        "2421": {"vr": "OB", "BinaryLength": 201600},
        "2422": {"vr": "OB", "BinaryLength": 201600},
        "2423": {"vr": "OB", "BinaryLength": 201600},
        "2424": {"vr": "OB", "BinaryLength": 201600},
        "2425": {"vr": "OB", "BinaryLength": 201600},
        "2426": {"vr": "OB", "BinaryLength": 201600},
        "2427": {"vr": "OB", "BinaryLength": 201600},
        "2428": {"vr": "OB", "BinaryLength": 201600},
        "2429": {"vr": "OB", "BinaryLength": 201600},
        "2430": {"vr": "OB", "BinaryLength": 201600},
        "2431": {"vr": "OB", "BinaryLength": 201600},
        "2432": {"vr": "OB", "BinaryLength": 201600},
        "2433": {"vr": "OB", "BinaryLength": 201600},
        "2434": {"vr": "OB", "BinaryLength": 201600},
        "2435": {"vr": "OB", "BinaryLength": 201600},
        "2436": {"vr": "OB", "BinaryLength": 201600},
        "2437": {"vr": "OB", "BinaryLength": 201600},
        "2438": {"vr": "OB", "BinaryLength": 201600},
        "2439": {"vr": "OB", "BinaryLength": 201600},
        "2440": {"vr": "OB", "BinaryLength": 201600},
        "2441": {"vr": "OB", "BinaryLength": 201600},
        "2442": {"vr": "OB", "BinaryLength": 201600},
        "2443": {"vr": "OB", "BinaryLength": 201600},
        "2444": {"vr": "OB", "BinaryLength": 201600},
        "2445": {"vr": "OB", "BinaryLength": 201600},
        "2446": {"vr": "OB", "BinaryLength": 201600},
        "2447": {"vr": "OB", "BinaryLength": 201600},
        "2448": {"vr": "OB", "BinaryLength": 201600},
        "2449": {"vr": "OB", "BinaryLength": 201600},
        "2450": {"vr": "OB", "BinaryLength": 201600},
        "2451": {"vr": "OB", "BinaryLength": 201600},
        "2452": {"vr": "OB", "BinaryLength": 201600},
        "2453": {"vr": "OB", "BinaryLength": 201600},
        "2454": {"vr": "OB", "BinaryLength": 201600},
        "2455": {"vr": "OB", "BinaryLength": 201600},
        "2456": {"vr": "OB", "BinaryLength": 201600},
        "2457": {"vr": "OB", "BinaryLength": 201600},
        "2458": {"vr": "OB", "BinaryLength": 201600},
        "2459": {"vr": "OB", "BinaryLength": 201600},
        "2460": {"vr": "OB", "BinaryLength": 201600},
        "2461": {"vr": "OB", "BinaryLength": 201600},
        "2462": {"vr": "OB", "BinaryLength": 201600},
        "2463": {"vr": "OB", "BinaryLength": 201600},
        "2464": {"vr": "OB", "BinaryLength": 201600},
        "2465": {"vr": "OB", "BinaryLength": 201600},
        "2466": {"vr": "OB", "BinaryLength": 201600},
        "2467": {"vr": "OB", "BinaryLength": 201600},
        "2468": {"vr": "OB", "BinaryLength": 201600},
        "2469": {"vr": "OB", "BinaryLength": 201600},
        "2470": {"vr": "OB", "BinaryLength": 201600},
        "2471": {"vr": "OB", "BinaryLength": 201600},
        "2472": {"vr": "OB", "BinaryLength": 201600},
        "2473": {"vr": "OB", "BinaryLength": 201600},
        "2474": {"vr": "OB", "BinaryLength": 201600},
        "2475": {"vr": "OB", "BinaryLength": 201600},
        "2476": {"vr": "OB", "BinaryLength": 201600},
        "2477": {"vr": "OB", "BinaryLength": 201600},
        "2478": {"vr": "OB", "BinaryLength": 201600},
        "2479": {"vr": "OB", "BinaryLength": 201600},
        "2480": {"vr": "OB", "BinaryLength": 201600},
        "2481": {"vr": "OB", "BinaryLength": 201600},
        "2482": {"vr": "OB", "BinaryLength": 201600},
        "2483": {"vr": "OB", "BinaryLength": 201600},
        "2484": {"vr": "OB", "BinaryLength": 201600},
        "2485": {"vr": "OB", "BinaryLength": 201600},
        "2486": {"vr": "OB", "BinaryLength": 201600},
        "2487": {"vr": "OB", "BinaryLength": 201600},
        "2488": {"vr": "OB", "BinaryLength": 201600},
        "2489": {"vr": "OB", "BinaryLength": 201600},
        "2490": {"vr": "OB", "BinaryLength": 201600},
        "2491": {"vr": "OB", "BinaryLength": 201600},
        "2492": {"vr": "OB", "BinaryLength": 201600},
        "2493": {"vr": "OB", "BinaryLength": 201600},
        "2494": {"vr": "OB", "BinaryLength": 201600},
        "2495": {"vr": "OB", "BinaryLength": 201600},
        "2496": {"vr": "OB", "BinaryLength": 201600},
        "2497": {"vr": "OB", "BinaryLength": 201600},
        "2498": {"vr": "OB", "BinaryLength": 201600},
        "2499": {"vr": "OB", "BinaryLength": 201600},
        "2500": {"vr": "OB", "BinaryLength": 201600},
        "2501": {"vr": "OB", "BinaryLength": 201600},
        "2502": {"vr": "OB", "BinaryLength": 201600},
        "2503": {"vr": "OB", "BinaryLength": 201600},
        "2504": {"vr": "OB", "BinaryLength": 201600},
        "2505": {"vr": "OB", "BinaryLength": 201600},
        "2506": {"vr": "OB", "BinaryLength": 201600},
        "2507": {"vr": "OB", "BinaryLength": 201600},
        "2508": {"vr": "OB", "BinaryLength": 201600},
        "2509": {"vr": "OB", "BinaryLength": 201600},
        "2510": {"vr": "OB", "BinaryLength": 201600},
        "2511": {"vr": "OB", "BinaryLength": 201600},
        "2512": {"vr": "OB", "BinaryLength": 201600},
        "2513": {"vr": "OB", "BinaryLength": 201600},
        "2514": {"vr": "OB", "BinaryLength": 201600},
        "2515": {"vr": "OB", "BinaryLength": 201600},
        "2516": {"vr": "OB", "BinaryLength": 201600},
        "2517": {"vr": "OB", "BinaryLength": 201600},
        "2518": {"vr": "OB", "BinaryLength": 201600},
        "2519": {"vr": "OB", "BinaryLength": 201600},
        "2520": {"vr": "OB", "BinaryLength": 201600},
        "2521": {"vr": "OB", "BinaryLength": 201600},
        "2522": {"vr": "OB", "BinaryLength": 201600},
        "2523": {"vr": "OB", "BinaryLength": 201600},
        "2524": {"vr": "OB", "BinaryLength": 201600},
        "2525": {"vr": "OB", "BinaryLength": 201600},
        "2526": {"vr": "OB", "BinaryLength": 201600},
        "2527": {"vr": "OB", "BinaryLength": 201600},
        "2528": {"vr": "OB", "BinaryLength": 201600},
        "2529": {"vr": "OB", "BinaryLength": 201600},
        "2530": {"vr": "OB", "BinaryLength": 201600},
        "2531": {"vr": "OB", "BinaryLength": 201600},
        "2532": {"vr": "OB", "BinaryLength": 201600},
        "2533": {"vr": "OB", "BinaryLength": 201600},
        "2534": {"vr": "OB", "BinaryLength": 201600},
        "2535": {"vr": "OB", "BinaryLength": 201600},
        "2536": {"vr": "OB", "BinaryLength": 201600},
        "2537": {"vr": "OB", "BinaryLength": 201600},
        "2538": {"vr": "OB", "BinaryLength": 201600},
        "2539": {"vr": "OB", "BinaryLength": 201600},
        "2540": {"vr": "OB", "BinaryLength": 201600},
        "2541": {"vr": "OB", "BinaryLength": 201600},
        "2542": {"vr": "OB", "BinaryLength": 201600},
        "2543": {"vr": "OB", "BinaryLength": 201600},
        "2544": {"vr": "OB", "BinaryLength": 201600},
        "2545": {"vr": "OB", "BinaryLength": 201600},
        "2546": {"vr": "OB", "BinaryLength": 201600},
        "2547": {"vr": "OB", "BinaryLength": 201600},
        "2548": {"vr": "OB", "BinaryLength": 201600},
        "2549": {"vr": "OB", "BinaryLength": 201600},
        "2550": {"vr": "OB", "BinaryLength": 201600},
        "2551": {"vr": "OB", "BinaryLength": 201600},
        "2552": {"vr": "OB", "BinaryLength": 201600},
        "2553": {"vr": "OB", "BinaryLength": 201600},
        "2554": {"vr": "OB", "BinaryLength": 201600},
        "2555": {"vr": "OB", "BinaryLength": 201600},
        "2556": {"vr": "OB", "BinaryLength": 201600},
        "2557": {"vr": "OB", "BinaryLength": 201600},
        "2558": {"vr": "OB", "BinaryLength": 201600},
        "2559": {"vr": "OB", "BinaryLength": 201600},
        "2560": {"vr": "OB", "BinaryLength": 201600},
        "2561": {"vr": "OB", "BinaryLength": 201600},
        "2562": {"vr": "OB", "BinaryLength": 201600},
        "2563": {"vr": "OB", "BinaryLength": 201600},
        "2564": {"vr": "OB", "BinaryLength": 201600},
        "2565": {"vr": "OB", "BinaryLength": 201600},
        "2566": {"vr": "OB", "BinaryLength": 201600},
        "2567": {"vr": "OB", "BinaryLength": 201600},
        "2568": {"vr": "OB", "BinaryLength": 201600},
        "2569": {"vr": "OB", "BinaryLength": 201600},
        "2570": {"vr": "OB", "BinaryLength": 201600},
        "2571": {"vr": "OB", "BinaryLength": 201600},
        "2572": {"vr": "OB", "BinaryLength": 201600},
        "2573": {"vr": "OB", "BinaryLength": 201600},
        "2574": {"vr": "OB", "BinaryLength": 201600},
        "2575": {"vr": "OB", "BinaryLength": 201600},
        "2576": {"vr": "OB", "BinaryLength": 201600},
        "2577": {"vr": "OB", "BinaryLength": 201600},
        "2578": {"vr": "OB", "BinaryLength": 201600},
        "2579": {"vr": "OB", "BinaryLength": 201600},
        "2580": {"vr": "OB", "BinaryLength": 201600},
        "2581": {"vr": "OB", "BinaryLength": 201600},
        "2582": {"vr": "OB", "BinaryLength": 201600},
        "2583": {"vr": "OB", "BinaryLength": 201600},
        "2584": {"vr": "OB", "BinaryLength": 201600},
        "2585": {"vr": "OB", "BinaryLength": 201600},
        "2586": {"vr": "OB", "BinaryLength": 201600},
        "2587": {"vr": "OB", "BinaryLength": 201600},
        "2588": {"vr": "OB", "BinaryLength": 201600},
        "2589": {"vr": "OB", "BinaryLength": 201600},
        "2590": {"vr": "OB", "BinaryLength": 201600},
        "2591": {"vr": "OB", "BinaryLength": 201600},
        "2592": {"vr": "OB", "BinaryLength": 201600},
        "2593": {"vr": "OB", "BinaryLength": 201600},
        "2594": {"vr": "OB", "BinaryLength": 201600},
        "2595": {"vr": "OB", "BinaryLength": 201600},
        "2596": {"vr": "OB", "BinaryLength": 201600},
        "2597": {"vr": "OB", "BinaryLength": 201600},
        "2598": {"vr": "OB", "BinaryLength": 201600},
        "2599": {"vr": "OB", "BinaryLength": 201600},
        "2600": {"vr": "OB", "BinaryLength": 201600},
        "2601": {"vr": "OB", "BinaryLength": 201600},
        "2602": {"vr": "OB", "BinaryLength": 201600},
        "2603": {"vr": "OB", "BinaryLength": 201600},
        "2604": {"vr": "OB", "BinaryLength": 201600},
        "2605": {"vr": "OB", "BinaryLength": 201600},
        "2606": {"vr": "OB", "BinaryLength": 201600},
        "2607": {"vr": "OB", "BinaryLength": 201600},
        "2608": {"vr": "OB", "BinaryLength": 201600},
        "2609": {"vr": "OB", "BinaryLength": 201600},
        "2610": {"vr": "OB", "BinaryLength": 201600},
        "2611": {"vr": "OB", "BinaryLength": 201600},
        "2612": {"vr": "OB", "BinaryLength": 201600},
        "2613": {"vr": "OB", "BinaryLength": 201600},
        "2614": {"vr": "OB", "BinaryLength": 201600},
        "2615": {"vr": "OB", "BinaryLength": 201600},
        "2616": {"vr": "OB", "BinaryLength": 201600},
        "2617": {"vr": "OB", "BinaryLength": 201600},
        "2618": {"vr": "OB", "BinaryLength": 201600},
        "2619": {"vr": "OB", "BinaryLength": 201600},
        "2620": {"vr": "OB", "BinaryLength": 201600},
        "2621": {"vr": "OB", "BinaryLength": 201600},
        "2622": {"vr": "OB", "BinaryLength": 201600},
        "2623": {"vr": "OB", "BinaryLength": 201600},
        "2624": {"vr": "OB", "BinaryLength": 201600},
        "2625": {"vr": "OB", "BinaryLength": 201600},
        "2626": {"vr": "OB", "BinaryLength": 201600},
        "2627": {"vr": "OB", "BinaryLength": 201600},
        "2628": {"vr": "OB", "BinaryLength": 201600},
        "2629": {"vr": "OB", "BinaryLength": 201600},
        "2630": {"vr": "OB", "BinaryLength": 201600},
        "2631": {"vr": "OB", "BinaryLength": 201600},
        "2632": {"vr": "OB", "BinaryLength": 201600},
        "2633": {"vr": "OB", "BinaryLength": 201600},
        "2634": {"vr": "OB", "BinaryLength": 201600},
        "2635": {"vr": "OB", "BinaryLength": 201600},
        "2636": {"vr": "OB", "BinaryLength": 201600},
        "2637": {"vr": "OB", "BinaryLength": 201600},
        "2638": {"vr": "OB", "BinaryLength": 201600},
        "2639": {"vr": "OB", "BinaryLength": 201600},
        "2640": {"vr": "OB", "BinaryLength": 201600},
        "2641": {"vr": "OB", "BinaryLength": 201600},
        "2642": {"vr": "OB", "BinaryLength": 201600},
        "2643": {"vr": "OB", "BinaryLength": 201600},
        "2644": {"vr": "OB", "BinaryLength": 201600},
        "2645": {"vr": "OB", "BinaryLength": 201600},
        "2646": {"vr": "OB", "BinaryLength": 201600},
        "2647": {"vr": "OB", "BinaryLength": 201600},
        "2648": {"vr": "OB", "BinaryLength": 201600},
        "2649": {"vr": "OB", "BinaryLength": 201600},
        "2650": {"vr": "OB", "BinaryLength": 201600},
        "2651": {"vr": "OB", "BinaryLength": 201600},
        "2652": {"vr": "OB", "BinaryLength": 201600},
        "2653": {"vr": "OB", "BinaryLength": 201600},
        "2654": {"vr": "OB", "BinaryLength": 201600},
        "2655": {"vr": "OB", "BinaryLength": 201600},
        "2656": {"vr": "OB", "BinaryLength": 201600},
        "2657": {"vr": "OB", "BinaryLength": 201600},
        "2658": {"vr": "OB", "BinaryLength": 201600},
        "2659": {"vr": "OB", "BinaryLength": 201600},
        "2660": {"vr": "OB", "BinaryLength": 201600},
        "2661": {"vr": "OB", "BinaryLength": 201600},
        "2662": {"vr": "OB", "BinaryLength": 201600},
        "2663": {"vr": "OB", "BinaryLength": 201600},
        "2664": {"vr": "OB", "BinaryLength": 201600},
        "2665": {"vr": "OB", "BinaryLength": 201600},
        "2666": {"vr": "OB", "BinaryLength": 201600},
        "2667": {"vr": "OB", "BinaryLength": 201600},
        "2668": {"vr": "OB", "BinaryLength": 201600},
        "2669": {"vr": "OB", "BinaryLength": 201600},
        "2670": {"vr": "OB", "BinaryLength": 201600},
        "2671": {"vr": "OB", "BinaryLength": 201600},
        "2672": {"vr": "OB", "BinaryLength": 201600},
        "2673": {"vr": "OB", "BinaryLength": 201600},
        "2674": {"vr": "OB", "BinaryLength": 201600},
        "2675": {"vr": "OB", "BinaryLength": 201600},
        "2676": {"vr": "OB", "BinaryLength": 201600},
        "2677": {"vr": "OB", "BinaryLength": 201600},
        "2678": {"vr": "OB", "BinaryLength": 201600},
        "2679": {"vr": "OB", "BinaryLength": 201600},
        "2680": {"vr": "OB", "BinaryLength": 201600},
        "2681": {"vr": "OB", "BinaryLength": 201600},
        "2682": {"vr": "OB", "BinaryLength": 201600},
        "2683": {"vr": "OB", "BinaryLength": 201600},
        "2684": {"vr": "OB", "BinaryLength": 201600},
        "2685": {"vr": "OB", "BinaryLength": 201600},
        "2686": {"vr": "OB", "BinaryLength": 201600},
        "2687": {"vr": "OB", "BinaryLength": 201600},
        "2688": {"vr": "OB", "BinaryLength": 201600},
        "2689": {"vr": "OB", "BinaryLength": 201600},
        "2690": {"vr": "OB", "BinaryLength": 201600},
        "2691": {"vr": "OB", "BinaryLength": 201600},
        "2692": {"vr": "OB", "BinaryLength": 201600},
        "2693": {"vr": "OB", "BinaryLength": 201600},
        "2694": {"vr": "OB", "BinaryLength": 201600},
        "2695": {"vr": "OB", "BinaryLength": 201600},
        "2696": {"vr": "OB", "BinaryLength": 201600},
        "2697": {"vr": "OB", "BinaryLength": 201600},
        "2698": {"vr": "OB", "BinaryLength": 201600},
        "2699": {"vr": "OB", "BinaryLength": 201600},
        "2700": {"vr": "OB", "BinaryLength": 201600},
        "2701": {"vr": "OB", "BinaryLength": 201600},
        "2702": {"vr": "OB", "BinaryLength": 201600},
        "2703": {"vr": "OB", "BinaryLength": 201600},
        "2704": {"vr": "OB", "BinaryLength": 201600},
        "2705": {"vr": "OB", "BinaryLength": 201600},
        "2706": {"vr": "OB", "BinaryLength": 201600},
        "2707": {"vr": "OB", "BinaryLength": 201600},
        "2708": {"vr": "OB", "BinaryLength": 201600},
        "2709": {"vr": "OB", "BinaryLength": 201600},
        "2710": {"vr": "OB", "BinaryLength": 201600},
        "2711": {"vr": "OB", "BinaryLength": 201600},
        "2712": {"vr": "OB", "BinaryLength": 201600},
        "2713": {"vr": "OB", "BinaryLength": 201600},
        "2714": {"vr": "OB", "BinaryLength": 201600},
        "2715": {"vr": "OB", "BinaryLength": 201600},
        "2716": {"vr": "OB", "BinaryLength": 201600},
        "2717": {"vr": "OB", "BinaryLength": 201600},
        "2718": {"vr": "OB", "BinaryLength": 201600},
        "2719": {"vr": "OB", "BinaryLength": 201600},
        "2720": {"vr": "OB", "BinaryLength": 201600},
        "2721": {"vr": "OB", "BinaryLength": 201600},
        "2722": {"vr": "OB", "BinaryLength": 201600},
        "2723": {"vr": "OB", "BinaryLength": 201600},
        "2724": {"vr": "OB", "BinaryLength": 201600},
        "2725": {"vr": "OB", "BinaryLength": 201600},
        "2726": {"vr": "OB", "BinaryLength": 201600},
        "2727": {"vr": "OB", "BinaryLength": 201600},
        "2728": {"vr": "OB", "BinaryLength": 201600},
        "2729": {"vr": "OB", "BinaryLength": 201600},
        "2730": {"vr": "OB", "BinaryLength": 201600},
        "2731": {"vr": "OB", "BinaryLength": 201600},
        "2732": {"vr": "OB", "BinaryLength": 201600},
        "2733": {"vr": "OB", "BinaryLength": 201600},
        "2734": {"vr": "OB", "BinaryLength": 201600},
        "2735": {"vr": "OB", "BinaryLength": 201600},
        "2736": {"vr": "OB", "BinaryLength": 201600},
        "2737": {"vr": "OB", "BinaryLength": 201600},
        "2738": {"vr": "OB", "BinaryLength": 201600},
        "2739": {"vr": "OB", "BinaryLength": 201600},
        "2740": {"vr": "OB", "BinaryLength": 201600},
        "2741": {"vr": "OB", "BinaryLength": 201600},
        "2742": {"vr": "OB", "BinaryLength": 201600},
        "2743": {"vr": "OB", "BinaryLength": 201600},
        "2744": {"vr": "OB", "BinaryLength": 201600},
        "2745": {"vr": "OB", "BinaryLength": 201600},
        "2746": {"vr": "OB", "BinaryLength": 201600},
        "2747": {"vr": "OB", "BinaryLength": 201600},
        "2748": {"vr": "OB", "BinaryLength": 201600},
        "2749": {"vr": "OB", "BinaryLength": 201600},
        "2750": {"vr": "OB", "BinaryLength": 201600},
        "2751": {"vr": "OB", "BinaryLength": 201600},
        "2752": {"vr": "OB", "BinaryLength": 201600},
        "2753": {"vr": "OB", "BinaryLength": 201600},
        "2754": {"vr": "OB", "BinaryLength": 201600},
        "2755": {"vr": "OB", "BinaryLength": 201600},
        "2756": {"vr": "OB", "BinaryLength": 201600},
        "2757": {"vr": "OB", "BinaryLength": 201600},
        "2758": {"vr": "OB", "BinaryLength": 201600},
        "2759": {"vr": "OB", "BinaryLength": 201600},
        "2760": {"vr": "OB", "BinaryLength": 201600},
        "2761": {"vr": "OB", "BinaryLength": 201600},
        "2762": {"vr": "OB", "BinaryLength": 201600},
        "2763": {"vr": "OB", "BinaryLength": 201600},
        "2764": {"vr": "OB", "BinaryLength": 201600},
        "2765": {"vr": "OB", "BinaryLength": 201600},
        "2766": {"vr": "OB", "BinaryLength": 201600},
        "2767": {"vr": "OB", "BinaryLength": 201600},
        "2768": {"vr": "OB", "BinaryLength": 201600},
        "2769": {"vr": "OB", "BinaryLength": 201600},
        "2770": {"vr": "OB", "BinaryLength": 201600},
        "2771": {"vr": "OB", "BinaryLength": 201600},
        "2772": {"vr": "OB", "BinaryLength": 201600},
        "2773": {"vr": "OB", "BinaryLength": 201600},
        "2774": {"vr": "OB", "BinaryLength": 201600},
        "2775": {"vr": "OB", "BinaryLength": 201600},
        "2776": {"vr": "OB", "BinaryLength": 201600},
        "2777": {"vr": "OB", "BinaryLength": 201600},
        "2778": {"vr": "OB", "BinaryLength": 201600},
        "2779": {"vr": "OB", "BinaryLength": 201600},
        "2780": {"vr": "OB", "BinaryLength": 201600},
        "2781": {"vr": "OB", "BinaryLength": 201600},
        "2782": {"vr": "OB", "BinaryLength": 201600},
        "2783": {"vr": "OB", "BinaryLength": 201600},
        "2784": {"vr": "OB", "BinaryLength": 201600},
        "2785": {"vr": "OB", "BinaryLength": 201600},
        "2786": {"vr": "OB", "BinaryLength": 201600},
        "2787": {"vr": "OB", "BinaryLength": 201600},
        "2788": {"vr": "OB", "BinaryLength": 201600},
        "2789": {"vr": "OB", "BinaryLength": 201600},
        "2790": {"vr": "OB", "BinaryLength": 201600},
        "2791": {"vr": "OB", "BinaryLength": 201600},
        "2792": {"vr": "OB", "BinaryLength": 201600},
        "2793": {"vr": "OB", "BinaryLength": 201600},
        "2794": {"vr": "OB", "BinaryLength": 201600},
        "2795": {"vr": "OB", "BinaryLength": 201600},
        "2796": {"vr": "OB", "BinaryLength": 201600},
        "2797": {"vr": "OB", "BinaryLength": 201600},
        "2798": {"vr": "OB", "BinaryLength": 201600},
        "2799": {"vr": "OB", "BinaryLength": 201600},
        "2800": {"vr": "OB", "BinaryLength": 201600},
        "2801": {"vr": "OB", "BinaryLength": 201600},
        "2802": {"vr": "OB", "BinaryLength": 201600},
        "2803": {"vr": "OB", "BinaryLength": 201600},
        "2804": {"vr": "OB", "BinaryLength": 201600},
        "2805": {"vr": "OB", "BinaryLength": 201600},
        "2806": {"vr": "OB", "BinaryLength": 201600},
        "2807": {"vr": "OB", "BinaryLength": 201600},
        "2808": {"vr": "OB", "BinaryLength": 201600},
        "2809": {"vr": "OB", "BinaryLength": 201600},
        "2810": {"vr": "OB", "BinaryLength": 201600},
        "2811": {"vr": "OB", "BinaryLength": 201600},
        "2812": {"vr": "OB", "BinaryLength": 201600},
        "2813": {"vr": "OB", "BinaryLength": 201600},
        "2814": {"vr": "OB", "BinaryLength": 201600},
        "2815": {"vr": "OB", "BinaryLength": 201600},
        "2816": {"vr": "OB", "BinaryLength": 201600},
        "2817": {"vr": "OB", "BinaryLength": 201600},
        "2818": {"vr": "OB", "BinaryLength": 201600},
        "2819": {"vr": "OB", "BinaryLength": 201600},
        "2820": {"vr": "OB", "BinaryLength": 201600},
        "2821": {"vr": "OB", "BinaryLength": 201600},
        "2822": {"vr": "OB", "BinaryLength": 201600},
        "2823": {"vr": "OB", "BinaryLength": 201600},
        "2824": {"vr": "OB", "BinaryLength": 201600},
        "2825": {"vr": "OB", "BinaryLength": 201600},
        "2826": {"vr": "OB", "BinaryLength": 201600},
        "2827": {"vr": "OB", "BinaryLength": 201600},
        "2828": {"vr": "OB", "BinaryLength": 201600},
        "2829": {"vr": "OB", "BinaryLength": 201600},
        "2830": {"vr": "OB", "BinaryLength": 201600},
        "2831": {"vr": "OB", "BinaryLength": 201600},
        "2832": {"vr": "OB", "BinaryLength": 201600},
        "2833": {"vr": "OB", "BinaryLength": 201600},
        "2834": {"vr": "OB", "BinaryLength": 201600},
        "2835": {"vr": "OB", "BinaryLength": 201600},
        "2836": {"vr": "OB", "BinaryLength": 201600},
        "2837": {"vr": "OB", "BinaryLength": 201600},
        "2838": {"vr": "OB", "BinaryLength": 201600},
        "2839": {"vr": "OB", "BinaryLength": 201600},
        "2840": {"vr": "OB", "BinaryLength": 201600},
        "2841": {"vr": "OB", "BinaryLength": 201600},
        "2842": {"vr": "OB", "BinaryLength": 201600},
        "2843": {"vr": "OB", "BinaryLength": 201600},
        "2844": {"vr": "OB", "BinaryLength": 201600},
        "2845": {"vr": "OB", "BinaryLength": 201600},
        "2846": {"vr": "OB", "BinaryLength": 201600},
        "2847": {"vr": "OB", "BinaryLength": 201600},
        "2848": {"vr": "OB", "BinaryLength": 201600},
        "2849": {"vr": "OB", "BinaryLength": 201600},
        "2850": {"vr": "OB", "BinaryLength": 201600},
        "2851": {"vr": "OB", "BinaryLength": 201600},
        "2852": {"vr": "OB", "BinaryLength": 201600},
        "2853": {"vr": "OB", "BinaryLength": 201600},
        "2854": {"vr": "OB", "BinaryLength": 201600},
        "2855": {"vr": "OB", "BinaryLength": 201600},
        "2856": {"vr": "OB", "BinaryLength": 201600},
        "2857": {"vr": "OB", "BinaryLength": 201600},
        "2858": {"vr": "OB", "BinaryLength": 201600},
        "2859": {"vr": "OB", "BinaryLength": 201600},
        "2860": {"vr": "OB", "BinaryLength": 201600},
        "2861": {"vr": "OB", "BinaryLength": 201600},
        "2862": {"vr": "OB", "BinaryLength": 201600},
        "2863": {"vr": "OB", "BinaryLength": 201600},
        "2864": {"vr": "OB", "BinaryLength": 201600},
        "2865": {"vr": "OB", "BinaryLength": 201600},
        "2866": {"vr": "OB", "BinaryLength": 201600},
        "2867": {"vr": "OB", "BinaryLength": 201600},
        "2868": {"vr": "OB", "BinaryLength": 201600},
        "2869": {"vr": "OB", "BinaryLength": 201600},
        "2870": {"vr": "OB", "BinaryLength": 201600},
        "2871": {"vr": "OB", "BinaryLength": 201600},
        "2872": {"vr": "OB", "BinaryLength": 201600},
        "2873": {"vr": "OB", "BinaryLength": 201600},
        "2874": {"vr": "OB", "BinaryLength": 201600},
        "2875": {"vr": "OB", "BinaryLength": 201600},
        "2876": {"vr": "OB", "BinaryLength": 201600},
        "2877": {"vr": "OB", "BinaryLength": 201600},
        "2878": {"vr": "OB", "BinaryLength": 201600},
        "2879": {"vr": "OB", "BinaryLength": 201600},
        "2880": {"vr": "OB", "BinaryLength": 201600},
        "2881": {"vr": "OB", "BinaryLength": 201600},
        "2882": {"vr": "OB", "BinaryLength": 201600},
        "2883": {"vr": "OB", "BinaryLength": 201600},
        "2884": {"vr": "OB", "BinaryLength": 201600},
        "2885": {"vr": "OB", "BinaryLength": 201600},
        "2886": {"vr": "OB", "BinaryLength": 201600},
        "2887": {"vr": "OB", "BinaryLength": 201600},
        "2888": {"vr": "OB", "BinaryLength": 201600},
        "2889": {"vr": "OB", "BinaryLength": 201600},
        "2890": {"vr": "OB", "BinaryLength": 201600},
        "2891": {"vr": "OB", "BinaryLength": 201600},
        "2892": {"vr": "OB", "BinaryLength": 201600},
        "2893": {"vr": "OB", "BinaryLength": 201600},
        "2894": {"vr": "OB", "BinaryLength": 201600},
        "2895": {"vr": "OB", "BinaryLength": 201600},
        "2896": {"vr": "OB", "BinaryLength": 201600},
        "2897": {"vr": "OB", "BinaryLength": 201600},
        "2898": {"vr": "OB", "BinaryLength": 201600},
        "2899": {"vr": "OB", "BinaryLength": 201600},
        "2900": {"vr": "OB", "BinaryLength": 201600},
        "2901": {"vr": "OB", "BinaryLength": 201600},
        "2902": {"vr": "OB", "BinaryLength": 201600},
        "2903": {"vr": "OB", "BinaryLength": 201600},
        "2904": {"vr": "OB", "BinaryLength": 201600},
        "2905": {"vr": "OB", "BinaryLength": 201600},
        "2906": {"vr": "OB", "BinaryLength": 201600},
        "2907": {"vr": "OB", "BinaryLength": 201600},
        "2908": {"vr": "OB", "BinaryLength": 201600},
        "2909": {"vr": "OB", "BinaryLength": 201600},
        "2910": {"vr": "OB", "BinaryLength": 201600},
        "2911": {"vr": "OB", "BinaryLength": 201600},
        "2912": {"vr": "OB", "BinaryLength": 201600},
        "2913": {"vr": "OB", "BinaryLength": 201600},
        "2914": {"vr": "OB", "BinaryLength": 201600},
        "2915": {"vr": "OB", "BinaryLength": 201600},
        "2916": {"vr": "OB", "BinaryLength": 201600},
        "2917": {"vr": "OB", "BinaryLength": 201600},
        "2918": {"vr": "OB", "BinaryLength": 201600},
        "2919": {"vr": "OB", "BinaryLength": 201600},
        "2920": {"vr": "OB", "BinaryLength": 201600},
        "2921": {"vr": "OB", "BinaryLength": 201600},
        "2922": {"vr": "OB", "BinaryLength": 201600},
        "2923": {"vr": "OB", "BinaryLength": 201600},
        "2924": {"vr": "OB", "BinaryLength": 201600},
        "2925": {"vr": "OB", "BinaryLength": 201600},
        "2926": {"vr": "OB", "BinaryLength": 201600},
        "2927": {"vr": "OB", "BinaryLength": 201600},
        "2928": {"vr": "OB", "BinaryLength": 201600},
        "2929": {"vr": "OB", "BinaryLength": 201600},
        "2930": {"vr": "OB", "BinaryLength": 201600},
        "2931": {"vr": "OB", "BinaryLength": 201600},
        "2932": {"vr": "OB", "BinaryLength": 201600},
        "2933": {"vr": "OB", "BinaryLength": 201600},
        "2934": {"vr": "OB", "BinaryLength": 201600},
        "2935": {"vr": "OB", "BinaryLength": 201600},
        "2936": {"vr": "OB", "BinaryLength": 201600},
        "2937": {"vr": "OB", "BinaryLength": 201600},
        "2938": {"vr": "OB", "BinaryLength": 201600},
        "2939": {"vr": "OB", "BinaryLength": 201600},
        "2940": {"vr": "OB", "BinaryLength": 201600},
        "2941": {"vr": "OB", "BinaryLength": 201600},
        "2942": {"vr": "OB", "BinaryLength": 201600},
        "2943": {"vr": "OB", "BinaryLength": 201600},
        "2944": {"vr": "OB", "BinaryLength": 201600},
        "2945": {"vr": "OB", "BinaryLength": 201600},
        "2946": {"vr": "OB", "BinaryLength": 201600},
        "2947": {"vr": "OB", "BinaryLength": 201600},
        "2948": {"vr": "OB", "BinaryLength": 201600},
        "2949": {"vr": "OB", "BinaryLength": 201600},
        "2950": {"vr": "OB", "BinaryLength": 201600},
        "2951": {"vr": "OB", "BinaryLength": 201600},
        "2952": {"vr": "OB", "BinaryLength": 201600},
        "2953": {"vr": "OB", "BinaryLength": 201600},
        "2954": {"vr": "OB", "BinaryLength": 201600},
        "2955": {"vr": "OB", "BinaryLength": 201600},
        "2956": {"vr": "OB", "BinaryLength": 201600},
        "2957": {"vr": "OB", "BinaryLength": 201600},
        "2958": {"vr": "OB", "BinaryLength": 201600},
        "2959": {"vr": "OB", "BinaryLength": 201600},
        "2960": {"vr": "OB", "BinaryLength": 201600},
        "2961": {"vr": "OB", "BinaryLength": 201600},
        "2962": {"vr": "OB", "BinaryLength": 201600},
        "2963": {"vr": "OB", "BinaryLength": 201600},
        "2964": {"vr": "OB", "BinaryLength": 201600},
        "2965": {"vr": "OB", "BinaryLength": 201600},
        "2966": {"vr": "OB", "BinaryLength": 201600},
        "2967": {"vr": "OB", "BinaryLength": 201600},
        "2968": {"vr": "OB", "BinaryLength": 201600},
        "2969": {"vr": "OB", "BinaryLength": 201600},
        "2970": {"vr": "OB", "BinaryLength": 201600},
        "2971": {"vr": "OB", "BinaryLength": 201600},
        "2972": {"vr": "OB", "BinaryLength": 201600},
        "2973": {"vr": "OB", "BinaryLength": 201600},
        "2974": {"vr": "OB", "BinaryLength": 201600},
        "2975": {"vr": "OB", "BinaryLength": 201600},
        "2976": {"vr": "OB", "BinaryLength": 201600},
        "2977": {"vr": "OB", "BinaryLength": 201600},
        "2978": {"vr": "OB", "BinaryLength": 201600},
        "2979": {"vr": "OB", "BinaryLength": 201600},
        "2980": {"vr": "OB", "BinaryLength": 201600},
        "2981": {"vr": "OB", "BinaryLength": 201600},
        "2982": {"vr": "OB", "BinaryLength": 201600},
        "2983": {"vr": "OB", "BinaryLength": 201600},
        "2984": {"vr": "OB", "BinaryLength": 201600},
        "2985": {"vr": "OB", "BinaryLength": 201600},
        "2986": {"vr": "OB", "BinaryLength": 201600},
        "2987": {"vr": "OB", "BinaryLength": 201600},
        "2988": {"vr": "OB", "BinaryLength": 201600},
        "2989": {"vr": "OB", "BinaryLength": 201600},
        "2990": {"vr": "OB", "BinaryLength": 201600},
        "2991": {"vr": "OB", "BinaryLength": 201600},
        "2992": {"vr": "OB", "BinaryLength": 201600},
        "2993": {"vr": "OB", "BinaryLength": 201600},
        "2994": {"vr": "OB", "BinaryLength": 201600},
        "2995": {"vr": "OB", "BinaryLength": 201600},
        "2996": {"vr": "OB", "BinaryLength": 201600},
        "2997": {"vr": "OB", "BinaryLength": 201600},
        "2998": {"vr": "OB", "BinaryLength": 201600},
        "2999": {"vr": "OB", "BinaryLength": 201600},
        "3000": {"vr": "OB", "BinaryLength": 201600},
        "3001": {"vr": "OB", "BinaryLength": 201600},
        "3002": {"vr": "OB", "BinaryLength": 201600},
        "3003": {"vr": "OB", "BinaryLength": 201600},
        "3004": {"vr": "OB", "BinaryLength": 201600},
        "3005": {"vr": "OB", "BinaryLength": 201600},
        "3006": {"vr": "OB", "BinaryLength": 201600},
        "3007": {"vr": "OB", "BinaryLength": 201600},
        "3008": {"vr": "OB", "BinaryLength": 201600},
        "3009": {"vr": "OB", "BinaryLength": 201600},
        "3010": {"vr": "OB", "BinaryLength": 201600},
        "3011": {"vr": "OB", "BinaryLength": 201600},
        "3012": {"vr": "OB", "BinaryLength": 201600},
        "3013": {"vr": "OB", "BinaryLength": 201600},
        "3014": {"vr": "OB", "BinaryLength": 201600},
        "3015": {"vr": "OB", "BinaryLength": 201600},
        "3016": {"vr": "OB", "BinaryLength": 201600},
        "3017": {"vr": "OB", "BinaryLength": 201600},
        "3018": {"vr": "OB", "BinaryLength": 201600},
        "3019": {"vr": "OB", "BinaryLength": 201600},
        "3020": {"vr": "OB", "BinaryLength": 201600},
        "3021": {"vr": "OB", "BinaryLength": 201600},
        "3022": {"vr": "OB", "BinaryLength": 201600},
        "3023": {"vr": "OB", "BinaryLength": 201600},
        "3024": {"vr": "OB", "BinaryLength": 201600},
        "3025": {"vr": "OB", "BinaryLength": 201600},
        "3026": {"vr": "OB", "BinaryLength": 201600},
        "3027": {"vr": "OB", "BinaryLength": 201600},
        "3028": {"vr": "OB", "BinaryLength": 201600},
        "3029": {"vr": "OB", "BinaryLength": 201600},
        "3030": {"vr": "OB", "BinaryLength": 201600},
        "3031": {"vr": "OB", "BinaryLength": 201600},
        "3032": {"vr": "OB", "BinaryLength": 201600},
        "3033": {"vr": "OB", "BinaryLength": 201600},
        "3034": {"vr": "OB", "BinaryLength": 201600},
        "3035": {"vr": "OB", "BinaryLength": 201600},
        "3036": {"vr": "OB", "BinaryLength": 201600},
        "3037": {"vr": "OB", "BinaryLength": 201600},
        "3038": {"vr": "OB", "BinaryLength": 201600},
        "3039": {"vr": "OB", "BinaryLength": 201600},
        "3040": {"vr": "OB", "BinaryLength": 201600},
        "3041": {"vr": "OB", "BinaryLength": 201600},
        "3042": {"vr": "OB", "BinaryLength": 201600},
        "3043": {"vr": "OB", "BinaryLength": 201600},
        "3044": {"vr": "OB", "BinaryLength": 201600},
        "3045": {"vr": "OB", "BinaryLength": 201600},
        "3046": {"vr": "OB", "BinaryLength": 201600},
        "3047": {"vr": "OB", "BinaryLength": 201600},
        "3048": {"vr": "OB", "BinaryLength": 201600},
        "3049": {"vr": "OB", "BinaryLength": 201600},
        "3050": {"vr": "OB", "BinaryLength": 201600},
        "3051": {"vr": "OB", "BinaryLength": 201600},
        "3052": {"vr": "OB", "BinaryLength": 201600},
        "3053": {"vr": "OB", "BinaryLength": 201600},
        "3054": {"vr": "OB", "BinaryLength": 201600},
        "3055": {"vr": "OB", "BinaryLength": 201600},
        "3056": {"vr": "OB", "BinaryLength": 201600},
        "3057": {"vr": "OB", "BinaryLength": 201600},
        "3058": {"vr": "OB", "BinaryLength": 201600},
        "3059": {"vr": "OB", "BinaryLength": 201600},
        "3060": {"vr": "OB", "BinaryLength": 201600},
        "3061": {"vr": "OB", "BinaryLength": 201600},
        "3062": {"vr": "OB", "BinaryLength": 201600},
        "3063": {"vr": "OB", "BinaryLength": 201600},
        "3064": {"vr": "OB", "BinaryLength": 201600},
        "3065": {"vr": "OB", "BinaryLength": 201600},
        "3066": {"vr": "OB", "BinaryLength": 201600},
        "3067": {"vr": "OB", "BinaryLength": 201600},
        "3068": {"vr": "OB", "BinaryLength": 201600},
        "3069": {"vr": "OB", "BinaryLength": 201600},
        "3070": {"vr": "OB", "BinaryLength": 201600},
        "3071": {"vr": "OB", "BinaryLength": 201600},
        "3072": {"vr": "OB", "BinaryLength": 201600},
        "3073": {"vr": "OB", "BinaryLength": 201600},
        "3074": {"vr": "OB", "BinaryLength": 201600},
        "3075": {"vr": "OB", "BinaryLength": 201600},
        "3076": {"vr": "OB", "BinaryLength": 201600},
        "3077": {"vr": "OB", "BinaryLength": 201600},
        "3078": {"vr": "OB", "BinaryLength": 201600},
        "3079": {"vr": "OB", "BinaryLength": 201600},
        "3080": {"vr": "OB", "BinaryLength": 201600},
        "3081": {"vr": "OB", "BinaryLength": 201600},
        "3082": {"vr": "OB", "BinaryLength": 201600},
        "3083": {"vr": "OB", "BinaryLength": 201600},
        "3084": {"vr": "OB", "BinaryLength": 201600},
        "3085": {"vr": "OB", "BinaryLength": 201600},
        "3086": {"vr": "OB", "BinaryLength": 201600},
        "3087": {"vr": "OB", "BinaryLength": 201600},
        "3088": {"vr": "OB", "BinaryLength": 201600},
        "3089": {"vr": "OB", "BinaryLength": 201600},
        "3090": {"vr": "OB", "BinaryLength": 201600},
        "3091": {"vr": "OB", "BinaryLength": 201600},
        "3092": {"vr": "OB", "BinaryLength": 201600},
        "3093": {"vr": "OB", "BinaryLength": 201600},
        "3094": {"vr": "OB", "BinaryLength": 201600},
        "3095": {"vr": "OB", "BinaryLength": 201600},
        "3096": {"vr": "OB", "BinaryLength": 201600},
        "3097": {"vr": "OB", "BinaryLength": 201600},
        "3098": {"vr": "OB", "BinaryLength": 201600},
        "3099": {"vr": "OB", "BinaryLength": 201600},
        "3100": {"vr": "OB", "BinaryLength": 201600},
        "3101": {"vr": "OB", "BinaryLength": 201600},
        "3102": {"vr": "OB", "BinaryLength": 201600},
        "3103": {"vr": "OB", "BinaryLength": 201600},
        "3104": {"vr": "OB", "BinaryLength": 201600},
        "3105": {"vr": "OB", "BinaryLength": 201600},
        "3106": {"vr": "OB", "BinaryLength": 201600},
        "3107": {"vr": "OB", "BinaryLength": 201600},
        "3108": {"vr": "OB", "BinaryLength": 201600},
        "3109": {"vr": "OB", "BinaryLength": 201600},
        "3110": {"vr": "OB", "BinaryLength": 201600},
        "3111": {"vr": "OB", "BinaryLength": 201600},
        "3112": {"vr": "OB", "BinaryLength": 201600},
        "3113": {"vr": "OB", "BinaryLength": 201600},
        "3114": {"vr": "OB", "BinaryLength": 201600},
        "3115": {"vr": "OB", "BinaryLength": 201600},
        "3116": {"vr": "OB", "BinaryLength": 201600},
        "3117": {"vr": "OB", "BinaryLength": 201600},
        "3118": {"vr": "OB", "BinaryLength": 201600},
        "3119": {"vr": "OB", "BinaryLength": 201600},
        "3120": {"vr": "OB", "BinaryLength": 201600},
        "3121": {"vr": "OB", "BinaryLength": 201600},
        "3122": {"vr": "OB", "BinaryLength": 201600},
        "3123": {"vr": "OB", "BinaryLength": 201600},
        "3124": {"vr": "OB", "BinaryLength": 201600},
        "3125": {"vr": "OB", "BinaryLength": 201600},
        "3126": {"vr": "OB", "BinaryLength": 201600},
        "3127": {"vr": "OB", "BinaryLength": 201600},
        "3128": {"vr": "OB", "BinaryLength": 201600},
        "3129": {"vr": "OB", "BinaryLength": 201600},
        "3130": {"vr": "OB", "BinaryLength": 201600},
        "3131": {"vr": "OB", "BinaryLength": 201600},
        "3132": {"vr": "OB", "BinaryLength": 201600},
        "3133": {"vr": "OB", "BinaryLength": 201600},
        "3134": {"vr": "OB", "BinaryLength": 201600},
        "3135": {"vr": "OB", "BinaryLength": 201600},
        "3136": {"vr": "OB", "BinaryLength": 201600},
        "3137": {"vr": "OB", "BinaryLength": 201600},
        "3138": {"vr": "OB", "BinaryLength": 201600},
        "3139": {"vr": "OB", "BinaryLength": 201600},
        "3140": {"vr": "OB", "BinaryLength": 201600},
        "3141": {"vr": "OB", "BinaryLength": 201600},
        "3142": {"vr": "OB", "BinaryLength": 201600},
        "3143": {"vr": "OB", "BinaryLength": 201600},
        "3144": {"vr": "OB", "BinaryLength": 201600},
        "3145": {"vr": "OB", "BinaryLength": 201600},
        "3146": {"vr": "OB", "BinaryLength": 201600},
        "3147": {"vr": "OB", "BinaryLength": 201600},
        "3148": {"vr": "OB", "BinaryLength": 201600},
        "3149": {"vr": "OB", "BinaryLength": 201600},
        "3150": {"vr": "OB", "BinaryLength": 201600},
        "3151": {"vr": "OB", "BinaryLength": 201600},
        "3152": {"vr": "OB", "BinaryLength": 201600},
        "3153": {"vr": "OB", "BinaryLength": 201600},
        "3154": {"vr": "OB", "BinaryLength": 201600},
        "3155": {"vr": "OB", "BinaryLength": 201600},
        "3156": {"vr": "OB", "BinaryLength": 201600},
        "3157": {"vr": "OB", "BinaryLength": 201600},
        "3158": {"vr": "OB", "BinaryLength": 201600},
        "3159": {"vr": "OB", "BinaryLength": 201600},
        "3160": {"vr": "OB", "BinaryLength": 201600},
        "3161": {"vr": "OB", "BinaryLength": 201600},
        "3162": {"vr": "OB", "BinaryLength": 201600},
        "3163": {"vr": "OB", "BinaryLength": 201600},
        "3164": {"vr": "OB", "BinaryLength": 201600},
        "3165": {"vr": "OB", "BinaryLength": 201600},
        "3166": {"vr": "OB", "BinaryLength": 201600},
        "3167": {"vr": "OB", "BinaryLength": 201600},
        "3168": {"vr": "OB", "BinaryLength": 201600},
        "3169": {"vr": "OB", "BinaryLength": 201600},
        "3170": {"vr": "OB", "BinaryLength": 201600},
        "3171": {"vr": "OB", "BinaryLength": 201600},
        "3172": {"vr": "OB", "BinaryLength": 201600},
        "3173": {"vr": "OB", "BinaryLength": 201600},
        "3174": {"vr": "OB", "BinaryLength": 201600},
        "3175": {"vr": "OB", "BinaryLength": 201600},
        "3176": {"vr": "OB", "BinaryLength": 201600},
        "3177": {"vr": "OB", "BinaryLength": 201600},
        "3178": {"vr": "OB", "BinaryLength": 201600},
        "3179": {"vr": "OB", "BinaryLength": 201600},
        "3180": {"vr": "OB", "BinaryLength": 201600},
        "3181": {"vr": "OB", "BinaryLength": 201600},
        "3182": {"vr": "OB", "BinaryLength": 201600},
        "3183": {"vr": "OB", "BinaryLength": 201600},
        "3184": {"vr": "OB", "BinaryLength": 201600},
        "3185": {"vr": "OB", "BinaryLength": 201600},
        "3186": {"vr": "OB", "BinaryLength": 201600},
        "3187": {"vr": "OB", "BinaryLength": 201600},
        "3188": {"vr": "OB", "BinaryLength": 201600},
        "3189": {"vr": "OB", "BinaryLength": 201600},
        "3190": {"vr": "OB", "BinaryLength": 201600},
        "3191": {"vr": "OB", "BinaryLength": 201600},
        "3192": {"vr": "OB", "BinaryLength": 201600},
        "3193": {"vr": "OB", "BinaryLength": 201600},
        "3194": {"vr": "OB", "BinaryLength": 201600},
        "3195": {"vr": "OB", "BinaryLength": 201600},
        "3196": {"vr": "OB", "BinaryLength": 201600},
        "3197": {"vr": "OB", "BinaryLength": 201600},
        "3198": {"vr": "OB", "BinaryLength": 201600},
        "3199": {"vr": "OB", "BinaryLength": 201600},
        "3200": {"vr": "OB", "BinaryLength": 201600},
        "3201": {"vr": "OB", "BinaryLength": 201600},
        "3202": {"vr": "OB", "BinaryLength": 201600},
        "3203": {"vr": "OB", "BinaryLength": 201600},
        "3204": {"vr": "OB", "BinaryLength": 201600},
        "3205": {"vr": "OB", "BinaryLength": 201600},
        "3206": {"vr": "OB", "BinaryLength": 201600},
        "3207": {"vr": "OB", "BinaryLength": 201600},
        "3208": {"vr": "OB", "BinaryLength": 201600},
        "3209": {"vr": "OB", "BinaryLength": 201600},
        "3210": {"vr": "OB", "BinaryLength": 201600},
        "3211": {"vr": "OB", "BinaryLength": 201600},
        "3212": {"vr": "OB", "BinaryLength": 201600},
        "3213": {"vr": "OB", "BinaryLength": 201600},
        "3214": {"vr": "OB", "BinaryLength": 201600},
        "3215": {"vr": "OB", "BinaryLength": 201600},
        "3216": {"vr": "OB", "BinaryLength": 201600},
        "3217": {"vr": "OB", "BinaryLength": 201600},
        "3218": {"vr": "OB", "BinaryLength": 201600},
        "3219": {"vr": "OB", "BinaryLength": 201600},
        "3220": {"vr": "OB", "BinaryLength": 201600},
        "3221": {"vr": "OB", "BinaryLength": 201600},
        "3222": {"vr": "OB", "BinaryLength": 201600},
        "3223": {"vr": "OB", "BinaryLength": 201600},
        "3224": {"vr": "OB", "BinaryLength": 201600},
        "3225": {"vr": "OB", "BinaryLength": 201600},
        "3226": {"vr": "OB", "BinaryLength": 201600},
        "3227": {"vr": "OB", "BinaryLength": 201600},
        "3228": {"vr": "OB", "BinaryLength": 201600},
        "3229": {"vr": "OB", "BinaryLength": 201600},
        "3230": {"vr": "OB", "BinaryLength": 201600},
        "3231": {"vr": "OB", "BinaryLength": 201600},
        "3232": {"vr": "OB", "BinaryLength": 201600},
        "3233": {"vr": "OB", "BinaryLength": 201600},
        "3234": {"vr": "OB", "BinaryLength": 201600},
        "3235": {"vr": "OB", "BinaryLength": 201600},
        "3236": {"vr": "OB", "BinaryLength": 201600},
        "3237": {"vr": "OB", "BinaryLength": 201600},
        "3238": {"vr": "OB", "BinaryLength": 201600},
        "3239": {"vr": "OB", "BinaryLength": 201600},
        "3240": {"vr": "OB", "BinaryLength": 201600},
        "3241": {"vr": "OB", "BinaryLength": 201600},
        "3242": {"vr": "OB", "BinaryLength": 201600},
        "3243": {"vr": "OB", "BinaryLength": 201600},
        "3244": {"vr": "OB", "BinaryLength": 201600},
        "3245": {"vr": "OB", "BinaryLength": 201600},
        "3246": {"vr": "OB", "BinaryLength": 201600},
        "3247": {"vr": "OB", "BinaryLength": 201600},
        "3248": {"vr": "OB", "BinaryLength": 201600},
        "3249": {"vr": "OB", "BinaryLength": 201600},
        "3250": {"vr": "OB", "BinaryLength": 201600},
        "3251": {"vr": "OB", "BinaryLength": 201600},
        "3252": {"vr": "OB", "BinaryLength": 201600},
        "3253": {"vr": "OB", "BinaryLength": 201600},
        "3254": {"vr": "OB", "BinaryLength": 201600},
        "3255": {"vr": "OB", "BinaryLength": 201600},
        "3256": {"vr": "OB", "BinaryLength": 201600},
        "3257": {"vr": "OB", "BinaryLength": 201600},
        "3258": {"vr": "OB", "BinaryLength": 201600},
        "3259": {"vr": "OB", "BinaryLength": 201600},
        "3260": {"vr": "OB", "BinaryLength": 201600},
        "3261": {"vr": "OB", "BinaryLength": 201600},
        "3262": {"vr": "OB", "BinaryLength": 201600},
        "3263": {"vr": "OB", "BinaryLength": 201600},
        "3264": {"vr": "OB", "BinaryLength": 201600},
        "3265": {"vr": "OB", "BinaryLength": 201600},
        "3266": {"vr": "OB", "BinaryLength": 201600},
        "3267": {"vr": "OB", "BinaryLength": 201600},
        "3268": {"vr": "OB", "BinaryLength": 201600},
        "3269": {"vr": "OB", "BinaryLength": 201600},
        "3270": {"vr": "OB", "BinaryLength": 201600},
        "3271": {"vr": "OB", "BinaryLength": 201600},
        "3272": {"vr": "OB", "BinaryLength": 201600},
        "3273": {"vr": "OB", "BinaryLength": 201600},
        "3274": {"vr": "OB", "BinaryLength": 201600},
        "3275": {"vr": "OB", "BinaryLength": 201600},
        "3276": {"vr": "OB", "BinaryLength": 201600},
        "3277": {"vr": "OB", "BinaryLength": 201600},
        "3278": {"vr": "OB", "BinaryLength": 201600},
        "3279": {"vr": "OB", "BinaryLength": 201600},
        "3280": {"vr": "OB", "BinaryLength": 201600},
        "3281": {"vr": "OB", "BinaryLength": 201600},
        "3282": {"vr": "OB", "BinaryLength": 201600},
        "3283": {"vr": "OB", "BinaryLength": 201600},
        "3284": {"vr": "OB", "BinaryLength": 201600},
        "3285": {"vr": "OB", "BinaryLength": 201600},
        "3286": {"vr": "OB", "BinaryLength": 201600},
        "3287": {"vr": "OB", "BinaryLength": 201600},
        "3288": {"vr": "OB", "BinaryLength": 201600},
        "3289": {"vr": "OB", "BinaryLength": 201600},
        "3290": {"vr": "OB", "BinaryLength": 201600},
        "3291": {"vr": "OB", "BinaryLength": 201600},
        "3292": {"vr": "OB", "BinaryLength": 201600},
        "3293": {"vr": "OB", "BinaryLength": 201600},
        "3294": {"vr": "OB", "BinaryLength": 201600},
        "3295": {"vr": "OB", "BinaryLength": 201600},
        "3296": {"vr": "OB", "BinaryLength": 201600},
        "3297": {"vr": "OB", "BinaryLength": 201600},
        "3298": {"vr": "OB", "BinaryLength": 201600},
        "3299": {"vr": "OB", "BinaryLength": 201600},
        "3300": {"vr": "OB", "BinaryLength": 201600},
        "3301": {"vr": "OB", "BinaryLength": 201600},
        "3302": {"vr": "OB", "BinaryLength": 201600},
        "3303": {"vr": "OB", "BinaryLength": 201600},
        "3304": {"vr": "OB", "BinaryLength": 201600},
        "3305": {"vr": "OB", "BinaryLength": 201600},
        "3306": {"vr": "OB", "BinaryLength": 201600},
        "3307": {"vr": "OB", "BinaryLength": 201600},
        "3308": {"vr": "OB", "BinaryLength": 201600},
        "3309": {"vr": "OB", "BinaryLength": 201600},
        "3310": {"vr": "OB", "BinaryLength": 201600},
        "3311": {"vr": "OB", "BinaryLength": 201600},
        "3312": {"vr": "OB", "BinaryLength": 201600},
        "3313": {"vr": "OB", "BinaryLength": 201600},
        "3314": {"vr": "OB", "BinaryLength": 201600},
        "3315": {"vr": "OB", "BinaryLength": 201600},
        "3316": {"vr": "OB", "BinaryLength": 201600},
        "3317": {"vr": "OB", "BinaryLength": 201600},
        "3318": {"vr": "OB", "BinaryLength": 201600},
        "3319": {"vr": "OB", "BinaryLength": 201600},
        "3320": {"vr": "OB", "BinaryLength": 201600},
        "3321": {"vr": "OB", "BinaryLength": 201600},
        "3322": {"vr": "OB", "BinaryLength": 201600},
        "3323": {"vr": "OB", "BinaryLength": 201600},
        "3324": {"vr": "OB", "BinaryLength": 201600},
        "3325": {"vr": "OB", "BinaryLength": 201600},
        "3326": {"vr": "OB", "BinaryLength": 201600},
        "3327": {"vr": "OB", "BinaryLength": 201600},
        "3328": {"vr": "OB", "BinaryLength": 201600},
        "3329": {"vr": "OB", "BinaryLength": 201600},
        "3330": {"vr": "OB", "BinaryLength": 201600},
        "3331": {"vr": "OB", "BinaryLength": 201600},
        "3332": {"vr": "OB", "BinaryLength": 201600},
        "3333": {"vr": "OB", "BinaryLength": 201600},
        "3334": {"vr": "OB", "BinaryLength": 201600},
        "3335": {"vr": "OB", "BinaryLength": 201600},
        "3336": {"vr": "OB", "BinaryLength": 201600},
        "3337": {"vr": "OB", "BinaryLength": 201600},
        "3338": {"vr": "OB", "BinaryLength": 201600},
        "3339": {"vr": "OB", "BinaryLength": 201600},
        "3340": {"vr": "OB", "BinaryLength": 201600},
        "3341": {"vr": "OB", "BinaryLength": 201600},
        "3342": {"vr": "OB", "BinaryLength": 201600},
        "3343": {"vr": "OB", "BinaryLength": 201600},
        "3344": {"vr": "OB", "BinaryLength": 201600},
        "3345": {"vr": "OB", "BinaryLength": 201600},
        "3346": {"vr": "OB", "BinaryLength": 201600},
        "3347": {"vr": "OB", "BinaryLength": 201600},
        "3348": {"vr": "OB", "BinaryLength": 201600},
        "3349": {"vr": "OB", "BinaryLength": 201600},
        "3350": {"vr": "OB", "BinaryLength": 201600},
        "3351": {"vr": "OB", "BinaryLength": 201600},
        "3352": {"vr": "OB", "BinaryLength": 201600},
        "3353": {"vr": "OB", "BinaryLength": 201600},
        "3354": {"vr": "OB", "BinaryLength": 201600},
        "3355": {"vr": "OB", "BinaryLength": 201600},
        "3356": {"vr": "OB", "BinaryLength": 201600},
        "3357": {"vr": "OB", "BinaryLength": 201600},
        "3358": {"vr": "OB", "BinaryLength": 201600},
        "3359": {"vr": "OB", "BinaryLength": 201600},
        "3360": {"vr": "OB", "BinaryLength": 201600},
        "3361": {"vr": "OB", "BinaryLength": 201600},
        "3362": {"vr": "OB", "BinaryLength": 201600},
        "3363": {"vr": "OB", "BinaryLength": 201600},
        "3364": {"vr": "OB", "BinaryLength": 201600},
        "3365": {"vr": "OB", "BinaryLength": 201600},
        "3366": {"vr": "OB", "BinaryLength": 201600},
        "3367": {"vr": "OB", "BinaryLength": 201600},
        "3368": {"vr": "OB", "BinaryLength": 201600},
        "3369": {"vr": "OB", "BinaryLength": 201600},
        "3370": {"vr": "OB", "BinaryLength": 201600},
        "3371": {"vr": "OB", "BinaryLength": 201600},
        "3372": {"vr": "OB", "BinaryLength": 201600},
        "3373": {"vr": "OB", "BinaryLength": 201600},
        "3374": {"vr": "OB", "BinaryLength": 201600},
        "3375": {"vr": "OB", "BinaryLength": 201600},
        "3376": {"vr": "OB", "BinaryLength": 201600},
        "3377": {"vr": "OB", "BinaryLength": 201600},
        "3378": {"vr": "OB", "BinaryLength": 201600},
        "3379": {"vr": "OB", "BinaryLength": 201600},
        "3380": {"vr": "OB", "BinaryLength": 201600},
        "3381": {"vr": "OB", "BinaryLength": 201600},
        "3382": {"vr": "OB", "BinaryLength": 201600},
        "3383": {"vr": "OB", "BinaryLength": 201600},
        "3384": {"vr": "OB", "BinaryLength": 201600},
        "3385": {"vr": "OB", "BinaryLength": 201600},
        "3386": {"vr": "OB", "BinaryLength": 201600},
        "3387": {"vr": "OB", "BinaryLength": 201600},
        "3388": {"vr": "OB", "BinaryLength": 201600},
        "3389": {"vr": "OB", "BinaryLength": 201600},
        "3390": {"vr": "OB", "BinaryLength": 201600},
        "3391": {"vr": "OB", "BinaryLength": 201600},
        "3392": {"vr": "OB", "BinaryLength": 201600},
        "3393": {"vr": "OB", "BinaryLength": 201600},
        "3394": {"vr": "OB", "BinaryLength": 201600},
        "3395": {"vr": "OB", "BinaryLength": 201600},
        "3396": {"vr": "OB", "BinaryLength": 201600},
        "3397": {"vr": "OB", "BinaryLength": 201600},
        "3398": {"vr": "OB", "BinaryLength": 201600},
        "3399": {"vr": "OB", "BinaryLength": 201600},
        "3400": {"vr": "OB", "BinaryLength": 201600},
        "3401": {"vr": "OB", "BinaryLength": 201600},
        "3402": {"vr": "OB", "BinaryLength": 201600},
        "3403": {"vr": "OB", "BinaryLength": 201600},
        "3404": {"vr": "OB", "BinaryLength": 201600},
        "3405": {"vr": "OB", "BinaryLength": 201600},
        "3406": {"vr": "OB", "BinaryLength": 201600},
        "3407": {"vr": "OB", "BinaryLength": 201600},
        "3408": {"vr": "OB", "BinaryLength": 201600},
        "3409": {"vr": "OB", "BinaryLength": 201600},
        "3410": {"vr": "OB", "BinaryLength": 201600},
        "3411": {"vr": "OB", "BinaryLength": 201600},
        "3412": {"vr": "OB", "BinaryLength": 201600},
        "3413": {"vr": "OB", "BinaryLength": 201600},
        "3414": {"vr": "OB", "BinaryLength": 201600},
        "3415": {"vr": "OB", "BinaryLength": 201600},
        "3416": {"vr": "OB", "BinaryLength": 201600},
        "3417": {"vr": "OB", "BinaryLength": 201600},
        "3418": {"vr": "OB", "BinaryLength": 201600},
        "3419": {"vr": "OB", "BinaryLength": 201600},
        "3420": {"vr": "OB", "BinaryLength": 201600},
        "3421": {"vr": "OB", "BinaryLength": 201600},
        "3422": {"vr": "OB", "BinaryLength": 201600},
        "3423": {"vr": "OB", "BinaryLength": 201600},
        "3424": {"vr": "OB", "BinaryLength": 201600},
        "3425": {"vr": "OB", "BinaryLength": 201600},
        "3426": {"vr": "OB", "BinaryLength": 201600},
        "3427": {"vr": "OB", "BinaryLength": 201600},
        "3428": {"vr": "OB", "BinaryLength": 201600},
        "3429": {"vr": "OB", "BinaryLength": 201600},
        "3430": {"vr": "OB", "BinaryLength": 201600},
        "3431": {"vr": "OB", "BinaryLength": 201600},
        "3432": {"vr": "OB", "BinaryLength": 201600},
        "3433": {"vr": "OB", "BinaryLength": 201600},
        "3434": {"vr": "OB", "BinaryLength": 201600},
        "3435": {"vr": "OB", "BinaryLength": 201600},
        "3436": {"vr": "OB", "BinaryLength": 201600},
        "3437": {"vr": "OB", "BinaryLength": 201600},
        "3438": {"vr": "OB", "BinaryLength": 201600},
        "3439": {"vr": "OB", "BinaryLength": 201600},
        "3440": {"vr": "OB", "BinaryLength": 201600},
        "3441": {"vr": "OB", "BinaryLength": 201600},
        "3442": {"vr": "OB", "BinaryLength": 201600},
        "3443": {"vr": "OB", "BinaryLength": 201600},
        "3444": {"vr": "OB", "BinaryLength": 201600},
        "3445": {"vr": "OB", "BinaryLength": 201600},
        "3446": {"vr": "OB", "BinaryLength": 201600},
        "3447": {"vr": "OB", "BinaryLength": 201600},
        "3448": {"vr": "OB", "BinaryLength": 201600},
        "3449": {"vr": "OB", "BinaryLength": 201600},
        "3450": {"vr": "OB", "BinaryLength": 201600},
        "3451": {"vr": "OB", "BinaryLength": 201600},
        "3452": {"vr": "OB", "BinaryLength": 201600},
        "3453": {"vr": "OB", "BinaryLength": 201600},
        "3454": {"vr": "OB", "BinaryLength": 201600},
        "3455": {"vr": "OB", "BinaryLength": 201600},
        "3456": {"vr": "OB", "BinaryLength": 201600},
        "3457": {"vr": "OB", "BinaryLength": 201600},
        "3458": {"vr": "OB", "BinaryLength": 201600},
        "3459": {"vr": "OB", "BinaryLength": 201600},
        "3460": {"vr": "OB", "BinaryLength": 201600},
        "3461": {"vr": "OB", "BinaryLength": 201600},
        "3462": {"vr": "OB", "BinaryLength": 201600},
        "3463": {"vr": "OB", "BinaryLength": 201600},
        "3464": {"vr": "OB", "BinaryLength": 201600},
        "3465": {"vr": "OB", "BinaryLength": 201600},
        "3466": {"vr": "OB", "BinaryLength": 201600},
        "3467": {"vr": "OB", "BinaryLength": 201600},
        "3468": {"vr": "OB", "BinaryLength": 201600},
        "3469": {"vr": "OB", "BinaryLength": 201600},
        "3470": {"vr": "OB", "BinaryLength": 201600},
        "3471": {"vr": "OB", "BinaryLength": 201600},
        "3472": {"vr": "OB", "BinaryLength": 201600},
        "3473": {"vr": "OB", "BinaryLength": 201600},
        "3474": {"vr": "OB", "BinaryLength": 201600},
        "3475": {"vr": "OB", "BinaryLength": 201600},
        "3476": {"vr": "OB", "BinaryLength": 201600},
        "3477": {"vr": "OB", "BinaryLength": 201600},
        "3478": {"vr": "OB", "BinaryLength": 201600},
        "3479": {"vr": "OB", "BinaryLength": 201600},
        "3480": {"vr": "OB", "BinaryLength": 201600},
        "3481": {"vr": "OB", "BinaryLength": 201600},
        "3482": {"vr": "OB", "BinaryLength": 201600},
        "3483": {"vr": "OB", "BinaryLength": 201600},
        "3484": {"vr": "OB", "BinaryLength": 201600},
        "3485": {"vr": "OB", "BinaryLength": 201600},
        "3486": {"vr": "OB", "BinaryLength": 201600},
        "3487": {"vr": "OB", "BinaryLength": 201600},
        "3488": {"vr": "OB", "BinaryLength": 201600},
        "3489": {"vr": "OB", "BinaryLength": 201600},
        "3490": {"vr": "OB", "BinaryLength": 201600},
        "3491": {"vr": "OB", "BinaryLength": 201600},
        "3492": {"vr": "OB", "BinaryLength": 201600},
        "3493": {"vr": "OB", "BinaryLength": 201600},
        "3494": {"vr": "OB", "BinaryLength": 201600},
        "3495": {"vr": "OB", "BinaryLength": 201600},
        "3496": {"vr": "OB", "BinaryLength": 201600},
        "3497": {"vr": "OB", "BinaryLength": 201600},
        "3498": {"vr": "OB", "BinaryLength": 201600},
        "3499": {"vr": "OB", "BinaryLength": 201600},
        "3500": {"vr": "OB", "BinaryLength": 201600},
        "3501": {"vr": "OB", "BinaryLength": 201600},
        "3502": {"vr": "OB", "BinaryLength": 201600},
        "3503": {"vr": "OB", "BinaryLength": 201600},
        "3504": {"vr": "OB", "BinaryLength": 201600},
        "3505": {"vr": "OB", "BinaryLength": 201600},
        "3506": {"vr": "OB", "BinaryLength": 201600},
        "3507": {"vr": "OB", "BinaryLength": 201600},
        "3508": {"vr": "OB", "BinaryLength": 201600},
        "3509": {"vr": "OB", "BinaryLength": 201600},
        "3510": {"vr": "OB", "BinaryLength": 201600},
        "3511": {"vr": "OB", "BinaryLength": 201600},
        "3512": {"vr": "OB", "BinaryLength": 201600},
        "3513": {"vr": "OB", "BinaryLength": 201600},
        "3514": {"vr": "OB", "BinaryLength": 201600},
        "3515": {"vr": "OB", "BinaryLength": 201600},
        "3516": {"vr": "OB", "BinaryLength": 201600},
        "3517": {"vr": "OB", "BinaryLength": 201600},
        "3518": {"vr": "OB", "BinaryLength": 201600},
        "3519": {"vr": "OB", "BinaryLength": 201600},
        "3520": {"vr": "OB", "BinaryLength": 201600},
        "3521": {"vr": "OB", "BinaryLength": 201600},
        "3522": {"vr": "OB", "BinaryLength": 201600},
        "3523": {"vr": "OB", "BinaryLength": 201600},
        "3524": {"vr": "OB", "BinaryLength": 201600},
        "3525": {"vr": "OB", "BinaryLength": 201600},
        "3526": {"vr": "OB", "BinaryLength": 201600},
        "3527": {"vr": "OB", "BinaryLength": 201600},
        "3528": {"vr": "OB", "BinaryLength": 201600},
        "3529": {"vr": "OB", "BinaryLength": 201600},
        "3530": {"vr": "OB", "BinaryLength": 201600},
        "3531": {"vr": "OB", "BinaryLength": 201600},
        "3532": {"vr": "OB", "BinaryLength": 201600},
        "3533": {"vr": "OB", "BinaryLength": 201600},
        "3534": {"vr": "OB", "BinaryLength": 201600},
        "3535": {"vr": "OB", "BinaryLength": 201600},
        "3536": {"vr": "OB", "BinaryLength": 201600},
        "3537": {"vr": "OB", "BinaryLength": 201600},
        "3538": {"vr": "OB", "BinaryLength": 201600},
        "3539": {"vr": "OB", "BinaryLength": 201600},
        "3540": {"vr": "OB", "BinaryLength": 201600},
        "3541": {"vr": "OB", "BinaryLength": 201600},
        "3542": {"vr": "OB", "BinaryLength": 201600},
        "3543": {"vr": "OB", "BinaryLength": 201600},
        "3544": {"vr": "OB", "BinaryLength": 201600},
        "3545": {"vr": "OB", "BinaryLength": 201600},
        "3546": {"vr": "OB", "BinaryLength": 201600},
        "3547": {"vr": "OB", "BinaryLength": 201600},
        "3548": {"vr": "OB", "BinaryLength": 201600},
        "3549": {"vr": "OB", "BinaryLength": 201600},
        "3550": {"vr": "OB", "BinaryLength": 201600},
        "3551": {"vr": "OB", "BinaryLength": 201600},
        "3552": {"vr": "OB", "BinaryLength": 201600},
        "3553": {"vr": "OB", "BinaryLength": 201600},
        "3554": {"vr": "OB", "BinaryLength": 201600},
        "3555": {"vr": "OB", "BinaryLength": 201600},
        "3556": {"vr": "OB", "BinaryLength": 201600},
        "3557": {"vr": "OB", "BinaryLength": 201600},
        "3558": {"vr": "OB", "BinaryLength": 201600},
        "3559": {"vr": "OB", "BinaryLength": 201600},
        "3560": {"vr": "OB", "BinaryLength": 201600},
        "3561": {"vr": "OB", "BinaryLength": 201600},
        "3562": {"vr": "OB", "BinaryLength": 201600},
        "3563": {"vr": "OB", "BinaryLength": 201600},
        "3564": {"vr": "OB", "BinaryLength": 201600},
        "3565": {"vr": "OB", "BinaryLength": 201600},
        "3566": {"vr": "OB", "BinaryLength": 201600},
        "3567": {"vr": "OB", "BinaryLength": 201600},
        "3568": {"vr": "OB", "BinaryLength": 201600},
        "3569": {"vr": "OB", "BinaryLength": 201600},
        "3570": {"vr": "OB", "BinaryLength": 201600},
        "3571": {"vr": "OB", "BinaryLength": 201600},
        "3572": {"vr": "OB", "BinaryLength": 201600},
        "3573": {"vr": "OB", "BinaryLength": 201600},
        "3574": {"vr": "OB", "BinaryLength": 201600},
        "3575": {"vr": "OB", "BinaryLength": 201600},
        "3576": {"vr": "OB", "BinaryLength": 201600},
        "3577": {"vr": "OB", "BinaryLength": 201600},
        "3578": {"vr": "OB", "BinaryLength": 201600},
        "3579": {"vr": "OB", "BinaryLength": 201600},
        "3580": {"vr": "OB", "BinaryLength": 201600},
        "3581": {"vr": "OB", "BinaryLength": 201600},
        "3582": {"vr": "OB", "BinaryLength": 201600},
        "3583": {"vr": "OB", "BinaryLength": 201600},
        "3584": {"vr": "OB", "BinaryLength": 201600},
        "3585": {"vr": "OB", "BinaryLength": 201600},
        "3586": {"vr": "OB", "BinaryLength": 201600},
        "3587": {"vr": "OB", "BinaryLength": 201600},
        "3588": {"vr": "OB", "BinaryLength": 201600},
        "3589": {"vr": "OB", "BinaryLength": 201600},
        "3590": {"vr": "OB", "BinaryLength": 201600},
        "3591": {"vr": "OB", "BinaryLength": 201600},
        "3592": {"vr": "OB", "BinaryLength": 201600},
        "3593": {"vr": "OB", "BinaryLength": 201600},
        "3594": {"vr": "OB", "BinaryLength": 201600},
        "3595": {"vr": "OB", "BinaryLength": 201600},
        "3596": {"vr": "OB", "BinaryLength": 201600},
        "3597": {"vr": "OB", "BinaryLength": 201600},
        "3598": {"vr": "OB", "BinaryLength": 201600},
        "3599": {"vr": "OB", "BinaryLength": 201600},
        "3600": {"vr": "OB", "BinaryLength": 201600},
        "3601": {"vr": "OB", "BinaryLength": 201600},
        "3602": {"vr": "OB", "BinaryLength": 201600},
        "3603": {"vr": "OB", "BinaryLength": 201600},
        "3604": {"vr": "OB", "BinaryLength": 201600},
        "3605": {"vr": "OB", "BinaryLength": 201600},
        "3606": {"vr": "OB", "BinaryLength": 201600},
        "3607": {"vr": "OB", "BinaryLength": 201600},
        "3608": {"vr": "OB", "BinaryLength": 201600},
        "3609": {"vr": "OB", "BinaryLength": 201600},
        "3610": {"vr": "OB", "BinaryLength": 201600},
        "3611": {"vr": "OB", "BinaryLength": 201600},
        "3612": {"vr": "OB", "BinaryLength": 201600},
        "3613": {"vr": "OB", "BinaryLength": 201600},
        "3614": {"vr": "OB", "BinaryLength": 201600},
        "3615": {"vr": "OB", "BinaryLength": 201600},
        "3616": {"vr": "OB", "BinaryLength": 201600},
        "3617": {"vr": "OB", "BinaryLength": 201600},
        "3618": {"vr": "OB", "BinaryLength": 201600},
        "3619": {"vr": "OB", "BinaryLength": 201600},
        "3620": {"vr": "OB", "BinaryLength": 201600},
        "3621": {"vr": "OB", "BinaryLength": 201600},
        "3622": {"vr": "OB", "BinaryLength": 201600},
        "3623": {"vr": "OB", "BinaryLength": 201600},
        "3624": {"vr": "OB", "BinaryLength": 201600},
        "3625": {"vr": "OB", "BinaryLength": 201600},
        "3626": {"vr": "OB", "BinaryLength": 201600},
        "3627": {"vr": "OB", "BinaryLength": 201600},
        "3628": {"vr": "OB", "BinaryLength": 201600},
        "3629": {"vr": "OB", "BinaryLength": 201600},
        "3630": {"vr": "OB", "BinaryLength": 201600},
        "3631": {"vr": "OB", "BinaryLength": 201600},
        "3632": {"vr": "OB", "BinaryLength": 201600},
        "3633": {"vr": "OB", "BinaryLength": 201600},
        "3634": {"vr": "OB", "BinaryLength": 201600},
        "3635": {"vr": "OB", "BinaryLength": 201600},
        "3636": {"vr": "OB", "BinaryLength": 201600},
        "3637": {"vr": "OB", "BinaryLength": 201600},
        "3638": {"vr": "OB", "BinaryLength": 201600},
        "3639": {"vr": "OB", "BinaryLength": 201600},
        "3640": {"vr": "OB", "BinaryLength": 201600},
        "3641": {"vr": "OB", "BinaryLength": 201600},
        "3642": {"vr": "OB", "BinaryLength": 201600},
        "3643": {"vr": "OB", "BinaryLength": 201600},
        "3644": {"vr": "OB", "BinaryLength": 201600},
        "3645": {"vr": "OB", "BinaryLength": 201600},
        "3646": {"vr": "OB", "BinaryLength": 201600},
        "3647": {"vr": "OB", "BinaryLength": 201600},
        "3648": {"vr": "OB", "BinaryLength": 201600},
        "3649": {"vr": "OB", "BinaryLength": 201600},
        "3650": {"vr": "OB", "BinaryLength": 201600},
        "3651": {"vr": "OB", "BinaryLength": 201600},
        "3652": {"vr": "OB", "BinaryLength": 201600},
        "3653": {"vr": "OB", "BinaryLength": 201600},
        "3654": {"vr": "OB", "BinaryLength": 201600},
        "3655": {"vr": "OB", "BinaryLength": 201600},
        "3656": {"vr": "OB", "BinaryLength": 201600},
        "3657": {"vr": "OB", "BinaryLength": 201600},
        "3658": {"vr": "OB", "BinaryLength": 201600},
        "3659": {"vr": "OB", "BinaryLength": 201600},
        "3660": {"vr": "OB", "BinaryLength": 201600},
        "3661": {"vr": "OB", "BinaryLength": 201600},
        "3662": {"vr": "OB", "BinaryLength": 201600},
        "3663": {"vr": "OB", "BinaryLength": 201600},
        "3664": {"vr": "OB", "BinaryLength": 201600},
        "3665": {"vr": "OB", "BinaryLength": 201600},
        "3666": {"vr": "OB", "BinaryLength": 201600},
        "3667": {"vr": "OB", "BinaryLength": 201600},
        "3668": {"vr": "OB", "BinaryLength": 201600},
        "3669": {"vr": "OB", "BinaryLength": 201600},
        "3670": {"vr": "OB", "BinaryLength": 201600},
        "3671": {"vr": "OB", "BinaryLength": 201600},
        "3672": {"vr": "OB", "BinaryLength": 201600},
        "3673": {"vr": "OB", "BinaryLength": 201600},
        "3674": {"vr": "OB", "BinaryLength": 201600},
        "3675": {"vr": "OB", "BinaryLength": 201600},
        "3676": {"vr": "OB", "BinaryLength": 201600},
        "3677": {"vr": "OB", "BinaryLength": 201600},
        "3678": {"vr": "OB", "BinaryLength": 201600},
        "3679": {"vr": "OB", "BinaryLength": 201600},
        "3680": {"vr": "OB", "BinaryLength": 201600},
        "3681": {"vr": "OB", "BinaryLength": 201600},
        "3682": {"vr": "OB", "BinaryLength": 201600},
        "3683": {"vr": "OB", "BinaryLength": 201600},
        "3684": {"vr": "OB", "BinaryLength": 201600},
        "3685": {"vr": "OB", "BinaryLength": 201600},
        "3686": {"vr": "OB", "BinaryLength": 201600},
        "3687": {"vr": "OB", "BinaryLength": 201600},
        "3688": {"vr": "OB", "BinaryLength": 201600},
        "3689": {"vr": "OB", "BinaryLength": 201600},
        "3690": {"vr": "OB", "BinaryLength": 201600},
        "3691": {"vr": "OB", "BinaryLength": 201600},
        "3692": {"vr": "OB", "BinaryLength": 201600},
        "3693": {"vr": "OB", "BinaryLength": 201600},
        "3694": {"vr": "OB", "BinaryLength": 201600},
        "3695": {"vr": "OB", "BinaryLength": 201600},
        "3696": {"vr": "OB", "BinaryLength": 201600},
        "3697": {"vr": "OB", "BinaryLength": 201600},
        "3698": {"vr": "OB", "BinaryLength": 201600},
        "3699": {"vr": "OB", "BinaryLength": 201600},
        "3700": {"vr": "OB", "BinaryLength": 201600},
        "3701": {"vr": "OB", "BinaryLength": 201600},
        "3702": {"vr": "OB", "BinaryLength": 201600},
        "3703": {"vr": "OB", "BinaryLength": 201600},
        "3704": {"vr": "OB", "BinaryLength": 201600},
        "3705": {"vr": "OB", "BinaryLength": 201600},
        "3706": {"vr": "OB", "BinaryLength": 201600},
        "3707": {"vr": "OB", "BinaryLength": 201600},
        "3708": {"vr": "OB", "BinaryLength": 201600},
        "3709": {"vr": "OB", "BinaryLength": 201600},
        "3710": {"vr": "OB", "BinaryLength": 201600},
        "3711": {"vr": "OB", "BinaryLength": 201600},
        "3712": {"vr": "OB", "BinaryLength": 201600},
        "3713": {"vr": "OB", "BinaryLength": 201600},
        "3714": {"vr": "OB", "BinaryLength": 201600},
        "3715": {"vr": "OB", "BinaryLength": 201600},
        "3716": {"vr": "OB", "BinaryLength": 201600},
        "3717": {"vr": "OB", "BinaryLength": 201600},
        "3718": {"vr": "OB", "BinaryLength": 201600},
        "3719": {"vr": "OB", "BinaryLength": 201600},
        "3720": {"vr": "OB", "BinaryLength": 201600},
        "3721": {"vr": "OB", "BinaryLength": 201600},
        "3722": {"vr": "OB", "BinaryLength": 201600},
        "3723": {"vr": "OB", "BinaryLength": 201600},
        "3724": {"vr": "OB", "BinaryLength": 201600},
        "3725": {"vr": "OB", "BinaryLength": 201600},
        "3726": {"vr": "OB", "BinaryLength": 201600},
        "3727": {"vr": "OB", "BinaryLength": 201600},
        "3728": {"vr": "OB", "BinaryLength": 201600},
        "3729": {"vr": "OB", "BinaryLength": 201600},
        "3730": {"vr": "OB", "BinaryLength": 201600},
        "3731": {"vr": "OB", "BinaryLength": 201600},
        "3732": {"vr": "OB", "BinaryLength": 201600},
        "3733": {"vr": "OB", "BinaryLength": 201600},
        "3734": {"vr": "OB", "BinaryLength": 201600},
        "3735": {"vr": "OB", "BinaryLength": 201600},
        "3736": {"vr": "OB", "BinaryLength": 201600},
        "3737": {"vr": "OB", "BinaryLength": 201600},
        "3738": {"vr": "OB", "BinaryLength": 201600},
        "3739": {"vr": "OB", "BinaryLength": 201600},
        "3740": {"vr": "OB", "BinaryLength": 201600},
        "3741": {"vr": "OB", "BinaryLength": 201600},
        "3742": {"vr": "OB", "BinaryLength": 201600},
        "3743": {"vr": "OB", "BinaryLength": 201600},
        "3744": {"vr": "OB", "BinaryLength": 201600},
        "3745": {"vr": "OB", "BinaryLength": 201600},
        "3746": {"vr": "OB", "BinaryLength": 201600},
        "3747": {"vr": "OB", "BinaryLength": 201600},
        "3748": {"vr": "OB", "BinaryLength": 201600},
        "3749": {"vr": "OB", "BinaryLength": 201600},
        "3750": {"vr": "OB", "BinaryLength": 201600},
        "3751": {"vr": "OB", "BinaryLength": 201600},
        "3752": {"vr": "OB", "BinaryLength": 201600},
        "3753": {"vr": "OB", "BinaryLength": 201600},
        "3754": {"vr": "OB", "BinaryLength": 201600},
        "3755": {"vr": "OB", "BinaryLength": 201600},
        "3756": {"vr": "OB", "BinaryLength": 201600},
        "3757": {"vr": "OB", "BinaryLength": 201600},
        "3758": {"vr": "OB", "BinaryLength": 201600},
        "3759": {"vr": "OB", "BinaryLength": 201600},
        "3760": {"vr": "OB", "BinaryLength": 201600},
        "3761": {"vr": "OB", "BinaryLength": 201600},
        "3762": {"vr": "OB", "BinaryLength": 201600},
        "3763": {"vr": "OB", "BinaryLength": 201600},
        "3764": {"vr": "OB", "BinaryLength": 201600},
        "3765": {"vr": "OB", "BinaryLength": 201600},
        "3766": {"vr": "OB", "BinaryLength": 201600},
        "3767": {"vr": "OB", "BinaryLength": 201600},
        "3768": {"vr": "OB", "BinaryLength": 201600},
        "3769": {"vr": "OB", "BinaryLength": 201600},
        "3770": {"vr": "OB", "BinaryLength": 201600},
        "3771": {"vr": "OB", "BinaryLength": 201600},
        "3772": {"vr": "OB", "BinaryLength": 201600},
        "3773": {"vr": "OB", "BinaryLength": 201600},
        "3774": {"vr": "OB", "BinaryLength": 201600},
        "3775": {"vr": "OB", "BinaryLength": 201600},
        "3776": {"vr": "OB", "BinaryLength": 201600},
        "3777": {"vr": "OB", "BinaryLength": 201600},
        "3778": {"vr": "OB", "BinaryLength": 201600},
        "3779": {"vr": "OB", "BinaryLength": 201600},
        "3780": {"vr": "OB", "BinaryLength": 201600},
        "3781": {"vr": "OB", "BinaryLength": 201600},
        "3782": {"vr": "OB", "BinaryLength": 201600},
        "3783": {"vr": "OB", "BinaryLength": 201600},
        "3784": {"vr": "OB", "BinaryLength": 201600},
        "3785": {"vr": "OB", "BinaryLength": 201600},
        "3786": {"vr": "OB", "BinaryLength": 201600},
        "3787": {"vr": "OB", "BinaryLength": 201600},
        "3788": {"vr": "OB", "BinaryLength": 201600},
        "3789": {"vr": "OB", "BinaryLength": 201600},
        "3790": {"vr": "OB", "BinaryLength": 201600},
        "3791": {"vr": "OB", "BinaryLength": 201600},
        "3792": {"vr": "OB", "BinaryLength": 201600},
        "3793": {"vr": "OB", "BinaryLength": 201600},
        "3794": {"vr": "OB", "BinaryLength": 201600},
        "3795": {"vr": "OB", "BinaryLength": 201600},
        "3796": {"vr": "OB", "BinaryLength": 201600},
        "3797": {"vr": "OB", "BinaryLength": 201600},
        "3798": {"vr": "OB", "BinaryLength": 201600},
        "3799": {"vr": "OB", "BinaryLength": 201600},
        "3800": {"vr": "OB", "BinaryLength": 201600},
        "3801": {"vr": "OB", "BinaryLength": 201600},
        "3802": {"vr": "OB", "BinaryLength": 201600},
        "3803": {"vr": "OB", "BinaryLength": 201600},
        "3804": {"vr": "OB", "BinaryLength": 201600},
        "3805": {"vr": "OB", "BinaryLength": 201600},
        "3806": {"vr": "OB", "BinaryLength": 201600},
        "3807": {"vr": "OB", "BinaryLength": 201600},
        "3808": {"vr": "OB", "BinaryLength": 201600},
        "3809": {"vr": "OB", "BinaryLength": 201600},
        "3810": {"vr": "OB", "BinaryLength": 201600},
        "3811": {"vr": "OB", "BinaryLength": 201600},
        "3812": {"vr": "OB", "BinaryLength": 201600},
        "3813": {"vr": "OB", "BinaryLength": 201600},
        "3814": {"vr": "OB", "BinaryLength": 201600},
        "3815": {"vr": "OB", "BinaryLength": 201600},
        "3816": {"vr": "OB", "BinaryLength": 201600},
        "3817": {"vr": "OB", "BinaryLength": 201600},
        "3818": {"vr": "OB", "BinaryLength": 201600},
        "3819": {"vr": "OB", "BinaryLength": 201600},
        "3820": {"vr": "OB", "BinaryLength": 201600},
        "3821": {"vr": "OB", "BinaryLength": 201600},
        "3822": {"vr": "OB", "BinaryLength": 201600},
        "3823": {"vr": "OB", "BinaryLength": 201600},
        "3824": {"vr": "OB", "BinaryLength": 201600},
        "3825": {"vr": "OB", "BinaryLength": 201600},
        "3826": {"vr": "OB", "BinaryLength": 201600},
        "3827": {"vr": "OB", "BinaryLength": 201600},
        "3828": {"vr": "OB", "BinaryLength": 201600},
        "3829": {"vr": "OB", "BinaryLength": 201600},
        "3830": {"vr": "OB", "BinaryLength": 201600},
        "3831": {"vr": "OB", "BinaryLength": 201600},
        "3832": {"vr": "OB", "BinaryLength": 201600},
        "3833": {"vr": "OB", "BinaryLength": 201600},
        "3834": {"vr": "OB", "BinaryLength": 201600},
        "3835": {"vr": "OB", "BinaryLength": 201600},
        "3836": {"vr": "OB", "BinaryLength": 201600},
        "3837": {"vr": "OB", "BinaryLength": 201600},
        "3838": {"vr": "OB", "BinaryLength": 201600},
        "3839": {"vr": "OB", "BinaryLength": 201600},
        "3840": {"vr": "OB", "BinaryLength": 201600},
        "3841": {"vr": "OB", "BinaryLength": 201600},
        "3842": {"vr": "OB", "BinaryLength": 201600},
        "3843": {"vr": "OB", "BinaryLength": 201600},
        "3844": {"vr": "OB", "BinaryLength": 201600},
        "3845": {"vr": "OB", "BinaryLength": 201600},
        "3846": {"vr": "OB", "BinaryLength": 201600},
        "3847": {"vr": "OB", "BinaryLength": 201600},
        "3848": {"vr": "OB", "BinaryLength": 201600},
        "3849": {"vr": "OB", "BinaryLength": 201600},
        "3850": {"vr": "OB", "BinaryLength": 201600},
        "3851": {"vr": "OB", "BinaryLength": 201600},
        "3852": {"vr": "OB", "BinaryLength": 201600},
        "3853": {"vr": "OB", "BinaryLength": 201600},
        "3854": {"vr": "OB", "BinaryLength": 201600},
        "3855": {"vr": "OB", "BinaryLength": 201600},
        "3856": {"vr": "OB", "BinaryLength": 201600},
        "3857": {"vr": "OB", "BinaryLength": 201600},
        "3858": {"vr": "OB", "BinaryLength": 201600},
        "3859": {"vr": "OB", "BinaryLength": 201600},
        "3860": {"vr": "OB", "BinaryLength": 201600},
        "3861": {"vr": "OB", "BinaryLength": 201600},
        "3862": {"vr": "OB", "BinaryLength": 201600},
        "3863": {"vr": "OB", "BinaryLength": 201600},
        "3864": {"vr": "OB", "BinaryLength": 201600},
        "3865": {"vr": "OB", "BinaryLength": 201600},
        "3866": {"vr": "OB", "BinaryLength": 201600},
        "3867": {"vr": "OB", "BinaryLength": 201600},
        "3868": {"vr": "OB", "BinaryLength": 201600},
        "3869": {"vr": "OB", "BinaryLength": 201600},
        "3870": {"vr": "OB", "BinaryLength": 201600},
        "3871": {"vr": "OB", "BinaryLength": 201600},
        "3872": {"vr": "OB", "BinaryLength": 201600},
        "3873": {"vr": "OB", "BinaryLength": 201600},
        "3874": {"vr": "OB", "BinaryLength": 201600},
        "3875": {"vr": "OB", "BinaryLength": 201600},
        "3876": {"vr": "OB", "BinaryLength": 201600},
        "3877": {"vr": "OB", "BinaryLength": 201600},
        "3878": {"vr": "OB", "BinaryLength": 201600},
        "3879": {"vr": "OB", "BinaryLength": 201600},
        "3880": {"vr": "OB", "BinaryLength": 201600},
        "3881": {"vr": "OB", "BinaryLength": 201600},
        "3882": {"vr": "OB", "BinaryLength": 201600},
        "3883": {"vr": "OB", "BinaryLength": 201600},
        "3884": {"vr": "OB", "BinaryLength": 201600},
        "3885": {"vr": "OB", "BinaryLength": 201600},
        "3886": {"vr": "OB", "BinaryLength": 201600},
        "3887": {"vr": "OB", "BinaryLength": 201600},
        "3888": {"vr": "OB", "BinaryLength": 201600},
        "3889": {"vr": "OB", "BinaryLength": 201600},
        "3890": {"vr": "OB", "BinaryLength": 201600},
        "3891": {"vr": "OB", "BinaryLength": 201600},
        "3892": {"vr": "OB", "BinaryLength": 201600},
        "3893": {"vr": "OB", "BinaryLength": 201600},
        "3894": {"vr": "OB", "BinaryLength": 201600},
        "3895": {"vr": "OB", "BinaryLength": 201600},
        "3896": {"vr": "OB", "BinaryLength": 201600},
        "3897": {"vr": "OB", "BinaryLength": 201600},
        "3898": {"vr": "OB", "BinaryLength": 201600},
        "3899": {"vr": "OB", "BinaryLength": 201600},
        "3900": {"vr": "OB", "BinaryLength": 201600},
        "3901": {"vr": "OB", "BinaryLength": 201600},
        "3902": {"vr": "OB", "BinaryLength": 201600},
        "3903": {"vr": "OB", "BinaryLength": 201600},
        "3904": {"vr": "OB", "BinaryLength": 201600},
        "3905": {"vr": "OB", "BinaryLength": 201600},
        "3906": {"vr": "OB", "BinaryLength": 201600},
        "3907": {"vr": "OB", "BinaryLength": 201600},
        "3908": {"vr": "OB", "BinaryLength": 201600},
        "3909": {"vr": "OB", "BinaryLength": 201600},
        "3910": {"vr": "OB", "BinaryLength": 201600},
        "3911": {"vr": "OB", "BinaryLength": 201600},
        "3912": {"vr": "OB", "BinaryLength": 201600},
        "3913": {"vr": "OB", "BinaryLength": 201600},
        "3914": {"vr": "OB", "BinaryLength": 201600},
        "3915": {"vr": "OB", "BinaryLength": 201600},
        "3916": {"vr": "OB", "BinaryLength": 201600},
        "3917": {"vr": "OB", "BinaryLength": 201600},
        "3918": {"vr": "OB", "BinaryLength": 201600},
        "3919": {"vr": "OB", "BinaryLength": 201600},
        "3920": {"vr": "OB", "BinaryLength": 201600},
        "3921": {"vr": "OB", "BinaryLength": 201600},
        "3922": {"vr": "OB", "BinaryLength": 201600},
        "3923": {"vr": "OB", "BinaryLength": 201600},
        "3924": {"vr": "OB", "BinaryLength": 201600},
        "3925": {"vr": "OB", "BinaryLength": 201600},
        "3926": {"vr": "OB", "BinaryLength": 201600},
        "3927": {"vr": "OB", "BinaryLength": 201600},
        "3928": {"vr": "OB", "BinaryLength": 201600},
        "3929": {"vr": "OB", "BinaryLength": 201600},
        "3930": {"vr": "OB", "BinaryLength": 201600},
        "3931": {"vr": "OB", "BinaryLength": 201600},
        "3932": {"vr": "OB", "BinaryLength": 201600},
        "3933": {"vr": "OB", "BinaryLength": 201600},
        "3934": {"vr": "OB", "BinaryLength": 201600},
        "3935": {"vr": "OB", "BinaryLength": 201600},
        "3936": {"vr": "OB", "BinaryLength": 201600},
        "3937": {"vr": "OB", "BinaryLength": 201600},
        "3938": {"vr": "OB", "BinaryLength": 201600},
        "3939": {"vr": "OB", "BinaryLength": 201600},
        "3940": {"vr": "OB", "BinaryLength": 201600},
        "3941": {"vr": "OB", "BinaryLength": 201600},
        "3942": {"vr": "OB", "BinaryLength": 201600},
        "3943": {"vr": "OB", "BinaryLength": 201600},
        "3944": {"vr": "OB", "BinaryLength": 201600},
        "3945": {"vr": "OB", "BinaryLength": 201600},
        "3946": {"vr": "OB", "BinaryLength": 201600},
        "3947": {"vr": "OB", "BinaryLength": 201600},
        "3948": {"vr": "OB", "BinaryLength": 201600},
        "3949": {"vr": "OB", "BinaryLength": 201600},
        "3950": {"vr": "OB", "BinaryLength": 201600},
        "3951": {"vr": "OB", "BinaryLength": 201600},
        "3952": {"vr": "OB", "BinaryLength": 201600},
        "3953": {"vr": "OB", "BinaryLength": 201600},
        "3954": {"vr": "OB", "BinaryLength": 201600},
        "3955": {"vr": "OB", "BinaryLength": 201600},
        "3956": {"vr": "OB", "BinaryLength": 201600},
        "3957": {"vr": "OB", "BinaryLength": 201600},
        "3958": {"vr": "OB", "BinaryLength": 201600},
        "3959": {"vr": "OB", "BinaryLength": 201600},
        "3960": {"vr": "OB", "BinaryLength": 201600},
        "3961": {"vr": "OB", "BinaryLength": 201600},
        "3962": {"vr": "OB", "BinaryLength": 201600},
        "3963": {"vr": "OB", "BinaryLength": 201600},
        "3964": {"vr": "OB", "BinaryLength": 201600},
        "3965": {"vr": "OB", "BinaryLength": 201600},
        "3966": {"vr": "OB", "BinaryLength": 201600},
        "3967": {"vr": "OB", "BinaryLength": 201600},
        "3968": {"vr": "OB", "BinaryLength": 201600},
        "3969": {"vr": "OB", "BinaryLength": 201600},
        "3970": {"vr": "OB", "BinaryLength": 201600},
        "3971": {"vr": "OB", "BinaryLength": 201600},
        "3972": {"vr": "OB", "BinaryLength": 201600},
        "3973": {"vr": "OB", "BinaryLength": 201600},
        "3974": {"vr": "OB", "BinaryLength": 201600},
        "3975": {"vr": "OB", "BinaryLength": 201600},
        "3976": {"vr": "OB", "BinaryLength": 201600},
        "3977": {"vr": "OB", "BinaryLength": 201600},
        "3978": {"vr": "OB", "BinaryLength": 201600},
        "3979": {"vr": "OB", "BinaryLength": 201600},
        "3980": {"vr": "OB", "BinaryLength": 201600},
        "3981": {"vr": "OB", "BinaryLength": 201600},
        "3982": {"vr": "OB", "BinaryLength": 201600},
        "3983": {"vr": "OB", "BinaryLength": 201600},
        "3984": {"vr": "OB", "BinaryLength": 201600},
        "3985": {"vr": "OB", "BinaryLength": 201600},
        "3986": {"vr": "OB", "BinaryLength": 201600},
        "3987": {"vr": "OB", "BinaryLength": 201600},
        "3988": {"vr": "OB", "BinaryLength": 201600},
        "3989": {"vr": "OB", "BinaryLength": 201600},
        "3990": {"vr": "OB", "BinaryLength": 201600},
        "3991": {"vr": "OB", "BinaryLength": 201600},
        "3992": {"vr": "OB", "BinaryLength": 201600},
        "3993": {"vr": "OB", "BinaryLength": 201600},
        "3994": {"vr": "OB", "BinaryLength": 201600},
        "3995": {"vr": "OB", "BinaryLength": 201600},
        "3996": {"vr": "OB", "BinaryLength": 201600},
        "3997": {"vr": "OB", "BinaryLength": 201600},
        "3998": {"vr": "OB", "BinaryLength": 201600},
        "3999": {"vr": "OB", "BinaryLength": 201600},
        "4000": {"vr": "OB", "BinaryLength": 201600},
        "4001": {"vr": "OB", "BinaryLength": 201600},
        "4002": {"vr": "OB", "BinaryLength": 201600},
        "4003": {"vr": "OB", "BinaryLength": 201600},
        "4004": {"vr": "OB", "BinaryLength": 201600},
        "4005": {"vr": "OB", "BinaryLength": 201600},
        "4006": {"vr": "OB", "BinaryLength": 201600},
        "4007": {"vr": "OB", "BinaryLength": 201600},
        "4008": {"vr": "OB", "BinaryLength": 201600},
        "4009": {"vr": "OB", "BinaryLength": 201600},
        "4010": {"vr": "OB", "BinaryLength": 201600},
        "4011": {"vr": "OB", "BinaryLength": 201600},
        "4012": {"vr": "OB", "BinaryLength": 201600},
        "4013": {"vr": "OB", "BinaryLength": 201600},
        "4014": {"vr": "OB", "BinaryLength": 201600},
        "4015": {"vr": "OB", "BinaryLength": 201600},
        "4016": {"vr": "OB", "BinaryLength": 201600},
        "4017": {"vr": "OB", "BinaryLength": 201600},
        "4018": {"vr": "OB", "BinaryLength": 201600},
        "4019": {"vr": "OB", "BinaryLength": 201600},
    },
    "7FE00010": {
        "0": {"vr": "OW", "BinaryLength": 24576},
        "1": {"vr": "OW", "BinaryLength": 24576},
        "2": {"vr": "OW", "BinaryLength": 24576},
        "3": {"vr": "OW", "BinaryLength": 24576},
        "4": {"vr": "OW", "BinaryLength": 24576},
        "5": {"vr": "OW", "BinaryLength": 24576},
        "6": {"vr": "OW", "BinaryLength": 24576},
        "7": {"vr": "OW", "BinaryLength": 24576},
        "8": {"vr": "OW", "BinaryLength": 24576},
        "9": {"vr": "OW", "BinaryLength": 24576},
        "10": {"vr": "OW", "BinaryLength": 24576},
        "11": {"vr": "OW", "BinaryLength": 24576},
        "12": {"vr": "OW", "BinaryLength": 24576},
        "13": {"vr": "OW", "BinaryLength": 24576},
        "14": {"vr": "OW", "BinaryLength": 24576},
        "15": {"vr": "OW", "BinaryLength": 24576},
        "16": {"vr": "OW", "BinaryLength": 24576},
        "17": {"vr": "OW", "BinaryLength": 24576},
        "18": {"vr": "OW", "BinaryLength": 24576},
        "19": {"vr": "OW", "BinaryLength": 24576},
        "20": {"vr": "OW", "BinaryLength": 24576},
        "21": {"vr": "OW", "BinaryLength": 24576},
        "22": {"vr": "OW", "BinaryLength": 24576},
        "23": {"vr": "OW", "BinaryLength": 24576},
        "24": {"vr": "OW", "BinaryLength": 24576},
        "25": {"vr": "OW", "BinaryLength": 24576},
        "26": {"vr": "OW", "BinaryLength": 24576},
        "27": {"vr": "OW", "BinaryLength": 24576},
        "28": {"vr": "OW", "BinaryLength": 24576},
        "29": {"vr": "OW", "BinaryLength": 24576},
        "30": {"vr": "OW", "BinaryLength": 24576},
        "31": {"vr": "OW", "BinaryLength": 24576},
        "32": {"vr": "OW", "BinaryLength": 24576},
        "33": {"vr": "OW", "BinaryLength": 24576},
        "34": {"vr": "OW", "BinaryLength": 24576},
        "35": {"vr": "OW", "BinaryLength": 24576},
        "36": {"vr": "OW", "BinaryLength": 24576},
        "37": {"vr": "OW", "BinaryLength": 24576},
        "38": {"vr": "OW", "BinaryLength": 24576},
        "39": {"vr": "OW", "BinaryLength": 24576},
        "40": {"vr": "OW", "BinaryLength": 24576},
        "41": {"vr": "OW", "BinaryLength": 24576},
        "42": {"vr": "OW", "BinaryLength": 24576},
        "43": {"vr": "OW", "BinaryLength": 24576},
        "44": {"vr": "OW", "BinaryLength": 24576},
        "45": {"vr": "OW", "BinaryLength": 24576},
        "46": {"vr": "OW", "BinaryLength": 24576},
        "47": {"vr": "OW", "BinaryLength": 24576},
        "48": {"vr": "OW", "BinaryLength": 24576},
        "49": {"vr": "OW", "BinaryLength": 24576},
        "50": {"vr": "OW", "BinaryLength": 24576},
        "51": {"vr": "OW", "BinaryLength": 24576},
        "52": {"vr": "OW", "BinaryLength": 24576},
        "53": {"vr": "OW", "BinaryLength": 24576},
        "54": {"vr": "OW", "BinaryLength": 24576},
        "55": {"vr": "OW", "BinaryLength": 24576},
        "56": {"vr": "OW", "BinaryLength": 24576},
        "57": {"vr": "OW", "BinaryLength": 24576},
        "58": {"vr": "OW", "BinaryLength": 24576},
        "59": {"vr": "OW", "BinaryLength": 24576},
        "60": {"vr": "OW", "BinaryLength": 24576},
        "61": {"vr": "OW", "BinaryLength": 24576},
        "62": {"vr": "OW", "BinaryLength": 24576},
        "63": {"vr": "OW", "BinaryLength": 24576},
        "64": {"vr": "OW", "BinaryLength": 24576},
        "65": {"vr": "OW", "BinaryLength": 24576},
        "66": {"vr": "OW", "BinaryLength": 24576},
        "67": {"vr": "OW", "BinaryLength": 24576},
        "68": {"vr": "OW", "BinaryLength": 24576},
        "69": {"vr": "OW", "BinaryLength": 24576},
        "70": {"vr": "OW", "BinaryLength": 24576},
        "71": {"vr": "OW", "BinaryLength": 24576},
        "72": {"vr": "OW", "BinaryLength": 24576},
        "73": {"vr": "OW", "BinaryLength": 24576},
        "74": {"vr": "OW", "BinaryLength": 24576},
        "75": {"vr": "OW", "BinaryLength": 24576},
        "76": {"vr": "OW", "BinaryLength": 24576},
        "77": {"vr": "OW", "BinaryLength": 24576},
        "78": {"vr": "OW", "BinaryLength": 24576},
        "79": {"vr": "OW", "BinaryLength": 24576},
        "80": {"vr": "OW", "BinaryLength": 24576},
        "81": {"vr": "OW", "BinaryLength": 24576},
        "82": {"vr": "OW", "BinaryLength": 24576},
        "83": {"vr": "OW", "BinaryLength": 24576},
        "84": {"vr": "OW", "BinaryLength": 24576},
        "85": {"vr": "OW", "BinaryLength": 24576},
        "86": {"vr": "OW", "BinaryLength": 24576},
        "87": {"vr": "OW", "BinaryLength": 24576},
        "88": {"vr": "OW", "BinaryLength": 24576},
        "89": {"vr": "OW", "BinaryLength": 24576},
        "90": {"vr": "OW", "BinaryLength": 24576},
        "91": {"vr": "OW", "BinaryLength": 24576},
        "92": {"vr": "OW", "BinaryLength": 24576},
        "93": {"vr": "OW", "BinaryLength": 24576},
        "94": {"vr": "OW", "BinaryLength": 24576},
        "95": {"vr": "OW", "BinaryLength": 24576},
        "96": {"vr": "OW", "BinaryLength": 24576},
        "97": {"vr": "OW", "BinaryLength": 24576},
        "98": {"vr": "OW", "BinaryLength": 24576},
        "99": {"vr": "OW", "BinaryLength": 24576},
        "100": {"vr": "OW", "BinaryLength": 24576},
        "101": {"vr": "OW", "BinaryLength": 24576},
        "102": {"vr": "OW", "BinaryLength": 24576},
        "103": {"vr": "OW", "BinaryLength": 24576},
        "104": {"vr": "OW", "BinaryLength": 24576},
        "105": {"vr": "OW", "BinaryLength": 24576},
        "106": {"vr": "OW", "BinaryLength": 24576},
        "107": {"vr": "OW", "BinaryLength": 24576},
        "108": {"vr": "OW", "BinaryLength": 24576},
        "109": {"vr": "OW", "BinaryLength": 24576},
        "110": {"vr": "OW", "BinaryLength": 24576},
        "111": {"vr": "OW", "BinaryLength": 24576},
        "112": {"vr": "OW", "BinaryLength": 24576},
        "113": {"vr": "OW", "BinaryLength": 24576},
        "114": {"vr": "OW", "BinaryLength": 24576},
        "115": {"vr": "OW", "BinaryLength": 24576},
        "116": {"vr": "OW", "BinaryLength": 24576},
        "117": {"vr": "OW", "BinaryLength": 24576},
        "118": {"vr": "OW", "BinaryLength": 24576},
        "119": {"vr": "OW", "BinaryLength": 24576},
        "120": {"vr": "OW", "BinaryLength": 24576},
        "121": {"vr": "OW", "BinaryLength": 24576},
        "122": {"vr": "OW", "BinaryLength": 24576},
        "123": {"vr": "OW", "BinaryLength": 24576},
        "124": {"vr": "OW", "BinaryLength": 24576},
        "125": {"vr": "OW", "BinaryLength": 24576},
        "126": {"vr": "OW", "BinaryLength": 24576},
        "127": {"vr": "OW", "BinaryLength": 24576},
        "128": {"vr": "OW", "BinaryLength": 24576},
        "129": {"vr": "OW", "BinaryLength": 24576},
        "130": {"vr": "OW", "BinaryLength": 24576},
        "131": {"vr": "OW", "BinaryLength": 24576},
        "132": {"vr": "OW", "BinaryLength": 24576},
        "133": {"vr": "OW", "BinaryLength": 24576},
        "134": {"vr": "OW", "BinaryLength": 24576},
        "135": {"vr": "OW", "BinaryLength": 24576},
        "136": {"vr": "OW", "BinaryLength": 24576},
        "137": {"vr": "OW", "BinaryLength": 24576},
        "138": {"vr": "OW", "BinaryLength": 24576},
        "139": {"vr": "OW", "BinaryLength": 24576},
        "140": {"vr": "OW", "BinaryLength": 24576},
        "141": {"vr": "OW", "BinaryLength": 24576},
        "142": {"vr": "OW", "BinaryLength": 24576},
        "143": {"vr": "OW", "BinaryLength": 24576},
        "144": {"vr": "OW", "BinaryLength": 24576},
        "145": {"vr": "OW", "BinaryLength": 24576},
        "146": {"vr": "OW", "BinaryLength": 24576},
        "147": {"vr": "OW", "BinaryLength": 24576},
        "148": {"vr": "OW", "BinaryLength": 24576},
        "149": {"vr": "OW", "BinaryLength": 24576},
        "150": {"vr": "OW", "BinaryLength": 24576},
        "151": {"vr": "OW", "BinaryLength": 24576},
        "152": {"vr": "OW", "BinaryLength": 24576},
        "153": {"vr": "OW", "BinaryLength": 24576},
        "154": {"vr": "OW", "BinaryLength": 24576},
        "155": {"vr": "OW", "BinaryLength": 24576},
        "156": {"vr": "OW", "BinaryLength": 24576},
        "157": {"vr": "OW", "BinaryLength": 24576},
        "158": {"vr": "OW", "BinaryLength": 24576},
        "159": {"vr": "OW", "BinaryLength": 24576},
        "160": {"vr": "OW", "BinaryLength": 24576},
        "161": {"vr": "OW", "BinaryLength": 24576},
        "162": {"vr": "OW", "BinaryLength": 24576},
        "163": {"vr": "OW", "BinaryLength": 24576},
        "164": {"vr": "OW", "BinaryLength": 24576},
        "165": {"vr": "OW", "BinaryLength": 24576},
        "166": {"vr": "OW", "BinaryLength": 24576},
        "167": {"vr": "OW", "BinaryLength": 24576},
        "168": {"vr": "OW", "BinaryLength": 24576},
        "169": {"vr": "OW", "BinaryLength": 24576},
        "170": {"vr": "OW", "BinaryLength": 24576},
        "171": {"vr": "OW", "BinaryLength": 24576},
        "172": {"vr": "OW", "BinaryLength": 24576},
        "173": {"vr": "OW", "BinaryLength": 24576},
        "174": {"vr": "OW", "BinaryLength": 24576},
        "175": {"vr": "OW", "BinaryLength": 24576},
        "176": {"vr": "OW", "BinaryLength": 24576},
        "177": {"vr": "OW", "BinaryLength": 24576},
        "178": {"vr": "OW", "BinaryLength": 24576},
        "179": {"vr": "OW", "BinaryLength": 24576},
        "180": {"vr": "OW", "BinaryLength": 24576},
        "181": {"vr": "OW", "BinaryLength": 24576},
        "182": {"vr": "OW", "BinaryLength": 24576},
        "183": {"vr": "OW", "BinaryLength": 24576},
        "184": {"vr": "OW", "BinaryLength": 24576},
        "185": {"vr": "OW", "BinaryLength": 24576},
        "186": {"vr": "OW", "BinaryLength": 24576},
        "187": {"vr": "OW", "BinaryLength": 24576},
        "188": {"vr": "OW", "BinaryLength": 24576},
        "189": {"vr": "OW", "BinaryLength": 24576},
        "190": {"vr": "OW", "BinaryLength": 24576},
        "191": {"vr": "OW", "BinaryLength": 24576},
        "192": {"vr": "OW", "BinaryLength": 24576},
        "193": {"vr": "OW", "BinaryLength": 24576},
        "194": {"vr": "OW", "BinaryLength": 24576},
        "195": {"vr": "OW", "BinaryLength": 24576},
        "196": {"vr": "OW", "BinaryLength": 24576},
        "197": {"vr": "OW", "BinaryLength": 24576},
        "198": {"vr": "OW", "BinaryLength": 24576},
        "199": {"vr": "OW", "BinaryLength": 24576},
        "200": {"vr": "OW", "BinaryLength": 24576},
        "201": {"vr": "OW", "BinaryLength": 24576},
        "202": {"vr": "OW", "BinaryLength": 24576},
        "203": {"vr": "OW", "BinaryLength": 24576},
        "204": {"vr": "OW", "BinaryLength": 24576},
        "205": {"vr": "OW", "BinaryLength": 24576},
        "206": {"vr": "OW", "BinaryLength": 24576},
        "207": {"vr": "OW", "BinaryLength": 24576},
        "208": {"vr": "OW", "BinaryLength": 24576},
        "209": {"vr": "OW", "BinaryLength": 24576},
        "210": {"vr": "OW", "BinaryLength": 24576},
        "211": {"vr": "OW", "BinaryLength": 24576},
        "212": {"vr": "OW", "BinaryLength": 24576},
        "213": {"vr": "OW", "BinaryLength": 24576},
        "214": {"vr": "OW", "BinaryLength": 24576},
        "215": {"vr": "OW", "BinaryLength": 24576},
        "216": {"vr": "OW", "BinaryLength": 24576},
        "217": {"vr": "OW", "BinaryLength": 24576},
        "218": {"vr": "OW", "BinaryLength": 24576},
        "219": {"vr": "OW", "BinaryLength": 24576},
        "220": {"vr": "OW", "BinaryLength": 24576},
        "221": {"vr": "OW", "BinaryLength": 24576},
        "222": {"vr": "OW", "BinaryLength": 24576},
        "223": {"vr": "OW", "BinaryLength": 24576},
        "224": {"vr": "OW", "BinaryLength": 24576},
        "225": {"vr": "OW", "BinaryLength": 24576},
        "226": {"vr": "OW", "BinaryLength": 24576},
        "227": {"vr": "OW", "BinaryLength": 24576},
        "228": {"vr": "OW", "BinaryLength": 24576},
        "229": {"vr": "OW", "BinaryLength": 24576},
        "230": {"vr": "OW", "BinaryLength": 24576},
        "231": {"vr": "OW", "BinaryLength": 24576},
        "232": {"vr": "OW", "BinaryLength": 24576},
        "233": {"vr": "OW", "BinaryLength": 24576},
        "234": {"vr": "OW", "BinaryLength": 24576},
        "235": {"vr": "OW", "BinaryLength": 24576},
        "236": {"vr": "OW", "BinaryLength": 24576},
        "237": {"vr": "OW", "BinaryLength": 24576},
        "238": {"vr": "OW", "BinaryLength": 24576},
        "239": {"vr": "OW", "BinaryLength": 24576},
        "240": {"vr": "OW", "BinaryLength": 24576},
        "241": {"vr": "OW", "BinaryLength": 24576},
        "242": {"vr": "OW", "BinaryLength": 24576},
        "243": {"vr": "OW", "BinaryLength": 24576},
        "244": {"vr": "OW", "BinaryLength": 24576},
        "245": {"vr": "OW", "BinaryLength": 24576},
        "246": {"vr": "OW", "BinaryLength": 24576},
        "247": {"vr": "OW", "BinaryLength": 24576},
        "248": {"vr": "OW", "BinaryLength": 24576},
        "249": {"vr": "OW", "BinaryLength": 24576},
        "250": {"vr": "OW", "BinaryLength": 24576},
        "251": {"vr": "OW", "BinaryLength": 24576},
        "252": {"vr": "OW", "BinaryLength": 24576},
        "253": {"vr": "OW", "BinaryLength": 24576},
        "254": {"vr": "OW", "BinaryLength": 24576},
        "255": {"vr": "OW", "BinaryLength": 24576},
        "256": {"vr": "OW", "BinaryLength": 24576},
        "257": {"vr": "OW", "BinaryLength": 24576},
        "258": {"vr": "OW", "BinaryLength": 24576},
        "259": {"vr": "OW", "BinaryLength": 24576},
        "260": {"vr": "OW", "BinaryLength": 24576},
        "261": {"vr": "OW", "BinaryLength": 24576},
        "262": {"vr": "OW", "BinaryLength": 24576},
        "263": {"vr": "OW", "BinaryLength": 24576},
        "264": {"vr": "OW", "BinaryLength": 24576},
        "265": {"vr": "OW", "BinaryLength": 24576},
        "266": {"vr": "OW", "BinaryLength": 24576},
        "267": {"vr": "OW", "BinaryLength": 24576},
        "268": {"vr": "OW", "BinaryLength": 24576},
        "269": {"vr": "OW", "BinaryLength": 24576},
        "270": {"vr": "OW", "BinaryLength": 24576},
        "271": {"vr": "OW", "BinaryLength": 24576},
        "272": {"vr": "OW", "BinaryLength": 24576},
        "273": {"vr": "OW", "BinaryLength": 24576},
        "274": {"vr": "OW", "BinaryLength": 24576},
        "275": {"vr": "OW", "BinaryLength": 24576},
        "276": {"vr": "OW", "BinaryLength": 24576},
        "277": {"vr": "OW", "BinaryLength": 24576},
        "278": {"vr": "OW", "BinaryLength": 24576},
        "279": {"vr": "OW", "BinaryLength": 24576},
        "280": {"vr": "OW", "BinaryLength": 24576},
        "281": {"vr": "OW", "BinaryLength": 24576},
        "282": {"vr": "OW", "BinaryLength": 24576},
        "283": {"vr": "OW", "BinaryLength": 24576},
        "284": {"vr": "OW", "BinaryLength": 24576},
        "285": {"vr": "OW", "BinaryLength": 24576},
        "286": {"vr": "OW", "BinaryLength": 24576},
        "287": {"vr": "OW", "BinaryLength": 24576},
        "288": {"vr": "OW", "BinaryLength": 24576},
        "289": {"vr": "OW", "BinaryLength": 24576},
        "290": {"vr": "OW", "BinaryLength": 24576},
        "291": {"vr": "OW", "BinaryLength": 24576},
        "292": {"vr": "OW", "BinaryLength": 24576},
        "293": {"vr": "OW", "BinaryLength": 24576},
        "294": {"vr": "OW", "BinaryLength": 24576},
        "295": {"vr": "OW", "BinaryLength": 24576},
        "296": {"vr": "OW", "BinaryLength": 24576},
        "297": {"vr": "OW", "BinaryLength": 24576},
        "298": {"vr": "OW", "BinaryLength": 24576},
        "299": {"vr": "OW", "BinaryLength": 24576},
        "300": {"vr": "OW", "BinaryLength": 24576},
        "301": {"vr": "OW", "BinaryLength": 24576},
        "302": {"vr": "OW", "BinaryLength": 24576},
        "303": {"vr": "OW", "BinaryLength": 24576},
        "304": {"vr": "OW", "BinaryLength": 24576},
        "305": {"vr": "OW", "BinaryLength": 24576},
        "306": {"vr": "OW", "BinaryLength": 24576},
        "307": {"vr": "OW", "BinaryLength": 24576},
        "308": {"vr": "OW", "BinaryLength": 24576},
        "309": {"vr": "OW", "BinaryLength": 24576},
        "310": {"vr": "OW", "BinaryLength": 24576},
        "311": {"vr": "OW", "BinaryLength": 24576},
        "312": {"vr": "OW", "BinaryLength": 24576},
        "313": {"vr": "OW", "BinaryLength": 24576},
        "314": {"vr": "OW", "BinaryLength": 24576},
        "315": {"vr": "OW", "BinaryLength": 24576},
        "316": {"vr": "OW", "BinaryLength": 24576},
        "317": {"vr": "OW", "BinaryLength": 24576},
        "318": {"vr": "OW", "BinaryLength": 24576},
        "319": {"vr": "OW", "BinaryLength": 24576},
        "320": {"vr": "OW", "BinaryLength": 24576},
        "321": {"vr": "OW", "BinaryLength": 24576},
        "322": {"vr": "OW", "BinaryLength": 24576},
        "323": {"vr": "OW", "BinaryLength": 24576},
        "324": {"vr": "OW", "BinaryLength": 24576},
        "325": {"vr": "OW", "BinaryLength": 24576},
        "326": {"vr": "OW", "BinaryLength": 24576},
        "327": {"vr": "OW", "BinaryLength": 24576},
        "328": {"vr": "OW", "BinaryLength": 24576},
        "329": {"vr": "OW", "BinaryLength": 24576},
        "330": {"vr": "OW", "BinaryLength": 24576},
        "331": {"vr": "OW", "BinaryLength": 24576},
        "332": {"vr": "OW", "BinaryLength": 24576},
        "333": {"vr": "OW", "BinaryLength": 24576},
        "334": {"vr": "OW", "BinaryLength": 24576},
        "335": {"vr": "OW", "BinaryLength": 24576},
        "336": {"vr": "OW", "BinaryLength": 24576},
        "337": {"vr": "OW", "BinaryLength": 24576},
        "338": {"vr": "OW", "BinaryLength": 24576},
        "339": {"vr": "OW", "BinaryLength": 24576},
        "340": {"vr": "OW", "BinaryLength": 24576},
        "341": {"vr": "OW", "BinaryLength": 24576},
        "342": {"vr": "OW", "BinaryLength": 24576},
        "343": {"vr": "OW", "BinaryLength": 24576},
        "344": {"vr": "OW", "BinaryLength": 24576},
        "345": {"vr": "OW", "BinaryLength": 24576},
        "346": {"vr": "OW", "BinaryLength": 24576},
        "347": {"vr": "OW", "BinaryLength": 24576},
        "348": {"vr": "OW", "BinaryLength": 24576},
        "349": {"vr": "OW", "BinaryLength": 24576},
        "350": {"vr": "OW", "BinaryLength": 24576},
        "351": {"vr": "OW", "BinaryLength": 24576},
        "352": {"vr": "OW", "BinaryLength": 24576},
        "353": {"vr": "OW", "BinaryLength": 24576},
        "354": {"vr": "OW", "BinaryLength": 24576},
        "355": {"vr": "OW", "BinaryLength": 24576},
        "356": {"vr": "OW", "BinaryLength": 24576},
        "357": {"vr": "OW", "BinaryLength": 24576},
        "358": {"vr": "OW", "BinaryLength": 24576},
        "359": {"vr": "OW", "BinaryLength": 24576},
        "360": {"vr": "OW", "BinaryLength": 24576},
        "361": {"vr": "OW", "BinaryLength": 24576},
        "362": {"vr": "OW", "BinaryLength": 24576},
        "363": {"vr": "OW", "BinaryLength": 24576},
        "364": {"vr": "OW", "BinaryLength": 24576},
        "365": {"vr": "OW", "BinaryLength": 24576},
        "366": {"vr": "OW", "BinaryLength": 24576},
        "367": {"vr": "OW", "BinaryLength": 24576},
        "368": {"vr": "OW", "BinaryLength": 24576},
        "369": {"vr": "OW", "BinaryLength": 24576},
        "370": {"vr": "OW", "BinaryLength": 24576},
        "371": {"vr": "OW", "BinaryLength": 24576},
        "372": {"vr": "OW", "BinaryLength": 24576},
        "373": {"vr": "OW", "BinaryLength": 24576},
        "374": {"vr": "OW", "BinaryLength": 24576},
        "375": {"vr": "OW", "BinaryLength": 24576},
        "376": {"vr": "OW", "BinaryLength": 24576},
        "377": {"vr": "OW", "BinaryLength": 24576},
        "378": {"vr": "OW", "BinaryLength": 24576},
        "379": {"vr": "OW", "BinaryLength": 24576},
        "380": {"vr": "OW", "BinaryLength": 24576},
        "381": {"vr": "OW", "BinaryLength": 24576},
        "382": {"vr": "OW", "BinaryLength": 24576},
        "383": {"vr": "OW", "BinaryLength": 24576},
        "384": {"vr": "OW", "BinaryLength": 24576},
        "385": {"vr": "OW", "BinaryLength": 24576},
        "386": {"vr": "OW", "BinaryLength": 24576},
        "387": {"vr": "OW", "BinaryLength": 24576},
        "388": {"vr": "OW", "BinaryLength": 24576},
        "389": {"vr": "OW", "BinaryLength": 24576},
        "390": {"vr": "OW", "BinaryLength": 24576},
        "391": {"vr": "OW", "BinaryLength": 24576},
        "392": {"vr": "OW", "BinaryLength": 24576},
        "393": {"vr": "OW", "BinaryLength": 24576},
        "394": {"vr": "OW", "BinaryLength": 24576},
        "395": {"vr": "OW", "BinaryLength": 24576},
        "396": {"vr": "OW", "BinaryLength": 24576},
        "397": {"vr": "OW", "BinaryLength": 24576},
        "398": {"vr": "OW", "BinaryLength": 24576},
        "399": {"vr": "OW", "BinaryLength": 24576},
        "400": {"vr": "OW", "BinaryLength": 24576},
        "401": {"vr": "OW", "BinaryLength": 24576},
        "402": {"vr": "OW", "BinaryLength": 24576},
        "403": {"vr": "OW", "BinaryLength": 24576},
        "404": {"vr": "OW", "BinaryLength": 24576},
        "405": {"vr": "OW", "BinaryLength": 24576},
        "406": {"vr": "OW", "BinaryLength": 24576},
        "407": {"vr": "OW", "BinaryLength": 24576},
        "408": {"vr": "OW", "BinaryLength": 24576},
        "409": {"vr": "OW", "BinaryLength": 24576},
        "410": {"vr": "OW", "BinaryLength": 24576},
        "411": {"vr": "OW", "BinaryLength": 24576},
        "412": {"vr": "OW", "BinaryLength": 24576},
        "413": {"vr": "OW", "BinaryLength": 24576},
        "414": {"vr": "OW", "BinaryLength": 24576},
        "415": {"vr": "OW", "BinaryLength": 24576},
        "416": {"vr": "OW", "BinaryLength": 24576},
        "417": {"vr": "OW", "BinaryLength": 24576},
        "418": {"vr": "OW", "BinaryLength": 24576},
        "419": {"vr": "OW", "BinaryLength": 24576},
        "420": {"vr": "OW", "BinaryLength": 24576},
        "421": {"vr": "OW", "BinaryLength": 24576},
        "422": {"vr": "OW", "BinaryLength": 24576},
        "423": {"vr": "OW", "BinaryLength": 24576},
        "424": {"vr": "OW", "BinaryLength": 24576},
        "425": {"vr": "OW", "BinaryLength": 24576},
        "426": {"vr": "OW", "BinaryLength": 24576},
        "427": {"vr": "OW", "BinaryLength": 24576},
        "428": {"vr": "OW", "BinaryLength": 24576},
        "429": {"vr": "OW", "BinaryLength": 24576},
        "430": {"vr": "OW", "BinaryLength": 24576},
        "431": {"vr": "OW", "BinaryLength": 24576},
        "432": {"vr": "OW", "BinaryLength": 24576},
        "433": {"vr": "OW", "BinaryLength": 24576},
        "434": {"vr": "OW", "BinaryLength": 24576},
        "435": {"vr": "OW", "BinaryLength": 24576},
        "436": {"vr": "OW", "BinaryLength": 24576},
        "437": {"vr": "OW", "BinaryLength": 24576},
        "438": {"vr": "OW", "BinaryLength": 24576},
        "439": {"vr": "OW", "BinaryLength": 24576},
        "440": {"vr": "OW", "BinaryLength": 24576},
        "441": {"vr": "OW", "BinaryLength": 24576},
        "442": {"vr": "OW", "BinaryLength": 24576},
        "443": {"vr": "OW", "BinaryLength": 24576},
        "444": {"vr": "OW", "BinaryLength": 24576},
        "445": {"vr": "OW", "BinaryLength": 24576},
        "446": {"vr": "OW", "BinaryLength": 24576},
        "447": {"vr": "OW", "BinaryLength": 24576},
        "448": {"vr": "OW", "BinaryLength": 24576},
        "449": {"vr": "OW", "BinaryLength": 24576},
        "450": {"vr": "OW", "BinaryLength": 24576},
        "451": {"vr": "OW", "BinaryLength": 24576},
        "452": {"vr": "OW", "BinaryLength": 24576},
        "453": {"vr": "OW", "BinaryLength": 24576},
        "454": {"vr": "OW", "BinaryLength": 24576},
        "455": {"vr": "OW", "BinaryLength": 24576},
        "456": {"vr": "OW", "BinaryLength": 24576},
        "457": {"vr": "OW", "BinaryLength": 24576},
        "458": {"vr": "OW", "BinaryLength": 24576},
        "459": {"vr": "OW", "BinaryLength": 24576},
        "460": {"vr": "OW", "BinaryLength": 24576},
        "461": {"vr": "OW", "BinaryLength": 24576},
        "462": {"vr": "OW", "BinaryLength": 24576},
        "463": {"vr": "OW", "BinaryLength": 24576},
        "464": {"vr": "OW", "BinaryLength": 24576},
        "465": {"vr": "OW", "BinaryLength": 24576},
        "466": {"vr": "OW", "BinaryLength": 24576},
        "467": {"vr": "OW", "BinaryLength": 24576},
        "468": {"vr": "OW", "BinaryLength": 24576},
        "469": {"vr": "OW", "BinaryLength": 24576},
        "470": {"vr": "OW", "BinaryLength": 24576},
        "471": {"vr": "OW", "BinaryLength": 24576},
        "472": {"vr": "OW", "BinaryLength": 24576},
        "473": {"vr": "OW", "BinaryLength": 24576},
        "474": {"vr": "OW", "BinaryLength": 24576},
        "475": {"vr": "OW", "BinaryLength": 24576},
        "476": {"vr": "OW", "BinaryLength": 24576},
        "477": {"vr": "OW", "BinaryLength": 24576},
        "478": {"vr": "OW", "BinaryLength": 24576},
        "479": {"vr": "OW", "BinaryLength": 24576},
        "480": {"vr": "OW", "BinaryLength": 24576},
        "481": {"vr": "OW", "BinaryLength": 24576},
        "482": {"vr": "OW", "BinaryLength": 24576},
        "483": {"vr": "OW", "BinaryLength": 24576},
        "484": {"vr": "OW", "BinaryLength": 24576},
        "485": {"vr": "OW", "BinaryLength": 24576},
        "486": {"vr": "OW", "BinaryLength": 24576},
        "487": {"vr": "OW", "BinaryLength": 24576},
        "488": {"vr": "OW", "BinaryLength": 24576},
        "489": {"vr": "OW", "BinaryLength": 24576},
        "490": {"vr": "OW", "BinaryLength": 24576},
        "491": {"vr": "OW", "BinaryLength": 24576},
        "492": {"vr": "OW", "BinaryLength": 24576},
        "493": {"vr": "OW", "BinaryLength": 24576},
        "494": {"vr": "OW", "BinaryLength": 24576},
        "495": {"vr": "OW", "BinaryLength": 24576},
        "496": {"vr": "OW", "BinaryLength": 24576},
        "497": {"vr": "OW", "BinaryLength": 24576},
        "498": {"vr": "OW", "BinaryLength": 24576},
        "499": {"vr": "OW", "BinaryLength": 24576},
        "500": {"vr": "OW", "BinaryLength": 24576},
        "501": {"vr": "OW", "BinaryLength": 24576},
        "502": {"vr": "OW", "BinaryLength": 24576},
        "503": {"vr": "OW", "BinaryLength": 24576},
        "504": {"vr": "OW", "BinaryLength": 24576},
        "505": {"vr": "OW", "BinaryLength": 24576},
        "506": {"vr": "OW", "BinaryLength": 24576},
        "507": {"vr": "OW", "BinaryLength": 24576},
        "508": {"vr": "OW", "BinaryLength": 24576},
        "509": {"vr": "OW", "BinaryLength": 24576},
        "510": {"vr": "OW", "BinaryLength": 24576},
        "511": {"vr": "OW", "BinaryLength": 24576},
        "512": {"vr": "OW", "BinaryLength": 24576},
        "513": {"vr": "OW", "BinaryLength": 24576},
        "514": {"vr": "OW", "BinaryLength": 24576},
        "515": {"vr": "OW", "BinaryLength": 24576},
        "516": {"vr": "OW", "BinaryLength": 24576},
        "517": {"vr": "OW", "BinaryLength": 24576},
        "518": {"vr": "OW", "BinaryLength": 24576},
        "519": {"vr": "OW", "BinaryLength": 24576},
        "520": {"vr": "OW", "BinaryLength": 24576},
        "521": {"vr": "OW", "BinaryLength": 24576},
        "522": {"vr": "OW", "BinaryLength": 24576},
        "523": {"vr": "OW", "BinaryLength": 24576},
        "524": {"vr": "OW", "BinaryLength": 24576},
        "525": {"vr": "OW", "BinaryLength": 24576},
        "526": {"vr": "OW", "BinaryLength": 24576},
        "527": {"vr": "OW", "BinaryLength": 24576},
        "528": {"vr": "OW", "BinaryLength": 24576},
        "529": {"vr": "OW", "BinaryLength": 24576},
        "530": {"vr": "OW", "BinaryLength": 24576},
        "531": {"vr": "OW", "BinaryLength": 24576},
        "532": {"vr": "OW", "BinaryLength": 24576},
        "533": {"vr": "OW", "BinaryLength": 24576},
        "534": {"vr": "OW", "BinaryLength": 24576},
        "535": {"vr": "OW", "BinaryLength": 24576},
        "536": {"vr": "OW", "BinaryLength": 24576},
        "537": {"vr": "OW", "BinaryLength": 24576},
        "538": {"vr": "OW", "BinaryLength": 24576},
        "539": {"vr": "OW", "BinaryLength": 24576},
        "540": {"vr": "OW", "BinaryLength": 24576},
        "541": {"vr": "OW", "BinaryLength": 24576},
        "542": {"vr": "OW", "BinaryLength": 24576},
        "543": {"vr": "OW", "BinaryLength": 24576},
        "544": {"vr": "OW", "BinaryLength": 24576},
        "545": {"vr": "OW", "BinaryLength": 24576},
        "546": {"vr": "OW", "BinaryLength": 24576},
        "547": {"vr": "OW", "BinaryLength": 24576},
        "548": {"vr": "OW", "BinaryLength": 24576},
        "549": {"vr": "OW", "BinaryLength": 24576},
        "550": {"vr": "OW", "BinaryLength": 24576},
        "551": {"vr": "OW", "BinaryLength": 24576},
        "552": {"vr": "OW", "BinaryLength": 24576},
        "553": {"vr": "OW", "BinaryLength": 24576},
        "554": {"vr": "OW", "BinaryLength": 24576},
        "555": {"vr": "OW", "BinaryLength": 24576},
        "556": {"vr": "OW", "BinaryLength": 24576},
        "557": {"vr": "OW", "BinaryLength": 24576},
        "558": {"vr": "OW", "BinaryLength": 24576},
        "559": {"vr": "OW", "BinaryLength": 24576},
        "560": {"vr": "OW", "BinaryLength": 24576},
        "561": {"vr": "OW", "BinaryLength": 24576},
        "562": {"vr": "OW", "BinaryLength": 24576},
        "563": {"vr": "OW", "BinaryLength": 24576},
        "564": {"vr": "OW", "BinaryLength": 24576},
        "565": {"vr": "OW", "BinaryLength": 24576},
        "566": {"vr": "OW", "BinaryLength": 24576},
        "567": {"vr": "OW", "BinaryLength": 24576},
        "568": {"vr": "OW", "BinaryLength": 24576},
        "569": {"vr": "OW", "BinaryLength": 24576},
        "570": {"vr": "OW", "BinaryLength": 24576},
        "571": {"vr": "OW", "BinaryLength": 24576},
        "572": {"vr": "OW", "BinaryLength": 24576},
        "573": {"vr": "OW", "BinaryLength": 24576},
        "574": {"vr": "OW", "BinaryLength": 24576},
        "575": {"vr": "OW", "BinaryLength": 24576},
        "576": {"vr": "OW", "BinaryLength": 24576},
        "577": {"vr": "OW", "BinaryLength": 24576},
        "578": {"vr": "OW", "BinaryLength": 24576},
        "579": {"vr": "OW", "BinaryLength": 24576},
        "580": {"vr": "OW", "BinaryLength": 24576},
        "581": {"vr": "OW", "BinaryLength": 24576},
        "582": {"vr": "OW", "BinaryLength": 24576},
        "583": {"vr": "OW", "BinaryLength": 24576},
        "584": {"vr": "OW", "BinaryLength": 24576},
        "585": {"vr": "OW", "BinaryLength": 24576},
        "586": {"vr": "OW", "BinaryLength": 24576},
        "587": {"vr": "OW", "BinaryLength": 24576},
        "588": {"vr": "OW", "BinaryLength": 24576},
        "589": {"vr": "OW", "BinaryLength": 24576},
        "590": {"vr": "OW", "BinaryLength": 24576},
        "591": {"vr": "OW", "BinaryLength": 24576},
        "592": {"vr": "OW", "BinaryLength": 24576},
        "593": {"vr": "OW", "BinaryLength": 24576},
        "594": {"vr": "OW", "BinaryLength": 24576},
        "595": {"vr": "OW", "BinaryLength": 24576},
        "596": {"vr": "OW", "BinaryLength": 24576},
        "597": {"vr": "OW", "BinaryLength": 24576},
        "598": {"vr": "OW", "BinaryLength": 24576},
        "599": {"vr": "OW", "BinaryLength": 24576},
        "600": {"vr": "OW", "BinaryLength": 24576},
        "601": {"vr": "OW", "BinaryLength": 24576},
        "602": {"vr": "OW", "BinaryLength": 24576},
        "603": {"vr": "OW", "BinaryLength": 24576},
        "604": {"vr": "OW", "BinaryLength": 24576},
        "605": {"vr": "OW", "BinaryLength": 24576},
        "606": {"vr": "OW", "BinaryLength": 24576},
        "607": {"vr": "OW", "BinaryLength": 24576},
        "608": {"vr": "OW", "BinaryLength": 24576},
        "609": {"vr": "OW", "BinaryLength": 24576},
        "610": {"vr": "OW", "BinaryLength": 24576},
        "611": {"vr": "OW", "BinaryLength": 24576},
        "612": {"vr": "OW", "BinaryLength": 24576},
        "613": {"vr": "OW", "BinaryLength": 24576},
        "614": {"vr": "OW", "BinaryLength": 24576},
        "615": {"vr": "OW", "BinaryLength": 24576},
        "616": {"vr": "OW", "BinaryLength": 24576},
        "617": {"vr": "OW", "BinaryLength": 24576},
        "618": {"vr": "OW", "BinaryLength": 24576},
        "619": {"vr": "OW", "BinaryLength": 24576},
        "620": {"vr": "OW", "BinaryLength": 24576},
        "621": {"vr": "OW", "BinaryLength": 24576},
        "622": {"vr": "OW", "BinaryLength": 24576},
        "623": {"vr": "OW", "BinaryLength": 24576},
        "624": {"vr": "OW", "BinaryLength": 24576},
        "625": {"vr": "OW", "BinaryLength": 24576},
        "626": {"vr": "OW", "BinaryLength": 24576},
        "627": {"vr": "OW", "BinaryLength": 24576},
        "628": {"vr": "OW", "BinaryLength": 24576},
        "629": {"vr": "OW", "BinaryLength": 24576},
        "630": {"vr": "OW", "BinaryLength": 24576},
        "631": {"vr": "OW", "BinaryLength": 24576},
        "632": {"vr": "OW", "BinaryLength": 24576},
        "633": {"vr": "OW", "BinaryLength": 24576},
        "634": {"vr": "OW", "BinaryLength": 24576},
        "635": {"vr": "OW", "BinaryLength": 24576},
        "636": {"vr": "OW", "BinaryLength": 24576},
        "637": {"vr": "OW", "BinaryLength": 24576},
        "638": {"vr": "OW", "BinaryLength": 24576},
        "639": {"vr": "OW", "BinaryLength": 24576},
        "640": {"vr": "OW", "BinaryLength": 24576},
        "641": {"vr": "OW", "BinaryLength": 24576},
        "642": {"vr": "OW", "BinaryLength": 24576},
        "643": {"vr": "OW", "BinaryLength": 24576},
        "644": {"vr": "OW", "BinaryLength": 24576},
        "645": {"vr": "OW", "BinaryLength": 24576},
        "646": {"vr": "OW", "BinaryLength": 24576},
        "647": {"vr": "OW", "BinaryLength": 24576},
        "648": {"vr": "OW", "BinaryLength": 24576},
        "649": {"vr": "OW", "BinaryLength": 24576},
        "650": {"vr": "OW", "BinaryLength": 24576},
        "651": {"vr": "OW", "BinaryLength": 24576},
        "652": {"vr": "OW", "BinaryLength": 24576},
        "653": {"vr": "OW", "BinaryLength": 24576},
        "654": {"vr": "OW", "BinaryLength": 24576},
        "655": {"vr": "OW", "BinaryLength": 24576},
        "656": {"vr": "OW", "BinaryLength": 24576},
        "657": {"vr": "OW", "BinaryLength": 24576},
        "658": {"vr": "OW", "BinaryLength": 24576},
        "659": {"vr": "OW", "BinaryLength": 24576},
        "660": {"vr": "OW", "BinaryLength": 24576},
        "661": {"vr": "OW", "BinaryLength": 24576},
        "662": {"vr": "OW", "BinaryLength": 24576},
        "663": {"vr": "OW", "BinaryLength": 24576},
        "664": {"vr": "OW", "BinaryLength": 24576},
        "665": {"vr": "OW", "BinaryLength": 24576},
        "666": {"vr": "OW", "BinaryLength": 24576},
        "667": {"vr": "OW", "BinaryLength": 24576},
        "668": {"vr": "OW", "BinaryLength": 24576},
        "669": {"vr": "OW", "BinaryLength": 24576},
        "670": {"vr": "OW", "BinaryLength": 24576},
        "671": {"vr": "OW", "BinaryLength": 24576},
        "672": {"vr": "OW", "BinaryLength": 24576},
        "673": {"vr": "OW", "BinaryLength": 24576},
        "674": {"vr": "OW", "BinaryLength": 24576},
        "675": {"vr": "OW", "BinaryLength": 24576},
        "676": {"vr": "OW", "BinaryLength": 24576},
        "677": {"vr": "OW", "BinaryLength": 24576},
        "678": {"vr": "OW", "BinaryLength": 24576},
        "679": {"vr": "OW", "BinaryLength": 24576},
        "680": {"vr": "OW", "BinaryLength": 24576},
        "681": {"vr": "OW", "BinaryLength": 24576},
        "682": {"vr": "OW", "BinaryLength": 24576},
        "683": {"vr": "OW", "BinaryLength": 24576},
        "684": {"vr": "OW", "BinaryLength": 24576},
        "685": {"vr": "OW", "BinaryLength": 24576},
        "686": {"vr": "OW", "BinaryLength": 24576},
        "687": {"vr": "OW", "BinaryLength": 24576},
        "688": {"vr": "OW", "BinaryLength": 24576},
        "689": {"vr": "OW", "BinaryLength": 24576},
        "690": {"vr": "OW", "BinaryLength": 24576},
        "691": {"vr": "OW", "BinaryLength": 24576},
        "692": {"vr": "OW", "BinaryLength": 24576},
        "693": {"vr": "OW", "BinaryLength": 24576},
        "694": {"vr": "OW", "BinaryLength": 24576},
        "695": {"vr": "OW", "BinaryLength": 24576},
        "696": {"vr": "OW", "BinaryLength": 24576},
        "697": {"vr": "OW", "BinaryLength": 24576},
        "698": {"vr": "OW", "BinaryLength": 24576},
        "699": {"vr": "OW", "BinaryLength": 24576},
        "700": {"vr": "OW", "BinaryLength": 24576},
        "701": {"vr": "OW", "BinaryLength": 24576},
        "702": {"vr": "OW", "BinaryLength": 24576},
        "703": {"vr": "OW", "BinaryLength": 24576},
        "704": {"vr": "OW", "BinaryLength": 24576},
        "705": {"vr": "OW", "BinaryLength": 24576},
        "706": {"vr": "OW", "BinaryLength": 24576},
        "707": {"vr": "OW", "BinaryLength": 24576},
        "708": {"vr": "OW", "BinaryLength": 24576},
        "709": {"vr": "OW", "BinaryLength": 24576},
        "710": {"vr": "OW", "BinaryLength": 24576},
        "711": {"vr": "OW", "BinaryLength": 24576},
        "712": {"vr": "OW", "BinaryLength": 24576},
        "713": {"vr": "OW", "BinaryLength": 24576},
        "714": {"vr": "OW", "BinaryLength": 24576},
        "715": {"vr": "OW", "BinaryLength": 24576},
        "716": {"vr": "OW", "BinaryLength": 24576},
        "717": {"vr": "OW", "BinaryLength": 24576},
        "718": {"vr": "OW", "BinaryLength": 24576},
        "719": {"vr": "OW", "BinaryLength": 24576},
        "720": {"vr": "OW", "BinaryLength": 24576},
        "721": {"vr": "OW", "BinaryLength": 24576},
        "722": {"vr": "OW", "BinaryLength": 24576},
        "723": {"vr": "OW", "BinaryLength": 24576},
        "724": {"vr": "OW", "BinaryLength": 24576},
        "725": {"vr": "OW", "BinaryLength": 24576},
        "726": {"vr": "OW", "BinaryLength": 24576},
        "727": {"vr": "OW", "BinaryLength": 24576},
        "728": {"vr": "OW", "BinaryLength": 24576},
        "729": {"vr": "OW", "BinaryLength": 24576},
        "730": {"vr": "OW", "BinaryLength": 24576},
        "731": {"vr": "OW", "BinaryLength": 24576},
        "732": {"vr": "OW", "BinaryLength": 24576},
        "733": {"vr": "OW", "BinaryLength": 24576},
        "734": {"vr": "OW", "BinaryLength": 24576},
        "735": {"vr": "OW", "BinaryLength": 24576},
        "736": {"vr": "OW", "BinaryLength": 24576},
        "737": {"vr": "OW", "BinaryLength": 24576},
        "738": {"vr": "OW", "BinaryLength": 24576},
        "739": {"vr": "OW", "BinaryLength": 24576},
        "740": {"vr": "OW", "BinaryLength": 24576},
        "741": {"vr": "OW", "BinaryLength": 24576},
        "742": {"vr": "OW", "BinaryLength": 24576},
        "743": {"vr": "OW", "BinaryLength": 24576},
        "744": {"vr": "OW", "BinaryLength": 24576},
        "745": {"vr": "OW", "BinaryLength": 24576},
        "746": {"vr": "OW", "BinaryLength": 24576},
        "747": {"vr": "OW", "BinaryLength": 24576},
        "748": {"vr": "OW", "BinaryLength": 24576},
        "749": {"vr": "OW", "BinaryLength": 24576},
        "750": {"vr": "OW", "BinaryLength": 24576},
        "751": {"vr": "OW", "BinaryLength": 24576},
        "752": {"vr": "OW", "BinaryLength": 24576},
        "753": {"vr": "OW", "BinaryLength": 24576},
        "754": {"vr": "OW", "BinaryLength": 24576},
        "755": {"vr": "OW", "BinaryLength": 24576},
        "756": {"vr": "OW", "BinaryLength": 24576},
        "757": {"vr": "OW", "BinaryLength": 24576},
        "758": {"vr": "OW", "BinaryLength": 24576},
        "759": {"vr": "OW", "BinaryLength": 24576},
        "760": {"vr": "OW", "BinaryLength": 24576},
        "761": {"vr": "OW", "BinaryLength": 24576},
        "762": {"vr": "OW", "BinaryLength": 24576},
        "763": {"vr": "OW", "BinaryLength": 24576},
        "764": {"vr": "OW", "BinaryLength": 24576},
        "765": {"vr": "OW", "BinaryLength": 24576},
        "766": {"vr": "OW", "BinaryLength": 24576},
        "767": {"vr": "OW", "BinaryLength": 24576},
        "768": {"vr": "OW", "BinaryLength": 24576},
        "769": {"vr": "OW", "BinaryLength": 24576},
        "770": {"vr": "OW", "BinaryLength": 24576},
        "771": {"vr": "OW", "BinaryLength": 24576},
        "772": {"vr": "OW", "BinaryLength": 24576},
        "773": {"vr": "OW", "BinaryLength": 24576},
        "774": {"vr": "OW", "BinaryLength": 24576},
        "775": {"vr": "OW", "BinaryLength": 24576},
        "776": {"vr": "OW", "BinaryLength": 24576},
        "777": {"vr": "OW", "BinaryLength": 24576},
        "778": {"vr": "OW", "BinaryLength": 24576},
        "779": {"vr": "OW", "BinaryLength": 24576},
        "780": {"vr": "OW", "BinaryLength": 24576},
        "781": {"vr": "OW", "BinaryLength": 24576},
        "782": {"vr": "OW", "BinaryLength": 24576},
        "783": {"vr": "OW", "BinaryLength": 24576},
        "784": {"vr": "OW", "BinaryLength": 24576},
        "785": {"vr": "OW", "BinaryLength": 24576},
        "786": {"vr": "OW", "BinaryLength": 24576},
        "787": {"vr": "OW", "BinaryLength": 24576},
        "788": {"vr": "OW", "BinaryLength": 24576},
        "789": {"vr": "OW", "BinaryLength": 24576},
        "790": {"vr": "OW", "BinaryLength": 24576},
        "791": {"vr": "OW", "BinaryLength": 24576},
        "792": {"vr": "OW", "BinaryLength": 24576},
        "793": {"vr": "OW", "BinaryLength": 24576},
        "794": {"vr": "OW", "BinaryLength": 24576},
        "795": {"vr": "OW", "BinaryLength": 24576},
        "796": {"vr": "OW", "BinaryLength": 24576},
        "797": {"vr": "OW", "BinaryLength": 24576},
        "798": {"vr": "OW", "BinaryLength": 24576},
        "799": {"vr": "OW", "BinaryLength": 24576},
        "800": {"vr": "OW", "BinaryLength": 24576},
        "801": {"vr": "OW", "BinaryLength": 24576},
        "802": {"vr": "OW", "BinaryLength": 24576},
        "803": {"vr": "OW", "BinaryLength": 24576},
        "804": {"vr": "OW", "BinaryLength": 24576},
        "805": {"vr": "OW", "BinaryLength": 24576},
        "806": {"vr": "OW", "BinaryLength": 24576},
        "807": {"vr": "OW", "BinaryLength": 24576},
        "808": {"vr": "OW", "BinaryLength": 24576},
        "809": {"vr": "OW", "BinaryLength": 24576},
        "810": {"vr": "OW", "BinaryLength": 24576},
        "811": {"vr": "OW", "BinaryLength": 24576},
        "812": {"vr": "OW", "BinaryLength": 24576},
        "813": {"vr": "OW", "BinaryLength": 24576},
        "814": {"vr": "OW", "BinaryLength": 24576},
        "815": {"vr": "OW", "BinaryLength": 24576},
        "816": {"vr": "OW", "BinaryLength": 24576},
        "817": {"vr": "OW", "BinaryLength": 24576},
        "818": {"vr": "OW", "BinaryLength": 24576},
        "819": {"vr": "OW", "BinaryLength": 24576},
        "820": {"vr": "OW", "BinaryLength": 24576},
        "821": {"vr": "OW", "BinaryLength": 24576},
        "822": {"vr": "OW", "BinaryLength": 24576},
        "823": {"vr": "OW", "BinaryLength": 24576},
        "824": {"vr": "OW", "BinaryLength": 24576},
        "825": {"vr": "OW", "BinaryLength": 24576},
        "826": {"vr": "OW", "BinaryLength": 24576},
        "827": {"vr": "OW", "BinaryLength": 24576},
        "828": {"vr": "OW", "BinaryLength": 24576},
        "829": {"vr": "OW", "BinaryLength": 24576},
        "830": {"vr": "OW", "BinaryLength": 24576},
        "831": {"vr": "OW", "BinaryLength": 24576},
        "832": {"vr": "OW", "BinaryLength": 24576},
        "833": {"vr": "OW", "BinaryLength": 24576},
        "834": {"vr": "OW", "BinaryLength": 24576},
        "835": {"vr": "OW", "BinaryLength": 24576},
        "836": {"vr": "OW", "BinaryLength": 24576},
        "837": {"vr": "OW", "BinaryLength": 24576},
        "838": {"vr": "OW", "BinaryLength": 24576},
        "839": {"vr": "OW", "BinaryLength": 24576},
        "840": {"vr": "OW", "BinaryLength": 24576},
        "841": {"vr": "OW", "BinaryLength": 24576},
        "842": {"vr": "OW", "BinaryLength": 24576},
        "843": {"vr": "OW", "BinaryLength": 24576},
        "844": {"vr": "OW", "BinaryLength": 24576},
        "845": {"vr": "OW", "BinaryLength": 24576},
        "846": {"vr": "OW", "BinaryLength": 24576},
        "847": {"vr": "OW", "BinaryLength": 24576},
        "848": {"vr": "OW", "BinaryLength": 24576},
        "849": {"vr": "OW", "BinaryLength": 24576},
        "850": {"vr": "OW", "BinaryLength": 24576},
        "851": {"vr": "OW", "BinaryLength": 24576},
        "852": {"vr": "OW", "BinaryLength": 24576},
        "853": {"vr": "OW", "BinaryLength": 24576},
        "854": {"vr": "OW", "BinaryLength": 24576},
        "855": {"vr": "OW", "BinaryLength": 24576},
        "856": {"vr": "OW", "BinaryLength": 24576},
        "857": {"vr": "OW", "BinaryLength": 24576},
        "858": {"vr": "OW", "BinaryLength": 24576},
        "859": {"vr": "OW", "BinaryLength": 24576},
        "860": {"vr": "OW", "BinaryLength": 24576},
        "861": {"vr": "OW", "BinaryLength": 24576},
        "862": {"vr": "OW", "BinaryLength": 24576},
        "863": {"vr": "OW", "BinaryLength": 24576},
        "864": {"vr": "OW", "BinaryLength": 24576},
        "865": {"vr": "OW", "BinaryLength": 24576},
        "866": {"vr": "OW", "BinaryLength": 24576},
        "867": {"vr": "OW", "BinaryLength": 24576},
        "868": {"vr": "OW", "BinaryLength": 24576},
        "869": {"vr": "OW", "BinaryLength": 24576},
        "870": {"vr": "OW", "BinaryLength": 24576},
        "871": {"vr": "OW", "BinaryLength": 24576},
        "872": {"vr": "OW", "BinaryLength": 24576},
        "873": {"vr": "OW", "BinaryLength": 24576},
        "874": {"vr": "OW", "BinaryLength": 24576},
        "875": {"vr": "OW", "BinaryLength": 24576},
        "876": {"vr": "OW", "BinaryLength": 24576},
        "877": {"vr": "OW", "BinaryLength": 24576},
        "878": {"vr": "OW", "BinaryLength": 24576},
        "879": {"vr": "OW", "BinaryLength": 24576},
        "880": {"vr": "OW", "BinaryLength": 24576},
        "881": {"vr": "OW", "BinaryLength": 24576},
        "882": {"vr": "OW", "BinaryLength": 24576},
        "883": {"vr": "OW", "BinaryLength": 24576},
        "884": {"vr": "OW", "BinaryLength": 24576},
        "885": {"vr": "OW", "BinaryLength": 24576},
        "886": {"vr": "OW", "BinaryLength": 24576},
        "887": {"vr": "OW", "BinaryLength": 24576},
        "888": {"vr": "OW", "BinaryLength": 24576},
        "889": {"vr": "OW", "BinaryLength": 24576},
        "890": {"vr": "OW", "BinaryLength": 24576},
        "891": {"vr": "OW", "BinaryLength": 24576},
        "892": {"vr": "OW", "BinaryLength": 24576},
        "893": {"vr": "OW", "BinaryLength": 24576},
        "894": {"vr": "OW", "BinaryLength": 24576},
        "895": {"vr": "OW", "BinaryLength": 24576},
        "896": {"vr": "OW", "BinaryLength": 24576},
        "897": {"vr": "OW", "BinaryLength": 24576},
        "898": {"vr": "OW", "BinaryLength": 24576},
        "899": {"vr": "OW", "BinaryLength": 24576},
        "900": {"vr": "OW", "BinaryLength": 24576},
        "901": {"vr": "OW", "BinaryLength": 24576},
        "902": {"vr": "OW", "BinaryLength": 24576},
        "903": {"vr": "OW", "BinaryLength": 24576},
        "904": {"vr": "OW", "BinaryLength": 24576},
        "905": {"vr": "OW", "BinaryLength": 24576},
        "906": {"vr": "OW", "BinaryLength": 24576},
        "907": {"vr": "OW", "BinaryLength": 24576},
        "908": {"vr": "OW", "BinaryLength": 24576},
        "909": {"vr": "OW", "BinaryLength": 24576},
        "910": {"vr": "OW", "BinaryLength": 24576},
        "911": {"vr": "OW", "BinaryLength": 24576},
        "912": {"vr": "OW", "BinaryLength": 24576},
        "913": {"vr": "OW", "BinaryLength": 24576},
        "914": {"vr": "OW", "BinaryLength": 24576},
        "915": {"vr": "OW", "BinaryLength": 24576},
        "916": {"vr": "OW", "BinaryLength": 24576},
        "917": {"vr": "OW", "BinaryLength": 24576},
        "918": {"vr": "OW", "BinaryLength": 24576},
        "919": {"vr": "OW", "BinaryLength": 24576},
        "920": {"vr": "OW", "BinaryLength": 24576},
        "921": {"vr": "OW", "BinaryLength": 24576},
        "922": {"vr": "OW", "BinaryLength": 24576},
        "923": {"vr": "OW", "BinaryLength": 24576},
        "924": {"vr": "OW", "BinaryLength": 24576},
        "925": {"vr": "OW", "BinaryLength": 24576},
        "926": {"vr": "OW", "BinaryLength": 24576},
        "927": {"vr": "OW", "BinaryLength": 24576},
        "928": {"vr": "OW", "BinaryLength": 24576},
        "929": {"vr": "OW", "BinaryLength": 24576},
        "930": {"vr": "OW", "BinaryLength": 24576},
        "931": {"vr": "OW", "BinaryLength": 24576},
        "932": {"vr": "OW", "BinaryLength": 24576},
        "933": {"vr": "OW", "BinaryLength": 24576},
        "934": {"vr": "OW", "BinaryLength": 24576},
        "935": {"vr": "OW", "BinaryLength": 24576},
        "936": {"vr": "OW", "BinaryLength": 24576},
        "937": {"vr": "OW", "BinaryLength": 24576},
        "938": {"vr": "OW", "BinaryLength": 24576},
        "939": {"vr": "OW", "BinaryLength": 24576},
        "940": {"vr": "OW", "BinaryLength": 24576},
        "941": {"vr": "OW", "BinaryLength": 24576},
        "942": {"vr": "OW", "BinaryLength": 24576},
        "943": {"vr": "OW", "BinaryLength": 24576},
        "944": {"vr": "OW", "BinaryLength": 24576},
        "945": {"vr": "OW", "BinaryLength": 24576},
        "946": {"vr": "OW", "BinaryLength": 24576},
        "947": {"vr": "OW", "BinaryLength": 24576},
        "948": {"vr": "OW", "BinaryLength": 24576},
        "949": {"vr": "OW", "BinaryLength": 24576},
        "950": {"vr": "OW", "BinaryLength": 24576},
        "951": {"vr": "OW", "BinaryLength": 24576},
        "952": {"vr": "OW", "BinaryLength": 24576},
        "953": {"vr": "OW", "BinaryLength": 24576},
        "954": {"vr": "OW", "BinaryLength": 24576},
        "955": {"vr": "OW", "BinaryLength": 24576},
        "956": {"vr": "OW", "BinaryLength": 24576},
        "957": {"vr": "OW", "BinaryLength": 24576},
        "958": {"vr": "OW", "BinaryLength": 24576},
        "959": {"vr": "OW", "BinaryLength": 24576},
        "960": {"vr": "OW", "BinaryLength": 24576},
        "961": {"vr": "OW", "BinaryLength": 24576},
        "962": {"vr": "OW", "BinaryLength": 24576},
        "963": {"vr": "OW", "BinaryLength": 24576},
        "964": {"vr": "OW", "BinaryLength": 24576},
        "965": {"vr": "OW", "BinaryLength": 24576},
        "966": {"vr": "OW", "BinaryLength": 24576},
        "967": {"vr": "OW", "BinaryLength": 24576},
        "968": {"vr": "OW", "BinaryLength": 24576},
        "969": {"vr": "OW", "BinaryLength": 24576},
        "970": {"vr": "OW", "BinaryLength": 24576},
        "971": {"vr": "OW", "BinaryLength": 24576},
        "972": {"vr": "OW", "BinaryLength": 24576},
        "973": {"vr": "OW", "BinaryLength": 24576},
        "974": {"vr": "OW", "BinaryLength": 24576},
        "975": {"vr": "OW", "BinaryLength": 24576},
        "976": {"vr": "OW", "BinaryLength": 24576},
        "977": {"vr": "OW", "BinaryLength": 24576},
        "978": {"vr": "OW", "BinaryLength": 24576},
        "979": {"vr": "OW", "BinaryLength": 24576},
        "980": {"vr": "OW", "BinaryLength": 24576},
        "981": {"vr": "OW", "BinaryLength": 24576},
        "982": {"vr": "OW", "BinaryLength": 24576},
        "983": {"vr": "OW", "BinaryLength": 24576},
        "984": {"vr": "OW", "BinaryLength": 24576},
        "985": {"vr": "OW", "BinaryLength": 24576},
        "986": {"vr": "OW", "BinaryLength": 24576},
        "987": {"vr": "OW", "BinaryLength": 24576},
        "988": {"vr": "OW", "BinaryLength": 24576},
        "989": {"vr": "OW", "BinaryLength": 24576},
        "990": {"vr": "OW", "BinaryLength": 24576},
        "991": {"vr": "OW", "BinaryLength": 24576},
        "992": {"vr": "OW", "BinaryLength": 24576},
        "993": {"vr": "OW", "BinaryLength": 24576},
        "994": {"vr": "OW", "BinaryLength": 24576},
        "995": {"vr": "OW", "BinaryLength": 24576},
        "996": {"vr": "OW", "BinaryLength": 24576},
        "997": {"vr": "OW", "BinaryLength": 24576},
        "998": {"vr": "OW", "BinaryLength": 24576},
        "999": {"vr": "OW", "BinaryLength": 24576},
        "1000": {"vr": "OW", "BinaryLength": 24576},
        "1001": {"vr": "OW", "BinaryLength": 24576},
        "1002": {"vr": "OW", "BinaryLength": 24576},
        "1003": {"vr": "OW", "BinaryLength": 24576},
        "1004": {"vr": "OW", "BinaryLength": 24576},
        "1005": {"vr": "OW", "BinaryLength": 24576},
        "1006": {"vr": "OW", "BinaryLength": 24576},
        "1007": {"vr": "OW", "BinaryLength": 24576},
        "1008": {"vr": "OW", "BinaryLength": 24576},
        "1009": {"vr": "OW", "BinaryLength": 24576},
        "1010": {"vr": "OW", "BinaryLength": 24576},
        "1011": {"vr": "OW", "BinaryLength": 24576},
        "1012": {"vr": "OW", "BinaryLength": 24576},
        "1013": {"vr": "OW", "BinaryLength": 24576},
        "1014": {"vr": "OW", "BinaryLength": 24576},
        "1015": {"vr": "OW", "BinaryLength": 24576},
        "1016": {"vr": "OW", "BinaryLength": 24576},
        "1017": {"vr": "OW", "BinaryLength": 24576},
        "1018": {"vr": "OW", "BinaryLength": 24576},
        "1019": {"vr": "OW", "BinaryLength": 24576},
        "1020": {"vr": "OW", "BinaryLength": 24576},
        "1021": {"vr": "OW", "BinaryLength": 24576},
        "1022": {"vr": "OW", "BinaryLength": 24576},
        "1023": {"vr": "OW", "BinaryLength": 24576},
        "1024": {"vr": "OW", "BinaryLength": 24576},
        "1025": {"vr": "OW", "BinaryLength": 24576},
        "1026": {"vr": "OW", "BinaryLength": 24576},
        "1027": {"vr": "OW", "BinaryLength": 24576},
        "1028": {"vr": "OW", "BinaryLength": 24576},
        "1029": {"vr": "OW", "BinaryLength": 24576},
        "1030": {"vr": "OW", "BinaryLength": 24576},
        "1031": {"vr": "OW", "BinaryLength": 24576},
        "1032": {"vr": "OW", "BinaryLength": 24576},
        "1033": {"vr": "OW", "BinaryLength": 24576},
        "1034": {"vr": "OW", "BinaryLength": 24576},
        "1035": {"vr": "OW", "BinaryLength": 24576},
        "1036": {"vr": "OW", "BinaryLength": 24576},
        "1037": {"vr": "OW", "BinaryLength": 24576},
        "1038": {"vr": "OW", "BinaryLength": 24576},
        "1039": {"vr": "OW", "BinaryLength": 24576},
        "1040": {"vr": "OW", "BinaryLength": 24576},
        "1041": {"vr": "OW", "BinaryLength": 24576},
        "1042": {"vr": "OW", "BinaryLength": 24576},
        "1043": {"vr": "OW", "BinaryLength": 24576},
        "1044": {"vr": "OW", "BinaryLength": 24576},
        "1045": {"vr": "OW", "BinaryLength": 24576},
        "1046": {"vr": "OW", "BinaryLength": 24576},
        "1047": {"vr": "OW", "BinaryLength": 24576},
        "1048": {"vr": "OW", "BinaryLength": 24576},
        "1049": {"vr": "OW", "BinaryLength": 24576},
        "1050": {"vr": "OW", "BinaryLength": 24576},
        "1051": {"vr": "OW", "BinaryLength": 24576},
        "1052": {"vr": "OW", "BinaryLength": 24576},
        "1053": {"vr": "OW", "BinaryLength": 24576},
        "1054": {"vr": "OW", "BinaryLength": 24576},
        "1055": {"vr": "OW", "BinaryLength": 24576},
        "1056": {"vr": "OW", "BinaryLength": 24576},
        "1057": {"vr": "OW", "BinaryLength": 24576},
        "1058": {"vr": "OW", "BinaryLength": 24576},
        "1059": {"vr": "OW", "BinaryLength": 24576},
        "1060": {"vr": "OW", "BinaryLength": 24576},
        "1061": {"vr": "OW", "BinaryLength": 24576},
        "1062": {"vr": "OW", "BinaryLength": 24576},
        "1063": {"vr": "OW", "BinaryLength": 24576},
        "1064": {"vr": "OW", "BinaryLength": 24576},
        "1065": {"vr": "OW", "BinaryLength": 24576},
        "1066": {"vr": "OW", "BinaryLength": 24576},
        "1067": {"vr": "OW", "BinaryLength": 24576},
        "1068": {"vr": "OW", "BinaryLength": 24576},
        "1069": {"vr": "OW", "BinaryLength": 24576},
        "1070": {"vr": "OW", "BinaryLength": 24576},
        "1071": {"vr": "OW", "BinaryLength": 24576},
        "1072": {"vr": "OW", "BinaryLength": 24576},
        "1073": {"vr": "OW", "BinaryLength": 24576},
        "1074": {"vr": "OW", "BinaryLength": 24576},
        "1075": {"vr": "OW", "BinaryLength": 24576},
        "1076": {"vr": "OW", "BinaryLength": 24576},
        "1077": {"vr": "OW", "BinaryLength": 24576},
        "1078": {"vr": "OW", "BinaryLength": 24576},
        "1079": {"vr": "OW", "BinaryLength": 24576},
        "1080": {"vr": "OW", "BinaryLength": 24576},
        "1081": {"vr": "OW", "BinaryLength": 24576},
        "1082": {"vr": "OW", "BinaryLength": 24576},
        "1083": {"vr": "OW", "BinaryLength": 24576},
        "1084": {"vr": "OW", "BinaryLength": 24576},
        "1085": {"vr": "OW", "BinaryLength": 24576},
        "1086": {"vr": "OW", "BinaryLength": 24576},
        "1087": {"vr": "OW", "BinaryLength": 24576},
        "1088": {"vr": "OW", "BinaryLength": 24576},
        "1089": {"vr": "OW", "BinaryLength": 24576},
        "1090": {"vr": "OW", "BinaryLength": 24576},
        "1091": {"vr": "OW", "BinaryLength": 24576},
        "1092": {"vr": "OW", "BinaryLength": 24576},
        "1093": {"vr": "OW", "BinaryLength": 24576},
        "1094": {"vr": "OW", "BinaryLength": 24576},
        "1095": {"vr": "OW", "BinaryLength": 24576},
        "1096": {"vr": "OW", "BinaryLength": 24576},
        "1097": {"vr": "OW", "BinaryLength": 24576},
        "1098": {"vr": "OW", "BinaryLength": 24576},
        "1099": {"vr": "OW", "BinaryLength": 24576},
        "1100": {"vr": "OW", "BinaryLength": 24576},
        "1101": {"vr": "OW", "BinaryLength": 24576},
        "1102": {"vr": "OW", "BinaryLength": 24576},
        "1103": {"vr": "OW", "BinaryLength": 24576},
        "1104": {"vr": "OW", "BinaryLength": 24576},
        "1105": {"vr": "OW", "BinaryLength": 24576},
        "1106": {"vr": "OW", "BinaryLength": 24576},
        "1107": {"vr": "OW", "BinaryLength": 24576},
        "1108": {"vr": "OW", "BinaryLength": 24576},
        "1109": {"vr": "OW", "BinaryLength": 24576},
        "1110": {"vr": "OW", "BinaryLength": 24576},
        "1111": {"vr": "OW", "BinaryLength": 24576},
        "1112": {"vr": "OW", "BinaryLength": 24576},
        "1113": {"vr": "OW", "BinaryLength": 24576},
        "1114": {"vr": "OW", "BinaryLength": 24576},
        "1115": {"vr": "OW", "BinaryLength": 24576},
        "1116": {"vr": "OW", "BinaryLength": 24576},
        "1117": {"vr": "OW", "BinaryLength": 24576},
        "1118": {"vr": "OW", "BinaryLength": 24576},
        "1119": {"vr": "OW", "BinaryLength": 24576},
        "1120": {"vr": "OW", "BinaryLength": 24576},
        "1121": {"vr": "OW", "BinaryLength": 24576},
        "1122": {"vr": "OW", "BinaryLength": 24576},
        "1123": {"vr": "OW", "BinaryLength": 24576},
        "1124": {"vr": "OW", "BinaryLength": 24576},
        "1125": {"vr": "OW", "BinaryLength": 24576},
        "1126": {"vr": "OW", "BinaryLength": 24576},
        "1127": {"vr": "OW", "BinaryLength": 24576},
        "1128": {"vr": "OW", "BinaryLength": 24576},
        "1129": {"vr": "OW", "BinaryLength": 24576},
        "1130": {"vr": "OW", "BinaryLength": 24576},
        "1131": {"vr": "OW", "BinaryLength": 24576},
        "1132": {"vr": "OW", "BinaryLength": 24576},
        "1133": {"vr": "OW", "BinaryLength": 24576},
        "1134": {"vr": "OW", "BinaryLength": 24576},
        "1135": {"vr": "OW", "BinaryLength": 24576},
        "1136": {"vr": "OW", "BinaryLength": 24576},
        "1137": {"vr": "OW", "BinaryLength": 24576},
        "1138": {"vr": "OW", "BinaryLength": 24576},
        "1139": {"vr": "OW", "BinaryLength": 24576},
        "1140": {"vr": "OW", "BinaryLength": 24576},
        "1141": {"vr": "OW", "BinaryLength": 24576},
        "1142": {"vr": "OW", "BinaryLength": 24576},
        "1143": {"vr": "OW", "BinaryLength": 24576},
        "1144": {"vr": "OW", "BinaryLength": 24576},
        "1145": {"vr": "OW", "BinaryLength": 24576},
        "1146": {"vr": "OW", "BinaryLength": 24576},
        "1147": {"vr": "OW", "BinaryLength": 24576},
        "1148": {"vr": "OW", "BinaryLength": 24576},
        "1149": {"vr": "OW", "BinaryLength": 24576},
        "1150": {"vr": "OW", "BinaryLength": 24576},
        "1151": {"vr": "OW", "BinaryLength": 24576},
        "1152": {"vr": "OW", "BinaryLength": 24576},
        "1153": {"vr": "OW", "BinaryLength": 24576},
        "1154": {"vr": "OW", "BinaryLength": 24576},
        "1155": {"vr": "OW", "BinaryLength": 24576},
        "1156": {"vr": "OW", "BinaryLength": 24576},
        "1157": {"vr": "OW", "BinaryLength": 24576},
        "1158": {"vr": "OW", "BinaryLength": 24576},
        "1159": {"vr": "OW", "BinaryLength": 24576},
        "1160": {"vr": "OW", "BinaryLength": 24576},
        "1161": {"vr": "OW", "BinaryLength": 24576},
        "1162": {"vr": "OW", "BinaryLength": 24576},
        "1163": {"vr": "OW", "BinaryLength": 24576},
        "1164": {"vr": "OW", "BinaryLength": 24576},
        "1165": {"vr": "OW", "BinaryLength": 24576},
        "1166": {"vr": "OW", "BinaryLength": 24576},
        "1167": {"vr": "OW", "BinaryLength": 24576},
        "1168": {"vr": "OW", "BinaryLength": 24576},
        "1169": {"vr": "OW", "BinaryLength": 24576},
        "1170": {"vr": "OW", "BinaryLength": 24576},
        "1171": {"vr": "OW", "BinaryLength": 24576},
        "1172": {"vr": "OW", "BinaryLength": 24576},
        "1173": {"vr": "OW", "BinaryLength": 24576},
        "1174": {"vr": "OW", "BinaryLength": 24576},
        "1175": {"vr": "OW", "BinaryLength": 24576},
        "1176": {"vr": "OW", "BinaryLength": 24576},
        "1177": {"vr": "OW", "BinaryLength": 24576},
        "1178": {"vr": "OW", "BinaryLength": 24576},
        "1179": {"vr": "OW", "BinaryLength": 24576},
        "1180": {"vr": "OW", "BinaryLength": 24576},
        "1181": {"vr": "OW", "BinaryLength": 24576},
        "1182": {"vr": "OW", "BinaryLength": 24576},
        "1183": {"vr": "OW", "BinaryLength": 24576},
        "1184": {"vr": "OW", "BinaryLength": 24576},
        "1185": {"vr": "OW", "BinaryLength": 24576},
        "1186": {"vr": "OW", "BinaryLength": 24576},
        "1187": {"vr": "OW", "BinaryLength": 24576},
        "1188": {"vr": "OW", "BinaryLength": 24576},
        "1189": {"vr": "OW", "BinaryLength": 24576},
        "1190": {"vr": "OW", "BinaryLength": 24576},
        "1191": {"vr": "OW", "BinaryLength": 24576},
        "1192": {"vr": "OW", "BinaryLength": 24576},
        "1193": {"vr": "OW", "BinaryLength": 24576},
        "1194": {"vr": "OW", "BinaryLength": 24576},
        "1195": {"vr": "OW", "BinaryLength": 24576},
        "1196": {"vr": "OW", "BinaryLength": 24576},
        "1197": {"vr": "OW", "BinaryLength": 24576},
        "1198": {"vr": "OW", "BinaryLength": 24576},
        "1199": {"vr": "OW", "BinaryLength": 24576},
        "1200": {"vr": "OW", "BinaryLength": 24576},
        "1201": {"vr": "OW", "BinaryLength": 24576},
        "1202": {"vr": "OW", "BinaryLength": 24576},
        "1203": {"vr": "OW", "BinaryLength": 24576},
        "1204": {"vr": "OW", "BinaryLength": 24576},
        "1205": {"vr": "OW", "BinaryLength": 24576},
        "1206": {"vr": "OW", "BinaryLength": 24576},
        "1207": {"vr": "OW", "BinaryLength": 24576},
        "1208": {"vr": "OW", "BinaryLength": 24576},
        "1209": {"vr": "OW", "BinaryLength": 24576},
        "1210": {"vr": "OW", "BinaryLength": 24576},
        "1211": {"vr": "OW", "BinaryLength": 24576},
        "1212": {"vr": "OW", "BinaryLength": 24576},
        "1213": {"vr": "OW", "BinaryLength": 24576},
        "1214": {"vr": "OW", "BinaryLength": 24576},
        "1215": {"vr": "OW", "BinaryLength": 24576},
        "1216": {"vr": "OW", "BinaryLength": 24576},
        "1217": {"vr": "OW", "BinaryLength": 24576},
        "1218": {"vr": "OW", "BinaryLength": 24576},
        "1219": {"vr": "OW", "BinaryLength": 24576},
        "1220": {"vr": "OW", "BinaryLength": 24576},
        "1221": {"vr": "OW", "BinaryLength": 24576},
        "1222": {"vr": "OW", "BinaryLength": 24576},
        "1223": {"vr": "OW", "BinaryLength": 24576},
        "1224": {"vr": "OW", "BinaryLength": 24576},
        "1225": {"vr": "OW", "BinaryLength": 24576},
        "1226": {"vr": "OW", "BinaryLength": 24576},
        "1227": {"vr": "OW", "BinaryLength": 24576},
        "1228": {"vr": "OW", "BinaryLength": 24576},
        "1229": {"vr": "OW", "BinaryLength": 24576},
        "1230": {"vr": "OW", "BinaryLength": 24576},
        "1231": {"vr": "OW", "BinaryLength": 24576},
        "1232": {"vr": "OW", "BinaryLength": 24576},
        "1233": {"vr": "OW", "BinaryLength": 24576},
        "1234": {"vr": "OW", "BinaryLength": 24576},
        "1235": {"vr": "OW", "BinaryLength": 24576},
        "1236": {"vr": "OW", "BinaryLength": 24576},
        "1237": {"vr": "OW", "BinaryLength": 24576},
        "1238": {"vr": "OW", "BinaryLength": 24576},
        "1239": {"vr": "OW", "BinaryLength": 24576},
        "1240": {"vr": "OW", "BinaryLength": 24576},
        "1241": {"vr": "OW", "BinaryLength": 24576},
        "1242": {"vr": "OW", "BinaryLength": 24576},
        "1243": {"vr": "OW", "BinaryLength": 24576},
        "1244": {"vr": "OW", "BinaryLength": 24576},
        "1245": {"vr": "OW", "BinaryLength": 24576},
        "1246": {"vr": "OW", "BinaryLength": 24576},
        "1247": {"vr": "OW", "BinaryLength": 24576},
        "1248": {"vr": "OW", "BinaryLength": 24576},
        "1249": {"vr": "OW", "BinaryLength": 24576},
        "1250": {"vr": "OW", "BinaryLength": 24576},
        "1251": {"vr": "OW", "BinaryLength": 24576},
        "1252": {"vr": "OW", "BinaryLength": 24576},
        "1253": {"vr": "OW", "BinaryLength": 24576},
        "1254": {"vr": "OW", "BinaryLength": 24576},
        "1255": {"vr": "OW", "BinaryLength": 24576},
        "1256": {"vr": "OW", "BinaryLength": 24576},
        "1257": {"vr": "OW", "BinaryLength": 24576},
        "1258": {"vr": "OW", "BinaryLength": 24576},
        "1259": {"vr": "OW", "BinaryLength": 24576},
        "1260": {"vr": "OW", "BinaryLength": 24576},
        "1261": {"vr": "OW", "BinaryLength": 24576},
        "1262": {"vr": "OW", "BinaryLength": 24576},
        "1263": {"vr": "OW", "BinaryLength": 24576},
        "1264": {"vr": "OW", "BinaryLength": 24576},
        "1265": {"vr": "OW", "BinaryLength": 24576},
        "1266": {"vr": "OW", "BinaryLength": 24576},
        "1267": {"vr": "OW", "BinaryLength": 24576},
        "1268": {"vr": "OW", "BinaryLength": 24576},
        "1269": {"vr": "OW", "BinaryLength": 24576},
        "1270": {"vr": "OW", "BinaryLength": 24576},
        "1271": {"vr": "OW", "BinaryLength": 24576},
        "1272": {"vr": "OW", "BinaryLength": 24576},
        "1273": {"vr": "OW", "BinaryLength": 24576},
        "1274": {"vr": "OW", "BinaryLength": 24576},
        "1275": {"vr": "OW", "BinaryLength": 24576},
        "1276": {"vr": "OW", "BinaryLength": 24576},
        "1277": {"vr": "OW", "BinaryLength": 24576},
        "1278": {"vr": "OW", "BinaryLength": 24576},
        "1279": {"vr": "OW", "BinaryLength": 24576},
        "1280": {"vr": "OW", "BinaryLength": 24576},
        "1281": {"vr": "OW", "BinaryLength": 24576},
        "1282": {"vr": "OW", "BinaryLength": 24576},
        "1283": {"vr": "OW", "BinaryLength": 24576},
        "1284": {"vr": "OW", "BinaryLength": 24576},
        "1285": {"vr": "OW", "BinaryLength": 24576},
        "1286": {"vr": "OW", "BinaryLength": 24576},
        "1287": {"vr": "OW", "BinaryLength": 24576},
        "1288": {"vr": "OW", "BinaryLength": 24576},
        "1289": {"vr": "OW", "BinaryLength": 24576},
        "1290": {"vr": "OW", "BinaryLength": 24576},
        "1291": {"vr": "OW", "BinaryLength": 24576},
        "1292": {"vr": "OW", "BinaryLength": 24576},
        "1293": {"vr": "OW", "BinaryLength": 24576},
        "1294": {"vr": "OW", "BinaryLength": 24576},
        "1295": {"vr": "OW", "BinaryLength": 24576},
        "1296": {"vr": "OW", "BinaryLength": 24576},
        "1297": {"vr": "OW", "BinaryLength": 24576},
        "1298": {"vr": "OW", "BinaryLength": 24576},
        "1299": {"vr": "OW", "BinaryLength": 24576},
        "1300": {"vr": "OW", "BinaryLength": 24576},
        "1301": {"vr": "OW", "BinaryLength": 24576},
        "1302": {"vr": "OW", "BinaryLength": 24576},
        "1303": {"vr": "OW", "BinaryLength": 24576},
        "1304": {"vr": "OW", "BinaryLength": 24576},
        "1305": {"vr": "OW", "BinaryLength": 24576},
        "1306": {"vr": "OW", "BinaryLength": 24576},
        "1307": {"vr": "OW", "BinaryLength": 24576},
        "1308": {"vr": "OW", "BinaryLength": 24576},
        "1309": {"vr": "OW", "BinaryLength": 24576},
        "1310": {"vr": "OW", "BinaryLength": 24576},
        "1311": {"vr": "OW", "BinaryLength": 24576},
        "1312": {"vr": "OW", "BinaryLength": 24576},
        "1313": {"vr": "OW", "BinaryLength": 24576},
        "1314": {"vr": "OW", "BinaryLength": 24576},
        "1315": {"vr": "OW", "BinaryLength": 24576},
        "1316": {"vr": "OW", "BinaryLength": 24576},
        "1317": {"vr": "OW", "BinaryLength": 24576},
        "1318": {"vr": "OW", "BinaryLength": 24576},
        "1319": {"vr": "OW", "BinaryLength": 24576},
        "1320": {"vr": "OW", "BinaryLength": 24576},
        "1321": {"vr": "OW", "BinaryLength": 24576},
        "1322": {"vr": "OW", "BinaryLength": 24576},
        "1323": {"vr": "OW", "BinaryLength": 24576},
        "1324": {"vr": "OW", "BinaryLength": 24576},
        "1325": {"vr": "OW", "BinaryLength": 24576},
        "1326": {"vr": "OW", "BinaryLength": 24576},
        "1327": {"vr": "OW", "BinaryLength": 24576},
        "1328": {"vr": "OW", "BinaryLength": 24576},
        "1329": {"vr": "OW", "BinaryLength": 24576},
        "1330": {"vr": "OW", "BinaryLength": 24576},
        "1331": {"vr": "OW", "BinaryLength": 24576},
        "1332": {"vr": "OW", "BinaryLength": 24576},
        "1333": {"vr": "OW", "BinaryLength": 24576},
        "1334": {"vr": "OW", "BinaryLength": 24576},
        "1335": {"vr": "OW", "BinaryLength": 24576},
        "1336": {"vr": "OW", "BinaryLength": 24576},
        "1337": {"vr": "OW", "BinaryLength": 24576},
        "1338": {"vr": "OW", "BinaryLength": 24576},
        "1339": {"vr": "OW", "BinaryLength": 24576},
        "1340": {"vr": "OW", "BinaryLength": 24576},
        "1341": {"vr": "OW", "BinaryLength": 24576},
        "1342": {"vr": "OW", "BinaryLength": 24576},
        "1343": {"vr": "OW", "BinaryLength": 24576},
        "1344": {"vr": "OW", "BinaryLength": 24576},
        "1345": {"vr": "OW", "BinaryLength": 24576},
        "1346": {"vr": "OW", "BinaryLength": 24576},
        "1347": {"vr": "OW", "BinaryLength": 24576},
        "1348": {"vr": "OW", "BinaryLength": 24576},
        "1349": {"vr": "OW", "BinaryLength": 24576},
        "1350": {"vr": "OW", "BinaryLength": 24576},
        "1351": {"vr": "OW", "BinaryLength": 24576},
        "1352": {"vr": "OW", "BinaryLength": 24576},
        "1353": {"vr": "OW", "BinaryLength": 24576},
        "1354": {"vr": "OW", "BinaryLength": 24576},
        "1355": {"vr": "OW", "BinaryLength": 24576},
        "1356": {"vr": "OW", "BinaryLength": 24576},
        "1357": {"vr": "OW", "BinaryLength": 24576},
        "1358": {"vr": "OW", "BinaryLength": 24576},
        "1359": {"vr": "OW", "BinaryLength": 24576},
        "1360": {"vr": "OW", "BinaryLength": 24576},
        "1361": {"vr": "OW", "BinaryLength": 24576},
        "1362": {"vr": "OW", "BinaryLength": 24576},
        "1363": {"vr": "OW", "BinaryLength": 24576},
        "1364": {"vr": "OW", "BinaryLength": 24576},
        "1365": {"vr": "OW", "BinaryLength": 24576},
        "1366": {"vr": "OW", "BinaryLength": 24576},
        "1367": {"vr": "OW", "BinaryLength": 24576},
        "1368": {"vr": "OW", "BinaryLength": 24576},
        "1369": {"vr": "OW", "BinaryLength": 24576},
        "1370": {"vr": "OW", "BinaryLength": 24576},
        "1371": {"vr": "OW", "BinaryLength": 24576},
        "1372": {"vr": "OW", "BinaryLength": 24576},
        "1373": {"vr": "OW", "BinaryLength": 24576},
        "1374": {"vr": "OW", "BinaryLength": 24576},
        "1375": {"vr": "OW", "BinaryLength": 24576},
        "1376": {"vr": "OW", "BinaryLength": 24576},
        "1377": {"vr": "OW", "BinaryLength": 24576},
        "1378": {"vr": "OW", "BinaryLength": 24576},
        "1379": {"vr": "OW", "BinaryLength": 24576},
        "1380": {"vr": "OW", "BinaryLength": 24576},
        "1381": {"vr": "OW", "BinaryLength": 24576},
        "1382": {"vr": "OW", "BinaryLength": 24576},
        "1383": {"vr": "OW", "BinaryLength": 24576},
        "1384": {"vr": "OW", "BinaryLength": 24576},
        "1385": {"vr": "OW", "BinaryLength": 24576},
        "1386": {"vr": "OW", "BinaryLength": 24576},
        "1387": {"vr": "OW", "BinaryLength": 24576},
        "1388": {"vr": "OW", "BinaryLength": 24576},
        "1389": {"vr": "OW", "BinaryLength": 24576},
        "1390": {"vr": "OW", "BinaryLength": 24576},
        "1391": {"vr": "OW", "BinaryLength": 24576},
        "1392": {"vr": "OW", "BinaryLength": 24576},
        "1393": {"vr": "OW", "BinaryLength": 24576},
        "1394": {"vr": "OW", "BinaryLength": 24576},
        "1395": {"vr": "OW", "BinaryLength": 24576},
        "1396": {"vr": "OW", "BinaryLength": 24576},
        "1397": {"vr": "OW", "BinaryLength": 24576},
        "1398": {"vr": "OW", "BinaryLength": 24576},
        "1399": {"vr": "OW", "BinaryLength": 24576},
        "1400": {"vr": "OW", "BinaryLength": 24576},
        "1401": {"vr": "OW", "BinaryLength": 24576},
        "1402": {"vr": "OW", "BinaryLength": 24576},
        "1403": {"vr": "OW", "BinaryLength": 24576},
        "1404": {"vr": "OW", "BinaryLength": 24576},
        "1405": {"vr": "OW", "BinaryLength": 24576},
        "1406": {"vr": "OW", "BinaryLength": 24576},
        "1407": {"vr": "OW", "BinaryLength": 24576},
        "1408": {"vr": "OW", "BinaryLength": 24576},
        "1409": {"vr": "OW", "BinaryLength": 24576},
        "1410": {"vr": "OW", "BinaryLength": 24576},
        "1411": {"vr": "OW", "BinaryLength": 24576},
        "1412": {"vr": "OW", "BinaryLength": 24576},
        "1413": {"vr": "OW", "BinaryLength": 24576},
        "1414": {"vr": "OW", "BinaryLength": 24576},
        "1415": {"vr": "OW", "BinaryLength": 24576},
        "1416": {"vr": "OW", "BinaryLength": 24576},
        "1417": {"vr": "OW", "BinaryLength": 24576},
        "1418": {"vr": "OW", "BinaryLength": 24576},
        "1419": {"vr": "OW", "BinaryLength": 24576},
        "1420": {"vr": "OW", "BinaryLength": 24576},
        "1421": {"vr": "OW", "BinaryLength": 24576},
        "1422": {"vr": "OW", "BinaryLength": 24576},
        "1423": {"vr": "OW", "BinaryLength": 24576},
        "1424": {"vr": "OW", "BinaryLength": 24576},
        "1425": {"vr": "OW", "BinaryLength": 24576},
        "1426": {"vr": "OW", "BinaryLength": 24576},
        "1427": {"vr": "OW", "BinaryLength": 24576},
        "1428": {"vr": "OW", "BinaryLength": 24576},
        "1429": {"vr": "OW", "BinaryLength": 24576},
        "1430": {"vr": "OW", "BinaryLength": 24576},
        "1431": {"vr": "OW", "BinaryLength": 24576},
        "1432": {"vr": "OW", "BinaryLength": 24576},
        "1433": {"vr": "OW", "BinaryLength": 24576},
        "1434": {"vr": "OW", "BinaryLength": 24576},
        "1435": {"vr": "OW", "BinaryLength": 24576},
        "1436": {"vr": "OW", "BinaryLength": 24576},
        "1437": {"vr": "OW", "BinaryLength": 24576},
        "1438": {"vr": "OW", "BinaryLength": 24576},
        "1439": {"vr": "OW", "BinaryLength": 24576},
        "1440": {"vr": "OW", "BinaryLength": 24576},
        "1441": {"vr": "OW", "BinaryLength": 24576},
        "1442": {"vr": "OW", "BinaryLength": 24576},
        "1443": {"vr": "OW", "BinaryLength": 24576},
        "1444": {"vr": "OW", "BinaryLength": 24576},
        "1445": {"vr": "OW", "BinaryLength": 24576},
        "1446": {"vr": "OW", "BinaryLength": 24576},
        "1447": {"vr": "OW", "BinaryLength": 24576},
        "1448": {"vr": "OW", "BinaryLength": 24576},
        "1449": {"vr": "OW", "BinaryLength": 24576},
        "1450": {"vr": "OW", "BinaryLength": 24576},
        "1451": {"vr": "OW", "BinaryLength": 24576},
        "1452": {"vr": "OW", "BinaryLength": 24576},
        "1453": {"vr": "OW", "BinaryLength": 24576},
        "1454": {"vr": "OW", "BinaryLength": 24576},
        "1455": {"vr": "OW", "BinaryLength": 24576},
        "1456": {"vr": "OW", "BinaryLength": 24576},
        "1457": {"vr": "OW", "BinaryLength": 24576},
        "1458": {"vr": "OW", "BinaryLength": 24576},
        "1459": {"vr": "OW", "BinaryLength": 24576},
        "1460": {"vr": "OW", "BinaryLength": 24576},
        "1461": {"vr": "OW", "BinaryLength": 24576},
        "1462": {"vr": "OW", "BinaryLength": 24576},
        "1463": {"vr": "OW", "BinaryLength": 24576},
        "1464": {"vr": "OW", "BinaryLength": 24576},
        "1465": {"vr": "OW", "BinaryLength": 24576},
        "1466": {"vr": "OW", "BinaryLength": 24576},
        "1467": {"vr": "OW", "BinaryLength": 24576},
        "1468": {"vr": "OW", "BinaryLength": 24576},
        "1469": {"vr": "OW", "BinaryLength": 24576},
        "1470": {"vr": "OW", "BinaryLength": 24576},
        "1471": {"vr": "OW", "BinaryLength": 24576},
        "1472": {"vr": "OW", "BinaryLength": 24576},
        "1473": {"vr": "OW", "BinaryLength": 24576},
        "1474": {"vr": "OW", "BinaryLength": 24576},
        "1475": {"vr": "OW", "BinaryLength": 24576},
        "1476": {"vr": "OW", "BinaryLength": 24576},
        "1477": {"vr": "OW", "BinaryLength": 24576},
        "1478": {"vr": "OW", "BinaryLength": 24576},
        "1479": {"vr": "OW", "BinaryLength": 24576},
        "1480": {"vr": "OW", "BinaryLength": 24576},
        "1481": {"vr": "OW", "BinaryLength": 24576},
        "1482": {"vr": "OW", "BinaryLength": 24576},
        "1483": {"vr": "OW", "BinaryLength": 24576},
        "1484": {"vr": "OW", "BinaryLength": 24576},
        "1485": {"vr": "OW", "BinaryLength": 24576},
        "1486": {"vr": "OW", "BinaryLength": 24576},
        "1487": {"vr": "OW", "BinaryLength": 24576},
        "1488": {"vr": "OW", "BinaryLength": 24576},
        "1489": {"vr": "OW", "BinaryLength": 24576},
        "1490": {"vr": "OW", "BinaryLength": 24576},
        "1491": {"vr": "OW", "BinaryLength": 24576},
        "1492": {"vr": "OW", "BinaryLength": 24576},
        "1493": {"vr": "OW", "BinaryLength": 24576},
        "1494": {"vr": "OW", "BinaryLength": 24576},
        "1495": {"vr": "OW", "BinaryLength": 24576},
        "1496": {"vr": "OW", "BinaryLength": 24576},
        "1497": {"vr": "OW", "BinaryLength": 24576},
        "1498": {"vr": "OW", "BinaryLength": 24576},
        "1499": {"vr": "OW", "BinaryLength": 24576},
        "1500": {"vr": "OW", "BinaryLength": 24576},
        "1501": {"vr": "OW", "BinaryLength": 24576},
        "1502": {"vr": "OW", "BinaryLength": 24576},
        "1503": {"vr": "OW", "BinaryLength": 24576},
        "1504": {"vr": "OW", "BinaryLength": 24576},
        "1505": {"vr": "OW", "BinaryLength": 24576},
        "1506": {"vr": "OW", "BinaryLength": 24576},
        "1507": {"vr": "OW", "BinaryLength": 24576},
        "1508": {"vr": "OW", "BinaryLength": 24576},
        "1509": {"vr": "OW", "BinaryLength": 24576},
        "1510": {"vr": "OW", "BinaryLength": 24576},
        "1511": {"vr": "OW", "BinaryLength": 24576},
        "1512": {"vr": "OW", "BinaryLength": 24576},
        "1513": {"vr": "OW", "BinaryLength": 24576},
        "1514": {"vr": "OW", "BinaryLength": 24576},
        "1515": {"vr": "OW", "BinaryLength": 24576},
        "1516": {"vr": "OW", "BinaryLength": 24576},
        "1517": {"vr": "OW", "BinaryLength": 24576},
        "1518": {"vr": "OW", "BinaryLength": 24576},
        "1519": {"vr": "OW", "BinaryLength": 24576},
        "1520": {"vr": "OW", "BinaryLength": 24576},
        "1521": {"vr": "OW", "BinaryLength": 24576},
        "1522": {"vr": "OW", "BinaryLength": 24576},
        "1523": {"vr": "OW", "BinaryLength": 24576},
        "1524": {"vr": "OW", "BinaryLength": 24576},
        "1525": {"vr": "OW", "BinaryLength": 24576},
        "1526": {"vr": "OW", "BinaryLength": 24576},
        "1527": {"vr": "OW", "BinaryLength": 24576},
        "1528": {"vr": "OW", "BinaryLength": 24576},
        "1529": {"vr": "OW", "BinaryLength": 24576},
        "1530": {"vr": "OW", "BinaryLength": 24576},
        "1531": {"vr": "OW", "BinaryLength": 24576},
        "1532": {"vr": "OW", "BinaryLength": 24576},
        "1533": {"vr": "OW", "BinaryLength": 24576},
        "1534": {"vr": "OW", "BinaryLength": 24576},
        "1535": {"vr": "OW", "BinaryLength": 24576},
        "1536": {"vr": "OW", "BinaryLength": 24576},
        "1537": {"vr": "OW", "BinaryLength": 24576},
        "1538": {"vr": "OW", "BinaryLength": 24576},
        "1539": {"vr": "OW", "BinaryLength": 24576},
        "1540": {"vr": "OW", "BinaryLength": 24576},
        "1541": {"vr": "OW", "BinaryLength": 24576},
        "1542": {"vr": "OW", "BinaryLength": 24576},
        "1543": {"vr": "OW", "BinaryLength": 24576},
        "1544": {"vr": "OW", "BinaryLength": 24576},
        "1545": {"vr": "OW", "BinaryLength": 24576},
        "1546": {"vr": "OW", "BinaryLength": 24576},
        "1547": {"vr": "OW", "BinaryLength": 24576},
        "1548": {"vr": "OW", "BinaryLength": 24576},
        "1549": {"vr": "OW", "BinaryLength": 24576},
        "1550": {"vr": "OW", "BinaryLength": 24576},
        "1551": {"vr": "OW", "BinaryLength": 24576},
        "1552": {"vr": "OW", "BinaryLength": 24576},
        "1553": {"vr": "OW", "BinaryLength": 24576},
        "1554": {"vr": "OW", "BinaryLength": 24576},
        "1555": {"vr": "OW", "BinaryLength": 24576},
        "1556": {"vr": "OW", "BinaryLength": 24576},
        "1557": {"vr": "OW", "BinaryLength": 24576},
        "1558": {"vr": "OW", "BinaryLength": 24576},
        "1559": {"vr": "OW", "BinaryLength": 24576},
        "1560": {"vr": "OW", "BinaryLength": 24576},
        "1561": {"vr": "OW", "BinaryLength": 24576},
        "1562": {"vr": "OW", "BinaryLength": 24576},
        "1563": {"vr": "OW", "BinaryLength": 24576},
        "1564": {"vr": "OW", "BinaryLength": 24576},
        "1565": {"vr": "OW", "BinaryLength": 24576},
        "1566": {"vr": "OW", "BinaryLength": 24576},
        "1567": {"vr": "OW", "BinaryLength": 24576},
        "1568": {"vr": "OW", "BinaryLength": 24576},
        "1569": {"vr": "OW", "BinaryLength": 24576},
        "1570": {"vr": "OW", "BinaryLength": 24576},
        "1571": {"vr": "OW", "BinaryLength": 24576},
        "1572": {"vr": "OW", "BinaryLength": 24576},
        "1573": {"vr": "OW", "BinaryLength": 24576},
        "1574": {"vr": "OW", "BinaryLength": 24576},
        "1575": {"vr": "OW", "BinaryLength": 24576},
        "1576": {"vr": "OW", "BinaryLength": 24576},
        "1577": {"vr": "OW", "BinaryLength": 24576},
        "1578": {"vr": "OW", "BinaryLength": 24576},
        "1579": {"vr": "OW", "BinaryLength": 24576},
        "1580": {"vr": "OW", "BinaryLength": 24576},
        "1581": {"vr": "OW", "BinaryLength": 24576},
        "1582": {"vr": "OW", "BinaryLength": 24576},
        "1583": {"vr": "OW", "BinaryLength": 24576},
        "1584": {"vr": "OW", "BinaryLength": 24576},
        "1585": {"vr": "OW", "BinaryLength": 24576},
        "1586": {"vr": "OW", "BinaryLength": 24576},
        "1587": {"vr": "OW", "BinaryLength": 24576},
        "1588": {"vr": "OW", "BinaryLength": 24576},
        "1589": {"vr": "OW", "BinaryLength": 24576},
        "1590": {"vr": "OW", "BinaryLength": 24576},
        "1591": {"vr": "OW", "BinaryLength": 24576},
        "1592": {"vr": "OW", "BinaryLength": 24576},
        "1593": {"vr": "OW", "BinaryLength": 24576},
        "1594": {"vr": "OW", "BinaryLength": 24576},
        "1595": {"vr": "OW", "BinaryLength": 24576},
        "1596": {"vr": "OW", "BinaryLength": 24576},
        "1597": {"vr": "OW", "BinaryLength": 24576},
        "1598": {"vr": "OW", "BinaryLength": 24576},
        "1599": {"vr": "OW", "BinaryLength": 24576},
        "1600": {"vr": "OW", "BinaryLength": 24576},
        "1601": {"vr": "OW", "BinaryLength": 24576},
        "1602": {"vr": "OW", "BinaryLength": 24576},
        "1603": {"vr": "OW", "BinaryLength": 24576},
        "1604": {"vr": "OW", "BinaryLength": 24576},
        "1605": {"vr": "OW", "BinaryLength": 24576},
        "1606": {"vr": "OW", "BinaryLength": 24576},
        "1607": {"vr": "OW", "BinaryLength": 24576},
        "1608": {"vr": "OW", "BinaryLength": 24576},
        "1609": {"vr": "OW", "BinaryLength": 24576},
        "1610": {"vr": "OW", "BinaryLength": 24576},
        "1611": {"vr": "OW", "BinaryLength": 24576},
        "1612": {"vr": "OW", "BinaryLength": 24576},
        "1613": {"vr": "OW", "BinaryLength": 24576},
        "1614": {"vr": "OW", "BinaryLength": 24576},
        "1615": {"vr": "OW", "BinaryLength": 24576},
        "1616": {"vr": "OW", "BinaryLength": 24576},
        "1617": {"vr": "OW", "BinaryLength": 24576},
        "1618": {"vr": "OW", "BinaryLength": 24576},
        "1619": {"vr": "OW", "BinaryLength": 24576},
        "1620": {"vr": "OW", "BinaryLength": 24576},
        "1621": {"vr": "OW", "BinaryLength": 24576},
        "1622": {"vr": "OW", "BinaryLength": 24576},
        "1623": {"vr": "OW", "BinaryLength": 24576},
        "1624": {"vr": "OW", "BinaryLength": 24576},
        "1625": {"vr": "OW", "BinaryLength": 24576},
        "1626": {"vr": "OW", "BinaryLength": 24576},
        "1627": {"vr": "OW", "BinaryLength": 24576},
        "1628": {"vr": "OW", "BinaryLength": 24576},
        "1629": {"vr": "OW", "BinaryLength": 24576},
        "1630": {"vr": "OW", "BinaryLength": 24576},
        "1631": {"vr": "OW", "BinaryLength": 24576},
        "1632": {"vr": "OW", "BinaryLength": 24576},
        "1633": {"vr": "OW", "BinaryLength": 24576},
        "1634": {"vr": "OW", "BinaryLength": 24576},
        "1635": {"vr": "OW", "BinaryLength": 24576},
        "1636": {"vr": "OW", "BinaryLength": 24576},
        "1637": {"vr": "OW", "BinaryLength": 24576},
        "1638": {"vr": "OW", "BinaryLength": 24576},
        "1639": {"vr": "OW", "BinaryLength": 24576},
        "1640": {"vr": "OW", "BinaryLength": 24576},
        "1641": {"vr": "OW", "BinaryLength": 24576},
        "1642": {"vr": "OW", "BinaryLength": 24576},
        "1643": {"vr": "OW", "BinaryLength": 24576},
        "1644": {"vr": "OW", "BinaryLength": 24576},
        "1645": {"vr": "OW", "BinaryLength": 24576},
        "1646": {"vr": "OW", "BinaryLength": 24576},
        "1647": {"vr": "OW", "BinaryLength": 24576},
        "1648": {"vr": "OW", "BinaryLength": 24576},
        "1649": {"vr": "OW", "BinaryLength": 24576},
        "1650": {"vr": "OW", "BinaryLength": 24576},
        "1651": {"vr": "OW", "BinaryLength": 24576},
        "1652": {"vr": "OW", "BinaryLength": 24576},
        "1653": {"vr": "OW", "BinaryLength": 24576},
        "1654": {"vr": "OW", "BinaryLength": 24576},
        "1655": {"vr": "OW", "BinaryLength": 24576},
        "1656": {"vr": "OW", "BinaryLength": 24576},
        "1657": {"vr": "OW", "BinaryLength": 24576},
        "1658": {"vr": "OW", "BinaryLength": 24576},
        "1659": {"vr": "OW", "BinaryLength": 24576},
        "1660": {"vr": "OW", "BinaryLength": 24576},
        "1661": {"vr": "OW", "BinaryLength": 24576},
        "1662": {"vr": "OW", "BinaryLength": 24576},
        "1663": {"vr": "OW", "BinaryLength": 24576},
        "1664": {"vr": "OW", "BinaryLength": 24576},
        "1665": {"vr": "OW", "BinaryLength": 24576},
        "1666": {"vr": "OW", "BinaryLength": 24576},
        "1667": {"vr": "OW", "BinaryLength": 24576},
        "1668": {"vr": "OW", "BinaryLength": 24576},
        "1669": {"vr": "OW", "BinaryLength": 24576},
        "1670": {"vr": "OW", "BinaryLength": 24576},
        "1671": {"vr": "OW", "BinaryLength": 24576},
        "1672": {"vr": "OW", "BinaryLength": 24576},
        "1673": {"vr": "OW", "BinaryLength": 24576},
        "1674": {"vr": "OW", "BinaryLength": 24576},
        "1675": {"vr": "OW", "BinaryLength": 24576},
        "1676": {"vr": "OW", "BinaryLength": 24576},
        "1677": {"vr": "OW", "BinaryLength": 24576},
        "1678": {"vr": "OW", "BinaryLength": 24576},
        "1679": {"vr": "OW", "BinaryLength": 24576},
        "1680": {"vr": "OW", "BinaryLength": 24576},
        "1681": {"vr": "OW", "BinaryLength": 24576},
        "1682": {"vr": "OW", "BinaryLength": 24576},
        "1683": {"vr": "OW", "BinaryLength": 24576},
        "1684": {"vr": "OW", "BinaryLength": 24576},
        "1685": {"vr": "OW", "BinaryLength": 24576},
        "1686": {"vr": "OW", "BinaryLength": 24576},
        "1687": {"vr": "OW", "BinaryLength": 24576},
        "1688": {"vr": "OW", "BinaryLength": 24576},
        "1689": {"vr": "OW", "BinaryLength": 24576},
        "1690": {"vr": "OW", "BinaryLength": 24576},
        "1691": {"vr": "OW", "BinaryLength": 24576},
        "1692": {"vr": "OW", "BinaryLength": 24576},
        "1693": {"vr": "OW", "BinaryLength": 24576},
        "1694": {"vr": "OW", "BinaryLength": 24576},
        "1695": {"vr": "OW", "BinaryLength": 24576},
        "1696": {"vr": "OW", "BinaryLength": 24576},
        "1697": {"vr": "OW", "BinaryLength": 24576},
        "1698": {"vr": "OW", "BinaryLength": 24576},
        "1699": {"vr": "OW", "BinaryLength": 24576},
        "1700": {"vr": "OW", "BinaryLength": 24576},
        "1701": {"vr": "OW", "BinaryLength": 24576},
        "1702": {"vr": "OW", "BinaryLength": 24576},
        "1703": {"vr": "OW", "BinaryLength": 24576},
        "1704": {"vr": "OW", "BinaryLength": 24576},
        "1705": {"vr": "OW", "BinaryLength": 24576},
        "1706": {"vr": "OW", "BinaryLength": 24576},
        "1707": {"vr": "OW", "BinaryLength": 24576},
        "1708": {"vr": "OW", "BinaryLength": 24576},
        "1709": {"vr": "OW", "BinaryLength": 24576},
        "1710": {"vr": "OW", "BinaryLength": 24576},
        "1711": {"vr": "OW", "BinaryLength": 24576},
        "1712": {"vr": "OW", "BinaryLength": 24576},
        "1713": {"vr": "OW", "BinaryLength": 24576},
        "1714": {"vr": "OW", "BinaryLength": 24576},
        "1715": {"vr": "OW", "BinaryLength": 24576},
        "1716": {"vr": "OW", "BinaryLength": 24576},
        "1717": {"vr": "OW", "BinaryLength": 24576},
        "1718": {"vr": "OW", "BinaryLength": 24576},
        "1719": {"vr": "OW", "BinaryLength": 24576},
        "1720": {"vr": "OW", "BinaryLength": 24576},
        "1721": {"vr": "OW", "BinaryLength": 24576},
        "1722": {"vr": "OW", "BinaryLength": 24576},
        "1723": {"vr": "OW", "BinaryLength": 24576},
        "1724": {"vr": "OW", "BinaryLength": 24576},
        "1725": {"vr": "OW", "BinaryLength": 24576},
        "1726": {"vr": "OW", "BinaryLength": 24576},
        "1727": {"vr": "OW", "BinaryLength": 24576},
        "1728": {"vr": "OW", "BinaryLength": 24576},
        "1729": {"vr": "OW", "BinaryLength": 24576},
        "1730": {"vr": "OW", "BinaryLength": 24576},
        "1731": {"vr": "OW", "BinaryLength": 24576},
        "1732": {"vr": "OW", "BinaryLength": 24576},
        "1733": {"vr": "OW", "BinaryLength": 24576},
        "1734": {"vr": "OW", "BinaryLength": 24576},
        "1735": {"vr": "OW", "BinaryLength": 24576},
        "1736": {"vr": "OW", "BinaryLength": 24576},
        "1737": {"vr": "OW", "BinaryLength": 24576},
        "1738": {"vr": "OW", "BinaryLength": 24576},
        "1739": {"vr": "OW", "BinaryLength": 24576},
        "1740": {"vr": "OW", "BinaryLength": 24576},
        "1741": {"vr": "OW", "BinaryLength": 24576},
        "1742": {"vr": "OW", "BinaryLength": 24576},
        "1743": {"vr": "OW", "BinaryLength": 24576},
        "1744": {"vr": "OW", "BinaryLength": 24576},
        "1745": {"vr": "OW", "BinaryLength": 24576},
        "1746": {"vr": "OW", "BinaryLength": 24576},
        "1747": {"vr": "OW", "BinaryLength": 24576},
        "1748": {"vr": "OW", "BinaryLength": 24576},
        "1749": {"vr": "OW", "BinaryLength": 24576},
        "1750": {"vr": "OW", "BinaryLength": 24576},
        "1751": {"vr": "OW", "BinaryLength": 24576},
        "1752": {"vr": "OW", "BinaryLength": 24576},
        "1753": {"vr": "OW", "BinaryLength": 24576},
        "1754": {"vr": "OW", "BinaryLength": 24576},
        "1755": {"vr": "OW", "BinaryLength": 24576},
        "1756": {"vr": "OW", "BinaryLength": 24576},
        "1757": {"vr": "OW", "BinaryLength": 24576},
        "1758": {"vr": "OW", "BinaryLength": 24576},
        "1759": {"vr": "OW", "BinaryLength": 24576},
        "1760": {"vr": "OW", "BinaryLength": 24576},
        "1761": {"vr": "OW", "BinaryLength": 24576},
        "1762": {"vr": "OW", "BinaryLength": 24576},
        "1763": {"vr": "OW", "BinaryLength": 24576},
        "1764": {"vr": "OW", "BinaryLength": 24576},
        "1765": {"vr": "OW", "BinaryLength": 24576},
        "1766": {"vr": "OW", "BinaryLength": 24576},
        "1767": {"vr": "OW", "BinaryLength": 24576},
        "1768": {"vr": "OW", "BinaryLength": 24576},
        "1769": {"vr": "OW", "BinaryLength": 24576},
        "1770": {"vr": "OW", "BinaryLength": 24576},
        "1771": {"vr": "OW", "BinaryLength": 24576},
        "1772": {"vr": "OW", "BinaryLength": 24576},
        "1773": {"vr": "OW", "BinaryLength": 24576},
        "1774": {"vr": "OW", "BinaryLength": 24576},
        "1775": {"vr": "OW", "BinaryLength": 24576},
        "1776": {"vr": "OW", "BinaryLength": 24576},
        "1777": {"vr": "OW", "BinaryLength": 24576},
        "1778": {"vr": "OW", "BinaryLength": 24576},
        "1779": {"vr": "OW", "BinaryLength": 24576},
        "1780": {"vr": "OW", "BinaryLength": 24576},
        "1781": {"vr": "OW", "BinaryLength": 24576},
        "1782": {"vr": "OW", "BinaryLength": 24576},
        "1783": {"vr": "OW", "BinaryLength": 24576},
        "1784": {"vr": "OW", "BinaryLength": 24576},
        "1785": {"vr": "OW", "BinaryLength": 24576},
        "1786": {"vr": "OW", "BinaryLength": 24576},
        "1787": {"vr": "OW", "BinaryLength": 24576},
        "1788": {"vr": "OW", "BinaryLength": 24576},
        "1789": {"vr": "OW", "BinaryLength": 24576},
        "1790": {"vr": "OW", "BinaryLength": 24576},
        "1791": {"vr": "OW", "BinaryLength": 24576},
        "1792": {"vr": "OW", "BinaryLength": 24576},
        "1793": {"vr": "OW", "BinaryLength": 24576},
        "1794": {"vr": "OW", "BinaryLength": 24576},
        "1795": {"vr": "OW", "BinaryLength": 24576},
        "1796": {"vr": "OW", "BinaryLength": 24576},
        "1797": {"vr": "OW", "BinaryLength": 24576},
        "1798": {"vr": "OW", "BinaryLength": 24576},
        "1799": {"vr": "OW", "BinaryLength": 24576},
        "1800": {"vr": "OW", "BinaryLength": 24576},
        "1801": {"vr": "OW", "BinaryLength": 24576},
        "1802": {"vr": "OW", "BinaryLength": 24576},
        "1803": {"vr": "OW", "BinaryLength": 24576},
        "1804": {"vr": "OW", "BinaryLength": 24576},
        "1805": {"vr": "OW", "BinaryLength": 24576},
        "1806": {"vr": "OW", "BinaryLength": 24576},
        "1807": {"vr": "OW", "BinaryLength": 24576},
        "1808": {"vr": "OW", "BinaryLength": 24576},
        "1809": {"vr": "OW", "BinaryLength": 24576},
        "1810": {"vr": "OW", "BinaryLength": 24576},
        "1811": {"vr": "OW", "BinaryLength": 24576},
        "1812": {"vr": "OW", "BinaryLength": 24576},
        "1813": {"vr": "OW", "BinaryLength": 24576},
        "1814": {"vr": "OW", "BinaryLength": 24576},
        "1815": {"vr": "OW", "BinaryLength": 24576},
        "1816": {"vr": "OW", "BinaryLength": 24576},
        "1817": {"vr": "OW", "BinaryLength": 24576},
        "1818": {"vr": "OW", "BinaryLength": 24576},
        "1819": {"vr": "OW", "BinaryLength": 24576},
        "1820": {"vr": "OW", "BinaryLength": 24576},
        "1821": {"vr": "OW", "BinaryLength": 24576},
        "1822": {"vr": "OW", "BinaryLength": 24576},
        "1823": {"vr": "OW", "BinaryLength": 24576},
        "1824": {"vr": "OW", "BinaryLength": 24576},
        "1825": {"vr": "OW", "BinaryLength": 24576},
        "1826": {"vr": "OW", "BinaryLength": 24576},
        "1827": {"vr": "OW", "BinaryLength": 24576},
        "1828": {"vr": "OW", "BinaryLength": 24576},
        "1829": {"vr": "OW", "BinaryLength": 24576},
        "1830": {"vr": "OW", "BinaryLength": 24576},
        "1831": {"vr": "OW", "BinaryLength": 24576},
        "1832": {"vr": "OW", "BinaryLength": 24576},
        "1833": {"vr": "OW", "BinaryLength": 24576},
        "1834": {"vr": "OW", "BinaryLength": 24576},
        "1835": {"vr": "OW", "BinaryLength": 24576},
        "1836": {"vr": "OW", "BinaryLength": 24576},
        "1837": {"vr": "OW", "BinaryLength": 24576},
        "1838": {"vr": "OW", "BinaryLength": 24576},
        "1839": {"vr": "OW", "BinaryLength": 24576},
        "1840": {"vr": "OW", "BinaryLength": 24576},
        "1841": {"vr": "OW", "BinaryLength": 24576},
        "1842": {"vr": "OW", "BinaryLength": 24576},
        "1843": {"vr": "OW", "BinaryLength": 24576},
        "1844": {"vr": "OW", "BinaryLength": 24576},
        "1845": {"vr": "OW", "BinaryLength": 24576},
        "1846": {"vr": "OW", "BinaryLength": 24576},
        "1847": {"vr": "OW", "BinaryLength": 24576},
        "1848": {"vr": "OW", "BinaryLength": 24576},
        "1849": {"vr": "OW", "BinaryLength": 24576},
        "1850": {"vr": "OW", "BinaryLength": 24576},
        "1851": {"vr": "OW", "BinaryLength": 24576},
        "1852": {"vr": "OW", "BinaryLength": 24576},
        "1853": {"vr": "OW", "BinaryLength": 24576},
        "1854": {"vr": "OW", "BinaryLength": 24576},
        "1855": {"vr": "OW", "BinaryLength": 24576},
        "1856": {"vr": "OW", "BinaryLength": 24576},
        "1857": {"vr": "OW", "BinaryLength": 24576},
        "1858": {"vr": "OW", "BinaryLength": 24576},
        "1859": {"vr": "OW", "BinaryLength": 24576},
        "1860": {"vr": "OW", "BinaryLength": 24576},
        "1861": {"vr": "OW", "BinaryLength": 24576},
        "1862": {"vr": "OW", "BinaryLength": 24576},
        "1863": {"vr": "OW", "BinaryLength": 24576},
        "1864": {"vr": "OW", "BinaryLength": 24576},
        "1865": {"vr": "OW", "BinaryLength": 24576},
        "1866": {"vr": "OW", "BinaryLength": 24576},
        "1867": {"vr": "OW", "BinaryLength": 24576},
        "1868": {"vr": "OW", "BinaryLength": 24576},
        "1869": {"vr": "OW", "BinaryLength": 24576},
        "1870": {"vr": "OW", "BinaryLength": 24576},
        "1871": {"vr": "OW", "BinaryLength": 24576},
        "1872": {"vr": "OW", "BinaryLength": 24576},
        "1873": {"vr": "OW", "BinaryLength": 24576},
        "1874": {"vr": "OW", "BinaryLength": 24576},
        "1875": {"vr": "OW", "BinaryLength": 24576},
        "1876": {"vr": "OW", "BinaryLength": 24576},
        "1877": {"vr": "OW", "BinaryLength": 24576},
        "1878": {"vr": "OW", "BinaryLength": 24576},
        "1879": {"vr": "OW", "BinaryLength": 24576},
        "1880": {"vr": "OW", "BinaryLength": 24576},
        "1881": {"vr": "OW", "BinaryLength": 24576},
        "1882": {"vr": "OW", "BinaryLength": 24576},
        "1883": {"vr": "OW", "BinaryLength": 24576},
        "1884": {"vr": "OW", "BinaryLength": 24576},
        "1885": {"vr": "OW", "BinaryLength": 24576},
        "1886": {"vr": "OW", "BinaryLength": 24576},
        "1887": {"vr": "OW", "BinaryLength": 24576},
        "1888": {"vr": "OW", "BinaryLength": 24576},
        "1889": {"vr": "OW", "BinaryLength": 24576},
        "1890": {"vr": "OW", "BinaryLength": 24576},
        "1891": {"vr": "OW", "BinaryLength": 24576},
        "1892": {"vr": "OW", "BinaryLength": 24576},
        "1893": {"vr": "OW", "BinaryLength": 24576},
        "1894": {"vr": "OW", "BinaryLength": 24576},
        "1895": {"vr": "OW", "BinaryLength": 24576},
        "1896": {"vr": "OW", "BinaryLength": 24576},
        "1897": {"vr": "OW", "BinaryLength": 24576},
        "1898": {"vr": "OW", "BinaryLength": 24576},
        "1899": {"vr": "OW", "BinaryLength": 24576},
        "1900": {"vr": "OW", "BinaryLength": 24576},
        "1901": {"vr": "OW", "BinaryLength": 24576},
        "1902": {"vr": "OW", "BinaryLength": 24576},
        "1903": {"vr": "OW", "BinaryLength": 24576},
        "1904": {"vr": "OW", "BinaryLength": 24576},
        "1905": {"vr": "OW", "BinaryLength": 24576},
        "1906": {"vr": "OW", "BinaryLength": 24576},
        "1907": {"vr": "OW", "BinaryLength": 24576},
        "1908": {"vr": "OW", "BinaryLength": 24576},
        "1909": {"vr": "OW", "BinaryLength": 24576},
        "1910": {"vr": "OW", "BinaryLength": 24576},
        "1911": {"vr": "OW", "BinaryLength": 24576},
        "1912": {"vr": "OW", "BinaryLength": 24576},
        "1913": {"vr": "OW", "BinaryLength": 24576},
        "1914": {"vr": "OW", "BinaryLength": 24576},
        "1915": {"vr": "OW", "BinaryLength": 24576},
        "1916": {"vr": "OW", "BinaryLength": 24576},
        "1917": {"vr": "OW", "BinaryLength": 24576},
        "1918": {"vr": "OW", "BinaryLength": 24576},
        "1919": {"vr": "OW", "BinaryLength": 24576},
        "1920": {"vr": "OW", "BinaryLength": 24576},
        "1921": {"vr": "OW", "BinaryLength": 24576},
        "1922": {"vr": "OW", "BinaryLength": 24576},
        "1923": {"vr": "OW", "BinaryLength": 24576},
        "1924": {"vr": "OW", "BinaryLength": 24576},
        "1925": {"vr": "OW", "BinaryLength": 24576},
        "1926": {"vr": "OW", "BinaryLength": 24576},
        "1927": {"vr": "OW", "BinaryLength": 24576},
        "1928": {"vr": "OW", "BinaryLength": 24576},
        "1929": {"vr": "OW", "BinaryLength": 24576},
        "1930": {"vr": "OW", "BinaryLength": 24576},
        "1931": {"vr": "OW", "BinaryLength": 24576},
        "1932": {"vr": "OW", "BinaryLength": 24576},
        "1933": {"vr": "OW", "BinaryLength": 24576},
        "1934": {"vr": "OW", "BinaryLength": 24576},
        "1935": {"vr": "OW", "BinaryLength": 24576},
        "1936": {"vr": "OW", "BinaryLength": 24576},
        "1937": {"vr": "OW", "BinaryLength": 24576},
        "1938": {"vr": "OW", "BinaryLength": 24576},
        "1939": {"vr": "OW", "BinaryLength": 24576},
        "1940": {"vr": "OW", "BinaryLength": 24576},
        "1941": {"vr": "OW", "BinaryLength": 24576},
        "1942": {"vr": "OW", "BinaryLength": 24576},
        "1943": {"vr": "OW", "BinaryLength": 24576},
        "1944": {"vr": "OW", "BinaryLength": 24576},
        "1945": {"vr": "OW", "BinaryLength": 24576},
        "1946": {"vr": "OW", "BinaryLength": 24576},
        "1947": {"vr": "OW", "BinaryLength": 24576},
        "1948": {"vr": "OW", "BinaryLength": 24576},
        "1949": {"vr": "OW", "BinaryLength": 24576},
        "1950": {"vr": "OW", "BinaryLength": 24576},
        "1951": {"vr": "OW", "BinaryLength": 24576},
        "1952": {"vr": "OW", "BinaryLength": 24576},
        "1953": {"vr": "OW", "BinaryLength": 24576},
        "1954": {"vr": "OW", "BinaryLength": 24576},
        "1955": {"vr": "OW", "BinaryLength": 24576},
        "1956": {"vr": "OW", "BinaryLength": 24576},
        "1957": {"vr": "OW", "BinaryLength": 24576},
        "1958": {"vr": "OW", "BinaryLength": 24576},
        "1959": {"vr": "OW", "BinaryLength": 24576},
        "1960": {"vr": "OW", "BinaryLength": 24576},
        "1961": {"vr": "OW", "BinaryLength": 24576},
        "1962": {"vr": "OW", "BinaryLength": 24576},
        "1963": {"vr": "OW", "BinaryLength": 24576},
        "1964": {"vr": "OW", "BinaryLength": 24576},
        "1965": {"vr": "OW", "BinaryLength": 24576},
        "1966": {"vr": "OW", "BinaryLength": 24576},
        "1967": {"vr": "OW", "BinaryLength": 24576},
        "1968": {"vr": "OW", "BinaryLength": 24576},
        "1969": {"vr": "OW", "BinaryLength": 24576},
        "1970": {"vr": "OW", "BinaryLength": 24576},
        "1971": {"vr": "OW", "BinaryLength": 24576},
        "1972": {"vr": "OW", "BinaryLength": 24576},
        "1973": {"vr": "OW", "BinaryLength": 24576},
        "1974": {"vr": "OW", "BinaryLength": 24576},
        "1975": {"vr": "OW", "BinaryLength": 24576},
        "1976": {"vr": "OW", "BinaryLength": 24576},
        "1977": {"vr": "OW", "BinaryLength": 24576},
        "1978": {"vr": "OW", "BinaryLength": 24576},
        "1979": {"vr": "OW", "BinaryLength": 24576},
        "1980": {"vr": "OW", "BinaryLength": 24576},
        "1981": {"vr": "OW", "BinaryLength": 24576},
        "1982": {"vr": "OW", "BinaryLength": 24576},
        "1983": {"vr": "OW", "BinaryLength": 24576},
        "1984": {"vr": "OW", "BinaryLength": 24576},
        "1985": {"vr": "OW", "BinaryLength": 24576},
        "1986": {"vr": "OW", "BinaryLength": 24576},
        "1987": {"vr": "OW", "BinaryLength": 24576},
        "1988": {"vr": "OW", "BinaryLength": 24576},
        "1989": {"vr": "OW", "BinaryLength": 24576},
        "1990": {"vr": "OW", "BinaryLength": 24576},
        "1991": {"vr": "OW", "BinaryLength": 24576},
        "1992": {"vr": "OW", "BinaryLength": 24576},
        "1993": {"vr": "OW", "BinaryLength": 24576},
        "1994": {"vr": "OW", "BinaryLength": 24576},
        "1995": {"vr": "OW", "BinaryLength": 24576},
        "1996": {"vr": "OW", "BinaryLength": 24576},
        "1997": {"vr": "OW", "BinaryLength": 24576},
        "1998": {"vr": "OW", "BinaryLength": 24576},
        "1999": {"vr": "OW", "BinaryLength": 24576},
        "2000": {"vr": "OW", "BinaryLength": 24576},
        "2001": {"vr": "OW", "BinaryLength": 24576},
        "2002": {"vr": "OW", "BinaryLength": 24576},
        "2003": {"vr": "OW", "BinaryLength": 24576},
        "2004": {"vr": "OW", "BinaryLength": 24576},
        "2005": {"vr": "OW", "BinaryLength": 24576},
        "2006": {"vr": "OW", "BinaryLength": 24576},
        "2007": {"vr": "OW", "BinaryLength": 24576},
        "2008": {"vr": "OW", "BinaryLength": 24576},
        "2009": {"vr": "OW", "BinaryLength": 24576},
        "2010": {"vr": "OW", "BinaryLength": 24576},
        "2011": {"vr": "OW", "BinaryLength": 24576},
        "2012": {"vr": "OW", "BinaryLength": 24576},
        "2013": {"vr": "OW", "BinaryLength": 24576},
        "2014": {"vr": "OW", "BinaryLength": 24576},
        "2015": {"vr": "OW", "BinaryLength": 24576},
        "2016": {"vr": "OW", "BinaryLength": 24576},
        "2017": {"vr": "OW", "BinaryLength": 24576},
        "2018": {"vr": "OW", "BinaryLength": 24576},
        "2019": {"vr": "OW", "BinaryLength": 24576},
        "2020": {"vr": "OW", "BinaryLength": 24576},
        "2021": {"vr": "OW", "BinaryLength": 24576},
        "2022": {"vr": "OW", "BinaryLength": 24576},
        "2023": {"vr": "OW", "BinaryLength": 24576},
        "2024": {"vr": "OW", "BinaryLength": 24576},
        "2025": {"vr": "OW", "BinaryLength": 24576},
        "2026": {"vr": "OW", "BinaryLength": 24576},
        "2027": {"vr": "OW", "BinaryLength": 24576},
        "2028": {"vr": "OW", "BinaryLength": 24576},
        "2029": {"vr": "OW", "BinaryLength": 24576},
        "2030": {"vr": "OW", "BinaryLength": 24576},
        "2031": {"vr": "OW", "BinaryLength": 24576},
        "2032": {"vr": "OW", "BinaryLength": 24576},
        "2033": {"vr": "OW", "BinaryLength": 24576},
        "2034": {"vr": "OW", "BinaryLength": 24576},
        "2035": {"vr": "OW", "BinaryLength": 24576},
        "2036": {"vr": "OW", "BinaryLength": 24576},
        "2037": {"vr": "OW", "BinaryLength": 24576},
        "2038": {"vr": "OW", "BinaryLength": 24576},
        "2039": {"vr": "OW", "BinaryLength": 24576},
        "2040": {"vr": "OW", "BinaryLength": 24576},
        "2041": {"vr": "OW", "BinaryLength": 24576},
        "2042": {"vr": "OW", "BinaryLength": 24576},
        "2043": {"vr": "OW", "BinaryLength": 24576},
        "2044": {"vr": "OW", "BinaryLength": 24576},
        "2045": {"vr": "OW", "BinaryLength": 24576},
        "2046": {"vr": "OW", "BinaryLength": 24576},
        "2047": {"vr": "OW", "BinaryLength": 24576},
        "2048": {"vr": "OW", "BinaryLength": 24576},
        "2049": {"vr": "OW", "BinaryLength": 24576},
        "2050": {"vr": "OW", "BinaryLength": 24576},
        "2051": {"vr": "OW", "BinaryLength": 24576},
        "2052": {"vr": "OW", "BinaryLength": 24576},
        "2053": {"vr": "OW", "BinaryLength": 24576},
        "2054": {"vr": "OW", "BinaryLength": 24576},
        "2055": {"vr": "OW", "BinaryLength": 24576},
        "2056": {"vr": "OW", "BinaryLength": 24576},
        "2057": {"vr": "OW", "BinaryLength": 24576},
        "2058": {"vr": "OW", "BinaryLength": 24576},
        "2059": {"vr": "OW", "BinaryLength": 24576},
        "2060": {"vr": "OW", "BinaryLength": 24576},
        "2061": {"vr": "OW", "BinaryLength": 24576},
        "2062": {"vr": "OW", "BinaryLength": 24576},
        "2063": {"vr": "OW", "BinaryLength": 24576},
        "2064": {"vr": "OW", "BinaryLength": 24576},
        "2065": {"vr": "OW", "BinaryLength": 24576},
        "2066": {"vr": "OW", "BinaryLength": 24576},
        "2067": {"vr": "OW", "BinaryLength": 24576},
        "2068": {"vr": "OW", "BinaryLength": 24576},
        "2069": {"vr": "OW", "BinaryLength": 24576},
        "2070": {"vr": "OW", "BinaryLength": 24576},
        "2071": {"vr": "OW", "BinaryLength": 24576},
        "2072": {"vr": "OW", "BinaryLength": 24576},
        "2073": {"vr": "OW", "BinaryLength": 24576},
        "2074": {"vr": "OW", "BinaryLength": 24576},
        "2075": {"vr": "OW", "BinaryLength": 24576},
        "2076": {"vr": "OW", "BinaryLength": 24576},
        "2077": {"vr": "OW", "BinaryLength": 24576},
        "2078": {"vr": "OW", "BinaryLength": 24576},
        "2079": {"vr": "OW", "BinaryLength": 24576},
        "2080": {"vr": "OW", "BinaryLength": 24576},
        "2081": {"vr": "OW", "BinaryLength": 24576},
        "2082": {"vr": "OW", "BinaryLength": 24576},
        "2083": {"vr": "OW", "BinaryLength": 24576},
        "2084": {"vr": "OW", "BinaryLength": 24576},
        "2085": {"vr": "OW", "BinaryLength": 24576},
        "2086": {"vr": "OW", "BinaryLength": 24576},
        "2087": {"vr": "OW", "BinaryLength": 24576},
        "2088": {"vr": "OW", "BinaryLength": 24576},
        "2089": {"vr": "OW", "BinaryLength": 24576},
        "2090": {"vr": "OW", "BinaryLength": 24576},
        "2091": {"vr": "OW", "BinaryLength": 24576},
        "2092": {"vr": "OW", "BinaryLength": 24576},
        "2093": {"vr": "OW", "BinaryLength": 24576},
        "2094": {"vr": "OW", "BinaryLength": 24576},
        "2095": {"vr": "OW", "BinaryLength": 24576},
        "2096": {"vr": "OW", "BinaryLength": 24576},
        "2097": {"vr": "OW", "BinaryLength": 24576},
        "2098": {"vr": "OW", "BinaryLength": 24576},
        "2099": {"vr": "OW", "BinaryLength": 24576},
        "2100": {"vr": "OW", "BinaryLength": 24576},
        "2101": {"vr": "OW", "BinaryLength": 24576},
        "2102": {"vr": "OW", "BinaryLength": 24576},
        "2103": {"vr": "OW", "BinaryLength": 24576},
        "2104": {"vr": "OW", "BinaryLength": 24576},
        "2105": {"vr": "OW", "BinaryLength": 24576},
        "2106": {"vr": "OW", "BinaryLength": 24576},
        "2107": {"vr": "OW", "BinaryLength": 24576},
        "2108": {"vr": "OW", "BinaryLength": 24576},
        "2109": {"vr": "OW", "BinaryLength": 24576},
        "2110": {"vr": "OW", "BinaryLength": 24576},
        "2111": {"vr": "OW", "BinaryLength": 24576},
        "2112": {"vr": "OW", "BinaryLength": 24576},
        "2113": {"vr": "OW", "BinaryLength": 24576},
        "2114": {"vr": "OW", "BinaryLength": 24576},
        "2115": {"vr": "OW", "BinaryLength": 24576},
        "2116": {"vr": "OW", "BinaryLength": 24576},
        "2117": {"vr": "OW", "BinaryLength": 24576},
        "2118": {"vr": "OW", "BinaryLength": 24576},
        "2119": {"vr": "OW", "BinaryLength": 24576},
        "2120": {"vr": "OW", "BinaryLength": 24576},
        "2121": {"vr": "OW", "BinaryLength": 24576},
        "2122": {"vr": "OW", "BinaryLength": 24576},
        "2123": {"vr": "OW", "BinaryLength": 24576},
        "2124": {"vr": "OW", "BinaryLength": 24576},
        "2125": {"vr": "OW", "BinaryLength": 24576},
        "2126": {"vr": "OW", "BinaryLength": 24576},
        "2127": {"vr": "OW", "BinaryLength": 24576},
        "2128": {"vr": "OW", "BinaryLength": 24576},
        "2129": {"vr": "OW", "BinaryLength": 24576},
        "2130": {"vr": "OW", "BinaryLength": 24576},
        "2131": {"vr": "OW", "BinaryLength": 24576},
        "2132": {"vr": "OW", "BinaryLength": 24576},
        "2133": {"vr": "OW", "BinaryLength": 24576},
        "2134": {"vr": "OW", "BinaryLength": 24576},
        "2135": {"vr": "OW", "BinaryLength": 24576},
        "2136": {"vr": "OW", "BinaryLength": 24576},
        "2137": {"vr": "OW", "BinaryLength": 24576},
        "2138": {"vr": "OW", "BinaryLength": 24576},
        "2139": {"vr": "OW", "BinaryLength": 24576},
        "2140": {"vr": "OW", "BinaryLength": 24576},
        "2141": {"vr": "OW", "BinaryLength": 24576},
        "2142": {"vr": "OW", "BinaryLength": 24576},
        "2143": {"vr": "OW", "BinaryLength": 24576},
        "2144": {"vr": "OW", "BinaryLength": 24576},
        "2145": {"vr": "OW", "BinaryLength": 24576},
        "2146": {"vr": "OW", "BinaryLength": 24576},
        "2147": {"vr": "OW", "BinaryLength": 24576},
        "2148": {"vr": "OW", "BinaryLength": 24576},
        "2149": {"vr": "OW", "BinaryLength": 24576},
        "2150": {"vr": "OW", "BinaryLength": 24576},
        "2151": {"vr": "OW", "BinaryLength": 24576},
        "2152": {"vr": "OW", "BinaryLength": 24576},
        "2153": {"vr": "OW", "BinaryLength": 24576},
        "2154": {"vr": "OW", "BinaryLength": 24576},
        "2155": {"vr": "OW", "BinaryLength": 24576},
        "2156": {"vr": "OW", "BinaryLength": 24576},
        "2157": {"vr": "OW", "BinaryLength": 24576},
        "2158": {"vr": "OW", "BinaryLength": 24576},
        "2159": {"vr": "OW", "BinaryLength": 24576},
        "2160": {"vr": "OW", "BinaryLength": 24576},
        "2161": {"vr": "OW", "BinaryLength": 24576},
        "2162": {"vr": "OW", "BinaryLength": 24576},
        "2163": {"vr": "OW", "BinaryLength": 24576},
        "2164": {"vr": "OW", "BinaryLength": 24576},
        "2165": {"vr": "OW", "BinaryLength": 24576},
        "2166": {"vr": "OW", "BinaryLength": 24576},
        "2167": {"vr": "OW", "BinaryLength": 24576},
        "2168": {"vr": "OW", "BinaryLength": 24576},
        "2169": {"vr": "OW", "BinaryLength": 24576},
        "2170": {"vr": "OW", "BinaryLength": 24576},
        "2171": {"vr": "OW", "BinaryLength": 24576},
        "2172": {"vr": "OW", "BinaryLength": 24576},
        "2173": {"vr": "OW", "BinaryLength": 24576},
        "2174": {"vr": "OW", "BinaryLength": 24576},
        "2175": {"vr": "OW", "BinaryLength": 24576},
        "2176": {"vr": "OW", "BinaryLength": 24576},
        "2177": {"vr": "OW", "BinaryLength": 24576},
        "2178": {"vr": "OW", "BinaryLength": 24576},
        "2179": {"vr": "OW", "BinaryLength": 24576},
        "2180": {"vr": "OW", "BinaryLength": 24576},
        "2181": {"vr": "OW", "BinaryLength": 24576},
        "2182": {"vr": "OW", "BinaryLength": 24576},
        "2183": {"vr": "OW", "BinaryLength": 24576},
        "2184": {"vr": "OW", "BinaryLength": 24576},
        "2185": {"vr": "OW", "BinaryLength": 24576},
        "2186": {"vr": "OW", "BinaryLength": 24576},
        "2187": {"vr": "OW", "BinaryLength": 24576},
        "2188": {"vr": "OW", "BinaryLength": 24576},
        "2189": {"vr": "OW", "BinaryLength": 24576},
        "2190": {"vr": "OW", "BinaryLength": 24576},
        "2191": {"vr": "OW", "BinaryLength": 24576},
        "2192": {"vr": "OW", "BinaryLength": 24576},
        "2193": {"vr": "OW", "BinaryLength": 24576},
        "2194": {"vr": "OW", "BinaryLength": 24576},
        "2195": {"vr": "OW", "BinaryLength": 24576},
        "2196": {"vr": "OW", "BinaryLength": 24576},
        "2197": {"vr": "OW", "BinaryLength": 24576},
        "2198": {"vr": "OW", "BinaryLength": 24576},
        "2199": {"vr": "OW", "BinaryLength": 24576},
        "2200": {"vr": "OW", "BinaryLength": 24576},
        "2201": {"vr": "OW", "BinaryLength": 24576},
        "2202": {"vr": "OW", "BinaryLength": 24576},
        "2203": {"vr": "OW", "BinaryLength": 24576},
        "2204": {"vr": "OW", "BinaryLength": 24576},
        "2205": {"vr": "OW", "BinaryLength": 24576},
        "2206": {"vr": "OW", "BinaryLength": 24576},
        "2207": {"vr": "OW", "BinaryLength": 24576},
        "2208": {"vr": "OW", "BinaryLength": 24576},
        "2209": {"vr": "OW", "BinaryLength": 24576},
        "2210": {"vr": "OW", "BinaryLength": 24576},
        "2211": {"vr": "OW", "BinaryLength": 24576},
        "2212": {"vr": "OW", "BinaryLength": 24576},
        "2213": {"vr": "OW", "BinaryLength": 24576},
        "2214": {"vr": "OW", "BinaryLength": 24576},
        "2215": {"vr": "OW", "BinaryLength": 24576},
        "2216": {"vr": "OW", "BinaryLength": 24576},
        "2217": {"vr": "OW", "BinaryLength": 24576},
        "2218": {"vr": "OW", "BinaryLength": 24576},
        "2219": {"vr": "OW", "BinaryLength": 24576},
        "2220": {"vr": "OW", "BinaryLength": 24576},
        "2221": {"vr": "OW", "BinaryLength": 24576},
        "2222": {"vr": "OW", "BinaryLength": 24576},
        "2223": {"vr": "OW", "BinaryLength": 24576},
        "2224": {"vr": "OW", "BinaryLength": 24576},
        "2225": {"vr": "OW", "BinaryLength": 24576},
        "2226": {"vr": "OW", "BinaryLength": 24576},
        "2227": {"vr": "OW", "BinaryLength": 24576},
        "2228": {"vr": "OW", "BinaryLength": 24576},
        "2229": {"vr": "OW", "BinaryLength": 24576},
        "2230": {"vr": "OW", "BinaryLength": 24576},
        "2231": {"vr": "OW", "BinaryLength": 24576},
        "2232": {"vr": "OW", "BinaryLength": 24576},
        "2233": {"vr": "OW", "BinaryLength": 24576},
        "2234": {"vr": "OW", "BinaryLength": 24576},
        "2235": {"vr": "OW", "BinaryLength": 24576},
        "2236": {"vr": "OW", "BinaryLength": 24576},
        "2237": {"vr": "OW", "BinaryLength": 24576},
        "2238": {"vr": "OW", "BinaryLength": 24576},
        "2239": {"vr": "OW", "BinaryLength": 24576},
        "2240": {"vr": "OW", "BinaryLength": 24576},
        "2241": {"vr": "OW", "BinaryLength": 24576},
        "2242": {"vr": "OW", "BinaryLength": 24576},
        "2243": {"vr": "OW", "BinaryLength": 24576},
        "2244": {"vr": "OW", "BinaryLength": 24576},
        "2245": {"vr": "OW", "BinaryLength": 24576},
        "2246": {"vr": "OW", "BinaryLength": 24576},
        "2247": {"vr": "OW", "BinaryLength": 24576},
        "2248": {"vr": "OW", "BinaryLength": 24576},
        "2249": {"vr": "OW", "BinaryLength": 24576},
        "2250": {"vr": "OW", "BinaryLength": 24576},
        "2251": {"vr": "OW", "BinaryLength": 24576},
        "2252": {"vr": "OW", "BinaryLength": 24576},
        "2253": {"vr": "OW", "BinaryLength": 24576},
        "2254": {"vr": "OW", "BinaryLength": 24576},
        "2255": {"vr": "OW", "BinaryLength": 24576},
        "2256": {"vr": "OW", "BinaryLength": 24576},
        "2257": {"vr": "OW", "BinaryLength": 24576},
        "2258": {"vr": "OW", "BinaryLength": 24576},
        "2259": {"vr": "OW", "BinaryLength": 24576},
        "2260": {"vr": "OW", "BinaryLength": 24576},
        "2261": {"vr": "OW", "BinaryLength": 24576},
        "2262": {"vr": "OW", "BinaryLength": 24576},
        "2263": {"vr": "OW", "BinaryLength": 24576},
        "2264": {"vr": "OW", "BinaryLength": 24576},
        "2265": {"vr": "OW", "BinaryLength": 24576},
        "2266": {"vr": "OW", "BinaryLength": 24576},
        "2267": {"vr": "OW", "BinaryLength": 24576},
        "2268": {"vr": "OW", "BinaryLength": 24576},
        "2269": {"vr": "OW", "BinaryLength": 24576},
        "2270": {"vr": "OW", "BinaryLength": 24576},
        "2271": {"vr": "OW", "BinaryLength": 24576},
        "2272": {"vr": "OW", "BinaryLength": 24576},
        "2273": {"vr": "OW", "BinaryLength": 24576},
        "2274": {"vr": "OW", "BinaryLength": 24576},
        "2275": {"vr": "OW", "BinaryLength": 24576},
        "2276": {"vr": "OW", "BinaryLength": 24576},
        "2277": {"vr": "OW", "BinaryLength": 24576},
        "2278": {"vr": "OW", "BinaryLength": 24576},
        "2279": {"vr": "OW", "BinaryLength": 24576},
        "2280": {"vr": "OW", "BinaryLength": 24576},
        "2281": {"vr": "OW", "BinaryLength": 24576},
        "2282": {"vr": "OW", "BinaryLength": 24576},
        "2283": {"vr": "OW", "BinaryLength": 24576},
        "2284": {"vr": "OW", "BinaryLength": 24576},
        "2285": {"vr": "OW", "BinaryLength": 24576},
        "2286": {"vr": "OW", "BinaryLength": 24576},
        "2287": {"vr": "OW", "BinaryLength": 24576},
        "2288": {"vr": "OW", "BinaryLength": 24576},
        "2289": {"vr": "OW", "BinaryLength": 24576},
        "2290": {"vr": "OW", "BinaryLength": 24576},
        "2291": {"vr": "OW", "BinaryLength": 24576},
        "2292": {"vr": "OW", "BinaryLength": 24576},
        "2293": {"vr": "OW", "BinaryLength": 24576},
        "2294": {"vr": "OW", "BinaryLength": 24576},
        "2295": {"vr": "OW", "BinaryLength": 24576},
        "2296": {"vr": "OW", "BinaryLength": 24576},
        "2297": {"vr": "OW", "BinaryLength": 24576},
        "2298": {"vr": "OW", "BinaryLength": 24576},
        "2299": {"vr": "OW", "BinaryLength": 24576},
        "2300": {"vr": "OW", "BinaryLength": 24576},
        "2301": {"vr": "OW", "BinaryLength": 24576},
        "2302": {"vr": "OW", "BinaryLength": 24576},
        "2303": {"vr": "OW", "BinaryLength": 24576},
        "2304": {"vr": "OW", "BinaryLength": 24576},
        "2305": {"vr": "OW", "BinaryLength": 24576},
        "2306": {"vr": "OW", "BinaryLength": 24576},
        "2307": {"vr": "OW", "BinaryLength": 24576},
        "2308": {"vr": "OW", "BinaryLength": 24576},
        "2309": {"vr": "OW", "BinaryLength": 24576},
        "2310": {"vr": "OW", "BinaryLength": 24576},
        "2311": {"vr": "OW", "BinaryLength": 24576},
        "2312": {"vr": "OW", "BinaryLength": 24576},
        "2313": {"vr": "OW", "BinaryLength": 24576},
        "2314": {"vr": "OW", "BinaryLength": 24576},
        "2315": {"vr": "OW", "BinaryLength": 24576},
        "2316": {"vr": "OW", "BinaryLength": 24576},
        "2317": {"vr": "OW", "BinaryLength": 24576},
        "2318": {"vr": "OW", "BinaryLength": 24576},
        "2319": {"vr": "OW", "BinaryLength": 24576},
        "2320": {"vr": "OW", "BinaryLength": 24576},
        "2321": {"vr": "OW", "BinaryLength": 24576},
        "2322": {"vr": "OW", "BinaryLength": 24576},
        "2323": {"vr": "OW", "BinaryLength": 24576},
        "2324": {"vr": "OW", "BinaryLength": 24576},
        "2325": {"vr": "OW", "BinaryLength": 24576},
        "2326": {"vr": "OW", "BinaryLength": 24576},
        "2327": {"vr": "OW", "BinaryLength": 24576},
        "2328": {"vr": "OW", "BinaryLength": 24576},
        "2329": {"vr": "OW", "BinaryLength": 24576},
        "2330": {"vr": "OW", "BinaryLength": 24576},
        "2331": {"vr": "OW", "BinaryLength": 24576},
        "2332": {"vr": "OW", "BinaryLength": 24576},
        "2333": {"vr": "OW", "BinaryLength": 24576},
        "2334": {"vr": "OW", "BinaryLength": 24576},
        "2335": {"vr": "OW", "BinaryLength": 24576},
        "2336": {"vr": "OW", "BinaryLength": 24576},
        "2337": {"vr": "OW", "BinaryLength": 24576},
        "2338": {"vr": "OW", "BinaryLength": 24576},
        "2339": {"vr": "OW", "BinaryLength": 24576},
        "2340": {"vr": "OW", "BinaryLength": 24576},
        "2341": {"vr": "OW", "BinaryLength": 24576},
        "2342": {"vr": "OW", "BinaryLength": 24576},
        "2343": {"vr": "OW", "BinaryLength": 24576},
        "2344": {"vr": "OW", "BinaryLength": 24576},
        "2345": {"vr": "OW", "BinaryLength": 24576},
        "2346": {"vr": "OW", "BinaryLength": 24576},
        "2347": {"vr": "OW", "BinaryLength": 24576},
        "2348": {"vr": "OW", "BinaryLength": 24576},
        "2349": {"vr": "OW", "BinaryLength": 24576},
        "2350": {"vr": "OW", "BinaryLength": 24576},
        "2351": {"vr": "OW", "BinaryLength": 24576},
        "2352": {"vr": "OW", "BinaryLength": 24576},
        "2353": {"vr": "OW", "BinaryLength": 24576},
        "2354": {"vr": "OW", "BinaryLength": 24576},
        "2355": {"vr": "OW", "BinaryLength": 24576},
        "2356": {"vr": "OW", "BinaryLength": 24576},
        "2357": {"vr": "OW", "BinaryLength": 24576},
        "2358": {"vr": "OW", "BinaryLength": 24576},
        "2359": {"vr": "OW", "BinaryLength": 24576},
        "2360": {"vr": "OW", "BinaryLength": 24576},
        "2361": {"vr": "OW", "BinaryLength": 24576},
        "2362": {"vr": "OW", "BinaryLength": 24576},
        "2363": {"vr": "OW", "BinaryLength": 24576},
        "2364": {"vr": "OW", "BinaryLength": 24576},
        "2365": {"vr": "OW", "BinaryLength": 24576},
        "2366": {"vr": "OW", "BinaryLength": 24576},
        "2367": {"vr": "OW", "BinaryLength": 24576},
        "2368": {"vr": "OW", "BinaryLength": 24576},
        "2369": {"vr": "OW", "BinaryLength": 24576},
        "2370": {"vr": "OW", "BinaryLength": 24576},
        "2371": {"vr": "OW", "BinaryLength": 24576},
        "2372": {"vr": "OW", "BinaryLength": 24576},
        "2373": {"vr": "OW", "BinaryLength": 24576},
        "2374": {"vr": "OW", "BinaryLength": 24576},
        "2375": {"vr": "OW", "BinaryLength": 24576},
        "2376": {"vr": "OW", "BinaryLength": 24576},
        "2377": {"vr": "OW", "BinaryLength": 24576},
        "2378": {"vr": "OW", "BinaryLength": 24576},
        "2379": {"vr": "OW", "BinaryLength": 24576},
        "2380": {"vr": "OW", "BinaryLength": 24576},
        "2381": {"vr": "OW", "BinaryLength": 24576},
        "2382": {"vr": "OW", "BinaryLength": 24576},
        "2383": {"vr": "OW", "BinaryLength": 24576},
        "2384": {"vr": "OW", "BinaryLength": 24576},
        "2385": {"vr": "OW", "BinaryLength": 24576},
        "2386": {"vr": "OW", "BinaryLength": 24576},
        "2387": {"vr": "OW", "BinaryLength": 24576},
        "2388": {"vr": "OW", "BinaryLength": 24576},
        "2389": {"vr": "OW", "BinaryLength": 24576},
        "2390": {"vr": "OW", "BinaryLength": 24576},
        "2391": {"vr": "OW", "BinaryLength": 24576},
        "2392": {"vr": "OW", "BinaryLength": 24576},
        "2393": {"vr": "OW", "BinaryLength": 24576},
        "2394": {"vr": "OW", "BinaryLength": 24576},
        "2395": {"vr": "OW", "BinaryLength": 24576},
        "2396": {"vr": "OW", "BinaryLength": 24576},
        "2397": {"vr": "OW", "BinaryLength": 24576},
        "2398": {"vr": "OW", "BinaryLength": 24576},
        "2399": {"vr": "OW", "BinaryLength": 24576},
        "2400": {"vr": "OW", "BinaryLength": 24576},
        "2401": {"vr": "OW", "BinaryLength": 24576},
        "2402": {"vr": "OW", "BinaryLength": 24576},
        "2403": {"vr": "OW", "BinaryLength": 24576},
        "2404": {"vr": "OW", "BinaryLength": 24576},
        "2405": {"vr": "OW", "BinaryLength": 24576},
        "2406": {"vr": "OW", "BinaryLength": 24576},
        "2407": {"vr": "OW", "BinaryLength": 24576},
        "2408": {"vr": "OW", "BinaryLength": 24576},
        "2409": {"vr": "OW", "BinaryLength": 24576},
        "2410": {"vr": "OW", "BinaryLength": 24576},
        "2411": {"vr": "OW", "BinaryLength": 24576},
        "2412": {"vr": "OW", "BinaryLength": 24576},
        "2413": {"vr": "OW", "BinaryLength": 24576},
        "2414": {"vr": "OW", "BinaryLength": 24576},
        "2415": {"vr": "OW", "BinaryLength": 24576},
        "2416": {"vr": "OW", "BinaryLength": 24576},
        "2417": {"vr": "OW", "BinaryLength": 24576},
        "2418": {"vr": "OW", "BinaryLength": 24576},
        "2419": {"vr": "OW", "BinaryLength": 24576},
        "2420": {"vr": "OW", "BinaryLength": 24576},
        "2421": {"vr": "OW", "BinaryLength": 24576},
        "2422": {"vr": "OW", "BinaryLength": 24576},
        "2423": {"vr": "OW", "BinaryLength": 24576},
        "2424": {"vr": "OW", "BinaryLength": 24576},
        "2425": {"vr": "OW", "BinaryLength": 24576},
        "2426": {"vr": "OW", "BinaryLength": 24576},
        "2427": {"vr": "OW", "BinaryLength": 24576},
        "2428": {"vr": "OW", "BinaryLength": 24576},
        "2429": {"vr": "OW", "BinaryLength": 24576},
        "2430": {"vr": "OW", "BinaryLength": 24576},
        "2431": {"vr": "OW", "BinaryLength": 24576},
        "2432": {"vr": "OW", "BinaryLength": 24576},
        "2433": {"vr": "OW", "BinaryLength": 24576},
        "2434": {"vr": "OW", "BinaryLength": 24576},
        "2435": {"vr": "OW", "BinaryLength": 24576},
        "2436": {"vr": "OW", "BinaryLength": 24576},
        "2437": {"vr": "OW", "BinaryLength": 24576},
        "2438": {"vr": "OW", "BinaryLength": 24576},
        "2439": {"vr": "OW", "BinaryLength": 24576},
        "2440": {"vr": "OW", "BinaryLength": 24576},
        "2441": {"vr": "OW", "BinaryLength": 24576},
        "2442": {"vr": "OW", "BinaryLength": 24576},
        "2443": {"vr": "OW", "BinaryLength": 24576},
        "2444": {"vr": "OW", "BinaryLength": 24576},
        "2445": {"vr": "OW", "BinaryLength": 24576},
        "2446": {"vr": "OW", "BinaryLength": 24576},
        "2447": {"vr": "OW", "BinaryLength": 24576},
        "2448": {"vr": "OW", "BinaryLength": 24576},
        "2449": {"vr": "OW", "BinaryLength": 24576},
        "2450": {"vr": "OW", "BinaryLength": 24576},
        "2451": {"vr": "OW", "BinaryLength": 24576},
        "2452": {"vr": "OW", "BinaryLength": 24576},
        "2453": {"vr": "OW", "BinaryLength": 24576},
        "2454": {"vr": "OW", "BinaryLength": 24576},
        "2455": {"vr": "OW", "BinaryLength": 24576},
        "2456": {"vr": "OW", "BinaryLength": 24576},
        "2457": {"vr": "OW", "BinaryLength": 24576},
        "2458": {"vr": "OW", "BinaryLength": 24576},
        "2459": {"vr": "OW", "BinaryLength": 24576},
        "2460": {"vr": "OW", "BinaryLength": 24576},
        "2461": {"vr": "OW", "BinaryLength": 24576},
        "2462": {"vr": "OW", "BinaryLength": 24576},
        "2463": {"vr": "OW", "BinaryLength": 24576},
        "2464": {"vr": "OW", "BinaryLength": 24576},
        "2465": {"vr": "OW", "BinaryLength": 24576},
        "2466": {"vr": "OW", "BinaryLength": 24576},
        "2467": {"vr": "OW", "BinaryLength": 24576},
        "2468": {"vr": "OW", "BinaryLength": 24576},
        "2469": {"vr": "OW", "BinaryLength": 24576},
        "2470": {"vr": "OW", "BinaryLength": 24576},
        "2471": {"vr": "OW", "BinaryLength": 24576},
        "2472": {"vr": "OW", "BinaryLength": 24576},
        "2473": {"vr": "OW", "BinaryLength": 24576},
        "2474": {"vr": "OW", "BinaryLength": 24576},
        "2475": {"vr": "OW", "BinaryLength": 24576},
        "2476": {"vr": "OW", "BinaryLength": 24576},
        "2477": {"vr": "OW", "BinaryLength": 24576},
        "2478": {"vr": "OW", "BinaryLength": 24576},
        "2479": {"vr": "OW", "BinaryLength": 24576},
        "2480": {"vr": "OW", "BinaryLength": 24576},
        "2481": {"vr": "OW", "BinaryLength": 24576},
        "2482": {"vr": "OW", "BinaryLength": 24576},
        "2483": {"vr": "OW", "BinaryLength": 24576},
        "2484": {"vr": "OW", "BinaryLength": 24576},
        "2485": {"vr": "OW", "BinaryLength": 24576},
        "2486": {"vr": "OW", "BinaryLength": 24576},
        "2487": {"vr": "OW", "BinaryLength": 24576},
        "2488": {"vr": "OW", "BinaryLength": 24576},
        "2489": {"vr": "OW", "BinaryLength": 24576},
        "2490": {"vr": "OW", "BinaryLength": 24576},
        "2491": {"vr": "OW", "BinaryLength": 24576},
        "2492": {"vr": "OW", "BinaryLength": 24576},
        "2493": {"vr": "OW", "BinaryLength": 24576},
        "2494": {"vr": "OW", "BinaryLength": 24576},
        "2495": {"vr": "OW", "BinaryLength": 24576},
        "2496": {"vr": "OW", "BinaryLength": 24576},
        "2497": {"vr": "OW", "BinaryLength": 24576},
        "2498": {"vr": "OW", "BinaryLength": 24576},
        "2499": {"vr": "OW", "BinaryLength": 24576},
        "2500": {"vr": "OW", "BinaryLength": 24576},
        "2501": {"vr": "OW", "BinaryLength": 24576},
        "2502": {"vr": "OW", "BinaryLength": 24576},
        "2503": {"vr": "OW", "BinaryLength": 24576},
        "2504": {"vr": "OW", "BinaryLength": 24576},
        "2505": {"vr": "OW", "BinaryLength": 24576},
        "2506": {"vr": "OW", "BinaryLength": 24576},
        "2507": {"vr": "OW", "BinaryLength": 24576},
        "2508": {"vr": "OW", "BinaryLength": 24576},
        "2509": {"vr": "OW", "BinaryLength": 24576},
        "2510": {"vr": "OW", "BinaryLength": 24576},
        "2511": {"vr": "OW", "BinaryLength": 24576},
        "2512": {"vr": "OW", "BinaryLength": 24576},
        "2513": {"vr": "OW", "BinaryLength": 24576},
        "2514": {"vr": "OW", "BinaryLength": 24576},
        "2515": {"vr": "OW", "BinaryLength": 24576},
        "2516": {"vr": "OW", "BinaryLength": 24576},
        "2517": {"vr": "OW", "BinaryLength": 24576},
        "2518": {"vr": "OW", "BinaryLength": 24576},
        "2519": {"vr": "OW", "BinaryLength": 24576},
        "2520": {"vr": "OW", "BinaryLength": 24576},
        "2521": {"vr": "OW", "BinaryLength": 24576},
        "2522": {"vr": "OW", "BinaryLength": 24576},
        "2523": {"vr": "OW", "BinaryLength": 24576},
        "2524": {"vr": "OW", "BinaryLength": 24576},
        "2525": {"vr": "OW", "BinaryLength": 24576},
        "2526": {"vr": "OW", "BinaryLength": 24576},
        "2527": {"vr": "OW", "BinaryLength": 24576},
        "2528": {"vr": "OW", "BinaryLength": 24576},
        "2529": {"vr": "OW", "BinaryLength": 24576},
        "2530": {"vr": "OW", "BinaryLength": 24576},
        "2531": {"vr": "OW", "BinaryLength": 24576},
        "2532": {"vr": "OW", "BinaryLength": 24576},
        "2533": {"vr": "OW", "BinaryLength": 24576},
        "2534": {"vr": "OW", "BinaryLength": 24576},
        "2535": {"vr": "OW", "BinaryLength": 24576},
        "2536": {"vr": "OW", "BinaryLength": 24576},
        "2537": {"vr": "OW", "BinaryLength": 24576},
        "2538": {"vr": "OW", "BinaryLength": 24576},
        "2539": {"vr": "OW", "BinaryLength": 24576},
        "2540": {"vr": "OW", "BinaryLength": 24576},
        "2541": {"vr": "OW", "BinaryLength": 24576},
        "2542": {"vr": "OW", "BinaryLength": 24576},
        "2543": {"vr": "OW", "BinaryLength": 24576},
        "2544": {"vr": "OW", "BinaryLength": 24576},
        "2545": {"vr": "OW", "BinaryLength": 24576},
        "2546": {"vr": "OW", "BinaryLength": 24576},
        "2547": {"vr": "OW", "BinaryLength": 24576},
        "2548": {"vr": "OW", "BinaryLength": 24576},
        "2549": {"vr": "OW", "BinaryLength": 24576},
        "2550": {"vr": "OW", "BinaryLength": 24576},
        "2551": {"vr": "OW", "BinaryLength": 24576},
        "2552": {"vr": "OW", "BinaryLength": 24576},
        "2553": {"vr": "OW", "BinaryLength": 24576},
        "2554": {"vr": "OW", "BinaryLength": 24576},
        "2555": {"vr": "OW", "BinaryLength": 24576},
        "2556": {"vr": "OW", "BinaryLength": 24576},
        "2557": {"vr": "OW", "BinaryLength": 24576},
        "2558": {"vr": "OW", "BinaryLength": 24576},
        "2559": {"vr": "OW", "BinaryLength": 24576},
        "2560": {"vr": "OW", "BinaryLength": 24576},
        "2561": {"vr": "OW", "BinaryLength": 24576},
        "2562": {"vr": "OW", "BinaryLength": 24576},
        "2563": {"vr": "OW", "BinaryLength": 24576},
        "2564": {"vr": "OW", "BinaryLength": 24576},
        "2565": {"vr": "OW", "BinaryLength": 24576},
        "2566": {"vr": "OW", "BinaryLength": 24576},
        "2567": {"vr": "OW", "BinaryLength": 24576},
        "2568": {"vr": "OW", "BinaryLength": 24576},
        "2569": {"vr": "OW", "BinaryLength": 24576},
        "2570": {"vr": "OW", "BinaryLength": 24576},
        "2571": {"vr": "OW", "BinaryLength": 24576},
        "2572": {"vr": "OW", "BinaryLength": 24576},
        "2573": {"vr": "OW", "BinaryLength": 24576},
        "2574": {"vr": "OW", "BinaryLength": 24576},
        "2575": {"vr": "OW", "BinaryLength": 24576},
        "2576": {"vr": "OW", "BinaryLength": 24576},
        "2577": {"vr": "OW", "BinaryLength": 24576},
        "2578": {"vr": "OW", "BinaryLength": 24576},
        "2579": {"vr": "OW", "BinaryLength": 24576},
        "2580": {"vr": "OW", "BinaryLength": 24576},
        "2581": {"vr": "OW", "BinaryLength": 24576},
        "2582": {"vr": "OW", "BinaryLength": 24576},
        "2583": {"vr": "OW", "BinaryLength": 24576},
        "2584": {"vr": "OW", "BinaryLength": 24576},
        "2585": {"vr": "OW", "BinaryLength": 24576},
        "2586": {"vr": "OW", "BinaryLength": 24576},
        "2587": {"vr": "OW", "BinaryLength": 24576},
        "2588": {"vr": "OW", "BinaryLength": 24576},
        "2589": {"vr": "OW", "BinaryLength": 24576},
        "2590": {"vr": "OW", "BinaryLength": 24576},
        "2591": {"vr": "OW", "BinaryLength": 24576},
        "2592": {"vr": "OW", "BinaryLength": 24576},
        "2593": {"vr": "OW", "BinaryLength": 24576},
        "2594": {"vr": "OW", "BinaryLength": 24576},
        "2595": {"vr": "OW", "BinaryLength": 24576},
        "2596": {"vr": "OW", "BinaryLength": 24576},
        "2597": {"vr": "OW", "BinaryLength": 24576},
        "2598": {"vr": "OW", "BinaryLength": 24576},
        "2599": {"vr": "OW", "BinaryLength": 24576},
        "2600": {"vr": "OW", "BinaryLength": 24576},
        "2601": {"vr": "OW", "BinaryLength": 24576},
        "2602": {"vr": "OW", "BinaryLength": 24576},
        "2603": {"vr": "OW", "BinaryLength": 24576},
        "2604": {"vr": "OW", "BinaryLength": 24576},
        "2605": {"vr": "OW", "BinaryLength": 24576},
        "2606": {"vr": "OW", "BinaryLength": 24576},
        "2607": {"vr": "OW", "BinaryLength": 24576},
        "2608": {"vr": "OW", "BinaryLength": 24576},
        "2609": {"vr": "OW", "BinaryLength": 24576},
        "2610": {"vr": "OW", "BinaryLength": 24576},
        "2611": {"vr": "OW", "BinaryLength": 24576},
        "2612": {"vr": "OW", "BinaryLength": 24576},
        "2613": {"vr": "OW", "BinaryLength": 24576},
        "2614": {"vr": "OW", "BinaryLength": 24576},
        "2615": {"vr": "OW", "BinaryLength": 24576},
        "2616": {"vr": "OW", "BinaryLength": 24576},
        "2617": {"vr": "OW", "BinaryLength": 24576},
        "2618": {"vr": "OW", "BinaryLength": 24576},
        "2619": {"vr": "OW", "BinaryLength": 24576},
        "2620": {"vr": "OW", "BinaryLength": 24576},
        "2621": {"vr": "OW", "BinaryLength": 24576},
        "2622": {"vr": "OW", "BinaryLength": 24576},
        "2623": {"vr": "OW", "BinaryLength": 24576},
        "2624": {"vr": "OW", "BinaryLength": 24576},
        "2625": {"vr": "OW", "BinaryLength": 24576},
        "2626": {"vr": "OW", "BinaryLength": 24576},
        "2627": {"vr": "OW", "BinaryLength": 24576},
        "2628": {"vr": "OW", "BinaryLength": 24576},
        "2629": {"vr": "OW", "BinaryLength": 24576},
        "2630": {"vr": "OW", "BinaryLength": 24576},
        "2631": {"vr": "OW", "BinaryLength": 24576},
        "2632": {"vr": "OW", "BinaryLength": 24576},
        "2633": {"vr": "OW", "BinaryLength": 24576},
        "2634": {"vr": "OW", "BinaryLength": 24576},
        "2635": {"vr": "OW", "BinaryLength": 24576},
        "2636": {"vr": "OW", "BinaryLength": 24576},
        "2637": {"vr": "OW", "BinaryLength": 24576},
        "2638": {"vr": "OW", "BinaryLength": 24576},
        "2639": {"vr": "OW", "BinaryLength": 24576},
        "2640": {"vr": "OW", "BinaryLength": 24576},
        "2641": {"vr": "OW", "BinaryLength": 24576},
        "2642": {"vr": "OW", "BinaryLength": 24576},
        "2643": {"vr": "OW", "BinaryLength": 24576},
        "2644": {"vr": "OW", "BinaryLength": 24576},
        "2645": {"vr": "OW", "BinaryLength": 24576},
        "2646": {"vr": "OW", "BinaryLength": 24576},
        "2647": {"vr": "OW", "BinaryLength": 24576},
        "2648": {"vr": "OW", "BinaryLength": 24576},
        "2649": {"vr": "OW", "BinaryLength": 24576},
        "2650": {"vr": "OW", "BinaryLength": 24576},
        "2651": {"vr": "OW", "BinaryLength": 24576},
        "2652": {"vr": "OW", "BinaryLength": 24576},
        "2653": {"vr": "OW", "BinaryLength": 24576},
        "2654": {"vr": "OW", "BinaryLength": 24576},
        "2655": {"vr": "OW", "BinaryLength": 24576},
        "2656": {"vr": "OW", "BinaryLength": 24576},
        "2657": {"vr": "OW", "BinaryLength": 24576},
        "2658": {"vr": "OW", "BinaryLength": 24576},
        "2659": {"vr": "OW", "BinaryLength": 24576},
        "2660": {"vr": "OW", "BinaryLength": 24576},
        "2661": {"vr": "OW", "BinaryLength": 24576},
        "2662": {"vr": "OW", "BinaryLength": 24576},
        "2663": {"vr": "OW", "BinaryLength": 24576},
        "2664": {"vr": "OW", "BinaryLength": 24576},
        "2665": {"vr": "OW", "BinaryLength": 24576},
        "2666": {"vr": "OW", "BinaryLength": 24576},
        "2667": {"vr": "OW", "BinaryLength": 24576},
        "2668": {"vr": "OW", "BinaryLength": 24576},
        "2669": {"vr": "OW", "BinaryLength": 24576},
        "2670": {"vr": "OW", "BinaryLength": 24576},
        "2671": {"vr": "OW", "BinaryLength": 24576},
        "2672": {"vr": "OW", "BinaryLength": 24576},
        "2673": {"vr": "OW", "BinaryLength": 24576},
        "2674": {"vr": "OW", "BinaryLength": 24576},
        "2675": {"vr": "OW", "BinaryLength": 24576},
        "2676": {"vr": "OW", "BinaryLength": 24576},
        "2677": {"vr": "OW", "BinaryLength": 24576},
        "2678": {"vr": "OW", "BinaryLength": 24576},
        "2679": {"vr": "OW", "BinaryLength": 24576},
        "2680": {"vr": "OW", "BinaryLength": 24576},
        "2681": {"vr": "OW", "BinaryLength": 24576},
        "2682": {"vr": "OW", "BinaryLength": 24576},
        "2683": {"vr": "OW", "BinaryLength": 24576},
        "2684": {"vr": "OW", "BinaryLength": 24576},
        "2685": {"vr": "OW", "BinaryLength": 24576},
        "2686": {"vr": "OW", "BinaryLength": 24576},
        "2687": {"vr": "OW", "BinaryLength": 24576},
        "2688": {"vr": "OW", "BinaryLength": 24576},
        "2689": {"vr": "OW", "BinaryLength": 24576},
        "2690": {"vr": "OW", "BinaryLength": 24576},
        "2691": {"vr": "OW", "BinaryLength": 24576},
        "2692": {"vr": "OW", "BinaryLength": 24576},
        "2693": {"vr": "OW", "BinaryLength": 24576},
        "2694": {"vr": "OW", "BinaryLength": 24576},
        "2695": {"vr": "OW", "BinaryLength": 24576},
        "2696": {"vr": "OW", "BinaryLength": 24576},
        "2697": {"vr": "OW", "BinaryLength": 24576},
        "2698": {"vr": "OW", "BinaryLength": 24576},
        "2699": {"vr": "OW", "BinaryLength": 24576},
        "2700": {"vr": "OW", "BinaryLength": 24576},
        "2701": {"vr": "OW", "BinaryLength": 24576},
        "2702": {"vr": "OW", "BinaryLength": 24576},
        "2703": {"vr": "OW", "BinaryLength": 24576},
        "2704": {"vr": "OW", "BinaryLength": 24576},
        "2705": {"vr": "OW", "BinaryLength": 24576},
        "2706": {"vr": "OW", "BinaryLength": 24576},
        "2707": {"vr": "OW", "BinaryLength": 24576},
        "2708": {"vr": "OW", "BinaryLength": 24576},
        "2709": {"vr": "OW", "BinaryLength": 24576},
        "2710": {"vr": "OW", "BinaryLength": 24576},
        "2711": {"vr": "OW", "BinaryLength": 24576},
        "2712": {"vr": "OW", "BinaryLength": 24576},
        "2713": {"vr": "OW", "BinaryLength": 24576},
        "2714": {"vr": "OW", "BinaryLength": 24576},
        "2715": {"vr": "OW", "BinaryLength": 24576},
        "2716": {"vr": "OW", "BinaryLength": 24576},
        "2717": {"vr": "OW", "BinaryLength": 24576},
        "2718": {"vr": "OW", "BinaryLength": 24576},
        "2719": {"vr": "OW", "BinaryLength": 24576},
        "2720": {"vr": "OW", "BinaryLength": 24576},
        "2721": {"vr": "OW", "BinaryLength": 24576},
        "2722": {"vr": "OW", "BinaryLength": 24576},
        "2723": {"vr": "OW", "BinaryLength": 24576},
        "2724": {"vr": "OW", "BinaryLength": 24576},
        "2725": {"vr": "OW", "BinaryLength": 24576},
        "2726": {"vr": "OW", "BinaryLength": 24576},
        "2727": {"vr": "OW", "BinaryLength": 24576},
        "2728": {"vr": "OW", "BinaryLength": 24576},
        "2729": {"vr": "OW", "BinaryLength": 24576},
        "2730": {"vr": "OW", "BinaryLength": 24576},
        "2731": {"vr": "OW", "BinaryLength": 24576},
        "2732": {"vr": "OW", "BinaryLength": 24576},
        "2733": {"vr": "OW", "BinaryLength": 24576},
        "2734": {"vr": "OW", "BinaryLength": 24576},
        "2735": {"vr": "OW", "BinaryLength": 24576},
        "2736": {"vr": "OW", "BinaryLength": 24576},
        "2737": {"vr": "OW", "BinaryLength": 24576},
        "2738": {"vr": "OW", "BinaryLength": 24576},
        "2739": {"vr": "OW", "BinaryLength": 24576},
        "2740": {"vr": "OW", "BinaryLength": 24576},
        "2741": {"vr": "OW", "BinaryLength": 24576},
        "2742": {"vr": "OW", "BinaryLength": 24576},
        "2743": {"vr": "OW", "BinaryLength": 24576},
        "2744": {"vr": "OW", "BinaryLength": 24576},
        "2745": {"vr": "OW", "BinaryLength": 24576},
        "2746": {"vr": "OW", "BinaryLength": 24576},
        "2747": {"vr": "OW", "BinaryLength": 24576},
        "2748": {"vr": "OW", "BinaryLength": 24576},
        "2749": {"vr": "OW", "BinaryLength": 24576},
        "2750": {"vr": "OW", "BinaryLength": 24576},
        "2751": {"vr": "OW", "BinaryLength": 24576},
        "2752": {"vr": "OW", "BinaryLength": 24576},
        "2753": {"vr": "OW", "BinaryLength": 24576},
        "2754": {"vr": "OW", "BinaryLength": 24576},
        "2755": {"vr": "OW", "BinaryLength": 24576},
        "2756": {"vr": "OW", "BinaryLength": 24576},
        "2757": {"vr": "OW", "BinaryLength": 24576},
        "2758": {"vr": "OW", "BinaryLength": 24576},
        "2759": {"vr": "OW", "BinaryLength": 24576},
        "2760": {"vr": "OW", "BinaryLength": 24576},
        "2761": {"vr": "OW", "BinaryLength": 24576},
        "2762": {"vr": "OW", "BinaryLength": 24576},
        "2763": {"vr": "OW", "BinaryLength": 24576},
        "2764": {"vr": "OW", "BinaryLength": 24576},
        "2765": {"vr": "OW", "BinaryLength": 24576},
        "2766": {"vr": "OW", "BinaryLength": 24576},
        "2767": {"vr": "OW", "BinaryLength": 24576},
        "2768": {"vr": "OW", "BinaryLength": 24576},
        "2769": {"vr": "OW", "BinaryLength": 24576},
        "2770": {"vr": "OW", "BinaryLength": 24576},
        "2771": {"vr": "OW", "BinaryLength": 24576},
        "2772": {"vr": "OW", "BinaryLength": 24576},
        "2773": {"vr": "OW", "BinaryLength": 24576},
        "2774": {"vr": "OW", "BinaryLength": 24576},
        "2775": {"vr": "OW", "BinaryLength": 24576},
        "2776": {"vr": "OW", "BinaryLength": 24576},
        "2777": {"vr": "OW", "BinaryLength": 24576},
        "2778": {"vr": "OW", "BinaryLength": 24576},
        "2779": {"vr": "OW", "BinaryLength": 24576},
        "2780": {"vr": "OW", "BinaryLength": 24576},
        "2781": {"vr": "OW", "BinaryLength": 24576},
        "2782": {"vr": "OW", "BinaryLength": 24576},
        "2783": {"vr": "OW", "BinaryLength": 24576},
        "2784": {"vr": "OW", "BinaryLength": 24576},
        "2785": {"vr": "OW", "BinaryLength": 24576},
        "2786": {"vr": "OW", "BinaryLength": 24576},
        "2787": {"vr": "OW", "BinaryLength": 24576},
        "2788": {"vr": "OW", "BinaryLength": 24576},
        "2789": {"vr": "OW", "BinaryLength": 24576},
        "2790": {"vr": "OW", "BinaryLength": 24576},
        "2791": {"vr": "OW", "BinaryLength": 24576},
        "2792": {"vr": "OW", "BinaryLength": 24576},
        "2793": {"vr": "OW", "BinaryLength": 24576},
        "2794": {"vr": "OW", "BinaryLength": 24576},
        "2795": {"vr": "OW", "BinaryLength": 24576},
        "2796": {"vr": "OW", "BinaryLength": 24576},
        "2797": {"vr": "OW", "BinaryLength": 24576},
        "2798": {"vr": "OW", "BinaryLength": 24576},
        "2799": {"vr": "OW", "BinaryLength": 24576},
        "2800": {"vr": "OW", "BinaryLength": 24576},
        "2801": {"vr": "OW", "BinaryLength": 24576},
        "2802": {"vr": "OW", "BinaryLength": 24576},
        "2803": {"vr": "OW", "BinaryLength": 24576},
        "2804": {"vr": "OW", "BinaryLength": 24576},
        "2805": {"vr": "OW", "BinaryLength": 24576},
        "2806": {"vr": "OW", "BinaryLength": 24576},
        "2807": {"vr": "OW", "BinaryLength": 24576},
        "2808": {"vr": "OW", "BinaryLength": 24576},
        "2809": {"vr": "OW", "BinaryLength": 24576},
        "2810": {"vr": "OW", "BinaryLength": 24576},
        "2811": {"vr": "OW", "BinaryLength": 24576},
        "2812": {"vr": "OW", "BinaryLength": 24576},
        "2813": {"vr": "OW", "BinaryLength": 24576},
        "2814": {"vr": "OW", "BinaryLength": 24576},
        "2815": {"vr": "OW", "BinaryLength": 24576},
        "2816": {"vr": "OW", "BinaryLength": 24576},
        "2817": {"vr": "OW", "BinaryLength": 24576},
        "2818": {"vr": "OW", "BinaryLength": 24576},
        "2819": {"vr": "OW", "BinaryLength": 24576},
        "2820": {"vr": "OW", "BinaryLength": 24576},
        "2821": {"vr": "OW", "BinaryLength": 24576},
        "2822": {"vr": "OW", "BinaryLength": 24576},
        "2823": {"vr": "OW", "BinaryLength": 24576},
        "2824": {"vr": "OW", "BinaryLength": 24576},
        "2825": {"vr": "OW", "BinaryLength": 24576},
        "2826": {"vr": "OW", "BinaryLength": 24576},
        "2827": {"vr": "OW", "BinaryLength": 24576},
        "2828": {"vr": "OW", "BinaryLength": 24576},
        "2829": {"vr": "OW", "BinaryLength": 24576},
        "2830": {"vr": "OW", "BinaryLength": 24576},
        "2831": {"vr": "OW", "BinaryLength": 24576},
        "2832": {"vr": "OW", "BinaryLength": 24576},
        "2833": {"vr": "OW", "BinaryLength": 24576},
        "2834": {"vr": "OW", "BinaryLength": 24576},
        "2835": {"vr": "OW", "BinaryLength": 24576},
        "2836": {"vr": "OW", "BinaryLength": 24576},
        "2837": {"vr": "OW", "BinaryLength": 24576},
        "2838": {"vr": "OW", "BinaryLength": 24576},
        "2839": {"vr": "OW", "BinaryLength": 24576},
        "2840": {"vr": "OW", "BinaryLength": 24576},
        "2841": {"vr": "OW", "BinaryLength": 24576},
        "2842": {"vr": "OW", "BinaryLength": 24576},
        "2843": {"vr": "OW", "BinaryLength": 24576},
        "2844": {"vr": "OW", "BinaryLength": 24576},
        "2845": {"vr": "OW", "BinaryLength": 24576},
        "2846": {"vr": "OW", "BinaryLength": 24576},
        "2847": {"vr": "OW", "BinaryLength": 24576},
        "2848": {"vr": "OW", "BinaryLength": 24576},
        "2849": {"vr": "OW", "BinaryLength": 24576},
        "2850": {"vr": "OW", "BinaryLength": 24576},
        "2851": {"vr": "OW", "BinaryLength": 24576},
        "2852": {"vr": "OW", "BinaryLength": 24576},
        "2853": {"vr": "OW", "BinaryLength": 24576},
        "2854": {"vr": "OW", "BinaryLength": 24576},
        "2855": {"vr": "OW", "BinaryLength": 24576},
        "2856": {"vr": "OW", "BinaryLength": 24576},
        "2857": {"vr": "OW", "BinaryLength": 24576},
        "2858": {"vr": "OW", "BinaryLength": 24576},
        "2859": {"vr": "OW", "BinaryLength": 24576},
        "2860": {"vr": "OW", "BinaryLength": 24576},
        "2861": {"vr": "OW", "BinaryLength": 24576},
        "2862": {"vr": "OW", "BinaryLength": 24576},
        "2863": {"vr": "OW", "BinaryLength": 24576},
        "2864": {"vr": "OW", "BinaryLength": 24576},
        "2865": {"vr": "OW", "BinaryLength": 24576},
        "2866": {"vr": "OW", "BinaryLength": 24576},
        "2867": {"vr": "OW", "BinaryLength": 24576},
        "2868": {"vr": "OW", "BinaryLength": 24576},
        "2869": {"vr": "OW", "BinaryLength": 24576},
        "2870": {"vr": "OW", "BinaryLength": 24576},
        "2871": {"vr": "OW", "BinaryLength": 24576},
        "2872": {"vr": "OW", "BinaryLength": 24576},
        "2873": {"vr": "OW", "BinaryLength": 24576},
        "2874": {"vr": "OW", "BinaryLength": 24576},
        "2875": {"vr": "OW", "BinaryLength": 24576},
        "2876": {"vr": "OW", "BinaryLength": 24576},
        "2877": {"vr": "OW", "BinaryLength": 24576},
        "2878": {"vr": "OW", "BinaryLength": 24576},
        "2879": {"vr": "OW", "BinaryLength": 24576},
        "2880": {"vr": "OW", "BinaryLength": 24576},
        "2881": {"vr": "OW", "BinaryLength": 24576},
        "2882": {"vr": "OW", "BinaryLength": 24576},
        "2883": {"vr": "OW", "BinaryLength": 24576},
        "2884": {"vr": "OW", "BinaryLength": 24576},
        "2885": {"vr": "OW", "BinaryLength": 24576},
        "2886": {"vr": "OW", "BinaryLength": 24576},
        "2887": {"vr": "OW", "BinaryLength": 24576},
        "2888": {"vr": "OW", "BinaryLength": 24576},
        "2889": {"vr": "OW", "BinaryLength": 24576},
        "2890": {"vr": "OW", "BinaryLength": 24576},
        "2891": {"vr": "OW", "BinaryLength": 24576},
        "2892": {"vr": "OW", "BinaryLength": 24576},
        "2893": {"vr": "OW", "BinaryLength": 24576},
        "2894": {"vr": "OW", "BinaryLength": 24576},
        "2895": {"vr": "OW", "BinaryLength": 24576},
        "2896": {"vr": "OW", "BinaryLength": 24576},
        "2897": {"vr": "OW", "BinaryLength": 24576},
        "2898": {"vr": "OW", "BinaryLength": 24576},
        "2899": {"vr": "OW", "BinaryLength": 24576},
        "2900": {"vr": "OW", "BinaryLength": 24576},
        "2901": {"vr": "OW", "BinaryLength": 24576},
        "2902": {"vr": "OW", "BinaryLength": 24576},
        "2903": {"vr": "OW", "BinaryLength": 24576},
        "2904": {"vr": "OW", "BinaryLength": 24576},
        "2905": {"vr": "OW", "BinaryLength": 24576},
        "2906": {"vr": "OW", "BinaryLength": 24576},
        "2907": {"vr": "OW", "BinaryLength": 24576},
        "2908": {"vr": "OW", "BinaryLength": 24576},
        "2909": {"vr": "OW", "BinaryLength": 24576},
        "2910": {"vr": "OW", "BinaryLength": 24576},
        "2911": {"vr": "OW", "BinaryLength": 24576},
        "2912": {"vr": "OW", "BinaryLength": 24576},
        "2913": {"vr": "OW", "BinaryLength": 24576},
        "2914": {"vr": "OW", "BinaryLength": 24576},
        "2915": {"vr": "OW", "BinaryLength": 24576},
        "2916": {"vr": "OW", "BinaryLength": 24576},
        "2917": {"vr": "OW", "BinaryLength": 24576},
        "2918": {"vr": "OW", "BinaryLength": 24576},
        "2919": {"vr": "OW", "BinaryLength": 24576},
        "2920": {"vr": "OW", "BinaryLength": 24576},
        "2921": {"vr": "OW", "BinaryLength": 24576},
        "2922": {"vr": "OW", "BinaryLength": 24576},
        "2923": {"vr": "OW", "BinaryLength": 24576},
        "2924": {"vr": "OW", "BinaryLength": 24576},
        "2925": {"vr": "OW", "BinaryLength": 24576},
        "2926": {"vr": "OW", "BinaryLength": 24576},
        "2927": {"vr": "OW", "BinaryLength": 24576},
        "2928": {"vr": "OW", "BinaryLength": 24576},
        "2929": {"vr": "OW", "BinaryLength": 24576},
        "2930": {"vr": "OW", "BinaryLength": 24576},
        "2931": {"vr": "OW", "BinaryLength": 24576},
        "2932": {"vr": "OW", "BinaryLength": 24576},
        "2933": {"vr": "OW", "BinaryLength": 24576},
        "2934": {"vr": "OW", "BinaryLength": 24576},
        "2935": {"vr": "OW", "BinaryLength": 24576},
        "2936": {"vr": "OW", "BinaryLength": 24576},
        "2937": {"vr": "OW", "BinaryLength": 24576},
        "2938": {"vr": "OW", "BinaryLength": 24576},
        "2939": {"vr": "OW", "BinaryLength": 24576},
        "2940": {"vr": "OW", "BinaryLength": 24576},
        "2941": {"vr": "OW", "BinaryLength": 24576},
        "2942": {"vr": "OW", "BinaryLength": 24576},
        "2943": {"vr": "OW", "BinaryLength": 24576},
        "2944": {"vr": "OW", "BinaryLength": 24576},
        "2945": {"vr": "OW", "BinaryLength": 24576},
        "2946": {"vr": "OW", "BinaryLength": 24576},
        "2947": {"vr": "OW", "BinaryLength": 24576},
        "2948": {"vr": "OW", "BinaryLength": 24576},
        "2949": {"vr": "OW", "BinaryLength": 24576},
        "2950": {"vr": "OW", "BinaryLength": 24576},
        "2951": {"vr": "OW", "BinaryLength": 24576},
        "2952": {"vr": "OW", "BinaryLength": 24576},
        "2953": {"vr": "OW", "BinaryLength": 24576},
        "2954": {"vr": "OW", "BinaryLength": 24576},
        "2955": {"vr": "OW", "BinaryLength": 24576},
        "2956": {"vr": "OW", "BinaryLength": 24576},
        "2957": {"vr": "OW", "BinaryLength": 24576},
        "2958": {"vr": "OW", "BinaryLength": 24576},
        "2959": {"vr": "OW", "BinaryLength": 24576},
        "2960": {"vr": "OW", "BinaryLength": 24576},
        "2961": {"vr": "OW", "BinaryLength": 24576},
        "2962": {"vr": "OW", "BinaryLength": 24576},
        "2963": {"vr": "OW", "BinaryLength": 24576},
        "2964": {"vr": "OW", "BinaryLength": 24576},
        "2965": {"vr": "OW", "BinaryLength": 24576},
        "2966": {"vr": "OW", "BinaryLength": 24576},
        "2967": {"vr": "OW", "BinaryLength": 24576},
        "2968": {"vr": "OW", "BinaryLength": 24576},
        "2969": {"vr": "OW", "BinaryLength": 24576},
        "2970": {"vr": "OW", "BinaryLength": 24576},
        "2971": {"vr": "OW", "BinaryLength": 24576},
        "2972": {"vr": "OW", "BinaryLength": 24576},
        "2973": {"vr": "OW", "BinaryLength": 24576},
        "2974": {"vr": "OW", "BinaryLength": 24576},
        "2975": {"vr": "OW", "BinaryLength": 24576},
        "2976": {"vr": "OW", "BinaryLength": 24576},
        "2977": {"vr": "OW", "BinaryLength": 24576},
        "2978": {"vr": "OW", "BinaryLength": 24576},
        "2979": {"vr": "OW", "BinaryLength": 24576},
        "2980": {"vr": "OW", "BinaryLength": 24576},
        "2981": {"vr": "OW", "BinaryLength": 24576},
        "2982": {"vr": "OW", "BinaryLength": 24576},
        "2983": {"vr": "OW", "BinaryLength": 24576},
        "2984": {"vr": "OW", "BinaryLength": 24576},
        "2985": {"vr": "OW", "BinaryLength": 24576},
        "2986": {"vr": "OW", "BinaryLength": 24576},
        "2987": {"vr": "OW", "BinaryLength": 24576},
        "2988": {"vr": "OW", "BinaryLength": 24576},
        "2989": {"vr": "OW", "BinaryLength": 24576},
        "2990": {"vr": "OW", "BinaryLength": 24576},
        "2991": {"vr": "OW", "BinaryLength": 24576},
        "2992": {"vr": "OW", "BinaryLength": 24576},
        "2993": {"vr": "OW", "BinaryLength": 24576},
        "2994": {"vr": "OW", "BinaryLength": 24576},
        "2995": {"vr": "OW", "BinaryLength": 24576},
        "2996": {"vr": "OW", "BinaryLength": 24576},
        "2997": {"vr": "OW", "BinaryLength": 24576},
        "2998": {"vr": "OW", "BinaryLength": 24576},
        "2999": {"vr": "OW", "BinaryLength": 24576},
        "3000": {"vr": "OW", "BinaryLength": 24576},
        "3001": {"vr": "OW", "BinaryLength": 24576},
        "3002": {"vr": "OW", "BinaryLength": 24576},
        "3003": {"vr": "OW", "BinaryLength": 24576},
        "3004": {"vr": "OW", "BinaryLength": 24576},
        "3005": {"vr": "OW", "BinaryLength": 24576},
        "3006": {"vr": "OW", "BinaryLength": 24576},
        "3007": {"vr": "OW", "BinaryLength": 24576},
        "3008": {"vr": "OW", "BinaryLength": 24576},
        "3009": {"vr": "OW", "BinaryLength": 24576},
        "3010": {"vr": "OW", "BinaryLength": 24576},
        "3011": {"vr": "OW", "BinaryLength": 24576},
        "3012": {"vr": "OW", "BinaryLength": 24576},
        "3013": {"vr": "OW", "BinaryLength": 24576},
        "3014": {"vr": "OW", "BinaryLength": 24576},
        "3015": {"vr": "OW", "BinaryLength": 24576},
        "3016": {"vr": "OW", "BinaryLength": 24576},
        "3017": {"vr": "OW", "BinaryLength": 24576},
        "3018": {"vr": "OW", "BinaryLength": 24576},
        "3019": {"vr": "OW", "BinaryLength": 24576},
        "3020": {"vr": "OW", "BinaryLength": 24576},
        "3021": {"vr": "OW", "BinaryLength": 24576},
        "3022": {"vr": "OW", "BinaryLength": 24576},
        "3023": {"vr": "OW", "BinaryLength": 24576},
        "3024": {"vr": "OW", "BinaryLength": 24576},
        "3025": {"vr": "OW", "BinaryLength": 24576},
        "3026": {"vr": "OW", "BinaryLength": 24576},
        "3027": {"vr": "OW", "BinaryLength": 24576},
        "3028": {"vr": "OW", "BinaryLength": 24576},
        "3029": {"vr": "OW", "BinaryLength": 24576},
        "3030": {"vr": "OW", "BinaryLength": 24576},
        "3031": {"vr": "OW", "BinaryLength": 24576},
        "3032": {"vr": "OW", "BinaryLength": 24576},
        "3033": {"vr": "OW", "BinaryLength": 24576},
        "3034": {"vr": "OW", "BinaryLength": 24576},
        "3035": {"vr": "OW", "BinaryLength": 24576},
        "3036": {"vr": "OW", "BinaryLength": 24576},
        "3037": {"vr": "OW", "BinaryLength": 24576},
        "3038": {"vr": "OW", "BinaryLength": 24576},
        "3039": {"vr": "OW", "BinaryLength": 24576},
        "3040": {"vr": "OW", "BinaryLength": 24576},
        "3041": {"vr": "OW", "BinaryLength": 24576},
        "3042": {"vr": "OW", "BinaryLength": 24576},
        "3043": {"vr": "OW", "BinaryLength": 24576},
        "3044": {"vr": "OW", "BinaryLength": 24576},
        "3045": {"vr": "OW", "BinaryLength": 24576},
        "3046": {"vr": "OW", "BinaryLength": 24576},
        "3047": {"vr": "OW", "BinaryLength": 24576},
        "3048": {"vr": "OW", "BinaryLength": 24576},
        "3049": {"vr": "OW", "BinaryLength": 24576},
        "3050": {"vr": "OW", "BinaryLength": 24576},
        "3051": {"vr": "OW", "BinaryLength": 24576},
        "3052": {"vr": "OW", "BinaryLength": 24576},
        "3053": {"vr": "OW", "BinaryLength": 24576},
        "3054": {"vr": "OW", "BinaryLength": 24576},
        "3055": {"vr": "OW", "BinaryLength": 24576},
        "3056": {"vr": "OW", "BinaryLength": 24576},
        "3057": {"vr": "OW", "BinaryLength": 24576},
        "3058": {"vr": "OW", "BinaryLength": 24576},
        "3059": {"vr": "OW", "BinaryLength": 24576},
        "3060": {"vr": "OW", "BinaryLength": 24576},
        "3061": {"vr": "OW", "BinaryLength": 24576},
        "3062": {"vr": "OW", "BinaryLength": 24576},
        "3063": {"vr": "OW", "BinaryLength": 24576},
        "3064": {"vr": "OW", "BinaryLength": 24576},
        "3065": {"vr": "OW", "BinaryLength": 24576},
        "3066": {"vr": "OW", "BinaryLength": 24576},
        "3067": {"vr": "OW", "BinaryLength": 24576},
        "3068": {"vr": "OW", "BinaryLength": 24576},
        "3069": {"vr": "OW", "BinaryLength": 24576},
        "3070": {"vr": "OW", "BinaryLength": 24576},
        "3071": {"vr": "OW", "BinaryLength": 24576},
        "3072": {"vr": "OW", "BinaryLength": 24576},
        "3073": {"vr": "OW", "BinaryLength": 24576},
        "3074": {"vr": "OW", "BinaryLength": 24576},
        "3075": {"vr": "OW", "BinaryLength": 24576},
        "3076": {"vr": "OW", "BinaryLength": 24576},
        "3077": {"vr": "OW", "BinaryLength": 24576},
        "3078": {"vr": "OW", "BinaryLength": 24576},
        "3079": {"vr": "OW", "BinaryLength": 24576},
        "3080": {"vr": "OW", "BinaryLength": 24576},
        "3081": {"vr": "OW", "BinaryLength": 24576},
        "3082": {"vr": "OW", "BinaryLength": 24576},
        "3083": {"vr": "OW", "BinaryLength": 24576},
        "3084": {"vr": "OW", "BinaryLength": 24576},
        "3085": {"vr": "OW", "BinaryLength": 24576},
        "3086": {"vr": "OW", "BinaryLength": 24576},
        "3087": {"vr": "OW", "BinaryLength": 24576},
        "3088": {"vr": "OW", "BinaryLength": 24576},
        "3089": {"vr": "OW", "BinaryLength": 24576},
        "3090": {"vr": "OW", "BinaryLength": 24576},
        "3091": {"vr": "OW", "BinaryLength": 24576},
        "3092": {"vr": "OW", "BinaryLength": 24576},
        "3093": {"vr": "OW", "BinaryLength": 24576},
        "3094": {"vr": "OW", "BinaryLength": 24576},
        "3095": {"vr": "OW", "BinaryLength": 24576},
        "3096": {"vr": "OW", "BinaryLength": 24576},
        "3097": {"vr": "OW", "BinaryLength": 24576},
        "3098": {"vr": "OW", "BinaryLength": 24576},
        "3099": {"vr": "OW", "BinaryLength": 24576},
        "3100": {"vr": "OW", "BinaryLength": 24576},
        "3101": {"vr": "OW", "BinaryLength": 24576},
        "3102": {"vr": "OW", "BinaryLength": 24576},
        "3103": {"vr": "OW", "BinaryLength": 24576},
        "3104": {"vr": "OW", "BinaryLength": 24576},
        "3105": {"vr": "OW", "BinaryLength": 24576},
        "3106": {"vr": "OW", "BinaryLength": 24576},
        "3107": {"vr": "OW", "BinaryLength": 24576},
        "3108": {"vr": "OW", "BinaryLength": 24576},
        "3109": {"vr": "OW", "BinaryLength": 24576},
        "3110": {"vr": "OW", "BinaryLength": 24576},
        "3111": {"vr": "OW", "BinaryLength": 24576},
        "3112": {"vr": "OW", "BinaryLength": 24576},
        "3113": {"vr": "OW", "BinaryLength": 24576},
        "3114": {"vr": "OW", "BinaryLength": 24576},
        "3115": {"vr": "OW", "BinaryLength": 24576},
        "3116": {"vr": "OW", "BinaryLength": 24576},
        "3117": {"vr": "OW", "BinaryLength": 24576},
        "3118": {"vr": "OW", "BinaryLength": 24576},
        "3119": {"vr": "OW", "BinaryLength": 24576},
        "3120": {"vr": "OW", "BinaryLength": 24576},
        "3121": {"vr": "OW", "BinaryLength": 24576},
        "3122": {"vr": "OW", "BinaryLength": 24576},
        "3123": {"vr": "OW", "BinaryLength": 24576},
        "3124": {"vr": "OW", "BinaryLength": 24576},
        "3125": {"vr": "OW", "BinaryLength": 24576},
        "3126": {"vr": "OW", "BinaryLength": 24576},
        "3127": {"vr": "OW", "BinaryLength": 24576},
        "3128": {"vr": "OW", "BinaryLength": 24576},
        "3129": {"vr": "OW", "BinaryLength": 24576},
        "3130": {"vr": "OW", "BinaryLength": 24576},
        "3131": {"vr": "OW", "BinaryLength": 24576},
        "3132": {"vr": "OW", "BinaryLength": 24576},
        "3133": {"vr": "OW", "BinaryLength": 24576},
        "3134": {"vr": "OW", "BinaryLength": 24576},
        "3135": {"vr": "OW", "BinaryLength": 24576},
        "3136": {"vr": "OW", "BinaryLength": 24576},
        "3137": {"vr": "OW", "BinaryLength": 24576},
        "3138": {"vr": "OW", "BinaryLength": 24576},
        "3139": {"vr": "OW", "BinaryLength": 24576},
        "3140": {"vr": "OW", "BinaryLength": 24576},
        "3141": {"vr": "OW", "BinaryLength": 24576},
        "3142": {"vr": "OW", "BinaryLength": 24576},
        "3143": {"vr": "OW", "BinaryLength": 24576},
        "3144": {"vr": "OW", "BinaryLength": 24576},
        "3145": {"vr": "OW", "BinaryLength": 24576},
        "3146": {"vr": "OW", "BinaryLength": 24576},
        "3147": {"vr": "OW", "BinaryLength": 24576},
        "3148": {"vr": "OW", "BinaryLength": 24576},
        "3149": {"vr": "OW", "BinaryLength": 24576},
        "3150": {"vr": "OW", "BinaryLength": 24576},
        "3151": {"vr": "OW", "BinaryLength": 24576},
        "3152": {"vr": "OW", "BinaryLength": 24576},
        "3153": {"vr": "OW", "BinaryLength": 24576},
        "3154": {"vr": "OW", "BinaryLength": 24576},
        "3155": {"vr": "OW", "BinaryLength": 24576},
        "3156": {"vr": "OW", "BinaryLength": 24576},
        "3157": {"vr": "OW", "BinaryLength": 24576},
        "3158": {"vr": "OW", "BinaryLength": 24576},
        "3159": {"vr": "OW", "BinaryLength": 24576},
        "3160": {"vr": "OW", "BinaryLength": 24576},
        "3161": {"vr": "OW", "BinaryLength": 24576},
        "3162": {"vr": "OW", "BinaryLength": 24576},
        "3163": {"vr": "OW", "BinaryLength": 24576},
        "3164": {"vr": "OW", "BinaryLength": 24576},
        "3165": {"vr": "OW", "BinaryLength": 24576},
        "3166": {"vr": "OW", "BinaryLength": 24576},
        "3167": {"vr": "OW", "BinaryLength": 24576},
        "3168": {"vr": "OW", "BinaryLength": 24576},
        "3169": {"vr": "OW", "BinaryLength": 24576},
        "3170": {"vr": "OW", "BinaryLength": 24576},
        "3171": {"vr": "OW", "BinaryLength": 24576},
        "3172": {"vr": "OW", "BinaryLength": 24576},
        "3173": {"vr": "OW", "BinaryLength": 24576},
        "3174": {"vr": "OW", "BinaryLength": 24576},
        "3175": {"vr": "OW", "BinaryLength": 24576},
        "3176": {"vr": "OW", "BinaryLength": 24576},
        "3177": {"vr": "OW", "BinaryLength": 24576},
        "3178": {"vr": "OW", "BinaryLength": 24576},
        "3179": {"vr": "OW", "BinaryLength": 24576},
        "3180": {"vr": "OW", "BinaryLength": 24576},
        "3181": {"vr": "OW", "BinaryLength": 24576},
        "3182": {"vr": "OW", "BinaryLength": 24576},
        "3183": {"vr": "OW", "BinaryLength": 24576},
        "3184": {"vr": "OW", "BinaryLength": 24576},
        "3185": {"vr": "OW", "BinaryLength": 24576},
        "3186": {"vr": "OW", "BinaryLength": 24576},
        "3187": {"vr": "OW", "BinaryLength": 24576},
        "3188": {"vr": "OW", "BinaryLength": 24576},
        "3189": {"vr": "OW", "BinaryLength": 24576},
        "3190": {"vr": "OW", "BinaryLength": 24576},
        "3191": {"vr": "OW", "BinaryLength": 24576},
        "3192": {"vr": "OW", "BinaryLength": 24576},
        "3193": {"vr": "OW", "BinaryLength": 24576},
        "3194": {"vr": "OW", "BinaryLength": 24576},
        "3195": {"vr": "OW", "BinaryLength": 24576},
        "3196": {"vr": "OW", "BinaryLength": 24576},
        "3197": {"vr": "OW", "BinaryLength": 24576},
        "3198": {"vr": "OW", "BinaryLength": 24576},
        "3199": {"vr": "OW", "BinaryLength": 24576},
        "3200": {"vr": "OW", "BinaryLength": 24576},
        "3201": {"vr": "OW", "BinaryLength": 24576},
        "3202": {"vr": "OW", "BinaryLength": 24576},
        "3203": {"vr": "OW", "BinaryLength": 24576},
        "3204": {"vr": "OW", "BinaryLength": 24576},
        "3205": {"vr": "OW", "BinaryLength": 24576},
        "3206": {"vr": "OW", "BinaryLength": 24576},
        "3207": {"vr": "OW", "BinaryLength": 24576},
        "3208": {"vr": "OW", "BinaryLength": 24576},
        "3209": {"vr": "OW", "BinaryLength": 24576},
        "3210": {"vr": "OW", "BinaryLength": 24576},
        "3211": {"vr": "OW", "BinaryLength": 24576},
        "3212": {"vr": "OW", "BinaryLength": 24576},
        "3213": {"vr": "OW", "BinaryLength": 24576},
        "3214": {"vr": "OW", "BinaryLength": 24576},
        "3215": {"vr": "OW", "BinaryLength": 24576},
        "3216": {"vr": "OW", "BinaryLength": 24576},
        "3217": {"vr": "OW", "BinaryLength": 24576},
        "3218": {"vr": "OW", "BinaryLength": 24576},
        "3219": {"vr": "OW", "BinaryLength": 24576},
        "3220": {"vr": "OW", "BinaryLength": 24576},
        "3221": {"vr": "OW", "BinaryLength": 24576},
        "3222": {"vr": "OW", "BinaryLength": 24576},
        "3223": {"vr": "OW", "BinaryLength": 24576},
        "3224": {"vr": "OW", "BinaryLength": 24576},
        "3225": {"vr": "OW", "BinaryLength": 24576},
        "3226": {"vr": "OW", "BinaryLength": 24576},
        "3227": {"vr": "OW", "BinaryLength": 24576},
        "3228": {"vr": "OW", "BinaryLength": 24576},
        "3229": {"vr": "OW", "BinaryLength": 24576},
        "3230": {"vr": "OW", "BinaryLength": 24576},
        "3231": {"vr": "OW", "BinaryLength": 24576},
        "3232": {"vr": "OW", "BinaryLength": 24576},
        "3233": {"vr": "OW", "BinaryLength": 24576},
        "3234": {"vr": "OW", "BinaryLength": 24576},
        "3235": {"vr": "OW", "BinaryLength": 24576},
        "3236": {"vr": "OW", "BinaryLength": 24576},
        "3237": {"vr": "OW", "BinaryLength": 24576},
        "3238": {"vr": "OW", "BinaryLength": 24576},
        "3239": {"vr": "OW", "BinaryLength": 24576},
        "3240": {"vr": "OW", "BinaryLength": 24576},
        "3241": {"vr": "OW", "BinaryLength": 24576},
        "3242": {"vr": "OW", "BinaryLength": 24576},
        "3243": {"vr": "OW", "BinaryLength": 24576},
        "3244": {"vr": "OW", "BinaryLength": 24576},
        "3245": {"vr": "OW", "BinaryLength": 24576},
        "3246": {"vr": "OW", "BinaryLength": 24576},
        "3247": {"vr": "OW", "BinaryLength": 24576},
        "3248": {"vr": "OW", "BinaryLength": 24576},
        "3249": {"vr": "OW", "BinaryLength": 24576},
        "3250": {"vr": "OW", "BinaryLength": 24576},
        "3251": {"vr": "OW", "BinaryLength": 24576},
        "3252": {"vr": "OW", "BinaryLength": 24576},
        "3253": {"vr": "OW", "BinaryLength": 24576},
        "3254": {"vr": "OW", "BinaryLength": 24576},
        "3255": {"vr": "OW", "BinaryLength": 24576},
        "3256": {"vr": "OW", "BinaryLength": 24576},
        "3257": {"vr": "OW", "BinaryLength": 24576},
        "3258": {"vr": "OW", "BinaryLength": 24576},
        "3259": {"vr": "OW", "BinaryLength": 24576},
        "3260": {"vr": "OW", "BinaryLength": 24576},
        "3261": {"vr": "OW", "BinaryLength": 24576},
        "3262": {"vr": "OW", "BinaryLength": 24576},
        "3263": {"vr": "OW", "BinaryLength": 24576},
        "3264": {"vr": "OW", "BinaryLength": 24576},
        "3265": {"vr": "OW", "BinaryLength": 24576},
        "3266": {"vr": "OW", "BinaryLength": 24576},
        "3267": {"vr": "OW", "BinaryLength": 24576},
        "3268": {"vr": "OW", "BinaryLength": 24576},
        "3269": {"vr": "OW", "BinaryLength": 24576},
        "3270": {"vr": "OW", "BinaryLength": 24576},
        "3271": {"vr": "OW", "BinaryLength": 24576},
        "3272": {"vr": "OW", "BinaryLength": 24576},
        "3273": {"vr": "OW", "BinaryLength": 24576},
        "3274": {"vr": "OW", "BinaryLength": 24576},
        "3275": {"vr": "OW", "BinaryLength": 24576},
        "3276": {"vr": "OW", "BinaryLength": 24576},
        "3277": {"vr": "OW", "BinaryLength": 24576},
        "3278": {"vr": "OW", "BinaryLength": 24576},
        "3279": {"vr": "OW", "BinaryLength": 24576},
        "3280": {"vr": "OW", "BinaryLength": 24576},
        "3281": {"vr": "OW", "BinaryLength": 24576},
        "3282": {"vr": "OW", "BinaryLength": 24576},
        "3283": {"vr": "OW", "BinaryLength": 24576},
        "3284": {"vr": "OW", "BinaryLength": 24576},
        "3285": {"vr": "OW", "BinaryLength": 24576},
        "3286": {"vr": "OW", "BinaryLength": 24576},
        "3287": {"vr": "OW", "BinaryLength": 24576},
        "3288": {"vr": "OW", "BinaryLength": 24576},
        "3289": {"vr": "OW", "BinaryLength": 24576},
        "3290": {"vr": "OW", "BinaryLength": 24576},
        "3291": {"vr": "OW", "BinaryLength": 24576},
        "3292": {"vr": "OW", "BinaryLength": 24576},
        "3293": {"vr": "OW", "BinaryLength": 24576},
        "3294": {"vr": "OW", "BinaryLength": 24576},
        "3295": {"vr": "OW", "BinaryLength": 24576},
        "3296": {"vr": "OW", "BinaryLength": 24576},
        "3297": {"vr": "OW", "BinaryLength": 24576},
        "3298": {"vr": "OW", "BinaryLength": 24576},
        "3299": {"vr": "OW", "BinaryLength": 24576},
        "3300": {"vr": "OW", "BinaryLength": 24576},
        "3301": {"vr": "OW", "BinaryLength": 24576},
        "3302": {"vr": "OW", "BinaryLength": 24576},
        "3303": {"vr": "OW", "BinaryLength": 24576},
        "3304": {"vr": "OW", "BinaryLength": 24576},
        "3305": {"vr": "OW", "BinaryLength": 24576},
        "3306": {"vr": "OW", "BinaryLength": 24576},
        "3307": {"vr": "OW", "BinaryLength": 24576},
        "3308": {"vr": "OW", "BinaryLength": 24576},
        "3309": {"vr": "OW", "BinaryLength": 24576},
        "3310": {"vr": "OW", "BinaryLength": 24576},
        "3311": {"vr": "OW", "BinaryLength": 24576},
        "3312": {"vr": "OW", "BinaryLength": 24576},
        "3313": {"vr": "OW", "BinaryLength": 24576},
        "3314": {"vr": "OW", "BinaryLength": 24576},
        "3315": {"vr": "OW", "BinaryLength": 24576},
        "3316": {"vr": "OW", "BinaryLength": 24576},
        "3317": {"vr": "OW", "BinaryLength": 24576},
        "3318": {"vr": "OW", "BinaryLength": 24576},
        "3319": {"vr": "OW", "BinaryLength": 24576},
        "3320": {"vr": "OW", "BinaryLength": 24576},
        "3321": {"vr": "OW", "BinaryLength": 24576},
        "3322": {"vr": "OW", "BinaryLength": 24576},
        "3323": {"vr": "OW", "BinaryLength": 24576},
        "3324": {"vr": "OW", "BinaryLength": 24576},
        "3325": {"vr": "OW", "BinaryLength": 24576},
        "3326": {"vr": "OW", "BinaryLength": 24576},
        "3327": {"vr": "OW", "BinaryLength": 24576},
        "3328": {"vr": "OW", "BinaryLength": 24576},
        "3329": {"vr": "OW", "BinaryLength": 24576},
        "3330": {"vr": "OW", "BinaryLength": 24576},
        "3331": {"vr": "OW", "BinaryLength": 24576},
        "3332": {"vr": "OW", "BinaryLength": 24576},
        "3333": {"vr": "OW", "BinaryLength": 24576},
        "3334": {"vr": "OW", "BinaryLength": 24576},
        "3335": {"vr": "OW", "BinaryLength": 24576},
        "3336": {"vr": "OW", "BinaryLength": 24576},
        "3337": {"vr": "OW", "BinaryLength": 24576},
        "3338": {"vr": "OW", "BinaryLength": 24576},
        "3339": {"vr": "OW", "BinaryLength": 24576},
        "3340": {"vr": "OW", "BinaryLength": 24576},
        "3341": {"vr": "OW", "BinaryLength": 24576},
        "3342": {"vr": "OW", "BinaryLength": 24576},
        "3343": {"vr": "OW", "BinaryLength": 24576},
        "3344": {"vr": "OW", "BinaryLength": 24576},
        "3345": {"vr": "OW", "BinaryLength": 24576},
        "3346": {"vr": "OW", "BinaryLength": 24576},
        "3347": {"vr": "OW", "BinaryLength": 24576},
        "3348": {"vr": "OW", "BinaryLength": 24576},
        "3349": {"vr": "OW", "BinaryLength": 24576},
        "3350": {"vr": "OW", "BinaryLength": 24576},
        "3351": {"vr": "OW", "BinaryLength": 24576},
        "3352": {"vr": "OW", "BinaryLength": 24576},
        "3353": {"vr": "OW", "BinaryLength": 24576},
        "3354": {"vr": "OW", "BinaryLength": 24576},
        "3355": {"vr": "OW", "BinaryLength": 24576},
        "3356": {"vr": "OW", "BinaryLength": 24576},
        "3357": {"vr": "OW", "BinaryLength": 24576},
        "3358": {"vr": "OW", "BinaryLength": 24576},
        "3359": {"vr": "OW", "BinaryLength": 24576},
        "3360": {"vr": "OW", "BinaryLength": 24576},
        "3361": {"vr": "OW", "BinaryLength": 24576},
        "3362": {"vr": "OW", "BinaryLength": 24576},
        "3363": {"vr": "OW", "BinaryLength": 24576},
        "3364": {"vr": "OW", "BinaryLength": 24576},
        "3365": {"vr": "OW", "BinaryLength": 24576},
        "3366": {"vr": "OW", "BinaryLength": 24576},
        "3367": {"vr": "OW", "BinaryLength": 24576},
        "3368": {"vr": "OW", "BinaryLength": 24576},
        "3369": {"vr": "OW", "BinaryLength": 24576},
        "3370": {"vr": "OW", "BinaryLength": 24576},
        "3371": {"vr": "OW", "BinaryLength": 24576},
        "3372": {"vr": "OW", "BinaryLength": 24576},
        "3373": {"vr": "OW", "BinaryLength": 24576},
        "3374": {"vr": "OW", "BinaryLength": 24576},
        "3375": {"vr": "OW", "BinaryLength": 24576},
        "3376": {"vr": "OW", "BinaryLength": 24576},
        "3377": {"vr": "OW", "BinaryLength": 24576},
        "3378": {"vr": "OW", "BinaryLength": 24576},
        "3379": {"vr": "OW", "BinaryLength": 24576},
        "3380": {"vr": "OW", "BinaryLength": 24576},
        "3381": {"vr": "OW", "BinaryLength": 24576},
        "3382": {"vr": "OW", "BinaryLength": 24576},
        "3383": {"vr": "OW", "BinaryLength": 24576},
        "3384": {"vr": "OW", "BinaryLength": 24576},
        "3385": {"vr": "OW", "BinaryLength": 24576},
        "3386": {"vr": "OW", "BinaryLength": 24576},
        "3387": {"vr": "OW", "BinaryLength": 24576},
        "3388": {"vr": "OW", "BinaryLength": 24576},
        "3389": {"vr": "OW", "BinaryLength": 24576},
        "3390": {"vr": "OW", "BinaryLength": 24576},
        "3391": {"vr": "OW", "BinaryLength": 24576},
        "3392": {"vr": "OW", "BinaryLength": 24576},
        "3393": {"vr": "OW", "BinaryLength": 24576},
        "3394": {"vr": "OW", "BinaryLength": 24576},
        "3395": {"vr": "OW", "BinaryLength": 24576},
        "3396": {"vr": "OW", "BinaryLength": 24576},
        "3397": {"vr": "OW", "BinaryLength": 24576},
        "3398": {"vr": "OW", "BinaryLength": 24576},
        "3399": {"vr": "OW", "BinaryLength": 24576},
        "3400": {"vr": "OW", "BinaryLength": 24576},
        "3401": {"vr": "OW", "BinaryLength": 24576},
        "3402": {"vr": "OW", "BinaryLength": 24576},
        "3403": {"vr": "OW", "BinaryLength": 24576},
        "3404": {"vr": "OW", "BinaryLength": 24576},
        "3405": {"vr": "OW", "BinaryLength": 24576},
        "3406": {"vr": "OW", "BinaryLength": 24576},
        "3407": {"vr": "OW", "BinaryLength": 24576},
        "3408": {"vr": "OW", "BinaryLength": 24576},
        "3409": {"vr": "OW", "BinaryLength": 24576},
        "3410": {"vr": "OW", "BinaryLength": 24576},
        "3411": {"vr": "OW", "BinaryLength": 24576},
        "3412": {"vr": "OW", "BinaryLength": 24576},
        "3413": {"vr": "OW", "BinaryLength": 24576},
        "3414": {"vr": "OW", "BinaryLength": 24576},
        "3415": {"vr": "OW", "BinaryLength": 24576},
        "3416": {"vr": "OW", "BinaryLength": 24576},
        "3417": {"vr": "OW", "BinaryLength": 24576},
        "3418": {"vr": "OW", "BinaryLength": 24576},
        "3419": {"vr": "OW", "BinaryLength": 24576},
        "3420": {"vr": "OW", "BinaryLength": 24576},
        "3421": {"vr": "OW", "BinaryLength": 24576},
        "3422": {"vr": "OW", "BinaryLength": 24576},
        "3423": {"vr": "OW", "BinaryLength": 24576},
        "3424": {"vr": "OW", "BinaryLength": 24576},
        "3425": {"vr": "OW", "BinaryLength": 24576},
        "3426": {"vr": "OW", "BinaryLength": 24576},
        "3427": {"vr": "OW", "BinaryLength": 24576},
        "3428": {"vr": "OW", "BinaryLength": 24576},
        "3429": {"vr": "OW", "BinaryLength": 24576},
        "3430": {"vr": "OW", "BinaryLength": 24576},
        "3431": {"vr": "OW", "BinaryLength": 24576},
        "3432": {"vr": "OW", "BinaryLength": 24576},
        "3433": {"vr": "OW", "BinaryLength": 24576},
        "3434": {"vr": "OW", "BinaryLength": 24576},
        "3435": {"vr": "OW", "BinaryLength": 24576},
        "3436": {"vr": "OW", "BinaryLength": 24576},
        "3437": {"vr": "OW", "BinaryLength": 24576},
        "3438": {"vr": "OW", "BinaryLength": 24576},
        "3439": {"vr": "OW", "BinaryLength": 24576},
        "3440": {"vr": "OW", "BinaryLength": 24576},
        "3441": {"vr": "OW", "BinaryLength": 24576},
        "3442": {"vr": "OW", "BinaryLength": 24576},
        "3443": {"vr": "OW", "BinaryLength": 24576},
        "3444": {"vr": "OW", "BinaryLength": 24576},
        "3445": {"vr": "OW", "BinaryLength": 24576},
        "3446": {"vr": "OW", "BinaryLength": 24576},
        "3447": {"vr": "OW", "BinaryLength": 24576},
        "3448": {"vr": "OW", "BinaryLength": 24576},
        "3449": {"vr": "OW", "BinaryLength": 24576},
        "3450": {"vr": "OW", "BinaryLength": 24576},
        "3451": {"vr": "OW", "BinaryLength": 24576},
        "3452": {"vr": "OW", "BinaryLength": 24576},
        "3453": {"vr": "OW", "BinaryLength": 24576},
        "3454": {"vr": "OW", "BinaryLength": 24576},
        "3455": {"vr": "OW", "BinaryLength": 24576},
        "3456": {"vr": "OW", "BinaryLength": 24576},
        "3457": {"vr": "OW", "BinaryLength": 24576},
        "3458": {"vr": "OW", "BinaryLength": 24576},
        "3459": {"vr": "OW", "BinaryLength": 24576},
        "3460": {"vr": "OW", "BinaryLength": 24576},
        "3461": {"vr": "OW", "BinaryLength": 24576},
        "3462": {"vr": "OW", "BinaryLength": 24576},
        "3463": {"vr": "OW", "BinaryLength": 24576},
        "3464": {"vr": "OW", "BinaryLength": 24576},
        "3465": {"vr": "OW", "BinaryLength": 24576},
        "3466": {"vr": "OW", "BinaryLength": 24576},
        "3467": {"vr": "OW", "BinaryLength": 24576},
        "3468": {"vr": "OW", "BinaryLength": 24576},
        "3469": {"vr": "OW", "BinaryLength": 24576},
        "3470": {"vr": "OW", "BinaryLength": 24576},
        "3471": {"vr": "OW", "BinaryLength": 24576},
        "3472": {"vr": "OW", "BinaryLength": 24576},
        "3473": {"vr": "OW", "BinaryLength": 24576},
        "3474": {"vr": "OW", "BinaryLength": 24576},
        "3475": {"vr": "OW", "BinaryLength": 24576},
        "3476": {"vr": "OW", "BinaryLength": 24576},
        "3477": {"vr": "OW", "BinaryLength": 24576},
        "3478": {"vr": "OW", "BinaryLength": 24576},
        "3479": {"vr": "OW", "BinaryLength": 24576},
        "3480": {"vr": "OW", "BinaryLength": 24576},
        "3481": {"vr": "OW", "BinaryLength": 24576},
        "3482": {"vr": "OW", "BinaryLength": 24576},
        "3483": {"vr": "OW", "BinaryLength": 24576},
        "3484": {"vr": "OW", "BinaryLength": 24576},
        "3485": {"vr": "OW", "BinaryLength": 24576},
        "3486": {"vr": "OW", "BinaryLength": 24576},
        "3487": {"vr": "OW", "BinaryLength": 24576},
        "3488": {"vr": "OW", "BinaryLength": 24576},
        "3489": {"vr": "OW", "BinaryLength": 24576},
        "3490": {"vr": "OW", "BinaryLength": 24576},
        "3491": {"vr": "OW", "BinaryLength": 24576},
        "3492": {"vr": "OW", "BinaryLength": 24576},
        "3493": {"vr": "OW", "BinaryLength": 24576},
        "3494": {"vr": "OW", "BinaryLength": 24576},
        "3495": {"vr": "OW", "BinaryLength": 24576},
        "3496": {"vr": "OW", "BinaryLength": 24576},
        "3497": {"vr": "OW", "BinaryLength": 24576},
        "3498": {"vr": "OW", "BinaryLength": 24576},
        "3499": {"vr": "OW", "BinaryLength": 24576},
        "3500": {"vr": "OW", "BinaryLength": 24576},
        "3501": {"vr": "OW", "BinaryLength": 24576},
        "3502": {"vr": "OW", "BinaryLength": 24576},
        "3503": {"vr": "OW", "BinaryLength": 24576},
        "3504": {"vr": "OW", "BinaryLength": 24576},
        "3505": {"vr": "OW", "BinaryLength": 24576},
        "3506": {"vr": "OW", "BinaryLength": 24576},
        "3507": {"vr": "OW", "BinaryLength": 24576},
        "3508": {"vr": "OW", "BinaryLength": 24576},
        "3509": {"vr": "OW", "BinaryLength": 24576},
        "3510": {"vr": "OW", "BinaryLength": 24576},
        "3511": {"vr": "OW", "BinaryLength": 24576},
        "3512": {"vr": "OW", "BinaryLength": 24576},
        "3513": {"vr": "OW", "BinaryLength": 24576},
        "3514": {"vr": "OW", "BinaryLength": 24576},
        "3515": {"vr": "OW", "BinaryLength": 24576},
        "3516": {"vr": "OW", "BinaryLength": 24576},
        "3517": {"vr": "OW", "BinaryLength": 24576},
        "3518": {"vr": "OW", "BinaryLength": 24576},
        "3519": {"vr": "OW", "BinaryLength": 24576},
        "3520": {"vr": "OW", "BinaryLength": 24576},
        "3521": {"vr": "OW", "BinaryLength": 24576},
        "3522": {"vr": "OW", "BinaryLength": 24576},
        "3523": {"vr": "OW", "BinaryLength": 24576},
        "3524": {"vr": "OW", "BinaryLength": 24576},
        "3525": {"vr": "OW", "BinaryLength": 24576},
        "3526": {"vr": "OW", "BinaryLength": 24576},
        "3527": {"vr": "OW", "BinaryLength": 24576},
        "3528": {"vr": "OW", "BinaryLength": 24576},
        "3529": {"vr": "OW", "BinaryLength": 24576},
        "3530": {"vr": "OW", "BinaryLength": 24576},
        "3531": {"vr": "OW", "BinaryLength": 24576},
        "3532": {"vr": "OW", "BinaryLength": 24576},
        "3533": {"vr": "OW", "BinaryLength": 24576},
        "3534": {"vr": "OW", "BinaryLength": 24576},
        "3535": {"vr": "OW", "BinaryLength": 24576},
        "3536": {"vr": "OW", "BinaryLength": 24576},
        "3537": {"vr": "OW", "BinaryLength": 24576},
        "3538": {"vr": "OW", "BinaryLength": 24576},
        "3539": {"vr": "OW", "BinaryLength": 24576},
        "3540": {"vr": "OW", "BinaryLength": 24576},
        "3541": {"vr": "OW", "BinaryLength": 24576},
        "3542": {"vr": "OW", "BinaryLength": 24576},
        "3543": {"vr": "OW", "BinaryLength": 24576},
        "3544": {"vr": "OW", "BinaryLength": 24576},
        "3545": {"vr": "OW", "BinaryLength": 24576},
        "3546": {"vr": "OW", "BinaryLength": 24576},
        "3547": {"vr": "OW", "BinaryLength": 24576},
        "3548": {"vr": "OW", "BinaryLength": 24576},
        "3549": {"vr": "OW", "BinaryLength": 24576},
        "3550": {"vr": "OW", "BinaryLength": 24576},
        "3551": {"vr": "OW", "BinaryLength": 24576},
        "3552": {"vr": "OW", "BinaryLength": 24576},
        "3553": {"vr": "OW", "BinaryLength": 24576},
        "3554": {"vr": "OW", "BinaryLength": 24576},
        "3555": {"vr": "OW", "BinaryLength": 24576},
        "3556": {"vr": "OW", "BinaryLength": 24576},
        "3557": {"vr": "OW", "BinaryLength": 24576},
        "3558": {"vr": "OW", "BinaryLength": 24576},
        "3559": {"vr": "OW", "BinaryLength": 24576},
        "3560": {"vr": "OW", "BinaryLength": 24576},
        "3561": {"vr": "OW", "BinaryLength": 24576},
        "3562": {"vr": "OW", "BinaryLength": 24576},
        "3563": {"vr": "OW", "BinaryLength": 24576},
        "3564": {"vr": "OW", "BinaryLength": 24576},
        "3565": {"vr": "OW", "BinaryLength": 24576},
        "3566": {"vr": "OW", "BinaryLength": 24576},
        "3567": {"vr": "OW", "BinaryLength": 24576},
        "3568": {"vr": "OW", "BinaryLength": 24576},
        "3569": {"vr": "OW", "BinaryLength": 24576},
        "3570": {"vr": "OW", "BinaryLength": 24576},
        "3571": {"vr": "OW", "BinaryLength": 24576},
        "3572": {"vr": "OW", "BinaryLength": 24576},
        "3573": {"vr": "OW", "BinaryLength": 24576},
        "3574": {"vr": "OW", "BinaryLength": 24576},
        "3575": {"vr": "OW", "BinaryLength": 24576},
        "3576": {"vr": "OW", "BinaryLength": 24576},
        "3577": {"vr": "OW", "BinaryLength": 24576},
        "3578": {"vr": "OW", "BinaryLength": 24576},
        "3579": {"vr": "OW", "BinaryLength": 24576},
        "3580": {"vr": "OW", "BinaryLength": 24576},
        "3581": {"vr": "OW", "BinaryLength": 24576},
        "3582": {"vr": "OW", "BinaryLength": 24576},
        "3583": {"vr": "OW", "BinaryLength": 24576},
        "3584": {"vr": "OW", "BinaryLength": 24576},
        "3585": {"vr": "OW", "BinaryLength": 24576},
        "3586": {"vr": "OW", "BinaryLength": 24576},
        "3587": {"vr": "OW", "BinaryLength": 24576},
        "3588": {"vr": "OW", "BinaryLength": 24576},
        "3589": {"vr": "OW", "BinaryLength": 24576},
        "3590": {"vr": "OW", "BinaryLength": 24576},
        "3591": {"vr": "OW", "BinaryLength": 24576},
        "3592": {"vr": "OW", "BinaryLength": 24576},
        "3593": {"vr": "OW", "BinaryLength": 24576},
        "3594": {"vr": "OW", "BinaryLength": 24576},
        "3595": {"vr": "OW", "BinaryLength": 24576},
        "3596": {"vr": "OW", "BinaryLength": 24576},
        "3597": {"vr": "OW", "BinaryLength": 24576},
        "3598": {"vr": "OW", "BinaryLength": 24576},
        "3599": {"vr": "OW", "BinaryLength": 24576},
        "3600": {"vr": "OW", "BinaryLength": 24576},
        "3601": {"vr": "OW", "BinaryLength": 24576},
        "3602": {"vr": "OW", "BinaryLength": 24576},
        "3603": {"vr": "OW", "BinaryLength": 24576},
        "3604": {"vr": "OW", "BinaryLength": 24576},
        "3605": {"vr": "OW", "BinaryLength": 24576},
        "3606": {"vr": "OW", "BinaryLength": 24576},
        "3607": {"vr": "OW", "BinaryLength": 24576},
        "3608": {"vr": "OW", "BinaryLength": 24576},
        "3609": {"vr": "OW", "BinaryLength": 24576},
        "3610": {"vr": "OW", "BinaryLength": 24576},
        "3611": {"vr": "OW", "BinaryLength": 24576},
        "3612": {"vr": "OW", "BinaryLength": 24576},
        "3613": {"vr": "OW", "BinaryLength": 24576},
        "3614": {"vr": "OW", "BinaryLength": 24576},
        "3615": {"vr": "OW", "BinaryLength": 24576},
        "3616": {"vr": "OW", "BinaryLength": 24576},
        "3617": {"vr": "OW", "BinaryLength": 24576},
        "3618": {"vr": "OW", "BinaryLength": 24576},
        "3619": {"vr": "OW", "BinaryLength": 24576},
        "3620": {"vr": "OW", "BinaryLength": 24576},
        "3621": {"vr": "OW", "BinaryLength": 24576},
        "3622": {"vr": "OW", "BinaryLength": 24576},
        "3623": {"vr": "OW", "BinaryLength": 24576},
        "3624": {"vr": "OW", "BinaryLength": 24576},
        "3625": {"vr": "OW", "BinaryLength": 24576},
        "3626": {"vr": "OW", "BinaryLength": 24576},
        "3627": {"vr": "OW", "BinaryLength": 24576},
        "3628": {"vr": "OW", "BinaryLength": 24576},
        "3629": {"vr": "OW", "BinaryLength": 24576},
        "3630": {"vr": "OW", "BinaryLength": 24576},
        "3631": {"vr": "OW", "BinaryLength": 24576},
        "3632": {"vr": "OW", "BinaryLength": 24576},
        "3633": {"vr": "OW", "BinaryLength": 24576},
        "3634": {"vr": "OW", "BinaryLength": 24576},
        "3635": {"vr": "OW", "BinaryLength": 24576},
        "3636": {"vr": "OW", "BinaryLength": 24576},
        "3637": {"vr": "OW", "BinaryLength": 24576},
        "3638": {"vr": "OW", "BinaryLength": 24576},
        "3639": {"vr": "OW", "BinaryLength": 24576},
        "3640": {"vr": "OW", "BinaryLength": 24576},
        "3641": {"vr": "OW", "BinaryLength": 24576},
        "3642": {"vr": "OW", "BinaryLength": 24576},
        "3643": {"vr": "OW", "BinaryLength": 24576},
        "3644": {"vr": "OW", "BinaryLength": 24576},
        "3645": {"vr": "OW", "BinaryLength": 24576},
        "3646": {"vr": "OW", "BinaryLength": 24576},
        "3647": {"vr": "OW", "BinaryLength": 24576},
        "3648": {"vr": "OW", "BinaryLength": 24576},
        "3649": {"vr": "OW", "BinaryLength": 24576},
        "3650": {"vr": "OW", "BinaryLength": 24576},
        "3651": {"vr": "OW", "BinaryLength": 24576},
        "3652": {"vr": "OW", "BinaryLength": 24576},
        "3653": {"vr": "OW", "BinaryLength": 24576},
        "3654": {"vr": "OW", "BinaryLength": 24576},
        "3655": {"vr": "OW", "BinaryLength": 24576},
        "3656": {"vr": "OW", "BinaryLength": 24576},
        "3657": {"vr": "OW", "BinaryLength": 24576},
        "3658": {"vr": "OW", "BinaryLength": 24576},
        "3659": {"vr": "OW", "BinaryLength": 24576},
        "3660": {"vr": "OW", "BinaryLength": 24576},
        "3661": {"vr": "OW", "BinaryLength": 24576},
        "3662": {"vr": "OW", "BinaryLength": 24576},
        "3663": {"vr": "OW", "BinaryLength": 24576},
        "3664": {"vr": "OW", "BinaryLength": 24576},
        "3665": {"vr": "OW", "BinaryLength": 24576},
        "3666": {"vr": "OW", "BinaryLength": 24576},
        "3667": {"vr": "OW", "BinaryLength": 24576},
        "3668": {"vr": "OW", "BinaryLength": 24576},
        "3669": {"vr": "OW", "BinaryLength": 24576},
        "3670": {"vr": "OW", "BinaryLength": 24576},
        "3671": {"vr": "OW", "BinaryLength": 24576},
        "3672": {"vr": "OW", "BinaryLength": 24576},
        "3673": {"vr": "OW", "BinaryLength": 24576},
        "3674": {"vr": "OW", "BinaryLength": 24576},
        "3675": {"vr": "OW", "BinaryLength": 24576},
        "3676": {"vr": "OW", "BinaryLength": 24576},
        "3677": {"vr": "OW", "BinaryLength": 24576},
        "3678": {"vr": "OW", "BinaryLength": 24576},
        "3679": {"vr": "OW", "BinaryLength": 24576},
        "3680": {"vr": "OW", "BinaryLength": 24576},
        "3681": {"vr": "OW", "BinaryLength": 24576},
        "3682": {"vr": "OW", "BinaryLength": 24576},
        "3683": {"vr": "OW", "BinaryLength": 24576},
        "3684": {"vr": "OW", "BinaryLength": 24576},
        "3685": {"vr": "OW", "BinaryLength": 24576},
        "3686": {"vr": "OW", "BinaryLength": 24576},
        "3687": {"vr": "OW", "BinaryLength": 24576},
        "3688": {"vr": "OW", "BinaryLength": 24576},
        "3689": {"vr": "OW", "BinaryLength": 24576},
        "3690": {"vr": "OW", "BinaryLength": 24576},
        "3691": {"vr": "OW", "BinaryLength": 24576},
        "3692": {"vr": "OW", "BinaryLength": 24576},
        "3693": {"vr": "OW", "BinaryLength": 24576},
        "3694": {"vr": "OW", "BinaryLength": 24576},
        "3695": {"vr": "OW", "BinaryLength": 24576},
        "3696": {"vr": "OW", "BinaryLength": 24576},
        "3697": {"vr": "OW", "BinaryLength": 24576},
        "3698": {"vr": "OW", "BinaryLength": 24576},
        "3699": {"vr": "OW", "BinaryLength": 24576},
        "3700": {"vr": "OW", "BinaryLength": 24576},
        "3701": {"vr": "OW", "BinaryLength": 24576},
        "3702": {"vr": "OW", "BinaryLength": 24576},
        "3703": {"vr": "OW", "BinaryLength": 24576},
        "3704": {"vr": "OW", "BinaryLength": 24576},
        "3705": {"vr": "OW", "BinaryLength": 24576},
        "3706": {"vr": "OW", "BinaryLength": 24576},
        "3707": {"vr": "OW", "BinaryLength": 24576},
        "3708": {"vr": "OW", "BinaryLength": 24576},
        "3709": {"vr": "OW", "BinaryLength": 24576},
        "3710": {"vr": "OW", "BinaryLength": 24576},
        "3711": {"vr": "OW", "BinaryLength": 24576},
        "3712": {"vr": "OW", "BinaryLength": 24576},
        "3713": {"vr": "OW", "BinaryLength": 24576},
        "3714": {"vr": "OW", "BinaryLength": 24576},
        "3715": {"vr": "OW", "BinaryLength": 24576},
        "3716": {"vr": "OW", "BinaryLength": 24576},
        "3717": {"vr": "OW", "BinaryLength": 24576},
        "3718": {"vr": "OW", "BinaryLength": 24576},
        "3719": {"vr": "OW", "BinaryLength": 24576},
        "3720": {"vr": "OW", "BinaryLength": 24576},
        "3721": {"vr": "OW", "BinaryLength": 24576},
        "3722": {"vr": "OW", "BinaryLength": 24576},
        "3723": {"vr": "OW", "BinaryLength": 24576},
        "3724": {"vr": "OW", "BinaryLength": 24576},
        "3725": {"vr": "OW", "BinaryLength": 24576},
        "3726": {"vr": "OW", "BinaryLength": 24576},
        "3727": {"vr": "OW", "BinaryLength": 24576},
        "3728": {"vr": "OW", "BinaryLength": 24576},
        "3729": {"vr": "OW", "BinaryLength": 24576},
        "3730": {"vr": "OW", "BinaryLength": 24576},
        "3731": {"vr": "OW", "BinaryLength": 24576},
        "3732": {"vr": "OW", "BinaryLength": 24576},
        "3733": {"vr": "OW", "BinaryLength": 24576},
        "3734": {"vr": "OW", "BinaryLength": 24576},
        "3735": {"vr": "OW", "BinaryLength": 24576},
        "3736": {"vr": "OW", "BinaryLength": 24576},
        "3737": {"vr": "OW", "BinaryLength": 24576},
        "3738": {"vr": "OW", "BinaryLength": 24576},
        "3739": {"vr": "OW", "BinaryLength": 24576},
        "3740": {"vr": "OW", "BinaryLength": 24576},
        "3741": {"vr": "OW", "BinaryLength": 24576},
        "3742": {"vr": "OW", "BinaryLength": 24576},
        "3743": {"vr": "OW", "BinaryLength": 24576},
        "3744": {"vr": "OW", "BinaryLength": 24576},
        "3745": {"vr": "OW", "BinaryLength": 24576},
        "3746": {"vr": "OW", "BinaryLength": 24576},
        "3747": {"vr": "OW", "BinaryLength": 24576},
        "3748": {"vr": "OW", "BinaryLength": 24576},
        "3749": {"vr": "OW", "BinaryLength": 24576},
        "3750": {"vr": "OW", "BinaryLength": 24576},
        "3751": {"vr": "OW", "BinaryLength": 24576},
        "3752": {"vr": "OW", "BinaryLength": 24576},
        "3753": {"vr": "OW", "BinaryLength": 24576},
        "3754": {"vr": "OW", "BinaryLength": 24576},
        "3755": {"vr": "OW", "BinaryLength": 24576},
        "3756": {"vr": "OW", "BinaryLength": 24576},
        "3757": {"vr": "OW", "BinaryLength": 24576},
        "3758": {"vr": "OW", "BinaryLength": 24576},
        "3759": {"vr": "OW", "BinaryLength": 24576},
        "3760": {"vr": "OW", "BinaryLength": 24576},
        "3761": {"vr": "OW", "BinaryLength": 24576},
        "3762": {"vr": "OW", "BinaryLength": 24576},
        "3763": {"vr": "OW", "BinaryLength": 24576},
        "3764": {"vr": "OW", "BinaryLength": 24576},
        "3765": {"vr": "OW", "BinaryLength": 24576},
        "3766": {"vr": "OW", "BinaryLength": 24576},
        "3767": {"vr": "OW", "BinaryLength": 24576},
        "3768": {"vr": "OW", "BinaryLength": 24576},
        "3769": {"vr": "OW", "BinaryLength": 24576},
        "3770": {"vr": "OW", "BinaryLength": 24576},
        "3771": {"vr": "OW", "BinaryLength": 24576},
        "3772": {"vr": "OW", "BinaryLength": 24576},
        "3773": {"vr": "OW", "BinaryLength": 24576},
        "3774": {"vr": "OW", "BinaryLength": 24576},
        "3775": {"vr": "OW", "BinaryLength": 24576},
        "3776": {"vr": "OW", "BinaryLength": 24576},
        "3777": {"vr": "OW", "BinaryLength": 24576},
        "3778": {"vr": "OW", "BinaryLength": 24576},
        "3779": {"vr": "OW", "BinaryLength": 24576},
        "3780": {"vr": "OW", "BinaryLength": 24576},
        "3781": {"vr": "OW", "BinaryLength": 24576},
        "3782": {"vr": "OW", "BinaryLength": 24576},
        "3783": {"vr": "OW", "BinaryLength": 24576},
        "3784": {"vr": "OW", "BinaryLength": 24576},
        "3785": {"vr": "OW", "BinaryLength": 24576},
        "3786": {"vr": "OW", "BinaryLength": 24576},
        "3787": {"vr": "OW", "BinaryLength": 24576},
        "3788": {"vr": "OW", "BinaryLength": 24576},
        "3789": {"vr": "OW", "BinaryLength": 24576},
        "3790": {"vr": "OW", "BinaryLength": 24576},
        "3791": {"vr": "OW", "BinaryLength": 24576},
        "3792": {"vr": "OW", "BinaryLength": 24576},
        "3793": {"vr": "OW", "BinaryLength": 24576},
        "3794": {"vr": "OW", "BinaryLength": 24576},
        "3795": {"vr": "OW", "BinaryLength": 24576},
        "3796": {"vr": "OW", "BinaryLength": 24576},
        "3797": {"vr": "OW", "BinaryLength": 24576},
        "3798": {"vr": "OW", "BinaryLength": 24576},
        "3799": {"vr": "OW", "BinaryLength": 24576},
        "3800": {"vr": "OW", "BinaryLength": 24576},
        "3801": {"vr": "OW", "BinaryLength": 24576},
        "3802": {"vr": "OW", "BinaryLength": 24576},
        "3803": {"vr": "OW", "BinaryLength": 24576},
        "3804": {"vr": "OW", "BinaryLength": 24576},
        "3805": {"vr": "OW", "BinaryLength": 24576},
        "3806": {"vr": "OW", "BinaryLength": 24576},
        "3807": {"vr": "OW", "BinaryLength": 24576},
        "3808": {"vr": "OW", "BinaryLength": 24576},
        "3809": {"vr": "OW", "BinaryLength": 24576},
        "3810": {"vr": "OW", "BinaryLength": 24576},
        "3811": {"vr": "OW", "BinaryLength": 24576},
        "3812": {"vr": "OW", "BinaryLength": 24576},
        "3813": {"vr": "OW", "BinaryLength": 24576},
        "3814": {"vr": "OW", "BinaryLength": 24576},
        "3815": {"vr": "OW", "BinaryLength": 24576},
        "3816": {"vr": "OW", "BinaryLength": 24576},
        "3817": {"vr": "OW", "BinaryLength": 24576},
        "3818": {"vr": "OW", "BinaryLength": 24576},
        "3819": {"vr": "OW", "BinaryLength": 24576},
        "3820": {"vr": "OW", "BinaryLength": 24576},
        "3821": {"vr": "OW", "BinaryLength": 24576},
        "3822": {"vr": "OW", "BinaryLength": 24576},
        "3823": {"vr": "OW", "BinaryLength": 24576},
        "3824": {"vr": "OW", "BinaryLength": 24576},
        "3825": {"vr": "OW", "BinaryLength": 24576},
        "3826": {"vr": "OW", "BinaryLength": 24576},
        "3827": {"vr": "OW", "BinaryLength": 24576},
        "3828": {"vr": "OW", "BinaryLength": 24576},
        "3829": {"vr": "OW", "BinaryLength": 24576},
        "3830": {"vr": "OW", "BinaryLength": 24576},
        "3831": {"vr": "OW", "BinaryLength": 24576},
        "3832": {"vr": "OW", "BinaryLength": 24576},
        "3833": {"vr": "OW", "BinaryLength": 24576},
        "3834": {"vr": "OW", "BinaryLength": 24576},
        "3835": {"vr": "OW", "BinaryLength": 24576},
        "3836": {"vr": "OW", "BinaryLength": 24576},
        "3837": {"vr": "OW", "BinaryLength": 24576},
        "3838": {"vr": "OW", "BinaryLength": 24576},
        "3839": {"vr": "OW", "BinaryLength": 24576},
        "3840": {"vr": "OW", "BinaryLength": 24576},
        "3841": {"vr": "OW", "BinaryLength": 24576},
        "3842": {"vr": "OW", "BinaryLength": 24576},
        "3843": {"vr": "OW", "BinaryLength": 24576},
        "3844": {"vr": "OW", "BinaryLength": 24576},
        "3845": {"vr": "OW", "BinaryLength": 24576},
        "3846": {"vr": "OW", "BinaryLength": 24576},
        "3847": {"vr": "OW", "BinaryLength": 24576},
        "3848": {"vr": "OW", "BinaryLength": 24576},
        "3849": {"vr": "OW", "BinaryLength": 24576},
        "3850": {"vr": "OW", "BinaryLength": 24576},
        "3851": {"vr": "OW", "BinaryLength": 24576},
        "3852": {"vr": "OW", "BinaryLength": 24576},
        "3853": {"vr": "OW", "BinaryLength": 24576},
        "3854": {"vr": "OW", "BinaryLength": 24576},
        "3855": {"vr": "OW", "BinaryLength": 24576},
        "3856": {"vr": "OW", "BinaryLength": 24576},
        "3857": {"vr": "OW", "BinaryLength": 24576},
        "3858": {"vr": "OW", "BinaryLength": 24576},
        "3859": {"vr": "OW", "BinaryLength": 24576},
        "3860": {"vr": "OW", "BinaryLength": 24576},
        "3861": {"vr": "OW", "BinaryLength": 24576},
        "3862": {"vr": "OW", "BinaryLength": 24576},
        "3863": {"vr": "OW", "BinaryLength": 24576},
        "3864": {"vr": "OW", "BinaryLength": 24576},
        "3865": {"vr": "OW", "BinaryLength": 24576},
        "3866": {"vr": "OW", "BinaryLength": 24576},
        "3867": {"vr": "OW", "BinaryLength": 24576},
        "3868": {"vr": "OW", "BinaryLength": 24576},
        "3869": {"vr": "OW", "BinaryLength": 24576},
        "3870": {"vr": "OW", "BinaryLength": 24576},
        "3871": {"vr": "OW", "BinaryLength": 24576},
        "3872": {"vr": "OW", "BinaryLength": 24576},
        "3873": {"vr": "OW", "BinaryLength": 24576},
        "3874": {"vr": "OW", "BinaryLength": 24576},
        "3875": {"vr": "OW", "BinaryLength": 24576},
        "3876": {"vr": "OW", "BinaryLength": 24576},
        "3877": {"vr": "OW", "BinaryLength": 24576},
        "3878": {"vr": "OW", "BinaryLength": 24576},
        "3879": {"vr": "OW", "BinaryLength": 24576},
        "3880": {"vr": "OW", "BinaryLength": 24576},
        "3881": {"vr": "OW", "BinaryLength": 24576},
        "3882": {"vr": "OW", "BinaryLength": 24576},
        "3883": {"vr": "OW", "BinaryLength": 24576},
        "3884": {"vr": "OW", "BinaryLength": 24576},
        "3885": {"vr": "OW", "BinaryLength": 24576},
        "3886": {"vr": "OW", "BinaryLength": 24576},
        "3887": {"vr": "OW", "BinaryLength": 24576},
        "3888": {"vr": "OW", "BinaryLength": 24576},
        "3889": {"vr": "OW", "BinaryLength": 24576},
        "3890": {"vr": "OW", "BinaryLength": 24576},
        "3891": {"vr": "OW", "BinaryLength": 24576},
        "3892": {"vr": "OW", "BinaryLength": 24576},
        "3893": {"vr": "OW", "BinaryLength": 24576},
        "3894": {"vr": "OW", "BinaryLength": 24576},
        "3895": {"vr": "OW", "BinaryLength": 24576},
        "3896": {"vr": "OW", "BinaryLength": 24576},
        "3897": {"vr": "OW", "BinaryLength": 24576},
        "3898": {"vr": "OW", "BinaryLength": 24576},
        "3899": {"vr": "OW", "BinaryLength": 24576},
        "3900": {"vr": "OW", "BinaryLength": 24576},
        "3901": {"vr": "OW", "BinaryLength": 24576},
        "3902": {"vr": "OW", "BinaryLength": 24576},
        "3903": {"vr": "OW", "BinaryLength": 24576},
        "3904": {"vr": "OW", "BinaryLength": 24576},
        "3905": {"vr": "OW", "BinaryLength": 24576},
        "3906": {"vr": "OW", "BinaryLength": 24576},
        "3907": {"vr": "OW", "BinaryLength": 24576},
        "3908": {"vr": "OW", "BinaryLength": 24576},
        "3909": {"vr": "OW", "BinaryLength": 24576},
        "3910": {"vr": "OW", "BinaryLength": 24576},
        "3911": {"vr": "OW", "BinaryLength": 24576},
        "3912": {"vr": "OW", "BinaryLength": 24576},
        "3913": {"vr": "OW", "BinaryLength": 24576},
        "3914": {"vr": "OW", "BinaryLength": 24576},
        "3915": {"vr": "OW", "BinaryLength": 24576},
        "3916": {"vr": "OW", "BinaryLength": 24576},
        "3917": {"vr": "OW", "BinaryLength": 24576},
        "3918": {"vr": "OW", "BinaryLength": 24576},
        "3919": {"vr": "OW", "BinaryLength": 24576},
        "3920": {"vr": "OW", "BinaryLength": 24576},
        "3921": {"vr": "OW", "BinaryLength": 24576},
        "3922": {"vr": "OW", "BinaryLength": 24576},
        "3923": {"vr": "OW", "BinaryLength": 24576},
        "3924": {"vr": "OW", "BinaryLength": 24576},
        "3925": {"vr": "OW", "BinaryLength": 24576},
        "3926": {"vr": "OW", "BinaryLength": 24576},
        "3927": {"vr": "OW", "BinaryLength": 24576},
        "3928": {"vr": "OW", "BinaryLength": 24576},
        "3929": {"vr": "OW", "BinaryLength": 24576},
        "3930": {"vr": "OW", "BinaryLength": 24576},
        "3931": {"vr": "OW", "BinaryLength": 24576},
        "3932": {"vr": "OW", "BinaryLength": 24576},
        "3933": {"vr": "OW", "BinaryLength": 24576},
        "3934": {"vr": "OW", "BinaryLength": 24576},
        "3935": {"vr": "OW", "BinaryLength": 24576},
        "3936": {"vr": "OW", "BinaryLength": 24576},
        "3937": {"vr": "OW", "BinaryLength": 24576},
        "3938": {"vr": "OW", "BinaryLength": 24576},
        "3939": {"vr": "OW", "BinaryLength": 24576},
        "3940": {"vr": "OW", "BinaryLength": 24576},
        "3941": {"vr": "OW", "BinaryLength": 24576},
        "3942": {"vr": "OW", "BinaryLength": 24576},
        "3943": {"vr": "OW", "BinaryLength": 24576},
        "3944": {"vr": "OW", "BinaryLength": 24576},
        "3945": {"vr": "OW", "BinaryLength": 24576},
        "3946": {"vr": "OW", "BinaryLength": 24576},
        "3947": {"vr": "OW", "BinaryLength": 24576},
        "3948": {"vr": "OW", "BinaryLength": 24576},
        "3949": {"vr": "OW", "BinaryLength": 24576},
        "3950": {"vr": "OW", "BinaryLength": 24576},
        "3951": {"vr": "OW", "BinaryLength": 24576},
        "3952": {"vr": "OW", "BinaryLength": 24576},
        "3953": {"vr": "OW", "BinaryLength": 24576},
        "3954": {"vr": "OW", "BinaryLength": 24576},
        "3955": {"vr": "OW", "BinaryLength": 24576},
        "3956": {"vr": "OW", "BinaryLength": 24576},
        "3957": {"vr": "OW", "BinaryLength": 24576},
        "3958": {"vr": "OW", "BinaryLength": 24576},
        "3959": {"vr": "OW", "BinaryLength": 24576},
        "3960": {"vr": "OW", "BinaryLength": 24576},
        "3961": {"vr": "OW", "BinaryLength": 24576},
        "3962": {"vr": "OW", "BinaryLength": 24576},
        "3963": {"vr": "OW", "BinaryLength": 24576},
        "3964": {"vr": "OW", "BinaryLength": 24576},
        "3965": {"vr": "OW", "BinaryLength": 24576},
        "3966": {"vr": "OW", "BinaryLength": 24576},
        "3967": {"vr": "OW", "BinaryLength": 24576},
        "3968": {"vr": "OW", "BinaryLength": 24576},
        "3969": {"vr": "OW", "BinaryLength": 24576},
        "3970": {"vr": "OW", "BinaryLength": 24576},
        "3971": {"vr": "OW", "BinaryLength": 24576},
        "3972": {"vr": "OW", "BinaryLength": 24576},
        "3973": {"vr": "OW", "BinaryLength": 24576},
        "3974": {"vr": "OW", "BinaryLength": 24576},
        "3975": {"vr": "OW", "BinaryLength": 24576},
        "3976": {"vr": "OW", "BinaryLength": 24576},
        "3977": {"vr": "OW", "BinaryLength": 24576},
        "3978": {"vr": "OW", "BinaryLength": 24576},
        "3979": {"vr": "OW", "BinaryLength": 24576},
        "3980": {"vr": "OW", "BinaryLength": 24576},
        "3981": {"vr": "OW", "BinaryLength": 24576},
        "3982": {"vr": "OW", "BinaryLength": 24576},
        "3983": {"vr": "OW", "BinaryLength": 24576},
        "3984": {"vr": "OW", "BinaryLength": 24576},
        "3985": {"vr": "OW", "BinaryLength": 24576},
        "3986": {"vr": "OW", "BinaryLength": 24576},
        "3987": {"vr": "OW", "BinaryLength": 24576},
        "3988": {"vr": "OW", "BinaryLength": 24576},
        "3989": {"vr": "OW", "BinaryLength": 24576},
        "3990": {"vr": "OW", "BinaryLength": 24576},
        "3991": {"vr": "OW", "BinaryLength": 24576},
        "3992": {"vr": "OW", "BinaryLength": 24576},
        "3993": {"vr": "OW", "BinaryLength": 24576},
        "3994": {"vr": "OW", "BinaryLength": 24576},
        "3995": {"vr": "OW", "BinaryLength": 24576},
        "3996": {"vr": "OW", "BinaryLength": 24576},
        "3997": {"vr": "OW", "BinaryLength": 24576},
        "3998": {"vr": "OW", "BinaryLength": 24576},
        "3999": {"vr": "OW", "BinaryLength": 24576},
        "4000": {"vr": "OW", "BinaryLength": 24576},
        "4001": {"vr": "OW", "BinaryLength": 24576},
        "4002": {"vr": "OW", "BinaryLength": 24576},
        "4003": {"vr": "OW", "BinaryLength": 24576},
        "4004": {"vr": "OW", "BinaryLength": 24576},
        "4005": {"vr": "OW", "BinaryLength": 24576},
        "4006": {"vr": "OW", "BinaryLength": 24576},
        "4007": {"vr": "OW", "BinaryLength": 24576},
        "4008": {"vr": "OW", "BinaryLength": 24576},
        "4009": {"vr": "OW", "BinaryLength": 24576},
        "4010": {"vr": "OW", "BinaryLength": 24576},
        "4011": {"vr": "OW", "BinaryLength": 24576},
        "4012": {"vr": "OW", "BinaryLength": 24576},
        "4013": {"vr": "OW", "BinaryLength": 24576},
        "4014": {"vr": "OW", "BinaryLength": 24576},
        "4015": {"vr": "OW", "BinaryLength": 24576},
        "4016": {"vr": "OW", "BinaryLength": 24576},
        "4017": {"vr": "OW", "BinaryLength": 24576},
        "4018": {"vr": "OW", "BinaryLength": 24576},
        "4019": {"vr": "OW", "BinaryLength": 24576},
    },
}
